/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/editor/common/core/range","vs/base/common/errors","vs/editor/common/core/offsetRange","vs/editor/common/core/position","vs/base/common/arrays","vs/base/common/strings","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/diffAlgorithm","vs/base/common/arraysFind","vs/base/common/lifecycle","vs/base/common/event","vs/editor/common/core/lineRange","vs/base/common/assert","vs/base/common/objects","vs/editor/common/diff/defaultLinesDiffComputer/utils","vs/editor/common/diff/rangeMapping","vs/base/common/platform","vs/base/common/uri","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/map","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/codiconsUtil","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/myersDiffAlgorithm","vs/editor/common/diff/defaultLinesDiffComputer/linesSliceCharSequence","vs/editor/common/diff/linesDiffComputer","vs/editor/common/diff/legacyLinesDiffComputer","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/cache","vs/base/common/hash","vs/base/common/codiconsLibrary","vs/base/common/codicons","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/defaultLinesDiffComputer/heuristicSequenceOptimizations","vs/editor/common/diff/defaultLinesDiffComputer/lineSequence","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/defaultLinesDiffComputer/computeMovedLines","vs/editor/common/diff/defaultLinesDiffComputer/defaultLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/platform","vs/nls","vs/nls!vs/editor/common/services/editorSimpleWorker","vs/base/common/process","vs/base/common/path","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],re=function(C){for(var t=[],i=0,P=C.length;i<P;i++)t[i]=ne[C[i]];return t};const xe=this,ze=typeof global=="object"?global:{};var oe;(function(C){C.global=xe;class t{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=t._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof C.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}C.Environment=t})(oe||(oe={}));var oe;(function(C){class t{constructor(h,k,c){this.type=h,this.detail=k,this.timestamp=c}}C.LoaderEvent=t;class i{constructor(h){this._events=[new t(1,"",h)]}record(h,k){this._events.push(new t(h,k,C.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}C.LoaderEventRecorder=i;class P{record(h,k){}getEvents(){return[]}}P.INSTANCE=new P,C.NullLoaderEventRecorder=P})(oe||(oe={}));var oe;(function(C){class t{static fileUriToFilePath(P,p){if(p=decodeURI(p).replace(/%23/g,"#"),P){if(/^file:\/\/\//.test(p))return p.substr(8);if(/^file:\/\//.test(p))return p.substr(5)}else if(/^file:\/\//.test(p))return p.substr(7);return p}static startsWith(P,p){return P.length>=p.length&&P.substr(0,p.length)===p}static endsWith(P,p){return P.length>=p.length&&P.substr(P.length-p.length)===p}static containsQueryString(P){return/^[^\#]*\?/gi.test(P)}static isAbsolutePath(P){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(P)}static forEachProperty(P,p){if(P){let h;for(h in P)P.hasOwnProperty(h)&&p(h,P[h])}}static isEmpty(P){let p=!0;return t.forEachProperty(P,()=>{p=!1}),p}static recursiveClone(P){if(!P||typeof P!="object"||P instanceof RegExp||!Array.isArray(P)&&Object.getPrototypeOf(P)!==Object.prototype)return P;let p=Array.isArray(P)?[]:{};return t.forEachProperty(P,(h,k)=>{k&&typeof k=="object"?p[h]=t.recursiveClone(k):p[h]=k}),p}static generateAnonymousModule(){return"===anonymous"+t.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(P){return t.startsWith(P,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=C.global.performance&&typeof C.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?C.global.performance.now():Date.now()}}t.NEXT_ANONYMOUS_ID=1,t.PERFORMANCE_NOW_PROBED=!1,t.HAS_PERFORMANCE_NOW=!1,C.Utilities=t})(oe||(oe={}));var oe;(function(C){function t(p){if(p instanceof Error)return p;const h=new Error(p.message||String(p)||"Unknown Error");return p.stack&&(h.stack=p.stack),h}C.ensureError=t;class i{static validateConfigurationOptions(h){function k(c){if(c.phase==="loading"){console.error('Loading "'+c.moduleId+'" failed'),console.error(c),console.error("Here are the modules that depend on it:"),console.error(c.neededBy);return}if(c.phase==="factory"){console.error('The factory function of "'+c.moduleId+'" has thrown an exception'),console.error(c),console.error("Here are the modules that depend on it:"),console.error(c.neededBy);return}}if(h=h||{},typeof h.baseUrl!="string"&&(h.baseUrl=""),typeof h.isBuild!="boolean"&&(h.isBuild=!1),typeof h.paths!="object"&&(h.paths={}),typeof h.config!="object"&&(h.config={}),typeof h.catchError>"u"&&(h.catchError=!1),typeof h.recordStats>"u"&&(h.recordStats=!1),typeof h.urlArgs!="string"&&(h.urlArgs=""),typeof h.onError!="function"&&(h.onError=k),Array.isArray(h.ignoreDuplicateModules)||(h.ignoreDuplicateModules=[]),h.baseUrl.length>0&&(C.Utilities.endsWith(h.baseUrl,"/")||(h.baseUrl+="/")),typeof h.cspNonce!="string"&&(h.cspNonce=""),typeof h.preferScriptTags>"u"&&(h.preferScriptTags=!1),h.nodeCachedData&&typeof h.nodeCachedData=="object"&&(typeof h.nodeCachedData.seed!="string"&&(h.nodeCachedData.seed="seed"),(typeof h.nodeCachedData.writeDelay!="number"||h.nodeCachedData.writeDelay<0)&&(h.nodeCachedData.writeDelay=1e3*7),!h.nodeCachedData.path||typeof h.nodeCachedData.path!="string")){const c=t(new Error("INVALID cached data configuration, 'path' MUST be set"));c.phase="configuration",h.onError(c),h.nodeCachedData=void 0}return h}static mergeConfigurationOptions(h=null,k=null){let c=C.Utilities.recursiveClone(k||{});return C.Utilities.forEachProperty(h,(l,u)=>{l==="ignoreDuplicateModules"&&typeof c.ignoreDuplicateModules<"u"?c.ignoreDuplicateModules=c.ignoreDuplicateModules.concat(u):l==="paths"&&typeof c.paths<"u"?C.Utilities.forEachProperty(u,(o,E)=>c.paths[o]=E):l==="config"&&typeof c.config<"u"?C.Utilities.forEachProperty(u,(o,E)=>c.config[o]=E):c[l]=C.Utilities.recursiveClone(u)}),i.validateConfigurationOptions(c)}}C.ConfigurationOptionsUtil=i;class P{constructor(h,k){if(this._env=h,this.options=i.mergeConfigurationOptions(k),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let c=this.options.nodeRequire.main.filename,l=Math.max(c.lastIndexOf("/"),c.lastIndexOf("\\"));this.options.baseUrl=c.substring(0,l+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let h=0;h<this.options.ignoreDuplicateModules.length;h++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[h]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],C.Utilities.forEachProperty(this.options.paths,(h,k)=>{Array.isArray(k)?this.sortedPathsRules.push({from:h,to:k}):this.sortedPathsRules.push({from:h,to:[k]})}),this.sortedPathsRules.sort((h,k)=>k.from.length-h.from.length)}cloneAndMerge(h){return new P(this._env,i.mergeConfigurationOptions(h,this.options))}getOptionsLiteral(){return this.options}_applyPaths(h){let k;for(let c=0,l=this.sortedPathsRules.length;c<l;c++)if(k=this.sortedPathsRules[c],C.Utilities.startsWith(h,k.from)){let u=[];for(let o=0,E=k.to.length;o<E;o++)u.push(k.to[o]+h.substr(k.from.length));return u}return[h]}_addUrlArgsToUrl(h){return C.Utilities.containsQueryString(h)?h+"&"+this.options.urlArgs:h+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(h){return this.options.urlArgs?this._addUrlArgsToUrl(h):h}_addUrlArgsIfNecessaryToUrls(h){if(this.options.urlArgs)for(let k=0,c=h.length;k<c;k++)h[k]=this._addUrlArgsToUrl(h[k]);return h}moduleIdToPaths(h){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(h))return this.isBuild()?["empty:"]:["node|"+h];let k=h,c;if(!C.Utilities.endsWith(k,".js")&&!C.Utilities.isAbsolutePath(k)){c=this._applyPaths(k);for(let l=0,u=c.length;l<u;l++)this.isBuild()&&c[l]==="empty:"||(C.Utilities.isAbsolutePath(c[l])||(c[l]=this.options.baseUrl+c[l]),!C.Utilities.endsWith(c[l],".js")&&!C.Utilities.containsQueryString(c[l])&&(c[l]=c[l]+".js"))}else!C.Utilities.endsWith(k,".js")&&!C.Utilities.containsQueryString(k)&&(k=k+".js"),c=[k];return this._addUrlArgsIfNecessaryToUrls(c)}requireToUrl(h){let k=h;return C.Utilities.isAbsolutePath(k)||(k=this._applyPaths(k)[0],C.Utilities.isAbsolutePath(k)||(k=this.options.baseUrl+k)),this._addUrlArgsIfNecessaryToUrl(k)}isBuild(){return this.options.isBuild}shouldInvokeFactory(h){return!!(!this.options.isBuild||C.Utilities.isAnonymousModule(h)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[h])}isDuplicateMessageIgnoredFor(h){return this.ignoreDuplicateModulesMap.hasOwnProperty(h)}getConfigForModule(h){if(this.options.config)return this.options.config[h]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(h){this.options.onError(h)}}C.Configuration=P})(oe||(oe={}));var oe;(function(C){class t{constructor(u){this._env=u,this._scriptLoader=null,this._callbackMap={}}load(u,o,E,b){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new p;else if(this._env.isElectronRenderer){const{preferScriptTags:e}=u.getConfig().getOptionsLiteral();e?this._scriptLoader=new i:this._scriptLoader=new h(this._env)}else this._env.isNode?this._scriptLoader=new h(this._env):this._scriptLoader=new i;let m={callback:E,errorback:b};if(this._callbackMap.hasOwnProperty(o)){this._callbackMap[o].push(m);return}this._callbackMap[o]=[m],this._scriptLoader.load(u,o,()=>this.triggerCallback(o),e=>this.triggerErrorback(o,e))}triggerCallback(u){let o=this._callbackMap[u];delete this._callbackMap[u];for(let E=0;E<o.length;E++)o[E].callback()}triggerErrorback(u,o){let E=this._callbackMap[u];delete this._callbackMap[u];for(let b=0;b<E.length;b++)E[b].errorback(o)}}class i{attachListeners(u,o,E){let b=()=>{u.removeEventListener("load",m),u.removeEventListener("error",e)},m=L=>{b(),o()},e=L=>{b(),E(L)};u.addEventListener("load",m),u.addEventListener("error",e)}load(u,o,E,b){if(/^node\|/.test(o)){let m=u.getConfig().getOptionsLiteral(),e=k(u.getRecorder(),m.nodeRequire||C.global.nodeRequire),L=o.split("|"),j=null;try{j=e(L[1])}catch(N){b(N);return}u.enqueueDefineAnonymousModule([],()=>j),E()}else{let m=document.createElement("script");m.setAttribute("async","async"),m.setAttribute("type","text/javascript"),this.attachListeners(m,E,b);const{trustedTypesPolicy:e}=u.getConfig().getOptionsLiteral();e&&(o=e.createScriptURL(o)),m.setAttribute("src",o);const{cspNonce:L}=u.getConfig().getOptionsLiteral();L&&m.setAttribute("nonce",L),document.getElementsByTagName("head")[0].appendChild(m)}}}function P(l){const{trustedTypesPolicy:u}=l.getConfig().getOptionsLiteral();try{return(u?self.eval(u.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class p{constructor(){this._cachedCanUseEval=null}_canUseEval(u){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=P(u)),this._cachedCanUseEval}load(u,o,E,b){if(/^node\|/.test(o)){const m=u.getConfig().getOptionsLiteral(),e=k(u.getRecorder(),m.nodeRequire||C.global.nodeRequire),L=o.split("|");let j=null;try{j=e(L[1])}catch(N){b(N);return}u.enqueueDefineAnonymousModule([],function(){return j}),E()}else{const{trustedTypesPolicy:m}=u.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(o)&&o.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(u)){fetch(o).then(L=>{if(L.status!==200)throw new Error(L.statusText);return L.text()}).then(L=>{L=`${L}
//# sourceURL=${o}`,(m?self.eval(m.createScript("",L)):new Function(L)).call(self),E()}).then(void 0,b);return}try{m&&(o=m.createScriptURL(o)),importScripts(o),E()}catch(L){b(L)}}}}class h{constructor(u){this._env=u,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(u){this._didInitialize||(this._didInitialize=!0,this._fs=u("fs"),this._vm=u("vm"),this._path=u("path"),this._crypto=u("crypto"))}_initNodeRequire(u,o){const{nodeCachedData:E}=o.getConfig().getOptionsLiteral();if(!E||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const b=this,m=u("module");function e(L){const j=L.constructor;let N=function(d){try{return L.require(d)}finally{}};return N.resolve=function(d,a){return j._resolveFilename(d,L,!1,a)},N.resolve.paths=function(d){return j._resolveLookupPaths(d,L)},N.main=process.mainModule,N.extensions=j._extensions,N.cache=j._cache,N}m.prototype._compile=function(L,j){const N=m.wrap(L.replace(/^#!.*/,"")),$=o.getRecorder(),d=b._getCachedDataPath(E,j),a={filename:j};let f;try{const R=b._fs.readFileSync(d);f=R.slice(0,16),a.cachedData=R.slice(16),$.record(60,d)}catch{$.record(61,d)}const n=new b._vm.Script(N,a),s=n.runInThisContext(a),w=b._path.dirname(j),g=e(this),v=[this.exports,g,this,j,w,process,ze,Buffer],A=s.apply(this.exports,v);return b._handleCachedData(n,N,d,!a.cachedData,o),b._verifyCachedData(n,N,d,f,o),A}}load(u,o,E,b){const m=u.getConfig().getOptionsLiteral(),e=k(u.getRecorder(),m.nodeRequire||C.global.nodeRequire),L=m.nodeInstrumenter||function(N){return N};this._init(e),this._initNodeRequire(e,u);let j=u.getRecorder();if(/^node\|/.test(o)){let N=o.split("|"),$=null;try{$=e(N[1])}catch(d){b(d);return}u.enqueueDefineAnonymousModule([],()=>$),E()}else{o=C.Utilities.fileUriToFilePath(this._env.isWindows,o);const N=this._path.normalize(o),$=this._getElectronRendererScriptPathOrUri(N),d=!!m.nodeCachedData,a=d?this._getCachedDataPath(m.nodeCachedData,o):void 0;this._readSourceAndCachedData(N,a,j,(f,n,s,w)=>{if(f){b(f);return}let g;n.charCodeAt(0)===h._BOM?g=h._PREFIX+n.substring(1)+h._SUFFIX:g=h._PREFIX+n+h._SUFFIX,g=L(g,N);const v={filename:$,cachedData:s},A=this._createAndEvalScript(u,g,v,E,b);this._handleCachedData(A,g,a,d&&!s,u),this._verifyCachedData(A,g,a,w,u)})}}_createAndEvalScript(u,o,E,b,m){const e=u.getRecorder();e.record(31,E.filename);const L=new this._vm.Script(o,E),j=L.runInThisContext(E),N=u.getGlobalAMDDefineFunc();let $=!1;const d=function(){return $=!0,N.apply(null,arguments)};return d.amd=N.amd,j.call(C.global,u.getGlobalAMDRequireFunc(),d,E.filename,this._path.dirname(E.filename)),e.record(32,E.filename),$?b():m(new Error(`Didn't receive define call in ${E.filename}!`)),L}_getElectronRendererScriptPathOrUri(u){if(!this._env.isElectronRenderer)return u;let o=u.match(/^([a-z])\:(.*)/i);return o?`file:///${(o[1].toUpperCase()+":"+o[2]).replace(/\\/g,"/")}`:`file://${u}`}_getCachedDataPath(u,o){const E=this._crypto.createHash("md5").update(o,"utf8").update(u.seed,"utf8").update(process.arch,"").digest("hex"),b=this._path.basename(o).replace(/\.js$/,"");return this._path.join(u.path,`${b}-${E}.code`)}_handleCachedData(u,o,E,b,m){u.cachedDataRejected?this._fs.unlink(E,e=>{m.getRecorder().record(62,E),this._createAndWriteCachedData(u,o,E,m),e&&m.getConfig().onError(e)}):b&&this._createAndWriteCachedData(u,o,E,m)}_createAndWriteCachedData(u,o,E,b){let m=Math.ceil(b.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),e=-1,L=0,j;const N=()=>{setTimeout(()=>{j||(j=this._crypto.createHash("md5").update(o,"utf8").digest());const $=u.createCachedData();if(!($.length===0||$.length===e||L>=5)){if($.length<e){N();return}e=$.length,this._fs.writeFile(E,Buffer.concat([j,$]),d=>{d&&b.getConfig().onError(d),b.getRecorder().record(63,E),N()})}},m*Math.pow(4,L++))};N()}_readSourceAndCachedData(u,o,E,b){if(!o)this._fs.readFile(u,{encoding:"utf8"},b);else{let m,e,L,j=2;const N=$=>{$?b($):--j===0&&b(void 0,m,e,L)};this._fs.readFile(u,{encoding:"utf8"},($,d)=>{m=d,N($)}),this._fs.readFile(o,($,d)=>{!$&&d&&d.length>0?(L=d.slice(0,16),e=d.slice(16),E.record(60,o)):E.record(61,o),N()})}}_verifyCachedData(u,o,E,b,m){b&&(u.cachedDataRejected||setTimeout(()=>{const e=this._crypto.createHash("md5").update(o,"utf8").digest();b.equals(e)||(m.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${E}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(E,L=>{L&&m.getConfig().onError(L)}))},Math.ceil(5e3*(1+Math.random()))))}}h._BOM=65279,h._PREFIX="(function (require, define, __filename, __dirname) { ",h._SUFFIX=`
});`;function k(l,u){if(u.__$__isRecorded)return u;const o=function(b){l.record(33,b);try{return u(b)}finally{l.record(34,b)}};return o.__$__isRecorded=!0,o}C.ensureRecordedNodeRequire=k;function c(l){return new t(l)}C.createScriptLoader=c})(oe||(oe={}));var oe;(function(C){class t{constructor(l){let u=l.lastIndexOf("/");u!==-1?this.fromModulePath=l.substr(0,u+1):this.fromModulePath=""}static _normalizeModuleId(l){let u=l,o;for(o=/\/\.\//;o.test(u);)u=u.replace(o,"/");for(u=u.replace(/^\.\//g,""),o=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;o.test(u);)u=u.replace(o,"/");return u=u.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),u}resolveModule(l){let u=l;return C.Utilities.isAbsolutePath(u)||(C.Utilities.startsWith(u,"./")||C.Utilities.startsWith(u,"../"))&&(u=t._normalizeModuleId(this.fromModulePath+u)),u}}t.ROOT=new t(""),C.ModuleIdResolver=t;class i{constructor(l,u,o,E,b,m){this.id=l,this.strId=u,this.dependencies=o,this._callback=E,this._errorback=b,this.moduleIdResolver=m,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(l,u){try{return{returnedValue:l.apply(C.global,u),producedError:null}}catch(o){return{returnedValue:null,producedError:o}}}static _invokeFactory(l,u,o,E){return l.shouldInvokeFactory(u)?l.shouldCatchError()?this._safeInvokeFunction(o,E):{returnedValue:o.apply(C.global,E),producedError:null}:{returnedValue:null,producedError:null}}complete(l,u,o,E){this._isComplete=!0;let b=null;if(this._callback)if(typeof this._callback=="function"){l.record(21,this.strId);let m=i._invokeFactory(u,this.strId,this._callback,o);b=m.producedError,l.record(22,this.strId),!b&&typeof m.returnedValue<"u"&&(!this.exportsPassedIn||C.Utilities.isEmpty(this.exports))&&(this.exports=m.returnedValue)}else this.exports=this._callback;if(b){let m=C.ensureError(b);m.phase="factory",m.moduleId=this.strId,m.neededBy=E(this.id),this.error=m,u.onError(m)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(l){return this._isComplete=!0,this.error=l,this._errorback?(this._errorback(l),!0):!1}isComplete(){return this._isComplete}}C.Module=i;class P{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(l){let u=this._strModuleIdToIntModuleId.get(l);return typeof u>"u"&&(u=this._nextId++,this._strModuleIdToIntModuleId.set(l,u),this._intModuleIdToStrModuleId[u]=l),u}getStrModuleId(l){return this._intModuleIdToStrModuleId[l]}}class p{constructor(l){this.id=l}}p.EXPORTS=new p(0),p.MODULE=new p(1),p.REQUIRE=new p(2),C.RegularDependency=p;class h{constructor(l,u,o){this.id=l,this.pluginId=u,this.pluginParam=o}}C.PluginDependency=h;class k{constructor(l,u,o,E,b=0){this._env=l,this._scriptLoader=u,this._loaderAvailableTimestamp=b,this._defineFunc=o,this._requireFunc=E,this._moduleIdProvider=new P,this._config=new C.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[],this._requireFunc.moduleManager=this}reset(){return new k(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(l,u){let o=m=>m.replace(/\\/g,"/"),E=o(l),b=u.split(/\n/);for(let m=0;m<b.length;m++){let e=b[m].match(/(.*):(\d+):(\d+)\)?$/);if(e){let L=e[1],j=e[2],N=e[3],$=Math.max(L.lastIndexOf(" ")+1,L.lastIndexOf("(")+1);if(L=L.substr($),L=o(L),L===E){let d={line:parseInt(j,10),col:parseInt(N,10)};return d.line===1&&(d.col-=53),d}}}throw new Error("Could not correlate define call site for needle "+l)}getBuildInfo(){if(!this._config.isBuild())return null;let l=[],u=0;for(let o=0,E=this._modules2.length;o<E;o++){let b=this._modules2[o];if(!b)continue;let m=this._buildInfoPath[b.id]||null,e=this._buildInfoDefineStack[b.id]||null,L=this._buildInfoDependencies[b.id];l[u++]={id:b.strId,path:m,defineLocation:m&&e?k._findRelevantLocationInStack(m,e):null,dependencies:L,shim:null,exports:b.exports}}return l}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new C.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=C.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(l,u){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let o=null;this._config.isBuild()&&(o=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:o,dependencies:l,callback:u}}defineModule(l,u,o,E,b,m=new t(l)){let e=this._moduleIdProvider.getModuleId(l);if(this._modules2[e]){this._config.isDuplicateMessageIgnoredFor(l)||console.warn("Duplicate definition of module '"+l+"'");return}let L=new i(e,l,this._normalizeDependencies(u,m),o,E,m);this._modules2[e]=L,this._config.isBuild()&&(this._buildInfoDefineStack[e]=b,this._buildInfoDependencies[e]=(L.dependencies||[]).map(j=>this._moduleIdProvider.getStrModuleId(j.id))),this._resolve(L)}_normalizeDependency(l,u){if(l==="exports")return p.EXPORTS;if(l==="module")return p.MODULE;if(l==="require")return p.REQUIRE;let o=l.indexOf("!");if(o>=0){let E=u.resolveModule(l.substr(0,o)),b=u.resolveModule(l.substr(o+1)),m=this._moduleIdProvider.getModuleId(E+"!"+b),e=this._moduleIdProvider.getModuleId(E);return new h(m,e,b)}return new p(this._moduleIdProvider.getModuleId(u.resolveModule(l)))}_normalizeDependencies(l,u){let o=[],E=0;for(let b=0,m=l.length;b<m;b++)o[E++]=this._normalizeDependency(l[b],u);return o}_relativeRequire(l,u,o,E){if(typeof u=="string")return this.synchronousRequire(u,l);this.defineModule(C.Utilities.generateAnonymousModule(),u,o,E,null,l)}synchronousRequire(l,u=new t(l)){let o=this._normalizeDependency(l,u),E=this._modules2[o.id];if(!E)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+l+"'. This is the first mention of this module!");if(!E.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+l+"'. This module has not been resolved completely yet.");if(E.error)throw E.error;return E.exports}configure(l,u){let o=this._config.shouldRecordStats();u?this._config=new C.Configuration(this._env,l):this._config=this._config.cloneAndMerge(l),this._config.shouldRecordStats()&&!o&&(this._recorder=null)}getConfig(){return this._config}_onLoad(l){if(this._currentAnonymousDefineCall!==null){let u=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(l),u.dependencies,u.callback,null,u.stack)}}_createLoadError(l,u){let o=this._moduleIdProvider.getStrModuleId(l),E=(this._inverseDependencies2[l]||[]).map(m=>this._moduleIdProvider.getStrModuleId(m));const b=C.ensureError(u);return b.phase="loading",b.moduleId=o,b.neededBy=E,b}_onLoadError(l,u){const o=this._createLoadError(l,u);this._modules2[l]||(this._modules2[l]=new i(l,this._moduleIdProvider.getStrModuleId(l),[],()=>{},null,null));let E=[];for(let e=0,L=this._moduleIdProvider.getMaxModuleId();e<L;e++)E[e]=!1;let b=!1,m=[];for(m.push(l),E[l]=!0;m.length>0;){let e=m.shift(),L=this._modules2[e];L&&(b=L.onDependencyError(o)||b);let j=this._inverseDependencies2[e];if(j)for(let N=0,$=j.length;N<$;N++){let d=j[N];E[d]||(m.push(d),E[d]=!0)}}b||this._config.onError(o)}_hasDependencyPath(l,u){let o=this._modules2[l];if(!o)return!1;let E=[];for(let m=0,e=this._moduleIdProvider.getMaxModuleId();m<e;m++)E[m]=!1;let b=[];for(b.push(o),E[l]=!0;b.length>0;){let e=b.shift().dependencies;if(e)for(let L=0,j=e.length;L<j;L++){let N=e[L];if(N.id===u)return!0;let $=this._modules2[N.id];$&&!E[N.id]&&(E[N.id]=!0,b.push($))}}return!1}_findCyclePath(l,u,o){if(l===u||o===50)return[l];let E=this._modules2[l];if(!E)return null;let b=E.dependencies;if(b)for(let m=0,e=b.length;m<e;m++){let L=this._findCyclePath(b[m].id,u,o+1);if(L!==null)return L.push(l),L}return null}_createRequire(l){let u=(o,E,b)=>this._relativeRequire(l,o,E,b);return u.toUrl=o=>this._config.requireToUrl(l.resolveModule(o)),u.getStats=()=>this.getLoaderEvents(),u.hasDependencyCycle=()=>this._hasDependencyCycle,u.config=(o,E=!1)=>{this.configure(o,E)},u.__$__nodeRequire=C.global.nodeRequire,u}_loadModule(l){if(this._modules2[l]||this._knownModules2[l])return;this._knownModules2[l]=!0;let u=this._moduleIdProvider.getStrModuleId(l),o=this._config.moduleIdToPaths(u),E=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(u.indexOf("/")===-1||E.test(u))&&o.push("node|"+u);let b=-1,m=e=>{if(b++,b>=o.length)this._onLoadError(l,e);else{let L=o[b],j=this.getRecorder();if(this._config.isBuild()&&L==="empty:"){this._buildInfoPath[l]=L,this.defineModule(this._moduleIdProvider.getStrModuleId(l),[],null,null,null),this._onLoad(l);return}j.record(10,L),this._scriptLoader.load(this,L,()=>{this._config.isBuild()&&(this._buildInfoPath[l]=L),j.record(11,L),this._onLoad(l)},N=>{j.record(12,L),m(N)})}};m(null)}_loadPluginDependency(l,u){if(this._modules2[u.id]||this._knownModules2[u.id])return;this._knownModules2[u.id]=!0;let o=E=>{this.defineModule(this._moduleIdProvider.getStrModuleId(u.id),[],E,null,null)};o.error=E=>{this._config.onError(this._createLoadError(u.id,E))},l.load(u.pluginParam,this._createRequire(t.ROOT),o,this._config.getOptionsLiteral())}_resolve(l){let u=l.dependencies;if(u)for(let o=0,E=u.length;o<E;o++){let b=u[o];if(b===p.EXPORTS){l.exportsPassedIn=!0,l.unresolvedDependenciesCount--;continue}if(b===p.MODULE){l.unresolvedDependenciesCount--;continue}if(b===p.REQUIRE){l.unresolvedDependenciesCount--;continue}let m=this._modules2[b.id];if(m&&m.isComplete()){if(m.error){l.onDependencyError(m.error);return}l.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(b.id,l.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(b.id)+"' and '"+this._moduleIdProvider.getStrModuleId(l.id)+"'. The cyclic path follows:");let e=this._findCyclePath(b.id,l.id,0)||[];e.reverse(),e.push(b.id),console.warn(e.map(L=>this._moduleIdProvider.getStrModuleId(L)).join(` => 
`)),l.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[b.id]=this._inverseDependencies2[b.id]||[],this._inverseDependencies2[b.id].push(l.id),b instanceof h){let e=this._modules2[b.pluginId];if(e&&e.isComplete()){this._loadPluginDependency(e.exports,b);continue}let L=this._inversePluginDependencies2.get(b.pluginId);L||(L=[],this._inversePluginDependencies2.set(b.pluginId,L)),L.push(b),this._loadModule(b.pluginId);continue}this._loadModule(b.id)}l.unresolvedDependenciesCount===0&&this._onModuleComplete(l)}_onModuleComplete(l){let u=this.getRecorder();if(l.isComplete())return;let o=l.dependencies,E=[];if(o)for(let L=0,j=o.length;L<j;L++){let N=o[L];if(N===p.EXPORTS){E[L]=l.exports;continue}if(N===p.MODULE){E[L]={id:l.strId,config:()=>this._config.getConfigForModule(l.strId)};continue}if(N===p.REQUIRE){E[L]=this._createRequire(l.moduleIdResolver);continue}let $=this._modules2[N.id];if($){E[L]=$.exports;continue}E[L]=null}const b=L=>(this._inverseDependencies2[L]||[]).map(j=>this._moduleIdProvider.getStrModuleId(j));l.complete(u,this._config,E,b);let m=this._inverseDependencies2[l.id];if(this._inverseDependencies2[l.id]=null,m)for(let L=0,j=m.length;L<j;L++){let N=m[L],$=this._modules2[N];$.unresolvedDependenciesCount--,$.unresolvedDependenciesCount===0&&this._onModuleComplete($)}let e=this._inversePluginDependencies2.get(l.id);if(e){this._inversePluginDependencies2.delete(l.id);for(let L=0,j=e.length;L<j;L++)this._loadPluginDependency(l.exports,e[L])}}}C.ModuleManager=k})(oe||(oe={}));var te,oe;(function(C){const t=new C.Environment;let i=null;const P=function(c,l,u){typeof c!="string"&&(u=l,l=c,c=null),(typeof l!="object"||!Array.isArray(l))&&(u=l,l=null),l||(l=["require","exports","module"]),c?i.defineModule(c,l,u,null,null):i.enqueueDefineAnonymousModule(l,u)};P.amd={jQuery:!0};const p=function(c,l=!1){i.configure(c,l)},h=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){p(arguments[0]);return}if(typeof arguments[0]=="string")return i.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){i.defineModule(C.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};h.config=p,h.getConfig=function(){return i.getConfig().getOptionsLiteral()},h.reset=function(){i=i.reset()},h.getBuildInfo=function(){return i.getBuildInfo()},h.getStats=function(){return i.getLoaderEvents()},h.define=P;function k(){if(typeof C.global.require<"u"||typeof require<"u"){const c=C.global.require||require;if(typeof c=="function"&&typeof c.resolve=="function"){const l=C.ensureRecordedNodeRequire(i.getRecorder(),c);C.global.nodeRequire=l,h.nodeRequire=l,h.__$__nodeRequire=l}}t.isNode&&!t.isElectronRenderer&&!t.isElectronNodeIntegrationWebWorker?module.exports=h:(t.isElectronRenderer||(C.global.define=P),C.global.require=h)}C.init=k,(typeof C.global.define!="function"||!C.global.define.amd)&&(i=new C.ModuleManager(t,C.createScriptLoader(t),P,h,C.Utilities.getHighPerformanceTimestamp()),typeof C.global.require<"u"&&typeof C.global.require!="function"&&h.config(C.global.require),te=function(){return P.apply(null,arguments)},te.amd=P.amd,typeof doNotInitLoader>"u"&&k())})(oe||(oe={})),te(ne[71],re([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=void 0;function i(c,l,u,o){if(o=o||{},(o["vs/css"]||{}).disabled){u({});return}const b=l.toUrl(c+".css");P(c,b,()=>{u({})},m=>{typeof u.error=="function"&&u.error("Could not find "+b+".")})}t.load=i;function P(c,l,u,o){if(p(c,l)){u();return}h(c,l,u,o)}function p(c,l){const u=window.document.getElementsByTagName("link");for(let o=0,E=u.length;o<E;o++){const b=u[o].getAttribute("data-name"),m=u[o].getAttribute("href");if(b===c||m===l)return!0}return!1}function h(c,l,u,o){const E=document.createElement("link");E.setAttribute("rel","stylesheet"),E.setAttribute("type","text/css"),E.setAttribute("data-name",c),k(c,E,u,o),E.setAttribute("href",l),(window.document.head||window.document.getElementsByTagName("head")[0]).appendChild(E)}function k(c,l,u,o){const E=()=>{l.removeEventListener("load",b),l.removeEventListener("error",m)},b=e=>{E(),u()},m=e=>{E(),o(e)};l.addEventListener("load",b),l.addEventListener("error",m)}}),te("vs/nls",["require","exports"],function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=t.create=t.setPseudoTranslation=t.getConfiguredDefaultLocale=t.localize2=t.localize=void 0;let i=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const P="i-default";function p(j,N){let $;return N.length===0?$=j:$=j.replace(/\{(\d+)\}/g,(d,a)=>{const f=a[0],n=N[f];let s=d;return typeof n=="string"?s=n:(typeof n=="number"||typeof n=="boolean"||n===void 0||n===null)&&(s=String(n)),s}),i&&($="\uFF3B"+$.replace(/[aouei]/g,"$&$&")+"\uFF3D"),$}function h(j,N){let $=j[N];return $||($=j["*"],$)?$:null}function k(j){return j.charAt(j.length-1)==="/"?j:j+"/"}async function c(j,N,$){const d=k(j)+k(N)+"vscode/"+k($),a=await fetch(d);if(a.ok)return await a.json();throw new Error(`${a.status} - ${a.statusText}`)}function l(j){return function(N,$){const d=Array.prototype.slice.call(arguments,2);return p(j[N],d)}}function u(j){return(N,$,...d)=>({value:p(j[N],d),original:p($,d)})}function o(j,N,...$){return p(N,$)}t.localize=o;function E(j,N,...$){const d=p(N,$);return{value:d,original:d}}t.localize2=E;function b(j){}t.getConfiguredDefaultLocale=b;function m(j){i=j}t.setPseudoTranslation=m;function e(j,N){return{localize:l(N[j]),localize2:u(N[j]),getConfiguredDefaultLocale:N.getConfiguredDefaultLocale??($=>{})}}t.create=e;function L(j,N,$,d){const a=d["vs/nls"]??{};if(!j||j.length===0)return $({localize:o,localize2:E,getConfiguredDefaultLocale:()=>a.availableLanguages?.["*"]});const f=a.availableLanguages?h(a.availableLanguages,j):null,n=f===null||f===P;let s=".nls";n||(s=s+"."+f);const w=g=>{Array.isArray(g)?(g.localize=l(g),g.localize2=u(g)):(g.localize=l(g[j]),g.localize2=u(g[j])),g.getConfiguredDefaultLocale=()=>a.availableLanguages?.["*"],$(g)};typeof a.loadBundle=="function"?a.loadBundle(j,f,(g,v)=>{g?N([j+".nls"],w):w(v)}):a.translationServiceUrl&&!n?(async()=>{try{const g=await c(a.translationServiceUrl,f,j);return w(g)}catch(g){if(!f.includes("-"))return console.error(g),N([j+".nls"],w);try{const v=f.split("-")[0],A=await c(a.translationServiceUrl,v,j);return a.availableLanguages??={},a.availableLanguages["*"]=v,w(A)}catch(v){return console.error(v),N([j+".nls"],w)}}})():N([j+s],w,g=>{if(s===".nls"){console.error("Failed trying to load default language strings",g);return}console.error(`Failed to load message bundle for language ${f}. Falling back to the default language:`,g),N([j+".nls"],w)})}t.load=L}),function(){const C=globalThis.MonacoEnvironment,t=C&&C.baseUrl?C.baseUrl:"../../../";function i(o,E){if(C?.createTrustedTypesPolicy)try{return C.createTrustedTypesPolicy(o,E)}catch(b){console.warn(b);return}try{return self.trustedTypes?.createPolicy(o,E)}catch(b){console.warn(b);return}}const P=i("amdLoader",{createScriptURL:o=>o,createScript:(o,...E)=>{const b=E.slice(0,-1).join(","),m=E.pop().toString();return`(function anonymous(${b}) { ${m}
})`}});function p(){try{return(P?globalThis.eval(P.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function h(){return new Promise((o,E)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return o();const b=t+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(b)&&b.substring(0,globalThis.origin.length)!==globalThis.origin)&&p()){fetch(b).then(e=>{if(e.status!==200)throw new Error(e.statusText);return e.text()}).then(e=>{e=`${e}
//# sourceURL=${b}`,(P?globalThis.eval(P.createScript("",e)):new Function(e)).call(globalThis),o()}).then(void 0,E);return}P?importScripts(P.createScriptURL(b)):importScripts(b),o()})}function k(){require.config({baseUrl:t,catchError:!0,trustedTypesPolicy:P,amdModulesPattern:/^vs\//})}function c(o){h().then(()=>{k(),require([o],function(E){setTimeout(function(){const b=E.create((m,e)=>{globalThis.postMessage(m,e)},null);for(globalThis.onmessage=m=>b.onmessage(m.data,m.ports);u.length>0;){const m=u.shift();b.onmessage(m.data,m.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&k();let l=!0;const u=[];globalThis.onmessage=o=>{if(!l){u.push(o);return}l=!1,c(o.data)}}(),te(ne[9],re([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rb=t.$qb=t.$pb=t.$ob=t.$nb=t.$mb=t.$lb=t.$kb=t.$jb=t.$ib=t.$hb=t.$gb=t.$fb=void 0;function i(L,j,N){const $=P(L,j);if($!==-1)return L[$]}t.$fb=i;function P(L,j,N=L.length-1){for(let $=N;$>=0;$--){const d=L[$];if(j(d))return $}return-1}t.$gb=P;function p(L,j){const N=h(L,j);return N===-1?void 0:L[N]}t.$hb=p;function h(L,j,N=0,$=L.length){let d=N,a=$;for(;d<a;){const f=Math.floor((d+a)/2);j(L[f])?d=f+1:a=f}return d-1}t.$ib=h;function k(L,j){const N=c(L,j);return N===L.length?void 0:L[N]}t.$jb=k;function c(L,j,N=0,$=L.length){let d=N,a=$;for(;d<a;){const f=Math.floor((d+a)/2);j(L[f])?a=f:d=f+1}return d}t.$kb=c;function l(L,j,N=0,$=L.length){const d=c(L,j,N,$);return d===L.length?-1:d}t.$lb=l;class u{static{this.assertInvariants=!1}constructor(j){this.e=j,this.c=0}findLastMonotonous(j){if(u.assertInvariants){if(this.d){for(const $ of this.e)if(this.d($)&&!j($))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=j}const N=h(this.e,j,this.c);return this.c=N+1,N===-1?void 0:this.e[N]}}t.$mb=u;function o(L,j){if(L.length===0)return;let N=L[0];for(let $=1;$<L.length;$++){const d=L[$];j(d,N)>0&&(N=d)}return N}t.$nb=o;function E(L,j){if(L.length===0)return;let N=L[0];for(let $=1;$<L.length;$++){const d=L[$];j(d,N)>=0&&(N=d)}return N}t.$ob=E;function b(L,j){return o(L,(N,$)=>-j(N,$))}t.$pb=b;function m(L,j){if(L.length===0)return-1;let N=0;for(let $=1;$<L.length;$++){const d=L[$];j(d,L[N])>0&&(N=$)}return N}t.$qb=m;function e(L,j){for(const N of L){const $=j(N);if($!==void 0)return $}}t.$rb=e}),te(ne[35],re([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$N=t.$M=t.$L=t.$K=void 0;function i(k,c){const l=Object.create(null);for(const u of k){const o=c(u);let E=l[o];E||(E=l[o]=[]),E.push(u)}return l}t.$K=i;function P(k,c){const l=[],u=[];for(const o of k)c.has(o)||l.push(o);for(const o of c)k.has(o)||u.push(o);return{removed:l,added:u}}t.$L=P;function p(k,c){const l=[],u=[];for(const[o,E]of k)c.has(o)||l.push(E);for(const[o,E]of c)k.has(o)||u.push(E);return{removed:l,added:u}}t.$M=p;function h(k,c){const l=new Set;for(const u of c)k.has(u)&&l.add(u);return l}t.$N=h}),te(ne[36],re([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$At=t.$zt=t.$yt=t.$xt=void 0;function i(c,l){const u=Math.pow(10,l);return Math.round(c*u)/u}class P{constructor(l,u,o,E=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,l))|0,this.g=Math.min(255,Math.max(0,u))|0,this.b=Math.min(255,Math.max(0,o))|0,this.a=i(Math.max(Math.min(1,E),0),3)}static equals(l,u){return l.r===u.r&&l.g===u.g&&l.b===u.b&&l.a===u.a}}t.$xt=P;class p{constructor(l,u,o,E){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=i(Math.max(Math.min(1,u),0),3),this.l=i(Math.max(Math.min(1,o),0),3),this.a=i(Math.max(Math.min(1,E),0),3)}static equals(l,u){return l.h===u.h&&l.s===u.s&&l.l===u.l&&l.a===u.a}static fromRGBA(l){const u=l.r/255,o=l.g/255,E=l.b/255,b=l.a,m=Math.max(u,o,E),e=Math.min(u,o,E);let L=0,j=0;const N=(e+m)/2,$=m-e;if($>0){switch(j=Math.min(N<=.5?$/(2*N):$/(2-2*N),1),m){case u:L=(o-E)/$+(o<E?6:0);break;case o:L=(E-u)/$+2;break;case E:L=(u-o)/$+4;break}L*=60,L=Math.round(L)}return new p(L,j,N,b)}static i(l,u,o){return o<0&&(o+=1),o>1&&(o-=1),o<1/6?l+(u-l)*6*o:o<1/2?u:o<2/3?l+(u-l)*(2/3-o)*6:l}static toRGBA(l){const u=l.h/360,{s:o,l:E,a:b}=l;let m,e,L;if(o===0)m=e=L=E;else{const j=E<.5?E*(1+o):E+o-E*o,N=2*E-j;m=p.i(N,j,u+1/3),e=p.i(N,j,u),L=p.i(N,j,u-1/3)}return new P(Math.round(m*255),Math.round(e*255),Math.round(L*255),b)}}t.$yt=p;class h{constructor(l,u,o,E){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=i(Math.max(Math.min(1,u),0),3),this.v=i(Math.max(Math.min(1,o),0),3),this.a=i(Math.max(Math.min(1,E),0),3)}static equals(l,u){return l.h===u.h&&l.s===u.s&&l.v===u.v&&l.a===u.a}static fromRGBA(l){const u=l.r/255,o=l.g/255,E=l.b/255,b=Math.max(u,o,E),m=Math.min(u,o,E),e=b-m,L=b===0?0:e/b;let j;return e===0?j=0:b===u?j=((o-E)/e%6+6)%6:b===o?j=(E-u)/e+2:j=(u-o)/e+4,new h(Math.round(j*60),L,b,l.a)}static toRGBA(l){const{h:u,s:o,v:E,a:b}=l,m=E*o,e=m*(1-Math.abs(u/60%2-1)),L=E-m;let[j,N,$]=[0,0,0];return u<60?(j=m,N=e):u<120?(j=e,N=m):u<180?(N=m,$=e):u<240?(N=e,$=m):u<300?(j=e,$=m):u<=360&&(j=m,$=e),j=Math.round((j+L)*255),N=Math.round((N+L)*255),$=Math.round(($+L)*255),new P(j,N,$,b)}}t.$zt=h;class k{static fromHex(l){return k.Format.CSS.parseHex(l)||k.red}static equals(l,u){return!l&&!u?!0:!l||!u?!1:l.equals(u)}get hsla(){return this.i?this.i:p.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:h.fromRGBA(this.rgba)}constructor(l){if(l)if(l instanceof P)this.rgba=l;else if(l instanceof p)this.i=l,this.rgba=p.toRGBA(l);else if(l instanceof h)this.j=l,this.rgba=h.toRGBA(l);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(l){return!!l&&P.equals(this.rgba,l.rgba)&&p.equals(this.hsla,l.hsla)&&h.equals(this.hsva,l.hsva)}getRelativeLuminance(){const l=k.k(this.rgba.r),u=k.k(this.rgba.g),o=k.k(this.rgba.b),E=.2126*l+.7152*u+.0722*o;return i(E,4)}static k(l){const u=l/255;return u<=.03928?u/12.92:Math.pow((u+.055)/1.055,2.4)}getContrastRatio(l){const u=this.getRelativeLuminance(),o=l.getRelativeLuminance();return u>o?(u+.05)/(o+.05):(o+.05)/(u+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(l){const u=this.getRelativeLuminance(),o=l.getRelativeLuminance();return u>o}isDarkerThan(l){const u=this.getRelativeLuminance(),o=l.getRelativeLuminance();return u<o}lighten(l){return new k(new p(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*l,this.hsla.a))}darken(l){return new k(new p(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*l,this.hsla.a))}transparent(l){const{r:u,g:o,b:E,a:b}=this.rgba;return new k(new P(u,o,E,b*l))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new k(new P(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(l){const u=l.rgba,o=this.rgba.a,E=u.a,b=o+E*(1-o);if(b<1e-6)return k.transparent;const m=this.rgba.r*o/b+u.r*E*(1-o)/b,e=this.rgba.g*o/b+u.g*E*(1-o)/b,L=this.rgba.b*o/b+u.b*E*(1-o)/b;return new k(new P(m,e,L,b))}makeOpaque(l){if(this.isOpaque()||l.rgba.a!==1)return this;const{r:u,g:o,b:E,a:b}=this.rgba;return new k(new P(l.rgba.r-b*(l.rgba.r-u),l.rgba.g-b*(l.rgba.g-o),l.rgba.b-b*(l.rgba.b-E),1))}flatten(...l){const u=l.reduceRight((o,E)=>k.o(E,o));return k.o(this,u)}static o(l,u){const o=1-l.rgba.a;return new k(new P(o*u.rgba.r+l.rgba.a*l.rgba.r,o*u.rgba.g+l.rgba.a*l.rgba.g,o*u.rgba.b+l.rgba.a*l.rgba.b))}toString(){return this.u||(this.u=k.Format.CSS.format(this)),this.u}static getLighterColor(l,u,o){if(l.isLighterThan(u))return l;o=o||.5;const E=l.getRelativeLuminance(),b=u.getRelativeLuminance();return o=o*(b-E)/b,l.lighten(o)}static getDarkerColor(l,u,o){if(l.isDarkerThan(u))return l;o=o||.5;const E=l.getRelativeLuminance(),b=u.getRelativeLuminance();return o=o*(E-b)/E,l.darken(o)}static{this.white=new k(new P(255,255,255,1))}static{this.black=new k(new P(0,0,0,1))}static{this.red=new k(new P(255,0,0,1))}static{this.blue=new k(new P(0,0,255,1))}static{this.green=new k(new P(0,255,0,1))}static{this.cyan=new k(new P(0,255,255,1))}static{this.lightgrey=new k(new P(211,211,211,1))}static{this.transparent=new k(new P(0,0,0,0))}}t.$At=k,function(c){let l;(function(u){let o;(function(E){function b(n){return n.rgba.a===1?`rgb(${n.rgba.r}, ${n.rgba.g}, ${n.rgba.b})`:c.Format.CSS.formatRGBA(n)}E.formatRGB=b;function m(n){return`rgba(${n.rgba.r}, ${n.rgba.g}, ${n.rgba.b}, ${+n.rgba.a.toFixed(2)})`}E.formatRGBA=m;function e(n){return n.hsla.a===1?`hsl(${n.hsla.h}, ${(n.hsla.s*100).toFixed(2)}%, ${(n.hsla.l*100).toFixed(2)}%)`:c.Format.CSS.formatHSLA(n)}E.formatHSL=e;function L(n){return`hsla(${n.hsla.h}, ${(n.hsla.s*100).toFixed(2)}%, ${(n.hsla.l*100).toFixed(2)}%, ${n.hsla.a.toFixed(2)})`}E.formatHSLA=L;function j(n){const s=n.toString(16);return s.length!==2?"0"+s:s}function N(n){return`#${j(n.rgba.r)}${j(n.rgba.g)}${j(n.rgba.b)}`}E.formatHex=N;function $(n,s=!1){return s&&n.rgba.a===1?c.Format.CSS.formatHex(n):`#${j(n.rgba.r)}${j(n.rgba.g)}${j(n.rgba.b)}${j(Math.round(n.rgba.a*255))}`}E.formatHexA=$;function d(n){return n.isOpaque()?c.Format.CSS.formatHex(n):c.Format.CSS.formatRGBA(n)}E.format=d;function a(n){const s=n.length;if(s===0||n.charCodeAt(0)!==35)return null;if(s===7){const w=16*f(n.charCodeAt(1))+f(n.charCodeAt(2)),g=16*f(n.charCodeAt(3))+f(n.charCodeAt(4)),v=16*f(n.charCodeAt(5))+f(n.charCodeAt(6));return new c(new P(w,g,v,1))}if(s===9){const w=16*f(n.charCodeAt(1))+f(n.charCodeAt(2)),g=16*f(n.charCodeAt(3))+f(n.charCodeAt(4)),v=16*f(n.charCodeAt(5))+f(n.charCodeAt(6)),A=16*f(n.charCodeAt(7))+f(n.charCodeAt(8));return new c(new P(w,g,v,A/255))}if(s===4){const w=f(n.charCodeAt(1)),g=f(n.charCodeAt(2)),v=f(n.charCodeAt(3));return new c(new P(16*w+w,16*g+g,16*v+v))}if(s===5){const w=f(n.charCodeAt(1)),g=f(n.charCodeAt(2)),v=f(n.charCodeAt(3)),A=f(n.charCodeAt(4));return new c(new P(16*w+w,16*g+g,16*v+v,(16*A+A)/255))}return null}E.parseHex=a;function f(n){switch(n){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(o=u.CSS||(u.CSS={}))})(l=c.Format||(c.Format={}))}(k||(t.$At=k={}))}),te(ne[37],re([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_s=void 0;class i{constructor(p,h,k,c){this.originalStart=p,this.originalLength=h,this.modifiedStart=k,this.modifiedLength=c}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$_s=i}),te(ne[3],re([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=t.$bb=t.$ab=t.$_=t.$$=t.$0=t.$9=t.$8=t.$7=t.$6=t.$5=t.$4=t.$3=t.$2=t.$1=t.$Z=t.setUnexpectedErrorHandler=t.$X=t.$W=void 0;class i{constructor(){this.b=[],this.a=function(n){setTimeout(()=>{throw n.stack?d.isErrorNoTelemetry(n)?new d(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.b.push(n),()=>{this.d(n)}}c(n){this.b.forEach(s=>{s(n)})}d(n){this.b.splice(this.b.indexOf(n),1)}setUnexpectedErrorHandler(n){this.a=n}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(n){this.a(n),this.c(n)}onUnexpectedExternalError(n){this.a(n)}}t.$W=i,t.$X=new i;function P(f){t.$X.setUnexpectedErrorHandler(f)}t.setUnexpectedErrorHandler=P;function p(f){if(!f||typeof f!="object")return!1;const n=f;return n.code==="EPIPE"&&n.syscall?.toUpperCase()==="WRITE"}t.$Z=p;function h(f){u(f)||t.$X.onUnexpectedError(f)}t.$1=h;function k(f){u(f)||t.$X.onUnexpectedExternalError(f)}t.$2=k;function c(f){if(f instanceof Error){const{name:n,message:s}=f,w=f.stacktrace||f.stack;return{$isError:!0,name:n,message:s,stack:w,noTelemetry:d.isErrorNoTelemetry(f)}}return f}t.$3=c;const l="Canceled";function u(f){return f instanceof o?!0:f instanceof Error&&f.name===l&&f.message===l}t.$4=u;class o extends Error{constructor(){super(l),this.name=this.message}}t.$5=o;function E(){const f=new Error(l);return f.name=f.message,f}t.$6=E;function b(f){return f?new Error(`Illegal argument: ${f}`):new Error("Illegal argument")}t.$7=b;function m(f){return f?new Error(`Illegal state: ${f}`):new Error("Illegal state")}t.$8=m;class e extends TypeError{constructor(n){super(n?`${n} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$9=e;function L(f){return f?f.message?f.message:f.stack?f.stack.split(`
`)[0]:String(f):"Error"}t.$0=L;class j extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}t.$$=j;class N extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}t.$_=N;class $ extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$ab=$;class d extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof d)return n;const s=new d;return s.message=n.message,s.stack=n.stack,s}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}t.$bb=d;class a extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,a.prototype)}}t.$cb=a}),te(ne[6],re([0,1,3,9]),function(C,t,i,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ac=t.$_b=t.$$b=t.$0b=t.$9b=t.$8b=t.$7b=t.CompareResult=t.$6b=t.$5b=t.$4b=t.$3b=t.$2b=t.$1b=t.$Zb=t.$Yb=t.$Xb=t.$Wb=t.$Vb=t.$Ub=t.$Tb=t.$Sb=t.$Rb=t.$Qb=t.$Pb=t.$Ob=t.$Nb=t.$Mb=t.$Lb=t.$Kb=t.$Jb=t.$Ib=t.$Hb=t.$Gb=t.top=t.$Eb=t.$Db=t.$Cb=t.$Bb=t.$Ab=t.$zb=t.$yb=t.$xb=t.$wb=t.$vb=t.$ub=t.$tb=t.$sb=void 0;function p(V,z=0){return V[V.length-(1+z)]}t.$sb=p;function h(V){if(V.length===0)throw new Error("Invalid tail call");return[V.slice(0,V.length-1),V[V.length-1]]}t.$tb=h;function k(V,z,x=(Y,H)=>Y===H){if(V===z)return!0;if(!V||!z||V.length!==z.length)return!1;for(let Y=0,H=V.length;Y<H;Y++)if(!x(V[Y],z[Y]))return!1;return!0}t.$ub=k;function c(V,z){const x=V.length-1;z<x&&(V[z]=V[x]),V.pop()}t.$vb=c;function l(V,z,x){return u(V.length,Y=>x(V[Y],z))}t.$wb=l;function u(V,z){let x=0,Y=V-1;for(;x<=Y;){const H=(x+Y)/2|0,J=z(H);if(J<0)x=H+1;else if(J>0)Y=H-1;else return H}return-(x+1)}t.$xb=u;function o(V,z,x){if(V=V|0,V>=z.length)throw new TypeError("invalid index");const Y=z[Math.floor(z.length*Math.random())],H=[],J=[],U=[];for(const K of z){const ie=x(K,Y);ie<0?H.push(K):ie>0?J.push(K):U.push(K)}return V<H.length?o(V,H,x):V<H.length+U.length?U[0]:o(V-(H.length+U.length),J,x)}t.$yb=o;function E(V,z){const x=[];let Y;for(const H of V.slice(0).sort(z))!Y||z(Y[0],H)!==0?(Y=[H],x.push(Y)):Y.push(H);return x}t.$zb=E;function*b(V,z){let x,Y;for(const H of V)Y!==void 0&&z(Y,H)?x.push(H):(x&&(yield x),x=[H]),Y=H;x&&(yield x)}t.$Ab=b;function m(V,z){for(let x=0;x<=V.length;x++)z(x===0?void 0:V[x-1],x===V.length?void 0:V[x])}t.$Bb=m;function e(V,z){for(let x=0;x<V.length;x++)z(x===0?void 0:V[x-1],V[x],x+1===V.length?void 0:V[x+1])}t.$Cb=e;function L(V,z,x){const Y=[];function H(K,ie,le){if(ie===0&&le.length===0)return;const fe=Y[Y.length-1];fe&&fe.start+fe.deleteCount===K?(fe.deleteCount+=ie,fe.toInsert.push(...le)):Y.push({start:K,deleteCount:ie,toInsert:le})}let J=0,U=0;for(;;){if(J===V.length){H(J,0,z.slice(U));break}if(U===z.length){H(J,V.length-J,[]);break}const K=V[J],ie=z[U],le=x(K,ie);le===0?(J+=1,U+=1):le<0?(H(J,1,[]),J+=1):le>0&&(H(J,0,[ie]),U+=1)}return Y}t.$Db=L;function j(V,z,x){const Y=L(V,z,x),H=[],J=[];for(const U of Y)H.push(...V.slice(U.start,U.start+U.deleteCount)),J.push(...U.toInsert);return{removed:H,added:J}}t.$Eb=j;function N(V,z,x){if(x===0)return[];const Y=V.slice(0,x).sort(z);return d(V,z,Y,x,V.length),Y}t.top=N;function $(V,z,x,Y,H){return x===0?Promise.resolve([]):new Promise((J,U)=>{(async()=>{const K=V.length,ie=V.slice(0,x).sort(z);for(let le=x,fe=Math.min(x+Y,K);le<K;le=fe,fe=Math.min(fe+Y,K)){if(le>x&&await new Promise(ce=>setTimeout(ce)),H&&H.isCancellationRequested)throw new i.$5;d(V,z,ie,le,fe)}return ie})().then(J,U)})}t.$Gb=$;function d(V,z,x,Y,H){for(const J=x.length;Y<H;Y++){const U=V[Y];if(z(U,x[J-1])<0){x.pop();const K=(0,P.$kb)(x,ie=>z(U,ie)<0);x.splice(K,0,U)}}}function a(V){return V.filter(z=>!!z)}t.$Hb=a;function f(V){let z=0;for(let x=0;x<V.length;x++)V[x]&&(V[z]=V[x],z+=1);V.length=z}t.$Ib=f;function n(V,z,x){V.splice(x,0,V.splice(z,1)[0])}t.$Jb=n;function s(V){return!Array.isArray(V)||V.length===0}t.$Kb=s;function w(V){return Array.isArray(V)&&V.length>0}t.$Lb=w;function g(V,z=x=>x){const x=new Set;return V.filter(Y=>{const H=z(Y);return x.has(H)?!1:(x.add(H),!0)})}t.$Mb=g;function v(V){const z=new Set;return x=>{const Y=V(x);return z.has(Y)?!1:(z.add(Y),!0)}}t.$Nb=v;function A(V,z){return V.length>0?V[0]:z}t.$Ob=A;function R(V,z){return V.length>0?V[V.length-1]:z}t.$Pb=R;function y(V,z,x=(Y,H)=>Y===H){let Y=0;for(let H=0,J=Math.min(V.length,z.length);H<J&&x(V[H],z[H]);H++)Y++;return Y}t.$Qb=y;function F(V){return[].concat(...V)}t.$Rb=F;function M(V,z){let x=typeof z=="number"?V:0;typeof z=="number"?x=V:(x=0,z=V);const Y=[];if(x<=z)for(let H=x;H<z;H++)Y.push(H);else for(let H=x;H>z;H--)Y.push(H);return Y}t.$Sb=M;function S(V,z,x){return V.reduce((Y,H)=>(Y[z(H)]=x?x(H):H,Y),Object.create(null))}t.$Tb=S;function D(V,z){return V.push(z),()=>q(V,z)}t.$Ub=D;function q(V,z){const x=V.indexOf(z);if(x>-1)return V.splice(x,1),z}t.$Vb=q;function W(V,z,x){const Y=V.slice(0,z),H=V.slice(z);return Y.concat(x,H)}t.$Wb=W;function G(V,z){let x;if(typeof z=="number"){let Y=z;x=()=>{const H=Math.sin(Y++)*179426549;return H-Math.floor(H)}}else x=Math.random;for(let Y=V.length-1;Y>0;Y-=1){const H=Math.floor(x()*(Y+1)),J=V[Y];V[Y]=V[H],V[H]=J}}t.$Xb=G;function ee(V,z){const x=V.indexOf(z);x>-1&&(V.splice(x,1),V.unshift(z))}t.$Yb=ee;function T(V,z){const x=V.indexOf(z);x>-1&&(V.splice(x,1),V.push(z))}t.$Zb=T;function B(V,z){for(const x of z)V.push(x)}t.$1b=B;function _(V,z){return Array.isArray(V)?V.map(z):z(V)}t.$2b=_;function Q(V){return Array.isArray(V)?V:[V]}t.$3b=Q;function se(V){return V[Math.floor(Math.random()*V.length)]}t.$4b=se;function ae(V,z,x){const Y=ge(V,z),H=V.length,J=x.length;V.length=H+J;for(let U=H-1;U>=Y;U--)V[U+J]=V[U];for(let U=0;U<J;U++)V[U+Y]=x[U]}t.$5b=ae;function r(V,z,x,Y){const H=ge(V,z);let J=V.splice(H,x);return J===void 0&&(J=[]),ae(V,H,Y),J}t.$6b=r;function ge(V,z){return z<0?Math.max(z+V.length,0):Math.min(z,V.length)}var ve;(function(V){function z(J){return J<0}V.isLessThan=z;function x(J){return J<=0}V.isLessThanOrEqual=x;function Y(J){return J>0}V.isGreaterThan=Y;function H(J){return J===0}V.isNeitherLessOrGreaterThan=H,V.greaterThan=1,V.lessThan=-1,V.neitherLessOrGreaterThan=0})(ve||(t.CompareResult=ve={}));function Ee(V,z){return(x,Y)=>z(V(x),V(Y))}t.$7b=Ee;function $e(...V){return(z,x)=>{for(const Y of V){const H=Y(z,x);if(!ve.isNeitherLessOrGreaterThan(H))return H}return ve.neitherLessOrGreaterThan}}t.$8b=$e;const pe=(V,z)=>V-z;t.$9b=pe;const ye=(V,z)=>(0,t.$9b)(V?1:0,z?1:0);t.$0b=ye;function Se(V){return(z,x)=>-V(z,x)}t.$$b=Se;class Ie{constructor(z){this.g=z,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(z){let x=this.c;for(;x<this.g.length&&z(this.g[x]);)x++;const Y=x===this.c?null:this.g.slice(this.c,x);return this.c=x,Y}takeFromEndWhile(z){let x=this.d;for(;x>=0&&z(this.g[x]);)x--;const Y=x===this.d?null:this.g.slice(x+1,this.d+1);return this.d=x,Y}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const z=this.g[this.c];return this.c++,z}removeLast(){const z=this.g[this.d];return this.d--,z}takeCount(z){const x=this.g.slice(this.c,this.c+z);return this.c+=z,x}}t.$_b=Ie;class je{static{this.empty=new je(z=>{})}constructor(z){this.iterate=z}forEach(z){this.iterate(x=>(z(x),!0))}toArray(){const z=[];return this.iterate(x=>(z.push(x),!0)),z}filter(z){return new je(x=>this.iterate(Y=>z(Y)?x(Y):!0))}map(z){return new je(x=>this.iterate(Y=>x(z(Y))))}some(z){let x=!1;return this.iterate(Y=>(x=z(Y),!x)),x}findFirst(z){let x;return this.iterate(Y=>z(Y)?(x=Y,!1):!0),x}findLast(z){let x;return this.iterate(Y=>(z(Y)&&(x=Y),!0)),x}findLastMaxBy(z){let x,Y=!0;return this.iterate(H=>((Y||ve.isGreaterThan(z(H,x)))&&(Y=!1,x=H),!0)),x}}t.$ac=je}),te(ne[13],re([0,1,3]),function(C,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ad=t.$_c=t.$$c=t.$0c=t.$9c=t.ok=void 0;function P(u,o){if(!u)throw new Error(o?`Assertion failed (${o})`:"Assertion Failed")}t.ok=P;function p(u,o="Unreachable"){throw new Error(o)}t.$9c=p;function h(u){if(!u)throw new i.$cb("Assertion Failed")}t.$0c=h;function k(u){u||(0,i.$1)(new i.$cb("Soft Assertion Failed"))}t.$$c=k;function c(u){if(!u()){debugger;u(),(0,i.$1)(new i.$cb("Assertion Failed"))}}t.$_c=c;function l(u,o){let E=0;for(;E<u.length-1;){const b=u[E],m=u[E+1];if(!o(b,m))return!1;E++}return!0}t.$ad=l}),te(ne[19],re([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$db=void 0;function i(P,p){const h=this;let k=!1,c;return function(){if(k)return c;if(k=!0,p)try{c=P.apply(h,arguments)}finally{p()}else c=P.apply(h,arguments);return c}}t.$db=i}),te(ne[20],re([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var i;(function(P){function p(n){return n&&typeof n=="object"&&typeof n[Symbol.iterator]=="function"}P.is=p;const h=Object.freeze([]);function k(){return h}P.empty=k;function*c(n){yield n}P.single=c;function l(n){return p(n)?n:c(n)}P.wrap=l;function u(n){return n||h}P.from=u;function*o(n){for(let s=n.length-1;s>=0;s--)yield n[s]}P.reverse=o;function E(n){return!n||n[Symbol.iterator]().next().done===!0}P.isEmpty=E;function b(n){return n[Symbol.iterator]().next().value}P.first=b;function m(n,s){for(const w of n)if(s(w))return!0;return!1}P.some=m;function e(n,s){for(const w of n)if(s(w))return w}P.find=e;function*L(n,s){for(const w of n)s(w)&&(yield w)}P.filter=L;function*j(n,s){let w=0;for(const g of n)yield s(g,w++)}P.map=j;function*N(...n){for(const s of n)yield*s}P.concat=N;function $(n,s,w){let g=w;for(const v of n)g=s(g,v);return g}P.reduce=$;function*d(n,s,w=n.length){for(s<0&&(s+=n.length),w<0?w+=n.length:w>n.length&&(w=n.length);s<w;s++)yield n[s]}P.slice=d;function a(n,s=Number.POSITIVE_INFINITY){const w=[];if(s===0)return[w,n];const g=n[Symbol.iterator]();for(let v=0;v<s;v++){const A=g.next();if(A.done)return[w,P.empty()];w.push(A.value)}return[w,{[Symbol.iterator](){return g}}]}P.consume=a;async function f(n){const s=[];for await(const w of n)s.push(w);return Promise.resolve(s)}P.asyncToArray=f})(i||(t.Iterable=i={}))}),te(ne[38],re([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ir=t.KeyMod=t.KeyCodeUtils=t.$hr=t.$gr=t.$fr=t.$er=t.$dr=t.ScanCode=t.KeyCode=void 0;var i;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(i||(t.KeyCode=i={}));var P;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(P||(t.ScanCode=P={}));class p{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(L,j){this._keyCodeToStr[L]=j,this._strToKeyCode[j.toLowerCase()]=L}keyCodeToStr(L){return this._keyCodeToStr[L]}strToKeyCode(L){return this._strToKeyCode[L.toLowerCase()]||0}}const h=new p,k=new p,c=new p;t.$dr=new Array(230),t.$er={};const l=[],u=Object.create(null),o=Object.create(null);t.$fr={lowerCaseToEnum:e=>o[e]||0,toEnum:e=>u[e]||0,toString:e=>l[e]||"None"},t.$gr=[],t.$hr=[];for(let e=0;e<=193;e++)t.$gr[e]=-1;for(let e=0;e<=132;e++)t.$hr[e]=-1;(function(){const e="",L=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],j=[],N=[];for(const $ of L){const[d,a,f,n,s,w,g,v,A]=$;if(N[a]||(N[a]=!0,l[a]=f,u[f]=a,o[f.toLowerCase()]=a,d&&(t.$gr[a]=n,n!==0&&n!==3&&n!==5&&n!==4&&n!==6&&n!==57&&(t.$hr[n]=a))),!j[n]){if(j[n]=!0,!s)throw new Error(`String representation missing for key code ${n} around scan code ${f}`);h.define(n,s),k.define(n,v||s),c.define(n,A||v||s)}w&&(t.$dr[w]=n),g&&(t.$er[g]=n)}t.$hr[3]=46})();var E;(function(e){function L(f){return h.keyCodeToStr(f)}e.toString=L;function j(f){return h.strToKeyCode(f)}e.fromString=j;function N(f){return k.keyCodeToStr(f)}e.toUserSettingsUS=N;function $(f){return c.keyCodeToStr(f)}e.toUserSettingsGeneral=$;function d(f){return k.strToKeyCode(f)||c.strToKeyCode(f)}e.fromUserSettings=d;function a(f){if(f>=98&&f<=113)return null;switch(f){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return h.keyCodeToStr(f)}e.toElectronAccelerator=a})(E||(t.KeyCodeUtils=E={}));var b;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(b||(t.KeyMod=b={}));function m(e,L){const j=(L&65535)<<16>>>0;return(e|j)>>>0}t.$ir=m}),te(ne[39],re([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$V=void 0;class i{constructor(p){this.d=p,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(p){this.c=p}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$V=i}),te(ne[21],re([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4c=void 0;class i{static{this.Undefined=new i(void 0)}constructor(h){this.element=h,this.next=i.Undefined,this.prev=i.Undefined}}class P{constructor(){this.a=i.Undefined,this.b=i.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===i.Undefined}clear(){let h=this.a;for(;h!==i.Undefined;){const k=h.next;h.prev=i.Undefined,h.next=i.Undefined,h=k}this.a=i.Undefined,this.b=i.Undefined,this.c=0}unshift(h){return this.d(h,!1)}push(h){return this.d(h,!0)}d(h,k){const c=new i(h);if(this.a===i.Undefined)this.a=c,this.b=c;else if(k){const u=this.b;this.b=c,c.prev=u,u.next=c}else{const u=this.a;this.a=c,c.next=u,u.prev=c}this.c+=1;let l=!1;return()=>{l||(l=!0,this.e(c))}}shift(){if(this.a!==i.Undefined){const h=this.a.element;return this.e(this.a),h}}pop(){if(this.b!==i.Undefined){const h=this.b.element;return this.e(this.b),h}}e(h){if(h.prev!==i.Undefined&&h.next!==i.Undefined){const k=h.prev;k.next=h.next,h.next.prev=k}else h.prev===i.Undefined&&h.next===i.Undefined?(this.a=i.Undefined,this.b=i.Undefined):h.next===i.Undefined?(this.b=this.b.prev,this.b.next=i.Undefined):h.prev===i.Undefined&&(this.a=this.a.next,this.a.prev=i.Undefined);this.c-=1}*[Symbol.iterator](){let h=this.a;for(;h!==i.Undefined;)yield h.element,h=h.next}}t.$4c=P}),te(ne[22],re([0,1]),function(C,t){"use strict";var i,P,p;Object.defineProperty(t,"__esModule",{value:!0}),t.$Hc=t.$Gc=t.$Fc=t.$Ec=t.$Dc=t.$Cc=t.Touch=t.$Bc=t.$Ac=t.$zc=t.$yc=t.$xc=void 0;function h(d,a,f){let n=d.get(a);return n===void 0&&(n=f,d.set(a,n)),n}t.$xc=h;function k(d){const a=[];return d.forEach((f,n)=>{a.push(`${n} => ${f}`)}),`Map(${d.size}) {${a.join(", ")}}`}t.$yc=k;function c(d){const a=[];return d.forEach(f=>{a.push(f)}),`Set(${d.size}) {${a.join(", ")}}`}t.$zc=c;class l{constructor(a,f){this.uri=a,this.value=f}}function u(d){return Array.isArray(d)}class o{static{this.c=a=>a.toString()}constructor(a,f){if(this[i]="ResourceMap",a instanceof o)this.d=new Map(a.d),this.e=f??o.c;else if(u(a)){this.d=new Map,this.e=f??o.c;for(const[n,s]of a)this.set(n,s)}else this.d=new Map,this.e=a??o.c}set(a,f){return this.d.set(this.e(a),new l(a,f)),this}get(a){return this.d.get(this.e(a))?.value}has(a){return this.d.has(this.e(a))}get size(){return this.d.size}clear(){this.d.clear()}delete(a){return this.d.delete(this.e(a))}forEach(a,f){typeof f<"u"&&(a=a.bind(f));for(const[n,s]of this.d)a(s.value,s.uri,this)}*values(){for(const a of this.d.values())yield a.value}*keys(){for(const a of this.d.values())yield a.uri}*entries(){for(const a of this.d.values())yield[a.uri,a.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,a]of this.d)yield[a.uri,a.value]}}t.$Ac=o;class E{constructor(a,f){this[P]="ResourceSet",!a||typeof a=="function"?this.c=new o(a):(this.c=new o(f),a.forEach(this.add,this))}get size(){return this.c.size}add(a){return this.c.set(a,a),this}clear(){this.c.clear()}delete(a){return this.c.delete(a)}forEach(a,f){this.c.forEach((n,s)=>a.call(f,s,s,this))}has(a){return this.c.has(a)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Bc=E;var b;(function(d){d[d.None=0]="None",d[d.AsOld=1]="AsOld",d[d.AsNew=2]="AsNew"})(b||(t.Touch=b={}));class m{constructor(){this[p]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(a){return this.c.has(a)}get(a,f=0){const n=this.c.get(a);if(n)return f!==0&&this.l(n,f),n.value}set(a,f,n=0){let s=this.c.get(a);if(s)s.value=f,n!==0&&this.l(s,n);else{switch(s={key:a,value:f,next:void 0,previous:void 0},n){case 0:this.j(s);break;case 1:this.i(s);break;case 2:this.j(s);break;default:this.j(s);break}this.c.set(a,s),this.f++}return this}delete(a){return!!this.remove(a)}remove(a){const f=this.c.get(a);if(f)return this.c.delete(a),this.k(f),this.f--,f.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const a=this.d;return this.c.delete(a.key),this.k(a),this.f--,a.value}forEach(a,f){const n=this.g;let s=this.d;for(;s;){if(f?a.bind(f)(s.value,s.key,this):a(s.value,s.key,this),this.g!==n)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const a=this,f=this.g;let n=this.d;const s={[Symbol.iterator](){return s},next(){if(a.g!==f)throw new Error("LinkedMap got modified during iteration.");if(n){const w={value:n.key,done:!1};return n=n.next,w}else return{value:void 0,done:!0}}};return s}values(){const a=this,f=this.g;let n=this.d;const s={[Symbol.iterator](){return s},next(){if(a.g!==f)throw new Error("LinkedMap got modified during iteration.");if(n){const w={value:n.value,done:!1};return n=n.next,w}else return{value:void 0,done:!0}}};return s}entries(){const a=this,f=this.g;let n=this.d;const s={[Symbol.iterator](){return s},next(){if(a.g!==f)throw new Error("LinkedMap got modified during iteration.");if(n){const w={value:[n.key,n.value],done:!1};return n=n.next,w}else return{value:void 0,done:!0}}};return s}[(p=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(a){if(a>=this.size)return;if(a===0){this.clear();return}let f=this.d,n=this.size;for(;f&&n>a;)this.c.delete(f.key),f=f.next,n--;this.d=f,this.f=n,f&&(f.previous=void 0),this.g++}i(a){if(!this.d&&!this.e)this.e=a;else if(this.d)a.next=this.d,this.d.previous=a;else throw new Error("Invalid list");this.d=a,this.g++}j(a){if(!this.d&&!this.e)this.d=a;else if(this.e)a.previous=this.e,this.e.next=a;else throw new Error("Invalid list");this.e=a,this.g++}k(a){if(a===this.d&&a===this.e)this.d=void 0,this.e=void 0;else if(a===this.d){if(!a.next)throw new Error("Invalid list");a.next.previous=void 0,this.d=a.next}else if(a===this.e){if(!a.previous)throw new Error("Invalid list");a.previous.next=void 0,this.e=a.previous}else{const f=a.next,n=a.previous;if(!f||!n)throw new Error("Invalid list");f.previous=n,n.next=f}a.next=void 0,a.previous=void 0,this.g++}l(a,f){if(!this.d||!this.e)throw new Error("Invalid list");if(!(f!==1&&f!==2)){if(f===1){if(a===this.d)return;const n=a.next,s=a.previous;a===this.e?(s.next=void 0,this.e=s):(n.previous=s,s.next=n),a.previous=void 0,a.next=this.d,this.d.previous=a,this.d=a,this.g++}else if(f===2){if(a===this.e)return;const n=a.next,s=a.previous;a===this.d?(n.previous=void 0,this.d=n):(n.previous=s,s.next=n),a.next=void 0,a.previous=this.e,this.e.next=a,this.e=a,this.g++}}}toJSON(){const a=[];return this.forEach((f,n)=>{a.push([n,f])}),a}fromJSON(a){this.clear();for(const[f,n]of a)this.set(f,n)}}t.$Cc=m;class e extends m{constructor(a,f=1){super(),this.m=a,this.n=Math.min(Math.max(0,f),1)}get limit(){return this.m}set limit(a){this.m=a,this.o()}get ratio(){return this.n}set ratio(a){this.n=Math.min(Math.max(0,a),1),this.o()}get(a,f=2){return super.get(a,f)}peek(a){return super.get(a,0)}set(a,f){return super.set(a,f,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}t.$Dc=e;class L{constructor(){this.c=new Map}add(a){return this.c.set(a,(this.c.get(a)||0)+1),this}delete(a){let f=this.c.get(a)||0;return f===0?!1:(f--,f===0?this.c.delete(a):this.c.set(a,f),!0)}has(a){return this.c.has(a)}}t.$Ec=L;class j{constructor(a){if(this.c=new Map,this.d=new Map,a)for(const[f,n]of a)this.set(f,n)}clear(){this.c.clear(),this.d.clear()}set(a,f){this.c.set(a,f),this.d.set(f,a)}get(a){return this.c.get(a)}getKey(a){return this.d.get(a)}delete(a){const f=this.c.get(a);return f===void 0?!1:(this.c.delete(a),this.d.delete(f),!0)}forEach(a,f){this.c.forEach((n,s)=>{a.call(f,n,s,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}t.$Fc=j;class N{constructor(){this.c=new Map}add(a,f){let n=this.c.get(a);n||(n=new Set,this.c.set(a,n)),n.add(f)}delete(a,f){const n=this.c.get(a);n&&(n.delete(f),n.size===0&&this.c.delete(a))}forEach(a,f){const n=this.c.get(a);n&&n.forEach(f)}get(a){const f=this.c.get(a);return f||new Set}}t.$Gc=N;function $(d,a){if(d===a)return!0;if(d.size!==a.size)return!1;for(const[f,n]of d)if(!a.has(f)||a.get(f)!==n)return!1;for(const[f]of a)if(!d.has(f))return!1;return!0}t.$Hc=$}),te(ne[10],re([0,1,6,35,22,19,20]),function(C,t,i,P,p,h,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3c=t.$2c=t.$1c=t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Tc=t.$Sc=t.$Rc=t.$Qc=t.$Pc=t.$Oc=t.$Nc=t.$Mc=t.$Lc=t.$Kc=t.$Jc=t.$Ic=void 0;const c=!1;let l=null;class u{constructor(){this.b=new Map}static{this.a=0}c(D){let q=this.b.get(D);return q||(q={parent:null,source:null,isSingleton:!1,value:D,idx:u.a++},this.b.set(D,q)),q}trackDisposable(D){const q=this.c(D);q.source||(q.source=new Error().stack)}setParent(D,q){const W=this.c(D);W.parent=q}markAsDisposed(D){this.b.delete(D)}markAsSingleton(D){this.c(D).isSingleton=!0}f(D,q){const W=q.get(D);if(W)return W;const G=D.parent?this.f(this.c(D.parent),q):D;return q.set(D,G),G}getTrackedDisposables(){const D=new Map;return[...this.b.entries()].filter(([,W])=>W.source!==null&&!this.f(W,D).isSingleton).flatMap(([W])=>W)}computeLeakingDisposables(D=10,q){let W;if(q)W=q;else{const _=new Map,Q=[...this.b.values()].filter(ae=>ae.source!==null&&!this.f(ae,_).isSingleton);if(Q.length===0)return;const se=new Set(Q.map(ae=>ae.value));if(W=Q.filter(ae=>!(ae.parent&&se.has(ae.parent))),W.length===0)throw new Error("There are cyclic diposable chains!")}if(!W)return;function G(_){function Q(ae,r){for(;ae.length>0&&r.some(ge=>typeof ge=="string"?ge===ae[0]:ae[0].match(ge));)ae.shift()}const se=_.source.split(`
`).map(ae=>ae.trim().replace("at ","")).filter(ae=>ae!=="");return Q(se,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),se.reverse()}const ee=new p.$Gc;for(const _ of W){const Q=G(_);for(let se=0;se<=Q.length;se++)ee.add(Q.slice(0,se).join(`
`),_)}W.sort((0,i.$7b)(_=>_.idx,i.$9b));let T="",B=0;for(const _ of W.slice(0,D)){B++;const Q=G(_),se=[];for(let ae=0;ae<Q.length;ae++){let r=Q[ae];r=`(shared with ${ee.get(Q.slice(0,ae+1).join(`
`)).size}/${W.length} leaks) at ${r}`;const ve=ee.get(Q.slice(0,ae).join(`
`)),Ee=(0,P.$K)([...ve].map($e=>G($e)[ae]),$e=>$e);delete Ee[Q[ae]];for(const[$e,pe]of Object.entries(Ee))se.unshift(`    - stacktraces of ${pe.length} other leaks continue with ${$e}`);se.unshift(r)}T+=`


==================== Leaking disposable ${B}/${W.length}: ${_.value.constructor.name} ====================
${se.join(`
`)}
============================================================

`}return W.length>D&&(T+=`


... and ${W.length-D} more leaking disposables

`),{leaks:W,details:T}}}t.$Ic=u;function o(S){l=S}if(t.$Jc=o,c){const S="__is_disposable_tracked__";o(new class{trackDisposable(D){const q=new Error("Potentially leaked disposable").stack;setTimeout(()=>{D[S]||console.log(q)},3e3)}setParent(D,q){if(D&&D!==n.None)try{D[S]=!0}catch{}}markAsDisposed(D){if(D&&D!==n.None)try{D[S]=!0}catch{}}markAsSingleton(D){}})}function E(S){return l?.trackDisposable(S),S}t.$Kc=E;function b(S){l?.markAsDisposed(S)}t.$Lc=b;function m(S,D){l?.setParent(S,D)}function e(S,D){if(l)for(const q of S)l.setParent(q,D)}function L(S){return l?.markAsSingleton(S),S}t.$Mc=L;function j(S){return typeof S.dispose=="function"&&S.dispose.length===0}t.$Nc=j;function N(S){if(k.Iterable.is(S)){const D=[];for(const q of S)if(q)try{q.dispose()}catch(W){D.push(W)}if(D.length===1)throw D[0];if(D.length>1)throw new AggregateError(D,"Encountered errors while disposing of store");return Array.isArray(S)?[]:S}else if(S)return S.dispose(),S}t.$Oc=N;function $(S){for(const D of S)j(D)&&D.dispose();return[]}t.$Pc=$;function d(...S){const D=a(()=>N(S));return e(S,D),D}t.$Qc=d;function a(S){const D=E({dispose:(0,h.$db)(()=>{b(D),S()})});return D}t.$Rc=a;class f{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,E(this)}dispose(){this.g||(b(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{N(this.f)}finally{this.f.clear()}}add(D){if(!D)return D;if(D===this)throw new Error("Cannot register a disposable on itself!");return m(D,this),this.g?f.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(D),D}delete(D){if(D){if(D===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(D),D.dispose()}}deleteAndLeak(D){D&&this.f.has(D)&&(this.f.delete(D),m(D,null))}}t.$Sc=f;class n{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new f,E(this),m(this.q,this)}dispose(){b(this),this.q.dispose()}B(D){if(D===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(D)}}t.$Tc=n;class s{constructor(){this.b=!1,E(this)}get value(){return this.b?void 0:this.a}set value(D){this.b||D===this.a||(this.a?.dispose(),D&&m(D,this),this.a=D)}clear(){this.value=void 0}dispose(){this.b=!0,b(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const D=this.a;return this.a=void 0,D&&m(D,null),D}}t.$Uc=s;class w{constructor(D){this.a=new s,this.b=!1,this.a.value=D}get value(){return this.a.value}set value(D){this.b||D===this.a.value||(this.a.value=D)}dispose(){this.b=!0,this.a.dispose()}}t.$Vc=w;class g{constructor(D){this.b=D,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Wc=g;class v{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,E(this)}set(D){let q=D;return this.unset=()=>q=void 0,this.isset=()=>q!==void 0,this.dispose=()=>{q&&(q(),q=void 0,b(this))},this}}t.$Xc=v;class A{constructor(){this.a=new Map}acquire(D,...q){let W=this.a.get(D);W||(W={counter:0,object:this.b(D,...q)},this.a.set(D,W));const{object:G}=W,ee=(0,h.$db)(()=>{--W.counter===0&&(this.c(D,W.object),this.a.delete(D))});return W.counter++,{object:G,dispose:ee}}}t.$Yc=A;class R{constructor(D){this.a=D}async acquire(D,...q){const W=this.a.acquire(D,...q);try{return{object:await W.object,dispose:()=>W.dispose()}}catch(G){throw W.dispose(),G}}}t.$Zc=R;class y{constructor(D){this.object=D}dispose(){}}t.$1c=y;function F(S){const D=new f;try{S(D)}finally{D.dispose()}}t.$2c=F;class M{constructor(){this.a=new Map,this.b=!1,E(this)}dispose(){b(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{N(this.a.values())}finally{this.a.clear()}}has(D){return this.a.has(D)}get size(){return this.a.size}get(D){return this.a.get(D)}set(D,q,W=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),W||this.a.get(D)?.dispose(),this.a.set(D,q)}deleteAndDispose(D){this.a.get(D)?.dispose(),this.a.delete(D)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$3c=M}),te(ne[23],re([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1d=void 0;const i=globalThis.performance&&typeof globalThis.performance.now=="function";class P{static create(h){return new P(h)}constructor(h){this.c=i&&h===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$1d=P}),te(ne[11],re([0,1,3,19,10,21,23]),function(C,t,i,P,p,h,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$be=t.$ae=t.$_d=t.$$d=t.$0d=t.$9d=t.$8d=t.$7d=t.$6d=t.$5d=t.$4d=t.$3d=t.Event=void 0;const c=!1,l=!1;var u;(function(F){F.None=()=>p.$Tc.None;function M(H){if(l){const{onDidAddListener:J}=H,U=e.create();let K=0;H.onDidAddListener=()=>{++K===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),U.print()),J?.()}}}function S(H,J){return se(H,()=>{},0,void 0,!0,void 0,J)}F.defer=S;function D(H){return(J,U=null,K)=>{let ie=!1,le;return le=H(fe=>{if(!ie)return le?le.dispose():ie=!0,J.call(U,fe)},null,K),ie&&le.dispose(),le}}F.once=D;function q(H,J,U){return _((K,ie=null,le)=>H(fe=>K.call(ie,J(fe)),null,le),U)}F.map=q;function W(H,J,U){return _((K,ie=null,le)=>H(fe=>{J(fe),K.call(ie,fe)},null,le),U)}F.forEach=W;function G(H,J,U){return _((K,ie=null,le)=>H(fe=>J(fe)&&K.call(ie,fe),null,le),U)}F.filter=G;function ee(H){return H}F.signal=ee;function T(...H){return(J,U=null,K)=>{const ie=(0,p.$Qc)(...H.map(le=>le(fe=>J.call(U,fe))));return Q(ie,K)}}F.any=T;function B(H,J,U,K){let ie=U;return q(H,le=>(ie=J(ie,le),ie),K)}F.reduce=B;function _(H,J){let U;const K={onWillAddFirstListener(){U=H(ie.fire,ie)},onDidRemoveLastListener(){U?.dispose()}};J||M(K);const ie=new d(K);return J?.add(ie),ie.event}function Q(H,J){return J instanceof Array?J.push(H):J&&J.add(H),H}function se(H,J,U=100,K=!1,ie=!1,le,fe){let ce,de,Me,De=0,Pe;const qe={leakWarningThreshold:le,onWillAddFirstListener(){ce=H(we=>{De++,de=J(de,we),K&&!Me&&(Fe.fire(de),de=void 0),Pe=()=>{const Ve=de;de=void 0,Me=void 0,(!K||De>1)&&Fe.fire(Ve),De=0},typeof U=="number"?(clearTimeout(Me),Me=setTimeout(Pe,U)):Me===void 0&&(Me=0,queueMicrotask(Pe))})},onWillRemoveListener(){ie&&De>0&&Pe?.()},onDidRemoveLastListener(){Pe=void 0,ce.dispose()}};fe||M(qe);const Fe=new d(qe);return fe?.add(Fe),Fe.event}F.debounce=se;function ae(H,J=0,U){return F.debounce(H,(K,ie)=>K?(K.push(ie),K):[ie],J,void 0,!0,void 0,U)}F.accumulate=ae;function r(H,J=(K,ie)=>K===ie,U){let K=!0,ie;return G(H,le=>{const fe=K||!J(le,ie);return K=!1,ie=le,fe},U)}F.latch=r;function ge(H,J,U){return[F.filter(H,J,U),F.filter(H,K=>!J(K),U)]}F.split=ge;function ve(H,J=!1,U=[],K){let ie=U.slice(),le=H(de=>{ie?ie.push(de):ce.fire(de)});K&&K.add(le);const fe=()=>{ie?.forEach(de=>ce.fire(de)),ie=null},ce=new d({onWillAddFirstListener(){le||(le=H(de=>ce.fire(de)),K&&K.add(le))},onDidAddFirstListener(){ie&&(J?setTimeout(fe):fe())},onDidRemoveLastListener(){le&&le.dispose(),le=null}});return K&&K.add(ce),ce.event}F.buffer=ve;function Ee(H,J){return(K,ie,le)=>{const fe=J(new pe);return H(function(ce){const de=fe.evaluate(ce);de!==$e&&K.call(ie,de)},void 0,le)}}F.chain=Ee;const $e=Symbol("HaltChainable");class pe{constructor(){this.f=[]}map(J){return this.f.push(J),this}forEach(J){return this.f.push(U=>(J(U),U)),this}filter(J){return this.f.push(U=>J(U)?U:$e),this}reduce(J,U){let K=U;return this.f.push(ie=>(K=J(K,ie),K)),this}latch(J=(U,K)=>U===K){let U=!0,K;return this.f.push(ie=>{const le=U||!J(ie,K);return U=!1,K=ie,le?ie:$e}),this}evaluate(J){for(const U of this.f)if(J=U(J),J===$e)break;return J}}function ye(H,J,U=K=>K){const K=(...ce)=>fe.fire(U(...ce)),ie=()=>H.on(J,K),le=()=>H.removeListener(J,K),fe=new d({onWillAddFirstListener:ie,onDidRemoveLastListener:le});return fe.event}F.fromNodeEventEmitter=ye;function Se(H,J,U=K=>K){const K=(...ce)=>fe.fire(U(...ce)),ie=()=>H.addEventListener(J,K),le=()=>H.removeEventListener(J,K),fe=new d({onWillAddFirstListener:ie,onDidRemoveLastListener:le});return fe.event}F.fromDOMEventEmitter=Se;function Ie(H){return new Promise(J=>D(H)(J))}F.toPromise=Ie;function je(H){const J=new d;return H.then(U=>{J.fire(U)},()=>{J.fire(void 0)}).finally(()=>{J.dispose()}),J.event}F.fromPromise=je;function V(H,J,U){return J(U),H(K=>J(K))}F.runAndSubscribe=V;class z{constructor(J,U){this._observable=J,this.f=0,this.g=!1;const K={onWillAddFirstListener:()=>{J.addObserver(this)},onDidRemoveLastListener:()=>{J.removeObserver(this)}};U||M(K),this.emitter=new d(K),U&&U.add(this.emitter)}beginUpdate(J){this.f++}handlePossibleChange(J){}handleChange(J,U){this.g=!0}endUpdate(J){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function x(H,J){return new z(H,J).emitter.event}F.fromObservable=x;function Y(H){return(J,U,K)=>{let ie=0,le=!1;const fe={beginUpdate(){ie++},endUpdate(){ie--,ie===0&&(H.reportChanges(),le&&(le=!1,J.call(U)))},handlePossibleChange(){},handleChange(){le=!0}};H.addObserver(fe),H.reportChanges();const ce={dispose(){H.removeObserver(fe)}};return K instanceof p.$Sc?K.add(ce):Array.isArray(K)&&K.push(ce),ce}}F.fromObservableLight=Y})(u||(t.Event=u={}));class o{static{this.all=new Set}static{this.f=0}constructor(M){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${M}_${o.f++}`,o.all.add(this)}start(M){this.g=new k.$1d,this.listenerCount=M}stop(){if(this.g){const M=this.g.elapsed();this.durations.push(M),this.elapsedOverall+=M,this.invocationCount+=1,this.g=void 0}}}t.$3d=o;let E=-1;function b(F){const M=E;return E=F,{dispose(){E=M}}}t.$4d=b;class m{constructor(M,S=Math.random().toString(18).slice(2,5)){this.threshold=M,this.name=S,this.g=0}dispose(){this.f?.clear()}check(M,S){const D=this.threshold;if(D<=0||S<D)return;this.f||(this.f=new Map);const q=this.f.get(M.value)||0;if(this.f.set(M.value,q+1),this.g-=1,this.g<=0){this.g=D*.5;let W,G=0;for(const[ee,T]of this.f)(!W||G<T)&&(W=ee,G=T);console.warn(`[${this.name}] potential listener LEAK detected, having ${S} listeners already. MOST frequent listener (${G}):`),console.warn(W)}return()=>{const W=this.f.get(M.value)||0;this.f.set(M.value,W-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(M){this.value=M}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let L=0;class j{constructor(M){this.value=M,this.id=L++}}const N=2,$=(F,M)=>{if(F instanceof j)M(F);else for(let S=0;S<F.length;S++){const D=F[S];D&&M(D)}};class d{constructor(M){this.w=0,this.f=M,this.g=E>0||this.f?.leakWarningThreshold?new m(this.f?.leakWarningThreshold??E):void 0,this.j=this.f?._profName?new o(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(c){const M=this.t;queueMicrotask(()=>{$(M,S=>S.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(M,S,D)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),p.$Tc.None;if(this.m)return p.$Tc.None;S&&(M=M.bind(S));const q=new j(M);let W,G;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(q.stack=e.create(),W=this.g.check(q.stack,this.w+1)),c&&(q.stack=G??e.create()),this.t?this.t instanceof j?(this.u??=new f,this.t=[this.t,q]):this.t.push(q):(this.f?.onWillAddFirstListener?.(this),this.t=q,this.f?.onDidAddFirstListener?.(this)),this.w++;const ee=(0,p.$Rc)(()=>{W?.(),this.x(q)});return D instanceof p.$Sc?D.add(ee):Array.isArray(D)&&D.push(ee),ee},this.q}x(M){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const S=this.t,D=S.indexOf(M);if(D===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,S[D]=void 0;const q=this.u.current===this;if(this.w*N<=S.length){let W=0;for(let G=0;G<S.length;G++)S[G]?S[W++]=S[G]:q&&(this.u.end--,W<this.u.i&&this.u.i--);S.length=W}}y(M,S){if(!M)return;const D=this.f?.onListenerError||i.$1;if(!D){M.value(S);return}try{M.value(S)}catch(q){D(q)}}z(M){const S=M.current.t;for(;M.i<M.end;)this.y(S[M.i++],M.value);M.reset()}fire(M){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof j)this.y(this.t,M);else{const S=this.u;S.enqueue(this,M,this.t.length),this.z(S)}this.j?.stop()}hasListeners(){return this.w>0}}t.$5d=d;const a=()=>new f;t.$6d=a;class f{constructor(){this.i=-1,this.end=0}enqueue(M,S,D){this.i=0,this.end=D,this.current=M,this.value=S}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class n extends d{async fireAsync(M,S,D){if(this.t)for(this.h||(this.h=new h.$4c),$(this.t,q=>this.h.push([q.value,M]));this.h.size>0&&!S.isCancellationRequested;){const[q,W]=this.h.shift(),G=[],ee={...W,token:S,waitUntil:T=>{if(Object.isFrozen(G))throw new Error("waitUntil can NOT be called asynchronous");D&&(T=D(T,q)),G.push(T)}};try{q(ee)}catch(T){(0,i.$1)(T);continue}Object.freeze(G),await Promise.allSettled(G).then(T=>{for(const B of T)B.status==="rejected"&&(0,i.$1)(B.reason)})}}}t.$7d=n;class s extends d{get isPaused(){return this.h!==0}constructor(M){super(M),this.h=0,this.s=new h.$4c,this.A=M?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const M=Array.from(this.s);this.s.clear(),super.fire(this.A(M))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(M){this.w&&(this.h!==0?this.s.push(M):super.fire(M))}}t.$8d=s;class w extends s{constructor(M){super(M),this.k=M.delay??100}fire(M){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(M)}}t.$9d=w;class g extends d{constructor(M){super(M),this.h=[],this.k=M?.merge}fire(M){this.hasListeners()&&(this.h.push(M),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(S=>super.fire(S)),this.h=[]}))}}t.$0d=g;class v{constructor(){this.g=!1,this.h=[],this.f=new d({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(M){const S={event:M,listener:null};this.h.push(S),this.g&&this.m(S);const D=()=>{this.g&&this.o(S);const q=this.h.indexOf(S);this.h.splice(q,1)};return(0,p.$Rc)((0,P.$db)(D))}j(){this.g=!0,this.h.forEach(M=>this.m(M))}k(){this.g=!1,this.h.forEach(M=>this.o(M))}m(M){M.listener=M.event(S=>this.f.fire(S))}o(M){M.listener?.dispose(),M.listener=null}dispose(){this.f.dispose();for(const M of this.h)M.listener?.dispose();this.h=[]}}t.$$d=v;class A{constructor(M,S,D,q){this.f=new p.$Sc;const W=this.f.add(new v),G=this.f.add(new p.$3c);function ee(T){G.set(T,W.add(q(T)))}for(const T of M)ee(T);this.f.add(S(T=>{ee(T)})),this.f.add(D(T=>{G.deleteAndDispose(T)})),this.event=W.event}dispose(){this.f.dispose()}}t.$_d=A;class R{constructor(){this.f=[]}wrapEvent(M){return(S,D,q)=>M(W=>{const G=this.f[this.f.length-1];G?G.push(()=>S.call(D,W)):S.call(D,W)},void 0,q)}bufferEvents(M){const S=[];this.f.push(S);const D=M();return this.f.pop(),S.forEach(q=>q()),D}}t.$ae=R;class y{constructor(){this.f=!1,this.g=u.None,this.h=p.$Tc.None,this.j=new d({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(M){this.g=M,this.f&&(this.h.dispose(),this.h=M(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$be=y}),te(ne[24],re([0,1,11]),function(C,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ce=t.CancellationToken=void 0;const P=Object.freeze(function(c,l){const u=setTimeout(c.bind(l),0);return{dispose(){clearTimeout(u)}}});var p;(function(c){function l(u){return u===c.None||u===c.Cancelled||u instanceof h?!0:!u||typeof u!="object"?!1:typeof u.isCancellationRequested=="boolean"&&typeof u.onCancellationRequested=="function"}c.isCancellationToken=l,c.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:i.Event.None}),c.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:P})})(p||(t.CancellationToken=p={}));class h{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?P:(this.b||(this.b=new i.$5d),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class k{constructor(l){this.f=void 0,this.g=void 0,this.g=l&&l.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new h),this.f}cancel(){this.f?this.f instanceof h&&this.f.cancel():this.f=p.Cancelled}dispose(l=!1){l&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof h&&this.f.dispose():this.f=p.None}}t.$ce=k}),te(ne[40],re([0,1,24]),function(C,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pe=t.$Oe=t.$Ne=void 0;class P{constructor(c){this.b=c,this.a=null}get(){if(this.a)return this.a;const c=new i.$ce,l=this.b(c.token);return this.a={promise:l,dispose:()=>{this.a=null,c.cancel(),c.dispose()}},this.a}}t.$Ne=P;class p{constructor(c){this.c=c,this.a=void 0,this.b=void 0}get(c){const l=JSON.stringify(c);return this.b!==l&&(this.b=l,this.a=this.c(c)),this.a}}t.$Oe=p;class h{get cachedValues(){return this.a}constructor(c){this.b=c,this.a=new Map}get(c){if(this.a.has(c))return this.a.get(c);const l=this.b(c);return this.a.set(c,l),l}}t.$Pe=h}),te(ne[7],re([0,1,40,39]),function(C,t,i,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Rf=t.$Qf=t.$Pf=t.$Of=t.GraphemeBreakType=t.$Nf=t.$Mf=t.$Lf=t.$Kf=t.$Jf=t.$If=t.$Hf=t.$Gf=t.$Ff=t.$Ef=t.$Df=t.$Cf=t.$Bf=t.$Af=t.$zf=t.$yf=t.$xf=t.$wf=t.$vf=t.$uf=t.$tf=t.$sf=t.$rf=t.$qf=t.$pf=t.$of=t.$nf=t.$mf=t.$lf=t.$kf=t.$jf=t.$if=t.$hf=t.$gf=t.$ff=t.$ef=t.$df=t.$cf=t.$bf=t.$af=t.$_e=t.$$e=t.$0e=t.$9e=t.$8e=t.$7e=t.$6e=t.$5e=t.$4e=t.$3e=t.$2e=t.$1e=t.$Ze=t.$Ye=t.$Xe=t.$We=t.$Ve=t.$Ue=t.$Te=t.$Se=void 0;function p(I){return!I||typeof I!="string"?!0:I.trim().length===0}t.$Se=p;const h=/{(\d+)}/g;function k(I,...O){return O.length===0?I:I.replace(h,function(X,Z){const ue=parseInt(Z,10);return isNaN(ue)||ue<0||ue>=O.length?X:O[ue]})}t.$Te=k;const c=/{([^}]+)}/g;function l(I,O){return Object.keys(O).length===0?I:I.replace(c,(X,Z)=>O[Z]??X)}t.$Ue=l;function u(I){return I.replace(/[<>"'&]/g,O=>{switch(O){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return O})}t.$Ve=u;function o(I){return I.replace(/[<>&]/g,function(O){switch(O){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return O}})}t.$We=o;function E(I){return I.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.$Xe=E;function b(I,O){let X=0;const Z=O.charCodeAt(0);for(let ue=I.length-1;ue>=0;ue--)I.charCodeAt(ue)===Z&&X++;return X}t.$Ye=b;function m(I,O,X="\u2026"){return I.length<=O?I:`${I.substr(0,O)}${X}`}t.$Ze=m;function e(I,O,X="\u2026"){if(I.length<=O)return I;const Z=Math.ceil(O/2)-X.length/2,ue=Math.floor(O/2)-X.length/2;return`${I.substr(0,Z)}${X}${I.substr(I.length-ue)}`}t.$1e=e;function L(I,O=" "){const X=j(I,O);return N(X,O)}t.$2e=L;function j(I,O){if(!I||!O)return I;const X=O.length;if(X===0||I.length===0)return I;let Z=0;for(;I.indexOf(O,Z)===Z;)Z=Z+X;return I.substring(Z)}t.$3e=j;function N(I,O){if(!I||!O)return I;const X=O.length,Z=I.length;if(X===0||Z===0)return I;let ue=Z,he=-1;for(;he=I.lastIndexOf(O,ue-1),!(he===-1||he+X!==ue);){if(he===0)return"";ue=he}return I.substring(0,ue)}t.$4e=N;function $(I){return I.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.$5e=$;function d(I){return I.replace(/\*/g,"")}t.$6e=d;function a(I,O,X={}){if(!I)throw new Error("Cannot create regex from empty string");O||(I=E(I)),X.wholeWord&&(/\B/.test(I.charAt(0))||(I="\\b"+I),/\B/.test(I.charAt(I.length-1))||(I=I+"\\b"));let Z="";return X.global&&(Z+="g"),X.matchCase||(Z+="i"),X.multiline&&(Z+="m"),X.unicode&&(Z+="u"),new RegExp(I,Z)}t.$7e=a;function f(I){return I.source==="^"||I.source==="^$"||I.source==="$"||I.source==="^\\s*$"?!1:!!(I.exec("")&&I.lastIndex===0)}t.$8e=f;function n(I){return I.split(/\r\n|\r|\n/)}t.$9e=n;function s(I){const O=[],X=I.split(/(\r\n|\r|\n)/);for(let Z=0;Z<Math.ceil(X.length/2);Z++)O.push(X[2*Z]+(X[2*Z+1]??""));return O}t.$0e=s;function w(I){for(let O=0,X=I.length;O<X;O++){const Z=I.charCodeAt(O);if(Z!==32&&Z!==9)return O}return-1}t.$$e=w;function g(I,O=0,X=I.length){for(let Z=O;Z<X;Z++){const ue=I.charCodeAt(Z);if(ue!==32&&ue!==9)return I.substring(O,Z)}return I.substring(O,X)}t.$_e=g;function v(I,O=I.length-1){for(let X=O;X>=0;X--){const Z=I.charCodeAt(X);if(Z!==32&&Z!==9)return X}return-1}t.$af=v;function A(I,O,X){const Z=[];let ue=0;for(const he of I.matchAll(O)){if(Z.push(I.slice(ue,he.index)),he.index===void 0)throw new Error("match.index should be defined");ue=he.index+he[0].length,Z.push(X(he[0],...he.slice(1),he.index,I,he.groups))}return Z.push(I.slice(ue)),Promise.all(Z).then(he=>he.join(""))}t.$bf=A;function R(I,O){return I<O?-1:I>O?1:0}t.$cf=R;function y(I,O,X=0,Z=I.length,ue=0,he=O.length){for(;X<Z&&ue<he;X++,ue++){const ke=I.charCodeAt(X),Le=O.charCodeAt(ue);if(ke<Le)return-1;if(ke>Le)return 1}const me=Z-X,Ae=he-ue;return me<Ae?-1:me>Ae?1:0}t.$df=y;function F(I,O){return M(I,O,0,I.length,0,O.length)}t.$ef=F;function M(I,O,X=0,Z=I.length,ue=0,he=O.length){for(;X<Z&&ue<he;X++,ue++){let ke=I.charCodeAt(X),Le=O.charCodeAt(ue);if(ke===Le)continue;if(ke>=128||Le>=128)return y(I.toLowerCase(),O.toLowerCase(),X,Z,ue,he);D(ke)&&(ke-=32),D(Le)&&(Le-=32);const be=ke-Le;if(be!==0)return be}const me=Z-X,Ae=he-ue;return me<Ae?-1:me>Ae?1:0}t.$ff=M;function S(I){return I>=48&&I<=57}t.$gf=S;function D(I){return I>=97&&I<=122}t.$hf=D;function q(I){return I>=65&&I<=90}t.$if=q;function W(I,O){return I.length===O.length&&M(I,O)===0}t.$jf=W;function G(I,O){const X=O.length;return O.length>I.length?!1:M(I,O,0,X)===0}t.$kf=G;function ee(I,O){const X=Math.min(I.length,O.length);let Z;for(Z=0;Z<X;Z++)if(I.charCodeAt(Z)!==O.charCodeAt(Z))return Z;return X}t.$lf=ee;function T(I,O){const X=Math.min(I.length,O.length);let Z;const ue=I.length-1,he=O.length-1;for(Z=0;Z<X;Z++)if(I.charCodeAt(ue-Z)!==O.charCodeAt(he-Z))return Z;return X}t.$mf=T;function B(I){return 55296<=I&&I<=56319}t.$nf=B;function _(I){return 56320<=I&&I<=57343}t.$of=_;function Q(I,O){return(I-55296<<10)+(O-56320)+65536}t.$pf=Q;function se(I,O,X){const Z=I.charCodeAt(X);if(B(Z)&&X+1<O){const ue=I.charCodeAt(X+1);if(_(ue))return Q(Z,ue)}return Z}t.$qf=se;function ae(I,O){const X=I.charCodeAt(O-1);if(_(X)&&O>1){const Z=I.charCodeAt(O-2);if(B(Z))return Q(Z,X)}return X}class r{get offset(){return this.e}constructor(O,X=0){this.c=O,this.d=O.length,this.e=X}setOffset(O){this.e=O}prevCodePoint(){const O=ae(this.c,this.e);return this.e-=O>=65536?2:1,O}nextCodePoint(){const O=se(this.c,this.d,this.e);return this.e+=O>=65536?2:1,O}eol(){return this.e>=this.d}}t.$rf=r;class ge{get offset(){return this.c.offset}constructor(O,X=0){this.c=new r(O,X)}nextGraphemeLength(){const O=we.getInstance(),X=this.c,Z=X.offset;let ue=O.getGraphemeBreakType(X.nextCodePoint());for(;!X.eol();){const he=X.offset,me=O.getGraphemeBreakType(X.nextCodePoint());if(qe(ue,me)){X.setOffset(he);break}ue=me}return X.offset-Z}prevGraphemeLength(){const O=we.getInstance(),X=this.c,Z=X.offset;let ue=O.getGraphemeBreakType(X.prevCodePoint());for(;X.offset>0;){const he=X.offset,me=O.getGraphemeBreakType(X.prevCodePoint());if(qe(me,ue)){X.setOffset(he);break}ue=me}return Z-X.offset}eol(){return this.c.eol()}}t.$sf=ge;function ve(I,O){return new ge(I,O).nextGraphemeLength()}t.$tf=ve;function Ee(I,O){return new ge(I,O).prevGraphemeLength()}t.$uf=Ee;function $e(I,O){O>0&&_(I.charCodeAt(O))&&O--;const X=O+ve(I,O);return[X-Ee(I,X),X]}t.$vf=$e;function pe(I){const O=new ge(I);let X=0;for(;!O.eol();)X++,O.nextGraphemeLength();return X}t.$wf=pe;let ye;function Se(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Ie(I){return ye||(ye=Se()),ye.test(I)}t.$xf=Ie;const je=/^[\t\n\r\x20-\x7E]*$/;function V(I){return je.test(I)}t.$yf=V,t.$zf=/[\u2028\u2029]/;function z(I){return t.$zf.test(I)}t.$Af=z;function x(I){return I>=11904&&I<=55215||I>=63744&&I<=64255||I>=65281&&I<=65374}t.$Bf=x;function Y(I){return I>=127462&&I<=127487||I===8986||I===8987||I===9200||I===9203||I>=9728&&I<=10175||I===11088||I===11093||I>=127744&&I<=128591||I>=128640&&I<=128764||I>=128992&&I<=129008||I>=129280&&I<=129535||I>=129648&&I<=129782}t.$Cf=Y;function H(I,O,X=""){const Z=I.trimStart();if(Z.length<O)return Z;const ue=/\b/g;let he=0;for(;ue.test(Z)&&!(Z.length-ue.lastIndex<O);)he=ue.lastIndex,ue.lastIndex+=1;return he===0?Z:X+Z.substring(he).trimStart()}t.$Df=H;const J=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,U=/\x1b\].*?\x07/g;function K(I){return I&&(I=I.replace(J,"").replace(U,"")),I}t.$Ef=K,t.$Ff="\uFEFF";function ie(I){return!!(I&&I.length>0&&I.charCodeAt(0)===65279)}t.$Gf=ie;function le(I){return ie(I)?I.substr(1):I}t.$Hf=le;function fe(I,O){if(!I||!O||I.length<O.length)return!1;const X=O.length,Z=I.toLowerCase();let ue=0,he=-1;for(;ue<X;){const me=Z.indexOf(O[ue],he+1);if(me<0)return!1;he=me,ue++}return!0}t.$If=fe;function ce(I,O=!1){return I?(O&&(I=I.replace(/\\./g,"")),I.toLowerCase()!==I):!1}t.$Jf=ce;function de(I){return I.charAt(0).toUpperCase()+I.slice(1)}t.$Kf=de;function Me(I,O=1){if(O===0)return"";let X=-1;do X=I.indexOf(`
`,X+1),O--;while(O>0&&X>=0);return X===-1?I:(I[X-1]==="\r"&&X--,I.substr(0,X))}t.$Lf=Me;function De(I){return I=I%(2*26),I<26?String.fromCharCode(97+I):String.fromCharCode(65+I-26)}t.$Mf=De;function Pe(I){return we.getInstance().getGraphemeBreakType(I)}t.$Nf=Pe;function qe(I,O){return I===0?O!==5&&O!==7:I===2&&O===3?!1:I===4||I===2||I===3||O===4||O===2||O===3?!0:!(I===8&&(O===8||O===9||O===11||O===12)||(I===11||I===9)&&(O===9||O===10)||(I===12||I===10)&&O===10||O===5||O===13||O===7||I===1||I===13&&O===14||I===6&&O===6)}var Fe;(function(I){I[I.Other=0]="Other",I[I.Prepend=1]="Prepend",I[I.CR=2]="CR",I[I.LF=3]="LF",I[I.Control=4]="Control",I[I.Extend=5]="Extend",I[I.Regional_Indicator=6]="Regional_Indicator",I[I.SpacingMark=7]="SpacingMark",I[I.L=8]="L",I[I.V=9]="V",I[I.T=10]="T",I[I.LV=11]="LV",I[I.LVT=12]="LVT",I[I.ZWJ=13]="ZWJ",I[I.Extended_Pictographic=14]="Extended_Pictographic"})(Fe||(t.GraphemeBreakType=Fe={}));class we{static{this.c=null}static getInstance(){return we.c||(we.c=new we),we.c}constructor(){this.d=Ve()}getGraphemeBreakType(O){if(O<32)return O===10?3:O===13?2:4;if(O<127)return 0;const X=this.d,Z=X.length/3;let ue=1;for(;ue<=Z;)if(O<X[3*ue])ue=2*ue;else if(O>X[3*ue+1])ue=2*ue+1;else return X[3*ue+2];return 0}}function Ve(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(I,O){if(I===0)return 0;const X=Ge(I,O);if(X!==void 0)return X;const Z=new r(O,I);return Z.prevCodePoint(),Z.offset}t.$Of=He;function Ge(I,O){const X=new r(O,I);let Z=X.prevCodePoint();for(;Xe(Z)||Z===65039||Z===8419;){if(X.offset===0)return;Z=X.prevCodePoint()}if(!Y(Z))return;let ue=X.offset;return ue>0&&X.prevCodePoint()===8205&&(ue=X.offset),ue}function Xe(I){return 127995<=I&&I<=127999}var Ce;(function(I){I[I.zwj=8205]="zwj",I[I.emojiVariantSelector=65039]="emojiVariantSelector",I[I.enclosingKeyCap=8419]="enclosingKeyCap"})(Ce||(Ce={})),t.$Pf="\xA0";class Te{static{this.c=new P.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new i.$Oe(O=>{function X(be){const Re=new Map;for(let Ne=0;Ne<be.length;Ne+=2)Re.set(be[Ne],be[Ne+1]);return Re}function Z(be,Re){const Ne=new Map(be);for(const[Oe,We]of Re)Ne.set(Oe,We);return Ne}function ue(be,Re){if(!be)return Re;const Ne=new Map;for(const[Oe,We]of be)Re.has(Oe)&&Ne.set(Oe,We);return Ne}const he=this.c.value;let me=O.filter(be=>!be.startsWith("_")&&be in he);me.length===0&&(me=["_default"]);let Ae;for(const be of me){const Re=X(he[be]);Ae=ue(Ae,Re)}const ke=X(he._common),Le=Z(ke,Ae);return new Te(Le)})}static getInstance(O){return Te.d.get(Array.from(O))}static{this.e=new P.$V(()=>Object.keys(Te.c.value).filter(O=>!O.startsWith("_")))}static getLocales(){return Te.e.value}constructor(O){this.f=O}isAmbiguous(O){return this.f.has(O)}getPrimaryConfusable(O){return this.f.get(O)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$Qf=Te;class Be{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Be.c())),this.d}static isInvisibleCharacter(O){return Be.e().has(O)}static get codePoints(){return Be.e()}}t.$Rf=Be}),te(ne[41],re([0,1,7]),function(C,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_i=t.$$i=t.$0i=t.$9i=t.$8i=t.$7i=t.$6i=void 0;function P(N){return p(N,0)}t.$6i=P;function p(N,$){switch(typeof N){case"object":return N===null?h(349,$):Array.isArray(N)?l(N,$):u(N,$);case"string":return c(N,$);case"boolean":return k(N,$);case"number":return h(N,$);case"undefined":return h(937,$);default:return h(617,$)}}t.$7i=p;function h(N,$){return($<<5)-$+N|0}t.$8i=h;function k(N,$){return h(N?433:863,$)}function c(N,$){$=h(149417,$);for(let d=0,a=N.length;d<a;d++)$=h(N.charCodeAt(d),$);return $}t.$9i=c;function l(N,$){return $=h(104579,$),N.reduce((d,a)=>p(a,d),$)}function u(N,$){return $=h(181387,$),Object.keys(N).sort().reduce((d,a)=>(d=c(a,d),p(N[a],d)),$)}class o{constructor(){this.g=0}get value(){return this.g}hash($){return this.g=p($,this.g),this.g}}t.$0i=o;var E;(function(N){N[N.BLOCK_SIZE=64]="BLOCK_SIZE",N[N.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function b(N,$,d=32){const a=d-$,f=~((1<<a)-1);return(N<<$|(f&N)>>>a)>>>0}function m(N,$=0,d=N.byteLength,a=0){for(let f=0;f<d;f++)N[$+f]=a}function e(N,$,d="0"){for(;N.length<$;)N=d+N;return N}function L(N,$=32){return N instanceof ArrayBuffer?Array.from(new Uint8Array(N)).map(d=>d.toString(16).padStart(2,"0")).join(""):e((N>>>0).toString(16),$/4)}t.$$i=L;class j{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update($){const d=$.length;if(d===0)return;const a=this.p;let f=this.r,n=this.u,s,w;for(n!==0?(s=n,w=-1,n=0):(s=$.charCodeAt(0),w=0);;){let g=s;if(i.$nf(s))if(w+1<d){const v=$.charCodeAt(w+1);i.$of(v)?(w++,g=i.$pf(s,v)):g=65533}else{n=s;break}else i.$of(s)&&(g=65533);if(f=this.w(a,f,g),w++,w<d)s=$.charCodeAt(w);else break}this.r=f,this.u=n}w($,d,a){return a<128?$[d++]=a:a<2048?($[d++]=192|(a&1984)>>>6,$[d++]=128|(a&63)>>>0):a<65536?($[d++]=224|(a&61440)>>>12,$[d++]=128|(a&4032)>>>6,$[d++]=128|(a&63)>>>0):($[d++]=240|(a&1835008)>>>18,$[d++]=128|(a&258048)>>>12,$[d++]=128|(a&4032)>>>6,$[d++]=128|(a&63)>>>0),d>=64&&(this.y(),d-=64,this.t+=64,$[0]=$[64],$[1]=$[65],$[2]=$[66]),d}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),L(this.h)+L(this.l)+L(this.m)+L(this.n)+L(this.o)}x(){this.p[this.r++]=128,m(this.p,this.r),this.r>56&&(this.y(),m(this.p));const $=8*this.t;this.q.setUint32(56,Math.floor($/4294967296),!1),this.q.setUint32(60,$%4294967296,!1),this.y()}y(){const $=j.g,d=this.q;for(let R=0;R<64;R+=4)$.setUint32(R,d.getUint32(R,!1),!1);for(let R=64;R<320;R+=4)$.setUint32(R,b($.getUint32(R-12,!1)^$.getUint32(R-32,!1)^$.getUint32(R-56,!1)^$.getUint32(R-64,!1),1),!1);let a=this.h,f=this.l,n=this.m,s=this.n,w=this.o,g,v,A;for(let R=0;R<80;R++)R<20?(g=f&n|~f&s,v=1518500249):R<40?(g=f^n^s,v=1859775393):R<60?(g=f&n|f&s|n&s,v=2400959708):(g=f^n^s,v=3395469782),A=b(a,5)+g+w+v+$.getUint32(R*4,!1)&4294967295,w=s,s=n,n=b(f,30),f=a,a=A;this.h=this.h+a&4294967295,this.l=this.l+f&4294967295,this.m=this.m+n&4294967295,this.n=this.n+s&4294967295,this.o=this.o+w&4294967295}}t.$_i=j}),te(ne[25],re([0,1,37,41]),function(C,t,i,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ct=t.$bt=t.$at=void 0;class p{constructor(b){this.a=b}getElements(){const b=this.a,m=new Int32Array(b.length);for(let e=0,L=b.length;e<L;e++)m[e]=b.charCodeAt(e);return m}}t.$at=p;function h(E,b,m){return new o(new p(E),new p(b)).ComputeDiff(m).changes}t.$bt=h;class k{static Assert(b,m){if(!b)throw new Error(m)}}class c{static Copy(b,m,e,L,j){for(let N=0;N<j;N++)e[L+N]=b[m+N]}static Copy2(b,m,e,L,j){for(let N=0;N<j;N++)e[L+N]=b[m+N]}}var l;(function(E){E[E.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(l||(l={}));class u{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new i.$_s(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(b,m){this.b=Math.min(this.b,b),this.c=Math.min(this.c,m),this.d++}AddModifiedElement(b,m){this.b=Math.min(this.b,b),this.c=Math.min(this.c,m),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class o{constructor(b,m,e=null){this.a=e,this.b=b,this.c=m;const[L,j,N]=o.o(b),[$,d,a]=o.o(m);this.d=N&&a,this.e=L,this.f=j,this.g=$,this.h=d,this.k=[],this.m=[]}static n(b){return b.length>0&&typeof b[0]=="string"}static o(b){const m=b.getElements();if(o.n(m)){const e=new Int32Array(m.length);for(let L=0,j=m.length;L<j;L++)e[L]=(0,P.$9i)(m[L],0);return[m,e,!0]}return m instanceof Int32Array?[[],m,!1]:[[],new Int32Array(m),!1]}p(b,m){return this.f[b]!==this.h[m]?!1:this.d?this.e[b]===this.g[m]:!0}q(b,m){if(!this.p(b,m))return!1;const e=o.r(this.b,b),L=o.r(this.c,m);return e===L}static r(b,m){return typeof b.getStrictElement=="function"?b.getStrictElement(m):null}s(b,m){return this.f[b]!==this.f[m]?!1:this.d?this.e[b]===this.e[m]:!0}u(b,m){return this.h[b]!==this.h[m]?!1:this.d?this.g[b]===this.g[m]:!0}ComputeDiff(b){return this.v(0,this.f.length-1,0,this.h.length-1,b)}v(b,m,e,L,j){const N=[!1];let $=this.w(b,m,e,L,N);return j&&($=this.z($)),{quitEarly:N[0],changes:$}}w(b,m,e,L,j){for(j[0]=!1;b<=m&&e<=L&&this.p(b,e);)b++,e++;for(;m>=b&&L>=e&&this.p(m,L);)m--,L--;if(b>m||e>L){let n;return e<=L?(k.Assert(b===m+1,"originalStart should only be one more than originalEnd"),n=[new i.$_s(b,0,e,L-e+1)]):b<=m?(k.Assert(e===L+1,"modifiedStart should only be one more than modifiedEnd"),n=[new i.$_s(b,m-b+1,e,0)]):(k.Assert(b===m+1,"originalStart should only be one more than originalEnd"),k.Assert(e===L+1,"modifiedStart should only be one more than modifiedEnd"),n=[]),n}const N=[0],$=[0],d=this.y(b,m,e,L,N,$,j),a=N[0],f=$[0];if(d!==null)return d;if(!j[0]){const n=this.w(b,a,e,f,j);let s=[];return j[0]?s=[new i.$_s(a+1,m-(a+1)+1,f+1,L-(f+1)+1)]:s=this.w(a+1,m,f+1,L,j),this.H(n,s)}return[new i.$_s(b,m-b+1,e,L-e+1)]}x(b,m,e,L,j,N,$,d,a,f,n,s,w,g,v,A,R,y){let F=null,M=null,S=new u,D=m,q=e,W=w[0]-A[0]-L,G=-1073741824,ee=this.k.length-1;do{const T=W+b;T===D||T<q&&a[T-1]<a[T+1]?(n=a[T+1],g=n-W-L,n<G&&S.MarkNextChange(),G=n,S.AddModifiedElement(n+1,g),W=T+1-b):(n=a[T-1]+1,g=n-W-L,n<G&&S.MarkNextChange(),G=n-1,S.AddOriginalElement(n,g+1),W=T-1-b),ee>=0&&(a=this.k[ee],b=a[0],D=1,q=a.length-1)}while(--ee>=-1);if(F=S.getReverseChanges(),y[0]){let T=w[0]+1,B=A[0]+1;if(F!==null&&F.length>0){const _=F[F.length-1];T=Math.max(T,_.getOriginalEnd()),B=Math.max(B,_.getModifiedEnd())}M=[new i.$_s(T,s-T+1,B,v-B+1)]}else{S=new u,D=N,q=$,W=w[0]-A[0]-d,G=1073741824,ee=R?this.m.length-1:this.m.length-2;do{const T=W+j;T===D||T<q&&f[T-1]>=f[T+1]?(n=f[T+1]-1,g=n-W-d,n>G&&S.MarkNextChange(),G=n+1,S.AddOriginalElement(n+1,g+1),W=T+1-j):(n=f[T-1],g=n-W-d,n>G&&S.MarkNextChange(),G=n,S.AddModifiedElement(n+1,g+1),W=T-1-j),ee>=0&&(f=this.m[ee],j=f[0],D=1,q=f.length-1)}while(--ee>=-1);M=S.getChanges()}return this.H(F,M)}y(b,m,e,L,j,N,$){let d=0,a=0,f=0,n=0,s=0,w=0;b--,e--,j[0]=0,N[0]=0,this.k=[],this.m=[];const g=m-b+(L-e),v=g+1,A=new Int32Array(v),R=new Int32Array(v),y=L-e,F=m-b,M=b-e,S=m-L,q=(F-y)%2===0;A[y]=b,R[F]=m,$[0]=!1;for(let W=1;W<=g/2+1;W++){let G=0,ee=0;f=this.J(y-W,W,y,v),n=this.J(y+W,W,y,v);for(let B=f;B<=n;B+=2){B===f||B<n&&A[B-1]<A[B+1]?d=A[B+1]:d=A[B-1]+1,a=d-(B-y)-M;const _=d;for(;d<m&&a<L&&this.p(d+1,a+1);)d++,a++;if(A[B]=d,d+a>G+ee&&(G=d,ee=a),!q&&Math.abs(B-F)<=W-1&&d>=R[B])return j[0]=d,N[0]=a,_<=R[B]&&1447>0&&W<=1448?this.x(y,f,n,M,F,s,w,S,A,R,d,m,j,a,L,N,q,$):null}const T=(G-b+(ee-e)-W)/2;if(this.a!==null&&!this.a(G,T))return $[0]=!0,j[0]=G,N[0]=ee,T>0&&1447>0&&W<=1448?this.x(y,f,n,M,F,s,w,S,A,R,d,m,j,a,L,N,q,$):(b++,e++,[new i.$_s(b,m-b+1,e,L-e+1)]);s=this.J(F-W,W,F,v),w=this.J(F+W,W,F,v);for(let B=s;B<=w;B+=2){B===s||B<w&&R[B-1]>=R[B+1]?d=R[B+1]-1:d=R[B-1],a=d-(B-F)-S;const _=d;for(;d>b&&a>e&&this.p(d,a);)d--,a--;if(R[B]=d,q&&Math.abs(B-y)<=W&&d<=A[B])return j[0]=d,N[0]=a,_>=A[B]&&1447>0&&W<=1448?this.x(y,f,n,M,F,s,w,S,A,R,d,m,j,a,L,N,q,$):null}if(W<=1447){let B=new Int32Array(n-f+2);B[0]=y-f+1,c.Copy2(A,f,B,1,n-f+1),this.k.push(B),B=new Int32Array(w-s+2),B[0]=F-s+1,c.Copy2(R,s,B,1,w-s+1),this.m.push(B)}}return this.x(y,f,n,M,F,s,w,S,A,R,d,m,j,a,L,N,q,$)}z(b){for(let m=0;m<b.length;m++){const e=b[m],L=m<b.length-1?b[m+1].originalStart:this.f.length,j=m<b.length-1?b[m+1].modifiedStart:this.h.length,N=e.originalLength>0,$=e.modifiedLength>0;for(;e.originalStart+e.originalLength<L&&e.modifiedStart+e.modifiedLength<j&&(!N||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!$||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const a=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!a)break;e.originalStart++,e.modifiedStart++}const d=[null];if(m<b.length-1&&this.I(b[m],b[m+1],d)){b[m]=d[0],b.splice(m+1,1),m--;continue}}for(let m=b.length-1;m>=0;m--){const e=b[m];let L=0,j=0;if(m>0){const n=b[m-1];L=n.originalStart+n.originalLength,j=n.modifiedStart+n.modifiedLength}const N=e.originalLength>0,$=e.modifiedLength>0;let d=0,a=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let n=1;;n++){const s=e.originalStart-n,w=e.modifiedStart-n;if(s<L||w<j||N&&!this.s(s,s+e.originalLength)||$&&!this.u(w,w+e.modifiedLength))break;const v=(s===L&&w===j?5:0)+this.G(s,e.originalLength,w,e.modifiedLength);v>a&&(a=v,d=n)}e.originalStart-=d,e.modifiedStart-=d;const f=[null];if(m>0&&this.I(b[m-1],b[m],f)){b[m-1]=f[0],b.splice(m,1),m++;continue}}if(this.d)for(let m=1,e=b.length;m<e;m++){const L=b[m-1],j=b[m],N=j.originalStart-L.originalStart-L.originalLength,$=L.originalStart,d=j.originalStart+j.originalLength,a=d-$,f=L.modifiedStart,n=j.modifiedStart+j.modifiedLength,s=n-f;if(N<5&&a<20&&s<20){const w=this.A($,a,f,s,N);if(w){const[g,v]=w;(g!==L.originalStart+L.originalLength||v!==L.modifiedStart+L.modifiedLength)&&(L.originalLength=g-L.originalStart,L.modifiedLength=v-L.modifiedStart,j.originalStart=g+N,j.modifiedStart=v+N,j.originalLength=d-j.originalStart,j.modifiedLength=n-j.modifiedStart)}}}return b}A(b,m,e,L,j){if(m<j||L<j)return null;const N=b+m-j+1,$=e+L-j+1;let d=0,a=0,f=0;for(let n=b;n<N;n++)for(let s=e;s<$;s++){const w=this.B(n,s,j);w>0&&w>d&&(d=w,a=n,f=s)}return d>0?[a,f]:null}B(b,m,e){let L=0;for(let j=0;j<e;j++){if(!this.p(b+j,m+j))return 0;L+=this.e[b+j].length}return L}C(b){return b<=0||b>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[b])}D(b,m){if(this.C(b)||this.C(b-1))return!0;if(m>0){const e=b+m;if(this.C(e-1)||this.C(e))return!0}return!1}E(b){return b<=0||b>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[b])}F(b,m){if(this.E(b)||this.E(b-1))return!0;if(m>0){const e=b+m;if(this.E(e-1)||this.E(e))return!0}return!1}G(b,m,e,L){const j=this.D(b,m)?1:0,N=this.F(e,L)?1:0;return j+N}H(b,m){const e=[];if(b.length===0||m.length===0)return m.length>0?m:b;if(this.I(b[b.length-1],m[0],e)){const L=new Array(b.length+m.length-1);return c.Copy(b,0,L,0,b.length-1),L[b.length-1]=e[0],c.Copy(m,1,L,b.length,m.length-1),L}else{const L=new Array(b.length+m.length);return c.Copy(b,0,L,0,b.length),c.Copy(m,0,L,b.length,m.length),L}}I(b,m,e){if(k.Assert(b.originalStart<=m.originalStart,"Left change is not less than or equal to right change"),k.Assert(b.modifiedStart<=m.modifiedStart,"Left change is not less than or equal to right change"),b.originalStart+b.originalLength>=m.originalStart||b.modifiedStart+b.modifiedLength>=m.modifiedStart){const L=b.originalStart;let j=b.originalLength;const N=b.modifiedStart;let $=b.modifiedLength;return b.originalStart+b.originalLength>=m.originalStart&&(j=m.originalStart+m.originalLength-b.originalStart),b.modifiedStart+b.modifiedLength>=m.modifiedStart&&($=m.modifiedStart+m.modifiedLength-b.modifiedStart),e[0]=new i.$_s(L,j,N,$),!0}else return e[0]=null,!1}J(b,m,e,L){if(b>=0&&b<L)return b;const j=e,N=L-e-1,$=m%2===0;if(b<0){const d=j%2===0;return $===d?0:1}else{const d=N%2===0;return $===d?L-1:L-2}}}t.$ct=o}),te(ne[26],re([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0f=t.$9f=t.$8f=t.$7f=t.$6f=t.$5f=t.$4f=t.$3f=t.$2f=t.$1f=t.$Zf=t.$Yf=t.$Xf=t.$Wf=t.$Vf=t.$Uf=t.$Tf=t.$Sf=void 0;function i(f){return typeof f=="string"}t.$Sf=i;function P(f){return Array.isArray(f)&&f.every(n=>i(n))}t.$Tf=P;function p(f){return typeof f=="object"&&f!==null&&!Array.isArray(f)&&!(f instanceof RegExp)&&!(f instanceof Date)}t.$Uf=p;function h(f){const n=Object.getPrototypeOf(Uint8Array);return typeof f=="object"&&f instanceof n}t.$Vf=h;function k(f){return typeof f=="number"&&!isNaN(f)}t.$Wf=k;function c(f){return!!f&&typeof f[Symbol.iterator]=="function"}t.$Xf=c;function l(f){return f===!0||f===!1}t.$Yf=l;function u(f){return typeof f>"u"}t.$Zf=u;function o(f){return!E(f)}t.$1f=o;function E(f){return u(f)||f===null}t.$2f=E;function b(f,n){if(!f)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}t.$3f=b;function m(f){if(E(f))throw new Error("Assertion Failed: argument is undefined or null");return f}t.$4f=m;function e(...f){const n=[];for(let s=0;s<f.length;s++){const w=f[s];if(E(w))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);n.push(w)}return n}t.$5f=e;const L=Object.prototype.hasOwnProperty;function j(f){if(!p(f))return!1;for(const n in f)if(L.call(f,n))return!1;return!0}t.$6f=j;function N(f){return typeof f=="function"}t.$7f=N;function $(...f){return f.length>0&&f.every(N)}t.$8f=$;function d(f,n){const s=Math.min(f.length,n.length);for(let w=0;w<s;w++)a(f[w],n[w])}t.$9f=d;function a(f,n){if(i(n)){if(typeof f!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(N(n)){try{if(f instanceof n)return}catch{}if(!E(f)&&f.constructor===n||n.length===1&&n.call(void 0,f)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.$0f=a}),te(ne[27],re([0,1,26]),function(C,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kk=t.$jk=void 0;const P=Object.create(null);function p(k,c){if((0,i.$Sf)(c)){const l=P[c];if(l===void 0)throw new Error(`${k} references an unknown codicon: ${c}`);c=l}return P[k]=c,{id:k}}t.$jk=p;function h(){return P}t.$kk=h}),te(ne[42],re([0,1,27]),function(C,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lk=void 0,t.$lk={add:(0,i.$jk)("add",6e4),plus:(0,i.$jk)("plus",6e4),gistNew:(0,i.$jk)("gist-new",6e4),repoCreate:(0,i.$jk)("repo-create",6e4),lightbulb:(0,i.$jk)("lightbulb",60001),lightBulb:(0,i.$jk)("light-bulb",60001),repo:(0,i.$jk)("repo",60002),repoDelete:(0,i.$jk)("repo-delete",60002),gistFork:(0,i.$jk)("gist-fork",60003),repoForked:(0,i.$jk)("repo-forked",60003),gitPullRequest:(0,i.$jk)("git-pull-request",60004),gitPullRequestAbandoned:(0,i.$jk)("git-pull-request-abandoned",60004),recordKeys:(0,i.$jk)("record-keys",60005),keyboard:(0,i.$jk)("keyboard",60005),tag:(0,i.$jk)("tag",60006),tagAdd:(0,i.$jk)("tag-add",60006),tagRemove:(0,i.$jk)("tag-remove",60006),gitPullRequestLabel:(0,i.$jk)("git-pull-request-label",60006),person:(0,i.$jk)("person",60007),personFollow:(0,i.$jk)("person-follow",60007),personOutline:(0,i.$jk)("person-outline",60007),personFilled:(0,i.$jk)("person-filled",60007),gitBranch:(0,i.$jk)("git-branch",60008),gitBranchCreate:(0,i.$jk)("git-branch-create",60008),gitBranchDelete:(0,i.$jk)("git-branch-delete",60008),sourceControl:(0,i.$jk)("source-control",60008),mirror:(0,i.$jk)("mirror",60009),mirrorPublic:(0,i.$jk)("mirror-public",60009),star:(0,i.$jk)("star",60010),starAdd:(0,i.$jk)("star-add",60010),starDelete:(0,i.$jk)("star-delete",60010),starEmpty:(0,i.$jk)("star-empty",60010),comment:(0,i.$jk)("comment",60011),commentAdd:(0,i.$jk)("comment-add",60011),alert:(0,i.$jk)("alert",60012),warning:(0,i.$jk)("warning",60012),search:(0,i.$jk)("search",60013),searchSave:(0,i.$jk)("search-save",60013),logOut:(0,i.$jk)("log-out",60014),signOut:(0,i.$jk)("sign-out",60014),logIn:(0,i.$jk)("log-in",60015),signIn:(0,i.$jk)("sign-in",60015),eye:(0,i.$jk)("eye",60016),eyeUnwatch:(0,i.$jk)("eye-unwatch",60016),eyeWatch:(0,i.$jk)("eye-watch",60016),circleFilled:(0,i.$jk)("circle-filled",60017),primitiveDot:(0,i.$jk)("primitive-dot",60017),closeDirty:(0,i.$jk)("close-dirty",60017),debugBreakpoint:(0,i.$jk)("debug-breakpoint",60017),debugBreakpointDisabled:(0,i.$jk)("debug-breakpoint-disabled",60017),debugBreakpointPending:(0,i.$jk)("debug-breakpoint-pending",60377),debugHint:(0,i.$jk)("debug-hint",60017),primitiveSquare:(0,i.$jk)("primitive-square",60018),edit:(0,i.$jk)("edit",60019),pencil:(0,i.$jk)("pencil",60019),info:(0,i.$jk)("info",60020),issueOpened:(0,i.$jk)("issue-opened",60020),gistPrivate:(0,i.$jk)("gist-private",60021),gitForkPrivate:(0,i.$jk)("git-fork-private",60021),lock:(0,i.$jk)("lock",60021),mirrorPrivate:(0,i.$jk)("mirror-private",60021),close:(0,i.$jk)("close",60022),removeClose:(0,i.$jk)("remove-close",60022),x:(0,i.$jk)("x",60022),repoSync:(0,i.$jk)("repo-sync",60023),sync:(0,i.$jk)("sync",60023),clone:(0,i.$jk)("clone",60024),desktopDownload:(0,i.$jk)("desktop-download",60024),beaker:(0,i.$jk)("beaker",60025),microscope:(0,i.$jk)("microscope",60025),vm:(0,i.$jk)("vm",60026),deviceDesktop:(0,i.$jk)("device-desktop",60026),file:(0,i.$jk)("file",60027),fileText:(0,i.$jk)("file-text",60027),more:(0,i.$jk)("more",60028),ellipsis:(0,i.$jk)("ellipsis",60028),kebabHorizontal:(0,i.$jk)("kebab-horizontal",60028),mailReply:(0,i.$jk)("mail-reply",60029),reply:(0,i.$jk)("reply",60029),organization:(0,i.$jk)("organization",60030),organizationFilled:(0,i.$jk)("organization-filled",60030),organizationOutline:(0,i.$jk)("organization-outline",60030),newFile:(0,i.$jk)("new-file",60031),fileAdd:(0,i.$jk)("file-add",60031),newFolder:(0,i.$jk)("new-folder",60032),fileDirectoryCreate:(0,i.$jk)("file-directory-create",60032),trash:(0,i.$jk)("trash",60033),trashcan:(0,i.$jk)("trashcan",60033),history:(0,i.$jk)("history",60034),clock:(0,i.$jk)("clock",60034),folder:(0,i.$jk)("folder",60035),fileDirectory:(0,i.$jk)("file-directory",60035),symbolFolder:(0,i.$jk)("symbol-folder",60035),logoGithub:(0,i.$jk)("logo-github",60036),markGithub:(0,i.$jk)("mark-github",60036),github:(0,i.$jk)("github",60036),terminal:(0,i.$jk)("terminal",60037),console:(0,i.$jk)("console",60037),repl:(0,i.$jk)("repl",60037),zap:(0,i.$jk)("zap",60038),symbolEvent:(0,i.$jk)("symbol-event",60038),error:(0,i.$jk)("error",60039),stop:(0,i.$jk)("stop",60039),variable:(0,i.$jk)("variable",60040),symbolVariable:(0,i.$jk)("symbol-variable",60040),array:(0,i.$jk)("array",60042),symbolArray:(0,i.$jk)("symbol-array",60042),symbolModule:(0,i.$jk)("symbol-module",60043),symbolPackage:(0,i.$jk)("symbol-package",60043),symbolNamespace:(0,i.$jk)("symbol-namespace",60043),symbolObject:(0,i.$jk)("symbol-object",60043),symbolMethod:(0,i.$jk)("symbol-method",60044),symbolFunction:(0,i.$jk)("symbol-function",60044),symbolConstructor:(0,i.$jk)("symbol-constructor",60044),symbolBoolean:(0,i.$jk)("symbol-boolean",60047),symbolNull:(0,i.$jk)("symbol-null",60047),symbolNumeric:(0,i.$jk)("symbol-numeric",60048),symbolNumber:(0,i.$jk)("symbol-number",60048),symbolStructure:(0,i.$jk)("symbol-structure",60049),symbolStruct:(0,i.$jk)("symbol-struct",60049),symbolParameter:(0,i.$jk)("symbol-parameter",60050),symbolTypeParameter:(0,i.$jk)("symbol-type-parameter",60050),symbolKey:(0,i.$jk)("symbol-key",60051),symbolText:(0,i.$jk)("symbol-text",60051),symbolReference:(0,i.$jk)("symbol-reference",60052),goToFile:(0,i.$jk)("go-to-file",60052),symbolEnum:(0,i.$jk)("symbol-enum",60053),symbolValue:(0,i.$jk)("symbol-value",60053),symbolRuler:(0,i.$jk)("symbol-ruler",60054),symbolUnit:(0,i.$jk)("symbol-unit",60054),activateBreakpoints:(0,i.$jk)("activate-breakpoints",60055),archive:(0,i.$jk)("archive",60056),arrowBoth:(0,i.$jk)("arrow-both",60057),arrowDown:(0,i.$jk)("arrow-down",60058),arrowLeft:(0,i.$jk)("arrow-left",60059),arrowRight:(0,i.$jk)("arrow-right",60060),arrowSmallDown:(0,i.$jk)("arrow-small-down",60061),arrowSmallLeft:(0,i.$jk)("arrow-small-left",60062),arrowSmallRight:(0,i.$jk)("arrow-small-right",60063),arrowSmallUp:(0,i.$jk)("arrow-small-up",60064),arrowUp:(0,i.$jk)("arrow-up",60065),bell:(0,i.$jk)("bell",60066),bold:(0,i.$jk)("bold",60067),book:(0,i.$jk)("book",60068),bookmark:(0,i.$jk)("bookmark",60069),debugBreakpointConditionalUnverified:(0,i.$jk)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,i.$jk)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,i.$jk)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,i.$jk)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,i.$jk)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,i.$jk)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,i.$jk)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,i.$jk)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,i.$jk)("debug-breakpoint-log-disabled",60075),briefcase:(0,i.$jk)("briefcase",60076),broadcast:(0,i.$jk)("broadcast",60077),browser:(0,i.$jk)("browser",60078),bug:(0,i.$jk)("bug",60079),calendar:(0,i.$jk)("calendar",60080),caseSensitive:(0,i.$jk)("case-sensitive",60081),check:(0,i.$jk)("check",60082),checklist:(0,i.$jk)("checklist",60083),chevronDown:(0,i.$jk)("chevron-down",60084),dropDownButton:(0,i.$jk)("drop-down-button",60084),chevronLeft:(0,i.$jk)("chevron-left",60085),chevronRight:(0,i.$jk)("chevron-right",60086),chevronUp:(0,i.$jk)("chevron-up",60087),chromeClose:(0,i.$jk)("chrome-close",60088),chromeMaximize:(0,i.$jk)("chrome-maximize",60089),chromeMinimize:(0,i.$jk)("chrome-minimize",60090),chromeRestore:(0,i.$jk)("chrome-restore",60091),circle:(0,i.$jk)("circle",60092),circleOutline:(0,i.$jk)("circle-outline",60092),debugBreakpointUnverified:(0,i.$jk)("debug-breakpoint-unverified",60092),circleSlash:(0,i.$jk)("circle-slash",60093),circuitBoard:(0,i.$jk)("circuit-board",60094),clearAll:(0,i.$jk)("clear-all",60095),clippy:(0,i.$jk)("clippy",60096),closeAll:(0,i.$jk)("close-all",60097),cloudDownload:(0,i.$jk)("cloud-download",60098),cloudUpload:(0,i.$jk)("cloud-upload",60099),code:(0,i.$jk)("code",60100),collapseAll:(0,i.$jk)("collapse-all",60101),colorMode:(0,i.$jk)("color-mode",60102),commentDiscussion:(0,i.$jk)("comment-discussion",60103),compareChanges:(0,i.$jk)("compare-changes",60157),creditCard:(0,i.$jk)("credit-card",60105),dash:(0,i.$jk)("dash",60108),dashboard:(0,i.$jk)("dashboard",60109),database:(0,i.$jk)("database",60110),debugContinue:(0,i.$jk)("debug-continue",60111),debugDisconnect:(0,i.$jk)("debug-disconnect",60112),debugPause:(0,i.$jk)("debug-pause",60113),debugRestart:(0,i.$jk)("debug-restart",60114),debugStart:(0,i.$jk)("debug-start",60115),debugStepInto:(0,i.$jk)("debug-step-into",60116),debugStepOut:(0,i.$jk)("debug-step-out",60117),debugStepOver:(0,i.$jk)("debug-step-over",60118),debugStop:(0,i.$jk)("debug-stop",60119),debug:(0,i.$jk)("debug",60120),deviceCameraVideo:(0,i.$jk)("device-camera-video",60121),deviceCamera:(0,i.$jk)("device-camera",60122),deviceMobile:(0,i.$jk)("device-mobile",60123),diffAdded:(0,i.$jk)("diff-added",60124),diffIgnored:(0,i.$jk)("diff-ignored",60125),diffModified:(0,i.$jk)("diff-modified",60126),diffRemoved:(0,i.$jk)("diff-removed",60127),diffRenamed:(0,i.$jk)("diff-renamed",60128),diff:(0,i.$jk)("diff",60129),discard:(0,i.$jk)("discard",60130),editorLayout:(0,i.$jk)("editor-layout",60131),emptyWindow:(0,i.$jk)("empty-window",60132),exclude:(0,i.$jk)("exclude",60133),extensions:(0,i.$jk)("extensions",60134),eyeClosed:(0,i.$jk)("eye-closed",60135),fileBinary:(0,i.$jk)("file-binary",60136),fileCode:(0,i.$jk)("file-code",60137),fileMedia:(0,i.$jk)("file-media",60138),filePdf:(0,i.$jk)("file-pdf",60139),fileSubmodule:(0,i.$jk)("file-submodule",60140),fileSymlinkDirectory:(0,i.$jk)("file-symlink-directory",60141),fileSymlinkFile:(0,i.$jk)("file-symlink-file",60142),fileZip:(0,i.$jk)("file-zip",60143),files:(0,i.$jk)("files",60144),filter:(0,i.$jk)("filter",60145),flame:(0,i.$jk)("flame",60146),foldDown:(0,i.$jk)("fold-down",60147),foldUp:(0,i.$jk)("fold-up",60148),fold:(0,i.$jk)("fold",60149),folderActive:(0,i.$jk)("folder-active",60150),folderOpened:(0,i.$jk)("folder-opened",60151),gear:(0,i.$jk)("gear",60152),gift:(0,i.$jk)("gift",60153),gistSecret:(0,i.$jk)("gist-secret",60154),gist:(0,i.$jk)("gist",60155),gitCommit:(0,i.$jk)("git-commit",60156),gitCompare:(0,i.$jk)("git-compare",60157),gitMerge:(0,i.$jk)("git-merge",60158),githubAction:(0,i.$jk)("github-action",60159),githubAlt:(0,i.$jk)("github-alt",60160),globe:(0,i.$jk)("globe",60161),grabber:(0,i.$jk)("grabber",60162),graph:(0,i.$jk)("graph",60163),gripper:(0,i.$jk)("gripper",60164),heart:(0,i.$jk)("heart",60165),home:(0,i.$jk)("home",60166),horizontalRule:(0,i.$jk)("horizontal-rule",60167),hubot:(0,i.$jk)("hubot",60168),inbox:(0,i.$jk)("inbox",60169),issueClosed:(0,i.$jk)("issue-closed",60324),issueReopened:(0,i.$jk)("issue-reopened",60171),issues:(0,i.$jk)("issues",60172),italic:(0,i.$jk)("italic",60173),jersey:(0,i.$jk)("jersey",60174),json:(0,i.$jk)("json",60175),bracket:(0,i.$jk)("bracket",60175),kebabVertical:(0,i.$jk)("kebab-vertical",60176),key:(0,i.$jk)("key",60177),law:(0,i.$jk)("law",60178),lightbulbAutofix:(0,i.$jk)("lightbulb-autofix",60179),linkExternal:(0,i.$jk)("link-external",60180),link:(0,i.$jk)("link",60181),listOrdered:(0,i.$jk)("list-ordered",60182),listUnordered:(0,i.$jk)("list-unordered",60183),liveShare:(0,i.$jk)("live-share",60184),loading:(0,i.$jk)("loading",60185),location:(0,i.$jk)("location",60186),mailRead:(0,i.$jk)("mail-read",60187),mail:(0,i.$jk)("mail",60188),markdown:(0,i.$jk)("markdown",60189),megaphone:(0,i.$jk)("megaphone",60190),mention:(0,i.$jk)("mention",60191),milestone:(0,i.$jk)("milestone",60192),gitPullRequestMilestone:(0,i.$jk)("git-pull-request-milestone",60192),mortarBoard:(0,i.$jk)("mortar-board",60193),move:(0,i.$jk)("move",60194),multipleWindows:(0,i.$jk)("multiple-windows",60195),mute:(0,i.$jk)("mute",60196),noNewline:(0,i.$jk)("no-newline",60197),note:(0,i.$jk)("note",60198),octoface:(0,i.$jk)("octoface",60199),openPreview:(0,i.$jk)("open-preview",60200),package:(0,i.$jk)("package",60201),paintcan:(0,i.$jk)("paintcan",60202),pin:(0,i.$jk)("pin",60203),play:(0,i.$jk)("play",60204),run:(0,i.$jk)("run",60204),plug:(0,i.$jk)("plug",60205),preserveCase:(0,i.$jk)("preserve-case",60206),preview:(0,i.$jk)("preview",60207),project:(0,i.$jk)("project",60208),pulse:(0,i.$jk)("pulse",60209),question:(0,i.$jk)("question",60210),quote:(0,i.$jk)("quote",60211),radioTower:(0,i.$jk)("radio-tower",60212),reactions:(0,i.$jk)("reactions",60213),references:(0,i.$jk)("references",60214),refresh:(0,i.$jk)("refresh",60215),regex:(0,i.$jk)("regex",60216),remoteExplorer:(0,i.$jk)("remote-explorer",60217),remote:(0,i.$jk)("remote",60218),remove:(0,i.$jk)("remove",60219),replaceAll:(0,i.$jk)("replace-all",60220),replace:(0,i.$jk)("replace",60221),repoClone:(0,i.$jk)("repo-clone",60222),repoForcePush:(0,i.$jk)("repo-force-push",60223),repoPull:(0,i.$jk)("repo-pull",60224),repoPush:(0,i.$jk)("repo-push",60225),report:(0,i.$jk)("report",60226),requestChanges:(0,i.$jk)("request-changes",60227),rocket:(0,i.$jk)("rocket",60228),rootFolderOpened:(0,i.$jk)("root-folder-opened",60229),rootFolder:(0,i.$jk)("root-folder",60230),rss:(0,i.$jk)("rss",60231),ruby:(0,i.$jk)("ruby",60232),saveAll:(0,i.$jk)("save-all",60233),saveAs:(0,i.$jk)("save-as",60234),save:(0,i.$jk)("save",60235),screenFull:(0,i.$jk)("screen-full",60236),screenNormal:(0,i.$jk)("screen-normal",60237),searchStop:(0,i.$jk)("search-stop",60238),server:(0,i.$jk)("server",60240),settingsGear:(0,i.$jk)("settings-gear",60241),settings:(0,i.$jk)("settings",60242),shield:(0,i.$jk)("shield",60243),smiley:(0,i.$jk)("smiley",60244),sortPrecedence:(0,i.$jk)("sort-precedence",60245),splitHorizontal:(0,i.$jk)("split-horizontal",60246),splitVertical:(0,i.$jk)("split-vertical",60247),squirrel:(0,i.$jk)("squirrel",60248),starFull:(0,i.$jk)("star-full",60249),starHalf:(0,i.$jk)("star-half",60250),symbolClass:(0,i.$jk)("symbol-class",60251),symbolColor:(0,i.$jk)("symbol-color",60252),symbolCustomColor:(0,i.$jk)("symbol-customcolor",60252),symbolConstant:(0,i.$jk)("symbol-constant",60253),symbolEnumMember:(0,i.$jk)("symbol-enum-member",60254),symbolField:(0,i.$jk)("symbol-field",60255),symbolFile:(0,i.$jk)("symbol-file",60256),symbolInterface:(0,i.$jk)("symbol-interface",60257),symbolKeyword:(0,i.$jk)("symbol-keyword",60258),symbolMisc:(0,i.$jk)("symbol-misc",60259),symbolOperator:(0,i.$jk)("symbol-operator",60260),symbolProperty:(0,i.$jk)("symbol-property",60261),wrench:(0,i.$jk)("wrench",60261),wrenchSubaction:(0,i.$jk)("wrench-subaction",60261),symbolSnippet:(0,i.$jk)("symbol-snippet",60262),tasklist:(0,i.$jk)("tasklist",60263),telescope:(0,i.$jk)("telescope",60264),textSize:(0,i.$jk)("text-size",60265),threeBars:(0,i.$jk)("three-bars",60266),thumbsdown:(0,i.$jk)("thumbsdown",60267),thumbsup:(0,i.$jk)("thumbsup",60268),tools:(0,i.$jk)("tools",60269),triangleDown:(0,i.$jk)("triangle-down",60270),triangleLeft:(0,i.$jk)("triangle-left",60271),triangleRight:(0,i.$jk)("triangle-right",60272),triangleUp:(0,i.$jk)("triangle-up",60273),twitter:(0,i.$jk)("twitter",60274),unfold:(0,i.$jk)("unfold",60275),unlock:(0,i.$jk)("unlock",60276),unmute:(0,i.$jk)("unmute",60277),unverified:(0,i.$jk)("unverified",60278),verified:(0,i.$jk)("verified",60279),versions:(0,i.$jk)("versions",60280),vmActive:(0,i.$jk)("vm-active",60281),vmOutline:(0,i.$jk)("vm-outline",60282),vmRunning:(0,i.$jk)("vm-running",60283),watch:(0,i.$jk)("watch",60284),whitespace:(0,i.$jk)("whitespace",60285),wholeWord:(0,i.$jk)("whole-word",60286),window:(0,i.$jk)("window",60287),wordWrap:(0,i.$jk)("word-wrap",60288),zoomIn:(0,i.$jk)("zoom-in",60289),zoomOut:(0,i.$jk)("zoom-out",60290),listFilter:(0,i.$jk)("list-filter",60291),listFlat:(0,i.$jk)("list-flat",60292),listSelection:(0,i.$jk)("list-selection",60293),selection:(0,i.$jk)("selection",60293),listTree:(0,i.$jk)("list-tree",60294),debugBreakpointFunctionUnverified:(0,i.$jk)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,i.$jk)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,i.$jk)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,i.$jk)("debug-stackframe-active",60297),circleSmallFilled:(0,i.$jk)("circle-small-filled",60298),debugStackframeDot:(0,i.$jk)("debug-stackframe-dot",60298),debugStackframe:(0,i.$jk)("debug-stackframe",60299),debugStackframeFocused:(0,i.$jk)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,i.$jk)("debug-breakpoint-unsupported",60300),symbolString:(0,i.$jk)("symbol-string",60301),debugReverseContinue:(0,i.$jk)("debug-reverse-continue",60302),debugStepBack:(0,i.$jk)("debug-step-back",60303),debugRestartFrame:(0,i.$jk)("debug-restart-frame",60304),callIncoming:(0,i.$jk)("call-incoming",60306),callOutgoing:(0,i.$jk)("call-outgoing",60307),menu:(0,i.$jk)("menu",60308),expandAll:(0,i.$jk)("expand-all",60309),feedback:(0,i.$jk)("feedback",60310),gitPullRequestReviewer:(0,i.$jk)("git-pull-request-reviewer",60310),groupByRefType:(0,i.$jk)("group-by-ref-type",60311),ungroupByRefType:(0,i.$jk)("ungroup-by-ref-type",60312),account:(0,i.$jk)("account",60313),gitPullRequestAssignee:(0,i.$jk)("git-pull-request-assignee",60313),bellDot:(0,i.$jk)("bell-dot",60314),debugConsole:(0,i.$jk)("debug-console",60315),library:(0,i.$jk)("library",60316),output:(0,i.$jk)("output",60317),runAll:(0,i.$jk)("run-all",60318),syncIgnored:(0,i.$jk)("sync-ignored",60319),pinned:(0,i.$jk)("pinned",60320),githubInverted:(0,i.$jk)("github-inverted",60321),debugAlt:(0,i.$jk)("debug-alt",60305),serverProcess:(0,i.$jk)("server-process",60322),serverEnvironment:(0,i.$jk)("server-environment",60323),pass:(0,i.$jk)("pass",60324),stopCircle:(0,i.$jk)("stop-circle",60325),playCircle:(0,i.$jk)("play-circle",60326),record:(0,i.$jk)("record",60327),debugAltSmall:(0,i.$jk)("debug-alt-small",60328),vmConnect:(0,i.$jk)("vm-connect",60329),cloud:(0,i.$jk)("cloud",60330),merge:(0,i.$jk)("merge",60331),exportIcon:(0,i.$jk)("export",60332),graphLeft:(0,i.$jk)("graph-left",60333),magnet:(0,i.$jk)("magnet",60334),notebook:(0,i.$jk)("notebook",60335),redo:(0,i.$jk)("redo",60336),checkAll:(0,i.$jk)("check-all",60337),pinnedDirty:(0,i.$jk)("pinned-dirty",60338),passFilled:(0,i.$jk)("pass-filled",60339),circleLargeFilled:(0,i.$jk)("circle-large-filled",60340),circleLarge:(0,i.$jk)("circle-large",60341),circleLargeOutline:(0,i.$jk)("circle-large-outline",60341),combine:(0,i.$jk)("combine",60342),gather:(0,i.$jk)("gather",60342),table:(0,i.$jk)("table",60343),variableGroup:(0,i.$jk)("variable-group",60344),typeHierarchy:(0,i.$jk)("type-hierarchy",60345),typeHierarchySub:(0,i.$jk)("type-hierarchy-sub",60346),typeHierarchySuper:(0,i.$jk)("type-hierarchy-super",60347),gitPullRequestCreate:(0,i.$jk)("git-pull-request-create",60348),runAbove:(0,i.$jk)("run-above",60349),runBelow:(0,i.$jk)("run-below",60350),notebookTemplate:(0,i.$jk)("notebook-template",60351),debugRerun:(0,i.$jk)("debug-rerun",60352),workspaceTrusted:(0,i.$jk)("workspace-trusted",60353),workspaceUntrusted:(0,i.$jk)("workspace-untrusted",60354),workspaceUnspecified:(0,i.$jk)("workspace-unspecified",60355),terminalCmd:(0,i.$jk)("terminal-cmd",60356),terminalDebian:(0,i.$jk)("terminal-debian",60357),terminalLinux:(0,i.$jk)("terminal-linux",60358),terminalPowershell:(0,i.$jk)("terminal-powershell",60359),terminalTmux:(0,i.$jk)("terminal-tmux",60360),terminalUbuntu:(0,i.$jk)("terminal-ubuntu",60361),terminalBash:(0,i.$jk)("terminal-bash",60362),arrowSwap:(0,i.$jk)("arrow-swap",60363),copy:(0,i.$jk)("copy",60364),personAdd:(0,i.$jk)("person-add",60365),filterFilled:(0,i.$jk)("filter-filled",60366),wand:(0,i.$jk)("wand",60367),debugLineByLine:(0,i.$jk)("debug-line-by-line",60368),inspect:(0,i.$jk)("inspect",60369),layers:(0,i.$jk)("layers",60370),layersDot:(0,i.$jk)("layers-dot",60371),layersActive:(0,i.$jk)("layers-active",60372),compass:(0,i.$jk)("compass",60373),compassDot:(0,i.$jk)("compass-dot",60374),compassActive:(0,i.$jk)("compass-active",60375),azure:(0,i.$jk)("azure",60376),issueDraft:(0,i.$jk)("issue-draft",60377),gitPullRequestClosed:(0,i.$jk)("git-pull-request-closed",60378),gitPullRequestDraft:(0,i.$jk)("git-pull-request-draft",60379),debugAll:(0,i.$jk)("debug-all",60380),debugCoverage:(0,i.$jk)("debug-coverage",60381),runErrors:(0,i.$jk)("run-errors",60382),folderLibrary:(0,i.$jk)("folder-library",60383),debugContinueSmall:(0,i.$jk)("debug-continue-small",60384),beakerStop:(0,i.$jk)("beaker-stop",60385),graphLine:(0,i.$jk)("graph-line",60386),graphScatter:(0,i.$jk)("graph-scatter",60387),pieChart:(0,i.$jk)("pie-chart",60388),bracketDot:(0,i.$jk)("bracket-dot",60389),bracketError:(0,i.$jk)("bracket-error",60390),lockSmall:(0,i.$jk)("lock-small",60391),azureDevops:(0,i.$jk)("azure-devops",60392),verifiedFilled:(0,i.$jk)("verified-filled",60393),newLine:(0,i.$jk)("newline",60394),layout:(0,i.$jk)("layout",60395),layoutActivitybarLeft:(0,i.$jk)("layout-activitybar-left",60396),layoutActivitybarRight:(0,i.$jk)("layout-activitybar-right",60397),layoutPanelLeft:(0,i.$jk)("layout-panel-left",60398),layoutPanelCenter:(0,i.$jk)("layout-panel-center",60399),layoutPanelJustify:(0,i.$jk)("layout-panel-justify",60400),layoutPanelRight:(0,i.$jk)("layout-panel-right",60401),layoutPanel:(0,i.$jk)("layout-panel",60402),layoutSidebarLeft:(0,i.$jk)("layout-sidebar-left",60403),layoutSidebarRight:(0,i.$jk)("layout-sidebar-right",60404),layoutStatusbar:(0,i.$jk)("layout-statusbar",60405),layoutMenubar:(0,i.$jk)("layout-menubar",60406),layoutCentered:(0,i.$jk)("layout-centered",60407),layoutSidebarRightOff:(0,i.$jk)("layout-sidebar-right-off",60416),layoutPanelOff:(0,i.$jk)("layout-panel-off",60417),layoutSidebarLeftOff:(0,i.$jk)("layout-sidebar-left-off",60418),target:(0,i.$jk)("target",60408),indent:(0,i.$jk)("indent",60409),recordSmall:(0,i.$jk)("record-small",60410),errorSmall:(0,i.$jk)("error-small",60411),arrowCircleDown:(0,i.$jk)("arrow-circle-down",60412),arrowCircleLeft:(0,i.$jk)("arrow-circle-left",60413),arrowCircleRight:(0,i.$jk)("arrow-circle-right",60414),arrowCircleUp:(0,i.$jk)("arrow-circle-up",60415),heartFilled:(0,i.$jk)("heart-filled",60420),map:(0,i.$jk)("map",60421),mapFilled:(0,i.$jk)("map-filled",60422),circleSmall:(0,i.$jk)("circle-small",60423),bellSlash:(0,i.$jk)("bell-slash",60424),bellSlashDot:(0,i.$jk)("bell-slash-dot",60425),commentUnresolved:(0,i.$jk)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,i.$jk)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,i.$jk)("git-pull-request-new-changes",60428),searchFuzzy:(0,i.$jk)("search-fuzzy",60429),commentDraft:(0,i.$jk)("comment-draft",60430),send:(0,i.$jk)("send",60431),sparkle:(0,i.$jk)("sparkle",60432),insert:(0,i.$jk)("insert",60433),mic:(0,i.$jk)("mic",60434),thumbsDownFilled:(0,i.$jk)("thumbsdown-filled",60435),thumbsUpFilled:(0,i.$jk)("thumbsup-filled",60436),coffee:(0,i.$jk)("coffee",60437),snake:(0,i.$jk)("snake",60438),game:(0,i.$jk)("game",60439),vr:(0,i.$jk)("vr",60440),chip:(0,i.$jk)("chip",60441),piano:(0,i.$jk)("piano",60442),music:(0,i.$jk)("music",60443),micFilled:(0,i.$jk)("mic-filled",60444),gitFetch:(0,i.$jk)("git-fetch",60445),copilot:(0,i.$jk)("copilot",60446),lightbulbSparkle:(0,i.$jk)("lightbulb-sparkle",60447),lightbulbSparkleAutofix:(0,i.$jk)("lightbulb-sparkle-autofix",60447),robot:(0,i.$jk)("robot",60448),sparkleFilled:(0,i.$jk)("sparkle-filled",60449),diffSingle:(0,i.$jk)("diff-single",60450),diffMultiple:(0,i.$jk)("diff-multiple",60451),surroundWith:(0,i.$jk)("surround-with",60452),gitStash:(0,i.$jk)("git-stash",60454),gitStashApply:(0,i.$jk)("git-stash-apply",60455),gitStashPop:(0,i.$jk)("git-stash-pop",60456),runAllCoverage:(0,i.$jk)("run-all-coverage",60461),runCoverage:(0,i.$jk)("run-all-coverage",60460),coverage:(0,i.$jk)("coverage",60462),githubProject:(0,i.$jk)("github-project",60463)}}),te(ne[43],re([0,1,27,42]),function(C,t,i,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ok=t.$nk=t.$mk=void 0;function p(){return Object.values(t.$ok)}t.$mk=p,t.$nk={dialogError:(0,i.$jk)("dialog-error","error"),dialogWarning:(0,i.$jk)("dialog-warning","warning"),dialogInfo:(0,i.$jk)("dialog-info","info"),dialogClose:(0,i.$jk)("dialog-close","close"),treeItemExpanded:(0,i.$jk)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,i.$jk)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,i.$jk)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,i.$jk)("tree-filter-clear","close"),treeItemLoading:(0,i.$jk)("tree-item-loading","loading"),menuSelection:(0,i.$jk)("menu-selection","check"),menuSubmenu:(0,i.$jk)("menu-submenu","chevron-right"),menuBarMore:(0,i.$jk)("menubar-more","more"),scrollbarButtonLeft:(0,i.$jk)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,i.$jk)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,i.$jk)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,i.$jk)("scrollbar-button-down","triangle-down"),toolBarMore:(0,i.$jk)("toolbar-more","more"),quickInputBack:(0,i.$jk)("quick-input-back","arrow-left")},t.$ok={...P.$lk,...t.$nk}}),te(ne[14],re([0,1,26]),function(C,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Vn=t.$Un=t.$Tn=t.$Sn=t.$Rn=t.$Qn=t.$Pn=t.$On=t.$Nn=t.$Mn=t.$Ln=t.$Kn=void 0;function P(N){if(!N||typeof N!="object"||N instanceof RegExp)return N;const $=Array.isArray(N)?[]:{};return Object.entries(N).forEach(([d,a])=>{$[d]=a&&typeof a=="object"?P(a):a}),$}t.$Kn=P;function p(N){if(!N||typeof N!="object")return N;const $=[N];for(;$.length>0;){const d=$.shift();Object.freeze(d);for(const a in d)if(h.call(d,a)){const f=d[a];typeof f=="object"&&!Object.isFrozen(f)&&!(0,i.$Vf)(f)&&$.push(f)}}return N}t.$Ln=p;const h=Object.prototype.hasOwnProperty;function k(N,$){return c(N,$,new Set)}t.$Mn=k;function c(N,$,d){if((0,i.$2f)(N))return N;const a=$(N);if(typeof a<"u")return a;if(Array.isArray(N)){const f=[];for(const n of N)f.push(c(n,$,d));return f}if((0,i.$Uf)(N)){if(d.has(N))throw new Error("Cannot clone recursive data-structure");d.add(N);const f={};for(const n in N)h.call(N,n)&&(f[n]=c(N[n],$,d));return d.delete(N),f}return N}function l(N,$,d=!0){return(0,i.$Uf)(N)?((0,i.$Uf)($)&&Object.keys($).forEach(a=>{a in N?d&&((0,i.$Uf)(N[a])&&(0,i.$Uf)($[a])?l(N[a],$[a],d):N[a]=$[a]):N[a]=$[a]}),N):$}t.$Nn=l;function u(N,$){if(N===$)return!0;if(N==null||$===null||$===void 0||typeof N!=typeof $||typeof N!="object"||Array.isArray(N)!==Array.isArray($))return!1;let d,a;if(Array.isArray(N)){if(N.length!==$.length)return!1;for(d=0;d<N.length;d++)if(!u(N[d],$[d]))return!1}else{const f=[];for(a in N)f.push(a);f.sort();const n=[];for(a in $)n.push(a);if(n.sort(),!u(f,n))return!1;for(d=0;d<f.length;d++)if(!u(N[f[d]],$[f[d]]))return!1}return!0}t.$On=u;function o(N){const $=new Set;return JSON.stringify(N,(d,a)=>{if((0,i.$Uf)(a)||Array.isArray(a)){if($.has(a))return"[Circular]";$.add(a)}return a})}t.$Pn=o;function E(N,$){const d=Object.create(null);return!N||!$||Object.keys($).forEach(f=>{const n=N[f],s=$[f];u(n,s)||(d[f]=s)}),d}t.$Qn=E;function b(N,$){const d=$.toLowerCase(),a=Object.keys(N).find(f=>f.toLowerCase()===d);return a?N[a]:N[$]}t.$Rn=b;function m(N,$){const d=Object.create(null);for(const[a,f]of Object.entries(N))$(a,f)&&(d[a]=f);return d}t.$Sn=m;function e(N){let $=[];for(;Object.prototype!==N;)$=$.concat(Object.getOwnPropertyNames(N)),N=Object.getPrototypeOf(N);return $}t.$Tn=e;function L(N){const $=[];for(const d of e(N))typeof N[d]=="function"&&$.push(d);return $}t.$Un=L;function j(N,$){const d=f=>function(){const n=Array.prototype.slice.call(arguments,0);return $(f,n)},a={};for(const f of N)a[f]=d(f);return a}t.$Vn=j}),te(ne[28],re([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Re=t.$Qe=t.Constants=void 0;var i;(function(h){h[h.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",h[h.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",h[h.MAX_UINT_8=255]="MAX_UINT_8",h[h.MAX_UINT_16=65535]="MAX_UINT_16",h[h.MAX_UINT_32=4294967295]="MAX_UINT_32",h[h.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(i||(t.Constants=i={}));function P(h){return h<0?0:h>255?255:h|0}t.$Qe=P;function p(h){return h<0?0:h>4294967295?4294967295:h|0}t.$Re=p}),te(ne[29],re([0,1,28]),function(C,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ut=t.$tt=void 0;class P{constructor(c){const l=(0,i.$Qe)(c);this.c=l,this.a=P.d(l),this.b=new Map}static d(c){const l=new Uint8Array(256);return l.fill(c),l}set(c,l){const u=(0,i.$Qe)(l);c>=0&&c<256?this.a[c]=u:this.b.set(c,u)}get(c){return c>=0&&c<256?this.a[c]:this.b.get(c)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}t.$tt=P;var p;(function(k){k[k.False=0]="False",k[k.True=1]="True"})(p||(p={}));class h{constructor(){this.a=new P(0)}add(c){this.a.set(c,1)}has(c){return this.a.get(c)===1}clear(){return this.a.clear()}}t.$ut=h}),te(ne[4],re([0,1,3]),function(C,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$et=t.$dt=void 0;class P{static addRange(k,c){let l=0;for(;l<c.length&&c[l].endExclusive<k.start;)l++;let u=l;for(;u<c.length&&c[u].start<=k.endExclusive;)u++;if(l===u)c.splice(l,0,k);else{const o=Math.min(k.start,c[l].start),E=Math.max(k.endExclusive,c[u-1].endExclusive);c.splice(l,u-l,new P(o,E))}}static tryCreate(k,c){if(!(k>c))return new P(k,c)}static ofLength(k){return new P(0,k)}static ofStartAndLength(k,c){return new P(k,k+c)}constructor(k,c){if(this.start=k,this.endExclusive=c,k>c)throw new i.$cb(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(k){return new P(this.start+k,this.endExclusive+k)}deltaStart(k){return new P(this.start+k,this.endExclusive)}deltaEnd(k){return new P(this.start,this.endExclusive+k)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(k){return this.start===k.start&&this.endExclusive===k.endExclusive}containsRange(k){return this.start<=k.start&&k.endExclusive<=this.endExclusive}contains(k){return this.start<=k&&k<this.endExclusive}join(k){return new P(Math.min(this.start,k.start),Math.max(this.endExclusive,k.endExclusive))}intersect(k){const c=Math.max(this.start,k.start),l=Math.min(this.endExclusive,k.endExclusive);if(c<=l)return new P(c,l)}intersects(k){const c=Math.max(this.start,k.start),l=Math.min(this.endExclusive,k.endExclusive);return c<l}intersectsOrTouches(k){const c=Math.max(this.start,k.start),l=Math.min(this.endExclusive,k.endExclusive);return c<=l}isBefore(k){return this.endExclusive<=k.start}isAfter(k){return this.start>=k.endExclusive}slice(k){return k.slice(this.start,this.endExclusive)}substring(k){return k.substring(this.start,this.endExclusive)}clip(k){if(this.isEmpty)throw new i.$cb(`Invalid clipping range: ${this.toString()}`);return Math.max(this.start,Math.min(this.endExclusive-1,k))}clipCyclic(k){if(this.isEmpty)throw new i.$cb(`Invalid clipping range: ${this.toString()}`);return k<this.start?this.endExclusive-(this.start-k)%this.length:k>=this.endExclusive?this.start+(k-this.start)%this.length:k}map(k){const c=[];for(let l=this.start;l<this.endExclusive;l++)c.push(k(l));return c}forEach(k){for(let c=this.start;c<this.endExclusive;c++)k(c)}}t.$dt=P;class p{constructor(){this.a=[]}addRange(k){let c=0;for(;c<this.a.length&&this.a[c].endExclusive<k.start;)c++;let l=c;for(;l<this.a.length&&this.a[l].start<=k.endExclusive;)l++;if(c===l)this.a.splice(c,0,k);else{const u=Math.min(k.start,this.a[c].start),o=Math.max(k.endExclusive,this.a[l-1].endExclusive);this.a.splice(c,l-c,new P(u,o))}}toString(){return this.a.map(k=>k.toString()).join(", ")}intersectsStrict(k){let c=0;for(;c<this.a.length&&this.a[c].endExclusive<=k.start;)c++;return c<this.a.length&&this.a[c].start<k.endExclusive}intersectWithRange(k){const c=new p;for(const l of this.a){const u=l.intersect(k);u&&c.addRange(u)}return c}intersectWithRangeLength(k){return this.intersectWithRange(k).length}get length(){return this.a.reduce((k,c)=>k+c.length,0)}}t.$et=p}),te(ne[5],re([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8s=void 0;class i{constructor(p,h){this.lineNumber=p,this.column=h}with(p=this.lineNumber,h=this.column){return p===this.lineNumber&&h===this.column?this:new i(p,h)}delta(p=0,h=0){return this.with(this.lineNumber+p,this.column+h)}equals(p){return i.equals(this,p)}static equals(p,h){return!p&&!h?!0:!!p&&!!h&&p.lineNumber===h.lineNumber&&p.column===h.column}isBefore(p){return i.isBefore(this,p)}static isBefore(p,h){return p.lineNumber<h.lineNumber?!0:h.lineNumber<p.lineNumber?!1:p.column<h.column}isBeforeOrEqual(p){return i.isBeforeOrEqual(this,p)}static isBeforeOrEqual(p,h){return p.lineNumber<h.lineNumber?!0:h.lineNumber<p.lineNumber?!1:p.column<=h.column}static compare(p,h){const k=p.lineNumber|0,c=h.lineNumber|0;if(k===c){const l=p.column|0,u=h.column|0;return l-u}return k-c}clone(){return new i(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(p){return new i(p.lineNumber,p.column)}static isIPosition(p){return p&&typeof p.lineNumber=="number"&&typeof p.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}t.$8s=i}),te(ne[2],re([0,1,5]),function(C,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9s=void 0;class P{constructor(h,k,c,l){h>c||h===c&&k>l?(this.startLineNumber=c,this.startColumn=l,this.endLineNumber=h,this.endColumn=k):(this.startLineNumber=h,this.startColumn=k,this.endLineNumber=c,this.endColumn=l)}isEmpty(){return P.isEmpty(this)}static isEmpty(h){return h.startLineNumber===h.endLineNumber&&h.startColumn===h.endColumn}containsPosition(h){return P.containsPosition(this,h)}static containsPosition(h,k){return!(k.lineNumber<h.startLineNumber||k.lineNumber>h.endLineNumber||k.lineNumber===h.startLineNumber&&k.column<h.startColumn||k.lineNumber===h.endLineNumber&&k.column>h.endColumn)}static strictContainsPosition(h,k){return!(k.lineNumber<h.startLineNumber||k.lineNumber>h.endLineNumber||k.lineNumber===h.startLineNumber&&k.column<=h.startColumn||k.lineNumber===h.endLineNumber&&k.column>=h.endColumn)}containsRange(h){return P.containsRange(this,h)}static containsRange(h,k){return!(k.startLineNumber<h.startLineNumber||k.endLineNumber<h.startLineNumber||k.startLineNumber>h.endLineNumber||k.endLineNumber>h.endLineNumber||k.startLineNumber===h.startLineNumber&&k.startColumn<h.startColumn||k.endLineNumber===h.endLineNumber&&k.endColumn>h.endColumn)}strictContainsRange(h){return P.strictContainsRange(this,h)}static strictContainsRange(h,k){return!(k.startLineNumber<h.startLineNumber||k.endLineNumber<h.startLineNumber||k.startLineNumber>h.endLineNumber||k.endLineNumber>h.endLineNumber||k.startLineNumber===h.startLineNumber&&k.startColumn<=h.startColumn||k.endLineNumber===h.endLineNumber&&k.endColumn>=h.endColumn)}plusRange(h){return P.plusRange(this,h)}static plusRange(h,k){let c,l,u,o;return k.startLineNumber<h.startLineNumber?(c=k.startLineNumber,l=k.startColumn):k.startLineNumber===h.startLineNumber?(c=k.startLineNumber,l=Math.min(k.startColumn,h.startColumn)):(c=h.startLineNumber,l=h.startColumn),k.endLineNumber>h.endLineNumber?(u=k.endLineNumber,o=k.endColumn):k.endLineNumber===h.endLineNumber?(u=k.endLineNumber,o=Math.max(k.endColumn,h.endColumn)):(u=h.endLineNumber,o=h.endColumn),new P(c,l,u,o)}intersectRanges(h){return P.intersectRanges(this,h)}static intersectRanges(h,k){let c=h.startLineNumber,l=h.startColumn,u=h.endLineNumber,o=h.endColumn;const E=k.startLineNumber,b=k.startColumn,m=k.endLineNumber,e=k.endColumn;return c<E?(c=E,l=b):c===E&&(l=Math.max(l,b)),u>m?(u=m,o=e):u===m&&(o=Math.min(o,e)),c>u||c===u&&l>o?null:new P(c,l,u,o)}equalsRange(h){return P.equalsRange(this,h)}static equalsRange(h,k){return!h&&!k?!0:!!h&&!!k&&h.startLineNumber===k.startLineNumber&&h.startColumn===k.startColumn&&h.endLineNumber===k.endLineNumber&&h.endColumn===k.endColumn}getEndPosition(){return P.getEndPosition(this)}static getEndPosition(h){return new i.$8s(h.endLineNumber,h.endColumn)}getStartPosition(){return P.getStartPosition(this)}static getStartPosition(h){return new i.$8s(h.startLineNumber,h.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(h,k){return new P(this.startLineNumber,this.startColumn,h,k)}setStartPosition(h,k){return new P(h,k,this.endLineNumber,this.endColumn)}collapseToStart(){return P.collapseToStart(this)}static collapseToStart(h){return new P(h.startLineNumber,h.startColumn,h.startLineNumber,h.startColumn)}collapseToEnd(){return P.collapseToEnd(this)}static collapseToEnd(h){return new P(h.endLineNumber,h.endColumn,h.endLineNumber,h.endColumn)}delta(h){return new P(this.startLineNumber+h,this.startColumn,this.endLineNumber+h,this.endColumn)}static fromPositions(h,k=h){return new P(h.lineNumber,h.column,k.lineNumber,k.column)}static lift(h){return h?new P(h.startLineNumber,h.startColumn,h.endLineNumber,h.endColumn):null}static isIRange(h){return h&&typeof h.startLineNumber=="number"&&typeof h.startColumn=="number"&&typeof h.endLineNumber=="number"&&typeof h.endColumn=="number"}static areIntersectingOrTouching(h,k){return!(h.endLineNumber<k.startLineNumber||h.endLineNumber===k.startLineNumber&&h.endColumn<k.startColumn||k.endLineNumber<h.startLineNumber||k.endLineNumber===h.startLineNumber&&k.endColumn<h.startColumn)}static areIntersecting(h,k){return!(h.endLineNumber<k.startLineNumber||h.endLineNumber===k.startLineNumber&&h.endColumn<=k.startColumn||k.endLineNumber<h.startLineNumber||k.endLineNumber===h.startLineNumber&&k.endColumn<=h.startColumn)}static compareRangesUsingStarts(h,k){if(h&&k){const u=h.startLineNumber|0,o=k.startLineNumber|0;if(u===o){const E=h.startColumn|0,b=k.startColumn|0;if(E===b){const m=h.endLineNumber|0,e=k.endLineNumber|0;if(m===e){const L=h.endColumn|0,j=k.endColumn|0;return L-j}return m-e}return E-b}return u-o}return(h?1:0)-(k?1:0)}static compareRangesUsingEnds(h,k){return h.endLineNumber===k.endLineNumber?h.endColumn===k.endColumn?h.startLineNumber===k.startLineNumber?h.startColumn-k.startColumn:h.startLineNumber-k.startLineNumber:h.endColumn-k.endColumn:h.endLineNumber-k.endLineNumber}static spansMultipleLines(h){return h.endLineNumber>h.startLineNumber}toJSON(){return this}}t.$9s=P}),te(ne[44],re([0,1,2]),function(C,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0s=void 0;class P{static insert(h,k){return{range:new i.$9s(h.lineNumber,h.column,h.lineNumber,h.column),text:k,forceMoveMarkers:!0}}static delete(h){return{range:h,text:null}}static replace(h,k){return{range:h,text:k}}static replaceMove(h,k){return{range:h,text:k,forceMoveMarkers:!0}}}t.$0s=P}),te(ne[12],re([0,1,3,4,2,9]),function(C,t,i,P,p,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gt=t.$ft=void 0;class k{static fromRange(u){return new k(u.startLineNumber,u.endLineNumber)}static fromRangeInclusive(u){return new k(u.startLineNumber,u.endLineNumber+1)}static subtract(u,o){return o?u.startLineNumber<o.startLineNumber&&o.endLineNumberExclusive<u.endLineNumberExclusive?[new k(u.startLineNumber,o.startLineNumber),new k(o.endLineNumberExclusive,u.endLineNumberExclusive)]:o.startLineNumber<=u.startLineNumber&&u.endLineNumberExclusive<=o.endLineNumberExclusive?[]:o.endLineNumberExclusive<u.endLineNumberExclusive?[new k(Math.max(o.endLineNumberExclusive,u.startLineNumber),u.endLineNumberExclusive)]:[new k(u.startLineNumber,Math.min(o.startLineNumber,u.endLineNumberExclusive))]:[u]}static joinMany(u){if(u.length===0)return[];let o=new c(u[0].slice());for(let E=1;E<u.length;E++)o=o.getUnion(new c(u[E].slice()));return o.ranges}static ofLength(u,o){return new k(u,u+o)}static deserialize(u){return new k(u[0],u[1])}constructor(u,o){if(u>o)throw new i.$cb(`startLineNumber ${u} cannot be after endLineNumberExclusive ${o}`);this.startLineNumber=u,this.endLineNumberExclusive=o}contains(u){return this.startLineNumber<=u&&u<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(u){return new k(this.startLineNumber+u,this.endLineNumberExclusive+u)}deltaLength(u){return new k(this.startLineNumber,this.endLineNumberExclusive+u)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(u){return new k(Math.min(this.startLineNumber,u.startLineNumber),Math.max(this.endLineNumberExclusive,u.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(u){const o=Math.max(this.startLineNumber,u.startLineNumber),E=Math.min(this.endLineNumberExclusive,u.endLineNumberExclusive);if(o<=E)return new k(o,E)}intersectsStrict(u){return this.startLineNumber<u.endLineNumberExclusive&&u.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(u){return this.startLineNumber<=u.endLineNumberExclusive&&u.startLineNumber<=this.endLineNumberExclusive}equals(u){return this.startLineNumber===u.startLineNumber&&this.endLineNumberExclusive===u.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new p.$9s(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new p.$9s(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(u){const o=[];for(let E=this.startLineNumber;E<this.endLineNumberExclusive;E++)o.push(u(E));return o}forEach(u){for(let o=this.startLineNumber;o<this.endLineNumberExclusive;o++)u(o)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(u){return this.startLineNumber<=u&&u<this.endLineNumberExclusive}toOffsetRange(){return new P.$dt(this.startLineNumber-1,this.endLineNumberExclusive-1)}}t.$ft=k;class c{constructor(u=[]){this.c=u}get ranges(){return this.c}addRange(u){if(u.length===0)return;const o=(0,h.$kb)(this.c,b=>b.endLineNumberExclusive>=u.startLineNumber),E=(0,h.$ib)(this.c,b=>b.startLineNumber<=u.endLineNumberExclusive)+1;if(o===E)this.c.splice(o,0,u);else if(o===E-1){const b=this.c[o];this.c[o]=b.join(u)}else{const b=this.c[o].join(this.c[E-1]).join(u);this.c.splice(o,E-o,b)}}contains(u){const o=(0,h.$hb)(this.c,E=>E.startLineNumber<=u);return!!o&&o.endLineNumberExclusive>u}intersects(u){const o=(0,h.$hb)(this.c,E=>E.startLineNumber<u.endLineNumberExclusive);return!!o&&o.endLineNumberExclusive>u.startLineNumber}getUnion(u){if(this.c.length===0)return u;if(u.c.length===0)return this;const o=[];let E=0,b=0,m=null;for(;E<this.c.length||b<u.c.length;){let e=null;if(E<this.c.length&&b<u.c.length){const L=this.c[E],j=u.c[b];L.startLineNumber<j.startLineNumber?(e=L,E++):(e=j,b++)}else E<this.c.length?(e=this.c[E],E++):(e=u.c[b],b++);m===null?m=e:m.endLineNumberExclusive>=e.startLineNumber?m=new k(m.startLineNumber,Math.max(m.endLineNumberExclusive,e.endLineNumberExclusive)):(o.push(m),m=e)}return m!==null&&o.push(m),new c(o)}subtractFrom(u){const o=(0,h.$kb)(this.c,e=>e.endLineNumberExclusive>=u.startLineNumber),E=(0,h.$ib)(this.c,e=>e.startLineNumber<=u.endLineNumberExclusive)+1;if(o===E)return new c([u]);const b=[];let m=u.startLineNumber;for(let e=o;e<E;e++){const L=this.c[e];L.startLineNumber>m&&b.push(new k(m,L.startLineNumber)),m=L.endLineNumberExclusive}return m<u.endLineNumberExclusive&&b.push(new k(m,u.endLineNumberExclusive)),new c(b)}toString(){return this.c.map(u=>u.toString()).join(", ")}getIntersection(u){const o=[];let E=0,b=0;for(;E<this.c.length&&b<u.c.length;){const m=this.c[E],e=u.c[b],L=m.intersect(e);L&&!L.isEmpty&&o.push(L),m.endLineNumberExclusive<e.endLineNumberExclusive?E++:b++}return new c(o)}getWithDelta(u){return new c(this.c.map(o=>o.delta(u)))}}t.$gt=c}),te(ne[45],re([0,1,5,2]),function(C,t,i,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$s=t.SelectionDirection=void 0;var p;(function(k){k[k.LTR=0]="LTR",k[k.RTL=1]="RTL"})(p||(t.SelectionDirection=p={}));class h extends P.$9s{constructor(c,l,u,o){super(c,l,u,o),this.selectionStartLineNumber=c,this.selectionStartColumn=l,this.positionLineNumber=u,this.positionColumn=o}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(c){return h.selectionsEqual(this,c)}static selectionsEqual(c,l){return c.selectionStartLineNumber===l.selectionStartLineNumber&&c.selectionStartColumn===l.selectionStartColumn&&c.positionLineNumber===l.positionLineNumber&&c.positionColumn===l.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(c,l){return this.getDirection()===0?new h(this.startLineNumber,this.startColumn,c,l):new h(c,l,this.startLineNumber,this.startColumn)}getPosition(){return new i.$8s(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new i.$8s(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(c,l){return this.getDirection()===0?new h(c,l,this.endLineNumber,this.endColumn):new h(this.endLineNumber,this.endColumn,c,l)}static fromPositions(c,l=c){return new h(c.lineNumber,c.column,l.lineNumber,l.column)}static fromRange(c,l){return l===0?new h(c.startLineNumber,c.startColumn,c.endLineNumber,c.endColumn):new h(c.endLineNumber,c.endColumn,c.startLineNumber,c.startColumn)}static liftSelection(c){return new h(c.selectionStartLineNumber,c.selectionStartColumn,c.positionLineNumber,c.positionColumn)}static selectionsArrEqual(c,l){if(c&&!l||!c&&l)return!1;if(!c&&!l)return!0;if(c.length!==l.length)return!1;for(let u=0,o=c.length;u<o;u++)if(!this.selectionsEqual(c[u],l[u]))return!1;return!0}static isISelection(c){return c&&typeof c.selectionStartLineNumber=="number"&&typeof c.selectionStartColumn=="number"&&typeof c.positionLineNumber=="number"&&typeof c.positionColumn=="number"}static createWithDirection(c,l,u,o,E){return E===0?new h(c,l,u,o):new h(u,o,c,l)}}t.$$s=h}),te(ne[46],re([0,1,29]),function(C,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wt=t.$vt=t.WordCharacterClass=void 0;var P;(function(k){k[k.Regular=0]="Regular",k[k.Whitespace=1]="Whitespace",k[k.WordSeparator=2]="WordSeparator"})(P||(t.WordCharacterClass=P={}));class p extends i.$tt{constructor(c){super(0);for(let l=0,u=c.length;l<u;l++)this.set(c.charCodeAt(l),2);this.set(32,1),this.set(9,1)}}t.$vt=p;function h(k){const c={};return l=>(c.hasOwnProperty(l)||(c[l]=k(l)),c[l])}t.$wt=h(k=>new p(k))}),te(ne[30],re([0,1,20,10,21]),function(C,t,i,P,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ls=t.$Ks=t.$Js=t.$Is=t.$Hs=void 0,t.$Hs="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function h(E=""){let b="(-?\\d*\\.\\d\\w*)|([^";for(const m of t.$Hs)E.indexOf(m)>=0||(b+="\\"+m);return b+="\\s]+)",new RegExp(b,"g")}t.$Is=h();function k(E){let b=t.$Is;if(E&&E instanceof RegExp)if(E.global)b=E;else{let m="g";E.ignoreCase&&(m+="i"),E.multiline&&(m+="m"),E.unicode&&(m+="u"),b=new RegExp(E.source,m)}return b.lastIndex=0,b}t.$Js=k;const c=new p.$4c;c.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function l(E){const b=c.unshift(E);return(0,P.$Rc)(b)}t.$Ks=l;function u(E,b,m,e,L){if(b=k(b),L||(L=i.Iterable.first(c)),m.length>L.maxLen){let a=E-L.maxLen/2;return a<0?a=0:e+=a,m=m.substring(a,E+L.maxLen/2),u(E,b,m,e,L)}const j=Date.now(),N=E-1-e;let $=-1,d=null;for(let a=1;!(Date.now()-j>=L.timeBudget);a++){const f=N-L.windowSize*a;b.lastIndex=Math.max(0,f);const n=o(b,m,N,$);if(!n&&d||(d=n,f<=0))break;$=f}if(d){const a={word:d[0],startColumn:e+1+d.index,endColumn:e+1+d.index+d[0].length};return b.lastIndex=0,a}return null}t.$Ls=u;function o(E,b,m,e){let L;for(;L=E.exec(b);){const j=L.index||0;if(j<=m&&E.lastIndex>=m)return L;if(e>0&&j>e)return null}return null}}),te(ne[8],re([0,1,6,3,4]),function(C,t,i,P,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$j2=t.$i2=t.$h2=t.$g2=t.$f2=void 0;class h{static trivial(E,b){return new h([new k(p.$dt.ofLength(E.length),p.$dt.ofLength(b.length))],!1)}static trivialTimedOut(E,b){return new h([new k(p.$dt.ofLength(E.length),p.$dt.ofLength(b.length))],!0)}constructor(E,b){this.diffs=E,this.hitTimeout=b}}t.$f2=h;class k{static invert(E,b){const m=[];return(0,i.$Bb)(E,(e,L)=>{m.push(k.fromOffsetPairs(e?e.getEndExclusives():c.zero,L?L.getStarts():new c(b,(e?e.seq2Range.endExclusive-e.seq1Range.endExclusive:0)+b)))}),m}static fromOffsetPairs(E,b){return new k(new p.$dt(E.offset1,b.offset1),new p.$dt(E.offset2,b.offset2))}constructor(E,b){this.seq1Range=E,this.seq2Range=b}swap(){return new k(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(E){return new k(this.seq1Range.join(E.seq1Range),this.seq2Range.join(E.seq2Range))}delta(E){return E===0?this:new k(this.seq1Range.delta(E),this.seq2Range.delta(E))}deltaStart(E){return E===0?this:new k(this.seq1Range.deltaStart(E),this.seq2Range.deltaStart(E))}deltaEnd(E){return E===0?this:new k(this.seq1Range.deltaEnd(E),this.seq2Range.deltaEnd(E))}intersectsOrTouches(E){return this.seq1Range.intersectsOrTouches(E.seq1Range)||this.seq2Range.intersectsOrTouches(E.seq2Range)}intersect(E){const b=this.seq1Range.intersect(E.seq1Range),m=this.seq2Range.intersect(E.seq2Range);if(!(!b||!m))return new k(b,m)}getStarts(){return new c(this.seq1Range.start,this.seq2Range.start)}getEndExclusives(){return new c(this.seq1Range.endExclusive,this.seq2Range.endExclusive)}}t.$g2=k;class c{static{this.zero=new c(0,0)}static{this.max=new c(Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER)}constructor(E,b){this.offset1=E,this.offset2=b}toString(){return`${this.offset1} <-> ${this.offset2}`}delta(E){return E===0?this:new c(this.offset1+E,this.offset2+E)}equals(E){return this.offset1===E.offset1&&this.offset2===E.offset2}}t.$h2=c;class l{static{this.instance=new l}isValid(){return!0}}t.$i2=l;class u{constructor(E){if(this.e=E,this.c=Date.now(),this.d=!0,E<=0)throw new P.$cb("timeout must be positive")}isValid(){if(!(Date.now()-this.c<this.e)&&this.d){this.d=!1;debugger}return this.d}disable(){this.e=Number.MAX_SAFE_INTEGER,this.isValid=()=>!0,this.d=!0}}t.$j2=u}),te(ne[31],re([0,1,4,8]),function(C,t,i,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$o2=void 0;class p{compute(u,o,E=P.$i2.instance){if(u.length===0||o.length===0)return P.$f2.trivial(u,o);const b=u,m=o;function e(s,w){for(;s<b.length&&w<m.length&&b.getElement(s)===m.getElement(w);)s++,w++;return s}let L=0;const j=new k;j.set(0,e(0,0));const N=new c;N.set(0,j.get(0)===0?null:new h(null,0,0,j.get(0)));let $=0;e:for(;;){if(L++,!E.isValid())return P.$f2.trivialTimedOut(b,m);const s=-Math.min(L,m.length+L%2),w=Math.min(L,b.length+L%2);for($=s;$<=w;$+=2){let g=0;const v=$===w?-1:j.get($+1),A=$===s?-1:j.get($-1)+1;g++;const R=Math.min(Math.max(v,A),b.length),y=R-$;if(g++,R>b.length||y>m.length)continue;const F=e(R,y);j.set($,F);const M=R===v?N.get($+1):N.get($-1);if(N.set($,F!==R?new h(M,R,y,F-R):M),j.get($)===b.length&&j.get($)-$===m.length)break e}}let d=N.get($);const a=[];let f=b.length,n=m.length;for(;;){const s=d?d.x+d.length:0,w=d?d.y+d.length:0;if((s!==f||w!==n)&&a.push(new P.$g2(new i.$dt(s,f),new i.$dt(w,n))),!d)break;f=d.x,n=d.y,d=d.prev}return a.reverse(),new P.$f2(a,!1)}}t.$o2=p;class h{constructor(u,o,E,b){this.prev=u,this.x=o,this.y=E,this.length=b}}class k{constructor(){this.a=new Int32Array(10),this.b=new Int32Array(10)}get(u){return u<0?(u=-u-1,this.b[u]):this.a[u]}set(u,o){if(u<0){if(u=-u-1,u>=this.b.length){const E=this.b;this.b=new Int32Array(E.length*2),this.b.set(E)}this.b[u]=o}else{if(u>=this.a.length){const E=this.a;this.a=new Int32Array(E.length*2),this.a.set(E)}this.a[u]=o}}}class c{constructor(){this.a=[],this.b=[]}get(u){return u<0?(u=-u-1,this.b[u]):this.a[u]}set(u,o){u<0?(u=-u-1,this.b[u]=o):this.a[u]=o}}}),te(ne[47],re([0,1,6,4,8]),function(C,t,i,P,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$w2=t.$v2=t.$u2=t.$t2=t.$s2=void 0;function h(e,L,j){let N=j;return N=k(e,L,N),N=k(e,L,N),N=c(e,L,N),N}t.$s2=h;function k(e,L,j){if(j.length===0)return j;const N=[];N.push(j[0]);for(let d=1;d<j.length;d++){const a=N[N.length-1];let f=j[d];if(f.seq1Range.isEmpty||f.seq2Range.isEmpty){const n=f.seq1Range.start-a.seq1Range.endExclusive;let s;for(s=1;s<=n&&!(e.getElement(f.seq1Range.start-s)!==e.getElement(f.seq1Range.endExclusive-s)||L.getElement(f.seq2Range.start-s)!==L.getElement(f.seq2Range.endExclusive-s));s++);if(s--,s===n){N[N.length-1]=new p.$g2(new P.$dt(a.seq1Range.start,f.seq1Range.endExclusive-n),new P.$dt(a.seq2Range.start,f.seq2Range.endExclusive-n));continue}f=f.delta(-s)}N.push(f)}const $=[];for(let d=0;d<N.length-1;d++){const a=N[d+1];let f=N[d];if(f.seq1Range.isEmpty||f.seq2Range.isEmpty){const n=a.seq1Range.start-f.seq1Range.endExclusive;let s;for(s=0;s<n&&!(!e.isStronglyEqual(f.seq1Range.start+s,f.seq1Range.endExclusive+s)||!L.isStronglyEqual(f.seq2Range.start+s,f.seq2Range.endExclusive+s));s++);if(s===n){N[d+1]=new p.$g2(new P.$dt(f.seq1Range.start+n,a.seq1Range.endExclusive),new P.$dt(f.seq2Range.start+n,a.seq2Range.endExclusive));continue}s>0&&(f=f.delta(s))}$.push(f)}return N.length>0&&$.push(N[N.length-1]),$}function c(e,L,j){if(!e.getBoundaryScore||!L.getBoundaryScore)return j;for(let N=0;N<j.length;N++){const $=N>0?j[N-1]:void 0,d=j[N],a=N+1<j.length?j[N+1]:void 0,f=new P.$dt($?$.seq1Range.endExclusive+1:0,a?a.seq1Range.start-1:e.length),n=new P.$dt($?$.seq2Range.endExclusive+1:0,a?a.seq2Range.start-1:L.length);d.seq1Range.isEmpty?j[N]=l(d,e,L,f,n):d.seq2Range.isEmpty&&(j[N]=l(d.swap(),L,e,n,f).swap())}return j}function l(e,L,j,N,$){let a=1;for(;e.seq1Range.start-a>=N.start&&e.seq2Range.start-a>=$.start&&j.isStronglyEqual(e.seq2Range.start-a,e.seq2Range.endExclusive-a)&&a<100;)a++;a--;let f=0;for(;e.seq1Range.start+f<N.endExclusive&&e.seq2Range.endExclusive+f<$.endExclusive&&j.isStronglyEqual(e.seq2Range.start+f,e.seq2Range.endExclusive+f)&&f<100;)f++;if(a===0&&f===0)return e;let n=0,s=-1;for(let w=-a;w<=f;w++){const g=e.seq2Range.start+w,v=e.seq2Range.endExclusive+w,A=e.seq1Range.start+w,R=L.getBoundaryScore(A)+j.getBoundaryScore(g)+j.getBoundaryScore(v);R>s&&(s=R,n=w)}return e.delta(n)}function u(e,L,j){const N=[];for(const $ of j){const d=N[N.length-1];if(!d){N.push($);continue}$.seq1Range.start-d.seq1Range.endExclusive<=2||$.seq2Range.start-d.seq2Range.endExclusive<=2?N[N.length-1]=new p.$g2(d.seq1Range.join($.seq1Range),d.seq2Range.join($.seq2Range)):N.push($)}return N}t.$t2=u;function o(e,L,j){const N=p.$g2.invert(j,e.length),$=[];let d=new p.$h2(0,0);function a(n,s){if(n.offset1<d.offset1||n.offset2<d.offset2)return;const w=e.findWordContaining(n.offset1),g=L.findWordContaining(n.offset2);if(!w||!g)return;let v=new p.$g2(w,g);const A=v.intersect(s);let R=A.seq1Range.length,y=A.seq2Range.length;for(;N.length>0;){const F=N[0];if(!(F.seq1Range.intersects(v.seq1Range)||F.seq2Range.intersects(v.seq2Range)))break;const S=e.findWordContaining(F.seq1Range.start),D=L.findWordContaining(F.seq2Range.start),q=new p.$g2(S,D),W=q.intersect(F);if(R+=W.seq1Range.length,y+=W.seq2Range.length,v=v.join(q),v.seq1Range.endExclusive>=F.seq1Range.endExclusive)N.shift();else break}R+y<(v.seq1Range.length+v.seq2Range.length)*2/3&&$.push(v),d=v.getEndExclusives()}for(;N.length>0;){const n=N.shift();n.seq1Range.isEmpty||(a(n.getStarts(),n),a(n.getEndExclusives().delta(-1),n))}return E(j,$)}t.$u2=o;function E(e,L){const j=[];for(;e.length>0||L.length>0;){const N=e[0],$=L[0];let d;N&&(!$||N.seq1Range.start<$.seq1Range.start)?d=e.shift():d=L.shift(),j.length>0&&j[j.length-1].seq1Range.endExclusive>=d.seq1Range.start?j[j.length-1]=j[j.length-1].join(d):j.push(d)}return j}function b(e,L,j){let N=j;if(N.length===0)return N;let $=0,d;do{d=!1;const a=[N[0]];for(let f=1;f<N.length;f++){let w=function(v,A){const R=new P.$dt(s.seq1Range.endExclusive,n.seq1Range.start);return e.getText(R).replace(/\s/g,"").length<=4&&(v.seq1Range.length+v.seq2Range.length>5||A.seq1Range.length+A.seq2Range.length>5)};const n=N[f],s=a[a.length-1];w(s,n)?(d=!0,a[a.length-1]=a[a.length-1].join(n)):a.push(n)}N=a}while($++<10&&d);return N}t.$v2=b;function m(e,L,j){let N=j;if(N.length===0)return N;let $=0,d;do{d=!1;const f=[N[0]];for(let n=1;n<N.length;n++){let g=function(A,R){const y=new P.$dt(w.seq1Range.endExclusive,s.seq1Range.start);if(e.countLinesIn(y)>5||y.length>500)return!1;const M=e.getText(y).trim();if(M.length>20||M.split(/\r\n|\r|\n/).length>1)return!1;const S=e.countLinesIn(A.seq1Range),D=A.seq1Range.length,q=L.countLinesIn(A.seq2Range),W=A.seq2Range.length,G=e.countLinesIn(R.seq1Range),ee=R.seq1Range.length,T=L.countLinesIn(R.seq2Range),B=R.seq2Range.length,_=2*40+50;function Q(se){return Math.min(se,_)}return Math.pow(Math.pow(Q(S*40+D),1.5)+Math.pow(Q(q*40+W),1.5),1.5)+Math.pow(Math.pow(Q(G*40+ee),1.5)+Math.pow(Q(T*40+B),1.5),1.5)>(_**1.5)**1.5*1.3};const s=N[n],w=f[f.length-1];g(w,s)?(d=!0,f[f.length-1]=f[f.length-1].join(s)):f.push(s)}N=f}while($++<10&&d);const a=[];return(0,i.$Cb)(N,(f,n,s)=>{let w=n;function g(M){return M.length>0&&M.trim().length<=3&&n.seq1Range.length+n.seq2Range.length>100}const v=e.extendToFullLines(n.seq1Range),A=e.getText(new P.$dt(v.start,n.seq1Range.start));g(A)&&(w=w.deltaStart(-A.length));const R=e.getText(new P.$dt(n.seq1Range.endExclusive,v.endExclusive));g(R)&&(w=w.deltaEnd(R.length));const y=p.$g2.fromOffsetPairs(f?f.getEndExclusives():p.$h2.zero,s?s.getStarts():p.$h2.max),F=w.intersect(y);a.length>0&&F.getStarts().equals(a[a.length-1].getEndExclusives())?a[a.length-1]=a[a.length-1].join(F):a.push(F)}),a}t.$w2=m}),te(ne[48],re([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$r2=void 0;class i{constructor(h,k){this.a=h,this.b=k}getElement(h){return this.a[h]}get length(){return this.a.length}getBoundaryScore(h){const k=h===0?0:P(this.b[h-1]),c=h===this.b.length?0:P(this.b[h]);return 1e3-(k+c)}getText(h){return this.b.slice(h.start,h.endExclusive).join(`
`)}isStronglyEqual(h,k){return this.b[h]===this.b[k]}}t.$r2=i;function P(p){let h=0;for(;h<p.length&&(p.charCodeAt(h)===32||p.charCodeAt(h)===9);)h++;return h}}),te(ne[15],re([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$m2=t.$l2=t.$k2=void 0;class i{constructor(k,c){this.width=k,this.height=c,this.a=[],this.a=new Array(k*c)}get(k,c){return this.a[k+c*this.width]}set(k,c,l){this.a[k+c*this.width]=l}}t.$k2=i;function P(h){return h===32||h===9}t.$l2=P;class p{static{this.a=new Map}static b(k){let c=this.a.get(k);return c===void 0&&(c=this.a.size,this.a.set(k,c)),c}constructor(k,c,l){this.range=k,this.lines=c,this.source=l,this.d=[];let u=0;for(let o=k.startLineNumber-1;o<k.endLineNumberExclusive-1;o++){const E=c[o];for(let m=0;m<E.length;m++){u++;const e=E[m],L=p.b(e);this.d[L]=(this.d[L]||0)+1}u++;const b=p.b(`
`);this.d[b]=(this.d[b]||0)+1}this.c=u}computeSimilarity(k){let c=0;const l=Math.max(this.d.length,k.d.length);for(let u=0;u<l;u++)c+=Math.abs((this.d[u]??0)-(k.d[u]??0));return 1-c/(this.c+k.c)}}t.$m2=p}),te(ne[49],re([0,1,4,8,15]),function(C,t,i,P,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$n2=void 0;class h{compute(c,l,u=P.$i2.instance,o){if(c.length===0||l.length===0)return P.$f2.trivial(c,l);const E=new p.$k2(c.length,l.length),b=new p.$k2(c.length,l.length),m=new p.$k2(c.length,l.length);for(let a=0;a<c.length;a++)for(let f=0;f<l.length;f++){if(!u.isValid())return P.$f2.trivialTimedOut(c,l);const n=a===0?0:E.get(a-1,f),s=f===0?0:E.get(a,f-1);let w;c.getElement(a)===l.getElement(f)?(a===0||f===0?w=0:w=E.get(a-1,f-1),a>0&&f>0&&b.get(a-1,f-1)===3&&(w+=m.get(a-1,f-1)),w+=o?o(a,f):1):w=-1;const g=Math.max(n,s,w);if(g===w){const v=a>0&&f>0?m.get(a-1,f-1):0;m.set(a,f,v+1),b.set(a,f,3)}else g===n?(m.set(a,f,0),b.set(a,f,1)):g===s&&(m.set(a,f,0),b.set(a,f,2));E.set(a,f,g)}const e=[];let L=c.length,j=l.length;function N(a,f){(a+1!==L||f+1!==j)&&e.push(new P.$g2(new i.$dt(a+1,L),new i.$dt(f+1,j))),L=a,j=f}let $=c.length-1,d=l.length-1;for(;$>=0&&d>=0;)b.get($,d)===3?(N($,d),$--,d--):b.get($,d)===1?$--:d--;return N(-1,-1),e.reverse(),new P.$f2(e,!1)}}t.$n2=h}),te(ne[32],re([0,1,9,4,5,2,15]),function(C,t,i,P,p,h,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$p2=void 0;class c{constructor(e,L,j){this.lines=e,this.considerWhitespaceChanges=j,this.b=[],this.c=[],this.d=[];let N=!1;L.start>0&&L.endExclusive>=e.length&&(L=new P.$dt(L.start-1,L.endExclusive),N=!0),this.lineRange=L,this.c[0]=0;for(let $=this.lineRange.start;$<this.lineRange.endExclusive;$++){let d=e[$],a=0;if(N)a=d.length,d="",N=!1;else if(!j){const f=d.trimStart();a=d.length-f.length,d=f.trimEnd()}this.d.push(a);for(let f=0;f<d.length;f++)this.b.push(d.charCodeAt(f));$<e.length-1&&(this.b.push(10),this.c[$-this.lineRange.start+1]=this.b.length)}this.d.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new P.$dt(0,this.length))}getText(e){return this.b.slice(e.start,e.endExclusive).map(L=>String.fromCharCode(L)).join("")}getElement(e){return this.b[e]}get length(){return this.b.length}getBoundaryScore(e){const L=b(e>0?this.b[e-1]:-1),j=b(e<this.b.length?this.b[e]:-1);if(L===7&&j===8)return 0;if(L===8)return 150;let N=0;return L!==j&&(N+=10,L===0&&j===1&&(N+=1)),N+=E(L),N+=E(j),N}translateOffset(e){if(this.lineRange.isEmpty)return new p.$8s(this.lineRange.start+1,1);const L=(0,i.$ib)(this.c,j=>j<=e);return new p.$8s(this.lineRange.start+L+1,e-this.c[L]+this.d[L]+1)}translateRange(e){return h.$9s.fromPositions(this.translateOffset(e.start),this.translateOffset(e.endExclusive))}findWordContaining(e){if(e<0||e>=this.b.length||!l(this.b[e]))return;let L=e;for(;L>0&&l(this.b[L-1]);)L--;let j=e;for(;j<this.b.length&&l(this.b[j]);)j++;return new P.$dt(L,j)}countLinesIn(e){return this.translateOffset(e.endExclusive).lineNumber-this.translateOffset(e.start).lineNumber}isStronglyEqual(e,L){return this.b[e]===this.b[L]}extendToFullLines(e){const L=(0,i.$hb)(this.c,N=>N<=e.start)??0,j=(0,i.$jb)(this.c,N=>e.endExclusive<=N)??this.b.length;return new P.$dt(L,j)}}t.$p2=c;function l(m){return m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57}var u;(function(m){m[m.WordLower=0]="WordLower",m[m.WordUpper=1]="WordUpper",m[m.WordNumber=2]="WordNumber",m[m.End=3]="End",m[m.Other=4]="Other",m[m.Separator=5]="Separator",m[m.Space=6]="Space",m[m.LineBreakCR=7]="LineBreakCR",m[m.LineBreakLF=8]="LineBreakLF"})(u||(u={}));const o={0:0,1:0,2:0,3:10,4:2,5:30,6:3,7:10,8:10};function E(m){return o[m]}function b(m){return m===10?8:m===13?7:(0,k.$l2)(m)?6:m>=97&&m<=122?0:m>=65&&m<=90?1:m>=48&&m<=57?2:m===-1?3:m===44||m===59?5:4}}),te(ne[33],re([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lt=t.$kt=void 0;class i{constructor(h,k,c){this.changes=h,this.moves=k,this.hitTimeout=c}}t.$kt=i;class P{constructor(h,k){this.lineRangeMapping=h,this.changes=k}flip(){return new P(this.lineRangeMapping.flip(),this.changes.map(h=>h.flip()))}}t.$lt=P}),te(ne[16],re([0,1,12]),function(C,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jt=t.$it=t.$ht=void 0;class P{static inverse(c,l,u){const o=[];let E=1,b=1;for(const e of c){const L=new P(new i.$ft(E,e.original.startLineNumber),new i.$ft(b,e.modified.startLineNumber));L.modified.isEmpty||o.push(L),E=e.original.endLineNumberExclusive,b=e.modified.endLineNumberExclusive}const m=new P(new i.$ft(E,l+1),new i.$ft(b,u+1));return m.modified.isEmpty||o.push(m),o}static clip(c,l,u){const o=[];for(const E of c){const b=E.original.intersect(l),m=E.modified.intersect(u);b&&!b.isEmpty&&m&&!m.isEmpty&&o.push(new P(b,m))}return o}constructor(c,l){this.original=c,this.modified=l}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new P(this.modified,this.original)}join(c){return new P(this.original.join(c.original),this.modified.join(c.modified))}get changedLineCount(){return Math.max(this.original.length,this.modified.length)}}t.$ht=P;class p extends P{constructor(c,l,u){super(c,l),this.innerChanges=u}flip(){return new p(this.modified,this.original,this.innerChanges?.map(c=>c.flip()))}}t.$it=p;class h{constructor(c,l){this.originalRange=c,this.modifiedRange=l}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new h(this.modifiedRange,this.originalRange)}}t.$jt=h}),te(ne[50],re([0,1,8,16,6,9,22,12,4,32,15,31]),function(C,t,i,P,p,h,k,c,l,u,o,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$q2=void 0;function b(d,a,f,n,s,w){let{moves:g,excludedChanges:v}=e(d,a,f,w);if(!w.isValid())return[];const A=d.filter(y=>!v.has(y)),R=L(A,n,s,a,f,w);return(0,p.$1b)(g,R),g=N(g),g=g.filter(y=>{const F=y.original.toOffsetRange().slice(a).map(S=>S.trim());return F.join(`
`).length>=15&&m(F,S=>S.length>=2)>=2}),g=$(d,g),g}t.$q2=b;function m(d,a){let f=0;for(const n of d)a(n)&&f++;return f}function e(d,a,f,n){const s=[],w=d.filter(A=>A.modified.isEmpty&&A.original.length>=3).map(A=>new o.$m2(A.original,a,A)),g=new Set(d.filter(A=>A.original.isEmpty&&A.modified.length>=3).map(A=>new o.$m2(A.modified,f,A))),v=new Set;for(const A of w){let R=-1,y;for(const F of g){const M=A.computeSimilarity(F);M>R&&(R=M,y=F)}if(R>.9&&y&&(g.delete(y),s.push(new P.$ht(A.range,y.range)),v.add(A.source),v.add(y.source)),!n.isValid())return{moves:s,excludedChanges:v}}return{moves:s,excludedChanges:v}}function L(d,a,f,n,s,w){const g=[],v=new k.$Gc;for(const M of d)for(let S=M.original.startLineNumber;S<M.original.endLineNumberExclusive-2;S++){const D=`${a[S-1]}:${a[S+1-1]}:${a[S+2-1]}`;v.add(D,{range:new c.$ft(S,S+3)})}const A=[];d.sort((0,p.$7b)(M=>M.modified.startLineNumber,p.$9b));for(const M of d){let S=[];for(let D=M.modified.startLineNumber;D<M.modified.endLineNumberExclusive-2;D++){const q=`${f[D-1]}:${f[D+1-1]}:${f[D+2-1]}`,W=new c.$ft(D,D+3),G=[];v.forEach(q,({range:ee})=>{for(const B of S)if(B.originalLineRange.endLineNumberExclusive+1===ee.endLineNumberExclusive&&B.modifiedLineRange.endLineNumberExclusive+1===W.endLineNumberExclusive){B.originalLineRange=new c.$ft(B.originalLineRange.startLineNumber,ee.endLineNumberExclusive),B.modifiedLineRange=new c.$ft(B.modifiedLineRange.startLineNumber,W.endLineNumberExclusive),G.push(B);return}const T={modifiedLineRange:W,originalLineRange:ee};A.push(T),G.push(T)}),S=G}if(!w.isValid())return[]}A.sort((0,p.$$b)((0,p.$7b)(M=>M.modifiedLineRange.length,p.$9b)));const R=new c.$gt,y=new c.$gt;for(const M of A){const S=M.modifiedLineRange.startLineNumber-M.originalLineRange.startLineNumber,D=R.subtractFrom(M.modifiedLineRange),q=y.subtractFrom(M.originalLineRange).getWithDelta(S),W=D.getIntersection(q);for(const G of W.ranges){if(G.length<3)continue;const ee=G,T=G.delta(-S);g.push(new P.$ht(T,ee)),R.addRange(ee),y.addRange(T)}}g.sort((0,p.$7b)(M=>M.original.startLineNumber,p.$9b));const F=new h.$mb(d);for(let M=0;M<g.length;M++){const S=g[M],D=F.findLastMonotonous(Q=>Q.original.startLineNumber<=S.original.startLineNumber),q=(0,h.$hb)(d,Q=>Q.modified.startLineNumber<=S.modified.startLineNumber),W=Math.max(S.original.startLineNumber-D.original.startLineNumber,S.modified.startLineNumber-q.modified.startLineNumber),G=F.findLastMonotonous(Q=>Q.original.startLineNumber<S.original.endLineNumberExclusive),ee=(0,h.$hb)(d,Q=>Q.modified.startLineNumber<S.modified.endLineNumberExclusive),T=Math.max(G.original.endLineNumberExclusive-S.original.endLineNumberExclusive,ee.modified.endLineNumberExclusive-S.modified.endLineNumberExclusive);let B;for(B=0;B<W;B++){const Q=S.original.startLineNumber-B-1,se=S.modified.startLineNumber-B-1;if(Q>n.length||se>s.length||R.contains(se)||y.contains(Q)||!j(n[Q-1],s[se-1],w))break}B>0&&(y.addRange(new c.$ft(S.original.startLineNumber-B,S.original.startLineNumber)),R.addRange(new c.$ft(S.modified.startLineNumber-B,S.modified.startLineNumber)));let _;for(_=0;_<T;_++){const Q=S.original.endLineNumberExclusive+_,se=S.modified.endLineNumberExclusive+_;if(Q>n.length||se>s.length||R.contains(se)||y.contains(Q)||!j(n[Q-1],s[se-1],w))break}_>0&&(y.addRange(new c.$ft(S.original.endLineNumberExclusive,S.original.endLineNumberExclusive+_)),R.addRange(new c.$ft(S.modified.endLineNumberExclusive,S.modified.endLineNumberExclusive+_))),(B>0||_>0)&&(g[M]=new P.$ht(new c.$ft(S.original.startLineNumber-B,S.original.endLineNumberExclusive+_),new c.$ft(S.modified.startLineNumber-B,S.modified.endLineNumberExclusive+_)))}return g}function j(d,a,f){if(d.trim()===a.trim())return!0;if(d.length>300&&a.length>300)return!1;const s=new E.$o2().compute(new u.$p2([d],new l.$dt(0,1),!1),new u.$p2([a],new l.$dt(0,1),!1),f);let w=0;const g=i.$g2.invert(s.diffs,d.length);for(const y of g)y.seq1Range.forEach(F=>{(0,o.$l2)(d.charCodeAt(F))||w++});function v(y){let F=0;for(let M=0;M<d.length;M++)(0,o.$l2)(y.charCodeAt(M))||F++;return F}const A=v(d.length>a.length?d:a);return w/A>.6&&A>10}function N(d){if(d.length===0)return d;d.sort((0,p.$7b)(f=>f.original.startLineNumber,p.$9b));const a=[d[0]];for(let f=1;f<d.length;f++){const n=a[a.length-1],s=d[f],w=s.original.startLineNumber-n.original.endLineNumberExclusive,g=s.modified.startLineNumber-n.modified.endLineNumberExclusive;if(w>=0&&g>=0&&w+g<=2){a[a.length-1]=n.join(s);continue}a.push(s)}return a}function $(d,a){const f=new h.$mb(d);return a=a.filter(n=>{const s=f.findLastMonotonous(v=>v.original.startLineNumber<n.original.endLineNumberExclusive)||new P.$ht(new c.$ft(1,1),new c.$ft(1,1)),w=(0,h.$hb)(d,v=>v.modified.startLineNumber<n.modified.endLineNumberExclusive);return s!==w}),a}}),te(ne[51],re([0,1,6,13,12,4,2,8,49,31,50,47,48,32,33,16]),function(C,t,i,P,p,h,k,c,l,u,o,E,b,m,e,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$z2=t.$y2=t.$x2=void 0;class j{constructor(){this.e=new l.$n2,this.f=new u.$o2}computeDiff(a,f,n){if(a.length<=1&&(0,i.$ub)(a,f,(_,Q)=>_===Q))return new e.$kt([],[],!1);if(a.length===1&&a[0].length===0||f.length===1&&f[0].length===0)return new e.$kt([new L.$it(new p.$ft(1,a.length+1),new p.$ft(1,f.length+1),[new L.$jt(new k.$9s(1,1,a.length,a[0].length+1),new k.$9s(1,1,f.length,f[0].length+1))])],[],!1);const s=n.maxComputationTimeMs===0?c.$i2.instance:new c.$j2(n.maxComputationTimeMs),w=!n.ignoreTrimWhitespace,g=new Map;function v(_){let Q=g.get(_);return Q===void 0&&(Q=g.size,g.set(_,Q)),Q}const A=a.map(_=>v(_.trim())),R=f.map(_=>v(_.trim())),y=new b.$r2(A,a),F=new b.$r2(R,f),M=y.length+F.length<1700?this.e.compute(y,F,s,(_,Q)=>a[_]===f[Q]?f[Q].length===0?.1:1+Math.log(1+f[Q].length):.99):this.f.compute(y,F);let S=M.diffs,D=M.hitTimeout;S=(0,E.$s2)(y,F,S),S=(0,E.$v2)(y,F,S);const q=[],W=_=>{if(w)for(let Q=0;Q<_;Q++){const se=G+Q,ae=ee+Q;if(a[se]!==f[ae]){const r=this.j(a,f,new c.$g2(new h.$dt(se,se+1),new h.$dt(ae,ae+1)),s,w);for(const ge of r.mappings)q.push(ge);r.hitTimeout&&(D=!0)}}};let G=0,ee=0;for(const _ of S){(0,P.$_c)(()=>_.seq1Range.start-G===_.seq2Range.start-ee);const Q=_.seq1Range.start-G;W(Q),G=_.seq1Range.endExclusive,ee=_.seq2Range.endExclusive;const se=this.j(a,f,_,s,w);se.hitTimeout&&(D=!0);for(const ae of se.mappings)q.push(ae)}W(a.length-G);const T=N(q,a,f);let B=[];return n.computeMoves&&(B=this.h(T,a,f,A,R,s,w)),(0,P.$_c)(()=>{function _(se,ae){if(se.lineNumber<1||se.lineNumber>ae.length)return!1;const r=ae[se.lineNumber-1];return!(se.column<1||se.column>r.length+1)}function Q(se,ae){return!(se.startLineNumber<1||se.startLineNumber>ae.length+1||se.endLineNumberExclusive<1||se.endLineNumberExclusive>ae.length+1)}for(const se of T){if(!se.innerChanges)return!1;for(const ae of se.innerChanges)if(!(_(ae.modifiedRange.getStartPosition(),f)&&_(ae.modifiedRange.getEndPosition(),f)&&_(ae.originalRange.getStartPosition(),a)&&_(ae.originalRange.getEndPosition(),a)))return!1;if(!Q(se.modified,f)||!Q(se.original,a))return!1}return!0}),new e.$kt(T,B,D)}h(a,f,n,s,w,g,v){return(0,o.$q2)(a,f,n,s,w,g).map(y=>{const F=this.j(f,n,new c.$g2(y.original.toOffsetRange(),y.modified.toOffsetRange()),g,v),M=N(F.mappings,f,n,!0);return new e.$lt(y,M)})}j(a,f,n,s,w){const g=new m.$p2(a,n.seq1Range,w),v=new m.$p2(f,n.seq2Range,w),A=g.length+v.length<500?this.e.compute(g,v,s):this.f.compute(g,v,s);let R=A.diffs;return R=(0,E.$s2)(g,v,R),R=(0,E.$u2)(g,v,R),R=(0,E.$t2)(g,v,R),R=(0,E.$w2)(g,v,R),{mappings:R.map(F=>new L.$jt(g.translateRange(F.seq1Range),v.translateRange(F.seq2Range))),hitTimeout:A.hitTimeout}}}t.$x2=j;function N(d,a,f,n=!1){const s=[];for(const w of(0,i.$Ab)(d.map(g=>$(g,a,f)),(g,v)=>g.original.overlapOrTouch(v.original)||g.modified.overlapOrTouch(v.modified))){const g=w[0],v=w[w.length-1];s.push(new L.$it(g.original.join(v.original),g.modified.join(v.modified),w.map(A=>A.innerChanges[0])))}return(0,P.$_c)(()=>!n&&s.length>0&&(s[0].modified.startLineNumber!==s[0].original.startLineNumber||f.length-s[s.length-1].modified.endLineNumberExclusive!==a.length-s[s.length-1].original.endLineNumberExclusive)?!1:(0,P.$ad)(s,(w,g)=>g.original.startLineNumber-w.original.endLineNumberExclusive===g.modified.startLineNumber-w.modified.endLineNumberExclusive&&w.original.endLineNumberExclusive<g.original.startLineNumber&&w.modified.endLineNumberExclusive<g.modified.startLineNumber)),s}t.$y2=N;function $(d,a,f){let n=0,s=0;d.modifiedRange.endColumn===1&&d.originalRange.endColumn===1&&d.originalRange.startLineNumber+n<=d.originalRange.endLineNumber&&d.modifiedRange.startLineNumber+n<=d.modifiedRange.endLineNumber&&(s=-1),d.modifiedRange.startColumn-1>=f[d.modifiedRange.startLineNumber-1].length&&d.originalRange.startColumn-1>=a[d.originalRange.startLineNumber-1].length&&d.originalRange.startLineNumber<=d.originalRange.endLineNumber+s&&d.modifiedRange.startLineNumber<=d.modifiedRange.endLineNumber+s&&(n=1);const w=new p.$ft(d.originalRange.startLineNumber+n,d.originalRange.endLineNumber+1+s),g=new p.$ft(d.modifiedRange.startLineNumber+n,d.modifiedRange.endLineNumber+1+s);return new L.$it(w,g,[d])}t.$z2=$}),te(ne[34],re([0,1,25,33,16,7,2,13,12]),function(C,t,i,P,p,h,k,c,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nt=t.$mt=void 0;const u=3;class o{computeDiff(n,s,w){const v=new N(n,s,{maxComputationTime:w.maxComputationTimeMs,shouldIgnoreTrimWhitespace:w.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),A=[];let R=null;for(const y of v.changes){let F;y.originalEndLineNumber===0?F=new l.$ft(y.originalStartLineNumber+1,y.originalStartLineNumber+1):F=new l.$ft(y.originalStartLineNumber,y.originalEndLineNumber+1);let M;y.modifiedEndLineNumber===0?M=new l.$ft(y.modifiedStartLineNumber+1,y.modifiedStartLineNumber+1):M=new l.$ft(y.modifiedStartLineNumber,y.modifiedEndLineNumber+1);let S=new p.$it(F,M,y.charChanges?.map(D=>new p.$jt(new k.$9s(D.originalStartLineNumber,D.originalStartColumn,D.originalEndLineNumber,D.originalEndColumn),new k.$9s(D.modifiedStartLineNumber,D.modifiedStartColumn,D.modifiedEndLineNumber,D.modifiedEndColumn))));R&&(R.modified.endLineNumberExclusive===S.modified.startLineNumber||R.original.endLineNumberExclusive===S.original.startLineNumber)&&(S=new p.$it(R.original.join(S.original),R.modified.join(S.modified),R.innerChanges&&S.innerChanges?R.innerChanges.concat(S.innerChanges):void 0),A.pop()),A.push(S),R=S}return(0,c.$_c)(()=>(0,c.$ad)(A,(y,F)=>F.original.startLineNumber-y.original.endLineNumberExclusive===F.modified.startLineNumber-y.modified.endLineNumberExclusive&&y.original.endLineNumberExclusive<F.original.startLineNumber&&y.modified.endLineNumberExclusive<F.modified.startLineNumber)),new P.$kt(A,[],v.quitEarly)}}t.$mt=o;function E(f,n,s,w){return new i.$ct(f,n,s).ComputeDiff(w)}class b{constructor(n){const s=[],w=[];for(let g=0,v=n.length;g<v;g++)s[g]=$(n[g],1),w[g]=d(n[g],1);this.lines=n,this.a=s,this.b=w}getElements(){const n=[];for(let s=0,w=this.lines.length;s<w;s++)n[s]=this.lines[s].substring(this.a[s]-1,this.b[s]-1);return n}getStrictElement(n){return this.lines[n]}getStartLineNumber(n){return n+1}getEndLineNumber(n){return n+1}createCharSequence(n,s,w){const g=[],v=[],A=[];let R=0;for(let y=s;y<=w;y++){const F=this.lines[y],M=n?this.a[y]:1,S=n?this.b[y]:F.length+1;for(let D=M;D<S;D++)g[R]=F.charCodeAt(D-1),v[R]=y+1,A[R]=D,R++;!n&&y<w&&(g[R]=10,v[R]=y+1,A[R]=F.length+1,R++)}return new m(g,v,A)}}class m{constructor(n,s,w){this.a=n,this.b=s,this.d=w}toString(){return"["+this.a.map((n,s)=>(n===10?"\\n":String.fromCharCode(n))+`-(${this.b[s]},${this.d[s]})`).join(", ")+"]"}e(n,s){if(n<0||n>=s.length)throw new Error("Illegal index")}getElements(){return this.a}getStartLineNumber(n){return n>0&&n===this.b.length?this.getEndLineNumber(n-1):(this.e(n,this.b),this.b[n])}getEndLineNumber(n){return n===-1?this.getStartLineNumber(n+1):(this.e(n,this.b),this.a[n]===10?this.b[n]+1:this.b[n])}getStartColumn(n){return n>0&&n===this.d.length?this.getEndColumn(n-1):(this.e(n,this.d),this.d[n])}getEndColumn(n){return n===-1?this.getStartColumn(n+1):(this.e(n,this.d),this.a[n]===10?1:this.d[n]+1)}}class e{constructor(n,s,w,g,v,A,R,y){this.originalStartLineNumber=n,this.originalStartColumn=s,this.originalEndLineNumber=w,this.originalEndColumn=g,this.modifiedStartLineNumber=v,this.modifiedStartColumn=A,this.modifiedEndLineNumber=R,this.modifiedEndColumn=y}static createFromDiffChange(n,s,w){const g=s.getStartLineNumber(n.originalStart),v=s.getStartColumn(n.originalStart),A=s.getEndLineNumber(n.originalStart+n.originalLength-1),R=s.getEndColumn(n.originalStart+n.originalLength-1),y=w.getStartLineNumber(n.modifiedStart),F=w.getStartColumn(n.modifiedStart),M=w.getEndLineNumber(n.modifiedStart+n.modifiedLength-1),S=w.getEndColumn(n.modifiedStart+n.modifiedLength-1);return new e(g,v,A,R,y,F,M,S)}}function L(f){if(f.length<=1)return f;const n=[f[0]];let s=n[0];for(let w=1,g=f.length;w<g;w++){const v=f[w],A=v.originalStart-(s.originalStart+s.originalLength),R=v.modifiedStart-(s.modifiedStart+s.modifiedLength);Math.min(A,R)<u?(s.originalLength=v.originalStart+v.originalLength-s.originalStart,s.modifiedLength=v.modifiedStart+v.modifiedLength-s.modifiedStart):(n.push(v),s=v)}return n}class j{constructor(n,s,w,g,v){this.originalStartLineNumber=n,this.originalEndLineNumber=s,this.modifiedStartLineNumber=w,this.modifiedEndLineNumber=g,this.charChanges=v}static createFromDiffResult(n,s,w,g,v,A,R){let y,F,M,S,D;if(s.originalLength===0?(y=w.getStartLineNumber(s.originalStart)-1,F=0):(y=w.getStartLineNumber(s.originalStart),F=w.getEndLineNumber(s.originalStart+s.originalLength-1)),s.modifiedLength===0?(M=g.getStartLineNumber(s.modifiedStart)-1,S=0):(M=g.getStartLineNumber(s.modifiedStart),S=g.getEndLineNumber(s.modifiedStart+s.modifiedLength-1)),A&&s.originalLength>0&&s.originalLength<20&&s.modifiedLength>0&&s.modifiedLength<20&&v()){const q=w.createCharSequence(n,s.originalStart,s.originalStart+s.originalLength-1),W=g.createCharSequence(n,s.modifiedStart,s.modifiedStart+s.modifiedLength-1);if(q.getElements().length>0&&W.getElements().length>0){let G=E(q,W,v,!0).changes;R&&(G=L(G)),D=[];for(let ee=0,T=G.length;ee<T;ee++)D.push(e.createFromDiffChange(G[ee],q,W))}}return new j(y,F,M,S,D)}}class N{constructor(n,s,w){this.a=w.shouldComputeCharChanges,this.b=w.shouldPostProcessCharChanges,this.d=w.shouldIgnoreTrimWhitespace,this.e=w.shouldMakePrettyDiff,this.f=n,this.g=s,this.h=new b(n),this.j=new b(s),this.k=a(w.maxComputationTime),this.l=a(w.maxComputationTime===0?0:Math.min(w.maxComputationTime,5e3))}computeDiff(){if(this.h.lines.length===1&&this.h.lines[0].length===0)return this.j.lines.length===1&&this.j.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.j.lines.length,charChanges:void 0}]};if(this.j.lines.length===1&&this.j.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.h.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const n=E(this.h,this.j,this.k,this.e),s=n.changes,w=n.quitEarly;if(this.d){const R=[];for(let y=0,F=s.length;y<F;y++)R.push(j.createFromDiffResult(this.d,s[y],this.h,this.j,this.l,this.a,this.b));return{quitEarly:w,changes:R}}const g=[];let v=0,A=0;for(let R=-1,y=s.length;R<y;R++){const F=R+1<y?s[R+1]:null,M=F?F.originalStart:this.f.length,S=F?F.modifiedStart:this.g.length;for(;v<M&&A<S;){const D=this.f[v],q=this.g[A];if(D!==q){{let W=$(D,1),G=$(q,1);for(;W>1&&G>1;){const ee=D.charCodeAt(W-2),T=q.charCodeAt(G-2);if(ee!==T)break;W--,G--}(W>1||G>1)&&this.m(g,v+1,1,W,A+1,1,G)}{let W=d(D,1),G=d(q,1);const ee=D.length+1,T=q.length+1;for(;W<ee&&G<T;){const B=D.charCodeAt(W-1),_=D.charCodeAt(G-1);if(B!==_)break;W++,G++}(W<ee||G<T)&&this.m(g,v+1,W,ee,A+1,G,T)}}v++,A++}F&&(g.push(j.createFromDiffResult(this.d,F,this.h,this.j,this.l,this.a,this.b)),v+=F.originalLength,A+=F.modifiedLength)}return{quitEarly:w,changes:g}}m(n,s,w,g,v,A,R){if(this.n(n,s,w,g,v,A,R))return;let y;this.a&&(y=[new e(s,w,s,g,v,A,v,R)]),n.push(new j(s,s,v,v,y))}n(n,s,w,g,v,A,R){const y=n.length;if(y===0)return!1;const F=n[y-1];return F.originalEndLineNumber===0||F.modifiedEndLineNumber===0?!1:F.originalEndLineNumber===s&&F.modifiedEndLineNumber===v?(this.a&&F.charChanges&&F.charChanges.push(new e(s,w,s,g,v,A,v,R)),!0):F.originalEndLineNumber+1===s&&F.modifiedEndLineNumber+1===v?(F.originalEndLineNumber=s,F.modifiedEndLineNumber=v,this.a&&F.charChanges&&F.charChanges.push(new e(s,w,s,g,v,A,v,R)),!0):!1}}t.$nt=N;function $(f,n){const s=h.$$e(f);return s===-1?n:s+1}function d(f,n){const s=h.$af(f);return s===-1?n:s+2}function a(f){if(f===0)return()=>!0;const n=Date.now();return()=>Date.now()-n<f}}),te(ne[52],re([0,1,34,51]),function(C,t,i,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$A2=void 0,t.$A2={getLegacy:()=>new i.$mt,getDefault:()=>new P.$x2}}),te(ne[53],re([0,1,36]),function(C,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$B2=void 0;function P(b){const m=[];for(const e of b){const L=Number(e);(L||L===0&&e.replace(/\s/g,"")!=="")&&m.push(L)}return m}function p(b,m,e,L){return{red:b/255,blue:e/255,green:m/255,alpha:L}}function h(b,m){const e=m.index,L=m[0].length;if(!e)return;const j=b.positionAt(e);return{startLineNumber:j.lineNumber,startColumn:j.column,endLineNumber:j.lineNumber,endColumn:j.column+L}}function k(b,m){if(!b)return;const e=i.$At.Format.CSS.parseHex(m);if(e)return{range:b,color:p(e.rgba.r,e.rgba.g,e.rgba.b,e.rgba.a)}}function c(b,m,e){if(!b||m.length!==1)return;const j=m[0].values(),N=P(j);return{range:b,color:p(N[0],N[1],N[2],e?N[3]:1)}}function l(b,m,e){if(!b||m.length!==1)return;const j=m[0].values(),N=P(j),$=new i.$At(new i.$yt(N[0],N[1]/100,N[2]/100,e?N[3]:1));return{range:b,color:p($.rgba.r,$.rgba.g,$.rgba.b,$.rgba.a)}}function u(b,m){return typeof b=="string"?[...b.matchAll(m)]:b.findMatches(m)}function o(b){const m=[],L=u(b,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(L.length>0)for(const j of L){const N=j.filter(f=>f!==void 0),$=N[1],d=N[2];if(!d)continue;let a;if($==="rgb"){const f=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;a=c(h(b,j),u(d,f),!1)}else if($==="rgba"){const f=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;a=c(h(b,j),u(d,f),!0)}else if($==="hsl"){const f=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;a=l(h(b,j),u(d,f),!1)}else if($==="hsla"){const f=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;a=l(h(b,j),u(d,f),!0)}else $==="#"&&(a=k(h(b,j),$+d));a&&m.push(a)}return m}function E(b){return!b||typeof b.getValue!="function"||typeof b.positionAt!="function"?[]:o(b)}t.$B2=E}),te(ne[54],re([0,1,29]),function(C,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$b2=t.$a2=t.$_1=t.State=void 0;var P;(function(m){m[m.Invalid=0]="Invalid",m[m.Start=1]="Start",m[m.H=2]="H",m[m.HT=3]="HT",m[m.HTT=4]="HTT",m[m.HTTP=5]="HTTP",m[m.F=6]="F",m[m.FI=7]="FI",m[m.FIL=8]="FIL",m[m.BeforeColon=9]="BeforeColon",m[m.AfterColon=10]="AfterColon",m[m.AlmostThere=11]="AlmostThere",m[m.End=12]="End",m[m.Accept=13]="Accept",m[m.LastKnownState=14]="LastKnownState"})(P||(t.State=P={}));class p{constructor(e,L,j){const N=new Uint8Array(e*L);for(let $=0,d=e*L;$<d;$++)N[$]=j;this.a=N,this.rows=e,this.cols=L}get(e,L){return this.a[e*this.cols+L]}set(e,L,j){this.a[e*this.cols+L]=j}}class h{constructor(e){let L=0,j=0;for(let $=0,d=e.length;$<d;$++){const[a,f,n]=e[$];f>L&&(L=f),a>j&&(j=a),n>j&&(j=n)}L++,j++;const N=new p(j,L,0);for(let $=0,d=e.length;$<d;$++){const[a,f,n]=e[$];N.set(a,f,n)}this.a=N,this.b=L}nextState(e,L){return L<0||L>=this.b?0:this.a.get(e,L)}}t.$_1=h;let k=null;function c(){return k===null&&(k=new h([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),k}var l;(function(m){m[m.None=0]="None",m[m.ForceTermination=1]="ForceTermination",m[m.CannotEndIn=2]="CannotEndIn"})(l||(l={}));let u=null;function o(){if(u===null){u=new i.$tt(0);const m=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let L=0;L<m.length;L++)u.set(m.charCodeAt(L),1);const e=".,;:";for(let L=0;L<e.length;L++)u.set(e.charCodeAt(L),2)}return u}class E{static a(e,L,j,N,$){let d=$-1;do{const a=L.charCodeAt(d);if(e.get(a)!==2)break;d--}while(d>N);if(N>0){const a=L.charCodeAt(N-1),f=L.charCodeAt(d);(a===40&&f===41||a===91&&f===93||a===123&&f===125)&&d--}return{range:{startLineNumber:j,startColumn:N+1,endLineNumber:j,endColumn:d+2},url:L.substring(N,d+1)}}static computeLinks(e,L=c()){const j=o(),N=[];for(let $=1,d=e.getLineCount();$<=d;$++){const a=e.getLineContent($),f=a.length;let n=0,s=0,w=0,g=1,v=!1,A=!1,R=!1,y=!1;for(;n<f;){let F=!1;const M=a.charCodeAt(n);if(g===13){let S;switch(M){case 40:v=!0,S=0;break;case 41:S=v?0:1;break;case 91:R=!0,A=!0,S=0;break;case 93:R=!1,S=A?0:1;break;case 123:y=!0,S=0;break;case 125:S=y?0:1;break;case 39:case 34:case 96:w===M?S=1:w===39||w===34||w===96?S=0:S=1;break;case 42:S=w===42?1:0;break;case 124:S=w===124?1:0;break;case 32:S=R?0:1;break;default:S=j.get(M)}S===1&&(N.push(E.a(j,a,$,s,n)),F=!0)}else if(g===12){let S;M===91?(A=!0,S=0):S=j.get(M),S===1?F=!0:g=13}else g=L.nextState(g,M),g===0&&(F=!0);F&&(g=1,v=!1,A=!1,y=!1,s=n+1,w=M),n++}g===13&&N.push(E.a(j,a,$,s,f))}return N}}t.$a2=E;function b(m){return!m||typeof m.getLineCount!="function"||typeof m.getLineContent!="function"?[]:E.computeLinks(m)}t.$b2=b}),te(ne[55],re([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$c2=void 0;class i{constructor(){this.c=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}static{this.INSTANCE=new i}navigateValueSet(p,h,k,c,l){if(p&&h){const u=this.a(h,l);if(u)return{range:p,value:u}}if(k&&c){const u=this.a(c,l);if(u)return{range:k,value:u}}return null}a(p,h){const k=this.b(p,h);return k!==null?k:this.d(p,h)}b(p,h){const k=Math.pow(10,p.length-(p.lastIndexOf(".")+1));let c=Number(p);const l=parseFloat(p);return!isNaN(c)&&!isNaN(l)&&c===l?c===0&&!h?null:(c=Math.floor(c*k),c+=h?k:-k,String(c/k)):null}d(p,h){return this.e(this.c,p,h)}e(p,h,k){let c=null;for(let l=0,u=p.length;c===null&&l<u;l++)c=this.f(p[l],h,k);return c}f(p,h,k){let c=p.indexOf(h);return c>=0?(c+=k?1:-1,c<0?c=p.length-1:c%=p.length,p[c]):null}}t.$c2=i}),te(ne[56],re([0,1,14]),function(C,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uv=t.$tv=t.$sv=t.$rv=t.ModelConstants=t.PositionAffinity=t.$qv=t.TrackedRangeStickiness=t.$pv=t.$ov=t.EndOfLineSequence=t.DefaultEndOfLine=t.EndOfLinePreference=t.InjectedTextCursorStops=t.MinimapPosition=t.GlyphMarginLane=t.OverviewRulerLane=void 0;var P;(function(a){a[a.Left=1]="Left",a[a.Center=2]="Center",a[a.Right=4]="Right",a[a.Full=7]="Full"})(P||(t.OverviewRulerLane=P={}));var p;(function(a){a[a.Left=1]="Left",a[a.Center=2]="Center",a[a.Right=3]="Right"})(p||(t.GlyphMarginLane=p={}));var h;(function(a){a[a.Inline=1]="Inline",a[a.Gutter=2]="Gutter"})(h||(t.MinimapPosition=h={}));var k;(function(a){a[a.Both=0]="Both",a[a.Right=1]="Right",a[a.Left=2]="Left",a[a.None=3]="None"})(k||(t.InjectedTextCursorStops=k={}));var c;(function(a){a[a.TextDefined=0]="TextDefined",a[a.LF=1]="LF",a[a.CRLF=2]="CRLF"})(c||(t.EndOfLinePreference=c={}));var l;(function(a){a[a.LF=1]="LF",a[a.CRLF=2]="CRLF"})(l||(t.DefaultEndOfLine=l={}));var u;(function(a){a[a.LF=0]="LF",a[a.CRLF=1]="CRLF"})(u||(t.EndOfLineSequence=u={}));class o{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(f){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,f.tabSize|0),f.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,f.indentSize|0),this.a=!1),this.insertSpaces=!!f.insertSpaces,this.defaultEOL=f.defaultEOL|0,this.trimAutoWhitespace=!!f.trimAutoWhitespace,this.bracketPairColorizationOptions=f.bracketPairColorizationOptions}equals(f){return this.tabSize===f.tabSize&&this.a===f.a&&this.indentSize===f.indentSize&&this.insertSpaces===f.insertSpaces&&this.defaultEOL===f.defaultEOL&&this.trimAutoWhitespace===f.trimAutoWhitespace&&(0,i.$On)(this.bracketPairColorizationOptions,f.bracketPairColorizationOptions)}createChangeEvent(f){return{tabSize:this.tabSize!==f.tabSize,indentSize:this.indentSize!==f.indentSize,insertSpaces:this.insertSpaces!==f.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==f.trimAutoWhitespace}}}t.$ov=o;class E{constructor(f,n){this._findMatchBrand=void 0,this.range=f,this.matches=n}}t.$pv=E;var b;(function(a){a[a.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",a[a.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",a[a.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",a[a.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(b||(t.TrackedRangeStickiness=b={}));function m(a){return a&&typeof a.read=="function"}t.$qv=m;var e;(function(a){a[a.Left=0]="Left",a[a.Right=1]="Right",a[a.None=2]="None",a[a.LeftOfInjectedText=3]="LeftOfInjectedText",a[a.RightOfInjectedText=4]="RightOfInjectedText"})(e||(t.PositionAffinity=e={}));var L;(function(a){a[a.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(L||(t.ModelConstants=L={}));class j{constructor(f,n,s,w,g,v){this.identifier=f,this.range=n,this.text=s,this.forceMoveMarkers=w,this.isAutoWhitespaceEdit=g,this._isTracked=v}}t.$rv=j;class N{constructor(f,n,s){this.regex=f,this.wordSeparators=n,this.simpleSearch=s}}t.$sv=N;class ${constructor(f,n,s){this.reverseEdits=f,this.changes=n,this.trimAutoWhitespaceLineNumbers=s}}t.$tv=$;function d(a){return!a.isTooLargeForSyncing()&&!a.isForSimpleWidget}t.$uv=d}),te(ne[57],re([0,1,6,28]),function(C,t,i,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zv=t.$yv=t.$xv=void 0;class p{constructor(l){this.a=l,this.b=new Uint32Array(l.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(l,u){l=(0,P.$Re)(l);const o=this.a,E=this.b,b=u.length;return b===0?!1:(this.a=new Uint32Array(o.length+b),this.a.set(o.subarray(0,l),0),this.a.set(o.subarray(l),l+b),this.a.set(u,l),l-1<this.c[0]&&(this.c[0]=l-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(E.subarray(0,this.c[0]+1)),!0)}setValue(l,u){return l=(0,P.$Re)(l),u=(0,P.$Re)(u),this.a[l]===u?!1:(this.a[l]=u,l-1<this.c[0]&&(this.c[0]=l-1),!0)}removeValues(l,u){l=(0,P.$Re)(l),u=(0,P.$Re)(u);const o=this.a,E=this.b;if(l>=o.length)return!1;const b=o.length-l;return u>=b&&(u=b),u===0?!1:(this.a=new Uint32Array(o.length-u),this.a.set(o.subarray(0,l),0),this.a.set(o.subarray(l+u),l),this.b=new Uint32Array(this.a.length),l-1<this.c[0]&&(this.c[0]=l-1),this.c[0]>=0&&this.b.set(E.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(l){return l<0?0:(l=(0,P.$Re)(l),this.d(l))}d(l){if(l<=this.c[0])return this.b[l];let u=this.c[0]+1;u===0&&(this.b[0]=this.a[0],u++),l>=this.a.length&&(l=this.a.length-1);for(let o=u;o<=l;o++)this.b[o]=this.b[o-1]+this.a[o];return this.c[0]=Math.max(this.c[0],l),this.b[l]}getIndexOf(l){l=Math.floor(l),this.getTotalSum();let u=0,o=this.a.length-1,E=0,b=0,m=0;for(;u<=o;)if(E=u+(o-u)/2|0,b=this.b[E],m=b-this.a[E],l<m)o=E-1;else if(l>=b)u=E+1;else break;return new k(E,l-m)}}t.$xv=p;class h{constructor(l){this.a=l,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(l){return this.g(),l===0?0:this.d[l-1]}getIndexOf(l){this.g();const u=this.e[l],o=u>0?this.d[u-1]:0;return new k(u,l-o)}removeValues(l,u){this.a.splice(l,u),this.f(l)}insertValues(l,u){this.a=(0,i.$Wb)(this.a,l,u),this.f(l)}f(l){this.b=!1,this.c=Math.min(this.c,l-1)}g(){if(!this.b){for(let l=this.c+1,u=this.a.length;l<u;l++){const o=this.a[l],E=l>0?this.d[l-1]:0;this.d[l]=E+o;for(let b=0;b<o;b++)this.e[E+b]=l}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(l,u){this.a[l]!==u&&(this.a[l]=u,this.f(l))}}t.$yv=h;class k{constructor(l,u){this.index=l,this.remainder=u,this._prefixSumIndexOfResultBrand=void 0,this.index=l,this.remainder=u}}t.$zv=k}),te(ne[58],re([0,1,7,5,57]),function(C,t,i,P,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Av=void 0;class h{constructor(c,l,u,o){this.d=c,this.f=l,this.g=u,this.h=o,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(c){c.eol&&c.eol!==this.g&&(this.g=c.eol,this.j=null);const l=c.changes;for(const u of l)this.o(u.range),this.p(new P.$8s(u.range.startLineNumber,u.range.startColumn),u.text);this.h=c.versionId,this.k=null}l(){if(!this.j){const c=this.g.length,l=this.f.length,u=new Uint32Array(l);for(let o=0;o<l;o++)u[o]=this.f[o].length+c;this.j=new p.$xv(u)}}n(c,l){this.f[c]=l,this.j&&this.j.setValue(c,this.f[c].length+this.g.length)}o(c){if(c.startLineNumber===c.endLineNumber){if(c.startColumn===c.endColumn)return;this.n(c.startLineNumber-1,this.f[c.startLineNumber-1].substring(0,c.startColumn-1)+this.f[c.startLineNumber-1].substring(c.endColumn-1));return}this.n(c.startLineNumber-1,this.f[c.startLineNumber-1].substring(0,c.startColumn-1)+this.f[c.endLineNumber-1].substring(c.endColumn-1)),this.f.splice(c.startLineNumber,c.endLineNumber-c.startLineNumber),this.j&&this.j.removeValues(c.startLineNumber,c.endLineNumber-c.startLineNumber)}p(c,l){if(l.length===0)return;const u=(0,i.$9e)(l);if(u.length===1){this.n(c.lineNumber-1,this.f[c.lineNumber-1].substring(0,c.column-1)+u[0]+this.f[c.lineNumber-1].substring(c.column-1));return}u[u.length-1]+=this.f[c.lineNumber-1].substring(c.column-1),this.n(c.lineNumber-1,this.f[c.lineNumber-1].substring(0,c.column-1)+u[0]);const o=new Uint32Array(u.length-1);for(let E=1;E<u.length;E++)this.f.splice(c.lineNumber+E-1,0,u[E]),o[E-1]=u[E].length+this.g.length;this.j&&this.j.insertValues(c.lineNumber,o)}}t.$Av=h}),te(ne[59],re([0,1,7,46,5,2,56]),function(C,t,i,P,p,h,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kC=t.$jC=t.$iC=t.$hC=t.$gC=t.$fC=void 0;const c=999;class l{constructor($,d,a,f){this.searchString=$,this.isRegex=d,this.matchCase=a,this.wordSeparators=f}parseSearchRequest(){if(this.searchString==="")return null;let $;this.isRegex?$=u(this.searchString):$=this.searchString.indexOf(`
`)>=0;let d=null;try{d=i.$7e(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:$,global:!0,unicode:!0})}catch{return null}if(!d)return null;let a=!this.isRegex&&!$;return a&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(a=this.matchCase),new k.$sv(d,this.wordSeparators?(0,P.$wt)(this.wordSeparators):null,a?this.searchString:null)}}t.$fC=l;function u(N){if(!N||N.length===0)return!1;for(let $=0,d=N.length;$<d;$++){const a=N.charCodeAt($);if(a===10)return!0;if(a===92){if($++,$>=d)break;const f=N.charCodeAt($);if(f===110||f===114||f===87)return!0}}return!1}t.$gC=u;function o(N,$,d){if(!d)return new k.$pv(N,null);const a=[];for(let f=0,n=$.length;f<n;f++)a[f]=$[f];return new k.$pv(N,a)}t.$hC=o;class E{constructor($){const d=[];let a=0;for(let f=0,n=$.length;f<n;f++)$.charCodeAt(f)===10&&(d[a++]=f);this.a=d}findLineFeedCountBeforeOffset($){const d=this.a;let a=0,f=d.length-1;if(f===-1||$<=d[0])return 0;for(;a<f;){const n=a+((f-a)/2>>0);d[n]>=$?f=n-1:d[n+1]>=$?(a=n,f=n):a=n+1}return a+1}}class b{static findMatches($,d,a,f,n){const s=d.parseSearchRequest();return s?s.regex.multiline?this.b($,a,new j(s.wordSeparators,s.regex),f,n):this.c($,a,s,f,n):[]}static a($,d,a,f,n,s){let w,g=0;f?(g=f.findLineFeedCountBeforeOffset(n),w=d+n+g):w=d+n;let v;if(f){const F=f.findLineFeedCountBeforeOffset(n+s.length)-g;v=w+s.length+F}else v=w+s.length;const A=$.getPositionAt(w),R=$.getPositionAt(v);return new h.$9s(A.lineNumber,A.column,R.lineNumber,R.column)}static b($,d,a,f,n){const s=$.getOffsetAt(d.getStartPosition()),w=$.getValueInRange(d,1),g=$.getEOL()===`\r
`?new E(w):null,v=[];let A=0,R;for(a.reset(0);R=a.next(w);)if(v[A++]=o(this.a($,s,w,g,R.index,R[0]),R,f),A>=n)return v;return v}static c($,d,a,f,n){const s=[];let w=0;if(d.startLineNumber===d.endLineNumber){const v=$.getLineContent(d.startLineNumber).substring(d.startColumn-1,d.endColumn-1);return w=this.d(a,v,d.startLineNumber,d.startColumn-1,w,s,f,n),s}const g=$.getLineContent(d.startLineNumber).substring(d.startColumn-1);w=this.d(a,g,d.startLineNumber,d.startColumn-1,w,s,f,n);for(let v=d.startLineNumber+1;v<d.endLineNumber&&w<n;v++)w=this.d(a,$.getLineContent(v),v,0,w,s,f,n);if(w<n){const v=$.getLineContent(d.endLineNumber).substring(0,d.endColumn-1);w=this.d(a,v,d.endLineNumber,0,w,s,f,n)}return s}static d($,d,a,f,n,s,w,g){const v=$.wordSeparators;if(!w&&$.simpleSearch){const y=$.simpleSearch,F=y.length,M=d.length;let S=-F;for(;(S=d.indexOf(y,S+F))!==-1;)if((!v||L(v,d,M,S,F))&&(s[n++]=new k.$pv(new h.$9s(a,S+1+f,a,S+1+F+f),null),n>=g))return n;return n}const A=new j($.wordSeparators,$.regex);let R;A.reset(0);do if(R=A.next(d),R&&(s[n++]=o(new h.$9s(a,R.index+1+f,a,R.index+1+R[0].length+f),R,w),n>=g))return n;while(R);return n}static findNextMatch($,d,a,f){const n=d.parseSearchRequest();if(!n)return null;const s=new j(n.wordSeparators,n.regex);return n.regex.multiline?this.e($,a,s,f):this.f($,a,s,f)}static e($,d,a,f){const n=new p.$8s(d.lineNumber,1),s=$.getOffsetAt(n),w=$.getLineCount(),g=$.getValueInRange(new h.$9s(n.lineNumber,n.column,w,$.getLineMaxColumn(w)),1),v=$.getEOL()===`\r
`?new E(g):null;a.reset(d.column-1);const A=a.next(g);return A?o(this.a($,s,g,v,A.index,A[0]),A,f):d.lineNumber!==1||d.column!==1?this.e($,new p.$8s(1,1),a,f):null}static f($,d,a,f){const n=$.getLineCount(),s=d.lineNumber,w=$.getLineContent(s),g=this.g(a,w,s,d.column,f);if(g)return g;for(let v=1;v<=n;v++){const A=(s+v-1)%n,R=$.getLineContent(A+1),y=this.g(a,R,A+1,1,f);if(y)return y}return null}static g($,d,a,f,n){$.reset(f-1);const s=$.next(d);return s?o(new h.$9s(a,s.index+1,a,s.index+1+s[0].length),s,n):null}static findPreviousMatch($,d,a,f){const n=d.parseSearchRequest();if(!n)return null;const s=new j(n.wordSeparators,n.regex);return n.regex.multiline?this.h($,a,s,f):this.j($,a,s,f)}static h($,d,a,f){const n=this.b($,new h.$9s(1,1,d.lineNumber,d.column),a,f,10*c);if(n.length>0)return n[n.length-1];const s=$.getLineCount();return d.lineNumber!==s||d.column!==$.getLineMaxColumn(s)?this.h($,new p.$8s(s,$.getLineMaxColumn(s)),a,f):null}static j($,d,a,f){const n=$.getLineCount(),s=d.lineNumber,w=$.getLineContent(s).substring(0,d.column-1),g=this.k(a,w,s,f);if(g)return g;for(let v=1;v<=n;v++){const A=(n+s-v-1)%n,R=$.getLineContent(A+1),y=this.k(a,R,A+1,f);if(y)return y}return null}static k($,d,a,f){let n=null,s;for($.reset(0);s=$.next(d);)n=o(new h.$9s(a,s.index+1,a,s.index+1+s[0].length),s,f);return n}}t.$iC=b;function m(N,$,d,a,f){if(a===0)return!0;const n=$.charCodeAt(a-1);if(N.get(n)!==0||n===13||n===10)return!0;if(f>0){const s=$.charCodeAt(a);if(N.get(s)!==0)return!0}return!1}function e(N,$,d,a,f){if(a+f===d)return!0;const n=$.charCodeAt(a+f);if(N.get(n)!==0||n===13||n===10)return!0;if(f>0){const s=$.charCodeAt(a+f-1);if(N.get(s)!==0)return!0}return!1}function L(N,$,d,a,f){return m(N,$,d,a,f)&&e(N,$,d,a,f)}t.$jC=L;class j{constructor($,d){this._wordSeparators=$,this.a=d,this.b=-1,this.c=0}reset($){this.a.lastIndex=$,this.b=-1,this.c=0}next($){const d=$.length;let a;do{if(this.b+this.c===d||(a=this.a.exec($),!a))return null;const f=a.index,n=a[0].length;if(f===this.b&&n===this.c){if(n===0){i.$qf($,d,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=f,this.c=n,!this._wordSeparators||L(this._wordSeparators,$,d,f,n))return a}while(a);return null}}t.$kC=j}),te(ne[60],re([0,1,2,59,7,13,30]),function(C,t,i,P,p,h,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnicodeHighlighterReasonKind=t.$$1=void 0;class c{static computeUnicodeHighlights(e,L,j){const N=j?j.startLineNumber:1,$=j?j.endLineNumber:e.getLineCount(),d=new o(L),a=d.getCandidateCodePoints();let f;a==="allNonBasicAscii"?f=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):f=new RegExp(`${l(Array.from(a))}`,"g");const n=new P.$kC(null,f),s=[];let w=!1,g,v=0,A=0,R=0;e:for(let y=N,F=$;y<=F;y++){const M=e.getLineContent(y),S=M.length;n.reset(0);do if(g=n.next(M),g){let D=g.index,q=g.index+g[0].length;if(D>0){const T=M.charCodeAt(D-1);p.$nf(T)&&D--}if(q+1<S){const T=M.charCodeAt(q-1);p.$nf(T)&&q++}const W=M.substring(D,q);let G=(0,k.$Ls)(D+1,k.$Is,M,0);G&&G.endColumn<=D+1&&(G=null);const ee=d.shouldHighlightNonBasicASCII(W,G?G.word:null);if(ee!==0){if(ee===3?v++:ee===2?A++:ee===1?R++:(0,h.$9c)(ee),s.length>=1e3){w=!0;break e}s.push(new i.$9s(y,D+1,y,q+1))}}while(g)}return{ranges:s,hasMore:w,ambiguousCharacterCount:v,invisibleCharacterCount:A,nonBasicAsciiCharacterCount:R}}static computeUnicodeHighlightReason(e,L){const j=new o(L);switch(j.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const $=e.codePointAt(0),d=j.ambiguousCharacters.getPrimaryConfusable($),a=p.$Qf.getLocales().filter(f=>!p.$Qf.getInstance(new Set([...L.allowedLocales,f])).isAmbiguous($));return{kind:0,confusableWith:String.fromCodePoint(d),notAmbiguousInLocales:a}}case 1:return{kind:2}}}}t.$$1=c;function l(m,e){return`[${p.$Xe(m.map(j=>String.fromCodePoint(j)).join(""))}]`}var u;(function(m){m[m.Ambiguous=0]="Ambiguous",m[m.Invisible=1]="Invisible",m[m.NonBasicAscii=2]="NonBasicAscii"})(u||(t.UnicodeHighlighterReasonKind=u={}));class o{constructor(e){this.b=e,this.a=new Set(e.allowedCodePoints),this.ambiguousCharacters=p.$Qf.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.b.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.b.invisibleCharacters)for(const L of p.$Rf.codePoints)E(String.fromCodePoint(L))||e.add(L);if(this.b.ambiguousCharacters)for(const L of this.ambiguousCharacters.getConfusableCodePoints())e.add(L);for(const L of this.a)e.delete(L);return e}shouldHighlightNonBasicASCII(e,L){const j=e.codePointAt(0);if(this.a.has(j))return 0;if(this.b.nonBasicASCII)return 1;let N=!1,$=!1;if(L)for(const d of L){const a=d.codePointAt(0),f=p.$yf(d);N=N||f,!f&&!this.ambiguousCharacters.isAmbiguous(a)&&!p.$Rf.isInvisibleCharacter(a)&&($=!0)}return!N&&$?0:this.b.invisibleCharacters&&!E(e)&&p.$Rf.isInvisibleCharacter(j)?2:this.b.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(j)?3:0}}function E(m){return m===" "||m===`
`||m==="	"}var b;(function(m){m[m.None=0]="None",m[m.NonBasicASCII=1]="NonBasicASCII",m[m.Invisible=2]="Invisible",m[m.Ambiguous=3]="Ambiguous"})(b||(b={}))}),te(ne[61],re([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.ShowLightbulbIconMode=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.PositionAffinity=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.NewSymbolNameTag=t.MouseTargetType=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineEditTriggerKind=t.InlineCompletionTriggerKind=t.InlayHintKind=t.InjectedTextCursorStops=t.IndentAction=t.GlyphMarginLane=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.CodeActionTriggerType=t.AccessibilitySupport=void 0;var i;(function(r){r[r.Unknown=0]="Unknown",r[r.Disabled=1]="Disabled",r[r.Enabled=2]="Enabled"})(i||(t.AccessibilitySupport=i={}));var P;(function(r){r[r.Invoke=1]="Invoke",r[r.Auto=2]="Auto"})(P||(t.CodeActionTriggerType=P={}));var p;(function(r){r[r.None=0]="None",r[r.KeepWhitespace=1]="KeepWhitespace",r[r.InsertAsSnippet=4]="InsertAsSnippet"})(p||(t.CompletionItemInsertTextRule=p={}));var h;(function(r){r[r.Method=0]="Method",r[r.Function=1]="Function",r[r.Constructor=2]="Constructor",r[r.Field=3]="Field",r[r.Variable=4]="Variable",r[r.Class=5]="Class",r[r.Struct=6]="Struct",r[r.Interface=7]="Interface",r[r.Module=8]="Module",r[r.Property=9]="Property",r[r.Event=10]="Event",r[r.Operator=11]="Operator",r[r.Unit=12]="Unit",r[r.Value=13]="Value",r[r.Constant=14]="Constant",r[r.Enum=15]="Enum",r[r.EnumMember=16]="EnumMember",r[r.Keyword=17]="Keyword",r[r.Text=18]="Text",r[r.Color=19]="Color",r[r.File=20]="File",r[r.Reference=21]="Reference",r[r.Customcolor=22]="Customcolor",r[r.Folder=23]="Folder",r[r.TypeParameter=24]="TypeParameter",r[r.User=25]="User",r[r.Issue=26]="Issue",r[r.Snippet=27]="Snippet"})(h||(t.CompletionItemKind=h={}));var k;(function(r){r[r.Deprecated=1]="Deprecated"})(k||(t.CompletionItemTag=k={}));var c;(function(r){r[r.Invoke=0]="Invoke",r[r.TriggerCharacter=1]="TriggerCharacter",r[r.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(c||(t.CompletionTriggerKind=c={}));var l;(function(r){r[r.EXACT=0]="EXACT",r[r.ABOVE=1]="ABOVE",r[r.BELOW=2]="BELOW"})(l||(t.ContentWidgetPositionPreference=l={}));var u;(function(r){r[r.NotSet=0]="NotSet",r[r.ContentFlush=1]="ContentFlush",r[r.RecoverFromMarkers=2]="RecoverFromMarkers",r[r.Explicit=3]="Explicit",r[r.Paste=4]="Paste",r[r.Undo=5]="Undo",r[r.Redo=6]="Redo"})(u||(t.CursorChangeReason=u={}));var o;(function(r){r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(o||(t.DefaultEndOfLine=o={}));var E;(function(r){r[r.Text=0]="Text",r[r.Read=1]="Read",r[r.Write=2]="Write"})(E||(t.DocumentHighlightKind=E={}));var b;(function(r){r[r.None=0]="None",r[r.Keep=1]="Keep",r[r.Brackets=2]="Brackets",r[r.Advanced=3]="Advanced",r[r.Full=4]="Full"})(b||(t.EditorAutoIndentStrategy=b={}));var m;(function(r){r[r.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",r[r.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",r[r.accessibilitySupport=2]="accessibilitySupport",r[r.accessibilityPageSize=3]="accessibilityPageSize",r[r.ariaLabel=4]="ariaLabel",r[r.ariaRequired=5]="ariaRequired",r[r.autoClosingBrackets=6]="autoClosingBrackets",r[r.autoClosingComments=7]="autoClosingComments",r[r.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",r[r.autoClosingDelete=9]="autoClosingDelete",r[r.autoClosingOvertype=10]="autoClosingOvertype",r[r.autoClosingQuotes=11]="autoClosingQuotes",r[r.autoIndent=12]="autoIndent",r[r.automaticLayout=13]="automaticLayout",r[r.autoSurround=14]="autoSurround",r[r.bracketPairColorization=15]="bracketPairColorization",r[r.guides=16]="guides",r[r.codeLens=17]="codeLens",r[r.codeLensFontFamily=18]="codeLensFontFamily",r[r.codeLensFontSize=19]="codeLensFontSize",r[r.colorDecorators=20]="colorDecorators",r[r.colorDecoratorsLimit=21]="colorDecoratorsLimit",r[r.columnSelection=22]="columnSelection",r[r.comments=23]="comments",r[r.contextmenu=24]="contextmenu",r[r.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",r[r.cursorBlinking=26]="cursorBlinking",r[r.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",r[r.cursorStyle=28]="cursorStyle",r[r.cursorSurroundingLines=29]="cursorSurroundingLines",r[r.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",r[r.cursorWidth=31]="cursorWidth",r[r.disableLayerHinting=32]="disableLayerHinting",r[r.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",r[r.domReadOnly=34]="domReadOnly",r[r.dragAndDrop=35]="dragAndDrop",r[r.dropIntoEditor=36]="dropIntoEditor",r[r.emptySelectionClipboard=37]="emptySelectionClipboard",r[r.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",r[r.extraEditorClassName=39]="extraEditorClassName",r[r.fastScrollSensitivity=40]="fastScrollSensitivity",r[r.find=41]="find",r[r.fixedOverflowWidgets=42]="fixedOverflowWidgets",r[r.folding=43]="folding",r[r.foldingStrategy=44]="foldingStrategy",r[r.foldingHighlight=45]="foldingHighlight",r[r.foldingImportsByDefault=46]="foldingImportsByDefault",r[r.foldingMaximumRegions=47]="foldingMaximumRegions",r[r.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",r[r.fontFamily=49]="fontFamily",r[r.fontInfo=50]="fontInfo",r[r.fontLigatures=51]="fontLigatures",r[r.fontSize=52]="fontSize",r[r.fontWeight=53]="fontWeight",r[r.fontVariations=54]="fontVariations",r[r.formatOnPaste=55]="formatOnPaste",r[r.formatOnType=56]="formatOnType",r[r.glyphMargin=57]="glyphMargin",r[r.gotoLocation=58]="gotoLocation",r[r.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",r[r.hover=60]="hover",r[r.inDiffEditor=61]="inDiffEditor",r[r.inlineSuggest=62]="inlineSuggest",r[r.inlineEdit=63]="inlineEdit",r[r.letterSpacing=64]="letterSpacing",r[r.lightbulb=65]="lightbulb",r[r.lineDecorationsWidth=66]="lineDecorationsWidth",r[r.lineHeight=67]="lineHeight",r[r.lineNumbers=68]="lineNumbers",r[r.lineNumbersMinChars=69]="lineNumbersMinChars",r[r.linkedEditing=70]="linkedEditing",r[r.links=71]="links",r[r.matchBrackets=72]="matchBrackets",r[r.minimap=73]="minimap",r[r.mouseStyle=74]="mouseStyle",r[r.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",r[r.mouseWheelZoom=76]="mouseWheelZoom",r[r.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",r[r.multiCursorModifier=78]="multiCursorModifier",r[r.multiCursorPaste=79]="multiCursorPaste",r[r.multiCursorLimit=80]="multiCursorLimit",r[r.occurrencesHighlight=81]="occurrencesHighlight",r[r.overviewRulerBorder=82]="overviewRulerBorder",r[r.overviewRulerLanes=83]="overviewRulerLanes",r[r.padding=84]="padding",r[r.pasteAs=85]="pasteAs",r[r.parameterHints=86]="parameterHints",r[r.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",r[r.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",r[r.quickSuggestions=89]="quickSuggestions",r[r.quickSuggestionsDelay=90]="quickSuggestionsDelay",r[r.readOnly=91]="readOnly",r[r.readOnlyMessage=92]="readOnlyMessage",r[r.renameOnType=93]="renameOnType",r[r.renderControlCharacters=94]="renderControlCharacters",r[r.renderFinalNewline=95]="renderFinalNewline",r[r.renderLineHighlight=96]="renderLineHighlight",r[r.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",r[r.renderValidationDecorations=98]="renderValidationDecorations",r[r.renderWhitespace=99]="renderWhitespace",r[r.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",r[r.roundedSelection=101]="roundedSelection",r[r.rulers=102]="rulers",r[r.scrollbar=103]="scrollbar",r[r.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",r[r.scrollBeyondLastLine=105]="scrollBeyondLastLine",r[r.scrollPredominantAxis=106]="scrollPredominantAxis",r[r.selectionClipboard=107]="selectionClipboard",r[r.selectionHighlight=108]="selectionHighlight",r[r.selectOnLineNumbers=109]="selectOnLineNumbers",r[r.showFoldingControls=110]="showFoldingControls",r[r.showUnused=111]="showUnused",r[r.snippetSuggestions=112]="snippetSuggestions",r[r.smartSelect=113]="smartSelect",r[r.smoothScrolling=114]="smoothScrolling",r[r.stickyScroll=115]="stickyScroll",r[r.stickyTabStops=116]="stickyTabStops",r[r.stopRenderingLineAfter=117]="stopRenderingLineAfter",r[r.suggest=118]="suggest",r[r.suggestFontSize=119]="suggestFontSize",r[r.suggestLineHeight=120]="suggestLineHeight",r[r.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",r[r.suggestSelection=122]="suggestSelection",r[r.tabCompletion=123]="tabCompletion",r[r.tabIndex=124]="tabIndex",r[r.unicodeHighlighting=125]="unicodeHighlighting",r[r.unusualLineTerminators=126]="unusualLineTerminators",r[r.useShadowDOM=127]="useShadowDOM",r[r.useTabStops=128]="useTabStops",r[r.wordBreak=129]="wordBreak",r[r.wordSeparators=130]="wordSeparators",r[r.wordWrap=131]="wordWrap",r[r.wordWrapBreakAfterCharacters=132]="wordWrapBreakAfterCharacters",r[r.wordWrapBreakBeforeCharacters=133]="wordWrapBreakBeforeCharacters",r[r.wordWrapColumn=134]="wordWrapColumn",r[r.wordWrapOverride1=135]="wordWrapOverride1",r[r.wordWrapOverride2=136]="wordWrapOverride2",r[r.wrappingIndent=137]="wrappingIndent",r[r.wrappingStrategy=138]="wrappingStrategy",r[r.showDeprecated=139]="showDeprecated",r[r.inlayHints=140]="inlayHints",r[r.editorClassName=141]="editorClassName",r[r.pixelRatio=142]="pixelRatio",r[r.tabFocusMode=143]="tabFocusMode",r[r.layoutInfo=144]="layoutInfo",r[r.wrappingInfo=145]="wrappingInfo",r[r.defaultColorDecorators=146]="defaultColorDecorators",r[r.colorDecoratorsActivatedOn=147]="colorDecoratorsActivatedOn",r[r.inlineCompletionsAccessibilityVerbose=148]="inlineCompletionsAccessibilityVerbose"})(m||(t.EditorOption=m={}));var e;(function(r){r[r.TextDefined=0]="TextDefined",r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(e||(t.EndOfLinePreference=e={}));var L;(function(r){r[r.LF=0]="LF",r[r.CRLF=1]="CRLF"})(L||(t.EndOfLineSequence=L={}));var j;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=3]="Right"})(j||(t.GlyphMarginLane=j={}));var N;(function(r){r[r.None=0]="None",r[r.Indent=1]="Indent",r[r.IndentOutdent=2]="IndentOutdent",r[r.Outdent=3]="Outdent"})(N||(t.IndentAction=N={}));var $;(function(r){r[r.Both=0]="Both",r[r.Right=1]="Right",r[r.Left=2]="Left",r[r.None=3]="None"})($||(t.InjectedTextCursorStops=$={}));var d;(function(r){r[r.Type=1]="Type",r[r.Parameter=2]="Parameter"})(d||(t.InlayHintKind=d={}));var a;(function(r){r[r.Automatic=0]="Automatic",r[r.Explicit=1]="Explicit"})(a||(t.InlineCompletionTriggerKind=a={}));var f;(function(r){r[r.Invoke=0]="Invoke",r[r.Automatic=1]="Automatic"})(f||(t.InlineEditTriggerKind=f={}));var n;(function(r){r[r.DependsOnKbLayout=-1]="DependsOnKbLayout",r[r.Unknown=0]="Unknown",r[r.Backspace=1]="Backspace",r[r.Tab=2]="Tab",r[r.Enter=3]="Enter",r[r.Shift=4]="Shift",r[r.Ctrl=5]="Ctrl",r[r.Alt=6]="Alt",r[r.PauseBreak=7]="PauseBreak",r[r.CapsLock=8]="CapsLock",r[r.Escape=9]="Escape",r[r.Space=10]="Space",r[r.PageUp=11]="PageUp",r[r.PageDown=12]="PageDown",r[r.End=13]="End",r[r.Home=14]="Home",r[r.LeftArrow=15]="LeftArrow",r[r.UpArrow=16]="UpArrow",r[r.RightArrow=17]="RightArrow",r[r.DownArrow=18]="DownArrow",r[r.Insert=19]="Insert",r[r.Delete=20]="Delete",r[r.Digit0=21]="Digit0",r[r.Digit1=22]="Digit1",r[r.Digit2=23]="Digit2",r[r.Digit3=24]="Digit3",r[r.Digit4=25]="Digit4",r[r.Digit5=26]="Digit5",r[r.Digit6=27]="Digit6",r[r.Digit7=28]="Digit7",r[r.Digit8=29]="Digit8",r[r.Digit9=30]="Digit9",r[r.KeyA=31]="KeyA",r[r.KeyB=32]="KeyB",r[r.KeyC=33]="KeyC",r[r.KeyD=34]="KeyD",r[r.KeyE=35]="KeyE",r[r.KeyF=36]="KeyF",r[r.KeyG=37]="KeyG",r[r.KeyH=38]="KeyH",r[r.KeyI=39]="KeyI",r[r.KeyJ=40]="KeyJ",r[r.KeyK=41]="KeyK",r[r.KeyL=42]="KeyL",r[r.KeyM=43]="KeyM",r[r.KeyN=44]="KeyN",r[r.KeyO=45]="KeyO",r[r.KeyP=46]="KeyP",r[r.KeyQ=47]="KeyQ",r[r.KeyR=48]="KeyR",r[r.KeyS=49]="KeyS",r[r.KeyT=50]="KeyT",r[r.KeyU=51]="KeyU",r[r.KeyV=52]="KeyV",r[r.KeyW=53]="KeyW",r[r.KeyX=54]="KeyX",r[r.KeyY=55]="KeyY",r[r.KeyZ=56]="KeyZ",r[r.Meta=57]="Meta",r[r.ContextMenu=58]="ContextMenu",r[r.F1=59]="F1",r[r.F2=60]="F2",r[r.F3=61]="F3",r[r.F4=62]="F4",r[r.F5=63]="F5",r[r.F6=64]="F6",r[r.F7=65]="F7",r[r.F8=66]="F8",r[r.F9=67]="F9",r[r.F10=68]="F10",r[r.F11=69]="F11",r[r.F12=70]="F12",r[r.F13=71]="F13",r[r.F14=72]="F14",r[r.F15=73]="F15",r[r.F16=74]="F16",r[r.F17=75]="F17",r[r.F18=76]="F18",r[r.F19=77]="F19",r[r.F20=78]="F20",r[r.F21=79]="F21",r[r.F22=80]="F22",r[r.F23=81]="F23",r[r.F24=82]="F24",r[r.NumLock=83]="NumLock",r[r.ScrollLock=84]="ScrollLock",r[r.Semicolon=85]="Semicolon",r[r.Equal=86]="Equal",r[r.Comma=87]="Comma",r[r.Minus=88]="Minus",r[r.Period=89]="Period",r[r.Slash=90]="Slash",r[r.Backquote=91]="Backquote",r[r.BracketLeft=92]="BracketLeft",r[r.Backslash=93]="Backslash",r[r.BracketRight=94]="BracketRight",r[r.Quote=95]="Quote",r[r.OEM_8=96]="OEM_8",r[r.IntlBackslash=97]="IntlBackslash",r[r.Numpad0=98]="Numpad0",r[r.Numpad1=99]="Numpad1",r[r.Numpad2=100]="Numpad2",r[r.Numpad3=101]="Numpad3",r[r.Numpad4=102]="Numpad4",r[r.Numpad5=103]="Numpad5",r[r.Numpad6=104]="Numpad6",r[r.Numpad7=105]="Numpad7",r[r.Numpad8=106]="Numpad8",r[r.Numpad9=107]="Numpad9",r[r.NumpadMultiply=108]="NumpadMultiply",r[r.NumpadAdd=109]="NumpadAdd",r[r.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",r[r.NumpadSubtract=111]="NumpadSubtract",r[r.NumpadDecimal=112]="NumpadDecimal",r[r.NumpadDivide=113]="NumpadDivide",r[r.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",r[r.ABNT_C1=115]="ABNT_C1",r[r.ABNT_C2=116]="ABNT_C2",r[r.AudioVolumeMute=117]="AudioVolumeMute",r[r.AudioVolumeUp=118]="AudioVolumeUp",r[r.AudioVolumeDown=119]="AudioVolumeDown",r[r.BrowserSearch=120]="BrowserSearch",r[r.BrowserHome=121]="BrowserHome",r[r.BrowserBack=122]="BrowserBack",r[r.BrowserForward=123]="BrowserForward",r[r.MediaTrackNext=124]="MediaTrackNext",r[r.MediaTrackPrevious=125]="MediaTrackPrevious",r[r.MediaStop=126]="MediaStop",r[r.MediaPlayPause=127]="MediaPlayPause",r[r.LaunchMediaPlayer=128]="LaunchMediaPlayer",r[r.LaunchMail=129]="LaunchMail",r[r.LaunchApp2=130]="LaunchApp2",r[r.Clear=131]="Clear",r[r.MAX_VALUE=132]="MAX_VALUE"})(n||(t.KeyCode=n={}));var s;(function(r){r[r.Hint=1]="Hint",r[r.Info=2]="Info",r[r.Warning=4]="Warning",r[r.Error=8]="Error"})(s||(t.MarkerSeverity=s={}));var w;(function(r){r[r.Unnecessary=1]="Unnecessary",r[r.Deprecated=2]="Deprecated"})(w||(t.MarkerTag=w={}));var g;(function(r){r[r.Inline=1]="Inline",r[r.Gutter=2]="Gutter"})(g||(t.MinimapPosition=g={}));var v;(function(r){r[r.UNKNOWN=0]="UNKNOWN",r[r.TEXTAREA=1]="TEXTAREA",r[r.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",r[r.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",r[r.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",r[r.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",r[r.CONTENT_TEXT=6]="CONTENT_TEXT",r[r.CONTENT_EMPTY=7]="CONTENT_EMPTY",r[r.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",r[r.CONTENT_WIDGET=9]="CONTENT_WIDGET",r[r.OVERVIEW_RULER=10]="OVERVIEW_RULER",r[r.SCROLLBAR=11]="SCROLLBAR",r[r.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",r[r.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(v||(t.MouseTargetType=v={}));var A;(function(r){r[r.AIGenerated=1]="AIGenerated"})(A||(t.NewSymbolNameTag=A={}));var R;(function(r){r[r.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",r[r.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",r[r.TOP_CENTER=2]="TOP_CENTER"})(R||(t.OverlayWidgetPositionPreference=R={}));var y;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=4]="Right",r[r.Full=7]="Full"})(y||(t.OverviewRulerLane=y={}));var F;(function(r){r[r.Left=0]="Left",r[r.Right=1]="Right",r[r.None=2]="None",r[r.LeftOfInjectedText=3]="LeftOfInjectedText",r[r.RightOfInjectedText=4]="RightOfInjectedText"})(F||(t.PositionAffinity=F={}));var M;(function(r){r[r.Off=0]="Off",r[r.On=1]="On",r[r.Relative=2]="Relative",r[r.Interval=3]="Interval",r[r.Custom=4]="Custom"})(M||(t.RenderLineNumbersType=M={}));var S;(function(r){r[r.None=0]="None",r[r.Text=1]="Text",r[r.Blocks=2]="Blocks"})(S||(t.RenderMinimap=S={}));var D;(function(r){r[r.Smooth=0]="Smooth",r[r.Immediate=1]="Immediate"})(D||(t.ScrollType=D={}));var q;(function(r){r[r.Auto=1]="Auto",r[r.Hidden=2]="Hidden",r[r.Visible=3]="Visible"})(q||(t.ScrollbarVisibility=q={}));var W;(function(r){r[r.LTR=0]="LTR",r[r.RTL=1]="RTL"})(W||(t.SelectionDirection=W={}));var G;(function(r){r.Off="off",r.OnCode="onCode",r.On="on"})(G||(t.ShowLightbulbIconMode=G={}));var ee;(function(r){r[r.Invoke=1]="Invoke",r[r.TriggerCharacter=2]="TriggerCharacter",r[r.ContentChange=3]="ContentChange"})(ee||(t.SignatureHelpTriggerKind=ee={}));var T;(function(r){r[r.File=0]="File",r[r.Module=1]="Module",r[r.Namespace=2]="Namespace",r[r.Package=3]="Package",r[r.Class=4]="Class",r[r.Method=5]="Method",r[r.Property=6]="Property",r[r.Field=7]="Field",r[r.Constructor=8]="Constructor",r[r.Enum=9]="Enum",r[r.Interface=10]="Interface",r[r.Function=11]="Function",r[r.Variable=12]="Variable",r[r.Constant=13]="Constant",r[r.String=14]="String",r[r.Number=15]="Number",r[r.Boolean=16]="Boolean",r[r.Array=17]="Array",r[r.Object=18]="Object",r[r.Key=19]="Key",r[r.Null=20]="Null",r[r.EnumMember=21]="EnumMember",r[r.Struct=22]="Struct",r[r.Event=23]="Event",r[r.Operator=24]="Operator",r[r.TypeParameter=25]="TypeParameter"})(T||(t.SymbolKind=T={}));var B;(function(r){r[r.Deprecated=1]="Deprecated"})(B||(t.SymbolTag=B={}));var _;(function(r){r[r.Hidden=0]="Hidden",r[r.Blink=1]="Blink",r[r.Smooth=2]="Smooth",r[r.Phase=3]="Phase",r[r.Expand=4]="Expand",r[r.Solid=5]="Solid"})(_||(t.TextEditorCursorBlinkingStyle=_={}));var Q;(function(r){r[r.Line=1]="Line",r[r.Block=2]="Block",r[r.Underline=3]="Underline",r[r.LineThin=4]="LineThin",r[r.BlockOutline=5]="BlockOutline",r[r.UnderlineThin=6]="UnderlineThin"})(Q||(t.TextEditorCursorStyle=Q={}));var se;(function(r){r[r.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",r[r.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",r[r.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",r[r.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(se||(t.TrackedRangeStickiness=se={}));var ae;(function(r){r[r.None=0]="None",r[r.Same=1]="Same",r[r.Indent=2]="Indent",r[r.DeepIndent=3]="DeepIndent"})(ae||(t.WrappingIndent=ae={}))}),te(ne[62],re([0,1,11,10]),function(C,t,i,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ht=void 0;class p{constructor(){this.a=new Map,this.b=new Map,this.c=new i.$5d,this.onDidChange=this.c.event,this.d=null}handleChange(c){this.c.fire({changedLanguages:c,changedColorMap:!1})}register(c,l){return this.a.set(c,l),this.handleChange([c]),(0,P.$Rc)(()=>{this.a.get(c)===l&&(this.a.delete(c),this.handleChange([c]))})}get(c){return this.a.get(c)||null}registerFactory(c,l){this.b.get(c)?.dispose();const u=new h(this,c,l);return this.b.set(c,u),(0,P.$Rc)(()=>{const o=this.b.get(c);!o||o!==u||(this.b.delete(c),o.dispose())})}async getOrCreate(c){const l=this.get(c);if(l)return l;const u=this.b.get(c);return!u||u.isResolved?null:(await u.resolve(),this.get(c))}isResolved(c){if(this.get(c))return!0;const u=this.b.get(c);return!!(!u||u.isResolved)}setColorMap(c){this.d=c,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}t.$Ht=p;class h extends P.$Tc{get isResolved(){return this.c}constructor(c,l,u){super(),this.f=c,this.g=l,this.h=u,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const c=await this.h.tokenizationSupport;this.c=!0,c&&!this.a&&this.B(this.f.register(this.g,c))}}}),te(ne[63],re([64,65]),function(C,t){return C.create("vs/base/common/platform",t)}),te(ne[17],re([0,1,63]),function(C,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$J=t.$I=t.$H=t.$G=t.$F=t.$E=t.$D=t.OS=t.OperatingSystem=t.$B=t.$A=t.$z=t.$y=t.$x=t.Language=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.$h=t.Platform=t.$g=void 0,t.$g="en";let P=!1,p=!1,h=!1,k=!1,c=!1,l=!1,u=!1,o=!1,E=!1,b=!1,m,e=t.$g,L=t.$g,j,N;const $=globalThis;let d;typeof $.vscode<"u"&&typeof $.vscode.process<"u"?d=$.vscode.process:typeof process<"u"&&(d=process);const a=typeof d?.versions?.electron=="string",f=a&&d?.type==="renderer";if(typeof d=="object"){P=d.platform==="win32",p=d.platform==="darwin",h=d.platform==="linux",k=h&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,u=a,E=!!d.env.CI||!!d.env.BUILD_ARTIFACTSTAGINGDIRECTORY,m=t.$g,e=t.$g;const M=d.env.VSCODE_NLS_CONFIG;if(M)try{const S=JSON.parse(M),D=S.availableLanguages["*"];m=S.locale,L=S.osLocale,e=D||t.$g,j=S._translationsConfigFile}catch{}c=!0}else typeof navigator=="object"&&!f?(N=navigator.userAgent,P=N.indexOf("Windows")>=0,p=N.indexOf("Macintosh")>=0,o=(N.indexOf("Macintosh")>=0||N.indexOf("iPad")>=0||N.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,h=N.indexOf("Linux")>=0,b=N?.indexOf("Mobi")>=0,l=!0,m=i.getConfiguredDefaultLocale(i.localize(0,null))||t.$g,e=m,L=navigator.language):console.error("Unable to resolve platform.");var n;(function(M){M[M.Web=0]="Web",M[M.Mac=1]="Mac",M[M.Linux=2]="Linux",M[M.Windows=3]="Windows"})(n||(t.Platform=n={}));function s(M){switch(M){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.$h=s;let w=0;p?w=1:P?w=3:h&&(w=2),t.$i=P,t.$j=p,t.$k=h,t.$l=k,t.$m=c,t.$n=u,t.$o=l,t.$p=l&&typeof $.importScripts=="function",t.$q=t.$p?$.origin:void 0,t.$r=o,t.$s=b,t.$t=E,t.$u=w,t.$v=N,t.$w=e;var g;(function(M){function S(){return t.$w}M.value=S;function D(){return t.$w.length===2?t.$w==="en":t.$w.length>=3?t.$w[0]==="e"&&t.$w[1]==="n"&&t.$w[2]==="-":!1}M.isDefaultVariant=D;function q(){return t.$w==="en"}M.isDefault=q})(g||(t.Language=g={})),t.$x=m,t.$y=L,t.$z=j,t.$A=typeof $.postMessage=="function"&&!$.importScripts,t.$B=(()=>{if(t.$A){const M=[];$.addEventListener("message",D=>{if(D.data&&D.data.vscodeScheduleAsyncWork)for(let q=0,W=M.length;q<W;q++){const G=M[q];if(G.id===D.data.vscodeScheduleAsyncWork){M.splice(q,1),G.callback();return}}});let S=0;return D=>{const q=++S;M.push({id:q,callback:D}),$.postMessage({vscodeScheduleAsyncWork:q},"*")}}return M=>setTimeout(M)})();var v;(function(M){M[M.Windows=1]="Windows",M[M.Macintosh=2]="Macintosh",M[M.Linux=3]="Linux"})(v||(t.OperatingSystem=v={})),t.OS=p||o?2:P?1:3;let A=!0,R=!1;function y(){if(!R){R=!0;const M=new Uint8Array(2);M[0]=1,M[1]=2,A=new Uint16Array(M.buffer)[0]===513}return A}t.$D=y,t.$E=!!(t.$v&&t.$v.indexOf("Chrome")>=0),t.$F=!!(t.$v&&t.$v.indexOf("Firefox")>=0),t.$G=!!(!t.$E&&t.$v&&t.$v.indexOf("Safari")>=0),t.$H=!!(t.$v&&t.$v.indexOf("Edg/")>=0),t.$I=!!(t.$v&&t.$v.indexOf("Android")>=0);function F(M){return parseFloat(M)>=20}t.$J=F}),te(ne[66],re([0,1,17]),function(C,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ec=t.$dc=t.env=t.cwd=void 0;let P;const p=globalThis.vscode;if(typeof p<"u"&&typeof p.process<"u"){const h=p.process;P={get platform(){return h.platform},get arch(){return h.arch},get env(){return h.env},cwd(){return h.cwd()}}}else typeof process<"u"?P={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:P={get platform(){return i.$i?"win32":i.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=P.cwd,t.env=P.env,t.$dc=P.platform,t.$ec=P.arch}),te(ne[67],re([0,1,66]),function(C,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tc=t.sep=t.$rc=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=t.$fc=void 0;const P=65,p=97,h=90,k=122,c=46,l=47,u=92,o=58,E=63;class b extends Error{constructor(s,w,g){let v;typeof w=="string"&&w.indexOf("not ")===0?(v="must not be",w=w.replace(/^not /,"")):v="must be";const A=s.indexOf(".")!==-1?"property":"argument";let R=`The "${s}" ${A} ${v} of type ${w}`;R+=`. Received type ${typeof g}`,super(R),this.code="ERR_INVALID_ARG_TYPE"}}function m(n,s){if(n===null||typeof n!="object")throw new b(s,"Object",n)}function e(n,s){if(typeof n!="string")throw new b(s,"string",n)}const L=i.$dc==="win32";function j(n){return n===l||n===u}function N(n){return n===l}function $(n){return n>=P&&n<=h||n>=p&&n<=k}function d(n,s,w,g){let v="",A=0,R=-1,y=0,F=0;for(let M=0;M<=n.length;++M){if(M<n.length)F=n.charCodeAt(M);else{if(g(F))break;F=l}if(g(F)){if(!(R===M-1||y===1))if(y===2){if(v.length<2||A!==2||v.charCodeAt(v.length-1)!==c||v.charCodeAt(v.length-2)!==c){if(v.length>2){const S=v.lastIndexOf(w);S===-1?(v="",A=0):(v=v.slice(0,S),A=v.length-1-v.lastIndexOf(w)),R=M,y=0;continue}else if(v.length!==0){v="",A=0,R=M,y=0;continue}}s&&(v+=v.length>0?`${w}..`:"..",A=2)}else v.length>0?v+=`${w}${n.slice(R+1,M)}`:v=n.slice(R+1,M),A=M-R-1;R=M,y=0}else F===c&&y!==-1?++y:y=-1}return v}function a(n,s){m(s,"pathObject");const w=s.dir||s.root,g=s.base||`${s.name||""}${s.ext||""}`;return w?w===s.root?`${w}${g}`:`${w}${n}${g}`:g}t.$fc={resolve(...n){let s="",w="",g=!1;for(let v=n.length-1;v>=-1;v--){let A;if(v>=0){if(A=n[v],e(A,"path"),A.length===0)continue}else s.length===0?A=i.cwd():(A=i.env[`=${s}`]||i.cwd(),(A===void 0||A.slice(0,2).toLowerCase()!==s.toLowerCase()&&A.charCodeAt(2)===u)&&(A=`${s}\\`));const R=A.length;let y=0,F="",M=!1;const S=A.charCodeAt(0);if(R===1)j(S)&&(y=1,M=!0);else if(j(S))if(M=!0,j(A.charCodeAt(1))){let D=2,q=D;for(;D<R&&!j(A.charCodeAt(D));)D++;if(D<R&&D!==q){const W=A.slice(q,D);for(q=D;D<R&&j(A.charCodeAt(D));)D++;if(D<R&&D!==q){for(q=D;D<R&&!j(A.charCodeAt(D));)D++;(D===R||D!==q)&&(F=`\\\\${W}\\${A.slice(q,D)}`,y=D)}}}else y=1;else $(S)&&A.charCodeAt(1)===o&&(F=A.slice(0,2),y=2,R>2&&j(A.charCodeAt(2))&&(M=!0,y=3));if(F.length>0)if(s.length>0){if(F.toLowerCase()!==s.toLowerCase())continue}else s=F;if(g){if(s.length>0)break}else if(w=`${A.slice(y)}\\${w}`,g=M,M&&s.length>0)break}return w=d(w,!g,"\\",j),g?`${s}\\${w}`:`${s}${w}`||"."},normalize(n){e(n,"path");const s=n.length;if(s===0)return".";let w=0,g,v=!1;const A=n.charCodeAt(0);if(s===1)return N(A)?"\\":n;if(j(A))if(v=!0,j(n.charCodeAt(1))){let y=2,F=y;for(;y<s&&!j(n.charCodeAt(y));)y++;if(y<s&&y!==F){const M=n.slice(F,y);for(F=y;y<s&&j(n.charCodeAt(y));)y++;if(y<s&&y!==F){for(F=y;y<s&&!j(n.charCodeAt(y));)y++;if(y===s)return`\\\\${M}\\${n.slice(F)}\\`;y!==F&&(g=`\\\\${M}\\${n.slice(F,y)}`,w=y)}}}else w=1;else $(A)&&n.charCodeAt(1)===o&&(g=n.slice(0,2),w=2,s>2&&j(n.charCodeAt(2))&&(v=!0,w=3));let R=w<s?d(n.slice(w),!v,"\\",j):"";return R.length===0&&!v&&(R="."),R.length>0&&j(n.charCodeAt(s-1))&&(R+="\\"),g===void 0?v?`\\${R}`:R:v?`${g}\\${R}`:`${g}${R}`},isAbsolute(n){e(n,"path");const s=n.length;if(s===0)return!1;const w=n.charCodeAt(0);return j(w)||s>2&&$(w)&&n.charCodeAt(1)===o&&j(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let s,w;for(let A=0;A<n.length;++A){const R=n[A];e(R,"path"),R.length>0&&(s===void 0?s=w=R:s+=`\\${R}`)}if(s===void 0)return".";let g=!0,v=0;if(typeof w=="string"&&j(w.charCodeAt(0))){++v;const A=w.length;A>1&&j(w.charCodeAt(1))&&(++v,A>2&&(j(w.charCodeAt(2))?++v:g=!1))}if(g){for(;v<s.length&&j(s.charCodeAt(v));)v++;v>=2&&(s=`\\${s.slice(v)}`)}return t.$fc.normalize(s)},relative(n,s){if(e(n,"from"),e(s,"to"),n===s)return"";const w=t.$fc.resolve(n),g=t.$fc.resolve(s);if(w===g||(n=w.toLowerCase(),s=g.toLowerCase(),n===s))return"";let v=0;for(;v<n.length&&n.charCodeAt(v)===u;)v++;let A=n.length;for(;A-1>v&&n.charCodeAt(A-1)===u;)A--;const R=A-v;let y=0;for(;y<s.length&&s.charCodeAt(y)===u;)y++;let F=s.length;for(;F-1>y&&s.charCodeAt(F-1)===u;)F--;const M=F-y,S=R<M?R:M;let D=-1,q=0;for(;q<S;q++){const G=n.charCodeAt(v+q);if(G!==s.charCodeAt(y+q))break;G===u&&(D=q)}if(q!==S){if(D===-1)return g}else{if(M>S){if(s.charCodeAt(y+q)===u)return g.slice(y+q+1);if(q===2)return g.slice(y+q)}R>S&&(n.charCodeAt(v+q)===u?D=q:q===2&&(D=3)),D===-1&&(D=0)}let W="";for(q=v+D+1;q<=A;++q)(q===A||n.charCodeAt(q)===u)&&(W+=W.length===0?"..":"\\..");return y+=D,W.length>0?`${W}${g.slice(y,F)}`:(g.charCodeAt(y)===u&&++y,g.slice(y,F))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const s=t.$fc.resolve(n);if(s.length<=2)return n;if(s.charCodeAt(0)===u){if(s.charCodeAt(1)===u){const w=s.charCodeAt(2);if(w!==E&&w!==c)return`\\\\?\\UNC\\${s.slice(2)}`}}else if($(s.charCodeAt(0))&&s.charCodeAt(1)===o&&s.charCodeAt(2)===u)return`\\\\?\\${s}`;return n},dirname(n){e(n,"path");const s=n.length;if(s===0)return".";let w=-1,g=0;const v=n.charCodeAt(0);if(s===1)return j(v)?n:".";if(j(v)){if(w=g=1,j(n.charCodeAt(1))){let y=2,F=y;for(;y<s&&!j(n.charCodeAt(y));)y++;if(y<s&&y!==F){for(F=y;y<s&&j(n.charCodeAt(y));)y++;if(y<s&&y!==F){for(F=y;y<s&&!j(n.charCodeAt(y));)y++;if(y===s)return n;y!==F&&(w=g=y+1)}}}}else $(v)&&n.charCodeAt(1)===o&&(w=s>2&&j(n.charCodeAt(2))?3:2,g=w);let A=-1,R=!0;for(let y=s-1;y>=g;--y)if(j(n.charCodeAt(y))){if(!R){A=y;break}}else R=!1;if(A===-1){if(w===-1)return".";A=w}return n.slice(0,A)},basename(n,s){s!==void 0&&e(s,"ext"),e(n,"path");let w=0,g=-1,v=!0,A;if(n.length>=2&&$(n.charCodeAt(0))&&n.charCodeAt(1)===o&&(w=2),s!==void 0&&s.length>0&&s.length<=n.length){if(s===n)return"";let R=s.length-1,y=-1;for(A=n.length-1;A>=w;--A){const F=n.charCodeAt(A);if(j(F)){if(!v){w=A+1;break}}else y===-1&&(v=!1,y=A+1),R>=0&&(F===s.charCodeAt(R)?--R===-1&&(g=A):(R=-1,g=y))}return w===g?g=y:g===-1&&(g=n.length),n.slice(w,g)}for(A=n.length-1;A>=w;--A)if(j(n.charCodeAt(A))){if(!v){w=A+1;break}}else g===-1&&(v=!1,g=A+1);return g===-1?"":n.slice(w,g)},extname(n){e(n,"path");let s=0,w=-1,g=0,v=-1,A=!0,R=0;n.length>=2&&n.charCodeAt(1)===o&&$(n.charCodeAt(0))&&(s=g=2);for(let y=n.length-1;y>=s;--y){const F=n.charCodeAt(y);if(j(F)){if(!A){g=y+1;break}continue}v===-1&&(A=!1,v=y+1),F===c?w===-1?w=y:R!==1&&(R=1):w!==-1&&(R=-1)}return w===-1||v===-1||R===0||R===1&&w===v-1&&w===g+1?"":n.slice(w,v)},format:a.bind(null,"\\"),parse(n){e(n,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return s;const w=n.length;let g=0,v=n.charCodeAt(0);if(w===1)return j(v)?(s.root=s.dir=n,s):(s.base=s.name=n,s);if(j(v)){if(g=1,j(n.charCodeAt(1))){let D=2,q=D;for(;D<w&&!j(n.charCodeAt(D));)D++;if(D<w&&D!==q){for(q=D;D<w&&j(n.charCodeAt(D));)D++;if(D<w&&D!==q){for(q=D;D<w&&!j(n.charCodeAt(D));)D++;D===w?g=D:D!==q&&(g=D+1)}}}}else if($(v)&&n.charCodeAt(1)===o){if(w<=2)return s.root=s.dir=n,s;if(g=2,j(n.charCodeAt(2))){if(w===3)return s.root=s.dir=n,s;g=3}}g>0&&(s.root=n.slice(0,g));let A=-1,R=g,y=-1,F=!0,M=n.length-1,S=0;for(;M>=g;--M){if(v=n.charCodeAt(M),j(v)){if(!F){R=M+1;break}continue}y===-1&&(F=!1,y=M+1),v===c?A===-1?A=M:S!==1&&(S=1):A!==-1&&(S=-1)}return y!==-1&&(A===-1||S===0||S===1&&A===y-1&&A===R+1?s.base=s.name=n.slice(R,y):(s.name=n.slice(R,A),s.base=n.slice(R,y),s.ext=n.slice(A,y))),R>0&&R!==g?s.dir=n.slice(0,R-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const f=(()=>{if(L){const n=/\\/g;return()=>{const s=i.cwd().replace(n,"/");return s.slice(s.indexOf("/"))}}return()=>i.cwd()})();t.$gc={resolve(...n){let s="",w=!1;for(let g=n.length-1;g>=-1&&!w;g--){const v=g>=0?n[g]:f();e(v,"path"),v.length!==0&&(s=`${v}/${s}`,w=v.charCodeAt(0)===l)}return s=d(s,!w,"/",N),w?`/${s}`:s.length>0?s:"."},normalize(n){if(e(n,"path"),n.length===0)return".";const s=n.charCodeAt(0)===l,w=n.charCodeAt(n.length-1)===l;return n=d(n,!s,"/",N),n.length===0?s?"/":w?"./":".":(w&&(n+="/"),s?`/${n}`:n)},isAbsolute(n){return e(n,"path"),n.length>0&&n.charCodeAt(0)===l},join(...n){if(n.length===0)return".";let s;for(let w=0;w<n.length;++w){const g=n[w];e(g,"path"),g.length>0&&(s===void 0?s=g:s+=`/${g}`)}return s===void 0?".":t.$gc.normalize(s)},relative(n,s){if(e(n,"from"),e(s,"to"),n===s||(n=t.$gc.resolve(n),s=t.$gc.resolve(s),n===s))return"";const w=1,g=n.length,v=g-w,A=1,R=s.length-A,y=v<R?v:R;let F=-1,M=0;for(;M<y;M++){const D=n.charCodeAt(w+M);if(D!==s.charCodeAt(A+M))break;D===l&&(F=M)}if(M===y)if(R>y){if(s.charCodeAt(A+M)===l)return s.slice(A+M+1);if(M===0)return s.slice(A+M)}else v>y&&(n.charCodeAt(w+M)===l?F=M:M===0&&(F=0));let S="";for(M=w+F+1;M<=g;++M)(M===g||n.charCodeAt(M)===l)&&(S+=S.length===0?"..":"/..");return`${S}${s.slice(A+F)}`},toNamespacedPath(n){return n},dirname(n){if(e(n,"path"),n.length===0)return".";const s=n.charCodeAt(0)===l;let w=-1,g=!0;for(let v=n.length-1;v>=1;--v)if(n.charCodeAt(v)===l){if(!g){w=v;break}}else g=!1;return w===-1?s?"/":".":s&&w===1?"//":n.slice(0,w)},basename(n,s){s!==void 0&&e(s,"ext"),e(n,"path");let w=0,g=-1,v=!0,A;if(s!==void 0&&s.length>0&&s.length<=n.length){if(s===n)return"";let R=s.length-1,y=-1;for(A=n.length-1;A>=0;--A){const F=n.charCodeAt(A);if(F===l){if(!v){w=A+1;break}}else y===-1&&(v=!1,y=A+1),R>=0&&(F===s.charCodeAt(R)?--R===-1&&(g=A):(R=-1,g=y))}return w===g?g=y:g===-1&&(g=n.length),n.slice(w,g)}for(A=n.length-1;A>=0;--A)if(n.charCodeAt(A)===l){if(!v){w=A+1;break}}else g===-1&&(v=!1,g=A+1);return g===-1?"":n.slice(w,g)},extname(n){e(n,"path");let s=-1,w=0,g=-1,v=!0,A=0;for(let R=n.length-1;R>=0;--R){const y=n.charCodeAt(R);if(y===l){if(!v){w=R+1;break}continue}g===-1&&(v=!1,g=R+1),y===c?s===-1?s=R:A!==1&&(A=1):s!==-1&&(A=-1)}return s===-1||g===-1||A===0||A===1&&s===g-1&&s===w+1?"":n.slice(s,g)},format:a.bind(null,"/"),parse(n){e(n,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return s;const w=n.charCodeAt(0)===l;let g;w?(s.root="/",g=1):g=0;let v=-1,A=0,R=-1,y=!0,F=n.length-1,M=0;for(;F>=g;--F){const S=n.charCodeAt(F);if(S===l){if(!y){A=F+1;break}continue}R===-1&&(y=!1,R=F+1),S===c?v===-1?v=F:M!==1&&(M=1):v!==-1&&(M=-1)}if(R!==-1){const S=A===0&&w?1:A;v===-1||M===0||M===1&&v===R-1&&v===A+1?s.base=s.name=n.slice(S,R):(s.name=n.slice(S,v),s.base=n.slice(S,R),s.ext=n.slice(v,R))}return A>0?s.dir=n.slice(0,A-1):w&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},t.$gc.win32=t.$fc.win32=t.$fc,t.$gc.posix=t.$fc.posix=t.$gc,t.$hc=L?t.$fc.normalize:t.$gc.normalize,t.$ic=L?t.$fc.isAbsolute:t.$gc.isAbsolute,t.$jc=L?t.$fc.join:t.$gc.join,t.$kc=L?t.$fc.resolve:t.$gc.resolve,t.$lc=L?t.$fc.relative:t.$gc.relative,t.$mc=L?t.$fc.dirname:t.$gc.dirname,t.$nc=L?t.$fc.basename:t.$gc.basename,t.$oc=L?t.$fc.extname:t.$gc.extname,t.$pc=L?t.$fc.format:t.$gc.format,t.$qc=L?t.$fc.parse:t.$gc.parse,t.$rc=L?t.$fc.toNamespacedPath:t.$gc.toNamespacedPath,t.sep=L?t.$fc.sep:t.$gc.sep,t.$tc=L?t.$fc.delimiter:t.$gc.delimiter}),te(ne[18],re([0,1,67,17]),function(C,t,i,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wc=t.$vc=t.URI=void 0;const p=/^\w[\w\d+.-]*$/,h=/^\//,k=/^\/\//;function c(g,v){if(!g.scheme&&v)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${g.authority}", path: "${g.path}", query: "${g.query}", fragment: "${g.fragment}"}`);if(g.scheme&&!p.test(g.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(g.path){if(g.authority){if(!h.test(g.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(g.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function l(g,v){return!g&&!v?"file":g}function u(g,v){switch(g){case"https":case"http":case"file":v?v[0]!==E&&(v=E+v):v=E;break}return v}const o="",E="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{static isUri(v){return v instanceof m?!0:v?typeof v.authority=="string"&&typeof v.fragment=="string"&&typeof v.path=="string"&&typeof v.query=="string"&&typeof v.scheme=="string"&&typeof v.fsPath=="string"&&typeof v.with=="function"&&typeof v.toString=="function":!1}constructor(v,A,R,y,F,M=!1){typeof v=="object"?(this.scheme=v.scheme||o,this.authority=v.authority||o,this.path=v.path||o,this.query=v.query||o,this.fragment=v.fragment||o):(this.scheme=l(v,M),this.authority=A||o,this.path=u(this.scheme,R||o),this.query=y||o,this.fragment=F||o,c(this,M))}get fsPath(){return a(this,!1)}with(v){if(!v)return this;let{scheme:A,authority:R,path:y,query:F,fragment:M}=v;return A===void 0?A=this.scheme:A===null&&(A=o),R===void 0?R=this.authority:R===null&&(R=o),y===void 0?y=this.path:y===null&&(y=o),F===void 0?F=this.query:F===null&&(F=o),M===void 0?M=this.fragment:M===null&&(M=o),A===this.scheme&&R===this.authority&&y===this.path&&F===this.query&&M===this.fragment?this:new j(A,R,y,F,M)}static parse(v,A=!1){const R=b.exec(v);return R?new j(R[2]||o,w(R[4]||o),w(R[5]||o),w(R[7]||o),w(R[9]||o),A):new j(o,o,o,o,o)}static file(v){let A=o;if(P.$i&&(v=v.replace(/\\/g,E)),v[0]===E&&v[1]===E){const R=v.indexOf(E,2);R===-1?(A=v.substring(2),v=E):(A=v.substring(2,R),v=v.substring(R)||E)}return new j("file",A,v,o,o)}static from(v,A){return new j(v.scheme,v.authority,v.path,v.query,v.fragment,A)}static joinPath(v,...A){if(!v.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let R;return P.$i&&v.scheme==="file"?R=m.file(i.$fc.join(a(v,!0),...A)).path:R=i.$gc.join(v.path,...A),v.with({path:R})}toString(v=!1){return f(this,v)}toJSON(){return this}static revive(v){if(v){if(v instanceof m)return v;{const A=new j(v);return A._formatted=v.external??null,A._fsPath=v._sep===L?v.fsPath??null:null,A}}else return v}}t.URI=m;function e(g){return!g||typeof g!="object"?!1:typeof g.scheme=="string"&&(typeof g.authority=="string"||typeof g.authority>"u")&&(typeof g.path=="string"||typeof g.path>"u")&&(typeof g.query=="string"||typeof g.query>"u")&&(typeof g.fragment=="string"||typeof g.fragment>"u")}t.$vc=e;const L=P.$i?1:void 0;class j extends m{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=a(this,!1)),this._fsPath}toString(v=!1){return v?f(this,!0):(this._formatted||(this._formatted=f(this,!1)),this._formatted)}toJSON(){const v={$mid:1};return this._fsPath&&(v.fsPath=this._fsPath,v._sep=L),this._formatted&&(v.external=this._formatted),this.path&&(v.path=this.path),this.scheme&&(v.scheme=this.scheme),this.authority&&(v.authority=this.authority),this.query&&(v.query=this.query),this.fragment&&(v.fragment=this.fragment),v}}const N={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function $(g,v,A){let R,y=-1;for(let F=0;F<g.length;F++){const M=g.charCodeAt(F);if(M>=97&&M<=122||M>=65&&M<=90||M>=48&&M<=57||M===45||M===46||M===95||M===126||v&&M===47||A&&M===91||A&&M===93||A&&M===58)y!==-1&&(R+=encodeURIComponent(g.substring(y,F)),y=-1),R!==void 0&&(R+=g.charAt(F));else{R===void 0&&(R=g.substr(0,F));const S=N[M];S!==void 0?(y!==-1&&(R+=encodeURIComponent(g.substring(y,F)),y=-1),R+=S):y===-1&&(y=F)}}return y!==-1&&(R+=encodeURIComponent(g.substring(y))),R!==void 0?R:g}function d(g){let v;for(let A=0;A<g.length;A++){const R=g.charCodeAt(A);R===35||R===63?(v===void 0&&(v=g.substr(0,A)),v+=N[R]):v!==void 0&&(v+=g[A])}return v!==void 0?v:g}function a(g,v){let A;return g.authority&&g.path.length>1&&g.scheme==="file"?A=`//${g.authority}${g.path}`:g.path.charCodeAt(0)===47&&(g.path.charCodeAt(1)>=65&&g.path.charCodeAt(1)<=90||g.path.charCodeAt(1)>=97&&g.path.charCodeAt(1)<=122)&&g.path.charCodeAt(2)===58?v?A=g.path.substr(1):A=g.path[1].toLowerCase()+g.path.substr(2):A=g.path,P.$i&&(A=A.replace(/\//g,"\\")),A}t.$wc=a;function f(g,v){const A=v?d:$;let R="",{scheme:y,authority:F,path:M,query:S,fragment:D}=g;if(y&&(R+=y,R+=":"),(F||y==="file")&&(R+=E,R+=E),F){let q=F.indexOf("@");if(q!==-1){const W=F.substr(0,q);F=F.substr(q+1),q=W.lastIndexOf(":"),q===-1?R+=A(W,!1,!1):(R+=A(W.substr(0,q),!1,!1),R+=":",R+=A(W.substr(q+1),!1,!0)),R+="@"}F=F.toLowerCase(),q=F.lastIndexOf(":"),q===-1?R+=A(F,!1,!0):(R+=A(F.substr(0,q),!1,!0),R+=F.substr(q))}if(M){if(M.length>=3&&M.charCodeAt(0)===47&&M.charCodeAt(2)===58){const q=M.charCodeAt(1);q>=65&&q<=90&&(M=`/${String.fromCharCode(q+32)}:${M.substr(3)}`)}else if(M.length>=2&&M.charCodeAt(1)===58){const q=M.charCodeAt(0);q>=65&&q<=90&&(M=`${String.fromCharCode(q+32)}:${M.substr(2)}`)}R+=A(M,!0,!1)}return S&&(R+="?",R+=A(S,!1,!1)),D&&(R+="#",R+=v?D:$(D,!1,!1)),R}function n(g){try{return decodeURIComponent(g)}catch{return g.length>3?g.substr(0,3)+n(g.substr(3)):g}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function w(g){return g.match(s)?g.replace(s,v=>n(v)):g}}),te(ne[72],re([0,1,3,11,10,14,17,7]),function(C,t,i,P,p,h,k,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.SimpleWorkerServer=t.SimpleWorkerClient=t.logOnceWebWorkerWarning=void 0;const l="$initialize";let u=!1;function o(w){k.$o&&(u||(u=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(w.message))}t.logOnceWebWorkerWarning=o;var E;(function(w){w[w.Request=0]="Request",w[w.Reply=1]="Reply",w[w.SubscribeEvent=2]="SubscribeEvent",w[w.Event=3]="Event",w[w.UnsubscribeEvent=4]="UnsubscribeEvent"})(E||(E={}));class b{constructor(g,v,A,R){this.vsWorker=g,this.req=v,this.method=A,this.args=R,this.type=0}}class m{constructor(g,v,A,R){this.vsWorker=g,this.seq=v,this.res=A,this.err=R,this.type=1}}class e{constructor(g,v,A,R){this.vsWorker=g,this.req=v,this.eventName=A,this.arg=R,this.type=2}}class L{constructor(g,v,A){this.vsWorker=g,this.req=v,this.event=A,this.type=3}}class j{constructor(g,v){this.vsWorker=g,this.req=v,this.type=4}}class N{constructor(g){this.a=-1,this.g=g,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(g){this.a=g}sendMessage(g,v){const A=String(++this.b);return new Promise((R,y)=>{this.c[A]={resolve:R,reject:y},this.o(new b(this.a,A,g,v))})}listen(g,v){let A=null;const R=new P.$5d({onWillAddFirstListener:()=>{A=String(++this.b),this.d.set(A,R),this.o(new e(this.a,A,g,v))},onDidRemoveLastListener:()=>{this.d.delete(A),this.o(new j(this.a,A)),A=null}});return R.event}handleMessage(g){!g||!g.vsWorker||this.a!==-1&&g.vsWorker!==this.a||this.h(g)}h(g){switch(g.type){case 1:return this.j(g);case 0:return this.k(g);case 2:return this.l(g);case 3:return this.m(g);case 4:return this.n(g)}}j(g){if(!this.c[g.seq]){console.warn("Got reply to unknown seq");return}const v=this.c[g.seq];if(delete this.c[g.seq],g.err){let A=g.err;g.err.$isError&&(A=new Error,A.name=g.err.name,A.message=g.err.message,A.stack=g.err.stack),v.reject(A);return}v.resolve(g.res)}k(g){const v=g.req;this.g.handleMessage(g.method,g.args).then(R=>{this.o(new m(this.a,v,R,void 0))},R=>{R.detail instanceof Error&&(R.detail=(0,i.$3)(R.detail)),this.o(new m(this.a,v,void 0,(0,i.$3)(R)))})}l(g){const v=g.req,A=this.g.handleEvent(g.eventName,g.arg)(R=>{this.o(new L(this.a,v,R))});this.f.set(v,A)}m(g){if(!this.d.has(g.req)){console.warn("Got event for unknown req");return}this.d.get(g.req).fire(g.event)}n(g){if(!this.f.has(g.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get(g.req).dispose(),this.f.delete(g.req)}o(g){const v=[];if(g.type===0)for(let A=0;A<g.args.length;A++)g.args[A]instanceof ArrayBuffer&&v.push(g.args[A]);else g.type===1&&g.res instanceof ArrayBuffer&&v.push(g.res);this.g.sendMessage(g,v)}}class $ extends p.$Tc{constructor(g,v,A){super();let R=null;this.a=this.B(g.create("vs/base/common/worker/simpleWorker",q=>{this.c.handleMessage(q)},q=>{R?.(q)})),this.c=new N({sendMessage:(q,W)=>{this.a.postMessage(q,W)},handleMessage:(q,W)=>{if(typeof A[q]!="function")return Promise.reject(new Error("Missing method "+q+" on main thread host."));try{return Promise.resolve(A[q].apply(A,W))}catch(G){return Promise.reject(G)}},handleEvent:(q,W)=>{if(a(q)){const G=A[q].call(A,W);if(typeof G!="function")throw new Error(`Missing dynamic event ${q} on main thread host.`);return G}if(d(q)){const G=A[q];if(typeof G!="function")throw new Error(`Missing event ${q} on main thread host.`);return G}throw new Error(`Malformed event name ${q}`)}}),this.c.setWorkerId(this.a.getId());let y=null;const F=globalThis.require;typeof F<"u"&&typeof F.getConfig=="function"?y=F.getConfig():typeof globalThis.requirejs<"u"&&(y=globalThis.requirejs.s.contexts._.config);const M=(0,h.$Un)(A);this.b=this.c.sendMessage(l,[this.a.getId(),JSON.parse(JSON.stringify(y)),v,M]);const S=(q,W)=>this.g(q,W),D=(q,W)=>this.c.listen(q,W);this.f=new Promise((q,W)=>{R=W,this.b.then(G=>{q(f(G,S,D))},G=>{W(G),this.h("Worker failed to load "+v,G)})})}getProxyObject(){return this.f}g(g,v){return new Promise((A,R)=>{this.b.then(()=>{this.c.sendMessage(g,v).then(A,R)},R)})}h(g,v){console.error(g),console.info(v)}}t.SimpleWorkerClient=$;function d(w){return w[0]==="o"&&w[1]==="n"&&c.$if(w.charCodeAt(2))}function a(w){return/^onDynamic/.test(w)&&c.$if(w.charCodeAt(9))}function f(w,g,v){const A=F=>function(){const M=Array.prototype.slice.call(arguments,0);return g(F,M)},R=F=>function(M){return v(F,M)},y={};for(const F of w){if(a(F)){y[F]=R(F);continue}if(d(F)){y[F]=v(F,void 0);continue}y[F]=A(F)}return y}class n{constructor(g,v){this.a=v,this.b=null,this.c=new N({sendMessage:(A,R)=>{g(A,R)},handleMessage:(A,R)=>this.d(A,R),handleEvent:(A,R)=>this.f(A,R)})}onmessage(g){this.c.handleMessage(g)}d(g,v){if(g===l)return this.g(v[0],v[1],v[2],v[3]);if(!this.b||typeof this.b[g]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+g));try{return Promise.resolve(this.b[g].apply(this.b,v))}catch(A){return Promise.reject(A)}}f(g,v){if(!this.b)throw new Error("Missing requestHandler");if(a(g)){const A=this.b[g].call(this.b,v);if(typeof A!="function")throw new Error(`Missing dynamic event ${g} on request handler.`);return A}if(d(g)){const A=this.b[g];if(typeof A!="function")throw new Error(`Missing event ${g} on request handler.`);return A}throw new Error(`Malformed event name ${g}`)}g(g,v,A,R){this.c.setWorkerId(g);const M=f(R,(S,D)=>this.c.sendMessage(S,D),(S,D)=>this.c.listen(S,D));return this.a?(this.b=this.a(M),Promise.resolve((0,h.$Un)(this.b))):(v&&(typeof v.baseUrl<"u"&&delete v.baseUrl,typeof v.paths<"u"&&typeof v.paths.vs<"u"&&delete v.paths.vs,typeof v.trustedTypesPolicy<"u"&&delete v.trustedTypesPolicy,v.catchError=!0,globalThis.require.config(v)),new Promise((S,D)=>{(globalThis.require||C)([A],W=>{if(this.b=W.create(M),!this.b){D(new Error("No RequestHandler!"));return}S((0,h.$Un)(this.b))},D)}))}}t.SimpleWorkerServer=n;function s(w){return new n(w,null)}t.create=s}),te(ne[68],re([64,65]),function(C,t){return C.create("vs/editor/common/languages",t)}),te(ne[69],re([0,1,43,18,44,2,62,68]),function(C,t,i,P,p,h,k,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InlineEditTriggerKind=t.ExternalUriOpenerPriority=t.$2t=t.$1t=t.InlayHintKind=t.CommentState=t.CommentMode=t.CommentThreadState=t.CommentThreadCollapsibleState=t.Command=t.NewSymbolNameTag=t.$Zt=t.$Yt=t.SymbolKinds=t.SymbolTag=t.$Xt=t.$Wt=t.SymbolKind=t.$Vt=t.DocumentHighlightKind=t.SignatureHelpTriggerKind=t.CodeActionTriggerType=t.$Ut=t.InlineCompletionTriggerKind=t.CompletionTriggerKind=t.CompletionItemInsertTextRule=t.CompletionItemTag=t.CompletionItemKinds=t.CompletionItemKind=t.$Tt=t.$St=t.$Rt=void 0;class l{constructor(B,_,Q){this.offset=B,this.type=_,this.language=Q,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}t.$Rt=l;class u{constructor(B,_){this.tokens=B,this.endState=_,this._tokenizationResultBrand=void 0}}t.$St=u;class o{constructor(B,_){this.tokens=B,this.endState=_,this._encodedTokenizationResultBrand=void 0}}t.$Tt=o;var E;(function(T){T[T.Method=0]="Method",T[T.Function=1]="Function",T[T.Constructor=2]="Constructor",T[T.Field=3]="Field",T[T.Variable=4]="Variable",T[T.Class=5]="Class",T[T.Struct=6]="Struct",T[T.Interface=7]="Interface",T[T.Module=8]="Module",T[T.Property=9]="Property",T[T.Event=10]="Event",T[T.Operator=11]="Operator",T[T.Unit=12]="Unit",T[T.Value=13]="Value",T[T.Constant=14]="Constant",T[T.Enum=15]="Enum",T[T.EnumMember=16]="EnumMember",T[T.Keyword=17]="Keyword",T[T.Text=18]="Text",T[T.Color=19]="Color",T[T.File=20]="File",T[T.Reference=21]="Reference",T[T.Customcolor=22]="Customcolor",T[T.Folder=23]="Folder",T[T.TypeParameter=24]="TypeParameter",T[T.User=25]="User",T[T.Issue=26]="Issue",T[T.Snippet=27]="Snippet"})(E||(t.CompletionItemKind=E={}));var b;(function(T){const B=new Map;B.set(0,i.$ok.symbolMethod),B.set(1,i.$ok.symbolFunction),B.set(2,i.$ok.symbolConstructor),B.set(3,i.$ok.symbolField),B.set(4,i.$ok.symbolVariable),B.set(5,i.$ok.symbolClass),B.set(6,i.$ok.symbolStruct),B.set(7,i.$ok.symbolInterface),B.set(8,i.$ok.symbolModule),B.set(9,i.$ok.symbolProperty),B.set(10,i.$ok.symbolEvent),B.set(11,i.$ok.symbolOperator),B.set(12,i.$ok.symbolUnit),B.set(13,i.$ok.symbolValue),B.set(15,i.$ok.symbolEnum),B.set(14,i.$ok.symbolConstant),B.set(15,i.$ok.symbolEnum),B.set(16,i.$ok.symbolEnumMember),B.set(17,i.$ok.symbolKeyword),B.set(27,i.$ok.symbolSnippet),B.set(18,i.$ok.symbolText),B.set(19,i.$ok.symbolColor),B.set(20,i.$ok.symbolFile),B.set(21,i.$ok.symbolReference),B.set(22,i.$ok.symbolCustomColor),B.set(23,i.$ok.symbolFolder),B.set(24,i.$ok.symbolTypeParameter),B.set(25,i.$ok.account),B.set(26,i.$ok.issues);function _(ae){let r=B.get(ae);return r||(console.info("No codicon found for CompletionItemKind "+ae),r=i.$ok.symbolProperty),r}T.toIcon=_;const Q=new Map;Q.set("method",0),Q.set("function",1),Q.set("constructor",2),Q.set("field",3),Q.set("variable",4),Q.set("class",5),Q.set("struct",6),Q.set("interface",7),Q.set("module",8),Q.set("property",9),Q.set("event",10),Q.set("operator",11),Q.set("unit",12),Q.set("value",13),Q.set("constant",14),Q.set("enum",15),Q.set("enum-member",16),Q.set("enumMember",16),Q.set("keyword",17),Q.set("snippet",27),Q.set("text",18),Q.set("color",19),Q.set("file",20),Q.set("reference",21),Q.set("customcolor",22),Q.set("folder",23),Q.set("type-parameter",24),Q.set("typeParameter",24),Q.set("account",25),Q.set("issue",26);function se(ae,r){let ge=Q.get(ae);return typeof ge>"u"&&!r&&(ge=9),ge}T.fromString=se})(b||(t.CompletionItemKinds=b={}));var m;(function(T){T[T.Deprecated=1]="Deprecated"})(m||(t.CompletionItemTag=m={}));var e;(function(T){T[T.None=0]="None",T[T.KeepWhitespace=1]="KeepWhitespace",T[T.InsertAsSnippet=4]="InsertAsSnippet"})(e||(t.CompletionItemInsertTextRule=e={}));var L;(function(T){T[T.Invoke=0]="Invoke",T[T.TriggerCharacter=1]="TriggerCharacter",T[T.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(L||(t.CompletionTriggerKind=L={}));var j;(function(T){T[T.Automatic=0]="Automatic",T[T.Explicit=1]="Explicit"})(j||(t.InlineCompletionTriggerKind=j={}));class N{constructor(B,_,Q,se){this.range=B,this.text=_,this.completionKind=Q,this.isSnippetText=se}equals(B){return h.$9s.lift(this.range).equalsRange(B.range)&&this.text===B.text&&this.completionKind===B.completionKind&&this.isSnippetText===B.isSnippetText}}t.$Ut=N;var $;(function(T){T[T.Invoke=1]="Invoke",T[T.Auto=2]="Auto"})($||(t.CodeActionTriggerType=$={}));var d;(function(T){T[T.Invoke=1]="Invoke",T[T.TriggerCharacter=2]="TriggerCharacter",T[T.ContentChange=3]="ContentChange"})(d||(t.SignatureHelpTriggerKind=d={}));var a;(function(T){T[T.Text=0]="Text",T[T.Read=1]="Read",T[T.Write=2]="Write"})(a||(t.DocumentHighlightKind=a={}));function f(T){return T&&P.URI.isUri(T.uri)&&h.$9s.isIRange(T.range)&&(h.$9s.isIRange(T.originSelectionRange)||h.$9s.isIRange(T.targetSelectionRange))}t.$Vt=f;var n;(function(T){T[T.File=0]="File",T[T.Module=1]="Module",T[T.Namespace=2]="Namespace",T[T.Package=3]="Package",T[T.Class=4]="Class",T[T.Method=5]="Method",T[T.Property=6]="Property",T[T.Field=7]="Field",T[T.Constructor=8]="Constructor",T[T.Enum=9]="Enum",T[T.Interface=10]="Interface",T[T.Function=11]="Function",T[T.Variable=12]="Variable",T[T.Constant=13]="Constant",T[T.String=14]="String",T[T.Number=15]="Number",T[T.Boolean=16]="Boolean",T[T.Array=17]="Array",T[T.Object=18]="Object",T[T.Key=19]="Key",T[T.Null=20]="Null",T[T.EnumMember=21]="EnumMember",T[T.Struct=22]="Struct",T[T.Event=23]="Event",T[T.Operator=24]="Operator",T[T.TypeParameter=25]="TypeParameter"})(n||(t.SymbolKind=n={})),t.$Wt={17:(0,c.localize)(0,null),16:(0,c.localize)(1,null),4:(0,c.localize)(2,null),13:(0,c.localize)(3,null),8:(0,c.localize)(4,null),9:(0,c.localize)(5,null),21:(0,c.localize)(6,null),23:(0,c.localize)(7,null),7:(0,c.localize)(8,null),0:(0,c.localize)(9,null),11:(0,c.localize)(10,null),10:(0,c.localize)(11,null),19:(0,c.localize)(12,null),5:(0,c.localize)(13,null),1:(0,c.localize)(14,null),2:(0,c.localize)(15,null),20:(0,c.localize)(16,null),15:(0,c.localize)(17,null),18:(0,c.localize)(18,null),24:(0,c.localize)(19,null),3:(0,c.localize)(20,null),6:(0,c.localize)(21,null),14:(0,c.localize)(22,null),22:(0,c.localize)(23,null),25:(0,c.localize)(24,null),12:(0,c.localize)(25,null)};function s(T,B){return(0,c.localize)(26,null,T,t.$Wt[B])}t.$Xt=s;var w;(function(T){T[T.Deprecated=1]="Deprecated"})(w||(t.SymbolTag=w={}));var g;(function(T){const B=new Map;B.set(0,i.$ok.symbolFile),B.set(1,i.$ok.symbolModule),B.set(2,i.$ok.symbolNamespace),B.set(3,i.$ok.symbolPackage),B.set(4,i.$ok.symbolClass),B.set(5,i.$ok.symbolMethod),B.set(6,i.$ok.symbolProperty),B.set(7,i.$ok.symbolField),B.set(8,i.$ok.symbolConstructor),B.set(9,i.$ok.symbolEnum),B.set(10,i.$ok.symbolInterface),B.set(11,i.$ok.symbolFunction),B.set(12,i.$ok.symbolVariable),B.set(13,i.$ok.symbolConstant),B.set(14,i.$ok.symbolString),B.set(15,i.$ok.symbolNumber),B.set(16,i.$ok.symbolBoolean),B.set(17,i.$ok.symbolArray),B.set(18,i.$ok.symbolObject),B.set(19,i.$ok.symbolKey),B.set(20,i.$ok.symbolNull),B.set(21,i.$ok.symbolEnumMember),B.set(22,i.$ok.symbolStruct),B.set(23,i.$ok.symbolEvent),B.set(24,i.$ok.symbolOperator),B.set(25,i.$ok.symbolTypeParameter);function _(Q){let se=B.get(Q);return se||(console.info("No codicon found for SymbolKind "+Q),se=i.$ok.symbolProperty),se}T.toIcon=_})(g||(t.SymbolKinds=g={}));class v{static asEditOperation(B){return p.$0s.replace(h.$9s.lift(B.range),B.text)}}t.$Yt=v;class A{static{this.Comment=new A("comment")}static{this.Imports=new A("imports")}static{this.Region=new A("region")}static fromValue(B){switch(B){case"comment":return A.Comment;case"imports":return A.Imports;case"region":return A.Region}return new A(B)}constructor(B){this.value=B}}t.$Zt=A;var R;(function(T){T[T.AIGenerated=1]="AIGenerated"})(R||(t.NewSymbolNameTag=R={}));var y;(function(T){function B(_){return!_||typeof _!="object"?!1:typeof _.id=="string"&&typeof _.title=="string"}T.is=B})(y||(t.Command=y={}));var F;(function(T){T[T.Collapsed=0]="Collapsed",T[T.Expanded=1]="Expanded"})(F||(t.CommentThreadCollapsibleState=F={}));var M;(function(T){T[T.Unresolved=0]="Unresolved",T[T.Resolved=1]="Resolved"})(M||(t.CommentThreadState=M={}));var S;(function(T){T[T.Editing=0]="Editing",T[T.Preview=1]="Preview"})(S||(t.CommentMode=S={}));var D;(function(T){T[T.Published=0]="Published",T[T.Draft=1]="Draft"})(D||(t.CommentState=D={}));var q;(function(T){T[T.Type=1]="Type",T[T.Parameter=2]="Parameter"})(q||(t.InlayHintKind=q={}));class W{constructor(B){this.b=B,this.a=null}dispose(){this.a&&this.a.then(B=>{B&&B.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}t.$1t=W,t.$2t=new k.$Ht;var G;(function(T){T[T.None=0]="None",T[T.Option=1]="Option",T[T.Default=2]="Default",T[T.Preferred=3]="Preferred"})(G||(t.ExternalUriOpenerPriority=G={}));var ee;(function(T){T[T.Invoke=0]="Invoke",T[T.Automatic=1]="Automatic"})(ee||(t.InlineEditTriggerKind=ee={}))}),te(ne[70],re([0,1,24,11,38,18,5,2,45,69,61]),function(C,t,i,P,p,h,k,c,l,u,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$e2=t.$d2=void 0;class E{static{this.CtrlCmd=2048}static{this.Shift=1024}static{this.Alt=512}static{this.WinCtrl=256}static chord(e,L){return(0,p.$ir)(e,L)}}t.$d2=E;function b(){return{editor:void 0,languages:void 0,CancellationTokenSource:i.$ce,Emitter:P.$5d,KeyCode:o.KeyCode,KeyMod:E,Position:k.$8s,Range:c.$9s,Selection:l.$$s,SelectionDirection:o.SelectionDirection,MarkerSeverity:o.MarkerSeverity,MarkerTag:o.MarkerTag,Uri:h.URI,Token:u.$Rt}}t.$e2=b}),te(ne[73],re([0,1,25,18,5,2,58,30,54,55,70,23,60,34,52,14,3,53]),function(C,t,i,P,p,h,k,c,l,u,o,E,b,m,e,L,j,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.EditorSimpleWorker=void 0;class $ extends k.$Av{get uri(){return this.d}get eol(){return this.g}getValue(){return this.getText()}findMatches(n){const s=[];for(let w=0;w<this.f.length;w++){const g=this.f[w],v=this.offsetAt(new p.$8s(w+1,1)),A=g.matchAll(n);for(const R of A)(R.index||R.index===0)&&(R.index=R.index+v),s.push(R)}return s}getLinesContent(){return this.f.slice(0)}getLineCount(){return this.f.length}getLineContent(n){return this.f[n-1]}getWordAtPosition(n,s){const w=(0,c.$Ls)(n.column,(0,c.$Js)(s),this.f[n.lineNumber-1],0);return w?new h.$9s(n.lineNumber,w.startColumn,n.lineNumber,w.endColumn):null}getWordUntilPosition(n,s){const w=this.getWordAtPosition(n,s);return w?{word:this.f[n.lineNumber-1].substring(w.startColumn-1,n.column-1),startColumn:w.startColumn,endColumn:n.column}:{word:"",startColumn:n.column,endColumn:n.column}}words(n){const s=this.f,w=this.q.bind(this);let g=0,v="",A=0,R=[];return{*[Symbol.iterator](){for(;;)if(A<R.length){const y=v.substring(R[A].start,R[A].end);A+=1,yield y}else if(g<s.length)v=s[g],R=w(v,n),A=0,g+=1;else break}}}getLineWords(n,s){const w=this.f[n-1],g=this.q(w,s),v=[];for(const A of g)v.push({word:w.substring(A.start,A.end),startColumn:A.start+1,endColumn:A.end+1});return v}q(n,s){const w=[];let g;for(s.lastIndex=0;(g=s.exec(n))&&g[0].length!==0;)w.push({start:g.index,end:g.index+g[0].length});return w}getValueInRange(n){if(n=this.r(n),n.startLineNumber===n.endLineNumber)return this.f[n.startLineNumber-1].substring(n.startColumn-1,n.endColumn-1);const s=this.g,w=n.startLineNumber-1,g=n.endLineNumber-1,v=[];v.push(this.f[w].substring(n.startColumn-1));for(let A=w+1;A<g;A++)v.push(this.f[A]);return v.push(this.f[g].substring(0,n.endColumn-1)),v.join(s)}offsetAt(n){return n=this.s(n),this.l(),this.j.getPrefixSum(n.lineNumber-2)+(n.column-1)}positionAt(n){n=Math.floor(n),n=Math.max(0,n),this.l();const s=this.j.getIndexOf(n),w=this.f[s.index].length;return{lineNumber:1+s.index,column:1+Math.min(s.remainder,w)}}r(n){const s=this.s({lineNumber:n.startLineNumber,column:n.startColumn}),w=this.s({lineNumber:n.endLineNumber,column:n.endColumn});return s.lineNumber!==n.startLineNumber||s.column!==n.startColumn||w.lineNumber!==n.endLineNumber||w.column!==n.endColumn?{startLineNumber:s.lineNumber,startColumn:s.column,endLineNumber:w.lineNumber,endColumn:w.column}:n}s(n){if(!p.$8s.isIPosition(n))throw new Error("bad position");let{lineNumber:s,column:w}=n,g=!1;if(s<1)s=1,w=1,g=!0;else if(s>this.f.length)s=this.f.length,w=this.f[s-1].length+1,g=!0;else{const v=this.f[s-1].length+1;w<1?(w=1,g=!0):w>v&&(w=v,g=!0)}return g?{lineNumber:s,column:w}:n}}class d{constructor(n,s){this.d=n,this.f=Object.create(null),this.g=s,this.h=null}dispose(){this.f=Object.create(null)}j(n){return this.f[n]}k(){const n=[];return Object.keys(this.f).forEach(s=>n.push(this.f[s])),n}acceptNewModel(n){this.f[n.url]=new $(P.URI.parse(n.url),n.lines,n.EOL,n.versionId)}acceptModelChanged(n,s){if(!this.f[n])return;this.f[n].onEvents(s)}acceptRemovedModel(n){this.f[n]&&delete this.f[n]}async computeUnicodeHighlights(n,s,w){const g=this.j(n);return g?b.$$1.computeUnicodeHighlights(g,s,w):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async computeDiff(n,s,w,g){const v=this.j(n),A=this.j(s);return!v||!A?null:d.l(v,A,w,g)}static l(n,s,w,g){const v=g==="advanced"?e.$A2.getDefault():e.$A2.getLegacy(),A=n.getLinesContent(),R=s.getLinesContent(),y=v.computeDiff(A,R,w),F=y.changes.length>0?!1:this.n(n,s);function M(S){return S.map(D=>[D.original.startLineNumber,D.original.endLineNumberExclusive,D.modified.startLineNumber,D.modified.endLineNumberExclusive,D.innerChanges?.map(q=>[q.originalRange.startLineNumber,q.originalRange.startColumn,q.originalRange.endLineNumber,q.originalRange.endColumn,q.modifiedRange.startLineNumber,q.modifiedRange.startColumn,q.modifiedRange.endLineNumber,q.modifiedRange.endColumn])])}return{identical:F,quitEarly:y.hitTimeout,changes:M(y.changes),moves:y.moves.map(S=>[S.lineRangeMapping.original.startLineNumber,S.lineRangeMapping.original.endLineNumberExclusive,S.lineRangeMapping.modified.startLineNumber,S.lineRangeMapping.modified.endLineNumberExclusive,M(S.changes)])}}static n(n,s){const w=n.getLineCount(),g=s.getLineCount();if(w!==g)return!1;for(let v=1;v<=w;v++){const A=n.getLineContent(v),R=s.getLineContent(v);if(A!==R)return!1}return!0}async computeDirtyDiff(n,s,w){const g=this.j(n),v=this.j(s);if(!g||!v)return null;const A=g.getLinesContent(),R=v.getLinesContent();return new m.$nt(A,R,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:w,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}static{this.o=1e5}async computeMoreMinimalEdits(n,s,w){const g=this.j(n);if(!g)return s;const v=[];let A;s=s.slice(0).sort((y,F)=>{if(y.range&&F.range)return h.$9s.compareRangesUsingStarts(y.range,F.range);const M=y.range?0:1,S=F.range?0:1;return M-S});let R=0;for(let y=1;y<s.length;y++)h.$9s.getEndPosition(s[R].range).equals(h.$9s.getStartPosition(s[y].range))?(s[R].range=h.$9s.fromPositions(h.$9s.getStartPosition(s[R].range),h.$9s.getEndPosition(s[y].range)),s[R].text+=s[y].text):(R++,s[R]=s[y]);s.length=R+1;for(let{range:y,text:F,eol:M}of s){if(typeof M=="number"&&(A=M),h.$9s.isEmpty(y)&&!F)continue;const S=g.getValueInRange(y);if(F=F.replace(/\r\n|\n|\r/g,g.eol),S===F)continue;if(Math.max(F.length,S.length)>d.o){v.push({range:y,text:F});continue}const D=(0,i.$bt)(S,F,w),q=g.offsetAt(h.$9s.lift(y).getStartPosition());for(const W of D){const G=g.positionAt(q+W.originalStart),ee=g.positionAt(q+W.originalStart+W.originalLength),T={text:F.substr(W.modifiedStart,W.modifiedLength),range:{startLineNumber:G.lineNumber,startColumn:G.column,endLineNumber:ee.lineNumber,endColumn:ee.column}};g.getValueInRange(T.range)!==T.text&&v.push(T)}}return typeof A=="number"&&v.push({eol:A,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),v}computeHumanReadableDiff(n,s,w){const g=this.j(n);if(!g)return s;const v=[];let A;s=s.slice(0).sort((R,y)=>{if(R.range&&y.range)return h.$9s.compareRangesUsingStarts(R.range,y.range);const F=R.range?0:1,M=y.range?0:1;return F-M});for(let{range:R,text:y,eol:F}of s){let G=function(T,B){return new p.$8s(T.lineNumber+B.lineNumber-1,B.lineNumber===1?T.column+B.column-1:B.column)},ee=function(T,B){const _=[];for(let Q=B.startLineNumber;Q<=B.endLineNumber;Q++){const se=T[Q-1];Q===B.startLineNumber&&Q===B.endLineNumber?_.push(se.substring(B.startColumn-1,B.endColumn-1)):Q===B.startLineNumber?_.push(se.substring(B.startColumn-1)):Q===B.endLineNumber?_.push(se.substring(0,B.endColumn-1)):_.push(se)}return _};if(typeof F=="number"&&(A=F),h.$9s.isEmpty(R)&&!y)continue;const M=g.getValueInRange(R);if(y=y.replace(/\r\n|\n|\r/g,g.eol),M===y)continue;if(Math.max(y.length,M.length)>d.o){v.push({range:R,text:y});continue}const S=M.split(/\r\n|\n|\r/),D=y.split(/\r\n|\n|\r/),q=e.$A2.getDefault().computeDiff(S,D,w),W=h.$9s.lift(R).getStartPosition();for(const T of q.changes)if(T.innerChanges)for(const B of T.innerChanges)v.push({range:h.$9s.fromPositions(G(W,B.originalRange.getStartPosition()),G(W,B.originalRange.getEndPosition())),text:ee(D,B.modifiedRange).join(g.eol)});else throw new j.$cb("The experimental diff algorithm always produces inner changes")}return typeof A=="number"&&v.push({eol:A,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),v}async computeLinks(n){const s=this.j(n);return s?(0,l.$b2)(s):null}async computeDefaultDocumentColors(n){const s=this.j(n);return s?(0,N.$B2)(s):null}static{this.p=1e4}async textualSuggest(n,s,w,g){const v=new E.$1d,A=new RegExp(w,g),R=new Set;e:for(const y of n){const F=this.j(y);if(F){for(const M of F.words(A))if(!(M===s||!isNaN(Number(M)))&&(R.add(M),R.size>d.p))break e}}return{words:Array.from(R),duration:v.elapsed()}}async computeWordRanges(n,s,w,g){const v=this.j(n);if(!v)return Object.create(null);const A=new RegExp(w,g),R=Object.create(null);for(let y=s.startLineNumber;y<s.endLineNumber;y++){const F=v.getLineWords(y,A);for(const M of F){if(!isNaN(Number(M.word)))continue;let S=R[M.word];S||(S=[],R[M.word]=S),S.push({startLineNumber:y,startColumn:M.startColumn,endLineNumber:y,endColumn:M.endColumn})}}return R}async navigateValueSet(n,s,w,g,v){const A=this.j(n);if(!A)return null;const R=new RegExp(g,v);s.startColumn===s.endColumn&&(s={startLineNumber:s.startLineNumber,startColumn:s.startColumn,endLineNumber:s.endLineNumber,endColumn:s.endColumn+1});const y=A.getValueInRange(s),F=A.getWordAtPosition({lineNumber:s.startLineNumber,column:s.startColumn},R);if(!F)return null;const M=A.getValueInRange(F);return u.$c2.INSTANCE.navigateValueSet(s,y,F,M,w)}loadForeignModule(n,s,w){const g=(R,y)=>this.d.fhr(R,y),A={host:(0,L.$Vn)(w,g),getMirrorModels:()=>this.k()};return this.g?(this.h=this.g(A,s),Promise.resolve((0,L.$Un)(this.h))):new Promise((R,y)=>{C([n],F=>{this.h=F.create(A,s),R((0,L.$Un)(this.h))},y)})}fmr(n,s){if(!this.h||typeof this.h[n]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+n));try{return Promise.resolve(this.h[n].apply(this.h,s))}catch(w){return Promise.reject(w)}}}t.EditorSimpleWorker=d;function a(f){return new d(f,null)}t.create=a,typeof importScripts=="function"&&(globalThis.monaco=(0,o.$e2)())})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/8c2b09c0443b94d75a73819ed35610f7e09375ae/core/vs/base/worker/workerMain.js.map
