/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ae=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","electron","vs/base/common/errors","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","vs/base/common/strings","os","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/map","vs/base/common/uuid","vs/base/common/extpath","vs/platform/state/node/state","vs/base/common/objects","vs/base/common/process","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/environment/common/environment","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/json","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/hash","fs","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/decorators","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/window/common/window","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/ternarySearchTree","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/lazy","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/remote/common/remoteHosts","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/codicons","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindows","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","vs/base/common/normalization","crypto","net","vs/base/node/id","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/codiconsUtil","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/base/node/unc","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/windows/electron-main/windowImpl","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindow","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindowsMainService","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","string_decoder","vs/code/electron-main/main"],ce=function(X){for(var e=[],n=0,R=X.length;n<R;n++)e[n]=ae[X[n]];return e};define(ae[136],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function n(w,p,u){const f=R(w,p);if(f!==-1)return w[f]}e.$fb=n;function R(w,p,u=w.length-1){for(let f=u;f>=0;f--){const h=w[f];if(p(h))return f}return-1}e.$gb=R;function P(w,p){const u=O(w,p);return u===-1?void 0:w[u]}e.$hb=P;function O(w,p,u=0,f=w.length){let h=u,g=f;for(;h<g;){const a=Math.floor((h+g)/2);p(w[a])?h=a+1:g=a}return h-1}e.$ib=O;function C(w,p){const u=S(w,p);return u===w.length?void 0:w[u]}e.$jb=C;function S(w,p,u=0,f=w.length){let h=u,g=f;for(;h<g;){const a=Math.floor((h+g)/2);p(w[a])?g=a:h=a+1}return h}e.$kb=S;function d(w,p,u=0,f=w.length){const h=S(w,p,u,f);return h===w.length?-1:h}e.$lb=d;class c{static{this.assertInvariants=!1}constructor(p){this.e=p,this.c=0}findLastMonotonous(p){if(c.assertInvariants){if(this.d){for(const f of this.e)if(this.d(f)&&!p(f))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=p}const u=O(this.e,p,this.c);return this.c=u+1,u===-1?void 0:this.e[u]}}e.$mb=c;function y(w,p){if(w.length===0)return;let u=w[0];for(let f=1;f<w.length;f++){const h=w[f];p(h,u)>0&&(u=h)}return u}e.$nb=y;function v(w,p){if(w.length===0)return;let u=w[0];for(let f=1;f<w.length;f++){const h=w[f];p(h,u)>=0&&(u=h)}return u}e.$ob=v;function k(w,p){return y(w,(u,f)=>-p(u,f))}e.$pb=k;function $(w,p){if(w.length===0)return-1;let u=0;for(let f=1;f<w.length;f++){const h=w[f];p(h,w[u])>0&&(u=f)}return u}e.$qb=$;function m(w,p){for(const u of w){const f=p(u);if(f!==void 0)return f}}e.$rb=m}),define(ae[137],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N=e.$M=e.$L=e.$K=void 0;function n(C,S){const d=Object.create(null);for(const c of C){const y=S(c);let v=d[y];v||(v=d[y]=[]),v.push(c)}return d}e.$K=n;function R(C,S){const d=[],c=[];for(const y of C)S.has(y)||d.push(y);for(const y of S)C.has(y)||c.push(y);return{removed:d,added:c}}e.$L=R;function P(C,S){const d=[],c=[];for(const[y,v]of C)S.has(y)||d.push(v);for(const[y,v]of S)C.has(y)||c.push(v);return{removed:d,added:c}}e.$M=P;function O(C,S){const d=new Set;for(const c of S)C.has(c)&&d.add(c);return d}e.$N=O}),define(ae[138],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$At=e.$zt=e.$yt=e.$xt=void 0;function n(S,d){const c=Math.pow(10,d);return Math.round(S*c)/c}class R{constructor(d,c,y,v=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,d))|0,this.g=Math.min(255,Math.max(0,c))|0,this.b=Math.min(255,Math.max(0,y))|0,this.a=n(Math.max(Math.min(1,v),0),3)}static equals(d,c){return d.r===c.r&&d.g===c.g&&d.b===c.b&&d.a===c.a}}e.$xt=R;class P{constructor(d,c,y,v){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,d),0)|0,this.s=n(Math.max(Math.min(1,c),0),3),this.l=n(Math.max(Math.min(1,y),0),3),this.a=n(Math.max(Math.min(1,v),0),3)}static equals(d,c){return d.h===c.h&&d.s===c.s&&d.l===c.l&&d.a===c.a}static fromRGBA(d){const c=d.r/255,y=d.g/255,v=d.b/255,k=d.a,$=Math.max(c,y,v),m=Math.min(c,y,v);let w=0,p=0;const u=(m+$)/2,f=$-m;if(f>0){switch(p=Math.min(u<=.5?f/(2*u):f/(2-2*u),1),$){case c:w=(y-v)/f+(y<v?6:0);break;case y:w=(v-c)/f+2;break;case v:w=(c-y)/f+4;break}w*=60,w=Math.round(w)}return new P(w,p,u,k)}static i(d,c,y){return y<0&&(y+=1),y>1&&(y-=1),y<1/6?d+(c-d)*6*y:y<1/2?c:y<2/3?d+(c-d)*(2/3-y)*6:d}static toRGBA(d){const c=d.h/360,{s:y,l:v,a:k}=d;let $,m,w;if(y===0)$=m=w=v;else{const p=v<.5?v*(1+y):v+y-v*y,u=2*v-p;$=P.i(u,p,c+1/3),m=P.i(u,p,c),w=P.i(u,p,c-1/3)}return new R(Math.round($*255),Math.round(m*255),Math.round(w*255),k)}}e.$yt=P;class O{constructor(d,c,y,v){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,d),0)|0,this.s=n(Math.max(Math.min(1,c),0),3),this.v=n(Math.max(Math.min(1,y),0),3),this.a=n(Math.max(Math.min(1,v),0),3)}static equals(d,c){return d.h===c.h&&d.s===c.s&&d.v===c.v&&d.a===c.a}static fromRGBA(d){const c=d.r/255,y=d.g/255,v=d.b/255,k=Math.max(c,y,v),$=Math.min(c,y,v),m=k-$,w=k===0?0:m/k;let p;return m===0?p=0:k===c?p=((y-v)/m%6+6)%6:k===y?p=(v-c)/m+2:p=(c-y)/m+4,new O(Math.round(p*60),w,k,d.a)}static toRGBA(d){const{h:c,s:y,v,a:k}=d,$=v*y,m=$*(1-Math.abs(c/60%2-1)),w=v-$;let[p,u,f]=[0,0,0];return c<60?(p=$,u=m):c<120?(p=m,u=$):c<180?(u=$,f=m):c<240?(u=m,f=$):c<300?(p=m,f=$):c<=360&&(p=$,f=m),p=Math.round((p+w)*255),u=Math.round((u+w)*255),f=Math.round((f+w)*255),new R(p,u,f,k)}}e.$zt=O;class C{static fromHex(d){return C.Format.CSS.parseHex(d)||C.red}static equals(d,c){return!d&&!c?!0:!d||!c?!1:d.equals(c)}get hsla(){return this.i?this.i:P.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:O.fromRGBA(this.rgba)}constructor(d){if(d)if(d instanceof R)this.rgba=d;else if(d instanceof P)this.i=d,this.rgba=P.toRGBA(d);else if(d instanceof O)this.j=d,this.rgba=O.toRGBA(d);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(d){return!!d&&R.equals(this.rgba,d.rgba)&&P.equals(this.hsla,d.hsla)&&O.equals(this.hsva,d.hsva)}getRelativeLuminance(){const d=C.k(this.rgba.r),c=C.k(this.rgba.g),y=C.k(this.rgba.b),v=.2126*d+.7152*c+.0722*y;return n(v,4)}static k(d){const c=d/255;return c<=.03928?c/12.92:Math.pow((c+.055)/1.055,2.4)}getContrastRatio(d){const c=this.getRelativeLuminance(),y=d.getRelativeLuminance();return c>y?(c+.05)/(y+.05):(y+.05)/(c+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(d){const c=this.getRelativeLuminance(),y=d.getRelativeLuminance();return c>y}isDarkerThan(d){const c=this.getRelativeLuminance(),y=d.getRelativeLuminance();return c<y}lighten(d){return new C(new P(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*d,this.hsla.a))}darken(d){return new C(new P(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*d,this.hsla.a))}transparent(d){const{r:c,g:y,b:v,a:k}=this.rgba;return new C(new R(c,y,v,k*d))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new C(new R(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(d){const c=d.rgba,y=this.rgba.a,v=c.a,k=y+v*(1-y);if(k<1e-6)return C.transparent;const $=this.rgba.r*y/k+c.r*v*(1-y)/k,m=this.rgba.g*y/k+c.g*v*(1-y)/k,w=this.rgba.b*y/k+c.b*v*(1-y)/k;return new C(new R($,m,w,k))}makeOpaque(d){if(this.isOpaque()||d.rgba.a!==1)return this;const{r:c,g:y,b:v,a:k}=this.rgba;return new C(new R(d.rgba.r-k*(d.rgba.r-c),d.rgba.g-k*(d.rgba.g-y),d.rgba.b-k*(d.rgba.b-v),1))}flatten(...d){const c=d.reduceRight((y,v)=>C.o(v,y));return C.o(this,c)}static o(d,c){const y=1-d.rgba.a;return new C(new R(y*c.rgba.r+d.rgba.a*d.rgba.r,y*c.rgba.g+d.rgba.a*d.rgba.g,y*c.rgba.b+d.rgba.a*d.rgba.b))}toString(){return this.u||(this.u=C.Format.CSS.format(this)),this.u}static getLighterColor(d,c,y){if(d.isLighterThan(c))return d;y=y||.5;const v=d.getRelativeLuminance(),k=c.getRelativeLuminance();return y=y*(k-v)/k,d.lighten(y)}static getDarkerColor(d,c,y){if(d.isDarkerThan(c))return d;y=y||.5;const v=d.getRelativeLuminance(),k=c.getRelativeLuminance();return y=y*(v-k)/v,d.darken(y)}static{this.white=new C(new R(255,255,255,1))}static{this.black=new C(new R(0,0,0,1))}static{this.red=new C(new R(255,0,0,1))}static{this.blue=new C(new R(0,0,255,1))}static{this.green=new C(new R(0,255,0,1))}static{this.cyan=new C(new R(0,255,255,1))}static{this.lightgrey=new C(new R(211,211,211,1))}static{this.transparent=new C(new R(0,0,0,0))}}e.$At=C,function(S){let d;(function(c){let y;(function(v){function k(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:S.Format.CSS.formatRGBA(t)}v.formatRGB=k;function $(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}v.formatRGBA=$;function m(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:S.Format.CSS.formatHSLA(t)}v.formatHSL=m;function w(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}v.formatHSLA=w;function p(t){const o=t.toString(16);return o.length!==2?"0"+o:o}function u(t){return`#${p(t.rgba.r)}${p(t.rgba.g)}${p(t.rgba.b)}`}v.formatHex=u;function f(t,o=!1){return o&&t.rgba.a===1?S.Format.CSS.formatHex(t):`#${p(t.rgba.r)}${p(t.rgba.g)}${p(t.rgba.b)}${p(Math.round(t.rgba.a*255))}`}v.formatHexA=f;function h(t){return t.isOpaque()?S.Format.CSS.formatHex(t):S.Format.CSS.formatRGBA(t)}v.format=h;function g(t){const o=t.length;if(o===0||t.charCodeAt(0)!==35)return null;if(o===7){const r=16*a(t.charCodeAt(1))+a(t.charCodeAt(2)),i=16*a(t.charCodeAt(3))+a(t.charCodeAt(4)),s=16*a(t.charCodeAt(5))+a(t.charCodeAt(6));return new S(new R(r,i,s,1))}if(o===9){const r=16*a(t.charCodeAt(1))+a(t.charCodeAt(2)),i=16*a(t.charCodeAt(3))+a(t.charCodeAt(4)),s=16*a(t.charCodeAt(5))+a(t.charCodeAt(6)),l=16*a(t.charCodeAt(7))+a(t.charCodeAt(8));return new S(new R(r,i,s,l/255))}if(o===4){const r=a(t.charCodeAt(1)),i=a(t.charCodeAt(2)),s=a(t.charCodeAt(3));return new S(new R(16*r+r,16*i+i,16*s+s))}if(o===5){const r=a(t.charCodeAt(1)),i=a(t.charCodeAt(2)),s=a(t.charCodeAt(3)),l=a(t.charCodeAt(4));return new S(new R(16*r+r,16*i+i,16*s+s,(16*l+l)/255))}return null}v.parseHex=g;function a(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(y=c.CSS||(c.CSS={}))})(d=S.Format||(S.Format={}))}(C||(e.$At=C={}))}),define(ae[50],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=e.$Kh=e.$Jh=void 0;function n(C){return(S,d,c)=>{let y=null,v=null;if(typeof c.value=="function"?(y="value",v=c.value):typeof c.get=="function"&&(y="get",v=c.get),!v)throw new Error("not supported");c[y]=C(v,d)}}function R(C,S,d){let c=null,y=null;if(typeof d.value=="function"?(c="value",y=d.value,y.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof d.get=="function"&&(c="get",y=d.get),!y)throw new Error("not supported");const v=`$memoize$${S}`;d[c]=function(...k){return this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!1,enumerable:!1,writable:!1,value:y.apply(this,k)}),this[v]}}e.$Jh=R;function P(C,S,d){return n((c,y)=>{const v=`$debounce$${y}`,k=`$debounce$result$${y}`;return function(...$){this[k]||(this[k]=d?d():void 0),clearTimeout(this[v]),S&&(this[k]=S(this[k],...$),$=[this[k]]),this[v]=setTimeout(()=>{c.apply(this,$),this[k]=d?d():void 0},C)}})}e.$Kh=P;function O(C,S,d){return n((c,y)=>{const v=`$throttle$timer$${y}`,k=`$throttle$result$${y}`,$=`$throttle$lastRun$${y}`,m=`$throttle$pending$${y}`;return function(...w){if(this[k]||(this[k]=d?d():void 0),(this[$]===null||this[$]===void 0)&&(this[$]=-Number.MAX_VALUE),S&&(this[k]=S(this[k],...w)),this[m])return;const p=this[$]+C;p<=Date.now()?(this[$]=Date.now(),c.apply(this,[this[k]]),this[k]=d?d():void 0):(this[m]=!0,this[v]=setTimeout(()=>{this[m]=!1,this[$]=Date.now(),c.apply(this,[this[k]]),this[k]=d?d():void 0},p-Date.now()))}})}e.$Lh=O}),define(ae[15],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class n{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?h.isErrorNoTelemetry(t)?new h(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(o=>{o(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=n,e.$X=new n;function R(a){e.$X.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=R;function P(a){if(!a||typeof a!="object")return!1;const t=a;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$Z=P;function O(a){c(a)||e.$X.onUnexpectedError(a)}e.$1=O;function C(a){c(a)||e.$X.onUnexpectedExternalError(a)}e.$2=C;function S(a){if(a instanceof Error){const{name:t,message:o}=a,r=a.stacktrace||a.stack;return{$isError:!0,name:t,message:o,stack:r,noTelemetry:h.isErrorNoTelemetry(a)}}return a}e.$3=S;const d="Canceled";function c(a){return a instanceof y?!0:a instanceof Error&&a.name===d&&a.message===d}e.$4=c;class y extends Error{constructor(){super(d),this.name=this.message}}e.$5=y;function v(){const a=new Error(d);return a.name=a.message,a}e.$6=v;function k(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.$7=k;function $(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.$8=$;class m extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=m;function w(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.$0=w;class p extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=p;class u extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=u;class f extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=f;class h extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof h)return t;const o=new h;return o.message=t.message,o.stack=t.stack,o}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=h;class g extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,g.prototype)}}e.$cb=g}),define(ae[22],ce([0,1,15,136]),function(X,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function P(z,Z=0){return z[z.length-(1+Z)]}e.$sb=P;function O(z){if(z.length===0)throw new Error("Invalid tail call");return[z.slice(0,z.length-1),z[z.length-1]]}e.$tb=O;function C(z,Z,H=(_,B)=>_===B){if(z===Z)return!0;if(!z||!Z||z.length!==Z.length)return!1;for(let _=0,B=z.length;_<B;_++)if(!H(z[_],Z[_]))return!1;return!0}e.$ub=C;function S(z,Z){const H=z.length-1;Z<H&&(z[Z]=z[H]),z.pop()}e.$vb=S;function d(z,Z,H){return c(z.length,_=>H(z[_],Z))}e.$wb=d;function c(z,Z){let H=0,_=z-1;for(;H<=_;){const B=(H+_)/2|0,ee=Z(B);if(ee<0)H=B+1;else if(ee>0)_=B-1;else return B}return-(H+1)}e.$xb=c;function y(z,Z,H){if(z=z|0,z>=Z.length)throw new TypeError("invalid index");const _=Z[Math.floor(Z.length*Math.random())],B=[],ee=[],ie=[];for(const de of Z){const me=H(de,_);me<0?B.push(de):me>0?ee.push(de):ie.push(de)}return z<B.length?y(z,B,H):z<B.length+ie.length?ie[0]:y(z-(B.length+ie.length),ee,H)}e.$yb=y;function v(z,Z){const H=[];let _;for(const B of z.slice(0).sort(Z))!_||Z(_[0],B)!==0?(_=[B],H.push(_)):_.push(B);return H}e.$zb=v;function*k(z,Z){let H,_;for(const B of z)_!==void 0&&Z(_,B)?H.push(B):(H&&(yield H),H=[B]),_=B;H&&(yield H)}e.$Ab=k;function $(z,Z){for(let H=0;H<=z.length;H++)Z(H===0?void 0:z[H-1],H===z.length?void 0:z[H])}e.$Bb=$;function m(z,Z){for(let H=0;H<z.length;H++)Z(H===0?void 0:z[H-1],z[H],H+1===z.length?void 0:z[H+1])}e.$Cb=m;function w(z,Z,H){const _=[];function B(de,me,Ee){if(me===0&&Ee.length===0)return;const Pe=_[_.length-1];Pe&&Pe.start+Pe.deleteCount===de?(Pe.deleteCount+=me,Pe.toInsert.push(...Ee)):_.push({start:de,deleteCount:me,toInsert:Ee})}let ee=0,ie=0;for(;;){if(ee===z.length){B(ee,0,Z.slice(ie));break}if(ie===Z.length){B(ee,z.length-ee,[]);break}const de=z[ee],me=Z[ie],Ee=H(de,me);Ee===0?(ee+=1,ie+=1):Ee<0?(B(ee,1,[]),ee+=1):Ee>0&&(B(ee,0,[me]),ie+=1)}return _}e.$Db=w;function p(z,Z,H){const _=w(z,Z,H),B=[],ee=[];for(const ie of _)B.push(...z.slice(ie.start,ie.start+ie.deleteCount)),ee.push(...ie.toInsert);return{removed:B,added:ee}}e.$Eb=p;function u(z,Z,H){if(H===0)return[];const _=z.slice(0,H).sort(Z);return h(z,Z,_,H,z.length),_}e.top=u;function f(z,Z,H,_,B){return H===0?Promise.resolve([]):new Promise((ee,ie)=>{(async()=>{const de=z.length,me=z.slice(0,H).sort(Z);for(let Ee=H,Pe=Math.min(H+_,de);Ee<de;Ee=Pe,Pe=Math.min(Pe+_,de)){if(Ee>H&&await new Promise(Le=>setTimeout(Le)),B&&B.isCancellationRequested)throw new n.$5;h(z,Z,me,Ee,Pe)}return me})().then(ee,ie)})}e.$Gb=f;function h(z,Z,H,_,B){for(const ee=H.length;_<B;_++){const ie=z[_];if(Z(ie,H[ee-1])<0){H.pop();const de=(0,R.$kb)(H,me=>Z(ie,me)<0);H.splice(de,0,ie)}}}function g(z){return z.filter(Z=>!!Z)}e.$Hb=g;function a(z){let Z=0;for(let H=0;H<z.length;H++)z[H]&&(z[Z]=z[H],Z+=1);z.length=Z}e.$Ib=a;function t(z,Z,H){z.splice(H,0,z.splice(Z,1)[0])}e.$Jb=t;function o(z){return!Array.isArray(z)||z.length===0}e.$Kb=o;function r(z){return Array.isArray(z)&&z.length>0}e.$Lb=r;function i(z,Z=H=>H){const H=new Set;return z.filter(_=>{const B=Z(_);return H.has(B)?!1:(H.add(B),!0)})}e.$Mb=i;function s(z){const Z=new Set;return H=>{const _=z(H);return Z.has(_)?!1:(Z.add(_),!0)}}e.$Nb=s;function l(z,Z){return z.length>0?z[0]:Z}e.$Ob=l;function b(z,Z){return z.length>0?z[z.length-1]:Z}e.$Pb=b;function D(z,Z,H=(_,B)=>_===B){let _=0;for(let B=0,ee=Math.min(z.length,Z.length);B<ee&&H(z[B],Z[B]);B++)_++;return _}e.$Qb=D;function j(z){return[].concat(...z)}e.$Rb=j;function E(z,Z){let H=typeof Z=="number"?z:0;typeof Z=="number"?H=z:(H=0,Z=z);const _=[];if(H<=Z)for(let B=H;B<Z;B++)_.push(B);else for(let B=H;B>Z;B--)_.push(B);return _}e.$Sb=E;function I(z,Z,H){return z.reduce((_,B)=>(_[Z(B)]=H?H(B):B,_),Object.create(null))}e.$Tb=I;function M(z,Z){return z.push(Z),()=>T(z,Z)}e.$Ub=M;function T(z,Z){const H=z.indexOf(Z);if(H>-1)return z.splice(H,1),Z}e.$Vb=T;function W(z,Z,H){const _=z.slice(0,Z),B=z.slice(Z);return _.concat(H,B)}e.$Wb=W;function V(z,Z){let H;if(typeof Z=="number"){let _=Z;H=()=>{const B=Math.sin(_++)*179426549;return B-Math.floor(B)}}else H=Math.random;for(let _=z.length-1;_>0;_-=1){const B=Math.floor(H()*(_+1)),ee=z[_];z[_]=z[B],z[B]=ee}}e.$Xb=V;function J(z,Z){const H=z.indexOf(Z);H>-1&&(z.splice(H,1),z.unshift(Z))}e.$Yb=J;function le(z,Z){const H=z.indexOf(Z);H>-1&&(z.splice(H,1),z.push(Z))}e.$Zb=le;function re(z,Z){for(const H of Z)z.push(H)}e.$1b=re;function ue(z,Z){return Array.isArray(z)?z.map(Z):Z(z)}e.$2b=ue;function Q(z){return Array.isArray(z)?z:[z]}e.$3b=Q;function Y(z){return z[Math.floor(Math.random()*z.length)]}e.$4b=Y;function U(z,Z,H){const _=N(z,Z),B=z.length,ee=H.length;z.length=B+ee;for(let ie=B-1;ie>=_;ie--)z[ie+ee]=z[ie];for(let ie=0;ie<ee;ie++)z[ie+_]=H[ie]}e.$5b=U;function L(z,Z,H,_){const B=N(z,Z);let ee=z.splice(B,H);return ee===void 0&&(ee=[]),U(z,B,_),ee}e.$6b=L;function N(z,Z){return Z<0?Math.max(Z+z.length,0):Math.min(Z,z.length)}var G;(function(z){function Z(ee){return ee<0}z.isLessThan=Z;function H(ee){return ee<=0}z.isLessThanOrEqual=H;function _(ee){return ee>0}z.isGreaterThan=_;function B(ee){return ee===0}z.isNeitherLessOrGreaterThan=B,z.greaterThan=1,z.lessThan=-1,z.neitherLessOrGreaterThan=0})(G||(e.CompareResult=G={}));function q(z,Z){return(H,_)=>Z(z(H),z(_))}e.$7b=q;function oe(...z){return(Z,H)=>{for(const _ of z){const B=_(Z,H);if(!G.isNeitherLessOrGreaterThan(B))return B}return G.neitherLessOrGreaterThan}}e.$8b=oe;const he=(z,Z)=>z-Z;e.$9b=he;const K=(z,Z)=>(0,e.$9b)(z?1:0,Z?1:0);e.$0b=K;function A(z){return(Z,H)=>-z(Z,H)}e.$$b=A;class F{constructor(Z){this.g=Z,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(Z){let H=this.c;for(;H<this.g.length&&Z(this.g[H]);)H++;const _=H===this.c?null:this.g.slice(this.c,H);return this.c=H,_}takeFromEndWhile(Z){let H=this.d;for(;H>=0&&Z(this.g[H]);)H--;const _=H===this.d?null:this.g.slice(H+1,this.d+1);return this.d=H,_}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const Z=this.g[this.c];return this.c++,Z}removeLast(){const Z=this.g[this.d];return this.d--,Z}takeCount(Z){const H=this.g.slice(this.c,this.c+Z);return this.c+=Z,H}}e.$_b=F;class x{static{this.empty=new x(Z=>{})}constructor(Z){this.iterate=Z}forEach(Z){this.iterate(H=>(Z(H),!0))}toArray(){const Z=[];return this.iterate(H=>(Z.push(H),!0)),Z}filter(Z){return new x(H=>this.iterate(_=>Z(_)?H(_):!0))}map(Z){return new x(H=>this.iterate(_=>H(Z(_))))}some(Z){let H=!1;return this.iterate(_=>(H=Z(_),!H)),H}findFirst(Z){let H;return this.iterate(_=>Z(_)?(H=_,!1):!0),H}findLast(Z){let H;return this.iterate(_=>(Z(_)&&(H=_),!0)),H}findLastMaxBy(Z){let H,_=!0;return this.iterate(B=>((_||G.isGreaterThan(Z(B,H)))&&(_=!1,H=B),!0)),H}}e.$ac=x}),define(ae[139],ce([0,1,15]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=e.$_c=e.$$c=e.$0c=e.$9c=e.ok=void 0;function R(c,y){if(!c)throw new Error(y?`Assertion failed (${y})`:"Assertion Failed")}e.ok=R;function P(c,y="Unreachable"){throw new Error(y)}e.$9c=P;function O(c){if(!c)throw new n.$cb("Assertion Failed")}e.$0c=O;function C(c){c||(0,n.$1)(new n.$cb("Soft Assertion Failed"))}e.$$c=C;function S(c){if(!c()){debugger;c(),(0,n.$1)(new n.$cb("Assertion Failed"))}}e.$_c=S;function d(c,y){let v=0;for(;v<c.length-1;){const k=c[v],$=c[v+1];if(!y(k,$))return!1;v++}return!0}e.$ad=d}),define(ae[85],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function n(R,P){const O=this;let C=!1,S;return function(){if(C)return S;if(C=!0,P)try{S=R.apply(O,arguments)}finally{P()}else S=R.apply(O,arguments);return S}}e.$db=n}),define(ae[71],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var n;(function(R){function P(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}R.is=P;const O=Object.freeze([]);function C(){return O}R.empty=C;function*S(t){yield t}R.single=S;function d(t){return P(t)?t:S(t)}R.wrap=d;function c(t){return t||O}R.from=c;function*y(t){for(let o=t.length-1;o>=0;o--)yield t[o]}R.reverse=y;function v(t){return!t||t[Symbol.iterator]().next().done===!0}R.isEmpty=v;function k(t){return t[Symbol.iterator]().next().value}R.first=k;function $(t,o){for(const r of t)if(o(r))return!0;return!1}R.some=$;function m(t,o){for(const r of t)if(o(r))return r}R.find=m;function*w(t,o){for(const r of t)o(r)&&(yield r)}R.filter=w;function*p(t,o){let r=0;for(const i of t)yield o(i,r++)}R.map=p;function*u(...t){for(const o of t)yield*o}R.concat=u;function f(t,o,r){let i=r;for(const s of t)i=o(i,s);return i}R.reduce=f;function*h(t,o,r=t.length){for(o<0&&(o+=t.length),r<0?r+=t.length:r>t.length&&(r=t.length);o<r;o++)yield t[o]}R.slice=h;function g(t,o=Number.POSITIVE_INFINITY){const r=[];if(o===0)return[r,t];const i=t[Symbol.iterator]();for(let s=0;s<o;s++){const l=i.next();if(l.done)return[r,R.empty()];r.push(l.value)}return[r,{[Symbol.iterator](){return i}}]}R.consume=g;async function a(t){const o=[];for await(const r of t)o.push(r);return Promise.resolve(o)}R.asyncToArray=a})(n||(e.Iterable=n={}))}),define(ae[42],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var n;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(n||(e.ScanError=n={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R||(e.SyntaxKind=R={}));var P;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(P||(e.ParseErrorCode=P={}));var O;(function(t){t.DEFAULT={allowTrailingComma:!0}})(O||(e.ParseOptions=O={}));function C(t,o=!1){let r=0;const i=t.length;let s="",l=0,b=16,D=0;function j(J){let le=0,re=0;for(;le<J;){const ue=t.charCodeAt(r);if(ue>=48&&ue<=57)re=re*16+ue-48;else if(ue>=65&&ue<=70)re=re*16+ue-65+10;else if(ue>=97&&ue<=102)re=re*16+ue-97+10;else break;r++,le++}return le<J&&(re=-1),re}function E(J){r=J,s="",l=0,b=16,D=0}function I(){const J=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&c(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&c(t.charCodeAt(r)))for(r++;r<t.length&&c(t.charCodeAt(r));)r++;else return D=3,t.substring(J,r);let le=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&c(t.charCodeAt(r))){for(r++;r<t.length&&c(t.charCodeAt(r));)r++;le=r}else D=3;return t.substring(J,le)}function M(){let J="",le=r;for(;;){if(r>=i){J+=t.substring(le,r),D=2;break}const re=t.charCodeAt(r);if(re===34){J+=t.substring(le,r),r++;break}if(re===92){if(J+=t.substring(le,r),r++,r>=i){D=2;break}switch(t.charCodeAt(r++)){case 34:J+='"';break;case 92:J+="\\";break;case 47:J+="/";break;case 98:J+="\b";break;case 102:J+="\f";break;case 110:J+=`
`;break;case 114:J+="\r";break;case 116:J+="	";break;case 117:{const Q=j(4);Q>=0?J+=String.fromCharCode(Q):D=4;break}default:D=5}le=r;continue}if(re>=0&&re<=31)if(d(re)){J+=t.substring(le,r),D=2;break}else D=6;r++}return J}function T(){if(s="",D=0,l=r,r>=i)return l=i,b=17;let J=t.charCodeAt(r);if(S(J)){do r++,s+=String.fromCharCode(J),J=t.charCodeAt(r);while(S(J));return b=15}if(d(J))return r++,s+=String.fromCharCode(J),J===13&&t.charCodeAt(r)===10&&(r++,s+=`
`),b=14;switch(J){case 123:return r++,b=1;case 125:return r++,b=2;case 91:return r++,b=3;case 93:return r++,b=4;case 58:return r++,b=6;case 44:return r++,b=5;case 34:return r++,s=M(),b=10;case 47:{const le=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<i&&!d(t.charCodeAt(r));)r++;return s=t.substring(le,r),b=12}if(t.charCodeAt(r+1)===42){r+=2;const re=i-1;let ue=!1;for(;r<re;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,ue=!0;break}r++}return ue||(r++,D=1),s=t.substring(le,r),b=13}return s+=String.fromCharCode(J),r++,b=16}case 45:if(s+=String.fromCharCode(J),r++,r===i||!c(t.charCodeAt(r)))return b=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=I(),b=11;default:for(;r<i&&W(J);)r++,J=t.charCodeAt(r);if(l!==r){switch(s=t.substring(l,r),s){case"true":return b=8;case"false":return b=9;case"null":return b=7}return b=16}return s+=String.fromCharCode(J),r++,b=16}}function W(J){if(S(J)||d(J))return!1;switch(J){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function V(){let J;do J=T();while(J>=12&&J<=15);return J}return{setPosition:E,getPosition:()=>r,scan:o?V:T,getToken:()=>b,getTokenValue:()=>s,getTokenOffset:()=>l,getTokenLength:()=>r-l,getTokenError:()=>D}}e.$pn=C;function S(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function d(t){return t===10||t===13||t===8232||t===8233}function c(t){return t>=48&&t<=57}var y;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(y||(y={}));function v(t,o){const r=[],i=new Object;let s;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let b=!1;function D(j,E,I,M){l.value=j,l.offset=E,l.length=I,l.type=M,l.colonOffset=void 0,s=l}try{h(t,{onObjectBegin:(j,E)=>{if(o<=j)throw i;s=void 0,b=o>j,r.push("")},onObjectProperty:(j,E,I)=>{if(o<E||(D(j,E,I,"property"),r[r.length-1]=j,o<=E+I))throw i},onObjectEnd:(j,E)=>{if(o<=j)throw i;s=void 0,r.pop()},onArrayBegin:(j,E)=>{if(o<=j)throw i;s=void 0,r.push(0)},onArrayEnd:(j,E)=>{if(o<=j)throw i;s=void 0,r.pop()},onLiteralValue:(j,E,I)=>{if(o<E||(D(j,E,I,a(j)),o<=E+I))throw i},onSeparator:(j,E,I)=>{if(o<=E)throw i;if(j===":"&&s&&s.type==="property")s.colonOffset=E,b=!1,s=void 0;else if(j===","){const M=r[r.length-1];typeof M=="number"?r[r.length-1]=M+1:(b=!0,r[r.length-1]=""),s=void 0}}})}catch(j){if(j!==i)throw j}return{path:r,previousNode:s,isAtPropertyKey:b,matches:j=>{let E=0;for(let I=0;E<j.length&&I<r.length;I++)if(j[E]===r[I]||j[E]==="*")E++;else if(j[E]!=="**")return!1;return E===j.length}}}e.$qn=v;function k(t,o=[],r=O.DEFAULT){let i=null,s=[];const l=[];function b(j){Array.isArray(s)?s.push(j):i!==null&&(s[i]=j)}return h(t,{onObjectBegin:()=>{const j={};b(j),l.push(s),s=j,i=null},onObjectProperty:j=>{i=j},onObjectEnd:()=>{s=l.pop()},onArrayBegin:()=>{const j=[];b(j),l.push(s),s=j,i=null},onArrayEnd:()=>{s=l.pop()},onLiteralValue:b,onError:(j,E,I)=>{o.push({error:j,offset:E,length:I})}},r),s[0]}e.$rn=k;function $(t,o=[],r=O.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(j){i.type==="property"&&(i.length=j-i.offset,i=i.parent)}function l(j){return i.children.push(j),j}h(t,{onObjectBegin:j=>{i=l({type:"object",offset:j,length:-1,parent:i,children:[]})},onObjectProperty:(j,E,I)=>{i=l({type:"property",offset:E,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:j,offset:E,length:I,parent:i})},onObjectEnd:(j,E)=>{i.length=j+E-i.offset,i=i.parent,s(j+E)},onArrayBegin:(j,E)=>{i=l({type:"array",offset:j,length:-1,parent:i,children:[]})},onArrayEnd:(j,E)=>{i.length=j+E-i.offset,i=i.parent,s(j+E)},onLiteralValue:(j,E,I)=>{l({type:a(j),offset:E,length:I,parent:i,value:j}),s(E+I)},onSeparator:(j,E,I)=>{i.type==="property"&&(j===":"?i.colonOffset=E:j===","&&s(E))},onError:(j,E,I)=>{o.push({error:j,offset:E,length:I})}},r);const D=i.children[0];return D&&delete D.parent,D}e.$sn=$;function m(t,o){if(!t)return;let r=t;for(const i of o)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let s=!1;for(const l of r.children)if(Array.isArray(l.children)&&l.children[0].value===i){r=l.children[1],s=!0;break}if(!s)return}else{const s=i;if(r.type!=="array"||s<0||!Array.isArray(r.children)||s>=r.children.length)return;r=r.children[s]}return r}e.$tn=m;function w(t){if(!t.parent||!t.parent.children)return[];const o=w(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;o.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&o.push(r)}return o}e.$un=w;function p(t){switch(t.type){case"array":return t.children.map(p);case"object":{const o=Object.create(null);for(const r of t.children){const i=r.children[1];i&&(o[r.children[0].value]=p(i))}return o}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$vn=p;function u(t,o,r=!1){return o>=t.offset&&o<t.offset+t.length||r&&o===t.offset+t.length}e.$wn=u;function f(t,o,r=!1){if(u(t,o,r)){const i=t.children;if(Array.isArray(i))for(let s=0;s<i.length&&i[s].offset<=o;s++){const l=f(i[s],o,r);if(l)return l}return t}}e.$xn=f;function h(t,o,r=O.DEFAULT){const i=C(t,!1);function s(q){return q?()=>q(i.getTokenOffset(),i.getTokenLength()):()=>!0}function l(q){return q?oe=>q(oe,i.getTokenOffset(),i.getTokenLength()):()=>!0}const b=s(o.onObjectBegin),D=l(o.onObjectProperty),j=s(o.onObjectEnd),E=s(o.onArrayBegin),I=s(o.onArrayEnd),M=l(o.onLiteralValue),T=l(o.onSeparator),W=s(o.onComment),V=l(o.onError),J=r&&r.disallowComments,le=r&&r.allowTrailingComma;function re(){for(;;){const q=i.scan();switch(i.getTokenError()){case 4:ue(14);break;case 5:ue(15);break;case 3:ue(13);break;case 1:J||ue(11);break;case 2:ue(12);break;case 6:ue(16);break}switch(q){case 12:case 13:J?ue(10):W();break;case 16:ue(1);break;case 15:case 14:break;default:return q}}}function ue(q,oe=[],he=[]){if(V(q),oe.length+he.length>0){let K=i.getToken();for(;K!==17;){if(oe.indexOf(K)!==-1){re();break}else if(he.indexOf(K)!==-1)break;K=re()}}}function Q(q){const oe=i.getTokenValue();return q?M(oe):D(oe),re(),!0}function Y(){switch(i.getToken()){case 11:{let q=0;try{q=JSON.parse(i.getTokenValue()),typeof q!="number"&&(ue(2),q=0)}catch{ue(2)}M(q);break}case 7:M(null);break;case 8:M(!0);break;case 9:M(!1);break;default:return!1}return re(),!0}function U(){return i.getToken()!==10?(ue(3,[],[2,5]),!1):(Q(!1),i.getToken()===6?(T(":"),re(),G()||ue(4,[],[2,5])):ue(5,[],[2,5]),!0)}function L(){b(),re();let q=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(q||ue(4,[],[]),T(","),re(),i.getToken()===2&&le)break}else q&&ue(6,[],[]);U()||ue(4,[],[2,5]),q=!0}return j(),i.getToken()!==2?ue(7,[2],[]):re(),!0}function N(){E(),re();let q=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(q||ue(4,[],[]),T(","),re(),i.getToken()===4&&le)break}else q&&ue(6,[],[]);G()||ue(4,[],[4,5]),q=!0}return I(),i.getToken()!==4?ue(8,[4],[]):re(),!0}function G(){switch(i.getToken()){case 3:return N();case 1:return L();case 10:return Q(!0);default:return Y()}}return re(),i.getToken()===17?r.allowEmptyContent?!0:(ue(4,[],[]),!1):G()?(i.getToken()!==17&&ue(9,[],[]),!0):(ue(4,[],[]),!1)}e.$yn=h;function g(t,o){const r=C(t),i=[];let s,l=0,b;do switch(b=r.getPosition(),s=r.scan(),s){case 12:case 13:case 17:l!==b&&i.push(t.substring(l,b)),o!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,o)),l=r.getPosition();break}while(s!==17);return i.join("")}e.$zn=g;function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$An=a}),define(ae[140],ce([0,1,42]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$En=e.$Dn=e.$Cn=e.$Bn=void 0;function R(c,y,v){let k,$,m,w,p;if(y){for(w=y.offset,p=w+y.length,m=w;m>0&&!d(c,m-1);)m--;let b=p;for(;b<c.length&&!d(c,b);)b++;$=c.substring(m,b),k=C($,v)}else $=c,k=0,m=0,w=0,p=c.length;const u=S(v,c);let f=!1,h=0,g;v.insertSpaces?g=O(" ",v.tabSize||4):g="	";const a=(0,n.$pn)($,!1);let t=!1;function o(){return u+O(g,k+h)}function r(){let b=a.scan();for(f=!1;b===15||b===14;)f=f||b===14,b=a.scan();return t=b===16||a.getTokenError()!==0,b}const i=[];function s(b,D,j){!t&&D<p&&j>w&&c.substring(D,j)!==b&&i.push({offset:D,length:j-D,content:b})}let l=r();if(l!==17){const b=a.getTokenOffset()+m,D=O(g,k);s(D,m,b)}for(;l!==17;){let b=a.getTokenOffset()+a.getTokenLength()+m,D=r(),j="";for(;!f&&(D===12||D===13);){const I=a.getTokenOffset()+m;s(" ",b,I),b=a.getTokenOffset()+a.getTokenLength()+m,j=D===12?o():"",D=r()}if(D===2)l!==1&&(h--,j=o());else if(D===4)l!==3&&(h--,j=o());else{switch(l){case 3:case 1:h++,j=o();break;case 5:case 12:j=o();break;case 13:f?j=o():j=" ";break;case 6:j=" ";break;case 10:if(D===6){j="";break}case 7:case 8:case 9:case 11:case 2:case 4:D===12||D===13?j=" ":D!==5&&D!==17&&(t=!0);break;case 16:t=!0;break}f&&(D===12||D===13)&&(j=o())}const E=a.getTokenOffset()+m;s(j,b,E),l=D}return i}e.$Bn=R;function P(c,y){const v=JSON.stringify(c,void 0,y.insertSpaces?y.tabSize||4:"	");return y.eol!==void 0?v.replace(/\r\n|\r|\n/g,y.eol):v}e.$Cn=P;function O(c,y){let v="";for(let k=0;k<y;k++)v+=c;return v}function C(c,y){let v=0,k=0;const $=y.tabSize||4;for(;v<c.length;){const m=c.charAt(v);if(m===" ")k++;else if(m==="	")k+=$;else break;v++}return Math.floor(k/$)}function S(c,y){for(let v=0;v<y.length;v++){const k=y.charAt(v);if(k==="\r")return v+1<y.length&&y.charAt(v+1)===`
`?`\r
`:"\r";if(k===`
`)return`
`}return c&&c.eol||`
`}e.$Dn=S;function d(c,y){return`\r
`.indexOf(c.charAt(y))!==-1}e.$En=d}),define(ae[102],ce([0,1,42,140]),function(X,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=void 0;function P(c,y,v){return O(c,y,void 0,v)}e.$Fn=P;function O(c,y,v,k,$){const m=y.slice(),w=[],p=(0,n.$sn)(c,w);let u,f;for(;m.length>0&&(f=m.pop(),u=(0,n.$tn)(p,m),u===void 0&&v!==void 0);)typeof f=="string"?v={[f]:v}:v=[v];if(u)if(u.type==="object"&&typeof f=="string"&&Array.isArray(u.children)){const h=(0,n.$tn)(u,[f]);if(h!==void 0)if(v===void 0){if(!h.parent)throw new Error("Malformed AST");const g=u.children.indexOf(h.parent);let a,t=h.parent.offset+h.parent.length;if(g>0){const o=u.children[g-1];a=o.offset+o.length}else a=u.offset+1,u.children.length>1&&(t=u.children[1].offset);return C(c,{offset:a,length:t-a,content:""},k)}else return C(c,{offset:h.offset,length:h.length,content:JSON.stringify(v)},k);else{if(v===void 0)return[];const g=`${JSON.stringify(f)}: ${JSON.stringify(v)}`,a=$?$(u.children.map(o=>o.children[0].value)):u.children.length;let t;if(a>0){const o=u.children[a-1];t={offset:o.offset+o.length,length:0,content:","+g}}else u.children.length===0?t={offset:u.offset+1,length:0,content:g}:t={offset:u.offset+1,length:0,content:g+","};return C(c,t,k)}}else if(u.type==="array"&&typeof f=="number"&&Array.isArray(u.children))if(v!==void 0){const h=`${JSON.stringify(v)}`;let g;if(u.children.length===0||f===0)g={offset:u.offset+1,length:0,content:u.children.length===0?h:h+","};else{const a=f===-1||f>u.children.length?u.children.length:f,t=u.children[a-1];g={offset:t.offset+t.length,length:0,content:","+h}}return C(c,g,k)}else{const h=f,g=u.children[h];let a;if(u.children.length===1)a={offset:u.offset+1,length:u.length-2,content:""};else if(u.children.length-1===h){const t=u.children[h-1],o=t.offset+t.length,r=u.offset+u.length;a={offset:o,length:r-2-o,content:""}}else a={offset:g.offset,length:u.children[h+1].offset-g.offset,content:""};return C(c,a,k)}else throw new Error(`Can not add ${typeof f!="number"?"index":"property"} to parent of type ${u.type}`);else{if(v===void 0)throw new Error("Can not delete in empty document");return C(c,{offset:p?p.offset:0,length:p?p.length:0,content:JSON.stringify(v)},k)}}e.$Gn=O;function C(c,y,v){let k=S(c,y),$=y.offset,m=y.offset+y.content.length;if(y.length===0||y.content.length===0){for(;$>0&&!(0,R.$En)(k,$-1);)$--;for(;m<k.length&&!(0,R.$En)(k,m);)m++}const w=(0,R.$Bn)(k,{offset:$,length:m-$},v);for(let u=w.length-1;u>=0;u--){const f=w[u];k=S(k,f),$=Math.min($,f.offset),m=Math.max(m,f.offset+f.length),m+=f.content.length-f.length}const p=c.length-(k.length-m)-$;return[{offset:$,length:p,content:k.substring($,m)}]}e.$Hn=C;function S(c,y){return c.substring(0,y.offset)+y.content+c.substring(y.offset+y.length)}e.$In=S;function d(c,y){const v=y.slice(0).sort(($,m)=>{const w=$.offset-m.offset;return w===0?$.length-m.length:w});let k=c.length;for(let $=v.length-1;$>=0;$--){const m=v[$];if(m.offset+m.length<=k)c=S(c,m);else throw new Error("Overlapping edit");k=m.offset}return c}e.$Jn=d}),define(ae[61],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class n{constructor(P){this.d=P,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(P){this.c=P}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=n}),define(ae[103],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0;class n{static{this.Undefined=new n(void 0)}constructor(O){this.element=O,this.next=n.Undefined,this.prev=n.Undefined}}class R{constructor(){this.a=n.Undefined,this.b=n.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===n.Undefined}clear(){let O=this.a;for(;O!==n.Undefined;){const C=O.next;O.prev=n.Undefined,O.next=n.Undefined,O=C}this.a=n.Undefined,this.b=n.Undefined,this.c=0}unshift(O){return this.d(O,!1)}push(O){return this.d(O,!0)}d(O,C){const S=new n(O);if(this.a===n.Undefined)this.a=S,this.b=S;else if(C){const c=this.b;this.b=S,S.prev=c,c.next=S}else{const c=this.a;this.a=S,S.next=c,c.prev=S}this.c+=1;let d=!1;return()=>{d||(d=!0,this.e(S))}}shift(){if(this.a!==n.Undefined){const O=this.a.element;return this.e(this.a),O}}pop(){if(this.b!==n.Undefined){const O=this.b.element;return this.e(this.b),O}}e(O){if(O.prev!==n.Undefined&&O.next!==n.Undefined){const C=O.prev;C.next=O.next,O.next.prev=C}else O.prev===n.Undefined&&O.next===n.Undefined?(this.a=n.Undefined,this.b=n.Undefined):O.next===n.Undefined?(this.b=this.b.prev,this.b.next=n.Undefined):O.prev===n.Undefined&&(this.a=this.a.next,this.a.prev=n.Undefined);this.c-=1}*[Symbol.iterator](){let O=this.a;for(;O!==n.Undefined;)yield O.element,O=O.next}}e.$4c=R}),define(ae[31],ce([0,1]),function(X,e){"use strict";var n,R,P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function O(h,g,a){let t=h.get(g);return t===void 0&&(t=a,h.set(g,t)),t}e.$xc=O;function C(h){const g=[];return h.forEach((a,t)=>{g.push(`${t} => ${a}`)}),`Map(${h.size}) {${g.join(", ")}}`}e.$yc=C;function S(h){const g=[];return h.forEach(a=>{g.push(a)}),`Set(${h.size}) {${g.join(", ")}}`}e.$zc=S;class d{constructor(g,a){this.uri=g,this.value=a}}function c(h){return Array.isArray(h)}class y{static{this.c=g=>g.toString()}constructor(g,a){if(this[n]="ResourceMap",g instanceof y)this.d=new Map(g.d),this.e=a??y.c;else if(c(g)){this.d=new Map,this.e=a??y.c;for(const[t,o]of g)this.set(t,o)}else this.d=new Map,this.e=g??y.c}set(g,a){return this.d.set(this.e(g),new d(g,a)),this}get(g){return this.d.get(this.e(g))?.value}has(g){return this.d.has(this.e(g))}get size(){return this.d.size}clear(){this.d.clear()}delete(g){return this.d.delete(this.e(g))}forEach(g,a){typeof a<"u"&&(g=g.bind(a));for(const[t,o]of this.d)g(o.value,o.uri,this)}*values(){for(const g of this.d.values())yield g.value}*keys(){for(const g of this.d.values())yield g.uri}*entries(){for(const g of this.d.values())yield[g.uri,g.value]}*[(n=Symbol.toStringTag,Symbol.iterator)](){for(const[,g]of this.d)yield[g.uri,g.value]}}e.$Ac=y;class v{constructor(g,a){this[R]="ResourceSet",!g||typeof g=="function"?this.c=new y(g):(this.c=new y(a),g.forEach(this.add,this))}get size(){return this.c.size}add(g){return this.c.set(g,g),this}clear(){this.c.clear()}delete(g){return this.c.delete(g)}forEach(g,a){this.c.forEach((t,o)=>g.call(a,o,o,this))}has(g){return this.c.has(g)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=v;var k;(function(h){h[h.None=0]="None",h[h.AsOld=1]="AsOld",h[h.AsNew=2]="AsNew"})(k||(e.Touch=k={}));class ${constructor(){this[P]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(g){return this.c.has(g)}get(g,a=0){const t=this.c.get(g);if(t)return a!==0&&this.l(t,a),t.value}set(g,a,t=0){let o=this.c.get(g);if(o)o.value=a,t!==0&&this.l(o,t);else{switch(o={key:g,value:a,next:void 0,previous:void 0},t){case 0:this.j(o);break;case 1:this.i(o);break;case 2:this.j(o);break;default:this.j(o);break}this.c.set(g,o),this.f++}return this}delete(g){return!!this.remove(g)}remove(g){const a=this.c.get(g);if(a)return this.c.delete(g),this.k(a),this.f--,a.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const g=this.d;return this.c.delete(g.key),this.k(g),this.f--,g.value}forEach(g,a){const t=this.g;let o=this.d;for(;o;){if(a?g.bind(a)(o.value,o.key,this):g(o.value,o.key,this),this.g!==t)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const g=this,a=this.g;let t=this.d;const o={[Symbol.iterator](){return o},next(){if(g.g!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const r={value:t.key,done:!1};return t=t.next,r}else return{value:void 0,done:!0}}};return o}values(){const g=this,a=this.g;let t=this.d;const o={[Symbol.iterator](){return o},next(){if(g.g!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const r={value:t.value,done:!1};return t=t.next,r}else return{value:void 0,done:!0}}};return o}entries(){const g=this,a=this.g;let t=this.d;const o={[Symbol.iterator](){return o},next(){if(g.g!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const r={value:[t.key,t.value],done:!1};return t=t.next,r}else return{value:void 0,done:!0}}};return o}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(g){if(g>=this.size)return;if(g===0){this.clear();return}let a=this.d,t=this.size;for(;a&&t>g;)this.c.delete(a.key),a=a.next,t--;this.d=a,this.f=t,a&&(a.previous=void 0),this.g++}i(g){if(!this.d&&!this.e)this.e=g;else if(this.d)g.next=this.d,this.d.previous=g;else throw new Error("Invalid list");this.d=g,this.g++}j(g){if(!this.d&&!this.e)this.d=g;else if(this.e)g.previous=this.e,this.e.next=g;else throw new Error("Invalid list");this.e=g,this.g++}k(g){if(g===this.d&&g===this.e)this.d=void 0,this.e=void 0;else if(g===this.d){if(!g.next)throw new Error("Invalid list");g.next.previous=void 0,this.d=g.next}else if(g===this.e){if(!g.previous)throw new Error("Invalid list");g.previous.next=void 0,this.e=g.previous}else{const a=g.next,t=g.previous;if(!a||!t)throw new Error("Invalid list");a.previous=t,t.next=a}g.next=void 0,g.previous=void 0,this.g++}l(g,a){if(!this.d||!this.e)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(g===this.d)return;const t=g.next,o=g.previous;g===this.e?(o.next=void 0,this.e=o):(t.previous=o,o.next=t),g.previous=void 0,g.next=this.d,this.d.previous=g,this.d=g,this.g++}else if(a===2){if(g===this.e)return;const t=g.next,o=g.previous;g===this.d?(t.previous=void 0,this.d=t):(t.previous=o,o.next=t),g.next=void 0,g.previous=this.e,this.e.next=g,this.e=g,this.g++}}}toJSON(){const g=[];return this.forEach((a,t)=>{g.push([t,a])}),g}fromJSON(g){this.clear();for(const[a,t]of g)this.set(a,t)}}e.$Cc=$;class m extends ${constructor(g,a=1){super(),this.m=g,this.n=Math.min(Math.max(0,a),1)}get limit(){return this.m}set limit(g){this.m=g,this.o()}get ratio(){return this.n}set ratio(g){this.n=Math.min(Math.max(0,g),1),this.o()}get(g,a=2){return super.get(g,a)}peek(g){return super.get(g,0)}set(g,a){return super.set(g,a,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Dc=m;class w{constructor(){this.c=new Map}add(g){return this.c.set(g,(this.c.get(g)||0)+1),this}delete(g){let a=this.c.get(g)||0;return a===0?!1:(a--,a===0?this.c.delete(g):this.c.set(g,a),!0)}has(g){return this.c.has(g)}}e.$Ec=w;class p{constructor(g){if(this.c=new Map,this.d=new Map,g)for(const[a,t]of g)this.set(a,t)}clear(){this.c.clear(),this.d.clear()}set(g,a){this.c.set(g,a),this.d.set(a,g)}get(g){return this.c.get(g)}getKey(g){return this.d.get(g)}delete(g){const a=this.c.get(g);return a===void 0?!1:(this.c.delete(g),this.d.delete(a),!0)}forEach(g,a){this.c.forEach((t,o)=>{g.call(a,t,o,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Fc=p;class u{constructor(){this.c=new Map}add(g,a){let t=this.c.get(g);t||(t=new Set,this.c.set(g,t)),t.add(a)}delete(g,a){const t=this.c.get(g);t&&(t.delete(a),t.size===0&&this.c.delete(g))}forEach(g,a){const t=this.c.get(g);t&&t.forEach(a)}get(g){const a=this.c.get(g);return a||new Set}}e.$Gc=u;function f(h,g){if(h===g)return!0;if(h.size!==g.size)return!1;for(const[a,t]of h)if(!g.has(a)||g.get(a)!==t)return!1;for(const[a]of g)if(!h.has(a))return!1;return!0}e.$Hc=f}),define(ae[2],ce([0,1,22,137,31,85,71]),function(X,e,n,R,P,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=void 0;const S=!1;let d=null;class c{constructor(){this.b=new Map}static{this.a=0}c(M){let T=this.b.get(M);return T||(T={parent:null,source:null,isSingleton:!1,value:M,idx:c.a++},this.b.set(M,T)),T}trackDisposable(M){const T=this.c(M);T.source||(T.source=new Error().stack)}setParent(M,T){const W=this.c(M);W.parent=T}markAsDisposed(M){this.b.delete(M)}markAsSingleton(M){this.c(M).isSingleton=!0}f(M,T){const W=T.get(M);if(W)return W;const V=M.parent?this.f(this.c(M.parent),T):M;return T.set(M,V),V}getTrackedDisposables(){const M=new Map;return[...this.b.entries()].filter(([,W])=>W.source!==null&&!this.f(W,M).isSingleton).flatMap(([W])=>W)}computeLeakingDisposables(M=10,T){let W;if(T)W=T;else{const ue=new Map,Q=[...this.b.values()].filter(U=>U.source!==null&&!this.f(U,ue).isSingleton);if(Q.length===0)return;const Y=new Set(Q.map(U=>U.value));if(W=Q.filter(U=>!(U.parent&&Y.has(U.parent))),W.length===0)throw new Error("There are cyclic diposable chains!")}if(!W)return;function V(ue){function Q(U,L){for(;U.length>0&&L.some(N=>typeof N=="string"?N===U[0]:U[0].match(N));)U.shift()}const Y=ue.source.split(`
`).map(U=>U.trim().replace("at ","")).filter(U=>U!=="");return Q(Y,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Y.reverse()}const J=new P.$Gc;for(const ue of W){const Q=V(ue);for(let Y=0;Y<=Q.length;Y++)J.add(Q.slice(0,Y).join(`
`),ue)}W.sort((0,n.$7b)(ue=>ue.idx,n.$9b));let le="",re=0;for(const ue of W.slice(0,M)){re++;const Q=V(ue),Y=[];for(let U=0;U<Q.length;U++){let L=Q[U];L=`(shared with ${J.get(Q.slice(0,U+1).join(`
`)).size}/${W.length} leaks) at ${L}`;const G=J.get(Q.slice(0,U).join(`
`)),q=(0,R.$K)([...G].map(oe=>V(oe)[U]),oe=>oe);delete q[Q[U]];for(const[oe,he]of Object.entries(q))Y.unshift(`    - stacktraces of ${he.length} other leaks continue with ${oe}`);Y.unshift(L)}le+=`


==================== Leaking disposable ${re}/${W.length}: ${ue.value.constructor.name} ====================
${Y.join(`
`)}
============================================================

`}return W.length>M&&(le+=`


... and ${W.length-M} more leaking disposables

`),{leaks:W,details:le}}}e.$Ic=c;function y(I){d=I}if(e.$Jc=y,S){const I="__is_disposable_tracked__";y(new class{trackDisposable(M){const T=new Error("Potentially leaked disposable").stack;setTimeout(()=>{M[I]||console.log(T)},3e3)}setParent(M,T){if(M&&M!==t.None)try{M[I]=!0}catch{}}markAsDisposed(M){if(M&&M!==t.None)try{M[I]=!0}catch{}}markAsSingleton(M){}})}function v(I){return d?.trackDisposable(I),I}e.$Kc=v;function k(I){d?.markAsDisposed(I)}e.$Lc=k;function $(I,M){d?.setParent(I,M)}function m(I,M){if(d)for(const T of I)d.setParent(T,M)}function w(I){return d?.markAsSingleton(I),I}e.$Mc=w;function p(I){return typeof I.dispose=="function"&&I.dispose.length===0}e.$Nc=p;function u(I){if(C.Iterable.is(I)){const M=[];for(const T of I)if(T)try{T.dispose()}catch(W){M.push(W)}if(M.length===1)throw M[0];if(M.length>1)throw new AggregateError(M,"Encountered errors while disposing of store");return Array.isArray(I)?[]:I}else if(I)return I.dispose(),I}e.$Oc=u;function f(I){for(const M of I)p(M)&&M.dispose();return[]}e.$Pc=f;function h(...I){const M=g(()=>u(I));return m(I,M),M}e.$Qc=h;function g(I){const M=v({dispose:(0,O.$db)(()=>{k(M),I()})});return M}e.$Rc=g;class a{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,v(this)}dispose(){this.g||(k(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{u(this.f)}finally{this.f.clear()}}add(M){if(!M)return M;if(M===this)throw new Error("Cannot register a disposable on itself!");return $(M,this),this.g?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(M),M}delete(M){if(M){if(M===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(M),M.dispose()}}deleteAndLeak(M){M&&this.f.has(M)&&(this.f.delete(M),$(M,null))}}e.$Sc=a;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new a,v(this),$(this.q,this)}dispose(){k(this),this.q.dispose()}B(M){if(M===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(M)}}e.$Tc=t;class o{constructor(){this.b=!1,v(this)}get value(){return this.b?void 0:this.a}set value(M){this.b||M===this.a||(this.a?.dispose(),M&&$(M,this),this.a=M)}clear(){this.value=void 0}dispose(){this.b=!0,k(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const M=this.a;return this.a=void 0,M&&$(M,null),M}}e.$Uc=o;class r{constructor(M){this.a=new o,this.b=!1,this.a.value=M}get value(){return this.a.value}set value(M){this.b||M===this.a.value||(this.a.value=M)}dispose(){this.b=!0,this.a.dispose()}}e.$Vc=r;class i{constructor(M){this.b=M,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Wc=i;class s{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,v(this)}set(M){let T=M;return this.unset=()=>T=void 0,this.isset=()=>T!==void 0,this.dispose=()=>{T&&(T(),T=void 0,k(this))},this}}e.$Xc=s;class l{constructor(){this.a=new Map}acquire(M,...T){let W=this.a.get(M);W||(W={counter:0,object:this.b(M,...T)},this.a.set(M,W));const{object:V}=W,J=(0,O.$db)(()=>{--W.counter===0&&(this.c(M,W.object),this.a.delete(M))});return W.counter++,{object:V,dispose:J}}}e.$Yc=l;class b{constructor(M){this.a=M}async acquire(M,...T){const W=this.a.acquire(M,...T);try{return{object:await W.object,dispose:()=>W.dispose()}}catch(V){throw W.dispose(),V}}}e.$Zc=b;class D{constructor(M){this.object=M}dispose(){}}e.$1c=D;function j(I){const M=new a;try{I(M)}finally{M.dispose()}}e.$2c=j;class E{constructor(){this.a=new Map,this.b=!1,v(this)}dispose(){k(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{u(this.a.values())}finally{this.a.clear()}}has(M){return this.a.has(M)}get size(){return this.a.size}get(M){return this.a.get(M)}set(M,T,W=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),W||this.a.get(M)?.dispose(),this.a.set(M,T)}deleteAndDispose(M){this.a.get(M)?.dispose(),this.a.delete(M)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$3c=E}),define(ae[86],ce([0,1,31]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sl=e.$Rl=e.$Ql=void 0;const R=new n.$Dc(1e4);function P(c){return d(c,"NFC",R)}e.$Ql=P;const O=new n.$Dc(1e4);function C(c){return d(c,"NFD",O)}e.$Rl=C;const S=/[^\u0000-\u0080]/;function d(c,y,v){if(!c)return c;const k=v.get(c);if(k)return k;let $;return S.test(c)?$=c.normalize(y):$=c,v.set(c,$),$}e.$Sl=function(){const c=/[\u0300-\u036f]/g;return function(y){return C(y).replace(c,"")}}()}),define(ae[141],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$im=e.$hm=e.$gm=e.rot=e.$em=void 0;function n(S,d,c){return Math.min(Math.max(S,d),c)}e.$em=n;function R(S,d){return(d+S%d)%d}e.rot=R;class P{constructor(){this.a=0}getNext(){return this.a++}}e.$gm=P;class O{constructor(){this.a=1,this.b=0}update(d){return this.b=this.b+(d-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$hm=O;class C{constructor(d){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(d),this.c.fill(0,0,d)}update(d){const c=this.c[this.d];return this.c[this.d]=d,this.d=(this.d+1)%this.c.length,this.e-=c,this.e+=d,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$im=C}),function(){function X(P){const O=[];typeof P=="number"&&O.push("code/timeOrigin",P);function C(d){O.push(d,Date.now())}function S(){const d=[];for(let c=0;c<O.length;c+=2)d.push({name:O[c],startTime:O[c+1]});return d}return{mark:C,getMarks:S}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?X():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const C of performance.getEntriesByType("mark"))O.push({name:C.name,startTime:Math.round(P+C.startTime)});return O}};if(typeof process=="object"){const P=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return X(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),X()}function n(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return n(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=n(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=n(R))}(),function(X,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var n=e();for(var R in n)(typeof exports=="object"?exports:X)[R]=n[R]}}(typeof self<"u"?self:this,function(){return function(X){var e={};function n(R){if(e[R])return e[R].exports;var P=e[R]={i:R,l:!1,exports:{}};return X[R].call(P.exports,P,P.exports,n),P.l=!0,P.exports}return n.m=X,n.c=e,n.d=function(R,P,O){n.o(R,P)||Object.defineProperty(R,P,{enumerable:!0,get:O})},n.r=function(R){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},n.t=function(R,P){if(1&P&&(R=n(R)),8&P||4&P&&typeof R=="object"&&R&&R.__esModule)return R;var O=Object.create(null);if(n.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:R}),2&P&&typeof R!="string")for(var C in R)n.d(O,C,function(S){return R[S]}.bind(null,C));return O},n.n=function(R){var P=R&&R.__esModule?function(){return R.default}:function(){return R};return n.d(P,"a",P),P},n.o=function(R,P){return Object.prototype.hasOwnProperty.call(R,P)},n.p="",n(n.s=0)}([function(X,e,n){(function(R){var P;e=X.exports=he,P=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var te=Array.prototype.slice.call(arguments,0);te.unshift("SEMVER"),console.log.apply(console,te)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var O=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,S=e.re=[],d=e.src=[],c=0,y=c++;d[y]="0|[1-9]\\d*";var v=c++;d[v]="[0-9]+";var k=c++;d[k]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var $=c++;d[$]="("+d[y]+")\\.("+d[y]+")\\.("+d[y]+")";var m=c++;d[m]="("+d[v]+")\\.("+d[v]+")\\.("+d[v]+")";var w=c++;d[w]="(?:"+d[y]+"|"+d[k]+")";var p=c++;d[p]="(?:"+d[v]+"|"+d[k]+")";var u=c++;d[u]="(?:-("+d[w]+"(?:\\."+d[w]+")*))";var f=c++;d[f]="(?:-?("+d[p]+"(?:\\."+d[p]+")*))";var h=c++;d[h]="[0-9A-Za-z-]+";var g=c++;d[g]="(?:\\+("+d[h]+"(?:\\."+d[h]+")*))";var a=c++,t="v?"+d[$]+d[u]+"?"+d[g]+"?";d[a]="^"+t+"$";var o="[v=\\s]*"+d[m]+d[f]+"?"+d[g]+"?",r=c++;d[r]="^"+o+"$";var i=c++;d[i]="((?:<|>)?=?)";var s=c++;d[s]=d[v]+"|x|X|\\*";var l=c++;d[l]=d[y]+"|x|X|\\*";var b=c++;d[b]="[v=\\s]*("+d[l]+")(?:\\.("+d[l]+")(?:\\.("+d[l]+")(?:"+d[u]+")?"+d[g]+"?)?)?";var D=c++;d[D]="[v=\\s]*("+d[s]+")(?:\\.("+d[s]+")(?:\\.("+d[s]+")(?:"+d[f]+")?"+d[g]+"?)?)?";var j=c++;d[j]="^"+d[i]+"\\s*"+d[b]+"$";var E=c++;d[E]="^"+d[i]+"\\s*"+d[D]+"$";var I=c++;d[I]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var M=c++;d[M]="(?:~>?)";var T=c++;d[T]="(\\s*)"+d[M]+"\\s+",S[T]=new RegExp(d[T],"g");var W=c++;d[W]="^"+d[M]+d[b]+"$";var V=c++;d[V]="^"+d[M]+d[D]+"$";var J=c++;d[J]="(?:\\^)";var le=c++;d[le]="(\\s*)"+d[J]+"\\s+",S[le]=new RegExp(d[le],"g");var re=c++;d[re]="^"+d[J]+d[b]+"$";var ue=c++;d[ue]="^"+d[J]+d[D]+"$";var Q=c++;d[Q]="^"+d[i]+"\\s*("+o+")$|^$";var Y=c++;d[Y]="^"+d[i]+"\\s*("+t+")$|^$";var U=c++;d[U]="(\\s*)"+d[i]+"\\s*("+o+"|"+d[b]+")",S[U]=new RegExp(d[U],"g");var L=c++;d[L]="^\\s*("+d[b]+")\\s+-\\s+("+d[b]+")\\s*$";var N=c++;d[N]="^\\s*("+d[D]+")\\s+-\\s+("+d[D]+")\\s*$";var G=c++;d[G]="(<|>)?=?\\s*\\*";for(var q=0;q<35;q++)P(q,d[q]),S[q]||(S[q]=new RegExp(d[q]));function oe(te,fe){if(te instanceof he)return te;if(typeof te!="string"||te.length>O||!(fe?S[r]:S[a]).test(te))return null;try{return new he(te,fe)}catch{return null}}function he(te,fe){if(te instanceof he){if(te.loose===fe)return te;te=te.version}else if(typeof te!="string")throw new TypeError("Invalid Version: "+te);if(te.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof he))return new he(te,fe);P("SemVer",te,fe),this.loose=fe;var ge=te.trim().match(fe?S[r]:S[a]);if(!ge)throw new TypeError("Invalid Version: "+te);if(this.raw=te,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Ie){if(/^[0-9]+$/.test(Ie)){var Ae=+Ie;if(Ae>=0&&Ae<C)return Ae}return Ie}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=oe,e.valid=function(te,fe){var ge=oe(te,fe);return ge?ge.version:null},e.clean=function(te,fe){var ge=oe(te.trim().replace(/^[=v]+/,""),fe);return ge?ge.version:null},e.SemVer=he,he.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},he.prototype.toString=function(){return this.version},he.prototype.compare=function(te){return P("SemVer.compare",this.version,this.loose,te),te instanceof he||(te=new he(te,this.loose)),this.compareMain(te)||this.comparePre(te)},he.prototype.compareMain=function(te){return te instanceof he||(te=new he(te,this.loose)),A(this.major,te.major)||A(this.minor,te.minor)||A(this.patch,te.patch)},he.prototype.comparePre=function(te){if(te instanceof he||(te=new he(te,this.loose)),this.prerelease.length&&!te.prerelease.length)return-1;if(!this.prerelease.length&&te.prerelease.length)return 1;if(!this.prerelease.length&&!te.prerelease.length)return 0;var fe=0;do{var ge=this.prerelease[fe],Ie=te.prerelease[fe];if(P("prerelease compare",fe,ge,Ie),ge===void 0&&Ie===void 0)return 0;if(Ie===void 0)return 1;if(ge===void 0)return-1;if(ge!==Ie)return A(ge,Ie)}while(++fe)},he.prototype.inc=function(te,fe){switch(te){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",fe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",fe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",fe),this.inc("pre",fe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",fe),this.inc("pre",fe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}fe&&(this.prerelease[0]===fe?isNaN(this.prerelease[1])&&(this.prerelease=[fe,0]):this.prerelease=[fe,0]);break;default:throw new Error("invalid increment argument: "+te)}return this.format(),this.raw=this.version,this},e.inc=function(te,fe,ge,Ie){typeof ge=="string"&&(Ie=ge,ge=void 0);try{return new he(te,ge).inc(fe,Ie).version}catch{return null}},e.diff=function(te,fe){if(Z(te,fe))return null;var ge=oe(te),Ie=oe(fe);if(ge.prerelease.length||Ie.prerelease.length){for(var Ae in ge)if((Ae==="major"||Ae==="minor"||Ae==="patch")&&ge[Ae]!==Ie[Ae])return"pre"+Ae;return"prerelease"}for(var Ae in ge)if((Ae==="major"||Ae==="minor"||Ae==="patch")&&ge[Ae]!==Ie[Ae])return Ae},e.compareIdentifiers=A;var K=/^[0-9]+$/;function A(te,fe){var ge=K.test(te),Ie=K.test(fe);return ge&&Ie&&(te=+te,fe=+fe),ge&&!Ie?-1:Ie&&!ge?1:te<fe?-1:te>fe?1:0}function F(te,fe,ge){return new he(te,ge).compare(new he(fe,ge))}function x(te,fe,ge){return F(te,fe,ge)>0}function z(te,fe,ge){return F(te,fe,ge)<0}function Z(te,fe,ge){return F(te,fe,ge)===0}function H(te,fe,ge){return F(te,fe,ge)!==0}function _(te,fe,ge){return F(te,fe,ge)>=0}function B(te,fe,ge){return F(te,fe,ge)<=0}function ee(te,fe,ge,Ie){var Ae;switch(fe){case"===":typeof te=="object"&&(te=te.version),typeof ge=="object"&&(ge=ge.version),Ae=te===ge;break;case"!==":typeof te=="object"&&(te=te.version),typeof ge=="object"&&(ge=ge.version),Ae=te!==ge;break;case"":case"=":case"==":Ae=Z(te,ge,Ie);break;case"!=":Ae=H(te,ge,Ie);break;case">":Ae=x(te,ge,Ie);break;case">=":Ae=_(te,ge,Ie);break;case"<":Ae=z(te,ge,Ie);break;case"<=":Ae=B(te,ge,Ie);break;default:throw new TypeError("Invalid operator: "+fe)}return Ae}function ie(te,fe){if(te instanceof ie){if(te.loose===fe)return te;te=te.value}if(!(this instanceof ie))return new ie(te,fe);P("comparator",te,fe),this.loose=fe,this.parse(te),this.semver===de?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(te,fe){return A(fe,te)},e.major=function(te,fe){return new he(te,fe).major},e.minor=function(te,fe){return new he(te,fe).minor},e.patch=function(te,fe){return new he(te,fe).patch},e.compare=F,e.compareLoose=function(te,fe){return F(te,fe,!0)},e.rcompare=function(te,fe,ge){return F(fe,te,ge)},e.sort=function(te,fe){return te.sort(function(ge,Ie){return e.compare(ge,Ie,fe)})},e.rsort=function(te,fe){return te.sort(function(ge,Ie){return e.rcompare(ge,Ie,fe)})},e.gt=x,e.lt=z,e.eq=Z,e.neq=H,e.gte=_,e.lte=B,e.cmp=ee,e.Comparator=ie;var de={};function me(te,fe){if(te instanceof me)return te.loose===fe?te:new me(te.raw,fe);if(te instanceof ie)return new me(te.value,fe);if(!(this instanceof me))return new me(te,fe);if(this.loose=fe,this.raw=te,this.set=te.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+te);this.format()}function Ee(te){return!te||te.toLowerCase()==="x"||te==="*"}function Pe(te,fe,ge,Ie,Ae,Te,Me,Ge,Ue,Ke,He,qe,ne){return((fe=Ee(ge)?"":Ee(Ie)?">="+ge+".0.0":Ee(Ae)?">="+ge+"."+Ie+".0":">="+fe)+" "+(Ge=Ee(Ue)?"":Ee(Ke)?"<"+(+Ue+1)+".0.0":Ee(He)?"<"+Ue+"."+(+Ke+1)+".0":qe?"<="+Ue+"."+Ke+"."+He+"-"+qe:"<="+Ge)).trim()}function Le(te,fe){for(var ge=0;ge<te.length;ge++)if(!te[ge].test(fe))return!1;if(fe.prerelease.length){for(ge=0;ge<te.length;ge++)if(P(te[ge].semver),te[ge].semver!==de&&te[ge].semver.prerelease.length>0){var Ie=te[ge].semver;if(Ie.major===fe.major&&Ie.minor===fe.minor&&Ie.patch===fe.patch)return!0}return!1}return!0}function ke(te,fe,ge){try{fe=new me(fe,ge)}catch{return!1}return fe.test(te)}function ye(te,fe,ge,Ie){var Ae,Te,Me,Ge,Ue;switch(te=new he(te,Ie),fe=new me(fe,Ie),ge){case">":Ae=x,Te=B,Me=z,Ge=">",Ue=">=";break;case"<":Ae=z,Te=_,Me=x,Ge="<",Ue="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ke(te,fe,Ie))return!1;for(var Ke=0;Ke<fe.set.length;++Ke){var He=fe.set[Ke],qe=null,ne=null;if(He.forEach(function($e){$e.semver===de&&($e=new ie(">=0.0.0")),qe=qe||$e,ne=ne||$e,Ae($e.semver,qe.semver,Ie)?qe=$e:Me($e.semver,ne.semver,Ie)&&(ne=$e)}),qe.operator===Ge||qe.operator===Ue||(!ne.operator||ne.operator===Ge)&&Te(te,ne.semver)||ne.operator===Ue&&Me(te,ne.semver))return!1}return!0}ie.prototype.parse=function(te){var fe=this.loose?S[Q]:S[Y],ge=te.match(fe);if(!ge)throw new TypeError("Invalid comparator: "+te);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new he(ge[2],this.loose):this.semver=de},ie.prototype.toString=function(){return this.value},ie.prototype.test=function(te){return P("Comparator.test",te,this.loose),this.semver===de||(typeof te=="string"&&(te=new he(te,this.loose)),ee(te,this.operator,this.semver,this.loose))},ie.prototype.intersects=function(te,fe){if(!(te instanceof ie))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new me(te.value,fe),ke(this.value,ge,fe);if(te.operator==="")return ge=new me(this.value,fe),ke(te.semver,ge,fe);var Ie=!(this.operator!==">="&&this.operator!==">"||te.operator!==">="&&te.operator!==">"),Ae=!(this.operator!=="<="&&this.operator!=="<"||te.operator!=="<="&&te.operator!=="<"),Te=this.semver.version===te.semver.version,Me=!(this.operator!==">="&&this.operator!=="<="||te.operator!==">="&&te.operator!=="<="),Ge=ee(this.semver,"<",te.semver,fe)&&(this.operator===">="||this.operator===">")&&(te.operator==="<="||te.operator==="<"),Ue=ee(this.semver,">",te.semver,fe)&&(this.operator==="<="||this.operator==="<")&&(te.operator===">="||te.operator===">");return Ie||Ae||Te&&Me||Ge||Ue},e.Range=me,me.prototype.format=function(){return this.range=this.set.map(function(te){return te.join(" ").trim()}).join("||").trim(),this.range},me.prototype.toString=function(){return this.range},me.prototype.parseRange=function(te){var fe=this.loose;te=te.trim(),P("range",te,fe);var ge=fe?S[N]:S[L];te=te.replace(ge,Pe),P("hyphen replace",te),te=te.replace(S[U],"$1$2$3"),P("comparator trim",te,S[U]),te=(te=(te=te.replace(S[T],"$1~")).replace(S[le],"$1^")).split(/\s+/).join(" ");var Ie=fe?S[Q]:S[Y],Ae=te.split(" ").map(function(Te){return function(Me,Ge){return P("comp",Me),Me=function(Ue,Ke){return Ue.trim().split(/\s+/).map(function(He){return function(qe,ne){P("caret",qe,ne);var $e=ne?S[ue]:S[re];return qe.replace($e,function(pe,be,Se,Oe,Ne){var Xe;return P("caret",qe,pe,be,Se,Oe,Ne),Ee(be)?Xe="":Ee(Se)?Xe=">="+be+".0.0 <"+(+be+1)+".0.0":Ee(Oe)?Xe=be==="0"?">="+be+"."+Se+".0 <"+be+"."+(+Se+1)+".0":">="+be+"."+Se+".0 <"+(+be+1)+".0.0":Ne?(P("replaceCaret pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Xe=be==="0"?Se==="0"?">="+be+"."+Se+"."+Oe+Ne+" <"+be+"."+Se+"."+(+Oe+1):">="+be+"."+Se+"."+Oe+Ne+" <"+be+"."+(+Se+1)+".0":">="+be+"."+Se+"."+Oe+Ne+" <"+(+be+1)+".0.0"):(P("no pr"),Xe=be==="0"?Se==="0"?">="+be+"."+Se+"."+Oe+" <"+be+"."+Se+"."+(+Oe+1):">="+be+"."+Se+"."+Oe+" <"+be+"."+(+Se+1)+".0":">="+be+"."+Se+"."+Oe+" <"+(+be+1)+".0.0"),P("caret return",Xe),Xe})}(He,Ke)}).join(" ")}(Me,Ge),P("caret",Me),Me=function(Ue,Ke){return Ue.trim().split(/\s+/).map(function(He){return function(qe,ne){var $e=ne?S[V]:S[W];return qe.replace($e,function(pe,be,Se,Oe,Ne){var Xe;return P("tilde",qe,pe,be,Se,Oe,Ne),Ee(be)?Xe="":Ee(Se)?Xe=">="+be+".0.0 <"+(+be+1)+".0.0":Ee(Oe)?Xe=">="+be+"."+Se+".0 <"+be+"."+(+Se+1)+".0":Ne?(P("replaceTilde pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Xe=">="+be+"."+Se+"."+Oe+Ne+" <"+be+"."+(+Se+1)+".0"):Xe=">="+be+"."+Se+"."+Oe+" <"+be+"."+(+Se+1)+".0",P("tilde return",Xe),Xe})}(He,Ke)}).join(" ")}(Me,Ge),P("tildes",Me),Me=function(Ue,Ke){return P("replaceXRanges",Ue,Ke),Ue.split(/\s+/).map(function(He){return function(qe,ne){qe=qe.trim();var $e=ne?S[E]:S[j];return qe.replace($e,function(pe,be,Se,Oe,Ne,Xe){P("xRange",qe,pe,be,Se,Oe,Ne,Xe);var xe=Ee(Se),Qe=xe||Ee(Oe),Ze=Qe||Ee(Ne);return be==="="&&Ze&&(be=""),xe?pe=be===">"||be==="<"?"<0.0.0":"*":be&&Ze?(Qe&&(Oe=0),Ze&&(Ne=0),be===">"?(be=">=",Qe?(Se=+Se+1,Oe=0,Ne=0):Ze&&(Oe=+Oe+1,Ne=0)):be==="<="&&(be="<",Qe?Se=+Se+1:Oe=+Oe+1),pe=be+Se+"."+Oe+"."+Ne):Qe?pe=">="+Se+".0.0 <"+(+Se+1)+".0.0":Ze&&(pe=">="+Se+"."+Oe+".0 <"+Se+"."+(+Oe+1)+".0"),P("xRange return",pe),pe})}(He,Ke)}).join(" ")}(Me,Ge),P("xrange",Me),Me=function(Ue,Ke){return P("replaceStars",Ue,Ke),Ue.trim().replace(S[G],"")}(Me,Ge),P("stars",Me),Me}(Te,fe)}).join(" ").split(/\s+/);return this.loose&&(Ae=Ae.filter(function(Te){return!!Te.match(Ie)})),Ae=Ae.map(function(Te){return new ie(Te,fe)})},me.prototype.intersects=function(te,fe){if(!(te instanceof me))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Ie){return te.set.some(function(Ae){return Ae.every(function(Te){return Ie.intersects(Te,fe)})})})})},e.toComparators=function(te,fe){return new me(te,fe).set.map(function(ge){return ge.map(function(Ie){return Ie.value}).join(" ").trim().split(" ")})},me.prototype.test=function(te){if(!te)return!1;typeof te=="string"&&(te=new he(te,this.loose));for(var fe=0;fe<this.set.length;fe++)if(Le(this.set[fe],te))return!0;return!1},e.satisfies=ke,e.maxSatisfying=function(te,fe,ge){var Ie=null,Ae=null;try{var Te=new me(fe,ge)}catch{return null}return te.forEach(function(Me){Te.test(Me)&&(Ie&&Ae.compare(Me)!==-1||(Ae=new he(Ie=Me,ge)))}),Ie},e.minSatisfying=function(te,fe,ge){var Ie=null,Ae=null;try{var Te=new me(fe,ge)}catch{return null}return te.forEach(function(Me){Te.test(Me)&&(Ie&&Ae.compare(Me)!==1||(Ae=new he(Ie=Me,ge)))}),Ie},e.validRange=function(te,fe){try{return new me(te,fe).range||"*"}catch{return null}},e.ltr=function(te,fe,ge){return ye(te,fe,"<",ge)},e.gtr=function(te,fe,ge){return ye(te,fe,">",ge)},e.outside=ye,e.prerelease=function(te,fe){var ge=oe(te,fe);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(te,fe,ge){return te=new me(te,ge),fe=new me(fe,ge),te.intersects(fe)},e.coerce=function(te){if(te instanceof he)return te;if(typeof te!="string")return null;var fe=te.match(S[I]);return fe==null?null:oe((fe[1]||"0")+"."+(fe[2]||"0")+"."+(fe[3]||"0"))}}).call(this,n(1))},function(X,e){var n,R,P=X.exports={};function O(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function S(p){if(n===setTimeout)return setTimeout(p,0);if((n===O||!n)&&setTimeout)return n=setTimeout,setTimeout(p,0);try{return n(p,0)}catch{try{return n.call(null,p,0)}catch{return n.call(this,p,0)}}}(function(){try{n=typeof setTimeout=="function"?setTimeout:O}catch{n=O}try{R=typeof clearTimeout=="function"?clearTimeout:C}catch{R=C}})();var d,c=[],y=!1,v=-1;function k(){y&&d&&(y=!1,d.length?c=d.concat(c):v=-1,c.length&&$())}function $(){if(!y){var p=S(k);y=!0;for(var u=c.length;u;){for(d=c,c=[];++v<u;)d&&d[v].run();v=-1,u=c.length}d=null,y=!1,function(f){if(R===clearTimeout)return clearTimeout(f);if((R===C||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(f);try{R(f)}catch{try{return R.call(null,f)}catch{return R.call(this,f)}}}(p)}}function m(p,u){this.fun=p,this.array=u}function w(){}P.nextTick=function(p){var u=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)u[f-1]=arguments[f];c.push(new m(p,u)),c.length!==1||y||S($)},m.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=w,P.addListener=w,P.once=w,P.off=w,P.removeListener=w,P.removeAllListeners=w,P.emit=w,P.prependListener=w,P.prependOnceListener=w,P.listeners=function(p){return[]},P.binding=function(p){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(p){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(ae[142],ce([0,1]),function(X,e){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$cs=void 0;class R{constructor(S,d,c){this.level=S,this.key=d,this.value=c,this.forward=[]}}const P=void 0;class O{constructor(S,d=2**16){this.comparator=S,this[n]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(d)|0),this.e=new R(this.c,P,P)}get size(){return this.f}clear(){this.e=new R(this.c,P,P),this.f=0}has(S){return!!O.g(this,S,this.comparator)}get(S){return O.g(this,S,this.comparator)?.value}set(S,d){return O.h(this,S,d,this.comparator)&&(this.f+=1),this}delete(S){const d=O.k(this,S,this.comparator);return d&&(this.f-=1),d}forEach(S,d){let c=this.e.forward[0];for(;c;)S.call(d,c.value,c.key,this),c=c.forward[0]}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let S=this.e.forward[0];for(;S;)yield[S.key,S.value],S=S.forward[0]}*keys(){let S=this.e.forward[0];for(;S;)yield S.key,S=S.forward[0]}*values(){let S=this.e.forward[0];for(;S;)yield S.value,S=S.forward[0]}toString(){let S="[SkipList]:",d=this.e.forward[0];for(;d;)S+=`node(${d.key}, ${d.value}, lvl:${d.level})`,d=d.forward[0];return S}static g(S,d,c){let y=S.e;for(let v=S.d-1;v>=0;v--)for(;y.forward[v]&&c(y.forward[v].key,d)<0;)y=y.forward[v];if(y=y.forward[0],y&&c(y.key,d)===0)return y}static h(S,d,c,y){const v=[];let k=S.e;for(let $=S.d-1;$>=0;$--){for(;k.forward[$]&&y(k.forward[$].key,d)<0;)k=k.forward[$];v[$]=k}if(k=k.forward[0],k&&y(k.key,d)===0)return k.value=c,!1;{const $=O.j(S);if($>S.d){for(let m=S.d;m<$;m++)v[m]=S.e;S.d=$}k=new R($,d,c);for(let m=0;m<$;m++)k.forward[m]=v[m].forward[m],v[m].forward[m]=k;return!0}}static j(S,d=.5){let c=1;for(;Math.random()<d&&c<S.c;)c+=1;return c}static k(S,d,c){const y=[];let v=S.e;for(let k=S.d-1;k>=0;k--){for(;v.forward[k]&&c(v.forward[k].key,d)<0;)v=v.forward[k];y[k]=v}if(v=v.forward[0],!v||c(v.key,d)!==0)return!1;for(let k=0;k<S.d&&y[k].forward[k]===v;k++)y[k].forward[k]=v.forward[k];for(;S.d>0&&S.e.forward[S.d-1]===P;)S.d-=1;return!0}}e.$cs=O}),define(ae[72],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1d=void 0;const n=globalThis.performance&&typeof globalThis.performance.now=="function";class R{static create(O){return new R(O)}constructor(O){this.c=n&&O===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$1d=R}),define(ae[3],ce([0,1,15,85,2,103,72]),function(X,e,n,R,P,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.Event=void 0;const S=!1,d=!1;var c;(function(j){j.None=()=>P.$Tc.None;function E(B){if(d){const{onDidAddListener:ee}=B,ie=m.create();let de=0;B.onDidAddListener=()=>{++de===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ie.print()),ee?.()}}}function I(B,ee){return Y(B,()=>{},0,void 0,!0,void 0,ee)}j.defer=I;function M(B){return(ee,ie=null,de)=>{let me=!1,Ee;return Ee=B(Pe=>{if(!me)return Ee?Ee.dispose():me=!0,ee.call(ie,Pe)},null,de),me&&Ee.dispose(),Ee}}j.once=M;function T(B,ee,ie){return ue((de,me=null,Ee)=>B(Pe=>de.call(me,ee(Pe)),null,Ee),ie)}j.map=T;function W(B,ee,ie){return ue((de,me=null,Ee)=>B(Pe=>{ee(Pe),de.call(me,Pe)},null,Ee),ie)}j.forEach=W;function V(B,ee,ie){return ue((de,me=null,Ee)=>B(Pe=>ee(Pe)&&de.call(me,Pe),null,Ee),ie)}j.filter=V;function J(B){return B}j.signal=J;function le(...B){return(ee,ie=null,de)=>{const me=(0,P.$Qc)(...B.map(Ee=>Ee(Pe=>ee.call(ie,Pe))));return Q(me,de)}}j.any=le;function re(B,ee,ie,de){let me=ie;return T(B,Ee=>(me=ee(me,Ee),me),de)}j.reduce=re;function ue(B,ee){let ie;const de={onWillAddFirstListener(){ie=B(me.fire,me)},onDidRemoveLastListener(){ie?.dispose()}};ee||E(de);const me=new h(de);return ee?.add(me),me.event}function Q(B,ee){return ee instanceof Array?ee.push(B):ee&&ee.add(B),B}function Y(B,ee,ie=100,de=!1,me=!1,Ee,Pe){let Le,ke,ye,te=0,fe;const ge={leakWarningThreshold:Ee,onWillAddFirstListener(){Le=B(Ae=>{te++,ke=ee(ke,Ae),de&&!ye&&(Ie.fire(ke),ke=void 0),fe=()=>{const Te=ke;ke=void 0,ye=void 0,(!de||te>1)&&Ie.fire(Te),te=0},typeof ie=="number"?(clearTimeout(ye),ye=setTimeout(fe,ie)):ye===void 0&&(ye=0,queueMicrotask(fe))})},onWillRemoveListener(){me&&te>0&&fe?.()},onDidRemoveLastListener(){fe=void 0,Le.dispose()}};Pe||E(ge);const Ie=new h(ge);return Pe?.add(Ie),Ie.event}j.debounce=Y;function U(B,ee=0,ie){return j.debounce(B,(de,me)=>de?(de.push(me),de):[me],ee,void 0,!0,void 0,ie)}j.accumulate=U;function L(B,ee=(de,me)=>de===me,ie){let de=!0,me;return V(B,Ee=>{const Pe=de||!ee(Ee,me);return de=!1,me=Ee,Pe},ie)}j.latch=L;function N(B,ee,ie){return[j.filter(B,ee,ie),j.filter(B,de=>!ee(de),ie)]}j.split=N;function G(B,ee=!1,ie=[],de){let me=ie.slice(),Ee=B(ke=>{me?me.push(ke):Le.fire(ke)});de&&de.add(Ee);const Pe=()=>{me?.forEach(ke=>Le.fire(ke)),me=null},Le=new h({onWillAddFirstListener(){Ee||(Ee=B(ke=>Le.fire(ke)),de&&de.add(Ee))},onDidAddFirstListener(){me&&(ee?setTimeout(Pe):Pe())},onDidRemoveLastListener(){Ee&&Ee.dispose(),Ee=null}});return de&&de.add(Le),Le.event}j.buffer=G;function q(B,ee){return(de,me,Ee)=>{const Pe=ee(new he);return B(function(Le){const ke=Pe.evaluate(Le);ke!==oe&&de.call(me,ke)},void 0,Ee)}}j.chain=q;const oe=Symbol("HaltChainable");class he{constructor(){this.f=[]}map(ee){return this.f.push(ee),this}forEach(ee){return this.f.push(ie=>(ee(ie),ie)),this}filter(ee){return this.f.push(ie=>ee(ie)?ie:oe),this}reduce(ee,ie){let de=ie;return this.f.push(me=>(de=ee(de,me),de)),this}latch(ee=(ie,de)=>ie===de){let ie=!0,de;return this.f.push(me=>{const Ee=ie||!ee(me,de);return ie=!1,de=me,Ee?me:oe}),this}evaluate(ee){for(const ie of this.f)if(ee=ie(ee),ee===oe)break;return ee}}function K(B,ee,ie=de=>de){const de=(...Le)=>Pe.fire(ie(...Le)),me=()=>B.on(ee,de),Ee=()=>B.removeListener(ee,de),Pe=new h({onWillAddFirstListener:me,onDidRemoveLastListener:Ee});return Pe.event}j.fromNodeEventEmitter=K;function A(B,ee,ie=de=>de){const de=(...Le)=>Pe.fire(ie(...Le)),me=()=>B.addEventListener(ee,de),Ee=()=>B.removeEventListener(ee,de),Pe=new h({onWillAddFirstListener:me,onDidRemoveLastListener:Ee});return Pe.event}j.fromDOMEventEmitter=A;function F(B){return new Promise(ee=>M(B)(ee))}j.toPromise=F;function x(B){const ee=new h;return B.then(ie=>{ee.fire(ie)},()=>{ee.fire(void 0)}).finally(()=>{ee.dispose()}),ee.event}j.fromPromise=x;function z(B,ee,ie){return ee(ie),B(de=>ee(de))}j.runAndSubscribe=z;class Z{constructor(ee,ie){this._observable=ee,this.f=0,this.g=!1;const de={onWillAddFirstListener:()=>{ee.addObserver(this)},onDidRemoveLastListener:()=>{ee.removeObserver(this)}};ie||E(de),this.emitter=new h(de),ie&&ie.add(this.emitter)}beginUpdate(ee){this.f++}handlePossibleChange(ee){}handleChange(ee,ie){this.g=!0}endUpdate(ee){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function H(B,ee){return new Z(B,ee).emitter.event}j.fromObservable=H;function _(B){return(ee,ie,de)=>{let me=0,Ee=!1;const Pe={beginUpdate(){me++},endUpdate(){me--,me===0&&(B.reportChanges(),Ee&&(Ee=!1,ee.call(ie)))},handlePossibleChange(){},handleChange(){Ee=!0}};B.addObserver(Pe),B.reportChanges();const Le={dispose(){B.removeObserver(Pe)}};return de instanceof P.$Sc?de.add(Le):Array.isArray(de)&&de.push(Le),Le}}j.fromObservableLight=_})(c||(e.Event=c={}));class y{static{this.all=new Set}static{this.f=0}constructor(E){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${E}_${y.f++}`,y.all.add(this)}start(E){this.g=new C.$1d,this.listenerCount=E}stop(){if(this.g){const E=this.g.elapsed();this.durations.push(E),this.elapsedOverall+=E,this.invocationCount+=1,this.g=void 0}}}e.$3d=y;let v=-1;function k(j){const E=v;return v=j,{dispose(){v=E}}}e.$4d=k;class ${constructor(E,I=Math.random().toString(18).slice(2,5)){this.threshold=E,this.name=I,this.g=0}dispose(){this.f?.clear()}check(E,I){const M=this.threshold;if(M<=0||I<M)return;this.f||(this.f=new Map);const T=this.f.get(E.value)||0;if(this.f.set(E.value,T+1),this.g-=1,this.g<=0){this.g=M*.5;let W,V=0;for(const[J,le]of this.f)(!W||V<le)&&(W=J,V=le);console.warn(`[${this.name}] potential listener LEAK detected, having ${I} listeners already. MOST frequent listener (${V}):`),console.warn(W)}return()=>{const W=this.f.get(E.value)||0;this.f.set(E.value,W-1)}}}class m{static create(){return new m(new Error().stack??"")}constructor(E){this.value=E}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let w=0;class p{constructor(E){this.value=E,this.id=w++}}const u=2,f=(j,E)=>{if(j instanceof p)E(j);else for(let I=0;I<j.length;I++){const M=j[I];M&&E(M)}};class h{constructor(E){this.w=0,this.f=E,this.g=v>0||this.f?.leakWarningThreshold?new $(this.f?.leakWarningThreshold??v):void 0,this.j=this.f?._profName?new y(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(S){const E=this.t;queueMicrotask(()=>{f(E,I=>I.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(E,I,M)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),P.$Tc.None;if(this.m)return P.$Tc.None;I&&(E=E.bind(I));const T=new p(E);let W,V;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(T.stack=m.create(),W=this.g.check(T.stack,this.w+1)),S&&(T.stack=V??m.create()),this.t?this.t instanceof p?(this.u??=new a,this.t=[this.t,T]):this.t.push(T):(this.f?.onWillAddFirstListener?.(this),this.t=T,this.f?.onDidAddFirstListener?.(this)),this.w++;const J=(0,P.$Rc)(()=>{W?.(),this.x(T)});return M instanceof P.$Sc?M.add(J):Array.isArray(M)&&M.push(J),J},this.q}x(E){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const I=this.t,M=I.indexOf(E);if(M===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,I[M]=void 0;const T=this.u.current===this;if(this.w*u<=I.length){let W=0;for(let V=0;V<I.length;V++)I[V]?I[W++]=I[V]:T&&(this.u.end--,W<this.u.i&&this.u.i--);I.length=W}}y(E,I){if(!E)return;const M=this.f?.onListenerError||n.$1;if(!M){E.value(I);return}try{E.value(I)}catch(T){M(T)}}z(E){const I=E.current.t;for(;E.i<E.end;)this.y(I[E.i++],E.value);E.reset()}fire(E){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof p)this.y(this.t,E);else{const I=this.u;I.enqueue(this,E,this.t.length),this.z(I)}this.j?.stop()}hasListeners(){return this.w>0}}e.$5d=h;const g=()=>new a;e.$6d=g;class a{constructor(){this.i=-1,this.end=0}enqueue(E,I,M){this.i=0,this.end=M,this.current=E,this.value=I}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends h{async fireAsync(E,I,M){if(this.t)for(this.h||(this.h=new O.$4c),f(this.t,T=>this.h.push([T.value,E]));this.h.size>0&&!I.isCancellationRequested;){const[T,W]=this.h.shift(),V=[],J={...W,token:I,waitUntil:le=>{if(Object.isFrozen(V))throw new Error("waitUntil can NOT be called asynchronous");M&&(le=M(le,T)),V.push(le)}};try{T(J)}catch(le){(0,n.$1)(le);continue}Object.freeze(V),await Promise.allSettled(V).then(le=>{for(const re of le)re.status==="rejected"&&(0,n.$1)(re.reason)})}}}e.$7d=t;class o extends h{get isPaused(){return this.h!==0}constructor(E){super(E),this.h=0,this.s=new O.$4c,this.A=E?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const E=Array.from(this.s);this.s.clear(),super.fire(this.A(E))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(E){this.w&&(this.h!==0?this.s.push(E):super.fire(E))}}e.$8d=o;class r extends o{constructor(E){super(E),this.k=E.delay??100}fire(E){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(E)}}e.$9d=r;class i extends h{constructor(E){super(E),this.h=[],this.k=E?.merge}fire(E){this.hasListeners()&&(this.h.push(E),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(I=>super.fire(I)),this.h=[]}))}}e.$0d=i;class s{constructor(){this.g=!1,this.h=[],this.f=new h({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(E){const I={event:E,listener:null};this.h.push(I),this.g&&this.m(I);const M=()=>{this.g&&this.o(I);const T=this.h.indexOf(I);this.h.splice(T,1)};return(0,P.$Rc)((0,R.$db)(M))}j(){this.g=!0,this.h.forEach(E=>this.m(E))}k(){this.g=!1,this.h.forEach(E=>this.o(E))}m(E){E.listener=E.event(I=>this.f.fire(I))}o(E){E.listener?.dispose(),E.listener=null}dispose(){this.f.dispose();for(const E of this.h)E.listener?.dispose();this.h=[]}}e.$$d=s;class l{constructor(E,I,M,T){this.f=new P.$Sc;const W=this.f.add(new s),V=this.f.add(new P.$3c);function J(le){V.set(le,W.add(T(le)))}for(const le of E)J(le);this.f.add(I(le=>{J(le)})),this.f.add(M(le=>{V.deleteAndDispose(le)})),this.event=W.event}dispose(){this.f.dispose()}}e.$_d=l;class b{constructor(){this.f=[]}wrapEvent(E){return(I,M,T)=>E(W=>{const V=this.f[this.f.length-1];V?V.push(()=>I.call(M,W)):I.call(M,W)},void 0,T)}bufferEvents(E){const I=[];this.f.push(I);const M=E();return this.f.pop(),I.forEach(T=>T()),M}}e.$ae=b;class D{constructor(){this.f=!1,this.g=c.None,this.h=P.$Tc.None,this.j=new h({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(E){this.g=E,this.f&&(this.h.dispose(),this.h=E(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$be=D}),define(ae[23],ce([0,1,3]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ce=e.CancellationToken=void 0;const R=Object.freeze(function(S,d){const c=setTimeout(S.bind(d),0);return{dispose(){clearTimeout(c)}}});var P;(function(S){function d(c){return c===S.None||c===S.Cancelled||c instanceof O?!0:!c||typeof c!="object"?!1:typeof c.isCancellationRequested=="boolean"&&typeof c.onCancellationRequested=="function"}S.isCancellationToken=d,S.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:n.Event.None}),S.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(P||(e.CancellationToken=P={}));class O{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?R:(this.b||(this.b=new n.$5d),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class C{constructor(d){this.f=void 0,this.g=void 0,this.g=d&&d.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new O),this.f}cancel(){this.f?this.f instanceof O&&this.f.cancel():this.f=P.Cancelled}dispose(d=!1){d&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof O&&this.f.dispose():this.f=P.None}}e.$ce=C}),define(ae[143],ce([0,1,23]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pe=e.$Oe=e.$Ne=void 0;class R{constructor(S){this.b=S,this.a=null}get(){if(this.a)return this.a;const S=new n.$ce,d=this.b(S.token);return this.a={promise:d,dispose:()=>{this.a=null,S.cancel(),S.dispose()}},this.a}}e.$Ne=R;class P{constructor(S){this.c=S,this.a=void 0,this.b=void 0}get(S){const d=JSON.stringify(S);return this.b!==d&&(this.b=d,this.a=this.c(S)),this.a}}e.$Oe=P;class O{get cachedValues(){return this.a}constructor(S){this.b=S,this.a=new Map}get(S){if(this.a.has(S))return this.a.get(S);const d=this.b(S);return this.a.set(S,d),d}}e.$Pe=O}),define(ae[62],ce([0,1,15,2]),function(X,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=void 0;function P(g){const a=g;return a?typeof a.read=="function":!1}e.$de=P;function O(g){const a=g;return a?[a.on,a.pause,a.resume,a.destroy].every(t=>typeof t=="function"):!1}e.$ee=O;function C(g){const a=g;return a?O(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.$fe=C;function S(g,a){return new d(g,a)}e.$ge=S;class d{constructor(a,t){this.e=a,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(a){if(!this.a.destroyed){if(this.a.flowing)this.g(a);else if(this.b.data.push(a),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(a){this.a.destroyed||(this.a.flowing?this.h(a):this.b.error.push(a))}end(a){this.a.destroyed||(typeof a<"u"&&this.write(a),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(a){this.c.data.slice(0).forEach(t=>t(a))}h(a){this.c.error.length===0?(0,n.$1)(a):this.c.error.slice(0).forEach(t=>t(a))}i(){this.c.end.slice(0).forEach(a=>a())}on(a,t){if(!this.a.destroyed)switch(a){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(a,t){if(this.a.destroyed)return;let o;switch(a){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const r=o.indexOf(t);r>=0&&o.splice(r,1)}}j(){if(this.b.data.length>0){const a=this.e(this.b.data);this.g(a),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const a of this.b.error)this.h(a);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(g,a){const t=[];let o;for(;(o=g.read())!==null;)t.push(o);return a(t)}e.$he=c;function y(g,a,t){const o=[];let r;for(;(r=g.read())!==null&&o.length<t;)o.push(r);return r===null&&o.length>0?a(o):{read:()=>{if(o.length>0)return o.shift();if(typeof r<"u"){const i=r;return r=void 0,i}return g.read()}}}e.$ie=y;function v(g,a){return new Promise((t,o)=>{const r=[];k(g,{onData:i=>{a&&r.push(i)},onError:i=>{a?o(i):t(void 0)},onEnd:()=>{t(a?a(r):void 0)}})})}e.$je=v;function k(g,a,t){g.on("error",o=>{t?.isCancellationRequested||a.onError(o)}),g.on("end",()=>{t?.isCancellationRequested||a.onEnd()}),g.on("data",o=>{t?.isCancellationRequested||a.onData(o)})}e.$ke=k;function $(g,a){return new Promise((t,o)=>{const r=new R.$Sc,i=[],s=D=>{if(i.push(D),i.length>a)return r.dispose(),g.pause(),t({stream:g,buffer:i,ended:!1})},l=D=>(r.dispose(),o(D)),b=()=>(r.dispose(),t({stream:g,buffer:i,ended:!0}));r.add((0,R.$Rc)(()=>g.removeListener("error",l))),g.on("error",l),r.add((0,R.$Rc)(()=>g.removeListener("end",b))),g.on("end",b),r.add((0,R.$Rc)(()=>g.removeListener("data",s))),g.on("data",s)})}e.$le=$;function m(g,a){const t=S(a);return t.end(g),t}e.$me=m;function w(){const g=S(()=>{throw new Error("not supported")});return g.end(),g}e.$ne=w;function p(g){let a=!1;return{read:()=>a?null:(a=!0,g)}}e.$oe=p;function u(g,a,t){const o=S(t);return k(g,{onData:r=>o.write(a.data(r)),onError:r=>o.error(a.error?a.error(r):r),onEnd:()=>o.end()}),o}e.$pe=u;function f(g,a,t){let o=!1;return{read:()=>{const r=a.read();return o?r:(o=!0,r!==null?t([g,r]):g)}}}e.$qe=f;function h(g,a,t){let o=!1;const r=S(t);return k(a,{onData:i=>o?r.write(i):(o=!0,r.write(t([g,i]))),onError:i=>r.error(i),onEnd:()=>{o||(o=!0,r.write(g)),r.end()}}),r}e.$re=h}),define(ae[17],ce([0,1,61,62]),function(X,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=void 0;const P=typeof Buffer<"u",O=new n.$V(()=>new Uint8Array(256));let C,S;class d{static alloc(I){return P?new d(Buffer.allocUnsafe(I)):new d(new Uint8Array(I))}static wrap(I){return P&&!Buffer.isBuffer(I)&&(I=Buffer.from(I.buffer,I.byteOffset,I.byteLength)),new d(I)}static fromString(I,M){return!(M?.dontUseNodeBuffer||!1)&&P?new d(Buffer.from(I)):(C||(C=new TextEncoder),new d(C.encode(I)))}static fromByteArray(I){const M=d.alloc(I.length);for(let T=0,W=I.length;T<W;T++)M.buffer[T]=I[T];return M}static concat(I,M){if(typeof M>"u"){M=0;for(let V=0,J=I.length;V<J;V++)M+=I[V].byteLength}const T=d.alloc(M);let W=0;for(let V=0,J=I.length;V<J;V++){const le=I[V];T.set(le,W),W+=le.byteLength}return T}constructor(I){this.buffer=I,this.byteLength=this.buffer.byteLength}clone(){const I=d.alloc(this.byteLength);return I.set(this),I}toString(){return P?this.buffer.toString():(S||(S=new TextDecoder),S.decode(this.buffer))}slice(I,M){return new d(this.buffer.subarray(I,M))}set(I,M){if(I instanceof d)this.buffer.set(I.buffer,M);else if(I instanceof Uint8Array)this.buffer.set(I,M);else if(I instanceof ArrayBuffer)this.buffer.set(new Uint8Array(I),M);else if(ArrayBuffer.isView(I))this.buffer.set(new Uint8Array(I.buffer,I.byteOffset,I.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE(I){return k(this.buffer,I)}writeUInt32BE(I,M){$(this.buffer,I,M)}readUInt32LE(I){return m(this.buffer,I)}writeUInt32LE(I,M){w(this.buffer,I,M)}readUInt8(I){return p(this.buffer,I)}writeUInt8(I,M){u(this.buffer,I,M)}indexOf(I,M=0){return c(this.buffer,I instanceof d?I.buffer:I,M)}}e.$se=d;function c(E,I,M=0){const T=I.byteLength,W=E.byteLength;if(T===0)return 0;if(T===1)return E.indexOf(I[0]);if(T>W-M)return-1;const V=O.value;V.fill(I.length);for(let ue=0;ue<I.length;ue++)V[I[ue]]=I.length-ue-1;let J=M+I.length-1,le=J,re=-1;for(;J<W;)if(E[J]===I[le]){if(le===0){re=J;break}J--,le--}else J+=Math.max(I.length-le,V[E[J]]),le=I.length-1;return re}e.$te=c;function y(E,I){return E[I+0]<<0>>>0|E[I+1]<<8>>>0}e.$ue=y;function v(E,I,M){E[M+0]=I&255,I=I>>>8,E[M+1]=I&255}e.$ve=v;function k(E,I){return E[I]*2**24+E[I+1]*2**16+E[I+2]*2**8+E[I+3]}e.$we=k;function $(E,I,M){E[M+3]=I,I=I>>>8,E[M+2]=I,I=I>>>8,E[M+1]=I,I=I>>>8,E[M]=I}e.$xe=$;function m(E,I){return E[I+0]<<0>>>0|E[I+1]<<8>>>0|E[I+2]<<16>>>0|E[I+3]<<24>>>0}e.$ye=m;function w(E,I,M){E[M+0]=I&255,I=I>>>8,E[M+1]=I&255,I=I>>>8,E[M+2]=I&255,I=I>>>8,E[M+3]=I&255}e.$ze=w;function p(E,I){return E[I]}e.$Ae=p;function u(E,I,M){E[M]=I}e.$Be=u;function f(E){return R.$he(E,I=>d.concat(I))}e.$Ce=f;function h(E){return R.$oe(E)}e.$De=h;function g(E){return R.$je(E,I=>d.concat(I))}e.$Ee=g;async function a(E){return E.ended?d.concat(E.buffer):d.concat([...E.buffer,await g(E.stream)])}e.$Fe=a;function t(E){return R.$me(E,I=>d.concat(I))}e.$Ge=t;function o(E){return R.$pe(E,{data:I=>typeof I=="string"?d.fromString(I):d.wrap(I)},I=>d.concat(I))}e.$He=o;function r(E){return R.$ge(I=>d.concat(I),E)}e.$Ie=r;function i(E,I){return R.$qe(E,I,M=>d.concat(M))}e.$Je=i;function s(E,I){return R.$re(E,I,M=>d.concat(M))}e.$Ke=s;function l(E){let I=0,M=0,T=0;const W=new Uint8Array(Math.floor(E.length/4*3)),V=le=>{switch(M){case 3:W[T++]=I|le,M=0;break;case 2:W[T++]=I|le>>>2,I=le<<6,M=3;break;case 1:W[T++]=I|le>>>4,I=le<<4,M=2;break;default:I=le<<2,M=1}};for(let le=0;le<E.length;le++){const re=E.charCodeAt(le);if(re>=65&&re<=90)V(re-65);else if(re>=97&&re<=122)V(re-97+26);else if(re>=48&&re<=57)V(re-48+52);else if(re===43||re===45)V(62);else if(re===47||re===95)V(63);else{if(re===61)break;throw new SyntaxError(`Unexpected base64 character ${E[le]}`)}}const J=T;for(;M>0;)V(0);return d.wrap(W).slice(0,J)}e.$Le=l;const b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function j({buffer:E},I=!0,M=!1){const T=M?D:b;let W="";const V=E.byteLength%3;let J=0;for(;J<E.byteLength-V;J+=3){const le=E[J+0],re=E[J+1],ue=E[J+2];W+=T[le>>>2],W+=T[(le<<4|re>>>4)&63],W+=T[(re<<2|ue>>>6)&63],W+=T[ue&63]}if(V===1){const le=E[J+0];W+=T[le>>>2],W+=T[le<<4&63],I&&(W+="==")}else if(V===2){const le=E[J+0],re=E[J+1];W+=T[le>>>2],W+=T[(le<<4|re>>>4)&63],W+=T[re<<2&63],I&&(W+="=")}return W}e.$Me=j}),define(ae[25],ce([0,1,143,61]),function(X,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rf=e.$Qf=e.$Pf=e.$Of=e.GraphemeBreakType=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=void 0;function P(ne){return!ne||typeof ne!="string"?!0:ne.trim().length===0}e.$Se=P;const O=/{(\d+)}/g;function C(ne,...$e){return $e.length===0?ne:ne.replace(O,function(pe,be){const Se=parseInt(be,10);return isNaN(Se)||Se<0||Se>=$e.length?pe:$e[Se]})}e.$Te=C;const S=/{([^}]+)}/g;function d(ne,$e){return Object.keys($e).length===0?ne:ne.replace(S,(pe,be)=>$e[be]??pe)}e.$Ue=d;function c(ne){return ne.replace(/[<>"'&]/g,$e=>{switch($e){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return $e})}e.$Ve=c;function y(ne){return ne.replace(/[<>&]/g,function($e){switch($e){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return $e}})}e.$We=y;function v(ne){return ne.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Xe=v;function k(ne,$e){let pe=0;const be=$e.charCodeAt(0);for(let Se=ne.length-1;Se>=0;Se--)ne.charCodeAt(Se)===be&&pe++;return pe}e.$Ye=k;function $(ne,$e,pe="\u2026"){return ne.length<=$e?ne:`${ne.substr(0,$e)}${pe}`}e.$Ze=$;function m(ne,$e,pe="\u2026"){if(ne.length<=$e)return ne;const be=Math.ceil($e/2)-pe.length/2,Se=Math.floor($e/2)-pe.length/2;return`${ne.substr(0,be)}${pe}${ne.substr(ne.length-Se)}`}e.$1e=m;function w(ne,$e=" "){const pe=p(ne,$e);return u(pe,$e)}e.$2e=w;function p(ne,$e){if(!ne||!$e)return ne;const pe=$e.length;if(pe===0||ne.length===0)return ne;let be=0;for(;ne.indexOf($e,be)===be;)be=be+pe;return ne.substring(be)}e.$3e=p;function u(ne,$e){if(!ne||!$e)return ne;const pe=$e.length,be=ne.length;if(pe===0||be===0)return ne;let Se=be,Oe=-1;for(;Oe=ne.lastIndexOf($e,Se-1),!(Oe===-1||Oe+pe!==Se);){if(Oe===0)return"";Se=Oe}return ne.substring(0,Se)}e.$4e=u;function f(ne){return ne.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$5e=f;function h(ne){return ne.replace(/\*/g,"")}e.$6e=h;function g(ne,$e,pe={}){if(!ne)throw new Error("Cannot create regex from empty string");$e||(ne=v(ne)),pe.wholeWord&&(/\B/.test(ne.charAt(0))||(ne="\\b"+ne),/\B/.test(ne.charAt(ne.length-1))||(ne=ne+"\\b"));let be="";return pe.global&&(be+="g"),pe.matchCase||(be+="i"),pe.multiline&&(be+="m"),pe.unicode&&(be+="u"),new RegExp(ne,be)}e.$7e=g;function a(ne){return ne.source==="^"||ne.source==="^$"||ne.source==="$"||ne.source==="^\\s*$"?!1:!!(ne.exec("")&&ne.lastIndex===0)}e.$8e=a;function t(ne){return ne.split(/\r\n|\r|\n/)}e.$9e=t;function o(ne){const $e=[],pe=ne.split(/(\r\n|\r|\n)/);for(let be=0;be<Math.ceil(pe.length/2);be++)$e.push(pe[2*be]+(pe[2*be+1]??""));return $e}e.$0e=o;function r(ne){for(let $e=0,pe=ne.length;$e<pe;$e++){const be=ne.charCodeAt($e);if(be!==32&&be!==9)return $e}return-1}e.$$e=r;function i(ne,$e=0,pe=ne.length){for(let be=$e;be<pe;be++){const Se=ne.charCodeAt(be);if(Se!==32&&Se!==9)return ne.substring($e,be)}return ne.substring($e,pe)}e.$_e=i;function s(ne,$e=ne.length-1){for(let pe=$e;pe>=0;pe--){const be=ne.charCodeAt(pe);if(be!==32&&be!==9)return pe}return-1}e.$af=s;function l(ne,$e,pe){const be=[];let Se=0;for(const Oe of ne.matchAll($e)){if(be.push(ne.slice(Se,Oe.index)),Oe.index===void 0)throw new Error("match.index should be defined");Se=Oe.index+Oe[0].length,be.push(pe(Oe[0],...Oe.slice(1),Oe.index,ne,Oe.groups))}return be.push(ne.slice(Se)),Promise.all(be).then(Oe=>Oe.join(""))}e.$bf=l;function b(ne,$e){return ne<$e?-1:ne>$e?1:0}e.$cf=b;function D(ne,$e,pe=0,be=ne.length,Se=0,Oe=$e.length){for(;pe<be&&Se<Oe;pe++,Se++){const xe=ne.charCodeAt(pe),Qe=$e.charCodeAt(Se);if(xe<Qe)return-1;if(xe>Qe)return 1}const Ne=be-pe,Xe=Oe-Se;return Ne<Xe?-1:Ne>Xe?1:0}e.$df=D;function j(ne,$e){return E(ne,$e,0,ne.length,0,$e.length)}e.$ef=j;function E(ne,$e,pe=0,be=ne.length,Se=0,Oe=$e.length){for(;pe<be&&Se<Oe;pe++,Se++){let xe=ne.charCodeAt(pe),Qe=$e.charCodeAt(Se);if(xe===Qe)continue;if(xe>=128||Qe>=128)return D(ne.toLowerCase(),$e.toLowerCase(),pe,be,Se,Oe);M(xe)&&(xe-=32),M(Qe)&&(Qe-=32);const Ze=xe-Qe;if(Ze!==0)return Ze}const Ne=be-pe,Xe=Oe-Se;return Ne<Xe?-1:Ne>Xe?1:0}e.$ff=E;function I(ne){return ne>=48&&ne<=57}e.$gf=I;function M(ne){return ne>=97&&ne<=122}e.$hf=M;function T(ne){return ne>=65&&ne<=90}e.$if=T;function W(ne,$e){return ne.length===$e.length&&E(ne,$e)===0}e.$jf=W;function V(ne,$e){const pe=$e.length;return $e.length>ne.length?!1:E(ne,$e,0,pe)===0}e.$kf=V;function J(ne,$e){const pe=Math.min(ne.length,$e.length);let be;for(be=0;be<pe;be++)if(ne.charCodeAt(be)!==$e.charCodeAt(be))return be;return pe}e.$lf=J;function le(ne,$e){const pe=Math.min(ne.length,$e.length);let be;const Se=ne.length-1,Oe=$e.length-1;for(be=0;be<pe;be++)if(ne.charCodeAt(Se-be)!==$e.charCodeAt(Oe-be))return be;return pe}e.$mf=le;function re(ne){return 55296<=ne&&ne<=56319}e.$nf=re;function ue(ne){return 56320<=ne&&ne<=57343}e.$of=ue;function Q(ne,$e){return(ne-55296<<10)+($e-56320)+65536}e.$pf=Q;function Y(ne,$e,pe){const be=ne.charCodeAt(pe);if(re(be)&&pe+1<$e){const Se=ne.charCodeAt(pe+1);if(ue(Se))return Q(be,Se)}return be}e.$qf=Y;function U(ne,$e){const pe=ne.charCodeAt($e-1);if(ue(pe)&&$e>1){const be=ne.charCodeAt($e-2);if(re(be))return Q(be,pe)}return pe}class L{get offset(){return this.e}constructor($e,pe=0){this.c=$e,this.d=$e.length,this.e=pe}setOffset($e){this.e=$e}prevCodePoint(){const $e=U(this.c,this.e);return this.e-=$e>=65536?2:1,$e}nextCodePoint(){const $e=Y(this.c,this.d,this.e);return this.e+=$e>=65536?2:1,$e}eol(){return this.e>=this.d}}e.$rf=L;class N{get offset(){return this.c.offset}constructor($e,pe=0){this.c=new L($e,pe)}nextGraphemeLength(){const $e=Ae.getInstance(),pe=this.c,be=pe.offset;let Se=$e.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const Oe=pe.offset,Ne=$e.getGraphemeBreakType(pe.nextCodePoint());if(ge(Se,Ne)){pe.setOffset(Oe);break}Se=Ne}return pe.offset-be}prevGraphemeLength(){const $e=Ae.getInstance(),pe=this.c,be=pe.offset;let Se=$e.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const Oe=pe.offset,Ne=$e.getGraphemeBreakType(pe.prevCodePoint());if(ge(Ne,Se)){pe.setOffset(Oe);break}Se=Ne}return be-pe.offset}eol(){return this.c.eol()}}e.$sf=N;function G(ne,$e){return new N(ne,$e).nextGraphemeLength()}e.$tf=G;function q(ne,$e){return new N(ne,$e).prevGraphemeLength()}e.$uf=q;function oe(ne,$e){$e>0&&ue(ne.charCodeAt($e))&&$e--;const pe=$e+G(ne,$e);return[pe-q(ne,pe),pe]}e.$vf=oe;function he(ne){const $e=new N(ne);let pe=0;for(;!$e.eol();)pe++,$e.nextGraphemeLength();return pe}e.$wf=he;let K;function A(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function F(ne){return K||(K=A()),K.test(ne)}e.$xf=F;const x=/^[\t\n\r\x20-\x7E]*$/;function z(ne){return x.test(ne)}e.$yf=z,e.$zf=/[\u2028\u2029]/;function Z(ne){return e.$zf.test(ne)}e.$Af=Z;function H(ne){return ne>=11904&&ne<=55215||ne>=63744&&ne<=64255||ne>=65281&&ne<=65374}e.$Bf=H;function _(ne){return ne>=127462&&ne<=127487||ne===8986||ne===8987||ne===9200||ne===9203||ne>=9728&&ne<=10175||ne===11088||ne===11093||ne>=127744&&ne<=128591||ne>=128640&&ne<=128764||ne>=128992&&ne<=129008||ne>=129280&&ne<=129535||ne>=129648&&ne<=129782}e.$Cf=_;function B(ne,$e,pe=""){const be=ne.trimStart();if(be.length<$e)return be;const Se=/\b/g;let Oe=0;for(;Se.test(be)&&!(be.length-Se.lastIndex<$e);)Oe=Se.lastIndex,Se.lastIndex+=1;return Oe===0?be:pe+be.substring(Oe).trimStart()}e.$Df=B;const ee=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ie=/\x1b\].*?\x07/g;function de(ne){return ne&&(ne=ne.replace(ee,"").replace(ie,"")),ne}e.$Ef=de,e.$Ff="\uFEFF";function me(ne){return!!(ne&&ne.length>0&&ne.charCodeAt(0)===65279)}e.$Gf=me;function Ee(ne){return me(ne)?ne.substr(1):ne}e.$Hf=Ee;function Pe(ne,$e){if(!ne||!$e||ne.length<$e.length)return!1;const pe=$e.length,be=ne.toLowerCase();let Se=0,Oe=-1;for(;Se<pe;){const Ne=be.indexOf($e[Se],Oe+1);if(Ne<0)return!1;Oe=Ne,Se++}return!0}e.$If=Pe;function Le(ne,$e=!1){return ne?($e&&(ne=ne.replace(/\\./g,"")),ne.toLowerCase()!==ne):!1}e.$Jf=Le;function ke(ne){return ne.charAt(0).toUpperCase()+ne.slice(1)}e.$Kf=ke;function ye(ne,$e=1){if($e===0)return"";let pe=-1;do pe=ne.indexOf(`
`,pe+1),$e--;while($e>0&&pe>=0);return pe===-1?ne:(ne[pe-1]==="\r"&&pe--,ne.substr(0,pe))}e.$Lf=ye;function te(ne){return ne=ne%(2*26),ne<26?String.fromCharCode(97+ne):String.fromCharCode(65+ne-26)}e.$Mf=te;function fe(ne){return Ae.getInstance().getGraphemeBreakType(ne)}e.$Nf=fe;function ge(ne,$e){return ne===0?$e!==5&&$e!==7:ne===2&&$e===3?!1:ne===4||ne===2||ne===3||$e===4||$e===2||$e===3?!0:!(ne===8&&($e===8||$e===9||$e===11||$e===12)||(ne===11||ne===9)&&($e===9||$e===10)||(ne===12||ne===10)&&$e===10||$e===5||$e===13||$e===7||ne===1||ne===13&&$e===14||ne===6&&$e===6)}var Ie;(function(ne){ne[ne.Other=0]="Other",ne[ne.Prepend=1]="Prepend",ne[ne.CR=2]="CR",ne[ne.LF=3]="LF",ne[ne.Control=4]="Control",ne[ne.Extend=5]="Extend",ne[ne.Regional_Indicator=6]="Regional_Indicator",ne[ne.SpacingMark=7]="SpacingMark",ne[ne.L=8]="L",ne[ne.V=9]="V",ne[ne.T=10]="T",ne[ne.LV=11]="LV",ne[ne.LVT=12]="LVT",ne[ne.ZWJ=13]="ZWJ",ne[ne.Extended_Pictographic=14]="Extended_Pictographic"})(Ie||(e.GraphemeBreakType=Ie={}));class Ae{static{this.c=null}static getInstance(){return Ae.c||(Ae.c=new Ae),Ae.c}constructor(){this.d=Te()}getGraphemeBreakType($e){if($e<32)return $e===10?3:$e===13?2:4;if($e<127)return 0;const pe=this.d,be=pe.length/3;let Se=1;for(;Se<=be;)if($e<pe[3*Se])Se=2*Se;else if($e>pe[3*Se+1])Se=2*Se+1;else return pe[3*Se+2];return 0}}function Te(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Me(ne,$e){if(ne===0)return 0;const pe=Ge(ne,$e);if(pe!==void 0)return pe;const be=new L($e,ne);return be.prevCodePoint(),be.offset}e.$Of=Me;function Ge(ne,$e){const pe=new L($e,ne);let be=pe.prevCodePoint();for(;Ue(be)||be===65039||be===8419;){if(pe.offset===0)return;be=pe.prevCodePoint()}if(!_(be))return;let Se=pe.offset;return Se>0&&pe.prevCodePoint()===8205&&(Se=pe.offset),Se}function Ue(ne){return 127995<=ne&&ne<=127999}var Ke;(function(ne){ne[ne.zwj=8205]="zwj",ne[ne.emojiVariantSelector=65039]="emojiVariantSelector",ne[ne.enclosingKeyCap=8419]="enclosingKeyCap"})(Ke||(Ke={})),e.$Pf="\xA0";class He{static{this.c=new R.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new n.$Oe($e=>{function pe(Ze){const st=new Map;for(let tt=0;tt<Ze.length;tt+=2)st.set(Ze[tt],Ze[tt+1]);return st}function be(Ze,st){const tt=new Map(Ze);for(const[ot,at]of st)tt.set(ot,at);return tt}function Se(Ze,st){if(!Ze)return st;const tt=new Map;for(const[ot,at]of Ze)st.has(ot)&&tt.set(ot,at);return tt}const Oe=this.c.value;let Ne=$e.filter(Ze=>!Ze.startsWith("_")&&Ze in Oe);Ne.length===0&&(Ne=["_default"]);let Xe;for(const Ze of Ne){const st=pe(Oe[Ze]);Xe=Se(Xe,st)}const xe=pe(Oe._common),Qe=be(xe,Xe);return new He(Qe)})}static getInstance($e){return He.d.get(Array.from($e))}static{this.e=new R.$V(()=>Object.keys(He.c.value).filter($e=>!$e.startsWith("_")))}static getLocales(){return He.e.value}constructor($e){this.f=$e}isAmbiguous($e){return this.f.has($e)}getPrimaryConfusable($e){return this.f.get($e)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Qf=He;class qe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(qe.c())),this.d}static isInvisibleCharacter($e){return qe.e().has($e)}static get codePoints(){return qe.e()}}e.$Rf=qe}),define(ae[45],ce([0,1,25]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=void 0;function R(u){return P(u,0)}e.$6i=R;function P(u,f){switch(typeof u){case"object":return u===null?O(349,f):Array.isArray(u)?d(u,f):c(u,f);case"string":return S(u,f);case"boolean":return C(u,f);case"number":return O(u,f);case"undefined":return O(937,f);default:return O(617,f)}}e.$7i=P;function O(u,f){return(f<<5)-f+u|0}e.$8i=O;function C(u,f){return O(u?433:863,f)}function S(u,f){f=O(149417,f);for(let h=0,g=u.length;h<g;h++)f=O(u.charCodeAt(h),f);return f}e.$9i=S;function d(u,f){return f=O(104579,f),u.reduce((h,g)=>P(g,h),f)}function c(u,f){return f=O(181387,f),Object.keys(u).sort().reduce((h,g)=>(h=S(g,h),P(u[g],h)),f)}class y{constructor(){this.g=0}get value(){return this.g}hash(f){return this.g=P(f,this.g),this.g}}e.$0i=y;var v;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(v||(v={}));function k(u,f,h=32){const g=h-f,a=~((1<<g)-1);return(u<<f|(a&u)>>>g)>>>0}function $(u,f=0,h=u.byteLength,g=0){for(let a=0;a<h;a++)u[f+a]=g}function m(u,f,h="0"){for(;u.length<f;)u=h+u;return u}function w(u,f=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(h=>h.toString(16).padStart(2,"0")).join(""):m((u>>>0).toString(16),f/4)}e.$$i=w;class p{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(f){const h=f.length;if(h===0)return;const g=this.p;let a=this.r,t=this.u,o,r;for(t!==0?(o=t,r=-1,t=0):(o=f.charCodeAt(0),r=0);;){let i=o;if(n.$nf(o))if(r+1<h){const s=f.charCodeAt(r+1);n.$of(s)?(r++,i=n.$pf(o,s)):i=65533}else{t=o;break}else n.$of(o)&&(i=65533);if(a=this.w(g,a,i),r++,r<h)o=f.charCodeAt(r);else break}this.r=a,this.u=t}w(f,h,g){return g<128?f[h++]=g:g<2048?(f[h++]=192|(g&1984)>>>6,f[h++]=128|(g&63)>>>0):g<65536?(f[h++]=224|(g&61440)>>>12,f[h++]=128|(g&4032)>>>6,f[h++]=128|(g&63)>>>0):(f[h++]=240|(g&1835008)>>>18,f[h++]=128|(g&258048)>>>12,f[h++]=128|(g&4032)>>>6,f[h++]=128|(g&63)>>>0),h>=64&&(this.y(),h-=64,this.t+=64,f[0]=f[64],f[1]=f[65],f[2]=f[66]),h}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),w(this.h)+w(this.l)+w(this.m)+w(this.n)+w(this.o)}x(){this.p[this.r++]=128,$(this.p,this.r),this.r>56&&(this.y(),$(this.p));const f=8*this.t;this.q.setUint32(56,Math.floor(f/4294967296),!1),this.q.setUint32(60,f%4294967296,!1),this.y()}y(){const f=p.g,h=this.q;for(let b=0;b<64;b+=4)f.setUint32(b,h.getUint32(b,!1),!1);for(let b=64;b<320;b+=4)f.setUint32(b,k(f.getUint32(b-12,!1)^f.getUint32(b-32,!1)^f.getUint32(b-56,!1)^f.getUint32(b-64,!1),1),!1);let g=this.h,a=this.l,t=this.m,o=this.n,r=this.o,i,s,l;for(let b=0;b<80;b++)b<20?(i=a&t|~a&o,s=1518500249):b<40?(i=a^t^o,s=1859775393):b<60?(i=a&t|a&o|t&o,s=2400959708):(i=a^t^o,s=3395469782),l=k(g,5)+i+r+s+f.getUint32(b*4,!1)&4294967295,r=o,o=t,t=k(a,30),a=g,g=l;this.h=this.h+g&4294967295,this.l=this.l+a&4294967295,this.m=this.m+t&4294967295,this.n=this.n+o&4294967295,this.o=this.o+r&4294967295}}e.$_i=p}),define(ae[73],ce([0,1,25]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(R||(R={})),function(P){const O="error",C="warning",S="warn",d="info",c="ignore";function y(k){return k?n.$jf(O,k)?P.Error:n.$jf(C,k)||n.$jf(S,k)?P.Warning:n.$jf(d,k)?P.Info:P.Ignore:P.Ignore}P.fromValue=y;function v(k){switch(k){case P.Error:return O;case P.Warning:return C;case P.Info:return d;default:return c}}P.toString=v}(R||(R={})),e.default=R}),define(ae[144],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2d=void 0,e.$2d=Symbol("MicrotaskDelay")}),define(ae[59],ce([0,1,22,25]),function(X,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$li=e.$ki=e.$ji=e.$ii=e.$hi=void 0;class P{constructor(){this.b="",this.c=0}reset($){return this.b=$,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp($){const m=$.charCodeAt(0),w=this.b.charCodeAt(this.c);return m-w}value(){return this.b[this.c]}}e.$hi=P;class O{constructor($=!0){this.e=$}reset($){return this.b=$,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let $=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if($)this.c++;else break;else $=!1;return this}cmp($){return this.e?(0,R.$df)($,this.b,0,$.length,this.c,this.d):(0,R.$ff)($,this.b,0,$.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$ii=O;class C{constructor($=!0,m=!0){this.f=$,this.g=m}reset($){this.d=0,this.e=0,this.b=$,this.c=$.length;for(let m=$.length-1;m>=0;m--,this.c--){const w=this.b.charCodeAt(m);if(!(w===47||this.f&&w===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let $=!0;for(;this.e<this.c;this.e++){const m=this.b.charCodeAt(this.e);if(m===47||this.f&&m===92)if($)this.d++;else break;else $=!1}return this}cmp($){return this.g?(0,R.$df)($,this.b,0,$.length,this.d,this.e):(0,R.$ff)($,this.b,0,$.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$ji=C;var S;(function(k){k[k.Scheme=1]="Scheme",k[k.Authority=2]="Authority",k[k.Path=3]="Path",k[k.Query=4]="Query",k[k.Fragment=5]="Fragment"})(S||(S={}));class d{constructor($,m){this.f=$,this.g=m,this.d=[],this.e=0}reset($){return this.c=$,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new C(!1,!this.f($)),this.b.reset($.path),this.b.value()&&this.d.push(3)),this.g($)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp($){if(this.d[this.e]===1)return(0,R.$ef)($,this.c.scheme);if(this.d[this.e]===2)return(0,R.$ef)($,this.c.authority);if(this.d[this.e]===3)return this.b.cmp($);if(this.d[this.e]===4)return(0,R.$cf)($,this.c.query);if(this.d[this.e]===5)return(0,R.$cf)($,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$ki=d;class c{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const $=this.right;return this.right=$.left,$.left=this,this.updateHeight(),$.updateHeight(),$}rotateRight(){const $=this.left;return this.left=$.right,$.right=this,this.updateHeight(),$.updateHeight(),$}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(k){k[k.Left=-1]="Left",k[k.Mid=0]="Mid",k[k.Right=1]="Right"})(y||(y={}));class v{static forUris($=()=>!1,m=()=>!1){return new v(new d($,m))}static forPaths($=!1){return new v(new C(void 0,!$))}static forStrings(){return new v(new P)}static forConfigKeys(){return new v(new O)}constructor($){this.b=$}clear(){this.c=void 0}fill($,m){if(m){const w=m.slice(0);(0,n.$Xb)(w);for(const p of w)this.set(p,$)}else{const w=$.slice(0);(0,n.$Xb)(w);for(const p of w)this.set(p[0],p[1])}}set($,m){const w=this.b.reset($);let p;this.c||(this.c=new c,this.c.segment=w.value());const u=[];for(p=this.c;;){const h=w.cmp(p.segment);if(h>0)p.left||(p.left=new c,p.left.segment=w.value()),u.push([-1,p]),p=p.left;else if(h<0)p.right||(p.right=new c,p.right.segment=w.value()),u.push([1,p]),p=p.right;else if(w.hasNext())w.next(),p.mid||(p.mid=new c,p.mid.segment=w.value()),u.push([0,p]),p=p.mid;else break}const f=p.value;p.value=m,p.key=$;for(let h=u.length-1;h>=0;h--){const g=u[h][1];g.updateHeight();const a=g.balanceFactor();if(a<-1||a>1){const t=u[h][0],o=u[h+1][0];if(t===1&&o===1)u[h][1]=g.rotateLeft();else if(t===-1&&o===-1)u[h][1]=g.rotateRight();else if(t===1&&o===-1)g.right=u[h+1][1]=u[h+1][1].rotateRight(),u[h][1]=g.rotateLeft();else if(t===-1&&o===1)g.left=u[h+1][1]=u[h+1][1].rotateLeft(),u[h][1]=g.rotateRight();else throw new Error;if(h>0)switch(u[h-1][0]){case-1:u[h-1][1].left=u[h][1];break;case 1:u[h-1][1].right=u[h][1];break;case 0:u[h-1][1].mid=u[h][1];break}else this.c=u[0][1]}}return f}get($){return this.d($)?.value}d($){const m=this.b.reset($);let w=this.c;for(;w;){const p=m.cmp(w.segment);if(p>0)w=w.left;else if(p<0)w=w.right;else if(m.hasNext())m.next(),w=w.mid;else break}return w}has($){const m=this.d($);return!(m?.value===void 0&&m?.mid===void 0)}delete($){return this.e($,!1)}deleteSuperstr($){return this.e($,!0)}e($,m){const w=this.b.reset($),p=[];let u=this.c;for(;u;){const f=w.cmp(u.segment);if(f>0)p.push([-1,u]),u=u.left;else if(f<0)p.push([1,u]),u=u.right;else if(w.hasNext())w.next(),p.push([0,u]),u=u.mid;else break}if(u){if(m?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const f=this.f(u.right);if(f.key){const{key:h,value:g,segment:a}=f;this.e(f.key,!1),u.key=h,u.value=g,u.segment=a}}else{const f=u.left??u.right;if(p.length>0){const[h,g]=p[p.length-1];switch(h){case-1:g.left=f;break;case 0:g.mid=f;break;case 1:g.right=f;break}}else this.c=f}for(let f=p.length-1;f>=0;f--){const h=p[f][1];h.updateHeight();const g=h.balanceFactor();if(g>1?(h.right.balanceFactor()>=0||(h.right=h.right.rotateRight()),p[f][1]=h.rotateLeft()):g<-1&&(h.left.balanceFactor()<=0||(h.left=h.left.rotateLeft()),p[f][1]=h.rotateRight()),f>0)switch(p[f-1][0]){case-1:p[f-1][1].left=p[f][1];break;case 1:p[f-1][1].right=p[f][1];break;case 0:p[f-1][1].mid=p[f][1];break}else this.c=p[0][1]}}}f($){for(;$.left;)$=$.left;return $}findSubstr($){const m=this.b.reset($);let w=this.c,p;for(;w;){const u=m.cmp(w.segment);if(u>0)w=w.left;else if(u<0)w=w.right;else if(m.hasNext())m.next(),p=w.value||p,w=w.mid;else break}return w&&w.value||p}findSuperstr($){return this.g($,!1)}g($,m){const w=this.b.reset($);let p=this.c;for(;p;){const u=w.cmp(p.segment);if(u>0)p=p.left;else if(u<0)p=p.right;else if(w.hasNext())w.next(),p=p.mid;else return p.mid?this.h(p.mid):m?p.value:void 0}}hasElementOrSubtree($){return this.g($,!0)!==void 0}forEach($){for(const[m,w]of this)$(w,m)}*[Symbol.iterator](){yield*this.h(this.c)}h($){const m=[];return this.j($,m),m[Symbol.iterator]()}j($,m){$&&($.left&&this.j($.left,m),$.value&&m.push([$.key,$.value]),$.mid&&this.j($.mid,m),$.right&&this.j($.right,m))}_isBalanced(){const $=m=>{if(!m)return!0;const w=m.balanceFactor();return w<-1||w>1?!1:$(m.left)&&$(m.right)};return $(this.c)}}e.$li=v}),define(ae[12],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=void 0;function n(a){return typeof a=="string"}e.$Sf=n;function R(a){return Array.isArray(a)&&a.every(t=>n(t))}e.$Tf=R;function P(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.$Uf=P;function O(a){const t=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof t}e.$Vf=O;function C(a){return typeof a=="number"&&!isNaN(a)}e.$Wf=C;function S(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.$Xf=S;function d(a){return a===!0||a===!1}e.$Yf=d;function c(a){return typeof a>"u"}e.$Zf=c;function y(a){return!v(a)}e.$1f=y;function v(a){return c(a)||a===null}e.$2f=v;function k(a,t){if(!a)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$3f=k;function $(a){if(v(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.$4f=$;function m(...a){const t=[];for(let o=0;o<a.length;o++){const r=a[o];if(v(r))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);t.push(r)}return t}e.$5f=m;const w=Object.prototype.hasOwnProperty;function p(a){if(!P(a))return!1;for(const t in a)if(w.call(a,t))return!1;return!0}e.$6f=p;function u(a){return typeof a=="function"}e.$7f=u;function f(...a){return a.length>0&&a.every(u)}e.$8f=f;function h(a,t){const o=Math.min(a.length,t.length);for(let r=0;r<o;r++)g(a[r],t[r])}e.$9f=h;function g(a,t){if(n(t)){if(typeof a!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(u(t)){try{if(a instanceof t)return}catch{}if(!v(a)&&a.constructor===t||t.length===1&&t.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$0f=g}),define(ae[104],ce([0,1,12]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kk=e.$jk=void 0;const R=Object.create(null);function P(C,S){if((0,n.$Sf)(S)){const d=R[S];if(d===void 0)throw new Error(`${C} references an unknown codicon: ${S}`);S=d}return R[C]=S,{id:C}}e.$jk=P;function O(){return R}e.$kk=O}),define(ae[145],ce([0,1,104]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lk=void 0,e.$lk={add:(0,n.$jk)("add",6e4),plus:(0,n.$jk)("plus",6e4),gistNew:(0,n.$jk)("gist-new",6e4),repoCreate:(0,n.$jk)("repo-create",6e4),lightbulb:(0,n.$jk)("lightbulb",60001),lightBulb:(0,n.$jk)("light-bulb",60001),repo:(0,n.$jk)("repo",60002),repoDelete:(0,n.$jk)("repo-delete",60002),gistFork:(0,n.$jk)("gist-fork",60003),repoForked:(0,n.$jk)("repo-forked",60003),gitPullRequest:(0,n.$jk)("git-pull-request",60004),gitPullRequestAbandoned:(0,n.$jk)("git-pull-request-abandoned",60004),recordKeys:(0,n.$jk)("record-keys",60005),keyboard:(0,n.$jk)("keyboard",60005),tag:(0,n.$jk)("tag",60006),tagAdd:(0,n.$jk)("tag-add",60006),tagRemove:(0,n.$jk)("tag-remove",60006),gitPullRequestLabel:(0,n.$jk)("git-pull-request-label",60006),person:(0,n.$jk)("person",60007),personFollow:(0,n.$jk)("person-follow",60007),personOutline:(0,n.$jk)("person-outline",60007),personFilled:(0,n.$jk)("person-filled",60007),gitBranch:(0,n.$jk)("git-branch",60008),gitBranchCreate:(0,n.$jk)("git-branch-create",60008),gitBranchDelete:(0,n.$jk)("git-branch-delete",60008),sourceControl:(0,n.$jk)("source-control",60008),mirror:(0,n.$jk)("mirror",60009),mirrorPublic:(0,n.$jk)("mirror-public",60009),star:(0,n.$jk)("star",60010),starAdd:(0,n.$jk)("star-add",60010),starDelete:(0,n.$jk)("star-delete",60010),starEmpty:(0,n.$jk)("star-empty",60010),comment:(0,n.$jk)("comment",60011),commentAdd:(0,n.$jk)("comment-add",60011),alert:(0,n.$jk)("alert",60012),warning:(0,n.$jk)("warning",60012),search:(0,n.$jk)("search",60013),searchSave:(0,n.$jk)("search-save",60013),logOut:(0,n.$jk)("log-out",60014),signOut:(0,n.$jk)("sign-out",60014),logIn:(0,n.$jk)("log-in",60015),signIn:(0,n.$jk)("sign-in",60015),eye:(0,n.$jk)("eye",60016),eyeUnwatch:(0,n.$jk)("eye-unwatch",60016),eyeWatch:(0,n.$jk)("eye-watch",60016),circleFilled:(0,n.$jk)("circle-filled",60017),primitiveDot:(0,n.$jk)("primitive-dot",60017),closeDirty:(0,n.$jk)("close-dirty",60017),debugBreakpoint:(0,n.$jk)("debug-breakpoint",60017),debugBreakpointDisabled:(0,n.$jk)("debug-breakpoint-disabled",60017),debugBreakpointPending:(0,n.$jk)("debug-breakpoint-pending",60377),debugHint:(0,n.$jk)("debug-hint",60017),primitiveSquare:(0,n.$jk)("primitive-square",60018),edit:(0,n.$jk)("edit",60019),pencil:(0,n.$jk)("pencil",60019),info:(0,n.$jk)("info",60020),issueOpened:(0,n.$jk)("issue-opened",60020),gistPrivate:(0,n.$jk)("gist-private",60021),gitForkPrivate:(0,n.$jk)("git-fork-private",60021),lock:(0,n.$jk)("lock",60021),mirrorPrivate:(0,n.$jk)("mirror-private",60021),close:(0,n.$jk)("close",60022),removeClose:(0,n.$jk)("remove-close",60022),x:(0,n.$jk)("x",60022),repoSync:(0,n.$jk)("repo-sync",60023),sync:(0,n.$jk)("sync",60023),clone:(0,n.$jk)("clone",60024),desktopDownload:(0,n.$jk)("desktop-download",60024),beaker:(0,n.$jk)("beaker",60025),microscope:(0,n.$jk)("microscope",60025),vm:(0,n.$jk)("vm",60026),deviceDesktop:(0,n.$jk)("device-desktop",60026),file:(0,n.$jk)("file",60027),fileText:(0,n.$jk)("file-text",60027),more:(0,n.$jk)("more",60028),ellipsis:(0,n.$jk)("ellipsis",60028),kebabHorizontal:(0,n.$jk)("kebab-horizontal",60028),mailReply:(0,n.$jk)("mail-reply",60029),reply:(0,n.$jk)("reply",60029),organization:(0,n.$jk)("organization",60030),organizationFilled:(0,n.$jk)("organization-filled",60030),organizationOutline:(0,n.$jk)("organization-outline",60030),newFile:(0,n.$jk)("new-file",60031),fileAdd:(0,n.$jk)("file-add",60031),newFolder:(0,n.$jk)("new-folder",60032),fileDirectoryCreate:(0,n.$jk)("file-directory-create",60032),trash:(0,n.$jk)("trash",60033),trashcan:(0,n.$jk)("trashcan",60033),history:(0,n.$jk)("history",60034),clock:(0,n.$jk)("clock",60034),folder:(0,n.$jk)("folder",60035),fileDirectory:(0,n.$jk)("file-directory",60035),symbolFolder:(0,n.$jk)("symbol-folder",60035),logoGithub:(0,n.$jk)("logo-github",60036),markGithub:(0,n.$jk)("mark-github",60036),github:(0,n.$jk)("github",60036),terminal:(0,n.$jk)("terminal",60037),console:(0,n.$jk)("console",60037),repl:(0,n.$jk)("repl",60037),zap:(0,n.$jk)("zap",60038),symbolEvent:(0,n.$jk)("symbol-event",60038),error:(0,n.$jk)("error",60039),stop:(0,n.$jk)("stop",60039),variable:(0,n.$jk)("variable",60040),symbolVariable:(0,n.$jk)("symbol-variable",60040),array:(0,n.$jk)("array",60042),symbolArray:(0,n.$jk)("symbol-array",60042),symbolModule:(0,n.$jk)("symbol-module",60043),symbolPackage:(0,n.$jk)("symbol-package",60043),symbolNamespace:(0,n.$jk)("symbol-namespace",60043),symbolObject:(0,n.$jk)("symbol-object",60043),symbolMethod:(0,n.$jk)("symbol-method",60044),symbolFunction:(0,n.$jk)("symbol-function",60044),symbolConstructor:(0,n.$jk)("symbol-constructor",60044),symbolBoolean:(0,n.$jk)("symbol-boolean",60047),symbolNull:(0,n.$jk)("symbol-null",60047),symbolNumeric:(0,n.$jk)("symbol-numeric",60048),symbolNumber:(0,n.$jk)("symbol-number",60048),symbolStructure:(0,n.$jk)("symbol-structure",60049),symbolStruct:(0,n.$jk)("symbol-struct",60049),symbolParameter:(0,n.$jk)("symbol-parameter",60050),symbolTypeParameter:(0,n.$jk)("symbol-type-parameter",60050),symbolKey:(0,n.$jk)("symbol-key",60051),symbolText:(0,n.$jk)("symbol-text",60051),symbolReference:(0,n.$jk)("symbol-reference",60052),goToFile:(0,n.$jk)("go-to-file",60052),symbolEnum:(0,n.$jk)("symbol-enum",60053),symbolValue:(0,n.$jk)("symbol-value",60053),symbolRuler:(0,n.$jk)("symbol-ruler",60054),symbolUnit:(0,n.$jk)("symbol-unit",60054),activateBreakpoints:(0,n.$jk)("activate-breakpoints",60055),archive:(0,n.$jk)("archive",60056),arrowBoth:(0,n.$jk)("arrow-both",60057),arrowDown:(0,n.$jk)("arrow-down",60058),arrowLeft:(0,n.$jk)("arrow-left",60059),arrowRight:(0,n.$jk)("arrow-right",60060),arrowSmallDown:(0,n.$jk)("arrow-small-down",60061),arrowSmallLeft:(0,n.$jk)("arrow-small-left",60062),arrowSmallRight:(0,n.$jk)("arrow-small-right",60063),arrowSmallUp:(0,n.$jk)("arrow-small-up",60064),arrowUp:(0,n.$jk)("arrow-up",60065),bell:(0,n.$jk)("bell",60066),bold:(0,n.$jk)("bold",60067),book:(0,n.$jk)("book",60068),bookmark:(0,n.$jk)("bookmark",60069),debugBreakpointConditionalUnverified:(0,n.$jk)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,n.$jk)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,n.$jk)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,n.$jk)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,n.$jk)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,n.$jk)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,n.$jk)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,n.$jk)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,n.$jk)("debug-breakpoint-log-disabled",60075),briefcase:(0,n.$jk)("briefcase",60076),broadcast:(0,n.$jk)("broadcast",60077),browser:(0,n.$jk)("browser",60078),bug:(0,n.$jk)("bug",60079),calendar:(0,n.$jk)("calendar",60080),caseSensitive:(0,n.$jk)("case-sensitive",60081),check:(0,n.$jk)("check",60082),checklist:(0,n.$jk)("checklist",60083),chevronDown:(0,n.$jk)("chevron-down",60084),dropDownButton:(0,n.$jk)("drop-down-button",60084),chevronLeft:(0,n.$jk)("chevron-left",60085),chevronRight:(0,n.$jk)("chevron-right",60086),chevronUp:(0,n.$jk)("chevron-up",60087),chromeClose:(0,n.$jk)("chrome-close",60088),chromeMaximize:(0,n.$jk)("chrome-maximize",60089),chromeMinimize:(0,n.$jk)("chrome-minimize",60090),chromeRestore:(0,n.$jk)("chrome-restore",60091),circle:(0,n.$jk)("circle",60092),circleOutline:(0,n.$jk)("circle-outline",60092),debugBreakpointUnverified:(0,n.$jk)("debug-breakpoint-unverified",60092),circleSlash:(0,n.$jk)("circle-slash",60093),circuitBoard:(0,n.$jk)("circuit-board",60094),clearAll:(0,n.$jk)("clear-all",60095),clippy:(0,n.$jk)("clippy",60096),closeAll:(0,n.$jk)("close-all",60097),cloudDownload:(0,n.$jk)("cloud-download",60098),cloudUpload:(0,n.$jk)("cloud-upload",60099),code:(0,n.$jk)("code",60100),collapseAll:(0,n.$jk)("collapse-all",60101),colorMode:(0,n.$jk)("color-mode",60102),commentDiscussion:(0,n.$jk)("comment-discussion",60103),compareChanges:(0,n.$jk)("compare-changes",60157),creditCard:(0,n.$jk)("credit-card",60105),dash:(0,n.$jk)("dash",60108),dashboard:(0,n.$jk)("dashboard",60109),database:(0,n.$jk)("database",60110),debugContinue:(0,n.$jk)("debug-continue",60111),debugDisconnect:(0,n.$jk)("debug-disconnect",60112),debugPause:(0,n.$jk)("debug-pause",60113),debugRestart:(0,n.$jk)("debug-restart",60114),debugStart:(0,n.$jk)("debug-start",60115),debugStepInto:(0,n.$jk)("debug-step-into",60116),debugStepOut:(0,n.$jk)("debug-step-out",60117),debugStepOver:(0,n.$jk)("debug-step-over",60118),debugStop:(0,n.$jk)("debug-stop",60119),debug:(0,n.$jk)("debug",60120),deviceCameraVideo:(0,n.$jk)("device-camera-video",60121),deviceCamera:(0,n.$jk)("device-camera",60122),deviceMobile:(0,n.$jk)("device-mobile",60123),diffAdded:(0,n.$jk)("diff-added",60124),diffIgnored:(0,n.$jk)("diff-ignored",60125),diffModified:(0,n.$jk)("diff-modified",60126),diffRemoved:(0,n.$jk)("diff-removed",60127),diffRenamed:(0,n.$jk)("diff-renamed",60128),diff:(0,n.$jk)("diff",60129),discard:(0,n.$jk)("discard",60130),editorLayout:(0,n.$jk)("editor-layout",60131),emptyWindow:(0,n.$jk)("empty-window",60132),exclude:(0,n.$jk)("exclude",60133),extensions:(0,n.$jk)("extensions",60134),eyeClosed:(0,n.$jk)("eye-closed",60135),fileBinary:(0,n.$jk)("file-binary",60136),fileCode:(0,n.$jk)("file-code",60137),fileMedia:(0,n.$jk)("file-media",60138),filePdf:(0,n.$jk)("file-pdf",60139),fileSubmodule:(0,n.$jk)("file-submodule",60140),fileSymlinkDirectory:(0,n.$jk)("file-symlink-directory",60141),fileSymlinkFile:(0,n.$jk)("file-symlink-file",60142),fileZip:(0,n.$jk)("file-zip",60143),files:(0,n.$jk)("files",60144),filter:(0,n.$jk)("filter",60145),flame:(0,n.$jk)("flame",60146),foldDown:(0,n.$jk)("fold-down",60147),foldUp:(0,n.$jk)("fold-up",60148),fold:(0,n.$jk)("fold",60149),folderActive:(0,n.$jk)("folder-active",60150),folderOpened:(0,n.$jk)("folder-opened",60151),gear:(0,n.$jk)("gear",60152),gift:(0,n.$jk)("gift",60153),gistSecret:(0,n.$jk)("gist-secret",60154),gist:(0,n.$jk)("gist",60155),gitCommit:(0,n.$jk)("git-commit",60156),gitCompare:(0,n.$jk)("git-compare",60157),gitMerge:(0,n.$jk)("git-merge",60158),githubAction:(0,n.$jk)("github-action",60159),githubAlt:(0,n.$jk)("github-alt",60160),globe:(0,n.$jk)("globe",60161),grabber:(0,n.$jk)("grabber",60162),graph:(0,n.$jk)("graph",60163),gripper:(0,n.$jk)("gripper",60164),heart:(0,n.$jk)("heart",60165),home:(0,n.$jk)("home",60166),horizontalRule:(0,n.$jk)("horizontal-rule",60167),hubot:(0,n.$jk)("hubot",60168),inbox:(0,n.$jk)("inbox",60169),issueClosed:(0,n.$jk)("issue-closed",60324),issueReopened:(0,n.$jk)("issue-reopened",60171),issues:(0,n.$jk)("issues",60172),italic:(0,n.$jk)("italic",60173),jersey:(0,n.$jk)("jersey",60174),json:(0,n.$jk)("json",60175),bracket:(0,n.$jk)("bracket",60175),kebabVertical:(0,n.$jk)("kebab-vertical",60176),key:(0,n.$jk)("key",60177),law:(0,n.$jk)("law",60178),lightbulbAutofix:(0,n.$jk)("lightbulb-autofix",60179),linkExternal:(0,n.$jk)("link-external",60180),link:(0,n.$jk)("link",60181),listOrdered:(0,n.$jk)("list-ordered",60182),listUnordered:(0,n.$jk)("list-unordered",60183),liveShare:(0,n.$jk)("live-share",60184),loading:(0,n.$jk)("loading",60185),location:(0,n.$jk)("location",60186),mailRead:(0,n.$jk)("mail-read",60187),mail:(0,n.$jk)("mail",60188),markdown:(0,n.$jk)("markdown",60189),megaphone:(0,n.$jk)("megaphone",60190),mention:(0,n.$jk)("mention",60191),milestone:(0,n.$jk)("milestone",60192),gitPullRequestMilestone:(0,n.$jk)("git-pull-request-milestone",60192),mortarBoard:(0,n.$jk)("mortar-board",60193),move:(0,n.$jk)("move",60194),multipleWindows:(0,n.$jk)("multiple-windows",60195),mute:(0,n.$jk)("mute",60196),noNewline:(0,n.$jk)("no-newline",60197),note:(0,n.$jk)("note",60198),octoface:(0,n.$jk)("octoface",60199),openPreview:(0,n.$jk)("open-preview",60200),package:(0,n.$jk)("package",60201),paintcan:(0,n.$jk)("paintcan",60202),pin:(0,n.$jk)("pin",60203),play:(0,n.$jk)("play",60204),run:(0,n.$jk)("run",60204),plug:(0,n.$jk)("plug",60205),preserveCase:(0,n.$jk)("preserve-case",60206),preview:(0,n.$jk)("preview",60207),project:(0,n.$jk)("project",60208),pulse:(0,n.$jk)("pulse",60209),question:(0,n.$jk)("question",60210),quote:(0,n.$jk)("quote",60211),radioTower:(0,n.$jk)("radio-tower",60212),reactions:(0,n.$jk)("reactions",60213),references:(0,n.$jk)("references",60214),refresh:(0,n.$jk)("refresh",60215),regex:(0,n.$jk)("regex",60216),remoteExplorer:(0,n.$jk)("remote-explorer",60217),remote:(0,n.$jk)("remote",60218),remove:(0,n.$jk)("remove",60219),replaceAll:(0,n.$jk)("replace-all",60220),replace:(0,n.$jk)("replace",60221),repoClone:(0,n.$jk)("repo-clone",60222),repoForcePush:(0,n.$jk)("repo-force-push",60223),repoPull:(0,n.$jk)("repo-pull",60224),repoPush:(0,n.$jk)("repo-push",60225),report:(0,n.$jk)("report",60226),requestChanges:(0,n.$jk)("request-changes",60227),rocket:(0,n.$jk)("rocket",60228),rootFolderOpened:(0,n.$jk)("root-folder-opened",60229),rootFolder:(0,n.$jk)("root-folder",60230),rss:(0,n.$jk)("rss",60231),ruby:(0,n.$jk)("ruby",60232),saveAll:(0,n.$jk)("save-all",60233),saveAs:(0,n.$jk)("save-as",60234),save:(0,n.$jk)("save",60235),screenFull:(0,n.$jk)("screen-full",60236),screenNormal:(0,n.$jk)("screen-normal",60237),searchStop:(0,n.$jk)("search-stop",60238),server:(0,n.$jk)("server",60240),settingsGear:(0,n.$jk)("settings-gear",60241),settings:(0,n.$jk)("settings",60242),shield:(0,n.$jk)("shield",60243),smiley:(0,n.$jk)("smiley",60244),sortPrecedence:(0,n.$jk)("sort-precedence",60245),splitHorizontal:(0,n.$jk)("split-horizontal",60246),splitVertical:(0,n.$jk)("split-vertical",60247),squirrel:(0,n.$jk)("squirrel",60248),starFull:(0,n.$jk)("star-full",60249),starHalf:(0,n.$jk)("star-half",60250),symbolClass:(0,n.$jk)("symbol-class",60251),symbolColor:(0,n.$jk)("symbol-color",60252),symbolCustomColor:(0,n.$jk)("symbol-customcolor",60252),symbolConstant:(0,n.$jk)("symbol-constant",60253),symbolEnumMember:(0,n.$jk)("symbol-enum-member",60254),symbolField:(0,n.$jk)("symbol-field",60255),symbolFile:(0,n.$jk)("symbol-file",60256),symbolInterface:(0,n.$jk)("symbol-interface",60257),symbolKeyword:(0,n.$jk)("symbol-keyword",60258),symbolMisc:(0,n.$jk)("symbol-misc",60259),symbolOperator:(0,n.$jk)("symbol-operator",60260),symbolProperty:(0,n.$jk)("symbol-property",60261),wrench:(0,n.$jk)("wrench",60261),wrenchSubaction:(0,n.$jk)("wrench-subaction",60261),symbolSnippet:(0,n.$jk)("symbol-snippet",60262),tasklist:(0,n.$jk)("tasklist",60263),telescope:(0,n.$jk)("telescope",60264),textSize:(0,n.$jk)("text-size",60265),threeBars:(0,n.$jk)("three-bars",60266),thumbsdown:(0,n.$jk)("thumbsdown",60267),thumbsup:(0,n.$jk)("thumbsup",60268),tools:(0,n.$jk)("tools",60269),triangleDown:(0,n.$jk)("triangle-down",60270),triangleLeft:(0,n.$jk)("triangle-left",60271),triangleRight:(0,n.$jk)("triangle-right",60272),triangleUp:(0,n.$jk)("triangle-up",60273),twitter:(0,n.$jk)("twitter",60274),unfold:(0,n.$jk)("unfold",60275),unlock:(0,n.$jk)("unlock",60276),unmute:(0,n.$jk)("unmute",60277),unverified:(0,n.$jk)("unverified",60278),verified:(0,n.$jk)("verified",60279),versions:(0,n.$jk)("versions",60280),vmActive:(0,n.$jk)("vm-active",60281),vmOutline:(0,n.$jk)("vm-outline",60282),vmRunning:(0,n.$jk)("vm-running",60283),watch:(0,n.$jk)("watch",60284),whitespace:(0,n.$jk)("whitespace",60285),wholeWord:(0,n.$jk)("whole-word",60286),window:(0,n.$jk)("window",60287),wordWrap:(0,n.$jk)("word-wrap",60288),zoomIn:(0,n.$jk)("zoom-in",60289),zoomOut:(0,n.$jk)("zoom-out",60290),listFilter:(0,n.$jk)("list-filter",60291),listFlat:(0,n.$jk)("list-flat",60292),listSelection:(0,n.$jk)("list-selection",60293),selection:(0,n.$jk)("selection",60293),listTree:(0,n.$jk)("list-tree",60294),debugBreakpointFunctionUnverified:(0,n.$jk)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,n.$jk)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,n.$jk)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,n.$jk)("debug-stackframe-active",60297),circleSmallFilled:(0,n.$jk)("circle-small-filled",60298),debugStackframeDot:(0,n.$jk)("debug-stackframe-dot",60298),debugStackframe:(0,n.$jk)("debug-stackframe",60299),debugStackframeFocused:(0,n.$jk)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,n.$jk)("debug-breakpoint-unsupported",60300),symbolString:(0,n.$jk)("symbol-string",60301),debugReverseContinue:(0,n.$jk)("debug-reverse-continue",60302),debugStepBack:(0,n.$jk)("debug-step-back",60303),debugRestartFrame:(0,n.$jk)("debug-restart-frame",60304),callIncoming:(0,n.$jk)("call-incoming",60306),callOutgoing:(0,n.$jk)("call-outgoing",60307),menu:(0,n.$jk)("menu",60308),expandAll:(0,n.$jk)("expand-all",60309),feedback:(0,n.$jk)("feedback",60310),gitPullRequestReviewer:(0,n.$jk)("git-pull-request-reviewer",60310),groupByRefType:(0,n.$jk)("group-by-ref-type",60311),ungroupByRefType:(0,n.$jk)("ungroup-by-ref-type",60312),account:(0,n.$jk)("account",60313),gitPullRequestAssignee:(0,n.$jk)("git-pull-request-assignee",60313),bellDot:(0,n.$jk)("bell-dot",60314),debugConsole:(0,n.$jk)("debug-console",60315),library:(0,n.$jk)("library",60316),output:(0,n.$jk)("output",60317),runAll:(0,n.$jk)("run-all",60318),syncIgnored:(0,n.$jk)("sync-ignored",60319),pinned:(0,n.$jk)("pinned",60320),githubInverted:(0,n.$jk)("github-inverted",60321),debugAlt:(0,n.$jk)("debug-alt",60305),serverProcess:(0,n.$jk)("server-process",60322),serverEnvironment:(0,n.$jk)("server-environment",60323),pass:(0,n.$jk)("pass",60324),stopCircle:(0,n.$jk)("stop-circle",60325),playCircle:(0,n.$jk)("play-circle",60326),record:(0,n.$jk)("record",60327),debugAltSmall:(0,n.$jk)("debug-alt-small",60328),vmConnect:(0,n.$jk)("vm-connect",60329),cloud:(0,n.$jk)("cloud",60330),merge:(0,n.$jk)("merge",60331),exportIcon:(0,n.$jk)("export",60332),graphLeft:(0,n.$jk)("graph-left",60333),magnet:(0,n.$jk)("magnet",60334),notebook:(0,n.$jk)("notebook",60335),redo:(0,n.$jk)("redo",60336),checkAll:(0,n.$jk)("check-all",60337),pinnedDirty:(0,n.$jk)("pinned-dirty",60338),passFilled:(0,n.$jk)("pass-filled",60339),circleLargeFilled:(0,n.$jk)("circle-large-filled",60340),circleLarge:(0,n.$jk)("circle-large",60341),circleLargeOutline:(0,n.$jk)("circle-large-outline",60341),combine:(0,n.$jk)("combine",60342),gather:(0,n.$jk)("gather",60342),table:(0,n.$jk)("table",60343),variableGroup:(0,n.$jk)("variable-group",60344),typeHierarchy:(0,n.$jk)("type-hierarchy",60345),typeHierarchySub:(0,n.$jk)("type-hierarchy-sub",60346),typeHierarchySuper:(0,n.$jk)("type-hierarchy-super",60347),gitPullRequestCreate:(0,n.$jk)("git-pull-request-create",60348),runAbove:(0,n.$jk)("run-above",60349),runBelow:(0,n.$jk)("run-below",60350),notebookTemplate:(0,n.$jk)("notebook-template",60351),debugRerun:(0,n.$jk)("debug-rerun",60352),workspaceTrusted:(0,n.$jk)("workspace-trusted",60353),workspaceUntrusted:(0,n.$jk)("workspace-untrusted",60354),workspaceUnspecified:(0,n.$jk)("workspace-unspecified",60355),terminalCmd:(0,n.$jk)("terminal-cmd",60356),terminalDebian:(0,n.$jk)("terminal-debian",60357),terminalLinux:(0,n.$jk)("terminal-linux",60358),terminalPowershell:(0,n.$jk)("terminal-powershell",60359),terminalTmux:(0,n.$jk)("terminal-tmux",60360),terminalUbuntu:(0,n.$jk)("terminal-ubuntu",60361),terminalBash:(0,n.$jk)("terminal-bash",60362),arrowSwap:(0,n.$jk)("arrow-swap",60363),copy:(0,n.$jk)("copy",60364),personAdd:(0,n.$jk)("person-add",60365),filterFilled:(0,n.$jk)("filter-filled",60366),wand:(0,n.$jk)("wand",60367),debugLineByLine:(0,n.$jk)("debug-line-by-line",60368),inspect:(0,n.$jk)("inspect",60369),layers:(0,n.$jk)("layers",60370),layersDot:(0,n.$jk)("layers-dot",60371),layersActive:(0,n.$jk)("layers-active",60372),compass:(0,n.$jk)("compass",60373),compassDot:(0,n.$jk)("compass-dot",60374),compassActive:(0,n.$jk)("compass-active",60375),azure:(0,n.$jk)("azure",60376),issueDraft:(0,n.$jk)("issue-draft",60377),gitPullRequestClosed:(0,n.$jk)("git-pull-request-closed",60378),gitPullRequestDraft:(0,n.$jk)("git-pull-request-draft",60379),debugAll:(0,n.$jk)("debug-all",60380),debugCoverage:(0,n.$jk)("debug-coverage",60381),runErrors:(0,n.$jk)("run-errors",60382),folderLibrary:(0,n.$jk)("folder-library",60383),debugContinueSmall:(0,n.$jk)("debug-continue-small",60384),beakerStop:(0,n.$jk)("beaker-stop",60385),graphLine:(0,n.$jk)("graph-line",60386),graphScatter:(0,n.$jk)("graph-scatter",60387),pieChart:(0,n.$jk)("pie-chart",60388),bracketDot:(0,n.$jk)("bracket-dot",60389),bracketError:(0,n.$jk)("bracket-error",60390),lockSmall:(0,n.$jk)("lock-small",60391),azureDevops:(0,n.$jk)("azure-devops",60392),verifiedFilled:(0,n.$jk)("verified-filled",60393),newLine:(0,n.$jk)("newline",60394),layout:(0,n.$jk)("layout",60395),layoutActivitybarLeft:(0,n.$jk)("layout-activitybar-left",60396),layoutActivitybarRight:(0,n.$jk)("layout-activitybar-right",60397),layoutPanelLeft:(0,n.$jk)("layout-panel-left",60398),layoutPanelCenter:(0,n.$jk)("layout-panel-center",60399),layoutPanelJustify:(0,n.$jk)("layout-panel-justify",60400),layoutPanelRight:(0,n.$jk)("layout-panel-right",60401),layoutPanel:(0,n.$jk)("layout-panel",60402),layoutSidebarLeft:(0,n.$jk)("layout-sidebar-left",60403),layoutSidebarRight:(0,n.$jk)("layout-sidebar-right",60404),layoutStatusbar:(0,n.$jk)("layout-statusbar",60405),layoutMenubar:(0,n.$jk)("layout-menubar",60406),layoutCentered:(0,n.$jk)("layout-centered",60407),layoutSidebarRightOff:(0,n.$jk)("layout-sidebar-right-off",60416),layoutPanelOff:(0,n.$jk)("layout-panel-off",60417),layoutSidebarLeftOff:(0,n.$jk)("layout-sidebar-left-off",60418),target:(0,n.$jk)("target",60408),indent:(0,n.$jk)("indent",60409),recordSmall:(0,n.$jk)("record-small",60410),errorSmall:(0,n.$jk)("error-small",60411),arrowCircleDown:(0,n.$jk)("arrow-circle-down",60412),arrowCircleLeft:(0,n.$jk)("arrow-circle-left",60413),arrowCircleRight:(0,n.$jk)("arrow-circle-right",60414),arrowCircleUp:(0,n.$jk)("arrow-circle-up",60415),heartFilled:(0,n.$jk)("heart-filled",60420),map:(0,n.$jk)("map",60421),mapFilled:(0,n.$jk)("map-filled",60422),circleSmall:(0,n.$jk)("circle-small",60423),bellSlash:(0,n.$jk)("bell-slash",60424),bellSlashDot:(0,n.$jk)("bell-slash-dot",60425),commentUnresolved:(0,n.$jk)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,n.$jk)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,n.$jk)("git-pull-request-new-changes",60428),searchFuzzy:(0,n.$jk)("search-fuzzy",60429),commentDraft:(0,n.$jk)("comment-draft",60430),send:(0,n.$jk)("send",60431),sparkle:(0,n.$jk)("sparkle",60432),insert:(0,n.$jk)("insert",60433),mic:(0,n.$jk)("mic",60434),thumbsDownFilled:(0,n.$jk)("thumbsdown-filled",60435),thumbsUpFilled:(0,n.$jk)("thumbsup-filled",60436),coffee:(0,n.$jk)("coffee",60437),snake:(0,n.$jk)("snake",60438),game:(0,n.$jk)("game",60439),vr:(0,n.$jk)("vr",60440),chip:(0,n.$jk)("chip",60441),piano:(0,n.$jk)("piano",60442),music:(0,n.$jk)("music",60443),micFilled:(0,n.$jk)("mic-filled",60444),gitFetch:(0,n.$jk)("git-fetch",60445),copilot:(0,n.$jk)("copilot",60446),lightbulbSparkle:(0,n.$jk)("lightbulb-sparkle",60447),lightbulbSparkleAutofix:(0,n.$jk)("lightbulb-sparkle-autofix",60447),robot:(0,n.$jk)("robot",60448),sparkleFilled:(0,n.$jk)("sparkle-filled",60449),diffSingle:(0,n.$jk)("diff-single",60450),diffMultiple:(0,n.$jk)("diff-multiple",60451),surroundWith:(0,n.$jk)("surround-with",60452),gitStash:(0,n.$jk)("git-stash",60454),gitStashApply:(0,n.$jk)("git-stash-apply",60455),gitStashPop:(0,n.$jk)("git-stash-pop",60456),runAllCoverage:(0,n.$jk)("run-all-coverage",60461),runCoverage:(0,n.$jk)("run-all-coverage",60460),coverage:(0,n.$jk)("coverage",60462),githubProject:(0,n.$jk)("github-project",60463)}}),define(ae[74],ce([0,1,104,145]),function(X,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ok=e.$nk=e.$mk=void 0;function P(){return Object.values(e.$ok)}e.$mk=P,e.$nk={dialogError:(0,n.$jk)("dialog-error","error"),dialogWarning:(0,n.$jk)("dialog-warning","warning"),dialogInfo:(0,n.$jk)("dialog-info","info"),dialogClose:(0,n.$jk)("dialog-close","close"),treeItemExpanded:(0,n.$jk)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,n.$jk)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,n.$jk)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,n.$jk)("tree-filter-clear","close"),treeItemLoading:(0,n.$jk)("tree-item-loading","loading"),menuSelection:(0,n.$jk)("menu-selection","check"),menuSubmenu:(0,n.$jk)("menu-submenu","chevron-right"),menuBarMore:(0,n.$jk)("menubar-more","more"),scrollbarButtonLeft:(0,n.$jk)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,n.$jk)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,n.$jk)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,n.$jk)("scrollbar-button-down","triangle-down"),toolBarMore:(0,n.$jk)("toolbar-more","more"),quickInputBack:(0,n.$jk)("quick-input-back","arrow-left")},e.$ok={...R.$lk,...e.$nk}}),define(ae[35],ce([0,1,12]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.$Ln=e.$Kn=void 0;function R(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const f=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([h,g])=>{f[h]=g&&typeof g=="object"?R(g):g}),f}e.$Kn=R;function P(u){if(!u||typeof u!="object")return u;const f=[u];for(;f.length>0;){const h=f.shift();Object.freeze(h);for(const g in h)if(O.call(h,g)){const a=h[g];typeof a=="object"&&!Object.isFrozen(a)&&!(0,n.$Vf)(a)&&f.push(a)}}return u}e.$Ln=P;const O=Object.prototype.hasOwnProperty;function C(u,f){return S(u,f,new Set)}e.$Mn=C;function S(u,f,h){if((0,n.$2f)(u))return u;const g=f(u);if(typeof g<"u")return g;if(Array.isArray(u)){const a=[];for(const t of u)a.push(S(t,f,h));return a}if((0,n.$Uf)(u)){if(h.has(u))throw new Error("Cannot clone recursive data-structure");h.add(u);const a={};for(const t in u)O.call(u,t)&&(a[t]=S(u[t],f,h));return h.delete(u),a}return u}function d(u,f,h=!0){return(0,n.$Uf)(u)?((0,n.$Uf)(f)&&Object.keys(f).forEach(g=>{g in u?h&&((0,n.$Uf)(u[g])&&(0,n.$Uf)(f[g])?d(u[g],f[g],h):u[g]=f[g]):u[g]=f[g]}),u):f}e.$Nn=d;function c(u,f){if(u===f)return!0;if(u==null||f===null||f===void 0||typeof u!=typeof f||typeof u!="object"||Array.isArray(u)!==Array.isArray(f))return!1;let h,g;if(Array.isArray(u)){if(u.length!==f.length)return!1;for(h=0;h<u.length;h++)if(!c(u[h],f[h]))return!1}else{const a=[];for(g in u)a.push(g);a.sort();const t=[];for(g in f)t.push(g);if(t.sort(),!c(a,t))return!1;for(h=0;h<a.length;h++)if(!c(u[a[h]],f[a[h]]))return!1}return!0}e.$On=c;function y(u){const f=new Set;return JSON.stringify(u,(h,g)=>{if((0,n.$Uf)(g)||Array.isArray(g)){if(f.has(g))return"[Circular]";f.add(g)}return g})}e.$Pn=y;function v(u,f){const h=Object.create(null);return!u||!f||Object.keys(f).forEach(a=>{const t=u[a],o=f[a];c(t,o)||(h[a]=o)}),h}e.$Qn=v;function k(u,f){const h=f.toLowerCase(),g=Object.keys(u).find(a=>a.toLowerCase()===h);return g?u[g]:u[f]}e.$Rn=k;function $(u,f){const h=Object.create(null);for(const[g,a]of Object.entries(u))f(g,a)&&(h[g]=a);return h}e.$Sn=$;function m(u){let f=[];for(;Object.prototype!==u;)f=f.concat(Object.getOwnPropertyNames(u)),u=Object.getPrototypeOf(u);return f}e.$Tn=m;function w(u){const f=[];for(const h of m(u))typeof u[h]=="function"&&f.push(h);return f}e.$Un=w;function p(u,f){const h=a=>function(){const t=Array.prototype.slice.call(arguments,0);return f(a,t)},g={};for(const a of u)g[a]=h(a);return g}e.$Vn=p}),define(ae[105],ce([0,1,74]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$pk=e.ThemeColor=void 0;var R;(function(C){function S(d){return d&&typeof d=="object"&&typeof d.id=="string"}C.isThemeColor=S})(R||(e.ThemeColor=R={}));function P(C){return{id:C}}e.$pk=P;var O;(function(C){C.iconNameSegment="[A-Za-z0-9]+",C.iconNameExpression="[A-Za-z0-9-]+",C.iconModifierExpression="~[A-Za-z]+",C.iconNameCharacter="[A-Za-z0-9~-]";const S=new RegExp(`^(${C.iconNameExpression})(${C.iconModifierExpression})?$`);function d(f){const h=S.exec(f.id);if(!h)return d(n.$ok.error);const[,g,a]=h,t=["codicon","codicon-"+g];return a&&t.push("codicon-modifier-"+a.substring(1)),t}C.asClassNameArray=d;function c(f){return d(f).join(" ")}C.asClassName=c;function y(f){return"."+d(f).join(".")}C.asCSSSelector=y;function v(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(typeof f.color>"u"||R.isThemeColor(f.color))}C.isThemeIcon=v;const k=new RegExp(`^\\$\\((${C.iconNameExpression}(?:${C.iconModifierExpression})?)\\)$`);function $(f){const h=k.exec(f);if(!h)return;const[,g]=h;return{id:g}}C.fromString=$;function m(f){return{id:f}}C.fromId=m;function w(f,h){let g=f.id;const a=g.lastIndexOf("~");return a!==-1&&(g=g.substring(0,a)),h&&(g=`${g}~${h}`),{id:g}}C.modify=w;function p(f){const h=f.id.lastIndexOf("~");if(h!==-1)return f.id.substring(h+1)}C.getModifier=p;function u(f,h){return f.id===h.id&&f.color?.id===h.color?.id}C.isEqual=u})(O||(e.ThemeIcon=O={}))}),define(ae[32],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bg=e.$Ag=void 0;const n=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(P){return n.test(P)}e.$Ag=R,e.$Bg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(S){for(let d=0;d<S.length;d++)S[d]=Math.floor(Math.random()*256);return S};const O=new Uint8Array(16),C=[];for(let S=0;S<256;S++)C.push(S.toString(16).padStart(2,"0"));return function(){P(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let d=0,c="";return c+=C[O[d++]],c+=C[O[d++]],c+=C[O[d++]],c+=C[O[d++]],c+="-",c+=C[O[d++]],c+=C[O[d++]],c+="-",c+=C[O[d++]],c+=C[O[d++]],c+="-",c+=C[O[d++]],c+=C[O[d++]],c+="-",c+=C[O[d++]],c+=C[O[d++]],c+=C[O[d++]],c+=C[O[d++]],c+=C[O[d++]],c+=C[O[d++]],c}}()}),define(ae[146],ce([0,1,87,46,85]),function(X,e,n,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FV=void 0;async function O(C,S){if(await new Promise((y,v)=>{const k=R.createReadStream(C),$=n.createHash("sha256");k.pipe($);const m=(0,P.$db)((w,p)=>{k.removeAllListeners(),$.removeAllListeners(),w?v(w):y(p)});k.once("error",m),k.once("end",m),$.once("error",m),$.once("data",w=>m(void 0,w.toString("hex")))})!==S)throw new Error("Hash mismatch")}e.$FV=O}),define(ae[147],ce([0,1,26]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=void 0;const R=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function P(C){const S=C.replace(/\-/g,":").toLowerCase();return!R.has(S)}function O(){const C=(0,n.networkInterfaces)();for(const S in C){const d=C[S];if(d){for(const{mac:c}of d)if(P(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$ln=O}),define(ae[106],ce([0,1,88]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fg=e.$Eg=e.$Dg=void 0;function R(S,d,c,y=1){let v=!1;return new Promise(k=>{const $=setTimeout(()=>{if(!v)return v=!0,k(0)},c);P(S,d,y,m=>{if(!v)return v=!0,clearTimeout($),k(m)})})}e.$Dg=R;function P(S,d,c,y){if(d===0)return y(0);const v=new n.Socket;v.once("connect",()=>(C(v),P(S+c,d-1,c,y))),v.once("data",()=>{}),v.once("error",k=>(C(v),k.code!=="ECONNREFUSED"?P(S+c,d-1,c,y):y(S))),v.connect(S,"127.0.0.1")}e.$Eg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function O(S,d,c,y="127.0.0.1"){let v=!1,k,$=1;const m=n.createServer({pauseOnConnect:!0});function w(p,u){v||(v=!0,m.removeAllListeners(),m.close(),k&&clearTimeout(k),u(p))}return new Promise(p=>{k=setTimeout(()=>{w(0,p)},c),m.on("listening",()=>{w(S,p)}),m.on("error",u=>{u&&(u.code==="EADDRINUSE"||u.code==="EACCES")&&$<d?(S++,$++,m.listen(S,y)):w(0,p)}),m.on("close",()=>{w(0,p)}),m.listen(S,y)})}e.$Fg=O;function C(S){try{S.removeAllListeners("connect"),S.removeAllListeners("error"),S.end(),S.destroy(),S.unref()}catch(d){console.error(d)}}}),function(){function X(){function e(){return process.uncHostAllowlist}function n(d){const c=new Set;if(Array.isArray(d))for(const y of d)typeof y=="string"&&c.add(y);return Array.from(c)}function R(){const d=e();return d?Array.from(d):[]}function P(d){if(process.platform!=="win32")return;const c=e();if(c)if(typeof d=="string")c.add(d.toLowerCase());else for(const y of n(d))P(y)}function O(d){if(typeof d!="string")return;const c=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let y;for(const v of c){if(d.indexOf(v)!==0)continue;const $=d.indexOf("\\",v.length);if($===-1)continue;const m=d.substring(v.length,$);if(m){y=m;break}}return y}function C(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function S(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:R,addUNCHostToAllowlist:P,getUNCHost:O,disableUNCAccessRestrictions:C,isUNCAccessRestrictionsDisabled:S}}typeof define=="function"?define("vs/base/node/unc",[],function(){return X()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=X():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(ae[148],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JV=e.$IV=void 0,e.$IV="vscode:contextmenu",e.$JV="vscode:onCloseContextMenu"}),define(ae[149],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QV=void 0;class n{constructor(P,O){this.a=P,this.onMessage=O}send(P){try{this.a.send("vscode:message",P.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$QV=n}),define(ae[150],ce([11,10]),function(X,e){return X.create("vs/base/common/date",e)}),define(ae[151],ce([0,1,150]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lm=e.$Km=e.$Jm=void 0;const R=60,P=R*60,O=P*24,C=O*7,S=O*30,d=O*365;function c(k,$,m,w){typeof k!="number"&&(k=k.getTime());const p=Math.round((new Date().getTime()-k)/1e3);if(p<-30)return(0,n.localize)(0,null,c(new Date().getTime()+p*1e3,!1));if(!w&&p<30)return(0,n.localize)(1,null);let u;return p<R?(u=p,$?u===1?m?(0,n.localize)(2,null,u):(0,n.localize)(3,null,u):m?(0,n.localize)(4,null,u):(0,n.localize)(5,null,u):u===1?m?(0,n.localize)(6,null,u):(0,n.localize)(7,null,u):m?(0,n.localize)(8,null,u):(0,n.localize)(9,null,u)):p<P?(u=Math.floor(p/R),$?u===1?m?(0,n.localize)(10,null,u):(0,n.localize)(11,null,u):m?(0,n.localize)(12,null,u):(0,n.localize)(13,null,u):u===1?m?(0,n.localize)(14,null,u):(0,n.localize)(15,null,u):m?(0,n.localize)(16,null,u):(0,n.localize)(17,null,u)):p<O?(u=Math.floor(p/P),$?u===1?m?(0,n.localize)(18,null,u):(0,n.localize)(19,null,u):m?(0,n.localize)(20,null,u):(0,n.localize)(21,null,u):u===1?m?(0,n.localize)(22,null,u):(0,n.localize)(23,null,u):m?(0,n.localize)(24,null,u):(0,n.localize)(25,null,u)):p<C?(u=Math.floor(p/O),$?u===1?(0,n.localize)(26,null,u):(0,n.localize)(27,null,u):u===1?(0,n.localize)(28,null,u):(0,n.localize)(29,null,u)):p<S?(u=Math.floor(p/C),$?u===1?m?(0,n.localize)(30,null,u):(0,n.localize)(31,null,u):m?(0,n.localize)(32,null,u):(0,n.localize)(33,null,u):u===1?m?(0,n.localize)(34,null,u):(0,n.localize)(35,null,u):m?(0,n.localize)(36,null,u):(0,n.localize)(37,null,u)):p<d?(u=Math.floor(p/S),$?u===1?m?(0,n.localize)(38,null,u):(0,n.localize)(39,null,u):m?(0,n.localize)(40,null,u):(0,n.localize)(41,null,u):u===1?m?(0,n.localize)(42,null,u):(0,n.localize)(43,null,u):m?(0,n.localize)(44,null,u):(0,n.localize)(45,null,u)):(u=Math.floor(p/d),$?u===1?m?(0,n.localize)(46,null,u):(0,n.localize)(47,null,u):m?(0,n.localize)(48,null,u):(0,n.localize)(49,null,u):u===1?m?(0,n.localize)(50,null,u):(0,n.localize)(51,null,u):m?(0,n.localize)(52,null,u):(0,n.localize)(53,null,u))}e.$Jm=c;function y(k,$){const m=Math.abs(k/1e3);return m<1?$?(0,n.localize)(54,null,k):(0,n.localize)(55,null,k):m<R?$?(0,n.localize)(56,null,Math.round(k)/1e3):(0,n.localize)(57,null,Math.round(k)/1e3):m<P?$?(0,n.localize)(58,null,Math.round(k/(1e3*R))):(0,n.localize)(59,null,Math.round(k/(1e3*R))):m<O?$?(0,n.localize)(60,null,Math.round(k/(1e3*P))):(0,n.localize)(61,null,Math.round(k/(1e3*P))):(0,n.localize)(62,null,Math.round(k/(1e3*O)))}e.$Km=y;function v(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$Lm=v}),define(ae[152],ce([11,10]),function(X,e){return X.create("vs/base/common/errorMessage",e)}),define(ae[51],ce([0,1,22,12,152]),function(X,e,n,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5i=e.$4i=e.$3i=void 0;function O(v,k){return k&&(v.stack||v.stacktrace)?P.localize(0,null,S(v),C(v.stack)||C(v.stacktrace)):S(v)}function C(v){return Array.isArray(v)?v.join(`
`):v}function S(v){return v.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${v.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?P.localize(1,null,v.message):v.message||P.localize(2,null)}function d(v=null,k=!1){if(!v)return P.localize(3,null);if(Array.isArray(v)){const $=n.$Hb(v),m=d($[0],k);return $.length>1?P.localize(4,null,m,$.length):m}if(R.$Sf(v))return v;if(v.detail){const $=v.detail;if($.error)return O($.error,k);if($.exception)return O($.exception,k)}return v.stack?O(v,k):v.message?v.message:P.localize(5,null)}e.$3i=d;function c(v){const k=v;return k instanceof Error&&Array.isArray(k.actions)}e.$4i=c;function y(v,k){let $;return typeof v=="string"?$=new Error(v):$=v,$.actions=k,$}e.$5i=y}),define(ae[153],ce([11,10]),function(X,e){return X.create("vs/base/common/jsonErrorMessages",e)}),define(ae[154],ce([0,1,153]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_p=void 0;function R(P){switch(P){case 1:return(0,n.localize)(0,null);case 2:return(0,n.localize)(1,null);case 3:return(0,n.localize)(2,null);case 4:return(0,n.localize)(3,null);case 5:return(0,n.localize)(4,null);case 6:return(0,n.localize)(5,null);case 7:return(0,n.localize)(6,null);case 8:return(0,n.localize)(7,null);case 9:return(0,n.localize)(8,null);default:return""}}e.$_p=R}),define(ae[155],ce([11,10]),function(X,e){return X.create("vs/base/common/platform",e)}),define(ae[4],ce([0,1,155]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let R=!1,P=!1,O=!1,C=!1,S=!1,d=!1,c=!1,y=!1,v=!1,k=!1,$,m=e.$g,w=e.$g,p,u;const f=globalThis;let h;typeof f.vscode<"u"&&typeof f.vscode.process<"u"?h=f.vscode.process:typeof process<"u"&&(h=process);const g=typeof h?.versions?.electron=="string",a=g&&h?.type==="renderer";if(typeof h=="object"){R=h.platform==="win32",P=h.platform==="darwin",O=h.platform==="linux",C=O&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,c=g,v=!!h.env.CI||!!h.env.BUILD_ARTIFACTSTAGINGDIRECTORY,$=e.$g,m=e.$g;const E=h.env.VSCODE_NLS_CONFIG;if(E)try{const I=JSON.parse(E),M=I.availableLanguages["*"];$=I.locale,w=I.osLocale,m=M||e.$g,p=I._translationsConfigFile}catch{}S=!0}else typeof navigator=="object"&&!a?(u=navigator.userAgent,R=u.indexOf("Windows")>=0,P=u.indexOf("Macintosh")>=0,y=(u.indexOf("Macintosh")>=0||u.indexOf("iPad")>=0||u.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,O=u.indexOf("Linux")>=0,k=u?.indexOf("Mobi")>=0,d=!0,$=n.getConfiguredDefaultLocale(n.localize(0,null))||e.$g,m=$,w=navigator.language):console.error("Unable to resolve platform.");var t;(function(E){E[E.Web=0]="Web",E[E.Mac=1]="Mac",E[E.Linux=2]="Linux",E[E.Windows=3]="Windows"})(t||(e.Platform=t={}));function o(E){switch(E){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=o;let r=0;P?r=1:R?r=3:O&&(r=2),e.$i=R,e.$j=P,e.$k=O,e.$l=C,e.$m=S,e.$n=c,e.$o=d,e.$p=d&&typeof f.importScripts=="function",e.$q=e.$p?f.origin:void 0,e.$r=y,e.$s=k,e.$t=v,e.$u=r,e.$v=u,e.$w=m;var i;(function(E){function I(){return e.$w}E.value=I;function M(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}E.isDefaultVariant=M;function T(){return e.$w==="en"}E.isDefault=T})(i||(e.Language=i={})),e.$x=$,e.$y=w,e.$z=p,e.$A=typeof f.postMessage=="function"&&!f.importScripts,e.$B=(()=>{if(e.$A){const E=[];f.addEventListener("message",M=>{if(M.data&&M.data.vscodeScheduleAsyncWork)for(let T=0,W=E.length;T<W;T++){const V=E[T];if(V.id===M.data.vscodeScheduleAsyncWork){E.splice(T,1),V.callback();return}}});let I=0;return M=>{const T=++I;E.push({id:T,callback:M}),f.postMessage({vscodeScheduleAsyncWork:T},"*")}}return E=>setTimeout(E)})();var s;(function(E){E[E.Windows=1]="Windows",E[E.Macintosh=2]="Macintosh",E[E.Linux=3]="Linux"})(s||(e.OperatingSystem=s={})),e.OS=P||y?2:R?1:3;let l=!0,b=!1;function D(){if(!b){b=!0;const E=new Uint8Array(2);E[0]=1,E[1]=2,l=new Uint16Array(E.buffer)[0]===513}return l}e.$D=D,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function j(E){return parseFloat(E)>=20}e.$J=j}),define(ae[36],ce([0,1,4]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let R;const P=globalThis.vscode;if(typeof P<"u"&&typeof P.process<"u"){const O=P.process;R={get platform(){return O.platform},get arch(){return O.arch},get env(){return O.env},cwd(){return O.cwd()}}}else typeof process<"u"?R={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:R={get platform(){return n.$i?"win32":n.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.$dc=R.platform,e.$ec=R.arch}),define(ae[9],ce([0,1,36]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const R=65,P=97,O=90,C=122,S=46,d=47,c=92,y=58,v=63;class k extends Error{constructor(o,r,i){let s;typeof r=="string"&&r.indexOf("not ")===0?(s="must not be",r=r.replace(/^not /,"")):s="must be";const l=o.indexOf(".")!==-1?"property":"argument";let b=`The "${o}" ${l} ${s} of type ${r}`;b+=`. Received type ${typeof i}`,super(b),this.code="ERR_INVALID_ARG_TYPE"}}function $(t,o){if(t===null||typeof t!="object")throw new k(o,"Object",t)}function m(t,o){if(typeof t!="string")throw new k(o,"string",t)}const w=n.$dc==="win32";function p(t){return t===d||t===c}function u(t){return t===d}function f(t){return t>=R&&t<=O||t>=P&&t<=C}function h(t,o,r,i){let s="",l=0,b=-1,D=0,j=0;for(let E=0;E<=t.length;++E){if(E<t.length)j=t.charCodeAt(E);else{if(i(j))break;j=d}if(i(j)){if(!(b===E-1||D===1))if(D===2){if(s.length<2||l!==2||s.charCodeAt(s.length-1)!==S||s.charCodeAt(s.length-2)!==S){if(s.length>2){const I=s.lastIndexOf(r);I===-1?(s="",l=0):(s=s.slice(0,I),l=s.length-1-s.lastIndexOf(r)),b=E,D=0;continue}else if(s.length!==0){s="",l=0,b=E,D=0;continue}}o&&(s+=s.length>0?`${r}..`:"..",l=2)}else s.length>0?s+=`${r}${t.slice(b+1,E)}`:s=t.slice(b+1,E),l=E-b-1;b=E,D=0}else j===S&&D!==-1?++D:D=-1}return s}function g(t,o){$(o,"pathObject");const r=o.dir||o.root,i=o.base||`${o.name||""}${o.ext||""}`;return r?r===o.root?`${r}${i}`:`${r}${t}${i}`:i}e.$fc={resolve(...t){let o="",r="",i=!1;for(let s=t.length-1;s>=-1;s--){let l;if(s>=0){if(l=t[s],m(l,"path"),l.length===0)continue}else o.length===0?l=n.cwd():(l=n.env[`=${o}`]||n.cwd(),(l===void 0||l.slice(0,2).toLowerCase()!==o.toLowerCase()&&l.charCodeAt(2)===c)&&(l=`${o}\\`));const b=l.length;let D=0,j="",E=!1;const I=l.charCodeAt(0);if(b===1)p(I)&&(D=1,E=!0);else if(p(I))if(E=!0,p(l.charCodeAt(1))){let M=2,T=M;for(;M<b&&!p(l.charCodeAt(M));)M++;if(M<b&&M!==T){const W=l.slice(T,M);for(T=M;M<b&&p(l.charCodeAt(M));)M++;if(M<b&&M!==T){for(T=M;M<b&&!p(l.charCodeAt(M));)M++;(M===b||M!==T)&&(j=`\\\\${W}\\${l.slice(T,M)}`,D=M)}}}else D=1;else f(I)&&l.charCodeAt(1)===y&&(j=l.slice(0,2),D=2,b>2&&p(l.charCodeAt(2))&&(E=!0,D=3));if(j.length>0)if(o.length>0){if(j.toLowerCase()!==o.toLowerCase())continue}else o=j;if(i){if(o.length>0)break}else if(r=`${l.slice(D)}\\${r}`,i=E,E&&o.length>0)break}return r=h(r,!i,"\\",p),i?`${o}\\${r}`:`${o}${r}`||"."},normalize(t){m(t,"path");const o=t.length;if(o===0)return".";let r=0,i,s=!1;const l=t.charCodeAt(0);if(o===1)return u(l)?"\\":t;if(p(l))if(s=!0,p(t.charCodeAt(1))){let D=2,j=D;for(;D<o&&!p(t.charCodeAt(D));)D++;if(D<o&&D!==j){const E=t.slice(j,D);for(j=D;D<o&&p(t.charCodeAt(D));)D++;if(D<o&&D!==j){for(j=D;D<o&&!p(t.charCodeAt(D));)D++;if(D===o)return`\\\\${E}\\${t.slice(j)}\\`;D!==j&&(i=`\\\\${E}\\${t.slice(j,D)}`,r=D)}}}else r=1;else f(l)&&t.charCodeAt(1)===y&&(i=t.slice(0,2),r=2,o>2&&p(t.charCodeAt(2))&&(s=!0,r=3));let b=r<o?h(t.slice(r),!s,"\\",p):"";return b.length===0&&!s&&(b="."),b.length>0&&p(t.charCodeAt(o-1))&&(b+="\\"),i===void 0?s?`\\${b}`:b:s?`${i}\\${b}`:`${i}${b}`},isAbsolute(t){m(t,"path");const o=t.length;if(o===0)return!1;const r=t.charCodeAt(0);return p(r)||o>2&&f(r)&&t.charCodeAt(1)===y&&p(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let o,r;for(let l=0;l<t.length;++l){const b=t[l];m(b,"path"),b.length>0&&(o===void 0?o=r=b:o+=`\\${b}`)}if(o===void 0)return".";let i=!0,s=0;if(typeof r=="string"&&p(r.charCodeAt(0))){++s;const l=r.length;l>1&&p(r.charCodeAt(1))&&(++s,l>2&&(p(r.charCodeAt(2))?++s:i=!1))}if(i){for(;s<o.length&&p(o.charCodeAt(s));)s++;s>=2&&(o=`\\${o.slice(s)}`)}return e.$fc.normalize(o)},relative(t,o){if(m(t,"from"),m(o,"to"),t===o)return"";const r=e.$fc.resolve(t),i=e.$fc.resolve(o);if(r===i||(t=r.toLowerCase(),o=i.toLowerCase(),t===o))return"";let s=0;for(;s<t.length&&t.charCodeAt(s)===c;)s++;let l=t.length;for(;l-1>s&&t.charCodeAt(l-1)===c;)l--;const b=l-s;let D=0;for(;D<o.length&&o.charCodeAt(D)===c;)D++;let j=o.length;for(;j-1>D&&o.charCodeAt(j-1)===c;)j--;const E=j-D,I=b<E?b:E;let M=-1,T=0;for(;T<I;T++){const V=t.charCodeAt(s+T);if(V!==o.charCodeAt(D+T))break;V===c&&(M=T)}if(T!==I){if(M===-1)return i}else{if(E>I){if(o.charCodeAt(D+T)===c)return i.slice(D+T+1);if(T===2)return i.slice(D+T)}b>I&&(t.charCodeAt(s+T)===c?M=T:T===2&&(M=3)),M===-1&&(M=0)}let W="";for(T=s+M+1;T<=l;++T)(T===l||t.charCodeAt(T)===c)&&(W+=W.length===0?"..":"\\..");return D+=M,W.length>0?`${W}${i.slice(D,j)}`:(i.charCodeAt(D)===c&&++D,i.slice(D,j))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const o=e.$fc.resolve(t);if(o.length<=2)return t;if(o.charCodeAt(0)===c){if(o.charCodeAt(1)===c){const r=o.charCodeAt(2);if(r!==v&&r!==S)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(f(o.charCodeAt(0))&&o.charCodeAt(1)===y&&o.charCodeAt(2)===c)return`\\\\?\\${o}`;return t},dirname(t){m(t,"path");const o=t.length;if(o===0)return".";let r=-1,i=0;const s=t.charCodeAt(0);if(o===1)return p(s)?t:".";if(p(s)){if(r=i=1,p(t.charCodeAt(1))){let D=2,j=D;for(;D<o&&!p(t.charCodeAt(D));)D++;if(D<o&&D!==j){for(j=D;D<o&&p(t.charCodeAt(D));)D++;if(D<o&&D!==j){for(j=D;D<o&&!p(t.charCodeAt(D));)D++;if(D===o)return t;D!==j&&(r=i=D+1)}}}}else f(s)&&t.charCodeAt(1)===y&&(r=o>2&&p(t.charCodeAt(2))?3:2,i=r);let l=-1,b=!0;for(let D=o-1;D>=i;--D)if(p(t.charCodeAt(D))){if(!b){l=D;break}}else b=!1;if(l===-1){if(r===-1)return".";l=r}return t.slice(0,l)},basename(t,o){o!==void 0&&m(o,"ext"),m(t,"path");let r=0,i=-1,s=!0,l;if(t.length>=2&&f(t.charCodeAt(0))&&t.charCodeAt(1)===y&&(r=2),o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let b=o.length-1,D=-1;for(l=t.length-1;l>=r;--l){const j=t.charCodeAt(l);if(p(j)){if(!s){r=l+1;break}}else D===-1&&(s=!1,D=l+1),b>=0&&(j===o.charCodeAt(b)?--b===-1&&(i=l):(b=-1,i=D))}return r===i?i=D:i===-1&&(i=t.length),t.slice(r,i)}for(l=t.length-1;l>=r;--l)if(p(t.charCodeAt(l))){if(!s){r=l+1;break}}else i===-1&&(s=!1,i=l+1);return i===-1?"":t.slice(r,i)},extname(t){m(t,"path");let o=0,r=-1,i=0,s=-1,l=!0,b=0;t.length>=2&&t.charCodeAt(1)===y&&f(t.charCodeAt(0))&&(o=i=2);for(let D=t.length-1;D>=o;--D){const j=t.charCodeAt(D);if(p(j)){if(!l){i=D+1;break}continue}s===-1&&(l=!1,s=D+1),j===S?r===-1?r=D:b!==1&&(b=1):r!==-1&&(b=-1)}return r===-1||s===-1||b===0||b===1&&r===s-1&&r===i+1?"":t.slice(r,s)},format:g.bind(null,"\\"),parse(t){m(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const r=t.length;let i=0,s=t.charCodeAt(0);if(r===1)return p(s)?(o.root=o.dir=t,o):(o.base=o.name=t,o);if(p(s)){if(i=1,p(t.charCodeAt(1))){let M=2,T=M;for(;M<r&&!p(t.charCodeAt(M));)M++;if(M<r&&M!==T){for(T=M;M<r&&p(t.charCodeAt(M));)M++;if(M<r&&M!==T){for(T=M;M<r&&!p(t.charCodeAt(M));)M++;M===r?i=M:M!==T&&(i=M+1)}}}}else if(f(s)&&t.charCodeAt(1)===y){if(r<=2)return o.root=o.dir=t,o;if(i=2,p(t.charCodeAt(2))){if(r===3)return o.root=o.dir=t,o;i=3}}i>0&&(o.root=t.slice(0,i));let l=-1,b=i,D=-1,j=!0,E=t.length-1,I=0;for(;E>=i;--E){if(s=t.charCodeAt(E),p(s)){if(!j){b=E+1;break}continue}D===-1&&(j=!1,D=E+1),s===S?l===-1?l=E:I!==1&&(I=1):l!==-1&&(I=-1)}return D!==-1&&(l===-1||I===0||I===1&&l===D-1&&l===b+1?o.base=o.name=t.slice(b,D):(o.name=t.slice(b,l),o.base=t.slice(b,D),o.ext=t.slice(l,D))),b>0&&b!==i?o.dir=t.slice(0,b-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const a=(()=>{if(w){const t=/\\/g;return()=>{const o=n.cwd().replace(t,"/");return o.slice(o.indexOf("/"))}}return()=>n.cwd()})();e.$gc={resolve(...t){let o="",r=!1;for(let i=t.length-1;i>=-1&&!r;i--){const s=i>=0?t[i]:a();m(s,"path"),s.length!==0&&(o=`${s}/${o}`,r=s.charCodeAt(0)===d)}return o=h(o,!r,"/",u),r?`/${o}`:o.length>0?o:"."},normalize(t){if(m(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===d,r=t.charCodeAt(t.length-1)===d;return t=h(t,!o,"/",u),t.length===0?o?"/":r?"./":".":(r&&(t+="/"),o?`/${t}`:t)},isAbsolute(t){return m(t,"path"),t.length>0&&t.charCodeAt(0)===d},join(...t){if(t.length===0)return".";let o;for(let r=0;r<t.length;++r){const i=t[r];m(i,"path"),i.length>0&&(o===void 0?o=i:o+=`/${i}`)}return o===void 0?".":e.$gc.normalize(o)},relative(t,o){if(m(t,"from"),m(o,"to"),t===o||(t=e.$gc.resolve(t),o=e.$gc.resolve(o),t===o))return"";const r=1,i=t.length,s=i-r,l=1,b=o.length-l,D=s<b?s:b;let j=-1,E=0;for(;E<D;E++){const M=t.charCodeAt(r+E);if(M!==o.charCodeAt(l+E))break;M===d&&(j=E)}if(E===D)if(b>D){if(o.charCodeAt(l+E)===d)return o.slice(l+E+1);if(E===0)return o.slice(l+E)}else s>D&&(t.charCodeAt(r+E)===d?j=E:E===0&&(j=0));let I="";for(E=r+j+1;E<=i;++E)(E===i||t.charCodeAt(E)===d)&&(I+=I.length===0?"..":"/..");return`${I}${o.slice(l+j)}`},toNamespacedPath(t){return t},dirname(t){if(m(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===d;let r=-1,i=!0;for(let s=t.length-1;s>=1;--s)if(t.charCodeAt(s)===d){if(!i){r=s;break}}else i=!1;return r===-1?o?"/":".":o&&r===1?"//":t.slice(0,r)},basename(t,o){o!==void 0&&m(o,"ext"),m(t,"path");let r=0,i=-1,s=!0,l;if(o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let b=o.length-1,D=-1;for(l=t.length-1;l>=0;--l){const j=t.charCodeAt(l);if(j===d){if(!s){r=l+1;break}}else D===-1&&(s=!1,D=l+1),b>=0&&(j===o.charCodeAt(b)?--b===-1&&(i=l):(b=-1,i=D))}return r===i?i=D:i===-1&&(i=t.length),t.slice(r,i)}for(l=t.length-1;l>=0;--l)if(t.charCodeAt(l)===d){if(!s){r=l+1;break}}else i===-1&&(s=!1,i=l+1);return i===-1?"":t.slice(r,i)},extname(t){m(t,"path");let o=-1,r=0,i=-1,s=!0,l=0;for(let b=t.length-1;b>=0;--b){const D=t.charCodeAt(b);if(D===d){if(!s){r=b+1;break}continue}i===-1&&(s=!1,i=b+1),D===S?o===-1?o=b:l!==1&&(l=1):o!==-1&&(l=-1)}return o===-1||i===-1||l===0||l===1&&o===i-1&&o===r+1?"":t.slice(o,i)},format:g.bind(null,"/"),parse(t){m(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const r=t.charCodeAt(0)===d;let i;r?(o.root="/",i=1):i=0;let s=-1,l=0,b=-1,D=!0,j=t.length-1,E=0;for(;j>=i;--j){const I=t.charCodeAt(j);if(I===d){if(!D){l=j+1;break}continue}b===-1&&(D=!1,b=j+1),I===S?s===-1?s=j:E!==1&&(E=1):s!==-1&&(E=-1)}if(b!==-1){const I=l===0&&r?1:l;s===-1||E===0||E===1&&s===b-1&&s===l+1?o.base=o.name=t.slice(I,b):(o.name=t.slice(I,s),o.base=t.slice(I,b),o.ext=t.slice(s,b))}return l>0?o.dir=t.slice(0,l-1):r&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=w?e.$fc.normalize:e.$gc.normalize,e.$ic=w?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=w?e.$fc.join:e.$gc.join,e.$kc=w?e.$fc.resolve:e.$gc.resolve,e.$lc=w?e.$fc.relative:e.$gc.relative,e.$mc=w?e.$fc.dirname:e.$gc.dirname,e.$nc=w?e.$fc.basename:e.$gc.basename,e.$oc=w?e.$fc.extname:e.$gc.extname,e.$pc=w?e.$fc.format:e.$gc.format,e.$qc=w?e.$fc.parse:e.$gc.parse,e.$rc=w?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=w?e.$fc.sep:e.$gc.sep,e.$tc=w?e.$fc.delimiter:e.$gc.delimiter}),define(ae[33],ce([0,1,9,4,25,12]),function(X,e,n,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=void 0;function C(l){return l===47||l===92}e.$$f=C;function S(l){return l.replace(/[\\/]/g,n.$gc.sep)}e.$_f=S;function d(l){return l.indexOf("/")===-1&&(l=S(l)),/^[a-zA-Z]:(\/|$)/.test(l)&&(l="/"+l),l}e.$ag=d;function c(l,b=n.$gc.sep){if(!l)return"";const D=l.length,j=l.charCodeAt(0);if(C(j)){if(C(l.charCodeAt(1))&&!C(l.charCodeAt(2))){let I=3;const M=I;for(;I<D&&!C(l.charCodeAt(I));I++);if(M!==I&&!C(l.charCodeAt(I+1))){for(I+=1;I<D;I++)if(C(l.charCodeAt(I)))return l.slice(0,I+1).replace(/[\\/]/g,b)}}return b}else if(u(j)&&l.charCodeAt(1)===58)return C(l.charCodeAt(2))?l.slice(0,2)+b:l.slice(0,2);let E=l.indexOf("://");if(E!==-1){for(E+=3;E<D;E++)if(C(l.charCodeAt(E)))return l.slice(0,E+1)}return""}e.$bg=c;function y(l){if(!R.$i||!l||l.length<5)return!1;let b=l.charCodeAt(0);if(b!==92||(b=l.charCodeAt(1),b!==92))return!1;let D=2;const j=D;for(;D<l.length&&(b=l.charCodeAt(D),b!==92);D++);return!(j===D||(b=l.charCodeAt(D+1),isNaN(b)||b===92))}e.$cg=y;const v=/[\\/:\*\?"<>\|]/g,k=/[\\/]/g,$=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(l,b=R.$i){const D=b?v:k;return!(!l||l.length===0||/^\s+$/.test(l)||(D.lastIndex=0,D.test(l))||b&&$.test(l)||l==="."||l===".."||b&&l[l.length-1]==="."||b&&l.length!==l.trim().length||l.length>255)}e.$dg=m;function w(l,b,D){const j=l===b;return!D||j?j:!l||!b?!1:(0,P.$jf)(l,b)}e.$eg=w;function p(l,b,D,j=n.sep){if(l===b)return!0;if(!l||!b||b.length>l.length)return!1;if(D){if(!(0,P.$kf)(l,b))return!1;if(b.length===l.length)return!0;let I=b.length;return b.charAt(b.length-1)===j&&I--,l.charAt(I)===j}return b.charAt(b.length-1)!==j&&(b+=j),l.indexOf(b)===0}e.$fg=p;function u(l){return l>=65&&l<=90||l>=97&&l<=122}e.$gg=u;function f(l,b){return R.$i&&l.endsWith(":")&&(l+=n.sep),(0,n.$ic)(l)||(l=(0,n.$jc)(b,l)),l=(0,n.$hc)(l),R.$i?(l=(0,P.$4e)(l,n.sep),l.endsWith(":")&&(l+=n.sep)):(l=(0,P.$4e)(l,n.sep),l||(l=n.sep)),l}e.$hg=f;function h(l){const b=(0,n.$hc)(l);return R.$i?l.length>3?!1:g(b)&&(l.length===2||b.charCodeAt(2)===92):b===n.$gc.sep}e.$ig=h;function g(l,b=R.$i){return b?u(l.charCodeAt(0))&&l.charCodeAt(1)===58:!1}e.$jg=g;function a(l,b=R.$i){return g(l,b)?l[0]:void 0}e.$kg=a;function t(l,b,D){return b.length>l.length?-1:l===b?0:(D&&(l=l.toLowerCase(),b=b.toLowerCase()),l.indexOf(b))}e.$lg=t;function o(l){const b=l.split(":");let D,j,E;for(const I of b){const M=Number(I);(0,O.$Wf)(M)?j===void 0?j=M:E===void 0&&(E=M):D=D?[D,I].join(":"):I}if(!D)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:D,line:j!==void 0?j:void 0,column:E!==void 0?E:j!==void 0?1:void 0}}e.$mg=o;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function s(l,b,D=8){let j="";for(let I=0;I<D;I++){let M;I===0&&R.$i&&!b&&(D===3||D===4)?M=i:M=r,j+=M.charAt(Math.floor(Math.random()*M.length))}let E;return b?E=`${b}-${j}`:E=j,l?(0,n.$jc)(l,E):E}e.$ng=s}),define(ae[75],ce([0,1,4]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3l=e.$2l=e.TerminateResponseCode=e.Source=void 0;var R;(function(S){S[S.stdout=0]="stdout",S[S.stderr=1]="stderr"})(R||(e.Source=R={}));var P;(function(S){S[S.Success=0]="Success",S[S.Unknown=1]="Unknown",S[S.AccessDenied=2]="AccessDenied",S[S.ProcessNotFound=3]="ProcessNotFound"})(P||(e.TerminateResponseCode=P={}));function O(S,...d){const c=d.reduce((k,$)=>(k[$]=!0,k),{}),y=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(S).filter(k=>!c[k]).forEach(k=>{for(let $=0;$<y.length;$++)if(k.search(y[$])!==-1){delete S[k];break}})}e.$2l=O;function C(S){S&&(delete S.DEBUG,n.$j&&delete S.DYLD_LIBRARY_PATH,n.$k&&delete S.LD_PRELOAD)}e.$3l=C}),define(ae[7],ce([0,1,9,4]),function(X,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const P=/^\w[\w\d+.-]*$/,O=/^\//,C=/^\/\//;function S(i,s){if(!i.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!P.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!O.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(C.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function d(i,s){return!i&&!s?"file":i}function c(i,s){switch(i){case"https":case"http":case"file":s?s[0]!==v&&(s=v+s):s=v;break}return s}const y="",v="/",k=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class ${static isUri(s){return s instanceof $?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}constructor(s,l,b,D,j,E=!1){typeof s=="object"?(this.scheme=s.scheme||y,this.authority=s.authority||y,this.path=s.path||y,this.query=s.query||y,this.fragment=s.fragment||y):(this.scheme=d(s,E),this.authority=l||y,this.path=c(this.scheme,b||y),this.query=D||y,this.fragment=j||y,S(this,E))}get fsPath(){return g(this,!1)}with(s){if(!s)return this;let{scheme:l,authority:b,path:D,query:j,fragment:E}=s;return l===void 0?l=this.scheme:l===null&&(l=y),b===void 0?b=this.authority:b===null&&(b=y),D===void 0?D=this.path:D===null&&(D=y),j===void 0?j=this.query:j===null&&(j=y),E===void 0?E=this.fragment:E===null&&(E=y),l===this.scheme&&b===this.authority&&D===this.path&&j===this.query&&E===this.fragment?this:new p(l,b,D,j,E)}static parse(s,l=!1){const b=k.exec(s);return b?new p(b[2]||y,r(b[4]||y),r(b[5]||y),r(b[7]||y),r(b[9]||y),l):new p(y,y,y,y,y)}static file(s){let l=y;if(R.$i&&(s=s.replace(/\\/g,v)),s[0]===v&&s[1]===v){const b=s.indexOf(v,2);b===-1?(l=s.substring(2),s=v):(l=s.substring(2,b),s=s.substring(b)||v)}return new p("file",l,s,y,y)}static from(s,l){return new p(s.scheme,s.authority,s.path,s.query,s.fragment,l)}static joinPath(s,...l){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let b;return R.$i&&s.scheme==="file"?b=$.file(n.$fc.join(g(s,!0),...l)).path:b=n.$gc.join(s.path,...l),s.with({path:b})}toString(s=!1){return a(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof $)return s;{const l=new p(s);return l._formatted=s.external??null,l._fsPath=s._sep===w?s.fsPath??null:null,l}}else return s}}e.URI=$;function m(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.$vc=m;const w=R.$i?1:void 0;class p extends ${constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(s=!1){return s?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=w),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const u={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function f(i,s,l){let b,D=-1;for(let j=0;j<i.length;j++){const E=i.charCodeAt(j);if(E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57||E===45||E===46||E===95||E===126||s&&E===47||l&&E===91||l&&E===93||l&&E===58)D!==-1&&(b+=encodeURIComponent(i.substring(D,j)),D=-1),b!==void 0&&(b+=i.charAt(j));else{b===void 0&&(b=i.substr(0,j));const I=u[E];I!==void 0?(D!==-1&&(b+=encodeURIComponent(i.substring(D,j)),D=-1),b+=I):D===-1&&(D=j)}}return D!==-1&&(b+=encodeURIComponent(i.substring(D))),b!==void 0?b:i}function h(i){let s;for(let l=0;l<i.length;l++){const b=i.charCodeAt(l);b===35||b===63?(s===void 0&&(s=i.substr(0,l)),s+=u[b]):s!==void 0&&(s+=i[l])}return s!==void 0?s:i}function g(i,s){let l;return i.authority&&i.path.length>1&&i.scheme==="file"?l=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?s?l=i.path.substr(1):l=i.path[1].toLowerCase()+i.path.substr(2):l=i.path,R.$i&&(l=l.replace(/\//g,"\\")),l}e.$wc=g;function a(i,s){const l=s?h:f;let b="",{scheme:D,authority:j,path:E,query:I,fragment:M}=i;if(D&&(b+=D,b+=":"),(j||D==="file")&&(b+=v,b+=v),j){let T=j.indexOf("@");if(T!==-1){const W=j.substr(0,T);j=j.substr(T+1),T=W.lastIndexOf(":"),T===-1?b+=l(W,!1,!1):(b+=l(W.substr(0,T),!1,!1),b+=":",b+=l(W.substr(T+1),!1,!0)),b+="@"}j=j.toLowerCase(),T=j.lastIndexOf(":"),T===-1?b+=l(j,!1,!0):(b+=l(j.substr(0,T),!1,!0),b+=j.substr(T))}if(E){if(E.length>=3&&E.charCodeAt(0)===47&&E.charCodeAt(2)===58){const T=E.charCodeAt(1);T>=65&&T<=90&&(E=`/${String.fromCharCode(T+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===58){const T=E.charCodeAt(0);T>=65&&T<=90&&(E=`${String.fromCharCode(T+32)}:${E.substr(2)}`)}b+=l(E,!0,!1)}return I&&(b+="?",b+=l(I,!1,!1)),M&&(b+="#",b+=s?M:f(M,!1,!1)),b}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(o)?i.replace(o,s=>t(s)):i}}),define(ae[156],ce([0,1,7]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Cq=e.$Bq=e.$Aq=void 0;function R(c){const y=c;return y&&typeof y.type=="string"&&typeof y.severity=="string"}e.$Aq=R;function P(c){const y=[];let v;try{const k=JSON.parse(c.arguments),$=k[k.length-1];$&&$.__$stack&&(k.pop(),v=$.__$stack),y.push(...k)}catch{y.push("Unable to log remote console arguments",c.arguments)}return{args:y,stack:v}}e.$Bq=P;function O(c){if(typeof c!="string")return O(P(c).stack);const y=c;if(y){const v=C(y),k=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(v||"");if(k&&k.length===4)return{uri:n.URI.file(k[1]),line:Number(k[2]),column:Number(k[3])}}}e.$Cq=O;function C(c){if(!c)return c;const y=c.indexOf(`
`);return y===-1?c:c.substring(0,y)}function S(c,y){const{args:v,stack:k}=P(c),$=typeof v[0]=="string"&&v.length===1;let m=C(k);m&&(m=`(${m.trim()})`);let w=[];if(typeof v[0]=="string"?m&&$?w=[`%c[${y}] %c${v[0]} %c${m}`,d("blue"),d(""),d("grey")]:w=[`%c[${y}] %c${v[0]}`,d("blue"),d(""),...v.slice(1)]:w=[`%c[${y}]%`,d("blue"),...v],m&&!$&&w.push(m),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,w)}e.log=S;function d(c){return`color: ${c}`}}),define(ae[76],ce([0,1,17,7]),function(X,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oh=e.$Nh=e.$Mh=void 0;function P(d){return JSON.stringify(d,C)}e.$Mh=P;function O(d){let c=JSON.parse(d);return c=S(c),c}e.$Nh=O;function C(d,c){return c instanceof RegExp?{$mid:2,source:c.source,flags:c.flags}:c}function S(d,c=0){if(!d||c>200)return d;if(typeof d=="object"){switch(d.$mid){case 1:return R.URI.revive(d);case 2:return new RegExp(d.source,d.flags);case 17:return new Date(d.source)}if(d instanceof n.$se||d instanceof Uint8Array)return d;if(Array.isArray(d))for(let y=0;y<d.length;++y)d[y]=S(d[y],c+1);else for(const y in d)Object.hasOwnProperty.call(d,y)&&(d[y]=S(d[y],c+1))}return d}e.$Oh=S}),define(ae[13],ce([0,1,15,4,25,7,9]),function(X,e,n,R,P,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.Schemas=void 0;var S;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeManagedRemoteResource="vscode-managed-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.vscodeChatCodeBlock="vscode-chat-code-block",m.vscodeChatSesssion="vscode-chat-editor",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm",m.codeSetting="code-setting"})(S||(e.Schemas=S={}));function d(m,w){return O.URI.isUri(m)?(0,P.$jf)(m.scheme,w):(0,P.$kf)(m,w+":")}e.$og=d;function c(m,...w){return w.some(p=>d(m,p))}e.$pg=c,e.$qg="vscode-tkn",e.$rg="tkn";class y{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(w){this.d=w}setDelegate(w){this.e=w}setServerRootPath(w,p){this.f=v(w,p)}getServerRootPath(){return this.f}get g(){return C.$gc.join(this.f,S.vscodeRemoteResource)}set(w,p,u){this.a[w]=p,this.b[w]=u}setConnectionToken(w,p){this.c[w]=p}getPreferredWebSchema(){return this.d}rewrite(w){if(this.e)try{return this.e(w)}catch(a){return n.$1(a),w}const p=w.authority;let u=this.a[p];u&&u.indexOf(":")!==-1&&u.indexOf("[")===-1&&(u=`[${u}]`);const f=this.b[p],h=this.c[p];let g=`path=${encodeURIComponent(w.path)}`;return typeof h=="string"&&(g+=`&${e.$rg}=${encodeURIComponent(h)}`),O.URI.from({scheme:R.$o?this.d:S.vscodeRemoteResource,authority:`${u}:${f}`,path:this.g,query:g})}}e.$sg=new y;function v(m,w){return C.$gc.join(w??"/",`${m.quality??"oss"}-${m.commit??"dev"}`)}e.$tg=v,e.$ug="vs/../../extensions",e.$vg="vs/../../node_modules",e.$wg="vs/../../node_modules.asar",e.$xg="vs/../../node_modules.asar.unpacked",e.$yg="vscode-app";class k{static{this.a=e.$yg}asBrowserUri(w){const p=this.b(w,X);return this.uriToBrowserUri(p)}uriToBrowserUri(w){return w.scheme===S.vscodeRemote?e.$sg.rewrite(w):w.scheme===S.file&&(R.$m||R.$q===`${S.vscodeFileResource}://${k.a}`)?w.with({scheme:S.vscodeFileResource,authority:w.authority||k.a,query:null,fragment:null}):w}asFileUri(w){const p=this.b(w,X);return this.uriToFileUri(p)}uriToFileUri(w){return w.scheme===S.vscodeFileResource?w.with({scheme:S.file,authority:w.authority!==k.a?w.authority:null,query:null,fragment:null}):w}b(w,p){return O.URI.isUri(w)?w:O.URI.parse(p.toUrl(w))}}e.$zg=new k;var $;(function(m){const w=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(w.get("3"));const p="vscode-coi";function u(h){let g;typeof h=="string"?g=new URL(h).searchParams:h instanceof URL?g=h.searchParams:O.URI.isUri(h)&&(g=new URL(h.toString(!0)).searchParams);const a=g?.get(p);if(a)return w.get(a)}m.getHeadersFromQuery=u;function f(h,g,a){if(!globalThis.crossOriginIsolated)return;const t=g&&a?"3":a?"2":"1";h instanceof URLSearchParams?h.set(p,t):h[p]=t}m.addSearchParam=f})($||(e.COI=$={}))}),define(ae[19],ce([0,1,33,13,9,4,25,7]),function(X,e,n,R,P,O,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3g=e.DataUri=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=void 0;function d($){return(0,S.$wc)($,!0)}e.$Gg=d;class c{constructor(m){this.a=m}compare(m,w,p=!1){return m===w?0:(0,C.$cf)(this.getComparisonKey(m,p),this.getComparisonKey(w,p))}isEqual(m,w,p=!1){return m===w?!0:!m||!w?!1:this.getComparisonKey(m,p)===this.getComparisonKey(w,p)}getComparisonKey(m,w=!1){return m.with({path:this.a(m)?m.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(m){return this.a(m)}isEqualOrParent(m,w,p=!1){if(m.scheme===w.scheme){if(m.scheme===R.Schemas.file)return n.$fg(d(m),d(w),this.a(m))&&m.query===w.query&&(p||m.fragment===w.fragment);if((0,e.$Xg)(m.authority,w.authority))return n.$fg(m.path,w.path,this.a(m),"/")&&m.query===w.query&&(p||m.fragment===w.fragment)}return!1}joinPath(m,...w){return S.URI.joinPath(m,...w)}basenameOrAuthority(m){return(0,e.$Pg)(m)||m.authority}basename(m){return P.$gc.basename(m.path)}extname(m){return P.$gc.extname(m.path)}dirname(m){if(m.path.length===0)return m;let w;return m.scheme===R.Schemas.file?w=S.URI.file(P.$mc(d(m))).path:(w=P.$gc.dirname(m.path),m.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${m.toString})) resulted in a relative path`),w="/")),m.with({path:w})}normalizePath(m){if(!m.path.length)return m;let w;return m.scheme===R.Schemas.file?w=S.URI.file(P.$hc(d(m))).path:w=P.$gc.normalize(m.path),m.with({path:w})}relativePath(m,w){if(m.scheme!==w.scheme||!(0,e.$Xg)(m.authority,w.authority))return;if(m.scheme===R.Schemas.file){const f=P.$lc(d(m),d(w));return O.$i?n.$_f(f):f}let p=m.path||"/";const u=w.path||"/";if(this.a(m)){let f=0;for(const h=Math.min(p.length,u.length);f<h&&!(p.charCodeAt(f)!==u.charCodeAt(f)&&p.charAt(f).toLowerCase()!==u.charAt(f).toLowerCase());f++);p=u.substr(0,f)+p.substr(f)}return P.$gc.relative(p,u)}resolvePath(m,w){if(m.scheme===R.Schemas.file){const p=S.URI.file(P.$kc(d(m),w));return m.with({authority:p.authority,path:p.path})}return w=n.$ag(w),m.with({path:P.$gc.resolve(m.path,w)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,w){return m===w||m!==void 0&&w!==void 0&&(0,C.$jf)(m,w)}hasTrailingPathSeparator(m,w=P.sep){if(m.scheme===R.Schemas.file){const p=d(m);return p.length>n.$bg(p).length&&p[p.length-1]===w}else{const p=m.path;return p.length>1&&p.charCodeAt(p.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,w=P.sep){return(0,e.$Yg)(m,w)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,w=P.sep){let p=!1;if(m.scheme===R.Schemas.file){const u=d(m);p=u!==void 0&&u.length===n.$bg(u).length&&u[u.length-1]===w}else{w="/";const u=m.path;p=u.length===1&&u.charCodeAt(u.length-1)===47}return!p&&!(0,e.$Yg)(m,w)?m.with({path:m.path+"/"}):m}}e.$Hg=c,e.$Ig=new c(()=>!1),e.$Jg=new c($=>$.scheme===R.Schemas.file?!O.$k:!0),e.$Kg=new c($=>!0),e.$Lg=e.$Ig.isEqual.bind(e.$Ig),e.$Mg=e.$Ig.isEqualOrParent.bind(e.$Ig),e.$Ng=e.$Ig.getComparisonKey.bind(e.$Ig),e.$Og=e.$Ig.basenameOrAuthority.bind(e.$Ig),e.$Pg=e.$Ig.basename.bind(e.$Ig),e.$Qg=e.$Ig.extname.bind(e.$Ig),e.$Rg=e.$Ig.dirname.bind(e.$Ig),e.$Sg=e.$Ig.joinPath.bind(e.$Ig),e.$Tg=e.$Ig.normalizePath.bind(e.$Ig),e.$Ug=e.$Ig.relativePath.bind(e.$Ig),e.$Vg=e.$Ig.resolvePath.bind(e.$Ig),e.$Wg=e.$Ig.isAbsolutePath.bind(e.$Ig),e.$Xg=e.$Ig.isEqualAuthority.bind(e.$Ig),e.$Yg=e.$Ig.hasTrailingPathSeparator.bind(e.$Ig),e.$Zg=e.$Ig.removeTrailingPathSeparator.bind(e.$Ig),e.$1g=e.$Ig.addTrailingPathSeparator.bind(e.$Ig);function y($,m){const w=[];for(let p=0;p<$.length;p++){const u=m($[p]);$.some((f,h)=>h===p?!1:(0,e.$Mg)(u,m(f)))||w.push($[p])}return w}e.$2g=y;var v;(function($){$.META_DATA_LABEL="label",$.META_DATA_DESCRIPTION="description",$.META_DATA_SIZE="size",$.META_DATA_MIME="mime";function m(w){const p=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(h=>{const[g,a]=h.split(":");g&&a&&p.set(g,a)});const f=w.path.substring(0,w.path.indexOf(";"));return f&&p.set($.META_DATA_MIME,f),p}$.parseMetaData=m})(v||(e.DataUri=v={}));function k($,m,w){if(m){let p=$.path;return p&&p[0]!==P.$gc.sep&&(p=P.$gc.sep+p),$.with({scheme:w,authority:m,path:p})}return $.with({scheme:w})}e.$3g=k}),define(ae[8],ce([0,1,23,15,3,2,19,4,144,61]),function(X,e,n,R,P,O,C,S,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.Promises=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=void 0;function y(_){return!!_&&typeof _.then=="function"}e.$4g=y;function v(_){const B=new n.$ce,ee=_(B.token),ie=new Promise((de,me)=>{const Ee=B.token.onCancellationRequested(()=>{Ee.dispose(),me(new R.$5)});Promise.resolve(ee).then(Pe=>{Ee.dispose(),B.dispose(),de(Pe)},Pe=>{Ee.dispose(),B.dispose(),me(Pe)})});return new class{cancel(){B.cancel(),B.dispose()}then(de,me){return ie.then(de,me)}catch(de){return this.then(void 0,de)}finally(de){return ie.finally(de)}}}e.$5g=v;function k(_,B,ee){return new Promise((ie,de)=>{const me=B.onCancellationRequested(()=>{me.dispose(),ie(ee)});_.then(ie,de).finally(()=>me.dispose())})}e.$6g=k;function $(_,B){return new Promise((ee,ie)=>{const de=B.onCancellationRequested(()=>{de.dispose(),ie(new R.$5)});_.then(ee,ie).finally(()=>de.dispose())})}e.$7g=$;async function m(_){let B=-1;const ee=_.map((ie,de)=>ie.then(me=>(B=de,me)));try{return await Promise.race(ee)}finally{_.forEach((ie,de)=>{de!==B&&ie.cancel()})}}e.$8g=m;function w(_,B,ee){let ie;const de=setTimeout(()=>{ie?.(void 0),ee?.()},B);return Promise.race([_.finally(()=>clearTimeout(de)),new Promise(me=>ie=me)])}e.$9g=w;function p(_){return new Promise((B,ee)=>{const ie=_();y(ie)?ie.then(B,ee):B(ie)})}e.$0g=p;function u(){let _,B;return{promise:new Promise((ie,de)=>{_=ie,B=de}),resolve:_,reject:B}}e.$$g=u;class f{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(B){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=B,!this.b){const ee=()=>{if(this.b=null,this.f)return;const ie=this.queue(this.d);return this.d=null,ie};this.b=new Promise(ie=>{this.a.then(ee,ee).then(ie)})}return new Promise((ee,ie)=>{this.b.then(ee,ie)})}return this.a=B(),new Promise((ee,ie)=>{this.a.then(de=>{this.a=null,ee(de)},de=>{this.a=null,ie(de)})})}dispose(){this.f=!0}}e.$_g=f;class h{constructor(){this.a=Promise.resolve(null)}queue(B){return this.a=this.a.then(()=>B(),()=>B())}}e.$ah=h;class g{constructor(){this.a=new Map}queue(B,ee){const de=(this.a.get(B)??Promise.resolve()).catch(()=>{}).then(ee).finally(()=>{this.a.get(B)===de&&this.a.delete(B)});return this.a.set(B,de),de}}e.$bh=g;const a=(_,B)=>{let ee=!0;const ie=setTimeout(()=>{ee=!1,B()},_);return{isTriggered:()=>ee,dispose:()=>{clearTimeout(ie),ee=!1}}},t=_=>{let B=!0;return queueMicrotask(()=>{B&&(B=!1,_())}),{isTriggered:()=>B,dispose:()=>{B=!1}}};class o{constructor(B){this.defaultDelay=B,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(B,ee=this.defaultDelay){this.g=B,this.h(),this.b||(this.b=new Promise((de,me)=>{this.d=de,this.f=me}).then(()=>{if(this.b=null,this.d=null,this.g){const de=this.g;return this.g=null,de()}}));const ie=()=>{this.a=null,this.d?.(null)};return this.a=ee===d.$2d?t(ie):a(ee,ie),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new R.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$ch=o;class r{constructor(B){this.a=new o(B),this.b=new f}trigger(B,ee){return this.a.trigger(()=>this.b.queue(B),ee)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$dh=r;class i{constructor(){this.a=!1,this.b=new Promise((B,ee)=>{this.d=B})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$eh=i;class s extends i{constructor(B){super(),this.f=setTimeout(()=>this.open(),B)}open(){clearTimeout(this.f),super.open()}}e.$fh=s;function l(_,B){return B?new Promise((ee,ie)=>{const de=setTimeout(()=>{me.dispose(),ee()},_),me=B.onCancellationRequested(()=>{clearTimeout(de),me.dispose(),ie(new R.$5)})}):v(ee=>l(_,ee))}e.$gh=l;function b(_,B=0,ee){const ie=setTimeout(()=>{_(),ee&&de.dispose()},B),de=(0,O.$Rc)(()=>{clearTimeout(ie),ee?.deleteAndLeak(de)});return ee?.add(de),de}e.$hh=b;function D(_){const B=[];let ee=0;const ie=_.length;function de(){return ee<ie?_[ee++]():null}function me(Ee){Ee!=null&&B.push(Ee);const Pe=de();return Pe?Pe.then(me):Promise.resolve(B)}return Promise.resolve(null).then(me)}e.$ih=D;function j(_,B=ie=>!!ie,ee=null){let ie=0;const de=_.length,me=()=>{if(ie>=de)return Promise.resolve(ee);const Ee=_[ie++];return Promise.resolve(Ee()).then(Le=>B(Le)?Promise.resolve(Le):me())};return me()}e.$jh=j;function E(_,B=ie=>!!ie,ee=null){if(_.length===0)return Promise.resolve(ee);let ie=_.length;const de=()=>{ie=-1;for(const me of _)me.cancel?.()};return new Promise((me,Ee)=>{for(const Pe of _)Pe.then(Le=>{--ie>=0&&B(Le)?(de(),me(Le)):ie===0&&me(ee)}).catch(Le=>{--ie>=0&&(de(),Ee(Le))})})}e.$kh=E;class I{constructor(B){this.a=0,this.b=!1,this.f=B,this.g=[],this.d=0,this.h=new P.$5d}whenIdle(){return this.size>0?P.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(B){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((ee,ie)=>{this.g.push({factory:B,c:ee,e:ie}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const B=this.g.shift();this.d++;const ee=B.factory();ee.then(B.c,B.e),ee.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$lh=I;class M extends I{constructor(){super(1)}}e.$mh=M;class T{constructor(){this.a=new N,this.b=0}queue(B){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,B())):this.a.run(this.b++,B())}}e.$nh=T;class W{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const B=new oe;return this.b.add(B),B.p}g(){for(const[,B]of this.a)if(B.size>0)return!1;return!0}queueSize(B,ee=C.$Ig){const ie=ee.getComparisonKey(B);return this.a.get(ie)?.size??0}queueFor(B,ee,ie=C.$Ig){const de=ie.getComparisonKey(B);let me=this.a.get(de);if(!me){me=new M;const Ee=this.f++,Pe=P.Event.once(me.onDrained)(()=>{me?.dispose(),this.a.delete(de),this.h(),this.d?.deleteAndDispose(Ee),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new O.$3c),this.d.set(Ee,Pe),this.a.set(de,me)}return me.queue(ee)}h(){this.g()&&this.j()}j(){for(const B of this.b)B.complete();this.b.clear()}dispose(){for(const[,B]of this.a)B.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$oh=W;class V{constructor(B,ee){this.a=-1,typeof B=="function"&&typeof ee=="number"&&this.setIfNotSet(B,ee)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(B,ee){this.cancel(),this.a=setTimeout(()=>{this.a=-1,B()},ee)}setIfNotSet(B,ee){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,B()},ee))}}e.$ph=V;class J{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(B,ee,ie=globalThis){this.cancel();const de=ie.setInterval(()=>{B()},ee);this.d=(0,O.$Rc)(()=>{ie.clearInterval(de),this.d=void 0})}dispose(){this.cancel()}}e.$qh=J;class le{constructor(B,ee){this.b=-1,this.a=B,this.d=ee,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(B=this.d){this.cancel(),this.b=setTimeout(this.f,B)}get delay(){return this.d}set delay(B){this.d=B}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$rh=le;class re{constructor(B,ee){ee%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ee}ms is not a multiple of 1000ms.`),this.a=B,this.b=ee,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(B=this.b){B%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${B}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(B/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$sh=re;class ue extends le{constructor(B,ee){super(B,ee),this.j=[]}work(B){this.j.push(B),this.isScheduled()||this.schedule()}h(){const B=this.j;this.j=[],this.a?.(B)}dispose(){this.j=[],super.dispose()}}e.$th=ue;class Q extends O.$Tc{constructor(B,ee){super(),this.g=B,this.h=ee,this.a=[],this.b=this.B(new O.$Uc),this.f=!1}get pending(){return this.a.length}work(B){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+B.length>this.g.maxBufferedWork)return!1}else if(this.pending+B.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ee of B)this.a.push(ee);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new le(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$uh=Q,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$wh=(_,B)=>{(0,S.$B)(()=>{if(ee)return;const ie=Date.now()+15;B(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ie-Date.now())}}))});let ee=!1;return{dispose(){ee||(ee=!0)}}}:e.$wh=(_,B,ee)=>{const ie=_.requestIdleCallback(B,typeof ee=="number"?{timeout:ee}:void 0);let de=!1;return{dispose(){de||(de=!0,_.cancelIdleCallback(ie))}}},e.$vh=_=>(0,e.$wh)(globalThis,_)}();class Y{constructor(B,ee){this.g=!1,this.d=()=>{try{this.j=ee()}catch(ie){this.l=ie}finally{this.g=!0}},this.f=(0,e.$wh)(B,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$xh=Y;class U extends Y{constructor(B){super(globalThis,B)}}e.$yh=U;async function L(_,B,ee){let ie;for(let de=0;de<ee;de++)try{return await _()}catch(me){ie=me,await l(B)}throw ie}e.$zh=L;class N{isRunning(B){return typeof B=="number"?this.a?.taskId===B:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(B,ee,ie){return this.a={taskId:B,cancel:()=>ie?.(),promise:ee},ee.then(()=>this.d(B),()=>this.d(B)),ee}d(B){this.a&&B===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const B=this.b;this.b=void 0,B.run().then(B.promiseResolve,B.promiseReject)}}queue(B){if(this.b)this.b.run=B;else{const{promise:ee,resolve:ie,reject:de}=u();this.b={run:B,promise:ee,promiseResolve:ie,promiseReject:de}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Ah=N;class G{constructor(B,ee=()=>Date.now()){this.d=B,this.f=ee,this.a=0,this.b=0}increment(){const B=this.f();return B-this.a>this.d&&(this.a=B,this.b=0),this.b++,this.b}}e.$Bh=G;var q;(function(_){_[_.Resolved=0]="Resolved",_[_.Rejected=1]="Rejected"})(q||(q={}));class oe{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((B,ee)=>{this.a=B,this.b=ee})}complete(B){return new Promise(ee=>{this.a(B),this.d={outcome:0,value:B},ee()})}error(B){return new Promise(ee=>{this.b(B),this.d={outcome:1,value:B},ee()})}cancel(){return this.error(new R.$5)}}e.$Ch=oe;var he;(function(_){async function B(ie){let de;const me=await Promise.all(ie.map(Ee=>Ee.then(Pe=>Pe,Pe=>{de||(de=Pe)})));if(typeof de<"u")throw de;return me}_.settled=B;function ee(ie){return new Promise(async(de,me)=>{try{await ie(de,me)}catch(Ee){me(Ee)}})}_.withAsyncBody=ee})(he||(e.Promises=he={}));class K{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(B){this.a=void 0,this.b=void 0,this.d=!1,this.promise=B.then(ee=>(this.a=ee,this.d=!0,ee),ee=>{throw this.b=ee,this.d=!0,ee})}requireValue(){if(!this.d)throw new R.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Dh=K;class A{constructor(B){this.b=B,this.a=new c.$V(()=>new K(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Eh=A;var F;(function(_){_[_.Initial=0]="Initial",_[_.DoneOK=1]="DoneOK",_[_.DoneError=2]="DoneError"})(F||(F={}));class x{static fromArray(B){return new x(ee=>{ee.emitMany(B)})}static fromPromise(B){return new x(async ee=>{ee.emitMany(await B)})}static fromPromises(B){return new x(async ee=>{await Promise.all(B.map(async ie=>ee.emitOne(await ie)))})}static merge(B){return new x(async ee=>{await Promise.all(B.map(async ie=>{for await(const de of ie)ee.emitOne(de)}))})}static{this.EMPTY=x.fromArray([])}constructor(B){this.a=0,this.b=[],this.d=null,this.f=new P.$5d,queueMicrotask(async()=>{const ee={emitOne:ie=>this.g(ie),emitMany:ie=>this.h(ie),reject:ie=>this.k(ie)};try{await Promise.resolve(B(ee)),this.j()}catch(ie){this.k(ie)}finally{ee.emitOne=void 0,ee.emitMany=void 0,ee.reject=void 0}})}[Symbol.asyncIterator](){let B=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(B<this.b.length)return{done:!1,value:this.b[B++]};if(this.a===1)return{done:!0,value:void 0};await P.Event.toPromise(this.f.event)}while(!0)}}}static map(B,ee){return new x(async ie=>{for await(const de of B)ie.emitOne(ee(de))})}map(B){return x.map(this,B)}static filter(B,ee){return new x(async ie=>{for await(const de of B)ee(de)&&ie.emitOne(de)})}filter(B){return x.filter(this,B)}static coalesce(B){return x.filter(B,ee=>!!ee)}coalesce(){return x.coalesce(this)}static async toPromise(B){const ee=[];for await(const ie of B)ee.push(ie);return ee}toPromise(){return x.toPromise(this)}g(B){this.a===0&&(this.b.push(B),this.f.fire())}h(B){this.a===0&&(this.b=this.b.concat(B),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(B){this.a===0&&(this.a=2,this.d=B,this.f.fire())}}e.$Fh=x;class z extends x{constructor(B,ee){super(ee),this.l=B}cancel(){this.l.cancel()}}e.$Gh=z;function Z(_){const B=new n.$ce,ee=_(B.token);return new z(B,async ie=>{const de=B.token.onCancellationRequested(()=>{de.dispose(),B.dispose(),ie.reject(new R.$5)});try{for await(const me of ee){if(B.token.isCancellationRequested)return;ie.emitOne(me)}de.dispose(),B.dispose()}catch(me){de.dispose(),B.dispose(),ie.reject(me)}})}e.$Hh=Z;class H{constructor(){this.a=new oe,this.b=new x(ie=>{if(B){ie.reject(B);return}return ee&&ie.emitMany(ee),this.d=de=>ie.reject(de),this.f=de=>ie.emitOne(de),this.a.p});let B,ee;this.f=ie=>{ee||(ee=[]),ee.push(ie)},this.d=ie=>{B||(B=ie)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(B){this.d(B),this.a.complete()}emitOne(B){this.f(B)}}e.$Ih=H}),define(ae[107],ce([0,1,22,8,33,31,9,4,25]),function(X,e,n,R,P,O,C,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=void 0;function c(){return Object.create(null)}e.$Tj=c,e.$Uj="**",e.$Vj="/";const y="[/\\\\]",v="[^/\\\\]",k=/\//g;function $(Y,U){switch(Y){case 0:return"";case 1:return`${v}*?`;default:return`(?:${y}|${v}+${y}${U?`|${y}${v}+`:""})*?`}}function m(Y,U){if(!Y)return[];const L=[];let N=!1,G=!1,q="";for(const oe of Y){switch(oe){case U:if(!N&&!G){L.push(q),q="";continue}break;case"{":N=!0;break;case"}":N=!1;break;case"[":G=!0;break;case"]":G=!1;break}q+=oe}return q&&L.push(q),L}e.$Wj=m;function w(Y){if(!Y)return"";let U="";const L=m(Y,e.$Vj);if(L.every(N=>N===e.$Uj))U=".*";else{let N=!1;L.forEach((G,q)=>{if(G===e.$Uj){if(N)return;U+=$(2,q===L.length-1)}else{let oe=!1,he="",K=!1,A="";for(const F of G){if(F!=="}"&&oe){he+=F;continue}if(K&&(F!=="]"||!A)){let x;F==="-"?x=F:(F==="^"||F==="!")&&!A?x="^":F===e.$Vj?x="":x=(0,d.$Xe)(F),A+=x;continue}switch(F){case"{":oe=!0;continue;case"[":K=!0;continue;case"}":{const z=`(?:${m(he,",").map(Z=>w(Z)).join("|")})`;U+=z,oe=!1,he="";break}case"]":{U+="["+A+"]",K=!1,A="";break}case"?":U+=v;continue;case"*":U+=$(1);continue;default:U+=(0,d.$Xe)(F)}}q<L.length-1&&(L[q+1]!==e.$Uj||q+2<L.length)&&(U+=y)}N=G===e.$Uj})}return U}const p=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,f=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,h=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,g=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new O.$Dc(1e4),o=function(){return!1},r=function(){return null};function i(Y,U){if(!Y)return r;let L;typeof Y!="string"?L=Y.pattern:L=Y,L=L.trim();const N=`${L}_${!!U.trimForExclusions}`;let G=t.get(N);if(G)return s(G,Y);let q;return p.test(L)?G=b(L.substr(4),L):(q=u.exec(l(L,U)))?G=D(q[1],L):(U.trimForExclusions?h:f).test(L)?G=j(L,U):(q=g.exec(l(L,U)))?G=E(q[1].substr(1),L,!0):(q=a.exec(l(L,U)))?G=E(q[1],L,!1):G=I(L),t.set(N,G),s(G,Y)}function s(Y,U){if(typeof U=="string")return Y;const L=function(N,G){return(0,P.$fg)(N,U.base,!S.$k)?Y((0,d.$3e)(N.substr(U.base.length),C.sep),G):null};return L.allBasenames=Y.allBasenames,L.allPaths=Y.allPaths,L.basenames=Y.basenames,L.patterns=Y.patterns,L}function l(Y,U){return U.trimForExclusions&&Y.endsWith("/**")?Y.substr(0,Y.length-2):Y}function b(Y,U){return function(L,N){return typeof L=="string"&&L.endsWith(Y)?U:null}}function D(Y,U){const L=`/${Y}`,N=`\\${Y}`,G=function(oe,he){return typeof oe!="string"?null:he?he===Y?U:null:oe===Y||oe.endsWith(L)||oe.endsWith(N)?U:null},q=[Y];return G.basenames=q,G.patterns=[U],G.allBasenames=q,G}function j(Y,U){const L=ue(Y.slice(1,-1).split(",").map(he=>i(he,U)).filter(he=>he!==r),Y),N=L.length;if(!N)return r;if(N===1)return L[0];const G=function(he,K){for(let A=0,F=L.length;A<F;A++)if(L[A](he,K))return Y;return null},q=L.find(he=>!!he.allBasenames);q&&(G.allBasenames=q.allBasenames);const oe=L.reduce((he,K)=>K.allPaths?he.concat(K.allPaths):he,[]);return oe.length&&(G.allPaths=oe),G}function E(Y,U,L){const N=C.sep===C.$gc.sep,G=N?Y:Y.replace(k,C.sep),q=C.sep+G,oe=C.$gc.sep+Y;let he;return L?he=function(K,A){return typeof K=="string"&&(K===G||K.endsWith(q)||!N&&(K===Y||K.endsWith(oe)))?U:null}:he=function(K,A){return typeof K=="string"&&(K===G||!N&&K===Y)?U:null},he.allPaths=[(L?"*/":"./")+Y],he}function I(Y){try{const U=new RegExp(`^${w(Y)}$`);return function(L){return U.lastIndex=0,typeof L=="string"&&U.test(L)?Y:null}}catch{return r}}function M(Y,U,L){return!Y||typeof U!="string"?!1:T(Y)(U,void 0,L)}e.$Xj=M;function T(Y,U={}){if(!Y)return o;if(typeof Y=="string"||W(Y)){const L=i(Y,U);if(L===r)return o;const N=function(G,q){return!!L(G,q)};return L.allBasenames&&(N.allBasenames=L.allBasenames),L.allPaths&&(N.allPaths=L.allPaths),N}return le(Y,U)}e.$Yj=T;function W(Y){const U=Y;return U?typeof U.base=="string"&&typeof U.pattern=="string":!1}e.$Zj=W;function V(Y){return Y.allBasenames||[]}e.$1j=V;function J(Y){return Y.allPaths||[]}e.$2j=J;function le(Y,U){const L=ue(Object.getOwnPropertyNames(Y).map(he=>re(he,Y[he],U)).filter(he=>he!==r)),N=L.length;if(!N)return r;if(!L.some(he=>!!he.requiresSiblings)){if(N===1)return L[0];const he=function(F,x){let z;for(let Z=0,H=L.length;Z<H;Z++){const _=L[Z](F,x);if(typeof _=="string")return _;(0,R.$4g)(_)&&(z||(z=[]),z.push(_))}return z?(async()=>{for(const Z of z){const H=await Z;if(typeof H=="string")return H}return null})():null},K=L.find(F=>!!F.allBasenames);K&&(he.allBasenames=K.allBasenames);const A=L.reduce((F,x)=>x.allPaths?F.concat(x.allPaths):F,[]);return A.length&&(he.allPaths=A),he}const G=function(he,K,A){let F,x;for(let z=0,Z=L.length;z<Z;z++){const H=L[z];H.requiresSiblings&&A&&(K||(K=(0,C.$nc)(he)),F||(F=K.substr(0,K.length-(0,C.$oc)(he).length)));const _=H(he,K,F,A);if(typeof _=="string")return _;(0,R.$4g)(_)&&(x||(x=[]),x.push(_))}return x?(async()=>{for(const z of x){const Z=await z;if(typeof Z=="string")return Z}return null})():null},q=L.find(he=>!!he.allBasenames);q&&(G.allBasenames=q.allBasenames);const oe=L.reduce((he,K)=>K.allPaths?he.concat(K.allPaths):he,[]);return oe.length&&(G.allPaths=oe),G}function re(Y,U,L){if(U===!1)return r;const N=i(Y,L);if(N===r)return r;if(typeof U=="boolean")return N;if(U){const G=U.when;if(typeof G=="string"){const q=(oe,he,K,A)=>{if(!A||!N(oe,he))return null;const F=G.replace("$(basename)",()=>K),x=A(F);return(0,R.$4g)(x)?x.then(z=>z?Y:null):x?Y:null};return q.requiresSiblings=!0,q}}return N}function ue(Y,U){const L=Y.filter(he=>!!he.basenames);if(L.length<2)return Y;const N=L.reduce((he,K)=>{const A=K.basenames;return A?he.concat(A):he},[]);let G;if(U){G=[];for(let he=0,K=N.length;he<K;he++)G.push(U)}else G=L.reduce((he,K)=>{const A=K.patterns;return A?he.concat(A):he},[]);const q=function(he,K){if(typeof he!="string")return null;if(!K){let F;for(F=he.length;F>0;F--){const x=he.charCodeAt(F-1);if(x===47||x===92)break}K=he.substr(F)}const A=N.indexOf(K);return A!==-1?G[A]:null};q.basenames=N,q.patterns=G,q.allBasenames=N;const oe=Y.filter(he=>!he.basenames);return oe.push(q),oe}function Q(Y,U){return(0,n.$ub)(Y,U,(L,N)=>typeof L=="string"&&typeof N=="string"?L===N:typeof L!="string"&&typeof N!="string"?L.base===N.base&&L.pattern===N.pattern:!1)}e.$3j=Q}),define(ae[47],ce([0,1,22,33,9,4,19,25]),function(X,e,n,R,P,O,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hw=e.$gw=e.$fw=e.$ew=e.$dw=e.$cw=e.$bw=e.$aw=e.$_v=e.$$v=void 0;function d(i,s){const{os:l,tildify:b,relative:D}=s;if(D){const I=c(i,D,l);if(typeof I=="string")return I}let j=i.fsPath;if(l===1&&!O.$i?j=j.replace(/\//g,"\\"):l!==1&&O.$i&&(j=j.replace(/\\/g,"/")),l!==1&&b?.userHome){const I=b.userHome.fsPath;let M;i.scheme!==b.userHome.scheme&&i.path[0]===P.$gc.sep&&i.path[1]!==P.$gc.sep?M=b.userHome.with({path:i.path}).fsPath:M=j,j=k(M,I,l)}return(l===1?P.$fc:P.$gc).normalize(y(j,l===1))}e.$$v=d;function c(i,s,l){const b=l===1?P.$fc:P.$gc,D=l===3?C.$Ig:C.$Kg,j=s.getWorkspace(),E=(0,n.$Ob)(j.folders);if(!E)return;i.scheme!==E.uri.scheme&&i.path[0]===P.$gc.sep&&i.path[1]!==P.$gc.sep&&(i=E.uri.with({path:i.path}));const I=s.getWorkspaceFolder(i);if(!I)return;let M;if(D.isEqual(I.uri,i)?M="":M=D.relativePath(I.uri,i)??"",M&&(M=b.normalize(M)),j.folders.length>1&&!s.noPrefix){const T=I.name?I.name:D.basenameOrAuthority(I.uri);M=M?`${T} \u2022 ${M}`:T}return M}function y(i,s=O.$i){return(0,R.$jg)(i,s)?i.charAt(0).toUpperCase()+i.slice(1):i}e.$_v=y;let v=Object.create(null);function k(i,s,l=O.OS){if(l===1||!i||!s)return i;let b=v.original===s?v.normalized:void 0;b||(b=s,O.$i&&(b=(0,R.$_f)(b)),b=`${(0,S.$4e)(b,P.$gc.sep)}${P.$gc.sep}`,v={original:s,normalized:b});let D=i;return O.$i&&(D=(0,R.$_f)(D)),(l===3?D.startsWith(b):(0,S.$kf)(D,b))?`~/${D.substr(b.length)}`:i}e.$aw=k;function $(i,s){return i.replace(/^~($|\/|\\)/,`${s}$1`)}e.$bw=$;const m="\u2026",w="\\\\",p="~";function u(i,s=P.sep){const l=new Array(i.length);let b=!1;for(let D=0;D<i.length;D++){const j=i[D];if(j===""){l[D]=`.${s}`;continue}if(!j){l[D]=j;continue}b=!0;let E="",I=j;I.indexOf(w)===0?(E=I.substr(0,I.indexOf(w)+w.length),I=I.substr(I.indexOf(w)+w.length)):I.indexOf(s)===0?(E=I.substr(0,I.indexOf(s)+s.length),I=I.substr(I.indexOf(s)+s.length)):I.indexOf(p)===0&&(E=I.substr(0,I.indexOf(p)+p.length),I=I.substr(I.indexOf(p)+p.length));const M=I.split(s);for(let T=1;b&&T<=M.length;T++)for(let W=M.length-T;b&&W>=0;W--){b=!1;let V=M.slice(W,W+T).join(s);for(let J=0;!b&&J<i.length;J++)if(J!==D&&i[J]&&i[J].indexOf(V)>-1){const le=W+T===M.length,re=W>0&&i[J].indexOf(s)>-1?s+V:V,ue=i[J].endsWith(re);b=!le||ue}if(!b){let J="";(M[0].endsWith(":")||E!=="")&&(W===1&&(W=0,T++,V=M[0]+s+V),W>0&&(J=M[0]+s),J=E+J),W>0&&(J=J+m+s),J=J+V,W+T<M.length&&(J=J+s+m),l[D]=J}}b&&(l[D]=j)}return l}e.$cw=u;var f;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(f||(f={}));function h(i,s=Object.create(null)){const l=[];let b=!1,D="";for(const j of i)if(j==="$"||b&&j==="{")D&&l.push({value:D,type:f.TEXT}),D="",b=!0;else if(j==="}"&&b){const E=s[D];if(typeof E=="string")E.length&&l.push({value:E,type:f.VARIABLE});else if(E){const I=l[l.length-1];(!I||I.type!==f.SEPARATOR)&&l.push({value:E.label,type:f.SEPARATOR})}D="",b=!1}else D+=j;return D&&!b&&l.push({value:D,type:f.TEXT}),l.filter((j,E)=>{if(j.type===f.SEPARATOR){const I=l[E-1],M=l[E+1];return[I,M].every(T=>T&&(T.type===f.VARIABLE||T.type===f.TEXT)&&T.value.length>0)}return!0}).map(j=>j.value).join("")}e.$dw=h;function g(i,s){return O.$j||s?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,O.$j?"&":"&&"):i.replace(/&&|&/g,l=>l==="&"?"&&":"&")}e.$ew=g;function a(i,s){return O.$j||s?i.replace(/\(&&\w\)|&&/g,""):O.$i?i.replace(/&&|&/g,l=>l==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.$fw=a;function t(i){return i.replace(/&/g,"&&")}e.$gw=t;function o(i){if(i.endsWith("]")){const s=i.lastIndexOf(" [",i.length-2);if(s!==-1){const l=r(i.substring(0,s)),b=i.substring(s);return{name:l.name+b,parentPath:l.parentPath}}}return r(i)}e.$hw=o;function r(i){const s=i.indexOf("/")!==-1?P.$gc:P.$fc,l=s.basename(i),b=s.dirname(i);return l.length?{name:l,parentPath:b}:{name:b,parentPath:""}}}),define(ae[157],ce([0,1,17,7]),function(X,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kn=e.$jn=e.$in=e.$hn=e.$gn=void 0;function P(v){return v.toJSON()}class O{constructor(k){this.a=k}transformIncoming(k){const $=this.a.transformIncoming(k);return $===k?k:P(R.URI.from($))}transformOutgoing(k){const $=this.a.transformOutgoing(k);return $===k?k:P(R.URI.from($))}transformOutgoingURI(k){const $=this.a.transformOutgoing(k);return $===k?k:R.URI.from($)}transformOutgoingScheme(k){return this.a.transformOutgoingScheme(k)}}e.$gn=O,e.$hn=new class{transformIncoming(v){return v}transformOutgoing(v){return v}transformOutgoingURI(v){return v}transformOutgoingScheme(v){return v}};function C(v,k,$){if(!v||$>200)return null;if(typeof v=="object"){if(v instanceof R.URI)return k.transformOutgoing(v);for(const m in v)if(Object.hasOwnProperty.call(v,m)){const w=C(v[m],k,$+1);w!==null&&(v[m]=w)}}return null}function S(v,k){const $=C(v,k,0);return $===null?v:$}e.$in=S;function d(v,k,$,m){if(!v||m>200)return null;if(typeof v=="object"){if(v.$mid===1)return $?R.URI.revive(k.transformIncoming(v)):k.transformIncoming(v);if(v instanceof n.$se)return null;for(const w in v)if(Object.hasOwnProperty.call(v,w)){const p=d(v[w],k,$,m+1);p!==null&&(v[w]=p)}}return null}function c(v,k){const $=d(v,k,!1,0);return $===null?v:$}e.$jn=c;function y(v,k){const $=d(v,k,!0,0);return $===null?v:$}e.$kn=y}),define(ae[89],ce([0,1,26,59,32,147,4]),function(X,e,n,R,P,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$on=e.$nn=e.$mn=void 0,e.$mn=new class{c(k){return this.a||(this.a=R.$li.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(k)}value(){if(this.b===void 0){let k=0,$=0;const m=(0,n.networkInterfaces)();for(const w in m){const p=m[w];if(p)for(const{mac:u,internal:f}of p)f||($+=1,this.c(u.toUpperCase())&&(k+=1))}this.b=$>0?k/$:0}return this.b}};let S;async function d(k){return S||(S=(async()=>await c(k)||P.$Bg())()),S}e.$nn=d;async function c(k){try{const $=await new Promise((w,p)=>{X(["crypto"],w,p)}),m=(0,O.$ln)();return $.createHash("sha256").update(m,"utf8").digest("hex")}catch($){k($);return}}const y="Software\\Microsoft\\SQMClient";async function v(k){if(C.$i){const $=await new Promise((m,w)=>{X(["@vscode/windows-registry"],m,w)});try{return $.GetStringRegKey("HKEY_LOCAL_MACHINE",y,"MachineId")||""}catch(m){return k(m),""}}return""}e.$on=v}),define(ae[21],ce([0,1,46,26,158,8,33,86,9,4,19,7]),function(X,e,n,R,P,O,C,S,d,c,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var k;(function(re){re[re.UNLINK=0]="UNLINK",re[re.MOVE=1]="MOVE"})(k||(e.RimRafMode=k={}));async function $(re,ue=k.UNLINK,Q){if((0,C.$ig)(re))throw new Error("rimraf - will refuse to recursively delete root");return ue===k.UNLINK?w(re):m(re,Q)}async function m(re,ue=(0,C.$ng)((0,R.tmpdir)())){try{try{await n.promises.rename(re,ue)}catch(Q){return Q.code==="ENOENT"?void 0:w(re)}w(ue).catch(Q=>{})}catch(Q){if(Q.code!=="ENOENT")throw Q}}async function w(re){return(0,P.promisify)(n.rm)(re,{recursive:!0,force:!0,maxRetries:3})}function p(re){if((0,C.$ig)(re))throw new Error("rimraf - will refuse to recursively delete root");n.rmSync(re,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=p;async function u(re,ue){return g(await(ue?f(re):(0,P.promisify)(n.readdir)(re)))}async function f(re){try{return await(0,P.promisify)(n.readdir)(re,{withFileTypes:!0})}catch(Y){console.warn("[node.js fs] readdir with filetypes failed with error: ",Y)}const ue=[],Q=await u(re);for(const Y of Q){let U=!1,L=!1,N=!1;try{const G=await e.Promises.lstat((0,d.$jc)(re,Y));U=G.isFile(),L=G.isDirectory(),N=G.isSymbolicLink()}catch(G){console.warn("[node.js fs] unexpected error from lstat after readdir: ",G)}ue.push({name:Y,isFile:()=>U,isDirectory:()=>L,isSymbolicLink:()=>N})}return ue}function h(re){return g(n.readdirSync(re))}e.readdirSync=h;function g(re){return re.map(ue=>typeof ue=="string"?c.$j?(0,S.$Ql)(ue):ue:(ue.name=c.$j?(0,S.$Ql)(ue.name):ue.name,ue))}async function a(re){const ue=await u(re),Q=[];for(const Y of ue)await o.existsDirectory((0,d.$jc)(re,Y))&&Q.push(Y);return Q}function t(re,ue=1e3){return new Promise(Q=>{let Y=!1;const U=setInterval(()=>{Y||(Y=!0,n.access(re,L=>{Y=!1,L&&(clearInterval(U),Q(void 0))}))},ue)})}e.whenDeleted=t;var o;(function(re){async function ue(U){let L;try{if(L=await e.Promises.lstat(U),!L.isSymbolicLink())return{stat:L}}catch{}try{return{stat:await e.Promises.stat(U),symbolicLink:L?.isSymbolicLink()?{dangling:!1}:void 0}}catch(N){if(N.code==="ENOENT"&&L)return{stat:L,symbolicLink:{dangling:!0}};if(c.$i&&N.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(U)),symbolicLink:{dangling:!1}}}catch(G){if(G.code==="ENOENT"&&L)return{stat:L,symbolicLink:{dangling:!0}};throw G}throw N}}re.stat=ue;async function Q(U){try{const{stat:L,symbolicLink:N}=await re.stat(U);return L.isFile()&&N?.dangling!==!0}catch{}return!1}re.existsFile=Q;async function Y(U){try{const{stat:L,symbolicLink:N}=await re.stat(U);return L.isDirectory()&&N?.dangling!==!0}catch{}return!1}re.existsDirectory=Y})(o||(e.SymlinkSupport=o={}));const r=new O.$oh;function i(re,ue,Q){return r.queueFor(v.URI.file(re),()=>{const Y=j(Q);return new Promise((U,L)=>b(re,ue,Y,N=>N?L(N):U()))},y.$Jg)}let s=!0;function l(re){s=re}e.configureFlushOnWrite=l;function b(re,ue,Q,Y){if(!s)return n.writeFile(re,ue,{mode:Q.mode,flag:Q.flag},Y);n.open(re,Q.flag,Q.mode,(U,L)=>{if(U)return Y(U);n.writeFile(L,ue,N=>{if(N)return n.close(L,()=>Y(N));n.fdatasync(L,G=>(G&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",G),l(!1)),n.close(L,q=>Y(q))))})})}function D(re,ue,Q){const Y=j(Q);if(!s)return n.writeFileSync(re,ue,{mode:Y.mode,flag:Y.flag});const U=n.openSync(re,Y.flag,Y.mode);try{n.writeFileSync(U,ue);try{n.fdatasyncSync(U)}catch(L){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",L),l(!1)}}finally{n.closeSync(U)}}e.writeFileSync=D;function j(re){return re?{mode:typeof re.mode=="number"?re.mode:438,flag:typeof re.flag=="string"?re.flag:"w"}:{mode:438,flag:"w"}}async function E(re,ue,Q=6e4){if(re!==ue)try{c.$i&&typeof Q=="number"?await I(re,ue,Date.now(),Q):await(0,P.promisify)(n.rename)(re,ue)}catch(Y){if(re.toLowerCase()!==ue.toLowerCase()&&Y.code==="EXDEV"||re.endsWith("."))await M(re,ue,{preserveSymlinks:!1}),await $(re,k.MOVE);else throw Y}}async function I(re,ue,Q,Y,U=0){try{return await(0,P.promisify)(n.rename)(re,ue)}catch(L){if(L.code!=="EACCES"&&L.code!=="EPERM"&&L.code!=="EBUSY")throw L;if(Date.now()-Q>=Y)throw console.error(`[node.js fs] rename failed after ${U} retries with error: ${L}`),L;if(U===0){let N=!1;try{const{stat:G}=await o.stat(ue);G.isFile()||(N=!0)}catch{}if(N)throw L}return await(0,O.$gh)(Math.min(100,U*10)),I(re,ue,Q,Y,U+1)}}async function M(re,ue,Q){return W(re,ue,{root:{source:re,target:ue},options:Q,handledSourcePaths:new Set})}const T=511;async function W(re,ue,Q){if(Q.handledSourcePaths.has(re))return;Q.handledSourcePaths.add(re);const{stat:Y,symbolicLink:U}=await o.stat(re);if(U){if(Q.options.preserveSymlinks)try{return await le(re,ue,Q)}catch{}if(U.dangling)return}return Y.isDirectory()?V(re,ue,Y.mode&T,Q):J(re,ue,Y.mode&T)}async function V(re,ue,Q,Y){await e.Promises.mkdir(ue,{recursive:!0,mode:Q});const U=await u(re);for(const L of U)await W((0,d.$jc)(re,L),(0,d.$jc)(ue,L),Y)}async function J(re,ue,Q){await e.Promises.copyFile(re,ue),await e.Promises.chmod(ue,Q)}async function le(re,ue,Q){let Y=await e.Promises.readlink(re);(0,C.$fg)(Y,Q.root.source,!c.$k)&&(Y=(0,d.$jc)(Q.root.target,Y.substr(Q.root.source.length+1))),await e.Promises.symlink(Y,ue)}e.Promises=new class{get access(){return(0,P.promisify)(n.access)}get stat(){return(0,P.promisify)(n.stat)}get lstat(){return(0,P.promisify)(n.lstat)}get utimes(){return(0,P.promisify)(n.utimes)}get read(){return(re,ue,Q,Y,U)=>new Promise((L,N)=>{n.read(re,ue,Q,Y,U,(G,q,oe)=>G?N(G):L({bytesRead:q,buffer:oe}))})}get readFile(){return(0,P.promisify)(n.readFile)}get write(){return(re,ue,Q,Y,U)=>new Promise((L,N)=>{n.write(re,ue,Q,Y,U,(G,q,oe)=>G?N(G):L({bytesWritten:q,buffer:oe}))})}get appendFile(){return(0,P.promisify)(n.appendFile)}get fdatasync(){return(0,P.promisify)(n.fdatasync)}get truncate(){return(0,P.promisify)(n.truncate)}get copyFile(){return(0,P.promisify)(n.copyFile)}get open(){return(0,P.promisify)(n.open)}get close(){return(0,P.promisify)(n.close)}get symlink(){return(0,P.promisify)(n.symlink)}get readlink(){return(0,P.promisify)(n.readlink)}get chmod(){return(0,P.promisify)(n.chmod)}get mkdir(){return(0,P.promisify)(n.mkdir)}get unlink(){return(0,P.promisify)(n.unlink)}get rmdir(){return(0,P.promisify)(n.rmdir)}get realpath(){return(0,P.promisify)(n.realpath)}async exists(re){try{return await e.Promises.access(re),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return a}get writeFile(){return i}get rm(){return $}get rename(){return E}get copy(){return M}}}),define(ae[108],ce([0,1,46,9,4,25,21]),function(X,e,n,R,P,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=e.$Jq=e.$Iq=e.$Hq=void 0;function S(k){if(P.$k)return k;const $=(0,R.$mc)(k);if(k===$)return k;const m=((0,R.$nc)(k)||k).toLowerCase();try{const p=(0,C.readdirSync)($).filter(u=>u.toLowerCase()===m);if(p.length===1){const u=S($);if(u)return(0,R.$jc)(u,p[0])}else if(p.length>1){const u=p.indexOf(m);if(u>=0){const f=S($);if(f)return(0,R.$jc)(f,p[u])}}}catch{}return null}e.$Hq=S;async function d(k){if(P.$k)return k;const $=(0,R.$mc)(k);if(k===$)return k;const m=((0,R.$nc)(k)||k).toLowerCase();try{const p=(await C.Promises.readdir($)).filter(u=>u.toLowerCase()===m);if(p.length===1){const u=await d($);if(u)return(0,R.$jc)(u,p[0])}else if(p.length>1){const u=p.indexOf(m);if(u>=0){const f=await d($);if(f)return(0,R.$jc)(f,p[u])}}}catch{}return null}e.$Iq=d;async function c(k){try{return await C.Promises.realpath(k)}catch{const m=v(k);return await C.Promises.access(m,n.constants.R_OK),m}}e.$Jq=c;function y(k){try{return n.realpathSync(k)}catch{const m=v(k);return n.accessSync(m,n.constants.R_OK),m}}e.$Kq=y;function v(k){return(0,O.$4e)((0,R.$hc)(k),R.sep)}}),define(ae[109],ce([0,1,26,9,21]),function(X,e,n,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1l=e.$Zl=void 0;const O=/^\d+$/,C=/^Microsoft.PowerShell_.*/,S=/^Microsoft.PowerShellPreview_.*/;var d;(function(g){g[g.x64=0]="x64",g[g.x86=1]="x86",g[g.ARM=2]="ARM"})(d||(d={}));let c;switch(process.arch){case"ia32":c=1;break;case"arm":case"arm64":c=2;break;default:c=0;break}let y;process.env.PROCESSOR_ARCHITEW6432?y=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?y=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?y=1:y=0;class v{constructor(a,t,o){this.exePath=a,this.displayName=t,this.a=o}async exists(){return this.a===void 0&&(this.a=await P.SymlinkSupport.existsFile(this.exePath)),this.a}}function k({useAlternateBitness:g=!1}={}){return g?c===0?process.env["ProgramFiles(x86)"]||null:y===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function $({useAlternateBitness:g=!1,findPreview:a=!1}={}){const t=k({useAlternateBitness:g});if(!t)return null;const o=R.$jc(t,"PowerShell");if(!await P.SymlinkSupport.existsDirectory(o))return null;let r=-1,i=null;for(const b of await P.Promises.readdir(o)){let D=-1;if(a){const E=b.indexOf("-");if(E<0)continue;const I=b.substring(0,E);if(!O.test(I)||b.substring(E+1)!=="preview")continue;D=parseInt(I,10)}else{if(!O.test(b))continue;D=parseInt(b,10)}if(D<=r)continue;const j=R.$jc(o,b,"pwsh.exe");await P.SymlinkSupport.existsFile(j)&&(i=j,r=D)}if(!i)return null;const s=t.includes("x86")?" (x86)":"",l=a?" Preview":"";return new v(i,`PowerShell${l}${s}`,!0)}async function m({findPreview:g}={}){if(!process.env.LOCALAPPDATA)return null;const a=R.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await P.SymlinkSupport.existsDirectory(a))return null;const{pwshMsixDirRegex:t,pwshMsixName:o}=g?{pwshMsixDirRegex:S,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:C,pwshMsixName:"PowerShell (Store)"};for(const r of await P.Promises.readdir(a))if(t.test(r)){const i=R.$jc(a,r,"pwsh.exe");return new v(i,o)}return null}function w(){const g=R.$jc(n.homedir(),".dotnet","tools","pwsh.exe");return new v(g,".NET Core PowerShell Global Tool")}function p(){const g=R.$jc(process.env.windir,c===1&&y!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new v(g,"Windows PowerShell",!0)}async function*u(){let g=await $();g&&(yield g),g=await $({useAlternateBitness:!0}),g&&(yield g),g=await m(),g&&(yield g),g=w(),g&&(yield g),g=await $({findPreview:!0}),g&&(yield g),g=await m({findPreview:!0}),g&&(yield g),g=await $({useAlternateBitness:!0,findPreview:!0}),g&&(yield g),g=p(),g&&(yield g)}async function*f(){for await(const g of u())await g.exists()&&(yield g)}e.$Zl=f;async function h(){for await(const g of f())return g;return null}e.$1l=h}),define(ae[90],ce([0,1,9,4,36,75,12,21]),function(X,e,n,R,P,O,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$5l=e.$4l=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return O.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return O.TerminateResponseCode}});function d(v=P.env){return v.comspec||"cmd.exe"}e.$4l=d;function c(v){let k=[],$=!1;const m=function(w){if($){k.push(w);return}(!v.send(w,u=>{if(u&&console.error(u),$=!1,k.length>0){const f=k.slice(0);k=[],f.forEach(h=>m(h))}})||R.$i)&&($=!0)};return{send:m}}e.$5l=c;var y;(function(v){async function k($,m,w){if(n.$ic($))return $;if(m===void 0&&(m=P.cwd()),n.$mc($)!=="."||(w===void 0&&C.$Sf(P.env.PATH)&&(w=P.env.PATH.split(n.$tc)),w===void 0||w.length===0))return n.$jc(m,$);async function u(f){if(await S.Promises.exists(f)){let h;try{h=await S.Promises.stat(f)}catch(g){g.message.startsWith("EACCES")&&(h=await S.Promises.lstat(f))}return h?!h.isDirectory():!1}return!1}for(const f of w){let h;if(n.$ic(f)?h=n.$jc(f,$):h=n.$jc(m,f,$),await u(h))return h;let g=h+".com";if(await u(g)||(g=h+".exe",await u(g)))return g}return n.$jc(m,$)}v.findExecutable=k})(y||(e.win32=y={}))}),define(ae[110],ce([0,1,48,13]),function(X,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gs=void 0;function P(C){return new Promise((S,d)=>{let c;const y=new Map;function v($,m,w,p,u){const f=y.get(m);if($===C||f){const h={name:k(w),cmd:w,pid:$,ppid:m,load:p,mem:u};y.set($,h),$===C&&(c=h),f&&(f.children||(f.children=[]),f.children.push(h),f.children.length>1&&(f.children=f.children.sort((g,a)=>g.pid-a.pid)))}}function k($){const m=/--utility-sub-type=network/i,w=/--crashes-directory/i,p=/\\pipe\\winpty-control/i,u=/conhost\.exe.+--headless/i,f=/--type=([a-zA-Z-]+)/;if(w.exec($))return"electron-crash-reporter";if(p.exec($))return"winpty-agent";if(u.exec($))return"conpty-agent";let h=f.exec($);if(h&&h.length===2)return h[1]==="renderer"?"window":h[1]==="utility"?m.exec($)?"utility-network-service":"utility-process":h[1]==="extensionHost"?"extension-host":h[1];const g=/[a-zA-Z-]+\.js/g;let a="";do h=g.exec($),h&&(a+=h+" ");while(h);return a&&$.indexOf("node ")<0&&$.indexOf("node.exe")<0?`electron-nodejs (${a})`:$}if(process.platform==="win32"){const $=m=>m.indexOf("\\\\?\\")===0||m.indexOf("\\??\\")===0?m.substring(4):m.indexOf('"\\\\?\\')===0||m.indexOf('"\\??\\')===0?'"'+m.substring(5):m;new Promise((m,w)=>{X(["@vscode/windows-process-tree"],m,w)}).then(m=>{m.getProcessList(C,w=>{if(!w){d(new Error(`Root process ${C} not found`));return}m.getProcessCpuUsage(w,p=>{const u=new Map;p.forEach(f=>{const h=$(f.commandLine||"");u.set(f.pid,{name:k(h),cmd:h,pid:f.pid,ppid:f.ppid,load:f.cpu||0,mem:f.memory||0})}),c=u.get(C),c?(u.forEach(f=>{const h=u.get(f.ppid);h&&(h.children||(h.children=[]),h.children.push(f))}),u.forEach(f=>{f.children&&(f.children=f.children.sort((h,g)=>h.pid-g.pid))}),S(c)):d(new Error(`Root process ${C} not found`))})},m.ProcessDataFlag.CommandLine|m.ProcessDataFlag.Memory)})}else{let $=function(){let m=[c];const w=[];for(;m.length;){const u=m.shift();u&&(w.push(u.pid),u.children&&(m=m.concat(u.children)))}let p=JSON.stringify(R.$zg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);p+=" "+w.join(" "),(0,n.exec)(p,{},(u,f,h)=>{if(u||h)d(u||new Error(h.toString()));else{const g=f.toString().split(`
`);for(let a=0;a<w.length;a++){const t=y.get(w[a]);t.load=parseFloat(g[a])}if(!c){d(new Error(`Root process ${C} not found`));return}S(c)}})};(0,n.exec)("which ps",{},(m,w,p)=>{if(m||p)if(process.platform!=="linux")d(m||new Error(p.toString()));else{const u=JSON.stringify(R.$zg.asFileUri("vs/base/node/ps.sh").fsPath);(0,n.exec)(u,{},(f,h,g)=>{f||g?d(f||new Error(g.toString())):(O(h,v),$())})}else{const u=w.toString().trim();(0,n.exec)(`${u} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(h,g,a)=>{h||a&&!a.includes("screen size is bogus")?d(h||new Error(a.toString())):(O(g,v),process.platform==="linux"?$():c?S(c):d(new Error(`Root process ${C} not found`)))})}})}})}e.$gs=P;function O(C,S){const d=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,c=C.toString().split(`
`);for(const y of c){const v=d.exec(y.trim());v&&v.length===6&&S(parseInt(v[1]),parseInt(v[2]),v[5],parseFloat(v[3]),parseFloat(v[4]))}}}),define(ae[111],ce([0,1,26,4,109,90]),function(X,e,n,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6l=void 0;async function C(v,k){return v===1?R.$i?y():O.$4l(k):d(v,k)}e.$6l=C;let S=null;function d(v,k){if(R.$k&&v===2||R.$j&&v===3)return"/bin/bash";if(!S){let $;if(R.$i)$="/bin/bash";else{if($=k.SHELL,!$)try{$=(0,n.userInfo)().shell}catch{}$||($="sh"),$==="/bin/false"&&($="/bin/bash")}S=$}return S}let c=null;async function y(){return c||(c=(await(0,P.$1l)()).exePath),c}});var ve=this&&this.__decorate||function(X,e,n,R){var P=arguments.length,O=P<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,n):R,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(X,e,n,R);else for(var S=X.length-1;S>=0;S--)(C=X[S])&&(O=(P<3?C(O):P>3?C(e,n,O):C(e,n))||O);return P>3&&O&&Object.defineProperty(e,n,O),O};define(ae[43],ce([0,1,22,8,17,23,50,15,3,2,76,25,12]),function(X,e,n,R,P,O,C,S,d,c,y,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1h=e.ProxyChannel=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.RequestInitiator=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=void 0;var $;(function(U){U[U.Promise=100]="Promise",U[U.PromiseCancel=101]="PromiseCancel",U[U.EventListen=102]="EventListen",U[U.EventDispose=103]="EventDispose"})($||($={}));function m(U){switch(U){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(U){U[U.Initialize=200]="Initialize",U[U.PromiseSuccess=201]="PromiseSuccess",U[U.PromiseError=202]="PromiseError",U[U.PromiseErrorObj=203]="PromiseErrorObj",U[U.EventFire=204]="EventFire"})(w||(w={}));function p(U){switch(U){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(U){U[U.Uninitialized=0]="Uninitialized",U[U.Idle=1]="Idle"})(u||(u={}));function f(U){let L=0;for(let N=0;;N+=7){const G=U.read(1);if(L|=(G.buffer[0]&127)<<N,!(G.buffer[0]&128))return L}}const h=r(0);function g(U,L){if(L===0){U.write(h);return}let N=0;for(let q=L;q!==0;q=q>>>7)N++;const G=P.$se.alloc(N);for(let q=0;L!==0;q++)G.buffer[q]=L&127,L=L>>>7,L>0&&(G.buffer[q]|=128);U.write(G)}class a{constructor(L){this.b=L,this.a=0}read(L){const N=this.b.slice(this.a,this.a+L);return this.a+=N.byteLength,N}}e.$Ph=a;class t{constructor(){this.a=[]}get buffer(){return P.$se.concat(this.a)}write(L){this.a.push(L)}}e.$Qh=t;var o;(function(U){U[U.Undefined=0]="Undefined",U[U.String=1]="String",U[U.Buffer=2]="Buffer",U[U.VSBuffer=3]="VSBuffer",U[U.Array=4]="Array",U[U.Object=5]="Object",U[U.Int=6]="Int"})(o||(o={}));function r(U){const L=P.$se.alloc(1);return L.writeUInt8(U,0),L}const i={Undefined:r(o.Undefined),String:r(o.String),Buffer:r(o.Buffer),VSBuffer:r(o.VSBuffer),Array:r(o.Array),Object:r(o.Object),Uint:r(o.Int)},s=typeof Buffer<"u";function l(U,L){if(typeof L>"u")U.write(i.Undefined);else if(typeof L=="string"){const N=P.$se.fromString(L);U.write(i.String),g(U,N.byteLength),U.write(N)}else if(s&&Buffer.isBuffer(L)){const N=P.$se.wrap(L);U.write(i.Buffer),g(U,N.byteLength),U.write(N)}else if(L instanceof P.$se)U.write(i.VSBuffer),g(U,L.byteLength),U.write(L);else if(Array.isArray(L)){U.write(i.Array),g(U,L.length);for(const N of L)l(U,N)}else if(typeof L=="number"&&(L|0)===L)U.write(i.Uint),g(U,L);else{const N=P.$se.fromString(JSON.stringify(L));U.write(i.Object),g(U,N.byteLength),U.write(N)}}e.$Rh=l;function b(U){switch(U.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return U.read(f(U)).toString();case o.Buffer:return U.read(f(U)).buffer;case o.VSBuffer:return U.read(f(U));case o.Array:{const N=f(U),G=[];for(let q=0;q<N;q++)G.push(b(U));return G}case o.Object:return JSON.parse(U.read(f(U)).toString());case o.Int:return f(U)}}e.$Sh=b;class D{constructor(L,N,G=null,q=1e3){this.h=L,this.j=N,this.k=G,this.l=q,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(oe=>this.q(oe)),this.m({type:200})}registerChannel(L,N){this.b.set(L,N),setTimeout(()=>this.w(L),0)}m(L){switch(L.type){case 200:{const N=this.o([L.type]);this.k?.logOutgoing(N,0,1,p(L.type));return}case 201:case 202:case 204:case 203:{const N=this.o([L.type,L.id],L.data);this.k?.logOutgoing(N,L.id,1,p(L.type),L.data);return}}}o(L,N=void 0){const G=new t;return l(G,L),l(G,N),this.p(G.buffer)}p(L){try{return this.h.send(L),L.byteLength}catch{return 0}}q(L){const N=new a(L),G=b(N),q=b(N),oe=G[0];switch(oe){case 100:return this.k?.logIncoming(L.byteLength,G[1],1,`${m(oe)}: ${G[2]}.${G[3]}`,q),this.s({type:oe,id:G[1],channelName:G[2],name:G[3],arg:q});case 102:return this.k?.logIncoming(L.byteLength,G[1],1,`${m(oe)}: ${G[2]}.${G[3]}`,q),this.t({type:oe,id:G[1],channelName:G[2],name:G[3],arg:q});case 101:return this.k?.logIncoming(L.byteLength,G[1],1,`${m(oe)}`),this.u({type:oe,id:G[1]});case 103:return this.k?.logIncoming(L.byteLength,G[1],1,`${m(oe)}`),this.u({type:oe,id:G[1]})}}s(L){const N=this.b.get(L.channelName);if(!N){this.v(L);return}const G=new O.$ce;let q;try{q=N.call(this.j,L.name,L.arg,G.token)}catch(K){q=Promise.reject(K)}const oe=L.id;q.then(K=>{this.m({id:oe,data:K,type:201})},K=>{K instanceof Error?this.m({id:oe,data:{message:K.message,name:K.name,stack:K.stack?K.stack.split?K.stack.split(`
`):K.stack:void 0},type:202}):this.m({id:oe,data:K,type:203})}).finally(()=>{he.dispose(),this.d.delete(L.id)});const he=(0,c.$Rc)(()=>G.cancel());this.d.set(L.id,he)}t(L){const N=this.b.get(L.channelName);if(!N){this.v(L);return}const G=L.id,oe=N.listen(this.j,L.name,L.arg)(he=>this.m({id:G,data:he,type:204}));this.d.set(L.id,oe)}u(L){const N=this.d.get(L.id);N&&(N.dispose(),this.d.delete(L.id))}v(L){let N=this.g.get(L.channelName);N||(N=[],this.g.set(L.channelName,N));const G=setTimeout(()=>{console.error(`Unknown channel: ${L.channelName}`),L.type===100&&this.m({id:L.id,data:{name:"Unknown channel",message:`Channel name '${L.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);N.push({request:L,timeoutTimer:G})}w(L){const N=this.g.get(L);if(N){for(const G of N)switch(clearTimeout(G.timeoutTimer),G.request.type){case 100:this.s(G.request);break;case 102:this.t(G.request);break}this.g.delete(L)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.$Oc)(this.d.values()),this.d.clear()}}e.$Th=D;var j;(function(U){U[U.LocalSide=0]="LocalSide",U[U.OtherSide=1]="OtherSide"})(j||(e.RequestInitiator=j={}));class E{constructor(L,N=null){this.l=L,this.a=!1,this.b=u.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new d.$5d,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(G=>this.s(G)),this.j=N}getChannel(L){const N=this;return{call(G,q,oe){return N.a?Promise.reject(new S.$5):N.m(L,G,q,oe)},listen(G,q){return N.a?d.Event.None:N.o(L,G,q)}}}m(L,N,G,q=O.CancellationToken.None){const oe=this.g++,K={id:oe,type:100,channelName:L,name:N,arg:G};if(q.isCancellationRequested)return Promise.reject(new S.$5);let A;return new Promise((x,z)=>{if(q.isCancellationRequested)return z(new S.$5);const Z=()=>{const ee=ie=>{switch(ie.type){case 201:this.f.delete(oe),x(ie.data);break;case 202:{this.f.delete(oe);const de=new Error(ie.data.message);de.stack=Array.isArray(ie.data.stack)?ie.data.stack.join(`
`):ie.data.stack,de.name=ie.data.name,z(de);break}case 203:this.f.delete(oe),z(ie.data);break}};this.f.set(oe,ee),this.p(K)};let H=null;this.b===u.Idle?Z():(H=(0,R.$5g)(ee=>this.u()),H.then(()=>{H=null,Z()}));const _=()=>{H?(H.cancel(),H=null):this.p({id:oe,type:101}),z(new S.$5)},B=q.onCancellationRequested(_);A=(0,c.$Qc)((0,c.$Rc)(_),B),this.d.add(A)}).finally(()=>{A.dispose(),this.d.delete(A)})}o(L,N,G){const q=this.g++,he={id:q,type:102,channelName:L,name:N,arg:G};let K=null;const A=new d.$5d({onWillAddFirstListener:()=>{K=(0,R.$5g)(x=>this.u()),K.then(()=>{K=null,this.d.add(A),this.p(he)})},onDidRemoveLastListener:()=>{K?(K.cancel(),K=null):(this.d.delete(A),this.p({id:q,type:103}))}}),F=x=>A.fire(x.data);return this.f.set(q,F),A.event}p(L){switch(L.type){case 100:case 102:{const N=this.q([L.type,L.id,L.channelName,L.name],L.arg);this.j?.logOutgoing(N,L.id,0,`${m(L.type)}: ${L.channelName}.${L.name}`,L.arg);return}case 101:case 103:{const N=this.q([L.type,L.id]);this.j?.logOutgoing(N,L.id,0,m(L.type));return}}}q(L,N=void 0){const G=new t;return l(G,L),l(G,N),this.r(G.buffer)}r(L){try{return this.l.send(L),L.byteLength}catch{return 0}}s(L){const N=new a(L),G=b(N),q=b(N),oe=G[0];switch(oe){case 200:return this.j?.logIncoming(L.byteLength,0,0,p(oe)),this.t({type:G[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(L.byteLength,G[1],0,p(oe),q),this.t({type:G[0],id:G[1],data:q})}}t(L){if(L.type===200){this.b=u.Idle,this.k.fire();return}this.f.get(L.id)?.(L)}get onDidInitializePromise(){return d.Event.toPromise(this.onDidInitialize)}u(){return this.b===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.$Oc)(this.d.values()),this.d.clear()}}e.$Uh=E,ve([C.$Jh],E.prototype,"onDidInitializePromise",null);class I{get connections(){const L=[];return this.f.forEach(N=>L.push(N)),L}constructor(L){this.a=new Map,this.f=new Set,this.g=new d.$5d,this.onDidAddConnection=this.g.event,this.h=new d.$5d,this.onDidRemoveConnection=this.h.event,this.j=new c.$Sc,this.j.add(L(({protocol:N,onDidClientDisconnect:G})=>{const q=d.Event.once(N.onMessage);this.j.add(q(oe=>{const he=new a(oe),K=b(he),A=new D(N,K),F=new E(N);this.a.forEach((z,Z)=>A.registerChannel(Z,z));const x={channelServer:A,channelClient:F,ctx:K};this.f.add(x),this.g.fire(x),this.j.add(G(()=>{A.dispose(),F.dispose(),this.f.delete(x),this.h.fire(x)}))}))}))}getChannel(L,N){const G=this;return{call(q,oe,he){let K;if((0,k.$7f)(N)){const F=(0,n.$4b)(G.connections.filter(N));K=F?Promise.resolve(F):d.Event.toPromise(d.Event.filter(G.onDidAddConnection,N))}else K=N.routeCall(G,q,oe);const A=K.then(F=>F.channelClient.getChannel(L));return T(A).call(q,oe,he)},listen(q,oe){if((0,k.$7f)(N))return G.k(L,N,q,oe);const he=N.routeEvent(G,q,oe).then(K=>K.channelClient.getChannel(L));return T(he).listen(q,oe)}}}k(L,N,G,q){const oe=this;let he;const K=new d.$5d({onWillAddFirstListener:()=>{he=new c.$Sc;const A=new d.$$d,F=new Map,x=Z=>{const _=Z.channelClient.getChannel(L).listen(G,q),B=A.add(_);F.set(Z,B)},z=Z=>{const H=F.get(Z);H&&(H.dispose(),F.delete(Z))};oe.connections.filter(N).forEach(x),d.Event.filter(oe.onDidAddConnection,N)(x,void 0,he),oe.onDidRemoveConnection(z,void 0,he),A.event(K.fire,K,he),he.add(A)},onDidRemoveLastListener:()=>{he?.dispose(),he=void 0}});return K.event}registerChannel(L,N){this.a.set(L,N);for(const G of this.f)G.channelServer.registerChannel(L,N)}dispose(){this.j.dispose();for(const L of this.f)L.channelClient.dispose(),L.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Vh=I;class M{constructor(L,N,G=null){const q=new t;l(q,N),L.send(q.buffer),this.a=new E(L,G),this.d=new D(L,N,G)}getChannel(L){return this.a.getChannel(L)}registerChannel(L,N){this.d.registerChannel(L,N)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Wh=M;function T(U){return{call(L,N,G){return U.then(q=>q.call(L,N,G))},listen(L,N){const G=new d.$be;return U.then(q=>G.input=q.listen(L,N)),G.event}}}e.$Xh=T;function W(U){let L=!1;return{call(N,G,q){return L?U.call(N,G,q):(0,R.$gh)(0).then(()=>L=!0).then(()=>U.call(N,G,q))},listen(N,G){if(L)return U.listen(N,G);const q=new d.$be;return(0,R.$gh)(0).then(()=>L=!0).then(()=>q.input=U.listen(N,G)),q.event}}}e.$Yh=W;class V{constructor(L){this.a=L}routeCall(L){return this.b(L)}routeEvent(L){return this.b(L)}async b(L){for(const N of L.connections)if(await Promise.resolve(this.a(N.ctx)))return Promise.resolve(N);return await d.Event.toPromise(L.onDidAddConnection),await this.b(L)}}e.$Zh=V;var J;(function(U){function L(oe,he,K){const A=oe,F=K&&K.disableMarshalling,x=new Map;for(const z in A)G(z)&&x.set(z,d.Event.buffer(A[z],!0,void 0,he));return new class{listen(z,Z,H){const _=x.get(Z);if(_)return _;const B=A[Z];if(typeof B=="function"){if(q(Z))return B.call(A,H);if(G(Z))return x.set(Z,d.Event.buffer(A[Z],!0,void 0,he)),x.get(Z)}throw new S.$bb(`Event not found: ${Z}`)}call(z,Z,H){const _=A[Z];if(typeof _=="function"){if(!F&&Array.isArray(H))for(let ee=0;ee<H.length;ee++)H[ee]=(0,y.$Oh)(H[ee]);let B=_.apply(A,H);return B instanceof Promise||(B=Promise.resolve(B)),B}throw new S.$bb(`Method not found: ${Z}`)}}}U.fromService=L;function N(oe,he){const K=he&&he.disableMarshalling;return new Proxy({},{get(A,F){if(typeof F=="string")return he?.properties?.has(F)?he.properties.get(F):q(F)?function(x){return oe.listen(F,x)}:G(F)?oe.listen(F):async function(...x){let z;he&&!(0,k.$2f)(he.context)?z=[he.context,...x]:z=x;const Z=await oe.call(F,z);return K?Z:(0,y.$Oh)(Z)};throw new S.$bb(`Property not found: ${String(F)}`)}})}U.toService=N;function G(oe){return oe[0]==="o"&&oe[1]==="n"&&v.$if(oe.charCodeAt(2))}function q(oe){return/^onDynamic/.test(oe)&&v.$if(oe.charCodeAt(9))}})(J||(e.ProxyChannel=J={}));const le=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function re(U){if(Array.isArray(U))return U;if(U&&typeof U=="object"&&typeof U.toString=="function"){const L=U.toString();if(L!=="[object Object]")return L}return U}function ue(U){return Array.isArray(U)?U.map(re):re(U)}function Q(U,L,N,G,q,oe,he){he=ue(he);const K=le[q],A=K[G%K.length];let F=[`%c[${U}]%c[${String(L).padStart(7," ")}]%c[len: ${String(N).padStart(5," ")}]%c${String(G).padStart(5," ")} - ${oe}`,"color: darkgreen","color: grey","color: grey",`color: ${A}`];/\($/.test(oe)?(F=F.concat(he),F.push(")")):F.push(he),console.log.apply(console,F)}class Y{constructor(L,N){this.d=L,this.f=N,this.a=0,this.b=0}logOutgoing(L,N,G,q,oe){this.b+=L,Q(this.d,this.b,L,N,G,q,oe)}logIncoming(L,N,G,q,oe){this.a+=L,Q(this.f,this.a,L,N,G,q,oe)}}e.$1h=Y}),define(ae[159],ce([0,1,17,3,43]),function(X,e,n,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OV=e.$NV=void 0;class O{constructor(d){this.a=d,this.onMessage=R.Event.fromDOMEventEmitter(this.a,"message",c=>c.data?n.$se.wrap(c.data):n.$se.alloc(0)),d.start()}send(d){this.a.postMessage(d.buffer)}disconnect(){this.a.close()}}e.$NV=O;class C extends P.$Wh{constructor(d,c){const y=new O(d);super(y,c),this.b=y}dispose(){this.b.disconnect(),super.dispose()}}e.$OV=C}),define(ae[112],ce([0,1,17,3,2,43]),function(X,e,n,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=e.$5h=e.$4h=e.$3h=e.ProtocolConstants=e.$2h=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var C;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(C||(e.SocketDiagnosticsEventType=C={}));var S;(function(i){i.enableDiagnostics=!1,i.records=[];const s=new WeakMap;let l=0;function b(j,E){if(!s.has(j)){const I=String(++l);s.set(j,I)}return s.get(j)}function D(j,E,I,M){if(!i.enableDiagnostics)return;const T=b(j,E);if(M instanceof n.$se||M instanceof Uint8Array||M instanceof ArrayBuffer||ArrayBuffer.isView(M)){const W=n.$se.alloc(M.byteLength);W.set(M),i.records.push({timestamp:Date.now(),id:T,label:E,type:I,buff:W})}else i.records.push({timestamp:Date.now(),id:T,label:E,type:I,data:M})}i.traceSocketEvent=D})(S||(e.SocketDiagnostics=S={}));var d;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(d||(e.SocketCloseEventType=d={}));let c=null;function y(){return c||(c=n.$se.alloc(0)),c}class v{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(s){this.a.push(s),this.b+=s.byteLength}read(s){return this.c(s,!0)}peek(s){return this.c(s,!1)}c(s,l){if(s===0)return y();if(s>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===s){const E=this.a[0];return l&&(this.a.shift(),this.b-=s),E}if(this.a[0].byteLength>s){const E=this.a[0].slice(0,s);return l&&(this.a[0]=this.a[0].slice(s),this.b-=s),E}const b=n.$se.alloc(s);let D=0,j=0;for(;s>0;){const E=this.a[j];if(E.byteLength>s){const I=E.slice(0,s);b.set(I,D),D+=s,l&&(this.a[j]=E.slice(s),this.b-=s),s-=s}else b.set(E,D),D+=E.byteLength,l?(this.a.shift(),this.b-=E.byteLength):j++,s-=E.byteLength}return b}}e.$2h=v;var k;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(k||(k={}));function $(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var m;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(m||(e.ProtocolConstants=m={}));class w{constructor(s,l,b,D){this.type=s,this.id=l,this.ack=b,this.data=D,this.writtenTime=0}get size(){return this.data.byteLength}}class p extends P.$Tc{constructor(s){super(),this.f=this.B(new R.$5d),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=s,this.b=!1,this.c=new v,this.B(this.a.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(s);this.c.byteLength>=this.g.readLen;){const l=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=l.readUInt32BE(9),this.g.messageType=l.readUInt8(0),this.g.id=l.readUInt32BE(1),this.g.ack=l.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:$(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const b=this.g.messageType,D=this.g.id,j=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",l),this.f.fire(new w(b,D,j,l)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class u{constructor(s){this.k=null,this.a=!1,this.b=!1,this.c=s,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(s){if(this.a)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=n.$se.alloc(13);l.writeUInt8(s.type,0),l.writeUInt32BE(s.id,1),l.writeUInt32BE(s.ack,5),l.writeUInt32BE(s.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:$(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",s.data),this.j(l,s.data)}g(s,l){const b=this.f===0;return this.d.push(s,l),this.f+=s.byteLength+l.byteLength,b}h(){const s=n.$se.concat(this.d,this.f);return this.d.length=0,this.f=0,s}j(s,l){this.g(s,l)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const s=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this.c.write(s)}}class f extends P.$Tc{constructor(s){super(),this.f=new R.$5d,this.onMessage=this.f.event,this.g=new R.$5d,this.onDidDispose=this.g.event,this.a=s,this.b=this.B(new u(this.a)),this.c=this.B(new p(this.a)),this.B(this.c.onMessage(l=>{l.type===1&&this.f.fire(l.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(s){this.b.write(new w(1,0,0,s))}}e.$3h=f;class h extends O.$Wh{static fromSocket(s,l){return new h(new f(s),l)}get onDidDispose(){return this.b.onDidDispose}constructor(s,l,b=null){super(s,l,b),this.b=s}dispose(){super.dispose();const s=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),s.end()}}e.$4h=h;class g{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new R.$5d({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(s){this.b?this.d.length>0?this.d.push(s):this.a.fire(s):this.d.push(s)}flushBuffer(){this.d=[]}}e.$5h=g;class a{constructor(s){this.data=s,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let s=0,l=this.a;for(;l;)l=l.next,s++;return s}peek(){return this.a?this.a.data:null}toArray(){const s=[];let l=0,b=this.a;for(;b;)s[l++]=b.data,b=b.next;return s}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(s){const l=new a(s);if(!this.a){this.a=l,this.b=l;return}this.b.next=l,this.b=l}}class o{static{this.a=10}static{this.b=null}static getInstance(){return o.b||(o.b=new o),o.b}constructor(){this.c=[];const s=Date.now();for(let l=0;l<o.a;l++)this.c[l]=s-1e3*l;setInterval(()=>{for(let l=o.a;l>=1;l--)this.c[l]=this.c[l-1];this.c[0]=Date.now()},1e3)}d(){const s=Date.now(),l=(1+o.a)*1e3;let b=0;for(let D=0;D<o.a;D++)s-this.c[D]<=l&&b++;return 1-b/o.a}hasHighLoad(){return this.d()>=.5}}class r{get unacknowledgedCount(){return this.c-this.d}constructor(s){this.u=new g,this.onControlMessage=this.u.event,this.v=new g,this.onMessage=this.v.event,this.w=new g,this.onDidDispose=this.w.event,this.x=new g,this.onSocketClose=this.x.event,this.y=new g,this.onSocketTimeout=this.y.event,this.s=s.loadEstimator??o.getInstance(),this.t=s.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new P.$Sc,this.o=s.socket,this.p=this.r.add(new u(this.o)),this.q=this.r.add(new p(this.o)),this.r.add(this.q.onMessage(l=>this.z(l))),this.r.add(this.o.onClose(l=>this.x.fire(l))),s.initialChunk&&this.q.acceptChunk(s.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const s=new w(5,0,0,y());this.p.write(s),this.p.flush()}sendPause(){const s=new w(7,0,0,y());this.p.write(s)}sendResume(){const s=new w(8,0,0,y());this.p.write(s)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(s,l){this.a=!0,this.r.dispose(),this.r=new P.$Sc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=s,this.p=this.r.add(new u(this.o)),this.q=this.r.add(new p(this.o)),this.r.add(this.q.onMessage(b=>this.z(b))),this.r.add(this.o.onClose(b=>this.x.fire(b))),this.q.acceptChunk(l)}endAcceptReconnection(){this.a=!1,this.h=this.g;const s=new w(3,0,this.h,y());this.p.write(s);const l=this.b.toArray();for(let b=0,D=l.length;b<D;b++)this.p.write(l[b]);this.B()}acceptDisconnect(){this.w.fire()}z(s){if(s.ack>this.d){this.d=s.ack;do{const l=this.b.peek();if(l&&l.id<=s.ack)this.b.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this.g)if(s.id!==this.g+1){const l=Date.now();l-this.m>1e4&&(this.m=l,this.p.write(new w(6,0,0,y())))}else this.g=s.id,this.j=Date.now(),this.A(),this.v.fire(s.data);break}case 2:{this.u.fire(s.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const l=this.b.toArray();for(let b=0,D=l.length;b<D;b++)this.p.write(l[b]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(s){const l=++this.c;this.h=this.g;const b=new w(1,l,this.h,s);this.b.push(b),this.a||(this.p.write(b),this.B())}sendControl(s){const l=new w(2,0,0,s);this.p.write(l)}A(){if(this.g<=this.h||this.k)return;const s=Date.now()-this.j;if(s>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-s+5)}B(){if(this.c<=this.d||this.f||this.a)return;const s=this.b.peek(),l=Date.now()-s.writtenTime,b=Date.now()-this.q.lastReadTime,D=Date.now()-this.n;if(l>=2e4&&b>=2e4&&D>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:l,timeSinceLastReceivedSomeData:b});return}const j=Math.max(2e4-l,2e4-b,2e4-D,500);this.f=setTimeout(()=>{this.f=null,this.B()},j)}C(){if(this.g<=this.h)return;this.h=this.g;const s=new w(3,0,this.h,y());this.p.write(s)}D(){this.h=this.g;const s=new w(9,0,this.h,y());this.p.write(s)}}e.$6h=r}),define(ae[37],ce([0,1,14,15,13]),function(X,e,n,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KV=void 0;class O{constructor(){this.a=new WeakMap}on(S,d){const c=(y,...v)=>{this.b(S,y)&&d(y,...v)};return this.a.set(d,c),n.ipcMain.on(S,c),this}once(S,d){return n.ipcMain.once(S,(c,...y)=>{this.b(S,c)&&d(c,...y)}),this}handle(S,d){return n.ipcMain.handle(S,(c,...y)=>this.b(S,c)?d(c,...y):Promise.reject(`Invalid channel '${S}' or sender for ipcMain.handle() usage.`)),this}removeHandler(S){return n.ipcMain.removeHandler(S),this}removeListener(S,d){const c=this.a.get(d);return c&&(n.ipcMain.removeListener(S,c),this.a.delete(d)),this}b(S,d){if(!S||!S.startsWith("vscode:"))return(0,R.$1)(`Refused to handle ipcMain event for channel '${S}' because the channel is unknown.`),!1;const c=d.senderFrame,y=c.url;if(!y||y==="about:blank")return!0;let v="unknown";try{v=new URL(y).host}catch{return(0,R.$1)(`Refused to handle ipcMain event for channel '${S}' because of a malformed URL '${y}'.`),!1}return v!==P.$yg?((0,R.$1)(`Refused to handle ipcMain event for channel '${S}' because of a bad origin of '${v}'.`),!1):c.parent!==null?((0,R.$1)(`Refused to handle ipcMain event for channel '${S}' because sender of origin '${v}' is not a main frame.`),!1):!0}}e.$KV=new O}),define(ae[160],ce([0,1,14,37,148]),function(X,e,n,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LV=void 0;function O(){R.$KV.on(P.$IV,(S,d,c,y,v)=>{const k=C(S,y,c);k.popup({x:v?v.x:void 0,y:v?v.y:void 0,positioningItem:v?v.positioningItem:void 0,callback:()=>{k&&S.sender.send(P.$JV,d)}})})}e.$LV=O;function C(S,d,c){const y=new n.Menu;return c.forEach(v=>{let k;v.type==="separator"?k=new n.MenuItem({type:v.type}):Array.isArray(v.submenu)?k=new n.MenuItem({submenu:C(S,d,v.submenu),label:v.label}):k=new n.MenuItem({label:v.label,type:v.type,accelerator:v.accelerator,checked:v.checked,enabled:v.enabled,visible:v.visible,click:($,m,w)=>S.sender.send(d,v.id,w)}),y.append(k)}),y}}),define(ae[161],ce([0,1,37,17,3,2,43,149]),function(X,e,n,R,P,O,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RV=void 0;function d(y,v){const k=P.Event.fromNodeEventEmitter(n.$KV,v,(m,w)=>({event:m,message:w})),$=P.Event.filter(k,({event:m})=>m.sender.id===y);return P.Event.map($,({message:m})=>m&&R.$se.wrap(m))}class c extends C.$Vh{static{this.b=new Map}static d(){const v=P.Event.fromNodeEventEmitter(n.$KV,"vscode:hello",({sender:k})=>k);return P.Event.map(v,k=>{const $=k.id;c.b.get($)?.dispose();const w=new P.$5d;c.b.set($,(0,O.$Rc)(()=>w.fire()));const p=d($,"vscode:message"),u=P.Event.any(P.Event.signal(d($,"vscode:disconnect")),w.event);return{protocol:new S.$QV(k,p),onDidClientDisconnect:u}})}constructor(){super(c.d())}}e.$RV=c}),define(ae[113],ce([0,1,37,3,32,159]),function(X,e,n,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TV=e.$SV=void 0;class C extends O.$OV{constructor(c,y){super({addEventListener:(v,k)=>c.addListener(v,k),removeEventListener:(v,k)=>c.removeListener(v,k),postMessage:v=>c.postMessage(v),start:()=>c.start(),close:()=>c.close()},y)}}e.$SV=C;async function S(d){if(d.isDestroyed()||d.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const c=(0,P.$Bg)();d.webContents.send("vscode:createMessageChannel",c);const y=R.Event.fromNodeEventEmitter(n.$KV,"vscode:createMessageChannelResult",(k,$)=>({nonce:$,port:k.ports[0]})),{port:v}=await R.Event.toPromise(R.Event.once(R.Event.filter(y,k=>k.nonce===c)));return v}e.$TV=S}),define(ae[162],ce([0,1,48,8,17,23,156,15,3,2,35,90,75,43]),function(X,e,n,R,P,O,C,S,d,c,y,v,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=e.$Eq=void 0;class m extends $.$Th{constructor(u){super({send:f=>{try{process.send?.(f.buffer.toString("base64"))}catch{}},onMessage:d.Event.fromNodeEventEmitter(process,"message",f=>P.$se.wrap(Buffer.from(f,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.$Eq=m;class w{constructor(u,f){this.i=u,this.j=f,this.c=new Set,this.g=new Map,this.h=new d.$5d,this.onDidProcessExit=this.h.event;const h=f&&f.timeout?f.timeout:6e4;this.b=new R.$ch(h),this.d=null,this.f=null}getChannel(u){const f=this;return{call(h,g,a){return f.k(u,h,g,a)},listen(h,g){return f.l(u,h,g)}}}k(u,f,h,g=O.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(g.isCancellationRequested)return Promise.reject(S.$6());this.b.cancel();const a=this.n(u),t=(0,R.$5g)(i=>a.call(f,h,i)),o=g.onCancellationRequested(()=>t.cancel()),r=(0,c.$Rc)(()=>t.cancel());return this.c.add(r),t.finally(()=>{o.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(u,f,h){if(!this.b)return d.Event.None;this.b.cancel();let g;const a=new d.$5d({onWillAddFirstListener:()=>{g=this.n(u).listen(f,h)(a.fire,a),this.c.add(g)},onDidRemoveLastListener:()=>{this.c.delete(g),g.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return a.event}get m(){if(!this.f){const u=this.j&&this.j.args?this.j.args:[],f=Object.create(null);f.env={...(0,y.$Kn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(f.env={...f.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(f.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s)).filter(s=>!s.startsWith("--vscode-"))),(0,k.$3l)(f.env),this.d=(0,n.fork)(this.i,u,f);const h=new d.$5d;d.Event.fromNodeEventEmitter(this.d,"message",s=>s)(s=>{if((0,C.$Aq)(s)){(0,C.log)(s,`IPC Library: ${this.j.serverName}`);return}h.fire(P.$se.wrap(Buffer.from(s,"base64")))});const a=this.j.useQueue?(0,v.$5l)(this.d):this.d,t=s=>this.d&&this.d.connected&&a.send(s.buffer.toString("base64")),o=h.event,r={send:t,onMessage:o};this.f=new $.$Uh(r);const i=()=>this.o();process.once("exit",i),this.d.on("error",s=>console.warn('IPC "'+this.j.serverName+'" errored with '+s)),this.d.on("exit",(s,l)=>{process.removeListener("exit",i),this.c.forEach(b=>(0,c.$Oc)(b)),this.c.clear(),s!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+s+" and signal "+l),this.b?.cancel(),this.o(),this.h.fire({code:s,signal:l})})}return this.f}n(u){let f=this.g.get(u);return f||(f=this.m.getChannel(u),this.g.set(u,f)),f}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Fq=w}),define(ae[114],ce([0,1,8,3,2,76,12]),function(X,e,n,R,P,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fp=e.$Ep=e.StorageState=e.$Dp=e.StorageHint=void 0;var S;(function(k){k[k.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",k[k.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(S||(e.StorageHint=S={}));function d(k){const $=k;return $?.changed instanceof Map||$?.deleted instanceof Set}e.$Dp=d;var c;(function(k){k[k.None=0]="None",k[k.Initialized=1]="Initialized",k[k.Closed=2]="Closed"})(c||(e.StorageState=c={}));class y extends P.$Tc{static{this.a=100}constructor($,m=Object.create(null)){super(),this.r=$,this.s=m,this.b=this.B(new R.$8d),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new n.$dh(y.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal($=>this.u($)))}u($){this.b.pause();try{$.changed?.forEach((m,w)=>this.w(w,m)),$.deleted?.forEach(m=>this.w(m,void 0))}finally{this.b.resume()}}w($,m){if(this.c===c.Closed)return;let w=!1;(0,C.$2f)(m)?w=this.f.delete($):this.f.get($)!==m&&(this.f.set($,m),w=!0),w&&this.b.fire({key:$,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==S.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get($,m){const w=this.f.get($);return(0,C.$2f)(w)?m:w}getBoolean($,m){const w=this.get($);return(0,C.$2f)(w)?m:w==="true"}getNumber($,m){const w=this.get($);return(0,C.$2f)(w)?m:parseInt(w,10)}getObject($,m){const w=this.get($);return(0,C.$2f)(w)?m:(0,O.$Nh)(w)}async set($,m,w=!1){if(this.c===c.Closed)return;if((0,C.$2f)(m))return this.delete($,w);const p=(0,C.$Uf)(m)||Array.isArray(m)?(0,O.$Mh)(m):String(m);if(this.f.get($)!==p)return this.f.set($,p),this.j.set($,p),this.h.delete($),this.b.fire({key:$,external:w}),this.D()}async delete($,m=!1){if(!(this.c===c.Closed||!this.f.delete($)))return this.h.has($)||this.h.add($),this.j.delete($),this.b.fire({key:$,external:m}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const $={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems($).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush($){if(this.z)return this.D($)}async D($){return this.s.hint===S.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),$)}async whenFlushed(){if(this.z)return new Promise($=>this.n.push($))}isInMemory(){return this.s.hint===S.STORAGE_IN_MEMORY}}e.$Ep=y;class v{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems($){$.insert?.forEach((m,w)=>this.a.set(w,m)),$.delete?.forEach(m=>this.a.delete(m))}async optimize(){}async close(){}}e.$Fp=v}),define(ae[163],ce([0,1,8,3,31,9,21]),function(X,e,n,R,P,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dW=void 0;class S{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return R.Event.None}static{this.a=2e3}static{this.b=256}constructor(y,v=Object.create(null)){this.g=y,this.h=v,this.c=(0,O.$nc)(this.g),this.d=new d(this.h.logging),this.f=this.n(this.g)}async getItems(){const y=await this.f,v=new Map;return(await this.s(y,"SELECT * FROM ItemTable")).forEach($=>v.set($.key,$.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${v.size} rows`),v}async updateItems(y){const v=await this.f;return this.j(v,y)}j(y,v){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${v.insert?(0,P.$yc)(v.insert):"0"}), delete(${v.delete?(0,P.$zc)(v.delete):"0"})`),this.t(y,()=>{const k=v.insert,$=v.delete;if(k&&k.size>0){const m=[];m.push([]);let w=0;k.forEach((p,u)=>{let f=m[w];f.length>S.b&&(w++,f=[],m.push(f)),f.push(u,p)}),m.forEach(p=>{this.u(y,`INSERT INTO ItemTable VALUES ${new Array(p.length/2).fill("(?,?)").join(",")}`,u=>u.run(p),()=>{const u=[];let f=0;return k.forEach((h,g)=>{u.push(g),f+=h.length}),`Keys: ${u.join(", ")} Length: ${f}`})})}if($&&$.size){const m=[];m.push([]);let w=0;$.forEach(p=>{let u=m[w];u.length>S.b&&(w++,u=[],m.push(u)),u.push(p)}),m.forEach(p=>{this.u(y,`DELETE FROM ItemTable WHERE key IN (${new Array(p.length).fill("?").join(",")})`,u=>u.run(p),()=>{const u=[];return $.forEach(f=>{u.push(f)}),`Keys: ${u.join(", ")}`})})}})}async optimize(){this.d.trace(`[storage ${this.c}] vacuum()`);const y=await this.f;return this.q(y,"VACUUM")}async close(y){this.d.trace(`[storage ${this.c}] close()`);const v=await this.f;return this.k(v,y)}k(y,v){return new Promise((k,$)=>{y.db.close(m=>(m&&this.o(y,`[storage ${this.c}] close(): ${m}`),this.g===S.IN_MEMORY_PATH?k():!y.isErroneous&&!y.isInMemory?this.l().then(k,w=>(this.d.error(`[storage ${this.c}] backup(): ${w}`),k())):typeof v=="function"?C.Promises.unlink(this.g).then(()=>this.p(this.g).then(w=>{const p=()=>this.k(w,void 0);return this.j(w,{insert:v()}).then(()=>p(),u=>(p(),Promise.reject(u)))})).then(k,$):$(m||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const y=this.m(this.g);return C.Promises.copy(this.g,y,{preserveSymlinks:!1})}m(y){return`${y}.backup`}async checkIntegrity(y){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${y})`);const v=await this.f,k=await this.r(v,y?"PRAGMA integrity_check":"PRAGMA quick_check"),$=y?k.integrity_check:k.quick_check;return v.isErroneous?`${$} (last error: ${v.lastError})`:v.isInMemory?`${$} (in-memory!)`:$}async n(y,v=!0){this.d.trace(`[storage ${this.c}] open(${y}, retryOnBusy: ${v})`);try{return await this.p(y)}catch(k){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${k}`),k.code==="SQLITE_BUSY"&&v)return await(0,n.$gh)(S.a),this.n(y,!1);try{await C.Promises.unlink(y);try{await C.Promises.rename(this.m(y),y,!1)}catch{}return await this.p(y)}catch($){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${$}`),this.p(S.IN_MEMORY_PATH)}}}o(y,v){y.isErroneous=!0,y.lastError=v,this.d.error(v)}p(y){return new Promise((v,k)=>{new Promise(($,m)=>{X(["@vscode/sqlite3"],$,m)}).then($=>{const m={db:new(this.d.isTracing?$.verbose().Database:$.Database)(y,w=>w?m.db&&w.code!=="SQLITE_CANTOPEN"?m.db.close(()=>k(w)):k(w):this.q(m,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>v(m),p=>m.db.close(()=>k(p)))),isInMemory:y===S.IN_MEMORY_PATH};m.db.on("error",w=>this.o(m,`[storage ${this.c}] Error (event): ${w}`)),this.d.isTracing&&m.db.on("trace",w=>this.d.trace(`[storage ${this.c}] Trace (event): ${w}`))},k)})}q(y,v){return new Promise((k,$)=>{y.db.exec(v,m=>m?(this.o(y,`[storage ${this.c}] exec(): ${m}`),$(m)):k())})}r(y,v){return new Promise((k,$)=>{y.db.get(v,(m,w)=>m?(this.o(y,`[storage ${this.c}] get(): ${m}`),$(m)):k(w))})}s(y,v){return new Promise((k,$)=>{y.db.all(v,(m,w)=>m?(this.o(y,`[storage ${this.c}] all(): ${m}`),$(m)):k(w))})}t(y,v){return new Promise((k,$)=>{y.db.serialize(()=>{y.db.run("BEGIN TRANSACTION"),v(),y.db.run("END TRANSACTION",m=>m?(this.o(y,`[storage ${this.c}] transaction(): ${m}`),$(m)):k())})})}u(y,v,k,$){const m=y.db.prepare(v),w=p=>{this.o(y,`[storage ${this.c}] prepare(): ${p} (${v}). Details: ${$()}`)};m.on("error",w),k(m),m.finalize(p=>{p&&w(p),m.removeListener("error",w)})}}e.$dW=S;class d{static{this.a="VSCODE_TRACE_STORAGE"}constructor(y){y&&typeof y.logTrace=="function"&&process.env[d.a]&&(this.b=y.logTrace),y&&typeof y.logError=="function"&&(this.c=y.logError)}get isTracing(){return!!this.b}trace(y){this.b?.(y)}error(y){this.c?.(y)}}}),define(ae[164],ce([11,10]),function(X,e){return X.create("vs/code/electron-main/app",e)}),define(ae[165],ce([11,10]),function(X,e){return X.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ae[166],ce([11,10]),function(X,e){return X.create("vs/platform/contextkey/common/contextkey",e)}),define(ae[167],ce([11,10]),function(X,e){return X.create("vs/platform/contextkey/common/scanner",e)}),define(ae[168],ce([11,10]),function(X,e){return X.create("vs/platform/dialogs/common/dialogs",e)}),define(ae[169],ce([11,10]),function(X,e){return X.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(ae[170],ce([11,10]),function(X,e){return X.create("vs/platform/environment/node/argv",e)}),define(ae[171],ce([11,10]),function(X,e){return X.create("vs/platform/environment/node/argvHelper",e)}),define(ae[172],ce([11,10]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ae[173],ce([11,10]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ae[174],ce([11,10]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ae[175],ce([11,10]),function(X,e){return X.create("vs/platform/extensions/common/extensionValidator",e)}),define(ae[176],ce([11,10]),function(X,e){return X.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ae[177],ce([11,10]),function(X,e){return X.create("vs/platform/files/common/fileService",e)}),define(ae[178],ce([11,10]),function(X,e){return X.create("vs/platform/files/common/files",e)}),define(ae[179],ce([11,10]),function(X,e){return X.create("vs/platform/files/common/io",e)}),define(ae[180],ce([11,10]),function(X,e){return X.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(ae[181],ce([11,10]),function(X,e){return X.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ae[182],ce([11,10]),function(X,e){return X.create("vs/platform/issue/electron-main/issueMainService",e)}),define(ae[183],ce([11,10]),function(X,e){return X.create("vs/platform/menubar/electron-main/menubar",e)}),define(ae[184],ce([11,10]),function(X,e){return X.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(ae[185],ce([11,10]),function(X,e){return X.create("vs/platform/request/common/request",e)}),define(ae[186],ce([11,10]),function(X,e){return X.create("vs/platform/shell/node/shellEnv",e)}),define(ae[187],ce([11,10]),function(X,e){return X.create("vs/platform/telemetry/common/telemetryService",e)}),define(ae[188],ce([11,10]),function(X,e){return X.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ae[189],ce([11,10]),function(X,e){return X.create("vs/platform/terminal/common/terminalProfiles",e)}),define(ae[190],ce([11,10]),function(X,e){return X.create("vs/platform/update/common/update.config.contribution",e)}),define(ae[191],ce([11,10]),function(X,e){return X.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ae[192],ce([11,10]),function(X,e){return X.create("vs/platform/windows/electron-main/windowImpl",e)}),define(ae[193],ce([11,10]),function(X,e){return X.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(ae[194],ce([11,10]),function(X,e){return X.create("vs/platform/workspace/common/workspace",e)}),define(ae[195],ce([11,10]),function(X,e){return X.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(ae[196],ce([11,10]),function(X,e){return X.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(ae[197],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$geb=e.$feb=void 0;function n(P){return P&&P.hasOwnProperty("folderUri")}e.$feb=n;function R(P){return P&&P.hasOwnProperty("workspace")}e.$geb=R}),define(ae[198],ce([0,1,7]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I$b=e.$H$b=e.$G$b=void 0;function R(C){return typeof C?.backupFolder=="string"}e.$G$b=R;function P(C){let S=[];try{Array.isArray(C.workspaces)&&(S=C.workspaces.map(d=>({workspace:{id:d.id,configPath:n.URI.parse(d.configURIPath)},remoteAuthority:d.remoteAuthority})))}catch{}return S}e.$H$b=P;function O(C){let S=[];try{Array.isArray(C.folders)&&(S=C.folders.map(d=>({folderUri:n.URI.parse(d.folderUri),remoteAuthority:d.remoteAuthority})))}catch{}return S}e.$I$b=O}),define(ae[199],ce([0,1,15,167]),function(X,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aj=e.TokenType=void 0;var P;(function(c){c[c.LParen=0]="LParen",c[c.RParen=1]="RParen",c[c.Neg=2]="Neg",c[c.Eq=3]="Eq",c[c.NotEq=4]="NotEq",c[c.Lt=5]="Lt",c[c.LtEq=6]="LtEq",c[c.Gt=7]="Gt",c[c.GtEq=8]="GtEq",c[c.RegexOp=9]="RegexOp",c[c.RegexStr=10]="RegexStr",c[c.True=11]="True",c[c.False=12]="False",c[c.In=13]="In",c[c.Not=14]="Not",c[c.And=15]="And",c[c.Or=16]="Or",c[c.Str=17]="Str",c[c.QuotedStr=18]="QuotedStr",c[c.Error=19]="Error",c[c.EOF=20]="EOF"})(P||(e.TokenType=P={}));function O(...c){switch(c.length){case 1:return(0,R.localize)(0,null,c[0]);case 2:return(0,R.localize)(1,null,c[0],c[1]);case 3:return(0,R.localize)(2,null,c[0],c[1],c[2]);default:return}}const C=(0,R.localize)(3,null),S=(0,R.localize)(4,null);class d{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(y){switch(y.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return y.isTripleEq?"===":"==";case 4:return y.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return y.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return y.lexeme;case 18:return y.lexeme;case 19:return y.lexeme;case 20:return"EOF";default:throw(0,n.$8)(`unhandled token type: ${JSON.stringify(y)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(y=>y.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(y){return this.c=y,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const v=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:v})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const v=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:v})}else this.h(126)?this.k(9):this.l(O("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(O("&&"));break;case 124:this.h(124)?this.k(16):this.l(O("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(y){return this.r()||this.c.charCodeAt(this.e)!==y?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(y){this.f.push({type:y,offset:this.d})}l(y){const v=this.d,k=this.c.substring(this.d,this.e),$={type:19,offset:this.d,lexeme:k};this.g.push({offset:v,lexeme:k,additionalInfo:y}),this.f.push($)}n(){this.m.lastIndex=this.d;const y=this.m.exec(this.c);if(y){this.e=this.d+y[0].length;const v=this.c.substring(this.d,this.e),k=d.b.get(v);k?this.k(k):this.f.push({type:17,lexeme:v,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(C);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let y=this.e,v=!1,k=!1;for(;;){if(y>=this.c.length){this.e=y,this.l(S);return}const m=this.c.charCodeAt(y);if(v)v=!1;else if(m===47&&!k){y++;break}else m===91?k=!0:m===92?v=!0:m===93&&(k=!1);y++}for(;y<this.c.length&&d.a.has(this.c.charCodeAt(y));)y++;this.e=y;const $=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:$,offset:this.d})}r(){return this.e>=this.c.length}}e.$aj=d}),define(ae[200],ce([0,1,3,2]),function(X,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ro=e.$qo=void 0;class P{constructor(){this.a=new n.$5d,this.b=new n.$5d,this.c=new n.$5d,this.d=new n.$5d}static{this.ChannelName="extensionhostdebugservice"}call(S,d,c){switch(d){case"close":return Promise.resolve(this.a.fire({sessionId:c[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:c[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:c[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:c[0],port:c[1],subId:c[2]}))}throw new Error("Method not implemented.")}listen(S,d,c){switch(d){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$qo=P;class O extends R.$Tc{constructor(S){super(),this.b=S}reload(S){this.b.call("reload",[S])}get onReload(){return this.b.listen("reload")}close(S){this.b.call("close",[S])}get onClose(){return this.b.listen("close")}attachSession(S,d,c){this.b.call("attach",[S,d,c])}get onAttachSession(){return this.b.listen("attach")}terminateSession(S,d){this.b.call("terminate",[S,d])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(S,d){return this.b.call("openExtensionDevelopmentHostWindow",[S,d])}}e.$ro=O}),define(ae[201],ce([0,1,151,50,13,9,36,19,7]),function(X,e,n,R,P,O,C,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=e.$Om=e.$Nm=e.$Mm=void 0,e.$Mm=/^([^.]+\..+)[:=](.+)$/;class c{get appRoot(){return(0,O.$mc)(P.$zg.asFileUri("").fsPath)}get userHome(){return d.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return d.URI.file((0,O.$jc)(this.userDataPath,"User"))}get tmpDir(){return d.URI.file(this.b.tmpDir)}get cacheHome(){return d.URI.file(this.userDataPath)}get stateResource(){return(0,S.$Sg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:P.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,S.$Sg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const $=(0,n.$Lm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,O.$jc)(this.userDataPath,"logs",$)}return d.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,S.$Sg)(d.URI.file((0,O.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,S.$Sg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,S.$Sg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,S.$Sg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const $=C.env.VSCODE_PORTABLE;return $?d.URI.file((0,O.$jc)($,"argv.json")):(0,S.$Sg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return d.URI.file((0,O.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const $=this.args["builtin-extensions-dir"];return $?(0,O.$kc)($):(0,O.$hc)((0,O.$jc)(P.$zg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const $=this.args["extensions-download-dir"];return $?d.URI.file((0,O.$kc)($)):d.URI.file((0,O.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const $=this.args["extensions-dir"];if($)return(0,O.$kc)($);const m=C.env.VSCODE_EXTENSIONS;if(m)return m;const w=C.env.VSCODE_PORTABLE;return w?(0,O.$jc)(w,"extensions"):(0,S.$Sg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const $=this.args.extensionDevelopmentPath;if(Array.isArray($))return $.map(m=>/^[^:/?#]+?:\/\//.test(m)?d.URI.parse(m):d.URI.file((0,O.$hc)(m)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map($=>$==="ui"||$==="workspace"||$==="web"?$:"workspace")}get extensionTestsLocationURI(){const $=this.args.extensionTestsPath;if($)return/^[^:/?#]+?:\/\//.test($)?d.URI.parse($):d.URI.file((0,O.$hc)($))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const $=this.args["disable-extension"];if($){if(typeof $=="string")return[$];if(Array.isArray($)&&$.length>0)return $}return!1}get debugExtensionHost(){return y(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!C.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find($=>!e.$Mm.test($))}get extensionLogLevel(){const $=[];for(const m of this.args.log||[]){const w=e.$Mm.exec(m);w&&w[1]&&w[2]&&$.push([w[1],w[2]])}return $.length?$:void 0}get serviceMachineIdResource(){return(0,S.$Sg)(d.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const $=C.env.VSCODE_PORTABLE;return $?d.URI.file((0,O.$jc)($,"policy.json")):(0,S.$Sg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn($){this.args.continueOn=$}get args(){return this.a}constructor($,m,w){this.a=$,this.b=m,this.c=w,this.editSessionId=this.args.editSessionId}}e.$Nm=c,ve([R.$Jh],c.prototype,"appRoot",null),ve([R.$Jh],c.prototype,"userHome",null),ve([R.$Jh],c.prototype,"userDataPath",null),ve([R.$Jh],c.prototype,"appSettingsHome",null),ve([R.$Jh],c.prototype,"tmpDir",null),ve([R.$Jh],c.prototype,"cacheHome",null),ve([R.$Jh],c.prototype,"stateResource",null),ve([R.$Jh],c.prototype,"userRoamingDataHome",null),ve([R.$Jh],c.prototype,"userDataSyncHome",null),ve([R.$Jh],c.prototype,"sync",null),ve([R.$Jh],c.prototype,"machineSettingsResource",null),ve([R.$Jh],c.prototype,"workspaceStorageHome",null),ve([R.$Jh],c.prototype,"localHistoryHome",null),ve([R.$Jh],c.prototype,"keyboardLayoutResource",null),ve([R.$Jh],c.prototype,"argvResource",null),ve([R.$Jh],c.prototype,"isExtensionDevelopment",null),ve([R.$Jh],c.prototype,"untitledWorkspacesHome",null),ve([R.$Jh],c.prototype,"builtinExtensionsPath",null),ve([R.$Jh],c.prototype,"extensionsPath",null),ve([R.$Jh],c.prototype,"extensionDevelopmentLocationURI",null),ve([R.$Jh],c.prototype,"extensionDevelopmentKind",null),ve([R.$Jh],c.prototype,"extensionTestsLocationURI",null),ve([R.$Jh],c.prototype,"debugExtensionHost",null),ve([R.$Jh],c.prototype,"logLevel",null),ve([R.$Jh],c.prototype,"extensionLogLevel",null),ve([R.$Jh],c.prototype,"serviceMachineIdResource",null),ve([R.$Jh],c.prototype,"disableTelemetry",null),ve([R.$Jh],c.prototype,"disableWorkspaceTrust",null),ve([R.$Jh],c.prototype,"useInMemorySecretStorage",null),ve([R.$Jh],c.prototype,"policyFile",null);function y(k,$){return v(k["inspect-extensions"],k["inspect-brk-extensions"],5870,$,k.debugId,k.extensionEnvironment)}e.$Om=y;function v(k,$,m,w,p,u){const h=Number($||k)||(w?null:m),g=h?!!$:!1;let a;if(u)try{a=JSON.parse(u)}catch{}return{port:h,break:g,debugId:p,env:a}}e.$Pm=v}),define(ae[115],ce([0,1,311,4,170]),function(X,e,n,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=void 0;const O={o:(0,P.localize)(0,null),e:(0,P.localize)(1,null),t:(0,P.localize)(2,null)};e.$7l=["tunnel","serve-web"],e.$8l={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,P.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,P.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,P.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,P.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,P.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,P.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,P.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,P.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,P.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,P.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,P.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,P.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,P.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,P.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,P.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,P.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,P.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,P.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,P.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,P.localize)(22,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,P.localize)(23,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,P.localize)(24,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,P.localize)(25,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,P.localize)(26,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,P.localize)(27,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,P.localize)(28,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,P.localize)(29,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,P.localize)(30,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,P.localize)(31,null)},sync:{type:"string",cat:"t",description:(0,P.localize)(32,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,P.localize)(33,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,P.localize)(34,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,P.localize)(35,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,P.localize)(36,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,P.localize)(37,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const C={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function S(w,p,u=C){const f=w.find(l=>l.length>0&&l[0]!=="-"),h={},g=["_"],a=[],t={};let o;for(const l in p){const b=p[l];b.type==="subcommand"?l===f&&(o=b):(b.alias&&(h[l]=b.alias),b.type==="string"||b.type==="string[]"?(g.push(l),b.deprecates&&g.push(...b.deprecates)):b.type==="boolean"&&(a.push(l),b.deprecates&&a.push(...b.deprecates)),b.global&&(t[l]=b))}if(o&&f){const l=t;for(const E in o.options)l[E]=o.options[E];const b=w.filter(E=>E!==f),D=u.getSubcommandReporter?u.getSubcommandReporter(f):void 0,j=S(b,l,D);return{[f]:j,_:[]}}const r=n(w,{string:g,boolean:a,alias:h}),i={},s=r;i._=r._.map(l=>String(l)).filter(l=>l.length>0),delete s._;for(const l in p){const b=p[l];if(b.type==="subcommand")continue;b.alias&&delete s[b.alias];let D=s[l];if(b.deprecates)for(const j of b.deprecates)s.hasOwnProperty(j)&&(D||(D=s[j],D&&u.onDeprecatedOption(j,b.deprecationMessage||(0,P.localize)(38,null,l))),delete s[j]);if(typeof D<"u"){if(b.type==="string[]"){if(Array.isArray(D)||(D=[D]),!b.allowEmptyValue){const j=D.filter(E=>E.length>0);j.length!==D.length&&(u.onEmptyValue(l),D=j.length>0?j:void 0)}}else b.type==="string"&&(Array.isArray(D)?(D=D.pop(),u.onMultipleValues(l,D)):!D&&!b.allowEmptyValue&&(u.onEmptyValue(l),D=void 0));i[l]=D,b.deprecationMessage&&u.onDeprecatedOption(l,b.deprecationMessage)}delete s[l]}for(const l in s)u.onUnknownOption(l);return i}e.$9l=S;function d(w,p){let u="";return p.args&&(Array.isArray(p.args)?u=` <${p.args.join("> <")}>`:u=` <${p.args}>`),p.alias?`-${p.alias} --${w}${u}`:`--${w}${u}`}function c(w,p){const u=[];for(const f in w){const h=w[f],g=d(f,h);u.push([g,h.description])}return y(u,p)}e.$0l=c;function y(w,p){const f=w.reduce((a,t)=>Math.max(a,t[0].length),12)+2+1;if(p-f<25)return w.reduce((a,t)=>a.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const h=p-f-1,g=[];for(const a of w){const t=a[0],o=k(a[1],h),r=v(f-t.length-2);g.push("  "+t+r+o[0]);for(let i=1;i<o.length;i++)g.push(v(f)+o[i])}return g}function v(w){return" ".repeat(w)}function k(w,p){const u=[];for(;w.length;){const f=w.length<p?w.length:w.lastIndexOf(" ",p),h=w.slice(0,f).trim();w=w.slice(f),u.push(h)}return u}function $(w,p,u,f,h){const g=process.stdout.isTTY&&process.stdout.columns||80,a=h?.noInputFiles!==!0?`[${(0,P.localize)(39,null)}...]`:"",t=[`${w} ${u}`];t.push(""),t.push(`${(0,P.localize)(40,null)}: ${p} [${(0,P.localize)(41,null)}]${a}`),t.push(""),h?.noPipe!==!0&&(R.$i?t.push((0,P.localize)(42,null,p)):t.push((0,P.localize)(43,null,p)),t.push(""));const o={},r=[];for(const i in f){const s=f[i];if(s.type==="subcommand")s.description&&r.push({command:i,description:s.description});else if(s.description&&s.cat){let l=o[s.cat];l||(o[s.cat]=l={}),l[i]=s}}for(const i in o){const s=i,l=o[s];l&&(t.push(O[s]),t.push(...c(l,g)),t.push(""))}return r.length&&(t.push((0,P.localize)(44,null)),t.push(...y(r.map(i=>[i.command,i.description]),g)),t.push("")),t.join(`
`)}e.$$l=$;function m(w,p){return`${w||(0,P.localize)(45,null)}
${p||(0,P.localize)(46,null)}
${process.arch}`}e.$_l=m}),define(ae[202],ce([0,1,88,200,115]),function(X,e,n,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i_b=void 0;class O extends R.$qo{constructor(S){super(),this.f=S}call(S,d,c){return d==="openExtensionDevelopmentHostWindow"?this.g(c[0],c[1]):super.call(S,d,c)}async g(S,d){const c=(0,P.$9l)(S,P.$8l);c.debugRenderer=d;const y=c.extensionDevelopmentPath;if(!y)return{success:!1};const[v]=await this.f.openExtensionDevelopmentHostWindow(y,{context:5,cli:c,forceProfile:c.profile,forceTempProfile:c["profile-temp"]});if(!d)return{success:!0};const k=v.win;if(!k)return{success:!0};const $=k.webContents.debugger;let m=$.isAttached()?1/0:0;const w=(0,n.createServer)(p=>{m++===0&&$.attach();let u=!1;const f=a=>{u||p.write(JSON.stringify(a)+"\0")},h=(a,t,o,r)=>f({method:t,params:o,sessionId:r});k.on("close",()=>{$.removeListener("message",h),p.end(),u=!0}),$.addListener("message",h);let g=Buffer.alloc(0);p.on("data",a=>{g=Buffer.concat([g,a]);for(let t=g.indexOf(0);t!==-1;t=g.indexOf(0)){let o;try{const r=g.slice(0,t).toString("utf8");g=g.slice(t+1),o=JSON.parse(r)}catch(r){console.error("error reading cdp line",r)}$.sendCommand(o.method,o.params,o.sessionId).then(r=>f({id:o.id,sessionId:o.sessionId,result:r})).catch(r=>f({id:o.id,sessionId:o.sessionId,error:{code:0,message:r.message}}))}}),p.on("error",a=>{console.error("error on cdp pipe:",a)}),p.on("close",()=>{u=!0,--m===0&&$.detach()})});return await new Promise(p=>w.listen(0,p)),k.on("close",()=>w.close()),{rendererDebugPort:w.address().port,success:!0}}}e.$i_b=O}),define(ae[63],ce([0,1,312,171,115]),function(X,e,n,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dm=e.$cm=e.$bm=e.$am=void 0;function O(v,k){const $=(h,g)=>{console.warn((0,R.localize)(0,null,h,g))},m=h=>{console.warn((0,R.localize)(1,null,h))},w=(h,g)=>{console.warn((0,R.localize)(2,null,h,g))},p=h=>({onUnknownOption:g=>{P.$7l.includes(h)||console.warn((0,R.localize)(3,null,g,h))},onMultipleValues:$,onEmptyValue:m,onDeprecatedOption:w,getSubcommandReporter:P.$7l.includes(h)?p:void 0}),u={onUnknownOption:h=>{console.warn((0,R.localize)(4,null,h))},onMultipleValues:$,onEmptyValue:m,onDeprecatedOption:w,getSubcommandReporter:p},f=(0,P.$9l)(v,P.$8l,k?u:void 0);return f.goto&&f._.forEach(h=>n(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(h),(0,R.localize)(5,null))),f}function C(v){const k=v.findIndex($=>!/^-/.test($));if(k>-1)return[...v.slice(0,k),...v.slice(k+1)]}function S(v){let[,...k]=v;process.env.VSCODE_DEV&&(k=C(k)||[]);const $=!y(process.env);return O(k,$)}e.$am=S;function d(v){let[,,...k]=v;return process.env.VSCODE_DEV&&(k=C(k)||[]),O(k,!0)}e.$bm=d;function c(v,...k){const $=v.indexOf("--");return $===-1?v.push(...k):v.splice($,0,...k),v}e.$cm=c;function y(v){return v.VSCODE_CLI==="1"}e.$dm=y}),function(){"use strict";function X(e,n,R){function P(C,S){const d=O(C,S),c=[d];return e.isAbsolute(d)||c.unshift(R),e.resolve(...c)}function O(C,S){process.env.VSCODE_DEV&&(S="code-oss-dev");const d=process.env.VSCODE_PORTABLE;if(d)return e.join(d,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,S);const y=C["user-data-dir"];if(y)return y;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const v=process.env.USERPROFILE;if(typeof v!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(v,"AppData","Roaming")}break;case"darwin":c=e.join(n.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(n.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,S)}return{getUserDataPath:P}}if(typeof define=="function")define(ae[203],ce([116,26,36]),function(e,n,R){return X(e,n,R.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),n=require("os");module.exports=X(e,n,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ae[91],ce([0,1,26,201,203]),function(X,e,n,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=e.$Rm=e.$Qm=void 0;class O extends R.$Nm{constructor(c,y){super(c,{homeDir:(0,n.homedir)(),tmpDir:(0,n.tmpdir)(),userDataDir:(0,P.getUserDataPath)(c,y.nameShort)},y)}}e.$Qm=O;function C(d,c){return(0,R.$Pm)(d["inspect-ptyhost"],d["inspect-brk-ptyhost"],5877,c,d.extensionEnvironment)}e.$Rm=C;function S(d,c){return(0,R.$Pm)(d["inspect-sharedprocess"],d["inspect-brk-sharedprocess"],5879,c,d.extensionEnvironment)}e.$Sm=S}),define(ae[204],ce([0,1,46,26,33]),function(X,e,n,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bac=void 0;function O(C){const S=(0,P.$ng)((0,R.tmpdir)());try{return(0,n.writeFileSync)(S,""),C&&console.log(`Marker file for --wait created: ${S}`),S}catch(d){C&&console.error(`Failed to create marker file for --wait: ${d}`);return}}e.$Bac=O}),define(ae[205],ce([0,1,12,173]),function(X,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=void 0;function P(C,S,d,c){try{O(C,S,d,c)}catch(y){C.error(y?.message??y)}return S}e.$aq=P;function O(C,S,d,c){const y=(v,k,$)=>{const m=v[k];if((0,n.$Sf)(m)){const w=m,p=w.length;if(p>1&&w[0]==="%"&&w[p-1]==="%"){const u=w.substr(1,p-2);let f=d[u];f===void 0&&c&&(f=c[u]);const h=typeof f=="string"?f:f?.message,g=c?.[u],a=typeof g=="string"?g:g?.message;if(!h){a||C.warn(`[${S.name}]: ${(0,R.localize)(0,null,u)}`);return}if($&&(k==="title"||k==="category")&&a&&a!==h){const t={value:h,original:a};v[k]=t}else v[k]=h}}else if((0,n.$Uf)(m))for(const w in m)m.hasOwnProperty(w)&&(w==="commands"?y(m,w,!0):y(m,w,$));else if(Array.isArray(m))for(let w=0;w<m.length;w++)y(m,w,$)};for(const v in S)S.hasOwnProperty(v)&&y(S,v)}}),define(ae[206],ce([0,1,19,73,175,207]),function(X,e,n,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$up=e.$tp=e.$sp=e.$rp=e.$qp=e.$pp=e.$op=void 0;const C=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function d(u){return u=u.trim(),u==="*"||C.test(u)}e.$op=d;function c(u){if(!d(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const f=u.match(C);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.$pp=c;function y(u){if(!u)return null;const f=u.majorBase,h=u.majorMustEqual,g=u.minorBase;let a=u.minorMustEqual;const t=u.patchBase;let o=u.patchMustEqual;u.hasCaret&&(f===0||(a=!1),o=!1);let r=0;if(u.preRelease){const i=S.exec(u.preRelease);if(i){const[,s,l,b]=i;r=Date.UTC(Number(s),Number(l)-1,Number(b))}}return{majorBase:f,majorMustEqual:h,minorBase:g,minorMustEqual:a,patchBase:t,patchMustEqual:o,isMinimum:u.hasGreaterEquals,notBefore:r}}e.$qp=y;function v(u,f,h){let g;typeof u=="string"?g=y(c(u)):g=u;let a;f instanceof Date?a=f.getTime():typeof f=="string"&&(a=new Date(f).getTime());let t;if(typeof h=="string"?t=y(c(h)):t=h,!g||!t)return!1;const o=g.majorBase,r=g.minorBase,i=g.patchBase;let s=t.majorBase,l=t.minorBase,b=t.patchBase;const D=t.notBefore;let j=t.majorMustEqual,E=t.minorMustEqual,I=t.patchMustEqual;return t.isMinimum?o>s?!0:o<s?!1:r>l?!0:r<l||a&&a<D?!1:i>=b:(o===1&&s===0&&(!j||!E||!I)&&(s=1,l=0,b=0,j=!0,E=!1,I=!1),o<s?!1:o>s?!j:r<l?!1:r>l?!E:i<b?!1:i>b?!I:!(a&&a<D))}e.$rp=v;function k(u,f,h,g,a){const t=[];if(typeof g.publisher<"u"&&typeof g.publisher!="string")return t.push([R.default.Error,P.localize(0,null)]),t;if(typeof g.name!="string")return t.push([R.default.Error,P.localize(1,null,"name")]),t;if(typeof g.version!="string")return t.push([R.default.Error,P.localize(2,null,"version")]),t;if(!g.engines)return t.push([R.default.Error,P.localize(3,null,"engines")]),t;if(typeof g.engines.vscode!="string")return t.push([R.default.Error,P.localize(4,null,"engines.vscode")]),t;if(typeof g.extensionDependencies<"u"&&!p(g.extensionDependencies))return t.push([R.default.Error,P.localize(5,null,"extensionDependencies")]),t;if(typeof g.activationEvents<"u"){if(!p(g.activationEvents))return t.push([R.default.Error,P.localize(6,null,"activationEvents")]),t;if(typeof g.main>"u"&&typeof g.browser>"u")return t.push([R.default.Error,P.localize(7,null,"activationEvents","main","browser")]),t}if(typeof g.extensionKind<"u"&&typeof g.main>"u"&&t.push([R.default.Warning,P.localize(8,null,"extensionKind")]),typeof g.main<"u"){if(typeof g.main!="string")return t.push([R.default.Error,P.localize(9,null,"main")]),t;{const i=(0,n.$Sg)(h,g.main);(0,n.$Mg)(i,h)||t.push([R.default.Warning,P.localize(10,null,i.path,h.path)])}}if(typeof g.browser<"u"){if(typeof g.browser!="string")return t.push([R.default.Error,P.localize(11,null,"browser")]),t;{const i=(0,n.$Sg)(h,g.browser);(0,n.$Mg)(i,h)||t.push([R.default.Warning,P.localize(12,null,i.path,h.path)])}}if(!O.valid(g.version))return t.push([R.default.Error,P.localize(13,null)]),t;const o=[];if(!$(u,f,g,a,o))for(const i of o)t.push([R.default.Error,i]);return t}e.$sp=k;function $(u,f,h,g,a){return g||typeof h.main>"u"&&typeof h.browser>"u"?!0:w(u,f,h.engines.vscode,a)}e.$tp=$;function m(u,f,h){return u==="*"||w(f,h,u)}e.$up=m;function w(u,f,h,g=[]){const a=y(c(h));if(!a)return g.push(P.localize(14,null,h)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return g.push(P.localize(15,null,h)),!1}else if(!a.majorMustEqual)return g.push(P.localize(16,null,h)),!1;return v(u,f,a)?!0:(g.push(P.localize(17,null,u,h)),!1)}function p(u){if(!Array.isArray(u))return!1;for(let f=0,h=u.length;f<h;f++)if(typeof u[f]!="string")return!1;return!0}}),define(ae[208],ce([0,1,17,32]),function(X,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=void 0;async function P(O,C,S){let d=S&&S.get("storage.serviceMachineId",-1)||null;if(d)return d;try{const y=(await C.readFile(O.serviceMachineIdResource)).value.toString();d=(0,R.$Ag)(y)?y:null}catch{d=null}if(!d){d=(0,R.$Bg)();try{await C.writeFile(O.serviceMachineIdResource,n.$se.fromString(d))}catch{}}return S?.store("storage.serviceMachineId",d,-1,1),d}e.$Op=P}),define(ae[77],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ci=void 0;class n{constructor(P,O=[],C=!1){this.ctor=P,this.staticArguments=O,this.supportsDelayedInstantiation=C}}e.$ci=n}),define(ae[209],ce([0,1,77]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bs=e.$as=e.InstantiationType=void 0;const R=[];var P;(function(S){S[S.Eager=0]="Eager",S[S.Delayed=1]="Delayed"})(P||(e.InstantiationType=P={}));function O(S,d,c){d instanceof n.$ci||(d=new n.$ci(d,[],!!c)),R.push([S,d])}e.$as=O;function C(){return R}e.$bs=C}),define(ae[210],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=e.$Qq=void 0;class n{constructor(O,C){this.key=O,this.data=C,this.incoming=new Map,this.outgoing=new Map}}e.$Qq=n;class R{constructor(O){this.b=O,this.a=new Map}roots(){const O=[];for(const C of this.a.values())C.outgoing.size===0&&O.push(C);return O}insertEdge(O,C){const S=this.lookupOrInsertNode(O),d=this.lookupOrInsertNode(C);S.outgoing.set(d.key,d),d.incoming.set(S.key,S)}removeNode(O){const C=this.b(O);this.a.delete(C);for(const S of this.a.values())S.outgoing.delete(C),S.incoming.delete(C)}lookupOrInsertNode(O){const C=this.b(O);let S=this.a.get(C);return S||(S=new n(C,O),this.a.set(C,S)),S}lookup(O){return this.a.get(this.b(O))}isEmpty(){return this.a.size===0}toString(){const O=[];for(const[C,S]of this.a)O.push(`${C}
	(-> incoming)[${[...S.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...S.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,C]of this.a){const S=new Set([O]),d=this.c(C,S);if(d)return d}}c(O,C){for(const[S,d]of O.outgoing){if(C.has(S))return[...C,S].join(" -> ");C.add(S);const c=this.c(d,C);if(c)return c;C.delete(S)}}}e.$Rq=R}),define(ae[6],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gi=e.$fi=e.$ei=e._util=void 0;var n;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function S(d){return d[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=S})(n||(e._util=n={})),e.$ei=P("instantiationService");function R(C,S,d){S[n.DI_TARGET]===S?S[n.DI_DEPENDENCIES].push({id:C,index:d}):(S[n.DI_DEPENDENCIES]=[{id:C,index:d}],S[n.DI_TARGET]=S)}function P(C){if(n.serviceIds.has(C))return n.serviceIds.get(C);const S=function(d,c,y){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(S,d,y)};return S.toString=()=>C,n.serviceIds.set(C,S),S}e.$fi=P;function O(C){return C}e.$gi=O}),define(ae[78],ce([0,1,6]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A_b=void 0,e.$A_b=(0,n.$fi)("auxiliaryWindowsMainService")}),define(ae[64],ce([0,1,6]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J$b=void 0,e.$J$b=(0,n.$fi)("backupMainService")}),define(ae[18],ce([0,1,12,7,6]),function(X,e,n,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.ConfigurationTarget=e.$Ni=e.$Mi=e.$Li=void 0,e.$Li=(0,P.$fi)("configurationService");function O(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof R.URI)}e.$Mi=O;function C(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof R.URI)}e.$Ni=C;var S;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(S||(e.ConfigurationTarget=S={}));function d(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Oi=d;function c(u){return u.applicationValue!==void 0||u.userValue!==void 0||u.userLocalValue!==void 0||u.userRemoteValue!==void 0||u.workspaceValue!==void 0||u.workspaceFolderValue!==void 0}e.$Pi=c;function y(u,f){const h=Object.create(null);for(const g in u)v(h,g,u[g],f);return h}e.$Qi=y;function v(u,f,h,g){const a=f.split("."),t=a.pop();let o=u;for(let r=0;r<a.length;r++){const i=a[r];let s=o[i];switch(typeof s){case"undefined":s=o[i]=Object.create(null);break;case"object":break;default:g(`Ignoring ${f} as ${a.slice(0,r+1).join(".")} is ${JSON.stringify(s)}`);return}o=s}if(typeof o=="object"&&o!==null)try{o[t]=h}catch{g(`Ignoring ${f} as ${a.join(".")} is ${JSON.stringify(o)}`)}else g(`Ignoring ${f} as ${a.join(".")} is ${JSON.stringify(o)}`)}e.$Ri=v;function k(u,f){const h=f.split(".");$(u,h)}e.$Si=k;function $(u,f){const h=f.shift();if(f.length===0){delete u[h];return}if(Object.keys(u).indexOf(h)!==-1){const g=u[h];typeof g=="object"&&!Array.isArray(g)&&($(g,f),Object.keys(g).length===0&&delete u[h])}}function m(u,f,h){function g(o,r){let i=o;for(const s of r){if(typeof i!="object"||i===null)return;i=i[s]}return i}const a=f.split("."),t=g(u,a);return typeof t>"u"?h:t}e.$Ti=m;function w(u,f,h){Object.keys(f).forEach(g=>{g!=="__proto__"&&(g in u?n.$Uf(u[g])&&n.$Uf(f[g])?w(u[g],f[g],h):h&&(u[g]=f[g]):u[g]=f[g])})}e.$Ui=w;function p(u){return u.replace(/[\[\]]/g,"")}e.$Vi=p}),define(ae[117],ce([0,1,4,25,199,6,166,15]),function(X,e,n,R,P,O,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.ContextKeyExprType=e.$bj=void 0;const d=new Map;d.set("false",!1),d.set("true",!0),d.set("isMac",n.$j),d.set("isLinux",n.$k),d.set("isWindows",n.$i),d.set("isWeb",n.$o),d.set("isMacNative",n.$j&&!n.$o),d.set("isEdge",n.$H),d.set("isFirefox",n.$F),d.set("isChrome",n.$E),d.set("isSafari",n.$G);function c(K,A){if(d.get(K)!==void 0)throw(0,S.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");d.set(K,A)}e.$bj=c;const y=Object.prototype.hasOwnProperty;var v;(function(K){K[K.False=0]="False",K[K.True=1]="True",K[K.Defined=2]="Defined",K[K.Not=3]="Not",K[K.Equals=4]="Equals",K[K.NotEquals=5]="NotEquals",K[K.And=6]="And",K[K.Regex=7]="Regex",K[K.NotRegex=8]="NotRegex",K[K.Or=9]="Or",K[K.In=10]="In",K[K.NotIn=11]="NotIn",K[K.Greater=12]="Greater",K[K.GreaterEquals=13]="GreaterEquals",K[K.Smaller=14]="Smaller",K[K.SmallerEquals=15]="SmallerEquals"})(v||(e.ContextKeyExprType=v={}));const k={regexParsingWithErrorRecovery:!0},$=(0,C.localize)(0,null),m=(0,C.localize)(1,null),w=(0,C.localize)(2,null),p=(0,C.localize)(3,null),u=(0,C.localize)(4,null),f=(0,C.localize)(5,null),h=(0,C.localize)(6,null),g=(0,C.localize)(7,null);class a{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(A=k){this.k=A,this.d=new P.$aj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(A){if(A===""){this.h.push({message:$,offset:0,lexeme:"",additionalInfo:m});return}this.f=this.d.reset(A).scan(),this.g=0,this.h=[];try{const F=this.l();if(!this.E()){const x=this.D(),z=x.type===17?f:void 0;throw this.h.push({message:u,offset:x.offset,lexeme:P.$aj.getLexeme(x),additionalInfo:z}),a.c}return F}catch(F){if(F!==a.c)throw F;return}}l(){return this.m()}m(){const A=[this.o()];for(;this.y(16);){const F=this.o();A.push(F)}return A.length===1?A[0]:t.or(...A)}o(){const A=[this.s()];for(;this.y(15);){const F=this.s();A.push(F)}return A.length===1?A[0]:t.and(...A)}s(){if(this.y(2)){const A=this.D();switch(A.type){case 11:return this.z(),s.INSTANCE;case 12:return this.z(),l.INSTANCE;case 0:{this.z();const F=this.l();return this.A(1,p),F?.negate()}case 17:return this.z(),M.create(A.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",A)}}return this.t()}t(){const A=this.D();switch(A.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const F=this.l();return this.A(1,p),F}case 17:{const F=A.lexeme;if(this.z(),this.y(9)){const z=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),z.type!==10)throw this.B("REGEX",z);const Z=z.lexeme,H=Z.lastIndexOf("/"),_=H===Z.length-1?void 0:this.w(Z.substring(H+1));let B;try{B=new RegExp(Z.substring(1,H),_)}catch{throw this.B("REGEX",z)}return re.create(F,B)}switch(z.type){case 10:case 19:{const Z=[z.lexeme];this.z();let H=this.D(),_=0;for(let me=0;me<z.lexeme.length;me++)z.lexeme.charCodeAt(me)===40?_++:z.lexeme.charCodeAt(me)===41&&_--;for(;!this.E()&&H.type!==15&&H.type!==16;){switch(H.type){case 0:_++;break;case 1:_--;break;case 10:case 18:for(let me=0;me<H.lexeme.length;me++)H.lexeme.charCodeAt(me)===40?_++:z.lexeme.charCodeAt(me)===41&&_--}if(_<0)break;Z.push(P.$aj.getLexeme(H)),this.z(),H=this.D()}const B=Z.join(""),ee=B.lastIndexOf("/"),ie=ee===B.length-1?void 0:this.w(B.substring(ee+1));let de;try{de=new RegExp(B.substring(1,ee),ie)}catch{throw this.B("REGEX",z)}return t.regex(F,de)}case 18:{const Z=z.lexeme;this.z();let H=null;if(!(0,R.$Se)(Z)){const _=Z.indexOf("/"),B=Z.lastIndexOf("/");if(_!==B&&_>=0){const ee=Z.slice(_+1,B),ie=Z[B+1]==="i"?"i":"";try{H=new RegExp(ee,ie)}catch{throw this.B("REGEX",z)}}}if(H===null)throw this.B("REGEX",z);return re.create(F,H)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,w);const z=this.u();return t.notIn(F,z)}switch(this.D().type){case 3:{this.z();const z=this.u();if(this.x().type===18)return t.equals(F,z);switch(z){case"true":return t.has(F);case"false":return t.not(F);default:return t.equals(F,z)}}case 4:{this.z();const z=this.u();if(this.x().type===18)return t.notEquals(F,z);switch(z){case"true":return t.not(F);case"false":return t.has(F);default:return t.notEquals(F,z)}}case 5:return this.z(),J.create(F,this.u());case 6:return this.z(),le.create(F,this.u());case 7:return this.z(),W.create(F,this.u());case 8:return this.z(),V.create(F,this.u());case 13:return this.z(),t.in(F,this.u());default:return t.has(F)}}case 20:throw this.h.push({message:h,offset:A.offset,lexeme:"",additionalInfo:g}),a.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const A=this.D();switch(A.type){case 17:case 18:return this.z(),A.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(A){return A.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(A){return this.C(A)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(A,F){if(this.C(A))return this.z();throw this.B(F,this.D())}B(A,F,x){const z=(0,C.localize)(8,null,A,P.$aj.getLexeme(F)),Z=F.offset,H=P.$aj.getLexeme(F);return this.h.push({message:z,offset:Z,lexeme:H,additionalInfo:x}),a.c}C(A){return this.D().type===A}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$cj=a;class t{static false(){return s.INSTANCE}static true(){return l.INSTANCE}static has(A){return b.create(A)}static equals(A,F){return D.create(A,F)}static notEquals(A,F){return I.create(A,F)}static regex(A,F){return re.create(A,F)}static in(A,F){return j.create(A,F)}static notIn(A,F){return E.create(A,F)}static not(A){return M.create(A)}static and(...A){return Y.create(A,null,!0)}static or(...A){return U.create(A,null,!0)}static greater(A,F){return W.create(A,F)}static greaterEquals(A,F){return V.create(A,F)}static smaller(A,F){return J.create(A,F)}static smallerEquals(A,F){return le.create(A,F)}static{this.c=new a({regexParsingWithErrorRecovery:!1})}static deserialize(A){return A==null?void 0:this.c.parse(A)}}e.$dj=t;function o(K){const A=new a({regexParsingWithErrorRecovery:!1});return K.map(F=>(A.parse(F),A.lexingErrors.length>0?A.lexingErrors.map(x=>({errorMessage:x.additionalInfo?(0,C.localize)(9,null,x.additionalInfo):(0,C.localize)(10,null),offset:x.offset,length:x.lexeme.length})):A.parsingErrors.length>0?A.parsingErrors.map(x=>({errorMessage:x.additionalInfo?`${x.message}. ${x.additionalInfo}`:x.message,offset:x.offset,length:x.lexeme.length})):[]))}e.$ej=o;function r(K,A){const F=K?K.substituteConstants():void 0,x=A?A.substituteConstants():void 0;return!F&&!x?!0:!F||!x?!1:F.equals(x)}e.$fj=r;function i(K,A){return K.cmp(A)}class s{static{this.INSTANCE=new s}constructor(){this.type=0}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!1}serialize(){return"false"}keys(){return[]}map(A){return this}negate(){return l.INSTANCE}}e.$gj=s;class l{static{this.INSTANCE=new l}constructor(){this.type=1}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!0}serialize(){return"true"}keys(){return[]}map(A){return this}negate(){return s.INSTANCE}}e.$hj=l;class b{static create(A,F=null){const x=d.get(A);return typeof x=="boolean"?x?l.INSTANCE:s.INSTANCE:new b(A,F)}constructor(A,F){this.key=A,this.c=F,this.type=2}cmp(A){return A.type!==this.type?this.type-A.type:N(this.key,A.key)}equals(A){return A.type===this.type?this.key===A.key:!1}substituteConstants(){const A=d.get(this.key);return typeof A=="boolean"?A?l.INSTANCE:s.INSTANCE:this}evaluate(A){return!!A.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(A){return A.mapDefined(this.key)}negate(){return this.c||(this.c=M.create(this.key,this)),this.c}}e.$ij=b;class D{static create(A,F,x=null){if(typeof F=="boolean")return F?b.create(A,x):M.create(A,x);const z=d.get(A);return typeof z=="boolean"?F===(z?"true":"false")?l.INSTANCE:s.INSTANCE:new D(A,F,x)}constructor(A,F,x){this.c=A,this.d=F,this.f=x,this.type=4}cmp(A){return A.type!==this.type?this.type-A.type:G(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){const A=d.get(this.c);if(typeof A=="boolean"){const F=A?"true":"false";return this.d===F?l.INSTANCE:s.INSTANCE}return this}evaluate(A){return A.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(A){return A.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$jj=D;class j{static create(A,F){return new j(A,F)}constructor(A,F){this.d=A,this.f=F,this.type=10,this.c=null}cmp(A){return A.type!==this.type?this.type-A.type:G(this.d,this.f,A.d,A.f)}equals(A){return A.type===this.type?this.d===A.d&&this.f===A.f:!1}substituteConstants(){return this}evaluate(A){const F=A.getValue(this.f),x=A.getValue(this.d);return Array.isArray(F)?F.includes(x):typeof x=="string"&&typeof F=="object"&&F!==null?y.call(F,x):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(A){return A.mapIn(this.d,this.f)}negate(){return this.c||(this.c=E.create(this.d,this.f)),this.c}}e.$kj=j;class E{static create(A,F){return new E(A,F)}constructor(A,F){this.d=A,this.f=F,this.type=11,this.c=j.create(A,F)}cmp(A){return A.type!==this.type?this.type-A.type:this.c.cmp(A.c)}equals(A){return A.type===this.type?this.c.equals(A.c):!1}substituteConstants(){return this}evaluate(A){return!this.c.evaluate(A)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(A){return A.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$lj=E;class I{static create(A,F,x=null){if(typeof F=="boolean")return F?M.create(A,x):b.create(A,x);const z=d.get(A);return typeof z=="boolean"?F===(z?"true":"false")?s.INSTANCE:l.INSTANCE:new I(A,F,x)}constructor(A,F,x){this.c=A,this.d=F,this.f=x,this.type=5}cmp(A){return A.type!==this.type?this.type-A.type:G(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){const A=d.get(this.c);if(typeof A=="boolean"){const F=A?"true":"false";return this.d===F?s.INSTANCE:l.INSTANCE}return this}evaluate(A){return A.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(A){return A.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$mj=I;class M{static create(A,F=null){const x=d.get(A);return typeof x=="boolean"?x?s.INSTANCE:l.INSTANCE:new M(A,F)}constructor(A,F){this.c=A,this.d=F,this.type=3}cmp(A){return A.type!==this.type?this.type-A.type:N(this.c,A.c)}equals(A){return A.type===this.type?this.c===A.c:!1}substituteConstants(){const A=d.get(this.c);return typeof A=="boolean"?A?s.INSTANCE:l.INSTANCE:this}evaluate(A){return!A.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(A){return A.mapNot(this.c)}negate(){return this.d||(this.d=b.create(this.c,this)),this.d}}e.$nj=M;function T(K,A){if(typeof K=="string"){const F=parseFloat(K);isNaN(F)||(K=F)}return typeof K=="string"||typeof K=="number"?A(K):s.INSTANCE}class W{static create(A,F,x=null){return T(F,z=>new W(A,z,x))}constructor(A,F,x){this.c=A,this.d=F,this.f=x,this.type=12}cmp(A){return A.type!==this.type?this.type-A.type:G(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(A){return A.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=le.create(this.c,this.d,this)),this.f}}e.$oj=W;class V{static create(A,F,x=null){return T(F,z=>new V(A,z,x))}constructor(A,F,x){this.c=A,this.d=F,this.f=x,this.type=13}cmp(A){return A.type!==this.type?this.type-A.type:G(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(A){return A.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=J.create(this.c,this.d,this)),this.f}}e.$pj=V;class J{static create(A,F,x=null){return T(F,z=>new J(A,z,x))}constructor(A,F,x){this.c=A,this.d=F,this.f=x,this.type=14}cmp(A){return A.type!==this.type?this.type-A.type:G(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(A){return A.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$qj=J;class le{static create(A,F,x=null){return T(F,z=>new le(A,z,x))}constructor(A,F,x){this.c=A,this.d=F,this.f=x,this.type=15}cmp(A){return A.type!==this.type?this.type-A.type:G(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(A){return A.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$rj=le;class re{static create(A,F){return new re(A,F)}constructor(A,F){this.d=A,this.f=F,this.type=7,this.c=null}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.d<A.d)return-1;if(this.d>A.d)return 1;const F=this.f?this.f.source:"",x=A.f?A.f.source:"";return F<x?-1:F>x?1:0}equals(A){if(A.type===this.type){const F=this.f?this.f.source:"",x=A.f?A.f.source:"";return this.d===A.d&&F===x}return!1}substituteConstants(){return this}evaluate(A){const F=A.getValue(this.d);return this.f?this.f.test(F):!1}serialize(){const A=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${A}`}keys(){return[this.d]}map(A){return A.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ue.create(this)),this.c}}e.$sj=re;class ue{static create(A){return new ue(A)}constructor(A){this.c=A,this.type=8}cmp(A){return A.type!==this.type?this.type-A.type:this.c.cmp(A.c)}equals(A){return A.type===this.type?this.c.equals(A.c):!1}substituteConstants(){return this}evaluate(A){return!this.c.evaluate(A)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(A){return new ue(this.c.map(A))}negate(){return this.c}}e.$tj=ue;function Q(K){let A=null;for(let F=0,x=K.length;F<x;F++){const z=K[F].substituteConstants();if(K[F]!==z&&A===null){A=[];for(let Z=0;Z<F;Z++)A[Z]=K[Z]}A!==null&&(A[F]=z)}return A===null?K:A}class Y{static create(A,F,x){return Y.d(A,F,x)}constructor(A,F){this.expr=A,this.c=F,this.type=6}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let F=0,x=this.expr.length;F<x;F++){const z=i(this.expr[F],A.expr[F]);if(z!==0)return z}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let F=0,x=this.expr.length;F<x;F++)if(!this.expr[F].equals(A.expr[F]))return!1;return!0}return!1}substituteConstants(){const A=Q(this.expr);return A===this.expr?this:Y.create(A,this.c,!1)}evaluate(A){for(let F=0,x=this.expr.length;F<x;F++)if(!this.expr[F].evaluate(A))return!1;return!0}static d(A,F,x){const z=[];let Z=!1;for(const H of A)if(H){if(H.type===1){Z=!0;continue}if(H.type===0)return s.INSTANCE;if(H.type===6){z.push(...H.expr);continue}z.push(H)}if(z.length===0&&Z)return l.INSTANCE;if(z.length!==0){if(z.length===1)return z[0];z.sort(i);for(let H=1;H<z.length;H++)z[H-1].equals(z[H])&&(z.splice(H,1),H--);if(z.length===1)return z[0];for(;z.length>1;){const H=z[z.length-1];if(H.type!==9)break;z.pop();const _=z.pop(),B=z.length===0,ee=U.create(H.expr.map(ie=>Y.create([ie,_],null,x)),null,B);ee&&(z.push(ee),z.sort(i))}if(z.length===1)return z[0];if(x){for(let H=0;H<z.length;H++)for(let _=H+1;_<z.length;_++)if(z[H].negate().equals(z[_]))return s.INSTANCE;if(z.length===1)return z[0]}return new Y(z,F)}}serialize(){return this.expr.map(A=>A.serialize()).join(" && ")}keys(){const A=[];for(const F of this.expr)A.push(...F.keys());return A}map(A){return new Y(this.expr.map(F=>F.map(A)),null)}negate(){if(!this.c){const A=[];for(const F of this.expr)A.push(F.negate());this.c=U.create(A,this,!0)}return this.c}}e.$uj=Y;class U{static create(A,F,x){return U.d(A,F,x)}constructor(A,F){this.expr=A,this.c=F,this.type=9}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let F=0,x=this.expr.length;F<x;F++){const z=i(this.expr[F],A.expr[F]);if(z!==0)return z}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let F=0,x=this.expr.length;F<x;F++)if(!this.expr[F].equals(A.expr[F]))return!1;return!0}return!1}substituteConstants(){const A=Q(this.expr);return A===this.expr?this:U.create(A,this.c,!1)}evaluate(A){for(let F=0,x=this.expr.length;F<x;F++)if(this.expr[F].evaluate(A))return!0;return!1}static d(A,F,x){let z=[],Z=!1;if(A){for(let H=0,_=A.length;H<_;H++){const B=A[H];if(B){if(B.type===0){Z=!0;continue}if(B.type===1)return l.INSTANCE;if(B.type===9){z=z.concat(B.expr);continue}z.push(B)}}if(z.length===0&&Z)return s.INSTANCE;z.sort(i)}if(z.length!==0){if(z.length===1)return z[0];for(let H=1;H<z.length;H++)z[H-1].equals(z[H])&&(z.splice(H,1),H--);if(z.length===1)return z[0];if(x){for(let H=0;H<z.length;H++)for(let _=H+1;_<z.length;_++)if(z[H].negate().equals(z[_]))return l.INSTANCE;if(z.length===1)return z[0]}return new U(z,F)}}serialize(){return this.expr.map(A=>A.serialize()).join(" || ")}keys(){const A=[];for(const F of this.expr)A.push(...F.keys());return A}map(A){return new U(this.expr.map(F=>F.map(A)),null)}negate(){if(!this.c){const A=[];for(const F of this.expr)A.push(F.negate());for(;A.length>1;){const F=A.shift(),x=A.shift(),z=[];for(const Z of he(F))for(const H of he(x))z.push(Y.create([Z,H],null,!1));A.unshift(U.create(z,null,!1))}this.c=U.create(A,this,!0)}return this.c}}e.$vj=U;class L extends b{static{this.d=[]}static all(){return L.d.values()}constructor(A,F,x){super(A,null),this.f=F,typeof x=="object"?L.d.push({...x,key:A}):x!==!0&&L.d.push({key:A,description:x,type:F!=null?typeof F:void 0})}bindTo(A){return A.createKey(this.key,this.f)}getValue(A){return A.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(A){return D.create(this.key,A)}notEqualsTo(A){return I.create(this.key,A)}}e.$wj=L,e.$xj=(0,O.$fi)("contextKeyService");function N(K,A){return K<A?-1:K>A?1:0}function G(K,A,F,x){return K<F?-1:K>F?1:A<x?-1:A>x?1:0}function q(K,A){if(K.type===0||A.type===1)return!0;if(K.type===9)return A.type===9?oe(K.expr,A.expr):!1;if(A.type===9){for(const F of A.expr)if(q(K,F))return!0;return!1}if(K.type===6){if(A.type===6)return oe(A.expr,K.expr);for(const F of K.expr)if(q(F,A))return!0;return!1}return K.equals(A)}e.$yj=q;function oe(K,A){let F=0,x=0;for(;F<K.length&&x<A.length;){const z=K[F].cmp(A[x]);if(z<0)return!1;z===0&&F++,x++}return F===K.length}function he(K){return K.type===9?K.expr:[K]}}),define(ae[92],ce([0,1,6]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zm=e.$Ym=e.$Xm=e.ID=void 0,e.ID="diagnosticsService",e.$Xm=(0,n.$fi)(e.ID);function R(O){return!!O.hostName&&!!O.errorMessage}e.$Ym=R;class P{async getPerformanceInfo(C,S){return{}}async getSystemInfo(C,S){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(C,S){return""}async getWorkspaceFileExtensions(C){return{extensions:[]}}async reportWorkspaceStats(C){}}e.$Zm=P}),define(ae[118],ce([0,1,19,73,168,6,47,4,35]),function(X,e,n,R,P,O,C,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mw=e.$lw=e.ConfirmResult=e.$kw=e.$jw=e.$iw=void 0,e.$iw=(0,O.$fi)("dialogService");var c;(function(w){w[w.Confirmation=1]="Confirmation",w[w.Prompt=2]="Prompt",w[w.Input=3]="Input"})(c||(c={}));class y{a(p){return this.d(p,c.Confirmation)}b(p){return this.d(p,c.Prompt)}c(p){return this.d(p,c.Input)}d(p,u){const f=[];switch(u){case c.Confirmation:{const h=p;h.primaryButton?f.push(h.primaryButton):f.push((0,P.localize)(0,null)),h.cancelButton?f.push(h.cancelButton):f.push((0,P.localize)(1,null));break}case c.Prompt:{const h=p;Array.isArray(h.buttons)&&h.buttons.length>0&&f.push(...h.buttons.map(g=>g.label)),h.cancelButton&&(h.cancelButton===!0?f.push((0,P.localize)(2,null)):typeof h.cancelButton=="string"?f.push(h.cancelButton):h.cancelButton.label?f.push(h.cancelButton.label):f.push((0,P.localize)(3,null))),f.length===0&&f.push((0,P.localize)(4,null));break}case c.Input:{const h=p;h.primaryButton?f.push(h.primaryButton):f.push((0,P.localize)(5,null)),h.cancelButton?f.push(h.cancelButton):f.push((0,P.localize)(6,null));break}}return f}e(p){if(typeof p=="string")return p;if(typeof p=="number")return p===R.default.Info?"info":p===R.default.Error?"error":p===R.default.Warning?"warning":"none"}f(p,u,f){const h=[...p.buttons??[]];p.cancelButton&&typeof p.cancelButton!="string"&&typeof p.cancelButton!="boolean"&&h.push(p.cancelButton);let g=h[u]?.run({checkboxChecked:f});return g instanceof Promise||(g=Promise.resolve(g)),{result:g,checkboxChecked:f}}}e.$jw=y,e.$kw=(0,O.$fi)("fileDialogService");var v;(function(w){w[w.SAVE=0]="SAVE",w[w.DONT_SAVE=1]="DONT_SAVE",w[w.CANCEL=2]="CANCEL"})(v||(e.ConfirmResult=v={}));const k=10;function $(w){const p=[];return p.push(...w.slice(0,k).map(u=>typeof u=="string"?u:(0,n.$Pg)(u))),w.length>k&&(w.length-k===1?p.push((0,P.localize)(7,null)):p.push((0,P.localize)(8,null,w.length-k))),p.push(""),p.join(`
`)}e.$lw=$;function m(w,p){const u=(0,d.$Kn)(w);let f=(u.buttons??[]).map(t=>(0,C.$fw)(t)),h=(w.buttons||[]).map((t,o)=>o),g=0,a=u.cancelId??f.length-1;if(f.length>1){const t=typeof a=="number"?f[a]:void 0;if(S.$k||S.$j){if(typeof t=="string"&&f.length>1&&a!==1){f.splice(a,1),f.splice(1,0,t);const o=h[a];h.splice(a,1),h.splice(1,0,o),a=1}S.$k&&f.length>1&&(f=f.reverse(),h=h.reverse(),g=f.length-1,typeof t=="string"&&(a=g-1))}else if(S.$i&&typeof t=="string"&&f.length>1&&a!==f.length-1){f.splice(a,1),f.push(t);const o=h[a];h.splice(a,1),h.push(o),a=f.length-1}}return u.buttons=f,u.defaultId=g,u.cancelId=a,u.noLink=!0,u.title=u.title||p.nameLong,{options:u,buttonIndeces:h}}e.$mw=m}),define(ae[119],ce([0,1,6]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vW=e.$uW=e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$tW=e.$sW=void 0,e.$sW=(0,n.$fi)("encryptionService"),e.$tW=(0,n.$fi)("encryptionMainService");var R;(function(S){S.kwallet="kwallet",S.kwallet5="kwallet5",S.gnomeLibsecret="gnome-libsecret",S.basic="basic"})(R||(e.PasswordStoreCLIOption=R={}));var P;(function(S){S.unknown="unknown",S.basicText="basic_text",S.gnomeAny="gnome_any",S.gnomeLibsecret="gnome_libsecret",S.gnomeKeyring="gnome_keyring",S.kwallet="kwallet",S.kwallet5="kwallet5",S.kwallet6="kwallet6",S.dplib="dpapi",S.keychainAccess="keychain_access"})(P||(e.KnownStorageProvider=P={}));function O(S){return S==="kwallet"||S==="kwallet5"||S==="kwallet6"}e.$uW=O;function C(S){return S==="gnome_any"||S==="gnome_libsecret"||S==="gnome_keyring"}e.$vW=C}),define(ae[38],ce([0,1,6]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ni=e.$mi=void 0,e.$mi=(0,n.$fi)("environmentService"),e.$ni=(0,n.$gi)(e.$mi)}),define(ae[120],ce([0,1,172,6]),function(X,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.ExtensionGalleryErrorCode=e.$Oo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$No=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=void 0,e.$Bo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Co=new RegExp(e.$Bo),e.$Do="__web_extension",e.$Eo="skipWalkthrough",e.$Fo="extensionsSync",e.$Go="dependecyOrPackExtensionInstall";function P(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Ho=P;function O(h){switch(h){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Io=O;function C(h,g){switch(h){case 3:return g==="x64"?"win32-x64":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Jo=C;function S(h,g){return g==="web"&&!h.includes("web")}e.$Ko=S;function d(h,g,a){return S(g,a)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===a}e.$Lo=d;function c(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.$Mo=c;var y;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(y||(e.SortBy=y={}));var v;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(v||(e.SortOrder=v={}));var k;(function(h){h.Install="install",h.Uninstall="uninstall"})(k||(e.StatisticType=k={}));var $;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})($||(e.InstallOperation=$={})),e.$No=(0,R.$fi)("extensionGalleryService");var m;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.DownloadSignature="DownloadSignature",h.UpdateMetadata="UpdateMetadata",h.Extract="Extract",h.Scanning="Scanning",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Signature="Signature",h.NotAllowed="NotAllowed",h.Gallery="Gallery",h.Unknown="Unknown",h.Internal="Internal"})(m||(e.ExtensionManagementErrorCode=m={}));var w;(function(h){h.UnknownError="UnknownError",h.PackageIsInvalidZip="PackageIsInvalidZip",h.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(w||(e.ExtensionSignaturetErrorCode=w={}));class p extends Error{constructor(g,a){super(g),this.code=a,this.name=a}}e.$Oo=p;var u;(function(h){h.Timeout="Timeout",h.Cancelled="Cancelled",h.Failed="Failed"})(u||(e.ExtensionGalleryErrorCode=u={}));class f extends Error{constructor(g,a){super(g),this.code=a,this.name=a}}e.$Po=f,e.$Qo=(0,R.$fi)("extensionManagementService"),e.$Ro="extensionsIdentifiers/disabled",e.$So="extensionsIdentifiers/enabled",e.$To=(0,R.$fi)("IGlobalExtensionEnablementService"),e.$Uo=(0,R.$fi)("IExtensionTipsService"),e.$Vo=(0,n.localize2)(0,"Extensions"),e.$Wo=(0,n.localize2)(1,"Preferences")}),define(ae[211],ce([0,1,6]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q_b=e.$p_b=void 0,e.$p_b=(0,n.$fi)("extensionHostStarter"),e.$q_b="extensionHostStarter"}),define(ae[212],ce([0,1,6]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x4b=e.$w4b=void 0,e.$w4b=(0,n.$fi)("externalTerminal"),e.$x4b="Terminal.app"}),define(ae[213],ce([0,1,6]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s_b=void 0,e.$s_b=(0,n.$fi)("externalTerminal")}),define(ae[214],ce([0,1,48,50,13,9,4,75,21,90,176,212]),function(X,e,n,R,P,O,C,S,d,c,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v_b=e.$u_b=e.$t_b=void 0;const k=y.localize(0,null);class ${async getDefaultTerminalForPlatforms(){return{windows:m.getDefaultTerminalWindows(),linux:await p.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class m extends ${static{this.b="cmd.exe"}openTerminal(a,t){return this.spawnTerminal(n,a,c.$4l(),t)}spawnTerminal(a,t,o,r){const i=t.windowsExec||m.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const s=O.$nc(i,".exe").toLowerCase();if(s==="cmder")return a.spawn(i,r?[r]:void 0),Promise.resolve(void 0);const l=["/c","start","/wait"];return i.indexOf(" ")>=0&&l.push('""'),l.push(i),s==="wt"&&l.push("-d ."),new Promise((b,D)=>{const j=u(process),E=a.spawn(o,l,{cwd:r,env:j,detached:!0});E.on("error",D),E.on("exit",()=>b())})}async runInTerminal(a,t,o,r,i){const s="windowsExec"in i&&i.windowsExec?i.windowsExec:m.getDefaultTerminalWindows(),l=await m.f();return new Promise((b,D)=>{const j=`"${t} - ${k}"`,E=`"${o.join('" "')}" & pause`,I=Object.assign({},u(process),r);Object.keys(I).filter(J=>I[J]===null).forEach(J=>delete I[J]);const M={cwd:t,env:I,windowsVerbatimArguments:!0};let T,W;O.$nc(s,".exe")==="wt"?(T=s,W=["-d",".",m.b,"/c",E]):l?(T=l,W=["-d",".",s,"/c",E]):(T=m.b,W=["/c","start",j,"/wait",s,"/c",`"${E}"`]),n.spawn(T,W,M).on("error",J=>{D(f(J))}),b(void 0)})}static getDefaultTerminalWindows(){if(!m.d){const a=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");m.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${a?"Sysnative":"System32"}\\cmd.exe`}return m.d}static async f(){try{const a=await c.win32.findExecutable("wt");return await d.Promises.exists(a)?a:void 0}catch{return}}}e.$t_b=m,ve([R.$Jh],m,"f",null);class w extends ${static{this.b="/usr/bin/osascript"}openTerminal(a,t){return this.spawnTerminal(n,a,t)}runInTerminal(a,t,o,r,i){const s=i.osxExec||v.$x4b;return new Promise((l,b)=>{if(s===v.$x4b||s==="iTerm.app"){const D=s===v.$x4b?"TerminalHelper":"iTermHelper",E=[P.$zg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${D}.scpt`).fsPath,"-t",a||k,"-w",t];for(const T of o)E.push("-a"),E.push(T);if(r){const T=Object.assign({},u(process),r);for(const W in T){const V=T[W];V===null?(E.push("-u"),E.push(W)):(E.push("-e"),E.push(`${W}=${V}`))}}let I="";const M=n.spawn(w.b,E);M.on("error",T=>{b(f(T))}),M.stderr.on("data",T=>{I+=T.toString()}),M.on("exit",T=>{if(T===0)l(void 0);else if(I){const W=I.split(`
`,1);b(new Error(W[0]))}else b(new Error(y.localize(1,null,D,T)))})}else b(new Error(y.localize(2,null,s)))})}spawnTerminal(a,t,o){const r=t.osxExec||v.$x4b;return new Promise((i,s)=>{const l=["-a",r];o&&l.push(o);const b=u(process),D=a.spawn("/usr/bin/open",l,{cwd:o,env:b});D.on("error",s),D.on("exit",()=>i())})}}e.$u_b=w;class p extends ${static{this.b=y.localize(3,null)}openTerminal(a,t){return this.spawnTerminal(n,a,t)}runInTerminal(a,t,o,r,i){const s=i.linuxExec?Promise.resolve(i.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((l,b)=>{const D=[];s.then(j=>{j.indexOf("gnome-terminal")>=0?D.push("-x"):D.push("-e"),D.push("bash"),D.push("-c");const E=`${h(o)}; echo; read -p "${p.b}" -n1;`;D.push(`''${E}''`);const I=Object.assign({},u(process),r);Object.keys(I).filter(V=>I[V]===null).forEach(V=>delete I[V]);const M={cwd:t,env:I};let T="";const W=n.spawn(j,D,M);W.on("error",V=>{b(f(V))}),W.stderr.on("data",V=>{T+=V.toString()}),W.on("exit",V=>{if(V===0)l(void 0);else if(T){const J=T.split(`
`,1);b(new Error(J[0]))}else b(new Error(y.localize(4,null,j,V)))})})})}static async getDefaultTerminalLinuxReady(){if(!p.d)if(!C.$k)p.d=Promise.resolve("xterm");else{const a=await d.Promises.exists("/etc/debian_version");p.d=new Promise(t=>{a?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return p.d}spawnTerminal(a,t,o){const r=t.linuxExec?Promise.resolve(t.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((i,s)=>{r.then(l=>{const b=u(process),D=a.spawn(l,[],{cwd:o,env:b});D.on("error",s),D.on("exit",()=>i())})})}}e.$v_b=p;function u(g){const a={...g.env};return(0,S.$2l)(a),a}function f(g){return"errno"in g&&g.errno==="ENOENT"&&"path"in g&&typeof g.path=="string"?new Error(y.localize(5,null,g.path)):g}function h(g){let a="";for(const t of g)t.indexOf(" ")>=0?a+='"'+t+'"':a+=t,a+=" ";return a}}),define(ae[16],ce([0,1,59,9,25,12,7,178,6,4,13,61]),function(X,e,n,R,P,O,C,S,d,c,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cl=e.$bl=e.$al=e.$_k=e.$$k=e.FileKind=e.$0k=e.$9k=e.$8k=e.$7k=e.$6k=e.$5k=e.$4k=e.FileOperationResult=e.$3k=e.$2k=e.$1k=e.$Zk=e.$Yk=e.FileChangeType=e.$Xk=e.FileOperation=e.$Wk=e.$Vk=e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.FileSystemProviderErrorCode=e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.$Ik=e.FileSystemProviderCapabilities=e.$Hk=e.FilePermission=e.FileType=e.$Gk=e.$Fk=void 0,e.$Fk=(0,d.$fi)("fileService");function k(q){return q.create===!0}e.$Gk=k;var $;(function(q){q[q.Unknown=0]="Unknown",q[q.File=1]="File",q[q.Directory=2]="Directory",q[q.SymbolicLink=64]="SymbolicLink"})($||(e.FileType=$={}));var m;(function(q){q[q.Readonly=1]="Readonly",q[q.Locked=2]="Locked"})(m||(e.FilePermission=m={}));function w(q){const oe=q;return!!oe&&typeof oe.onDidChange=="function"}e.$Hk=w;var p;(function(q){q[q.None=0]="None",q[q.FileReadWrite=2]="FileReadWrite",q[q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",q[q.FileReadStream=16]="FileReadStream",q[q.FileFolderCopy=8]="FileFolderCopy",q[q.PathCaseSensitive=1024]="PathCaseSensitive",q[q.Readonly=2048]="Readonly",q[q.Trash=4096]="Trash",q[q.FileWriteUnlock=8192]="FileWriteUnlock",q[q.FileAtomicRead=16384]="FileAtomicRead",q[q.FileAtomicWrite=32768]="FileAtomicWrite",q[q.FileAtomicDelete=65536]="FileAtomicDelete",q[q.FileClone=131072]="FileClone"})(p||(e.FileSystemProviderCapabilities=p={}));function u(q){return!!(q.capabilities&2)}e.$Ik=u;function f(q){return!!(q.capabilities&8)}e.$Jk=f;function h(q){return!!(q.capabilities&131072)}e.$Kk=h;function g(q){return!!(q.capabilities&4)}e.$Lk=g;function a(q){return!!(q.capabilities&16)}e.$Mk=a;function t(q){return u(q)?!!(q.capabilities&16384):!1}e.$Nk=t;function o(q){return u(q)?!!(q.capabilities&32768):!1}e.$Ok=o;function r(q){return!!(q.capabilities&65536)}e.$Pk=r;function i(q){return!!(q.capabilities&2048)}e.$Qk=i;var s;(function(q){q.FileExists="EntryExists",q.FileNotFound="EntryNotFound",q.FileNotADirectory="EntryNotADirectory",q.FileIsADirectory="EntryIsADirectory",q.FileExceedsStorageQuota="EntryExceedsStorageQuota",q.FileTooLarge="EntryTooLarge",q.FileWriteLocked="EntryWriteLocked",q.NoPermissions="NoPermissions",q.Unavailable="Unavailable",q.Unknown="Unknown"})(s||(e.FileSystemProviderErrorCode=s={}));class l extends Error{static create(oe,he){const K=new l(oe.toString(),he);return j(K,he),K}constructor(oe,he){super(oe),this.code=he}}e.$Rk=l;function b(q,oe){return l.create(q,oe)}e.$Sk=b;function D(q){return q||b((0,S.localize)(0,null),s.Unknown)}e.$Tk=D;function j(q,oe){return q.name=oe?`${oe} (FileSystemError)`:"FileSystemError",q}e.$Uk=j;function E(q){if(!q)return s.Unknown;if(q instanceof l)return q.code;const oe=/^(.+) \(FileSystemError\)$/.exec(q.name);if(!oe)return s.Unknown;switch(oe[1]){case s.FileExists:return s.FileExists;case s.FileIsADirectory:return s.FileIsADirectory;case s.FileNotADirectory:return s.FileNotADirectory;case s.FileNotFound:return s.FileNotFound;case s.FileTooLarge:return s.FileTooLarge;case s.FileWriteLocked:return s.FileWriteLocked;case s.NoPermissions:return s.NoPermissions;case s.Unavailable:return s.Unavailable}return s.Unknown}e.$Vk=E;function I(q){if(q instanceof le)return q.fileOperationResult;switch(E(q)){case s.FileNotFound:return 1;case s.FileIsADirectory:return 0;case s.FileNotADirectory:return 9;case s.FileWriteLocked:return 5;case s.NoPermissions:return 6;case s.FileExists:return 4;case s.FileTooLarge:return 7;default:return 10}}e.$Wk=I;var M;(function(q){q[q.CREATE=0]="CREATE",q[q.DELETE=1]="DELETE",q[q.MOVE=2]="MOVE",q[q.COPY=3]="COPY",q[q.WRITE=4]="WRITE"})(M||(e.FileOperation=M={}));class T{constructor(oe,he,K){this.resource=oe,this.operation=he,this.target=K}isOperation(oe){return this.operation===oe}}e.$Xk=T;var W;(function(q){q[q.UPDATED=0]="UPDATED",q[q.ADDED=1]="ADDED",q[q.DELETED=2]="DELETED"})(W||(e.FileChangeType=W={}));class V{static{this.a=null}constructor(oe,he){this.c=he,this.b=void 0,this.d=new v.$V(()=>{const K=n.$li.forUris(()=>this.c);return K.fill(this.rawAdded.map(A=>[A,!0])),K}),this.f=new v.$V(()=>{const K=n.$li.forUris(()=>this.c);return K.fill(this.rawUpdated.map(A=>[A,!0])),K}),this.g=new v.$V(()=>{const K=n.$li.forUris(()=>this.c);return K.fill(this.rawDeleted.map(A=>[A,!0])),K}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const K of oe){switch(K.type){case 1:this.rawAdded.push(K.resource);break;case 0:this.rawUpdated.push(K.resource);break;case 2:this.rawDeleted.push(K.resource);break}this.b!==V.a&&(typeof K.cId=="number"?this.b===void 0?this.b=K.cId:this.b!==K.cId&&(this.b=V.a):this.b!==void 0&&(this.b=V.a))}}contains(oe,...he){return this.h(oe,{includeChildren:!1},...he)}affects(oe,...he){return this.h(oe,{includeChildren:!0},...he)}h(oe,he,...K){if(!oe)return!1;const A=K.length>0;return!!((!A||K.includes(1))&&(this.d.value.get(oe)||he.includeChildren&&this.d.value.findSuperstr(oe))||(!A||K.includes(0))&&(this.f.value.get(oe)||he.includeChildren&&this.f.value.findSuperstr(oe))||(!A||K.includes(2))&&(this.g.value.findSubstr(oe)||he.includeChildren&&this.g.value.findSuperstr(oe)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(oe){return this.b===oe}hasCorrelation(){return typeof this.b=="number"}}e.$Yk=V;function J(q,oe,he){return!q||!oe||q===oe||oe.length>q.length?!1:(oe.charAt(oe.length-1)!==R.sep&&(oe+=R.sep),he?(0,P.$kf)(q,oe):q.indexOf(oe)===0)}e.$Zk=J;class le extends Error{constructor(oe,he,K){super(oe),this.fileOperationResult=he,this.options=K}}e.$1k=le;class re extends le{constructor(oe,he,K,A){super(oe,he,A),this.fileOperationResult=he,this.size=K}}e.$2k=re;class ue extends le{constructor(oe,he,K){super(oe,2,K),this.stat=he}}e.$3k=ue;var Q;(function(q){q[q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",q[q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",q[q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",q[q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",q[q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",q[q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",q[q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",q[q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",q[q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",q[q.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",q[q.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Q||(e.FileOperationResult=Q={})),e.$4k={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$5k={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$6k="files.associations",e.$7k="files.exclude",e.$8k="files.readonlyInclude",e.$9k="files.readonlyExclude",e.$0k="files.readonlyFromPermissions";var Y;(function(q){q[q.FILE=0]="FILE",q[q.FOLDER=1]="FOLDER",q[q.ROOT_FOLDER=2]="ROOT_FOLDER"})(Y||(e.FileKind=Y={})),e.$$k="";function U(q){if(!(typeof q.size!="number"||typeof q.mtime!="number"))return q.mtime.toString(29)+q.size.toString(31)}e.$_k=U;async function L(q,oe){if(!oe.hasProvider(C.URI.from({scheme:q.scheme})))return new Promise(he=>{const K=oe.onDidChangeFileSystemProviderRegistrations(A=>{A.scheme===q.scheme&&A.added&&(K.dispose(),he())})})}e.$al=L;class N{static{this.KB=1024}static{this.MB=N.KB*N.KB}static{this.GB=N.MB*N.KB}static{this.TB=N.GB*N.KB}static formatSize(oe){return(0,O.$Wf)(oe)||(oe=0),oe<N.KB?(0,S.localize)(1,null,oe.toFixed(0)):oe<N.MB?(0,S.localize)(2,null,(oe/N.KB).toFixed(2)):oe<N.GB?(0,S.localize)(3,null,(oe/N.MB).toFixed(2)):oe<N.TB?(0,S.localize)(4,null,(oe/N.GB).toFixed(2)):(0,S.localize)(5,null,(oe/N.TB).toFixed(2))}}e.$bl=N;function G(q){const oe=typeof q=="string"||q?.scheme===y.Schemas.vscodeRemote;return typeof q!="string"&&q?.scheme===y.Schemas.file?1024*N.MB:oe?10*N.MB:c.$o?50*N.MB:1024*N.MB}e.$cl=G}),define(ae[121],ce([0,1,17,15,179,16]),function(X,e,n,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pq=void 0;async function C(y,v,k,$,m,w){let p;try{await S(y,v,k,$,m,w)}catch(u){p=u}finally{p&&m.errorTransformer&&(p=m.errorTransformer(p)),typeof p<"u"&&k.error(p),k.end()}}e.$pq=C;async function S(y,v,k,$,m,w){d(w);const p=await y.open(v,{create:!1});try{d(w);let u=0,f=0,h=m&&typeof m.length=="number"?m.length:void 0,g=n.$se.alloc(Math.min(m.bufferSize,typeof h=="number"?h:m.bufferSize)),a=m&&typeof m.position=="number"?m.position:0,t=0;do f=await y.read(p,a,g.buffer,t,g.byteLength-t),a+=f,t+=f,u+=f,typeof h=="number"&&(h-=f),t===g.byteLength&&(await k.write($(g)),g=n.$se.alloc(Math.min(m.bufferSize,typeof h=="number"?h:m.bufferSize)),t=0);while(f>0&&(typeof h!="number"||h>0)&&d(w)&&c(u,m));if(t>0){let o=t;typeof h=="number"&&(o=Math.min(t,h)),k.write($(g.slice(0,o)))}}catch(u){throw(0,O.$Tk)(u)}finally{await y.close(p)}}function d(y){if(y.isCancellationRequested)throw(0,R.$6)();return!0}function c(y,v){if(typeof v?.limits?.size=="number"&&y>v.limits.size)throw(0,O.$Sk)((0,P.localize)(0,null),O.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ae[65],ce([0,1,107,2,9,4,7,16]),function(X,e,n,R,P,O,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=e.$xq=e.$wq=e.$vq=e.$uq=e.$tq=e.$sq=e.$rq=void 0;function d(u){return u.recursive===!0}e.$rq=d;class c extends R.$Tc{static{this.a=5}constructor(f,h,g,a){super(),this.h=f,this.j=h,this.m=g,this.n=a,this.c=this.B(new R.$Uc),this.f=void 0,this.g=0}s(){const f=new R.$Sc;this.c.value=f,this.b=this.r(f),this.b.setVerboseLogging(this.m),f.add(this.b.onDidChangeFile(h=>this.h(h))),f.add(this.b.onDidLogMessage(h=>this.j(h))),f.add(this.b.onDidError(h=>this.t(h)))}t(f){this.n.restartOnError?this.g<c.a&&this.f?(this.w(`restarting watcher after error: ${f}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${f}`):this.w(f)}u(f){this.g++,this.s(),this.watch(f)}async watch(f){this.f=f,await this.b?.watch(f)}async setVerboseLogging(f){this.m=f,await this.b?.setVerboseLogging(f)}w(f){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${f}`})}y(f){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${f}`})}dispose(){return this.b=void 0,super.dispose()}}e.$sq=c;class y extends c{constructor(f,h,g){super(f,h,g,{type:"node.js",restartOnError:!1})}}e.$tq=y;class v extends c{constructor(f,h,g){super(f,h,g,{type:"universal",restartOnError:!0})}}e.$uq=v;function k(u){return u.map(f=>({type:f.type,resource:C.URI.revive(f.resource),cId:f.cId}))}e.$vq=k;function $(u){const f=new p;for(const h of u)f.processEvent(h);return f.coalesce()}e.$wq=$;function m(u,f){return typeof f=="string"&&!f.startsWith(n.$Uj)&&!(0,P.$ic)(f)?{base:u,pattern:f}:f}e.$xq=m;function w(u,f){const h=[];for(const g of f)h.push((0,n.$Yj)(m(u,g)));return h}e.$yq=w;class p{constructor(){this.a=new Set,this.b=new Map}c(f){return O.$k?f.resource.fsPath:f.resource.fsPath.toLowerCase()}processEvent(f){const h=this.b.get(this.c(f));let g=!1;if(h){const a=h.type,t=f.type;h.resource.fsPath!==f.resource.fsPath&&(f.type===2||f.type===1)?g=!0:a===1&&t===2?(this.b.delete(this.c(f)),this.a.delete(h)):a===2&&t===1?h.type=0:a===1&&t===0||(h.type=t)}else g=!0;g&&(this.a.add(f),this.b.set(this.c(f),f))}coalesce(){const f=[],h=[];return Array.from(this.a).filter(g=>g.type!==2?(f.push(g),!1):!0).sort((g,a)=>g.resource.fsPath.length-a.resource.fsPath.length).filter(g=>h.some(a=>(0,S.$Zk)(g.resource.fsPath,a,!O.$k))?!1:(h.push(g.resource.fsPath),!0)).concat(f)}}}),define(ae[215],ce([0,1,17,51,15,3,2,62,32,16,65]),function(X,e,n,R,P,O,C,S,d,c,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rP=e.$qP=void 0,e.$qP="localFilesystem";class v extends C.$Tc{constructor($,m){super(),this.a=$,this.b=m,this.onDidChangeCapabilities=O.Event.None,this.f=this.B(new O.$5d),this.onDidChangeFile=this.f.event,this.g=this.B(new O.$5d),this.onDidWatchError=this.g.event,this.h=(0,d.$Bg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat($){return this.a.call("stat",[$])}readdir($){return this.a.call("readdir",[$])}async readFile($,m){const{buffer:w}=await this.a.call("readFile",[$,m]);return w}readFileStream($,m,w){const p=(0,S.$ge)(f=>n.$se.concat(f.map(h=>n.$se.wrap(h))).buffer),u=new C.$Sc;return u.add(this.a.listen("readFileStream",[$,m])(f=>{if(f instanceof n.$se)p.write(f.buffer);else{if(f==="end")p.end();else{let h;if(f instanceof Error)h=f;else{const g=f;h=(0,c.$Sk)(g.message??(0,R.$3i)(g),g.code??c.FileSystemProviderErrorCode.Unknown)}p.error(h),p.end()}u.dispose()}})),u.add(w.onCancellationRequested(()=>{p.error((0,P.$6)()),p.end(),u.dispose()})),p}writeFile($,m,w){return this.a.call("writeFile",[$,n.$se.wrap(m),w])}open($,m){return this.a.call("open",[$,m])}close($){return this.a.call("close",[$])}async read($,m,w,p,u){const[f,h]=await this.a.call("read",[$,m,u]);return w.set(f.buffer.slice(0,h),p),h}write($,m,w,p,u){return this.a.call("write",[$,m,n.$se.wrap(w),p,u])}mkdir($){return this.a.call("mkdir",[$])}delete($,m){return this.a.call("delete",[$,m])}rename($,m,w){return this.a.call("rename",[$,m,w])}copy($,m,w){return this.a.call("copy",[$,m,w])}cloneFile($,m){return this.a.call("cloneFile",[$,m])}j(){this.B(this.a.listen("fileChange",[this.h])($=>{if(Array.isArray($)){const m=$;this.f.fire((0,y.$vq)(m))}else{const m=$;this.g.fire(m)}}))}watch($,m){const w=(0,d.$Bg)();return this.a.call("watch",[this.h,w,$,m]),(0,C.$Rc)(()=>this.a.call("unwatch",[this.h,w]))}}e.$rP=v}),define(ae[216],ce([0,1,46,8,23,33,2,86,9,4,19,7,108,21,65]),function(X,e,n,R,P,O,C,S,d,c,y,v,k,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=e.$Lq=void 0;class w extends C.$Tc{static{this.a=100}static{this.b=75}constructor(f,h,g,a){super(),this.m=f,this.n=h,this.r=g,this.s=a,this.c=this.B(new R.$uh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.n(t))),this.f=this.B(new R.$th(t=>this.z(t),w.b)),this.g=(0,m.$yq)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,m.$yq)(this.m.path,this.m.includes):void 0,this.j=new P.$ce,this.ready=this.t()}async t(){try{const f=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const h=await $.Promises.stat(f);this.B(await this.w(f,h.isDirectory()))}catch(f){f.code!=="ENOENT"?this.D(f):this.G(f)}}async u(f){let h=f.path;try{h=await $.Promises.realpath(f.path),f.path===h&&(h=await(0,k.$Iq)(f.path)??f.path),f.path!==h&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${f.path}, real: ${h})`)}catch{}return h}async w(f,h){if(c.$j&&(0,O.$fg)(f,"/Volumes/",!0))return this.D(`Refusing to watch ${f} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),C.$Tc.None;const g=new P.$ce(this.j.token),a=new C.$Sc;try{const t=v.URI.file(this.m.path),o=(0,d.$nc)(f),r=(0,n.watch)(f);a.add((0,C.$Rc)(()=>{r.removeAllListeners(),r.close()})),this.G(`Started watching: '${f}'`);const i=new Set;if(h)try{for(const l of await $.Promises.readdir(f))i.add(l)}catch(l){this.D(l)}const s=new Map;a.add((0,C.$Rc)(()=>{for(const[,l]of s)l.dispose();s.clear()})),r.on("error",(l,b)=>{this.D(`Failed to watch ${f} for changes using fs.watch() (${l}, ${b})`),this.dispose()}),r.on("change",(l,b)=>{if(g.token.isCancellationRequested)return;this.G(`[raw] ["${l}"] ${b}`);let D="";if(b&&(D=b.toString(),c.$j&&(D=(0,S.$Ql)(D))),!(!D||l!=="change"&&l!=="rename"))if(h)if(l==="rename"){s.get(D)?.dispose();const j=setTimeout(async()=>{if(s.delete(D),D===o&&!await $.Promises.exists(f)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const E=await this.C((0,d.$jc)(f,D));if(g.token.isCancellationRequested)return;let I;E?i.has(D)?I=0:(I=1,i.add(D)):(i.delete(D),I=2),this.y({resource:(0,y.$Sg)(t,D),type:I,cId:this.m.correlationId})},w.a);s.set(D,(0,C.$Rc)(()=>clearTimeout(j)))}else{let j;i.has(D)?j=0:(j=1,i.add(D)),this.y({resource:(0,y.$Sg)(t,D),type:j,cId:this.m.correlationId})}else if(l==="rename"||D!==o){const j=setTimeout(async()=>{const E=await $.Promises.exists(f);g.token.isCancellationRequested||(E?(this.y({resource:t,type:0,cId:this.m.correlationId},!0),a.add(await this.w(f,!1))):(this.y({resource:t,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},w.a);a.clear(),a.add((0,C.$Rc)(()=>clearTimeout(j)))}else this.y({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){await $.Promises.exists(f)&&!g.token.isCancellationRequested&&this.D(`Failed to watch ${f} for changes using fs.watch() (${t.toString()})`)}return(0,C.$Rc)(()=>{g.dispose(!0),a.dispose()})}y(f,h=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.resource.fsPath}`),!h&&this.g.some(g=>g(f.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${f.resource.fsPath}`):!h&&this.h&&this.h.length>0&&!this.h.some(g=>g(f.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${f.resource.fsPath}`):this.f.work(f))}z(f){const h=(0,m.$wq)(f);if(h.length>0){if(this.s)for(const a of h)this.G(` >> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.resource.fsPath}`);this.c.work(h)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${h[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${h.length}, most recent change: ${h[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(f){if(c.$k)return $.Promises.exists(f);try{const h=(0,d.$nc)(f);return(await $.Promises.readdir((0,d.$mc)(f))).some(a=>a===h)}catch(h){return this.G(h),!1}}setVerboseLogging(f){this.s=f}D(f){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${f}`})}F(f){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${f}`})}G(f){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${f}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$Lq=w;async function p(u,f,h,g,a=512){const t=await $.Promises.open(u,"r"),o=Buffer.allocUnsafe(a),r=new P.$ce(g);let i,s=!1;const l={path:u,excludes:[],recursive:!1},b=new w(l,D=>{(async()=>{for(const{type:j}of D)if(j===0){if(s)return;s=!0;try{for(;!r.token.isCancellationRequested;){const{bytesRead:E}=await $.Promises.read(t,o,0,a,null);if(!E||r.token.isCancellationRequested)break;f(o.slice(0,E))}}catch(E){i=new Error(E),r.dispose(!0)}finally{s=!1}}})()});return await b.ready,h(),new Promise((D,j)=>{r.token.onCancellationRequested(async()=>{b.dispose();try{await $.Promises.close(t)}catch(E){i=new Error(E)}i?j(i):D()})})}e.$Mq=p}),define(ae[217],ce([0,1,3,107,2,4,216]),function(X,e,n,R,P,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=void 0;class S extends P.$Tc{constructor(){super(...arguments),this.a=this.B(new n.$5d),this.onDidChangeFile=this.a.event,this.b=this.B(new n.$5d),this.onDidLogMessage=this.b.event,this.onDidError=n.Event.None,this.c=new Map,this.f=!1}async watch(c){const y=this.j(c),v=y.filter($=>{const m=this.c.get($.path);return m?!(0,R.$3j)(m.request.excludes,$.excludes)||!(0,R.$3j)(m.request.includes,$.includes):!0}),k=Array.from(this.c.values()).filter(({request:$})=>!y.find(m=>m.path===$.path&&(0,R.$3j)(m.excludes,$.excludes)&&(0,R.$3j)(m.includes,$.includes))).map(({request:$})=>$.path);v.length&&this.m(`Request to start watching: ${v.map($=>`${$.path} (excludes: ${$.excludes.length>0?$.excludes:"<none>"}, includes: ${$.includes&&$.includes.length>0?JSON.stringify($.includes):"<all>"}, correlationId: ${typeof $.correlationId=="number"?$.correlationId:"<none>"})`).join(",")}`),k.length&&this.m(`Request to stop watching: ${k.join(",")}`);for(const $ of k)this.h($);for(const $ of v)this.g($)}g(c){const y=new C.$Lq(c,k=>this.a.fire(k),k=>this.b.fire(k),this.f),v={request:c,instance:y};this.c.set(c.path,v)}async stop(){for(const[c]of this.c)this.h(c);this.c.clear()}h(c){const y=this.c.get(c);y&&(this.c.delete(c),y.instance.dispose())}j(c){const y=new Map;for(const v of c){const k=O.$k?v.path:v.path.toLowerCase();let $=y.get(v.correlationId);$||($=new Map,y.set(v.correlationId,$)),$.set(k,v)}return Array.from(y.values()).map(v=>Array.from(v.values())).flat()}async setVerboseLogging(c){this.f=c;for(const[,y]of this.c)y.instance.setVerboseLogging(c)}m(c){this.f&&this.b.fire({type:"trace",message:this.n(c)})}n(c,y){return y?`[File Watcher (node.js)] ${c} (path: ${y.request.path})`:`[File Watcher (node.js)] ${c}`}}e.$Nq=S}),define(ae[218],ce([0,1,65,217]),function(X,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oq=void 0;class P extends n.$tq{constructor(C,S,d){super(C,S,d),this.s()}r(C){return C.add(new R.$Nq)}}e.$Oq=P}),define(ae[219],ce([0,1,13,43,162,65]),function(X,e,n,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gq=void 0;class C extends O.$uq{constructor(d,c,y){super(d,c,y),this.s()}r(d){const c=d.add(new P.$Fq(n.$zg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return d.add(c.onDidProcessExit(({code:y,signal:v})=>this.t(`terminated by itself with code ${y}, signal: ${v}`))),R.ProxyChannel.toService((0,R.$Yh)(c.getChannel("watcher")))}}e.$Gq=C}),define(ae[93],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$di=void 0;class n{constructor(...P){this.a=new Map;for(const[O,C]of P)this.set(O,C)}set(P,O){const C=this.a.get(P);return this.a.set(P,O),C}has(P){return this.a.has(P)}get(P){return this.a.get(P)}}e.$di=n}),define(ae[220],ce([0,1,8,15,2,77,210,6,93,103]),function(X,e,n,R,P,O,C,S,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=e.$Sq=void 0;const y=!1;class v extends Error{constructor(p){super("cyclic dependency between services"),this.message=p.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${p.toString()}`}}class k{constructor(p=new d.$di,u=!1,f,h=y){this.f=p,this.g=u,this.h=f,this.i=h,this.o=new Set,this.f.set(S.$ei,this),this._globalGraph=h?f?._globalGraph??new C.$Rq(g=>g):void 0}createChild(p){return new k(p,this.g,this,this.i)}invokeFunction(p,...u){const f=m.traceInvocation(this.i,p);let h=!1;try{return p({get:a=>{if(h)throw(0,R.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(a,f);if(!t)throw new Error(`[invokeFunction] unknown service '${a}'`);return t}},...u)}finally{h=!0,f.stop()}}createInstance(p,...u){let f,h;return p instanceof O.$ci?(f=m.traceCreation(this.i,p.ctor),h=this.j(p.ctor,p.staticArguments.concat(u),f)):(f=m.traceCreation(this.i,p),h=this.j(p,u,f)),f.stop(),h}j(p,u=[],f){const h=S._util.getServiceDependencies(p).sort((t,o)=>t.index-o.index),g=[];for(const t of h){const o=this.m(t.id,f);o||this.u(`[createInstance] ${p.name} depends on UNKNOWN service ${t.id}.`,!1),g.push(o)}const a=h.length>0?h[0].index:u.length;if(u.length!==a){console.trace(`[createInstance] First service dependency of ${p.name} at position ${a+1} conflicts with ${u.length} static arguments`);const t=a-u.length;t>0?u=u.concat(new Array(t)):u=u.slice(0,a)}return Reflect.construct(p,u.concat(g))}k(p,u){if(this.f.get(p)instanceof O.$ci)this.f.set(p,u);else if(this.h)this.h.k(p,u);else throw new Error("illegalState - setting UNKNOWN service instance")}l(p){const u=this.f.get(p);return!u&&this.h?this.h.l(p):u}m(p,u){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(p));const f=this.l(p);return f instanceof O.$ci?this.q(p,f,u.branch(p,!0)):(u.branch(p,!1),f)}q(p,u,f){if(this.o.has(p))throw new Error(`illegal state - RECURSIVELY instantiating service '${p}'`);this.o.add(p);try{return this.r(p,u,f)}finally{this.o.delete(p)}}r(p,u,f){const h=new C.$Rq(t=>t.id.toString());let g=0;const a=[{id:p,desc:u,_trace:f}];for(;a.length;){const t=a.pop();if(h.lookupOrInsertNode(t),g++>1e3)throw new v(h);for(const o of S._util.getServiceDependencies(t.desc.ctor)){const r=this.l(o.id);if(r||this.u(`[createInstance] ${p} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(o.id)),r instanceof O.$ci){const i={id:o.id,desc:r,_trace:t._trace.branch(o.id,!0)};h.insertEdge(t,i),a.push(i)}}}for(;;){const t=h.roots();if(t.length===0){if(!h.isEmpty())throw new v(h);break}for(const{data:o}of t){if(this.l(o.id)instanceof O.$ci){const i=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,i)}h.removeNode(o)}}return this.l(p)}s(p,u,f=[],h,g){if(this.f.get(p)instanceof O.$ci)return this.t(p,u,f,h,g);if(this.h)return this.h.s(p,u,f,h,g);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}t(p,u,f=[],h,g){if(h){const a=new k(void 0,this.g,this,this.i);a.c=String(p);const t=new Map,o=new n.$yh(()=>{const r=a.j(u,f,g);for(const[i,s]of t){const l=r[i];if(typeof l=="function")for(const b of s)b.disposable=l.apply(r,b.listener)}return t.clear(),r});return new Proxy(Object.create(null),{get(r,i){if(!o.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let b=t.get(i);return b||(b=new c.$4c,t.set(i,b)),(j,E,I)=>{if(o.isInitialized)return o.value[i](j,E,I);{const M={listener:[j,E,I],disposable:void 0},T=b.push(M);return(0,P.$Rc)(()=>{T(),M.disposable?.dispose()})}}}if(i in r)return r[i];const s=o.value;let l=s[i];return typeof l!="function"||(l=l.bind(s),r[i]=l),l},set(r,i,s){return o.value[i]=s,!0},getPrototypeOf(r){return u.prototype}})}else return this.j(u,f,g)}u(p,u){if(u&&console.warn(p),this.g)throw new Error(p)}}e.$Sq=k;var $;(function(w){w[w.None=0]="None",w[w.Creation=1]="Creation",w[w.Invocation=2]="Invocation",w[w.Branch=3]="Branch"})($||($={}));class m{static{this.all=new Set}static{this.c=new class extends m{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(p,u){return p?new m(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m.c}static traceCreation(p,u){return p?new m(1,u.name):m.c}static{this.f=0}constructor(p,u){this.type=p,this.name=u,this.g=Date.now(),this.h=[]}branch(p,u){const f=new m(3,p.toString());return this.h.push([p,u,f]),f}stop(){const p=Date.now()-this.g;m.f+=p;let u=!1;function f(g,a){const t=[],o=new Array(g+1).join("	");for(const[r,i,s]of a.h)if(i&&s){u=!0,t.push(`${o}CREATES -> ${r}`);const l=f(g+1,s);l&&t.push(l)}else t.push(`${o}uses -> ${r}`);return t.join(`
`)}const h=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${p.toFixed(2)}ms (grand total ${m.f.toFixed(2)}ms)`];(p>2||u)&&m.all.add(h.join(`
`))}}e.$Tq=m}),define(ae[221],ce([0,1,6]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DBb=e.IssueType=void 0;var R;(function(P){P[P.Bug=0]="Bug",P[P.PerformanceIssue=1]="PerformanceIssue",P[P.FeatureRequest=2]="FeatureRequest"})(R||(e.IssueType=R={})),e.$DBb=(0,n.$fi)("issueService")}),define(ae[5],ce([0,1,51,3,45,2,31,4,19,12,7,117,6]),function(X,e,n,R,P,O,C,S,d,c,y,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.log=e.$Cj=e.LogLevel=e.$Bj=e.$Aj=e.$zj=void 0,e.$zj=(0,k.$fi)("logService"),e.$Aj=(0,k.$fi)("loggerService");function $(){return new Date().toISOString()}function m(j){return(0,c.$Wf)(j)}e.$Bj=m;var w;(function(j){j[j.Off=0]="Off",j[j.Trace=1]="Trace",j[j.Debug=2]="Debug",j[j.Info=3]="Info",j[j.Warning=4]="Warning",j[j.Error=5]="Error"})(w||(e.LogLevel=w={})),e.$Cj=w.Info;function p(j,E,I){switch(E){case w.Trace:j.trace(I);break;case w.Debug:j.debug(I);break;case w.Info:j.info(I);break;case w.Warning:j.warn(I);break;case w.Error:j.error(I);break;case w.Off:break;default:throw new Error(`Invalid log level ${E}`)}}e.log=p;function u(j,E=!1){let I="";for(let M=0;M<j.length;M++){let T=j[M];if(T instanceof Error&&(T=(0,n.$3i)(T,E)),typeof T=="object")try{T=JSON.stringify(T)}catch{}I+=(M>0?" ":"")+T}return I}class f extends O.$Tc{constructor(){super(...arguments),this.b=e.$Cj,this.c=this.B(new R.$5d),this.onDidChangeLogLevel=this.c.event}setLevel(E){this.b!==E&&(this.b=E,this.c.fire(this.b))}getLevel(){return this.b}f(E){return this.b!==w.Off&&this.b<=E}}e.$Ej=f;class h extends f{constructor(E){super(),this.h=E}f(E){return this.h||super.f(E)}trace(E,...I){this.f(w.Trace)&&this.g(w.Trace,u([E,...I],!0))}debug(E,...I){this.f(w.Debug)&&this.g(w.Debug,u([E,...I]))}info(E,...I){this.f(w.Info)&&this.g(w.Info,u([E,...I]))}warn(E,...I){this.f(w.Warning)&&this.g(w.Warning,u([E,...I]))}error(E,...I){if(this.f(w.Error))if(E instanceof Error){const M=Array.prototype.slice.call(arguments);M[0]=E.stack,this.g(w.Error,u(M))}else this.g(w.Error,u([E,...I]))}flush(){}}e.$Fj=h;class g extends f{constructor(E=e.$Cj){super(),this.setLevel(E),this.g=!S.$i}trace(E,...I){this.f(w.Trace)&&(this.g?console.log(`\x1B[90m[main ${$()}]\x1B[0m`,E,...I):console.log(`[main ${$()}]`,E,...I))}debug(E,...I){this.f(w.Debug)&&(this.g?console.log(`\x1B[90m[main ${$()}]\x1B[0m`,E,...I):console.log(`[main ${$()}]`,E,...I))}info(E,...I){this.f(w.Info)&&(this.g?console.log(`\x1B[90m[main ${$()}]\x1B[0m`,E,...I):console.log(`[main ${$()}]`,E,...I))}warn(E,...I){this.f(w.Warning)&&(this.g?console.warn(`\x1B[93m[main ${$()}]\x1B[0m`,E,...I):console.warn(`[main ${$()}]`,E,...I))}error(E,...I){this.f(w.Error)&&(this.g?console.error(`\x1B[91m[main ${$()}]\x1B[0m`,E,...I):console.error(`[main ${$()}]`,E,...I))}flush(){}}e.$Gj=g;class a extends f{constructor(E=e.$Cj,I=!0){super(),this.g=I,this.setLevel(E)}trace(E,...I){this.f(w.Trace)&&(this.g?console.log("%cTRACE","color: #888",E,...I):console.log(E,...I))}debug(E,...I){this.f(w.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",E,...I):console.log(E,...I))}info(E,...I){this.f(w.Info)&&(this.g?console.log("%c INFO","color: #33f",E,...I):console.log(E,...I))}warn(E,...I){this.f(w.Warning)&&(this.g?console.log("%c WARN","color: #993",E,...I):console.log(E,...I))}error(E,...I){this.f(w.Error)&&(this.g?console.log("%c  ERR","color: #f33",E,...I):console.error(E,...I))}flush(){}}e.$Hj=a;class t extends f{constructor(E,I=e.$Cj){super(),this.g=E,this.setLevel(I)}trace(E,...I){this.f(w.Trace)&&this.g.log(w.Trace,[this.h(E),...I])}debug(E,...I){this.f(w.Debug)&&this.g.log(w.Debug,[this.h(E),...I])}info(E,...I){this.f(w.Info)&&this.g.log(w.Info,[this.h(E),...I])}warn(E,...I){this.f(w.Warning)&&this.g.log(w.Warning,[this.h(E),...I])}error(E,...I){this.f(w.Error)&&this.g.log(w.Error,[this.h(E),...I])}h(E){return typeof E=="string"?E:(0,n.$3i)(E,this.f(w.Trace))}flush(){}}e.$Ij=t;class o extends f{constructor(E){super(),this.g=E,E.length&&this.setLevel(E[0].getLevel())}setLevel(E){for(const I of this.g)I.setLevel(E);super.setLevel(E)}trace(E,...I){for(const M of this.g)M.trace(E,...I)}debug(E,...I){for(const M of this.g)M.debug(E,...I)}info(E,...I){for(const M of this.g)M.info(E,...I)}warn(E,...I){for(const M of this.g)M.warn(E,...I)}error(E,...I){for(const M of this.g)M.error(E,...I)}flush(){for(const E of this.g)E.flush()}dispose(){for(const E of this.g)E.dispose();super.dispose()}}e.$Jj=o;class r extends O.$Tc{constructor(E,I,M){if(super(),this.h=E,this.j=I,this.b=new C.$Ac,this.c=this.B(new R.$5d),this.onDidChangeLoggers=this.c.event,this.f=this.B(new R.$5d),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new R.$5d),this.onDidChangeVisibility=this.g.event,M)for(const T of M)this.b.set(T.resource,{logger:void 0,info:T})}m(E){return(0,c.$Sf)(E)?[...this.b.values()].find(I=>I.info.id===E):this.b.get(E)}getLogger(E){return this.m(E)?.logger}createLogger(E,I){const M=this.n(E),T=(0,c.$Sf)(E)?E:I?.id??(0,P.$6i)(M.toString()).toString(16);let W=this.b.get(M)?.logger;const V=I?.logLevel==="always"?w.Trace:I?.logLevel;W||(W=this.s(M,V??this.getLogLevel(M)??this.h,{...I,id:T}));const J={logger:W,info:{resource:M,id:T,logLevel:V,name:I?.name,hidden:I?.hidden,extensionId:I?.extensionId,when:I?.when}};return this.registerLogger(J.info),this.b.set(M,J),W}n(E){return(0,c.$Sf)(E)?(0,d.$Sg)(this.j,`${E}.log`):E}setLogLevel(E,I){if(y.URI.isUri(E)){const M=E,T=I,W=this.b.get(M);W&&T!==W.info.logLevel&&(W.info.logLevel=T===this.h?void 0:T,W.logger?.setLevel(T),this.b.set(W.info.resource,W),this.f.fire([M,T]))}else{this.h=E;for(const[M,T]of this.b.entries())this.b.get(M)?.info.logLevel===void 0&&T.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(E,I){const M=this.m(E);M&&I!==!M.info.hidden&&(M.info.hidden=!I,this.b.set(M.info.resource,M),this.g.fire([M.info.resource,I]))}getLogLevel(E){let I;return E&&(I=this.b.get(E)?.info.logLevel),I??this.h}registerLogger(E){const I=this.b.get(E.resource);I?I.info.hidden!==E.hidden&&this.setVisibility(E.resource,!E.hidden):(this.b.set(E.resource,{info:E,logger:void 0}),this.c.fire({added:[E],removed:[]}))}deregisterLogger(E){const I=this.b.get(E);I&&(I.logger&&I.logger.dispose(),this.b.delete(E),this.c.fire({added:[],removed:[I.info]}))}*getRegisteredLoggers(){for(const E of this.b.values())yield E.info}getRegisteredLogger(E){return this.b.get(E)?.info}dispose(){this.b.forEach(E=>E.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Kj=r;class i{constructor(){this.onDidChangeLogLevel=new R.$5d().event}setLevel(E){}getLevel(){return w.Info}trace(E,...I){}debug(E,...I){}info(E,...I){}warn(E,...I){}error(E,...I){}critical(E,...I){}dispose(){}flush(){}}e.$Lj=i;class s extends i{}e.$Mj=s;function l(j){if(j.verbose)return w.Trace;if(typeof j.logLevel=="string"){const E=D(j.logLevel.toLowerCase());if(E!==void 0)return E}return e.$Cj}e.$Nj=l;function b(j){switch(j){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Off:return"off"}}e.$Oj=b;function D(j){switch(j){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Error;case"off":return w.Off}}e.$Pj=D,e.$Qj=new v.$wj("logLevel",b(w.Info))});var se=this&&this.__param||function(X,e){return function(n,R){e(n,R,X)}};define(ae[222],ce([0,1,14,4,5]),function(X,e,n,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o_b=void 0;const O=n.safeStorage;let C=class{constructor(d){this.a=d,n.app.commandLine.getSwitchValue("password-store")==="basic"&&O.setUsePlainTextEncryption?.(!0)}async encrypt(d){this.a.trace("[EncryptionMainService] Encrypting value.");try{const c=JSON.stringify(O.encryptString(d));return this.a.trace("[EncryptionMainService] Encrypted value."),c}catch(c){throw this.a.error(c),c}}async decrypt(d){let c;try{if(c=JSON.parse(d),!c.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${d}`);const y=Buffer.from(c.data);this.a.trace("[EncryptionMainService] Decrypting value.");const v=O.decryptString(y);return this.a.trace("[EncryptionMainService] Decrypted value."),v}catch(y){throw this.a.error(y),y}}isEncryptionAvailable(){return Promise.resolve(O.isEncryptionAvailable())}getKeyStorageProvider(){if(R.$i)return Promise.resolve("dpapi");if(R.$j)return Promise.resolve("keychain_access");if(O.getSelectedStorageBackend)try{const d=O.getSelectedStorageBackend();return Promise.resolve(d)}catch(d){this.a.error(d)}return Promise.resolve("unknown")}async setUsePlainTextEncryption(){if(R.$i)throw new Error("Setting plain text encryption is not supported on Windows.");if(R.$j)throw new Error("Setting plain text encryption is not supported on macOS.");if(!O.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");O.setUsePlainTextEncryption(!0)}};e.$o_b=C,e.$o_b=C=ve([se(0,P.$zj)],C)}),define(ae[223],ce([0,1,22,8,15,3,2,9,65,5]),function(X,e,n,R,P,O,C,S,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=void 0;class y extends C.$Tc{constructor(k,$){super(),this.a=k,this.b=$,this.c=this.B(new O.$5d),this.onDidChangeFile=this.c.event,this.g=this.B(new O.$5d),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new R.$dh(0)),this.w=[],this.y=this.B(new R.$dh(0))}watch(k,$){return $.recursive||this.b?.watcher?.forceUniversal?this.n(k,$):this.z(k,$)}n(k,$){const m={path:this.H(k),excludes:$.excludes,includes:$.includes,recursive:$.recursive,correlationId:$.correlationId},w=(0,n.$Ub)(this.j,m);return this.r(),(0,C.$Rc)(()=>{w(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(k=>(0,P.$1)(k))}s(){this.h||(this.h=this.B(this.t($=>this.c.fire((0,d.$vq)($)),$=>this.G($),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)})));const k=this.b?.watcher?.recursive?.usePolling;if(k===!0)for(const $ of this.j)(0,d.$rq)($)&&($.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(k))for(const $ of this.j)(0,d.$rq)($)&&k.includes($.path)&&($.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(k,$){const m={path:this.H(k),excludes:$.excludes,includes:$.includes,recursive:!1,correlationId:$.correlationId},w=(0,n.$Ub)(this.w,m);return this.C(),(0,C.$Rc)(()=>{w(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(k=>(0,P.$1)(k))}D(){return this.u||(this.u=this.B(this.F(k=>this.c.fire((0,d.$vq)(k)),k=>this.G(k),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)}))),this.u.watch(this.w)}G(k){k.type==="error"&&this.g.fire(k.message),this.a[k.type](k.message)}H(k){return(0,S.$hc)(k.fsPath)}}e.$zq=y}),define(ae[224],ce([0,1,22,8,17,23,3,45,71,2,59,13,66,19,62,177,16,121,5,15]),function(X,e,n,R,P,O,C,S,d,c,y,v,k,$,m,w,p,u,f,h){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$qq=void 0;let a=class extends c.$Tc{static{g=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new C.$5d),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new C.$5d),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new C.$5d),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new C.$5d),this.onDidRunOperation=this.r.event,this.X=this.B(new C.$5d),this.Y=this.B(new C.$5d),this.onDidFilesChange=this.Y.event,this.Z=this.B(new C.$5d),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new R.$oh)}registerProvider(o,r){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,k.mark)(`code/registerFilesystem/${o}`);const i=new c.$Sc;return this.h.set(o,r),this.c.fire({added:!0,scheme:o,provider:r}),i.add(r.onDidChangeFile(s=>{const l=new p.$Yk(s,!this.S(r));this.X.fire(l),l.hasCorrelation()||this.Y.fire(l)})),typeof r.onDidWatchError=="function"&&i.add(r.onDidWatchError(s=>this.Z.fire(new Error(s)))),i.add(r.onDidChangeCapabilities(()=>this.g.fire({provider:r,scheme:o}))),(0,c.$Rc)(()=>{this.c.fire({added:!1,scheme:o,provider:r}),this.h.delete(o),(0,c.$Oc)(i)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const r=[];this.f.fire({scheme:o,join(i){r.push(i)}}),!this.h.has(o)&&await R.Promises.settled(r)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,r){const i=this.h.get(o.scheme);return!!(i&&i.capabilities&r)}listCapabilities(){return d.Iterable.map(this.h,([o,r])=>({scheme:o,capabilities:r.capabilities}))}async j(o){if(!(0,$.$Wg)(o))throw new p.$1k((0,w.localize)(0,null,this.sb(o)),8);await this.activateProvider(o.scheme);const r=this.h.get(o.scheme);if(!r){const i=new h.$bb;throw i.message=(0,w.localize)(1,null,o.toString()),i}return r}async m(o){const r=await this.j(o);if((0,p.$Lk)(r)||(0,p.$Ik)(r)||(0,p.$Mk)(r))return r;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const r=await this.j(o);if((0,p.$Lk)(r)||(0,p.$Ik)(r))return r;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,r){try{return await this.s(o,r)}catch(i){throw(0,p.$Vk)(i)===p.FileSystemProviderErrorCode.FileNotFound?new p.$1k((0,w.localize)(2,null,this.sb(o)),1):(0,p.$Tk)(i)}}async s(o,r){const i=await this.j(o),s=this.S(i),l=r?.resolveTo,b=r?.resolveSingleChildDescendants,D=r?.resolveMetadata,j=await i.stat(o);let E;return this.t(i,o,j,void 0,!!D,(I,M)=>(E||(E=y.$li.forUris(()=>!s),E.set(o,!0),l&&E.fill(!0,l)),E.get(I.resource)||E.findSuperstr(I.resource.with({query:null,fragment:null}))?!0:I.isDirectory&&b?M===1:!1))}async t(o,r,i,s,l,b){const{providerExtUri:D}=this.R(o),j={resource:r,name:D.basename(r),isFile:(i.type&p.FileType.File)!==0,isDirectory:(i.type&p.FileType.Directory)!==0,isSymbolicLink:(i.type&p.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&p.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((i.permissions??0)&p.FilePermission.Locked),etag:(0,p.$_k)({mtime:i.mtime,size:i.size}),children:void 0};if(j.isDirectory&&b(j,s)){try{const E=await o.readdir(r),I=await R.Promises.settled(E.map(async([M,T])=>{try{const W=D.joinPath(r,M),V=l?await o.stat(W):{type:T};return await this.t(o,W,V,E.length,l,b)}catch(W){return this.b.trace(W),null}}));j.children=(0,n.$Hb)(I)}catch(E){this.b.trace(E),j.children=[]}return j}return j}async resolveAll(o){return R.Promises.settled(o.map(async r=>{try{return{stat:await this.s(r.resource,r.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(o){const r=await this.j(o),i=await r.stat(o);return this.t(r,o,i,void 0,!0,()=>!1)}async exists(o){const r=await this.j(o);try{return!!await r.stat(o)}catch{return!1}}async canCreateFile(o,r){try{await this.u(o,r)}catch(i){return i}return!0}async u(o,r){if(!r?.overwrite&&await this.exists(o))throw new p.$1k((0,w.localize)(3,null,this.sb(o)),3,r)}async createFile(o,r=P.$se.fromString(""),i){await this.u(o,i);const s=await this.writeFile(o,r);return this.r.fire(new p.$Xk(o,0,s)),s}async writeFile(o,r,i){const s=this.qb(await this.n(o),o),{providerExtUri:l}=this.R(s);let b=i;if((0,p.$Ok)(s)&&!b?.atomic){const D=s.enforceAtomicWriteFile?.(o);D&&(b={...i,atomic:D})}try{await this.w(s,o,b)||await this.U(s,l.dirname(o));let j;if((0,p.$Ik)(s)&&!(r instanceof P.$se))if((0,m.$ee)(r)){const E=await(0,m.$le)(r,3);E.ended?j=P.$se.concat(E.buffer):j=E}else j=(0,m.$ie)(r,E=>P.$se.concat(E),3);else j=r;!(0,p.$Lk)(s)||(0,p.$Ik)(s)&&j instanceof P.$se||(0,p.$Ik)(s)&&(0,p.$Ok)(s)&&b?.atomic?await this.hb(s,o,b,j):await this.db(s,o,b,j instanceof P.$se?(0,P.$De)(j):j),this.r.fire(new p.$Xk(o,4))}catch(D){throw new p.$1k((0,w.localize)(4,null,this.sb(o),(0,p.$Tk)(D).toString()),(0,p.$Wk)(D),b)}return this.resolve(o,{resolveMetadata:!0})}async w(o,r,i){const s=!!i?.unlock;if(s&&!(o.capabilities&8192))throw new Error((0,w.localize)(5,null,this.sb(r)));if(!!i?.atomic){if(!(o.capabilities&32768))throw new Error((0,w.localize)(6,null,this.sb(r)));if(!(o.capabilities&2))throw new Error((0,w.localize)(7,null,this.sb(r)));if(s)throw new Error((0,w.localize)(8,null,this.sb(r)))}let b;try{b=await o.stat(r)}catch{return}if(b.type&p.FileType.Directory)throw new p.$1k((0,w.localize)(9,null,this.sb(r)),0,i);if(this.rb(r,b),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==p.$$k&&typeof b.mtime=="number"&&typeof b.size=="number"&&i.mtime<b.mtime&&i.etag!==(0,p.$_k)({mtime:i.mtime,size:b.size}))throw new p.$1k((0,w.localize)(10,null),3,i);return b}async readFile(o,r,i){const s=await this.m(o);return r?.atomic?this.z(s,o,r,i):this.C(s,o,r,i)}async z(o,r,i,s){return new Promise((l,b)=>{this.cb.queueFor(r,async()=>{try{const D=await this.C(o,r,i,s);l(D)}catch(D){b(D)}},this.R(o).providerExtUri)})}async C(o,r,i,s){const l=await this.D(o,r,{...i,preferUnbuffered:!0},s);return{...l,value:await(0,P.$Ee)(l.value)}}async readFileStream(o,r,i){const s=await this.m(o);return this.D(s,o,r,i)}async D(o,r,i,s){const l=new O.$ce(s);let b=i;(0,p.$Nk)(o)&&o.enforceAtomicReadFile?.(r)&&(b={...i,atomic:!0});const D=this.J(r,b).then(E=>E,E=>{throw l.dispose(!0),E});let j;try{return typeof b?.etag=="string"&&b.etag!==p.$$k&&await D,b?.atomic&&(0,p.$Nk)(o)||!((0,p.$Lk)(o)||(0,p.$Mk)(o))||(0,p.$Ik)(o)&&b?.preferUnbuffered?j=this.I(o,r,b):(0,p.$Mk)(o)?j=this.G(o,r,l.token,b):j=this.H(o,r,l.token,b),j.on("end",()=>l.dispose()),j.on("error",()=>l.dispose()),{...await D,value:j}}catch(E){throw j&&await(0,m.$je)(j),this.F(E,r,b)}}F(o,r,i){const s=(0,w.localize)(11,null,this.sb(r),(0,p.$Tk)(o).toString());return o instanceof p.$3k?new p.$3k(s,o.stat,i):o instanceof p.$2k?new p.$2k(s,o.fileOperationResult,o.size,o.options):new p.$1k(s,(0,p.$Wk)(o),i)}G(o,r,i,s=Object.create(null)){const l=o.readFileStream(r,s,i);return(0,m.$pe)(l,{data:b=>b instanceof P.$se?b:P.$se.wrap(b),error:b=>this.F(b,r,s)},b=>P.$se.concat(b))}H(o,r,i,s=Object.create(null)){const l=(0,P.$Ie)();return(0,u.$pq)(o,r,l,b=>b,{...s,bufferSize:this.a,errorTransformer:b=>this.F(b,r,s)},i),l}I(o,r,i){const s=(0,m.$ge)(l=>P.$se.concat(l));return(async()=>{try{let l;i?.atomic&&(0,p.$Nk)(o)?l=await o.readFile(r,{atomic:!0}):l=await o.readFile(r),typeof i?.position=="number"&&(l=l.slice(i.position)),typeof i?.length=="number"&&(l=l.slice(0,i.length)),this.L(r,l.byteLength,i),s.end(P.$se.wrap(l))}catch(l){s.error(l),s.end()}})(),s}async J(o,r){const i=await this.resolve(o,{resolveMetadata:!0});if(i.isDirectory)throw new p.$1k((0,w.localize)(12,null,this.sb(o)),0,r);if(typeof r?.etag=="string"&&r.etag!==p.$$k&&r.etag===i.etag)throw new p.$3k((0,w.localize)(13,null),i,r);return this.L(o,i.size,r),i}L(o,r,i){if(typeof i?.limits?.size=="number"&&r>i.limits.size)throw new p.$2k((0,w.localize)(14,null,this.sb(o)),7,r,i)}async canMove(o,r,i){return this.M(o,r,"move",i)}async canCopy(o,r,i){return this.M(o,r,"copy",i)}async M(o,r,i,s){if(o.toString()!==r.toString())try{const l=i==="move"?this.qb(await this.n(o),o):await this.m(o),b=this.qb(await this.n(r),r);await this.Q(l,o,b,r,i,s)}catch(l){return l}return!0}async move(o,r,i){const s=this.qb(await this.n(o),o),l=this.qb(await this.n(r),r),b=await this.N(s,o,l,r,"move",!!i),D=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new p.$Xk(o,b==="move"?2:3,D)),D}async copy(o,r,i){const s=await this.m(o),l=this.qb(await this.n(r),r),b=await this.N(s,o,l,r,"copy",!!i),D=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new p.$Xk(o,b==="copy"?3:2,D)),D}async N(o,r,i,s,l,b){if(r.toString()===s.toString())return l;const{exists:D,isSameResourceWithDifferentPathCase:j}=await this.Q(o,r,i,s,l,b);if(D&&!j&&b&&await this.del(s,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(s)),l==="copy"){if(o===i&&(0,p.$Jk)(o))await o.copy(r,s,{overwrite:b});else{const E=await this.resolve(r);E.isDirectory?await this.P(o,E,i,s):await this.O(o,r,i,s)}return l}else return o===i?(await o.rename(r,s,{overwrite:b}),l):(await this.N(o,r,i,s,"copy",b),await this.del(r,{recursive:!0}),"copy")}async O(o,r,i,s){if((0,p.$Lk)(o)&&(0,p.$Lk)(i))return this.jb(o,r,i,s);if((0,p.$Lk)(o)&&(0,p.$Ik)(i))return this.pb(o,r,i,s);if((0,p.$Ik)(o)&&(0,p.$Lk)(i))return this.nb(o,r,i,s);if((0,p.$Ik)(o)&&(0,p.$Ik)(i))return this.lb(o,r,i,s)}async P(o,r,i,s){await i.mkdir(s),Array.isArray(r.children)&&await R.Promises.settled(r.children.map(async l=>{const b=this.R(i).providerExtUri.joinPath(s,l.name);return l.isDirectory?this.P(o,await this.resolve(l.resource),i,b):this.O(o,l.resource,i,b)}))}async Q(o,r,i,s,l,b){let D=!1;if(o===i){const{providerExtUri:E,isPathCaseSensitive:I}=this.R(o);if(I||(D=E.isEqual(r,s)),D&&l==="copy")throw new Error((0,w.localize)(15,null,this.sb(r),this.sb(s)));if(!D&&E.isEqualOrParent(s,r))throw new Error((0,w.localize)(16,null,this.sb(r),this.sb(s)))}const j=await this.exists(s);if(j&&!D){if(!b)throw new p.$1k((0,w.localize)(17,null,this.sb(r),this.sb(s)),4);if(o===i){const{providerExtUri:E}=this.R(o);if(E.isEqualOrParent(r,s))throw new Error((0,w.localize)(18,null,this.sb(r),this.sb(s)))}}return{exists:j,isSameResourceWithDifferentPathCase:D}}R(o){const r=this.S(o);return{providerExtUri:r?$.$Ig:$.$Kg,isPathCaseSensitive:r}}S(o){return!!(o.capabilities&1024)}async createFolder(o){const r=this.qb(await this.j(o),o);await this.U(r,o);const i=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new p.$Xk(o,0,i)),i}async U(o,r){const i=[],{providerExtUri:s}=this.R(o);for(;!s.isEqual(r,s.dirname(r));)try{if(!((await o.stat(r)).type&p.FileType.Directory))throw new Error((0,w.localize)(19,null,this.sb(r)));break}catch(l){if((0,p.$Vk)(l)!==p.FileSystemProviderErrorCode.FileNotFound)throw l;i.push(s.basename(r)),r=s.dirname(r)}for(let l=i.length-1;l>=0;l--){r=s.joinPath(r,i[l]);try{await o.mkdir(r)}catch(b){if((0,p.$Vk)(b)!==p.FileSystemProviderErrorCode.FileExists)throw b}}}async canDelete(o,r){try{await this.W(o,r)}catch(i){return i}return!0}async W(o,r){const i=this.qb(await this.j(o),o),s=!!r?.useTrash;if(s&&!(i.capabilities&4096))throw new Error((0,w.localize)(20,null,this.sb(o)));const l=r?.atomic;if(l&&!(i.capabilities&65536))throw new Error((0,w.localize)(21,null,this.sb(o)));if(s&&l)throw new Error((0,w.localize)(22,null,this.sb(o)));let b;try{b=await i.stat(o)}catch{}if(b)this.rb(o,b);else throw new p.$1k((0,w.localize)(23,null,this.sb(o)),1);if(!!!r?.recursive){const j=await this.resolve(o);if(j.isDirectory&&Array.isArray(j.children)&&j.children.length>0)throw new Error((0,w.localize)(24,null,this.sb(o)))}return i}async del(o,r){const i=await this.W(o,r);let s=r;if((0,p.$Pk)(i)&&!s?.atomic){const j=i.enforceAtomicDelete?.(o);j&&(s={...r,atomic:j})}const l=!!s?.useTrash,b=!!s?.recursive,D=s?.atomic??!1;await i.delete(o,{recursive:b,useTrash:l,atomic:D}),this.r.fire(new p.$Xk(o,1))}async cloneFile(o,r){const i=await this.j(o),s=this.qb(await this.n(r),r);if(!(i===s&&this.R(i).providerExtUri.isEqual(o,r)))return i===s&&(0,p.$Kk)(i)?i.cloneFile(o,r):(await this.U(s,this.R(s).providerExtUri.dirname(r)),i===s&&(0,p.$Jk)(i)?this.cb.queueFor(o,()=>i.copy(o,r,{overwrite:!0}),this.R(i).providerExtUri):this.cb.queueFor(o,()=>this.O(i,o,s,r),this.R(i).providerExtUri))}static{this.ab=0}createWatcher(o,r){return this.watch(o,{...r,correlationId:g.ab++})}watch(o,r={recursive:!1,excludes:[]}){const i=new c.$Sc;let s=!1,l=()=>{s=!0};i.add((0,c.$Rc)(()=>l())),(async()=>{try{const D=await this.bb(o,r);s?(0,c.$Oc)(D):l=()=>(0,c.$Oc)(D)}catch(D){this.b.error(D)}})();const b=r.correlationId;if(typeof b=="number"){const D=i.add(new C.$5d);return i.add(this.X.event(E=>{E.correlates(b)&&D.fire(E)})),{onDidChange:D.event,dispose:()=>i.dispose()}}return i}async bb(o,r){const i=await this.j(o),s=(0,S.$6i)([this.R(i).providerExtUri.getComparisonKey(o),r]);let l=this.$.get(s);return l||(l={count:0,disposable:i.watch(o,r)},this.$.set(s,l)),l.count+=1,(0,c.$Rc)(()=>{l&&(l.count--,l.count===0&&((0,c.$Oc)(l.disposable),this.$.delete(s)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,c.$Oc)(o.disposable);this.$.clear()}async db(o,r,i,s){return this.cb.queueFor(r,async()=>{const l=await o.open(r,{create:!0,unlock:i?.unlock??!1});try{(0,m.$ee)(s)||(0,m.$fe)(s)?await this.eb(o,l,s):await this.fb(o,l,s)}catch(b){throw(0,p.$Tk)(b)}finally{await o.close(l)}},this.R(o).providerExtUri)}async eb(o,r,i){let s=0,l;if((0,m.$fe)(i)){if(i.buffer.length>0){const b=P.$se.concat(i.buffer);await this.gb(o,r,b,b.byteLength,s,0),s+=b.byteLength}if(i.ended)return;l=i.stream}else l=i;return new Promise((b,D)=>{(0,m.$ke)(l,{onData:async j=>{l.pause();try{await this.gb(o,r,j,j.byteLength,s,0)}catch(E){return D(E)}s+=j.byteLength,setTimeout(()=>l.resume())},onError:j=>D(j),onEnd:()=>b()})})}async fb(o,r,i){let s=0,l;for(;(l=i.read())!==null;)await this.gb(o,r,l,l.byteLength,s,0),s+=l.byteLength}async gb(o,r,i,s,l,b){let D=0;for(;D<s;){const j=await o.write(r,l+D,i.buffer,b+D,s-D);D+=j}}async hb(o,r,i,s){return this.cb.queueFor(r,()=>this.ib(o,r,i,s),this.R(o).providerExtUri)}async ib(o,r,i,s){let l;s instanceof P.$se?l=s:(0,m.$ee)(s)?l=await(0,P.$Ee)(s):(0,m.$fe)(s)?l=await(0,P.$Fe)(s):l=(0,P.$Ce)(s),await o.writeFile(r,l.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(o,r,i,s){return this.cb.queueFor(s,()=>this.kb(o,r,i,s),this.R(i).providerExtUri)}async kb(o,r,i,s){let l,b;try{l=await o.open(r,{create:!1}),b=await i.open(s,{create:!0,unlock:!1});const D=P.$se.alloc(this.a);let j=0,E=0,I=0;do I=await o.read(l,j,D.buffer,E,D.byteLength-E),await this.gb(i,b,D,I,j,E),j+=I,E+=I,E===D.byteLength&&(E=0);while(I>0)}catch(D){throw(0,p.$Tk)(D)}finally{await R.Promises.settled([typeof l=="number"?o.close(l):Promise.resolve(),typeof b=="number"?i.close(b):Promise.resolve()])}}async lb(o,r,i,s){return this.cb.queueFor(s,()=>this.mb(o,r,i,s),this.R(i).providerExtUri)}async mb(o,r,i,s){return i.writeFile(s,await o.readFile(r),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,r,i,s){return this.cb.queueFor(s,()=>this.ob(o,r,i,s),this.R(i).providerExtUri)}async ob(o,r,i,s){const l=await i.open(s,{create:!0,unlock:!1});try{const b=await o.readFile(r);await this.gb(i,l,P.$se.wrap(b),b.byteLength,0,0)}catch(b){throw(0,p.$Tk)(b)}finally{await i.close(l)}}async pb(o,r,i,s){const l=await(0,P.$Ee)(this.H(o,r,O.CancellationToken.None));await this.hb(i,s,void 0,l)}qb(o,r){if(o.capabilities&2048)throw new p.$1k((0,w.localize)(25,null,this.sb(r)),6);return o}rb(o,r){if((r.permissions??0)&p.FilePermission.Readonly)throw new p.$1k((0,w.localize)(26,null,this.sb(o)),6)}sb(o){return o.scheme===v.Schemas.file?o.fsPath:o.toString(!0)}};e.$qq=a,e.$qq=a=g=ve([se(0,f.$zj)],a)}),define(ae[94],ce([0,1,46,313,8,31,17,3,33,2,9,4,19,62,21,181,16,121,223,51,219,218]),function(X,e,n,R,P,O,C,S,d,c,y,v,k,$,m,w,p,u,f,h,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=void 0,(()=>{try{(0,R.gracefulify)(n)}catch(o){console.error(`Error enabling graceful-fs: ${(0,h.$3i)(o)}`)}})();class t extends f.$zq{static{this.I=!1}constructor(r,i){super(r,i),this.onDidChangeCapabilities=S.Event.None,this.N=new O.$Ac(s=>k.$Jg.getComparisonKey(s)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,v.$k&&(this.J|=1024)),this.J}async stat(r){try{const{stat:i,symbolicLink:s}=await m.SymlinkSupport.stat(this.H(r));return{type:this.M(i,s),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:p.FilePermission.Locked}}catch(i){throw this.fb(i)}}async L(r){try{return await this.stat(r)}catch{return}}async readdir(r){try{const i=await m.Promises.readdir(this.H(r),{withFileTypes:!0}),s=[];return await Promise.all(i.map(async l=>{try{let b;l.isSymbolicLink()?b=(await this.stat((0,k.$Sg)(r,l.name))).type:b=this.M(l),s.push([l.name,b])}catch(b){this.a.trace(b)}})),s}catch(i){throw this.fb(i)}}M(r,i){let s;return i?.dangling?s=p.FileType.Unknown:r.isFile()?s=p.FileType.File:r.isDirectory()?s=p.FileType.Directory:s=p.FileType.Unknown,i&&(s|=p.FileType.SymbolicLink),s}async O(r){const i=this.H(r);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let s;for(;s=this.N.get(r);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await s.wait();const l=new P.$eh;return this.N.set(r,l),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,c.$Rc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(r)===l&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(r)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),l.open()})}async readFile(r,i){let s;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(r)})`),s=await this.O(r));const l=this.H(r);return await m.Promises.readFile(l)}catch(l){throw this.fb(l)}finally{s?.dispose()}}P(r){t.I&&this.a.trace(r)}readFileStream(r,i,s){const l=(0,$.$ge)(b=>C.$se.concat(b.map(D=>C.$se.wrap(D))).buffer);return(0,u.$pq)(this,r,l,b=>b.buffer,{...i,bufferSize:256*1024},s),l}async writeFile(r,i,s){return s?.atomic!==!1&&s?.atomic?.postfix&&await this.Q(r)?this.R(r,(0,k.$Sg)((0,k.$Rg)(r),`${(0,k.$Pg)(r)}${s.atomic.postfix}`),i,s):this.S(r,i,s)}async Q(r){try{const i=this.H(r),{symbolicLink:s}=await m.SymlinkSupport.stat(i);if(s)return!1}catch{}return!0}async R(r,i,s,l){const b=new c.$Sc;try{b.add(await this.O(r)),b.add(await this.O(i)),await this.S(i,s,l,!0);try{await this.rename(i,r,{overwrite:!0})}catch(D){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw D}}finally{b.dispose()}}async S(r,i,s,l){let b;try{const D=this.H(r);if(!s.create||!s.overwrite){if(await m.Promises.exists(D)){if(!s.overwrite)throw(0,p.$Sk)((0,w.localize)(0,null),p.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,p.$Sk)((0,w.localize)(1,null),p.FileSystemProviderErrorCode.FileNotFound)}b=await this.open(r,{create:!0,unlock:s.unlock},l),await this.write(b,0,i,0,i.byteLength)}catch(D){throw await this.gb(r,D)}finally{typeof b=="number"&&await this.close(b)}}static{this.Y=!0}static configureFlushOnWrite(r){t.Y=r}async open(r,i,s){const l=this.H(r);let b;(0,p.$Gk)(i)&&!s&&(b=await this.O(r));let D;try{if((0,p.$Gk)(i)&&i.unlock)try{const{stat:E}=await m.SymlinkSupport.stat(l);E.mode&128||await m.Promises.chmod(l,E.mode|128)}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}let j;if((0,p.$Gk)(i)){if(v.$i)try{await m.Promises.truncate(l,0),j="r+"}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}j||(j="w")}else j="r";D=await m.Promises.open(l,j)}catch(j){throw b?.dispose(),(0,p.$Gk)(i)?await this.gb(r,j):this.fb(j)}if(this.U.set(D,0),(0,p.$Gk)(i)&&this.X.set(D,r),b){const j=this.W.get(D);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${D} (${l})`),this.W.set(D,b),j&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${D} (${l})`),j.dispose())}return D}async close(r){const i=this.W.get(r);try{if(this.U.delete(r),this.X.delete(r)&&t.Y)try{await m.Promises.fdatasync(r)}catch(s){t.configureFlushOnWrite(!1),this.a.error(s)}return await m.Promises.close(r)}catch(s){throw this.fb(s)}finally{i&&(this.W.get(r)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.W.delete(r)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),i.dispose())}}async read(r,i,s,l,b){const D=this.Z(r,i);let j=null;try{j=(await m.Promises.read(r,s,l,b,D)).bytesRead}catch(E){throw this.fb(E)}finally{this.$(r,D,j)}return j}Z(r,i){return i===this.U.get(r)?null:i}$(r,i,s){const l=this.U.get(r);typeof l=="number"&&(typeof i=="number"||(typeof s=="number"?this.U.set(r,l+s):this.U.delete(r)))}async write(r,i,s,l,b){return(0,P.$zh)(()=>this.ab(r,i,s,l,b),100,3)}async ab(r,i,s,l,b){const D=this.Z(r,i);let j=null;try{j=(await m.Promises.write(r,s,l,b,D)).bytesWritten}catch(E){throw await this.gb(this.X.get(r),E)}finally{this.$(r,D,j)}return j}async mkdir(r){try{await m.Promises.mkdir(this.H(r))}catch(i){throw this.fb(i)}}async delete(r,i){try{const s=this.H(r);if(i.recursive){let l;i?.atomic!==!1&&i.atomic.postfix&&(l=(0,y.$jc)((0,y.$mc)(s),`${(0,y.$nc)(s)}${i.atomic.postfix}`)),await m.Promises.rm(s,m.RimRafMode.MOVE,l)}else try{await m.Promises.unlink(s)}catch(l){if(l.code==="EPERM"||l.code==="EISDIR"){let b=!1;try{const{stat:D,symbolicLink:j}=await m.SymlinkSupport.stat(s);b=D.isDirectory()&&!j}catch{}if(b)await m.Promises.rmdir(s);else throw l}else throw l}}catch(s){throw this.fb(s)}}async rename(r,i,s){const l=this.H(r),b=this.H(i);if(l!==b)try{await this.bb(r,i,"move",s.overwrite),await m.Promises.rename(l,b)}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,w.localize)(2,null,(0,y.$nc)(l),(0,y.$nc)((0,y.$mc)(b)),D.toString()))),this.fb(D)}}async copy(r,i,s){const l=this.H(r),b=this.H(i);if(l!==b)try{await this.bb(r,i,"copy",s.overwrite),await m.Promises.copy(l,b,{preserveSymlinks:!0})}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,w.localize)(3,null,(0,y.$nc)(l),(0,y.$nc)((0,y.$mc)(b)),D.toString()))),this.fb(D)}}async bb(r,i,s,l){const b=this.H(r),D=this.H(i);let j=!1;if(!!(this.capabilities&1024)||(j=(0,d.$eg)(b,D,!0)),j){if(s==="copy")throw(0,p.$Sk)((0,w.localize)(4,null),p.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const I=await this.L(r);if(!I)throw(0,p.$Sk)((0,w.localize)(5,null),p.FileSystemProviderErrorCode.FileNotFound);const M=await this.L(i);if(M){if(!l)throw(0,p.$Sk)((0,w.localize)(6,null),p.FileSystemProviderErrorCode.FileExists);I.type&p.FileType.File&&M.type&p.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(r,i){return this.cb(r,i,!1)}async cb(r,i,s){const l=this.H(r),b=this.H(i),D=!!(this.capabilities&1024);if((0,d.$eg)(l,b,!D))return;const j=new c.$Sc;try{j.add(await this.O(r)),j.add(await this.O(i)),s&&await m.Promises.mkdir((0,y.$mc)(b),{recursive:!0}),await m.Promises.copyFile(l,b)}catch(E){if(E.code==="ENOENT"&&!s)return this.cb(r,i,!0);throw this.fb(E)}finally{j.dispose()}}t(r,i,s){return new g.$Gq(l=>r(l),l=>i(l),s)}F(r,i,s){return new a.$Oq(l=>r(l),l=>i(l),s)}fb(r){if(r instanceof p.$Rk)return r;let i=r,s;switch(r.code){case"ENOENT":s=p.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=p.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=p.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=p.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=p.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${r.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=p.FileSystemProviderErrorCode.Unknown;break;default:s=p.FileSystemProviderErrorCode.Unknown}return(0,p.$Sk)(i,s)}async gb(r,i){let s=this.fb(i);if(r&&s.code===p.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await m.SymlinkSupport.stat(this.H(r));l.mode&128||(s=(0,p.$Sk)(i,p.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.a.trace(l)}return s}}e.$Pq=t}),define(ae[225],ce([0,1,3,94,2,17,62,23]),function(X,e,n,R,P,O,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ns=e.$ms=void 0;class d extends P.$Tc{constructor(v,k){super(),this.a=v,this.b=k,this.F=new Map,this.G=new Map}call(v,k,$){const m=this.c(v);switch(k){case"stat":return this.g(m,$[0]);case"readdir":return this.h(m,$[0]);case"open":return this.r(m,$[0],$[1]);case"close":return this.s($[0]);case"read":return this.t($[0],$[1],$[2]);case"readFile":return this.j(m,$[0],$[1]);case"write":return this.u($[0],$[1],$[2],$[3],$[4]);case"writeFile":return this.n(m,$[0],$[1],$[2]);case"rename":return this.z(m,$[0],$[1],$[2]);case"copy":return this.C(m,$[0],$[1],$[2]);case"cloneFile":return this.D(m,$[0],$[1]);case"mkdir":return this.w(m,$[0]);case"delete":return this.y(m,$[0],$[1]);case"watch":return this.I(m,$[0],$[1],$[2],$[3]);case"unwatch":return this.J($[0],$[1])}throw new Error(`IPC Command ${k} not found`)}listen(v,k,$){const m=this.c(v);switch(k){case"fileChange":return this.H(m,$[0]);case"readFileStream":return this.m(m,$[0],$[1])}throw new Error(`Unknown event ${k}`)}g(v,k){const $=this.f(v,k,!0);return this.a.stat($)}h(v,k){const $=this.f(v,k);return this.a.readdir($)}async j(v,k,$){const m=this.f(v,k,!0),w=await this.a.readFile(m,$);return O.$se.wrap(w)}m(v,k,$){const m=this.f(v,k,!0),w=new S.$ce,p=new n.$5d({onDidRemoveLastListener:()=>{w.cancel()}}),u=this.a.readFileStream(m,$,w.token);return(0,C.$ke)(u,{onData:f=>p.fire(O.$se.wrap(f)),onError:f=>p.fire(f),onEnd:()=>{p.fire("end"),p.dispose(),w.dispose()}}),p.event}n(v,k,$,m){const w=this.f(v,k);return this.a.writeFile(w,$.buffer,m)}r(v,k,$){const m=this.f(v,k,!0);return this.a.open(m,$)}s(v){return this.a.close(v)}async t(v,k,$){const m=O.$se.alloc($),p=await this.a.read(v,k,m.buffer,0,$);return[m,p]}u(v,k,$,m,w){return this.a.write(v,k,$.buffer,m,w)}w(v,k){const $=this.f(v,k);return this.a.mkdir($)}y(v,k,$){const m=this.f(v,k);return this.a.delete(m,$)}z(v,k,$,m){const w=this.f(v,k),p=this.f(v,$);return this.a.rename(w,p,m)}C(v,k,$,m){const w=this.f(v,k),p=this.f(v,$);return this.a.copy(w,p,m)}D(v,k,$){const m=this.f(v,k),w=this.f(v,$);return this.a.cloneFile(m,w)}H(v,k){const $=new n.$5d({onWillAddFirstListener:()=>{this.F.set(k,this.L(v,$))},onDidRemoveLastListener:()=>{(0,P.$Oc)(this.F.get(k)),this.F.delete(k)}});return $.event}async I(v,k,$,m,w){const p=this.F.get(k);if(p){const u=this.f(v,m),f=p.watch($,u,w);this.G.set(k+$,f)}}async J(v,k){const $=v+k,m=this.G.get($);m&&((0,P.$Oc)(m),this.G.delete($))}dispose(){super.dispose();for(const[,v]of this.G)v.dispose();this.G.clear();for(const[,v]of this.F)v.dispose();this.F.clear()}}e.$ms=d;class c extends P.$Tc{constructor(v,k,$,m){super(),this.c=v,this.f=$,this.g=m,this.a=new Map,this.b=this.B(new R.$Pq(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(k)}h(v){const k=this.B(new n.$5d);this.B(k.event($=>{v.fire($.map(m=>({resource:this.c.transformOutgoingURI(m.resource),type:m.type,cId:m.cId})))})),this.B(this.b.onDidChangeFile($=>k.fire($))),this.B(this.b.onDidWatchError($=>v.fire($)))}j(v){}m(v){}watch(v,k,$){const m=this.m(this.g);return Array.isArray(m)&&($.excludes=[...$.excludes,...m]),this.a.set(v,this.b.watch(k,$)),(0,P.$Rc)(()=>{(0,P.$Oc)(this.a.get(v)),this.a.delete(v)})}dispose(){for(const[,v]of this.a)v.dispose();this.a.clear(),super.dispose()}}e.$ns=c}),define(ae[226],ce([0,1,14,180,4,7,16,9,225,157]),function(X,e,n,R,P,O,C,S,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w_b=void 0;class y extends d.$ms{constructor($,m,w){super($,m),this.M=w}c($){return c.$hn}f($,m){return O.URI.revive(m)}async y($,m,w){if(!w.useTrash)return super.y($,m,w);const p=this.f($,m),u=(0,S.$hc)(p.fsPath);try{await n.shell.trashItem(u)}catch{throw(0,C.$Sk)(P.$i?(0,R.localize)(0,null,(0,S.$nc)(u)):(0,R.localize)(1,null,(0,S.$nc)(u)),C.FileSystemProviderErrorCode.Unknown)}}L($,m){return new v($,m,this.b,this.M)}}e.$w_b=y;class v extends d.$ns{watch($,m,w){if(w.recursive)throw(0,C.$Sk)("Recursive file watching is not supported from main process for performance reasons.",C.FileSystemProviderErrorCode.Unavailable);return super.watch($,m,w)}}}),define(ae[227],ce([0,1,5]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m9b=void 0;class R extends n.$Fj{constructor(O=n.$Cj){super(),this.m=[],this.n=void 0,this.setLevel(O),this.B(this.onDidChangeLogLevel(C=>{this.n?.setLevel(C)}))}set logger(O){this.n=O;for(const{level:C,message:S}of this.m)(0,n.log)(O,C,S);this.m=[]}g(O,C){this.n?(0,n.log)(this.n,O,C):this.getLevel()<=O&&this.m.push({level:O,message:C})}dispose(){this.n?.dispose(),super.dispose()}flush(){this.n?.flush()}}e.$m9b=R}),define(ae[228],ce([0,1,7,3,5,2]),function(X,e,n,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qr=e.$Pr=e.$Or=void 0;class C extends P.$Kj{constructor(v,k,$,m,w){super(k,$,m),this.r=v,this.t=w,this.B(w.listen("onDidChangeLogLevel",v)(p=>{(0,P.$Bj)(p)?super.setLogLevel(p):super.setLogLevel(n.URI.revive(p[0]),p[1])})),this.B(w.listen("onDidChangeVisibility",v)(([p,u])=>super.setVisibility(n.URI.revive(p),u))),this.B(w.listen("onDidChangeLoggers",v)(({added:p,removed:u})=>{for(const f of p)super.registerLogger({...f,resource:n.URI.revive(f.resource)});for(const f of u)super.deregisterLogger(f.resource)}))}createConsoleMainLogger(){return new P.$Ij({log:(v,k)=>{this.t.call("consoleLog",[v,k])}})}registerLogger(v){super.registerLogger(v),this.t.call("registerLogger",[v,this.r])}deregisterLogger(v){super.deregisterLogger(v),this.t.call("deregisterLogger",[v,this.r])}setLogLevel(v,k){super.setLogLevel(v,k),this.t.call("setLogLevel",[v,k])}setVisibility(v,k){super.setVisibility(v,k),this.t.call("setVisibility",[this.n(v),k])}s(v,k,$){return new S(this.t,v,k,$,this.r)}static setLogLevel(v,k,$){return v.call("setLogLevel",[k,$])}}e.$Or=C;class S extends P.$Fj{constructor(v,k,$,m,w){super(m?.logLevel==="always"),this.r=v,this.s=k,this.m=!1,this.n=[],this.setLevel($),this.r.call("createLogger",[k,m,w]).then(()=>{this.u(this.n),this.m=!0})}g(v,k){const $=[[v,k]];this.m?this.u($):this.n.push(...$)}u(v){this.r.call("log",[this.s,v])}}class d{constructor(v,k){this.a=v,this.b=k}listen(v,k){const $=this.b(v);switch(k){case"onDidChangeLoggers":return R.Event.map(this.a.onDidChangeLoggers,m=>({added:[...m.added].map(w=>this.c(w,$)),removed:[...m.removed].map(w=>this.c(w,$))}));case"onDidChangeVisibility":return R.Event.map(this.a.onDidChangeVisibility,m=>[$.transformOutgoingURI(m[0]),m[1]]);case"onDidChangeLogLevel":return R.Event.map(this.a.onDidChangeLogLevel,m=>(0,P.$Bj)(m)?m:[$.transformOutgoingURI(m[0]),m[1]])}throw new Error(`Event not found: ${k}`)}async call(v,k,$){const m=this.b(v);switch(k){case"setLogLevel":return(0,P.$Bj)($[0])?this.a.setLogLevel($[0]):this.a.setLogLevel(n.URI.revive(m.transformIncoming($[0][0])),$[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(w=>this.c(w,m)))}throw new Error(`Call not found: ${k}`)}c(v,k){return{...v,resource:k.transformOutgoingURI(v.resource)}}}e.$Pr=d;class c extends O.$Tc{constructor(v,k){super(),k.call("setLogLevel",[v.getLogLevel()]),this.B(v.onDidChangeLogLevel($=>k.call("setLogLevel",[$]))),k.call("getRegisteredLoggers").then($=>{for(const m of $)v.registerLogger({...m,resource:n.URI.revive(m.resource)})}),this.B(k.listen("onDidChangeVisibility")(([$,m])=>v.setVisibility(n.URI.revive($),m))),this.B(k.listen("onDidChangeLoggers")(({added:$,removed:m})=>{for(const w of $)v.registerLogger({...w,resource:n.URI.revive(w.resource)});for(const w of m)v.deregisterLogger(w.resource)}))}}e.$Qr=c}),define(ae[229],ce([0,1,2,5]),function(X,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IP=void 0;class P extends n.$Tc{constructor(C,S=[]){super(),this.a=new R.$Jj([C,...S]),this.B(C.onDidChangeLogLevel(d=>this.setLevel(d)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(C){this.a.setLevel(C)}getLevel(){return this.a.getLevel()}trace(C,...S){this.a.trace(C,...S)}debug(C,...S){this.a.debug(C,...S)}info(C,...S){this.a.info(C,...S)}warn(C,...S){this.a.warn(C,...S)}error(C,...S){this.a.error(C,...S)}flush(){this.a.flush()}}e.$IP=P}),define(ae[230],ce([0,1,31,7,5]),function(X,e,n,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rac=void 0;class O{constructor(S){this.b=S,this.a=new n.$Ac}listen(S,d,c){switch(d){case"onDidChangeLoggers":return c?this.b.getOnDidChangeLoggersEvent(c):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return c?this.b.getOnDidChangeLogLevelEvent(c):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return c?this.b.getOnDidChangeVisibilityEvent(c):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${d}`)}async call(S,d,c){switch(d){case"createLogger":this.c(R.URI.revive(c[0]),c[1],c[2]);return;case"log":return this.e(R.URI.revive(c[0]),c[1]);case"consoleLog":return this.d(c[0],c[1]);case"setLogLevel":return(0,P.$Bj)(c[0])?this.b.setLogLevel(c[0]):this.b.setLogLevel(R.URI.revive(c[0]),c[1]);case"setVisibility":return this.b.setVisibility(R.URI.revive(c[0]),c[1]);case"registerLogger":return this.b.registerLogger({...c[0],resource:R.URI.revive(c[0].resource)},c[1]);case"deregisterLogger":return this.b.deregisterLogger(R.URI.revive(c[0]))}throw new Error(`Call not found: ${d}`)}c(S,d,c){this.a.set(S,this.b.createLogger(S,d,c))}d(S,d){let c=console.log;switch(S){case P.LogLevel.Error:c=console.error;break;case P.LogLevel.Warning:c=console.warn;break;case P.LogLevel.Info:c=console.info;break}c.call(console,...d)}e(S,d){const c=this.a.get(S);if(!c)throw new Error("Create the logger before logging");for(const[y,v]of d)(0,P.log)(c,y,v)}}e.$rac=O}),define(ae[231],ce([0,1,16,5]),function(X,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xP=void 0;var P;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(P||(P={}));async function O(c,y,v,k,$){try{const m=await new Promise((p,u)=>{X(["@vscode/spdlog"],p,u)});m.setFlushOn(P.Trace);const w=await m.createAsyncRotatingLogger(c,y,v,k);return $?w.clearFormatters():w.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),w}catch(m){console.error(m)}return null}function C(c,y,v){switch(y){case R.LogLevel.Trace:c.trace(v);break;case R.LogLevel.Debug:c.debug(v);break;case R.LogLevel.Info:c.info(v);break;case R.LogLevel.Warning:c.warn(v);break;case R.LogLevel.Error:c.error(v);break;case R.LogLevel.Off:break;default:throw new Error(`Invalid log level ${y}`)}}function S(c,y){switch(y){case R.LogLevel.Trace:c.setLevel(P.Trace);break;case R.LogLevel.Debug:c.setLevel(P.Debug);break;case R.LogLevel.Info:c.setLevel(P.Info);break;case R.LogLevel.Warning:c.setLevel(P.Warning);break;case R.LogLevel.Error:c.setLevel(P.Error);break;case R.LogLevel.Off:c.setLevel(P.Off);break;default:throw new Error(`Invalid log level ${y}`)}}class d extends R.$Fj{constructor(y,v,k,$,m){super(),this.m=[],this.setLevel(m),this.n=this.s(y,v,k,$),this.B(this.onDidChangeLogLevel(w=>{this.r&&S(this.r,w)}))}async s(y,v,k,$){const m=k?6:1,w=30/m*n.$bl.MB,p=await O(y,v,w,m,$);if(p){this.r=p,S(this.r,this.getLevel());for(const{level:u,message:f}of this.m)C(this.r,u,f);this.m=[]}}g(y,v){this.r?C(this.r,y,v):this.getLevel()<=y&&this.m.push({level:y,message:v})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$xP=d}),define(ae[232],ce([0,1,32,5,231]),function(X,e,n,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yP=void 0;class O extends R.$Kj{s(S,d,c){return new P.$xP((0,n.$Bg)(),S.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,d)}}e.$yP=O}),define(ae[67],ce([0,1,31,3,6,5,232]),function(X,e,n,R,P,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5$b=e.$4$b=void 0,e.$4$b=(0,P.$gi)(O.$Aj);class S extends C.$yP{constructor(){super(...arguments),this.u=new n.$Ac}createLogger(c,y,v){v!==void 0&&this.u.set(this.n(c),v);try{return super.createLogger(c,y)}catch(k){throw this.u.delete(this.n(c)),k}}registerLogger(c,y){y!==void 0&&this.u.set(c.resource,y),super.registerLogger(c)}deregisterLogger(c){this.u.delete(c),super.deregisterLogger(c)}getRegisteredLoggers(c){const y=[];for(const v of super.getRegisteredLoggers())c===this.u.get(v.resource)&&y.push(v);return y}getOnDidChangeLogLevelEvent(c){return R.Event.filter(this.onDidChangeLogLevel,y=>(0,O.$Bj)(y)||this.w(y[0],c))}getOnDidChangeVisibilityEvent(c){return R.Event.filter(this.onDidChangeVisibility,([y])=>this.w(y,c))}getOnDidChangeLoggersEvent(c){return R.Event.filter(R.Event.map(this.onDidChangeLoggers,y=>({added:[...y.added].filter(k=>this.w(k.resource,c)),removed:[...y.removed].filter(k=>this.w(k.resource,c))})),y=>y.added.length>0||y.removed.length>0)}deregisterLoggers(c){for(const[y,v]of this.u)v===c&&this.deregisterLogger(y)}w(c,y){const v=this.u.get(c);return v===void 0||v===y}dispose(){super.dispose(),this.u.clear()}}e.$5$b=S}),define(ae[233],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M_b=e.$L_b=e.$K_b=e.$J_b=void 0;function n(C){return C.submenu!==void 0}e.$J_b=n;function R(C){return C.id==="vscode.menubar.separator"}e.$K_b=R;function P(C){return C.uri!==void 0}e.$L_b=P;function O(C){return!n(C)&&!R(C)&&!P(C)}e.$M_b=O}),define(ae[39],ce([0,1,3,71,2,6]),function(X,e,n,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1n=e.$Zn=e.$Yn=void 0,e.$Yn=(0,O.$fi)("policy");class C extends P.$Tc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new n.$5d),this.onDidChange=this.h.event}async updatePolicyDefinitions(c){const y=Object.keys(this.f).length;return this.f={...c,...this.f},y!==Object.keys(this.f).length&&await this.j(c),R.Iterable.reduce(this.g.entries(),(v,[k,$])=>({...v,[k]:$}),{})}getPolicyValue(c){return this.g.get(c)}serialize(){return R.Iterable.reduce(Object.entries(this.f),(c,[y,v])=>({...c,[y]:{definition:v,value:this.g.get(y)}}),{})}}e.$Zn=C;class S{constructor(){this.onDidChange=n.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$1n=S}),define(ae[234],ce([0,1,8,3,71,12,16,5,39]),function(X,e,n,R,P,O,C,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kac=void 0;function c(v,k){const $=[];for(const m of new Set(P.Iterable.concat(v.keys(),k.keys())))v.get(m)!==k.get(m)&&$.push(m);return $}let y=class extends d.$Zn{constructor(k,$,m){super(),this.m=k,this.n=$,this.s=m,this.c=this.B(new n.$dh(500));const w=R.Event.filter($.onDidFilesChange,p=>p.affects(k));this.B($.watch(k)),this.B(w(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const k=new Map;try{const $=await this.n.readFile(this.m),m=JSON.parse($.value.toString());if(!(0,O.$Uf)(m))throw new Error("Policy file isn't a JSON object");for(const w of Object.keys(m))this.f[w]&&k.set(w,m[w])}catch($){$.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",$)}return k}async w(){const k=await this.u(),$=c(this.g,k);this.g=k,$.length>0&&this.h.fire($)}};e.$Kac=y,e.$Kac=y=ve([se(1,C.$Fk),se(2,S.$zj)],y)}),define(ae[235],ce([0,1,3,2,39]),function(X,e,n,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jac=e.$iac=void 0;class O{constructor(d){this.b=d,this.a=new R.$Sc}listen(d,c){switch(c){case"onDidChange":return n.Event.map(this.b.onDidChange,y=>y.reduce((v,k)=>({...v,[k]:this.b.getPolicyValue(k)??null}),{}),this.a)}throw new Error(`Event not found: ${c}`)}call(d,c,y){switch(c){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(y)}throw new Error(`Call not found: ${c}`)}dispose(){this.a.dispose()}}e.$iac=O;class C extends P.$Zn{constructor(d,c){super(),this.a=c;for(const y in d){const{definition:v,value:k}=d[y];this.f[y]=v,k!==void 0&&this.g.set(y,k)}this.a.listen("onDidChange")(y=>{for(const v in y){const k=y[v];k===null?this.g.delete(v):this.g.set(v,k)}this.h.fire(Object.keys(y))})}async j(d){const c=await this.a.call("updatePolicyDefinitions",d);for(const y in c)this.g.set(y,c[y])}}e.$jac=C}),define(ae[236],ce([0,1,39,8,2,5]),function(X,e,n,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jac=void 0;let C=class extends n.$Zn{constructor(d,c){super(),this.m=d,this.n=c,this.a=new R.$_g,this.b=this.B(new P.$Uc)}async j(d){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(d).length} policy definitions`);const{createWatcher:c}=await new Promise((y,v)=>{X(["@vscode/policy-watcher"],y,v)});await this.a.queue(()=>new Promise((y,v)=>{try{this.b.value=c(this.n,d,k=>{this.t(k),y()})}catch(k){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",k),v(k)}}))}t(d){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(d)}`);for(const c in d){const y=d[c];y===void 0?this.g.delete(c):this.g.set(c,y)}this.h.fire(Object.keys(d))}};e.$Jac=C,e.$Jac=C=ve([se(0,O.$zj)],C)}),define(ae[79],ce([0,1,36]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let R;const P=globalThis.vscode;if(typeof P<"u"&&typeof P.context<"u"){const O=P.context.configuration();if(O)R=O.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(R=globalThis._VSCODE_PRODUCT_JSON,n.env.VSCODE_DEV&&Object.assign(R,{nameShort:`${R.nameShort} Dev`,nameLong:`${R.nameLong} Dev`,dataFolderName:`${R.dataFolderName}-dev`,serverDataFolderName:R.serverDataFolderName?`${R.serverDataFolderName}-dev`:void 0}),!R.version){const O=globalThis._VSCODE_PACKAGE_JSON;Object.assign(R,{version:O.version})}}else R={},Object.keys(R).length===0&&Object.assign(R,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=R}),define(ae[27],ce([0,1,6]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=e.$Rj=void 0,e.$Rj=(0,n.$fi)("productService"),e.$Sj="vscode://schemas/vscode-product"}),define(ae[237],ce([0,1,8,5]),function(X,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z_b=void 0;let P=class{constructor(C,S,d){this.a=C,this.b=S,this.c=d}async inspect(C){await this.d();const S=this.a.webContents.debugger;await S.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,n.$gh)(C);const d=await S.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),d.profile}async d(){const C=this.a.webContents.debugger;C.attach(),await C.sendCommand("Profiler.enable")}async e(){const C=this.a.webContents.debugger;await C.sendCommand("Profiler.disable"),C.detach()}};e.$z_b=P,e.$z_b=P=ve([se(2,R.$zj)],P)}),define(ae[80],ce([0,1,6]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M$b=void 0,e.$M$b=(0,n.$fi)("protocolMainService")}),define(ae[44],ce([0,1,139,12]),function(X,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wn=void 0;class P{constructor(){this.a=new Map}add(C,S){n.ok(R.$Sf(C)),n.ok(R.$Uf(S)),n.ok(!this.a.has(C),"There is already an extension with this id"),this.a.set(C,S)}knows(C){return this.a.has(C)}as(C){return this.a.get(C)||null}}e.$Wn=new P}),define(ae[238],ce([0,1,3,44]),function(X,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xn=void 0,e.$Xn={JSONContribution:"base.contributions.json"};function P(S){return S.length>0&&S.charAt(S.length-1)==="#"?S.substring(0,S.length-1):S}class O{constructor(){this.b=new n.$5d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(d,c){this.a[P(d)]=c,this.b.fire(d)}notifySchemaChanged(d){this.b.fire(d)}getSchemaContributions(){return{schemas:this.a}}}const C=new O;R.$Wn.add(e.$Xn.JSONContribution,C)}),define(ae[52],ce([0,1,22,3,12,165,18,238,44]),function(X,e,n,R,P,O,C,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.ConfigurationScope=e.$2n=e.EditPresentationTypes=void 0;var c;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$2n={Configuration:"base.contributions.configuration"};var y;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(y||(e.ConfigurationScope=y={})),e.$3n={properties:{},patternProperties:{}},e.$4n={properties:{},patternProperties:{}},e.$5n={properties:{},patternProperties:{}},e.$6n={properties:{},patternProperties:{}},e.$7n={properties:{},patternProperties:{}},e.$8n={properties:{},patternProperties:{}},e.$9n="vscode://schemas/settings/resourceLanguage",e.$0n="vscode://schemas/settings/configurationDefaults";const v=d.$Wn.as(S.$Xn.JSONContribution);class k{constructor(){this.h=new Set,this.i=new R.$5d,this.onDidSchemaChange=this.i.event,this.j=new R.$5d,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:O.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},v.registerSchema(e.$9n,this.g),this.v()}registerConfiguration(t,o=!0){this.registerConfigurations([t],o)}registerConfigurations(t,o=!0){const r=new Set;this.n(t,o,r),v.registerSchema(e.$9n,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(t){const o=new Set;this.o(t,o),v.registerSchema(e.$9n,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:t,remove:o}){const r=new Set;this.o(o,r),this.n(t,!1,r),v.registerSchema(e.$9n,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(t){const o=new Set;this.k(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(t,o){const r=[];for(const{overrides:i,source:s}of t)for(const l in i)if(o.add(l),e.$_n.test(l)){const b=this.a.get(l),D=b?.valuesSources??new Map;if(s)for(const M of Object.keys(i[l]))D.set(M,s);const j={...b?.value||{},...i[l]};this.a.set(l,{source:s,value:j,valuesSources:D});const E=(0,C.$Vi)(l),I={type:"object",default:j,description:O.localize(1,null,E),$ref:e.$9n,defaultDefaultValue:j,source:P.$Sf(s)?void 0:s,defaultValueSource:s};r.push(...w(l)),this.d[l]=I,this.b.properties[l]=I}else{this.a.set(l,{value:i[l],source:s});const b=this.d[l];b&&(this.w(l,b),this.r(l,b))}this.m(r)}deregisterDefaultConfigurations(t){const o=new Set;this.l(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(t,o){for(const{overrides:r,source:i}of t)for(const s in r){const l=this.a.get(s),b=P.$Sf(i)?i:i?.id,D=P.$Sf(l?.source)?l?.source:l?.source?.id;if(b===D)if(o.add(s),this.a.delete(s),e.$_n.test(s))delete this.d[s],delete this.b.properties[s];else{const j=this.d[s];j&&(this.w(s,j),this.r(s,j))}}this.u()}deltaConfiguration(t){let o=!1;const r=new Set;t.removedDefaults&&(this.l(t.removedDefaults,r),o=!0),t.addedDefaults&&(this.k(t.addedDefaults,r),o=!0),t.removedConfigurations&&this.o(t.removedConfigurations,r),t.addedConfigurations&&this.n(t.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const o of t)this.h.add(o);this.u()}n(t,o,r){t.forEach(i=>{this.p(i,o,i.extensionInfo,i.restrictedProperties,void 0,r),this.c.push(i),this.q(i)})}o(t,o){const r=i=>{if(i.properties)for(const s in i.properties){o.add(s);const l=this.d[s];l?.policy?.name&&this.e.delete(l.policy.name),delete this.d[s],this.s(s,i.properties[s])}i.allOf?.forEach(s=>r(s))};for(const i of t){r(i);const s=this.c.indexOf(i);s!==-1&&this.c.splice(s,1)}}p(t,o=!0,r,i,s=3,l){s=P.$2f(t.scope)?s:t.scope;const b=t.properties;if(b)for(const j in b){const E=b[j];if(o&&h(j,E)){delete b[j];continue}if(E.source=r,E.defaultDefaultValue=b[j].default,this.w(j,E),e.$_n.test(j)?E.scope=void 0:(E.scope=P.$2f(E.scope)?s:E.scope,E.restricted=P.$2f(E.restricted)?!!i?.includes(j):E.restricted),b[j].hasOwnProperty("included")&&!b[j].included){this.f[j]=b[j],delete b[j];continue}else this.d[j]=b[j],b[j].policy?.name&&this.e.set(b[j].policy.name,j);!b[j].deprecationMessage&&b[j].markdownDeprecationMessage&&(b[j].deprecationMessage=b[j].markdownDeprecationMessage),l.add(j)}const D=t.allOf;if(D)for(const j of D)this.p(j,o,r,i,s,l)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const o=r=>{const i=r.properties;if(i)for(const l in i)this.r(l,i[l]);r.allOf?.forEach(o)};o(t)}r(t,o){switch(e.$3n.properties[t]=o,o.scope){case 1:e.$4n.properties[t]=o;break;case 2:e.$5n.properties[t]=o;break;case 6:e.$6n.properties[t]=o;break;case 3:e.$7n.properties[t]=o;break;case 4:e.$8n.properties[t]=o;break;case 5:e.$8n.properties[t]=o,this.g.properties[t]=o;break}}s(t,o){switch(delete e.$3n.properties[t],o.scope){case 1:delete e.$4n.properties[t];break;case 2:delete e.$5n.properties[t];break;case 6:delete e.$6n.properties[t];break;case 3:delete e.$7n.properties[t];break;case 4:case 5:delete e.$8n.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const o=`[${t}]`,r={type:"object",description:O.localize(2,null),errorMessage:O.localize(3,null),$ref:e.$9n};this.w(o,r),e.$3n.properties[o]=r,e.$4n.properties[o]=r,e.$5n.properties[o]=r,e.$6n.properties[o]=r,e.$7n.properties[o]=r,e.$8n.properties[o]=r}}v(){const t={type:"object",description:O.localize(4,null),errorMessage:O.localize(5,null),$ref:e.$9n};e.$3n.patternProperties[e.$$n]=t,e.$4n.patternProperties[e.$$n]=t,e.$5n.patternProperties[e.$$n]=t,e.$6n.patternProperties[e.$$n]=t,e.$7n.patternProperties[e.$$n]=t,e.$8n.patternProperties[e.$$n]=t,this.i.fire()}w(t,o){const r=this.a.get(t);let i=r?.value,s=r?.source;P.$Zf(i)&&(i=o.defaultDefaultValue,s=void 0),P.$Zf(i)&&(i=u(o.type)),o.default=i,o.defaultValueSource=s}}const $="\\[([^\\]]+)\\]",m=new RegExp($,"g");e.$$n=`^(${$})+$`,e.$_n=new RegExp(e.$$n);function w(a){const t=[];if(e.$_n.test(a)){let o=m.exec(a);for(;o?.length;){const r=o[1].trim();r&&t.push(r),o=m.exec(a)}}return(0,n.$Mb)(t)}e.$ao=w;function p(a){return a.reduce((t,o)=>`${t}[${o}]`,"")}e.$bo=p;function u(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$co=u;const f=new k;d.$Wn.add(e.$2n.Configuration,f);function h(a,t){return a.trim()?e.$_n.test(a)?O.localize(7,null,a):f.getConfigurationProperties()[a]!==void 0?O.localize(8,null,a):t.policy?.name&&f.getPolicyConfigurations().get(t.policy?.name)!==void 0?O.localize(9,null,a,t.policy?.name,f.getPolicyConfigurations().get(t.policy?.name)):null:O.localize(6,null)}e.$do=h;function g(){const a=[],t=f.getConfigurationProperties();for(const o of Object.keys(t))a.push([o,t[o].scope]);return a.push(["launch",4]),a.push(["task",4]),a}e.$eo=g}),define(ae[122],ce([0,1,22,3,42,2,31,35,12,7,18,52,44]),function(X,e,n,R,P,O,C,S,d,c,y,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=void 0;function $(o){return Object.isFrozen(o)?o:S.$Ln(o)}class m{constructor(r={},i=[],s=[],l){this.b=r,this.c=i,this.d=s,this.raw=l,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(i=>{if(i instanceof m)return i;const s=new w("");return s.parseRaw(i),s.configurationModel});this.f=r.reduce((i,s)=>s===i?s:i.merge(s),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,y.$Ti)(this.contents,r):this.contents}inspect(r,i){const s=this;return{get value(){return $(s.rawConfiguration.getValue(r))},get override(){return i?$(s.rawConfiguration.getOverrideValue(r,i)):void 0},get merged(){return $(i?s.rawConfiguration.override(i).getValue(r):s.rawConfiguration.getValue(r))},get overrides(){const l=[];for(const{contents:b,identifiers:D,keys:j}of s.rawConfiguration.overrides){const E=new m(b,j).getValue(r);E!==void 0&&l.push({identifiers:D,value:E})}return l.length?$(l):void 0}}}getOverrideValue(r,i){const s=this.i(i);return s?r?(0,y.$Ti)(s,r):s:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const s of this.overrides)s.identifiers.includes(r)&&i.push(...s.keys);return n.$Mb(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return n.$Mb(r)}override(r){let i=this.a.get(r);return i||(i=this.g(r),this.a.set(r,i)),i}merge(...r){const i=S.$Kn(this.contents),s=S.$Kn(this.overrides),l=[...this.keys],b=this.raw?.length?[...this.raw]:[this];for(const D of r)if(b.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.h(i,D.contents);for(const j of D.overrides){const[E]=s.filter(I=>n.$ub(I.identifiers,j.identifiers));E?(this.h(E.contents,j.contents),E.keys.push(...j.keys),E.keys=n.$Mb(E.keys)):s.push(S.$Kn(j))}for(const j of D.keys)l.indexOf(j)===-1&&l.push(j)}return new m(i,l,s,b.every(D=>D instanceof m)?void 0:b)}g(r){const i=this.i(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const s={};for(const l of n.$Mb([...Object.keys(this.contents),...Object.keys(i)])){let b=this.contents[l];const D=i[l];D&&(typeof b=="object"&&typeof D=="object"?(b=S.$Kn(b),this.h(b,D)):b=D),s[l]=b}return new m(s,this.keys,this.overrides)}h(r,i){for(const s of Object.keys(i)){if(s in r&&d.$Uf(r[s])&&d.$Uf(i[s])){this.h(r[s],i[s]);continue}r[s]=S.$Kn(i[s])}}i(r){let i=null,s=null;const l=b=>{b&&(s?this.h(s,b):s=S.$Kn(b))};for(const b of this.overrides)b.identifiers.length===1&&b.identifiers[0]===r?i=b.contents:b.identifiers.includes(r)&&l(b.contents);return l(i),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,i){this.j(r,i,!0)}setValue(r,i){this.j(r,i,!1)}removeValue(r){const i=this.keys.indexOf(r);i!==-1&&(this.keys.splice(i,1),(0,y.$Si)(this.contents,r),v.$_n.test(r)&&this.overrides.splice(this.overrides.findIndex(s=>n.$ub(s.identifiers,(0,v.$ao)(r))),1))}j(r,i,s){(0,y.$Ri)(this.contents,r,i,l=>console.error(l)),s=s||this.keys.indexOf(r)===-1,s&&this.keys.push(r),v.$_n.test(r)&&this.overrides.push({identifiers:(0,v.$ao)(r),keys:Object.keys(this.contents[r]),contents:(0,y.$Qi)(this.contents[r],l=>console.error(l))})}}e.$fo=m;class w{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new m}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,i){if(!d.$2f(r)){const s=this.g(r);this.parseRaw(s,i)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,i){this.a=r;const{contents:s,keys:l,overrides:b,restricted:D,hasExcludedProperties:j}=this.h(r,i);this.b=new m(s,l,b,j?[r]:void 0),this.c=D||[]}g(r){let i={},s=null,l=[];const b=[],D=[];function j(I){Array.isArray(l)?l.push(I):s!==null&&(l[s]=I)}const E={onObjectBegin:()=>{const I={};j(I),b.push(l),l=I,s=null},onObjectProperty:I=>{s=I},onObjectEnd:()=>{l=b.pop()},onArrayBegin:()=>{const I=[];j(I),b.push(l),l=I,s=null},onArrayEnd:()=>{l=b.pop()},onLiteralValue:j,onError:(I,M,T)=>{D.push({error:I,offset:M,length:T})}};if(r)try{P.$yn(r,E),i=l[0]||{}}catch(I){console.error(`Error while parsing settings file ${this.f}: ${I}`),this.d=[I]}return i}h(r,i){const s=k.$Wn.as(v.$2n.Configuration).getConfigurationProperties(),l=this.i(r,s,!0,i);r=l.raw;const b=(0,y.$Qi)(r,E=>console.error(`Conflict in settings file ${this.f}: ${E}`)),D=Object.keys(r),j=this.j(r,E=>console.error(`Conflict in settings file ${this.f}: ${E}`));return{contents:b,keys:D,overrides:j,restricted:l.restricted,hasExcludedProperties:l.hasExcludedProperties}}i(r,i,s,l){let b=!1;if(!l?.scopes&&!l?.skipRestricted&&!l?.exclude?.length)return{raw:r,restricted:[],hasExcludedProperties:b};const D={},j=[];for(const E in r)if(v.$_n.test(E)&&s){const I=this.i(r[E],i,!1,l);D[E]=I.raw,b=b||I.hasExcludedProperties,j.push(...I.restricted)}else{const I=i[E],M=I?typeof I.scope<"u"?I.scope:3:void 0;I?.restricted&&j.push(E),!l.exclude?.includes(E)&&(l.include?.includes(E)||(M===void 0||l.scopes===void 0||l.scopes.includes(M))&&!(l.skipRestricted&&I?.restricted))?D[E]=r[E]:b=!0}return{raw:D,restricted:j,hasExcludedProperties:b}}j(r,i){const s=[];for(const l of Object.keys(r))if(v.$_n.test(l)){const b={};for(const D in r[l])b[D]=r[l][D];s.push({identifiers:(0,v.$ao)(l),keys:Object.keys(b),contents:(0,y.$Qi)(b,i)})}return s}}e.$go=w;class p extends O.$Tc{constructor(r,i,s,l){super(),this.c=r,this.f=i,this.g=l,this.b=this.B(new R.$5d),this.onDidChange=this.b.event,this.a=new w(this.c.toString()),this.B(this.g.watch(s.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(R.Event.any(R.Event.filter(this.g.onDidFilesChange,b=>b.contains(this.c)),R.Event.filter(this.g.onDidRunOperation,b=>(b.isOperation(0)||b.isOperation(3)||b.isOperation(1)||b.isOperation(4))&&s.isEqual(b.resource,r)))(()=>this.b.fire()))}async loadConfiguration(){try{const r=await this.g.readFile(this.c);return this.a.parse(r.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new m}}reparse(r){return r&&(this.f=r),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$ho=p;class u{constructor(r,i,s,l,b,D,j,E,I,M,T,W,V){this.a=r,this.b=i,this.c=s,this.overrideIdentifiers=l,this.d=b,this.f=D,this.g=j,this.h=E,this.i=I,this.j=M,this.k=T,this.l=W,this.m=V}get value(){return $(this.c)}n(r){return r?.value!==void 0||r?.override!==void 0||r?.overrides!==void 0?r:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class f{constructor(r,i,s,l,b=new m,D=new m,j=new C.$Ac,E=new m,I=new C.$Ac){this.c=r,this.d=i,this.f=s,this.g=l,this.h=b,this.i=D,this.j=j,this.l=E,this.m=I,this.a=null,this.b=new C.$Ac,this.n=null}getValue(r,i,s){return this.p(r,i,s).getValue(r)}updateValue(r,i,s={}){let l;s.resource?(l=this.m.get(s.resource),l||(l=new m,this.m.set(s.resource,l))):l=this.l,i===void 0?l.removeValue(r):l.setValue(r,i),s.resource||(this.a=null)}inspect(r,i,s){const l=this.p(r,i,s),b=this.t(i.resource,s),D=i.resource?this.m.get(i.resource)||this.l:this.l,j=new Set;for(const E of l.overrides)for(const I of E.identifiers)l.getOverrideValue(r,I)!==void 0&&j.add(I);return new u(r,i,l.getValue(r),j.size?[...j]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this.i:void 0,b||void 0,D)}keys(r){const i=this.t(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,i){this.j.set(r,i),this.b.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const s=[];if(!i){const{added:l,updated:b,removed:D}=a(this.c,r);i=[...l,...b,...D]}for(const l of i)for(const b of(0,v.$ao)(l)){const D=this.c.getKeysForOverrideIdentifier(b),j=r.getKeysForOverrideIdentifier(b),E=[...j.filter(I=>D.indexOf(I)===-1),...D.filter(I=>j.indexOf(I)===-1),...D.filter(I=>!S.$On(this.c.override(b).getValue(I),r.override(b).getValue(I)))];s.push([b,E])}return this.updateDefaultConfiguration(r),{keys:i,overrides:s}}compareAndUpdatePolicyConfiguration(r){const{added:i,updated:s,removed:l}=a(this.d,r),b=[...i,...s,...l];return b.length&&this.updatePolicyConfiguration(r),{keys:b,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:i,updated:s,removed:l,overrides:b}=a(this.applicationConfiguration,r),D=[...i,...s,...l];return D.length&&this.updateApplicationConfiguration(r),{keys:D,overrides:b}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:s,removed:l,overrides:b}=a(this.localUserConfiguration,r),D=[...i,...s,...l];return D.length&&this.updateLocalUserConfiguration(r),{keys:D,overrides:b}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:s,removed:l,overrides:b}=a(this.remoteUserConfiguration,r),D=[...i,...s,...l];return D.length&&this.updateRemoteUserConfiguration(r),{keys:D,overrides:b}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:s,removed:l,overrides:b}=a(this.workspaceConfiguration,r),D=[...i,...s,...l];return D.length&&this.updateWorkspaceConfiguration(r),{keys:D,overrides:b}}compareAndUpdateFolderConfiguration(r,i){const s=this.folderConfigurations.get(r),{added:l,updated:b,removed:D,overrides:j}=a(s,i),E=[...l,...b,...D];return(E.length||!s)&&this.updateFolderConfiguration(r,i),{keys:E,overrides:j}}compareAndDeleteFolderConfiguration(r){const i=this.folderConfigurations.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:s,updated:l,removed:b,overrides:D}=a(i,void 0);return{keys:[...s,...l,...b],overrides:D}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(r,i,s){let l=this.q(i,s);return i.overrideIdentifier&&(l=l.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(l=l.merge(this.d)),l}q({resource:r},i){let s=this.r();if(i&&r){const l=i.getFolder(r);l&&(s=this.s(l.uri)||s);const b=this.m.get(r);b&&(s=s.merge(b))}return s}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(r){let i=this.b.get(r);if(!i){const s=this.r(),l=this.j.get(r);l?(i=s.merge(l),this.b.set(r,i)):i=s}return i}t(r,i){if(i&&r){const s=i.getFolder(r);if(s)return this.j.get(s.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,i)=>{const{contents:s,overrides:l,keys:b}=this.j.get(i);return r.push([i,{contents:s,overrides:l,keys:b}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(i=>r.add(i)),this.userConfiguration.keys.forEach(i=>r.add(i)),this.i.keys.forEach(i=>r.add(i)),this.j.forEach(i=>i.keys.forEach(s=>r.add(s))),[...r.values()]}u(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(s=>r.add(s))),[...r.values()]}v(r){const i=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(s=>i.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>i.add(s)),this.i.getKeysForOverrideIdentifier(r).forEach(s=>i.add(s)),this.j.forEach(s=>s.getKeysForOverrideIdentifier(r).forEach(l=>i.add(l))),[...i.values()]}static parse(r){const i=this.w(r.defaults),s=this.w(r.policy),l=this.w(r.application),b=this.w(r.user),D=this.w(r.workspace),j=r.folders.reduce((E,I)=>(E.set(c.URI.revive(I[0]),this.w(I[1])),E),new C.$Ac);return new f(i,s,l,b,new m,D,j,new m,new C.$Ac)}static w(r){return new m(r.contents,r.keys,r.overrides)}}e.$io=f;function h(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const r=new Set,i=new Map;for(const l of o)l.keys.forEach(b=>r.add(b)),l.overrides.forEach(([b,D])=>{const j=(0,C.$xc)(i,b,new Set);D.forEach(E=>j.add(E))});const s=[];return i.forEach((l,b)=>s.push([b,[...l.values()]])),{keys:[...r.values()],overrides:s}}e.$jo=h;class g{constructor(r,i,s,l){this.change=r,this.f=i,this.g=s,this.h=l,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const b of r.keys)this.affectedKeys.add(b);for(const[,b]of r.overrides)for(const D of b)this.affectedKeys.add(D);this.d=this.a;for(const b of this.affectedKeys)this.d+=b+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=f.parse(this.f.data)),this.i}affectsConfiguration(r,i){const s=this.a+r,l=this.d.indexOf(s);if(l<0)return!1;const b=l+s.length;if(b>=this.d.length)return!1;const D=this.d.charCodeAt(b);if(D!==this.b&&D!==this.c)return!1;if(i){const j=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.f?.workspace):void 0,E=this.g.getValue(r,i,this.h);return!S.$On(j,E)}return!0}}e.$ko=g;function a(o,r){const{added:i,removed:s,updated:l}=t(r?.rawConfiguration,o?.rawConfiguration),b=[],D=o?.getAllOverrideIdentifiers()||[],j=r?.getAllOverrideIdentifiers()||[];if(r){const E=j.filter(I=>!D.includes(I));for(const I of E)b.push([I,r.getKeysForOverrideIdentifier(I)])}if(o){const E=D.filter(I=>!j.includes(I));for(const I of E)b.push([I,o.getKeysForOverrideIdentifier(I)])}if(r&&o){for(const E of D)if(j.includes(E)){const I=t({contents:o.getOverrideValue(void 0,E)||{},keys:o.getKeysForOverrideIdentifier(E)},{contents:r.getOverrideValue(void 0,E)||{},keys:r.getKeysForOverrideIdentifier(E)});b.push([E,[...I.added,...I.removed,...I.updated]])}}return{added:i,removed:s,updated:l,overrides:b}}function t(o,r){const i=o?r?o.keys.filter(b=>r.keys.indexOf(b)===-1):[...o.keys]:[],s=r?o?r.keys.filter(b=>o.keys.indexOf(b)===-1):[...r.keys]:[],l=[];if(o&&r){for(const b of r.keys)if(o.keys.indexOf(b)!==-1){const D=(0,y.$Ti)(r.contents,b),j=(0,y.$Ti)(o.contents,b);S.$On(D,j)||l.push(b)}}return{added:i,removed:s,updated:l}}}),define(ae[239],ce([0,1,22,3,2,35,12,122,52,5,39,44]),function(X,e,n,R,P,O,C,S,d,c,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$no=e.$mo=e.$lo=void 0;class k extends P.$Tc{constructor(){super(...arguments),this.a=this.B(new R.$5d),this.onDidChangeConfiguration=this.a.event,this.b=new S.$fo}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(v.$Wn.as(d.$2n.Configuration).onDidUpdateConfiguration(({properties:p,defaultsOverrides:u})=>this.c(Array.from(p),u))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(p,u){this.h(p,v.$Wn.as(d.$2n.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:p})}f(){return{}}g(){this.b=new S.$fo;const p=v.$Wn.as(d.$2n.Configuration).getConfigurationProperties();this.h(Object.keys(p),p)}h(p,u){const f=this.f();for(const h of p){const g=f[h],a=u[h];g!==void 0?this.b.addValue(h,g):a?this.b.addValue(h,a.default):this.b.removeValue(h)}}}e.$lo=k;class ${constructor(){this.onDidChangeConfiguration=R.Event.None,this.configurationModel=new S.$fo}async initialize(){return this.configurationModel}}e.$mo=$;let m=class extends P.$Tc{get configurationModel(){return this.b}constructor(p,u,f){super(),this.c=p,this.f=u,this.g=f,this.a=this.B(new R.$5d),this.onDidChangeConfiguration=this.a.event,this.b=new S.$fo}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(p=>this.j(p))),this.B(this.c.onDidChangeConfiguration(async({properties:p})=>this.m(await this.h(p),!0))),this.b}async h(p){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",p);const u={},f=[],h=v.$Wn.as(d.$2n.Configuration).getConfigurationProperties();for(const g of p){const a=h[g];if(!a){f.push(g);continue}if(a.policy){if(a.type!=="string"&&a.type!=="number"){this.g.warn(`Policy ${a.policy.name} has unsupported type ${a.type}`);continue}f.push(g),u[a.policy.name]={type:a.type}}}return(0,C.$6f)(u)||await this.f.updatePolicyDefinitions(u),f}j(p){this.g.trace("PolicyConfiguration#onDidChangePolicies",p);const u=v.$Wn.as(d.$2n.Configuration).getPolicyConfigurations(),f=(0,n.$Hb)(p.map(h=>u.get(h)));this.m(f,!0)}m(p,u){this.g.trace("PolicyConfiguration#update",p);const f=v.$Wn.as(d.$2n.Configuration).getConfigurationProperties(),h=[],g=this.b.isEmpty();for(const a of p){const t=f[a]?.policy?.name;if(t){const o=this.f.getPolicyValue(t);(g?o!==void 0:!(0,O.$On)(this.b.getValue(a),o))&&h.push([a,o])}else this.b.getValue(a)!==void 0&&h.push([a,void 0])}if(h.length){this.g.trace("PolicyConfiguration#changed",h);const a=this.b;this.b=new S.$fo;for(const t of a.keys)this.b.setValue(t,a.getValue(t));for(const[t,o]of h)o===void 0?this.b.removeValue(t):this.b.setValue(t,o);u&&this.a.fire(this.b)}}};e.$no=m,e.$no=m=ve([se(1,y.$Yn),se(2,c.$zj)],m)}),define(ae[240],ce([0,1,22,8,17,3,42,102,2,35,4,19,18,122,52,239,39]),function(X,e,n,R,P,O,C,S,d,c,y,v,k,$,m,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=void 0;class u extends d.$Tc{constructor(g,a,t,o){super(),this.m=g,this.h=this.B(new O.$5d),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new w.$lo),this.c=t instanceof p.$1n?new w.$mo:this.B(new w.$no(this.b,t,o)),this.f=this.B(new $.$ho(this.m,{},v.$Jg,a)),this.a=new $.$io(this.b.configurationModel,this.c.configurationModel,new $.$fo,new $.$fo),this.j=new f(g,a,this),this.g=this.B(new R.$rh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:r,properties:i})=>this.r(r,i))),this.B(this.c.onDidChangeConfiguration(r=>this.s(r))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[g,a,t]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new $.$io(g,a,new $.$fo,t)}getConfigurationData(){return this.a.toData()}getValue(g,a){const t=typeof g=="string"?g:void 0,o=(0,k.$Mi)(g)?g:(0,k.$Mi)(a)?a:{};return this.a.getValue(t,o,void 0)}async updateValue(g,a,t,o,r){const i=(0,k.$Ni)(t)?t:(0,k.$Mi)(t)?{resource:t.resource,overrideIdentifiers:t.overrideIdentifier?[t.overrideIdentifier]:void 0}:void 0,s=i?o:t;if(s!==void 0&&s!==3&&s!==2)throw new Error(`Unable to write ${g} to target ${s}.`);i?.overrideIdentifiers&&(i.overrideIdentifiers=(0,n.$Mb)(i.overrideIdentifiers),i.overrideIdentifiers=i.overrideIdentifiers.length?i.overrideIdentifiers:void 0);const l=this.inspect(g,{resource:i?.resource,overrideIdentifier:i?.overrideIdentifiers?i.overrideIdentifiers[0]:void 0});if(l.policyValue!==void 0)throw new Error(`Unable to write ${g} because it is configured in system policy.`);if((0,c.$On)(a,l.defaultValue)&&(a=void 0),i?.overrideIdentifiers?.length&&i.overrideIdentifiers.length>1){const D=i.overrideIdentifiers.sort(),j=this.a.localUserConfiguration.overrides.find(E=>(0,n.$ub)([...E.identifiers].sort(),D));j&&(i.overrideIdentifiers=j.identifiers)}const b=i?.overrideIdentifiers?.length?[(0,m.$bo)(i.overrideIdentifiers),g]:[g];await this.j.write(b,a),await this.reloadConfiguration()}inspect(g,a={}){return this.a.inspect(g,a,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const g=await this.f.loadConfiguration();this.n(g)}n(g){const a=this.a.toData(),t=this.a.compareAndUpdateLocalUserConfiguration(g);this.t(t,a,2)}r(g,a){const t=this.a.toData(),o=this.a.compareAndUpdateDefaultConfiguration(g,a);this.t(o,t,7)}s(g){const a=this.a.toData(),t=this.a.compareAndUpdatePolicyConfiguration(g);this.t(t,a,7)}t(g,a,t){const o=new $.$ko(g,{data:a},this.a);o.source=t,this.h.fire(o)}}e.$oo=u;class f{constructor(g,a,t){this.b=g,this.c=a,this.d=t,this.a=new R.$mh}write(g,a){return this.a.queue(()=>this.e(g,a))}async e(g,a){let t;try{t=(await this.c.readFile(this.b)).value.toString()}catch(i){if(i.fileOperationResult===1)t="{}";else throw i}const o=[];if((0,C.$rn)(t,o,{allowTrailingComma:!0,allowEmptyContent:!0}),o.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const r=this.f(t,g,a);t=(0,S.$Jn)(t,r),await this.c.writeFile(this.b,P.$se.fromString(t))}f(g,a,t){const{tabSize:o,insertSpaces:r,eol:i}=this.h;if(!a.length){const s=JSON.stringify(t,null,r?" ".repeat(o):"	");return[{content:s,length:s.length,offset:0}]}return(0,S.$Gn)(g,a,t,{tabSize:o,insertSpaces:r,eol:i})}get h(){if(!this.g){let g=y.OS===3||y.OS===2?`
`:`\r
`;const a=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});a&&typeof a=="string"&&a!=="auto"&&(g=a),this.g={eol:g,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(ae[241],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yac=e.$xac=e.$wac=void 0,e.$wac="request",e.$xac="remoteResourceHandler";class n{async routeCall(P,O,C){if(O!==e.$wac)throw new Error(`Call not found: ${O}`);const S=C[0];if(S?.authority){const d=P.connections.find(c=>c.ctx===S.authority);if(d)return d}throw new Error("Caller not found")}routeEvent(P,O){throw new Error(`Event not found: ${O}`)}}e.$yac=n}),define(ae[242],ce([0,1,15,6]),function(X,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ol=e.$nl=e.RemoteAuthorityResolverErrorCode=e.$ml=e.$ll=e.RemoteConnectionType=e.$kl=void 0,e.$kl=(0,R.$fi)("remoteAuthorityResolverService");var P;(function(y){y[y.WebSocket=0]="WebSocket",y[y.Managed=1]="Managed"})(P||(e.RemoteConnectionType=P={}));class O{constructor(v){this.id=v,this.type=1}toString(){return`Managed(${this.id})`}}e.$ll=O;class C{constructor(v,k){this.host=v,this.port=k,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$ml=C;var S;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound",y.InvalidAuthority="InvalidAuthority"})(S||(e.RemoteAuthorityResolverErrorCode=S={}));class d extends n.$bb{static isNotAvailable(v){return v instanceof d&&v._code===S.NotAvailable}static isTemporarilyNotAvailable(v){return v instanceof d&&v._code===S.TemporarilyNotAvailable}static isNoResolverFound(v){return v instanceof d&&v._code===S.NoResolverFound}static isInvalidAuthority(v){return v instanceof d&&v._code===S.InvalidAuthority}static isHandled(v){return v instanceof d&&v.isHandled}constructor(v,k=S.Unknown,$){super(v),this._message=v,this._code=k,this._detail=$,this.isHandled=k===S.NotAvailable&&$===!0,Object.setPrototypeOf(this,d.prototype)}}e.$nl=d;function c(y){const v=y.indexOf("+");return v===-1?y:y.substring(0,v)}e.$ol=c}),define(ae[243],ce([0,1,8,17,23,15,3,2,13,66,72,32,112,242]),function(X,e,n,R,P,O,C,S,d,c,y,v,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.PersistentConnectionEventType=e.$vl=e.$ul=e.$tl=e.ConnectionType=void 0;const m=30*1e3;var w;(function(K){K[K.Management=1]="Management",K[K.ExtensionHost=2]="ExtensionHost",K[K.Tunnel=3]="Tunnel"})(w||(e.ConnectionType=w={}));function p(K){switch(K){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function u(K){const A=new P.$ce;return setTimeout(()=>A.cancel(),K),A.token}function f(K,A){if(K.isCancellationRequested||A.isCancellationRequested)return P.CancellationToken.Cancelled;const F=new P.$ce;return K.onCancellationRequested(()=>F.cancel()),A.onCancellationRequested(()=>F.cancel()),F.token}class h{get didTimeout(){return this.c==="timedout"}constructor(A){this.c="pending",this.d=new S.$Sc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,n.$$g)(),A.isCancellationRequested?this.h():this.d.add(A.onCancellationRequested(()=>this.h()))}registerDisposable(A){this.c==="pending"?this.d.add(A):A.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const A=new Error("Time limit reached");return A.code="ETIMEDOUT",A.syscall="connect",A}resolve(A){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(A))}reject(A){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(A))}}function g(K,A){const F=new h(A);return F.registerDisposable(K.onControlMessage(x=>{const z=JSON.parse(x.toString()),Z=L(z);Z?F.reject(Z):F.resolve(z)})),F.promise}function a(K,A,F,x,z,Z,H,_){const B=new h(_),ee=y.$1d.create(!1);return K.info(`Creating a socket (${H})...`),c.mark(`code/willCreateSocket/${Z}`),A.connect(F,x,z,H).then(ie=>{B.didTimeout?(c.mark(`code/didCreateSocketError/${Z}`),K.info(`Creating a socket (${H}) finished after ${ee.elapsed()} ms, but this is too late and has timed out already.`),ie?.dispose()):(c.mark(`code/didCreateSocketOK/${Z}`),K.info(`Creating a socket (${H}) was successful after ${ee.elapsed()} ms.`),B.resolve(ie))},ie=>{c.mark(`code/didCreateSocketError/${Z}`),K.info(`Creating a socket (${H}) returned an error after ${ee.elapsed()} ms.`),K.error(ie),B.reject(ie)}),B.promise}function t(K,A){const F=new h(A);return K.then(x=>{F.didTimeout||F.resolve(x)},x=>{F.didTimeout||F.reject(x)}),F.promise}async function o(K,A,F,x){const z=oe(K,A);K.logService.trace(`${z} 1/6. invoking socketFactory.connect().`);let Z;try{Z=await a(K.logService,K.remoteSocketFactoryService,K.connectTo,d.$sg.getServerRootPath(),`reconnectionToken=${K.reconnectionToken}&reconnection=${K.reconnectionProtocol?"true":"false"}`,p(A),`renderer-${p(A)}-${K.reconnectionToken}`,x)}catch(ie){throw K.logService.error(`${z} socketFactory.connect() failed or timed out. Error:`),K.logService.error(ie),ie}K.logService.trace(`${z} 2/6. socketFactory.connect() was successful.`);let H,_;K.reconnectionProtocol?(K.reconnectionProtocol.beginAcceptReconnection(Z,null),H=K.reconnectionProtocol,_=!1):(H=new k.$6h({socket:Z}),_=!0),K.logService.trace(`${z} 3/6. sending AuthRequest control message.`);const B=await t(K.signService.createNewMessage((0,v.$Bg)()),x),ee={type:"auth",auth:K.connectionToken||"00000000000000000000",data:B.data};H.sendControl(R.$se.fromString(JSON.stringify(ee)));try{const ie=await g(H,f(x,u(1e4)));if(ie.type!=="sign"||typeof ie.data!="string"){const Pe=new Error("Unexpected handshake message");throw Pe.code="VSCODE_CONNECTION_ERROR",Pe}if(K.logService.trace(`${z} 4/6. received SignRequest control message.`),!await t(K.signService.validate(B,ie.signedData),x)){const Pe=new Error("Refused to connect to unsupported server");throw Pe.code="VSCODE_CONNECTION_ERROR",Pe}const me=await t(K.signService.sign(ie.data),x),Ee={type:"connectionType",commit:K.commit,signedData:me,desiredConnectionType:A};return F&&(Ee.args=F),K.logService.trace(`${z} 5/6. sending ConnectionTypeRequest control message.`),H.sendControl(R.$se.fromString(JSON.stringify(Ee))),{protocol:H,ownsProtocol:_}}catch(ie){throw ie&&ie.code==="ETIMEDOUT"&&(K.logService.error(`${z} the handshake timed out. Error:`),K.logService.error(ie)),ie&&ie.code==="VSCODE_CONNECTION_ERROR"&&(K.logService.error(`${z} received error control message when negotiating connection. Error:`),K.logService.error(ie)),_&&U(H),ie}}async function r(K,A,F,x){const z=Date.now(),Z=oe(K,A),{protocol:H,ownsProtocol:_}=await o(K,A,F,x),B=new h(x);return B.registerDisposable(H.onControlMessage(ee=>{const ie=JSON.parse(ee.toString()),de=L(ie);de?(K.logService.error(`${Z} received error control message when negotiating connection. Error:`),K.logService.error(de),_&&U(H),B.reject(de)):(K.reconnectionProtocol?.endAcceptReconnection(),K.logService.trace(`${Z} 6/6. handshake finished, connection is up and running after ${he(z)}!`),B.resolve({protocol:H,firstMessage:ie}))})),B.promise}async function i(K,A){const{protocol:F}=await r(K,1,void 0,A);return{protocol:F}}async function s(K,A,F){const{protocol:x,firstMessage:z}=await r(K,2,A,F),Z=z&&z.debugPort;return{protocol:x,debugPort:Z}}async function l(K,A,F){const x=Date.now(),z=oe(K,3),{protocol:Z}=await o(K,3,A,F);return K.logService.trace(`${z} 6/6. handshake finished, connection is up and running after ${he(x)}!`),Z}async function b(K,A,F){const{connectTo:x,connectionToken:z}=await K.addressProvider.getAddress();return{commit:K.commit,quality:K.quality,connectTo:x,connectionToken:z,reconnectionToken:A,reconnectionProtocol:F,remoteSocketFactoryService:K.remoteSocketFactoryService,signService:K.signService,logService:K.logService}}async function D(K,A,F){return E(K,async x=>{const{protocol:z}=await i(x,P.CancellationToken.None);return new Q(K,A,F,x.reconnectionToken,z)})}e.$tl=D;async function j(K,A){return E(K,async F=>{const{protocol:x,debugPort:z}=await s(F,A,P.CancellationToken.None);return new Y(K,A,F.reconnectionToken,x,z)})}e.$ul=j;async function E(K,A){for(let x=1;;x++)try{const z=(0,v.$Bg)(),Z=await b(K,z,null);return await A(Z)}catch(z){if(x<5)K.logService.error(`[remote-connection][attempt ${x}] An error occurred in initial connection! Will retry... Error:`),K.logService.error(z);else throw K.logService.error(`[remote-connection][attempt ${x}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),K.logService.error(z),ue.triggerPermanentFailure(0,0,$.$nl.isHandled(z)),z}}async function I(K,A,F){const x=await b(K,(0,v.$Bg)(),null);return await l(x,{host:A,port:F},P.CancellationToken.None)}e.$vl=I;function M(K){return(0,n.$5g)(A=>new Promise((F,x)=>{const z=setTimeout(F,K*1e3);A.onCancellationRequested(()=>{clearTimeout(z),F()})}))}var T;(function(K){K[K.ConnectionLost=0]="ConnectionLost",K[K.ReconnectionWait=1]="ReconnectionWait",K[K.ReconnectionRunning=2]="ReconnectionRunning",K[K.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",K[K.ConnectionGain=4]="ConnectionGain"})(T||(e.PersistentConnectionEventType=T={}));class W{constructor(A,F){this.reconnectionToken=A,this.millisSinceLastIncomingData=F,this.type=0}}e.$wl=W;class V{constructor(A,F,x,z){this.reconnectionToken=A,this.millisSinceLastIncomingData=F,this.durationSeconds=x,this.c=z,this.type=1}skipWait(){this.c.cancel()}}e.$xl=V;class J{constructor(A,F,x){this.reconnectionToken=A,this.millisSinceLastIncomingData=F,this.attempt=x,this.type=2}}e.$yl=J;class le{constructor(A,F,x){this.reconnectionToken=A,this.millisSinceLastIncomingData=F,this.attempt=x,this.type=4}}e.$zl=le;class re{constructor(A,F,x,z){this.reconnectionToken=A,this.millisSinceLastIncomingData=F,this.attempt=x,this.handled=z,this.type=3}}e.$Al=re;class ue extends S.$Tc{static triggerPermanentFailure(A,F,x){this._permanentFailure=!0,this.f=A,this.g=F,this.h=x,this.j.forEach(z=>z.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(A=>A.y())}static debugPauseSocketWriting(){this.j.forEach(A=>A.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||ue._permanentFailure}constructor(A,F,x,z,Z){super(),this.t=A,this.u=F,this.reconnectionToken=x,this.protocol=z,this.w=Z,this.m=this.B(new C.$5d),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new le(this.reconnectionToken,0,0)),this.B(z.onSocketClose(H=>{const _=q(this.t,this.reconnectionToken,!0);H?H.type===0?(this.u.logService.info(`${_} received socket close event (hadError: ${H.hadError}).`),H.error&&this.u.logService.error(H.error)):(this.u.logService.info(`${_} received socket close event (wasClean: ${H.wasClean}, code: ${H.code}, reason: ${H.reason}).`),H.event&&this.u.logService.error(H.event)):this.u.logService.info(`${_} received socket close event.`),this.y()})),this.B(z.onSocketTimeout(H=>{const _=q(this.t,this.reconnectionToken,!0);this.u.logService.info(`${_} received socket timeout event (unacknowledgedMsgCount: ${H.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${H.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${H.timeSinceLastReceivedSomeData}).`),this.y()})),ue.j.push(this),this.B((0,S.$Rc)(()=>{const H=ue.j.indexOf(this);H>=0&&ue.j.splice(H,1)})),this.n&&this.D(ue.f,ue.g,ue.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const A=q(this.t,this.reconnectionToken,!0);this.u.logService.info(`${A} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new W(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const F=[0,5,5,10,10,10,10,10,30];let x=-1;do{x++;const z=x<F.length?F[x]:F[F.length-1];try{if(z>0){const H=M(z);this.m.fire(new V(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z,H)),this.u.logService.info(`${A} waiting for ${z} seconds before reconnecting...`);try{await H}catch{}}if(this.n){this.u.logService.error(`${A} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new J(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),x+1)),this.u.logService.info(`${A} resolving connection...`);const Z=await b(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${A} connecting to ${Z.connectTo}...`),await this.G(Z,u(m)),this.u.logService.info(`${A} reconnected!`),this.m.fire(new le(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),x+1));break}catch(Z){if(Z.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${A} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(Z),this.C(this.protocol.getMillisSinceLastIncomingData(),x+1,!1);break}if(x>360){this.u.logService.error(`${A} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(Z),this.C(this.protocol.getMillisSinceLastIncomingData(),x+1,!1);break}if($.$nl.isTemporarilyNotAvailable(Z)){this.u.logService.info(`${A} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Z);continue}if((Z.code==="ETIMEDOUT"||Z.code==="ENETUNREACH"||Z.code==="ECONNREFUSED"||Z.code==="ECONNRESET")&&Z.syscall==="connect"){this.u.logService.info(`${A} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Z);continue}if((0,O.$4)(Z)){this.u.logService.info(`${A} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Z);continue}if(Z instanceof $.$nl){this.u.logService.error(`${A} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(Z),this.C(this.protocol.getMillisSinceLastIncomingData(),x+1,$.$nl.isHandled(Z));break}this.u.logService.error(`${A} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(Z),this.C(this.protocol.getMillisSinceLastIncomingData(),x+1,!1);break}}while(!this.n&&!this.s)}C(A,F,x){this.w?ue.triggerPermanentFailure(A,F,x):this.D(A,F,x)}D(A,F,x){this.m.fire(new re(this.reconnectionToken,A,F,x)),U(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$Bl=ue;class Q extends ue{constructor(A,F,x,z,Z){super(1,A,z,Z,!0),this.client=this.B(new k.$4h(Z,{remoteAuthority:F,clientId:x},A.ipcLogger))}async G(A,F){await i(A,F)}}e.$Cl=Q;class Y extends ue{constructor(A,F,x,z,Z){super(2,A,x,z,!1),this.H=F,this.debugPort=Z}async G(A,F){await s(A,this.H,F)}}e.$Dl=Y;function U(K){try{K.acceptDisconnect();const A=K.getSocket();K.dispose(),A.dispose()}catch(A){(0,O.$1)(A)}}function L(K){if(K&&K.type==="error"){const A=new Error(`Connection error: ${K.reason}`);return A.code="VSCODE_CONNECTION_ERROR",A}return null}function N(K,A){for(;K.length<A;)K+=" ";return K}function G(K,A){return`[remote-connection][${N(p(K),13)}][${A.substr(0,5)}\u2026]`}function q(K,A,F){return`${G(K,A)}[${F?"reconnect":"initial"}]`}function oe(K,A){return`${q(A,K.reconnectionToken,!!K.reconnectionProtocol)}[${K.connectTo}]`}function he(K){return`${Date.now()-K} ms`}}),define(ae[68],ce([0,1,13]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=e.$rm=e.$qm=e.$pm=void 0;function R(d){return d.scheme===n.Schemas.vscodeRemote?d.authority:void 0}e.$pm=R;function P(d){if(!d)return;const c=d.indexOf("+");return c<0?d:d.substr(0,c)}e.$qm=P;function O(d){const{host:c,port:y}=S(d);if(typeof y>"u")throw new Error(`Invalid remote authority: ${d}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:c,port:y}}e.$rm=O;function C(d,c){let{host:y,port:v}=S(d);return typeof v>"u"&&(v=c),{host:y,port:v}}e.$sm=C;function S(d){const c=d.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(c)return{host:c[1],port:parseInt(c[2],10)};const y=d.match(/^(\[[0-9a-z:]+\])$/);if(y)return{host:y[1],port:void 0};const v=d.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:d,port:void 0}}}),define(ae[123],ce([0,1,25,6,68]),function(X,e,n,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gm=e.$Fm=e.$Em=e.$Dm=e.$Cm=e.$Bm=e.$Am=e.$zm=e.TargetPlatform=e.ExtensionType=e.$ym=e.$xm=e.$wm=e.$vm=e.$um=e.$tm=void 0,e.$tm="extensions.user.cache",e.$um="extensions.builtin.cache",e.$vm="undefined_publisher",e.$wm=["ui","workspace","web"];function O(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.$xm=O,e.$ym=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var C;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(C||(e.ExtensionType=C={}));var S;(function(w){w.WIN32_X64="win32-x64",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(S||(e.TargetPlatform=S={}));class d{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,u){if(typeof p>"u"||p===null)return typeof u>"u"||u===null;if(typeof u>"u"||u===null)return!1;if(typeof p=="string"||typeof u=="string"){const f=typeof p=="string"?p:p.value,h=typeof u=="string"?u:u.value;return n.$jf(f,h)}return p._lower===u._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.$zm=d;class c{get size(){return this.c.size}constructor(p){if(this.c=new Set,p)for(const u of p)this.add(u)}add(p){this.c.add(d.toKey(p))}delete(p){return this.c.delete(d.toKey(p))}has(p){return this.c.has(d.toKey(p))}}e.$Am=c;class y{constructor(){this.c=new Map}clear(){this.c.clear()}delete(p){this.c.delete(d.toKey(p))}get(p){return this.c.get(d.toKey(p))}has(p){return this.c.has(d.toKey(p))}set(p,u){this.c.set(d.toKey(p),u)}values(){return this.c.values()}forEach(p){this.c.forEach(p)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Bm=y;function v(w){return k(w)}e.$Cm=v;function k(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.$Dm=k;function $(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.$Em=$;function m(w,p){if(p){const u=`onResolveRemoteAuthority:${(0,P.$qm)(p)}`;return!!w.activationEvents?.includes(u)}return!1}e.$Fm=m,e.$Gm=(0,R.$fi)("IBuiltinExtensionsScannerService")}),define(ae[244],ce([0,1,2,6]),function(X,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ql=e.$pl=void 0,e.$pl=(0,R.$fi)("remoteSocketFactoryService");class P{constructor(){this.a={}}register(C,S){return this.a[C]??=[],this.a[C].push(S),(0,n.$Rc)(()=>{const d=this.a[C]?.indexOf(S);typeof d=="number"&&d>=0&&this.a[C]?.splice(d,1)})}b(C){return(this.a[C.type]||[]).find(d=>d.supports(C))}connect(C,S,d,c){const y=this.b(C);if(!y)throw new Error(`No socket factory found for ${C}`);return y.connect(C,S,d,c)}}e.$ql=P}),define(ae[245],ce([0,1,26,48,21,116]),function(X,e,n,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y_b=void 0;let C;async function S($=!1){return(C===void 0||$)&&(C=d()),C}e.$y_b=S;async function d(){const $=c();if($===void 0)return!1;if($>=22e3){const m=v();if(m)return new Promise(w=>{R.execFile(m,["--status"],p=>w(!p))})}else{const m=k();if(m)try{if((await P.Promises.stat(m)).isFile())return!0}catch{}}return!1}function c(){const $=/(\d+)\.(\d+)\.(\d+)/g.exec(n.release());if($)return parseInt($[3])}function y($){const m=process.env.SystemRoot;if(m){const w=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return O.join(m,w?"Sysnative":"System32",$)}}function v(){return y("wsl.exe")}function k(){return y("lxss\\LxssManager.dll")}}),define(ae[53],ce([0,1,17,15,2,185,52,6,5,44]),function(X,e,n,R,P,O,C,S,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=e.$Bp=e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=void 0,e.$vp=(0,S.$fi)("requestService");class y{constructor(a){this.b=a}toJSON(){if(!this.a){const a=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?a[t]="*****":a[t]=this.b[t];this.a=a}return this.a}}class v extends P.$Tc{constructor(a){super(),this.b=0,this.a=a.createLogger("network",{name:(0,O.localize)(0,null),when:d.$Qj.isEqualTo((0,d.$Oj)(d.LogLevel.Trace)).serialize()})}async c(a,t,o){const r=`${a} #${++this.b}: ${t.url}`;this.a.trace(`${r} - begin`,t.type,new y(t.headers??{}));try{const i=await o();return this.a.trace(`${r} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${r} - error`,t.type,(0,R.$0)(i)),i}}}e.$wp=v;function k(g){return g.res.statusCode&&g.res.statusCode>=200&&g.res.statusCode<300||g.res.statusCode===1223}e.$xp=k;function $(g){return g.res.statusCode===204}e.$yp=$;async function m(g){return $(g)?null:(await(0,n.$Ee)(g.stream)).toString()}e.$zp=m;async function w(g){if(!k(g))throw new Error("Server returned "+g.res.statusCode);return m(g)}e.$Ap=w;async function p(g){if(!k(g))throw new Error("Server returned "+g.res.statusCode);if($(g))return null;const t=(await(0,n.$Ee)(g.stream)).toString();try{return JSON.parse(t)}catch(o){throw o.message+=`:
`+t,o}}e.$Bp=p;function u(g){h(g)}e.$Cp=u;let f;function h(g){const a=c.$Wn.as(C.$2n.Configuration),t=f;f={id:"http",order:15,title:(0,O.localize)(1,null),type:"object",scope:g,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,O.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,O.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,O.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,O.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,O.localize)(6,null),(0,O.localize)(7,null),(0,O.localize)(8,null),(0,O.localize)(9,null)],default:"override",description:(0,O.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,O.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,O.localize)(12,null),restricted:!0}}},a.updateConfigurations({add:[f],remove:t?[t]:[]})}h(1)}),define(ae[246],ce([0,1,17,23]),function(X,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zr=e.$yr=void 0;class P{constructor(S){this.a=S}listen(S,d){throw new Error("Invalid listen")}call(S,d,c,y=R.CancellationToken.None){switch(d){case"request":return this.a.request(c[0],y).then(async({res:v,stream:k})=>{const $=await(0,n.$Ee)(k);return[{statusCode:v.statusCode,headers:v.headers},$]});case"resolveProxy":return this.a.resolveProxy(c[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$yr=P;class O{constructor(S){this.a=S}async request(S,d){const[c,y]=await this.a.call("request",[S],d);return{res:c,stream:(0,n.$Ge)(y)}}async resolveProxy(S){return this.a.call("resolveProxy",[S])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$zr=O}),define(ae[247],ce([0,1,248,12]),function(X,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ar=void 0;function P(C,S){return C.protocol==="http:"?S.HTTP_PROXY||S.http_proxy||null:C.protocol==="https:"&&(S.HTTPS_PROXY||S.https_proxy||S.HTTP_PROXY||S.http_proxy)||null}async function O(C,S,d={}){const c=(0,n.parse)(C),y=d.proxyUrl||P(c,S);if(!y)return null;const v=(0,n.parse)(y);if(!/^https?:$/.test(v.protocol||""))return null;const k={host:v.hostname||"",port:(v.port?+v.port:0)||(v.protocol==="https"?443:80),auth:v.auth,rejectUnauthorized:(0,R.$Yf)(d.strictSSL)?d.strictSSL:!0};return c.protocol==="http:"?new(await new Promise(($,m)=>{X(["http-proxy-agent"],$,m)})).HttpProxyAgent(y,k):new(await new Promise(($,m)=>{X(["https-proxy-agent"],$,m)})).HttpsProxyAgent(y,k)}e.$Ar=O}),define(ae[249],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U_b=e.$T_b=e.$S_b=void 0,e.$S_b={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$T_b={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$U_b={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(ae[95],ce([0,1,48,9,186,23,51,15,4,32,111,63,8,141]),function(X,e,n,R,P,O,C,S,d,c,y,v,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jm=void 0;let m;async function w(u,f,h,g){return h["force-disable-user-env"]?(f.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):d.$i?(f.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,v.$dm)(g)&&!h["force-user-env"]?(f.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,v.$dm)(g)?f.trace("resolveShellEnv(): running (--force-user-env)"):f.trace("resolveShellEnv(): running (macOS/Linux)"),m||(m=k.Promises.withAsyncBody(async(a,t)=>{const o=new O.$ce;let r=1e4;const i=u.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(r=(0,$.$em)(i,1,120)*1e3);const s=setTimeout(()=>{o.dispose(!0),t(new Error((0,P.localize)(0,null)))},r);try{a(await p(f,o.token))}catch(l){!(0,S.$4)(l)&&!o.token.isCancellationRequested?t(new Error((0,P.localize)(1,null,(0,C.$3i)(l)))):a({})}finally{clearTimeout(s),o.dispose()}})),m)}e.$jm=w;async function p(u,f){const h=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",h);const g=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",g);const a=(0,c.$Bg)().replace(/-/g,"").substr(0,12),t=new RegExp(a+"({.*})"+a),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};u.trace("getUnixShellEnvironment#env",o);const r=await(0,y.$6l)(d.OS,o);return u.trace("getUnixShellEnvironment#shell",r),new Promise((i,s)=>{if(f.isCancellationRequested)return s(new S.$5);const l=(0,R.$nc)(r);let b,D;const j="";/^pwsh(-preview)?$/.test(l)?(b=`& '${process.execPath}' ${j} -p '''${a}'' + JSON.stringify(process.env) + ''${a}'''`,D=["-Login","-Command"]):l==="nu"?(b=`^'${process.execPath}' ${j} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,D=["-i","-l","-c"]):l==="xonsh"?(b=`import os, json; print("${a}", json.dumps(dict(os.environ)), "${a}")`,D=["-i","-l","-c"]):(b=`'${process.execPath}' ${j} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,l==="tcsh"||l==="csh"?D=["-ic"]:D=["-i","-l","-c"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(D),b);const E=(0,n.spawn)(r,[...D,b],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});f.onCancellationRequested(()=>(E.kill(),s(new S.$5))),E.on("error",T=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,C.$3i)(T)),s(T)});const I=[];E.stdout.on("data",T=>I.push(T));const M=[];E.stderr.on("data",T=>M.push(T)),E.on("close",(T,W)=>{const V=Buffer.concat(I).toString("utf8");u.trace("getUnixShellEnvironment#raw",V);const J=Buffer.concat(M).toString("utf8");if(J.trim()&&u.trace("getUnixShellEnvironment#stderr",J),T||W)return s(new Error((0,P.localize)(2,null,T,W)));const le=t.exec(V),re=le?le[1]:"{}";try{const ue=JSON.parse(re);h?ue.ELECTRON_RUN_AS_NODE=h:delete ue.ELECTRON_RUN_AS_NODE,g?ue.ELECTRON_NO_ATTACH_CONSOLE=g:delete ue.ELECTRON_NO_ATTACH_CONSOLE,delete ue.VSCODE_RESOLVING_ENVIRONMENT,delete ue.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",ue),i(ue)}catch(ue){u.error("getUnixShellEnvironment#errorCaught",(0,C.$3i)(ue)),s(ue)}})})}}),define(ae[250],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O8b=void 0;class n{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(P){try{const O=await this.c();if(O){const C=String(n.a++);return this.b.set(C,O),{id:C,data:O.createNewMessage(P)}}}catch{}return{id:"",data:P}}async validate(P,O){if(!P.id)return!0;const C=this.b.get(P.id);if(!C)return!1;this.b.delete(P.id);try{return C.validate(O)==="ok"}catch{return!1}finally{C.dispose?.()}}async sign(P){try{return await this.d(P)}catch{}return P}}e.$O8b=n}),define(ae[96],ce([0,1,6]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sl=e.$rl=void 0,e.$rl="signService",e.$sl=(0,n.$fi)(e.$rl)}),define(ae[251],ce([0,1,250]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iac=void 0;class R extends n.$O8b{c(){return this.h().then(O=>new O.validator)}d(O){return this.h().then(C=>new C.signer().sign(O))}h(){return new Promise((O,C)=>X(["vsda"],O,C))}}e.$Iac=R}),define(ae[34],ce([0,1,6]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AP=e.$zP=void 0,e.$zP=(0,n.$fi)("stateReadService"),e.$AP=(0,n.$fi)("stateService")}),define(ae[124],ce([0,1,8,17,2,12,38,16,5]),function(X,e,n,R,P,O,C,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DP=e.$CP=e.$BP=e.SaveStrategy=void 0;var c;(function($){$[$.IMMEDIATE=0]="IMMEDIATE",$[$.DELAYED=1]="DELAYED"})(c||(e.SaveStrategy=c={}));class y extends P.$Tc{constructor(m,w,p,u){super(),this.h=m,this.j=w,this.m=p,this.n=u,this.a=Object.create(null),this.b="",this.c=this.B(new n.$dh(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(m){m.fileOperationResult!==1&&this.m.error(m)}}getItem(m,w){const p=this.a[m];return(0,O.$2f)(p)?w:p}setItem(m,w){this.setItems([{key:m,data:w}])}setItems(m){let w=!1;for(const{key:p,data:u}of m)this.a[p]!==u&&((0,O.$2f)(u)?(0,O.$Zf)(this.a[p])||(this.a[p]=void 0,w=!0):(this.a[p]=u,w=!0));w&&this.s()}removeItem(m){(0,O.$Zf)(this.a[m])||(this.a[m]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const m=JSON.stringify(this.a,null,4);if(m!==this.b)try{await this.n.writeFile(this.h,R.$se.fromString(m),{atomic:{postfix:".vsctmp"}}),this.b=m}catch(w){this.m.error(w)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$BP=y;let v=class extends P.$Tc{constructor(m,w,p,u){super(),this.a=this.B(new y(w.stateResource,m,p,u))}async init(){await this.a.init()}getItem(m,w){return this.a.getItem(m,w)}};e.$CP=v,e.$CP=v=ve([se(1,C.$mi),se(2,d.$zj),se(3,S.$Fk)],v);class k extends v{setItem(m,w){this.a.setItem(m,w)}setItems(m){this.a.setItems(m)}removeItem(m){this.a.removeItem(m)}close(){return this.a.close()}}e.$DP=k}),define(ae[125],ce([0,1,4,36,32]),function(X,e,n,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yo=e.$Xo=void 0;function O(d){if(n.$u===2&&/^penguin(\.|$)/i.test(d))return"chromebook"}function C(d,c,y,v,k,$,m,w,p){const u=Object.create(null);u["common.machineId"]=$,u["common.sqmId"]=m,u.sessionID=(0,P.$Bg)()+Date.now(),u.commitHash=v,u.version=k,u["common.platformVersion"]=(d||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=(0,n.$h)(n.$u),u["common.nodePlatform"]=R.$dc,u["common.nodeArch"]=y,u["common.product"]=p||"desktop",w&&(u["common.msftInternal"]=w);let f=0;const h=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-h,enumerable:!0},"common.sequence":{get:()=>f++,enumerable:!0}}),n.$l&&(u["common.snap"]="true");const g=O(c);return g&&(u["common.platformDetail"]=g),u}e.$Xo=C;function S(d){const c=R.env.USERDNSDOMAIN;if(!c)return!1;const y=c.toLowerCase();return d.some(v=>y===v)}e.$Yo=S}),define(ae[28],ce([0,1,6]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Ol=e.$Nl=e.$Ml=e.$Ll=e.$Kl=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=e.$El=void 0,e.$El=(0,n.$fi)("telemetryService"),e.$Fl=(0,n.$fi)("customEndpointTelemetryService"),e.$Gl="telemetry.currentSessionDate",e.$Hl="telemetry.firstSessionDate",e.$Il="telemetry.lastSessionDate",e.$Jl="telemetry.machineId",e.$Kl="telemetry.sqmId",e.$Ll="telemetry",e.$Ml="telemetry.telemetryLevel",e.$Nl="telemetry.enableCrashReporter",e.$Ol="telemetry.enableTelemetry";var R;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(R||(e.TelemetryLevel=R={}));var P;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(P||(e.TelemetryConfiguration=P={}))}),define(ae[252],ce([0,1,26,8,42,13,9,4,7,89,21,110,92,16,27,28]),function(X,e,n,R,P,O,C,S,d,c,y,v,k,$,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ks=e.$js=e.$is=e.$hs=void 0;const p=new Map;async function u(t,o){const r=`${t}::${o.join(":")}`,i=p.get(r);if(i)return i;const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],l=new Map,b=new Map,D=2e4;function j(I,M,T,W){const V=M.substring(I.length+1);return R.Promises.withAsyncBody(async J=>{let le;try{le=await y.Promises.readdir(M,{withFileTypes:!0})}catch{J();return}if(W.count>=D){W.count+=le.length,W.maxReached=!0,J();return}let re=le.length;if(re===0){J();return}let ue=le;W.count+le.length>D&&(W.maxReached=!0,re=D-W.count,ue=le.slice(0,re)),W.count+=le.length;for(const Q of ue)if(Q.isDirectory()){if(T.includes(Q.name)||await j(I,(0,C.$jc)(M,Q.name),T,W),--re===0){J();return}}else{const Y=Q.name.lastIndexOf(".");if(Y>=0){const U=Q.name.substring(Y+1);U&&l.set(U,(l.get(U)??0)+1)}for(const U of s)U.relativePathPattern?.test(V)!==!1&&U.filePattern.test(Q.name)&&b.set(U.tag,(b.get(U.tag)??0)+1);if(--re===0){J();return}}})}const E=R.Promises.withAsyncBody(async I=>{const M={count:0,maxReached:!1};await j(t,t,o,M);const T=await g(t);I({configFiles:f(b),fileTypes:f(l),fileCount:M.count,maxFilesReached:M.maxReached,launchConfigFiles:T})});return p.set(r,E),E}e.$hs=u;function f(t){return Array.from(t.entries(),([o,r])=>({name:o,count:r})).sort((o,r)=>r.count-o.count)}function h(){const t={os:`${n.type()} ${n.arch()} ${n.release()}`,memory:`${(n.totalmem()/$.$bl.GB).toFixed(2)}GB (${(n.freemem()/$.$bl.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(c.$mn.value()*100)}%`},o=n.cpus();return o&&o.length>0&&(t.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),t}e.$is=h;async function g(t){try{const o=new Map,r=(0,C.$jc)(t,".vscode","launch.json"),i=await y.Promises.readFile(r),s=[],l=(0,P.$rn)(i.toString(),s);if(s.length)return console.log(`Unable to parse ${r}`),[];if((0,P.$An)(l)==="object"&&l.configurations)for(const b of l.configurations){const D=b.type;D&&(o.has(D)?o.set(D,o.get(D)+1):o.set(D,1))}return f(o)}catch{return[]}}e.$js=g;let a=class{constructor(o,r){this.c=o,this.d=r}f(o){const r=[];return r.push(`OS Version:       ${o.os}`),r.push(`CPUs:             ${o.cpus}`),r.push(`Memory (System):  ${o.memory}`),r.push(`VM:               ${o.vmHint}`),r.join(`
`)}g(o){const r=[];r.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),r.push(`OS Version:       ${n.type()} ${n.arch()} ${n.release()}`);const i=n.cpus();return i&&i.length>0&&r.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),r.push(`Memory (System):  ${(n.totalmem()/$.$bl.GB).toFixed(2)}GB (${(n.freemem()/$.$bl.GB).toFixed(2)}GB free)`),S.$i||r.push(`Load (avg):       ${n.loadavg().map(s=>Math.round(s)).join(", ")}`),r.push(`VM:               ${Math.round(c.$mn.value()*100)}%`),r.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${o.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.j(o.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(o,r){return Promise.all([(0,v.$gs)(o.mainPID),this.k(o)]).then(async i=>{let[s,l]=i,b=this.m(o,s);return r.forEach(D=>{if((0,k.$Ym)(D))b+=`
${D.errorMessage}`,l+=`
${D.errorMessage}`;else if(b+=`

Remote: ${D.hostName}`,D.processes&&(b+=`
${this.m(o,D.processes)}`),D.workspaceMetadata){l+=`
|  Remote: ${D.hostName}`;for(const j of Object.keys(D.workspaceMetadata)){const E=D.workspaceMetadata[j];let I=`${E.fileCount} files`;E.maxFilesReached&&(I=`more than ${I}`),l+=`|    Folder (${j}): ${I}`,l+=this.h(E)}}}),{processInfo:b,workspaceInfo:l}})}async getSystemInfo(o,r){const{memory:i,vmHint:s,os:l,cpus:b}=h(),D={os:l,memory:i,cpus:b,vmHint:s,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:r};return S.$i||(D.load=`${n.loadavg().map(j=>Math.round(j)).join(", ")}`),S.$k&&(D.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(D)}async getDiagnostics(o,r){const i=[];return(0,v.$gs)(o.mainPID).then(async s=>(i.push(""),i.push(this.g(o)),i.push(""),i.push(this.m(o,s)),o.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(o))),r.forEach(l=>{if((0,k.$Ym)(l))i.push(`
${l.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${l.hostName}`),i.push(this.f(l.machineInfo)),l.processes&&i.push(this.m(o,l.processes)),l.workspaceMetadata)for(const b of Object.keys(l.workspaceMetadata)){const D=l.workspaceMetadata[b];let j=`${D.fileCount} files`;D.maxFilesReached&&(j=`more than ${j}`),i.push(`Folder (${b}): ${j}`),i.push(this.h(D))}}),i.push(""),i.push(""),i.join(`
`)))}h(o){const r=[];let s=0;const l=(E,I)=>{const M=` ${E}(${I})`;s+M.length>60?(r.push(b),b="|                 ",s=b.length):s+=M.length,b+=M};let b="|      File types:";const D=10,j=o.fileTypes.length>D?D:o.fileTypes.length;for(let E=0;E<j;E++){const I=o.fileTypes[E];l(I.name,I.count)}if(r.push(b),o.configFiles.length>=0&&(b="|      Conf files:",s=0,o.configFiles.forEach(E=>{l(E.name,E.count)}),r.push(b)),o.launchConfigFiles.length>0){let E="|      Launch Configs:";o.launchConfigFiles.forEach(I=>{const M=I.count>1?` ${I.name}(${I.count})`:` ${I.name}`;E+=M}),r.push(E)}return r.join(`
`)}j(o){const r=Math.max(...Object.keys(o).map(i=>i.length));return Object.keys(o).map(i=>`${i}:  ${" ".repeat(r-i.length)}  ${o[i]}`).join(`
                  `)}k(o){const r=[],i=[];return o.windows.forEach(s=>{s.folderURIs.length===0||s.remoteAuthority||(r.push(`|  Window (${s.title})`),s.folderURIs.forEach(l=>{const b=d.URI.revive(l);if(b.scheme===O.Schemas.file){const D=b.fsPath;i.push(u(D,["node_modules",".git"]).then(j=>{let E=`${j.fileCount} files`;j.maxFilesReached&&(E=`more than ${E}`),r.push(`|    Folder (${(0,C.$nc)(D)}): ${E}`),r.push(this.h(j))}).catch(j=>{r.push(`|      Error: Unable to collect workspace stats for folder ${D} (${j.toString()})`)}))}else r.push(`|    Folder (${b.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(s=>r.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}m(o,r){const i=new Map;o.windows.forEach(l=>i.set(l.pid,`window [${l.id}] (${l.title})`)),o.pidToNames.forEach(({pid:l,name:b})=>i.set(l,b));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),r&&this.n(o.mainPID,i,s,r,0),s.join(`
`)}n(o,r,i,s,l){const b=l===0;let D;b?D=s.pid===o?`${this.d.applicationName} main`:"remote agent":r.has(s.pid)?D=r.get(s.pid):D=`${"  ".repeat(l)} ${s.name}`;const j=process.platform==="win32"?s.mem:n.totalmem()*(s.mem/100);i.push(`${s.load.toFixed(0).padStart(5," ")}	${(j/$.$bl.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${D}`),Array.isArray(s.children)&&s.children.forEach(E=>this.n(o,r,i,E,l+1))}async getWorkspaceFileExtensions(o){const r=new Set;for(const{uri:i}of o.folders){const s=d.URI.revive(i);if(s.scheme!==O.Schemas.file)continue;const l=s.fsPath;try{(await u(l,["node_modules",".git"])).fileTypes.forEach(D=>r.add(D.name))}catch{}}return{extensions:[...r]}}async reportWorkspaceStats(o){for(const{uri:r}of o.folders){const i=d.URI.revive(r);if(i.scheme!==O.Schemas.file)continue;const s=i.fsPath;try{const l=await u(s,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),l.fileTypes.forEach(b=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:b.name,count:b.count})}),l.launchConfigFiles.forEach(b=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:b.name,count:b.count})}),l.configFiles.forEach(b=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:b.name,count:b.count})})}catch{}}}};e.$ks=a,e.$ks=a=ve([se(0,w.$El),se(1,m.$Rj)],a)}),define(ae[253],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y_b=e.$X_b=void 0;class n{constructor(O){this.b=O}listen(O,C){throw new Error(`Event not found: ${C}`)}call(O,C,{eventName:S,data:d}){return this.b.forEach(c=>c.log(S,d)),Promise.resolve(null)}}e.$X_b=n;class R{constructor(O){this.b=O}log(O,C){return this.b.call("log",{eventName:O,data:C}).then(void 0,S=>`Failed to log telemetry: ${console.warn(S)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$Y_b=R}),define(ae[54],ce([0,1,35,12,68,125,28]),function(X,e,n,R,P,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=void 0;class S{constructor(o){this.value=o,this.isTrustedTelemetryValue=!0}}e.$Zo=S;class d{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$1o=d,e.$2o=new d;class c{async publicLog(o,r,i){}async publicLogError(o,r,i){}}e.$3o=c,e.$4o="telemetry",e.$5o="extensionTelemetryLog",e.$6o={log:()=>null,flush:()=>Promise.resolve(null)};function y(t,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!t.enableTelemetry)}e.$7o=y;function v(t,o){return o.extensionTestsLocationURI?!0:!(o.isBuilt||o.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.$8o=v;function k(t){const o=t.getValue(C.$Ml),r=t.getValue(C.$Nl);if(t.getValue(C.$Ol)===!1||r===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$9o=k;function $(t){const o={},r={},i={};p(t,i);for(let s in i){s=s.length>150?s.substr(s.length-149):s;const l=i[s];typeof l=="number"?r[s]=l:typeof l=="boolean"?r[s]=l?1:0:typeof l=="string"?(l.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${l.length}`),o[s]=l.substring(0,8191)):typeof l<"u"&&l!==null&&(o[s]=l)}return{properties:o,measurements:r}}e.$0o=$;const m=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function w(t){if(!t)return"none";const o=(0,P.$qm)(t);return m.has(o)?o:"other"}e.$$o=w;function p(t,o,r=0,i){if(t)for(const s of Object.getOwnPropertyNames(t)){const l=t[s],b=i?i+s:s;Array.isArray(l)?o[b]=(0,n.$Pn)(l):l instanceof Date?o[b]=l.toISOString():(0,R.$Uf)(l)?r<2?p(l,o,r+1,b+"."):o[b]=(0,n.$Pn)(l):o[b]=l}}function u(t,o){const r=t.msftInternalDomains||[],i=o.getValue("telemetry.internalTesting");return(0,O.$Yo)(r)||i}e.$_o=u;function f(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.$ap=f;function h(t,o){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let r=t;const i=[];for(const D of o)for(;;){const j=D.exec(t);if(!j)break;i.push([j.index,D.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,l=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let b=0;for(r="";;){const D=l.exec(t);if(!D)break;const j=i.some(([E,I])=>D.index<I&&E<l.lastIndex);!s.test(D[0])&&!j&&(r+=t.substring(b,D.index)+"<REDACTED: user-file-path>",b=l.lastIndex)}return b<t.length&&(r+=t.substr(b)),r}function g(t){if(!t)return t;const o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of o)if(r.regex.test(t))return`<REDACTED: ${r.label}>`;return t}function a(t,o){return(0,n.$Mn)(t,r=>{if(r instanceof S||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let i=r.replaceAll("%20"," ");i=h(i,o);for(const s of o)i=i.replace(s,"");return i=g(i),i}})}e.$bp=a}),define(ae[126],ce([0,1,25,120,123,4,7,15,36,54]),function(X,e,n,R,P,O,C,S,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$np=e.$mp=e.$lp=e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=void 0;function y(r,i){return r.uuid&&i.uuid?r.uuid===i.uuid:r.id===i.id?!0:(0,n.$ef)(r.id,i.id)===0}e.$cp=y;const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class k{static create(i){const s=i.manifest?i.manifest.version:i.version,l=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new k(i.identifier,s,l)}static parse(i){const s=v.exec(i);return s&&s[1]&&s[2]?new k({id:s[1]},s[2],s[4]||void 0):null}constructor(i,s,l="undefined"){this.version=s,this.targetPlatform=l,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof k?y(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$dp=k;const $=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function m(r){const i=$.exec(r);return i&&i[1]?[p(i[1]),i[2]]:[p(r),void 0]}e.$ep=m;function w(r,i){return`${r}.${i}`}e.$fp=w;function p(r){return r.toLowerCase()}e.$gp=p;function u(r,i){return p(w(r??P.$vm,i))}e.$hp=u;function f(r,i){const s=[],l=b=>{for(const D of s)if(D.some(j=>y(i(j),i(b))))return D;return null};for(const b of r){const D=l(b);D?D.push(b):s.push([b])}return s}e.$ip=f;function h(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.$jp=h;function g(r){return{id:new c.$Zo(r.identifier.id),name:new c.$Zo(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$kp=g,e.$lp=new P.$zm("pprice.better-merge");function a(r,i){const s=[],l=i.manifest.extensionDependencies?.slice(0)??[];for(;l.length;){const b=l.shift();if(b&&s.every(D=>!y(D.identifier,{id:b}))){const D=r.filter(j=>y(j.identifier,{id:b}));D.length===1&&(s.push(D[0]),l.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}e.$mp=a;async function t(r,i){if(!O.$k)return!1;let s;try{s=(await r.readFile(C.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await r.readFile(C.URI.file("/usr/lib/os-release"))).value.toString()}catch(b){i.debug("Error while getting the os-release file.",(0,S.$0)(b))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(r,i){const s=await t(r,i),l=(0,R.$Jo)(s?"alpine":O.$u,d.$ec);return i.debug("ComputeTargetPlatform:",l),l}e.$np=o}),define(ae[254],ce([0,1,208,54]),function(X,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=void 0;async function P(O,C,S,d,c,y,v){const k={"X-Market-Client-Id":`VSCode ${O}`,"User-Agent":`VSCode ${O} (${C.nameShort})`};if((0,R.$7o)(C,S)&&(0,R.$9o)(d)===3){const $=await(0,n.$Op)(S,c,y);k["X-Market-User-Id"]=$,k["VSCode-SessionId"]=v.machineId||$}return k}e.$Pp=P}),define(ae[255],ce([0,1,2,35,4,25,187,18,52,79,27,44,28,54]),function(X,e,n,R,P,O,C,S,d,c,y,v,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=void 0;let m=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(u,f,h){this.k=f,this.l=h,this.d={},this.i=new n.$Sc,this.j=[],this.b=u.appenders,this.c=u.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=u.piiPaths||[],this.g=3,this.h=!!u.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const g of this.f)this.j.push(new RegExp((0,O.$Xe)(g),"gi")),g.indexOf("\\")>=0&&this.j.push(new RegExp((0,O.$Xe)(g.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(g=>{(g.affectsConfiguration(k.$Ml)||g.affectsConfiguration(k.$Ol)||g.affectsConfiguration(k.$Nl))&&this.m()}))}setExperimentProperty(u,f){this.d[u]=f}m(){let u=(0,$.$9o)(this.k);const f=this.l.enabledTelemetryLevels;if(f){this.h=this.sendErrorTelemetry?f.error:!1;const h=f.usage?3:f.error?2:0;u=Math.min(u,h)}this.g=u}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(u,f,h){this.g<f||(h=(0,R.$Nn)(h,this.d),h=(0,$.$bp)(h,this.j),h=(0,R.$Nn)(h,this.c),this.b.forEach(g=>g.log(u,h)))}publicLog(u,f){this.n(u,3,f)}publicLog2(u,f){this.publicLog(u,f)}publicLogError(u,f){this.h&&this.n(u,2,f)}publicLogError2(u,f){this.publicLogError(u,f)}};e.$Dr=m,e.$Dr=m=ve([se(1,S.$Li),se(2,y.$Rj)],m);function w(){const p=(0,C.localize)(0,null,c.default.nameLong),u=c.default.privacyStatementUrl?(0,C.localize)(2,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,C.localize)(1,null,"https://aka.ms/vscode-telemetry"),f=P.$o?"":(0,C.localize)(3,null),h=(0,C.localize)(4,null),g=(0,C.localize)(5,null),a=(0,C.localize)(6,null),t=(0,C.localize)(7,null),o=`
|       | ${h} | ${g} | ${a} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,C.localize)(8,null);return`
${p} ${u} ${f}

&nbsp;

${t}
${o}

&nbsp;

${r}
`}v.$Wn.as(d.$2n.Configuration).registerConfiguration({id:k.$Ll,order:1,type:"object",title:(0,C.localize)(9,null),properties:{[k.$Ml]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,C.localize)(10,null),(0,C.localize)(11,null),(0,C.localize)(12,null),(0,C.localize)(13,null)],markdownDescription:w(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),v.$Wn.as(d.$2n.Configuration).registerConfiguration({id:k.$Ll,order:110,type:"object",title:(0,C.localize)(14,null),properties:{[k.$Ol]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,C.localize)(16,null,c.default.nameLong,c.default.privacyStatementUrl):(0,C.localize)(15,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,C.localize)(17,null,`\`#${k.$Ml}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ae[256],ce([0,1,4,89,28]),function(X,e,n,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oac=e.$nac=void 0;async function O(S,d){let c=S.getItem(P.$Jl);return(typeof c!="string"||n.$j&&c==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(c=await(0,R.$nn)(d.error.bind(d))),c}e.$nac=O;async function C(S,d){let c=S.getItem(P.$Kl);return typeof c!="string"&&(c=await(0,R.$on)(d.error.bind(d))),c}e.$oac=C}),define(ae[257],ce([0,1,28,256]),function(X,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qac=e.$pac=void 0;async function P(C,S){const d=await(0,R.$nac)(C,S);return C.setItem(n.$Jl,d),d}e.$pac=P;async function O(C,S){const d=await(0,R.$oac)(C,S);return C.setItem(n.$Kl,d),d}e.$qac=O}),define(ae[127],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var n;(function(R){R[R.Replace=1]="Replace",R[R.Append=2]="Append",R[R.Prepend=3]="Prepend"})(n||(e.EnvironmentVariableMutatorType=n={}))}),define(ae[258],ce([0,1,4,127]),function(X,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7r=void 0;const P=new Map([[R.EnvironmentVariableMutatorType.Append,"APPEND"],[R.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[R.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class O{constructor(y){this.collections=y,this.a=new Map,this.b=new Map,y.forEach((v,k)=>{this.d(v,k);const $=v.map.entries();let m=$.next();for(;!m.done;){const w=m.value[1],p=m.value[0];let u=this.a.get(p);if(u||(u=[],this.a.set(p,u)),u.length>0&&u[0].type===R.EnvironmentVariableMutatorType.Replace){m=$.next();continue}const f={extensionIdentifier:k,value:w.value,type:w.type,scope:w.scope,variable:w.variable,options:w.options};f.scope||delete f.scope,u.unshift(f),m=$.next()}})}async applyToProcessEnvironment(y,v,k){let $;n.$i&&($={},Object.keys(y).forEach(m=>$[m.toLowerCase()]=m));for(const[m,w]of this.getVariableMap(v)){const p=n.$i&&$[m.toLowerCase()]||m;for(const u of w){const f=k?await k(u.value):u.value;if(u.options?.applyAtProcessCreation??!0)switch(u.type){case R.EnvironmentVariableMutatorType.Append:y[p]=(y[p]||"")+f;break;case R.EnvironmentVariableMutatorType.Prepend:y[p]=f+(y[p]||"");break;case R.EnvironmentVariableMutatorType.Replace:y[p]=f;break}if(u.options?.applyAtShellIntegration??!1){const h=`VSCODE_ENV_${P.get(u.type)}`;y[h]=(y[h]?y[h]+":":"")+m+"="+this.c(f)}}}}c(y){return y.replaceAll(":","\\x3a")}diff(y,v){const k=new Map,$=new Map,m=new Map;if(y.getVariableMap(v).forEach((w,p)=>{const u=this.getVariableMap(v).get(p),f=S(w,u);f&&k.set(p,f)}),this.getVariableMap(v).forEach((w,p)=>{const u=y.getVariableMap(v).get(p),f=S(w,u);f&&m.set(p,f)}),this.getVariableMap(v).forEach((w,p)=>{const u=y.getVariableMap(v).get(p),f=d(w,u);f&&$.set(p,f)}),!(k.size===0&&$.size===0&&m.size===0))return{added:k,changed:$,removed:m}}getVariableMap(y){const v=new Map;for(const k of this.a.values()){const $=k.filter(m=>C(m,y));$.length>0&&v.set($[0].variable,$)}return v}getDescriptionMap(y){const v=new Map;for(const k of this.b.values()){const $=k.filter(m=>C(m,y,!0));for(const m of $)v.set(m.extensionIdentifier,m.description)}return v}d(y,v){if(!y.descriptionMap)return;const k=y.descriptionMap.entries();let $=k.next();for(;!$.done;){const m=$.value[1],w=$.value[0];let p=this.b.get(w);p||(p=[],this.b.set(w,p));const u={extensionIdentifier:v,scope:m.scope,description:m.description};u.scope||delete u.scope,p.push(u),$=k.next()}}}e.$7r=O;function C(c,y,v=!1){return c.scope?!!(c.scope.workspaceFolder&&y?.workspaceFolder&&c.scope.workspaceFolder.index===y.workspaceFolder.index):v?y===c.scope:!0}function S(c,y){if(!y)return c;const v=new Set;y.forEach($=>v.add($.extensionIdentifier));const k=[];return c.forEach($=>{v.has($.extensionIdentifier)||k.push($)}),k.length===0?void 0:k}function d(c,y){if(!y)return;const v=new Map;y.forEach($=>v.set($.extensionIdentifier,$));const k=[];return c.forEach($=>{const m=v.get($.extensionIdentifier);m&&($.type!==m.type||$.value!==m.value||$.scope?.workspaceFolder?.index!==m.scope?.workspaceFolder?.index)&&k.push(m)}),k.length===0?void 0:k}}),define(ae[259],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6r=e.$5r=e.$4r=e.$3r=e.$2r=e.$1r=void 0;function n(d){return[...d.entries()]}e.$1r=n;function R(d){return d?[...d.entries()]:[]}e.$2r=R;function P(d){return new Map(d)}e.$3r=P;function O(d){return new Map(d??[])}e.$4r=O;function C(d){return Array.from(d.entries()).map(c=>[c[0],n(c[1].map),R(c[1].descriptionMap)])}e.$5r=C;function S(d){return new Map(d.map(c=>[c[0],{map:P(c[1]),descriptionMap:O(c[2])}]))}e.$6r=S}),define(ae[260],ce([0,1,8,23,3,2,5]),function(X,e,n,R,P,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rr=void 0;let S=class extends O.$Tc{constructor(c,y){super(),this.h=y,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new P.$5d),this.onCreateRequest=this.g.event,this.b=c===void 0?15e3:c,this.B((0,O.$Rc)(()=>{for(const v of this.f.values())(0,O.$Oc)(v)}))}createRequest(c){return new Promise((y,v)=>{const k=++this.a;this.c.set(k,y),this.g.fire({requestId:k,...c});const $=new R.$ce;(0,n.$gh)(this.b,$.token).then(()=>v(`Request ${k} timed out (${this.b}ms)`)),this.f.set(k,[(0,O.$Rc)(()=>$.cancel())])})}acceptReply(c,y){const v=this.c.get(c);v?(this.c.delete(c),(0,O.$Oc)(this.f.get(c)||[]),this.f.delete(c),v(y)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${c}`)}};e.$Rr=S,e.$Rr=S=ve([se(1,C.$zj)],S)}),define(ae[128],ce([0,1,6,117,44]),function(X,e,n,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nr=e.$Mr=e.$Lr=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$Kr=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$Jr=void 0,e.$Jr=new R.$wj("terminalTabFocusMode",!1,!0);var O;(function(a){a.AutomationProfile="terminal.integrated.automationProfile.",a.DefaultProfile="terminal.integrated.defaultProfile.",a.Profiles="terminal.integrated.profiles."})(O||(e.TerminalSettingPrefix=O={}));var C;(function(a){a.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",a.AutomationProfileLinux="terminal.integrated.automationProfile.linux",a.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",a.AutomationProfileWindows="terminal.integrated.automationProfile.windows",a.ProfilesWindows="terminal.integrated.profiles.windows",a.ProfilesMacOs="terminal.integrated.profiles.osx",a.ProfilesLinux="terminal.integrated.profiles.linux",a.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",a.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",a.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",a.UseWslProfiles="terminal.integrated.useWslProfiles",a.TabsDefaultColor="terminal.integrated.tabs.defaultColor",a.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",a.TabsEnabled="terminal.integrated.tabs.enabled",a.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",a.TabsHideCondition="terminal.integrated.tabs.hideCondition",a.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",a.TabsShowActions="terminal.integrated.tabs.showActions",a.TabsLocation="terminal.integrated.tabs.location",a.TabsFocusMode="terminal.integrated.tabs.focusMode",a.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",a.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",a.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",a.CopyOnSelection="terminal.integrated.copyOnSelection",a.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",a.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",a.FontFamily="terminal.integrated.fontFamily",a.FontSize="terminal.integrated.fontSize",a.LetterSpacing="terminal.integrated.letterSpacing",a.LineHeight="terminal.integrated.lineHeight",a.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",a.TabStopWidth="terminal.integrated.tabStopWidth",a.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",a.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",a.BellDuration="terminal.integrated.bellDuration",a.FontWeight="terminal.integrated.fontWeight",a.FontWeightBold="terminal.integrated.fontWeightBold",a.CursorBlinking="terminal.integrated.cursorBlinking",a.CursorStyle="terminal.integrated.cursorStyle",a.CursorStyleInactive="terminal.integrated.cursorStyleInactive",a.CursorWidth="terminal.integrated.cursorWidth",a.Scrollback="terminal.integrated.scrollback",a.DetectLocale="terminal.integrated.detectLocale",a.DefaultLocation="terminal.integrated.defaultLocation",a.GpuAcceleration="terminal.integrated.gpuAcceleration",a.TerminalTitleSeparator="terminal.integrated.tabs.separator",a.TerminalTitle="terminal.integrated.tabs.title",a.TerminalDescription="terminal.integrated.tabs.description",a.RightClickBehavior="terminal.integrated.rightClickBehavior",a.Cwd="terminal.integrated.cwd",a.ConfirmOnExit="terminal.integrated.confirmOnExit",a.ConfirmOnKill="terminal.integrated.confirmOnKill",a.EnableBell="terminal.integrated.enableBell",a.EnableVisualBell="terminal.integrated.enableVisualBell",a.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",a.AllowChords="terminal.integrated.allowChords",a.AllowMnemonics="terminal.integrated.allowMnemonics",a.TabFocusMode="terminal.integrated.tabFocusMode",a.EnvMacOs="terminal.integrated.env.osx",a.EnvLinux="terminal.integrated.env.linux",a.EnvWindows="terminal.integrated.env.windows",a.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",a.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",a.ShowExitAlert="terminal.integrated.showExitAlert",a.SplitCwd="terminal.integrated.splitCwd",a.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",a.WordSeparators="terminal.integrated.wordSeparators",a.EnableFileLinks="terminal.integrated.enableFileLinks",a.UnicodeVersion="terminal.integrated.unicodeVersion",a.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",a.LocalEchoEnabled="terminal.integrated.localEchoEnabled",a.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",a.LocalEchoStyle="terminal.integrated.localEchoStyle",a.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",a.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",a.HideOnStartup="terminal.integrated.hideOnStartup",a.CustomGlyphs="terminal.integrated.customGlyphs",a.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",a.InheritEnv="terminal.integrated.inheritEnv",a.ShowLinkHover="terminal.integrated.showLinkHover",a.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",a.AutoReplies="terminal.integrated.autoReplies",a.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",a.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",a.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",a.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",a.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",a.EnableImages="terminal.integrated.enableImages",a.SmoothScrolling="terminal.integrated.smoothScrolling",a.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",a.FocusAfterRun="terminal.integrated.focusAfterRun",a.AccessibleViewPreserveCursorPosition="terminal.integrated.accessibleViewPreserveCursorPosition",a.AccessibleViewFocusOnCommandExecution="terminal.integrated.accessibleViewFocusOnCommandExecution",a.StickyScrollEnabled="terminal.integrated.stickyScroll.enabled",a.StickyScrollMaxLineCount="terminal.integrated.stickyScroll.maxLineCount",a.MouseWheelZoom="terminal.integrated.mouseWheelZoom",a.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",a.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",a.DevMode="terminal.integrated.developer.devMode"})(C||(e.TerminalSettingId=C={}));var S;(function(a){a.PowerShell="pwsh",a.Bash="bash",a.Fish="fish",a.Sh="sh",a.Csh="csh",a.Ksh="ksh",a.Zsh="zsh",a.Python="python"})(S||(e.PosixShellType=S={}));var d;(function(a){a.CommandPrompt="cmd",a.PowerShell="pwsh",a.Wsl="wsl",a.GitBash="gitbash",a.Python="python"})(d||(e.WindowsShellType=d={}));var c;(function(a){a[a.Api=0]="Api",a[a.Process=1]="Process",a[a.Sequence=2]="Sequence",a[a.Config=3]="Config"})(c||(e.TitleEventSource=c={}));var y;(function(a){a.LocalPty="localPty",a.PtyHost="ptyHost",a.PtyHostWindow="ptyHostWindow",a.Logger="logger",a.Heartbeat="heartbeat"})(y||(e.TerminalIpcChannels=y={}));var v;(function(a){a.Cwd="cwd",a.InitialCwd="initialCwd",a.FixedDimensions="fixedDimensions",a.Title="title",a.ShellType="shellType",a.HasChildProcesses="hasChildProcesses",a.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",a.OverrideDimensions="overrideDimensions",a.FailedShellIntegrationActivation="failedShellIntegrationActivation",a.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(v||(e.ProcessPropertyType=v={})),e.$Kr=(0,n.$fi)("ptyService");var k;(function(a){a[a.BeatInterval=5e3]="BeatInterval",a[a.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",a[a.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",a[a.SecondWaitMultiplier=1]="SecondWaitMultiplier",a[a.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(k||(e.HeartbeatConstants=k={}));var $;(function(a){a[a.Panel=1]="Panel",a[a.Editor=2]="Editor"})($||(e.TerminalLocation=$={}));var m;(function(a){a.TerminalView="view",a.Editor="editor"})(m||(e.TerminalLocationString=m={}));var w;(function(a){a[a.GraceTime=6e4]="GraceTime",a[a.ShortGraceTime=6e3]="ShortGraceTime"})(w||(e.LocalReconnectConstants=w={}));var p;(function(a){a[a.HighWatermarkChars=1e5]="HighWatermarkChars",a[a.LowWatermarkChars=5e3]="LowWatermarkChars",a[a.CharCountAckSize=5e3]="CharCountAckSize"})(p||(e.FlowControlConstants=p={}));var u;(function(a){a.GitBash="Git Bash",a.Pwsh="PowerShell"})(u||(e.ProfileSource=u={}));var f;(function(a){a[a.Off=0]="Off",a[a.FinalTerm=1]="FinalTerm",a[a.VSCode=2]="VSCode"})(f||(e.ShellIntegrationStatus=f={}));var h;(function(a){a[a.Unknown=0]="Unknown",a[a.Shutdown=1]="Shutdown",a[a.Process=2]="Process",a[a.User=3]="User",a[a.Extension=4]="Extension"})(h||(e.TerminalExitReason=h={})),e.$Lr={Backend:"workbench.contributions.terminal.processBackend"};class g{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const o=this.b(t.remoteAuthority);if(this.a.has(o))throw new Error(`A terminal backend with remote authority '${o}' was already registered.`);this.a.set(o,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}P.$Wn.add(e.$Lr.Backend,new g),e.$Mr=(0,n.$fi)("localPtyService"),e.$Nr=(0,n.$fi)("terminalLogService")}),define(ae[261],ce([0,1,74,7,189,105]),function(X,e,n,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vr=e.$Ur=e.$Tr=e.$Sr=void 0;function C(k,$){const m=[{name:null,description:(0,P.localize)(0,null)}];return m.push(...k.map(w=>({name:w.profileName,description:S(w)}))),$&&m.push(...$.map(w=>({name:w.title,description:d(w)}))),{values:m.map(w=>w.name),markdownDescriptions:m.map(w=>w.description)}}e.$Sr=C;function S(k){let $=`$(${O.ThemeIcon.isThemeIcon(k.icon)?k.icon.id:k.icon?k.icon:n.$ok.terminal.id}) ${k.profileName}
- path: ${k.path}`;return k.args&&(typeof k.args=="string"?$+=`
- args: "${k.args}"`:$+=`
- args: [${k.args.length===0?"":`'${k.args.join("','")}'`}]`),k.overrideName!==void 0&&($+=`
- overrideName: ${k.overrideName}`),k.color&&($+=`
- color: ${k.color}`),k.env&&($+=`
- env: ${JSON.stringify(k.env)}`),$}function d(k){return`$(${O.ThemeIcon.isThemeIcon(k.icon)?k.icon.id:k.icon?k.icon:n.$ok.terminal.id}) ${k.title}
- extensionIdentifier: ${k.extensionIdentifier}`}function c(k,$){if(!k&&!$)return!0;if(typeof k=="string"&&typeof $=="string")return k===$;if(Array.isArray(k)&&Array.isArray($)){if(k.length!==$.length)return!1;for(let m=0;m<k.length;m++)if(k[m]!==$[m])return!1;return!0}return!1}e.$Tr=c;function y(k,$){if(!k&&!$)return!0;if(!k||!$)return!1;if(O.ThemeIcon.isThemeIcon(k)&&O.ThemeIcon.isThemeIcon($))return k.id===$.id&&k.color===$.color;if(typeof k=="object"&&"light"in k&&"dark"in k&&typeof $=="object"&&"light"in $&&"dark"in $){const m=k,w=$;if((R.URI.isUri(m.light)||v(m.light))&&(R.URI.isUri(m.dark)||v(m.dark))&&(R.URI.isUri(w.light)||v(w.light))&&(R.URI.isUri(w.dark)||v(w.dark)))return m.light.path===w.light.path&&m.dark.path===w.dark.path}if(R.URI.isUri(k)&&R.URI.isUri($)||v(k)||v($)){const m=k,w=$;return m.path===w.path&&m.scheme===w.scheme}return!1}e.$Ur=y;function v(k){return k?typeof k.path=="string"&&typeof k.scheme=="string":!1}e.$Vr=v}),define(ae[262],ce([0,1,74,4,188,52,44,261]),function(X,e,n,R,P,O,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zr=e.$Yr=e.$Xr=e.$Wr=void 0,e.$Wr={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$Xr={type:"string",enum:Array.from((0,n.$mk)(),p=>p.id),markdownEnumDescriptions:Array.from((0,n.$mk)(),p=>`$(${p.id})`)};const d={args:{description:(0,P.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,P.localize)(1,null),type:"boolean"},icon:{description:(0,P.localize)(2,null),...e.$Xr},color:{description:(0,P.localize)(3,null),...e.$Wr},env:{markdownDescription:(0,P.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},c={type:"object",required:["path"],properties:{path:{description:(0,P.localize)(5,null),type:["string","array"],items:{type:"string"}},...d}},y={type:"object",required:["path"],properties:{path:{description:(0,P.localize)(6,null),type:["string"],items:{type:"string"}},...d}};function v(p){const u=p===2?"linux":p===1?"osx":"windows";return(0,P.localize)(7,null,(0,R.$h)(p),'```json\n"terminal.integrated.profile.'+u+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const k={id:"terminal",order:100,title:(0,P.localize)(8,null),type:"object",properties:{"terminal.integrated.automationProfile.linux":{restricted:!0,markdownDescription:(0,P.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},y],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.automationProfile.osx":{restricted:!0,markdownDescription:(0,P.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},y],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.automationProfile.windows":{restricted:!0,markdownDescription:(0,P.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},y],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.profiles.windows":{restricted:!0,markdownDescription:v(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,P.localize)(12,null),enum:["PowerShell","Git Bash"]},...d}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,P.localize)(13,null),type:"string"},id:{description:(0,P.localize)(14,null),type:"string"},title:{description:(0,P.localize)(15,null),type:"string"},...d}},{type:"null"},c]}},"terminal.integrated.profiles.osx":{restricted:!0,markdownDescription:v(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,P.localize)(16,null),type:"string"},id:{description:(0,P.localize)(17,null),type:"string"},title:{description:(0,P.localize)(18,null),type:"string"},...d}},{type:"null"},c]}},"terminal.integrated.profiles.linux":{restricted:!0,markdownDescription:v(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,P.localize)(19,null),type:"string"},id:{description:(0,P.localize)(20,null),type:"string"},title:{description:(0,P.localize)(21,null),type:"string"},...d}},{type:"null"},c]}},"terminal.integrated.useWslProfiles":{description:(0,P.localize)(22,null),type:"boolean",default:!0},"terminal.integrated.inheritEnv":{scope:1,description:(0,P.localize)(23,null),type:"boolean",default:!0},"terminal.integrated.persistentSessionScrollback":{scope:1,markdownDescription:(0,P.localize)(24,null),type:"number",default:100},"terminal.integrated.showLinkHover":{scope:1,description:(0,P.localize)(25,null),type:"boolean",default:!0},"terminal.integrated.ignoreProcessNames":{markdownDescription:(0,P.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function $(){C.$Wn.as(O.$2n.Configuration).registerConfiguration(k),w()}e.$Yr=$;let m;function w(p,u){const f=C.$Wn.as(O.$2n.Configuration);let h;p&&(h=(0,S.$Sr)(p?.profiles,u));const g=m;m={id:"terminal",order:100,title:(0,P.localize)(27,null),type:"object",properties:{"terminal.integrated.defaultProfile.linux":{restricted:!0,markdownDescription:(0,P.localize)(28,null),type:["string","null"],default:null,enum:p?.os===3?h?.values:void 0,markdownEnumDescriptions:p?.os===3?h?.markdownDescriptions:void 0},"terminal.integrated.defaultProfile.osx":{restricted:!0,markdownDescription:(0,P.localize)(29,null),type:["string","null"],default:null,enum:p?.os===2?h?.values:void 0,markdownEnumDescriptions:p?.os===2?h?.markdownDescriptions:void 0},"terminal.integrated.defaultProfile.windows":{restricted:!0,markdownDescription:(0,P.localize)(30,null),type:["string","null"],default:null,enum:p?.os===1?h?.values:void 0,markdownEnumDescriptions:p?.os===1?h?.markdownDescriptions:void 0}}},f.updateConfigurations({add:[m],remove:g?[g]:[]})}e.$Zr=w}),define(ae[263],ce([0,1,26,13,35,9,4,36,25,12,21,127,259,258]),function(X,e,n,R,P,O,C,S,d,c,y,v,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0r=e.$9r=e.$8r=void 0;function m(){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(n.release());let s=0;return i&&i.length===4&&(s=parseInt(i[3])),s}e.$8r=m;async function w(i,s,l,b=S.env,D=y.Promises.exists){if(O.$ic(i))return await D(i)?i:void 0;if(s===void 0&&(s=S.cwd()),O.$mc(i)!=="."){const M=O.$jc(s,i);return await D(M)?M:void 0}const E=(0,P.$Rn)(b,"PATH");if(l===void 0&&(0,c.$Sf)(E)&&(l=E.split(O.$tc)),l===void 0||l.length===0){const M=O.$jc(s,i);return await D(M)?M:void 0}for(const M of l){let T;if(O.$ic(M)?T=O.$jc(M,i):T=O.$jc(s,M,i),await D(T))return T;if(C.$i){let W=T+".com";if(await D(W)||(W=T+".exe",await D(W)))return W}}const I=O.$jc(s,i);return await D(I)?I:void 0}e.$9r=w;function p(i,s,l,b,D){const j=C.$i&&(!s.windowsEnableConpty||m()<18309);if(!s.shellIntegration.enabled||!i.executable||i.isFeatureTerminal&&!i.forceShellIntegration||i.hideFromUser||i.ignoreShellIntegration||j)return;const E=i.args,I=S.$dc==="win32"?O.$nc(i.executable).toLowerCase():O.$nc(i.executable),M=O.$mc(R.$zg.asFileUri("").fsPath);let T;const W={VSCODE_INJECTION:"1"};if(s.shellIntegration.nonce&&(W.VSCODE_NONCE=s.shellIntegration.nonce),C.$i){if(I==="pwsh.exe"||I==="powershell.exe")return!E||o(E)?T=h.get(f.WindowsPwsh):t(E)&&(T=h.get(f.WindowsPwshLogin)),T?(T=[...T],T[T.length-1]=(0,d.$Te)(T[T.length-1],M,""),s.shellIntegration.suggestEnabled&&(W.VSCODE_SUGGEST="1"),{newArgs:T,envMixin:W}):void 0;b.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args);return}switch(I){case"bash":return!E||E.length===0?T=h.get(f.Bash):r(E)&&(W.VSCODE_SHELL_LOGIN="1",u(s,W),T=h.get(f.Bash)),T?(T=[...T],T[T.length-1]=(0,d.$Te)(T[T.length-1],M),{newArgs:T,envMixin:W}):void 0;case"fish":{const V=l?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",J=O.$jc(M,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return W.XDG_DATA_DIRS=`${V}:${J}`,u(s,W),{newArgs:void 0,envMixin:W}}case"pwsh":return!E||o(E)?T=h.get(f.Pwsh):t(E)&&(T=h.get(f.PwshLogin)),T?(s.shellIntegration.suggestEnabled&&(W.VSCODE_SUGGEST="1"),T=[...T],T[T.length-1]=(0,d.$Te)(T[T.length-1],M,""),{newArgs:T,envMixin:W}):void 0;case"zsh":{if(!E||E.length===0?T=h.get(f.Zsh):r(E)?(T=h.get(f.ZshLogin),u(s,W)):(E===h.get(f.Zsh)||E===h.get(f.ZshLogin))&&(T=E),!T)return;T=[...T],T[T.length-1]=(0,d.$Te)(T[T.length-1],M);let V;try{V=n.userInfo().username}catch{V="unknown"}const J=O.$jc(n.tmpdir(),`${V}-${D.applicationName}-zsh`);W.ZDOTDIR=J;const le=l?.ZDOTDIR??n.homedir()??"~";W.USER_ZDOTDIR=le;const re=[];return re.push({source:O.$jc(M,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:O.$jc(J,".zshrc")}),re.push({source:O.$jc(M,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:O.$jc(J,".zprofile")}),re.push({source:O.$jc(M,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:O.$jc(J,".zshenv")}),re.push({source:O.$jc(M,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:O.$jc(J,".zlogin")}),{newArgs:T,envMixin:W,filesToCopy:re}}}b.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args)}e.$0r=p;function u(i,s){if(C.$j&&i.environmentVariableCollections){const l=(0,k.$6r)(i.environmentVariableCollections),D=new $.$7r(l).getVariableMap({workspaceFolder:i.workspaceFolder}).get("PATH"),j=[];if(D)for(const E of D)E.type===v.EnvironmentVariableMutatorType.Prepend&&j.push(E.value);j.length>0&&(s.VSCODE_PATH_PREFIX=j.join(""))}}var f;(function(i){i.WindowsPwsh="windows-pwsh",i.WindowsPwshLogin="windows-pwsh-login",i.Pwsh="pwsh",i.PwshLogin="pwsh-login",i.Zsh="zsh",i.ZshLogin="zsh-login",i.Bash="bash"})(f||(f={}));const h=new Map;h.set(f.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),h.set(f.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),h.set(f.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),h.set(f.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),h.set(f.Zsh,["-i"]),h.set(f.ZshLogin,["-il"]),h.set(f.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const g=["-login","-l"],a=["-nol","-nologo"];function t(i){return typeof i=="string"?g.includes(i.toLowerCase()):i.length===1&&g.includes(i[0].toLowerCase())||i.length===2&&(g.includes(i[0].toLowerCase())||g.includes(i[1].toLowerCase()))&&(a.includes(i[0].toLowerCase())||a.includes(i[1].toLowerCase()))}function o(i){return typeof i=="string"?a.includes(i.toLowerCase()):i.length===0||i?.length===1&&a.includes(i[0].toLowerCase())}function r(i){return i==="string"&&g.includes(i.toLowerCase())||typeof i!="string"&&i.length===1&&g.includes(i[0].toLowerCase())}}),define(ae[264],ce([0,1,48,74,9,4,12,21,109,263,116]),function(X,e,n,R,P,O,C,S,d,c,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$r=void 0;var v;(function(l){l.UnixShellsPath="/etc/shells"})(v||(v={}));let k,$=!0;function m(l,b,D,j,E=process.env,I,M,T,W){return I=I||{existsFile:S.SymlinkSupport.existsFile,readFile:S.Promises.readFile},O.$i?w(D,I,E,M,j.getValue("terminal.integrated.useWslProfiles")!==!1,l&&typeof l=="object"?{...l}:j.getValue("terminal.integrated.profiles.windows"),typeof b=="string"?b:j.getValue("terminal.integrated.defaultProfile.windows"),W,T):r(I,M,D,l&&typeof l=="object"?{...l}:j.getValue(O.$k?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof b=="string"?b:j.getValue(O.$k?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),W,T,E)}e.$$r=m;async function w(l,b,D,j,E,I,M,T,W){const V=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),J=`${process.env.windir}\\${V?"Sysnative":"System32"}`;let le=!1;(0,c.$8r)()>=16299&&(le=!0),await h(T);const re=new Map;if(l){re.set("PowerShell",{source:"PowerShell",icon:R.$ok.terminalPowershell,isAutoDetected:!0}),re.set("Windows PowerShell",{path:`${J}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:R.$ok.terminalPowershell,isAutoDetected:!0}),re.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),re.set("Command Prompt",{path:`${J}\\cmd.exe`,icon:R.$ok.terminalCmd,isAutoDetected:!0}),re.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),re.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],env:{CHERE_INVOKING:"1"},icon:R.$ok.terminalBash,isAutoDetected:!0});const Q=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;re.set("Cmder",{path:`${J}\\cmd.exe`,args:["/K",Q],requiresPath:process.env.CMDER_ROOT?Q:{path:Q,isUnsafe:!0},isAutoDetected:!0})}i(I,re);const ue=await p(re.entries(),M,b,D,j,W);if(l&&E)try{const Q=await t(`${J}\\${le?"wsl":"bash"}.exe`,M);for(const Y of Q)(!I||!(Y.profileName in I))&&ue.push(Y)}catch{$&&(j?.trace("WSL is not installed, so could not detect WSL profiles"),$=!1)}return ue}async function p(l,b,D,j=process.env,E,I){const M=[];for(const[T,W]of l)M.push(u(T,W,b,D,j,E,I));return(await Promise.all(M)).filter(T=>!!T)}async function u(l,b,D,j,E=process.env,I,M){if(b===null)return;let T,W,V;if("source"in b&&!("path"in b)){const ue=k?.get(b.source);if(!ue)return;T=ue.paths,W=b.args||ue.args,b.icon?V=f(b.icon):ue.icon&&(V=ue.icon)}else T=Array.isArray(b.path)?b.path:[b.path],W=O.$i||Array.isArray(b.args)?b.args:void 0,V=f(b.icon);let J;if(M){const ue=T.map(Y=>typeof Y=="string"?Y:Y.path),Q=await M(ue);J=new Array(T.length);for(let Y=0;Y<T.length;Y++)typeof T[Y]=="string"?J[Y]=Q[Y]:J[Y]={path:Q[Y],isUnsafe:!0}}else J=T.slice();let le;if(b.requiresPath){let ue;if((0,C.$Sf)(b.requiresPath)?ue=b.requiresPath:(ue=b.requiresPath.path,b.requiresPath.isUnsafe&&(le=ue)),!await j.existsFile(ue))return}const re=await s(l,D,J,j,E,W,b.env,b.overrideName,b.isAutoDetected,le);if(!re){I?.debug("Terminal profile not validated",l,T);return}return re.isAutoDetected=b.isAutoDetected,re.icon=V,re.color=b.color,re}function f(l){return typeof l=="string"?{id:l}:l}async function h(l){if(k&&!l)return;const[b,D]=await Promise.all([g(),l||a()]);k=new Map,k.set("Git Bash",{profileName:"Git Bash",paths:b,args:["--login","-i"]}),k.set("PowerShell",{profileName:"PowerShell",paths:D,icon:R.$ok.terminalPowershell})}async function g(){const l=new Set,b=await(0,c.$9r)("git.exe");if(b){const E=(0,y.dirname)(b);l.add((0,y.resolve)(E,"../.."))}function D(E,I){I&&E.add(I)}D(l,process.env.ProgramW6432),D(l,process.env.ProgramFiles),D(l,process.env["ProgramFiles(X86)"]),D(l,`${process.env.LocalAppData}\\Program`);const j=[];for(const E of l)j.push(`${E}\\Git\\bin\\bash.exe`,`${E}\\Git\\usr\\bin\\bash.exe`,`${E}\\usr\\bin\\bash.exe`);return j.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),j.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),j}async function a(){const l=[];for await(const b of(0,d.$Zl)())l.push(b.exePath);return l}async function t(l,b){const D=[],j=await new Promise((M,T)=>{n.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(W,V)=>{if(W)return T("Problem occurred when getting wsl distros");M(V)})});if(!j)return[];const E=new RegExp(/[\r?\n]/),I=j.split(E).filter(M=>M.trim().length>0&&M!=="");for(const M of I){if(M===""||M.startsWith("docker-desktop"))continue;const T=`${M} (WSL)`,W={profileName:T,path:l,args:["-d",`${M}`],isDefault:T===b,icon:o(M),isAutoDetected:!1};D.push(W)}return D}function o(l){return l.includes("Ubuntu")?R.$ok.terminalUbuntu:l.includes("Debian")?R.$ok.terminalDebian:R.$ok.terminalLinux}async function r(l,b,D,j,E,I,M,T){const W=new Map;if(D&&await l.existsFile("/etc/shells")){const V=(await l.readFile("/etc/shells")).toString(),J=(I||V.split(`
`)).map(re=>{const ue=re.indexOf("#");return ue===-1?re:re.substring(0,ue)}).filter(re=>re.trim().length>0),le=new Map;for(const re of J){let ue=(0,P.$nc)(re),Q=le.get(ue)||0;Q++,Q>1&&(ue=`${ue} (${Q})`),le.set(ue,Q),W.set(ue,{path:re,isAutoDetected:!0})}}return i(j,W),await p(W.entries(),E,l,T,b,M)}function i(l,b){if(l)for(const[D,j]of Object.entries(l))j===null||typeof j!="object"||!("path"in j)&&!("source"in j)?b.delete(D):(j.icon=j.icon||b.get(D)?.icon,b.set(D,j))}async function s(l,b,D,j,E,I,M,T,W,V){if(D.length===0)return Promise.resolve(void 0);const J=D.shift();if(J==="")return s(l,b,D,j,E,I,M,T,W);const le=typeof J!="string"&&J.isUnsafe,re=typeof J=="string"?J:J.path,ue={profileName:l,path:re,args:I,env:M,overrideName:T,isAutoDetected:W,isDefault:l===b,isUnsafePath:le,requiresUnsafePath:V};if((0,P.$nc)(re)===re){const Y=E.PATH?E.PATH.split(P.$tc):void 0,U=await(0,c.$9r)(re,void 0,Y,void 0,j.existsFile);return U?(ue.path=U,ue.isFromPath=!0,ue):s(l,b,D,j,E,I)}return await j.existsFile((0,P.$hc)(re))?ue:s(l,b,D,j,E,I,M,T,W)}}),define(ae[265],ce([0,1,3,2,4,43,18,5,228,95,260,128,262,264,111,72]),function(X,e,n,R,P,O,C,S,d,c,y,v,k,$,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_r=void 0;var p;(function(f){f[f.MaxRestarts=5]="MaxRestarts"})(p||(p={}));let u=class extends R.$Tc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(h,g,a,t){super(),this.M=h,this.N=g,this.O=a,this.P=t,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new n.$5d),this.onPtyHostExit=this.u.event,this.w=this.B(new n.$5d),this.onPtyHostStart=this.w.event,this.y=this.B(new n.$5d),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new n.$5d),this.onPtyHostResponsive=this.z.event,this.C=this.B(new n.$5d),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new n.$5d),this.onProcessData=this.D.event,this.F=this.B(new n.$5d),this.onProcessReady=this.F.event,this.G=this.B(new n.$5d),this.onProcessReplay=this.G.event,this.H=this.B(new n.$5d),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new n.$5d),this.onDidRequestDetach=this.I.event,this.J=this.B(new n.$5d),this.onDidChangeProperty=this.J.event,this.L=this.B(new n.$5d),this.onProcessExit=this.L.event,(0,k.$Yr)(),this.B(this.M),this.B((0,R.$Rc)(()=>this.W())),this.j=this.B(new y.$Rr(void 0,this.O)),this.j.onCreateRequest(this.C.fire,this.C),this.M.onRequestConnection&&n.Event.once(this.M.onRequestConnection)(()=>this.h()),this.M.onWillShutdown?.(()=>this.m=!0)}get Q(){return this.N.getValue("terminal.integrated.ignoreProcessNames")}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(P.$i)return process.env;try{return await(0,c.$jm)(this.N,this.O,{_:[]},process.env)}catch(h){return this.O.error("ptyHost was unable to resolve shell environment",h),{}}}U(){const h=this.M.start(),g=h.client;this.O.getLevel()===S.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),O.ProxyChannel.toService(g.getChannel(v.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(h.onDidProcessExit(o=>{this.u.fire(o.code),!this.m&&!this.q.isDisposed&&(this.n<=p.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${o.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${o.code}, giving up`))}));const t=O.ProxyChannel.toService(g.getChannel(v.TerminalIpcChannels.PtyHost));return this.B(t.onProcessData(o=>this.D.fire(o))),this.B(t.onProcessReady(o=>this.F.fire(o))),this.B(t.onProcessExit(o=>this.L.fire(o))),this.B(t.onDidChangeProperty(o=>this.J.fire(o))),this.B(t.onProcessReplay(o=>this.G.fire(o))),this.B(t.onProcessOrphanQuestion(o=>this.H.fire(o))),this.B(t.onDidRequestDetach(o=>this.I.fire(o))),this.B(new d.$Qr(this.P,g.getChannel(v.TerminalIpcChannels.Logger))),this.a=h,this.b=t,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async o=>{o.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.R()})),this.R(),[h,t]}async createProcess(h,g,a,t,o,r,i,s,l,b,D){const j=setTimeout(()=>this.$(),v.HeartbeatConstants.CreateProcessTimeout),E=await this.f.createProcess(h,g,a,t,o,r,i,s,l,b,D);return clearTimeout(j),E}updateTitle(h,g,a){return this.f.updateTitle(h,g,a)}updateIcon(h,g,a,t){return this.f.updateIcon(h,g,a,t)}attachToProcess(h){return this.f.attachToProcess(h)}detachFromProcess(h,g){return this.f.detachFromProcess(h,g)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(h){return this.f.start(h)}shutdown(h,g){return this.f.shutdown(h,g)}input(h,g){return this.f.input(h,g)}processBinary(h,g){return this.f.processBinary(h,g)}resize(h,g,a){return this.f.resize(h,g,a)}clearBuffer(h){return this.f.clearBuffer(h)}acknowledgeDataEvent(h,g){return this.f.acknowledgeDataEvent(h,g)}setUnicodeVersion(h,g){return this.f.setUnicodeVersion(h,g)}getInitialCwd(h){return this.f.getInitialCwd(h)}getCwd(h){return this.f.getCwd(h)}async getLatency(){const h=new w.$1d,g=await this.f.getLatency();return h.stop(),[{label:"ptyhostservice<->ptyhost",latency:h.elapsed()},...g]}orphanQuestionReply(h){return this.f.orphanQuestionReply(h)}installAutoReply(h,g){return this.f.installAutoReply(h,g)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(h){return this.f.uninstallAutoReply(h)}getDefaultSystemShell(h){return this.g?.getDefaultSystemShell(h)??(0,m.$6l)(h??P.OS,process.env)}async getProfiles(h,g,a,t=!1){const o=await this.S();return(0,$.$$r)(g,a,t,this.N,o,void 0,this.O,this.bb.bind(this,h))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(h,g){return this.f.getWslPath(h,g)}getRevivedPtyNewId(h,g){return this.f.getRevivedPtyNewId(h,g)}setTerminalLayoutInfo(h){return this.f.setTerminalLayoutInfo(h)}async getTerminalLayoutInfo(h){return this.g?.getTerminalLayoutInfo(h)}async requestDetachInstance(h,g){return this.f.requestDetachInstance(h,g)}async acceptDetachInstanceReply(h,g){return this.f.acceptDetachInstanceReply(h,g)}async freePortKillProcess(h){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(h)}async serializeTerminalState(h){return this.f.serializeTerminalState(h)}async reviveTerminalProcesses(h,g,a){return this.f.reviveTerminalProcesses(h,g,a)}async refreshProperty(h,g){return this.f.refreshProperty(h,g)}async updateProperty(h,g,a){return this.f.updateProperty(h,g,a)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(h){this.ab(),this.s=setTimeout(()=>this.Y(),h?v.HeartbeatConstants.ConnectingBeatInterval:v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier+v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${v.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(h,g){return this.j.createRequest({workspaceId:h,originalText:g})}async acceptPtyHostResolvedVariables(h,g){this.j.acceptReply(h,g)}};e.$_r=u,e.$_r=u=ve([se(1,C.$Li),se(2,S.$zj),se(3,S.$Aj)],u)}),define(ae[69],ce([0,1,14,3,2,4,18,6,34]),function(X,e,n,R,P,O,C,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O$b=e.$N$b=void 0;const c="#FFFFFF",y="#1E1E1E",v="#000000",k="#FFFFFF",$="theme",m="themeBackground",w="windowSplash";e.$N$b=(0,S.$fi)("themeMainService");let p=class extends P.$Tc{constructor(f,h){super(),this.b=f,this.c=h,this.a=this.B(new R.$5d),this.onDidChangeColorScheme=this.a.event,this.B(this.c.onDidChangeConfiguration(g=>{g.affectsConfiguration("window.systemColorTheme")&&this.f()})),this.f(),this.B(R.Event.fromNodeEventEmitter(n.nativeTheme,"updated")(()=>this.a.fire(this.getColorScheme())))}f(){switch(this.c.getValue("window.systemColorTheme")){case"dark":n.nativeTheme.themeSource="dark";break;case"light":n.nativeTheme.themeSource="light";break;case"auto":switch(this.g()){case"vs":n.nativeTheme.themeSource="light";break;case"vs-dark":n.nativeTheme.themeSource="dark";break;default:n.nativeTheme.themeSource="system"}break;default:n.nativeTheme.themeSource="system";break}}getColorScheme(){if(O.$i){if(n.nativeTheme.shouldUseHighContrastColors)return{dark:n.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(O.$j){if(n.nativeTheme.shouldUseInvertedColorScheme||n.nativeTheme.shouldUseHighContrastColors)return{dark:n.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(O.$k&&n.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:n.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const f=this.getColorScheme();if(f.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return f.dark?v:k;let h=this.b.getItem(m,null);if(!h)switch(this.g()){case"vs":h=c;break;case"hc-black":h=v;break;case"hc-light":h=k;break;default:h=y}return O.$j&&h.toUpperCase()===y&&(h="#171717"),h}g(){switch(this.b.getItem($,"vs-dark").split(" ")[0]){case"vs":return"vs";case"hc-black":return"hc-black";case"hc-light":return"hc-light";default:return"vs-dark"}}saveWindowSplash(f,h){this.b.setItems([{key:$,data:h.baseTheme},{key:m,data:h.colorInfo.background},{key:w,data:h}]),typeof f=="number"&&this.h(f,h),this.f()}h(f,h){for(const g of n.BrowserWindow.getAllWindows())if(g.id===f){g.setBackgroundColor(h.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(w)}};e.$O$b=p,e.$O$b=p=ve([se(0,d.$AP),se(1,C.$Li)],p)}),define(ae[129],ce([0,1,3,18,6,5]),function(X,e,n,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zv=e.$Yv=e.$Xv=e.$Wv=e.$Vv=e.$Uv=e.$Tv=e.$Sv=e.ProvidedOnAutoForward=e.$Rv=e.TunnelPrivacyId=e.TunnelProtocol=e.$Qv=e.$Pv=void 0,e.$Pv=(0,P.$fi)("tunnelService"),e.$Qv=(0,P.$fi)("sharedTunnelsService");var C;(function(p){p.Http="http",p.Https="https"})(C||(e.TunnelProtocol=C={}));var S;(function(p){p.ConstantPrivate="constantPrivate",p.Private="private",p.Public="public"})(S||(e.TunnelPrivacyId=S={}));function d(p){return!!p.forwardPort}e.$Rv=d;var c;(function(p){p[p.Notify=1]="Notify",p[p.OpenBrowser=2]="OpenBrowser",p[p.OpenPreview=3]="OpenPreview",p[p.Silent=4]="Silent",p[p.Ignore=5]="Ignore",p[p.OpenBrowserOnce=6]="OpenBrowserOnce"})(c||(e.ProvidedOnAutoForward=c={}));function y(p){if(p.scheme!=="http"&&p.scheme!=="https")return;const u=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(p.authority);if(u)return{address:u[1],port:+u[2]}}e.$Sv=y,e.$Tv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function v(p){return e.$Tv.indexOf(p)>=0}e.$Uv=v,e.$Vv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function k(p){return e.$Vv.indexOf(p)>=0}e.$Wv=k;function $(p,u,f,h){if(f===1)return!1;if(f===2&&k(u)){const g=/(\d+)\.(\d+)\.(\d+)/g.exec(h);if(g?.length===4&&parseInt(g[1])>=18)return!1}return p<1024}e.$Xv=$;class m{constructor(u,f,h){this.remoteAddress=u,this.localAddress=f,this.b=h,this.a=new n.$5d,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Yv=m;let w=class{constructor(u,f){this.k=u,this.l=f,this.a=new n.$5d,this.onTunnelOpened=this.a.event,this.b=new n.$5d,this.onTunnelClosed=this.b.event,this.c=new n.$5d,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const u=this.l.getValue("remote.localPortHost");return!u||u==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(u){return this.f=u,u?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(u){this.g=u.elevation,this.i=u.privacyOptions,this.h=u.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const u=[],f=Array.from(this.e.values());for(const h of f){const g=Array.from(h.values());for(const a of g){const t=await a.value;t&&typeof t!="string"&&u.push(t)}}return u}async dispose(){for(const u of this.e.values()){for(const{value:f}of u.values())await f.then(h=>typeof h!="string"?h?.dispose():void 0);u.clear()}this.e.clear()}setEnvironmentTunnel(u,f,h,g,a){this.q(u,f,Promise.resolve({tunnelRemoteHost:u,tunnelRemotePort:f,localAddress:h,privacy:g,protocol:a,dispose:()=>Promise.resolve()}))}async getExistingTunnel(u,f){(k(u)||v(u))&&(u=e.$Tv[0]);const h=this.s(u,f);if(h)return++h.refcount,h.value}openTunnel(u,f,h,g,a,t=!1,o,r){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${f}:${h} on local port ${a}.`);const i=this.f??u;if(!i)return;if(f||(f="localhost"),g||(g=this.m),this.f&&this.j.has(h)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const s=this.t(i,f,h,g,a,t,o,r);return s?s.then(l=>{if(l){if(typeof l=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(f,h),l}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(f,h);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const b=this.o(l);return(l.tunnelRemoteHost!==f||l.tunnelRemotePort!==h)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),o&&l.privacy!==o&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(b),b}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),s)}o(u){return{tunnelRemotePort:u.tunnelRemotePort,tunnelRemoteHost:u.tunnelRemoteHost,tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress,privacy:u.privacy,protocol:u.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${u.tunnelRemoteHost}:${u.tunnelRemotePort} `);const f=this.e.get(u.tunnelRemoteHost);if(f){const h=f.get(u.tunnelRemotePort);h&&(h.refcount--,await this.p(u.tunnelRemoteHost,u.tunnelRemotePort,h))}}}}async p(u,f,h){if(h.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${u}:${f}.`);const g=h.value.then(async a=>{a&&typeof a!="string"&&(await a.dispose(!0),this.b.fire({host:a.tunnelRemoteHost,port:a.tunnelRemotePort}))});return this.e.has(u)&&this.e.get(u).delete(f),g}}async closeTunnel(u,f){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${u}:${f} `);const h=this.e.get(u);if(h&&h.has(f)){const g=h.get(f);g.refcount=0,await this.p(u,f,g)}}q(u,f,h){this.e.has(u)||this.e.set(u,new Map),this.e.get(u).set(f,{refcount:1,value:h})}async r(u,f){const h=this.e.get(u);if(h){const g=h.get(f),a=g?await g.value:void 0;(!a||typeof a=="string")&&h.delete(f),h.size===0&&this.e.delete(u)}}s(u,f){const h=[u];v(u)?(h.push(...e.$Tv),h.push(...e.$Vv)):k(u)&&h.push(...e.$Vv);const g=h.map(a=>this.e.get(a));for(const a of g){const t=a?.get(f);if(t)return t}}canTunnel(u){return!!y(u)}u(u,f,h,g,a,t,o){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${f}:${h} on local port ${g}.`);const r=h;this.j.add(r);const i=g===void 0?h:g,s={elevationRequired:a?this.isPortPrivileged(i):!1},l={remoteAddress:{host:f,port:h},localAddressPort:g,privacy:t,public:t?t!==S.Private:void 0,protocol:o},b=u.forwardPort(l,s);return b?(this.q(f,h,b),b.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(r)})):this.j.delete(r),b}};e.$Zv=w,e.$Zv=w=ve([se(0,O.$zj),se(1,R.$Li)],w)}),define(ae[49],ce([0,1,6]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JW=e.$IW=e.DisablementReason=e.UpdateType=e.StateType=void 0;var R;(function(C){C.Uninitialized="uninitialized",C.Idle="idle",C.Disabled="disabled",C.CheckingForUpdates="checking for updates",C.AvailableForDownload="available for download",C.Downloading="downloading",C.Downloaded="downloaded",C.Updating="updating",C.Ready="ready"})(R||(e.StateType=R={}));var P;(function(C){C[C.Setup=0]="Setup",C[C.Archive=1]="Archive",C[C.Snap=2]="Snap"})(P||(e.UpdateType=P={}));var O;(function(C){C[C.NotBuilt=0]="NotBuilt",C[C.DisabledByEnvironment=1]="DisabledByEnvironment",C[C.ManuallyDisabled=2]="ManuallyDisabled",C[C.MissingConfiguration=3]="MissingConfiguration",C[C.InvalidConfiguration=4]="InvalidConfiguration",C[C.RunningAsAdmin=5]="RunningAsAdmin"})(O||(e.DisablementReason=O={})),e.$IW={Uninitialized:{type:"uninitialized"},Disabled:C=>({type:"disabled",reason:C}),Idle:(C,S)=>({type:"idle",updateType:C,error:S}),CheckingForUpdates:C=>({type:"checking for updates",explicit:C}),AvailableForDownload:C=>({type:"available for download",update:C}),Downloading:C=>({type:"downloading",update:C}),Downloaded:C=>({type:"downloaded",update:C}),Updating:C=>({type:"updating",update:C}),Ready:C=>({type:"ready",update:C})},e.$JW=(0,n.$fi)("updateService")}),define(ae[266],ce([0,1,4,190,52,44]),function(X,e,n,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),O.$Wn.as(P.$2n.Configuration).registerConfiguration({id:"update",order:15,title:(0,R.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,R.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,R.localize)(2,null),(0,R.localize)(3,null),(0,R.localize)(4,null),(0,R.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,R.localize)(6,null),deprecationMessage:(0,R.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,R.localize)(8,null),description:(0,R.localize)(9,null),included:n.$i&&!n.$o},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,R.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(ae[267],ce([0,1,3,49]),function(X,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1_b=e.$Z_b=void 0;class P{constructor(S){this.a=S}listen(S,d){switch(d){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${d}`)}call(S,d,c){switch(d){case"checkForUpdates":return this.a.checkForUpdates(c);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(c)}throw new Error(`Call not found: ${d}`)}}e.$Z_b=P;class O{get state(){return this.b}set state(S){this.b=S,this.a.fire(S)}constructor(S){this.c=S,this.a=new n.$5d,this.onStateChange=this.a.event,this.b=R.$IW.Uninitialized,this.c.listen("onStateChange")(d=>this.state=d),this.c.call("_getInitialState").then(d=>this.state=d)}checkForUpdates(S){return this.c.call("checkForUpdates",S)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(S){return this.c.call("_applySpecificUpdate",S)}}e.$1_b=O}),define(ae[40],ce([0,1,6]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dl=void 0,e.$dl=(0,n.$fi)("IUriIdentityService")}),define(ae[268],ce([0,1,40,209,16,19,142,3,2]),function(X,e,n,R,P,O,C,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ds=void 0;class c{static{this._clock=0}constructor(k){this.uri=k,this.time=c._clock++}touch(){return this.time=c._clock++,this}}let y=class{constructor(k){this.g=k,this.c=new d.$Sc,this.f=2**16;const $=new Map,m=w=>{let p=$.get(w.scheme);return p===void 0&&(p=k.hasProvider(w)&&!this.g.hasCapability(w,1024),$.set(w.scheme,p)),p};this.c.add(S.Event.any(k.onDidChangeFileSystemProviderRegistrations,k.onDidChangeFileSystemProviderCapabilities)(w=>{$.delete(w.scheme)})),this.extUri=new O.$Hg(m),this.d=new C.$cs((w,p)=>this.extUri.compare(w,p,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(k){this.g.hasProvider(k)&&(k=(0,O.$Tg)(k));const $=this.d.get(k);return $?$.touch().uri.with({fragment:k.fragment}):(this.d.set(k,new c(k)),this.h(),k)}h(){if(this.d.size<this.f)return;const k=[...this.d.entries()].sort((m,w)=>m[1].time<w[1].time?1:m[1].time>w[1].time?-1:0);c._clock=0,this.d.clear();const $=this.f*.5;for(let m=0;m<$;m++)this.d.set(k[m][0],k[m][1].touch())}};e.$ds=y,e.$ds=y=ve([se(0,P.$Fk)],y),(0,R.$as)(n.$dl,y,1)}),define(ae[130],ce([0,1,6]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zW=void 0,e.$zW=(0,n.$fi)("urlService")}),define(ae[269],ce([0,1,7]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0_b=e.$9_b=e.$8_b=void 0;class R{constructor(S){this.a=S}listen(S,d){throw new Error(`Event not found: ${d}`)}call(S,d,c){switch(d){case"handleURL":return this.a.handleURL(n.URI.revive(c[0]),c[1])}throw new Error(`Call not found: ${d}`)}}e.$8_b=R;class P{constructor(S){this.a=S}handleURL(S,d){return this.a.call("handleURL",[S.toJSON(),d])}}e.$9_b=P;class O{constructor(S,d){this.a=S,this.b=d}async routeCall(S,d,c,y){if(d!=="handleURL")throw new Error(`Call not found: ${d}`);if(Array.isArray(c)&&c.length>0){const v=n.URI.revive(c[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",v.toString(!0)),v.query){const k=/\bwindowId=(\d+)/.exec(v.query);if(k){const $=k[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${$}"`,v.toString(!0));const m=new RegExp(`window:${$}`),w=S.connections.find(p=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",p.ctx),m.test(p.ctx)));if(w)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",v.toString(!0)),w;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",v.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",v.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(S,d,c,y)}routeEvent(S,d){throw new Error(`Event not found: ${d}`)}}e.$0_b=O}),define(ae[270],ce([0,1,8,2,7,27]),function(X,e,n,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BW=e.$AW=void 0;class C extends R.$Tc{constructor(){super(...arguments),this.a=new Set}open(c,y){const v=[...this.a.values()];return(0,n.$jh)(v.map(k=>()=>k.handleURL(c,y)),void 0,!1).then(k=>k||!1)}registerHandler(c){return this.a.add(c),(0,R.$Rc)(()=>this.a.delete(c))}}e.$AW=C;let S=class extends C{constructor(c){super(),this.b=c}create(c){let{authority:y,path:v,query:k,fragment:$}=c||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return y&&v&&v.indexOf("/")!==0&&(v=`/${v}`),P.URI.from({scheme:this.b.urlProtocol,authority:y,path:v,query:k,fragment:$})}};e.$BW=S,e.$BW=S=ve([se(0,O.$Rj)],S)}),define(ae[271],ce([0,1,14,8,3,2,4,7]),function(X,e,n,R,P,O,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$_b=void 0;class d extends O.$Tc{constructor(y,v,k,$,m,w){if(super(),this.c=v,this.f=w,this.a=[],this.b=0,y&&(w.trace("ElectronURLListener initialUrisToHandle:",y.map(f=>f.originalUrl)),this.a=y),C.$i){const f=$.isBuilt?[]:[`"${$.appRoot}"`];f.push("--open-url","--"),n.app.setAsDefaultProtocolClient(m.urlProtocol,process.execPath,f)}const p=P.Event.map(P.Event.fromNodeEventEmitter(n.app,"open-url",(f,h)=>({event:f,url:h})),({event:f,url:h})=>(f.preventDefault(),h));this.B(p(f=>{const h=this.g(f);h&&this.c.open(h,{originalUrl:f})})),k.getWindows().filter(f=>f.isReady).length>0?(w.trace("ElectronURLListener: window is ready to handle URLs"),this.h()):(w.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this.B(P.Event.once(k.onDidSignalReadyWindow)(()=>this.h())))}g(y){try{return S.URI.parse(y)}catch{return}}async h(){if(this.b++>10){this.f.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.f.trace("ElectronURLListener#flush(): flushing URLs");const y=[];for(const v of this.a)await this.c.open(v.uri,{originalUrl:v.originalUrl})?this.f.trace("ElectronURLListener#flush(): URL was handled",v.originalUrl):(this.f.trace("ElectronURLListener#flush(): URL was not yet handled",v.originalUrl),y.push(v));y.length!==0&&(this.a=y,(0,R.$hh)(()=>this.h(),500,this.q))}}e.$$_b=d}),define(ae[272],ce([0,1,3,2,16,59,31]),function(X,e,n,R,P,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lac=void 0;class S extends R.$Tc{constructor(c,y,v,k,$,m){super(),this.f=c,this.g=y,this.h=v,this.j=k,this.m=$,this.n=m,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new n.$5d),this.onDidChangeFile=this.a.event,this.b=O.$li.forUris(()=>!(this.capabilities&1024)),this.c=new C.$Bc(w=>this.m.extUri.getComparisonKey(this.t(w))),this.r(),this.B(k.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(w=>this.s(w)))}r(){this.c.clear();for(const c of this.j.profiles)this.c.add(c.settingsResource),this.c.add(c.keybindingsResource),this.c.add(c.tasksResource),this.c.add(c.extensionsResource)}open(c,y){return this.g.open(this.t(c),y)}close(c){return this.g.close(c)}read(c,y,v,k,$){return this.g.read(c,y,v,k,$)}write(c,y,v,k,$){return this.g.write(c,y,v,k,$)}watch(c,y){this.b.set(c,c);const v=this.g.watch(this.t(c),y);return(0,R.$Rc)(()=>{this.b.delete(c),v.dispose()})}stat(c){return this.g.stat(this.t(c))}mkdir(c){return this.g.mkdir(this.t(c))}rename(c,y,v){return this.g.rename(this.t(c),this.t(y),v)}readFile(c,y){return this.g.readFile(this.t(c),y)}readFileStream(c,y,v){return this.g.readFileStream(this.t(c),y,v)}readdir(c){return this.g.readdir(this.t(c))}enforceAtomicReadFile(c){return this.c.has(c)}writeFile(c,y,v){return this.g.writeFile(this.t(c),y,v)}enforceAtomicWriteFile(c){return this.c.has(c)?{postfix:".vsctmp"}:!1}delete(c,y){return this.g.delete(this.t(c),y)}copy(c,y,v){if((0,P.$Jk)(this.g))return this.g.copy(this.t(c),this.t(y),v);throw new Error("copy not supported")}cloneFile(c,y){if((0,P.$Kk)(this.g))return this.g.cloneFile(this.t(c),this.t(y));throw new Error("clone not supported")}s(c){const y=[];for(const v of c){if(v.resource.scheme!==this.f)continue;const k=this.u(v.resource);this.b.findSubstr(k)&&y.push({resource:k,type:v.type,cId:v.cId})}y.length&&(this.n.debug("User data changed"),this.a.fire(y))}t(c){return c.with({scheme:this.f})}u(c){return c.with({scheme:this.h})}}e.$Lac=S}),define(ae[273],ce([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sac=void 0,e.$sac="utilityProcessWorker"}),define(ae[274],ce([0,1,6]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$__b=void 0,e.$__b=(0,n.$fi)("webviewManagerService")}),define(ae[275],ce([0,1,14,2,13,7]),function(X,e,n,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aac=void 0;class C extends R.$Tc{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const d=this.b.bind(this);n.protocol.registerFileProtocol(P.Schemas.vscodeWebview,d)}b(d,c){try{const y=O.URI.parse(d.url),v=C.a.get(y.path);if(typeof v=="string"){const k=`vs/workbench/contrib/webview/browser/pre/${v}`,$=P.$zg.asFileUri(k);return c({path:$.fsPath,headers:{...P.COI.getHeadersFromQuery(d.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return c({error:-10})}catch{}return c({error:-2})}}e.$aac=C}),define(ae[55],ce([0,1,4]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bD=e.$aD=e.$_C=e.$$C=e.$0C=e.$9C=e.CustomTitleBarVisibility=e.TitlebarStyle=e.TitleBarSetting=e.$8C=e.$7C=e.$6C=e.$5C=e.$4C=e.$3C=void 0,e.$3C={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function R(u){return typeof u.parentId=="number"}e.$4C=R;function P(u){return!!u.workspaceUri}e.$5C=P;function O(u){return!!u.folderUri}e.$6C=O;function C(u){return!!u.fileUri}e.$7C=C;function S(u){const f=k(u),h=u.getValue("window.menuBarVisibility");return h==="default"||f&&h==="compact"||n.$j&&n.$m?"classic":h}e.$8C=S;var d;(function(u){u.TITLE_BAR_STYLE="window.titleBarStyle",u.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(d||(e.TitleBarSetting=d={}));var c;(function(u){u.NATIVE="native",u.CUSTOM="custom"})(c||(e.TitlebarStyle=c={}));var y;(function(u){u.AUTO="auto",u.WINDOWED="windowed",u.NEVER="never"})(y||(e.CustomTitleBarVisibility=y={}));function v(u,f){return!0}e.$9C=v;function k(u,f){return f||(f=$(u)),f==="native"}e.$0C=k;function $(u){if(n.$o)return"custom";const f=u.getValue("window");if(f){if(n.$j&&f.nativeTabs===!0||n.$j&&f.nativeFullScreen===!1)return"native";const a=f.titleBarStyle;if(a==="native"||a==="custom")return a}return n.$k?"native":"custom"}e.$$C=$;function m(u){return!(!n.$i||n.$o||k(u))}e.$_C=m;function w(u){const f=u.getValue("window");return!f||typeof f.nativeFullScreen!="boolean"||f.nativeTabs?!0:f.nativeFullScreen!==!1}e.$aD=w;function p(u=0){return Math.pow(1.2,u)}e.$bD=p}),define(ae[81],ce([0,1,14]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$D$b=e.$C$b=e.UnloadReason=e.LoadReason=void 0;var R;(function(c){c[c.INITIAL=1]="INITIAL",c[c.LOAD=2]="LOAD",c[c.RELOAD=3]="RELOAD"})(R||(e.LoadReason=R={}));var P;(function(c){c[c.CLOSE=1]="CLOSE",c[c.QUIT=2]="QUIT",c[c.RELOAD=3]="RELOAD",c[c.LOAD=4]="LOAD"})(P||(e.UnloadReason=P={}));const O=function(c=1){return{width:1024,height:768,mode:c}};e.$C$b=O;const C=function(){const v=n.screen.getPrimaryDisplay().workArea,k=Math.max(v.x+v.width/2-800/2,0),$=Math.max(v.y+v.height/2-600/2,0);return{x:k,y:$,width:800,height:600,mode:1}};e.$D$b=C;var S;(function(c){c[c.Maximized=0]="Maximized",c[c.Normal=1]="Normal",c[c.Minimized=2]="Minimized",c[c.Fullscreen=3]="Fullscreen"})(S||(e.WindowMode=S={}));var d;(function(c){c[c.UNRESPONSIVE=1]="UNRESPONSIVE",c[c.PROCESS_GONE=2]="PROCESS_GONE",c[c.LOAD=3]="LOAD"})(d||(e.WindowError=d={}))}),define(ae[276],ce([0,1,8,3,2]),function(X,e,n,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gac=void 0;class O extends P.$Tc{constructor({onDidOpenMainWindow:S,onDidFocusMainWindow:d,getActiveWindowId:c}){super(),this.a=this.B(new P.$Sc),R.Event.latch(R.Event.any(S,d))(this.f,this,this.a),this.b=(0,n.$5g)(()=>c()),(async()=>{try{const v=await this.b;this.c=typeof this.c=="number"?this.c:v}catch{}finally{this.b=void 0}})()}f(S){this.b&&(this.b.cancel(),this.b=void 0),this.c=S}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$gac=O}),define(ae[30],ce([0,1,194,9,59,19,7,6,13]),function(X,e,n,R,P,O,C,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.WorkbenchState=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=void 0,e.$oi=(0,S.$fi)("contextService");function c(i){const s=i;return typeof s?.id=="string"&&C.URI.isUri(s.uri)}e.$pi=c;function y(i){return typeof i?.id=="string"&&!c(i)&&!k(i)}e.$qi=y,e.$ri={id:"ext-dev"},e.$si={id:"empty-window"};function v(i,s){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,R.$nc)(i)}:s?e.$ri:e.$si;const l=i;return l.configuration?{id:l.id,configPath:l.configuration}:l.folders.length===1?{id:l.id,uri:l.folders[0].uri}:{id:l.id}}e.$ti=v;function k(i){const s=i;return typeof s?.id=="string"&&C.URI.isUri(s.configPath)}e.$ui=k;function $(i){const s=i;if(s?.uri)return{id:s.id,uri:C.URI.revive(s.uri)};const l=i;if(l?.configPath)return{id:l.id,configPath:C.URI.revive(l.configPath)};if(i?.id)return{id:i.id}}e.$vi=$;var m;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(m||(e.WorkbenchState=m={}));function w(i){const s=i;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}e.$wi=w;function p(i){const s=i;return!!(s&&typeof s=="object"&&C.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}e.$xi=p;class u{constructor(s,l,b,D,j){this.h=s,this.j=b,this.k=D,this.l=j,this.c=P.$li.forUris(this.l,()=>!0),this.folders=l}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=P.$li.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$yi=u;class f{constructor(s,l){this.raw=l,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,O.$Sg)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$zi=f;function h(i){return new f({uri:i,index:0,name:(0,O.$Og)(i)},{uri:i.toString()})}e.$Ai=h,e.$Bi="code-workspace",e.$Ci=`.${e.$Bi}`,e.$Di=[{name:(0,n.localize)(0,null),extensions:[e.$Bi]}],e.$Ei="workspace.json";function g(i,s){return O.$Jg.isEqualOrParent(i,s.untitledWorkspacesHome)}e.$Fi=g;function a(i){let s;return C.URI.isUri(i)?s=i:s=i.configuration,s?.scheme===d.Schemas.tmp}e.$Gi=a,e.$Hi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.$Hi}e.$Ii=t;function o(i,s){return!g(i,s)&&!a(i)}e.$Ji=o;function r(i){return(typeof i=="string"?(0,R.$oc)(i):(0,O.$Qg)(i))===e.$Ci}e.$Ki=r}),define(ae[56],ce([0,1,14,8,45,47,2,86,4,21,169,118,6,5,27,30]),function(X,e,n,R,P,O,C,S,d,c,y,v,k,$,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L$b=e.$K$b=void 0,e.$K$b=(0,k.$fi)("dialogMainService");let p=class{constructor(f,h){this.d=f,this.e=h,this.a=new Map,this.b=new Map,this.c=new R.$mh}pickFileFolder(f,h){return this.f({...f,pickFolders:!0,pickFiles:!0,title:(0,y.localize)(0,null)},h)}pickFolder(f,h){return this.f({...f,pickFolders:!0,title:(0,y.localize)(1,null)},h)}pickFile(f,h){return this.f({...f,pickFiles:!0,title:(0,y.localize)(2,null)},h)}pickWorkspace(f,h){const g=(0,y.localize)(3,null),a=(0,O.$fw)((0,y.localize)(4,null)),t=w.$Di;return this.f({...f,pickFiles:!0,title:g,filters:t,buttonLabel:a},h)}async f(f,h){const g={title:f.title,buttonLabel:f.buttonLabel,filters:f.filters,defaultPath:f.defaultPath};(typeof f.pickFiles=="boolean"||typeof f.pickFolders=="boolean")&&(g.properties=void 0,f.pickFiles&&f.pickFolders&&(g.properties=["multiSelections","openDirectory","openFile","createDirectory"])),g.properties||(g.properties=["multiSelections",f.pickFolders?"openDirectory":"openFile","createDirectory"]),d.$j&&g.properties.push("treatPackageAsDirectory");const a=await this.showOpenDialog(g,(h||n.BrowserWindow.getFocusedWindow())??void 0);if(a&&a.filePaths&&a.filePaths.length>0)return a.filePaths}g(f){if(f){let h=this.b.get(f.id);return h||(h=new R.$mh,this.b.set(f.id,h)),h}else return this.c}showMessageBox(f,h){return this.g(h).queue(async()=>{const{options:g,buttonIndeces:a}=(0,v.$mw)(f,this.e);let t;return h?t=await n.dialog.showMessageBox(h,g):t=await n.dialog.showMessageBox(g),{response:a[t.response],checkboxChecked:t.checkboxChecked}})}async showSaveDialog(f,h){const g=this.j(f,h);if(!g)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.g(h).queue(async()=>{let a;return h?a=await n.dialog.showSaveDialog(h,f):a=await n.dialog.showSaveDialog(f),a.filePath=this.h(a.filePath),a})}finally{(0,C.$Oc)(g)}}h(f){return f&&d.$j&&(f=(0,S.$Ql)(f)),f}i(f){return f.map(h=>this.h(h))}async showOpenDialog(f,h){f.defaultPath&&(await c.Promises.exists(f.defaultPath)||(f.defaultPath=void 0));const g=this.j(f,h);if(!g)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(h).queue(async()=>{let a;return h?a=await n.dialog.showOpenDialog(h,f):a=await n.dialog.showOpenDialog(f),a.filePaths=this.i(a.filePaths),a})}finally{(0,C.$Oc)(g)}}j(f,h){if(!h)return C.$Tc.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",f);let g=this.a.get(h.id);g||(g=new Set,this.a.set(h.id,g));const a=(0,P.$6i)(f);if(!g.has(a))return this.d.trace("[DialogMainService]: new file dialog lock created",f),g.add(a),(0,C.$Rc)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",f),g?.delete(a),g?.size===0&&this.a.delete(h.id)})}};e.$L$b=p,e.$L$b=p=ve([se(0,$.$zj),se(1,m.$Rj)],p)}),define(ae[277],ce([0,1,3,2,76,30]),function(X,e,n,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W_b=void 0;class C extends R.$Tc{static{this.a=100}constructor(d,c){super(),this.f=d,this.g=c,this.b=this.B(new n.$5d),this.c=new Map,this.h(c.applicationStorage,this.b)}h(d,c){this.B(n.Event.debounce(d.onDidChangeStorage,(y,v)=>(y?y.push(v):y=[v],y),C.a)(y=>{y.length&&c.fire(this.j(y,d))}))}j(d,c){const y=new Map,v=new Set;return d.forEach(k=>{const $=c.get(k.key);typeof $=="string"?y.set(k.key,$):v.add(k.key)}),{changed:Array.from(y.entries()),deleted:Array.from(v.values())}}listen(d,c,y){switch(c){case"onDidChangeStorage":{const v=y.profile?(0,P.$Oh)(y.profile):void 0;if(!v)return this.b.event;let k=this.c.get(v.id);return k||(k=this.B(new n.$5d),this.h(this.g.profileStorage(v),k),this.c.set(v.id,k)),k.event}}throw new Error(`Event not found: ${c}`)}async call(d,c,y){const v=y.profile?(0,P.$Oh)(y.profile):void 0,k=(0,O.$vi)(y.workspace),$=await this.m(v,k);switch(c){case"getItems":return Array.from($.items.entries());case"updateItems":{const m=y;if(m.insert)for(const[w,p]of m.insert)$.set(w,p);m.delete?.forEach(w=>$.delete(w));break}case"optimize":return $.optimize();case"isUsed":{const m=y.payload;if(typeof m=="string")return this.g.isUsed(m)}default:throw new Error(`Call not found: ${c}`)}}async m(d,c){let y;c?y=this.g.workspaceStorage(c):d?y=this.g.profileStorage(d):y=this.g.applicationStorage;try{await y.init()}catch(v){this.f.error(`StorageIPC#init: Unable to init ${c?"workspace":d?"profile":"application"} storage due to ${v}`)}return y}}e.$W_b=C}),define(ae[41],ce([0,1,45,3,2,19,7,191,38,16,6,5,30,31,40,8,32,25,12]),function(X,e,n,R,P,O,C,S,d,c,y,v,k,$,m,w,p,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jl=e.$il=e.$hl=e.$gl=e.$fl=e.$el=e.ProfileResourceType=void 0;var h;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(h||(e.ProfileResourceType=h={}));function g(i){const s=i;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&C.URI.isUri(s.location)&&C.URI.isUri(s.globalStorageHome)&&C.URI.isUri(s.settingsResource)&&C.URI.isUri(s.keybindingsResource)&&C.URI.isUri(s.tasksResource)&&C.URI.isUri(s.snippetsHome)&&C.URI.isUri(s.extensionsResource))}e.$el=g,e.$fl=(0,y.$fi)("IUserDataProfilesService");function a(i,s){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:C.URI.revive(i.location).with({scheme:s}),globalStorageHome:C.URI.revive(i.globalStorageHome).with({scheme:s}),settingsResource:C.URI.revive(i.settingsResource).with({scheme:s}),keybindingsResource:C.URI.revive(i.keybindingsResource).with({scheme:s}),tasksResource:C.URI.revive(i.tasksResource).with({scheme:s}),snippetsHome:C.URI.revive(i.snippetsHome).with({scheme:s}),extensionsResource:C.URI.revive(i.extensionsResource).with({scheme:s}),cacheHome:C.URI.revive(i.cacheHome).with({scheme:s}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$gl=a;function t(i,s,l,b,D,j){return{id:i,name:s,location:l,isDefault:!1,shortName:D?.shortName,icon:D?.icon,globalStorageHome:j&&D?.useDefaultFlags?.globalState?j.globalStorageHome:(0,O.$Sg)(l,"globalStorage"),settingsResource:j&&D?.useDefaultFlags?.settings?j.settingsResource:(0,O.$Sg)(l,"settings.json"),keybindingsResource:j&&D?.useDefaultFlags?.keybindings?j.keybindingsResource:(0,O.$Sg)(l,"keybindings.json"),tasksResource:j&&D?.useDefaultFlags?.tasks?j.tasksResource:(0,O.$Sg)(l,"tasks.json"),snippetsHome:j&&D?.useDefaultFlags?.snippets?j.snippetsHome:(0,O.$Sg)(l,"snippets"),extensionsResource:j&&D?.useDefaultFlags?.extensions?j.extensionsResource:(0,O.$Sg)(l,"extensions.json"),cacheHome:(0,O.$Sg)(b,i),useDefaultFlags:D?.useDefaultFlags,isTransient:D?.transient}}e.$hl=t;let o=class extends P.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(s,l,b,D){super(),this.t=s,this.u=l,this.w=b,this.y=D,this.f=!0,this.h=this.B(new R.$5d),this.onDidChangeProfiles=this.h.event,this.j=this.B(new R.$5d),this.onWillCreateProfile=this.j.event,this.m=this.B(new R.$5d),this.onWillRemoveProfile=this.m.event,this.n=this.B(new R.$5d),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new $.$Ac,emptyWindows:new Map},this.profilesHome=(0,O.$Sg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,O.$Sg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(s){this.f!==s&&(this.z=void 0,this.f=s)}isEnabled(){return this.f}get C(){if(!this.z){const s=this.D(),l=[s];if(this.f)try{for(const j of this.O()){if(!j.name||!(0,f.$Sf)(j.name)||!j.location){this.y.warn("Skipping the invalid stored profile",j.location||j.name);continue}l.push(t((0,O.$Pg)(j.location),j.name,j.location,this.g,{shortName:j.shortName,icon:j.icon,useDefaultFlags:j.useDefaultFlags},s))}}catch(j){this.y.error(j)}const b=new $.$Ac,D=new Map;if(l.length)try{const j=this.Q();if(j.workspaces)for(const[E,I]of Object.entries(j.workspaces)){const M=C.URI.parse(E),T=l.find(W=>W.id===I);T&&b.set(M,T)}if(j.emptyWindows)for(const[E,I]of Object.entries(j.emptyWindows)){const M=l.find(T=>T.id===I);M&&D.set(E,M)}}catch(j){this.y.error(j)}this.z={profiles:l,workspaces:b,emptyWindows:D}}return this.z}D(){const s=t("__default__profile__",(0,S.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...s,extensionsResource:this.S()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const l="Temp",b=new RegExp(`${(0,u.$Xe)(l)}\\s(\\d+)`);let D=0;for(const E of this.profiles){const I=b.exec(E.name),M=I?parseInt(I[1]):0;D=M>D?M:D}const j=`${l} ${D+1}`;return this.createProfile((0,n.$6i)((0,p.$Bg)()).toString(16),j,{transient:!0},s)}async createNamedProfile(s,l,b){return this.createProfile((0,n.$6i)((0,p.$Bg)()).toString(16),s,l,b)}async createProfile(s,l,b,D){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const j=await this.F(s,l,b);return D&&await this.setProfileForWorkspace(D,j),j}async F(s,l,b){if(!(0,f.$Sf)(l)||!l)throw new Error("Name of the profile is mandatory and must be of type `string`");let D=this.r.get(l);return D||(D=(async()=>{try{const j=this.profiles.find(M=>M.name===l||M.id===s);if(j)return j;const E=t(s,l,(0,O.$Sg)(this.profilesHome,s),this.g,b,this.defaultProfile);await this.u.createFolder(E.location);const I=[];return this.j.fire({profile:E,join(M){I.push(M)}}),await w.Promises.settled(I),this.I([E],[],[]),E}finally{this.r.delete(l)}})(),this.r.set(l,D)),D}async updateProfile(s,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let b=this.profiles.find(D=>D.id===s.id);if(!b)throw new Error(`Profile '${s.name}' does not exist`);return b=t(b.id,l.name??b.name,b.location,this.g,{shortName:l.shortName??b.shortName,icon:l.icon===null?void 0:l.icon??b.icon,transient:l.transient??b.isTransient,useDefaultFlags:l.useDefaultFlags??b.useDefaultFlags},this.defaultProfile),this.I([],[],[b]),b}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const l=this.profiles.find(D=>D.id===s.id);if(!l)throw new Error(`Profile '${s.name}' does not exist`);const b=[];this.m.fire({profile:l,join(D){b.push(D)}});try{await Promise.allSettled(b)}catch(D){this.y.error(D)}for(const D of[...this.C.emptyWindows.keys()])l.id===this.C.emptyWindows.get(D)?.id&&this.C.emptyWindows.delete(D);for(const D of[...this.C.workspaces.keys()])l.id===this.C.workspaces.get(D)?.id&&this.C.workspaces.delete(D);this.M(),this.I([],[l],[]);try{await this.u.del(l.cacheHome,{recursive:!0})}catch(D){(0,c.$Wk)(D)!==1&&this.y.error(D)}}async setProfileForWorkspace(s,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const b=this.profiles.find(D=>D.id===l.id);if(!b)throw new Error(`Profile '${l.name}' does not exist`);this.L(s,b)}unsetWorkspace(s,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(s,void 0,l)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const s=await this.u.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(l=>l.isDirectory&&this.profiles.every(b=>!this.w.extUri.isEqual(b.location,l.resource))).map(l=>this.u.del(l.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.s.profiles.filter(l=>!this.H(l));await Promise.allSettled(s.map(l=>this.removeProfile(l)))}getProfileForWorkspace(s){const l=this.G(s);return C.URI.isUri(l)?this.s.workspaces.get(l)??this.C.workspaces.get(l):this.s.emptyWindows.get(l)??this.C.emptyWindows.get(l)}G(s){return(0,k.$pi)(s)?s.uri:(0,k.$ui)(s)?s.configPath:s.id}H(s){return!!([...this.s.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,s.location))||[...this.s.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,s.location))||[...this.C.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,s.location))||[...this.C.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,s.location)))}I(s,l,b){const D=[...this.profiles,...s],j=[];this.s.profiles=[];for(let E of D)E.isDefault||l.some(I=>E.id===I.id)||(E=b.find(I=>E.id===I.id)??E,E.isTransient?this.s.profiles.push(E):j.push({location:E.location,name:E.name,shortName:E.shortName,icon:E.icon,useDefaultFlags:E.useDefaultFlags}));this.P(j),this.z=void 0,this.J(s,l,b)}J(s,l,b){this.h.fire({added:s,removed:l,updated:b,all:this.profiles})}L(s,l,b){b=l?.isTransient?!0:b,b||this.L(s,void 0,!0);const D=this.G(s),j=b?this.s:this.C;C.URI.isUri(D)?(j.workspaces.delete(D),l&&j.workspaces.set(D,l)):(j.emptyWindows.delete(D),l&&j.emptyWindows.set(D,l)),b||this.M()}M(){const s={};for(const[b,D]of this.C.workspaces.entries())s[b.toString()]=D.id;const l={};for(const[b,D]of this.C.emptyWindows.entries())l[b.toString()]=D.id;this.R({workspaces:s,emptyWindows:l}),this.z=void 0}N(s){const l={},b=this.D();if(s.workspaces)for(const[j,E]of Object.entries(s.workspaces)){const I=C.URI.parse(E);l[j]=this.w.extUri.isEqual(I,b.location)?b.id:this.w.extUri.basename(I)}const D={};if(s.emptyWindows)for(const[j,E]of Object.entries(s.emptyWindows)){const I=C.URI.parse(E);D[j]=this.w.extUri.isEqual(I,b.location)?b.id:this.w.extUri.basename(I)}return{workspaces:l,emptyWindows:D}}O(){return[]}P(s){throw new Error("not implemented")}Q(){return{}}R(s){throw new Error("not implemented")}S(){}};e.$il=o,e.$il=o=ve([se(0,d.$mi),se(1,c.$Fk),se(2,m.$dl),se(3,v.$zj)],o);class r extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(s){this.a=s}Q(){return this.X}R(s){this.X=s}}e.$jl=r}),define(ae[82],ce([0,1,8,17,2,3,31,7,120,126,16,6,5,41,40,12,15,28]),function(X,e,n,R,P,O,C,S,d,c,y,v,k,$,m,w,p,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=e.$0p=e.$9p=e.ExtensionsProfileScanningErrorCode=void 0;var f;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(f||(e.ExtensionsProfileScanningErrorCode=f={}));class h extends Error{constructor(r,i){super(r),this.code=i}}e.$9p=h,e.$0p=(0,v.$fi)("IExtensionsProfileScannerService");let g=class extends P.$Tc{constructor(r,i,s,l,b,D){super(),this.j=r,this.m=i,this.n=s,this.r=l,this.s=b,this.t=D,this.b=this.B(new O.$5d),this.onAddExtensions=this.b.event,this.c=this.B(new O.$5d),this.onDidAddExtensions=this.c.event,this.f=this.B(new O.$5d),this.onRemoveExtensions=this.f.event,this.g=this.B(new O.$5d),this.onDidRemoveExtensions=this.g.event,this.h=new C.$Ac}scanProfileExtensions(r,i){return this.u(r,void 0,i)}async addExtensionsToProfile(r,i){const s=[],l=[];try{return await this.u(i,b=>{const D=[];for(const j of b)r.some(([E])=>(0,c.$cp)(E.identifier,j.identifier)&&E.manifest.version!==j.version)?s.push(j):D.push(j);for(const[j,E]of r){const I=D.findIndex(T=>(0,c.$cp)(T.identifier,j.identifier)&&T.version===j.manifest.version),M={identifier:j.identifier,version:j.manifest.version,location:j.location,metadata:E};I===-1?(l.push(M),D.push(M)):D.splice(I,1,M)}return l.length&&this.b.fire({extensions:l,profileLocation:i}),s.length&&this.f.fire({extensions:s,profileLocation:i}),D}),l.length&&this.c.fire({extensions:l,profileLocation:i}),s.length&&this.g.fire({extensions:s,profileLocation:i}),l}catch(b){throw l.length&&this.c.fire({extensions:l,error:b,profileLocation:i}),s.length&&this.g.fire({extensions:s,error:b,profileLocation:i}),b}}async updateMetadata(r,i){const s=[];return await this.u(i,l=>{const b=[];for(const D of l){const j=r.find(([E])=>(0,c.$cp)(E.identifier,D.identifier)&&E.manifest.version===D.version);j&&(D.metadata={...D.metadata,...j[1]},s.push(D)),b.push(D)}return b}),s}async removeExtensionFromProfile(r,i){const s=[];try{await this.u(i,l=>{const b=[];for(const D of l)(0,c.$cp)(D.identifier,r.identifier)?s.push(D):b.push(D);return s.length&&this.f.fire({extensions:s,profileLocation:i}),b}),s.length&&this.g.fire({extensions:s,profileLocation:i})}catch(l){throw s.length&&this.g.fire({extensions:s,error:l,profileLocation:i}),l}}async u(r,i,s){return this.F(r).queue(async()=>{let l=[],b;try{const D=await this.m.readFile(r);b=JSON.parse(D.value.toString().trim()||"[]")}catch(D){if((0,y.$Wk)(D)!==1)throw D;if(this.r.extUri.isEqual(r,this.n.defaultProfile.extensionsResource)&&(b=await this.D()),!b&&s?.bailOutWhenFileNotFound)throw new h((0,p.$0)(D),"ERROR_PROFILE_NOT_FOUND")}if(b){Array.isArray(b)||this.w(r);let D=!1;for(const j of b){a(j)||this.w(r);let E;if((0,w.$Sf)(j.relativeLocation)&&j.relativeLocation)E=this.z(j.relativeLocation);else if((0,w.$Sf)(j.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${j.location}`);continue}else{E=S.URI.revive(j.location);const I=this.y(E);I&&(D=!0,j.relativeLocation=I)}(0,w.$Zf)(j.metadata?.hasPreReleaseVersion)&&j.metadata?.preRelease&&(D=!0,j.metadata.hasPreReleaseVersion=!0),l.push({identifier:j.identifier,location:E,version:j.version,metadata:j.metadata})}D&&await this.m.writeFile(r,R.$se.fromString(JSON.stringify(b)))}if(i){l=i(l);const D=l.map(j=>({identifier:j.identifier,version:j.version,location:j.location.toJSON(),relativeLocation:this.y(j.location),metadata:j.metadata}));await this.m.writeFile(r,R.$se.fromString(JSON.stringify(D)))}return l})}w(r){const i=new h(`Invalid extensions content in ${r.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(r){return this.r.extUri.isEqual(this.r.extUri.dirname(r),this.j)?this.r.extUri.basename(r):void 0}z(r){return this.r.extUri.joinPath(this.j,r)}async D(){return this.C||(this.C=(async()=>{const r=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let s;try{s=(await this.m.readFile(r)).value.toString()}catch(b){if((0,y.$Wk)(b)===1)return;throw b}this.t.info("Migrating extensions from old default profile location",r.toString());let l;try{const b=JSON.parse(s);Array.isArray(b)&&b.every(D=>a(D))?l=b:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",b)}catch(b){this.t.error(b)}if(l)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,R.$se.fromString(JSON.stringify(l)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",r.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(b){if((0,y.$Wk)(b)===3)this.t.info("Migration from old default profile location to new location is done by another window",r.toString(),this.n.defaultProfile.extensionsResource.toString());else throw b}try{await this.m.del(r)}catch(b){(0,y.$Wk)(b)!==1&&this.t.error(b)}try{await this.m.del(i)}catch(b){(0,y.$Wk)(b)!==1&&this.t.error(b)}return l})()),this.C}F(r){let i=this.h.get(r);return i||(i=new n.$mh,this.h.set(r,i)),i}};e.$$p=g,e.$$p=g=ve([se(1,y.$Fk),se(2,$.$fl),se(3,m.$dl),se(4,u.$El),se(5,k.$zj)],g);function a(o){return(0,w.$Uf)(o)&&(0,d.$Mo)(o.identifier)&&(t(o.location)||(0,w.$Sf)(o.location)&&o.location)&&((0,w.$Zf)(o.relativeLocation)||(0,w.$Sf)(o.relativeLocation))&&o.version&&(0,w.$Sf)(o.version)}function t(o){return o?(0,w.$Sf)(o.path)&&(0,w.$Sf)(o.scheme):!1}}),define(ae[131],ce([0,1,22,8,35,17,15,42,154,2,13,9,4,19,207,73,12,7,174,38,126,123,206,16,6,5,27,3,76,82,41,40,205]),function(X,e,n,R,P,O,C,S,d,c,y,v,k,$,m,w,p,u,f,h,g,a,t,o,r,i,s,l,b,D,j,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=e.$eq=e.$dq=e.$cq=e.$bq=e.Translations=void 0;var M;(function(ue){function Q(Y,U){if(Y===U)return!0;const L=Object.keys(Y),N=new Set;for(const G of Object.keys(U))N.add(G);if(L.length!==N.size)return!1;for(const G of L){if(Y[G]!==U[G])return!1;N.delete(G)}return N.size===0}ue.equals=Q})(M||(e.Translations=M={})),e.$bq=(0,r.$fi)("IExtensionsScannerService");let T=class extends c.$Tc{constructor(Q,Y,U,L,N,G,q,oe,he,K,A,F){super(),this.systemExtensionsLocation=Q,this.userExtensionsLocation=Y,this.r=U,this.s=L,this.t=N,this.u=G,this.w=q,this.y=oe,this.z=he,this.C=K,this.D=A,this.F=F,this.g=this.B(new l.$5d),this.onDidChangeCache=this.g.event,this.h=(0,$.$Sg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(J,this.s,this.h)),this.m=this.B(this.F.createInstance(J,this.s,this.h)),this.n=this.B(this.F.createInstance(V,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,g.$np)(this.w,this.y)),this.G}async scanAllExtensions(Q,Y,U){const[L,N]=await Promise.all([this.scanSystemExtensions(Q),this.scanUserExtensions(Y)]),G=U?await this.scanExtensionsUnderDevelopment(Q,[...L,...N]):[];return this.L(L,N,G,await this.getTargetPlatform(),!0)}async scanSystemExtensions(Q){const Y=[];Y.push(this.M(!!Q.useCache,Q.language)),Y.push(this.N(Q.language,!!Q.checkControlFile));const[U,L]=await Promise.all(Y);return this.J([...U,...L],0,Q,!1)}async scanUserExtensions(Q){const Y=Q.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",Y);const U=this.D.extUri.isEqual(Q.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,L=await this.P(Y,!!Q.profileLocation,1,!Q.includeUninstalled,Q.language,!0,U),N=Q.useCache&&!L.devMode&&L.excludeObsolete?this.m:this.n;let G;try{G=await N.scanExtensions(L)}catch(q){if(q instanceof D.$9p&&q.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),G=await N.scanExtensions(L);else throw q}return G=await this.J(G,1,Q,!0),this.y.trace("Scanned user extensions:",G.length),G}async scanExtensionsUnderDevelopment(Q,Y){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const U=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(L=>L.scheme===y.Schemas.file).map(async L=>{const N=await this.P(L,!1,1,!0,Q.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(N)).map(q=>(q.type=Y.find(oe=>(0,g.$cp)(oe.identifier,q.identifier))?.type??q.type,this.n.validate(q,N)))}))).flat();return this.J(U,"development",Q,!0)}return[]}async scanExistingExtension(Q,Y,U){const L=await this.P(Q,!1,Y,!0,U.language,!0,void 0),N=await this.n.scanExtension(L);return!N||!U.includeInvalid&&!N.isValid?null:N}async scanOneOrMultipleExtensions(Q,Y,U){const L=await this.P(Q,!1,Y,!0,U.language,!0,void 0),N=await this.n.scanOneOrMultipleExtensions(L);return this.J(N,Y,U,!0)}async scanMetadata(Q){const Y=(0,$.$Sg)(Q,"package.json"),U=(await this.w.readFile(Y)).value.toString();return JSON.parse(U).__metadata}async updateMetadata(Q,Y){const U=(0,$.$Sg)(Q,"package.json"),L=(await this.w.readFile(U)).value.toString(),N=JSON.parse(L);Y.isMachineScoped===!1&&delete Y.isMachineScoped,Y.isBuiltin===!1&&delete Y.isBuiltin,N.__metadata={...N.__metadata,...Y},await this.w.writeFile((0,$.$Sg)(Q,"package.json"),O.$se.fromString(JSON.stringify(N,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(Q){if(Q instanceof D.$9p&&Q.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw Q}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const Q=await this.scanUserExtensions({includeInvalid:!0});if(Q.length)await this.u.addExtensionsToProfile(Q.map(Y=>[Y,Y.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,O.$se.fromString(JSON.stringify([])))}catch(Y){(0,o.$Wk)(Y)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,C.$0)(Y))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(Q){this.y.error(Q)}finally{this.H=void 0}})()),this.H}async J(Q,Y,U,L){return U.includeAllVersions||(Q=this.L(Y===0?Q:void 0,Y===1?Q:void 0,Y==="development"?Q:void 0,await this.getTargetPlatform(),L)),U.includeInvalid||(Q=Q.filter(N=>N.isValid)),Q.sort((N,G)=>{const q=v.$nc(N.location.fsPath),oe=v.$nc(G.location.fsPath);return q<oe?-1:q>oe?1:0})}L(Q,Y,U,L,N){const G=(oe,he,K)=>{if(oe.isValid&&!he.isValid)return!1;if(oe.isValid===he.isValid){if(N&&m.gt(oe.manifest.version,he.manifest.version))return this.y.debug(`Skipping extension ${he.location.path} with lower version ${he.manifest.version} in favour of ${oe.location.path} with version ${oe.manifest.version}`),!1;if(m.eq(oe.manifest.version,he.manifest.version)){if(oe.type===0)return this.y.debug(`Skipping extension ${he.location.path} in favour of system extension ${oe.location.path} with same version`),!1;if(oe.targetPlatform===L)return this.y.debug(`Skipping extension ${he.location.path} from different target platform ${he.targetPlatform}`),!1}}return K?this.y.warn(`Overwriting user extension ${oe.location.path} with ${he.location.path}.`):this.y.debug(`Overwriting user extension ${oe.location.path} with ${he.location.path}.`),!0},q=new a.$Bm;return Q?.forEach(oe=>{const he=q.get(oe.identifier.id);(!he||G(he,oe,!1))&&q.set(oe.identifier.id,oe)}),Y?.forEach(oe=>{const he=q.get(oe.identifier.id);if(!he&&Q&&oe.type===0){this.y.debug(`Skipping obsolete system extension ${oe.location.path}.`);return}(!he||G(he,oe,!1))&&q.set(oe.identifier.id,oe)}),U?.forEach(oe=>{const he=q.get(oe.identifier.id);(!he||G(he,oe,!0))&&q.set(oe.identifier.id,oe),q.set(oe.identifier.id,oe)}),[...q.values()]}async M(Q,Y){this.y.trace("Started scanning system extensions");const U=await this.P(this.systemExtensionsLocation,!1,0,!0,Y,!0,void 0),N=await(Q&&!U.devMode?this.j:this.n).scanExtensions(U);return this.y.trace("Scanned system extensions:",N.length),N}async N(Q,Y){const U=this.z.isBuilt?[]:this.C.builtInExtensions;if(!U?.length)return[];this.y.trace("Started scanning dev system extensions");const L=Y?await this.O():{},N=[],G=u.URI.file(v.$hc(v.$jc(y.$zg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const oe of U){const he=L[oe.name]||"marketplace";switch(he){case"disabled":break;case"marketplace":N.push((0,$.$Sg)(G,oe.name));break;default:N.push(u.URI.file(he));break}}const q=await Promise.all(N.map(async oe=>this.n.scanExtension(await this.P(oe,!1,0,!0,Q,!0,void 0))));return this.y.trace("Scanned dev system extensions:",q.length),(0,n.$Hb)(q)}async O(){try{const Q=await this.w.readFile(this.r);return JSON.parse(Q.value.toString())}catch{return{}}}async P(Q,Y,U,L,N,G,q){const oe=await this.f(N??k.$w),he=await this.Q(Q),K=Y&&!this.D.extUri.isEqual(Q,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,A=K?await this.Q(K):void 0;return new W(Q,he,K,A,Y,q,U,L,G,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,N,oe)}async Q(Q){try{const Y=await this.w.stat(Q);if(typeof Y.mtime=="number")return Y.mtime}catch{}}};e.$cq=T,e.$cq=T=ve([se(4,j.$fl),se(5,D.$0p),se(6,o.$Fk),se(7,i.$zj),se(8,h.$mi),se(9,s.$Rj),se(10,E.$dl),se(11,r.$ei)],T);class W{constructor(Q,Y,U,L,N,G,q,oe,he,K,A,F,x,z,Z){this.location=Q,this.mtime=Y,this.applicationExtensionslocation=U,this.applicationExtensionslocationMtime=L,this.profile=N,this.profileScanOptions=G,this.type=q,this.excludeObsolete=oe,this.validate=he,this.productVersion=K,this.productDate=A,this.productCommit=F,this.devMode=x,this.language=z,this.translations=Z}static createNlsConfiguration(Q){return{language:Q.language,pseudo:Q.language==="pseudo",devMode:Q.devMode,translations:Q.translations}}static equals(Q,Y){return(0,$.$Lg)(Q.location,Y.location)&&Q.mtime===Y.mtime&&(0,$.$Lg)(Q.applicationExtensionslocation,Y.applicationExtensionslocation)&&Q.applicationExtensionslocationMtime===Y.applicationExtensionslocationMtime&&Q.profile===Y.profile&&P.$On(Q.profileScanOptions,Y.profileScanOptions)&&Q.type===Y.type&&Q.excludeObsolete===Y.excludeObsolete&&Q.validate===Y.validate&&Q.productVersion===Y.productVersion&&Q.productDate===Y.productDate&&Q.productCommit===Y.productCommit&&Q.devMode===Y.devMode&&Q.language===Y.language&&M.equals(Q.translations,Y.translations)}}e.$dq=W;let V=class extends c.$Tc{constructor(Q,Y,U,L,N){super(),this.f=Q,this.g=Y,this.h=U,this.j=L,this.m=N}async scanExtensions(Q){const Y=Q.profile?await this.r(Q):await this.n(Q);let U={};if(Q.excludeObsolete&&Q.type===1)try{const L=(await this.j.readFile(this.f)).value.toString();U=JSON.parse(L)}catch{}return(0,p.$6f)(U)?Y:Y.filter(L=>!U[g.$dp.create(L).toString()])}async n(Q){const Y=await this.j.resolve(Q.location);if(!Y.children?.length)return[];const U=await Promise.all(Y.children.map(async L=>{if(!L.isDirectory||Q.type===1&&(0,$.$Pg)(L.resource).indexOf(".")===0)return null;const N=new W(L.resource,Q.mtime,Q.applicationExtensionslocation,Q.applicationExtensionslocationMtime,Q.profile,Q.profileScanOptions,Q.type,Q.excludeObsolete,Q.validate,Q.productVersion,Q.productDate,Q.productCommit,Q.devMode,Q.language,Q.translations);return this.scanExtension(N)}));return(0,n.$Hb)(U).sort((L,N)=>L.location.path<N.location.path?-1:1)}async r(Q){let Y=await this.s(Q.location,()=>!0,Q);if(Q.applicationExtensionslocation&&!this.h.extUri.isEqual(Q.location,Q.applicationExtensionslocation)){Y=Y.filter(L=>!L.metadata?.isApplicationScoped);const U=await this.s(Q.applicationExtensionslocation,L=>!!L.metadata?.isBuiltin||!!L.metadata?.isApplicationScoped,Q);Y.push(...U)}return Y}async s(Q,Y,U){const L=await this.g.scanProfileExtensions(Q,U.profileScanOptions);if(!L.length)return[];const N=await Promise.all(L.map(async G=>{if(Y(G)){const q=new W(G.location,U.mtime,U.applicationExtensionslocation,U.applicationExtensionslocationMtime,U.profile,U.profileScanOptions,U.type,U.excludeObsolete,U.validate,U.productVersion,U.productDate,U.productCommit,U.devMode,U.language,U.translations);return this.scanExtension(q,G.metadata)}return null}));return(0,n.$Hb)(N)}async scanOneOrMultipleExtensions(Q){try{if(await this.j.exists((0,$.$Sg)(Q.location,"package.json"))){const Y=await this.scanExtension(Q);return Y?[Y]:[]}else return await this.scanExtensions(Q)}catch(Y){return this.m.error(`Error scanning extensions at ${Q.location.path}:`,(0,C.$0)(Y)),[]}}async scanExtension(Q,Y){try{let U=await this.scanExtensionManifest(Q.location);if(U){U.publisher||(U.publisher=a.$vm),Y=Y??U.__metadata,delete U.__metadata;const L=(0,g.$hp)(U.publisher,U.name),N=Y?.id?{id:L,uuid:Y.id}:{id:L},G=Y?.isSystem?0:Q.type,q=G===0||!!Y?.isBuiltin;U=await this.t(Q.location,U,W.createNlsConfiguration(Q));const oe={type:G,identifier:N,manifest:U,location:Q.location,isBuiltin:q,targetPlatform:Y?.targetPlatform??"undefined",metadata:Y,isValid:!0,validations:[]};return Q.validate?this.validate(oe,Q):oe}}catch(U){Q.type!==0&&this.m.error(U)}return null}validate(Q,Y){let U=!0;const L=(0,t.$sp)(Y.productVersion,Y.productDate,Y.location,Q.manifest,Q.isBuiltin);for(const[N,G]of L)N===w.default.Error&&(U=!1,this.m.error(this.z(Y.location,G)));return Q.isValid=U,Q.validations=L,Q}async scanExtensionManifest(Q){const Y=(0,$.$Sg)(Q,"package.json");let U;try{U=(await this.j.readFile(Y)).value.toString()}catch(N){return(0,o.$Wk)(N)!==1&&this.m.error(this.z(Q,(0,f.localize)(0,null,Y.path,N.message))),null}let L;try{L=JSON.parse(U)}catch{const G=[];(0,S.$rn)(U,G);for(const q of G)this.m.error(this.z(Q,(0,f.localize)(1,null,Y.path,q.offset,q.length,(0,d.$_p)(q.error))));return null}return(0,S.$An)(L)!=="object"?(this.m.error(this.z(Q,(0,f.localize)(2,null,Y.path))),null):L}async t(Q,Y,U){const L=await this.u(Q,Y,U);if(L)try{const N=[],G=await this.w(L.default,N);if(N.length>0)return N.forEach(oe=>{this.m.error(this.z(Q,(0,f.localize)(3,null,L.default?.path,(0,d.$_p)(oe.error))))}),Y;if((0,S.$An)(L)!=="object")return this.m.error(this.z(Q,(0,f.localize)(4,null,L.default?.path))),Y;const q=L.values||Object.create(null);return(0,I.$aq)(this.m,Y,q,G)}catch{}return Y}async u(Q,Y,U){const L=(0,$.$Sg)(Q,"package.nls.json"),N=(he,K)=>{K.forEach(A=>{this.m.error(this.z(Q,(0,f.localize)(5,null,he?.path,(0,d.$_p)(A.error))))})},G=he=>{this.m.error(this.z(Q,(0,f.localize)(6,null,he?.path)))},q=`${Y.publisher}.${Y.name}`,oe=U.translations[q];if(oe)try{const he=u.URI.file(oe),K=(await this.j.readFile(he)).value.toString(),A=[],F=(0,S.$rn)(K,A);return A.length>0?(N(he,A),{values:void 0,default:L}):(0,S.$An)(F)!=="object"?(G(he),{values:void 0,default:L}):{values:F.contents?F.contents.package:void 0,default:L}}catch{return{values:void 0,default:L}}else{if(!await this.j.exists(L))return;let K;try{K=await this.y(Q,U)}catch{return}if(!K.localized)return{values:void 0,default:K.original};try{const A=(await this.j.readFile(K.localized)).value.toString(),F=[],x=(0,S.$rn)(A,F);return F.length>0?(N(K.localized,F),{values:void 0,default:K.original}):(0,S.$An)(x)!=="object"?(G(K.localized),{values:void 0,default:K.original}):{values:x,default:K.original}}catch{return{values:void 0,default:K.original}}}}async w(Q,Y){if(Q)try{const U=(await this.j.readFile(Q)).value.toString();return(0,S.$rn)(U,Y)}catch{}}y(Q,Y){return new Promise((U,L)=>{const N=G=>{const q=(0,$.$Sg)(Q,`package.nls.${G}.json`);this.j.exists(q).then(oe=>{oe&&U({localized:q,original:(0,$.$Sg)(Q,"package.nls.json")});const he=G.lastIndexOf("-");he===-1?U({localized:(0,$.$Sg)(Q,"package.nls.json"),original:null}):(G=G.substring(0,he),N(G))})};if(Y.devMode||Y.pseudo||!Y.language)return U({localized:(0,$.$Sg)(Q,"package.nls.json"),original:null});N(Y.language)})}z(Q,Y){return`[${Q.path}]: ${Y}`}};V=ve([se(1,D.$0p),se(2,E.$dl),se(3,o.$Fk),se(4,i.$zj)],V);let J=class extends V{constructor(Q,Y,U,L,N,G,q){super(Y,L,N,G,q),this.G=Q,this.H=U,this.D=this.B(new R.$dh(3e3)),this.F=this.B(new l.$5d),this.onDidChangeCache=this.F.event}async scanExtensions(Q){const Y=this.M(Q),U=await this.I(Y);if(this.C=Q,U&&U.input&&W.equals(U.input,this.C))return this.m.debug("Using cached extensions scan result",Q.location.toString()),this.D.trigger(()=>this.L()),U.result.map(N=>(N.location=u.URI.revive(N.location),N));const L=await super.scanExtensions(Q);return await this.J(Y,{input:Q,result:L}),L}async I(Q){try{const Y=await this.j.readFile(Q),U=JSON.parse(Y.value.toString());return{result:U.result,input:(0,b.$Oh)(U.input)}}catch(Y){this.m.debug("Error while reading the extension cache file:",Q.path,(0,C.$0)(Y))}return null}async J(Q,Y){try{await this.j.writeFile(Q,O.$se.fromString(JSON.stringify(Y)))}catch(U){this.m.debug("Error while writing the extension cache file:",Q.path,(0,C.$0)(U))}}async L(){if(!this.C)return;const Q=this.M(this.C),Y=await this.I(Q);if(!Y)return;const U=Y.result,L=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!P.$On(L,U))try{this.m.info("Invalidating Cache",U,L),await this.j.del(Q),this.F.fire()}catch(N){this.m.error(N)}}M(Q){const Y=this.N(Q);return this.h.extUri.joinPath(Y.cacheHome,Q.type===0?a.$um:a.$tm)}N(Q){return Q.type===0?this.H.defaultProfile:Q.profile?this.h.extUri.isEqual(Q.location,this.G.extensionsResource)?this.G:this.H.profiles.find(Y=>this.h.extUri.isEqual(Q.location,Y.extensionsResource))??this.G:this.H.defaultProfile}};J=ve([se(2,j.$fl),se(3,D.$0p),se(4,E.$dl),se(5,o.$Fk),se(6,i.$zj)],J);function le(ue,Q){const Y=(0,g.$fp)(ue.manifest.publisher,ue.manifest.name);return{id:Y,identifier:new a.$zm(Y),isBuiltin:ue.type===0,isUserBuiltin:ue.type===1&&ue.isBuiltin,isUnderDevelopment:Q,extensionLocation:ue.location,uuid:ue.identifier.uuid,targetPlatform:ue.targetPlatform,...ue.manifest}}e.$eq=le;class re extends T{constructor(Q,Y,U,L,N,G,q,oe,he,K,A,F){super(Q,Y,(0,$.$Sg)(U,".vscode-oss-dev","extensions","control.json"),L,N,G,q,oe,he,K,A,F),this.R=(async()=>{if(k.$z)try{const x=await this.w.readFile(u.URI.file(k.$z));return JSON.parse(x.value.toString())}catch{}return Object.create(null)})()}f(Q){return this.R}}e.$fq=re}),define(ae[278],ce([0,1,5,41,40,28,82,16,38,7]),function(X,e,n,R,P,O,C,S,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HP=void 0;let y=class extends C.$$p{constructor(k,$,m,w,p,u){super(c.URI.file(k.extensionsPath),$,m,w,p,u)}};e.$HP=y,e.$HP=y=ve([se(0,d.$ni),se(1,S.$Fk),se(2,R.$fl),se(3,P.$dl),se(4,O.$El),se(5,n.$zj)],y)}),define(ae[279],ce([0,1,7,38,82,131,16,6,5,27,40,41]),function(X,e,n,R,P,O,C,S,d,c,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kac=void 0;let k=class extends O.$fq{constructor(m,w,p,u,f,h,g,a){super(n.URI.file(f.builtinExtensionsPath),n.URI.file(f.extensionsPath),f.userHome,m.defaultProfile,m,w,p,u,f,h,g,a)}};e.$kac=k,e.$kac=k=ve([se(0,v.$fl),se(1,P.$0p),se(2,C.$Fk),se(3,d.$zj),se(4,R.$ni),se(5,c.$Rj),se(6,y.$dl),se(7,S.$ei)],k)}),define(ae[280],ce([0,1,14,2,13,9,4,59,7,32,37,38,5,41]),function(X,e,n,R,P,O,C,S,d,c,y,v,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cac=void 0;let m=class extends R.$Tc{constructor(p,u,f){super(),this.c=p,this.f=f,this.a=S.$li.forPaths(!C.$k),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(p.appRoot),this.addValidFileRoot(p.extensionsPath),this.addValidFileRoot(u.defaultProfile.globalStorageHome.with({scheme:P.Schemas.file}).fsPath),this.addValidFileRoot(p.workspaceStorageHome.with({scheme:P.Schemas.file}).fsPath),this.g()}g(){const{defaultSession:p}=n.session;p.protocol.registerFileProtocol(P.Schemas.vscodeFileResource,(u,f)=>this.j(u,f)),p.protocol.interceptFileProtocol(P.Schemas.file,(u,f)=>this.h(u,f)),this.B((0,R.$Rc)(()=>{p.protocol.unregisterProtocol(P.Schemas.vscodeFileResource),p.protocol.uninterceptProtocol(P.Schemas.file)}))}addValidFileRoot(p){const u=(0,O.$hc)(p);return this.a.get(u)?R.$Tc.None:(this.a.set(u,!0),(0,R.$Rc)(()=>this.a.delete(u)))}h(p,u){const f=d.URI.parse(p.url);return this.f.error(`Refused to load resource ${f.fsPath} from ${P.Schemas.file}: protocol (original URL: ${p.url})`),u({error:-3})}j(p,u){const f=this.m(p);let h;return this.c.crossOriginIsolated&&((0,O.$nc)(f)==="workbench.html"||(0,O.$nc)(f)==="workbench-dev.html"?h=P.COI.CoopAndCoep:h=P.COI.getHeadersFromQuery(p.url)),this.a.findSubstr(f)?u({path:f,headers:h}):this.b.has((0,O.$oc)(f).toLowerCase())?u({path:f}):(this.f.error(`${P.Schemas.vscodeFileResource}: Refused to load resource ${f} from ${P.Schemas.vscodeFileResource}: protocol (original URL: ${p.url})`),u({error:-3}))}m(p){const u=d.URI.parse(p.url),f=P.$zg.uriToFileUri(u);return(0,O.$hc)(f.fsPath)}createIPCObjectUrl(){let p;const u=d.URI.from({scheme:"vscode",path:(0,c.$Bg)()}),f=u.toString(),h=async()=>p;return y.$KV.handle(f,h),this.f.trace(`IPC Object URL: Registered new channel ${f}.`),{resource:u,update:g=>p=g,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${f}.`),y.$KV.removeHandler(f)}}}};e.$Cac=m,e.$Cac=m=ve([se(0,v.$ni),se(1,$.$fl),se(2,k.$zj)],m)}),define(ae[97],ce([0,1,8,3,2,66,12,114,6,41]),function(X,e,n,R,P,O,C,S,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Np=e.$Mp=e.$Lp=e.$Kp=e.$Jp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Ip=e.$Hp=e.$Gp=void 0,e.$Gp="__$__isNewStorageMarker",e.$Hp="__$__targetStorageMarker",e.$Ip=(0,d.$fi)("storageService");var y;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(y||(e.WillSaveStateReason=y={}));var v;(function(f){f[f.APPLICATION=-1]="APPLICATION",f[f.PROFILE=0]="PROFILE",f[f.WORKSPACE=1]="WORKSPACE"})(v||(e.StorageScope=v={}));var k;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(k||(e.StorageTarget=k={}));function $(f){const h=f.get(e.$Hp);if(h)try{return JSON.parse(h)}catch{}return Object.create(null)}e.$Jp=$;class m extends P.$Tc{static{this.a=60*1e3}constructor(h={flushInterval:m.a}){super(),this.m=h,this.b=this.B(new R.$8d),this.c=this.B(new R.$8d),this.onDidChangeTarget=this.c.event,this.f=this.B(new R.$5d),this.onWillSaveState=this.f.event,this.h=this.B(new n.$rh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new P.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(h,g,a){return R.Event.filter(this.b.event,t=>t.scope===h&&(g===void 0||t.key===g),a)}n(){this.j.value=(0,n.$vh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,P.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,O.mark)("code/willInitStorage");try{await this.O()}finally{(0,O.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(h,g){const{key:a,external:t}=g;if(a===e.$Hp){switch(h){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:h})}else this.b.fire({scope:h,key:a,target:this.J(h)[a],external:t})}w(h){this.f.fire({reason:h})}get(h,g,a){return this.P(g)?.get(h,a)}getBoolean(h,g,a){return this.P(g)?.getBoolean(h,a)}getNumber(h,g,a){return this.P(g)?.getNumber(h,a)}getObject(h,g,a){return this.P(g)?.getObject(h,a)}storeAll(h,g){this.y(()=>{for(const a of h)this.store(a.key,a.value,a.scope,a.target,g)})}store(h,g,a,t,o=!1){if((0,C.$2f)(g)){this.remove(h,a,o);return}this.y(()=>{this.z(h,a,t),this.P(a)?.set(h,g,o)})}remove(h,g,a=!1){this.y(()=>{this.z(h,g,void 0),this.P(g)?.delete(h,a)})}y(h){this.b.pause(),this.c.pause();try{h()}finally{this.b.resume(),this.c.resume()}}keys(h,g){const a=[],t=this.J(h);for(const o of Object.keys(t))t[o]===g&&a.push(o);return a}z(h,g,a,t=!1){const o=this.J(g);typeof a=="number"?o[h]!==a&&(o[h]=a,this.P(g)?.set(e.$Hp,JSON.stringify(o),t)):typeof o[h]=="number"&&(delete o[h],this.P(g)?.set(e.$Hp,JSON.stringify(o),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(h){switch(h){case-1:return this.I;case 0:return this.G;default:return this.D}}L(h){const g=this.P(h);return g?$(g):Object.create(null)}isNew(h){return this.getBoolean(e.$Gp,h)===!0}async flush(h=y.NONE){this.f.fire({reason:h});const g=this.P(-1),a=this.P(0),t=this.P(1);switch(h){case y.NONE:await n.Promises.settled([g?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case y.SHUTDOWN:await n.Promises.settled([g?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const h=this.P(-1)?.items??new Map,g=this.P(0)?.items??new Map,a=this.P(1)?.items??new Map;return u(h,g,a,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(h){return await this.flush(),this.P(h)?.optimize()}async switch(h,g){return this.w(y.NONE),(0,c.$el)(h)?this.R(h,g):this.S(h,g)}M(h,g){return!(h.id===g.id||w(g)&&w(h))}N(h,g,a){this.y(()=>{const t=new Set;for(const[o,r]of h)t.add(o),g.get(o)!==r&&this.u(a,{key:o,external:!0});for(const[o]of g.items)t.has(o)||this.u(a,{key:o,external:!0})})}}e.$Kp=m;function w(f){return f.isDefault||!!f.useDefaultFlags?.globalState}e.$Lp=w;class p extends m{constructor(){super(),this.U=this.B(new S.$Ep(new S.$Fp,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new S.$Ep(new S.$Fp,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new S.$Ep(new S.$Fp,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(h=>this.u(1,h))),this.B(this.W.onDidChangeStorage(h=>this.u(0,h))),this.B(this.U.onDidChangeStorage(h=>this.u(-1,h)))}P(h){switch(h){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(h){switch(h){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(h){return!1}}e.$Mp=p;async function u(f,h,g,a,t,o){const r=M=>{try{return JSON.parse(M)}catch{return M}},i=new Map,s=new Map;f.forEach((M,T)=>{i.set(T,M),s.set(T,r(M))});const l=new Map,b=new Map;h.forEach((M,T)=>{l.set(T,M),b.set(T,r(M))});const D=new Map,j=new Map;g.forEach((M,T)=>{D.set(T,M),j.set(T,r(M))}),console.group(a!==t?`Storage: Application (path: ${a})`:`Storage: Application & Profile (path: ${a}, default profile)`);const E=[];if(i.forEach((M,T)=>{E.push({key:T,value:M})}),console.table(E),console.groupEnd(),console.log(s),a!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const M=[];l.forEach((T,W)=>{M.push({key:W,value:T})}),console.table(M),console.groupEnd(),console.log(b)}console.group(`Storage: Workspace (path: ${o})`);const I=[];D.forEach((M,T)=>{I.push({key:T,value:M})}),console.table(I),console.groupEnd(),console.log(j)}e.$Np=u}),define(ae[281],ce([0,1,22,8,3,2,9,72,7,21,114,163,5,97,28,30,13]),function(X,e,n,R,P,O,C,S,d,c,y,v,k,$,m,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b_b=e.$a_b=e.$_$b=e.$$$b=void 0;class u extends O.$Tc{static{this.a=2e3}get storage(){return this.f}constructor(r,i){super(),this.m=r,this.n=i,this.b=this.B(new P.$5d),this.onDidChangeStorage=this.b.event,this.c=this.B(new P.$5d),this.onDidCloseStorage=this.c.event,this.f=this.B(new y.$Ep(new y.$Fp,{hint:y.StorageHint.STORAGE_IN_MEMORY})),this.g=void 0,this.h=new R.$Ch,this.whenInit=this.h.p,this.j=y.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.j===y.StorageState.None)try{const r=this.B(await this.t());this.f.dispose(),this.f=r,this.B(r.onDidChangeStorage(s=>this.b.fire(s))),await this.s(r);const i=r.getBoolean($.$Gp);i===void 0?r.set($.$Gp,!0):i&&r.set($.$Gp,!1)}catch(r){this.m.error(`[storage main] initialize(): Unable to init storage due to ${r}`)}finally{this.j=y.StorageState.Initialized,this.h.complete()}})()),this.g}r(){return{logTrace:this.m.getLevel()===k.LogLevel.Trace?r=>this.m.trace(r):void 0,logError:r=>this.m.error(r)}}s(r){return r.init()}get items(){return this.f.items}get(r,i){return this.f.get(r,i)}set(r,i){return this.f.set(r,i)}delete(r){return this.f.delete(r)}optimize(){return this.f.optimize()}async close(){const r=new S.$1d(!1);await this.w(),r.stop(),r.elapsed()>u.a&&await this.u(r),this.c.fire()}async u(r){if(this.path)try{const i=(0,n.top)(Array.from(this.f.items.entries()).map(([l,b])=>({key:l,length:b.length})),(l,b)=>b.length-l.length,5).map(l=>`${l.key}:${l.length}`).join(", "),s=(await this.n.stat(d.URI.file(this.path))).size;this.m.warn(`[storage main] detected slow close() operation: Time: ${r.elapsed()}ms, DB size: ${s}b, Large Keys: ${i}`)}catch(i){this.m.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async w(){this.g&&await this.g,this.j=y.StorageState.Closed,await this.f.close()}}class f extends u{static{this.y="state.vscdb"}get path(){if(!this.C.useInMemoryStorage)return(0,C.$jc)(this.z.globalStorageHome.with({scheme:p.Schemas.file}).fsPath,f.y)}constructor(r,i,s,l){super(s,l),this.z=r,this.C=i}async t(){return new y.$Ep(new v.$dW(this.path??v.$dW.IN_MEMORY_PATH,{logging:this.r()}),this.path?void 0:{hint:y.StorageHint.STORAGE_IN_MEMORY})}}class h extends f{constructor(r,i,s,l){super(r,i,s,l)}}e.$$$b=h;class g extends f{constructor(r,i,s,l){super(i.defaultProfile,r,s,l)}async s(r){await super.s(r),this.G(r)}G(r){r.get(m.$Hl,void 0)===void 0&&r.set(m.$Hl,new Date().toUTCString());const s=r.get(m.$Gl,void 0),l=new Date().toUTCString();r.set(m.$Il,typeof s>"u"?null:s),r.set(m.$Gl,l)}}e.$_$b=g;class a extends u{static{this.y="state.vscdb"}static{this.z="workspace.json"}get path(){if(!this.D.useInMemoryStorage)return(0,C.$jc)(this.F.workspaceStorageHome.with({scheme:p.Schemas.file}).fsPath,this.C.id,a.y)}constructor(r,i,s,l,b){super(s,b),this.C=r,this.D=i,this.F=l}async t(){const{storageFilePath:r,wasCreated:i}=await this.H();return new y.$Ep(new v.$dW(r,{logging:this.r()}),{hint:this.D.useInMemoryStorage?y.StorageHint.STORAGE_IN_MEMORY:i?y.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async H(){if(this.D.useInMemoryStorage)return{storageFilePath:v.$dW.IN_MEMORY_PATH,wasCreated:!0};const r=(0,C.$jc)(this.F.workspaceStorageHome.with({scheme:p.Schemas.file}).fsPath,this.C.id),i=(0,C.$jc)(r,a.y);return await c.Promises.exists(r)?{storageFilePath:i,wasCreated:!1}:(await c.Promises.mkdir(r,{recursive:!0}),this.I(r),{storageFilePath:i,wasCreated:!0})}async I(r){let i;if((0,w.$pi)(this.C)?i={folder:this.C.uri.toString()}:(0,w.$ui)(this.C)&&(i={workspace:this.C.configPath.toString()}),i)try{const s=(0,C.$jc)(r,a.z);await c.Promises.exists(s)||await c.Promises.writeFile(s,JSON.stringify(i,void 0,2))}catch(s){this.m.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${s}`)}}}e.$a_b=a;class t extends u{get path(){}async t(){return new y.$Ep(new y.$Fp,{hint:y.StorageHint.STORAGE_IN_MEMORY})}}e.$b_b=t}),define(ae[282],ce([0,1,3,2,97]),function(X,e,n,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mac=void 0;class O extends R.$Tc{constructor(S,d,c){super(),this.b=S,this.c=d,this.f=c;const y=this.B(new R.$Uc);this.a=this.B(new n.$5d({onWillAddFirstListener:()=>y.value=this.g(),onDidRemoveLastListener:()=>y.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const S=new R.$Sc;return S.add(n.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(d,c)=>(d?d.push(c.key):d=[c.key],d),100)(d=>this.h(d))),S.add(n.Event.debounce(this.b.onDidChangeProfileStorage,(d,c)=>{d||(d=new Map);let y=d.get(c.profile.id);return y||d.set(c.profile.id,y={profile:c.profile,keys:[],storage:c.storage}),y.keys.push(c.key),d},100)(d=>this.j(d))),S}h(S){const d=S.includes(P.$Hp)?[this.c.defaultProfile]:[],c=[];if(S=S.filter(y=>y!==P.$Hp),S.length){const y=(0,P.$Jp)(this.b.applicationStorage.storage);c.push({profile:this.c.defaultProfile,changes:S.map(v=>({key:v,scope:0,target:y[v]}))})}this.m(d,c)}j(S){const d=[],c=new Map;for(const[y,v]of S.entries()){v.keys.includes(P.$Hp)&&d.push(v.profile);const k=v.keys.filter($=>$!==P.$Hp);if(k.length){const $=(0,P.$Jp)(v.storage.storage);c.set(y,{profile:v.profile,changes:k.map(m=>({key:m,scope:0,target:$[m]}))})}}this.m(d,[...c.values()])}m(S,d){(S.length||d.length)&&this.a.fire({valueChanges:d,targetChanges:S})}listen(S,d,c){switch(d){case"onDidChange":return this.a.event}throw new Error(`[ProfileStorageChangesListenerChannel] Event not found: ${d}`)}async call(S,d){throw new Error(`Call not found: ${d}`)}}e.$mac=O}),define(ae[283],ce([0,1,7,38,16,5,34,40,41,12,124]),function(X,e,n,R,P,O,C,S,d,c,y){"use strict";var v,k;Object.defineProperty(e,"__esModule",{value:!0}),e.$GP=e.$FP=e.$EP=void 0;let $=class extends d.$il{static{v=this}static{this.a="profileAssociationsMigration"}constructor(u,f,h,g,a){super(h,g,f,a),this.U=u,this.W=h}O(){return this.U.getItem(v.b,[]).map(f=>({...f,location:(0,c.$Sf)(f.location)?this.w.extUri.joinPath(this.profilesHome,f.location):n.URI.revive(f.location)}))}Q(){const u=this.U.getItem(v.c,{});return this.U.getItem(v.a,!1)?u:this.N(u)}S(){return this.w.extUri.joinPath(n.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$EP=$,e.$EP=$=v=ve([se(0,C.$zP),se(1,S.$dl),se(2,R.$ni),se(3,P.$Fk),se(4,O.$zj)],$);let m=k=class extends ${constructor(u,f,h,g,a){super(u,f,h,g,a),this.$=u}P(u){u.length?this.$.setItem(k.b,u.map(f=>({...f,location:this.w.extUri.basename(f.location)}))):this.$.removeItem(k.b)}O(){const u=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(u),this.$.setItem("userDataProfilesMigration",!0)),u}R(u){u.emptyWindows||u.workspaces?this.$.setItem(k.c,u):this.$.removeItem(k.c)}Q(){const u="workspaceAndProfileInfo",f=this.$.getItem(u,void 0);if(f){this.$.removeItem(u);const g=f.reduce((a,{workspace:t,profile:o})=>(a[n.URI.revive(t).toString()]=n.URI.revive(o).toString(),a),{});this.$.setItem(k.c,{workspaces:g})}const h=super.Q();return this.$.getItem(k.a,!1)||(this.R(h),this.$.setItem(k.a,!0)),h}};e.$FP=m,e.$FP=m=k=ve([se(0,C.$AP),se(1,S.$dl),se(2,R.$ni),se(3,P.$Fk),se(4,O.$zj)],m);let w=class extends m{constructor(u,f,h,g){super(new y.$DP(0,f,g,h),u,f,h,g)}async init(){return await this.$.init(),super.init()}};e.$GP=w,e.$GP=w=ve([se(0,S.$dl),se(1,R.$ni),se(2,P.$Fk),se(3,O.$zj)],w)}),define(ae[57],ce([0,1,38,16,6,5,40,41,283,34]),function(X,e,n,R,P,O,C,S,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T$b=e.$S$b=void 0,e.$S$b=(0,P.$gi)(S.$fl);let y=class extends d.$FP{constructor(k,$,m,w,p){super(k,$,m,w,p)}getAssociatedEmptyWindows(){const k=[];for(const $ of this.C.emptyWindows.keys())k.push({id:$});return k}};e.$T$b=y,e.$T$b=y=ve([se(0,c.$AP),se(1,C.$dl),se(2,n.$ni),se(3,R.$Fk),se(4,O.$zj)],y)}),define(ae[132],ce([0,1,19,7,30]),function(X,e,n,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W$b=e.$V$b=e.$U$b=void 0;async function O(d,c,y){for(const k of d){const $=k.openedWorkspace;if((0,P.$ui)($)){const m=await y($);if(m){if(m.folders.some(w=>n.$Jg.isEqualOrParent(c,w.uri)))return k}else if(n.$Jg.isEqualOrParent(c,$.configPath))return k}}const v=d.filter(k=>(0,P.$pi)(k.openedWorkspace)&&n.$Jg.isEqualOrParent(c,k.openedWorkspace.uri));if(v.length)return v.sort((k,$)=>-(k.openedWorkspace.uri.path.length-$.openedWorkspace.uri.path.length))[0]}e.$U$b=O;function C(d,c){for(const y of d)if((0,P.$ui)(y.openedWorkspace)&&n.$Jg.isEqual(y.openedWorkspace.configPath,c)||(0,P.$pi)(y.openedWorkspace)&&n.$Jg.isEqual(y.openedWorkspace.uri,c))return y}e.$V$b=C;function S(d,c){const y=v=>c.some(k=>n.$Jg.isEqual(R.URI.file(k),R.URI.file(v)));for(const v of d)if(v.config?.extensionDevelopmentPath?.some(k=>y(k)))return v}e.$W$b=S}),define(ae[98],ce([0,1,33,42,102,47,13,9,4,19,7,6,68,30]),function(X,e,n,R,P,O,C,S,d,c,y,v,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qeb=e.$peb=e.$oeb=e.$neb=e.$meb=e.$leb=e.$keb=e.$jeb=e.$ieb=e.$heb=void 0,e.$heb=(0,v.$fi)("workspacesService");function m(j){return j.hasOwnProperty("workspace")}e.$ieb=m;function w(j){return j.hasOwnProperty("folderUri")}e.$jeb=w;function p(j){return j.hasOwnProperty("fileUri")}e.$keb=p;function u(j){return f(j)||h(j)}e.$leb=u;function f(j){const E=j;return typeof E?.path=="string"&&(!E.name||typeof E.name=="string")}function h(j){const E=j;return typeof E?.uri=="string"&&(!E.name||typeof E.name=="string")}function g(j,E,I,M,T){if(j.scheme!==M.scheme)return{name:I,uri:j.toString(!0)};let W=E?void 0:T.relativePath(M,j);if(W!==void 0)W.length===0?W=".":d.$i&&(W=a(W));else if(j.scheme===C.Schemas.file)W=j.fsPath,d.$i&&(W=a(W));else if(T.isEqualAuthority(j.authority,M.authority))W=j.path;else return{name:I,uri:j.toString(!0)};return{name:I,path:W}}e.$meb=g;function a(j){return j=(0,O.$_v)(j),(0,n.$cg)(j)||(j=(0,n.$_f)(j)),j}function t(j,E,I){const M=[],T=new Set,W=I.dirname(E);for(const V of j){let J;if(f(V))V.path&&(J=I.resolvePath(W,V.path));else if(h(V))try{J=y.URI.parse(V.uri),J.path[0]!==S.$gc.sep&&(J=J.with({path:S.$gc.sep+J.path}))}catch(le){console.warn(le)}if(J){const le=I.getComparisonKey(J);if(!T.has(le)){T.add(le);const re=V.name||I.basenameOrAuthority(J);M.push(new $.$zi({uri:J,name:re,index:M.length},V))}}}return M}e.$neb=t;function o(j,E,I,M,T){const W=r(E,j),V=T.dirname(E),J=T.dirname(M),le=[];for(const Y of W.folders){const U=f(Y)?T.resolvePath(V,Y.path):y.URI.parse(Y.uri);let L;I?L=!1:L=!f(Y)||(0,S.$ic)(Y.path),le.push(g(U,L,Y.name,J,T))}const re={insertSpaces:!1,tabSize:4,eol:d.$k||d.$j?`
`:`\r
`},ue=P.$Gn(j,["folders"],le,re);let Q=P.$Jn(j,ue);return(0,c.$Xg)(W.remoteAuthority,(0,k.$pm)(M))&&(Q=P.$Jn(Q,P.$Fn(Q,["remoteAuthority"],re))),Q}e.$oeb=o;function r(j,E){const I=R.$rn(E);if(I&&Array.isArray(I.folders))I.folders=I.folders.filter(M=>u(M));else throw new Error(`${j} looks like an invalid workspace file.`);return I}function i(j){return j.workspace&&typeof j.workspace=="object"&&typeof j.workspace.id=="string"&&typeof j.workspace.configPath=="string"}function s(j){return typeof j.folderUri=="string"}function l(j){return typeof j.fileUri=="string"}function b(j,E){const I={workspaces:[],files:[]};if(j){const M=function(W,V){for(let J=0;J<W.length;J++)try{V(W[J],J)}catch(le){E.warn(`Error restoring recent entry ${JSON.stringify(W[J])}: ${le.toString()}. Skip entry.`)}},T=j;Array.isArray(T.entries)&&M(T.entries,W=>{const V=W.label,J=W.remoteAuthority;i(W)?I.workspaces.push({label:V,remoteAuthority:J,workspace:{id:W.workspace.id,configPath:y.URI.parse(W.workspace.configPath)}}):s(W)?I.workspaces.push({label:V,remoteAuthority:J,folderUri:y.URI.parse(W.folderUri)}):l(W)&&I.files.push({label:V,remoteAuthority:J,fileUri:y.URI.parse(W.fileUri)})})}return I}e.$peb=b;function D(j){const E={entries:[]};for(const I of j.workspaces)w(I)?E.entries.push({folderUri:I.folderUri.toString(),label:I.label,remoteAuthority:I.remoteAuthority}):E.entries.push({workspace:{id:I.workspace.id,configPath:I.workspace.configPath.toString()},label:I.label,remoteAuthority:I.remoteAuthority});for(const I of j.files)E.entries.push({fileUri:I.fileUri.toString(),label:I.label,remoteAuthority:I.remoteAuthority});return E}e.$qeb=D}),define(ae[99],ce([0,1,87,13,4,19]),function(X,e,n,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1$b=e.$Z$b=e.$Y$b=e.$X$b=void 0,e.$X$b=128/4;function C(c){function y(){let v=c.scheme===R.Schemas.file?(0,O.$Gg)(c):c.toString();return P.$k||(v=v.toLowerCase()),(0,n.createHash)("md5").update(v).digest("hex")}return{id:y(),configPath:c}}e.$Y$b=C;function S(c,y){function v(){if(c.scheme!==R.Schemas.file)return(0,n.createHash)("md5").update(c.toString()).digest("hex");if(!y)return;let $;return P.$k?$=y.ino:P.$j?$=y.birthtime.getTime():P.$i&&(typeof y.birthtimeMs=="number"?$=Math.floor(y.birthtimeMs):$=y.birthtime.getTime()),(0,n.createHash)("md5").update(c.fsPath).update($?String($):"").digest("hex")}const k=v();if(typeof k=="string")return{id:k,uri:c}}e.$Z$b=S;function d(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$1$b=d}),define(ae[100],ce([0,1,87,88,26,284,17,15,3,2,9,4,32,43,112]),function(X,e,n,R,P,O,C,S,d,c,y,v,k,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=void 0;class w{traceSocketEvent(E,I){m.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,E,I)}constructor(E,I=""){this.f=!0,this.debugLabel=I,this.socket=E,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=M=>{if(this.traceSocketEvent("error",{code:M?.code,message:M?.message}),M){if(M.code==="EPIPE")return;(0,S.$1)(M)}},this.socket.on("error",this.a),this.b=M=>{this.traceSocketEvent("close",{hadError:M}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(E){const I=M=>{this.traceSocketEvent("read",M),E(C.$se.wrap(M))};return this.socket.on("data",I),{dispose:()=>this.socket.off("data",I)}}onClose(E){const I=M=>{E({type:0,hadError:M,error:void 0})};return this.socket.on("close",I),{dispose:()=>this.socket.off("close",I)}}onEnd(E){const I=()=>{E()};return this.socket.on("end",I),{dispose:()=>this.socket.off("end",I)}}write(E){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",E),this.socket.write(E.buffer,I=>{if(I){if(I.code==="EPIPE")return;(0,S.$1)(I)}})}catch(I){if(I.code==="EPIPE")return;(0,S.$1)(I)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((E,I)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),E();return}const M=()=>{this.socket.off("close",M),this.socket.off("end",M),this.socket.off("error",M),this.socket.off("timeout",M),this.socket.off("drain",M),this.traceSocketEvent("nodeDrainEnd"),E()};this.socket.on("close",M),this.socket.on("end",M),this.socket.on("error",M),this.socket.on("timeout",M),this.socket.on("drain",M)})}}e.$7h=w;var p;(function(j){j[j.MinHeaderByteSize=2]="MinHeaderByteSize",j[j.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(p||(p={}));var u;(function(j){j[j.PeekHeader=1]="PeekHeader",j[j.ReadHeader=2]="ReadHeader",j[j.ReadBody=3]="ReadBody",j[j.Fin=4]="Fin"})(u||(u={}));class f extends c.$Tc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(E,I){this.socket.traceSocketEvent(E,I)}constructor(E,I,M,T){super(),this.f=this.B(new d.$5d),this.g=this.B(new d.$5d),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=E,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:I,inflateBytesLength:M?.byteLength||0,recordInflateBytes:T}),this.a=this.B(new h(this,I,M,T,this.f,(W,V)=>this.m(W,V))),this.B(this.a.onError(W=>{console.error(W),(0,S.$1)(W),this.g.fire({type:0,hadError:!0,error:W})})),this.b=new m.$2h,this.B(this.socket.onData(W=>this.n(W))),this.B(this.socket.onClose(async W=>{this.a.isProcessingReadQueue()&&await d.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(W)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(E){return this.f.event(E)}onClose(E){return this.g.event(E)}onEnd(E){return this.socket.onEnd(E)}write(E){let I=0;for(;I<E.byteLength;)this.a.writeMessage(E.slice(I,Math.min(I+262144,E.byteLength)),{compressed:!0,opcode:2}),I+=262144}m(E,{compressed:I,opcode:M}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",E);let T=2;E.byteLength<126?T+=0:E.byteLength<2**16?T+=2:T+=8;const W=C.$se.alloc(T),V=I?64:0,J=M&15;if(W.writeUInt8(128|V|J,0),E.byteLength<126)W.writeUInt8(E.byteLength,1);else if(E.byteLength<2**16){W.writeUInt8(126,1);let le=1;W.writeUInt8(E.byteLength>>>8&255,++le),W.writeUInt8(E.byteLength>>>0&255,++le)}else{W.writeUInt8(127,1);let le=1;W.writeUInt8(0,++le),W.writeUInt8(0,++le),W.writeUInt8(0,++le),W.writeUInt8(0,++le),W.writeUInt8(E.byteLength>>>24&255,++le),W.writeUInt8(E.byteLength>>>16&255,++le),W.writeUInt8(E.byteLength>>>8&255,++le),W.writeUInt8(E.byteLength>>>0&255,++le)}this.socket.write(C.$se.concat([W,E]))}end(){this.h=!0,this.socket.end()}n(E){if(E.byteLength!==0){for(this.b.acceptChunk(E);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const I=this.b.peek(this.j.readLen),M=I.readUInt8(0),T=(M&128)>>>7,W=(M&64)>>>6,V=M&15,J=I.readUInt8(1),le=(J&128)>>>7,re=J&127;this.j.state=2,this.j.readLen=2+(le?4:0)+(re===126?2:0)+(re===127?8:0),this.j.fin=T,this.j.firstFrameOfMessage&&(this.j.compressed=!!W),this.j.firstFrameOfMessage=!!T,this.j.mask=0,this.j.opcode=V,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const I=this.b.read(this.j.readLen),M=I.readUInt8(1),T=(M&128)>>>7;let W=M&127,V=1;W===126?W=I.readUInt8(++V)*2**8+I.readUInt8(++V):W===127&&(W=I.readUInt8(++V)*0+I.readUInt8(++V)*0+I.readUInt8(++V)*0+I.readUInt8(++V)*0+I.readUInt8(++V)*2**24+I.readUInt8(++V)*2**16+I.readUInt8(++V)*2**8+I.readUInt8(++V));let J=0;T&&(J=I.readUInt8(++V)*2**24+I.readUInt8(++V)*2**16+I.readUInt8(++V)*2**8+I.readUInt8(++V)),this.j.state=3,this.j.readLen=W,this.j.mask=J,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const I=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",I),t(I,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",I),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(I,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(I,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await d.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$8h=f;class h extends c.$Tc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:C.$se.alloc(0)}constructor(E,I,M,T,W,V){super(),this.n=E,this.r=W,this.s=V,this.a=this.B(new d.$5d),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new d.$5d),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new d.$5d),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,I?(this.b=this.B(new g(this.n,T,M,{windowBits:15})),this.f=this.B(new a(this.n,{windowBits:15})),this.B(this.b.onError(J=>this.a.fire(J))),this.B(this.f.onError(J=>this.a.fire(J)))):(this.b=null,this.f=null)}writeMessage(E,I){this.g.push({data:E,options:I}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:E,options:I}=this.g.shift();if(this.f&&I.compressed){const M=await this.w(this.f,E);this.s(M,I)}else this.s(E,{...I,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(E,I){return new Promise((M,T)=>{E.write(I),E.flush(W=>M(W))})}acceptFrame(E,I,M){this.h.push({data:E,isCompressed:I,isLastFrameOfMessage:M}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const E=this.h.shift();if(this.b&&E.isCompressed){const I=await this.C(this.b,E.data,E.isLastFrameOfMessage);this.r.fire(I)}else this.r.fire(E.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(E,I,M){return new Promise((T,W)=>{E.write(I),M&&E.write(C.$se.fromByteArray([0,0,255,255])),E.flush(V=>T(V))})}}class g extends c.$Tc{get recordedInflateBytes(){return this.j?C.$se.concat(this.f):C.$se.alloc(0)}constructor(E,I,M,T){super(),this.h=E,this.j=I,this.a=this.B(new d.$5d),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,O.createInflateRaw)(T),this.b.on("error",W=>{this.h.traceSocketEvent("zlibInflateError",{message:W?.message,code:W?.code}),this.a.fire(W)}),this.b.on("data",W=>{this.h.traceSocketEvent("zlibInflateData",W),this.g.push(C.$se.wrap(W))}),M&&(this.h.traceSocketEvent("zlibInflateInitialWrite",M.buffer),this.b.write(M.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(E){this.j&&this.f.push(E.clone()),this.h.traceSocketEvent("zlibInflateWrite",E),this.b.write(E.buffer)}flush(E){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const I=C.$se.concat(this.g);this.g.length=0,E(I)})}}class a extends c.$Tc{constructor(E,I){super(),this.g=E,this.a=this.B(new d.$5d),this.onError=this.a.event,this.f=[],this.b=(0,O.createDeflateRaw)({windowBits:15}),this.b.on("error",M=>{this.g.traceSocketEvent("zlibDeflateError",{message:M?.message,code:M?.code}),this.a.fire(M)}),this.b.on("data",M=>{this.g.traceSocketEvent("zlibDeflateData",M),this.f.push(C.$se.wrap(M))})}write(E){this.g.traceSocketEvent("zlibDeflateWrite",E.buffer),this.b.write(E.buffer)}flush(E){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let I=C.$se.concat(this.f);this.f.length=0,I=I.slice(0,I.byteLength-4),E(I)})}}function t(j,E){if(E===0)return;const I=j.byteLength>>>2;for(let le=0;le<I;le++){const re=j.readUInt32BE(le*4);j.writeUInt32BE(re^E,le*4)}const M=I*4,T=j.byteLength-M,W=E>>>24&255,V=E>>>16&255,J=E>>>8&255;T>=1&&j.writeUInt8(j.readUInt8(M)^W,M),T>=2&&j.writeUInt8(j.readUInt8(M+1)^V,M+1),T>=3&&j.writeUInt8(j.readUInt8(M+2)^J,M+2)}e.$9h=process.env.XDG_RUNTIME_DIR;const o={2:107,1:103};function r(){const j=(0,k.$Bg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${j}-sock`;const E=process.platform!=="darwin"&&e.$9h?e.$9h:(0,P.tmpdir)(),I=(0,y.$jc)(E,`vscode-ipc-${j}.sock`);return s(I),I}e.$0h=r;function i(j,E,I){const T=(0,n.createHash)("sha256").update(j).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${T}-${I}-${E}-sock`;const W=I.substr(0,4),V=E.substr(0,6);let J;return process.platform!=="darwin"&&e.$9h&&!process.env.VSCODE_PORTABLE?J=(0,y.$jc)(e.$9h,`vscode-${T}-${W}-${V}.sock`):J=(0,y.$jc)(j,`${W}-${V}.sock`),s(J),J}e.$$h=i;function s(j){const E=o[v.$u];typeof E=="number"&&j.length>=E&&console.warn(`WARNING: IPC handle "${j}" is longer than ${E} chars, try a shorter --user-data-dir`)}class l extends $.$Vh{static b(E){const I=d.Event.fromNodeEventEmitter(E,"connection");return d.Event.map(I,M=>({protocol:new m.$3h(new w(M,"ipc-server-connection")),onDidClientDisconnect:d.Event.once(d.Event.fromNodeEventEmitter(M,"close"))}))}constructor(E){super(l.b(E)),this.d=E}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$_h=l;function b(j){return new Promise((E,I)=>{const M=(0,R.createServer)();M.on("error",I),M.listen(j,()=>{M.removeListener("error",I),E(new l(M))})})}e.$ai=b;function D(j,E){return new Promise((I,M)=>{const T=(0,R.createConnection)(j,()=>{T.removeListener("error",M),I(m.$4h.fromSocket(new w(T,`ipc-client${E}`),E))});T.once("error",M)})}e.$bi=D}),define(ae[24],ce([0,1,50,9,4,100,38,91,6]),function(X,e,n,R,P,O,C,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F$b=e.$E$b=void 0,e.$E$b=(0,d.$gi)(C.$mi);class c extends S.$Qm{constructor(){super(...arguments),this.d={}}get cachedLanguagesPath(){return(0,R.$jc)(this.userDataPath,"clp")}get backupHome(){return(0,R.$jc)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,O.$$h)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,R.$jc)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(P.$k){for(const v in process.env)if(v.endsWith("_VSCODE_SNAP_ORIG")){const k=v.slice(0,-17);if(this.d[k])continue;process.env[k]&&(this.d[k]=process.env[k]),process.env[v]?process.env[k]=process.env[v]:delete process.env[k]}}}restoreSnapExportedVariables(){if(P.$k)for(const v in this.d)process.env[v]=this.d[v],delete this.d[v]}}e.$F$b=c,ve([n.$Jh],c.prototype,"cachedLanguagesPath",null),ve([n.$Jh],c.prototype,"backupHome",null),ve([n.$Jh],c.prototype,"mainIPCHandle",null),ve([n.$Jh],c.prototype,"mainLockfile",null),ve([n.$Jh],c.prototype,"disableUpdates",null),ve([n.$Jh],c.prototype,"crossOriginIsolated",null),ve([n.$Jh],c.prototype,"codeCachePath",null),ve([n.$Jh],c.prototype,"useCodeCache",null)}),define(ae[285],ce([0,1,87,33,13,9,4,19,21,198,18,24,34,16,5,197,30,99]),function(X,e,n,R,P,O,C,S,d,c,y,v,k,$,m,w,p,u){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$h_b=void 0;let h=class{static{f=this}static{this.a="backupWorkspaces"}constructor(a,t,o,r){this.j=a,this.k=t,this.l=o,this.m=r,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=S.$Jg,this.i={isEqual:(i,s)=>(0,R.$eg)(i,s,!C.$k)}}async initialize(){const a=this.m.getItem(f.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(a.emptyWindows),this.d=await this.u((0,c.$H$b)(a)),this.e=await this.v((0,c.$I$b)(a)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==$.$5k.OFF}q(){return this.s()===$.$5k.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||$.$5k.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(a,t){this.d.some(r=>a.workspace.id===r.workspace.id)||(this.d.push(a),this.C());const o=(0,O.$jc)(this.c,a.workspace.id);return t?this.t(o,t).then(()=>o):o}async t(a,t){if(await d.Promises.exists(a)&&await this.z(a),await d.Promises.exists(t))try{await d.Promises.rename(t,a,!1)}catch(o){this.l.error(`Backup: Could not move backup folder to new location: ${o.toString()}`)}}registerFolderBackup(a){return this.e.some(t=>this.h.isEqual(a.folderUri,t.folderUri))||(this.e.push(a),this.C()),(0,O.$jc)(this.c,this.D(a))}registerEmptyWindowBackup(a){return this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,a.backupFolder))||(this.g.push(a),this.C()),(0,O.$jc)(this.c,a.backupFolder)}async u(a){if(!Array.isArray(a))return[];const t=new Set,o=[];for(const r of a){const i=r.workspace;if(!(0,p.$ui)(i))return[];if(!t.has(i.id)){t.add(i.id);const s=(0,O.$jc)(this.c,i.id);await this.B(s)?i.configPath.scheme!==P.Schemas.file||await d.Promises.exists(i.configPath.fsPath)?o.push(r):await this.z(s):await this.x(s)}}return o}async v(a){if(!Array.isArray(a))return[];const t=[],o=new Set;for(const r of a){const i=r.folderUri,s=this.h.getComparisonKey(i);if(!o.has(s)){o.add(s);const l=(0,O.$jc)(this.c,this.D(r));await this.B(l)?i.scheme!==P.Schemas.file||await d.Promises.exists(i.fsPath)?t.push(r):await this.z(l):await this.x(l)}}return t}async w(a){if(!Array.isArray(a))return[];const t=[],o=new Set;for(const r of a){const i=r.backupFolder;if(typeof i!="string")return[];if(!o.has(i)){o.add(i);const s=(0,O.$jc)(this.c,i);await this.B(s)?t.push(r):await this.x(s)}}return t}async x(a){try{await d.Promises.rm(a,d.RimRafMode.MOVE)}catch(t){this.l.error(`Backup: Could not delete stale backup: ${t.toString()}`)}}y(){let a=(0,u.$1$b)();for(;this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,a.id));)a=(0,u.$1$b)();return{backupFolder:a.id}}async z(a){const t=this.y(),o=(0,O.$jc)(this.c,t.backupFolder);try{await d.Promises.rename(a,o,!1)}catch(r){return this.l.error(`Backup: Could not rename backup folder: ${r.toString()}`),!1}return this.g.push(t),!0}async getDirtyWorkspaces(){const a=[];for(const t of this.d)await this.A(t)&&a.push(t);for(const t of this.e)await this.A(t)&&a.push(t);return a}A(a){let t;return(0,c.$G$b)(a)?t=(0,O.$jc)(this.c,a.backupFolder):(0,w.$feb)(a)?t=(0,O.$jc)(this.c,this.D(a)):t=(0,O.$jc)(this.c,a.workspace.id),this.B(t)}async B(a){try{const t=await d.Promises.readdir(a);for(const o of t)try{if((await d.Promises.readdir((0,O.$jc)(a,o))).length>0)return!0}catch{}}catch{}return!1}C(){const a={workspaces:this.d.map(({workspace:t,remoteAuthority:o})=>{const r={id:t.id,configURIPath:t.configPath.toString()};return o&&(r.remoteAuthority=o),r}),folders:this.e.map(({folderUri:t,remoteAuthority:o})=>{const r={folderUri:t.toString()};return o&&(r.remoteAuthority=o),r}),emptyWindows:this.g.map(({backupFolder:t,remoteAuthority:o})=>{const r={backupFolder:t};return o&&(r.remoteAuthority=o),r})};this.m.setItem(f.a,a)}D(a){const t=a.folderUri;let o;return t.scheme===P.Schemas.file?o=C.$k?t.fsPath:t.fsPath.toLowerCase():o=t.toString().toLowerCase(),(0,n.createHash)("md5").update(o).digest("hex")}};e.$h_b=h,e.$h_b=h=f=ve([se(0,v.$E$b),se(1,y.$Li),se(2,m.$zj),se(3,k.$AP)],h)}),define(ae[20],ce([0,1,14,37,8,3,2,4,36,12,6,5,34,24]),function(X,e,n,R,P,O,C,S,d,c,y,v,k,$){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$0$b=e.LifecycleMainPhase=e.ShutdownReason=e.$9$b=void 0,e.$9$b=(0,y.$fi)("lifecycleMainService");var w;(function(f){f[f.QUIT=1]="QUIT",f[f.KILL=2]="KILL"})(w||(e.ShutdownReason=w={}));var p;(function(f){f[f.Starting=1]="Starting",f[f.Ready=2]="Ready",f[f.AfterWindowOpen=3]="AfterWindowOpen",f[f.Eventually=4]="Eventually"})(p||(e.LifecycleMainPhase=p={}));let u=class extends C.$Tc{static{m=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.j}get wasRestarted(){return this.m}get phase(){return this.n}constructor(h,g,a){super(),this.F=h,this.G=g,this.H=a,this.c=this.B(new O.$5d),this.onBeforeShutdown=this.c.event,this.f=this.B(new O.$5d),this.onWillShutdown=this.f.event,this.g=this.B(new O.$5d),this.onWillLoadWindow=this.g.event,this.h=this.B(new O.$5d),this.onBeforeCloseWindow=this.h.event,this.j=!1,this.m=!1,this.n=1,this.r=new Set,this.s=0,this.t=0,this.u=void 0,this.w=void 0,this.y=void 0,this.z=new Map,this.C=new Map,this.D=void 0,this.I(),this.when(2).then(()=>this.J())}I(){this.m=!!this.G.getItem(m.b),this.m&&this.G.removeItem(m.b)}J(){const h=()=>{this.j||(this.S("Lifecycle#app.on(before-quit)"),this.j=!0,this.S("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),S.$j&&this.t===0&&this.L(1))};n.app.addListener("before-quit",h);const g=()=>{this.S("Lifecycle#app.on(window-all-closed)"),(this.j||!S.$j)&&n.app.quit()};n.app.addListener("window-all-closed",g),n.app.once("will-quit",a=>{this.S("Lifecycle#app.on(will-quit) - begin"),a.preventDefault(),this.L(1).finally(()=>{this.S("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.O(!1),n.app.removeListener("before-quit",h),n.app.removeListener("window-all-closed",g),this.S("Lifecycle#app.on(will-quit) - calling app.quit()"),n.app.quit()})})}L(h){if(this.y)return this.y;const g=this.F;this.S("Lifecycle#onWillShutdown.fire()");const a=[];return this.f.fire({reason:h,join(t,o){g.trace(`Lifecycle#onWillShutdown - begin '${t}'`),a.push(o.finally(()=>{g.trace(`Lifecycle#onWillShutdown - end '${t}'`)}))}}),this.y=(async()=>{try{await P.Promises.settled(a)}catch(t){this.F.error(t)}try{await this.G.close()}catch(t){this.F.error(t)}})(),this.y}set phase(h){if(h<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.n===h)return;this.S(`lifecycle (main): phase changed (value: ${h})`),this.n=h;const g=this.C.get(this.n);g&&(g.open(),this.C.delete(this.n))}async when(h){if(h<=this.n)return;let g=this.C.get(h);g||(g=new P.$eh,this.C.set(h,g)),await g.wait()}registerWindow(h){const g=new C.$Sc;this.t++,g.add(h.onWillLoad(t=>this.g.fire({window:h,workspace:t.workspace,reason:t.reason})));const a=(0,c.$4f)(h.win);a.on("close",t=>{const o=h.id;if(this.r.has(o)){this.r.delete(o);return}this.S(`Lifecycle#window.on('close') - window ID ${h.id}`),t.preventDefault(),this.unload(h,1).then(r=>{if(r){this.r.delete(o);return}this.r.add(o),this.S(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${o}`),this.h.fire(h),h.close()})}),a.on("closed",()=>{this.S(`Lifecycle#window.on('closed') - window ID ${h.id}`),this.t--,g.dispose(),this.t===0&&(!S.$j||this.j)&&this.L(1)})}registerAuxWindow(h){const g=(0,c.$4f)(h.win);g.on("close",a=>{this.S(`Lifecycle#auxWindow.on('close') - window ID ${h.id}`),this.j&&(this.S("Lifecycle#auxWindow.on('close') - preventDefault() because quit requested"),a.preventDefault())}),g.on("closed",()=>{this.S(`Lifecycle#auxWindow.on('closed') - window ID ${h.id}`)})}async reload(h,g){await this.unload(h,3)||h.reload(g)}unload(h,g){const a=this.z.get(h.id);if(a)return a;const t=this.M(h,g).finally(()=>{this.z.delete(h.id)});return this.z.set(h.id,t),t}async M(h,g){if(!h.isReady)return!1;this.S(`Lifecycle#unload() - window ID ${h.id}`);const a=this.j?2:g,t=await this.P(h,a);return t?(this.S(`Lifecycle#unload() - veto in renderer (window ID ${h.id})`),this.N(t)):(await this.Q(h,a),!1)}N(h){return h?(this.O(!0),this.j=!1,!0):!1}O(h){this.w&&(this.w(h),this.w=void 0,this.u=void 0)}P(h,g){return new Promise(a=>{const t=this.s++,o=`vscode:ok${t}`,r=`vscode:cancel${t}`;R.$KV.once(o,()=>{a(!1)}),R.$KV.once(r,()=>{a(!0)}),h.send("vscode:onBeforeUnload",{okChannel:o,cancelChannel:r,reason:g})})}Q(h,g){return new Promise(a=>{const o=`vscode:reply${this.s++}`;R.$KV.once(o,()=>a()),h.send("vscode:onWillUnload",{replyChannel:o,reason:g})})}quit(h){return this.R(h).then(g=>{if(!g&&h)try{if(S.$i){const a=(0,d.cwd)();a!==process.cwd()&&process.chdir(a)}}catch(a){this.F.error(a)}return g})}R(h){return this.S(`Lifecycle#quit() - begin (willRestart: ${h})`),this.u?(this.S("Lifecycle#quit() - returning pending quit promise"),this.u):(h&&this.G.setItem(m.b,!0),this.u=new Promise(g=>{this.w=g,this.S("Lifecycle#quit() - calling app.quit()"),n.app.quit()}),this.u)}S(h){this.H.args["enable-smoke-test-driver"]?this.F.info(h):this.F.trace(h)}setRelaunchHandler(h){this.D=h}async relaunch(h){this.S("Lifecycle#relaunch()");const g=process.argv.slice(1);if(h?.addArgs&&g.push(...h.addArgs),h?.removeArgs)for(const o of h.removeArgs){const r=g.indexOf(o);r>=0&&g.splice(r,1)}const a=()=>{this.D?.handleRelaunch(h)||(this.S("Lifecycle#relaunch() - calling app.relaunch()"),n.app.relaunch({args:g}))};n.app.once("quit",a),await this.quit(!0)&&n.app.removeListener("quit",a)}async kill(h){this.S("Lifecycle#kill()"),await this.L(2),await Promise.race([(0,P.$gh)(1e3),(async()=>{for(const g of n.BrowserWindow.getAllWindows())if(g&&!g.isDestroyed()){let a;g.webContents&&!g.webContents.isDestroyed()?a=new Promise(t=>g.once("closed",t)):a=Promise.resolve(),g.destroy(),await a}})()]),n.app.exit(h)}};e.$0$b=u,e.$0$b=u=m=ve([se(0,v.$zj),se(1,k.$AP),se(2,$.$E$b)],u)}),define(ae[286],ce([0,1,4,3,2,6,20]),function(X,e,n,R,P,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F_b=e.$E_b=void 0,e.$E_b=(0,O.$fi)("keyboardLayoutMainService");let S=class extends P.$Tc{constructor(y){super(),this.a=this.B(new R.$5d),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,y.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const y=await new Promise((v,k)=>{X(["native-keymap"],v,k)});this.c=d(y),n.$t||y.onDidChangeKeyboardLayout(()=>{this.c=d(y),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$F_b=S,e.$F_b=S=ve([se(0,C.$9$b)],S);function d(c){const y=c.getKeyMap(),v=c.getCurrentKeyboardLayout();return{keyboardMapping:y,keyboardLayoutInfo:v}}}),define(ae[287],ce([0,1,248,8,17,15,12,18,38,95,5,53,247,284]),function(X,e,n,R,P,O,C,S,d,c,y,v,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cr=e.$Br=void 0;let m=class extends v.$wp{constructor(f,h,g,a){super(a),this.m=f,this.n=h,this.r=g,this.s(),this.B(f.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.s()}))}s(){const f=this.m.getValue("http");this.f=f?.proxy,this.g=!!f?.proxyStrictSSL,this.h=f?.proxyAuthorization}async request(f,h){const{f:g,g:a}=this;let t;try{t=await(0,c.$jm)(this.m,this.r,this.n.args,process.env)}catch(i){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,O.$0)(i)))}const o={...process.env,...t},r=f.agent?f.agent:await(0,k.$Ar)(f.url||"",o,{proxyUrl:g,strictSSL:a});return f.agent=r,f.strictSSL=a,this.h&&(f.headers={...f.headers||{},"Proxy-Authorization":this.h}),this.c(f.isChromiumNetwork?"electron":"node",f,()=>p(f,h))}async resolveProxy(f){}async loadCertificates(){return(await new Promise((h,g)=>{X(["@vscode/proxy-agent"],h,g)})).loadSystemCertificates({log:this.r})}};e.$Br=m,e.$Br=m=ve([se(0,S.$Li),se(1,d.$ni),se(2,y.$zj),se(3,y.$Aj)],m);async function w(u){return((0,n.parse)(u.url).protocol==="https:"?await new Promise((g,a)=>{X(["https"],g,a)}):await new Promise((g,a)=>{X(["http"],g,a)})).request}async function p(u,f){return R.Promises.withAsyncBody(async(h,g)=>{const a=(0,n.parse)(u.url),t=u.getRawRequest?u.getRawRequest(u):await w(u),o={hostname:a.hostname,port:a.port?parseInt(a.port):a.protocol==="https:"?443:80,protocol:a.protocol,path:a.path,method:u.type||"GET",headers:u.headers,agent:u.agent,rejectUnauthorized:(0,C.$Yf)(u.strictSSL)?u.strictSSL:!0};u.user&&u.password&&(o.auth=u.user+":"+u.password);const r=t(o,i=>{const s=(0,C.$Wf)(u.followRedirects)?u.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&s>0&&i.headers.location)p({...u,url:i.headers.location,followRedirects:s-1},f).then(h,g);else{let l=i;!u.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(l=i.pipe((0,$.createGunzip)())),h({res:i,stream:(0,P.$He)(l)})}});r.on("error",g),u.timeout&&r.setTimeout(u.timeout),u.isChromiumNetwork&&r.removeHeader("Content-Length"),u.data&&typeof u.data=="string"&&r.write(u.data),r.end(),f.onCancellationRequested(()=>{r.abort(),g(new O.$5)})})}e.$Cr=p}),define(ae[288],ce([0,1,14,287]),function(X,e,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hac=void 0;function P(C){return n.net.request}class O extends R.$Br{request(S,d){return super.request({...S||{},getRawRequest:P,isChromiumNetwork:!0},d)}}e.$Hac=O}),define(ae[83],ce([0,1,7,3,2,38,16,6,20,5,97,281,41,57,40,13]),function(X,e,n,R,P,O,C,S,d,c,y,v,k,$,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f_b=e.$e_b=e.$d_b=e.$c_b=void 0,e.$c_b=(0,S.$fi)("storageMainService");let p=class extends P.$Tc{constructor(h,g,a,t,o,r){super(),this.c=h,this.f=g,this.g=a,this.h=t,this.j=o,this.m=r,this.a=void 0,this.b=this.B(new R.$5d),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.B(this.s()),this.t=new Map,this.w=new Map,this.r()}n(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}r(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(h=>{h.window.profile&&this.profileStorage(h.window.profile).init(),h.workspace&&this.workspaceStorage(h.workspace).init()})),this.B(this.h.onWillShutdown(h=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=h.reason,h.join("applicationStorage",this.applicationStorage.close());for(const[,g]of this.t)h.join("profileStorage",g.close());for(const[,g]of this.w)h.join("workspaceStorage",g.close())})),this.B(this.g.onWillCreateProfile(h=>{h.join((async()=>{await this.j.exists(h.profile.globalStorageHome)||await this.j.createFolder(h.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(h=>{const g=this.t.get(h.profile.id);g&&h.join(g.close())}))}s(){this.c.trace("StorageMainService: creating application storage");const h=new v.$_$b(this.n(),this.g,this.c,this.j);return this.B(R.Event.once(h.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")})),h}profileStorage(h){if((0,y.$Lp)(h))return this.applicationStorage;let g=this.t.get(h.id);if(!g){this.c.trace(`StorageMainService: creating profile storage (${h.name})`),g=this.B(this.u(h)),this.t.set(h.id,g);const a=this.B(g.onDidChangeStorage(t=>this.b.fire({...t,storage:g,profile:h})));this.B(R.Event.once(g.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${h.name})`),this.t.delete(h.id),a.dispose()}))}return g}u(h){return this.a===2?new v.$b_b(this.c,this.j):new v.$$$b(h,this.n(),this.c,this.j)}workspaceStorage(h){let g=this.w.get(h.id);return g||(this.c.trace(`StorageMainService: creating workspace storage (${h.id})`),g=this.B(this.y(h)),this.w.set(h.id,g),this.B(R.Event.once(g.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${h.id})`),this.w.delete(h.id)}))),g}y(h){return this.a===2?new v.$b_b(this.c,this.j):new v.$a_b(h,this.n(),this.c,this.f,this.j)}isUsed(h){const g=n.URI.file(h);for(const a of[this.applicationStorage,...this.t.values(),...this.w.values()])if(a.path&&this.m.extUri.isEqualOrParent(n.URI.file(a.path),g))return!0;return!1}};e.$d_b=p,e.$d_b=p=ve([se(0,c.$zj),se(1,O.$mi),se(2,$.$S$b),se(3,d.$9$b),se(4,C.$Fk),se(5,m.$dl)],p),e.$e_b=(0,S.$fi)("applicationStorageMainService");let u=class extends y.$Kp{constructor(h,g){super(),this.s=h,this.U=g,this.whenReady=this.U.applicationStorage.whenInit}O(){return this.U.applicationStorage.whenInit}P(h){if(h===-1)return this.U.applicationStorage.storage}Q(h){if(h===-1)return this.s.defaultProfile.globalStorageHome.with({scheme:w.Schemas.file}).fsPath}r(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}R(){throw new Error("Switching storage profile is unsupported from main process")}S(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$f_b=u,e.$f_b=u=ve([se(0,k.$fl),se(1,e.$c_b)],u)}),define(ae[289],ce([0,1,88,26,106,100,8,2,4,18,5,27,243,244,96,129,17]),function(X,e,n,R,P,O,C,S,d,c,y,v,k,$,m,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gac=e.$Fac=e.$Eac=e.$Dac=void 0;async function u(t,o,r,i,s){let l;for(let b=3;b&&(l?.dispose(),l=await new f(t,o,r,i,s).waitForReady(),!(s&&P.$Eg[s]||!P.$Eg[l.tunnelLocalPort]));b--);return l}class f extends S.$Tc{constructor(o,r,i,s,l){super(),this.m=r,this.n=l,this.privacy=w.TunnelPrivacyId.Private,this.j=new Map,this.a=o,this.b=n.createServer(),this.c=new C.$eh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=b=>this.r(b),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=s,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(r=>{r()})}async waitForReady(){const o=this.n??this.tunnelRemotePort,r=(0,w.$Wv)(this.m)?"0.0.0.0":"127.0.0.1";let i=await(0,P.$Fg)(o,2,1e3,r),s=null;return this.b.listen(i,this.m),await this.c.wait(),s=this.b.address(),s||(i=0,this.b.listen(i,this.m),await this.c.wait(),s=this.b.address()),this.tunnelLocalPort=s.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${s.port}`,this}async r(o){o.pause();const r=(0,w.$Uv)(this.tunnelRemoteHost)||(0,w.$Wv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,k.$vl)(this.a,r,this.tunnelRemotePort),s=i.getSocket(),l=i.readEntireBuffer();i.dispose(),l.byteLength>0&&o.write(l.buffer),o.on("end",()=>{o.localAddress&&this.j.delete(o.localAddress),s.end()}),o.on("close",()=>s.end()),o.on("error",()=>{o.localAddress&&this.j.delete(o.localAddress),s instanceof O.$7h?s.socket.destroy():s.end()}),s instanceof O.$7h?this.t(o,s):this.s(o,s),o.localAddress&&this.j.set(o.localAddress,()=>{o.end(),s.end()})}s(o,r){r.onClose(()=>o.destroy()),r.onEnd(()=>o.end()),r.onData(i=>o.write(i.buffer)),o.on("data",i=>r.write(p.$se.wrap(i))),o.resume()}t(o,r){const i=r.socket;i.on("end",()=>o.end()),i.on("close",()=>o.end()),i.on("error",()=>{o.destroy()}),i.pipe(o),o.pipe(i)}}e.$Dac=f;let h=class extends w.$Zv{constructor(o,r,i,s,l){super(r,l),this.v=o,this.w=i,this.y=s}isPortPrivileged(o){return(0,w.$Xv)(o,this.m,d.OS,R.release())}t(o,r,i,s,l,b,D,j){const E=this.s(r,i);if(E)return++E.refcount,E.value;if((0,w.$Rv)(o))return this.u(o,r,i,l,b,D,j);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${r}:${i} on local port ${l}.`);const I={commit:this.y.commit,quality:this.y.quality,addressProvider:o,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},M=u(I,s,r,i,l);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(r,i,M),M}}};e.$Eac=h,e.$Eac=h=ve([se(0,$.$pl),se(1,y.$zj),se(2,m.$sl),se(3,v.$Rj),se(4,c.$Li)],h);let g=class extends h{constructor(o,r,i,s,l){super(o,r,i,s,l)}};e.$Fac=g,e.$Fac=g=ve([se(0,$.$pl),se(1,y.$zj),se(2,m.$sl),se(3,v.$Rj),se(4,c.$Li)],g);let a=class extends S.$Tc{constructor(o,r,i,s,l){super(),this.b=o,this.c=r,this.f=i,this.g=s,this.h=l,this.a=new Map}async openTunnel(o,r,i,s,l,b,D,j,E){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${s} on local port ${b}.`),!this.a.has(o)){const I=new g(this.b,this.c,this.g,this.f,this.h);this.B(I),this.a.set(o,I),I.onTunnelClosed(async()=>{(await I.tunnels).length===0&&(I.dispose(),this.a.delete(o))})}return this.a.get(o).openTunnel(r,i,s,l,b,D,j,E)}};e.$Gac=a,e.$Gac=a=ve([se(0,$.$pl),se(1,y.$zj),se(2,v.$Rj),se(3,m.$sl),se(4,c.$Li)],a)}),define(ae[101],ce([0,1,8,23,3,18,24,20,5,27,53,49]),function(X,e,n,R,P,O,C,S,d,c,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3_b=e.$2_b=void 0;function k(m,w,p){return`${p.updateUrl}/api/update/${m}/${w}/${p.commit}`}e.$2_b=k;let $=class{get state(){return this.b}d(w){this.j.info("update#setState",w.type),this.b=w,this.c.fire(w)}constructor(w,p,u,f,h,g){this.f=w,this.g=p,this.h=u,this.i=f,this.j=h,this.k=g,this.b=v.$IW.Uninitialized,this.c=new P.$5d,this.onStateChange=this.c.event,w.when(3).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(v.$IW.Disabled(0));return}if(this.h.disableUpdates){this.d(v.$IW.Disabled(1)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(v.$IW.Disabled(3)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const w=this.g.getValue("update.mode"),p=this.m(w);if(!p){this.d(v.$IW.Disabled(2)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(p),!this.a){this.d(v.$IW.Disabled(4)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.g.getValue("_update.prss")){const u=new URL(this.a);u.searchParams.set("prss","true"),this.a=u.toString()}if(this.d(v.$IW.Idle(this.q())),w==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}w==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,u=>this.j.error(u))}m(w){return w==="none"?void 0:this.k.quality}n(w=60*60*1e3){return(0,n.$gh)(w).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(w){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(w)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(w){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(w=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},R.CancellationToken.None)).res.statusCode===204}catch(p){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(p);return}}async _applySpecificUpdate(w){}q(){return 1}r(){}};e.$3_b=$,e.$3_b=$=ve([se(0,S.$9$b),se(1,O.$Li),se(2,C.$E$b),se(3,y.$vp),se(4,d.$zj),se(5,c.$Rj)],$)}),define(ae[290],ce([0,1,14,50,3,45,2,18,24,20,5,27,53,28,49,101]),function(X,e,n,R,P,O,C,S,d,c,y,v,k,$,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4_b=void 0;let p=class extends w.$3_b{get v(){return P.Event.fromNodeEventEmitter(n.autoUpdater,"error",(f,h)=>h)}get w(){return P.Event.fromNodeEventEmitter(n.autoUpdater,"update-not-available")}get x(){return P.Event.fromNodeEventEmitter(n.autoUpdater,"update-available",(f,h,g)=>({url:h,version:g,productVersion:g}))}get y(){return P.Event.fromNodeEventEmitter(n.autoUpdater,"update-downloaded",(f,h,g,a)=>({releaseNotes:h,version:g,productVersion:g,date:a}))}constructor(f,h,g,a,t,o,r){super(f,h,a,t,o,r),this.z=g,this.u=new C.$Sc,f.setRelaunchHandler(this)}handleRelaunch(f){return f?.addArgs||f?.removeArgs||this.state.type!=="ready"?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B(f){this.z.publicLog2("update:error",{messageHash:String((0,O.$6i)(String(f)))}),this.j.error("UpdateService error:",f);const h=this.state.type==="checking for updates"&&this.state.explicit?f:void 0;this.d(m.$IW.Idle(1,h))}s(f){let h;this.k.darwinUniversalAssetId?h=this.k.darwinUniversalAssetId:h=process.arch==="x64"?"darwin":"darwin-arm64";const g=(0,w.$2_b)(h,f,this.k);try{n.autoUpdater.setFeedURL({url:g})}catch(a){this.j.error("Failed to set update feed URL",a);return}return g}t(f){this.d(m.$IW.CheckingForUpdates(f)),n.autoUpdater.checkForUpdates()}E(f){this.state.type==="checking for updates"&&this.d(m.$IW.Downloading(f))}F(f){this.state.type==="downloading"&&(this.z.publicLog2("update:downloaded",{version:f.version}),this.d(m.$IW.Ready(f)))}G(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(m.$IW.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),n.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$4_b=p,ve([R.$Jh],p.prototype,"v",null),ve([R.$Jh],p.prototype,"w",null),ve([R.$Jh],p.prototype,"x",null),ve([R.$Jh],p.prototype,"y",null),e.$4_b=p=ve([se(0,c.$9$b),se(1,S.$Li),se(2,$.$El),se(3,d.$E$b),se(4,k.$vp),se(5,y.$zj),se(6,v.$Rj)],p)}),define(ae[291],ce([0,1,48,46,8,3,9,24,20,5,28,49]),function(X,e,n,R,P,O,C,S,d,c,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6_b=void 0;let k=class{get state(){return this.a}d(w){this.g.info("update#setState",w.type),this.a=w,this.b.fire(w)}constructor(w,p,u){if(this.f=w,this.g=u,this.a=v.$IW.Uninitialized,this.b=new O.$5d,this.onStateChange=this.b.event,p.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(v.$IW.Idle(this.k())),this.h(30*1e3).then(void 0,f=>this.g.error(f))}h(w=60*60*1e3){return(0,P.$gh)(w).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(w){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(w)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(w){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(w=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(w){}};k=ve([se(0,d.$9$b),se(1,S.$E$b),se(2,c.$zj)],k);let $=class extends k{constructor(w,p,u,f,h,g){super(u,f,h),this.o=w,this.p=p,this.q=g;const a=(0,R.watch)(C.$mc(this.o)),t=O.Event.fromNodeEventEmitter(a,"change",(s,l)=>l),o=O.Event.filter(t,s=>s==="current"),i=O.Event.debounce(o,(s,l)=>l,2e3)(()=>this.checkForUpdates(!1));u.onWillShutdown(()=>{i.dispose(),a.close()})}m(){this.d(v.$IW.CheckingForUpdates(!1)),this.u().then(w=>{w?this.d(v.$IW.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(v.$IW.Idle(2)))},w=>{this.g.error(w),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(v.$IW.Idle(2,w.message||w))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,n.spawn)("sleep 3 && "+C.$nc(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const w=await new Promise((u,f)=>(0,R.realpath)(`${C.$mc(this.o)}/current`,(h,g)=>h?f(h):u(g))),p=C.$nc(w);return this.p!==p}isLatestVersion(){return this.u().then(void 0,w=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$6_b=$,e.$6_b=$=ve([se(2,d.$9$b),se(3,S.$E$b),se(4,c.$zj),se(5,y.$El)],$)}),define(ae[29],ce([0,1,14,4,6,81,55,69,27,18,24,9,138]),function(X,e,n,R,P,O,C,S,d,c,y,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowStateValidator=e.$R$b=e.$Q$b=e.OpenContext=e.$P$b=void 0,e.$P$b=(0,P.$fi)("windowsMainService");var $;(function(u){u[u.CLI=0]="CLI",u[u.DOCK=1]="DOCK",u[u.MENU=2]="MENU",u[u.DIALOG=3]="DIALOG",u[u.DESKTOP=4]="DESKTOP",u[u.API=5]="API"})($||(e.OpenContext=$={}));function m(u,f,h){const g=u.get(S.$N$b),a=u.get(d.$Rj),t=u.get(c.$Li),o=u.get(y.$E$b),r=t.getValue("window"),i={backgroundColor:g.getBackgroundColor(),minWidth:C.$3C.WIDTH,minHeight:C.$3C.HEIGHT,title:a.nameLong,...h,x:f.x,y:f.y,width:f.width,height:f.height,webPreferences:{enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,C.$bD)(f.zoomLevel??r?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...h?.webPreferences,sandbox:!0},experimentalDarkMode:!0};if(R.$k?i.icon=(0,v.$jc)(o.appRoot,"resources/linux/code.png"):R.$i&&!o.isBuilt&&(i.icon=(0,v.$jc)(o.appRoot,"resources/win32/code_150x150.png")),R.$j&&(i.acceptFirstMouse=!0,r?.clickThroughInactive===!1&&(i.acceptFirstMouse=!1)),R.$j&&!(0,C.$aD)(t)&&(i.fullscreenable=!1),R.$j&&r?.nativeTabs===!0&&(i.tabbingIdentifier=a.nameShort),!(0,C.$0C)(t)&&(i.titleBarStyle="hidden",R.$j||(i.frame=!1),(0,C.$_C)(t))){const b=g.getWindowSplash()?.colorInfo.titleBarBackground??g.getBackgroundColor(),D=k.$At.fromHex(b).isDarker()?"#FFFFFF":"#000000";i.titleBarOverlay={height:29,color:b,symbolColor:D}}return i}e.$Q$b=m;function w(u){let f,h=Number.MIN_VALUE;for(const g of u)g.lastFocusTime>h&&(h=g.lastFocusTime,f=g);return f}e.$R$b=w;var p;(function(u){function f(g,a,t=n.screen.getAllDisplays()){if(g.trace(`window#validateWindowState: validating window state on ${t.length} display(s)`,a),typeof a.x!="number"||typeof a.y!="number"||typeof a.width!="number"||typeof a.height!="number"){g.trace("window#validateWindowState: unexpected type of state values");return}if(a.width<=0||a.height<=0){g.trace("window#validateWindowState: unexpected negative values");return}if(t.length===1){const i=h(t[0]);if(g.trace("window#validateWindowState: single monitor working area",i),i){let s=function(){!a||typeof a.x!="number"||typeof a.y!="number"||!i||(a.x<i.x&&(a.x=i.x),a.y<i.y&&(a.y=i.y))};s(),a.width>i.width&&(a.width=i.width),a.height>i.height&&(a.height=i.height),a.x>i.x+i.width-128&&(a.x=i.x+i.width-a.width),a.y>i.y+i.height-128&&(a.y=i.y+i.height-a.height),s()}return a}if(a.display&&a.mode===3){const i=t.find(s=>s.id===a.display);if(i&&typeof i.bounds?.x=="number"&&typeof i.bounds?.y=="number"){g.trace("window#validateWindowState: restoring fullscreen to previous display");const s=(0,O.$C$b)(3);return s.x=i.bounds.x,s.y=i.bounds.y,s}}let o,r;try{o=n.screen.getDisplayMatching({x:a.x,y:a.y,width:a.width,height:a.height}),r=h(o),g.trace("window#validateWindowState: multi-monitor working area",r)}catch(i){g.error("window#validateWindowState: error finding display for window state",i)}if(o&&r&&a.x+a.width>r.x&&a.y+a.height>r.y&&a.x<r.x+r.width&&a.y<r.y+r.height)return a;g.trace("window#validateWindowState: state is outside of the multi-monitor working area")}u.validateWindowState=f;function h(g){if(g.workArea.width>0&&g.workArea.height>0)return g.workArea;if(g.bounds.width>0&&g.bounds.height>0)return g.bounds}})(p||(e.WindowStateValidator=p={}))}),define(ae[292],ce([0,1,14,23,3,45,2,32,119,5,83,29]),function(X,e,n,R,P,O,C,S,d,c,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g_b=void 0;var k;(function(m){m[m.Initial=1]="Initial",m[m.StoredCredentialsUsed=2]="StoredCredentialsUsed",m[m.LoginDialogShown=3]="LoginDialogShown"})(k||(k={}));let $=class extends C.$Tc{constructor(w,p,u,f){super(),this.g=w,this.h=p,this.j=u,this.m=f,this.a="proxy-credentials://",this.b=void 0,this.c=k.Initial,this.f=void 0,this.n()}n(){const w=P.Event.fromNodeEventEmitter(n.app,"login",(p,u,f,h,g)=>({event:p,webContents:u,req:f,authInfo:h,callback:g}));this.B(w(this.r,this))}async r({event:w,authInfo:p,req:u,callback:f}){if(!p.isProxy)return;if(!this.b&&this.c===k.LoginDialogShown&&u.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}w.preventDefault();let h;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),h=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.s(p);try{h=await this.b}finally{this.b=void 0}}f(h?.username,h?.password)}async s(w){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const p=await this.t(w);if(p)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),p;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async t(w){this.g.trace("auth#doResolveProxyCredentials - enter",w);const p=String((0,O.$6i)({scheme:w.scheme,host:w.host,port:w.port}));let u,f;try{const t=this.m.get(this.a+p,-1);if(t){const o=JSON.parse(await this.j.decrypt(t));u=o.username,f=o.password}}catch(t){this.g.error(t)}if(this.c!==k.StoredCredentialsUsed&&typeof u=="string"&&typeof f=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=k.StoredCredentialsUsed,{username:u,password:f};const h=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!h){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${h.id} to handle proxy login`);const g={authInfo:w,username:this.f?.username??u,password:this.f?.password??f,replyChannel:`vscode:proxyAuthResponse:${(0,S.$Bg)()}`};h.sendWhenReady("vscode:openProxyAuthenticationDialog",R.CancellationToken.None,g),this.c=k.LoginDialogShown;const a=await new Promise(t=>{const o=async(r,i,s)=>{if(i===g.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${h.id}`),h.win?.webContents.off("ipc-message",o),s){const l={username:s.username,password:s.password};try{if(s.remember){const b=await this.j.encrypt(JSON.stringify(l));this.m.store(this.a+p,b,-1,1)}else this.m.remove(this.a+p,-1)}catch(b){this.g.error(b)}t({username:l.username,password:l.password})}else t(void 0)};h.win?.webContents.on("ipc-message",o)});return this.f=a,a}};e.$g_b=$,e.$g_b=$=ve([se(0,c.$zj),se(1,v.$P$b),se(2,d.$tW),se(3,y.$e_b)],$)}),define(ae[293],ce([0,1,14,22,4,7,21,18,63,6,5,130,29]),function(X,e,n,R,P,O,C,S,d,c,y,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I_b=e.$H_b=e.ID=void 0,e.ID="launchMainService",e.$H_b=(0,c.$fi)(e.ID);let $=class{constructor(w,p,u,f){this.a=w,this.b=p,this.c=u,this.d=f}async start(w,p){this.a.trace("Received data from other instance: ",w,p),P.$j&&n.app.focus({steal:!0});const u=this.e(w);if(u.length){let f=Promise.resolve();if(this.b.getWindowCount()===0){const h=(0,R.$Ob)(await this.b.openEmptyWindow({context:4}));h&&(f=h.ready())}f.then(()=>{for(const{uri:h,originalUrl:g}of u)this.c.open(h,{originalUrl:g})})}else return this.f(w,p)}e(w){return w["open-url"]&&w._urls&&w._urls.length>0?(0,R.$Hb)(w._urls.map(p=>{try{return{uri:O.URI.parse(p),originalUrl:p}}catch{return null}})):[]}async f(w,p){const u=(0,d.$dm)(p)?0:4;let f=[];const h=w.wait&&w.waitMarkerFilePath?O.URI.file(w.waitMarkerFilePath):void 0,g=w.remote||void 0,a={context:u,cli:w,userEnv:w["preserve-env"]||u===0?p:void 0,waitMarkerFileURI:h,remoteAuthority:g,forceProfile:w.profile,forceTempProfile:w["profile-temp"]};if(w.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(w.extensionDevelopmentPath,a);else if(!w._.length&&!w["folder-uri"]&&!w["file-uri"]){let t=!1;if(w["new-window"]||w["unity-launch"]||a.forceProfile||a.forceTempProfile)t=!0;else if(w["reuse-window"])t=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!P.$j}if(t)f=await this.b.open({...a,forceNewWindow:!0,forceEmpty:!0});else{const o=this.b.getLastActiveWindow();o?(this.b.openExistingWindow(o,a),f=[o]):f=await this.b.open({...a,forceEmpty:!0})}}else f=await this.b.open({...a,forceNewWindow:w["new-window"],preferNewWindow:!w["reuse-window"]&&!w.wait,forceReuseWindow:w["reuse-window"],diffMode:w.diff,mergeMode:w.merge,addMode:w.add,noRecentEntry:!!w["skip-add-to-recently-opened"],gotoLineMode:w.goto});if(h&&f.length===1&&f[0])return Promise.race([f[0].whenClosedOrLoaded,(0,C.whenDeleted)(h.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$I_b=$,e.$I_b=$=ve([se(0,y.$zj),se(1,k.$P$b),se(2,v.$zW),se(3,S.$Li)],$)}),define(ae[294],ce([0,1,2,20,57,30,8,29]),function(X,e,n,R,P,O,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lac=void 0;let d=class extends n.$Tc{constructor(y,v,k){super(),this.a=v,this.b=k,this.B(y.onWillLoadWindow($=>{$.reason===2&&this.c($.window)})),this.B(y.onBeforeCloseWindow($=>this.c($))),this.B(new C.$rh(()=>this.g(),30*1e3)).schedule()}async c(y){const v=this.f(y),k=this.a.getProfileForWorkspace(v);k?.isTransient&&(this.a.unsetWorkspace(v,k.isTransient),k.isTransient&&await this.a.cleanUpTransientProfiles())}f(y){return y.openedWorkspace??(0,O.$ti)(y.backupPath,y.isExtensionDevelopmentHost)}g(){const y=this.a.getAssociatedEmptyWindows();if(y.length===0)return;const v=this.b.getWindows().map(k=>this.f(k));for(const k of y)v.some($=>$.id===k.id)||this.a.unsetWorkspace(k,!1)}};e.$lac=d,e.$lac=d=ve([se(0,R.$9$b),se(1,P.$S$b),se(2,S.$P$b)],d)}),define(ae[60],ce([0,1,14,2,3,5,314,8,13,29,73,28,20,75,35,4,133]),function(X,e,n,R,P,O,C,S,d,c,y,v,k,$,m,w,p){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$k_b=e.$j_b=void 0;function f(a){return typeof a.responseWindowId=="number"}let h=class extends R.$Tc{static{u=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from(u.b.values())}constructor(t,o,r){super(),this.u=t,this.w=o,this.y=r,this.c=String(++u.a),this.f=this.B(new P.$5d),this.onStdout=this.f.event,this.g=this.B(new P.$5d),this.onStderr=this.g.event,this.h=this.B(new P.$5d),this.onMessage=this.h.event,this.j=this.B(new P.$5d),this.onSpawn=this.j.event,this.m=this.B(new P.$5d),this.onExit=this.m.event,this.n=this.B(new P.$5d),this.onCrash=this.n.event,this.r=void 0,this.s=void 0,this.t=void 0}z(t,o){let r;switch(this.t?.correlationId?r=`[UtilityProcess id: ${this.t?.correlationId}, type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${t}`:r=`[UtilityProcess type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${t}`,o){case y.default.Error:this.u.error(r);break;case y.default.Warning:this.u.warn(r);break;case y.default.Info:this.u.trace(r);break}}C(){return this.r?(this.z("Cannot start utility process because it is already running...",y.default.Error),!1):!0}start(t){const o=this.D(t);return o&&t.payload&&this.postMessage(t.payload),o}D(t){if(!this.C())return!1;this.t=t;const o=`${this.t.type}-${this.c}`,r=d.$zg.asFileUri("bootstrap-fork.js").fsPath,i=this.t.args??[],s=this.t.execArgv??[],l=this.t.allowLoadingUnsignedLibraries,b=this.t.forceAllocationsToV8Sandbox,D="pipe",j=this.F(t);return this.z("creating new...",y.default.Info),this.r=n.utilityProcess.fork(r,i,{serviceName:o,env:j,execArgv:s,allowLoadingUnsignedLibraries:l,forceAllocationsToV8Sandbox:b,stdio:D}),this.G(this.r,this.t,o),!0}F(t){const o=t.env?{...t.env}:{...(0,m.$Kn)(process.env)};o.VSCODE_AMD_ENTRYPOINT=t.entryPoint,typeof t.parentLifecycleBound=="number"&&(o.VSCODE_PARENT_PID=String(t.parentLifecycleBound)),o.VSCODE_CRASH_REPORTER_PROCESS_TYPE=t.type,w.$i&&((0,p.isUNCAccessRestrictionsDisabled)()?o.NODE_DISABLE_UNC_ACCESS_CHECKS="1":o.NODE_UNC_HOST_ALLOWLIST=(0,p.getUNCHostAllowlist)().join("\\")),(0,$.$3l)(o);for(const r of Object.keys(o))o[r]=String(o[r]);return o}G(t,o,r){if(t.stdout){const i=new C.StringDecoder("utf-8");this.B(P.Event.fromNodeEventEmitter(t.stdout,"data")(s=>this.f.fire(typeof s=="string"?s:i.write(s))))}if(t.stderr){const i=new C.StringDecoder("utf-8");this.B(P.Event.fromNodeEventEmitter(t.stderr,"data")(s=>this.g.fire(typeof s=="string"?s:i.write(s))))}this.B(P.Event.fromNodeEventEmitter(t,"message")(i=>this.h.fire(i))),this.B(P.Event.fromNodeEventEmitter(t,"spawn")(()=>{this.s=t.pid,typeof t.pid=="number"&&u.b.set(t.pid,{pid:t.pid,name:f(o)?`${o.type} [${o.responseWindowId}]`:o.type}),this.z("successfully created",y.default.Info),this.j.fire(t.pid)})),this.B(P.Event.fromNodeEventEmitter(t,"exit")(i=>{this.z(`received exit event with code ${i}`,y.default.Info),this.m.fire({pid:this.s,code:i,signal:"unknown"}),this.H()})),this.B(P.Event.fromNodeEventEmitter(n.app,"child-process-gone",(i,s)=>({event:i,details:s}))(({details:i})=>{i.type==="Utility"&&i.name===r&&(this.z(`crashed with code ${i.exitCode} and reason '${i.reason}'`,y.default.Error),this.w.publicLog2("utilityprocesscrash",{type:o.type,reason:i.reason,code:i.exitCode}),this.n.fire({pid:this.s,code:i.exitCode,reason:i.reason}),this.H())}))}once(t,o){const r=this.B(this.h.event(i=>{i===t&&(r.dispose(),o())}))}postMessage(t,o){this.r&&this.r.postMessage(t,o)}connect(t){const{port1:o,port2:r}=new n.MessageChannelMain;return this.postMessage(t,[r]),o}enableInspectPort(){if(!this.r||typeof this.s!="number")return!1;this.z("enabling inspect port",y.default.Info);const t=process;return typeof t._debugProcess=="function"?(t._debugProcess(this.s),!0):!1}kill(){if(!this.r)return;this.z("attempting to kill the process...",y.default.Info),this.r.kill()?(this.z("successfully killed the process",y.default.Info),this.H()):this.z("unable to kill the process",y.default.Warning)}H(){typeof this.s=="number"&&u.b.delete(this.s),this.r=void 0}async waitForExit(t){this.r&&(this.z("waiting to exit...",y.default.Info),await Promise.race([P.Event.toPromise(this.onExit),(0,S.$gh)(t)]),this.r&&(this.z(`did not exit within ${t}ms, will kill it now...`,y.default.Info),this.kill()))}};e.$j_b=h,e.$j_b=h=u=ve([se(0,O.$zj),se(1,v.$El),se(2,k.$9$b)],h);let g=class extends h{constructor(t,o,r,i){super(t,r,i),this.I=o}start(t){const o=this.I.getWindowById(t.responseWindowId);if(!o?.win||o.win.isDestroyed()||o.win.webContents.isDestroyed())return this.z("Refusing to start utility process because requesting window cannot be found or is destroyed...",y.default.Error),!0;if(!super.D(t))return!1;this.J(o.win,t);const i=this.connect(t.payload);return o.win.webContents.postMessage(t.responseChannel,t.responseNonce,[i]),!0}J(t,o){o.windowLifecycleBound&&(this.B(P.Event.filter(this.y.onWillLoadWindow,r=>r.window.win===t)(()=>this.kill())),this.B(P.Event.fromNodeEventEmitter(t,"closed")(()=>this.kill())))}};e.$k_b=g,e.$k_b=g=ve([se(0,O.$zj),se(1,c.$P$b),se(2,v.$El),se(3,k.$9$b)],g)}),define(ae[295],ce([0,1,15,3,5,20,8,60,29,28]),function(X,e,n,R,P,O,C,S,d,c){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$r_b=void 0;let v=class{static{y=this}static{this.a=0}constructor($,m,w,p){this.d=$,this.f=m,this.g=w,this.h=p,this.b=new Map,this.c=!1,this.f.onWillShutdown(u=>{this.c=!0,u.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}i($){const m=this.b.get($);if(!m)throw new Error("Unknown extension host!");return m}onDynamicStdout($){return this.i($).onStdout}onDynamicStderr($){return this.i($).onStderr}onDynamicMessage($){return this.i($).onMessage}onDynamicExit($){return this.i($).onExit}async createExtensionHost(){if(this.c)throw(0,n.$6)();const $=String(++y.a),m=new S.$k_b(this.d,this.g,this.h,this.f);return this.b.set($,m),m.onExit(({pid:w,code:p,signal:u})=>{this.d.info(`Extension host with pid ${w} exited with code: ${p}, signal: ${u}.`),setTimeout(()=>{m.dispose(),this.b.delete($)}),setTimeout(()=>{try{process.kill(w,0),this.d.error(`Extension host with pid ${w} still exists, forcefully killing it...`),process.kill(w)}catch{}},1e3)}),{id:$}}async start($,m){if(this.c)throw(0,n.$6)();const w=this.i($);return w.start({...m,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:m.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:$}),{pid:await R.Event.toPromise(w.onSpawn)}}async enableInspectPort($){if(this.c)throw(0,n.$6)();const m=this.b.get($);return m?m.enableInspectPort():!1}async kill($){if(this.c)throw(0,n.$6)();const m=this.b.get($);m&&m.kill()}async _killAllNow(){for(const[,$]of this.b)$.kill()}async _waitForAllExit($){const m=[];for(const[,w]of this.b)m.push(w.waitForExit($));return C.Promises.settled(m).then(()=>{})}};e.$r_b=v,e.$r_b=v=y=ve([se(0,P.$zj),se(1,O.$9$b),se(2,d.$P$b),se(3,c.$El)],v)}),define(ae[296],ce([0,1,37,8,2,24,20,5,41,39,67,60,54,91,12,249]),function(X,e,n,R,P,O,C,S,d,c,y,v,k,$,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V_b=void 0;let p=class extends P.$Tc{constructor(f,h,g,a,t,o,r,i){super(),this.c=f,this.f=h,this.g=g,this.h=a,this.j=t,this.m=o,this.n=r,this.r=i,this.a=new R.$eh,this.b=void 0,this.w=void 0,this.y=void 0,this.s()}s(){n.$KV.on(w.$T_b.request,(f,h)=>this.t(f,h,w.$T_b.response)),n.$KV.on(w.$U_b.request,(f,h)=>this.t(f,h,w.$U_b.response)),this.B(this.j.onWillShutdown(()=>this.u()))}async t(f,h,g){this.m.trace(`[SharedProcess] onWindowConnection for: ${g}`),this.a.isOpen()||this.a.open(),await this.whenReady();const a=await this.connect(g);if(f.sender.isDestroyed())return a.close();f.sender.postMessage(g,h,[a])}u(){this.m.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage(w.$S_b.exit),this.b=void 0}whenReady(){return this.w||(this.w=(async()=>{await this.z;const f=new R.$Ch;this.b?this.b.once(w.$S_b.initDone,()=>f.complete()):n.$KV.once(w.$S_b.initDone,()=>f.complete()),await f.p,this.m.trace("[SharedProcess] Overall ready")})()),this.w}get z(){return this.y||(this.y=(async()=>{await this.a.wait(),this.C();const f=new R.$Ch;this.b?this.b.once(w.$S_b.ipcReady,()=>f.complete()):n.$KV.once(w.$S_b.ipcReady,()=>f.complete()),await f.p,this.m.trace("[SharedProcess] IPC ready")})()),this.y}C(){this.b=this.B(new v.$j_b(this.m,k.$2o,this.j));const f=(0,$.$Sm)(this.g.args,this.g.isBuilt);let h;f.port&&(h=["--nolazy"],f.break?h.push(`--inspect-brk=${f.port}`):h.push(`--inspect=${f.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.D(),execArgv:h})}D(){return{machineId:this.c,sqmId:this.f,codeCachePath:this.g.codeCachePath,profiles:{home:this.h.profilesHome,all:this.h.profiles},args:this.g.args,logLevel:this.n.getLogLevel(),loggers:this.n.getRegisteredLoggers(),policiesData:this.r.serialize()}}async connect(f){return await this.z,(0,m.$4f)(this.b).connect(f)}};e.$V_b=p,e.$V_b=p=ve([se(2,O.$E$b),se(3,d.$fl),se(4,C.$9$b),se(5,S.$zj),se(6,y.$4$b),se(7,c.$Yn)],p)}),define(ae[297],ce([0,1,24,91,20,5,54,60,113,37,2,3,35,18,13]),function(X,e,n,R,P,O,C,S,d,c,y,v,k,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vac=void 0;let w=class extends y.$Tc{constructor(u,f,h,g,a){super(),this.f=u,this.g=f,this.h=h,this.j=g,this.m=a,this.a=void 0,this.b=new v.$5d,this.onRequestConnection=this.b.event,this.c=new v.$5d,this.onWillShutdown=this.c.event,this.j.onWillShutdown(()=>this.c.fire()),c.$KV.on("vscode:createPtyHostMessageChannel",(t,o)=>this.r(t,o)),this.B((0,y.$Rc)(()=>{c.$KV.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new S.$j_b(this.m,C.$2o,this.j);const u=(0,R.$Rm)(this.h.args,this.h.isBuilt),f=u.port?["--nolazy",`--inspect${u.break?"-brk":""}=${u.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:f,args:["--logsPath",this.h.logsHome.with({scheme:m.Schemas.file}).fsPath],env:this.n()});const h=this.a.connect(),g=new d.$SV(h,"ptyHost"),a=new y.$Sc;return a.add(g),a.add((0,y.$Rc)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:g,store:a,onDidProcessExit:this.a.onExit}}n(){this.h.unsetSnapExportedVariables();const u={...(0,k.$Kn)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},f=this.g.getValue("terminal.integrated.developer.ptyHost.latency");f&&typeof f=="number"&&(u.VSCODE_LATENCY=String(f));const h=this.g.getValue("terminal.integrated.developer.ptyHost.startupDelay");return h&&typeof h=="number"&&(u.VSCODE_STARTUP_DELAY=String(h)),this.h.restoreSnapExportedVariables(),u}r(u,f){this.b.fire();const h=this.a.connect();if(u.sender.isDestroyed()){h.close();return}u.sender.postMessage("vscode:createPtyHostMessageChannelResult",f,[h])}};e.$vac=w,e.$vac=w=ve([se(1,$.$Li),se(2,n.$E$b),se(3,P.$9$b),se(4,O.$zj)],w)}),define(ae[298],ce([0,1,2,6,5,29,60,28,45,3,8,20]),function(X,e,n,R,P,O,C,S,d,c,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uac=e.$tac=void 0,e.$tac=(0,R.$fi)("utilityProcessWorker");let k=class extends n.$Tc{constructor(w,p,u,f){super(),this.b=w,this.c=p,this.f=u,this.g=f,this.a=new Map}async createWorker(w){const p=`window: ${w.reply.windowId}, moduleId: ${w.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${p})`);const u=this.h(w);this.a.has(u)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${p})`),this.disposeWorker(w));const f=new $(this.b,this.c,this.f,this.g,w);if(!f.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set(u,f);const h=new y.$Ch;return c.Event.once(f.onDidTerminate)(g=>{g.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${g.code}, signal: ${g.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${g.code}, signal: ${g.signal}`),this.a.delete(u),h.complete({reason:g})}),h.p}h(w){return(0,d.$6i)({moduleId:w.process.moduleId,windowId:w.reply.windowId})}async disposeWorker(w){const p=this.h(w),u=this.a.get(p);u&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${w.reply.windowId}, moduleId: ${w.process.moduleId})`),u.kill(),this.a.delete(p))}};e.$uac=k,e.$uac=k=ve([se(0,P.$zj),se(1,O.$P$b),se(2,S.$El),se(3,v.$9$b)],k);let $=class extends n.$Tc{constructor(w,p,u,f,h){super(),this.c=w,this.f=p,this.g=u,this.h=f,this.j=h,this.a=this.B(new c.$5d),this.onDidTerminate=this.a.event,this.b=new C.$k_b(this.c,this.f,this.g,this.h),this.m()}m(){this.B(this.b.onExit(w=>this.a.fire({code:w.code,signal:w.signal}))),this.B(this.b.onCrash(w=>this.a.fire({code:w.code,signal:"ECRASH"})))}spawn(){const p=this.f.getWindowById(this.j.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.j.process.type,entryPoint:this.j.process.moduleId,parentLifecycleBound:p,windowLifecycleBound:!0,correlationId:`${this.j.reply.windowId}`,responseWindowId:this.j.reply.windowId,responseChannel:this.j.reply.channel,responseNonce:this.j.reply.nonce})}kill(){this.b.kill()}};$=ve([se(0,P.$zj),se(1,O.$P$b),se(2,S.$El),se(3,v.$9$b)],$)}),define(ae[299],ce([0,1,14,3,2,275,29]),function(X,e,n,R,P,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bac=void 0;let S=class extends P.$Tc{constructor(c){super(),this.b=c,this.a=this.B(new R.$5d),this.onFoundInFrame=this.a.event,this.B(new O.$aac)}async setIgnoreMenuShortcuts(c,y){let v;if(typeof c.windowId=="number"){const{windowId:k}=c,$=this.b.getWindowById(k);if(!$?.win)throw new Error(`Invalid windowId: ${k}`);v=$.win.webContents}else{const{webContentsId:k}=c;if(v=n.webContents.fromId(k),!v)throw new Error(`Invalid webContentsId: ${k}`)}v.isDestroyed()||v.setIgnoreMenuShortcuts(y)}async findInFrame(c,y,v,k){const m=this.c(c,y);if(typeof m.findInFrame=="function"){m.findInFrame(v,{findNext:k.findNext,forward:k.forward});const w=(p,u)=>{u.finalUpdate&&(this.a.fire(u),m.removeListener("found-in-frame",w))};m.on("found-in-frame",w)}}async stopFindInFrame(c,y,v){const $=this.c(c,y);typeof $.stopFindInFrame=="function"&&$.stopFindInFrame(v.keepSelection?"keepSelection":"clearSelection")}c(c,y){const v=this.b.getWindowById(c.windowId);if(!v?.win)throw new Error(`Invalid windowId: ${c}`);const k=v.win.webContents.mainFrame.framesInSubtree.find($=>$.name===y);if(!k)throw new Error(`Unknown frame: ${y}`);return k}};e.$bac=S,e.$bac=S=ve([se(0,C.$P$b)],S)}),define(ae[300],ce([0,1,14,2,4,19,7,18,20,5,34,29,81,30]),function(X,e,n,R,P,O,C,S,d,c,y,v,k,$){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$eac=e.$dac=e.$cac=void 0;let w=class extends R.$Tc{static{m=this}static{this.a="windowsState"}get state(){return this.b}constructor(a,t,o,r,i){super(),this.g=a,this.h=t,this.j=o,this.m=r,this.n=i,this.b=p(this.h.getItem(m.a)),this.c=void 0,this.f=!1,this.r()}r(){n.app.on("browser-window-blur",()=>{this.f||this.t()}),this.j.onBeforeCloseWindow(a=>this.u(a)),this.j.onBeforeShutdown(()=>this.s()),this.g.onDidChangeWindowsCount(a=>{a.newCount-a.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(a=>this.u(a))}s(){this.f=!0,this.t()}t(){const a=new Set,t={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!t.lastActiveWindow){let i=this.g.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.g.getWindows().find(s=>!s.isExtensionDevelopmentHost)),i&&(t.lastActiveWindow=this.w(i),t.lastActiveWindow.uiState.mode===3&&a.add(t.lastActiveWindow.uiState.display))}const o=this.g.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);o&&(t.lastPluginDevelopmentHostWindow=this.w(o),t.lastPluginDevelopmentHostWindow.uiState.mode===3&&(a.has(t.lastPluginDevelopmentHostWindow.uiState.display)?P.$j&&!o.win?.isSimpleFullScreen()&&(t.lastPluginDevelopmentHostWindow.uiState.mode=1):a.add(t.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(t.openedWindows=this.g.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const s=this.w(i);return s.uiState.mode===3&&(a.has(s.uiState.display)?P.$j&&s.windowId!==t.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(s.uiState.mode=1):a.add(s.uiState.display)),s}));const r=f(t);this.h.setItem(m.a,r),this.f&&this.m.trace("[WindowsStateHandler] onBeforeShutdown",r)}u(a){if(this.j.quitRequested)return;const t=this.w(a);a.isExtensionDevelopmentHost&&!a.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=t:!a.isExtensionDevelopmentHost&&a.openedWorkspace&&this.b.openedWindows.forEach(o=>{const r=(0,$.$ui)(a.openedWorkspace)&&o.workspace?.id===a.openedWorkspace.id,i=(0,$.$pi)(a.openedWorkspace)&&o.folderUri&&O.$Jg.isEqual(o.folderUri,a.openedWorkspace.uri);(r||i)&&(o.uiState=t.uiState)}),this.g.getWindowCount()===1&&(this.c=t)}w(a){return{windowId:a.id,workspace:(0,$.$ui)(a.openedWorkspace)?a.openedWorkspace:void 0,folderUri:(0,$.$pi)(a.openedWorkspace)?a.openedWorkspace.uri:void 0,backupPath:a.backupPath,remoteAuthority:a.remoteAuthority,uiState:a.serializeWindowState()}}getNewWindowState(a){const t=this.z(a),o=this.n.getValue("window");if(t.mode===3){let r;t.hasDefaultState?r=!!(o?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(o.newWindowDimensions)>=0):r=!!(this.j.wasRestarted||o?.restoreFullscreen),r||(t.mode=1)}return t}z(a){const t=this.g.getLastActiveWindow();if(!a.extensionTestsPath){if(a.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const b=a.workspace;if((0,$.$ui)(b)){const j=this.state.openedWindows.filter(E=>E.workspace&&E.workspace.id===b.id).map(E=>E.uiState);if(j.length)return j[0]}if((0,$.$pi)(b)){const j=this.state.openedWindows.filter(E=>E.folderUri&&O.$Jg.isEqual(E.folderUri,b.uri)).map(E=>E.uiState);if(j.length)return j[0]}else if(a.backupPath){const j=this.state.openedWindows.filter(E=>E.backupPath===a.backupPath).map(E=>E.uiState);if(j.length)return j[0]}const D=this.c||this.state.lastActiveWindow;if(!t&&D)return D.uiState}let o;const r=n.screen.getAllDisplays();if(r.length===1)o=r[0];else{if(P.$j){const b=n.screen.getCursorScreenPoint();o=n.screen.getDisplayNearestPoint(b)}!o&&t&&(o=n.screen.getDisplayMatching(t.getBounds())),o||(o=n.screen.getPrimaryDisplay()||r[0])}let i=(0,k.$C$b)();i.x=Math.round(o.bounds.x+o.bounds.width/2-i.width/2),i.y=Math.round(o.bounds.y+o.bounds.height/2-i.height/2);const s=this.n.getValue("window");let l=!0;if(s?.newWindowDimensions){if(s.newWindowDimensions==="maximized")i.mode=0,l=!1;else if(s.newWindowDimensions==="fullscreen")i.mode=3,l=!1;else if((s.newWindowDimensions==="inherit"||s.newWindowDimensions==="offset")&&t){const b=t.serializeWindowState();b.mode===3?i.mode=3:i={...b,zoomLevel:void 0},l=i.mode!==3&&s.newWindowDimensions==="offset"}}return l&&(i=this.C(i)),i.hasDefaultState=!0,i}C(a){if(this.g.getWindows().length===0)return a;a.x=typeof a.x=="number"?a.x:0,a.y=typeof a.y=="number"?a.y:0;const t=this.g.getWindows().map(o=>o.getBounds());for(;t.some(o=>o.x===a.x||o.y===a.y);)a.x+=30,a.y+=30;return a}};e.$cac=w,e.$cac=w=m=ve([se(0,v.$P$b),se(1,y.$AP),se(2,d.$9$b),se(3,c.$zj),se(4,S.$Li)],w);function p(g){const a={openedWindows:[]},t=g||{openedWindows:[]};return t.lastActiveWindow&&(a.lastActiveWindow=u(t.lastActiveWindow)),t.lastPluginDevelopmentHostWindow&&(a.lastPluginDevelopmentHostWindow=u(t.lastPluginDevelopmentHostWindow)),Array.isArray(t.openedWindows)&&(a.openedWindows=t.openedWindows.map(o=>u(o))),a}e.$dac=p;function u(g){const a={uiState:g.uiState};return g.backupPath&&(a.backupPath=g.backupPath),g.remoteAuthority&&(a.remoteAuthority=g.remoteAuthority),g.folder&&(a.folderUri=C.URI.parse(g.folder)),g.workspaceIdentifier&&(a.workspace={id:g.workspaceIdentifier.id,configPath:C.URI.parse(g.workspaceIdentifier.configURIPath)}),a}function f(g){return{lastActiveWindow:g.lastActiveWindow&&h(g.lastActiveWindow),lastPluginDevelopmentHostWindow:g.lastPluginDevelopmentHostWindow&&h(g.lastPluginDevelopmentHostWindow),openedWindows:g.openedWindows.map(a=>h(a))}}e.$eac=f;function h(g){return{workspaceIdentifier:g.workspace&&{id:g.workspace.id,configURIPath:g.workspace.configPath.toString()},folder:g.folderUri&&g.folderUri.toString(),backupPath:g.backupPath,remoteAuthority:g.remoteAuthority,uiState:g.uiState}}}),define(ae[58],ce([0,1,14,3,42,2,13,9,19,21,196,64,56,24,6,5,57,132,30,98,99]),function(X,e,n,R,P,O,C,S,d,c,y,v,k,$,m,w,p,u,f,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3$b=e.$2$b=void 0,e.$2$b=(0,m.$fi)("workspacesManagementMainService");let a=class extends O.$Tc{constructor(o,r,i,s,l){super(),this.g=o,this.h=r,this.j=i,this.m=s,this.n=l,this.a=this.B(new R.$5d),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new R.$5d),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const o=(await c.Promises.readdir(this.c.with({scheme:C.Schemas.file}).fsPath)).map(r=>(0,d.$Sg)(this.c,r,f.$Ei));for(const r of o){const i=(0,g.$Y$b)(r),s=await this.resolveLocalWorkspace(r);s?this.f.push({workspace:i,remoteAuthority:s.remoteAuthority}):await this.deleteUntitledWorkspace(i)}}catch(o){o.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${o}).`)}}resolveLocalWorkspace(o){return this.r(o,r=>c.Promises.readFile(r,"utf8"))}r(o,r){if(this.s(o)&&o.scheme===C.Schemas.file)try{const i=r(o.fsPath);return i instanceof Promise?i.then(s=>this.t(o,s),s=>{}):this.t(o,i)}catch{return}}s(o){return(0,f.$Fi)(o,this.g)||(0,f.$Ki)(o)}t(o,r){try{const i=this.u(o,r),s=(0,g.$Y$b)(o);return{id:s.id,configPath:s.configPath,folders:(0,h.$neb)(i.folders,s.configPath,d.$Jg),remoteAuthority:i.remoteAuthority,transient:i.transient}}catch(i){this.h.warn(i.toString())}}u(o,r){const i=(0,P.$rn)(r);if(i&&Array.isArray(i.folders))i.folders=i.folders.filter(s=>(0,h.$leb)(s));else throw new Error(`${o.toString(!0)} looks like an invalid workspace file.`);return i}async createUntitledWorkspace(o,r){const{workspace:i,storedWorkspace:s}=this.w(o,r),l=i.configPath.fsPath;return await c.Promises.mkdir((0,S.$mc)(l),{recursive:!0}),await c.Promises.writeFile(l,JSON.stringify(s,null,"	")),this.f.push({workspace:i,remoteAuthority:r}),i}w(o=[],r){const i=(Date.now()+Math.round(Math.random()*1e3)).toString(),s=(0,d.$Sg)(this.c,i),l=(0,d.$Sg)(s,f.$Ei),b=[];for(const D of o)b.push((0,h.$meb)(D.uri,!0,D.name,s,d.$Jg));return{workspace:(0,g.$Y$b)(l),storedWorkspace:{folders:b,remoteAuthority:r}}}async getWorkspaceIdentifier(o){return(0,g.$Y$b)(o)}isUntitledWorkspace(o){return(0,f.$Fi)(o.configPath,this.g)}async deleteUntitledWorkspace(o){this.isUntitledWorkspace(o)&&(await this.y(o),this.j.isEnabled()&&this.j.unsetWorkspace(o),this.a.fire(o))}async y(o){const r=(0,d.$Gg)(o.configPath);try{await c.Promises.rm((0,S.$mc)(r));const i=(0,S.$jc)(this.g.workspaceStorageHome.with({scheme:C.Schemas.file}).fsPath,o.id);await c.Promises.exists(i)&&await c.Promises.writeFile((0,S.$jc)(i,"obsolete"),""),this.f=this.f.filter(s=>s.workspace.id!==o.id)}catch(i){this.h.warn(`Unable to delete untitled workspace ${r} (${i}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(o,r,i){if(!o||!o.win||!o.isReady||!await this.z(o,r,i))return;const l=await this.C(o,(0,g.$Y$b)(i));if(l)return this.b.fire({window:o,workspace:l.workspace}),l}async z(o,r,i){return i?(0,f.$ui)(o.openedWorkspace)&&d.$Jg.isEqual(o.openedWorkspace.configPath,i)?!1:(0,u.$V$b)(r,i)?(await this.n.showMessageBox({type:"info",buttons:[(0,y.localize)(0,null)],message:(0,y.localize)(1,null,(0,d.$Pg)(i)),detail:(0,y.localize)(2,null)},n.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async C(o,r){if(!o.config)return;o.focus();let i;return o.config.extensionDevelopmentPath||(o.config.backupPath?i=await this.m.registerWorkspaceBackup({workspace:r,remoteAuthority:o.remoteAuthority},o.config.backupPath):i=this.m.registerWorkspaceBackup({workspace:r,remoteAuthority:o.remoteAuthority})),(0,f.$ui)(o.openedWorkspace)&&this.isUntitledWorkspace(o.openedWorkspace)&&await this.deleteUntitledWorkspace(o.openedWorkspace),o.config.workspace=r,o.config.backupPath=i,{workspace:r,backupPath:i}}};e.$3$b=a,e.$3$b=a=ve([se(0,$.$E$b),se(1,w.$zj),se(2,p.$S$b),se(3,v.$J$b),se(4,k.$K$b)],a)}),define(ae[134],ce([0,1,14,37,23,6,29,30,58,12,5,60]),function(X,e,n,R,P,O,C,S,d,c,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n_b=e.$m_b=e.ID=void 0,e.ID="diagnosticsMainService",e.$m_b=(0,O.$fi)(e.ID);let k=class{constructor(m,w,p){this.a=m,this.b=w,this.c=p}async getRemoteDiagnostics(m){const w=this.a.getWindows();return(await Promise.all(w.map(async u=>{const f=u.remoteAuthority;if(!f)return;const h=`vscode:getDiagnosticInfoResponse${u.id}`,g={includeProcesses:m.includeProcesses,folders:m.includeWorkspaceMetadata?await this.f(u):void 0};return new Promise(a=>{u.sendWhenReady("vscode:getDiagnosticInfo",P.CancellationToken.None,{replyChannel:h,args:g}),R.$KV.once(h,(t,o)=>{o||a({hostName:f,errorMessage:`Unable to resolve connection to '${f}'.`}),a(o)}),setTimeout(()=>{a({hostName:f,errorMessage:`Connection to '${f}' could not be established`})},5e3)})}))).filter(u=>!!u)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const m=[];for(const p of n.BrowserWindow.getAllWindows()){const u=this.a.getWindowById(p.id);u?m.push(await this.d(u)):m.push(this.e(p))}const w=[];for(const{pid:p,name:u}of v.$j_b.getAll())w.push({pid:p,name:u});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:m,pidToNames:w,screenReader:!!n.app.accessibilitySupportEnabled,gpuFeatureStatus:n.app.getGPUFeatureStatus()}}async d(m){const w=await this.f(m),p=(0,c.$4f)(m.win);return this.e(p,w,m.remoteAuthority)}e(m,w=[],p){return{id:m.id,pid:m.webContents.getOSProcessId(),title:m.getTitle(),folderURIs:w,remoteAuthority:p}}async f(m){const w=[],p=m.openedWorkspace;if((0,S.$pi)(p))w.push(p.uri);else if((0,S.$ui)(p)){const u=await this.b.resolveLocalWorkspace(p.configPath);u&&u.folders.forEach(h=>{w.push(h.uri)})}return w}};e.$n_b=k,e.$n_b=k=ve([se(0,C.$P$b),se(1,d.$2$b),se(2,y.$zj)],k)}),define(ae[70],ce([0,1,48,14,26,158,50,3,2,13,9,4,7,108,89,21,106,184,56,24,6,20,5,27,69,29,30,58,17,245,237,78,15]),function(X,e,n,R,P,O,C,S,d,c,y,v,k,$,m,w,p,u,f,h,g,a,t,o,r,i,s,l,b,D,j,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C_b=e.$B_b=void 0,e.$B_b=(0,g.$fi)("nativeHostMainService");let M=class extends d.$Tc{constructor(W,V,J,le,re,ue,Q,Y,U){super(),this.a=W,this.b=V,this.c=J,this.f=le,this.g=re,this.h=ue,this.j=Q,this.m=Y,this.n=U,this.onDidOpenMainWindow=S.Event.map(this.a.onDidOpenWindow,L=>L.id),this.onDidTriggerWindowSystemContextMenu=S.Event.any(S.Event.filter(S.Event.map(this.a.onDidTriggerSystemContextMenu,({window:L,x:N,y:G})=>({windowId:L.id,x:N,y:G})),({windowId:L})=>!!this.a.getWindowById(L)),S.Event.filter(S.Event.map(this.b.onDidTriggerSystemContextMenu,({window:L,x:N,y:G})=>({windowId:L.id,x:N,y:G})),({windowId:L})=>!!this.b.getWindowById(L))),this.onDidMaximizeWindow=S.Event.any(S.Event.filter(S.Event.map(this.a.onDidMaximizeWindow,L=>L.id),L=>!!this.a.getWindowById(L)),S.Event.filter(S.Event.map(this.b.onDidMaximizeWindow,L=>L.id),L=>!!this.b.getWindowById(L))),this.onDidUnmaximizeWindow=S.Event.any(S.Event.filter(S.Event.map(this.a.onDidUnmaximizeWindow,L=>L.id),L=>!!this.a.getWindowById(L)),S.Event.filter(S.Event.map(this.b.onDidUnmaximizeWindow,L=>L.id),L=>!!this.b.getWindowById(L))),this.onDidChangeWindowFullScreen=S.Event.any(S.Event.map(this.a.onDidChangeFullScreen,L=>({windowId:L.window.id,fullscreen:L.fullscreen})),S.Event.map(this.b.onDidChangeFullScreen,L=>({windowId:L.window.id,fullscreen:L.fullscreen}))),this.onDidBlurMainWindow=S.Event.filter(S.Event.fromNodeEventEmitter(R.app,"browser-window-blur",(L,N)=>N.id),L=>!!this.a.getWindowById(L)),this.onDidFocusMainWindow=S.Event.any(S.Event.map(S.Event.filter(S.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),L=>!!L),L=>L.id),S.Event.filter(S.Event.fromNodeEventEmitter(R.app,"browser-window-focus",(L,N)=>N.id),L=>!!this.a.getWindowById(L))),this.onDidBlurMainOrAuxiliaryWindow=S.Event.any(this.onDidBlurMainWindow,S.Event.filter(S.Event.fromNodeEventEmitter(R.app,"browser-window-blur",(L,N)=>N.id),L=>!!this.b.getWindowById(L))),this.onDidFocusMainOrAuxiliaryWindow=S.Event.any(this.onDidFocusMainWindow,S.Event.filter(S.Event.fromNodeEventEmitter(R.app,"browser-window-focus",(L,N)=>N.id),L=>!!this.b.getWindowById(L))),this.onDidResumeOS=S.Event.fromNodeEventEmitter(R.powerMonitor,"resume"),this.onDidChangeColorScheme=this.m.onDidChangeColorScheme,this.r=this.B(new S.$5d),this.onDidChangePassword=this.r.event,this.onDidChangeDisplay=S.Event.debounce(S.Event.any(S.Event.filter(S.Event.fromNodeEventEmitter(R.screen,"display-metrics-changed",(L,N,G)=>G),L=>!(Array.isArray(L)&&L.length===1&&L[0]==="workArea")),S.Event.fromNodeEventEmitter(R.screen,"display-added"),S.Event.fromNodeEventEmitter(R.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(W,V){const J=this.a.getWindows().map(re=>({id:re.id,workspace:re.openedWorkspace??(0,s.$ti)(re.backupPath,re.isExtensionDevelopmentHost),title:re.win?.getTitle()??"",filename:re.getRepresentedFilename(),dirty:re.isDocumentEdited()})),le=[];return V.includeAuxiliaryWindows&&le.push(...this.b.getWindows().map(re=>({id:re.id,parentId:re.parentId,title:re.win?.getTitle()??"",filename:re.getRepresentedFilename()}))),[...J,...le]}async getWindowCount(W){return this.a.getWindowCount()}async getActiveWindowId(W){const V=this.a.getFocusedWindow()||this.a.getLastActiveWindow();if(V)return V.id}openWindow(W,V,J){return Array.isArray(V)?this.s(W,V,J):this.t(W,V)}async s(W,V,J=Object.create(null)){V.length>0&&await this.a.open({context:5,contextWindowId:W,urisToOpen:V,cli:this.g.args,forceNewWindow:J.forceNewWindow,forceReuseWindow:J.forceReuseWindow,preferNewWindow:J.preferNewWindow,diffMode:J.diffMode,mergeMode:J.mergeMode,addMode:J.addMode,gotoLineMode:J.gotoLineMode,noRecentEntry:J.noRecentEntry,waitMarkerFileURI:J.waitMarkerFileURI,remoteAuthority:J.remoteAuthority||void 0,forceProfile:J.forceProfile,forceTempProfile:J.forceTempProfile})}async t(W,V){await this.a.openEmptyWindow({context:5,contextWindowId:W},V)}async toggleFullScreen(W,V){this.C(V?.targetWindowId,W)?.toggleFullScreen()}async handleTitleDoubleClick(W,V){this.C(V?.targetWindowId,W)?.handleTitleDoubleClick()}async getCursorScreenPoint(W){const V=R.screen.getCursorScreenPoint(),J=R.screen.getDisplayNearestPoint(V);return{point:V,display:J.bounds}}async isMaximized(W,V){return this.C(V?.targetWindowId,W)?.win?.isMaximized()??!1}async maximizeWindow(W,V){this.C(V?.targetWindowId,W)?.win?.maximize()}async unmaximizeWindow(W,V){this.C(V?.targetWindowId,W)?.win?.unmaximize()}async minimizeWindow(W,V){this.C(V?.targetWindowId,W)?.win?.minimize()}async moveWindowTop(W,V){this.C(V?.targetWindowId,W)?.win?.moveTop()}async positionWindow(W,V,J){const le=this.C(J?.targetWindowId,W);if(le?.win){if(le.win.isFullScreen()){const re=S.Event.toPromise(S.Event.once(S.Event.fromNodeEventEmitter(le.win,"leave-full-screen")));le.win.setFullScreen(!1),await re}le.win.setBounds(V)}}async updateWindowControls(W,V){this.C(V?.targetWindowId,W)?.updateWindowControls(V)}async focusWindow(W,V){this.C(V?.targetWindowId,W)?.focus({force:V?.force??!1})}async setMinimumSize(W,V,J){const le=this.D(W);if(le?.win){const[re,ue]=le.win.getSize(),[Q,Y]=le.win.getMinimumSize(),[U,L]=[V??Q,J??Y],[N,G]=[Math.max(re,U),Math.max(ue,L)];(Q!==U||Y!==L)&&le.win.setMinimumSize(U,L),(re!==N||ue!==G)&&le.win.setSize(N,G)}}async saveWindowSplash(W,V){this.m.saveWindowSplash(W,V)}async installShellCommand(W){const{source:V,target:J}=await this.u();try{const{symbolicLink:le}=await w.SymlinkSupport.stat(V);if(le&&!le.dangling){const re=await(0,$.$Jq)(V);if(J===re)return}await w.Promises.unlink(V)}catch(le){if(le.code!=="ENOENT")throw le}try{await w.Promises.symlink(J,V)}catch(le){if(le.code!=="EACCES"&&le.code!=="ENOENT")throw le;const{response:re}=await this.showMessageBox(W,{type:"info",message:(0,u.localize)(0,null,this.j.nameShort),buttons:[(0,u.localize)(1,null),(0,u.localize)(2,null)]});if(re===1)throw new I.$5;try{const ue=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${J}' '${V}'\\" with administrator privileges"`;await(0,O.promisify)(n.exec)(ue)}catch{throw new Error((0,u.localize)(3,null,V))}}}async uninstallShellCommand(W){const{source:V}=await this.u();try{await w.Promises.unlink(V)}catch(J){switch(J.code){case"EACCES":{const{response:le}=await this.showMessageBox(W,{type:"info",message:(0,u.localize)(4,null,this.j.nameShort),buttons:[(0,u.localize)(5,null),(0,u.localize)(6,null)]});if(le===1)throw new I.$5;try{const re=`osascript -e "do shell script \\"rm '${V}'\\" with administrator privileges"`;await(0,O.promisify)(n.exec)(re)}catch{throw new Error((0,u.localize)(7,null,V))}break}case"ENOENT":break;default:throw J}}}async u(){const W=(0,y.$kc)(this.g.appRoot,"bin","code"),V=`/usr/local/bin/${this.j.applicationName}`;if(!await w.Promises.exists(W))throw new Error((0,u.localize)(8,null,W));return{source:V,target:W}}async showMessageBox(W,V){const J=this.C(V?.targetWindowId,W);return this.c.showMessageBox(V,J?.win??void 0)}async showSaveDialog(W,V){const J=this.C(V?.targetWindowId,W);return this.c.showSaveDialog(V,J?.win??void 0)}async showOpenDialog(W,V){const J=this.C(V?.targetWindowId,W);return this.c.showOpenDialog(V,J?.win??void 0)}async pickFileFolderAndOpen(W,V){const J=await this.c.pickFileFolder(V);J&&await this.w(await Promise.all(J.map(async le=>await w.SymlinkSupport.existsDirectory(le)?{folderUri:k.URI.file(le)}:{fileUri:k.URI.file(le)})),V,W)}async pickFolderAndOpen(W,V){const J=await this.c.pickFolder(V);J&&await this.w(J.map(le=>({folderUri:k.URI.file(le)})),V,W)}async pickFileAndOpen(W,V){const J=await this.c.pickFile(V);J&&await this.w(J.map(le=>({fileUri:k.URI.file(le)})),V,W)}async pickWorkspaceAndOpen(W,V){const J=await this.c.pickWorkspace(V);J&&await this.w(J.map(le=>({workspaceUri:k.URI.file(le)})),V,W)}async w(W,V,J){await this.a.open({context:3,contextWindowId:J,cli:this.g.args,urisToOpen:W,forceNewWindow:V.forceNewWindow})}async showItemInFolder(W,V){R.shell.showItemInFolder(V)}async setRepresentedFilename(W,V,J){this.C(J?.targetWindowId,W)?.setRepresentedFilename(V)}async setDocumentEdited(W,V,J){this.C(J?.targetWindowId,W)?.setDocumentEdited(V)}async openExternal(W,V){return this.g.unsetSnapExportedVariables(),R.shell.openExternal(V),this.g.restoreSnapExportedVariables(),!0}moveItemToTrash(W,V){return R.shell.trashItem(V)}async isAdmin(){let W;return v.$i?W=(await new Promise((V,J)=>{X(["native-is-elevated"],V,J)}))():W=process.getuid?.()===0,W}async writeElevated(W,V,J,le){const re=await new Promise((ue,Q)=>{X(["@vscode/sudo-prompt"],ue,Q)});return new Promise((ue,Q)=>{const Y=[`"${this.z}"`];le?.unlock&&Y.push("--file-chmod"),Y.push("--file-write",`"${V.fsPath}"`,`"${J.fsPath}"`);const U={name:this.j.nameLong.replace("-",""),icns:v.$j&&this.g.isBuilt?(0,y.$jc)((0,y.$mc)(this.g.appRoot),`${this.j.nameShort}.icns`):void 0};re.exec(Y.join(" "),U,(L,N,G)=>{N&&this.h.trace(`[sudo-prompt] received stdout: ${N}`),G&&this.h.trace(`[sudo-prompt] received stderr: ${G}`),L?Q(L):ue(void 0)})})}async isRunningUnderARM64Translation(){return v.$k||v.$i?!1:R.app.runningUnderARM64Translation}get z(){return v.$i?this.g.isBuilt?(0,y.$jc)((0,y.$mc)(process.execPath),"bin",`${this.j.applicationName}.cmd`):(0,y.$jc)(this.g.appRoot,"scripts","code-cli.bat"):v.$k?this.g.isBuilt?(0,y.$jc)((0,y.$mc)(process.execPath),"bin",`${this.j.applicationName}`):(0,y.$jc)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,y.$jc)(this.g.appRoot,"bin","code"):(0,y.$jc)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,P.totalmem)(),freemem:(0,P.freemem)(),loadavg:(0,P.loadavg)()}}async getOSProperties(){return{arch:(0,P.arch)(),platform:(0,P.platform)(),release:(0,P.release)(),type:(0,P.type)(),cpus:(0,P.cpus)()}}async getOSVirtualMachineHint(){return m.$mn.value()}async getOSColorScheme(){return this.m.getColorScheme()}async hasWSLFeatureInstalled(){return v.$i&&(0,D.$y_b)()}async killProcess(W,V,J){process.kill(V,J)}async readClipboardText(W,V){return R.clipboard.readText(V)}async writeClipboardText(W,V,J){return R.clipboard.writeText(V,J)}async readClipboardFindText(W){return R.clipboard.readFindText()}async writeClipboardFindText(W,V){return R.clipboard.writeFindText(V)}async writeClipboardBuffer(W,V,J,le){return R.clipboard.writeBuffer(V,Buffer.from(J.buffer),le)}async readClipboardBuffer(W,V){return b.$se.wrap(R.clipboard.readBuffer(V))}async hasClipboard(W,V,J){return R.clipboard.has(V,J)}async newWindowTab(){await this.a.open({context:5,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){R.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){R.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){R.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){R.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){R.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(W,V){this.D(W)?.updateTouchBar(V)}async notifyReady(W){this.D(W)?.setReady()}async relaunch(W,V){return this.f.relaunch(V)}async reload(W,V){const J=this.D(W);if(J){if((0,s.$ui)(J.openedWorkspace)){const le=J.openedWorkspace.configPath;if(le.scheme===c.Schemas.file&&(await this.n.resolveLocalWorkspace(le))?.transient)return this.openWindow(J.id,{forceReuseWindow:!0})}return this.f.reload(J,V?.disableExtensions!==void 0?{_:[],"disable-extensions":V.disableExtensions}:void 0)}}async closeWindow(W,V){return this.C(V?.targetWindowId,W)?.win?.close()}async quit(W){const V=this.a.getLastActiveWindow();V?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&V.win?V.win.close():this.f.quit()}async exit(W,V){await this.f.kill(V)}async resolveProxy(W,V){return this.D(W)?.win?.webContents?.session?.resolveProxy(V)}async loadCertificates(W){return(await new Promise((J,le)=>{X(["@vscode/proxy-agent"],J,le)})).loadSystemCertificates({log:this.h})}findFreePort(W,V,J,le,re=1){return(0,p.$Dg)(V,J,le,re)}async openDevTools(W,V){this.C(V?.targetWindowId,W)?.win?.webContents.openDevTools(V?.mode?{mode:V.mode,activate:V.activate}:void 0)}async toggleDevTools(W,V){this.C(V?.targetWindowId,W)?.win?.webContents.toggleDevTools()}async profileRenderer(W,V,J){const le=this.D(W);if(!le||!le.win)throw new Error;return await new j.$z_b(le.win,V,this.h).inspect(J)}async windowsGetStringRegKey(W,V,J,le){if(!v.$i)return;const re=await new Promise((ue,Q)=>{X(["@vscode/windows-registry"],ue,Q)});try{return re.GetStringRegKey(V,J,le)}catch{return}}C(W,V){return this.D(W)??this.F(W)??this.D(V)}D(W){if(typeof W=="number")return this.a.getWindowById(W)}F(W){if(typeof W=="number")return this.b.getWindowById(W)}};e.$C_b=M,ve([C.$Jh],M.prototype,"z",null),e.$C_b=M=ve([se(0,i.$P$b),se(1,E.$A_b),se(2,f.$K$b),se(3,a.$9$b),se(4,h.$E$b),se(5,t.$zj),se(6,o.$Rj),se(7,r.$N$b),se(8,l.$2$b)],M)}),define(ae[301],ce([0,1,14,26,8,23,33,2,13,4,7,110,37,182,92,134,56,24,5,70,79,27,80,34,60,55,29]),function(X,e,n,R,P,O,C,S,d,c,y,v,k,$,m,w,p,u,f,h,g,a,t,o,r,i,s){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$D_b=void 0;const b="issue.processExplorerWindowState";let D=class{static{l=this}static{this.a="#1E1E1E"}constructor(I,M,T,W,V,J,le,re,ue,Q,Y){this.g=I,this.h=M,this.i=T,this.j=W,this.k=V,this.l=J,this.m=le,this.n=re,this.o=ue,this.p=Q,this.q=Y,this.b=null,this.c=null,this.d=null,this.f=null,this.r()}r(){k.$KV.on("vscode:listProcesses",async I=>{const M=[];try{M.push({name:(0,$.localize)(0,null),rootProcess:await(0,v.$gs)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(W=>{(0,m.$Ym)(W)?M.push({name:W.hostName,rootProcess:W}):W.processes&&M.push({name:W.hostName,rootProcess:W.processes})})}catch(T){this.i.error(`Listing processes failed: ${T}`)}this.t(I,"vscode:listProcessesResponse",M)}),k.$KV.on("vscode:workbenchCommand",(I,M)=>{const{id:T,from:W,args:V}=M;let J;switch(W){case"processExplorer":J=this.f;break;default:throw new Error(`Unexpected command source: ${W}`)}J?.webContents.send("vscode:runAction",{id:T,from:W,args:V})}),k.$KV.on("vscode:closeProcessExplorer",I=>{this.d?.close()}),k.$KV.on("vscode:pidToNameRequest",async I=>{const M=await this.k.getMainDiagnostics(),T=[];for(const W of M.windows)T.push([W.pid,`window [${W.id}] (${W.title})`]);for(const{pid:W,name:V}of r.$j_b.getAll())T.push([W,V]);this.t(I,"vscode:pidToNameResponse",T)})}async openReporter(I){if(this.b)this.b&&this.s(this.b);else if(this.c=n.BrowserWindow.getFocusedWindow(),this.c){const M=new S.$Sc,T=M.add(this.n.createIPCObjectUrl()),W=this.v(this.c,700,800);this.b=this.u(W,T,{backgroundColor:I.styles.backgroundColor,title:(0,$.localize)(1,null),zoomLevel:I.zoomLevel,alwaysOnTop:!1},"issue-reporter"),T.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:I,disableExtensions:!!this.h.disableExtensions,os:{type:(0,R.type)(),arch:(0,R.arch)(),release:(0,R.release)()},product:g.default}),this.b.loadURL(d.$zg.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,M.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,M.dispose())})}}async openProcessExplorer(I){if(!this.d&&(this.f=n.BrowserWindow.getFocusedWindow(),this.f)){const M=new S.$Sc,T=M.add(this.n.createIPCObjectUrl()),W=this.p.getItem(b,void 0),V=j(W)?W:this.v(this.f,800,500);this.d=this.u(V,T,{backgroundColor:I.styles.backgroundColor,title:(0,$.localize)(2,null),zoomLevel:I.zoomLevel,alwaysOnTop:!0},"process-explorer"),T.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:I,product:g.default}),this.d.loadURL(d.$zg.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,M.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,M.dispose())});const J=()=>{if(!this.d)return;const le=this.d.getSize(),re=this.d.getPosition();if(!le||!re)return;const ue={width:le[0],height:le[1],x:re[0],y:re[1]};this.p.setItem(b,ue)};this.d.on("moved",J),this.d.on("resized",J)}this.d&&this.s(this.d)}async stopTracing(){if(!this.h.args.trace)return;const I=await n.contentTracing.stopRecording(`${(0,C.$ng)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,$.localize)(3,null),detail:(0,$.localize)(4,null,I),buttons:[(0,$.localize)(5,null)]},n.BrowserWindow.getFocusedWindow()??void 0),this.m.showItemInFolder(void 0,I)}async getSystemStatus(){const[I,M]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(I,M)}async $getSystemInfo(){const[I,M]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.j.getSystemInfo(I,M)}async $getPerformanceInfo(){try{const[I,M]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(I,M)}catch(I){throw this.i.warn("issueService#getPerformanceInfo ",I.message),I}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.m.reload(this.c.id,{disableExtensions:!0})}catch(I){this.i.error(I)}}async $showConfirmCloseDialog(){if(this.b){const{response:I}=await this.l.showMessageBox({type:"warning",message:(0,$.localize)(6,null),buttons:[(0,$.localize)(7,null),(0,$.localize)(8,null)]},this.b);I===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:I}=await this.l.showMessageBox({type:"warning",message:(0,$.localize)(9,null),buttons:[(0,$.localize)(10,null),(0,$.localize)(11,null)]},this.b);return I===0}return!1}issueReporterWindowCheck(){if(!this.c)throw new Error("Issue reporter window not available");const I=this.q.getWindowById(this.c.id);if(!I)throw new Error("Window not found");return I}async $getIssueReporterUri(I){const M=this.issueReporterWindowCheck(),T=`vscode:triggerIssueUriRequestHandlerResponse${M.id}`;return P.Promises.withAsyncBody(async(W,V)=>{const J=new O.$ce;M.sendWhenReady("vscode:triggerIssueUriRequestHandler",J.token,{replyChannel:T,extensionId:I}),k.$KV.once(T,(le,re)=>{W(y.URI.parse(re))});try{await(0,P.$gh)(5e3),J.cancel(),V(new Error("Timed out waiting for issue reporter URI"))}finally{k.$KV.removeHandler(T)}})}async $getIssueReporterData(I){const M=this.issueReporterWindowCheck(),T=`vscode:triggerIssueDataProviderResponse${M.id}`;return P.Promises.withAsyncBody(async W=>{const V=new O.$ce;M.sendWhenReady("vscode:triggerIssueDataProvider",V.token,{replyChannel:T,extensionId:I}),k.$KV.once(T,(J,le)=>{W(le)});try{await(0,P.$gh)(5e3),V.cancel(),W("Error: Extension timed out waiting for issue reporter data")}finally{k.$KV.removeHandler(T)}})}async $getIssueReporterTemplate(I){const M=this.issueReporterWindowCheck(),T=`vscode:triggerIssueDataTemplateResponse${M.id}`;return P.Promises.withAsyncBody(async W=>{const V=new O.$ce;M.sendWhenReady("vscode:triggerIssueDataTemplate",V.token,{replyChannel:T,extensionId:I}),k.$KV.once(T,(J,le)=>{W(le)});try{await(0,P.$gh)(5e3),V.cancel(),W("Error: Extension timed out waiting for issue reporter template")}finally{k.$KV.removeHandler(T)}})}async $getReporterStatus(I,M){const T=[!1,!1],W=this.issueReporterWindowCheck(),V="vscode:triggerReporterStatus",J=new O.$ce;return W.sendWhenReady(V,J.token,{replyChannel:V,extensionId:I,extensionName:M}),await(0,P.$9g)(new Promise(re=>k.$KV.once("vscode:triggerReporterStatusResponse",(ue,Q)=>re(Q))),2e3,()=>{this.i.error("Error: Extension timed out waiting for reporter status"),J.cancel()})??T}async $sendReporterMenu(I,M){const T=this.issueReporterWindowCheck(),W="vscode:triggerReporterMenu",V=new O.$ce;return T.sendWhenReady(W,V.token,{replyChannel:W,extensionId:I,extensionName:M}),await(0,P.$9g)(new Promise(le=>k.$KV.once(`vscode:triggerReporterMenuResponse:${I}`,(re,ue)=>le(ue))),5e3,()=>{this.i.error(`Error: Extension ${I} timed out waiting for menu response`),V.cancel()})}async $closeReporter(){this.b?.close()}async closeProcessExplorer(){this.d?.close()}s(I){I.isMinimized()&&I.restore(),I.focus()}t(I,M,...T){I.sender.isDestroyed()||I.sender.send(M,...T)}u(I,M,T,W){const V=new n.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:I.width,height:I.height,minWidth:300,minHeight:200,x:I.x,y:I.y,title:T.title,backgroundColor:T.backgroundColor||l.a,webPreferences:{preload:d.$zg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${M.resource.toString()}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,i.$bD)(T.zoomLevel),sandbox:!0},alwaysOnTop:T.alwaysOnTop,experimentalDarkMode:!0});return V.setMenuBarVisibility(!1),V}v(I,M,T){let W;const V=n.screen.getAllDisplays();if(V.length===1)W=V[0];else{if(c.$j){const re=n.screen.getCursorScreenPoint();W=n.screen.getDisplayNearestPoint(re)}!W&&I&&(W=n.screen.getDisplayMatching(I.getBounds())),W||(W=n.screen.getPrimaryDisplay()||V[0])}const J=W.bounds,le={width:M,height:T,x:J.x+J.width/2-M/2,y:J.y+J.height/2-T/2};return J.width>0&&J.height>0&&(le.x<J.x&&(le.x=J.x),le.y<J.y&&(le.y=J.y),le.x>J.x+J.width&&(le.x=J.x),le.y>J.y+J.height&&(le.y=J.y),le.width>J.width&&(le.width=J.width),le.height>J.height&&(le.height=J.height)),le}};e.$D_b=D,e.$D_b=D=l=ve([se(1,u.$E$b),se(2,f.$zj),se(3,m.$Xm),se(4,w.$m_b),se(5,p.$K$b),se(6,h.$B_b),se(7,t.$M$b),se(8,a.$Rj),se(9,o.$AP),se(10,s.$P$b)],D);function j(E){return typeof E!="object"||E===null?!1:"x"in E&&"y"in E&&"width"in E&&"height"in E}}),define(ae[302],ce([0,1,23,18,24,20,5,70,27,53,28,49,101]),function(X,e,n,R,P,O,C,S,d,c,y,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5_b=void 0;let $=class extends k.$3_b{constructor(w,p,u,f,h,g,a,t){super(w,p,f,h,g,t),this.e=u,this.u=a}s(w){return(0,k.$2_b)(`linux-${process.arch}`,w,this.k)}t(w){this.a&&(this.d(v.$IW.CheckingForUpdates(w)),this.i.request({url:this.a},n.CancellationToken.None).then(c.$Bp).then(p=>{!p||!p.url||!p.version||!p.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!w}),this.d(v.$IW.Idle(1))):this.d(v.$IW.AvailableForDownload(p))}).then(void 0,p=>{this.j.error(p);const u=w?p.message||p:void 0;this.d(v.$IW.Idle(1,u))}))}async o(w){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):w.update.url&&this.u.openExternal(void 0,w.update.url),this.d(v.$IW.Idle(1))}};e.$5_b=$,e.$5_b=$=ve([se(0,O.$9$b),se(1,R.$Li),se(2,y.$El),se(3,P.$E$b),se(4,c.$vp),se(5,C.$zj),se(6,S.$B_b),se(7,d.$Rj)],$)}),define(ae[303],ce([0,1,48,46,26,8,23,50,45,9,7,146,21,18,24,16,20,5,70,27,53,28,49,101]),function(X,e,n,R,P,O,C,S,d,c,y,v,k,$,m,w,p,u,f,h,g,a,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7_b=void 0;async function r(b,D=1e3){for(;!b();)await(0,O.$gh)(D)}let i;function s(){return typeof i>"u"&&(i=R.existsSync(c.$jc(c.$mc(process.execPath),"unins000.exe"))?0:1),i}let l=class extends o.$3_b{get cachePath(){const D=c.$jc((0,P.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return k.Promises.mkdir(D,{recursive:!0}).then(()=>D)}constructor(D,j,E,I,M,T,W,V,J){super(D,j,I,M,T,J),this.u=E,this.v=W,this.w=V,D.setRelaunchHandler(this)}handleRelaunch(D){return D?.addArgs||D?.removeArgs||this.state.type!=="ready"||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(t.$IW.Disabled(5)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(D){let j=`win32-${process.arch}`;return s()===1?j+="-archive":this.k.target==="user"&&(j+="-user"),(0,o.$2_b)(j,D,this.k)}t(D){this.a&&(this.d(t.$IW.CheckingForUpdates(D)),this.i.request({url:this.a},C.CancellationToken.None).then(g.$Bp).then(j=>{const E=s();return!j||!j.url||!j.version||!j.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!D}),this.d(t.$IW.Idle(E)),Promise.resolve(null)):E===1?(this.d(t.$IW.AvailableForDownload(j)),Promise.resolve(null)):(this.d(t.$IW.Downloading(j)),this.C(j.version).then(()=>this.B(j.version).then(I=>k.Promises.exists(I).then(M=>{if(M)return Promise.resolve(I);const T=`${I}.tmp`;return this.i.request({url:j.url},C.CancellationToken.None).then(W=>this.v.writeFile(y.URI.file(T),W.stream)).then(j.sha256hash?()=>(0,v.$FV)(T,j.sha256hash):()=>{}).then(()=>k.Promises.rename(T,I,!1)).then(()=>I)})).then(I=>{const M=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:I},M?this.k.target==="user"?this.p():this.d(t.$IW.Downloaded(j)):this.d(t.$IW.Ready(j))})))}).then(void 0,j=>{this.u.publicLog2("update:error",{messageHash:String((0,d.$6i)(String(j)))}),this.j.error(j);const E=D?j.message||j:void 0;this.d(t.$IW.Idle(s(),E))}))}async o(D){D.update.url&&this.w.openExternal(void 0,D.update.url),this.d(t.$IW.Idle(s()))}async B(D){const j=await this.cachePath;return c.$jc(j,`CodeSetup-${this.k.quality}-${D}.exe`)}async C(D=null){const j=D?T=>!new RegExp(`${this.k.quality}-${D}\\.exe$`).test(T):()=>!0,E=await this.cachePath,M=(await k.Promises.readdir(E)).filter(j).map(async T=>{try{await k.Promises.unlink(c.$jc(E,T))}catch{}});await Promise.all(M)}async p(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const D=this.state.update;this.d(t.$IW.Updating(D));const j=await this.cachePath;this.e.updateFilePath=c.$jc(j,`CodeSetup-${this.k.quality}-${D.version}.flag`),await k.Promises.writeFile(this.e.updateFilePath,"flag"),(0,n.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(t.$IW.Idle(s()))});const I=`${this.k.win32MutexName}-ready`,M=await new Promise((T,W)=>{X(["@vscode/windows-mutex"],T,W)});r(()=>M.isActive(I)).then(()=>this.d(t.$IW.Ready(D)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?R.unlinkSync(this.e.updateFilePath):(0,n.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return s()}async _applySpecificUpdate(D){if(this.state.type!=="idle")return;const j=this.g.getValue("update.enableWindowsBackgroundUpdates"),E={version:"unknown",productVersion:"unknown"};this.d(t.$IW.Downloading(E)),this.e={packagePath:D},j?this.k.target==="user"?this.p():this.d(t.$IW.Downloaded(E)):this.d(t.$IW.Ready(E))}};e.$7_b=l,ve([S.$Jh],l.prototype,"cachePath",null),e.$7_b=l=ve([se(0,p.$9$b),se(1,$.$Li),se(2,a.$El),se(3,m.$E$b),se(4,g.$vp),se(5,u.$zj),se(6,w.$Fk),se(7,f.$B_b),se(8,h.$Rj)],l)}),define(ae[135],ce([0,1,14,8,23,51,3,2,13,66,4,7,192,26,64,18,56,24,63,16,20,5,27,80,254,83,28,105,69,55,29,30,58,81,39,34,57,67,22,6]),function(X,e,n,R,P,O,C,S,d,c,y,v,k,$,m,w,p,u,f,h,g,a,t,o,r,i,s,l,b,D,j,E,I,M,T,W,V,J,le,re){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7$b=e.$6$b=void 0;var ue;(function(U){U[U.NONE=0]="NONE",U[U.NAVIGATING=1]="NAVIGATING",U[U.READY=2]="READY"})(ue||(ue={}));class Q extends S.$Tc{get lastFocusTime(){return this.j}get win(){return this.m}n(L){this.m=L,this.B(C.Event.fromNodeEventEmitter(L,"maximize")(()=>this.b.fire())),this.B(C.Event.fromNodeEventEmitter(L,"unmaximize")(()=>this.c.fire())),this.B(C.Event.fromNodeEventEmitter(L,"closed")(()=>{this.a.fire(),this.dispose()})),this.B(C.Event.fromNodeEventEmitter(L,"focus")(()=>{this.j=Date.now()})),this.B(C.Event.fromNodeEventEmitter(this.m,"enter-full-screen")(()=>this.g.fire())),this.B(C.Event.fromNodeEventEmitter(this.m,"leave-full-screen")(()=>this.h.fire()));const N=!(0,D.$0C)(this.r);if(y.$j&&N&&L.setSheetOffset((0,y.$J)((0,$.release)())?28:22),N&&(y.$i&&(0,D.$_C)(this.r)||y.$j)){const G=this.s.getItem(Q.C);G&&this.updateWindowControls({height:G})}y.$i&&N&&L.hookWindowMessage(278,()=>{const[q,oe]=L.getPosition(),he=n.screen.getCursorScreenPoint(),K=he.x-q,A=he.y-oe;return!(K>30&&A>=0&&A<=Math.max(L.getBounds().height*.15,35))||(L.setEnabled(!1),L.setEnabled(!0),this.f.fire({x:K,y:A})),0}),this.t.args["open-devtools"]===!0&&L.webContents.openDevTools(),y.$j&&(this.B(this.onDidEnterFullScreen(()=>{this.G?.complete(!0)})),this.B(this.onDidLeaveFullScreen(()=>{this.G?.complete(!0)})))}constructor(L,N,G,q){super(),this.r=L,this.s=N,this.t=G,this.u=q,this.a=this.B(new C.$5d),this.onDidClose=this.a.event,this.b=this.B(new C.$5d),this.onDidMaximize=this.b.event,this.c=this.B(new C.$5d),this.onDidUnmaximize=this.c.event,this.f=this.B(new C.$5d),this.onDidTriggerSystemContextMenu=this.f.event,this.g=this.B(new C.$5d),this.onDidEnterFullScreen=this.g.event,this.h=this.B(new C.$5d),this.onDidLeaveFullScreen=this.h.event,this.j=Date.now(),this.m=null,this.D=(0,D.$_C)(this.r),this.F=void 0,this.G=void 0}setRepresentedFilename(L){y.$j?this.win?.setRepresentedFilename(L):this.w=L}getRepresentedFilename(){return y.$j?this.win?.getRepresentedFilename():this.w}setDocumentEdited(L){y.$j&&this.win?.setDocumentEdited(L),this.z=L}isDocumentEdited(){return y.$j?!!this.win?.isDocumentEdited():!!this.z}focus(L){y.$j&&L?.force&&n.app.focus({steal:!0});const N=this.win;N&&(N.isMinimized()&&N.restore(),N.focus())}handleTitleDoubleClick(){const L=this.win;if(L)if(y.$j)switch(n.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":L.minimize();break;case"None":break;case"Maximize":default:L.isMaximized()?L.unmaximize():L.maximize()}else L.isMaximized()?L.unmaximize():L.maximize()}static{this.C="windowControlHeight"}updateWindowControls(L){const N=this.win;if(N){if(L.height&&this.s.setItem(Y.C,L.height),y.$i&&this.D)N.setTitleBarOverlay({color:L.backgroundColor?.trim()===""?void 0:L.backgroundColor,symbolColor:L.foregroundColor?.trim()===""?void 0:L.foregroundColor,height:L.height?L.height-1:void 0});else if(y.$j&&L.height!==void 0){const G=(L.height-15)/2;G?N.setWindowButtonPosition({x:G,y:G}):N.setWindowButtonPosition(null)}}}toggleFullScreen(){this.H(!this.isFullScreen,!1)}H(L,N){(0,D.$aD)(this.r)?this.I(L,N):this.L(L)}get isFullScreen(){if(y.$j&&typeof this.F=="boolean")return this.F;const L=this.win,N=L?.isFullScreen(),G=L?.isSimpleFullScreen();return!!(N||G)}I(L,N){const G=this.win;G?.isSimpleFullScreen()&&G?.setSimpleFullScreen(!1),this.J(L,N)}J(L,N){if(y.$j){this.F=L;const q=this.G=new R.$Ch;(async()=>{const oe=await Promise.race([q.p,(0,R.$gh)(1e4).then(()=>!1)]);this.G===q&&(this.F=void 0,this.G=void 0,!oe&&L&&N&&this.win&&!this.win.isFullScreen()&&(this.u.warn("window: native macOS fullscreen transition did not happen within 10s from restoring"),this.h.fire()))})()}this.win?.setFullScreen(L)}L(L){const N=this.win;N?.isFullScreen()&&this.J(!1,!1),N?.setSimpleFullScreen(L),N?.webContents.focus()}dispose(){super.dispose(),this.m=null}}e.$6$b=Q;let Y=class extends Q{get id(){return this.P}get backupPath(){return this.R?.backupPath}get openedWorkspace(){return this.R?.workspace}get profile(){if(!this.config)return;const L=this.gb.profiles.find(N=>N.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&L?L:this.gb.getProfileForWorkspace(this.config.workspace??(0,E.$ti)(this.backupPath,this.isExtensionDevelopmentHost))??this.gb.defaultProfile}get remoteAuthority(){return this.R?.remoteAuthority}get config(){return this.R}get isExtensionDevelopmentHost(){return!!this.R?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.R?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.R?.debugId}constructor(L,N,G,q,oe,he,K,A,F,x,z,Z,H,_,B,ee,ie,de,me,Ee,Pe){super(x,Ee,q,N),this.eb=G,this.fb=oe,this.gb=he,this.hb=K,this.ib=A,this.jb=F,this.kb=z,this.lb=Z,this.mb=H,this.nb=_,this.ob=B,this.pb=ee,this.qb=ie,this.rb=de,this.sb=me,this.M=this.B(new C.$5d),this.onWillLoad=this.M.event,this.N=this.B(new C.$5d),this.onDidSignalReady=this.N.event,this.O=this.B(new C.$5d),this.onDidDestroy=this.O.event,this.W=[],this.X=[],this.Y=void 0,this.Z=void 0,this.$=void 0,this.ab=this.B(this.rb.createIPCObjectUrl()),this.db=!1,this.tb=0;{const[Le,ke]=this.Db(L.state);this.S=Le,this.u.trace("window#ctor: using window state",Le);const ye=this.S.mode===0||this.S.mode===3,te=Pe.invokeFunction(j.$Q$b,this.S,{show:!ye,webPreferences:{preload:d.$zg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.ab.resource.toString()}`],v8CacheOptions:this.t.useCodeCache?"bypassHeatCheck":"none"}});(0,c.mark)("code/willCreateCodeBrowserWindow"),this.m=new n.BrowserWindow(te),(0,c.mark)("code/didCreateCodeBrowserWindow"),this.P=this.m.id,this.n(this.m);const fe=this.r.getValue("window"),ge=y.$j&&fe?.nativeTabs===!0;(y.$j||y.$i)&&ke&&(!ge||n.BrowserWindow.getAllWindows().length===1)&&[this.S.width,this.S.height,this.S.x,this.S.y].every(Ie=>typeof Ie=="number")&&this.m.setBounds({width:this.S.width,height:this.S.height,x:this.S.x,y:this.S.y}),ye&&((0,c.mark)("code/willMaximizeCodeWindow"),this.m.maximize(),this.S.mode===3&&this.H(!0,!0),this.m.show(),(0,c.mark)("code/didMaximizeCodeWindow")),this.j=Date.now()}this.Ab(),this.Jb(),this.ub()}setReady(){for(this.u.trace(`window#load: window reported ready (id: ${this.P})`),this.tb=2;this.W.length;)this.W.pop()(this);this.N.fire()}ready(){return new Promise(L=>{if(this.isReady)return L(this);this.W.push(L)})}get isReady(){return this.tb===2}get whenClosedOrLoaded(){return new Promise(L=>{function N(){G.dispose(),q.dispose(),L()}const G=this.onDidClose(()=>N()),q=this.onWillLoad(()=>N())})}ub(){this.m.on("unresponsive",()=>this.xb(1)),this.m.webContents.on("render-process-gone",(N,G)=>this.xb(2,{...G})),this.m.webContents.on("did-fail-load",(N,G,q)=>this.xb(3,{reason:q,exitCode:G})),this.m.webContents.on("will-prevent-unload",N=>{N.preventDefault()}),this.m.webContents.on("did-finish-load",()=>{this.bb&&(this.R=this.bb,this.bb=void 0)}),this.B(this.onDidMaximize(()=>{this.R&&(this.R.maximized=!0)})),this.B(this.onDidUnmaximize(()=>{this.R&&(this.R.maximized=!1)})),this.B(this.onDidEnterFullScreen(()=>{this.sendWhenReady("vscode:enterFullScreen",P.CancellationToken.None)})),this.B(this.onDidLeaveFullScreen(()=>{this.sendWhenReady("vscode:leaveFullScreen",P.CancellationToken.None)})),this.B(this.r.onDidChangeConfiguration(N=>this.Ab(N))),this.B(this.lb.onDidDeleteUntitledWorkspace(N=>this.zb(N)));const L=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.m.webContents.session.webRequest.onBeforeSendHeaders({urls:L},async(N,G)=>{const q=await this.wb();G({cancel:!1,requestHeaders:Object.assign(N.requestHeaders,q)})})}wb(){return this.vb||(this.vb=(0,r.$Pp)(this.qb.version,this.qb,this.t,this.r,this.hb,this.ib,this.nb)),this.vb}async xb(L,N){switch(L){case 2:this.u.error(`CodeWindow: renderer process gone (reason: ${N?.reason||"<unknown>"}, code: ${N?.exitCode||"<unknown>"})`);break;case 1:this.u.error("CodeWindow: detected unresponsive");break;case 3:this.u.error(`CodeWindow: failed to load (reason: ${N?.reason||"<unknown>"}, code: ${N?.exitCode||"<unknown>"})`);break}switch(this.nb.publicLog2("windowerror",{type:L,reason:N?.reason,code:N?.exitCode}),L){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.pb.kill(1);return}if(this.t.args["enable-smoke-test-driver"]){await this.yb(!1,!1),this.pb.quit();return}if(L===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.m&&this.m.webContents&&this.m.webContents.isDevToolsOpened())return;const{response:G,checkboxChecked:q}=await this.ob.showMessageBox({type:"warning",buttons:[(0,k.localize)(0,null),(0,k.localize)(1,null),(0,k.localize)(2,null)],message:(0,k.localize)(3,null),detail:(0,k.localize)(4,null),checkboxLabel:this.R?.workspace?(0,k.localize)(5,null):void 0},this.m);if(G!==2){const oe=G===0;await this.yb(oe,q)}}else if(L===2){let G;N?G=(0,k.localize)(7,null,N.reason,N.exitCode??"<unknown>"):G=(0,k.localize)(6,null);const{response:q,checkboxChecked:oe}=await this.ob.showMessageBox({type:"warning",buttons:[this.R?.workspace?(0,k.localize)(8,null):(0,k.localize)(9,null),(0,k.localize)(10,null)],message:G,detail:this.R?.workspace?(0,k.localize)(11,null):(0,k.localize)(12,null),checkboxLabel:this.R?.workspace?(0,k.localize)(13,null):void 0},this.m),he=q===0;await this.yb(he,oe)}break}}async yb(L,N){const G=this.R?.workspace;if(N&&G)try{const q=this.jb.workspaceStorage(G);await q.init(),q.delete("memento/workbench.parts.editor"),await q.close()}catch(q){this.u.error(q)}this.O.fire();try{if(L&&this.R){let q,oe;(0,E.$pi)(G)?q={folderUri:G.uri}:(0,E.$ui)(G)?q={workspaceUri:G.configPath}:oe=!0,(0,le.$Ob)(await this.sb.open({context:5,userEnv:this.R.userEnv,cli:{...this.t.args,_:[]},urisToOpen:q?[q]:void 0,forceEmpty:oe,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}finally{this.m?.destroy()}}zb(L){this.R?.workspace?.id===L.id&&(this.R.workspace=void 0)}Ab(L){if(!L||L.affectsConfiguration("window.menuBarVisibility")){const N=this.Fb();N!==this.U&&(this.U=N,this.Gb(N))}if(!L||L.affectsConfiguration("http.proxy")){let N=(this.r.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;N?.endsWith("/")&&(N=N.substr(0,N.length-1));const G=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((N||"").indexOf("@")===-1&&(N!==this.Y||G!==this.Z)){this.Y=N,this.Z=G;const q=N||"",oe=G?`${G},<local>`:"<local>";this.u.trace(`Setting proxy to '${q}', bypassing '${oe}'`),this.m.webContents.session.setProxy({proxyRules:q,proxyBypassRules:oe,pacScript:""})}}}addTabbedWindow(L){y.$j&&L.win&&this.m.addTabbedWindow(L.win)}load(L,N=Object.create(null)){this.u.trace(`window#load: attempt to load window (id: ${this.P})`),this.isDocumentEdited()&&(!N.isReload||!this.mb.isHotExitEnabled())&&this.setDocumentEdited(!1),N.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.m.setTitle(this.qb.nameLong)),this.Bb(L,N),this.tb===0?this.R=L:this.bb=L,this.tb=1,this.m.loadURL(d.$zg.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.t.isBuilt?"":"-dev"}.html`).toString(!0));const G=this.db;this.db=!0,!this.t.isBuilt&&!this.t.extensionTestsLocationURI&&this.B(new R.$rh(()=>{this.m&&!this.m.isVisible()&&!this.m.isMinimized()&&(this.m.show(),this.focus({force:!0}),this.m.webContents.openDevTools())},1e4)).schedule(),this.M.fire({workspace:L.workspace,reason:N.isReload?3:G?2:1})}Bb(L,N){const G=(this.R??this.bb)?.userEnv;if(G){const q=(0,f.$dm)(G)&&!(0,f.$dm)(L.userEnv),oe=this.isExtensionDevelopmentHost;(q||oe)&&(L.userEnv={...G,...L.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(L.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),N.disableExtensions!==void 0&&(L["disable-extensions"]=N.disableExtensions),L.fullscreen=this.isFullScreen,L.maximized=this.m.isMaximized(),L.partsSplash=this.kb.getWindowSplash(),L.zoomLevel=this.Ib(),L.isCustomZoomLevel=typeof this.$=="number",L.isCustomZoomLevel&&L.partsSplash&&(L.partsSplash.zoomLevel=L.zoomLevel),(0,c.mark)("code/willOpenNewWindow"),L.perfMarks=(0,c.getMarks)(),this.ab.update(L)}async reload(L){const N=Object.assign({},this.R);N.workspace=await this.Cb(N),delete N.filesToOpenOrCreate,delete N.filesToDiff,delete N.filesToMerge,delete N.filesToWait,this.isExtensionDevelopmentHost&&L&&(N.verbose=L.verbose,N.debugId=L.debugId,N.extensionEnvironment=L.extensionEnvironment,N["inspect-extensions"]=L["inspect-extensions"],N["inspect-brk-extensions"]=L["inspect-brk-extensions"],N["extensions-dir"]=L["extensions-dir"]),N.accessibilitySupport=n.app.isAccessibilitySupportEnabled(),N.isInitialStartup=!1,N.policiesData=this.fb.serialize(),N.continueOn=this.t.continueOn,N.profiles={all:this.gb.profiles,profile:this.profile||this.gb.defaultProfile,home:this.gb.profilesHome},N.logLevel=this.eb.getLogLevel(),N.loggers={window:this.eb.getRegisteredLoggers(this.id),global:this.eb.getRegisteredLoggers()},this.load(N,{isReload:!0,disableExtensions:L?.["disable-extensions"]})}async Cb(L){if((0,E.$ui)(L.workspace)){const N=L.workspace.configPath;if(N.scheme===d.Schemas.file&&!await this.hb.exists(N))return}else if((0,E.$pi)(L.workspace)){const N=L.workspace.uri;if(N.scheme===d.Schemas.file&&!await this.hb.exists(N))return}return L.workspace}serializeWindowState(){if(!this.m)return(0,M.$C$b)();if(this.isFullScreen){let G;try{G=n.screen.getDisplayMatching(this.getBounds())}catch{}const q=(0,M.$C$b)();return{mode:3,display:G?G.id:void 0,width:this.S.width||q.width,height:this.S.height||q.height,x:this.S.x||0,y:this.S.y||0,zoomLevel:this.$}}const L=Object.create(null);let N;if(!y.$j&&this.m.isMaximized()?N=0:N=1,N===0?L.mode=0:L.mode=1,N===1||N===0){let G;N===1?G=this.getBounds():G=this.m.getNormalBounds(),L.x=G.x,L.y=G.y,L.width=G.width,L.height=G.height}return L.zoomLevel=this.$,L}Db(L){(0,c.mark)("code/willRestoreCodeWindowState");let N=!1;if(L){this.$=L.zoomLevel;try{const G=n.screen.getAllDisplays();N=G.length>1,L=j.WindowStateValidator.validateWindowState(this.u,L,G)}catch(G){this.u.warn(`Unexpected error validating window state: ${G}
${G.stack}`)}}return(0,c.mark)("code/didRestoreCodeWindowState"),[L||(0,M.$C$b)(),N]}getBounds(){const[L,N]=this.m.getPosition(),[G,q]=this.m.getSize();return{x:L,y:N,width:G,height:q}}H(L,N){super.H(L,N),this.sendWhenReady(L?"vscode:enterFullScreen":"vscode:leaveFullScreen",P.CancellationToken.None),this.U&&this.Gb(this.U,!1)}Fb(){let L=(0,D.$8C)(this.r);return["visible","toggle","hidden"].indexOf(L)<0&&(L="classic"),L}Gb(L,N=!0){y.$j||(L==="toggle"&&N&&this.send("vscode:showInfoMessage",(0,k.localize)(14,null)),L==="hidden"?setTimeout(()=>{this.Hb(L)}):this.Hb(L))}Hb(L){const N=this.isFullScreen;switch(L){case"classic":this.m.setMenuBarVisibility(!N),this.m.autoHideMenuBar=N;break;case"visible":this.m.setMenuBarVisibility(!0),this.m.autoHideMenuBar=!1;break;case"toggle":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!0;break;case"hidden":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!1;break}}notifyZoomLevel(L){this.$=L}Ib(){return typeof this.$=="number"?this.$:this.r.getValue("window")?.zoomLevel}close(){this.m?.close()}sendWhenReady(L,N,...G){this.isReady?this.send(L,...G):this.ready().then(()=>{N.isCancellationRequested||this.send(L,...G)})}send(L,...N){if(this.m){if(this.m.isDestroyed()||this.m.webContents.isDestroyed()){this.u.warn(`Sending IPC message to channel '${L}' for window that is destroyed`);return}try{this.m.webContents.send(L,...N)}catch(G){this.u.warn(`Error sending IPC message to channel '${L}' of window ${this.P}: ${(0,O.$3i)(G)}`)}}}updateTouchBar(L){y.$j&&this.X.forEach((N,G)=>{const q=L[G];N.segments=this.Lb(q)})}Jb(){if(y.$j){for(let L=0;L<10;L++){const N=this.Kb();this.X.push(N)}this.m.setTouchBar(new n.TouchBar({items:this.X}))}}Kb(L=[]){const N=this.Lb(L),G=new n.TouchBar.TouchBarSegmentedControl({segments:N,mode:"buttons",segmentStyle:"automatic",change:q=>{this.sendWhenReady("vscode:runAction",P.CancellationToken.None,{id:G.segments[q].id,from:"touchbar"})}});return G}Lb(L=[]){return L.map(G=>{let q;G.icon&&!l.ThemeIcon.isThemeIcon(G.icon)&&G.icon?.dark?.scheme===d.Schemas.file&&(q=n.nativeImage.createFromPath(v.URI.revive(G.icon.dark).fsPath),q.isEmpty()&&(q=void 0));let oe;return typeof G.title=="string"?oe=G.title:oe=G.title.value,{id:G.id,label:q?void 0:oe,icon:q}})}dispose(){super.dispose(),this.eb.deregisterLoggers(this.id)}};e.$7$b=Y,e.$7$b=Y=ve([se(1,a.$zj),se(2,J.$4$b),se(3,u.$E$b),se(4,T.$Yn),se(5,V.$S$b),se(6,h.$Fk),se(7,i.$e_b),se(8,i.$c_b),se(9,w.$Li),se(10,b.$N$b),se(11,I.$2$b),se(12,m.$J$b),se(13,s.$El),se(14,p.$K$b),se(15,g.$9$b),se(16,t.$Rj),se(17,o.$M$b),se(18,j.$P$b),se(19,W.$AP),se(20,re.$ei)],Y)}),define(ae[304],ce([0,1,14,4,18,24,20,5,34,55,135]),function(X,e,n,R,P,O,C,S,d,c,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8$b=void 0;let v=class extends y.$6$b{get win(){return super.win||this.tryClaimWindow(),super.win}constructor($,m,w,p,u,f){super(p,u,m,w),this.M=$,this.N=f,this.id=this.M.id,this.parentId=-1,this.tryClaimWindow()}tryClaimWindow(){if(this.m||this.q.isDisposed||this.M.isDestroyed())return;const $=n.BrowserWindow.fromWebContents(this.M);$&&(this.u.trace("[aux window] Claimed browser window instance"),this.n($),$.setMenu(null),(R.$i||R.$k)&&(0,c.$0C)(this.r)&&$.setAutoHideMenuBar(!0),this.N.registerAuxWindow(this))}};e.$8$b=v,e.$8$b=v=ve([se(1,O.$E$b),se(2,S.$zj),se(3,P.$Li),se(4,d.$AP),se(5,C.$9$b)],v)}),define(ae[305],ce([0,1,14,3,2,13,37,304,6,5,81,29]),function(X,e,n,R,P,O,C,S,d,c,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zac=void 0;let k=class extends P.$Tc{constructor(m,w){super(),this.h=m,this.j=w,this.a=this.B(new R.$5d),this.onDidMaximizeWindow=this.a.event,this.b=this.B(new R.$5d),this.onDidUnmaximizeWindow=this.b.event,this.c=this.B(new R.$5d),this.onDidChangeFullScreen=this.c.event,this.f=this.B(new R.$5d),this.onDidTriggerSystemContextMenu=this.f.event,this.g=new Map,this.m()}m(){n.app.on("browser-window-created",(m,w)=>{const p=this.getWindowById(w.id);p&&(this.j.trace('[aux window] app.on("browser-window-created"): Trying to claim auxiliary window'),p.tryClaimWindow())}),C.$KV.handle("vscode:registerAuxiliaryWindow",async(m,w)=>{const p=this.getWindowById(m.sender.id);return p&&(this.j.trace("[aux window] vscode:registerAuxiliaryWindow: Registering auxiliary window to main window"),p.parentId=w),m.sender.id})}createWindow(m){return this.h.invokeFunction(v.$Q$b,this.n(m),{webPreferences:{preload:O.$zg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-aux.js").fsPath}})}n(m){const w={},p=m.features.split(",");for(const f of p){const[h,g]=f.split("=");switch(h){case"width":w.width=parseInt(g,10);break;case"height":w.height=parseInt(g,10);break;case"left":w.x=parseInt(g,10);break;case"top":w.y=parseInt(g,10);break}}const u=v.WindowStateValidator.validateWindowState(this.j,w)??(0,y.$D$b)();return this.j.trace("[aux window] using window state",u),u}registerWindow(m){const w=new P.$Sc,p=this.h.createInstance(S.$8$b,m);this.g.set(p.id,p),w.add((0,P.$Rc)(()=>this.g.delete(p.id))),w.add(p.onDidMaximize(()=>this.a.fire(p))),w.add(p.onDidUnmaximize(()=>this.b.fire(p))),w.add(p.onDidEnterFullScreen(()=>this.c.fire({window:p,fullscreen:!0}))),w.add(p.onDidLeaveFullScreen(()=>this.c.fire({window:p,fullscreen:!1}))),w.add(p.onDidTriggerSystemContextMenu(({x:u,y:f})=>this.f.fire({window:p,x:u,y:f}))),R.Event.once(p.onDidClose)(()=>w.dispose())}getWindowById(m){return this.g.get(m)}getFocusedWindow(){const m=n.BrowserWindow.getFocusedWindow();if(m)return this.getWindowById(m.id)}getLastActiveWindow(){return(0,v.$R$b)(Array.from(this.g.values()))}getWindows(){return Array.from(this.g.values())}};e.$zac=k,e.$zac=k=ve([se(0,d.$ei),se(1,c.$zj)],k)}),define(ae[84],ce([0,1,14,22,8,3,47,2,13,4,19,7,21,195,6,20,5,83,98,30,58,31,56]),function(X,e,n,R,P,O,C,S,d,c,y,v,k,$,m,w,p,u,f,h,g,a,t){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$O_b=e.$N_b=void 0,e.$N_b=(0,m.$fi)("workspacesHistoryMainService");let r=class extends S.$Tc{static{o=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(s,l,b,D,j){super(),this.f=s,this.g=l,this.h=b,this.j=D,this.m=j,this.c=this.B(new O.$5d),this.onDidChangeRecentlyOpened=this.c.event,this.H=this.B(new P.$dh(800)),this.n()}n(){this.h.when(4).then(()=>this.I()),this.B(this.g.onDidEnterWorkspace(s=>this.addRecentlyOpened([{workspace:s.workspace,remoteAuthority:s.window.remoteAuthority}])))}async addRecentlyOpened(s){let l=[],b=[];for(const j of s)if((0,f.$ieb)(j))!this.g.isUntitledWorkspace(j.workspace)&&!this.w(l,j.workspace)&&l.push(j);else if((0,f.$jeb)(j))this.y(l,j.folderUri)||l.push(j);else{const E=this.z(b,j.fileUri),I=j.fileUri.scheme===d.Schemas.file&&o.G.indexOf((0,y.$Pg)(j.fileUri))>=0;!E&&!I&&(b.push(j),c.$i&&j.fileUri.scheme===d.Schemas.file&&n.app.addRecentDocument(j.fileUri.fsPath))}const D=await this.r({workspaces:l,files:b});l=D.workspaces,b=D.files,l.length>o.a&&(l.length=o.a),b.length>o.a&&(b.length=o.a),await this.t({workspaces:l,files:b}),this.c.fire(),c.$j&&this.H.trigger(()=>this.N())}async removeRecentlyOpened(s){const l=E=>{const I=this.u(E);for(const M of s)if(y.$Jg.isEqual(M,I))return!1;return!0},b=await this.getRecentlyOpened(),D=b.workspaces.filter(l),j=b.files.filter(l);(D.length!==b.workspaces.length||j.length!==b.files.length)&&(await this.t({files:j,workspaces:D}),this.c.fire(),c.$j&&this.H.trigger(()=>this.N()))}async clearRecentlyOpened(s){if(s?.confirm){const{response:l}=await this.m.showMessageBox({type:"warning",buttons:[(0,$.localize)(0,null),(0,$.localize)(1,null)],message:(0,$.localize)(2,null),detail:(0,$.localize)(3,null),cancelId:1});if(l!==0)return}await this.t({workspaces:[],files:[]}),n.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.r()}async r(s){const l=new a.$Ac(j=>y.$Jg.getComparisonKey(j));if(s?.workspaces)for(const j of s.workspaces)l.set(this.u(j),j);const b=new a.$Ac(j=>y.$Jg.getComparisonKey(j));if(s?.files)for(const j of s.files)b.set(this.u(j),j);const D=await this.s();for(const j of D.workspaces){const E=l.get(this.u(j));E?E.label=E.label??j.label:l.set(this.u(j),j)}for(const j of D.files){const E=b.get(this.u(j));E?E.label=E.label??j.label:b.set(this.u(j),j)}return{workspaces:[...l.values()],files:[...b.values()]}}async s(){await this.j.whenReady;let s;const l=this.j.get(o.b,-1);if(typeof l=="string")try{s=JSON.parse(l)}catch(b){this.f.error("Unexpected error parsing opened paths list",b)}return(0,f.$peb)(s,this.f)}async t(s){await this.j.whenReady,this.j.store(o.b,JSON.stringify((0,f.$qeb)(s)),-1,1)}u(s){return(0,f.$jeb)(s)?s.folderUri:(0,f.$keb)(s)?s.fileUri:s.workspace.configPath}w(s,l){return!!s.find(b=>(0,f.$ieb)(b)&&b.workspace.id===l.id)}y(s,l){return!!s.find(b=>(0,f.$jeb)(b)&&y.$Jg.isEqual(b.folderUri,l))}z(s,l){return!!s.find(b=>y.$Jg.isEqual(b.fileUri,l))}static{this.C=7}static{this.D=10}static{this.F=7}static{this.G=["COMMIT_EDITMSG","MERGE_MSG"]}async I(){c.$i&&(await this.J(),this.B(this.onDidChangeRecentlyOpened(()=>this.J())))}async J(){if(!c.$i)return;const s=[];if(s.push({type:"tasks",items:[{type:"task",title:(0,$.localize)(4,null),description:(0,$.localize)(5,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const l=[];for(const j of n.app.getJumpListSettings().removedItems){const E=j.args;if(E){const I=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(E);I&&l.push(v.URI.parse(I[2]))}}await this.removeRecentlyOpened(l);let b=!1;const D=(0,R.$Hb)((await this.getRecentlyOpened()).workspaces.slice(0,o.F).map(j=>{const E=(0,f.$ieb)(j)?j.workspace:j.folderUri,{title:I,description:M}=this.L(E,j.label);let T;return v.URI.isUri(E)?T=`--folder-uri "${E.toString()}"`:(b=!0,T=`--file-uri "${E.configPath.toString()}"`),{type:"task",title:I.substr(0,255),description:M.substr(0,255),program:process.execPath,args:T,iconPath:"explorer.exe",iconIndex:0}}));D.length>0&&s.push({type:"custom",name:b?(0,$.localize)(6,null):(0,$.localize)(7,null),items:D})}s.push({type:"recent"});try{const l=n.app.setJumpList(s);l&&l!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${l}`)}catch(l){this.f.warn("updateWindowsJumpList#setJumpList",l)}}L(s,l){if(l)return{title:(0,C.$hw)(l).name,description:l};if(v.URI.isUri(s))return{title:(0,y.$Pg)(s),description:this.M(s)};if(this.g.isUntitledWorkspace(s))return{title:(0,$.localize)(8,null),description:""};let b=(0,y.$Pg)(s.configPath);return b.endsWith(h.$Bi)&&(b=b.substr(0,b.length-h.$Bi.length-1)),{title:(0,$.localize)(9,null,b),description:this.M(s.configPath)}}M(s){return s.scheme==="file"?(0,C.$_v)(s.fsPath):s.toString()}async N(){if(!c.$j)return;n.app.clearRecentDocuments();const s=await this.getRecentlyOpened(),l=[];let b=0;for(let j=0;j<s.workspaces.length&&b<o.C;j++){const E=this.u(s.workspaces[j]);if(E.scheme===d.Schemas.file){const I=(0,y.$Gg)(E);await k.Promises.exists(I)&&(l.push(I),b++)}}const D=[];for(let j=0;j<s.files.length&&b<o.D;j++){const E=this.u(s.files[j]);if(E.scheme===d.Schemas.file){const I=(0,y.$Gg)(E);if(o.G.includes((0,y.$Pg)(E))||l.includes(I))continue;await k.Promises.exists(I)&&(D.push(I),b++)}}D.reverse().forEach(j=>n.app.addRecentDocument(j)),l.reverse().forEach(j=>n.app.addRecentDocument(j))}};e.$O_b=r,e.$O_b=r=o=ve([se(0,p.$zj),se(1,g.$2$b),se(2,w.$9$b),se(3,u.$e_b),se(4,t.$K$b)],r)}),define(ae[306],ce([0,1,14,8,23,47,4,7,183,78,18,24,20,5,233,70,27,34,28,49,55,29,84]),function(X,e,n,R,P,O,C,S,d,c,y,v,k,$,m,w,p,u,f,h,g,a,t){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$P_b=void 0;const r="menu";let i=class{static{o=this}static{this.a="lastKnownMenubarData"}constructor(b,D,j,E,I,M,T,W,V,J,le,re){this.n=b,this.o=D,this.p=j,this.q=E,this.r=I,this.s=M,this.t=T,this.u=W,this.v=V,this.w=J,this.x=le,this.y=re,this.m=Object.create(null),this.g=new R.$rh(()=>this.F(),0),this.h=new R.$rh(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(C.$j||(0,g.$0C)(D))&&this.z(),this.A(),this.d=!1,this.f=!1,this.j=[],this.I(),this.B()}z(){const b=this.t.getItem(o.a);b&&(b.menus&&(this.k=b.menus),b.keybindings&&(this.l=b.keybindings))}A(){this.m["workbench.action.files.newUntitledFile"]=(M,T,W)=>{this.Y({type:"commandId",commandId:"workbench.action.files.newUntitledFile"})||this.p.openEmptyWindow({context:2,contextWindowId:T?.id})},this.m["workbench.action.newWindow"]=(M,T,W)=>this.p.openEmptyWindow({context:2,contextWindowId:T?.id}),this.m["workbench.action.files.openFileFolder"]=(M,T,W)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.R(W),telemetryExtraData:{from:r}}),this.m["workbench.action.files.openFolder"]=(M,T,W)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.R(W),telemetryExtraData:{from:r}}),this.m["workbench.action.openWorkspace"]=(M,T,W)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.R(W),telemetryExtraData:{from:r}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened({confirm:!0});const b=this.x.youTubeUrl;b&&(this.m["workbench.action.openYouTubeUrl"]=()=>this.ab(b,"openYouTubeUrl"));const D=this.x.requestFeatureUrl;D&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.ab(D,"openUserVoiceUrl"));const j=this.x.reportIssueUrl;j&&(this.m["workbench.action.openIssueReporter"]=()=>this.ab(j,"openReportIssues"));const E=this.x.licenseUrl;E&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(C.$w){const M=E.indexOf("?")>0?"&":"?";this.ab(`${E}${M}lang=${C.$w}`,"openLicenseUrl")}else this.ab(E,"openLicenseUrl")});const I=this.x.privacyStatementUrl;I&&E&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.ab(I,"openPrivacyStatement")})}B(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(b=>this.G(b)),this.w.onDidBlurMainWindow(()=>this.H()),this.w.onDidFocusMainWindow(()=>this.H())}get C(){const b=this.o.getValue("window.enableMenuBarMnemonics");return typeof b!="boolean"?!0:b}get D(){if(!C.$j)return!1;const b=this.o.getValue("window.nativeTabs");return typeof b!="boolean"?!1:b}updateMenu(b,D){this.k=b.menus,this.l=b.keybindings,this.t.setItem(o.a,b),this.E()}E(){this.g.schedule()}F(){this.b||setTimeout(()=>{this.b||this.I()},10)}G(b){C.$j&&(b.oldCount===0&&b.newCount>0||b.oldCount>0&&b.newCount===0)&&(this.d=b.newCount===0,this.E())}H(){if(!C.$j)return;const b=n.BrowserWindow.getFocusedWindow();this.f=!b||!!this.y.getWindowById(b.id),this.E()}I(){const b=n.Menu.getApplicationMenu();if(b&&this.j.push(b),Object.keys(this.k).length===0){this.J(C.$j?new n.Menu:null);return}const D=new n.Menu;let j;if(C.$j){const I=new n.Menu;j=new n.MenuItem({label:this.x.nameShort,submenu:I}),this.K(I),D.append(j)}if(C.$j&&!this.c){this.c=!0;const I=new n.Menu;I.append(new n.MenuItem({label:this.cb(d.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),n.app.dock.setMenu(I)}if(this.M("File")){const I=new n.Menu,M=new n.MenuItem({label:this.cb(d.localize(1,null)),submenu:I});this.O(I,"File"),D.append(M)}if(this.M("Edit")){const I=new n.Menu,M=new n.MenuItem({label:this.cb(d.localize(2,null)),submenu:I});this.O(I,"Edit"),D.append(M)}if(this.M("Selection")){const I=new n.Menu,M=new n.MenuItem({label:this.cb(d.localize(3,null)),submenu:I});this.O(I,"Selection"),D.append(M)}if(this.M("View")){const I=new n.Menu,M=new n.MenuItem({label:this.cb(d.localize(4,null)),submenu:I});this.O(I,"View"),D.append(M)}if(this.M("Go")){const I=new n.Menu,M=new n.MenuItem({label:this.cb(d.localize(5,null)),submenu:I});this.O(I,"Go"),D.append(M)}if(this.M("Run")){const I=new n.Menu,M=new n.MenuItem({label:this.cb(d.localize(6,null)),submenu:I});this.O(I,"Run"),D.append(M)}if(this.M("Terminal")){const I=new n.Menu,M=new n.MenuItem({label:this.cb(d.localize(7,null)),submenu:I});this.O(I,"Terminal"),D.append(M)}let E;if(this.M("Window")){const I=new n.Menu;E=new n.MenuItem({label:this.cb(d.localize(8,null)),submenu:I,role:"window"}),this.U(I)}if(E&&D.append(E),this.M("Help")){const I=new n.Menu,M=new n.MenuItem({label:this.cb(d.localize(9,null)),submenu:I,role:"help"});this.O(I,"Help"),D.append(M)}D.items&&D.items.length>0?this.J(D):this.J(null),this.h.schedule()}J(b){if(n.Menu.setApplicationMenu(b),b)for(const D of this.y.getWindows())D.win?.setMenu(null)}K(b){const D=this.W(d.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),j=this.V();let E;if(this.M("Preferences")){const re=new n.Menu;this.O(re,"Preferences"),E=new n.MenuItem({label:this.cb(d.localize(11,null)),submenu:re})}const I=new n.Menu,M=new n.MenuItem({label:d.localize(12,null),role:"services",submenu:I}),T=new n.MenuItem({label:d.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),W=new n.MenuItem({label:d.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),V=new n.MenuItem({label:d.localize(15,null),role:"unhide"}),J=new n.MenuItem(this.$("workbench.action.quit",{label:d.localize(16,null,this.x.nameLong),click:async(re,ue,Q)=>{const Y=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||n.BrowserWindow.getFocusedWindow()||Y?.win?.isMinimized())&&await this.L(Q)&&this.w.quit(void 0)}})),le=[D];le.push(...j),E&&le.push(s(),E),le.push(s(),M,s(),T,W,V,s(),J),le.forEach(re=>b.append(re))}async L(b){if(this.p.getWindowCount()===0)return!0;const D=this.o.getValue("window.confirmBeforeClose");if(D==="always"||D==="keyboardOnly"&&this.S(b)){const{response:j}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,{type:"question",buttons:[d.localize(17,null),d.localize(18,null)],message:d.localize(19,null)});return j===0}return!0}M(b){if(!C.$j&&!(0,g.$0C)(this.o))return!1;switch(b){case"File":case"Help":if(C.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[b];case"Window":if(C.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[b]}}N(b,D){D.forEach(j=>{if((0,m.$K_b)(j))b.append(s());else if((0,m.$J_b)(j)){const E=new n.Menu,I=new n.MenuItem({label:this.cb(j.label),submenu:E});this.N(E,j.submenu.items),b.append(I)}else(0,m.$L_b)(j)?b.append(this.Q(j)):(0,m.$M_b)(j)&&(j.id==="workbench.action.showAboutDialog"&&this.P(b),C.$j?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[j.id]?b.append(new n.MenuItem(this.$(j.id,{label:this.cb(j.label),click:this.m[j.id]}))):b.append(this.W(j.label,j.id,!1,j.checked)):b.append(this.W(j.label,j.id,j.enabled!==!1,!!j.checked)):b.append(this.W(j.label,j.id,j.enabled!==!1,!!j.checked)))})}O(b,D){this.k&&this.k[D]&&this.N(b,this.k[D].items)}P(b){const D=this.V();D.length&&(D.forEach(j=>b.append(j)),b.append(s()))}Q(b){const D=S.URI.revive(b.uri),j=b.id,E=j==="openRecentFile"?{fileUri:D}:j==="openRecentWorkspace"?{workspaceUri:D}:{folderUri:D};return new n.MenuItem(this.$(j,{label:b.label,click:async(I,M,T)=>{const W=this.R(T);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[E],forceNewWindow:W,gotoLineMode:!1,remoteAuthority:b.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([D])}},!1))}R(b){return!!(b&&(!C.$j&&(b.ctrlKey||b.shiftKey)||C.$j&&(b.metaKey||b.altKey)))}S(b){return!!(b.triggeredByAccelerator||b.altKey||b.ctrlKey||b.metaKey||b.shiftKey)}T(b,D,j){const E={label:this.cb(b),role:j,enabled:!0};return new n.MenuItem(this.Z(D,E))}U(b){const D=new n.MenuItem({label:d.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),j=new n.MenuItem({label:d.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),E=new n.MenuItem({label:d.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),I=this.W(d.localize(23,null),"workbench.action.switchWindow"),M=[];this.D&&(M.push(s()),M.push(this.W(d.localize(24,null),"workbench.action.newWindowTab")),M.push(this.T(d.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),M.push(this.T(d.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),M.push(this.T(d.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),M.push(this.T(d.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[D,j,s(),I,...M,s(),E].forEach(T=>b.append(T))}V(){switch(this.n.state.type){case"idle":return[new n.MenuItem({label:this.cb(d.localize(29,null)),click:()=>setTimeout(()=>{this.bb("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new n.MenuItem({label:d.localize(30,null),enabled:!1})];case"available for download":return[new n.MenuItem({label:this.cb(d.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new n.MenuItem({label:d.localize(32,null),enabled:!1})];case"downloaded":return[new n.MenuItem({label:this.cb(d.localize(33,null)),click:()=>{this.bb("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new n.MenuItem({label:d.localize(34,null),enabled:!1})];case"ready":return[new n.MenuItem({label:this.cb(d.localize(35,null)),click:()=>{this.bb("RestartToUpdate"),this.n.quitAndInstall()}})];default:return[]}}W(b,D,j,E){const I=this.cb(b),M=typeof D=="function"?D:(le,re,ue)=>{const Q=le?le.userSettingsLabel:null;let Y=D;Array.isArray(D)&&(Y=this.R(ue)?D[1]:D[0]),Q&&ue.triggeredByAccelerator?this.Y({type:"keybinding",userSettingsLabel:Q}):this.Y({type:"commandId",commandId:Y})},T=typeof j=="boolean"?j:this.p.getWindowCount()>0,W=typeof E=="boolean"?E:!1,V={label:I,click:M,enabled:T};W&&(V.type="checkbox",V.checked=W);let J;return typeof D=="string"?J=D:Array.isArray(D)&&(J=D[0]),C.$j&&(J==="editor.action.clipboardCutAction"?V.role="cut":J==="editor.action.clipboardCopyAction"?V.role="copy":J==="editor.action.clipboardPasteAction"&&(V.role="paste"),J==="undo"?V.click=this.X(M,{inDevTools:le=>le.undo(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("undo:")}):J==="redo"?V.click=this.X(M,{inDevTools:le=>le.redo(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("redo:")}):J==="editor.action.selectAll"&&(V.click=this.X(M,{inDevTools:le=>le.selectAll(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("selectAll:")}))),new n.MenuItem(this.Z(J,V))}X(b,D){return(j,E,I)=>{const M=n.BrowserWindow.getFocusedWindow();if(!M)return D.inNoWindow();if(M.webContents.isDevToolsFocused()&&M.webContents.devToolsWebContents)return D.inDevTools(M.webContents.devToolsWebContents);b(j,E||M,I)}}Y(b){let D=n.BrowserWindow.getFocusedWindow();if(D){const E=this.y.getWindowById(D.id);E&&(D=this.p.getWindowById(E.parentId)?.win??null)}if(!D){const E=this.p.getLastActiveWindow();E?.win?.isMinimized()&&(D=E.win)}const j=D?this.p.getWindowById(D.id):void 0;if(j){if(this.v.trace("menubar#runActionInRenderer",b),C.$j&&!this.q.isBuilt&&!j.isReady&&(b.type==="commandId"&&b.commandId==="workbench.action.toggleDevTools"||b.type!=="commandId"&&b.userSettingsLabel==="alt+cmd+i"))return!1;if(b.type==="commandId"){const E={id:b.commandId,from:"menu"};j.sendWhenReady("vscode:runAction",P.CancellationToken.None,E)}else{const E={userSettingsLabel:b.userSettingsLabel};j.sendWhenReady("vscode:runKeybinding",P.CancellationToken.None,E)}return!0}else return this.v.trace("menubar#runActionInRenderer: no active window found",b),!1}Z(b,D){const j=typeof b=="string"?this.l[b]:void 0;if(j?.label){if(j.isNative!==!1)D.accelerator=j.label,D.userSettingsLabel=j.userSettingsLabel;else if(typeof D.label=="string"){const E=D.label.indexOf("[");E>=0?D.label=`${D.label.substr(0,E)} [${j.label}]`:D.label=`${D.label} [${j.label}]`}}else D.accelerator=void 0;return D}$(b,D,j=!D.accelerator){j&&(D=this.Z(b,D));const E=D.click;return D.click=(I,M,T)=>{this.bb(b),E?.(I,M,T)},D}ab(b,D){this.w.openExternal(void 0,b),this.bb(D)}bb(b){this.r.publicLog2("workbenchActionExecuted",{id:b,from:r})}cb(b){return(0,O.$ew)(b,!this.C)}};e.$P_b=i,e.$P_b=i=o=ve([se(0,h.$JW),se(1,y.$Li),se(2,a.$P$b),se(3,v.$E$b),se(4,f.$El),se(5,t.$N_b),se(6,u.$AP),se(7,k.$9$b),se(8,$.$zj),se(9,w.$B_b),se(10,p.$Rj),se(11,c.$A_b)],i);function s(){return new n.MenuItem({type:"separator"})}}),define(ae[307],ce([0,1,6,20,5,306]),function(X,e,n,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R_b=e.$Q_b=void 0,e.$Q_b=(0,n.$fi)("menubarMainService");let C=class{constructor(d,c,y){this.b=d,this.c=c,this.d=y,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(O.$P_b)}async updateMenubar(d,c){this.d.trace("menubarService#updateMenubar",d),(await this.a).updateMenu(c,d)}};e.$R_b=C,e.$R_b=C=ve([se(0,n.$ei),se(1,R.$9$b),se(2,P.$zj)],C)}),define(ae[308],ce([0,1,14,21,133,26,22,23,3,33,47,2,13,9,66,4,36,19,12,7,193,64,18,56,24,16,6,20,5,79,80,68,34,55,135,29,132,300,30,99,84,58,69,39,57,67,78]),function(X,e,n,R,P,O,C,S,d,c,y,v,k,$,m,w,p,u,f,h,g,a,t,o,r,i,s,l,b,D,j,E,I,M,T,W,V,J,le,re,ue,Q,Y,U,L,N,G){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fac=void 0;function q(K){return(0,le.$ui)(K?.workspace)}function oe(K){return(0,le.$pi)(K?.workspace)}let he=class extends v.$Tc{constructor(A,F,x,z,Z,H,_,B,ee,ie,de,me,Ee,Pe,Le,ke,ye,te,fe,ge){super(),this.s=A,this.t=F,this.u=x,this.w=z,this.z=Z,this.C=H,this.D=_,this.F=B,this.G=ee,this.H=ie,this.I=de,this.J=me,this.L=Ee,this.M=Pe,this.N=Le,this.O=ke,this.P=ye,this.Q=te,this.R=fe,this.S=ge,this.a=this.B(new d.$5d),this.onDidOpenWindow=this.a.event,this.b=this.B(new d.$5d),this.onDidSignalReadyWindow=this.b.event,this.c=this.B(new d.$5d),this.onDidDestroyWindow=this.c.event,this.f=this.B(new d.$5d),this.onDidChangeWindowsCount=this.f.event,this.g=this.B(new d.$5d),this.onDidMaximizeWindow=this.g.event,this.h=this.B(new d.$5d),this.onDidUnmaximizeWindow=this.h.event,this.j=this.B(new d.$5d),this.onDidChangeFullScreen=this.j.event,this.m=this.B(new d.$5d),this.onDidTriggerSystemContextMenu=this.m.event,this.n=new Map,this.r=this.B(new J.$cac(this,this.C,this.H,this.w,this.J)),this.U()}U(){this.B(this.M.onDidEnterWorkspace(A=>this.b.fire(A.window))),this.B(this.onDidSignalReadyWindow(A=>{if(A.config?.extensionDevelopmentPath||A.config?.extensionTestsPath){const F=new v.$Sc;if(F.add(d.Event.any(A.onDidClose,A.onDidDestroy)(()=>F.dispose())),A.config.extensionDevelopmentPath)for(const x of A.config.extensionDevelopmentPath)F.add(this.Q.addValidFileRoot(x));A.config.extensionTestsPath&&F.add(this.Q.addValidFileRoot(A.config.extensionTestsPath))}}))}openEmptyWindow(A,F){const x=this.F.args,z=F?.remoteAuthority||void 0,Z=!0,H=F?.forceReuseWindow,_=!H;return this.open({...A,cli:x,forceEmpty:Z,forceNewWindow:_,forceReuseWindow:H,remoteAuthority:z})}openExistingWindow(A,F){A.focus(),this.W(F,[A])}async open(A){this.w.trace("windowsManager#open"),A.addMode&&(A.initialStartup||!this.getLastActiveWindow())&&(A.addMode=!1);const F=[],x=[],z=[],Z=[],H=[];let _,B=0;const ee=await this.cb(A);this.w.trace("windowsManager#open pathsToOpen",ee);for(const Pe of ee)oe(Pe)?A.addMode?F.push(Pe):x.push(Pe):q(Pe)?z.push(Pe):Pe.fileUri?(_||(_={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Pe.remoteAuthority}),_.filesToOpenOrCreate.push(Pe)):Pe.backupPath?H.push({backupFolder:(0,$.$nc)(Pe.backupPath),remoteAuthority:Pe.remoteAuthority}):B++;A.diffMode&&_&&_.filesToOpenOrCreate.length>=2&&(_.filesToDiff=_.filesToOpenOrCreate.slice(0,2),_.filesToOpenOrCreate=[]),A.mergeMode&&_&&_.filesToOpenOrCreate.length===4&&(_.filesToMerge=_.filesToOpenOrCreate.slice(0,4),_.filesToOpenOrCreate=[],_.filesToDiff=[]),_&&A.waitMarkerFileURI&&(_.filesToWait={paths:(0,C.$Hb)([..._.filesToDiff,_.filesToMerge[3],..._.filesToOpenOrCreate]),waitMarkerFileUri:A.waitMarkerFileURI}),A.initialStartup?(Z.push(...this.M.getUntitledWorkspaces()),z.push(...Z),H.push(...this.I.getEmptyWindowBackups())):H.length=0;const{windows:ie,filesOpenedInWindow:de}=await this.X(A,z,x,H,B,_,F);if(this.w.trace(`windowsManager#open used window count ${ie.length} (workspacesToOpen: ${z.length}, foldersToOpen: ${x.length}, emptyToRestore: ${H.length}, emptyToOpen: ${B})`),ie.length>1)if(de)de.focus();else{const Pe=this.r.state.lastActiveWindow&&!A.forceEmpty&&!A.cli._.length&&!A.cli["file-uri"]&&!A.cli["folder-uri"]&&!(A.urisToOpen&&A.urisToOpen.length);let Le=!0,ke=!0;if(Pe){const ye=ie.filter(te=>this.r.state.lastActiveWindow&&te.backupPath===this.r.state.lastActiveWindow.backupPath);ye.length&&(ye[0].focus(),Le=!1,ke=!1)}if(Le)for(let ye=ie.length-1;ye>=0;ye--){const te=ie[ye];if(!(te.openedWorkspace&&Z.some(fe=>te.openedWorkspace&&fe.workspace.id===te.openedWorkspace.id)||te.backupPath&&H.some(fe=>te.backupPath&&fe.backupFolder===(0,$.$nc)(te.backupPath)))){te.focus(),ke=!1;break}}ke&&ie[ie.length-1].focus()}const me=_&&_.filesToDiff.length>0,Ee=_&&_.filesToMerge.length>0;if(!ie.some(Pe=>Pe.isExtensionDevelopmentHost)&&!me&&!Ee&&!A.noRecentEntry){const Pe=[];for(const Le of ee)q(Le)&&!Le.transient?Pe.push({label:Le.label,workspace:Le.workspace,remoteAuthority:Le.remoteAuthority}):oe(Le)?Pe.push({label:Le.label,folderUri:Le.workspace.uri,remoteAuthority:Le.remoteAuthority}):Le.fileUri&&Pe.push({label:Le.label,fileUri:Le.fileUri,remoteAuthority:Le.remoteAuthority});this.L.addRecentlyOpened(Pe)}return this.W(A,ie),ie}W(A,F){const x=A.waitMarkerFileURI;A.context===0&&x&&F.length===1&&F[0]&&(async()=>{await F[0].whenClosedOrLoaded;try{await this.P.del(x)}catch{}})()}async X(A,F,x,z,Z,H,_){const B=[];let ee;function ie(ye,te){B.push(ye),te&&(ee=ye,H=void 0)}let{openFolderInNewWindow:de,openFilesInNewWindow:me}=this.ob(A);if(!A.initialStartup&&_.length>0){const ye=_[0].remoteAuthority,te=this.ub(ye);te&&ie(this.$(te,_.map(fe=>fe.workspace.uri)))}const Ee=x.length+F.length+z.length;if(H&&Ee===0){const ye=H.filesToOpenOrCreate[0]||H.filesToDiff[0]||H.filesToMerge[3],te=this.getWindows().filter(ge=>H&&(0,u.$Xg)(ge.remoteAuthority,H.remoteAuthority));let fe;ye?.fileUri&&!me&&((A.context===4||A.context===0||A.context===1)&&(fe=await(0,V.$U$b)(te,ye.fileUri,async ge=>ge.configPath.scheme===k.Schemas.file?this.M.resolveLocalWorkspace(ge.configPath):void 0)),fe||(fe=this.vb(te))),fe?(0,le.$ui)(fe.openedWorkspace)?F.push({workspace:fe.openedWorkspace,remoteAuthority:fe.remoteAuthority}):(0,le.$pi)(fe.openedWorkspace)?x.push({workspace:fe.openedWorkspace,remoteAuthority:fe.remoteAuthority}):ie(this.Y(A,fe,H),!0):ie(await this.pb({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,filesToOpen:H,forceNewWindow:!0,remoteAuthority:H.remoteAuthority,forceNewTabbedWindow:A.forceNewTabbedWindow,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile}),!0)}const Pe=(0,C.$Mb)(F,ye=>ye.workspace.id);if(Pe.length>0){const ye=(0,C.$Hb)(Pe.map(te=>(0,V.$V$b)(this.getWindows(),te.workspace.configPath)));if(ye.length>0){const te=ye[0],fe=(0,u.$Xg)(H?.remoteAuthority,te.remoteAuthority)?H:void 0;ie(this.Y(A,te,fe),!!fe),de=!0}for(const te of Pe){if(ye.some(Ie=>Ie.openedWorkspace&&Ie.openedWorkspace.id===te.workspace.id))continue;const fe=te.remoteAuthority,ge=(0,u.$Xg)(H?.remoteAuthority,fe)?H:void 0;ie(await this.bb(A,te,de,ge),!!ge),de=!0}}const Le=(0,C.$Mb)(x,ye=>u.$Jg.getComparisonKey(ye.workspace.uri));if(Le.length>0){const ye=(0,C.$Hb)(Le.map(te=>(0,V.$V$b)(this.getWindows(),te.workspace.uri)));if(ye.length>0){const te=ye[0],fe=(0,u.$Xg)(H?.remoteAuthority,te.remoteAuthority)?H:void 0;ie(this.Y(A,te,fe),!!fe),de=!0}for(const te of Le){if(ye.some(Ie=>(0,le.$pi)(Ie.openedWorkspace)&&u.$Jg.isEqual(Ie.openedWorkspace.uri,te.workspace.uri)))continue;const fe=te.remoteAuthority,ge=(0,u.$Xg)(H?.remoteAuthority,fe)?H:void 0;ie(await this.bb(A,te,de,ge),!!ge),de=!0}}const ke=(0,C.$Mb)(z,ye=>ye.backupFolder);if(ke.length>0)for(const ye of ke){const te=ye.remoteAuthority,fe=(0,u.$Xg)(H?.remoteAuthority,te)?H:void 0;ie(await this.ab(A,!0,te,fe,ye),!!fe),de=!0}if(B.length===0||H){H&&!Z&&Z++;const ye=H?H.remoteAuthority:A.remoteAuthority;for(let te=0;te<Z;te++)ie(await this.ab(A,de,ye,H),!!H),de=!0}return{windows:(0,C.$Mb)(B),filesOpenedInWindow:ee}}Y(A,F,x){this.w.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:x}),this.Z(F);const z={filesToOpenOrCreate:x?.filesToOpenOrCreate,filesToDiff:x?.filesToDiff,filesToMerge:x?.filesToMerge,filesToWait:x?.filesToWait,termProgram:A?.userEnv?.TERM_PROGRAM};return F.sendWhenReady("vscode:openFiles",S.CancellationToken.None,z),F}Z(A){let F=A;const x=n.BrowserWindow.getFocusedWindow();if(x&&x.id!==A.id){const z=this.S.getWindowById(x.id);z&&z.parentId===A.id&&(F=z)}F.focus()}$(A,F){this.w.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:F}),A.focus();const x={foldersToAdd:F};return A.sendWhenReady("vscode:addFolders",S.CancellationToken.None,x),A}ab(A,F,x,z,Z){this.w.trace("windowsManager#doOpenEmpty",{restore:!!Z,remoteAuthority:x,filesToOpen:z,forceNewWindow:F});let H;return!F&&typeof A.contextWindowId=="number"&&(H=this.getWindowById(A.contextWindowId)),this.pb({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:x,forceNewWindow:F,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:z,windowToUse:H,emptyWindowBackupInfo:Z,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile})}bb(A,F,x,z,Z){return this.w.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:F,filesToOpen:z}),!x&&!Z&&typeof A.contextWindowId=="number"&&(Z=this.getWindowById(A.contextWindowId)),this.pb({workspace:F.workspace,userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:F.remoteAuthority,forceNewWindow:x,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:z,windowToUse:Z,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile})}async cb(A){let F,x=!1,z=!1;if(A.urisToOpen&&A.urisToOpen.length>0?(F=await this.db(A),x=!0):A.forceEmpty?F=[Object.create(null)]:A.cli._.length||A.cli["folder-uri"]||A.cli["file-uri"]?(F=await this.eb(A.cli),F.length===0&&F.push(Object.create(null)),x=!0):(F=await this.gb(),F.length===0&&F.push(Object.create(null)),z=!0),!A.addMode&&x){const Z=F.filter(H=>oe(H));if(Z.length>1){const H=Z[0].remoteAuthority;if(Z.every(_=>(0,u.$Xg)(_.remoteAuthority,H))){const _=await this.M.createUntitledWorkspace(Z.map(B=>({uri:B.workspace.uri})));F.push({workspace:_,remoteAuthority:H}),F=F.filter(B=>!oe(B))}}}if(A.initialStartup&&!z&&this.J.getValue("window")?.restoreWindows==="preserve"){const Z=await this.gb();F.unshift(...Z.filter(H=>q(H)||oe(H)||H.backupPath))}return F}async db(A){const F={gotoLineMode:A.gotoLineMode,remoteAuthority:A.remoteAuthority},x=await Promise.all((0,C.$Hb)(A.urisToOpen||[]).map(async z=>{const Z=await this.ib(z,F);if(Z)return Z.label=z.label,Z;const H=this.kb(z);this.O.showMessageBox({type:"info",buttons:[(0,g.localize)(0,null)],message:H.scheme===k.Schemas.file?(0,g.localize)(1,null):(0,g.localize)(2,null),detail:H.scheme===k.Schemas.file?(0,g.localize)(3,null,(0,y.$$v)(H,{os:w.OS,tildify:this.F})):(0,g.localize)(4,null,H.toString(!0))},n.BrowserWindow.getFocusedWindow()??void 0)}));return(0,C.$Hb)(x)}async eb(A){const F=[],x={ignoreFileNotFound:!0,gotoLineMode:A.goto,remoteAuthority:A.remote||void 0,forceOpenWorkspaceAsFile:A.diff&&A._.length===2||A.merge&&A._.length===4},z=A["folder-uri"];if(z){const _=await Promise.all(z.map(B=>{const ee=this.fb(B);if(ee)return this.ib({folderUri:ee},x)}));F.push(...(0,C.$Hb)(_))}const Z=A["file-uri"];if(Z){const _=await Promise.all(Z.map(B=>{const ee=this.fb(B);if(ee)return this.ib((0,le.$Ki)(B)?{workspaceUri:ee}:{fileUri:ee},x)}));F.push(...(0,C.$Hb)(_))}const H=await Promise.all(A._.map(_=>x.remoteAuthority?this.nb(_,x):this.lb(_,x)));return F.push(...(0,C.$Hb)(H)),F}fb(A){try{const F=h.URI.parse(A);if(!F.scheme){this.w.error(`Invalid URI input string, scheme missing: ${A}`);return}return F.path?F:F.with({path:"/"})}catch(F){this.w.error(`Invalid URI input string: ${A}, ${F.message}`)}}async gb(){const A=this.hb();switch(A){case"none":return[];case"one":case"all":case"preserve":case"folders":{const F=[];A!=="one"&&F.push(...this.r.state.openedWindows),this.r.state.lastActiveWindow&&F.push(this.r.state.lastActiveWindow);const x=await Promise.all(F.map(async z=>{if(z.workspace){const Z=await this.ib({workspaceUri:z.workspace.configPath},{remoteAuthority:z.remoteAuthority,rejectTransientWorkspaces:!0});if(q(Z))return Z}else if(z.folderUri){const Z=await this.ib({folderUri:z.folderUri},{remoteAuthority:z.remoteAuthority});if(oe(Z))return Z}else if(A!=="folders"&&z.backupPath)return{backupPath:z.backupPath,remoteAuthority:z.remoteAuthority}}));return(0,C.$Hb)(x)}}}hb(){let A;return this.H.wasRestarted?A="all":(A=this.J.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(A)||(A="all")),A}async ib(A,F=Object.create(null)){const x=this.kb(A);return x.scheme===k.Schemas.file?((0,M.$7C)(A)&&(F={...F,forceOpenWorkspaceAsFile:!0}),this.lb(x.fsPath,F)):this.jb(A,F)}jb(A,F){let x=this.kb(A);const z=(0,E.$pm)(x)||F.remoteAuthority;if(x=(0,u.$Zg)((0,u.$Tg)(x)),(0,M.$7C)(A)){if(F.gotoLineMode){const{path:Z,line:H,column:_}=(0,c.$mg)(x.path);return{fileUri:x.with({path:Z}),options:{selection:H?{startLineNumber:H,startColumn:_||1}:void 0},remoteAuthority:z}}return{fileUri:x,remoteAuthority:z}}else if((0,M.$5C)(A))return{workspace:(0,re.$Y$b)(x),remoteAuthority:z};return{workspace:(0,re.$Z$b)(x),remoteAuthority:z}}kb(A){return(0,M.$5C)(A)?A.workspaceUri:(0,M.$6C)(A)?A.folderUri:A.fileUri}async lb(A,F,x){let z,Z;F.gotoLineMode&&({path:A,line:z,column:Z}=(0,c.$mg)(A)),A=(0,c.$hg)((0,$.$hc)(A),(0,p.cwd)());try{const H=await R.Promises.stat(A);if(H.isFile()){if(!F.forceOpenWorkspaceAsFile){const _=await this.M.resolveLocalWorkspace(h.URI.file(A));if(_)return _.transient&&F.rejectTransientWorkspaces?void 0:{workspace:{id:_.id,configPath:_.configPath},type:i.FileType.File,exists:!0,remoteAuthority:_.remoteAuthority,transient:_.transient}}return{fileUri:h.URI.file(A),type:i.FileType.File,exists:!0,options:{selection:z?{startLineNumber:z,startColumn:Z||1}:void 0}}}else{if(H.isDirectory())return{workspace:(0,re.$Z$b)(h.URI.file(A),H),type:i.FileType.Directory,exists:!0};if(!w.$i&&A==="/dev/null")return{fileUri:h.URI.file(A),type:i.FileType.File,exists:!0}}}catch(H){if(H.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!x)return this.mb(A,F);const _=h.URI.file(A);if(this.L.removeRecentlyOpened([_]),F.ignoreFileNotFound)return{fileUri:_,type:i.FileType.File,exists:!1}}}async mb(A,F){const x=h.URI.file(A),{response:z,checkboxChecked:Z}=await this.O.showMessageBox({type:"warning",buttons:[(0,g.localize)(5,null),(0,g.localize)(6,null),(0,g.localize)(7,null)],message:(0,g.localize)(8,null,x.authority),detail:(0,g.localize)(9,null,(0,y.$$v)(x,{os:w.OS,tildify:this.F})),checkboxLabel:(0,g.localize)(10,null,x.authority),cancelId:1});if(z===0){if((0,P.addUNCHostToAllowlist)(x.authority),Z){const H={channel:"vscode:configureAllowedUNCHost",args:x.authority};this.sendToFocused(H.channel,H.args),this.sendToOpeningWindow(H.channel,H.args)}return this.lb(A,F,!0)}if(z===2)return n.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.mb(A,F)}nb(A,F){const x=A.charCodeAt(0),z=F.remoteAuthority;let Z,H;F.gotoLineMode&&({path:A,line:Z,column:H}=(0,c.$mg)(A)),x!==47&&((0,c.$gg)(x)&&A.charCodeAt(A.charCodeAt(1))===58&&(A=(0,c.$_f)(A)),A=`/${A}`);const _=h.URI.from({scheme:k.Schemas.vscodeRemote,authority:z,path:A});if(A.charCodeAt(A.length-1)!==47){if((0,le.$Ki)(A))return F.forceOpenWorkspaceAsFile?{fileUri:_,options:{selection:Z?{startLineNumber:Z,startColumn:H||1}:void 0},remoteAuthority:F.remoteAuthority}:{workspace:(0,re.$Y$b)(_),remoteAuthority:z};if(F.gotoLineMode||$.$gc.basename(A).indexOf(".")!==-1)return{fileUri:_,options:{selection:Z?{startLineNumber:Z,startColumn:H||1}:void 0},remoteAuthority:z}}return{workspace:(0,re.$Z$b)(_),remoteAuthority:z}}ob(A){const F=this.J.getValue("window"),x=F?.openFoldersInNewWindow||"default",z=F?.openFilesInNewWindow||"off";let Z=(A.preferNewWindow||A.forceNewWindow)&&!A.forceReuseWindow;!A.forceNewWindow&&!A.forceReuseWindow&&(x==="on"||x==="off")&&(Z=x==="on");let H=!1;return A.forceNewWindow||A.forceReuseWindow?H=!!A.forceNewWindow&&!A.forceReuseWindow:(w.$j?A.context===1&&(H=!0):A.context!==3&&A.context!==2&&!(A.userEnv&&A.userEnv.TERM_PROGRAM==="vscode")&&(H=!0),!A.cli.extensionDevelopmentPath&&(z==="on"||z==="off")&&(H=z==="on")),{openFolderInNewWindow:!!Z,openFilesInNewWindow:H}}async openExtensionDevelopmentHostWindow(A,F){const x=(0,V.$W$b)(this.getWindows(),A);if(x)return this.H.reload(x,F.cli),x.focus(),[x];let z=F.cli["folder-uri"]||[],Z=F.cli["file-uri"]||[],H=F.cli._;if(!H.length&&!z.length&&!Z.length&&!F.cli.extensionTestsPath){const ee=this.r.state.lastPluginDevelopmentHostWindow,ie=ee?.workspace??ee?.folderUri;ie&&(h.URI.isUri(ie)?ie.scheme===k.Schemas.file?H=[ie.fsPath]:z=[ie.toString()]:ie.configPath.scheme===k.Schemas.file?H=[(0,u.$Gg)(ie.configPath)]:Z=[ie.configPath.toString()])}let _=F.remoteAuthority;for(const ee of A)if(ee.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ie=h.URI.parse(ee),de=(0,E.$pm)(ie);de&&(_?(0,u.$Xg)(de,_)||this.w.error("more than one extension development path authority"):_=de)}H=H.filter(ee=>{const ie=h.URI.file(ee);return(0,V.$V$b)(this.getWindows(),ie)?!1:(0,u.$Xg)((0,E.$pm)(ie),_)}),z=z.filter(ee=>{const ie=this.fb(ee);return ie&&(0,V.$V$b)(this.getWindows(),ie)?!1:ie?(0,u.$Xg)((0,E.$pm)(ie),_):!1}),Z=Z.filter(ee=>{const ie=this.fb(ee);return ie&&(0,V.$V$b)(this.getWindows(),ie)?!1:ie?(0,u.$Xg)((0,E.$pm)(ie),_):!1}),F.cli._=H,F.cli["folder-uri"]=z,F.cli["file-uri"]=Z;const B={context:F.context,cli:F.cli,forceNewWindow:!0,forceEmpty:!H.length&&!z.length&&!Z.length,userEnv:F.userEnv,noRecentEntry:!0,waitMarkerFileURI:F.waitMarkerFileURI,remoteAuthority:_,forceProfile:F.forceProfile,forceTempProfile:F.forceTempProfile};return this.open(B)}async pb(A){const F=this.J.getValue("window"),x=this.getLastActiveWindow(),z=x?.profile??this.G.defaultProfile;let Z;!A.forceNewWindow&&!A.forceNewTabbedWindow&&(Z=A.windowToUse||x,Z&&Z.focus());const H={...this.F.args,...A.cli,machineId:this.s,sqmId:this.t,windowId:-1,mainPid:process.pid,appRoot:this.F.appRoot,execPath:process.execPath,codeCachePath:this.F.codeCachePath,backupPath:A.emptyWindowBackupInfo?(0,$.$jc)(this.F.backupHome,A.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.G.profilesHome,all:this.G.profiles,profile:z},homeDir:this.F.userHome.with({scheme:k.Schemas.file}).fsPath,tmpDir:this.F.tmpDir.with({scheme:k.Schemas.file}).fsPath,userDataDir:this.F.userDataPath,remoteAuthority:A.remoteAuthority,workspace:A.workspace,userEnv:{...this.u,...A.userEnv},filesToOpenOrCreate:A.filesToOpen?.filesToOpenOrCreate,filesToDiff:A.filesToOpen?.filesToDiff,filesToMerge:A.filesToOpen?.filesToMerge,filesToWait:A.filesToOpen?.filesToWait,logLevel:this.z.getLogLevel(),loggers:{window:[],global:this.z.getRegisteredLoggers()},logsPath:this.F.logsHome.with({scheme:k.Schemas.file}).fsPath,product:D.default,isInitialStartup:A.initialStartup,perfMarks:(0,m.getMarks)(),os:{release:(0,O.release)(),hostname:(0,O.hostname)(),arch:(0,O.arch)()},autoDetectHighContrast:F?.autoDetectHighContrast??!0,autoDetectColorScheme:F?.autoDetectColorScheme??!1,accessibilitySupport:n.app.accessibilitySupportEnabled,colorScheme:this.R.getColorScheme(),policiesData:this.D.serialize(),continueOn:this.F.continueOn};if(Z){const _=Z.config;!H.extensionDevelopmentPath&&_?.extensionDevelopmentPath&&(H.extensionDevelopmentPath=_.extensionDevelopmentPath,H.extensionDevelopmentKind=_.extensionDevelopmentKind,H["enable-proposed-api"]=_["enable-proposed-api"],H.verbose=_.verbose,H["inspect-extensions"]=_["inspect-extensions"],H["inspect-brk-extensions"]=_["inspect-brk-extensions"],H.debugId=_.debugId,H.extensionEnvironment=_.extensionEnvironment,H["extensions-dir"]=_["extensions-dir"],H["disable-extensions"]=_["disable-extensions"]),H.loggers={global:H.loggers.global,window:_?.loggers.window??H.loggers.window}}else{const _=this.r.getNewWindowState(H);(0,m.mark)("code/willCreateCodeWindow");const B=Z=this.N.createInstance(T.$7$b,{state:_,extensionDevelopmentPath:H.extensionDevelopmentPath,isExtensionTestHost:!!H.extensionTestsPath});(0,m.mark)("code/didCreateCodeWindow"),A.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(B),this.n.set(B.id,B),this.a.fire(B),this.f.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const ee=new v.$Sc;ee.add(B.onDidSignalReady(()=>this.b.fire(B))),ee.add(d.Event.once(B.onDidClose)(()=>this.sb(B,ee))),ee.add(d.Event.once(B.onDidDestroy)(()=>this.tb(B))),ee.add(B.onDidMaximize(()=>this.g.fire(B))),ee.add(B.onDidUnmaximize(()=>this.h.fire(B))),ee.add(B.onDidEnterFullScreen(()=>this.j.fire({window:B,fullscreen:!0}))),ee.add(B.onDidLeaveFullScreen(()=>this.j.fire({window:B,fullscreen:!1}))),ee.add(B.onDidTriggerSystemContextMenu(({x:de,y:me})=>this.m.fire({window:B,x:de,y:me})));const ie=(0,f.$4f)(B.win?.webContents);ie.removeAllListeners("devtools-reload-page"),ie.on("devtools-reload-page",()=>this.H.reload(B)),this.H.registerWindow(B)}return H.windowId=Z.id,Z.isReady?this.H.unload(Z,4).then(async _=>{_||await this.qb(Z,H,A,z)}):await this.qb(Z,H,A,z),Z}async qb(A,F,x,z){if(F.extensionDevelopmentPath||((0,le.$ui)(F.workspace)?F.backupPath=this.I.registerWorkspaceBackup({workspace:F.workspace,remoteAuthority:F.remoteAuthority}):(0,le.$pi)(F.workspace)?F.backupPath=this.I.registerFolderBackup({folderUri:F.workspace.uri,remoteAuthority:F.remoteAuthority}):F.backupPath=this.I.registerEmptyWindowBackup({backupFolder:x.emptyWindowBackupInfo?.backupFolder??(0,re.$1$b)().id,remoteAuthority:F.remoteAuthority})),this.G.isEnabled()){const Z=F.workspace??(0,le.$ti)(F.backupPath,!1),H=this.rb(x,Z,z),_=H instanceof Promise?await H:H;F.profiles.profile=_,F.extensionDevelopmentPath||await this.G.setProfileForWorkspace(Z,_)}A.load(F)}rb(A,F,x){return A.forceProfile?this.G.profiles.find(z=>z.name===A.forceProfile)??this.G.createNamedProfile(A.forceProfile):A.forceTempProfile?this.G.createTransientProfile():this.G.getProfileForWorkspace(F)??x}sb(A,F){this.n.delete(A.id),this.f.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),F.dispose()}tb(A){this.n.delete(A.id),this.c.fire(A)}getFocusedWindow(){const A=n.BrowserWindow.getFocusedWindow();if(A)return this.getWindowById(A.id)}getLastActiveWindow(){return this.vb(this.getWindows())}ub(A){return this.vb(this.getWindows().filter(F=>(0,u.$Xg)(F.remoteAuthority,A)))}vb(A){return(0,W.$R$b)(A)}sendToFocused(A,...F){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(A,S.CancellationToken.None,...F)}sendToOpeningWindow(A,...F){this.B(d.Event.once(this.onDidSignalReadyWindow)(x=>{x.sendWhenReady(A,S.CancellationToken.None,...F)}))}sendToAll(A,F,x){for(const z of this.getWindows())x&&x.indexOf(z.id)>=0||z.sendWhenReady(A,S.CancellationToken.None,F)}getWindows(){return Array.from(this.n.values())}getWindowCount(){return this.n.size}getWindowById(A){return this.n.get(A)}getWindowByWebContents(A){const F=n.BrowserWindow.fromWebContents(A);if(F)return this.getWindowById(F.id)}};e.$fac=he,e.$fac=he=ve([se(3,b.$zj),se(4,N.$4$b),se(5,I.$AP),se(6,U.$Yn),se(7,r.$E$b),se(8,L.$S$b),se(9,l.$9$b),se(10,a.$J$b),se(11,t.$Li),se(12,ue.$N_b),se(13,Q.$2$b),se(14,s.$ei),se(15,o.$K$b),se(16,i.$Fk),se(17,j.$M$b),se(18,Y.$N$b),se(19,G.$A_b)],he)}),define(ae[309],ce([0,1,64,29,84,58]),function(X,e,n,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hac=void 0;let C=class{constructor(d,c,y,v){this.a=d,this.b=c,this.c=y,this.d=v,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(d,c){const y=this.b.getWindowById(d);if(y)return this.a.enterWorkspace(y,this.b.getWindows(),c)}createUntitledWorkspace(d,c,y){return this.a.createUntitledWorkspace(c,y)}deleteUntitledWorkspace(d,c){return this.a.deleteUntitledWorkspace(c)}getWorkspaceIdentifier(d,c){return this.a.getWorkspaceIdentifier(c)}getRecentlyOpened(d){return this.c.getRecentlyOpened()}addRecentlyOpened(d,c){return this.c.addRecentlyOpened(c)}removeRecentlyOpened(d,c){return this.c.removeRecentlyOpened(c)}clearRecentlyOpened(d){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$hac=C,e.$hac=C=ve([se(0,O.$2$b),se(1,R.$P$b),se(2,P.$N_b),se(3,n.$J$b)],C)}),define(ae[310],ce([0,1,14,133,37,26,17,51,15,33,3,42,47,2,13,9,4,12,7,32,160,43,161,113,292,164,64,285,18,202,92,134,56,119,222,24,63,95,211,295,213,214,215,16,226,94,77,6,93,221,301,286,293,20,5,307,70,27,68,296,96,34,277,83,125,28,253,255,54,49,267,290,302,291,303,130,269,270,271,274,299,55,29,308,276,30,98,84,309,58,39,235,57,246,53,82,131,279,294,282,8,257,278,230,67,298,273,22,128,297,265,241,61,78,305]),function(X,e,n,R,P,O,C,S,d,c,y,v,k,$,m,w,p,u,f,h,g,a,t,o,r,i,s,l,b,D,j,E,I,M,T,W,V,J,le,re,ue,Q,Y,U,L,N,G,q,oe,he,K,A,F,x,z,Z,H,_,B,ee,ie,de,me,Ee,Pe,Le,ke,ye,te,fe,ge,Ie,Ae,Te,Me,Ge,Ue,Ke,He,qe,ne,$e,pe,be,Se,Oe,Ne,Xe,xe,Qe,Ze,st,tt,ot,at,yt,vt,kt,Et,St,ct,$t,Pt,jt,It,lt,Ct,gt,ut,Dt,Rt,ht,At,mt,Ot){"use strict";var ft;Object.defineProperty(e,"__esModule",{value:!0}),e.$Aac=void 0;let dt=class extends $.$Tc{static{ft=this}static{this.a={[m.Schemas.file]:"security.promptForLocalFileProtocolHandling",[m.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(je,Ce,Re,we,De,ze,Be,Je,Fe,We,Ve,Ye){super(),this.g=je,this.h=Ce,this.j=Re,this.m=we,this.n=De,this.s=ze,this.t=Be,this.u=Je,this.w=Fe,this.y=We,this.z=Ve,this.C=Ye,this.D(),this.F()}D(){const je=Fe=>Fe?.startsWith(`${m.Schemas.vscodeWebview}://`),Ce=new Set(["clipboard-read","clipboard-sanitized-write"]);n.session.defaultSession.setPermissionRequestHandler((Fe,We,Ve,Ye)=>je(Ye.requestingUrl)?Ve(Ce.has(We)):Ve(!1)),n.session.defaultSession.setPermissionCheckHandler((Fe,We,Ve,Ye)=>je(Ye.requestingUrl)?Ce.has(We):!1);const Re=new Set([m.Schemas.file,m.Schemas.vscodeFileResource,m.Schemas.vscodeRemoteResource,m.Schemas.vscodeManagedRemoteResource,"devtools"]),we=Fe=>{for(let We=Fe;We;We=We.parent)if(We.url.startsWith(`${m.Schemas.vscodeWebview}://`))return!0;return!1},De=Fe=>Fe.resourceType==="xhr"||we(Fe.frame),ze=Fe=>{const We=Fe.frame;if(!We||!this.b)return!1;const Ve=n.BrowserWindow.getAllWindows();for(const Ye of Ve)if(We.processId===Ye.webContents.mainFrame.processId)return!0;return!1},Be=(Fe,We)=>{if(Fe.path!=="/index.html")return!0;const Ve=We.frame;if(!Ve||!this.b)return!1;for(const Ye of this.b.getWindows())if(Ye.win&&Ve.processId===Ye.win.webContents.mainFrame.processId)return!0;return!1};n.session.defaultSession.webRequest.onBeforeRequest((Fe,We)=>{const Ve=f.URI.parse(Fe.url);return Ve.scheme===m.Schemas.vscodeWebview&&!Be(Ve,Fe)?(this.m.error("Blocked vscode-webview request",Fe.url),We({cancel:!0})):Ve.scheme===m.Schemas.vscodeFileResource&&!ze(Fe)?(this.m.error("Blocked vscode-file request",Fe.url),We({cancel:!0})):Ve.path.endsWith(".svg")&&!Re.has(Ve.scheme)?We({cancel:!De(Fe)}):We({cancel:!1})}),n.session.defaultSession.webRequest.onHeadersReceived((Fe,We)=>{const Ve=Fe.responseHeaders,Ye=Ve["content-type"]||Ve["Content-Type"];if(Ye&&Array.isArray(Ye)){const _e=f.URI.parse(Fe.url);if(_e.path.endsWith(".svg")&&Re.has(_e.scheme))return Ve["Content-Type"]=["image/svg+xml"],We({cancel:!1,responseHeaders:Ve});if(!_e.path.endsWith(m.Schemas.vscodeRemoteResource)&&Ye.some(it=>it.toLowerCase().includes("image/svg")))return We({cancel:!De(Fe)})}return We({cancel:!1})}),n.session.defaultSession.webRequest.onHeadersReceived((Fe,We)=>{if(Fe.url.startsWith("https://vscode.download.prss.microsoft.com/")){const Ve=Fe.responseHeaders??Object.create(null);if(Ve["Access-Control-Allow-Origin"]===void 0)return Ve["Access-Control-Allow-Origin"]=["*"],We({cancel:!1,responseHeaders:Ve})}return We({cancel:!1})});const Je=n.session.defaultSession;typeof Je.setCodeCachePath=="function"&&this.s.codeCachePath&&Je.setCodeCachePath((0,w.$jc)(this.s.codeCachePath,"chrome")),p.$i&&(this.u.getValue("security.restrictUNCAccess")===!1?(0,R.disableUNCAccessRestrictions)():(0,R.addUNCHostToAllowlist)(this.u.getValue("security.allowedUNCHosts")))}F(){(0,d.setUnexpectedErrorHandler)(Re=>this.H(Re)),process.on("uncaughtException",Re=>{(0,d.$Z)(Re)||(0,d.$1)(Re)}),process.on("unhandledRejection",Re=>(0,d.$1)(Re)),this.t.onWillShutdown(()=>this.dispose()),(0,g.$LV)(),n.app.on("accessibility-support-changed",(Re,we)=>{this.b?.sendToAll("vscode:accessibilitySupportChanged",we)}),n.app.on("activate",async(Re,we)=>{this.m.trace("app#activate"),we||await this.b?.openEmptyWindow({context:1})}),n.app.on("web-contents-created",(Re,we)=>{we?.opener?.url.startsWith(`${m.Schemas.vscodeFileResource}://${m.$yg}/`)&&(this.m.trace('[aux window]  app.on("web-contents-created"): Registering auxiliary window'),this.c?.registerWindow(we)),we.on("will-navigate",De=>{this.m.error("webContents#will-navigate: Prevented webcontent navigation"),De.preventDefault()}),we.setWindowOpenHandler(De=>De.url==="about:blank"?(this.m.trace("[aux window] webContents#setWindowOpenHandler: Allowing auxiliary window to open on about:blank"),{action:"allow",overrideBrowserWindowOptions:this.c?.createWindow(De)}):(this.m.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${De.url}}`),this.f?.openExternal(void 0,De.url),{action:"deny"}))});let je=[],Ce;n.app.on("open-file",(Re,we)=>{this.m.trace("app#open-file: ",we),Re.preventDefault(),je.push((0,Oe.$Ki)(we)?{workspaceUri:f.URI.file(we)}:{fileUri:f.URI.file(we)}),Ce!==void 0&&(clearTimeout(Ce),Ce=void 0),Ce=setTimeout(async()=>{await this.b?.open({context:1,cli:this.s.args,urisToOpen:je,gotoLineMode:!1,preferNewWindow:!0}),je=[],Ce=void 0},100)}),n.app.on("new-window-for-tab",async()=>{await this.b?.openEmptyWindow({context:4})}),P.$KV.handle("vscode:fetchShellEnv",Re=>{const we=this.b?.getWindowByWebContents(Re.sender);let De,ze;return we?.config?(De=we.config,ze={...process.env,...we.config.userEnv}):(De=this.s.args,ze=process.env),this.X(De,ze,!1)}),P.$KV.handle("vscode:writeNlsFile",(Re,we,De)=>{const ze=this.G([we]);if(!ze||typeof De!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.y.writeFile(ze,C.$se.fromString(De))}),P.$KV.handle("vscode:readNlsFile",async(Re,...we)=>{const De=this.G(we);if(!De)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.y.readFile(De)).value.toString()}),P.$KV.on("vscode:toggleDevTools",Re=>Re.sender.toggleDevTools()),P.$KV.on("vscode:openDevTools",Re=>Re.sender.openDevTools()),P.$KV.on("vscode:reloadWindow",Re=>Re.sender.reload()),P.$KV.handle("vscode:notifyZoomLevel",async(Re,we)=>{const De=this.b?.getWindowById(Re.sender.id);De&&De.notifyZoomLevel(we)})}G(je){let Ce;for(const Re of je)typeof Re=="string"&&(typeof Ce!="string"?Ce=Re:Ce=(0,w.$jc)(Ce,Re));if(!(typeof Ce!="string"||!(0,w.$ic)(Ce)||!(0,c.$fg)(Ce,this.s.cachedLanguagesPath,!p.$k)))return f.URI.file(Ce)}H(je){if(je){const Ce={message:`[uncaught exception in main]: ${je.message}`,stack:je.stack};this.b?.sendToFocused("vscode:reportError",JSON.stringify(Ce))}this.m.error(`[uncaught exception in main]: ${je}`),je.stack&&this.m.error(je.stack)}async startup(){this.m.debug("Starting VS Code"),this.m.debug(`from: ${this.s.appRoot}`),this.m.debug("args:",this.s.args);const je=this.z.win32AppUserModelId;p.$i&&je&&n.app.setAppUserModelId(je);try{p.$j&&this.u.getValue("window.nativeTabs")===!0&&!n.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&n.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(We){this.m.error(We)}const Ce=new t.$RV;this.t.onWillShutdown(We=>{We.reason===2&&Ce.dispose()}),this.m.trace("Resolving machine identifier...");const[Re,we]=await Promise.all([(0,$t.$pac)(this.w,this.m),(0,$t.$qac)(this.w,this.m)]);this.m.trace(`Resolved machine identifier: ${Re}`);const{sharedProcessReady:De,sharedProcessClient:ze}=this.P(Re,we),Be=await this.Q(Re,we,De);this.B(Be.createInstance(r.$g_b)),this.B(Be.createInstance(Et.$lac)),Be.invokeFunction(We=>this.R(We,Ce,ze));const Je=await Be.invokeFunction(We=>this.I(We,Ce));this.J(Ce),this.t.phase=2,await Be.invokeFunction(We=>this.S(We,Je)),this.t.phase=3,this.U(),this.B(new ct.$rh(()=>{this.B((0,ct.$vh)(()=>this.t.phase=4,2500))},2500)).schedule()}async I(je,Ce){const Re=this.b=je.get(pe.$P$b),we=je.get(Ge.$zW),De=this.f=je.get(H.$B_b),ze=je.get(I.$K$b),Be=this;we.registerHandler({async handleURL(_e,it){return Be.O(Re,ze,we,_e,it)}});const Je=this.B(new Se.$gac({onDidOpenMainWindow:De.onDidOpenMainWindow,onDidFocusMainWindow:De.onDidFocusMainWindow,getActiveWindowId:()=>De.getActiveWindowId(-1)})),Fe=new a.$Zh(_e=>Je.getActiveClientId().then(it=>_e===it)),We=new Ue.$0_b(Fe,this.m),Ve=Ce.getChannel("urlHandler",We);we.registerHandler(new Ue.$9_b(Ve));const Ye=await this.L(Re,ze);return this.B(new He.$$_b(Ye?.urls,we,Re,this.s,this.z,this.m)),Ye}J(je){const Ce=()=>({statusCode:404,data:"Not found"}),Re=new At.$V(()=>je.getChannel(ht.$xac,new ht.$yac));n.protocol.registerBufferProtocol(m.Schemas.vscodeManagedRemoteResource,(we,De)=>{const ze=f.URI.parse(we.url);if(!ze.authority.startsWith("window:"))return De(Ce());Re.value.call(ht.$wac,[ze]).then(Be=>De({...Be,data:Buffer.from(Be.body,"base64")}),Be=>{this.m.warn("error dispatching remote resource call",Be),De({statusCode:500,data:String(Be)})})})}async L(je,Ce){const Re=this.s.args["open-url"]?this.s.args._urls||[]:[];Re.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Re);const we=global.getOpenUrls()||[];if(we.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",we),Re.length+we.length===0)return;const De=[...Re,...we].map(Je=>{try{return{uri:f.URI.parse(Je),originalUrl:Je}}catch{this.m.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Je);return}}),ze=[],Be=[];for(const Je of De){if(!Je)continue;const Fe=this.N(Je.uri);if(Fe)if(await this.M(Fe,je,Ce)){this.m.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Je.uri.toString(!0));continue}else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Je.uri.toString(!0),Fe),ze.push(Fe);else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Je.uri.toString(!0)),Be.push(Je)}return{urls:Be,openables:ze}}async M(je,Ce,Re){let we,De;if((0,$e.$5C)(je)?(we=je.workspaceUri,De=(0,i.localize)(0,null,we.scheme===m.Schemas.file?(0,k.$$v)(we,{os:p.OS,tildify:this.s}):we.toString(!0),this.z.nameShort)):(0,$e.$6C)(je)?(we=je.folderUri,De=(0,i.localize)(1,null,we.scheme===m.Schemas.file?(0,k.$$v)(we,{os:p.OS,tildify:this.s}):we.toString(!0),this.z.nameShort)):(we=je.fileUri,De=(0,i.localize)(2,null,we.scheme===m.Schemas.file?(0,k.$$v)(we,{os:p.OS,tildify:this.s}):we.toString(!0),this.z.nameShort)),we.scheme!==m.Schemas.file&&we.scheme!==m.Schemas.vscodeRemote||this.u.getValue(ft.a[we.scheme])===!1)return!1;const{response:Be,checkboxChecked:Je}=await Re.showMessageBox({type:"warning",buttons:[(0,i.localize)(3,null),(0,i.localize)(4,null)],message:De,detail:(0,i.localize)(5,null),checkboxLabel:we.scheme===m.Schemas.file?(0,i.localize)(6,null):(0,i.localize)(7,null),cancelId:1});if(Be!==0)return!0;if(Je){const Fe={channel:"vscode:disablePromptForProtocolHandling",args:we.scheme===m.Schemas.file?"local":"remote"};Ce.sendToFocused(Fe.channel,Fe.args),Ce.sendToOpeningWindow(Fe.channel,Fe.args)}return!1}N(je){if(je.path){if(je.authority===m.Schemas.file){const Ce=f.URI.file(je.fsPath);return(0,Oe.$Ki)(Ce)?{workspaceUri:Ce}:{fileUri:Ce}}else if(je.authority===m.Schemas.vscodeRemote){const Ce=je.path.indexOf(w.$gc.sep,1);if(Ce!==-1){const Re=je.path.substring(1,Ce),we=je.path.substring(Ce);let De=je.query;const ze=new URLSearchParams(je.query);ze.get("windowId")==="_blank"&&(ze.delete("windowId"),De=ze.toString());const Be=f.URI.from({scheme:m.Schemas.vscodeRemote,authority:Re,path:we,query:De,fragment:je.fragment});return(0,Oe.$Ki)(we)?{workspaceUri:Be}:/:[\d]+$/.test(we)?{fileUri:Be}:{folderUri:Be}}}}}async O(je,Ce,Re,we,De){this.m.trace("app#handleProtocolUrl():",we.toString(!0),De),we.scheme===this.z.urlProtocol&&we.path==="workspace"&&(we=we.with({authority:"file",path:f.URI.parse(we.query).path,query:""}));let ze=!1;const Be=new URLSearchParams(we.query);Be.get("windowId")==="_blank"?(this.m.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",we.toString(!0)),Be.delete("windowId"),we=we.with({query:Be.toString()}),ze=!0):p.$j&&je.getWindowCount()===0&&(this.m.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",we.toString(!0)),ze=!0);const Je=Be.get("continueOn");Je!==null&&(this.m.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",we.toString(!0)),Be.delete("continueOn"),we=we.with({query:Be.toString()}),this.s.continueOn=Je??void 0);const Fe=this.N(we);return Fe?await this.M(Fe,je,Ce)?(this.m.trace("app#handleProtocolUrl() protocol url was blocked:",we.toString(!0)),!0):(this.m.trace("app#handleProtocolUrl() opening protocol url as window:",Fe,we.toString(!0)),(0,gt.$Ob)(await je.open({context:5,cli:{...this.s.args},urisToOpen:[Fe],forceNewWindow:ze,gotoLineMode:!0}))?.focus(),!0):ze?(this.m.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",we.toString(!0)),await(0,gt.$Ob)(await je.open({context:5,cli:{...this.s.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,B.$pm)(we)}))?.ready(),Re.open(we,De)):(this.m.trace("app#handleProtocolUrl(): not handled",we.toString(!0),De),!1)}P(je,Ce){const Re=this.B(this.j.createInstance(ee.$V_b,je,Ce)),we=(async()=>{this.m.trace("Main->SharedProcess#connect");const ze=await Re.connect();return this.m.trace("Main->SharedProcess#connect: connection established"),new o.$SV(ze,"main")})();return{sharedProcessReady:(async()=>(await Re.whenReady(),we))(),sharedProcessClient:we}}async Q(je,Ce,Re){const we=new oe.$di;switch(process.platform){case"win32":we.set(fe.$JW,new G.$ci(Me.$7_b));break;case"linux":p.$l?we.set(fe.$JW,new G.$ci(Te.$6_b,[process.env.SNAP,process.env.SNAP_REVISION])):we.set(fe.$JW,new G.$ci(Ae.$5_b));break;case"darwin":we.set(fe.$JW,new G.$ci(Ie.$4_b));break}we.set(pe.$P$b,new G.$ci(be.$fac,[je,Ce,this.h],!1)),we.set(mt.$A_b,new G.$ci(Ot.$zac,void 0,!1));const De=new I.$L$b(this.m,this.z);we.set(I.$K$b,De),we.set(F.$H_b,new G.$ci(F.$I_b,void 0,!1)),we.set(E.$m_b,new G.$ci(E.$n_b,void 0,!1)),we.set(j.$Xm,a.ProxyChannel.toService((0,a.$Xh)(Re.then(We=>We.getChannel("diagnostics"))))),we.set(he.$DBb,new G.$ci(K.$D_b,[this.h])),we.set(M.$tW,new G.$ci(T.$o_b)),we.set(A.$E_b,new G.$ci(A.$F_b)),we.set(H.$B_b,new G.$ci(H.$C_b,void 0,!1)),we.set(qe.$__b,new G.$ci(ne.$bac)),we.set(Z.$Q_b,new G.$ci(Z.$R_b)),we.set(le.$p_b,new G.$ci(re.$r_b)),we.set(Ee.$c_b,new G.$ci(Ee.$d_b)),we.set(Ee.$e_b,new G.$ci(Ee.$f_b));const ze=new Dt.$vac({graceTime:6e4,shortGraceTime:6e3,scrollback:this.u.getValue("terminal.integrated.persistentSessionScrollback")??100},this.u,this.s,this.t,this.m),Be=new Rt.$_r(ze,this.u,this.m,this.n);we.set(ut.$Mr,Be),p.$i?we.set(ue.$s_b,new G.$ci(Q.$t_b)):p.$j?we.set(ue.$s_b,new G.$ci(Q.$u_b)):p.$k&&we.set(ue.$s_b,new G.$ci(Q.$v_b));const Je=new l.$h_b(this.s,this.u,this.m,this.w);we.set(s.$J$b,Je);const Fe=new Qe.$3$b(this.s,this.m,this.C,Je,De);if(we.set(Qe.$2$b,Fe),we.set(Ne.$heb,new G.$ci(xe.$hac,void 0,!1)),we.set(Xe.$N_b,new G.$ci(Xe.$O_b,void 0,!1)),we.set(Ge.$zW,new G.$ci(Ke.$BW,void 0,!1)),(0,te.$7o)(this.z,this.s)){const We=(0,te.$_o)(this.z,this.u),Ve=(0,a.$Xh)(Re.then(rt=>rt.getChannel("telemetryAppender"))),Ye=new ke.$Y_b(Ve),_e=(0,Pe.$Xo)((0,O.release)(),(0,O.hostname)(),process.arch,this.z.commit,this.z.version,je,Ce,We),it=(0,te.$ap)(this.s),nt={appenders:[Ye],commonProperties:_e,piiPaths:it,sendErrorTelemetry:!0};we.set(Le.$El,new G.$ci(ye.$Dr,[nt],!1))}else we.set(Le.$El,te.$2o);return we.set(yt.$0p,new G.$ci(Pt.$HP,void 0,!0)),we.set(vt.$bq,new G.$ci(kt.$kac,void 0,!0)),we.set(lt.$tac,new G.$ci(lt.$uac,void 0,!0)),await ct.Promises.settled([Je.initialize(),Fe.initialize()]),this.j.createChild(we)}R(je,Ce,Re){const we=this.B(new $.$Sc),De=a.ProxyChannel.fromService(je.get(F.$H_b),we,{disableMarshalling:!0});this.g.registerChannel("launch",De);const ze=a.ProxyChannel.fromService(je.get(E.$m_b),we,{disableMarshalling:!0});this.g.registerChannel("diagnostics",ze);const Be=new st.$iac(je.get(Ze.$Yn));Ce.registerChannel("policy",Be),Re.then(et=>et.registerChannel("policy",Be));const Je=this.y.getProvider(m.Schemas.file);(0,u.$3f)(Je instanceof N.$Pq);const Fe=new L.$w_b(Je,this.m,this.s);Ce.registerChannel(Y.$qP,Fe),Re.then(et=>et.registerChannel(Y.$qP,Fe));const We=a.ProxyChannel.fromService(je.get(tt.$S$b),we);Ce.registerChannel("userDataProfiles",We),Re.then(et=>et.registerChannel("userDataProfiles",We));const Ve=new ot.$yr(je.get(at.$vp));Re.then(et=>et.registerChannel("request",Ve));const Ye=new ge.$Z_b(je.get(fe.$JW));Ce.registerChannel("update",Ye);const _e=a.ProxyChannel.fromService(je.get(he.$DBb),we);Ce.registerChannel("issue",_e);const it=a.ProxyChannel.fromService(je.get(M.$tW),we);Ce.registerChannel("encryption",it);const nt=a.ProxyChannel.fromService(je.get(ie.$sl),we);Ce.registerChannel("sign",nt);const rt=a.ProxyChannel.fromService(je.get(A.$E_b),we);Ce.registerChannel("keyboardLayout",rt),this.f=je.get(H.$B_b);const wt=a.ProxyChannel.fromService(this.f,we);Ce.registerChannel("nativeHost",wt),Re.then(et=>et.registerChannel("nativeHost",wt));const Mt=a.ProxyChannel.fromService(je.get(Ne.$heb),we);Ce.registerChannel("workspaces",Mt);const Lt=a.ProxyChannel.fromService(je.get(Z.$Q_b),we);Ce.registerChannel("menubar",Lt);const Ft=a.ProxyChannel.fromService(je.get(Ge.$zW),we);Ce.registerChannel("url",Ft);const Wt=a.ProxyChannel.fromService(je.get(qe.$__b),we);Ce.registerChannel("webview",Wt);const bt=this.B(new me.$W_b(this.m,je.get(Ee.$c_b)));Ce.registerChannel("storage",bt),Re.then(et=>et.registerChannel("storage",bt));const Tt=this.B(new St.$mac(je.get(Ee.$c_b),je.get(tt.$S$b),this.m));Re.then(et=>et.registerChannel("profileStorageListener",Tt));const Nt=a.ProxyChannel.fromService(je.get(ut.$Mr),we);Ce.registerChannel(ut.TerminalIpcChannels.LocalPty,Nt);const zt=a.ProxyChannel.fromService(je.get(ue.$s_b),we);Ce.registerChannel("externalTerminal",zt);const pt=new jt.$rac(je.get(It.$4$b));Ce.registerChannel("logger",pt),Re.then(et=>et.registerChannel("logger",pt));const Bt=new D.$i_b(je.get(pe.$P$b));Ce.registerChannel("extensionhostdebugservice",Bt);const qt=a.ProxyChannel.fromService(je.get(le.$p_b),we);Ce.registerChannel(le.$q_b,qt);const Ut=a.ProxyChannel.fromService(je.get(lt.$tac),we);Ce.registerChannel(Ct.$sac,Ut)}async S(je,Ce){const Re=this.b=je.get(pe.$P$b);this.c=je.get(mt.$A_b);const we=(0,V.$dm)(process.env)?0:4,De=this.s.args;if(Ce){if(Ce.openables.length>0)return Re.open({context:we,cli:De,urisToOpen:Ce.openables,gotoLineMode:!0,initialStartup:!0});if(Ce.urls.length>0)for(const nt of Ce.urls){const rt=new URLSearchParams(nt.uri.query);if(rt.get("windowId")==="_blank")return rt.delete("windowId"),nt.originalUrl=nt.uri.toString(!0),nt.uri=nt.uri.with({query:rt.toString()}),Re.open({context:we,cli:De,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const ze=global.macOpenFiles,Be=De._.length,Je=!!De["folder-uri"],Fe=!!De["file-uri"],We=De["skip-add-to-recently-opened"]===!0,Ve=De.wait&&De.waitMarkerFilePath?f.URI.file(De.waitMarkerFilePath):void 0,Ye=De.remote||void 0,_e=De.profile,it=De["profile-temp"];if(!Be&&!Je&&!Fe){if(De["new-window"]||_e||it)return Re.open({context:we,cli:De,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:We,waitMarkerFileURI:Ve,initialStartup:!0,remoteAuthority:Ye,forceProfile:_e,forceTempProfile:it});if(ze.length)return Re.open({context:1,cli:De,urisToOpen:ze.map(nt=>(0,Oe.$Ki)(nt)?{workspaceUri:f.URI.file(nt)}:{fileUri:f.URI.file(nt)}),noRecentEntry:We,waitMarkerFileURI:Ve,initialStartup:!0})}return Re.open({context:we,cli:De,forceNewWindow:De["new-window"]||!Be&&De["unity-launch"],diffMode:De.diff,mergeMode:De.merge,noRecentEntry:We,waitMarkerFileURI:Ve,gotoLineMode:De.goto,initialStartup:!0,remoteAuthority:Ye,forceProfile:_e,forceTempProfile:it})}U(){this.W(),n.protocol.registerHttpProtocol(m.Schemas.vscodeRemoteResource,(je,Ce)=>{Ce({url:je.url.replace(/^vscode-remote-resource:/,"http:"),method:je.method})}),this.X(this.s.args,process.env,!0),this.Y(),p.$j&&n.app.runningUnderARM64Translation&&this.b?.sendToFocused("vscode:showTranslatedBuildWarning")}async W(){const je=this.z.win32MutexName;if(p.$i&&je)try{const Ce=await new Promise((we,De)=>{X(["@vscode/windows-mutex"],we,De)}),Re=new Ce.Mutex(je);y.Event.once(this.t.onWillShutdown)(()=>Re.release())}catch(Ce){this.m.error(Ce)}}async X(je,Ce,Re){try{return await(0,J.$jm)(this.u,this.m,je,Ce)}catch(we){const De=(0,S.$3i)(we);Re?this.b?.sendToFocused("vscode:showResolveShellEnvError",De):this.m.error(De)}return{}}async Y(){try{const Ce=(await this.y.readFile(this.s.argvResource)).value.toString(),Re=JSON.parse((0,v.$zn)(Ce)),De=(0,te.$9o)(this.u)>=1;if(Re["enable-crash-reporter"]===void 0){const ze=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${De},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,h.$Bg)()}"`,"}"],Be=Ce.substring(0,Ce.length-2).concat(`,
`,ze.join(`
`));await this.y.writeFile(this.s.argvResource,C.$se.fromString(Be))}else{const ze=Ce.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${De},`);ze!==Ce&&await this.y.writeFile(this.s.argvResource,C.$se.fromString(ze))}}catch(je){this.m.error(je)}}};e.$Aac=dt,e.$Aac=dt=ft=ve([se(2,q.$ei),se(3,z.$zj),se(4,z.$Aj),se(5,W.$E$b),se(6,x.$9$b),se(7,b.$Li),se(8,de.$AP),se(9,U.$Fk),se(10,_.$Rj),se(11,tt.$S$b)],dt)}),define(ae[315],ce([0,1,14,46,7,22,8,51,15,33,3,47,13,9,66,4,36,25,21,43,100,310,10,18,240,252,24,63,204,16,224,94,77,220,93,20,227,5,79,27,80,280,129,289,53,288,96,251,34,54,69,57,39,236,234,2,40,268,67,229,118,124,272,266]),function(X,e,n,R,P,O,C,S,d,c,y,v,k,$,m,w,p,u,f,h,g,a,t,o,r,i,s,l,b,D,j,E,I,M,T,W,V,J,le,re,ue,Q,Y,U,L,N,G,q,oe,he,K,A,F,x,z,Z,H,_,B,ee,ie,de,me){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Ee{main(){try{this.a()}catch(ke){console.error(ke.message),n.app.exit(1)}}async a(){(0,d.setUnexpectedErrorHandler)(Me=>console.error(Me));const[ke,ye,te,fe,ge,Ie,Ae,Te]=this.b();try{try{await this.d(te,Te,fe,ge,Ae)}catch(Me){throw this.f(te,Ae,Me),Me}await ke.invokeFunction(async Me=>{const Ge=Me.get(J.$zj),Ue=Me.get(W.$9$b),Ke=Me.get(D.$Fk),He=Me.get(J.$Aj),qe=await this.e(Ge,te,Ue,ke,Ae,!0);return f.Promises.writeFile(te.mainLockfile,String(process.pid)).catch(ne=>{Ge.warn(`app#startup(): Error writing main lockfile: ${ne.stack}`)}),Ie.logger=He.createLogger("main",{name:(0,t.localize)(0,null)}),y.Event.once(Ue.onWillShutdown)(ne=>{Ke.dispose(),fe.dispose(),ne.join("instanceLockfile",f.Promises.unlink(te.mainLockfile).catch(()=>{}))}),ke.createInstance(a.$Aac,qe,ye).startup()})}catch(Me){ke.invokeFunction(this.i,Me)}}b(){const ke=new T.$di,ye=new Z.$Sc;process.once("exit",()=>ye.dispose());const te={_serviceBrand:void 0,...le.default};ke.set(re.$Rj,te);const fe=new s.$F$b(this.j(),te),ge=this.c(fe);ke.set(s.$E$b,fe);const Ie=new B.$5$b((0,J.$Nj)(fe),fe.logsHome);ke.set(B.$4$b,Ie);const Ae=new V.$m9b(Ie.getLogLevel()),Te=ye.add(new ee.$IP(Ae,[new J.$Gj(Ie.getLogLevel())]));ke.set(J.$zj,Te);const Me=new j.$qq(Te);ke.set(D.$Fk,Me);const Ge=new E.$Pq(Te);Me.registerProvider(k.Schemas.file,Ge);const Ue=new _.$ds(Me);ke.set(H.$dl,Ue);const Ke=new de.$DP(1,fe,Te,Me);ke.set(oe.$zP,Ke),ke.set(oe.$AP,Ke);const He=new A.$T$b(Ke,Ue,fe,Me,Te);ke.set(A.$S$b,He),Me.registerProvider(k.Schemas.vscodeUserData,new me.$Lac(k.Schemas.file,Ge,k.Schemas.vscodeUserData,He,Ue,Te));const qe=w.$i&&te.win32RegValueName?ye.add(new x.$Jac(Te,te.win32RegValueName)):fe.policyFile?ye.add(new z.$Kac(fe.policyFile,Me,Te)):new F.$1n;ke.set(F.$Yn,qe);const ne=new r.$oo(He.defaultProfile.settingsResource,Me,qe,Te);return ke.set(o.$Li,ne),ke.set(W.$9$b,new I.$ci(W.$0$b,void 0,!1)),ke.set(L.$vp,new I.$ci(N.$Hac,void 0,!0)),ke.set(K.$N$b,new I.$ci(K.$O$b)),ke.set(G.$sl,new I.$ci(q.$Iac,void 0,!1)),ke.set(Y.$Pv,new I.$ci(U.$Fac)),ke.set(ue.$M$b,new Q.$Cac(fe,He,Te)),[new M.$Sq(ke,!0),ge,fe,ne,Ke,Ae,te,He]}c(ke){const ye={VSCODE_IPC_HOOK:ke.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(te=>{const fe=process.env[te];typeof fe=="string"&&(ye[te]=fe)}),Object.assign(process.env,ye),ye}async d(ke,ye,te,fe,ge){await C.Promises.settled([Promise.all([ke.extensionsPath,ke.codeCachePath,ke.logsHome.with({scheme:k.Schemas.file}).fsPath,ye.defaultProfile.globalStorageHome.with({scheme:k.Schemas.file}).fsPath,ke.workspaceStorageHome.with({scheme:k.Schemas.file}).fsPath,ke.localHistoryHome.with({scheme:k.Schemas.file}).fsPath,ke.backupHome].map(Ie=>Ie?f.Promises.mkdir(Ie,{recursive:!0}):void 0)),fe.init(),te.initialize()]),ye.init()}async e(ke,ye,te,fe,ge,Ie){let Ae;try{(0,m.mark)("code/willStartMainServer"),Ae=await(0,g.$ai)(ye.mainIPCHandle),(0,m.mark)("code/didStartMainServer"),y.Event.once(te.onWillShutdown)(()=>Ae.dispose())}catch(Te){if(Te.code!=="EADDRINUSE")throw this.f(ye,ge,Te),Te;let Me;try{Me=await(0,g.$bi)(ye.mainIPCHandle,"main")}catch(He){if(!Ie||w.$i||He.code!=="ECONNREFUSED")throw He.code==="EPERM"&&this.g((0,t.localize)(1,null,ge.nameShort),(0,t.localize)(2,null),ge),He;try{(0,R.unlinkSync)(ye.mainIPCHandle)}catch(qe){throw ke.warn("Could not delete obsolete instance handle",qe),qe}return this.e(ke,ye,te,fe,ge,!1)}if(ye.extensionTestsLocationURI&&!ye.debugExtensionHost.break){const He=`Running extension tests from the command line is currently only supported if no other instance of ${ge.nameShort} is running.`;throw ke.error(He),Me.dispose(),new Error(He)}let Ge;!ye.args.wait&&!ye.args.status&&(Ge=setTimeout(()=>{this.g((0,t.localize)(3,null,ge.nameShort),(0,t.localize)(4,null),ge)},1e4));const Ue=h.ProxyChannel.toService(Me.getChannel("launch"),{disableMarshalling:!0}),Ke=h.ProxyChannel.toService(Me.getChannel("diagnostics"),{disableMarshalling:!0});if(ye.args.status)return fe.invokeFunction(async()=>{const He=new i.$ks(he.$2o,ge),qe=await Ke.getMainDiagnostics(),ne=await Ke.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),$e=await He.getDiagnostics(qe,ne);throw console.log($e),new d.$ab});throw w.$i&&await this.h(Ue,ke),ke.trace("Sending env to running instance..."),await Ue.start(ye.args,process.env),Me.dispose(),Ge&&clearTimeout(Ge),new d.$ab("Sent env to running instance. Terminating...")}if(ye.args.status)throw console.log((0,t.localize)(5,null,ge.nameShort)),new d.$ab("Terminating...");return process.env.VSCODE_PID=String(process.pid),Ae}f(ke,ye,te){if(te.code==="EACCES"||te.code==="EPERM"){const fe=(0,O.$Hb)([ke.userDataPath,ke.extensionsPath,g.$9h]).map(ge=>(0,v.$$v)(P.URI.file(ge),{os:w.OS,tildify:ke}));this.g((0,t.localize)(6,null),(0,t.localize)(7,null,(0,S.$3i)(te),fe.join(`
`)),ye)}}g(ke,ye,te){n.dialog.showMessageBoxSync((0,ie.$mw)({type:"warning",buttons:[(0,t.localize)(8,null)],message:ke,detail:ye},te).options)}async h(ke,ye){if(w.$i){const te=await ke.getMainProcessId();ye.trace("Sending some foreground love to the running instance:",te);try{(await new Promise((fe,ge)=>{X(["windows-foreground-love"],fe,ge)})).allowSetForegroundWindow(te)}catch(fe){ye.error(fe)}}}i(ke,ye){const te=ke.get(J.$zj),fe=ke.get(W.$9$b);let ge=0;ye&&(ye.isExpected?ye.message&&te.trace(ye.message):(ge=1,ye.stack?te.error(ye.stack):te.error(`Startup error: ${ye.toString()}`))),fe.kill(ge)}j(){const ke=this.k((0,l.$am)(process.argv));if(ke.wait&&!ke.waitMarkerFilePath){const ye=(0,b.$Bac)(ke.verbose);ye&&((0,l.$cm)(process.argv,"--waitMarkerFilePath",ye),ke.waitMarkerFilePath=ye)}return ke}k(ke){if(ke["open-url"]&&(ke._urls=ke._,ke._=[]),!ke.remote){const ye=this.l(ke._,ke.goto);ke._=ye}return ke}l(ke,ye){const te=(0,p.cwd)(),fe=ke.map(Ae=>{let Te=String(Ae),Me;ye&&(Me=(0,c.$mg)(Te),Te=Me.path),Te&&(Te=this.m(te,Te));const Ge=(0,c.$hg)(Te,te),Ue=(0,$.$nc)(Ge);return Ue&&!(0,c.$dg)(Ue)?null:ye&&Me?(Me.path=Ge,this.n(Me)):Ge}),ge=w.$i||w.$j,Ie=(0,O.$Mb)(fe,Ae=>Ae&&ge?Ae.toLowerCase():Ae||"");return(0,O.$Hb)(Ie)}m(ke,ye){return w.$i&&(ye=(0,u.$4e)(ye,'"')),ye=(0,u.$2e)((0,u.$2e)(ye," "),"	"),w.$i&&(ye=(0,$.$kc)(ke,ye),ye=(0,u.$4e)(ye,".")),ye}n(ke){const ye=[ke.path];return typeof ke.line=="number"&&ye.push(String(ke.line)),typeof ke.column=="number"&&ye.push(String(ke.column)),ye.join(":")}}new Ee().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/8c2b09c0443b94d75a73819ed35610f7e09375ae/core/vs/code/electron-main/main.js.map
