/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ie=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/platform/log/common/log","vs/nls!vs/code/node/cliProcessMain","vs/base/common/event","vs/base/common/errors","vs/nls","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/objects","vs/base/common/uuid","vs/platform/configuration/common/configuration","vs/base/common/strings","vs/base/common/map","vs/platform/product/common/productService","os","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/base/common/json","vs/platform/policy/common/policy","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/base/common/amd","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","fs","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/request/node/requestService","vs/base/common/lazy","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","zlib","vs/code/node/cliProcessMain"],ne=function(J){for(var e=[],N=0,D=J.length;N<D;N++)e[N]=ie[J[N]];return e};define(ie[70],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class N{static get(){const R=new Map,L=new Map,A=new Map,S=new Map;function u(m,w){m.has(w.detail)||m.set(w.detail,-w.timestamp)}function a(m,w){const k=m.get(w.detail);k&&(k>=0||m.set(w.detail,k+w.timestamp))}let y=[];typeof J=="function"&&typeof J.getStats=="function"&&(y=J.getStats().slice(0).sort((m,w)=>m.timestamp-w.timestamp));for(const m of y)switch(m.type){case 10:u(R,m);break;case 11:case 12:a(R,m);break;case 21:u(L,m);break;case 22:a(L,m);break;case 33:u(A,m);break;case 34:a(A,m);break;case 31:u(S,m);break;case 32:a(S,m);break}let E=0;A.forEach(m=>E+=m);function d(m){const w=[];return m.forEach((k,v)=>w.push([v,k])),w}return{amdLoad:d(R),amdInvoke:d(L),nodeRequire:d(A),nodeEval:d(S),nodeRequireTotal:E}}static toMarkdownTable(R,L){let A="";const S=[];return R.forEach((u,a)=>{S[a]=u.length}),L.forEach(u=>{u.forEach((a,y)=>{typeof a>"u"&&(a=u[y]="-");const E=a.toString().length;S[y]=Math.max(E,S[y])})}),R.forEach((u,a)=>{A+=`| ${u+" ".repeat(S[a]-u.toString().length)} `}),A+=`|
`,R.forEach((u,a)=>{A+=`| ${"-".repeat(S[a])} `}),A+=`|
`,L.forEach(u=>{u.forEach((a,y)=>{typeof a<"u"&&(A+=`| ${a+" ".repeat(S[y]-a.toString().length)} `)}),A+=`|
`}),A}}e.$U=N}),define(ie[53],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=e.$Kh=e.$Jh=void 0;function N(A){return(S,u,a)=>{let y=null,E=null;if(typeof a.value=="function"?(y="value",E=a.value):typeof a.get=="function"&&(y="get",E=a.get),!E)throw new Error("not supported");a[y]=A(E,u)}}function D(A,S,u){let a=null,y=null;if(typeof u.value=="function"?(a="value",y=u.value,y.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(a="get",y=u.get),!y)throw new Error("not supported");const E=`$memoize$${S}`;u[a]=function(...d){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:y.apply(this,d)}),this[E]}}e.$Jh=D;function R(A,S,u){return N((a,y)=>{const E=`$debounce$${y}`,d=`$debounce$result$${y}`;return function(...m){this[d]||(this[d]=u?u():void 0),clearTimeout(this[E]),S&&(this[d]=S(this[d],...m),m=[this[d]]),this[E]=setTimeout(()=>{a.apply(this,m),this[d]=u?u():void 0},A)}})}e.$Kh=R;function L(A,S,u){return N((a,y)=>{const E=`$throttle$timer$${y}`,d=`$throttle$result$${y}`,m=`$throttle$lastRun$${y}`,w=`$throttle$pending$${y}`;return function(...k){if(this[d]||(this[d]=u?u():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),S&&(this[d]=S(this[d],...k)),this[w])return;const v=this[m]+A;v<=Date.now()?(this[m]=Date.now(),a.apply(this,[this[d]]),this[d]=u?u():void 0):(this[w]=!0,this[E]=setTimeout(()=>{this[w]=!1,this[m]=Date.now(),a.apply(this,[this[d]]),this[d]=u?u():void 0},v-Date.now()))}})}e.$Lh=L}),define(ie[71],ne([0,1,7]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=e.$_c=e.$$c=e.$0c=e.$9c=e.ok=void 0;function D(a,y){if(!a)throw new Error(y?`Assertion failed (${y})`:"Assertion Failed")}e.ok=D;function R(a,y="Unreachable"){throw new Error(y)}e.$9c=R;function L(a){if(!a)throw new N.$cb("Assertion Failed")}e.$0c=L;function A(a){a||(0,N.$1)(new N.$cb("Soft Assertion Failed"))}e.$$c=A;function S(a){if(!a()){debugger;a(),(0,N.$1)(new N.$cb("Assertion Failed"))}}e.$_c=S;function u(a,y){let E=0;for(;E<a.length-1;){const d=a[E],m=a[E+1];if(!y(d,m))return!1;E++}return!0}e.$ad=u}),define(ie[38],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var N;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(N||(e.ScanError=N={}));var D;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(D||(e.SyntaxKind=D={}));var R;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(R||(e.ParseErrorCode=R={}));var L;(function(i){i.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function A(i,r=!1){let t=0;const n=i.length;let s="",o=0,l=16,O=0;function I(re){let he=0,de=0;for(;he<re;){const ae=i.charCodeAt(t);if(ae>=48&&ae<=57)de=de*16+ae-48;else if(ae>=65&&ae<=70)de=de*16+ae-65+10;else if(ae>=97&&ae<=102)de=de*16+ae-97+10;else break;t++,he++}return he<re&&(de=-1),de}function b(re){t=re,s="",o=0,l=16,O=0}function j(){const re=t;if(i.charCodeAt(t)===48)t++;else for(t++;t<i.length&&a(i.charCodeAt(t));)t++;if(t<i.length&&i.charCodeAt(t)===46)if(t++,t<i.length&&a(i.charCodeAt(t)))for(t++;t<i.length&&a(i.charCodeAt(t));)t++;else return O=3,i.substring(re,t);let he=t;if(t<i.length&&(i.charCodeAt(t)===69||i.charCodeAt(t)===101))if(t++,(t<i.length&&i.charCodeAt(t)===43||i.charCodeAt(t)===45)&&t++,t<i.length&&a(i.charCodeAt(t))){for(t++;t<i.length&&a(i.charCodeAt(t));)t++;he=t}else O=3;return i.substring(re,he)}function q(){let re="",he=t;for(;;){if(t>=n){re+=i.substring(he,t),O=2;break}const de=i.charCodeAt(t);if(de===34){re+=i.substring(he,t),t++;break}if(de===92){if(re+=i.substring(he,t),t++,t>=n){O=2;break}switch(i.charCodeAt(t++)){case 34:re+='"';break;case 92:re+="\\";break;case 47:re+="/";break;case 98:re+="\b";break;case 102:re+="\f";break;case 110:re+=`
`;break;case 114:re+="\r";break;case 116:re+="	";break;case 117:{const B=I(4);B>=0?re+=String.fromCharCode(B):O=4;break}default:O=5}he=t;continue}if(de>=0&&de<=31)if(u(de)){re+=i.substring(he,t),O=2;break}else O=6;t++}return re}function Y(){if(s="",O=0,o=t,t>=n)return o=n,l=17;let re=i.charCodeAt(t);if(S(re)){do t++,s+=String.fromCharCode(re),re=i.charCodeAt(t);while(S(re));return l=15}if(u(re))return t++,s+=String.fromCharCode(re),re===13&&i.charCodeAt(t)===10&&(t++,s+=`
`),l=14;switch(re){case 123:return t++,l=1;case 125:return t++,l=2;case 91:return t++,l=3;case 93:return t++,l=4;case 58:return t++,l=6;case 44:return t++,l=5;case 34:return t++,s=q(),l=10;case 47:{const he=t-1;if(i.charCodeAt(t+1)===47){for(t+=2;t<n&&!u(i.charCodeAt(t));)t++;return s=i.substring(he,t),l=12}if(i.charCodeAt(t+1)===42){t+=2;const de=n-1;let ae=!1;for(;t<de;){if(i.charCodeAt(t)===42&&i.charCodeAt(t+1)===47){t+=2,ae=!0;break}t++}return ae||(t++,O=1),s=i.substring(he,t),l=13}return s+=String.fromCharCode(re),t++,l=16}case 45:if(s+=String.fromCharCode(re),t++,t===n||!a(i.charCodeAt(t)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=j(),l=11;default:for(;t<n&&K(re);)t++,re=i.charCodeAt(t);if(o!==t){switch(s=i.substring(o,t),s){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return s+=String.fromCharCode(re),t++,l=16}}function K(re){if(S(re)||u(re))return!1;switch(re){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function oe(){let re;do re=Y();while(re>=12&&re<=15);return re}return{setPosition:b,getPosition:()=>t,scan:r?oe:Y,getToken:()=>l,getTokenValue:()=>s,getTokenOffset:()=>o,getTokenLength:()=>t-o,getTokenError:()=>O}}e.$pn=A;function S(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function u(i){return i===10||i===13||i===8232||i===8233}function a(i){return i>=48&&i<=57}var y;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(y||(y={}));function E(i,r){const t=[],n=new Object;let s;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function O(I,b,j,q){o.value=I,o.offset=b,o.length=j,o.type=q,o.colonOffset=void 0,s=o}try{$(i,{onObjectBegin:(I,b)=>{if(r<=I)throw n;s=void 0,l=r>I,t.push("")},onObjectProperty:(I,b,j)=>{if(r<b||(O(I,b,j,"property"),t[t.length-1]=I,r<=b+j))throw n},onObjectEnd:(I,b)=>{if(r<=I)throw n;s=void 0,t.pop()},onArrayBegin:(I,b)=>{if(r<=I)throw n;s=void 0,t.push(0)},onArrayEnd:(I,b)=>{if(r<=I)throw n;s=void 0,t.pop()},onLiteralValue:(I,b,j)=>{if(r<b||(O(I,b,j,g(I)),r<=b+j))throw n},onSeparator:(I,b,j)=>{if(r<=b)throw n;if(I===":"&&s&&s.type==="property")s.colonOffset=b,l=!1,s=void 0;else if(I===","){const q=t[t.length-1];typeof q=="number"?t[t.length-1]=q+1:(l=!0,t[t.length-1]=""),s=void 0}}})}catch(I){if(I!==n)throw I}return{path:t,previousNode:s,isAtPropertyKey:l,matches:I=>{let b=0;for(let j=0;b<I.length&&j<t.length;j++)if(I[b]===t[j]||I[b]==="*")b++;else if(I[b]!=="**")return!1;return b===I.length}}}e.$qn=E;function d(i,r=[],t=L.DEFAULT){let n=null,s=[];const o=[];function l(I){Array.isArray(s)?s.push(I):n!==null&&(s[n]=I)}return $(i,{onObjectBegin:()=>{const I={};l(I),o.push(s),s=I,n=null},onObjectProperty:I=>{n=I},onObjectEnd:()=>{s=o.pop()},onArrayBegin:()=>{const I=[];l(I),o.push(s),s=I,n=null},onArrayEnd:()=>{s=o.pop()},onLiteralValue:l,onError:(I,b,j)=>{r.push({error:I,offset:b,length:j})}},t),s[0]}e.$rn=d;function m(i,r=[],t=L.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(I){n.type==="property"&&(n.length=I-n.offset,n=n.parent)}function o(I){return n.children.push(I),I}$(i,{onObjectBegin:I=>{n=o({type:"object",offset:I,length:-1,parent:n,children:[]})},onObjectProperty:(I,b,j)=>{n=o({type:"property",offset:b,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:I,offset:b,length:j,parent:n})},onObjectEnd:(I,b)=>{n.length=I+b-n.offset,n=n.parent,s(I+b)},onArrayBegin:(I,b)=>{n=o({type:"array",offset:I,length:-1,parent:n,children:[]})},onArrayEnd:(I,b)=>{n.length=I+b-n.offset,n=n.parent,s(I+b)},onLiteralValue:(I,b,j)=>{o({type:g(I),offset:b,length:j,parent:n,value:I}),s(b+j)},onSeparator:(I,b,j)=>{n.type==="property"&&(I===":"?n.colonOffset=b:I===","&&s(b))},onError:(I,b,j)=>{r.push({error:I,offset:b,length:j})}},t);const O=n.children[0];return O&&delete O.parent,O}e.$sn=m;function w(i,r){if(!i)return;let t=i;for(const n of r)if(typeof n=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let s=!1;for(const o of t.children)if(Array.isArray(o.children)&&o.children[0].value===n){t=o.children[1],s=!0;break}if(!s)return}else{const s=n;if(t.type!=="array"||s<0||!Array.isArray(t.children)||s>=t.children.length)return;t=t.children[s]}return t}e.$tn=w;function k(i){if(!i.parent||!i.parent.children)return[];const r=k(i.parent);if(i.parent.type==="property"){const t=i.parent.children[0].value;r.push(t)}else if(i.parent.type==="array"){const t=i.parent.children.indexOf(i);t!==-1&&r.push(t)}return r}e.$un=k;function v(i){switch(i.type){case"array":return i.children.map(v);case"object":{const r=Object.create(null);for(const t of i.children){const n=t.children[1];n&&(r[t.children[0].value]=v(n))}return r}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.$vn=v;function c(i,r,t=!1){return r>=i.offset&&r<i.offset+i.length||t&&r===i.offset+i.length}e.$wn=c;function p(i,r,t=!1){if(c(i,r,t)){const n=i.children;if(Array.isArray(n))for(let s=0;s<n.length&&n[s].offset<=r;s++){const o=p(n[s],r,t);if(o)return o}return i}}e.$xn=p;function $(i,r,t=L.DEFAULT){const n=A(i,!1);function s(Q){return Q?()=>Q(n.getTokenOffset(),n.getTokenLength()):()=>!0}function o(Q){return Q?_=>Q(_,n.getTokenOffset(),n.getTokenLength()):()=>!0}const l=s(r.onObjectBegin),O=o(r.onObjectProperty),I=s(r.onObjectEnd),b=s(r.onArrayBegin),j=s(r.onArrayEnd),q=o(r.onLiteralValue),Y=o(r.onSeparator),K=s(r.onComment),oe=o(r.onError),re=t&&t.disallowComments,he=t&&t.allowTrailingComma;function de(){for(;;){const Q=n.scan();switch(n.getTokenError()){case 4:ae(14);break;case 5:ae(15);break;case 3:ae(13);break;case 1:re||ae(11);break;case 2:ae(12);break;case 6:ae(16);break}switch(Q){case 12:case 13:re?ae(10):K();break;case 16:ae(1);break;case 15:case 14:break;default:return Q}}}function ae(Q,_=[],U=[]){if(oe(Q),_.length+U.length>0){let F=n.getToken();for(;F!==17;){if(_.indexOf(F)!==-1){de();break}else if(U.indexOf(F)!==-1)break;F=de()}}}function B(Q){const _=n.getTokenValue();return Q?q(_):O(_),de(),!0}function X(){switch(n.getToken()){case 11:{let Q=0;try{Q=JSON.parse(n.getTokenValue()),typeof Q!="number"&&(ae(2),Q=0)}catch{ae(2)}q(Q);break}case 7:q(null);break;case 8:q(!0);break;case 9:q(!1);break;default:return!1}return de(),!0}function T(){return n.getToken()!==10?(ae(3,[],[2,5]),!1):(B(!1),n.getToken()===6?(Y(":"),de(),Z()||ae(4,[],[2,5])):ae(5,[],[2,5]),!0)}function M(){l(),de();let Q=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(Q||ae(4,[],[]),Y(","),de(),n.getToken()===2&&he)break}else Q&&ae(6,[],[]);T()||ae(4,[],[2,5]),Q=!0}return I(),n.getToken()!==2?ae(7,[2],[]):de(),!0}function H(){b(),de();let Q=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(Q||ae(4,[],[]),Y(","),de(),n.getToken()===4&&he)break}else Q&&ae(6,[],[]);Z()||ae(4,[],[4,5]),Q=!0}return j(),n.getToken()!==4?ae(8,[4],[]):de(),!0}function Z(){switch(n.getToken()){case 3:return H();case 1:return M();case 10:return B(!0);default:return X()}}return de(),n.getToken()===17?t.allowEmptyContent?!0:(ae(4,[],[]),!1):Z()?(n.getToken()!==17&&ae(9,[],[]),!0):(ae(4,[],[]),!1)}e.$yn=$;function h(i,r){const t=A(i),n=[];let s,o=0,l;do switch(l=t.getPosition(),s=t.scan(),s){case 12:case 13:case 17:o!==l&&n.push(i.substring(o,l)),r!==void 0&&n.push(t.getTokenValue().replace(/[^\r\n]/g,r)),o=t.getPosition();break}while(s!==17);return n.join("")}e.$zn=h;function g(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.$An=g}),define(ie[72],ne([0,1,38]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$En=e.$Dn=e.$Cn=e.$Bn=void 0;function D(a,y,E){let d,m,w,k,v;if(y){for(k=y.offset,v=k+y.length,w=k;w>0&&!u(a,w-1);)w--;let l=v;for(;l<a.length&&!u(a,l);)l++;m=a.substring(w,l),d=A(m,E)}else m=a,d=0,w=0,k=0,v=a.length;const c=S(E,a);let p=!1,$=0,h;E.insertSpaces?h=L(" ",E.tabSize||4):h="	";const g=(0,N.$pn)(m,!1);let i=!1;function r(){return c+L(h,d+$)}function t(){let l=g.scan();for(p=!1;l===15||l===14;)p=p||l===14,l=g.scan();return i=l===16||g.getTokenError()!==0,l}const n=[];function s(l,O,I){!i&&O<v&&I>k&&a.substring(O,I)!==l&&n.push({offset:O,length:I-O,content:l})}let o=t();if(o!==17){const l=g.getTokenOffset()+w,O=L(h,d);s(O,w,l)}for(;o!==17;){let l=g.getTokenOffset()+g.getTokenLength()+w,O=t(),I="";for(;!p&&(O===12||O===13);){const j=g.getTokenOffset()+w;s(" ",l,j),l=g.getTokenOffset()+g.getTokenLength()+w,I=O===12?r():"",O=t()}if(O===2)o!==1&&($--,I=r());else if(O===4)o!==3&&($--,I=r());else{switch(o){case 3:case 1:$++,I=r();break;case 5:case 12:I=r();break;case 13:p?I=r():I=" ";break;case 6:I=" ";break;case 10:if(O===6){I="";break}case 7:case 8:case 9:case 11:case 2:case 4:O===12||O===13?I=" ":O!==5&&O!==17&&(i=!0);break;case 16:i=!0;break}p&&(O===12||O===13)&&(I=r())}const b=g.getTokenOffset()+w;s(I,l,b),o=O}return n}e.$Bn=D;function R(a,y){const E=JSON.stringify(a,void 0,y.insertSpaces?y.tabSize||4:"	");return y.eol!==void 0?E.replace(/\r\n|\r|\n/g,y.eol):E}e.$Cn=R;function L(a,y){let E="";for(let d=0;d<y;d++)E+=a;return E}function A(a,y){let E=0,d=0;const m=y.tabSize||4;for(;E<a.length;){const w=a.charAt(E);if(w===" ")d++;else if(w==="	")d+=m;else break;E++}return Math.floor(d/m)}function S(a,y){for(let E=0;E<y.length;E++){const d=y.charAt(E);if(d==="\r")return E+1<y.length&&y.charAt(E+1)===`
`?`\r
`:"\r";if(d===`
`)return`
`}return a&&a.eol||`
`}e.$Dn=S;function u(a,y){return`\r
`.indexOf(a.charAt(y))!==-1}e.$En=u}),define(ie[73],ne([0,1,38,72]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=void 0;function R(a,y,E){return L(a,y,void 0,E)}e.$Fn=R;function L(a,y,E,d,m){const w=y.slice(),k=[],v=(0,N.$sn)(a,k);let c,p;for(;w.length>0&&(p=w.pop(),c=(0,N.$tn)(v,w),c===void 0&&E!==void 0);)typeof p=="string"?E={[p]:E}:E=[E];if(c)if(c.type==="object"&&typeof p=="string"&&Array.isArray(c.children)){const $=(0,N.$tn)(c,[p]);if($!==void 0)if(E===void 0){if(!$.parent)throw new Error("Malformed AST");const h=c.children.indexOf($.parent);let g,i=$.parent.offset+$.parent.length;if(h>0){const r=c.children[h-1];g=r.offset+r.length}else g=c.offset+1,c.children.length>1&&(i=c.children[1].offset);return A(a,{offset:g,length:i-g,content:""},d)}else return A(a,{offset:$.offset,length:$.length,content:JSON.stringify(E)},d);else{if(E===void 0)return[];const h=`${JSON.stringify(p)}: ${JSON.stringify(E)}`,g=m?m(c.children.map(r=>r.children[0].value)):c.children.length;let i;if(g>0){const r=c.children[g-1];i={offset:r.offset+r.length,length:0,content:","+h}}else c.children.length===0?i={offset:c.offset+1,length:0,content:h}:i={offset:c.offset+1,length:0,content:h+","};return A(a,i,d)}}else if(c.type==="array"&&typeof p=="number"&&Array.isArray(c.children))if(E!==void 0){const $=`${JSON.stringify(E)}`;let h;if(c.children.length===0||p===0)h={offset:c.offset+1,length:0,content:c.children.length===0?$:$+","};else{const g=p===-1||p>c.children.length?c.children.length:p,i=c.children[g-1];h={offset:i.offset+i.length,length:0,content:","+$}}return A(a,h,d)}else{const $=p,h=c.children[$];let g;if(c.children.length===1)g={offset:c.offset+1,length:c.length-2,content:""};else if(c.children.length-1===$){const i=c.children[$-1],r=i.offset+i.length,t=c.offset+c.length;g={offset:r,length:t-2-r,content:""}}else g={offset:h.offset,length:c.children[$+1].offset-h.offset,content:""};return A(a,g,d)}else throw new Error(`Can not add ${typeof p!="number"?"index":"property"} to parent of type ${c.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return A(a,{offset:v?v.offset:0,length:v?v.length:0,content:JSON.stringify(E)},d)}}e.$Gn=L;function A(a,y,E){let d=S(a,y),m=y.offset,w=y.offset+y.content.length;if(y.length===0||y.content.length===0){for(;m>0&&!(0,D.$En)(d,m-1);)m--;for(;w<d.length&&!(0,D.$En)(d,w);)w++}const k=(0,D.$Bn)(d,{offset:m,length:w-m},E);for(let c=k.length-1;c>=0;c--){const p=k[c];d=S(d,p),m=Math.min(m,p.offset),w=Math.max(w,p.offset+p.length),w+=p.content.length-p.length}const v=a.length-(d.length-w)-m;return[{offset:m,length:v,content:d.substring(m,w)}]}e.$Hn=A;function S(a,y){return a.substring(0,y.offset)+y.content+a.substring(y.offset+y.length)}e.$In=S;function u(a,y){const E=y.slice(0).sort((m,w)=>{const k=m.offset-w.offset;return k===0?m.length-w.length:k});let d=a.length;for(let m=E.length-1;m>=0;m--){const w=E[m];if(w.offset+w.length<=d)a=S(a,w);else throw new Error("Overlapping edit");d=w.offset}return a}e.$Jn=u}),define(ie[74],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$im=e.$hm=e.$gm=e.rot=e.$em=void 0;function N(S,u,a){return Math.min(Math.max(S,u),a)}e.$em=N;function D(S,u){return(u+S%u)%u}e.rot=D;class R{constructor(){this.a=0}getNext(){return this.a++}}e.$gm=R;class L{constructor(){this.a=1,this.b=0}update(u){return this.b=this.b+(u-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$hm=L;class A{constructor(u){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(u),this.c.fill(0,0,u)}update(u){const a=this.c[this.d];return this.c[this.d]=u,this.d=(this.d+1)%this.c.length,this.e-=a,this.e+=u,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$im=A}),function(){function J(R){const L=[];typeof R=="number"&&L.push("code/timeOrigin",R);function A(u){L.push(u,Date.now())}function S(){const u=[];for(let a=0;a<L.length;a+=2)u.push({name:L[a],startTime:L[a+1]});return u}return{mark:A,getMarks:S}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const A of performance.getEntriesByType("mark"))L.push({name:A.name,startTime:Math.round(R+A.startTime)});return L}};if(typeof process=="object"){const R=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function N(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return N(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=N(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=N(D))}(),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var N=e();for(var D in N)(typeof exports=="object"?exports:J)[D]=N[D]}}(typeof self<"u"?self:this,function(){return function(J){var e={};function N(D){if(e[D])return e[D].exports;var R=e[D]={i:D,l:!1,exports:{}};return J[D].call(R.exports,R,R.exports,N),R.l=!0,R.exports}return N.m=J,N.c=e,N.d=function(D,R,L){N.o(D,R)||Object.defineProperty(D,R,{enumerable:!0,get:L})},N.r=function(D){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},N.t=function(D,R){if(1&R&&(D=N(D)),8&R||4&R&&typeof D=="object"&&D&&D.__esModule)return D;var L=Object.create(null);if(N.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:D}),2&R&&typeof D!="string")for(var A in D)N.d(L,A,function(S){return D[S]}.bind(null,A));return L},N.n=function(D){var R=D&&D.__esModule?function(){return D.default}:function(){return D};return N.d(R,"a",R),R},N.o=function(D,R){return Object.prototype.hasOwnProperty.call(D,R)},N.p="",N(N.s=0)}([function(J,e,N){(function(D){var R;e=J.exports=U,R=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,S=e.re=[],u=e.src=[],a=0,y=a++;u[y]="0|[1-9]\\d*";var E=a++;u[E]="[0-9]+";var d=a++;u[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var m=a++;u[m]="("+u[y]+")\\.("+u[y]+")\\.("+u[y]+")";var w=a++;u[w]="("+u[E]+")\\.("+u[E]+")\\.("+u[E]+")";var k=a++;u[k]="(?:"+u[y]+"|"+u[d]+")";var v=a++;u[v]="(?:"+u[E]+"|"+u[d]+")";var c=a++;u[c]="(?:-("+u[k]+"(?:\\."+u[k]+")*))";var p=a++;u[p]="(?:-?("+u[v]+"(?:\\."+u[v]+")*))";var $=a++;u[$]="[0-9A-Za-z-]+";var h=a++;u[h]="(?:\\+("+u[$]+"(?:\\."+u[$]+")*))";var g=a++,i="v?"+u[m]+u[c]+"?"+u[h]+"?";u[g]="^"+i+"$";var r="[v=\\s]*"+u[w]+u[p]+"?"+u[h]+"?",t=a++;u[t]="^"+r+"$";var n=a++;u[n]="((?:<|>)?=?)";var s=a++;u[s]=u[E]+"|x|X|\\*";var o=a++;u[o]=u[y]+"|x|X|\\*";var l=a++;u[l]="[v=\\s]*("+u[o]+")(?:\\.("+u[o]+")(?:\\.("+u[o]+")(?:"+u[c]+")?"+u[h]+"?)?)?";var O=a++;u[O]="[v=\\s]*("+u[s]+")(?:\\.("+u[s]+")(?:\\.("+u[s]+")(?:"+u[p]+")?"+u[h]+"?)?)?";var I=a++;u[I]="^"+u[n]+"\\s*"+u[l]+"$";var b=a++;u[b]="^"+u[n]+"\\s*"+u[O]+"$";var j=a++;u[j]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var q=a++;u[q]="(?:~>?)";var Y=a++;u[Y]="(\\s*)"+u[q]+"\\s+",S[Y]=new RegExp(u[Y],"g");var K=a++;u[K]="^"+u[q]+u[l]+"$";var oe=a++;u[oe]="^"+u[q]+u[O]+"$";var re=a++;u[re]="(?:\\^)";var he=a++;u[he]="(\\s*)"+u[re]+"\\s+",S[he]=new RegExp(u[he],"g");var de=a++;u[de]="^"+u[re]+u[l]+"$";var ae=a++;u[ae]="^"+u[re]+u[O]+"$";var B=a++;u[B]="^"+u[n]+"\\s*("+r+")$|^$";var X=a++;u[X]="^"+u[n]+"\\s*("+i+")$|^$";var T=a++;u[T]="(\\s*)"+u[n]+"\\s*("+r+"|"+u[l]+")",S[T]=new RegExp(u[T],"g");var M=a++;u[M]="^\\s*("+u[l]+")\\s+-\\s+("+u[l]+")\\s*$";var H=a++;u[H]="^\\s*("+u[O]+")\\s+-\\s+("+u[O]+")\\s*$";var Z=a++;u[Z]="(<|>)?=?\\s*\\*";for(var Q=0;Q<35;Q++)R(Q,u[Q]),S[Q]||(S[Q]=new RegExp(u[Q]));function _(V,x){if(V instanceof U)return V;if(typeof V!="string"||V.length>L||!(x?S[t]:S[g]).test(V))return null;try{return new U(V,x)}catch{return null}}function U(V,x){if(V instanceof U){if(V.loose===x)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof U))return new U(V,x);R("SemVer",V,x),this.loose=x;var ee=V.trim().match(x?S[t]:S[g]);if(!ee)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+ee[1],this.minor=+ee[2],this.patch=+ee[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");ee[4]?this.prerelease=ee[4].split(".").map(function(ge){if(/^[0-9]+$/.test(ge)){var ye=+ge;if(ye>=0&&ye<A)return ye}return ge}):this.prerelease=[],this.build=ee[5]?ee[5].split("."):[],this.format()}e.parse=_,e.valid=function(V,x){var ee=_(V,x);return ee?ee.version:null},e.clean=function(V,x){var ee=_(V.trim().replace(/^[=v]+/,""),x);return ee?ee.version:null},e.SemVer=U,U.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},U.prototype.toString=function(){return this.version},U.prototype.compare=function(V){return R("SemVer.compare",this.version,this.loose,V),V instanceof U||(V=new U(V,this.loose)),this.compareMain(V)||this.comparePre(V)},U.prototype.compareMain=function(V){return V instanceof U||(V=new U(V,this.loose)),f(this.major,V.major)||f(this.minor,V.minor)||f(this.patch,V.patch)},U.prototype.comparePre=function(V){if(V instanceof U||(V=new U(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var x=0;do{var ee=this.prerelease[x],ge=V.prerelease[x];if(R("prerelease compare",x,ee,ge),ee===void 0&&ge===void 0)return 0;if(ge===void 0)return 1;if(ee===void 0)return-1;if(ee!==ge)return f(ee,ge)}while(++x)},U.prototype.inc=function(V,x){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",x);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",x);break;case"prepatch":this.prerelease.length=0,this.inc("patch",x),this.inc("pre",x);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",x),this.inc("pre",x);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ee=this.prerelease.length;--ee>=0;)typeof this.prerelease[ee]=="number"&&(this.prerelease[ee]++,ee=-2);ee===-1&&this.prerelease.push(0)}x&&(this.prerelease[0]===x?isNaN(this.prerelease[1])&&(this.prerelease=[x,0]):this.prerelease=[x,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},e.inc=function(V,x,ee,ge){typeof ee=="string"&&(ge=ee,ee=void 0);try{return new U(V,ee).inc(x,ge).version}catch{return null}},e.diff=function(V,x){if(W(V,x))return null;var ee=_(V),ge=_(x);if(ee.prerelease.length||ge.prerelease.length){for(var ye in ee)if((ye==="major"||ye==="minor"||ye==="patch")&&ee[ye]!==ge[ye])return"pre"+ye;return"prerelease"}for(var ye in ee)if((ye==="major"||ye==="minor"||ye==="patch")&&ee[ye]!==ge[ye])return ye},e.compareIdentifiers=f;var F=/^[0-9]+$/;function f(V,x){var ee=F.test(V),ge=F.test(x);return ee&&ge&&(V=+V,x=+x),ee&&!ge?-1:ge&&!ee?1:V<x?-1:V>x?1:0}function P(V,x,ee){return new U(V,ee).compare(new U(x,ee))}function z(V,x,ee){return P(V,x,ee)>0}function C(V,x,ee){return P(V,x,ee)<0}function W(V,x,ee){return P(V,x,ee)===0}function G(V,x,ee){return P(V,x,ee)!==0}function te(V,x,ee){return P(V,x,ee)>=0}function le(V,x,ee){return P(V,x,ee)<=0}function ue(V,x,ee,ge){var ye;switch(x){case"===":typeof V=="object"&&(V=V.version),typeof ee=="object"&&(ee=ee.version),ye=V===ee;break;case"!==":typeof V=="object"&&(V=V.version),typeof ee=="object"&&(ee=ee.version),ye=V!==ee;break;case"":case"=":case"==":ye=W(V,ee,ge);break;case"!=":ye=G(V,ee,ge);break;case">":ye=z(V,ee,ge);break;case">=":ye=te(V,ee,ge);break;case"<":ye=C(V,ee,ge);break;case"<=":ye=le(V,ee,ge);break;default:throw new TypeError("Invalid operator: "+x)}return ye}function $e(V,x){if(V instanceof $e){if(V.loose===x)return V;V=V.value}if(!(this instanceof $e))return new $e(V,x);R("comparator",V,x),this.loose=x,this.parse(V),this.semver===we?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(V,x){return f(x,V)},e.major=function(V,x){return new U(V,x).major},e.minor=function(V,x){return new U(V,x).minor},e.patch=function(V,x){return new U(V,x).patch},e.compare=P,e.compareLoose=function(V,x){return P(V,x,!0)},e.rcompare=function(V,x,ee){return P(x,V,ee)},e.sort=function(V,x){return V.sort(function(ee,ge){return e.compare(ee,ge,x)})},e.rsort=function(V,x){return V.sort(function(ee,ge){return e.rcompare(ee,ge,x)})},e.gt=z,e.lt=C,e.eq=W,e.neq=G,e.gte=te,e.lte=le,e.cmp=ue,e.Comparator=$e;var we={};function fe(V,x){if(V instanceof fe)return V.loose===x?V:new fe(V.raw,x);if(V instanceof $e)return new fe(V.value,x);if(!(this instanceof fe))return new fe(V,x);if(this.loose=x,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(ee){return this.parseRange(ee.trim())},this).filter(function(ee){return ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function ce(V){return!V||V.toLowerCase()==="x"||V==="*"}function pe(V,x,ee,ge,ye,De,Se,ze,Ie,Ne,Ce,Oe,Ae){return((x=ce(ee)?"":ce(ge)?">="+ee+".0.0":ce(ye)?">="+ee+"."+ge+".0":">="+x)+" "+(ze=ce(Ie)?"":ce(Ne)?"<"+(+Ie+1)+".0.0":ce(Ce)?"<"+Ie+"."+(+Ne+1)+".0":Oe?"<="+Ie+"."+Ne+"."+Ce+"-"+Oe:"<="+ze)).trim()}function ve(V,x){for(var ee=0;ee<V.length;ee++)if(!V[ee].test(x))return!1;if(x.prerelease.length){for(ee=0;ee<V.length;ee++)if(R(V[ee].semver),V[ee].semver!==we&&V[ee].semver.prerelease.length>0){var ge=V[ee].semver;if(ge.major===x.major&&ge.minor===x.minor&&ge.patch===x.patch)return!0}return!1}return!0}function Pe(V,x,ee){try{x=new fe(x,ee)}catch{return!1}return x.test(V)}function je(V,x,ee,ge){var ye,De,Se,ze,Ie;switch(V=new U(V,ge),x=new fe(x,ge),ee){case">":ye=z,De=le,Se=C,ze=">",Ie=">=";break;case"<":ye=C,De=te,Se=z,ze="<",Ie="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Pe(V,x,ge))return!1;for(var Ne=0;Ne<x.set.length;++Ne){var Ce=x.set[Ne],Oe=null,Ae=null;if(Ce.forEach(function(Fe){Fe.semver===we&&(Fe=new $e(">=0.0.0")),Oe=Oe||Fe,Ae=Ae||Fe,ye(Fe.semver,Oe.semver,ge)?Oe=Fe:Se(Fe.semver,Ae.semver,ge)&&(Ae=Fe)}),Oe.operator===ze||Oe.operator===Ie||(!Ae.operator||Ae.operator===ze)&&De(V,Ae.semver)||Ae.operator===Ie&&Se(V,Ae.semver))return!1}return!0}$e.prototype.parse=function(V){var x=this.loose?S[B]:S[X],ee=V.match(x);if(!ee)throw new TypeError("Invalid comparator: "+V);this.operator=ee[1],this.operator==="="&&(this.operator=""),ee[2]?this.semver=new U(ee[2],this.loose):this.semver=we},$e.prototype.toString=function(){return this.value},$e.prototype.test=function(V){return R("Comparator.test",V,this.loose),this.semver===we||(typeof V=="string"&&(V=new U(V,this.loose)),ue(V,this.operator,this.semver,this.loose))},$e.prototype.intersects=function(V,x){if(!(V instanceof $e))throw new TypeError("a Comparator is required");var ee;if(this.operator==="")return ee=new fe(V.value,x),Pe(this.value,ee,x);if(V.operator==="")return ee=new fe(this.value,x),Pe(V.semver,ee,x);var ge=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),ye=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),De=this.semver.version===V.semver.version,Se=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),ze=ue(this.semver,"<",V.semver,x)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),Ie=ue(this.semver,">",V.semver,x)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return ge||ye||De&&Se||ze||Ie},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(V){var x=this.loose;V=V.trim(),R("range",V,x);var ee=x?S[H]:S[M];V=V.replace(ee,pe),R("hyphen replace",V),V=V.replace(S[T],"$1$2$3"),R("comparator trim",V,S[T]),V=(V=(V=V.replace(S[Y],"$1~")).replace(S[he],"$1^")).split(/\s+/).join(" ");var ge=x?S[B]:S[X],ye=V.split(" ").map(function(De){return function(Se,ze){return R("comp",Se),Se=function(Ie,Ne){return Ie.trim().split(/\s+/).map(function(Ce){return function(Oe,Ae){R("caret",Oe,Ae);var Fe=Ae?S[ae]:S[de];return Oe.replace(Fe,function(Le,be,Ee,ke,Re){var Ue;return R("caret",Oe,Le,be,Ee,ke,Re),ce(be)?Ue="":ce(Ee)?Ue=">="+be+".0.0 <"+(+be+1)+".0.0":ce(ke)?Ue=be==="0"?">="+be+"."+Ee+".0 <"+be+"."+(+Ee+1)+".0":">="+be+"."+Ee+".0 <"+(+be+1)+".0.0":Re?(R("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Ue=be==="0"?Ee==="0"?">="+be+"."+Ee+"."+ke+Re+" <"+be+"."+Ee+"."+(+ke+1):">="+be+"."+Ee+"."+ke+Re+" <"+be+"."+(+Ee+1)+".0":">="+be+"."+Ee+"."+ke+Re+" <"+(+be+1)+".0.0"):(R("no pr"),Ue=be==="0"?Ee==="0"?">="+be+"."+Ee+"."+ke+" <"+be+"."+Ee+"."+(+ke+1):">="+be+"."+Ee+"."+ke+" <"+be+"."+(+Ee+1)+".0":">="+be+"."+Ee+"."+ke+" <"+(+be+1)+".0.0"),R("caret return",Ue),Ue})}(Ce,Ne)}).join(" ")}(Se,ze),R("caret",Se),Se=function(Ie,Ne){return Ie.trim().split(/\s+/).map(function(Ce){return function(Oe,Ae){var Fe=Ae?S[oe]:S[K];return Oe.replace(Fe,function(Le,be,Ee,ke,Re){var Ue;return R("tilde",Oe,Le,be,Ee,ke,Re),ce(be)?Ue="":ce(Ee)?Ue=">="+be+".0.0 <"+(+be+1)+".0.0":ce(ke)?Ue=">="+be+"."+Ee+".0 <"+be+"."+(+Ee+1)+".0":Re?(R("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Ue=">="+be+"."+Ee+"."+ke+Re+" <"+be+"."+(+Ee+1)+".0"):Ue=">="+be+"."+Ee+"."+ke+" <"+be+"."+(+Ee+1)+".0",R("tilde return",Ue),Ue})}(Ce,Ne)}).join(" ")}(Se,ze),R("tildes",Se),Se=function(Ie,Ne){return R("replaceXRanges",Ie,Ne),Ie.split(/\s+/).map(function(Ce){return function(Oe,Ae){Oe=Oe.trim();var Fe=Ae?S[b]:S[I];return Oe.replace(Fe,function(Le,be,Ee,ke,Re,Ue){R("xRange",Oe,Le,be,Ee,ke,Re,Ue);var qe=ce(Ee),Me=qe||ce(ke),Te=Me||ce(Re);return be==="="&&Te&&(be=""),qe?Le=be===">"||be==="<"?"<0.0.0":"*":be&&Te?(Me&&(ke=0),Te&&(Re=0),be===">"?(be=">=",Me?(Ee=+Ee+1,ke=0,Re=0):Te&&(ke=+ke+1,Re=0)):be==="<="&&(be="<",Me?Ee=+Ee+1:ke=+ke+1),Le=be+Ee+"."+ke+"."+Re):Me?Le=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":Te&&(Le=">="+Ee+"."+ke+".0 <"+Ee+"."+(+ke+1)+".0"),R("xRange return",Le),Le})}(Ce,Ne)}).join(" ")}(Se,ze),R("xrange",Se),Se=function(Ie,Ne){return R("replaceStars",Ie,Ne),Ie.trim().replace(S[Z],"")}(Se,ze),R("stars",Se),Se}(De,x)}).join(" ").split(/\s+/);return this.loose&&(ye=ye.filter(function(De){return!!De.match(ge)})),ye=ye.map(function(De){return new $e(De,x)})},fe.prototype.intersects=function(V,x){if(!(V instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(ee){return ee.every(function(ge){return V.set.some(function(ye){return ye.every(function(De){return ge.intersects(De,x)})})})})},e.toComparators=function(V,x){return new fe(V,x).set.map(function(ee){return ee.map(function(ge){return ge.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new U(V,this.loose));for(var x=0;x<this.set.length;x++)if(ve(this.set[x],V))return!0;return!1},e.satisfies=Pe,e.maxSatisfying=function(V,x,ee){var ge=null,ye=null;try{var De=new fe(x,ee)}catch{return null}return V.forEach(function(Se){De.test(Se)&&(ge&&ye.compare(Se)!==-1||(ye=new U(ge=Se,ee)))}),ge},e.minSatisfying=function(V,x,ee){var ge=null,ye=null;try{var De=new fe(x,ee)}catch{return null}return V.forEach(function(Se){De.test(Se)&&(ge&&ye.compare(Se)!==1||(ye=new U(ge=Se,ee)))}),ge},e.validRange=function(V,x){try{return new fe(V,x).range||"*"}catch{return null}},e.ltr=function(V,x,ee){return je(V,x,"<",ee)},e.gtr=function(V,x,ee){return je(V,x,">",ee)},e.outside=je,e.prerelease=function(V,x){var ee=_(V,x);return ee&&ee.prerelease.length?ee.prerelease:null},e.intersects=function(V,x,ee){return V=new fe(V,ee),x=new fe(x,ee),V.intersects(x)},e.coerce=function(V){if(V instanceof U)return V;if(typeof V!="string")return null;var x=V.match(S[j]);return x==null?null:_((x[1]||"0")+"."+(x[2]||"0")+"."+(x[3]||"0"))}}).call(this,N(1))},function(J,e){var N,D,R=J.exports={};function L(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function S(v){if(N===setTimeout)return setTimeout(v,0);if((N===L||!N)&&setTimeout)return N=setTimeout,setTimeout(v,0);try{return N(v,0)}catch{try{return N.call(null,v,0)}catch{return N.call(this,v,0)}}}(function(){try{N=typeof setTimeout=="function"?setTimeout:L}catch{N=L}try{D=typeof clearTimeout=="function"?clearTimeout:A}catch{D=A}})();var u,a=[],y=!1,E=-1;function d(){y&&u&&(y=!1,u.length?a=u.concat(a):E=-1,a.length&&m())}function m(){if(!y){var v=S(d);y=!0;for(var c=a.length;c;){for(u=a,a=[];++E<c;)u&&u[E].run();E=-1,c=a.length}u=null,y=!1,function(p){if(D===clearTimeout)return clearTimeout(p);if((D===A||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(p);try{D(p)}catch{try{return D.call(null,p)}catch{return D.call(this,p)}}}(v)}}function w(v,c){this.fun=v,this.array=c}function k(){}R.nextTick=function(v){var c=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)c[p-1]=arguments[p];a.push(new w(v,c)),a.length!==1||y||S(m)},w.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=k,R.addListener=k,R.once=k,R.off=k,R.removeListener=k,R.removeAllListeners=k,R.emit=k,R.prependListener=k,R.prependOnceListener=k,R.listeners=function(v){return[]},R.binding=function(v){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function(v){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(ie[75],ne([0,1]),function(J,e){"use strict";var N;Object.defineProperty(e,"__esModule",{value:!0}),e.$cs=void 0;class D{constructor(S,u,a){this.level=S,this.key=u,this.value=a,this.forward=[]}}const R=void 0;class L{constructor(S,u=2**16){this.comparator=S,this[N]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(u)|0),this.e=new D(this.c,R,R)}get size(){return this.f}clear(){this.e=new D(this.c,R,R),this.f=0}has(S){return!!L.g(this,S,this.comparator)}get(S){return L.g(this,S,this.comparator)?.value}set(S,u){return L.h(this,S,u,this.comparator)&&(this.f+=1),this}delete(S){const u=L.k(this,S,this.comparator);return u&&(this.f-=1),u}forEach(S,u){let a=this.e.forward[0];for(;a;)S.call(u,a.value,a.key,this),a=a.forward[0]}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let S=this.e.forward[0];for(;S;)yield[S.key,S.value],S=S.forward[0]}*keys(){let S=this.e.forward[0];for(;S;)yield S.key,S=S.forward[0]}*values(){let S=this.e.forward[0];for(;S;)yield S.value,S=S.forward[0]}toString(){let S="[SkipList]:",u=this.e.forward[0];for(;u;)S+=`node(${u.key}, ${u.value}, lvl:${u.level})`,u=u.forward[0];return S}static g(S,u,a){let y=S.e;for(let E=S.d-1;E>=0;E--)for(;y.forward[E]&&a(y.forward[E].key,u)<0;)y=y.forward[E];if(y=y.forward[0],y&&a(y.key,u)===0)return y}static h(S,u,a,y){const E=[];let d=S.e;for(let m=S.d-1;m>=0;m--){for(;d.forward[m]&&y(d.forward[m].key,u)<0;)d=d.forward[m];E[m]=d}if(d=d.forward[0],d&&y(d.key,u)===0)return d.value=a,!1;{const m=L.j(S);if(m>S.d){for(let w=S.d;w<m;w++)E[w]=S.e;S.d=m}d=new D(m,u,a);for(let w=0;w<m;w++)d.forward[w]=E[w].forward[w],E[w].forward[w]=d;return!0}}static j(S,u=.5){let a=1;for(;Math.random()<u&&a<S.c;)a+=1;return a}static k(S,u,a){const y=[];let E=S.e;for(let d=S.d-1;d>=0;d--){for(;E.forward[d]&&a(E.forward[d].key,u)<0;)E=E.forward[d];y[d]=E}if(E=E.forward[0],!E||a(E.key,u)!==0)return!1;for(let d=0;d<S.d&&y[d].forward[d]===E;d++)y[d].forward[d]=E.forward[d];for(;S.d>0&&S.e.forward[S.d-1]===R;)S.d-=1;return!0}}e.$cs=L}),define(ie[46],ne([0,1,7,2]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=void 0;function R(h){const g=h;return g?typeof g.read=="function":!1}e.$de=R;function L(h){const g=h;return g?[g.on,g.pause,g.resume,g.destroy].every(i=>typeof i=="function"):!1}e.$ee=L;function A(h){const g=h;return g?L(g.stream)&&Array.isArray(g.buffer)&&typeof g.ended=="boolean":!1}e.$fe=A;function S(h,g){return new u(h,g)}e.$ge=S;class u{constructor(g,i){this.e=g,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(g){if(!this.a.destroyed){if(this.a.flowing)this.g(g);else if(this.b.data.push(g),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(g){this.a.destroyed||(this.a.flowing?this.h(g):this.b.error.push(g))}end(g){this.a.destroyed||(typeof g<"u"&&this.write(g),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(g){this.c.data.slice(0).forEach(i=>i(g))}h(g){this.c.error.length===0?(0,N.$1)(g):this.c.error.slice(0).forEach(i=>i(g))}i(){this.c.end.slice(0).forEach(g=>g())}on(g,i){if(!this.a.destroyed)switch(g){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(g,i){if(this.a.destroyed)return;let r;switch(g){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const t=r.indexOf(i);t>=0&&r.splice(t,1)}}j(){if(this.b.data.length>0){const g=this.e(this.b.data);this.g(g),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const g of this.b.error)this.h(g);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(h,g){const i=[];let r;for(;(r=h.read())!==null;)i.push(r);return g(i)}e.$he=a;function y(h,g,i){const r=[];let t;for(;(t=h.read())!==null&&r.length<i;)r.push(t);return t===null&&r.length>0?g(r):{read:()=>{if(r.length>0)return r.shift();if(typeof t<"u"){const n=t;return t=void 0,n}return h.read()}}}e.$ie=y;function E(h,g){return new Promise((i,r)=>{const t=[];d(h,{onData:n=>{g&&t.push(n)},onError:n=>{g?r(n):i(void 0)},onEnd:()=>{i(g?g(t):void 0)}})})}e.$je=E;function d(h,g,i){h.on("error",r=>{i?.isCancellationRequested||g.onError(r)}),h.on("end",()=>{i?.isCancellationRequested||g.onEnd()}),h.on("data",r=>{i?.isCancellationRequested||g.onData(r)})}e.$ke=d;function m(h,g){return new Promise((i,r)=>{const t=new D.$Sc,n=[],s=O=>{if(n.push(O),n.length>g)return t.dispose(),h.pause(),i({stream:h,buffer:n,ended:!1})},o=O=>(t.dispose(),r(O)),l=()=>(t.dispose(),i({stream:h,buffer:n,ended:!0}));t.add((0,D.$Rc)(()=>h.removeListener("error",o))),h.on("error",o),t.add((0,D.$Rc)(()=>h.removeListener("end",l))),h.on("end",l),t.add((0,D.$Rc)(()=>h.removeListener("data",s))),h.on("data",s)})}e.$le=m;function w(h,g){const i=S(g);return i.end(h),i}e.$me=w;function k(){const h=S(()=>{throw new Error("not supported")});return h.end(),h}e.$ne=k;function v(h){let g=!1;return{read:()=>g?null:(g=!0,h)}}e.$oe=v;function c(h,g,i){const r=S(i);return d(h,{onData:t=>r.write(g.data(t)),onError:t=>r.error(g.error?g.error(t):t),onEnd:()=>r.end()}),r}e.$pe=c;function p(h,g,i){let r=!1;return{read:()=>{const t=g.read();return r?t:(r=!0,t!==null?i([h,t]):h)}}}e.$qe=p;function $(h,g,i){let r=!1;const t=S(i);return d(g,{onData:n=>r?t.write(n):(r=!0,t.write(i([h,n]))),onError:n=>t.error(n),onEnd:()=>{r||(r=!0,t.write(h)),t.end()}}),t}e.$re=$}),define(ie[14],ne([0,1,166,46]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=void 0;const R=typeof Buffer<"u",L=new N.$V(()=>new Uint8Array(256));let A,S;class u{static alloc(j){return R?new u(Buffer.allocUnsafe(j)):new u(new Uint8Array(j))}static wrap(j){return R&&!Buffer.isBuffer(j)&&(j=Buffer.from(j.buffer,j.byteOffset,j.byteLength)),new u(j)}static fromString(j,q){return!(q?.dontUseNodeBuffer||!1)&&R?new u(Buffer.from(j)):(A||(A=new TextEncoder),new u(A.encode(j)))}static fromByteArray(j){const q=u.alloc(j.length);for(let Y=0,K=j.length;Y<K;Y++)q.buffer[Y]=j[Y];return q}static concat(j,q){if(typeof q>"u"){q=0;for(let oe=0,re=j.length;oe<re;oe++)q+=j[oe].byteLength}const Y=u.alloc(q);let K=0;for(let oe=0,re=j.length;oe<re;oe++){const he=j[oe];Y.set(he,K),K+=he.byteLength}return Y}constructor(j){this.buffer=j,this.byteLength=this.buffer.byteLength}clone(){const j=u.alloc(this.byteLength);return j.set(this),j}toString(){return R?this.buffer.toString():(S||(S=new TextDecoder),S.decode(this.buffer))}slice(j,q){return new u(this.buffer.subarray(j,q))}set(j,q){if(j instanceof u)this.buffer.set(j.buffer,q);else if(j instanceof Uint8Array)this.buffer.set(j,q);else if(j instanceof ArrayBuffer)this.buffer.set(new Uint8Array(j),q);else if(ArrayBuffer.isView(j))this.buffer.set(new Uint8Array(j.buffer,j.byteOffset,j.byteLength),q);else throw new Error("Unknown argument 'array'")}readUInt32BE(j){return d(this.buffer,j)}writeUInt32BE(j,q){m(this.buffer,j,q)}readUInt32LE(j){return w(this.buffer,j)}writeUInt32LE(j,q){k(this.buffer,j,q)}readUInt8(j){return v(this.buffer,j)}writeUInt8(j,q){c(this.buffer,j,q)}indexOf(j,q=0){return a(this.buffer,j instanceof u?j.buffer:j,q)}}e.$se=u;function a(b,j,q=0){const Y=j.byteLength,K=b.byteLength;if(Y===0)return 0;if(Y===1)return b.indexOf(j[0]);if(Y>K-q)return-1;const oe=L.value;oe.fill(j.length);for(let ae=0;ae<j.length;ae++)oe[j[ae]]=j.length-ae-1;let re=q+j.length-1,he=re,de=-1;for(;re<K;)if(b[re]===j[he]){if(he===0){de=re;break}re--,he--}else re+=Math.max(j.length-he,oe[b[re]]),he=j.length-1;return de}e.$te=a;function y(b,j){return b[j+0]<<0>>>0|b[j+1]<<8>>>0}e.$ue=y;function E(b,j,q){b[q+0]=j&255,j=j>>>8,b[q+1]=j&255}e.$ve=E;function d(b,j){return b[j]*2**24+b[j+1]*2**16+b[j+2]*2**8+b[j+3]}e.$we=d;function m(b,j,q){b[q+3]=j,j=j>>>8,b[q+2]=j,j=j>>>8,b[q+1]=j,j=j>>>8,b[q]=j}e.$xe=m;function w(b,j){return b[j+0]<<0>>>0|b[j+1]<<8>>>0|b[j+2]<<16>>>0|b[j+3]<<24>>>0}e.$ye=w;function k(b,j,q){b[q+0]=j&255,j=j>>>8,b[q+1]=j&255,j=j>>>8,b[q+2]=j&255,j=j>>>8,b[q+3]=j&255}e.$ze=k;function v(b,j){return b[j]}e.$Ae=v;function c(b,j,q){b[q]=j}e.$Be=c;function p(b){return D.$he(b,j=>u.concat(j))}e.$Ce=p;function $(b){return D.$oe(b)}e.$De=$;function h(b){return D.$je(b,j=>u.concat(j))}e.$Ee=h;async function g(b){return b.ended?u.concat(b.buffer):u.concat([...b.buffer,await h(b.stream)])}e.$Fe=g;function i(b){return D.$me(b,j=>u.concat(j))}e.$Ge=i;function r(b){return D.$pe(b,{data:j=>typeof j=="string"?u.fromString(j):u.wrap(j)},j=>u.concat(j))}e.$He=r;function t(b){return D.$ge(j=>u.concat(j),b)}e.$Ie=t;function n(b,j){return D.$qe(b,j,q=>u.concat(q))}e.$Je=n;function s(b,j){return D.$re(b,j,q=>u.concat(q))}e.$Ke=s;function o(b){let j=0,q=0,Y=0;const K=new Uint8Array(Math.floor(b.length/4*3)),oe=he=>{switch(q){case 3:K[Y++]=j|he,q=0;break;case 2:K[Y++]=j|he>>>2,j=he<<6,q=3;break;case 1:K[Y++]=j|he>>>4,j=he<<4,q=2;break;default:j=he<<2,q=1}};for(let he=0;he<b.length;he++){const de=b.charCodeAt(he);if(de>=65&&de<=90)oe(de-65);else if(de>=97&&de<=122)oe(de-97+26);else if(de>=48&&de<=57)oe(de-48+52);else if(de===43||de===45)oe(62);else if(de===47||de===95)oe(63);else{if(de===61)break;throw new SyntaxError(`Unexpected base64 character ${b[he]}`)}}const re=Y;for(;q>0;)oe(0);return u.wrap(K).slice(0,re)}e.$Le=o;const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",O="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function I({buffer:b},j=!0,q=!1){const Y=q?O:l;let K="";const oe=b.byteLength%3;let re=0;for(;re<b.byteLength-oe;re+=3){const he=b[re+0],de=b[re+1],ae=b[re+2];K+=Y[he>>>2],K+=Y[(he<<4|de>>>4)&63],K+=Y[(de<<2|ae>>>6)&63],K+=Y[ae&63]}if(oe===1){const he=b[re+0];K+=Y[he>>>2],K+=Y[he<<4&63],j&&(K+="==")}else if(oe===2){const he=b[re+0],de=b[re+1];K+=Y[he>>>2],K+=Y[(he<<4|de>>>4)&63],K+=Y[de<<2&63],j&&(K+="=")}return K}e.$Me=I}),define(ie[43],ne([0,1,30]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=void 0;function D(c){return R(c,0)}e.$6i=D;function R(c,p){switch(typeof c){case"object":return c===null?L(349,p):Array.isArray(c)?u(c,p):a(c,p);case"string":return S(c,p);case"boolean":return A(c,p);case"number":return L(c,p);case"undefined":return L(937,p);default:return L(617,p)}}e.$7i=R;function L(c,p){return(p<<5)-p+c|0}e.$8i=L;function A(c,p){return L(c?433:863,p)}function S(c,p){p=L(149417,p);for(let $=0,h=c.length;$<h;$++)p=L(c.charCodeAt($),p);return p}e.$9i=S;function u(c,p){return p=L(104579,p),c.reduce(($,h)=>R(h,$),p)}function a(c,p){return p=L(181387,p),Object.keys(c).sort().reduce(($,h)=>($=S(h,$),R(c[h],$)),p)}class y{constructor(){this.g=0}get value(){return this.g}hash(p){return this.g=R(p,this.g),this.g}}e.$0i=y;var E;(function(c){c[c.BLOCK_SIZE=64]="BLOCK_SIZE",c[c.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function d(c,p,$=32){const h=$-p,g=~((1<<h)-1);return(c<<p|(g&c)>>>h)>>>0}function m(c,p=0,$=c.byteLength,h=0){for(let g=0;g<$;g++)c[p+g]=h}function w(c,p,$="0"){for(;c.length<p;)c=$+c;return c}function k(c,p=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map($=>$.toString(16).padStart(2,"0")).join(""):w((c>>>0).toString(16),p/4)}e.$$i=k;class v{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(p){const $=p.length;if($===0)return;const h=this.p;let g=this.r,i=this.u,r,t;for(i!==0?(r=i,t=-1,i=0):(r=p.charCodeAt(0),t=0);;){let n=r;if(N.$nf(r))if(t+1<$){const s=p.charCodeAt(t+1);N.$of(s)?(t++,n=N.$pf(r,s)):n=65533}else{i=r;break}else N.$of(r)&&(n=65533);if(g=this.w(h,g,n),t++,t<$)r=p.charCodeAt(t);else break}this.r=g,this.u=i}w(p,$,h){return h<128?p[$++]=h:h<2048?(p[$++]=192|(h&1984)>>>6,p[$++]=128|(h&63)>>>0):h<65536?(p[$++]=224|(h&61440)>>>12,p[$++]=128|(h&4032)>>>6,p[$++]=128|(h&63)>>>0):(p[$++]=240|(h&1835008)>>>18,p[$++]=128|(h&258048)>>>12,p[$++]=128|(h&4032)>>>6,p[$++]=128|(h&63)>>>0),$>=64&&(this.y(),$-=64,this.t+=64,p[0]=p[64],p[1]=p[65],p[2]=p[66]),$}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),k(this.h)+k(this.l)+k(this.m)+k(this.n)+k(this.o)}x(){this.p[this.r++]=128,m(this.p,this.r),this.r>56&&(this.y(),m(this.p));const p=8*this.t;this.q.setUint32(56,Math.floor(p/4294967296),!1),this.q.setUint32(60,p%4294967296,!1),this.y()}y(){const p=v.g,$=this.q;for(let l=0;l<64;l+=4)p.setUint32(l,$.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)p.setUint32(l,d(p.getUint32(l-12,!1)^p.getUint32(l-32,!1)^p.getUint32(l-56,!1)^p.getUint32(l-64,!1),1),!1);let h=this.h,g=this.l,i=this.m,r=this.n,t=this.o,n,s,o;for(let l=0;l<80;l++)l<20?(n=g&i|~g&r,s=1518500249):l<40?(n=g^i^r,s=1859775393):l<60?(n=g&i|g&r|i&r,s=2400959708):(n=g^i^r,s=3395469782),o=d(h,5)+n+t+s+p.getUint32(l*4,!1)&4294967295,t=r,r=i,i=d(g,30),g=h,h=o;this.h=this.h+h&4294967295,this.l=this.l+g&4294967295,this.m=this.m+i&4294967295,this.n=this.n+r&4294967295,this.o=this.o+t&4294967295}}e.$_i=v}),define(ie[54],ne([0,1,30]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var D;(function(R){R[R.Ignore=0]="Ignore",R[R.Info=1]="Info",R[R.Warning=2]="Warning",R[R.Error=3]="Error"})(D||(D={})),function(R){const L="error",A="warning",S="warn",u="info",a="ignore";function y(d){return d?N.$jf(L,d)?R.Error:N.$jf(A,d)||N.$jf(S,d)?R.Warning:N.$jf(u,d)?R.Info:R.Ignore:R.Ignore}R.fromValue=y;function E(d){switch(d){case R.Error:return L;case R.Warning:return A;case R.Info:return u;default:return a}}R.toString=E}(D||(D={})),e.default=D}),define(ie[27],ne([0,1,3]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.$Ln=e.$Kn=void 0;function D(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const p=Array.isArray(c)?[]:{};return Object.entries(c).forEach(([$,h])=>{p[$]=h&&typeof h=="object"?D(h):h}),p}e.$Kn=D;function R(c){if(!c||typeof c!="object")return c;const p=[c];for(;p.length>0;){const $=p.shift();Object.freeze($);for(const h in $)if(L.call($,h)){const g=$[h];typeof g=="object"&&!Object.isFrozen(g)&&!(0,N.$Vf)(g)&&p.push(g)}}return c}e.$Ln=R;const L=Object.prototype.hasOwnProperty;function A(c,p){return S(c,p,new Set)}e.$Mn=A;function S(c,p,$){if((0,N.$2f)(c))return c;const h=p(c);if(typeof h<"u")return h;if(Array.isArray(c)){const g=[];for(const i of c)g.push(S(i,p,$));return g}if((0,N.$Uf)(c)){if($.has(c))throw new Error("Cannot clone recursive data-structure");$.add(c);const g={};for(const i in c)L.call(c,i)&&(g[i]=S(c[i],p,$));return $.delete(c),g}return c}function u(c,p,$=!0){return(0,N.$Uf)(c)?((0,N.$Uf)(p)&&Object.keys(p).forEach(h=>{h in c?$&&((0,N.$Uf)(c[h])&&(0,N.$Uf)(p[h])?u(c[h],p[h],$):c[h]=p[h]):c[h]=p[h]}),c):p}e.$Nn=u;function a(c,p){if(c===p)return!0;if(c==null||p===null||p===void 0||typeof c!=typeof p||typeof c!="object"||Array.isArray(c)!==Array.isArray(p))return!1;let $,h;if(Array.isArray(c)){if(c.length!==p.length)return!1;for($=0;$<c.length;$++)if(!a(c[$],p[$]))return!1}else{const g=[];for(h in c)g.push(h);g.sort();const i=[];for(h in p)i.push(h);if(i.sort(),!a(g,i))return!1;for($=0;$<g.length;$++)if(!a(c[g[$]],p[g[$]]))return!1}return!0}e.$On=a;function y(c){const p=new Set;return JSON.stringify(c,($,h)=>{if((0,N.$Uf)(h)||Array.isArray(h)){if(p.has(h))return"[Circular]";p.add(h)}return h})}e.$Pn=y;function E(c,p){const $=Object.create(null);return!c||!p||Object.keys(p).forEach(g=>{const i=c[g],r=p[g];a(i,r)||($[g]=r)}),$}e.$Qn=E;function d(c,p){const $=p.toLowerCase(),h=Object.keys(c).find(g=>g.toLowerCase()===$);return h?c[h]:c[p]}e.$Rn=d;function m(c,p){const $=Object.create(null);for(const[h,g]of Object.entries(c))p(h,g)&&($[h]=g);return $}e.$Sn=m;function w(c){let p=[];for(;Object.prototype!==c;)p=p.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return p}e.$Tn=w;function k(c){const p=[];for(const $ of w(c))typeof c[$]=="function"&&p.push($);return p}e.$Un=k;function v(c,p){const $=g=>function(){const i=Array.prototype.slice.call(arguments,0);return p(g,i)},h={};for(const g of c)h[g]=$(g);return h}e.$Vn=v}),define(ie[28],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bg=e.$Ag=void 0;const N=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(R){return N.test(R)}e.$Ag=D,e.$Bg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(S){for(let u=0;u<S.length;u++)S[u]=Math.floor(Math.random()*256);return S};const L=new Uint8Array(16),A=[];for(let S=0;S<256;S++)A.push(S.toString(16).padStart(2,"0"));return function(){R(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let u=0,a="";return a+=A[L[u++]],a+=A[L[u++]],a+=A[L[u++]],a+=A[L[u++]],a+="-",a+=A[L[u++]],a+=A[L[u++]],a+="-",a+=A[L[u++]],a+=A[L[u++]],a+="-",a+=A[L[u++]],a+=A[L[u++]],a+="-",a+=A[L[u++]],a+=A[L[u++]],a+=A[L[u++]],a+=A[L[u++]],a+=A[L[u++]],a+=A[L[u++]],a}}()}),define(ie[76],ne([0,1,33]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=void 0;const D=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function R(A){const S=A.replace(/\-/g,":").toLowerCase();return!D.has(S)}function L(){const A=(0,N.networkInterfaces)();for(const S in A){const u=A[S];if(u){for(const{mac:a}of u)if(R(a))return a}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$ln=L}),define(ie[77],ne([8,5]),function(J,e){return J.create("vs/base/common/date",e)}),define(ie[78],ne([0,1,77]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lm=e.$Km=e.$Jm=void 0;const D=60,R=D*60,L=R*24,A=L*7,S=L*30,u=L*365;function a(d,m,w,k){typeof d!="number"&&(d=d.getTime());const v=Math.round((new Date().getTime()-d)/1e3);if(v<-30)return(0,N.localize)(0,null,a(new Date().getTime()+v*1e3,!1));if(!k&&v<30)return(0,N.localize)(1,null);let c;return v<D?(c=v,m?c===1?w?(0,N.localize)(2,null,c):(0,N.localize)(3,null,c):w?(0,N.localize)(4,null,c):(0,N.localize)(5,null,c):c===1?w?(0,N.localize)(6,null,c):(0,N.localize)(7,null,c):w?(0,N.localize)(8,null,c):(0,N.localize)(9,null,c)):v<R?(c=Math.floor(v/D),m?c===1?w?(0,N.localize)(10,null,c):(0,N.localize)(11,null,c):w?(0,N.localize)(12,null,c):(0,N.localize)(13,null,c):c===1?w?(0,N.localize)(14,null,c):(0,N.localize)(15,null,c):w?(0,N.localize)(16,null,c):(0,N.localize)(17,null,c)):v<L?(c=Math.floor(v/R),m?c===1?w?(0,N.localize)(18,null,c):(0,N.localize)(19,null,c):w?(0,N.localize)(20,null,c):(0,N.localize)(21,null,c):c===1?w?(0,N.localize)(22,null,c):(0,N.localize)(23,null,c):w?(0,N.localize)(24,null,c):(0,N.localize)(25,null,c)):v<A?(c=Math.floor(v/L),m?c===1?(0,N.localize)(26,null,c):(0,N.localize)(27,null,c):c===1?(0,N.localize)(28,null,c):(0,N.localize)(29,null,c)):v<S?(c=Math.floor(v/A),m?c===1?w?(0,N.localize)(30,null,c):(0,N.localize)(31,null,c):w?(0,N.localize)(32,null,c):(0,N.localize)(33,null,c):c===1?w?(0,N.localize)(34,null,c):(0,N.localize)(35,null,c):w?(0,N.localize)(36,null,c):(0,N.localize)(37,null,c)):v<u?(c=Math.floor(v/S),m?c===1?w?(0,N.localize)(38,null,c):(0,N.localize)(39,null,c):w?(0,N.localize)(40,null,c):(0,N.localize)(41,null,c):c===1?w?(0,N.localize)(42,null,c):(0,N.localize)(43,null,c):w?(0,N.localize)(44,null,c):(0,N.localize)(45,null,c)):(c=Math.floor(v/u),m?c===1?w?(0,N.localize)(46,null,c):(0,N.localize)(47,null,c):w?(0,N.localize)(48,null,c):(0,N.localize)(49,null,c):c===1?w?(0,N.localize)(50,null,c):(0,N.localize)(51,null,c):w?(0,N.localize)(52,null,c):(0,N.localize)(53,null,c))}e.$Jm=a;function y(d,m){const w=Math.abs(d/1e3);return w<1?m?(0,N.localize)(54,null,d):(0,N.localize)(55,null,d):w<D?m?(0,N.localize)(56,null,Math.round(d)/1e3):(0,N.localize)(57,null,Math.round(d)/1e3):w<R?m?(0,N.localize)(58,null,Math.round(d/(1e3*D))):(0,N.localize)(59,null,Math.round(d/(1e3*D))):w<L?m?(0,N.localize)(60,null,Math.round(d/(1e3*R))):(0,N.localize)(61,null,Math.round(d/(1e3*R))):(0,N.localize)(62,null,Math.round(d/(1e3*L)))}e.$Km=y;function E(d){return d.getFullYear()+"-"+String(d.getMonth()+1).padStart(2,"0")+"-"+String(d.getDate()).padStart(2,"0")+"T"+String(d.getHours()).padStart(2,"0")+":"+String(d.getMinutes()).padStart(2,"0")+":"+String(d.getSeconds()).padStart(2,"0")+"."+(d.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$Lm=E}),define(ie[79],ne([8,5]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(ie[34],ne([0,1,19,3,79]),function(J,e,N,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5i=e.$4i=e.$3i=void 0;function L(E,d){return d&&(E.stack||E.stacktrace)?R.localize(0,null,S(E),A(E.stack)||A(E.stacktrace)):S(E)}function A(E){return Array.isArray(E)?E.join(`
`):E}function S(E){return E.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${E.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?R.localize(1,null,E.message):E.message||R.localize(2,null)}function u(E=null,d=!1){if(!E)return R.localize(3,null);if(Array.isArray(E)){const m=N.$Hb(E),w=u(m[0],d);return m.length>1?R.localize(4,null,w,m.length):w}if(D.$Sf(E))return E;if(E.detail){const m=E.detail;if(m.error)return L(m.error,d);if(m.exception)return L(m.exception,d)}return E.stack?L(E,d):E.message?E.message:R.localize(5,null)}e.$3i=u;function a(E){const d=E;return d instanceof Error&&Array.isArray(d.actions)}e.$4i=a;function y(E,d){let m;return typeof E=="string"?m=new Error(E):m=E,m.actions=d,m}e.$5i=y}),define(ie[80],ne([8,5]),function(J,e){return J.create("vs/base/common/jsonErrorMessages",e)}),define(ie[81],ne([0,1,80]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_p=void 0;function D(R){switch(R){case 1:return(0,N.localize)(0,null);case 2:return(0,N.localize)(1,null);case 3:return(0,N.localize)(2,null);case 4:return(0,N.localize)(3,null);case 5:return(0,N.localize)(4,null);case 6:return(0,N.localize)(5,null);case 7:return(0,N.localize)(6,null);case 8:return(0,N.localize)(7,null);case 9:return(0,N.localize)(8,null);default:return""}}e.$_p=D}),define(ie[55],ne([0,1,12]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3l=e.$2l=e.TerminateResponseCode=e.Source=void 0;var D;(function(S){S[S.stdout=0]="stdout",S[S.stderr=1]="stderr"})(D||(e.Source=D={}));var R;(function(S){S[S.Success=0]="Success",S[S.Unknown=1]="Unknown",S[S.AccessDenied=2]="AccessDenied",S[S.ProcessNotFound=3]="ProcessNotFound"})(R||(e.TerminateResponseCode=R={}));function L(S,...u){const a=u.reduce((d,m)=>(d[m]=!0,d),{}),y=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(S).filter(d=>!a[d]).forEach(d=>{for(let m=0;m<y.length;m++)if(d.search(y[m])!==-1){delete S[d];break}})}e.$2l=L;function A(S){S&&(delete S.DEBUG,N.$j&&delete S.DYLD_LIBRARY_PATH,N.$k&&delete S.LD_PRELOAD)}e.$3l=A}),define(ie[82],ne([0,1,11]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Cq=e.$Bq=e.$Aq=void 0;function D(a){const y=a;return y&&typeof y.type=="string"&&typeof y.severity=="string"}e.$Aq=D;function R(a){const y=[];let E;try{const d=JSON.parse(a.arguments),m=d[d.length-1];m&&m.__$stack&&(d.pop(),E=m.__$stack),y.push(...d)}catch{y.push("Unable to log remote console arguments",a.arguments)}return{args:y,stack:E}}e.$Bq=R;function L(a){if(typeof a!="string")return L(R(a).stack);const y=a;if(y){const E=A(y),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(d&&d.length===4)return{uri:N.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}e.$Cq=L;function A(a){if(!a)return a;const y=a.indexOf(`
`);return y===-1?a:a.substring(0,y)}function S(a,y){const{args:E,stack:d}=R(a),m=typeof E[0]=="string"&&E.length===1;let w=A(d);w&&(w=`(${w.trim()})`);let k=[];if(typeof E[0]=="string"?w&&m?k=[`%c[${y}] %c${E[0]} %c${w}`,u("blue"),u(""),u("grey")]:k=[`%c[${y}] %c${E[0]}`,u("blue"),u(""),...E.slice(1)]:k=[`%c[${y}]%`,u("blue"),...E],w&&!m&&k.push(w),typeof console[a.severity]!="function")throw new Error("Unknown console method");console[a.severity].apply(console,k)}e.log=S;function u(a){return`color: ${a}`}}),define(ie[47],ne([0,1,14,11]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oh=e.$Nh=e.$Mh=void 0;function R(u){return JSON.stringify(u,A)}e.$Mh=R;function L(u){let a=JSON.parse(u);return a=S(a),a}e.$Nh=L;function A(u,a){return a instanceof RegExp?{$mid:2,source:a.source,flags:a.flags}:a}function S(u,a=0){if(!u||a>200)return u;if(typeof u=="object"){switch(u.$mid){case 1:return D.URI.revive(u);case 2:return new RegExp(u.source,u.flags);case 17:return new Date(u.source)}if(u instanceof N.$se||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let y=0;y<u.length;++y)u[y]=S(u[y],a+1);else for(const y in u)Object.hasOwnProperty.call(u,y)&&(u[y]=S(u[y],a+1))}return u}e.$Oh=S}),define(ie[83],ne([0,1,70,15,12,11]),function(J,e,N,D,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wD=void 0;class A{constructor(d,m,w){this.id=d,this.dependencies=m,this.callback=w}}class S{static{this.INSTANCE=new S}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(d,m,w)=>{typeof d!="string"&&(w=m,m=d,d=null),(typeof m!="object"||!Array.isArray(m))&&(w=m,m=null),this.c.push(new A(d,m,w))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){if(d.startsWith(window.location.origin)||d.startsWith("vscode-file://vscode-app"))return d;throw new Error(`[trusted_script_src] Invalid script url: ${d}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){return d}})))}async load(d){this.g();const m=await(this.a?this.i(d):this.b?this.h(d):this.j(d));if(!m)throw new Error(`Did not receive a define call from script ${d}`);if(Array.isArray(m.dependencies)&&m.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${d}. The dependencies are: ${m.dependencies.join(", ")}`);return typeof m.callback=="function"?m.callback([]):m.callback}h(d){return new Promise((m,w)=>{const k=document.createElement("script");k.setAttribute("async","async"),k.setAttribute("type","text/javascript");const v=()=>{k.removeEventListener("load",c),k.removeEventListener("error",p)},c=$=>{v(),m(this.c.pop())},p=$=>{v(),w($)};k.addEventListener("load",c),k.addEventListener("error",p),this.f&&(d=this.f.createScriptURL(d)),k.setAttribute("src",d),window.document.getElementsByTagName("head")[0].appendChild(k)})}i(d){return new Promise((m,w)=>{try{this.f&&(d=this.f.createScriptURL(d)),importScripts(d),m(this.c.pop())}catch(k){w(k)}})}async j(d){try{const m=globalThis._VSCODE_NODE_MODULES.fs,w=globalThis._VSCODE_NODE_MODULES.vm,k=globalThis._VSCODE_NODE_MODULES.module,v=L.URI.parse(d).fsPath,c=m.readFileSync(v).toString(),p=k.wrap(c.replace(/^#!.*/,""));return new w.Script(p).runInThisContext().apply(),this.c.pop()}catch(m){throw m}}}const u=new Map;let a={};typeof globalThis.require=="object"&&(a=globalThis.require.paths??{});async function y(E,d,m){if(N.$T){m===void 0&&(m=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),a[E]&&(E=a[E]);const w=`${E}/${d}`;if(u.has(w))return u.get(w);let k;if(/^\w[\w\d+.-]*:\/\//.test(w))k=w;else{const $=`${m&&!R.$o?D.$wg:D.$vg}/${w}`;k=D.$zg.asBrowserUri($).toString(!0)}const v=S.INSTANCE.load(k);return u.set(w,v),v}else return await new Promise((w,k)=>{J([E],w,k)})}e.$wD=y}),define(ie[84],ne([0,1,33,48,28,76,12]),function(J,e,N,D,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$on=e.$nn=e.$mn=void 0,e.$mn=new class{c(d){return this.a||(this.a=D.$li.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(d)}value(){if(this.b===void 0){let d=0,m=0;const w=(0,N.networkInterfaces)();for(const k in w){const v=w[k];if(v)for(const{mac:c,internal:p}of v)p||(m+=1,this.c(c.toUpperCase())&&(d+=1))}this.b=m>0?d/m:0}return this.b}};let S;async function u(d){return S||(S=(async()=>await a(d)||R.$Bg())()),S}e.$nn=u;async function a(d){try{const m=await new Promise((k,v)=>{J(["crypto"],k,v)}),w=(0,L.$ln)();return m.createHash("sha256").update(w,"utf8").digest("hex")}catch(m){d(m);return}}const y="Software\\Microsoft\\SQMClient";async function E(d){if(A.$i){const m=await new Promise((w,k)=>{J(["@vscode/windows-registry"],w,k)});try{return m.GetStringRegKey("HKEY_LOCAL_MACHINE",y,"MachineId")||""}catch(w){return d(w),""}}return""}e.$on=E}),define(ie[85],ne([0,1,33,16,24]),function(J,e,N,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1l=e.$Zl=void 0;const L=/^\d+$/,A=/^Microsoft.PowerShell_.*/,S=/^Microsoft.PowerShellPreview_.*/;var u;(function(h){h[h.x64=0]="x64",h[h.x86=1]="x86",h[h.ARM=2]="ARM"})(u||(u={}));let a;switch(process.arch){case"ia32":a=1;break;case"arm":case"arm64":a=2;break;default:a=0;break}let y;process.env.PROCESSOR_ARCHITEW6432?y=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?y=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?y=1:y=0;class E{constructor(g,i,r){this.exePath=g,this.displayName=i,this.a=r}async exists(){return this.a===void 0&&(this.a=await R.SymlinkSupport.existsFile(this.exePath)),this.a}}function d({useAlternateBitness:h=!1}={}){return h?a===0?process.env["ProgramFiles(x86)"]||null:y===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function m({useAlternateBitness:h=!1,findPreview:g=!1}={}){const i=d({useAlternateBitness:h});if(!i)return null;const r=D.$jc(i,"PowerShell");if(!await R.SymlinkSupport.existsDirectory(r))return null;let t=-1,n=null;for(const l of await R.Promises.readdir(r)){let O=-1;if(g){const b=l.indexOf("-");if(b<0)continue;const j=l.substring(0,b);if(!L.test(j)||l.substring(b+1)!=="preview")continue;O=parseInt(j,10)}else{if(!L.test(l))continue;O=parseInt(l,10)}if(O<=t)continue;const I=D.$jc(r,l,"pwsh.exe");await R.SymlinkSupport.existsFile(I)&&(n=I,t=O)}if(!n)return null;const s=i.includes("x86")?" (x86)":"",o=g?" Preview":"";return new E(n,`PowerShell${o}${s}`,!0)}async function w({findPreview:h}={}){if(!process.env.LOCALAPPDATA)return null;const g=D.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await R.SymlinkSupport.existsDirectory(g))return null;const{pwshMsixDirRegex:i,pwshMsixName:r}=h?{pwshMsixDirRegex:S,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const t of await R.Promises.readdir(g))if(i.test(t)){const n=D.$jc(g,t,"pwsh.exe");return new E(n,r)}return null}function k(){const h=D.$jc(N.homedir(),".dotnet","tools","pwsh.exe");return new E(h,".NET Core PowerShell Global Tool")}function v(){const h=D.$jc(process.env.windir,a===1&&y!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(h,"Windows PowerShell",!0)}async function*c(){let h=await m();h&&(yield h),h=await m({useAlternateBitness:!0}),h&&(yield h),h=await w(),h&&(yield h),h=k(),h&&(yield h),h=await m({findPreview:!0}),h&&(yield h),h=await w({findPreview:!0}),h&&(yield h),h=await m({useAlternateBitness:!0,findPreview:!0}),h&&(yield h),h=v(),h&&(yield h)}async function*p(){for await(const h of c())await h.exists()&&(yield h)}e.$Zl=p;async function $(){for await(const h of p())return h;return null}e.$1l=$}),define(ie[56],ne([0,1,16,12,35,55,3,24]),function(J,e,N,D,R,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$5l=e.$4l=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function u(E=R.env){return E.comspec||"cmd.exe"}e.$4l=u;function a(E){let d=[],m=!1;const w=function(k){if(m){d.push(k);return}(!E.send(k,c=>{if(c&&console.error(c),m=!1,d.length>0){const p=d.slice(0);d=[],p.forEach($=>w($))}})||D.$i)&&(m=!0)};return{send:w}}e.$5l=a;var y;(function(E){async function d(m,w,k){if(N.$ic(m))return m;if(w===void 0&&(w=R.cwd()),N.$mc(m)!=="."||(k===void 0&&A.$Sf(R.env.PATH)&&(k=R.env.PATH.split(N.$tc)),k===void 0||k.length===0))return N.$jc(w,m);async function c(p){if(await S.Promises.exists(p)){let $;try{$=await S.Promises.stat(p)}catch(h){h.message.startsWith("EACCES")&&($=await S.Promises.lstat(p))}return $?!$.isDirectory():!1}return!1}for(const p of k){let $;if(N.$ic(p)?$=N.$jc(p,m):$=N.$jc(w,p,m),await c($))return $;let h=$+".com";if(await c(h)||(h=$+".exe",await c(h)))return h}return N.$jc(w,m)}E.findExecutable=d})(y||(e.win32=y={}))}),define(ie[86],ne([0,1,33,12,85,56]),function(J,e,N,D,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6l=void 0;async function A(E,d){return E===1?D.$i?y():L.$4l(d):u(E,d)}e.$6l=A;let S=null;function u(E,d){if(D.$k&&E===2||D.$j&&E===3)return"/bin/bash";if(!S){let m;if(D.$i)m="/bin/bash";else{if(m=d.SHELL,!m)try{m=(0,N.userInfo)().shell}catch{}m||(m="sh"),m==="/bin/false"&&(m="/bin/bash")}S=m}return S}let a=null;async function y(){return a||(a=(await(0,R.$1l)()).exePath),a}});var me=this&&this.__decorate||function(J,e,N,D){var R=arguments.length,L=R<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,N):D,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(J,e,N,D);else for(var S=J.length-1;S>=0;S--)(A=J[S])&&(L=(R<3?A(L):R>3?A(e,N,L):A(e,N))||L);return R>3&&L&&Object.defineProperty(e,N,L),L};define(ie[57],ne([0,1,19,9,14,20,53,7,6,2,47,30,3]),function(J,e,N,D,R,L,A,S,u,a,y,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1h=e.ProxyChannel=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.RequestInitiator=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=void 0;var m;(function(T){T[T.Promise=100]="Promise",T[T.PromiseCancel=101]="PromiseCancel",T[T.EventListen=102]="EventListen",T[T.EventDispose=103]="EventDispose"})(m||(m={}));function w(T){switch(T){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var k;(function(T){T[T.Initialize=200]="Initialize",T[T.PromiseSuccess=201]="PromiseSuccess",T[T.PromiseError=202]="PromiseError",T[T.PromiseErrorObj=203]="PromiseErrorObj",T[T.EventFire=204]="EventFire"})(k||(k={}));function v(T){switch(T){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var c;(function(T){T[T.Uninitialized=0]="Uninitialized",T[T.Idle=1]="Idle"})(c||(c={}));function p(T){let M=0;for(let H=0;;H+=7){const Z=T.read(1);if(M|=(Z.buffer[0]&127)<<H,!(Z.buffer[0]&128))return M}}const $=t(0);function h(T,M){if(M===0){T.write($);return}let H=0;for(let Q=M;Q!==0;Q=Q>>>7)H++;const Z=R.$se.alloc(H);for(let Q=0;M!==0;Q++)Z.buffer[Q]=M&127,M=M>>>7,M>0&&(Z.buffer[Q]|=128);T.write(Z)}class g{constructor(M){this.b=M,this.a=0}read(M){const H=this.b.slice(this.a,this.a+M);return this.a+=H.byteLength,H}}e.$Ph=g;class i{constructor(){this.a=[]}get buffer(){return R.$se.concat(this.a)}write(M){this.a.push(M)}}e.$Qh=i;var r;(function(T){T[T.Undefined=0]="Undefined",T[T.String=1]="String",T[T.Buffer=2]="Buffer",T[T.VSBuffer=3]="VSBuffer",T[T.Array=4]="Array",T[T.Object=5]="Object",T[T.Int=6]="Int"})(r||(r={}));function t(T){const M=R.$se.alloc(1);return M.writeUInt8(T,0),M}const n={Undefined:t(r.Undefined),String:t(r.String),Buffer:t(r.Buffer),VSBuffer:t(r.VSBuffer),Array:t(r.Array),Object:t(r.Object),Uint:t(r.Int)},s=typeof Buffer<"u";function o(T,M){if(typeof M>"u")T.write(n.Undefined);else if(typeof M=="string"){const H=R.$se.fromString(M);T.write(n.String),h(T,H.byteLength),T.write(H)}else if(s&&Buffer.isBuffer(M)){const H=R.$se.wrap(M);T.write(n.Buffer),h(T,H.byteLength),T.write(H)}else if(M instanceof R.$se)T.write(n.VSBuffer),h(T,M.byteLength),T.write(M);else if(Array.isArray(M)){T.write(n.Array),h(T,M.length);for(const H of M)o(T,H)}else if(typeof M=="number"&&(M|0)===M)T.write(n.Uint),h(T,M);else{const H=R.$se.fromString(JSON.stringify(M));T.write(n.Object),h(T,H.byteLength),T.write(H)}}e.$Rh=o;function l(T){switch(T.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return T.read(p(T)).toString();case r.Buffer:return T.read(p(T)).buffer;case r.VSBuffer:return T.read(p(T));case r.Array:{const H=p(T),Z=[];for(let Q=0;Q<H;Q++)Z.push(l(T));return Z}case r.Object:return JSON.parse(T.read(p(T)).toString());case r.Int:return p(T)}}e.$Sh=l;class O{constructor(M,H,Z=null,Q=1e3){this.h=M,this.j=H,this.k=Z,this.l=Q,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(_=>this.q(_)),this.m({type:200})}registerChannel(M,H){this.b.set(M,H),setTimeout(()=>this.w(M),0)}m(M){switch(M.type){case 200:{const H=this.o([M.type]);this.k?.logOutgoing(H,0,1,v(M.type));return}case 201:case 202:case 204:case 203:{const H=this.o([M.type,M.id],M.data);this.k?.logOutgoing(H,M.id,1,v(M.type),M.data);return}}}o(M,H=void 0){const Z=new i;return o(Z,M),o(Z,H),this.p(Z.buffer)}p(M){try{return this.h.send(M),M.byteLength}catch{return 0}}q(M){const H=new g(M),Z=l(H),Q=l(H),_=Z[0];switch(_){case 100:return this.k?.logIncoming(M.byteLength,Z[1],1,`${w(_)}: ${Z[2]}.${Z[3]}`,Q),this.s({type:_,id:Z[1],channelName:Z[2],name:Z[3],arg:Q});case 102:return this.k?.logIncoming(M.byteLength,Z[1],1,`${w(_)}: ${Z[2]}.${Z[3]}`,Q),this.t({type:_,id:Z[1],channelName:Z[2],name:Z[3],arg:Q});case 101:return this.k?.logIncoming(M.byteLength,Z[1],1,`${w(_)}`),this.u({type:_,id:Z[1]});case 103:return this.k?.logIncoming(M.byteLength,Z[1],1,`${w(_)}`),this.u({type:_,id:Z[1]})}}s(M){const H=this.b.get(M.channelName);if(!H){this.v(M);return}const Z=new L.$ce;let Q;try{Q=H.call(this.j,M.name,M.arg,Z.token)}catch(F){Q=Promise.reject(F)}const _=M.id;Q.then(F=>{this.m({id:_,data:F,type:201})},F=>{F instanceof Error?this.m({id:_,data:{message:F.message,name:F.name,stack:F.stack?F.stack.split?F.stack.split(`
`):F.stack:void 0},type:202}):this.m({id:_,data:F,type:203})}).finally(()=>{U.dispose(),this.d.delete(M.id)});const U=(0,a.$Rc)(()=>Z.cancel());this.d.set(M.id,U)}t(M){const H=this.b.get(M.channelName);if(!H){this.v(M);return}const Z=M.id,_=H.listen(this.j,M.name,M.arg)(U=>this.m({id:Z,data:U,type:204}));this.d.set(M.id,_)}u(M){const H=this.d.get(M.id);H&&(H.dispose(),this.d.delete(M.id))}v(M){let H=this.g.get(M.channelName);H||(H=[],this.g.set(M.channelName,H));const Z=setTimeout(()=>{console.error(`Unknown channel: ${M.channelName}`),M.type===100&&this.m({id:M.id,data:{name:"Unknown channel",message:`Channel name '${M.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);H.push({request:M,timeoutTimer:Z})}w(M){const H=this.g.get(M);if(H){for(const Z of H)switch(clearTimeout(Z.timeoutTimer),Z.request.type){case 100:this.s(Z.request);break;case 102:this.t(Z.request);break}this.g.delete(M)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,a.$Oc)(this.d.values()),this.d.clear()}}e.$Th=O;var I;(function(T){T[T.LocalSide=0]="LocalSide",T[T.OtherSide=1]="OtherSide"})(I||(e.RequestInitiator=I={}));class b{constructor(M,H=null){this.l=M,this.a=!1,this.b=c.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new u.$5d,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Z=>this.s(Z)),this.j=H}getChannel(M){const H=this;return{call(Z,Q,_){return H.a?Promise.reject(new S.$5):H.m(M,Z,Q,_)},listen(Z,Q){return H.a?u.Event.None:H.o(M,Z,Q)}}}m(M,H,Z,Q=L.CancellationToken.None){const _=this.g++,F={id:_,type:100,channelName:M,name:H,arg:Z};if(Q.isCancellationRequested)return Promise.reject(new S.$5);let f;return new Promise((z,C)=>{if(Q.isCancellationRequested)return C(new S.$5);const W=()=>{const ue=$e=>{switch($e.type){case 201:this.f.delete(_),z($e.data);break;case 202:{this.f.delete(_);const we=new Error($e.data.message);we.stack=Array.isArray($e.data.stack)?$e.data.stack.join(`
`):$e.data.stack,we.name=$e.data.name,C(we);break}case 203:this.f.delete(_),C($e.data);break}};this.f.set(_,ue),this.p(F)};let G=null;this.b===c.Idle?W():(G=(0,D.$5g)(ue=>this.u()),G.then(()=>{G=null,W()}));const te=()=>{G?(G.cancel(),G=null):this.p({id:_,type:101}),C(new S.$5)},le=Q.onCancellationRequested(te);f=(0,a.$Qc)((0,a.$Rc)(te),le),this.d.add(f)}).finally(()=>{f.dispose(),this.d.delete(f)})}o(M,H,Z){const Q=this.g++,U={id:Q,type:102,channelName:M,name:H,arg:Z};let F=null;const f=new u.$5d({onWillAddFirstListener:()=>{F=(0,D.$5g)(z=>this.u()),F.then(()=>{F=null,this.d.add(f),this.p(U)})},onDidRemoveLastListener:()=>{F?(F.cancel(),F=null):(this.d.delete(f),this.p({id:Q,type:103}))}}),P=z=>f.fire(z.data);return this.f.set(Q,P),f.event}p(M){switch(M.type){case 100:case 102:{const H=this.q([M.type,M.id,M.channelName,M.name],M.arg);this.j?.logOutgoing(H,M.id,0,`${w(M.type)}: ${M.channelName}.${M.name}`,M.arg);return}case 101:case 103:{const H=this.q([M.type,M.id]);this.j?.logOutgoing(H,M.id,0,w(M.type));return}}}q(M,H=void 0){const Z=new i;return o(Z,M),o(Z,H),this.r(Z.buffer)}r(M){try{return this.l.send(M),M.byteLength}catch{return 0}}s(M){const H=new g(M),Z=l(H),Q=l(H),_=Z[0];switch(_){case 200:return this.j?.logIncoming(M.byteLength,0,0,v(_)),this.t({type:Z[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(M.byteLength,Z[1],0,v(_),Q),this.t({type:Z[0],id:Z[1],data:Q})}}t(M){if(M.type===200){this.b=c.Idle,this.k.fire();return}this.f.get(M.id)?.(M)}get onDidInitializePromise(){return u.Event.toPromise(this.onDidInitialize)}u(){return this.b===c.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,a.$Oc)(this.d.values()),this.d.clear()}}e.$Uh=b,me([A.$Jh],b.prototype,"onDidInitializePromise",null);class j{get connections(){const M=[];return this.f.forEach(H=>M.push(H)),M}constructor(M){this.a=new Map,this.f=new Set,this.g=new u.$5d,this.onDidAddConnection=this.g.event,this.h=new u.$5d,this.onDidRemoveConnection=this.h.event,this.j=new a.$Sc,this.j.add(M(({protocol:H,onDidClientDisconnect:Z})=>{const Q=u.Event.once(H.onMessage);this.j.add(Q(_=>{const U=new g(_),F=l(U),f=new O(H,F),P=new b(H);this.a.forEach((C,W)=>f.registerChannel(W,C));const z={channelServer:f,channelClient:P,ctx:F};this.f.add(z),this.g.fire(z),this.j.add(Z(()=>{f.dispose(),P.dispose(),this.f.delete(z),this.h.fire(z)}))}))}))}getChannel(M,H){const Z=this;return{call(Q,_,U){let F;if((0,d.$7f)(H)){const P=(0,N.$4b)(Z.connections.filter(H));F=P?Promise.resolve(P):u.Event.toPromise(u.Event.filter(Z.onDidAddConnection,H))}else F=H.routeCall(Z,Q,_);const f=F.then(P=>P.channelClient.getChannel(M));return Y(f).call(Q,_,U)},listen(Q,_){if((0,d.$7f)(H))return Z.k(M,H,Q,_);const U=H.routeEvent(Z,Q,_).then(F=>F.channelClient.getChannel(M));return Y(U).listen(Q,_)}}}k(M,H,Z,Q){const _=this;let U;const F=new u.$5d({onWillAddFirstListener:()=>{U=new a.$Sc;const f=new u.$$d,P=new Map,z=W=>{const te=W.channelClient.getChannel(M).listen(Z,Q),le=f.add(te);P.set(W,le)},C=W=>{const G=P.get(W);G&&(G.dispose(),P.delete(W))};_.connections.filter(H).forEach(z),u.Event.filter(_.onDidAddConnection,H)(z,void 0,U),_.onDidRemoveConnection(C,void 0,U),f.event(F.fire,F,U),U.add(f)},onDidRemoveLastListener:()=>{U?.dispose(),U=void 0}});return F.event}registerChannel(M,H){this.a.set(M,H);for(const Z of this.f)Z.channelServer.registerChannel(M,H)}dispose(){this.j.dispose();for(const M of this.f)M.channelClient.dispose(),M.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Vh=j;class q{constructor(M,H,Z=null){const Q=new i;o(Q,H),M.send(Q.buffer),this.a=new b(M,Z),this.d=new O(M,H,Z)}getChannel(M){return this.a.getChannel(M)}registerChannel(M,H){this.d.registerChannel(M,H)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Wh=q;function Y(T){return{call(M,H,Z){return T.then(Q=>Q.call(M,H,Z))},listen(M,H){const Z=new u.$be;return T.then(Q=>Z.input=Q.listen(M,H)),Z.event}}}e.$Xh=Y;function K(T){let M=!1;return{call(H,Z,Q){return M?T.call(H,Z,Q):(0,D.$gh)(0).then(()=>M=!0).then(()=>T.call(H,Z,Q))},listen(H,Z){if(M)return T.listen(H,Z);const Q=new u.$be;return(0,D.$gh)(0).then(()=>M=!0).then(()=>Q.input=T.listen(H,Z)),Q.event}}}e.$Yh=K;class oe{constructor(M){this.a=M}routeCall(M){return this.b(M)}routeEvent(M){return this.b(M)}async b(M){for(const H of M.connections)if(await Promise.resolve(this.a(H.ctx)))return Promise.resolve(H);return await u.Event.toPromise(M.onDidAddConnection),await this.b(M)}}e.$Zh=oe;var re;(function(T){function M(_,U,F){const f=_,P=F&&F.disableMarshalling,z=new Map;for(const C in f)Z(C)&&z.set(C,u.Event.buffer(f[C],!0,void 0,U));return new class{listen(C,W,G){const te=z.get(W);if(te)return te;const le=f[W];if(typeof le=="function"){if(Q(W))return le.call(f,G);if(Z(W))return z.set(W,u.Event.buffer(f[W],!0,void 0,U)),z.get(W)}throw new S.$bb(`Event not found: ${W}`)}call(C,W,G){const te=f[W];if(typeof te=="function"){if(!P&&Array.isArray(G))for(let ue=0;ue<G.length;ue++)G[ue]=(0,y.$Oh)(G[ue]);let le=te.apply(f,G);return le instanceof Promise||(le=Promise.resolve(le)),le}throw new S.$bb(`Method not found: ${W}`)}}}T.fromService=M;function H(_,U){const F=U&&U.disableMarshalling;return new Proxy({},{get(f,P){if(typeof P=="string")return U?.properties?.has(P)?U.properties.get(P):Q(P)?function(z){return _.listen(P,z)}:Z(P)?_.listen(P):async function(...z){let C;U&&!(0,d.$2f)(U.context)?C=[U.context,...z]:C=z;const W=await _.call(P,C);return F?W:(0,y.$Oh)(W)};throw new S.$bb(`Property not found: ${String(P)}`)}})}T.toService=H;function Z(_){return _[0]==="o"&&_[1]==="n"&&E.$if(_.charCodeAt(2))}function Q(_){return/^onDynamic/.test(_)&&E.$if(_.charCodeAt(9))}})(re||(e.ProxyChannel=re={}));const he=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function de(T){if(Array.isArray(T))return T;if(T&&typeof T=="object"&&typeof T.toString=="function"){const M=T.toString();if(M!=="[object Object]")return M}return T}function ae(T){return Array.isArray(T)?T.map(de):de(T)}function B(T,M,H,Z,Q,_,U){U=ae(U);const F=he[Q],f=F[Z%F.length];let P=[`%c[${T}]%c[${String(M).padStart(7," ")}]%c[len: ${String(H).padStart(5," ")}]%c${String(Z).padStart(5," ")} - ${_}`,"color: darkgreen","color: grey","color: grey",`color: ${f}`];/\($/.test(_)?(P=P.concat(U),P.push(")")):P.push(U),console.log.apply(console,P)}class X{constructor(M,H){this.d=M,this.f=H,this.a=0,this.b=0}logOutgoing(M,H,Z,Q,_){this.b+=M,B(this.d,this.b,M,H,Z,Q,_)}logIncoming(M,H,Z,Q,_){this.a+=M,B(this.f,this.a,M,H,Z,Q,_)}}e.$1h=X}),define(ie[87],ne([0,1,58,9,14,20,82,7,6,2,27,56,55,57]),function(J,e,N,D,R,L,A,S,u,a,y,E,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=e.$Eq=void 0;class w extends m.$Th{constructor(c){super({send:p=>{try{process.send?.(p.buffer.toString("base64"))}catch{}},onMessage:u.Event.fromNodeEventEmitter(process,"message",p=>R.$se.wrap(Buffer.from(p,"base64")))},c),process.once("disconnect",()=>this.dispose())}}e.$Eq=w;class k{constructor(c,p){this.i=c,this.j=p,this.c=new Set,this.g=new Map,this.h=new u.$5d,this.onDidProcessExit=this.h.event;const $=p&&p.timeout?p.timeout:6e4;this.b=new D.$ch($),this.d=null,this.f=null}getChannel(c){const p=this;return{call($,h,g){return p.k(c,$,h,g)},listen($,h){return p.l(c,$,h)}}}k(c,p,$,h=L.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(h.isCancellationRequested)return Promise.reject(S.$6());this.b.cancel();const g=this.n(c),i=(0,D.$5g)(n=>g.call(p,$,n)),r=h.onCancellationRequested(()=>i.cancel()),t=(0,a.$Rc)(()=>i.cancel());return this.c.add(t),i.finally(()=>{r.dispose(),this.c.delete(t),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(c,p,$){if(!this.b)return u.Event.None;this.b.cancel();let h;const g=new u.$5d({onWillAddFirstListener:()=>{h=this.n(c).listen(p,$)(g.fire,g),this.c.add(h)},onDidRemoveLastListener:()=>{this.c.delete(h),h.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return g.event}get m(){if(!this.f){const c=this.j&&this.j.args?this.j.args:[],p=Object.create(null);p.env={...(0,y.$Kn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(p.env={...p.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(p.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(p.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(p.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),p.execArgv===void 0&&(p.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s)).filter(s=>!s.startsWith("--vscode-"))),(0,d.$3l)(p.env),this.d=(0,N.fork)(this.i,c,p);const $=new u.$5d;u.Event.fromNodeEventEmitter(this.d,"message",s=>s)(s=>{if((0,A.$Aq)(s)){(0,A.log)(s,`IPC Library: ${this.j.serverName}`);return}$.fire(R.$se.wrap(Buffer.from(s,"base64")))});const g=this.j.useQueue?(0,E.$5l)(this.d):this.d,i=s=>this.d&&this.d.connected&&g.send(s.buffer.toString("base64")),r=$.event,t={send:i,onMessage:r};this.f=new m.$Uh(t);const n=()=>this.o();process.once("exit",n),this.d.on("error",s=>console.warn('IPC "'+this.j.serverName+'" errored with '+s)),this.d.on("exit",(s,o)=>{process.removeListener("exit",n),this.c.forEach(l=>(0,a.$Oc)(l)),this.c.clear(),s!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+s+" and signal "+o),this.b?.cancel(),this.o(),this.h.fire({code:s,signal:o})})}return this.f}n(c){let p=this.g.get(c);return p||(p=this.m.getChannel(c),this.g.set(c,p)),p}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Fq=k}),define(ie[88],ne([0,1,9,6,2,47,3]),function(J,e,N,D,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fp=e.$Ep=e.StorageState=e.$Dp=e.StorageHint=void 0;var S;(function(d){d[d.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",d[d.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(S||(e.StorageHint=S={}));function u(d){const m=d;return m?.changed instanceof Map||m?.deleted instanceof Set}e.$Dp=u;var a;(function(d){d[d.None=0]="None",d[d.Initialized=1]="Initialized",d[d.Closed=2]="Closed"})(a||(e.StorageState=a={}));class y extends R.$Tc{static{this.a=100}constructor(m,w=Object.create(null)){super(),this.r=m,this.s=w,this.b=this.B(new D.$8d),this.onDidChangeStorage=this.b.event,this.c=a.None,this.f=new Map,this.g=this.B(new N.$dh(y.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(m=>this.u(m)))}u(m){this.b.pause();try{m.changed?.forEach((w,k)=>this.w(k,w)),m.deleted?.forEach(w=>this.w(w,void 0))}finally{this.b.resume()}}w(m,w){if(this.c===a.Closed)return;let k=!1;(0,A.$2f)(w)?k=this.f.delete(m):this.f.get(m)!==w&&(this.f.set(m,w),k=!0),k&&this.b.fire({key:m,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===a.None&&(this.c=a.Initialized,this.s.hint!==S.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(m,w){const k=this.f.get(m);return(0,A.$2f)(k)?w:k}getBoolean(m,w){const k=this.get(m);return(0,A.$2f)(k)?w:k==="true"}getNumber(m,w){const k=this.get(m);return(0,A.$2f)(k)?w:parseInt(k,10)}getObject(m,w){const k=this.get(m);return(0,A.$2f)(k)?w:(0,L.$Nh)(k)}async set(m,w,k=!1){if(this.c===a.Closed)return;if((0,A.$2f)(w))return this.delete(m,k);const v=(0,A.$Uf)(w)||Array.isArray(w)?(0,L.$Mh)(w):String(w);if(this.f.get(m)!==v)return this.f.set(m,v),this.j.set(m,v),this.h.delete(m),this.b.fire({key:m,external:k}),this.D()}async delete(m,w=!1){if(!(this.c===a.Closed||!this.f.delete(m)))return this.h.has(m)||this.h.add(m),this.j.delete(m),this.b.fire({key:m,external:w}),this.D()}async optimize(){if(this.c!==a.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=a.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const m={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(m).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(m){if(this.z)return this.D(m)}async D(m){return this.s.hint===S.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),m)}async whenFlushed(){if(this.z)return new Promise(m=>this.n.push(m))}isInMemory(){return this.s.hint===S.STORAGE_IN_MEMORY}}e.$Ep=y;class E{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(m){m.insert?.forEach((w,k)=>this.a.set(k,w)),m.delete?.forEach(w=>this.a.delete(w))}async optimize(){}async close(){}}e.$Fp=E}),define(ie[89],ne([8,5]),function(J,e){return J.create("vs/base/node/zip",e)}),define(ie[49],ne([0,1,90,9,16,3,24,89]),function(J,e,N,D,R,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=e.$3p=e.zip=e.$1p=e.$Zp=void 0,e.$Zp="end of central directory record signature not found";const u=new RegExp(e.$Zp);class a extends Error{constructor(g,i){let r=i.message;switch(g){case"CorruptZip":r=`Corrupt ZIP: ${r}`;break}super(r),this.type=g,this.cause=i}}e.$1p=a;function y(h){const g=h.externalFileAttributes>>16||33188;return[448,56,7].map(i=>g&i).reduce((i,r)=>i+r,g&61440)}function E(h){if(h instanceof a)return h;let g;return u.test(h.message)&&(g="CorruptZip"),new a(g,h)}function d(h,g,i,r,t,n){const s=R.$mc(g),o=R.$jc(r,s);if(!o.startsWith(r))return Promise.reject(new Error(S.localize(0,null,g)));const l=R.$jc(r,g);let O;return n.onCancellationRequested(()=>{O?.destroy()}),Promise.resolve(A.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((I,b)=>{if(!n.isCancellationRequested)try{O=(0,N.createWriteStream)(l,{mode:i}),O.once("close",()=>I()),O.once("error",b),h.once("error",b),h.pipe(O)}catch(j){b(j)}}))}function m(h,g,i,r){let t=(0,D.$5g)(()=>Promise.resolve()),n=0;const s=r.onCancellationRequested(()=>{t.cancel(),h.close()});return new Promise((o,l)=>{const O=new D.$ah,I=b=>{b.isCancellationRequested||(n++,h.readEntry())};h.once("error",l),h.once("close",()=>t.then(()=>{r.isCancellationRequested||h.entryCount===n?o():l(new a("Incomplete",new Error(S.localize(1,null,n,h.entryCount))))},l)),h.readEntry(),h.on("entry",b=>{if(r.isCancellationRequested)return;if(!i.sourcePathRegex.test(b.fileName)){I(r);return}const j=b.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(j)){const K=R.$jc(g,j);t=(0,D.$5g)(oe=>A.Promises.mkdir(K,{recursive:!0}).then(()=>I(oe)).then(void 0,l));return}const q=k(h,b),Y=y(b);t=(0,D.$5g)(K=>O.queue(()=>q.then(oe=>d(oe,j,Y,g,i,K).then(()=>I(K)))).then(null,l))})}).finally(()=>s.dispose())}async function w(h,g=!1){const{open:i}=await new Promise((r,t)=>{J(["yauzl"],r,t)});return new Promise((r,t)=>{i(h,g?{lazyEntries:!0}:void 0,(n,s)=>{n?t(E(n)):r((0,L.$4f)(s))})})}function k(h,g){return new Promise((i,r)=>{h.openReadStream(g,(t,n)=>{t?r(E(t)):i((0,L.$4f)(n))})})}async function v(h,g){const{ZipFile:i}=await new Promise((r,t)=>{J(["yazl"],r,t)});return new Promise((r,t)=>{const n=new i;g.forEach(o=>{o.contents?n.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&n.addFile(o.localPath,o.path)}),n.end();const s=(0,N.createWriteStream)(h);n.outputStream.pipe(s),n.outputStream.once("error",t),s.once("error",t),s.once("finish",()=>r(h))})}e.zip=v;function c(h,g,i={},r){const t=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let n=w(h,!0);return i.overwrite&&(n=n.then(s=>A.Promises.rm(g).then(()=>s))),n.then(s=>m(s,g,{sourcePathRegex:t},r))}e.$3p=c;function p(h,g){return w(h).then(i=>new Promise((r,t)=>{i.on("entry",n=>{n.fileName===g&&k(i,n).then(s=>r(s),s=>t(s))}),i.once("close",()=>t(new Error(S.localize(2,null,g))))}))}function $(h,g){return p(h,g).then(i=>new Promise((r,t)=>{const n=[];i.once("error",t),i.on("data",s=>n.push(s)),i.on("end",()=>r(Buffer.concat(n)))}))}e.$4p=$}),define(ie[91],ne([8,5]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ie[92],ne([8,5]),function(J,e){return J.create("vs/platform/contextkey/common/contextkey",e)}),define(ie[93],ne([8,5]),function(J,e){return J.create("vs/platform/contextkey/common/scanner",e)}),define(ie[94],ne([8,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ie[95],ne([8,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ie[96],ne([8,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(ie[97],ne([8,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ie[98],ne([8,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ie[99],ne([8,5]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ie[100],ne([8,5]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ie[101],ne([8,5]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(ie[102],ne([8,5]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(ie[103],ne([8,5]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(ie[104],ne([8,5]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ie[105],ne([8,5]),function(J,e){return J.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ie[106],ne([8,5]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(ie[107],ne([8,5]),function(J,e){return J.create("vs/platform/shell/node/shellEnv",e)}),define(ie[108],ne([8,5]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(ie[109],ne([8,5]),function(J,e){return J.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ie[110],ne([8,5]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(ie[111],ne([0,1,7,93]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aj=e.TokenType=void 0;var R;(function(a){a[a.LParen=0]="LParen",a[a.RParen=1]="RParen",a[a.Neg=2]="Neg",a[a.Eq=3]="Eq",a[a.NotEq=4]="NotEq",a[a.Lt=5]="Lt",a[a.LtEq=6]="LtEq",a[a.Gt=7]="Gt",a[a.GtEq=8]="GtEq",a[a.RegexOp=9]="RegexOp",a[a.RegexStr=10]="RegexStr",a[a.True=11]="True",a[a.False=12]="False",a[a.In=13]="In",a[a.Not=14]="Not",a[a.And=15]="And",a[a.Or=16]="Or",a[a.Str=17]="Str",a[a.QuotedStr=18]="QuotedStr",a[a.Error=19]="Error",a[a.EOF=20]="EOF"})(R||(e.TokenType=R={}));function L(...a){switch(a.length){case 1:return(0,D.localize)(0,null,a[0]);case 2:return(0,D.localize)(1,null,a[0],a[1]);case 3:return(0,D.localize)(2,null,a[0],a[1],a[2]);default:return}}const A=(0,D.localize)(3,null),S=(0,D.localize)(4,null);class u{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(y){switch(y.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return y.isTripleEq?"===":"==";case 4:return y.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return y.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return y.lexeme;case 18:return y.lexeme;case 19:return y.lexeme;case 20:return"EOF";default:throw(0,N.$8)(`unhandled token type: ${JSON.stringify(y)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(y=>y.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(y){return this.c=y,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const E=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:E})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const E=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:E})}else this.h(126)?this.k(9):this.l(L("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(L("&&"));break;case 124:this.h(124)?this.k(16):this.l(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(y){return this.r()||this.c.charCodeAt(this.e)!==y?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(y){this.f.push({type:y,offset:this.d})}l(y){const E=this.d,d=this.c.substring(this.d,this.e),m={type:19,offset:this.d,lexeme:d};this.g.push({offset:E,lexeme:d,additionalInfo:y}),this.f.push(m)}n(){this.m.lastIndex=this.d;const y=this.m.exec(this.c);if(y){this.e=this.d+y[0].length;const E=this.c.substring(this.d,this.e),d=u.b.get(E);d?this.k(d):this.f.push({type:17,lexeme:E,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let y=this.e,E=!1,d=!1;for(;;){if(y>=this.c.length){this.e=y,this.l(S);return}const w=this.c.charCodeAt(y);if(E)E=!1;else if(w===47&&!d){y++;break}else w===91?d=!0:w===92?E=!0:w===93&&(d=!1);y++}for(;y<this.c.length&&u.a.has(this.c.charCodeAt(y));)y++;this.e=y;const m=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:m,offset:this.d})}r(){return this.e>=this.c.length}}e.$aj=u}),define(ie[112],ne([0,1,78,53,15,16,35,17,11]),function(J,e,N,D,R,L,A,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=e.$Om=e.$Nm=e.$Mm=void 0,e.$Mm=/^([^.]+\..+)[:=](.+)$/;class a{get appRoot(){return(0,L.$mc)(R.$zg.asFileUri("").fsPath)}get userHome(){return u.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return u.URI.file((0,L.$jc)(this.userDataPath,"User"))}get tmpDir(){return u.URI.file(this.b.tmpDir)}get cacheHome(){return u.URI.file(this.userDataPath)}get stateResource(){return(0,S.$Sg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:R.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,S.$Sg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const m=(0,N.$Lm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.$jc)(this.userDataPath,"logs",m)}return u.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,S.$Sg)(u.URI.file((0,L.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,S.$Sg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,S.$Sg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,S.$Sg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const m=A.env.VSCODE_PORTABLE;return m?u.URI.file((0,L.$jc)(m,"argv.json")):(0,S.$Sg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return u.URI.file((0,L.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const m=this.args["builtin-extensions-dir"];return m?(0,L.$kc)(m):(0,L.$hc)((0,L.$jc)(R.$zg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const m=this.args["extensions-download-dir"];return m?u.URI.file((0,L.$kc)(m)):u.URI.file((0,L.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const m=this.args["extensions-dir"];if(m)return(0,L.$kc)(m);const w=A.env.VSCODE_EXTENSIONS;if(w)return w;const k=A.env.VSCODE_PORTABLE;return k?(0,L.$jc)(k,"extensions"):(0,S.$Sg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const m=this.args.extensionDevelopmentPath;if(Array.isArray(m))return m.map(w=>/^[^:/?#]+?:\/\//.test(w)?u.URI.parse(w):u.URI.file((0,L.$hc)(w)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(m=>m==="ui"||m==="workspace"||m==="web"?m:"workspace")}get extensionTestsLocationURI(){const m=this.args.extensionTestsPath;if(m)return/^[^:/?#]+?:\/\//.test(m)?u.URI.parse(m):u.URI.file((0,L.$hc)(m))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const m=this.args["disable-extension"];if(m){if(typeof m=="string")return[m];if(Array.isArray(m)&&m.length>0)return m}return!1}get debugExtensionHost(){return y(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(m=>!e.$Mm.test(m))}get extensionLogLevel(){const m=[];for(const w of this.args.log||[]){const k=e.$Mm.exec(w);k&&k[1]&&k[2]&&m.push([k[1],k[2]])}return m.length?m:void 0}get serviceMachineIdResource(){return(0,S.$Sg)(u.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const m=A.env.VSCODE_PORTABLE;return m?u.URI.file((0,L.$jc)(m,"policy.json")):(0,S.$Sg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(m){this.args.continueOn=m}get args(){return this.a}constructor(m,w,k){this.a=m,this.b=w,this.c=k,this.editSessionId=this.args.editSessionId}}e.$Nm=a,me([D.$Jh],a.prototype,"appRoot",null),me([D.$Jh],a.prototype,"userHome",null),me([D.$Jh],a.prototype,"userDataPath",null),me([D.$Jh],a.prototype,"appSettingsHome",null),me([D.$Jh],a.prototype,"tmpDir",null),me([D.$Jh],a.prototype,"cacheHome",null),me([D.$Jh],a.prototype,"stateResource",null),me([D.$Jh],a.prototype,"userRoamingDataHome",null),me([D.$Jh],a.prototype,"userDataSyncHome",null),me([D.$Jh],a.prototype,"sync",null),me([D.$Jh],a.prototype,"machineSettingsResource",null),me([D.$Jh],a.prototype,"workspaceStorageHome",null),me([D.$Jh],a.prototype,"localHistoryHome",null),me([D.$Jh],a.prototype,"keyboardLayoutResource",null),me([D.$Jh],a.prototype,"argvResource",null),me([D.$Jh],a.prototype,"isExtensionDevelopment",null),me([D.$Jh],a.prototype,"untitledWorkspacesHome",null),me([D.$Jh],a.prototype,"builtinExtensionsPath",null),me([D.$Jh],a.prototype,"extensionsPath",null),me([D.$Jh],a.prototype,"extensionDevelopmentLocationURI",null),me([D.$Jh],a.prototype,"extensionDevelopmentKind",null),me([D.$Jh],a.prototype,"extensionTestsLocationURI",null),me([D.$Jh],a.prototype,"debugExtensionHost",null),me([D.$Jh],a.prototype,"logLevel",null),me([D.$Jh],a.prototype,"extensionLogLevel",null),me([D.$Jh],a.prototype,"serviceMachineIdResource",null),me([D.$Jh],a.prototype,"disableTelemetry",null),me([D.$Jh],a.prototype,"disableWorkspaceTrust",null),me([D.$Jh],a.prototype,"useInMemorySecretStorage",null),me([D.$Jh],a.prototype,"policyFile",null);function y(d,m){return E(d["inspect-extensions"],d["inspect-brk-extensions"],5870,m,d.debugId,d.extensionEnvironment)}e.$Om=y;function E(d,m,w,k,v,c){const $=Number(m||d)||(k?null:w),h=$?!!m:!1;let g;if(c)try{g=JSON.parse(c)}catch{}return{port:$,break:h,debugId:v,env:g}}e.$Pm=E}),function(){"use strict";function J(e,N,D){function R(A,S){const u=L(A,S),a=[u];return e.isAbsolute(u)||a.unshift(D),e.resolve(...a)}function L(A,S){process.env.VSCODE_DEV&&(S="code-oss-dev");const u=process.env.VSCODE_PORTABLE;if(u)return e.join(u,"user-data");let a=process.env.VSCODE_APPDATA;if(a)return e.join(a,S);const y=A["user-data-dir"];if(y)return y;switch(process.platform){case"win32":if(a=process.env.APPDATA,!a){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");a=e.join(E,"AppData","Roaming")}break;case"darwin":a=e.join(N.homedir(),"Library","Application Support");break;case"linux":a=process.env.XDG_CONFIG_HOME||e.join(N.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(a,S)}return{getUserDataPath:R}}if(typeof define=="function")define(ie[113],ne([167,33,35]),function(e,N,D){return J(e,N,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),N=require("os");module.exports=J(e,N,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ie[114],ne([0,1,33,112,113]),function(J,e,N,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=e.$Rm=e.$Qm=void 0;class L extends D.$Nm{constructor(a,y){super(a,{homeDir:(0,N.homedir)(),tmpDir:(0,N.tmpdir)(),userDataDir:(0,R.getUserDataPath)(a,y.nameShort)},y)}}e.$Qm=L;function A(u,a){return(0,D.$Pm)(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,a,u.extensionEnvironment)}e.$Rm=A;function S(u,a){return(0,D.$Pm)(u["inspect-sharedprocess"],u["inspect-brk-sharedprocess"],5879,a,u.extensionEnvironment)}e.$Sm=S}),define(ie[115],ne([0,1,3,97]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=void 0;function R(A,S,u,a){try{L(A,S,u,a)}catch(y){A.error(y?.message??y)}return S}e.$aq=R;function L(A,S,u,a){const y=(E,d,m)=>{const w=E[d];if((0,N.$Sf)(w)){const k=w,v=k.length;if(v>1&&k[0]==="%"&&k[v-1]==="%"){const c=k.substr(1,v-2);let p=u[c];p===void 0&&a&&(p=a[c]);const $=typeof p=="string"?p:p?.message,h=a?.[c],g=typeof h=="string"?h:h?.message;if(!$){g||A.warn(`[${S.name}]: ${(0,D.localize)(0,null,c)}`);return}if(m&&(d==="title"||d==="category")&&g&&g!==$){const i={value:$,original:g};E[d]=i}else E[d]=$}}else if((0,N.$Uf)(w))for(const k in w)w.hasOwnProperty(k)&&(k==="commands"?y(w,k,!0):y(w,k,m));else if(Array.isArray(w))for(let k=0;k<w.length;k++)y(w,k,m)};for(const E in S)S.hasOwnProperty(E)&&y(S,E)}}),define(ie[116],ne([0,1,49,100]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=void 0;function R(L){return(0,N.$4p)(L,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch{throw new Error((0,D.localize)(0,null))}})}e.$iq=R}),define(ie[50],ne([0,1,17,54,101,44]),function(J,e,N,D,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$up=e.$tp=e.$sp=e.$rp=e.$qp=e.$pp=e.$op=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function u(c){return c=c.trim(),c==="*"||A.test(c)}e.$op=u;function a(c){if(!u(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const p=c.match(A);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.$pp=a;function y(c){if(!c)return null;const p=c.majorBase,$=c.majorMustEqual,h=c.minorBase;let g=c.minorMustEqual;const i=c.patchBase;let r=c.patchMustEqual;c.hasCaret&&(p===0||(g=!1),r=!1);let t=0;if(c.preRelease){const n=S.exec(c.preRelease);if(n){const[,s,o,l]=n;t=Date.UTC(Number(s),Number(o)-1,Number(l))}}return{majorBase:p,majorMustEqual:$,minorBase:h,minorMustEqual:g,patchBase:i,patchMustEqual:r,isMinimum:c.hasGreaterEquals,notBefore:t}}e.$qp=y;function E(c,p,$){let h;typeof c=="string"?h=y(a(c)):h=c;let g;p instanceof Date?g=p.getTime():typeof p=="string"&&(g=new Date(p).getTime());let i;if(typeof $=="string"?i=y(a($)):i=$,!h||!i)return!1;const r=h.majorBase,t=h.minorBase,n=h.patchBase;let s=i.majorBase,o=i.minorBase,l=i.patchBase;const O=i.notBefore;let I=i.majorMustEqual,b=i.minorMustEqual,j=i.patchMustEqual;return i.isMinimum?r>s?!0:r<s?!1:t>o?!0:t<o||g&&g<O?!1:n>=l:(r===1&&s===0&&(!I||!b||!j)&&(s=1,o=0,l=0,I=!0,b=!1,j=!1),r<s?!1:r>s?!I:t<o?!1:t>o?!b:n<l?!1:n>l?!j:!(g&&g<O))}e.$rp=E;function d(c,p,$,h,g){const i=[];if(typeof h.publisher<"u"&&typeof h.publisher!="string")return i.push([D.default.Error,R.localize(0,null)]),i;if(typeof h.name!="string")return i.push([D.default.Error,R.localize(1,null,"name")]),i;if(typeof h.version!="string")return i.push([D.default.Error,R.localize(2,null,"version")]),i;if(!h.engines)return i.push([D.default.Error,R.localize(3,null,"engines")]),i;if(typeof h.engines.vscode!="string")return i.push([D.default.Error,R.localize(4,null,"engines.vscode")]),i;if(typeof h.extensionDependencies<"u"&&!v(h.extensionDependencies))return i.push([D.default.Error,R.localize(5,null,"extensionDependencies")]),i;if(typeof h.activationEvents<"u"){if(!v(h.activationEvents))return i.push([D.default.Error,R.localize(6,null,"activationEvents")]),i;if(typeof h.main>"u"&&typeof h.browser>"u")return i.push([D.default.Error,R.localize(7,null,"activationEvents","main","browser")]),i}if(typeof h.extensionKind<"u"&&typeof h.main>"u"&&i.push([D.default.Warning,R.localize(8,null,"extensionKind")]),typeof h.main<"u"){if(typeof h.main!="string")return i.push([D.default.Error,R.localize(9,null,"main")]),i;{const n=(0,N.$Sg)($,h.main);(0,N.$Mg)(n,$)||i.push([D.default.Warning,R.localize(10,null,n.path,$.path)])}}if(typeof h.browser<"u"){if(typeof h.browser!="string")return i.push([D.default.Error,R.localize(11,null,"browser")]),i;{const n=(0,N.$Sg)($,h.browser);(0,N.$Mg)(n,$)||i.push([D.default.Warning,R.localize(12,null,n.path,$.path)])}}if(!L.valid(h.version))return i.push([D.default.Error,R.localize(13,null)]),i;const r=[];if(!m(c,p,h,g,r))for(const n of r)i.push([D.default.Error,n]);return i}e.$sp=d;function m(c,p,$,h,g){return h||typeof $.main>"u"&&typeof $.browser>"u"?!0:k(c,p,$.engines.vscode,g)}e.$tp=m;function w(c,p,$){return c==="*"||k(p,$,c)}e.$up=w;function k(c,p,$,h=[]){const g=y(a($));if(!g)return h.push(R.localize(14,null,$)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return h.push(R.localize(15,null,$)),!1}else if(!g.majorMustEqual)return h.push(R.localize(16,null,$)),!1;return E(c,p,g)?!0:(h.push(R.localize(17,null,c,$)),!1)}function v(c){if(!Array.isArray(c))return!1;for(let p=0,$=c.length;p<$;p++)if(typeof c[p]!="string")return!1;return!0}}),define(ie[117],ne([0,1,14,28]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=void 0;async function R(L,A,S){let u=S&&S.get("storage.serviceMachineId",-1)||null;if(u)return u;try{const y=(await A.readFile(L.serviceMachineIdResource)).value.toString();u=(0,D.$Ag)(y)?y:null}catch{u=null}if(!u){u=(0,D.$Bg)();try{await A.writeFile(L.serviceMachineIdResource,N.$se.fromString(u))}catch{}}return S?.store("storage.serviceMachineId",u,-1,1),u}e.$Op=R}),define(ie[51],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ci=void 0;class N{constructor(R,L=[],A=!1){this.ctor=R,this.staticArguments=L,this.supportsDelayedInstantiation=A}}e.$ci=N}),define(ie[118],ne([0,1,51]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bs=e.$as=e.InstantiationType=void 0;const D=[];var R;(function(S){S[S.Eager=0]="Eager",S[S.Delayed=1]="Delayed"})(R||(e.InstantiationType=R={}));function L(S,u,a){u instanceof N.$ci||(u=new N.$ci(u,[],!!a)),D.push([S,u])}e.$as=L;function A(){return D}e.$bs=A}),define(ie[119],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=e.$Qq=void 0;class N{constructor(L,A){this.key=L,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$Qq=N;class D{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const A of this.a.values())A.outgoing.size===0&&L.push(A);return L}insertEdge(L,A){const S=this.lookupOrInsertNode(L),u=this.lookupOrInsertNode(A);S.outgoing.set(u.key,u),u.incoming.set(S.key,S)}removeNode(L){const A=this.b(L);this.a.delete(A);for(const S of this.a.values())S.outgoing.delete(A),S.incoming.delete(A)}lookupOrInsertNode(L){const A=this.b(L);let S=this.a.get(A);return S||(S=new N(A,L),this.a.set(A,S)),S}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[A,S]of this.a)L.push(`${A}
	(-> incoming)[${[...S.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...S.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,A]of this.a){const S=new Set([L]),u=this.c(A,S);if(u)return u}}c(L,A){for(const[S,u]of L.outgoing){if(A.has(S))return[...A,S].join(" -> ");A.add(S);const a=this.c(u,A);if(a)return a;A.delete(S)}}}e.$Rq=D}),define(ie[29],ne([0,1,3,11,10]),function(J,e,N,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.ConfigurationTarget=e.$Ni=e.$Mi=e.$Li=void 0,e.$Li=(0,R.$fi)("configurationService");function L(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof D.URI)}e.$Mi=L;function A(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof D.URI)}e.$Ni=A;var S;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(S||(e.ConfigurationTarget=S={}));function u(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Oi=u;function a(c){return c.applicationValue!==void 0||c.userValue!==void 0||c.userLocalValue!==void 0||c.userRemoteValue!==void 0||c.workspaceValue!==void 0||c.workspaceFolderValue!==void 0}e.$Pi=a;function y(c,p){const $=Object.create(null);for(const h in c)E($,h,c[h],p);return $}e.$Qi=y;function E(c,p,$,h){const g=p.split("."),i=g.pop();let r=c;for(let t=0;t<g.length;t++){const n=g[t];let s=r[n];switch(typeof s){case"undefined":s=r[n]=Object.create(null);break;case"object":break;default:h(`Ignoring ${p} as ${g.slice(0,t+1).join(".")} is ${JSON.stringify(s)}`);return}r=s}if(typeof r=="object"&&r!==null)try{r[i]=$}catch{h(`Ignoring ${p} as ${g.join(".")} is ${JSON.stringify(r)}`)}else h(`Ignoring ${p} as ${g.join(".")} is ${JSON.stringify(r)}`)}e.$Ri=E;function d(c,p){const $=p.split(".");m(c,$)}e.$Si=d;function m(c,p){const $=p.shift();if(p.length===0){delete c[$];return}if(Object.keys(c).indexOf($)!==-1){const h=c[$];typeof h=="object"&&!Array.isArray(h)&&(m(h,p),Object.keys(h).length===0&&delete c[$])}}function w(c,p,$){function h(r,t){let n=r;for(const s of t){if(typeof n!="object"||n===null)return;n=n[s]}return n}const g=p.split("."),i=h(c,g);return typeof i>"u"?$:i}e.$Ti=w;function k(c,p,$){Object.keys(p).forEach(h=>{h!=="__proto__"&&(h in c?N.$Uf(c[h])&&N.$Uf(p[h])?k(c[h],p[h],$):$&&(c[h]=p[h]):c[h]=p[h])})}e.$Ui=k;function v(c){return c.replace(/[\[\]]/g,"")}e.$Vi=v}),define(ie[120],ne([0,1,12,30,111,10,92,7]),function(J,e,N,D,R,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.ContextKeyExprType=e.$bj=void 0;const u=new Map;u.set("false",!1),u.set("true",!0),u.set("isMac",N.$j),u.set("isLinux",N.$k),u.set("isWindows",N.$i),u.set("isWeb",N.$o),u.set("isMacNative",N.$j&&!N.$o),u.set("isEdge",N.$H),u.set("isFirefox",N.$F),u.set("isChrome",N.$E),u.set("isSafari",N.$G);function a(F,f){if(u.get(F)!==void 0)throw(0,S.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");u.set(F,f)}e.$bj=a;const y=Object.prototype.hasOwnProperty;var E;(function(F){F[F.False=0]="False",F[F.True=1]="True",F[F.Defined=2]="Defined",F[F.Not=3]="Not",F[F.Equals=4]="Equals",F[F.NotEquals=5]="NotEquals",F[F.And=6]="And",F[F.Regex=7]="Regex",F[F.NotRegex=8]="NotRegex",F[F.Or=9]="Or",F[F.In=10]="In",F[F.NotIn=11]="NotIn",F[F.Greater=12]="Greater",F[F.GreaterEquals=13]="GreaterEquals",F[F.Smaller=14]="Smaller",F[F.SmallerEquals=15]="SmallerEquals"})(E||(e.ContextKeyExprType=E={}));const d={regexParsingWithErrorRecovery:!0},m=(0,A.localize)(0,null),w=(0,A.localize)(1,null),k=(0,A.localize)(2,null),v=(0,A.localize)(3,null),c=(0,A.localize)(4,null),p=(0,A.localize)(5,null),$=(0,A.localize)(6,null),h=(0,A.localize)(7,null);class g{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(f=d){this.k=f,this.d=new R.$aj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(f){if(f===""){this.h.push({message:m,offset:0,lexeme:"",additionalInfo:w});return}this.f=this.d.reset(f).scan(),this.g=0,this.h=[];try{const P=this.l();if(!this.E()){const z=this.D(),C=z.type===17?p:void 0;throw this.h.push({message:c,offset:z.offset,lexeme:R.$aj.getLexeme(z),additionalInfo:C}),g.c}return P}catch(P){if(P!==g.c)throw P;return}}l(){return this.m()}m(){const f=[this.o()];for(;this.y(16);){const P=this.o();f.push(P)}return f.length===1?f[0]:i.or(...f)}o(){const f=[this.s()];for(;this.y(15);){const P=this.s();f.push(P)}return f.length===1?f[0]:i.and(...f)}s(){if(this.y(2)){const f=this.D();switch(f.type){case 11:return this.z(),s.INSTANCE;case 12:return this.z(),o.INSTANCE;case 0:{this.z();const P=this.l();return this.A(1,v),P?.negate()}case 17:return this.z(),q.create(f.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",f)}}return this.t()}t(){const f=this.D();switch(f.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const P=this.l();return this.A(1,v),P}case 17:{const P=f.lexeme;if(this.z(),this.y(9)){const C=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),C.type!==10)throw this.B("REGEX",C);const W=C.lexeme,G=W.lastIndexOf("/"),te=G===W.length-1?void 0:this.w(W.substring(G+1));let le;try{le=new RegExp(W.substring(1,G),te)}catch{throw this.B("REGEX",C)}return de.create(P,le)}switch(C.type){case 10:case 19:{const W=[C.lexeme];this.z();let G=this.D(),te=0;for(let fe=0;fe<C.lexeme.length;fe++)C.lexeme.charCodeAt(fe)===40?te++:C.lexeme.charCodeAt(fe)===41&&te--;for(;!this.E()&&G.type!==15&&G.type!==16;){switch(G.type){case 0:te++;break;case 1:te--;break;case 10:case 18:for(let fe=0;fe<G.lexeme.length;fe++)G.lexeme.charCodeAt(fe)===40?te++:C.lexeme.charCodeAt(fe)===41&&te--}if(te<0)break;W.push(R.$aj.getLexeme(G)),this.z(),G=this.D()}const le=W.join(""),ue=le.lastIndexOf("/"),$e=ue===le.length-1?void 0:this.w(le.substring(ue+1));let we;try{we=new RegExp(le.substring(1,ue),$e)}catch{throw this.B("REGEX",C)}return i.regex(P,we)}case 18:{const W=C.lexeme;this.z();let G=null;if(!(0,D.$Se)(W)){const te=W.indexOf("/"),le=W.lastIndexOf("/");if(te!==le&&te>=0){const ue=W.slice(te+1,le),$e=W[le+1]==="i"?"i":"";try{G=new RegExp(ue,$e)}catch{throw this.B("REGEX",C)}}}if(G===null)throw this.B("REGEX",C);return de.create(P,G)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,k);const C=this.u();return i.notIn(P,C)}switch(this.D().type){case 3:{this.z();const C=this.u();if(this.x().type===18)return i.equals(P,C);switch(C){case"true":return i.has(P);case"false":return i.not(P);default:return i.equals(P,C)}}case 4:{this.z();const C=this.u();if(this.x().type===18)return i.notEquals(P,C);switch(C){case"true":return i.not(P);case"false":return i.has(P);default:return i.notEquals(P,C)}}case 5:return this.z(),re.create(P,this.u());case 6:return this.z(),he.create(P,this.u());case 7:return this.z(),K.create(P,this.u());case 8:return this.z(),oe.create(P,this.u());case 13:return this.z(),i.in(P,this.u());default:return i.has(P)}}case 20:throw this.h.push({message:$,offset:f.offset,lexeme:"",additionalInfo:h}),g.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const f=this.D();switch(f.type){case 17:case 18:return this.z(),f.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(f){return f.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(f){return this.C(f)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(f,P){if(this.C(f))return this.z();throw this.B(P,this.D())}B(f,P,z){const C=(0,A.localize)(8,null,f,R.$aj.getLexeme(P)),W=P.offset,G=R.$aj.getLexeme(P);return this.h.push({message:C,offset:W,lexeme:G,additionalInfo:z}),g.c}C(f){return this.D().type===f}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$cj=g;class i{static false(){return s.INSTANCE}static true(){return o.INSTANCE}static has(f){return l.create(f)}static equals(f,P){return O.create(f,P)}static notEquals(f,P){return j.create(f,P)}static regex(f,P){return de.create(f,P)}static in(f,P){return I.create(f,P)}static notIn(f,P){return b.create(f,P)}static not(f){return q.create(f)}static and(...f){return X.create(f,null,!0)}static or(...f){return T.create(f,null,!0)}static greater(f,P){return K.create(f,P)}static greaterEquals(f,P){return oe.create(f,P)}static smaller(f,P){return re.create(f,P)}static smallerEquals(f,P){return he.create(f,P)}static{this.c=new g({regexParsingWithErrorRecovery:!1})}static deserialize(f){return f==null?void 0:this.c.parse(f)}}e.$dj=i;function r(F){const f=new g({regexParsingWithErrorRecovery:!1});return F.map(P=>(f.parse(P),f.lexingErrors.length>0?f.lexingErrors.map(z=>({errorMessage:z.additionalInfo?(0,A.localize)(9,null,z.additionalInfo):(0,A.localize)(10,null),offset:z.offset,length:z.lexeme.length})):f.parsingErrors.length>0?f.parsingErrors.map(z=>({errorMessage:z.additionalInfo?`${z.message}. ${z.additionalInfo}`:z.message,offset:z.offset,length:z.lexeme.length})):[]))}e.$ej=r;function t(F,f){const P=F?F.substituteConstants():void 0,z=f?f.substituteConstants():void 0;return!P&&!z?!0:!P||!z?!1:P.equals(z)}e.$fj=t;function n(F,f){return F.cmp(f)}class s{static{this.INSTANCE=new s}constructor(){this.type=0}cmp(f){return this.type-f.type}equals(f){return f.type===this.type}substituteConstants(){return this}evaluate(f){return!1}serialize(){return"false"}keys(){return[]}map(f){return this}negate(){return o.INSTANCE}}e.$gj=s;class o{static{this.INSTANCE=new o}constructor(){this.type=1}cmp(f){return this.type-f.type}equals(f){return f.type===this.type}substituteConstants(){return this}evaluate(f){return!0}serialize(){return"true"}keys(){return[]}map(f){return this}negate(){return s.INSTANCE}}e.$hj=o;class l{static create(f,P=null){const z=u.get(f);return typeof z=="boolean"?z?o.INSTANCE:s.INSTANCE:new l(f,P)}constructor(f,P){this.key=f,this.c=P,this.type=2}cmp(f){return f.type!==this.type?this.type-f.type:H(this.key,f.key)}equals(f){return f.type===this.type?this.key===f.key:!1}substituteConstants(){const f=u.get(this.key);return typeof f=="boolean"?f?o.INSTANCE:s.INSTANCE:this}evaluate(f){return!!f.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(f){return f.mapDefined(this.key)}negate(){return this.c||(this.c=q.create(this.key,this)),this.c}}e.$ij=l;class O{static create(f,P,z=null){if(typeof P=="boolean")return P?l.create(f,z):q.create(f,z);const C=u.get(f);return typeof C=="boolean"?P===(C?"true":"false")?o.INSTANCE:s.INSTANCE:new O(f,P,z)}constructor(f,P,z){this.c=f,this.d=P,this.f=z,this.type=4}cmp(f){return f.type!==this.type?this.type-f.type:Z(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){const f=u.get(this.c);if(typeof f=="boolean"){const P=f?"true":"false";return this.d===P?o.INSTANCE:s.INSTANCE}return this}evaluate(f){return f.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(f){return f.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$jj=O;class I{static create(f,P){return new I(f,P)}constructor(f,P){this.d=f,this.f=P,this.type=10,this.c=null}cmp(f){return f.type!==this.type?this.type-f.type:Z(this.d,this.f,f.d,f.f)}equals(f){return f.type===this.type?this.d===f.d&&this.f===f.f:!1}substituteConstants(){return this}evaluate(f){const P=f.getValue(this.f),z=f.getValue(this.d);return Array.isArray(P)?P.includes(z):typeof z=="string"&&typeof P=="object"&&P!==null?y.call(P,z):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(f){return f.mapIn(this.d,this.f)}negate(){return this.c||(this.c=b.create(this.d,this.f)),this.c}}e.$kj=I;class b{static create(f,P){return new b(f,P)}constructor(f,P){this.d=f,this.f=P,this.type=11,this.c=I.create(f,P)}cmp(f){return f.type!==this.type?this.type-f.type:this.c.cmp(f.c)}equals(f){return f.type===this.type?this.c.equals(f.c):!1}substituteConstants(){return this}evaluate(f){return!this.c.evaluate(f)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(f){return f.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$lj=b;class j{static create(f,P,z=null){if(typeof P=="boolean")return P?q.create(f,z):l.create(f,z);const C=u.get(f);return typeof C=="boolean"?P===(C?"true":"false")?s.INSTANCE:o.INSTANCE:new j(f,P,z)}constructor(f,P,z){this.c=f,this.d=P,this.f=z,this.type=5}cmp(f){return f.type!==this.type?this.type-f.type:Z(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){const f=u.get(this.c);if(typeof f=="boolean"){const P=f?"true":"false";return this.d===P?s.INSTANCE:o.INSTANCE}return this}evaluate(f){return f.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(f){return f.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$mj=j;class q{static create(f,P=null){const z=u.get(f);return typeof z=="boolean"?z?s.INSTANCE:o.INSTANCE:new q(f,P)}constructor(f,P){this.c=f,this.d=P,this.type=3}cmp(f){return f.type!==this.type?this.type-f.type:H(this.c,f.c)}equals(f){return f.type===this.type?this.c===f.c:!1}substituteConstants(){const f=u.get(this.c);return typeof f=="boolean"?f?s.INSTANCE:o.INSTANCE:this}evaluate(f){return!f.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(f){return f.mapNot(this.c)}negate(){return this.d||(this.d=l.create(this.c,this)),this.d}}e.$nj=q;function Y(F,f){if(typeof F=="string"){const P=parseFloat(F);isNaN(P)||(F=P)}return typeof F=="string"||typeof F=="number"?f(F):s.INSTANCE}class K{static create(f,P,z=null){return Y(P,C=>new K(f,C,z))}constructor(f,P,z){this.c=f,this.d=P,this.f=z,this.type=12}cmp(f){return f.type!==this.type?this.type-f.type:Z(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){return this}evaluate(f){return typeof this.d=="string"?!1:parseFloat(f.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(f){return f.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=he.create(this.c,this.d,this)),this.f}}e.$oj=K;class oe{static create(f,P,z=null){return Y(P,C=>new oe(f,C,z))}constructor(f,P,z){this.c=f,this.d=P,this.f=z,this.type=13}cmp(f){return f.type!==this.type?this.type-f.type:Z(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){return this}evaluate(f){return typeof this.d=="string"?!1:parseFloat(f.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(f){return f.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=re.create(this.c,this.d,this)),this.f}}e.$pj=oe;class re{static create(f,P,z=null){return Y(P,C=>new re(f,C,z))}constructor(f,P,z){this.c=f,this.d=P,this.f=z,this.type=14}cmp(f){return f.type!==this.type?this.type-f.type:Z(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){return this}evaluate(f){return typeof this.d=="string"?!1:parseFloat(f.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(f){return f.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=oe.create(this.c,this.d,this)),this.f}}e.$qj=re;class he{static create(f,P,z=null){return Y(P,C=>new he(f,C,z))}constructor(f,P,z){this.c=f,this.d=P,this.f=z,this.type=15}cmp(f){return f.type!==this.type?this.type-f.type:Z(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){return this}evaluate(f){return typeof this.d=="string"?!1:parseFloat(f.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(f){return f.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=K.create(this.c,this.d,this)),this.f}}e.$rj=he;class de{static create(f,P){return new de(f,P)}constructor(f,P){this.d=f,this.f=P,this.type=7,this.c=null}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.d<f.d)return-1;if(this.d>f.d)return 1;const P=this.f?this.f.source:"",z=f.f?f.f.source:"";return P<z?-1:P>z?1:0}equals(f){if(f.type===this.type){const P=this.f?this.f.source:"",z=f.f?f.f.source:"";return this.d===f.d&&P===z}return!1}substituteConstants(){return this}evaluate(f){const P=f.getValue(this.d);return this.f?this.f.test(P):!1}serialize(){const f=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${f}`}keys(){return[this.d]}map(f){return f.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ae.create(this)),this.c}}e.$sj=de;class ae{static create(f){return new ae(f)}constructor(f){this.c=f,this.type=8}cmp(f){return f.type!==this.type?this.type-f.type:this.c.cmp(f.c)}equals(f){return f.type===this.type?this.c.equals(f.c):!1}substituteConstants(){return this}evaluate(f){return!this.c.evaluate(f)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(f){return new ae(this.c.map(f))}negate(){return this.c}}e.$tj=ae;function B(F){let f=null;for(let P=0,z=F.length;P<z;P++){const C=F[P].substituteConstants();if(F[P]!==C&&f===null){f=[];for(let W=0;W<P;W++)f[W]=F[W]}f!==null&&(f[P]=C)}return f===null?F:f}class X{static create(f,P,z){return X.d(f,P,z)}constructor(f,P){this.expr=f,this.c=P,this.type=6}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.expr.length<f.expr.length)return-1;if(this.expr.length>f.expr.length)return 1;for(let P=0,z=this.expr.length;P<z;P++){const C=n(this.expr[P],f.expr[P]);if(C!==0)return C}return 0}equals(f){if(f.type===this.type){if(this.expr.length!==f.expr.length)return!1;for(let P=0,z=this.expr.length;P<z;P++)if(!this.expr[P].equals(f.expr[P]))return!1;return!0}return!1}substituteConstants(){const f=B(this.expr);return f===this.expr?this:X.create(f,this.c,!1)}evaluate(f){for(let P=0,z=this.expr.length;P<z;P++)if(!this.expr[P].evaluate(f))return!1;return!0}static d(f,P,z){const C=[];let W=!1;for(const G of f)if(G){if(G.type===1){W=!0;continue}if(G.type===0)return s.INSTANCE;if(G.type===6){C.push(...G.expr);continue}C.push(G)}if(C.length===0&&W)return o.INSTANCE;if(C.length!==0){if(C.length===1)return C[0];C.sort(n);for(let G=1;G<C.length;G++)C[G-1].equals(C[G])&&(C.splice(G,1),G--);if(C.length===1)return C[0];for(;C.length>1;){const G=C[C.length-1];if(G.type!==9)break;C.pop();const te=C.pop(),le=C.length===0,ue=T.create(G.expr.map($e=>X.create([$e,te],null,z)),null,le);ue&&(C.push(ue),C.sort(n))}if(C.length===1)return C[0];if(z){for(let G=0;G<C.length;G++)for(let te=G+1;te<C.length;te++)if(C[G].negate().equals(C[te]))return s.INSTANCE;if(C.length===1)return C[0]}return new X(C,P)}}serialize(){return this.expr.map(f=>f.serialize()).join(" && ")}keys(){const f=[];for(const P of this.expr)f.push(...P.keys());return f}map(f){return new X(this.expr.map(P=>P.map(f)),null)}negate(){if(!this.c){const f=[];for(const P of this.expr)f.push(P.negate());this.c=T.create(f,this,!0)}return this.c}}e.$uj=X;class T{static create(f,P,z){return T.d(f,P,z)}constructor(f,P){this.expr=f,this.c=P,this.type=9}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.expr.length<f.expr.length)return-1;if(this.expr.length>f.expr.length)return 1;for(let P=0,z=this.expr.length;P<z;P++){const C=n(this.expr[P],f.expr[P]);if(C!==0)return C}return 0}equals(f){if(f.type===this.type){if(this.expr.length!==f.expr.length)return!1;for(let P=0,z=this.expr.length;P<z;P++)if(!this.expr[P].equals(f.expr[P]))return!1;return!0}return!1}substituteConstants(){const f=B(this.expr);return f===this.expr?this:T.create(f,this.c,!1)}evaluate(f){for(let P=0,z=this.expr.length;P<z;P++)if(this.expr[P].evaluate(f))return!0;return!1}static d(f,P,z){let C=[],W=!1;if(f){for(let G=0,te=f.length;G<te;G++){const le=f[G];if(le){if(le.type===0){W=!0;continue}if(le.type===1)return o.INSTANCE;if(le.type===9){C=C.concat(le.expr);continue}C.push(le)}}if(C.length===0&&W)return s.INSTANCE;C.sort(n)}if(C.length!==0){if(C.length===1)return C[0];for(let G=1;G<C.length;G++)C[G-1].equals(C[G])&&(C.splice(G,1),G--);if(C.length===1)return C[0];if(z){for(let G=0;G<C.length;G++)for(let te=G+1;te<C.length;te++)if(C[G].negate().equals(C[te]))return o.INSTANCE;if(C.length===1)return C[0]}return new T(C,P)}}serialize(){return this.expr.map(f=>f.serialize()).join(" || ")}keys(){const f=[];for(const P of this.expr)f.push(...P.keys());return f}map(f){return new T(this.expr.map(P=>P.map(f)),null)}negate(){if(!this.c){const f=[];for(const P of this.expr)f.push(P.negate());for(;f.length>1;){const P=f.shift(),z=f.shift(),C=[];for(const W of U(P))for(const G of U(z))C.push(X.create([W,G],null,!1));f.unshift(T.create(C,null,!1))}this.c=T.create(f,this,!0)}return this.c}}e.$vj=T;class M extends l{static{this.d=[]}static all(){return M.d.values()}constructor(f,P,z){super(f,null),this.f=P,typeof z=="object"?M.d.push({...z,key:f}):z!==!0&&M.d.push({key:f,description:z,type:P!=null?typeof P:void 0})}bindTo(f){return f.createKey(this.key,this.f)}getValue(f){return f.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(f){return O.create(this.key,f)}notEqualsTo(f){return j.create(this.key,f)}}e.$wj=M,e.$xj=(0,L.$fi)("contextKeyService");function H(F,f){return F<f?-1:F>f?1:0}function Z(F,f,P,z){return F<P?-1:F>P?1:f<z?-1:f>z?1:0}function Q(F,f){if(F.type===0||f.type===1)return!0;if(F.type===9)return f.type===9?_(F.expr,f.expr):!1;if(f.type===9){for(const P of f.expr)if(Q(F,P))return!0;return!1}if(F.type===6){if(f.type===6)return _(f.expr,F.expr);for(const P of F.expr)if(Q(P,f))return!0;return!1}return F.equals(f)}e.$yj=Q;function _(F,f){let P=0,z=0;for(;P<F.length&&z<f.length;){const C=F[P].cmp(f[z]);if(C<0)return!1;C===0&&P++,z++}return P===F.length}function U(F){return F.type===9?F.expr:[F]}}),define(ie[59],ne([0,1,10]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$so=void 0,e.$so=(0,N.$fi)("downloadService")}),define(ie[18],ne([0,1,10]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ni=e.$mi=void 0,e.$mi=(0,N.$fi)("environmentService"),e.$ni=(0,N.$gi)(e.$mi)}),define(ie[21],ne([0,1,95,10]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.ExtensionGalleryErrorCode=e.$Oo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$No=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=void 0,e.$Bo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Co=new RegExp(e.$Bo),e.$Do="__web_extension",e.$Eo="skipWalkthrough",e.$Fo="extensionsSync",e.$Go="dependecyOrPackExtensionInstall";function R($){switch($){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Ho=R;function L($){switch($){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Io=L;function A($,h){switch($){case 3:return h==="x64"?"win32-x64":h==="arm64"?"win32-arm64":"unknown";case 2:return h==="x64"?"linux-x64":h==="arm64"?"linux-arm64":h==="arm"?"linux-armhf":"unknown";case"alpine":return h==="x64"?"alpine-x64":h==="arm64"?"alpine-arm64":"unknown";case 1:return h==="x64"?"darwin-x64":h==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Jo=A;function S($,h){return h==="web"&&!$.includes("web")}e.$Ko=S;function u($,h,g){return S(h,g)?!1:$==="undefined"||$==="universal"?!0:$==="unknown"?!1:$===g}e.$Lo=u;function a($){return $&&typeof $=="object"&&typeof $.id=="string"&&(!$.uuid||typeof $.uuid=="string")}e.$Mo=a;var y;(function($){$[$.NoneOrRelevance=0]="NoneOrRelevance",$[$.LastUpdatedDate=1]="LastUpdatedDate",$[$.Title=2]="Title",$[$.PublisherName=3]="PublisherName",$[$.InstallCount=4]="InstallCount",$[$.PublishedDate=10]="PublishedDate",$[$.AverageRating=6]="AverageRating",$[$.WeightedRating=12]="WeightedRating"})(y||(e.SortBy=y={}));var E;(function($){$[$.Default=0]="Default",$[$.Ascending=1]="Ascending",$[$.Descending=2]="Descending"})(E||(e.SortOrder=E={}));var d;(function($){$.Install="install",$.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var m;(function($){$[$.None=1]="None",$[$.Install=2]="Install",$[$.Update=3]="Update",$[$.Migrate=4]="Migrate"})(m||(e.InstallOperation=m={})),e.$No=(0,D.$fi)("extensionGalleryService");var w;(function($){$.Unsupported="Unsupported",$.Deprecated="Deprecated",$.Malicious="Malicious",$.Incompatible="Incompatible",$.IncompatibleTargetPlatform="IncompatibleTargetPlatform",$.ReleaseVersionNotFound="ReleaseVersionNotFound",$.Invalid="Invalid",$.Download="Download",$.DownloadSignature="DownloadSignature",$.UpdateMetadata="UpdateMetadata",$.Extract="Extract",$.Scanning="Scanning",$.Delete="Delete",$.Rename="Rename",$.CorruptZip="CorruptZip",$.IncompleteZip="IncompleteZip",$.Signature="Signature",$.NotAllowed="NotAllowed",$.Gallery="Gallery",$.Unknown="Unknown",$.Internal="Internal"})(w||(e.ExtensionManagementErrorCode=w={}));var k;(function($){$.UnknownError="UnknownError",$.PackageIsInvalidZip="PackageIsInvalidZip",$.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(k||(e.ExtensionSignaturetErrorCode=k={}));class v extends Error{constructor(h,g){super(h),this.code=g,this.name=g}}e.$Oo=v;var c;(function($){$.Timeout="Timeout",$.Cancelled="Cancelled",$.Failed="Failed"})(c||(e.ExtensionGalleryErrorCode=c={}));class p extends Error{constructor(h,g){super(h),this.code=g,this.name=g}}e.$Po=p,e.$Qo=(0,D.$fi)("extensionManagementService"),e.$Ro="extensionsIdentifiers/disabled",e.$So="extensionsIdentifiers/enabled",e.$To=(0,D.$fi)("IGlobalExtensionEnablementService"),e.$Uo=(0,D.$fi)("IExtensionTipsService"),e.$Vo=(0,N.localize2)(0,"Extensions"),e.$Wo=(0,N.localize2)(1,"Preferences")}),define(ie[60],ne([0,1,14,7,103,13]),function(J,e,N,D,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pq=void 0;async function A(y,E,d,m,w,k){let v;try{await S(y,E,d,m,w,k)}catch(c){v=c}finally{v&&w.errorTransformer&&(v=w.errorTransformer(v)),typeof v<"u"&&d.error(v),d.end()}}e.$pq=A;async function S(y,E,d,m,w,k){u(k);const v=await y.open(E,{create:!1});try{u(k);let c=0,p=0,$=w&&typeof w.length=="number"?w.length:void 0,h=N.$se.alloc(Math.min(w.bufferSize,typeof $=="number"?$:w.bufferSize)),g=w&&typeof w.position=="number"?w.position:0,i=0;do p=await y.read(v,g,h.buffer,i,h.byteLength-i),g+=p,i+=p,c+=p,typeof $=="number"&&($-=p),i===h.byteLength&&(await d.write(m(h)),h=N.$se.alloc(Math.min(w.bufferSize,typeof $=="number"?$:w.bufferSize)),i=0);while(p>0&&(typeof $!="number"||$>0)&&u(k)&&a(c,w));if(i>0){let r=i;typeof $=="number"&&(r=Math.min(i,$)),d.write(m(h.slice(0,r)))}}catch(c){throw(0,L.$Tk)(c)}finally{await y.close(v)}}function u(y){if(y.isCancellationRequested)throw(0,D.$6)();return!0}function a(y,E){if(typeof E?.limits?.size=="number"&&y>E.limits.size)throw(0,L.$Sk)((0,R.localize)(0,null),L.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ie[121],ne([0,1,6,168,2,12,169]),function(J,e,N,D,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=void 0;class S extends R.$Tc{constructor(){super(...arguments),this.a=this.B(new N.$5d),this.onDidChangeFile=this.a.event,this.b=this.B(new N.$5d),this.onDidLogMessage=this.b.event,this.onDidError=N.Event.None,this.c=new Map,this.f=!1}async watch(a){const y=this.j(a),E=y.filter(m=>{const w=this.c.get(m.path);return w?!(0,D.$3j)(w.request.excludes,m.excludes)||!(0,D.$3j)(w.request.includes,m.includes):!0}),d=Array.from(this.c.values()).filter(({request:m})=>!y.find(w=>w.path===m.path&&(0,D.$3j)(w.excludes,m.excludes)&&(0,D.$3j)(w.includes,m.includes))).map(({request:m})=>m.path);E.length&&this.m(`Request to start watching: ${E.map(m=>`${m.path} (excludes: ${m.excludes.length>0?m.excludes:"<none>"}, includes: ${m.includes&&m.includes.length>0?JSON.stringify(m.includes):"<all>"}, correlationId: ${typeof m.correlationId=="number"?m.correlationId:"<none>"})`).join(",")}`),d.length&&this.m(`Request to stop watching: ${d.join(",")}`);for(const m of d)this.h(m);for(const m of E)this.g(m)}g(a){const y=new A.$Lq(a,d=>this.a.fire(d),d=>this.b.fire(d),this.f),E={request:a,instance:y};this.c.set(a.path,E)}async stop(){for(const[a]of this.c)this.h(a);this.c.clear()}h(a){const y=this.c.get(a);y&&(this.c.delete(a),y.instance.dispose())}j(a){const y=new Map;for(const E of a){const d=L.$k?E.path:E.path.toLowerCase();let m=y.get(E.correlationId);m||(m=new Map,y.set(E.correlationId,m)),m.set(d,E)}return Array.from(y.values()).map(E=>Array.from(E.values())).flat()}async setVerboseLogging(a){this.f=a;for(const[,y]of this.c)y.instance.setVerboseLogging(a)}m(a){this.f&&this.b.fire({type:"trace",message:this.n(a)})}n(a,y){return y?`[File Watcher (node.js)] ${a} (path: ${y.request.path})`:`[File Watcher (node.js)] ${a}`}}e.$Nq=S}),define(ie[122],ne([0,1,61,121]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oq=void 0;class R extends N.$tq{constructor(A,S,u){super(A,S,u),this.s()}r(A){return A.add(new D.$Nq)}}e.$Oq=R}),define(ie[123],ne([0,1,15,57,87,61]),function(J,e,N,D,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gq=void 0;class A extends L.$uq{constructor(u,a,y){super(u,a,y),this.s()}r(u){const a=u.add(new R.$Fq(N.$zg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return u.add(a.onDidProcessExit(({code:y,signal:E})=>this.t(`terminated by itself with code ${y}, signal: ${E}`))),D.ProxyChannel.toService((0,D.$Yh)(a.getChannel("watcher")))}}e.$Gq=A}),define(ie[62],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$di=void 0;class N{constructor(...R){this.a=new Map;for(const[L,A]of R)this.set(L,A)}set(R,L){const A=this.a.get(R);return this.a.set(R,L),A}has(R){return this.a.has(R)}get(R){return this.a.get(R)}}e.$di=N}),define(ie[124],ne([0,1,9,7,2,51,119,10,62,170]),function(J,e,N,D,R,L,A,S,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=e.$Sq=void 0;const y=!1;class E extends Error{constructor(v){super("cyclic dependency between services"),this.message=v.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${v.toString()}`}}class d{constructor(v=new u.$di,c=!1,p,$=y){this.f=v,this.g=c,this.h=p,this.i=$,this.o=new Set,this.f.set(S.$ei,this),this._globalGraph=$?p?._globalGraph??new A.$Rq(h=>h):void 0}createChild(v){return new d(v,this.g,this,this.i)}invokeFunction(v,...c){const p=w.traceInvocation(this.i,v);let $=!1;try{return v({get:g=>{if($)throw(0,D.$8)("service accessor is only valid during the invocation of its target method");const i=this.m(g,p);if(!i)throw new Error(`[invokeFunction] unknown service '${g}'`);return i}},...c)}finally{$=!0,p.stop()}}createInstance(v,...c){let p,$;return v instanceof L.$ci?(p=w.traceCreation(this.i,v.ctor),$=this.j(v.ctor,v.staticArguments.concat(c),p)):(p=w.traceCreation(this.i,v),$=this.j(v,c,p)),p.stop(),$}j(v,c=[],p){const $=S._util.getServiceDependencies(v).sort((i,r)=>i.index-r.index),h=[];for(const i of $){const r=this.m(i.id,p);r||this.u(`[createInstance] ${v.name} depends on UNKNOWN service ${i.id}.`,!1),h.push(r)}const g=$.length>0?$[0].index:c.length;if(c.length!==g){console.trace(`[createInstance] First service dependency of ${v.name} at position ${g+1} conflicts with ${c.length} static arguments`);const i=g-c.length;i>0?c=c.concat(new Array(i)):c=c.slice(0,g)}return Reflect.construct(v,c.concat(h))}k(v,c){if(this.f.get(v)instanceof L.$ci)this.f.set(v,c);else if(this.h)this.h.k(v,c);else throw new Error("illegalState - setting UNKNOWN service instance")}l(v){const c=this.f.get(v);return!c&&this.h?this.h.l(v):c}m(v,c){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(v));const p=this.l(v);return p instanceof L.$ci?this.q(v,p,c.branch(v,!0)):(c.branch(v,!1),p)}q(v,c,p){if(this.o.has(v))throw new Error(`illegal state - RECURSIVELY instantiating service '${v}'`);this.o.add(v);try{return this.r(v,c,p)}finally{this.o.delete(v)}}r(v,c,p){const $=new A.$Rq(i=>i.id.toString());let h=0;const g=[{id:v,desc:c,_trace:p}];for(;g.length;){const i=g.pop();if($.lookupOrInsertNode(i),h++>1e3)throw new E($);for(const r of S._util.getServiceDependencies(i.desc.ctor)){const t=this.l(r.id);if(t||this.u(`[createInstance] ${v} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(r.id)),t instanceof L.$ci){const n={id:r.id,desc:t,_trace:i._trace.branch(r.id,!0)};$.insertEdge(i,n),g.push(n)}}}for(;;){const i=$.roots();if(i.length===0){if(!$.isEmpty())throw new E($);break}for(const{data:r}of i){if(this.l(r.id)instanceof L.$ci){const n=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,n)}$.removeNode(r)}}return this.l(v)}s(v,c,p=[],$,h){if(this.f.get(v)instanceof L.$ci)return this.t(v,c,p,$,h);if(this.h)return this.h.s(v,c,p,$,h);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}t(v,c,p=[],$,h){if($){const g=new d(void 0,this.g,this,this.i);g.c=String(v);const i=new Map,r=new N.$yh(()=>{const t=g.j(c,p,h);for(const[n,s]of i){const o=t[n];if(typeof o=="function")for(const l of s)l.disposable=o.apply(t,l.listener)}return i.clear(),t});return new Proxy(Object.create(null),{get(t,n){if(!r.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let l=i.get(n);return l||(l=new a.$4c,i.set(n,l)),(I,b,j)=>{if(r.isInitialized)return r.value[n](I,b,j);{const q={listener:[I,b,j],disposable:void 0},Y=l.push(q);return(0,R.$Rc)(()=>{Y(),q.disposable?.dispose()})}}}if(n in t)return t[n];const s=r.value;let o=s[n];return typeof o!="function"||(o=o.bind(s),t[n]=o),o},set(t,n,s){return r.value[n]=s,!0},getPrototypeOf(t){return c.prototype}})}else return this.j(c,p,h)}u(v,c){if(c&&console.warn(v),this.g)throw new Error(v)}}e.$Sq=d;var m;(function(k){k[k.None=0]="None",k[k.Creation=1]="Creation",k[k.Invocation=2]="Invocation",k[k.Branch=3]="Branch"})(m||(m={}));class w{static{this.all=new Set}static{this.c=new class extends w{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(v,c){return v?new w(2,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):w.c}static traceCreation(v,c){return v?new w(1,c.name):w.c}static{this.f=0}constructor(v,c){this.type=v,this.name=c,this.g=Date.now(),this.h=[]}branch(v,c){const p=new w(3,v.toString());return this.h.push([v,c,p]),p}stop(){const v=Date.now()-this.g;w.f+=v;let c=!1;function p(h,g){const i=[],r=new Array(h+1).join("	");for(const[t,n,s]of g.h)if(n&&s){c=!0,i.push(`${r}CREATES -> ${t}`);const o=p(h+1,s);o&&i.push(o)}else i.push(`${r}uses -> ${t}`);return i.join(`
`)}const $=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${v.toFixed(2)}ms (grand total ${w.f.toFixed(2)}ms)`];(v>2||c)&&w.all.add($.join(`
`))}}e.$Tq=w});var se=this&&this.__param||function(J,e){return function(N,D){e(N,D,J)}};define(ie[63],ne([0,1,20,2,12,105,21,10]),function(J,e,N,D,R,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wr=e.$vr=e.$ur=void 0;function u(y){return y.tags.find(E=>E.startsWith("lp-"))?.split("lp-")[1]}e.$ur=u,e.$vr=(0,S.$fi)("languagePackService");let a=class extends D.$Tc{constructor(E){super(),this.c=E}async getAvailableLanguages(){const E=new N.$ce;setTimeout(()=>E.cancel(),1e3);let d;try{d=await this.c.query({text:'category:"language packs"',pageSize:20},E.token)}catch{return[]}const w=d.firstPage.filter(k=>k.properties.localizedLanguages?.length&&k.tags.some(v=>v.startsWith("lp-"))).map(k=>{const v=k.properties.localizedLanguages?.[0],c=u(k);return{...this.f(c,v,k),extensionId:k.identifier.id,galleryExtension:k}});return w.push(this.f("en","English")),w}f(E,d,m){const w=d??E;let k;if(w!==E&&(k=`(${E})`),E.toLowerCase()===R.$w.toLowerCase()&&(k??="",k+=(0,L.localize)(0,null)),m?.installCount){k??="";const v=m.installCount;let c;v>1e6?c=`${Math.floor(v/1e5)/10}M`:v>1e3?c=`${Math.floor(v/1e3)}K`:c=String(v),k+=` $(cloud-download) ${c}`}return{id:E,label:w,description:k}}};e.$wr=a,e.$wr=a=me([se(0,A.$No)],a)}),define(ie[4],ne([0,1,34,6,43,2,31,12,17,3,11,120,10]),function(J,e,N,D,R,L,A,S,u,a,y,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.log=e.$Cj=e.LogLevel=e.$Bj=e.$Aj=e.$zj=void 0,e.$zj=(0,d.$fi)("logService"),e.$Aj=(0,d.$fi)("loggerService");function m(){return new Date().toISOString()}function w(I){return(0,a.$Wf)(I)}e.$Bj=w;var k;(function(I){I[I.Off=0]="Off",I[I.Trace=1]="Trace",I[I.Debug=2]="Debug",I[I.Info=3]="Info",I[I.Warning=4]="Warning",I[I.Error=5]="Error"})(k||(e.LogLevel=k={})),e.$Cj=k.Info;function v(I,b,j){switch(b){case k.Trace:I.trace(j);break;case k.Debug:I.debug(j);break;case k.Info:I.info(j);break;case k.Warning:I.warn(j);break;case k.Error:I.error(j);break;case k.Off:break;default:throw new Error(`Invalid log level ${b}`)}}e.log=v;function c(I,b=!1){let j="";for(let q=0;q<I.length;q++){let Y=I[q];if(Y instanceof Error&&(Y=(0,N.$3i)(Y,b)),typeof Y=="object")try{Y=JSON.stringify(Y)}catch{}j+=(q>0?" ":"")+Y}return j}class p extends L.$Tc{constructor(){super(...arguments),this.b=e.$Cj,this.c=this.B(new D.$5d),this.onDidChangeLogLevel=this.c.event}setLevel(b){this.b!==b&&(this.b=b,this.c.fire(this.b))}getLevel(){return this.b}f(b){return this.b!==k.Off&&this.b<=b}}e.$Ej=p;class $ extends p{constructor(b){super(),this.h=b}f(b){return this.h||super.f(b)}trace(b,...j){this.f(k.Trace)&&this.g(k.Trace,c([b,...j],!0))}debug(b,...j){this.f(k.Debug)&&this.g(k.Debug,c([b,...j]))}info(b,...j){this.f(k.Info)&&this.g(k.Info,c([b,...j]))}warn(b,...j){this.f(k.Warning)&&this.g(k.Warning,c([b,...j]))}error(b,...j){if(this.f(k.Error))if(b instanceof Error){const q=Array.prototype.slice.call(arguments);q[0]=b.stack,this.g(k.Error,c(q))}else this.g(k.Error,c([b,...j]))}flush(){}}e.$Fj=$;class h extends p{constructor(b=e.$Cj){super(),this.setLevel(b),this.g=!S.$i}trace(b,...j){this.f(k.Trace)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,b,...j):console.log(`[main ${m()}]`,b,...j))}debug(b,...j){this.f(k.Debug)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,b,...j):console.log(`[main ${m()}]`,b,...j))}info(b,...j){this.f(k.Info)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,b,...j):console.log(`[main ${m()}]`,b,...j))}warn(b,...j){this.f(k.Warning)&&(this.g?console.warn(`\x1B[93m[main ${m()}]\x1B[0m`,b,...j):console.warn(`[main ${m()}]`,b,...j))}error(b,...j){this.f(k.Error)&&(this.g?console.error(`\x1B[91m[main ${m()}]\x1B[0m`,b,...j):console.error(`[main ${m()}]`,b,...j))}flush(){}}e.$Gj=h;class g extends p{constructor(b=e.$Cj,j=!0){super(),this.g=j,this.setLevel(b)}trace(b,...j){this.f(k.Trace)&&(this.g?console.log("%cTRACE","color: #888",b,...j):console.log(b,...j))}debug(b,...j){this.f(k.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",b,...j):console.log(b,...j))}info(b,...j){this.f(k.Info)&&(this.g?console.log("%c INFO","color: #33f",b,...j):console.log(b,...j))}warn(b,...j){this.f(k.Warning)&&(this.g?console.log("%c WARN","color: #993",b,...j):console.log(b,...j))}error(b,...j){this.f(k.Error)&&(this.g?console.log("%c  ERR","color: #f33",b,...j):console.error(b,...j))}flush(){}}e.$Hj=g;class i extends p{constructor(b,j=e.$Cj){super(),this.g=b,this.setLevel(j)}trace(b,...j){this.f(k.Trace)&&this.g.log(k.Trace,[this.h(b),...j])}debug(b,...j){this.f(k.Debug)&&this.g.log(k.Debug,[this.h(b),...j])}info(b,...j){this.f(k.Info)&&this.g.log(k.Info,[this.h(b),...j])}warn(b,...j){this.f(k.Warning)&&this.g.log(k.Warning,[this.h(b),...j])}error(b,...j){this.f(k.Error)&&this.g.log(k.Error,[this.h(b),...j])}h(b){return typeof b=="string"?b:(0,N.$3i)(b,this.f(k.Trace))}flush(){}}e.$Ij=i;class r extends p{constructor(b){super(),this.g=b,b.length&&this.setLevel(b[0].getLevel())}setLevel(b){for(const j of this.g)j.setLevel(b);super.setLevel(b)}trace(b,...j){for(const q of this.g)q.trace(b,...j)}debug(b,...j){for(const q of this.g)q.debug(b,...j)}info(b,...j){for(const q of this.g)q.info(b,...j)}warn(b,...j){for(const q of this.g)q.warn(b,...j)}error(b,...j){for(const q of this.g)q.error(b,...j)}flush(){for(const b of this.g)b.flush()}dispose(){for(const b of this.g)b.dispose();super.dispose()}}e.$Jj=r;class t extends L.$Tc{constructor(b,j,q){if(super(),this.h=b,this.j=j,this.b=new A.$Ac,this.c=this.B(new D.$5d),this.onDidChangeLoggers=this.c.event,this.f=this.B(new D.$5d),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new D.$5d),this.onDidChangeVisibility=this.g.event,q)for(const Y of q)this.b.set(Y.resource,{logger:void 0,info:Y})}m(b){return(0,a.$Sf)(b)?[...this.b.values()].find(j=>j.info.id===b):this.b.get(b)}getLogger(b){return this.m(b)?.logger}createLogger(b,j){const q=this.n(b),Y=(0,a.$Sf)(b)?b:j?.id??(0,R.$6i)(q.toString()).toString(16);let K=this.b.get(q)?.logger;const oe=j?.logLevel==="always"?k.Trace:j?.logLevel;K||(K=this.s(q,oe??this.getLogLevel(q)??this.h,{...j,id:Y}));const re={logger:K,info:{resource:q,id:Y,logLevel:oe,name:j?.name,hidden:j?.hidden,extensionId:j?.extensionId,when:j?.when}};return this.registerLogger(re.info),this.b.set(q,re),K}n(b){return(0,a.$Sf)(b)?(0,u.$Sg)(this.j,`${b}.log`):b}setLogLevel(b,j){if(y.URI.isUri(b)){const q=b,Y=j,K=this.b.get(q);K&&Y!==K.info.logLevel&&(K.info.logLevel=Y===this.h?void 0:Y,K.logger?.setLevel(Y),this.b.set(K.info.resource,K),this.f.fire([q,Y]))}else{this.h=b;for(const[q,Y]of this.b.entries())this.b.get(q)?.info.logLevel===void 0&&Y.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(b,j){const q=this.m(b);q&&j!==!q.info.hidden&&(q.info.hidden=!j,this.b.set(q.info.resource,q),this.g.fire([q.info.resource,j]))}getLogLevel(b){let j;return b&&(j=this.b.get(b)?.info.logLevel),j??this.h}registerLogger(b){const j=this.b.get(b.resource);j?j.info.hidden!==b.hidden&&this.setVisibility(b.resource,!b.hidden):(this.b.set(b.resource,{info:b,logger:void 0}),this.c.fire({added:[b],removed:[]}))}deregisterLogger(b){const j=this.b.get(b);j&&(j.logger&&j.logger.dispose(),this.b.delete(b),this.c.fire({added:[],removed:[j.info]}))}*getRegisteredLoggers(){for(const b of this.b.values())yield b.info}getRegisteredLogger(b){return this.b.get(b)?.info}dispose(){this.b.forEach(b=>b.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Kj=t;class n{constructor(){this.onDidChangeLogLevel=new D.$5d().event}setLevel(b){}getLevel(){return k.Info}trace(b,...j){}debug(b,...j){}info(b,...j){}warn(b,...j){}error(b,...j){}critical(b,...j){}dispose(){}flush(){}}e.$Lj=n;class s extends n{}e.$Mj=s;function o(I){if(I.verbose)return k.Trace;if(typeof I.logLevel=="string"){const b=O(I.logLevel.toLowerCase());if(b!==void 0)return b}return e.$Cj}e.$Nj=o;function l(I){switch(I){case k.Trace:return"trace";case k.Debug:return"debug";case k.Info:return"info";case k.Warning:return"warn";case k.Error:return"error";case k.Off:return"off"}}e.$Oj=l;function O(I){switch(I){case"trace":return k.Trace;case"debug":return k.Debug;case"info":return k.Info;case"warn":return k.Warning;case"error":return k.Error;case"critical":return k.Error;case"off":return k.Off}}e.$Pj=O,e.$Qj=new E.$wj("logLevel",l(k.Info))}),define(ie[64],ne([0,1,7,10,4]),function(J,e,N,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Up=e.$Tp=void 0,e.$Tp=(0,D.$fi)("IExtensionSignatureVerificationService");let L=class{constructor(S){this.b=S}c(){return this.a||(this.a=new Promise((S,u)=>J(["@vscode/vsce-sign"],async a=>S(a),u))),this.a}async verify(S,u,a){let y;try{y=await this.c()}catch(E){return this.b.error("Could not load vsce-sign module",(0,N.$0)(E)),!1}return y.verify(S,u,a)}};e.$Up=L,e.$Up=L=me([se(0,R.$zj)],L)}),define(ie[125],ne([0,1,19,9,7,6,2,16,61,4]),function(J,e,N,D,R,L,A,S,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=void 0;class y extends A.$Tc{constructor(d,m){super(),this.a=d,this.b=m,this.c=this.B(new L.$5d),this.onDidChangeFile=this.c.event,this.g=this.B(new L.$5d),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new D.$dh(0)),this.w=[],this.y=this.B(new D.$dh(0))}watch(d,m){return m.recursive||this.b?.watcher?.forceUniversal?this.n(d,m):this.z(d,m)}n(d,m){const w={path:this.H(d),excludes:m.excludes,includes:m.includes,recursive:m.recursive,correlationId:m.correlationId},k=(0,N.$Ub)(this.j,w);return this.r(),(0,A.$Rc)(()=>{k(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(d=>(0,R.$1)(d))}s(){this.h||(this.h=this.B(this.t(m=>this.c.fire((0,u.$vq)(m)),m=>this.G(m),this.a.getLevel()===a.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===a.LogLevel.Trace)})));const d=this.b?.watcher?.recursive?.usePolling;if(d===!0)for(const m of this.j)(0,u.$rq)(m)&&(m.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(d))for(const m of this.j)(0,u.$rq)(m)&&d.includes(m.path)&&(m.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(d,m){const w={path:this.H(d),excludes:m.excludes,includes:m.includes,recursive:!1,correlationId:m.correlationId},k=(0,N.$Ub)(this.w,w);return this.C(),(0,A.$Rc)(()=>{k(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(d=>(0,R.$1)(d))}D(){return this.u||(this.u=this.B(this.F(d=>this.c.fire((0,u.$vq)(d)),d=>this.G(d),this.a.getLevel()===a.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===a.LogLevel.Trace)}))),this.u.watch(this.w)}G(d){d.type==="error"&&this.g.fire(d.message),this.a[d.type](d.message)}H(d){return(0,S.$hc)(d.fsPath)}}e.$zq=y}),define(ie[126],ne([0,1,19,9,14,20,6,43,65,2,48,15,127,17,46,102,13,60,4,7]),function(J,e,N,D,R,L,A,S,u,a,y,E,d,m,w,k,v,c,p,$){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$qq=void 0;let g=class extends a.$Tc{static{h=this}constructor(r){super(),this.b=r,this.a=256*1024,this.c=this.B(new A.$5d),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new A.$5d),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new A.$5d),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new A.$5d),this.onDidRunOperation=this.r.event,this.X=this.B(new A.$5d),this.Y=this.B(new A.$5d),this.onDidFilesChange=this.Y.event,this.Z=this.B(new A.$5d),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new D.$oh)}registerProvider(r,t){if(this.h.has(r))throw new Error(`A filesystem provider for the scheme '${r}' is already registered.`);(0,d.mark)(`code/registerFilesystem/${r}`);const n=new a.$Sc;return this.h.set(r,t),this.c.fire({added:!0,scheme:r,provider:t}),n.add(t.onDidChangeFile(s=>{const o=new v.$Yk(s,!this.S(t));this.X.fire(o),o.hasCorrelation()||this.Y.fire(o)})),typeof t.onDidWatchError=="function"&&n.add(t.onDidWatchError(s=>this.Z.fire(new Error(s)))),n.add(t.onDidChangeCapabilities(()=>this.g.fire({provider:t,scheme:r}))),(0,a.$Rc)(()=>{this.c.fire({added:!1,scheme:r,provider:t}),this.h.delete(r),(0,a.$Oc)(n)})}getProvider(r){return this.h.get(r)}async activateProvider(r){const t=[];this.f.fire({scheme:r,join(n){t.push(n)}}),!this.h.has(r)&&await D.Promises.settled(t)}async canHandleResource(r){return await this.activateProvider(r.scheme),this.hasProvider(r)}hasProvider(r){return this.h.has(r.scheme)}hasCapability(r,t){const n=this.h.get(r.scheme);return!!(n&&n.capabilities&t)}listCapabilities(){return u.Iterable.map(this.h,([r,t])=>({scheme:r,capabilities:t.capabilities}))}async j(r){if(!(0,m.$Wg)(r))throw new v.$1k((0,k.localize)(0,null,this.sb(r)),8);await this.activateProvider(r.scheme);const t=this.h.get(r.scheme);if(!t){const n=new $.$bb;throw n.message=(0,k.localize)(1,null,r.toString()),n}return t}async m(r){const t=await this.j(r);if((0,v.$Lk)(t)||(0,v.$Ik)(t)||(0,v.$Mk)(t))return t;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(r){const t=await this.j(r);if((0,v.$Lk)(t)||(0,v.$Ik)(t))return t;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(r,t){try{return await this.s(r,t)}catch(n){throw(0,v.$Vk)(n)===v.FileSystemProviderErrorCode.FileNotFound?new v.$1k((0,k.localize)(2,null,this.sb(r)),1):(0,v.$Tk)(n)}}async s(r,t){const n=await this.j(r),s=this.S(n),o=t?.resolveTo,l=t?.resolveSingleChildDescendants,O=t?.resolveMetadata,I=await n.stat(r);let b;return this.t(n,r,I,void 0,!!O,(j,q)=>(b||(b=y.$li.forUris(()=>!s),b.set(r,!0),o&&b.fill(!0,o)),b.get(j.resource)||b.findSuperstr(j.resource.with({query:null,fragment:null}))?!0:j.isDirectory&&l?q===1:!1))}async t(r,t,n,s,o,l){const{providerExtUri:O}=this.R(r),I={resource:t,name:O.basename(t),isFile:(n.type&v.FileType.File)!==0,isDirectory:(n.type&v.FileType.Directory)!==0,isSymbolicLink:(n.type&v.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:!!((n.permissions??0)&v.FilePermission.Readonly)||!!(r.capabilities&2048),locked:!!((n.permissions??0)&v.FilePermission.Locked),etag:(0,v.$_k)({mtime:n.mtime,size:n.size}),children:void 0};if(I.isDirectory&&l(I,s)){try{const b=await r.readdir(t),j=await D.Promises.settled(b.map(async([q,Y])=>{try{const K=O.joinPath(t,q),oe=o?await r.stat(K):{type:Y};return await this.t(r,K,oe,b.length,o,l)}catch(K){return this.b.trace(K),null}}));I.children=(0,N.$Hb)(j)}catch(b){this.b.trace(b),I.children=[]}return I}return I}async resolveAll(r){return D.Promises.settled(r.map(async t=>{try{return{stat:await this.s(t.resource,t.options),success:!0}}catch(n){return this.b.trace(n),{stat:void 0,success:!1}}}))}async stat(r){const t=await this.j(r),n=await t.stat(r);return this.t(t,r,n,void 0,!0,()=>!1)}async exists(r){const t=await this.j(r);try{return!!await t.stat(r)}catch{return!1}}async canCreateFile(r,t){try{await this.u(r,t)}catch(n){return n}return!0}async u(r,t){if(!t?.overwrite&&await this.exists(r))throw new v.$1k((0,k.localize)(3,null,this.sb(r)),3,t)}async createFile(r,t=R.$se.fromString(""),n){await this.u(r,n);const s=await this.writeFile(r,t);return this.r.fire(new v.$Xk(r,0,s)),s}async writeFile(r,t,n){const s=this.qb(await this.n(r),r),{providerExtUri:o}=this.R(s);let l=n;if((0,v.$Ok)(s)&&!l?.atomic){const O=s.enforceAtomicWriteFile?.(r);O&&(l={...n,atomic:O})}try{await this.w(s,r,l)||await this.U(s,o.dirname(r));let I;if((0,v.$Ik)(s)&&!(t instanceof R.$se))if((0,w.$ee)(t)){const b=await(0,w.$le)(t,3);b.ended?I=R.$se.concat(b.buffer):I=b}else I=(0,w.$ie)(t,b=>R.$se.concat(b),3);else I=t;!(0,v.$Lk)(s)||(0,v.$Ik)(s)&&I instanceof R.$se||(0,v.$Ik)(s)&&(0,v.$Ok)(s)&&l?.atomic?await this.hb(s,r,l,I):await this.db(s,r,l,I instanceof R.$se?(0,R.$De)(I):I),this.r.fire(new v.$Xk(r,4))}catch(O){throw new v.$1k((0,k.localize)(4,null,this.sb(r),(0,v.$Tk)(O).toString()),(0,v.$Wk)(O),l)}return this.resolve(r,{resolveMetadata:!0})}async w(r,t,n){const s=!!n?.unlock;if(s&&!(r.capabilities&8192))throw new Error((0,k.localize)(5,null,this.sb(t)));if(!!n?.atomic){if(!(r.capabilities&32768))throw new Error((0,k.localize)(6,null,this.sb(t)));if(!(r.capabilities&2))throw new Error((0,k.localize)(7,null,this.sb(t)));if(s)throw new Error((0,k.localize)(8,null,this.sb(t)))}let l;try{l=await r.stat(t)}catch{return}if(l.type&v.FileType.Directory)throw new v.$1k((0,k.localize)(9,null,this.sb(t)),0,n);if(this.rb(t,l),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==v.$$k&&typeof l.mtime=="number"&&typeof l.size=="number"&&n.mtime<l.mtime&&n.etag!==(0,v.$_k)({mtime:n.mtime,size:l.size}))throw new v.$1k((0,k.localize)(10,null),3,n);return l}async readFile(r,t,n){const s=await this.m(r);return t?.atomic?this.z(s,r,t,n):this.C(s,r,t,n)}async z(r,t,n,s){return new Promise((o,l)=>{this.cb.queueFor(t,async()=>{try{const O=await this.C(r,t,n,s);o(O)}catch(O){l(O)}},this.R(r).providerExtUri)})}async C(r,t,n,s){const o=await this.D(r,t,{...n,preferUnbuffered:!0},s);return{...o,value:await(0,R.$Ee)(o.value)}}async readFileStream(r,t,n){const s=await this.m(r);return this.D(s,r,t,n)}async D(r,t,n,s){const o=new L.$ce(s);let l=n;(0,v.$Nk)(r)&&r.enforceAtomicReadFile?.(t)&&(l={...n,atomic:!0});const O=this.J(t,l).then(b=>b,b=>{throw o.dispose(!0),b});let I;try{return typeof l?.etag=="string"&&l.etag!==v.$$k&&await O,l?.atomic&&(0,v.$Nk)(r)||!((0,v.$Lk)(r)||(0,v.$Mk)(r))||(0,v.$Ik)(r)&&l?.preferUnbuffered?I=this.I(r,t,l):(0,v.$Mk)(r)?I=this.G(r,t,o.token,l):I=this.H(r,t,o.token,l),I.on("end",()=>o.dispose()),I.on("error",()=>o.dispose()),{...await O,value:I}}catch(b){throw I&&await(0,w.$je)(I),this.F(b,t,l)}}F(r,t,n){const s=(0,k.localize)(11,null,this.sb(t),(0,v.$Tk)(r).toString());return r instanceof v.$3k?new v.$3k(s,r.stat,n):r instanceof v.$2k?new v.$2k(s,r.fileOperationResult,r.size,r.options):new v.$1k(s,(0,v.$Wk)(r),n)}G(r,t,n,s=Object.create(null)){const o=r.readFileStream(t,s,n);return(0,w.$pe)(o,{data:l=>l instanceof R.$se?l:R.$se.wrap(l),error:l=>this.F(l,t,s)},l=>R.$se.concat(l))}H(r,t,n,s=Object.create(null)){const o=(0,R.$Ie)();return(0,c.$pq)(r,t,o,l=>l,{...s,bufferSize:this.a,errorTransformer:l=>this.F(l,t,s)},n),o}I(r,t,n){const s=(0,w.$ge)(o=>R.$se.concat(o));return(async()=>{try{let o;n?.atomic&&(0,v.$Nk)(r)?o=await r.readFile(t,{atomic:!0}):o=await r.readFile(t),typeof n?.position=="number"&&(o=o.slice(n.position)),typeof n?.length=="number"&&(o=o.slice(0,n.length)),this.L(t,o.byteLength,n),s.end(R.$se.wrap(o))}catch(o){s.error(o),s.end()}})(),s}async J(r,t){const n=await this.resolve(r,{resolveMetadata:!0});if(n.isDirectory)throw new v.$1k((0,k.localize)(12,null,this.sb(r)),0,t);if(typeof t?.etag=="string"&&t.etag!==v.$$k&&t.etag===n.etag)throw new v.$3k((0,k.localize)(13,null),n,t);return this.L(r,n.size,t),n}L(r,t,n){if(typeof n?.limits?.size=="number"&&t>n.limits.size)throw new v.$2k((0,k.localize)(14,null,this.sb(r)),7,t,n)}async canMove(r,t,n){return this.M(r,t,"move",n)}async canCopy(r,t,n){return this.M(r,t,"copy",n)}async M(r,t,n,s){if(r.toString()!==t.toString())try{const o=n==="move"?this.qb(await this.n(r),r):await this.m(r),l=this.qb(await this.n(t),t);await this.Q(o,r,l,t,n,s)}catch(o){return o}return!0}async move(r,t,n){const s=this.qb(await this.n(r),r),o=this.qb(await this.n(t),t),l=await this.N(s,r,o,t,"move",!!n),O=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new v.$Xk(r,l==="move"?2:3,O)),O}async copy(r,t,n){const s=await this.m(r),o=this.qb(await this.n(t),t),l=await this.N(s,r,o,t,"copy",!!n),O=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new v.$Xk(r,l==="copy"?3:2,O)),O}async N(r,t,n,s,o,l){if(t.toString()===s.toString())return o;const{exists:O,isSameResourceWithDifferentPathCase:I}=await this.Q(r,t,n,s,o,l);if(O&&!I&&l&&await this.del(s,{recursive:!0}),await this.U(n,this.R(n).providerExtUri.dirname(s)),o==="copy"){if(r===n&&(0,v.$Jk)(r))await r.copy(t,s,{overwrite:l});else{const b=await this.resolve(t);b.isDirectory?await this.P(r,b,n,s):await this.O(r,t,n,s)}return o}else return r===n?(await r.rename(t,s,{overwrite:l}),o):(await this.N(r,t,n,s,"copy",l),await this.del(t,{recursive:!0}),"copy")}async O(r,t,n,s){if((0,v.$Lk)(r)&&(0,v.$Lk)(n))return this.jb(r,t,n,s);if((0,v.$Lk)(r)&&(0,v.$Ik)(n))return this.pb(r,t,n,s);if((0,v.$Ik)(r)&&(0,v.$Lk)(n))return this.nb(r,t,n,s);if((0,v.$Ik)(r)&&(0,v.$Ik)(n))return this.lb(r,t,n,s)}async P(r,t,n,s){await n.mkdir(s),Array.isArray(t.children)&&await D.Promises.settled(t.children.map(async o=>{const l=this.R(n).providerExtUri.joinPath(s,o.name);return o.isDirectory?this.P(r,await this.resolve(o.resource),n,l):this.O(r,o.resource,n,l)}))}async Q(r,t,n,s,o,l){let O=!1;if(r===n){const{providerExtUri:b,isPathCaseSensitive:j}=this.R(r);if(j||(O=b.isEqual(t,s)),O&&o==="copy")throw new Error((0,k.localize)(15,null,this.sb(t),this.sb(s)));if(!O&&b.isEqualOrParent(s,t))throw new Error((0,k.localize)(16,null,this.sb(t),this.sb(s)))}const I=await this.exists(s);if(I&&!O){if(!l)throw new v.$1k((0,k.localize)(17,null,this.sb(t),this.sb(s)),4);if(r===n){const{providerExtUri:b}=this.R(r);if(b.isEqualOrParent(t,s))throw new Error((0,k.localize)(18,null,this.sb(t),this.sb(s)))}}return{exists:I,isSameResourceWithDifferentPathCase:O}}R(r){const t=this.S(r);return{providerExtUri:t?m.$Ig:m.$Kg,isPathCaseSensitive:t}}S(r){return!!(r.capabilities&1024)}async createFolder(r){const t=this.qb(await this.j(r),r);await this.U(t,r);const n=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new v.$Xk(r,0,n)),n}async U(r,t){const n=[],{providerExtUri:s}=this.R(r);for(;!s.isEqual(t,s.dirname(t));)try{if(!((await r.stat(t)).type&v.FileType.Directory))throw new Error((0,k.localize)(19,null,this.sb(t)));break}catch(o){if((0,v.$Vk)(o)!==v.FileSystemProviderErrorCode.FileNotFound)throw o;n.push(s.basename(t)),t=s.dirname(t)}for(let o=n.length-1;o>=0;o--){t=s.joinPath(t,n[o]);try{await r.mkdir(t)}catch(l){if((0,v.$Vk)(l)!==v.FileSystemProviderErrorCode.FileExists)throw l}}}async canDelete(r,t){try{await this.W(r,t)}catch(n){return n}return!0}async W(r,t){const n=this.qb(await this.j(r),r),s=!!t?.useTrash;if(s&&!(n.capabilities&4096))throw new Error((0,k.localize)(20,null,this.sb(r)));const o=t?.atomic;if(o&&!(n.capabilities&65536))throw new Error((0,k.localize)(21,null,this.sb(r)));if(s&&o)throw new Error((0,k.localize)(22,null,this.sb(r)));let l;try{l=await n.stat(r)}catch{}if(l)this.rb(r,l);else throw new v.$1k((0,k.localize)(23,null,this.sb(r)),1);if(!!!t?.recursive){const I=await this.resolve(r);if(I.isDirectory&&Array.isArray(I.children)&&I.children.length>0)throw new Error((0,k.localize)(24,null,this.sb(r)))}return n}async del(r,t){const n=await this.W(r,t);let s=t;if((0,v.$Pk)(n)&&!s?.atomic){const I=n.enforceAtomicDelete?.(r);I&&(s={...t,atomic:I})}const o=!!s?.useTrash,l=!!s?.recursive,O=s?.atomic??!1;await n.delete(r,{recursive:l,useTrash:o,atomic:O}),this.r.fire(new v.$Xk(r,1))}async cloneFile(r,t){const n=await this.j(r),s=this.qb(await this.n(t),t);if(!(n===s&&this.R(n).providerExtUri.isEqual(r,t)))return n===s&&(0,v.$Kk)(n)?n.cloneFile(r,t):(await this.U(s,this.R(s).providerExtUri.dirname(t)),n===s&&(0,v.$Jk)(n)?this.cb.queueFor(r,()=>n.copy(r,t,{overwrite:!0}),this.R(n).providerExtUri):this.cb.queueFor(r,()=>this.O(n,r,s,t),this.R(n).providerExtUri))}static{this.ab=0}createWatcher(r,t){return this.watch(r,{...t,correlationId:h.ab++})}watch(r,t={recursive:!1,excludes:[]}){const n=new a.$Sc;let s=!1,o=()=>{s=!0};n.add((0,a.$Rc)(()=>o())),(async()=>{try{const O=await this.bb(r,t);s?(0,a.$Oc)(O):o=()=>(0,a.$Oc)(O)}catch(O){this.b.error(O)}})();const l=t.correlationId;if(typeof l=="number"){const O=n.add(new A.$5d);return n.add(this.X.event(b=>{b.correlates(l)&&O.fire(b)})),{onDidChange:O.event,dispose:()=>n.dispose()}}return n}async bb(r,t){const n=await this.j(r),s=(0,S.$6i)([this.R(n).providerExtUri.getComparisonKey(r),t]);let o=this.$.get(s);return o||(o={count:0,disposable:n.watch(r,t)},this.$.set(s,o)),o.count+=1,(0,a.$Rc)(()=>{o&&(o.count--,o.count===0&&((0,a.$Oc)(o.disposable),this.$.delete(s)))})}dispose(){super.dispose();for(const[,r]of this.$)(0,a.$Oc)(r.disposable);this.$.clear()}async db(r,t,n,s){return this.cb.queueFor(t,async()=>{const o=await r.open(t,{create:!0,unlock:n?.unlock??!1});try{(0,w.$ee)(s)||(0,w.$fe)(s)?await this.eb(r,o,s):await this.fb(r,o,s)}catch(l){throw(0,v.$Tk)(l)}finally{await r.close(o)}},this.R(r).providerExtUri)}async eb(r,t,n){let s=0,o;if((0,w.$fe)(n)){if(n.buffer.length>0){const l=R.$se.concat(n.buffer);await this.gb(r,t,l,l.byteLength,s,0),s+=l.byteLength}if(n.ended)return;o=n.stream}else o=n;return new Promise((l,O)=>{(0,w.$ke)(o,{onData:async I=>{o.pause();try{await this.gb(r,t,I,I.byteLength,s,0)}catch(b){return O(b)}s+=I.byteLength,setTimeout(()=>o.resume())},onError:I=>O(I),onEnd:()=>l()})})}async fb(r,t,n){let s=0,o;for(;(o=n.read())!==null;)await this.gb(r,t,o,o.byteLength,s,0),s+=o.byteLength}async gb(r,t,n,s,o,l){let O=0;for(;O<s;){const I=await r.write(t,o+O,n.buffer,l+O,s-O);O+=I}}async hb(r,t,n,s){return this.cb.queueFor(t,()=>this.ib(r,t,n,s),this.R(r).providerExtUri)}async ib(r,t,n,s){let o;s instanceof R.$se?o=s:(0,w.$ee)(s)?o=await(0,R.$Ee)(s):(0,w.$fe)(s)?o=await(0,R.$Fe)(s):o=(0,R.$Ce)(s),await r.writeFile(t,o.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1,atomic:n?.atomic??!1})}async jb(r,t,n,s){return this.cb.queueFor(s,()=>this.kb(r,t,n,s),this.R(n).providerExtUri)}async kb(r,t,n,s){let o,l;try{o=await r.open(t,{create:!1}),l=await n.open(s,{create:!0,unlock:!1});const O=R.$se.alloc(this.a);let I=0,b=0,j=0;do j=await r.read(o,I,O.buffer,b,O.byteLength-b),await this.gb(n,l,O,j,I,b),I+=j,b+=j,b===O.byteLength&&(b=0);while(j>0)}catch(O){throw(0,v.$Tk)(O)}finally{await D.Promises.settled([typeof o=="number"?r.close(o):Promise.resolve(),typeof l=="number"?n.close(l):Promise.resolve()])}}async lb(r,t,n,s){return this.cb.queueFor(s,()=>this.mb(r,t,n,s),this.R(n).providerExtUri)}async mb(r,t,n,s){return n.writeFile(s,await r.readFile(t),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(r,t,n,s){return this.cb.queueFor(s,()=>this.ob(r,t,n,s),this.R(n).providerExtUri)}async ob(r,t,n,s){const o=await n.open(s,{create:!0,unlock:!1});try{const l=await r.readFile(t);await this.gb(n,o,R.$se.wrap(l),l.byteLength,0,0)}catch(l){throw(0,v.$Tk)(l)}finally{await n.close(o)}}async pb(r,t,n,s){const o=await(0,R.$Ee)(this.H(r,t,L.CancellationToken.None));await this.hb(n,s,void 0,o)}qb(r,t){if(r.capabilities&2048)throw new v.$1k((0,k.localize)(25,null,this.sb(t)),6);return r}rb(r,t){if((t.permissions??0)&v.FilePermission.Readonly)throw new v.$1k((0,k.localize)(26,null,this.sb(r)),6)}sb(r){return r.scheme===E.Schemas.file?r.fsPath:r.toString(!0)}};e.$qq=g,e.$qq=g=h=me([se(0,p.$zj)],g)}),define(ie[128],ne([0,1,90,171,9,31,14,6,172,2,16,12,17,46,24,104,13,60,125,34,123,122]),function(J,e,N,D,R,L,A,S,u,a,y,E,d,m,w,k,v,c,p,$,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=void 0,(()=>{try{(0,D.gracefulify)(N)}catch(r){console.error(`Error enabling graceful-fs: ${(0,$.$3i)(r)}`)}})();class i extends p.$zq{static{this.I=!1}constructor(t,n){super(t,n),this.onDidChangeCapabilities=S.Event.None,this.N=new L.$Ac(s=>d.$Jg.getComparisonKey(s)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,E.$k&&(this.J|=1024)),this.J}async stat(t){try{const{stat:n,symbolicLink:s}=await w.SymlinkSupport.stat(this.H(t));return{type:this.M(n,s),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:v.FilePermission.Locked}}catch(n){throw this.fb(n)}}async L(t){try{return await this.stat(t)}catch{return}}async readdir(t){try{const n=await w.Promises.readdir(this.H(t),{withFileTypes:!0}),s=[];return await Promise.all(n.map(async o=>{try{let l;o.isSymbolicLink()?l=(await this.stat((0,d.$Sg)(t,o.name))).type:l=this.M(o),s.push([o.name,l])}catch(l){this.a.trace(l)}})),s}catch(n){throw this.fb(n)}}M(t,n){let s;return n?.dangling?s=v.FileType.Unknown:t.isFile()?s=v.FileType.File:t.isDirectory()?s=v.FileType.Directory:s=v.FileType.Unknown,n&&(s|=v.FileType.SymbolicLink),s}async O(t){const n=this.H(t);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let s;for(;s=this.N.get(t);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await s.wait();const o=new R.$eh;return this.N.set(t,o),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,a.$Rc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.N.get(t)===o&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.N.delete(t)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),o.open()})}async readFile(t,n){let s;try{n?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(t)})`),s=await this.O(t));const o=this.H(t);return await w.Promises.readFile(o)}catch(o){throw this.fb(o)}finally{s?.dispose()}}P(t){i.I&&this.a.trace(t)}readFileStream(t,n,s){const o=(0,m.$ge)(l=>A.$se.concat(l.map(O=>A.$se.wrap(O))).buffer);return(0,c.$pq)(this,t,o,l=>l.buffer,{...n,bufferSize:256*1024},s),o}async writeFile(t,n,s){return s?.atomic!==!1&&s?.atomic?.postfix&&await this.Q(t)?this.R(t,(0,d.$Sg)((0,d.$Rg)(t),`${(0,d.$Pg)(t)}${s.atomic.postfix}`),n,s):this.S(t,n,s)}async Q(t){try{const n=this.H(t),{symbolicLink:s}=await w.SymlinkSupport.stat(n);if(s)return!1}catch{}return!0}async R(t,n,s,o){const l=new a.$Sc;try{l.add(await this.O(t)),l.add(await this.O(n)),await this.S(n,s,o,!0);try{await this.rename(n,t,{overwrite:!0})}catch(O){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw O}}finally{l.dispose()}}async S(t,n,s,o){let l;try{const O=this.H(t);if(!s.create||!s.overwrite){if(await w.Promises.exists(O)){if(!s.overwrite)throw(0,v.$Sk)((0,k.localize)(0,null),v.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,v.$Sk)((0,k.localize)(1,null),v.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(t,{create:!0,unlock:s.unlock},o),await this.write(l,0,n,0,n.byteLength)}catch(O){throw await this.gb(t,O)}finally{typeof l=="number"&&await this.close(l)}}static{this.Y=!0}static configureFlushOnWrite(t){i.Y=t}async open(t,n,s){const o=this.H(t);let l;(0,v.$Gk)(n)&&!s&&(l=await this.O(t));let O;try{if((0,v.$Gk)(n)&&n.unlock)try{const{stat:b}=await w.SymlinkSupport.stat(o);b.mode&128||await w.Promises.chmod(o,b.mode|128)}catch(b){b.code!=="ENOENT"&&this.a.trace(b)}let I;if((0,v.$Gk)(n)){if(E.$i)try{await w.Promises.truncate(o,0),I="r+"}catch(b){b.code!=="ENOENT"&&this.a.trace(b)}I||(I="w")}else I="r";O=await w.Promises.open(o,I)}catch(I){throw l?.dispose(),(0,v.$Gk)(n)?await this.gb(t,I):this.fb(I)}if(this.U.set(O,0),(0,v.$Gk)(n)&&this.X.set(O,t),l){const I=this.W.get(O);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${O} (${o})`),this.W.set(O,l),I&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${O} (${o})`),I.dispose())}return O}async close(t){const n=this.W.get(t);try{if(this.U.delete(t),this.X.delete(t)&&i.Y)try{await w.Promises.fdatasync(t)}catch(s){i.configureFlushOnWrite(!1),this.a.error(s)}return await w.Promises.close(t)}catch(s){throw this.fb(s)}finally{n&&(this.W.get(t)===n&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.W.delete(t)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),n.dispose())}}async read(t,n,s,o,l){const O=this.Z(t,n);let I=null;try{I=(await w.Promises.read(t,s,o,l,O)).bytesRead}catch(b){throw this.fb(b)}finally{this.$(t,O,I)}return I}Z(t,n){return n===this.U.get(t)?null:n}$(t,n,s){const o=this.U.get(t);typeof o=="number"&&(typeof n=="number"||(typeof s=="number"?this.U.set(t,o+s):this.U.delete(t)))}async write(t,n,s,o,l){return(0,R.$zh)(()=>this.ab(t,n,s,o,l),100,3)}async ab(t,n,s,o,l){const O=this.Z(t,n);let I=null;try{I=(await w.Promises.write(t,s,o,l,O)).bytesWritten}catch(b){throw await this.gb(this.X.get(t),b)}finally{this.$(t,O,I)}return I}async mkdir(t){try{await w.Promises.mkdir(this.H(t))}catch(n){throw this.fb(n)}}async delete(t,n){try{const s=this.H(t);if(n.recursive){let o;n?.atomic!==!1&&n.atomic.postfix&&(o=(0,y.$jc)((0,y.$mc)(s),`${(0,y.$nc)(s)}${n.atomic.postfix}`)),await w.Promises.rm(s,w.RimRafMode.MOVE,o)}else try{await w.Promises.unlink(s)}catch(o){if(o.code==="EPERM"||o.code==="EISDIR"){let l=!1;try{const{stat:O,symbolicLink:I}=await w.SymlinkSupport.stat(s);l=O.isDirectory()&&!I}catch{}if(l)await w.Promises.rmdir(s);else throw o}else throw o}}catch(s){throw this.fb(s)}}async rename(t,n,s){const o=this.H(t),l=this.H(n);if(o!==l)try{await this.bb(t,n,"move",s.overwrite),await w.Promises.rename(o,l)}catch(O){throw(O.code==="EINVAL"||O.code==="EBUSY"||O.code==="ENAMETOOLONG")&&(O=new Error((0,k.localize)(2,null,(0,y.$nc)(o),(0,y.$nc)((0,y.$mc)(l)),O.toString()))),this.fb(O)}}async copy(t,n,s){const o=this.H(t),l=this.H(n);if(o!==l)try{await this.bb(t,n,"copy",s.overwrite),await w.Promises.copy(o,l,{preserveSymlinks:!0})}catch(O){throw(O.code==="EINVAL"||O.code==="EBUSY"||O.code==="ENAMETOOLONG")&&(O=new Error((0,k.localize)(3,null,(0,y.$nc)(o),(0,y.$nc)((0,y.$mc)(l)),O.toString()))),this.fb(O)}}async bb(t,n,s,o){const l=this.H(t),O=this.H(n);let I=!1;if(!!(this.capabilities&1024)||(I=(0,u.$eg)(l,O,!0)),I){if(s==="copy")throw(0,v.$Sk)((0,k.localize)(4,null),v.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const j=await this.L(t);if(!j)throw(0,v.$Sk)((0,k.localize)(5,null),v.FileSystemProviderErrorCode.FileNotFound);const q=await this.L(n);if(q){if(!o)throw(0,v.$Sk)((0,k.localize)(6,null),v.FileSystemProviderErrorCode.FileExists);j.type&v.FileType.File&&q.type&v.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(t,n){return this.cb(t,n,!1)}async cb(t,n,s){const o=this.H(t),l=this.H(n),O=!!(this.capabilities&1024);if((0,u.$eg)(o,l,!O))return;const I=new a.$Sc;try{I.add(await this.O(t)),I.add(await this.O(n)),s&&await w.Promises.mkdir((0,y.$mc)(l),{recursive:!0}),await w.Promises.copyFile(o,l)}catch(b){if(b.code==="ENOENT"&&!s)return this.cb(t,n,!0);throw this.fb(b)}finally{I.dispose()}}t(t,n,s){return new h.$Gq(o=>t(o),o=>n(o),s)}F(t,n,s){return new g.$Oq(o=>t(o),o=>n(o),s)}fb(t){if(t instanceof v.$Rk)return t;let n=t,s;switch(t.code){case"ENOENT":s=v.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=v.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=v.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=v.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=v.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${t.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=v.FileSystemProviderErrorCode.Unknown;break;default:s=v.FileSystemProviderErrorCode.Unknown}return(0,v.$Sk)(n,s)}async gb(t,n){let s=this.fb(n);if(t&&s.code===v.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await w.SymlinkSupport.stat(this.H(t));o.mode&128||(s=(0,v.$Sk)(n,v.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.a.trace(o)}return s}}e.$Pq=i}),define(ie[129],ne([0,1,2,4]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IP=void 0;class R extends N.$Tc{constructor(A,S=[]){super(),this.a=new D.$Jj([A,...S]),this.B(A.onDidChangeLogLevel(u=>this.setLevel(u)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...S){this.a.trace(A,...S)}debug(A,...S){this.a.debug(A,...S)}info(A,...S){this.a.info(A,...S)}warn(A,...S){this.a.warn(A,...S)}error(A,...S){this.a.error(A,...S)}flush(){this.a.flush()}}e.$IP=R}),define(ie[130],ne([0,1,13,4]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xP=void 0;var R;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(R||(R={}));async function L(a,y,E,d,m){try{const w=await new Promise((v,c)=>{J(["@vscode/spdlog"],v,c)});w.setFlushOn(R.Trace);const k=await w.createAsyncRotatingLogger(a,y,E,d);return m?k.clearFormatters():k.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),k}catch(w){console.error(w)}return null}function A(a,y,E){switch(y){case D.LogLevel.Trace:a.trace(E);break;case D.LogLevel.Debug:a.debug(E);break;case D.LogLevel.Info:a.info(E);break;case D.LogLevel.Warning:a.warn(E);break;case D.LogLevel.Error:a.error(E);break;case D.LogLevel.Off:break;default:throw new Error(`Invalid log level ${y}`)}}function S(a,y){switch(y){case D.LogLevel.Trace:a.setLevel(R.Trace);break;case D.LogLevel.Debug:a.setLevel(R.Debug);break;case D.LogLevel.Info:a.setLevel(R.Info);break;case D.LogLevel.Warning:a.setLevel(R.Warning);break;case D.LogLevel.Error:a.setLevel(R.Error);break;case D.LogLevel.Off:a.setLevel(R.Off);break;default:throw new Error(`Invalid log level ${y}`)}}class u extends D.$Fj{constructor(y,E,d,m,w){super(),this.m=[],this.setLevel(w),this.n=this.s(y,E,d,m),this.B(this.onDidChangeLogLevel(k=>{this.r&&S(this.r,k)}))}async s(y,E,d,m){const w=d?6:1,k=30/w*N.$bl.MB,v=await L(y,E,k,w,m);if(v){this.r=v,S(this.r,this.getLevel());for(const{level:c,message:p}of this.m)A(this.r,c,p);this.m=[]}}g(y,E){this.r?A(this.r,y,E):this.getLevel()<=y&&this.m.push({level:y,message:E})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$xP=u}),define(ie[131],ne([0,1,28,4,130]),function(J,e,N,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yP=void 0;class L extends D.$Kj{s(S,u,a){return new R.$xP((0,N.$Bg)(),S.fsPath,!a?.donotRotate,!!a?.donotUseFormatters,u)}}e.$yP=L}),define(ie[39],ne([0,1,6,65,2,10]),function(J,e,N,D,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1n=e.$Zn=e.$Yn=void 0,e.$Yn=(0,L.$fi)("policy");class A extends R.$Tc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new N.$5d),this.onDidChange=this.h.event}async updatePolicyDefinitions(a){const y=Object.keys(this.f).length;return this.f={...a,...this.f},y!==Object.keys(this.f).length&&await this.j(a),D.Iterable.reduce(this.g.entries(),(E,[d,m])=>({...E,[d]:m}),{})}getPolicyValue(a){return this.g.get(a)}serialize(){return D.Iterable.reduce(Object.entries(this.f),(a,[y,E])=>({...a,[y]:{definition:E,value:this.g.get(y)}}),{})}}e.$Zn=A;class S{constructor(){this.onDidChange=N.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$1n=S}),define(ie[132],ne([0,1,9,6,65,3,13,4,39]),function(J,e,N,D,R,L,A,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kac=void 0;function a(E,d){const m=[];for(const w of new Set(R.Iterable.concat(E.keys(),d.keys())))E.get(w)!==d.get(w)&&m.push(w);return m}let y=class extends u.$Zn{constructor(d,m,w){super(),this.m=d,this.n=m,this.s=w,this.c=this.B(new N.$dh(500));const k=D.Event.filter(m.onDidFilesChange,v=>v.affects(d));this.B(m.watch(d)),this.B(k(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const d=new Map;try{const m=await this.n.readFile(this.m),w=JSON.parse(m.value.toString());if(!(0,L.$Uf)(w))throw new Error("Policy file isn't a JSON object");for(const k of Object.keys(w))this.f[k]&&d.set(k,w[k])}catch(m){m.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",m)}return d}async w(){const d=await this.u(),m=a(this.g,d);this.g=d,m.length>0&&this.h.fire(m)}};e.$Kac=y,e.$Kac=y=me([se(1,A.$Fk),se(2,S.$zj)],y)}),define(ie[133],ne([0,1,39,9,2,4]),function(J,e,N,D,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jac=void 0;let A=class extends N.$Zn{constructor(u,a){super(),this.m=u,this.n=a,this.a=new D.$_g,this.b=this.B(new R.$Uc)}async j(u){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(u).length} policy definitions`);const{createWatcher:a}=await new Promise((y,E)=>{J(["@vscode/policy-watcher"],y,E)});await this.a.queue(()=>new Promise((y,E)=>{try{this.b.value=a(this.n,u,d=>{this.t(d),y()})}catch(d){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",d),E(d)}}))}t(u){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(u)}`);for(const a in u){const y=u[a];y===void 0?this.g.delete(a):this.g.set(a,y)}this.h.fire(Object.keys(u))}};e.$Jac=A,e.$Jac=A=me([se(0,L.$zj)],A)}),define(ie[32],ne([0,1,10]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=e.$Rj=void 0,e.$Rj=(0,N.$fi)("productService"),e.$Sj="vscode://schemas/vscode-product"}),define(ie[36],ne([0,1,71,3]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wn=void 0;class R{constructor(){this.a=new Map}add(A,S){N.ok(D.$Sf(A)),N.ok(D.$Uf(S)),N.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,S)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$Wn=new R}),define(ie[134],ne([0,1,6,36]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xn=void 0,e.$Xn={JSONContribution:"base.contributions.json"};function R(S){return S.length>0&&S.charAt(S.length-1)==="#"?S.substring(0,S.length-1):S}class L{constructor(){this.b=new N.$5d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(u,a){this.a[R(u)]=a,this.b.fire(u)}notifySchemaChanged(u){this.b.fire(u)}getSchemaContributions(){return{schemas:this.a}}}const A=new L;D.$Wn.add(e.$Xn.JSONContribution,A)}),define(ie[40],ne([0,1,19,6,3,91,29,134,36]),function(J,e,N,D,R,L,A,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.ConfigurationScope=e.$2n=e.EditPresentationTypes=void 0;var a;(function(g){g.Multiline="multilineText",g.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.$2n={Configuration:"base.contributions.configuration"};var y;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.MACHINE=2]="MACHINE",g[g.WINDOW=3]="WINDOW",g[g.RESOURCE=4]="RESOURCE",g[g.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",g[g.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(y||(e.ConfigurationScope=y={})),e.$3n={properties:{},patternProperties:{}},e.$4n={properties:{},patternProperties:{}},e.$5n={properties:{},patternProperties:{}},e.$6n={properties:{},patternProperties:{}},e.$7n={properties:{},patternProperties:{}},e.$8n={properties:{},patternProperties:{}},e.$9n="vscode://schemas/settings/resourceLanguage",e.$0n="vscode://schemas/settings/configurationDefaults";const E=u.$Wn.as(S.$Xn.JSONContribution);class d{constructor(){this.h=new Set,this.i=new D.$5d,this.onDidSchemaChange=this.i.event,this.j=new D.$5d,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},E.registerSchema(e.$9n,this.g),this.v()}registerConfiguration(i,r=!0){this.registerConfigurations([i],r)}registerConfigurations(i,r=!0){const t=new Set;this.n(i,r,t),E.registerSchema(e.$9n,this.g),this.i.fire(),this.j.fire({properties:t})}deregisterConfigurations(i){const r=new Set;this.o(i,r),E.registerSchema(e.$9n,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:i,remove:r}){const t=new Set;this.o(r,t),this.n(i,!1,t),E.registerSchema(e.$9n,this.g),this.i.fire(),this.j.fire({properties:t})}registerDefaultConfigurations(i){const r=new Set;this.k(i,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(i,r){const t=[];for(const{overrides:n,source:s}of i)for(const o in n)if(r.add(o),e.$_n.test(o)){const l=this.a.get(o),O=l?.valuesSources??new Map;if(s)for(const q of Object.keys(n[o]))O.set(q,s);const I={...l?.value||{},...n[o]};this.a.set(o,{source:s,value:I,valuesSources:O});const b=(0,A.$Vi)(o),j={type:"object",default:I,description:L.localize(1,null,b),$ref:e.$9n,defaultDefaultValue:I,source:R.$Sf(s)?void 0:s,defaultValueSource:s};t.push(...k(o)),this.d[o]=j,this.b.properties[o]=j}else{this.a.set(o,{value:n[o],source:s});const l=this.d[o];l&&(this.w(o,l),this.r(o,l))}this.m(t)}deregisterDefaultConfigurations(i){const r=new Set;this.l(i,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(i,r){for(const{overrides:t,source:n}of i)for(const s in t){const o=this.a.get(s),l=R.$Sf(n)?n:n?.id,O=R.$Sf(o?.source)?o?.source:o?.source?.id;if(l===O)if(r.add(s),this.a.delete(s),e.$_n.test(s))delete this.d[s],delete this.b.properties[s];else{const I=this.d[s];I&&(this.w(s,I),this.r(s,I))}}this.u()}deltaConfiguration(i){let r=!1;const t=new Set;i.removedDefaults&&(this.l(i.removedDefaults,t),r=!0),i.addedDefaults&&(this.k(i.addedDefaults,t),r=!0),i.removedConfigurations&&this.o(i.removedConfigurations,t),i.addedConfigurations&&this.n(i.addedConfigurations,!1,t),this.i.fire(),this.j.fire({properties:t,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const r of i)this.h.add(r);this.u()}n(i,r,t){i.forEach(n=>{this.p(n,r,n.extensionInfo,n.restrictedProperties,void 0,t),this.c.push(n),this.q(n)})}o(i,r){const t=n=>{if(n.properties)for(const s in n.properties){r.add(s);const o=this.d[s];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[s],this.s(s,n.properties[s])}n.allOf?.forEach(s=>t(s))};for(const n of i){t(n);const s=this.c.indexOf(n);s!==-1&&this.c.splice(s,1)}}p(i,r=!0,t,n,s=3,o){s=R.$2f(i.scope)?s:i.scope;const l=i.properties;if(l)for(const I in l){const b=l[I];if(r&&$(I,b)){delete l[I];continue}if(b.source=t,b.defaultDefaultValue=l[I].default,this.w(I,b),e.$_n.test(I)?b.scope=void 0:(b.scope=R.$2f(b.scope)?s:b.scope,b.restricted=R.$2f(b.restricted)?!!n?.includes(I):b.restricted),l[I].hasOwnProperty("included")&&!l[I].included){this.f[I]=l[I],delete l[I];continue}else this.d[I]=l[I],l[I].policy?.name&&this.e.set(l[I].policy.name,I);!l[I].deprecationMessage&&l[I].markdownDeprecationMessage&&(l[I].deprecationMessage=l[I].markdownDeprecationMessage),o.add(I)}const O=i.allOf;if(O)for(const I of O)this.p(I,r,t,n,s,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const r=t=>{const n=t.properties;if(n)for(const o in n)this.r(o,n[o]);t.allOf?.forEach(r)};r(i)}r(i,r){switch(e.$3n.properties[i]=r,r.scope){case 1:e.$4n.properties[i]=r;break;case 2:e.$5n.properties[i]=r;break;case 6:e.$6n.properties[i]=r;break;case 3:e.$7n.properties[i]=r;break;case 4:e.$8n.properties[i]=r;break;case 5:e.$8n.properties[i]=r,this.g.properties[i]=r;break}}s(i,r){switch(delete e.$3n.properties[i],r.scope){case 1:delete e.$4n.properties[i];break;case 2:delete e.$5n.properties[i];break;case 6:delete e.$6n.properties[i];break;case 3:delete e.$7n.properties[i];break;case 4:case 5:delete e.$8n.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const r=`[${i}]`,t={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.$9n};this.w(r,t),e.$3n.properties[r]=t,e.$4n.properties[r]=t,e.$5n.properties[r]=t,e.$6n.properties[r]=t,e.$7n.properties[r]=t,e.$8n.properties[r]=t}}v(){const i={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.$9n};e.$3n.patternProperties[e.$$n]=i,e.$4n.patternProperties[e.$$n]=i,e.$5n.patternProperties[e.$$n]=i,e.$6n.patternProperties[e.$$n]=i,e.$7n.patternProperties[e.$$n]=i,e.$8n.patternProperties[e.$$n]=i,this.i.fire()}w(i,r){const t=this.a.get(i);let n=t?.value,s=t?.source;R.$Zf(n)&&(n=r.defaultDefaultValue,s=void 0),R.$Zf(n)&&(n=c(r.type)),r.default=n,r.defaultValueSource=s}}const m="\\[([^\\]]+)\\]",w=new RegExp(m,"g");e.$$n=`^(${m})+$`,e.$_n=new RegExp(e.$$n);function k(g){const i=[];if(e.$_n.test(g)){let r=w.exec(g);for(;r?.length;){const t=r[1].trim();t&&i.push(t),r=w.exec(g)}}return(0,N.$Mb)(i)}e.$ao=k;function v(g){return g.reduce((i,r)=>`${i}[${r}]`,"")}e.$bo=v;function c(g){switch(Array.isArray(g)?g[0]:g){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$co=c;const p=new d;u.$Wn.add(e.$2n.Configuration,p);function $(g,i){return g.trim()?e.$_n.test(g)?L.localize(7,null,g):p.getConfigurationProperties()[g]!==void 0?L.localize(8,null,g):i.policy?.name&&p.getPolicyConfigurations().get(i.policy?.name)!==void 0?L.localize(9,null,g,i.policy?.name,p.getPolicyConfigurations().get(i.policy?.name)):null:L.localize(6,null)}e.$do=$;function h(){const g=[],i=p.getConfigurationProperties();for(const r of Object.keys(i))g.push([r,i[r].scope]);return g.push(["launch",4]),g.push(["task",4]),g}e.$eo=h}),define(ie[66],ne([0,1,19,6,38,2,31,27,3,11,29,40,36]),function(J,e,N,D,R,L,A,S,u,a,y,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=void 0;function m(r){return Object.isFrozen(r)?r:S.$Ln(r)}class w{constructor(t={},n=[],s=[],o){this.b=t,this.c=n,this.d=s,this.raw=o,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const t=this.raw.map(n=>{if(n instanceof w)return n;const s=new k("");return s.parseRaw(n),s.configurationModel});this.f=t.reduce((n,s)=>s===n?s:n.merge(s),t[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,y.$Ti)(this.contents,t):this.contents}inspect(t,n){const s=this;return{get value(){return m(s.rawConfiguration.getValue(t))},get override(){return n?m(s.rawConfiguration.getOverrideValue(t,n)):void 0},get merged(){return m(n?s.rawConfiguration.override(n).getValue(t):s.rawConfiguration.getValue(t))},get overrides(){const o=[];for(const{contents:l,identifiers:O,keys:I}of s.rawConfiguration.overrides){const b=new w(l,I).getValue(t);b!==void 0&&o.push({identifiers:O,value:b})}return o.length?m(o):void 0}}}getOverrideValue(t,n){const s=this.i(n);return s?t?(0,y.$Ti)(s,t):s:void 0}getKeysForOverrideIdentifier(t){const n=[];for(const s of this.overrides)s.identifiers.includes(t)&&n.push(...s.keys);return N.$Mb(n)}getAllOverrideIdentifiers(){const t=[];for(const n of this.overrides)t.push(...n.identifiers);return N.$Mb(t)}override(t){let n=this.a.get(t);return n||(n=this.g(t),this.a.set(t,n)),n}merge(...t){const n=S.$Kn(this.contents),s=S.$Kn(this.overrides),o=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const O of t)if(l.push(...O.raw?.length?O.raw:[O]),!O.isEmpty()){this.h(n,O.contents);for(const I of O.overrides){const[b]=s.filter(j=>N.$ub(j.identifiers,I.identifiers));b?(this.h(b.contents,I.contents),b.keys.push(...I.keys),b.keys=N.$Mb(b.keys)):s.push(S.$Kn(I))}for(const I of O.keys)o.indexOf(I)===-1&&o.push(I)}return new w(n,o,s,l.every(O=>O instanceof w)?void 0:l)}g(t){const n=this.i(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const s={};for(const o of N.$Mb([...Object.keys(this.contents),...Object.keys(n)])){let l=this.contents[o];const O=n[o];O&&(typeof l=="object"&&typeof O=="object"?(l=S.$Kn(l),this.h(l,O)):l=O),s[o]=l}return new w(s,this.keys,this.overrides)}h(t,n){for(const s of Object.keys(n)){if(s in t&&u.$Uf(t[s])&&u.$Uf(n[s])){this.h(t[s],n[s]);continue}t[s]=S.$Kn(n[s])}}i(t){let n=null,s=null;const o=l=>{l&&(s?this.h(s,l):s=S.$Kn(l))};for(const l of this.overrides)l.identifiers.length===1&&l.identifiers[0]===t?n=l.contents:l.identifiers.includes(t)&&o(l.contents);return o(n),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,n){this.j(t,n,!0)}setValue(t,n){this.j(t,n,!1)}removeValue(t){const n=this.keys.indexOf(t);n!==-1&&(this.keys.splice(n,1),(0,y.$Si)(this.contents,t),E.$_n.test(t)&&this.overrides.splice(this.overrides.findIndex(s=>N.$ub(s.identifiers,(0,E.$ao)(t))),1))}j(t,n,s){(0,y.$Ri)(this.contents,t,n,o=>console.error(o)),s=s||this.keys.indexOf(t)===-1,s&&this.keys.push(t),E.$_n.test(t)&&this.overrides.push({identifiers:(0,E.$ao)(t),keys:Object.keys(this.contents[t]),contents:(0,y.$Qi)(this.contents[t],o=>console.error(o))})}}e.$fo=w;class k{constructor(t){this.f=t,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new w}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,n){if(!u.$2f(t)){const s=this.g(t);this.parseRaw(s,n)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,n){this.a=t;const{contents:s,keys:o,overrides:l,restricted:O,hasExcludedProperties:I}=this.h(t,n);this.b=new w(s,o,l,I?[t]:void 0),this.c=O||[]}g(t){let n={},s=null,o=[];const l=[],O=[];function I(j){Array.isArray(o)?o.push(j):s!==null&&(o[s]=j)}const b={onObjectBegin:()=>{const j={};I(j),l.push(o),o=j,s=null},onObjectProperty:j=>{s=j},onObjectEnd:()=>{o=l.pop()},onArrayBegin:()=>{const j=[];I(j),l.push(o),o=j,s=null},onArrayEnd:()=>{o=l.pop()},onLiteralValue:I,onError:(j,q,Y)=>{O.push({error:j,offset:q,length:Y})}};if(t)try{R.$yn(t,b),n=o[0]||{}}catch(j){console.error(`Error while parsing settings file ${this.f}: ${j}`),this.d=[j]}return n}h(t,n){const s=d.$Wn.as(E.$2n.Configuration).getConfigurationProperties(),o=this.i(t,s,!0,n);t=o.raw;const l=(0,y.$Qi)(t,b=>console.error(`Conflict in settings file ${this.f}: ${b}`)),O=Object.keys(t),I=this.j(t,b=>console.error(`Conflict in settings file ${this.f}: ${b}`));return{contents:l,keys:O,overrides:I,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}i(t,n,s,o){let l=!1;if(!o?.scopes&&!o?.skipRestricted&&!o?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:l};const O={},I=[];for(const b in t)if(E.$_n.test(b)&&s){const j=this.i(t[b],n,!1,o);O[b]=j.raw,l=l||j.hasExcludedProperties,I.push(...j.restricted)}else{const j=n[b],q=j?typeof j.scope<"u"?j.scope:3:void 0;j?.restricted&&I.push(b),!o.exclude?.includes(b)&&(o.include?.includes(b)||(q===void 0||o.scopes===void 0||o.scopes.includes(q))&&!(o.skipRestricted&&j?.restricted))?O[b]=t[b]:l=!0}return{raw:O,restricted:I,hasExcludedProperties:l}}j(t,n){const s=[];for(const o of Object.keys(t))if(E.$_n.test(o)){const l={};for(const O in t[o])l[O]=t[o][O];s.push({identifiers:(0,E.$ao)(o),keys:Object.keys(l),contents:(0,y.$Qi)(l,n)})}return s}}e.$go=k;class v extends L.$Tc{constructor(t,n,s,o){super(),this.c=t,this.f=n,this.g=o,this.b=this.B(new D.$5d),this.onDidChange=this.b.event,this.a=new k(this.c.toString()),this.B(this.g.watch(s.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(D.Event.any(D.Event.filter(this.g.onDidFilesChange,l=>l.contains(this.c)),D.Event.filter(this.g.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&s.isEqual(l.resource,t)))(()=>this.b.fire()))}async loadConfiguration(){try{const t=await this.g.readFile(this.c);return this.a.parse(t.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new w}}reparse(t){return t&&(this.f=t),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$ho=v;class c{constructor(t,n,s,o,l,O,I,b,j,q,Y,K,oe){this.a=t,this.b=n,this.c=s,this.overrideIdentifiers=o,this.d=l,this.f=O,this.g=I,this.h=b,this.i=j,this.j=q,this.k=Y,this.l=K,this.m=oe}get value(){return m(this.c)}n(t){return t?.value!==void 0||t?.override!==void 0||t?.overrides!==void 0?t:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class p{constructor(t,n,s,o,l=new w,O=new w,I=new A.$Ac,b=new w,j=new A.$Ac){this.c=t,this.d=n,this.f=s,this.g=o,this.h=l,this.i=O,this.j=I,this.l=b,this.m=j,this.a=null,this.b=new A.$Ac,this.n=null}getValue(t,n,s){return this.p(t,n,s).getValue(t)}updateValue(t,n,s={}){let o;s.resource?(o=this.m.get(s.resource),o||(o=new w,this.m.set(s.resource,o))):o=this.l,n===void 0?o.removeValue(t):o.setValue(t,n),s.resource||(this.a=null)}inspect(t,n,s){const o=this.p(t,n,s),l=this.t(n.resource,s),O=n.resource?this.m.get(n.resource)||this.l:this.l,I=new Set;for(const b of o.overrides)for(const j of b.identifiers)o.getOverrideValue(t,j)!==void 0&&I.add(j);return new c(t,n,o.getValue(t),I.size?[...I]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this.i:void 0,l||void 0,O)}keys(t){const n=this.t(void 0,t);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(t){this.c=t,this.a=null,this.b.clear()}updatePolicyConfiguration(t){this.d=t}updateApplicationConfiguration(t){this.f=t,this.a=null,this.b.clear()}updateLocalUserConfiguration(t){this.g=t,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(t){this.h=t,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(t){this.i=t,this.a=null,this.b.clear()}updateFolderConfiguration(t,n){this.j.set(t,n),this.b.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this.b.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const s=[];if(!n){const{added:o,updated:l,removed:O}=g(this.c,t);n=[...o,...l,...O]}for(const o of n)for(const l of(0,E.$ao)(o)){const O=this.c.getKeysForOverrideIdentifier(l),I=t.getKeysForOverrideIdentifier(l),b=[...I.filter(j=>O.indexOf(j)===-1),...O.filter(j=>I.indexOf(j)===-1),...O.filter(j=>!S.$On(this.c.override(l).getValue(j),t.override(l).getValue(j)))];s.push([l,b])}return this.updateDefaultConfiguration(t),{keys:n,overrides:s}}compareAndUpdatePolicyConfiguration(t){const{added:n,updated:s,removed:o}=g(this.d,t),l=[...n,...s,...o];return l.length&&this.updatePolicyConfiguration(t),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:n,updated:s,removed:o,overrides:l}=g(this.applicationConfiguration,t),O=[...n,...s,...o];return O.length&&this.updateApplicationConfiguration(t),{keys:O,overrides:l}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:s,removed:o,overrides:l}=g(this.localUserConfiguration,t),O=[...n,...s,...o];return O.length&&this.updateLocalUserConfiguration(t),{keys:O,overrides:l}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:s,removed:o,overrides:l}=g(this.remoteUserConfiguration,t),O=[...n,...s,...o];return O.length&&this.updateRemoteUserConfiguration(t),{keys:O,overrides:l}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:s,removed:o,overrides:l}=g(this.workspaceConfiguration,t),O=[...n,...s,...o];return O.length&&this.updateWorkspaceConfiguration(t),{keys:O,overrides:l}}compareAndUpdateFolderConfiguration(t,n){const s=this.folderConfigurations.get(t),{added:o,updated:l,removed:O,overrides:I}=g(s,n),b=[...o,...l,...O];return(b.length||!s)&&this.updateFolderConfiguration(t,n),{keys:b,overrides:I}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:o,removed:l,overrides:O}=g(n,void 0);return{keys:[...s,...o,...l],overrides:O}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(t,n,s){let o=this.q(n,s);return n.overrideIdentifier&&(o=o.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(t)!==void 0&&(o=o.merge(this.d)),o}q({resource:t},n){let s=this.r();if(n&&t){const o=n.getFolder(t);o&&(s=this.s(o.uri)||s);const l=this.m.get(t);l&&(s=s.merge(l))}return s}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(t){let n=this.b.get(t);if(!n){const s=this.r(),o=this.j.get(t);o?(n=s.merge(o),this.b.set(t,n)):n=s}return n}t(t,n){if(n&&t){const s=n.getFolder(t);if(s)return this.j.get(s.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((t,n)=>{const{contents:s,overrides:o,keys:l}=this.j.get(n);return t.push([n,{contents:s,overrides:o,keys:l}]),t},[])}}allKeys(){const t=new Set;return this.c.keys.forEach(n=>t.add(n)),this.userConfiguration.keys.forEach(n=>t.add(n)),this.i.keys.forEach(n=>t.add(n)),this.j.forEach(n=>n.keys.forEach(s=>t.add(s))),[...t.values()]}u(){const t=new Set;return this.c.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.i.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.j.forEach(n=>n.getAllOverrideIdentifiers().forEach(s=>t.add(s))),[...t.values()]}v(t){const n=new Set;return this.c.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.i.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.j.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(o=>n.add(o))),[...n.values()]}static parse(t){const n=this.w(t.defaults),s=this.w(t.policy),o=this.w(t.application),l=this.w(t.user),O=this.w(t.workspace),I=t.folders.reduce((b,j)=>(b.set(a.URI.revive(j[0]),this.w(j[1])),b),new A.$Ac);return new p(n,s,o,l,new w,O,I,new w,new A.$Ac)}static w(t){return new w(t.contents,t.keys,t.overrides)}}e.$io=p;function $(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const t=new Set,n=new Map;for(const o of r)o.keys.forEach(l=>t.add(l)),o.overrides.forEach(([l,O])=>{const I=(0,A.$xc)(n,l,new Set);O.forEach(b=>I.add(b))});const s=[];return n.forEach((o,l)=>s.push([l,[...o.values()]])),{keys:[...t.values()],overrides:s}}e.$jo=$;class h{constructor(t,n,s,o){this.change=t,this.f=n,this.g=s,this.h=o,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const l of t.keys)this.affectedKeys.add(l);for(const[,l]of t.overrides)for(const O of l)this.affectedKeys.add(O);this.d=this.a;for(const l of this.affectedKeys)this.d+=l+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=p.parse(this.f.data)),this.i}affectsConfiguration(t,n){const s=this.a+t,o=this.d.indexOf(s);if(o<0)return!1;const l=o+s.length;if(l>=this.d.length)return!1;const O=this.d.charCodeAt(l);if(O!==this.b&&O!==this.c)return!1;if(n){const I=this.previousConfiguration?this.previousConfiguration.getValue(t,n,this.f?.workspace):void 0,b=this.g.getValue(t,n,this.h);return!S.$On(I,b)}return!0}}e.$ko=h;function g(r,t){const{added:n,removed:s,updated:o}=i(t?.rawConfiguration,r?.rawConfiguration),l=[],O=r?.getAllOverrideIdentifiers()||[],I=t?.getAllOverrideIdentifiers()||[];if(t){const b=I.filter(j=>!O.includes(j));for(const j of b)l.push([j,t.getKeysForOverrideIdentifier(j)])}if(r){const b=O.filter(j=>!I.includes(j));for(const j of b)l.push([j,r.getKeysForOverrideIdentifier(j)])}if(t&&r){for(const b of O)if(I.includes(b)){const j=i({contents:r.getOverrideValue(void 0,b)||{},keys:r.getKeysForOverrideIdentifier(b)},{contents:t.getOverrideValue(void 0,b)||{},keys:t.getKeysForOverrideIdentifier(b)});l.push([b,[...j.added,...j.removed,...j.updated]])}}return{added:n,removed:s,updated:o,overrides:l}}function i(r,t){const n=r?t?r.keys.filter(l=>t.keys.indexOf(l)===-1):[...r.keys]:[],s=t?r?t.keys.filter(l=>r.keys.indexOf(l)===-1):[...t.keys]:[],o=[];if(r&&t){for(const l of t.keys)if(r.keys.indexOf(l)!==-1){const O=(0,y.$Ti)(t.contents,l),I=(0,y.$Ti)(r.contents,l);S.$On(O,I)||o.push(l)}}return{added:n,removed:s,updated:o}}}),define(ie[135],ne([0,1,19,6,2,27,3,66,40,4,39,36]),function(J,e,N,D,R,L,A,S,u,a,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$no=e.$mo=e.$lo=void 0;class d extends R.$Tc{constructor(){super(...arguments),this.a=this.B(new D.$5d),this.onDidChangeConfiguration=this.a.event,this.b=new S.$fo}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(E.$Wn.as(u.$2n.Configuration).onDidUpdateConfiguration(({properties:v,defaultsOverrides:c})=>this.c(Array.from(v),c))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(v,c){this.h(v,E.$Wn.as(u.$2n.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:v})}f(){return{}}g(){this.b=new S.$fo;const v=E.$Wn.as(u.$2n.Configuration).getConfigurationProperties();this.h(Object.keys(v),v)}h(v,c){const p=this.f();for(const $ of v){const h=p[$],g=c[$];h!==void 0?this.b.addValue($,h):g?this.b.addValue($,g.default):this.b.removeValue($)}}}e.$lo=d;class m{constructor(){this.onDidChangeConfiguration=D.Event.None,this.configurationModel=new S.$fo}async initialize(){return this.configurationModel}}e.$mo=m;let w=class extends R.$Tc{get configurationModel(){return this.b}constructor(v,c,p){super(),this.c=v,this.f=c,this.g=p,this.a=this.B(new D.$5d),this.onDidChangeConfiguration=this.a.event,this.b=new S.$fo}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(v=>this.j(v))),this.B(this.c.onDidChangeConfiguration(async({properties:v})=>this.m(await this.h(v),!0))),this.b}async h(v){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",v);const c={},p=[],$=E.$Wn.as(u.$2n.Configuration).getConfigurationProperties();for(const h of v){const g=$[h];if(!g){p.push(h);continue}if(g.policy){if(g.type!=="string"&&g.type!=="number"){this.g.warn(`Policy ${g.policy.name} has unsupported type ${g.type}`);continue}p.push(h),c[g.policy.name]={type:g.type}}}return(0,A.$6f)(c)||await this.f.updatePolicyDefinitions(c),p}j(v){this.g.trace("PolicyConfiguration#onDidChangePolicies",v);const c=E.$Wn.as(u.$2n.Configuration).getPolicyConfigurations(),p=(0,N.$Hb)(v.map($=>c.get($)));this.m(p,!0)}m(v,c){this.g.trace("PolicyConfiguration#update",v);const p=E.$Wn.as(u.$2n.Configuration).getConfigurationProperties(),$=[],h=this.b.isEmpty();for(const g of v){const i=p[g]?.policy?.name;if(i){const r=this.f.getPolicyValue(i);(h?r!==void 0:!(0,L.$On)(this.b.getValue(g),r))&&$.push([g,r])}else this.b.getValue(g)!==void 0&&$.push([g,void 0])}if($.length){this.g.trace("PolicyConfiguration#changed",$);const g=this.b;this.b=new S.$fo;for(const i of g.keys)this.b.setValue(i,g.getValue(i));for(const[i,r]of $)r===void 0?this.b.removeValue(i):this.b.setValue(i,r);c&&this.a.fire(this.b)}}};e.$no=w,e.$no=w=me([se(1,y.$Yn),se(2,a.$zj)],w)}),define(ie[136],ne([0,1,19,9,14,6,38,73,2,27,12,17,29,66,40,135,39]),function(J,e,N,D,R,L,A,S,u,a,y,E,d,m,w,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=void 0;class c extends u.$Tc{constructor(h,g,i,r){super(),this.m=h,this.h=this.B(new L.$5d),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new k.$lo),this.c=i instanceof v.$1n?new k.$mo:this.B(new k.$no(this.b,i,r)),this.f=this.B(new m.$ho(this.m,{},E.$Jg,g)),this.a=new m.$io(this.b.configurationModel,this.c.configurationModel,new m.$fo,new m.$fo),this.j=new p(h,g,this),this.g=this.B(new D.$rh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:t,properties:n})=>this.r(t,n))),this.B(this.c.onDidChangeConfiguration(t=>this.s(t))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[h,g,i]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new m.$io(h,g,new m.$fo,i)}getConfigurationData(){return this.a.toData()}getValue(h,g){const i=typeof h=="string"?h:void 0,r=(0,d.$Mi)(h)?h:(0,d.$Mi)(g)?g:{};return this.a.getValue(i,r,void 0)}async updateValue(h,g,i,r,t){const n=(0,d.$Ni)(i)?i:(0,d.$Mi)(i)?{resource:i.resource,overrideIdentifiers:i.overrideIdentifier?[i.overrideIdentifier]:void 0}:void 0,s=n?r:i;if(s!==void 0&&s!==3&&s!==2)throw new Error(`Unable to write ${h} to target ${s}.`);n?.overrideIdentifiers&&(n.overrideIdentifiers=(0,N.$Mb)(n.overrideIdentifiers),n.overrideIdentifiers=n.overrideIdentifiers.length?n.overrideIdentifiers:void 0);const o=this.inspect(h,{resource:n?.resource,overrideIdentifier:n?.overrideIdentifiers?n.overrideIdentifiers[0]:void 0});if(o.policyValue!==void 0)throw new Error(`Unable to write ${h} because it is configured in system policy.`);if((0,a.$On)(g,o.defaultValue)&&(g=void 0),n?.overrideIdentifiers?.length&&n.overrideIdentifiers.length>1){const O=n.overrideIdentifiers.sort(),I=this.a.localUserConfiguration.overrides.find(b=>(0,N.$ub)([...b.identifiers].sort(),O));I&&(n.overrideIdentifiers=I.identifiers)}const l=n?.overrideIdentifiers?.length?[(0,w.$bo)(n.overrideIdentifiers),h]:[h];await this.j.write(l,g),await this.reloadConfiguration()}inspect(h,g={}){return this.a.inspect(h,g,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const h=await this.f.loadConfiguration();this.n(h)}n(h){const g=this.a.toData(),i=this.a.compareAndUpdateLocalUserConfiguration(h);this.t(i,g,2)}r(h,g){const i=this.a.toData(),r=this.a.compareAndUpdateDefaultConfiguration(h,g);this.t(r,i,7)}s(h){const g=this.a.toData(),i=this.a.compareAndUpdatePolicyConfiguration(h);this.t(i,g,7)}t(h,g,i){const r=new m.$ko(h,{data:g},this.a);r.source=i,this.h.fire(r)}}e.$oo=c;class p{constructor(h,g,i){this.b=h,this.c=g,this.d=i,this.a=new D.$mh}write(h,g){return this.a.queue(()=>this.e(h,g))}async e(h,g){let i;try{i=(await this.c.readFile(this.b)).value.toString()}catch(n){if(n.fileOperationResult===1)i="{}";else throw n}const r=[];if((0,A.$rn)(i,r,{allowTrailingComma:!0,allowEmptyContent:!0}),r.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const t=this.f(i,h,g);i=(0,S.$Jn)(i,t),await this.c.writeFile(this.b,R.$se.fromString(i))}f(h,g,i){const{tabSize:r,insertSpaces:t,eol:n}=this.h;if(!g.length){const s=JSON.stringify(i,null,t?" ".repeat(r):"	");return[{content:s,length:s.length,offset:0}]}return(0,S.$Gn)(h,g,i,{tabSize:r,insertSpaces:t,eol:n})}get h(){if(!this.g){let h=y.OS===3||y.OS===2?`
`:`\r
`;const g=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});g&&typeof g=="string"&&g!=="auto"&&(h=g),this.g={eol:h,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(ie[67],ne([0,1,15]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=e.$rm=e.$qm=e.$pm=void 0;function D(u){return u.scheme===N.Schemas.vscodeRemote?u.authority:void 0}e.$pm=D;function R(u){if(!u)return;const a=u.indexOf("+");return a<0?u:u.substr(0,a)}e.$qm=R;function L(u){const{host:a,port:y}=S(u);if(typeof y>"u")throw new Error(`Invalid remote authority: ${u}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:a,port:y}}e.$rm=L;function A(u,a){let{host:y,port:E}=S(u);return typeof E>"u"&&(E=a),{host:y,port:E}}e.$sm=A;function S(u){const a=u.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(a)return{host:a[1],port:parseInt(a[2],10)};const y=u.match(/^(\[[0-9a-z:]+\])$/);if(y)return{host:y[1],port:void 0};const E=u.match(/(.*):(\d+)$/);return E?{host:E[1],port:parseInt(E[2],10)}:{host:u,port:void 0}}}),define(ie[37],ne([0,1,30,10,67]),function(J,e,N,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gm=e.$Fm=e.$Em=e.$Dm=e.$Cm=e.$Bm=e.$Am=e.$zm=e.TargetPlatform=e.ExtensionType=e.$ym=e.$xm=e.$wm=e.$vm=e.$um=e.$tm=void 0,e.$tm="extensions.user.cache",e.$um="extensions.builtin.cache",e.$vm="undefined_publisher",e.$wm=["ui","workspace","web"];function L(k){if(typeof k=="object"&&k!==null&&k.supported!==!0)return k.description}e.$xm=L,e.$ym=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var A;(function(k){k[k.System=0]="System",k[k.User=1]="User"})(A||(e.ExtensionType=A={}));var S;(function(k){k.WIN32_X64="win32-x64",k.WIN32_ARM64="win32-arm64",k.LINUX_X64="linux-x64",k.LINUX_ARM64="linux-arm64",k.LINUX_ARMHF="linux-armhf",k.ALPINE_X64="alpine-x64",k.ALPINE_ARM64="alpine-arm64",k.DARWIN_X64="darwin-x64",k.DARWIN_ARM64="darwin-arm64",k.WEB="web",k.UNIVERSAL="universal",k.UNKNOWN="unknown",k.UNDEFINED="undefined"})(S||(e.TargetPlatform=S={}));class u{constructor(v){this.value=v,this._lower=v.toLowerCase()}static equals(v,c){if(typeof v>"u"||v===null)return typeof c>"u"||c===null;if(typeof c>"u"||c===null)return!1;if(typeof v=="string"||typeof c=="string"){const p=typeof v=="string"?v:v.value,$=typeof c=="string"?c:c.value;return N.$jf(p,$)}return v._lower===c._lower}static toKey(v){return typeof v=="string"?v.toLowerCase():v._lower}}e.$zm=u;class a{get size(){return this.c.size}constructor(v){if(this.c=new Set,v)for(const c of v)this.add(c)}add(v){this.c.add(u.toKey(v))}delete(v){return this.c.delete(u.toKey(v))}has(v){return this.c.has(u.toKey(v))}}e.$Am=a;class y{constructor(){this.c=new Map}clear(){this.c.clear()}delete(v){this.c.delete(u.toKey(v))}get(v){return this.c.get(u.toKey(v))}has(v){return this.c.has(u.toKey(v))}set(v,c){this.c.set(u.toKey(v),c)}values(){return this.c.values()}forEach(v){this.c.forEach(v)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Bm=y;function E(k){return d(k)}e.$Cm=E;function d(k){return k.contributes&&k.contributes.localizations?k.contributes.localizations.length>0:!1}e.$Dm=d;function m(k){return k.contributes&&k.contributes.authentication?k.contributes.authentication.length>0:!1}e.$Em=m;function w(k,v){if(v){const c=`onResolveRemoteAuthority:${(0,R.$qm)(v)}`;return!!k.activationEvents?.includes(c)}return!1}e.$Fm=w,e.$Gm=(0,D.$fi)("IBuiltinExtensionsScannerService")}),define(ie[137],ne([0,1,2,37,13]),function(J,e,N,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=void 0;class L extends N.$Tc{constructor(S,u,a,y,E){super(),this.a=S,this.b=u,this.c=a,this.f=E,this.B(y.onDidInstallExtensions(d=>this.g(d))),this.B(y.onDidUninstallExtension(d=>this.h(d)))}g(S){for(const u of S)u.local&&this.invalidate(u.profileLocation)}h(S){S.error||this.invalidate(S.profileLocation)}async invalidate(S){if(S)for(const u of this.a.profiles)this.c.extUri.isEqual(u.extensionsResource,S)&&await this.j(u);else await this.j(this.a.defaultProfile)}async j(S){try{await this.b.del(this.c.extUri.joinPath(S.cacheHome,D.$tm))}catch(u){(0,R.$Wk)(u)!==1&&this.f.error(u)}}}e.$jq=L}),define(ie[45],ne([0,1,14,7,2,106,40,10,4,36]),function(J,e,N,D,R,L,A,S,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=e.$Bp=e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=void 0,e.$vp=(0,S.$fi)("requestService");class y{constructor(g){this.b=g}toJSON(){if(!this.a){const g=Object.create(null);for(const i in this.b)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?g[i]="*****":g[i]=this.b[i];this.a=g}return this.a}}class E extends R.$Tc{constructor(g){super(),this.b=0,this.a=g.createLogger("network",{name:(0,L.localize)(0,null),when:u.$Qj.isEqualTo((0,u.$Oj)(u.LogLevel.Trace)).serialize()})}async c(g,i,r){const t=`${g} #${++this.b}: ${i.url}`;this.a.trace(`${t} - begin`,i.type,new y(i.headers??{}));try{const n=await r();return this.a.trace(`${t} - end`,i.type,n.res.statusCode,n.res.headers),n}catch(n){throw this.a.error(`${t} - error`,i.type,(0,D.$0)(n)),n}}}e.$wp=E;function d(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}e.$xp=d;function m(h){return h.res.statusCode===204}e.$yp=m;async function w(h){return m(h)?null:(await(0,N.$Ee)(h.stream)).toString()}e.$zp=w;async function k(h){if(!d(h))throw new Error("Server returned "+h.res.statusCode);return w(h)}e.$Ap=k;async function v(h){if(!d(h))throw new Error("Server returned "+h.res.statusCode);if(m(h))return null;const i=(await(0,N.$Ee)(h.stream)).toString();try{return JSON.parse(i)}catch(r){throw r.message+=`:
`+i,r}}e.$Bp=v;function c(h){$(h)}e.$Cp=c;let p;function $(h){const g=a.$Wn.as(A.$2n.Configuration),i=p;p={id:"http",order:15,title:(0,L.localize)(1,null),type:"object",scope:h,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,L.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(6,null),(0,L.localize)(7,null),(0,L.localize)(8,null),(0,L.localize)(9,null)],default:"override",description:(0,L.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,L.localize)(12,null),restricted:!0}}},g.updateConfigurations({add:[p],remove:i?[i]:[]})}$(1)}),define(ie[138],ne([0,1,20,15,13,45]),function(J,e,N,D,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XP=void 0;let A=class{constructor(u,a){this.a=u,this.b=a}async download(u,a,y=N.CancellationToken.None){if(u.scheme===D.Schemas.file||u.scheme===D.Schemas.vscodeRemote){await this.b.copy(u,a);return}const E={type:"GET",url:u.toString(!0)},d=await this.a.request(E,y);if(d.res.statusCode===200)await this.b.writeFile(a,d.stream);else{const m=await(0,L.$Ap)(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${m}`)}}};e.$XP=A,e.$XP=A=me([se(0,L.$vp),se(1,R.$Fk)],A)}),define(ie[139],ne([0,1,140,3]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ar=void 0;function R(A,S){return A.protocol==="http:"?S.HTTP_PROXY||S.http_proxy||null:A.protocol==="https:"&&(S.HTTPS_PROXY||S.https_proxy||S.HTTP_PROXY||S.http_proxy)||null}async function L(A,S,u={}){const a=(0,N.parse)(A),y=u.proxyUrl||R(a,S);if(!y)return null;const E=(0,N.parse)(y);if(!/^https?:$/.test(E.protocol||""))return null;const d={host:E.hostname||"",port:(E.port?+E.port:0)||(E.protocol==="https"?443:80),auth:E.auth,rejectUnauthorized:(0,D.$Yf)(u.strictSSL)?u.strictSSL:!0};return a.protocol==="http:"?new(await new Promise((m,w)=>{J(["http-proxy-agent"],m,w)})).HttpProxyAgent(y,d):new(await new Promise((m,w)=>{J(["https-proxy-agent"],m,w)})).HttpsProxyAgent(y,d)}e.$Ar=L}),define(ie[141],ne([0,1,58,16,107,20,34,7,12,28,86,173,9,74]),function(J,e,N,D,R,L,A,S,u,a,y,E,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jm=void 0;let w;async function k(c,p,$,h){return $["force-disable-user-env"]?(p.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):u.$i?(p.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,E.$dm)(h)&&!$["force-user-env"]?(p.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,E.$dm)(h)?p.trace("resolveShellEnv(): running (--force-user-env)"):p.trace("resolveShellEnv(): running (macOS/Linux)"),w||(w=d.Promises.withAsyncBody(async(g,i)=>{const r=new L.$ce;let t=1e4;const n=c.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(t=(0,m.$em)(n,1,120)*1e3);const s=setTimeout(()=>{r.dispose(!0),i(new Error((0,R.localize)(0,null)))},t);try{g(await v(p,r.token))}catch(o){!(0,S.$4)(o)&&!r.token.isCancellationRequested?i(new Error((0,R.localize)(1,null,(0,A.$3i)(o)))):g({})}finally{clearTimeout(s),r.dispose()}})),w)}e.$jm=k;async function v(c,p){const $=process.env.ELECTRON_RUN_AS_NODE;c.trace("getUnixShellEnvironment#runAsNode",$);const h=process.env.ELECTRON_NO_ATTACH_CONSOLE;c.trace("getUnixShellEnvironment#noAttach",h);const g=(0,a.$Bg)().replace(/-/g,"").substr(0,12),i=new RegExp(g+"({.*})"+g),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};c.trace("getUnixShellEnvironment#env",r);const t=await(0,y.$6l)(u.OS,r);return c.trace("getUnixShellEnvironment#shell",t),new Promise((n,s)=>{if(p.isCancellationRequested)return s(new S.$5);const o=(0,D.$nc)(t);let l,O;const I="";/^pwsh(-preview)?$/.test(o)?(l=`& '${process.execPath}' ${I} -p '''${g}'' + JSON.stringify(process.env) + ''${g}'''`,O=["-Login","-Command"]):o==="nu"?(l=`^'${process.execPath}' ${I} -p '"${g}" + JSON.stringify(process.env) + "${g}"'`,O=["-i","-l","-c"]):o==="xonsh"?(l=`import os, json; print("${g}", json.dumps(dict(os.environ)), "${g}")`,O=["-i","-l","-c"]):(l=`'${process.execPath}' ${I} -p '"${g}" + JSON.stringify(process.env) + "${g}"'`,o==="tcsh"||o==="csh"?O=["-ic"]:O=["-i","-l","-c"]),c.trace("getUnixShellEnvironment#spawn",JSON.stringify(O),l);const b=(0,N.spawn)(t,[...O,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});p.onCancellationRequested(()=>(b.kill(),s(new S.$5))),b.on("error",Y=>{c.error("getUnixShellEnvironment#errorChildProcess",(0,A.$3i)(Y)),s(Y)});const j=[];b.stdout.on("data",Y=>j.push(Y));const q=[];b.stderr.on("data",Y=>q.push(Y)),b.on("close",(Y,K)=>{const oe=Buffer.concat(j).toString("utf8");c.trace("getUnixShellEnvironment#raw",oe);const re=Buffer.concat(q).toString("utf8");if(re.trim()&&c.trace("getUnixShellEnvironment#stderr",re),Y||K)return s(new Error((0,R.localize)(2,null,Y,K)));const he=i.exec(oe),de=he?he[1]:"{}";try{const ae=JSON.parse(de);$?ae.ELECTRON_RUN_AS_NODE=$:delete ae.ELECTRON_RUN_AS_NODE,h?ae.ELECTRON_NO_ATTACH_CONSOLE=h:delete ae.ELECTRON_NO_ATTACH_CONSOLE,delete ae.VSCODE_RESOLVING_ENVIRONMENT,delete ae.XDG_RUNTIME_DIR,c.trace("getUnixShellEnvironment#result",ae),n(ae)}catch(ae){c.error("getUnixShellEnvironment#errorCaught",(0,A.$3i)(ae)),s(ae)}})})}}),define(ie[142],ne([0,1,10]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AP=e.$zP=void 0,e.$zP=(0,N.$fi)("stateReadService"),e.$AP=(0,N.$fi)("stateService")}),define(ie[68],ne([0,1,9,14,2,3,18,13,4]),function(J,e,N,D,R,L,A,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DP=e.$CP=e.$BP=e.SaveStrategy=void 0;var a;(function(m){m[m.IMMEDIATE=0]="IMMEDIATE",m[m.DELAYED=1]="DELAYED"})(a||(e.SaveStrategy=a={}));class y extends R.$Tc{constructor(w,k,v,c){super(),this.h=w,this.j=k,this.m=v,this.n=c,this.a=Object.create(null),this.b="",this.c=this.B(new N.$dh(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(w){w.fileOperationResult!==1&&this.m.error(w)}}getItem(w,k){const v=this.a[w];return(0,L.$2f)(v)?k:v}setItem(w,k){this.setItems([{key:w,data:k}])}setItems(w){let k=!1;for(const{key:v,data:c}of w)this.a[v]!==c&&((0,L.$2f)(c)?(0,L.$Zf)(this.a[v])||(this.a[v]=void 0,k=!0):(this.a[v]=c,k=!0));k&&this.s()}removeItem(w){(0,L.$Zf)(this.a[w])||(this.a[w]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const w=JSON.stringify(this.a,null,4);if(w!==this.b)try{await this.n.writeFile(this.h,D.$se.fromString(w),{atomic:{postfix:".vsctmp"}}),this.b=w}catch(k){this.m.error(k)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$BP=y;let E=class extends R.$Tc{constructor(w,k,v,c){super(),this.a=this.B(new y(k.stateResource,w,v,c))}async init(){await this.a.init()}getItem(w,k){return this.a.getItem(w,k)}};e.$CP=E,e.$CP=E=me([se(1,A.$mi),se(2,u.$zj),se(3,S.$Fk)],E);class d extends E{setItem(w,k){this.a.setItem(w,k)}setItems(w){this.a.setItems(w)}removeItem(w){this.a.removeItem(w)}close(){return this.a.close()}}e.$DP=d}),define(ie[69],ne([0,1,12,35,28]),function(J,e,N,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yo=e.$Xo=void 0;function L(u){if(N.$u===2&&/^penguin(\.|$)/i.test(u))return"chromebook"}function A(u,a,y,E,d,m,w,k,v){const c=Object.create(null);c["common.machineId"]=m,c["common.sqmId"]=w,c.sessionID=(0,R.$Bg)()+Date.now(),c.commitHash=E,c.version=d,c["common.platformVersion"]=(u||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,N.$h)(N.$u),c["common.nodePlatform"]=D.$dc,c["common.nodeArch"]=y,c["common.product"]=v||"desktop",k&&(c["common.msftInternal"]=k);let p=0;const $=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-$,enumerable:!0},"common.sequence":{get:()=>p++,enumerable:!0}}),N.$l&&(c["common.snap"]="true");const h=L(a);return h&&(c["common.platformDetail"]=h),c}e.$Xo=A;function S(u){const a=D.env.USERDNSDOMAIN;if(!a)return!1;const y=a.toLowerCase();return u.some(E=>y===E)}e.$Yo=S}),define(ie[25],ne([0,1,10]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Ol=e.$Nl=e.$Ml=e.$Ll=e.$Kl=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=e.$El=void 0,e.$El=(0,N.$fi)("telemetryService"),e.$Fl=(0,N.$fi)("customEndpointTelemetryService"),e.$Gl="telemetry.currentSessionDate",e.$Hl="telemetry.firstSessionDate",e.$Il="telemetry.lastSessionDate",e.$Jl="telemetry.machineId",e.$Kl="telemetry.sqmId",e.$Ll="telemetry",e.$Ml="telemetry.telemetryLevel",e.$Nl="telemetry.enableCrashReporter",e.$Ol="telemetry.enableTelemetry";var D;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(D||(e.TelemetryLevel=D={}));var R;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(R||(e.TelemetryConfiguration=R={}))}),define(ie[41],ne([0,1,27,3,67,69,25]),function(J,e,N,D,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=void 0;class S{constructor(r){this.value=r,this.isTrustedTelemetryValue=!0}}e.$Zo=S;class u{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$1o=u,e.$2o=new u;class a{async publicLog(r,t,n){}async publicLogError(r,t,n){}}e.$3o=a,e.$4o="telemetry",e.$5o="extensionTelemetryLog",e.$6o={log:()=>null,flush:()=>Promise.resolve(null)};function y(i,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!i.enableTelemetry)}e.$7o=y;function E(i,r){return r.extensionTestsLocationURI?!0:!(r.isBuilt||r.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$8o=E;function d(i){const r=i.getValue(A.$Ml),t=i.getValue(A.$Nl);if(i.getValue(A.$Ol)===!1||t===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$9o=d;function m(i){const r={},t={},n={};v(i,n);for(let s in n){s=s.length>150?s.substr(s.length-149):s;const o=n[s];typeof o=="number"?t[s]=o:typeof o=="boolean"?t[s]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${o.length}`),r[s]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(r[s]=o)}return{properties:r,measurements:t}}e.$0o=m;const w=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function k(i){if(!i)return"none";const r=(0,R.$qm)(i);return w.has(r)?r:"other"}e.$$o=k;function v(i,r,t=0,n){if(i)for(const s of Object.getOwnPropertyNames(i)){const o=i[s],l=n?n+s:s;Array.isArray(o)?r[l]=(0,N.$Pn)(o):o instanceof Date?r[l]=o.toISOString():(0,D.$Uf)(o)?t<2?v(o,r,t+1,l+"."):r[l]=(0,N.$Pn)(o):r[l]=o}}function c(i,r){const t=i.msftInternalDomains||[],n=r.getValue("telemetry.internalTesting");return(0,L.$Yo)(t)||n}e.$_o=c;function p(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$ap=p;function $(i,r){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let t=i;const n=[];for(const O of r)for(;;){const I=O.exec(i);if(!I)break;n.push([I.index,O.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(t="";;){const O=o.exec(i);if(!O)break;const I=n.some(([b,j])=>O.index<j&&b<o.lastIndex);!s.test(O[0])&&!I&&(t+=i.substring(l,O.index)+"<REDACTED: user-file-path>",l=o.lastIndex)}return l<i.length&&(t+=i.substr(l)),t}function h(i){if(!i)return i;const r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const t of r)if(t.regex.test(i))return`<REDACTED: ${t.label}>`;return i}function g(i,r){return(0,N.$Mn)(i,t=>{if(t instanceof S||Object.hasOwnProperty.call(t,"isTrustedTelemetryValue"))return t.value;if(typeof t=="string"){let n=t.replaceAll("%20"," ");n=$(n,r);for(const s of r)n=n.replace(s,"");return n=h(n),n}})}e.$bp=g}),define(ie[26],ne([0,1,30,21,37,12,11,7,35,41]),function(J,e,N,D,R,L,A,S,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$np=e.$mp=e.$lp=e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=void 0;function y(t,n){return t.uuid&&n.uuid?t.uuid===n.uuid:t.id===n.id?!0:(0,N.$ef)(t.id,n.id)===0}e.$cp=y;const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class d{static create(n){const s=n.manifest?n.manifest.version:n.version,o=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new d(n.identifier,s,o)}static parse(n){const s=E.exec(n);return s&&s[1]&&s[2]?new d({id:s[1]},s[2],s[4]||void 0):null}constructor(n,s,o="undefined"){this.version=s,this.targetPlatform=o,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof d?y(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.$dp=d;const m=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function w(t){const n=m.exec(t);return n&&n[1]?[v(n[1]),n[2]]:[v(t),void 0]}e.$ep=w;function k(t,n){return`${t}.${n}`}e.$fp=k;function v(t){return t.toLowerCase()}e.$gp=v;function c(t,n){return v(k(t??R.$vm,n))}e.$hp=c;function p(t,n){const s=[],o=l=>{for(const O of s)if(O.some(I=>y(n(I),n(l))))return O;return null};for(const l of t){const O=o(l);O?O.push(l):s.push([l])}return s}e.$ip=p;function $(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.$jp=$;function h(t){return{id:new a.$Zo(t.identifier.id),name:new a.$Zo(t.name),galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),isSigned:t.isSigned,...t.telemetryData}}e.$kp=h,e.$lp=new R.$zm("pprice.better-merge");function g(t,n){const s=[],o=n.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const l=o.shift();if(l&&s.every(O=>!y(O.identifier,{id:l}))){const O=t.filter(I=>y(I.identifier,{id:l}));O.length===1&&(s.push(O[0]),o.push(...O[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}e.$mp=g;async function i(t,n){if(!L.$k)return!1;let s;try{s=(await t.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await t.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){n.debug("Error while getting the os-release file.",(0,S.$0)(l))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(t,n){const s=await i(t,n),o=(0,D.$Jo)(s?"alpine":L.$u,u.$ec);return n.debug("ComputeTargetPlatform:",o),o}e.$np=r}),define(ie[143],ne([0,1,20,7,15,17,44,11,96,21,26,37]),function(J,e,N,D,R,L,A,S,u,a,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=void 0;const d=k=>(0,u.localize)(0,null,k),m=(0,u.localize)(1,null,"ms-dotnettools.csharp");let w=class{constructor(v,c,p){this.a=v,this.b=c,this.d=p}get f(){}async listExtensions(v,c,p){let $=await this.b.getInstalled(1,p);const h=E.$ym.map(i=>i.toLowerCase());if(c&&c!==""){if(h.indexOf(c.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}$=$.filter(i=>i.manifest.categories?i.manifest.categories.map(t=>t.toLowerCase()).indexOf(c.toLowerCase())>-1:!1)}else if(c===""){this.a.info("Possible Categories: "),h.forEach(i=>{this.a.info(i)});return}this.f&&this.a.info((0,u.localize)(2,null,this.f)),$=$.sort((i,r)=>i.identifier.id.localeCompare(r.identifier.id));let g;for(const i of $)g!==i.identifier.id&&(g=i.identifier.id,this.a.info(v?`${g}@${i.manifest.version}`:g))}async installExtensions(v,c,p,$){const h=[];try{v.length&&this.a.info(this.f?(0,u.localize)(3,null,this.f):(0,u.localize)(4,null));const g=[],i=[],r=(n,s,o)=>{i.push({id:n,version:s!=="prerelease"?s:void 0,installOptions:{...p,isBuiltin:o,installPreReleaseVersion:s==="prerelease"||p.installPreReleaseVersion}})};for(const n of v)if(n instanceof S.URI)g.push({vsix:n,installOptions:p});else{const[s,o]=(0,y.$ep)(n);r(s,o,!1)}for(const n of c)if(n instanceof S.URI)g.push({vsix:n,installOptions:{...p,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[s,o]=(0,y.$ep)(n);r(s,o,!0)}const t=await this.b.getInstalled(1,p.profileLocation);if(g.length&&await Promise.all(g.map(async({vsix:n,installOptions:s})=>{try{await this.h(n,s,$,t)}catch(o){this.a.error(o),h.push(n.toString())}})),i.length){const n=await this.g(i,t,$);h.push(...n)}}catch(g){throw this.a.error((0,u.localize)(5,null,(0,D.$0)(g))),g}if(h.length)throw new Error((0,u.localize)(6,null,h.join(", ")))}async updateExtensions(v){const c=await this.b.getInstalled(1,v),p=[];for(const i of c)i.identifier.uuid&&p.push({...i.identifier,preRelease:i.preRelease});this.a.trace((0,u.localize)(7,null,p.length));const $=await this.d.getExtensions(p,{compatible:!0},N.CancellationToken.None),h=[];for(const i of $)for(const r of c)(0,y.$cp)(r.identifier,i.identifier)&&(0,A.gt)(i.version,r.manifest.version)&&h.push({extension:i,options:{operation:3,installPreReleaseVersion:r.isPreReleaseVersion}});if(!h.length){this.a.info((0,u.localize)(8,null));return}this.a.info((0,u.localize)(9,null,h.map(i=>i.extension.identifier.id).join(", ")));const g=await this.b.installGalleryExtensions(h);for(const i of g)i.error?this.a.error((0,u.localize)(10,null,i.identifier.id,(0,D.$0)(i.error))):this.a.info((0,u.localize)(11,null,i.identifier.id,i.local?.manifest.version))}async g(v,c,p){if(v=v.filter(({id:i,version:r})=>{const t=c.find(n=>(0,y.$cp)(n.identifier,{id:i}));if(t){if(!p&&(!r||r==="prerelease"&&t.preRelease))return this.a.info((0,u.localize)(12,null,i,t.manifest.version,i)),!1;if(r&&t.manifest.version===r)return this.a.info((0,u.localize)(13,null,`${i}@${r}`)),!1}return!0}),!v.length)return[];const $=[],h=[],g=await this.j(v);if(await Promise.all(v.map(async({id:i,version:r,installOptions:t})=>{const n=g.get(i.toLowerCase());if(!n){this.a.error(`${d(r?`${i}@${r}`:i)}
${m}`),$.push(i);return}try{const o=await this.d.getManifest(n,N.CancellationToken.None);if(o&&!this.k(o))return}catch(o){this.a.error(o.message||o.stack||o),$.push(i);return}const s=c.find(o=>(0,y.$cp)(o.identifier,n.identifier));if(s){if(n.version===s.manifest.version){this.a.info((0,u.localize)(14,null,r?`${i}@${r}`:i));return}this.a.info((0,u.localize)(15,null,i,n.version))}t.isBuiltin?this.a.info(r?(0,u.localize)(16,null,i,r):(0,u.localize)(17,null,i)):this.a.info(r?(0,u.localize)(18,null,i,r):(0,u.localize)(19,null,i)),h.push({extension:n,options:{...t,installGivenVersion:!!r}})})),h.length){const i=await this.b.installGalleryExtensions(h);for(const r of i)r.error?(this.a.error((0,u.localize)(20,null,r.identifier.id,(0,D.$0)(r.error))),$.push(r.identifier.id)):this.a.info((0,u.localize)(21,null,r.identifier.id,r.local?.manifest.version))}return $}async h(v,c,p,$){const h=await this.b.getManifest(v);if(!h)throw new Error("Invalid vsix");if(await this.l(h,p,c.profileLocation,$))try{await this.b.install(v,c),this.a.info((0,u.localize)(22,null,(0,L.$Pg)(v)))}catch(i){if((0,D.$4)(i))this.a.info((0,u.localize)(23,null,(0,L.$Pg)(v)));else throw i}}async j(v){const c=new Map,p=v.some(g=>g.installOptions.installPreReleaseVersion),$=await this.b.getTargetPlatform(),h=[];for(const g of v)a.$Co.test(g.id)&&h.push({...g,preRelease:p});if(h.length){const g=await this.d.getExtensions(h,{targetPlatform:$},N.CancellationToken.None);for(const i of g)c.set(i.identifier.id.toLowerCase(),i)}return c}k(v){return!0}async l(v,c,p,$){if(!c){const h={id:(0,y.$hp)(v.publisher,v.name)},g=$.find(i=>(0,y.$cp)(h,i.identifier)&&(0,A.gt)(i.manifest.version,v.version));if(g)return this.a.info((0,u.localize)(24,null,g.identifier.id,g.manifest.version,v.version)),!1}return this.k(v)}async uninstallExtensions(v,c,p){const $=async g=>{if(g instanceof S.URI){const i=await this.b.getManifest(g);return(0,y.$fp)(i.publisher,i.name)}return g},h=[];for(const g of v){const i=await $(g),t=(await this.b.getInstalled(void 0,p)).filter(n=>(0,y.$cp)(n.identifier,{id:i}));if(!t.length)throw new Error(`${this.m(i)}
${m}`);if(t.some(n=>n.type===0)){this.a.info((0,u.localize)(25,null,i));return}if(!c&&t.some(n=>n.isBuiltin)){this.a.info((0,u.localize)(26,null,i));return}this.a.info((0,u.localize)(27,null,i));for(const n of t)await this.b.uninstall(n,{profileLocation:p}),h.push(n);this.f?this.a.info((0,u.localize)(28,null,i,this.f)):this.a.info((0,u.localize)(29,null,i))}}async locateExtension(v){const c=await this.b.getInstalled();v.forEach(p=>{c.forEach($=>{if($.identifier.id===p&&$.location.scheme===R.Schemas.file){this.a.info($.location.fsPath);return}})})}m(v){return this.f?(0,u.localize)(30,null,v,this.f):(0,u.localize)(31,null,v)}};e.$Vp=w,e.$Vp=w=me([se(1,a.$Qo),se(2,a.$No)],w)}),define(ie[144],ne([0,1,9,7,2,15,17,44,3,28,24,49,29,18,21,26,64,13,4]),function(J,e,N,D,R,L,A,S,u,a,y,E,d,m,w,k,v,c,p){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=void 0;let h=class extends R.$Tc{static{$=this}static{this.c=".sigzip"}constructor(i,r,t,n,s,o){super(),this.h=r,this.j=t,this.m=n,this.n=s,this.r=o,this.extensionsDownloadDir=i.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(i,r,t){await this.g;const n=(0,A.$Sg)(this.extensionsDownloadDir,this.z(i));try{await this.w(i,n,o=>this.j.download(i,o,r))}catch(o){throw new w.$Oo(o.message,w.ExtensionManagementErrorCode.Download)}let s=!1;if(t&&this.t(i)){const o=await this.u(i);try{s=await this.n.verify(n.fsPath,o.fsPath,this.r.getLevel()===p.LogLevel.Trace)}catch(l){const O=l;if(s=O.code,O.output&&this.r.trace(`Extension signature verification details for ${i.identifier.id} ${i.version}:
${O.output}`),s===w.ExtensionSignaturetErrorCode.PackageIsInvalidZip||s===w.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip){try{await this.delete(n)}catch(I){this.r.error(I)}throw new w.$Oo(E.$Zp,w.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(o)}catch(l){this.r.error(l)}}}return s===!0?this.r.info(`Extension signature is verified: ${i.identifier.id}`):s===!1?this.r.info(`Extension signature verification is not done: ${i.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${s}': ${i.identifier.id}`),{location:n,verificationStatus:s}}t(i){if(!i.isSigned)return this.r.info(`Extension is not signed: ${i.identifier.id}`),!1;const r=this.m.getValue("extensions.verifySignature");return(0,u.$Yf)(r)?r:!0}async u(i){await this.g;const r=(0,A.$Sg)(this.extensionsDownloadDir,`${this.z(i)}${$.c}`);try{await this.w(i,r,t=>this.j.downloadSignatureArchive(i,t))}catch(t){throw new w.$Oo(t.message,w.ExtensionManagementErrorCode.DownloadSignature)}return r}async w(i,r,t){if(await this.h.exists(r))return;if(r.scheme!==L.Schemas.file){await t(r);return}const n=(0,A.$Sg)(this.extensionsDownloadDir,`.${(0,a.$Bg)()}`);await this.h.exists(n)||await t(n);try{await y.Promises.rename(n.fsPath,r.fsPath,2*60*1e3)}catch(s){try{await this.h.del(n)}catch{}if(s.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",i.identifier.id,r.path);else throw this.r.info(`Rename failed because of ${(0,D.$0)(s)}. Deleted the file from downloaded location`,n.path),s}}async delete(i){await this.g,await this.h.del(i)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const i=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(i.children){const r=[],t=[],n=[];for(const l of i.children)if(l.name.endsWith($.c))n.push(l.resource);else{const O=k.$dp.parse(l.name);O&&t.push([O,l])}const s=(0,k.$ip)(t,([l])=>l),o=[];for(const l of s)l.sort((O,I)=>S.rcompare(O[0].version,I[0].version)),r.push(...l.slice(1).map(O=>O[1].resource)),o.push(l[0][1]);o.sort((l,O)=>l.mtime-O.mtime),r.push(...o.slice(0,Math.max(0,o.length-this.f)).map(l=>l.resource)),r.push(...n),await N.Promises.settled(r.map(l=>(this.r.trace("Deleting from cache",l.path),this.h.del(l))))}}catch(i){this.r.error(i)}}z(i){return this.f?k.$dp.create(i).toString().toLowerCase():(0,a.$Bg)()}};e.$gq=h,e.$gq=h=$=me([se(0,m.$ni),se(1,c.$Fk),se(2,w.$No),se(3,d.$Li),se(4,v.$Tp),se(5,p.$zj)],h)}),define(ie[145],ne([0,1,6,2,31,26,37]),function(J,e,N,D,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=void 0;class S extends D.$Tc{constructor(a,y,E,d,m,w,k){super(),this.f=a,this.g=y,this.h=E,this.j=d,this.m=m,this.n=w,this.r=k,this.a=this.B(new N.$5d),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new D.$3c),this.s().then(null,v=>k.error(v))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(a=>this.u(a.added))),this.B(this.j.onAddExtensions(a=>this.w(a))),this.B(this.j.onDidAddExtensions(a=>this.y(a))),this.B(this.j.onRemoveExtensions(a=>this.z(a))),this.B(this.j.onDidRemoveExtensions(a=>this.C(a))),this.B(this.n.onDidFilesChange(a=>this.D(a)))}async u(a){try{a.length&&await Promise.all(a.map(y=>(this.c.set(y.id,(0,D.$Qc)(this.n.watch(this.m.extUri.dirname(y.extensionsResource)),this.n.watch(y.extensionsResource))),this.G(y.extensionsResource))))}catch(y){throw this.r.error(y),y}}async w(a){for(const y of a.extensions)this.I(this.L(y.identifier,y.version),a.profileLocation)}async y(a){for(const y of a.extensions){const E=this.L(y.identifier,y.version);a.error?this.J(E,a.profileLocation):this.I(E,a.profileLocation)}}async z(a){for(const y of a.extensions)this.J(this.L(y.identifier,y.version),a.profileLocation)}async C(a){const y=[],E=[];for(const d of a.extensions){const m=this.L(d.identifier,d.version);a.error?this.I(m,a.profileLocation):(this.J(m,a.profileLocation),this.b.has(m)||(this.r.debug("Extension is removed from all profiles",d.identifier.id,d.version),E.push(this.f.scanInstalledExtensionAtLocation(d.location).then(w=>{w?y.push(w):this.r.info("Extension not found at the location",d.location.toString())},w=>this.r.error(w)))))}try{await Promise.all(E),y.length&&await this.H(y)}catch(d){this.r.error(d)}}D(a){for(const y of this.h.profiles)a.contains(y.extensionsResource,0,1)&&this.F(y.extensionsResource)}async F(a){const y=[],E=[],d=await this.j.scanProfileExtensions(a),m=new Set,w=new Set;for(const[k,v]of this.b)v.has(a)&&w.add(k);for(const k of d){const v=this.L(k.identifier,k.version);m.add(v),w.has(v)||(y.push(k.identifier),this.I(v,a))}for(const k of w)if(!m.has(k)){const v=this.M(k);v&&(E.push(v.identifier),this.J(k,a))}(y.length||E.length)&&this.a.fire({added:y.length?{extensions:y,profileLocation:a}:void 0,removed:E.length?{extensions:E,profileLocation:a}:void 0})}async G(a){const y=await this.j.scanProfileExtensions(a);for(const E of y)this.I(this.L(E.identifier,E.version),a)}async H(a){a||(a=(await this.f.scanAllUserInstalledExtensions()).filter(E=>!this.b.has(this.L(E.identifier,E.manifest.version)))),a.length&&await this.f.markAsUninstalled(...a)}I(a,y){let E=this.b.get(a);E||this.b.set(a,E=new R.$Bc(d=>this.m.extUri.getComparisonKey(d))),E.add(y)}J(a,y){const E=this.b.get(a);E&&E.delete(y),E?.size||this.b.delete(a)}L(a,y){return`${A.$zm.toKey(a.id)}@${y}`}M(a){const[y,E]=(0,L.$ep)(a);return E?{identifier:{id:y},version:E}:void 0}}e.$kq=S}),define(ie[146],ne([0,1,117,41]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=void 0;async function R(L,A,S,u,a,y,E){const d={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${A.nameShort})`};if((0,D.$7o)(A,S)&&(0,D.$9o)(u)===3){const m=await(0,N.$Op)(S,a,y);d["X-Market-User-Id"]=m,d["VSCode-SessionId"]=E.machineId||m}return d}e.$Pp=R}),define(ie[147],ne([0,1,174,19,9,2,15,16,24,18,21,26,4,63,11]),function(J,e,N,D,R,L,A,S,u,a,y,E,d,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xr=void 0;let k=class extends m.$wr{constructor($,h,g,i){super(g),this.h=$,this.j=i,this.g=this.B(new v(h,i)),this.h.registerParticipant({postInstall:async r=>this.m(r),postUninstall:async r=>this.n(r)})}async getBuiltInExtensionTranslationsUri($,h){const i=(await this.g.getLanguagePacks())[h];if(!i){this.j.warn(`No language pack found for ${h}`);return}const r=i.translations[$];return r?w.URI.file(r):void 0}async getInstalledLanguages(){const $=await this.g.getLanguagePacks(),h=Object.keys($).map(g=>{const i=$[g];return{...this.f(g,i.label),extensionId:i.extensions[0].extensionIdentifier.id}});return h.push(this.f("en","English")),h.sort((g,i)=>g.label.localeCompare(i.label)),h}async m($){$&&$.manifest&&$.manifest.contributes&&$.manifest.contributes.localizations&&$.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",$.identifier.id),await this.update())}async n($){const h=await this.g.getLanguagePacks();Object.keys(h).some(g=>h[g]&&h[g].extensions.some(i=>(0,E.$cp)(i.extensionIdentifier,$.identifier)))&&(this.j.info("Removing language packs from the extension",$.identifier.id),await this.update())}async update(){const[$,h]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),g=await this.g.update(h);return!(0,D.$ub)(Object.keys($),Object.keys(g))}};e.$xr=k,e.$xr=k=me([se(0,y.$Qo),se(1,a.$ni),se(2,y.$No),se(3,d.$zj)],k);let v=class extends L.$Tc{constructor($,h){super(),this.j=h,this.c={},this.f=(0,S.$jc)($.userDataPath,"languagepacks.json"),this.g=new R.$mh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update($){return this.s(h=>{Object.keys(h).forEach(g=>delete h[g]),this.m(h,...$)}).then(()=>this.c)}m($,...h){for(const g of h)g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&this.n($,g);Object.keys($).forEach(g=>this.r($[g]))}n($,h){const g=h.identifier,i=h.manifest.contributes&&h.manifest.contributes.localizations?h.manifest.contributes.localizations:[];for(const r of i)if(h.location.scheme===A.Schemas.file&&c(r)){let t=$[r.languageId];t||(t={hash:"",extensions:[],translations:{},label:r.localizedLanguageName??r.languageName},$[r.languageId]=t);const n=t.extensions.filter(s=>(0,E.$cp)(s.extensionIdentifier,g))[0];n?n.version=h.manifest.version:t.extensions.push({extensionIdentifier:g,version:h.manifest.version});for(const s of r.translations)t.translations[s.id]=(0,S.$jc)(h.location.fsPath,s.path)}}r($){if($){const h=(0,N.createHash)("md5");for(const g of $.extensions)h.update(g.extensionIdentifier.uuid||g.extensionIdentifier.id).update(g.version);$.hash=h.digest("hex")}}s($=()=>null){return this.g.queue(()=>{let h=null;return u.Promises.readFile(this.f,"utf8").then(void 0,g=>g.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(g)).then(g=>{try{return JSON.parse(g)}catch{return{}}}).then(g=>(h=$(g),g)).then(g=>{for(const r of Object.keys(g))g[r]||delete g[r];this.c=g,this.h=!0;const i=JSON.stringify(this.c);return this.j.debug("Writing language packs",i),u.Promises.writeFile(this.f,i)}).then(()=>h,g=>this.j.error(g))})}};v=me([se(0,a.$ni),se(1,d.$zj)],v);function c(p){if(typeof p.languageId!="string"||!Array.isArray(p.translations)||p.translations.length===0)return!1;for(const $ of p.translations)if(typeof $.id!="string"||typeof $.path!="string")return!1;return!(p.languageName&&typeof p.languageName!="string"||p.localizedLanguageName&&typeof p.localizedLanguageName!="string")}}),define(ie[148],ne([0,1,83,7,27,41]),function(J,e,N,D,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vP=void 0;const A="https://mobile.events.data.microsoft.com/OneCollector/1.0",S="https://mobile.events.data.microsoft.com/ping";async function u(y,E,d){const m=await(0,N.$wD)("@microsoft/1ds-core-js","dist/ms.core.js"),w=await(0,N.$wD)("@microsoft/1ds-post-js","dist/ms.post.js"),k=new m.AppInsightsCore,v=new w.PostChannel,c={instrumentationKey:y,endpointUrl:A,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[v]]};if(d){c.extensionConfig={};const p={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:d};c.extensionConfig[v.identifier]=p}return k.initialize(c,[]),k.addTelemetryInitializer(p=>{p.ext=p.ext??{},p.ext.web=p.ext.web??{},p.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',E&&(p.ext.utc=p.ext.utc??{},p.ext.utc.flags=8462029)}),k}class a{constructor(E,d,m,w,k){this.e=E,this.f=d,this.g=m,this.h=k,this.c=A,this.d=S,this.g||(this.g={}),typeof w=="function"?this.a=w():this.a=w,this.b=null}i(E){if(this.a){if(typeof this.a!="string"){E(this.a);return}this.b||(this.b=u(this.a,this.e,this.h)),this.b.then(d=>{E(d)},d=>{(0,D.$1)(d),console.error(d)})}}log(E,d){if(!this.a)return;d=(0,R.$Nn)(d,this.g),d=(0,L.$0o)(d);const m=this.f+"/"+E;try{this.i(w=>{w.pluginVersionString=d?.properties.version??"Unknown",w.track({name:m,baseData:{name:m,properties:d?.properties,measurements:d?.measurements}})})}catch{}}flush(){return this.a?new Promise(E=>{this.i(d=>{d.unload(!0,()=>{this.a=void 0,E(void 0)})})}):Promise.resolve(void 0)}}e.$vP=a}),define(ie[149],ne([0,1,2,27,12,30,108,29,40,150,32,36,25,41]),function(J,e,N,D,R,L,A,S,u,a,y,E,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=void 0;let w=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(c,p,$){this.k=p,this.l=$,this.d={},this.i=new N.$Sc,this.j=[],this.b=c.appenders,this.c=c.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=c.piiPaths||[],this.g=3,this.h=!!c.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const h of this.f)this.j.push(new RegExp((0,L.$Xe)(h),"gi")),h.indexOf("\\")>=0&&this.j.push(new RegExp((0,L.$Xe)(h.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(h=>{(h.affectsConfiguration(d.$Ml)||h.affectsConfiguration(d.$Ol)||h.affectsConfiguration(d.$Nl))&&this.m()}))}setExperimentProperty(c,p){this.d[c]=p}m(){let c=(0,m.$9o)(this.k);const p=this.l.enabledTelemetryLevels;if(p){this.h=this.sendErrorTelemetry?p.error:!1;const $=p.usage?3:p.error?2:0;c=Math.min(c,$)}this.g=c}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(c,p,$){this.g<p||($=(0,D.$Nn)($,this.d),$=(0,m.$bp)($,this.j),$=(0,D.$Nn)($,this.c),this.b.forEach(h=>h.log(c,$)))}publicLog(c,p){this.n(c,3,p)}publicLog2(c,p){this.publicLog(c,p)}publicLogError(c,p){this.h&&this.n(c,2,p)}publicLogError2(c,p){this.publicLogError(c,p)}};e.$Dr=w,e.$Dr=w=me([se(1,S.$Li),se(2,y.$Rj)],w);function k(){const v=(0,A.localize)(0,null,a.default.nameLong),c=a.default.privacyStatementUrl?(0,A.localize)(2,null,"https://aka.ms/vscode-telemetry",a.default.privacyStatementUrl):(0,A.localize)(1,null,"https://aka.ms/vscode-telemetry"),p=R.$o?"":(0,A.localize)(3,null),$=(0,A.localize)(4,null),h=(0,A.localize)(5,null),g=(0,A.localize)(6,null),i=(0,A.localize)(7,null),r=`
|       | ${$} | ${h} | ${g} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,A.localize)(8,null);return`
${v} ${c} ${p}

&nbsp;

${i}
${r}

&nbsp;

${t}
`}E.$Wn.as(u.$2n.Configuration).registerConfiguration({id:d.$Ll,order:1,type:"object",title:(0,A.localize)(9,null),properties:{[d.$Ml]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,A.localize)(10,null),(0,A.localize)(11,null),(0,A.localize)(12,null),(0,A.localize)(13,null)],markdownDescription:k(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),E.$Wn.as(u.$2n.Configuration).registerConfiguration({id:d.$Ll,order:110,type:"object",title:(0,A.localize)(14,null),properties:{[d.$Ol]:{type:"boolean",markdownDescription:a.default.privacyStatementUrl?(0,A.localize)(16,null,a.default.nameLong,a.default.privacyStatementUrl):(0,A.localize)(15,null,a.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,A.localize)(17,null,`\`#${d.$Ml}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ie[151],ne([0,1,14,20,175,148]),function(J,e,N,D,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wP=void 0;async function A(y,E){const d=await E.request(y,D.CancellationToken.None),m=(await(0,N.$Ee)(d.stream)).toString(),w=d.res.statusCode??200;return{headers:d.res.headers,statusCode:w,responseData:m}}async function S(y){const E={method:y.type,headers:y.headers};return new Promise((m,w)=>{const k=R.request(y.url??"",E,v=>{v.on("data",function(c){m({headers:v.headers,statusCode:v.statusCode??200,responseData:c.toString()})}),v.on("error",function(c){w(c)})});k.write(y.data,v=>{v&&w(v)}),k.end()})}async function u(y,E,d){const m=typeof E.data=="string"?E.data:new TextDecoder().decode(E.data),w={type:"POST",headers:{...E.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(E.data).toString()},url:E.urlString,data:m};try{const k=y?await A(w,y):await S(w);d(k.statusCode,k.headers,k.responseData)}catch{d(0,{})}}class a extends L.$vP{constructor(E,d,m,w,k){const v={sendPOST:(c,p)=>{u(E,c,p)}};super(d,m,w,k,v)}}e.$wP=a}),define(ie[152],ne([0,1,16,24]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0ac=void 0;async function R(L,A){const S=Object.create(null),u=(y,E)=>{const d=JSON.parse(y);S[E]=d};if(A){const y=[],E=await D.Promises.readdir(A);for(const m of E)try{(await D.Promises.stat((0,N.$jc)(A,m))).isDirectory()&&y.push(m)}catch{}const d=[];for(const m of y)(await D.Promises.readdir((0,N.$jc)(A,m))).filter(k=>k==="telemetry.json").length===1&&d.push(m);for(const m of d){const w=(await D.Promises.readFile((0,N.$jc)(A,m,"telemetry.json"))).toString();u(w,m)}}let a=(await D.Promises.readFile((0,N.$jc)(L,"telemetry-core.json"))).toString();return u(a,"vscode-core"),a=(await D.Promises.readFile((0,N.$jc)(L,"telemetry-extensions.json"))).toString(),u(a,"vscode-extensions"),JSON.stringify(S,null,4)}e.$0ac=R}),define(ie[153],ne([0,1,12,84,25]),function(J,e,N,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oac=e.$nac=void 0;async function L(S,u){let a=S.getItem(R.$Jl);return(typeof a!="string"||N.$j&&a==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(a=await(0,D.$nn)(u.error.bind(u))),a}e.$nac=L;async function A(S,u){let a=S.getItem(R.$Kl);return typeof a!="string"&&(a=await(0,D.$on)(u.error.bind(u))),a}e.$oac=A}),define(ie[22],ne([0,1,10]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dl=void 0,e.$dl=(0,N.$fi)("IUriIdentityService")}),define(ie[154],ne([0,1,22,118,13,17,75,6,2]),function(J,e,N,D,R,L,A,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ds=void 0;class a{static{this._clock=0}constructor(d){this.uri=d,this.time=a._clock++}touch(){return this.time=a._clock++,this}}let y=class{constructor(d){this.g=d,this.c=new u.$Sc,this.f=2**16;const m=new Map,w=k=>{let v=m.get(k.scheme);return v===void 0&&(v=d.hasProvider(k)&&!this.g.hasCapability(k,1024),m.set(k.scheme,v)),v};this.c.add(S.Event.any(d.onDidChangeFileSystemProviderRegistrations,d.onDidChangeFileSystemProviderCapabilities)(k=>{m.delete(k.scheme)})),this.extUri=new L.$Hg(w),this.d=new A.$cs((k,v)=>this.extUri.compare(k,v,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(d){this.g.hasProvider(d)&&(d=(0,L.$Tg)(d));const m=this.d.get(d);return m?m.touch().uri.with({fragment:d.fragment}):(this.d.set(d,new a(d)),this.h(),d)}h(){if(this.d.size<this.f)return;const d=[...this.d.entries()].sort((w,k)=>w[1].time<k[1].time?1:w[1].time>k[1].time?-1:0);a._clock=0,this.d.clear();const m=this.f*.5;for(let w=0;w<m;w++)this.d.set(d[w][0],d[w][1].touch())}};e.$ds=y,e.$ds=y=me([se(0,R.$Fk)],y),(0,D.$as)(N.$dl,y,1)}),define(ie[155],ne([0,1,6,2,13,48,31]),function(J,e,N,D,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lac=void 0;class S extends D.$Tc{constructor(a,y,E,d,m,w){super(),this.f=a,this.g=y,this.h=E,this.j=d,this.m=m,this.n=w,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new N.$5d),this.onDidChangeFile=this.a.event,this.b=L.$li.forUris(()=>!(this.capabilities&1024)),this.c=new A.$Bc(k=>this.m.extUri.getComparisonKey(this.t(k))),this.r(),this.B(d.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(k=>this.s(k)))}r(){this.c.clear();for(const a of this.j.profiles)this.c.add(a.settingsResource),this.c.add(a.keybindingsResource),this.c.add(a.tasksResource),this.c.add(a.extensionsResource)}open(a,y){return this.g.open(this.t(a),y)}close(a){return this.g.close(a)}read(a,y,E,d,m){return this.g.read(a,y,E,d,m)}write(a,y,E,d,m){return this.g.write(a,y,E,d,m)}watch(a,y){this.b.set(a,a);const E=this.g.watch(this.t(a),y);return(0,D.$Rc)(()=>{this.b.delete(a),E.dispose()})}stat(a){return this.g.stat(this.t(a))}mkdir(a){return this.g.mkdir(this.t(a))}rename(a,y,E){return this.g.rename(this.t(a),this.t(y),E)}readFile(a,y){return this.g.readFile(this.t(a),y)}readFileStream(a,y,E){return this.g.readFileStream(this.t(a),y,E)}readdir(a){return this.g.readdir(this.t(a))}enforceAtomicReadFile(a){return this.c.has(a)}writeFile(a,y,E){return this.g.writeFile(this.t(a),y,E)}enforceAtomicWriteFile(a){return this.c.has(a)?{postfix:".vsctmp"}:!1}delete(a,y){return this.g.delete(this.t(a),y)}copy(a,y,E){if((0,R.$Jk)(this.g))return this.g.copy(this.t(a),this.t(y),E);throw new Error("copy not supported")}cloneFile(a,y){if((0,R.$Kk)(this.g))return this.g.cloneFile(this.t(a),this.t(y));throw new Error("clone not supported")}s(a){const y=[];for(const E of a){if(E.resource.scheme!==this.f)continue;const d=this.u(E.resource);this.b.findSubstr(d)&&y.push({resource:d,type:E.type,cId:E.cId})}y.length&&(this.n.debug("User data changed"),this.a.fire(y))}t(a){return a.with({scheme:this.f})}u(a){return a.with({scheme:this.h})}}e.$Lac=S}),define(ie[156],ne([0,1,110,16,48,17,11,10,15]),function(J,e,N,D,R,L,A,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.WorkbenchState=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=void 0,e.$oi=(0,S.$fi)("contextService");function a(n){const s=n;return typeof s?.id=="string"&&A.URI.isUri(s.uri)}e.$pi=a;function y(n){return typeof n?.id=="string"&&!a(n)&&!d(n)}e.$qi=y,e.$ri={id:"ext-dev"},e.$si={id:"empty-window"};function E(n,s){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,D.$nc)(n)}:s?e.$ri:e.$si;const o=n;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}e.$ti=E;function d(n){const s=n;return typeof s?.id=="string"&&A.URI.isUri(s.configPath)}e.$ui=d;function m(n){const s=n;if(s?.uri)return{id:s.id,uri:A.URI.revive(s.uri)};const o=n;if(o?.configPath)return{id:o.id,configPath:A.URI.revive(o.configPath)};if(n?.id)return{id:n.id}}e.$vi=m;var w;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(w||(e.WorkbenchState=w={}));function k(n){const s=n;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}e.$wi=k;function v(n){const s=n;return!!(s&&typeof s=="object"&&A.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}e.$xi=v;class c{constructor(s,o,l,O,I){this.h=s,this.j=l,this.k=O,this.l=I,this.c=R.$li.forUris(this.l,()=>!0),this.folders=o}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=R.$li.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$yi=c;class p{constructor(s,o){this.raw=o,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,L.$Sg)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$zi=p;function $(n){return new p({uri:n,index:0,name:(0,L.$Og)(n)},{uri:n.toString()})}e.$Ai=$,e.$Bi="code-workspace",e.$Ci=`.${e.$Bi}`,e.$Di=[{name:(0,N.localize)(0,null),extensions:[e.$Bi]}],e.$Ei="workspace.json";function h(n,s){return L.$Jg.isEqualOrParent(n,s.untitledWorkspacesHome)}e.$Fi=h;function g(n){let s;return A.URI.isUri(n)?s=n:s=n.configuration,s?.scheme===u.Schemas.tmp}e.$Gi=g,e.$Hi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(n){return n.id===e.$Hi}e.$Ii=i;function r(n,s){return!h(n,s)&&!g(n)}e.$Ji=r;function t(n){return(typeof n=="string"?(0,D.$oc)(n):(0,L.$Qg)(n))===e.$Ci}e.$Ki=t}),define(ie[23],ne([0,1,43,6,2,17,11,109,18,13,10,4,156,31,22,9,28,30,3]),function(J,e,N,D,R,L,A,S,u,a,y,E,d,m,w,k,v,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jl=e.$il=e.$hl=e.$gl=e.$fl=e.$el=e.ProfileResourceType=void 0;var $;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState"})($||(e.ProfileResourceType=$={}));function h(n){const s=n;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&A.URI.isUri(s.location)&&A.URI.isUri(s.globalStorageHome)&&A.URI.isUri(s.settingsResource)&&A.URI.isUri(s.keybindingsResource)&&A.URI.isUri(s.tasksResource)&&A.URI.isUri(s.snippetsHome)&&A.URI.isUri(s.extensionsResource))}e.$el=h,e.$fl=(0,y.$fi)("IUserDataProfilesService");function g(n,s){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,icon:n.icon,location:A.URI.revive(n.location).with({scheme:s}),globalStorageHome:A.URI.revive(n.globalStorageHome).with({scheme:s}),settingsResource:A.URI.revive(n.settingsResource).with({scheme:s}),keybindingsResource:A.URI.revive(n.keybindingsResource).with({scheme:s}),tasksResource:A.URI.revive(n.tasksResource).with({scheme:s}),snippetsHome:A.URI.revive(n.snippetsHome).with({scheme:s}),extensionsResource:A.URI.revive(n.extensionsResource).with({scheme:s}),cacheHome:A.URI.revive(n.cacheHome).with({scheme:s}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.$gl=g;function i(n,s,o,l,O,I){return{id:n,name:s,location:o,isDefault:!1,shortName:O?.shortName,icon:O?.icon,globalStorageHome:I&&O?.useDefaultFlags?.globalState?I.globalStorageHome:(0,L.$Sg)(o,"globalStorage"),settingsResource:I&&O?.useDefaultFlags?.settings?I.settingsResource:(0,L.$Sg)(o,"settings.json"),keybindingsResource:I&&O?.useDefaultFlags?.keybindings?I.keybindingsResource:(0,L.$Sg)(o,"keybindings.json"),tasksResource:I&&O?.useDefaultFlags?.tasks?I.tasksResource:(0,L.$Sg)(o,"tasks.json"),snippetsHome:I&&O?.useDefaultFlags?.snippets?I.snippetsHome:(0,L.$Sg)(o,"snippets"),extensionsResource:I&&O?.useDefaultFlags?.extensions?I.extensionsResource:(0,L.$Sg)(o,"extensions.json"),cacheHome:(0,L.$Sg)(l,n),useDefaultFlags:O?.useDefaultFlags,isTransient:O?.transient}}e.$hl=i;let r=class extends R.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(s,o,l,O){super(),this.t=s,this.u=o,this.w=l,this.y=O,this.f=!0,this.h=this.B(new D.$5d),this.onDidChangeProfiles=this.h.event,this.j=this.B(new D.$5d),this.onWillCreateProfile=this.j.event,this.m=this.B(new D.$5d),this.onWillRemoveProfile=this.m.event,this.n=this.B(new D.$5d),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new m.$Ac,emptyWindows:new Map},this.profilesHome=(0,L.$Sg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,L.$Sg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(s){this.f!==s&&(this.z=void 0,this.f=s)}isEnabled(){return this.f}get C(){if(!this.z){const s=this.D(),o=[s];if(this.f)try{for(const I of this.O()){if(!I.name||!(0,p.$Sf)(I.name)||!I.location){this.y.warn("Skipping the invalid stored profile",I.location||I.name);continue}o.push(i((0,L.$Pg)(I.location),I.name,I.location,this.g,{shortName:I.shortName,icon:I.icon,useDefaultFlags:I.useDefaultFlags},s))}}catch(I){this.y.error(I)}const l=new m.$Ac,O=new Map;if(o.length)try{const I=this.Q();if(I.workspaces)for(const[b,j]of Object.entries(I.workspaces)){const q=A.URI.parse(b),Y=o.find(K=>K.id===j);Y&&l.set(q,Y)}if(I.emptyWindows)for(const[b,j]of Object.entries(I.emptyWindows)){const q=o.find(Y=>Y.id===j);q&&O.set(b,q)}}catch(I){this.y.error(I)}this.z={profiles:o,workspaces:l,emptyWindows:O}}return this.z}D(){const s=i("__default__profile__",(0,S.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...s,extensionsResource:this.S()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const o="Temp",l=new RegExp(`${(0,c.$Xe)(o)}\\s(\\d+)`);let O=0;for(const b of this.profiles){const j=l.exec(b.name),q=j?parseInt(j[1]):0;O=q>O?q:O}const I=`${o} ${O+1}`;return this.createProfile((0,N.$6i)((0,v.$Bg)()).toString(16),I,{transient:!0},s)}async createNamedProfile(s,o,l){return this.createProfile((0,N.$6i)((0,v.$Bg)()).toString(16),s,o,l)}async createProfile(s,o,l,O){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const I=await this.F(s,o,l);return O&&await this.setProfileForWorkspace(O,I),I}async F(s,o,l){if(!(0,p.$Sf)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let O=this.r.get(o);return O||(O=(async()=>{try{const I=this.profiles.find(q=>q.name===o||q.id===s);if(I)return I;const b=i(s,o,(0,L.$Sg)(this.profilesHome,s),this.g,l,this.defaultProfile);await this.u.createFolder(b.location);const j=[];return this.j.fire({profile:b,join(q){j.push(q)}}),await k.Promises.settled(j),this.I([b],[],[]),b}finally{this.r.delete(o)}})(),this.r.set(o,O)),O}async updateProfile(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let l=this.profiles.find(O=>O.id===s.id);if(!l)throw new Error(`Profile '${s.name}' does not exist`);return l=i(l.id,o.name??l.name,l.location,this.g,{shortName:o.shortName??l.shortName,icon:o.icon===null?void 0:o.icon??l.icon,transient:o.transient??l.isTransient,useDefaultFlags:o.useDefaultFlags??l.useDefaultFlags},this.defaultProfile),this.I([],[],[l]),l}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(O=>O.id===s.id);if(!o)throw new Error(`Profile '${s.name}' does not exist`);const l=[];this.m.fire({profile:o,join(O){l.push(O)}});try{await Promise.allSettled(l)}catch(O){this.y.error(O)}for(const O of[...this.C.emptyWindows.keys()])o.id===this.C.emptyWindows.get(O)?.id&&this.C.emptyWindows.delete(O);for(const O of[...this.C.workspaces.keys()])o.id===this.C.workspaces.get(O)?.id&&this.C.workspaces.delete(O);this.M(),this.I([],[o],[]);try{await this.u.del(o.cacheHome,{recursive:!0})}catch(O){(0,a.$Wk)(O)!==1&&this.y.error(O)}}async setProfileForWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const l=this.profiles.find(O=>O.id===o.id);if(!l)throw new Error(`Profile '${o.name}' does not exist`);this.L(s,l)}unsetWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(s,void 0,o)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const s=await this.u.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(o=>o.isDirectory&&this.profiles.every(l=>!this.w.extUri.isEqual(l.location,o.resource))).map(o=>this.u.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.s.profiles.filter(o=>!this.H(o));await Promise.allSettled(s.map(o=>this.removeProfile(o)))}getProfileForWorkspace(s){const o=this.G(s);return A.URI.isUri(o)?this.s.workspaces.get(o)??this.C.workspaces.get(o):this.s.emptyWindows.get(o)??this.C.emptyWindows.get(o)}G(s){return(0,d.$pi)(s)?s.uri:(0,d.$ui)(s)?s.configPath:s.id}H(s){return!!([...this.s.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.s.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.C.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.C.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location)))}I(s,o,l){const O=[...this.profiles,...s],I=[];this.s.profiles=[];for(let b of O)b.isDefault||o.some(j=>b.id===j.id)||(b=l.find(j=>b.id===j.id)??b,b.isTransient?this.s.profiles.push(b):I.push({location:b.location,name:b.name,shortName:b.shortName,icon:b.icon,useDefaultFlags:b.useDefaultFlags}));this.P(I),this.z=void 0,this.J(s,o,l)}J(s,o,l){this.h.fire({added:s,removed:o,updated:l,all:this.profiles})}L(s,o,l){l=o?.isTransient?!0:l,l||this.L(s,void 0,!0);const O=this.G(s),I=l?this.s:this.C;A.URI.isUri(O)?(I.workspaces.delete(O),o&&I.workspaces.set(O,o)):(I.emptyWindows.delete(O),o&&I.emptyWindows.set(O,o)),l||this.M()}M(){const s={};for(const[l,O]of this.C.workspaces.entries())s[l.toString()]=O.id;const o={};for(const[l,O]of this.C.emptyWindows.entries())o[l.toString()]=O.id;this.R({workspaces:s,emptyWindows:o}),this.z=void 0}N(s){const o={},l=this.D();if(s.workspaces)for(const[I,b]of Object.entries(s.workspaces)){const j=A.URI.parse(b);o[I]=this.w.extUri.isEqual(j,l.location)?l.id:this.w.extUri.basename(j)}const O={};if(s.emptyWindows)for(const[I,b]of Object.entries(s.emptyWindows)){const j=A.URI.parse(b);O[I]=this.w.extUri.isEqual(j,l.location)?l.id:this.w.extUri.basename(j)}return{workspaces:o,emptyWindows:O}}O(){return[]}P(s){throw new Error("not implemented")}Q(){return{}}R(s){throw new Error("not implemented")}S(){}};e.$il=r,e.$il=r=me([se(0,u.$mi),se(1,a.$Fk),se(2,w.$dl),se(3,E.$zj)],r);class t extends r{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(s){this.a=s}Q(){return this.X}R(s){this.X=s}}e.$jl=t}),define(ie[157],ne([0,1,19,9,20,7,6,2,12,3,11,94,21,26,37,4,32,25,22,23]),function(J,e,N,D,R,L,A,S,u,a,y,E,d,m,w,k,v,c,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=e.$7p=e.$6p=e.$5p=void 0;let h=class extends S.$Tc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(s,o,l,O,I,b){super(),this.z=s,this.C=o,this.D=l,this.F=O,this.G=I,this.H=b,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new A.$5d),this.s=this.B(new A.$5d),this.t=this.B(new A.$5d),this.u=this.B(new A.$5d),this.w=this.B(new A.$5d),this.y=[],this.B((0,S.$Rc)(()=>{this.j.forEach(({task:j})=>j.cancel()),this.m.forEach(j=>j.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(s){const o=await this.getTargetPlatform();return s.allTargetPlatforms.some(l=>(0,d.$Lo)(l,s.allTargetPlatforms,o))}async installFromGallery(s,o={}){try{const O=(await this.installGalleryExtensions([{extension:s,options:o}])).find(({identifier:I})=>(0,m.$cp)(I,s.identifier));if(O?.local)return O?.local;throw O?.error?O.error:new d.$Oo(`Unknown error while installing extension ${s.identifier.id}`,d.ExtensionManagementErrorCode.Unknown)}catch(l){throw i(l)}}async installGalleryExtensions(s){if(!this.z.isEnabled())throw new d.$Oo(E.localize(0,null),d.ExtensionManagementErrorCode.NotAllowed);const o=[],l=[];await Promise.allSettled(s.map(async({extension:O,options:I})=>{try{const b=await this.N(O,!!I?.installGivenVersion,!!I?.installPreReleaseVersion);l.push({...b,options:I})}catch(b){o.push({identifier:O.identifier,operation:2,source:O,error:b})}})),l.length&&o.push(...await this.I(l));for(const O of o)O.error&&(this.F.error("Failed to install extension.",O.identifier.id),this.F.error(O.error),O.source&&!y.URI.isUri(O.source)&&r(this.C,"extensionGallery:install",{extensionData:(0,m.$kp)(O.source),error:O.error}));return o}async uninstall(s,o={}){return this.F.trace("ExtensionManagementService#uninstall",s.identifier.id),this.P(s,o)}async toggleAppliationScope(s,o){if((0,w.$Cm)(s.manifest)||s.isBuiltin)return s;if(s.isApplicationScoped){let l=await this.updateMetadata(s,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(o,this.H.defaultProfile.extensionsResource)||(l=await this.$(s,this.H.defaultProfile.extensionsResource,o));for(const O of this.H.profiles){const I=(await this.getInstalled(1,O.extensionsResource)).find(b=>(0,m.$cp)(b.identifier,s.identifier));I?this.w.fire(I):this.u.fire({identifier:s.identifier,profileLocation:O.extensionsResource})}return l}else{const l=this.D.extUri.isEqual(o,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(s,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(s,o,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:l.identifier,operation:2,local:l,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),l}}getExtensionsControlManifest(){const s=new Date().getTime();return(!this.g||s-this.h>1e3*60*5)&&(this.g=this.W(),this.h=s),this.g}registerParticipant(s){this.y.push(s)}async I(s){const o=[],l=new Map,O=[],I=[],b=(q,Y)=>`${m.$dp.create(q).toString()}-${Y.toString()}`,j=(q,Y,K)=>{const oe=this.Y(q,Y,K),re=y.URI.isUri(Y)?Y.path:`${Y.identifier.id.toLowerCase()}-${K.profileLocation.toString()}`;l.set(re,{task:oe,manifest:q}),this.n.fire({identifier:oe.identifier,source:Y,profileLocation:K.profileLocation}),this.F.info("Installing extension:",oe.identifier.id),y.URI.isUri(Y)||this.j.set(b(Y,K.profileLocation),{task:oe,waitingTasks:[]})};try{for(const{manifest:q,extension:Y,options:K}of s){const oe=K.isApplicationScoped||K.isBuiltin||(0,w.$Cm)(q),re={...K,installOnlyNewlyAddedFromExtensionPack:K.installOnlyNewlyAddedFromExtensionPack??!y.URI.isUri(Y),isApplicationScoped:oe,profileLocation:oe?this.H.defaultProfile.extensionsResource:K.profileLocation??this.X()},he=y.URI.isUri(Y)?void 0:this.j.get(b(Y,re.profileLocation));he?(this.F.info("Extension is already requested to install",he.task.identifier.id),O.push(he.task.waitUntilTaskIsFinished())):j(q,Y,re)}await Promise.all([...l.values()].map(async({task:q,manifest:Y})=>{if(q.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",q.identifier.id);else try{const K=await this.M(q.identifier,Y,!!q.options.installOnlyNewlyAddedFromExtensionPack,!!q.options.installPreReleaseVersion,q.options.profileLocation),oe=await this.getInstalled(void 0,q.options.profileLocation),re={...q.options,donotIncludePackAndDependencies:!0,context:{...q.options.context,[d.$Go]:!0}};for(const{gallery:he,manifest:de}of(0,N.$Mb)(K,({gallery:ae})=>ae.identifier.id)){if(l.has(`${he.identifier.id.toLowerCase()}-${re.profileLocation.toString()}`))continue;const ae=this.j.get(b(he,re.profileLocation));if(ae){if(this.J(q,ae.task)){const B=ae.task.identifier;this.F.info("Waiting for already requested installing extension",B.id,q.identifier.id),ae.waitingTasks.push(q),O.push(A.Event.toPromise(A.Event.filter(this.onDidInstallExtensions,X=>X.some(T=>(0,m.$cp)(T.identifier,B)))).then(X=>{if(this.F.info("Finished waiting for already requested installing extension",B.id,q.identifier.id),!X.find(M=>(0,m.$cp)(M.identifier,B))?.local)throw new Error(`Extension ${B.id} is not installed`)}))}}else oe.some(({identifier:B})=>(0,m.$cp)(B,he.identifier))||j(de,he,re)}}catch(K){if(y.URI.isUri(q.source))(0,N.$Lb)(Y.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",q.identifier.id,K.message),(0,N.$Lb)(Y.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",q.identifier.id,K.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",q.identifier.id),K}})),await this.L([...l.values()].map(async({task:q})=>{const Y=new Date().getTime();try{const K=await q.run();if(await this.L(this.y.map(oe=>oe.postInstall(K,q.source,q.options,R.CancellationToken.None))),!y.URI.isUri(q.source)){const oe=q.operation===3,re=oe?void 0:(new Date().getTime()-q.source.lastUpdated)/1e3;if(r(this.C,oe?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.$kp)(q.source),verificationStatus:q.verificationStatus,duration:new Date().getTime()-Y,durationSinceUpdate:re}),u.$o&&q.operation!==3)try{await this.z.reportStatistic(K.manifest.publisher,K.manifest.name,K.manifest.version,"install")}catch{}}I.push({local:K,identifier:q.identifier,operation:q.operation,source:q.source,context:q.options.context,profileLocation:q.profileLocation,applicationScoped:K.isApplicationScoped})}catch(K){throw this.F.error("Error while installing the extension",q.identifier.id,(0,L.$0)(K)),K}})),O.length&&await this.L(O);for(const q of I)this.F.info("Extension installed successfully:",q.identifier.id),o.push(q);return o}catch(q){I.length&&await Promise.allSettled(I.map(async({local:Y,profileLocation:K})=>{try{await this.Z(Y,{versionOnly:!0,profileLocation:K}).run(),this.F.info("Rollback: Uninstalled extension",Y.identifier.id)}catch(oe){this.F.warn("Rollback: Error while uninstalling extension",Y.identifier.id,(0,L.$0)(oe))}}));for(const{task:Y}of l.values())Y.cancel(),o.push({identifier:Y.identifier,operation:2,source:Y.source,context:Y.options.context,profileLocation:Y.profileLocation,error:q});throw q}finally{for(const{task:q}of l.values())q.source&&!y.URI.isUri(q.source)&&this.j.delete(b(q.source,q.profileLocation));o.length&&this.s.fire(o)}}J(s,o){for(const[,{task:l,waitingTasks:O}]of this.j.entries())if(l===s&&(O.includes(o)||O.some(I=>this.J(I,o)))||l===o&&O[0]&&!this.J(s,O[0]))return!1;return!0}async L(s){const o=[],l=[],O=await Promise.allSettled(s);for(const I of O)I.status==="fulfilled"?o.push(I.value):l.push(I.reason);if(l.length)throw g(l);return o}async M(s,o,l,O,I){if(!this.z.isEnabled())return[];const b=await this.getInstalled(void 0,I),j=[],q=[],Y=async(K,oe)=>{j.push(K);const re=oe.extensionDependencies||[],he=[...re];if(oe.extensionPack){const de=l?b.find(ae=>(0,m.$cp)(ae.identifier,K)):void 0;for(const ae of oe.extensionPack)de&&de.manifest.extensionPack&&de.manifest.extensionPack.some(B=>(0,m.$cp)({id:B},{id:ae}))||he.every(B=>!(0,m.$cp)({id:B},{id:ae}))&&he.push(ae)}if(he.length){const de=he.filter(ae=>j.every(B=>!(0,m.$cp)(B,{id:ae})));if(de.length){const ae=await this.z.getExtensions(de.map(B=>({id:B,preRelease:O})),R.CancellationToken.None);for(const B of ae){if(j.find(M=>(0,m.$cp)(M,B.identifier)))continue;const X=re.some(M=>(0,m.$cp)({id:M},B.identifier));let T;try{T=await this.N(B,!1,O)}catch(M){if(X)throw M;this.F.info("Skipping the packed extension as it cannot be installed",B.identifier.id,(0,L.$0)(M));continue}q.push({gallery:T.extension,manifest:T.manifest}),await Y(T.extension.identifier,T.manifest)}}}};return await Y(s,o),q}async N(s,o,l){let O;const I=await this.getExtensionsControlManifest();if(I.malicious.some(q=>(0,m.$cp)(s.identifier,q)))throw new d.$Oo(E.localize(1,null,s.identifier.id),d.ExtensionManagementErrorCode.Malicious);const b=I.deprecated[s.identifier.id.toLowerCase()];if(b?.extension?.autoMigrate){if(this.F.info(`The '${s.identifier.id}' extension is deprecated, fetching the compatible '${b.extension.id}' extension instead.`),O=(await this.z.getExtensions([{id:b.extension.id,preRelease:b.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},R.CancellationToken.None))[0],!O)throw new d.$Oo(E.localize(2,null,s.identifier.id,b.extension.id),d.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(s)){const q=await this.getTargetPlatform();throw new d.$Oo(E.localize(3,null,s.identifier.id,this.G.nameLong,(0,d.$Ho)(q)),d.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(O=await this.O(s,o,l),!O)throw!l&&s.properties.isPreReleaseVersion&&(await this.z.getExtensions([s.identifier],R.CancellationToken.None))[0]?new d.$Oo(E.localize(4,null,s.displayName??s.identifier.id),d.ExtensionManagementErrorCode.ReleaseVersionNotFound):new d.$Oo(E.localize(5,null,s.identifier.id,this.G.nameLong,this.G.version),d.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",O.identifier.id);const j=await this.z.getManifest(O,R.CancellationToken.None);if(j===null)throw new d.$Oo(`Missing manifest for extension ${O.identifier.id}`,d.ExtensionManagementErrorCode.Invalid);if(j.version!==O.version)throw new d.$Oo(`Cannot install '${O.identifier.id}' extension because of version mismatch in Marketplace`,d.ExtensionManagementErrorCode.Invalid);return{extension:O,manifest:j}}async O(s,o,l){const O=await this.getTargetPlatform();let I=null;return!o&&s.hasPreReleaseVersion&&s.properties.isPreReleaseVersion!==l&&(I=(await this.z.getExtensions([{...s.identifier,preRelease:l}],{targetPlatform:O,compatible:!0},R.CancellationToken.None))[0]||null),!I&&await this.z.isExtensionCompatible(s,l,O)&&(I=s),I||(o?I=(await this.z.getExtensions([{...s.identifier,version:s.version}],{targetPlatform:O,compatible:!0},R.CancellationToken.None))[0]||null:I=await this.z.getCompatibleExtension(s,l,O)),I}async P(s,o){const l={...o,profileLocation:s.isApplicationScoped?this.H.defaultProfile.extensionsResource:o.profileLocation??this.X()},O=K=>`${K.id.toLowerCase()}${l.versionOnly?`-${s.manifest.version}`:""}${l.profileLocation?`@${l.profileLocation.toString()}`:""}`,I=this.m.get(O(s.identifier));if(I)return this.F.info("Extensions is already requested to uninstall",s.identifier.id),I.waitUntilTaskIsFinished();const b=K=>{const oe=this.Z(K,l);return this.m.set(O(oe.extension.identifier),oe),l.profileLocation?this.F.info("Uninstalling extension from the profile:",`${K.identifier.id}@${K.manifest.version}`,l.profileLocation.toString()):this.F.info("Uninstalling extension:",`${K.identifier.id}@${K.manifest.version}`),this.t.fire({identifier:K.identifier,profileLocation:l.profileLocation,applicationScoped:K.isApplicationScoped}),oe},j=(K,oe)=>{oe?l.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${K.identifier.id}@${K.manifest.version}`,l.profileLocation.toString(),oe.message):this.F.error("Failed to uninstall extension:",`${K.identifier.id}@${K.manifest.version}`,oe.message):l.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${K.identifier.id}@${K.manifest.version}`,l.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${K.identifier.id}@${K.manifest.version}`),r(this.C,"extensionGallery:uninstall",{extensionData:(0,m.$jp)(K),error:oe}),this.u.fire({identifier:K.identifier,error:oe?.code,profileLocation:l.profileLocation,applicationScoped:K.isApplicationScoped})},q=[],Y=[];try{q.push(b(s));const K=await this.getInstalled(1,l.profileLocation);if(l.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${s.identifier.id}@${s.manifest.version}`);else{const oe=this.S(s,K);for(const re of oe)this.m.has(O(re.identifier))?this.F.info("Extensions is already requested to uninstall",re.identifier.id):q.push(b(re))}l.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${s.identifier.id}@${s.manifest.version}`):this.Q(q.map(oe=>oe.extension),K,s),await this.L(q.map(async oe=>{try{if(await oe.run(),await this.L(this.y.map(re=>re.postUninstall(oe.extension,l,R.CancellationToken.None))),oe.extension.identifier.uuid)try{await this.z.reportStatistic(oe.extension.manifest.publisher,oe.extension.manifest.name,oe.extension.manifest.version,"uninstall")}catch{}j(oe.extension)}catch(re){const he=re instanceof d.$Oo?re:new d.$Oo((0,L.$0)(re),d.ExtensionManagementErrorCode.Internal);throw j(oe.extension,he),he}finally{Y.push(oe)}}))}catch(K){const oe=K instanceof d.$Oo?K:new d.$Oo((0,L.$0)(K),d.ExtensionManagementErrorCode.Internal);for(const re of q){try{re.cancel()}catch{}Y.includes(re)||j(re.extension,oe)}throw oe}finally{for(const K of q)this.m.delete(O(K.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",K.extension.identifier.id)}}Q(s,o,l){for(const O of s){const I=this.U(O,o);if(I.length){const b=I.filter(j=>!s.some(q=>(0,m.$cp)(q.identifier,j.identifier)));if(b.length)throw new Error(this.R(O,b,l))}}}R(s,o,l){return l===s?o.length===1?E.localize(6,null,l.manifest.displayName||l.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?E.localize(7,null,l.manifest.displayName||l.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):E.localize(8,null,l.manifest.displayName||l.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?E.localize(9,null,l.manifest.displayName||l.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?E.localize(10,null,l.manifest.displayName||l.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):E.localize(11,null,l.manifest.displayName||l.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}S(s,o,l=[]){if(l.indexOf(s)!==-1)return[];l.push(s);const O=s.manifest.extensionPack?s.manifest.extensionPack:[];if(O.length){const I=o.filter(j=>!j.isBuiltin&&O.some(q=>(0,m.$cp)({id:q},j.identifier))),b=[];for(const j of I)b.push(...this.S(j,o,l));return[...I,...b]}return[]}U(s,o){return o.filter(l=>l.manifest.extensionDependencies&&l.manifest.extensionDependencies.some(O=>(0,m.$cp)({id:O},s.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(s){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,L.$0)(s)),{malicious:[],deprecated:{},search:[]}}}};e.$5p=h,e.$5p=h=me([se(0,d.$No),se(1,c.$El),se(2,p.$dl),se(3,k.$zj),se(4,v.$Rj),se(5,$.$fl)],h);function g(n){const s=Array.isArray(n)?n:[n];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((o,l)=>new Error(`${o.message}${o.message?",":""}${l instanceof Error?l.message:l}`),new Error(""))}e.$6p=g;function i(n){if(n instanceof d.$Oo)return n;if(n instanceof d.$Po){const o=new d.$Oo(n.message,d.ExtensionManagementErrorCode.Gallery);return o.stack=n.stack,o}const s=new d.$Oo(n.message,d.ExtensionManagementErrorCode.Internal);return s.stack=n.stack,s}e.$7p=i;function r(n,s,{extensionData:o,verificationStatus:l,duration:O,error:I,durationSinceUpdate:b}){let j,q;(0,a.$1f)(l)&&(l===!0?l="Verified":(l===!1||(j=d.ExtensionManagementErrorCode.Signature,q=l),l="Unverified")),I&&(I instanceof d.$Oo||I instanceof d.$Po?(j=I.code,I.code===d.ExtensionManagementErrorCode.Signature&&(q=I.message)):j=d.ExtensionManagementErrorCode.Internal),n.publicLog(s,{...o,verificationStatus:l,success:!I,duration:O,errorcode:j,errorcodeDetail:q,durationSinceUpdate:b})}class t{constructor(){this.d=new D.$eh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,D.$5g)(s=>this.h(s))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,D.$5g)(s=>new Promise((o,l)=>{const O=s.onCancellationRequested(()=>{O.dispose(),l(new L.$5)})})),this.d.open()),this.g.cancel()}}e.$8p=t}),define(ie[42],ne([0,1,9,14,2,6,31,11,21,26,13,10,4,23,22,3,7,25]),function(J,e,N,D,R,L,A,S,u,a,y,E,d,m,w,k,v,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=e.$0p=e.$9p=e.ExtensionsProfileScanningErrorCode=void 0;var p;(function(r){r.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",r.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(p||(e.ExtensionsProfileScanningErrorCode=p={}));class $ extends Error{constructor(t,n){super(t),this.code=n}}e.$9p=$,e.$0p=(0,E.$fi)("IExtensionsProfileScannerService");let h=class extends R.$Tc{constructor(t,n,s,o,l,O){super(),this.j=t,this.m=n,this.n=s,this.r=o,this.s=l,this.t=O,this.b=this.B(new L.$5d),this.onAddExtensions=this.b.event,this.c=this.B(new L.$5d),this.onDidAddExtensions=this.c.event,this.f=this.B(new L.$5d),this.onRemoveExtensions=this.f.event,this.g=this.B(new L.$5d),this.onDidRemoveExtensions=this.g.event,this.h=new A.$Ac}scanProfileExtensions(t,n){return this.u(t,void 0,n)}async addExtensionsToProfile(t,n){const s=[],o=[];try{return await this.u(n,l=>{const O=[];for(const I of l)t.some(([b])=>(0,a.$cp)(b.identifier,I.identifier)&&b.manifest.version!==I.version)?s.push(I):O.push(I);for(const[I,b]of t){const j=O.findIndex(Y=>(0,a.$cp)(Y.identifier,I.identifier)&&Y.version===I.manifest.version),q={identifier:I.identifier,version:I.manifest.version,location:I.location,metadata:b};j===-1?(o.push(q),O.push(q)):O.splice(j,1,q)}return o.length&&this.b.fire({extensions:o,profileLocation:n}),s.length&&this.f.fire({extensions:s,profileLocation:n}),O}),o.length&&this.c.fire({extensions:o,profileLocation:n}),s.length&&this.g.fire({extensions:s,profileLocation:n}),o}catch(l){throw o.length&&this.c.fire({extensions:o,error:l,profileLocation:n}),s.length&&this.g.fire({extensions:s,error:l,profileLocation:n}),l}}async updateMetadata(t,n){const s=[];return await this.u(n,o=>{const l=[];for(const O of o){const I=t.find(([b])=>(0,a.$cp)(b.identifier,O.identifier)&&b.manifest.version===O.version);I&&(O.metadata={...O.metadata,...I[1]},s.push(O)),l.push(O)}return l}),s}async removeExtensionFromProfile(t,n){const s=[];try{await this.u(n,o=>{const l=[];for(const O of o)(0,a.$cp)(O.identifier,t.identifier)?s.push(O):l.push(O);return s.length&&this.f.fire({extensions:s,profileLocation:n}),l}),s.length&&this.g.fire({extensions:s,profileLocation:n})}catch(o){throw s.length&&this.g.fire({extensions:s,error:o,profileLocation:n}),o}}async u(t,n,s){return this.F(t).queue(async()=>{let o=[],l;try{const O=await this.m.readFile(t);l=JSON.parse(O.value.toString().trim()||"[]")}catch(O){if((0,y.$Wk)(O)!==1)throw O;if(this.r.extUri.isEqual(t,this.n.defaultProfile.extensionsResource)&&(l=await this.D()),!l&&s?.bailOutWhenFileNotFound)throw new $((0,v.$0)(O),"ERROR_PROFILE_NOT_FOUND")}if(l){Array.isArray(l)||this.w(t);let O=!1;for(const I of l){g(I)||this.w(t);let b;if((0,k.$Sf)(I.relativeLocation)&&I.relativeLocation)b=this.z(I.relativeLocation);else if((0,k.$Sf)(I.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${I.location}`);continue}else{b=S.URI.revive(I.location);const j=this.y(b);j&&(O=!0,I.relativeLocation=j)}(0,k.$Zf)(I.metadata?.hasPreReleaseVersion)&&I.metadata?.preRelease&&(O=!0,I.metadata.hasPreReleaseVersion=!0),o.push({identifier:I.identifier,location:b,version:I.version,metadata:I.metadata})}O&&await this.m.writeFile(t,D.$se.fromString(JSON.stringify(l)))}if(n){o=n(o);const O=o.map(I=>({identifier:I.identifier,version:I.version,location:I.location.toJSON(),relativeLocation:this.y(I.location),metadata:I.metadata}));await this.m.writeFile(t,D.$se.fromString(JSON.stringify(O)))}return o})}w(t){const n=new $(`Invalid extensions content in ${t.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}y(t){return this.r.extUri.isEqual(this.r.extUri.dirname(t),this.j)?this.r.extUri.basename(t):void 0}z(t){return this.r.extUri.joinPath(this.j,t)}async D(){return this.C||(this.C=(async()=>{const t=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),n=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let s;try{s=(await this.m.readFile(t)).value.toString()}catch(l){if((0,y.$Wk)(l)===1)return;throw l}this.t.info("Migrating extensions from old default profile location",t.toString());let o;try{const l=JSON.parse(s);Array.isArray(l)&&l.every(O=>g(O))?o=l:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",l)}catch(l){this.t.error(l)}if(o)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,D.$se.fromString(JSON.stringify(o)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",t.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(l){if((0,y.$Wk)(l)===3)this.t.info("Migration from old default profile location to new location is done by another window",t.toString(),this.n.defaultProfile.extensionsResource.toString());else throw l}try{await this.m.del(t)}catch(l){(0,y.$Wk)(l)!==1&&this.t.error(l)}try{await this.m.del(n)}catch(l){(0,y.$Wk)(l)!==1&&this.t.error(l)}return o})()),this.C}F(t){let n=this.h.get(t);return n||(n=new N.$mh,this.h.set(t,n)),n}};e.$$p=h,e.$$p=h=me([se(1,y.$Fk),se(2,m.$fl),se(3,w.$dl),se(4,c.$El),se(5,d.$zj)],h);function g(r){return(0,k.$Uf)(r)&&(0,u.$Mo)(r.identifier)&&(i(r.location)||(0,k.$Sf)(r.location)&&r.location)&&((0,k.$Zf)(r.relativeLocation)||(0,k.$Sf)(r.relativeLocation))&&r.version&&(0,k.$Sf)(r.version)}function i(r){return r?(0,k.$Sf)(r.path)&&(0,k.$Sf)(r.scheme):!1}}),define(ie[52],ne([0,1,19,9,27,14,7,38,81,2,15,16,12,17,44,54,3,11,98,18,26,37,50,13,10,4,32,6,47,42,23,22,115]),function(J,e,N,D,R,L,A,S,u,a,y,E,d,m,w,k,v,c,p,$,h,g,i,r,t,n,s,o,l,O,I,b,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=e.$eq=e.$dq=e.$cq=e.$bq=e.Translations=void 0;var q;(function(ae){function B(X,T){if(X===T)return!0;const M=Object.keys(X),H=new Set;for(const Z of Object.keys(T))H.add(Z);if(M.length!==H.size)return!1;for(const Z of M){if(X[Z]!==T[Z])return!1;H.delete(Z)}return H.size===0}ae.equals=B})(q||(e.Translations=q={})),e.$bq=(0,t.$fi)("IExtensionsScannerService");let Y=class extends a.$Tc{constructor(B,X,T,M,H,Z,Q,_,U,F,f,P){super(),this.systemExtensionsLocation=B,this.userExtensionsLocation=X,this.r=T,this.s=M,this.t=H,this.u=Z,this.w=Q,this.y=_,this.z=U,this.C=F,this.D=f,this.F=P,this.g=this.B(new o.$5d),this.onDidChangeCache=this.g.event,this.h=(0,m.$Sg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(re,this.s,this.h)),this.m=this.B(this.F.createInstance(re,this.s,this.h)),this.n=this.B(this.F.createInstance(oe,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,h.$np)(this.w,this.y)),this.G}async scanAllExtensions(B,X,T){const[M,H]=await Promise.all([this.scanSystemExtensions(B),this.scanUserExtensions(X)]),Z=T?await this.scanExtensionsUnderDevelopment(B,[...M,...H]):[];return this.L(M,H,Z,await this.getTargetPlatform(),!0)}async scanSystemExtensions(B){const X=[];X.push(this.M(!!B.useCache,B.language)),X.push(this.N(B.language,!!B.checkControlFile));const[T,M]=await Promise.all(X);return this.J([...T,...M],0,B,!1)}async scanUserExtensions(B){const X=B.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",X);const T=this.D.extUri.isEqual(B.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,M=await this.P(X,!!B.profileLocation,1,!B.includeUninstalled,B.language,!0,T),H=B.useCache&&!M.devMode&&M.excludeObsolete?this.m:this.n;let Z;try{Z=await H.scanExtensions(M)}catch(Q){if(Q instanceof O.$9p&&Q.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),Z=await H.scanExtensions(M);else throw Q}return Z=await this.J(Z,1,B,!0),this.y.trace("Scanned user extensions:",Z.length),Z}async scanExtensionsUnderDevelopment(B,X){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const T=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(M=>M.scheme===y.Schemas.file).map(async M=>{const H=await this.P(M,!1,1,!0,B.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(H)).map(Q=>(Q.type=X.find(_=>(0,h.$cp)(_.identifier,Q.identifier))?.type??Q.type,this.n.validate(Q,H)))}))).flat();return this.J(T,"development",B,!0)}return[]}async scanExistingExtension(B,X,T){const M=await this.P(B,!1,X,!0,T.language,!0,void 0),H=await this.n.scanExtension(M);return!H||!T.includeInvalid&&!H.isValid?null:H}async scanOneOrMultipleExtensions(B,X,T){const M=await this.P(B,!1,X,!0,T.language,!0,void 0),H=await this.n.scanOneOrMultipleExtensions(M);return this.J(H,X,T,!0)}async scanMetadata(B){const X=(0,m.$Sg)(B,"package.json"),T=(await this.w.readFile(X)).value.toString();return JSON.parse(T).__metadata}async updateMetadata(B,X){const T=(0,m.$Sg)(B,"package.json"),M=(await this.w.readFile(T)).value.toString(),H=JSON.parse(M);X.isMachineScoped===!1&&delete X.isMachineScoped,X.isBuiltin===!1&&delete X.isBuiltin,H.__metadata={...H.__metadata,...X},await this.w.writeFile((0,m.$Sg)(B,"package.json"),L.$se.fromString(JSON.stringify(H,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(B){if(B instanceof O.$9p&&B.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw B}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const B=await this.scanUserExtensions({includeInvalid:!0});if(B.length)await this.u.addExtensionsToProfile(B.map(X=>[X,X.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,L.$se.fromString(JSON.stringify([])))}catch(X){(0,r.$Wk)(X)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,A.$0)(X))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(B){this.y.error(B)}finally{this.H=void 0}})()),this.H}async J(B,X,T,M){return T.includeAllVersions||(B=this.L(X===0?B:void 0,X===1?B:void 0,X==="development"?B:void 0,await this.getTargetPlatform(),M)),T.includeInvalid||(B=B.filter(H=>H.isValid)),B.sort((H,Z)=>{const Q=E.$nc(H.location.fsPath),_=E.$nc(Z.location.fsPath);return Q<_?-1:Q>_?1:0})}L(B,X,T,M,H){const Z=(_,U,F)=>{if(_.isValid&&!U.isValid)return!1;if(_.isValid===U.isValid){if(H&&w.gt(_.manifest.version,U.manifest.version))return this.y.debug(`Skipping extension ${U.location.path} with lower version ${U.manifest.version} in favour of ${_.location.path} with version ${_.manifest.version}`),!1;if(w.eq(_.manifest.version,U.manifest.version)){if(_.type===0)return this.y.debug(`Skipping extension ${U.location.path} in favour of system extension ${_.location.path} with same version`),!1;if(_.targetPlatform===M)return this.y.debug(`Skipping extension ${U.location.path} from different target platform ${U.targetPlatform}`),!1}}return F?this.y.warn(`Overwriting user extension ${_.location.path} with ${U.location.path}.`):this.y.debug(`Overwriting user extension ${_.location.path} with ${U.location.path}.`),!0},Q=new g.$Bm;return B?.forEach(_=>{const U=Q.get(_.identifier.id);(!U||Z(U,_,!1))&&Q.set(_.identifier.id,_)}),X?.forEach(_=>{const U=Q.get(_.identifier.id);if(!U&&B&&_.type===0){this.y.debug(`Skipping obsolete system extension ${_.location.path}.`);return}(!U||Z(U,_,!1))&&Q.set(_.identifier.id,_)}),T?.forEach(_=>{const U=Q.get(_.identifier.id);(!U||Z(U,_,!0))&&Q.set(_.identifier.id,_),Q.set(_.identifier.id,_)}),[...Q.values()]}async M(B,X){this.y.trace("Started scanning system extensions");const T=await this.P(this.systemExtensionsLocation,!1,0,!0,X,!0,void 0),H=await(B&&!T.devMode?this.j:this.n).scanExtensions(T);return this.y.trace("Scanned system extensions:",H.length),H}async N(B,X){const T=this.z.isBuilt?[]:this.C.builtInExtensions;if(!T?.length)return[];this.y.trace("Started scanning dev system extensions");const M=X?await this.O():{},H=[],Z=c.URI.file(E.$hc(E.$jc(y.$zg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const _ of T){const U=M[_.name]||"marketplace";switch(U){case"disabled":break;case"marketplace":H.push((0,m.$Sg)(Z,_.name));break;default:H.push(c.URI.file(U));break}}const Q=await Promise.all(H.map(async _=>this.n.scanExtension(await this.P(_,!1,0,!0,B,!0,void 0))));return this.y.trace("Scanned dev system extensions:",Q.length),(0,N.$Hb)(Q)}async O(){try{const B=await this.w.readFile(this.r);return JSON.parse(B.value.toString())}catch{return{}}}async P(B,X,T,M,H,Z,Q){const _=await this.f(H??d.$w),U=await this.Q(B),F=X&&!this.D.extUri.isEqual(B,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,f=F?await this.Q(F):void 0;return new K(B,U,F,f,X,Q,T,M,Z,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,H,_)}async Q(B){try{const X=await this.w.stat(B);if(typeof X.mtime=="number")return X.mtime}catch{}}};e.$cq=Y,e.$cq=Y=me([se(4,I.$fl),se(5,O.$0p),se(6,r.$Fk),se(7,n.$zj),se(8,$.$mi),se(9,s.$Rj),se(10,b.$dl),se(11,t.$ei)],Y);class K{constructor(B,X,T,M,H,Z,Q,_,U,F,f,P,z,C,W){this.location=B,this.mtime=X,this.applicationExtensionslocation=T,this.applicationExtensionslocationMtime=M,this.profile=H,this.profileScanOptions=Z,this.type=Q,this.excludeObsolete=_,this.validate=U,this.productVersion=F,this.productDate=f,this.productCommit=P,this.devMode=z,this.language=C,this.translations=W}static createNlsConfiguration(B){return{language:B.language,pseudo:B.language==="pseudo",devMode:B.devMode,translations:B.translations}}static equals(B,X){return(0,m.$Lg)(B.location,X.location)&&B.mtime===X.mtime&&(0,m.$Lg)(B.applicationExtensionslocation,X.applicationExtensionslocation)&&B.applicationExtensionslocationMtime===X.applicationExtensionslocationMtime&&B.profile===X.profile&&R.$On(B.profileScanOptions,X.profileScanOptions)&&B.type===X.type&&B.excludeObsolete===X.excludeObsolete&&B.validate===X.validate&&B.productVersion===X.productVersion&&B.productDate===X.productDate&&B.productCommit===X.productCommit&&B.devMode===X.devMode&&B.language===X.language&&q.equals(B.translations,X.translations)}}e.$dq=K;let oe=class extends a.$Tc{constructor(B,X,T,M,H){super(),this.f=B,this.g=X,this.h=T,this.j=M,this.m=H}async scanExtensions(B){const X=B.profile?await this.r(B):await this.n(B);let T={};if(B.excludeObsolete&&B.type===1)try{const M=(await this.j.readFile(this.f)).value.toString();T=JSON.parse(M)}catch{}return(0,v.$6f)(T)?X:X.filter(M=>!T[h.$dp.create(M).toString()])}async n(B){const X=await this.j.resolve(B.location);if(!X.children?.length)return[];const T=await Promise.all(X.children.map(async M=>{if(!M.isDirectory||B.type===1&&(0,m.$Pg)(M.resource).indexOf(".")===0)return null;const H=new K(M.resource,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(H)}));return(0,N.$Hb)(T).sort((M,H)=>M.location.path<H.location.path?-1:1)}async r(B){let X=await this.s(B.location,()=>!0,B);if(B.applicationExtensionslocation&&!this.h.extUri.isEqual(B.location,B.applicationExtensionslocation)){X=X.filter(M=>!M.metadata?.isApplicationScoped);const T=await this.s(B.applicationExtensionslocation,M=>!!M.metadata?.isBuiltin||!!M.metadata?.isApplicationScoped,B);X.push(...T)}return X}async s(B,X,T){const M=await this.g.scanProfileExtensions(B,T.profileScanOptions);if(!M.length)return[];const H=await Promise.all(M.map(async Z=>{if(X(Z)){const Q=new K(Z.location,T.mtime,T.applicationExtensionslocation,T.applicationExtensionslocationMtime,T.profile,T.profileScanOptions,T.type,T.excludeObsolete,T.validate,T.productVersion,T.productDate,T.productCommit,T.devMode,T.language,T.translations);return this.scanExtension(Q,Z.metadata)}return null}));return(0,N.$Hb)(H)}async scanOneOrMultipleExtensions(B){try{if(await this.j.exists((0,m.$Sg)(B.location,"package.json"))){const X=await this.scanExtension(B);return X?[X]:[]}else return await this.scanExtensions(B)}catch(X){return this.m.error(`Error scanning extensions at ${B.location.path}:`,(0,A.$0)(X)),[]}}async scanExtension(B,X){try{let T=await this.scanExtensionManifest(B.location);if(T){T.publisher||(T.publisher=g.$vm),X=X??T.__metadata,delete T.__metadata;const M=(0,h.$hp)(T.publisher,T.name),H=X?.id?{id:M,uuid:X.id}:{id:M},Z=X?.isSystem?0:B.type,Q=Z===0||!!X?.isBuiltin;T=await this.t(B.location,T,K.createNlsConfiguration(B));const _={type:Z,identifier:H,manifest:T,location:B.location,isBuiltin:Q,targetPlatform:X?.targetPlatform??"undefined",metadata:X,isValid:!0,validations:[]};return B.validate?this.validate(_,B):_}}catch(T){B.type!==0&&this.m.error(T)}return null}validate(B,X){let T=!0;const M=(0,i.$sp)(X.productVersion,X.productDate,X.location,B.manifest,B.isBuiltin);for(const[H,Z]of M)H===k.default.Error&&(T=!1,this.m.error(this.z(X.location,Z)));return B.isValid=T,B.validations=M,B}async scanExtensionManifest(B){const X=(0,m.$Sg)(B,"package.json");let T;try{T=(await this.j.readFile(X)).value.toString()}catch(H){return(0,r.$Wk)(H)!==1&&this.m.error(this.z(B,(0,p.localize)(0,null,X.path,H.message))),null}let M;try{M=JSON.parse(T)}catch{const Z=[];(0,S.$rn)(T,Z);for(const Q of Z)this.m.error(this.z(B,(0,p.localize)(1,null,X.path,Q.offset,Q.length,(0,u.$_p)(Q.error))));return null}return(0,S.$An)(M)!=="object"?(this.m.error(this.z(B,(0,p.localize)(2,null,X.path))),null):M}async t(B,X,T){const M=await this.u(B,X,T);if(M)try{const H=[],Z=await this.w(M.default,H);if(H.length>0)return H.forEach(_=>{this.m.error(this.z(B,(0,p.localize)(3,null,M.default?.path,(0,u.$_p)(_.error))))}),X;if((0,S.$An)(M)!=="object")return this.m.error(this.z(B,(0,p.localize)(4,null,M.default?.path))),X;const Q=M.values||Object.create(null);return(0,j.$aq)(this.m,X,Q,Z)}catch{}return X}async u(B,X,T){const M=(0,m.$Sg)(B,"package.nls.json"),H=(U,F)=>{F.forEach(f=>{this.m.error(this.z(B,(0,p.localize)(5,null,U?.path,(0,u.$_p)(f.error))))})},Z=U=>{this.m.error(this.z(B,(0,p.localize)(6,null,U?.path)))},Q=`${X.publisher}.${X.name}`,_=T.translations[Q];if(_)try{const U=c.URI.file(_),F=(await this.j.readFile(U)).value.toString(),f=[],P=(0,S.$rn)(F,f);return f.length>0?(H(U,f),{values:void 0,default:M}):(0,S.$An)(P)!=="object"?(Z(U),{values:void 0,default:M}):{values:P.contents?P.contents.package:void 0,default:M}}catch{return{values:void 0,default:M}}else{if(!await this.j.exists(M))return;let F;try{F=await this.y(B,T)}catch{return}if(!F.localized)return{values:void 0,default:F.original};try{const f=(await this.j.readFile(F.localized)).value.toString(),P=[],z=(0,S.$rn)(f,P);return P.length>0?(H(F.localized,P),{values:void 0,default:F.original}):(0,S.$An)(z)!=="object"?(Z(F.localized),{values:void 0,default:F.original}):{values:z,default:F.original}}catch{return{values:void 0,default:F.original}}}}async w(B,X){if(B)try{const T=(await this.j.readFile(B)).value.toString();return(0,S.$rn)(T,X)}catch{}}y(B,X){return new Promise((T,M)=>{const H=Z=>{const Q=(0,m.$Sg)(B,`package.nls.${Z}.json`);this.j.exists(Q).then(_=>{_&&T({localized:Q,original:(0,m.$Sg)(B,"package.nls.json")});const U=Z.lastIndexOf("-");U===-1?T({localized:(0,m.$Sg)(B,"package.nls.json"),original:null}):(Z=Z.substring(0,U),H(Z))})};if(X.devMode||X.pseudo||!X.language)return T({localized:(0,m.$Sg)(B,"package.nls.json"),original:null});H(X.language)})}z(B,X){return`[${B.path}]: ${X}`}};oe=me([se(1,O.$0p),se(2,b.$dl),se(3,r.$Fk),se(4,n.$zj)],oe);let re=class extends oe{constructor(B,X,T,M,H,Z,Q){super(X,M,H,Z,Q),this.G=B,this.H=T,this.D=this.B(new D.$dh(3e3)),this.F=this.B(new o.$5d),this.onDidChangeCache=this.F.event}async scanExtensions(B){const X=this.M(B),T=await this.I(X);if(this.C=B,T&&T.input&&K.equals(T.input,this.C))return this.m.debug("Using cached extensions scan result",B.location.toString()),this.D.trigger(()=>this.L()),T.result.map(H=>(H.location=c.URI.revive(H.location),H));const M=await super.scanExtensions(B);return await this.J(X,{input:B,result:M}),M}async I(B){try{const X=await this.j.readFile(B),T=JSON.parse(X.value.toString());return{result:T.result,input:(0,l.$Oh)(T.input)}}catch(X){this.m.debug("Error while reading the extension cache file:",B.path,(0,A.$0)(X))}return null}async J(B,X){try{await this.j.writeFile(B,L.$se.fromString(JSON.stringify(X)))}catch(T){this.m.debug("Error while writing the extension cache file:",B.path,(0,A.$0)(T))}}async L(){if(!this.C)return;const B=this.M(this.C),X=await this.I(B);if(!X)return;const T=X.result,M=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!R.$On(M,T))try{this.m.info("Invalidating Cache",T,M),await this.j.del(B),this.F.fire()}catch(H){this.m.error(H)}}M(B){const X=this.N(B);return this.h.extUri.joinPath(X.cacheHome,B.type===0?g.$um:g.$tm)}N(B){return B.type===0?this.H.defaultProfile:B.profile?this.h.extUri.isEqual(B.location,this.G.extensionsResource)?this.G:this.H.profiles.find(X=>this.h.extUri.isEqual(B.location,X.extensionsResource))??this.G:this.H.defaultProfile}};re=me([se(2,I.$fl),se(3,O.$0p),se(4,b.$dl),se(5,r.$Fk),se(6,n.$zj)],re);function he(ae,B){const X=(0,h.$fp)(ae.manifest.publisher,ae.manifest.name);return{id:X,identifier:new g.$zm(X),isBuiltin:ae.type===0,isUserBuiltin:ae.type===1&&ae.isBuiltin,isUnderDevelopment:B,extensionLocation:ae.location,uuid:ae.identifier.uuid,targetPlatform:ae.targetPlatform,...ae.manifest}}e.$eq=he;class de extends Y{constructor(B,X,T,M,H,Z,Q,_,U,F,f,P){super(B,X,(0,m.$Sg)(T,".vscode-oss-dev","extensions","control.json"),M,H,Z,Q,_,U,F,f,P),this.R=(async()=>{if(d.$z)try{const z=await this.w.readFile(c.URI.file(d.$z));return JSON.parse(z.value.toString())}catch{}return Object.create(null)})()}f(B){return this.R}}e.$fq=de}),define(ie[158],ne([0,1,58,9,34,6,2,15,16,24,4,23]),function(J,e,N,D,R,L,A,S,u,a,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hq=void 0;let d=class extends A.$Tc{constructor(w,k){super(),this.b=w,this.f=k,this.a=new D.$lh(5)}async postUninstall(w){const k=this.g(w,"uninstall");k&&(this.f.info(w.identifier.id,w.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(k.script,"uninstall",k.args,!0,w),this.f.info("Finished running post uninstall script",w.identifier.id,w.manifest.version)}catch(v){this.f.error("Failed to run post uninstall script",w.identifier.id,w.manifest.version),this.f.error(v)}}));try{await a.Promises.rm(this.m(w))}catch(v){this.f.error("Error while removing extension storage path",w.identifier.id),this.f.error(v)}}g(w,k){const v=`vscode:${k}`;if(w.location.scheme===S.Schemas.file&&w.manifest&&w.manifest.scripts&&typeof w.manifest.scripts[v]=="string"){const c=w.manifest.scripts[v].split(" ");return c.length<2||c[0]!=="node"||!c[1]?(this.f.warn(w.identifier.id,w.manifest.version,`${v} should be a node script`),null):{script:(0,u.$jc)(w.location.fsPath,c[1]),args:c.slice(2)||[]}}return null}h(w,k,v,c,p){return new Promise(($,h)=>{const g=this.j(w,k,v,p);let i;const r=t=>{i&&(clearTimeout(i),i=null),t?h(t):$(void 0)};g.on("error",t=>{r((0,R.$3i)(t)||"Unknown")}),g.on("exit",(t,n)=>{r(t?`post-${k} process exited with code ${t}`:void 0)}),c&&(i=setTimeout(()=>{i=null,g.kill(),h("timed out")},5e3))})}j(w,k,v,c){const p={silent:!0,execArgv:void 0},$=(0,N.fork)(w,[`--type=extension-post-${k}`,...v],p);$.stdout.setEncoding("utf8"),$.stderr.setEncoding("utf8");const h=L.Event.fromNodeEventEmitter($.stdout,"data"),g=L.Event.fromNodeEventEmitter($.stderr,"data");h(t=>this.f.info(c.identifier.id,c.manifest.version,`post-${k}`,t)),g(t=>this.f.error(c.identifier.id,c.manifest.version,`post-${k}`,t));const i=L.Event.any(L.Event.map(h,t=>({data:`%c${t}`,format:[""]})),L.Event.map(g,t=>({data:`%c${t}`,format:["color: red"]})));return L.Event.debounce(i,(t,n)=>t?{data:t.data+n.data,format:[...t.format,...n.format]}:{data:n.data,format:n.format},100)(t=>{console.group(c.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),$}m(w){return(0,u.$jc)(this.b.defaultProfile.globalStorageHome.fsPath,w.identifier.id.toLowerCase())}};e.$hq=d,e.$hq=d=me([se(0,E.$fl),se(1,y.$zj)],d)}),define(ie[159],ne([0,1,9,14,20,34,7,6,43,2,31,15,16,17,44,3,11,28,24,49,99,59,18,157,21,26,42,52,144,158,116,137,145,50,13,10,4,32,25,22,23]),function(J,e,N,D,R,L,A,S,u,a,y,E,d,m,w,k,v,c,p,$,h,g,i,r,t,n,s,o,l,O,I,b,j,q,Y,K,oe,re,he,de,ae){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oq=e.$nq=e.$mq=e.$lq=void 0,e.$lq=(0,K.$gi)(t.$Qo);const B=".vsctmp";let X=class extends r.$5p{constructor(U,F,f,P,z,C,W,G,te,le,ue,$e){super(U,F,ue,f,le,$e),this.eb=z,this.fb=C,this.gb=W,this.hb=te,this.db=new Map,this.qb=new y.$Bc;const we=this.B(G.createInstance(O.$hq));this.ab=this.B(G.createInstance(T,ce=>we.postUninstall(ce))),this.bb=this.B(new b.$jq($e,te,ue,this,this.F)),this.cb=this.B(G.createInstance(l.$gq));const fe=this.B(new j.$kq(this,this.eb,$e,C,ue,te,f));this.B(fe.onDidChangeExtensionsByAnotherSource(ce=>this.pb(ce))),this.rb()}getTargetPlatform(){return this.ib||(this.ib=(0,n.$np)(this.hb,this.F)),this.ib}async zip(U){this.F.trace("ExtensionManagementService#zip",U.identifier.id);const F=await this.ob(U),f=await(0,$.zip)((0,m.$Sg)(this.cb.extensionsDownloadDir,(0,c.$Bg)()).fsPath,F);return v.URI.file(f)}async unzip(U){return this.F.trace("ExtensionManagementService#unzip",U.toString()),(await this.install(U)).identifier}async getManifest(U){const{location:F,cleanup:f}=await this.kb(U),P=d.$kc(F.fsPath);try{return await(0,I.$iq)(P)}finally{await f()}}getInstalled(U,F=this.H.defaultProfile.extensionsResource){return this.ab.scanExtensions(U??null,F)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(U){return this.ab.scanUserExtensionAtLocation(U)}async install(U,F={}){this.F.trace("ExtensionManagementService#install",U.toString());const{location:f,cleanup:P}=await this.kb(U);try{const z=await(0,I.$iq)(d.$kc(f.fsPath)),C=(0,n.$hp)(z.publisher,z.name);if(z.engines&&z.engines.vscode&&!(0,q.$up)(z.engines.vscode,this.G.version,this.G.date))throw new Error(h.localize(0,null,C,this.G.version));const G=(await this.I([{manifest:z,extension:f,options:F}])).find(({identifier:te})=>(0,n.$cp)(te,{id:C}));if(G?.local)return G.local;throw G?.error?G.error:(0,r.$7p)(new Error(`Unknown error while installing extension ${C}`))}finally{await P()}}async installFromLocation(U,F){this.F.trace("ExtensionManagementService#installFromLocation",U.toString());const f=await this.ab.scanUserExtensionAtLocation(U);if(!f||!f.manifest.name||!f.manifest.version)throw new Error(`Cannot find a valid extension from the location ${U.toString()}`);return await this.tb([[f,void 0]],F),this.F.info("Successfully installed extension",f.identifier.id,F.toString()),f}async installExtensionsFromProfile(U,F,f){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",U,F.toString(),f.toString());const P=(await this.ab.scanExtensions(1,F)).filter(z=>U.some(C=>(0,n.$cp)(C,z.identifier)));if(P.length){const z=await Promise.all(P.map(C=>this.ab.scanMetadata(C,F)));await this.tb(P.map((C,W)=>[C,z[W]]),f),this.F.info("Successfully installed extensions",P.map(C=>C.identifier.id),f.toString())}return P}async updateMetadata(U,F,f=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",U.identifier.id),F.isPreReleaseVersion&&(F.preRelease=!0,F.hasPreReleaseVersion=!0),F.isMachineScoped===!1&&(F.isMachineScoped=void 0),F.isBuiltin===!1&&(F.isBuiltin=void 0),F.pinned===!1&&(F.pinned=void 0),U=await this.ab.updateMetadata(U,F,f),this.bb.invalidate(f),this.w.fire(U),U}async reinstallFromGallery(U){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",U.identifier.id),!this.z.isEnabled())throw new Error(h.localize(1,null));const F=await this.getTargetPlatform(),[f]=await this.z.getExtensions([{...U.identifier,preRelease:U.preRelease}],{targetPlatform:F,compatible:!0},R.CancellationToken.None);if(!f)throw new Error(h.localize(2,null));await this.ab.setUninstalled(U);try{await this.ab.removeUninstalledExtension(U)}catch(P){throw new Error(h.localize(3,null,(0,L.$3i)(P)))}return this.installFromGallery(f)}$(U,F,f,P){return this.ab.copyExtension(U,F,f,P)}copyExtensions(U,F){return this.ab.copyExtensions(U,F)}markAsUninstalled(...U){return this.ab.setUninstalled(...U)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(U){this.F.error(U)}}async download(U,F,f){const{location:P}=await this.cb.download(U,F,!f);return P}async kb(U){if(U.scheme===E.Schemas.file)return{location:U,async cleanup(){}};this.F.trace("Downloading extension from",U.toString());const F=(0,m.$Sg)(this.cb.extensionsDownloadDir,(0,c.$Bg)());return await this.gb.download(U,F),this.F.info("Downloaded extension to",F.toString()),{location:F,cleanup:async()=>{try{await this.hb.del(F)}catch(P){this.F.error(P)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(U,F,f){if(v.URI.isUri(F))return new Z(U,F,f,this.z,this.ab,this.D,this.H,this.eb,this.fb,this.F);const P=n.$dp.create(F).toString();let z=this.db.get(P);return z||(this.db.set(P,z=new H(U,F,f,this.cb,this.ab,this.D,this.H,this.eb,this.fb,this.F)),z.waitUntilTaskIsFinished().finally(()=>this.db.delete(P))),z}Z(U,F){return new Q(U,F.profileLocation,this.fb)}async ob(U){const F=async P=>{let z=await p.Promises.readdir(P);z=z.map(G=>d.$jc(P,G));const C=await Promise.all(z.map(G=>p.Promises.stat(G)));let W=Promise.resolve([]);return C.forEach((G,te)=>{const le=z[te];G.isFile()&&(W=W.then(ue=>[...ue,le])),G.isDirectory()&&(W=W.then(ue=>F(le).then($e=>[...ue,...$e])))}),W};return(await F(U.location.fsPath)).map(P=>({path:`extension/${d.$lc(U.location.fsPath,P)}`,localPath:P}))}async pb({added:U,removed:F}){if(F){const f=U&&this.D.extUri.isEqual(F.profileLocation,U.profileLocation)?F.extensions.filter(P=>U.extensions.every(z=>!(0,n.$cp)(z,P))):F.extensions;for(const P of f)this.F.info("Extensions removed from another source",P.id,F.profileLocation.toString()),this.u.fire({identifier:P,profileLocation:F.profileLocation})}if(U){const P=(await this.ab.scanExtensions(1,U.profileLocation)).filter(z=>U.extensions.some(C=>(0,n.$cp)(C,z.identifier)));this.s.fire(P.map(z=>(this.F.info("Extensions added from another source",z.identifier.id,U.profileLocation.toString()),{identifier:z.identifier,local:z,profileLocation:U.profileLocation,operation:1})))}}async rb(){this.B(this.ab.onExtract(F=>this.qb.add(F)));const U=await this.hb.resolve(this.eb.userExtensionsLocation);for(const F of U.children??[])F.isDirectory&&this.qb.add(F.resource);this.B(this.hb.watch(this.eb.userExtensionsLocation)),this.B(this.hb.onDidFilesChange(F=>this.sb(F)))}async sb(U){if(!U.affects(this.eb.userExtensionsLocation,1))return;const F=[];for(const f of U.rawAdded){if(this.qb.has(f)||!this.D.extUri.isEqual(this.D.extUri.dirname(f),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(f,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(f).startsWith(".")||!(await this.hb.stat(f)).isDirectory)continue;const P=await this.ab.scanUserExtensionAtLocation(f);P&&P.installedTimestamp===void 0&&(this.qb.add(f),F.push(P))}F.length&&(await this.tb(F.map(f=>[f,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",F.map(f=>f.identifier.id)))}async tb(U,F){const f=U.map(P=>P[0]);await this.ub(f),await this.fb.addExtensionsToProfile(U,F),this.s.fire(f.map(P=>({local:P,identifier:P.identifier,operation:1,profileLocation:F})))}async ub(U){const F=await this.ab.getUninstalledExtensions();for(const f of U){const P=n.$dp.create(f);F[P.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",P.id),await this.ab.setInstalled(P),this.F.info("Removed the extension from uninstalled list:",P.id))}}};e.$mq=X,e.$mq=X=me([se(0,t.$No),se(1,he.$El),se(2,oe.$zj),se(3,i.$ni),se(4,o.$bq),se(5,s.$0p),se(6,g.$so),se(7,K.$ei),se(8,Y.$Fk),se(9,re.$Rj),se(10,de.$dl),se(11,ae.$fl)],X);let T=class extends a.$Tc{constructor(U,F,f,P,z,C){super(),this.j=U,this.m=F,this.n=f,this.s=P,this.t=z,this.u=C,this.h=this.B(new S.$5d),this.onExtract=this.h.event,this.c=(0,m.$Sg)(this.n.userExtensionsLocation,".obsolete"),this.g=new N.$mh}async cleanUp(){await this.H(),await this.G()}async scanExtensions(U,F){const f={includeInvalid:!0,profileLocation:F};let P=[];return U===null||U===0?P.push(...await this.n.scanAllExtensions({includeInvalid:!0},f,!1)):U===1&&P.push(...await this.n.scanUserExtensions(f)),P=U!==null?P.filter(z=>z.type===U):P,Promise.all(P.map(z=>this.F(z)))}async scanAllUserExtensions(U){const F=await this.n.scanUserExtensions({includeAllVersions:!U,includeInvalid:!0});return Promise.all(F.map(f=>this.F(f)))}async scanUserExtensionAtLocation(U){try{const F=await this.n.scanExistingExtension(U,1,{includeInvalid:!0});if(F)return await this.F(F)}catch(F){this.u.error(F)}return null}async extractUserExtension(U,F,f,P,z){const C=U.toString(),W=v.URI.file(d.$jc(this.n.userExtensionsLocation.fsPath,`.${(0,c.$Bg)()}`)),G=v.URI.file(d.$jc(this.n.userExtensionsLocation.fsPath,C));let te=await this.m.exists(G);if(te&&P){try{await this.y(U.id,G,"removeExisting")}catch{throw new t.$Oo(h.localize(4,null,G.fsPath,U.id),t.ExtensionManagementErrorCode.Delete)}te=!1}if(te)await this.n.updateMetadata(G,f);else try{try{this.u.trace(`Started extracting the extension from ${F} to ${G.fsPath}`),await(0,$.$3p)(F,W.fsPath,{sourcePath:"extension",overwrite:!0},z),this.u.info(`Extracted extension to ${G}:`,U.id)}catch(le){let ue=t.ExtensionManagementErrorCode.Extract;throw le instanceof $.$1p&&(le.type==="CorruptZip"?ue=t.ExtensionManagementErrorCode.CorruptZip:le.type==="Incomplete"&&(ue=t.ExtensionManagementErrorCode.IncompleteZip)),new t.$Oo(le.message,ue)}await this.n.updateMetadata(W,f);try{this.u.trace(`Started renaming the extension from ${W.fsPath} to ${G.fsPath}`),await this.C(W.fsPath,G.fsPath),this.u.info("Renamed to",G.fsPath)}catch(le){if(le.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",U.id);else throw this.u.info(`Rename failed because of ${(0,A.$0)(le)}. Deleted from extracted location`,W),le}this.h.fire(G)}catch(le){try{await this.m.del(W,{recursive:!0})}catch{}throw le}return this.D(G,1)}async scanMetadata(U,F){return F?(await this.w(U,F))?.metadata:this.n.scanMetadata(U.location)}async w(U,F){return(await this.s.scanProfileExtensions(F)).find(P=>(0,n.$cp)(P.identifier,U.identifier))}async updateMetadata(U,F,f){return f?await this.s.updateMetadata([[U,F]],f):await this.n.updateMetadata(U.location,F),this.D(U.location,U.type,f)}getUninstalledExtensions(){return this.z()}async setUninstalled(...U){const F=U.map(f=>n.$dp.create(f));await this.z(f=>F.forEach(P=>{f[P.toString()]=!0,this.u.info("Marked extension as uninstalled",P.toString())}))}async setInstalled(U){await this.z(F=>delete F[U.toString()])}async removeExtension(U,F){if(this.t.extUri.isEqualOrParent(U.location,this.n.userExtensionsLocation))return this.y(U.identifier.id,U.location,F)}async removeUninstalledExtension(U){await this.removeExtension(U,"uninstalled"),await this.z(F=>delete F[n.$dp.create(U).toString()])}async copyExtension(U,F,f,P){const z=await this.w(U,F),C=await this.w(U,f);if(P={...z?.metadata,...P},C)if(this.t.extUri.isEqual(C.location,U.location))await this.s.updateMetadata([[U,{...C.metadata,...P}]],f);else{const W=await this.D(C.location,U.type,f);await this.s.removeExtensionFromProfile(W,f),await this.s.addExtensionsToProfile([[U,{...C.metadata,...P}]],f)}else await this.s.addExtensionsToProfile([[U,P]],f);return this.D(U.location,U.type,f)}async copyExtensions(U,F){const f=await this.scanExtensions(1,U),P=await Promise.all(f.filter(z=>!z.isApplicationScoped).map(async z=>[z,await this.scanMetadata(z,U)]));await this.s.addExtensionsToProfile(P,F)}async y(U,F,f){this.u.trace(`Deleting ${f} extension from disk`,U,F.fsPath);const P=this.t.extUri.joinPath(this.t.extUri.dirname(F),`${this.t.extUri.basename(F)}.${(0,u.$6i)((0,c.$Bg)()).toString(16)}${B}`);await this.C(F.fsPath,P.fsPath),await this.m.del(P,{recursive:!0}),this.u.info(`Deleted ${f} extension from disk`,U,F.fsPath)}async z(U){return this.g.queue(async()=>{let F;try{F=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(P){if((0,Y.$Wk)(P)!==1)throw P}let f={};if(F)try{f=JSON.parse(F)}catch{}return U&&(U(f),Object.keys(f).length?await this.m.writeFile(this.c,D.$se.fromString(JSON.stringify(f))):await this.m.del(this.c)),f})}async C(U,F){try{await p.Promises.rename(U,F,2*60*1e3)}catch(f){throw new t.$Oo(f.message||h.localize(5,null,U,F),f.code||t.ExtensionManagementErrorCode.Rename)}}async D(U,F,f){if(f){const z=(await this.n.scanUserExtensions({profileLocation:f})).find(C=>this.t.extUri.isEqual(C.location,U));if(z)return this.F(z)}else{const P=await this.n.scanExistingExtension(U,F,{includeInvalid:!0});if(P)return this.F(P)}throw new Error(h.localize(6,null,U.path))}async F(U){const F=await this.m.resolve(U.location);let f,P;return F.children&&(f=F.children.find(({name:z})=>/^readme(\.txt|\.md|)$/i.test(z))?.resource,P=F.children.find(({name:z})=>/^changelog(\.txt|\.md|)$/i.test(z))?.resource),{identifier:U.identifier,type:U.type,isBuiltin:U.isBuiltin||!!U.metadata?.isBuiltin,location:U.location,manifest:U.manifest,targetPlatform:U.targetPlatform,validations:U.validations,isValid:U.isValid,readmeUrl:f,changelogUrl:P,publisherDisplayName:U.metadata?.publisherDisplayName||null,publisherId:U.metadata?.publisherId||null,isApplicationScoped:!!U.metadata?.isApplicationScoped,isMachineScoped:!!U.metadata?.isMachineScoped,isPreReleaseVersion:!!U.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!U.metadata?.hasPreReleaseVersion,preRelease:!!U.metadata?.preRelease,installedTimestamp:U.metadata?.installedTimestamp,updated:!!U.metadata?.updated,pinned:!!U.metadata?.pinned}}async G(){const U=await this.getUninstalledExtensions();if(Object.keys(U).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(U));const F=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),f=new Set;for(const z of F)U[n.$dp.create(z).toString()]||f.add(z.identifier.id.toLowerCase());try{const z=(0,n.$ip)(F,C=>C.identifier);await N.Promises.settled(z.map(async C=>{const W=C.sort((G,te)=>w.rcompare(G.manifest.version,te.manifest.version))[0];f.has(W.identifier.id.toLowerCase())||await this.j(await this.F(W))}))}catch(z){this.u.error(z)}const P=F.filter(z=>z.metadata&&U[n.$dp.create(z).toString()]);await Promise.allSettled(P.map(z=>this.removeUninstalledExtension(z)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let U;try{U=await this.m.resolve(this.n.userExtensionsLocation)}catch(F){(0,Y.$Wk)(F)!==1&&this.u.error(F);return}if(U?.children)try{await Promise.allSettled(U.children.map(async F=>{if(!(!F.isDirectory||!F.name.endsWith(B))){this.u.trace("Deleting the temporarily deleted folder",F.resource.toString());try{await this.m.del(F.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",F.resource.toString())}catch(f){(0,Y.$Wk)(f)!==1&&this.u.error(f)}}}))}catch{}}};e.$nq=T,e.$nq=T=me([se(1,Y.$Fk),se(2,o.$bq),se(3,s.$0p),se(4,de.$dl),se(5,oe.$zj)],T);class M extends r.$8p{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,k.$Zf)(this.options.operation)?this.l:this.options.operation}constructor(U,F,f,P,z,C,W,G,te){super(),this.identifier=U,this.source=F,this.options=f,this.m=P,this.n=z,this.o=C,this.p=W,this.q=G,this.s=te,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(U){const[F,f]=await this.x(U);return this.j=F.isBuiltin||F.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[F,f]],this.j),F}async u({zipPath:U,key:F,metadata:f},P,z){let C=await this.v(F);return C?C=await this.m.updateMetadata(C,f):(this.s.trace("Extracting extension...",F.id),C=await this.m.extractUserExtension(F,U,f,P,z),this.s.info("Extracting extension completed.",F.id)),C}async v(U){return await this.w(U)?(this.s.trace("Removing the extension from uninstalled list:",U.id),await this.m.setInstalled(U),this.s.info("Removed the extension from uninstalled list:",U.id),(await this.m.scanAllUserExtensions(!0)).find(P=>n.$dp.create(P).equals(U))):void 0}async w(U){return!!(await this.m.getUninstalledExtensions())[U.toString()]}}class H extends M{constructor(U,F,f,P,z,C,W,G,te,le){super(F.identifier,F,f,z,C,W,G,te,le),this.y=F,this.z=P}async x(U){let F;try{F=await this.m.scanExtensions(null,this.options.profileLocation)}catch(W){throw new t.$Oo(W,t.ExtensionManagementErrorCode.Scanning)}const f=F.find(W=>(0,n.$cp)(W.identifier,this.y.identifier));f&&(this.l=3);const P={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||f?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||f?.isMachineScoped,isBuiltin:this.options.isBuiltin||f?.isBuiltin,isSystem:f?.type===0?!0:void 0,updated:!!f,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,hasPreReleaseVersion:f?.hasPreReleaseVersion||this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??f?.pinned,preRelease:(0,k.$Yf)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.y.properties.isPreReleaseVersion||f?.preRelease};if(f?.manifest.version===this.y.version)try{return[await this.m.updateMetadata(f,P),P]}catch(W){throw new t.$Oo((0,A.$0)(W),t.ExtensionManagementErrorCode.UpdateMetadata)}const{location:z,verificationStatus:C}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=C,this.B(z.fsPath),[await this.u({zipPath:z.fsPath,key:n.$dp.create(this.y),metadata:P},!1,U),P]}catch(W){try{await this.z.delete(z)}catch(G){this.s.warn("Error while deleting the downloaded file",z.toString(),(0,A.$0)(G))}throw W}}async B(U){try{await(0,I.$iq)(U)}catch(F){throw new t.$Oo((0,r.$6p)(F).message,t.ExtensionManagementErrorCode.Invalid)}}}e.$oq=H;class Z extends M{constructor(U,F,f,P,z,C,W,G,te,le){super({id:(0,n.$hp)(U.publisher,U.name)},F,f,z,C,W,G,te,le),this.y=U,this.z=F,this.A=P}async h(U){const F=await super.h(U);return this.D(F,U),F}async x(U){const F=new n.$dp(this.identifier,this.y.version),P=(await this.m.scanExtensions(1,this.options.profileLocation)).find(W=>(0,n.$cp)(this.identifier,W.identifier)),z={isApplicationScoped:this.options.isApplicationScoped||P?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||P?.isMachineScoped,isBuiltin:this.options.isBuiltin||P?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??P?.pinned};if(P)if(this.l=3,F.equals(new n.$dp(P.identifier,P.manifest.version)))try{await this.m.removeExtension(P,"existing")}catch{throw new Error(h.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&w.gt(P.manifest.version,this.y.version)&&await this.m.setUninstalled(P);else{const W=await this.v(F);if(W)try{await this.m.removeExtension(W,"existing")}catch{throw new Error(h.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:d.$kc(this.z.fsPath),key:F,metadata:z},!0,U),z]}async D(U,F){try{let[f]=await this.A.getExtensions([{id:U.identifier.id,version:U.manifest.version}],F);if(f||([f]=await this.A.getExtensions([{id:U.identifier.id}],F)),f){const P={id:f.identifier.uuid,publisherDisplayName:f.publisherDisplayName,publisherId:f.publisherId,isPreReleaseVersion:f.properties.isPreReleaseVersion,hasPreReleaseVersion:U.hasPreReleaseVersion||f.properties.isPreReleaseVersion,preRelease:f.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(U,P,this.options.profileLocation)}}catch{}}}class Q extends r.$8p{constructor(U,F,f){super(),this.extension=U,this.j=F,this.k=f}async h(U){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ie[160],ne([0,1,4,23,22,25,42,13,18,11]),function(J,e,N,D,R,L,A,S,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HP=void 0;let y=class extends A.$$p{constructor(d,m,w,k,v,c){super(a.URI.file(d.extensionsPath),m,w,k,v,c)}};e.$HP=y,e.$HP=y=me([se(0,u.$ni),se(1,S.$Fk),se(2,D.$fl),se(3,R.$dl),se(4,L.$El),se(5,N.$zj)],y)}),define(ie[161],ne([0,1,11,18,42,52,13,10,4,32,22,23]),function(J,e,N,D,R,L,A,S,u,a,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kac=void 0;let d=class extends L.$fq{constructor(w,k,v,c,p,$,h,g){super(N.URI.file(p.builtinExtensionsPath),N.URI.file(p.extensionsPath),p.userHome,w.defaultProfile,w,k,v,c,p,$,h,g)}};e.$kac=d,e.$kac=d=me([se(0,E.$fl),se(1,R.$0p),se(2,A.$Fk),se(3,u.$zj),se(4,D.$ni),se(5,a.$Rj),se(6,y.$dl),se(7,S.$ei)],d)}),define(ie[162],ne([0,1,9,6,2,127,3,88,10,23]),function(J,e,N,D,R,L,A,S,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Np=e.$Mp=e.$Lp=e.$Kp=e.$Jp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Ip=e.$Hp=e.$Gp=void 0,e.$Gp="__$__isNewStorageMarker",e.$Hp="__$__targetStorageMarker",e.$Ip=(0,u.$fi)("storageService");var y;(function(p){p[p.NONE=0]="NONE",p[p.SHUTDOWN=1]="SHUTDOWN"})(y||(e.WillSaveStateReason=y={}));var E;(function(p){p[p.APPLICATION=-1]="APPLICATION",p[p.PROFILE=0]="PROFILE",p[p.WORKSPACE=1]="WORKSPACE"})(E||(e.StorageScope=E={}));var d;(function(p){p[p.USER=0]="USER",p[p.MACHINE=1]="MACHINE"})(d||(e.StorageTarget=d={}));function m(p){const $=p.get(e.$Hp);if($)try{return JSON.parse($)}catch{}return Object.create(null)}e.$Jp=m;class w extends R.$Tc{static{this.a=60*1e3}constructor($={flushInterval:w.a}){super(),this.m=$,this.b=this.B(new D.$8d),this.c=this.B(new D.$8d),this.onDidChangeTarget=this.c.event,this.f=this.B(new D.$5d),this.onWillSaveState=this.f.event,this.h=this.B(new N.$rh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new R.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue($,h,g){return D.Event.filter(this.b.event,i=>i.scope===$&&(h===void 0||i.key===h),g)}n(){this.j.value=(0,N.$vh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,R.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.O()}finally{(0,L.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u($,h){const{key:g,external:i}=h;if(g===e.$Hp){switch($){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:$})}else this.b.fire({scope:$,key:g,target:this.J($)[g],external:i})}w($){this.f.fire({reason:$})}get($,h,g){return this.P(h)?.get($,g)}getBoolean($,h,g){return this.P(h)?.getBoolean($,g)}getNumber($,h,g){return this.P(h)?.getNumber($,g)}getObject($,h,g){return this.P(h)?.getObject($,g)}storeAll($,h){this.y(()=>{for(const g of $)this.store(g.key,g.value,g.scope,g.target,h)})}store($,h,g,i,r=!1){if((0,A.$2f)(h)){this.remove($,g,r);return}this.y(()=>{this.z($,g,i),this.P(g)?.set($,h,r)})}remove($,h,g=!1){this.y(()=>{this.z($,h,void 0),this.P(h)?.delete($,g)})}y($){this.b.pause(),this.c.pause();try{$()}finally{this.b.resume(),this.c.resume()}}keys($,h){const g=[],i=this.J($);for(const r of Object.keys(i))i[r]===h&&g.push(r);return g}z($,h,g,i=!1){const r=this.J(h);typeof g=="number"?r[$]!==g&&(r[$]=g,this.P(h)?.set(e.$Hp,JSON.stringify(r),i)):typeof r[$]=="number"&&(delete r[$],this.P(h)?.set(e.$Hp,JSON.stringify(r),i))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J($){switch($){case-1:return this.I;case 0:return this.G;default:return this.D}}L($){const h=this.P($);return h?m(h):Object.create(null)}isNew($){return this.getBoolean(e.$Gp,$)===!0}async flush($=y.NONE){this.f.fire({reason:$});const h=this.P(-1),g=this.P(0),i=this.P(1);switch($){case y.NONE:await N.Promises.settled([h?.whenFlushed()??Promise.resolve(),g?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case y.SHUTDOWN:await N.Promises.settled([h?.flush(0)??Promise.resolve(),g?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const $=this.P(-1)?.items??new Map,h=this.P(0)?.items??new Map,g=this.P(1)?.items??new Map;return c($,h,g,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize($){return await this.flush(),this.P($)?.optimize()}async switch($,h){return this.w(y.NONE),(0,a.$el)($)?this.R($,h):this.S($,h)}M($,h){return!($.id===h.id||k(h)&&k($))}N($,h,g){this.y(()=>{const i=new Set;for(const[r,t]of $)i.add(r),h.get(r)!==t&&this.u(g,{key:r,external:!0});for(const[r]of h.items)i.has(r)||this.u(g,{key:r,external:!0})})}}e.$Kp=w;function k(p){return p.isDefault||!!p.useDefaultFlags?.globalState}e.$Lp=k;class v extends w{constructor(){super(),this.U=this.B(new S.$Ep(new S.$Fp,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new S.$Ep(new S.$Fp,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new S.$Ep(new S.$Fp,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage($=>this.u(1,$))),this.B(this.W.onDidChangeStorage($=>this.u(0,$))),this.B(this.U.onDidChangeStorage($=>this.u(-1,$)))}P($){switch($){case-1:return this.U;case 0:return this.W;default:return this.X}}Q($){switch($){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope($){return!1}}e.$Mp=v;async function c(p,$,h,g,i,r){const t=q=>{try{return JSON.parse(q)}catch{return q}},n=new Map,s=new Map;p.forEach((q,Y)=>{n.set(Y,q),s.set(Y,t(q))});const o=new Map,l=new Map;$.forEach((q,Y)=>{o.set(Y,q),l.set(Y,t(q))});const O=new Map,I=new Map;h.forEach((q,Y)=>{O.set(Y,q),I.set(Y,t(q))}),console.group(g!==i?`Storage: Application (path: ${g})`:`Storage: Application & Profile (path: ${g}, default profile)`);const b=[];if(n.forEach((q,Y)=>{b.push({key:Y,value:q})}),console.table(b),console.groupEnd(),console.log(s),g!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const q=[];o.forEach((Y,K)=>{q.push({key:K,value:Y})}),console.table(q),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${r})`);const j=[];O.forEach((q,Y)=>{j.push({key:Y,value:q})}),console.table(j),console.groupEnd(),console.log(I)}e.$Np=c}),define(ie[163],ne([0,1,19,20,7,12,35,3,11,29,18,21,26,50,13,4,32,45,146,162,25,176]),function(J,e,N,D,R,L,A,S,u,a,y,E,d,m,w,k,v,c,p,$,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=e.$Rp=e.$Qp=void 0;const i=L.$o?"web":(0,E.$Jo)(L.$u,A.$ec),r="X-Market-Search-Activity-Id";var t;(function(P){P[P.None=0]="None",P[P.IncludeVersions=1]="IncludeVersions",P[P.IncludeFiles=2]="IncludeFiles",P[P.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",P[P.IncludeSharedAccounts=8]="IncludeSharedAccounts",P[P.IncludeVersionProperties=16]="IncludeVersionProperties",P[P.ExcludeNonValidated=32]="ExcludeNonValidated",P[P.IncludeInstallationTargets=64]="IncludeInstallationTargets",P[P.IncludeAssetUri=128]="IncludeAssetUri",P[P.IncludeStatistics=256]="IncludeStatistics",P[P.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",P[P.Unpublished=4096]="Unpublished",P[P.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function n(...P){return String(P.reduce((z,C)=>z|C,0))}var s;(function(P){P[P.Tag=1]="Tag",P[P.ExtensionId=4]="ExtensionId",P[P.Category=5]="Category",P[P.ExtensionName=7]="ExtensionName",P[P.Target=8]="Target",P[P.Featured=9]="Featured",P[P.SearchText=10]="SearchText",P[P.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},l={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},I={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:t.None,criteria:[],assetTypes:[]};class b{constructor(z=I){this.d=z}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(z,C=this.d.pageSize){return new b({...this.d,pageNumber:z,pageSize:C})}withFilter(z,...C){const W=[...this.d.criteria,...C.length?C.map(G=>({filterType:z,value:G})):[{filterType:z}]];return new b({...this.d,criteria:W})}withSortBy(z){return new b({...this.d,sortBy:z})}withSortOrder(z){return new b({...this.d,sortOrder:z})}withFlags(...z){return new b({...this.d,flags:z.reduce((C,W)=>C|W,0)})}withAssetTypes(...z){return new b({...this.d,assetTypes:z})}withSource(z){return new b({...this.d,source:z})}get raw(){const{criteria:z,pageNumber:C,pageSize:W,sortBy:G,sortOrder:te,flags:le,assetTypes:ue}=this.d;return{filters:[{criteria:z,pageNumber:C,pageSize:W,sortBy:G,sortOrder:te}],assetTypes:ue,flags:le}}get searchText(){const z=this.d.criteria.filter(C=>C.filterType===s.SearchText)[0];return z&&z.value?z.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(z=>String(z.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function j(P,z){const C=(P||[]).filter(W=>W.statisticName===z)[0];return C?C.value:0}function q(P){const z="Microsoft.VisualStudio.Code.Translation.";return P.files.filter(W=>W.assetType.indexOf(z)===0).reduce((W,G)=>{const te=oe(P,G.assetType);return te&&W.push([G.assetType.substring(z.length),te]),W},[])}function Y(P){if(P.properties){const z=P.properties.filter(G=>G.key===o.Repository),C=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),W=z.filter(G=>C.test(G.value))[0];return W?{uri:W.value,fallbackUri:W.value}:null}return oe(P,o.Repository)}function K(P){return{uri:`${P.fallbackAssetUri}/${o.VSIX}?redirect=true${P.targetPlatform?`&targetPlatform=${P.targetPlatform}`:""}`,fallbackUri:`${P.fallbackAssetUri}/${o.VSIX}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`}}function oe(P,z){return P.files.filter(W=>W.assetType===z)[0]?{uri:`${P.assetUri}/${z}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`,fallbackUri:`${P.fallbackAssetUri}/${z}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`}:null}function re(P,z){const C=P.properties?P.properties.filter(G=>G.key===z):[],W=C.length>0&&C[0].value;return W?W.split(",").map(G=>(0,d.$gp)(G)):[]}function he(P){const z=P.properties?P.properties.filter(C=>C.key===l.Engine):[];return z.length>0&&z[0].value||""}function de(P){const z=P.properties?P.properties.filter(C=>C.key===l.PreRelease):[];return z.length>0&&z[0].value==="true"}function ae(P){const z=P.properties?P.properties.filter(W=>W.key===l.LocalizedLanguages):[],C=z.length>0&&z[0].value||"";return C?C.split(","):[]}function B(P){return P.properties?.find(z=>z.key===l.SponsorLink)?.value}function X(P){return P.properties?.find(z=>z.key===l.SupportLink)?.value}function T(P){return P.indexOf("preview")!==-1}function M(P){return P.targetPlatform?(0,E.$Io)(P.targetPlatform):"undefined"}function H(P){const z=(0,N.$Mb)(P.versions.map(M)),C=!!P.tags?.includes(E.$Do),W=z.indexOf("web");return C?W===-1&&z.push("web"):W!==-1&&z.splice(W,1),z}function Z(P,z){for(let C=0;C<P.length;C++){const W=P[C];if(W.version===P[C-1]?.version){let G=C;if(M(W)===z)for(;G>0&&P[G-1].version===W.version;)G--;G!==C&&(P.splice(C,1),P.splice(G,0,W))}}return P}e.$Qp=Z;function Q(P,z,C){P.telemetryData={index:z,querySource:C,queryActivityId:P.queryContext?.[r]}}function _(P,z,C,W){const G=P.versions[0],te={manifest:oe(z,o.Manifest),readme:oe(z,o.Details),changelog:oe(z,o.Changelog),license:oe(z,o.License),repository:Y(z),download:K(z),icon:oe(z,o.Icon),signature:oe(z,o.Signature),coreTranslations:q(z)};return{identifier:{id:(0,d.$hp)(P.publisher.publisherName,P.extensionName),uuid:P.extensionId},name:P.extensionName,version:z.version,displayName:P.displayName,publisherId:P.publisher.publisherId,publisher:P.publisher.publisherName,publisherDisplayName:P.publisher.displayName,publisherDomain:P.publisher.domain?{link:P.publisher.domain,verified:!!P.publisher.isDomainVerified}:void 0,publisherSponsorLink:B(G),description:P.shortDescription??"",installCount:j(P.statistics,"install"),rating:j(P.statistics,"averagerating"),ratingCount:j(P.statistics,"ratingcount"),categories:P.categories||[],tags:P.tags||[],releaseDate:Date.parse(P.releaseDate),lastUpdated:Date.parse(P.lastUpdated),allTargetPlatforms:C,assets:te,properties:{dependencies:re(z,l.Dependency),extensionPack:re(z,l.ExtensionPack),engine:he(z),localizedLanguages:ae(z),targetPlatform:M(z),isPreReleaseVersion:de(z)},hasPreReleaseVersion:de(G),hasReleaseVersion:!0,preview:T(P.flags),isSigned:!!te.signature,queryContext:W,supportLink:X(G)}}let U=class{constructor(z,C,W,G,te,le,ue,$e){this.k=C,this.l=W,this.n=G,this.o=te,this.q=le,this.u=ue,this.w=$e;const we=ue.extensionsGallery,fe=we?.servicePPEUrl&&$e.getValue("_extensionsGallery.enablePPE");this.d=fe?we.servicePPEUrl:we?.serviceUrl,this.g=fe?void 0:we?.searchUrl,this.h=we?.controlUrl,this.j=(0,p.$Pp)(ue.version,ue,this.n,this.w,this.q,z,this.o)}x(z=""){return`${this.d}${z}`}isEnabled(){return!!this.d}async getExtensions(z,C,W){const G=D.CancellationToken.isCancellationToken(C)?{}:C,te=D.CancellationToken.isCancellationToken(C)?C:W,le=[],ue=[],$e=[],we=[];let fe=!0;for(const ve of z){ve.uuid?ue.push(ve.uuid):le.push(ve.id);const Pe=!!(ve.version||ve.preRelease);$e.push({id:ve.id,uuid:ve.uuid,includePreRelease:Pe}),ve.version&&we.push({id:ve.id,uuid:ve.uuid,version:ve.version}),fe=fe&&!!ve.hasPreRelease&&!Pe}if(!ue.length&&!le.length)return[];let ce=new b().withPage(1,z.length);ue.length&&(ce=ce.withFilter(s.ExtensionId,...ue)),le.length&&(ce=ce.withFilter(s.ExtensionName,...le)),(G.queryAllVersions||fe)&&(ce=ce.withFlags(ce.flags,t.IncludeVersions)),G.source&&(ce=ce.withSource(G.source));const{extensions:pe}=await this.z(ce,{targetPlatform:G.targetPlatform??i,includePreRelease:$e,versions:we,compatible:!!G.compatible},te);return G.source&&pe.forEach((ve,Pe)=>Q(ve,Pe,G.source)),pe}async getCompatibleExtension(z,C,W){if((0,E.$Ko)(z.allTargetPlatforms,W))return null;if(await this.isExtensionCompatible(z,C,W))return z;const G=new b().withFlags(t.IncludeVersions).withPage(1,1).withFilter(s.ExtensionId,z.identifier.uuid),{extensions:te}=await this.z(G,{targetPlatform:W,compatible:!0,includePreRelease:C},D.CancellationToken.None);return te[0]||null}async isExtensionCompatible(z,C,W){if(!(0,E.$Lo)(z.properties.targetPlatform,z.allTargetPlatforms,W)||!C&&z.properties.isPreReleaseVersion)return!1;let G=z.properties.engine;if(!G){const te=await this.getManifest(z,D.CancellationToken.None);if(!te)throw new Error("Manifest was not found");G=te.engines.vscode}return(0,m.$up)(G,this.u.version,this.u.date)}async y(z,C,W,G,te){if(!(0,E.$Lo)(M(z),G,te)||C!=="any"&&de(z)!==(C==="prerelease"))return!1;if(W)try{const le=await this.E(z);if(!(0,m.$up)(le,this.u.version,this.u.date))return!1}catch(le){return this.l.error(`Error while getting the engine for the version ${z.version}.`,(0,R.$0)(le)),!1}return!0}async query(z,C){let W=z.text||"";const G=z.pageSize??50;let te=new b().withPage(1,G);W?(W=W.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,ce,pe)=>(te=te.withFilter(s.Category,pe||ce),"")),W=W.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,ce,pe)=>(te=te.withFilter(s.Tag,pe||ce),"")),W=W.replace(/\bfeatured(\s+|\b|$)/g,()=>(te=te.withFilter(s.Featured),"")),W=W.trim(),W&&(W=W.length<200?W:W.substring(0,200),te=te.withFilter(s.SearchText,W)),te=te.withSortBy(0)):z.ids?te=te.withFilter(s.ExtensionId,...z.ids):z.names?te=te.withFilter(s.ExtensionName,...z.names):te=te.withSortBy(4),typeof z.sortBy=="number"&&(te=te.withSortBy(z.sortBy)),typeof z.sortOrder=="number"&&(te=te.withSortOrder(z.sortOrder)),z.source&&(te=te.withSource(z.source));const le=async(fe,ce)=>{const{extensions:pe,total:ve}=await this.z(fe,{targetPlatform:i,compatible:!1,includePreRelease:!!z.includePreRelease},ce);return pe.forEach((Pe,je)=>Q(Pe,(fe.pageNumber-1)*fe.pageSize+je,z.source)),{extensions:pe,total:ve}},{extensions:ue,total:$e}=await le(te,C),we=async(fe,ce)=>{if(ce.isCancellationRequested)throw new R.$5;const{extensions:pe}=await le(te.withPage(fe+1),ce);return pe};return{firstPage:ue,total:$e,pageSize:te.pageSize,getPage:we}}async z(z,C,W){const G=z.flags;z.flags&t.IncludeLatestVersionOnly&&z.flags&t.IncludeVersions&&(z=z.withFlags(z.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(z.flags&t.IncludeLatestVersionOnly)&&!(z.flags&t.IncludeVersions)&&(z=z.withFlags(z.flags,t.IncludeLatestVersionOnly)),C.versions?.length&&(z=z.withFlags(z.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),z=z.withFlags(z.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:te,total:le,context:ue}=await this.B(z,W);if(!(z.flags&t.IncludeLatestVersionOnly)){const ce=[];for(const pe of te){const ve=await this.A(pe,C,ue);ve&&ce.push(ve)}return{extensions:ce,total:le}}const we=[],fe=new Map;for(let ce=0;ce<te.length;ce++){const pe=te[ce],ve={id:(0,d.$hp)(pe.publisher.publisherName,pe.extensionName),uuid:pe.extensionId},Pe=(0,S.$Yf)(C.includePreRelease)?C.includePreRelease:!!C.includePreRelease.find(V=>(0,d.$cp)(V,ve))?.includePreRelease;if(C.compatible&&(0,E.$Ko)(H(pe),C.targetPlatform))continue;const je=await this.A(pe,C,ue);!je||je.properties.isPreReleaseVersion&&(!Pe||!je.hasReleaseVersion)||!je.properties.isPreReleaseVersion&&je.properties.targetPlatform!==C.targetPlatform&&je.hasPreReleaseVersion?fe.set(pe.extensionId,ce):we.push([ce,je])}if(fe.size){const ce=new g.$1d,pe=new b().withFlags(G&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,fe.size).withFilter(s.ExtensionId,...fe.keys()),{extensions:ve}=await this.z(pe,C,W);this.o.publicLog2("galleryService:additionalQuery",{duration:ce.elapsed(),count:fe.size});for(const Pe of ve){const je=fe.get(Pe.identifier.uuid);we.push([je,Pe])}}return{extensions:we.sort((ce,pe)=>ce[0]-pe[0]).map(([,ce])=>ce),total:le}}async A(z,C,W){const G={id:(0,d.$hp)(z.publisher.publisherName,z.extensionName),uuid:z.extensionId},te=C.versions?.find(we=>(0,d.$cp)(we,G))?.version,le=(0,S.$Yf)(C.includePreRelease)?C.includePreRelease:!!C.includePreRelease.find(we=>(0,d.$cp)(we,G))?.includePreRelease,ue=H(z),$e=Z(z.versions,C.targetPlatform);if(C.compatible&&(0,E.$Ko)(ue,C.targetPlatform))return null;for(let we=0;we<$e.length;we++){const fe=$e[we];if(!(te&&fe.version!==te)){if(await this.y(fe,le?"any":"release",C.compatible,ue,C.targetPlatform))return _(z,fe,ue,W);if(te&&fe.version===te)return null}}return te||C.compatible?null:_(z,z.versions[0],ue)}async B(z,C){if(!this.isEnabled())throw new Error("No extension gallery service configured.");z=z.withFlags(z.flags,t.ExcludeNonValidated).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExcludeWithFlags,n(t.Unpublished));const W=await this.j,G=JSON.stringify(z.raw),te={...W,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(G.length)},le=new g.$1d;let ue,$e,we=0;try{if(ue=await this.k.request({type:"POST",url:this.g&&z.criteria.some(ce=>ce.filterType===s.SearchText)?this.g:this.x("/extensionquery"),data:G,headers:te},C),ue.res.statusCode&&ue.res.statusCode>=400&&ue.res.statusCode<500)return{galleryExtensions:[],total:we};const fe=await(0,c.$Bp)(ue);if(fe){const ce=fe.results[0],pe=ce.extensions,ve=ce.resultMetadata&&ce.resultMetadata.filter(Pe=>Pe.metadataType==="ResultCount")[0];return we=ve&&ve.metadataItems.filter(Pe=>Pe.name==="TotalCount")[0].count||0,{galleryExtensions:pe,total:we,context:{[r]:ue.res.headers.activityid}}}return{galleryExtensions:[],total:we}}catch(fe){const ce=(0,R.$4)(fe)?E.ExtensionGalleryErrorCode.Cancelled:(0,R.$0)(fe).startsWith("XHR timeout")?E.ExtensionGalleryErrorCode.Timeout:E.ExtensionGalleryErrorCode.Failed;throw $e=new E.$Po((0,R.$0)(fe),ce),$e}finally{this.o.publicLog2("galleryService:query",{...z.telemetryData,requestBodySize:String(G.length),duration:le.elapsed(),success:!!ue&&(0,c.$xp)(ue),responseBodySize:ue?.res.headers["Content-Length"],statusCode:ue?String(ue.res.statusCode):void 0,errorCode:$e?.code,count:String(we)})}}async reportStatistic(z,C,W,G){if(!this.isEnabled())return;const te=L.$o?this.x(`/itemName/${z}.${C}/version/${W}/statType/${G==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${z}/extensions/${C}/${W}/stats?statType=${G}`),le=L.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",$e={...await this.j,Accept:le};try{await this.k.request({type:"POST",url:te,headers:$e},D.CancellationToken.None)}catch{}}async download(z,C,W){this.l.trace("ExtensionGalleryService#download",z.identifier.id);const G=(0,d.$kp)(z),te=new Date().getTime(),le=ce=>this.o.publicLog("galleryService:downloadVSIX",{...G,duration:ce}),ue=W===2?"install":W===3?"update":"",$e=ue?{uri:`${z.assets.download.uri}${u.URI.parse(z.assets.download.uri).query?"&":"?"}${ue}=true`,fallbackUri:`${z.assets.download.fallbackUri}${u.URI.parse(z.assets.download.fallbackUri).query?"&":"?"}${ue}=true`}:z.assets.download,we=z.queryContext?.[r]?{[r]:z.queryContext[r]}:void 0,fe=await this.D($e,we?{headers:we}:void 0);await this.q.writeFile(C,fe.stream),le(new Date().getTime()-te)}async downloadSignatureArchive(z,C){if(!z.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",z.identifier.id);const W=await this.D(z.assets.signature);await this.q.writeFile(C,W.stream)}async getReadme(z,C){if(z.assets.readme){const W=await this.D(z.assets.readme,{},C);return await(0,c.$Ap)(W)||""}return""}async getManifest(z,C){if(z.assets.manifest){const W=await this.D(z.assets.manifest,{},C),G=await(0,c.$Ap)(W);return G?JSON.parse(G):null}return null}async C(z,C){const W=oe(z,o.Manifest);if(!W)throw new Error("Manifest was not found");const G={"Accept-Encoding":"gzip"},te=await this.D(W,{headers:G});return await(0,c.$Bp)(te)}async getCoreTranslation(z,C){const W=z.assets.coreTranslations.filter(G=>G[0]===C.toUpperCase())[0];if(W){const G=await this.D(W[1]),te=await(0,c.$Ap)(G);return te?JSON.parse(te):null}return null}async getChangelog(z,C){if(z.assets.changelog){const W=await this.D(z.assets.changelog,{},C);return await(0,c.$Ap)(W)||""}return""}async getAllCompatibleVersions(z,C,W){let G=new b().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);z.identifier.uuid?G=G.withFilter(s.ExtensionId,z.identifier.uuid):G=G.withFilter(s.ExtensionName,z.identifier.id);const{galleryExtensions:te}=await this.B(G,D.CancellationToken.None);if(!te.length)return[];const le=H(te[0]);if((0,E.$Ko)(le,W))return[];const ue=[];await Promise.all(te[0].versions.map(async fe=>{try{await this.y(fe,C?"any":"release",!0,le,W)&&ue.push(fe)}catch{}}));const $e=[],we=new Set;for(const fe of Z(ue,W))we.has(fe.version)||(we.add(fe.version),$e.push({version:fe.version,date:fe.lastUpdated,isPreReleaseVersion:de(fe)}));return $e}async D(z,C={},W=D.CancellationToken.None){const G=await this.j,te={type:"GET"},le={...G,...C.headers||{}};C={...C,...te,headers:le};const ue=z.uri,$e=z.fallbackUri,we={...C,url:ue};try{const fe=await this.k.request(we,W);if(fe.res.statusCode===200)return fe;const ce=await(0,c.$Ap)(fe);throw new Error(`Expected 200, got back ${fe.res.statusCode} instead.

${ce}`)}catch(fe){if((0,R.$4)(fe))throw fe;const ce=(0,R.$0)(fe);this.o.publicLog2("galleryService:cdnFallback",{url:ue,message:ce});const pe={...C,url:$e};return this.k.request(pe,W)}}async E(z){let C=he(z);if(!C){const W=await this.C(z,D.CancellationToken.None);if(!W)throw new Error("Manifest was not found");C=W.engines.vscode}return C}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const z=await this.k.request({type:"GET",url:this.h},D.CancellationToken.None);if(z.res.statusCode!==200)throw new Error("Could not get extensions report.");const C=await(0,c.$Bp)(z),W=[],G={},te=[];if(C){for(const le of C.malicious)W.push({id:le});if(C.migrateToPreRelease)for(const[le,ue]of Object.entries(C.migrateToPreRelease))(!ue.engine||(0,m.$up)(ue.engine,this.u.version,this.u.date))&&(G[le.toLowerCase()]={disallowInstall:!0,extension:{id:ue.id,displayName:ue.displayName,autoMigrate:{storage:!!ue.migrateStorage},preRelease:!0}});if(C.deprecated)for(const[le,ue]of Object.entries(C.deprecated))ue&&(G[le.toLowerCase()]=(0,S.$Yf)(ue)?{}:ue);if(C.search)for(const le of C.search)te.push(le)}return{malicious:W,deprecated:G,search:te}}};U=me([se(1,c.$vp),se(2,k.$zj),se(3,y.$mi),se(4,h.$El),se(5,w.$Fk),se(6,v.$Rj),se(7,a.$Li)],U);let F=class extends U{constructor(z,C,W,G,te,le,ue,$e){super(z,C,W,G,te,le,ue,$e)}};e.$Rp=F,e.$Rp=F=me([se(0,$.$Ip),se(1,c.$vp),se(2,k.$zj),se(3,y.$mi),se(4,h.$El),se(5,w.$Fk),se(6,v.$Rj),se(7,a.$Li)],F);let f=class extends U{constructor(z,C,W,G,te,le,ue){super(void 0,z,C,W,G,te,le,ue)}};e.$Sp=f,e.$Sp=f=me([se(0,c.$vp),se(1,k.$zj),se(2,y.$mi),se(3,h.$El),se(4,w.$Fk),se(5,v.$Rj),se(6,a.$Li)],f)}),define(ie[164],ne([0,1,11,18,13,4,142,22,23,3,68]),function(J,e,N,D,R,L,A,S,u,a,y){"use strict";var E,d;Object.defineProperty(e,"__esModule",{value:!0}),e.$GP=e.$FP=e.$EP=void 0;let m=class extends u.$il{static{E=this}static{this.a="profileAssociationsMigration"}constructor(c,p,$,h,g){super($,h,p,g),this.U=c,this.W=$}O(){return this.U.getItem(E.b,[]).map(p=>({...p,location:(0,a.$Sf)(p.location)?this.w.extUri.joinPath(this.profilesHome,p.location):N.URI.revive(p.location)}))}Q(){const c=this.U.getItem(E.c,{});return this.U.getItem(E.a,!1)?c:this.N(c)}S(){return this.w.extUri.joinPath(N.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$EP=m,e.$EP=m=E=me([se(0,A.$zP),se(1,S.$dl),se(2,D.$ni),se(3,R.$Fk),se(4,L.$zj)],m);let w=d=class extends m{constructor(c,p,$,h,g){super(c,p,$,h,g),this.$=c}P(c){c.length?this.$.setItem(d.b,c.map(p=>({...p,location:this.w.extUri.basename(p.location)}))):this.$.removeItem(d.b)}O(){const c=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(c),this.$.setItem("userDataProfilesMigration",!0)),c}R(c){c.emptyWindows||c.workspaces?this.$.setItem(d.c,c):this.$.removeItem(d.c)}Q(){const c="workspaceAndProfileInfo",p=this.$.getItem(c,void 0);if(p){this.$.removeItem(c);const h=p.reduce((g,{workspace:i,profile:r})=>(g[N.URI.revive(i).toString()]=N.URI.revive(r).toString(),g),{});this.$.setItem(d.c,{workspaces:h})}const $=super.Q();return this.$.getItem(d.a,!1)||(this.R($),this.$.setItem(d.a,!0)),$}};e.$FP=w,e.$FP=w=d=me([se(0,A.$AP),se(1,S.$dl),se(2,D.$ni),se(3,R.$Fk),se(4,L.$zj)],w);let k=class extends w{constructor(c,p,$,h){super(new y.$DP(0,p,h,$),c,p,$,h)}async init(){return await this.$.init(),super.init()}};e.$GP=k,e.$GP=k=me([se(0,S.$dl),se(1,D.$ni),se(2,R.$Fk),se(3,L.$zj)],k)}),define(ie[165],ne([0,1,140,9,14,7,3,29,18,141,4,45,139,177]),function(J,e,N,D,R,L,A,S,u,a,y,E,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cr=e.$Br=void 0;let w=class extends E.$wp{constructor(p,$,h,g){super(g),this.m=p,this.n=$,this.r=h,this.s(),this.B(p.onDidChangeConfiguration(i=>{i.affectsConfiguration("http")&&this.s()}))}s(){const p=this.m.getValue("http");this.f=p?.proxy,this.g=!!p?.proxyStrictSSL,this.h=p?.proxyAuthorization}async request(p,$){const{f:h,g}=this;let i;try{i=await(0,a.$jm)(this.m,this.r,this.n.args,process.env)}catch(n){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,L.$0)(n)))}const r={...process.env,...i},t=p.agent?p.agent:await(0,d.$Ar)(p.url||"",r,{proxyUrl:h,strictSSL:g});return p.agent=t,p.strictSSL=g,this.h&&(p.headers={...p.headers||{},"Proxy-Authorization":this.h}),this.c(p.isChromiumNetwork?"electron":"node",p,()=>v(p,$))}async resolveProxy(p){}async loadCertificates(){return(await new Promise(($,h)=>{J(["@vscode/proxy-agent"],$,h)})).loadSystemCertificates({log:this.r})}};e.$Br=w,e.$Br=w=me([se(0,S.$Li),se(1,u.$ni),se(2,y.$zj),se(3,y.$Aj)],w);async function k(c){return((0,N.parse)(c.url).protocol==="https:"?await new Promise((h,g)=>{J(["https"],h,g)}):await new Promise((h,g)=>{J(["http"],h,g)})).request}async function v(c,p){return D.Promises.withAsyncBody(async($,h)=>{const g=(0,N.parse)(c.url),i=c.getRawRequest?c.getRawRequest(c):await k(c),r={hostname:g.hostname,port:g.port?parseInt(g.port):g.protocol==="https:"?443:80,protocol:g.protocol,path:g.path,method:c.type||"GET",headers:c.headers,agent:c.agent,rejectUnauthorized:(0,A.$Yf)(c.strictSSL)?c.strictSSL:!0};c.user&&c.password&&(r.auth=c.user+":"+c.password);const t=i(r,n=>{const s=(0,A.$Wf)(c.followRedirects)?c.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&s>0&&n.headers.location)v({...c,url:n.headers.location,followRedirects:s-1},p).then($,h);else{let o=n;!c.isChromiumNetwork&&n.headers["content-encoding"]==="gzip"&&(o=n.pipe((0,m.createGunzip)())),$({res:n,stream:(0,R.$He)(o)})}});t.on("error",h),c.timeout&&t.setTimeout(c.timeout),c.isChromiumNetwork&&t.removeHeader("Content-Length"),c.data&&typeof c.data=="string"&&t.write(c.data),t.end(),p.onCancellationRequested(()=>{t.abort(),h(new L.$5)})})}e.$Cr=v}),define(ie[178],ne([0,1,33,9,34,7,2,15,16,12,35,11,24,29,136,59,138,18,114,163,21,64,143,42,52,159,161,13,126,128,51,124,62,63,147,4,132,39,133,150,32,45,165,68,69,25,149,41,151,152,22,154,23,164,153,160,129,131,5,155]),function(J,e,N,D,R,L,A,S,u,a,y,E,d,m,w,k,v,c,p,$,h,g,i,r,t,n,s,o,l,O,I,b,j,q,Y,K,oe,re,he,de,ae,B,X,T,M,H,Z,Q,_,U,F,f,P,z,C,W,G,te,le,ue){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class $e extends A.$Tc{constructor(ce){super(),this.b=ce,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[ce,pe]=await this.f();return ce.invokeFunction(async ve=>{const Pe=ve.get(K.$zj),je=ve.get(o.$Fk),V=ve.get(c.$ni),x=ve.get(P.$fl);Pe.info("CLI main",this.b),this.g(Pe),await this.h(V,je,x,ce),await Promise.all(pe.map(ee=>{(0,D.$9g)(ee.flush(),1e3)}))})}async f(){const ce=new j.$di,pe={_serviceBrand:void 0,...de.default};ce.set(ae.$Rj,pe);const ve=new p.$Qm(this.b,pe);ce.set(c.$ni,ve),await Promise.all([ve.appSettingsHome.with({scheme:S.Schemas.file}).fsPath,ve.extensionsPath].map(Le=>Le?d.Promises.mkdir(Le,{recursive:!0}):void 0));const Pe=new te.$yP((0,K.$Nj)(ve),ve.logsHome);ce.set(K.$Aj,Pe);const je=this.B(Pe.createLogger("cli",{name:(0,le.localize)(0,null)})),V=[];Pe.getLogLevel()===K.LogLevel.Trace&&V.push(new K.$Hj(Pe.getLogLevel()));const x=this.B(new G.$IP(je,V));ce.set(K.$zj,x);const ee=this.B(new l.$qq(x));ce.set(o.$Fk,ee);const ge=this.B(new O.$Pq(x));ee.registerProvider(S.Schemas.file,ge);const ye=new f.$ds(ee);ce.set(F.$dl,ye);const De=new T.$CP(1,ve,x,ee),Se=new z.$EP(De,ye,ve,ee,x);ce.set(P.$fl,Se),ee.registerProvider(S.Schemas.vscodeUserData,new ue.$Lac(S.Schemas.file,ge,S.Schemas.vscodeUserData,Se,ye,x));const ze=a.$i&&pe.win32RegValueName?this.B(new he.$Jac(x,pe.win32RegValueName)):ve.policyFile?this.B(new oe.$Kac(ve.policyFile,ee,x)):new re.$1n;ce.set(re.$Yn,ze);const Ie=this.B(new w.$oo(Se.defaultProfile.settingsResource,ee,ze,x));ce.set(m.$Li,Ie),await Promise.all([De.init(),Ie.initialize()]);let Ne;try{Ne=await(0,C.$nac)(De,x)}catch(Le){Le.code!=="ENOENT"&&x.error(Le)}const Ce=await(0,C.$oac)(De,x);Se.init(),ce.set(F.$dl,new f.$ds(ee));const Oe=new X.$Br(Ie,ve,x,Pe);ce.set(B.$vp,Oe),ce.set(k.$so,new I.$ci(v.$XP,void 0,!0)),ce.set(r.$0p,new I.$ci(W.$HP,void 0,!0)),ce.set(t.$bq,new I.$ci(s.$kac,void 0,!0)),ce.set(g.$Tp,new I.$ci(g.$Up,void 0,!0)),ce.set(n.$lq,new I.$ci(n.$mq,void 0,!0)),ce.set(h.$No,new I.$ci($.$Sp,void 0,!0)),ce.set(q.$vr,new I.$ci(Y.$xr,void 0,!1));const Ae=[],Fe=(0,Q.$_o)(pe,Ie);if((0,Q.$7o)(pe,ve)){pe.aiConfig&&pe.aiConfig.ariaKey&&Ae.push(new _.$wP(Oe,Fe,"monacoworkbench",null,pe.aiConfig.ariaKey));const Le={appenders:Ae,sendErrorTelemetry:!1,commonProperties:(0,M.$Xo)((0,N.release)(),(0,N.hostname)(),process.arch,pe.commit,pe.version,Ne,Ce,Fe),piiPaths:(0,Q.$ap)(ve)};ce.set(H.$El,new I.$ci(Z.$Dr,[Le],!1))}else ce.set(H.$El,Q.$2o);return[new b.$Sq(ce),Ae]}g(ce){(0,L.setUnexpectedErrorHandler)(pe=>{const ve=(0,R.$3i)(pe,!0);ve&&ce.error(`[uncaught exception in CLI]: ${ve}`)}),process.on("uncaughtException",pe=>{(0,L.$Z)(pe)||(0,L.$1)(pe)}),process.on("unhandledRejection",pe=>(0,L.$1)(pe))}async h(ce,pe,ve,Pe){let je;if(ce.args.profile&&(je=ve.profiles.find(x=>x.name===ce.args.profile),!je))throw new Error(`Profile '${ce.args.profile}' not found.`);const V=(je??ve.defaultProfile).extensionsResource;if(this.b["list-extensions"])return Pe.createInstance(i.$Vp,new K.$Hj(K.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,V);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const x={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:V};return Pe.createInstance(i.$Vp,new K.$Hj(K.LogLevel.Info,!1)).installExtensions(this.j(this.b["install-extension"]||[]),this.j(this.b["install-builtin-extension"]||[]),x,!!this.b.force)}else{if(this.b["uninstall-extension"])return Pe.createInstance(i.$Vp,new K.$Hj(K.LogLevel.Info,!1)).uninstallExtensions(this.j(this.b["uninstall-extension"]),!!this.b.force,V);if(this.b["update-extensions"])return Pe.createInstance(i.$Vp,new K.$Hj(K.LogLevel.Info,!1)).updateExtensions(V);if(this.b["locate-extension"])return Pe.createInstance(i.$Vp,new K.$Hj(K.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,U.$0ac)(ce.appRoot,ce.extensionsPath))}}j(ce){return ce.map(pe=>/\.vsix$/i.test(pe)?E.URI.file((0,u.$ic)(pe)?pe:(0,u.$jc)((0,y.cwd)(),pe)):pe)}}async function we(fe){const ce=new $e(fe);try{await ce.run()}finally{ce.dispose()}}e.main=we})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/8c2b09c0443b94d75a73819ed35610f7e09375ae/core/vs/code/node/cliProcessMain.js.map
