/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Se=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/strings","vs/base/common/network","vs/workbench/api/common/extHostTypeConverters","vs/base/common/path","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/buffer","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/base/common/uuid","vs/base/node/pfs","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/platform/registry/common/platform","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/lazy","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/iterator","vs/editor/common/core/position","vs/base/common/process","child_process","vs/platform/configuration/common/configuration","vs/base/common/decorators","vs/base/common/hash","vs/base/common/themables","vs/base/common/marshalling","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","net","os","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/editor/common/model","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/codiconsUtil","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostLanguageModels","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","crypto","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],De=function(fe){for(var e=[],l=0,j=fe.length;l<j;l++)e[l]=Se[fe[l]];return e};define(Se[161],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class l{static get(){const L=new Map,A=new Map,R=new Map,p=new Map;function w(S,k){S.has(k.detail)||S.set(k.detail,-k.timestamp)}function E(S,k){const u=S.get(k.detail);u&&(u>=0||S.set(k.detail,u+k.timestamp))}let M=[];typeof fe=="function"&&typeof fe.getStats=="function"&&(M=fe.getStats().slice(0).sort((S,k)=>S.timestamp-k.timestamp));for(const S of M)switch(S.type){case 10:w(L,S);break;case 11:case 12:E(L,S);break;case 21:w(A,S);break;case 22:E(A,S);break;case 33:w(R,S);break;case 34:E(R,S);break;case 31:w(p,S);break;case 32:E(p,S);break}let C=0;R.forEach(S=>C+=S);function v(S){const k=[];return S.forEach((u,m)=>k.push([m,u])),k}return{amdLoad:v(L),amdInvoke:v(A),nodeRequire:v(R),nodeEval:v(p),nodeRequireTotal:C}}static toMarkdownTable(L,A){let R="";const p=[];return L.forEach((w,E)=>{p[E]=w.length}),A.forEach(w=>{w.forEach((E,M)=>{typeof E>"u"&&(E=w[M]="-");const C=E.toString().length;p[M]=Math.max(C,p[M])})}),L.forEach((w,E)=>{R+=`| ${w+" ".repeat(p[E]-w.toString().length)} `}),R+=`|
`,L.forEach((w,E)=>{R+=`| ${"-".repeat(p[E])} `}),R+=`|
`,A.forEach(w=>{w.forEach((E,M)=>{typeof E<"u"&&(R+=`| ${E+" ".repeat(p[M]-E.toString().length)} `)}),R+=`|
`}),R}}e.$U=l}),define(Se[162],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function l(u,m,o){const i=j(u,m);if(i!==-1)return u[i]}e.$fb=l;function j(u,m,o=u.length-1){for(let i=o;i>=0;i--){const n=u[i];if(m(n))return i}return-1}e.$gb=j;function L(u,m){const o=A(u,m);return o===-1?void 0:u[o]}e.$hb=L;function A(u,m,o=0,i=u.length){let n=o,s=i;for(;n<s;){const c=Math.floor((n+s)/2);m(u[c])?n=c+1:s=c}return n-1}e.$ib=A;function R(u,m){const o=p(u,m);return o===u.length?void 0:u[o]}e.$jb=R;function p(u,m,o=0,i=u.length){let n=o,s=i;for(;n<s;){const c=Math.floor((n+s)/2);m(u[c])?s=c:n=c+1}return n}e.$kb=p;function w(u,m,o=0,i=u.length){const n=p(u,m,o,i);return n===u.length?-1:n}e.$lb=w;class E{static{this.assertInvariants=!1}constructor(m){this.e=m,this.c=0}findLastMonotonous(m){if(E.assertInvariants){if(this.d){for(const i of this.e)if(this.d(i)&&!m(i))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=m}const o=A(this.e,m,this.c);return this.c=o+1,o===-1?void 0:this.e[o]}}e.$mb=E;function M(u,m){if(u.length===0)return;let o=u[0];for(let i=1;i<u.length;i++){const n=u[i];m(n,o)>0&&(o=n)}return o}e.$nb=M;function C(u,m){if(u.length===0)return;let o=u[0];for(let i=1;i<u.length;i++){const n=u[i];m(n,o)>=0&&(o=n)}return o}e.$ob=C;function v(u,m){return M(u,(o,i)=>-m(o,i))}e.$pb=v;function S(u,m){if(u.length===0)return-1;let o=0;for(let i=1;i<u.length;i++){const n=u[i];m(n,u[o])>0&&(o=i)}return o}e.$qb=S;function k(u,m){for(const o of u){const i=m(o);if(i!==void 0)return i}}e.$rb=k}),define(Se[72],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N=e.$M=e.$L=e.$K=void 0;function l(R,p){const w=Object.create(null);for(const E of R){const M=p(E);let C=w[M];C||(C=w[M]=[]),C.push(E)}return w}e.$K=l;function j(R,p){const w=[],E=[];for(const M of R)p.has(M)||w.push(M);for(const M of p)R.has(M)||E.push(M);return{removed:w,added:E}}e.$L=j;function L(R,p){const w=[],E=[];for(const[M,C]of R)p.has(M)||w.push(C);for(const[M,C]of p)R.has(M)||E.push(C);return{removed:w,added:E}}e.$M=L;function A(R,p){const w=new Set;for(const E of p)R.has(E)&&w.add(E);return w}e.$N=A}),define(Se[53],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=e.$Kh=e.$Jh=void 0;function l(R){return(p,w,E)=>{let M=null,C=null;if(typeof E.value=="function"?(M="value",C=E.value):typeof E.get=="function"&&(M="get",C=E.get),!C)throw new Error("not supported");E[M]=R(C,w)}}function j(R,p,w){let E=null,M=null;if(typeof w.value=="function"?(E="value",M=w.value,M.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof w.get=="function"&&(E="get",M=w.get),!M)throw new Error("not supported");const C=`$memoize$${p}`;w[E]=function(...v){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:M.apply(this,v)}),this[C]}}e.$Jh=j;function L(R,p,w){return l((E,M)=>{const C=`$debounce$${M}`,v=`$debounce$result$${M}`;return function(...S){this[v]||(this[v]=w?w():void 0),clearTimeout(this[C]),p&&(this[v]=p(this[v],...S),S=[this[v]]),this[C]=setTimeout(()=>{E.apply(this,S),this[v]=w?w():void 0},R)}})}e.$Kh=L;function A(R,p,w){return l((E,M)=>{const C=`$throttle$timer$${M}`,v=`$throttle$result$${M}`,S=`$throttle$lastRun$${M}`,k=`$throttle$pending$${M}`;return function(...u){if(this[v]||(this[v]=w?w():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),p&&(this[v]=p(this[v],...u)),this[k])return;const m=this[S]+R;m<=Date.now()?(this[S]=Date.now(),E.apply(this,[this[v]]),this[v]=w?w():void 0):(this[k]=!0,this[C]=setTimeout(()=>{this[k]=!1,this[S]=Date.now(),E.apply(this,[this[v]]),this[v]=w?w():void 0},m-Date.now()))}})}e.$Lh=A}),define(Se[13],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class l{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?n.isErrorNoTelemetry(t)?new n(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(f=>{f(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=l,e.$X=new l;function j(c){e.$X.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=j;function L(c){if(!c||typeof c!="object")return!1;const t=c;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$Z=L;function A(c){E(c)||e.$X.onUnexpectedError(c)}e.$1=A;function R(c){E(c)||e.$X.onUnexpectedExternalError(c)}e.$2=R;function p(c){if(c instanceof Error){const{name:t,message:f}=c,h=c.stacktrace||c.stack;return{$isError:!0,name:t,message:f,stack:h,noTelemetry:n.isErrorNoTelemetry(c)}}return c}e.$3=p;const w="Canceled";function E(c){return c instanceof M?!0:c instanceof Error&&c.name===w&&c.message===w}e.$4=E;class M extends Error{constructor(){super(w),this.name=this.message}}e.$5=M;function C(){const c=new Error(w);return c.name=c.message,c}e.$6=C;function v(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.$7=v;function S(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.$8=S;class k extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=k;function u(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.$0=u;class m extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=m;class o extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=o;class i extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=i;class n extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof n)return t;const f=new n;return f.message=t.message,f.stack=t.stack,f}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=n;class s extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,s.prototype)}}e.$cb=s}),define(Se[19],De([1,0,13,162]),function(fe,e,l,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function L(le,ue=0){return le[le.length-(1+ue)]}e.$sb=L;function A(le){if(le.length===0)throw new Error("Invalid tail call");return[le.slice(0,le.length-1),le[le.length-1]]}e.$tb=A;function R(le,ue,ce=(de,H)=>de===H){if(le===ue)return!0;if(!le||!ue||le.length!==ue.length)return!1;for(let de=0,H=le.length;de<H;de++)if(!ce(le[de],ue[de]))return!1;return!0}e.$ub=R;function p(le,ue){const ce=le.length-1;ue<ce&&(le[ue]=le[ce]),le.pop()}e.$vb=p;function w(le,ue,ce){return E(le.length,de=>ce(le[de],ue))}e.$wb=w;function E(le,ue){let ce=0,de=le-1;for(;ce<=de;){const H=(ce+de)/2|0,Z=ue(H);if(Z<0)ce=H+1;else if(Z>0)de=H-1;else return H}return-(ce+1)}e.$xb=E;function M(le,ue,ce){if(le=le|0,le>=ue.length)throw new TypeError("invalid index");const de=ue[Math.floor(ue.length*Math.random())],H=[],Z=[],he=[];for(const be of ue){const Pe=ce(be,de);Pe<0?H.push(be):Pe>0?Z.push(be):he.push(be)}return le<H.length?M(le,H,ce):le<H.length+he.length?he[0]:M(le-(H.length+he.length),Z,ce)}e.$yb=M;function C(le,ue){const ce=[];let de;for(const H of le.slice(0).sort(ue))!de||ue(de[0],H)!==0?(de=[H],ce.push(de)):de.push(H);return ce}e.$zb=C;function*v(le,ue){let ce,de;for(const H of le)de!==void 0&&ue(de,H)?ce.push(H):(ce&&(yield ce),ce=[H]),de=H;ce&&(yield ce)}e.$Ab=v;function S(le,ue){for(let ce=0;ce<=le.length;ce++)ue(ce===0?void 0:le[ce-1],ce===le.length?void 0:le[ce])}e.$Bb=S;function k(le,ue){for(let ce=0;ce<le.length;ce++)ue(ce===0?void 0:le[ce-1],le[ce],ce+1===le.length?void 0:le[ce+1])}e.$Cb=k;function u(le,ue,ce){const de=[];function H(be,Pe,pe){if(Pe===0&&pe.length===0)return;const Ae=de[de.length-1];Ae&&Ae.start+Ae.deleteCount===be?(Ae.deleteCount+=Pe,Ae.toInsert.push(...pe)):de.push({start:be,deleteCount:Pe,toInsert:pe})}let Z=0,he=0;for(;;){if(Z===le.length){H(Z,0,ue.slice(he));break}if(he===ue.length){H(Z,le.length-Z,[]);break}const be=le[Z],Pe=ue[he],pe=ce(be,Pe);pe===0?(Z+=1,he+=1):pe<0?(H(Z,1,[]),Z+=1):pe>0&&(H(Z,0,[Pe]),he+=1)}return de}e.$Db=u;function m(le,ue,ce){const de=u(le,ue,ce),H=[],Z=[];for(const he of de)H.push(...le.slice(he.start,he.start+he.deleteCount)),Z.push(...he.toInsert);return{removed:H,added:Z}}e.$Eb=m;function o(le,ue,ce){if(ce===0)return[];const de=le.slice(0,ce).sort(ue);return n(le,ue,de,ce,le.length),de}e.top=o;function i(le,ue,ce,de,H){return ce===0?Promise.resolve([]):new Promise((Z,he)=>{(async()=>{const be=le.length,Pe=le.slice(0,ce).sort(ue);for(let pe=ce,Ae=Math.min(ce+de,be);pe<be;pe=Ae,Ae=Math.min(Ae+de,be)){if(pe>ce&&await new Promise(Oe=>setTimeout(Oe)),H&&H.isCancellationRequested)throw new l.$5;n(le,ue,Pe,pe,Ae)}return Pe})().then(Z,he)})}e.$Gb=i;function n(le,ue,ce,de,H){for(const Z=ce.length;de<H;de++){const he=le[de];if(ue(he,ce[Z-1])<0){ce.pop();const be=(0,j.$kb)(ce,Pe=>ue(he,Pe)<0);ce.splice(be,0,he)}}}function s(le){return le.filter(ue=>!!ue)}e.$Hb=s;function c(le){let ue=0;for(let ce=0;ce<le.length;ce++)le[ce]&&(le[ue]=le[ce],ue+=1);le.length=ue}e.$Ib=c;function t(le,ue,ce){le.splice(ce,0,le.splice(ue,1)[0])}e.$Jb=t;function f(le){return!Array.isArray(le)||le.length===0}e.$Kb=f;function h(le){return Array.isArray(le)&&le.length>0}e.$Lb=h;function r(le,ue=ce=>ce){const ce=new Set;return le.filter(de=>{const H=ue(de);return ce.has(H)?!1:(ce.add(H),!0)})}e.$Mb=r;function a(le){const ue=new Set;return ce=>{const de=le(ce);return ue.has(de)?!1:(ue.add(de),!0)}}e.$Nb=a;function d(le,ue){return le.length>0?le[0]:ue}e.$Ob=d;function $(le,ue){return le.length>0?le[le.length-1]:ue}e.$Pb=$;function D(le,ue,ce=(de,H)=>de===H){let de=0;for(let H=0,Z=Math.min(le.length,ue.length);H<Z&&ce(le[H],ue[H]);H++)de++;return de}e.$Qb=D;function b(le){return[].concat(...le)}e.$Rb=b;function g(le,ue){let ce=typeof ue=="number"?le:0;typeof ue=="number"?ce=le:(ce=0,ue=le);const de=[];if(ce<=ue)for(let H=ce;H<ue;H++)de.push(H);else for(let H=ce;H>ue;H--)de.push(H);return de}e.$Sb=g;function y(le,ue,ce){return le.reduce((de,H)=>(de[ue(H)]=ce?ce(H):H,de),Object.create(null))}e.$Tb=y;function P(le,ue){return le.push(ue),()=>N(le,ue)}e.$Ub=P;function N(le,ue){const ce=le.indexOf(ue);if(ce>-1)return le.splice(ce,1),ue}e.$Vb=N;function U(le,ue,ce){const de=le.slice(0,ue),H=le.slice(ue);return de.concat(ce,H)}e.$Wb=U;function z(le,ue){let ce;if(typeof ue=="number"){let de=ue;ce=()=>{const H=Math.sin(de++)*179426549;return H-Math.floor(H)}}else ce=Math.random;for(let de=le.length-1;de>0;de-=1){const H=Math.floor(ce()*(de+1)),Z=le[de];le[de]=le[H],le[H]=Z}}e.$Xb=z;function F(le,ue){const ce=le.indexOf(ue);ce>-1&&(le.splice(ce,1),le.unshift(ue))}e.$Yb=F;function I(le,ue){const ce=le.indexOf(ue);ce>-1&&(le.splice(ce,1),le.push(ue))}e.$Zb=I;function O(le,ue){for(const ce of ue)le.push(ce)}e.$1b=O;function T(le,ue){return Array.isArray(le)?le.map(ue):ue(le)}e.$2b=T;function G(le){return Array.isArray(le)?le:[le]}e.$3b=G;function te(le){return le[Math.floor(Math.random()*le.length)]}e.$4b=te;function x(le,ue,ce){const de=Q(le,ue),H=le.length,Z=ce.length;le.length=H+Z;for(let he=H-1;he>=de;he--)le[he+Z]=le[he];for(let he=0;he<Z;he++)le[he+de]=ce[he]}e.$5b=x;function X(le,ue,ce,de){const H=Q(le,ue);let Z=le.splice(H,ce);return Z===void 0&&(Z=[]),x(le,H,de),Z}e.$6b=X;function Q(le,ue){return ue<0?Math.max(ue+le.length,0):Math.min(ue,le.length)}var ae;(function(le){function ue(Z){return Z<0}le.isLessThan=ue;function ce(Z){return Z<=0}le.isLessThanOrEqual=ce;function de(Z){return Z>0}le.isGreaterThan=de;function H(Z){return Z===0}le.isNeitherLessOrGreaterThan=H,le.greaterThan=1,le.lessThan=-1,le.neitherLessOrGreaterThan=0})(ae||(e.CompareResult=ae={}));function _(le,ue){return(ce,de)=>ue(le(ce),le(de))}e.$7b=_;function ge(...le){return(ue,ce)=>{for(const de of le){const H=de(ue,ce);if(!ae.isNeitherLessOrGreaterThan(H))return H}return ae.neitherLessOrGreaterThan}}e.$8b=ge;const se=(le,ue)=>le-ue;e.$9b=se;const re=(le,ue)=>(0,e.$9b)(le?1:0,ue?1:0);e.$0b=re;function B(le){return(ue,ce)=>-le(ue,ce)}e.$$b=B;class ie{constructor(ue){this.g=ue,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ue){let ce=this.c;for(;ce<this.g.length&&ue(this.g[ce]);)ce++;const de=ce===this.c?null:this.g.slice(this.c,ce);return this.c=ce,de}takeFromEndWhile(ue){let ce=this.d;for(;ce>=0&&ue(this.g[ce]);)ce--;const de=ce===this.d?null:this.g.slice(ce+1,this.d+1);return this.d=ce,de}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ue=this.g[this.c];return this.c++,ue}removeLast(){const ue=this.g[this.d];return this.d--,ue}takeCount(ue){const ce=this.g.slice(this.c,this.c+ue);return this.c+=ue,ce}}e.$_b=ie;class ye{static{this.empty=new ye(ue=>{})}constructor(ue){this.iterate=ue}forEach(ue){this.iterate(ce=>(ue(ce),!0))}toArray(){const ue=[];return this.iterate(ce=>(ue.push(ce),!0)),ue}filter(ue){return new ye(ce=>this.iterate(de=>ue(de)?ce(de):!0))}map(ue){return new ye(ce=>this.iterate(de=>ce(ue(de))))}some(ue){let ce=!1;return this.iterate(de=>(ce=ue(de),!ce)),ce}findFirst(ue){let ce;return this.iterate(de=>ue(de)?(ce=de,!1):!0),ce}findLast(ue){let ce;return this.iterate(de=>(ue(de)&&(ce=de),!0)),ce}findLastMaxBy(ue){let ce,de=!0;return this.iterate(H=>((de||ae.isGreaterThan(ue(H,ce)))&&(de=!1,ce=H),!0)),ce}}e.$ac=ye}),define(Se[61],De([1,0,13]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=e.$_c=e.$$c=e.$0c=e.$9c=e.ok=void 0;function j(E,M){if(!E)throw new Error(M?`Assertion failed (${M})`:"Assertion Failed")}e.ok=j;function L(E,M="Unreachable"){throw new Error(M)}e.$9c=L;function A(E){if(!E)throw new l.$cb("Assertion Failed")}e.$0c=A;function R(E){E||(0,l.$1)(new l.$cb("Soft Assertion Failed"))}e.$$c=R;function p(E){if(!E()){debugger;E(),(0,l.$1)(new l.$cb("Assertion Failed"))}}e.$_c=p;function w(E,M){let C=0;for(;C<E.length-1;){const v=E[C],S=E[C+1];if(!M(v,S))return!1;C++}return!0}e.$ad=w}),define(Se[73],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function l(j,L){const A=this;let R=!1,p;return function(){if(R)return p;if(R=!0,L)try{p=j.apply(A,arguments)}finally{L()}else p=j.apply(A,arguments);return p}}e.$db=l}),define(Se[124],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rO=e.$qO=void 0;class l{constructor(L){this.a=L,this.b=0}nextId(){return this.a+ ++this.b}}e.$qO=l,e.$rO=new l("id#")}),define(Se[48],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var l;(function(j){function L(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}j.is=L;const A=Object.freeze([]);function R(){return A}j.empty=R;function*p(t){yield t}j.single=p;function w(t){return L(t)?t:p(t)}j.wrap=w;function E(t){return t||A}j.from=E;function*M(t){for(let f=t.length-1;f>=0;f--)yield t[f]}j.reverse=M;function C(t){return!t||t[Symbol.iterator]().next().done===!0}j.isEmpty=C;function v(t){return t[Symbol.iterator]().next().value}j.first=v;function S(t,f){for(const h of t)if(f(h))return!0;return!1}j.some=S;function k(t,f){for(const h of t)if(f(h))return h}j.find=k;function*u(t,f){for(const h of t)f(h)&&(yield h)}j.filter=u;function*m(t,f){let h=0;for(const r of t)yield f(r,h++)}j.map=m;function*o(...t){for(const f of t)yield*f}j.concat=o;function i(t,f,h){let r=h;for(const a of t)r=f(r,a);return r}j.reduce=i;function*n(t,f,h=t.length){for(f<0&&(f+=t.length),h<0?h+=t.length:h>t.length&&(h=t.length);f<h;f++)yield t[f]}j.slice=n;function s(t,f=Number.POSITIVE_INFINITY){const h=[];if(f===0)return[h,t];const r=t[Symbol.iterator]();for(let a=0;a<f;a++){const d=r.next();if(d.done)return[h,j.empty()];h.push(d.value)}return[h,{[Symbol.iterator](){return r}}]}j.consume=s;async function c(t){const f=[];for await(const h of t)f.push(h);return Promise.resolve(f)}j.asyncToArray=c})(l||(e.Iterable=l={}))}),define(Se[163],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var l;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(l||(e.ScanError=l={}));var j;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(j||(e.SyntaxKind=j={}));var L;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(L||(e.ParseErrorCode=L={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function R(t,f=!1){let h=0;const r=t.length;let a="",d=0,$=16,D=0;function b(F){let I=0,O=0;for(;I<F;){const T=t.charCodeAt(h);if(T>=48&&T<=57)O=O*16+T-48;else if(T>=65&&T<=70)O=O*16+T-65+10;else if(T>=97&&T<=102)O=O*16+T-97+10;else break;h++,I++}return I<F&&(O=-1),O}function g(F){h=F,a="",d=0,$=16,D=0}function y(){const F=h;if(t.charCodeAt(h)===48)h++;else for(h++;h<t.length&&E(t.charCodeAt(h));)h++;if(h<t.length&&t.charCodeAt(h)===46)if(h++,h<t.length&&E(t.charCodeAt(h)))for(h++;h<t.length&&E(t.charCodeAt(h));)h++;else return D=3,t.substring(F,h);let I=h;if(h<t.length&&(t.charCodeAt(h)===69||t.charCodeAt(h)===101))if(h++,(h<t.length&&t.charCodeAt(h)===43||t.charCodeAt(h)===45)&&h++,h<t.length&&E(t.charCodeAt(h))){for(h++;h<t.length&&E(t.charCodeAt(h));)h++;I=h}else D=3;return t.substring(F,I)}function P(){let F="",I=h;for(;;){if(h>=r){F+=t.substring(I,h),D=2;break}const O=t.charCodeAt(h);if(O===34){F+=t.substring(I,h),h++;break}if(O===92){if(F+=t.substring(I,h),h++,h>=r){D=2;break}switch(t.charCodeAt(h++)){case 34:F+='"';break;case 92:F+="\\";break;case 47:F+="/";break;case 98:F+="\b";break;case 102:F+="\f";break;case 110:F+=`
`;break;case 114:F+="\r";break;case 116:F+="	";break;case 117:{const G=b(4);G>=0?F+=String.fromCharCode(G):D=4;break}default:D=5}I=h;continue}if(O>=0&&O<=31)if(w(O)){F+=t.substring(I,h),D=2;break}else D=6;h++}return F}function N(){if(a="",D=0,d=h,h>=r)return d=r,$=17;let F=t.charCodeAt(h);if(p(F)){do h++,a+=String.fromCharCode(F),F=t.charCodeAt(h);while(p(F));return $=15}if(w(F))return h++,a+=String.fromCharCode(F),F===13&&t.charCodeAt(h)===10&&(h++,a+=`
`),$=14;switch(F){case 123:return h++,$=1;case 125:return h++,$=2;case 91:return h++,$=3;case 93:return h++,$=4;case 58:return h++,$=6;case 44:return h++,$=5;case 34:return h++,a=P(),$=10;case 47:{const I=h-1;if(t.charCodeAt(h+1)===47){for(h+=2;h<r&&!w(t.charCodeAt(h));)h++;return a=t.substring(I,h),$=12}if(t.charCodeAt(h+1)===42){h+=2;const O=r-1;let T=!1;for(;h<O;){if(t.charCodeAt(h)===42&&t.charCodeAt(h+1)===47){h+=2,T=!0;break}h++}return T||(h++,D=1),a=t.substring(I,h),$=13}return a+=String.fromCharCode(F),h++,$=16}case 45:if(a+=String.fromCharCode(F),h++,h===r||!E(t.charCodeAt(h)))return $=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=y(),$=11;default:for(;h<r&&U(F);)h++,F=t.charCodeAt(h);if(d!==h){switch(a=t.substring(d,h),a){case"true":return $=8;case"false":return $=9;case"null":return $=7}return $=16}return a+=String.fromCharCode(F),h++,$=16}}function U(F){if(p(F)||w(F))return!1;switch(F){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function z(){let F;do F=N();while(F>=12&&F<=15);return F}return{setPosition:g,getPosition:()=>h,scan:f?z:N,getToken:()=>$,getTokenValue:()=>a,getTokenOffset:()=>d,getTokenLength:()=>h-d,getTokenError:()=>D}}e.$pn=R;function p(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function w(t){return t===10||t===13||t===8232||t===8233}function E(t){return t>=48&&t<=57}var M;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(M||(M={}));function C(t,f){const h=[],r=new Object;let a;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let $=!1;function D(b,g,y,P){d.value=b,d.offset=g,d.length=y,d.type=P,d.colonOffset=void 0,a=d}try{n(t,{onObjectBegin:(b,g)=>{if(f<=b)throw r;a=void 0,$=f>b,h.push("")},onObjectProperty:(b,g,y)=>{if(f<g||(D(b,g,y,"property"),h[h.length-1]=b,f<=g+y))throw r},onObjectEnd:(b,g)=>{if(f<=b)throw r;a=void 0,h.pop()},onArrayBegin:(b,g)=>{if(f<=b)throw r;a=void 0,h.push(0)},onArrayEnd:(b,g)=>{if(f<=b)throw r;a=void 0,h.pop()},onLiteralValue:(b,g,y)=>{if(f<g||(D(b,g,y,c(b)),f<=g+y))throw r},onSeparator:(b,g,y)=>{if(f<=g)throw r;if(b===":"&&a&&a.type==="property")a.colonOffset=g,$=!1,a=void 0;else if(b===","){const P=h[h.length-1];typeof P=="number"?h[h.length-1]=P+1:($=!0,h[h.length-1]=""),a=void 0}}})}catch(b){if(b!==r)throw b}return{path:h,previousNode:a,isAtPropertyKey:$,matches:b=>{let g=0;for(let y=0;g<b.length&&y<h.length;y++)if(b[g]===h[y]||b[g]==="*")g++;else if(b[g]!=="**")return!1;return g===b.length}}}e.$qn=C;function v(t,f=[],h=A.DEFAULT){let r=null,a=[];const d=[];function $(b){Array.isArray(a)?a.push(b):r!==null&&(a[r]=b)}return n(t,{onObjectBegin:()=>{const b={};$(b),d.push(a),a=b,r=null},onObjectProperty:b=>{r=b},onObjectEnd:()=>{a=d.pop()},onArrayBegin:()=>{const b=[];$(b),d.push(a),a=b,r=null},onArrayEnd:()=>{a=d.pop()},onLiteralValue:$,onError:(b,g,y)=>{f.push({error:b,offset:g,length:y})}},h),a[0]}e.$rn=v;function S(t,f=[],h=A.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(b){r.type==="property"&&(r.length=b-r.offset,r=r.parent)}function d(b){return r.children.push(b),b}n(t,{onObjectBegin:b=>{r=d({type:"object",offset:b,length:-1,parent:r,children:[]})},onObjectProperty:(b,g,y)=>{r=d({type:"property",offset:g,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:b,offset:g,length:y,parent:r})},onObjectEnd:(b,g)=>{r.length=b+g-r.offset,r=r.parent,a(b+g)},onArrayBegin:(b,g)=>{r=d({type:"array",offset:b,length:-1,parent:r,children:[]})},onArrayEnd:(b,g)=>{r.length=b+g-r.offset,r=r.parent,a(b+g)},onLiteralValue:(b,g,y)=>{d({type:c(b),offset:g,length:y,parent:r,value:b}),a(g+y)},onSeparator:(b,g,y)=>{r.type==="property"&&(b===":"?r.colonOffset=g:b===","&&a(g))},onError:(b,g,y)=>{f.push({error:b,offset:g,length:y})}},h);const D=r.children[0];return D&&delete D.parent,D}e.$sn=S;function k(t,f){if(!t)return;let h=t;for(const r of f)if(typeof r=="string"){if(h.type!=="object"||!Array.isArray(h.children))return;let a=!1;for(const d of h.children)if(Array.isArray(d.children)&&d.children[0].value===r){h=d.children[1],a=!0;break}if(!a)return}else{const a=r;if(h.type!=="array"||a<0||!Array.isArray(h.children)||a>=h.children.length)return;h=h.children[a]}return h}e.$tn=k;function u(t){if(!t.parent||!t.parent.children)return[];const f=u(t.parent);if(t.parent.type==="property"){const h=t.parent.children[0].value;f.push(h)}else if(t.parent.type==="array"){const h=t.parent.children.indexOf(t);h!==-1&&f.push(h)}return f}e.$un=u;function m(t){switch(t.type){case"array":return t.children.map(m);case"object":{const f=Object.create(null);for(const h of t.children){const r=h.children[1];r&&(f[h.children[0].value]=m(r))}return f}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$vn=m;function o(t,f,h=!1){return f>=t.offset&&f<t.offset+t.length||h&&f===t.offset+t.length}e.$wn=o;function i(t,f,h=!1){if(o(t,f,h)){const r=t.children;if(Array.isArray(r))for(let a=0;a<r.length&&r[a].offset<=f;a++){const d=i(r[a],f,h);if(d)return d}return t}}e.$xn=i;function n(t,f,h=A.DEFAULT){const r=R(t,!1);function a(_){return _?()=>_(r.getTokenOffset(),r.getTokenLength()):()=>!0}function d(_){return _?ge=>_(ge,r.getTokenOffset(),r.getTokenLength()):()=>!0}const $=a(f.onObjectBegin),D=d(f.onObjectProperty),b=a(f.onObjectEnd),g=a(f.onArrayBegin),y=a(f.onArrayEnd),P=d(f.onLiteralValue),N=d(f.onSeparator),U=a(f.onComment),z=d(f.onError),F=h&&h.disallowComments,I=h&&h.allowTrailingComma;function O(){for(;;){const _=r.scan();switch(r.getTokenError()){case 4:T(14);break;case 5:T(15);break;case 3:T(13);break;case 1:F||T(11);break;case 2:T(12);break;case 6:T(16);break}switch(_){case 12:case 13:F?T(10):U();break;case 16:T(1);break;case 15:case 14:break;default:return _}}}function T(_,ge=[],se=[]){if(z(_),ge.length+se.length>0){let re=r.getToken();for(;re!==17;){if(ge.indexOf(re)!==-1){O();break}else if(se.indexOf(re)!==-1)break;re=O()}}}function G(_){const ge=r.getTokenValue();return _?P(ge):D(ge),O(),!0}function te(){switch(r.getToken()){case 11:{let _=0;try{_=JSON.parse(r.getTokenValue()),typeof _!="number"&&(T(2),_=0)}catch{T(2)}P(_);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return O(),!0}function x(){return r.getToken()!==10?(T(3,[],[2,5]),!1):(G(!1),r.getToken()===6?(N(":"),O(),ae()||T(4,[],[2,5])):T(5,[],[2,5]),!0)}function X(){$(),O();let _=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(_||T(4,[],[]),N(","),O(),r.getToken()===2&&I)break}else _&&T(6,[],[]);x()||T(4,[],[2,5]),_=!0}return b(),r.getToken()!==2?T(7,[2],[]):O(),!0}function Q(){g(),O();let _=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(_||T(4,[],[]),N(","),O(),r.getToken()===4&&I)break}else _&&T(6,[],[]);ae()||T(4,[],[4,5]),_=!0}return y(),r.getToken()!==4?T(8,[4],[]):O(),!0}function ae(){switch(r.getToken()){case 3:return Q();case 1:return X();case 10:return G(!0);default:return te()}}return O(),r.getToken()===17?h.allowEmptyContent?!0:(T(4,[],[]),!1):ae()?(r.getToken()!==17&&T(9,[],[]),!0):(T(4,[],[]),!1)}e.$yn=n;function s(t,f){const h=R(t),r=[];let a,d=0,$;do switch($=h.getPosition(),a=h.scan(),a){case 12:case 13:case 17:d!==$&&r.push(t.substring(d,$)),f!==void 0&&r.push(h.getTokenValue().replace(/[^\r\n]/g,f)),d=h.getPosition();break}while(a!==17);return r.join("")}e.$zn=s;function c(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$An=c}),define(Se[43],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class l{constructor(L){this.d=L,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(L){this.c=L}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=l}),define(Se[74],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0;class l{static{this.Undefined=new l(void 0)}constructor(A){this.element=A,this.next=l.Undefined,this.prev=l.Undefined}}class j{constructor(){this.a=l.Undefined,this.b=l.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===l.Undefined}clear(){let A=this.a;for(;A!==l.Undefined;){const R=A.next;A.prev=l.Undefined,A.next=l.Undefined,A=R}this.a=l.Undefined,this.b=l.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,R){const p=new l(A);if(this.a===l.Undefined)this.a=p,this.b=p;else if(R){const E=this.b;this.b=p,p.prev=E,E.next=p}else{const E=this.a;this.a=p,p.next=E,E.prev=p}this.c+=1;let w=!1;return()=>{w||(w=!0,this.e(p))}}shift(){if(this.a!==l.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==l.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==l.Undefined&&A.next!==l.Undefined){const R=A.prev;R.next=A.next,A.next.prev=R}else A.prev===l.Undefined&&A.next===l.Undefined?(this.a=l.Undefined,this.b=l.Undefined):A.next===l.Undefined?(this.b=this.b.prev,this.b.next=l.Undefined):A.prev===l.Undefined&&(this.a=this.a.next,this.a.prev=l.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==l.Undefined;)yield A.element,A=A.next}}e.$4c=j}),define(Se[28],De([1,0]),function(fe,e){"use strict";var l,j,L;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function A(n,s,c){let t=n.get(s);return t===void 0&&(t=c,n.set(s,t)),t}e.$xc=A;function R(n){const s=[];return n.forEach((c,t)=>{s.push(`${t} => ${c}`)}),`Map(${n.size}) {${s.join(", ")}}`}e.$yc=R;function p(n){const s=[];return n.forEach(c=>{s.push(c)}),`Set(${n.size}) {${s.join(", ")}}`}e.$zc=p;class w{constructor(s,c){this.uri=s,this.value=c}}function E(n){return Array.isArray(n)}class M{static{this.c=s=>s.toString()}constructor(s,c){if(this[l]="ResourceMap",s instanceof M)this.d=new Map(s.d),this.e=c??M.c;else if(E(s)){this.d=new Map,this.e=c??M.c;for(const[t,f]of s)this.set(t,f)}else this.d=new Map,this.e=s??M.c}set(s,c){return this.d.set(this.e(s),new w(s,c)),this}get(s){return this.d.get(this.e(s))?.value}has(s){return this.d.has(this.e(s))}get size(){return this.d.size}clear(){this.d.clear()}delete(s){return this.d.delete(this.e(s))}forEach(s,c){typeof c<"u"&&(s=s.bind(c));for(const[t,f]of this.d)s(f.value,f.uri,this)}*values(){for(const s of this.d.values())yield s.value}*keys(){for(const s of this.d.values())yield s.uri}*entries(){for(const s of this.d.values())yield[s.uri,s.value]}*[(l=Symbol.toStringTag,Symbol.iterator)](){for(const[,s]of this.d)yield[s.uri,s.value]}}e.$Ac=M;class C{constructor(s,c){this[j]="ResourceSet",!s||typeof s=="function"?this.c=new M(s):(this.c=new M(c),s.forEach(this.add,this))}get size(){return this.c.size}add(s){return this.c.set(s,s),this}clear(){this.c.clear()}delete(s){return this.c.delete(s)}forEach(s,c){this.c.forEach((t,f)=>s.call(c,f,f,this))}has(s){return this.c.has(s)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(j=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=C;var v;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(v||(e.Touch=v={}));class S{constructor(){this[L]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(s){return this.c.has(s)}get(s,c=0){const t=this.c.get(s);if(t)return c!==0&&this.l(t,c),t.value}set(s,c,t=0){let f=this.c.get(s);if(f)f.value=c,t!==0&&this.l(f,t);else{switch(f={key:s,value:c,next:void 0,previous:void 0},t){case 0:this.j(f);break;case 1:this.i(f);break;case 2:this.j(f);break;default:this.j(f);break}this.c.set(s,f),this.f++}return this}delete(s){return!!this.remove(s)}remove(s){const c=this.c.get(s);if(c)return this.c.delete(s),this.k(c),this.f--,c.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const s=this.d;return this.c.delete(s.key),this.k(s),this.f--,s.value}forEach(s,c){const t=this.g;let f=this.d;for(;f;){if(c?s.bind(c)(f.value,f.key,this):s(f.value,f.key,this),this.g!==t)throw new Error("LinkedMap got modified during iteration.");f=f.next}}keys(){const s=this,c=this.g;let t=this.d;const f={[Symbol.iterator](){return f},next(){if(s.g!==c)throw new Error("LinkedMap got modified during iteration.");if(t){const h={value:t.key,done:!1};return t=t.next,h}else return{value:void 0,done:!0}}};return f}values(){const s=this,c=this.g;let t=this.d;const f={[Symbol.iterator](){return f},next(){if(s.g!==c)throw new Error("LinkedMap got modified during iteration.");if(t){const h={value:t.value,done:!1};return t=t.next,h}else return{value:void 0,done:!0}}};return f}entries(){const s=this,c=this.g;let t=this.d;const f={[Symbol.iterator](){return f},next(){if(s.g!==c)throw new Error("LinkedMap got modified during iteration.");if(t){const h={value:[t.key,t.value],done:!1};return t=t.next,h}else return{value:void 0,done:!0}}};return f}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(s){if(s>=this.size)return;if(s===0){this.clear();return}let c=this.d,t=this.size;for(;c&&t>s;)this.c.delete(c.key),c=c.next,t--;this.d=c,this.f=t,c&&(c.previous=void 0),this.g++}i(s){if(!this.d&&!this.e)this.e=s;else if(this.d)s.next=this.d,this.d.previous=s;else throw new Error("Invalid list");this.d=s,this.g++}j(s){if(!this.d&&!this.e)this.d=s;else if(this.e)s.previous=this.e,this.e.next=s;else throw new Error("Invalid list");this.e=s,this.g++}k(s){if(s===this.d&&s===this.e)this.d=void 0,this.e=void 0;else if(s===this.d){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this.d=s.next}else if(s===this.e){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this.e=s.previous}else{const c=s.next,t=s.previous;if(!c||!t)throw new Error("Invalid list");c.previous=t,t.next=c}s.next=void 0,s.previous=void 0,this.g++}l(s,c){if(!this.d||!this.e)throw new Error("Invalid list");if(!(c!==1&&c!==2)){if(c===1){if(s===this.d)return;const t=s.next,f=s.previous;s===this.e?(f.next=void 0,this.e=f):(t.previous=f,f.next=t),s.previous=void 0,s.next=this.d,this.d.previous=s,this.d=s,this.g++}else if(c===2){if(s===this.e)return;const t=s.next,f=s.previous;s===this.d?(t.previous=void 0,this.d=t):(t.previous=f,f.next=t),s.next=void 0,s.previous=this.e,this.e.next=s,this.e=s,this.g++}}}toJSON(){const s=[];return this.forEach((c,t)=>{s.push([t,c])}),s}fromJSON(s){this.clear();for(const[c,t]of s)this.set(c,t)}}e.$Cc=S;class k extends S{constructor(s,c=1){super(),this.m=s,this.n=Math.min(Math.max(0,c),1)}get limit(){return this.m}set limit(s){this.m=s,this.o()}get ratio(){return this.n}set ratio(s){this.n=Math.min(Math.max(0,s),1),this.o()}get(s,c=2){return super.get(s,c)}peek(s){return super.get(s,0)}set(s,c){return super.set(s,c,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Dc=k;class u{constructor(){this.c=new Map}add(s){return this.c.set(s,(this.c.get(s)||0)+1),this}delete(s){let c=this.c.get(s)||0;return c===0?!1:(c--,c===0?this.c.delete(s):this.c.set(s,c),!0)}has(s){return this.c.has(s)}}e.$Ec=u;class m{constructor(s){if(this.c=new Map,this.d=new Map,s)for(const[c,t]of s)this.set(c,t)}clear(){this.c.clear(),this.d.clear()}set(s,c){this.c.set(s,c),this.d.set(c,s)}get(s){return this.c.get(s)}getKey(s){return this.d.get(s)}delete(s){const c=this.c.get(s);return c===void 0?!1:(this.c.delete(s),this.d.delete(c),!0)}forEach(s,c){this.c.forEach((t,f)=>{s.call(c,t,f,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Fc=m;class o{constructor(){this.c=new Map}add(s,c){let t=this.c.get(s);t||(t=new Set,this.c.set(s,t)),t.add(c)}delete(s,c){const t=this.c.get(s);t&&(t.delete(c),t.size===0&&this.c.delete(s))}forEach(s,c){const t=this.c.get(s);t&&t.forEach(c)}get(s){const c=this.c.get(s);return c||new Set}}e.$Gc=o;function i(n,s){if(n===s)return!0;if(n.size!==s.size)return!1;for(const[c,t]of n)if(!s.has(c)||s.get(c)!==t)return!1;for(const[c]of s)if(!n.has(c))return!1;return!0}e.$Hc=i}),define(Se[3],De([1,0,19,72,28,73,48]),function(fe,e,l,j,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=void 0;const p=!1;let w=null;class E{constructor(){this.b=new Map}static{this.a=0}c(P){let N=this.b.get(P);return N||(N={parent:null,source:null,isSingleton:!1,value:P,idx:E.a++},this.b.set(P,N)),N}trackDisposable(P){const N=this.c(P);N.source||(N.source=new Error().stack)}setParent(P,N){const U=this.c(P);U.parent=N}markAsDisposed(P){this.b.delete(P)}markAsSingleton(P){this.c(P).isSingleton=!0}f(P,N){const U=N.get(P);if(U)return U;const z=P.parent?this.f(this.c(P.parent),N):P;return N.set(P,z),z}getTrackedDisposables(){const P=new Map;return[...this.b.entries()].filter(([,U])=>U.source!==null&&!this.f(U,P).isSingleton).flatMap(([U])=>U)}computeLeakingDisposables(P=10,N){let U;if(N)U=N;else{const T=new Map,G=[...this.b.values()].filter(x=>x.source!==null&&!this.f(x,T).isSingleton);if(G.length===0)return;const te=new Set(G.map(x=>x.value));if(U=G.filter(x=>!(x.parent&&te.has(x.parent))),U.length===0)throw new Error("There are cyclic diposable chains!")}if(!U)return;function z(T){function G(x,X){for(;x.length>0&&X.some(Q=>typeof Q=="string"?Q===x[0]:x[0].match(Q));)x.shift()}const te=T.source.split(`
`).map(x=>x.trim().replace("at ","")).filter(x=>x!=="");return G(te,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),te.reverse()}const F=new L.$Gc;for(const T of U){const G=z(T);for(let te=0;te<=G.length;te++)F.add(G.slice(0,te).join(`
`),T)}U.sort((0,l.$7b)(T=>T.idx,l.$9b));let I="",O=0;for(const T of U.slice(0,P)){O++;const G=z(T),te=[];for(let x=0;x<G.length;x++){let X=G[x];X=`(shared with ${F.get(G.slice(0,x+1).join(`
`)).size}/${U.length} leaks) at ${X}`;const ae=F.get(G.slice(0,x).join(`
`)),_=(0,j.$K)([...ae].map(ge=>z(ge)[x]),ge=>ge);delete _[G[x]];for(const[ge,se]of Object.entries(_))te.unshift(`    - stacktraces of ${se.length} other leaks continue with ${ge}`);te.unshift(X)}I+=`


==================== Leaking disposable ${O}/${U.length}: ${T.value.constructor.name} ====================
${te.join(`
`)}
============================================================

`}return U.length>P&&(I+=`


... and ${U.length-P} more leaking disposables

`),{leaks:U,details:I}}}e.$Ic=E;function M(y){w=y}if(e.$Jc=M,p){const y="__is_disposable_tracked__";M(new class{trackDisposable(P){const N=new Error("Potentially leaked disposable").stack;setTimeout(()=>{P[y]||console.log(N)},3e3)}setParent(P,N){if(P&&P!==t.None)try{P[y]=!0}catch{}}markAsDisposed(P){if(P&&P!==t.None)try{P[y]=!0}catch{}}markAsSingleton(P){}})}function C(y){return w?.trackDisposable(y),y}e.$Kc=C;function v(y){w?.markAsDisposed(y)}e.$Lc=v;function S(y,P){w?.setParent(y,P)}function k(y,P){if(w)for(const N of y)w.setParent(N,P)}function u(y){return w?.markAsSingleton(y),y}e.$Mc=u;function m(y){return typeof y.dispose=="function"&&y.dispose.length===0}e.$Nc=m;function o(y){if(R.Iterable.is(y)){const P=[];for(const N of y)if(N)try{N.dispose()}catch(U){P.push(U)}if(P.length===1)throw P[0];if(P.length>1)throw new AggregateError(P,"Encountered errors while disposing of store");return Array.isArray(y)?[]:y}else if(y)return y.dispose(),y}e.$Oc=o;function i(y){for(const P of y)m(P)&&P.dispose();return[]}e.$Pc=i;function n(...y){const P=s(()=>o(y));return k(y,P),P}e.$Qc=n;function s(y){const P=C({dispose:(0,A.$db)(()=>{v(P),y()})});return P}e.$Rc=s;class c{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,C(this)}dispose(){this.g||(v(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{o(this.f)}finally{this.f.clear()}}add(P){if(!P)return P;if(P===this)throw new Error("Cannot register a disposable on itself!");return S(P,this),this.g?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(P),P}delete(P){if(P){if(P===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(P),P.dispose()}}deleteAndLeak(P){P&&this.f.has(P)&&(this.f.delete(P),S(P,null))}}e.$Sc=c;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new c,C(this),S(this.q,this)}dispose(){v(this),this.q.dispose()}B(P){if(P===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(P)}}e.$Tc=t;class f{constructor(){this.b=!1,C(this)}get value(){return this.b?void 0:this.a}set value(P){this.b||P===this.a||(this.a?.dispose(),P&&S(P,this),this.a=P)}clear(){this.value=void 0}dispose(){this.b=!0,v(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const P=this.a;return this.a=void 0,P&&S(P,null),P}}e.$Uc=f;class h{constructor(P){this.a=new f,this.b=!1,this.a.value=P}get value(){return this.a.value}set value(P){this.b||P===this.a.value||(this.a.value=P)}dispose(){this.b=!0,this.a.dispose()}}e.$Vc=h;class r{constructor(P){this.b=P,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Wc=r;class a{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,C(this)}set(P){let N=P;return this.unset=()=>N=void 0,this.isset=()=>N!==void 0,this.dispose=()=>{N&&(N(),N=void 0,v(this))},this}}e.$Xc=a;class d{constructor(){this.a=new Map}acquire(P,...N){let U=this.a.get(P);U||(U={counter:0,object:this.b(P,...N)},this.a.set(P,U));const{object:z}=U,F=(0,A.$db)(()=>{--U.counter===0&&(this.c(P,U.object),this.a.delete(P))});return U.counter++,{object:z,dispose:F}}}e.$Yc=d;class ${constructor(P){this.a=P}async acquire(P,...N){const U=this.a.acquire(P,...N);try{return{object:await U.object,dispose:()=>U.dispose()}}catch(z){throw U.dispose(),z}}}e.$Zc=$;class D{constructor(P){this.object=P}dispose(){}}e.$1c=D;function b(y){const P=new c;try{y(P)}finally{P.dispose()}}e.$2c=b;class g{constructor(){this.a=new Map,this.b=!1,C(this)}dispose(){v(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{o(this.a.values())}finally{this.a.clear()}}has(P){return this.a.has(P)}get size(){return this.a.size}get(P){return this.a.get(P)}set(P,N,U=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),U||this.a.get(P)?.dispose(),this.a.set(P,N)}deleteAndDispose(P){this.a.get(P)?.dispose(),this.a.delete(P)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$3c=g}),function(fe,e){typeof define=="function"&&define.amd?define(Se[164],De([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(fe=typeof globalThis<"u"?globalThis:fe||self,e(fe.marked={}))}(this,function(fe){"use strict";function e(ue,ce){for(var de=0;de<ce.length;de++){var H=ce[de];H.enumerable=H.enumerable||!1,H.configurable=!0,"value"in H&&(H.writable=!0),Object.defineProperty(ue,H.key,H)}}function l(ue,ce,de){return ce&&e(ue.prototype,ce),de&&e(ue,de),Object.defineProperty(ue,"prototype",{writable:!1}),ue}function j(ue,ce){if(ue){if(typeof ue=="string")return L(ue,ce);var de=Object.prototype.toString.call(ue).slice(8,-1);if(de==="Object"&&ue.constructor&&(de=ue.constructor.name),de==="Map"||de==="Set")return Array.from(ue);if(de==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(de))return L(ue,ce)}}function L(ue,ce){(ce==null||ce>ue.length)&&(ce=ue.length);for(var de=0,H=new Array(ce);de<ce;de++)H[de]=ue[de];return H}function A(ue,ce){var de=typeof Symbol<"u"&&ue[Symbol.iterator]||ue["@@iterator"];if(de)return(de=de.call(ue)).next.bind(de);if(Array.isArray(ue)||(de=j(ue))||ce&&ue&&typeof ue.length=="number"){de&&(ue=de);var H=0;return function(){return H>=ue.length?{done:!0}:{done:!1,value:ue[H++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}fe.defaults=R();function p(ue){fe.defaults=ue}var w=/[&<>"']/,E=/[&<>"']/g,M=/[<>"']|&(?!#?\w+;)/,C=/[<>"']|&(?!#?\w+;)/g,v={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},S=function(ce){return v[ce]};function k(ue,ce){if(ce){if(w.test(ue))return ue.replace(E,S)}else if(M.test(ue))return ue.replace(C,S);return ue}var u=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function m(ue){return ue.replace(u,function(ce,de){return de=de.toLowerCase(),de==="colon"?":":de.charAt(0)==="#"?de.charAt(1)==="x"?String.fromCharCode(parseInt(de.substring(2),16)):String.fromCharCode(+de.substring(1)):""})}var o=/(^|[^\[])\^/g;function i(ue,ce){ue=typeof ue=="string"?ue:ue.source,ce=ce||"";var de={replace:function(Z,he){return he=he.source||he,he=he.replace(o,"$1"),ue=ue.replace(Z,he),de},getRegex:function(){return new RegExp(ue,ce)}};return de}var n=/[^\w:]/g,s=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function c(ue,ce,de){if(ue){var H;try{H=decodeURIComponent(m(de)).replace(n,"").toLowerCase()}catch{return null}if(H.indexOf("javascript:")===0||H.indexOf("vbscript:")===0||H.indexOf("data:")===0)return null}ce&&!s.test(de)&&(de=a(ce,de));try{de=encodeURI(de).replace(/%25/g,"%")}catch{return null}return de}var t={},f=/^[^:]+:\/*[^/]*$/,h=/^([^:]+:)[\s\S]*$/,r=/^([^:]+:\/*[^/]*)[\s\S]*$/;function a(ue,ce){t[" "+ue]||(f.test(ue)?t[" "+ue]=ue+"/":t[" "+ue]=b(ue,"/",!0)),ue=t[" "+ue];var de=ue.indexOf(":")===-1;return ce.substring(0,2)==="//"?de?ce:ue.replace(h,"$1")+ce:ce.charAt(0)==="/"?de?ce:ue.replace(r,"$1")+ce:ue+ce}var d={exec:function(){}};function $(ue){for(var ce=1,de,H;ce<arguments.length;ce++){de=arguments[ce];for(H in de)Object.prototype.hasOwnProperty.call(de,H)&&(ue[H]=de[H])}return ue}function D(ue,ce){var de=ue.replace(/\|/g,function(he,be,Pe){for(var pe=!1,Ae=be;--Ae>=0&&Pe[Ae]==="\\";)pe=!pe;return pe?"|":" |"}),H=de.split(/ \|/),Z=0;if(H[0].trim()||H.shift(),H.length>0&&!H[H.length-1].trim()&&H.pop(),H.length>ce)H.splice(ce);else for(;H.length<ce;)H.push("");for(;Z<H.length;Z++)H[Z]=H[Z].trim().replace(/\\\|/g,"|");return H}function b(ue,ce,de){var H=ue.length;if(H===0)return"";for(var Z=0;Z<H;){var he=ue.charAt(H-Z-1);if(he===ce&&!de)Z++;else if(he!==ce&&de)Z++;else break}return ue.slice(0,H-Z)}function g(ue,ce){if(ue.indexOf(ce[1])===-1)return-1;for(var de=ue.length,H=0,Z=0;Z<de;Z++)if(ue[Z]==="\\")Z++;else if(ue[Z]===ce[0])H++;else if(ue[Z]===ce[1]&&(H--,H<0))return Z;return-1}function y(ue){ue&&ue.sanitize&&!ue.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(ue,ce){if(ce<1)return"";for(var de="";ce>1;)ce&1&&(de+=ue),ce>>=1,ue+=ue;return de+ue}function N(ue,ce,de,H){var Z=ce.href,he=ce.title?k(ce.title):null,be=ue[1].replace(/\\([\[\]])/g,"$1");if(ue[0].charAt(0)!=="!"){H.state.inLink=!0;var Pe={type:"link",raw:de,href:Z,title:he,text:be,tokens:H.inlineTokens(be)};return H.state.inLink=!1,Pe}return{type:"image",raw:de,href:Z,title:he,text:k(be)}}function U(ue,ce){var de=ue.match(/^(\s+)(?:```)/);if(de===null)return ce;var H=de[1];return ce.split(`
`).map(function(Z){var he=Z.match(/^\s+/);if(he===null)return Z;var be=he[0];return be.length>=H.length?Z.slice(H.length):Z}).join(`
`)}var z=function(){function ue(de){this.options=de||fe.defaults}var ce=ue.prototype;return ce.space=function(H){var Z=this.rules.block.newline.exec(H);if(Z&&Z[0].length>0)return{type:"space",raw:Z[0]}},ce.code=function(H){var Z=this.rules.block.code.exec(H);if(Z){var he=Z[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Z[0],codeBlockStyle:"indented",text:this.options.pedantic?he:b(he,`
`)}}},ce.fences=function(H){var Z=this.rules.block.fences.exec(H);if(Z){var he=Z[0],be=U(he,Z[3]||"");return{type:"code",raw:he,lang:Z[2]?Z[2].trim():Z[2],text:be}}},ce.heading=function(H){var Z=this.rules.block.heading.exec(H);if(Z){var he=Z[2].trim();if(/#$/.test(he)){var be=b(he,"#");(this.options.pedantic||!be||/ $/.test(be))&&(he=be.trim())}return{type:"heading",raw:Z[0],depth:Z[1].length,text:he,tokens:this.lexer.inline(he)}}},ce.hr=function(H){var Z=this.rules.block.hr.exec(H);if(Z)return{type:"hr",raw:Z[0]}},ce.blockquote=function(H){var Z=this.rules.block.blockquote.exec(H);if(Z){var he=Z[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:Z[0],tokens:this.lexer.blockTokens(he,[]),text:he}}},ce.list=function(H){var Z=this.rules.block.list.exec(H);if(Z){var he,be,Pe,pe,Ae,Oe,ze,q,W,Y,J,$e,ve=Z[1].trim(),Fe=ve.length>1,He={type:"list",raw:"",ordered:Fe,start:Fe?+ve.slice(0,-1):"",loose:!1,items:[]};ve=Fe?"\\d{1,9}\\"+ve.slice(-1):"\\"+ve,this.options.pedantic&&(ve=Fe?ve:"[*+-]");for(var Qe=new RegExp("^( {0,3}"+ve+")((?:[	 ][^\\n]*)?(?:\\n|$))");H&&($e=!1,!(!(Z=Qe.exec(H))||this.rules.block.hr.test(H)));){if(he=Z[0],H=H.substring(he.length),q=Z[2].split(`
`,1)[0],W=H.split(`
`,1)[0],this.options.pedantic?(pe=2,J=q.trimLeft()):(pe=Z[2].search(/[^ ]/),pe=pe>4?1:pe,J=q.slice(pe),pe+=Z[1].length),Oe=!1,!q&&/^ *$/.test(W)&&(he+=W+`
`,H=H.substring(W.length+1),$e=!0),!$e)for(var tt=new RegExp("^ {0,"+Math.min(3,pe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),st=new RegExp("^ {0,"+Math.min(3,pe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),ut=new RegExp("^ {0,"+Math.min(3,pe-1)+"}(?:```|~~~)"),rt=new RegExp("^ {0,"+Math.min(3,pe-1)+"}#");H&&(Y=H.split(`
`,1)[0],q=Y,this.options.pedantic&&(q=q.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(ut.test(q)||rt.test(q)||tt.test(q)||st.test(H)));){if(q.search(/[^ ]/)>=pe||!q.trim())J+=`
`+q.slice(pe);else if(!Oe)J+=`
`+q;else break;!Oe&&!q.trim()&&(Oe=!0),he+=Y+`
`,H=H.substring(Y.length+1)}He.loose||(ze?He.loose=!0:/\n *\n *$/.test(he)&&(ze=!0)),this.options.gfm&&(be=/^\[[ xX]\] /.exec(J),be&&(Pe=be[0]!=="[ ] ",J=J.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:he,task:!!be,checked:Pe,loose:!1,text:J}),He.raw+=he}He.items[He.items.length-1].raw=he.trimRight(),He.items[He.items.length-1].text=J.trimRight(),He.raw=He.raw.trimRight();var Ie=He.items.length;for(Ae=0;Ae<Ie;Ae++){this.lexer.state.top=!1,He.items[Ae].tokens=this.lexer.blockTokens(He.items[Ae].text,[]);var Be=He.items[Ae].tokens.filter(function(Ke){return Ke.type==="space"}),Le=Be.every(function(Ke){for(var ne=Ke.raw.split(""),oe=0,Ce=A(ne),Ge;!(Ge=Ce()).done;){var xe=Ge.value;if(xe===`
`&&(oe+=1),oe>1)return!0}return!1});!He.loose&&Be.length&&Le&&(He.loose=!0,He.items[Ae].loose=!0)}return He}},ce.html=function(H){var Z=this.rules.block.html.exec(H);if(Z){var he={type:"html",raw:Z[0],pre:!this.options.sanitizer&&(Z[1]==="pre"||Z[1]==="script"||Z[1]==="style"),text:Z[0]};if(this.options.sanitize){var be=this.options.sanitizer?this.options.sanitizer(Z[0]):k(Z[0]);he.type="paragraph",he.text=be,he.tokens=this.lexer.inline(be)}return he}},ce.def=function(H){var Z=this.rules.block.def.exec(H);if(Z){Z[3]&&(Z[3]=Z[3].substring(1,Z[3].length-1));var he=Z[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:he,raw:Z[0],href:Z[2],title:Z[3]}}},ce.table=function(H){var Z=this.rules.block.table.exec(H);if(Z){var he={type:"table",header:D(Z[1]).map(function(ze){return{text:ze}}),align:Z[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:Z[3]&&Z[3].trim()?Z[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(he.header.length===he.align.length){he.raw=Z[0];var be=he.align.length,Pe,pe,Ae,Oe;for(Pe=0;Pe<be;Pe++)/^ *-+: *$/.test(he.align[Pe])?he.align[Pe]="right":/^ *:-+: *$/.test(he.align[Pe])?he.align[Pe]="center":/^ *:-+ *$/.test(he.align[Pe])?he.align[Pe]="left":he.align[Pe]=null;for(be=he.rows.length,Pe=0;Pe<be;Pe++)he.rows[Pe]=D(he.rows[Pe],he.header.length).map(function(ze){return{text:ze}});for(be=he.header.length,pe=0;pe<be;pe++)he.header[pe].tokens=this.lexer.inline(he.header[pe].text);for(be=he.rows.length,pe=0;pe<be;pe++)for(Oe=he.rows[pe],Ae=0;Ae<Oe.length;Ae++)Oe[Ae].tokens=this.lexer.inline(Oe[Ae].text);return he}}},ce.lheading=function(H){var Z=this.rules.block.lheading.exec(H);if(Z)return{type:"heading",raw:Z[0],depth:Z[2].charAt(0)==="="?1:2,text:Z[1],tokens:this.lexer.inline(Z[1])}},ce.paragraph=function(H){var Z=this.rules.block.paragraph.exec(H);if(Z){var he=Z[1].charAt(Z[1].length-1)===`
`?Z[1].slice(0,-1):Z[1];return{type:"paragraph",raw:Z[0],text:he,tokens:this.lexer.inline(he)}}},ce.text=function(H){var Z=this.rules.block.text.exec(H);if(Z)return{type:"text",raw:Z[0],text:Z[0],tokens:this.lexer.inline(Z[0])}},ce.escape=function(H){var Z=this.rules.inline.escape.exec(H);if(Z)return{type:"escape",raw:Z[0],text:k(Z[1])}},ce.tag=function(H){var Z=this.rules.inline.tag.exec(H);if(Z)return!this.lexer.state.inLink&&/^<a /i.test(Z[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(Z[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(Z[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Z[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:Z[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Z[0]):k(Z[0]):Z[0]}},ce.link=function(H){var Z=this.rules.inline.link.exec(H);if(Z){var he=Z[2].trim();if(!this.options.pedantic&&/^</.test(he)){if(!/>$/.test(he))return;var be=b(he.slice(0,-1),"\\");if((he.length-be.length)%2===0)return}else{var Pe=g(Z[2],"()");if(Pe>-1){var pe=Z[0].indexOf("!")===0?5:4,Ae=pe+Z[1].length+Pe;Z[2]=Z[2].substring(0,Pe),Z[0]=Z[0].substring(0,Ae).trim(),Z[3]=""}}var Oe=Z[2],ze="";if(this.options.pedantic){var q=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Oe);q&&(Oe=q[1],ze=q[3])}else ze=Z[3]?Z[3].slice(1,-1):"";return Oe=Oe.trim(),/^</.test(Oe)&&(this.options.pedantic&&!/>$/.test(he)?Oe=Oe.slice(1):Oe=Oe.slice(1,-1)),N(Z,{href:Oe&&Oe.replace(this.rules.inline._escapes,"$1"),title:ze&&ze.replace(this.rules.inline._escapes,"$1")},Z[0],this.lexer)}},ce.reflink=function(H,Z){var he;if((he=this.rules.inline.reflink.exec(H))||(he=this.rules.inline.nolink.exec(H))){var be=(he[2]||he[1]).replace(/\s+/g," ");if(be=Z[be.toLowerCase()],!be||!be.href){var Pe=he[0].charAt(0);return{type:"text",raw:Pe,text:Pe}}return N(he,be,he[0],this.lexer)}},ce.emStrong=function(H,Z,he){he===void 0&&(he="");var be=this.rules.inline.emStrong.lDelim.exec(H);if(be&&!(be[3]&&he.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Pe=be[1]||be[2]||"";if(!Pe||Pe&&(he===""||this.rules.inline.punctuation.exec(he))){var pe=be[0].length-1,Ae,Oe,ze=pe,q=0,W=be[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(W.lastIndex=0,Z=Z.slice(-1*H.length+pe);(be=W.exec(Z))!=null;)if(Ae=be[1]||be[2]||be[3]||be[4]||be[5]||be[6],!!Ae){if(Oe=Ae.length,be[3]||be[4]){ze+=Oe;continue}else if((be[5]||be[6])&&pe%3&&!((pe+Oe)%3)){q+=Oe;continue}if(ze-=Oe,!(ze>0)){if(Oe=Math.min(Oe,Oe+ze+q),Math.min(pe,Oe)%2){var Y=H.slice(1,pe+be.index+Oe);return{type:"em",raw:H.slice(0,pe+be.index+Oe+1),text:Y,tokens:this.lexer.inlineTokens(Y)}}var J=H.slice(2,pe+be.index+Oe-1);return{type:"strong",raw:H.slice(0,pe+be.index+Oe+1),text:J,tokens:this.lexer.inlineTokens(J)}}}}}},ce.codespan=function(H){var Z=this.rules.inline.code.exec(H);if(Z){var he=Z[2].replace(/\n/g," "),be=/[^ ]/.test(he),Pe=/^ /.test(he)&&/ $/.test(he);return be&&Pe&&(he=he.substring(1,he.length-1)),he=k(he,!0),{type:"codespan",raw:Z[0],text:he}}},ce.br=function(H){var Z=this.rules.inline.br.exec(H);if(Z)return{type:"br",raw:Z[0]}},ce.del=function(H){var Z=this.rules.inline.del.exec(H);if(Z)return{type:"del",raw:Z[0],text:Z[2],tokens:this.lexer.inlineTokens(Z[2])}},ce.autolink=function(H,Z){var he=this.rules.inline.autolink.exec(H);if(he){var be,Pe;return he[2]==="@"?(be=k(this.options.mangle?Z(he[1]):he[1]),Pe="mailto:"+be):(be=k(he[1]),Pe=be),{type:"link",raw:he[0],text:be,href:Pe,tokens:[{type:"text",raw:be,text:be}]}}},ce.url=function(H,Z){var he;if(he=this.rules.inline.url.exec(H)){var be,Pe;if(he[2]==="@")be=k(this.options.mangle?Z(he[0]):he[0]),Pe="mailto:"+be;else{var pe;do pe=he[0],he[0]=this.rules.inline._backpedal.exec(he[0])[0];while(pe!==he[0]);be=k(he[0]),he[1]==="www."?Pe="http://"+be:Pe=be}return{type:"link",raw:he[0],text:be,href:Pe,tokens:[{type:"text",raw:be,text:be}]}}},ce.inlineText=function(H,Z){var he=this.rules.inline.text.exec(H);if(he){var be;return this.lexer.state.inRawBlock?be=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):k(he[0]):he[0]:be=k(this.options.smartypants?Z(he[0]):he[0]),{type:"text",raw:he[0],text:be}}},ue}(),F={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:d,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};F._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,F._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,F.def=i(F.def).replace("label",F._label).replace("title",F._title).getRegex(),F.bullet=/(?:[*+-]|\d{1,9}[.)])/,F.listItemStart=i(/^( *)(bull) */).replace("bull",F.bullet).getRegex(),F.list=i(F.list).replace(/bull/g,F.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+F.def.source+")").getRegex(),F._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",F._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,F.html=i(F.html,"i").replace("comment",F._comment).replace("tag",F._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),F.paragraph=i(F._paragraph).replace("hr",F.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",F._tag).getRegex(),F.blockquote=i(F.blockquote).replace("paragraph",F.paragraph).getRegex(),F.normal=$({},F),F.gfm=$({},F.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),F.gfm.table=i(F.gfm.table).replace("hr",F.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",F._tag).getRegex(),F.gfm.paragraph=i(F._paragraph).replace("hr",F.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",F.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",F._tag).getRegex(),F.pedantic=$({},F.normal,{html:i(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",F._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:d,paragraph:i(F.normal._paragraph).replace("hr",F.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",F.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var I={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:d,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:d,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};I._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",I.punctuation=i(I.punctuation).replace(/punctuation/g,I._punctuation).getRegex(),I.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,I.escapedEmSt=/\\\*|\\_/g,I._comment=i(F._comment).replace("(?:-->|$)","-->").getRegex(),I.emStrong.lDelim=i(I.emStrong.lDelim).replace(/punct/g,I._punctuation).getRegex(),I.emStrong.rDelimAst=i(I.emStrong.rDelimAst,"g").replace(/punct/g,I._punctuation).getRegex(),I.emStrong.rDelimUnd=i(I.emStrong.rDelimUnd,"g").replace(/punct/g,I._punctuation).getRegex(),I._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,I._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,I._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,I.autolink=i(I.autolink).replace("scheme",I._scheme).replace("email",I._email).getRegex(),I._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,I.tag=i(I.tag).replace("comment",I._comment).replace("attribute",I._attribute).getRegex(),I._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,I._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,I._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,I.link=i(I.link).replace("label",I._label).replace("href",I._href).replace("title",I._title).getRegex(),I.reflink=i(I.reflink).replace("label",I._label).replace("ref",F._label).getRegex(),I.nolink=i(I.nolink).replace("ref",F._label).getRegex(),I.reflinkSearch=i(I.reflinkSearch,"g").replace("reflink",I.reflink).replace("nolink",I.nolink).getRegex(),I.normal=$({},I),I.pedantic=$({},I.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:i(/^!?\[(label)\]\((.*?)\)/).replace("label",I._label).getRegex(),reflink:i(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",I._label).getRegex()}),I.gfm=$({},I.normal,{escape:i(I.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),I.gfm.url=i(I.gfm.url,"i").replace("email",I.gfm._extended_email).getRegex(),I.breaks=$({},I.gfm,{br:i(I.br).replace("{2,}","*").getRegex(),text:i(I.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function O(ue){return ue.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function T(ue){var ce="",de,H,Z=ue.length;for(de=0;de<Z;de++)H=ue.charCodeAt(de),Math.random()>.5&&(H="x"+H.toString(16)),ce+="&#"+H+";";return ce}var G=function(){function ue(de){this.tokens=[],this.tokens.links=Object.create(null),this.options=de||fe.defaults,this.options.tokenizer=this.options.tokenizer||new z,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var H={block:F.normal,inline:I.normal};this.options.pedantic?(H.block=F.pedantic,H.inline=I.pedantic):this.options.gfm&&(H.block=F.gfm,this.options.breaks?H.inline=I.breaks:H.inline=I.gfm),this.tokenizer.rules=H}ue.lex=function(H,Z){var he=new ue(Z);return he.lex(H)},ue.lexInline=function(H,Z){var he=new ue(Z);return he.inlineTokens(H)};var ce=ue.prototype;return ce.lex=function(H){H=H.replace(/\r\n|\r/g,`
`),this.blockTokens(H,this.tokens);for(var Z;Z=this.inlineQueue.shift();)this.inlineTokens(Z.src,Z.tokens);return this.tokens},ce.blockTokens=function(H,Z){var he=this;Z===void 0&&(Z=[]),this.options.pedantic?H=H.replace(/\t/g,"    ").replace(/^ +$/gm,""):H=H.replace(/^( *)(\t+)/gm,function(ze,q,W){return q+"    ".repeat(W.length)});for(var be,Pe,pe,Ae;H;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ze){return(be=ze.call({lexer:he},H,Z))?(H=H.substring(be.raw.length),Z.push(be),!0):!1}))){if(be=this.tokenizer.space(H)){H=H.substring(be.raw.length),be.raw.length===1&&Z.length>0?Z[Z.length-1].raw+=`
`:Z.push(be);continue}if(be=this.tokenizer.code(H)){H=H.substring(be.raw.length),Pe=Z[Z.length-1],Pe&&(Pe.type==="paragraph"||Pe.type==="text")?(Pe.raw+=`
`+be.raw,Pe.text+=`
`+be.text,this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):Z.push(be);continue}if(be=this.tokenizer.fences(H)){H=H.substring(be.raw.length),Z.push(be);continue}if(be=this.tokenizer.heading(H)){H=H.substring(be.raw.length),Z.push(be);continue}if(be=this.tokenizer.hr(H)){H=H.substring(be.raw.length),Z.push(be);continue}if(be=this.tokenizer.blockquote(H)){H=H.substring(be.raw.length),Z.push(be);continue}if(be=this.tokenizer.list(H)){H=H.substring(be.raw.length),Z.push(be);continue}if(be=this.tokenizer.html(H)){H=H.substring(be.raw.length),Z.push(be);continue}if(be=this.tokenizer.def(H)){H=H.substring(be.raw.length),Pe=Z[Z.length-1],Pe&&(Pe.type==="paragraph"||Pe.type==="text")?(Pe.raw+=`
`+be.raw,Pe.text+=`
`+be.raw,this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):this.tokens.links[be.tag]||(this.tokens.links[be.tag]={href:be.href,title:be.title});continue}if(be=this.tokenizer.table(H)){H=H.substring(be.raw.length),Z.push(be);continue}if(be=this.tokenizer.lheading(H)){H=H.substring(be.raw.length),Z.push(be);continue}if(pe=H,this.options.extensions&&this.options.extensions.startBlock&&function(){var ze=1/0,q=H.slice(1),W=void 0;he.options.extensions.startBlock.forEach(function(Y){W=Y.call({lexer:this},q),typeof W=="number"&&W>=0&&(ze=Math.min(ze,W))}),ze<1/0&&ze>=0&&(pe=H.substring(0,ze+1))}(),this.state.top&&(be=this.tokenizer.paragraph(pe))){Pe=Z[Z.length-1],Ae&&Pe.type==="paragraph"?(Pe.raw+=`
`+be.raw,Pe.text+=`
`+be.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):Z.push(be),Ae=pe.length!==H.length,H=H.substring(be.raw.length);continue}if(be=this.tokenizer.text(H)){H=H.substring(be.raw.length),Pe=Z[Z.length-1],Pe&&Pe.type==="text"?(Pe.raw+=`
`+be.raw,Pe.text+=`
`+be.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):Z.push(be);continue}if(H){var Oe="Infinite loop on byte: "+H.charCodeAt(0);if(this.options.silent){console.error(Oe);break}else throw new Error(Oe)}}return this.state.top=!0,Z},ce.inline=function(H,Z){return Z===void 0&&(Z=[]),this.inlineQueue.push({src:H,tokens:Z}),Z},ce.inlineTokens=function(H,Z){var he=this;Z===void 0&&(Z=[]);var be,Pe,pe,Ae=H,Oe,ze,q;if(this.tokens.links){var W=Object.keys(this.tokens.links);if(W.length>0)for(;(Oe=this.tokenizer.rules.inline.reflinkSearch.exec(Ae))!=null;)W.includes(Oe[0].slice(Oe[0].lastIndexOf("[")+1,-1))&&(Ae=Ae.slice(0,Oe.index)+"["+P("a",Oe[0].length-2)+"]"+Ae.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Oe=this.tokenizer.rules.inline.blockSkip.exec(Ae))!=null;)Ae=Ae.slice(0,Oe.index)+"["+P("a",Oe[0].length-2)+"]"+Ae.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Oe=this.tokenizer.rules.inline.escapedEmSt.exec(Ae))!=null;)Ae=Ae.slice(0,Oe.index)+"++"+Ae.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;H;)if(ze||(q=""),ze=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(J){return(be=J.call({lexer:he},H,Z))?(H=H.substring(be.raw.length),Z.push(be),!0):!1}))){if(be=this.tokenizer.escape(H)){H=H.substring(be.raw.length),Z.push(be);continue}if(be=this.tokenizer.tag(H)){H=H.substring(be.raw.length),Pe=Z[Z.length-1],Pe&&be.type==="text"&&Pe.type==="text"?(Pe.raw+=be.raw,Pe.text+=be.text):Z.push(be);continue}if(be=this.tokenizer.link(H)){H=H.substring(be.raw.length),Z.push(be);continue}if(be=this.tokenizer.reflink(H,this.tokens.links)){H=H.substring(be.raw.length),Pe=Z[Z.length-1],Pe&&be.type==="text"&&Pe.type==="text"?(Pe.raw+=be.raw,Pe.text+=be.text):Z.push(be);continue}if(be=this.tokenizer.emStrong(H,Ae,q)){H=H.substring(be.raw.length),Z.push(be);continue}if(be=this.tokenizer.codespan(H)){H=H.substring(be.raw.length),Z.push(be);continue}if(be=this.tokenizer.br(H)){H=H.substring(be.raw.length),Z.push(be);continue}if(be=this.tokenizer.del(H)){H=H.substring(be.raw.length),Z.push(be);continue}if(be=this.tokenizer.autolink(H,T)){H=H.substring(be.raw.length),Z.push(be);continue}if(!this.state.inLink&&(be=this.tokenizer.url(H,T))){H=H.substring(be.raw.length),Z.push(be);continue}if(pe=H,this.options.extensions&&this.options.extensions.startInline&&function(){var J=1/0,$e=H.slice(1),ve=void 0;he.options.extensions.startInline.forEach(function(Fe){ve=Fe.call({lexer:this},$e),typeof ve=="number"&&ve>=0&&(J=Math.min(J,ve))}),J<1/0&&J>=0&&(pe=H.substring(0,J+1))}(),be=this.tokenizer.inlineText(pe,O)){H=H.substring(be.raw.length),be.raw.slice(-1)!=="_"&&(q=be.raw.slice(-1)),ze=!0,Pe=Z[Z.length-1],Pe&&Pe.type==="text"?(Pe.raw+=be.raw,Pe.text+=be.text):Z.push(be);continue}if(H){var Y="Infinite loop on byte: "+H.charCodeAt(0);if(this.options.silent){console.error(Y);break}else throw new Error(Y)}}return Z},l(ue,null,[{key:"rules",get:function(){return{block:F,inline:I}}}]),ue}(),te=function(){function ue(de){this.options=de||fe.defaults}var ce=ue.prototype;return ce.code=function(H,Z,he){var be=(Z||"").match(/\S*/)[0];if(this.options.highlight){var Pe=this.options.highlight(H,be);Pe!=null&&Pe!==H&&(he=!0,H=Pe)}return H=H.replace(/\n$/,"")+`
`,be?'<pre><code class="'+this.options.langPrefix+k(be,!0)+'">'+(he?H:k(H,!0))+`</code></pre>
`:"<pre><code>"+(he?H:k(H,!0))+`</code></pre>
`},ce.blockquote=function(H){return`<blockquote>
`+H+`</blockquote>
`},ce.html=function(H){return H},ce.heading=function(H,Z,he,be){if(this.options.headerIds){var Pe=this.options.headerPrefix+be.slug(he);return"<h"+Z+' id="'+Pe+'">'+H+"</h"+Z+`>
`}return"<h"+Z+">"+H+"</h"+Z+`>
`},ce.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ce.list=function(H,Z,he){var be=Z?"ol":"ul",Pe=Z&&he!==1?' start="'+he+'"':"";return"<"+be+Pe+`>
`+H+"</"+be+`>
`},ce.listitem=function(H){return"<li>"+H+`</li>
`},ce.checkbox=function(H){return"<input "+(H?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ce.paragraph=function(H){return"<p>"+H+`</p>
`},ce.table=function(H,Z){return Z&&(Z="<tbody>"+Z+"</tbody>"),`<table>
<thead>
`+H+`</thead>
`+Z+`</table>
`},ce.tablerow=function(H){return`<tr>
`+H+`</tr>
`},ce.tablecell=function(H,Z){var he=Z.header?"th":"td",be=Z.align?"<"+he+' align="'+Z.align+'">':"<"+he+">";return be+H+("</"+he+`>
`)},ce.strong=function(H){return"<strong>"+H+"</strong>"},ce.em=function(H){return"<em>"+H+"</em>"},ce.codespan=function(H){return"<code>"+H+"</code>"},ce.br=function(){return this.options.xhtml?"<br/>":"<br>"},ce.del=function(H){return"<del>"+H+"</del>"},ce.link=function(H,Z,he){if(H=c(this.options.sanitize,this.options.baseUrl,H),H===null)return he;var be='<a href="'+k(H)+'"';return Z&&(be+=' title="'+Z+'"'),be+=">"+he+"</a>",be},ce.image=function(H,Z,he){if(H=c(this.options.sanitize,this.options.baseUrl,H),H===null)return he;var be='<img src="'+H+'" alt="'+he+'"';return Z&&(be+=' title="'+Z+'"'),be+=this.options.xhtml?"/>":">",be},ce.text=function(H){return H},ue}(),x=function(){function ue(){}var ce=ue.prototype;return ce.strong=function(H){return H},ce.em=function(H){return H},ce.codespan=function(H){return H},ce.del=function(H){return H},ce.html=function(H){return H},ce.text=function(H){return H},ce.link=function(H,Z,he){return""+he},ce.image=function(H,Z,he){return""+he},ce.br=function(){return""},ue}(),X=function(){function ue(){this.seen={}}var ce=ue.prototype;return ce.serialize=function(H){return H.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ce.getNextSafeSlug=function(H,Z){var he=H,be=0;if(this.seen.hasOwnProperty(he)){be=this.seen[H];do be++,he=H+"-"+be;while(this.seen.hasOwnProperty(he))}return Z||(this.seen[H]=be,this.seen[he]=0),he},ce.slug=function(H,Z){Z===void 0&&(Z={});var he=this.serialize(H);return this.getNextSafeSlug(he,Z.dryrun)},ue}(),Q=function(){function ue(de){this.options=de||fe.defaults,this.options.renderer=this.options.renderer||new te,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new x,this.slugger=new X}ue.parse=function(H,Z){var he=new ue(Z);return he.parse(H)},ue.parseInline=function(H,Z){var he=new ue(Z);return he.parseInline(H)};var ce=ue.prototype;return ce.parse=function(H,Z){Z===void 0&&(Z=!0);var he="",be,Pe,pe,Ae,Oe,ze,q,W,Y,J,$e,ve,Fe,He,Qe,tt,st,ut,rt,Ie=H.length;for(be=0;be<Ie;be++){if(J=H[be],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[J.type]&&(rt=this.options.extensions.renderers[J.type].call({parser:this},J),rt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(J.type))){he+=rt||"";continue}switch(J.type){case"space":continue;case"hr":{he+=this.renderer.hr();continue}case"heading":{he+=this.renderer.heading(this.parseInline(J.tokens),J.depth,m(this.parseInline(J.tokens,this.textRenderer)),this.slugger);continue}case"code":{he+=this.renderer.code(J.text,J.lang,J.escaped);continue}case"table":{for(W="",q="",Ae=J.header.length,Pe=0;Pe<Ae;Pe++)q+=this.renderer.tablecell(this.parseInline(J.header[Pe].tokens),{header:!0,align:J.align[Pe]});for(W+=this.renderer.tablerow(q),Y="",Ae=J.rows.length,Pe=0;Pe<Ae;Pe++){for(ze=J.rows[Pe],q="",Oe=ze.length,pe=0;pe<Oe;pe++)q+=this.renderer.tablecell(this.parseInline(ze[pe].tokens),{header:!1,align:J.align[pe]});Y+=this.renderer.tablerow(q)}he+=this.renderer.table(W,Y);continue}case"blockquote":{Y=this.parse(J.tokens),he+=this.renderer.blockquote(Y);continue}case"list":{for($e=J.ordered,ve=J.start,Fe=J.loose,Ae=J.items.length,Y="",Pe=0;Pe<Ae;Pe++)Qe=J.items[Pe],tt=Qe.checked,st=Qe.task,He="",Qe.task&&(ut=this.renderer.checkbox(tt),Fe?Qe.tokens.length>0&&Qe.tokens[0].type==="paragraph"?(Qe.tokens[0].text=ut+" "+Qe.tokens[0].text,Qe.tokens[0].tokens&&Qe.tokens[0].tokens.length>0&&Qe.tokens[0].tokens[0].type==="text"&&(Qe.tokens[0].tokens[0].text=ut+" "+Qe.tokens[0].tokens[0].text)):Qe.tokens.unshift({type:"text",text:ut}):He+=ut),He+=this.parse(Qe.tokens,Fe),Y+=this.renderer.listitem(He,st,tt);he+=this.renderer.list(Y,$e,ve);continue}case"html":{he+=this.renderer.html(J.text);continue}case"paragraph":{he+=this.renderer.paragraph(this.parseInline(J.tokens));continue}case"text":{for(Y=J.tokens?this.parseInline(J.tokens):J.text;be+1<Ie&&H[be+1].type==="text";)J=H[++be],Y+=`
`+(J.tokens?this.parseInline(J.tokens):J.text);he+=Z?this.renderer.paragraph(Y):Y;continue}default:{var Be='Token with "'+J.type+'" type was not found.';if(this.options.silent){console.error(Be);return}else throw new Error(Be)}}}return he},ce.parseInline=function(H,Z){Z=Z||this.renderer;var he="",be,Pe,pe,Ae=H.length;for(be=0;be<Ae;be++){if(Pe=H[be],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Pe.type]&&(pe=this.options.extensions.renderers[Pe.type].call({parser:this},Pe),pe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Pe.type))){he+=pe||"";continue}switch(Pe.type){case"escape":{he+=Z.text(Pe.text);break}case"html":{he+=Z.html(Pe.text);break}case"link":{he+=Z.link(Pe.href,Pe.title,this.parseInline(Pe.tokens,Z));break}case"image":{he+=Z.image(Pe.href,Pe.title,Pe.text);break}case"strong":{he+=Z.strong(this.parseInline(Pe.tokens,Z));break}case"em":{he+=Z.em(this.parseInline(Pe.tokens,Z));break}case"codespan":{he+=Z.codespan(Pe.text);break}case"br":{he+=Z.br();break}case"del":{he+=Z.del(this.parseInline(Pe.tokens,Z));break}case"text":{he+=Z.text(Pe.text);break}default:{var Oe='Token with "'+Pe.type+'" type was not found.';if(this.options.silent){console.error(Oe);return}else throw new Error(Oe)}}}return he},ue}();function ae(ue,ce,de){if(typeof ue>"u"||ue===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ue!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ue)+", string expected");if(typeof ce=="function"&&(de=ce,ce=null),ce=$({},ae.defaults,ce||{}),y(ce),de){var H=ce.highlight,Z;try{Z=G.lex(ue,ce)}catch(Ae){return de(Ae)}var he=function(Oe){var ze;if(!Oe)try{ce.walkTokens&&ae.walkTokens(Z,ce.walkTokens),ze=Q.parse(Z,ce)}catch(q){Oe=q}return ce.highlight=H,Oe?de(Oe):de(null,ze)};if(!H||H.length<3||(delete ce.highlight,!Z.length))return he();var be=0;ae.walkTokens(Z,function(Ae){Ae.type==="code"&&(be++,setTimeout(function(){H(Ae.text,Ae.lang,function(Oe,ze){if(Oe)return he(Oe);ze!=null&&ze!==Ae.text&&(Ae.text=ze,Ae.escaped=!0),be--,be===0&&he()})},0))}),be===0&&he();return}function Pe(Ae){if(Ae.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+k(Ae.message+"",!0)+"</pre>";throw Ae}try{var pe=G.lex(ue,ce);if(ce.walkTokens){if(ce.async)return Promise.all(ae.walkTokens(pe,ce.walkTokens)).then(function(){return Q.parse(pe,ce)}).catch(Pe);ae.walkTokens(pe,ce.walkTokens)}return Q.parse(pe,ce)}catch(Ae){Pe(Ae)}}ae.options=ae.setOptions=function(ue){return $(ae.defaults,ue),p(ae.defaults),ae},ae.getDefaults=R,ae.defaults=fe.defaults,ae.use=function(){for(var ue=arguments.length,ce=new Array(ue),de=0;de<ue;de++)ce[de]=arguments[de];var H=$.apply(void 0,[{}].concat(ce)),Z=ae.defaults.extensions||{renderers:{},childTokens:{}},he;ce.forEach(function(be){if(be.extensions&&(he=!0,be.extensions.forEach(function(pe){if(!pe.name)throw new Error("extension name required");if(pe.renderer){var Ae=Z.renderers?Z.renderers[pe.name]:null;Ae?Z.renderers[pe.name]=function(){for(var Oe=arguments.length,ze=new Array(Oe),q=0;q<Oe;q++)ze[q]=arguments[q];var W=pe.renderer.apply(this,ze);return W===!1&&(W=Ae.apply(this,ze)),W}:Z.renderers[pe.name]=pe.renderer}if(pe.tokenizer){if(!pe.level||pe.level!=="block"&&pe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");Z[pe.level]?Z[pe.level].unshift(pe.tokenizer):Z[pe.level]=[pe.tokenizer],pe.start&&(pe.level==="block"?Z.startBlock?Z.startBlock.push(pe.start):Z.startBlock=[pe.start]:pe.level==="inline"&&(Z.startInline?Z.startInline.push(pe.start):Z.startInline=[pe.start]))}pe.childTokens&&(Z.childTokens[pe.name]=pe.childTokens)})),be.renderer&&function(){var pe=ae.defaults.renderer||new te,Ae=function(q){var W=pe[q];pe[q]=function(){for(var Y=arguments.length,J=new Array(Y),$e=0;$e<Y;$e++)J[$e]=arguments[$e];var ve=be.renderer[q].apply(pe,J);return ve===!1&&(ve=W.apply(pe,J)),ve}};for(var Oe in be.renderer)Ae(Oe);H.renderer=pe}(),be.tokenizer&&function(){var pe=ae.defaults.tokenizer||new z,Ae=function(q){var W=pe[q];pe[q]=function(){for(var Y=arguments.length,J=new Array(Y),$e=0;$e<Y;$e++)J[$e]=arguments[$e];var ve=be.tokenizer[q].apply(pe,J);return ve===!1&&(ve=W.apply(pe,J)),ve}};for(var Oe in be.tokenizer)Ae(Oe);H.tokenizer=pe}(),be.walkTokens){var Pe=ae.defaults.walkTokens;H.walkTokens=function(pe){var Ae=[];return Ae.push(be.walkTokens.call(this,pe)),Pe&&(Ae=Ae.concat(Pe.call(this,pe))),Ae}}he&&(H.extensions=Z),ae.setOptions(H)})},ae.walkTokens=function(ue,ce){for(var de=[],H=function(){var Pe=he.value;switch(de=de.concat(ce.call(ae,Pe)),Pe.type){case"table":{for(var pe=A(Pe.header),Ae;!(Ae=pe()).done;){var Oe=Ae.value;de=de.concat(ae.walkTokens(Oe.tokens,ce))}for(var ze=A(Pe.rows),q;!(q=ze()).done;)for(var W=q.value,Y=A(W),J;!(J=Y()).done;){var $e=J.value;de=de.concat(ae.walkTokens($e.tokens,ce))}break}case"list":{de=de.concat(ae.walkTokens(Pe.items,ce));break}default:ae.defaults.extensions&&ae.defaults.extensions.childTokens&&ae.defaults.extensions.childTokens[Pe.type]?ae.defaults.extensions.childTokens[Pe.type].forEach(function(ve){de=de.concat(ae.walkTokens(Pe[ve],ce))}):Pe.tokens&&(de=de.concat(ae.walkTokens(Pe.tokens,ce)))}},Z=A(ue),he;!(he=Z()).done;)H();return de},ae.parseInline=function(ue,ce){if(typeof ue>"u"||ue===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ue!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ue)+", string expected");ce=$({},ae.defaults,ce||{}),y(ce);try{var de=G.lexInline(ue,ce);return ce.walkTokens&&ae.walkTokens(de,ce.walkTokens),Q.parseInline(de,ce)}catch(H){if(H.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+k(H.message+"",!0)+"</pre>";throw H}},ae.Parser=Q,ae.parser=Q.parse,ae.Renderer=te,ae.TextRenderer=x,ae.Lexer=G,ae.lexer=G.lex,ae.Tokenizer=z,ae.Slugger=X,ae.parse=ae;var _=ae.options,ge=ae.setOptions,se=ae.use,re=ae.walkTokens,B=ae.parseInline,ie=ae,ye=Q.parse,le=G.lex;fe.Lexer=G,fe.Parser=Q,fe.Renderer=te,fe.Slugger=X,fe.TextRenderer=x,fe.Tokenizer=z,fe.getDefaults=R,fe.lexer=le,fe.marked=ae,fe.options=_,fe.parse=ie,fe.parseInline=B,fe.parser=ye,fe.setOptions=ge,fe.use=se,fe.walkTokens=re,Object.defineProperty(fe,"__esModule",{value:!0})}),define(Se[165],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4j=void 0;function l(u){const m=A(u);if(m&&m.length>0)return new Uint32Array(m)}e.$4j=l;let j=0;const L=new Uint32Array(10);function A(u){if(j=0,R(u,C,4352),j>0||(R(u,v,4449),j>0)||(R(u,S,4520),j>0)||(R(u,k,12593),j))return L.subarray(0,j);if(u>=44032&&u<=55203){const m=u-44032,o=m%588,i=Math.floor(m/588),n=Math.floor(o/28),s=o%28-1;if(i<C.length?R(i,C,0):4352+i-12593<k.length&&R(4352+i,k,12593),n<v.length?R(n,v,0):4449+n-12593<k.length&&R(4449+n-12593,k,12593),s>=0&&(s<S.length?R(s,S,0):4520+s-12593<k.length&&R(4520+s-12593,k,12593)),j>0)return L.subarray(0,j)}}function R(u,m,o){u>=o&&u<o+m.length&&p(m[u-o])}function p(u){u!==0&&(L[j++]=u&255,u>>8&&(L[j++]=u>>8&255),u>>16&&(L[j++]=u>>16&255))}var w;(function(u){u[u.InitialConsonant=4352]="InitialConsonant",u[u.Vowel=4449]="Vowel",u[u.FinalConsonant=4520]="FinalConsonant",u[u.CompatibilityJamo=12593]="CompatibilityJamo"})(w||(w={}));var E;(function(u){u[u.NUL=0]="NUL",u[u.A=65]="A",u[u.B=66]="B",u[u.C=67]="C",u[u.D=68]="D",u[u.E=69]="E",u[u.F=70]="F",u[u.G=71]="G",u[u.H=72]="H",u[u.I=73]="I",u[u.J=74]="J",u[u.K=75]="K",u[u.L=76]="L",u[u.M=77]="M",u[u.N=78]="N",u[u.O=79]="O",u[u.P=80]="P",u[u.Q=81]="Q",u[u.R=82]="R",u[u.S=83]="S",u[u.T=84]="T",u[u.U=85]="U",u[u.V=86]="V",u[u.W=87]="W",u[u.X=88]="X",u[u.Y=89]="Y",u[u.Z=90]="Z",u[u.a=97]="a",u[u.b=98]="b",u[u.c=99]="c",u[u.d=100]="d",u[u.e=101]="e",u[u.f=102]="f",u[u.g=103]="g",u[u.h=104]="h",u[u.i=105]="i",u[u.j=106]="j",u[u.k=107]="k",u[u.l=108]="l",u[u.m=109]="m",u[u.n=110]="n",u[u.o=111]="o",u[u.p=112]="p",u[u.q=113]="q",u[u.r=114]="r",u[u.s=115]="s",u[u.t=116]="t",u[u.u=117]="u",u[u.v=118]="v",u[u.w=119]="w",u[u.x=120]="x",u[u.y=121]="y",u[u.z=122]="z"})(E||(E={}));var M;(function(u){u[u.fa=24934]="fa",u[u.fg=26470]="fg",u[u.fq=29030]="fq",u[u.fr=29286]="fr",u[u.ft=29798]="ft",u[u.fv=30310]="fv",u[u.fx=30822]="fx",u[u.hk=27496]="hk",u[u.hl=27752]="hl",u[u.ho=28520]="ho",u[u.ml=27757]="ml",u[u.nj=27246]="nj",u[u.nl=27758]="nl",u[u.np=28782]="np",u[u.qt=29809]="qt",u[u.rt=29810]="rt",u[u.sg=26483]="sg",u[u.sw=30579]="sw"})(M||(M={}));const C=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),v=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),S=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),k=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Se[75],De([1,0,28]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sl=e.$Rl=e.$Ql=void 0;const j=new l.$Dc(1e4);function L(E){return w(E,"NFC",j)}e.$Ql=L;const A=new l.$Dc(1e4);function R(E){return w(E,"NFD",A)}e.$Rl=R;const p=/[^\u0000-\u0080]/;function w(E,M,C){if(!E)return E;const v=C.get(E);if(v)return v;let S;return p.test(E)?S=E.normalize(M):S=E,C.set(E,S),S}e.$Sl=function(){const E=/[\u0300-\u036f]/g;return function(M){return R(M).replace(E,"")}}()}),define(Se[125],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$im=e.$hm=e.$gm=e.rot=e.$em=void 0;function l(p,w,E){return Math.min(Math.max(p,w),E)}e.$em=l;function j(p,w){return(w+p%w)%w}e.rot=j;class L{constructor(){this.a=0}getNext(){return this.a++}}e.$gm=L;class A{constructor(){this.a=1,this.b=0}update(w){return this.b=this.b+(w-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$hm=A;class R{constructor(w){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(w),this.c.fill(0,0,w)}update(w){const E=this.c[this.d];return this.c[this.d]=w,this.d=(this.d+1)%this.c.length,this.e-=E,this.e+=w,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$im=R}),function(){function fe(L){const A=[];typeof L=="number"&&A.push("code/timeOrigin",L);function R(w){A.push(w,Date.now())}function p(){const w=[];for(let E=0;E<A.length;E+=2)w.push({name:A[E],startTime:A[E+1]});return w}return{mark:R,getMarks:p}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?fe():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const R of performance.getEntriesByType("mark"))A.push({name:R.name,startTime:Math.round(L+R.startTime)});return A}};if(typeof process=="object"){const L=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return fe(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),fe()}function l(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var j;typeof global=="object"?j=global:typeof self=="object"?j=self:j={},typeof define=="function"?define("vs/base/common/performance",[],function(){return l(j)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=l(j):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),j.perf=l(j))}(),function(fe,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var l=e();for(var j in l)(typeof exports=="object"?exports:fe)[j]=l[j]}}(typeof self<"u"?self:this,function(){return function(fe){var e={};function l(j){if(e[j])return e[j].exports;var L=e[j]={i:j,l:!1,exports:{}};return fe[j].call(L.exports,L,L.exports,l),L.l=!0,L.exports}return l.m=fe,l.c=e,l.d=function(j,L,A){l.o(j,L)||Object.defineProperty(j,L,{enumerable:!0,get:A})},l.r=function(j){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(j,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(j,"__esModule",{value:!0})},l.t=function(j,L){if(1&L&&(j=l(j)),8&L||4&L&&typeof j=="object"&&j&&j.__esModule)return j;var A=Object.create(null);if(l.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:j}),2&L&&typeof j!="string")for(var R in j)l.d(A,R,function(p){return j[p]}.bind(null,R));return A},l.n=function(j){var L=j&&j.__esModule?function(){return j.default}:function(){return j};return l.d(L,"a",L),L},l.o=function(j,L){return Object.prototype.hasOwnProperty.call(j,L)},l.p="",l(l.s=0)}([function(fe,e,l){(function(j){var L;e=fe.exports=se,L=typeof j=="object"&&j.env&&j.env.NODE_DEBUG&&/\bsemver\b/i.test(j.env.NODE_DEBUG)?function(){var W=Array.prototype.slice.call(arguments,0);W.unshift("SEMVER"),console.log.apply(console,W)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,p=e.re=[],w=e.src=[],E=0,M=E++;w[M]="0|[1-9]\\d*";var C=E++;w[C]="[0-9]+";var v=E++;w[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var S=E++;w[S]="("+w[M]+")\\.("+w[M]+")\\.("+w[M]+")";var k=E++;w[k]="("+w[C]+")\\.("+w[C]+")\\.("+w[C]+")";var u=E++;w[u]="(?:"+w[M]+"|"+w[v]+")";var m=E++;w[m]="(?:"+w[C]+"|"+w[v]+")";var o=E++;w[o]="(?:-("+w[u]+"(?:\\."+w[u]+")*))";var i=E++;w[i]="(?:-?("+w[m]+"(?:\\."+w[m]+")*))";var n=E++;w[n]="[0-9A-Za-z-]+";var s=E++;w[s]="(?:\\+("+w[n]+"(?:\\."+w[n]+")*))";var c=E++,t="v?"+w[S]+w[o]+"?"+w[s]+"?";w[c]="^"+t+"$";var f="[v=\\s]*"+w[k]+w[i]+"?"+w[s]+"?",h=E++;w[h]="^"+f+"$";var r=E++;w[r]="((?:<|>)?=?)";var a=E++;w[a]=w[C]+"|x|X|\\*";var d=E++;w[d]=w[M]+"|x|X|\\*";var $=E++;w[$]="[v=\\s]*("+w[d]+")(?:\\.("+w[d]+")(?:\\.("+w[d]+")(?:"+w[o]+")?"+w[s]+"?)?)?";var D=E++;w[D]="[v=\\s]*("+w[a]+")(?:\\.("+w[a]+")(?:\\.("+w[a]+")(?:"+w[i]+")?"+w[s]+"?)?)?";var b=E++;w[b]="^"+w[r]+"\\s*"+w[$]+"$";var g=E++;w[g]="^"+w[r]+"\\s*"+w[D]+"$";var y=E++;w[y]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=E++;w[P]="(?:~>?)";var N=E++;w[N]="(\\s*)"+w[P]+"\\s+",p[N]=new RegExp(w[N],"g");var U=E++;w[U]="^"+w[P]+w[$]+"$";var z=E++;w[z]="^"+w[P]+w[D]+"$";var F=E++;w[F]="(?:\\^)";var I=E++;w[I]="(\\s*)"+w[F]+"\\s+",p[I]=new RegExp(w[I],"g");var O=E++;w[O]="^"+w[F]+w[$]+"$";var T=E++;w[T]="^"+w[F]+w[D]+"$";var G=E++;w[G]="^"+w[r]+"\\s*("+f+")$|^$";var te=E++;w[te]="^"+w[r]+"\\s*("+t+")$|^$";var x=E++;w[x]="(\\s*)"+w[r]+"\\s*("+f+"|"+w[$]+")",p[x]=new RegExp(w[x],"g");var X=E++;w[X]="^\\s*("+w[$]+")\\s+-\\s+("+w[$]+")\\s*$";var Q=E++;w[Q]="^\\s*("+w[D]+")\\s+-\\s+("+w[D]+")\\s*$";var ae=E++;w[ae]="(<|>)?=?\\s*\\*";for(var _=0;_<35;_++)L(_,w[_]),p[_]||(p[_]=new RegExp(w[_]));function ge(W,Y){if(W instanceof se)return W;if(typeof W!="string"||W.length>A||!(Y?p[h]:p[c]).test(W))return null;try{return new se(W,Y)}catch{return null}}function se(W,Y){if(W instanceof se){if(W.loose===Y)return W;W=W.version}else if(typeof W!="string")throw new TypeError("Invalid Version: "+W);if(W.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof se))return new se(W,Y);L("SemVer",W,Y),this.loose=Y;var J=W.trim().match(Y?p[h]:p[c]);if(!J)throw new TypeError("Invalid Version: "+W);if(this.raw=W,this.major=+J[1],this.minor=+J[2],this.patch=+J[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");J[4]?this.prerelease=J[4].split(".").map(function($e){if(/^[0-9]+$/.test($e)){var ve=+$e;if(ve>=0&&ve<R)return ve}return $e}):this.prerelease=[],this.build=J[5]?J[5].split("."):[],this.format()}e.parse=ge,e.valid=function(W,Y){var J=ge(W,Y);return J?J.version:null},e.clean=function(W,Y){var J=ge(W.trim().replace(/^[=v]+/,""),Y);return J?J.version:null},e.SemVer=se,se.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},se.prototype.toString=function(){return this.version},se.prototype.compare=function(W){return L("SemVer.compare",this.version,this.loose,W),W instanceof se||(W=new se(W,this.loose)),this.compareMain(W)||this.comparePre(W)},se.prototype.compareMain=function(W){return W instanceof se||(W=new se(W,this.loose)),B(this.major,W.major)||B(this.minor,W.minor)||B(this.patch,W.patch)},se.prototype.comparePre=function(W){if(W instanceof se||(W=new se(W,this.loose)),this.prerelease.length&&!W.prerelease.length)return-1;if(!this.prerelease.length&&W.prerelease.length)return 1;if(!this.prerelease.length&&!W.prerelease.length)return 0;var Y=0;do{var J=this.prerelease[Y],$e=W.prerelease[Y];if(L("prerelease compare",Y,J,$e),J===void 0&&$e===void 0)return 0;if($e===void 0)return 1;if(J===void 0)return-1;if(J!==$e)return B(J,$e)}while(++Y)},se.prototype.inc=function(W,Y){switch(W){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Y);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Y);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Y),this.inc("pre",Y);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Y),this.inc("pre",Y);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var J=this.prerelease.length;--J>=0;)typeof this.prerelease[J]=="number"&&(this.prerelease[J]++,J=-2);J===-1&&this.prerelease.push(0)}Y&&(this.prerelease[0]===Y?isNaN(this.prerelease[1])&&(this.prerelease=[Y,0]):this.prerelease=[Y,0]);break;default:throw new Error("invalid increment argument: "+W)}return this.format(),this.raw=this.version,this},e.inc=function(W,Y,J,$e){typeof J=="string"&&($e=J,J=void 0);try{return new se(W,J).inc(Y,$e).version}catch{return null}},e.diff=function(W,Y){if(ue(W,Y))return null;var J=ge(W),$e=ge(Y);if(J.prerelease.length||$e.prerelease.length){for(var ve in J)if((ve==="major"||ve==="minor"||ve==="patch")&&J[ve]!==$e[ve])return"pre"+ve;return"prerelease"}for(var ve in J)if((ve==="major"||ve==="minor"||ve==="patch")&&J[ve]!==$e[ve])return ve},e.compareIdentifiers=B;var re=/^[0-9]+$/;function B(W,Y){var J=re.test(W),$e=re.test(Y);return J&&$e&&(W=+W,Y=+Y),J&&!$e?-1:$e&&!J?1:W<Y?-1:W>Y?1:0}function ie(W,Y,J){return new se(W,J).compare(new se(Y,J))}function ye(W,Y,J){return ie(W,Y,J)>0}function le(W,Y,J){return ie(W,Y,J)<0}function ue(W,Y,J){return ie(W,Y,J)===0}function ce(W,Y,J){return ie(W,Y,J)!==0}function de(W,Y,J){return ie(W,Y,J)>=0}function H(W,Y,J){return ie(W,Y,J)<=0}function Z(W,Y,J,$e){var ve;switch(Y){case"===":typeof W=="object"&&(W=W.version),typeof J=="object"&&(J=J.version),ve=W===J;break;case"!==":typeof W=="object"&&(W=W.version),typeof J=="object"&&(J=J.version),ve=W!==J;break;case"":case"=":case"==":ve=ue(W,J,$e);break;case"!=":ve=ce(W,J,$e);break;case">":ve=ye(W,J,$e);break;case">=":ve=de(W,J,$e);break;case"<":ve=le(W,J,$e);break;case"<=":ve=H(W,J,$e);break;default:throw new TypeError("Invalid operator: "+Y)}return ve}function he(W,Y){if(W instanceof he){if(W.loose===Y)return W;W=W.value}if(!(this instanceof he))return new he(W,Y);L("comparator",W,Y),this.loose=Y,this.parse(W),this.semver===be?this.value="":this.value=this.operator+this.semver.version,L("comp",this)}e.rcompareIdentifiers=function(W,Y){return B(Y,W)},e.major=function(W,Y){return new se(W,Y).major},e.minor=function(W,Y){return new se(W,Y).minor},e.patch=function(W,Y){return new se(W,Y).patch},e.compare=ie,e.compareLoose=function(W,Y){return ie(W,Y,!0)},e.rcompare=function(W,Y,J){return ie(Y,W,J)},e.sort=function(W,Y){return W.sort(function(J,$e){return e.compare(J,$e,Y)})},e.rsort=function(W,Y){return W.sort(function(J,$e){return e.rcompare(J,$e,Y)})},e.gt=ye,e.lt=le,e.eq=ue,e.neq=ce,e.gte=de,e.lte=H,e.cmp=Z,e.Comparator=he;var be={};function Pe(W,Y){if(W instanceof Pe)return W.loose===Y?W:new Pe(W.raw,Y);if(W instanceof he)return new Pe(W.value,Y);if(!(this instanceof Pe))return new Pe(W,Y);if(this.loose=Y,this.raw=W,this.set=W.split(/\s*\|\|\s*/).map(function(J){return this.parseRange(J.trim())},this).filter(function(J){return J.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+W);this.format()}function pe(W){return!W||W.toLowerCase()==="x"||W==="*"}function Ae(W,Y,J,$e,ve,Fe,He,Qe,tt,st,ut,rt,Ie){return((Y=pe(J)?"":pe($e)?">="+J+".0.0":pe(ve)?">="+J+"."+$e+".0":">="+Y)+" "+(Qe=pe(tt)?"":pe(st)?"<"+(+tt+1)+".0.0":pe(ut)?"<"+tt+"."+(+st+1)+".0":rt?"<="+tt+"."+st+"."+ut+"-"+rt:"<="+Qe)).trim()}function Oe(W,Y){for(var J=0;J<W.length;J++)if(!W[J].test(Y))return!1;if(Y.prerelease.length){for(J=0;J<W.length;J++)if(L(W[J].semver),W[J].semver!==be&&W[J].semver.prerelease.length>0){var $e=W[J].semver;if($e.major===Y.major&&$e.minor===Y.minor&&$e.patch===Y.patch)return!0}return!1}return!0}function ze(W,Y,J){try{Y=new Pe(Y,J)}catch{return!1}return Y.test(W)}function q(W,Y,J,$e){var ve,Fe,He,Qe,tt;switch(W=new se(W,$e),Y=new Pe(Y,$e),J){case">":ve=ye,Fe=H,He=le,Qe=">",tt=">=";break;case"<":ve=le,Fe=de,He=ye,Qe="<",tt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(W,Y,$e))return!1;for(var st=0;st<Y.set.length;++st){var ut=Y.set[st],rt=null,Ie=null;if(ut.forEach(function(Be){Be.semver===be&&(Be=new he(">=0.0.0")),rt=rt||Be,Ie=Ie||Be,ve(Be.semver,rt.semver,$e)?rt=Be:He(Be.semver,Ie.semver,$e)&&(Ie=Be)}),rt.operator===Qe||rt.operator===tt||(!Ie.operator||Ie.operator===Qe)&&Fe(W,Ie.semver)||Ie.operator===tt&&He(W,Ie.semver))return!1}return!0}he.prototype.parse=function(W){var Y=this.loose?p[G]:p[te],J=W.match(Y);if(!J)throw new TypeError("Invalid comparator: "+W);this.operator=J[1],this.operator==="="&&(this.operator=""),J[2]?this.semver=new se(J[2],this.loose):this.semver=be},he.prototype.toString=function(){return this.value},he.prototype.test=function(W){return L("Comparator.test",W,this.loose),this.semver===be||(typeof W=="string"&&(W=new se(W,this.loose)),Z(W,this.operator,this.semver,this.loose))},he.prototype.intersects=function(W,Y){if(!(W instanceof he))throw new TypeError("a Comparator is required");var J;if(this.operator==="")return J=new Pe(W.value,Y),ze(this.value,J,Y);if(W.operator==="")return J=new Pe(this.value,Y),ze(W.semver,J,Y);var $e=!(this.operator!==">="&&this.operator!==">"||W.operator!==">="&&W.operator!==">"),ve=!(this.operator!=="<="&&this.operator!=="<"||W.operator!=="<="&&W.operator!=="<"),Fe=this.semver.version===W.semver.version,He=!(this.operator!==">="&&this.operator!=="<="||W.operator!==">="&&W.operator!=="<="),Qe=Z(this.semver,"<",W.semver,Y)&&(this.operator===">="||this.operator===">")&&(W.operator==="<="||W.operator==="<"),tt=Z(this.semver,">",W.semver,Y)&&(this.operator==="<="||this.operator==="<")&&(W.operator===">="||W.operator===">");return $e||ve||Fe&&He||Qe||tt},e.Range=Pe,Pe.prototype.format=function(){return this.range=this.set.map(function(W){return W.join(" ").trim()}).join("||").trim(),this.range},Pe.prototype.toString=function(){return this.range},Pe.prototype.parseRange=function(W){var Y=this.loose;W=W.trim(),L("range",W,Y);var J=Y?p[Q]:p[X];W=W.replace(J,Ae),L("hyphen replace",W),W=W.replace(p[x],"$1$2$3"),L("comparator trim",W,p[x]),W=(W=(W=W.replace(p[N],"$1~")).replace(p[I],"$1^")).split(/\s+/).join(" ");var $e=Y?p[G]:p[te],ve=W.split(" ").map(function(Fe){return function(He,Qe){return L("comp",He),He=function(tt,st){return tt.trim().split(/\s+/).map(function(ut){return function(rt,Ie){L("caret",rt,Ie);var Be=Ie?p[T]:p[O];return rt.replace(Be,function(Le,Ke,ne,oe,Ce){var Ge;return L("caret",rt,Le,Ke,ne,oe,Ce),pe(Ke)?Ge="":pe(ne)?Ge=">="+Ke+".0.0 <"+(+Ke+1)+".0.0":pe(oe)?Ge=Ke==="0"?">="+Ke+"."+ne+".0 <"+Ke+"."+(+ne+1)+".0":">="+Ke+"."+ne+".0 <"+(+Ke+1)+".0.0":Ce?(L("replaceCaret pr",Ce),Ce.charAt(0)!=="-"&&(Ce="-"+Ce),Ge=Ke==="0"?ne==="0"?">="+Ke+"."+ne+"."+oe+Ce+" <"+Ke+"."+ne+"."+(+oe+1):">="+Ke+"."+ne+"."+oe+Ce+" <"+Ke+"."+(+ne+1)+".0":">="+Ke+"."+ne+"."+oe+Ce+" <"+(+Ke+1)+".0.0"):(L("no pr"),Ge=Ke==="0"?ne==="0"?">="+Ke+"."+ne+"."+oe+" <"+Ke+"."+ne+"."+(+oe+1):">="+Ke+"."+ne+"."+oe+" <"+Ke+"."+(+ne+1)+".0":">="+Ke+"."+ne+"."+oe+" <"+(+Ke+1)+".0.0"),L("caret return",Ge),Ge})}(ut,st)}).join(" ")}(He,Qe),L("caret",He),He=function(tt,st){return tt.trim().split(/\s+/).map(function(ut){return function(rt,Ie){var Be=Ie?p[z]:p[U];return rt.replace(Be,function(Le,Ke,ne,oe,Ce){var Ge;return L("tilde",rt,Le,Ke,ne,oe,Ce),pe(Ke)?Ge="":pe(ne)?Ge=">="+Ke+".0.0 <"+(+Ke+1)+".0.0":pe(oe)?Ge=">="+Ke+"."+ne+".0 <"+Ke+"."+(+ne+1)+".0":Ce?(L("replaceTilde pr",Ce),Ce.charAt(0)!=="-"&&(Ce="-"+Ce),Ge=">="+Ke+"."+ne+"."+oe+Ce+" <"+Ke+"."+(+ne+1)+".0"):Ge=">="+Ke+"."+ne+"."+oe+" <"+Ke+"."+(+ne+1)+".0",L("tilde return",Ge),Ge})}(ut,st)}).join(" ")}(He,Qe),L("tildes",He),He=function(tt,st){return L("replaceXRanges",tt,st),tt.split(/\s+/).map(function(ut){return function(rt,Ie){rt=rt.trim();var Be=Ie?p[g]:p[b];return rt.replace(Be,function(Le,Ke,ne,oe,Ce,Ge){L("xRange",rt,Le,Ke,ne,oe,Ce,Ge);var xe=pe(ne),nt=xe||pe(oe),Ne=nt||pe(Ce);return Ke==="="&&Ne&&(Ke=""),xe?Le=Ke===">"||Ke==="<"?"<0.0.0":"*":Ke&&Ne?(nt&&(oe=0),Ne&&(Ce=0),Ke===">"?(Ke=">=",nt?(ne=+ne+1,oe=0,Ce=0):Ne&&(oe=+oe+1,Ce=0)):Ke==="<="&&(Ke="<",nt?ne=+ne+1:oe=+oe+1),Le=Ke+ne+"."+oe+"."+Ce):nt?Le=">="+ne+".0.0 <"+(+ne+1)+".0.0":Ne&&(Le=">="+ne+"."+oe+".0 <"+ne+"."+(+oe+1)+".0"),L("xRange return",Le),Le})}(ut,st)}).join(" ")}(He,Qe),L("xrange",He),He=function(tt,st){return L("replaceStars",tt,st),tt.trim().replace(p[ae],"")}(He,Qe),L("stars",He),He}(Fe,Y)}).join(" ").split(/\s+/);return this.loose&&(ve=ve.filter(function(Fe){return!!Fe.match($e)})),ve=ve.map(function(Fe){return new he(Fe,Y)})},Pe.prototype.intersects=function(W,Y){if(!(W instanceof Pe))throw new TypeError("a Range is required");return this.set.some(function(J){return J.every(function($e){return W.set.some(function(ve){return ve.every(function(Fe){return $e.intersects(Fe,Y)})})})})},e.toComparators=function(W,Y){return new Pe(W,Y).set.map(function(J){return J.map(function($e){return $e.value}).join(" ").trim().split(" ")})},Pe.prototype.test=function(W){if(!W)return!1;typeof W=="string"&&(W=new se(W,this.loose));for(var Y=0;Y<this.set.length;Y++)if(Oe(this.set[Y],W))return!0;return!1},e.satisfies=ze,e.maxSatisfying=function(W,Y,J){var $e=null,ve=null;try{var Fe=new Pe(Y,J)}catch{return null}return W.forEach(function(He){Fe.test(He)&&($e&&ve.compare(He)!==-1||(ve=new se($e=He,J)))}),$e},e.minSatisfying=function(W,Y,J){var $e=null,ve=null;try{var Fe=new Pe(Y,J)}catch{return null}return W.forEach(function(He){Fe.test(He)&&($e&&ve.compare(He)!==1||(ve=new se($e=He,J)))}),$e},e.validRange=function(W,Y){try{return new Pe(W,Y).range||"*"}catch{return null}},e.ltr=function(W,Y,J){return q(W,Y,"<",J)},e.gtr=function(W,Y,J){return q(W,Y,">",J)},e.outside=q,e.prerelease=function(W,Y){var J=ge(W,Y);return J&&J.prerelease.length?J.prerelease:null},e.intersects=function(W,Y,J){return W=new Pe(W,J),Y=new Pe(Y,J),W.intersects(Y)},e.coerce=function(W){if(W instanceof se)return W;if(typeof W!="string")return null;var Y=W.match(p[y]);return Y==null?null:ge((Y[1]||"0")+"."+(Y[2]||"0")+"."+(Y[3]||"0"))}}).call(this,l(1))},function(fe,e){var l,j,L=fe.exports={};function A(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function p(m){if(l===setTimeout)return setTimeout(m,0);if((l===A||!l)&&setTimeout)return l=setTimeout,setTimeout(m,0);try{return l(m,0)}catch{try{return l.call(null,m,0)}catch{return l.call(this,m,0)}}}(function(){try{l=typeof setTimeout=="function"?setTimeout:A}catch{l=A}try{j=typeof clearTimeout=="function"?clearTimeout:R}catch{j=R}})();var w,E=[],M=!1,C=-1;function v(){M&&w&&(M=!1,w.length?E=w.concat(E):C=-1,E.length&&S())}function S(){if(!M){var m=p(v);M=!0;for(var o=E.length;o;){for(w=E,E=[];++C<o;)w&&w[C].run();C=-1,o=E.length}w=null,M=!1,function(i){if(j===clearTimeout)return clearTimeout(i);if((j===R||!j)&&clearTimeout)return j=clearTimeout,clearTimeout(i);try{j(i)}catch{try{return j.call(null,i)}catch{return j.call(this,i)}}}(m)}}function k(m,o){this.fun=m,this.array=o}function u(){}L.nextTick=function(m){var o=new Array(arguments.length-1);if(arguments.length>1)for(var i=1;i<arguments.length;i++)o[i-1]=arguments[i];E.push(new k(m,o)),E.length!==1||M||p(S)},k.prototype.run=function(){this.fun.apply(null,this.array)},L.title="browser",L.browser=!0,L.env={},L.argv=[],L.version="",L.versions={},L.on=u,L.addListener=u,L.once=u,L.off=u,L.removeListener=u,L.removeAllListeners=u,L.emit=u,L.prependListener=u,L.prependOnceListener=u,L.listeners=function(m){return[]},L.binding=function(m){throw new Error("process.binding is not supported")},L.cwd=function(){return"/"},L.chdir=function(m){throw new Error("process.chdir is not supported")},L.umask=function(){return 0}}])}),define(Se[38],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1d=void 0;const l=globalThis.performance&&typeof globalThis.performance.now=="function";class j{static create(A){return new j(A)}constructor(A){this.c=l&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$1d=j}),define(Se[4],De([1,0,13,73,3,74,38]),function(fe,e,l,j,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.Event=void 0;const p=!1,w=!1;var E;(function(b){b.None=()=>L.$Tc.None;function g(H){if(w){const{onDidAddListener:Z}=H,he=k.create();let be=0;H.onDidAddListener=()=>{++be===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),he.print()),Z?.()}}}function y(H,Z){return te(H,()=>{},0,void 0,!0,void 0,Z)}b.defer=y;function P(H){return(Z,he=null,be)=>{let Pe=!1,pe;return pe=H(Ae=>{if(!Pe)return pe?pe.dispose():Pe=!0,Z.call(he,Ae)},null,be),Pe&&pe.dispose(),pe}}b.once=P;function N(H,Z,he){return T((be,Pe=null,pe)=>H(Ae=>be.call(Pe,Z(Ae)),null,pe),he)}b.map=N;function U(H,Z,he){return T((be,Pe=null,pe)=>H(Ae=>{Z(Ae),be.call(Pe,Ae)},null,pe),he)}b.forEach=U;function z(H,Z,he){return T((be,Pe=null,pe)=>H(Ae=>Z(Ae)&&be.call(Pe,Ae),null,pe),he)}b.filter=z;function F(H){return H}b.signal=F;function I(...H){return(Z,he=null,be)=>{const Pe=(0,L.$Qc)(...H.map(pe=>pe(Ae=>Z.call(he,Ae))));return G(Pe,be)}}b.any=I;function O(H,Z,he,be){let Pe=he;return N(H,pe=>(Pe=Z(Pe,pe),Pe),be)}b.reduce=O;function T(H,Z){let he;const be={onWillAddFirstListener(){he=H(Pe.fire,Pe)},onDidRemoveLastListener(){he?.dispose()}};Z||g(be);const Pe=new n(be);return Z?.add(Pe),Pe.event}function G(H,Z){return Z instanceof Array?Z.push(H):Z&&Z.add(H),H}function te(H,Z,he=100,be=!1,Pe=!1,pe,Ae){let Oe,ze,q,W=0,Y;const J={leakWarningThreshold:pe,onWillAddFirstListener(){Oe=H(ve=>{W++,ze=Z(ze,ve),be&&!q&&($e.fire(ze),ze=void 0),Y=()=>{const Fe=ze;ze=void 0,q=void 0,(!be||W>1)&&$e.fire(Fe),W=0},typeof he=="number"?(clearTimeout(q),q=setTimeout(Y,he)):q===void 0&&(q=0,queueMicrotask(Y))})},onWillRemoveListener(){Pe&&W>0&&Y?.()},onDidRemoveLastListener(){Y=void 0,Oe.dispose()}};Ae||g(J);const $e=new n(J);return Ae?.add($e),$e.event}b.debounce=te;function x(H,Z=0,he){return b.debounce(H,(be,Pe)=>be?(be.push(Pe),be):[Pe],Z,void 0,!0,void 0,he)}b.accumulate=x;function X(H,Z=(be,Pe)=>be===Pe,he){let be=!0,Pe;return z(H,pe=>{const Ae=be||!Z(pe,Pe);return be=!1,Pe=pe,Ae},he)}b.latch=X;function Q(H,Z,he){return[b.filter(H,Z,he),b.filter(H,be=>!Z(be),he)]}b.split=Q;function ae(H,Z=!1,he=[],be){let Pe=he.slice(),pe=H(ze=>{Pe?Pe.push(ze):Oe.fire(ze)});be&&be.add(pe);const Ae=()=>{Pe?.forEach(ze=>Oe.fire(ze)),Pe=null},Oe=new n({onWillAddFirstListener(){pe||(pe=H(ze=>Oe.fire(ze)),be&&be.add(pe))},onDidAddFirstListener(){Pe&&(Z?setTimeout(Ae):Ae())},onDidRemoveLastListener(){pe&&pe.dispose(),pe=null}});return be&&be.add(Oe),Oe.event}b.buffer=ae;function _(H,Z){return(be,Pe,pe)=>{const Ae=Z(new se);return H(function(Oe){const ze=Ae.evaluate(Oe);ze!==ge&&be.call(Pe,ze)},void 0,pe)}}b.chain=_;const ge=Symbol("HaltChainable");class se{constructor(){this.f=[]}map(Z){return this.f.push(Z),this}forEach(Z){return this.f.push(he=>(Z(he),he)),this}filter(Z){return this.f.push(he=>Z(he)?he:ge),this}reduce(Z,he){let be=he;return this.f.push(Pe=>(be=Z(be,Pe),be)),this}latch(Z=(he,be)=>he===be){let he=!0,be;return this.f.push(Pe=>{const pe=he||!Z(Pe,be);return he=!1,be=Pe,pe?Pe:ge}),this}evaluate(Z){for(const he of this.f)if(Z=he(Z),Z===ge)break;return Z}}function re(H,Z,he=be=>be){const be=(...Oe)=>Ae.fire(he(...Oe)),Pe=()=>H.on(Z,be),pe=()=>H.removeListener(Z,be),Ae=new n({onWillAddFirstListener:Pe,onDidRemoveLastListener:pe});return Ae.event}b.fromNodeEventEmitter=re;function B(H,Z,he=be=>be){const be=(...Oe)=>Ae.fire(he(...Oe)),Pe=()=>H.addEventListener(Z,be),pe=()=>H.removeEventListener(Z,be),Ae=new n({onWillAddFirstListener:Pe,onDidRemoveLastListener:pe});return Ae.event}b.fromDOMEventEmitter=B;function ie(H){return new Promise(Z=>P(H)(Z))}b.toPromise=ie;function ye(H){const Z=new n;return H.then(he=>{Z.fire(he)},()=>{Z.fire(void 0)}).finally(()=>{Z.dispose()}),Z.event}b.fromPromise=ye;function le(H,Z,he){return Z(he),H(be=>Z(be))}b.runAndSubscribe=le;class ue{constructor(Z,he){this._observable=Z,this.f=0,this.g=!1;const be={onWillAddFirstListener:()=>{Z.addObserver(this)},onDidRemoveLastListener:()=>{Z.removeObserver(this)}};he||g(be),this.emitter=new n(be),he&&he.add(this.emitter)}beginUpdate(Z){this.f++}handlePossibleChange(Z){}handleChange(Z,he){this.g=!0}endUpdate(Z){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function ce(H,Z){return new ue(H,Z).emitter.event}b.fromObservable=ce;function de(H){return(Z,he,be)=>{let Pe=0,pe=!1;const Ae={beginUpdate(){Pe++},endUpdate(){Pe--,Pe===0&&(H.reportChanges(),pe&&(pe=!1,Z.call(he)))},handlePossibleChange(){},handleChange(){pe=!0}};H.addObserver(Ae),H.reportChanges();const Oe={dispose(){H.removeObserver(Ae)}};return be instanceof L.$Sc?be.add(Oe):Array.isArray(be)&&be.push(Oe),Oe}}b.fromObservableLight=de})(E||(e.Event=E={}));class M{static{this.all=new Set}static{this.f=0}constructor(g){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${g}_${M.f++}`,M.all.add(this)}start(g){this.g=new R.$1d,this.listenerCount=g}stop(){if(this.g){const g=this.g.elapsed();this.durations.push(g),this.elapsedOverall+=g,this.invocationCount+=1,this.g=void 0}}}e.$3d=M;let C=-1;function v(b){const g=C;return C=b,{dispose(){C=g}}}e.$4d=v;class S{constructor(g,y=Math.random().toString(18).slice(2,5)){this.threshold=g,this.name=y,this.g=0}dispose(){this.f?.clear()}check(g,y){const P=this.threshold;if(P<=0||y<P)return;this.f||(this.f=new Map);const N=this.f.get(g.value)||0;if(this.f.set(g.value,N+1),this.g-=1,this.g<=0){this.g=P*.5;let U,z=0;for(const[F,I]of this.f)(!U||z<I)&&(U=F,z=I);console.warn(`[${this.name}] potential listener LEAK detected, having ${y} listeners already. MOST frequent listener (${z}):`),console.warn(U)}return()=>{const U=this.f.get(g.value)||0;this.f.set(g.value,U-1)}}}class k{static create(){return new k(new Error().stack??"")}constructor(g){this.value=g}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let u=0;class m{constructor(g){this.value=g,this.id=u++}}const o=2,i=(b,g)=>{if(b instanceof m)g(b);else for(let y=0;y<b.length;y++){const P=b[y];P&&g(P)}};class n{constructor(g){this.w=0,this.f=g,this.g=C>0||this.f?.leakWarningThreshold?new S(this.f?.leakWarningThreshold??C):void 0,this.j=this.f?._profName?new M(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(p){const g=this.t;queueMicrotask(()=>{i(g,y=>y.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(g,y,P)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),L.$Tc.None;if(this.m)return L.$Tc.None;y&&(g=g.bind(y));const N=new m(g);let U,z;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(N.stack=k.create(),U=this.g.check(N.stack,this.w+1)),p&&(N.stack=z??k.create()),this.t?this.t instanceof m?(this.u??=new c,this.t=[this.t,N]):this.t.push(N):(this.f?.onWillAddFirstListener?.(this),this.t=N,this.f?.onDidAddFirstListener?.(this)),this.w++;const F=(0,L.$Rc)(()=>{U?.(),this.x(N)});return P instanceof L.$Sc?P.add(F):Array.isArray(P)&&P.push(F),F},this.q}x(g){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const y=this.t,P=y.indexOf(g);if(P===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,y[P]=void 0;const N=this.u.current===this;if(this.w*o<=y.length){let U=0;for(let z=0;z<y.length;z++)y[z]?y[U++]=y[z]:N&&(this.u.end--,U<this.u.i&&this.u.i--);y.length=U}}y(g,y){if(!g)return;const P=this.f?.onListenerError||l.$1;if(!P){g.value(y);return}try{g.value(y)}catch(N){P(N)}}z(g){const y=g.current.t;for(;g.i<g.end;)this.y(y[g.i++],g.value);g.reset()}fire(g){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof m)this.y(this.t,g);else{const y=this.u;y.enqueue(this,g,this.t.length),this.z(y)}this.j?.stop()}hasListeners(){return this.w>0}}e.$5d=n;const s=()=>new c;e.$6d=s;class c{constructor(){this.i=-1,this.end=0}enqueue(g,y,P){this.i=0,this.end=P,this.current=g,this.value=y}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends n{async fireAsync(g,y,P){if(this.t)for(this.h||(this.h=new A.$4c),i(this.t,N=>this.h.push([N.value,g]));this.h.size>0&&!y.isCancellationRequested;){const[N,U]=this.h.shift(),z=[],F={...U,token:y,waitUntil:I=>{if(Object.isFrozen(z))throw new Error("waitUntil can NOT be called asynchronous");P&&(I=P(I,N)),z.push(I)}};try{N(F)}catch(I){(0,l.$1)(I);continue}Object.freeze(z),await Promise.allSettled(z).then(I=>{for(const O of I)O.status==="rejected"&&(0,l.$1)(O.reason)})}}}e.$7d=t;class f extends n{get isPaused(){return this.h!==0}constructor(g){super(g),this.h=0,this.s=new A.$4c,this.A=g?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const g=Array.from(this.s);this.s.clear(),super.fire(this.A(g))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(g){this.w&&(this.h!==0?this.s.push(g):super.fire(g))}}e.$8d=f;class h extends f{constructor(g){super(g),this.k=g.delay??100}fire(g){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(g)}}e.$9d=h;class r extends n{constructor(g){super(g),this.h=[],this.k=g?.merge}fire(g){this.hasListeners()&&(this.h.push(g),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(y=>super.fire(y)),this.h=[]}))}}e.$0d=r;class a{constructor(){this.g=!1,this.h=[],this.f=new n({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(g){const y={event:g,listener:null};this.h.push(y),this.g&&this.m(y);const P=()=>{this.g&&this.o(y);const N=this.h.indexOf(y);this.h.splice(N,1)};return(0,L.$Rc)((0,j.$db)(P))}j(){this.g=!0,this.h.forEach(g=>this.m(g))}k(){this.g=!1,this.h.forEach(g=>this.o(g))}m(g){g.listener=g.event(y=>this.f.fire(y))}o(g){g.listener?.dispose(),g.listener=null}dispose(){this.f.dispose();for(const g of this.h)g.listener?.dispose();this.h=[]}}e.$$d=a;class d{constructor(g,y,P,N){this.f=new L.$Sc;const U=this.f.add(new a),z=this.f.add(new L.$3c);function F(I){z.set(I,U.add(N(I)))}for(const I of g)F(I);this.f.add(y(I=>{F(I)})),this.f.add(P(I=>{z.deleteAndDispose(I)})),this.event=U.event}dispose(){this.f.dispose()}}e.$_d=d;class ${constructor(){this.f=[]}wrapEvent(g){return(y,P,N)=>g(U=>{const z=this.f[this.f.length-1];z?z.push(()=>y.call(P,U)):y.call(P,U)},void 0,N)}bufferEvents(g){const y=[];this.f.push(y);const P=g();return this.f.pop(),y.forEach(N=>N()),P}}e.$ae=$;class D{constructor(){this.f=!1,this.g=E.None,this.h=L.$Tc.None,this.j=new n({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(g){this.g=g,this.f&&(this.h.dispose(),this.h=g(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$be=D}),define(Se[22],De([1,0,4]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ce=e.CancellationToken=void 0;const j=Object.freeze(function(p,w){const E=setTimeout(p.bind(w),0);return{dispose(){clearTimeout(E)}}});var L;(function(p){function w(E){return E===p.None||E===p.Cancelled||E instanceof A?!0:!E||typeof E!="object"?!1:typeof E.isCancellationRequested=="boolean"&&typeof E.onCancellationRequested=="function"}p.isCancellationToken=w,p.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:l.Event.None}),p.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:j})})(L||(e.CancellationToken=L={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?j:(this.b||(this.b=new l.$5d),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class R{constructor(w){this.f=void 0,this.g=void 0,this.g=w&&w.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new A),this.f}cancel(){this.f?this.f instanceof A&&this.f.cancel():this.f=L.Cancelled}dispose(w=!1){w&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof A&&this.f.dispose():this.f=L.None}}e.$ce=R}),define(Se[166],De([1,0,22]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pe=e.$Oe=e.$Ne=void 0;class j{constructor(p){this.b=p,this.a=null}get(){if(this.a)return this.a;const p=new l.$ce,w=this.b(p.token);return this.a={promise:w,dispose:()=>{this.a=null,p.cancel(),p.dispose()}},this.a}}e.$Ne=j;class L{constructor(p){this.c=p,this.a=void 0,this.b=void 0}get(p){const w=JSON.stringify(p);return this.b!==w&&(this.b=w,this.a=this.c(p)),this.a}}e.$Oe=L;class A{get cachedValues(){return this.a}constructor(p){this.b=p,this.a=new Map}get(p){if(this.a.has(p))return this.a.get(p);const w=this.b(p);return this.a.set(p,w),w}}e.$Pe=A}),define(Se[98],De([1,0,13,3]),function(fe,e,l,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=void 0;function L(s){const c=s;return c?typeof c.read=="function":!1}e.$de=L;function A(s){const c=s;return c?[c.on,c.pause,c.resume,c.destroy].every(t=>typeof t=="function"):!1}e.$ee=A;function R(s){const c=s;return c?A(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.$fe=R;function p(s,c){return new w(s,c)}e.$ge=p;class w{constructor(c,t){this.e=c,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(c){if(!this.a.destroyed){if(this.a.flowing)this.g(c);else if(this.b.data.push(c),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(c){this.a.destroyed||(this.a.flowing?this.h(c):this.b.error.push(c))}end(c){this.a.destroyed||(typeof c<"u"&&this.write(c),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(c){this.c.data.slice(0).forEach(t=>t(c))}h(c){this.c.error.length===0?(0,l.$1)(c):this.c.error.slice(0).forEach(t=>t(c))}i(){this.c.end.slice(0).forEach(c=>c())}on(c,t){if(!this.a.destroyed)switch(c){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(c,t){if(this.a.destroyed)return;let f;switch(c){case"data":f=this.c.data;break;case"end":f=this.c.end;break;case"error":f=this.c.error;break}if(f){const h=f.indexOf(t);h>=0&&f.splice(h,1)}}j(){if(this.b.data.length>0){const c=this.e(this.b.data);this.g(c),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(f=>f())}}k(){if(this.c.error.length>0){for(const c of this.b.error)this.h(c);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function E(s,c){const t=[];let f;for(;(f=s.read())!==null;)t.push(f);return c(t)}e.$he=E;function M(s,c,t){const f=[];let h;for(;(h=s.read())!==null&&f.length<t;)f.push(h);return h===null&&f.length>0?c(f):{read:()=>{if(f.length>0)return f.shift();if(typeof h<"u"){const r=h;return h=void 0,r}return s.read()}}}e.$ie=M;function C(s,c){return new Promise((t,f)=>{const h=[];v(s,{onData:r=>{c&&h.push(r)},onError:r=>{c?f(r):t(void 0)},onEnd:()=>{t(c?c(h):void 0)}})})}e.$je=C;function v(s,c,t){s.on("error",f=>{t?.isCancellationRequested||c.onError(f)}),s.on("end",()=>{t?.isCancellationRequested||c.onEnd()}),s.on("data",f=>{t?.isCancellationRequested||c.onData(f)})}e.$ke=v;function S(s,c){return new Promise((t,f)=>{const h=new j.$Sc,r=[],a=D=>{if(r.push(D),r.length>c)return h.dispose(),s.pause(),t({stream:s,buffer:r,ended:!1})},d=D=>(h.dispose(),f(D)),$=()=>(h.dispose(),t({stream:s,buffer:r,ended:!0}));h.add((0,j.$Rc)(()=>s.removeListener("error",d))),s.on("error",d),h.add((0,j.$Rc)(()=>s.removeListener("end",$))),s.on("end",$),h.add((0,j.$Rc)(()=>s.removeListener("data",a))),s.on("data",a)})}e.$le=S;function k(s,c){const t=p(c);return t.end(s),t}e.$me=k;function u(){const s=p(()=>{throw new Error("not supported")});return s.end(),s}e.$ne=u;function m(s){let c=!1;return{read:()=>c?null:(c=!0,s)}}e.$oe=m;function o(s,c,t){const f=p(t);return v(s,{onData:h=>f.write(c.data(h)),onError:h=>f.error(c.error?c.error(h):h),onEnd:()=>f.end()}),f}e.$pe=o;function i(s,c,t){let f=!1;return{read:()=>{const h=c.read();return f?h:(f=!0,h!==null?t([s,h]):s)}}}e.$qe=i;function n(s,c,t){let f=!1;const h=p(t);return v(c,{onData:r=>f?h.write(r):(f=!0,h.write(t([s,r]))),onError:r=>h.error(r),onEnd:()=>{f||(f=!0,h.write(s)),h.end()}}),h}e.$re=n}),define(Se[21],De([1,0,43,98]),function(fe,e,l,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=void 0;const L=typeof Buffer<"u",A=new l.$V(()=>new Uint8Array(256));let R,p;class w{static alloc(y){return L?new w(Buffer.allocUnsafe(y)):new w(new Uint8Array(y))}static wrap(y){return L&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new w(y)}static fromString(y,P){return!(P?.dontUseNodeBuffer||!1)&&L?new w(Buffer.from(y)):(R||(R=new TextEncoder),new w(R.encode(y)))}static fromByteArray(y){const P=w.alloc(y.length);for(let N=0,U=y.length;N<U;N++)P.buffer[N]=y[N];return P}static concat(y,P){if(typeof P>"u"){P=0;for(let z=0,F=y.length;z<F;z++)P+=y[z].byteLength}const N=w.alloc(P);let U=0;for(let z=0,F=y.length;z<F;z++){const I=y[z];N.set(I,U),U+=I.byteLength}return N}constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}clone(){const y=w.alloc(this.byteLength);return y.set(this),y}toString(){return L?this.buffer.toString():(p||(p=new TextDecoder),p.decode(this.buffer))}slice(y,P){return new w(this.buffer.subarray(y,P))}set(y,P){if(y instanceof w)this.buffer.set(y.buffer,P);else if(y instanceof Uint8Array)this.buffer.set(y,P);else if(y instanceof ArrayBuffer)this.buffer.set(new Uint8Array(y),P);else if(ArrayBuffer.isView(y))this.buffer.set(new Uint8Array(y.buffer,y.byteOffset,y.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(y){return v(this.buffer,y)}writeUInt32BE(y,P){S(this.buffer,y,P)}readUInt32LE(y){return k(this.buffer,y)}writeUInt32LE(y,P){u(this.buffer,y,P)}readUInt8(y){return m(this.buffer,y)}writeUInt8(y,P){o(this.buffer,y,P)}indexOf(y,P=0){return E(this.buffer,y instanceof w?y.buffer:y,P)}}e.$se=w;function E(g,y,P=0){const N=y.byteLength,U=g.byteLength;if(N===0)return 0;if(N===1)return g.indexOf(y[0]);if(N>U-P)return-1;const z=A.value;z.fill(y.length);for(let T=0;T<y.length;T++)z[y[T]]=y.length-T-1;let F=P+y.length-1,I=F,O=-1;for(;F<U;)if(g[F]===y[I]){if(I===0){O=F;break}F--,I--}else F+=Math.max(y.length-I,z[g[F]]),I=y.length-1;return O}e.$te=E;function M(g,y){return g[y+0]<<0>>>0|g[y+1]<<8>>>0}e.$ue=M;function C(g,y,P){g[P+0]=y&255,y=y>>>8,g[P+1]=y&255}e.$ve=C;function v(g,y){return g[y]*2**24+g[y+1]*2**16+g[y+2]*2**8+g[y+3]}e.$we=v;function S(g,y,P){g[P+3]=y,y=y>>>8,g[P+2]=y,y=y>>>8,g[P+1]=y,y=y>>>8,g[P]=y}e.$xe=S;function k(g,y){return g[y+0]<<0>>>0|g[y+1]<<8>>>0|g[y+2]<<16>>>0|g[y+3]<<24>>>0}e.$ye=k;function u(g,y,P){g[P+0]=y&255,y=y>>>8,g[P+1]=y&255,y=y>>>8,g[P+2]=y&255,y=y>>>8,g[P+3]=y&255}e.$ze=u;function m(g,y){return g[y]}e.$Ae=m;function o(g,y,P){g[P]=y}e.$Be=o;function i(g){return j.$he(g,y=>w.concat(y))}e.$Ce=i;function n(g){return j.$oe(g)}e.$De=n;function s(g){return j.$je(g,y=>w.concat(y))}e.$Ee=s;async function c(g){return g.ended?w.concat(g.buffer):w.concat([...g.buffer,await s(g.stream)])}e.$Fe=c;function t(g){return j.$me(g,y=>w.concat(y))}e.$Ge=t;function f(g){return j.$pe(g,{data:y=>typeof y=="string"?w.fromString(y):w.wrap(y)},y=>w.concat(y))}e.$He=f;function h(g){return j.$ge(y=>w.concat(y),g)}e.$Ie=h;function r(g,y){return j.$qe(g,y,P=>w.concat(P))}e.$Je=r;function a(g,y){return j.$re(g,y,P=>w.concat(P))}e.$Ke=a;function d(g){let y=0,P=0,N=0;const U=new Uint8Array(Math.floor(g.length/4*3)),z=I=>{switch(P){case 3:U[N++]=y|I,P=0;break;case 2:U[N++]=y|I>>>2,y=I<<6,P=3;break;case 1:U[N++]=y|I>>>4,y=I<<4,P=2;break;default:y=I<<2,P=1}};for(let I=0;I<g.length;I++){const O=g.charCodeAt(I);if(O>=65&&O<=90)z(O-65);else if(O>=97&&O<=122)z(O-97+26);else if(O>=48&&O<=57)z(O-48+52);else if(O===43||O===45)z(62);else if(O===47||O===95)z(63);else{if(O===61)break;throw new SyntaxError(`Unexpected base64 character ${g[I]}`)}}const F=N;for(;P>0;)z(0);return w.wrap(U).slice(0,F)}e.$Le=d;const $="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function b({buffer:g},y=!0,P=!1){const N=P?D:$;let U="";const z=g.byteLength%3;let F=0;for(;F<g.byteLength-z;F+=3){const I=g[F+0],O=g[F+1],T=g[F+2];U+=N[I>>>2],U+=N[(I<<4|O>>>4)&63],U+=N[(O<<2|T>>>6)&63],U+=N[T&63]}if(z===1){const I=g[F+0];U+=N[I>>>2],U+=N[I<<4&63],y&&(U+="==")}else if(z===2){const I=g[F+0],O=g[F+1];U+=N[I>>>2],U+=N[(I<<4|O>>>4)&63],U+=N[O<<2&63],y&&(U+="=")}return U}e.$Me=b}),define(Se[14],De([1,0,166,43]),function(fe,e,l,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rf=e.$Qf=e.$Pf=e.$Of=e.GraphemeBreakType=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=void 0;function L(Ie){return!Ie||typeof Ie!="string"?!0:Ie.trim().length===0}e.$Se=L;const A=/{(\d+)}/g;function R(Ie,...Be){return Be.length===0?Ie:Ie.replace(A,function(Le,Ke){const ne=parseInt(Ke,10);return isNaN(ne)||ne<0||ne>=Be.length?Le:Be[ne]})}e.$Te=R;const p=/{([^}]+)}/g;function w(Ie,Be){return Object.keys(Be).length===0?Ie:Ie.replace(p,(Le,Ke)=>Be[Ke]??Le)}e.$Ue=w;function E(Ie){return Ie.replace(/[<>"'&]/g,Be=>{switch(Be){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Be})}e.$Ve=E;function M(Ie){return Ie.replace(/[<>&]/g,function(Be){switch(Be){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Be}})}e.$We=M;function C(Ie){return Ie.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Xe=C;function v(Ie,Be){let Le=0;const Ke=Be.charCodeAt(0);for(let ne=Ie.length-1;ne>=0;ne--)Ie.charCodeAt(ne)===Ke&&Le++;return Le}e.$Ye=v;function S(Ie,Be,Le="\u2026"){return Ie.length<=Be?Ie:`${Ie.substr(0,Be)}${Le}`}e.$Ze=S;function k(Ie,Be,Le="\u2026"){if(Ie.length<=Be)return Ie;const Ke=Math.ceil(Be/2)-Le.length/2,ne=Math.floor(Be/2)-Le.length/2;return`${Ie.substr(0,Ke)}${Le}${Ie.substr(Ie.length-ne)}`}e.$1e=k;function u(Ie,Be=" "){const Le=m(Ie,Be);return o(Le,Be)}e.$2e=u;function m(Ie,Be){if(!Ie||!Be)return Ie;const Le=Be.length;if(Le===0||Ie.length===0)return Ie;let Ke=0;for(;Ie.indexOf(Be,Ke)===Ke;)Ke=Ke+Le;return Ie.substring(Ke)}e.$3e=m;function o(Ie,Be){if(!Ie||!Be)return Ie;const Le=Be.length,Ke=Ie.length;if(Le===0||Ke===0)return Ie;let ne=Ke,oe=-1;for(;oe=Ie.lastIndexOf(Be,ne-1),!(oe===-1||oe+Le!==ne);){if(oe===0)return"";ne=oe}return Ie.substring(0,ne)}e.$4e=o;function i(Ie){return Ie.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$5e=i;function n(Ie){return Ie.replace(/\*/g,"")}e.$6e=n;function s(Ie,Be,Le={}){if(!Ie)throw new Error("Cannot create regex from empty string");Be||(Ie=C(Ie)),Le.wholeWord&&(/\B/.test(Ie.charAt(0))||(Ie="\\b"+Ie),/\B/.test(Ie.charAt(Ie.length-1))||(Ie=Ie+"\\b"));let Ke="";return Le.global&&(Ke+="g"),Le.matchCase||(Ke+="i"),Le.multiline&&(Ke+="m"),Le.unicode&&(Ke+="u"),new RegExp(Ie,Ke)}e.$7e=s;function c(Ie){return Ie.source==="^"||Ie.source==="^$"||Ie.source==="$"||Ie.source==="^\\s*$"?!1:!!(Ie.exec("")&&Ie.lastIndex===0)}e.$8e=c;function t(Ie){return Ie.split(/\r\n|\r|\n/)}e.$9e=t;function f(Ie){const Be=[],Le=Ie.split(/(\r\n|\r|\n)/);for(let Ke=0;Ke<Math.ceil(Le.length/2);Ke++)Be.push(Le[2*Ke]+(Le[2*Ke+1]??""));return Be}e.$0e=f;function h(Ie){for(let Be=0,Le=Ie.length;Be<Le;Be++){const Ke=Ie.charCodeAt(Be);if(Ke!==32&&Ke!==9)return Be}return-1}e.$$e=h;function r(Ie,Be=0,Le=Ie.length){for(let Ke=Be;Ke<Le;Ke++){const ne=Ie.charCodeAt(Ke);if(ne!==32&&ne!==9)return Ie.substring(Be,Ke)}return Ie.substring(Be,Le)}e.$_e=r;function a(Ie,Be=Ie.length-1){for(let Le=Be;Le>=0;Le--){const Ke=Ie.charCodeAt(Le);if(Ke!==32&&Ke!==9)return Le}return-1}e.$af=a;function d(Ie,Be,Le){const Ke=[];let ne=0;for(const oe of Ie.matchAll(Be)){if(Ke.push(Ie.slice(ne,oe.index)),oe.index===void 0)throw new Error("match.index should be defined");ne=oe.index+oe[0].length,Ke.push(Le(oe[0],...oe.slice(1),oe.index,Ie,oe.groups))}return Ke.push(Ie.slice(ne)),Promise.all(Ke).then(oe=>oe.join(""))}e.$bf=d;function $(Ie,Be){return Ie<Be?-1:Ie>Be?1:0}e.$cf=$;function D(Ie,Be,Le=0,Ke=Ie.length,ne=0,oe=Be.length){for(;Le<Ke&&ne<oe;Le++,ne++){const xe=Ie.charCodeAt(Le),nt=Be.charCodeAt(ne);if(xe<nt)return-1;if(xe>nt)return 1}const Ce=Ke-Le,Ge=oe-ne;return Ce<Ge?-1:Ce>Ge?1:0}e.$df=D;function b(Ie,Be){return g(Ie,Be,0,Ie.length,0,Be.length)}e.$ef=b;function g(Ie,Be,Le=0,Ke=Ie.length,ne=0,oe=Be.length){for(;Le<Ke&&ne<oe;Le++,ne++){let xe=Ie.charCodeAt(Le),nt=Be.charCodeAt(ne);if(xe===nt)continue;if(xe>=128||nt>=128)return D(Ie.toLowerCase(),Be.toLowerCase(),Le,Ke,ne,oe);P(xe)&&(xe-=32),P(nt)&&(nt-=32);const Ne=xe-nt;if(Ne!==0)return Ne}const Ce=Ke-Le,Ge=oe-ne;return Ce<Ge?-1:Ce>Ge?1:0}e.$ff=g;function y(Ie){return Ie>=48&&Ie<=57}e.$gf=y;function P(Ie){return Ie>=97&&Ie<=122}e.$hf=P;function N(Ie){return Ie>=65&&Ie<=90}e.$if=N;function U(Ie,Be){return Ie.length===Be.length&&g(Ie,Be)===0}e.$jf=U;function z(Ie,Be){const Le=Be.length;return Be.length>Ie.length?!1:g(Ie,Be,0,Le)===0}e.$kf=z;function F(Ie,Be){const Le=Math.min(Ie.length,Be.length);let Ke;for(Ke=0;Ke<Le;Ke++)if(Ie.charCodeAt(Ke)!==Be.charCodeAt(Ke))return Ke;return Le}e.$lf=F;function I(Ie,Be){const Le=Math.min(Ie.length,Be.length);let Ke;const ne=Ie.length-1,oe=Be.length-1;for(Ke=0;Ke<Le;Ke++)if(Ie.charCodeAt(ne-Ke)!==Be.charCodeAt(oe-Ke))return Ke;return Le}e.$mf=I;function O(Ie){return 55296<=Ie&&Ie<=56319}e.$nf=O;function T(Ie){return 56320<=Ie&&Ie<=57343}e.$of=T;function G(Ie,Be){return(Ie-55296<<10)+(Be-56320)+65536}e.$pf=G;function te(Ie,Be,Le){const Ke=Ie.charCodeAt(Le);if(O(Ke)&&Le+1<Be){const ne=Ie.charCodeAt(Le+1);if(T(ne))return G(Ke,ne)}return Ke}e.$qf=te;function x(Ie,Be){const Le=Ie.charCodeAt(Be-1);if(T(Le)&&Be>1){const Ke=Ie.charCodeAt(Be-2);if(O(Ke))return G(Ke,Le)}return Le}class X{get offset(){return this.e}constructor(Be,Le=0){this.c=Be,this.d=Be.length,this.e=Le}setOffset(Be){this.e=Be}prevCodePoint(){const Be=x(this.c,this.e);return this.e-=Be>=65536?2:1,Be}nextCodePoint(){const Be=te(this.c,this.d,this.e);return this.e+=Be>=65536?2:1,Be}eol(){return this.e>=this.d}}e.$rf=X;class Q{get offset(){return this.c.offset}constructor(Be,Le=0){this.c=new X(Be,Le)}nextGraphemeLength(){const Be=ve.getInstance(),Le=this.c,Ke=Le.offset;let ne=Be.getGraphemeBreakType(Le.nextCodePoint());for(;!Le.eol();){const oe=Le.offset,Ce=Be.getGraphemeBreakType(Le.nextCodePoint());if(J(ne,Ce)){Le.setOffset(oe);break}ne=Ce}return Le.offset-Ke}prevGraphemeLength(){const Be=ve.getInstance(),Le=this.c,Ke=Le.offset;let ne=Be.getGraphemeBreakType(Le.prevCodePoint());for(;Le.offset>0;){const oe=Le.offset,Ce=Be.getGraphemeBreakType(Le.prevCodePoint());if(J(Ce,ne)){Le.setOffset(oe);break}ne=Ce}return Ke-Le.offset}eol(){return this.c.eol()}}e.$sf=Q;function ae(Ie,Be){return new Q(Ie,Be).nextGraphemeLength()}e.$tf=ae;function _(Ie,Be){return new Q(Ie,Be).prevGraphemeLength()}e.$uf=_;function ge(Ie,Be){Be>0&&T(Ie.charCodeAt(Be))&&Be--;const Le=Be+ae(Ie,Be);return[Le-_(Ie,Le),Le]}e.$vf=ge;function se(Ie){const Be=new Q(Ie);let Le=0;for(;!Be.eol();)Le++,Be.nextGraphemeLength();return Le}e.$wf=se;let re;function B(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ie(Ie){return re||(re=B()),re.test(Ie)}e.$xf=ie;const ye=/^[\t\n\r\x20-\x7E]*$/;function le(Ie){return ye.test(Ie)}e.$yf=le,e.$zf=/[\u2028\u2029]/;function ue(Ie){return e.$zf.test(Ie)}e.$Af=ue;function ce(Ie){return Ie>=11904&&Ie<=55215||Ie>=63744&&Ie<=64255||Ie>=65281&&Ie<=65374}e.$Bf=ce;function de(Ie){return Ie>=127462&&Ie<=127487||Ie===8986||Ie===8987||Ie===9200||Ie===9203||Ie>=9728&&Ie<=10175||Ie===11088||Ie===11093||Ie>=127744&&Ie<=128591||Ie>=128640&&Ie<=128764||Ie>=128992&&Ie<=129008||Ie>=129280&&Ie<=129535||Ie>=129648&&Ie<=129782}e.$Cf=de;function H(Ie,Be,Le=""){const Ke=Ie.trimStart();if(Ke.length<Be)return Ke;const ne=/\b/g;let oe=0;for(;ne.test(Ke)&&!(Ke.length-ne.lastIndex<Be);)oe=ne.lastIndex,ne.lastIndex+=1;return oe===0?Ke:Le+Ke.substring(oe).trimStart()}e.$Df=H;const Z=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,he=/\x1b\].*?\x07/g;function be(Ie){return Ie&&(Ie=Ie.replace(Z,"").replace(he,"")),Ie}e.$Ef=be,e.$Ff="\uFEFF";function Pe(Ie){return!!(Ie&&Ie.length>0&&Ie.charCodeAt(0)===65279)}e.$Gf=Pe;function pe(Ie){return Pe(Ie)?Ie.substr(1):Ie}e.$Hf=pe;function Ae(Ie,Be){if(!Ie||!Be||Ie.length<Be.length)return!1;const Le=Be.length,Ke=Ie.toLowerCase();let ne=0,oe=-1;for(;ne<Le;){const Ce=Ke.indexOf(Be[ne],oe+1);if(Ce<0)return!1;oe=Ce,ne++}return!0}e.$If=Ae;function Oe(Ie,Be=!1){return Ie?(Be&&(Ie=Ie.replace(/\\./g,"")),Ie.toLowerCase()!==Ie):!1}e.$Jf=Oe;function ze(Ie){return Ie.charAt(0).toUpperCase()+Ie.slice(1)}e.$Kf=ze;function q(Ie,Be=1){if(Be===0)return"";let Le=-1;do Le=Ie.indexOf(`
`,Le+1),Be--;while(Be>0&&Le>=0);return Le===-1?Ie:(Ie[Le-1]==="\r"&&Le--,Ie.substr(0,Le))}e.$Lf=q;function W(Ie){return Ie=Ie%(2*26),Ie<26?String.fromCharCode(97+Ie):String.fromCharCode(65+Ie-26)}e.$Mf=W;function Y(Ie){return ve.getInstance().getGraphemeBreakType(Ie)}e.$Nf=Y;function J(Ie,Be){return Ie===0?Be!==5&&Be!==7:Ie===2&&Be===3?!1:Ie===4||Ie===2||Ie===3||Be===4||Be===2||Be===3?!0:!(Ie===8&&(Be===8||Be===9||Be===11||Be===12)||(Ie===11||Ie===9)&&(Be===9||Be===10)||(Ie===12||Ie===10)&&Be===10||Be===5||Be===13||Be===7||Ie===1||Ie===13&&Be===14||Ie===6&&Be===6)}var $e;(function(Ie){Ie[Ie.Other=0]="Other",Ie[Ie.Prepend=1]="Prepend",Ie[Ie.CR=2]="CR",Ie[Ie.LF=3]="LF",Ie[Ie.Control=4]="Control",Ie[Ie.Extend=5]="Extend",Ie[Ie.Regional_Indicator=6]="Regional_Indicator",Ie[Ie.SpacingMark=7]="SpacingMark",Ie[Ie.L=8]="L",Ie[Ie.V=9]="V",Ie[Ie.T=10]="T",Ie[Ie.LV=11]="LV",Ie[Ie.LVT=12]="LVT",Ie[Ie.ZWJ=13]="ZWJ",Ie[Ie.Extended_Pictographic=14]="Extended_Pictographic"})($e||(e.GraphemeBreakType=$e={}));class ve{static{this.c=null}static getInstance(){return ve.c||(ve.c=new ve),ve.c}constructor(){this.d=Fe()}getGraphemeBreakType(Be){if(Be<32)return Be===10?3:Be===13?2:4;if(Be<127)return 0;const Le=this.d,Ke=Le.length/3;let ne=1;for(;ne<=Ke;)if(Be<Le[3*ne])ne=2*ne;else if(Be>Le[3*ne+1])ne=2*ne+1;else return Le[3*ne+2];return 0}}function Fe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(Ie,Be){if(Ie===0)return 0;const Le=Qe(Ie,Be);if(Le!==void 0)return Le;const Ke=new X(Be,Ie);return Ke.prevCodePoint(),Ke.offset}e.$Of=He;function Qe(Ie,Be){const Le=new X(Be,Ie);let Ke=Le.prevCodePoint();for(;tt(Ke)||Ke===65039||Ke===8419;){if(Le.offset===0)return;Ke=Le.prevCodePoint()}if(!de(Ke))return;let ne=Le.offset;return ne>0&&Le.prevCodePoint()===8205&&(ne=Le.offset),ne}function tt(Ie){return 127995<=Ie&&Ie<=127999}var st;(function(Ie){Ie[Ie.zwj=8205]="zwj",Ie[Ie.emojiVariantSelector=65039]="emojiVariantSelector",Ie[Ie.enclosingKeyCap=8419]="enclosingKeyCap"})(st||(st={})),e.$Pf="\xA0";class ut{static{this.c=new j.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new l.$Oe(Be=>{function Le(Ne){const $t=new Map;for(let Dt=0;Dt<Ne.length;Dt+=2)$t.set(Ne[Dt],Ne[Dt+1]);return $t}function Ke(Ne,$t){const Dt=new Map(Ne);for(const[Pt,Tt]of $t)Dt.set(Pt,Tt);return Dt}function ne(Ne,$t){if(!Ne)return $t;const Dt=new Map;for(const[Pt,Tt]of Ne)$t.has(Pt)&&Dt.set(Pt,Tt);return Dt}const oe=this.c.value;let Ce=Be.filter(Ne=>!Ne.startsWith("_")&&Ne in oe);Ce.length===0&&(Ce=["_default"]);let Ge;for(const Ne of Ce){const $t=Le(oe[Ne]);Ge=ne(Ge,$t)}const xe=Le(oe._common),nt=Ke(xe,Ge);return new ut(nt)})}static getInstance(Be){return ut.d.get(Array.from(Be))}static{this.e=new j.$V(()=>Object.keys(ut.c.value).filter(Be=>!Be.startsWith("_")))}static getLocales(){return ut.e.value}constructor(Be){this.f=Be}isAmbiguous(Be){return this.f.has(Be)}getPrimaryConfusable(Be){return this.f.get(Be)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Qf=ut;class rt{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(rt.c())),this.d}static isInvisibleCharacter(Be){return rt.e().has(Be)}static get codePoints(){return rt.e()}}e.$Rf=rt}),define(Se[126],De([1,0,28,165,14]),function(fe,e,l,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ik=e.$hk=e.$gk=e.$fk=e.FuzzyScore=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=e.$6j=e.or=void 0;function A(...pe){return function(Ae,Oe){for(let ze=0,q=pe.length;ze<q;ze++){const W=pe[ze](Ae,Oe);if(W)return W}return null}}e.or=A,e.$6j=R.bind(void 0,!1),e.$7j=R.bind(void 0,!0);function R(pe,Ae,Oe){if(!Oe||Oe.length<Ae.length)return null;let ze;return pe?ze=L.$kf(Oe,Ae):ze=Oe.indexOf(Ae)===0,ze?Ae.length>0?[{start:0,end:Ae.length}]:[]:null}function p(pe,Ae){const Oe=Ae.toLowerCase().indexOf(pe.toLowerCase());return Oe===-1?null:[{start:Oe,end:Oe+pe.length}]}e.$8j=p;function w(pe,Ae){return E(pe.toLowerCase(),Ae.toLowerCase(),0,0)}e.$9j=w;function E(pe,Ae,Oe,ze){if(Oe===pe.length)return[];if(ze===Ae.length)return null;if(pe[Oe]===Ae[ze]){let q=null;return(q=E(pe,Ae,Oe+1,ze+1))?s({start:ze,end:ze+1},q):null}return E(pe,Ae,Oe,ze+1)}function M(pe){return 97<=pe&&pe<=122}function C(pe){return 65<=pe&&pe<=90}e.$0j=C;function v(pe){return 48<=pe&&pe<=57}function S(pe){return pe===32||pe===9||pe===10||pe===13}const k=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(pe=>k.add(pe.charCodeAt(0)));function u(pe){return S(pe)||k.has(pe)}function m(pe,Ae){return pe===Ae||u(pe)&&u(Ae)}const o=new Map;function i(pe){if(o.has(pe))return o.get(pe);let Ae;const Oe=(0,j.$4j)(pe);return Oe&&(Ae=Oe),o.set(pe,Ae),Ae}function n(pe){return M(pe)||C(pe)||v(pe)}function s(pe,Ae){return Ae.length===0?Ae=[pe]:pe.end===Ae[0].start?Ae[0].start=pe.start:Ae.unshift(pe),Ae}function c(pe,Ae){for(let Oe=Ae;Oe<pe.length;Oe++){const ze=pe.charCodeAt(Oe);if(C(ze)||v(ze)||Oe>0&&!n(pe.charCodeAt(Oe-1)))return Oe}return pe.length}function t(pe,Ae,Oe,ze){if(Oe===pe.length)return[];if(ze===Ae.length)return null;if(pe[Oe]!==Ae[ze].toLowerCase())return null;{let q=null,W=ze+1;for(q=t(pe,Ae,Oe+1,ze+1);!q&&(W=c(Ae,W))<Ae.length;)q=t(pe,Ae,Oe+1,W),W++;return q===null?null:s({start:ze,end:ze+1},q)}}function f(pe){let Ae=0,Oe=0,ze=0,q=0,W=0;for(let Fe=0;Fe<pe.length;Fe++)W=pe.charCodeAt(Fe),C(W)&&Ae++,M(W)&&Oe++,n(W)&&ze++,v(W)&&q++;const Y=Ae/pe.length,J=Oe/pe.length,$e=ze/pe.length,ve=q/pe.length;return{upperPercent:Y,lowerPercent:J,alphaPercent:$e,numericPercent:ve}}function h(pe){const{upperPercent:Ae,lowerPercent:Oe}=pe;return Oe===0&&Ae>.6}function r(pe){const{upperPercent:Ae,lowerPercent:Oe,alphaPercent:ze,numericPercent:q}=pe;return Oe>.2&&Ae<.8&&ze>.6&&q<.2}function a(pe){let Ae=0,Oe=0,ze=0,q=0;for(let W=0;W<pe.length;W++)ze=pe.charCodeAt(W),C(ze)&&Ae++,M(ze)&&Oe++,S(ze)&&q++;return(Ae===0||Oe===0)&&q===0?pe.length<=30:Ae<=5}function d(pe,Ae){if(!Ae||(Ae=Ae.trim(),Ae.length===0)||!a(pe))return null;Ae.length>60&&(Ae=Ae.substring(0,60));const Oe=f(Ae);if(!r(Oe)){if(!h(Oe))return null;Ae=Ae.toLowerCase()}let ze=null,q=0;for(pe=pe.toLowerCase();q<Ae.length&&(ze=t(pe,Ae,0,q))===null;)q=c(Ae,q+1);return ze}e.$$j=d;function $(pe,Ae,Oe=!1){if(!Ae||Ae.length===0)return null;let ze=null,q=0;for(pe=pe.toLowerCase(),Ae=Ae.toLowerCase();q<Ae.length&&(ze=D(pe,Ae,0,q,Oe),ze===null);)q=b(Ae,q+1);return ze}e.$_j=$;function D(pe,Ae,Oe,ze,q){let W=0;if(Oe===pe.length)return[];if(ze===Ae.length)return null;if(!m(pe.charCodeAt(Oe),Ae.charCodeAt(ze))){const $e=i(pe.charCodeAt(Oe));if(!$e)return null;for(let ve=0;ve<$e.length;ve++)if(!m($e[ve],Ae.charCodeAt(ze+ve)))return null;W+=$e.length-1}let Y=null,J=ze+W+1;if(Y=D(pe,Ae,Oe+1,J,q),!q)for(;!Y&&(J=b(Ae,J))<Ae.length;)Y=D(pe,Ae,Oe+1,J,q),J++;if(!Y)return null;if(pe.charCodeAt(Oe)!==Ae.charCodeAt(ze)){const $e=i(pe.charCodeAt(Oe));if(!$e)return Y;for(let ve=0;ve<$e.length;ve++)if($e[ve]!==Ae.charCodeAt(ze+ve))return Y}return s({start:ze,end:ze+W+1},Y)}function b(pe,Ae){for(let Oe=Ae;Oe<pe.length;Oe++)if(u(pe.charCodeAt(Oe))||Oe>0&&u(pe.charCodeAt(Oe-1)))return Oe;return pe.length}const g=A(e.$7j,d,p),y=A(e.$7j,d,w),P=new l.$Dc(1e4);function N(pe,Ae,Oe=!1){if(typeof pe!="string"||typeof Ae!="string")return null;let ze=P.get(pe);ze||(ze=new RegExp(L.$5e(pe),"i"),P.set(pe,ze));const q=ze.exec(Ae);return q?[{start:q.index,end:q.index+q[0].length}]:Oe?y(pe,Ae):g(pe,Ae)}e.$ak=N;function U(pe,Ae){const Oe=ce(pe,pe.toLowerCase(),0,Ae,Ae.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Oe?F(Oe):null}e.$bk=U;function z(pe,Ae,Oe,ze,q,W){const Y=Math.min(13,pe.length);for(;Oe<Y;Oe++){const J=ce(pe,Ae,Oe,ze,q,W,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(J)return J}return[0,W]}e.$ck=z;function F(pe){if(typeof pe>"u")return[];const Ae=[],Oe=pe[1];for(let ze=pe.length-1;ze>1;ze--){const q=pe[ze]+Oe,W=Ae[Ae.length-1];W&&W.end===q?W.end=q+1:Ae.push({start:q,end:q+1})}return Ae}e.$dk=F;const I=128;function O(){const pe=[],Ae=[];for(let Oe=0;Oe<=I;Oe++)Ae[Oe]=0;for(let Oe=0;Oe<=I;Oe++)pe.push(Ae.slice(0));return pe}function T(pe){const Ae=[];for(let Oe=0;Oe<=pe;Oe++)Ae[Oe]=0;return Ae}const G=T(2*I),te=T(2*I),x=O(),X=O(),Q=O(),ae=!1;function _(pe,Ae,Oe,ze,q){function W(J,$e,ve=" "){for(;J.length<$e;)J=ve+J;return J}let Y=` |   |${ze.split("").map(J=>W(J,3)).join("|")}
`;for(let J=0;J<=Oe;J++)J===0?Y+=" |":Y+=`${Ae[J-1]}|`,Y+=pe[J].slice(0,q+1).map($e=>W($e.toString(),3)).join("|")+`
`;return Y}function ge(pe,Ae,Oe,ze){pe=pe.substr(Ae),Oe=Oe.substr(ze),console.log(_(X,pe,pe.length,Oe,Oe.length)),console.log(_(Q,pe,pe.length,Oe,Oe.length)),console.log(_(x,pe,pe.length,Oe,Oe.length))}function se(pe,Ae){if(Ae<0||Ae>=pe.length)return!1;const Oe=pe.codePointAt(Ae);switch(Oe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!L.$Cf(Oe)}}function re(pe,Ae){if(Ae<0||Ae>=pe.length)return!1;switch(pe.charCodeAt(Ae)){case 32:case 9:return!0;default:return!1}}function B(pe,Ae,Oe){return Ae[pe]!==Oe[pe]}function ie(pe,Ae,Oe,ze,q,W,Y=!1){for(;Ae<Oe&&q<W;)pe[Ae]===ze[q]&&(Y&&(G[Ae]=q),Ae+=1),q+=1;return Ae===Oe}e.$ek=ie;var ye;(function(pe){pe[pe.Diag=1]="Diag",pe[pe.Left=2]="Left",pe[pe.LeftLeft=3]="LeftLeft"})(ye||(ye={}));var le;(function(pe){pe.Default=[-100,0];function Ae(Oe){return!Oe||Oe.length===2&&Oe[0]===-100&&Oe[1]===0}pe.isDefault=Ae})(le||(e.FuzzyScore=le={}));class ue{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ae,Oe){this.firstMatchCanBeWeak=Ae,this.boostFullMatch=Oe}}e.$fk=ue;function ce(pe,Ae,Oe,ze,q,W,Y=ue.default){const J=pe.length>I?I:pe.length,$e=ze.length>I?I:ze.length;if(Oe>=J||W>=$e||J-Oe>$e-W||!ie(Ae,Oe,J,q,W,$e,!0))return;de(J,$e,Oe,W,Ae,q);let ve=1,Fe=1,He=Oe,Qe=W;const tt=[!1];for(ve=1,He=Oe;He<J;ve++,He++){const Be=G[He],Le=te[He],Ke=He+1<J?te[He+1]:$e;for(Fe=Be-W+1,Qe=Be;Qe<Ke;Fe++,Qe++){let ne=Number.MIN_SAFE_INTEGER,oe=!1;Qe<=Le&&(ne=H(pe,Ae,He,Oe,ze,q,Qe,$e,W,x[ve-1][Fe-1]===0,tt));let Ce=0;ne!==Number.MAX_SAFE_INTEGER&&(oe=!0,Ce=ne+X[ve-1][Fe-1]);const Ge=Qe>Be,xe=Ge?X[ve][Fe-1]+(x[ve][Fe-1]>0?-5:0):0,nt=Qe>Be+1&&x[ve][Fe-1]>0,Ne=nt?X[ve][Fe-2]+(x[ve][Fe-2]>0?-5:0):0;if(nt&&(!Ge||Ne>=xe)&&(!oe||Ne>=Ce))X[ve][Fe]=Ne,Q[ve][Fe]=3,x[ve][Fe]=0;else if(Ge&&(!oe||xe>=Ce))X[ve][Fe]=xe,Q[ve][Fe]=2,x[ve][Fe]=0;else if(oe)X[ve][Fe]=Ce,Q[ve][Fe]=1,x[ve][Fe]=x[ve-1][Fe-1]+1;else throw new Error("not possible")}}if(ae&&ge(pe,Oe,ze,W),!tt[0]&&!Y.firstMatchCanBeWeak)return;ve--,Fe--;const st=[X[ve][Fe],W];let ut=0,rt=0;for(;ve>=1;){let Be=Fe;do{const Le=Q[ve][Be];if(Le===3)Be=Be-2;else if(Le===2)Be=Be-1;else break}while(Be>=1);ut>1&&Ae[Oe+ve-1]===q[W+Fe-1]&&!B(Be+W-1,ze,q)&&ut+1>x[ve][Be]&&(Be=Fe),Be===Fe?ut++:ut=1,rt||(rt=Be),ve--,Fe=Be-1,st.push(Fe)}$e===J&&Y.boostFullMatch&&(st[0]+=2);const Ie=rt-J;return st[0]-=Ie,st}e.$gk=ce;function de(pe,Ae,Oe,ze,q,W){let Y=pe-1,J=Ae-1;for(;Y>=Oe&&J>=ze;)q[Y]===W[J]&&(te[Y]=J,Y--),J--}function H(pe,Ae,Oe,ze,q,W,Y,J,$e,ve,Fe){if(Ae[Oe]!==W[Y])return Number.MIN_SAFE_INTEGER;let He=1,Qe=!1;return Y===Oe-ze?He=pe[Oe]===q[Y]?7:5:B(Y,q,W)&&(Y===0||!B(Y-1,q,W))?(He=pe[Oe]===q[Y]?7:5,Qe=!0):se(W,Y)&&(Y===0||!se(W,Y-1))?He=5:(se(W,Y-1)||re(W,Y-1))&&(He=5,Qe=!0),He>1&&Oe===ze&&(Fe[0]=!0),Qe||(Qe=B(Y,q,W)||se(W,Y-1)||re(W,Y-1)),Oe===ze?Y>$e&&(He-=Qe?3:5):ve?He+=Qe?2:0:He+=Qe?0:1,Y+1===J&&(He-=Qe?3:5),He}function Z(pe,Ae,Oe,ze,q,W,Y){return be(pe,Ae,Oe,ze,q,W,!0,Y)}e.$hk=Z;function he(pe,Ae,Oe,ze,q,W,Y){return be(pe,Ae,Oe,ze,q,W,!1,Y)}e.$ik=he;function be(pe,Ae,Oe,ze,q,W,Y,J){let $e=ce(pe,Ae,Oe,ze,q,W,J);if($e&&!Y)return $e;if(pe.length>=3){const ve=Math.min(7,pe.length-1);for(let Fe=Oe+1;Fe<ve;Fe++){const He=Pe(pe,Fe);if(He){const Qe=ce(He,He.toLowerCase(),Oe,ze,q,W,J);Qe&&(Qe[0]-=3,(!$e||Qe[0]>$e[0])&&($e=Qe))}}}return $e}function Pe(pe,Ae){if(Ae+1>=pe.length)return;const Oe=pe[Ae],ze=pe[Ae+1];if(Oe!==ze)return pe.slice(0,Ae)+ze+Oe+pe.slice(Ae+2)}}),define(Se[54],De([1,0,14]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=void 0;function j(o){return L(o,0)}e.$6i=j;function L(o,i){switch(typeof o){case"object":return o===null?A(349,i):Array.isArray(o)?w(o,i):E(o,i);case"string":return p(o,i);case"boolean":return R(o,i);case"number":return A(o,i);case"undefined":return A(937,i);default:return A(617,i)}}e.$7i=L;function A(o,i){return(i<<5)-i+o|0}e.$8i=A;function R(o,i){return A(o?433:863,i)}function p(o,i){i=A(149417,i);for(let n=0,s=o.length;n<s;n++)i=A(o.charCodeAt(n),i);return i}e.$9i=p;function w(o,i){return i=A(104579,i),o.reduce((n,s)=>L(s,n),i)}function E(o,i){return i=A(181387,i),Object.keys(o).sort().reduce((n,s)=>(n=p(s,n),L(o[s],n)),i)}class M{constructor(){this.g=0}get value(){return this.g}hash(i){return this.g=L(i,this.g),this.g}}e.$0i=M;var C;(function(o){o[o.BLOCK_SIZE=64]="BLOCK_SIZE",o[o.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function v(o,i,n=32){const s=n-i,c=~((1<<s)-1);return(o<<i|(c&o)>>>s)>>>0}function S(o,i=0,n=o.byteLength,s=0){for(let c=0;c<n;c++)o[i+c]=s}function k(o,i,n="0"){for(;o.length<i;)o=n+o;return o}function u(o,i=32){return o instanceof ArrayBuffer?Array.from(new Uint8Array(o)).map(n=>n.toString(16).padStart(2,"0")).join(""):k((o>>>0).toString(16),i/4)}e.$$i=u;class m{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(i){const n=i.length;if(n===0)return;const s=this.p;let c=this.r,t=this.u,f,h;for(t!==0?(f=t,h=-1,t=0):(f=i.charCodeAt(0),h=0);;){let r=f;if(l.$nf(f))if(h+1<n){const a=i.charCodeAt(h+1);l.$of(a)?(h++,r=l.$pf(f,a)):r=65533}else{t=f;break}else l.$of(f)&&(r=65533);if(c=this.w(s,c,r),h++,h<n)f=i.charCodeAt(h);else break}this.r=c,this.u=t}w(i,n,s){return s<128?i[n++]=s:s<2048?(i[n++]=192|(s&1984)>>>6,i[n++]=128|(s&63)>>>0):s<65536?(i[n++]=224|(s&61440)>>>12,i[n++]=128|(s&4032)>>>6,i[n++]=128|(s&63)>>>0):(i[n++]=240|(s&1835008)>>>18,i[n++]=128|(s&258048)>>>12,i[n++]=128|(s&4032)>>>6,i[n++]=128|(s&63)>>>0),n>=64&&(this.y(),n-=64,this.t+=64,i[0]=i[64],i[1]=i[65],i[2]=i[66]),n}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),u(this.h)+u(this.l)+u(this.m)+u(this.n)+u(this.o)}x(){this.p[this.r++]=128,S(this.p,this.r),this.r>56&&(this.y(),S(this.p));const i=8*this.t;this.q.setUint32(56,Math.floor(i/4294967296),!1),this.q.setUint32(60,i%4294967296,!1),this.y()}y(){const i=m.g,n=this.q;for(let $=0;$<64;$+=4)i.setUint32($,n.getUint32($,!1),!1);for(let $=64;$<320;$+=4)i.setUint32($,v(i.getUint32($-12,!1)^i.getUint32($-32,!1)^i.getUint32($-56,!1)^i.getUint32($-64,!1),1),!1);let s=this.h,c=this.l,t=this.m,f=this.n,h=this.o,r,a,d;for(let $=0;$<80;$++)$<20?(r=c&t|~c&f,a=1518500249):$<40?(r=c^t^f,a=1859775393):$<60?(r=c&t|c&f|t&f,a=2400959708):(r=c^t^f,a=3395469782),d=v(s,5)+r+h+a+i.getUint32($*4,!1)&4294967295,h=f,f=t,t=v(c,30),c=s,s=d;this.h=this.h+s&4294967295,this.l=this.l+c&4294967295,this.m=this.m+t&4294967295,this.n=this.n+f&4294967295,this.o=this.o+h&4294967295}}e.$_i=m}),define(Se[39],De([1,0,14]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var j;(function(L){L[L.Ignore=0]="Ignore",L[L.Info=1]="Info",L[L.Warning=2]="Warning",L[L.Error=3]="Error"})(j||(j={})),function(L){const A="error",R="warning",p="warn",w="info",E="ignore";function M(v){return v?l.$jf(A,v)?L.Error:l.$jf(R,v)||l.$jf(p,v)?L.Warning:l.$jf(w,v)?L.Info:L.Ignore:L.Ignore}L.fromValue=M;function C(v){switch(v){case L.Error:return A;case L.Warning:return R;case L.Info:return w;default:return E}}L.toString=C}(j||(j={})),e.default=j}),define(Se[167],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2d=void 0,e.$2d=Symbol("MicrotaskDelay")}),define(Se[76],De([1,0,19,14]),function(fe,e,l,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$li=e.$ki=e.$ji=e.$ii=e.$hi=void 0;class L{constructor(){this.b="",this.c=0}reset(S){return this.b=S,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(S){const k=S.charCodeAt(0),u=this.b.charCodeAt(this.c);return k-u}value(){return this.b[this.c]}}e.$hi=L;class A{constructor(S=!0){this.e=S}reset(S){return this.b=S,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let S=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(S)this.c++;else break;else S=!1;return this}cmp(S){return this.e?(0,j.$df)(S,this.b,0,S.length,this.c,this.d):(0,j.$ff)(S,this.b,0,S.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$ii=A;class R{constructor(S=!0,k=!0){this.f=S,this.g=k}reset(S){this.d=0,this.e=0,this.b=S,this.c=S.length;for(let k=S.length-1;k>=0;k--,this.c--){const u=this.b.charCodeAt(k);if(!(u===47||this.f&&u===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let S=!0;for(;this.e<this.c;this.e++){const k=this.b.charCodeAt(this.e);if(k===47||this.f&&k===92)if(S)this.d++;else break;else S=!1}return this}cmp(S){return this.g?(0,j.$df)(S,this.b,0,S.length,this.d,this.e):(0,j.$ff)(S,this.b,0,S.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$ji=R;var p;(function(v){v[v.Scheme=1]="Scheme",v[v.Authority=2]="Authority",v[v.Path=3]="Path",v[v.Query=4]="Query",v[v.Fragment=5]="Fragment"})(p||(p={}));class w{constructor(S,k){this.f=S,this.g=k,this.d=[],this.e=0}reset(S){return this.c=S,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(S)),this.b.reset(S.path),this.b.value()&&this.d.push(3)),this.g(S)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(S){if(this.d[this.e]===1)return(0,j.$ef)(S,this.c.scheme);if(this.d[this.e]===2)return(0,j.$ef)(S,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(S);if(this.d[this.e]===4)return(0,j.$cf)(S,this.c.query);if(this.d[this.e]===5)return(0,j.$cf)(S,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$ki=w;class E{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const S=this.right;return this.right=S.left,S.left=this,this.updateHeight(),S.updateHeight(),S}rotateRight(){const S=this.left;return this.left=S.right,S.right=this,this.updateHeight(),S.updateHeight(),S}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var M;(function(v){v[v.Left=-1]="Left",v[v.Mid=0]="Mid",v[v.Right=1]="Right"})(M||(M={}));class C{static forUris(S=()=>!1,k=()=>!1){return new C(new w(S,k))}static forPaths(S=!1){return new C(new R(void 0,!S))}static forStrings(){return new C(new L)}static forConfigKeys(){return new C(new A)}constructor(S){this.b=S}clear(){this.c=void 0}fill(S,k){if(k){const u=k.slice(0);(0,l.$Xb)(u);for(const m of u)this.set(m,S)}else{const u=S.slice(0);(0,l.$Xb)(u);for(const m of u)this.set(m[0],m[1])}}set(S,k){const u=this.b.reset(S);let m;this.c||(this.c=new E,this.c.segment=u.value());const o=[];for(m=this.c;;){const n=u.cmp(m.segment);if(n>0)m.left||(m.left=new E,m.left.segment=u.value()),o.push([-1,m]),m=m.left;else if(n<0)m.right||(m.right=new E,m.right.segment=u.value()),o.push([1,m]),m=m.right;else if(u.hasNext())u.next(),m.mid||(m.mid=new E,m.mid.segment=u.value()),o.push([0,m]),m=m.mid;else break}const i=m.value;m.value=k,m.key=S;for(let n=o.length-1;n>=0;n--){const s=o[n][1];s.updateHeight();const c=s.balanceFactor();if(c<-1||c>1){const t=o[n][0],f=o[n+1][0];if(t===1&&f===1)o[n][1]=s.rotateLeft();else if(t===-1&&f===-1)o[n][1]=s.rotateRight();else if(t===1&&f===-1)s.right=o[n+1][1]=o[n+1][1].rotateRight(),o[n][1]=s.rotateLeft();else if(t===-1&&f===1)s.left=o[n+1][1]=o[n+1][1].rotateLeft(),o[n][1]=s.rotateRight();else throw new Error;if(n>0)switch(o[n-1][0]){case-1:o[n-1][1].left=o[n][1];break;case 1:o[n-1][1].right=o[n][1];break;case 0:o[n-1][1].mid=o[n][1];break}else this.c=o[0][1]}}return i}get(S){return this.d(S)?.value}d(S){const k=this.b.reset(S);let u=this.c;for(;u;){const m=k.cmp(u.segment);if(m>0)u=u.left;else if(m<0)u=u.right;else if(k.hasNext())k.next(),u=u.mid;else break}return u}has(S){const k=this.d(S);return!(k?.value===void 0&&k?.mid===void 0)}delete(S){return this.e(S,!1)}deleteSuperstr(S){return this.e(S,!0)}e(S,k){const u=this.b.reset(S),m=[];let o=this.c;for(;o;){const i=u.cmp(o.segment);if(i>0)m.push([-1,o]),o=o.left;else if(i<0)m.push([1,o]),o=o.right;else if(u.hasNext())u.next(),m.push([0,o]),o=o.mid;else break}if(o){if(k?(o.left=void 0,o.mid=void 0,o.right=void 0,o.height=1):(o.key=void 0,o.value=void 0),!o.mid&&!o.value)if(o.left&&o.right){const i=this.f(o.right);if(i.key){const{key:n,value:s,segment:c}=i;this.e(i.key,!1),o.key=n,o.value=s,o.segment=c}}else{const i=o.left??o.right;if(m.length>0){const[n,s]=m[m.length-1];switch(n){case-1:s.left=i;break;case 0:s.mid=i;break;case 1:s.right=i;break}}else this.c=i}for(let i=m.length-1;i>=0;i--){const n=m[i][1];n.updateHeight();const s=n.balanceFactor();if(s>1?(n.right.balanceFactor()>=0||(n.right=n.right.rotateRight()),m[i][1]=n.rotateLeft()):s<-1&&(n.left.balanceFactor()<=0||(n.left=n.left.rotateLeft()),m[i][1]=n.rotateRight()),i>0)switch(m[i-1][0]){case-1:m[i-1][1].left=m[i][1];break;case 1:m[i-1][1].right=m[i][1];break;case 0:m[i-1][1].mid=m[i][1];break}else this.c=m[0][1]}}}f(S){for(;S.left;)S=S.left;return S}findSubstr(S){const k=this.b.reset(S);let u=this.c,m;for(;u;){const o=k.cmp(u.segment);if(o>0)u=u.left;else if(o<0)u=u.right;else if(k.hasNext())k.next(),m=u.value||m,u=u.mid;else break}return u&&u.value||m}findSuperstr(S){return this.g(S,!1)}g(S,k){const u=this.b.reset(S);let m=this.c;for(;m;){const o=u.cmp(m.segment);if(o>0)m=m.left;else if(o<0)m=m.right;else if(u.hasNext())u.next(),m=m.mid;else return m.mid?this.h(m.mid):k?m.value:void 0}}hasElementOrSubtree(S){return this.g(S,!0)!==void 0}forEach(S){for(const[k,u]of this)S(u,k)}*[Symbol.iterator](){yield*this.h(this.c)}h(S){const k=[];return this.j(S,k),k[Symbol.iterator]()}j(S,k){S&&(S.left&&this.j(S.left,k),S.value&&k.push([S.key,S.value]),S.mid&&this.j(S.mid,k),S.right&&this.j(S.right,k))}_isBalanced(){const S=k=>{if(!k)return!0;const u=k.balanceFactor();return u<-1||u>1?!1:S(k.left)&&S(k.right)};return S(this.c)}}e.$li=C}),define(Se[18],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=void 0;function l(c){return typeof c=="string"}e.$Sf=l;function j(c){return Array.isArray(c)&&c.every(t=>l(t))}e.$Tf=j;function L(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}e.$Uf=L;function A(c){const t=Object.getPrototypeOf(Uint8Array);return typeof c=="object"&&c instanceof t}e.$Vf=A;function R(c){return typeof c=="number"&&!isNaN(c)}e.$Wf=R;function p(c){return!!c&&typeof c[Symbol.iterator]=="function"}e.$Xf=p;function w(c){return c===!0||c===!1}e.$Yf=w;function E(c){return typeof c>"u"}e.$Zf=E;function M(c){return!C(c)}e.$1f=M;function C(c){return E(c)||c===null}e.$2f=C;function v(c,t){if(!c)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$3f=v;function S(c){if(C(c))throw new Error("Assertion Failed: argument is undefined or null");return c}e.$4f=S;function k(...c){const t=[];for(let f=0;f<c.length;f++){const h=c[f];if(C(h))throw new Error(`Assertion Failed: argument at index ${f} is undefined or null`);t.push(h)}return t}e.$5f=k;const u=Object.prototype.hasOwnProperty;function m(c){if(!L(c))return!1;for(const t in c)if(u.call(c,t))return!1;return!0}e.$6f=m;function o(c){return typeof c=="function"}e.$7f=o;function i(...c){return c.length>0&&c.every(o)}e.$8f=i;function n(c,t){const f=Math.min(c.length,t.length);for(let h=0;h<f;h++)s(c[h],t[h])}e.$9f=n;function s(c,t){if(l(t)){if(typeof c!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(o(t)){try{if(c instanceof t)return}catch{}if(!C(c)&&c.constructor===t||t.length===1&&t.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$0f=s}),define(Se[99],De([1,0,18]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kk=e.$jk=void 0;const j=Object.create(null);function L(R,p){if((0,l.$Sf)(p)){const w=j[p];if(w===void 0)throw new Error(`${R} references an unknown codicon: ${p}`);p=w}return j[R]=p,{id:R}}e.$jk=L;function A(){return j}e.$kk=A}),define(Se[168],De([1,0,99]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lk=void 0,e.$lk={add:(0,l.$jk)("add",6e4),plus:(0,l.$jk)("plus",6e4),gistNew:(0,l.$jk)("gist-new",6e4),repoCreate:(0,l.$jk)("repo-create",6e4),lightbulb:(0,l.$jk)("lightbulb",60001),lightBulb:(0,l.$jk)("light-bulb",60001),repo:(0,l.$jk)("repo",60002),repoDelete:(0,l.$jk)("repo-delete",60002),gistFork:(0,l.$jk)("gist-fork",60003),repoForked:(0,l.$jk)("repo-forked",60003),gitPullRequest:(0,l.$jk)("git-pull-request",60004),gitPullRequestAbandoned:(0,l.$jk)("git-pull-request-abandoned",60004),recordKeys:(0,l.$jk)("record-keys",60005),keyboard:(0,l.$jk)("keyboard",60005),tag:(0,l.$jk)("tag",60006),tagAdd:(0,l.$jk)("tag-add",60006),tagRemove:(0,l.$jk)("tag-remove",60006),gitPullRequestLabel:(0,l.$jk)("git-pull-request-label",60006),person:(0,l.$jk)("person",60007),personFollow:(0,l.$jk)("person-follow",60007),personOutline:(0,l.$jk)("person-outline",60007),personFilled:(0,l.$jk)("person-filled",60007),gitBranch:(0,l.$jk)("git-branch",60008),gitBranchCreate:(0,l.$jk)("git-branch-create",60008),gitBranchDelete:(0,l.$jk)("git-branch-delete",60008),sourceControl:(0,l.$jk)("source-control",60008),mirror:(0,l.$jk)("mirror",60009),mirrorPublic:(0,l.$jk)("mirror-public",60009),star:(0,l.$jk)("star",60010),starAdd:(0,l.$jk)("star-add",60010),starDelete:(0,l.$jk)("star-delete",60010),starEmpty:(0,l.$jk)("star-empty",60010),comment:(0,l.$jk)("comment",60011),commentAdd:(0,l.$jk)("comment-add",60011),alert:(0,l.$jk)("alert",60012),warning:(0,l.$jk)("warning",60012),search:(0,l.$jk)("search",60013),searchSave:(0,l.$jk)("search-save",60013),logOut:(0,l.$jk)("log-out",60014),signOut:(0,l.$jk)("sign-out",60014),logIn:(0,l.$jk)("log-in",60015),signIn:(0,l.$jk)("sign-in",60015),eye:(0,l.$jk)("eye",60016),eyeUnwatch:(0,l.$jk)("eye-unwatch",60016),eyeWatch:(0,l.$jk)("eye-watch",60016),circleFilled:(0,l.$jk)("circle-filled",60017),primitiveDot:(0,l.$jk)("primitive-dot",60017),closeDirty:(0,l.$jk)("close-dirty",60017),debugBreakpoint:(0,l.$jk)("debug-breakpoint",60017),debugBreakpointDisabled:(0,l.$jk)("debug-breakpoint-disabled",60017),debugBreakpointPending:(0,l.$jk)("debug-breakpoint-pending",60377),debugHint:(0,l.$jk)("debug-hint",60017),primitiveSquare:(0,l.$jk)("primitive-square",60018),edit:(0,l.$jk)("edit",60019),pencil:(0,l.$jk)("pencil",60019),info:(0,l.$jk)("info",60020),issueOpened:(0,l.$jk)("issue-opened",60020),gistPrivate:(0,l.$jk)("gist-private",60021),gitForkPrivate:(0,l.$jk)("git-fork-private",60021),lock:(0,l.$jk)("lock",60021),mirrorPrivate:(0,l.$jk)("mirror-private",60021),close:(0,l.$jk)("close",60022),removeClose:(0,l.$jk)("remove-close",60022),x:(0,l.$jk)("x",60022),repoSync:(0,l.$jk)("repo-sync",60023),sync:(0,l.$jk)("sync",60023),clone:(0,l.$jk)("clone",60024),desktopDownload:(0,l.$jk)("desktop-download",60024),beaker:(0,l.$jk)("beaker",60025),microscope:(0,l.$jk)("microscope",60025),vm:(0,l.$jk)("vm",60026),deviceDesktop:(0,l.$jk)("device-desktop",60026),file:(0,l.$jk)("file",60027),fileText:(0,l.$jk)("file-text",60027),more:(0,l.$jk)("more",60028),ellipsis:(0,l.$jk)("ellipsis",60028),kebabHorizontal:(0,l.$jk)("kebab-horizontal",60028),mailReply:(0,l.$jk)("mail-reply",60029),reply:(0,l.$jk)("reply",60029),organization:(0,l.$jk)("organization",60030),organizationFilled:(0,l.$jk)("organization-filled",60030),organizationOutline:(0,l.$jk)("organization-outline",60030),newFile:(0,l.$jk)("new-file",60031),fileAdd:(0,l.$jk)("file-add",60031),newFolder:(0,l.$jk)("new-folder",60032),fileDirectoryCreate:(0,l.$jk)("file-directory-create",60032),trash:(0,l.$jk)("trash",60033),trashcan:(0,l.$jk)("trashcan",60033),history:(0,l.$jk)("history",60034),clock:(0,l.$jk)("clock",60034),folder:(0,l.$jk)("folder",60035),fileDirectory:(0,l.$jk)("file-directory",60035),symbolFolder:(0,l.$jk)("symbol-folder",60035),logoGithub:(0,l.$jk)("logo-github",60036),markGithub:(0,l.$jk)("mark-github",60036),github:(0,l.$jk)("github",60036),terminal:(0,l.$jk)("terminal",60037),console:(0,l.$jk)("console",60037),repl:(0,l.$jk)("repl",60037),zap:(0,l.$jk)("zap",60038),symbolEvent:(0,l.$jk)("symbol-event",60038),error:(0,l.$jk)("error",60039),stop:(0,l.$jk)("stop",60039),variable:(0,l.$jk)("variable",60040),symbolVariable:(0,l.$jk)("symbol-variable",60040),array:(0,l.$jk)("array",60042),symbolArray:(0,l.$jk)("symbol-array",60042),symbolModule:(0,l.$jk)("symbol-module",60043),symbolPackage:(0,l.$jk)("symbol-package",60043),symbolNamespace:(0,l.$jk)("symbol-namespace",60043),symbolObject:(0,l.$jk)("symbol-object",60043),symbolMethod:(0,l.$jk)("symbol-method",60044),symbolFunction:(0,l.$jk)("symbol-function",60044),symbolConstructor:(0,l.$jk)("symbol-constructor",60044),symbolBoolean:(0,l.$jk)("symbol-boolean",60047),symbolNull:(0,l.$jk)("symbol-null",60047),symbolNumeric:(0,l.$jk)("symbol-numeric",60048),symbolNumber:(0,l.$jk)("symbol-number",60048),symbolStructure:(0,l.$jk)("symbol-structure",60049),symbolStruct:(0,l.$jk)("symbol-struct",60049),symbolParameter:(0,l.$jk)("symbol-parameter",60050),symbolTypeParameter:(0,l.$jk)("symbol-type-parameter",60050),symbolKey:(0,l.$jk)("symbol-key",60051),symbolText:(0,l.$jk)("symbol-text",60051),symbolReference:(0,l.$jk)("symbol-reference",60052),goToFile:(0,l.$jk)("go-to-file",60052),symbolEnum:(0,l.$jk)("symbol-enum",60053),symbolValue:(0,l.$jk)("symbol-value",60053),symbolRuler:(0,l.$jk)("symbol-ruler",60054),symbolUnit:(0,l.$jk)("symbol-unit",60054),activateBreakpoints:(0,l.$jk)("activate-breakpoints",60055),archive:(0,l.$jk)("archive",60056),arrowBoth:(0,l.$jk)("arrow-both",60057),arrowDown:(0,l.$jk)("arrow-down",60058),arrowLeft:(0,l.$jk)("arrow-left",60059),arrowRight:(0,l.$jk)("arrow-right",60060),arrowSmallDown:(0,l.$jk)("arrow-small-down",60061),arrowSmallLeft:(0,l.$jk)("arrow-small-left",60062),arrowSmallRight:(0,l.$jk)("arrow-small-right",60063),arrowSmallUp:(0,l.$jk)("arrow-small-up",60064),arrowUp:(0,l.$jk)("arrow-up",60065),bell:(0,l.$jk)("bell",60066),bold:(0,l.$jk)("bold",60067),book:(0,l.$jk)("book",60068),bookmark:(0,l.$jk)("bookmark",60069),debugBreakpointConditionalUnverified:(0,l.$jk)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,l.$jk)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,l.$jk)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,l.$jk)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,l.$jk)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,l.$jk)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,l.$jk)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,l.$jk)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,l.$jk)("debug-breakpoint-log-disabled",60075),briefcase:(0,l.$jk)("briefcase",60076),broadcast:(0,l.$jk)("broadcast",60077),browser:(0,l.$jk)("browser",60078),bug:(0,l.$jk)("bug",60079),calendar:(0,l.$jk)("calendar",60080),caseSensitive:(0,l.$jk)("case-sensitive",60081),check:(0,l.$jk)("check",60082),checklist:(0,l.$jk)("checklist",60083),chevronDown:(0,l.$jk)("chevron-down",60084),dropDownButton:(0,l.$jk)("drop-down-button",60084),chevronLeft:(0,l.$jk)("chevron-left",60085),chevronRight:(0,l.$jk)("chevron-right",60086),chevronUp:(0,l.$jk)("chevron-up",60087),chromeClose:(0,l.$jk)("chrome-close",60088),chromeMaximize:(0,l.$jk)("chrome-maximize",60089),chromeMinimize:(0,l.$jk)("chrome-minimize",60090),chromeRestore:(0,l.$jk)("chrome-restore",60091),circle:(0,l.$jk)("circle",60092),circleOutline:(0,l.$jk)("circle-outline",60092),debugBreakpointUnverified:(0,l.$jk)("debug-breakpoint-unverified",60092),circleSlash:(0,l.$jk)("circle-slash",60093),circuitBoard:(0,l.$jk)("circuit-board",60094),clearAll:(0,l.$jk)("clear-all",60095),clippy:(0,l.$jk)("clippy",60096),closeAll:(0,l.$jk)("close-all",60097),cloudDownload:(0,l.$jk)("cloud-download",60098),cloudUpload:(0,l.$jk)("cloud-upload",60099),code:(0,l.$jk)("code",60100),collapseAll:(0,l.$jk)("collapse-all",60101),colorMode:(0,l.$jk)("color-mode",60102),commentDiscussion:(0,l.$jk)("comment-discussion",60103),compareChanges:(0,l.$jk)("compare-changes",60157),creditCard:(0,l.$jk)("credit-card",60105),dash:(0,l.$jk)("dash",60108),dashboard:(0,l.$jk)("dashboard",60109),database:(0,l.$jk)("database",60110),debugContinue:(0,l.$jk)("debug-continue",60111),debugDisconnect:(0,l.$jk)("debug-disconnect",60112),debugPause:(0,l.$jk)("debug-pause",60113),debugRestart:(0,l.$jk)("debug-restart",60114),debugStart:(0,l.$jk)("debug-start",60115),debugStepInto:(0,l.$jk)("debug-step-into",60116),debugStepOut:(0,l.$jk)("debug-step-out",60117),debugStepOver:(0,l.$jk)("debug-step-over",60118),debugStop:(0,l.$jk)("debug-stop",60119),debug:(0,l.$jk)("debug",60120),deviceCameraVideo:(0,l.$jk)("device-camera-video",60121),deviceCamera:(0,l.$jk)("device-camera",60122),deviceMobile:(0,l.$jk)("device-mobile",60123),diffAdded:(0,l.$jk)("diff-added",60124),diffIgnored:(0,l.$jk)("diff-ignored",60125),diffModified:(0,l.$jk)("diff-modified",60126),diffRemoved:(0,l.$jk)("diff-removed",60127),diffRenamed:(0,l.$jk)("diff-renamed",60128),diff:(0,l.$jk)("diff",60129),discard:(0,l.$jk)("discard",60130),editorLayout:(0,l.$jk)("editor-layout",60131),emptyWindow:(0,l.$jk)("empty-window",60132),exclude:(0,l.$jk)("exclude",60133),extensions:(0,l.$jk)("extensions",60134),eyeClosed:(0,l.$jk)("eye-closed",60135),fileBinary:(0,l.$jk)("file-binary",60136),fileCode:(0,l.$jk)("file-code",60137),fileMedia:(0,l.$jk)("file-media",60138),filePdf:(0,l.$jk)("file-pdf",60139),fileSubmodule:(0,l.$jk)("file-submodule",60140),fileSymlinkDirectory:(0,l.$jk)("file-symlink-directory",60141),fileSymlinkFile:(0,l.$jk)("file-symlink-file",60142),fileZip:(0,l.$jk)("file-zip",60143),files:(0,l.$jk)("files",60144),filter:(0,l.$jk)("filter",60145),flame:(0,l.$jk)("flame",60146),foldDown:(0,l.$jk)("fold-down",60147),foldUp:(0,l.$jk)("fold-up",60148),fold:(0,l.$jk)("fold",60149),folderActive:(0,l.$jk)("folder-active",60150),folderOpened:(0,l.$jk)("folder-opened",60151),gear:(0,l.$jk)("gear",60152),gift:(0,l.$jk)("gift",60153),gistSecret:(0,l.$jk)("gist-secret",60154),gist:(0,l.$jk)("gist",60155),gitCommit:(0,l.$jk)("git-commit",60156),gitCompare:(0,l.$jk)("git-compare",60157),gitMerge:(0,l.$jk)("git-merge",60158),githubAction:(0,l.$jk)("github-action",60159),githubAlt:(0,l.$jk)("github-alt",60160),globe:(0,l.$jk)("globe",60161),grabber:(0,l.$jk)("grabber",60162),graph:(0,l.$jk)("graph",60163),gripper:(0,l.$jk)("gripper",60164),heart:(0,l.$jk)("heart",60165),home:(0,l.$jk)("home",60166),horizontalRule:(0,l.$jk)("horizontal-rule",60167),hubot:(0,l.$jk)("hubot",60168),inbox:(0,l.$jk)("inbox",60169),issueClosed:(0,l.$jk)("issue-closed",60324),issueReopened:(0,l.$jk)("issue-reopened",60171),issues:(0,l.$jk)("issues",60172),italic:(0,l.$jk)("italic",60173),jersey:(0,l.$jk)("jersey",60174),json:(0,l.$jk)("json",60175),bracket:(0,l.$jk)("bracket",60175),kebabVertical:(0,l.$jk)("kebab-vertical",60176),key:(0,l.$jk)("key",60177),law:(0,l.$jk)("law",60178),lightbulbAutofix:(0,l.$jk)("lightbulb-autofix",60179),linkExternal:(0,l.$jk)("link-external",60180),link:(0,l.$jk)("link",60181),listOrdered:(0,l.$jk)("list-ordered",60182),listUnordered:(0,l.$jk)("list-unordered",60183),liveShare:(0,l.$jk)("live-share",60184),loading:(0,l.$jk)("loading",60185),location:(0,l.$jk)("location",60186),mailRead:(0,l.$jk)("mail-read",60187),mail:(0,l.$jk)("mail",60188),markdown:(0,l.$jk)("markdown",60189),megaphone:(0,l.$jk)("megaphone",60190),mention:(0,l.$jk)("mention",60191),milestone:(0,l.$jk)("milestone",60192),gitPullRequestMilestone:(0,l.$jk)("git-pull-request-milestone",60192),mortarBoard:(0,l.$jk)("mortar-board",60193),move:(0,l.$jk)("move",60194),multipleWindows:(0,l.$jk)("multiple-windows",60195),mute:(0,l.$jk)("mute",60196),noNewline:(0,l.$jk)("no-newline",60197),note:(0,l.$jk)("note",60198),octoface:(0,l.$jk)("octoface",60199),openPreview:(0,l.$jk)("open-preview",60200),package:(0,l.$jk)("package",60201),paintcan:(0,l.$jk)("paintcan",60202),pin:(0,l.$jk)("pin",60203),play:(0,l.$jk)("play",60204),run:(0,l.$jk)("run",60204),plug:(0,l.$jk)("plug",60205),preserveCase:(0,l.$jk)("preserve-case",60206),preview:(0,l.$jk)("preview",60207),project:(0,l.$jk)("project",60208),pulse:(0,l.$jk)("pulse",60209),question:(0,l.$jk)("question",60210),quote:(0,l.$jk)("quote",60211),radioTower:(0,l.$jk)("radio-tower",60212),reactions:(0,l.$jk)("reactions",60213),references:(0,l.$jk)("references",60214),refresh:(0,l.$jk)("refresh",60215),regex:(0,l.$jk)("regex",60216),remoteExplorer:(0,l.$jk)("remote-explorer",60217),remote:(0,l.$jk)("remote",60218),remove:(0,l.$jk)("remove",60219),replaceAll:(0,l.$jk)("replace-all",60220),replace:(0,l.$jk)("replace",60221),repoClone:(0,l.$jk)("repo-clone",60222),repoForcePush:(0,l.$jk)("repo-force-push",60223),repoPull:(0,l.$jk)("repo-pull",60224),repoPush:(0,l.$jk)("repo-push",60225),report:(0,l.$jk)("report",60226),requestChanges:(0,l.$jk)("request-changes",60227),rocket:(0,l.$jk)("rocket",60228),rootFolderOpened:(0,l.$jk)("root-folder-opened",60229),rootFolder:(0,l.$jk)("root-folder",60230),rss:(0,l.$jk)("rss",60231),ruby:(0,l.$jk)("ruby",60232),saveAll:(0,l.$jk)("save-all",60233),saveAs:(0,l.$jk)("save-as",60234),save:(0,l.$jk)("save",60235),screenFull:(0,l.$jk)("screen-full",60236),screenNormal:(0,l.$jk)("screen-normal",60237),searchStop:(0,l.$jk)("search-stop",60238),server:(0,l.$jk)("server",60240),settingsGear:(0,l.$jk)("settings-gear",60241),settings:(0,l.$jk)("settings",60242),shield:(0,l.$jk)("shield",60243),smiley:(0,l.$jk)("smiley",60244),sortPrecedence:(0,l.$jk)("sort-precedence",60245),splitHorizontal:(0,l.$jk)("split-horizontal",60246),splitVertical:(0,l.$jk)("split-vertical",60247),squirrel:(0,l.$jk)("squirrel",60248),starFull:(0,l.$jk)("star-full",60249),starHalf:(0,l.$jk)("star-half",60250),symbolClass:(0,l.$jk)("symbol-class",60251),symbolColor:(0,l.$jk)("symbol-color",60252),symbolCustomColor:(0,l.$jk)("symbol-customcolor",60252),symbolConstant:(0,l.$jk)("symbol-constant",60253),symbolEnumMember:(0,l.$jk)("symbol-enum-member",60254),symbolField:(0,l.$jk)("symbol-field",60255),symbolFile:(0,l.$jk)("symbol-file",60256),symbolInterface:(0,l.$jk)("symbol-interface",60257),symbolKeyword:(0,l.$jk)("symbol-keyword",60258),symbolMisc:(0,l.$jk)("symbol-misc",60259),symbolOperator:(0,l.$jk)("symbol-operator",60260),symbolProperty:(0,l.$jk)("symbol-property",60261),wrench:(0,l.$jk)("wrench",60261),wrenchSubaction:(0,l.$jk)("wrench-subaction",60261),symbolSnippet:(0,l.$jk)("symbol-snippet",60262),tasklist:(0,l.$jk)("tasklist",60263),telescope:(0,l.$jk)("telescope",60264),textSize:(0,l.$jk)("text-size",60265),threeBars:(0,l.$jk)("three-bars",60266),thumbsdown:(0,l.$jk)("thumbsdown",60267),thumbsup:(0,l.$jk)("thumbsup",60268),tools:(0,l.$jk)("tools",60269),triangleDown:(0,l.$jk)("triangle-down",60270),triangleLeft:(0,l.$jk)("triangle-left",60271),triangleRight:(0,l.$jk)("triangle-right",60272),triangleUp:(0,l.$jk)("triangle-up",60273),twitter:(0,l.$jk)("twitter",60274),unfold:(0,l.$jk)("unfold",60275),unlock:(0,l.$jk)("unlock",60276),unmute:(0,l.$jk)("unmute",60277),unverified:(0,l.$jk)("unverified",60278),verified:(0,l.$jk)("verified",60279),versions:(0,l.$jk)("versions",60280),vmActive:(0,l.$jk)("vm-active",60281),vmOutline:(0,l.$jk)("vm-outline",60282),vmRunning:(0,l.$jk)("vm-running",60283),watch:(0,l.$jk)("watch",60284),whitespace:(0,l.$jk)("whitespace",60285),wholeWord:(0,l.$jk)("whole-word",60286),window:(0,l.$jk)("window",60287),wordWrap:(0,l.$jk)("word-wrap",60288),zoomIn:(0,l.$jk)("zoom-in",60289),zoomOut:(0,l.$jk)("zoom-out",60290),listFilter:(0,l.$jk)("list-filter",60291),listFlat:(0,l.$jk)("list-flat",60292),listSelection:(0,l.$jk)("list-selection",60293),selection:(0,l.$jk)("selection",60293),listTree:(0,l.$jk)("list-tree",60294),debugBreakpointFunctionUnverified:(0,l.$jk)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,l.$jk)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,l.$jk)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,l.$jk)("debug-stackframe-active",60297),circleSmallFilled:(0,l.$jk)("circle-small-filled",60298),debugStackframeDot:(0,l.$jk)("debug-stackframe-dot",60298),debugStackframe:(0,l.$jk)("debug-stackframe",60299),debugStackframeFocused:(0,l.$jk)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,l.$jk)("debug-breakpoint-unsupported",60300),symbolString:(0,l.$jk)("symbol-string",60301),debugReverseContinue:(0,l.$jk)("debug-reverse-continue",60302),debugStepBack:(0,l.$jk)("debug-step-back",60303),debugRestartFrame:(0,l.$jk)("debug-restart-frame",60304),callIncoming:(0,l.$jk)("call-incoming",60306),callOutgoing:(0,l.$jk)("call-outgoing",60307),menu:(0,l.$jk)("menu",60308),expandAll:(0,l.$jk)("expand-all",60309),feedback:(0,l.$jk)("feedback",60310),gitPullRequestReviewer:(0,l.$jk)("git-pull-request-reviewer",60310),groupByRefType:(0,l.$jk)("group-by-ref-type",60311),ungroupByRefType:(0,l.$jk)("ungroup-by-ref-type",60312),account:(0,l.$jk)("account",60313),gitPullRequestAssignee:(0,l.$jk)("git-pull-request-assignee",60313),bellDot:(0,l.$jk)("bell-dot",60314),debugConsole:(0,l.$jk)("debug-console",60315),library:(0,l.$jk)("library",60316),output:(0,l.$jk)("output",60317),runAll:(0,l.$jk)("run-all",60318),syncIgnored:(0,l.$jk)("sync-ignored",60319),pinned:(0,l.$jk)("pinned",60320),githubInverted:(0,l.$jk)("github-inverted",60321),debugAlt:(0,l.$jk)("debug-alt",60305),serverProcess:(0,l.$jk)("server-process",60322),serverEnvironment:(0,l.$jk)("server-environment",60323),pass:(0,l.$jk)("pass",60324),stopCircle:(0,l.$jk)("stop-circle",60325),playCircle:(0,l.$jk)("play-circle",60326),record:(0,l.$jk)("record",60327),debugAltSmall:(0,l.$jk)("debug-alt-small",60328),vmConnect:(0,l.$jk)("vm-connect",60329),cloud:(0,l.$jk)("cloud",60330),merge:(0,l.$jk)("merge",60331),exportIcon:(0,l.$jk)("export",60332),graphLeft:(0,l.$jk)("graph-left",60333),magnet:(0,l.$jk)("magnet",60334),notebook:(0,l.$jk)("notebook",60335),redo:(0,l.$jk)("redo",60336),checkAll:(0,l.$jk)("check-all",60337),pinnedDirty:(0,l.$jk)("pinned-dirty",60338),passFilled:(0,l.$jk)("pass-filled",60339),circleLargeFilled:(0,l.$jk)("circle-large-filled",60340),circleLarge:(0,l.$jk)("circle-large",60341),circleLargeOutline:(0,l.$jk)("circle-large-outline",60341),combine:(0,l.$jk)("combine",60342),gather:(0,l.$jk)("gather",60342),table:(0,l.$jk)("table",60343),variableGroup:(0,l.$jk)("variable-group",60344),typeHierarchy:(0,l.$jk)("type-hierarchy",60345),typeHierarchySub:(0,l.$jk)("type-hierarchy-sub",60346),typeHierarchySuper:(0,l.$jk)("type-hierarchy-super",60347),gitPullRequestCreate:(0,l.$jk)("git-pull-request-create",60348),runAbove:(0,l.$jk)("run-above",60349),runBelow:(0,l.$jk)("run-below",60350),notebookTemplate:(0,l.$jk)("notebook-template",60351),debugRerun:(0,l.$jk)("debug-rerun",60352),workspaceTrusted:(0,l.$jk)("workspace-trusted",60353),workspaceUntrusted:(0,l.$jk)("workspace-untrusted",60354),workspaceUnspecified:(0,l.$jk)("workspace-unspecified",60355),terminalCmd:(0,l.$jk)("terminal-cmd",60356),terminalDebian:(0,l.$jk)("terminal-debian",60357),terminalLinux:(0,l.$jk)("terminal-linux",60358),terminalPowershell:(0,l.$jk)("terminal-powershell",60359),terminalTmux:(0,l.$jk)("terminal-tmux",60360),terminalUbuntu:(0,l.$jk)("terminal-ubuntu",60361),terminalBash:(0,l.$jk)("terminal-bash",60362),arrowSwap:(0,l.$jk)("arrow-swap",60363),copy:(0,l.$jk)("copy",60364),personAdd:(0,l.$jk)("person-add",60365),filterFilled:(0,l.$jk)("filter-filled",60366),wand:(0,l.$jk)("wand",60367),debugLineByLine:(0,l.$jk)("debug-line-by-line",60368),inspect:(0,l.$jk)("inspect",60369),layers:(0,l.$jk)("layers",60370),layersDot:(0,l.$jk)("layers-dot",60371),layersActive:(0,l.$jk)("layers-active",60372),compass:(0,l.$jk)("compass",60373),compassDot:(0,l.$jk)("compass-dot",60374),compassActive:(0,l.$jk)("compass-active",60375),azure:(0,l.$jk)("azure",60376),issueDraft:(0,l.$jk)("issue-draft",60377),gitPullRequestClosed:(0,l.$jk)("git-pull-request-closed",60378),gitPullRequestDraft:(0,l.$jk)("git-pull-request-draft",60379),debugAll:(0,l.$jk)("debug-all",60380),debugCoverage:(0,l.$jk)("debug-coverage",60381),runErrors:(0,l.$jk)("run-errors",60382),folderLibrary:(0,l.$jk)("folder-library",60383),debugContinueSmall:(0,l.$jk)("debug-continue-small",60384),beakerStop:(0,l.$jk)("beaker-stop",60385),graphLine:(0,l.$jk)("graph-line",60386),graphScatter:(0,l.$jk)("graph-scatter",60387),pieChart:(0,l.$jk)("pie-chart",60388),bracketDot:(0,l.$jk)("bracket-dot",60389),bracketError:(0,l.$jk)("bracket-error",60390),lockSmall:(0,l.$jk)("lock-small",60391),azureDevops:(0,l.$jk)("azure-devops",60392),verifiedFilled:(0,l.$jk)("verified-filled",60393),newLine:(0,l.$jk)("newline",60394),layout:(0,l.$jk)("layout",60395),layoutActivitybarLeft:(0,l.$jk)("layout-activitybar-left",60396),layoutActivitybarRight:(0,l.$jk)("layout-activitybar-right",60397),layoutPanelLeft:(0,l.$jk)("layout-panel-left",60398),layoutPanelCenter:(0,l.$jk)("layout-panel-center",60399),layoutPanelJustify:(0,l.$jk)("layout-panel-justify",60400),layoutPanelRight:(0,l.$jk)("layout-panel-right",60401),layoutPanel:(0,l.$jk)("layout-panel",60402),layoutSidebarLeft:(0,l.$jk)("layout-sidebar-left",60403),layoutSidebarRight:(0,l.$jk)("layout-sidebar-right",60404),layoutStatusbar:(0,l.$jk)("layout-statusbar",60405),layoutMenubar:(0,l.$jk)("layout-menubar",60406),layoutCentered:(0,l.$jk)("layout-centered",60407),layoutSidebarRightOff:(0,l.$jk)("layout-sidebar-right-off",60416),layoutPanelOff:(0,l.$jk)("layout-panel-off",60417),layoutSidebarLeftOff:(0,l.$jk)("layout-sidebar-left-off",60418),target:(0,l.$jk)("target",60408),indent:(0,l.$jk)("indent",60409),recordSmall:(0,l.$jk)("record-small",60410),errorSmall:(0,l.$jk)("error-small",60411),arrowCircleDown:(0,l.$jk)("arrow-circle-down",60412),arrowCircleLeft:(0,l.$jk)("arrow-circle-left",60413),arrowCircleRight:(0,l.$jk)("arrow-circle-right",60414),arrowCircleUp:(0,l.$jk)("arrow-circle-up",60415),heartFilled:(0,l.$jk)("heart-filled",60420),map:(0,l.$jk)("map",60421),mapFilled:(0,l.$jk)("map-filled",60422),circleSmall:(0,l.$jk)("circle-small",60423),bellSlash:(0,l.$jk)("bell-slash",60424),bellSlashDot:(0,l.$jk)("bell-slash-dot",60425),commentUnresolved:(0,l.$jk)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,l.$jk)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,l.$jk)("git-pull-request-new-changes",60428),searchFuzzy:(0,l.$jk)("search-fuzzy",60429),commentDraft:(0,l.$jk)("comment-draft",60430),send:(0,l.$jk)("send",60431),sparkle:(0,l.$jk)("sparkle",60432),insert:(0,l.$jk)("insert",60433),mic:(0,l.$jk)("mic",60434),thumbsDownFilled:(0,l.$jk)("thumbsdown-filled",60435),thumbsUpFilled:(0,l.$jk)("thumbsup-filled",60436),coffee:(0,l.$jk)("coffee",60437),snake:(0,l.$jk)("snake",60438),game:(0,l.$jk)("game",60439),vr:(0,l.$jk)("vr",60440),chip:(0,l.$jk)("chip",60441),piano:(0,l.$jk)("piano",60442),music:(0,l.$jk)("music",60443),micFilled:(0,l.$jk)("mic-filled",60444),gitFetch:(0,l.$jk)("git-fetch",60445),copilot:(0,l.$jk)("copilot",60446),lightbulbSparkle:(0,l.$jk)("lightbulb-sparkle",60447),lightbulbSparkleAutofix:(0,l.$jk)("lightbulb-sparkle-autofix",60447),robot:(0,l.$jk)("robot",60448),sparkleFilled:(0,l.$jk)("sparkle-filled",60449),diffSingle:(0,l.$jk)("diff-single",60450),diffMultiple:(0,l.$jk)("diff-multiple",60451),surroundWith:(0,l.$jk)("surround-with",60452),gitStash:(0,l.$jk)("git-stash",60454),gitStashApply:(0,l.$jk)("git-stash-apply",60455),gitStashPop:(0,l.$jk)("git-stash-pop",60456),runAllCoverage:(0,l.$jk)("run-all-coverage",60461),runCoverage:(0,l.$jk)("run-all-coverage",60460),coverage:(0,l.$jk)("coverage",60462),githubProject:(0,l.$jk)("github-project",60463)}}),define(Se[77],De([1,0,99,168]),function(fe,e,l,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ok=e.$nk=e.$mk=void 0;function L(){return Object.values(e.$ok)}e.$mk=L,e.$nk={dialogError:(0,l.$jk)("dialog-error","error"),dialogWarning:(0,l.$jk)("dialog-warning","warning"),dialogInfo:(0,l.$jk)("dialog-info","info"),dialogClose:(0,l.$jk)("dialog-close","close"),treeItemExpanded:(0,l.$jk)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,l.$jk)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,l.$jk)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,l.$jk)("tree-filter-clear","close"),treeItemLoading:(0,l.$jk)("tree-item-loading","loading"),menuSelection:(0,l.$jk)("menu-selection","check"),menuSubmenu:(0,l.$jk)("menu-submenu","chevron-right"),menuBarMore:(0,l.$jk)("menubar-more","more"),scrollbarButtonLeft:(0,l.$jk)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,l.$jk)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,l.$jk)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,l.$jk)("scrollbar-button-down","triangle-down"),toolBarMore:(0,l.$jk)("toolbar-more","more"),quickInputBack:(0,l.$jk)("quick-input-back","arrow-left")},e.$ok={...j.$lk,...e.$nk}}),define(Se[24],De([1,0,18]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.$Ln=e.$Kn=void 0;function j(o){if(!o||typeof o!="object"||o instanceof RegExp)return o;const i=Array.isArray(o)?[]:{};return Object.entries(o).forEach(([n,s])=>{i[n]=s&&typeof s=="object"?j(s):s}),i}e.$Kn=j;function L(o){if(!o||typeof o!="object")return o;const i=[o];for(;i.length>0;){const n=i.shift();Object.freeze(n);for(const s in n)if(A.call(n,s)){const c=n[s];typeof c=="object"&&!Object.isFrozen(c)&&!(0,l.$Vf)(c)&&i.push(c)}}return o}e.$Ln=L;const A=Object.prototype.hasOwnProperty;function R(o,i){return p(o,i,new Set)}e.$Mn=R;function p(o,i,n){if((0,l.$2f)(o))return o;const s=i(o);if(typeof s<"u")return s;if(Array.isArray(o)){const c=[];for(const t of o)c.push(p(t,i,n));return c}if((0,l.$Uf)(o)){if(n.has(o))throw new Error("Cannot clone recursive data-structure");n.add(o);const c={};for(const t in o)A.call(o,t)&&(c[t]=p(o[t],i,n));return n.delete(o),c}return o}function w(o,i,n=!0){return(0,l.$Uf)(o)?((0,l.$Uf)(i)&&Object.keys(i).forEach(s=>{s in o?n&&((0,l.$Uf)(o[s])&&(0,l.$Uf)(i[s])?w(o[s],i[s],n):o[s]=i[s]):o[s]=i[s]}),o):i}e.$Nn=w;function E(o,i){if(o===i)return!0;if(o==null||i===null||i===void 0||typeof o!=typeof i||typeof o!="object"||Array.isArray(o)!==Array.isArray(i))return!1;let n,s;if(Array.isArray(o)){if(o.length!==i.length)return!1;for(n=0;n<o.length;n++)if(!E(o[n],i[n]))return!1}else{const c=[];for(s in o)c.push(s);c.sort();const t=[];for(s in i)t.push(s);if(t.sort(),!E(c,t))return!1;for(n=0;n<c.length;n++)if(!E(o[c[n]],i[c[n]]))return!1}return!0}e.$On=E;function M(o){const i=new Set;return JSON.stringify(o,(n,s)=>{if((0,l.$Uf)(s)||Array.isArray(s)){if(i.has(s))return"[Circular]";i.add(s)}return s})}e.$Pn=M;function C(o,i){const n=Object.create(null);return!o||!i||Object.keys(i).forEach(c=>{const t=o[c],f=i[c];E(t,f)||(n[c]=f)}),n}e.$Qn=C;function v(o,i){const n=i.toLowerCase(),s=Object.keys(o).find(c=>c.toLowerCase()===n);return s?o[s]:o[i]}e.$Rn=v;function S(o,i){const n=Object.create(null);for(const[s,c]of Object.entries(o))i(s,c)&&(n[s]=c);return n}e.$Sn=S;function k(o){let i=[];for(;Object.prototype!==o;)i=i.concat(Object.getOwnPropertyNames(o)),o=Object.getPrototypeOf(o);return i}e.$Tn=k;function u(o){const i=[];for(const n of k(o))typeof o[n]=="function"&&i.push(n);return i}e.$Un=u;function m(o,i){const n=c=>function(){const t=Array.prototype.slice.call(arguments,0);return i(c,t)},s={};for(const c of o)s[c]=n(c);return s}e.$Vn=m}),define(Se[55],De([1,0,77]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$pk=e.ThemeColor=void 0;var j;(function(R){function p(w){return w&&typeof w=="object"&&typeof w.id=="string"}R.isThemeColor=p})(j||(e.ThemeColor=j={}));function L(R){return{id:R}}e.$pk=L;var A;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const p=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function w(i){const n=p.exec(i.id);if(!n)return w(l.$ok.error);const[,s,c]=n,t=["codicon","codicon-"+s];return c&&t.push("codicon-modifier-"+c.substring(1)),t}R.asClassNameArray=w;function E(i){return w(i).join(" ")}R.asClassName=E;function M(i){return"."+w(i).join(".")}R.asCSSSelector=M;function C(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||j.isThemeColor(i.color))}R.isThemeIcon=C;const v=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function S(i){const n=v.exec(i);if(!n)return;const[,s]=n;return{id:s}}R.fromString=S;function k(i){return{id:i}}R.fromId=k;function u(i,n){let s=i.id;const c=s.lastIndexOf("~");return c!==-1&&(s=s.substring(0,c)),n&&(s=`${s}~${n}`),{id:s}}R.modify=u;function m(i){const n=i.id.lastIndexOf("~");if(n!==-1)return i.id.substring(n+1)}R.getModifier=m;function o(i,n){return i.id===n.id&&i.color?.id===n.color?.id}R.isEqual=o})(A||(e.ThemeIcon=A={}))}),define(Se[169],De([1,0,126,14,55]),function(fe,e,l,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=void 0;const A="$(",R=new RegExp(`\\$\\(${L.ThemeIcon.iconNameExpression}(?:${L.ThemeIcon.iconModifierExpression})?\\)`,"g"),p=new RegExp(`(\\\\)?${R.source}`,"g");function w(o){return o.replace(p,(i,n)=>n?i:`\\${i}`)}e.$qk=w;const E=new RegExp(`\\\\${R.source}`,"g");function M(o){return o.replace(E,i=>`\\${i}`)}e.$rk=M;const C=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function v(o){return o.indexOf(A)===-1?o:o.replace(C,(i,n,s,c)=>s?i:n||c||"")}e.$sk=v;function S(o){return o?o.replace(/\$\((.*?)\)/g,(i,n)=>` ${n} `).trim():""}e.$tk=S;const k=new RegExp(`\\$\\(${L.ThemeIcon.iconNameCharacter}+\\)`,"g");function u(o){k.lastIndex=0;let i="";const n=[];let s=0;for(;;){const c=k.lastIndex,t=k.exec(o),f=o.substring(c,t?.index);if(f.length>0){i+=f;for(let h=0;h<f.length;h++)n.push(s)}if(!t)break;s+=t[0].length}return{text:i,iconOffsets:n}}e.$uk=u;function m(o,i,n=!1){const{text:s,iconOffsets:c}=i;if(!c||c.length===0)return(0,l.$ak)(o,s,n);const t=(0,j.$3e)(s," "),f=s.length-t.length,h=(0,l.$ak)(o,t,n);if(h)for(const r of h){const a=c[r.start+f]+f;r.start+=a,r.end+=a}return h}e.$vk=m}),define(Se[127],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Re=e.$Qe=e.Constants=void 0;var l;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(l||(e.Constants=l={}));function j(A){return A<0?0:A>255?255:A|0}e.$Qe=j;function L(A){return A<0?0:A>4294967295?4294967295:A|0}e.$Re=L}),define(Se[30],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bg=e.$Ag=void 0;const l=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function j(L){return l.test(L)}e.$Ag=j,e.$Bg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let L;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?L=crypto.getRandomValues.bind(crypto):L=function(p){for(let w=0;w<p.length;w++)p[w]=Math.floor(Math.random()*256);return p};const A=new Uint8Array(16),R=[];for(let p=0;p<256;p++)R.push(p.toString(16).padStart(2,"0"));return function(){L(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let w=0,E="";return E+=R[A[w++]],E+=R[A[w++]],E+=R[A[w++]],E+=R[A[w++]],E+="-",E+=R[A[w++]],E+=R[A[w++]],E+="-",E+=R[A[w++]],E+=R[A[w++]],E+="-",E+=R[A[w++]],E+=R[A[w++]],E+="-",E+=R[A[w++]],E+=R[A[w++]],E+=R[A[w++]],E+=R[A[w++]],E+=R[A[w++]],E+=R[A[w++]],E}}()}),define(Se[170],De([1,0,19,48,30]),function(fe,e,l,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ft=e.$Et=e.$Dt=e.$Ct=e.$Bt=void 0;function A(C){return{asString:async()=>C,asFile:()=>{},value:typeof C=="string"?C:void 0}}e.$Bt=A;function R(C,v,S){const k={id:(0,L.$Bg)(),name:C,uri:v,data:S};return{asString:async()=>"",asFile:()=>k,value:void 0}}e.$Ct=R;class p{constructor(){this.a=new Map}get size(){let v=0;for(const S of this.a)v++;return v}has(v){return this.a.has(this.b(v))}matches(v){const S=[...this.a.keys()];return j.Iterable.some(this,([k,u])=>u.asFile())&&S.push("files"),M(w(v),S)}get(v){return this.a.get(this.b(v))?.[0]}append(v,S){const k=this.a.get(v);k?k.push(S):this.a.set(this.b(v),[S])}replace(v,S){this.a.set(this.b(v),[S])}delete(v){this.a.delete(this.b(v))}*[Symbol.iterator](){for(const[v,S]of this.a)for(const k of S)yield[v,k]}b(v){return w(v)}}e.$Dt=p;function w(C){return C.toLowerCase()}function E(C,v){return M(w(C),v.map(w))}e.$Et=E;function M(C,v){if(C==="*/*")return v.length>0;if(v.includes(C))return!0;const S=C.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!S)return!1;const[k,u,m]=S;return m==="*"?v.some(o=>o.startsWith(u+"/")):!1}e.$Ft=Object.freeze({create:C=>(0,l.$Mb)(C.map(v=>v.toString())).join(`\r
`),split:C=>C.split(`\r
`),parse:C=>e.$Ft.split(C).filter(v=>!v.startsWith("#"))})}),define(Se[171],De([1,0,62]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fg=e.$Eg=e.$Dg=void 0;function j(p,w,E,M=1){let C=!1;return new Promise(v=>{const S=setTimeout(()=>{if(!C)return C=!0,v(0)},E);L(p,w,M,k=>{if(!C)return C=!0,clearTimeout(S),v(k)})})}e.$Dg=j;function L(p,w,E,M){if(w===0)return M(0);const C=new l.Socket;C.once("connect",()=>(R(C),L(p+E,w-1,E,M))),C.once("data",()=>{}),C.once("error",v=>(R(C),v.code!=="ECONNREFUSED"?L(p+E,w-1,E,M):M(p))),C.connect(p,"127.0.0.1")}e.$Eg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(p,w,E,M="127.0.0.1"){let C=!1,v,S=1;const k=l.createServer({pauseOnConnect:!0});function u(m,o){C||(C=!0,k.removeAllListeners(),k.close(),v&&clearTimeout(v),o(m))}return new Promise(m=>{v=setTimeout(()=>{u(0,m)},E),k.on("listening",()=>{u(p,m)}),k.on("error",o=>{o&&(o.code==="EADDRINUSE"||o.code==="EACCES")&&S<w?(p++,S++,k.listen(p,M)):u(0,m)}),k.on("close",()=>{u(0,m)}),k.listen(p,M)})}e.$Fg=A;function R(p){try{p.removeAllListeners("connect"),p.removeAllListeners("error"),p.end(),p.destroy(),p.unref()}catch(w){console.error(w)}}}),define(Se[128],De([1,0,127]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ut=e.$tt=void 0;class j{constructor(p){const w=(0,l.$Qe)(p);this.c=w,this.a=j.d(w),this.b=new Map}static d(p){const w=new Uint8Array(256);return w.fill(p),w}set(p,w){const E=(0,l.$Qe)(w);p>=0&&p<256?this.a[p]=E:this.b.set(p,E)}get(p){return p>=0&&p<256?this.a[p]:this.b.get(p)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$tt=j;var L;(function(R){R[R.False=0]="False",R[R.True=1]="True"})(L||(L={}));class A{constructor(){this.a=new j(0)}add(p){this.a.set(p,1)}has(p){return this.a.get(p)===1}clear(){return this.a.clear()}}e.$ut=A}),define(Se[172],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$It=e.StringEOL=void 0;var l;(function(L){L[L.Unknown=0]="Unknown",L[L.Invalid=3]="Invalid",L[L.LF=1]="LF",L[L.CRLF=2]="CRLF"})(l||(e.StringEOL=l={}));function j(L){let A=0,R=0,p=0,w=0;for(let E=0,M=L.length;E<M;E++){const C=L.charCodeAt(E);C===13?(A===0&&(R=E),A++,E+1<M&&L.charCodeAt(E+1)===10?(w|=2,E++):w|=3,p=E+1):C===10&&(w|=1,A===0&&(R=E),A++,p=E+1)}return A===0&&(R=L.length),[A,R,L.length-p,w]}e.$It=j}),define(Se[49],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8s=void 0;class l{constructor(L,A){this.lineNumber=L,this.column=A}with(L=this.lineNumber,A=this.column){return L===this.lineNumber&&A===this.column?this:new l(L,A)}delta(L=0,A=0){return this.with(this.lineNumber+L,this.column+A)}equals(L){return l.equals(this,L)}static equals(L,A){return!L&&!A?!0:!!L&&!!A&&L.lineNumber===A.lineNumber&&L.column===A.column}isBefore(L){return l.isBefore(this,L)}static isBefore(L,A){return L.lineNumber<A.lineNumber?!0:A.lineNumber<L.lineNumber?!1:L.column<A.column}isBeforeOrEqual(L){return l.isBeforeOrEqual(this,L)}static isBeforeOrEqual(L,A){return L.lineNumber<A.lineNumber?!0:A.lineNumber<L.lineNumber?!1:L.column<=A.column}static compare(L,A){const R=L.lineNumber|0,p=A.lineNumber|0;if(R===p){const w=L.column|0,E=A.column|0;return w-E}return R-p}clone(){return new l(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(L){return new l(L.lineNumber,L.column)}static isIPosition(L){return L&&typeof L.lineNumber=="number"&&typeof L.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$8s=l}),define(Se[29],De([1,0,49]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9s=void 0;class j{constructor(A,R,p,w){A>p||A===p&&R>w?(this.startLineNumber=p,this.startColumn=w,this.endLineNumber=A,this.endColumn=R):(this.startLineNumber=A,this.startColumn=R,this.endLineNumber=p,this.endColumn=w)}isEmpty(){return j.isEmpty(this)}static isEmpty(A){return A.startLineNumber===A.endLineNumber&&A.startColumn===A.endColumn}containsPosition(A){return j.containsPosition(this,A)}static containsPosition(A,R){return!(R.lineNumber<A.startLineNumber||R.lineNumber>A.endLineNumber||R.lineNumber===A.startLineNumber&&R.column<A.startColumn||R.lineNumber===A.endLineNumber&&R.column>A.endColumn)}static strictContainsPosition(A,R){return!(R.lineNumber<A.startLineNumber||R.lineNumber>A.endLineNumber||R.lineNumber===A.startLineNumber&&R.column<=A.startColumn||R.lineNumber===A.endLineNumber&&R.column>=A.endColumn)}containsRange(A){return j.containsRange(this,A)}static containsRange(A,R){return!(R.startLineNumber<A.startLineNumber||R.endLineNumber<A.startLineNumber||R.startLineNumber>A.endLineNumber||R.endLineNumber>A.endLineNumber||R.startLineNumber===A.startLineNumber&&R.startColumn<A.startColumn||R.endLineNumber===A.endLineNumber&&R.endColumn>A.endColumn)}strictContainsRange(A){return j.strictContainsRange(this,A)}static strictContainsRange(A,R){return!(R.startLineNumber<A.startLineNumber||R.endLineNumber<A.startLineNumber||R.startLineNumber>A.endLineNumber||R.endLineNumber>A.endLineNumber||R.startLineNumber===A.startLineNumber&&R.startColumn<=A.startColumn||R.endLineNumber===A.endLineNumber&&R.endColumn>=A.endColumn)}plusRange(A){return j.plusRange(this,A)}static plusRange(A,R){let p,w,E,M;return R.startLineNumber<A.startLineNumber?(p=R.startLineNumber,w=R.startColumn):R.startLineNumber===A.startLineNumber?(p=R.startLineNumber,w=Math.min(R.startColumn,A.startColumn)):(p=A.startLineNumber,w=A.startColumn),R.endLineNumber>A.endLineNumber?(E=R.endLineNumber,M=R.endColumn):R.endLineNumber===A.endLineNumber?(E=R.endLineNumber,M=Math.max(R.endColumn,A.endColumn)):(E=A.endLineNumber,M=A.endColumn),new j(p,w,E,M)}intersectRanges(A){return j.intersectRanges(this,A)}static intersectRanges(A,R){let p=A.startLineNumber,w=A.startColumn,E=A.endLineNumber,M=A.endColumn;const C=R.startLineNumber,v=R.startColumn,S=R.endLineNumber,k=R.endColumn;return p<C?(p=C,w=v):p===C&&(w=Math.max(w,v)),E>S?(E=S,M=k):E===S&&(M=Math.min(M,k)),p>E||p===E&&w>M?null:new j(p,w,E,M)}equalsRange(A){return j.equalsRange(this,A)}static equalsRange(A,R){return!A&&!R?!0:!!A&&!!R&&A.startLineNumber===R.startLineNumber&&A.startColumn===R.startColumn&&A.endLineNumber===R.endLineNumber&&A.endColumn===R.endColumn}getEndPosition(){return j.getEndPosition(this)}static getEndPosition(A){return new l.$8s(A.endLineNumber,A.endColumn)}getStartPosition(){return j.getStartPosition(this)}static getStartPosition(A){return new l.$8s(A.startLineNumber,A.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(A,R){return new j(this.startLineNumber,this.startColumn,A,R)}setStartPosition(A,R){return new j(A,R,this.endLineNumber,this.endColumn)}collapseToStart(){return j.collapseToStart(this)}static collapseToStart(A){return new j(A.startLineNumber,A.startColumn,A.startLineNumber,A.startColumn)}collapseToEnd(){return j.collapseToEnd(this)}static collapseToEnd(A){return new j(A.endLineNumber,A.endColumn,A.endLineNumber,A.endColumn)}delta(A){return new j(this.startLineNumber+A,this.startColumn,this.endLineNumber+A,this.endColumn)}static fromPositions(A,R=A){return new j(A.lineNumber,A.column,R.lineNumber,R.column)}static lift(A){return A?new j(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):null}static isIRange(A){return A&&typeof A.startLineNumber=="number"&&typeof A.startColumn=="number"&&typeof A.endLineNumber=="number"&&typeof A.endColumn=="number"}static areIntersectingOrTouching(A,R){return!(A.endLineNumber<R.startLineNumber||A.endLineNumber===R.startLineNumber&&A.endColumn<R.startColumn||R.endLineNumber<A.startLineNumber||R.endLineNumber===A.startLineNumber&&R.endColumn<A.startColumn)}static areIntersecting(A,R){return!(A.endLineNumber<R.startLineNumber||A.endLineNumber===R.startLineNumber&&A.endColumn<=R.startColumn||R.endLineNumber<A.startLineNumber||R.endLineNumber===A.startLineNumber&&R.endColumn<=A.startColumn)}static compareRangesUsingStarts(A,R){if(A&&R){const E=A.startLineNumber|0,M=R.startLineNumber|0;if(E===M){const C=A.startColumn|0,v=R.startColumn|0;if(C===v){const S=A.endLineNumber|0,k=R.endLineNumber|0;if(S===k){const u=A.endColumn|0,m=R.endColumn|0;return u-m}return S-k}return C-v}return E-M}return(A?1:0)-(R?1:0)}static compareRangesUsingEnds(A,R){return A.endLineNumber===R.endLineNumber?A.endColumn===R.endColumn?A.startLineNumber===R.startLineNumber?A.startColumn-R.startColumn:A.startLineNumber-R.startLineNumber:A.endColumn-R.endColumn:A.endLineNumber-R.endLineNumber}static spansMultipleLines(A){return A.endLineNumber>A.startLineNumber}toJSON(){return this}}e.$9s=j}),define(Se[173],De([1,0,29]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0s=void 0;class j{static insert(A,R){return{range:new l.$9s(A.lineNumber,A.column,A.lineNumber,A.column),text:R,forceMoveMarkers:!0}}static delete(A){return{range:A,text:null}}static replace(A,R){return{range:A,text:R}}static replaceMove(A,R){return{range:A,text:R,forceMoveMarkers:!0}}}e.$0s=j}),define(Se[174],De([1,0,49,29]),function(fe,e,l,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$s=e.SelectionDirection=void 0;var L;(function(R){R[R.LTR=0]="LTR",R[R.RTL=1]="RTL"})(L||(e.SelectionDirection=L={}));class A extends j.$9s{constructor(p,w,E,M){super(p,w,E,M),this.selectionStartLineNumber=p,this.selectionStartColumn=w,this.positionLineNumber=E,this.positionColumn=M}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(p){return A.selectionsEqual(this,p)}static selectionsEqual(p,w){return p.selectionStartLineNumber===w.selectionStartLineNumber&&p.selectionStartColumn===w.selectionStartColumn&&p.positionLineNumber===w.positionLineNumber&&p.positionColumn===w.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(p,w){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,p,w):new A(p,w,this.startLineNumber,this.startColumn)}getPosition(){return new l.$8s(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new l.$8s(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(p,w){return this.getDirection()===0?new A(p,w,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,p,w)}static fromPositions(p,w=p){return new A(p.lineNumber,p.column,w.lineNumber,w.column)}static fromRange(p,w){return w===0?new A(p.startLineNumber,p.startColumn,p.endLineNumber,p.endColumn):new A(p.endLineNumber,p.endColumn,p.startLineNumber,p.startColumn)}static liftSelection(p){return new A(p.selectionStartLineNumber,p.selectionStartColumn,p.positionLineNumber,p.positionColumn)}static selectionsArrEqual(p,w){if(p&&!w||!p&&w)return!1;if(!p&&!w)return!0;if(p.length!==w.length)return!1;for(let E=0,M=p.length;E<M;E++)if(!this.selectionsEqual(p[E],w[E]))return!1;return!0}static isISelection(p){return p&&typeof p.selectionStartLineNumber=="number"&&typeof p.selectionStartColumn=="number"&&typeof p.positionLineNumber=="number"&&typeof p.positionColumn=="number"}static createWithDirection(p,w,E,M,C){return C===0?new A(p,w,E,M):new A(E,M,p,w)}}e.$$s=A}),define(Se[175],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gs=void 0,e.$Gs={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Se[176],De([1,0,128]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wt=e.$vt=e.WordCharacterClass=void 0;var j;(function(R){R[R.Regular=0]="Regular",R[R.Whitespace=1]="Whitespace",R[R.WordSeparator=2]="WordSeparator"})(j||(e.WordCharacterClass=j={}));class L extends l.$tt{constructor(p){super(0);for(let w=0,E=p.length;w<E;w++)this.set(p.charCodeAt(w),2);this.set(32,1),this.set(9,1)}}e.$vt=L;function A(R){const p={};return w=>(p.hasOwnProperty(w)||(p[w]=R(w)),p[w])}e.$wt=A(R=>new L(R))}),define(Se[129],De([1,0,48,3,74]),function(fe,e,l,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ls=e.$Ks=e.$Js=e.$Is=e.$Hs=void 0,e.$Hs="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function A(C=""){let v="(-?\\d*\\.\\d\\w*)|([^";for(const S of e.$Hs)C.indexOf(S)>=0||(v+="\\"+S);return v+="\\s]+)",new RegExp(v,"g")}e.$Is=A();function R(C){let v=e.$Is;if(C&&C instanceof RegExp)if(C.global)v=C;else{let S="g";C.ignoreCase&&(S+="i"),C.multiline&&(S+="m"),C.unicode&&(S+="u"),v=new RegExp(C.source,S)}return v.lastIndex=0,v}e.$Js=R;const p=new L.$4c;p.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function w(C){const v=p.unshift(C);return(0,j.$Rc)(v)}e.$Ks=w;function E(C,v,S,k,u){if(v=R(v),u||(u=l.Iterable.first(p)),S.length>u.maxLen){let s=C-u.maxLen/2;return s<0?s=0:k+=s,S=S.substring(s,C+u.maxLen/2),E(C,v,S,k,u)}const m=Date.now(),o=C-1-k;let i=-1,n=null;for(let s=1;!(Date.now()-m>=u.timeBudget);s++){const c=o-u.windowSize*s;v.lastIndex=Math.max(0,c);const t=M(v,S,o,i);if(!t&&n||(n=t,c<=0))break;i=c}if(n){const s={word:n[0],startColumn:k+1+n.index,endColumn:k+1+n.index+n[0].length};return v.lastIndex=0,s}return null}e.$Ls=E;function M(C,v,S,k){let u;for(;u=C.exec(v);){const m=u.index||0;if(m<=S&&C.lastIndex>=S)return u;if(k>0&&m>k)return null}return null}}),define(Se[177],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8t=e.$7t=e.IndentAction=void 0;var l;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(l||(e.IndentAction=l={}));class j{constructor(p){if(this.e=null,this.f=!1,this.open=p.open,this.close=p.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(p.notIn))for(let w=0,E=p.notIn.length;w<E;w++)switch(p.notIn[w]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(p){switch(p){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(p,w){if(p.getTokenCount()===0)return!0;const E=p.findTokenIndexAtOffset(w-2),M=p.getStandardTokenType(E);return this.isOK(M)}g(p,w){for(let E=p;E<=w;E++){const M=String.fromCharCode(E);if(!this.open.includes(M)&&!this.close.includes(M))return M}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$7t=j;class L{constructor(p){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const w of p)A(this.autoClosingPairsOpenByStart,w.open.charAt(0),w),A(this.autoClosingPairsOpenByEnd,w.open.charAt(w.open.length-1),w),A(this.autoClosingPairsCloseByStart,w.close.charAt(0),w),A(this.autoClosingPairsCloseByEnd,w.close.charAt(w.close.length-1),w),w.close.length===1&&w.open.length===1&&A(this.autoClosingPairsCloseSingleChar,w.close,w)}}e.$8t=L;function A(R,p,w){R.has(p)?R.get(p).push(w):R.set(p,[w])}}),define(Se[178],De([1,0,128]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b2=e.$a2=e.$_1=e.State=void 0;var j;(function(S){S[S.Invalid=0]="Invalid",S[S.Start=1]="Start",S[S.H=2]="H",S[S.HT=3]="HT",S[S.HTT=4]="HTT",S[S.HTTP=5]="HTTP",S[S.F=6]="F",S[S.FI=7]="FI",S[S.FIL=8]="FIL",S[S.BeforeColon=9]="BeforeColon",S[S.AfterColon=10]="AfterColon",S[S.AlmostThere=11]="AlmostThere",S[S.End=12]="End",S[S.Accept=13]="Accept",S[S.LastKnownState=14]="LastKnownState"})(j||(e.State=j={}));class L{constructor(k,u,m){const o=new Uint8Array(k*u);for(let i=0,n=k*u;i<n;i++)o[i]=m;this.a=o,this.rows=k,this.cols=u}get(k,u){return this.a[k*this.cols+u]}set(k,u,m){this.a[k*this.cols+u]=m}}class A{constructor(k){let u=0,m=0;for(let i=0,n=k.length;i<n;i++){const[s,c,t]=k[i];c>u&&(u=c),s>m&&(m=s),t>m&&(m=t)}u++,m++;const o=new L(m,u,0);for(let i=0,n=k.length;i<n;i++){const[s,c,t]=k[i];o.set(s,c,t)}this.a=o,this.b=u}nextState(k,u){return u<0||u>=this.b?0:this.a.get(k,u)}}e.$_1=A;let R=null;function p(){return R===null&&(R=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),R}var w;(function(S){S[S.None=0]="None",S[S.ForceTermination=1]="ForceTermination",S[S.CannotEndIn=2]="CannotEndIn"})(w||(w={}));let E=null;function M(){if(E===null){E=new l.$tt(0);const S=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let u=0;u<S.length;u++)E.set(S.charCodeAt(u),1);const k=".,;:";for(let u=0;u<k.length;u++)E.set(k.charCodeAt(u),2)}return E}class C{static a(k,u,m,o,i){let n=i-1;do{const s=u.charCodeAt(n);if(k.get(s)!==2)break;n--}while(n>o);if(o>0){const s=u.charCodeAt(o-1),c=u.charCodeAt(n);(s===40&&c===41||s===91&&c===93||s===123&&c===125)&&n--}return{range:{startLineNumber:m,startColumn:o+1,endLineNumber:m,endColumn:n+2},url:u.substring(o,n+1)}}static computeLinks(k,u=p()){const m=M(),o=[];for(let i=1,n=k.getLineCount();i<=n;i++){const s=k.getLineContent(i),c=s.length;let t=0,f=0,h=0,r=1,a=!1,d=!1,$=!1,D=!1;for(;t<c;){let b=!1;const g=s.charCodeAt(t);if(r===13){let y;switch(g){case 40:a=!0,y=0;break;case 41:y=a?0:1;break;case 91:$=!0,d=!0,y=0;break;case 93:$=!1,y=d?0:1;break;case 123:D=!0,y=0;break;case 125:y=D?0:1;break;case 39:case 34:case 96:h===g?y=1:h===39||h===34||h===96?y=0:y=1;break;case 42:y=h===42?1:0;break;case 124:y=h===124?1:0;break;case 32:y=$?0:1;break;default:y=m.get(g)}y===1&&(o.push(C.a(m,s,i,f,t)),b=!0)}else if(r===12){let y;g===91?(d=!0,y=0):y=m.get(g),y===1?b=!0:r=13}else r=u.nextState(r,g),r===0&&(b=!0);b&&(r=1,a=!1,d=!1,D=!1,f=t+1,h=g),t++}r===13&&o.push(C.a(m,s,i,f,c))}return o}}e.$a2=C;function v(S){return!S||typeof S.getLineCount!="function"||typeof S.getLineContent!="function"?[]:C.computeLinks(S)}e.$b2=v}),define(Se[78],De([1,0,24]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uv=e.$tv=e.$sv=e.$rv=e.ModelConstants=e.PositionAffinity=e.$qv=e.TrackedRangeStickiness=e.$pv=e.$ov=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var j;(function(s){s[s.Left=1]="Left",s[s.Center=2]="Center",s[s.Right=4]="Right",s[s.Full=7]="Full"})(j||(e.OverviewRulerLane=j={}));var L;(function(s){s[s.Left=1]="Left",s[s.Center=2]="Center",s[s.Right=3]="Right"})(L||(e.GlyphMarginLane=L={}));var A;(function(s){s[s.Inline=1]="Inline",s[s.Gutter=2]="Gutter"})(A||(e.MinimapPosition=A={}));var R;(function(s){s[s.Both=0]="Both",s[s.Right=1]="Right",s[s.Left=2]="Left",s[s.None=3]="None"})(R||(e.InjectedTextCursorStops=R={}));var p;(function(s){s[s.TextDefined=0]="TextDefined",s[s.LF=1]="LF",s[s.CRLF=2]="CRLF"})(p||(e.EndOfLinePreference=p={}));var w;(function(s){s[s.LF=1]="LF",s[s.CRLF=2]="CRLF"})(w||(e.DefaultEndOfLine=w={}));var E;(function(s){s[s.LF=0]="LF",s[s.CRLF=1]="CRLF"})(E||(e.EndOfLineSequence=E={}));class M{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(c){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,c.tabSize|0),c.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,c.indentSize|0),this.a=!1),this.insertSpaces=!!c.insertSpaces,this.defaultEOL=c.defaultEOL|0,this.trimAutoWhitespace=!!c.trimAutoWhitespace,this.bracketPairColorizationOptions=c.bracketPairColorizationOptions}equals(c){return this.tabSize===c.tabSize&&this.a===c.a&&this.indentSize===c.indentSize&&this.insertSpaces===c.insertSpaces&&this.defaultEOL===c.defaultEOL&&this.trimAutoWhitespace===c.trimAutoWhitespace&&(0,l.$On)(this.bracketPairColorizationOptions,c.bracketPairColorizationOptions)}createChangeEvent(c){return{tabSize:this.tabSize!==c.tabSize,indentSize:this.indentSize!==c.indentSize,insertSpaces:this.insertSpaces!==c.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==c.trimAutoWhitespace}}}e.$ov=M;class C{constructor(c,t){this._findMatchBrand=void 0,this.range=c,this.matches=t}}e.$pv=C;var v;(function(s){s[s.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",s[s.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",s[s.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",s[s.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(v||(e.TrackedRangeStickiness=v={}));function S(s){return s&&typeof s.read=="function"}e.$qv=S;var k;(function(s){s[s.Left=0]="Left",s[s.Right=1]="Right",s[s.None=2]="None",s[s.LeftOfInjectedText=3]="LeftOfInjectedText",s[s.RightOfInjectedText=4]="RightOfInjectedText"})(k||(e.PositionAffinity=k={}));var u;(function(s){s[s.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(u||(e.ModelConstants=u={}));class m{constructor(c,t,f,h,r,a){this.identifier=c,this.range=t,this.text=f,this.forceMoveMarkers=h,this.isAutoWhitespaceEdit=r,this._isTracked=a}}e.$rv=m;class o{constructor(c,t,f){this.regex=c,this.wordSeparators=t,this.simpleSearch=f}}e.$sv=o;class i{constructor(c,t,f){this.reverseEdits=c,this.changes=t,this.trimAutoWhitespaceLineNumbers=f}}e.$tv=i;function n(s){return!s.isTooLargeForSyncing()&&!s.isForSimpleWidget}e.$uv=n}),define(Se[179],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eC=e.$dC=e.$cC=e.$bC=e.$aC=e.$_B=e.$$B=e.$0B=e.$9B=e.NodeColor=e.$8B=void 0;class l{constructor(m,o){this.piece=m,this.color=o,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$9B)return L(this.right);let m=this;for(;m.parent!==e.$9B&&m.parent.left!==m;)m=m.parent;return m.parent===e.$9B?e.$9B:m.parent}prev(){if(this.left!==e.$9B)return A(this.left);let m=this;for(;m.parent!==e.$9B&&m.parent.right!==m;)m=m.parent;return m.parent===e.$9B?e.$9B:m.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$8B=l;var j;(function(u){u[u.Black=0]="Black",u[u.Red=1]="Red"})(j||(e.NodeColor=j={})),e.$9B=new l(null,0),e.$9B.parent=e.$9B,e.$9B.left=e.$9B,e.$9B.right=e.$9B,e.$9B.color=0;function L(u){for(;u.left!==e.$9B;)u=u.left;return u}e.$0B=L;function A(u){for(;u.right!==e.$9B;)u=u.right;return u}e.$$B=A;function R(u){return u===e.$9B?0:u.size_left+u.piece.length+R(u.right)}function p(u){return u===e.$9B?0:u.lf_left+u.piece.lineFeedCnt+p(u.right)}function w(){e.$9B.parent=e.$9B}function E(u,m){const o=m.right;o.size_left+=m.size_left+(m.piece?m.piece.length:0),o.lf_left+=m.lf_left+(m.piece?m.piece.lineFeedCnt:0),m.right=o.left,o.left!==e.$9B&&(o.left.parent=m),o.parent=m.parent,m.parent===e.$9B?u.root=o:m.parent.left===m?m.parent.left=o:m.parent.right=o,o.left=m,m.parent=o}e.$_B=E;function M(u,m){const o=m.left;m.left=o.right,o.right!==e.$9B&&(o.right.parent=m),o.parent=m.parent,m.size_left-=o.size_left+(o.piece?o.piece.length:0),m.lf_left-=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),m.parent===e.$9B?u.root=o:m===m.parent.right?m.parent.right=o:m.parent.left=o,o.right=m,m.parent=o}e.$aC=M;function C(u,m){let o,i;if(m.left===e.$9B?(i=m,o=i.right):m.right===e.$9B?(i=m,o=i.left):(i=L(m.right),o=i.right),i===u.root){u.root=o,o.color=0,m.detach(),w(),u.root.parent=e.$9B;return}const n=i.color===1;if(i===i.parent.left?i.parent.left=o:i.parent.right=o,i===m?(o.parent=i.parent,k(u,o)):(i.parent===m?o.parent=i:o.parent=i.parent,k(u,o),i.left=m.left,i.right=m.right,i.parent=m.parent,i.color=m.color,m===u.root?u.root=i:m===m.parent.left?m.parent.left=i:m.parent.right=i,i.left!==e.$9B&&(i.left.parent=i),i.right!==e.$9B&&(i.right.parent=i),i.size_left=m.size_left,i.lf_left=m.lf_left,k(u,i)),m.detach(),o.parent.left===o){const c=R(o),t=p(o);if(c!==o.parent.size_left||t!==o.parent.lf_left){const f=c-o.parent.size_left,h=t-o.parent.lf_left;o.parent.size_left=c,o.parent.lf_left=t,S(u,o.parent,f,h)}}if(k(u,o.parent),n){w();return}let s;for(;o!==u.root&&o.color===0;)o===o.parent.left?(s=o.parent.right,s.color===1&&(s.color=0,o.parent.color=1,E(u,o.parent),s=o.parent.right),s.left.color===0&&s.right.color===0?(s.color=1,o=o.parent):(s.right.color===0&&(s.left.color=0,s.color=1,M(u,s),s=o.parent.right),s.color=o.parent.color,o.parent.color=0,s.right.color=0,E(u,o.parent),o=u.root)):(s=o.parent.left,s.color===1&&(s.color=0,o.parent.color=1,M(u,o.parent),s=o.parent.left),s.left.color===0&&s.right.color===0?(s.color=1,o=o.parent):(s.left.color===0&&(s.right.color=0,s.color=1,E(u,s),s=o.parent.left),s.color=o.parent.color,o.parent.color=0,s.left.color=0,M(u,o.parent),o=u.root));o.color=0,w()}e.$bC=C;function v(u,m){for(k(u,m);m!==u.root&&m.parent.color===1;)if(m.parent===m.parent.parent.left){const o=m.parent.parent.right;o.color===1?(m.parent.color=0,o.color=0,m.parent.parent.color=1,m=m.parent.parent):(m===m.parent.right&&(m=m.parent,E(u,m)),m.parent.color=0,m.parent.parent.color=1,M(u,m.parent.parent))}else{const o=m.parent.parent.left;o.color===1?(m.parent.color=0,o.color=0,m.parent.parent.color=1,m=m.parent.parent):(m===m.parent.left&&(m=m.parent,M(u,m)),m.parent.color=0,m.parent.parent.color=1,E(u,m.parent.parent))}u.root.color=0}e.$cC=v;function S(u,m,o,i){for(;m!==u.root&&m!==e.$9B;)m.parent.left===m&&(m.parent.size_left+=o,m.parent.lf_left+=i),m=m.parent}e.$dC=S;function k(u,m){let o=0,i=0;if(m!==u.root){for(;m!==u.root&&m===m.parent.right;)m=m.parent;if(m!==u.root)for(m=m.parent,o=R(m.left)-m.size_left,i=p(m.left)-m.lf_left,m.size_left+=o,m.lf_left+=i;m!==u.root&&(o!==0||i!==0);)m.parent.left===m&&(m.parent.size_left+=o,m.parent.lf_left+=i),m=m.parent}}e.$eC=k}),define(Se[180],De([1,0,19,127]),function(fe,e,l,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zv=e.$yv=e.$xv=void 0;class L{constructor(w){this.a=w,this.b=new Uint32Array(w.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(w,E){w=(0,j.$Re)(w);const M=this.a,C=this.b,v=E.length;return v===0?!1:(this.a=new Uint32Array(M.length+v),this.a.set(M.subarray(0,w),0),this.a.set(M.subarray(w),w+v),this.a.set(E,w),w-1<this.c[0]&&(this.c[0]=w-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(C.subarray(0,this.c[0]+1)),!0)}setValue(w,E){return w=(0,j.$Re)(w),E=(0,j.$Re)(E),this.a[w]===E?!1:(this.a[w]=E,w-1<this.c[0]&&(this.c[0]=w-1),!0)}removeValues(w,E){w=(0,j.$Re)(w),E=(0,j.$Re)(E);const M=this.a,C=this.b;if(w>=M.length)return!1;const v=M.length-w;return E>=v&&(E=v),E===0?!1:(this.a=new Uint32Array(M.length-E),this.a.set(M.subarray(0,w),0),this.a.set(M.subarray(w+E),w),this.b=new Uint32Array(this.a.length),w-1<this.c[0]&&(this.c[0]=w-1),this.c[0]>=0&&this.b.set(C.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(w){return w<0?0:(w=(0,j.$Re)(w),this.d(w))}d(w){if(w<=this.c[0])return this.b[w];let E=this.c[0]+1;E===0&&(this.b[0]=this.a[0],E++),w>=this.a.length&&(w=this.a.length-1);for(let M=E;M<=w;M++)this.b[M]=this.b[M-1]+this.a[M];return this.c[0]=Math.max(this.c[0],w),this.b[w]}getIndexOf(w){w=Math.floor(w),this.getTotalSum();let E=0,M=this.a.length-1,C=0,v=0,S=0;for(;E<=M;)if(C=E+(M-E)/2|0,v=this.b[C],S=v-this.a[C],w<S)M=C-1;else if(w>=v)E=C+1;else break;return new R(C,w-S)}}e.$xv=L;class A{constructor(w){this.a=w,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(w){return this.g(),w===0?0:this.d[w-1]}getIndexOf(w){this.g();const E=this.e[w],M=E>0?this.d[E-1]:0;return new R(E,w-M)}removeValues(w,E){this.a.splice(w,E),this.f(w)}insertValues(w,E){this.a=(0,l.$Wb)(this.a,w,E),this.f(w)}f(w){this.b=!1,this.c=Math.min(this.c,w-1)}g(){if(!this.b){for(let w=this.c+1,E=this.a.length;w<E;w++){const M=this.a[w],C=w>0?this.d[w-1]:0;this.d[w]=C+M;for(let v=0;v<M;v++)this.e[C+v]=w}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(w,E){this.a[w]!==E&&(this.a[w]=E,this.f(w))}}e.$yv=A;class R{constructor(w,E){this.index=w,this.remainder=E,this._prefixSumIndexOfResultBrand=void 0,this.index=w,this.remainder=E}}e.$zv=R}),define(Se[181],De([1,0,14,49,180]),function(fe,e,l,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Av=void 0;class A{constructor(p,w,E,M){this.d=p,this.f=w,this.g=E,this.h=M,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(p){p.eol&&p.eol!==this.g&&(this.g=p.eol,this.j=null);const w=p.changes;for(const E of w)this.o(E.range),this.p(new j.$8s(E.range.startLineNumber,E.range.startColumn),E.text);this.h=p.versionId,this.k=null}l(){if(!this.j){const p=this.g.length,w=this.f.length,E=new Uint32Array(w);for(let M=0;M<w;M++)E[M]=this.f[M].length+p;this.j=new L.$xv(E)}}n(p,w){this.f[p]=w,this.j&&this.j.setValue(p,this.f[p].length+this.g.length)}o(p){if(p.startLineNumber===p.endLineNumber){if(p.startColumn===p.endColumn)return;this.n(p.startLineNumber-1,this.f[p.startLineNumber-1].substring(0,p.startColumn-1)+this.f[p.startLineNumber-1].substring(p.endColumn-1));return}this.n(p.startLineNumber-1,this.f[p.startLineNumber-1].substring(0,p.startColumn-1)+this.f[p.endLineNumber-1].substring(p.endColumn-1)),this.f.splice(p.startLineNumber,p.endLineNumber-p.startLineNumber),this.j&&this.j.removeValues(p.startLineNumber,p.endLineNumber-p.startLineNumber)}p(p,w){if(w.length===0)return;const E=(0,l.$9e)(w);if(E.length===1){this.n(p.lineNumber-1,this.f[p.lineNumber-1].substring(0,p.column-1)+E[0]+this.f[p.lineNumber-1].substring(p.column-1));return}E[E.length-1]+=this.f[p.lineNumber-1].substring(p.column-1),this.n(p.lineNumber-1,this.f[p.lineNumber-1].substring(0,p.column-1)+E[0]);const M=new Uint32Array(E.length-1);for(let C=1;C<E.length;C++)this.f.splice(p.lineNumber+C-1,0,E[C]),M[C-1]=E[C].length+this.g.length;this.j&&this.j.insertValues(p.lineNumber,M)}}e.$Av=A}),define(Se[100],De([1,0,14,176,49,29,78]),function(fe,e,l,j,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kC=e.$jC=e.$iC=e.$hC=e.$gC=e.$fC=void 0;const p=999;class w{constructor(i,n,s,c){this.searchString=i,this.isRegex=n,this.matchCase=s,this.wordSeparators=c}parseSearchRequest(){if(this.searchString==="")return null;let i;this.isRegex?i=E(this.searchString):i=this.searchString.indexOf(`
`)>=0;let n=null;try{n=l.$7e(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:i,global:!0,unicode:!0})}catch{return null}if(!n)return null;let s=!this.isRegex&&!i;return s&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(s=this.matchCase),new R.$sv(n,this.wordSeparators?(0,j.$wt)(this.wordSeparators):null,s?this.searchString:null)}}e.$fC=w;function E(o){if(!o||o.length===0)return!1;for(let i=0,n=o.length;i<n;i++){const s=o.charCodeAt(i);if(s===10)return!0;if(s===92){if(i++,i>=n)break;const c=o.charCodeAt(i);if(c===110||c===114||c===87)return!0}}return!1}e.$gC=E;function M(o,i,n){if(!n)return new R.$pv(o,null);const s=[];for(let c=0,t=i.length;c<t;c++)s[c]=i[c];return new R.$pv(o,s)}e.$hC=M;class C{constructor(i){const n=[];let s=0;for(let c=0,t=i.length;c<t;c++)i.charCodeAt(c)===10&&(n[s++]=c);this.a=n}findLineFeedCountBeforeOffset(i){const n=this.a;let s=0,c=n.length-1;if(c===-1||i<=n[0])return 0;for(;s<c;){const t=s+((c-s)/2>>0);n[t]>=i?c=t-1:n[t+1]>=i?(s=t,c=t):s=t+1}return s+1}}class v{static findMatches(i,n,s,c,t){const f=n.parseSearchRequest();return f?f.regex.multiline?this.b(i,s,new m(f.wordSeparators,f.regex),c,t):this.c(i,s,f,c,t):[]}static a(i,n,s,c,t,f){let h,r=0;c?(r=c.findLineFeedCountBeforeOffset(t),h=n+t+r):h=n+t;let a;if(c){const b=c.findLineFeedCountBeforeOffset(t+f.length)-r;a=h+f.length+b}else a=h+f.length;const d=i.getPositionAt(h),$=i.getPositionAt(a);return new A.$9s(d.lineNumber,d.column,$.lineNumber,$.column)}static b(i,n,s,c,t){const f=i.getOffsetAt(n.getStartPosition()),h=i.getValueInRange(n,1),r=i.getEOL()===`\r
`?new C(h):null,a=[];let d=0,$;for(s.reset(0);$=s.next(h);)if(a[d++]=M(this.a(i,f,h,r,$.index,$[0]),$,c),d>=t)return a;return a}static c(i,n,s,c,t){const f=[];let h=0;if(n.startLineNumber===n.endLineNumber){const a=i.getLineContent(n.startLineNumber).substring(n.startColumn-1,n.endColumn-1);return h=this.d(s,a,n.startLineNumber,n.startColumn-1,h,f,c,t),f}const r=i.getLineContent(n.startLineNumber).substring(n.startColumn-1);h=this.d(s,r,n.startLineNumber,n.startColumn-1,h,f,c,t);for(let a=n.startLineNumber+1;a<n.endLineNumber&&h<t;a++)h=this.d(s,i.getLineContent(a),a,0,h,f,c,t);if(h<t){const a=i.getLineContent(n.endLineNumber).substring(0,n.endColumn-1);h=this.d(s,a,n.endLineNumber,0,h,f,c,t)}return f}static d(i,n,s,c,t,f,h,r){const a=i.wordSeparators;if(!h&&i.simpleSearch){const D=i.simpleSearch,b=D.length,g=n.length;let y=-b;for(;(y=n.indexOf(D,y+b))!==-1;)if((!a||u(a,n,g,y,b))&&(f[t++]=new R.$pv(new A.$9s(s,y+1+c,s,y+1+b+c),null),t>=r))return t;return t}const d=new m(i.wordSeparators,i.regex);let $;d.reset(0);do if($=d.next(n),$&&(f[t++]=M(new A.$9s(s,$.index+1+c,s,$.index+1+$[0].length+c),$,h),t>=r))return t;while($);return t}static findNextMatch(i,n,s,c){const t=n.parseSearchRequest();if(!t)return null;const f=new m(t.wordSeparators,t.regex);return t.regex.multiline?this.e(i,s,f,c):this.f(i,s,f,c)}static e(i,n,s,c){const t=new L.$8s(n.lineNumber,1),f=i.getOffsetAt(t),h=i.getLineCount(),r=i.getValueInRange(new A.$9s(t.lineNumber,t.column,h,i.getLineMaxColumn(h)),1),a=i.getEOL()===`\r
`?new C(r):null;s.reset(n.column-1);const d=s.next(r);return d?M(this.a(i,f,r,a,d.index,d[0]),d,c):n.lineNumber!==1||n.column!==1?this.e(i,new L.$8s(1,1),s,c):null}static f(i,n,s,c){const t=i.getLineCount(),f=n.lineNumber,h=i.getLineContent(f),r=this.g(s,h,f,n.column,c);if(r)return r;for(let a=1;a<=t;a++){const d=(f+a-1)%t,$=i.getLineContent(d+1),D=this.g(s,$,d+1,1,c);if(D)return D}return null}static g(i,n,s,c,t){i.reset(c-1);const f=i.next(n);return f?M(new A.$9s(s,f.index+1,s,f.index+1+f[0].length),f,t):null}static findPreviousMatch(i,n,s,c){const t=n.parseSearchRequest();if(!t)return null;const f=new m(t.wordSeparators,t.regex);return t.regex.multiline?this.h(i,s,f,c):this.j(i,s,f,c)}static h(i,n,s,c){const t=this.b(i,new A.$9s(1,1,n.lineNumber,n.column),s,c,10*p);if(t.length>0)return t[t.length-1];const f=i.getLineCount();return n.lineNumber!==f||n.column!==i.getLineMaxColumn(f)?this.h(i,new L.$8s(f,i.getLineMaxColumn(f)),s,c):null}static j(i,n,s,c){const t=i.getLineCount(),f=n.lineNumber,h=i.getLineContent(f).substring(0,n.column-1),r=this.k(s,h,f,c);if(r)return r;for(let a=1;a<=t;a++){const d=(t+f-a-1)%t,$=i.getLineContent(d+1),D=this.k(s,$,d+1,c);if(D)return D}return null}static k(i,n,s,c){let t=null,f;for(i.reset(0);f=i.next(n);)t=M(new A.$9s(s,f.index+1,s,f.index+1+f[0].length),f,c);return t}}e.$iC=v;function S(o,i,n,s,c){if(s===0)return!0;const t=i.charCodeAt(s-1);if(o.get(t)!==0||t===13||t===10)return!0;if(c>0){const f=i.charCodeAt(s);if(o.get(f)!==0)return!0}return!1}function k(o,i,n,s,c){if(s+c===n)return!0;const t=i.charCodeAt(s+c);if(o.get(t)!==0||t===13||t===10)return!0;if(c>0){const f=i.charCodeAt(s+c-1);if(o.get(f)!==0)return!0}return!1}function u(o,i,n,s,c){return S(o,i,n,s,c)&&k(o,i,n,s,c)}e.$jC=u;class m{constructor(i,n){this._wordSeparators=i,this.a=n,this.b=-1,this.c=0}reset(i){this.a.lastIndex=i,this.b=-1,this.c=0}next(i){const n=i.length;let s;do{if(this.b+this.c===n||(s=this.a.exec(i),!s))return null;const c=s.index,t=s[0].length;if(c===this.b&&t===this.c){if(t===0){l.$qf(i,n,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=c,this.c=t,!this._wordSeparators||u(this._wordSeparators,i,n,c,t))return s}while(s);return null}}e.$kC=m}),define(Se[130],De([1,0,49,29,78,179,100]),function(fe,e,l,j,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pC=e.$oC=e.$nC=e.$mC=e.$lC=void 0;const p=65535;function w(o){let i;return o[o.length-1]<65536?i=new Uint16Array(o.length):i=new Uint32Array(o.length),i.set(o,0),i}class E{constructor(i,n,s,c,t){this.lineStarts=i,this.cr=n,this.lf=s,this.crlf=c,this.isBasicASCII=t}}function M(o,i=!0){const n=[0];let s=1;for(let c=0,t=o.length;c<t;c++){const f=o.charCodeAt(c);f===13?c+1<t&&o.charCodeAt(c+1)===10?(n[s++]=c+2,c++):n[s++]=c+1:f===10&&(n[s++]=c+1)}return i?w(n):n}e.$lC=M;function C(o,i){o.length=0,o[0]=0;let n=1,s=0,c=0,t=0,f=!0;for(let r=0,a=i.length;r<a;r++){const d=i.charCodeAt(r);d===13?r+1<a&&i.charCodeAt(r+1)===10?(t++,o[n++]=r+2,r++):(s++,o[n++]=r+1):d===10?(c++,o[n++]=r+1):f&&d!==9&&(d<32||d>126)&&(f=!1)}const h=new E(w(o),s,c,t,f);return o.length=0,h}e.$mC=C;class v{constructor(i,n,s,c,t){this.bufferIndex=i,this.start=n,this.end=s,this.lineFeedCnt=c,this.length=t}}e.$nC=v;class S{constructor(i,n){this.buffer=i,this.lineStarts=n}}e.$oC=S;class k{constructor(i,n){this.a=[],this.c=i,this.d=n,this.b=0,i.root!==A.$9B&&i.iterate(i.root,s=>(s!==A.$9B&&this.a.push(s.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class u{constructor(i){this.a=i,this.b=[]}get(i){for(let n=this.b.length-1;n>=0;n--){const s=this.b[n];if(s.nodeStartOffset<=i&&s.nodeStartOffset+s.node.piece.length>=i)return s}return null}get2(i){for(let n=this.b.length-1;n>=0;n--){const s=this.b[n];if(s.nodeStartLineNumber&&s.nodeStartLineNumber<i&&s.nodeStartLineNumber+s.node.piece.lineFeedCnt>=i)return s}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let n=!1;const s=this.b;for(let c=0;c<s.length;c++){const t=s[c];if(t.node.parent===null||t.nodeStartOffset>=i){s[c]=null,n=!0;continue}}if(n){const c=[];for(const t of s)t!==null&&c.push(t);this.b=c}}}class m{constructor(i,n,s){this.create(i,n,s)}create(i,n,s){this.a=[new S("",[0])],this.g={line:0,column:0},this.root=A.$9B,this.b=1,this.c=0,this.d=n,this.e=n.length,this.f=s;let c=null;for(let t=0,f=i.length;t<f;t++)if(i[t].buffer.length>0){i[t].lineStarts||(i[t].lineStarts=M(i[t].buffer));const h=new v(t+1,{line:0,column:0},{line:i[t].lineStarts.length-1,column:i[t].buffer.length-i[t].lineStarts[i[t].lineStarts.length-1]},i[t].lineStarts.length-1,i[t].buffer.length);this.a.push(i[t]),c=this.S(c,h)}this.h=new u(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const n=p,s=n-Math.floor(n/3),c=s*2;let t="",f=0;const h=[];if(this.iterate(this.root,r=>{const a=this.R(r),d=a.length;if(f<=s||f+d<c)return t+=a,f+=d,!0;const $=t.replace(/\r\n|\r|\n/g,i);return h.push(new S($,M($))),t=a,f=d,!0}),f>0){const r=t.replace(/\r\n|\r|\n/g,i);h.push(new S(r,M(r)))}this.create(h,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new k(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let n=0;return this.iterate(this.root,c=>{if(c===A.$9B)return!0;const t=this.R(c),f=t.length,h=i.G(n),r=i.G(n+f),a=i.getValueInRange2(h,r);return n+=f,t===a})}getOffsetAt(i,n){let s=0,c=this.root;for(;c!==A.$9B;)if(c.left!==A.$9B&&c.lf_left+1>=i)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt+1>=i){s+=c.size_left;const t=this.B(c,i-c.lf_left-2);return s+=t+n-1}else i-=c.lf_left+c.piece.lineFeedCnt,s+=c.size_left+c.piece.length,c=c.right;return s}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let n=this.root,s=0;const c=i;for(;n!==A.$9B;)if(n.size_left!==0&&n.size_left>=i)n=n.left;else if(n.size_left+n.piece.length>=i){const t=this.A(n,i-n.size_left);if(s+=n.lf_left+t.index,t.index===0){const f=this.getOffsetAt(s+1,1),h=c-f;return new l.$8s(s+1,h+1)}return new l.$8s(s+1,t.remainder+1)}else if(i-=n.size_left+n.piece.length,s+=n.lf_left+n.piece.lineFeedCnt,n.right===A.$9B){const t=this.getOffsetAt(s+1,1),f=c-i-t;return new l.$8s(s+1,f+1)}else n=n.right;return new l.$8s(1,1)}getValueInRange(i,n){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const s=this.H(i.startLineNumber,i.startColumn),c=this.H(i.endLineNumber,i.endColumn),t=this.getValueInRange2(s,c);return n?n!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,n):n===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,n):t}getValueInRange2(i,n){if(i.node===n.node){const h=i.node,r=this.a[h.piece.bufferIndex].buffer,a=this.u(h.piece.bufferIndex,h.piece.start);return r.substring(a+i.remainder,a+n.remainder)}let s=i.node;const c=this.a[s.piece.bufferIndex].buffer,t=this.u(s.piece.bufferIndex,s.piece.start);let f=c.substring(t+i.remainder,t+s.piece.length);for(s=s.next();s!==A.$9B;){const h=this.a[s.piece.bufferIndex].buffer,r=this.u(s.piece.bufferIndex,s.piece.start);if(s===n.node){f+=h.substring(r,r+n.remainder);break}else f+=h.substr(r,s.piece.length);s=s.next()}return f}getLinesContent(){const i=[];let n=0,s="",c=!1;return this.iterate(this.root,t=>{if(t===A.$9B)return!0;const f=t.piece;let h=f.length;if(h===0)return!0;const r=this.a[f.bufferIndex].buffer,a=this.a[f.bufferIndex].lineStarts,d=f.start.line,$=f.end.line;let D=a[d]+f.start.column;if(c&&(r.charCodeAt(D)===10&&(D++,h--),i[n++]=s,s="",c=!1,h===0))return!0;if(d===$)return!this.f&&r.charCodeAt(D+h-1)===13?(c=!0,s+=r.substr(D,h-1)):s+=r.substr(D,h),!0;s+=this.f?r.substring(D,Math.max(D,a[d+1]-this.e)):r.substring(D,a[d+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=s;for(let b=d+1;b<$;b++)s=this.f?r.substring(a[b],a[b+1]-this.e):r.substring(a[b],a[b+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=s;return!this.f&&r.charCodeAt(a[$]+f.end.column-1)===13?(c=!0,f.end.column===0?n--:s=r.substr(a[$],f.end.column-1)):s=r.substr(a[$],f.end.column),!0}),c&&(i[n++]=s,s=""),i[n++]=s,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const n=i.node.next();if(!n)return 0;const s=this.a[n.piece.bufferIndex],c=this.u(n.piece.bufferIndex,n.piece.start);return s.buffer.charCodeAt(c)}else{const n=this.a[i.node.piece.bufferIndex],c=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return n.buffer.charCodeAt(c)}}getLineCharCode(i,n){const s=this.H(i,n+1);return this.l(s)}getLineLength(i){if(i===this.getLineCount()){const n=this.getOffsetAt(i,1);return this.getLength()-n}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const n=this.G(i);return this.l(n)}findMatchesInNode(i,n,s,c,t,f,h,r,a,d,$){const D=this.a[i.piece.bufferIndex],b=this.u(i.piece.bufferIndex,i.piece.start),g=this.u(i.piece.bufferIndex,t),y=this.u(i.piece.bufferIndex,f);let P;const N={line:0,column:0};let U,z;n._wordSeparators?(U=D.buffer.substring(g,y),z=F=>F+g,n.reset(0)):(U=D.buffer,z=F=>F,n.reset(g));do if(P=n.next(U),P){if(z(P.index)>=y)return d;this.s(i,z(P.index)-b,N);const F=this.t(i.piece.bufferIndex,t,N),I=N.line===t.line?N.column-t.column+c:N.column+1,O=I+P[0].length;if($[d++]=(0,R.$hC)(new j.$9s(s+F,I,s+F,O),P,r),z(P.index)+P[0].length>=y||d>=a)return d}while(P);return d}findMatchesLineByLine(i,n,s,c){const t=[];let f=0;const h=new R.$kC(n.wordSeparators,n.regex);let r=this.H(i.startLineNumber,i.startColumn);if(r===null)return[];const a=this.H(i.endLineNumber,i.endColumn);if(a===null)return[];let d=this.s(r.node,r.remainder);const $=this.s(a.node,a.remainder);if(r.node===a.node)return this.findMatchesInNode(r.node,h,i.startLineNumber,i.startColumn,d,$,n,s,c,f,t),t;let D=i.startLineNumber,b=r.node;for(;b!==a.node;){const y=this.t(b.piece.bufferIndex,d,b.piece.end);if(y>=1){const N=this.a[b.piece.bufferIndex].lineStarts,U=this.u(b.piece.bufferIndex,b.piece.start),z=N[d.line+y],F=D===i.startLineNumber?i.startColumn:1;if(f=this.findMatchesInNode(b,h,D,F,d,this.s(b,z-U),n,s,c,f,t),f>=c)return t;D+=y}const P=D===i.startLineNumber?i.startColumn-1:0;if(D===i.endLineNumber){const N=this.getLineContent(D).substring(P,i.endColumn-1);return f=this.n(n,h,N,i.endLineNumber,P,f,t,s,c),t}if(f=this.n(n,h,this.getLineContent(D).substr(P),D,P,f,t,s,c),f>=c)return t;D++,r=this.H(D,1),b=r.node,d=this.s(r.node,r.remainder)}if(D===i.endLineNumber){const y=D===i.startLineNumber?i.startColumn-1:0,P=this.getLineContent(D).substring(y,i.endColumn-1);return f=this.n(n,h,P,i.endLineNumber,y,f,t,s,c),t}const g=D===i.startLineNumber?i.startColumn:1;return f=this.findMatchesInNode(a.node,h,D,g,d,$,n,s,c,f,t),t}n(i,n,s,c,t,f,h,r,a){const d=i.wordSeparators;if(!r&&i.simpleSearch){const D=i.simpleSearch,b=D.length,g=s.length;let y=-b;for(;(y=s.indexOf(D,y+b))!==-1;)if((!d||(0,R.$jC)(d,s,g,y,b))&&(h[f++]=new L.$pv(new j.$9s(c,y+1+t,c,y+1+b+t),null),f>=a))return f;return f}let $;n.reset(0);do if($=n.next(s),$&&(h[f++]=(0,R.$hC)(new j.$9s(c,$.index+1+t,c,$.index+1+$[0].length+t),$,r),f>=a))return f;while($);return f}insert(i,n,s=!1){if(this.f=this.f&&s,this.j.lineNumber=0,this.j.value="",this.root!==A.$9B){const{node:c,remainder:t,nodeStartOffset:f}=this.G(i),h=c.piece,r=h.bufferIndex,a=this.s(c,t);if(c.piece.bufferIndex===0&&h.end.line===this.g.line&&h.end.column===this.g.column&&f+h.length===i&&n.length<p){this.F(c,n),this.y();return}if(f===i)this.o(n,c),this.h.validate(i);else if(f+c.piece.length>i){const d=[];let $=new v(h.bufferIndex,a,h.end,this.t(h.bufferIndex,a,h.end),this.u(r,h.end)-this.u(r,a));if(this.K()&&this.M(n)&&this.I(c,t)===10){const y={line:$.start.line+1,column:0};$=new v($.bufferIndex,y,$.end,this.t($.bufferIndex,y,$.end),$.length-1),n+=`
`}if(this.K()&&this.L(n))if(this.I(c,t-1)===13){const y=this.s(c,t-1);this.C(c,y),n="\r"+n,c.piece.length===0&&d.push(c)}else this.C(c,a);else this.C(c,a);const D=this.w(n);$.length>0&&this.S(c,$);let b=c;for(let g=0;g<D.length;g++)b=this.S(b,D[g]);this.v(d)}else this.q(n,c)}else{const c=this.w(n);let t=this.T(null,c[0]);for(let f=1;f<c.length;f++)t=this.S(t,c[f])}this.y()}delete(i,n){if(this.j.lineNumber=0,this.j.value="",n<=0||this.root===A.$9B)return;const s=this.G(i),c=this.G(i+n),t=s.node,f=c.node;if(t===f){const D=this.s(t,s.remainder),b=this.s(t,c.remainder);if(s.nodeStartOffset===i){if(n===t.piece.length){const g=t.next();(0,A.$bC)(this,t),this.N(g),this.y();return}this.D(t,b),this.h.validate(i),this.N(t),this.y();return}if(s.nodeStartOffset+t.piece.length===i+n){this.C(t,D),this.O(t),this.y();return}this.E(t,D,b),this.y();return}const h=[],r=this.s(t,s.remainder);this.C(t,r),this.h.validate(i),t.piece.length===0&&h.push(t);const a=this.s(f,c.remainder);this.D(f,a),f.piece.length===0&&h.push(f);const d=t.next();for(let D=d;D!==A.$9B&&D!==f;D=D.next())h.push(D);const $=t.piece.length===0?t.prev():t;this.v(h),this.O($),this.y()}o(i,n){const s=[];if(this.K()&&this.M(i)&&this.L(n)){const f=n.piece,h={line:f.start.line+1,column:0},r=new v(f.bufferIndex,h,f.end,this.t(f.bufferIndex,h,f.end),f.length-1);n.piece=r,i+=`
`,(0,A.$dC)(this,n,-1,-1),n.piece.length===0&&s.push(n)}const c=this.w(i);let t=this.T(n,c[c.length-1]);for(let f=c.length-2;f>=0;f--)t=this.T(t,c[f]);this.N(t),this.v(s)}q(i,n){this.Q(i,n)&&(i+=`
`);const s=this.w(i),c=this.S(n,s[0]);let t=c;for(let f=1;f<s.length;f++)t=this.S(t,s[f]);this.N(c)}s(i,n,s){const c=i.piece,t=i.piece.bufferIndex,f=this.a[t].lineStarts,r=f[c.start.line]+c.start.column+n;let a=c.start.line,d=c.end.line,$=0,D=0,b=0;for(;a<=d&&($=a+(d-a)/2|0,b=f[$],$!==d);)if(D=f[$+1],r<b)d=$-1;else if(r>=D)a=$+1;else break;return s?(s.line=$,s.column=r-b,null):{line:$,column:r-b}}t(i,n,s){if(s.column===0)return s.line-n.line;const c=this.a[i].lineStarts;if(s.line===c.length-1)return s.line-n.line;const t=c[s.line+1],f=c[s.line]+s.column;if(t>f+1)return s.line-n.line;const h=f-1;return this.a[i].buffer.charCodeAt(h)===13?s.line-n.line+1:s.line-n.line}u(i,n){return this.a[i].lineStarts[n.line]+n.column}v(i){for(let n=0;n<i.length;n++)(0,A.$bC)(this,i[n])}w(i){if(i.length>p){const d=[];for(;i.length>p;){const D=i.charCodeAt(p-1);let b;D===13||D>=55296&&D<=56319?(b=i.substring(0,p-1),i=i.substring(p-1)):(b=i.substring(0,p),i=i.substring(p));const g=M(b);d.push(new v(this.a.length,{line:0,column:0},{line:g.length-1,column:b.length-g[g.length-1]},g.length-1,b.length)),this.a.push(new S(b,g))}const $=M(i);return d.push(new v(this.a.length,{line:0,column:0},{line:$.length-1,column:i.length-$[$.length-1]},$.length-1,i.length)),this.a.push(new S(i,$)),d}let n=this.a[0].buffer.length;const s=M(i,!1);let c=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===n&&n!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},c=this.g;for(let d=0;d<s.length;d++)s[d]+=n+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(s.slice(1)),this.a[0].buffer+="_"+i,n+=1}else{if(n!==0)for(let d=0;d<s.length;d++)s[d]+=n;this.a[0].lineStarts=this.a[0].lineStarts.concat(s.slice(1)),this.a[0].buffer+=i}const t=this.a[0].buffer.length,f=this.a[0].lineStarts.length-1,h=t-this.a[0].lineStarts[f],r={line:f,column:h},a=new v(0,c,r,this.t(0,c,r),t-n);return this.g=r,[a]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,n=0){let s=this.root,c="";const t=this.h.get2(i);if(t){s=t.node;const f=this.B(s,i-t.nodeStartLineNumber-1),h=this.a[s.piece.bufferIndex].buffer,r=this.u(s.piece.bufferIndex,s.piece.start);if(t.nodeStartLineNumber+s.piece.lineFeedCnt===i)c=h.substring(r+f,r+s.piece.length);else{const a=this.B(s,i-t.nodeStartLineNumber);return h.substring(r+f,r+a-n)}}else{let f=0;const h=i;for(;s!==A.$9B;)if(s.left!==A.$9B&&s.lf_left>=i-1)s=s.left;else if(s.lf_left+s.piece.lineFeedCnt>i-1){const r=this.B(s,i-s.lf_left-2),a=this.B(s,i-s.lf_left-1),d=this.a[s.piece.bufferIndex].buffer,$=this.u(s.piece.bufferIndex,s.piece.start);return f+=s.size_left,this.h.set({node:s,nodeStartOffset:f,nodeStartLineNumber:h-(i-1-s.lf_left)}),d.substring($+r,$+a-n)}else if(s.lf_left+s.piece.lineFeedCnt===i-1){const r=this.B(s,i-s.lf_left-2),a=this.a[s.piece.bufferIndex].buffer,d=this.u(s.piece.bufferIndex,s.piece.start);c=a.substring(d+r,d+s.piece.length);break}else i-=s.lf_left+s.piece.lineFeedCnt,f+=s.size_left+s.piece.length,s=s.right}for(s=s.next();s!==A.$9B;){const f=this.a[s.piece.bufferIndex].buffer;if(s.piece.lineFeedCnt>0){const h=this.B(s,0),r=this.u(s.piece.bufferIndex,s.piece.start);return c+=f.substring(r,r+h-n),c}else{const h=this.u(s.piece.bufferIndex,s.piece.start);c+=f.substr(h,s.piece.length)}s=s.next()}return c}y(){let i=this.root,n=1,s=0;for(;i!==A.$9B;)n+=i.lf_left+i.piece.lineFeedCnt,s+=i.size_left+i.piece.length,i=i.right;this.b=n,this.c=s,this.h.validate(this.c)}A(i,n){const s=i.piece,c=this.s(i,n),t=c.line-s.start.line;if(this.u(s.bufferIndex,s.end)-this.u(s.bufferIndex,s.start)===n){const f=this.t(i.piece.bufferIndex,s.start,c);if(f!==t)return{index:f,remainder:0}}return{index:t,remainder:c.column}}B(i,n){if(n<0)return 0;const s=i.piece,c=this.a[s.bufferIndex].lineStarts,t=s.start.line+n+1;return t>s.end.line?c[s.end.line]+s.end.column-c[s.start.line]-s.start.column:c[t]-c[s.start.line]-s.start.column}C(i,n){const s=i.piece,c=s.lineFeedCnt,t=this.u(s.bufferIndex,s.end),f=n,h=this.u(s.bufferIndex,f),r=this.t(s.bufferIndex,s.start,f),a=r-c,d=h-t,$=s.length+d;i.piece=new v(s.bufferIndex,s.start,f,r,$),(0,A.$dC)(this,i,d,a)}D(i,n){const s=i.piece,c=s.lineFeedCnt,t=this.u(s.bufferIndex,s.start),f=n,h=this.t(s.bufferIndex,f,s.end),r=this.u(s.bufferIndex,f),a=h-c,d=t-r,$=s.length+d;i.piece=new v(s.bufferIndex,f,s.end,h,$),(0,A.$dC)(this,i,d,a)}E(i,n,s){const c=i.piece,t=c.start,f=c.end,h=c.length,r=c.lineFeedCnt,a=n,d=this.t(c.bufferIndex,c.start,a),$=this.u(c.bufferIndex,n)-this.u(c.bufferIndex,t);i.piece=new v(c.bufferIndex,c.start,a,d,$),(0,A.$dC)(this,i,$-h,d-r);const D=new v(c.bufferIndex,s,f,this.t(c.bufferIndex,s,f),this.u(c.bufferIndex,f)-this.u(c.bufferIndex,s)),b=this.S(i,D);this.N(b)}F(i,n){this.Q(n,i)&&(n+=`
`);const s=this.K()&&this.L(n)&&this.M(i),c=this.a[0].buffer.length;this.a[0].buffer+=n;const t=M(n,!1);for(let b=0;b<t.length;b++)t[b]+=c;if(s){const b=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:c-b}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const f=this.a[0].lineStarts.length-1,h=this.a[0].buffer.length-this.a[0].lineStarts[f],r={line:f,column:h},a=i.piece.length+n.length,d=i.piece.lineFeedCnt,$=this.t(0,i.piece.start,r),D=$-d;i.piece=new v(i.piece.bufferIndex,i.piece.start,r,$,a),this.g=r,(0,A.$dC)(this,i,n.length,D)}G(i){let n=this.root;const s=this.h.get(i);if(s)return{node:s.node,nodeStartOffset:s.nodeStartOffset,remainder:i-s.nodeStartOffset};let c=0;for(;n!==A.$9B;)if(n.size_left>i)n=n.left;else if(n.size_left+n.piece.length>=i){c+=n.size_left;const t={node:n,remainder:i-n.size_left,nodeStartOffset:c};return this.h.set(t),t}else i-=n.size_left+n.piece.length,c+=n.size_left+n.piece.length,n=n.right;return null}H(i,n){let s=this.root,c=0;for(;s!==A.$9B;)if(s.left!==A.$9B&&s.lf_left>=i-1)s=s.left;else if(s.lf_left+s.piece.lineFeedCnt>i-1){const t=this.B(s,i-s.lf_left-2),f=this.B(s,i-s.lf_left-1);return c+=s.size_left,{node:s,remainder:Math.min(t+n-1,f),nodeStartOffset:c}}else if(s.lf_left+s.piece.lineFeedCnt===i-1){const t=this.B(s,i-s.lf_left-2);if(t+n-1<=s.piece.length)return{node:s,remainder:t+n-1,nodeStartOffset:c};n-=s.piece.length-t;break}else i-=s.lf_left+s.piece.lineFeedCnt,c+=s.size_left+s.piece.length,s=s.right;for(s=s.next();s!==A.$9B;){if(s.piece.lineFeedCnt>0){const t=this.B(s,0),f=this.J(s);return{node:s,remainder:Math.min(n-1,t),nodeStartOffset:f}}else if(s.piece.length>=n-1){const t=this.J(s);return{node:s,remainder:n-1,nodeStartOffset:t}}else n-=s.piece.length;s=s.next()}return null}I(i,n){if(i.piece.lineFeedCnt<1)return-1;const s=this.a[i.piece.bufferIndex],c=this.u(i.piece.bufferIndex,i.piece.start)+n;return s.buffer.charCodeAt(c)}J(i){if(!i)return 0;let n=i.size_left;for(;i!==this.root;)i.parent.right===i&&(n+=i.parent.size_left+i.parent.piece.length),i=i.parent;return n}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===A.$9B||i.piece.lineFeedCnt===0)return!1;const n=i.piece,s=this.a[n.bufferIndex].lineStarts,c=n.start.line,t=s[c]+n.start.column;return c===s.length-1||s[c+1]>t+1?!1:this.a[n.bufferIndex].buffer.charCodeAt(t)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===A.$9B||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const n=i.prev();this.M(n)&&this.P(n,i)}}O(i){if(this.K()&&this.M(i)){const n=i.next();this.L(n)&&this.P(i,n)}}P(i,n){const s=[],c=this.a[i.piece.bufferIndex].lineStarts;let t;i.piece.end.column===0?t={line:i.piece.end.line-1,column:c[i.piece.end.line]-c[i.piece.end.line-1]-1}:t={line:i.piece.end.line,column:i.piece.end.column-1};const f=i.piece.length-1,h=i.piece.lineFeedCnt-1;i.piece=new v(i.piece.bufferIndex,i.piece.start,t,h,f),(0,A.$dC)(this,i,-1,-1),i.piece.length===0&&s.push(i);const r={line:n.piece.start.line+1,column:0},a=n.piece.length-1,d=this.t(n.piece.bufferIndex,r,n.piece.end);n.piece=new v(n.piece.bufferIndex,r,n.piece.end,d,a),(0,A.$dC)(this,n,-1,-1),n.piece.length===0&&s.push(n);const $=this.w(`\r
`);this.S(i,$[0]);for(let D=0;D<s.length;D++)(0,A.$bC)(this,s[D])}Q(i,n){if(this.K()&&this.M(i)){const s=n.next();if(this.L(s)){if(i+=`
`,s.piece.length===1)(0,A.$bC)(this,s);else{const c=s.piece,t={line:c.start.line+1,column:0},f=c.length-1,h=this.t(c.bufferIndex,t,c.end);s.piece=new v(c.bufferIndex,t,c.end,h,f),(0,A.$dC)(this,s,-1,-1)}return!0}}return!1}iterate(i,n){if(i===A.$9B)return n(A.$9B);const s=this.iterate(i.left,n);return s&&n(i)&&this.iterate(i.right,n)}R(i){if(i===A.$9B)return"";const n=this.a[i.piece.bufferIndex],s=i.piece,c=this.u(s.bufferIndex,s.start),t=this.u(s.bufferIndex,s.end);return n.buffer.substring(c,t)}getPieceContent(i){const n=this.a[i.bufferIndex],s=this.u(i.bufferIndex,i.start),c=this.u(i.bufferIndex,i.end);return n.buffer.substring(s,c)}S(i,n){const s=new A.$8B(n,1);if(s.left=A.$9B,s.right=A.$9B,s.parent=A.$9B,s.size_left=0,s.lf_left=0,this.root===A.$9B)this.root=s,s.color=0;else if(i.right===A.$9B)i.right=s,s.parent=i;else{const t=(0,A.$0B)(i.right);t.left=s,s.parent=t}return(0,A.$cC)(this,s),s}T(i,n){const s=new A.$8B(n,1);if(s.left=A.$9B,s.right=A.$9B,s.parent=A.$9B,s.size_left=0,s.lf_left=0,this.root===A.$9B)this.root=s,s.color=0;else if(i.left===A.$9B)i.left=s,s.parent=i;else{const c=(0,A.$$B)(i.left);c.right=s,s.parent=c}return(0,A.$cC)(this,s),s}U(i){let n="";return this.iterate(i,s=>(n+=this.R(s),!0)),n}}e.$pC=m}),define(Se[182],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K9=e.$J9=void 0;class l{constructor(){this.a=new Map}removeDragOperationTransfer(A){if(A&&this.a.has(A)){const R=this.a.get(A);return this.a.delete(A),R}}addDragOperationTransfer(A,R){this.a.set(A,R)}}e.$J9=l;class j{constructor(A){this.identifier=A}}e.$K9=j}),define(Se[183],De([1,0,4,3]),function(fe,e,l,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ht=void 0;class L{constructor(){this.a=new Map,this.b=new Map,this.c=new l.$5d,this.onDidChange=this.c.event,this.d=null}handleChange(p){this.c.fire({changedLanguages:p,changedColorMap:!1})}register(p,w){return this.a.set(p,w),this.handleChange([p]),(0,j.$Rc)(()=>{this.a.get(p)===w&&(this.a.delete(p),this.handleChange([p]))})}get(p){return this.a.get(p)||null}registerFactory(p,w){this.b.get(p)?.dispose();const E=new A(this,p,w);return this.b.set(p,E),(0,j.$Rc)(()=>{const M=this.b.get(p);!M||M!==E||(this.b.delete(p),M.dispose())})}async getOrCreate(p){const w=this.get(p);if(w)return w;const E=this.b.get(p);return!E||E.isResolved?null:(await E.resolve(),this.get(p))}isResolved(p){if(this.get(p))return!0;const E=this.b.get(p);return!!(!E||E.isResolved)}setColorMap(p){this.d=p,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$Ht=L;class A extends j.$Tc{get isResolved(){return this.c}constructor(p,w,E){super(),this.f=p,this.g=w,this.h=E,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const p=await this.h.tokenizationSupport;this.c=!0,p&&!this.a&&this.B(this.f.register(this.g,p))}}}),define(Se[184],De([9,10]),function(fe,e){return fe.create("vs/base/common/actions",e)}),define(Se[185],De([1,0,4,3,184]),function(fe,e,l,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=void 0;class A extends j.$Tc{constructor(v,S="",k="",u=!0,m){super(),this.h=this.B(new l.$5d),this.onDidChange=this.h.event,this.w=!0,this.j=v,this.m=S,this.u=k,this.w=u,this.C=m}get id(){return this.j}get label(){return this.m}set label(v){this.D(v)}D(v){this.m!==v&&(this.m=v,this.h.fire({label:v}))}get tooltip(){return this.n||""}set tooltip(v){this.F(v)}F(v){this.n!==v&&(this.n=v,this.h.fire({tooltip:v}))}get class(){return this.u}set class(v){this.G(v)}G(v){this.u!==v&&(this.u=v,this.h.fire({class:v}))}get enabled(){return this.w}set enabled(v){this.H(v)}H(v){this.w!==v&&(this.w=v,this.h.fire({enabled:v}))}get checked(){return this.z}set checked(v){this.I(v)}I(v){this.z!==v&&(this.z=v,this.h.fire({checked:v}))}async run(v,S){this.C&&await this.C(v)}}e.$Wi=A;class R extends j.$Tc{constructor(){super(...arguments),this.f=this.B(new l.$5d),this.onWillRun=this.f.event,this.m=this.B(new l.$5d),this.onDidRun=this.m.event}async run(v,S){if(!v.enabled)return;this.f.fire({action:v});let k;try{await this.u(v,S)}catch(u){k=u}this.m.fire({action:v,error:k})}async u(v,S){await v.run(S)}}e.$Xi=R;class p{constructor(){this.id=p.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...v){let S=[];for(const k of v)k.length&&(S.length?S=[...S,new p,...k]:S=k);return S}static{this.ID="vs.actions.separator"}async run(){}}e.$Yi=p;class w{get actions(){return this.a}constructor(v,S,k,u){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=v,this.label=S,this.class=u,this.a=k}async run(){}}e.$Zi=w;class E extends A{static{this.ID="vs.actions.empty"}constructor(){super(E.ID,L.localize(0,null),void 0,!1)}}e.$1i=E;function M(C){return{id:C.id,label:C.label,class:C.class,enabled:C.enabled??!0,checked:C.checked,run:async(...v)=>C.run(...v),tooltip:C.label}}e.$2i=M}),define(Se[186],De([9,10]),function(fe,e){return fe.create("vs/base/common/date",e)}),define(Se[187],De([1,0,186]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lm=e.$Km=e.$Jm=void 0;const j=60,L=j*60,A=L*24,R=A*7,p=A*30,w=A*365;function E(v,S,k,u){typeof v!="number"&&(v=v.getTime());const m=Math.round((new Date().getTime()-v)/1e3);if(m<-30)return(0,l.localize)(0,null,E(new Date().getTime()+m*1e3,!1));if(!u&&m<30)return(0,l.localize)(1,null);let o;return m<j?(o=m,S?o===1?k?(0,l.localize)(2,null,o):(0,l.localize)(3,null,o):k?(0,l.localize)(4,null,o):(0,l.localize)(5,null,o):o===1?k?(0,l.localize)(6,null,o):(0,l.localize)(7,null,o):k?(0,l.localize)(8,null,o):(0,l.localize)(9,null,o)):m<L?(o=Math.floor(m/j),S?o===1?k?(0,l.localize)(10,null,o):(0,l.localize)(11,null,o):k?(0,l.localize)(12,null,o):(0,l.localize)(13,null,o):o===1?k?(0,l.localize)(14,null,o):(0,l.localize)(15,null,o):k?(0,l.localize)(16,null,o):(0,l.localize)(17,null,o)):m<A?(o=Math.floor(m/L),S?o===1?k?(0,l.localize)(18,null,o):(0,l.localize)(19,null,o):k?(0,l.localize)(20,null,o):(0,l.localize)(21,null,o):o===1?k?(0,l.localize)(22,null,o):(0,l.localize)(23,null,o):k?(0,l.localize)(24,null,o):(0,l.localize)(25,null,o)):m<R?(o=Math.floor(m/A),S?o===1?(0,l.localize)(26,null,o):(0,l.localize)(27,null,o):o===1?(0,l.localize)(28,null,o):(0,l.localize)(29,null,o)):m<p?(o=Math.floor(m/R),S?o===1?k?(0,l.localize)(30,null,o):(0,l.localize)(31,null,o):k?(0,l.localize)(32,null,o):(0,l.localize)(33,null,o):o===1?k?(0,l.localize)(34,null,o):(0,l.localize)(35,null,o):k?(0,l.localize)(36,null,o):(0,l.localize)(37,null,o)):m<w?(o=Math.floor(m/p),S?o===1?k?(0,l.localize)(38,null,o):(0,l.localize)(39,null,o):k?(0,l.localize)(40,null,o):(0,l.localize)(41,null,o):o===1?k?(0,l.localize)(42,null,o):(0,l.localize)(43,null,o):k?(0,l.localize)(44,null,o):(0,l.localize)(45,null,o)):(o=Math.floor(m/w),S?o===1?k?(0,l.localize)(46,null,o):(0,l.localize)(47,null,o):k?(0,l.localize)(48,null,o):(0,l.localize)(49,null,o):o===1?k?(0,l.localize)(50,null,o):(0,l.localize)(51,null,o):k?(0,l.localize)(52,null,o):(0,l.localize)(53,null,o))}e.$Jm=E;function M(v,S){const k=Math.abs(v/1e3);return k<1?S?(0,l.localize)(54,null,v):(0,l.localize)(55,null,v):k<j?S?(0,l.localize)(56,null,Math.round(v)/1e3):(0,l.localize)(57,null,Math.round(v)/1e3):k<L?S?(0,l.localize)(58,null,Math.round(v/(1e3*j))):(0,l.localize)(59,null,Math.round(v/(1e3*j))):k<A?S?(0,l.localize)(60,null,Math.round(v/(1e3*L))):(0,l.localize)(61,null,Math.round(v/(1e3*L))):(0,l.localize)(62,null,Math.round(v/(1e3*A)))}e.$Km=M;function C(v){return v.getFullYear()+"-"+String(v.getMonth()+1).padStart(2,"0")+"-"+String(v.getDate()).padStart(2,"0")+"T"+String(v.getHours()).padStart(2,"0")+":"+String(v.getMinutes()).padStart(2,"0")+":"+String(v.getSeconds()).padStart(2,"0")+"."+(v.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$Lm=C}),define(Se[188],De([9,10]),function(fe,e){return fe.create("vs/base/common/errorMessage",e)}),define(Se[44],De([1,0,19,18,188]),function(fe,e,l,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5i=e.$4i=e.$3i=void 0;function A(C,v){return v&&(C.stack||C.stacktrace)?L.localize(0,null,p(C),R(C.stack)||R(C.stacktrace)):p(C)}function R(C){return Array.isArray(C)?C.join(`
`):C}function p(C){return C.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${C.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?L.localize(1,null,C.message):C.message||L.localize(2,null)}function w(C=null,v=!1){if(!C)return L.localize(3,null);if(Array.isArray(C)){const S=l.$Hb(C),k=w(S[0],v);return S.length>1?L.localize(4,null,k,S.length):k}if(j.$Sf(C))return C;if(C.detail){const S=C.detail;if(S.error)return A(S.error,v);if(S.exception)return A(S.exception,v)}return C.stack?A(C,v):C.message?C.message:L.localize(5,null)}e.$3i=w;function E(C){const v=C;return v instanceof Error&&Array.isArray(v.actions)}e.$4i=E;function M(C,v){let S;return typeof C=="string"?S=new Error(C):S=C,S.actions=v,S}e.$5i=M}),define(Se[189],De([9,10]),function(fe,e){return fe.create("vs/base/common/platform",e)}),define(Se[11],De([1,0,189]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let j=!1,L=!1,A=!1,R=!1,p=!1,w=!1,E=!1,M=!1,C=!1,v=!1,S,k=e.$g,u=e.$g,m,o;const i=globalThis;let n;typeof i.vscode<"u"&&typeof i.vscode.process<"u"?n=i.vscode.process:typeof process<"u"&&(n=process);const s=typeof n?.versions?.electron=="string",c=s&&n?.type==="renderer";if(typeof n=="object"){j=n.platform==="win32",L=n.platform==="darwin",A=n.platform==="linux",R=A&&!!n.env.SNAP&&!!n.env.SNAP_REVISION,E=s,C=!!n.env.CI||!!n.env.BUILD_ARTIFACTSTAGINGDIRECTORY,S=e.$g,k=e.$g;const g=n.env.VSCODE_NLS_CONFIG;if(g)try{const y=JSON.parse(g),P=y.availableLanguages["*"];S=y.locale,u=y.osLocale,k=P||e.$g,m=y._translationsConfigFile}catch{}p=!0}else typeof navigator=="object"&&!c?(o=navigator.userAgent,j=o.indexOf("Windows")>=0,L=o.indexOf("Macintosh")>=0,M=(o.indexOf("Macintosh")>=0||o.indexOf("iPad")>=0||o.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=o.indexOf("Linux")>=0,v=o?.indexOf("Mobi")>=0,w=!0,S=l.getConfiguredDefaultLocale(l.localize(0,null))||e.$g,k=S,u=navigator.language):console.error("Unable to resolve platform.");var t;(function(g){g[g.Web=0]="Web",g[g.Mac=1]="Mac",g[g.Linux=2]="Linux",g[g.Windows=3]="Windows"})(t||(e.Platform=t={}));function f(g){switch(g){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=f;let h=0;L?h=1:j?h=3:A&&(h=2),e.$i=j,e.$j=L,e.$k=A,e.$l=R,e.$m=p,e.$n=E,e.$o=w,e.$p=w&&typeof i.importScripts=="function",e.$q=e.$p?i.origin:void 0,e.$r=M,e.$s=v,e.$t=C,e.$u=h,e.$v=o,e.$w=k;var r;(function(g){function y(){return e.$w}g.value=y;function P(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}g.isDefaultVariant=P;function N(){return e.$w==="en"}g.isDefault=N})(r||(e.Language=r={})),e.$x=S,e.$y=u,e.$z=m,e.$A=typeof i.postMessage=="function"&&!i.importScripts,e.$B=(()=>{if(e.$A){const g=[];i.addEventListener("message",P=>{if(P.data&&P.data.vscodeScheduleAsyncWork)for(let N=0,U=g.length;N<U;N++){const z=g[N];if(z.id===P.data.vscodeScheduleAsyncWork){g.splice(N,1),z.callback();return}}});let y=0;return P=>{const N=++y;g.push({id:N,callback:P}),i.postMessage({vscodeScheduleAsyncWork:N},"*")}}return g=>setTimeout(g)})();var a;(function(g){g[g.Windows=1]="Windows",g[g.Macintosh=2]="Macintosh",g[g.Linux=3]="Linux"})(a||(e.OperatingSystem=a={})),e.OS=L||M?2:j?1:3;let d=!0,$=!1;function D(){if(!$){$=!0;const g=new Uint8Array(2);g[0]=1,g[1]=2,d=new Uint16Array(g.buffer)[0]===513}return d}e.$D=D,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function b(g){return parseFloat(g)>=20}e.$J=b}),define(Se[50],De([1,0,11]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let j;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.process<"u"){const A=L.process;j={get platform(){return A.platform},get arch(){return A.arch},get env(){return A.env},cwd(){return A.cwd()}}}else typeof process<"u"?j={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:j={get platform(){return l.$i?"win32":l.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=j.cwd,e.env=j.env,e.$dc=j.platform,e.$ec=j.arch}),define(Se[17],De([1,0,50]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const j=65,L=97,A=90,R=122,p=46,w=47,E=92,M=58,C=63;class v extends Error{constructor(f,h,r){let a;typeof h=="string"&&h.indexOf("not ")===0?(a="must not be",h=h.replace(/^not /,"")):a="must be";const d=f.indexOf(".")!==-1?"property":"argument";let $=`The "${f}" ${d} ${a} of type ${h}`;$+=`. Received type ${typeof r}`,super($),this.code="ERR_INVALID_ARG_TYPE"}}function S(t,f){if(t===null||typeof t!="object")throw new v(f,"Object",t)}function k(t,f){if(typeof t!="string")throw new v(f,"string",t)}const u=l.$dc==="win32";function m(t){return t===w||t===E}function o(t){return t===w}function i(t){return t>=j&&t<=A||t>=L&&t<=R}function n(t,f,h,r){let a="",d=0,$=-1,D=0,b=0;for(let g=0;g<=t.length;++g){if(g<t.length)b=t.charCodeAt(g);else{if(r(b))break;b=w}if(r(b)){if(!($===g-1||D===1))if(D===2){if(a.length<2||d!==2||a.charCodeAt(a.length-1)!==p||a.charCodeAt(a.length-2)!==p){if(a.length>2){const y=a.lastIndexOf(h);y===-1?(a="",d=0):(a=a.slice(0,y),d=a.length-1-a.lastIndexOf(h)),$=g,D=0;continue}else if(a.length!==0){a="",d=0,$=g,D=0;continue}}f&&(a+=a.length>0?`${h}..`:"..",d=2)}else a.length>0?a+=`${h}${t.slice($+1,g)}`:a=t.slice($+1,g),d=g-$-1;$=g,D=0}else b===p&&D!==-1?++D:D=-1}return a}function s(t,f){S(f,"pathObject");const h=f.dir||f.root,r=f.base||`${f.name||""}${f.ext||""}`;return h?h===f.root?`${h}${r}`:`${h}${t}${r}`:r}e.$fc={resolve(...t){let f="",h="",r=!1;for(let a=t.length-1;a>=-1;a--){let d;if(a>=0){if(d=t[a],k(d,"path"),d.length===0)continue}else f.length===0?d=l.cwd():(d=l.env[`=${f}`]||l.cwd(),(d===void 0||d.slice(0,2).toLowerCase()!==f.toLowerCase()&&d.charCodeAt(2)===E)&&(d=`${f}\\`));const $=d.length;let D=0,b="",g=!1;const y=d.charCodeAt(0);if($===1)m(y)&&(D=1,g=!0);else if(m(y))if(g=!0,m(d.charCodeAt(1))){let P=2,N=P;for(;P<$&&!m(d.charCodeAt(P));)P++;if(P<$&&P!==N){const U=d.slice(N,P);for(N=P;P<$&&m(d.charCodeAt(P));)P++;if(P<$&&P!==N){for(N=P;P<$&&!m(d.charCodeAt(P));)P++;(P===$||P!==N)&&(b=`\\\\${U}\\${d.slice(N,P)}`,D=P)}}}else D=1;else i(y)&&d.charCodeAt(1)===M&&(b=d.slice(0,2),D=2,$>2&&m(d.charCodeAt(2))&&(g=!0,D=3));if(b.length>0)if(f.length>0){if(b.toLowerCase()!==f.toLowerCase())continue}else f=b;if(r){if(f.length>0)break}else if(h=`${d.slice(D)}\\${h}`,r=g,g&&f.length>0)break}return h=n(h,!r,"\\",m),r?`${f}\\${h}`:`${f}${h}`||"."},normalize(t){k(t,"path");const f=t.length;if(f===0)return".";let h=0,r,a=!1;const d=t.charCodeAt(0);if(f===1)return o(d)?"\\":t;if(m(d))if(a=!0,m(t.charCodeAt(1))){let D=2,b=D;for(;D<f&&!m(t.charCodeAt(D));)D++;if(D<f&&D!==b){const g=t.slice(b,D);for(b=D;D<f&&m(t.charCodeAt(D));)D++;if(D<f&&D!==b){for(b=D;D<f&&!m(t.charCodeAt(D));)D++;if(D===f)return`\\\\${g}\\${t.slice(b)}\\`;D!==b&&(r=`\\\\${g}\\${t.slice(b,D)}`,h=D)}}}else h=1;else i(d)&&t.charCodeAt(1)===M&&(r=t.slice(0,2),h=2,f>2&&m(t.charCodeAt(2))&&(a=!0,h=3));let $=h<f?n(t.slice(h),!a,"\\",m):"";return $.length===0&&!a&&($="."),$.length>0&&m(t.charCodeAt(f-1))&&($+="\\"),r===void 0?a?`\\${$}`:$:a?`${r}\\${$}`:`${r}${$}`},isAbsolute(t){k(t,"path");const f=t.length;if(f===0)return!1;const h=t.charCodeAt(0);return m(h)||f>2&&i(h)&&t.charCodeAt(1)===M&&m(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let f,h;for(let d=0;d<t.length;++d){const $=t[d];k($,"path"),$.length>0&&(f===void 0?f=h=$:f+=`\\${$}`)}if(f===void 0)return".";let r=!0,a=0;if(typeof h=="string"&&m(h.charCodeAt(0))){++a;const d=h.length;d>1&&m(h.charCodeAt(1))&&(++a,d>2&&(m(h.charCodeAt(2))?++a:r=!1))}if(r){for(;a<f.length&&m(f.charCodeAt(a));)a++;a>=2&&(f=`\\${f.slice(a)}`)}return e.$fc.normalize(f)},relative(t,f){if(k(t,"from"),k(f,"to"),t===f)return"";const h=e.$fc.resolve(t),r=e.$fc.resolve(f);if(h===r||(t=h.toLowerCase(),f=r.toLowerCase(),t===f))return"";let a=0;for(;a<t.length&&t.charCodeAt(a)===E;)a++;let d=t.length;for(;d-1>a&&t.charCodeAt(d-1)===E;)d--;const $=d-a;let D=0;for(;D<f.length&&f.charCodeAt(D)===E;)D++;let b=f.length;for(;b-1>D&&f.charCodeAt(b-1)===E;)b--;const g=b-D,y=$<g?$:g;let P=-1,N=0;for(;N<y;N++){const z=t.charCodeAt(a+N);if(z!==f.charCodeAt(D+N))break;z===E&&(P=N)}if(N!==y){if(P===-1)return r}else{if(g>y){if(f.charCodeAt(D+N)===E)return r.slice(D+N+1);if(N===2)return r.slice(D+N)}$>y&&(t.charCodeAt(a+N)===E?P=N:N===2&&(P=3)),P===-1&&(P=0)}let U="";for(N=a+P+1;N<=d;++N)(N===d||t.charCodeAt(N)===E)&&(U+=U.length===0?"..":"\\..");return D+=P,U.length>0?`${U}${r.slice(D,b)}`:(r.charCodeAt(D)===E&&++D,r.slice(D,b))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const f=e.$fc.resolve(t);if(f.length<=2)return t;if(f.charCodeAt(0)===E){if(f.charCodeAt(1)===E){const h=f.charCodeAt(2);if(h!==C&&h!==p)return`\\\\?\\UNC\\${f.slice(2)}`}}else if(i(f.charCodeAt(0))&&f.charCodeAt(1)===M&&f.charCodeAt(2)===E)return`\\\\?\\${f}`;return t},dirname(t){k(t,"path");const f=t.length;if(f===0)return".";let h=-1,r=0;const a=t.charCodeAt(0);if(f===1)return m(a)?t:".";if(m(a)){if(h=r=1,m(t.charCodeAt(1))){let D=2,b=D;for(;D<f&&!m(t.charCodeAt(D));)D++;if(D<f&&D!==b){for(b=D;D<f&&m(t.charCodeAt(D));)D++;if(D<f&&D!==b){for(b=D;D<f&&!m(t.charCodeAt(D));)D++;if(D===f)return t;D!==b&&(h=r=D+1)}}}}else i(a)&&t.charCodeAt(1)===M&&(h=f>2&&m(t.charCodeAt(2))?3:2,r=h);let d=-1,$=!0;for(let D=f-1;D>=r;--D)if(m(t.charCodeAt(D))){if(!$){d=D;break}}else $=!1;if(d===-1){if(h===-1)return".";d=h}return t.slice(0,d)},basename(t,f){f!==void 0&&k(f,"ext"),k(t,"path");let h=0,r=-1,a=!0,d;if(t.length>=2&&i(t.charCodeAt(0))&&t.charCodeAt(1)===M&&(h=2),f!==void 0&&f.length>0&&f.length<=t.length){if(f===t)return"";let $=f.length-1,D=-1;for(d=t.length-1;d>=h;--d){const b=t.charCodeAt(d);if(m(b)){if(!a){h=d+1;break}}else D===-1&&(a=!1,D=d+1),$>=0&&(b===f.charCodeAt($)?--$===-1&&(r=d):($=-1,r=D))}return h===r?r=D:r===-1&&(r=t.length),t.slice(h,r)}for(d=t.length-1;d>=h;--d)if(m(t.charCodeAt(d))){if(!a){h=d+1;break}}else r===-1&&(a=!1,r=d+1);return r===-1?"":t.slice(h,r)},extname(t){k(t,"path");let f=0,h=-1,r=0,a=-1,d=!0,$=0;t.length>=2&&t.charCodeAt(1)===M&&i(t.charCodeAt(0))&&(f=r=2);for(let D=t.length-1;D>=f;--D){const b=t.charCodeAt(D);if(m(b)){if(!d){r=D+1;break}continue}a===-1&&(d=!1,a=D+1),b===p?h===-1?h=D:$!==1&&($=1):h!==-1&&($=-1)}return h===-1||a===-1||$===0||$===1&&h===a-1&&h===r+1?"":t.slice(h,a)},format:s.bind(null,"\\"),parse(t){k(t,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return f;const h=t.length;let r=0,a=t.charCodeAt(0);if(h===1)return m(a)?(f.root=f.dir=t,f):(f.base=f.name=t,f);if(m(a)){if(r=1,m(t.charCodeAt(1))){let P=2,N=P;for(;P<h&&!m(t.charCodeAt(P));)P++;if(P<h&&P!==N){for(N=P;P<h&&m(t.charCodeAt(P));)P++;if(P<h&&P!==N){for(N=P;P<h&&!m(t.charCodeAt(P));)P++;P===h?r=P:P!==N&&(r=P+1)}}}}else if(i(a)&&t.charCodeAt(1)===M){if(h<=2)return f.root=f.dir=t,f;if(r=2,m(t.charCodeAt(2))){if(h===3)return f.root=f.dir=t,f;r=3}}r>0&&(f.root=t.slice(0,r));let d=-1,$=r,D=-1,b=!0,g=t.length-1,y=0;for(;g>=r;--g){if(a=t.charCodeAt(g),m(a)){if(!b){$=g+1;break}continue}D===-1&&(b=!1,D=g+1),a===p?d===-1?d=g:y!==1&&(y=1):d!==-1&&(y=-1)}return D!==-1&&(d===-1||y===0||y===1&&d===D-1&&d===$+1?f.base=f.name=t.slice($,D):(f.name=t.slice($,d),f.base=t.slice($,D),f.ext=t.slice(d,D))),$>0&&$!==r?f.dir=t.slice(0,$-1):f.dir=f.root,f},sep:"\\",delimiter:";",win32:null,posix:null};const c=(()=>{if(u){const t=/\\/g;return()=>{const f=l.cwd().replace(t,"/");return f.slice(f.indexOf("/"))}}return()=>l.cwd()})();e.$gc={resolve(...t){let f="",h=!1;for(let r=t.length-1;r>=-1&&!h;r--){const a=r>=0?t[r]:c();k(a,"path"),a.length!==0&&(f=`${a}/${f}`,h=a.charCodeAt(0)===w)}return f=n(f,!h,"/",o),h?`/${f}`:f.length>0?f:"."},normalize(t){if(k(t,"path"),t.length===0)return".";const f=t.charCodeAt(0)===w,h=t.charCodeAt(t.length-1)===w;return t=n(t,!f,"/",o),t.length===0?f?"/":h?"./":".":(h&&(t+="/"),f?`/${t}`:t)},isAbsolute(t){return k(t,"path"),t.length>0&&t.charCodeAt(0)===w},join(...t){if(t.length===0)return".";let f;for(let h=0;h<t.length;++h){const r=t[h];k(r,"path"),r.length>0&&(f===void 0?f=r:f+=`/${r}`)}return f===void 0?".":e.$gc.normalize(f)},relative(t,f){if(k(t,"from"),k(f,"to"),t===f||(t=e.$gc.resolve(t),f=e.$gc.resolve(f),t===f))return"";const h=1,r=t.length,a=r-h,d=1,$=f.length-d,D=a<$?a:$;let b=-1,g=0;for(;g<D;g++){const P=t.charCodeAt(h+g);if(P!==f.charCodeAt(d+g))break;P===w&&(b=g)}if(g===D)if($>D){if(f.charCodeAt(d+g)===w)return f.slice(d+g+1);if(g===0)return f.slice(d+g)}else a>D&&(t.charCodeAt(h+g)===w?b=g:g===0&&(b=0));let y="";for(g=h+b+1;g<=r;++g)(g===r||t.charCodeAt(g)===w)&&(y+=y.length===0?"..":"/..");return`${y}${f.slice(d+b)}`},toNamespacedPath(t){return t},dirname(t){if(k(t,"path"),t.length===0)return".";const f=t.charCodeAt(0)===w;let h=-1,r=!0;for(let a=t.length-1;a>=1;--a)if(t.charCodeAt(a)===w){if(!r){h=a;break}}else r=!1;return h===-1?f?"/":".":f&&h===1?"//":t.slice(0,h)},basename(t,f){f!==void 0&&k(f,"ext"),k(t,"path");let h=0,r=-1,a=!0,d;if(f!==void 0&&f.length>0&&f.length<=t.length){if(f===t)return"";let $=f.length-1,D=-1;for(d=t.length-1;d>=0;--d){const b=t.charCodeAt(d);if(b===w){if(!a){h=d+1;break}}else D===-1&&(a=!1,D=d+1),$>=0&&(b===f.charCodeAt($)?--$===-1&&(r=d):($=-1,r=D))}return h===r?r=D:r===-1&&(r=t.length),t.slice(h,r)}for(d=t.length-1;d>=0;--d)if(t.charCodeAt(d)===w){if(!a){h=d+1;break}}else r===-1&&(a=!1,r=d+1);return r===-1?"":t.slice(h,r)},extname(t){k(t,"path");let f=-1,h=0,r=-1,a=!0,d=0;for(let $=t.length-1;$>=0;--$){const D=t.charCodeAt($);if(D===w){if(!a){h=$+1;break}continue}r===-1&&(a=!1,r=$+1),D===p?f===-1?f=$:d!==1&&(d=1):f!==-1&&(d=-1)}return f===-1||r===-1||d===0||d===1&&f===r-1&&f===h+1?"":t.slice(f,r)},format:s.bind(null,"/"),parse(t){k(t,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return f;const h=t.charCodeAt(0)===w;let r;h?(f.root="/",r=1):r=0;let a=-1,d=0,$=-1,D=!0,b=t.length-1,g=0;for(;b>=r;--b){const y=t.charCodeAt(b);if(y===w){if(!D){d=b+1;break}continue}$===-1&&(D=!1,$=b+1),y===p?a===-1?a=b:g!==1&&(g=1):a!==-1&&(g=-1)}if($!==-1){const y=d===0&&h?1:d;a===-1||g===0||g===1&&a===$-1&&a===d+1?f.base=f.name=t.slice(y,$):(f.name=t.slice(y,a),f.base=t.slice(y,$),f.ext=t.slice(a,$))}return d>0?f.dir=t.slice(0,d-1):h&&(f.dir="/"),f},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=u?e.$fc.normalize:e.$gc.normalize,e.$ic=u?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=u?e.$fc.join:e.$gc.join,e.$kc=u?e.$fc.resolve:e.$gc.resolve,e.$lc=u?e.$fc.relative:e.$gc.relative,e.$mc=u?e.$fc.dirname:e.$gc.dirname,e.$nc=u?e.$fc.basename:e.$gc.basename,e.$oc=u?e.$fc.extname:e.$gc.extname,e.$pc=u?e.$fc.format:e.$gc.format,e.$qc=u?e.$fc.parse:e.$gc.parse,e.$rc=u?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=u?e.$fc.sep:e.$gc.sep,e.$tc=u?e.$fc.delimiter:e.$gc.delimiter}),define(Se[131],De([1,0,43,17]),function(fe,e,l,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=e.$8q=e.$7q=e.$6q=e.$5q=e.$4q=e.$3q=e.$2q=e.$1q=e.$Zq=e.$Yq=e.$Xq=e.$Wq=void 0;const L=new l.$V(()=>{const D=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:D,collatorIsNumeric:D.resolvedOptions().numeric}}),A=new l.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new l.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function p(D,b,g=!1){const y=D||"",P=b||"",N=L.value.collator.compare(y,P);return L.value.collatorIsNumeric&&N===0&&y!==P?y<P?-1:1:N}e.$Wq=p;function w(D,b){const g=A.value.collator;return D=D||"",b=b||"",s(g,D,b)}e.$Xq=w;function E(D,b){const g=A.value.collator;return D=D||"",b=b||"",h(D,b)||s(g,D,b)}e.$Yq=E;function M(D,b){const g=A.value.collator;return D=D||"",b=b||"",f(D,b)||s(g,D,b)}e.$Zq=M;function C(D,b){return D=D||"",b=b||"",D===b?0:D<b?-1:1}e.$1q=C;function v(D,b){const[g,y]=i(D),[P,N]=i(b);let U=L.value.collator.compare(y,N);if(U===0){if(L.value.collatorIsNumeric&&y!==N)return y<N?-1:1;if(U=L.value.collator.compare(g,P),L.value.collatorIsNumeric&&U===0&&g!==P)return g<P?-1:1}return U}e.$2q=v;function S(D,b){D=D||"",b=b||"";const g=n(D),y=n(b),P=A.value.collator,N=R.value.collator;return s(N,g,y)||s(P,D,b)}e.$3q=S;function k(D,b){D=D||"",b=b||"";const g=n(D),y=n(b),P=A.value.collator,N=R.value.collator;return s(N,g,y)||h(D,b)||s(P,D,b)}e.$4q=k;function u(D,b){D=D||"",b=b||"";const g=n(D),y=n(b),P=A.value.collator,N=R.value.collator;return s(N,g,y)||f(D,b)||s(P,D,b)}e.$5q=u;function m(D,b){D=D||"",b=b||"";const g=n(D).toLowerCase(),y=n(b).toLowerCase();return g!==y?g<y?-1:1:D!==b?D<b?-1:1:0}e.$6q=m;const o=/^(.*?)(\.([^.]*))?$/;function i(D,b=!1){const g=D?o.exec(D):[];let y=[g&&g[1]||"",g&&g[3]||""];return b&&(!y[0]&&y[1]||y[0]&&y[0].charAt(0)===".")&&(y=[y[0]+"."+y[1],""]),y}function n(D){const b=D?o.exec(D):[];return b&&b[1]&&b[1].charAt(0)!=="."&&b[3]||""}function s(D,b,g){const y=D.compare(b,g);return y!==0?y:b.length!==g.length?b.length<g.length?-1:1:0}function c(D){const b=D.charAt(0);return b.toLocaleUpperCase()!==b}function t(D){const b=D.charAt(0);return b.toLocaleLowerCase()!==b}function f(D,b){return c(D)&&t(b)?-1:t(D)&&c(b)?1:0}function h(D,b){return t(D)&&c(b)?-1:c(D)&&t(b)?1:0}function r(D,b,g=!1){return g||(D=D&&D.toLowerCase(),b=b&&b.toLowerCase()),D===b?0:D<b?-1:1}function a(D,b,g=!1){const y=D.split(j.sep),P=b.split(j.sep),N=y.length-1,U=P.length-1;let z,F;for(let I=0;;I++){if(z=N===I,F=U===I,z&&F)return p(y[I],P[I],g);if(z)return-1;if(F)return 1;const O=r(y[I],P[I],g);if(O!==0)return O}}e.$7q=a;function d(D,b,g){const y=D.toLowerCase(),P=b.toLowerCase(),N=$(D,b,g);if(N)return N;const U=y.endsWith(g),z=P.endsWith(g);if(U!==z)return U?-1:1;const F=p(y,P);return F!==0?F:y.localeCompare(P)}e.$8q=d;function $(D,b,g){const y=D.toLowerCase(),P=b.toLowerCase(),N=y.startsWith(g),U=P.startsWith(g);if(N!==U)return N?-1:1;if(N&&U){if(y.length<P.length)return-1;if(y.length>P.length)return 1}return 0}e.$9q=$}),define(Se[34],De([1,0,17,11,14,18]),function(fe,e,l,j,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=void 0;function R(d){return d===47||d===92}e.$$f=R;function p(d){return d.replace(/[\\/]/g,l.$gc.sep)}e.$_f=p;function w(d){return d.indexOf("/")===-1&&(d=p(d)),/^[a-zA-Z]:(\/|$)/.test(d)&&(d="/"+d),d}e.$ag=w;function E(d,$=l.$gc.sep){if(!d)return"";const D=d.length,b=d.charCodeAt(0);if(R(b)){if(R(d.charCodeAt(1))&&!R(d.charCodeAt(2))){let y=3;const P=y;for(;y<D&&!R(d.charCodeAt(y));y++);if(P!==y&&!R(d.charCodeAt(y+1))){for(y+=1;y<D;y++)if(R(d.charCodeAt(y)))return d.slice(0,y+1).replace(/[\\/]/g,$)}}return $}else if(o(b)&&d.charCodeAt(1)===58)return R(d.charCodeAt(2))?d.slice(0,2)+$:d.slice(0,2);let g=d.indexOf("://");if(g!==-1){for(g+=3;g<D;g++)if(R(d.charCodeAt(g)))return d.slice(0,g+1)}return""}e.$bg=E;function M(d){if(!j.$i||!d||d.length<5)return!1;let $=d.charCodeAt(0);if($!==92||($=d.charCodeAt(1),$!==92))return!1;let D=2;const b=D;for(;D<d.length&&($=d.charCodeAt(D),$!==92);D++);return!(b===D||($=d.charCodeAt(D+1),isNaN($)||$===92))}e.$cg=M;const C=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,S=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function k(d,$=j.$i){const D=$?C:v;return!(!d||d.length===0||/^\s+$/.test(d)||(D.lastIndex=0,D.test(d))||$&&S.test(d)||d==="."||d===".."||$&&d[d.length-1]==="."||$&&d.length!==d.trim().length||d.length>255)}e.$dg=k;function u(d,$,D){const b=d===$;return!D||b?b:!d||!$?!1:(0,L.$jf)(d,$)}e.$eg=u;function m(d,$,D,b=l.sep){if(d===$)return!0;if(!d||!$||$.length>d.length)return!1;if(D){if(!(0,L.$kf)(d,$))return!1;if($.length===d.length)return!0;let y=$.length;return $.charAt($.length-1)===b&&y--,d.charAt(y)===b}return $.charAt($.length-1)!==b&&($+=b),d.indexOf($)===0}e.$fg=m;function o(d){return d>=65&&d<=90||d>=97&&d<=122}e.$gg=o;function i(d,$){return j.$i&&d.endsWith(":")&&(d+=l.sep),(0,l.$ic)(d)||(d=(0,l.$jc)($,d)),d=(0,l.$hc)(d),j.$i?(d=(0,L.$4e)(d,l.sep),d.endsWith(":")&&(d+=l.sep)):(d=(0,L.$4e)(d,l.sep),d||(d=l.sep)),d}e.$hg=i;function n(d){const $=(0,l.$hc)(d);return j.$i?d.length>3?!1:s($)&&(d.length===2||$.charCodeAt(2)===92):$===l.$gc.sep}e.$ig=n;function s(d,$=j.$i){return $?o(d.charCodeAt(0))&&d.charCodeAt(1)===58:!1}e.$jg=s;function c(d,$=j.$i){return s(d,$)?d[0]:void 0}e.$kg=c;function t(d,$,D){return $.length>d.length?-1:d===$?0:(D&&(d=d.toLowerCase(),$=$.toLowerCase()),d.indexOf($))}e.$lg=t;function f(d){const $=d.split(":");let D,b,g;for(const y of $){const P=Number(y);(0,A.$Wf)(P)?b===void 0?b=P:g===void 0&&(g=P):D=D?[D,y].join(":"):y}if(!D)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:D,line:b!==void 0?b:void 0,column:g!==void 0?g:b!==void 0?1:void 0}}e.$mg=f;const h="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",r="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function a(d,$,D=8){let b="";for(let y=0;y<D;y++){let P;y===0&&j.$i&&!$&&(D===3||D===4)?P=r:P=h,b+=P.charAt(Math.floor(Math.random()*P.length))}let g;return $?g=`${$}-${b}`:g=b,d?(0,l.$jc)(d,g):g}e.$ng=a}),define(Se[132],De([1,0,131,126,54,17,11,14]),function(fe,e,l,j,L,A,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=e.$br=e.$ar=e.$_q=e.$$q=e.$0q=void 0;const w=0,E=[w,[]];function M(T,G,te,x){if(!T||!G)return E;const X=T.length,Q=G.length;if(X<Q)return E;const ae=T.toLowerCase();return C(G,te,Q,T,ae,X,x)}e.$0q=M;function C(T,G,te,x,X,Q,ae){const _=[],ge=[];for(let ie=0;ie<te;ie++){const ye=ie*Q,le=ye-Q,ue=ie>0,ce=T[ie],de=G[ie];for(let H=0;H<Q;H++){const Z=H>0,he=ye+H,be=he-1,Pe=le+H-1,pe=Z?_[be]:0,Ae=ue&&Z?_[Pe]:0,Oe=ue&&Z?ge[Pe]:0;let ze;!Ae&&ue?ze=0:ze=v(ce,de,x,X,H,Oe),ze&&Ae+ze>=pe&&(ae||ue||X.startsWith(G,H))?(ge[he]=Oe+1,_[he]=Ae+ze):(ge[he]=w,_[he]=pe)}}const se=[];let re=te-1,B=Q-1;for(;re>=0&&B>=0;){const ie=re*Q+B;ge[ie]===w||(se.push(B),re--),B--}return[_[te*Q-1],se.reverse()]}function v(T,G,te,x,X,Q){let ae=0;if(!S(G,x[X]))return ae;if(ae+=1,Q>0&&(ae+=Q*5),T===te[X]&&(ae+=1),X===0)ae+=8;else{const _=k(te.charCodeAt(X-1));_?ae+=_:(0,j.$0j)(te.charCodeAt(X))&&Q===0&&(ae+=2)}return ae}function S(T,G){return T===G?!0:T==="/"||T==="\\"?G==="/"||G==="\\":!1}function k(T){switch(T){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const u=[void 0,[]];function m(T,G,te=0,x=0){const X=G;return X.values&&X.values.length>1?o(T,X.values,te,x):i(T,G,te,x)}e.$$q=m;function o(T,G,te,x){let X=0;const Q=[];for(const ae of G){const[_,ge]=i(T,ae,te,x);if(typeof _!="number")return u;X+=_,Q.push(...ge)}return[X,D(Q)]}function i(T,G,te,x){const X=(0,j.$gk)(G.original,G.originalLowercase,te,T,T.toLowerCase(),x,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return X?[X[0],(0,j.$dk)(X)]:u}const n=Object.freeze({score:0}),s=1<<18,c=1<<17,t=65536;function f(T,G,te,x){const X=x.values?x.values:[x];return(0,L.$6i)({[x.normalized]:{values:X.map(ae=>({value:ae.normalized,expectContiguousMatch:ae.expectContiguousMatch})),label:T,description:G,allowNonContiguousMatches:te}})}function h(T,G,te,x,X){if(!T||!G.normalized)return n;const Q=x.getItemLabel(T);if(!Q)return n;const ae=x.getItemDescription(T),_=f(Q,ae,te,G),ge=X[_];if(ge)return ge;const se=r(Q,ae,x.getItemPath(T),G,te);return X[_]=se,se}e.$_q=h;function r(T,G,te,x,X){const Q=!te||!x.containsPathSeparator;return te&&(R.$k?x.pathNormalized===te:(0,p.$jf)(x.pathNormalized,te))?{score:s,labelMatch:[{start:0,end:T.length}],descriptionMatch:G?[{start:0,end:G.length}]:void 0}:x.values&&x.values.length>1?a(T,G,te,x.values,Q,X):d(T,G,te,x,Q,X)}function a(T,G,te,x,X,Q){let ae=0;const _=[],ge=[];for(const se of x){const{score:re,labelMatch:B,descriptionMatch:ie}=d(T,G,te,se,X,Q);if(re===w)return n;ae+=re,B&&_.push(...B),ie&&ge.push(...ie)}return{score:ae,labelMatch:D(_),descriptionMatch:D(ge)}}function d(T,G,te,x,X,Q){if(X||!G){const[ae,_]=M(T,x.normalized,x.normalizedLowercase,Q&&!x.expectContiguousMatch);if(ae){const ge=(0,j.$7j)(x.normalized,T);let se;if(ge){se=c;const re=Math.round(x.normalized.length/T.length*100);se+=re}else se=t;return{score:se+ae,labelMatch:ge||$(_)}}}if(G){let ae=G;te&&(ae=`${G}${A.sep}`);const _=ae.length,ge=`${ae}${T}`,[se,re]=M(ge,x.normalized,x.normalizedLowercase,Q&&!x.expectContiguousMatch);if(se){const B=$(re),ie=[],ye=[];return B.forEach(le=>{le.start<_&&le.end>_?(ie.push({start:0,end:le.end-_}),ye.push({start:le.start,end:_})):le.start>=_?ie.push({start:le.start-_,end:le.end-_}):ye.push(le)}),{score:se,labelMatch:ie,descriptionMatch:ye}}}return n}function $(T){const G=[];if(!T)return G;let te;for(const x of T)te&&te.end===x?te.end+=1:(te={start:x,end:x+1},G.push(te));return G}function D(T){const G=T.sort((X,Q)=>X.start-Q.start),te=[];let x;for(const X of G)!x||!b(x,X)?(x=X,te.push(X)):(x.start=Math.min(x.start,X.start),x.end=Math.max(x.end,X.end));return te}function b(T,G){return!(T.end<G.start||G.end<T.start)}function g(T,G,te,x,X,Q){const ae=h(T,te,x,X,Q),_=h(G,te,x,X,Q),ge=ae.score,se=_.score;if((ge===s||se===s)&&ge!==se)return ge===s?-1:1;if(ge>t||se>t){if(ge!==se)return ge>se?-1:1;if(ge<c&&se<c){const ce=P(ae.labelMatch,_.labelMatch);if(ce!==0)return ce}const le=X.getItemLabel(T)||"",ue=X.getItemLabel(G)||"";if(le.length!==ue.length)return le.length-ue.length}if(ge!==se)return ge>se?-1:1;const re=Array.isArray(ae.labelMatch)&&ae.labelMatch.length>0,B=Array.isArray(_.labelMatch)&&_.labelMatch.length>0;if(re&&!B)return-1;if(B&&!re)return 1;const ie=y(T,ae,X),ye=y(G,_,X);return ie&&ye&&ie!==ye?ye>ie?-1:1:N(T,G,te,X)}e.$ar=g;function y(T,G,te){let x=-1,X=-1;if(G.descriptionMatch&&G.descriptionMatch.length?x=G.descriptionMatch[0].start:G.labelMatch&&G.labelMatch.length&&(x=G.labelMatch[0].start),G.labelMatch&&G.labelMatch.length){if(X=G.labelMatch[G.labelMatch.length-1].end,G.descriptionMatch&&G.descriptionMatch.length){const Q=te.getItemDescription(T);Q&&(X+=Q.length)}}else G.descriptionMatch&&G.descriptionMatch.length&&(X=G.descriptionMatch[G.descriptionMatch.length-1].end);return X-x}function P(T,G){if(!T&&!G||(!T||!T.length)&&(!G||!G.length))return 0;if(!G||!G.length)return-1;if(!T||!T.length)return 1;const te=T[0].start,X=T[T.length-1].end-te,Q=G[0].start,_=G[G.length-1].end-Q;return X===_?0:_<X?1:-1}function N(T,G,te,x){const X=x.getItemLabel(T)||"",Q=x.getItemLabel(G)||"",ae=x.getItemDescription(T),_=x.getItemDescription(G),ge=X.length+(ae?ae.length:0),se=Q.length+(_?_.length:0);if(ge!==se)return ge-se;const re=x.getItemPath(T),B=x.getItemPath(G);return re&&B&&re.length!==B.length?re.length-B.length:X!==Q?(0,l.$8q)(X,Q,te.normalized):ae&&_&&ae!==_?(0,l.$8q)(ae,_,te.normalized):re&&B&&re!==B?(0,l.$8q)(re,B,te.normalized):0}function U(T){return T.startsWith('"')&&T.endsWith('"')}const z=" ";function F(T){typeof T!="string"&&(T="");const G=T.toLowerCase(),{pathNormalized:te,normalized:x,normalizedLowercase:X}=I(T),Q=te.indexOf(A.sep)>=0,ae=U(T);let _;const ge=T.split(z);if(ge.length>1)for(const se of ge){const re=U(se),{pathNormalized:B,normalized:ie,normalizedLowercase:ye}=I(se);ie&&(_||(_=[]),_.push({original:se,originalLowercase:se.toLowerCase(),pathNormalized:B,normalized:ie,normalizedLowercase:ye,expectContiguousMatch:re}))}return{original:T,originalLowercase:G,pathNormalized:te,normalized:x,normalizedLowercase:X,values:_,containsPathSeparator:Q,expectContiguousMatch:ae}}e.$br=F;function I(T){let G;R.$i?G=T.replace(/\//g,A.sep):G=T.replace(/\\/g,A.sep);const te=(0,p.$6e)(G).replace(/\s|"/g,"");return{pathNormalized:G,normalized:te,normalizedLowercase:te.toLowerCase()}}function O(T){return Array.isArray(T)?F(T.map(G=>G.original).join(z)):F(T.original)}e.$cr=O}),define(Se[101],De([1,0,17]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xs=e.$ws=e.$vs=e.$us=e.$ts=void 0,e.$ts=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const j={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},L={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(M){const C=(0,l.$oc)(M),v=j[C.toLowerCase()];return v!==void 0?v:R(M)}e.$us=A;function R(M){const C=(0,l.$oc)(M);return L[C.toLowerCase()]}e.$vs=R;function p(M){for(const C in L)if(L[C]===M)return C}e.$ws=p;const w=/^(.+)\/(.+?)(;.+)?$/;function E(M,C){const v=w.exec(M);return v?`${v[1].toLowerCase()}/${v[2].toLowerCase()}${v[3]??""}`:C?void 0:M}e.$xs=E}),define(Se[102],De([1,0,11]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3l=e.$2l=e.TerminateResponseCode=e.Source=void 0;var j;(function(p){p[p.stdout=0]="stdout",p[p.stderr=1]="stderr"})(j||(e.Source=j={}));var L;(function(p){p[p.Success=0]="Success",p[p.Unknown=1]="Unknown",p[p.AccessDenied=2]="AccessDenied",p[p.ProcessNotFound=3]="ProcessNotFound"})(L||(e.TerminateResponseCode=L={}));function A(p,...w){const E=w.reduce((v,S)=>(v[S]=!0,v),{}),M=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(p).filter(v=>!E[v]).forEach(v=>{for(let S=0;S<M.length;S++)if(v.search(M[S])!==-1){delete p[v];break}})}e.$2l=A;function R(p){p&&(delete p.DEBUG,l.$j&&delete p.DYLD_LIBRARY_PATH,l.$k&&delete p.LD_PRELOAD)}e.$3l=R}),define(Se[2],De([1,0,17,11]),function(fe,e,l,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const L=/^\w[\w\d+.-]*$/,A=/^\//,R=/^\/\//;function p(r,a){if(!r.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!L.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!A.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(R.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function w(r,a){return!r&&!a?"file":r}function E(r,a){switch(r){case"https":case"http":case"file":a?a[0]!==C&&(a=C+a):a=C;break}return a}const M="",C="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class S{static isUri(a){return a instanceof S?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}constructor(a,d,$,D,b,g=!1){typeof a=="object"?(this.scheme=a.scheme||M,this.authority=a.authority||M,this.path=a.path||M,this.query=a.query||M,this.fragment=a.fragment||M):(this.scheme=w(a,g),this.authority=d||M,this.path=E(this.scheme,$||M),this.query=D||M,this.fragment=b||M,p(this,g))}get fsPath(){return s(this,!1)}with(a){if(!a)return this;let{scheme:d,authority:$,path:D,query:b,fragment:g}=a;return d===void 0?d=this.scheme:d===null&&(d=M),$===void 0?$=this.authority:$===null&&($=M),D===void 0?D=this.path:D===null&&(D=M),b===void 0?b=this.query:b===null&&(b=M),g===void 0?g=this.fragment:g===null&&(g=M),d===this.scheme&&$===this.authority&&D===this.path&&b===this.query&&g===this.fragment?this:new m(d,$,D,b,g)}static parse(a,d=!1){const $=v.exec(a);return $?new m($[2]||M,h($[4]||M),h($[5]||M),h($[7]||M),h($[9]||M),d):new m(M,M,M,M,M)}static file(a){let d=M;if(j.$i&&(a=a.replace(/\\/g,C)),a[0]===C&&a[1]===C){const $=a.indexOf(C,2);$===-1?(d=a.substring(2),a=C):(d=a.substring(2,$),a=a.substring($)||C)}return new m("file",d,a,M,M)}static from(a,d){return new m(a.scheme,a.authority,a.path,a.query,a.fragment,d)}static joinPath(a,...d){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let $;return j.$i&&a.scheme==="file"?$=S.file(l.$fc.join(s(a,!0),...d)).path:$=l.$gc.join(a.path,...d),a.with({path:$})}toString(a=!1){return c(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof S)return a;{const d=new m(a);return d._formatted=a.external??null,d._fsPath=a._sep===u?a.fsPath??null:null,d}}else return a}}e.URI=S;function k(r){return!r||typeof r!="object"?!1:typeof r.scheme=="string"&&(typeof r.authority=="string"||typeof r.authority>"u")&&(typeof r.path=="string"||typeof r.path>"u")&&(typeof r.query=="string"||typeof r.query>"u")&&(typeof r.fragment=="string"||typeof r.fragment>"u")}e.$vc=k;const u=j.$i?1:void 0;class m extends S{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=s(this,!1)),this._fsPath}toString(a=!1){return a?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=u),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const o={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function i(r,a,d){let $,D=-1;for(let b=0;b<r.length;b++){const g=r.charCodeAt(b);if(g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57||g===45||g===46||g===95||g===126||a&&g===47||d&&g===91||d&&g===93||d&&g===58)D!==-1&&($+=encodeURIComponent(r.substring(D,b)),D=-1),$!==void 0&&($+=r.charAt(b));else{$===void 0&&($=r.substr(0,b));const y=o[g];y!==void 0?(D!==-1&&($+=encodeURIComponent(r.substring(D,b)),D=-1),$+=y):D===-1&&(D=b)}}return D!==-1&&($+=encodeURIComponent(r.substring(D))),$!==void 0?$:r}function n(r){let a;for(let d=0;d<r.length;d++){const $=r.charCodeAt(d);$===35||$===63?(a===void 0&&(a=r.substr(0,d)),a+=o[$]):a!==void 0&&(a+=r[d])}return a!==void 0?a:r}function s(r,a){let d;return r.authority&&r.path.length>1&&r.scheme==="file"?d=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?a?d=r.path.substr(1):d=r.path[1].toLowerCase()+r.path.substr(2):d=r.path,j.$i&&(d=d.replace(/\//g,"\\")),d}e.$wc=s;function c(r,a){const d=a?n:i;let $="",{scheme:D,authority:b,path:g,query:y,fragment:P}=r;if(D&&($+=D,$+=":"),(b||D==="file")&&($+=C,$+=C),b){let N=b.indexOf("@");if(N!==-1){const U=b.substr(0,N);b=b.substr(N+1),N=U.lastIndexOf(":"),N===-1?$+=d(U,!1,!1):($+=d(U.substr(0,N),!1,!1),$+=":",$+=d(U.substr(N+1),!1,!0)),$+="@"}b=b.toLowerCase(),N=b.lastIndexOf(":"),N===-1?$+=d(b,!1,!0):($+=d(b.substr(0,N),!1,!0),$+=b.substr(N))}if(g){if(g.length>=3&&g.charCodeAt(0)===47&&g.charCodeAt(2)===58){const N=g.charCodeAt(1);N>=65&&N<=90&&(g=`/${String.fromCharCode(N+32)}:${g.substr(3)}`)}else if(g.length>=2&&g.charCodeAt(1)===58){const N=g.charCodeAt(0);N>=65&&N<=90&&(g=`${String.fromCharCode(N+32)}:${g.substr(2)}`)}$+=d(g,!0,!1)}return y&&($+="?",$+=d(y,!1,!1)),P&&($+="#",$+=a?P:i(P,!1,!1)),$}function t(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+t(r.substr(3)):r}}const f=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function h(r){return r.match(f)?r.replace(f,a=>t(a)):r}}),define(Se[190],De([1,0,2]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Cq=e.$Bq=e.$Aq=void 0;function j(E){const M=E;return M&&typeof M.type=="string"&&typeof M.severity=="string"}e.$Aq=j;function L(E){const M=[];let C;try{const v=JSON.parse(E.arguments),S=v[v.length-1];S&&S.__$stack&&(v.pop(),C=S.__$stack),M.push(...v)}catch{M.push("Unable to log remote console arguments",E.arguments)}return{args:M,stack:C}}e.$Bq=L;function A(E){if(typeof E!="string")return A(L(E).stack);const M=E;if(M){const C=R(M),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(v&&v.length===4)return{uri:l.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}e.$Cq=A;function R(E){if(!E)return E;const M=E.indexOf(`
`);return M===-1?E:E.substring(0,M)}function p(E,M){const{args:C,stack:v}=L(E),S=typeof C[0]=="string"&&C.length===1;let k=R(v);k&&(k=`(${k.trim()})`);let u=[];if(typeof C[0]=="string"?k&&S?u=[`%c[${M}] %c${C[0]} %c${k}`,w("blue"),w(""),w("grey")]:u=[`%c[${M}] %c${C[0]}`,w("blue"),w(""),...C.slice(1)]:u=[`%c[${M}]%`,w("blue"),...C],k&&!S&&u.push(k),typeof console[E.severity]!="function")throw new Error("Unknown console method");console[E.severity].apply(console,u)}e.log=p;function w(E){return`color: ${E}`}}),define(Se[56],De([1,0,21,2]),function(fe,e,l,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oh=e.$Nh=e.$Mh=void 0;function L(w){return JSON.stringify(w,R)}e.$Mh=L;function A(w){let E=JSON.parse(w);return E=p(E),E}e.$Nh=A;function R(w,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:E.flags}:E}function p(w,E=0){if(!w||E>200)return w;if(typeof w=="object"){switch(w.$mid){case 1:return j.URI.revive(w);case 2:return new RegExp(w.source,w.flags);case 17:return new Date(w.source)}if(w instanceof l.$se||w instanceof Uint8Array)return w;if(Array.isArray(w))for(let M=0;M<w.length;++M)w[M]=p(w[M],E+1);else for(const M in w)Object.hasOwnProperty.call(w,M)&&(w[M]=p(w[M],E+1))}return w}e.$Oh=p}),define(Se[15],De([1,0,13,11,14,2,17]),function(fe,e,l,j,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.Schemas=void 0;var p;(function(k){k.inMemory="inmemory",k.vscode="vscode",k.internal="private",k.walkThrough="walkThrough",k.walkThroughSnippet="walkThroughSnippet",k.http="http",k.https="https",k.file="file",k.mailto="mailto",k.untitled="untitled",k.data="data",k.command="command",k.vscodeRemote="vscode-remote",k.vscodeRemoteResource="vscode-remote-resource",k.vscodeManagedRemoteResource="vscode-managed-remote-resource",k.vscodeUserData="vscode-userdata",k.vscodeCustomEditor="vscode-custom-editor",k.vscodeNotebookCell="vscode-notebook-cell",k.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",k.vscodeNotebookCellOutput="vscode-notebook-cell-output",k.vscodeInteractiveInput="vscode-interactive-input",k.vscodeSettings="vscode-settings",k.vscodeWorkspaceTrust="vscode-workspace-trust",k.vscodeTerminal="vscode-terminal",k.vscodeChatCodeBlock="vscode-chat-code-block",k.vscodeChatSesssion="vscode-chat-editor",k.webviewPanel="webview-panel",k.vscodeWebview="vscode-webview",k.extension="extension",k.vscodeFileResource="vscode-file",k.tmp="tmp",k.vsls="vsls",k.vscodeSourceControl="vscode-scm",k.codeSetting="code-setting"})(p||(e.Schemas=p={}));function w(k,u){return A.URI.isUri(k)?(0,L.$jf)(k.scheme,u):(0,L.$kf)(k,u+":")}e.$og=w;function E(k,...u){return u.some(m=>w(k,m))}e.$pg=E,e.$qg="vscode-tkn",e.$rg="tkn";class M{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(u){this.d=u}setDelegate(u){this.e=u}setServerRootPath(u,m){this.f=C(u,m)}getServerRootPath(){return this.f}get g(){return R.$gc.join(this.f,p.vscodeRemoteResource)}set(u,m,o){this.a[u]=m,this.b[u]=o}setConnectionToken(u,m){this.c[u]=m}getPreferredWebSchema(){return this.d}rewrite(u){if(this.e)try{return this.e(u)}catch(c){return l.$1(c),u}const m=u.authority;let o=this.a[m];o&&o.indexOf(":")!==-1&&o.indexOf("[")===-1&&(o=`[${o}]`);const i=this.b[m],n=this.c[m];let s=`path=${encodeURIComponent(u.path)}`;return typeof n=="string"&&(s+=`&${e.$rg}=${encodeURIComponent(n)}`),A.URI.from({scheme:j.$o?this.d:p.vscodeRemoteResource,authority:`${o}:${i}`,path:this.g,query:s})}}e.$sg=new M;function C(k,u){return R.$gc.join(u??"/",`${k.quality??"oss"}-${k.commit??"dev"}`)}e.$tg=C,e.$ug="vs/../../extensions",e.$vg="vs/../../node_modules",e.$wg="vs/../../node_modules.asar",e.$xg="vs/../../node_modules.asar.unpacked",e.$yg="vscode-app";class v{static{this.a=e.$yg}asBrowserUri(u){const m=this.b(u,fe);return this.uriToBrowserUri(m)}uriToBrowserUri(u){return u.scheme===p.vscodeRemote?e.$sg.rewrite(u):u.scheme===p.file&&(j.$m||j.$q===`${p.vscodeFileResource}://${v.a}`)?u.with({scheme:p.vscodeFileResource,authority:u.authority||v.a,query:null,fragment:null}):u}asFileUri(u){const m=this.b(u,fe);return this.uriToFileUri(m)}uriToFileUri(u){return u.scheme===p.vscodeFileResource?u.with({scheme:p.file,authority:u.authority!==v.a?u.authority:null,query:null,fragment:null}):u}b(u,m){return A.URI.isUri(u)?u:A.URI.parse(m.toUrl(u))}}e.$zg=new v;var S;(function(k){const u=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);k.CoopAndCoep=Object.freeze(u.get("3"));const m="vscode-coi";function o(n){let s;typeof n=="string"?s=new URL(n).searchParams:n instanceof URL?s=n.searchParams:A.URI.isUri(n)&&(s=new URL(n.toString(!0)).searchParams);const c=s?.get(m);if(c)return u.get(c)}k.getHeadersFromQuery=o;function i(n,s,c){if(!globalThis.crossOriginIsolated)return;const t=s&&c?"3":c?"2":"1";n instanceof URLSearchParams?n.set(m,t):n[m]=t}k.addSearchParam=i})(S||(e.COI=S={}))}),define(Se[191],De([1,0,161,15,11,2]),function(fe,e,l,j,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wD=void 0;class R{constructor(v,S,k){this.id=v,this.dependencies=S,this.callback=k}}class p{static{this.INSTANCE=new p}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(v,S,k)=>{typeof v!="string"&&(k=S,S=v,v=null),(typeof S!="object"||!Array.isArray(S))&&(k=S,S=null),this.c.push(new R(v,S,k))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(v){if(v.startsWith(window.location.origin)||v.startsWith("vscode-file://vscode-app"))return v;throw new Error(`[trusted_script_src] Invalid script url: ${v}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(v){return v}})))}async load(v){this.g();const S=await(this.a?this.i(v):this.b?this.h(v):this.j(v));if(!S)throw new Error(`Did not receive a define call from script ${v}`);if(Array.isArray(S.dependencies)&&S.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${v}. The dependencies are: ${S.dependencies.join(", ")}`);return typeof S.callback=="function"?S.callback([]):S.callback}h(v){return new Promise((S,k)=>{const u=document.createElement("script");u.setAttribute("async","async"),u.setAttribute("type","text/javascript");const m=()=>{u.removeEventListener("load",o),u.removeEventListener("error",i)},o=n=>{m(),S(this.c.pop())},i=n=>{m(),k(n)};u.addEventListener("load",o),u.addEventListener("error",i),this.f&&(v=this.f.createScriptURL(v)),u.setAttribute("src",v),window.document.getElementsByTagName("head")[0].appendChild(u)})}i(v){return new Promise((S,k)=>{try{this.f&&(v=this.f.createScriptURL(v)),importScripts(v),S(this.c.pop())}catch(u){k(u)}})}async j(v){try{const S=globalThis._VSCODE_NODE_MODULES.fs,k=globalThis._VSCODE_NODE_MODULES.vm,u=globalThis._VSCODE_NODE_MODULES.module,m=A.URI.parse(v).fsPath,o=S.readFileSync(m).toString(),i=u.wrap(o.replace(/^#!.*/,""));return new k.Script(i).runInThisContext().apply(),this.c.pop()}catch(S){throw S}}}const w=new Map;let E={};typeof globalThis.require=="object"&&(E=globalThis.require.paths??{});async function M(C,v,S){if(l.$T){S===void 0&&(S=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),E[C]&&(C=E[C]);const k=`${C}/${v}`;if(w.has(k))return w.get(k);let u;if(/^\w[\w\d+.-]*:\/\//.test(k))u=k;else{const n=`${S&&!L.$o?j.$wg:j.$vg}/${k}`;u=j.$zg.asBrowserUri(n).toString(!0)}const m=p.INSTANCE.load(u);return w.set(k,m),m}else return await new Promise((k,u)=>{fe([C],k,u)})}e.$wD=M}),define(Se[23],De([1,0,34,15,17,11,14,2]),function(fe,e,l,j,L,A,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3g=e.DataUri=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=void 0;function w(S){return(0,p.$wc)(S,!0)}e.$Gg=w;class E{constructor(k){this.a=k}compare(k,u,m=!1){return k===u?0:(0,R.$cf)(this.getComparisonKey(k,m),this.getComparisonKey(u,m))}isEqual(k,u,m=!1){return k===u?!0:!k||!u?!1:this.getComparisonKey(k,m)===this.getComparisonKey(u,m)}getComparisonKey(k,u=!1){return k.with({path:this.a(k)?k.path.toLowerCase():void 0,fragment:u?null:void 0}).toString()}ignorePathCasing(k){return this.a(k)}isEqualOrParent(k,u,m=!1){if(k.scheme===u.scheme){if(k.scheme===j.Schemas.file)return l.$fg(w(k),w(u),this.a(k))&&k.query===u.query&&(m||k.fragment===u.fragment);if((0,e.$Xg)(k.authority,u.authority))return l.$fg(k.path,u.path,this.a(k),"/")&&k.query===u.query&&(m||k.fragment===u.fragment)}return!1}joinPath(k,...u){return p.URI.joinPath(k,...u)}basenameOrAuthority(k){return(0,e.$Pg)(k)||k.authority}basename(k){return L.$gc.basename(k.path)}extname(k){return L.$gc.extname(k.path)}dirname(k){if(k.path.length===0)return k;let u;return k.scheme===j.Schemas.file?u=p.URI.file(L.$mc(w(k))).path:(u=L.$gc.dirname(k.path),k.authority&&u.length&&u.charCodeAt(0)!==47&&(console.error(`dirname("${k.toString})) resulted in a relative path`),u="/")),k.with({path:u})}normalizePath(k){if(!k.path.length)return k;let u;return k.scheme===j.Schemas.file?u=p.URI.file(L.$hc(w(k))).path:u=L.$gc.normalize(k.path),k.with({path:u})}relativePath(k,u){if(k.scheme!==u.scheme||!(0,e.$Xg)(k.authority,u.authority))return;if(k.scheme===j.Schemas.file){const i=L.$lc(w(k),w(u));return A.$i?l.$_f(i):i}let m=k.path||"/";const o=u.path||"/";if(this.a(k)){let i=0;for(const n=Math.min(m.length,o.length);i<n&&!(m.charCodeAt(i)!==o.charCodeAt(i)&&m.charAt(i).toLowerCase()!==o.charAt(i).toLowerCase());i++);m=o.substr(0,i)+m.substr(i)}return L.$gc.relative(m,o)}resolvePath(k,u){if(k.scheme===j.Schemas.file){const m=p.URI.file(L.$kc(w(k),u));return k.with({authority:m.authority,path:m.path})}return u=l.$ag(u),k.with({path:L.$gc.resolve(k.path,u)})}isAbsolutePath(k){return!!k.path&&k.path[0]==="/"}isEqualAuthority(k,u){return k===u||k!==void 0&&u!==void 0&&(0,R.$jf)(k,u)}hasTrailingPathSeparator(k,u=L.sep){if(k.scheme===j.Schemas.file){const m=w(k);return m.length>l.$bg(m).length&&m[m.length-1]===u}else{const m=k.path;return m.length>1&&m.charCodeAt(m.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(k.fsPath)}}removeTrailingPathSeparator(k,u=L.sep){return(0,e.$Yg)(k,u)?k.with({path:k.path.substr(0,k.path.length-1)}):k}addTrailingPathSeparator(k,u=L.sep){let m=!1;if(k.scheme===j.Schemas.file){const o=w(k);m=o!==void 0&&o.length===l.$bg(o).length&&o[o.length-1]===u}else{u="/";const o=k.path;m=o.length===1&&o.charCodeAt(o.length-1)===47}return!m&&!(0,e.$Yg)(k,u)?k.with({path:k.path+"/"}):k}}e.$Hg=E,e.$Ig=new E(()=>!1),e.$Jg=new E(S=>S.scheme===j.Schemas.file?!A.$k:!0),e.$Kg=new E(S=>!0),e.$Lg=e.$Ig.isEqual.bind(e.$Ig),e.$Mg=e.$Ig.isEqualOrParent.bind(e.$Ig),e.$Ng=e.$Ig.getComparisonKey.bind(e.$Ig),e.$Og=e.$Ig.basenameOrAuthority.bind(e.$Ig),e.$Pg=e.$Ig.basename.bind(e.$Ig),e.$Qg=e.$Ig.extname.bind(e.$Ig),e.$Rg=e.$Ig.dirname.bind(e.$Ig),e.$Sg=e.$Ig.joinPath.bind(e.$Ig),e.$Tg=e.$Ig.normalizePath.bind(e.$Ig),e.$Ug=e.$Ig.relativePath.bind(e.$Ig),e.$Vg=e.$Ig.resolvePath.bind(e.$Ig),e.$Wg=e.$Ig.isAbsolutePath.bind(e.$Ig),e.$Xg=e.$Ig.isEqualAuthority.bind(e.$Ig),e.$Yg=e.$Ig.hasTrailingPathSeparator.bind(e.$Ig),e.$Zg=e.$Ig.removeTrailingPathSeparator.bind(e.$Ig),e.$1g=e.$Ig.addTrailingPathSeparator.bind(e.$Ig);function M(S,k){const u=[];for(let m=0;m<S.length;m++){const o=k(S[m]);S.some((i,n)=>n===m?!1:(0,e.$Mg)(o,k(i)))||u.push(S[m])}return u}e.$2g=M;var C;(function(S){S.META_DATA_LABEL="label",S.META_DATA_DESCRIPTION="description",S.META_DATA_SIZE="size",S.META_DATA_MIME="mime";function k(u){const m=new Map;u.path.substring(u.path.indexOf(";")+1,u.path.lastIndexOf(";")).split(";").forEach(n=>{const[s,c]=n.split(":");s&&c&&m.set(s,c)});const i=u.path.substring(0,u.path.indexOf(";"));return i&&m.set(S.META_DATA_MIME,i),m}S.parseMetaData=k})(C||(e.DataUri=C={}));function v(S,k,u){if(k){let m=S.path;return m&&m[0]!==L.$gc.sep&&(m=L.$gc.sep+m),S.with({scheme:u,authority:k,path:m})}return S.with({scheme:u})}e.$3g=v}),define(Se[8],De([1,0,22,13,4,3,23,11,167,43]),function(fe,e,l,j,L,A,R,p,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.Promises=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=void 0;function M(de){return!!de&&typeof de.then=="function"}e.$4g=M;function C(de){const H=new l.$ce,Z=de(H.token),he=new Promise((be,Pe)=>{const pe=H.token.onCancellationRequested(()=>{pe.dispose(),Pe(new j.$5)});Promise.resolve(Z).then(Ae=>{pe.dispose(),H.dispose(),be(Ae)},Ae=>{pe.dispose(),H.dispose(),Pe(Ae)})});return new class{cancel(){H.cancel(),H.dispose()}then(be,Pe){return he.then(be,Pe)}catch(be){return this.then(void 0,be)}finally(be){return he.finally(be)}}}e.$5g=C;function v(de,H,Z){return new Promise((he,be)=>{const Pe=H.onCancellationRequested(()=>{Pe.dispose(),he(Z)});de.then(he,be).finally(()=>Pe.dispose())})}e.$6g=v;function S(de,H){return new Promise((Z,he)=>{const be=H.onCancellationRequested(()=>{be.dispose(),he(new j.$5)});de.then(Z,he).finally(()=>be.dispose())})}e.$7g=S;async function k(de){let H=-1;const Z=de.map((he,be)=>he.then(Pe=>(H=be,Pe)));try{return await Promise.race(Z)}finally{de.forEach((he,be)=>{be!==H&&he.cancel()})}}e.$8g=k;function u(de,H,Z){let he;const be=setTimeout(()=>{he?.(void 0),Z?.()},H);return Promise.race([de.finally(()=>clearTimeout(be)),new Promise(Pe=>he=Pe)])}e.$9g=u;function m(de){return new Promise((H,Z)=>{const he=de();M(he)?he.then(H,Z):H(he)})}e.$0g=m;function o(){let de,H;return{promise:new Promise((he,be)=>{de=he,H=be}),resolve:de,reject:H}}e.$$g=o;class i{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(H){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=H,!this.b){const Z=()=>{if(this.b=null,this.f)return;const he=this.queue(this.d);return this.d=null,he};this.b=new Promise(he=>{this.a.then(Z,Z).then(he)})}return new Promise((Z,he)=>{this.b.then(Z,he)})}return this.a=H(),new Promise((Z,he)=>{this.a.then(be=>{this.a=null,Z(be)},be=>{this.a=null,he(be)})})}dispose(){this.f=!0}}e.$_g=i;class n{constructor(){this.a=Promise.resolve(null)}queue(H){return this.a=this.a.then(()=>H(),()=>H())}}e.$ah=n;class s{constructor(){this.a=new Map}queue(H,Z){const be=(this.a.get(H)??Promise.resolve()).catch(()=>{}).then(Z).finally(()=>{this.a.get(H)===be&&this.a.delete(H)});return this.a.set(H,be),be}}e.$bh=s;const c=(de,H)=>{let Z=!0;const he=setTimeout(()=>{Z=!1,H()},de);return{isTriggered:()=>Z,dispose:()=>{clearTimeout(he),Z=!1}}},t=de=>{let H=!0;return queueMicrotask(()=>{H&&(H=!1,de())}),{isTriggered:()=>H,dispose:()=>{H=!1}}};class f{constructor(H){this.defaultDelay=H,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(H,Z=this.defaultDelay){this.g=H,this.h(),this.b||(this.b=new Promise((be,Pe)=>{this.d=be,this.f=Pe}).then(()=>{if(this.b=null,this.d=null,this.g){const be=this.g;return this.g=null,be()}}));const he=()=>{this.a=null,this.d?.(null)};return this.a=Z===w.$2d?t(he):c(Z,he),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new j.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$ch=f;class h{constructor(H){this.a=new f(H),this.b=new i}trigger(H,Z){return this.a.trigger(()=>this.b.queue(H),Z)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$dh=h;class r{constructor(){this.a=!1,this.b=new Promise((H,Z)=>{this.d=H})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$eh=r;class a extends r{constructor(H){super(),this.f=setTimeout(()=>this.open(),H)}open(){clearTimeout(this.f),super.open()}}e.$fh=a;function d(de,H){return H?new Promise((Z,he)=>{const be=setTimeout(()=>{Pe.dispose(),Z()},de),Pe=H.onCancellationRequested(()=>{clearTimeout(be),Pe.dispose(),he(new j.$5)})}):C(Z=>d(de,Z))}e.$gh=d;function $(de,H=0,Z){const he=setTimeout(()=>{de(),Z&&be.dispose()},H),be=(0,A.$Rc)(()=>{clearTimeout(he),Z?.deleteAndLeak(be)});return Z?.add(be),be}e.$hh=$;function D(de){const H=[];let Z=0;const he=de.length;function be(){return Z<he?de[Z++]():null}function Pe(pe){pe!=null&&H.push(pe);const Ae=be();return Ae?Ae.then(Pe):Promise.resolve(H)}return Promise.resolve(null).then(Pe)}e.$ih=D;function b(de,H=he=>!!he,Z=null){let he=0;const be=de.length,Pe=()=>{if(he>=be)return Promise.resolve(Z);const pe=de[he++];return Promise.resolve(pe()).then(Oe=>H(Oe)?Promise.resolve(Oe):Pe())};return Pe()}e.$jh=b;function g(de,H=he=>!!he,Z=null){if(de.length===0)return Promise.resolve(Z);let he=de.length;const be=()=>{he=-1;for(const Pe of de)Pe.cancel?.()};return new Promise((Pe,pe)=>{for(const Ae of de)Ae.then(Oe=>{--he>=0&&H(Oe)?(be(),Pe(Oe)):he===0&&Pe(Z)}).catch(Oe=>{--he>=0&&(be(),pe(Oe))})})}e.$kh=g;class y{constructor(H){this.a=0,this.b=!1,this.f=H,this.g=[],this.d=0,this.h=new L.$5d}whenIdle(){return this.size>0?L.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(H){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((Z,he)=>{this.g.push({factory:H,c:Z,e:he}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const H=this.g.shift();this.d++;const Z=H.factory();Z.then(H.c,H.e),Z.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$lh=y;class P extends y{constructor(){super(1)}}e.$mh=P;class N{constructor(){this.a=new Q,this.b=0}queue(H){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,H())):this.a.run(this.b++,H())}}e.$nh=N;class U{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const H=new ge;return this.b.add(H),H.p}g(){for(const[,H]of this.a)if(H.size>0)return!1;return!0}queueSize(H,Z=R.$Ig){const he=Z.getComparisonKey(H);return this.a.get(he)?.size??0}queueFor(H,Z,he=R.$Ig){const be=he.getComparisonKey(H);let Pe=this.a.get(be);if(!Pe){Pe=new P;const pe=this.f++,Ae=L.Event.once(Pe.onDrained)(()=>{Pe?.dispose(),this.a.delete(be),this.h(),this.d?.deleteAndDispose(pe),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new A.$3c),this.d.set(pe,Ae),this.a.set(be,Pe)}return Pe.queue(Z)}h(){this.g()&&this.j()}j(){for(const H of this.b)H.complete();this.b.clear()}dispose(){for(const[,H]of this.a)H.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$oh=U;class z{constructor(H,Z){this.a=-1,typeof H=="function"&&typeof Z=="number"&&this.setIfNotSet(H,Z)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(H,Z){this.cancel(),this.a=setTimeout(()=>{this.a=-1,H()},Z)}setIfNotSet(H,Z){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,H()},Z))}}e.$ph=z;class F{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(H,Z,he=globalThis){this.cancel();const be=he.setInterval(()=>{H()},Z);this.d=(0,A.$Rc)(()=>{he.clearInterval(be),this.d=void 0})}dispose(){this.cancel()}}e.$qh=F;class I{constructor(H,Z){this.b=-1,this.a=H,this.d=Z,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(H=this.d){this.cancel(),this.b=setTimeout(this.f,H)}get delay(){return this.d}set delay(H){this.d=H}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$rh=I;class O{constructor(H,Z){Z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Z}ms is not a multiple of 1000ms.`),this.a=H,this.b=Z,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(H=this.b){H%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${H}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(H/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$sh=O;class T extends I{constructor(H,Z){super(H,Z),this.j=[]}work(H){this.j.push(H),this.isScheduled()||this.schedule()}h(){const H=this.j;this.j=[],this.a?.(H)}dispose(){this.j=[],super.dispose()}}e.$th=T;class G extends A.$Tc{constructor(H,Z){super(),this.g=H,this.h=Z,this.a=[],this.b=this.B(new A.$Uc),this.f=!1}get pending(){return this.a.length}work(H){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+H.length>this.g.maxBufferedWork)return!1}else if(this.pending+H.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Z of H)this.a.push(Z);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new I(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$uh=G,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$wh=(de,H)=>{(0,p.$B)(()=>{if(Z)return;const he=Date.now()+15;H(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,he-Date.now())}}))});let Z=!1;return{dispose(){Z||(Z=!0)}}}:e.$wh=(de,H,Z)=>{const he=de.requestIdleCallback(H,typeof Z=="number"?{timeout:Z}:void 0);let be=!1;return{dispose(){be||(be=!0,de.cancelIdleCallback(he))}}},e.$vh=de=>(0,e.$wh)(globalThis,de)}();class te{constructor(H,Z){this.g=!1,this.d=()=>{try{this.j=Z()}catch(he){this.l=he}finally{this.g=!0}},this.f=(0,e.$wh)(H,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$xh=te;class x extends te{constructor(H){super(globalThis,H)}}e.$yh=x;async function X(de,H,Z){let he;for(let be=0;be<Z;be++)try{return await de()}catch(Pe){he=Pe,await d(H)}throw he}e.$zh=X;class Q{isRunning(H){return typeof H=="number"?this.a?.taskId===H:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(H,Z,he){return this.a={taskId:H,cancel:()=>he?.(),promise:Z},Z.then(()=>this.d(H),()=>this.d(H)),Z}d(H){this.a&&H===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const H=this.b;this.b=void 0,H.run().then(H.promiseResolve,H.promiseReject)}}queue(H){if(this.b)this.b.run=H;else{const{promise:Z,resolve:he,reject:be}=o();this.b={run:H,promise:Z,promiseResolve:he,promiseReject:be}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Ah=Q;class ae{constructor(H,Z=()=>Date.now()){this.d=H,this.f=Z,this.a=0,this.b=0}increment(){const H=this.f();return H-this.a>this.d&&(this.a=H,this.b=0),this.b++,this.b}}e.$Bh=ae;var _;(function(de){de[de.Resolved=0]="Resolved",de[de.Rejected=1]="Rejected"})(_||(_={}));class ge{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((H,Z)=>{this.a=H,this.b=Z})}complete(H){return new Promise(Z=>{this.a(H),this.d={outcome:0,value:H},Z()})}error(H){return new Promise(Z=>{this.b(H),this.d={outcome:1,value:H},Z()})}cancel(){return this.error(new j.$5)}}e.$Ch=ge;var se;(function(de){async function H(he){let be;const Pe=await Promise.all(he.map(pe=>pe.then(Ae=>Ae,Ae=>{be||(be=Ae)})));if(typeof be<"u")throw be;return Pe}de.settled=H;function Z(he){return new Promise(async(be,Pe)=>{try{await he(be,Pe)}catch(pe){Pe(pe)}})}de.withAsyncBody=Z})(se||(e.Promises=se={}));class re{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(H){this.a=void 0,this.b=void 0,this.d=!1,this.promise=H.then(Z=>(this.a=Z,this.d=!0,Z),Z=>{throw this.b=Z,this.d=!0,Z})}requireValue(){if(!this.d)throw new j.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Dh=re;class B{constructor(H){this.b=H,this.a=new E.$V(()=>new re(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Eh=B;var ie;(function(de){de[de.Initial=0]="Initial",de[de.DoneOK=1]="DoneOK",de[de.DoneError=2]="DoneError"})(ie||(ie={}));class ye{static fromArray(H){return new ye(Z=>{Z.emitMany(H)})}static fromPromise(H){return new ye(async Z=>{Z.emitMany(await H)})}static fromPromises(H){return new ye(async Z=>{await Promise.all(H.map(async he=>Z.emitOne(await he)))})}static merge(H){return new ye(async Z=>{await Promise.all(H.map(async he=>{for await(const be of he)Z.emitOne(be)}))})}static{this.EMPTY=ye.fromArray([])}constructor(H){this.a=0,this.b=[],this.d=null,this.f=new L.$5d,queueMicrotask(async()=>{const Z={emitOne:he=>this.g(he),emitMany:he=>this.h(he),reject:he=>this.k(he)};try{await Promise.resolve(H(Z)),this.j()}catch(he){this.k(he)}finally{Z.emitOne=void 0,Z.emitMany=void 0,Z.reject=void 0}})}[Symbol.asyncIterator](){let H=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(H<this.b.length)return{done:!1,value:this.b[H++]};if(this.a===1)return{done:!0,value:void 0};await L.Event.toPromise(this.f.event)}while(!0)}}}static map(H,Z){return new ye(async he=>{for await(const be of H)he.emitOne(Z(be))})}map(H){return ye.map(this,H)}static filter(H,Z){return new ye(async he=>{for await(const be of H)Z(be)&&he.emitOne(be)})}filter(H){return ye.filter(this,H)}static coalesce(H){return ye.filter(H,Z=>!!Z)}coalesce(){return ye.coalesce(this)}static async toPromise(H){const Z=[];for await(const he of H)Z.push(he);return Z}toPromise(){return ye.toPromise(this)}g(H){this.a===0&&(this.b.push(H),this.f.fire())}h(H){this.a===0&&(this.b=this.b.concat(H),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(H){this.a===0&&(this.a=2,this.d=H,this.f.fire())}}e.$Fh=ye;class le extends ye{constructor(H,Z){super(Z),this.l=H}cancel(){this.l.cancel()}}e.$Gh=le;function ue(de){const H=new l.$ce,Z=de(H.token);return new le(H,async he=>{const be=H.token.onCancellationRequested(()=>{be.dispose(),H.dispose(),he.reject(new j.$5)});try{for await(const Pe of Z){if(H.token.isCancellationRequested)return;he.emitOne(Pe)}be.dispose(),H.dispose()}catch(Pe){be.dispose(),H.dispose(),he.reject(Pe)}})}e.$Hh=ue;class ce{constructor(){this.a=new ge,this.b=new ye(he=>{if(H){he.reject(H);return}return Z&&he.emitMany(Z),this.d=be=>he.reject(be),this.f=be=>he.emitOne(be),this.a.p});let H,Z;this.f=he=>{Z||(Z=[]),Z.push(he)},this.d=he=>{H||(H=he)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(H){this.d(H),this.a.complete()}emitOne(H){this.f(H)}}e.$Ih=ce}),define(Se[35],De([1,0,19,8,34,28,17,11,14]),function(fe,e,l,j,L,A,R,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=void 0;function E(){return Object.create(null)}e.$Tj=E,e.$Uj="**",e.$Vj="/";const M="[/\\\\]",C="[^/\\\\]",v=/\//g;function S(te,x){switch(te){case 0:return"";case 1:return`${C}*?`;default:return`(?:${M}|${C}+${M}${x?`|${M}${C}+`:""})*?`}}function k(te,x){if(!te)return[];const X=[];let Q=!1,ae=!1,_="";for(const ge of te){switch(ge){case x:if(!Q&&!ae){X.push(_),_="";continue}break;case"{":Q=!0;break;case"}":Q=!1;break;case"[":ae=!0;break;case"]":ae=!1;break}_+=ge}return _&&X.push(_),X}e.$Wj=k;function u(te){if(!te)return"";let x="";const X=k(te,e.$Vj);if(X.every(Q=>Q===e.$Uj))x=".*";else{let Q=!1;X.forEach((ae,_)=>{if(ae===e.$Uj){if(Q)return;x+=S(2,_===X.length-1)}else{let ge=!1,se="",re=!1,B="";for(const ie of ae){if(ie!=="}"&&ge){se+=ie;continue}if(re&&(ie!=="]"||!B)){let ye;ie==="-"?ye=ie:(ie==="^"||ie==="!")&&!B?ye="^":ie===e.$Vj?ye="":ye=(0,w.$Xe)(ie),B+=ye;continue}switch(ie){case"{":ge=!0;continue;case"[":re=!0;continue;case"}":{const le=`(?:${k(se,",").map(ue=>u(ue)).join("|")})`;x+=le,ge=!1,se="";break}case"]":{x+="["+B+"]",re=!1,B="";break}case"?":x+=C;continue;case"*":x+=S(1);continue;default:x+=(0,w.$Xe)(ie)}}_<X.length-1&&(X[_+1]!==e.$Uj||_+2<X.length)&&(x+=M)}Q=ae===e.$Uj})}return x}const m=/^\*\*\/\*\.[\w\.-]+$/,o=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,n=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,s=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new A.$Dc(1e4),f=function(){return!1},h=function(){return null};function r(te,x){if(!te)return h;let X;typeof te!="string"?X=te.pattern:X=te,X=X.trim();const Q=`${X}_${!!x.trimForExclusions}`;let ae=t.get(Q);if(ae)return a(ae,te);let _;return m.test(X)?ae=$(X.substr(4),X):(_=o.exec(d(X,x)))?ae=D(_[1],X):(x.trimForExclusions?n:i).test(X)?ae=b(X,x):(_=s.exec(d(X,x)))?ae=g(_[1].substr(1),X,!0):(_=c.exec(d(X,x)))?ae=g(_[1],X,!1):ae=y(X),t.set(Q,ae),a(ae,te)}function a(te,x){if(typeof x=="string")return te;const X=function(Q,ae){return(0,L.$fg)(Q,x.base,!p.$k)?te((0,w.$3e)(Q.substr(x.base.length),R.sep),ae):null};return X.allBasenames=te.allBasenames,X.allPaths=te.allPaths,X.basenames=te.basenames,X.patterns=te.patterns,X}function d(te,x){return x.trimForExclusions&&te.endsWith("/**")?te.substr(0,te.length-2):te}function $(te,x){return function(X,Q){return typeof X=="string"&&X.endsWith(te)?x:null}}function D(te,x){const X=`/${te}`,Q=`\\${te}`,ae=function(ge,se){return typeof ge!="string"?null:se?se===te?x:null:ge===te||ge.endsWith(X)||ge.endsWith(Q)?x:null},_=[te];return ae.basenames=_,ae.patterns=[x],ae.allBasenames=_,ae}function b(te,x){const X=T(te.slice(1,-1).split(",").map(se=>r(se,x)).filter(se=>se!==h),te),Q=X.length;if(!Q)return h;if(Q===1)return X[0];const ae=function(se,re){for(let B=0,ie=X.length;B<ie;B++)if(X[B](se,re))return te;return null},_=X.find(se=>!!se.allBasenames);_&&(ae.allBasenames=_.allBasenames);const ge=X.reduce((se,re)=>re.allPaths?se.concat(re.allPaths):se,[]);return ge.length&&(ae.allPaths=ge),ae}function g(te,x,X){const Q=R.sep===R.$gc.sep,ae=Q?te:te.replace(v,R.sep),_=R.sep+ae,ge=R.$gc.sep+te;let se;return X?se=function(re,B){return typeof re=="string"&&(re===ae||re.endsWith(_)||!Q&&(re===te||re.endsWith(ge)))?x:null}:se=function(re,B){return typeof re=="string"&&(re===ae||!Q&&re===te)?x:null},se.allPaths=[(X?"*/":"./")+te],se}function y(te){try{const x=new RegExp(`^${u(te)}$`);return function(X){return x.lastIndex=0,typeof X=="string"&&x.test(X)?te:null}}catch{return h}}function P(te,x,X){return!te||typeof x!="string"?!1:N(te)(x,void 0,X)}e.$Xj=P;function N(te,x={}){if(!te)return f;if(typeof te=="string"||U(te)){const X=r(te,x);if(X===h)return f;const Q=function(ae,_){return!!X(ae,_)};return X.allBasenames&&(Q.allBasenames=X.allBasenames),X.allPaths&&(Q.allPaths=X.allPaths),Q}return I(te,x)}e.$Yj=N;function U(te){const x=te;return x?typeof x.base=="string"&&typeof x.pattern=="string":!1}e.$Zj=U;function z(te){return te.allBasenames||[]}e.$1j=z;function F(te){return te.allPaths||[]}e.$2j=F;function I(te,x){const X=T(Object.getOwnPropertyNames(te).map(se=>O(se,te[se],x)).filter(se=>se!==h)),Q=X.length;if(!Q)return h;if(!X.some(se=>!!se.requiresSiblings)){if(Q===1)return X[0];const se=function(ie,ye){let le;for(let ue=0,ce=X.length;ue<ce;ue++){const de=X[ue](ie,ye);if(typeof de=="string")return de;(0,j.$4g)(de)&&(le||(le=[]),le.push(de))}return le?(async()=>{for(const ue of le){const ce=await ue;if(typeof ce=="string")return ce}return null})():null},re=X.find(ie=>!!ie.allBasenames);re&&(se.allBasenames=re.allBasenames);const B=X.reduce((ie,ye)=>ye.allPaths?ie.concat(ye.allPaths):ie,[]);return B.length&&(se.allPaths=B),se}const ae=function(se,re,B){let ie,ye;for(let le=0,ue=X.length;le<ue;le++){const ce=X[le];ce.requiresSiblings&&B&&(re||(re=(0,R.$nc)(se)),ie||(ie=re.substr(0,re.length-(0,R.$oc)(se).length)));const de=ce(se,re,ie,B);if(typeof de=="string")return de;(0,j.$4g)(de)&&(ye||(ye=[]),ye.push(de))}return ye?(async()=>{for(const le of ye){const ue=await le;if(typeof ue=="string")return ue}return null})():null},_=X.find(se=>!!se.allBasenames);_&&(ae.allBasenames=_.allBasenames);const ge=X.reduce((se,re)=>re.allPaths?se.concat(re.allPaths):se,[]);return ge.length&&(ae.allPaths=ge),ae}function O(te,x,X){if(x===!1)return h;const Q=r(te,X);if(Q===h)return h;if(typeof x=="boolean")return Q;if(x){const ae=x.when;if(typeof ae=="string"){const _=(ge,se,re,B)=>{if(!B||!Q(ge,se))return null;const ie=ae.replace("$(basename)",()=>re),ye=B(ie);return(0,j.$4g)(ye)?ye.then(le=>le?te:null):ye?te:null};return _.requiresSiblings=!0,_}}return Q}function T(te,x){const X=te.filter(se=>!!se.basenames);if(X.length<2)return te;const Q=X.reduce((se,re)=>{const B=re.basenames;return B?se.concat(B):se},[]);let ae;if(x){ae=[];for(let se=0,re=Q.length;se<re;se++)ae.push(x)}else ae=X.reduce((se,re)=>{const B=re.patterns;return B?se.concat(B):se},[]);const _=function(se,re){if(typeof se!="string")return null;if(!re){let ie;for(ie=se.length;ie>0;ie--){const ye=se.charCodeAt(ie-1);if(ye===47||ye===92)break}re=se.substr(ie)}const B=Q.indexOf(re);return B!==-1?ae[B]:null};_.basenames=Q,_.patterns=ae,_.allBasenames=Q;const ge=te.filter(se=>!se.basenames);return ge.push(_),ge}function G(te,x){return(0,l.$ub)(te,x,(X,Q)=>typeof X=="string"&&typeof Q=="string"?X===Q:typeof X!="string"&&typeof Q!="string"?X.base===Q.base&&X.pattern===Q.pattern:!1)}e.$3j=G}),define(Se[79],De([1,0,13,169,23,14,2]),function(fe,e,l,j,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ek=e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.MarkdownStringTextNewlineStyle=void 0;var p;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(p||(e.MarkdownStringTextNewlineStyle=p={}));class w{constructor(i="",n=!1){if(this.value=i,typeof this.value!="string")throw(0,l.$7)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(i,n=0){return this.value+=v(this.supportThemeIcons?(0,j.$qk)(i):i).replace(/([ \t]+)/g,(s,c)=>"&nbsp;".repeat(c.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,n){return this.value+=`
${S(n,i)}
`,this}appendLink(i,n,s){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(i),")"),s&&(this.value+=` "${this.c(this.c(s,'"'),")")}"`),this.value+=")",this}c(i,n){const s=new RegExp((0,A.$Xe)(n),"g");return i.replace(s,(c,t)=>i.charAt(t-1)!=="\\"?`\\${c}`:c)}}e.$wk=w;function E(o){return M(o)?!o.value:Array.isArray(o)?o.every(E):!0}e.$xk=E;function M(o){return o instanceof w?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||typeof o.isTrusted=="object"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}e.$yk=M;function C(o,i){return o===i?!0:!o||!i?!1:o.value===i.value&&o.isTrusted===i.isTrusted&&o.supportThemeIcons===i.supportThemeIcons&&o.supportHtml===i.supportHtml&&(o.baseUri===i.baseUri||!!o.baseUri&&!!i.baseUri&&(0,L.$Lg)(R.URI.from(o.baseUri),R.URI.from(i.baseUri)))}e.$zk=C;function v(o){return o.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$Ak=v;function S(o,i){const n=o.match(/^`+/gm)?.reduce((c,t)=>c.length>t.length?c:t).length??0,s=n>=3?n+1:3;return[`${"`".repeat(s)}${i}`,o,`${"`".repeat(s)}`].join(`
`)}e.$Bk=S;function k(o){return o.replace(/"/g,"&quot;")}e.$Ck=k;function u(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$Dk=u;function m(o){const i=[],n=o.split("|").map(c=>c.trim());o=n[0];const s=n[1];if(s){const c=/height=(\d+)/.exec(s),t=/width=(\d+)/.exec(s),f=c?c[1]:"",h=t?t[1]:"",r=isFinite(parseInt(h)),a=isFinite(parseInt(f));r&&i.push(`width="${h}"`),a&&i.push(`height="${f}"`)}return{href:o,dimensions:i}}e.$Ek=m}),define(Se[103],De([1,0,19,34,17,11,23,14]),function(fe,e,l,j,L,A,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hw=e.$gw=e.$fw=e.$ew=e.$dw=e.$cw=e.$bw=e.$aw=e.$_v=e.$$v=void 0;function w(r,a){const{os:d,tildify:$,relative:D}=a;if(D){const y=E(r,D,d);if(typeof y=="string")return y}let b=r.fsPath;if(d===1&&!A.$i?b=b.replace(/\//g,"\\"):d!==1&&A.$i&&(b=b.replace(/\\/g,"/")),d!==1&&$?.userHome){const y=$.userHome.fsPath;let P;r.scheme!==$.userHome.scheme&&r.path[0]===L.$gc.sep&&r.path[1]!==L.$gc.sep?P=$.userHome.with({path:r.path}).fsPath:P=b,b=v(P,y,d)}return(d===1?L.$fc:L.$gc).normalize(M(b,d===1))}e.$$v=w;function E(r,a,d){const $=d===1?L.$fc:L.$gc,D=d===3?R.$Ig:R.$Kg,b=a.getWorkspace(),g=(0,l.$Ob)(b.folders);if(!g)return;r.scheme!==g.uri.scheme&&r.path[0]===L.$gc.sep&&r.path[1]!==L.$gc.sep&&(r=g.uri.with({path:r.path}));const y=a.getWorkspaceFolder(r);if(!y)return;let P;if(D.isEqual(y.uri,r)?P="":P=D.relativePath(y.uri,r)??"",P&&(P=$.normalize(P)),b.folders.length>1&&!a.noPrefix){const N=y.name?y.name:D.basenameOrAuthority(y.uri);P=P?`${N} \u2022 ${P}`:N}return P}function M(r,a=A.$i){return(0,j.$jg)(r,a)?r.charAt(0).toUpperCase()+r.slice(1):r}e.$_v=M;let C=Object.create(null);function v(r,a,d=A.OS){if(d===1||!r||!a)return r;let $=C.original===a?C.normalized:void 0;$||($=a,A.$i&&($=(0,j.$_f)($)),$=`${(0,p.$4e)($,L.$gc.sep)}${L.$gc.sep}`,C={original:a,normalized:$});let D=r;return A.$i&&(D=(0,j.$_f)(D)),(d===3?D.startsWith($):(0,p.$kf)(D,$))?`~/${D.substr($.length)}`:r}e.$aw=v;function S(r,a){return r.replace(/^~($|\/|\\)/,`${a}$1`)}e.$bw=S;const k="\u2026",u="\\\\",m="~";function o(r,a=L.sep){const d=new Array(r.length);let $=!1;for(let D=0;D<r.length;D++){const b=r[D];if(b===""){d[D]=`.${a}`;continue}if(!b){d[D]=b;continue}$=!0;let g="",y=b;y.indexOf(u)===0?(g=y.substr(0,y.indexOf(u)+u.length),y=y.substr(y.indexOf(u)+u.length)):y.indexOf(a)===0?(g=y.substr(0,y.indexOf(a)+a.length),y=y.substr(y.indexOf(a)+a.length)):y.indexOf(m)===0&&(g=y.substr(0,y.indexOf(m)+m.length),y=y.substr(y.indexOf(m)+m.length));const P=y.split(a);for(let N=1;$&&N<=P.length;N++)for(let U=P.length-N;$&&U>=0;U--){$=!1;let z=P.slice(U,U+N).join(a);for(let F=0;!$&&F<r.length;F++)if(F!==D&&r[F]&&r[F].indexOf(z)>-1){const I=U+N===P.length,O=U>0&&r[F].indexOf(a)>-1?a+z:z,T=r[F].endsWith(O);$=!I||T}if(!$){let F="";(P[0].endsWith(":")||g!=="")&&(U===1&&(U=0,N++,z=P[0]+a+z),U>0&&(F=P[0]+a),F=g+F),U>0&&(F=F+k+a),F=F+z,U+N<P.length&&(F=F+a+k),d[D]=F}}$&&(d[D]=b)}return d}e.$cw=o;var i;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(i||(i={}));function n(r,a=Object.create(null)){const d=[];let $=!1,D="";for(const b of r)if(b==="$"||$&&b==="{")D&&d.push({value:D,type:i.TEXT}),D="",$=!0;else if(b==="}"&&$){const g=a[D];if(typeof g=="string")g.length&&d.push({value:g,type:i.VARIABLE});else if(g){const y=d[d.length-1];(!y||y.type!==i.SEPARATOR)&&d.push({value:g.label,type:i.SEPARATOR})}D="",$=!1}else D+=b;return D&&!$&&d.push({value:D,type:i.TEXT}),d.filter((b,g)=>{if(b.type===i.SEPARATOR){const y=d[g-1],P=d[g+1];return[y,P].every(N=>N&&(N.type===i.VARIABLE||N.type===i.TEXT)&&N.value.length>0)}return!0}).map(b=>b.value).join("")}e.$dw=n;function s(r,a){return A.$j||a?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.$j?"&":"&&"):r.replace(/&&|&/g,d=>d==="&"?"&&":"&")}e.$ew=s;function c(r,a){return A.$j||a?r.replace(/\(&&\w\)|&&/g,""):A.$i?r.replace(/&&|&/g,d=>d==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.$fw=c;function t(r){return r.replace(/&/g,"&&")}e.$gw=t;function f(r){if(r.endsWith("]")){const a=r.lastIndexOf(" [",r.length-2);if(a!==-1){const d=h(r.substring(0,a)),$=r.substring(a);return{name:d.name+$,parentPath:d.parentPath}}}return h(r)}e.$hw=f;function h(r){const a=r.indexOf("/")!==-1?L.$gc:L.$fc,d=a.basename(r),$=a.dirname(r);return d.length?{name:d,parentPath:$}:{name:$,parentPath:""}}}),define(Se[133],De([1,0,21,2]),function(fe,e,l,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kn=e.$jn=e.$in=e.$hn=e.$gn=void 0;function L(C){return C.toJSON()}class A{constructor(v){this.a=v}transformIncoming(v){const S=this.a.transformIncoming(v);return S===v?v:L(j.URI.from(S))}transformOutgoing(v){const S=this.a.transformOutgoing(v);return S===v?v:L(j.URI.from(S))}transformOutgoingURI(v){const S=this.a.transformOutgoing(v);return S===v?v:j.URI.from(S)}transformOutgoingScheme(v){return this.a.transformOutgoingScheme(v)}}e.$gn=A,e.$hn=new class{transformIncoming(C){return C}transformOutgoing(C){return C}transformOutgoingURI(C){return C}transformOutgoingScheme(C){return C}};function R(C,v,S){if(!C||S>200)return null;if(typeof C=="object"){if(C instanceof j.URI)return v.transformOutgoing(C);for(const k in C)if(Object.hasOwnProperty.call(C,k)){const u=R(C[k],v,S+1);u!==null&&(C[k]=u)}}return null}function p(C,v){const S=R(C,v,0);return S===null?C:S}e.$in=p;function w(C,v,S,k){if(!C||k>200)return null;if(typeof C=="object"){if(C.$mid===1)return S?j.URI.revive(v.transformIncoming(C)):v.transformIncoming(C);if(C instanceof l.$se)return null;for(const u in C)if(Object.hasOwnProperty.call(C,u)){const m=w(C[u],v,S,k+1);m!==null&&(C[u]=m)}}return null}function E(C,v){const S=w(C,v,!1,0);return S===null?C:S}e.$jn=E;function M(C,v){const S=w(C,v,!0,0);return S===null?C:S}e.$kn=M}),define(Se[31],De([1,0,57,63,391,8,34,75,17,11,23,2]),function(fe,e,l,j,L,A,R,p,w,E,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(O){O[O.UNLINK=0]="UNLINK",O[O.MOVE=1]="MOVE"})(v||(e.RimRafMode=v={}));async function S(O,T=v.UNLINK,G){if((0,R.$ig)(O))throw new Error("rimraf - will refuse to recursively delete root");return T===v.UNLINK?u(O):k(O,G)}async function k(O,T=(0,R.$ng)((0,j.tmpdir)())){try{try{await l.promises.rename(O,T)}catch(G){return G.code==="ENOENT"?void 0:u(O)}u(T).catch(G=>{})}catch(G){if(G.code!=="ENOENT")throw G}}async function u(O){return(0,L.promisify)(l.rm)(O,{recursive:!0,force:!0,maxRetries:3})}function m(O){if((0,R.$ig)(O))throw new Error("rimraf - will refuse to recursively delete root");l.rmSync(O,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=m;async function o(O,T){return s(await(T?i(O):(0,L.promisify)(l.readdir)(O)))}async function i(O){try{return await(0,L.promisify)(l.readdir)(O,{withFileTypes:!0})}catch(te){console.warn("[node.js fs] readdir with filetypes failed with error: ",te)}const T=[],G=await o(O);for(const te of G){let x=!1,X=!1,Q=!1;try{const ae=await e.Promises.lstat((0,w.$jc)(O,te));x=ae.isFile(),X=ae.isDirectory(),Q=ae.isSymbolicLink()}catch(ae){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ae)}T.push({name:te,isFile:()=>x,isDirectory:()=>X,isSymbolicLink:()=>Q})}return T}function n(O){return s(l.readdirSync(O))}e.readdirSync=n;function s(O){return O.map(T=>typeof T=="string"?E.$j?(0,p.$Ql)(T):T:(T.name=E.$j?(0,p.$Ql)(T.name):T.name,T))}async function c(O){const T=await o(O),G=[];for(const te of T)await f.existsDirectory((0,w.$jc)(O,te))&&G.push(te);return G}function t(O,T=1e3){return new Promise(G=>{let te=!1;const x=setInterval(()=>{te||(te=!0,l.access(O,X=>{te=!1,X&&(clearInterval(x),G(void 0))}))},T)})}e.whenDeleted=t;var f;(function(O){async function T(x){let X;try{if(X=await e.Promises.lstat(x),!X.isSymbolicLink())return{stat:X}}catch{}try{return{stat:await e.Promises.stat(x),symbolicLink:X?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Q){if(Q.code==="ENOENT"&&X)return{stat:X,symbolicLink:{dangling:!0}};if(E.$i&&Q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(ae){if(ae.code==="ENOENT"&&X)return{stat:X,symbolicLink:{dangling:!0}};throw ae}throw Q}}O.stat=T;async function G(x){try{const{stat:X,symbolicLink:Q}=await O.stat(x);return X.isFile()&&Q?.dangling!==!0}catch{}return!1}O.existsFile=G;async function te(x){try{const{stat:X,symbolicLink:Q}=await O.stat(x);return X.isDirectory()&&Q?.dangling!==!0}catch{}return!1}O.existsDirectory=te})(f||(e.SymlinkSupport=f={}));const h=new A.$oh;function r(O,T,G){return h.queueFor(C.URI.file(O),()=>{const te=b(G);return new Promise((x,X)=>$(O,T,te,Q=>Q?X(Q):x()))},M.$Jg)}let a=!0;function d(O){a=O}e.configureFlushOnWrite=d;function $(O,T,G,te){if(!a)return l.writeFile(O,T,{mode:G.mode,flag:G.flag},te);l.open(O,G.flag,G.mode,(x,X)=>{if(x)return te(x);l.writeFile(X,T,Q=>{if(Q)return l.close(X,()=>te(Q));l.fdatasync(X,ae=>(ae&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ae),d(!1)),l.close(X,_=>te(_))))})})}function D(O,T,G){const te=b(G);if(!a)return l.writeFileSync(O,T,{mode:te.mode,flag:te.flag});const x=l.openSync(O,te.flag,te.mode);try{l.writeFileSync(x,T);try{l.fdatasyncSync(x)}catch(X){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",X),d(!1)}}finally{l.closeSync(x)}}e.writeFileSync=D;function b(O){return O?{mode:typeof O.mode=="number"?O.mode:438,flag:typeof O.flag=="string"?O.flag:"w"}:{mode:438,flag:"w"}}async function g(O,T,G=6e4){if(O!==T)try{E.$i&&typeof G=="number"?await y(O,T,Date.now(),G):await(0,L.promisify)(l.rename)(O,T)}catch(te){if(O.toLowerCase()!==T.toLowerCase()&&te.code==="EXDEV"||O.endsWith("."))await P(O,T,{preserveSymlinks:!1}),await S(O,v.MOVE);else throw te}}async function y(O,T,G,te,x=0){try{return await(0,L.promisify)(l.rename)(O,T)}catch(X){if(X.code!=="EACCES"&&X.code!=="EPERM"&&X.code!=="EBUSY")throw X;if(Date.now()-G>=te)throw console.error(`[node.js fs] rename failed after ${x} retries with error: ${X}`),X;if(x===0){let Q=!1;try{const{stat:ae}=await f.stat(T);ae.isFile()||(Q=!0)}catch{}if(Q)throw X}return await(0,A.$gh)(Math.min(100,x*10)),y(O,T,G,te,x+1)}}async function P(O,T,G){return U(O,T,{root:{source:O,target:T},options:G,handledSourcePaths:new Set})}const N=511;async function U(O,T,G){if(G.handledSourcePaths.has(O))return;G.handledSourcePaths.add(O);const{stat:te,symbolicLink:x}=await f.stat(O);if(x){if(G.options.preserveSymlinks)try{return await I(O,T,G)}catch{}if(x.dangling)return}return te.isDirectory()?z(O,T,te.mode&N,G):F(O,T,te.mode&N)}async function z(O,T,G,te){await e.Promises.mkdir(T,{recursive:!0,mode:G});const x=await o(O);for(const X of x)await U((0,w.$jc)(O,X),(0,w.$jc)(T,X),te)}async function F(O,T,G){await e.Promises.copyFile(O,T),await e.Promises.chmod(T,G)}async function I(O,T,G){let te=await e.Promises.readlink(O);(0,R.$fg)(te,G.root.source,!E.$k)&&(te=(0,w.$jc)(G.root.target,te.substr(G.root.source.length+1))),await e.Promises.symlink(te,T)}e.Promises=new class{get access(){return(0,L.promisify)(l.access)}get stat(){return(0,L.promisify)(l.stat)}get lstat(){return(0,L.promisify)(l.lstat)}get utimes(){return(0,L.promisify)(l.utimes)}get read(){return(O,T,G,te,x)=>new Promise((X,Q)=>{l.read(O,T,G,te,x,(ae,_,ge)=>ae?Q(ae):X({bytesRead:_,buffer:ge}))})}get readFile(){return(0,L.promisify)(l.readFile)}get write(){return(O,T,G,te,x)=>new Promise((X,Q)=>{l.write(O,T,G,te,x,(ae,_,ge)=>ae?Q(ae):X({bytesWritten:_,buffer:ge}))})}get appendFile(){return(0,L.promisify)(l.appendFile)}get fdatasync(){return(0,L.promisify)(l.fdatasync)}get truncate(){return(0,L.promisify)(l.truncate)}get copyFile(){return(0,L.promisify)(l.copyFile)}get open(){return(0,L.promisify)(l.open)}get close(){return(0,L.promisify)(l.close)}get symlink(){return(0,L.promisify)(l.symlink)}get readlink(){return(0,L.promisify)(l.readlink)}get chmod(){return(0,L.promisify)(l.chmod)}get mkdir(){return(0,L.promisify)(l.mkdir)}get unlink(){return(0,L.promisify)(l.unlink)}get rmdir(){return(0,L.promisify)(l.rmdir)}get realpath(){return(0,L.promisify)(l.realpath)}async exists(O){try{return await e.Promises.access(O),!0}catch{return!1}}get readdir(){return o}get readDirsInDir(){return c}get writeFile(){return r}get rm(){return S}get rename(){return g}get copy(){return P}}}),define(Se[104],De([1,0,57,17,11,14,31]),function(fe,e,l,j,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=e.$Jq=e.$Iq=e.$Hq=void 0;function p(v){if(L.$k)return v;const S=(0,j.$mc)(v);if(v===S)return v;const k=((0,j.$nc)(v)||v).toLowerCase();try{const m=(0,R.readdirSync)(S).filter(o=>o.toLowerCase()===k);if(m.length===1){const o=p(S);if(o)return(0,j.$jc)(o,m[0])}else if(m.length>1){const o=m.indexOf(k);if(o>=0){const i=p(S);if(i)return(0,j.$jc)(i,m[o])}}}catch{}return null}e.$Hq=p;async function w(v){if(L.$k)return v;const S=(0,j.$mc)(v);if(v===S)return v;const k=((0,j.$nc)(v)||v).toLowerCase();try{const m=(await R.Promises.readdir(S)).filter(o=>o.toLowerCase()===k);if(m.length===1){const o=await w(S);if(o)return(0,j.$jc)(o,m[0])}else if(m.length>1){const o=m.indexOf(k);if(o>=0){const i=await w(S);if(i)return(0,j.$jc)(i,m[o])}}}catch{}return null}e.$Iq=w;async function E(v){try{return await R.Promises.realpath(v)}catch{const k=C(v);return await R.Promises.access(k,l.constants.R_OK),k}}e.$Jq=E;function M(v){try{return l.realpathSync(v)}catch{const k=C(v);return l.accessSync(k,l.constants.R_OK),k}}e.$Kq=M;function C(v){return(0,A.$4e)((0,j.$hc)(v),j.sep)}}),define(Se[105],De([1,0,17,11,50,102,18,31]),function(fe,e,l,j,L,A,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$5l=e.$4l=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function w(C=L.env){return C.comspec||"cmd.exe"}e.$4l=w;function E(C){let v=[],S=!1;const k=function(u){if(S){v.push(u);return}(!C.send(u,o=>{if(o&&console.error(o),S=!1,v.length>0){const i=v.slice(0);v=[],i.forEach(n=>k(n))}})||j.$i)&&(S=!0)};return{send:k}}e.$5l=E;var M;(function(C){async function v(S,k,u){if(l.$ic(S))return S;if(k===void 0&&(k=L.cwd()),l.$mc(S)!=="."||(u===void 0&&R.$Sf(L.env.PATH)&&(u=L.env.PATH.split(l.$tc)),u===void 0||u.length===0))return l.$jc(k,S);async function o(i){if(await p.Promises.exists(i)){let n;try{n=await p.Promises.stat(i)}catch(s){s.message.startsWith("EACCES")&&(n=await p.Promises.lstat(i))}return n?!n.isDirectory():!1}return!1}for(const i of u){let n;if(l.$ic(i)?n=l.$jc(i,S):n=l.$jc(k,i,S),await o(n))return n;let s=n+".com";if(await o(s)||(s=n+".exe",await o(s)))return s}return l.$jc(k,S)}C.findExecutable=v})(M||(e.win32=M={}))});var Ye=this&&this.__decorate||function(fe,e,l,j){var L=arguments.length,A=L<3?e:j===null?j=Object.getOwnPropertyDescriptor(e,l):j,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(fe,e,l,j);else for(var p=fe.length-1;p>=0;p--)(R=fe[p])&&(A=(L<3?R(A):L>3?R(e,l,A):R(e,l))||A);return L>3&&A&&Object.defineProperty(e,l,A),A};define(Se[80],De([1,0,19,8,21,22,53,13,4,3,56,14,18]),function(fe,e,l,j,L,A,R,p,w,E,M,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1h=e.ProxyChannel=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.RequestInitiator=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=void 0;var S;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(S||(S={}));function k(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var u;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(u||(u={}));function m(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var o;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(o||(o={}));function i(x){let X=0;for(let Q=0;;Q+=7){const ae=x.read(1);if(X|=(ae.buffer[0]&127)<<Q,!(ae.buffer[0]&128))return X}}const n=h(0);function s(x,X){if(X===0){x.write(n);return}let Q=0;for(let _=X;_!==0;_=_>>>7)Q++;const ae=L.$se.alloc(Q);for(let _=0;X!==0;_++)ae.buffer[_]=X&127,X=X>>>7,X>0&&(ae.buffer[_]|=128);x.write(ae)}class c{constructor(X){this.b=X,this.a=0}read(X){const Q=this.b.slice(this.a,this.a+X);return this.a+=Q.byteLength,Q}}e.$Ph=c;class t{constructor(){this.a=[]}get buffer(){return L.$se.concat(this.a)}write(X){this.a.push(X)}}e.$Qh=t;var f;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object",x[x.Int=6]="Int"})(f||(f={}));function h(x){const X=L.$se.alloc(1);return X.writeUInt8(x,0),X}const r={Undefined:h(f.Undefined),String:h(f.String),Buffer:h(f.Buffer),VSBuffer:h(f.VSBuffer),Array:h(f.Array),Object:h(f.Object),Uint:h(f.Int)},a=typeof Buffer<"u";function d(x,X){if(typeof X>"u")x.write(r.Undefined);else if(typeof X=="string"){const Q=L.$se.fromString(X);x.write(r.String),s(x,Q.byteLength),x.write(Q)}else if(a&&Buffer.isBuffer(X)){const Q=L.$se.wrap(X);x.write(r.Buffer),s(x,Q.byteLength),x.write(Q)}else if(X instanceof L.$se)x.write(r.VSBuffer),s(x,X.byteLength),x.write(X);else if(Array.isArray(X)){x.write(r.Array),s(x,X.length);for(const Q of X)d(x,Q)}else if(typeof X=="number"&&(X|0)===X)x.write(r.Uint),s(x,X);else{const Q=L.$se.fromString(JSON.stringify(X));x.write(r.Object),s(x,Q.byteLength),x.write(Q)}}e.$Rh=d;function $(x){switch(x.read(1).readUInt8(0)){case f.Undefined:return;case f.String:return x.read(i(x)).toString();case f.Buffer:return x.read(i(x)).buffer;case f.VSBuffer:return x.read(i(x));case f.Array:{const Q=i(x),ae=[];for(let _=0;_<Q;_++)ae.push($(x));return ae}case f.Object:return JSON.parse(x.read(i(x)).toString());case f.Int:return i(x)}}e.$Sh=$;class D{constructor(X,Q,ae=null,_=1e3){this.h=X,this.j=Q,this.k=ae,this.l=_,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ge=>this.q(ge)),this.m({type:200})}registerChannel(X,Q){this.b.set(X,Q),setTimeout(()=>this.w(X),0)}m(X){switch(X.type){case 200:{const Q=this.o([X.type]);this.k?.logOutgoing(Q,0,1,m(X.type));return}case 201:case 202:case 204:case 203:{const Q=this.o([X.type,X.id],X.data);this.k?.logOutgoing(Q,X.id,1,m(X.type),X.data);return}}}o(X,Q=void 0){const ae=new t;return d(ae,X),d(ae,Q),this.p(ae.buffer)}p(X){try{return this.h.send(X),X.byteLength}catch{return 0}}q(X){const Q=new c(X),ae=$(Q),_=$(Q),ge=ae[0];switch(ge){case 100:return this.k?.logIncoming(X.byteLength,ae[1],1,`${k(ge)}: ${ae[2]}.${ae[3]}`,_),this.s({type:ge,id:ae[1],channelName:ae[2],name:ae[3],arg:_});case 102:return this.k?.logIncoming(X.byteLength,ae[1],1,`${k(ge)}: ${ae[2]}.${ae[3]}`,_),this.t({type:ge,id:ae[1],channelName:ae[2],name:ae[3],arg:_});case 101:return this.k?.logIncoming(X.byteLength,ae[1],1,`${k(ge)}`),this.u({type:ge,id:ae[1]});case 103:return this.k?.logIncoming(X.byteLength,ae[1],1,`${k(ge)}`),this.u({type:ge,id:ae[1]})}}s(X){const Q=this.b.get(X.channelName);if(!Q){this.v(X);return}const ae=new A.$ce;let _;try{_=Q.call(this.j,X.name,X.arg,ae.token)}catch(re){_=Promise.reject(re)}const ge=X.id;_.then(re=>{this.m({id:ge,data:re,type:201})},re=>{re instanceof Error?this.m({id:ge,data:{message:re.message,name:re.name,stack:re.stack?re.stack.split?re.stack.split(`
`):re.stack:void 0},type:202}):this.m({id:ge,data:re,type:203})}).finally(()=>{se.dispose(),this.d.delete(X.id)});const se=(0,E.$Rc)(()=>ae.cancel());this.d.set(X.id,se)}t(X){const Q=this.b.get(X.channelName);if(!Q){this.v(X);return}const ae=X.id,ge=Q.listen(this.j,X.name,X.arg)(se=>this.m({id:ae,data:se,type:204}));this.d.set(X.id,ge)}u(X){const Q=this.d.get(X.id);Q&&(Q.dispose(),this.d.delete(X.id))}v(X){let Q=this.g.get(X.channelName);Q||(Q=[],this.g.set(X.channelName,Q));const ae=setTimeout(()=>{console.error(`Unknown channel: ${X.channelName}`),X.type===100&&this.m({id:X.id,data:{name:"Unknown channel",message:`Channel name '${X.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);Q.push({request:X,timeoutTimer:ae})}w(X){const Q=this.g.get(X);if(Q){for(const ae of Q)switch(clearTimeout(ae.timeoutTimer),ae.request.type){case 100:this.s(ae.request);break;case 102:this.t(ae.request);break}this.g.delete(X)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,E.$Oc)(this.d.values()),this.d.clear()}}e.$Th=D;var b;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})(b||(e.RequestInitiator=b={}));class g{constructor(X,Q=null){this.l=X,this.a=!1,this.b=o.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new w.$5d,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ae=>this.s(ae)),this.j=Q}getChannel(X){const Q=this;return{call(ae,_,ge){return Q.a?Promise.reject(new p.$5):Q.m(X,ae,_,ge)},listen(ae,_){return Q.a?w.Event.None:Q.o(X,ae,_)}}}m(X,Q,ae,_=A.CancellationToken.None){const ge=this.g++,re={id:ge,type:100,channelName:X,name:Q,arg:ae};if(_.isCancellationRequested)return Promise.reject(new p.$5);let B;return new Promise((ye,le)=>{if(_.isCancellationRequested)return le(new p.$5);const ue=()=>{const Z=he=>{switch(he.type){case 201:this.f.delete(ge),ye(he.data);break;case 202:{this.f.delete(ge);const be=new Error(he.data.message);be.stack=Array.isArray(he.data.stack)?he.data.stack.join(`
`):he.data.stack,be.name=he.data.name,le(be);break}case 203:this.f.delete(ge),le(he.data);break}};this.f.set(ge,Z),this.p(re)};let ce=null;this.b===o.Idle?ue():(ce=(0,j.$5g)(Z=>this.u()),ce.then(()=>{ce=null,ue()}));const de=()=>{ce?(ce.cancel(),ce=null):this.p({id:ge,type:101}),le(new p.$5)},H=_.onCancellationRequested(de);B=(0,E.$Qc)((0,E.$Rc)(de),H),this.d.add(B)}).finally(()=>{B.dispose(),this.d.delete(B)})}o(X,Q,ae){const _=this.g++,se={id:_,type:102,channelName:X,name:Q,arg:ae};let re=null;const B=new w.$5d({onWillAddFirstListener:()=>{re=(0,j.$5g)(ye=>this.u()),re.then(()=>{re=null,this.d.add(B),this.p(se)})},onDidRemoveLastListener:()=>{re?(re.cancel(),re=null):(this.d.delete(B),this.p({id:_,type:103}))}}),ie=ye=>B.fire(ye.data);return this.f.set(_,ie),B.event}p(X){switch(X.type){case 100:case 102:{const Q=this.q([X.type,X.id,X.channelName,X.name],X.arg);this.j?.logOutgoing(Q,X.id,0,`${k(X.type)}: ${X.channelName}.${X.name}`,X.arg);return}case 101:case 103:{const Q=this.q([X.type,X.id]);this.j?.logOutgoing(Q,X.id,0,k(X.type));return}}}q(X,Q=void 0){const ae=new t;return d(ae,X),d(ae,Q),this.r(ae.buffer)}r(X){try{return this.l.send(X),X.byteLength}catch{return 0}}s(X){const Q=new c(X),ae=$(Q),_=$(Q),ge=ae[0];switch(ge){case 200:return this.j?.logIncoming(X.byteLength,0,0,m(ge)),this.t({type:ae[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(X.byteLength,ae[1],0,m(ge),_),this.t({type:ae[0],id:ae[1],data:_})}}t(X){if(X.type===200){this.b=o.Idle,this.k.fire();return}this.f.get(X.id)?.(X)}get onDidInitializePromise(){return w.Event.toPromise(this.onDidInitialize)}u(){return this.b===o.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,E.$Oc)(this.d.values()),this.d.clear()}}e.$Uh=g,Ye([R.$Jh],g.prototype,"onDidInitializePromise",null);class y{get connections(){const X=[];return this.f.forEach(Q=>X.push(Q)),X}constructor(X){this.a=new Map,this.f=new Set,this.g=new w.$5d,this.onDidAddConnection=this.g.event,this.h=new w.$5d,this.onDidRemoveConnection=this.h.event,this.j=new E.$Sc,this.j.add(X(({protocol:Q,onDidClientDisconnect:ae})=>{const _=w.Event.once(Q.onMessage);this.j.add(_(ge=>{const se=new c(ge),re=$(se),B=new D(Q,re),ie=new g(Q);this.a.forEach((le,ue)=>B.registerChannel(ue,le));const ye={channelServer:B,channelClient:ie,ctx:re};this.f.add(ye),this.g.fire(ye),this.j.add(ae(()=>{B.dispose(),ie.dispose(),this.f.delete(ye),this.h.fire(ye)}))}))}))}getChannel(X,Q){const ae=this;return{call(_,ge,se){let re;if((0,v.$7f)(Q)){const ie=(0,l.$4b)(ae.connections.filter(Q));re=ie?Promise.resolve(ie):w.Event.toPromise(w.Event.filter(ae.onDidAddConnection,Q))}else re=Q.routeCall(ae,_,ge);const B=re.then(ie=>ie.channelClient.getChannel(X));return N(B).call(_,ge,se)},listen(_,ge){if((0,v.$7f)(Q))return ae.k(X,Q,_,ge);const se=Q.routeEvent(ae,_,ge).then(re=>re.channelClient.getChannel(X));return N(se).listen(_,ge)}}}k(X,Q,ae,_){const ge=this;let se;const re=new w.$5d({onWillAddFirstListener:()=>{se=new E.$Sc;const B=new w.$$d,ie=new Map,ye=ue=>{const de=ue.channelClient.getChannel(X).listen(ae,_),H=B.add(de);ie.set(ue,H)},le=ue=>{const ce=ie.get(ue);ce&&(ce.dispose(),ie.delete(ue))};ge.connections.filter(Q).forEach(ye),w.Event.filter(ge.onDidAddConnection,Q)(ye,void 0,se),ge.onDidRemoveConnection(le,void 0,se),B.event(re.fire,re,se),se.add(B)},onDidRemoveLastListener:()=>{se?.dispose(),se=void 0}});return re.event}registerChannel(X,Q){this.a.set(X,Q);for(const ae of this.f)ae.channelServer.registerChannel(X,Q)}dispose(){this.j.dispose();for(const X of this.f)X.channelClient.dispose(),X.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Vh=y;class P{constructor(X,Q,ae=null){const _=new t;d(_,Q),X.send(_.buffer),this.a=new g(X,ae),this.d=new D(X,Q,ae)}getChannel(X){return this.a.getChannel(X)}registerChannel(X,Q){this.d.registerChannel(X,Q)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Wh=P;function N(x){return{call(X,Q,ae){return x.then(_=>_.call(X,Q,ae))},listen(X,Q){const ae=new w.$be;return x.then(_=>ae.input=_.listen(X,Q)),ae.event}}}e.$Xh=N;function U(x){let X=!1;return{call(Q,ae,_){return X?x.call(Q,ae,_):(0,j.$gh)(0).then(()=>X=!0).then(()=>x.call(Q,ae,_))},listen(Q,ae){if(X)return x.listen(Q,ae);const _=new w.$be;return(0,j.$gh)(0).then(()=>X=!0).then(()=>_.input=x.listen(Q,ae)),_.event}}}e.$Yh=U;class z{constructor(X){this.a=X}routeCall(X){return this.b(X)}routeEvent(X){return this.b(X)}async b(X){for(const Q of X.connections)if(await Promise.resolve(this.a(Q.ctx)))return Promise.resolve(Q);return await w.Event.toPromise(X.onDidAddConnection),await this.b(X)}}e.$Zh=z;var F;(function(x){function X(ge,se,re){const B=ge,ie=re&&re.disableMarshalling,ye=new Map;for(const le in B)ae(le)&&ye.set(le,w.Event.buffer(B[le],!0,void 0,se));return new class{listen(le,ue,ce){const de=ye.get(ue);if(de)return de;const H=B[ue];if(typeof H=="function"){if(_(ue))return H.call(B,ce);if(ae(ue))return ye.set(ue,w.Event.buffer(B[ue],!0,void 0,se)),ye.get(ue)}throw new p.$bb(`Event not found: ${ue}`)}call(le,ue,ce){const de=B[ue];if(typeof de=="function"){if(!ie&&Array.isArray(ce))for(let Z=0;Z<ce.length;Z++)ce[Z]=(0,M.$Oh)(ce[Z]);let H=de.apply(B,ce);return H instanceof Promise||(H=Promise.resolve(H)),H}throw new p.$bb(`Method not found: ${ue}`)}}}x.fromService=X;function Q(ge,se){const re=se&&se.disableMarshalling;return new Proxy({},{get(B,ie){if(typeof ie=="string")return se?.properties?.has(ie)?se.properties.get(ie):_(ie)?function(ye){return ge.listen(ie,ye)}:ae(ie)?ge.listen(ie):async function(...ye){let le;se&&!(0,v.$2f)(se.context)?le=[se.context,...ye]:le=ye;const ue=await ge.call(ie,le);return re?ue:(0,M.$Oh)(ue)};throw new p.$bb(`Property not found: ${String(ie)}`)}})}x.toService=Q;function ae(ge){return ge[0]==="o"&&ge[1]==="n"&&C.$if(ge.charCodeAt(2))}function _(ge){return/^onDynamic/.test(ge)&&C.$if(ge.charCodeAt(9))}})(F||(e.ProxyChannel=F={}));const I=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function O(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){const X=x.toString();if(X!=="[object Object]")return X}return x}function T(x){return Array.isArray(x)?x.map(O):O(x)}function G(x,X,Q,ae,_,ge,se){se=T(se);const re=I[_],B=re[ae%re.length];let ie=[`%c[${x}]%c[${String(X).padStart(7," ")}]%c[len: ${String(Q).padStart(5," ")}]%c${String(ae).padStart(5," ")} - ${ge}`,"color: darkgreen","color: grey","color: grey",`color: ${B}`];/\($/.test(ge)?(ie=ie.concat(se),ie.push(")")):ie.push(se),console.log.apply(console,ie)}class te{constructor(X,Q){this.d=X,this.f=Q,this.a=0,this.b=0}logOutgoing(X,Q,ae,_,ge){this.b+=X,G(this.d,this.b,X,Q,ae,_,ge)}logIncoming(X,Q,ae,_,ge){this.a+=X,G(this.f,this.a,X,Q,ae,_,ge)}}e.$1h=te}),define(Se[81],De([1,0,21,4,3,80]),function(fe,e,l,j,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=e.$5h=e.$4h=e.$3h=e.ProtocolConstants=e.$2h=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var R;(function(r){r.Created="created",r.Read="read",r.Write="write",r.Open="open",r.Error="error",r.Close="close",r.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",r.NodeEndReceived="nodeEndReceived",r.NodeEndSent="nodeEndSent",r.NodeDrainBegin="nodeDrainBegin",r.NodeDrainEnd="nodeDrainEnd",r.zlibInflateError="zlibInflateError",r.zlibInflateData="zlibInflateData",r.zlibInflateInitialWrite="zlibInflateInitialWrite",r.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",r.zlibInflateWrite="zlibInflateWrite",r.zlibInflateFlushFired="zlibInflateFlushFired",r.zlibDeflateError="zlibDeflateError",r.zlibDeflateData="zlibDeflateData",r.zlibDeflateWrite="zlibDeflateWrite",r.zlibDeflateFlushFired="zlibDeflateFlushFired",r.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",r.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",r.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",r.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",r.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",r.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",r.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",r.ProtocolHeaderRead="protocolHeaderRead",r.ProtocolMessageRead="protocolMessageRead",r.ProtocolHeaderWrite="protocolHeaderWrite",r.ProtocolMessageWrite="protocolMessageWrite",r.ProtocolWrite="protocolWrite"})(R||(e.SocketDiagnosticsEventType=R={}));var p;(function(r){r.enableDiagnostics=!1,r.records=[];const a=new WeakMap;let d=0;function $(b,g){if(!a.has(b)){const y=String(++d);a.set(b,y)}return a.get(b)}function D(b,g,y,P){if(!r.enableDiagnostics)return;const N=$(b,g);if(P instanceof l.$se||P instanceof Uint8Array||P instanceof ArrayBuffer||ArrayBuffer.isView(P)){const U=l.$se.alloc(P.byteLength);U.set(P),r.records.push({timestamp:Date.now(),id:N,label:g,type:y,buff:U})}else r.records.push({timestamp:Date.now(),id:N,label:g,type:y,data:P})}r.traceSocketEvent=D})(p||(e.SocketDiagnostics=p={}));var w;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(w||(e.SocketCloseEventType=w={}));let E=null;function M(){return E||(E=l.$se.alloc(0)),E}class C{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(a){this.a.push(a),this.b+=a.byteLength}read(a){return this.c(a,!0)}peek(a){return this.c(a,!1)}c(a,d){if(a===0)return M();if(a>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===a){const g=this.a[0];return d&&(this.a.shift(),this.b-=a),g}if(this.a[0].byteLength>a){const g=this.a[0].slice(0,a);return d&&(this.a[0]=this.a[0].slice(a),this.b-=a),g}const $=l.$se.alloc(a);let D=0,b=0;for(;a>0;){const g=this.a[b];if(g.byteLength>a){const y=g.slice(0,a);$.set(y,D),D+=a,d&&(this.a[b]=g.slice(a),this.b-=a),a-=a}else $.set(g,D),D+=g.byteLength,d?(this.a.shift(),this.b-=g.byteLength):b++,a-=g.byteLength}return $}}e.$2h=C;var v;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest",r[r.Pause=7]="Pause",r[r.Resume=8]="Resume",r[r.KeepAlive=9]="KeepAlive"})(v||(v={}));function S(r){switch(r){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var k;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.TimeoutTime=2e4]="TimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",r[r.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(k||(e.ProtocolConstants=k={}));class u{constructor(a,d,$,D){this.type=a,this.id=d,this.ack=$,this.data=D,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends L.$Tc{constructor(a){super(),this.f=this.B(new j.$5d),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=a,this.b=!1,this.c=new C,this.B(this.a.onData(d=>this.acceptChunk(d))),this.lastReadTime=Date.now()}acceptChunk(a){if(!(!a||a.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(a);this.c.byteLength>=this.g.readLen;){const d=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=d.readUInt32BE(9),this.g.messageType=d.readUInt8(0),this.g.id=d.readUInt32BE(1),this.g.ack=d.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:S(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const $=this.g.messageType,D=this.g.id,b=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",d),this.f.fire(new u($,D,b,d)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class o{constructor(a){this.k=null,this.a=!1,this.b=!1,this.c=a,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(a){if(this.a)return;a.writtenTime=Date.now(),this.lastWriteTime=Date.now();const d=l.$se.alloc(13);d.writeUInt8(a.type,0),d.writeUInt32BE(a.id,1),d.writeUInt32BE(a.ack,5),d.writeUInt32BE(a.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:S(a.type),id:a.id,ack:a.ack,messageSize:a.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",a.data),this.j(d,a.data)}g(a,d){const $=this.f===0;return this.d.push(a,d),this.f+=a.byteLength+d.byteLength,$}h(){const a=l.$se.concat(this.d,this.f);return this.d.length=0,this.f=0,a}j(a,d){this.g(a,d)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const a=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:a.byteLength}),this.c.write(a)}}class i extends L.$Tc{constructor(a){super(),this.f=new j.$5d,this.onMessage=this.f.event,this.g=new j.$5d,this.onDidDispose=this.g.event,this.a=a,this.b=this.B(new o(this.a)),this.c=this.B(new m(this.a)),this.B(this.c.onMessage(d=>{d.type===1&&this.f.fire(d.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(a){this.b.write(new u(1,0,0,a))}}e.$3h=i;class n extends A.$Wh{static fromSocket(a,d){return new n(new i(a),d)}get onDidDispose(){return this.b.onDidDispose}constructor(a,d,$=null){super(a,d,$),this.b=a}dispose(){super.dispose();const a=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),a.end()}}e.$4h=n;class s{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new j.$5d({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(a){this.b?this.d.length>0?this.d.push(a):this.a.fire(a):this.d.push(a)}flushBuffer(){this.d=[]}}e.$5h=s;class c{constructor(a){this.data=a,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let a=0,d=this.a;for(;d;)d=d.next,a++;return a}peek(){return this.a?this.a.data:null}toArray(){const a=[];let d=0,$=this.a;for(;$;)a[d++]=$.data,$=$.next;return a}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(a){const d=new c(a);if(!this.a){this.a=d,this.b=d;return}this.b.next=d,this.b=d}}class f{static{this.a=10}static{this.b=null}static getInstance(){return f.b||(f.b=new f),f.b}constructor(){this.c=[];const a=Date.now();for(let d=0;d<f.a;d++)this.c[d]=a-1e3*d;setInterval(()=>{for(let d=f.a;d>=1;d--)this.c[d]=this.c[d-1];this.c[0]=Date.now()},1e3)}d(){const a=Date.now(),d=(1+f.a)*1e3;let $=0;for(let D=0;D<f.a;D++)a-this.c[D]<=d&&$++;return 1-$/f.a}hasHighLoad(){return this.d()>=.5}}class h{get unacknowledgedCount(){return this.c-this.d}constructor(a){this.u=new s,this.onControlMessage=this.u.event,this.v=new s,this.onMessage=this.v.event,this.w=new s,this.onDidDispose=this.w.event,this.x=new s,this.onSocketClose=this.x.event,this.y=new s,this.onSocketTimeout=this.y.event,this.s=a.loadEstimator??f.getInstance(),this.t=a.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new L.$Sc,this.o=a.socket,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new m(this.o)),this.r.add(this.q.onMessage(d=>this.z(d))),this.r.add(this.o.onClose(d=>this.x.fire(d))),a.initialChunk&&this.q.acceptChunk(a.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const a=new u(5,0,0,M());this.p.write(a),this.p.flush()}sendPause(){const a=new u(7,0,0,M());this.p.write(a)}sendResume(){const a=new u(8,0,0,M());this.p.write(a)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(a,d){this.a=!0,this.r.dispose(),this.r=new L.$Sc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=a,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new m(this.o)),this.r.add(this.q.onMessage($=>this.z($))),this.r.add(this.o.onClose($=>this.x.fire($))),this.q.acceptChunk(d)}endAcceptReconnection(){this.a=!1,this.h=this.g;const a=new u(3,0,this.h,M());this.p.write(a);const d=this.b.toArray();for(let $=0,D=d.length;$<D;$++)this.p.write(d[$]);this.B()}acceptDisconnect(){this.w.fire()}z(a){if(a.ack>this.d){this.d=a.ack;do{const d=this.b.peek();if(d&&d.id<=a.ack)this.b.pop();else break}while(!0)}switch(a.type){case 0:break;case 1:{if(a.id>this.g)if(a.id!==this.g+1){const d=Date.now();d-this.m>1e4&&(this.m=d,this.p.write(new u(6,0,0,M())))}else this.g=a.id,this.j=Date.now(),this.A(),this.v.fire(a.data);break}case 2:{this.u.fire(a.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const d=this.b.toArray();for(let $=0,D=d.length;$<D;$++)this.p.write(d[$]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(a){const d=++this.c;this.h=this.g;const $=new u(1,d,this.h,a);this.b.push($),this.a||(this.p.write($),this.B())}sendControl(a){const d=new u(2,0,0,a);this.p.write(d)}A(){if(this.g<=this.h||this.k)return;const a=Date.now()-this.j;if(a>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-a+5)}B(){if(this.c<=this.d||this.f||this.a)return;const a=this.b.peek(),d=Date.now()-a.writtenTime,$=Date.now()-this.q.lastReadTime,D=Date.now()-this.n;if(d>=2e4&&$>=2e4&&D>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:d,timeSinceLastReceivedSomeData:$});return}const b=Math.max(2e4-d,2e4-$,2e4-D,500);this.f=setTimeout(()=>{this.f=null,this.B()},b)}C(){if(this.g<=this.h)return;this.h=this.g;const a=new u(3,0,this.h,M());this.p.write(a)}D(){this.h=this.g;const a=new u(9,0,this.h,M());this.p.write(a)}}e.$6h=h}),define(Se[192],De([1,0,51,8,21,22,190,13,4,3,24,105,102,80]),function(fe,e,l,j,L,A,R,p,w,E,M,C,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=e.$Eq=void 0;class k extends S.$Th{constructor(o){super({send:i=>{try{process.send?.(i.buffer.toString("base64"))}catch{}},onMessage:w.Event.fromNodeEventEmitter(process,"message",i=>L.$se.wrap(Buffer.from(i,"base64")))},o),process.once("disconnect",()=>this.dispose())}}e.$Eq=k;class u{constructor(o,i){this.i=o,this.j=i,this.c=new Set,this.g=new Map,this.h=new w.$5d,this.onDidProcessExit=this.h.event;const n=i&&i.timeout?i.timeout:6e4;this.b=new j.$ch(n),this.d=null,this.f=null}getChannel(o){const i=this;return{call(n,s,c){return i.k(o,n,s,c)},listen(n,s){return i.l(o,n,s)}}}k(o,i,n,s=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(s.isCancellationRequested)return Promise.reject(p.$6());this.b.cancel();const c=this.n(o),t=(0,j.$5g)(r=>c.call(i,n,r)),f=s.onCancellationRequested(()=>t.cancel()),h=(0,E.$Rc)(()=>t.cancel());return this.c.add(h),t.finally(()=>{f.dispose(),this.c.delete(h),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(o,i,n){if(!this.b)return w.Event.None;this.b.cancel();let s;const c=new w.$5d({onWillAddFirstListener:()=>{s=this.n(o).listen(i,n)(c.fire,c),this.c.add(s)},onDidRemoveLastListener:()=>{this.c.delete(s),s.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return c.event}get m(){if(!this.f){const o=this.j&&this.j.args?this.j.args:[],i=Object.create(null);i.env={...(0,M.$Kn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(i.env={...i.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(i.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(i.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(i.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),i.execArgv===void 0&&(i.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a)).filter(a=>!a.startsWith("--vscode-"))),(0,v.$3l)(i.env),this.d=(0,l.fork)(this.i,o,i);const n=new w.$5d;w.Event.fromNodeEventEmitter(this.d,"message",a=>a)(a=>{if((0,R.$Aq)(a)){(0,R.log)(a,`IPC Library: ${this.j.serverName}`);return}n.fire(L.$se.wrap(Buffer.from(a,"base64")))});const c=this.j.useQueue?(0,C.$5l)(this.d):this.d,t=a=>this.d&&this.d.connected&&c.send(a.buffer.toString("base64")),f=n.event,h={send:t,onMessage:f};this.f=new S.$Uh(h);const r=()=>this.o();process.once("exit",r),this.d.on("error",a=>console.warn('IPC "'+this.j.serverName+'" errored with '+a)),this.d.on("exit",(a,d)=>{process.removeListener("exit",r),this.c.forEach($=>(0,E.$Oc)($)),this.c.clear(),a!==0&&d!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+a+" and signal "+d),this.b?.cancel(),this.o(),this.h.fire({code:a,signal:d})})}return this.f}n(o){let i=this.g.get(o);return i||(i=this.m.getChannel(o),this.g.set(o,i)),i}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Fq=u}),define(Se[193],De([1,0,8,4,3,56,18]),function(fe,e,l,j,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fp=e.$Ep=e.StorageState=e.$Dp=e.StorageHint=void 0;var p;(function(v){v[v.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",v[v.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(p||(e.StorageHint=p={}));function w(v){const S=v;return S?.changed instanceof Map||S?.deleted instanceof Set}e.$Dp=w;var E;(function(v){v[v.None=0]="None",v[v.Initialized=1]="Initialized",v[v.Closed=2]="Closed"})(E||(e.StorageState=E={}));class M extends L.$Tc{static{this.a=100}constructor(S,k=Object.create(null)){super(),this.r=S,this.s=k,this.b=this.B(new j.$8d),this.onDidChangeStorage=this.b.event,this.c=E.None,this.f=new Map,this.g=this.B(new l.$dh(M.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(S=>this.u(S)))}u(S){this.b.pause();try{S.changed?.forEach((k,u)=>this.w(u,k)),S.deleted?.forEach(k=>this.w(k,void 0))}finally{this.b.resume()}}w(S,k){if(this.c===E.Closed)return;let u=!1;(0,R.$2f)(k)?u=this.f.delete(S):this.f.get(S)!==k&&(this.f.set(S,k),u=!0),u&&this.b.fire({key:S,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===E.None&&(this.c=E.Initialized,this.s.hint!==p.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(S,k){const u=this.f.get(S);return(0,R.$2f)(u)?k:u}getBoolean(S,k){const u=this.get(S);return(0,R.$2f)(u)?k:u==="true"}getNumber(S,k){const u=this.get(S);return(0,R.$2f)(u)?k:parseInt(u,10)}getObject(S,k){const u=this.get(S);return(0,R.$2f)(u)?k:(0,A.$Nh)(u)}async set(S,k,u=!1){if(this.c===E.Closed)return;if((0,R.$2f)(k))return this.delete(S,u);const m=(0,R.$Uf)(k)||Array.isArray(k)?(0,A.$Mh)(k):String(k);if(this.f.get(S)!==m)return this.f.set(S,m),this.j.set(S,m),this.h.delete(S),this.b.fire({key:S,external:u}),this.D()}async delete(S,k=!1){if(!(this.c===E.Closed||!this.f.delete(S)))return this.h.has(S)||this.h.add(S),this.j.delete(S),this.b.fire({key:S,external:k}),this.D()}async optimize(){if(this.c!==E.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=E.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const S={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(S).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(S){if(this.z)return this.D(S)}async D(S){return this.s.hint===p.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),S)}async whenFlushed(){if(this.z)return new Promise(S=>this.n.push(S))}isInMemory(){return this.s.hint===p.STORAGE_IN_MEMORY}}e.$Ep=M;class C{constructor(){this.onDidChangeItemsExternal=j.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(S){S.insert?.forEach((k,u)=>this.a.set(u,k)),S.delete?.forEach(k=>this.a.delete(k))}async optimize(){}async close(){}}e.$Fp=C}),define(Se[194],De([1,0,14,11,21]),function(fe,e,l,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qt=e.$pt=e.$ot=void 0;let A;function R(){return A||(A=new TextDecoder("UTF-16LE")),A}let p;function w(){return p||(p=new TextDecoder("UTF-16BE")),p}let E;function M(){return E||(E=j.$D()?R():w()),E}e.$ot=M;function C(k,u,m){const o=new Uint16Array(k.buffer,u,m);return m>0&&(o[0]===65279||o[0]===65534)?v(k,u,m):R().decode(o)}e.$pt=C;function v(k,u,m){const o=[];let i=0;for(let n=0;n<m;n++){const s=L.$ue(k,u);u+=2,o[i++]=String.fromCharCode(s)}return o.join("")}class S{constructor(u){this.a=u|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const u=new Uint16Array(this.b.buffer,0,this.d);return M().decode(u)}f(){const u=this.e();this.d=0,this.c===null?this.c=[u]:this.c[this.c.length]=u}appendCharCode(u){const m=this.a-this.d;m<=1&&(m===0||l.$nf(u))&&this.f(),this.b[this.d++]=u}appendASCIICharCode(u){this.d===this.a&&this.f(),this.b[this.d++]=u}appendString(u){const m=u.length;if(this.d+m>=this.a){this.f(),this.c[this.c.length]=u;return}for(let o=0;o<m;o++)this.b[this.d++]=u.charCodeAt(o)}}e.$qt=S}),define(Se[195],De([1,0,21,194]),function(fe,e,l,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$st=e.$rt=void 0;function L(w){return w.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class A{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(E,M,C,v){this.oldPosition=E,this.oldText=M,this.newPosition=C,this.newText=v}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${L(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${L(this.oldText)}")`:`(replace@${this.oldPosition} "${L(this.oldText)}" with "${L(this.newText)}")`}static a(E){return 4+2*E.length}static c(E,M,C){const v=M.length;l.$xe(E,v,C),C+=4;for(let S=0;S<v;S++)l.$ve(E,M.charCodeAt(S),C),C+=2;return C}static d(E,M){const C=l.$we(E,M);return M+=4,(0,j.$pt)(E,M,C)}writeSize(){return 8+A.a(this.oldText)+A.a(this.newText)}write(E,M){return l.$xe(E,this.oldPosition,M),M+=4,l.$xe(E,this.newPosition,M),M+=4,M=A.c(E,this.oldText,M),M=A.c(E,this.newText,M),M}static read(E,M,C){const v=l.$we(E,M);M+=4;const S=l.$we(E,M);M+=4;const k=A.d(E,M);M+=A.a(k);const u=A.d(E,M);return M+=A.a(u),C.push(new A(v,k,S,u)),M}}e.$rt=A;function R(w,E){return w===null||w.length===0?E:new p(w,E).compress()}e.$st=R;class p{constructor(E,M){this.a=E,this.c=M,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let E=0,M=0,C=this.n(E),v=this.l(M);for(;E<this.f||M<this.h;){if(C===null){this.k(v),v=this.l(++M);continue}if(v===null){this.m(C),C=this.n(++E);continue}if(v.oldEnd<=C.newPosition){this.k(v),v=this.l(++M);continue}if(C.newEnd<=v.oldPosition){this.m(C),C=this.n(++E);continue}if(v.oldPosition<C.newPosition){const[o,i]=p.r(v,C.newPosition-v.oldPosition);this.k(o),v=i;continue}if(C.newPosition<v.oldPosition){const[o,i]=p.q(C,v.oldPosition-C.newPosition);this.m(o),C=i;continue}let u,m;if(v.oldEnd===C.newEnd)u=C,m=v,C=this.n(++E),v=this.l(++M);else if(v.oldEnd<C.newEnd){const[o,i]=p.q(C,v.oldLength);u=o,m=v,C=i,v=this.l(++M)}else{const[o,i]=p.r(v,C.newLength);u=C,m=o,C=this.n(++E),v=i}this.d[this.e++]=new A(u.oldPosition,u.oldText,m.newPosition,m.newText),this.g+=u.newLength-u.oldLength,this.j+=m.newLength-m.oldLength}const S=p.s(this.d);return p.t(S)}k(E){this.d[this.e++]=p.o(this.g,E),this.j+=E.newLength-E.oldLength}l(E){return E<this.h?this.c[E]:null}m(E){this.d[this.e++]=p.p(this.j,E),this.g+=E.newLength-E.oldLength}n(E){return E<this.f?this.a[E]:null}static o(E,M){return new A(M.oldPosition-E,M.oldText,M.newPosition,M.newText)}static p(E,M){return new A(M.oldPosition,M.oldText,M.newPosition+E,M.newText)}static q(E,M){const C=E.newText.substr(0,M),v=E.newText.substr(M);return[new A(E.oldPosition,E.oldText,E.newPosition,C),new A(E.oldEnd,"",E.newPosition+M,v)]}static r(E,M){const C=E.oldText.substr(0,M),v=E.oldText.substr(M);return[new A(E.oldPosition,C,E.newPosition,E.newText),new A(E.oldPosition+M,v,E.newEnd,"")]}static s(E){if(E.length===0)return E;const M=[];let C=0,v=E[0];for(let S=1;S<E.length;S++){const k=E[S];v.oldEnd===k.oldPosition?v=new A(v.oldPosition,v.oldText+k.oldText,v.newPosition,v.newText+k.newText):(M[C++]=v,v=k)}return M[C++]=v,M}static t(E){if(E.length===0)return E;const M=[];let C=0;for(let v=0;v<E.length;v++){const S=E[v];S.oldText!==S.newText&&(M[C++]=S)}return M}}}),define(Se[196],De([1,0,35,17]),function(fe,e,l,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qt=e.$Pt=void 0;function L(R,p,w,E,M,C){if(Array.isArray(R)){let v=0;for(const S of R){const k=L(S,p,w,E,M,C);if(k===10)return k;k>v&&(v=k)}return v}else{if(typeof R=="string")return E?R==="*"?5:R===w?10:0:0;if(R){const{language:v,pattern:S,scheme:k,hasAccessToAllModels:u,notebookType:m}=R;if(!E&&!u)return 0;m&&M&&(p=M);let o=0;if(k)if(k===p.scheme)o=10;else if(k==="*")o=5;else return 0;if(v)if(v===w)o=10;else if(v==="*")o=Math.max(o,5);else return 0;if(m)if(m===C)o=10;else if(m==="*"&&C!==void 0)o=Math.max(o,5);else return 0;if(S){let i;if(typeof S=="string"?i=S:i={...S,base:(0,j.$hc)(S.base)},i===p.fsPath||(0,l.$Xj)(i,p.fsPath))o=10;else return 0}return o}else return 0}}e.$Pt=L;function A(R){return typeof R=="string"?!1:Array.isArray(R)?R.some(A):!!R.notebookType}e.$Qt=A}),define(Se[197],De([1,0,4,14,29,78,130,172,195,3]),function(fe,e,l,j,L,A,R,p,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qC=void 0;class M extends E.$Tc{constructor(v,S,k,u,m,o,i){super(),this.m=this.B(new l.$5d),this.onDidChangeContent=this.m.event,this.f=S,this.j=!o,this.g=u,this.h=m,this.c=new R.$pC(v,k,i)}equals(v){return!(v instanceof M)||this.f!==v.f||this.getEOL()!==v.getEOL()?!1:this.c.equal(v.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(v){return this.c.createSnapshot(v?this.f:"")}getOffsetAt(v,S){return this.c.getOffsetAt(v,S)}getPositionAt(v){return this.c.getPositionAt(v)}getRangeAt(v,S){const k=v+S,u=this.getPositionAt(v),m=this.getPositionAt(k);return new L.$9s(u.lineNumber,u.column,m.lineNumber,m.column)}getValueInRange(v,S=0){if(v.isEmpty())return"";const k=this.n(S);return this.c.getValueInRange(v,k)}getValueLengthInRange(v,S=0){if(v.isEmpty())return 0;if(v.startLineNumber===v.endLineNumber)return v.endColumn-v.startColumn;const k=this.getOffsetAt(v.startLineNumber,v.startColumn),u=this.getOffsetAt(v.endLineNumber,v.endColumn);let m=0;const o=this.n(S),i=this.getEOL();if(o.length!==i.length){const n=o.length-i.length,s=v.endLineNumber-v.startLineNumber;m=n*s}return u-k+m}getCharacterCountInRange(v,S=0){if(this.j){let k=0;const u=v.startLineNumber,m=v.endLineNumber;for(let o=u;o<=m;o++){const i=this.getLineContent(o),n=o===u?v.startColumn-1:0,s=o===m?v.endColumn-1:i.length;for(let c=n;c<s;c++)j.$nf(i.charCodeAt(c))?(k=k+1,c=c+1):k=k+1}return k+=this.n(S).length*(m-u),k}return this.getValueLengthInRange(v,S)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(v){return this.c.getLineContent(v)}getLineCharCode(v,S){return this.c.getLineCharCode(v,S)}getCharCode(v){return this.c.getCharCode(v)}getLineLength(v){return this.c.getLineLength(v)}getLineMinColumn(v){return 1}getLineMaxColumn(v){return this.getLineLength(v)+1}getLineFirstNonWhitespaceColumn(v){const S=j.$$e(this.getLineContent(v));return S===-1?0:S+1}getLineLastNonWhitespaceColumn(v){const S=j.$af(this.getLineContent(v));return S===-1?0:S+2}n(v){switch(v){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(v){this.c.setEOL(v)}applyEdits(v,S,k){let u=this.g,m=this.h,o=this.j,i=!0,n=[];for(let a=0;a<v.length;a++){const d=v[a];i&&d._isTracked&&(i=!1);const $=d.range;if(d.text){let P=!0;o||(P=!j.$yf(d.text),o=P),!u&&P&&(u=j.$xf(d.text)),!m&&P&&(m=j.$Af(d.text))}let D="",b=0,g=0,y=0;if(d.text){let P;[b,g,y,P]=(0,p.$It)(d.text);const N=this.getEOL();P===0||P===(N===`\r
`?2:1)?D=d.text:D=d.text.replace(/\r\n|\r|\n/g,N)}n[a]={sortIndex:a,identifier:d.identifier||null,range:$,rangeOffset:this.getOffsetAt($.startLineNumber,$.startColumn),rangeLength:this.getValueLengthInRange($),text:D,eolCount:b,firstLineLength:g,lastLineLength:y,forceMoveMarkers:!!d.forceMoveMarkers,isAutoWhitespaceEdit:d.isAutoWhitespaceEdit||!1}}n.sort(M.u);let s=!1;for(let a=0,d=n.length-1;a<d;a++){const $=n[a].range.getEndPosition(),D=n[a+1].range.getStartPosition();if(D.isBeforeOrEqual($)){if(D.isBefore($))throw new Error("Overlapping ranges are not allowed!");s=!0}}i&&(n=this.s(n));const c=k||S?M._getInverseEditRanges(n):[],t=[];if(S)for(let a=0;a<n.length;a++){const d=n[a],$=c[a];if(d.isAutoWhitespaceEdit&&d.range.isEmpty())for(let D=$.startLineNumber;D<=$.endLineNumber;D++){let b="";D===$.startLineNumber&&(b=this.getLineContent(d.range.startLineNumber),j.$$e(b)!==-1)||t.push({lineNumber:D,oldContent:b})}}let f=null;if(k){let a=0;f=[];for(let d=0;d<n.length;d++){const $=n[d],D=c[d],b=this.getValueInRange($.range),g=$.rangeOffset+a;a+=$.text.length-b.length,f[d]={sortIndex:$.sortIndex,identifier:$.identifier,range:D,text:b,textChange:new w.$rt($.rangeOffset,b,g,$.text)}}s||f.sort((d,$)=>d.sortIndex-$.sortIndex)}this.g=u,this.h=m,this.j=o;const h=this.t(n);let r=null;if(S&&t.length>0){t.sort((a,d)=>d.lineNumber-a.lineNumber),r=[];for(let a=0,d=t.length;a<d;a++){const $=t[a].lineNumber;if(a>0&&t[a-1].lineNumber===$)continue;const D=t[a].oldContent,b=this.getLineContent($);b.length===0||b===D||j.$$e(b)!==-1||r.push($)}}return this.m.fire(),new A.$tv(f,h,r)}s(v){return v.length<1e3?v:[this._toSingleEditOperation(v)]}_toSingleEditOperation(v){let S=!1;const k=v[0].range,u=v[v.length-1].range,m=new L.$9s(k.startLineNumber,k.startColumn,u.endLineNumber,u.endColumn);let o=k.startLineNumber,i=k.startColumn;const n=[];for(let h=0,r=v.length;h<r;h++){const a=v[h],d=a.range;S=S||a.forceMoveMarkers,n.push(this.getValueInRange(new L.$9s(o,i,d.startLineNumber,d.startColumn))),a.text.length>0&&n.push(a.text),o=d.endLineNumber,i=d.endColumn}const s=n.join(""),[c,t,f]=(0,p.$It)(s);return{sortIndex:0,identifier:v[0].identifier,range:m,rangeOffset:this.getOffsetAt(m.startLineNumber,m.startColumn),rangeLength:this.getValueLengthInRange(m,0),text:s,eolCount:c,firstLineLength:t,lastLineLength:f,forceMoveMarkers:S,isAutoWhitespaceEdit:!1}}t(v){v.sort(M.w);const S=[];for(let k=0;k<v.length;k++){const u=v[k],m=u.range.startLineNumber,o=u.range.startColumn,i=u.range.endLineNumber,n=u.range.endColumn;if(m===i&&o===n&&u.text.length===0)continue;u.text?(this.c.delete(u.rangeOffset,u.rangeLength),this.c.insert(u.rangeOffset,u.text,!0)):this.c.delete(u.rangeOffset,u.rangeLength);const s=new L.$9s(m,o,i,n);S.push({range:s,rangeLength:u.rangeLength,text:u.text,rangeOffset:u.rangeOffset,forceMoveMarkers:u.forceMoveMarkers})}return S}findMatchesLineByLine(v,S,k,u){return this.c.findMatchesLineByLine(v,S,k,u)}getPieceTree(){return this.c}static _getInverseEditRange(v,S){const k=v.startLineNumber,u=v.startColumn,[m,o,i]=(0,p.$It)(S);let n;if(S.length>0){const s=m+1;s===1?n=new L.$9s(k,u,k,u+o):n=new L.$9s(k,u,k+s-1,i+1)}else n=new L.$9s(k,u,k,u);return n}static _getInverseEditRanges(v){const S=[];let k=0,u=0,m=null;for(let o=0,i=v.length;o<i;o++){const n=v[o];let s,c;m?m.range.endLineNumber===n.range.startLineNumber?(s=k,c=u+(n.range.startColumn-m.range.endColumn)):(s=k+(n.range.startLineNumber-m.range.endLineNumber),c=n.range.startColumn):(s=n.range.startLineNumber,c=n.range.startColumn);let t;if(n.text.length>0){const f=n.eolCount+1;f===1?t=new L.$9s(s,c,s,c+n.firstLineLength):t=new L.$9s(s,c,s+f-1,n.lastLineLength+1)}else t=new L.$9s(s,c,s,c);k=t.endLineNumber,u=t.endColumn,S.push(t),m=n}return S}static u(v,S){const k=L.$9s.compareRangesUsingEnds(v.range,S.range);return k===0?v.sortIndex-S.sortIndex:k}static w(v,S){const k=L.$9s.compareRangesUsingEnds(v.range,S.range);return k===0?S.sortIndex-v.sortIndex:-k}}e.$qC=M}),define(Se[198],De([1,0,14,130,197]),function(fe,e,l,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rC=void 0;class A{constructor(w,E,M,C,v,S,k,u,m){this.a=w,this.b=E,this.c=M,this.d=C,this.e=v,this.f=S,this.g=k,this.h=u,this.j=m}k(w){const E=this.c+this.d+this.e,M=this.c+this.e;return E===0?w===1?`
`:`\r
`:M>E/2?`\r
`:`
`}create(w){const E=this.k(w),M=this.a;if(this.j&&(E===`\r
`&&(this.c>0||this.d>0)||E===`
`&&(this.c>0||this.e>0)))for(let v=0,S=M.length;v<S;v++){const k=M[v].buffer.replace(/\r\n|\r|\n/g,E),u=(0,j.$lC)(k);M[v]=new j.$oC(k,u)}const C=new L.$qC(M,this.b,E,this.f,this.g,this.h,this.j);return{textBuffer:C,disposable:C}}getFirstLineText(w){return this.a[0].buffer.substr(0,w).split(/\r\n|\r|\n/)[0]}}class R{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(w){if(w.length===0)return;this.a.length===0&&l.$Gf(w)&&(this.b=l.$Ff,w=w.substr(1));const E=w.charCodeAt(w.length-1);E===13||E>=55296&&E<=56319?(this.m(w.substr(0,w.length-1),!1),this.c=!0,this.d=E):(this.m(w,!1),this.c=!1,this.d=E)}m(w,E){!E&&w.length===0||(this.c?this.n(String.fromCharCode(this.d)+w):this.n(w))}n(w){const E=(0,j.$mC)(this.e,w);this.a.push(new j.$oC(w,E.lineStarts)),this.f+=E.cr,this.g+=E.lf,this.h+=E.crlf,E.isBasicASCII||(this.l=!1,this.j||(this.j=l.$xf(w)),this.k||(this.k=l.$Af(w)))}finish(w=!0){return this.o(),new A(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,w)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const w=this.a[this.a.length-1];w.buffer+=String.fromCharCode(this.d);const E=(0,j.$lC)(w.buffer);w.lineStarts=E,this.d===13&&this.f++}}}e.$rC=R}),define(Se[134],De([1,0,21,11]),function(fe,e,l,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eab=e.$dab=void 0;var L;(function(C){C[C.Full=1]="Full",C[C.Delta=2]="Delta"})(L||(L={}));function A(C){for(let v=0,S=C.length;v<S;v+=4){const k=C[v+0],u=C[v+1],m=C[v+2],o=C[v+3];C[v+0]=o,C[v+1]=m,C[v+2]=u,C[v+3]=k}}function R(C){const v=new Uint8Array(C.buffer,C.byteOffset,C.length*4);return j.$D()||A(v),l.$se.wrap(v)}function p(C){const v=C.buffer;if(j.$D()||A(v),v.byteOffset%4===0)return new Uint32Array(v.buffer,v.byteOffset,v.length/4);{const S=new Uint8Array(v.byteLength);return S.set(v),new Uint32Array(S.buffer,S.byteOffset,S.length/4)}}function w(C){const v=new Uint32Array(E(C));let S=0;if(v[S++]=C.id,C.type==="full")v[S++]=1,v[S++]=C.data.length,v.set(C.data,S),S+=C.data.length;else{v[S++]=2,v[S++]=C.deltas.length;for(const k of C.deltas)v[S++]=k.start,v[S++]=k.deleteCount,k.data?(v[S++]=k.data.length,v.set(k.data,S),S+=k.data.length):v[S++]=0}return R(v)}e.$dab=w;function E(C){let v=0;if(v+=2,C.type==="full")v+=1+C.data.length;else{v+=1,v+=3*C.deltas.length;for(const S of C.deltas)S.data&&(v+=S.data.length)}return v}function M(C){const v=p(C);let S=0;const k=v[S++];if(v[S++]===1){const i=v[S++],n=v.subarray(S,S+i);return S+=i,{id:k,type:"full",data:n}}const m=v[S++],o=[];for(let i=0;i<m;i++){const n=v[S++],s=v[S++],c=v[S++];let t;c>0&&(t=v.subarray(S,S+c),S+=c),o[i]={start:n,deleteCount:s,data:t}}return{id:k,type:"delta",deltas:o}}e.$eab=M}),define(Se[199],De([9,10]),function(fe,e){return fe.create("vs/editor/common/config/editorOptions",e)}),define(Se[135],De([1,0,19,24,11,175,129,199]),function(fe,e,l,j,L,A,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var w;(function(ne){ne[ne.None=0]="None",ne[ne.Keep=1]="Keep",ne[ne.Brackets=2]="Brackets",ne[ne.Advanced=3]="Advanced",ne[ne.Full=4]="Full"})(w||(e.EditorAutoIndentStrategy=w={})),e.MINIMAP_GUTTER_WIDTH=8;class E{constructor(oe){this.c=oe}hasChanged(oe){return this.c[oe]}}e.ConfigurationChangedEvent=E;class M{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=M;class C{constructor(oe,Ce,Ge,xe){this.id=oe,this.name=Ce,this.defaultValue=Ge,this.schema=xe}applyUpdate(oe,Ce){return S(oe,Ce)}compute(oe,Ce,Ge){return Ge}}class v{constructor(oe,Ce){this.newValue=oe,this.didChange=Ce}}e.ApplyUpdateResult=v;function S(ne,oe){if(typeof ne!="object"||typeof oe!="object"||!ne||!oe)return new v(oe,ne!==oe);if(Array.isArray(ne)||Array.isArray(oe)){const Ge=Array.isArray(ne)&&Array.isArray(oe)&&l.$ub(ne,oe);return new v(oe,!Ge)}let Ce=!1;for(const Ge in oe)if(oe.hasOwnProperty(Ge)){const xe=S(ne[Ge],oe[Ge]);xe.didChange&&(ne[Ge]=xe.newValue,Ce=!0)}return new v(ne,Ce)}class k{constructor(oe){this.schema=void 0,this.id=oe,this.name="_never_",this.defaultValue=void 0}applyUpdate(oe,Ce){return S(oe,Ce)}validate(oe){return this.defaultValue}}class u{constructor(oe,Ce,Ge,xe){this.id=oe,this.name=Ce,this.defaultValue=Ge,this.schema=xe}applyUpdate(oe,Ce){return S(oe,Ce)}validate(oe){return typeof oe>"u"?this.defaultValue:oe}compute(oe,Ce,Ge){return Ge}}function m(ne,oe){return typeof ne>"u"?oe:ne==="false"?!1:!!ne}e.boolean=m;class o extends u{constructor(oe,Ce,Ge,xe=void 0){typeof xe<"u"&&(xe.type="boolean",xe.default=Ge),super(oe,Ce,Ge,xe)}validate(oe){return m(oe,this.defaultValue)}}function i(ne,oe,Ce,Ge){if(typeof ne>"u")return oe;let xe=parseInt(ne,10);return isNaN(xe)?oe:(xe=Math.max(Ce,xe),xe=Math.min(Ge,xe),xe|0)}e.clampedInt=i;class n extends u{static clampedInt(oe,Ce,Ge,xe){return i(oe,Ce,Ge,xe)}constructor(oe,Ce,Ge,xe,nt,Ne=void 0){typeof Ne<"u"&&(Ne.type="integer",Ne.default=Ge,Ne.minimum=xe,Ne.maximum=nt),super(oe,Ce,Ge,Ne),this.minimum=xe,this.maximum=nt}validate(oe){return n.clampedInt(oe,this.defaultValue,this.minimum,this.maximum)}}function s(ne,oe,Ce,Ge){if(typeof ne>"u")return oe;const xe=c.float(ne,oe);return c.clamp(xe,Ce,Ge)}e.clampedFloat=s;class c extends u{static clamp(oe,Ce,Ge){return oe<Ce?Ce:oe>Ge?Ge:oe}static float(oe,Ce){if(typeof oe=="number")return oe;if(typeof oe>"u")return Ce;const Ge=parseFloat(oe);return isNaN(Ge)?Ce:Ge}constructor(oe,Ce,Ge,xe,nt){typeof nt<"u"&&(nt.type="number",nt.default=Ge),super(oe,Ce,Ge,nt),this.validationFn=xe}validate(oe){return this.validationFn(c.float(oe,this.defaultValue))}}class t extends u{static string(oe,Ce){return typeof oe!="string"?Ce:oe}constructor(oe,Ce,Ge,xe=void 0){typeof xe<"u"&&(xe.type="string",xe.default=Ge),super(oe,Ce,Ge,xe)}validate(oe){return t.string(oe,this.defaultValue)}}function f(ne,oe,Ce,Ge){return typeof ne!="string"?oe:Ge&&ne in Ge?Ge[ne]:Ce.indexOf(ne)===-1?oe:ne}e.stringSet=f;class h extends u{constructor(oe,Ce,Ge,xe,nt=void 0){typeof nt<"u"&&(nt.type="string",nt.enum=xe,nt.default=Ge),super(oe,Ce,Ge,nt),this.c=xe}validate(oe){return f(oe,this.defaultValue,this.c)}}class r extends C{constructor(oe,Ce,Ge,xe,nt,Ne,$t=void 0){typeof $t<"u"&&($t.type="string",$t.enum=nt,$t.default=xe),super(oe,Ce,Ge,$t),this.c=nt,this.d=Ne}validate(oe){return typeof oe!="string"?this.defaultValue:this.c.indexOf(oe)===-1?this.defaultValue:this.d(oe)}}function a(ne){switch(ne){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class d extends C{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[p.localize(0,null),p.localize(1,null),p.localize(2,null)],default:"auto",tags:["accessibility"],description:p.localize(3,null)})}validate(oe){switch(oe){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(oe,Ce,Ge){return Ge===0?oe.accessibilitySupport:Ge}}class $ extends C{constructor(){const oe={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",oe,{"editor.comments.insertSpace":{type:"boolean",default:oe.insertSpace,description:p.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:oe.ignoreEmptyLines,description:p.localize(5,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{insertSpace:m(Ce.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:m(Ce.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var D;(function(ne){ne[ne.Hidden=0]="Hidden",ne[ne.Blink=1]="Blink",ne[ne.Smooth=2]="Smooth",ne[ne.Phase=3]="Phase",ne[ne.Expand=4]="Expand",ne[ne.Solid=5]="Solid"})(D||(e.TextEditorCursorBlinkingStyle=D={}));function b(ne){switch(ne){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var g;(function(ne){ne[ne.Line=1]="Line",ne[ne.Block=2]="Block",ne[ne.Underline=3]="Underline",ne[ne.LineThin=4]="LineThin",ne[ne.BlockOutline=5]="BlockOutline",ne[ne.UnderlineThin=6]="UnderlineThin"})(g||(e.TextEditorCursorStyle=g={}));function y(ne){switch(ne){case g.Line:return"line";case g.Block:return"block";case g.Underline:return"underline";case g.LineThin:return"line-thin";case g.BlockOutline:return"block-outline";case g.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=y;function P(ne){switch(ne){case"line":return g.Line;case"block":return g.Block;case"underline":return g.Underline;case"line-thin":return g.LineThin;case"block-outline":return g.BlockOutline;case"underline-thin":return g.UnderlineThin}}class N extends k{constructor(){super(141)}compute(oe,Ce,Ge){const xe=["monaco-editor"];return Ce.get(39)&&xe.push(Ce.get(39)),oe.extraEditorClassName&&xe.push(oe.extraEditorClassName),Ce.get(74)==="default"?xe.push("mouse-default"):Ce.get(74)==="copy"&&xe.push("mouse-copy"),Ce.get(111)&&xe.push("showUnused"),Ce.get(139)&&xe.push("showDeprecated"),xe.join(" ")}}class U extends o{constructor(){super(37,"emptySelectionClipboard",!0,{description:p.localize(6,null)})}compute(oe,Ce,Ge){return Ge&&oe.emptySelectionClipboard}}class z extends C{constructor(){const oe={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",oe,{"editor.find.cursorMoveOnType":{type:"boolean",default:oe.cursorMoveOnType,description:p.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:oe.seedSearchStringFromSelection,enumDescriptions:[p.localize(8,null),p.localize(9,null),p.localize(10,null)],description:p.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:oe.autoFindInSelection,enumDescriptions:[p.localize(12,null),p.localize(13,null),p.localize(14,null)],description:p.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:oe.globalFindClipboard,description:p.localize(16,null),included:L.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:oe.addExtraSpaceOnTop,description:p.localize(17,null)},"editor.find.loop":{type:"boolean",default:oe.loop,description:p.localize(18,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{cursorMoveOnType:m(Ce.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof oe.seedSearchStringFromSelection=="boolean"?oe.seedSearchStringFromSelection?"always":"never":f(Ce.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof oe.autoFindInSelection=="boolean"?oe.autoFindInSelection?"always":"never":f(Ce.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:m(Ce.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:m(Ce.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:m(Ce.loop,this.defaultValue.loop)}}}class F extends C{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",F.OFF,{anyOf:[{type:"boolean",description:p.localize(19,null)},{type:"string",description:p.localize(20,null)}],description:p.localize(21,null),default:!1})}validate(oe){return typeof oe>"u"?this.defaultValue:typeof oe=="string"?oe==="false"||oe.length===0?F.OFF:oe==="true"?F.ON:oe:oe?F.ON:F.OFF}}e.EditorFontLigatures=F;class I extends C{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",I.OFF,{anyOf:[{type:"boolean",description:p.localize(22,null)},{type:"string",description:p.localize(23,null)}],description:p.localize(24,null),default:!1})}validate(oe){return typeof oe>"u"?this.defaultValue:typeof oe=="string"?oe==="false"?I.OFF:oe==="true"?I.TRANSLATE:oe:oe?I.TRANSLATE:I.OFF}compute(oe,Ce,Ge){return oe.fontInfo.fontVariationSettings}}e.EditorFontVariations=I;class O extends k{constructor(){super(50)}compute(oe,Ce,Ge){return oe.fontInfo}}class T extends u{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:p.localize(25,null)})}validate(oe){const Ce=c.float(oe,this.defaultValue);return Ce===0?e.EDITOR_FONT_DEFAULTS.fontSize:c.clamp(Ce,6,100)}compute(oe,Ce,Ge){return oe.fontInfo.fontSize}}class G extends C{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:G.d,maximum:G.e,errorMessage:p.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:G.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:p.localize(27,null)})}validate(oe){return oe==="normal"||oe==="bold"?oe:String(n.clampedInt(oe,e.EDITOR_FONT_DEFAULTS.fontWeight,G.d,G.e))}}class te extends C{constructor(){const oe={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ce={type:"string",enum:["peek","gotoAndPeek","goto"],default:oe.multiple,enumDescriptions:[p.localize(28,null),p.localize(29,null),p.localize(30,null)]},Ge=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",oe,{"editor.gotoLocation.multiple":{deprecationMessage:p.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:p.localize(32,null),...Ce},"editor.gotoLocation.multipleTypeDefinitions":{description:p.localize(33,null),...Ce},"editor.gotoLocation.multipleDeclarations":{description:p.localize(34,null),...Ce},"editor.gotoLocation.multipleImplementations":{description:p.localize(35,null),...Ce},"editor.gotoLocation.multipleReferences":{description:p.localize(36,null),...Ce},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:oe.alternativeDefinitionCommand,enum:Ge,description:p.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:oe.alternativeTypeDefinitionCommand,enum:Ge,description:p.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:oe.alternativeDeclarationCommand,enum:Ge,description:p.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:oe.alternativeImplementationCommand,enum:Ge,description:p.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:oe.alternativeReferenceCommand,enum:Ge,description:p.localize(41,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{multiple:f(Ce.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ce.multipleDefinitions??f(Ce.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ce.multipleTypeDefinitions??f(Ce.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ce.multipleDeclarations??f(Ce.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ce.multipleImplementations??f(Ce.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ce.multipleReferences??f(Ce.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ce.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ce.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ce.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ce.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ce.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class x extends C{constructor(){const oe={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",oe,{"editor.hover.enabled":{type:"boolean",default:oe.enabled,description:p.localize(42,null)},"editor.hover.delay":{type:"number",default:oe.delay,minimum:0,maximum:1e4,description:p.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:oe.sticky,description:p.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:oe.hidingDelay,description:p.localize(45,null)},"editor.hover.above":{type:"boolean",default:oe.above,description:p.localize(46,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{enabled:m(Ce.enabled,this.defaultValue.enabled),delay:n.clampedInt(Ce.delay,this.defaultValue.delay,0,1e4),sticky:m(Ce.sticky,this.defaultValue.sticky),hidingDelay:n.clampedInt(Ce.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:m(Ce.above,this.defaultValue.above)}}}var X;(function(ne){ne[ne.None=0]="None",ne[ne.Text=1]="Text",ne[ne.Blocks=2]="Blocks"})(X||(e.RenderMinimap=X={}));class Q extends k{constructor(){super(144)}compute(oe,Ce,Ge){return Q.computeLayout(Ce,{memory:oe.memory,outerWidth:oe.outerWidth,outerHeight:oe.outerHeight,isDominatedByLongLines:oe.isDominatedByLongLines,lineHeight:oe.fontInfo.lineHeight,viewLineCount:oe.viewLineCount,lineNumbersDigitCount:oe.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:oe.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:oe.fontInfo.maxDigitWidth,pixelRatio:oe.pixelRatio,glyphMarginDecorationLaneCount:oe.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(oe){const Ce=oe.height/oe.lineHeight,Ge=Math.floor(oe.paddingTop/oe.lineHeight);let xe=Math.floor(oe.paddingBottom/oe.lineHeight);oe.scrollBeyondLastLine&&(xe=Math.max(xe,Ce-1));const nt=(Ge+oe.viewLineCount+xe)/(oe.pixelRatio*oe.height),Ne=Math.floor(oe.viewLineCount/nt);return{typicalViewportLineCount:Ce,extraLinesBeforeFirstLine:Ge,extraLinesBeyondLastLine:xe,desiredRatio:nt,minimapLineCount:Ne}}static c(oe,Ce){const Ge=oe.outerWidth,xe=oe.outerHeight,nt=oe.pixelRatio;if(!oe.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(nt*xe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:xe};const Ne=Ce.stableMinimapLayoutInput,$t=Ne&&oe.outerHeight===Ne.outerHeight&&oe.lineHeight===Ne.lineHeight&&oe.typicalHalfwidthCharacterWidth===Ne.typicalHalfwidthCharacterWidth&&oe.pixelRatio===Ne.pixelRatio&&oe.scrollBeyondLastLine===Ne.scrollBeyondLastLine&&oe.paddingTop===Ne.paddingTop&&oe.paddingBottom===Ne.paddingBottom&&oe.minimap.enabled===Ne.minimap.enabled&&oe.minimap.side===Ne.minimap.side&&oe.minimap.size===Ne.minimap.size&&oe.minimap.showSlider===Ne.minimap.showSlider&&oe.minimap.renderCharacters===Ne.minimap.renderCharacters&&oe.minimap.maxColumn===Ne.minimap.maxColumn&&oe.minimap.scale===Ne.minimap.scale&&oe.verticalScrollbarWidth===Ne.verticalScrollbarWidth&&oe.isViewportWrapping===Ne.isViewportWrapping,Dt=oe.lineHeight,Pt=oe.typicalHalfwidthCharacterWidth,Tt=oe.scrollBeyondLastLine,Xt=oe.minimap.renderCharacters;let Ct=nt>=2?Math.round(oe.minimap.scale*2):oe.minimap.scale;const Jt=oe.minimap.maxColumn,Yt=oe.minimap.size,_t=oe.minimap.side,ni=oe.verticalScrollbarWidth,et=oe.viewLineCount,Bt=oe.remainingWidth,ei=oe.isViewportWrapping,dt=Xt?2:3;let wt=Math.floor(nt*xe);const ti=wt/nt;let Ht=!1,Ut=!1,ft=dt*Ct,Rt=Ct/nt,ii=1;if(Yt==="fill"||Yt==="fit"){const{typicalViewportLineCount:Ot,extraLinesBeforeFirstLine:At,extraLinesBeyondLastLine:qt,desiredRatio:si,minimapLineCount:zt}=Q.computeContainedMinimapLineCount({viewLineCount:et,scrollBeyondLastLine:Tt,paddingTop:oe.paddingTop,paddingBottom:oe.paddingBottom,height:xe,lineHeight:Dt,pixelRatio:nt});if(et/zt>1)Ht=!0,Ut=!0,Ct=1,ft=1,Rt=Ct/nt;else{let kt=!1,jt=Ct+1;if(Yt==="fit"){const Qt=Math.ceil((At+et+qt)*ft);ei&&$t&&Bt<=Ce.stableFitRemainingWidth?(kt=!0,jt=Ce.stableFitMaxMinimapScale):kt=Qt>wt}if(Yt==="fill"||kt){Ht=!0;const Qt=Ct;ft=Math.min(Dt*nt,Math.max(1,Math.floor(1/si))),ei&&$t&&Bt<=Ce.stableFitRemainingWidth&&(jt=Ce.stableFitMaxMinimapScale),Ct=Math.min(jt,Math.max(1,Math.floor(ft/dt))),Ct>Qt&&(ii=Math.min(2,Ct/Qt)),Rt=Ct/nt/ii,wt=Math.ceil(Math.max(Ot,At+et+qt)*ft),ei?(Ce.stableMinimapLayoutInput=oe,Ce.stableFitRemainingWidth=Bt,Ce.stableFitMaxMinimapScale=Ct):(Ce.stableMinimapLayoutInput=null,Ce.stableFitRemainingWidth=0)}}}const Zt=Math.floor(Jt*Rt),Xe=Math.min(Zt,Math.max(0,Math.floor((Bt-ni-2)*Rt/(Pt+Rt)))+e.MINIMAP_GUTTER_WIDTH);let Lt=Math.floor(nt*Xe);const Wt=Lt/nt;Lt=Math.floor(Lt*ii);const ri=Xt?1:2,gt=_t==="left"?0:Ge-Xe-ni;return{renderMinimap:ri,minimapLeft:gt,minimapWidth:Xe,minimapHeightIsEditorHeight:Ht,minimapIsSampling:Ut,minimapScale:Ct,minimapLineHeight:ft,minimapCanvasInnerWidth:Lt,minimapCanvasInnerHeight:wt,minimapCanvasOuterWidth:Wt,minimapCanvasOuterHeight:ti}}static computeLayout(oe,Ce){const Ge=Ce.outerWidth|0,xe=Ce.outerHeight|0,nt=Ce.lineHeight|0,Ne=Ce.lineNumbersDigitCount|0,$t=Ce.typicalHalfwidthCharacterWidth,Dt=Ce.maxDigitWidth,Pt=Ce.pixelRatio,Tt=Ce.viewLineCount,Xt=oe.get(136),Ct=Xt==="inherit"?oe.get(135):Xt,Jt=Ct==="inherit"?oe.get(131):Ct,Yt=oe.get(134),_t=Ce.isDominatedByLongLines,ni=oe.get(57),et=oe.get(68).renderType!==0,Bt=oe.get(69),ei=oe.get(105),dt=oe.get(84),wt=oe.get(73),ti=oe.get(103),Ht=ti.verticalScrollbarSize,Ut=ti.verticalHasArrows,ft=ti.arrowSize,Rt=ti.horizontalScrollbarSize,ii=oe.get(43),Zt=oe.get(110)!=="never";let Xe=oe.get(66);ii&&Zt&&(Xe+=16);let Lt=0;if(et){const yt=Math.max(Ne,Bt);Lt=Math.round(yt*Dt)}let Wt=0;ni&&(Wt=nt*Ce.glyphMarginDecorationLaneCount);let ri=0,gt=ri+Wt,Ot=gt+Lt,At=Ot+Xe;const qt=Ge-Wt-Lt-Xe;let si=!1,zt=!1,Kt=-1;Ct==="inherit"&&_t?(si=!0,zt=!0):Jt==="on"||Jt==="bounded"?zt=!0:Jt==="wordWrapColumn"&&(Kt=Yt);const kt=Q.c({outerWidth:Ge,outerHeight:xe,lineHeight:nt,typicalHalfwidthCharacterWidth:$t,pixelRatio:Pt,scrollBeyondLastLine:ei,paddingTop:dt.top,paddingBottom:dt.bottom,minimap:wt,verticalScrollbarWidth:Ht,viewLineCount:Tt,remainingWidth:qt,isViewportWrapping:zt},Ce.memory||new M);kt.renderMinimap!==0&&kt.minimapLeft===0&&(ri+=kt.minimapWidth,gt+=kt.minimapWidth,Ot+=kt.minimapWidth,At+=kt.minimapWidth);const jt=qt-kt.minimapWidth,Qt=Math.max(1,Math.floor((jt-Ht-2)/$t)),Vt=Ut?ft:0;return zt&&(Kt=Math.max(1,Qt),Jt==="bounded"&&(Kt=Math.min(Kt,Yt))),{width:Ge,height:xe,glyphMarginLeft:ri,glyphMarginWidth:Wt,glyphMarginDecorationLaneCount:Ce.glyphMarginDecorationLaneCount,lineNumbersLeft:gt,lineNumbersWidth:Lt,decorationsLeft:Ot,decorationsWidth:Xe,contentLeft:At,contentWidth:jt,minimap:kt,viewportColumn:Qt,isWordWrapMinified:si,isViewportWrapping:zt,wrappingColumn:Kt,verticalScrollbarWidth:Ht,horizontalScrollbarHeight:Rt,overviewRuler:{top:Vt,width:Ht,height:xe-2*Vt,right:0}}}}e.EditorLayoutInfoComputer=Q;class ae extends C{constructor(){super(138,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[p.localize(47,null),p.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:p.localize(49,null)}})}validate(oe){return f(oe,"simple",["simple","advanced"])}compute(oe,Ce,Ge){return Ce.get(2)===2?"advanced":Ge}}var _;(function(ne){ne.Off="off",ne.OnCode="onCode",ne.On="on"})(_||(e.ShowLightbulbIconMode=_={}));class ge extends C{constructor(){const oe={enabled:_.OnCode};super(65,"lightbulb",oe,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[_.Off,_.OnCode,_.On],default:oe.enabled,enumDescriptions:[p.localize(50,null),p.localize(51,null),p.localize(52,null)],description:p.localize(53,null)}})}validate(oe){return!oe||typeof oe!="object"?this.defaultValue:{enabled:f(oe.enabled,this.defaultValue.enabled,[_.Off,_.OnCode,_.On])}}}class se extends C{constructor(){const oe={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",oe,{"editor.stickyScroll.enabled":{type:"boolean",default:oe.enabled,description:p.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:oe.maxLineCount,minimum:1,maximum:20,description:p.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:oe.defaultModel,description:p.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:oe.scrollWithEditor,description:p.localize(57,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{enabled:m(Ce.enabled,this.defaultValue.enabled),maxLineCount:n.clampedInt(Ce.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:f(Ce.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:m(Ce.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class re extends C{constructor(){const oe={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(140,"inlayHints",oe,{"editor.inlayHints.enabled":{type:"string",default:oe.enabled,description:p.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[p.localize(59,null),p.localize(60,null,L.$j?"Ctrl+Option":"Ctrl+Alt"),p.localize(61,null,L.$j?"Ctrl+Option":"Ctrl+Alt"),p.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:oe.fontSize,markdownDescription:p.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:oe.fontFamily,markdownDescription:p.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:oe.padding,description:p.localize(65,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return typeof Ce.enabled=="boolean"&&(Ce.enabled=Ce.enabled?"on":"off"),{enabled:f(Ce.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:n.clampedInt(Ce.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ce.fontFamily,this.defaultValue.fontFamily),padding:m(Ce.padding,this.defaultValue.padding)}}}class B extends C{constructor(){super(66,"lineDecorationsWidth",10)}validate(oe){return typeof oe=="string"&&/^\d+(\.\d+)?ch$/.test(oe)?-parseFloat(oe.substring(0,oe.length-2)):n.clampedInt(oe,this.defaultValue,0,1e3)}compute(oe,Ce,Ge){return Ge<0?n.clampedInt(-Ge*oe.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ge}}class ie extends c{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,oe=>c.clamp(oe,0,150),{markdownDescription:p.localize(66,null)})}compute(oe,Ce,Ge){return oe.fontInfo.lineHeight}}class ye extends C{constructor(){const oe={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(73,"minimap",oe,{"editor.minimap.enabled":{type:"boolean",default:oe.enabled,description:p.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:oe.autohide,description:p.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[p.localize(69,null),p.localize(70,null),p.localize(71,null)],default:oe.size,description:p.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:oe.side,description:p.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:oe.showSlider,description:p.localize(74,null)},"editor.minimap.scale":{type:"number",default:oe.scale,minimum:1,maximum:3,enum:[1,2,3],description:p.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:oe.renderCharacters,description:p.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:oe.maxColumn,description:p.localize(77,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{enabled:m(Ce.enabled,this.defaultValue.enabled),autohide:m(Ce.autohide,this.defaultValue.autohide),size:f(Ce.size,this.defaultValue.size,["proportional","fill","fit"]),side:f(Ce.side,this.defaultValue.side,["right","left"]),showSlider:f(Ce.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:m(Ce.renderCharacters,this.defaultValue.renderCharacters),scale:n.clampedInt(Ce.scale,1,1,3),maxColumn:n.clampedInt(Ce.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function le(ne){return ne==="ctrlCmd"?L.$j?"metaKey":"ctrlKey":"altKey"}class ue extends C{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(78,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(79,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{top:n.clampedInt(Ce.top,0,0,1e3),bottom:n.clampedInt(Ce.bottom,0,0,1e3)}}}class ce extends C{constructor(){const oe={enabled:!0,cycle:!0};super(86,"parameterHints",oe,{"editor.parameterHints.enabled":{type:"boolean",default:oe.enabled,description:p.localize(80,null)},"editor.parameterHints.cycle":{type:"boolean",default:oe.cycle,description:p.localize(81,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{enabled:m(Ce.enabled,this.defaultValue.enabled),cycle:m(Ce.cycle,this.defaultValue.cycle)}}}class de extends k{constructor(){super(142)}compute(oe,Ce,Ge){return oe.pixelRatio}}class H extends C{constructor(){const oe={other:"on",comments:"off",strings:"off"},Ce=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[p.localize(82,null),p.localize(83,null),p.localize(84,null)]}];super(89,"quickSuggestions",oe,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ce,default:oe.strings,description:p.localize(85,null)},comments:{anyOf:Ce,default:oe.comments,description:p.localize(86,null)},other:{anyOf:Ce,default:oe.other,description:p.localize(87,null)}},default:oe,markdownDescription:p.localize(88,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=oe}validate(oe){if(typeof oe=="boolean"){const Pt=oe?"on":"off";return{comments:Pt,strings:Pt,other:Pt}}if(!oe||typeof oe!="object")return this.defaultValue;const{other:Ce,comments:Ge,strings:xe}=oe,nt=["on","inline","off"];let Ne,$t,Dt;return typeof Ce=="boolean"?Ne=Ce?"on":"off":Ne=f(Ce,this.defaultValue.other,nt),typeof Ge=="boolean"?$t=Ge?"on":"off":$t=f(Ge,this.defaultValue.comments,nt),typeof xe=="boolean"?Dt=xe?"on":"off":Dt=f(xe,this.defaultValue.strings,nt),{other:Ne,comments:$t,strings:Dt}}}var Z;(function(ne){ne[ne.Off=0]="Off",ne[ne.On=1]="On",ne[ne.Relative=2]="Relative",ne[ne.Interval=3]="Interval",ne[ne.Custom=4]="Custom"})(Z||(e.RenderLineNumbersType=Z={}));class he extends C{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[p.localize(89,null),p.localize(90,null),p.localize(91,null),p.localize(92,null)],default:"on",description:p.localize(93,null)})}validate(oe){let Ce=this.defaultValue.renderType,Ge=this.defaultValue.renderFn;return typeof oe<"u"&&(typeof oe=="function"?(Ce=4,Ge=oe):oe==="interval"?Ce=3:oe==="relative"?Ce=2:oe==="on"?Ce=1:Ce=0),{renderType:Ce,renderFn:Ge}}}function be(ne){const oe=ne.get(98);return oe==="editable"?ne.get(91):oe!=="on"}e.filterValidationDecorations=be;class Pe extends C{constructor(){const oe=[],Ce={type:"number",description:p.localize(94,null)};super(102,"rulers",oe,{type:"array",items:{anyOf:[Ce,{type:["object"],properties:{column:Ce,color:{type:"string",description:p.localize(95,null),format:"color-hex"}}}]},default:oe,description:p.localize(96,null)})}validate(oe){if(Array.isArray(oe)){const Ce=[];for(const Ge of oe)if(typeof Ge=="number")Ce.push({column:n.clampedInt(Ge,0,0,1e4),color:null});else if(Ge&&typeof Ge=="object"){const xe=Ge;Ce.push({column:n.clampedInt(xe.column,0,0,1e4),color:xe.color})}return Ce.sort((Ge,xe)=>Ge.column-xe.column),Ce}return this.defaultValue}}class pe extends C{constructor(){super(92,"readOnlyMessage",void 0)}validate(oe){return!oe||typeof oe!="object"?this.defaultValue:oe}}function Ae(ne,oe){if(typeof ne!="string")return oe;switch(ne){case"hidden":return 2;case"visible":return 3;default:return 1}}class Oe extends C{constructor(){const oe={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",oe,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(97,null),p.localize(98,null),p.localize(99,null)],default:"auto",description:p.localize(100,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(101,null),p.localize(102,null),p.localize(103,null)],default:"auto",description:p.localize(104,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:oe.verticalScrollbarSize,description:p.localize(105,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:oe.horizontalScrollbarSize,description:p.localize(106,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:oe.scrollByPage,description:p.localize(107,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:oe.ignoreHorizontalScrollbarInContentHeight,description:p.localize(108,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe,Ge=n.clampedInt(Ce.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),xe=n.clampedInt(Ce.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:n.clampedInt(Ce.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ae(Ce.vertical,this.defaultValue.vertical),horizontal:Ae(Ce.horizontal,this.defaultValue.horizontal),useShadows:m(Ce.useShadows,this.defaultValue.useShadows),verticalHasArrows:m(Ce.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:m(Ce.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:m(Ce.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:m(Ce.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ge,horizontalSliderSize:n.clampedInt(Ce.horizontalSliderSize,Ge,0,1e3),verticalScrollbarSize:xe,verticalSliderSize:n.clampedInt(Ce.verticalSliderSize,xe,0,1e3),scrollByPage:m(Ce.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:m(Ce.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class ze extends C{constructor(){const oe={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",oe,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:oe.nonBasicASCII,description:p.localize(109,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:oe.invisibleCharacters,description:p.localize(110,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:oe.ambiguousCharacters,description:p.localize(111,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:oe.includeComments,description:p.localize(112,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:oe.includeStrings,description:p.localize(113,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:oe.allowedCharacters,description:p.localize(114,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:oe.allowedLocales,description:p.localize(115,null)}})}applyUpdate(oe,Ce){let Ge=!1;Ce.allowedCharacters&&oe&&(j.$On(oe.allowedCharacters,Ce.allowedCharacters)||(oe={...oe,allowedCharacters:Ce.allowedCharacters},Ge=!0)),Ce.allowedLocales&&oe&&(j.$On(oe.allowedLocales,Ce.allowedLocales)||(oe={...oe,allowedLocales:Ce.allowedLocales},Ge=!0));const xe=super.applyUpdate(oe,Ce);return Ge?new v(xe.newValue,!0):xe}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{nonBasicASCII:$e(Ce.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:m(Ce.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:m(Ce.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:$e(Ce.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:$e(Ce.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(oe.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(oe.allowedLocales,this.defaultValue.allowedLocales)}}c(oe,Ce){if(typeof oe!="object"||!oe)return Ce;const Ge={};for(const[xe,nt]of Object.entries(oe))nt===!0&&(Ge[xe]=!0);return Ge}}class q extends C{constructor(){const oe={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",oe,{"editor.inlineSuggest.enabled":{type:"boolean",default:oe.enabled,description:p.localize(116,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:oe.showToolbar,enum:["always","onHover","never"],enumDescriptions:[p.localize(117,null),p.localize(118,null),p.localize(119,null)],description:p.localize(120,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:oe.suppressSuggestions,description:p.localize(121,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:oe.fontFamily,description:p.localize(122,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{enabled:m(Ce.enabled,this.defaultValue.enabled),mode:f(Ce.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:f(Ce.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:m(Ce.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:m(Ce.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(Ce.fontFamily,this.defaultValue.fontFamily)}}}class W extends C{constructor(){const oe={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",oe,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:oe.enabled,description:p.localize(123,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:oe.showToolbar,enum:["always","onHover","never"],enumDescriptions:[p.localize(124,null),p.localize(125,null),p.localize(126,null)],description:p.localize(127,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:oe.fontFamily,description:p.localize(128,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:oe.backgroundColoring,description:p.localize(129,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{enabled:m(Ce.enabled,this.defaultValue.enabled),showToolbar:f(Ce.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:t.string(Ce.fontFamily,this.defaultValue.fontFamily),keepOnBlur:m(Ce.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:m(Ce.backgroundColoring,this.defaultValue.backgroundColoring)}}}class Y extends C{constructor(){const oe={enabled:A.$Gs.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.$Gs.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",oe,{"editor.bracketPairColorization.enabled":{type:"boolean",default:oe.enabled,markdownDescription:p.localize(130,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:oe.independentColorPoolPerBracketType,description:p.localize(131,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{enabled:m(Ce.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:m(Ce.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class J extends C{constructor(){const oe={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",oe,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[p.localize(132,null),p.localize(133,null),p.localize(134,null)],default:oe.bracketPairs,description:p.localize(135,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[p.localize(136,null),p.localize(137,null),p.localize(138,null)],default:oe.bracketPairsHorizontal,description:p.localize(139,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:oe.highlightActiveBracketPair,description:p.localize(140,null)},"editor.guides.indentation":{type:"boolean",default:oe.indentation,description:p.localize(141,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[p.localize(142,null),p.localize(143,null),p.localize(144,null)],default:oe.highlightActiveIndentation,description:p.localize(145,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{bracketPairs:$e(Ce.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:$e(Ce.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:m(Ce.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:m(Ce.indentation,this.defaultValue.indentation),highlightActiveIndentation:$e(Ce.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function $e(ne,oe,Ce){const Ge=Ce.indexOf(ne);return Ge===-1?oe:Ce[Ge]}class ve extends C{constructor(){const oe={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",oe,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[p.localize(146,null),p.localize(147,null)],default:oe.insertMode,description:p.localize(148,null)},"editor.suggest.filterGraceful":{type:"boolean",default:oe.filterGraceful,description:p.localize(149,null)},"editor.suggest.localityBonus":{type:"boolean",default:oe.localityBonus,description:p.localize(150,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:oe.shareSuggestSelections,markdownDescription:p.localize(151,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[p.localize(152,null),p.localize(153,null),p.localize(154,null),p.localize(155,null)],default:oe.selectionMode,markdownDescription:p.localize(156,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:oe.snippetsPreventQuickSuggestions,description:p.localize(157,null)},"editor.suggest.showIcons":{type:"boolean",default:oe.showIcons,description:p.localize(158,null)},"editor.suggest.showStatusBar":{type:"boolean",default:oe.showStatusBar,description:p.localize(159,null)},"editor.suggest.preview":{type:"boolean",default:oe.preview,description:p.localize(160,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:oe.showInlineDetails,description:p.localize(161,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:p.localize(162,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:p.localize(163,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:p.localize(164,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:p.localize(165,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:p.localize(166,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:p.localize(167,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:p.localize(168,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:p.localize(169,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:p.localize(170,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:p.localize(171,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:p.localize(172,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:p.localize(173,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:p.localize(174,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:p.localize(175,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:p.localize(176,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:p.localize(177,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:p.localize(178,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:p.localize(179,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:p.localize(180,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:p.localize(181,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:p.localize(182,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:p.localize(183,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:p.localize(184,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:p.localize(185,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:p.localize(186,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:p.localize(187,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:p.localize(188,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:p.localize(189,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:p.localize(190,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:p.localize(191,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:p.localize(192,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:p.localize(193,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{insertMode:f(Ce.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:m(Ce.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:m(Ce.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:m(Ce.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:m(Ce.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:f(Ce.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:m(Ce.showIcons,this.defaultValue.showIcons),showStatusBar:m(Ce.showStatusBar,this.defaultValue.showStatusBar),preview:m(Ce.preview,this.defaultValue.preview),previewMode:f(Ce.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:m(Ce.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:m(Ce.showMethods,this.defaultValue.showMethods),showFunctions:m(Ce.showFunctions,this.defaultValue.showFunctions),showConstructors:m(Ce.showConstructors,this.defaultValue.showConstructors),showDeprecated:m(Ce.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:m(Ce.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:m(Ce.showFields,this.defaultValue.showFields),showVariables:m(Ce.showVariables,this.defaultValue.showVariables),showClasses:m(Ce.showClasses,this.defaultValue.showClasses),showStructs:m(Ce.showStructs,this.defaultValue.showStructs),showInterfaces:m(Ce.showInterfaces,this.defaultValue.showInterfaces),showModules:m(Ce.showModules,this.defaultValue.showModules),showProperties:m(Ce.showProperties,this.defaultValue.showProperties),showEvents:m(Ce.showEvents,this.defaultValue.showEvents),showOperators:m(Ce.showOperators,this.defaultValue.showOperators),showUnits:m(Ce.showUnits,this.defaultValue.showUnits),showValues:m(Ce.showValues,this.defaultValue.showValues),showConstants:m(Ce.showConstants,this.defaultValue.showConstants),showEnums:m(Ce.showEnums,this.defaultValue.showEnums),showEnumMembers:m(Ce.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:m(Ce.showKeywords,this.defaultValue.showKeywords),showWords:m(Ce.showWords,this.defaultValue.showWords),showColors:m(Ce.showColors,this.defaultValue.showColors),showFiles:m(Ce.showFiles,this.defaultValue.showFiles),showReferences:m(Ce.showReferences,this.defaultValue.showReferences),showFolders:m(Ce.showFolders,this.defaultValue.showFolders),showTypeParameters:m(Ce.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:m(Ce.showSnippets,this.defaultValue.showSnippets),showUsers:m(Ce.showUsers,this.defaultValue.showUsers),showIssues:m(Ce.showIssues,this.defaultValue.showIssues)}}}class Fe extends C{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:p.localize(194,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:p.localize(195,null),default:!0,type:"boolean"}})}validate(oe){return!oe||typeof oe!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:m(oe.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:m(oe.selectSubwords,this.defaultValue.selectSubwords)}}}var He;(function(ne){ne[ne.None=0]="None",ne[ne.Same=1]="Same",ne[ne.Indent=2]="Indent",ne[ne.DeepIndent=3]="DeepIndent"})(He||(e.WrappingIndent=He={}));class Qe extends C{constructor(){super(137,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[p.localize(196,null),p.localize(197,null),p.localize(198,null),p.localize(199,null)],description:p.localize(200,null),default:"same"}})}validate(oe){switch(oe){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(oe,Ce,Ge){return Ce.get(2)===2?0:Ge}}class tt extends k{constructor(){super(145)}compute(oe,Ce,Ge){const xe=Ce.get(144);return{isDominatedByLongLines:oe.isDominatedByLongLines,isWordWrapMinified:xe.isWordWrapMinified,isViewportWrapping:xe.isViewportWrapping,wrappingColumn:xe.wrappingColumn}}}class st extends C{constructor(){const oe={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",oe,{"editor.dropIntoEditor.enabled":{type:"boolean",default:oe.enabled,markdownDescription:p.localize(201,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:p.localize(202,null),enum:["afterDrop","never"],enumDescriptions:[p.localize(203,null),p.localize(204,null)],default:"afterDrop"}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{enabled:m(Ce.enabled,this.defaultValue.enabled),showDropSelector:f(Ce.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class ut extends C{constructor(){const oe={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",oe,{"editor.pasteAs.enabled":{type:"boolean",default:oe.enabled,markdownDescription:p.localize(205,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:p.localize(206,null),enum:["afterPaste","never"],enumDescriptions:[p.localize(207,null),p.localize(208,null)],default:"afterPaste"}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{enabled:m(Ce.enabled,this.defaultValue.enabled),showPasteSelector:f(Ce.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const rt="Consolas, 'Courier New', monospace",Ie="Menlo, Monaco, 'Courier New', monospace",Be="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:L.$j?Ie:L.$k?Be:rt,fontWeight:"normal",fontSize:L.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Le(ne){return e.editorOptionsRegistry[ne.id]=ne,ne}var Ke;(function(ne){ne[ne.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ne[ne.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ne[ne.accessibilitySupport=2]="accessibilitySupport",ne[ne.accessibilityPageSize=3]="accessibilityPageSize",ne[ne.ariaLabel=4]="ariaLabel",ne[ne.ariaRequired=5]="ariaRequired",ne[ne.autoClosingBrackets=6]="autoClosingBrackets",ne[ne.autoClosingComments=7]="autoClosingComments",ne[ne.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ne[ne.autoClosingDelete=9]="autoClosingDelete",ne[ne.autoClosingOvertype=10]="autoClosingOvertype",ne[ne.autoClosingQuotes=11]="autoClosingQuotes",ne[ne.autoIndent=12]="autoIndent",ne[ne.automaticLayout=13]="automaticLayout",ne[ne.autoSurround=14]="autoSurround",ne[ne.bracketPairColorization=15]="bracketPairColorization",ne[ne.guides=16]="guides",ne[ne.codeLens=17]="codeLens",ne[ne.codeLensFontFamily=18]="codeLensFontFamily",ne[ne.codeLensFontSize=19]="codeLensFontSize",ne[ne.colorDecorators=20]="colorDecorators",ne[ne.colorDecoratorsLimit=21]="colorDecoratorsLimit",ne[ne.columnSelection=22]="columnSelection",ne[ne.comments=23]="comments",ne[ne.contextmenu=24]="contextmenu",ne[ne.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ne[ne.cursorBlinking=26]="cursorBlinking",ne[ne.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ne[ne.cursorStyle=28]="cursorStyle",ne[ne.cursorSurroundingLines=29]="cursorSurroundingLines",ne[ne.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ne[ne.cursorWidth=31]="cursorWidth",ne[ne.disableLayerHinting=32]="disableLayerHinting",ne[ne.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ne[ne.domReadOnly=34]="domReadOnly",ne[ne.dragAndDrop=35]="dragAndDrop",ne[ne.dropIntoEditor=36]="dropIntoEditor",ne[ne.emptySelectionClipboard=37]="emptySelectionClipboard",ne[ne.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ne[ne.extraEditorClassName=39]="extraEditorClassName",ne[ne.fastScrollSensitivity=40]="fastScrollSensitivity",ne[ne.find=41]="find",ne[ne.fixedOverflowWidgets=42]="fixedOverflowWidgets",ne[ne.folding=43]="folding",ne[ne.foldingStrategy=44]="foldingStrategy",ne[ne.foldingHighlight=45]="foldingHighlight",ne[ne.foldingImportsByDefault=46]="foldingImportsByDefault",ne[ne.foldingMaximumRegions=47]="foldingMaximumRegions",ne[ne.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ne[ne.fontFamily=49]="fontFamily",ne[ne.fontInfo=50]="fontInfo",ne[ne.fontLigatures=51]="fontLigatures",ne[ne.fontSize=52]="fontSize",ne[ne.fontWeight=53]="fontWeight",ne[ne.fontVariations=54]="fontVariations",ne[ne.formatOnPaste=55]="formatOnPaste",ne[ne.formatOnType=56]="formatOnType",ne[ne.glyphMargin=57]="glyphMargin",ne[ne.gotoLocation=58]="gotoLocation",ne[ne.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ne[ne.hover=60]="hover",ne[ne.inDiffEditor=61]="inDiffEditor",ne[ne.inlineSuggest=62]="inlineSuggest",ne[ne.inlineEdit=63]="inlineEdit",ne[ne.letterSpacing=64]="letterSpacing",ne[ne.lightbulb=65]="lightbulb",ne[ne.lineDecorationsWidth=66]="lineDecorationsWidth",ne[ne.lineHeight=67]="lineHeight",ne[ne.lineNumbers=68]="lineNumbers",ne[ne.lineNumbersMinChars=69]="lineNumbersMinChars",ne[ne.linkedEditing=70]="linkedEditing",ne[ne.links=71]="links",ne[ne.matchBrackets=72]="matchBrackets",ne[ne.minimap=73]="minimap",ne[ne.mouseStyle=74]="mouseStyle",ne[ne.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",ne[ne.mouseWheelZoom=76]="mouseWheelZoom",ne[ne.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",ne[ne.multiCursorModifier=78]="multiCursorModifier",ne[ne.multiCursorPaste=79]="multiCursorPaste",ne[ne.multiCursorLimit=80]="multiCursorLimit",ne[ne.occurrencesHighlight=81]="occurrencesHighlight",ne[ne.overviewRulerBorder=82]="overviewRulerBorder",ne[ne.overviewRulerLanes=83]="overviewRulerLanes",ne[ne.padding=84]="padding",ne[ne.pasteAs=85]="pasteAs",ne[ne.parameterHints=86]="parameterHints",ne[ne.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",ne[ne.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",ne[ne.quickSuggestions=89]="quickSuggestions",ne[ne.quickSuggestionsDelay=90]="quickSuggestionsDelay",ne[ne.readOnly=91]="readOnly",ne[ne.readOnlyMessage=92]="readOnlyMessage",ne[ne.renameOnType=93]="renameOnType",ne[ne.renderControlCharacters=94]="renderControlCharacters",ne[ne.renderFinalNewline=95]="renderFinalNewline",ne[ne.renderLineHighlight=96]="renderLineHighlight",ne[ne.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",ne[ne.renderValidationDecorations=98]="renderValidationDecorations",ne[ne.renderWhitespace=99]="renderWhitespace",ne[ne.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",ne[ne.roundedSelection=101]="roundedSelection",ne[ne.rulers=102]="rulers",ne[ne.scrollbar=103]="scrollbar",ne[ne.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",ne[ne.scrollBeyondLastLine=105]="scrollBeyondLastLine",ne[ne.scrollPredominantAxis=106]="scrollPredominantAxis",ne[ne.selectionClipboard=107]="selectionClipboard",ne[ne.selectionHighlight=108]="selectionHighlight",ne[ne.selectOnLineNumbers=109]="selectOnLineNumbers",ne[ne.showFoldingControls=110]="showFoldingControls",ne[ne.showUnused=111]="showUnused",ne[ne.snippetSuggestions=112]="snippetSuggestions",ne[ne.smartSelect=113]="smartSelect",ne[ne.smoothScrolling=114]="smoothScrolling",ne[ne.stickyScroll=115]="stickyScroll",ne[ne.stickyTabStops=116]="stickyTabStops",ne[ne.stopRenderingLineAfter=117]="stopRenderingLineAfter",ne[ne.suggest=118]="suggest",ne[ne.suggestFontSize=119]="suggestFontSize",ne[ne.suggestLineHeight=120]="suggestLineHeight",ne[ne.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",ne[ne.suggestSelection=122]="suggestSelection",ne[ne.tabCompletion=123]="tabCompletion",ne[ne.tabIndex=124]="tabIndex",ne[ne.unicodeHighlighting=125]="unicodeHighlighting",ne[ne.unusualLineTerminators=126]="unusualLineTerminators",ne[ne.useShadowDOM=127]="useShadowDOM",ne[ne.useTabStops=128]="useTabStops",ne[ne.wordBreak=129]="wordBreak",ne[ne.wordSeparators=130]="wordSeparators",ne[ne.wordWrap=131]="wordWrap",ne[ne.wordWrapBreakAfterCharacters=132]="wordWrapBreakAfterCharacters",ne[ne.wordWrapBreakBeforeCharacters=133]="wordWrapBreakBeforeCharacters",ne[ne.wordWrapColumn=134]="wordWrapColumn",ne[ne.wordWrapOverride1=135]="wordWrapOverride1",ne[ne.wordWrapOverride2=136]="wordWrapOverride2",ne[ne.wrappingIndent=137]="wrappingIndent",ne[ne.wrappingStrategy=138]="wrappingStrategy",ne[ne.showDeprecated=139]="showDeprecated",ne[ne.inlayHints=140]="inlayHints",ne[ne.editorClassName=141]="editorClassName",ne[ne.pixelRatio=142]="pixelRatio",ne[ne.tabFocusMode=143]="tabFocusMode",ne[ne.layoutInfo=144]="layoutInfo",ne[ne.wrappingInfo=145]="wrappingInfo",ne[ne.defaultColorDecorators=146]="defaultColorDecorators",ne[ne.colorDecoratorsActivatedOn=147]="colorDecoratorsActivatedOn",ne[ne.inlineCompletionsAccessibilityVerbose=148]="inlineCompletionsAccessibilityVerbose"})(Ke||(e.EditorOption=Ke={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Le(new o(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:p.localize(209,null)})),acceptSuggestionOnEnter:Le(new h(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",p.localize(210,null),""],markdownDescription:p.localize(211,null)})),accessibilitySupport:Le(new d),accessibilityPageSize:Le(new n(3,"accessibilityPageSize",10,1,1073741824,{description:p.localize(212,null),tags:["accessibility"]})),ariaLabel:Le(new t(4,"ariaLabel",p.localize(213,null))),ariaRequired:Le(new o(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Le(new o(8,"screenReaderAnnounceInlineSuggestion",!0,{description:p.localize(214,null),tags:["accessibility"]})),autoClosingBrackets:Le(new h(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(215,null),p.localize(216,null),""],description:p.localize(217,null)})),autoClosingComments:Le(new h(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(218,null),p.localize(219,null),""],description:p.localize(220,null)})),autoClosingDelete:Le(new h(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",p.localize(221,null),""],description:p.localize(222,null)})),autoClosingOvertype:Le(new h(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",p.localize(223,null),""],description:p.localize(224,null)})),autoClosingQuotes:Le(new h(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(225,null),p.localize(226,null),""],description:p.localize(227,null)})),autoIndent:Le(new r(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],a,{enumDescriptions:[p.localize(228,null),p.localize(229,null),p.localize(230,null),p.localize(231,null),p.localize(232,null)],description:p.localize(233,null)})),automaticLayout:Le(new o(13,"automaticLayout",!1)),autoSurround:Le(new h(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[p.localize(234,null),p.localize(235,null),p.localize(236,null),""],description:p.localize(237,null)})),bracketPairColorization:Le(new Y),bracketPairGuides:Le(new J),stickyTabStops:Le(new o(116,"stickyTabStops",!1,{description:p.localize(238,null)})),codeLens:Le(new o(17,"codeLens",!0,{description:p.localize(239,null)})),codeLensFontFamily:Le(new t(18,"codeLensFontFamily","",{description:p.localize(240,null)})),codeLensFontSize:Le(new n(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:p.localize(241,null)})),colorDecorators:Le(new o(20,"colorDecorators",!0,{description:p.localize(242,null)})),colorDecoratorActivatedOn:Le(new h(147,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[p.localize(243,null),p.localize(244,null),p.localize(245,null)],description:p.localize(246,null)})),colorDecoratorsLimit:Le(new n(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:p.localize(247,null)})),columnSelection:Le(new o(22,"columnSelection",!1,{description:p.localize(248,null)})),comments:Le(new $),contextmenu:Le(new o(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Le(new o(25,"copyWithSyntaxHighlighting",!0,{description:p.localize(249,null)})),cursorBlinking:Le(new r(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],b,{description:p.localize(250,null)})),cursorSmoothCaretAnimation:Le(new h(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[p.localize(251,null),p.localize(252,null),p.localize(253,null)],description:p.localize(254,null)})),cursorStyle:Le(new r(28,"cursorStyle",g.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:p.localize(255,null)})),cursorSurroundingLines:Le(new n(29,"cursorSurroundingLines",0,0,1073741824,{description:p.localize(256,null)})),cursorSurroundingLinesStyle:Le(new h(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[p.localize(257,null),p.localize(258,null)],markdownDescription:p.localize(259,null)})),cursorWidth:Le(new n(31,"cursorWidth",0,0,1073741824,{markdownDescription:p.localize(260,null)})),disableLayerHinting:Le(new o(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Le(new o(33,"disableMonospaceOptimizations",!1)),domReadOnly:Le(new o(34,"domReadOnly",!1)),dragAndDrop:Le(new o(35,"dragAndDrop",!0,{description:p.localize(261,null)})),emptySelectionClipboard:Le(new U),dropIntoEditor:Le(new st),stickyScroll:Le(new se),experimentalWhitespaceRendering:Le(new h(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[p.localize(262,null),p.localize(263,null),p.localize(264,null)],description:p.localize(265,null)})),extraEditorClassName:Le(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Le(new c(40,"fastScrollSensitivity",5,ne=>ne<=0?5:ne,{markdownDescription:p.localize(266,null)})),find:Le(new z),fixedOverflowWidgets:Le(new o(42,"fixedOverflowWidgets",!1)),folding:Le(new o(43,"folding",!0,{description:p.localize(267,null)})),foldingStrategy:Le(new h(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[p.localize(268,null),p.localize(269,null)],description:p.localize(270,null)})),foldingHighlight:Le(new o(45,"foldingHighlight",!0,{description:p.localize(271,null)})),foldingImportsByDefault:Le(new o(46,"foldingImportsByDefault",!1,{description:p.localize(272,null)})),foldingMaximumRegions:Le(new n(47,"foldingMaximumRegions",5e3,10,65e3,{description:p.localize(273,null)})),unfoldOnClickAfterEndOfLine:Le(new o(48,"unfoldOnClickAfterEndOfLine",!1,{description:p.localize(274,null)})),fontFamily:Le(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:p.localize(275,null)})),fontInfo:Le(new O),fontLigatures2:Le(new F),fontSize:Le(new T),fontWeight:Le(new G),fontVariations:Le(new I),formatOnPaste:Le(new o(55,"formatOnPaste",!1,{description:p.localize(276,null)})),formatOnType:Le(new o(56,"formatOnType",!1,{description:p.localize(277,null)})),glyphMargin:Le(new o(57,"glyphMargin",!0,{description:p.localize(278,null)})),gotoLocation:Le(new te),hideCursorInOverviewRuler:Le(new o(59,"hideCursorInOverviewRuler",!1,{description:p.localize(279,null)})),hover:Le(new x),inDiffEditor:Le(new o(61,"inDiffEditor",!1)),letterSpacing:Le(new c(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ne=>c.clamp(ne,-5,20),{description:p.localize(280,null)})),lightbulb:Le(new ge),lineDecorationsWidth:Le(new B),lineHeight:Le(new ie),lineNumbers:Le(new he),lineNumbersMinChars:Le(new n(69,"lineNumbersMinChars",5,1,300)),linkedEditing:Le(new o(70,"linkedEditing",!1,{description:p.localize(281,null)})),links:Le(new o(71,"links",!0,{description:p.localize(282,null)})),matchBrackets:Le(new h(72,"matchBrackets","always",["always","near","never"],{description:p.localize(283,null)})),minimap:Le(new ye),mouseStyle:Le(new h(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Le(new c(75,"mouseWheelScrollSensitivity",1,ne=>ne===0?1:ne,{markdownDescription:p.localize(284,null)})),mouseWheelZoom:Le(new o(76,"mouseWheelZoom",!1,{markdownDescription:L.$j?p.localize(285,null):p.localize(286,null)})),multiCursorMergeOverlapping:Le(new o(77,"multiCursorMergeOverlapping",!0,{description:p.localize(287,null)})),multiCursorModifier:Le(new r(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],le,{markdownEnumDescriptions:[p.localize(288,null),p.localize(289,null)],markdownDescription:p.localize(290,null)})),multiCursorPaste:Le(new h(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[p.localize(291,null),p.localize(292,null)],markdownDescription:p.localize(293,null)})),multiCursorLimit:Le(new n(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:p.localize(294,null)})),occurrencesHighlight:Le(new h(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[p.localize(295,null),p.localize(296,null),p.localize(297,null)],markdownDescription:p.localize(298,null)})),overviewRulerBorder:Le(new o(82,"overviewRulerBorder",!0,{description:p.localize(299,null)})),overviewRulerLanes:Le(new n(83,"overviewRulerLanes",3,0,3)),padding:Le(new ue),pasteAs:Le(new ut),parameterHints:Le(new ce),peekWidgetDefaultFocus:Le(new h(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[p.localize(300,null),p.localize(301,null)],description:p.localize(302,null)})),definitionLinkOpensInPeek:Le(new o(88,"definitionLinkOpensInPeek",!1,{description:p.localize(303,null)})),quickSuggestions:Le(new H),quickSuggestionsDelay:Le(new n(90,"quickSuggestionsDelay",10,0,1073741824,{description:p.localize(304,null)})),readOnly:Le(new o(91,"readOnly",!1)),readOnlyMessage:Le(new pe),renameOnType:Le(new o(93,"renameOnType",!1,{description:p.localize(305,null),markdownDeprecationMessage:p.localize(306,null)})),renderControlCharacters:Le(new o(94,"renderControlCharacters",!0,{description:p.localize(307,null),restricted:!0})),renderFinalNewline:Le(new h(95,"renderFinalNewline",L.$k?"dimmed":"on",["off","on","dimmed"],{description:p.localize(308,null)})),renderLineHighlight:Le(new h(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",p.localize(309,null)],description:p.localize(310,null)})),renderLineHighlightOnlyWhenFocus:Le(new o(97,"renderLineHighlightOnlyWhenFocus",!1,{description:p.localize(311,null)})),renderValidationDecorations:Le(new h(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Le(new h(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",p.localize(312,null),p.localize(313,null),p.localize(314,null),""],description:p.localize(315,null)})),revealHorizontalRightPadding:Le(new n(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Le(new o(101,"roundedSelection",!0,{description:p.localize(316,null)})),rulers:Le(new Pe),scrollbar:Le(new Oe),scrollBeyondLastColumn:Le(new n(104,"scrollBeyondLastColumn",4,0,1073741824,{description:p.localize(317,null)})),scrollBeyondLastLine:Le(new o(105,"scrollBeyondLastLine",!0,{description:p.localize(318,null)})),scrollPredominantAxis:Le(new o(106,"scrollPredominantAxis",!0,{description:p.localize(319,null)})),selectionClipboard:Le(new o(107,"selectionClipboard",!0,{description:p.localize(320,null),included:L.$k})),selectionHighlight:Le(new o(108,"selectionHighlight",!0,{description:p.localize(321,null)})),selectOnLineNumbers:Le(new o(109,"selectOnLineNumbers",!0)),showFoldingControls:Le(new h(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[p.localize(322,null),p.localize(323,null),p.localize(324,null)],description:p.localize(325,null)})),showUnused:Le(new o(111,"showUnused",!0,{description:p.localize(326,null)})),showDeprecated:Le(new o(139,"showDeprecated",!0,{description:p.localize(327,null)})),inlayHints:Le(new re),snippetSuggestions:Le(new h(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[p.localize(328,null),p.localize(329,null),p.localize(330,null),p.localize(331,null)],description:p.localize(332,null)})),smartSelect:Le(new Fe),smoothScrolling:Le(new o(114,"smoothScrolling",!1,{description:p.localize(333,null)})),stopRenderingLineAfter:Le(new n(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Le(new ve),inlineSuggest:Le(new q),inlineEdit:Le(new W),inlineCompletionsAccessibilityVerbose:Le(new o(148,"inlineCompletionsAccessibilityVerbose",!1,{description:p.localize(334,null)})),suggestFontSize:Le(new n(119,"suggestFontSize",0,0,1e3,{markdownDescription:p.localize(335,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Le(new n(120,"suggestLineHeight",0,0,1e3,{markdownDescription:p.localize(336,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Le(new o(121,"suggestOnTriggerCharacters",!0,{description:p.localize(337,null)})),suggestSelection:Le(new h(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[p.localize(338,null),p.localize(339,null),p.localize(340,null)],description:p.localize(341,null)})),tabCompletion:Le(new h(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[p.localize(342,null),p.localize(343,null),p.localize(344,null)],description:p.localize(345,null)})),tabIndex:Le(new n(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Le(new ze),unusualLineTerminators:Le(new h(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[p.localize(346,null),p.localize(347,null),p.localize(348,null)],description:p.localize(349,null)})),useShadowDOM:Le(new o(127,"useShadowDOM",!0)),useTabStops:Le(new o(128,"useTabStops",!0,{description:p.localize(350,null)})),wordBreak:Le(new h(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[p.localize(351,null),p.localize(352,null)],description:p.localize(353,null)})),wordSeparators:Le(new t(130,"wordSeparators",R.$Hs,{description:p.localize(354,null)})),wordWrap:Le(new h(131,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[p.localize(355,null),p.localize(356,null),p.localize(357,null),p.localize(358,null)],description:p.localize(359,null)})),wordWrapBreakAfterCharacters:Le(new t(132,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Le(new t(133,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Le(new n(134,"wordWrapColumn",80,1,1073741824,{markdownDescription:p.localize(360,null)})),wordWrapOverride1:Le(new h(135,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Le(new h(136,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Le(new N),defaultColorDecorators:Le(new o(146,"defaultColorDecorators",!1,{markdownDescription:p.localize(361,null)})),pixelRatio:Le(new de),tabFocusMode:Le(new o(143,"tabFocusMode",!1,{markdownDescription:p.localize(362,null)})),layoutInfo:Le(new Q),wrappingInfo:Le(new tt),wrappingIndent:Le(new Qe),wrappingStrategy:Le(new ae)}}),define(Se[200],De([9,10]),function(fe,e){return fe.create("vs/editor/common/languages",e)}),define(Se[82],De([1,0,77,2,173,29,183,200]),function(fe,e,l,j,L,A,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$2t=e.$1t=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTag=e.$Zt=e.$Yt=e.SymbolKinds=e.SymbolTag=e.$Xt=e.$Wt=e.SymbolKind=e.$Vt=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$Ut=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$Tt=e.$St=e.$Rt=void 0;class w{constructor(O,T,G){this.offset=O,this.type=T,this.language=G,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$Rt=w;class E{constructor(O,T){this.tokens=O,this.endState=T,this._tokenizationResultBrand=void 0}}e.$St=E;class M{constructor(O,T){this.tokens=O,this.endState=T,this._encodedTokenizationResultBrand=void 0}}e.$Tt=M;var C;(function(I){I[I.Method=0]="Method",I[I.Function=1]="Function",I[I.Constructor=2]="Constructor",I[I.Field=3]="Field",I[I.Variable=4]="Variable",I[I.Class=5]="Class",I[I.Struct=6]="Struct",I[I.Interface=7]="Interface",I[I.Module=8]="Module",I[I.Property=9]="Property",I[I.Event=10]="Event",I[I.Operator=11]="Operator",I[I.Unit=12]="Unit",I[I.Value=13]="Value",I[I.Constant=14]="Constant",I[I.Enum=15]="Enum",I[I.EnumMember=16]="EnumMember",I[I.Keyword=17]="Keyword",I[I.Text=18]="Text",I[I.Color=19]="Color",I[I.File=20]="File",I[I.Reference=21]="Reference",I[I.Customcolor=22]="Customcolor",I[I.Folder=23]="Folder",I[I.TypeParameter=24]="TypeParameter",I[I.User=25]="User",I[I.Issue=26]="Issue",I[I.Snippet=27]="Snippet"})(C||(e.CompletionItemKind=C={}));var v;(function(I){const O=new Map;O.set(0,l.$ok.symbolMethod),O.set(1,l.$ok.symbolFunction),O.set(2,l.$ok.symbolConstructor),O.set(3,l.$ok.symbolField),O.set(4,l.$ok.symbolVariable),O.set(5,l.$ok.symbolClass),O.set(6,l.$ok.symbolStruct),O.set(7,l.$ok.symbolInterface),O.set(8,l.$ok.symbolModule),O.set(9,l.$ok.symbolProperty),O.set(10,l.$ok.symbolEvent),O.set(11,l.$ok.symbolOperator),O.set(12,l.$ok.symbolUnit),O.set(13,l.$ok.symbolValue),O.set(15,l.$ok.symbolEnum),O.set(14,l.$ok.symbolConstant),O.set(15,l.$ok.symbolEnum),O.set(16,l.$ok.symbolEnumMember),O.set(17,l.$ok.symbolKeyword),O.set(27,l.$ok.symbolSnippet),O.set(18,l.$ok.symbolText),O.set(19,l.$ok.symbolColor),O.set(20,l.$ok.symbolFile),O.set(21,l.$ok.symbolReference),O.set(22,l.$ok.symbolCustomColor),O.set(23,l.$ok.symbolFolder),O.set(24,l.$ok.symbolTypeParameter),O.set(25,l.$ok.account),O.set(26,l.$ok.issues);function T(x){let X=O.get(x);return X||(console.info("No codicon found for CompletionItemKind "+x),X=l.$ok.symbolProperty),X}I.toIcon=T;const G=new Map;G.set("method",0),G.set("function",1),G.set("constructor",2),G.set("field",3),G.set("variable",4),G.set("class",5),G.set("struct",6),G.set("interface",7),G.set("module",8),G.set("property",9),G.set("event",10),G.set("operator",11),G.set("unit",12),G.set("value",13),G.set("constant",14),G.set("enum",15),G.set("enum-member",16),G.set("enumMember",16),G.set("keyword",17),G.set("snippet",27),G.set("text",18),G.set("color",19),G.set("file",20),G.set("reference",21),G.set("customcolor",22),G.set("folder",23),G.set("type-parameter",24),G.set("typeParameter",24),G.set("account",25),G.set("issue",26);function te(x,X){let Q=G.get(x);return typeof Q>"u"&&!X&&(Q=9),Q}I.fromString=te})(v||(e.CompletionItemKinds=v={}));var S;(function(I){I[I.Deprecated=1]="Deprecated"})(S||(e.CompletionItemTag=S={}));var k;(function(I){I[I.None=0]="None",I[I.KeepWhitespace=1]="KeepWhitespace",I[I.InsertAsSnippet=4]="InsertAsSnippet"})(k||(e.CompletionItemInsertTextRule=k={}));var u;(function(I){I[I.Invoke=0]="Invoke",I[I.TriggerCharacter=1]="TriggerCharacter",I[I.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(u||(e.CompletionTriggerKind=u={}));var m;(function(I){I[I.Automatic=0]="Automatic",I[I.Explicit=1]="Explicit"})(m||(e.InlineCompletionTriggerKind=m={}));class o{constructor(O,T,G,te){this.range=O,this.text=T,this.completionKind=G,this.isSnippetText=te}equals(O){return A.$9s.lift(this.range).equalsRange(O.range)&&this.text===O.text&&this.completionKind===O.completionKind&&this.isSnippetText===O.isSnippetText}}e.$Ut=o;var i;(function(I){I[I.Invoke=1]="Invoke",I[I.Auto=2]="Auto"})(i||(e.CodeActionTriggerType=i={}));var n;(function(I){I[I.Invoke=1]="Invoke",I[I.TriggerCharacter=2]="TriggerCharacter",I[I.ContentChange=3]="ContentChange"})(n||(e.SignatureHelpTriggerKind=n={}));var s;(function(I){I[I.Text=0]="Text",I[I.Read=1]="Read",I[I.Write=2]="Write"})(s||(e.DocumentHighlightKind=s={}));function c(I){return I&&j.URI.isUri(I.uri)&&A.$9s.isIRange(I.range)&&(A.$9s.isIRange(I.originSelectionRange)||A.$9s.isIRange(I.targetSelectionRange))}e.$Vt=c;var t;(function(I){I[I.File=0]="File",I[I.Module=1]="Module",I[I.Namespace=2]="Namespace",I[I.Package=3]="Package",I[I.Class=4]="Class",I[I.Method=5]="Method",I[I.Property=6]="Property",I[I.Field=7]="Field",I[I.Constructor=8]="Constructor",I[I.Enum=9]="Enum",I[I.Interface=10]="Interface",I[I.Function=11]="Function",I[I.Variable=12]="Variable",I[I.Constant=13]="Constant",I[I.String=14]="String",I[I.Number=15]="Number",I[I.Boolean=16]="Boolean",I[I.Array=17]="Array",I[I.Object=18]="Object",I[I.Key=19]="Key",I[I.Null=20]="Null",I[I.EnumMember=21]="EnumMember",I[I.Struct=22]="Struct",I[I.Event=23]="Event",I[I.Operator=24]="Operator",I[I.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.$Wt={17:(0,p.localize)(0,null),16:(0,p.localize)(1,null),4:(0,p.localize)(2,null),13:(0,p.localize)(3,null),8:(0,p.localize)(4,null),9:(0,p.localize)(5,null),21:(0,p.localize)(6,null),23:(0,p.localize)(7,null),7:(0,p.localize)(8,null),0:(0,p.localize)(9,null),11:(0,p.localize)(10,null),10:(0,p.localize)(11,null),19:(0,p.localize)(12,null),5:(0,p.localize)(13,null),1:(0,p.localize)(14,null),2:(0,p.localize)(15,null),20:(0,p.localize)(16,null),15:(0,p.localize)(17,null),18:(0,p.localize)(18,null),24:(0,p.localize)(19,null),3:(0,p.localize)(20,null),6:(0,p.localize)(21,null),14:(0,p.localize)(22,null),22:(0,p.localize)(23,null),25:(0,p.localize)(24,null),12:(0,p.localize)(25,null)};function f(I,O){return(0,p.localize)(26,null,I,e.$Wt[O])}e.$Xt=f;var h;(function(I){I[I.Deprecated=1]="Deprecated"})(h||(e.SymbolTag=h={}));var r;(function(I){const O=new Map;O.set(0,l.$ok.symbolFile),O.set(1,l.$ok.symbolModule),O.set(2,l.$ok.symbolNamespace),O.set(3,l.$ok.symbolPackage),O.set(4,l.$ok.symbolClass),O.set(5,l.$ok.symbolMethod),O.set(6,l.$ok.symbolProperty),O.set(7,l.$ok.symbolField),O.set(8,l.$ok.symbolConstructor),O.set(9,l.$ok.symbolEnum),O.set(10,l.$ok.symbolInterface),O.set(11,l.$ok.symbolFunction),O.set(12,l.$ok.symbolVariable),O.set(13,l.$ok.symbolConstant),O.set(14,l.$ok.symbolString),O.set(15,l.$ok.symbolNumber),O.set(16,l.$ok.symbolBoolean),O.set(17,l.$ok.symbolArray),O.set(18,l.$ok.symbolObject),O.set(19,l.$ok.symbolKey),O.set(20,l.$ok.symbolNull),O.set(21,l.$ok.symbolEnumMember),O.set(22,l.$ok.symbolStruct),O.set(23,l.$ok.symbolEvent),O.set(24,l.$ok.symbolOperator),O.set(25,l.$ok.symbolTypeParameter);function T(G){let te=O.get(G);return te||(console.info("No codicon found for SymbolKind "+G),te=l.$ok.symbolProperty),te}I.toIcon=T})(r||(e.SymbolKinds=r={}));class a{static asEditOperation(O){return L.$0s.replace(A.$9s.lift(O.range),O.text)}}e.$Yt=a;class d{static{this.Comment=new d("comment")}static{this.Imports=new d("imports")}static{this.Region=new d("region")}static fromValue(O){switch(O){case"comment":return d.Comment;case"imports":return d.Imports;case"region":return d.Region}return new d(O)}constructor(O){this.value=O}}e.$Zt=d;var $;(function(I){I[I.AIGenerated=1]="AIGenerated"})($||(e.NewSymbolNameTag=$={}));var D;(function(I){function O(T){return!T||typeof T!="object"?!1:typeof T.id=="string"&&typeof T.title=="string"}I.is=O})(D||(e.Command=D={}));var b;(function(I){I[I.Collapsed=0]="Collapsed",I[I.Expanded=1]="Expanded"})(b||(e.CommentThreadCollapsibleState=b={}));var g;(function(I){I[I.Unresolved=0]="Unresolved",I[I.Resolved=1]="Resolved"})(g||(e.CommentThreadState=g={}));var y;(function(I){I[I.Editing=0]="Editing",I[I.Preview=1]="Preview"})(y||(e.CommentMode=y={}));var P;(function(I){I[I.Published=0]="Published",I[I.Draft=1]="Draft"})(P||(e.CommentState=P={}));var N;(function(I){I[I.Type=1]="Type",I[I.Parameter=2]="Parameter"})(N||(e.InlayHintKind=N={}));class U{constructor(O){this.b=O,this.a=null}dispose(){this.a&&this.a.then(O=>{O&&O.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$1t=U,e.$2t=new R.$Ht;var z;(function(I){I[I.None=0]="None",I[I.Option=1]="Option",I[I.Default=2]="Default",I[I.Preferred=3]="Preferred"})(z||(e.ExternalUriOpenerPriority=z={}));var F;(function(I){I[I.Invoke=0]="Invoke",I[I.Automatic=1]="Automatic"})(F||(e.InlineEditTriggerKind=F={}))}),define(Se[201],De([9,10]),function(fe,e){return fe.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Se[202],De([9,10]),function(fe,e){return fe.create("vs/platform/contextkey/common/contextkey",e)}),define(Se[203],De([9,10]),function(fe,e){return fe.create("vs/platform/contextkey/common/scanner",e)}),define(Se[204],De([9,10]),function(fe,e){return fe.create("vs/platform/dialogs/common/dialogs",e)}),define(Se[205],De([9,10]),function(fe,e){return fe.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Se[206],De([9,10]),function(fe,e){return fe.create("vs/platform/extensions/common/extensionValidator",e)}),define(Se[207],De([9,10]),function(fe,e){return fe.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Se[208],De([9,10]),function(fe,e){return fe.create("vs/platform/files/common/files",e)}),define(Se[209],De([9,10]),function(fe,e){return fe.create("vs/platform/files/common/io",e)}),define(Se[210],De([9,10]),function(fe,e){return fe.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Se[211],De([9,10]),function(fe,e){return fe.create("vs/platform/markers/common/markers",e)}),define(Se[212],De([9,10]),function(fe,e){return fe.create("vs/platform/theme/common/iconRegistry",e)}),define(Se[213],De([9,10]),function(fe,e){return fe.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Se[214],De([9,10]),function(fe,e){return fe.create("vs/platform/workspace/common/workspace",e)}),define(Se[215],De([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Se[216],De([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Se[217],De([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Se[218],De([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Se[219],De([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(Se[220],De([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostLogService",e)}),define(Se[221],De([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostNotebook",e)}),define(Se[222],De([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Se[223],De([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Se[224],De([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Se[225],De([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Se[226],De([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Se[227],De([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Se[228],De([9,10]),function(fe,e){return fe.create("vs/workbench/api/node/extHostDebugService",e)}),define(Se[229],De([9,10]),function(fe,e){return fe.create("vs/workbench/common/configuration",e)}),define(Se[230],De([9,10]),function(fe,e){return fe.create("vs/workbench/common/editor",e)}),define(Se[231],De([9,10]),function(fe,e){return fe.create("vs/workbench/common/views",e)}),define(Se[232],De([9,10]),function(fe,e){return fe.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Se[233],De([9,10]),function(fe,e){return fe.create("vs/workbench/contrib/debug/common/debug",e)}),define(Se[234],De([9,10]),function(fe,e){return fe.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Se[235],De([9,10]),function(fe,e){return fe.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Se[236],De([9,10]),function(fe,e){return fe.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Se[237],De([9,10]),function(fe,e){return fe.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Se[238],De([9,10]),function(fe,e){return fe.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Se[239],De([9,10]),function(fe,e){return fe.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Se[240],De([9,10]),function(fe,e){return fe.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(Se[241],De([9,10]),function(fe,e){return fe.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Se[242],De([1,0,13,203]),function(fe,e,l,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aj=e.TokenType=void 0;var L;(function(E){E[E.LParen=0]="LParen",E[E.RParen=1]="RParen",E[E.Neg=2]="Neg",E[E.Eq=3]="Eq",E[E.NotEq=4]="NotEq",E[E.Lt=5]="Lt",E[E.LtEq=6]="LtEq",E[E.Gt=7]="Gt",E[E.GtEq=8]="GtEq",E[E.RegexOp=9]="RegexOp",E[E.RegexStr=10]="RegexStr",E[E.True=11]="True",E[E.False=12]="False",E[E.In=13]="In",E[E.Not=14]="Not",E[E.And=15]="And",E[E.Or=16]="Or",E[E.Str=17]="Str",E[E.QuotedStr=18]="QuotedStr",E[E.Error=19]="Error",E[E.EOF=20]="EOF"})(L||(e.TokenType=L={}));function A(...E){switch(E.length){case 1:return(0,j.localize)(0,null,E[0]);case 2:return(0,j.localize)(1,null,E[0],E[1]);case 3:return(0,j.localize)(2,null,E[0],E[1],E[2]);default:return}}const R=(0,j.localize)(3,null),p=(0,j.localize)(4,null);class w{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(M){switch(M.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return M.isTripleEq?"===":"==";case 4:return M.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return M.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return M.lexeme;case 18:return M.lexeme;case 19:return M.lexeme;case 20:return"EOF";default:throw(0,l.$8)(`unhandled token type: ${JSON.stringify(M)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(M=>M.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(M){return this.c=M,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const C=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:C})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const C=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:C})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(M){return this.r()||this.c.charCodeAt(this.e)!==M?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(M){this.f.push({type:M,offset:this.d})}l(M){const C=this.d,v=this.c.substring(this.d,this.e),S={type:19,offset:this.d,lexeme:v};this.g.push({offset:C,lexeme:v,additionalInfo:M}),this.f.push(S)}n(){this.m.lastIndex=this.d;const M=this.m.exec(this.c);if(M){this.e=this.d+M[0].length;const C=this.c.substring(this.d,this.e),v=w.b.get(C);v?this.k(v):this.f.push({type:17,lexeme:C,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let M=this.e,C=!1,v=!1;for(;;){if(M>=this.c.length){this.e=M,this.l(p);return}const k=this.c.charCodeAt(M);if(C)C=!1;else if(k===47&&!v){M++;break}else k===91?v=!0:k===92?C=!0:k===93&&(v=!1);M++}for(;M<this.c.length&&w.a.has(this.c.charCodeAt(M));)M++;this.e=M;const S=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:S,offset:this.d})}r(){return this.e>=this.c.length}}e.$aj=w}),define(Se[243],De([1,0,23,39,206,392]),function(fe,e,l,j,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$up=e.$tp=e.$sp=e.$rp=e.$qp=e.$pp=e.$op=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,p=/^-(\d{4})(\d{2})(\d{2})$/;function w(o){return o=o.trim(),o==="*"||R.test(o)}e.$op=w;function E(o){if(!w(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=o.match(R);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}e.$pp=E;function M(o){if(!o)return null;const i=o.majorBase,n=o.majorMustEqual,s=o.minorBase;let c=o.minorMustEqual;const t=o.patchBase;let f=o.patchMustEqual;o.hasCaret&&(i===0||(c=!1),f=!1);let h=0;if(o.preRelease){const r=p.exec(o.preRelease);if(r){const[,a,d,$]=r;h=Date.UTC(Number(a),Number(d)-1,Number($))}}return{majorBase:i,majorMustEqual:n,minorBase:s,minorMustEqual:c,patchBase:t,patchMustEqual:f,isMinimum:o.hasGreaterEquals,notBefore:h}}e.$qp=M;function C(o,i,n){let s;typeof o=="string"?s=M(E(o)):s=o;let c;i instanceof Date?c=i.getTime():typeof i=="string"&&(c=new Date(i).getTime());let t;if(typeof n=="string"?t=M(E(n)):t=n,!s||!t)return!1;const f=s.majorBase,h=s.minorBase,r=s.patchBase;let a=t.majorBase,d=t.minorBase,$=t.patchBase;const D=t.notBefore;let b=t.majorMustEqual,g=t.minorMustEqual,y=t.patchMustEqual;return t.isMinimum?f>a?!0:f<a?!1:h>d?!0:h<d||c&&c<D?!1:r>=$:(f===1&&a===0&&(!b||!g||!y)&&(a=1,d=0,$=0,b=!0,g=!1,y=!1),f<a?!1:f>a?!b:h<d?!1:h>d?!g:r<$?!1:r>$?!y:!(c&&c<D))}e.$rp=C;function v(o,i,n,s,c){const t=[];if(typeof s.publisher<"u"&&typeof s.publisher!="string")return t.push([j.default.Error,L.localize(0,null)]),t;if(typeof s.name!="string")return t.push([j.default.Error,L.localize(1,null,"name")]),t;if(typeof s.version!="string")return t.push([j.default.Error,L.localize(2,null,"version")]),t;if(!s.engines)return t.push([j.default.Error,L.localize(3,null,"engines")]),t;if(typeof s.engines.vscode!="string")return t.push([j.default.Error,L.localize(4,null,"engines.vscode")]),t;if(typeof s.extensionDependencies<"u"&&!m(s.extensionDependencies))return t.push([j.default.Error,L.localize(5,null,"extensionDependencies")]),t;if(typeof s.activationEvents<"u"){if(!m(s.activationEvents))return t.push([j.default.Error,L.localize(6,null,"activationEvents")]),t;if(typeof s.main>"u"&&typeof s.browser>"u")return t.push([j.default.Error,L.localize(7,null,"activationEvents","main","browser")]),t}if(typeof s.extensionKind<"u"&&typeof s.main>"u"&&t.push([j.default.Warning,L.localize(8,null,"extensionKind")]),typeof s.main<"u"){if(typeof s.main!="string")return t.push([j.default.Error,L.localize(9,null,"main")]),t;{const r=(0,l.$Sg)(n,s.main);(0,l.$Mg)(r,n)||t.push([j.default.Warning,L.localize(10,null,r.path,n.path)])}}if(typeof s.browser<"u"){if(typeof s.browser!="string")return t.push([j.default.Error,L.localize(11,null,"browser")]),t;{const r=(0,l.$Sg)(n,s.browser);(0,l.$Mg)(r,n)||t.push([j.default.Warning,L.localize(12,null,r.path,n.path)])}}if(!A.valid(s.version))return t.push([j.default.Error,L.localize(13,null)]),t;const f=[];if(!S(o,i,s,c,f))for(const r of f)t.push([j.default.Error,r]);return t}e.$sp=v;function S(o,i,n,s,c){return s||typeof n.main>"u"&&typeof n.browser>"u"?!0:u(o,i,n.engines.vscode,c)}e.$tp=S;function k(o,i,n){return o==="*"||u(i,n,o)}e.$up=k;function u(o,i,n,s=[]){const c=M(E(n));if(!c)return s.push(L.localize(14,null,n)),!1;if(c.majorBase===0){if(!c.majorMustEqual||!c.minorMustEqual)return s.push(L.localize(15,null,n)),!1}else if(!c.majorMustEqual)return s.push(L.localize(16,null,n)),!1;return C(o,i,c)?!0:(s.push(L.localize(17,null,o,n)),!1)}function m(o){if(!Array.isArray(o))return!1;for(let i=0,n=o.length;i<n;i++)if(typeof o[i]!="string")return!1;return!0}}),define(Se[106],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ci=void 0;class l{constructor(L,A=[],R=!1){this.ctor=L,this.staticArguments=A,this.supportsDelayedInstantiation=R}}e.$ci=l}),define(Se[83],De([1,0,106]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bs=e.$as=e.InstantiationType=void 0;const j=[];var L;(function(p){p[p.Eager=0]="Eager",p[p.Delayed=1]="Delayed"})(L||(e.InstantiationType=L={}));function A(p,w,E){w instanceof l.$ci||(w=new l.$ci(w,[],!!E)),j.push([p,w])}e.$as=A;function R(){return j}e.$bs=R}),define(Se[244],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=e.$Qq=void 0;class l{constructor(A,R){this.key=A,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$Qq=l;class j{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const R of this.a.values())R.outgoing.size===0&&A.push(R);return A}insertEdge(A,R){const p=this.lookupOrInsertNode(A),w=this.lookupOrInsertNode(R);p.outgoing.set(w.key,w),w.incoming.set(p.key,p)}removeNode(A){const R=this.b(A);this.a.delete(R);for(const p of this.a.values())p.outgoing.delete(R),p.incoming.delete(R)}lookupOrInsertNode(A){const R=this.b(A);let p=this.a.get(R);return p||(p=new l(R,A),this.a.set(R,p)),p}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[R,p]of this.a)A.push(`${R}
	(-> incoming)[${[...p.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...p.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,R]of this.a){const p=new Set([A]),w=this.c(R,p);if(w)return w}}c(A,R){for(const[p,w]of A.outgoing){if(R.has(p))return[...R,p].join(" -> ");R.add(p);const E=this.c(w,R);if(E)return E;R.delete(p)}}}e.$Rq=j}),define(Se[5],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gi=e.$fi=e.$ei=e._util=void 0;var l;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function p(w){return w[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=p})(l||(e._util=l={})),e.$ei=L("instantiationService");function j(R,p,w){p[l.DI_TARGET]===p?p[l.DI_DEPENDENCIES].push({id:R,index:w}):(p[l.DI_DEPENDENCIES]=[{id:R,index:w}],p[l.DI_TARGET]=p)}function L(R){if(l.serviceIds.has(R))return l.serviceIds.get(R);const p=function(w,E,M){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");j(p,w,M)};return p.toString=()=>R,l.serviceIds.set(R,p),p}e.$fi=L;function A(R){return R}e.$gi=A}),define(Se[52],De([1,0,18,2,5]),function(fe,e,l,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.ConfigurationTarget=e.$Ni=e.$Mi=e.$Li=void 0,e.$Li=(0,L.$fi)("configurationService");function A(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof j.URI)}e.$Mi=A;function R(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof j.URI)}e.$Ni=R;var p;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(p||(e.ConfigurationTarget=p={}));function w(o){switch(o){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Oi=w;function E(o){return o.applicationValue!==void 0||o.userValue!==void 0||o.userLocalValue!==void 0||o.userRemoteValue!==void 0||o.workspaceValue!==void 0||o.workspaceFolderValue!==void 0}e.$Pi=E;function M(o,i){const n=Object.create(null);for(const s in o)C(n,s,o[s],i);return n}e.$Qi=M;function C(o,i,n,s){const c=i.split("."),t=c.pop();let f=o;for(let h=0;h<c.length;h++){const r=c[h];let a=f[r];switch(typeof a){case"undefined":a=f[r]=Object.create(null);break;case"object":break;default:s(`Ignoring ${i} as ${c.slice(0,h+1).join(".")} is ${JSON.stringify(a)}`);return}f=a}if(typeof f=="object"&&f!==null)try{f[t]=n}catch{s(`Ignoring ${i} as ${c.join(".")} is ${JSON.stringify(f)}`)}else s(`Ignoring ${i} as ${c.join(".")} is ${JSON.stringify(f)}`)}e.$Ri=C;function v(o,i){const n=i.split(".");S(o,n)}e.$Si=v;function S(o,i){const n=i.shift();if(i.length===0){delete o[n];return}if(Object.keys(o).indexOf(n)!==-1){const s=o[n];typeof s=="object"&&!Array.isArray(s)&&(S(s,i),Object.keys(s).length===0&&delete o[n])}}function k(o,i,n){function s(f,h){let r=f;for(const a of h){if(typeof r!="object"||r===null)return;r=r[a]}return r}const c=i.split("."),t=s(o,c);return typeof t>"u"?n:t}e.$Ti=k;function u(o,i,n){Object.keys(i).forEach(s=>{s!=="__proto__"&&(s in o?l.$Uf(o[s])&&l.$Uf(i[s])?u(o[s],i[s],n):n&&(o[s]=i[s]):o[s]=i[s])})}e.$Ui=u;function m(o){return o.replace(/[\[\]]/g,"")}e.$Vi=m}),define(Se[45],De([1,0,11,14,242,5,202,13]),function(fe,e,l,j,L,A,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.ContextKeyExprType=e.$bj=void 0;const w=new Map;w.set("false",!1),w.set("true",!0),w.set("isMac",l.$j),w.set("isLinux",l.$k),w.set("isWindows",l.$i),w.set("isWeb",l.$o),w.set("isMacNative",l.$j&&!l.$o),w.set("isEdge",l.$H),w.set("isFirefox",l.$F),w.set("isChrome",l.$E),w.set("isSafari",l.$G);function E(re,B){if(w.get(re)!==void 0)throw(0,p.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");w.set(re,B)}e.$bj=E;const M=Object.prototype.hasOwnProperty;var C;(function(re){re[re.False=0]="False",re[re.True=1]="True",re[re.Defined=2]="Defined",re[re.Not=3]="Not",re[re.Equals=4]="Equals",re[re.NotEquals=5]="NotEquals",re[re.And=6]="And",re[re.Regex=7]="Regex",re[re.NotRegex=8]="NotRegex",re[re.Or=9]="Or",re[re.In=10]="In",re[re.NotIn=11]="NotIn",re[re.Greater=12]="Greater",re[re.GreaterEquals=13]="GreaterEquals",re[re.Smaller=14]="Smaller",re[re.SmallerEquals=15]="SmallerEquals"})(C||(e.ContextKeyExprType=C={}));const v={regexParsingWithErrorRecovery:!0},S=(0,R.localize)(0,null),k=(0,R.localize)(1,null),u=(0,R.localize)(2,null),m=(0,R.localize)(3,null),o=(0,R.localize)(4,null),i=(0,R.localize)(5,null),n=(0,R.localize)(6,null),s=(0,R.localize)(7,null);class c{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(B=v){this.k=B,this.d=new L.$aj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(B){if(B===""){this.h.push({message:S,offset:0,lexeme:"",additionalInfo:k});return}this.f=this.d.reset(B).scan(),this.g=0,this.h=[];try{const ie=this.l();if(!this.E()){const ye=this.D(),le=ye.type===17?i:void 0;throw this.h.push({message:o,offset:ye.offset,lexeme:L.$aj.getLexeme(ye),additionalInfo:le}),c.c}return ie}catch(ie){if(ie!==c.c)throw ie;return}}l(){return this.m()}m(){const B=[this.o()];for(;this.y(16);){const ie=this.o();B.push(ie)}return B.length===1?B[0]:t.or(...B)}o(){const B=[this.s()];for(;this.y(15);){const ie=this.s();B.push(ie)}return B.length===1?B[0]:t.and(...B)}s(){if(this.y(2)){const B=this.D();switch(B.type){case 11:return this.z(),a.INSTANCE;case 12:return this.z(),d.INSTANCE;case 0:{this.z();const ie=this.l();return this.A(1,m),ie?.negate()}case 17:return this.z(),P.create(B.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",B)}}return this.t()}t(){const B=this.D();switch(B.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const ie=this.l();return this.A(1,m),ie}case 17:{const ie=B.lexeme;if(this.z(),this.y(9)){const le=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),le.type!==10)throw this.B("REGEX",le);const ue=le.lexeme,ce=ue.lastIndexOf("/"),de=ce===ue.length-1?void 0:this.w(ue.substring(ce+1));let H;try{H=new RegExp(ue.substring(1,ce),de)}catch{throw this.B("REGEX",le)}return O.create(ie,H)}switch(le.type){case 10:case 19:{const ue=[le.lexeme];this.z();let ce=this.D(),de=0;for(let Pe=0;Pe<le.lexeme.length;Pe++)le.lexeme.charCodeAt(Pe)===40?de++:le.lexeme.charCodeAt(Pe)===41&&de--;for(;!this.E()&&ce.type!==15&&ce.type!==16;){switch(ce.type){case 0:de++;break;case 1:de--;break;case 10:case 18:for(let Pe=0;Pe<ce.lexeme.length;Pe++)ce.lexeme.charCodeAt(Pe)===40?de++:le.lexeme.charCodeAt(Pe)===41&&de--}if(de<0)break;ue.push(L.$aj.getLexeme(ce)),this.z(),ce=this.D()}const H=ue.join(""),Z=H.lastIndexOf("/"),he=Z===H.length-1?void 0:this.w(H.substring(Z+1));let be;try{be=new RegExp(H.substring(1,Z),he)}catch{throw this.B("REGEX",le)}return t.regex(ie,be)}case 18:{const ue=le.lexeme;this.z();let ce=null;if(!(0,j.$Se)(ue)){const de=ue.indexOf("/"),H=ue.lastIndexOf("/");if(de!==H&&de>=0){const Z=ue.slice(de+1,H),he=ue[H+1]==="i"?"i":"";try{ce=new RegExp(Z,he)}catch{throw this.B("REGEX",le)}}}if(ce===null)throw this.B("REGEX",le);return O.create(ie,ce)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,u);const le=this.u();return t.notIn(ie,le)}switch(this.D().type){case 3:{this.z();const le=this.u();if(this.x().type===18)return t.equals(ie,le);switch(le){case"true":return t.has(ie);case"false":return t.not(ie);default:return t.equals(ie,le)}}case 4:{this.z();const le=this.u();if(this.x().type===18)return t.notEquals(ie,le);switch(le){case"true":return t.not(ie);case"false":return t.has(ie);default:return t.notEquals(ie,le)}}case 5:return this.z(),F.create(ie,this.u());case 6:return this.z(),I.create(ie,this.u());case 7:return this.z(),U.create(ie,this.u());case 8:return this.z(),z.create(ie,this.u());case 13:return this.z(),t.in(ie,this.u());default:return t.has(ie)}}case 20:throw this.h.push({message:n,offset:B.offset,lexeme:"",additionalInfo:s}),c.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const B=this.D();switch(B.type){case 17:case 18:return this.z(),B.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(B){return B.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(B){return this.C(B)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(B,ie){if(this.C(B))return this.z();throw this.B(ie,this.D())}B(B,ie,ye){const le=(0,R.localize)(8,null,B,L.$aj.getLexeme(ie)),ue=ie.offset,ce=L.$aj.getLexeme(ie);return this.h.push({message:le,offset:ue,lexeme:ce,additionalInfo:ye}),c.c}C(B){return this.D().type===B}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$cj=c;class t{static false(){return a.INSTANCE}static true(){return d.INSTANCE}static has(B){return $.create(B)}static equals(B,ie){return D.create(B,ie)}static notEquals(B,ie){return y.create(B,ie)}static regex(B,ie){return O.create(B,ie)}static in(B,ie){return b.create(B,ie)}static notIn(B,ie){return g.create(B,ie)}static not(B){return P.create(B)}static and(...B){return te.create(B,null,!0)}static or(...B){return x.create(B,null,!0)}static greater(B,ie){return U.create(B,ie)}static greaterEquals(B,ie){return z.create(B,ie)}static smaller(B,ie){return F.create(B,ie)}static smallerEquals(B,ie){return I.create(B,ie)}static{this.c=new c({regexParsingWithErrorRecovery:!1})}static deserialize(B){return B==null?void 0:this.c.parse(B)}}e.$dj=t;function f(re){const B=new c({regexParsingWithErrorRecovery:!1});return re.map(ie=>(B.parse(ie),B.lexingErrors.length>0?B.lexingErrors.map(ye=>({errorMessage:ye.additionalInfo?(0,R.localize)(9,null,ye.additionalInfo):(0,R.localize)(10,null),offset:ye.offset,length:ye.lexeme.length})):B.parsingErrors.length>0?B.parsingErrors.map(ye=>({errorMessage:ye.additionalInfo?`${ye.message}. ${ye.additionalInfo}`:ye.message,offset:ye.offset,length:ye.lexeme.length})):[]))}e.$ej=f;function h(re,B){const ie=re?re.substituteConstants():void 0,ye=B?B.substituteConstants():void 0;return!ie&&!ye?!0:!ie||!ye?!1:ie.equals(ye)}e.$fj=h;function r(re,B){return re.cmp(B)}class a{static{this.INSTANCE=new a}constructor(){this.type=0}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!1}serialize(){return"false"}keys(){return[]}map(B){return this}negate(){return d.INSTANCE}}e.$gj=a;class d{static{this.INSTANCE=new d}constructor(){this.type=1}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!0}serialize(){return"true"}keys(){return[]}map(B){return this}negate(){return a.INSTANCE}}e.$hj=d;class ${static create(B,ie=null){const ye=w.get(B);return typeof ye=="boolean"?ye?d.INSTANCE:a.INSTANCE:new $(B,ie)}constructor(B,ie){this.key=B,this.c=ie,this.type=2}cmp(B){return B.type!==this.type?this.type-B.type:Q(this.key,B.key)}equals(B){return B.type===this.type?this.key===B.key:!1}substituteConstants(){const B=w.get(this.key);return typeof B=="boolean"?B?d.INSTANCE:a.INSTANCE:this}evaluate(B){return!!B.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(B){return B.mapDefined(this.key)}negate(){return this.c||(this.c=P.create(this.key,this)),this.c}}e.$ij=$;class D{static create(B,ie,ye=null){if(typeof ie=="boolean")return ie?$.create(B,ye):P.create(B,ye);const le=w.get(B);return typeof le=="boolean"?ie===(le?"true":"false")?d.INSTANCE:a.INSTANCE:new D(B,ie,ye)}constructor(B,ie,ye){this.c=B,this.d=ie,this.f=ye,this.type=4}cmp(B){return B.type!==this.type?this.type-B.type:ae(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=w.get(this.c);if(typeof B=="boolean"){const ie=B?"true":"false";return this.d===ie?d.INSTANCE:a.INSTANCE}return this}evaluate(B){return B.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(B){return B.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$jj=D;class b{static create(B,ie){return new b(B,ie)}constructor(B,ie){this.d=B,this.f=ie,this.type=10,this.c=null}cmp(B){return B.type!==this.type?this.type-B.type:ae(this.d,this.f,B.d,B.f)}equals(B){return B.type===this.type?this.d===B.d&&this.f===B.f:!1}substituteConstants(){return this}evaluate(B){const ie=B.getValue(this.f),ye=B.getValue(this.d);return Array.isArray(ie)?ie.includes(ye):typeof ye=="string"&&typeof ie=="object"&&ie!==null?M.call(ie,ye):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(B){return B.mapIn(this.d,this.f)}negate(){return this.c||(this.c=g.create(this.d,this.f)),this.c}}e.$kj=b;class g{static create(B,ie){return new g(B,ie)}constructor(B,ie){this.d=B,this.f=ie,this.type=11,this.c=b.create(B,ie)}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(B){return B.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$lj=g;class y{static create(B,ie,ye=null){if(typeof ie=="boolean")return ie?P.create(B,ye):$.create(B,ye);const le=w.get(B);return typeof le=="boolean"?ie===(le?"true":"false")?a.INSTANCE:d.INSTANCE:new y(B,ie,ye)}constructor(B,ie,ye){this.c=B,this.d=ie,this.f=ye,this.type=5}cmp(B){return B.type!==this.type?this.type-B.type:ae(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=w.get(this.c);if(typeof B=="boolean"){const ie=B?"true":"false";return this.d===ie?a.INSTANCE:d.INSTANCE}return this}evaluate(B){return B.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(B){return B.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$mj=y;class P{static create(B,ie=null){const ye=w.get(B);return typeof ye=="boolean"?ye?a.INSTANCE:d.INSTANCE:new P(B,ie)}constructor(B,ie){this.c=B,this.d=ie,this.type=3}cmp(B){return B.type!==this.type?this.type-B.type:Q(this.c,B.c)}equals(B){return B.type===this.type?this.c===B.c:!1}substituteConstants(){const B=w.get(this.c);return typeof B=="boolean"?B?a.INSTANCE:d.INSTANCE:this}evaluate(B){return!B.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(B){return B.mapNot(this.c)}negate(){return this.d||(this.d=$.create(this.c,this)),this.d}}e.$nj=P;function N(re,B){if(typeof re=="string"){const ie=parseFloat(re);isNaN(ie)||(re=ie)}return typeof re=="string"||typeof re=="number"?B(re):a.INSTANCE}class U{static create(B,ie,ye=null){return N(ie,le=>new U(B,le,ye))}constructor(B,ie,ye){this.c=B,this.d=ie,this.f=ye,this.type=12}cmp(B){return B.type!==this.type?this.type-B.type:ae(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$oj=U;class z{static create(B,ie,ye=null){return N(ie,le=>new z(B,le,ye))}constructor(B,ie,ye){this.c=B,this.d=ie,this.f=ye,this.type=13}cmp(B){return B.type!==this.type?this.type-B.type:ae(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$pj=z;class F{static create(B,ie,ye=null){return N(ie,le=>new F(B,le,ye))}constructor(B,ie,ye){this.c=B,this.d=ie,this.f=ye,this.type=14}cmp(B){return B.type!==this.type?this.type-B.type:ae(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$qj=F;class I{static create(B,ie,ye=null){return N(ie,le=>new I(B,le,ye))}constructor(B,ie,ye){this.c=B,this.d=ie,this.f=ye,this.type=15}cmp(B){return B.type!==this.type?this.type-B.type:ae(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$rj=I;class O{static create(B,ie){return new O(B,ie)}constructor(B,ie){this.d=B,this.f=ie,this.type=7,this.c=null}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.d<B.d)return-1;if(this.d>B.d)return 1;const ie=this.f?this.f.source:"",ye=B.f?B.f.source:"";return ie<ye?-1:ie>ye?1:0}equals(B){if(B.type===this.type){const ie=this.f?this.f.source:"",ye=B.f?B.f.source:"";return this.d===B.d&&ie===ye}return!1}substituteConstants(){return this}evaluate(B){const ie=B.getValue(this.d);return this.f?this.f.test(ie):!1}serialize(){const B=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${B}`}keys(){return[this.d]}map(B){return B.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=T.create(this)),this.c}}e.$sj=O;class T{static create(B){return new T(B)}constructor(B){this.c=B,this.type=8}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(B){return new T(this.c.map(B))}negate(){return this.c}}e.$tj=T;function G(re){let B=null;for(let ie=0,ye=re.length;ie<ye;ie++){const le=re[ie].substituteConstants();if(re[ie]!==le&&B===null){B=[];for(let ue=0;ue<ie;ue++)B[ue]=re[ue]}B!==null&&(B[ie]=le)}return B===null?re:B}class te{static create(B,ie,ye){return te.d(B,ie,ye)}constructor(B,ie){this.expr=B,this.c=ie,this.type=6}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let ie=0,ye=this.expr.length;ie<ye;ie++){const le=r(this.expr[ie],B.expr[ie]);if(le!==0)return le}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let ie=0,ye=this.expr.length;ie<ye;ie++)if(!this.expr[ie].equals(B.expr[ie]))return!1;return!0}return!1}substituteConstants(){const B=G(this.expr);return B===this.expr?this:te.create(B,this.c,!1)}evaluate(B){for(let ie=0,ye=this.expr.length;ie<ye;ie++)if(!this.expr[ie].evaluate(B))return!1;return!0}static d(B,ie,ye){const le=[];let ue=!1;for(const ce of B)if(ce){if(ce.type===1){ue=!0;continue}if(ce.type===0)return a.INSTANCE;if(ce.type===6){le.push(...ce.expr);continue}le.push(ce)}if(le.length===0&&ue)return d.INSTANCE;if(le.length!==0){if(le.length===1)return le[0];le.sort(r);for(let ce=1;ce<le.length;ce++)le[ce-1].equals(le[ce])&&(le.splice(ce,1),ce--);if(le.length===1)return le[0];for(;le.length>1;){const ce=le[le.length-1];if(ce.type!==9)break;le.pop();const de=le.pop(),H=le.length===0,Z=x.create(ce.expr.map(he=>te.create([he,de],null,ye)),null,H);Z&&(le.push(Z),le.sort(r))}if(le.length===1)return le[0];if(ye){for(let ce=0;ce<le.length;ce++)for(let de=ce+1;de<le.length;de++)if(le[ce].negate().equals(le[de]))return a.INSTANCE;if(le.length===1)return le[0]}return new te(le,ie)}}serialize(){return this.expr.map(B=>B.serialize()).join(" && ")}keys(){const B=[];for(const ie of this.expr)B.push(...ie.keys());return B}map(B){return new te(this.expr.map(ie=>ie.map(B)),null)}negate(){if(!this.c){const B=[];for(const ie of this.expr)B.push(ie.negate());this.c=x.create(B,this,!0)}return this.c}}e.$uj=te;class x{static create(B,ie,ye){return x.d(B,ie,ye)}constructor(B,ie){this.expr=B,this.c=ie,this.type=9}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let ie=0,ye=this.expr.length;ie<ye;ie++){const le=r(this.expr[ie],B.expr[ie]);if(le!==0)return le}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let ie=0,ye=this.expr.length;ie<ye;ie++)if(!this.expr[ie].equals(B.expr[ie]))return!1;return!0}return!1}substituteConstants(){const B=G(this.expr);return B===this.expr?this:x.create(B,this.c,!1)}evaluate(B){for(let ie=0,ye=this.expr.length;ie<ye;ie++)if(this.expr[ie].evaluate(B))return!0;return!1}static d(B,ie,ye){let le=[],ue=!1;if(B){for(let ce=0,de=B.length;ce<de;ce++){const H=B[ce];if(H){if(H.type===0){ue=!0;continue}if(H.type===1)return d.INSTANCE;if(H.type===9){le=le.concat(H.expr);continue}le.push(H)}}if(le.length===0&&ue)return a.INSTANCE;le.sort(r)}if(le.length!==0){if(le.length===1)return le[0];for(let ce=1;ce<le.length;ce++)le[ce-1].equals(le[ce])&&(le.splice(ce,1),ce--);if(le.length===1)return le[0];if(ye){for(let ce=0;ce<le.length;ce++)for(let de=ce+1;de<le.length;de++)if(le[ce].negate().equals(le[de]))return d.INSTANCE;if(le.length===1)return le[0]}return new x(le,ie)}}serialize(){return this.expr.map(B=>B.serialize()).join(" || ")}keys(){const B=[];for(const ie of this.expr)B.push(...ie.keys());return B}map(B){return new x(this.expr.map(ie=>ie.map(B)),null)}negate(){if(!this.c){const B=[];for(const ie of this.expr)B.push(ie.negate());for(;B.length>1;){const ie=B.shift(),ye=B.shift(),le=[];for(const ue of se(ie))for(const ce of se(ye))le.push(te.create([ue,ce],null,!1));B.unshift(x.create(le,null,!1))}this.c=x.create(B,this,!0)}return this.c}}e.$vj=x;class X extends ${static{this.d=[]}static all(){return X.d.values()}constructor(B,ie,ye){super(B,null),this.f=ie,typeof ye=="object"?X.d.push({...ye,key:B}):ye!==!0&&X.d.push({key:B,description:ye,type:ie!=null?typeof ie:void 0})}bindTo(B){return B.createKey(this.key,this.f)}getValue(B){return B.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(B){return D.create(this.key,B)}notEqualsTo(B){return y.create(this.key,B)}}e.$wj=X,e.$xj=(0,A.$fi)("contextKeyService");function Q(re,B){return re<B?-1:re>B?1:0}function ae(re,B,ie,ye){return re<ie?-1:re>ie?1:B<ye?-1:B>ye?1:0}function _(re,B){if(re.type===0||B.type===1)return!0;if(re.type===9)return B.type===9?ge(re.expr,B.expr):!1;if(B.type===9){for(const ie of B.expr)if(_(re,ie))return!0;return!1}if(re.type===6){if(B.type===6)return ge(B.expr,re.expr);for(const ie of re.expr)if(_(ie,B))return!0;return!1}return re.equals(B)}e.$yj=_;function ge(re,B){let ie=0,ye=0;for(;ie<re.length&&ye<B.length;){const le=re[ie].cmp(B[ye]);if(le<0)return!1;le===0&&ie++,ye++}return ie===re.length}function se(re){return re.type===9?re.expr:[re]}}),define(Se[245],De([1,0,23,39,204,5,103,11,24]),function(fe,e,l,j,L,A,R,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mw=e.$lw=e.ConfirmResult=e.$kw=e.$jw=e.$iw=void 0,e.$iw=(0,A.$fi)("dialogService");var E;(function(u){u[u.Confirmation=1]="Confirmation",u[u.Prompt=2]="Prompt",u[u.Input=3]="Input"})(E||(E={}));class M{a(m){return this.d(m,E.Confirmation)}b(m){return this.d(m,E.Prompt)}c(m){return this.d(m,E.Input)}d(m,o){const i=[];switch(o){case E.Confirmation:{const n=m;n.primaryButton?i.push(n.primaryButton):i.push((0,L.localize)(0,null)),n.cancelButton?i.push(n.cancelButton):i.push((0,L.localize)(1,null));break}case E.Prompt:{const n=m;Array.isArray(n.buttons)&&n.buttons.length>0&&i.push(...n.buttons.map(s=>s.label)),n.cancelButton&&(n.cancelButton===!0?i.push((0,L.localize)(2,null)):typeof n.cancelButton=="string"?i.push(n.cancelButton):n.cancelButton.label?i.push(n.cancelButton.label):i.push((0,L.localize)(3,null))),i.length===0&&i.push((0,L.localize)(4,null));break}case E.Input:{const n=m;n.primaryButton?i.push(n.primaryButton):i.push((0,L.localize)(5,null)),n.cancelButton?i.push(n.cancelButton):i.push((0,L.localize)(6,null));break}}return i}e(m){if(typeof m=="string")return m;if(typeof m=="number")return m===j.default.Info?"info":m===j.default.Error?"error":m===j.default.Warning?"warning":"none"}f(m,o,i){const n=[...m.buttons??[]];m.cancelButton&&typeof m.cancelButton!="string"&&typeof m.cancelButton!="boolean"&&n.push(m.cancelButton);let s=n[o]?.run({checkboxChecked:i});return s instanceof Promise||(s=Promise.resolve(s)),{result:s,checkboxChecked:i}}}e.$jw=M,e.$kw=(0,A.$fi)("fileDialogService");var C;(function(u){u[u.SAVE=0]="SAVE",u[u.DONT_SAVE=1]="DONT_SAVE",u[u.CANCEL=2]="CANCEL"})(C||(e.ConfirmResult=C={}));const v=10;function S(u){const m=[];return m.push(...u.slice(0,v).map(o=>typeof o=="string"?o:(0,l.$Pg)(o))),u.length>v&&(u.length-v===1?m.push((0,L.localize)(7,null)):m.push((0,L.localize)(8,null,u.length-v))),m.push(""),m.join(`
`)}e.$lw=S;function k(u,m){const o=(0,w.$Kn)(u);let i=(o.buttons??[]).map(t=>(0,R.$fw)(t)),n=(u.buttons||[]).map((t,f)=>f),s=0,c=o.cancelId??i.length-1;if(i.length>1){const t=typeof c=="number"?i[c]:void 0;if(p.$k||p.$j){if(typeof t=="string"&&i.length>1&&c!==1){i.splice(c,1),i.splice(1,0,t);const f=n[c];n.splice(c,1),n.splice(1,0,f),c=1}p.$k&&i.length>1&&(i=i.reverse(),n=n.reverse(),s=i.length-1,typeof t=="string"&&(c=s-1))}else if(p.$i&&typeof t=="string"&&i.length>1&&c!==i.length-1){i.splice(c,1),i.push(t);const f=n[c];n.splice(c,1),n.push(f),c=i.length-1}}return o.buttons=i,o.defaultId=s,o.cancelId=c,o.noLink=!0,o.title=o.title||m.nameLong,{options:o,buttonIndeces:n}}e.$mw=k}),define(Se[136],De([1,0,5]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ni=e.$mi=void 0,e.$mi=(0,l.$fi)("environmentService"),e.$ni=(0,l.$gi)(e.$mi)}),define(Se[137],De([1,0,205,5]),function(fe,e,l,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.ExtensionGalleryErrorCode=e.$Oo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$No=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=void 0,e.$Bo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Co=new RegExp(e.$Bo),e.$Do="__web_extension",e.$Eo="skipWalkthrough",e.$Fo="extensionsSync",e.$Go="dependecyOrPackExtensionInstall";function L(n){switch(n){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Ho=L;function A(n){switch(n){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Io=A;function R(n,s){switch(n){case 3:return s==="x64"?"win32-x64":s==="arm64"?"win32-arm64":"unknown";case 2:return s==="x64"?"linux-x64":s==="arm64"?"linux-arm64":s==="arm"?"linux-armhf":"unknown";case"alpine":return s==="x64"?"alpine-x64":s==="arm64"?"alpine-arm64":"unknown";case 1:return s==="x64"?"darwin-x64":s==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Jo=R;function p(n,s){return s==="web"&&!n.includes("web")}e.$Ko=p;function w(n,s,c){return p(s,c)?!1:n==="undefined"||n==="universal"?!0:n==="unknown"?!1:n===c}e.$Lo=w;function E(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.$Mo=E;var M;(function(n){n[n.NoneOrRelevance=0]="NoneOrRelevance",n[n.LastUpdatedDate=1]="LastUpdatedDate",n[n.Title=2]="Title",n[n.PublisherName=3]="PublisherName",n[n.InstallCount=4]="InstallCount",n[n.PublishedDate=10]="PublishedDate",n[n.AverageRating=6]="AverageRating",n[n.WeightedRating=12]="WeightedRating"})(M||(e.SortBy=M={}));var C;(function(n){n[n.Default=0]="Default",n[n.Ascending=1]="Ascending",n[n.Descending=2]="Descending"})(C||(e.SortOrder=C={}));var v;(function(n){n.Install="install",n.Uninstall="uninstall"})(v||(e.StatisticType=v={}));var S;(function(n){n[n.None=1]="None",n[n.Install=2]="Install",n[n.Update=3]="Update",n[n.Migrate=4]="Migrate"})(S||(e.InstallOperation=S={})),e.$No=(0,j.$fi)("extensionGalleryService");var k;(function(n){n.Unsupported="Unsupported",n.Deprecated="Deprecated",n.Malicious="Malicious",n.Incompatible="Incompatible",n.IncompatibleTargetPlatform="IncompatibleTargetPlatform",n.ReleaseVersionNotFound="ReleaseVersionNotFound",n.Invalid="Invalid",n.Download="Download",n.DownloadSignature="DownloadSignature",n.UpdateMetadata="UpdateMetadata",n.Extract="Extract",n.Scanning="Scanning",n.Delete="Delete",n.Rename="Rename",n.CorruptZip="CorruptZip",n.IncompleteZip="IncompleteZip",n.Signature="Signature",n.NotAllowed="NotAllowed",n.Gallery="Gallery",n.Unknown="Unknown",n.Internal="Internal"})(k||(e.ExtensionManagementErrorCode=k={}));var u;(function(n){n.UnknownError="UnknownError",n.PackageIsInvalidZip="PackageIsInvalidZip",n.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(u||(e.ExtensionSignaturetErrorCode=u={}));class m extends Error{constructor(s,c){super(s),this.code=c,this.name=c}}e.$Oo=m;var o;(function(n){n.Timeout="Timeout",n.Cancelled="Cancelled",n.Failed="Failed"})(o||(e.ExtensionGalleryErrorCode=o={}));class i extends Error{constructor(s,c){super(s),this.code=c,this.name=c}}e.$Po=i,e.$Qo=(0,j.$fi)("extensionManagementService"),e.$Ro="extensionsIdentifiers/disabled",e.$So="extensionsIdentifiers/enabled",e.$To=(0,j.$fi)("IGlobalExtensionEnablementService"),e.$Uo=(0,j.$fi)("IExtensionTipsService"),e.$Vo=(0,l.localize2)(0,"Extensions"),e.$Wo=(0,l.localize2)(1,"Preferences")}),define(Se[246],De([1,0,5]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x4b=e.$w4b=void 0,e.$w4b=(0,l.$fi)("externalTerminal"),e.$x4b="Terminal.app"}),define(Se[247],De([1,0,51,53,15,17,11,102,31,105,207,246]),function(fe,e,l,j,L,A,R,p,w,E,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v_b=e.$u_b=e.$t_b=void 0;const v=M.localize(0,null);class S{async getDefaultTerminalForPlatforms(){return{windows:k.getDefaultTerminalWindows(),linux:await m.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class k extends S{static{this.b="cmd.exe"}openTerminal(c,t){return this.spawnTerminal(l,c,E.$4l(),t)}spawnTerminal(c,t,f,h){const r=t.windowsExec||k.getDefaultTerminalWindows();h&&h[1]===":"&&(h=h[0].toUpperCase()+h.substr(1));const a=A.$nc(r,".exe").toLowerCase();if(a==="cmder")return c.spawn(r,h?[h]:void 0),Promise.resolve(void 0);const d=["/c","start","/wait"];return r.indexOf(" ")>=0&&d.push('""'),d.push(r),a==="wt"&&d.push("-d ."),new Promise(($,D)=>{const b=o(process),g=c.spawn(f,d,{cwd:h,env:b,detached:!0});g.on("error",D),g.on("exit",()=>$())})}async runInTerminal(c,t,f,h,r){const a="windowsExec"in r&&r.windowsExec?r.windowsExec:k.getDefaultTerminalWindows(),d=await k.f();return new Promise(($,D)=>{const b=`"${t} - ${v}"`,g=`"${f.join('" "')}" & pause`,y=Object.assign({},o(process),h);Object.keys(y).filter(F=>y[F]===null).forEach(F=>delete y[F]);const P={cwd:t,env:y,windowsVerbatimArguments:!0};let N,U;A.$nc(a,".exe")==="wt"?(N=a,U=["-d",".",k.b,"/c",g]):d?(N=d,U=["-d",".",a,"/c",g]):(N=k.b,U=["/c","start",b,"/wait",a,"/c",`"${g}"`]),l.spawn(N,U,P).on("error",F=>{D(i(F))}),$(void 0)})}static getDefaultTerminalWindows(){if(!k.d){const c=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");k.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${c?"Sysnative":"System32"}\\cmd.exe`}return k.d}static async f(){try{const c=await E.win32.findExecutable("wt");return await w.Promises.exists(c)?c:void 0}catch{return}}}e.$t_b=k,Ye([j.$Jh],k,"f",null);class u extends S{static{this.b="/usr/bin/osascript"}openTerminal(c,t){return this.spawnTerminal(l,c,t)}runInTerminal(c,t,f,h,r){const a=r.osxExec||C.$x4b;return new Promise((d,$)=>{if(a===C.$x4b||a==="iTerm.app"){const D=a===C.$x4b?"TerminalHelper":"iTermHelper",g=[L.$zg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${D}.scpt`).fsPath,"-t",c||v,"-w",t];for(const N of f)g.push("-a"),g.push(N);if(h){const N=Object.assign({},o(process),h);for(const U in N){const z=N[U];z===null?(g.push("-u"),g.push(U)):(g.push("-e"),g.push(`${U}=${z}`))}}let y="";const P=l.spawn(u.b,g);P.on("error",N=>{$(i(N))}),P.stderr.on("data",N=>{y+=N.toString()}),P.on("exit",N=>{if(N===0)d(void 0);else if(y){const U=y.split(`
`,1);$(new Error(U[0]))}else $(new Error(M.localize(1,null,D,N)))})}else $(new Error(M.localize(2,null,a)))})}spawnTerminal(c,t,f){const h=t.osxExec||C.$x4b;return new Promise((r,a)=>{const d=["-a",h];f&&d.push(f);const $=o(process),D=c.spawn("/usr/bin/open",d,{cwd:f,env:$});D.on("error",a),D.on("exit",()=>r())})}}e.$u_b=u;class m extends S{static{this.b=M.localize(3,null)}openTerminal(c,t){return this.spawnTerminal(l,c,t)}runInTerminal(c,t,f,h,r){const a=r.linuxExec?Promise.resolve(r.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((d,$)=>{const D=[];a.then(b=>{b.indexOf("gnome-terminal")>=0?D.push("-x"):D.push("-e"),D.push("bash"),D.push("-c");const g=`${n(f)}; echo; read -p "${m.b}" -n1;`;D.push(`''${g}''`);const y=Object.assign({},o(process),h);Object.keys(y).filter(z=>y[z]===null).forEach(z=>delete y[z]);const P={cwd:t,env:y};let N="";const U=l.spawn(b,D,P);U.on("error",z=>{$(i(z))}),U.stderr.on("data",z=>{N+=z.toString()}),U.on("exit",z=>{if(z===0)d(void 0);else if(N){const F=N.split(`
`,1);$(new Error(F[0]))}else $(new Error(M.localize(4,null,b,z)))})})})}static async getDefaultTerminalLinuxReady(){if(!m.d)if(!R.$k)m.d=Promise.resolve("xterm");else{const c=await w.Promises.exists("/etc/debian_version");m.d=new Promise(t=>{c?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return m.d}spawnTerminal(c,t,f){const h=t.linuxExec?Promise.resolve(t.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((r,a)=>{h.then(d=>{const $=o(process),D=c.spawn(d,[],{cwd:f,env:$});D.on("error",a),D.on("exit",()=>r())})})}}e.$v_b=m;function o(s){const c={...s.env};return(0,p.$2l)(c),c}function i(s){return"errno"in s&&s.errno==="ENOENT"&&"path"in s&&typeof s.path=="string"?new Error(M.localize(5,null,s.path)):s}function n(s){let c="";for(const t of s)t.indexOf(" ")>=0?c+='"'+t+'"':c+=t,c+=" ";return c}}),define(Se[32],De([1,0,76,17,14,18,2,208,5,11,15,43]),function(fe,e,l,j,L,A,R,p,w,E,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cl=e.$bl=e.$al=e.$_k=e.$$k=e.FileKind=e.$0k=e.$9k=e.$8k=e.$7k=e.$6k=e.$5k=e.$4k=e.FileOperationResult=e.$3k=e.$2k=e.$1k=e.$Zk=e.$Yk=e.FileChangeType=e.$Xk=e.FileOperation=e.$Wk=e.$Vk=e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.FileSystemProviderErrorCode=e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.$Ik=e.FileSystemProviderCapabilities=e.$Hk=e.FilePermission=e.FileType=e.$Gk=e.$Fk=void 0,e.$Fk=(0,w.$fi)("fileService");function v(_){return _.create===!0}e.$Gk=v;var S;(function(_){_[_.Unknown=0]="Unknown",_[_.File=1]="File",_[_.Directory=2]="Directory",_[_.SymbolicLink=64]="SymbolicLink"})(S||(e.FileType=S={}));var k;(function(_){_[_.Readonly=1]="Readonly",_[_.Locked=2]="Locked"})(k||(e.FilePermission=k={}));function u(_){const ge=_;return!!ge&&typeof ge.onDidChange=="function"}e.$Hk=u;var m;(function(_){_[_.None=0]="None",_[_.FileReadWrite=2]="FileReadWrite",_[_.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",_[_.FileReadStream=16]="FileReadStream",_[_.FileFolderCopy=8]="FileFolderCopy",_[_.PathCaseSensitive=1024]="PathCaseSensitive",_[_.Readonly=2048]="Readonly",_[_.Trash=4096]="Trash",_[_.FileWriteUnlock=8192]="FileWriteUnlock",_[_.FileAtomicRead=16384]="FileAtomicRead",_[_.FileAtomicWrite=32768]="FileAtomicWrite",_[_.FileAtomicDelete=65536]="FileAtomicDelete",_[_.FileClone=131072]="FileClone"})(m||(e.FileSystemProviderCapabilities=m={}));function o(_){return!!(_.capabilities&2)}e.$Ik=o;function i(_){return!!(_.capabilities&8)}e.$Jk=i;function n(_){return!!(_.capabilities&131072)}e.$Kk=n;function s(_){return!!(_.capabilities&4)}e.$Lk=s;function c(_){return!!(_.capabilities&16)}e.$Mk=c;function t(_){return o(_)?!!(_.capabilities&16384):!1}e.$Nk=t;function f(_){return o(_)?!!(_.capabilities&32768):!1}e.$Ok=f;function h(_){return!!(_.capabilities&65536)}e.$Pk=h;function r(_){return!!(_.capabilities&2048)}e.$Qk=r;var a;(function(_){_.FileExists="EntryExists",_.FileNotFound="EntryNotFound",_.FileNotADirectory="EntryNotADirectory",_.FileIsADirectory="EntryIsADirectory",_.FileExceedsStorageQuota="EntryExceedsStorageQuota",_.FileTooLarge="EntryTooLarge",_.FileWriteLocked="EntryWriteLocked",_.NoPermissions="NoPermissions",_.Unavailable="Unavailable",_.Unknown="Unknown"})(a||(e.FileSystemProviderErrorCode=a={}));class d extends Error{static create(ge,se){const re=new d(ge.toString(),se);return b(re,se),re}constructor(ge,se){super(ge),this.code=se}}e.$Rk=d;function $(_,ge){return d.create(_,ge)}e.$Sk=$;function D(_){return _||$((0,p.localize)(0,null),a.Unknown)}e.$Tk=D;function b(_,ge){return _.name=ge?`${ge} (FileSystemError)`:"FileSystemError",_}e.$Uk=b;function g(_){if(!_)return a.Unknown;if(_ instanceof d)return _.code;const ge=/^(.+) \(FileSystemError\)$/.exec(_.name);if(!ge)return a.Unknown;switch(ge[1]){case a.FileExists:return a.FileExists;case a.FileIsADirectory:return a.FileIsADirectory;case a.FileNotADirectory:return a.FileNotADirectory;case a.FileNotFound:return a.FileNotFound;case a.FileTooLarge:return a.FileTooLarge;case a.FileWriteLocked:return a.FileWriteLocked;case a.NoPermissions:return a.NoPermissions;case a.Unavailable:return a.Unavailable}return a.Unknown}e.$Vk=g;function y(_){if(_ instanceof I)return _.fileOperationResult;switch(g(_)){case a.FileNotFound:return 1;case a.FileIsADirectory:return 0;case a.FileNotADirectory:return 9;case a.FileWriteLocked:return 5;case a.NoPermissions:return 6;case a.FileExists:return 4;case a.FileTooLarge:return 7;default:return 10}}e.$Wk=y;var P;(function(_){_[_.CREATE=0]="CREATE",_[_.DELETE=1]="DELETE",_[_.MOVE=2]="MOVE",_[_.COPY=3]="COPY",_[_.WRITE=4]="WRITE"})(P||(e.FileOperation=P={}));class N{constructor(ge,se,re){this.resource=ge,this.operation=se,this.target=re}isOperation(ge){return this.operation===ge}}e.$Xk=N;var U;(function(_){_[_.UPDATED=0]="UPDATED",_[_.ADDED=1]="ADDED",_[_.DELETED=2]="DELETED"})(U||(e.FileChangeType=U={}));class z{static{this.a=null}constructor(ge,se){this.c=se,this.b=void 0,this.d=new C.$V(()=>{const re=l.$li.forUris(()=>this.c);return re.fill(this.rawAdded.map(B=>[B,!0])),re}),this.f=new C.$V(()=>{const re=l.$li.forUris(()=>this.c);return re.fill(this.rawUpdated.map(B=>[B,!0])),re}),this.g=new C.$V(()=>{const re=l.$li.forUris(()=>this.c);return re.fill(this.rawDeleted.map(B=>[B,!0])),re}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const re of ge){switch(re.type){case 1:this.rawAdded.push(re.resource);break;case 0:this.rawUpdated.push(re.resource);break;case 2:this.rawDeleted.push(re.resource);break}this.b!==z.a&&(typeof re.cId=="number"?this.b===void 0?this.b=re.cId:this.b!==re.cId&&(this.b=z.a):this.b!==void 0&&(this.b=z.a))}}contains(ge,...se){return this.h(ge,{includeChildren:!1},...se)}affects(ge,...se){return this.h(ge,{includeChildren:!0},...se)}h(ge,se,...re){if(!ge)return!1;const B=re.length>0;return!!((!B||re.includes(1))&&(this.d.value.get(ge)||se.includeChildren&&this.d.value.findSuperstr(ge))||(!B||re.includes(0))&&(this.f.value.get(ge)||se.includeChildren&&this.f.value.findSuperstr(ge))||(!B||re.includes(2))&&(this.g.value.findSubstr(ge)||se.includeChildren&&this.g.value.findSuperstr(ge)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ge){return this.b===ge}hasCorrelation(){return typeof this.b=="number"}}e.$Yk=z;function F(_,ge,se){return!_||!ge||_===ge||ge.length>_.length?!1:(ge.charAt(ge.length-1)!==j.sep&&(ge+=j.sep),se?(0,L.$kf)(_,ge):_.indexOf(ge)===0)}e.$Zk=F;class I extends Error{constructor(ge,se,re){super(ge),this.fileOperationResult=se,this.options=re}}e.$1k=I;class O extends I{constructor(ge,se,re,B){super(ge,se,B),this.fileOperationResult=se,this.size=re}}e.$2k=O;class T extends I{constructor(ge,se,re){super(ge,2,re),this.stat=se}}e.$3k=T;var G;(function(_){_[_.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",_[_.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",_[_.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",_[_.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",_[_.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",_[_.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",_[_.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",_[_.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",_[_.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",_[_.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",_[_.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(G||(e.FileOperationResult=G={})),e.$4k={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$5k={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$6k="files.associations",e.$7k="files.exclude",e.$8k="files.readonlyInclude",e.$9k="files.readonlyExclude",e.$0k="files.readonlyFromPermissions";var te;(function(_){_[_.FILE=0]="FILE",_[_.FOLDER=1]="FOLDER",_[_.ROOT_FOLDER=2]="ROOT_FOLDER"})(te||(e.FileKind=te={})),e.$$k="";function x(_){if(!(typeof _.size!="number"||typeof _.mtime!="number"))return _.mtime.toString(29)+_.size.toString(31)}e.$_k=x;async function X(_,ge){if(!ge.hasProvider(R.URI.from({scheme:_.scheme})))return new Promise(se=>{const re=ge.onDidChangeFileSystemProviderRegistrations(B=>{B.scheme===_.scheme&&B.added&&(re.dispose(),se())})})}e.$al=X;class Q{static{this.KB=1024}static{this.MB=Q.KB*Q.KB}static{this.GB=Q.MB*Q.KB}static{this.TB=Q.GB*Q.KB}static formatSize(ge){return(0,A.$Wf)(ge)||(ge=0),ge<Q.KB?(0,p.localize)(1,null,ge.toFixed(0)):ge<Q.MB?(0,p.localize)(2,null,(ge/Q.KB).toFixed(2)):ge<Q.GB?(0,p.localize)(3,null,(ge/Q.MB).toFixed(2)):ge<Q.TB?(0,p.localize)(4,null,(ge/Q.GB).toFixed(2)):(0,p.localize)(5,null,(ge/Q.TB).toFixed(2))}}e.$bl=Q;function ae(_){const ge=typeof _=="string"||_?.scheme===M.Schemas.vscodeRemote;return typeof _!="string"&&_?.scheme===M.Schemas.file?1024*Q.MB:ge?10*Q.MB:E.$o?50*Q.MB:1024*Q.MB}e.$cl=ae}),define(Se[248],De([1,0,21,13,209,32]),function(fe,e,l,j,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pq=void 0;async function R(M,C,v,S,k,u){let m;try{await p(M,C,v,S,k,u)}catch(o){m=o}finally{m&&k.errorTransformer&&(m=k.errorTransformer(m)),typeof m<"u"&&v.error(m),v.end()}}e.$pq=R;async function p(M,C,v,S,k,u){w(u);const m=await M.open(C,{create:!1});try{w(u);let o=0,i=0,n=k&&typeof k.length=="number"?k.length:void 0,s=l.$se.alloc(Math.min(k.bufferSize,typeof n=="number"?n:k.bufferSize)),c=k&&typeof k.position=="number"?k.position:0,t=0;do i=await M.read(m,c,s.buffer,t,s.byteLength-t),c+=i,t+=i,o+=i,typeof n=="number"&&(n-=i),t===s.byteLength&&(await v.write(S(s)),s=l.$se.alloc(Math.min(k.bufferSize,typeof n=="number"?n:k.bufferSize)),t=0);while(i>0&&(typeof n!="number"||n>0)&&w(u)&&E(o,k));if(t>0){let f=t;typeof n=="number"&&(f=Math.min(t,n)),v.write(S(s.slice(0,f)))}}catch(o){throw(0,A.$Tk)(o)}finally{await M.close(m)}}function w(M){if(M.isCancellationRequested)throw(0,j.$6)();return!0}function E(M,C){if(typeof C?.limits?.size=="number"&&M>C.limits.size)throw(0,A.$Sk)((0,L.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(Se[84],De([1,0,35,3,17,11,2,32]),function(fe,e,l,j,L,A,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=e.$xq=e.$wq=e.$vq=e.$uq=e.$tq=e.$sq=e.$rq=void 0;function w(o){return o.recursive===!0}e.$rq=w;class E extends j.$Tc{static{this.a=5}constructor(i,n,s,c){super(),this.h=i,this.j=n,this.m=s,this.n=c,this.c=this.B(new j.$Uc),this.f=void 0,this.g=0}s(){const i=new j.$Sc;this.c.value=i,this.b=this.r(i),this.b.setVerboseLogging(this.m),i.add(this.b.onDidChangeFile(n=>this.h(n))),i.add(this.b.onDidLogMessage(n=>this.j(n))),i.add(this.b.onDidError(n=>this.t(n)))}t(i){this.n.restartOnError?this.g<E.a&&this.f?(this.w(`restarting watcher after error: ${i}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${i}`):this.w(i)}u(i){this.g++,this.s(),this.watch(i)}async watch(i){this.f=i,await this.b?.watch(i)}async setVerboseLogging(i){this.m=i,await this.b?.setVerboseLogging(i)}w(i){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${i}`})}y(i){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${i}`})}dispose(){return this.b=void 0,super.dispose()}}e.$sq=E;class M extends E{constructor(i,n,s){super(i,n,s,{type:"node.js",restartOnError:!1})}}e.$tq=M;class C extends E{constructor(i,n,s){super(i,n,s,{type:"universal",restartOnError:!0})}}e.$uq=C;function v(o){return o.map(i=>({type:i.type,resource:R.URI.revive(i.resource),cId:i.cId}))}e.$vq=v;function S(o){const i=new m;for(const n of o)i.processEvent(n);return i.coalesce()}e.$wq=S;function k(o,i){return typeof i=="string"&&!i.startsWith(l.$Uj)&&!(0,L.$ic)(i)?{base:o,pattern:i}:i}e.$xq=k;function u(o,i){const n=[];for(const s of i)n.push((0,l.$Yj)(k(o,s)));return n}e.$yq=u;class m{constructor(){this.a=new Set,this.b=new Map}c(i){return A.$k?i.resource.fsPath:i.resource.fsPath.toLowerCase()}processEvent(i){const n=this.b.get(this.c(i));let s=!1;if(n){const c=n.type,t=i.type;n.resource.fsPath!==i.resource.fsPath&&(i.type===2||i.type===1)?s=!0:c===1&&t===2?(this.b.delete(this.c(i)),this.a.delete(n)):c===2&&t===1?n.type=0:c===1&&t===0||(n.type=t)}else s=!0;s&&(this.a.add(i),this.b.set(this.c(i),i))}coalesce(){const i=[],n=[];return Array.from(this.a).filter(s=>s.type!==2?(i.push(s),!1):!0).sort((s,c)=>s.resource.fsPath.length-c.resource.fsPath.length).filter(s=>n.some(c=>(0,p.$Zk)(s.resource.fsPath,c,!A.$k))?!1:(n.push(s.resource.fsPath),!0)).concat(i)}}}),define(Se[249],De([1,0,57,8,22,34,3,75,17,11,23,2,104,31,84]),function(fe,e,l,j,L,A,R,p,w,E,M,C,v,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=e.$Lq=void 0;class u extends R.$Tc{static{this.a=100}static{this.b=75}constructor(i,n,s,c){super(),this.m=i,this.n=n,this.r=s,this.s=c,this.c=this.B(new j.$uh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.n(t))),this.f=this.B(new j.$th(t=>this.z(t),u.b)),this.g=(0,k.$yq)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,k.$yq)(this.m.path,this.m.includes):void 0,this.j=new L.$ce,this.ready=this.t()}async t(){try{const i=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const n=await S.Promises.stat(i);this.B(await this.w(i,n.isDirectory()))}catch(i){i.code!=="ENOENT"?this.D(i):this.G(i)}}async u(i){let n=i.path;try{n=await S.Promises.realpath(i.path),i.path===n&&(n=await(0,v.$Iq)(i.path)??i.path),i.path!==n&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${i.path}, real: ${n})`)}catch{}return n}async w(i,n){if(E.$j&&(0,A.$fg)(i,"/Volumes/",!0))return this.D(`Refusing to watch ${i} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.$Tc.None;const s=new L.$ce(this.j.token),c=new R.$Sc;try{const t=C.URI.file(this.m.path),f=(0,w.$nc)(i),h=(0,l.watch)(i);c.add((0,R.$Rc)(()=>{h.removeAllListeners(),h.close()})),this.G(`Started watching: '${i}'`);const r=new Set;if(n)try{for(const d of await S.Promises.readdir(i))r.add(d)}catch(d){this.D(d)}const a=new Map;c.add((0,R.$Rc)(()=>{for(const[,d]of a)d.dispose();a.clear()})),h.on("error",(d,$)=>{this.D(`Failed to watch ${i} for changes using fs.watch() (${d}, ${$})`),this.dispose()}),h.on("change",(d,$)=>{if(s.token.isCancellationRequested)return;this.G(`[raw] ["${d}"] ${$}`);let D="";if($&&(D=$.toString(),E.$j&&(D=(0,p.$Ql)(D))),!(!D||d!=="change"&&d!=="rename"))if(n)if(d==="rename"){a.get(D)?.dispose();const b=setTimeout(async()=>{if(a.delete(D),D===f&&!await S.Promises.exists(i)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const g=await this.C((0,w.$jc)(i,D));if(s.token.isCancellationRequested)return;let y;g?r.has(D)?y=0:(y=1,r.add(D)):(r.delete(D),y=2),this.y({resource:(0,M.$Sg)(t,D),type:y,cId:this.m.correlationId})},u.a);a.set(D,(0,R.$Rc)(()=>clearTimeout(b)))}else{let b;r.has(D)?b=0:(b=1,r.add(D)),this.y({resource:(0,M.$Sg)(t,D),type:b,cId:this.m.correlationId})}else if(d==="rename"||D!==f){const b=setTimeout(async()=>{const g=await S.Promises.exists(i);s.token.isCancellationRequested||(g?(this.y({resource:t,type:0,cId:this.m.correlationId},!0),c.add(await this.w(i,!1))):(this.y({resource:t,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},u.a);c.clear(),c.add((0,R.$Rc)(()=>clearTimeout(b)))}else this.y({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){await S.Promises.exists(i)&&!s.token.isCancellationRequested&&this.D(`Failed to watch ${i} for changes using fs.watch() (${t.toString()})`)}return(0,R.$Rc)(()=>{s.dispose(!0),c.dispose()})}y(i,n=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${i.type===1?"[ADDED]":i.type===2?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`),!n&&this.g.some(s=>s(i.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${i.resource.fsPath}`):!n&&this.h&&this.h.length>0&&!this.h.some(s=>s(i.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${i.resource.fsPath}`):this.f.work(i))}z(i){const n=(0,k.$wq)(i);if(n.length>0){if(this.s)for(const c of n)this.G(` >> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.resource.fsPath}`);this.c.work(n)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${n[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${n.length}, most recent change: ${n[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(i){if(E.$k)return S.Promises.exists(i);try{const n=(0,w.$nc)(i);return(await S.Promises.readdir((0,w.$mc)(i))).some(c=>c===n)}catch(n){return this.G(n),!1}}setVerboseLogging(i){this.s=i}D(i){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${i}`})}F(i){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${i}`})}G(i){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${i}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$Lq=u;async function m(o,i,n,s,c=512){const t=await S.Promises.open(o,"r"),f=Buffer.allocUnsafe(c),h=new L.$ce(s);let r,a=!1;const d={path:o,excludes:[],recursive:!1},$=new u(d,D=>{(async()=>{for(const{type:b}of D)if(b===0){if(a)return;a=!0;try{for(;!h.token.isCancellationRequested;){const{bytesRead:g}=await S.Promises.read(t,f,0,c,null);if(!g||h.token.isCancellationRequested)break;i(f.slice(0,g))}}catch(g){r=new Error(g),h.dispose(!0)}finally{a=!1}}})()});return await $.ready,n(),new Promise((D,b)=>{h.token.onCancellationRequested(async()=>{$.dispose();try{await S.Promises.close(t)}catch(g){r=new Error(g)}r?b(r):D()})})}e.$Mq=m}),define(Se[250],De([1,0,4,35,3,11,249]),function(fe,e,l,j,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=void 0;class p extends L.$Tc{constructor(){super(...arguments),this.a=this.B(new l.$5d),this.onDidChangeFile=this.a.event,this.b=this.B(new l.$5d),this.onDidLogMessage=this.b.event,this.onDidError=l.Event.None,this.c=new Map,this.f=!1}async watch(E){const M=this.j(E),C=M.filter(S=>{const k=this.c.get(S.path);return k?!(0,j.$3j)(k.request.excludes,S.excludes)||!(0,j.$3j)(k.request.includes,S.includes):!0}),v=Array.from(this.c.values()).filter(({request:S})=>!M.find(k=>k.path===S.path&&(0,j.$3j)(k.excludes,S.excludes)&&(0,j.$3j)(k.includes,S.includes))).map(({request:S})=>S.path);C.length&&this.m(`Request to start watching: ${C.map(S=>`${S.path} (excludes: ${S.excludes.length>0?S.excludes:"<none>"}, includes: ${S.includes&&S.includes.length>0?JSON.stringify(S.includes):"<all>"}, correlationId: ${typeof S.correlationId=="number"?S.correlationId:"<none>"})`).join(",")}`),v.length&&this.m(`Request to stop watching: ${v.join(",")}`);for(const S of v)this.h(S);for(const S of C)this.g(S)}g(E){const M=new R.$Lq(E,v=>this.a.fire(v),v=>this.b.fire(v),this.f),C={request:E,instance:M};this.c.set(E.path,C)}async stop(){for(const[E]of this.c)this.h(E);this.c.clear()}h(E){const M=this.c.get(E);M&&(this.c.delete(E),M.instance.dispose())}j(E){const M=new Map;for(const C of E){const v=A.$k?C.path:C.path.toLowerCase();let S=M.get(C.correlationId);S||(S=new Map,M.set(C.correlationId,S)),S.set(v,C)}return Array.from(M.values()).map(C=>Array.from(C.values())).flat()}async setVerboseLogging(E){this.f=E;for(const[,M]of this.c)M.instance.setVerboseLogging(E)}m(E){this.f&&this.b.fire({type:"trace",message:this.n(E)})}n(E,M){return M?`[File Watcher (node.js)] ${E} (path: ${M.request.path})`:`[File Watcher (node.js)] ${E}`}}e.$Nq=p}),define(Se[251],De([1,0,84,250]),function(fe,e,l,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oq=void 0;class L extends l.$tq{constructor(R,p,w){super(R,p,w),this.s()}r(R){return R.add(new j.$Nq)}}e.$Oq=L}),define(Se[252],De([1,0,15,80,192,84]),function(fe,e,l,j,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gq=void 0;class R extends A.$uq{constructor(w,E,M){super(w,E,M),this.s()}r(w){const E=w.add(new L.$Fq(l.$zg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return w.add(E.onDidProcessExit(({code:M,signal:C})=>this.t(`terminated by itself with code ${M}, signal: ${C}`))),j.ProxyChannel.toService((0,j.$Yh)(E.getChannel("watcher")))}}e.$Gq=R}),define(Se[107],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$di=void 0;class l{constructor(...L){this.a=new Map;for(const[A,R]of L)this.set(A,R)}set(L,A){const R=this.a.get(L);return this.a.set(L,A),R}has(L){return this.a.has(L)}get(L){return this.a.get(L)}}e.$di=l}),define(Se[253],De([1,0,8,13,3,106,244,5,107,74]),function(fe,e,l,j,L,A,R,p,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=e.$Sq=void 0;const M=!1;class C extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class v{constructor(m=new w.$di,o=!1,i,n=M){this.f=m,this.g=o,this.h=i,this.i=n,this.o=new Set,this.f.set(p.$ei,this),this._globalGraph=n?i?._globalGraph??new R.$Rq(s=>s):void 0}createChild(m){return new v(m,this.g,this,this.i)}invokeFunction(m,...o){const i=k.traceInvocation(this.i,m);let n=!1;try{return m({get:c=>{if(n)throw(0,j.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(c,i);if(!t)throw new Error(`[invokeFunction] unknown service '${c}'`);return t}},...o)}finally{n=!0,i.stop()}}createInstance(m,...o){let i,n;return m instanceof A.$ci?(i=k.traceCreation(this.i,m.ctor),n=this.j(m.ctor,m.staticArguments.concat(o),i)):(i=k.traceCreation(this.i,m),n=this.j(m,o,i)),i.stop(),n}j(m,o=[],i){const n=p._util.getServiceDependencies(m).sort((t,f)=>t.index-f.index),s=[];for(const t of n){const f=this.m(t.id,i);f||this.u(`[createInstance] ${m.name} depends on UNKNOWN service ${t.id}.`,!1),s.push(f)}const c=n.length>0?n[0].index:o.length;if(o.length!==c){console.trace(`[createInstance] First service dependency of ${m.name} at position ${c+1} conflicts with ${o.length} static arguments`);const t=c-o.length;t>0?o=o.concat(new Array(t)):o=o.slice(0,c)}return Reflect.construct(m,o.concat(s))}k(m,o){if(this.f.get(m)instanceof A.$ci)this.f.set(m,o);else if(this.h)this.h.k(m,o);else throw new Error("illegalState - setting UNKNOWN service instance")}l(m){const o=this.f.get(m);return!o&&this.h?this.h.l(m):o}m(m,o){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(m));const i=this.l(m);return i instanceof A.$ci?this.q(m,i,o.branch(m,!0)):(o.branch(m,!1),i)}q(m,o,i){if(this.o.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this.o.add(m);try{return this.r(m,o,i)}finally{this.o.delete(m)}}r(m,o,i){const n=new R.$Rq(t=>t.id.toString());let s=0;const c=[{id:m,desc:o,_trace:i}];for(;c.length;){const t=c.pop();if(n.lookupOrInsertNode(t),s++>1e3)throw new C(n);for(const f of p._util.getServiceDependencies(t.desc.ctor)){const h=this.l(f.id);if(h||this.u(`[createInstance] ${m} depends on ${f.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(f.id)),h instanceof A.$ci){const r={id:f.id,desc:h,_trace:t._trace.branch(f.id,!0)};n.insertEdge(t,r),c.push(r)}}}for(;;){const t=n.roots();if(t.length===0){if(!n.isEmpty())throw new C(n);break}for(const{data:f}of t){if(this.l(f.id)instanceof A.$ci){const r=this.s(f.id,f.desc.ctor,f.desc.staticArguments,f.desc.supportsDelayedInstantiation,f._trace);this.k(f.id,r)}n.removeNode(f)}}return this.l(m)}s(m,o,i=[],n,s){if(this.f.get(m)instanceof A.$ci)return this.t(m,o,i,n,s);if(this.h)return this.h.s(m,o,i,n,s);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}t(m,o,i=[],n,s){if(n){const c=new v(void 0,this.g,this,this.i);c.c=String(m);const t=new Map,f=new l.$yh(()=>{const h=c.j(o,i,s);for(const[r,a]of t){const d=h[r];if(typeof d=="function")for(const $ of a)$.disposable=d.apply(h,$.listener)}return t.clear(),h});return new Proxy(Object.create(null),{get(h,r){if(!f.isInitialized&&typeof r=="string"&&(r.startsWith("onDid")||r.startsWith("onWill"))){let $=t.get(r);return $||($=new E.$4c,t.set(r,$)),(b,g,y)=>{if(f.isInitialized)return f.value[r](b,g,y);{const P={listener:[b,g,y],disposable:void 0},N=$.push(P);return(0,L.$Rc)(()=>{N(),P.disposable?.dispose()})}}}if(r in h)return h[r];const a=f.value;let d=a[r];return typeof d!="function"||(d=d.bind(a),h[r]=d),d},set(h,r,a){return f.value[r]=a,!0},getPrototypeOf(h){return o.prototype}})}else return this.j(o,i,s)}u(m,o){if(o&&console.warn(m),this.g)throw new Error(m)}}e.$Sq=v;var S;(function(u){u[u.None=0]="None",u[u.Creation=1]="Creation",u[u.Invocation=2]="Invocation",u[u.Branch=3]="Branch"})(S||(S={}));class k{static{this.all=new Set}static{this.c=new class extends k{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(m,o){return m?new k(2,o.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):k.c}static traceCreation(m,o){return m?new k(1,o.name):k.c}static{this.f=0}constructor(m,o){this.type=m,this.name=o,this.g=Date.now(),this.h=[]}branch(m,o){const i=new k(3,m.toString());return this.h.push([m,o,i]),i}stop(){const m=Date.now()-this.g;k.f+=m;let o=!1;function i(s,c){const t=[],f=new Array(s+1).join("	");for(const[h,r,a]of c.h)if(r&&a){o=!0,t.push(`${f}CREATES -> ${h}`);const d=i(s+1,a);d&&t.push(d)}else t.push(`${f}uses -> ${h}`);return t.join(`
`)}const n=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${i(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${k.f.toFixed(2)}ms)`];(m>2||o)&&k.all.add(n.join(`
`))}}e.$Tq=k}),define(Se[12],De([1,0,44,4,54,3,28,11,23,18,2,45,5]),function(fe,e,l,j,L,A,R,p,w,E,M,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.log=e.$Cj=e.LogLevel=e.$Bj=e.$Aj=e.$zj=void 0,e.$zj=(0,v.$fi)("logService"),e.$Aj=(0,v.$fi)("loggerService");function S(){return new Date().toISOString()}function k(b){return(0,E.$Wf)(b)}e.$Bj=k;var u;(function(b){b[b.Off=0]="Off",b[b.Trace=1]="Trace",b[b.Debug=2]="Debug",b[b.Info=3]="Info",b[b.Warning=4]="Warning",b[b.Error=5]="Error"})(u||(e.LogLevel=u={})),e.$Cj=u.Info;function m(b,g,y){switch(g){case u.Trace:b.trace(y);break;case u.Debug:b.debug(y);break;case u.Info:b.info(y);break;case u.Warning:b.warn(y);break;case u.Error:b.error(y);break;case u.Off:break;default:throw new Error(`Invalid log level ${g}`)}}e.log=m;function o(b,g=!1){let y="";for(let P=0;P<b.length;P++){let N=b[P];if(N instanceof Error&&(N=(0,l.$3i)(N,g)),typeof N=="object")try{N=JSON.stringify(N)}catch{}y+=(P>0?" ":"")+N}return y}class i extends A.$Tc{constructor(){super(...arguments),this.b=e.$Cj,this.c=this.B(new j.$5d),this.onDidChangeLogLevel=this.c.event}setLevel(g){this.b!==g&&(this.b=g,this.c.fire(this.b))}getLevel(){return this.b}f(g){return this.b!==u.Off&&this.b<=g}}e.$Ej=i;class n extends i{constructor(g){super(),this.h=g}f(g){return this.h||super.f(g)}trace(g,...y){this.f(u.Trace)&&this.g(u.Trace,o([g,...y],!0))}debug(g,...y){this.f(u.Debug)&&this.g(u.Debug,o([g,...y]))}info(g,...y){this.f(u.Info)&&this.g(u.Info,o([g,...y]))}warn(g,...y){this.f(u.Warning)&&this.g(u.Warning,o([g,...y]))}error(g,...y){if(this.f(u.Error))if(g instanceof Error){const P=Array.prototype.slice.call(arguments);P[0]=g.stack,this.g(u.Error,o(P))}else this.g(u.Error,o([g,...y]))}flush(){}}e.$Fj=n;class s extends i{constructor(g=e.$Cj){super(),this.setLevel(g),this.g=!p.$i}trace(g,...y){this.f(u.Trace)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,g,...y):console.log(`[main ${S()}]`,g,...y))}debug(g,...y){this.f(u.Debug)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,g,...y):console.log(`[main ${S()}]`,g,...y))}info(g,...y){this.f(u.Info)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,g,...y):console.log(`[main ${S()}]`,g,...y))}warn(g,...y){this.f(u.Warning)&&(this.g?console.warn(`\x1B[93m[main ${S()}]\x1B[0m`,g,...y):console.warn(`[main ${S()}]`,g,...y))}error(g,...y){this.f(u.Error)&&(this.g?console.error(`\x1B[91m[main ${S()}]\x1B[0m`,g,...y):console.error(`[main ${S()}]`,g,...y))}flush(){}}e.$Gj=s;class c extends i{constructor(g=e.$Cj,y=!0){super(),this.g=y,this.setLevel(g)}trace(g,...y){this.f(u.Trace)&&(this.g?console.log("%cTRACE","color: #888",g,...y):console.log(g,...y))}debug(g,...y){this.f(u.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",g,...y):console.log(g,...y))}info(g,...y){this.f(u.Info)&&(this.g?console.log("%c INFO","color: #33f",g,...y):console.log(g,...y))}warn(g,...y){this.f(u.Warning)&&(this.g?console.log("%c WARN","color: #993",g,...y):console.log(g,...y))}error(g,...y){this.f(u.Error)&&(this.g?console.log("%c  ERR","color: #f33",g,...y):console.error(g,...y))}flush(){}}e.$Hj=c;class t extends i{constructor(g,y=e.$Cj){super(),this.g=g,this.setLevel(y)}trace(g,...y){this.f(u.Trace)&&this.g.log(u.Trace,[this.h(g),...y])}debug(g,...y){this.f(u.Debug)&&this.g.log(u.Debug,[this.h(g),...y])}info(g,...y){this.f(u.Info)&&this.g.log(u.Info,[this.h(g),...y])}warn(g,...y){this.f(u.Warning)&&this.g.log(u.Warning,[this.h(g),...y])}error(g,...y){this.f(u.Error)&&this.g.log(u.Error,[this.h(g),...y])}h(g){return typeof g=="string"?g:(0,l.$3i)(g,this.f(u.Trace))}flush(){}}e.$Ij=t;class f extends i{constructor(g){super(),this.g=g,g.length&&this.setLevel(g[0].getLevel())}setLevel(g){for(const y of this.g)y.setLevel(g);super.setLevel(g)}trace(g,...y){for(const P of this.g)P.trace(g,...y)}debug(g,...y){for(const P of this.g)P.debug(g,...y)}info(g,...y){for(const P of this.g)P.info(g,...y)}warn(g,...y){for(const P of this.g)P.warn(g,...y)}error(g,...y){for(const P of this.g)P.error(g,...y)}flush(){for(const g of this.g)g.flush()}dispose(){for(const g of this.g)g.dispose();super.dispose()}}e.$Jj=f;class h extends A.$Tc{constructor(g,y,P){if(super(),this.h=g,this.j=y,this.b=new R.$Ac,this.c=this.B(new j.$5d),this.onDidChangeLoggers=this.c.event,this.f=this.B(new j.$5d),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new j.$5d),this.onDidChangeVisibility=this.g.event,P)for(const N of P)this.b.set(N.resource,{logger:void 0,info:N})}m(g){return(0,E.$Sf)(g)?[...this.b.values()].find(y=>y.info.id===g):this.b.get(g)}getLogger(g){return this.m(g)?.logger}createLogger(g,y){const P=this.n(g),N=(0,E.$Sf)(g)?g:y?.id??(0,L.$6i)(P.toString()).toString(16);let U=this.b.get(P)?.logger;const z=y?.logLevel==="always"?u.Trace:y?.logLevel;U||(U=this.s(P,z??this.getLogLevel(P)??this.h,{...y,id:N}));const F={logger:U,info:{resource:P,id:N,logLevel:z,name:y?.name,hidden:y?.hidden,extensionId:y?.extensionId,when:y?.when}};return this.registerLogger(F.info),this.b.set(P,F),U}n(g){return(0,E.$Sf)(g)?(0,w.$Sg)(this.j,`${g}.log`):g}setLogLevel(g,y){if(M.URI.isUri(g)){const P=g,N=y,U=this.b.get(P);U&&N!==U.info.logLevel&&(U.info.logLevel=N===this.h?void 0:N,U.logger?.setLevel(N),this.b.set(U.info.resource,U),this.f.fire([P,N]))}else{this.h=g;for(const[P,N]of this.b.entries())this.b.get(P)?.info.logLevel===void 0&&N.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(g,y){const P=this.m(g);P&&y!==!P.info.hidden&&(P.info.hidden=!y,this.b.set(P.info.resource,P),this.g.fire([P.info.resource,y]))}getLogLevel(g){let y;return g&&(y=this.b.get(g)?.info.logLevel),y??this.h}registerLogger(g){const y=this.b.get(g.resource);y?y.info.hidden!==g.hidden&&this.setVisibility(g.resource,!g.hidden):(this.b.set(g.resource,{info:g,logger:void 0}),this.c.fire({added:[g],removed:[]}))}deregisterLogger(g){const y=this.b.get(g);y&&(y.logger&&y.logger.dispose(),this.b.delete(g),this.c.fire({added:[],removed:[y.info]}))}*getRegisteredLoggers(){for(const g of this.b.values())yield g.info}getRegisteredLogger(g){return this.b.get(g)?.info}dispose(){this.b.forEach(g=>g.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Kj=h;class r{constructor(){this.onDidChangeLogLevel=new j.$5d().event}setLevel(g){}getLevel(){return u.Info}trace(g,...y){}debug(g,...y){}info(g,...y){}warn(g,...y){}error(g,...y){}critical(g,...y){}dispose(){}flush(){}}e.$Lj=r;class a extends r{}e.$Mj=a;function d(b){if(b.verbose)return u.Trace;if(typeof b.logLevel=="string"){const g=D(b.logLevel.toLowerCase());if(g!==void 0)return g}return e.$Cj}e.$Nj=d;function $(b){switch(b){case u.Trace:return"trace";case u.Debug:return"debug";case u.Info:return"info";case u.Warning:return"warn";case u.Error:return"error";case u.Off:return"off"}}e.$Oj=$;function D(b){switch(b){case"trace":return u.Trace;case"debug":return u.Debug;case"info":return u.Info;case"warn":return u.Warning;case"error":return u.Error;case"critical":return u.Error;case"off":return u.Off}}e.$Pj=D,e.$Qj=new C.$wj("logLevel",$(u.Info))}),define(Se[254],De([1,0,19,8,13,4,3,17,84,12]),function(fe,e,l,j,L,A,R,p,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=void 0;class M extends R.$Tc{constructor(v,S){super(),this.a=v,this.b=S,this.c=this.B(new A.$5d),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$5d),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new j.$dh(0)),this.w=[],this.y=this.B(new j.$dh(0))}watch(v,S){return S.recursive||this.b?.watcher?.forceUniversal?this.n(v,S):this.z(v,S)}n(v,S){const k={path:this.H(v),excludes:S.excludes,includes:S.includes,recursive:S.recursive,correlationId:S.correlationId},u=(0,l.$Ub)(this.j,k);return this.r(),(0,R.$Rc)(()=>{u(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(v=>(0,L.$1)(v))}s(){this.h||(this.h=this.B(this.t(S=>this.c.fire((0,w.$vq)(S)),S=>this.G(S),this.a.getLevel()===E.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===E.LogLevel.Trace)})));const v=this.b?.watcher?.recursive?.usePolling;if(v===!0)for(const S of this.j)(0,w.$rq)(S)&&(S.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(v))for(const S of this.j)(0,w.$rq)(S)&&v.includes(S.path)&&(S.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(v,S){const k={path:this.H(v),excludes:S.excludes,includes:S.includes,recursive:!1,correlationId:S.correlationId},u=(0,l.$Ub)(this.w,k);return this.C(),(0,R.$Rc)(()=>{u(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(v=>(0,L.$1)(v))}D(){return this.u||(this.u=this.B(this.F(v=>this.c.fire((0,w.$vq)(v)),v=>this.G(v),this.a.getLevel()===E.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===E.LogLevel.Trace)}))),this.u.watch(this.w)}G(v){v.type==="error"&&this.g.fire(v.message),this.a[v.type](v.message)}H(v){return(0,p.$hc)(v.fsPath)}}e.$zq=M}),define(Se[255],De([1,0,57,393,8,28,21,4,34,3,17,11,23,98,31,210,32,248,254,44,252,251]),function(fe,e,l,j,L,A,R,p,w,E,M,C,v,S,k,u,m,o,i,n,s,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=void 0,(()=>{try{(0,j.gracefulify)(l)}catch(f){console.error(`Error enabling graceful-fs: ${(0,n.$3i)(f)}`)}})();class t extends i.$zq{static{this.I=!1}constructor(h,r){super(h,r),this.onDidChangeCapabilities=p.Event.None,this.N=new A.$Ac(a=>v.$Jg.getComparisonKey(a)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,C.$k&&(this.J|=1024)),this.J}async stat(h){try{const{stat:r,symbolicLink:a}=await k.SymlinkSupport.stat(this.H(h));return{type:this.M(r,a),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size,permissions:r.mode&128?void 0:m.FilePermission.Locked}}catch(r){throw this.fb(r)}}async L(h){try{return await this.stat(h)}catch{return}}async readdir(h){try{const r=await k.Promises.readdir(this.H(h),{withFileTypes:!0}),a=[];return await Promise.all(r.map(async d=>{try{let $;d.isSymbolicLink()?$=(await this.stat((0,v.$Sg)(h,d.name))).type:$=this.M(d),a.push([d.name,$])}catch($){this.a.trace($)}})),a}catch(r){throw this.fb(r)}}M(h,r){let a;return r?.dangling?a=m.FileType.Unknown:h.isFile()?a=m.FileType.File:h.isDirectory()?a=m.FileType.Directory:a=m.FileType.Unknown,r&&(a|=m.FileType.SymbolicLink),a}async O(h){const r=this.H(h);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${r})`);let a;for(;a=this.N.get(h);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${r})`),await a.wait();const d=new L.$eh;return this.N.set(h,d),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${r})`),(0,E.$Rc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${r})`),this.N.get(h)===d&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${r})`),this.N.delete(h)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${r})`),d.open()})}async readFile(h,r){let a;try{r?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(h)})`),a=await this.O(h));const d=this.H(h);return await k.Promises.readFile(d)}catch(d){throw this.fb(d)}finally{a?.dispose()}}P(h){t.I&&this.a.trace(h)}readFileStream(h,r,a){const d=(0,S.$ge)($=>R.$se.concat($.map(D=>R.$se.wrap(D))).buffer);return(0,o.$pq)(this,h,d,$=>$.buffer,{...r,bufferSize:256*1024},a),d}async writeFile(h,r,a){return a?.atomic!==!1&&a?.atomic?.postfix&&await this.Q(h)?this.R(h,(0,v.$Sg)((0,v.$Rg)(h),`${(0,v.$Pg)(h)}${a.atomic.postfix}`),r,a):this.S(h,r,a)}async Q(h){try{const r=this.H(h),{symbolicLink:a}=await k.SymlinkSupport.stat(r);if(a)return!1}catch{}return!0}async R(h,r,a,d){const $=new E.$Sc;try{$.add(await this.O(h)),$.add(await this.O(r)),await this.S(r,a,d,!0);try{await this.rename(r,h,{overwrite:!0})}catch(D){try{await this.delete(r,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw D}}finally{$.dispose()}}async S(h,r,a,d){let $;try{const D=this.H(h);if(!a.create||!a.overwrite){if(await k.Promises.exists(D)){if(!a.overwrite)throw(0,m.$Sk)((0,u.localize)(0,null),m.FileSystemProviderErrorCode.FileExists)}else if(!a.create)throw(0,m.$Sk)((0,u.localize)(1,null),m.FileSystemProviderErrorCode.FileNotFound)}$=await this.open(h,{create:!0,unlock:a.unlock},d),await this.write($,0,r,0,r.byteLength)}catch(D){throw await this.gb(h,D)}finally{typeof $=="number"&&await this.close($)}}static{this.Y=!0}static configureFlushOnWrite(h){t.Y=h}async open(h,r,a){const d=this.H(h);let $;(0,m.$Gk)(r)&&!a&&($=await this.O(h));let D;try{if((0,m.$Gk)(r)&&r.unlock)try{const{stat:g}=await k.SymlinkSupport.stat(d);g.mode&128||await k.Promises.chmod(d,g.mode|128)}catch(g){g.code!=="ENOENT"&&this.a.trace(g)}let b;if((0,m.$Gk)(r)){if(C.$i)try{await k.Promises.truncate(d,0),b="r+"}catch(g){g.code!=="ENOENT"&&this.a.trace(g)}b||(b="w")}else b="r";D=await k.Promises.open(d,b)}catch(b){throw $?.dispose(),(0,m.$Gk)(r)?await this.gb(h,b):this.fb(b)}if(this.U.set(D,0),(0,m.$Gk)(r)&&this.X.set(D,h),$){const b=this.W.get(D);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${D} (${d})`),this.W.set(D,$),b&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${D} (${d})`),b.dispose())}return D}async close(h){const r=this.W.get(h);try{if(this.U.delete(h),this.X.delete(h)&&t.Y)try{await k.Promises.fdatasync(h)}catch(a){t.configureFlushOnWrite(!1),this.a.error(a)}return await k.Promises.close(h)}catch(a){throw this.fb(a)}finally{r&&(this.W.get(h)===r&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${h}`),this.W.delete(h)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${h}`),r.dispose())}}async read(h,r,a,d,$){const D=this.Z(h,r);let b=null;try{b=(await k.Promises.read(h,a,d,$,D)).bytesRead}catch(g){throw this.fb(g)}finally{this.$(h,D,b)}return b}Z(h,r){return r===this.U.get(h)?null:r}$(h,r,a){const d=this.U.get(h);typeof d=="number"&&(typeof r=="number"||(typeof a=="number"?this.U.set(h,d+a):this.U.delete(h)))}async write(h,r,a,d,$){return(0,L.$zh)(()=>this.ab(h,r,a,d,$),100,3)}async ab(h,r,a,d,$){const D=this.Z(h,r);let b=null;try{b=(await k.Promises.write(h,a,d,$,D)).bytesWritten}catch(g){throw await this.gb(this.X.get(h),g)}finally{this.$(h,D,b)}return b}async mkdir(h){try{await k.Promises.mkdir(this.H(h))}catch(r){throw this.fb(r)}}async delete(h,r){try{const a=this.H(h);if(r.recursive){let d;r?.atomic!==!1&&r.atomic.postfix&&(d=(0,M.$jc)((0,M.$mc)(a),`${(0,M.$nc)(a)}${r.atomic.postfix}`)),await k.Promises.rm(a,k.RimRafMode.MOVE,d)}else try{await k.Promises.unlink(a)}catch(d){if(d.code==="EPERM"||d.code==="EISDIR"){let $=!1;try{const{stat:D,symbolicLink:b}=await k.SymlinkSupport.stat(a);$=D.isDirectory()&&!b}catch{}if($)await k.Promises.rmdir(a);else throw d}else throw d}}catch(a){throw this.fb(a)}}async rename(h,r,a){const d=this.H(h),$=this.H(r);if(d!==$)try{await this.bb(h,r,"move",a.overwrite),await k.Promises.rename(d,$)}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,u.localize)(2,null,(0,M.$nc)(d),(0,M.$nc)((0,M.$mc)($)),D.toString()))),this.fb(D)}}async copy(h,r,a){const d=this.H(h),$=this.H(r);if(d!==$)try{await this.bb(h,r,"copy",a.overwrite),await k.Promises.copy(d,$,{preserveSymlinks:!0})}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,u.localize)(3,null,(0,M.$nc)(d),(0,M.$nc)((0,M.$mc)($)),D.toString()))),this.fb(D)}}async bb(h,r,a,d){const $=this.H(h),D=this.H(r);let b=!1;if(!!(this.capabilities&1024)||(b=(0,w.$eg)($,D,!0)),b){if(a==="copy")throw(0,m.$Sk)((0,u.localize)(4,null),m.FileSystemProviderErrorCode.FileExists);if(a==="move")return}const y=await this.L(h);if(!y)throw(0,m.$Sk)((0,u.localize)(5,null),m.FileSystemProviderErrorCode.FileNotFound);const P=await this.L(r);if(P){if(!d)throw(0,m.$Sk)((0,u.localize)(6,null),m.FileSystemProviderErrorCode.FileExists);y.type&m.FileType.File&&P.type&m.FileType.File||await this.delete(r,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(h,r){return this.cb(h,r,!1)}async cb(h,r,a){const d=this.H(h),$=this.H(r),D=!!(this.capabilities&1024);if((0,w.$eg)(d,$,!D))return;const b=new E.$Sc;try{b.add(await this.O(h)),b.add(await this.O(r)),a&&await k.Promises.mkdir((0,M.$mc)($),{recursive:!0}),await k.Promises.copyFile(d,$)}catch(g){if(g.code==="ENOENT"&&!a)return this.cb(h,r,!0);throw this.fb(g)}finally{b.dispose()}}t(h,r,a){return new s.$Gq(d=>h(d),d=>r(d),a)}F(h,r,a){return new c.$Oq(d=>h(d),d=>r(d),a)}fb(h){if(h instanceof m.$Rk)return h;let r=h,a;switch(h.code){case"ENOENT":a=m.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=m.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=m.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=m.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=m.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":r=`${h.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,a=m.FileSystemProviderErrorCode.Unknown;break;default:a=m.FileSystemProviderErrorCode.Unknown}return(0,m.$Sk)(r,a)}async gb(h,r){let a=this.fb(r);if(h&&a.code===m.FileSystemProviderErrorCode.NoPermissions)try{const{stat:d}=await k.SymlinkSupport.stat(this.H(h));d.mode&128||(a=(0,m.$Sk)(r,m.FileSystemProviderErrorCode.FileWriteLocked))}catch(d){this.a.trace(d)}return a}}e.$Pq=t}),define(Se[256],De([1,0,3,12]),function(fe,e,l,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IP=void 0;class L extends l.$Tc{constructor(R,p=[]){super(),this.a=new j.$Jj([R,...p]),this.B(R.onDidChangeLogLevel(w=>this.setLevel(w)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...p){this.a.trace(R,...p)}debug(R,...p){this.a.debug(R,...p)}info(R,...p){this.a.info(R,...p)}warn(R,...p){this.a.warn(R,...p)}error(R,...p){this.a.error(R,...p)}flush(){this.a.flush()}}e.$IP=L}),define(Se[257],De([1,0,32,12]),function(fe,e,l,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xP=void 0;var L;(function(E){E[E.Trace=0]="Trace",E[E.Debug=1]="Debug",E[E.Info=2]="Info",E[E.Warning=3]="Warning",E[E.Error=4]="Error",E[E.Critical=5]="Critical",E[E.Off=6]="Off"})(L||(L={}));async function A(E,M,C,v,S){try{const k=await new Promise((m,o)=>{fe(["@vscode/spdlog"],m,o)});k.setFlushOn(L.Trace);const u=await k.createAsyncRotatingLogger(E,M,C,v);return S?u.clearFormatters():u.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),u}catch(k){console.error(k)}return null}function R(E,M,C){switch(M){case j.LogLevel.Trace:E.trace(C);break;case j.LogLevel.Debug:E.debug(C);break;case j.LogLevel.Info:E.info(C);break;case j.LogLevel.Warning:E.warn(C);break;case j.LogLevel.Error:E.error(C);break;case j.LogLevel.Off:break;default:throw new Error(`Invalid log level ${M}`)}}function p(E,M){switch(M){case j.LogLevel.Trace:E.setLevel(L.Trace);break;case j.LogLevel.Debug:E.setLevel(L.Debug);break;case j.LogLevel.Info:E.setLevel(L.Info);break;case j.LogLevel.Warning:E.setLevel(L.Warning);break;case j.LogLevel.Error:E.setLevel(L.Error);break;case j.LogLevel.Off:E.setLevel(L.Off);break;default:throw new Error(`Invalid log level ${M}`)}}class w extends j.$Fj{constructor(M,C,v,S,k){super(),this.m=[],this.setLevel(k),this.n=this.s(M,C,v,S),this.B(this.onDidChangeLogLevel(u=>{this.r&&p(this.r,u)}))}async s(M,C,v,S){const k=v?6:1,u=30/k*l.$bl.MB,m=await A(M,C,u,k,S);if(m){this.r=m,p(this.r,this.getLevel());for(const{level:o,message:i}of this.m)R(this.r,o,i);this.m=[]}}g(M,C){this.r?R(this.r,M,C):this.getLevel()<=M&&this.m.push({level:M,message:C})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$xP=w}),define(Se[138],De([1,0,39,211,5]),function(fe,e,l,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ot=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(w){w[w.Unnecessary=1]="Unnecessary",w[w.Deprecated=2]="Deprecated"})(A||(e.MarkerTag=A={}));var R;(function(w){w[w.Hint=1]="Hint",w[w.Info=2]="Info",w[w.Warning=4]="Warning",w[w.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(w){function E(k,u){return u-k}w.compare=E;const M=Object.create(null);M[w.Error]=(0,j.localize)(0,null),M[w.Warning]=(0,j.localize)(1,null),M[w.Info]=(0,j.localize)(2,null);function C(k){return M[k]||""}w.toString=C;function v(k){switch(k){case l.default.Error:return w.Error;case l.default.Warning:return w.Warning;case l.default.Info:return w.Info;case l.default.Ignore:return w.Hint}}w.fromSeverity=v;function S(k){switch(k){case w.Error:return l.default.Error;case w.Warning:return l.default.Warning;case w.Info:return l.default.Info;case w.Hint:return l.default.Ignore}}w.toSeverity=S}(R||(e.MarkerSeverity=R={}));var p;(function(w){const E="";function M(v){return C(v,!0)}w.makeKey=M;function C(v,S){const k=[E];return v.source?k.push(v.source.replace("\xA6","\\\xA6")):k.push(E),v.code?typeof v.code=="string"?k.push(v.code.replace("\xA6","\\\xA6")):k.push(v.code.value.replace("\xA6","\\\xA6")):k.push(E),v.severity!==void 0&&v.severity!==null?k.push(R.toString(v.severity)):k.push(E),v.message&&S?k.push(v.message.replace("\xA6","\\\xA6")):k.push(E),v.startLineNumber!==void 0&&v.startLineNumber!==null?k.push(v.startLineNumber.toString()):k.push(E),v.startColumn!==void 0&&v.startColumn!==null?k.push(v.startColumn.toString()):k.push(E),v.endLineNumber!==void 0&&v.endLineNumber!==null?k.push(v.endLineNumber.toString()):k.push(E),v.endColumn!==void 0&&v.endColumn!==null?k.push(v.endColumn.toString()):k.push(E),k.push(E),k.join("\xA6")}w.makeKeyOptionalMessage=C})(p||(e.IMarkerData=p={})),e.$Ot=(0,L.$fi)("markerService")}),define(Se[258],De([1,0,4,39,5]),function(fe,e,l,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hv=e.$Gv=e.NotificationsFilter=e.$Fv=e.NeverShowAgainScope=e.NotificationPriority=e.$Ev=e.Severity=void 0,e.Severity=j.default,e.$Ev=(0,L.$fi)("notificationService");var A;(function(C){C[C.DEFAULT=0]="DEFAULT",C[C.SILENT=1]="SILENT",C[C.URGENT=2]="URGENT"})(A||(e.NotificationPriority=A={}));var R;(function(C){C[C.WORKSPACE=0]="WORKSPACE",C[C.PROFILE=1]="PROFILE",C[C.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));function p(C){if(C){const v=C;return typeof v.id=="string"&&typeof v.label=="string"}return!1}e.$Fv=p;var w;(function(C){C[C.OFF=0]="OFF",C[C.ERROR=1]="ERROR"})(w||(e.NotificationsFilter=w={}));class E{constructor(){this.progress=new M,this.onDidClose=l.Event.None,this.onDidChangeVisibility=l.Event.None}updateSeverity(v){}updateMessage(v){}updateActions(v){}close(){}}e.$Gv=E;class M{infinite(){}done(){}total(v){}worked(v){}}e.$Hv=M}),define(Se[259],De([1,0,50]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let j;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.context<"u"){const A=L.context.configuration();if(A)j=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(j=globalThis._VSCODE_PRODUCT_JSON,l.env.VSCODE_DEV&&Object.assign(j,{nameShort:`${j.nameShort} Dev`,nameLong:`${j.nameLong} Dev`,dataFolderName:`${j.dataFolderName}-dev`,serverDataFolderName:j.serverDataFolderName?`${j.serverDataFolderName}-dev`:void 0}),!j.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(j,{version:A.version})}}else j={},Object.keys(j).length===0&&Object.assign(j,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=j}),define(Se[139],De([1,0,5]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=e.$Rj=void 0,e.$Rj=(0,l.$fi)("productService"),e.$Sj="vscode://schemas/vscode-product"});var Ve=this&&this.__param||function(fe,e){return function(l,j){e(l,j,fe)}};define(Se[108],De([1,0,8,22,3,5]),function(fe,e,l,j,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ov=e.$Nv=e.$Mv=e.$Lv=e.$Kv=e.$Jv=e.ProgressLocation=e.$Iv=void 0,e.$Iv=(0,A.$fi)("progressService");var R;(function(C){C[C.Explorer=1]="Explorer",C[C.Scm=3]="Scm",C[C.Extensions=5]="Extensions",C[C.Window=10]="Window",C[C.Notification=15]="Notification",C[C.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$Jv=Object.freeze({total(){},worked(){},done(){}});class p{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(v){this.b=v}report(v){this.a=v,this.b(this.a)}}e.$Kv=p;class w{get value(){return this.a}constructor(v){this.e=v}report(v){this.b?this.b.push(v):this.b=[v],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const v=this.b.shift();this.a=v,await this.e(this.a)}}finally{this.c=!1;const v=this.d;this.d=void 0,v?.()}}drain(){return this.c?new Promise(v=>{const S=this.d;this.d=()=>{S?.(),v()}}):Promise.resolve()}}e.$Lv=w;let E=class extends L.$Tc{constructor(v,S){super(),this.a=new l.$Ch,S.withProgress(v,k=>(this.b=k,this.c&&k.report(this.c),this.a.p)),this.B((0,L.$Rc)(()=>this.a.complete()))}report(v){this.b?this.b.report(v):this.c=v}};e.$Mv=E,e.$Mv=E=Ye([Ve(1,e.$Iv)],E);class M extends L.$Tc{constructor(v){super(),this.g=v,this.a=0,this.b=this.B(new L.$Sc)}start(v){this.stop();const S=++this.a,k=new j.$ce;return this.f=setTimeout(()=>{S===this.a&&(this.c=this.g.show(!0))},v),this.b.add((0,L.$Rc)(()=>clearTimeout(this.f))),this.b.add((0,L.$Rc)(()=>k.cancel())),this.b.add((0,L.$Rc)(()=>this.c?this.c.done():void 0)),{id:S,token:k.token,stop:()=>this.h(S),isCurrent:()=>this.a===S}}stop(){this.h(this.a)}h(v){this.a===v&&this.b.clear()}}e.$Nv=M,e.$Ov=(0,A.$fi)("editorProgressService")}),define(Se[37],De([1,0,61,18]),function(fe,e,l,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wn=void 0;class L{constructor(){this.a=new Map}add(R,p){l.ok(j.$Sf(R)),l.ok(j.$Uf(p)),l.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,p)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$Wn=new L}),define(Se[109],De([1,0,4,37]),function(fe,e,l,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xn=void 0,e.$Xn={JSONContribution:"base.contributions.json"};function L(p){return p.length>0&&p.charAt(p.length-1)==="#"?p.substring(0,p.length-1):p}class A{constructor(){this.b=new l.$5d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(w,E){this.a[L(w)]=E,this.b.fire(w)}notifySchemaChanged(w){this.b.fire(w)}getSchemaContributions(){return{schemas:this.a}}}const R=new A;j.$Wn.add(e.$Xn.JSONContribution,R)}),define(Se[85],De([1,0,19,4,18,201,52,109,37]),function(fe,e,l,j,L,A,R,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.ConfigurationScope=e.$2n=e.EditPresentationTypes=void 0;var E;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(E||(e.EditPresentationTypes=E={})),e.$2n={Configuration:"base.contributions.configuration"};var M;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(M||(e.ConfigurationScope=M={})),e.$3n={properties:{},patternProperties:{}},e.$4n={properties:{},patternProperties:{}},e.$5n={properties:{},patternProperties:{}},e.$6n={properties:{},patternProperties:{}},e.$7n={properties:{},patternProperties:{}},e.$8n={properties:{},patternProperties:{}},e.$9n="vscode://schemas/settings/resourceLanguage",e.$0n="vscode://schemas/settings/configurationDefaults";const C=w.$Wn.as(p.$Xn.JSONContribution);class v{constructor(){this.h=new Set,this.i=new j.$5d,this.onDidSchemaChange=this.i.event,this.j=new j.$5d,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},C.registerSchema(e.$9n,this.g),this.v()}registerConfiguration(t,f=!0){this.registerConfigurations([t],f)}registerConfigurations(t,f=!0){const h=new Set;this.n(t,f,h),C.registerSchema(e.$9n,this.g),this.i.fire(),this.j.fire({properties:h})}deregisterConfigurations(t){const f=new Set;this.o(t,f),C.registerSchema(e.$9n,this.g),this.i.fire(),this.j.fire({properties:f})}updateConfigurations({add:t,remove:f}){const h=new Set;this.o(f,h),this.n(t,!1,h),C.registerSchema(e.$9n,this.g),this.i.fire(),this.j.fire({properties:h})}registerDefaultConfigurations(t){const f=new Set;this.k(t,f),this.i.fire(),this.j.fire({properties:f,defaultsOverrides:!0})}k(t,f){const h=[];for(const{overrides:r,source:a}of t)for(const d in r)if(f.add(d),e.$_n.test(d)){const $=this.a.get(d),D=$?.valuesSources??new Map;if(a)for(const P of Object.keys(r[d]))D.set(P,a);const b={...$?.value||{},...r[d]};this.a.set(d,{source:a,value:b,valuesSources:D});const g=(0,R.$Vi)(d),y={type:"object",default:b,description:A.localize(1,null,g),$ref:e.$9n,defaultDefaultValue:b,source:L.$Sf(a)?void 0:a,defaultValueSource:a};h.push(...u(d)),this.d[d]=y,this.b.properties[d]=y}else{this.a.set(d,{value:r[d],source:a});const $=this.d[d];$&&(this.w(d,$),this.r(d,$))}this.m(h)}deregisterDefaultConfigurations(t){const f=new Set;this.l(t,f),this.i.fire(),this.j.fire({properties:f,defaultsOverrides:!0})}l(t,f){for(const{overrides:h,source:r}of t)for(const a in h){const d=this.a.get(a),$=L.$Sf(r)?r:r?.id,D=L.$Sf(d?.source)?d?.source:d?.source?.id;if($===D)if(f.add(a),this.a.delete(a),e.$_n.test(a))delete this.d[a],delete this.b.properties[a];else{const b=this.d[a];b&&(this.w(a,b),this.r(a,b))}}this.u()}deltaConfiguration(t){let f=!1;const h=new Set;t.removedDefaults&&(this.l(t.removedDefaults,h),f=!0),t.addedDefaults&&(this.k(t.addedDefaults,h),f=!0),t.removedConfigurations&&this.o(t.removedConfigurations,h),t.addedConfigurations&&this.n(t.addedConfigurations,!1,h),this.i.fire(),this.j.fire({properties:h,defaultsOverrides:f})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const f of t)this.h.add(f);this.u()}n(t,f,h){t.forEach(r=>{this.p(r,f,r.extensionInfo,r.restrictedProperties,void 0,h),this.c.push(r),this.q(r)})}o(t,f){const h=r=>{if(r.properties)for(const a in r.properties){f.add(a);const d=this.d[a];d?.policy?.name&&this.e.delete(d.policy.name),delete this.d[a],this.s(a,r.properties[a])}r.allOf?.forEach(a=>h(a))};for(const r of t){h(r);const a=this.c.indexOf(r);a!==-1&&this.c.splice(a,1)}}p(t,f=!0,h,r,a=3,d){a=L.$2f(t.scope)?a:t.scope;const $=t.properties;if($)for(const b in $){const g=$[b];if(f&&n(b,g)){delete $[b];continue}if(g.source=h,g.defaultDefaultValue=$[b].default,this.w(b,g),e.$_n.test(b)?g.scope=void 0:(g.scope=L.$2f(g.scope)?a:g.scope,g.restricted=L.$2f(g.restricted)?!!r?.includes(b):g.restricted),$[b].hasOwnProperty("included")&&!$[b].included){this.f[b]=$[b],delete $[b];continue}else this.d[b]=$[b],$[b].policy?.name&&this.e.set($[b].policy.name,b);!$[b].deprecationMessage&&$[b].markdownDeprecationMessage&&($[b].deprecationMessage=$[b].markdownDeprecationMessage),d.add(b)}const D=t.allOf;if(D)for(const b of D)this.p(b,f,h,r,a,d)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const f=h=>{const r=h.properties;if(r)for(const d in r)this.r(d,r[d]);h.allOf?.forEach(f)};f(t)}r(t,f){switch(e.$3n.properties[t]=f,f.scope){case 1:e.$4n.properties[t]=f;break;case 2:e.$5n.properties[t]=f;break;case 6:e.$6n.properties[t]=f;break;case 3:e.$7n.properties[t]=f;break;case 4:e.$8n.properties[t]=f;break;case 5:e.$8n.properties[t]=f,this.g.properties[t]=f;break}}s(t,f){switch(delete e.$3n.properties[t],f.scope){case 1:delete e.$4n.properties[t];break;case 2:delete e.$5n.properties[t];break;case 6:delete e.$6n.properties[t];break;case 3:delete e.$7n.properties[t];break;case 4:case 5:delete e.$8n.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const f=`[${t}]`,h={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.$9n};this.w(f,h),e.$3n.properties[f]=h,e.$4n.properties[f]=h,e.$5n.properties[f]=h,e.$6n.properties[f]=h,e.$7n.properties[f]=h,e.$8n.properties[f]=h}}v(){const t={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.$9n};e.$3n.patternProperties[e.$$n]=t,e.$4n.patternProperties[e.$$n]=t,e.$5n.patternProperties[e.$$n]=t,e.$6n.patternProperties[e.$$n]=t,e.$7n.patternProperties[e.$$n]=t,e.$8n.patternProperties[e.$$n]=t,this.i.fire()}w(t,f){const h=this.a.get(t);let r=h?.value,a=h?.source;L.$Zf(r)&&(r=f.defaultDefaultValue,a=void 0),L.$Zf(r)&&(r=o(f.type)),f.default=r,f.defaultValueSource=a}}const S="\\[([^\\]]+)\\]",k=new RegExp(S,"g");e.$$n=`^(${S})+$`,e.$_n=new RegExp(e.$$n);function u(c){const t=[];if(e.$_n.test(c)){let f=k.exec(c);for(;f?.length;){const h=f[1].trim();h&&t.push(h),f=k.exec(c)}}return(0,l.$Mb)(t)}e.$ao=u;function m(c){return c.reduce((t,f)=>`${t}[${f}]`,"")}e.$bo=m;function o(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$co=o;const i=new v;w.$Wn.add(e.$2n.Configuration,i);function n(c,t){return c.trim()?e.$_n.test(c)?A.localize(7,null,c):i.getConfigurationProperties()[c]!==void 0?A.localize(8,null,c):t.policy?.name&&i.getPolicyConfigurations().get(t.policy?.name)!==void 0?A.localize(9,null,c,t.policy?.name,i.getPolicyConfigurations().get(t.policy?.name)):null:A.localize(6,null)}e.$do=n;function s(){const c=[],t=i.getConfigurationProperties();for(const f of Object.keys(t))c.push([f,t[f].scope]);return c.push(["launch",4]),c.push(["task",4]),c}e.$eo=s}),define(Se[260],De([1,0,19,4,163,3,28,24,18,2,52,85,37]),function(fe,e,l,j,L,A,R,p,w,E,M,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=void 0;function S(f){return Object.isFrozen(f)?f:p.$Ln(f)}class k{constructor(h={},r=[],a=[],d){this.b=h,this.c=r,this.d=a,this.raw=d,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const h=this.raw.map(r=>{if(r instanceof k)return r;const a=new u("");return a.parseRaw(r),a.configurationModel});this.f=h.reduce((r,a)=>a===r?a:r.merge(a),h[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(h){return h?(0,M.$Ti)(this.contents,h):this.contents}inspect(h,r){const a=this;return{get value(){return S(a.rawConfiguration.getValue(h))},get override(){return r?S(a.rawConfiguration.getOverrideValue(h,r)):void 0},get merged(){return S(r?a.rawConfiguration.override(r).getValue(h):a.rawConfiguration.getValue(h))},get overrides(){const d=[];for(const{contents:$,identifiers:D,keys:b}of a.rawConfiguration.overrides){const g=new k($,b).getValue(h);g!==void 0&&d.push({identifiers:D,value:g})}return d.length?S(d):void 0}}}getOverrideValue(h,r){const a=this.i(r);return a?h?(0,M.$Ti)(a,h):a:void 0}getKeysForOverrideIdentifier(h){const r=[];for(const a of this.overrides)a.identifiers.includes(h)&&r.push(...a.keys);return l.$Mb(r)}getAllOverrideIdentifiers(){const h=[];for(const r of this.overrides)h.push(...r.identifiers);return l.$Mb(h)}override(h){let r=this.a.get(h);return r||(r=this.g(h),this.a.set(h,r)),r}merge(...h){const r=p.$Kn(this.contents),a=p.$Kn(this.overrides),d=[...this.keys],$=this.raw?.length?[...this.raw]:[this];for(const D of h)if($.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.h(r,D.contents);for(const b of D.overrides){const[g]=a.filter(y=>l.$ub(y.identifiers,b.identifiers));g?(this.h(g.contents,b.contents),g.keys.push(...b.keys),g.keys=l.$Mb(g.keys)):a.push(p.$Kn(b))}for(const b of D.keys)d.indexOf(b)===-1&&d.push(b)}return new k(r,d,a,$.every(D=>D instanceof k)?void 0:$)}g(h){const r=this.i(h);if(!r||typeof r!="object"||!Object.keys(r).length)return this;const a={};for(const d of l.$Mb([...Object.keys(this.contents),...Object.keys(r)])){let $=this.contents[d];const D=r[d];D&&(typeof $=="object"&&typeof D=="object"?($=p.$Kn($),this.h($,D)):$=D),a[d]=$}return new k(a,this.keys,this.overrides)}h(h,r){for(const a of Object.keys(r)){if(a in h&&w.$Uf(h[a])&&w.$Uf(r[a])){this.h(h[a],r[a]);continue}h[a]=p.$Kn(r[a])}}i(h){let r=null,a=null;const d=$=>{$&&(a?this.h(a,$):a=p.$Kn($))};for(const $ of this.overrides)$.identifiers.length===1&&$.identifiers[0]===h?r=$.contents:$.identifiers.includes(h)&&d($.contents);return d(r),a}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(h,r){this.j(h,r,!0)}setValue(h,r){this.j(h,r,!1)}removeValue(h){const r=this.keys.indexOf(h);r!==-1&&(this.keys.splice(r,1),(0,M.$Si)(this.contents,h),C.$_n.test(h)&&this.overrides.splice(this.overrides.findIndex(a=>l.$ub(a.identifiers,(0,C.$ao)(h))),1))}j(h,r,a){(0,M.$Ri)(this.contents,h,r,d=>console.error(d)),a=a||this.keys.indexOf(h)===-1,a&&this.keys.push(h),C.$_n.test(h)&&this.overrides.push({identifiers:(0,C.$ao)(h),keys:Object.keys(this.contents[h]),contents:(0,M.$Qi)(this.contents[h],d=>console.error(d))})}}e.$fo=k;class u{constructor(h){this.f=h,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new k}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(h,r){if(!w.$2f(h)){const a=this.g(h);this.parseRaw(a,r)}}reparse(h){this.a&&this.parseRaw(this.a,h)}parseRaw(h,r){this.a=h;const{contents:a,keys:d,overrides:$,restricted:D,hasExcludedProperties:b}=this.h(h,r);this.b=new k(a,d,$,b?[h]:void 0),this.c=D||[]}g(h){let r={},a=null,d=[];const $=[],D=[];function b(y){Array.isArray(d)?d.push(y):a!==null&&(d[a]=y)}const g={onObjectBegin:()=>{const y={};b(y),$.push(d),d=y,a=null},onObjectProperty:y=>{a=y},onObjectEnd:()=>{d=$.pop()},onArrayBegin:()=>{const y=[];b(y),$.push(d),d=y,a=null},onArrayEnd:()=>{d=$.pop()},onLiteralValue:b,onError:(y,P,N)=>{D.push({error:y,offset:P,length:N})}};if(h)try{L.$yn(h,g),r=d[0]||{}}catch(y){console.error(`Error while parsing settings file ${this.f}: ${y}`),this.d=[y]}return r}h(h,r){const a=v.$Wn.as(C.$2n.Configuration).getConfigurationProperties(),d=this.i(h,a,!0,r);h=d.raw;const $=(0,M.$Qi)(h,g=>console.error(`Conflict in settings file ${this.f}: ${g}`)),D=Object.keys(h),b=this.j(h,g=>console.error(`Conflict in settings file ${this.f}: ${g}`));return{contents:$,keys:D,overrides:b,restricted:d.restricted,hasExcludedProperties:d.hasExcludedProperties}}i(h,r,a,d){let $=!1;if(!d?.scopes&&!d?.skipRestricted&&!d?.exclude?.length)return{raw:h,restricted:[],hasExcludedProperties:$};const D={},b=[];for(const g in h)if(C.$_n.test(g)&&a){const y=this.i(h[g],r,!1,d);D[g]=y.raw,$=$||y.hasExcludedProperties,b.push(...y.restricted)}else{const y=r[g],P=y?typeof y.scope<"u"?y.scope:3:void 0;y?.restricted&&b.push(g),!d.exclude?.includes(g)&&(d.include?.includes(g)||(P===void 0||d.scopes===void 0||d.scopes.includes(P))&&!(d.skipRestricted&&y?.restricted))?D[g]=h[g]:$=!0}return{raw:D,restricted:b,hasExcludedProperties:$}}j(h,r){const a=[];for(const d of Object.keys(h))if(C.$_n.test(d)){const $={};for(const D in h[d])$[D]=h[d][D];a.push({identifiers:(0,C.$ao)(d),keys:Object.keys($),contents:(0,M.$Qi)($,r)})}return a}}e.$go=u;class m extends A.$Tc{constructor(h,r,a,d){super(),this.c=h,this.f=r,this.g=d,this.b=this.B(new j.$5d),this.onDidChange=this.b.event,this.a=new u(this.c.toString()),this.B(this.g.watch(a.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(j.Event.any(j.Event.filter(this.g.onDidFilesChange,$=>$.contains(this.c)),j.Event.filter(this.g.onDidRunOperation,$=>($.isOperation(0)||$.isOperation(3)||$.isOperation(1)||$.isOperation(4))&&a.isEqual($.resource,h)))(()=>this.b.fire()))}async loadConfiguration(){try{const h=await this.g.readFile(this.c);return this.a.parse(h.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new k}}reparse(h){return h&&(this.f=h),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$ho=m;class o{constructor(h,r,a,d,$,D,b,g,y,P,N,U,z){this.a=h,this.b=r,this.c=a,this.overrideIdentifiers=d,this.d=$,this.f=D,this.g=b,this.h=g,this.i=y,this.j=P,this.k=N,this.l=U,this.m=z}get value(){return S(this.c)}n(h){return h?.value!==void 0||h?.override!==void 0||h?.overrides!==void 0?h:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class i{constructor(h,r,a,d,$=new k,D=new k,b=new R.$Ac,g=new k,y=new R.$Ac){this.c=h,this.d=r,this.f=a,this.g=d,this.h=$,this.i=D,this.j=b,this.l=g,this.m=y,this.a=null,this.b=new R.$Ac,this.n=null}getValue(h,r,a){return this.p(h,r,a).getValue(h)}updateValue(h,r,a={}){let d;a.resource?(d=this.m.get(a.resource),d||(d=new k,this.m.set(a.resource,d))):d=this.l,r===void 0?d.removeValue(h):d.setValue(h,r),a.resource||(this.a=null)}inspect(h,r,a){const d=this.p(h,r,a),$=this.t(r.resource,a),D=r.resource?this.m.get(r.resource)||this.l:this.l,b=new Set;for(const g of d.overrides)for(const y of g.identifiers)d.getOverrideValue(h,y)!==void 0&&b.add(y);return new o(h,r,d.getValue(h),b.size?[...b]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,a?this.i:void 0,$||void 0,D)}keys(h){const r=this.t(void 0,h);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:r?r.keys.slice(0):[]}}updateDefaultConfiguration(h){this.c=h,this.a=null,this.b.clear()}updatePolicyConfiguration(h){this.d=h}updateApplicationConfiguration(h){this.f=h,this.a=null,this.b.clear()}updateLocalUserConfiguration(h){this.g=h,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(h){this.h=h,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(h){this.i=h,this.a=null,this.b.clear()}updateFolderConfiguration(h,r){this.j.set(h,r),this.b.delete(h)}deleteFolderConfiguration(h){this.folderConfigurations.delete(h),this.b.delete(h)}compareAndUpdateDefaultConfiguration(h,r){const a=[];if(!r){const{added:d,updated:$,removed:D}=c(this.c,h);r=[...d,...$,...D]}for(const d of r)for(const $ of(0,C.$ao)(d)){const D=this.c.getKeysForOverrideIdentifier($),b=h.getKeysForOverrideIdentifier($),g=[...b.filter(y=>D.indexOf(y)===-1),...D.filter(y=>b.indexOf(y)===-1),...D.filter(y=>!p.$On(this.c.override($).getValue(y),h.override($).getValue(y)))];a.push([$,g])}return this.updateDefaultConfiguration(h),{keys:r,overrides:a}}compareAndUpdatePolicyConfiguration(h){const{added:r,updated:a,removed:d}=c(this.d,h),$=[...r,...a,...d];return $.length&&this.updatePolicyConfiguration(h),{keys:$,overrides:[]}}compareAndUpdateApplicationConfiguration(h){const{added:r,updated:a,removed:d,overrides:$}=c(this.applicationConfiguration,h),D=[...r,...a,...d];return D.length&&this.updateApplicationConfiguration(h),{keys:D,overrides:$}}compareAndUpdateLocalUserConfiguration(h){const{added:r,updated:a,removed:d,overrides:$}=c(this.localUserConfiguration,h),D=[...r,...a,...d];return D.length&&this.updateLocalUserConfiguration(h),{keys:D,overrides:$}}compareAndUpdateRemoteUserConfiguration(h){const{added:r,updated:a,removed:d,overrides:$}=c(this.remoteUserConfiguration,h),D=[...r,...a,...d];return D.length&&this.updateRemoteUserConfiguration(h),{keys:D,overrides:$}}compareAndUpdateWorkspaceConfiguration(h){const{added:r,updated:a,removed:d,overrides:$}=c(this.workspaceConfiguration,h),D=[...r,...a,...d];return D.length&&this.updateWorkspaceConfiguration(h),{keys:D,overrides:$}}compareAndUpdateFolderConfiguration(h,r){const a=this.folderConfigurations.get(h),{added:d,updated:$,removed:D,overrides:b}=c(a,r),g=[...d,...$,...D];return(g.length||!a)&&this.updateFolderConfiguration(h,r),{keys:g,overrides:b}}compareAndDeleteFolderConfiguration(h){const r=this.folderConfigurations.get(h);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(h);const{added:a,updated:d,removed:$,overrides:D}=c(r,void 0);return{keys:[...a,...d,...$],overrides:D}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(h,r,a){let d=this.q(r,a);return r.overrideIdentifier&&(d=d.override(r.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(h)!==void 0&&(d=d.merge(this.d)),d}q({resource:h},r){let a=this.r();if(r&&h){const d=r.getFolder(h);d&&(a=this.s(d.uri)||a);const $=this.m.get(h);$&&(a=a.merge($))}return a}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(h){let r=this.b.get(h);if(!r){const a=this.r(),d=this.j.get(h);d?(r=a.merge(d),this.b.set(h,r)):r=a}return r}t(h,r){if(r&&h){const a=r.getFolder(h);if(a)return this.j.get(a.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((h,r)=>{const{contents:a,overrides:d,keys:$}=this.j.get(r);return h.push([r,{contents:a,overrides:d,keys:$}]),h},[])}}allKeys(){const h=new Set;return this.c.keys.forEach(r=>h.add(r)),this.userConfiguration.keys.forEach(r=>h.add(r)),this.i.keys.forEach(r=>h.add(r)),this.j.forEach(r=>r.keys.forEach(a=>h.add(a))),[...h.values()]}u(){const h=new Set;return this.c.getAllOverrideIdentifiers().forEach(r=>h.add(r)),this.userConfiguration.getAllOverrideIdentifiers().forEach(r=>h.add(r)),this.i.getAllOverrideIdentifiers().forEach(r=>h.add(r)),this.j.forEach(r=>r.getAllOverrideIdentifiers().forEach(a=>h.add(a))),[...h.values()]}v(h){const r=new Set;return this.c.getKeysForOverrideIdentifier(h).forEach(a=>r.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(h).forEach(a=>r.add(a)),this.i.getKeysForOverrideIdentifier(h).forEach(a=>r.add(a)),this.j.forEach(a=>a.getKeysForOverrideIdentifier(h).forEach(d=>r.add(d))),[...r.values()]}static parse(h){const r=this.w(h.defaults),a=this.w(h.policy),d=this.w(h.application),$=this.w(h.user),D=this.w(h.workspace),b=h.folders.reduce((g,y)=>(g.set(E.URI.revive(y[0]),this.w(y[1])),g),new R.$Ac);return new i(r,a,d,$,new k,D,b,new k,new R.$Ac)}static w(h){return new k(h.contents,h.keys,h.overrides)}}e.$io=i;function n(...f){if(f.length===0)return{keys:[],overrides:[]};if(f.length===1)return f[0];const h=new Set,r=new Map;for(const d of f)d.keys.forEach($=>h.add($)),d.overrides.forEach(([$,D])=>{const b=(0,R.$xc)(r,$,new Set);D.forEach(g=>b.add(g))});const a=[];return r.forEach((d,$)=>a.push([$,[...d.values()]])),{keys:[...h.values()],overrides:a}}e.$jo=n;class s{constructor(h,r,a,d){this.change=h,this.f=r,this.g=a,this.h=d,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const $ of h.keys)this.affectedKeys.add($);for(const[,$]of h.overrides)for(const D of $)this.affectedKeys.add(D);this.d=this.a;for(const $ of this.affectedKeys)this.d+=$+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=i.parse(this.f.data)),this.i}affectsConfiguration(h,r){const a=this.a+h,d=this.d.indexOf(a);if(d<0)return!1;const $=d+a.length;if($>=this.d.length)return!1;const D=this.d.charCodeAt($);if(D!==this.b&&D!==this.c)return!1;if(r){const b=this.previousConfiguration?this.previousConfiguration.getValue(h,r,this.f?.workspace):void 0,g=this.g.getValue(h,r,this.h);return!p.$On(b,g)}return!0}}e.$ko=s;function c(f,h){const{added:r,removed:a,updated:d}=t(h?.rawConfiguration,f?.rawConfiguration),$=[],D=f?.getAllOverrideIdentifiers()||[],b=h?.getAllOverrideIdentifiers()||[];if(h){const g=b.filter(y=>!D.includes(y));for(const y of g)$.push([y,h.getKeysForOverrideIdentifier(y)])}if(f){const g=D.filter(y=>!b.includes(y));for(const y of g)$.push([y,f.getKeysForOverrideIdentifier(y)])}if(h&&f){for(const g of D)if(b.includes(g)){const y=t({contents:f.getOverrideValue(void 0,g)||{},keys:f.getKeysForOverrideIdentifier(g)},{contents:h.getOverrideValue(void 0,g)||{},keys:h.getKeysForOverrideIdentifier(g)});$.push([g,[...y.added,...y.removed,...y.updated]])}}return{added:r,removed:a,updated:d,overrides:$}}function t(f,h){const r=f?h?f.keys.filter($=>h.keys.indexOf($)===-1):[...f.keys]:[],a=h?f?h.keys.filter($=>f.keys.indexOf($)===-1):[...h.keys]:[],d=[];if(f&&h){for(const $ of h.keys)if(f.keys.indexOf($)!==-1){const D=(0,M.$Ti)(h.contents,$),b=(0,M.$Ti)(f.contents,$);p.$On(D,b)||d.push($)}}return{added:r,removed:a,updated:d}}}),define(Se[261],De([1,0,21,4,3,81]),function(fe,e,l,j,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ytb=e.$xtb=e.$wtb=e.$vtb=void 0;const R=(E,M,C)=>{const v=new Uint8Array(16);for(let u=0;u<16;u++)v[u]=Math.round(Math.random()*256);const S=(0,l.$Me)(l.$se.wrap(v));return[`GET ws://localhost${E}?${M}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${S}`].join(`\r
`)+`\r
\r
`};e.$vtb=R,e.$wtb=l.$se.fromString(`\r
\r
`);async function p(E,M,C,v,S){E.write(l.$se.fromString((0,e.$vtb)(M,C,v)));const k=new L.$Sc;try{return await new Promise((u,m)=>{let o;k.add(E.onData(i=>{o?o=l.$se.concat([o,i],o.byteLength+i.byteLength):o=i;const n=o.indexOf(e.$wtb);if(n===-1)return;u(E),E.pauseData();const s=o.slice(n+e.$wtb.byteLength);s.byteLength&&S.onData.fire(s)})),k.add(E.onClose(i=>m(i??new Error("socket closed")))),k.add(E.onEnd(()=>m(new Error("socket ended"))))})}catch(u){throw E.dispose(),u}finally{k.dispose()}}e.$xtb=p;class w extends L.$Tc{constructor(M,C){super(),this.g=M,this.a=this.B(new j.$8d),this.onData=(...v)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...v)),this.b=this.B(new j.$5d),this.onDidDispose=this.b.event,this.f=!1,this.B(C.onData),this.B(C.onData.event(v=>this.a.fire(v))),this.onClose=this.B(C.onClose).event,this.onEnd=this.B(C.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(M,C){A.SocketDiagnostics.traceSocketEvent(this,this.g,M,C)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$ytb=w}),define(Se[64],De([1,0,13,5]),function(fe,e,l,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ol=e.$nl=e.RemoteAuthorityResolverErrorCode=e.$ml=e.$ll=e.RemoteConnectionType=e.$kl=void 0,e.$kl=(0,j.$fi)("remoteAuthorityResolverService");var L;(function(M){M[M.WebSocket=0]="WebSocket",M[M.Managed=1]="Managed"})(L||(e.RemoteConnectionType=L={}));class A{constructor(C){this.id=C,this.type=1}toString(){return`Managed(${this.id})`}}e.$ll=A;class R{constructor(C,v){this.host=C,this.port=v,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$ml=R;var p;(function(M){M.Unknown="Unknown",M.NotAvailable="NotAvailable",M.TemporarilyNotAvailable="TemporarilyNotAvailable",M.NoResolverFound="NoResolverFound",M.InvalidAuthority="InvalidAuthority"})(p||(e.RemoteAuthorityResolverErrorCode=p={}));class w extends l.$bb{static isNotAvailable(C){return C instanceof w&&C._code===p.NotAvailable}static isTemporarilyNotAvailable(C){return C instanceof w&&C._code===p.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof w&&C._code===p.NoResolverFound}static isInvalidAuthority(C){return C instanceof w&&C._code===p.InvalidAuthority}static isHandled(C){return C instanceof w&&C.isHandled}constructor(C,v=p.Unknown,S){super(C),this._message=C,this._code=v,this._detail=S,this.isHandled=v===p.NotAvailable&&S===!0,Object.setPrototypeOf(this,w.prototype)}}e.$nl=w;function E(M){const C=M.indexOf("+");return C===-1?M:M.substring(0,C)}e.$ol=E}),define(Se[262],De([1,0,8,21,22,13,4,3,15,58,38,30,81,64]),function(fe,e,l,j,L,A,R,p,w,E,M,C,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.PersistentConnectionEventType=e.$vl=e.$ul=e.$tl=e.ConnectionType=void 0;const k=30*1e3;var u;(function(re){re[re.Management=1]="Management",re[re.ExtensionHost=2]="ExtensionHost",re[re.Tunnel=3]="Tunnel"})(u||(e.ConnectionType=u={}));function m(re){switch(re){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function o(re){const B=new L.$ce;return setTimeout(()=>B.cancel(),re),B.token}function i(re,B){if(re.isCancellationRequested||B.isCancellationRequested)return L.CancellationToken.Cancelled;const ie=new L.$ce;return re.onCancellationRequested(()=>ie.cancel()),B.onCancellationRequested(()=>ie.cancel()),ie.token}class n{get didTimeout(){return this.c==="timedout"}constructor(B){this.c="pending",this.d=new p.$Sc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,l.$$g)(),B.isCancellationRequested?this.h():this.d.add(B.onCancellationRequested(()=>this.h()))}registerDisposable(B){this.c==="pending"?this.d.add(B):B.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const B=new Error("Time limit reached");return B.code="ETIMEDOUT",B.syscall="connect",B}resolve(B){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(B))}reject(B){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(B))}}function s(re,B){const ie=new n(B);return ie.registerDisposable(re.onControlMessage(ye=>{const le=JSON.parse(ye.toString()),ue=X(le);ue?ie.reject(ue):ie.resolve(le)})),ie.promise}function c(re,B,ie,ye,le,ue,ce,de){const H=new n(de),Z=M.$1d.create(!1);return re.info(`Creating a socket (${ce})...`),E.mark(`code/willCreateSocket/${ue}`),B.connect(ie,ye,le,ce).then(he=>{H.didTimeout?(E.mark(`code/didCreateSocketError/${ue}`),re.info(`Creating a socket (${ce}) finished after ${Z.elapsed()} ms, but this is too late and has timed out already.`),he?.dispose()):(E.mark(`code/didCreateSocketOK/${ue}`),re.info(`Creating a socket (${ce}) was successful after ${Z.elapsed()} ms.`),H.resolve(he))},he=>{E.mark(`code/didCreateSocketError/${ue}`),re.info(`Creating a socket (${ce}) returned an error after ${Z.elapsed()} ms.`),re.error(he),H.reject(he)}),H.promise}function t(re,B){const ie=new n(B);return re.then(ye=>{ie.didTimeout||ie.resolve(ye)},ye=>{ie.didTimeout||ie.reject(ye)}),ie.promise}async function f(re,B,ie,ye){const le=ge(re,B);re.logService.trace(`${le} 1/6. invoking socketFactory.connect().`);let ue;try{ue=await c(re.logService,re.remoteSocketFactoryService,re.connectTo,w.$sg.getServerRootPath(),`reconnectionToken=${re.reconnectionToken}&reconnection=${re.reconnectionProtocol?"true":"false"}`,m(B),`renderer-${m(B)}-${re.reconnectionToken}`,ye)}catch(he){throw re.logService.error(`${le} socketFactory.connect() failed or timed out. Error:`),re.logService.error(he),he}re.logService.trace(`${le} 2/6. socketFactory.connect() was successful.`);let ce,de;re.reconnectionProtocol?(re.reconnectionProtocol.beginAcceptReconnection(ue,null),ce=re.reconnectionProtocol,de=!1):(ce=new v.$6h({socket:ue}),de=!0),re.logService.trace(`${le} 3/6. sending AuthRequest control message.`);const H=await t(re.signService.createNewMessage((0,C.$Bg)()),ye),Z={type:"auth",auth:re.connectionToken||"00000000000000000000",data:H.data};ce.sendControl(j.$se.fromString(JSON.stringify(Z)));try{const he=await s(ce,i(ye,o(1e4)));if(he.type!=="sign"||typeof he.data!="string"){const Ae=new Error("Unexpected handshake message");throw Ae.code="VSCODE_CONNECTION_ERROR",Ae}if(re.logService.trace(`${le} 4/6. received SignRequest control message.`),!await t(re.signService.validate(H,he.signedData),ye)){const Ae=new Error("Refused to connect to unsupported server");throw Ae.code="VSCODE_CONNECTION_ERROR",Ae}const Pe=await t(re.signService.sign(he.data),ye),pe={type:"connectionType",commit:re.commit,signedData:Pe,desiredConnectionType:B};return ie&&(pe.args=ie),re.logService.trace(`${le} 5/6. sending ConnectionTypeRequest control message.`),ce.sendControl(j.$se.fromString(JSON.stringify(pe))),{protocol:ce,ownsProtocol:de}}catch(he){throw he&&he.code==="ETIMEDOUT"&&(re.logService.error(`${le} the handshake timed out. Error:`),re.logService.error(he)),he&&he.code==="VSCODE_CONNECTION_ERROR"&&(re.logService.error(`${le} received error control message when negotiating connection. Error:`),re.logService.error(he)),de&&x(ce),he}}async function h(re,B,ie,ye){const le=Date.now(),ue=ge(re,B),{protocol:ce,ownsProtocol:de}=await f(re,B,ie,ye),H=new n(ye);return H.registerDisposable(ce.onControlMessage(Z=>{const he=JSON.parse(Z.toString()),be=X(he);be?(re.logService.error(`${ue} received error control message when negotiating connection. Error:`),re.logService.error(be),de&&x(ce),H.reject(be)):(re.reconnectionProtocol?.endAcceptReconnection(),re.logService.trace(`${ue} 6/6. handshake finished, connection is up and running after ${se(le)}!`),H.resolve({protocol:ce,firstMessage:he}))})),H.promise}async function r(re,B){const{protocol:ie}=await h(re,1,void 0,B);return{protocol:ie}}async function a(re,B,ie){const{protocol:ye,firstMessage:le}=await h(re,2,B,ie),ue=le&&le.debugPort;return{protocol:ye,debugPort:ue}}async function d(re,B,ie){const ye=Date.now(),le=ge(re,3),{protocol:ue}=await f(re,3,B,ie);return re.logService.trace(`${le} 6/6. handshake finished, connection is up and running after ${se(ye)}!`),ue}async function $(re,B,ie){const{connectTo:ye,connectionToken:le}=await re.addressProvider.getAddress();return{commit:re.commit,quality:re.quality,connectTo:ye,connectionToken:le,reconnectionToken:B,reconnectionProtocol:ie,remoteSocketFactoryService:re.remoteSocketFactoryService,signService:re.signService,logService:re.logService}}async function D(re,B,ie){return g(re,async ye=>{const{protocol:le}=await r(ye,L.CancellationToken.None);return new G(re,B,ie,ye.reconnectionToken,le)})}e.$tl=D;async function b(re,B){return g(re,async ie=>{const{protocol:ye,debugPort:le}=await a(ie,B,L.CancellationToken.None);return new te(re,B,ie.reconnectionToken,ye,le)})}e.$ul=b;async function g(re,B){for(let ye=1;;ye++)try{const le=(0,C.$Bg)(),ue=await $(re,le,null);return await B(ue)}catch(le){if(ye<5)re.logService.error(`[remote-connection][attempt ${ye}] An error occurred in initial connection! Will retry... Error:`),re.logService.error(le);else throw re.logService.error(`[remote-connection][attempt ${ye}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),re.logService.error(le),T.triggerPermanentFailure(0,0,S.$nl.isHandled(le)),le}}async function y(re,B,ie){const ye=await $(re,(0,C.$Bg)(),null);return await d(ye,{host:B,port:ie},L.CancellationToken.None)}e.$vl=y;function P(re){return(0,l.$5g)(B=>new Promise((ie,ye)=>{const le=setTimeout(ie,re*1e3);B.onCancellationRequested(()=>{clearTimeout(le),ie()})}))}var N;(function(re){re[re.ConnectionLost=0]="ConnectionLost",re[re.ReconnectionWait=1]="ReconnectionWait",re[re.ReconnectionRunning=2]="ReconnectionRunning",re[re.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",re[re.ConnectionGain=4]="ConnectionGain"})(N||(e.PersistentConnectionEventType=N={}));class U{constructor(B,ie){this.reconnectionToken=B,this.millisSinceLastIncomingData=ie,this.type=0}}e.$wl=U;class z{constructor(B,ie,ye,le){this.reconnectionToken=B,this.millisSinceLastIncomingData=ie,this.durationSeconds=ye,this.c=le,this.type=1}skipWait(){this.c.cancel()}}e.$xl=z;class F{constructor(B,ie,ye){this.reconnectionToken=B,this.millisSinceLastIncomingData=ie,this.attempt=ye,this.type=2}}e.$yl=F;class I{constructor(B,ie,ye){this.reconnectionToken=B,this.millisSinceLastIncomingData=ie,this.attempt=ye,this.type=4}}e.$zl=I;class O{constructor(B,ie,ye,le){this.reconnectionToken=B,this.millisSinceLastIncomingData=ie,this.attempt=ye,this.handled=le,this.type=3}}e.$Al=O;class T extends p.$Tc{static triggerPermanentFailure(B,ie,ye){this._permanentFailure=!0,this.f=B,this.g=ie,this.h=ye,this.j.forEach(le=>le.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(B=>B.y())}static debugPauseSocketWriting(){this.j.forEach(B=>B.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||T._permanentFailure}constructor(B,ie,ye,le,ue){super(),this.t=B,this.u=ie,this.reconnectionToken=ye,this.protocol=le,this.w=ue,this.m=this.B(new R.$5d),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new I(this.reconnectionToken,0,0)),this.B(le.onSocketClose(ce=>{const de=_(this.t,this.reconnectionToken,!0);ce?ce.type===0?(this.u.logService.info(`${de} received socket close event (hadError: ${ce.hadError}).`),ce.error&&this.u.logService.error(ce.error)):(this.u.logService.info(`${de} received socket close event (wasClean: ${ce.wasClean}, code: ${ce.code}, reason: ${ce.reason}).`),ce.event&&this.u.logService.error(ce.event)):this.u.logService.info(`${de} received socket close event.`),this.y()})),this.B(le.onSocketTimeout(ce=>{const de=_(this.t,this.reconnectionToken,!0);this.u.logService.info(`${de} received socket timeout event (unacknowledgedMsgCount: ${ce.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ce.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ce.timeSinceLastReceivedSomeData}).`),this.y()})),T.j.push(this),this.B((0,p.$Rc)(()=>{const ce=T.j.indexOf(this);ce>=0&&T.j.splice(ce,1)})),this.n&&this.D(T.f,T.g,T.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const B=_(this.t,this.reconnectionToken,!0);this.u.logService.info(`${B} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const ie=[0,5,5,10,10,10,10,10,30];let ye=-1;do{ye++;const le=ye<ie.length?ie[ye]:ie[ie.length-1];try{if(le>0){const ce=P(le);this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),le,ce)),this.u.logService.info(`${B} waiting for ${le} seconds before reconnecting...`);try{await ce}catch{}}if(this.n){this.u.logService.error(`${B} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ye+1)),this.u.logService.info(`${B} resolving connection...`);const ue=await $(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${B} connecting to ${ue.connectTo}...`),await this.G(ue,o(k)),this.u.logService.info(`${B} reconnected!`),this.m.fire(new I(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ye+1));break}catch(ue){if(ue.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${B} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(ue),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,!1);break}if(ye>360){this.u.logService.error(`${B} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(ue),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,!1);break}if(S.$nl.isTemporarilyNotAvailable(ue)){this.u.logService.info(`${B} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ue);continue}if((ue.code==="ETIMEDOUT"||ue.code==="ENETUNREACH"||ue.code==="ECONNREFUSED"||ue.code==="ECONNRESET")&&ue.syscall==="connect"){this.u.logService.info(`${B} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ue);continue}if((0,A.$4)(ue)){this.u.logService.info(`${B} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ue);continue}if(ue instanceof S.$nl){this.u.logService.error(`${B} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(ue),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,S.$nl.isHandled(ue));break}this.u.logService.error(`${B} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(ue),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,!1);break}}while(!this.n&&!this.s)}C(B,ie,ye){this.w?T.triggerPermanentFailure(B,ie,ye):this.D(B,ie,ye)}D(B,ie,ye){this.m.fire(new O(this.reconnectionToken,B,ie,ye)),x(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$Bl=T;class G extends T{constructor(B,ie,ye,le,ue){super(1,B,le,ue,!0),this.client=this.B(new v.$4h(ue,{remoteAuthority:ie,clientId:ye},B.ipcLogger))}async G(B,ie){await r(B,ie)}}e.$Cl=G;class te extends T{constructor(B,ie,ye,le,ue){super(2,B,ye,le,!1),this.H=ie,this.debugPort=ue}async G(B,ie){await a(B,this.H,ie)}}e.$Dl=te;function x(re){try{re.acceptDisconnect();const B=re.getSocket();re.dispose(),B.dispose()}catch(B){(0,A.$1)(B)}}function X(re){if(re&&re.type==="error"){const B=new Error(`Connection error: ${re.reason}`);return B.code="VSCODE_CONNECTION_ERROR",B}return null}function Q(re,B){for(;re.length<B;)re+=" ";return re}function ae(re,B){return`[remote-connection][${Q(m(re),13)}][${B.substr(0,5)}\u2026]`}function _(re,B,ie){return`${ae(re,B)}[${ie?"reconnect":"initial"}]`}function ge(re,B){return`${_(B,re.reconnectionToken,!!re.reconnectionProtocol)}[${re.connectTo}]`}function se(re){return`${Date.now()-re} ms`}}),define(Se[86],De([1,0,15]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=e.$rm=e.$qm=e.$pm=void 0;function j(w){return w.scheme===l.Schemas.vscodeRemote?w.authority:void 0}e.$pm=j;function L(w){if(!w)return;const E=w.indexOf("+");return E<0?w:w.substr(0,E)}e.$qm=L;function A(w){const{host:E,port:M}=p(w);if(typeof M>"u")throw new Error(`Invalid remote authority: ${w}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:E,port:M}}e.$rm=A;function R(w,E){let{host:M,port:C}=p(w);return typeof C>"u"&&(C=E),{host:M,port:C}}e.$sm=R;function p(w){const E=w.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(E)return{host:E[1],port:parseInt(E[2],10)};const M=w.match(/^(\[[0-9a-z:]+\])$/);if(M)return{host:M[1],port:void 0};const C=w.match(/(.*):(\d+)$/);return C?{host:C[1],port:parseInt(C[2],10)}:{host:w,port:void 0}}}),define(Se[25],De([1,0,14,5,86]),function(fe,e,l,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gm=e.$Fm=e.$Em=e.$Dm=e.$Cm=e.$Bm=e.$Am=e.$zm=e.TargetPlatform=e.ExtensionType=e.$ym=e.$xm=e.$wm=e.$vm=e.$um=e.$tm=void 0,e.$tm="extensions.user.cache",e.$um="extensions.builtin.cache",e.$vm="undefined_publisher",e.$wm=["ui","workspace","web"];function A(u){if(typeof u=="object"&&u!==null&&u.supported!==!0)return u.description}e.$xm=A,e.$ym=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var R;(function(u){u[u.System=0]="System",u[u.User=1]="User"})(R||(e.ExtensionType=R={}));var p;(function(u){u.WIN32_X64="win32-x64",u.WIN32_ARM64="win32-arm64",u.LINUX_X64="linux-x64",u.LINUX_ARM64="linux-arm64",u.LINUX_ARMHF="linux-armhf",u.ALPINE_X64="alpine-x64",u.ALPINE_ARM64="alpine-arm64",u.DARWIN_X64="darwin-x64",u.DARWIN_ARM64="darwin-arm64",u.WEB="web",u.UNIVERSAL="universal",u.UNKNOWN="unknown",u.UNDEFINED="undefined"})(p||(e.TargetPlatform=p={}));class w{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,o){if(typeof m>"u"||m===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof m=="string"||typeof o=="string"){const i=typeof m=="string"?m:m.value,n=typeof o=="string"?o:o.value;return l.$jf(i,n)}return m._lower===o._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.$zm=w;class E{get size(){return this.c.size}constructor(m){if(this.c=new Set,m)for(const o of m)this.add(o)}add(m){this.c.add(w.toKey(m))}delete(m){return this.c.delete(w.toKey(m))}has(m){return this.c.has(w.toKey(m))}}e.$Am=E;class M{constructor(){this.c=new Map}clear(){this.c.clear()}delete(m){this.c.delete(w.toKey(m))}get(m){return this.c.get(w.toKey(m))}has(m){return this.c.has(w.toKey(m))}set(m,o){this.c.set(w.toKey(m),o)}values(){return this.c.values()}forEach(m){this.c.forEach(m)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Bm=M;function C(u){return v(u)}e.$Cm=C;function v(u){return u.contributes&&u.contributes.localizations?u.contributes.localizations.length>0:!1}e.$Dm=v;function S(u){return u.contributes&&u.contributes.authentication?u.contributes.authentication.length>0:!1}e.$Em=S;function k(u,m){if(m){const o=`onResolveRemoteAuthority:${(0,L.$qm)(m)}`;return!!u.activationEvents?.includes(o)}return!1}e.$Fm=k,e.$Gm=(0,j.$fi)("IBuiltinExtensionsScannerService")}),define(Se[140],De([1,0,13,25]),function(fe,e,l,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DF=e.$CF=void 0;class L{constructor(){this.a=new Map,this.b=new WeakMap}register(R,p){this.a.set(R,p)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const p=Object.create(null);for(const w of R){const E=this.readActivationEvents(w);E.length>0&&(p[j.$zm.toKey(w.identifier)]=E)}return p}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const p=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let w=0;w<p.length;w++)p[w]==="onUri"&&(p[w]=`onUri:${j.$zm.toKey(R.identifier)}`);if(!R.contributes)return p;for(const w in R.contributes){const E=this.a.get(w);if(!E)continue;const M=R.contributes[w],C=Array.isArray(M)?M:[M];try{E(C,p)}catch(v){(0,l.$1)(v)}}return p}}e.$CF=L,e.$DF=new L}),define(Se[263],De([1,0,3,5]),function(fe,e,l,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ql=e.$pl=void 0,e.$pl=(0,j.$fi)("remoteSocketFactoryService");class L{constructor(){this.a={}}register(R,p){return this.a[R]??=[],this.a[R].push(p),(0,l.$Rc)(()=>{const w=this.a[R]?.indexOf(p);typeof w=="number"&&w>=0&&this.a[R]?.splice(w,1)})}b(R){return(this.a[R.type]||[]).find(w=>w.supports(R))}connect(R,p,w,E){const M=this.b(R);if(!M)throw new Error(`No socket factory found for ${R}`);return M.connect(R,p,w,E)}}e.$ql=L}),define(Se[264],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O8b=void 0;class l{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(L){try{const A=await this.c();if(A){const R=String(l.a++);return this.b.set(R,A),{id:R,data:A.createNewMessage(L)}}}catch{}return{id:"",data:L}}async validate(L,A){if(!L.id)return!0;const R=this.b.get(L.id);if(!R)return!1;this.b.delete(L.id);try{return R.validate(A)==="ok"}catch{return!1}finally{R.dispose?.()}}async sign(L){try{return await this.d(L)}catch{}return L}}e.$O8b=l}),define(Se[110],De([1,0,5]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sl=e.$rl=void 0,e.$rl="signService",e.$sl=(0,l.$fi)(e.$rl)}),define(Se[141],De([1,0,264]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iac=void 0;class j extends l.$O8b{c(){return this.h().then(A=>new A.validator)}d(A){return this.h().then(R=>new R.signer().sign(A))}h(){return new Promise((A,R)=>fe(["vsda"],A,R))}}e.$Iac=j}),define(Se[265],De([1,0,11,50,30]),function(fe,e,l,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yo=e.$Xo=void 0;function A(w){if(l.$u===2&&/^penguin(\.|$)/i.test(w))return"chromebook"}function R(w,E,M,C,v,S,k,u,m){const o=Object.create(null);o["common.machineId"]=S,o["common.sqmId"]=k,o.sessionID=(0,L.$Bg)()+Date.now(),o.commitHash=C,o.version=v,o["common.platformVersion"]=(w||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),o["common.platform"]=(0,l.$h)(l.$u),o["common.nodePlatform"]=j.$dc,o["common.nodeArch"]=M,o["common.product"]=m||"desktop",u&&(o["common.msftInternal"]=u);let i=0;const n=Date.now();Object.defineProperties(o,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),l.$l&&(o["common.snap"]="true");const s=A(E);return s&&(o["common.platformDetail"]=s),o}e.$Xo=R;function p(w){const E=j.env.USERDNSDOMAIN;if(!E)return!1;const M=E.toLowerCase();return w.some(C=>M===C)}e.$Yo=p}),define(Se[266],De([1,0,5]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Ol=e.$Nl=e.$Ml=e.$Ll=e.$Kl=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=e.$El=void 0,e.$El=(0,l.$fi)("telemetryService"),e.$Fl=(0,l.$fi)("customEndpointTelemetryService"),e.$Gl="telemetry.currentSessionDate",e.$Hl="telemetry.firstSessionDate",e.$Il="telemetry.lastSessionDate",e.$Jl="telemetry.machineId",e.$Kl="telemetry.sqmId",e.$Ll="telemetry",e.$Ml="telemetry.telemetryLevel",e.$Nl="telemetry.enableCrashReporter",e.$Ol="telemetry.enableTelemetry";var j;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(j||(e.TelemetryLevel=j={}));var L;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(L||(e.TelemetryConfiguration=L={}))}),define(Se[87],De([1,0,24,18,86,265,266]),function(fe,e,l,j,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=void 0;class p{constructor(f){this.value=f,this.isTrustedTelemetryValue=!0}}e.$Zo=p;class w{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$1o=w,e.$2o=new w;class E{async publicLog(f,h,r){}async publicLogError(f,h,r){}}e.$3o=E,e.$4o="telemetry",e.$5o="extensionTelemetryLog",e.$6o={log:()=>null,flush:()=>Promise.resolve(null)};function M(t,f){return!f.isBuilt&&!f.disableTelemetry?!0:!(f.disableTelemetry||!t.enableTelemetry)}e.$7o=M;function C(t,f){return f.extensionTestsLocationURI?!0:!(f.isBuilt||f.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.$8o=C;function v(t){const f=t.getValue(R.$Ml),h=t.getValue(R.$Nl);if(t.getValue(R.$Ol)===!1||h===!1)return 0;switch(f??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$9o=v;function S(t){const f={},h={},r={};m(t,r);for(let a in r){a=a.length>150?a.substr(a.length-149):a;const d=r[a];typeof d=="number"?h[a]=d:typeof d=="boolean"?h[a]=d?1:0:typeof d=="string"?(d.length>8192&&console.warn(`Telemetry property: ${a} has been trimmed to 8192, the original length is ${d.length}`),f[a]=d.substring(0,8191)):typeof d<"u"&&d!==null&&(f[a]=d)}return{properties:f,measurements:h}}e.$0o=S;const k=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function u(t){if(!t)return"none";const f=(0,L.$qm)(t);return k.has(f)?f:"other"}e.$$o=u;function m(t,f,h=0,r){if(t)for(const a of Object.getOwnPropertyNames(t)){const d=t[a],$=r?r+a:a;Array.isArray(d)?f[$]=(0,l.$Pn)(d):d instanceof Date?f[$]=d.toISOString():(0,j.$Uf)(d)?h<2?m(d,f,h+1,$+"."):f[$]=(0,l.$Pn)(d):f[$]=d}}function o(t,f){const h=t.msftInternalDomains||[],r=f.getValue("telemetry.internalTesting");return(0,A.$Yo)(h)||r}e.$_o=o;function i(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.$ap=i;function n(t,f){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let h=t;const r=[];for(const D of f)for(;;){const b=D.exec(t);if(!b)break;r.push([b.index,D.lastIndex])}const a=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,d=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let $=0;for(h="";;){const D=d.exec(t);if(!D)break;const b=r.some(([g,y])=>D.index<y&&g<d.lastIndex);!a.test(D[0])&&!b&&(h+=t.substring($,D.index)+"<REDACTED: user-file-path>",$=d.lastIndex)}return $<t.length&&(h+=t.substr($)),h}function s(t){if(!t)return t;const f=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const h of f)if(h.regex.test(t))return`<REDACTED: ${h.label}>`;return t}function c(t,f){return(0,l.$Mn)(t,h=>{if(h instanceof p||Object.hasOwnProperty.call(h,"isTrustedTelemetryValue"))return h.value;if(typeof h=="string"){let r=h.replaceAll("%20"," ");r=n(r,f);for(const a of f)r=r.replace(a,"");return r=s(r),r}})}e.$bp=c}),define(Se[267],De([1,0,14,137,25,11,2,13,50,87]),function(fe,e,l,j,L,A,R,p,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$np=e.$mp=e.$lp=e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=void 0;function M(h,r){return h.uuid&&r.uuid?h.uuid===r.uuid:h.id===r.id?!0:(0,l.$ef)(h.id,r.id)===0}e.$cp=M;const C=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class v{static create(r){const a=r.manifest?r.manifest.version:r.version,d=r.manifest?r.targetPlatform:r.properties.targetPlatform;return new v(r.identifier,a,d)}static parse(r){const a=C.exec(r);return a&&a[1]&&a[2]?new v({id:a[1]},a[2],a[4]||void 0):null}constructor(r,a,d="undefined"){this.version=a,this.targetPlatform=d,this.id=r.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(r){return r instanceof v?M(this,r)&&this.version===r.version&&this.targetPlatform===r.targetPlatform:!1}}e.$dp=v;const S=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function k(h){const r=S.exec(h);return r&&r[1]?[m(r[1]),r[2]]:[m(h),void 0]}e.$ep=k;function u(h,r){return`${h}.${r}`}e.$fp=u;function m(h){return h.toLowerCase()}e.$gp=m;function o(h,r){return m(u(h??L.$vm,r))}e.$hp=o;function i(h,r){const a=[],d=$=>{for(const D of a)if(D.some(b=>M(r(b),r($))))return D;return null};for(const $ of h){const D=d($);D?D.push($):a.push([$])}return a}e.$ip=i;function n(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.$jp=n;function s(h){return{id:new E.$Zo(h.identifier.id),name:new E.$Zo(h.name),galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,isPreReleaseVersion:h.properties.isPreReleaseVersion,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),isSigned:h.isSigned,...h.telemetryData}}e.$kp=s,e.$lp=new L.$zm("pprice.better-merge");function c(h,r){const a=[],d=r.manifest.extensionDependencies?.slice(0)??[];for(;d.length;){const $=d.shift();if($&&a.every(D=>!M(D.identifier,{id:$}))){const D=h.filter(b=>M(b.identifier,{id:$}));D.length===1&&(a.push(D[0]),d.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return a}e.$mp=c;async function t(h,r){if(!A.$k)return!1;let a;try{a=(await h.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{a=(await h.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch($){r.debug("Error while getting the os-release file.",(0,p.$0)($))}}return!!a&&(a.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function f(h,r){const a=await t(h,r),d=(0,j.$Jo)(a?"alpine":A.$u,w.$ec);return r.debug("ComputeTargetPlatform:",d),d}e.$np=f}),define(Se[268],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6r=e.$5r=e.$4r=e.$3r=e.$2r=e.$1r=void 0;function l(w){return[...w.entries()]}e.$1r=l;function j(w){return w?[...w.entries()]:[]}e.$2r=j;function L(w){return new Map(w)}e.$3r=L;function A(w){return new Map(w??[])}e.$4r=A;function R(w){return Array.from(w.entries()).map(E=>[E[0],l(E[1].map),j(E[1].descriptionMap)])}e.$5r=R;function p(w){return new Map(w.map(E=>[E[0],{map:L(E[1]),descriptionMap:A(E[2])}]))}e.$6r=p}),define(Se[269],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ptb=void 0;class l{constructor(L){this.b=L,this.a=new Map}dispose(){for(const L of this.a.values())L.dispose()}startBuffering(L,A,R=5){const p=A(w=>{const E=typeof w=="string"?w:w.data;let M=this.a.get(L);if(M){M.data.push(E);return}const C=setTimeout(()=>this.flushBuffer(L),R);M={data:[E],timeoutId:C,dispose:()=>{clearTimeout(C),this.flushBuffer(L),p.dispose()}},this.a.set(L,M)});return p}stopBuffering(L){this.a.get(L)?.dispose()}flushBuffer(L){const A=this.a.get(L);A&&(this.a.delete(L),this.b(L,A.data.join("")))}}e.$Ptb=l}),define(Se[270],De([1,0,8,77,99,55,4,18,2,212,109,37]),function(fe,e,l,j,L,A,R,p,w,E,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tw=e.$Sw=e.$Rw=e.$Qw=e.$Pw=e.$Ow=e.$Nw=e.$Mw=e.IconFontDefinition=e.IconContribution=e.$Lw=void 0,e.$Lw={IconContribution:"base.contributions.icons"};var v;(function(c){function t(f,h){let r=f.defaults;for(;A.ThemeIcon.isThemeIcon(r);){const a=u.getIcon(r.id);if(!a)return;r=a.defaults}return r}c.getDefinition=t})(v||(e.IconContribution=v={}));var S;(function(c){function t(h){return{weight:h.weight,style:h.style,src:h.src.map(r=>({format:r.format,location:r.location.toString()}))}}c.toJSONObject=t;function f(h){const r=a=>(0,p.$Sf)(a)?a:void 0;if(h&&Array.isArray(h.src)&&h.src.every(a=>(0,p.$Sf)(a.format)&&(0,p.$Sf)(a.location)))return{weight:r(h.weight),style:r(h.style),src:h.src.map(a=>({format:a.format,location:w.URI.parse(a.location)}))}}c.fromJSONObject=f})(S||(e.IconFontDefinition=S={}));class k{constructor(){this.a=new R.$5d,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,E.localize)(0,null)},fontCharacter:{type:"string",description:(0,E.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${A.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,f,h,r){const a=this.b[t];if(a){if(h&&!a.description){a.description=h,this.d.properties[t].markdownDescription=`${h} $(${t})`;const D=this.e.enum.indexOf(t);D!==-1&&(this.e.enumDescriptions[D]=h),this.a.fire()}return a}const d={id:t,description:h,defaults:f,deprecationMessage:r};this.b[t]=d;const $={$ref:"#/definitions/icons"};return r&&($.deprecationMessage=r),h&&($.markdownDescription=`${h}: $(${t})`),this.d.properties[t]=$,this.e.enum.push(t),this.e.enumDescriptions.push(h||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const f=this.e.enum.indexOf(t);f!==-1&&(this.e.enum.splice(f,1),this.e.enumDescriptions.splice(f,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,f){const h=this.f[t];return h||(this.f[t]=f,this.a.fire(),f)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=(a,d)=>a.id.localeCompare(d.id),f=a=>{for(;A.ThemeIcon.isThemeIcon(a.defaults);)a=this.b[a.defaults.id];return`codicon codicon-${a?a.id:""}`},h=[];h.push("| preview     | identifier                        | default codicon ID                | description"),h.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const r=Object.keys(this.b).map(a=>this.b[a]);for(const a of r.filter(d=>!!d.description).sort(t))h.push(`|<i class="${f(a)}"></i>|${a.id}|${A.ThemeIcon.isThemeIcon(a.defaults)?a.defaults.id:a.id}|${a.description||""}|`);h.push("| preview     | identifier                        "),h.push("| ----------- | --------------------------------- |");for(const a of r.filter(d=>!A.ThemeIcon.isThemeIcon(d.defaults)).sort(t))h.push(`|<i class="${f(a)}"></i>|${a.id}|`);return h.join(`
`)}}const u=new k;C.$Wn.add(e.$Lw.IconContribution,u);function m(c,t,f,h){return u.registerIcon(c,t,f,h)}e.$Mw=m;function o(){return u}e.$Nw=o;function i(){const c=(0,L.$kk)();for(const t in c){const f="\\"+c[t].toString(16);u.registerIcon(t,{fontCharacter:f})}}i(),e.$Ow="vscode://schemas/icons";const n=C.$Wn.as(M.$Xn.JSONContribution);n.registerSchema(e.$Ow,u.getIconSchema());const s=new l.$rh(()=>n.notifySchemaChanged(e.$Ow),200);u.onDidChange(()=>{s.isScheduled()||s.schedule()}),e.$Pw=m("widget-close",j.$ok.close,(0,E.localize)(2,null)),e.$Qw=m("goto-previous-location",j.$ok.arrowUp,(0,E.localize)(3,null)),e.$Rw=m("goto-next-location",j.$ok.arrowDown,(0,E.localize)(4,null)),e.$Sw=A.ThemeIcon.modify(j.$ok.sync,"spin"),e.$Tw=A.ThemeIcon.modify(j.$ok.loading,"spin")}),define(Se[88],De([1,0,4,52,5,12]),function(fe,e,l,j,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zv=e.$Yv=e.$Xv=e.$Wv=e.$Vv=e.$Uv=e.$Tv=e.$Sv=e.ProvidedOnAutoForward=e.$Rv=e.TunnelPrivacyId=e.TunnelProtocol=e.$Qv=e.$Pv=void 0,e.$Pv=(0,L.$fi)("tunnelService"),e.$Qv=(0,L.$fi)("sharedTunnelsService");var R;(function(m){m.Http="http",m.Https="https"})(R||(e.TunnelProtocol=R={}));var p;(function(m){m.ConstantPrivate="constantPrivate",m.Private="private",m.Public="public"})(p||(e.TunnelPrivacyId=p={}));function w(m){return!!m.forwardPort}e.$Rv=w;var E;(function(m){m[m.Notify=1]="Notify",m[m.OpenBrowser=2]="OpenBrowser",m[m.OpenPreview=3]="OpenPreview",m[m.Silent=4]="Silent",m[m.Ignore=5]="Ignore",m[m.OpenBrowserOnce=6]="OpenBrowserOnce"})(E||(e.ProvidedOnAutoForward=E={}));function M(m){if(m.scheme!=="http"&&m.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(m.authority);if(o)return{address:o[1],port:+o[2]}}e.$Sv=M,e.$Tv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function C(m){return e.$Tv.indexOf(m)>=0}e.$Uv=C,e.$Vv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(m){return e.$Vv.indexOf(m)>=0}e.$Wv=v;function S(m,o,i,n){if(i===1)return!1;if(i===2&&v(o)){const s=/(\d+)\.(\d+)\.(\d+)/g.exec(n);if(s?.length===4&&parseInt(s[1])>=18)return!1}return m<1024}e.$Xv=S;class k{constructor(o,i,n){this.remoteAddress=o,this.localAddress=i,this.b=n,this.a=new l.$5d,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Yv=k;let u=class{constructor(o,i){this.k=o,this.l=i,this.a=new l.$5d,this.onTunnelOpened=this.a.event,this.b=new l.$5d,this.onTunnelClosed=this.b.event,this.c=new l.$5d,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const o=this.l.getValue("remote.localPortHost");return!o||o==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(o){return this.f=o,o?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(o){this.g=o.elevation,this.i=o.privacyOptions,this.h=o.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const o=[],i=Array.from(this.e.values());for(const n of i){const s=Array.from(n.values());for(const c of s){const t=await c.value;t&&typeof t!="string"&&o.push(t)}}return o}async dispose(){for(const o of this.e.values()){for(const{value:i}of o.values())await i.then(n=>typeof n!="string"?n?.dispose():void 0);o.clear()}this.e.clear()}setEnvironmentTunnel(o,i,n,s,c){this.q(o,i,Promise.resolve({tunnelRemoteHost:o,tunnelRemotePort:i,localAddress:n,privacy:s,protocol:c,dispose:()=>Promise.resolve()}))}async getExistingTunnel(o,i){(v(o)||C(o))&&(o=e.$Tv[0]);const n=this.s(o,i);if(n)return++n.refcount,n.value}openTunnel(o,i,n,s,c,t=!1,f,h){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${i}:${n} on local port ${c}.`);const r=this.f??o;if(!r)return;if(i||(i="localhost"),s||(s=this.m),this.f&&this.j.has(n)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const a=this.t(r,i,n,s,c,t,f,h);return a?a.then(d=>{if(d){if(typeof d=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(i,n),d}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(i,n);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const $=this.o(d);return(d.tunnelRemoteHost!==i||d.tunnelRemotePort!==n)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),f&&d.privacy!==f&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire($),$}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),a)}o(o){return{tunnelRemotePort:o.tunnelRemotePort,tunnelRemoteHost:o.tunnelRemoteHost,tunnelLocalPort:o.tunnelLocalPort,localAddress:o.localAddress,privacy:o.privacy,protocol:o.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${o.tunnelRemoteHost}:${o.tunnelRemotePort} `);const i=this.e.get(o.tunnelRemoteHost);if(i){const n=i.get(o.tunnelRemotePort);n&&(n.refcount--,await this.p(o.tunnelRemoteHost,o.tunnelRemotePort,n))}}}}async p(o,i,n){if(n.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${o}:${i}.`);const s=n.value.then(async c=>{c&&typeof c!="string"&&(await c.dispose(!0),this.b.fire({host:c.tunnelRemoteHost,port:c.tunnelRemotePort}))});return this.e.has(o)&&this.e.get(o).delete(i),s}}async closeTunnel(o,i){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${o}:${i} `);const n=this.e.get(o);if(n&&n.has(i)){const s=n.get(i);s.refcount=0,await this.p(o,i,s)}}q(o,i,n){this.e.has(o)||this.e.set(o,new Map),this.e.get(o).set(i,{refcount:1,value:n})}async r(o,i){const n=this.e.get(o);if(n){const s=n.get(i),c=s?await s.value:void 0;(!c||typeof c=="string")&&n.delete(i),n.size===0&&this.e.delete(o)}}s(o,i){const n=[o];C(o)?(n.push(...e.$Tv),n.push(...e.$Vv)):v(o)&&n.push(...e.$Vv);const s=n.map(c=>this.e.get(c));for(const c of s){const t=c?.get(i);if(t)return t}}canTunnel(o){return!!M(o)}u(o,i,n,s,c,t,f){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${i}:${n} on local port ${s}.`);const h=n;this.j.add(h);const r=s===void 0?n:s,a={elevationRequired:c?this.isPortPrivileged(r):!1},d={remoteAddress:{host:i,port:n},localAddressPort:s,privacy:t,public:t?t!==p.Private:void 0,protocol:f},$=o.forwardPort(d,a);return $?(this.q(i,n,$),$.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(h)})):this.j.delete(h),$}};e.$Zv=u,e.$Zv=u=Ye([Ve(0,A.$zj),Ve(1,j.$Li)],u)}),define(Se[271],De([1,0,5]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dl=void 0,e.$dl=(0,l.$fi)("IUriIdentityService")}),define(Se[272],De([1,0,5]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$1v=void 0,e.$1v=(0,l.$fi)("editSessionIdentityService");var j;(function(L){L[L.Complete=100]="Complete",L[L.Partial=50]="Partial",L[L.None=0]="None"})(j||(e.EditSessionIdentityMatch=j={}))}),define(Se[273],De([1,0,15]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GL=e.$FL=e.$EL=e.$DL=e.$CL=void 0;function j(w){return w.scheme!==l.Schemas.file&&w.scheme!==l.Schemas.vscodeRemote}e.$CL=j;function L(w){if(w.folders.length)return w.folders.every(E=>j(E.uri))?w.folders[0].uri:void 0;if(w.configuration&&j(w.configuration))return w.configuration}e.$DL=L;function A(w){return L(w)?.scheme}e.$EL=A;function R(w){return L(w)?.authority}e.$FL=R;function p(w){return L(w)!==void 0}e.$GL=p}),define(Se[40],De([1,0,214,17,76,23,2,5,15]),function(fe,e,l,j,L,A,R,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.WorkbenchState=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=void 0,e.$oi=(0,p.$fi)("contextService");function E(r){const a=r;return typeof a?.id=="string"&&R.URI.isUri(a.uri)}e.$pi=E;function M(r){return typeof r?.id=="string"&&!E(r)&&!v(r)}e.$qi=M,e.$ri={id:"ext-dev"},e.$si={id:"empty-window"};function C(r,a){if(typeof r=="string"||typeof r>"u")return typeof r=="string"?{id:(0,j.$nc)(r)}:a?e.$ri:e.$si;const d=r;return d.configuration?{id:d.id,configPath:d.configuration}:d.folders.length===1?{id:d.id,uri:d.folders[0].uri}:{id:d.id}}e.$ti=C;function v(r){const a=r;return typeof a?.id=="string"&&R.URI.isUri(a.configPath)}e.$ui=v;function S(r){const a=r;if(a?.uri)return{id:a.id,uri:R.URI.revive(a.uri)};const d=r;if(d?.configPath)return{id:d.id,configPath:R.URI.revive(d.configPath)};if(r?.id)return{id:r.id}}e.$vi=S;var k;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(k||(e.WorkbenchState=k={}));function u(r){const a=r;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&Array.isArray(a.folders))}e.$wi=u;function m(r){const a=r;return!!(a&&typeof a=="object"&&R.URI.isUri(a.uri)&&typeof a.name=="string"&&typeof a.toResource=="function")}e.$xi=m;class o{constructor(a,d,$,D,b){this.h=a,this.j=$,this.k=D,this.l=b,this.c=L.$li.forUris(this.l,()=>!0),this.folders=d}update(a){this.h=a.id,this.k=a.configuration,this.j=a.transient,this.l=a.l,this.folders=a.folders}get folders(){return this.g}set folders(a){this.g=a,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(a){this.k=a}getFolder(a){return a&&this.c.findSubstr(a)||null}n(){this.c=L.$li.forUris(this.l,()=>!0);for(const a of this.folders)this.c.set(a.uri,a)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$yi=o;class i{constructor(a,d){this.raw=d,this.uri=a.uri,this.index=a.index,this.name=a.name}toResource(a){return(0,A.$Sg)(this.uri,a)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$zi=i;function n(r){return new i({uri:r,index:0,name:(0,A.$Og)(r)},{uri:r.toString()})}e.$Ai=n,e.$Bi="code-workspace",e.$Ci=`.${e.$Bi}`,e.$Di=[{name:(0,l.localize)(0,null),extensions:[e.$Bi]}],e.$Ei="workspace.json";function s(r,a){return A.$Jg.isEqualOrParent(r,a.untitledWorkspacesHome)}e.$Fi=s;function c(r){let a;return R.URI.isUri(r)?a=r:a=r.configuration,a?.scheme===w.Schemas.tmp}e.$Gi=c,e.$Hi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(r){return r.id===e.$Hi}e.$Ii=t;function f(r,a){return!s(r,a)&&!c(r)}e.$Ji=f;function h(r){return(typeof r=="string"?(0,j.$oc)(r):(0,A.$Qg)(r))===e.$Ci}e.$Ki=h}),define(Se[274],De([1,0,54,4,3,23,2,213,136,32,5,12,40,28,271,8,30,14,18]),function(fe,e,l,j,L,A,R,p,w,E,M,C,v,S,k,u,m,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jl=e.$il=e.$hl=e.$gl=e.$fl=e.$el=e.ProfileResourceType=void 0;var n;(function(r){r.Settings="settings",r.Keybindings="keybindings",r.Snippets="snippets",r.Tasks="tasks",r.Extensions="extensions",r.GlobalState="globalState"})(n||(e.ProfileResourceType=n={}));function s(r){const a=r;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&typeof a.isDefault=="boolean"&&typeof a.name=="string"&&R.URI.isUri(a.location)&&R.URI.isUri(a.globalStorageHome)&&R.URI.isUri(a.settingsResource)&&R.URI.isUri(a.keybindingsResource)&&R.URI.isUri(a.tasksResource)&&R.URI.isUri(a.snippetsHome)&&R.URI.isUri(a.extensionsResource))}e.$el=s,e.$fl=(0,M.$fi)("IUserDataProfilesService");function c(r,a){return{id:r.id,isDefault:r.isDefault,name:r.name,shortName:r.shortName,icon:r.icon,location:R.URI.revive(r.location).with({scheme:a}),globalStorageHome:R.URI.revive(r.globalStorageHome).with({scheme:a}),settingsResource:R.URI.revive(r.settingsResource).with({scheme:a}),keybindingsResource:R.URI.revive(r.keybindingsResource).with({scheme:a}),tasksResource:R.URI.revive(r.tasksResource).with({scheme:a}),snippetsHome:R.URI.revive(r.snippetsHome).with({scheme:a}),extensionsResource:R.URI.revive(r.extensionsResource).with({scheme:a}),cacheHome:R.URI.revive(r.cacheHome).with({scheme:a}),useDefaultFlags:r.useDefaultFlags,isTransient:r.isTransient}}e.$gl=c;function t(r,a,d,$,D,b){return{id:r,name:a,location:d,isDefault:!1,shortName:D?.shortName,icon:D?.icon,globalStorageHome:b&&D?.useDefaultFlags?.globalState?b.globalStorageHome:(0,A.$Sg)(d,"globalStorage"),settingsResource:b&&D?.useDefaultFlags?.settings?b.settingsResource:(0,A.$Sg)(d,"settings.json"),keybindingsResource:b&&D?.useDefaultFlags?.keybindings?b.keybindingsResource:(0,A.$Sg)(d,"keybindings.json"),tasksResource:b&&D?.useDefaultFlags?.tasks?b.tasksResource:(0,A.$Sg)(d,"tasks.json"),snippetsHome:b&&D?.useDefaultFlags?.snippets?b.snippetsHome:(0,A.$Sg)(d,"snippets"),extensionsResource:b&&D?.useDefaultFlags?.extensions?b.extensionsResource:(0,A.$Sg)(d,"extensions.json"),cacheHome:(0,A.$Sg)($,r),useDefaultFlags:D?.useDefaultFlags,isTransient:D?.transient}}e.$hl=t;let f=class extends L.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(a,d,$,D){super(),this.t=a,this.u=d,this.w=$,this.y=D,this.f=!0,this.h=this.B(new j.$5d),this.onDidChangeProfiles=this.h.event,this.j=this.B(new j.$5d),this.onWillCreateProfile=this.j.event,this.m=this.B(new j.$5d),this.onWillRemoveProfile=this.m.event,this.n=this.B(new j.$5d),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new S.$Ac,emptyWindows:new Map},this.profilesHome=(0,A.$Sg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,A.$Sg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(a){this.f!==a&&(this.z=void 0,this.f=a)}isEnabled(){return this.f}get C(){if(!this.z){const a=this.D(),d=[a];if(this.f)try{for(const b of this.O()){if(!b.name||!(0,i.$Sf)(b.name)||!b.location){this.y.warn("Skipping the invalid stored profile",b.location||b.name);continue}d.push(t((0,A.$Pg)(b.location),b.name,b.location,this.g,{shortName:b.shortName,icon:b.icon,useDefaultFlags:b.useDefaultFlags},a))}}catch(b){this.y.error(b)}const $=new S.$Ac,D=new Map;if(d.length)try{const b=this.Q();if(b.workspaces)for(const[g,y]of Object.entries(b.workspaces)){const P=R.URI.parse(g),N=d.find(U=>U.id===y);N&&$.set(P,N)}if(b.emptyWindows)for(const[g,y]of Object.entries(b.emptyWindows)){const P=d.find(N=>N.id===y);P&&D.set(g,P)}}catch(b){this.y.error(b)}this.z={profiles:d,workspaces:$,emptyWindows:D}}return this.z}D(){const a=t("__default__profile__",(0,p.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...a,extensionsResource:this.S()??a.extensionsResource,isDefault:!0}}async createTransientProfile(a){const d="Temp",$=new RegExp(`${(0,o.$Xe)(d)}\\s(\\d+)`);let D=0;for(const g of this.profiles){const y=$.exec(g.name),P=y?parseInt(y[1]):0;D=P>D?P:D}const b=`${d} ${D+1}`;return this.createProfile((0,l.$6i)((0,m.$Bg)()).toString(16),b,{transient:!0},a)}async createNamedProfile(a,d,$){return this.createProfile((0,l.$6i)((0,m.$Bg)()).toString(16),a,d,$)}async createProfile(a,d,$,D){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const b=await this.F(a,d,$);return D&&await this.setProfileForWorkspace(D,b),b}async F(a,d,$){if(!(0,i.$Sf)(d)||!d)throw new Error("Name of the profile is mandatory and must be of type `string`");let D=this.r.get(d);return D||(D=(async()=>{try{const b=this.profiles.find(P=>P.name===d||P.id===a);if(b)return b;const g=t(a,d,(0,A.$Sg)(this.profilesHome,a),this.g,$,this.defaultProfile);await this.u.createFolder(g.location);const y=[];return this.j.fire({profile:g,join(P){y.push(P)}}),await u.Promises.settled(y),this.I([g],[],[]),g}finally{this.r.delete(d)}})(),this.r.set(d,D)),D}async updateProfile(a,d){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let $=this.profiles.find(D=>D.id===a.id);if(!$)throw new Error(`Profile '${a.name}' does not exist`);return $=t($.id,d.name??$.name,$.location,this.g,{shortName:d.shortName??$.shortName,icon:d.icon===null?void 0:d.icon??$.icon,transient:d.transient??$.isTransient,useDefaultFlags:d.useDefaultFlags??$.useDefaultFlags},this.defaultProfile),this.I([],[],[$]),$}async removeProfile(a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(a.isDefault)throw new Error("Cannot remove default profile");const d=this.profiles.find(D=>D.id===a.id);if(!d)throw new Error(`Profile '${a.name}' does not exist`);const $=[];this.m.fire({profile:d,join(D){$.push(D)}});try{await Promise.allSettled($)}catch(D){this.y.error(D)}for(const D of[...this.C.emptyWindows.keys()])d.id===this.C.emptyWindows.get(D)?.id&&this.C.emptyWindows.delete(D);for(const D of[...this.C.workspaces.keys()])d.id===this.C.workspaces.get(D)?.id&&this.C.workspaces.delete(D);this.M(),this.I([],[d],[]);try{await this.u.del(d.cacheHome,{recursive:!0})}catch(D){(0,E.$Wk)(D)!==1&&this.y.error(D)}}async setProfileForWorkspace(a,d){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const $=this.profiles.find(D=>D.id===d.id);if(!$)throw new Error(`Profile '${d.name}' does not exist`);this.L(a,$)}unsetWorkspace(a,d){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(a,void 0,d)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const a=await this.u.resolve(this.profilesHome);await Promise.all((a.children||[]).filter(d=>d.isDirectory&&this.profiles.every($=>!this.w.extUri.isEqual($.location,d.resource))).map(d=>this.u.del(d.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const a=this.s.profiles.filter(d=>!this.H(d));await Promise.allSettled(a.map(d=>this.removeProfile(d)))}getProfileForWorkspace(a){const d=this.G(a);return R.URI.isUri(d)?this.s.workspaces.get(d)??this.C.workspaces.get(d):this.s.emptyWindows.get(d)??this.C.emptyWindows.get(d)}G(a){return(0,v.$pi)(a)?a.uri:(0,v.$ui)(a)?a.configPath:a.id}H(a){return!!([...this.s.emptyWindows.values()].some(d=>this.w.extUri.isEqual(d.location,a.location))||[...this.s.workspaces.values()].some(d=>this.w.extUri.isEqual(d.location,a.location))||[...this.C.emptyWindows.values()].some(d=>this.w.extUri.isEqual(d.location,a.location))||[...this.C.workspaces.values()].some(d=>this.w.extUri.isEqual(d.location,a.location)))}I(a,d,$){const D=[...this.profiles,...a],b=[];this.s.profiles=[];for(let g of D)g.isDefault||d.some(y=>g.id===y.id)||(g=$.find(y=>g.id===y.id)??g,g.isTransient?this.s.profiles.push(g):b.push({location:g.location,name:g.name,shortName:g.shortName,icon:g.icon,useDefaultFlags:g.useDefaultFlags}));this.P(b),this.z=void 0,this.J(a,d,$)}J(a,d,$){this.h.fire({added:a,removed:d,updated:$,all:this.profiles})}L(a,d,$){$=d?.isTransient?!0:$,$||this.L(a,void 0,!0);const D=this.G(a),b=$?this.s:this.C;R.URI.isUri(D)?(b.workspaces.delete(D),d&&b.workspaces.set(D,d)):(b.emptyWindows.delete(D),d&&b.emptyWindows.set(D,d)),$||this.M()}M(){const a={};for(const[$,D]of this.C.workspaces.entries())a[$.toString()]=D.id;const d={};for(const[$,D]of this.C.emptyWindows.entries())d[$.toString()]=D.id;this.R({workspaces:a,emptyWindows:d}),this.z=void 0}N(a){const d={},$=this.D();if(a.workspaces)for(const[b,g]of Object.entries(a.workspaces)){const y=R.URI.parse(g);d[b]=this.w.extUri.isEqual(y,$.location)?$.id:this.w.extUri.basename(y)}const D={};if(a.emptyWindows)for(const[b,g]of Object.entries(a.emptyWindows)){const y=R.URI.parse(g);D[b]=this.w.extUri.isEqual(y,$.location)?$.id:this.w.extUri.basename(y)}return{workspaces:d,emptyWindows:D}}O(){return[]}P(a){throw new Error("not implemented")}Q(){return{}}R(a){throw new Error("not implemented")}S(){}};e.$il=f,e.$il=f=Ye([Ve(0,w.$mi),Ve(1,E.$Fk),Ve(2,k.$dl),Ve(3,C.$zj)],f);class h extends f{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(a){this.a=a}Q(){return this.X}R(a){this.X=a}}e.$jl=h}),define(Se[275],De([1,0,8,4,3,58,18,193,5,274]),function(fe,e,l,j,L,A,R,p,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Np=e.$Mp=e.$Lp=e.$Kp=e.$Jp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Ip=e.$Hp=e.$Gp=void 0,e.$Gp="__$__isNewStorageMarker",e.$Hp="__$__targetStorageMarker",e.$Ip=(0,w.$fi)("storageService");var M;(function(i){i[i.NONE=0]="NONE",i[i.SHUTDOWN=1]="SHUTDOWN"})(M||(e.WillSaveStateReason=M={}));var C;(function(i){i[i.APPLICATION=-1]="APPLICATION",i[i.PROFILE=0]="PROFILE",i[i.WORKSPACE=1]="WORKSPACE"})(C||(e.StorageScope=C={}));var v;(function(i){i[i.USER=0]="USER",i[i.MACHINE=1]="MACHINE"})(v||(e.StorageTarget=v={}));function S(i){const n=i.get(e.$Hp);if(n)try{return JSON.parse(n)}catch{}return Object.create(null)}e.$Jp=S;class k extends L.$Tc{static{this.a=60*1e3}constructor(n={flushInterval:k.a}){super(),this.m=n,this.b=this.B(new j.$8d),this.c=this.B(new j.$8d),this.onDidChangeTarget=this.c.event,this.f=this.B(new j.$5d),this.onWillSaveState=this.f.event,this.h=this.B(new l.$rh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new L.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(n,s,c){return j.Event.filter(this.b.event,t=>t.scope===n&&(s===void 0||t.key===s),c)}n(){this.j.value=(0,l.$vh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,L.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.O()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(n,s){const{key:c,external:t}=s;if(c===e.$Hp){switch(n){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:n})}else this.b.fire({scope:n,key:c,target:this.J(n)[c],external:t})}w(n){this.f.fire({reason:n})}get(n,s,c){return this.P(s)?.get(n,c)}getBoolean(n,s,c){return this.P(s)?.getBoolean(n,c)}getNumber(n,s,c){return this.P(s)?.getNumber(n,c)}getObject(n,s,c){return this.P(s)?.getObject(n,c)}storeAll(n,s){this.y(()=>{for(const c of n)this.store(c.key,c.value,c.scope,c.target,s)})}store(n,s,c,t,f=!1){if((0,R.$2f)(s)){this.remove(n,c,f);return}this.y(()=>{this.z(n,c,t),this.P(c)?.set(n,s,f)})}remove(n,s,c=!1){this.y(()=>{this.z(n,s,void 0),this.P(s)?.delete(n,c)})}y(n){this.b.pause(),this.c.pause();try{n()}finally{this.b.resume(),this.c.resume()}}keys(n,s){const c=[],t=this.J(n);for(const f of Object.keys(t))t[f]===s&&c.push(f);return c}z(n,s,c,t=!1){const f=this.J(s);typeof c=="number"?f[n]!==c&&(f[n]=c,this.P(s)?.set(e.$Hp,JSON.stringify(f),t)):typeof f[n]=="number"&&(delete f[n],this.P(s)?.set(e.$Hp,JSON.stringify(f),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(n){switch(n){case-1:return this.I;case 0:return this.G;default:return this.D}}L(n){const s=this.P(n);return s?S(s):Object.create(null)}isNew(n){return this.getBoolean(e.$Gp,n)===!0}async flush(n=M.NONE){this.f.fire({reason:n});const s=this.P(-1),c=this.P(0),t=this.P(1);switch(n){case M.NONE:await l.Promises.settled([s?.whenFlushed()??Promise.resolve(),c?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case M.SHUTDOWN:await l.Promises.settled([s?.flush(0)??Promise.resolve(),c?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const n=this.P(-1)?.items??new Map,s=this.P(0)?.items??new Map,c=this.P(1)?.items??new Map;return o(n,s,c,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(n){return await this.flush(),this.P(n)?.optimize()}async switch(n,s){return this.w(M.NONE),(0,E.$el)(n)?this.R(n,s):this.S(n,s)}M(n,s){return!(n.id===s.id||u(s)&&u(n))}N(n,s,c){this.y(()=>{const t=new Set;for(const[f,h]of n)t.add(f),s.get(f)!==h&&this.u(c,{key:f,external:!0});for(const[f]of s.items)t.has(f)||this.u(c,{key:f,external:!0})})}}e.$Kp=k;function u(i){return i.isDefault||!!i.useDefaultFlags?.globalState}e.$Lp=u;class m extends k{constructor(){super(),this.U=this.B(new p.$Ep(new p.$Fp,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new p.$Ep(new p.$Fp,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new p.$Ep(new p.$Fp,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(n=>this.u(1,n))),this.B(this.W.onDidChangeStorage(n=>this.u(0,n))),this.B(this.U.onDidChangeStorage(n=>this.u(-1,n)))}P(n){switch(n){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(n){switch(n){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(n){return!1}}e.$Mp=m;async function o(i,n,s,c,t,f){const h=P=>{try{return JSON.parse(P)}catch{return P}},r=new Map,a=new Map;i.forEach((P,N)=>{r.set(N,P),a.set(N,h(P))});const d=new Map,$=new Map;n.forEach((P,N)=>{d.set(N,P),$.set(N,h(P))});const D=new Map,b=new Map;s.forEach((P,N)=>{D.set(N,P),b.set(N,h(P))}),console.group(c!==t?`Storage: Application (path: ${c})`:`Storage: Application & Profile (path: ${c}, default profile)`);const g=[];if(r.forEach((P,N)=>{g.push({key:N,value:P})}),console.table(g),console.groupEnd(),console.log(a),c!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const P=[];d.forEach((N,U)=>{P.push({key:U,value:N})}),console.table(P),console.groupEnd(),console.log($)}console.group(`Storage: Workspace (path: ${f})`);const y=[];D.forEach((P,N)=>{y.push({key:N,value:P})}),console.table(y),console.groupEnd(),console.log(b)}e.$Np=o}),define(Se[111],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nhc=void 0;class l{static{this.a=!1}constructor(L){this.d=L,this.b=new Map,this.c=1}add(L){const A=this.c++;return this.b.set(A,L),this.e(),A}get(L,A){return this.b.has(L)?this.b.get(L)[A]:void 0}delete(L){this.b.delete(L),this.e()}e(){l.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Nhc=l}),define(Se[59],De([1,0,15,23,5]),function(fe,e,l,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Thc=e.$Shc=void 0;class A{constructor(){this.a=new Set(Object.keys(l.Schemas)),this.b=new Map,this.extUri=new j.$Hg(p=>{const w=this.b.get(p.scheme);return!(w===void 0||w&1024)})}$acceptProviderInfos(p,w){w===null?this.b.delete(p.scheme):this.b.set(p.scheme,w)}isFreeScheme(p){return!this.b.has(p)&&!this.a.has(p)}getCapabilities(p){return this.b.get(p)}}e.$Shc=A,e.$Thc=(0,L.$fi)("IExtHostFileSystemInfo")}),define(Se[27],De([1,0,5]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BO=void 0,e.$BO=(0,l.$fi)("IExtHostInitDataService")}),define(Se[276],De([1,0,220,12,256,27]),function(fe,e,l,j,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zjc=void 0;let R=class extends L.$IP{constructor(w,E,M){const C=M.remote.isRemote?"remoteexthost":w?"workerexthost":"exthost",v=M.remote.isRemote?(0,l.localize)(0,null):w?(0,l.localize)(1,null):(0,l.localize)(2,null);super(E.createLogger(C,{name:v}))}};e.$Zjc=R,e.$Zjc=R=Ye([Ve(1,j.$Aj),Ve(2,A.$BO)],R)}),define(Se[277],De([1,0,8]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cic=e.$Bic=void 0;class j{constructor(R,p,w){this.h=new Map,this.a=R,this.b=p,this.c=w,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(E=>(this.f=E,this)),this.g=this.c.onDidChangeStorage(E=>{E.shared===this.b&&E.key===this.a&&(this.f=E.value)}),this.i=new l.$rh(()=>{const E=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const M of E.values())M.complete()}catch(M){for(const C of E.values())C.error(M)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,p){let w=this.f[R];return typeof w>"u"&&(w=p),w}update(R,p){this.f[R]=p;const w=this.h.get(R);if(w!==void 0)return w.p;const E=new l.$Ch;return this.h.set(R,E),this.i.isScheduled()||this.i.schedule(),E.p}dispose(){this.g.dispose()}}e.$Bic=j;class L extends j{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,p){super(R.identifier.value,!0,p),this.j=R}}e.$Cic=L}),define(Se[278],De([1,0,4,2]),function(fe,e,l,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pjc=void 0;class L{constructor(R){this.c=R,this.a=new l.$5d,this.onDidSaveNotebookDocument=this.a.event,this.b=new l.$5d,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,p,w,E){const C=this.c.getNotebookDocument(j.URI.revive(R)).acceptModelChanged(p.value,w,E);this.b.fire(C)}$acceptDirtyStateChanged(R,p){this.c.getNotebookDocument(j.URI.revive(R)).acceptDirty(p)}$acceptModelSaved(R){const p=this.c.getNotebookDocument(j.URI.revive(R));this.a.fire(p.apiNotebook)}}e.$pjc=L}),define(Se[20],De([1,0,5]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mO=e.$lO=void 0,e.$lO=(0,l.$fi)("IExtHostRpcService");class j{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.dispose=A.dispose.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.$mO=j}),define(Se[279],De([1,0,25,4]),function(fe,e,l,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jic=void 0;class L{#e;constructor(R,p){this.b=new j.$5d,this.onDidChange=this.b.event,this.a=l.$zm.toKey(R.identifier),this.#e=p,this.#e.onDidChangePassword(w=>{w.extensionId===this.a&&this.b.fire({key:w.key})})}get(R){return this.#e.get(this.a,R)}store(R,p){return this.#e.store(this.a,R,p)}delete(R){return this.#e.delete(this.a,R)}}e.$Jic=L}),define(Se[65],De([1,0,5]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aic=e.$_hc=void 0,e.$_hc=(0,l.$fi)("IURITransformerService");class j{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$aic=j}),define(Se[280],De([1,0,21]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jnb=e.$inb=void 0;class j{constructor(){this.buffers=[]}add(w){let E=this.buffers.indexOf(w);return E<0&&(E=this.buffers.length,this.buffers.push(w)),E}}function L(p,w){if(w.serializeBuffersForPostMessage){const E=new j,C=JSON.stringify(p,(S,k)=>{if(k instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:E.add(k)};if(ArrayBuffer.isView(k)){const u=A(k);if(u)return{$$vscode_array_buffer_reference$$:!0,index:E.add(k.buffer),view:{type:u,byteLength:k.byteLength,byteOffset:k.byteOffset}}}return k}),v=E.buffers.map(S=>{const k=new Uint8Array(S);return l.$se.wrap(k)});return{message:C,buffers:v}}else return{message:JSON.stringify(p),buffers:[]}}e.$inb=L;function A(p){switch(p.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(p,w){const E=w.map(v=>{const S=new ArrayBuffer(v.byteLength);return new Uint8Array(S).set(v.buffer),S}),M=w.length?(v,S)=>{if(S&&typeof S=="object"&&S.$$vscode_array_buffer_reference$$){const k=S,{index:u}=k,m=E[u];if(k.view)switch(k.view.type){case 1:return new Int8Array(m,k.view.byteOffset,k.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(m,k.view.byteOffset,k.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(m,k.view.byteOffset,k.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(m,k.view.byteOffset,k.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(m,k.view.byteOffset,k.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(m,k.view.byteOffset,k.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(m,k.view.byteOffset,k.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(m,k.view.byteOffset,k.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(m,k.view.byteOffset,k.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(m,k.view.byteOffset,k.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(m,k.view.byteOffset,k.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return m}return S}:void 0;return{message:JSON.parse(p,M),arrayBuffers:E}}e.$jnb=R}),define(Se[281],De([1,0,282,394,395,62,2,12,396]),function(fe,e,l,j,L,A,R,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vkc=void 0;const E=!1;function M(n,s,c,t,f,h){const r=h.environment.useHostProxy,a=typeof r=="boolean"?r:!h.remote.isRemote,d={resolveProxy:b=>n.resolveProxy(b),lookupProxyAuthorization:m.bind(void 0,t,f,s,{},h.remote.isRemote),getProxyURL:()=>s.getConfiguration("http").get("proxy"),getProxySupport:()=>s.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>v(s),addCertificatesV2:()=>S(s),log:t,getLogLevel:()=>{const b=t.getLevel();switch(b){case p.LogLevel.Trace:return w.LogLevel.Trace;case p.LogLevel.Debug:return w.LogLevel.Debug;case p.LogLevel.Info:return w.LogLevel.Info;case p.LogLevel.Warning:return w.LogLevel.Warning;case p.LogLevel.Error:return w.LogLevel.Error;case p.LogLevel.Off:return w.LogLevel.Off;default:return g(b)}function g(y){return t.error("Unknown log level",y),w.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:a,loadAdditionalCertificates:async()=>{const b=[];if(h.remote.isRemote&&b.push((0,w.loadSystemCertificates)({log:t})),a){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const g=n.loadCertificates();g.then(y=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",y.length)),b.push(g)}return(await Promise.all(b)).flat()},env:process.env},$=(0,w.createProxyResolver)(d),D=C(d,$);return u(c,D)}e.$vkc=M;function C(n,s){return{http:Object.assign(l,(0,w.createHttpPatch)(n,l,s)),https:Object.assign(j,(0,w.createHttpPatch)(n,j,s)),net:Object.assign(A,(0,w.createNetPatch)(n,A)),tls:Object.assign(L,(0,w.createTlsPatch)(n,L))}}function v(n){const s=n.getConfiguration("http");return!s.get("experimental.systemCertificatesV2",E)&&!!s.get("systemCertificates")}function S(n){const s=n.getConfiguration("http");return!!s.get("experimental.systemCertificatesV2",E)&&!!s.get("systemCertificates")}const k=new Map;function u(n,s){return n.getExtensionPathIndex().then(c=>{const t=globalThis._VSCODE_NODE_MODULES.module,f=t._load;t._load=function(r,a,d){if(r==="net")return s.net;if(r==="tls")return s.tls;if(r!=="http"&&r!=="https")return f.apply(this,arguments);const $=c.findSubstr(R.URI.file(a.filename));let D=k.get($);if(D||k.set($,D={}),!D[r]){const b=s[r];D[r]={...b}}return D[r]}})}async function m(n,s,c,t,f,h,r,a){const d=t[h];r&&(t[h]=r),n.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${h}`,`proxyAuthenticate:${r}`,`proxyAuthenticateCache:${d}`);const $=r||d,D=Array.isArray($)?$:typeof $=="string"?[$]:[];if(i(s,D,f),D.some(b=>/^(Negotiate|Kerberos)( |$)/i.test(b))&&!a.kerberosRequested)try{a.kerberosRequested=!0;const b=await new Promise((U,z)=>{fe(["kerberos"],U,z)}),g=new URL(h),y=c.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${g.hostname}`:`HTTP@${g.hostname}`);return n.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${h}`,`spn:${y}`),"Negotiate "+await(await b.initializeClient(y)).step("")}catch(b){n.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",b)}}let o=!1;function i(n,s,c){o||!s.length||(o=!0,n.$publicLog2("proxyAuthenticationRequest",{authenticationType:s.map(t=>t.split(" ")[0]).join(","),extensionHostType:c?"remote":"local"}))}}),define(Se[283],De([1,0,133]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$es=void 0;function j(A){return{transformIncoming:R=>R.scheme==="vscode-remote"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="file"?{scheme:"vscode-local",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoing:R=>R.scheme==="file"?{scheme:"vscode-remote",authority:A,path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="vscode-local"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoingScheme:R=>R==="file"?"vscode-remote":R==="vscode-local"?"file":R}}function L(A){return new l.$gn(j(A))}e.$es=L}),define(Se[142],De([1,0,230,18,2,3,5,37,32,15,44,185,39]),function(fe,e,l,j,L,A,R,p,w,E,M,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jF=e.$iF=e.$hF=e.EditorsOrder=e.$gF=e.CloseDirection=e.$fF=e.$eF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$dF=e.$cF=e.$bF=e.$aF=e.$_E=e.$$E=e.$0E=e.$9E=e.EditorInputCapabilities=e.$8E=e.SaveReason=e.Verbosity=e.$7E=e.$6E=e.$5E=e.$4E=e.$3E=e.$2E=e.$1E=e.$ZE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$YE=e.$XE=e.$WE=e.$VE=e.$UE=void 0,e.$UE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$VE={id:"default",displayName:(0,l.localize)(0,null),providerDisplayName:(0,l.localize)(1,null)},e.$WE="workbench.editor.sidebysideEditor",e.$XE="workbench.editors.textDiffEditor",e.$YE="workbench.editors.binaryResourceDiffEditor";var S;(function(se){se[se.PROGRAMMATIC=1]="PROGRAMMATIC",se[se.USER=2]="USER",se[se.EDIT=3]="EDIT",se[se.NAVIGATION=4]="NAVIGATION",se[se.JUMP=5]="JUMP"})(S||(e.EditorPaneSelectionChangeReason=S={}));var k;(function(se){se[se.IDENTICAL=1]="IDENTICAL",se[se.SIMILAR=2]="SIMILAR",se[se.DIFFERENT=3]="DIFFERENT"})(k||(e.EditorPaneSelectionCompareResult=k={}));function u(se){const re=se;return!!re&&typeof re.getSelection=="function"&&!!re.onDidChangeSelection}e.$ZE=u;function m(se,re,B){for(const ie of B.visibleEditorPanes)if(ie.group.id===re&&se.matches(ie.input))return ie.getViewState()}e.$1E=m;function o(se){if($(se))return!1;const re=se;return L.URI.isUri(re?.resource)}e.$2E=o;function i(se){if($(se))return!1;const re=se;return re?.original!==void 0&&re.modified!==void 0}e.$3E=i;function n(se){if($(se))return!1;const re=se;return!re||re.resources&&!Array.isArray(re.resources)?!1:!!re.resources||!!re.multiDiffSource}e.$4E=n;function s(se){if($(se)||i(se))return!1;const re=se;return re?.primary!==void 0&&re.secondary!==void 0}e.$5E=s;function c(se){if($(se))return!1;const re=se;return re?re.resource===void 0||re.resource.scheme===E.Schemas.untitled||re.forceUntitled===!0:!1}e.$6E=c;function t(se){if($(se))return!1;const re=se;return L.URI.isUri(re?.base?.resource)&&L.URI.isUri(re?.input1?.resource)&&L.URI.isUri(re?.input2?.resource)&&L.URI.isUri(re?.result?.resource)}e.$7E=t;var f;(function(se){se[se.SHORT=0]="SHORT",se[se.MEDIUM=1]="MEDIUM",se[se.LONG=2]="LONG"})(f||(e.Verbosity=f={}));var h;(function(se){se[se.EXPLICIT=1]="EXPLICIT",se[se.AUTO=2]="AUTO",se[se.FOCUS_CHANGE=3]="FOCUS_CHANGE",se[se.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(h||(e.SaveReason=h={}));class r{constructor(){this.a=new Map}registerSource(re,B){let ie=this.a.get(re);return ie||(ie={source:re,label:B},this.a.set(re,ie)),ie.source}getSourceLabel(re){return this.a.get(re)?.label??re}}e.$8E=new r;var a;(function(se){se[se.None=0]="None",se[se.Readonly=2]="Readonly",se[se.Untitled=4]="Untitled",se[se.Singleton=8]="Singleton",se[se.RequiresTrust=16]="RequiresTrust",se[se.CanSplitInGroup=32]="CanSplitInGroup",se[se.ForceDescription=64]="ForceDescription",se[se.CanDropIntoEditor=128]="CanDropIntoEditor",se[se.MultipleEditors=256]="MultipleEditors",se[se.Scratchpad=512]="Scratchpad",se[se.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(a||(e.EditorInputCapabilities=a={}));class d extends A.$Tc{}e.$9E=d;function $(se){return se instanceof d}e.$0E=$;function D(se){const re=se;return L.URI.isUri(re?.preferredResource)}function b(se){const re=se;return $(re?.primary)&&$(re?.secondary)}e.$$E=b;function g(se){const re=se;return $(re?.modified)&&$(re?.original)}e.$_E=g;function y(se,re,B,ie,ye){return ge(ie,[(0,C.$2i)({id:"workbench.action.openLargeFile",label:(0,l.localize)(2,null),run:()=>{const le={...B,limits:{size:Number.MAX_VALUE}};se.openEditor(re,le)}}),(0,C.$2i)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,l.localize)(3,null),run:()=>ye.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:v.default.Warning})}e.$aF=y;function P(se){return $(se?.editor)}e.$bF=P;function N(se){const re=se;return P(se)&&re?.group!==void 0}e.$cF=N;function U(se){const re=se;return typeof re?.groupId=="number"&&$(re.editor)}e.$dF=U;var z;(function(se){se[se.UNKNOWN=0]="UNKNOWN",se[se.REPLACE=1]="REPLACE",se[se.MOVE=2]="MOVE",se[se.UNPIN=3]="UNPIN"})(z||(e.EditorCloseContext=z={}));var F;(function(se){se[se.GROUP_ACTIVE=0]="GROUP_ACTIVE",se[se.GROUP_INDEX=1]="GROUP_INDEX",se[se.GROUP_LABEL=2]="GROUP_LABEL",se[se.GROUP_LOCKED=3]="GROUP_LOCKED",se[se.EDITOR_OPEN=4]="EDITOR_OPEN",se[se.EDITOR_CLOSE=5]="EDITOR_CLOSE",se[se.EDITOR_MOVE=6]="EDITOR_MOVE",se[se.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",se[se.EDITOR_LABEL=8]="EDITOR_LABEL",se[se.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",se[se.EDITOR_PIN=10]="EDITOR_PIN",se[se.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",se[se.EDITOR_STICKY=12]="EDITOR_STICKY",se[se.EDITOR_DIRTY=13]="EDITOR_DIRTY",se[se.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(F||(e.GroupModelChangeKind=F={}));var I;(function(se){se[se.PRIMARY=1]="PRIMARY",se[se.SECONDARY=2]="SECONDARY",se[se.BOTH=3]="BOTH",se[se.ANY=4]="ANY"})(I||(e.SideBySideEditor=I={}));class O{getOriginalUri(re,B){if(!re)return;if(t(re))return e.$fF.getOriginalUri(re.result,B);if(B?.supportSideBySide){const{primary:ye,secondary:le}=this.a(re);if(ye&&le){if(B?.supportSideBySide===I.BOTH)return{primary:this.getOriginalUri(ye,{filterByScheme:B.filterByScheme}),secondary:this.getOriginalUri(le,{filterByScheme:B.filterByScheme})};if(B?.supportSideBySide===I.ANY)return this.getOriginalUri(ye,{filterByScheme:B.filterByScheme})??this.getOriginalUri(le,{filterByScheme:B.filterByScheme});re=B.supportSideBySide===I.PRIMARY?ye:le}}if(i(re)||n(re)||s(re)||t(re))return;const ie=D(re)?re.preferredResource:re.resource;return!ie||!B||!B.filterByScheme?ie:this.b(ie,B.filterByScheme)}a(re){return b(re)||s(re)?{primary:re.primary,secondary:re.secondary}:g(re)||i(re)?{primary:re.modified,secondary:re.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(re,B){if(!re)return;if(t(re))return e.$fF.getCanonicalUri(re.result,B);if(B?.supportSideBySide){const{primary:ye,secondary:le}=this.a(re);if(ye&&le){if(B?.supportSideBySide===I.BOTH)return{primary:this.getCanonicalUri(ye,{filterByScheme:B.filterByScheme}),secondary:this.getCanonicalUri(le,{filterByScheme:B.filterByScheme})};if(B?.supportSideBySide===I.ANY)return this.getCanonicalUri(ye,{filterByScheme:B.filterByScheme})??this.getCanonicalUri(le,{filterByScheme:B.filterByScheme});re=B.supportSideBySide===I.PRIMARY?ye:le}}if(i(re)||n(re)||s(re)||t(re))return;const ie=re.resource;return!ie||!B||!B.filterByScheme?ie:this.b(ie,B.filterByScheme)}b(re,B){if(Array.isArray(B)){if(B.some(ie=>re.scheme===ie))return re}else if(B===re.scheme)return re}}var T;(function(se){se[se.UNKNOWN=0]="UNKNOWN",se[se.KEYBOARD=1]="KEYBOARD",se[se.MOUSE=2]="MOUSE"})(T||(e.EditorCloseMethod=T={}));function G(se,re,B,ie){if(!se.isSticky(re))return!1;switch(ie.preventPinnedEditorClose){case"keyboardAndMouse":return B===T.MOUSE||B===T.KEYBOARD;case"mouse":return B===T.MOUSE;case"keyboard":return B===T.KEYBOARD}return!1}e.$eF=G,e.$fF=new O;var te;(function(se){se[se.LEFT=0]="LEFT",se[se.RIGHT=1]="RIGHT"})(te||(e.CloseDirection=te={}));class x{constructor(){this.c=new Map,this.d=new Map}start(re){const B=this.a=re.get(R.$ei);for(const[ie,ye]of this.c)this.e(ie,ye,B);this.c.clear()}e(re,B,ie){const ye=ie.createInstance(B);this.d.set(re,ye)}registerFileEditorFactory(re){if(this.b)throw new Error("Can only register one file editor factory.");this.b=re}getFileEditorFactory(){return(0,j.$4f)(this.b)}registerEditorSerializer(re,B){if(this.c.has(re)||this.d.has(re))throw new Error(`A editor serializer with type ID '${re}' was already registered.`);return this.a?this.e(re,B,this.a):this.c.set(re,B),(0,A.$Rc)(()=>{this.c.delete(re),this.d.delete(re)})}getEditorSerializer(re){return this.d.get(typeof re=="string"?re:re.typeId)}}p.$Wn.add(e.$UE.EditorFactory,new x);async function X(se,re,B){return!se||!se.length?[]:await Promise.all(se.map(async ie=>{const ye=L.URI.revive(ie.fileUri);if(!ye){B.info("Cannot resolve the path because it is not valid.",ie);return}if(!await re.canHandleResource(ye)){B.info("Cannot resolve the path because it cannot be handled",ie);return}let ue=ie.exists,ce=ie.type;if(typeof ue!="boolean"||typeof ce!="number")try{ce=(await re.stat(ye)).isDirectory?w.FileType.Directory:w.FileType.Unknown,ue=!0}catch(H){B.error(H),ue=!1}if(!ue&&ie.openOnlyIfExists){B.info("Cannot resolve the path because it does not exist",ie);return}if(ce===w.FileType.Directory){B.info("Cannot resolve the path because it is a directory",ie);return}const de={...ie.options,pinned:!0};return ue?{resource:ye,options:de}:{resource:ye,options:de,forceUntitled:!0}}))}e.$gF=X;var Q;(function(se){se[se.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",se[se.SEQUENTIAL=1]="SEQUENTIAL"})(Q||(e.EditorsOrder=Q={}));function ae(se){const re=se;if(!re)return!1;const B=re;if(B.modified)return ae(B.modified);const ie=re;return!!(ie.contributionsState&&ie.viewState&&Array.isArray(ie.cursorState))}e.$hF=ae;function _(se){return(0,M.$4i)(se)}e.$iF=_;function ge(se,re,B){const ie=(0,M.$5i)(se,re);return ie.forceMessage=B?.forceMessage,ie.forceSeverity=B?.forceSeverity,ie.allowDialog=B?.allowDialog,ie}e.$jF=ge}),define(Se[284],De([1,0,4,231,5,3,28,37,19,24,77,270]),function(fe,e,l,j,L,A,R,p,w,E,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rF=e.$qF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$pF=e.ViewContentGroups=e.$oF=e.$nF=e.ViewContainerLocation=e.Extensions=e.$mF=e.$lF=e.$kF=void 0,e.$kF="views",e.$lF=(0,j.localize)(0,null),e.$mF=(0,C.$Mw)("default-view-icon",M.$ok.window,(0,j.localize)(1,null));var v;(function(f){f.ViewContainersRegistry="workbench.registry.view.containers",f.ViewsRegistry="workbench.registry.view"})(v||(e.Extensions=v={}));var S;(function(f){f[f.Sidebar=0]="Sidebar",f[f.Panel=1]="Panel",f[f.AuxiliaryBar=2]="AuxiliaryBar"})(S||(e.ViewContainerLocation=S={})),e.$nF=[0,1,2];function k(f){switch(f){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$oF=k;class u extends A.$Tc{constructor(){super(...arguments),this.c=this.B(new l.$5d),this.onDidRegister=this.c.event,this.f=this.B(new l.$5d),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,w.$Rb)([...this.g.values()])}registerViewContainer(h,r,a){const d=this.get(h.id);if(d)return d;const $=h;return $.openCommandActionDescriptor=a?.doNotRegisterOpenCommand?void 0:$.openCommandActionDescriptor??{id:$.id},(0,R.$xc)(this.g,r,[]).push($),a?.isDefault&&this.h.push($),this.c.fire({viewContainer:$,viewContainerLocation:r}),$}deregisterViewContainer(h){for(const r of this.g.keys()){const a=this.g.get(r),d=a?.indexOf(h);if(d!==-1){a?.splice(d,1),a.length===0&&this.g.delete(r),this.f.fire({viewContainer:h,viewContainerLocation:r});return}}}get(h){return this.all.filter(r=>r.id===h)[0]}getViewContainers(h){return[...this.g.get(h)||[]]}getViewContainerLocation(h){return[...this.g.keys()].filter(r=>this.getViewContainers(r).filter(a=>a?.id===h.id).length>0)[0]}getDefaultViewContainer(h){return this.h.find(r=>this.getViewContainerLocation(r)===h)}}p.$Wn.add(v.ViewContainersRegistry,new u);var m;(function(f){f.Open="2_open",f.Debug="4_debug",f.SCM="5_scm",f.More="9_more"})(m||(e.ViewContentGroups=m={}));function o(f,h){const r=f.group??m.More,a=h.group??m.More;return r!==a?r.localeCompare(a):(f.order??5)-(h.order??5)}class i extends A.$Tc{constructor(){super(...arguments),this.c=this.B(new l.$5d),this.onViewsRegistered=this.c.event,this.f=this.B(new l.$5d),this.onViewsDeregistered=this.f.event,this.g=this.B(new l.$5d),this.onDidChangeContainer=this.g.event,this.h=this.B(new l.$5d),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Gc}registerViews(h,r){this.registerViews2([{views:h,viewContainer:r}])}registerViews2(h){h.forEach(({views:r,viewContainer:a})=>this.r(r,a)),this.c.fire(h)}deregisterViews(h,r){const a=this.s(h,r);a.length&&this.f.fire({views:a,viewContainer:r})}moveViews(h,r){for(const a of this.m.keys())if(a!==r){const d=this.s(h,a);d.length&&(this.r(d,r),this.g.fire({views:d,from:a,to:r}))}}getViews(h){return this.m.get(h)||[]}getView(h){for(const r of this.j){const a=(this.m.get(r)||[]).filter(d=>d.id===h)[0];if(a)return a}return null}getViewContainer(h){for(const r of this.j)if((this.m.get(r)||[]).filter(d=>d.id===h)[0])return r;return null}registerViewWelcomeContent(h,r){return this.n.add(h,r),this.h.fire(h),(0,A.$Rc)(()=>{this.n.delete(h,r),this.h.fire(h)})}registerViewWelcomeContent2(h,r){const a=new Map;for(const[d,$]of r)this.n.add(h,$),a.set(d,(0,A.$Rc)(()=>{this.n.delete(h,$),this.h.fire(h)}));return this.h.fire(h),a}getViewWelcomeContent(h){const r=[];return this.n.forEach(h,a=>r.push(a)),r.sort(o)}r(h,r){let a=this.m.get(r);a||(a=[],this.m.set(r,a),this.j.push(r));for(const d of h){if(this.getView(d.id)!==null)throw new Error((0,j.localize)(2,null,d.id));a.push(d)}}s(h,r){const a=this.m.get(r);if(!a)return[];const d=[],$=[];for(const D of a)h.includes(D)?d.push(D):$.push(D);return d.length&&($.length?this.m.set(r,$):(this.m.delete(r),this.j.splice(this.j.indexOf(r),1))),d}}p.$Wn.add(v.ViewsRegistry,new i),e.$pF=(0,L.$fi)("viewDescriptorService");var n;(function(f){f[f.Default=0]="Default",f[f.Expand=1]="Expand"})(n||(e.ViewVisibilityState=n={}));var s;(function(f){f[f.None=0]="None",f[f.Collapsed=1]="Collapsed",f[f.Expanded=2]="Expanded"})(s||(e.TreeItemCollapsibleState=s={}));class c{constructor(h,r){this.c=!1,this.d=!1,(0,E.$Nn)(this,h),this.d=!!r,this.resolve=async a=>{if(r&&!this.c){const d=await r(a);d&&(this.tooltip=this.tooltip??d.tooltip,this.command=this.command??d.command)}a.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$qF=c;class t extends Error{constructor(h){super((0,j.localize)(3,null,h)),this.name="NoTreeViewError"}static is(h){return h.name==="NoTreeViewError"}}e.$rF=t}),define(Se[285],De([1,0,2,29,5]),function(fe,e,l,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BF=e.$AF=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$zF=e.$yF=void 0;function A(E){return!!E&&typeof E=="object"&&"uri"in E&&E.uri instanceof l.URI&&"version"in E&&typeof E.version=="number"&&"ranges"in E&&Array.isArray(E.ranges)&&E.ranges.every(j.$9s.isIRange)}e.$yF=A;function R(E){return!!E&&typeof E=="object"&&"documents"in E&&Array.isArray(E.documents)&&E.documents.every(A)}e.$zF=R;var p;(function(E){E[E.Down=0]="Down",E[E.Up=1]="Up"})(p||(e.InteractiveSessionVoteDirection=p={}));var w;(function(E){E[E.Action=1]="Action",E[E.Toolbar=2]="Toolbar"})(w||(e.ChatCopyKind=w={})),e.$AF=(0,L.$fi)("IChatService"),e.$BF="accessibility.voice.keywordActivation"}),define(Se[143],De([1,0,4,8,232]),function(fe,e,l,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Onb=void 0;class A{constructor(){this.f=new Map,this.m=[],this.n=new l.$5d,this.o=new l.$5d,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(p){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=p}onEvent(p){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=p}onRequest(p){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=p}sendResponse(p){p.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${p.command}`)):this.u("response",p)}sendRequest(p,w,E,M){const C={command:p};if(w&&Object.keys(w).length>0&&(C.arguments=w),this.u("request",C),typeof M=="number"){const v=setTimeout(()=>{clearTimeout(v);const S=this.f.get(C.seq);if(S){this.f.delete(C.seq);const k={type:"response",seq:0,request_seq:C.seq,success:!1,command:p,message:(0,L.localize)(0,null,M,p)};S(k)}},M)}return E&&this.f.set(C.seq,E),C.seq}acceptMessage(p){this.k?this.k(p):(this.m.push(p),this.m.length===1&&this.s())}q(p,w){return p.type!=="event"||w.type!=="event"}async s(){let p;for(;this.m.length;){if((!p||this.q(this.m[0],p))&&await(0,j.$gh)(0),p=this.m.shift(),!p)return;switch(p.type){case"event":this.j?.(p);break;case"request":this.g?.(p);break;case"response":{const w=p,E=this.f.get(w.request_seq);E&&(this.f.delete(w.request_seq),E(w));break}}}}u(p,w){w.type=p,w.seq=this.d++,this.sendMessage(w)}async w(){if(this.f.size===0)return Promise.resolve();const p=new Map;this.f.forEach((w,E)=>p.set(E,w)),await(0,j.$gh)(500),p.forEach((w,E)=>{w({type:"response",seq:0,request_seq:E,success:!1,command:"canceled",message:"canceled"}),this.f.delete(E)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$Onb=A}),define(Se[286],De([1,0,2,233,45,5]),function(fe,e,l,j,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$BI=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$AI=e.MemoryRangeType=e.$zI=e.State=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.$oI=e.$nI=e.$mI=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.$gI=e.$fI=e.$eI=e.$dI=e.$cI=e.$bI=e.$aI=e.$_H=e.$$H=e.$0H=e.$9H=e.$8H=e.$7H=e.$6H=e.$5H=e.$4H=e.$3H=e.$2H=e.$1H=e.$ZH=e.$YH=e.$XH=e.$WH=e.$VH=e.$UH=e.$TH=e.$SH=e.$RH=e.$QH=e.$PH=e.$OH=e.$NH=e.$MH=e.$LH=e.$KH=e.$JH=e.$IH=e.$HH=e.$GH=e.$FH=e.$EH=e.$DH=e.$CH=e.$BH=e.$AH=e.$zH=e.$yH=e.$xH=e.$wH=e.$vH=e.$uH=e.$tH=e.$sH=e.$rH=e.$qH=void 0,e.$qH="workbench.view.debug",e.$rH="workbench.debug.variablesView",e.$sH="workbench.debug.watchExpressionsView",e.$tH="workbench.debug.callStackView",e.$uH="workbench.debug.loadedScriptsView",e.$vH="workbench.debug.breakPointsView",e.$wH="workbench.debug.disassemblyView",e.$xH="workbench.panel.repl",e.$yH="workbench.panel.repl.view",e.$zH=new L.$wj("debugType",void 0,{type:"string",description:j.localize(0,null)}),e.$AH=new L.$wj("debugConfigurationType",void 0,{type:"string",description:j.localize(1,null)}),e.$BH=new L.$wj("debugState","inactive",{type:"string",description:j.localize(2,null)}),e.$CH="debugUx",e.$DH=new L.$wj(e.$CH,"default",{type:"string",description:j.localize(3,null)}),e.$EH=new L.$wj("hasDebugged",!1,{type:"boolean",description:j.localize(4,null)}),e.$FH=new L.$wj("inDebugMode",!1,{type:"boolean",description:j.localize(5,null)}),e.$GH=new L.$wj("inDebugRepl",!1,{type:"boolean",description:j.localize(6,null)}),e.$HH=new L.$wj("breakpointWidgetVisible",!1,{type:"boolean",description:j.localize(7,null)}),e.$IH=new L.$wj("inBreakpointWidget",!1,{type:"boolean",description:j.localize(8,null)}),e.$JH=new L.$wj("breakpointsFocused",!0,{type:"boolean",description:j.localize(9,null)}),e.$KH=new L.$wj("watchExpressionsFocused",!0,{type:"boolean",description:j.localize(10,null)}),e.$LH=new L.$wj("watchExpressionsExist",!1,{type:"boolean",description:j.localize(11,null)}),e.$MH=new L.$wj("variablesFocused",!0,{type:"boolean",description:j.localize(12,null)}),e.$NH=new L.$wj("expressionSelected",!1,{type:"boolean",description:j.localize(13,null)}),e.$OH=new L.$wj("breakpointInputFocused",!1,{type:"boolean",description:j.localize(14,null)}),e.$PH=new L.$wj("callStackItemType",void 0,{type:"string",description:j.localize(15,null)}),e.$QH=new L.$wj("callStackSessionIsAttach",!1,{type:"boolean",description:j.localize(16,null)}),e.$RH=new L.$wj("callStackItemStopped",!1,{type:"boolean",description:j.localize(17,null)}),e.$SH=new L.$wj("callStackSessionHasOneThread",!1,{type:"boolean",description:j.localize(18,null)}),e.$TH=new L.$wj("watchItemType",void 0,{type:"string",description:j.localize(19,null)}),e.$UH=new L.$wj("canViewMemory",void 0,{type:"boolean",description:j.localize(20,null)}),e.$VH=new L.$wj("breakpointItemType",void 0,{type:"string",description:j.localize(21,null)}),e.$WH=new L.$wj("breakpointHasModes",!1,{type:"boolean",description:j.localize(22,null)}),e.$XH=new L.$wj("breakpointSupportsCondition",!1,{type:"boolean",description:j.localize(23,null)}),e.$YH=new L.$wj("loadedScriptsSupported",!1,{type:"boolean",description:j.localize(24,null)}),e.$ZH=new L.$wj("loadedScriptsItemType",void 0,{type:"string",description:j.localize(25,null)}),e.$1H=new L.$wj("focusedSessionIsAttach",!1,{type:"boolean",description:j.localize(26,null)}),e.$2H=new L.$wj("focusedSessionIsNoDebug",!1,{type:"boolean",description:j.localize(27,null)}),e.$3H=new L.$wj("stepBackSupported",!1,{type:"boolean",description:j.localize(28,null)}),e.$4H=new L.$wj("restartFrameSupported",!1,{type:"boolean",description:j.localize(29,null)}),e.$5H=new L.$wj("stackFrameSupportsRestart",!1,{type:"boolean",description:j.localize(30,null)}),e.$6H=new L.$wj("jumpToCursorSupported",!1,{type:"boolean",description:j.localize(31,null)}),e.$7H=new L.$wj("stepIntoTargetsSupported",!1,{type:"boolean",description:j.localize(32,null)}),e.$8H=new L.$wj("breakpointsExist",!1,{type:"boolean",description:j.localize(33,null)}),e.$9H=new L.$wj("debuggersAvailable",!1,{type:"boolean",description:j.localize(34,null)}),e.$0H=new L.$wj("debugExtensionAvailable",!0,{type:"boolean",description:j.localize(35,null)}),e.$$H=new L.$wj("debugProtocolVariableMenuContext",void 0,{type:"string",description:j.localize(36,null)}),e.$_H=new L.$wj("debugSetVariableSupported",!1,{type:"boolean",description:j.localize(37,null)}),e.$aI=new L.$wj("debugSetExpressionSupported",!1,{type:"boolean",description:j.localize(38,null)}),e.$bI=new L.$wj("breakWhenValueChangesSupported",!1,{type:"boolean",description:j.localize(39,null)}),e.$cI=new L.$wj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:j.localize(40,null)}),e.$dI=new L.$wj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:j.localize(41,null)}),e.$eI=new L.$wj("terminateDebuggeeSupported",!1,{type:"boolean",description:j.localize(42,null)}),e.$fI=new L.$wj("suspendDebuggeeSupported",!1,{type:"boolean",description:j.localize(43,null)}),e.$gI=new L.$wj("variableEvaluateNamePresent",!1,{type:"boolean",description:j.localize(44,null)}),e.$hI=new L.$wj("variableIsReadonly",!1,{type:"boolean",description:j.localize(45,null)}),e.$iI=new L.$wj("variableValue",!1,{type:"string",description:j.localize(46,null)}),e.$jI=new L.$wj("variableType",!1,{type:"string",description:j.localize(47,null)}),e.$kI=new L.$wj("variableName",!1,{type:"string",description:j.localize(48,null)}),e.$lI=new L.$wj("variableLanguage",!1,{type:"string",description:j.localize(49,null)}),e.$mI=new L.$wj("variableExtensionId",!1,{type:"string",description:j.localize(50,null)}),e.$nI=new L.$wj("exceptionWidgetVisible",!1,{type:"boolean",description:j.localize(51,null)}),e.$oI=new L.$wj("multiSessionRepl",!1,{type:"boolean",description:j.localize(52,null)}),e.$pI=new L.$wj("multiSessionDebug",!1,{type:"boolean",description:j.localize(53,null)}),e.$qI=new L.$wj("disassembleRequestSupported",!1,{type:"boolean",description:j.localize(54,null)}),e.$rI=new L.$wj("disassemblyViewFocus",!1,{type:"boolean",description:j.localize(55,null)}),e.$sI=new L.$wj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:j.localize(56,null)}),e.$tI=new L.$wj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:j.localize(57,null)});const R=o=>j.localize(58,null,o);e.$uI=R,e.$vI="editor.contrib.debug",e.$wI="editor.contrib.breakpoint",e.$xI="debug",e.$yI={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:j.localize(59,null)};var p;(function(o){o[o.Inactive=0]="Inactive",o[o.Initializing=1]="Initializing",o[o.Stopped=2]="Stopped",o[o.Running=3]="Running"})(p||(e.State=p={}));function w(o){switch(o){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$zI=w;var E;(function(o){o[o.Valid=0]="Valid",o[o.Unreadable=1]="Unreadable",o[o.Error=2]="Error"})(E||(e.MemoryRangeType=E={})),e.$AI="vscode-debug-memory";var M;(function(o){o[o.Initial=1]="Initial",o[o.Dynamic=2]="Dynamic"})(M||(e.DebugConfigurationProviderTriggerKind=M={}));var C;(function(o){o.UnverifiedBreakpoints="unverifiedBreakpoints"})(C||(e.DebuggerString=C={})),e.$BI=(0,A.$fi)("debugService");var v;(function(o){o[o.CONDITION=0]="CONDITION",o[o.HIT_COUNT=1]="HIT_COUNT",o[o.LOG_MESSAGE=2]="LOG_MESSAGE",o[o.TRIGGER_POINT=3]="TRIGGER_POINT"})(v||(e.BreakpointWidgetContext=v={}));var S;(function(o){o[o.Command=0]="Command",o[o.Tree=1]="Tree"})(S||(e.DebugVisualizationType=S={}));var k;(function(o){o[o.None=0]="None",o[o.Collapsed=1]="Collapsed",o[o.Expanded=2]="Expanded"})(k||(e.DebugTreeItemCollapsibleState=k={}));var u;(function(o){o.deserialize=i=>i,o.serialize=i=>i})(u||(e.IDebugVisualizationTreeItem=u={}));var m;(function(o){o.deserialize=i=>({id:i.id,name:i.name,iconPath:i.iconPath&&{light:l.URI.revive(i.iconPath.light),dark:l.URI.revive(i.iconPath.dark)},iconClass:i.iconClass,visualization:i.visualization}),o.serialize=i=>i})(m||(e.IDebugVisualization=m={}))}),define(Se[287],De([1,0,14,2,17,24,15,29,22,19]),function(fe,e,l,j,L,A,R,p,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=void 0;const M=/{([^}]+)}/g;function C(D,b,g){return D.replace(M,function(y,P){return b&&P.length>0&&P[0]!=="_"?y:g&&g.hasOwnProperty(P)?g[P]:y})}e.$sG=C;function v(D){const b={};for(const g of Object.keys(D))g.startsWith("!")||(b[g]=D[g]);return b}e.$tG=v;function S(D){return D.configuration.request==="attach"&&!k(D)&&(!D.parentSession||S(D.parentSession))}e.$uG=S;function k(D){let b=D.configuration.type;if(b)return b==="vslsShare"&&(b=D.configuration.adapterProxy.configuration.type),(0,l.$jf)(b,"extensionhost")||(0,l.$jf)(b,"pwa-extensionhost")?D:D.parentSession?k(D.parentSession):void 0}e.$vG=k;function u(D){return D.type&&(D.label||D.program||D.runtime)}e.$wG=u;function m(D,b,g){let y,P=0;const N=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let U=null;for(;U=N.exec(D);){const z=U.index+1,F=z+U[0].length;if(z<=b&&F>=g){y=U[0],P=z;break}}if(y){const z=/\w+/g;let F=null;for(;(F=z.exec(y))&&!(F.index+1+P+F[0].length>=g););F&&(y=y.substring(0,z.lastIndex))}return y?{start:P,end:P+y.length-1}:{start:0,end:0}}e.$xG=m;async function o(D,b,g,y){if(D.evaluatableExpressionProvider.has(b)){const P=D.evaluatableExpressionProvider.ordered(b),N=(0,E.$Hb)(await Promise.all(P.map(async U=>{try{return await U.provideEvaluatableExpression(b,g,y??w.CancellationToken.None)}catch{return}})));if(N.length>0){let U=N[0].expression;const z=N[0].range;return U||(U=b.getLineContent(g.lineNumber).substring(z.startColumn-1,z.endColumn-1)),{range:z,matchingExpression:U}}}else{const P=b.getLineContent(g.lineNumber),{start:N,end:U}=m(P,g.column,g.column),z=P.substring(N-1,U);return{matchingExpression:z,range:new p.$9s(g.lineNumber,N,g.lineNumber,N+z.length)}}return null}e.$yG=o;const i=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(D){return!!(D&&D.match(i))}e.$zG=n;function s(D){if(typeof D.path=="string"&&!(typeof D.sourceReference=="number"&&D.sourceReference>0)){if(n(D.path))return j.URI.parse(D.path);if((0,L.$ic)(D.path))return j.URI.file(D.path)}return D.path}function c(D){if(typeof D.path=="object"){const b=j.URI.revive(D.path);if(b)return b.scheme===R.Schemas.file?b.fsPath:b.toString()}return D.path}function t(D,b){const g=b?s:c,y=(0,A.$Kn)(D);return h(y,(P,N)=>{P&&N&&(N.path=g(N))}),y}e.$AG=t;function f(D,b){const g=b?s:c,y=(0,A.$Kn)(D);return h(y,(P,N)=>{!P&&N&&(N.path=g(N))}),y}e.$BG=f;function h(D,b){switch(D.type){case"event":{const g=D;switch(g.event){case"output":b(!1,g.body.source);break;case"loadedSource":b(!1,g.body.source);break;case"breakpoint":b(!1,g.body.breakpoint.source);break;default:break}break}case"request":{const g=D;switch(g.command){case"setBreakpoints":b(!0,g.arguments.source);break;case"breakpointLocations":b(!0,g.arguments.source);break;case"source":b(!0,g.arguments.source);break;case"gotoTargets":b(!0,g.arguments.source);break;case"launchVSCode":g.arguments.args.forEach(y=>b(!1,y));break;default:break}break}case"response":{const g=D;if(g.success&&g.body)switch(g.command){case"stackTrace":g.body.stackFrames.forEach(y=>b(!1,y.source));break;case"loadedSources":g.body.sources.forEach(y=>b(!1,y));break;case"scopes":g.body.scopes.forEach(y=>b(!1,y.source));break;case"setFunctionBreakpoints":g.body.breakpoints.forEach(y=>b(!1,y.source));break;case"setBreakpoints":g.body.breakpoints.forEach(y=>b(!1,y.source));break;case"disassemble":g.body?.instructions.forEach(P=>b(!1,P.location));break;default:break}break}}}function r(D){return D.filter(b=>!b.presentation?.hidden).sort((b,g)=>b.presentation?g.presentation?b.presentation.group?g.presentation.group?b.presentation.group!==g.presentation.group?b.presentation.group.localeCompare(g.presentation.group):a(b.presentation.order,g.presentation.order):-1:g.presentation.group?1:a(b.presentation.order,g.presentation.order):-1:g.presentation?1:0)}e.$CG=r;function a(D,b){return typeof D!="number"?typeof b!="number"?0:1:typeof b!="number"?-1:D-b}async function d(D,b){const g=D.getValue("debug.saveBeforeStart",{overrideIdentifier:b.activeTextEditorLanguageId});if(g!=="none"&&(await b.saveAll(),g==="allEditorsInActiveGroup")){const y=b.activeEditorPane;y&&y.input.resource?.scheme===R.Schemas.untitled&&await b.save({editor:y.input,groupId:y.group.id})}await D.reloadConfiguration()}e.$DG=d;const $=(D,b)=>!D||!b?D===b:D.name===b.name&&D.path===b.path&&D.sourceReference===b.sourceReference;e.$EG=$}),define(Se[288],De([1,0,51,62,24,17,11,14,31,234,143]),function(fe,e,l,j,L,A,R,p,w,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0jc=e.$9jc=e.$8jc=e.$7jc=e.$6jc=void 0;class C extends M.$Onb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.i=/: */}constructor(){super(),this.p=Buffer.allocUnsafe(0),this.r=-1}t(o,i){this.l=i,this.p=Buffer.allocUnsafe(0),this.r=-1,o.on("data",n=>this.v(n))}sendMessage(o){if(this.l){const i=JSON.stringify(o);this.l.write(`Content-Length: ${Buffer.byteLength(i,"utf8")}${C.a}${i}`,"utf8")}}v(o){for(this.p=Buffer.concat([this.p,o]);;){if(this.r>=0){if(this.p.length>=this.r){const i=this.p.toString("utf8",0,this.r);if(this.p=this.p.slice(this.r),this.r=-1,i.length>0)try{this.acceptMessage(JSON.parse(i))}catch(n){this.n.fire(new Error((n.message||n)+`
`+i))}continue}}else{const i=this.p.indexOf(C.a);if(i!==-1){const s=this.p.toString("utf8",0,i).split(C.b);for(const c of s){const t=c.split(C.i);t[0]==="Content-Length"&&(this.r=Number(t[1]))}this.p=this.p.slice(i+C.a.length);continue}}break}}}e.$6jc=C;class v extends C{startSession(){return new Promise((o,i)=>{let n=!1;this.x=this.y(()=>{this.t(this.x,this.x),o(),n=!0}),this.x.on("close",()=>{n?this.n.fire(new Error("connection closed")):i(new Error("connection closed"))}),this.x.on("error",s=>{n?this.n.fire(s):i(s)})})}async stopSession(){await this.w(),this.x&&(this.x.end(),this.x=void 0)}}e.$7jc=v;class S extends v{constructor(o){super(),this.z=o}y(o){return j.createConnection(this.z.port,this.z.host||"127.0.0.1",o)}}e.$8jc=S;class k extends v{constructor(o){super(),this.z=o}y(o){return j.createConnection(this.z.path,o)}}e.$9jc=k;class u extends C{constructor(o,i){super(),this.y=o,this.z=i}async startSession(){const o=this.y.command,i=this.y.args,n=this.y.options||{};try{if(o)if(A.$ic(o)){if(!await w.Promises.exists(o))throw new Error(E.localize(0,null,o))}else o.indexOf("/")<0&&o.indexOf("\\")<0;else throw new Error(E.localize(1,null,this.z));let s=process.env;if(n.env&&Object.keys(n.env).length>0&&(s=L.$Nn(L.$Kn(process.env),n.env)),o==="node")if(Array.isArray(i)&&i.length>0){const c=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:s,execArgv:c?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};n.cwd&&(t.cwd=n.cwd);const f=l.fork(i[0],i.slice(1),t);if(!f.pid)throw new Error(E.localize(2,null,i[0]));this.x=f}else throw new Error(E.localize(3,null));else{const c={env:s};n.cwd&&(c.cwd=n.cwd),this.x=l.spawn(o,i,c)}this.x.on("error",c=>{this.n.fire(c)}),this.x.on("exit",(c,t)=>{this.o.fire(c)}),this.x.stdout.on("close",()=>{this.n.fire(new Error("read error"))}),this.x.stdout.on("error",c=>{this.n.fire(c)}),this.x.stdin.on("error",c=>{this.n.fire(c)}),this.x.stderr.resume(),this.t(this.x.stdout,this.x.stdin)}catch(s){this.n.fire(s)}}async stopSession(){return this.x?(await this.w(),R.$i?new Promise((o,i)=>{const n=l.exec(`taskkill /F /T /PID ${this.x.pid}`,function(s,c,t){if(s)return i(s)});n.on("exit",o),n.on("error",i)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(o,i){if(!o)return;const n=Object.create(null);o.runtime&&(o.runtime.indexOf("./")===0?n.runtime=A.$jc(i,o.runtime):n.runtime=o.runtime),o.runtimeArgs&&(n.runtimeArgs=o.runtimeArgs),o.program&&(A.$ic(o.program)?n.program=o.program:n.program=A.$jc(i,o.program)),o.args&&(n.args=o.args);const s=o;return s.win&&(n.win=u.A(s.win,i)),s.winx86&&(n.winx86=u.A(s.winx86,i)),s.windows&&(n.windows=u.A(s.windows,i)),s.osx&&(n.osx=u.A(s.osx,i)),s.linux&&(n.linux=u.A(s.linux,i)),n}static platformAdapterExecutable(o,i){let n=Object.create(null);i=i.toLowerCase();for(const r of o)if(r.contributes){const a=r.contributes.debuggers;a&&a.length>0&&a.filter(d=>typeof d.type=="string"&&p.$jf(d.type,i)).forEach(d=>{const $=u.A(d,r.extensionLocation.fsPath);n=L.$Nn(n,$,r.isBuiltin)})}let s;R.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?s=n.winx86||n.win||n.windows:R.$i?s=n.win||n.windows:R.$j?s=n.osx:R.$k&&(s=n.linux),s=s||n;const c=s.program||n.program,t=s.args||n.args,f=s.runtime||n.runtime,h=s.runtimeArgs||n.runtimeArgs;if(f)return{type:"executable",command:f,args:(h||[]).concat(typeof c=="string"?[c]:[]).concat(t||[])};if(c)return{type:"executable",command:c,args:t||[]}}}e.$0jc=u}),define(Se[289],De([1,0,51,34,11]),function(fe,e,l,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_jc=e.$$jc=void 0;function A(E,M){return new Promise((C,v)=>{let S="";const k=l.spawn(E,M);k.pid&&k.stdout.on("data",u=>{S+=u.toString()}),k.on("error",u=>{v(u)}),k.on("close",u=>{C(S)})})}async function R(E){if(E)if(L.$i){const M=await new Promise((C,v)=>{fe(["@vscode/windows-process-tree"],C,v)});return new Promise(C=>{M.getProcessTree(E,v=>{C(!!v&&v.children.length>0)})})}else return A("/usr/bin/pgrep",["-lP",String(E)]).then(M=>{const C=M.trim();return!(C.length===0||C.indexOf(" tmux")>=0)},M=>!0);return Promise.resolve(!0)}e.$$jc=R;var p;(function(E){E[E.cmd=0]="cmd",E[E.powershell=1]="powershell",E[E.bash=2]="bash"})(p||(p={}));function w(E,M,C,v){E=E.trim().toLowerCase();let S;E.indexOf("powershell")>=0||E.indexOf("pwsh")>=0?S=1:E.indexOf("cmd.exe")>=0?S=0:E.indexOf("bash")>=0?S=2:L.$i?S=0:S=2;let k,u=" ";switch(S){case 1:if(k=m=>(m=m.replace(/\'/g,"''"),m.length>0&&m.charAt(m.length-1)==="\\"?`'${m}\\'`:`'${m}'`),v){const m=(0,j.$kg)(v);m&&(u+=`${m}:; `),u+=`cd ${k(v)}; `}if(M.length>0){const m=M.shift(),o=C?m:k(m);u+=o[0]==="'"?`& ${o} `:`${o} `;for(const i of M)u+=i==="<"||i===">"||C?i:k(i),u+=" "}break;case 0:if(k=m=>(m=m.replace(/\"/g,'""'),m=m.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(o=>m.includes(o))||m.length===0?`"${m}"`:m),v){const m=(0,j.$kg)(v);m&&(u+=`${m}: && `),u+=`cd ${k(v)} && `}for(const m of M)u+=m==="<"||m===">"||C?m:k(m),u+=" ";break;case 2:{k=m=>(m=m.replace(/(["'\\\$!><#()\[\]*&^| ;{}?`])/g,"\\$1"),m.length===0?'""':m),v&&(u+=`cd ${k(v)} ; `);for(const m of M)u+=m==="<"||m===">"||C?m:k(m),u+=" ";break}}return u}e.$_jc=w}),define(Se[290],De([1,0,5]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0J=e.CellExecutionUpdateType=void 0;var j;(function(L){L[L.Output=1]="Output",L[L.OutputItems=2]="OutputItems",L[L.ExecutionState=3]="ExecutionState"})(j||(e.CellExecutionUpdateType=j={})),e.$0J=(0,l.$fi)("INotebookExecutionService")}),define(Se[291],De([1,0,5]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0gb=e.$9gb=e.ProxyKernelState=e.$8gb=void 0,e.$8gb=100;var j;(function(L){L[L.Disconnected=1]="Disconnected",L[L.Connected=2]="Connected",L[L.Initializing=3]="Initializing"})(j||(e.ProxyKernelState=j={})),e.$9gb=(0,l.$fi)("INotebookKernelService"),e.$0gb=(0,l.$fi)("INotebookKernelHistoryService")}),define(Se[292],De([1,0,3,29,198,100]),function(fe,e,l,j,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xTb=void 0;class R extends l.$Tc{constructor(w,E,M){super(),this._source=w,this.b=E,this.c=M,this.a=void 0}f(w){const E=w.getLineCount();return new j.$9s(1,1,E,this.g(w,E))}g(w,E){if(E<1||E>w.getLineCount())throw new Error("Illegal value for lineNumber");return w.getLineLength(E)+1}get inputTextBuffer(){if(!this.b){const w=new L.$rC;w.acceptChunk(this._source);const E=w.finish(!0),{textBuffer:M,disposable:C}=E.create(1);this.b=M,this.B(C)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(w=>{const E=new L.$rC;E.acceptChunk(w);const M=E.finish(!0),{textBuffer:C,disposable:v}=M.create(1);return this.B(v),C})),this.a}findInInputs(w){const M=new A.$fC(w,!1,!1,null).parseSearchRequest();if(!M)return[];const C=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(C,M,!0,5e3)}findInOutputs(w){const M=new A.$fC(w,!1,!1,null).parseSearchRequest();return M?this.outputTextBuffers.map(C=>{const v=C.findMatchesLineByLine(this.f(C),M,!0,5e3);if(v.length!==0)return{textBuffer:C,matches:v}}).filter(C=>!!C):[]}}e.$xTb=R}),define(Se[66],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WK=e.TestPosition=e.TestIdPathParts=void 0;var l;(function(A){A.Delimiter="\0"})(l||(e.TestIdPathParts=l={}));var j;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(j||(e.TestPosition=j={}));class L{static fromExtHostTestItem(R,p,w=R.parent){if(R._isRoot)return new L([p]);const E=[R.id];for(let M=w;M&&M.id!==p;M=M.parent)E.push(M.id);return E.push(p),new L(E.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const p=R.indexOf("\0");return p===-1?R:R.slice(0,p)}static fromString(R){return new L(R.split("\0"))}static join(R,p){return new L([...R.path,p])}static joinToString(R,p){return R.toString()+"\0"+p}static parentId(R){const p=R.lastIndexOf("\0");return p===-1?void 0:R.slice(0,p)}static localId(R){const p=R.lastIndexOf("\0");return p===-1?R:R.slice(p+1)}static isChild(R,p){return p.startsWith(R)&&p[R.length]==="\0"}static compare(R,p){return R===p?0:L.isChild(R,p)?2:L.isChild(p,R)?3:1}constructor(R,p=R.length){if(this.path=R,this.d=p,R.length===0||p<1)throw new Error("cannot create test with empty path")}get rootId(){return new L(this.path,1)}get parentId(){return this.d>1?new L(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new L(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new L(this.path,R)}compare(R){if(typeof R=="string")return L.compare(this.toString(),R);for(let p=0;p<R.d&&p<this.d;p++)if(R.path[p]!==this.path[p])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.$WK=L}),define(Se[89],De([1,0,2,49,29,66]),function(fe,e,l,j,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5K=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$4K=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$3K=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$2K=e.$1K=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$ZK=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$YK=e.$XK=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var R;(function(I){I[I.Unset=0]="Unset",I[I.Queued=1]="Queued",I[I.Running=2]="Running",I[I.Passed=3]="Passed",I[I.Failed=4]="Failed",I[I.Skipped=5]="Skipped",I[I.Errored=6]="Errored"})(R||(e.TestResultState=R={}));var p;(function(I){I[I.Run=1]="Run",I[I.Debug=2]="Debug",I[I.Coverage=3]="Coverage"})(p||(e.ExtTestRunProfileKind=p={}));var w;(function(I){I[I.Run=2]="Run",I[I.Debug=4]="Debug",I[I.Coverage=8]="Coverage",I[I.HasNonDefaultProfile=16]="HasNonDefaultProfile",I[I.HasConfigurable=32]="HasConfigurable",I[I.SupportsContinuousRun=64]="SupportsContinuousRun"})(w||(e.TestRunProfileBitset=w={})),e.$XK=[2,4,8,16,32,64];const E=I=>"runId"in I;e.$YK=E;var M;(function(I){I.serialize=O=>({range:O.range.toJSON(),uri:O.uri.toJSON()}),I.deserialize=(O,T)=>({range:L.$9s.lift(T.range),uri:O.asCanonicalUri(l.URI.revive(T.uri))})})(M||(e.IRichLocation=M={}));var C;(function(I){I[I.Error=0]="Error",I[I.Output=1]="Output"})(C||(e.TestMessageType=C={}));var v;(function(I){I.serialize=O=>({message:O.message,type:0,expected:O.expected,actual:O.actual,contextValue:O.contextValue,location:O.location&&M.serialize(O.location)}),I.deserialize=(O,T)=>({message:T.message,type:0,expected:T.expected,actual:T.actual,contextValue:T.contextValue,location:T.location&&M.deserialize(O,T.location)})})(v||(e.ITestErrorMessage=v={}));const S=(I,O)=>`${O?"s":"e"}${I}`;e.$ZK=S;var k;(function(I){I.serialize=O=>({message:O.message,type:1,offset:O.offset,length:O.length,location:O.location&&M.serialize(O.location)}),I.deserialize=(O,T)=>({message:T.message,type:1,offset:T.offset,length:T.length,location:T.location&&M.deserialize(O,T.location)})})(k||(e.ITestOutputMessage=k={}));var u;(function(I){I.serialize=O=>O.type===0?v.serialize(O):k.serialize(O),I.deserialize=(O,T)=>T.type===0?v.deserialize(O,T):k.deserialize(O,T)})(u||(e.ITestMessage=u={}));var m;(function(I){I.serializeWithoutMessages=O=>({state:O.state,duration:O.duration,messages:[]}),I.serialize=O=>({state:O.state,duration:O.duration,messages:O.messages.map(u.serialize)}),I.deserialize=(O,T)=>({state:T.state,duration:T.duration,messages:T.messages.map(G=>u.deserialize(O,G))})})(m||(e.ITestTaskState=m={}));const o="\0",i=(I,O)=>I+o+O;e.$1K=i;const n=I=>{const O=I.indexOf(o);return{ctrlId:I.slice(0,O),tagId:I.slice(O+1)}};e.$2K=n;var s;(function(I){I.serialize=O=>({extId:O.extId,label:O.label,tags:O.tags,busy:O.busy,children:void 0,uri:O.uri?.toJSON(),range:O.range?.toJSON()||null,description:O.description,error:O.error,sortText:O.sortText}),I.deserialize=(O,T)=>({extId:T.extId,label:T.label,tags:T.tags,busy:T.busy,children:void 0,uri:T.uri?O.asCanonicalUri(l.URI.revive(T.uri)):void 0,range:T.range?L.$9s.lift(T.range):null,description:T.description,error:T.error,sortText:T.sortText})})(s||(e.ITestItem=s={}));var c;(function(I){I[I.NotExpandable=0]="NotExpandable",I[I.Expandable=1]="Expandable",I[I.BusyExpanding=2]="BusyExpanding",I[I.Expanded=3]="Expanded"})(c||(e.TestItemExpandState=c={}));var t;(function(I){I.serialize=O=>({expand:O.expand,item:s.serialize(O.item)}),I.deserialize=(O,T)=>({controllerId:A.$WK.root(T.item.extId),expand:T.expand,item:s.deserialize(O,T.item)})})(t||(e.InternalTestItem=t={}));var f;(function(I){I.serialize=O=>{let T;return O.item&&(T={},O.item.label!==void 0&&(T.label=O.item.label),O.item.tags!==void 0&&(T.tags=O.item.tags),O.item.busy!==void 0&&(T.busy=O.item.busy),O.item.uri!==void 0&&(T.uri=O.item.uri?.toJSON()),O.item.range!==void 0&&(T.range=O.item.range?.toJSON()),O.item.description!==void 0&&(T.description=O.item.description),O.item.error!==void 0&&(T.error=O.item.error),O.item.sortText!==void 0&&(T.sortText=O.item.sortText)),{extId:O.extId,expand:O.expand,item:T}},I.deserialize=O=>{let T;return O.item&&(T={},O.item.label!==void 0&&(T.label=O.item.label),O.item.tags!==void 0&&(T.tags=O.item.tags),O.item.busy!==void 0&&(T.busy=O.item.busy),O.item.range!==void 0&&(T.range=O.item.range?L.$9s.lift(O.item.range):null),O.item.description!==void 0&&(T.description=O.item.description),O.item.error!==void 0&&(T.error=O.item.error),O.item.sortText!==void 0&&(T.sortText=O.item.sortText)),{extId:O.extId,expand:O.expand,item:T}}})(f||(e.ITestItemUpdate=f={}));const h=(I,O)=>{O.expand!==void 0&&(I.expand=O.expand),O.item!==void 0&&(I.item=I.item?Object.assign(I.item,O.item):O.item)};e.$3K=h;var r;(function(I){I.serializeWithoutMessages=O=>({...t.serialize(O),ownComputedState:O.ownComputedState,computedState:O.computedState,tasks:O.tasks.map(m.serializeWithoutMessages)}),I.serialize=O=>({...t.serialize(O),ownComputedState:O.ownComputedState,computedState:O.computedState,tasks:O.tasks.map(m.serialize)}),I.deserialize=(O,T)=>({...t.deserialize(O,T),ownComputedState:T.ownComputedState,computedState:T.computedState,tasks:T.tasks.map(G=>m.deserialize(O,G)),retired:!0})})(r||(e.TestResultItem=r={}));var a;(function(I){I.empty=()=>({covered:0,total:0}),I.sum=(O,T)=>{O.covered+=T.covered,O.total+=T.total}})(a||(e.ICoveredCount=a={}));var d;(function(I){I.serialize=O=>({statement:O.statement,branch:O.branch,declaration:O.declaration,details:O.details?.map(g.serialize),uri:O.uri.toJSON()}),I.deserialize=(O,T)=>({statement:T.statement,branch:T.branch,declaration:T.declaration,details:T.details?.map(g.deserialize),uri:O.asCanonicalUri(l.URI.revive(T.uri))})})(d||(e.IFileCoverage=d={}));function $(I){return{...I,location:I.location?.toJSON()}}function D(I){return I.location=I.location?j.$8s.isIPosition(I.location)?j.$8s.lift(I.location):L.$9s.lift(I.location):void 0,I}e.$4K=3;var b;(function(I){I[I.Declaration=0]="Declaration",I[I.Statement=1]="Statement",I[I.Branch=2]="Branch"})(b||(e.DetailType=b={}));var g;(function(I){I.serialize=O=>O.type===0?P.serialize(O):N.serialize(O),I.deserialize=O=>O.type===0?P.deserialize(O):N.deserialize(O)})(g||(e.CoverageDetails=g={}));var y;(function(I){I.serialize=$,I.deserialize=D})(y||(e.IBranchCoverage=y={}));var P;(function(I){I.serialize=$,I.deserialize=D})(P||(e.IDeclarationCoverage=P={}));var N;(function(I){I.serialize=O=>({...$(O),branches:O.branches?.map(y.serialize)}),I.deserialize=O=>({...D(O),branches:O.branches?.map(y.deserialize)})})(N||(e.IStatementCoverage=N={}));var U;(function(I){I[I.Add=0]="Add",I[I.Update=1]="Update",I[I.DocumentSynced=2]="DocumentSynced",I[I.Remove=3]="Remove",I[I.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",I[I.Retire=5]="Retire",I[I.AddTag=6]="AddTag",I[I.RemoveTag=7]="RemoveTag"})(U||(e.TestDiffOpType=U={}));var z;(function(I){I.deserialize=(O,T)=>T.op===0?{op:T.op,item:t.deserialize(O,T.item)}:T.op===1?{op:T.op,item:f.deserialize(T.item)}:T.op===2?{op:T.op,uri:O.asCanonicalUri(l.URI.revive(T.uri)),docv:T.docv}:T,I.serialize=O=>O.op===0?{op:O.op,item:t.serialize(O.item)}:O.op===1?{op:O.op,item:f.serialize(O.item)}:O})(z||(e.TestsDiffOp=z={}));class F{constructor(O){this.k=O,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(O){const T=this.v();for(const G of O)switch(G.op){case 0:this.l(t.deserialize(this.k,G.item),T);break;case 1:this.o(f.deserialize(G.item),T);break;case 3:this.p(G.itemId,T);break;case 5:this.q(G.itemId);break;case 4:this.updatePendingRoots(G.amount);break;case 6:this.c.set(G.tag.id,G.tag);break;case 7:this.c.delete(G.id);break}T.complete?.()}l(O,T){const G=A.$WK.parentId(O.item.extId)?.toString();let te;if(!G)te=this.w(O),this.g.add(te),this.f.set(O.item.extId,te);else if(this.f.has(G)){const x=this.f.get(G);x.children.add(O.item.extId),te=this.w(O,x),this.f.set(O.item.extId,te)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(O)}`);return}return T.add?.(te),O.expand===2&&this.h++,te}o(O,T){const G=this.f.get(O.extId);if(G)return O.expand!==void 0&&(G.expand===2&&this.h--,O.expand===2&&this.h++),(0,e.$3K)(G,O),T.update?.(G),G}p(O,T){const G=this.f.get(O);if(!G)return;const te=A.$WK.parentId(G.item.extId)?.toString();te?this.f.get(te).children.delete(G.item.extId):this.g.delete(G);const x=[[O]];for(;x.length;)for(const X of x.pop()){const Q=this.f.get(X);Q&&(x.push(Q.children),this.f.delete(X),T.remove?.(Q,Q!==G),Q.expand===2&&this.h--)}}q(O){}updatePendingRoots(O){this.j+=O}v(){return{}}}e.$5K=F}),define(Se[112],De([1,0,8,4,3,61,89,66]),function(fe,e,l,j,L,A,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fO=e.$eO=e.$dO=e.$cO=e.$bO=e.TestItemEventOp=void 0;var w;(function(i){i[i.Upsert=0]="Upsert",i[i.SetTags=1]="SetTags",i[i.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",i[i.RemoveChild=3]="RemoveChild",i[i.SetProp=4]="SetProp",i[i.Bulk=5]="Bulk",i[i.DocumentSynced=6]="DocumentSynced"})(w||(e.TestItemEventOp=w={}));const E=(i,n)=>i===n,C=Object.entries({range:(i,n)=>i===n?!0:!i||!n?!1:i.equalsRange(n),busy:E,label:E,description:E,error:E,sortText:E,tags:(i,n)=>!(i.length!==n.length||i.some(s=>!n.includes(s)))}),v=(i,n)=>{let s;for(const[c,t]of C)t(i[c],n[c])||(s?s[c]=n[c]:s={[c]:n[c]});return s};class S extends L.$Tc{get root(){return this.s.root}constructor(n){super(),this.s=n,this.f=this.B(new l.$rh(()=>this.flushDiff(),200)),this.g=this.B(new j.$5d),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(n){this.h=n;for(const s of this.tree.values())this.J(s)}get resolveHandler(){return this.h}collectDiff(){const n=this.m;return this.m=[],n}pushDiff(n){switch(n.op){case 2:{for(const s of this.m)if(s.op===2&&s.uri===n.uri){s.docv=n.docv;return}break}case 1:{const s=this.m[this.m.length-1];if(s){if(s.op===1&&s.item.extId===n.item.extId){(0,R.$3K)(s.item,n.item);return}if(s.op===0&&s.item.item.extId===n.item.extId){(0,R.$3K)(s.item,n.item);return}}break}}this.m.push(n),this.f.isScheduled()||this.f.schedule()}expand(n,s){const c=this.tree.get(n);if(c){if((c.expandLevels===void 0||s>c.expandLevels)&&(c.expandLevels=s),c.expand===1){const t=this.M(c);return t.isOpen()?this.L(c,s-1):t.wait().then(()=>this.L(c,s-1))}else if(c.expand===3)return c.resolveBarrier?.isOpen()===!1?c.resolveBarrier.wait().then(()=>this.L(c,s-1)):this.L(c,s-1)}}dispose(){for(const n of this.tree.values())this.s.getApiFor(n.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(n,s){switch(s.op){case 3:this.O(p.$WK.joinToString(n.fullId,s.id));break;case 0:this.z(s.item,n);break;case 5:for(const c of s.ops)this.w(n,c);break;case 1:this.C(s.new,s.old,n.fullId.toString());break;case 2:this.J(n);break;case 4:this.pushDiff({op:1,item:{extId:n.fullId.toString(),item:s.update}});break;case 6:this.y(n.actual.uri);break;default:(0,A.$9c)(s)}}y(n){n&&this.pushDiff({op:2,uri:n,docv:this.s.getDocumentVersion(n)})}z(n,s){const c=p.$WK.fromExtHostTestItem(n,this.root.id,s?.actual),t=this.s.getApiFor(n);t.parent&&t.parent!==s?.actual&&this.s.getChildren(t.parent).delete(n.id);let f=this.tree.get(c.toString());if(!f){f={fullId:c,actual:n,expandLevels:s?.expandLevels?s.expandLevels-1:void 0,expand:0},n.tags.forEach(this.D,this),this.tree.set(f.fullId.toString(),f),this.G(n,s),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:f.expand,item:this.s.toITestItem(n)}}),this.I(n,f,s);return}if(f.actual===n){this.H(n,f,s);return}if(f.actual.uri?.toString()!==n.uri?.toString())return this.O(c.toString()),this.z(n,s);const h=this.s.getChildren(f.actual),r=f.actual,a=v(this.s.toITestItem(r),this.s.toITestItem(n));this.s.getApiFor(r).listener=void 0,f.actual=n,f.expand=0,a&&(a.hasOwnProperty("tags")&&(this.C(n.tags,r.tags,c.toString()),delete a.tags),this.w(f,{op:4,update:a})),this.I(n,f,s);for(const[d,$]of h)this.s.getChildren(n).get($.id)||this.O(p.$WK.joinToString(c,$.id));this.y(f.actual.uri)}C(n,s,c){const t=new Set(s.map(f=>f.id));for(const f of n)t.delete(f.id)||this.D(f);this.pushDiff({op:1,item:{extId:c,item:{tags:n.map(f=>(0,R.$1K)(this.s.controllerId,f.id))}}}),t.forEach(this.F,this)}D(n){const s=this.j.get(n.id);s?s.refCount++:(this.j.set(n.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.$1K)(this.s.controllerId,n.id)}}))}F(n){const s=this.j.get(n);s&&!--s.refCount&&(this.j.delete(n),this.pushDiff({op:7,id:(0,R.$1K)(this.s.controllerId,n)}))}G(n,s){this.s.getApiFor(n).parent=s&&s.actual!==this.root?s.actual:void 0}H(n,s,c){this.G(n,c);const t=this.s.getApiFor(n);t.parent=c?.actual,t.listener=f=>this.w(s,f),this.J(s)}I(n,s,c){this.H(n,s,c);for(const[t,f]of this.s.getChildren(n))this.z(f,s)}J(n){let s;this.h?n.resolveBarrier?s=n.resolveBarrier.isOpen()?3:2:s=n.actual.canResolveChildren?1:0:s=0,s!==n.expand&&(n.expand=s,this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:s}}),s===1&&n.expandLevels!==void 0&&this.M(n))}L(n,s){if(s<0)return;const c=[];for(const[t,f]of this.s.getChildren(n.actual)){const h=this.expand(p.$WK.joinToString(n.fullId,f.id),s);(0,l.$4g)(h)&&c.push(h)}if(c.length)return Promise.all(c).then(()=>{})}M(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this.h){const f=new l.$eh;return f.open(),f}n.expand=2,this.N(n);const s=n.resolveBarrier=new l.$eh,c=f=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,f)};let t;try{t=this.h(n.actual===this.root?void 0:n.actual)}catch(f){c(f)}return(0,l.$4g)(t)?t.catch(c).then(()=>{s.open(),this.J(n)}):(s.open(),this.J(n)),n.resolveBarrier}N(n){this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:n.expand}})}O(n){const s=this.tree.get(n);if(!s)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:n});const c=[s];for(;c.length;){const t=c.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const f of t.actual.tags)this.F(f.id);this.tree.delete(t.fullId.toString());for(const[f,h]of this.s.getChildren(t.actual))c.push(this.tree.get(p.$WK.joinToString(t.fullId,h.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.g.fire(n)}}e.$bO=S;class k extends Error{constructor(n){super(`Attempted to insert a duplicate test item ID ${n}`)}}e.$cO=k;class u extends Error{constructor(n){super(`TestItem with ID "${n}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$dO=u;class m extends Error{constructor(n,s,c){super(`TestItem with ID "${n}" is from controller "${s}" and cannot be added as a child of an item from controller "${c}".`)}}e.$eO=m;const o=(i,n,s)=>{let c=new Map;return{get size(){return c.size},forEach(t,f){for(const h of c.values())t.call(f,h,this)},[Symbol.iterator](){return c.entries()},replace(t){const f=new Map,h=new Set(c.keys()),r={op:5,ops:[]};for(const a of t){if(!(a instanceof s))throw new u(a.id);const d=n(a).controllerId;if(d!==i.controllerId)throw new m(a.id,d,i.controllerId);if(f.has(a.id))throw new k(a.id);f.set(a.id,a),h.delete(a.id),r.ops.push({op:0,item:a})}for(const a of h.keys())r.ops.push({op:3,id:a});i.listener?.(r),c=f},add(t){if(!(t instanceof s))throw new u(t.id);c.set(t.id,t),i.listener?.({op:0,item:t})},delete(t){c.delete(t)&&i.listener?.({op:3,id:t})},get(t){return c.get(t)},toJSON(){return Array.from(c.values())}}};e.$fO=o}),define(Se[144],De([1,0,112]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hO=e.$gO=void 0;const j=new WeakMap,L=(R,p)=>{const w={controllerId:p};return j.set(R,w),w};e.$gO=L;const A=R=>{const p=j.get(R);if(!p)throw new l.$dO(R?.id||"<unknown>");return p};e.$hO=A}),define(Se[113],De([1,0,15,2]),function(fe,e,l,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kxb=e.$Jxb=e.$Ixb=e.$Hxb=e.$Gxb=void 0,e.$Gxb="vscode-cdn.net",e.$Hxb=`vscode-resource.${e.$Gxb}`,e.$Ixb=`'self' https://*.${e.$Gxb}`;function L(p,w){return p.scheme===l.Schemas.http||p.scheme===l.Schemas.https?p:(w&&w.authority&&w.isRemote&&p.scheme===l.Schemas.file&&(p=j.URI.from({scheme:l.Schemas.vscodeRemote,authority:w.authority,path:p.path})),j.URI.from({scheme:l.Schemas.https,authority:`${p.scheme}+${A(p.authority)}.${e.$Hxb}`,path:p.path,fragment:p.fragment,query:p.query}))}e.$Jxb=L;function A(p){return p.replace(/./g,w=>{const E=w.charCodeAt(0);return E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57?w:"-"+E.toString(16).padStart(4,"0")})}function R(p){return p.replace(/-([0-9a-f]{4})/g,(w,E)=>String.fromCharCode(parseInt(E,16)))}e.$Kxb=R}),define(Se[293],De([1,0,4,3,113]),function(fe,e,l,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0hc=void 0;class A{constructor(p,w,E){this.d=p,this.e=w,this.f=E,this.a=0,this.b=new j.$Sc,this.c=new Map,this.b.add(w.onDidChangeVisibleTextEditors(()=>{const M=w.getVisibleTextEditors();for(const C of this.c.values())M.indexOf(C.editor)<0&&C.inset.dispose()}))}dispose(){this.c.forEach(p=>p.inset.dispose()),this.b.dispose()}createWebviewEditorInset(p,w,E,M,C){let v;for(const n of this.e.getVisibleTextEditors(!0))if(n.value===p){v=n;break}if(!v)throw new Error("not a visible editor");const S=this,k=this.a++,u=new l.$5d,m=new l.$5d,o=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(n){return(0,L.$Jxb)(n,S.f)}get cspSource(){return L.$Ixb}set options(n){this.b=n,S.d.$setOptions(k,n)}get options(){return this.b}set html(n){this.a=n,S.d.$setHtml(k,n)}get html(){return this.a}get onDidReceiveMessage(){return u.event}postMessage(n){return S.d.$postMessage(k,n)}},i=new class{constructor(){this.editor=p,this.line=w,this.height=E,this.webview=o,this.onDidDispose=m.event}dispose(){S.c.has(k)&&(S.c.delete(k),S.d.$disposeEditorInset(k),m.fire(),m.dispose(),u.dispose())}};return this.d.$createEditorInset(k,v.id,v.value.document.uri,w+1,E,M||{},C.identifier,C.extensionLocation),this.c.set(k,{editor:p,inset:i,onDidReceiveMessage:u}),i}$onDidDispose(p){const w=this.c.get(p);w&&w.inset.dispose()}$onDidReceiveMessage(p,w){this.c.get(p)?.onDidReceiveMessage.fire(w)}}e.$0hc=A}),define(Se[145],De([1,0,5]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aL=e.$_K=void 0,e.$_K="__",e.$aL=(0,l.$fi)("IAuthenticationService")}),define(Se[294],De([1,0,5]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$O=e.VariableKind=e.$0O=void 0,e.$0O=(0,l.$fi)("configurationResolverService");var j;(function(A){A.Unknown="unknown",A.Env="env",A.Config="config",A.Command="command",A.Input="input",A.ExtensionInstallFolder="extensionInstallFolder",A.WorkspaceFolder="workspaceFolder",A.Cwd="cwd",A.WorkspaceFolderBasename="workspaceFolderBasename",A.UserHome="userHome",A.LineNumber="lineNumber",A.SelectedText="selectedText",A.File="file",A.FileWorkspaceFolder="fileWorkspaceFolder",A.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",A.RelativeFile="relativeFile",A.RelativeFileDirname="relativeFileDirname",A.FileDirname="fileDirname",A.FileExtname="fileExtname",A.FileBasename="fileBasename",A.FileBasenameNoExtension="fileBasenameNoExtension",A.FileDirnameBasename="fileDirnameBasename",A.ExecPath="execPath",A.ExecInstallFolder="execInstallFolder",A.PathSeparator="pathSeparator",A.PathSeparatorAlias="/"})(j||(e.VariableKind=j={}));class L extends Error{constructor(R,p){super(p),this.variable=R}}e.$$O=L}),define(Se[295],De([1,0,17,50,18,24,11,103,237,294,14]),function(fe,e,l,j,L,A,R,p,w,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mP=void 0;class C{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(S,k,u,m){this.h=new Map,this.a=S,this.b=k,this.g=u,m&&(this.c=m.then(o=>this.i(o)))}i(S){if(R.$i){const k=Object.create(null);return Object.keys(S).forEach(u=>{k[u.toLowerCase()]=S[u]}),k}return S}resolveWithEnvironment(S,k,u){return this.l({env:this.i(S),userHome:void 0},k?k.uri:void 0,u)}async resolveAsync(S,k){const u={env:await this.c,userHome:await this.g};return this.l(u,S?S.uri:void 0,k)}async j(S,k,u,m){const o=A.$Kn(k);R.$i&&o.windows?Object.keys(o.windows).forEach(n=>o[n]=o.windows[n]):R.$j&&o.osx?Object.keys(o.osx).forEach(n=>o[n]=o.osx[n]):R.$k&&o.linux&&Object.keys(o.linux).forEach(n=>o[n]=o.linux[n]),delete o.windows,delete o.osx,delete o.linux;const i={env:await this.c,userHome:await this.g};return this.l(i,S?S.uri:void 0,o,u,m)}async resolveAnyAsync(S,k,u){return this.j(S,k,u)}async resolveAnyMap(S,k,u){const m=new Map;return{newConfig:await this.j(S,k,u,m),resolvedVariables:m}}resolveWithInteractionReplace(S,k,u,m){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(S,k,u,m){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(S,k){if(this.h.has(S))throw new Error("Variable "+S+" is contributed twice.");this.h.set(S,k)}async l(S,k,u,m,o){if(L.$Sf(u))return this.m(S,k,u,m,o);if(Array.isArray(u))return Promise.all(u.map(i=>this.l(S,k,i,m,o)));if(L.$Uf(u)){const i=Object.create(null),n=await Promise.all(Object.keys(u).map(async s=>[await this.m(S,k,s,m,o),await this.l(S,k,u[s],m,o)]));for(const[s,c]of n)i[s]=c;return i}return u}m(S,k,u,m,o){return(0,M.$bf)(u,C.VARIABLE_REGEXP,async(i,n)=>{if(n.includes(C.VARIABLE_LHS))return i;let s=await this.o(S,i,n,k,m);return o?.set(n,s),s!==i&&L.$Sf(s)&&s.match(C.VARIABLE_REGEXP)&&(s=await this.m(S,k,s,m,o)),s})}n(S){return this.b?this.b.getUriLabel(S,{noPrefix:!0}):S.fsPath}async o(S,k,u,m,o){let i;const n=u.split(":");n.length>1&&(u=n[0],i=n[1]);const s=f=>{const h=this.a.getFilePath();if(h)return(0,p.$_v)(h);throw new E.$$O(f,(0,w.localize)(0,null,k))},c=f=>{const h=s(f);if(this.a.getWorkspaceFolderPathForFile){const r=this.a.getWorkspaceFolderPathForFile();if(r)return(0,p.$_v)(r)}throw new E.$$O(f,(0,w.localize)(1,null,k,l.$nc(h)))},t=f=>{if(i){const h=this.a.getFolderUri(i);if(h)return h;throw new E.$$O(f,(0,w.localize)(2,null,k,i))}if(m)return m;throw this.a.getWorkspaceFolderCount()>1?new E.$$O(f,(0,w.localize)(3,null,k)):new E.$$O(f,(0,w.localize)(4,null,k))};switch(u){case"env":if(i){if(S.env){const f=S.env[R.$i?i.toLowerCase():i];if(L.$Sf(f))return f}return""}throw new E.$$O(E.VariableKind.Env,(0,w.localize)(5,null,k));case"config":if(i){const f=this.a.getConfigurationValue(m,i);if(L.$2f(f))throw new E.$$O(E.VariableKind.Config,(0,w.localize)(6,null,k,i));if(L.$Uf(f))throw new E.$$O(E.VariableKind.Config,(0,w.localize)(7,null,k,i));return f}throw new E.$$O(E.VariableKind.Config,(0,w.localize)(8,null,k));case"command":return this.p(E.VariableKind.Command,k,i,o,"command");case"input":return this.p(E.VariableKind.Input,k,i,o,"input");case"extensionInstallFolder":if(i){const f=await this.a.getExtension(i);if(!f)throw new E.$$O(E.VariableKind.ExtensionInstallFolder,(0,w.localize)(9,null,k,i));return this.n(f.extensionLocation)}throw new E.$$O(E.VariableKind.ExtensionInstallFolder,(0,w.localize)(10,null,k));default:switch(u){case"workspaceRoot":case"workspaceFolder":return(0,p.$_v)(this.n(t(E.VariableKind.WorkspaceFolder)));case"cwd":return m||i?(0,p.$_v)(this.n(t(E.VariableKind.Cwd))):j.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,p.$_v)(l.$nc(this.n(t(E.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(S.userHome)return S.userHome;throw new E.$$O(E.VariableKind.UserHome,(0,w.localize)(11,null,k))}case"lineNumber":{const f=this.a.getLineNumber();if(f)return f;throw new E.$$O(E.VariableKind.LineNumber,(0,w.localize)(12,null,k))}case"selectedText":{const f=this.a.getSelectedText();if(f)return f;throw new E.$$O(E.VariableKind.SelectedText,(0,w.localize)(13,null,k))}case"file":return s(E.VariableKind.File);case"fileWorkspaceFolder":return c(E.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return l.$nc(c(E.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return m||i?l.$lc(this.n(t(E.VariableKind.RelativeFile)),s(E.VariableKind.RelativeFile)):s(E.VariableKind.RelativeFile);case"relativeFileDirname":{const f=l.$mc(s(E.VariableKind.RelativeFileDirname));if(m||i){const h=l.$lc(this.n(t(E.VariableKind.RelativeFileDirname)),f);return h.length===0?".":h}return f}case"fileDirname":return l.$mc(s(E.VariableKind.FileDirname));case"fileExtname":return l.$oc(s(E.VariableKind.FileExtname));case"fileBasename":return l.$nc(s(E.VariableKind.FileBasename));case"fileBasenameNoExtension":{const f=l.$nc(s(E.VariableKind.FileBasenameNoExtension));return f.slice(0,f.length-l.$oc(f).length)}case"fileDirnameBasename":return l.$nc(l.$mc(s(E.VariableKind.FileDirnameBasename)));case"execPath":{const f=this.a.getExecPath();return f||k}case"execInstallFolder":{const f=this.a.getAppRoot();return f||k}case"pathSeparator":case"/":return l.sep;default:try{const f=i?`${u}:${i}`:u;return this.p(E.VariableKind.Unknown,k,f,o,void 0)}catch{return k}}}}p(S,k,u,m,o){if(u&&m){const i=o===void 0?m[u]:m[o+":"+u];if(typeof i=="string")return i;throw new E.$$O(S,(0,w.localize)(14,null,k))}return k}}e.$mP=C}),define(Se[146],De([1,0,5,142]),function(fe,e,l,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qD=e.$pD=e.OpenEditorContext=e.GroupsOrder=e.$oD=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$nD=void 0,e.$nD=(0,l.$fi)("editorGroupsService");var L;(function(k){k[k.UP=0]="UP",k[k.DOWN=1]="DOWN",k[k.LEFT=2]="LEFT",k[k.RIGHT=3]="RIGHT"})(L||(e.GroupDirection=L={}));var A;(function(k){k[k.HORIZONTAL=0]="HORIZONTAL",k[k.VERTICAL=1]="VERTICAL"})(A||(e.GroupOrientation=A={}));var R;(function(k){k[k.FIRST=0]="FIRST",k[k.LAST=1]="LAST",k[k.NEXT=2]="NEXT",k[k.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var p;(function(k){k[k.MAXIMIZE=0]="MAXIMIZE",k[k.EXPAND=1]="EXPAND",k[k.EVEN=2]="EVEN"})(p||(e.GroupsArrangement=p={}));var w;(function(k){k[k.COPY_EDITORS=0]="COPY_EDITORS",k[k.MOVE_EDITORS=1]="MOVE_EDITORS"})(w||(e.MergeGroupMode=w={}));function E(k){const u=k;return(0,j.$0E)(u?.editor)&&(0,j.$0E)(u?.replacement)}e.$oD=E;var M;(function(k){k[k.CREATION_TIME=0]="CREATION_TIME",k[k.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",k[k.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(M||(e.GroupsOrder=M={}));var C;(function(k){k[k.NEW_EDITOR=1]="NEW_EDITOR",k[k.MOVE_EDITOR=2]="MOVE_EDITOR",k[k.COPY_EDITOR=3]="COPY_EDITOR"})(C||(e.OpenEditorContext=C={}));function v(k){const u=k;return!!u&&typeof u.id=="number"&&Array.isArray(u.editors)}e.$pD=v;function S(k){return k.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$qD=S}),define(Se[296],De([1,0,5,146]),function(fe,e,l,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vD=e.$uD=e.$tD=e.$sD=e.$rD=void 0,e.$rD=(0,l.$fi)("editorService"),e.$sD=-1,e.$tD=-2,e.$uD=-3;function L(A){const R=A;return typeof A=="number"||(0,j.$pD)(R)}e.$vD=L}),define(Se[147],De([1,0,5,136]),function(fe,e,l,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qL=void 0,e.$qL=(0,l.$gi)(j.$mi)}),define(Se[148],De([1,0,25,4,17,3,8]),function(fe,e,l,j,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R9b=e.$Q9b=e.$P9b=e.$O9b=e.$N9b=void 0;class p{constructor(i,n){this.versionId=i,this.removedDueToLooping=n}}e.$N9b=p;class w{static isHostExtension(i,n,s){if(n.getExtensionDescription(i))return!1;const c=s.getExtensionDescription(i);return c?!!((c.main||c.browser)&&c.api==="none"):!1}constructor(i,n){this.j=i,this.c=new j.$5d,this.onDidChange=this.c.event,this.d=0,this.e=n,this.k()}k(){this.e.sort(u),this.f=new l.$Bm,this.g=[],this.h=new Map;for(const i of this.e){if(this.f.has(i.identifier)){console.error("Extension `"+i.identifier.value+"` is already registered");continue}this.f.set(i.identifier,i),this.g.push(i);const n=this.j.readActivationEvents(i);for(const s of n)this.h.has(s)||this.h.set(s,[]),this.h.get(s).push(i)}}set(i){return this.e=i,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(i,n){this.e=m(this.e,n),this.e=this.e.concat(i);const s=w.l(this.e);return this.e=m(this.e,s.map(c=>c.identifier)),this.k(),this.d++,this.c.fire(void 0),new p(this.d,s)}static l(i){const n=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(h){this.d.has(h)||(this.d.add(h),this.e.push(h))}addArc(h,r){this.addNode(h),this.addNode(r),this.c.has(h)?this.c.get(h).push(r):this.c.set(h,[r])}getArcs(h){return this.c.has(h)?this.c.get(h):[]}hasOnlyGoodArcs(h,r){const a=n.getArcs(h);for(let d=0;d<a.length;d++)if(!r.has(a[d]))return!1;return!0}getNodes(){return this.e}},s=new l.$Bm;for(const h of i)if(s.set(h.identifier,h),h.extensionDependencies)for(const r of h.extensionDependencies)n.addArc(l.$zm.toKey(h.identifier),l.$zm.toKey(r));const c=new Set;n.getNodes().filter(h=>n.getArcs(h).length===0).forEach(h=>c.add(h));const t=n.getNodes().filter(h=>!c.has(h));let f;do{f=!1;for(let h=0;h<t.length;h++){const r=t[h];n.hasOnlyGoodArcs(r,c)&&(t.splice(h,1),h--,c.add(r),f=!0)}}while(f);return t.map(h=>s.get(h))}containsActivationEvent(i){return this.h.has(i)}containsExtension(i){return this.f.has(i)}getExtensionDescriptionsForActivationEvent(i){const n=this.h.get(i);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new E(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(i){const n=this.f.get(i);return n||void 0}getExtensionDescriptionByUUID(i){for(const n of this.g)if(n.uuid===i)return n}getExtensionDescriptionByIdOrUUID(i,n){return this.getExtensionDescription(i)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.$O9b=w;class E{constructor(i,n){this.versionId=i,this.extensions=n}}e.$P9b=E;class M{constructor(i){this.d=new S,this.c=new w(i,[])}async acquireLock(i){const n=await this.d.acquire(i);return new C(this,n)}deltaExtensions(i,n,s){if(!i.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(n,s)}containsActivationEvent(i){return this.c.containsActivationEvent(i)}containsExtension(i){return this.c.containsExtension(i)}getExtensionDescriptionsForActivationEvent(i){return this.c.getExtensionDescriptionsForActivationEvent(i)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(i){return this.c.getExtensionDescription(i)}getExtensionDescriptionByUUID(i){return this.c.getExtensionDescriptionByUUID(i)}getExtensionDescriptionByIdOrUUID(i,n){return this.c.getExtensionDescriptionByIdOrUUID(i,n)}}e.$Q9b=M;class C extends A.$Tc{constructor(i,n){super(),this.f=i,this.c=!1,this.B(n)}isAcquiredFor(i){return!this.c&&this.f===i}}e.$R9b=C;class v{constructor(i){this.name=i;const n=(0,R.$$g)();this.promise=n.promise,this.c=n.resolve}resolve(i){this.c(i)}}class S{constructor(){this.c=[],this.d=!1}async acquire(i){const n=new v(i);return this.c.push(n),this.e(),n.promise}e(){if(this.d||this.c.length===0)return;const i=this.c.shift();this.d=!0;let n=!0;const s=setTimeout(()=>{n&&console.warn(`The customer named ${i.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),c=()=>{n&&(clearTimeout(s),n=!1,this.d=!1,this.e())};i.resolve((0,A.$Rc)(c))}}var k;(function(o){o[o.Builtin=0]="Builtin",o[o.User=1]="User",o[o.Dev=2]="Dev"})(k||(k={}));function u(o,i){const n=o.isBuiltin?0:o.isUnderDevelopment?2:1,s=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(n!==s)return n-s;const c=L.$gc.basename(o.extensionLocation.path),t=L.$gc.basename(i.extensionLocation.path);return c<t?-1:c>t?1:0}function m(o,i){const n=new l.$Am(i);return o.filter(s=>!n.has(s.identifier))}}),define(Se[297],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.ExtHostConnectionType=void 0;var l;(function(M){M[M.IPC=1]="IPC",M[M.Socket=2]="Socket",M[M.MessagePort=3]="MessagePort"})(l||(e.ExtHostConnectionType=l={}));class j{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(C){this.pipeName=C,this.type=1}serialize(C){C[j.ENV_KEY]=this.pipeName}}e.$5m=j;class L{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(C){C[L.ENV_KEY]="1"}}e.$6m=L;class A{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(C){C[A.ENV_KEY]="1"}}e.$7m=A;function R(M){delete M[j.ENV_KEY],delete M[L.ENV_KEY],delete M[A.ENV_KEY]}function p(M,C){R(C),M.serialize(C)}e.$8m=p;function w(M){if(M[j.ENV_KEY])return E(M,new j(M[j.ENV_KEY]));if(M[L.ENV_KEY])return E(M,new L);if(M[A.ENV_KEY])return E(M,new A);throw new Error("No connection information defined in environment!")}e.$9m=w;function E(M,C){return R(M),C}}),define(Se[114],De([1,0,21]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$Im=e.$Hm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var j;(function(E){E[E.Desktop=1]="Desktop",E[E.Web=2]="Web"})(j||(e.UIKind=j={}));var L;(function(E){E[E.VersionMismatch=55]="VersionMismatch",E[E.UnexpectedError=81]="UnexpectedError"})(L||(e.ExtensionHostExitCode=L={}));var A;(function(E){E[E.Initialized=0]="Initialized",E[E.Ready=1]="Ready",E[E.Terminate=2]="Terminate"})(A||(e.MessageType=A={}));function R(E){const M=l.$se.alloc(1);switch(E){case 0:M.writeUInt8(1,0);break;case 1:M.writeUInt8(2,0);break;case 2:M.writeUInt8(3,0);break}return M}e.$Hm=R;function p(E,M){if(E.byteLength!==1)return!1;switch(E.readUInt8(0)){case 1:return M===0;case 2:return M===1;case 3:return M===2;default:return!1}}e.$Im=p;var w;(function(E){E.Start="START_NATIVE_LOG",E.End="END_NATIVE_LOG"})(w||(e.NativeLogMarkers=w={}))}),define(Se[90],De([1,0,5,4,12,27,114,86,87,24,2,3,223]),function(fe,e,l,j,L,A,R,p,w,E,M,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FO=e.$EO=e.$DO=e.$CO=void 0;let S=class extends C.$Tc{constructor(o,i){super(),this.s=o,this.t=i,this.a=this.B(new j.$5d),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new j.$5d),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=M.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:w.$5o,name:(0,v.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(n=>{(0,L.$Bj)(n)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===L.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(o,i,n){const s=this.getTelemetryDetails(),c=new k(i,n,o,this.n,this.j,this.getBuiltInCommonProperties(o),{isUsageEnabled:s.isUsageEnabled,isErrorsEnabled:s.isErrorsEnabled}),t=this.r.get(o.identifier.value)??[];return this.r.set(o.identifier.value,[...t,c]),c.apiTelemetryLogger}$initializeTelemetryLevel(o,i,n){this.f=o,this.g=i,this.c=n??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(o){const i=Object.create(null);switch(i["common.extname"]=`${o.publisher}.${o.name}`,i["common.extversion"]=o.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=u(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:i["common.uikind"]="web";break;case R.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,p.$qm)((0,w.$$o)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(o){this.h=this.getTelemetryConfiguration(),this.f=o;const i=this.getTelemetryDetails();this.r.forEach((n,s)=>{const c=n.filter(t=>!t.isDisposed);c.length===0?this.r.delete(s):this.r.set(s,c)}),this.r.forEach(n=>{for(const s of n)s.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(o,i){const s=this.r.get(o.value)?.filter(t=>!t.isDisposed);if(!s)return this.r.delete(o.value),!1;let c=!1;for(const t of s)t.ignoreUnhandledExtHostErrors||(t.logError(i),c=!0);return c}};e.$CO=S,e.$CO=S=Ye([Ve(0,A.$BO),Ve(1,L.$Aj)],S);class k{static validateSender(o){if(typeof o!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof o.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof o.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof o.flush<"u"&&typeof o.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(o,i,n,s,c,t,f){this.g=n,this.h=s,this.i=c,this.j=t,this.a=new j.$5d,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=o,this.d={isUsageEnabled:f.isUsageEnabled,isErrorsEnabled:f.isErrorsEnabled}}updateTelemetryEnablements(o,i){this.e&&(this.d={isUsageEnabled:o,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(o){let i="properties"in o?o.properties??{}:o;return i=(0,w.$bp)(i,[]),this.c&&(i=(0,E.$Nn)(i,this.c)),this.b||(i=(0,E.$Nn)(i,this.j)),"properties"in o?o.properties=i:o=i,o}k(o,i){this.f&&(this.g.publisher==="vscode"?o=this.g.name+"/"+o:o=this.g.identifier.value+"/"+o,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(o,i),this.h.trace(o,i))}logUsage(o,i){this.d.isUsageEnabled&&this.k(o,i)}logError(o,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof o=="string")this.k(o,i);else{const n={name:o.name,message:o.message,stack:o.stack,cause:o.cause},s=(0,w.$bp)(n,[]),c=new Error(s.message,{cause:s.cause});c.stack=s.stack,c.name=s.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(c,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const o=this,i={logUsage:o.logUsage.bind(o),get isUsageEnabled(){return o.d.isUsageEnabled},get isErrorsEnabled(){return o.d.isErrorsEnabled},logError:o.logError.bind(o),dispose:o.dispose.bind(o),onDidChangeEnableStates:o.a.event.bind(o)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let o=this.f;this.f=void 0,Promise.resolve(o.flush()).then(o=void 0),this.e=void 0}else this.f=void 0}}e.$DO=k;function u(m){const o=Date.now()-new Date(m).getTime();return isNaN(o)?!1:o<1e3*60*60*24}e.$EO=u,e.$FO=(0,l.$fi)("IExtHostTelemetry")}),define(Se[26],De([1,0,4,2,267,140,25,5]),function(fe,e,l,j,L,A,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4F=e.$3F=e.$2F=e.ActivationKind=e.$1F=e.$ZF=e.$YF=e.$XF=e.$WF=e.ExtensionHostStartup=e.$VF=e.$UF=e.$TF=e.$SF=void 0,e.$SF=Object.freeze({identifier:new R.$zm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:j.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$TF="extensions.webWorker",e.$UF=(0,p.$fi)("extensionService");class w{constructor(c){this.dependency=c}}e.$VF=w;var E;(function(s){s[s.EagerAutoStart=1]="EagerAutoStart",s[s.EagerManualStart=2]="EagerManualStart",s[s.Lazy=3]="Lazy"})(E||(e.ExtensionHostStartup=E={}));class M{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(c,t,f){this.c=c,this.d=t.slice(0),this.e=f.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:A.$DF.createActivationEventsMap(this.d)}}set(c,t,f){if(this.c>c)throw new Error(`ExtensionHostExtensions: invalid versionId ${c} (current: ${this.c})`);const h=[],r=[],a=[],d=[],$=C(this.d),D=C(t),b=(U,z)=>U.extensionLocation.toString()===z.extensionLocation.toString()||U.isBuiltin===z.isBuiltin||U.isUserBuiltin===z.isUserBuiltin||U.isUnderDevelopment===z.isUnderDevelopment;for(const U of this.d){const z=D.get(U.identifier);if(!z){h.push(U.identifier),$.delete(U.identifier);continue}if(!b(U,z)){h.push(U.identifier),$.delete(U.identifier);continue}}for(const U of t){const z=$.get(U.identifier);if(!z){r.push(U);continue}if(!b(z,U)){h.push(z.identifier),$.delete(z.identifier);continue}}const g=new R.$Am(this.e),y=new R.$Am(f);for(const U of this.e)y.has(U)||a.push(U);for(const U of f)g.has(U)||d.push(U);const P=A.$DF.createActivationEventsMap(r),N={versionId:c,toRemove:h,toAdd:r,addActivationEvents:P,myToRemove:a,myToAdd:d};return this.delta(N),N}delta(c){if(this.c>=c.versionId)return null;const{toRemove:t,toAdd:f,myToRemove:h,myToAdd:r}=c,a=new R.$Am(t),d=new R.$Am(h);for(let $=0;$<this.d.length;$++)a.has(this.d[$].identifier)&&(this.d.splice($,1),$--);for(let $=0;$<this.e.length;$++)d.has(this.e[$])&&(this.e.splice($,1),$--);for(const $ of f)this.d.push($);for(const $ of r)this.e.push($);return this.f=null,c}containsExtension(c){for(const t of this.e)if(R.$zm.equals(t,c))return!0;return!1}containsActivationEvent(c){return this.f||(this.f=this.g()),this.f.has(c)}g(){const c=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const f=A.$DF.readActivationEvents(t);for(const h of f)c.add(h)}return c}}e.$WF=M;function C(s){const c=new R.$Bm;for(const t of s)c.set(t.identifier,t);return c}function v(s,c){return s.enabledApiProposals?s.enabledApiProposals.includes(c):!1}e.$XF=v;function S(s,c){if(!v(s,c))throw new Error(`Extension '${s.identifier.value}' CANNOT use API proposal: ${c}.
Its package.json#enabledApiProposals-property declares: ${s.enabledApiProposals?.join(", ")??"[]"} but NOT ${c}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${s.identifier.value}`)}e.$YF=S;class k{constructor(c,t,f,h){this.codeLoadingTime=c,this.activateCallTime=t,this.activateResolvedTime=f,this.activationReason=h}}e.$ZF=k;class u{constructor(c,t){this.description=c,this.value=t}}e.$1F=u;var m;(function(s){s[s.Normal=0]="Normal",s[s.Immediate=1]="Immediate"})(m||(e.ActivationKind=m={}));function o(s){return{type:s.isBuiltin?0:1,isBuiltin:s.isBuiltin||s.isUserBuiltin,identifier:{id:(0,L.$hp)(s.publisher,s.name),uuid:s.uuid},manifest:s,location:s.extensionLocation,targetPlatform:s.targetPlatform,validations:[],isValid:!0}}e.$2F=o;function i(s,c){return{identifier:new R.$zm((0,L.$fp)(s.manifest.publisher,s.manifest.name)),isBuiltin:s.type===0,isUserBuiltin:s.type===1&&s.isBuiltin,isUnderDevelopment:!!c,extensionLocation:s.location,...s.manifest,uuid:s.identifier.uuid,targetPlatform:s.targetPlatform}}e.$3F=i;class n{constructor(){this.onDidRegisterExtensions=l.Event.None,this.onDidChangeExtensionsStatus=l.Event.None,this.onDidChangeExtensions=l.Event.None,this.onWillActivateByEvent=l.Event.None,this.onDidChangeResponsiveChange=l.Event.None,this.onWillStop=l.Event.None,this.extensions=[]}activateByEvent(c){return Promise.resolve(void 0)}activateById(c,t){return Promise.resolve(void 0)}activationEventIsDone(c){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(c){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(c,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(c){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$4F=n}),define(Se[298],De([1,0,13,148,25,26,12,8]),function(fe,e,l,j,L,A,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yic=e.$xic=e.$wic=e.$vic=e.$uic=e.$tic=void 0;class w{static{this.NONE=new w(!1,-1,-1,-1)}constructor(o,i,n,s){this.startup=o,this.codeLoadingTime=i,this.activateCallTime=n,this.activateResolvedTime=s}}e.$tic=w;class E{constructor(o){this.a=o,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(o,i){return o===-1||i===-1?-1:i-o}build(){return new w(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$uic=E;class M{constructor(o,i,n,s,c,t){this.activationFailed=o,this.activationFailedError=i,this.activationTimes=n,this.module=s,this.exports=c,this.subscriptions=t}}e.$vic=M;class C extends M{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.$wic=C;class v extends M{constructor(){super(!1,null,w.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$xic=v;class S extends M{constructor(o){super(!0,o,w.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let k=class{constructor(o,i,n,s){this.g=s,this.a=o,this.b=i,this.c=n,this.d=new L.$Bm,this.f=Object.create(null)}dispose(){for(const[o,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const o=[];for(const[i,n]of this.d)o.push(n.wait());await Promise.all(o)}isActivated(o){const i=this.d.get(o);return!!(i&&i.value)}getActivatedExtension(o){const i=this.d.get(o);if(!i||!i.value)throw new Error(`Extension '${o.value}' is not known or not activated`);return i.value}async activateByEvent(o,i){if(this.f[o])return;const n=this.a.getExtensionDescriptionsForActivationEvent(o);await this.h(n.map(s=>({id:s.identifier,reason:{startup:i,extensionId:s.identifier,activationEvent:o}}))),this.f[o]=!0}activateById(o,i){const n=this.a.getExtensionDescription(o);if(!n)throw new Error(`Extension '${o}' is not known`);return this.h([{id:n.identifier,reason:i}])}async h(o){const i=o.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all(i.map(n=>n.wait()))}j(o){if(this.d.has(o.id))return this.d.get(o.id);if(this.l(o.id))return this.k(o,null,[],null);const i=this.a.getExtensionDescription(o.id);if(!i){const c=new Error(`Cannot activate unknown extension '${o.id.value}'`),t=this.k(o,null,[],new S(c));return this.c.onExtensionActivationError(o.id,c,new A.$VF(o.id.value)),t}const n=[],s=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const c of s){if(this.m(c))continue;const t=this.d.get(c);if(t){n.push(t);continue}if(this.l(c)){n.push(this.j({id:this.b.getExtensionDescription(c).identifier,reason:o.reason}));continue}const f=this.a.getExtensionDescription(c);if(f){if(!f.main&&!f.browser)continue;n.push(this.j({id:f.identifier,reason:o.reason}));continue}const h=i.displayName||i.identifier.value,r=new Error(`Cannot activate the '${h}' extension because it depends on unknown extension '${c}'`),a=this.k(o,i.displayName,[],new S(r));return this.c.onExtensionActivationError(i.identifier,r,new A.$VF(c)),a}return this.k(o,i.displayName,n,null)}k(o,i,n,s){const c=new u(o.id,i,o.reason,n,s,this.c,this.g);return this.d.set(o.id,c),c}l(o){return j.$O9b.isHostExtension(o,this.a,this.b)}m(o){const i=this.b.getExtensionDescription(o);return i?!i.main&&!i.browser:!1}};e.$yic=k,e.$yic=k=Ye([Ve(3,R.$zj)],k);let u=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(o,i,n,s,c,t,f){this.c=o,this.d=i,this.f=n,this.g=s,this.h=c,this.j=t,this.k=f,this.a=new p.$eh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let o=0;o<this.g.length;o++){const i=this.g[o];if(i.value&&!i.value.activationFailed){this.g.splice(o,1),o--;continue}if(i.value&&i.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);n.detail=i.value.activationFailedError,this.h=new S(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(o=>o.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(o){const i=new Error;if(o&&o.name&&(i.name=o.name),o&&o.message?i.message=`Activating extension '${this.c.value}' failed: ${o.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${o}.`,o&&o.stack&&(i.stack=o.stack),this.h=new S(i),this.b&&l.$4(o))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(o)}}};u=Ye([Ve(6,R.$zj)],u)}),define(Se[299],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Se[300],De([1,0,239,13,39,137,109,37,25,299,139,140]),function(fe,e,l,j,L,A,R,p,w,E,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RF=e.$QF=e.$PF=e.$OF=e.$NF=e.$MF=void 0;const v=p.$Wn.as(R.$Xn.JSONContribution);class S{constructor(c,t,f){this.a=c,this.b=t,this.c=f}d(c,t){this.a({type:c,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(c){this.d(L.default.Error,c)}warn(c){this.d(L.default.Warning,c)}info(c){this.d(L.default.Info,c)}}e.$MF=S;class k{static a(c){const t=new w.$Am;for(let f=0,h=c.length;f<h;f++)t.add(c[f].description.identifier);return t}static compute(c,t){if(!c||!c.length)return new k(t,[]);if(!t||!t.length)return new k([],c);const f=this.a(c),h=this.a(t),r=t.filter(d=>!f.has(d.description.identifier)),a=c.filter(d=>!h.has(d.description.identifier));return new k(r,a)}constructor(c,t){this.added=c,this.removed=t}}e.$NF=k;class u{constructor(c,t){this.name=c,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(c){if(this.a!==null)throw new Error("Handler already set!");this.a=c,this.d()}acceptUsers(c){this.c=k.compute(this.b,c),this.b=c,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(c){(0,j.$1)(c)}}}e.$OF=u;const m={type:"string",enum:["ui","workspace"],enumDescriptions:[l.localize(0,null),l.localize(1,null)]},o="vscode://schemas/vscode-extensions";e.$PF={properties:{engines:{type:"object",description:l.localize(2,null),properties:{vscode:{type:"string",description:l.localize(3,null),default:"^1.22.0"}}},publisher:{description:l.localize(4,null),type:"string"},displayName:{description:l.localize(5,null),type:"string"},categories:{description:l.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:w.$ym},{type:"string",const:"Languages",deprecationMessage:l.localize(7,null)}]}},galleryBanner:{type:"object",description:l.localize(8,null),properties:{color:{description:l.localize(9,null),type:"string"},theme:{description:l.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:l.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:l.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:l.localize(13,null)},enabledApiProposals:{markdownDescription:l.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}},api:{markdownDescription:l.localize(15,null),type:"string",enum:["none"],enumDescriptions:[l.localize(16,null)]},activationEvents:{description:l.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:l.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:l.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:l.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:l.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:l.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:l.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:l.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:l.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:l.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:l.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:l.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:l.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:l.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:l.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:l.localize(32,null)},{label:"onUri",body:"onUri",description:l.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:l.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:l.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:l.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:l.localize(37,null)},{label:"onRenderer",description:l.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:l.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:l.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:l.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:l.localize(42,null)},{label:"*",description:l.localize(43,null),body:"*"}]}},badges:{type:"array",description:l.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:l.localize(45,null)},href:{type:"string",description:l.localize(46,null)},description:{type:"string",description:l.localize(47,null)}}}},markdown:{type:"string",description:l.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:l.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:l.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.$Bo}},extensionPack:{description:l.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.$Bo}},extensionKind:{description:l.localize(52,null),type:"array",items:m,default:["workspace"],defaultSnippets:[{body:["ui"],description:l.localize(53,null)},{body:["workspace"],description:l.localize(54,null)},{body:["ui","workspace"],description:l.localize(55,null)},{body:["workspace","ui"],description:l.localize(56,null)},{body:[],description:l.localize(57,null)}]},capabilities:{description:l.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:l.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:l.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[l.localize(61,null),l.localize(62,null),l.localize(63,null)]},description:{type:"string",markdownDescription:l.localize(64,null)}}},untrustedWorkspaces:{description:l.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:l.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[l.localize(67,null),l.localize(68,null),l.localize(69,null)]},restrictedConfigurations:{description:l.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:l.localize(71,null)}}}}},sponsor:{description:l.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:l.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:l.localize(74,null),type:"string"},"vscode:uninstall":{description:l.localize(75,null),type:"string"}}},icon:{type:"string",description:l.localize(76,null)},l10n:{type:"string",description:l.localize(77,null)},pricing:{type:"string",markdownDescription:l.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class i{constructor(){this.a=new Map}registerExtensionPoint(c){if(this.a.has(c.extensionPoint))throw new Error("Duplicate extension point: "+c.extensionPoint);const t=new u(c.extensionPoint,c.defaultExtensionKind);return this.a.set(c.extensionPoint,t),c.activationEventsGenerator&&C.$DF.register(c.extensionPoint,c.activationEventsGenerator),e.$PF.properties.contributes.properties[c.extensionPoint]=c.jsonSchema,v.registerSchema(o,e.$PF),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$QF=i;const n={ExtensionsRegistry:"ExtensionsRegistry"};p.$Wn.add(n.ExtensionsRegistry,new i),e.$RF=p.$Wn.as(n.ExtensionsRegistry),v.registerSchema(o,e.$PF),v.registerSchema(M.$Sj,{properties:{extensionEnabledApiProposals:{description:l.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}}]}}}})}),define(Se[301],De([1,0,235,18,24,300,45,4]),function(fe,e,l,j,L,A,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fH=void 0;const w={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:l.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:l.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:l.localize(2,null),default:""}}};var E;(function(v){function S(k,u,m){if(!k)return;const o=j.$Sf(k.type)?k.type:void 0;if(!o||o.length===0){m.error(l.localize(3,null));return}const i=[];if(Array.isArray(k.required))for(const n of k.required)j.$Sf(n)&&i.push(n);return{extensionId:u.value,taskType:o,required:i,properties:k.properties?L.$Kn(k.properties):{},when:k.when?R.$dj.deserialize(k.when):void 0}}v.from=S})(E||(E={}));const M=A.$RF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(v,S)=>{for(const k of v)k.type&&S.push(`onTaskType:${k.type}`)},jsonSchema:{description:l.localize(4,null),type:"array",items:w}});class C{constructor(){this.d=new p.$5d,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((S,k)=>{M.setHandler((u,m)=>{this.c=void 0;try{for(const o of m.removed){const i=o.value;for(const n of i)this.a&&n.type&&this.a[n.type]&&delete this.a[n.type]}for(const o of m.added){const i=o.value;for(const n of i){const s=E.from(n,o.description.identifier,o.collector);s&&(this.a[s.taskType]=s)}}(m.removed.length>0||m.added.length>0)&&this.d.fire()}catch{}S(void 0)})})}onReady(){return this.b}get(S){return this.a[S]}all(){return Object.keys(this.a).map(S=>this.a[S])}getJsonSchema(){if(this.c===void 0){const S=[];for(const k of this.all()){const u={type:"object",additionalProperties:!1};k.required.length>0&&(u.required=k.required.slice(0)),k.properties!==void 0?u.properties=L.$Kn(k.properties):u.properties=Object.create(null),u.properties.type={type:"string",enum:[k.taskType]},S.push(u)}this.c={oneOf:S}}return this.c}}e.$fH=new C}),define(Se[302],De([1,0,236,18,23,24,45,301]),function(fe,e,l,j,L,A,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$pH=e.JsonSchemaVersion=e.ExecutionEngine=e.$oH=e.$nH=e.$mH=e.$lH=e.$kH=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$jH=e.ShellQuoting=e.$iH=e.$hH=e.$gH=void 0,e.$gH="settings",e.$hH=new R.$wj("taskRunning",!1,l.localize(0,null)),e.$iH=l.localize2(2,"Tasks");var w;(function(I){I[I.Escape=1]="Escape",I[I.Strong=2]="Strong",I[I.Weak=3]="Weak"})(w||(e.ShellQuoting=w={})),e.$jH="$customized",function(I){function O(T){if(!T)return I.Strong;switch(T.toLowerCase()){case"escape":return I.Escape;case"strong":return I.Strong;case"weak":return I.Weak;default:return I.Strong}}I.from=O}(w||(e.ShellQuoting=w={}));var E;(function(I){I.defaults={cwd:"${workspaceFolder}"}})(E||(e.CommandOptions=E={}));var M;(function(I){I[I.Always=1]="Always",I[I.Silent=2]="Silent",I[I.Never=3]="Never"})(M||(e.RevealKind=M={})),function(I){function O(T){switch(T.toLowerCase()){case"always":return I.Always;case"silent":return I.Silent;case"never":return I.Never;default:return I.Always}}I.fromString=O}(M||(e.RevealKind=M={}));var C;(function(I){I[I.Never=1]="Never",I[I.OnProblem=2]="OnProblem",I[I.Always=3]="Always"})(C||(e.RevealProblemKind=C={})),function(I){function O(T){switch(T.toLowerCase()){case"always":return I.Always;case"never":return I.Never;case"onproblem":return I.OnProblem;default:return I.OnProblem}}I.fromString=O}(C||(e.RevealProblemKind=C={}));var v;(function(I){I[I.Shared=1]="Shared",I[I.Dedicated=2]="Dedicated",I[I.New=3]="New"})(v||(e.PanelKind=v={})),function(I){function O(T){switch(T.toLowerCase()){case"shared":return I.Shared;case"dedicated":return I.Dedicated;case"new":return I.New;default:return I.Shared}}I.fromString=O}(v||(e.PanelKind=v={}));var S;(function(I){I.defaults={echo:!0,reveal:M.Always,revealProblems:C.Never,focus:!1,panel:v.Shared,showReuseMessage:!0,clear:!1}})(S||(e.PresentationOptions=S={}));var k;(function(I){I[I.Shell=1]="Shell",I[I.Process=2]="Process",I[I.CustomExecution=3]="CustomExecution"})(k||(e.RuntimeType=k={})),function(I){function O(G){switch(G.toLowerCase()){case"shell":return I.Shell;case"process":return I.Process;case"customExecution":return I.CustomExecution;default:return I.Process}}I.fromString=O;function T(G){switch(G){case I.Shell:return"shell";case I.Process:return"process";case I.CustomExecution:return"customExecution";default:return"process"}}I.toString=T}(k||(e.RuntimeType=k={}));var u;(function(I){function O(T){return j.$Sf(T)?T:T.value}I.value=O})(u||(e.CommandString=u={}));var m;(function(I){I.Clean={_id:"clean",isDefault:!1},I.Build={_id:"build",isDefault:!1},I.Rebuild={_id:"rebuild",isDefault:!1},I.Test={_id:"test",isDefault:!1};function O(G){return G===I.Clean._id||G===I.Build._id||G===I.Rebuild._id||G===I.Test._id}I.is=O;function T(G){if(G!==void 0)return j.$Sf(G)?O(G)?{_id:G,isDefault:!1}:void 0:G}I.from=T})(m||(e.TaskGroup=m={}));var o;(function(I){I[I.Global=1]="Global",I[I.Workspace=2]="Workspace",I[I.Folder=3]="Folder"})(o||(e.TaskScope=o={}));var i;(function(I){I.Workspace="workspace",I.Extension="extension",I.InMemory="inMemory",I.WorkspaceFile="workspaceFile",I.User="user";function O(T){switch(T){case I.User:return 2;case I.WorkspaceFile:return 5;default:return 6}}I.toConfigurationTarget=O})(i||(e.TaskSourceKind=i={}));var n;(function(I){I.parallel="parallel",I.sequence="sequence"})(n||(e.DependsOrder=n={}));var s;(function(I){I[I.default=1]="default",I[I.folderOpen=2]="folderOpen"})(s||(e.RunOnOptions=s={}));var c;(function(I){I.defaults={reevaluateOnRerun:!0,runOn:s.default,instanceLimit:1}})(c||(e.RunOptions=c={}));class t{constructor(O,T,G,te,x,X){this._label="",this._id=O,T&&(this._label=T),G&&(this.type=G),this.runOptions=te,this.configurationProperties=x,this._source=X}getDefinition(O){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const O={folder:this.d(),id:this._id};return JSON.stringify(O)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(O,T=!1){if(O===void 0)return!1;if(j.$Sf(O))return O===this._label||O===this.configurationProperties.identifier||T&&O===this._id;const G=this.getDefinition(!0);return G!==void 0&&G._key===O._key}getQualifiedLabel(){const O=this.getWorkspaceFolder();return O?`${this._label} (${O.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(O){this.c===void 0&&(this.c=[]),O&&(this.c=this.c.concat(O))}get taskLoadMessages(){return this.c}}e.$kH=t;class f extends t{constructor(O,T,G,te,x,X,Q,ae){super(O,G,void 0,Q,ae,T),this.command={},this._source=T,this.hasDefinedMatchers=X,x&&(this.command=x)}clone(){return new f(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(O=!1){if(O&&this._source.customizes!==void 0)return this._source.customizes;{let T;switch(this.command?this.command.runtime:void 0){case k.Shell:T="shell";break;case k.Process:T="process";break;case k.CustomExecution:T="customExecution";break;case void 0:T="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:T,_key:this._id,id:this._id}}}static is(O){return O instanceof f}getMapKey(){const O=this._source.config.workspaceFolder;return O?`${O.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$gH:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const O=this.d();if(!O)return;let T=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(T+=this._source.kind);const G={type:e.$jH,folder:O,id:T};return JSON.stringify(G)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?L.$Pg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(O){return new f(O._id,O._source,O._label,O.type,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$lH=f;class h extends t{constructor(O,T,G,te,x,X,Q){super(O,G,te,X,Q,T),this._source=T,this.configures=x}static is(O){return O instanceof h}f(O){return O}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?L.$Pg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$gH:this._source.config.workspaceFolder?.uri.toString()}getKey(){const O=this.d();if(!O)return;let T=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(T+=this._source.kind);const G={type:e.$jH,folder:O,id:T};return JSON.stringify(G)}}e.$mH=h;class r extends t{constructor(O,T,G,te,x,X,Q,ae,_){super(O,G,te,ae,_,T),this.defines=x,this.hasDefinedMatchers=Q,this.command=X,this.icon=_.icon,this.hide=_.hide}clone(){return new r(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(O){return O instanceof r}getMapKey(){const O=this._source.workspaceFolder;return O?`${this._source.scope.toString()}|${O.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const O={type:"contributed",scope:this._source.scope,id:this._id};return O.folder=this.d(),JSON.stringify(O)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(O){return new r(O._id,O._source,O._label,O.type,O.defines,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$nH=r;class a extends t{constructor(O,T,G,te,x,X){super(O,G,te,x,X,T),this._source=T}clone(){return new a(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(O){return O instanceof a}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(O){return new a(O._id,O._source,O._label,O.type,O.runOptions,O.configurationProperties)}}e.$oH=a;var d;(function(I){I[I.Process=1]="Process",I[I.Terminal=2]="Terminal"})(d||(e.ExecutionEngine=d={})),function(I){I._default=I.Terminal}(d||(e.ExecutionEngine=d={}));var $;(function(I){I[I.V0_1_0=1]="V0_1_0",I[I.V2_0_0=2]="V2_0_0"})($||(e.JsonSchemaVersion=$={}));class D{constructor(O){this.c=new Map;for(let T=0;T<O.length;T++)this.c.set(O[T].uri.toString(),T)}compare(O,T){const G=O.getWorkspaceFolder(),te=T.getWorkspaceFolder();if(G&&te){let x=this.c.get(G.uri.toString());x=x===void 0?0:x+1;let X=this.c.get(te.uri.toString());return X=X===void 0?0:X+1,x===X?O._label.localeCompare(T._label):x-X}else return!G&&te?-1:G&&!te?1:0}}e.$pH=D;var b;(function(I){I.DependsOnStarted="dependsOnStarted",I.AcquiredInput="acquiredInput",I.Start="start",I.ProcessStarted="processStarted",I.Active="active",I.Inactive="inactive",I.Changed="changed",I.Terminated="terminated",I.ProcessEnded="processEnded",I.End="end"})(b||(e.TaskEventKind=b={}));var g;(function(I){I.SingleRun="singleRun",I.Background="background"})(g||(e.TaskRunType=g={}));var y;(function(I){I[I.System=0]="System",I[I.User=1]="User",I[I.FolderOpen=2]="FolderOpen",I[I.ConfigurationChange=3]="ConfigurationChange",I[I.Reconnect=4]="Reconnect"})(y||(e.TaskRunSource=y={}));var P;(function(I){function O(ae){return{taskId:ae._id,taskName:ae.configurationProperties.name,runType:ae.configurationProperties.isBackground?"background":"singleRun",group:ae.configurationProperties.group,__task:ae}}function T(ae,_,ge){return{...O(ae),kind:"start",terminalId:_,resolvedVariables:ge}}I.start=T;function G(ae,_,ge){return{...O(ae),kind:"processStarted",terminalId:_,processId:ge}}I.processStarted=G;function te(ae,_,ge){return{...O(ae),kind:"processEnded",terminalId:_,exitCode:ge}}I.processEnded=te;function x(ae,_,ge){return{...O(ae),kind:"terminated",exitReason:ge,terminalId:_}}I.terminated=x;function X(ae,_,ge){return{...O(_),kind:ae,terminalId:ge}}I.general=X;function Q(){return{kind:"changed"}}I.changed=Q})(P||(e.TaskEvent=P={}));var N;(function(I){function O(G){const te=Object.keys(G).sort();let x="";for(const X of te){let Q=G[X];Q instanceof Object?Q=O(Q):typeof Q=="string"&&(Q=Q.replace(/,/g,",,")),x+=X+","+Q+","}return x}function T(G){const x={_key:O(G),type:G.taskType};return Object.assign(x,G),x}I.create=T})(N||(e.KeyedTaskIdentifier=N={}));var U;(function(I){I.AutoDetect="task.autoDetect",I.SaveBeforeRun="task.saveBeforeRun",I.ShowDecorations="task.showDecorations",I.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",I.SlowProviderWarning="task.slowProviderWarning",I.QuickOpenHistory="task.quickOpen.history",I.QuickOpenDetail="task.quickOpen.detail",I.QuickOpenSkip="task.quickOpen.skip",I.QuickOpenShowAll="task.quickOpen.showAll",I.AllowAutomaticTasks="task.allowAutomaticTasks",I.Reconnection="task.reconnection",I.VerboseLogging="task.verboseLogging"})(U||(e.TaskSettingId=U={}));var z;(function(I){I.Tasks="tasks",I.SuppressTaskName="tasks.suppressTaskName",I.Windows="tasks.windows",I.Osx="tasks.osx",I.Linux="tasks.linux",I.ShowOutput="tasks.showOutput",I.IsShellCommand="tasks.isShellCommand",I.ServiceTestSetting="tasks.service.testSetting"})(z||(e.TasksSchemaProperties=z={}));var F;(function(I){function O(T,G){const te=p.$fH.get(T.type);if(te===void 0){const ae=A.$Kn(T);return delete ae._key,N.create(ae)}const x=Object.create(null);x.type=te.taskType;const X=new Set;te.required.forEach(ae=>X.add(ae));const Q=te.properties;for(const ae of Object.keys(Q)){const _=T[ae];if(_!=null)x[ae]=_;else if(X.has(ae)){const ge=Q[ae];if(ge.default!==void 0)x[ae]=A.$Kn(ge.default);else switch(ge.type){case"boolean":x[ae]=!1;break;case"number":case"integer":x[ae]=0;break;case"string":x[ae]="";break;default:G.error(l.localize(1,null,JSON.stringify(T,void 0,0),ae));return}}}return N.create(x)}I.createTaskIdentifier=O})(F||(e.TaskDefinition=F={}))}),define(Se[303],De([1,0,13]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T9b=e.$S9b=void 0;class j{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,p)=>{this.b=R,this.d=p,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,l.$1)(R))}then(R,p){return this.j().then(R,p)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$S9b=j;class L extends j{constructor(){super(),this.h=!0,this.i=new l.$5}}e.$T9b=L}),define(Se[67],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9v=e.$8v=e.$7v=e.$6v=void 0;class l{static{this.count=0}constructor(w){this._proxyIdentifierBrand=void 0,this.sid=w,this.nid=++l.count}}e.$6v=l;const j=[];function L(p){const w=new l(p);return j[w.nid]=w,w}e.$7v=L;function A(p){return j[p].sid}e.$8v=A;class R{constructor(w){this.value=w}}e.$9v=R}),define(Se[6],De([1,0,67]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7L=e.$6L=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$5L=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var j;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(j||(e.TextEditorRevealType=j={}));var L;(function(u){u[u.UnknownInput=0]="UnknownInput",u[u.TextInput=1]="TextInput",u[u.TextDiffInput=2]="TextDiffInput",u[u.TextMergeInput=3]="TextMergeInput",u[u.NotebookInput=4]="NotebookInput",u[u.NotebookDiffInput=5]="NotebookDiffInput",u[u.CustomEditorInput=6]="CustomEditorInput",u[u.WebviewEditorInput=7]="WebviewEditorInput",u[u.TerminalEditorInput=8]="TerminalEditorInput",u[u.InteractiveEditorInput=9]="InteractiveEditorInput",u[u.ChatEditorInput=10]="ChatEditorInput"})(L||(e.TabInputKind=L={}));var A;(function(u){u[u.TAB_OPEN=0]="TAB_OPEN",u[u.TAB_CLOSE=1]="TAB_CLOSE",u[u.TAB_UPDATE=2]="TAB_UPDATE",u[u.TAB_MOVE=3]="TAB_MOVE"})(A||(e.TabModelOperationKind=A={}));var R;(function(u){u[u.Editable=0]="Editable",u[u.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var p;(function(u){u[u.Int8Array=1]="Int8Array",u[u.Uint8Array=2]="Uint8Array",u[u.Uint8ClampedArray=3]="Uint8ClampedArray",u[u.Int16Array=4]="Int16Array",u[u.Uint16Array=5]="Uint16Array",u[u.Int32Array=6]="Int32Array",u[u.Uint32Array=7]="Uint32Array",u[u.Float32Array=8]="Float32Array",u[u.Float64Array=9]="Float64Array",u[u.BigInt64Array=10]="BigInt64Array",u[u.BigUint64Array=11]="BigUint64Array"})(p||(e.WebviewMessageArrayBufferViewType=p={}));var w;(function(u){u[u.Text=1]="Text",u[u.Error=2]="Error",u[u.Rich=3]="Rich"})(w||(e.CellOutputKind=w={}));var E;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(E||(e.NotebookEditorRevealType=E={}));var M;(function(u){u[u.None=0]="None",u[u.Process=1]="Process",u[u.Output=2]="Output"})(M||(e.CandidatePortSource=M={}));class C{static{this.a=0}static mixin(m){return m._id=C.a++,m}}e.$5L=C;var v;(function(u){u.label="a",u.kind="b",u.detail="c",u.documentation="d",u.sortText="e",u.filterText="f",u.preselect="g",u.insertText="h",u.insertTextRules="i",u.range="j",u.commitCharacters="k",u.additionalTextEdits="l",u.kindModifier="m",u.commandIdent="n",u.commandId="o",u.commandArguments="p"})(v||(e.ISuggestDataDtoField=v={}));var S;(function(u){u.defaultRanges="a",u.completions="b",u.isIncomplete="c",u.duration="d"})(S||(e.ISuggestResultDtoField=S={}));var k;(function(u){u[u.Workspace=0]="Workspace",u[u.TextDocument=1]="TextDocument"})(k||(e.ExtHostTestingResource=k={})),e.$6L={MainThreadAuthentication:(0,l.$7v)("MainThreadAuthentication"),MainThreadBulkEdits:(0,l.$7v)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,l.$7v)("MainThreadLanguageModels"),MainThreadChatAgents2:(0,l.$7v)("MainThreadChatAgents2"),MainThreadChatVariables:(0,l.$7v)("MainThreadChatVariables"),MainThreadClipboard:(0,l.$7v)("MainThreadClipboard"),MainThreadCommands:(0,l.$7v)("MainThreadCommands"),MainThreadComments:(0,l.$7v)("MainThreadComments"),MainThreadConfiguration:(0,l.$7v)("MainThreadConfiguration"),MainThreadConsole:(0,l.$7v)("MainThreadConsole"),MainThreadDebugService:(0,l.$7v)("MainThreadDebugService"),MainThreadDecorations:(0,l.$7v)("MainThreadDecorations"),MainThreadDiagnostics:(0,l.$7v)("MainThreadDiagnostics"),MainThreadDialogs:(0,l.$7v)("MainThreadDiaglogs"),MainThreadDocuments:(0,l.$7v)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,l.$7v)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,l.$7v)("MainThreadTextEditors"),MainThreadEditorInsets:(0,l.$7v)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,l.$7v)("MainThreadEditorTabs"),MainThreadErrors:(0,l.$7v)("MainThreadErrors"),MainThreadTreeViews:(0,l.$7v)("MainThreadTreeViews"),MainThreadDownloadService:(0,l.$7v)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,l.$7v)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,l.$7v)("MainThreadLanguages"),MainThreadLogger:(0,l.$7v)("MainThreadLogger"),MainThreadMessageService:(0,l.$7v)("MainThreadMessageService"),MainThreadOutputService:(0,l.$7v)("MainThreadOutputService"),MainThreadProgress:(0,l.$7v)("MainThreadProgress"),MainThreadQuickDiff:(0,l.$7v)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,l.$7v)("MainThreadQuickOpen"),MainThreadStatusBar:(0,l.$7v)("MainThreadStatusBar"),MainThreadSecretState:(0,l.$7v)("MainThreadSecretState"),MainThreadStorage:(0,l.$7v)("MainThreadStorage"),MainThreadSpeech:(0,l.$7v)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,l.$7v)("MainThreadTelemetry"),MainThreadTerminalService:(0,l.$7v)("MainThreadTerminalService"),MainThreadWebviews:(0,l.$7v)("MainThreadWebviews"),MainThreadWebviewPanels:(0,l.$7v)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,l.$7v)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,l.$7v)("MainThreadCustomEditors"),MainThreadUrls:(0,l.$7v)("MainThreadUrls"),MainThreadUriOpeners:(0,l.$7v)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,l.$7v)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,l.$7v)("MainThreadWorkspace"),MainThreadFileSystem:(0,l.$7v)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,l.$7v)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,l.$7v)("MainThreadExtensionService"),MainThreadSCM:(0,l.$7v)("MainThreadSCM"),MainThreadSearch:(0,l.$7v)("MainThreadSearch"),MainThreadShare:(0,l.$7v)("MainThreadShare"),MainThreadTask:(0,l.$7v)("MainThreadTask"),MainThreadWindow:(0,l.$7v)("MainThreadWindow"),MainThreadLabelService:(0,l.$7v)("MainThreadLabelService"),MainThreadNotebook:(0,l.$7v)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,l.$7v)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,l.$7v)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,l.$7v)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,l.$7v)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,l.$7v)("MainThreadInteractive"),MainThreadChat:(0,l.$7v)("MainThreadChat"),MainThreadInlineChat:(0,l.$7v)("MainThreadInlineChatShape"),MainThreadTheming:(0,l.$7v)("MainThreadTheming"),MainThreadTunnelService:(0,l.$7v)("MainThreadTunnelService"),MainThreadManagedSockets:(0,l.$7v)("MainThreadManagedSockets"),MainThreadTimeline:(0,l.$7v)("MainThreadTimeline"),MainThreadTesting:(0,l.$7v)("MainThreadTesting"),MainThreadLocalization:(0,l.$7v)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,l.$7v)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,l.$7v)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,l.$7v)("MainThreadIssueReporter")},e.$7L={ExtHostCommands:(0,l.$7v)("ExtHostCommands"),ExtHostConfiguration:(0,l.$7v)("ExtHostConfiguration"),ExtHostDiagnostics:(0,l.$7v)("ExtHostDiagnostics"),ExtHostDebugService:(0,l.$7v)("ExtHostDebugService"),ExtHostDecorations:(0,l.$7v)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,l.$7v)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,l.$7v)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,l.$7v)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,l.$7v)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,l.$7v)("ExtHostEditors"),ExtHostTreeViews:(0,l.$7v)("ExtHostTreeViews"),ExtHostFileSystem:(0,l.$7v)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,l.$7v)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,l.$7v)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,l.$7v)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,l.$7v)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,l.$7v)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,l.$7v)("ExtHostQuickDiff"),ExtHostStatusBar:(0,l.$7v)("ExtHostStatusBar"),ExtHostShare:(0,l.$7v)("ExtHostShare"),ExtHostExtensionService:(0,l.$7v)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,l.$7v)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,l.$7v)("ExtHostTerminalService"),ExtHostSCM:(0,l.$7v)("ExtHostSCM"),ExtHostSearch:(0,l.$7v)("ExtHostSearch"),ExtHostTask:(0,l.$7v)("ExtHostTask"),ExtHostWorkspace:(0,l.$7v)("ExtHostWorkspace"),ExtHostWindow:(0,l.$7v)("ExtHostWindow"),ExtHostWebviews:(0,l.$7v)("ExtHostWebviews"),ExtHostWebviewPanels:(0,l.$7v)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,l.$7v)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,l.$7v)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,l.$7v)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,l.$7v)("ExtHostEditorTabs"),ExtHostProgress:(0,l.$7v)("ExtHostProgress"),ExtHostComments:(0,l.$7v)("ExtHostComments"),ExtHostSecretState:(0,l.$7v)("ExtHostSecretState"),ExtHostStorage:(0,l.$7v)("ExtHostStorage"),ExtHostUrls:(0,l.$7v)("ExtHostUrls"),ExtHostUriOpeners:(0,l.$7v)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,l.$7v)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,l.$7v)("ExtHostOutputService"),ExtHostLabelService:(0,l.$7v)("ExtHostLabelService"),ExtHostNotebook:(0,l.$7v)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,l.$7v)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,l.$7v)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,l.$7v)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,l.$7v)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,l.$7v)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,l.$7v)("ExtHostInteractive"),ExtHostInlineChat:(0,l.$7v)("ExtHostInlineChatShape"),ExtHostChat:(0,l.$7v)("ExtHostChat"),ExtHostChatAgents2:(0,l.$7v)("ExtHostChatAgents"),ExtHostChatVariables:(0,l.$7v)("ExtHostChatVariables"),ExtHostChatProvider:(0,l.$7v)("ExtHostChatProvider"),ExtHostSpeech:(0,l.$7v)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,l.$7v)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,l.$7v)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,l.$7v)("ExtHostTheming"),ExtHostTunnelService:(0,l.$7v)("ExtHostTunnelService"),ExtHostManagedSockets:(0,l.$7v)("ExtHostManagedSockets"),ExtHostAuthentication:(0,l.$7v)("ExtHostAuthentication"),ExtHostTimeline:(0,l.$7v)("ExtHostTimeline"),ExtHostTesting:(0,l.$7v)("ExtHostTesting"),ExtHostTelemetry:(0,l.$7v)("ExtHostTelemetry"),ExtHostLocalization:(0,l.$7v)("ExtHostLocalization"),ExtHostIssueReporter:(0,l.$7v)("ExtHostIssueReporter")}}),define(Se[91],De([1,0,5,12,6,20]),function(fe,e,l,j,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rhc=e.$Qhc=e.$Phc=void 0,e.$Phc=(0,l.$fi)("IExtHostApiDeprecationService");let R=class{constructor(w,E){this.c=E,this.a=new Set,this.b=w.getProxy(L.$6L.MainThreadTelemetry)}report(w,E,M){const C=this.d(w,E);this.a.has(C)||(this.a.add(C),E.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${w}' is deprecated. ${M}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:E.identifier.value,apiId:w}))}d(w,E){return`${w}-${E.identifier.value}`}};e.$Qhc=R,e.$Qhc=R=Ye([Ve(0,A.$lO),Ve(1,j.$zj)],R),e.$Rhc=Object.freeze(new class{report(p,w,E){}})}),define(Se[304],De([1,0,48,3,6]),function(fe,e,l,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3hc=void 0;class A{static{this.a=0}constructor(w,E){this.extension=w,this.provider=E,this.handle=A.a++}}class R{static{this.a=0}constructor(w){this.b=new Map,this.c=new Map,this.d=w.getProxy(L.$6L.MainThreadChat)}registerChatProvider(w,E,M){const C=new A(w,M);return this.b.set(C.handle,C),this.d.$registerChatProvider(C.handle,E),(0,j.$Rc)(()=>{this.d.$unregisterChatProvider(C.handle),this.b.delete(C.handle)})}transferChatSession(w,E){const M=l.Iterable.find(this.c.keys(),C=>this.c.get(C)===w)??0;typeof M=="number"&&this.d.$transferChatSession(M,E)}sendInteractiveRequestToProvider(w,E){this.d.$sendRequestToProvider(w,E)}async $prepareChat(w,E){const M=this.b.get(w);if(!M)return;const C=await M.provider.prepareSession(E);if(!C)return;const v=R.a++;return this.c.set(v,C),{id:v,requesterUsername:C.requester?.name,requesterAvatarIconUri:C.requester?.icon,responderUsername:C.responder?.name,responderAvatarIconUri:C.responder?.icon,inputPlaceholder:C.inputPlaceholder}}$releaseSession(w){this.c.delete(w)}}e.$3hc=R}),define(Se[305],De([1,0,6]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8hc=void 0;class j{constructor(A){const R=A.getProxy(l.$6L.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(p){return R.$writeText(p)}})}}e.$8hc=j}),define(Se[306],De([1,0,24,6,27,20]),function(fe,e,l,j,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yjc=void 0;let R=class{constructor(M,C){this.a=M.getProxy(j.$6L.MainThreadConsole),this.b=C.consoleForward.includeStack,this.c=C.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(M,C){const v=this,S=console[M];Object.defineProperty(console,M,{set:()=>{},get:()=>function(){v.e(M,C,S,arguments)}})}e(M,C,v,S){this.a.$logExtensionHostMessage({type:"__$console",severity:C,arguments:w(S,this.b)}),this.c&&this.f(M,v,S)}};e.$Yjc=R,e.$Yjc=R=Ye([Ve(0,A.$lO),Ve(1,L.$BO)],R);const p=1e5;function w(E,M){const C=[];if(E.length)for(let v=0;v<E.length;v++){let S=E[v];if(typeof S>"u")S="undefined";else if(S instanceof Error){const k=S;k.stack?S=k.stack:S=k.toString()}C.push(S)}if(M){const v=new Error().stack;v&&C.push({__$stack:v.split(`
`).slice(3).join(`
`)})}try{const v=(0,l.$Pn)(C);return v.length>p?"Output omitted for a large object that exceeds the limits":v}catch(v){return`Output omitted for an object that cannot be inspected ('${v.toString()}')`}}}),define(Se[307],De([1,0,2,6,26]),function(fe,e,l,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ic=void 0;class A{constructor(p){this.a=p.getProxy(j.$6L.MainThreadDialogs)}showOpenDialog(p,w){return w?.allowUIResources&&(0,L.$YF)(p,"showLocal"),this.a.$showOpenDialog(w).then(E=>E?E.map(M=>l.URI.revive(M)):void 0)}showSaveDialog(p){return this.a.$showSaveDialog(p).then(w=>w?l.URI.revive(w):void 0)}}e.$3ic=A}),define(Se[308],De([1,0,3,6]),function(fe,e,l,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ljc=void 0;class L{constructor(R){this.b=0,this.a=R.getProxy(j.$6L.MainThreadLabelService)}$registerResourceLabelFormatter(R){const p=this.b++;return this.a.$registerResourceLabelFormatter(p,R),(0,l.$Rc)(()=>{this.a.$unregisterResourceLabelFormatter(p)})}}e.$ljc=L}),define(Se[115],De([1,0,11,14,2,5,12,6,27,20]),function(fe,e,l,j,L,A,R,p,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lic=e.$Kic=void 0;let M=class{constructor(v,S,k){this.f=k,this.d=new Map,this.a=S.getProxy(p.$6L.MainThreadLocalization),this.b=v.environment.appLanguage,this.c=this.b===l.$g}getMessage(v,S){const{message:k,args:u,comment:m}=S;if(this.c)return(0,j.$Ue)(k,u??{});let o=k;m&&m.length>0&&(o+=`/${Array.isArray(m)?m.join(""):m}`);const i=this.d.get(v)?.contents[o];return i||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${o}`),(0,j.$Ue)(i??k,u??{})}getBundle(v){return this.d.get(v)?.contents}getBundleUri(v){return this.d.get(v)?.uri}async initializeLocalizedMessages(v){if(this.c||!v.l10n&&!v.isBuiltin||this.d.has(v.identifier.value))return;let S;const k=await this.g(v);if(!k){this.f.error(`No bundle location found for extension ${v.identifier.value}`);return}try{const u=await this.a.$fetchBundleContents(k),m=JSON.parse(u);S=v.isBuiltin?m.contents?.bundle:m}catch(u){this.f.error(`Failed to load translations for ${v.identifier.value} from ${k}: ${u.message}`);return}S&&this.d.set(v.identifier.value,{contents:S,uri:k})}async g(v){if(v.isBuiltin){const S=await this.a.$fetchBuiltInBundleUri(v.identifier.value,this.b);return L.URI.revive(S)}return v.l10n?L.URI.joinPath(v.extensionLocation,v.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Kic=M,e.$Kic=M=Ye([Ve(0,w.$BO),Ve(1,E.$lO),Ve(2,R.$zj)],M),e.$Lic=(0,A.$fi)("IExtHostLocalizationService")}),define(Se[149],De([1,0,12,6,27,20,2,56]),function(fe,e,l,j,L,A,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xjc=void 0;let w=class extends l.$Kj{constructor(C,v){super(v.logLevel,v.logsLocation,v.loggers.map(S=>(0,p.$Oh)(S))),this.r=C.getProxy(j.$6L.MainThreadLogger)}$setLogLevel(C,v){v?this.setLogLevel(R.URI.revive(v),C):this.setLogLevel(C)}setVisibility(C,v){super.setVisibility(C,v),this.r.$setVisibility(C,v)}s(C,v,S){return new E(this.r,C,v,S)}};e.$Xjc=w,e.$Xjc=w=Ye([Ve(0,A.$lO),Ve(1,L.$BO)],w);class E extends l.$Fj{constructor(C,v,S,k){super(k?.logLevel==="always"),this.r=C,this.s=v,this.m=!1,this.n=[],this.setLevel(S),this.r.$createLogger(v,k).then(()=>{this.u(this.n),this.m=!0})}g(C,v){const S=[[C,v]];this.m?this.u(S):this.n.push(...S)}u(C){this.r.$log(this.s,C)}flush(){this.r.$flush(this.s)}}}),define(Se[116],De([1,0,6,5,3,20,21]),function(fe,e,l,j,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nic=e.$Mic=void 0,e.$Mic=(0,j.$fi)("IExtHostManagedSockets");let p=class{constructor(C){this.b=0,this.c=null,this.d=new Map,this.a=C.getProxy(l.$6L.MainThreadManagedSockets)}setFactory(C,v){for(const S of this.d.values())S.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new w(C,v),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(C){if(!this.c||this.c.socketFactoryId!==C)throw new Error(`No socket factory with id ${C}`);const v=++this.b,S=await this.c.makeConnection(),k=new L.$Sc;return this.d.set(v,new E(v,S,k)),k.add((0,L.$Rc)(()=>this.d.delete(v))),k.add(S.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(v),k.dispose()})),k.add(S.onDidClose(u=>{this.a.$onDidManagedSocketClose(v,u?.stack??u?.message),k.dispose()})),k.add(S.onDidReceiveMessage(u=>this.a.$onDidManagedSocketHaveData(v,R.$se.wrap(u)))),v}$remoteSocketWrite(C,v){this.d.get(C)?.actual.send(v.buffer)}$remoteSocketEnd(C){const v=this.d.get(C);v&&(v.actual.end(),v.dispose())}async $remoteSocketDrain(C){await this.d.get(C)?.actual.drain?.()}};e.$Nic=p,e.$Nic=p=Ye([Ve(0,A.$lO)],p);class w{constructor(C,v){this.socketFactoryId=C,this.makeConnection=v}}class E extends L.$Tc{constructor(C,v,S){super(),this.socketId=C,this.actual=v,this.B(S)}}}),define(Se[309],De([1,0,6,12,26]),function(fe,e,l,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$njc=void 0;function A(p){return p&&p.title}let R=class{constructor(w,E){this.b=E,this.a=w.getProxy(l.$6L.MainThreadMessageService)}showMessage(w,E,M,C,v){const S={source:{identifier:w.identifier,label:w.displayName||w.name}};let k;typeof C=="string"||A(C)?k=[C,...v]:(S.modal=C?.modal,S.useCustom=C?.useCustom,S.detail=C?.detail,k=v),S.useCustom&&(0,L.$YF)(w,"resolvers");const u=[];let m=!1;for(let o=0;o<k.length;o++){const i=k[o];if(typeof i=="string")u.push({title:i,handle:o,isCloseAffordance:!1});else if(typeof i=="object"){const{title:n,isCloseAffordance:s}=i;u.push({title:n,isCloseAffordance:!!s,handle:o}),s&&(m?this.b.warn(`[${w.identifier}] Only one message item can have 'isCloseAffordance':`,i):m=!0)}else this.b.warn(`[${w.identifier}] Invalid message item:`,i)}return this.a.$showMessage(E,M,S,u).then(o=>{if(typeof o=="number")return k[o]})}};e.$njc=R,e.$njc=R=Ye([Ve(1,j.$zj)],R)}),define(Se[310],De([1,0,3,18,2,26,6]),function(fe,e,l,j,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wjc=void 0;class p{constructor(E){this.b=new Map,this.a=E.getProxy(R.$6L.MainThreadProfileContentHandlers)}registerProfileContentHandler(E,M,C){if((0,A.$YF)(E,"profileContentHandlers"),this.b.has(M))throw new Error(`Handler with id '${M}' already registered`);return this.b.set(M,C),this.a.$registerProfileContentHandler(M,C.name,C.description,E.identifier.value),(0,l.$Rc)(()=>{this.b.delete(M),this.a.$unregisterProfileContentHandler(M)})}async $saveProfile(E,M,C,v){const S=this.b.get(E);if(!S)throw new Error(`Unknown handler with id: ${E}`);return S.saveProfile(M,C,v)}async $readProfile(E,M,C){const v=this.b.get(E);if(!v)throw new Error(`Unknown handler with id: ${E}`);return v.readProfile((0,j.$Sf)(M)?M:L.URI.revive(M),C)}}e.$wjc=p}),define(Se[117],De([1,0,6,4,5]),function(fe,e,l,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iic=e.$Hic=void 0;class A{constructor(p){this.b=new j.$5d,this.onDidChangePassword=this.b.event,this.a=p.getProxy(l.$6L.MainThreadSecretState)}async $onDidChangePassword(p){this.b.fire(p)}get(p,w){return this.a.$getPassword(p,w)}store(p,w,E){return this.a.$setPassword(p,w,E)}delete(p,w){return this.a.$deletePassword(p,w)}}e.$Hic=A,e.$Iic=(0,L.$fi)("IExtHostSecretState")}),define(Se[311],De([1,0,22,3,6]),function(fe,e,l,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Djc=void 0;class A{static{this.a=1}constructor(p){this.c=new Map,this.d=new Map,this.b=p.getProxy(L.$6L.MainThreadSpeech)}async $createSpeechToTextSession(p,w,E){const M=this.c.get(p);if(!M)return;const C=new j.$Sc,v=new l.$ce;this.d.set(w,v);const S=C.add(M.provideSpeechToTextSession(v.token,E?{language:E}:void 0));C.add(S.onDidChange(k=>{v.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(w,k)})),C.add(v.token.onCancellationRequested(()=>C.dispose()))}async $cancelSpeechToTextSession(p){this.d.get(p)?.dispose(!0),this.d.delete(p)}async $createKeywordRecognitionSession(p,w){const E=this.c.get(p);if(!E)return;const M=new j.$Sc,C=new l.$ce;this.d.set(w,C);const v=M.add(E.provideKeywordRecognitionSession(C.token));M.add(v.onDidChange(S=>{C.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(w,S)})),M.add(C.token.onCancellationRequested(()=>M.dispose()))}async $cancelKeywordRecognitionSession(p){this.d.get(p)?.dispose(!0),this.d.delete(p)}registerProvider(p,w,E){const M=A.a++;return this.c.set(M,E),this.b.$registerProvider(M,w,{extension:p,displayName:p.value}),(0,j.$Rc)(()=>{this.b.$unregisterProvider(M),this.c.delete(M)})}}e.$Djc=A}),define(Se[118],De([1,0,6,4,5]),function(fe,e,l,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aic=e.$zic=void 0;class A{constructor(p,w){this.c=w,this.b=new j.$5d,this.onDidChangeStorage=this.b.event,this.a=p.getProxy(l.$6L.MainThreadStorage)}registerExtensionStorageKeysToSync(p,w){this.a.$registerExtensionStorageKeysToSync(p,w)}async initializeExtensionStorage(p,w,E){const M=await this.a.$initializeExtensionStorage(p,w);let C;return M&&(C=this.d(p,w,M)),C||E}setValue(p,w,E){return this.a.$setValue(p,w,E)}$acceptValue(p,w,E){const M=this.d(p,w,E);M&&this.b.fire({shared:p,key:w,value:M})}d(p,w,E){try{return JSON.parse(E)}catch(M){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${w}, global: ${p}): ${M}`)}}}e.$zic=A,e.$Aic=(0,L.$fi)("IExtHostStorage")}),define(Se[312],De([1,0,3,15,2,6]),function(fe,e,l,j,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rjc=void 0;class R{static{this.a=new Set([j.Schemas.http,j.Schemas.https])}constructor(w){this.c=new Map,this.b=w.getProxy(A.$6L.MainThreadUriOpeners)}registerExternalUriOpener(w,E,M,C){if(this.c.has(E))throw new Error(`Opener with id '${E}' already registered`);const v=C.schemes.find(S=>!R.a.has(S));if(v)throw new Error(`Scheme '${v}' is not supported. Only http and https are currently supported.`);return this.c.set(E,M),this.b.$registerUriOpener(E,C.schemes,w,C.label),(0,l.$Rc)(()=>{this.c.delete(E),this.b.$unregisterUriOpener(E)})}async $canOpenUri(w,E,M){const C=this.c.get(w);if(!C)throw new Error(`Unknown opener with id: ${w}`);const v=L.URI.revive(E);return C.canOpenExternalUri(v,M)}async $openUri(w,E,M){const C=this.c.get(w);if(!C)throw new Error(`Unknown opener id: '${w}'`);return C.openExternalUri(L.URI.revive(E.resolvedUri),{sourceUri:L.URI.revive(E.sourceUri)},M)}}e.$Rjc=R}),define(Se[313],De([1,0,6,2,3,13,25]),function(fe,e,l,j,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sjc=void 0;class p{static{this.a=0}constructor(E){this.c=new R.$Am,this.d=new Map,this.b=E.getProxy(l.$6L.MainThreadUrls)}registerUriHandler(E,M){const C=E.identifier;if(this.c.has(C))throw new Error(`Protocol handler already registered for extension ${C}`);const v=p.a++;return this.c.add(C),this.d.set(v,M),this.b.$registerUriHandler(v,C,E.displayName||E.name),(0,L.$Rc)(()=>{this.c.delete(C),this.d.delete(v),this.b.$unregisterUriHandler(v)})}$handleExternalUri(E,M){const C=this.d.get(E);if(!C)return Promise.resolve(void 0);try{C.handleUri(j.URI.revive(M))}catch(v){(0,A.$1)(v)}return Promise.resolve(void 0)}async createAppUri(E){return j.URI.revive(await this.b.$createAppUri(E))}}e.$Sjc=p}),define(Se[92],De([1,0,4,3,15,24,2,243,280,113,6]),function(fe,e,l,j,L,A,R,p,w,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oic=e.$nic=e.$mic=e.$lic=e.$kic=void 0;class C{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(s,c,t,f,h,r,a){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new l.$5d,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new l.$5d,this._onDidDispose=this.#h.event,this.#e=s,this.#t=c,this.#o=t,this.#n=f,this.#s=h,this.#r=r,this.#l=v(r),this.#d=S(r),this.#i=a}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(s){return this.#u=!0,(0,E.$Jxb)(s,this.#n)}get cspSource(){const s=this.#r.extensionLocation;if(s.scheme===L.Schemas.https||s.scheme===L.Schemas.http){let c=s.toString();return c.endsWith("/")||(c+="/"),c+" "+E.$Ixb}return E.$Ixb}get html(){return this.a(),this.#a}set html(s){this.a(),this.#a!==s&&(this.#a=s,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(s)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(s)))}get options(){return this.a(),this.#o}set options(s){this.a(),A.$On(this.#o,s)||this.#t.$setOptions(this.#e,m(this.#r,this.#s,s)),this.#o=s}async postMessage(s){if(this.#c)return!1;const c=(0,w.$inb)(s,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,c.message,...c.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(s){if(!this.#d)return s;const c=this.#r.extensionLocation?.scheme===L.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===L.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return s.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(f,h,r,a,d,$)=>{const D=R.URI.from({scheme:a||"file",path:decodeURIComponent(d)}),b=(0,E.$Jxb)(D,{isRemote:c,authority:t}).toString();return`${h}${b}${$}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(f,h,r,a,d,$)=>{const D=R.URI.from({scheme:a||"file",path:decodeURIComponent(d)}),b=(0,E.$Jxb)(D,{isRemote:c,authority:t}).toString();return`${h}${b}${$}`})}}e.$kic=C;function v(n){try{const s=(0,p.$qp)((0,p.$pp)(n.engines.vscode));return!!s&&s.majorBase>=1&&s.minorBase>=57}catch{return!1}}e.$lic=v;function S(n){try{const s=(0,p.$qp)((0,p.$pp)(n.engines.vscode));return s?s.majorBase<1||s.majorBase===1&&s.minorBase<60:!1}catch{return!1}}class k extends j.$Tc{constructor(s,c,t,f,h){super(),this.c=c,this.f=t,this.g=f,this.h=h,this.b=new Map,this.a=s.getProxy(M.$6L.MainThreadWebviews)}dispose(){super.dispose();for(const s of this.b.values())s.dispose();this.b.clear()}$onMessage(s,c,t){const f=this.j(s);if(f){const{message:h}=(0,w.$jnb)(c,t.value);f._onMessageEmitter.fire(h)}}$onMissingCsp(s,c){this.g.warn(`${c} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(s,c,t){const f=new C(s,this.a,o(c),this.c,this.f,t,this.h);this.b.set(s,f);const h=f._onDidDispose(()=>{h.dispose(),this.deleteWebview(s)});return f}deleteWebview(s){this.b.delete(s)}j(s){return this.b.get(s)}}e.$mic=k;function u(n){return{id:n.identifier,location:n.extensionLocation}}e.$nic=u;function m(n,s,c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots||i(n,s)}}e.$oic=m;function o(n){return{enableCommandUris:n.enableCommandUris,enableScripts:n.enableScripts,enableForms:n.enableForms,portMapping:n.portMapping,localResourceRoots:n.localResourceRoots?.map(s=>R.URI.from(s))}}function i(n,s){return[...(s?.getWorkspaceFolders()||[]).map(c=>c.uri),n.extensionLocation]}}),define(Se[150],De([1,0,4,6,2,15,14,5,20,26]),function(fe,e,l,j,L,A,R,p,w,E){"use strict";var M;Object.defineProperty(e,"__esModule",{value:!0}),e.$Vjc=e.$Ujc=void 0;let C=class{static{M=this}static{this.a={focused:!0,active:!0}}getState(S){const k=this.d;return{get focused(){return k.focused},get active(){return(0,E.$YF)(S,"windowActivity"),k.active}}}constructor(S){this.c=new l.$5d,this.onDidChangeWindowState=this.c.event,this.d=M.a,this.b=S.getProxy(j.$6L.MainThreadWindow),this.b.$getInitialState().then(({isFocused:k,isActive:u})=>{this.onDidChangeWindowProperty("focused",k),this.onDidChangeWindowProperty("active",u)})}$onDidChangeWindowFocus(S){this.onDidChangeWindowProperty("focused",S)}$onDidChangeWindowActive(S){this.onDidChangeWindowProperty("active",S)}onDidChangeWindowProperty(S,k){k!==this.d[S]&&(this.d={...this.d,[S]:k},this.c.fire(this.d))}openUri(S,k){let u;if(typeof S=="string"){u=S;try{S=L.URI.parse(S)}catch{return Promise.reject(`Invalid uri - '${S}'`)}}return(0,R.$Se)(S.scheme)?Promise.reject("Invalid scheme - cannot be empty"):S.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${S.scheme}'`):this.b.$openUri(S,u,k)}async asExternalUri(S,k){if((0,R.$Se)(S.scheme))return Promise.reject("Invalid scheme - cannot be empty");const u=await this.b.$asExternalUri(S,k);return L.URI.from(u)}};e.$Ujc=C,e.$Ujc=C=M=Ye([Ve(0,w.$lO)],C),e.$Vjc=(0,p.$fi)("IExtHostWindow")}),define(Se[314],De([1,0,306,27,20]),function(fe,e,l,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xkc=void 0;const A=1024*1024;let R=class extends l.$Yjc{constructor(w,E){super(w,E),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(w,E,M){const C=w==="error"||w==="warn"?process.stderr:process.stdout;this.g=!0,C.write(`
START_NATIVE_LOG
`),E.apply(console,M),C.write(`
END_NATIVE_LOG
`),this.g=!1}j(w,E){const M=process[w],C=M.write;let v="";Object.defineProperty(M,"write",{set:()=>{},get:()=>(S,k,u)=>{if(!this.g){v+=S.toString(k);const m=v.length>A?v.length:v.lastIndexOf(`
`);m!==-1&&(console[E](v.slice(0,m)),v=v.slice(m+1))}C.call(M,S,k,u)}})}};e.$xkc=R,e.$xkc=R=Ye([Ve(0,L.$lO),Ve(1,j.$BO)],R)}),define(Se[315],De([1,0,149,15,257,30]),function(fe,e,l,j,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jkc=void 0;class R extends l.$Xjc{s(w,E,M){return w.scheme===j.Schemas.file?new L.$xP(M?.name||(0,A.$Bg)(),w.fsPath,!M?.donotRotate,!!M?.donotUseFormatters,E):super.s(w,E,M)}registerLogger(w){super.registerLogger(w),this.r.$registerLogger(w)}deregisterLogger(w){super.deregisterLogger(w),this.r.$deregisterLogger(w)}}e.$Jkc=R}),define(Se[316],De([1,0,8,21,22,13,4,3,133,303,67]),function(fe,e,l,j,L,A,R,p,w,E,M){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.$W9b=e.ResponsiveState=e.RequestInitiator=e.$V9b=e.$U9b=void 0;function v(y,P){try{return JSON.stringify(y,P)}catch{return"null"}}const S="$$ref$$",k={[S]:-1};class u{constructor(P,N){this.jsonString=P,this.referencedBuffers=N}}function m(y,P=null,N=!1){const U=[];return{jsonString:(N?v:JSON.stringify)(y,(F,I)=>{if(typeof I>"u")return k;if(typeof I=="object"){if(I instanceof j.$se){const O=U.push(I)-1;return{[S]:O}}if(P)return P(F,I)}return I}),referencedBuffers:U}}e.$U9b=m;function o(y,P,N){return JSON.parse(y,(U,z)=>{if(z){const F=z[S];if(typeof F=="number")return P[F];if(N&&z.$mid===1)return N.transformIncoming(z)}return z})}e.$V9b=o;function i(y,P){return JSON.stringify(y,P)}function n(y){return y?(P,N)=>N&&N.$mid===1?y.transformOutgoing(N):N:null}var s;(function(y){y[y.LocalSide=0]="LocalSide",y[y.OtherSide=1]="OtherSide"})(s||(e.RequestInitiator=s={}));var c;(function(y){y[y.Responsive=0]="Responsive",y[y.Unresponsive=1]="Unresponsive"})(c||(e.ResponsiveState=c={}));const t=()=>{},f=Symbol.for("rpcProtocol"),h=Symbol.for("rpcProxy");class r extends p.$Tc{static{C=f}static{this.a=3*1e3}constructor(P,N=null,U=null){super(),this[C]=!0,this.b=this.B(new R.$5d),this.onDidChangeResponsiveState=this.b.event,this.c=P,this.f=N,this.g=U,this.h=n(this.g),this.j=!1,this.m=[],this.s=[];for(let z=0,F=M.$6v.count;z<F;z++)this.m[z]=null,this.s[z]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new l.$rh(()=>this.H(),1e3)),this.c.onMessage(z=>this.L(z))}dispose(){this.j=!0,Object.keys(this.w).forEach(P=>{const N=this.w[P];delete this.w[P],N.resolveErr(A.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(P){this.z===0&&(this.C=Date.now()+r.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(P){this.C=Date.now()+r.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(P){this.y!==P&&(this.y=P,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(P){return this.g?(0,w.$jn)(P,this.g):P}getProxy(P){const{nid:N,sid:U}=P;return this.s[N]||(this.s[N]=this.J(N,U)),this.s[N]}J(P,N){const U={get:(z,F)=>(typeof F=="string"&&!z[F]&&F.charCodeAt(0)===36&&(z[F]=(...I)=>this.U(P,F,I)),F===h?N:z[F])};return new Proxy(Object.create(null),U)}set(P,N){return this.m[P.nid]=N,N}assertRegistered(P){for(let N=0,U=P.length;N<U;N++){const z=P[N];if(!this.m[z.nid])throw new Error(`Missing proxy instance ${z.sid}`)}}L(P){if(this.j)return;const N=P.byteLength,U=d.read(P,0),z=U.readUInt8(),F=U.readUInt32();switch(z){case 1:case 2:{let{rpcId:I,method:O,args:T}=D.deserializeRequestJSONArgs(U);this.g&&(T=(0,w.$jn)(T,this.g)),this.M(N,F,I,O,T,z===2);break}case 3:case 4:{let{rpcId:I,method:O,args:T}=D.deserializeRequestMixedArgs(U);this.g&&(T=(0,w.$jn)(T,this.g)),this.M(N,F,I,O,T,z===4);break}case 5:{this.f?.logIncoming(N,F,0,"ack"),this.G(F);break}case 6:{this.N(N,F);break}case 7:{this.O(N,F,void 0);break}case 9:{let I=D.deserializeReplyOKJSON(U);this.g&&(I=(0,w.$jn)(I,this.g)),this.O(N,F,I);break}case 10:{const I=D.deserializeReplyOKJSONWithBuffers(U,this.g);this.O(N,F,I);break}case 8:{const I=D.deserializeReplyOKVSBuffer(U);this.O(N,F,I);break}case 11:{let I=D.deserializeReplyErrError(U);this.g&&(I=(0,w.$jn)(I,this.g)),this.P(N,F,I);break}case 12:{this.P(N,F,void 0);break}default:console.error("received unexpected message"),console.error(P)}}M(P,N,U,z,F,I){this.f?.logIncoming(P,N,1,`receiveRequest ${(0,M.$8v)(U)}.${z}(`,F);const O=String(N);let T,G;if(I){const x=new L.$ce;F.push(x.token),T=this.Q(U,z,F),G=()=>x.cancel()}else T=this.Q(U,z,F),G=t;this.u[O]=G;const te=D.serializeAcknowledged(N);this.f?.logOutgoing(te.byteLength,N,1,"ack"),this.c.send(te),T.then(x=>{delete this.u[O];const X=D.serializeReplyOK(N,x,this.h);this.f?.logOutgoing(X.byteLength,N,1,"reply:",x),this.c.send(X)},x=>{delete this.u[O];const X=D.serializeReplyErr(N,x);this.f?.logOutgoing(X.byteLength,N,1,"replyErr:",x),this.c.send(X)})}N(P,N){this.f?.logIncoming(P,N,1,"receiveCancel");const U=String(N);this.u[U]?.()}O(P,N,U){this.f?.logIncoming(P,N,0,"receiveReply:",U);const z=String(N);if(!this.w.hasOwnProperty(z))return;const F=this.w[z];delete this.w[z],F.resolveOk(U)}P(P,N,U){this.f?.logIncoming(P,N,0,"receiveReplyErr:",U);const z=String(N);if(!this.w.hasOwnProperty(z))return;const F=this.w[z];delete this.w[z];let I;U&&(U.$isError?(I=new Error,I.name=U.name,I.message=U.message,I.stack=U.stack):I=U),F.resolveErr(I)}Q(P,N,U){try{return Promise.resolve(this.S(P,N,U))}catch(z){return Promise.reject(z)}}S(P,N,U){const z=this.m[P];if(!z)throw new Error("Unknown actor "+(0,M.$8v)(P));const F=z[N];if(typeof F!="function")throw new Error("Unknown method "+N+" on actor "+(0,M.$8v)(P));return F.apply(z,U)}U(P,N,U){if(this.j)return new E.$T9b;let z=null;if(U.length>0&&L.CancellationToken.isCancellationToken(U[U.length-1])&&(z=U.pop()),z&&z.isCancellationRequested)return Promise.reject(A.$6());const F=D.serializeRequestArguments(U,this.h),I=++this.t,O=String(I),T=new E.$S9b,G=new p.$Sc;z&&G.add(z.onCancellationRequested(()=>{const x=D.serializeCancel(I);this.f?.logOutgoing(x.byteLength,I,0,"cancel"),this.c.send(D.serializeCancel(I))})),this.w[O]=new a(T,G),this.F(I);const te=D.serializeRequest(I,P,N,F,!!z);return this.f?.logOutgoing(te.byteLength,I,0,`request: ${(0,M.$8v)(P)}.${N}(`,U),this.c.send(te),T}}e.$W9b=r;class a{constructor(P,N){this.a=P,this.b=N}resolveOk(P){this.a.resolveOk(P),this.b.dispose()}resolveErr(P){this.a.resolveErr(P),this.b.dispose()}}class d{static alloc(P,N,U){const z=new d(j.$se.alloc(U+1+4),0);return z.writeUInt8(P),z.writeUInt32(N),z}static read(P,N){return new d(P,N)}get buffer(){return this.a}constructor(P,N){this.a=P,this.b=N}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(P){this.a.writeUInt8(P,this.b),this.b+=1}readUInt8(){const P=this.a.readUInt8(this.b);return this.b+=1,P}writeUInt32(P){this.a.writeUInt32BE(P,this.b),this.b+=4}readUInt32(){const P=this.a.readUInt32BE(this.b);return this.b+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this.a.writeUInt8(P.byteLength,this.b),this.b+=1,this.a.set(P,this.b),this.b+=P.byteLength}readShortString(){const P=this.a.readUInt8(this.b);this.b+=1;const U=this.a.slice(this.b,this.b+P).toString();return this.b+=P,U}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readLongString(){const P=this.a.readUInt32BE(this.b);this.b+=4;const U=this.a.slice(this.b,this.b+P).toString();return this.b+=P,U}writeBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readVSBuffer(){const P=this.a.readUInt32BE(this.b);this.b+=4;const N=this.a.slice(this.b,this.b+P);return this.b+=P,N}static sizeMixedArray(P){let N=0;N+=1;for(let U=0,z=P.length;U<z;U++){const F=P[U];switch(N+=1,F.type){case 1:N+=this.sizeLongString(F.value);break;case 2:N+=this.sizeVSBuffer(F.value);break;case 3:N+=this.sizeUInt32,N+=this.sizeLongString(F.value);for(let I=0;I<F.buffers.length;++I)N+=this.sizeVSBuffer(F.buffers[I]);break;case 4:break}}return N}writeMixedArray(P){this.a.writeUInt8(P.length,this.b),this.b+=1;for(let N=0,U=P.length;N<U;N++){const z=P[N];switch(z.type){case 1:this.writeUInt8(1),this.writeLongString(z.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(z.value);break;case 3:this.writeUInt8(3),this.writeUInt32(z.buffers.length),this.writeLongString(z.value);for(let F=0;F<z.buffers.length;++F)this.writeBuffer(z.buffers[F]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this.a.readUInt8(this.b);this.b+=1;const N=new Array(P);for(let U=0;U<P;U++)switch(this.readUInt8()){case 1:N[U]=this.readLongString();break;case 2:N[U]=this.readVSBuffer();break;case 3:{const F=this.readUInt32(),I=this.readLongString(),O=[];for(let T=0;T<F;++T)O.push(this.readVSBuffer());N[U]=new M.$9v(o(I,O,null));break}case 4:N[U]=void 0;break}return N}}var $;(function(y){y[y.Simple=0]="Simple",y[y.Mixed=1]="Mixed"})($||($={}));class D{static a(P){for(let N=0,U=P.length;N<U;N++)if(P[N]instanceof j.$se||P[N]instanceof M.$9v||typeof P[N]>"u")return!0;return!1}static serializeRequestArguments(P,N){if(this.a(P)){const U=[];for(let z=0,F=P.length;z<F;z++){const I=P[z];if(I instanceof j.$se)U[z]={type:2,value:I};else if(typeof I>"u")U[z]={type:4};else if(I instanceof M.$9v){const{jsonString:O,referencedBuffers:T}=m(I.value,N);U[z]={type:3,value:j.$se.fromString(O),buffers:T}}else U[z]={type:1,value:j.$se.fromString(i(I,N))}}return{type:1,args:U}}return{type:0,args:i(P,N)}}static serializeRequest(P,N,U,z,F){switch(z.type){case 0:return this.b(P,N,U,z.args,F);case 1:return this.c(P,N,U,z.args,F)}}static b(P,N,U,z,F){const I=j.$se.fromString(U),O=j.$se.fromString(z);let T=0;T+=d.sizeUInt8(),T+=d.sizeShortString(I),T+=d.sizeLongString(O);const G=d.alloc(F?2:1,P,T);return G.writeUInt8(N),G.writeShortString(I),G.writeLongString(O),G.buffer}static deserializeRequestJSONArgs(P){const N=P.readUInt8(),U=P.readShortString(),z=P.readLongString();return{rpcId:N,method:U,args:JSON.parse(z)}}static c(P,N,U,z,F){const I=j.$se.fromString(U);let O=0;O+=d.sizeUInt8(),O+=d.sizeShortString(I),O+=d.sizeMixedArray(z);const T=d.alloc(F?4:3,P,O);return T.writeUInt8(N),T.writeShortString(I),T.writeMixedArray(z),T.buffer}static deserializeRequestMixedArgs(P){const N=P.readUInt8(),U=P.readShortString(),z=P.readMixedArray(),F=new Array(z.length);for(let I=0,O=z.length;I<O;I++){const T=z[I];typeof T=="string"?F[I]=JSON.parse(T):F[I]=T}return{rpcId:N,method:U,args:F}}static serializeAcknowledged(P){return d.alloc(5,P,0).buffer}static serializeCancel(P){return d.alloc(6,P,0).buffer}static serializeReplyOK(P,N,U){if(typeof N>"u")return this.d(P);if(N instanceof j.$se)return this.e(P,N);if(N instanceof M.$9v){const{jsonString:z,referencedBuffers:F}=m(N.value,U,!0);return this.g(P,z,F)}else return this.f(P,v(N,U))}static d(P){return d.alloc(7,P,0).buffer}static e(P,N){let U=0;U+=d.sizeVSBuffer(N);const z=d.alloc(8,P,U);return z.writeVSBuffer(N),z.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static f(P,N){const U=j.$se.fromString(N);let z=0;z+=d.sizeLongString(U);const F=d.alloc(9,P,z);return F.writeLongString(U),F.buffer}static g(P,N,U){const z=j.$se.fromString(N);let F=0;F+=d.sizeUInt32,F+=d.sizeLongString(z);for(const O of U)F+=d.sizeVSBuffer(O);const I=d.alloc(10,P,F);I.writeUInt32(U.length),I.writeLongString(z);for(const O of U)I.writeBuffer(O);return I.buffer}static deserializeReplyOKJSON(P){const N=P.readLongString();return JSON.parse(N)}static deserializeReplyOKJSONWithBuffers(P,N){const U=P.readUInt32(),z=P.readLongString(),F=[];for(let I=0;I<U;++I)F.push(P.readVSBuffer());return new M.$9v(o(z,F,N))}static serializeReplyErr(P,N){const U=N?v(A.$3(N),null):void 0;if(typeof U!="string")return this.h(P);const z=j.$se.fromString(U);let F=0;F+=d.sizeLongString(z);const I=d.alloc(11,P,F);return I.writeLongString(z),I.buffer}static deserializeReplyErrError(P){const N=P.readLongString();return JSON.parse(N)}static h(P){return d.alloc(12,P,0).buffer}}var b;(function(y){y[y.RequestJSONArgs=1]="RequestJSONArgs",y[y.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",y[y.RequestMixedArgs=3]="RequestMixedArgs",y[y.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",y[y.Acknowledged=5]="Acknowledged",y[y.Cancel=6]="Cancel",y[y.ReplyOKEmpty=7]="ReplyOKEmpty",y[y.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",y[y.ReplyOKJSON=9]="ReplyOKJSON",y[y.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",y[y.ReplyErrError=11]="ReplyErrError",y[y.ReplyErrEmpty=12]="ReplyErrEmpty"})(b||(b={}));var g;(function(y){y[y.String=1]="String",y[y.VSBuffer=2]="VSBuffer",y[y.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",y[y.Undefined=4]="Undefined"})(g||(g={}))}),define(Se[317],De([1,0,21,28,15,83,5]),function(fe,e,l,j,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PJ=e.$OJ=e.$NJ=e.$MJ=void 0,e.$MJ=(0,R.$fi)("notebookDocumentService");const p=["W","X","Y","Z","a","b","c","d","e","f"],w=new RegExp(`^[${p.join("")}]+`),E=7;function M(S){if(S.scheme!==L.Schemas.vscodeNotebookCell)return;const k=S.fragment.indexOf("s");if(k<0)return;const u=parseInt(S.fragment.substring(0,k).replace(w,""),E),m=(0,l.$Le)(S.fragment.substring(k+1)).toString();if(!isNaN(u))return{handle:u,notebook:S.with({scheme:m,fragment:null})}}e.$NJ=M;function C(S,k){const u=k.toString(E),o=`${u.length<p.length?p[u.length-1]:"z"}${u}s${(0,l.$Me)(l.$se.fromString(S.scheme),!0,!0)}`;return S.with({scheme:L.Schemas.vscodeNotebookCell,fragment:o})}e.$OJ=C;class v{constructor(){this.a=new j.$Ac}getNotebook(k){if(k.scheme===L.Schemas.vscodeNotebookCell){const u=M(k);if(u){const m=this.a.get(u.notebook);if(m)return m}}return this.a.get(k)}addNotebookDocument(k){this.a.set(k.uri,k)}removeNotebookDocument(k){this.a.delete(k.uri)}}e.$PJ=v,(0,A.$as)(e.$MJ,v,1)}),define(Se[119],De([1,0,21,35,48,101,15,17,11,45,317]),function(fe,e,l,j,L,A,R,p,w,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8J=e.$7J=e.$6J=e.$5J=e.CellStatusbarAlignment=e.$4J=e.$3J=e.$2J=e.NotebookEditorPriority=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.CellKind=e.$SJ=e.$RJ=e.$QJ=void 0,e.$QJ="workbench.editor.notebook",e.$RJ="workbench.editor.notebookTextDiffEditor",e.$SJ="workbench.editor.interactive";var C;(function(T){T[T.Markup=1]="Markup",T[T.Code=2]="Code"})(C||(e.CellKind=C={})),e.$TJ=["application/json","application/javascript","text/html","image/svg+xml",A.$ts.latex,A.$ts.markdown,"image/png","image/jpeg",A.$ts.text],e.$UJ=[A.$ts.latex,A.$ts.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",A.$ts.text],e.$VJ=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$WJ="_notAvailable";var v;(function(T){T[T.Running=1]="Running",T[T.Idle=2]="Idle"})(v||(e.NotebookRunState=v={}));var S;(function(T){T[T.Unconfirmed=1]="Unconfirmed",T[T.Pending=2]="Pending",T[T.Executing=3]="Executing"})(S||(e.NotebookCellExecutionState=S={}));var k;(function(T){T[T.Unconfirmed=1]="Unconfirmed",T[T.Pending=2]="Pending",T[T.Executing=3]="Executing"})(k||(e.NotebookExecutionState=k={}));var u;(function(T){T[T.WithHardKernelDependency=0]="WithHardKernelDependency",T[T.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",T[T.Pure=2]="Pure",T[T.Never=3]="Never"})(u||(e.NotebookRendererMatch=u={}));var m;(function(T){T.Always="always",T.Never="never",T.Optional="optional"})(m||(e.RendererMessagingSpec=m={}));var o;(function(T){T[T.ModelChange=1]="ModelChange",T[T.Move=2]="Move",T[T.ChangeCellLanguage=5]="ChangeCellLanguage",T[T.Initialize=6]="Initialize",T[T.ChangeCellMetadata=7]="ChangeCellMetadata",T[T.Output=8]="Output",T[T.OutputItem=9]="OutputItem",T[T.ChangeCellContent=10]="ChangeCellContent",T[T.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",T[T.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",T[T.ChangeCellMime=13]="ChangeCellMime",T[T.Unknown=100]="Unknown"})(o||(e.NotebookCellsChangeType=o={}));var i;(function(T){T[T.Handle=0]="Handle",T[T.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var n;(function(T){T[T.Replace=1]="Replace",T[T.Output=2]="Output",T[T.Metadata=3]="Metadata",T[T.CellLanguage=4]="CellLanguage",T[T.DocumentMetadata=5]="DocumentMetadata",T[T.Move=6]="Move",T[T.OutputItems=7]="OutputItems",T[T.PartialMetadata=8]="PartialMetadata",T[T.PartialInternalMetadata=9]="PartialInternalMetadata"})(n||(e.CellEditType=n={}));var s;(function(T){T.scheme=R.Schemas.vscodeNotebookCell;function G(_,ge){return(0,M.$OJ)(_,ge)}T.generate=G;function te(_){return(0,M.$NJ)(_)}T.parse=te;function x(_,ge){return _.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${ge??""},${_.scheme!==R.Schemas.file?_.scheme:""}`})}T.generateCellOutputUri=x;function X(_){if(_.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const ge=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(_.fragment);if(!ge)return;const se=ge[1]&&ge[1]!==""?ge[1]:void 0,re=ge[2];return{outputId:se,notebook:_.with({scheme:re||R.Schemas.file,fragment:null})}}T.parseCellOutputUri=X;function Q(_,ge,se){return T.generate(_,ge).with({scheme:se})}T.generateCellPropertyUri=Q;function ae(_,ge){if(_.scheme===ge)return T.parse(_.with({scheme:T.scheme}))}T.parseCellPropertyUri=ae})(s||(e.CellUri=s={}));const c=T=>w.$i?T.replace(/\//g,"\\"):T;class t{constructor(G=[],te=e.$TJ){this.e=te,this.d=[...new Set(G)].map(x=>({pattern:x,matches:j.$Yj(c(x))}))}sort(G){const te=new Map(L.Iterable.map(G,X=>[X,c(X)]));let x=[];for(const{matches:X}of this.d)for(const[Q,ae]of te)if(X(ae)){x.push(Q),te.delete(Q);break}return te.size&&(x=x.concat([...te.keys()].sort((X,Q)=>this.e.indexOf(X)-this.e.indexOf(Q)))),x}prioritize(G,te){const x=this.f(G);if(x===-1){this.d.unshift({pattern:G,matches:j.$Yj(c(G))});return}const X=new Set(te.map(ae=>this.f(ae,x)));X.delete(-1);const Q=Array.from(X).sort();this.d.splice(x+1,0,...Q.map(ae=>this.d[ae]));for(let ae=Q.length-1;ae>=0;ae--)this.d.splice(Q[ae],1)}toArray(){return this.d.map(G=>G.pattern)}f(G,te=this.d.length){const x=c(G);for(let X=0;X<te;X++)if(this.d[X].matches(x))return X;return-1}}e.$XJ=t;function f(T,G,te,x=(X,Q)=>X===Q){const X=[];function Q(ge,se,re){if(se===0&&re.length===0)return;const B=X[X.length-1];B&&B.start+B.deleteCount===ge?(B.deleteCount+=se,B.toInsert.push(...re)):X.push({start:ge,deleteCount:se,toInsert:re})}let ae=0,_=0;for(;;){if(ae===T.length){Q(ae,0,G.slice(_));break}if(_===G.length){Q(ae,T.length-ae,[]);break}const ge=T[ae],se=G[_];if(x(ge,se)){ae+=1,_+=1;continue}te(se)?(Q(ae,1,[]),ae+=1):(Q(ae,0,[se]),_+=1)}return X}e.$YJ=f,e.$ZJ=new E.$wj("notebookEditorCursorAtBoundary","none"),e.$1J=new E.$wj("notebookEditorCursorAtLineBoundary","none");var h;(function(T){T.default="default",T.option="option"})(h||(e.NotebookEditorPriority=h={}));function r(T){const G=T;return!!((typeof G.include=="string"||j.$Zj(G.include))&&(typeof G.exclude=="string"||j.$Zj(G.exclude)))}e.$2J=r;function a(T,G,te){if(Array.isArray(T.viewType)&&T.viewType.indexOf(G)>=0||T.viewType===G)return!0;if(T.filenamePattern){const x=r(T.filenamePattern)?T.filenamePattern.include:T.filenamePattern,X=r(T.filenamePattern)?T.filenamePattern.exclude:void 0;if(j.$Xj(x,(0,p.$nc)(te.fsPath).toLowerCase()))return!(X&&j.$Xj(X,(0,p.$nc)(te.fsPath).toLowerCase()))}return!1}e.$3J=a,e.$4J={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView"};var d;(function(T){T[T.Left=1]="Left",T[T.Right=2]="Right"})(d||(e.CellStatusbarAlignment=d={}));class ${static{this.d="notebook/"}static create(G){return`${$.d}${G}`}static parse(G){if(G.startsWith($.d))return G.substring($.d.length)}}e.$5J=$;function D(T){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(T)}e.$6J=D;const b=new TextDecoder;function g(T){const G=[];let te=!1;for(const ae of T)(G.length===0||te)&&(G.push(ae),te=!0);let x=N(G);const X=l.$se.concat(G.map(ae=>l.$se.wrap(ae))),Q=O(X);return x=x||Q.byteLength!==X.byteLength,{data:Q,didCompression:x}}e.$7J=g,e.$8J="\x1B[A";const y=e.$8J.split("").map(T=>T.charCodeAt(0)),P=10;function N(T){let G=!1;return T.forEach((te,x)=>{if(x===0||te.length<e.$8J.length)return;const X=T[x-1],Q=te.subarray(0,e.$8J.length);if(Q[0]===y[0]&&Q[1]===y[1]&&Q[2]===y[2]){const ae=X.lastIndexOf(P);if(ae===-1)return;G=!0,T[x-1]=X.subarray(0,ae),T[x]=te.subarray(e.$8J.length)}}),G}function U(T){let G=T;do T=G,G=T.replace(/[^\n]\x08/gm,"");while(G.length<T.length);return T}function z(T){for(T=T.replace(/\r+\n/gm,`
`);T.search(/\r[^$]/g)>-1;){const G=T.match(/^(.*)\r+/m)[1];let te=T.match(/\r+(.*)$/m)[1];te=te+G.slice(te.length,G.length),T=T.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,te)}return T}const F=8,I=13;function O(T){return!T.buffer.includes(F)&&!T.buffer.includes(I)?T:l.$se.fromString(z(U(b.decode(T.buffer))))}}),define(Se[7],De([1,0,19,13,79,28,101,14,18,2,30,25,32,64,119]),function(fe,e,l,j,L,A,R,p,w,E,M,C,v,S,k){"use strict";var u,m,o,i,n,s,c,t,f,h,r,a,d,$,D,b,g;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$aO=e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$_N=e.$$N=e.$0N=e.$9N=e.$8N=e.$7N=e.$6N=e.$5N=e.$4N=e.$3N=e.$2N=e.$1N=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$ZN=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$YN=e.$XN=e.$WN=e.$VN=e.$UN=e.$TN=e.$SN=e.$RN=e.$QN=e.$PN=e.$ON=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$NN=e.$MN=e.$LN=e.$KN=e.$JN=e.$IN=e.$HN=e.$GN=e.TestRunProfileKind=e.TestResultState=e.$FN=e.$EN=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$DN=e.NotebookVariablesRequestKind=e.$CN=e.$BN=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$AN=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$zN=e.$yN=e.$xN=e.$wN=e.$vN=e.ColorThemeKind=e.$uN=e.$tN=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$sN=e.$rN=e.DebugConsoleMode=e.$qN=e.$pN=e.$oN=e.$nN=e.$mN=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$lN=e.$kN=e.FileChangeType=e.$jN=e.NewSymbolNameTag=e.$iN=e.$hN=e.$gN=e.$fN=e.InlineCompletionTriggerKind=e.$eN=e.$dN=e.$cN=e.$bN=e.$aN=e.$_M=e.$$M=e.$0M=e.$9M=e.$8M=e.$7M=e.$6M=e.$5M=e.ConfigurationTarget=e.$4M=e.$3M=e.$2M=e.$1M=e.$ZM=e.$YM=e.$XM=e.$WM=e.$VM=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$UM=e.ViewBadge=e.ProgressLocation=e.$TM=e.$SM=e.TaskScope=e.ShellQuoting=e.$RM=e.$QM=e.$PM=e.TaskPanelKind=e.TaskRevealKind=e.$OM=e.TerminalLocation=e.$NM=e.$MM=e.$LM=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$KM=e.$JM=e.$IM=e.$HM=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$GM=e.StatusBarAlignment=e.ViewColumn=e.$FM=e.$EM=e.$DM=e.$CM=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$BM=e.$AM=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$zM=e.$yM=e.$xM=e.$wM=e.$vM=e.LanguageStatusSeverity=e.$uM=e.$tM=e.$sM=e.$rM=e.$qM=e.$pM=e.CodeActionTriggerKind=e.$oM=e.$nM=e.SymbolTag=e.SymbolKind=e.$mM=e.$lM=e.DocumentHighlightKind=e.$kM=e.$jM=e.$iM=e.$hM=e.DiagnosticSeverity=e.DiagnosticTag=e.$gM=e.$fM=e.FileEditType=e.$eM=e.$dM=e.$cM=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$bM=e.$aM=e.$_L=e.$$L=e.$0L=e.$9L=e.$8L=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function y(K){return Object.assign(K,{apply:function(...we){if(we.length===0)return Reflect.construct(K,[]);{const je=we.length===1?[]:we[1];return Reflect.construct(K,je,we[0].constructor)}},call:function(...we){if(we.length===0)return Reflect.construct(K,[]);{const[je,...Ze]=we;return Reflect.construct(K,Ze,je.constructor)}}})}var P;(function(K){K[K.Top=0]="Top",K[K.Bottom=1]="Bottom"})(P||(e.TerminalOutputAnchor=P={}));var N;(function(K){K[K.TerminalCommand=0]="TerminalCommand",K[K.Opener=1]="Opener",K[K.Command=3]="Command"})(N||(e.TerminalQuickFixType=N={}));let U=u=class{static from(...V){let we=V;return new u(function(){if(we){for(const je of we)je&&typeof je.dispose=="function"&&je.dispose();we=void 0}})}#e;constructor(V){this.#e=V}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$8L=U,e.$8L=U=u=Ye([y],U);let z=m=class{static Min(...V){if(V.length===0)throw new TypeError;let we=V[0];for(let je=1;je<V.length;je++){const Ze=V[je];Ze.isBefore(we)&&(we=Ze)}return we}static Max(...V){if(V.length===0)throw new TypeError;let we=V[0];for(let je=1;je<V.length;je++){const Ze=V[je];Ze.isAfter(we)&&(we=Ze)}return we}static isPosition(V){if(!V)return!1;if(V instanceof m)return!0;const{line:we,character:je}=V;return typeof we=="number"&&typeof je=="number"}static of(V){if(V instanceof m)return V;if(this.isPosition(V))return new m(V.line,V.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(V,we){if(V<0)throw(0,j.$7)("line must be non-negative");if(we<0)throw(0,j.$7)("character must be non-negative");this.c=V,this.e=we}isBefore(V){return this.c<V.c?!0:V.c<this.c?!1:this.e<V.e}isBeforeOrEqual(V){return this.c<V.c?!0:V.c<this.c?!1:this.e<=V.e}isAfter(V){return!this.isBeforeOrEqual(V)}isAfterOrEqual(V){return!this.isBefore(V)}isEqual(V){return this.c===V.c&&this.e===V.e}compareTo(V){return this.c<V.c?-1:this.c>V.line?1:this.e<V.e?-1:this.e>V.e?1:0}translate(V,we=0){if(V===null||we===null)throw(0,j.$7)();let je;return typeof V>"u"?je=0:typeof V=="number"?je=V:(je=typeof V.lineDelta=="number"?V.lineDelta:0,we=typeof V.characterDelta=="number"?V.characterDelta:0),je===0&&we===0?this:new m(this.line+je,this.character+we)}with(V,we=this.character){if(V===null||we===null)throw(0,j.$7)();let je;return typeof V>"u"?je=this.line:typeof V=="number"?je=V:(je=typeof V.line=="number"?V.line:this.line,we=typeof V.character=="number"?V.character:this.character),je===this.line&&we===this.character?this:new m(je,we)}toJSON(){return{line:this.line,character:this.character}}};e.$9L=z,e.$9L=z=m=Ye([y],z);let F=o=class{static isRange(V){return V instanceof o?!0:V?z.isPosition(V.start)&&z.isPosition(V.end):!1}static of(V){if(V instanceof o)return V;if(this.isRange(V))return new o(V.start,V.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(V,we,je,Ze){let it,lt;if(typeof V=="number"&&typeof we=="number"&&typeof je=="number"&&typeof Ze=="number"?(it=new z(V,we),lt=new z(je,Ze)):z.isPosition(V)&&z.isPosition(we)&&(it=z.of(V),lt=z.of(we)),!it||!lt)throw new Error("Invalid arguments");it.isBefore(lt)?(this.c=it,this.e=lt):(this.c=lt,this.e=it)}contains(V){return o.isRange(V)?this.contains(V.start)&&this.contains(V.end):z.isPosition(V)?!(z.of(V).isBefore(this.c)||this.e.isBefore(V)):!1}isEqual(V){return this.c.isEqual(V.c)&&this.e.isEqual(V.e)}intersection(V){const we=z.Max(V.start,this.c),je=z.Min(V.end,this.e);if(!we.isAfter(je))return new o(we,je)}union(V){if(this.contains(V))return this;if(V.contains(this))return V;const we=z.Min(V.start,this.c),je=z.Max(V.end,this.end);return new o(we,je)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(V,we=this.end){if(V===null||we===null)throw(0,j.$7)();let je;return V?z.isPosition(V)?je=V:(je=V.start||this.start,we=V.end||this.end):je=this.start,je.isEqual(this.c)&&we.isEqual(this.end)?this:new o(je,we)}toJSON(){return[this.start,this.end]}};e.$0L=F,e.$0L=F=o=Ye([y],F);let I=i=class extends F{static isSelection(V){return V instanceof i?!0:V?F.isRange(V)&&z.isPosition(V.anchor)&&z.isPosition(V.active)&&typeof V.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(V,we,je,Ze){let it,lt;if(typeof V=="number"&&typeof we=="number"&&typeof je=="number"&&typeof Ze=="number"?(it=new z(V,we),lt=new z(je,Ze)):z.isPosition(V)&&z.isPosition(we)&&(it=z.of(V),lt=z.of(we)),!it||!lt)throw new Error("Invalid arguments");super(it,lt),this.f=it,this.g=lt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$$L=I,e.$$L=I=i=Ye([y],I);const O=K=>{if(typeof K!="string"||K.length===0||!/^[0-9A-Za-z_\-]+$/.test(K))throw(0,j.$7)("connectionToken")};class T{static isResolvedAuthority(V){return V&&typeof V=="object"&&typeof V.host=="string"&&typeof V.port=="number"&&(V.connectionToken===void 0||typeof V.connectionToken=="string")}constructor(V,we,je){if(typeof V!="string"||V.length===0)throw(0,j.$7)("host");if(typeof we!="number"||we===0||Math.round(we)!==we)throw(0,j.$7)("port");typeof je<"u"&&O(je),this.host=V,this.port=Math.round(we),this.connectionToken=je}}e.$_L=T;class G{static isManagedResolvedAuthority(V){return V&&typeof V=="object"&&typeof V.makeConnection=="function"&&(V.connectionToken===void 0||typeof V.connectionToken=="string")}constructor(V,we){this.makeConnection=V,this.connectionToken=we,typeof we<"u"&&O(we)}}e.$aM=G;class te extends Error{static NotAvailable(V,we){return new te(V,S.RemoteAuthorityResolverErrorCode.NotAvailable,we)}static TemporarilyNotAvailable(V){return new te(V,S.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(V,we=S.RemoteAuthorityResolverErrorCode.Unknown,je){super(V),this._message=V,this._code=we,this._detail=je,Object.setPrototypeOf(this,te.prototype)}}e.$bM=te;var x;(function(K){K[K.LF=1]="LF",K[K.CRLF=2]="CRLF"})(x||(e.EndOfLine=x={}));var X;(function(K){K[K.Replace=1]="Replace",K[K.Append=2]="Append",K[K.Prepend=3]="Prepend"})(X||(e.EnvironmentVariableMutatorType=X={}));let Q=n=class{static isTextEdit(V){return V instanceof n?!0:V?F.isRange(V)&&typeof V.newText=="string":!1}static replace(V,we){return new n(V,we)}static insert(V,we){return n.replace(new F(V,V),we)}static delete(V){return n.replace(V,"")}static setEndOfLine(V){const we=new n(new F(new z(0,0),new z(0,0)),"");return we.newEol=V,we}get range(){return this.c}set range(V){if(V&&!F.isRange(V))throw(0,j.$7)("range");this.c=V}get newText(){return this.e||""}set newText(V){if(V&&typeof V!="string")throw(0,j.$7)("newText");this.e=V}get newEol(){return this.f}set newEol(V){if(V&&typeof V!="number")throw(0,j.$7)("newEol");this.f=V}constructor(V,we){this.c=V,this.e=we}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$cM=Q,e.$cM=Q=n=Ye([y],Q);let ae=s=class{static isNotebookCellEdit(V){return V instanceof s?!0:V?di.isNotebookRange(V)&&Array.isArray(V.newCells):!1}static replaceCells(V,we){return new s(V,we)}static insertCells(V,we){return new s(new di(V,V),we)}static deleteCells(V){return new s(V,[])}static updateCellMetadata(V,we){const je=new s(new di(V,V),[]);return je.newCellMetadata=we,je}static updateNotebookMetadata(V){const we=new s(new di(0,0),[]);return we.newNotebookMetadata=V,we}constructor(V,we){this.range=V,this.newCells=we}};e.$dM=ae,e.$dM=ae=s=Ye([y],ae);class _{static isSnippetTextEdit(V){return V instanceof _?!0:V?F.isRange(V.range)&&re.isSnippetString(V.snippet):!1}static replace(V,we){return new _(V,we)}static insert(V,we){return _.replace(new F(V,V),we)}constructor(V,we){this.range=V,this.snippet=we}}e.$eM=_;var ge;(function(K){K[K.File=1]="File",K[K.Text=2]="Text",K[K.Cell=3]="Cell",K[K.CellReplace=5]="CellReplace",K[K.Snippet=6]="Snippet"})(ge||(e.FileEditType=ge={}));let se=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(V,we,je,Ze){this.c.push({_type:1,from:V,to:we,options:je,metadata:Ze})}createFile(V,we,je){this.c.push({_type:1,from:void 0,to:V,options:we,metadata:je})}deleteFile(V,we,je){this.c.push({_type:1,from:V,to:void 0,options:we,metadata:je})}e(V,we,je){this.c.push({_type:3,metadata:je,uri:V,edit:{editType:5,metadata:we},notebookMetadata:we})}f(V,we,je,Ze){const it=we.start,lt=we.end;(it!==lt||je.length>0)&&this.c.push({_type:5,uri:V,index:it,count:lt-it,cells:je,metadata:Ze})}g(V,we,je,Ze){this.c.push({_type:3,metadata:Ze,uri:V,edit:{editType:3,index:we,metadata:je}})}replace(V,we,je,Ze){this.c.push({_type:2,uri:V,edit:new Q(we,je),metadata:Ze})}insert(V,we,je,Ze){this.replace(V,new F(we,we),je,Ze)}delete(V,we,je){this.replace(V,we,"",je)}has(V){return this.c.some(we=>we._type===2&&we.uri.toString()===V.toString())}set(V,we){if(we)for(const je of we){if(!je)continue;let Ze,it;Array.isArray(je)?(Ze=je[0],it=je[1]):Ze=je,ae.isNotebookCellEdit(Ze)?Ze.newCellMetadata?this.g(V,Ze.range.start,Ze.newCellMetadata,it):Ze.newNotebookMetadata?this.e(V,Ze.newNotebookMetadata,it):this.f(V,Ze.range,Ze.newCells,it):_.isSnippetTextEdit(Ze)?this.c.push({_type:6,uri:V,range:Ze.range,edit:Ze.snippet,metadata:it}):this.c.push({_type:2,uri:V,edit:Ze,metadata:it})}else{for(let je=0;je<this.c.length;je++){const Ze=this.c[je];switch(Ze._type){case 2:case 6:case 3:case 5:Ze.uri.toString()===V.toString()&&(this.c[je]=void 0);break}}(0,l.$Ib)(this.c)}}get(V){const we=[];for(const je of this.c)je._type===2&&je.uri.toString()===V.toString()&&we.push(je.edit);return we}entries(){const V=new A.$Ac;for(const we of this.c)if(we._type===2){let je=V.get(we.uri);je||(je=[we.uri,[]],V.set(we.uri,je)),je[1].push(we.edit)}return[...V.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$fM=se,e.$fM=se=Ye([y],se);let re=c=class{static isSnippetString(V){return V instanceof c?!0:V?typeof V.value=="string":!1}static c(V){return V.replace(/\$|}|\\/g,"\\$&")}constructor(V){this.e=1,this.value=V||""}appendText(V){return this.value+=c.c(V),this}appendTabstop(V=this.e++){return this.value+="$",this.value+=V,this}appendPlaceholder(V,we=this.e++){if(typeof V=="function"){const je=new c;je.e=this.e,V(je),this.e=je.e,V=je.value}else V=c.c(V);return this.value+="${",this.value+=we,this.value+=":",this.value+=V,this.value+="}",this}appendChoice(V,we=this.e++){const je=V.map(Ze=>Ze.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=we,this.value+="|",this.value+=je,this.value+="|}",this}appendVariable(V,we){if(typeof we=="function"){const je=new c;je.e=this.e,we(je),this.e=je.e,we=je.value}else typeof we=="string"&&(we=we.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=V,we&&(this.value+=":",this.value+=we),this.value+="}",this}};e.$gM=re,e.$gM=re=c=Ye([y],re);var B;(function(K){K[K.Unnecessary=1]="Unnecessary",K[K.Deprecated=2]="Deprecated"})(B||(e.DiagnosticTag=B={}));var ie;(function(K){K[K.Hint=3]="Hint",K[K.Information=2]="Information",K[K.Warning=1]="Warning",K[K.Error=0]="Error"})(ie||(e.DiagnosticSeverity=ie={}));let ye=t=class{static isLocation(V){return V instanceof t?!0:V?F.isRange(V.range)&&E.URI.isUri(V.uri):!1}constructor(V,we){if(this.uri=V,we)if(F.isRange(we))this.range=F.of(we);else if(z.isPosition(we))this.range=new F(we,we);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$hM=ye,e.$hM=ye=t=Ye([y],ye);let le=class{static is(V){return V?typeof V.message=="string"&&V.location&&F.isRange(V.location.range)&&E.URI.isUri(V.location.uri):!1}constructor(V,we){this.location=V,this.message=we}static isEqual(V,we){return V===we?!0:!V||!we?!1:V.message===we.message&&V.location.range.isEqual(we.location.range)&&V.location.uri.toString()===we.location.uri.toString()}};e.$iM=le,e.$iM=le=Ye([y],le);let ue=class{constructor(V,we,je=ie.Error){if(!F.isRange(V))throw new TypeError("range must be set");if(!we)throw new TypeError("message must be set");this.range=V,this.message=we,this.severity=je}toJSON(){return{severity:ie[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(V,we){return V===we?!0:!V||!we?!1:V.message===we.message&&V.severity===we.severity&&V.code===we.code&&V.severity===we.severity&&V.source===we.source&&V.range.isEqual(we.range)&&(0,l.$ub)(V.tags,we.tags)&&(0,l.$ub)(V.relatedInformation,we.relatedInformation,le.isEqual)}};e.$jM=ue,e.$jM=ue=Ye([y],ue);let ce=class{constructor(V,we){if(!V)throw new Error("Illegal argument, contents must be defined");Array.isArray(V)?this.contents=V:this.contents=[V],this.range=we}};e.$kM=ce,e.$kM=ce=Ye([y],ce);var de;(function(K){K[K.Text=0]="Text",K[K.Read=1]="Read",K[K.Write=2]="Write"})(de||(e.DocumentHighlightKind=de={}));let H=class{constructor(V,we=de.Text){this.range=V,this.kind=we}toJSON(){return{range:this.range,kind:de[this.kind]}}};e.$lM=H,e.$lM=H=Ye([y],H);let Z=class{constructor(V,we){this.uri=V,this.highlights=we}toJSON(){return{uri:this.uri,highlights:this.highlights.map(V=>V.toJSON())}}};e.$mM=Z,e.$mM=Z=Ye([y],Z);var he;(function(K){K[K.File=0]="File",K[K.Module=1]="Module",K[K.Namespace=2]="Namespace",K[K.Package=3]="Package",K[K.Class=4]="Class",K[K.Method=5]="Method",K[K.Property=6]="Property",K[K.Field=7]="Field",K[K.Constructor=8]="Constructor",K[K.Enum=9]="Enum",K[K.Interface=10]="Interface",K[K.Function=11]="Function",K[K.Variable=12]="Variable",K[K.Constant=13]="Constant",K[K.String=14]="String",K[K.Number=15]="Number",K[K.Boolean=16]="Boolean",K[K.Array=17]="Array",K[K.Object=18]="Object",K[K.Key=19]="Key",K[K.Null=20]="Null",K[K.EnumMember=21]="EnumMember",K[K.Struct=22]="Struct",K[K.Event=23]="Event",K[K.Operator=24]="Operator",K[K.TypeParameter=25]="TypeParameter"})(he||(e.SymbolKind=he={}));var be;(function(K){K[K.Deprecated=1]="Deprecated"})(be||(e.SymbolTag=be={}));let Pe=f=class{static validate(V){if(!V.name)throw new Error("name must not be falsy")}constructor(V,we,je,Ze,it){this.name=V,this.kind=we,this.containerName=it,typeof je=="string"&&(this.containerName=je),Ze instanceof ye?this.location=Ze:je instanceof F&&(this.location=new ye(Ze,je)),f.validate(this)}toJSON(){return{name:this.name,kind:he[this.kind],location:this.location,containerName:this.containerName}}};e.$nM=Pe,e.$nM=Pe=f=Ye([y],Pe);let pe=h=class{static validate(V){if(!V.name)throw new Error("name must not be falsy");if(!V.range.contains(V.selectionRange))throw new Error("selectionRange must be contained in fullRange");V.children?.forEach(h.validate)}constructor(V,we,je,Ze,it){this.name=V,this.detail=we,this.kind=je,this.range=Ze,this.selectionRange=it,this.children=[],h.validate(this)}};e.$oM=pe,e.$oM=pe=h=Ye([y],pe);var Ae;(function(K){K[K.Invoke=1]="Invoke",K[K.Automatic=2]="Automatic"})(Ae||(e.CodeActionTriggerKind=Ae={}));let Oe=class{constructor(V,we){this.title=V,this.kind=we}};e.$pM=Oe,e.$pM=Oe=Ye([y],Oe);let ze=class{static{r=this}static{this.c="."}constructor(V){this.value=V}append(V){return new r(this.value?this.value+r.c+V:V)}intersects(V){return this.contains(V)||V.contains(this)}contains(V){return this.value===V.value||V.value.startsWith(this.value+r.c)}};e.$qM=ze,e.$qM=ze=r=Ye([y],ze),ze.Empty=new ze(""),ze.QuickFix=ze.Empty.append("quickfix"),ze.Refactor=ze.Empty.append("refactor"),ze.RefactorExtract=ze.Refactor.append("extract"),ze.RefactorInline=ze.Refactor.append("inline"),ze.RefactorMove=ze.Refactor.append("move"),ze.RefactorRewrite=ze.Refactor.append("rewrite"),ze.Source=ze.Empty.append("source"),ze.SourceOrganizeImports=ze.Source.append("organizeImports"),ze.SourceFixAll=ze.Source.append("fixAll"),ze.Notebook=ze.Empty.append("notebook");let q=class{constructor(V,we){if(this.range=V,this.parent=we,we&&!we.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$rM=q,e.$rM=q=Ye([y],q);class W{constructor(V,we,je,Ze,it,lt){this.kind=V,this.name=we,this.detail=je,this.uri=Ze,this.range=it,this.selectionRange=lt}}e.$sM=W;class Y{constructor(V,we){this.fromRanges=we,this.from=V}}e.$tM=Y;class J{constructor(V,we){this.fromRanges=we,this.to=V}}e.$uM=J;var $e;(function(K){K[K.Information=0]="Information",K[K.Warning=1]="Warning",K[K.Error=2]="Error"})($e||(e.LanguageStatusSeverity=$e={}));let ve=class{constructor(V,we){this.range=V,this.command=we}get isResolved(){return!!this.command}};e.$vM=ve,e.$vM=ve=Ye([y],ve);let Fe=a=class{#e;static isMarkdownString(V){return V instanceof a?!0:V&&V.appendCodeblock&&V.appendMarkdown&&V.appendText&&V.value!==void 0}constructor(V,we=!1){this.#e=new L.$wk(V,{supportThemeIcons:we})}get value(){return this.#e.value}set value(V){this.#e.value=V}get isTrusted(){return this.#e.isTrusted}set isTrusted(V){this.#e.isTrusted=V}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(V){this.#e.supportThemeIcons=V}get supportHtml(){return this.#e.supportHtml}set supportHtml(V){this.#e.supportHtml=V}get baseUri(){return this.#e.baseUri}set baseUri(V){this.#e.baseUri=V}appendText(V){return this.#e.appendText(V),this}appendMarkdown(V){return this.#e.appendMarkdown(V),this}appendCodeblock(V,we){return this.#e.appendCodeblock(we??"",V),this}};e.$wM=Fe,e.$wM=Fe=a=Ye([y],Fe);let He=class{constructor(V,we){this.label=V,this.documentation=we}};e.$xM=He,e.$xM=He=Ye([y],He);let Qe=class{constructor(V,we){this.label=V,this.documentation=we,this.parameters=[]}};e.$yM=Qe,e.$yM=Qe=Ye([y],Qe);let tt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$zM=tt,e.$zM=tt=Ye([y],tt);var st;(function(K){K[K.Invoke=1]="Invoke",K[K.TriggerCharacter=2]="TriggerCharacter",K[K.ContentChange=3]="ContentChange"})(st||(e.SignatureHelpTriggerKind=st={}));var ut;(function(K){K[K.Type=1]="Type",K[K.Parameter=2]="Parameter"})(ut||(e.InlayHintKind=ut={}));let rt=class{constructor(V){this.value=V}};e.$AM=rt,e.$AM=rt=Ye([y],rt);let Ie=class{constructor(V,we,je){this.position=V,this.label=we,this.kind=je}};e.$BM=Ie,e.$BM=Ie=Ye([y],Ie);var Be;(function(K){K[K.Invoke=0]="Invoke",K[K.TriggerCharacter=1]="TriggerCharacter",K[K.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Be||(e.CompletionTriggerKind=Be={}));var Le;(function(K){K[K.Text=0]="Text",K[K.Method=1]="Method",K[K.Function=2]="Function",K[K.Constructor=3]="Constructor",K[K.Field=4]="Field",K[K.Variable=5]="Variable",K[K.Class=6]="Class",K[K.Interface=7]="Interface",K[K.Module=8]="Module",K[K.Property=9]="Property",K[K.Unit=10]="Unit",K[K.Value=11]="Value",K[K.Enum=12]="Enum",K[K.Keyword=13]="Keyword",K[K.Snippet=14]="Snippet",K[K.Color=15]="Color",K[K.File=16]="File",K[K.Reference=17]="Reference",K[K.Folder=18]="Folder",K[K.EnumMember=19]="EnumMember",K[K.Constant=20]="Constant",K[K.Struct=21]="Struct",K[K.Event=22]="Event",K[K.Operator=23]="Operator",K[K.TypeParameter=24]="TypeParameter",K[K.User=25]="User",K[K.Issue=26]="Issue"})(Le||(e.CompletionItemKind=Le={}));var Ke;(function(K){K[K.Deprecated=1]="Deprecated"})(Ke||(e.CompletionItemTag=Ke={}));let ne=class{constructor(V,we){this.label=V,this.kind=we}toJSON(){return{label:this.label,kind:this.kind&&Le[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$CM=ne,e.$CM=ne=Ye([y],ne);let oe=class{constructor(V=[],we=!1){this.items=V,this.isIncomplete=we}};e.$DM=oe,e.$DM=oe=Ye([y],oe);let Ce=class{constructor(V,we,je){this.insertText=V,this.range=we,this.command=je}};e.$EM=Ce,e.$EM=Ce=Ye([y],Ce);let Ge=class{constructor(V){this.commands=void 0,this.suppressSuggestions=void 0,this.items=V}};e.$FM=Ge,e.$FM=Ge=Ye([y],Ge);var xe;(function(K){K[K.Active=-1]="Active",K[K.Beside=-2]="Beside",K[K.One=1]="One",K[K.Two=2]="Two",K[K.Three=3]="Three",K[K.Four=4]="Four",K[K.Five=5]="Five",K[K.Six=6]="Six",K[K.Seven=7]="Seven",K[K.Eight=8]="Eight",K[K.Nine=9]="Nine"})(xe||(e.ViewColumn=xe={}));var nt;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(nt||(e.StatusBarAlignment=nt={}));function Ne(K,V){return`${C.$zm.toKey(K)}.${V}`}e.$GM=Ne;var $t;(function(K){K[K.Off=0]="Off",K[K.On=1]="On",K[K.Relative=2]="Relative",K[K.Interval=3]="Interval"})($t||(e.TextEditorLineNumbersStyle=$t={}));var Dt;(function(K){K[K.Manual=1]="Manual",K[K.AfterDelay=2]="AfterDelay",K[K.FocusOut=3]="FocusOut"})(Dt||(e.TextDocumentSaveReason=Dt={}));var Pt;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(Pt||(e.TextEditorRevealType=Pt={}));var Tt;(function(K){K[K.Keyboard=1]="Keyboard",K[K.Mouse=2]="Mouse",K[K.Command=3]="Command"})(Tt||(e.TextEditorSelectionChangeKind=Tt={}));var Xt;(function(K){K[K.Undo=1]="Undo",K[K.Redo=2]="Redo"})(Xt||(e.TextDocumentChangeReason=Xt={}));var Ct;(function(K){K[K.OpenOpen=0]="OpenOpen",K[K.ClosedClosed=1]="ClosedClosed",K[K.OpenClosed=2]="OpenClosed",K[K.ClosedOpen=3]="ClosedOpen"})(Ct||(e.DecorationRangeBehavior=Ct={})),function(K){function V(we){switch(we){case"keyboard":return K.Keyboard;case"mouse":return K.Mouse;case"api":return K.Command}}K.fromValue=V}(Tt||(e.TextEditorSelectionChangeKind=Tt={}));var Jt;(function(K){K[K.Other=0]="Other",K[K.Comment=1]="Comment",K[K.String=2]="String",K[K.RegEx=3]="RegEx"})(Jt||(e.SyntaxTokenType=Jt={})),function(K){function V(we){switch(we){case K.Other:return"other";case K.Comment:return"comment";case K.String:return"string";case K.RegEx:return"regex"}return"other"}K.toString=V}(Jt||(e.SyntaxTokenType=Jt={}));let Yt=class{constructor(V,we){if(we&&!E.URI.isUri(we))throw(0,j.$7)("target");if(!F.isRange(V)||V.isEmpty)throw(0,j.$7)("range");this.range=V,this.target=we}};e.$HM=Yt,e.$HM=Yt=Ye([y],Yt);let _t=class{constructor(V,we,je,Ze){this.red=V,this.green=we,this.blue=je,this.alpha=Ze}};e.$IM=_t,e.$IM=_t=Ye([y],_t);let ni=class{constructor(V,we){if(we&&!(we instanceof _t))throw(0,j.$7)("color");if(!F.isRange(V)||V.isEmpty)throw(0,j.$7)("range");this.range=V,this.color=we}};e.$JM=ni,e.$JM=ni=Ye([y],ni);let et=class{constructor(V){if(!V||typeof V!="string")throw(0,j.$7)("label");this.label=V}};e.$KM=et,e.$KM=et=Ye([y],et);var Bt;(function(K){K[K.RGB=0]="RGB",K[K.HEX=1]="HEX",K[K.HSL=2]="HSL"})(Bt||(e.ColorFormat=Bt={}));var ei;(function(K){K[K.Error=0]="Error",K[K.Warning=1]="Warning",K[K.Information=2]="Information"})(ei||(e.SourceControlInputBoxValidationType=ei={}));var dt;(function(K){K[K.Unknown=0]="Unknown",K[K.Shutdown=1]="Shutdown",K[K.Process=2]="Process",K[K.User=3]="User",K[K.Extension=4]="Extension"})(dt||(e.TerminalExitReason=dt={}));class wt{constructor(V,we,je){if(this.startIndex=V,this.length=we,this.tooltip=je,typeof V!="number"||V<0)throw(0,j.$7)("startIndex");if(typeof we!="number"||we<1)throw(0,j.$7)("length");if(je!==void 0&&typeof je!="string")throw(0,j.$7)("tooltip")}}e.$LM=wt;class ti{constructor(V){this.uri=V}}e.$MM=ti;class Ht{constructor(V){this.terminalCommand=V}}e.$NM=Ht;var Ut;(function(K){K[K.Panel=1]="Panel",K[K.Editor=2]="Editor"})(Ut||(e.TerminalLocation=Ut={}));class ft{constructor(V){if(this.options=V,typeof V!="object")throw(0,j.$7)("options")}}e.$OM=ft;var Rt;(function(K){K[K.Always=1]="Always",K[K.Silent=2]="Silent",K[K.Never=3]="Never"})(Rt||(e.TaskRevealKind=Rt={}));var ii;(function(K){K[K.Shared=1]="Shared",K[K.Dedicated=2]="Dedicated",K[K.New=3]="New"})(ii||(e.TaskPanelKind=ii={}));let Zt=class{static{d=this}static{this.Clean=new d("clean","Clean")}static{this.Build=new d("build","Build")}static{this.Rebuild=new d("rebuild","Rebuild")}static{this.Test=new d("test","Test")}static from(V){switch(V){case"clean":return d.Clean;case"build":return d.Build;case"rebuild":return d.Rebuild;case"test":return d.Test;default:return}}constructor(V,we){if(this.label=we,typeof V!="string"||typeof we!="string")throw(0,j.$7)("name");this.c=V}get id(){return this.c}};e.$PM=Zt,e.$PM=Zt=d=Ye([y],Zt);function Xe(K){let V="";for(let we=0;we<K.length;we++)V+=K[we].replace(/,/g,",,")+",";return V}let Lt=class{constructor(V,we,je){if(typeof V!="string")throw(0,j.$7)("process");this.e=[],this.c=V,we!==void 0&&(Array.isArray(we)?(this.e=we,this.f=je):this.f=we)}get process(){return this.c}set process(V){if(typeof V!="string")throw(0,j.$7)("process");this.c=V}get args(){return this.e}set args(V){Array.isArray(V)||(V=[]),this.e=V}get options(){return this.f}set options(V){this.f=V}computeId(){const V=[];if(V.push("process"),this.c!==void 0&&V.push(this.c),this.e&&this.e.length>0)for(const we of this.e)V.push(we);return Xe(V)}};e.$QM=Lt,e.$QM=Lt=Ye([y],Lt);let Wt=class{constructor(V,we,je){if(this.f=[],Array.isArray(we)){if(!V)throw(0,j.$7)("command can't be undefined or null");if(typeof V!="string"&&typeof V.value!="string")throw(0,j.$7)("command");this.e=V,this.f=we,this.g=je}else{if(typeof V!="string")throw(0,j.$7)("commandLine");this.c=V,this.g=we}}get commandLine(){return this.c}set commandLine(V){if(typeof V!="string")throw(0,j.$7)("commandLine");this.c=V}get command(){return this.e?this.e:""}set command(V){if(typeof V!="string"&&typeof V.value!="string")throw(0,j.$7)("command");this.e=V}get args(){return this.f}set args(V){this.f=V||[]}get options(){return this.g}set options(V){this.g=V}computeId(){const V=[];if(V.push("shell"),this.c!==void 0&&V.push(this.c),this.e!==void 0&&V.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const we of this.f)V.push(typeof we=="string"?we:we.value);return Xe(V)}};e.$RM=Wt,e.$RM=Wt=Ye([y],Wt);var ri;(function(K){K[K.Escape=1]="Escape",K[K.Strong=2]="Strong",K[K.Weak=3]="Weak"})(ri||(e.ShellQuoting=ri={}));var gt;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace"})(gt||(e.TaskScope=gt={}));class Ot{constructor(V){this.c=V}computeId(){return"customExecution"+(0,M.$Bg)()}set callback(V){this.c=V}get callback(){return this.c}}e.$SM=Ot;let At=class{static{$=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(V,we,je,Ze,it,lt){this.k=!1,this.l=this.definition=V;let mt;typeof we=="string"?(this.o=this.name=we,this.w=this.source=je,this.execution=Ze,mt=it,this.k=!0):we===gt.Global||we===gt.Workspace?(this.target=we,this.o=this.name=je,this.w=this.source=Ze,this.execution=it,mt=lt):(this.target=we,this.o=this.name=je,this.w=this.source=Ze,this.execution=it,mt=lt),typeof mt=="string"?(this.r=[mt],this.t=!0):Array.isArray(mt)?(this.r=mt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(V){this.j=V}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Lt?this.l={type:$.e,id:this.q.computeId()}:this.q instanceof Wt?this.l={type:$.f,id:this.q.computeId()}:this.q instanceof Ot?this.l={type:$.c,id:this.q.computeId()}:this.l={type:$.g,id:(0,M.$Bg)()}}get definition(){return this.l}set definition(V){if(V==null)throw(0,j.$7)("Kind can't be undefined or null");this.B(),this.l=V}get scope(){return this.m}set target(V){this.B(),this.m=V}get name(){return this.o}set name(V){if(typeof V!="string")throw(0,j.$7)("name");this.B(),this.o=V}get execution(){return this.q}set execution(V){V===null&&(V=void 0),this.B(),this.q=V;const we=this.l.type;($.g===we||$.e===we||$.f===we||$.c===we)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(V){if(Array.isArray(V))this.B(),this.r=V,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(V){V!==!0&&V!==!1&&(V=!1),this.B(),this.u=V}get source(){return this.w}set source(V){if(typeof V!="string"||V.length===0)throw(0,j.$7)("source must be a string of length > 0");this.B(),this.w=V}get group(){return this.x}set group(V){V===null&&(V=void 0),this.B(),this.x=V}get detail(){return this.A}set detail(V){V===null&&(V=void 0),this.A=V}get presentationOptions(){return this.y}set presentationOptions(V){V==null&&(V=Object.create(null)),this.B(),this.y=V}get runOptions(){return this.z}set runOptions(V){V==null&&(V=Object.create(null)),this.B(),this.z=V}};e.$TM=At,e.$TM=At=$=Ye([y],At);var qt;(function(K){K[K.SourceControl=1]="SourceControl",K[K.Window=10]="Window",K[K.Notification=15]="Notification"})(qt||(e.ProgressLocation=qt={}));var si;(function(K){function V(we){const je=we;return(0,w.$Wf)(je.value)?je.tooltip&&!(0,w.$Sf)(je.tooltip)?(console.log("INVALID view badge, invalid tooltip",je.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",je.value),!1)}K.isViewBadge=V})(si||(e.ViewBadge=si={}));let zt=D=class{static isTreeItem(V,we){const je=V;if(je.checkboxState!==void 0){const Ze=(0,w.$Wf)(je.checkboxState)?je.checkboxState:(0,w.$Uf)(je.checkboxState)&&(0,w.$Wf)(je.checkboxState.state)?je.checkboxState.state:void 0,it=!(0,w.$Wf)(je.checkboxState)&&(0,w.$Uf)(je.checkboxState)?je.checkboxState.tooltip:void 0;if(Ze===void 0||Ze!==kt.Checked&&Ze!==kt.Unchecked||it!==void 0&&!(0,w.$Sf)(it))return console.log("INVALID tree item, invalid checkboxState",je.checkboxState),!1}if(V instanceof D)return!0;if(je.label!==void 0&&!(0,w.$Sf)(je.label)&&!je.label?.label)return console.log("INVALID tree item, invalid label",je.label),!1;if(je.id!==void 0&&!(0,w.$Sf)(je.id))return console.log("INVALID tree item, invalid id",je.id),!1;if(je.iconPath!==void 0&&!(0,w.$Sf)(je.iconPath)&&!E.URI.isUri(je.iconPath)&&(!je.iconPath||!(0,w.$Sf)(je.iconPath.id))){const Ze=je.iconPath;if(!Ze||!(0,w.$Sf)(Ze.light)&&!E.URI.isUri(Ze.light)&&!(0,w.$Sf)(Ze.dark)&&!E.URI.isUri(Ze.dark))return console.log("INVALID tree item, invalid iconPath",je.iconPath),!1}return je.description!==void 0&&!(0,w.$Sf)(je.description)&&typeof je.description!="boolean"?(console.log("INVALID tree item, invalid description",je.description),!1):je.resourceUri!==void 0&&!E.URI.isUri(je.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",je.resourceUri),!1):je.tooltip!==void 0&&!(0,w.$Sf)(je.tooltip)&&!(je.tooltip instanceof Fe)?(console.log("INVALID tree item, invalid tooltip",je.tooltip),!1):je.command!==void 0&&!je.command.command?(console.log("INVALID tree item, invalid command",je.command),!1):je.collapsibleState!==void 0&&je.collapsibleState<Kt.None&&je.collapsibleState>Kt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",je.collapsibleState),!1):je.contextValue!==void 0&&!(0,w.$Sf)(je.contextValue)?(console.log("INVALID tree item, invalid contextValue",je.contextValue),!1):je.accessibilityInformation!==void 0&&!je.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",je.accessibilityInformation),!1):!0}constructor(V,we=Kt.None){this.collapsibleState=we,E.URI.isUri(V)?this.resourceUri=V:this.label=V}};e.$UM=zt,e.$UM=zt=D=Ye([y],zt);var Kt;(function(K){K[K.None=0]="None",K[K.Collapsed=1]="Collapsed",K[K.Expanded=2]="Expanded"})(Kt||(e.TreeItemCollapsibleState=Kt={}));var kt;(function(K){K[K.Unchecked=0]="Unchecked",K[K.Checked=1]="Checked"})(kt||(e.TreeItemCheckboxState=kt={}));let jt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(V){this.value=V}};e.$VM=jt,e.$VM=jt=Ye([y],jt);class Qt extends jt{}e.$WM=Qt;class Vt extends Qt{#e;constructor(V){super(""),this.#e=V}asFile(){return this.#e}}e.$XM=Vt;class yt{constructor(V,we,je,Ze){this.name=V,this.uri=we,this._itemId=je,this.c=Ze}data(){return this.c()}}e.$YM=yt;let It=class{#e=new Map;constructor(V){for(const[we,je]of V??[]){const Ze=this.#e.get(this.#t(we));Ze?Ze.push(je):this.#e.set(this.#t(we),[je])}}get(V){return this.#e.get(this.#t(V))?.[0]}set(V,we){this.#e.set(this.#t(V),[we])}forEach(V,we){for(const[je,Ze]of this.#e)for(const it of Ze)V.call(we,it,je,this)}*[Symbol.iterator](){for(const[V,we]of this.#e)for(const je of we)yield[V,je]}#t(V){return V.toLowerCase()}};e.$ZM=It,e.$ZM=It=Ye([y],It);let Et=class{constructor(V){this.insertText=V}};e.$1M=Et,e.$1M=Et=Ye([y],Et);let ci=class{constructor(V,we){this.label=we,this.insertText=V}};e.$2M=ci,e.$2M=ci=Ye([y],ci);let Re=class{constructor(V,we){this.id=V,this.color=we}static isThemeIcon(V){return typeof V.id!="string"?(console.log("INVALID ThemeIcon, invalid id",V.id),!1):!0}};e.$3M=Re,e.$3M=Re=Ye([y],Re),Re.File=new Re("file"),Re.Folder=new Re("folder");let Te=class{constructor(V){this.id=V}};e.$4M=Te,e.$4M=Te=Ye([y],Te);var Ee;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace",K[K.WorkspaceFolder=3]="WorkspaceFolder"})(Ee||(e.ConfigurationTarget=Ee={}));let ee=class{get base(){return this.c}set base(V){this.c=V,this.e=E.URI.file(V)}get baseUri(){return this.e}set baseUri(V){this.e=V,this.c=V.fsPath}constructor(V,we){if(typeof V!="string"&&(!V||!E.URI.isUri(V)&&!E.URI.isUri(V.uri)))throw(0,j.$7)("base");if(typeof we!="string")throw(0,j.$7)("pattern");typeof V=="string"?this.baseUri=E.URI.file(V):E.URI.isUri(V)?this.baseUri=V:this.baseUri=V.uri,this.pattern=we}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$5M=ee,e.$5M=ee=Ye([y],ee);const Me=new WeakMap;function qe(K,V){Me.set(K,V)}e.$6M=qe;let _e=class{constructor(V,we,je,Ze,it){this.enabled=typeof V=="boolean"?V:!0,typeof we=="string"&&(this.condition=we),typeof je=="string"&&(this.hitCondition=je),typeof Ze=="string"&&(this.logMessage=Ze),typeof it=="string"&&(this.mode=it)}get id(){return this.c||(this.c=Me.get(this)??(0,M.$Bg)()),this.c}};e.$7M=_e,e.$7M=_e=Ye([y],_e);let Je=class extends _e{constructor(V,we,je,Ze,it,lt){if(super(we,je,Ze,it,lt),V===null)throw(0,j.$7)("location");this.location=V}};e.$8M=Je,e.$8M=Je=Ye([y],Je);let ct=class extends _e{constructor(V,we,je,Ze,it,lt){super(we,je,Ze,it,lt),this.functionName=V}};e.$9M=ct,e.$9M=ct=Ye([y],ct);let vt=class extends _e{constructor(V,we,je,Ze,it,lt,mt,Gt){if(super(Ze,it,lt,mt,Gt),!we)throw(0,j.$7)("dataId");this.label=V,this.dataId=we,this.canPersist=je}};e.$0M=vt,e.$0M=vt=Ye([y],vt);let Nt=class{constructor(V,we,je){this.command=V,this.args=we||[],this.options=je}};e.$$M=Nt,e.$$M=Nt=Ye([y],Nt);let xt=class{constructor(V,we){this.port=V,this.host=we}};e.$_M=xt,e.$_M=xt=Ye([y],xt);let Mt=class{constructor(V){this.path=V}};e.$aN=Mt,e.$aN=Mt=Ye([y],Mt);let St=class{constructor(V){this.implementation=V}};e.$bN=St,e.$bN=St=Ye([y],St);let vi=class{constructor(V,we,je){this.session=V,this.threadId=we,this.frameId=je}};e.$cN=vi,e.$cN=vi=Ye([y],vi);let Pi=class{constructor(V,we){this.session=V,this.threadId=we}};e.$dN=Pi,e.$dN=Pi=Ye([y],Pi);let bi=class{constructor(V,we){this.range=V,this.expression=we}};e.$eN=bi,e.$eN=bi=Ye([y],bi);var wi;(function(K){K[K.Invoke=0]="Invoke",K[K.Automatic=1]="Automatic"})(wi||(e.InlineCompletionTriggerKind=wi={}));let ht=class{constructor(V,we){this.range=V,this.text=we}};e.$fN=ht,e.$fN=ht=Ye([y],ht);let Ai=class{constructor(V,we,je=!0){this.range=V,this.variableName=we,this.caseSensitiveLookup=je}};e.$gN=Ai,e.$gN=Ai=Ye([y],Ai);let ui=class{constructor(V,we){this.range=V,this.expression=we}};e.$hN=ui,e.$hN=ui=Ye([y],ui);let gi=class{constructor(V,we){this.frameId=V,this.stoppedLocation=we}};e.$iN=gi,e.$iN=gi=Ye([y],gi);var Ri;(function(K){K[K.AIGenerated=1]="AIGenerated"})(Ri||(e.NewSymbolNameTag=Ri={}));class ln{constructor(V,we){this.newSymbolName=V,this.tags=we}}e.$jN=ln;var Xi;(function(K){K[K.Changed=1]="Changed",K[K.Created=2]="Created",K[K.Deleted=3]="Deleted"})(Xi||(e.FileChangeType=Xi={}));let Li=b=class extends Error{static FileExists(V){return new b(V,v.FileSystemProviderErrorCode.FileExists,b.FileExists)}static FileNotFound(V){return new b(V,v.FileSystemProviderErrorCode.FileNotFound,b.FileNotFound)}static FileNotADirectory(V){return new b(V,v.FileSystemProviderErrorCode.FileNotADirectory,b.FileNotADirectory)}static FileIsADirectory(V){return new b(V,v.FileSystemProviderErrorCode.FileIsADirectory,b.FileIsADirectory)}static NoPermissions(V){return new b(V,v.FileSystemProviderErrorCode.NoPermissions,b.NoPermissions)}static Unavailable(V){return new b(V,v.FileSystemProviderErrorCode.Unavailable,b.Unavailable)}constructor(V,we=v.FileSystemProviderErrorCode.Unknown,je){super(E.URI.isUri(V)?V.toString(!0):V),this.code=je?.name??"Unknown",(0,v.$Uk)(this,we),Object.setPrototypeOf(this,b.prototype),typeof Error.captureStackTrace=="function"&&typeof je=="function"&&Error.captureStackTrace(this,je)}};e.$kN=Li,e.$kN=Li=b=Ye([y],Li);let yi=class{constructor(V,we,je){this.start=V,this.end=we,this.kind=je}};e.$lN=yi,e.$lN=yi=Ye([y],yi);var Zi;(function(K){K[K.Comment=1]="Comment",K[K.Imports=2]="Imports",K[K.Region=3]="Region"})(Zi||(e.FoldingRangeKind=Zi={}));var Mi;(function(K){K[K.Collapsed=0]="Collapsed",K[K.Expanded=1]="Expanded"})(Mi||(e.CommentThreadCollapsibleState=Mi={}));var xi;(function(K){K[K.Editing=0]="Editing",K[K.Preview=1]="Preview"})(xi||(e.CommentMode=xi={}));var ki;(function(K){K[K.Published=0]="Published",K[K.Draft=1]="Draft"})(ki||(e.CommentState=ki={}));var Ei;(function(K){K[K.Unresolved=0]="Unresolved",K[K.Resolved=1]="Resolved"})(Ei||(e.CommentThreadState=Ei={}));class hn{constructor(V,we=[]){this.tokenTypes=V,this.tokenModifiers=we}}e.$mN=hn;function dn(K){return typeof K>"u"||(0,w.$Tf)(K)}class mi{constructor(V){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,V){this.m=!0;for(let we=0,je=V.tokenTypes.length;we<je;we++)this.k.set(V.tokenTypes[we],we);for(let we=0,je=V.tokenModifiers.length;we<je;we++)this.l.set(V.tokenModifiers[we],we)}}push(V,we,je,Ze,it){if(typeof V=="number"&&typeof we=="number"&&typeof je=="number"&&typeof Ze=="number"&&(typeof it=="number"||typeof it>"u"))return typeof it>"u"&&(it=0),this.q(V,we,je,Ze,it);if(F.isRange(V)&&typeof we=="string"&&dn(je))return this.o(V,we,je);throw(0,j.$7)()}o(V,we,je){if(!this.m)throw new Error("Legend must be provided in constructor");if(V.start.line!==V.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(we))throw new Error("`tokenType` is not in the provided legend");const Ze=V.start.line,it=V.start.character,lt=V.end.character-V.start.character,mt=this.k.get(we);let Gt=0;if(je)for(const ai of je){if(!this.l.has(ai))throw new Error("`tokenModifier` is not in the provided legend");const hi=this.l.get(ai);Gt|=1<<hi>>>0}this.q(Ze,it,lt,mt,Gt)}q(V,we,je,Ze,it){if(this.f&&(V<this.c||V===this.c&&we<this.e)){this.f=!1;const Gt=this.g.length/5|0;let ai=0,hi=0;for(let fi=0;fi<Gt;fi++){let $i=this.g[5*fi],Yi=this.g[5*fi+1];$i===0?($i=ai,Yi+=hi):$i+=ai,this.g[5*fi]=$i,this.g[5*fi+1]=Yi,ai=$i,hi=Yi}}let lt=V,mt=we;this.f&&this.j>0&&(lt-=this.c,lt===0&&(mt-=this.e)),this.g[this.j++]=lt,this.g[this.j++]=mt,this.g[this.j++]=je,this.g[this.j++]=Ze,this.g[this.j++]=it,this.c=V,this.e=we}static r(V){const we=[],je=V.length/5|0;for(let mt=0;mt<je;mt++)we[mt]=mt;we.sort((mt,Gt)=>{const ai=V[5*mt],hi=V[5*Gt];if(ai===hi){const fi=V[5*mt+1],$i=V[5*Gt+1];return fi-$i}return ai-hi});const Ze=new Uint32Array(V.length);let it=0,lt=0;for(let mt=0;mt<je;mt++){const Gt=5*we[mt],ai=V[Gt+0],hi=V[Gt+1],fi=V[Gt+2],$i=V[Gt+3],Yi=V[Gt+4],An=ai-it,_n=An===0?hi-lt:hi,Qi=5*mt;Ze[Qi+0]=An,Ze[Qi+1]=_n,Ze[Qi+2]=fi,Ze[Qi+3]=$i,Ze[Qi+4]=Yi,it=ai,lt=hi}return Ze}build(V){return this.f?new Oi(new Uint32Array(this.g),V):new Oi(mi.r(this.g),V)}}e.$nN=mi;class Oi{constructor(V,we){this.resultId=we,this.data=V}}e.$oN=Oi;class fn{constructor(V,we,je){this.start=V,this.deleteCount=we,this.data=je}}e.$pN=fn;class gn{constructor(V,we){this.resultId=we,this.edits=V}}e.$qN=gn;var _i;(function(K){K[K.Separate=0]="Separate",K[K.MergeWithParent=1]="MergeWithParent"})(_i||(e.DebugConsoleMode=_i={}));class mn{constructor(V){this.name=V}}e.$rN=mn;let pi=class{static{this.Back={iconPath:new Re("arrow-left")}}constructor(){}};e.$sN=pi,e.$sN=pi=Ye([y],pi);var ji;(function(K){K[K.Separator=-1]="Separator",K[K.Default=0]="Default"})(ji||(e.QuickPickItemKind=ji={}));var en;(function(K){K[K.Info=1]="Info",K[K.Warning=2]="Warning",K[K.Error=3]="Error"})(en||(e.InputBoxValidationSeverity=en={}));var Ni;(function(K){K[K.UI=1]="UI",K[K.Workspace=2]="Workspace"})(Ni||(e.ExtensionKind=Ni={}));class tn{static validate(V){if(typeof V.badge=="string"){let we=(0,p.$tf)(V.badge,0);if(we<V.badge.length&&(we+=(0,p.$tf)(V.badge,we)),V.badge.length>we)throw new Error("The 'badge'-property must be undefined or a short character")}else if(V.badge&&!Re.isThemeIcon(V.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!V.color&&!V.badge&&!V.tooltip)throw new Error("The decoration is empty");return!0}constructor(V,we,je){this.badge=V,this.tooltip=we,this.color=je}}e.$tN=tn;let Fi=class{constructor(V){this.kind=V}};e.$uN=Fi,e.$uN=Fi=Ye([y],Fi);var nn;(function(K){K[K.Light=1]="Light",K[K.Dark=2]="Dark",K[K.HighContrast=3]="HighContrast",K[K.HighContrastLight=4]="HighContrastLight"})(nn||(e.ColorThemeKind=nn={}));class di{static isNotebookRange(V){return V instanceof di?!0:V?typeof V.start=="number"&&typeof V.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(V,we){if(V<0)throw(0,j.$7)("start must be positive");if(we<0)throw(0,j.$7)("end must be positive");V<=we?(this.c=V,this.e=we):(this.c=we,this.e=V)}with(V){let we=this.c,je=this.e;return V.start!==void 0&&(we=V.start),V.end!==void 0&&(je=V.end),we===this.c&&je===this.e?this:new di(we,je)}}e.$vN=di;class Si{static validate(V){if(typeof V.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof V.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof V.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(V){return Array.isArray(V)&&V.every(we=>Si.isNotebookCellData(we))}static isNotebookCellData(V){return!0}constructor(V,we,je,Ze,it,lt,mt){this.kind=V,this.value=we,this.languageId=je,this.mime=Ze,this.outputs=it??[],this.metadata=lt,this.executionSummary=mt,Si.validate(this)}}e.$wN=Si;class Ti{constructor(V){this.cells=V}}e.$xN=Ti;class oi{static isNotebookCellOutputItem(V){return V instanceof oi?!0:V?typeof V.mime=="string"&&V.data instanceof Uint8Array:!1}static error(V){const we={name:V.name,message:V.message,stack:V.stack};return oi.json(we,"application/vnd.code.notebook.error")}static stdout(V){return oi.text(V,"application/vnd.code.notebook.stdout")}static stderr(V){return oi.text(V,"application/vnd.code.notebook.stderr")}static bytes(V,we="application/octet-stream"){return new oi(V,we)}static#e=new TextEncoder;static text(V,we=R.$ts.text){const je=oi.#e.encode(String(V));return new oi(je,we)}static json(V,we="text/x-json"){const je=JSON.stringify(V,void 0,"	");return oi.text(je,we)}constructor(V,we){this.data=V,this.mime=we;const je=(0,R.$xs)(we,!0);if(!je)throw new Error(`INVALID mime type: ${we}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=je}}e.$yN=oi;class Ue{static isNotebookCellOutput(V){return V instanceof Ue?!0:!V||typeof V!="object"?!1:typeof V.id=="string"&&Array.isArray(V.items)}static ensureUniqueMimeTypes(V,we=!1){const je=new Set,Ze=new Set;for(let it=0;it<V.length;it++){const lt=V[it],mt=(0,R.$xs)(lt.mime);if(!je.has(mt)||(0,k.$6J)(mt)){je.add(mt);continue}Ze.add(it),we&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return Ze.size===0?V:V.filter((it,lt)=>!Ze.has(lt))}constructor(V,we,je){this.items=Ue.ensureUniqueMimeTypes(V,!0),typeof we=="string"?(this.id=we,this.metadata=je):(this.id=(0,M.$Bg)(),this.metadata=we??je)}}e.$zN=Ue;var li;(function(K){K[K.Markup=1]="Markup",K[K.Code=2]="Code"})(li||(e.NotebookCellKind=li={}));var zi;(function(K){K[K.Idle=1]="Idle",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(zi||(e.NotebookCellExecutionState=zi={}));var ot;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(ot||(e.NotebookCellStatusBarAlignment=ot={}));var bt;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(bt||(e.NotebookEditorRevealType=bt={}));class $n{constructor(V,we){this.text=V,this.alignment=we}}e.$AN=$n;var rn;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred"})(rn||(e.NotebookControllerAffinity=rn={}));var Bi;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred",K[K.Hidden=-1]="Hidden"})(Bi||(e.NotebookControllerAffinity2=Bi={}));class bn{constructor(V,we=[]){this.uri=V,this.provides=(0,l.$3b)(we)}}e.$BN=bn;class Di{constructor(V){this.label=V}}e.$CN=Di;var sn;(function(K){K[K.Named=1]="Named",K[K.Indexed=2]="Indexed"})(sn||(e.NotebookVariablesRequestKind=sn={}));let Ui=class{constructor(V,we){this.label=V,this.timestamp=we}};e.$DN=Ui,e.$DN=Ui=Ye([y],Ui);var on;(function(K){K[K.Production=1]="Production",K[K.Development=2]="Development",K[K.Test=3]="Test"})(on||(e.ExtensionMode=on={}));var Wi;(function(K){K[K.Node=1]="Node",K[K.Webworker=2]="Webworker"})(Wi||(e.ExtensionRuntime=Wi={}));var an;(function(K){K[K.Other=0]="Other",K[K.Comment=1]="Comment",K[K.String=2]="String",K[K.RegEx=3]="RegEx"})(an||(e.StandardTokenType=an={}));class wn{constructor(V,we){this.ranges=V,this.wordPattern=we}}e.$EN=wn;class pn{constructor(V){this.c=V}get autoForwardAction(){return this.c}}e.$FN=pn;var cn;(function(K){K[K.Queued=1]="Queued",K[K.Running=2]="Running",K[K.Passed=3]="Passed",K[K.Failed=4]="Failed",K[K.Skipped=5]="Skipped",K[K.Errored=6]="Errored"})(cn||(e.TestResultState=cn={}));var un;(function(K){K[K.Run=1]="Run",K[K.Debug=2]="Debug",K[K.Coverage=3]="Coverage"})(un||(e.TestRunProfileKind=un={}));let qi=class{constructor(V=void 0,we=void 0,je=void 0,Ze=!1){this.include=V,this.exclude=we,this.profile=je,this.continuous=Ze}};e.$GN=qi,e.$GN=qi=Ye([y],qi);let Vi=g=class{static diff(V,we,je){const Ze=new g(V);return Ze.expectedOutput=we,Ze.actualOutput=je,Ze}constructor(V){this.message=V}};e.$HN=Vi,e.$HN=Vi=g=Ye([y],Vi);let Hi=class{constructor(V){this.id=V}};e.$IN=Hi,e.$IN=Hi=Ye([y],Hi);class Ci{constructor(V,we){this.covered=V,this.total=we}}e.$JN=Ci;const Ki=K=>{if(K&&K.covered>K.total)throw new Error(`The total number of covered items (${K.covered}) cannot be greater than the total (${K.total})`)};class Gi{static fromDetails(V,we){const je=new Ci(0,0),Ze=new Ci(0,0),it=new Ci(0,0);for(const mt of we)if("branches"in mt){je.total+=1,je.covered+=mt.executed?1:0;for(const Gt of mt.branches)Ze.total+=1,Ze.covered+=Gt.executed?1:0}else it.total+=1,it.covered+=mt.executed?1:0;const lt=new Gi(V,je,Ze.total>0?Ze:void 0,it.total>0?it:void 0);return lt.detailedCoverage=we,lt}constructor(V,we,je,Ze){this.uri=V,this.statementCoverage=we,this.branchCoverage=je,this.declarationCoverage=Ze,Ki(we),Ki(je),Ki(Ze)}}e.$KN=Gi;class me{get executionCount(){return+this.executed}set executionCount(V){this.executed=V}constructor(V,we,je=[]){this.executed=V,this.location=we,this.branches=je}}e.$LN=me;class ke{get executionCount(){return+this.executed}set executionCount(V){this.executed=V}constructor(V,we,je){this.executed=V,this.location=we,this.label=je}}e.$MN=ke;class We{get executionCount(){return+this.executed}set executionCount(V){this.executed=V}constructor(V,we,je){this.name=V,this.executed=we,this.location=je}}e.$NN=We;var at;(function(K){K[K.None=0]="None",K[K.Option=1]="Option",K[K.Default=2]="Default",K[K.Preferred=3]="Preferred"})(at||(e.ExternalUriOpenerPriority=at={}));var pt;(function(K){K[K.Untrusted=0]="Untrusted",K[K.Trusted=1]="Trusted",K[K.Unspecified=2]="Unspecified"})(pt||(e.WorkspaceTrustState=pt={}));var Ft;(function(K){K[K.Notify=1]="Notify",K[K.OpenBrowser=2]="OpenBrowser",K[K.OpenPreview=3]="OpenPreview",K[K.Silent=4]="Silent",K[K.Ignore=5]="Ignore",K[K.OpenBrowserOnce=6]="OpenBrowserOnce"})(Ft||(e.PortAutoForwardAction=Ft={}));class Ji{constructor(V,we,je,Ze,it,lt){this.kind=V,this.name=we,this.detail=je,this.uri=Ze,this.range=it,this.selectionRange=lt}}e.$ON=Ji;class Rn{constructor(V){this.uri=V}}e.$PN=Rn;class Ln{constructor(V,we){this.original=V,this.modified=we}}e.$QN=Ln;class Mn{constructor(V,we,je,Ze){this.base=V,this.input1=we,this.input2=je,this.result=Ze}}e.$RN=Mn;class On{constructor(V,we){this.uri=V,this.viewType=we}}e.$SN=On;class jn{constructor(V){this.viewType=V}}e.$TN=jn;class Nn{constructor(V,we){this.uri=V,this.notebookType=we}}e.$UN=Nn;class Fn{constructor(V,we,je){this.original=V,this.modified=we,this.notebookType=je}}e.$VN=Fn;class Tn{constructor(){}}e.$WN=Tn;class zn{constructor(V,we){this.uri=V,this.inputBoxUri=we}}e.$XN=zn;class Bn{constructor(V){this.providerId=V}}e.$YN=Bn;var vn;(function(K){K[K.Down=0]="Down",K[K.Up=1]="Up"})(vn||(e.InteractiveSessionVoteDirection=vn={}));var yn;(function(K){K[K.Action=1]="Action",K[K.Toolbar=2]="Toolbar"})(yn||(e.ChatCopyKind=yn={}));var kn;(function(K){K[K.Short=1]="Short",K[K.Medium=2]="Medium",K[K.Full=3]="Full"})(kn||(e.ChatVariableLevel=kn={}));class Un{constructor(V,we){this.label=V,this.values=we}}e.$ZN=Un;var En;(function(K){K[K.Unhelpful=0]="Unhelpful",K[K.Helpful=1]="Helpful",K[K.Undone=2]="Undone",K[K.Accepted=3]="Accepted",K[K.Bug=4]="Bug"})(En||(e.InteractiveEditorResponseFeedbackKind=En={}));var Sn;(function(K){K[K.Unhelpful=0]="Unhelpful",K[K.Helpful=1]="Helpful"})(Sn||(e.ChatResultFeedbackKind=Sn={}));class Wn{constructor(V){this.value=typeof V=="string"?new Fe(V):V}}e.$1N=Wn;class qn{constructor(V,we){this.value=V,this.baseUri=we}}e.$2N=qn;class Vn{constructor(V,we){this.value=V,this.title=we}}e.$3N=Vn;class Hn{constructor(V){this.value=V}}e.$4N=Hn;class Kn{constructor(V){this.value=V}}e.$5N=Kn;class Gn{constructor(V){this.value=V}}e.$6N=Gn;class Jn{constructor(V,we,je,Ze){this.prompt=V,this.command=we,this.variables=je,this.participant=Ze}}e.$7N=Jn;class Yn{constructor(V,we,je,Ze){this.response=V,this.result=we,this.participant=je,this.command=Ze}}e.$8N=Yn;class Qn{constructor(V){this.content=V}}e.$9N=Qn;class Xn{constructor(V,we){this.content=V,this.name=we}}e.$0N=Xn;class Zn{constructor(V){this.content=V}}e.$$N=Zn;class Ii extends Error{static NotFound(V){return new Ii(V,Ii.NotFound.name)}static NoPermissions(V){return new Ii(V,Ii.NoPermissions.name)}constructor(V,we,je){super(V,{cause:je}),this.name="LanguageModelError",this.code=we??""}}e.$_N=Ii;var Dn;(function(K){K[K.SymbolInformation=1]="SymbolInformation",K[K.CommandInformation=2]="CommandInformation",K[K.SearchInformation=3]="SearchInformation",K[K.SettingInformation=4]="SettingInformation"})(Dn||(e.RelatedInformationType=Dn={}));var Cn;(function(K){K[K.Started=1]="Started",K[K.Recognizing=2]="Recognizing",K[K.Recognized=3]="Recognized",K[K.Stopped=4]="Stopped"})(Cn||(e.SpeechToTextStatus=Cn={}));var In;(function(K){K[K.Recognized=1]="Recognized",K[K.Stopped=2]="Stopped"})(In||(e.KeywordRecognitionStatus=In={}));class xn{constructor(V,we){this.text=V,this.range=we}}e.$aO=xn;var Pn;(function(K){K[K.Invoke=0]="Invoke",K[K.Automatic=1]="Automatic"})(Pn||(e.InlineEditTriggerKind=Pn={}))}),define(Se[318],De([1,0,6,7]),function(fe,e,l,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ohc=void 0;class L{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(l.$6L.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,p,w){if(this.a.size===0)throw new Error("No related information providers registered");const E=this.a.get(R);if(!E)throw new Error("related information provider not found");return await E.provideRelatedInformation(p,w)??[]}getRelatedInformation(R,p,w){return this.c.$getAiRelatedInformation(p,w)}registerRelatedInformationProvider(R,p,w){const E=this.b;return this.b++,this.a.set(E,w),this.c.$registerAiRelatedInformationProvider(E,p),new j.$8L(()=>{this.c.$unregisterAiRelatedInformationProvider(E),this.a.delete(E)})}}e.$Ohc=L}),define(Se[120],De([1,0,4,6,7,25,145,5,20]),function(fe,e,l,j,L,A,R,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1hc=e.$Zhc=void 0,e.$Zhc=(0,p.$fi)("IExtHostAuthentication");let E=class{constructor(v){this.b=new Map,this.c=new l.$5d,this.onDidChangeSessions=this.c.event,this.d=new M,this.f=new M,this.a=v.getProxy(j.$6L.MainThreadAuthentication)}async getSession(v,S,k,u={}){const m=A.$zm.toKey(v.identifier),o=[...k].sort().join(" ");return await this.d.getOrCreate(`${m} ${S} ${o}`,async()=>{await this.a.$ensureProvider(S);const i=v.displayName||v.name;return this.a.$getSession(S,k,m,i,u)})}async getSessions(v,S,k){const u=A.$zm.toKey(v.identifier),m=[...k].sort().join(" ");return await this.f.getOrCreate(`${u} ${m}`,async()=>{await this.a.$ensureProvider(S);const o=v.displayName||v.name;return this.a.$getSessions(S,k,u,o)})}async removeSession(v,S){const k=this.b.get(v);return k?k.provider.removeSession(S):this.a.$removeSession(v,S)}registerAuthenticationProvider(v,S,k,u){if(this.b.get(v))throw new Error(`An authentication provider with id '${v}' is already registered.`);this.b.set(v,{label:S,provider:k,options:u??{supportsMultipleAccounts:!1}});const m=k.onDidChangeSessions(o=>this.a.$sendDidChangeSessions(v,o));return this.a.$registerAuthenticationProvider(v,S,u?.supportsMultipleAccounts??!1),new L.$8L(()=>{m.dispose(),this.b.delete(v),this.a.$unregisterAuthenticationProvider(v)})}$createSession(v,S,k){const u=this.b.get(v);if(u)return Promise.resolve(u.provider.createSession(S,k));throw new Error(`Unable to find authentication provider with handle: ${v}`)}$removeSession(v,S){const k=this.b.get(v);if(k)return Promise.resolve(k.provider.removeSession(S));throw new Error(`Unable to find authentication provider with handle: ${v}`)}$getSessions(v,S){const k=this.b.get(v);if(k)return Promise.resolve(k.provider.getSessions(S));throw new Error(`Unable to find authentication provider with handle: ${v}`)}$onDidChangeAuthenticationSessions(v,S){return v.startsWith(R.$_K)||this.c.fire({provider:{id:v,label:S}}),Promise.resolve()}};e.$1hc=E,e.$1hc=E=Ye([Ve(0,w.$lO)],E);class M{constructor(){this.a=new Map}getOrCreate(v,S){const k=this.a.get(v);if(k)return k;const u=S().finally(()=>this.a.delete(v));return this.a.set(v,u),u}}}),define(Se[151],De([1,0,2,6,7,5,20,12,19,14,17,26]),function(fe,e,l,j,L,A,R,p,w,E,M,C){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$2ic=e.$1ic=void 0;let S=class{static{v=this}static{this.c=0}static{this.d=250}constructor(u,m){this.h=m,this.f=new Map,this.g=u.getProxy(j.$6L.MainThreadDecorations)}registerFileDecorationProvider(u,m){const o=v.c++;this.f.set(o,{provider:u,extensionDescription:m}),this.g.$registerDecorationProvider(o,m.identifier.value);const i=u.onDidChangeFileDecorations&&u.onDidChangeFileDecorations(n=>{if(!n){this.g.$onDidChange(o,null);return}const s=(0,w.$3b)(n);if(s.length<=v.d){this.g.$onDidChange(o,s);return}this.h.warn("[Decorations] CAPPING events from decorations provider",m.identifier.value,s.length);const c=s.map(h=>({uri:h,rank:(0,E.$Ye)(h.path,"/")})),t=(0,w.$zb)(c,(h,r)=>h.rank-r.rank||(0,E.$cf)(h.uri.path,r.uri.path)),f=[];e:for(const h of t){let r;for(const a of h){const d=(0,M.$mc)(a.uri.path);if(r!==d&&(r=d,f.push(a.uri)>=v.d))break e}}this.g.$onDidChange(o,f)});return new L.$8L(()=>{i?.dispose(),this.g.$unregisterDecorationProvider(o),this.f.delete(o)})}async $provideDecorations(u,m,o){if(!this.f.has(u))return Object.create(null);const i=Object.create(null),{provider:n,extensionDescription:s}=this.f.get(u);return await Promise.all(m.map(async c=>{try{const{uri:t,id:f}=c,h=await Promise.resolve(n.provideFileDecoration(l.URI.revive(t),o));if(!h)return;try{L.$tN.validate(h),h.badge&&typeof h.badge!="string"&&(0,C.$YF)(s,"codiconDecoration"),i[f]=[h.propagate,h.tooltip,h.badge,h.color]}catch(r){this.h.warn(`INVALID decoration from extension '${s.identifier.value}': ${r}`)}}catch(t){this.h.error(t)}})),i}};e.$1ic=S,e.$1ic=S=v=Ye([Ve(0,R.$lO),Ve(1,p.$zj)],S),e.$2ic=(0,A.$fi)("IExtHostDecorations")}),define(Se[319],De([1,0,13,2,7,6,15,22,14]),function(fe,e,l,j,L,A,R,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4ic=void 0;class E{static{this.a=0}constructor(C,v,S){this.d=v,this.e=S,this.b=new Map,this.c=C.getProxy(A.$6L.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(C,v){if(Object.keys(R.Schemas).indexOf(C)>=0)throw new Error(`scheme '${C}' already registered`);const S=E.a++;this.b.set(S,v),this.c.$registerTextContentProvider(S,C);let k;if(typeof v.onDidChange=="function"){let u;k=v.onDidChange(async m=>{if(m.scheme!==C){this.e.warn(`Provider for scheme '${C}' is firing event for schema '${m.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(m))return;u&&await u;const o=this.$provideTextDocumentContent(S,m).then(async i=>{if(!i&&typeof i!="string")return;const n=this.d.getDocument(m);if(!n)return;const s=(0,w.$9e)(i);if(!n.equalLines(s))return this.c.$onVirtualDocumentChange(m,i)}).catch(l.$1).finally(()=>{u===o&&(u=void 0)});u=o})}return new L.$8L(()=>{this.b.delete(S)&&this.c.$unregisterTextContentProvider(S),k&&(k.dispose(),k=void 0)})}$provideTextDocumentContent(C,v){const S=this.b.get(C);return S?Promise.resolve(S.provideTextDocumentContent(j.URI.revive(v),p.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${v.scheme}`))}}e.$4ic=E}),define(Se[152],De([1,0,61,15,14,181,129,7,19]),function(fe,e,l,j,L,A,R,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pO=e.$oO=e.$nO=void 0;const E=new Map;function M(k,u){u?E.set(k,u):E.delete(k)}e.$nO=M;function C(k){return E.get(k)}class v extends A.$Av{constructor(u,m,o,i,n,s,c){super(m,o,i,n),this.c=u,this.m=s,this.q=c,this.b=!1}dispose(){(0,l.ok)(!this.b),this.b=!0,this.q=!1}equalLines(u){return(0,w.$ub)(this.f,u)}get document(){if(!this.a){const u=this;this.a={get uri(){return u.d},get fileName(){return u.d.fsPath},get isUntitled(){return u.d.scheme===j.Schemas.untitled},get languageId(){return u.m},get version(){return u.h},get isClosed(){return u.b},get isDirty(){return u.q},save(){return u.r()},getText(m){return m?u.s(m):u.getText()},get eol(){return u.g===`
`?p.EndOfLine.LF:p.EndOfLine.CRLF},get lineCount(){return u.f.length},lineAt(m){return u.t(m)},offsetAt(m){return u.u(m)},positionAt(m){return u.v(m)},validateRange(m){return u.w(m)},validatePosition(m){return u.x(m)},getWordRangeAtPosition(m,o){return u.y(m,o)}}}return Object.freeze(this.a)}_acceptLanguageId(u){(0,l.ok)(!this.b),this.m=u}_acceptIsDirty(u){(0,l.ok)(!this.b),this.q=u}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(u){const m=this.w(u);if(m.isEmpty)return"";if(m.isSingleLine)return this.f[m.start.line].substring(m.start.character,m.end.character);const o=this.g,i=m.start.line,n=m.end.line,s=[];s.push(this.f[i].substring(m.start.character));for(let c=i+1;c<n;c++)s.push(this.f[c]);return s.push(this.f[n].substring(0,m.end.character)),s.join(o)}t(u){let m;if(u instanceof p.$9L?m=u.line:typeof u=="number"&&(m=u),typeof m!="number"||m<0||m>=this.f.length||Math.floor(m)!==m)throw new Error("Illegal value for `line`");return new S(m,this.f[m],m===this.f.length-1)}u(u){return u=this.x(u),this.l(),this.j.getPrefixSum(u.line-1)+u.character}v(u){u=Math.floor(u),u=Math.max(0,u),this.l();const m=this.j.getIndexOf(u),o=this.f[m.index].length;return new p.$9L(m.index,Math.min(m.remainder,o))}w(u){if(!(u instanceof p.$0L))throw new Error("Invalid argument");const m=this.x(u.start),o=this.x(u.end);return m===u.start&&o===u.end?u:new p.$0L(m.line,m.character,o.line,o.character)}x(u){if(!(u instanceof p.$9L))throw new Error("Invalid argument");if(this.f.length===0)return u.with(0,0);let{line:m,character:o}=u,i=!1;if(m<0)m=0,o=0,i=!0;else if(m>=this.f.length)m=this.f.length-1,o=this.f[m].length,i=!0;else{const n=this.f[m].length;o<0?(o=0,i=!0):o>n&&(o=n,i=!0)}return i?new p.$9L(m,o):u}y(u,m){const o=this.x(u);if(!m)m=C(this.m);else if((0,L.$8e)(m))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${m.source}' because it matches the empty string.`);const i=(0,R.$Ls)(o.character+1,(0,R.$Js)(m),this.f[o.line],0);if(i)return new p.$0L(o.line,i.startColumn-1,o.line,i.endColumn-1)}}e.$oO=v;class S{constructor(u,m,o){this.a=u,this.b=m,this.c=o}get lineNumber(){return this.a}get text(){return this.b}get range(){return new p.$0L(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new p.$0L(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$pO=S}),define(Se[320],De([1,0,6,7]),function(fe,e,l,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6ic=void 0;class L{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(l.$6L.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,p,w){if(this.a.size===0)throw new Error("No embedding vector providers registered");const E=this.a.get(R);if(!E)throw new Error("Embedding vector provider not found");const M=await E.provideEmbeddingVector(p,w);if(!M)throw new Error("Embedding vector provider returned undefined");return M}registerEmbeddingVectorProvider(R,p,w){const E=this.b;return this.b++,this.a.set(E,w),this.c.$registerAiEmbeddingVectorProvider(p,E),new j.$8L(()=>{this.c.$unregisterAiEmbeddingVectorProvider(E),this.a.delete(E)})}}e.$6ic=L}),define(Se[68],De([1,0,6,32,7,21,5,20,59,3,8,23,15]),function(fe,e,l,j,L,A,R,p,w,E,M,C,v){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$hic=e.$gic=void 0;let k=S=class{constructor(m,o){this.b=new Map,this.c=new M.$oh,this.a=m.getProxy(l.$6L.MainThreadFileSystem);const i=this;this.value=Object.freeze({async stat(n){try{let s;const c=i.b.get(n.scheme);return c?(await i.a.$ensureActivation(n.scheme),s=await c.impl.stat(n)):s=await i.a.$stat(n),{type:s.type,ctime:s.ctime,mtime:s.mtime,size:s.size,permissions:s.permissions===j.FilePermission.Readonly?1:void 0}}catch(s){S.e(s)}},async readDirectory(n){try{const s=i.b.get(n.scheme);return s?(await i.a.$ensureActivation(n.scheme),(await s.impl.readDirectory(n)).slice()):await i.a.$readdir(n)}catch(s){return S.e(s)}},async createDirectory(n){try{const s=i.b.get(n.scheme);return s&&!s.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(s.impl,s.extUri,n)):await i.a.$mkdir(n)}catch(s){return S.e(s)}},async readFile(n){try{const s=i.b.get(n.scheme);return s?(await i.a.$ensureActivation(n.scheme),(await s.impl.readFile(n)).slice()):(await i.a.$readFile(n)).buffer}catch(s){return S.e(s)}},async writeFile(n,s){try{const c=i.b.get(n.scheme);return c&&!c.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(c.impl,c.extUri,c.extUri.dirname(n)),await i.c.queueFor(n,()=>Promise.resolve(c.impl.writeFile(n,s,{create:!0,overwrite:!0})))):await i.a.$writeFile(n,A.$se.wrap(s))}catch(c){return S.e(c)}},async delete(n,s){try{const c=i.b.get(n.scheme);return c&&!c.isReadonly&&!s?.useTrash?(await i.a.$ensureActivation(n.scheme),await c.impl.delete(n,{recursive:!1,...s})):await i.a.$delete(n,{recursive:!1,useTrash:!1,atomic:!1,...s})}catch(c){return S.e(c)}},async rename(n,s,c){try{return await i.a.$rename(n,s,{overwrite:!1,...c})}catch(t){return S.e(t)}},async copy(n,s,c){try{return await i.a.$copy(n,s,{overwrite:!1,...c})}catch(t){return S.e(t)}},isWritableFileSystem(n){const s=o.getCapabilities(n);if(typeof s=="number")return!(s&2048)}})}async d(m,o,i){const n=[];for(;!o.isEqual(i,o.dirname(i));)try{if(!((await m.stat(i)).type&j.FileType.Directory))throw L.$kN.FileExists(`Unable to create folder '${i.scheme===v.Schemas.file?i.fsPath:i.toString(!0)}' that already exists but is not a directory`);break}catch(s){if(j.$Vk(s)!==j.FileSystemProviderErrorCode.FileNotFound)throw s;n.push(o.basename(i)),i=o.dirname(i)}for(let s=n.length-1;s>=0;s--){i=o.joinPath(i,n[s]);try{await m.createDirectory(i)}catch(c){if(j.$Vk(c)!==j.FileSystemProviderErrorCode.FileExists)throw c}}}static e(m){if(m instanceof L.$kN)throw m;if(m instanceof j.$Rk)switch(m.code){case j.FileSystemProviderErrorCode.FileExists:throw L.$kN.FileExists(m.message);case j.FileSystemProviderErrorCode.FileNotFound:throw L.$kN.FileNotFound(m.message);case j.FileSystemProviderErrorCode.FileNotADirectory:throw L.$kN.FileNotADirectory(m.message);case j.FileSystemProviderErrorCode.FileIsADirectory:throw L.$kN.FileIsADirectory(m.message);case j.FileSystemProviderErrorCode.NoPermissions:throw L.$kN.NoPermissions(m.message);case j.FileSystemProviderErrorCode.Unavailable:throw L.$kN.Unavailable(m.message);default:throw new L.$kN(m.message,m.name)}if(!(m instanceof Error))throw new L.$kN(String(m));if(m.name==="ENOPRO"||m.message.includes("ENOPRO"))throw L.$kN.Unavailable(m.message);switch(m.name){case j.FileSystemProviderErrorCode.FileExists:throw L.$kN.FileExists(m.message);case j.FileSystemProviderErrorCode.FileNotFound:throw L.$kN.FileNotFound(m.message);case j.FileSystemProviderErrorCode.FileNotADirectory:throw L.$kN.FileNotADirectory(m.message);case j.FileSystemProviderErrorCode.FileIsADirectory:throw L.$kN.FileIsADirectory(m.message);case j.FileSystemProviderErrorCode.NoPermissions:throw L.$kN.NoPermissions(m.message);case j.FileSystemProviderErrorCode.Unavailable:throw L.$kN.Unavailable(m.message);default:throw new L.$kN(m.message,m.name)}}addFileSystemProvider(m,o,i){return this.b.set(m,{impl:o,extUri:i?.isCaseSensitive?C.$Ig:C.$Kg,isReadonly:!!i?.isReadonly}),(0,E.$Rc)(()=>this.b.delete(m))}getFileSystemProviderExtUri(m){return this.b.get(m)?.extUri??C.$Ig}};e.$gic=k,e.$gic=k=S=Ye([Ve(0,p.$lO),Ve(1,w.$Thc)],k),e.$hic=(0,R.$fi)("IExtHostConsumerFileSystem")}),define(Se[321],De([1,0,6,7]),function(fe,e,l,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kjc=void 0;class L{constructor(R){this.a=new Map,this.b=new Map,this.c=R.getProxy(l.$6L.MainThreadIssueReporter)}async $getIssueReporterUri(R,p){if(this.a.size===0)throw new Error("No issue request handlers registered");const w=this.a.get(R);if(!w)throw new Error("Issue request handler not found");const E=await w.handleIssueUrlRequest();if(!E)throw new Error("Issue request handler returned no result");return E}async $getIssueReporterData(R,p){if(this.b.size===0)throw new Error("No issue request handlers registered");const w=this.b.get(R);if(!w)throw new Error("Issue data provider not found");const E=await w.provideIssueData(p);if(!E)throw new Error("Issue data provider returned no result");return E}async $getIssueReporterTemplate(R,p){if(this.b.size===0)throw new Error("No issue request handlers registered");const w=this.b.get(R);if(!w)throw new Error("Issue data provider not found");const E=await w.provideIssueTemplate(p);if(!E)throw new Error("Issue template provider returned no result");return E}registerIssueUriRequestHandler(R,p){const w=R.identifier.value;return this.a.set(w,p),this.c.$registerIssueUriRequestHandler(w),new j.$8L(()=>{this.c.$unregisterIssueUriRequestHandler(w),this.a.delete(w)})}registerIssueDataProvider(R,p){const w=R.identifier.value;return this.b.set(w,p),this.c.$registerIssueDataProvider(w),new j.$8L(()=>{this.c.$unregisterIssueDataProvider(w),this.b.delete(w)})}}e.$kjc=L}),define(Se[93],De([1,0,5,27,12,68,2]),function(fe,e,l,j,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jic=e.$iic=void 0,e.$iic=(0,l.$fi)("IExtensionStoragePaths");let p=class{constructor(E,M,C){this.d=M,this.f=C,this.a=E.workspace??void 0,this.b=E.environment,this.whenReady=this.h().then(v=>this.c=v)}async g(E){return R.URI.joinPath(this.b.workspaceStorageHome,E)}async h(){if(!this.a)return Promise.resolve(void 0);const E=this.a.id,M=await this.g(E);try{return await this.f.value.stat(M),this.d.trace("[ExtHostStorage] storage dir already exists",M),M}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",M),await this.f.value.createDirectory(M),await this.f.value.writeFile(R.URI.joinPath(M,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),M}catch(C){this.d.error("[ExtHostStorage]",C);return}}workspaceValue(E){if(this.c)return R.URI.joinPath(this.c,E.identifier.value)}globalValue(E){return R.URI.joinPath(this.b.globalStorageHome,E.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$jic=p,e.$jic=p=Ye([Ve(0,j.$BO),Ve(1,L.$zj),Ve(2,A.$hic)],p)}),define(Se[322],De([1,0,7,20,4]),function(fe,e,l,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Njc=void 0;let A=class{constructor(p){this.a=new l.$uN(l.ColorThemeKind.Dark),this.b=new L.$5d}get activeColorTheme(){return this.a}$onColorThemeChange(p){let w;switch(p){case"light":w=l.ColorThemeKind.Light;break;case"hcDark":w=l.ColorThemeKind.HighContrast;break;case"hcLight":w=l.ColorThemeKind.HighContrastLight;break;default:w=l.ColorThemeKind.Dark}this.a=new l.$uN(w),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Njc=A,e.$Njc=A=Ye([Ve(0,j.$lO)],A)}),define(Se[69],De([1,0,22,4,3,226,5,12,88,6,27,20,7]),function(fe,e,l,j,L,A,R,p,w,E,M,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AAb=e.$zAb=e.TunnelDtoConverter=void 0;class S extends w.$Yv{}var k;(function(m){function o(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,privacy:n.privacy??(n.public?w.TunnelPrivacyId.Public:w.TunnelPrivacyId.Private),protocol:n.protocol}}m.fromApiTunnel=o;function i(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.privacy!==w.TunnelPrivacyId.ConstantPrivate&&n.privacy!==w.TunnelPrivacyId.ConstantPrivate,privacy:n.privacy,protocol:n.protocol}}m.fromServiceTunnel=i})(k||(e.TunnelDtoConverter=k={})),e.$zAb=(0,R.$fi)("IExtHostTunnelService");let u=class extends L.$Tc{constructor(o,i,n){super(),this.s=n,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new j.$5d,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=o.getProxy(E.$6L.MainThreadTunnelService)}async openTunnel(o,i){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${o.identifier.value} called openTunnel API for ${i.remoteAddress.host}:${i.remoteAddress.port}.`);const n=await this.a.$openTunnel(i,o.displayName);if(n){const s=new S(n.remoteAddress,n.localAddress,()=>this.a.$closeTunnel(n.remoteAddress));return this.B(s),s}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(o,i){o.portRange===void 0&&o.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const n=this.u();return this.r.set(n,{selector:o,provider:i}),this.a.$registerPortsAttributesProvider(o,n),new v.$8L(()=>{this.r.delete(n),this.a.$unregisterPortsAttributesProvider(n)})}async $providePortAttributes(o,i,n,s,c){const t=[];for(const h of o){const r=this.r.get(h);if(!r)return[];t.push(...await Promise.all(i.map(async a=>{let d;try{d=await r.provider.providePortAttributes({port:a,pid:n,commandLine:s},c)}catch{d=await r.provider.providePortAttributes(a,n,s,c)}return{providedAttributes:d,port:a}})))}const f=t.filter(h=>!!h.providedAttributes);return f.length>0?f.map(h=>({autoForwardAction:h.providedAttributes.autoForwardAction,port:h.port})):[]}async $registerCandidateFinder(o){}registerTunnelProvider(o,i){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(s,c)=>await o.provideTunnel(s,c,l.CancellationToken.None)??void 0;const n=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,privacyOptions:i.tunnelFeatures?.privacyOptions,protocol:i.tunnelFeatures.protocol===void 0?!0:i.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(n),Promise.resolve((0,L.$Rc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(o,i){if(o){o.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(o.candidatePortSource),o.showCandidatePort&&(this.f=o.showCandidatePort,this.a.$setCandidateFilter());const n=o.tunnelFactory??(i?this.w(i):void 0);if(n){this.b=n;let s=o.tunnelFeatures?.privacyOptions??[];o.tunnelFeatures?.public&&s.length===0&&(s=[{id:"private",label:A.localize(0,null),themeIcon:"lock"},{id:"public",label:A.localize(1,null),themeIcon:"eye"}]);const c=o.tunnelFeatures?{elevation:!!o.tunnelFeatures?.elevation,public:!!o.tunnelFeatures?.public,privacyOptions:s,protocol:!0}:void 0;this.a.$setTunnelProvider(c)}}else this.b=void 0;return(0,L.$Rc)(()=>{this.b=void 0})}w(o){}async $closeTunnel(o,i){if(this.g.has(o.host)){const n=this.g.get(o.host);n.has(o.port)&&(i&&n.get(o.port).disposeListener.dispose(),await n.get(o.port).tunnel.dispose(),n.delete(o.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(o,i){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const n=this.b(o,i);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),n!==void 0){const s=await n;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),s===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(o.remoteAddress.host)||this.g.set(o.remoteAddress.host,new Map);const c=this.B(s.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(s.remoteAddress))));return this.g.get(o.remoteAddress.host).set(o.remoteAddress.port,{tunnel:s,disposeListener:c}),k.fromApiTunnel(s)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(n){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),n instanceof Error)return n.message}}async $applyCandidateFilter(o){const i=await Promise.all(o.map(s=>this.f(s.host,s.port,s.detail??""))),n=o.filter((s,c)=>i[c]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${o.map(s=>s.port).join(", ")} to ${n.map(s=>s.port).join(", ")}`),n}};e.$AAb=u,e.$AAb=u=Ye([Ve(0,C.$lO),Ve(1,M.$BO),Ve(2,p.$zj)],u)}),define(Se[16],De([1,0,19,21,170,73,79,28,164,56,101,24,23,18,2,29,82,138,144,142,119,66,89,296,26,7]),function(fe,e,l,j,L,A,R,p,w,E,M,C,v,S,k,u,m,o,i,n,s,c,t,f,h,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatAgentRequest=e.ChatResponseProgress=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$kO=e.$jO=e.MarkdownString=e.$iO=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0;var a;(function(Re){function Te(ee){const{selectionStartLineNumber:Me,selectionStartColumn:qe,positionLineNumber:_e,positionColumn:Je}=ee,ct=new r.$9L(Me-1,qe-1),vt=new r.$9L(_e-1,Je-1);return new r.$$L(ct,vt)}Re.to=Te;function Ee(ee){const{anchor:Me,active:qe}=ee;return{selectionStartLineNumber:Me.line+1,selectionStartColumn:Me.character+1,positionLineNumber:qe.line+1,positionColumn:qe.character+1}}Re.from=Ee})(a||(e.Selection=a={}));var d;(function(Re){function Te(ee){if(!ee)return;const{start:Me,end:qe}=ee;return{startLineNumber:Me.line+1,startColumn:Me.character+1,endLineNumber:qe.line+1,endColumn:qe.character+1}}Re.from=Te;function Ee(ee){if(!ee)return;const{startLineNumber:Me,startColumn:qe,endLineNumber:_e,endColumn:Je}=ee;return new r.$0L(Me-1,qe-1,_e-1,Je-1)}Re.to=Ee})(d||(e.Range=d={}));var $;(function(Re){function Te(ee){return{uri:ee.uri,range:d.from(ee.range)}}Re.from=Te;function Ee(ee){return new r.$hM(k.URI.revive(ee.uri),d.to(ee.range))}Re.to=Ee})($||(e.Location=$={}));var D;(function(Re){function Te(Ee){switch(Ee){case 1:return r.StandardTokenType.Comment;case 0:return r.StandardTokenType.Other;case 3:return r.StandardTokenType.RegEx;case 2:return r.StandardTokenType.String}}Re.to=Te})(D||(e.TokenType=D={}));var b;(function(Re){function Te(ee){return new r.$9L(ee.lineNumber-1,ee.column-1)}Re.to=Te;function Ee(ee){return{lineNumber:ee.line+1,column:ee.character+1}}Re.from=Ee})(b||(e.Position=b={}));var g;(function(Re){function Te(Me,qe,_e){return(0,l.$Hb)((0,l.$3b)(Me).map(Je=>Ee(Je,qe,_e)))}Re.from=Te;function Ee(Me,qe,_e){if(typeof Me=="string")return{$serialized:!0,language:Me,isBuiltin:_e?.isBuiltin};if(Me)return{$serialized:!0,language:Me.language,scheme:ee(Me.scheme,qe),pattern:oe.from(Me.pattern)??void 0,exclusive:Me.exclusive,notebookType:Me.notebookType,isBuiltin:_e?.isBuiltin}}function ee(Me,qe){return qe&&typeof Me=="string"?qe.transformOutgoingScheme(Me):Me}})(g||(e.DocumentSelector=g={}));var y;(function(Re){function Te(ee){switch(ee){case r.DiagnosticTag.Unnecessary:return 1;case r.DiagnosticTag.Deprecated:return 2}}Re.from=Te;function Ee(ee){switch(ee){case 1:return r.DiagnosticTag.Unnecessary;case 2:return r.DiagnosticTag.Deprecated;default:return}}Re.to=Ee})(y||(e.DiagnosticTag=y={}));var P;(function(Re){function Te(ee){let Me;return ee.code&&((0,S.$Sf)(ee.code)||(0,S.$Wf)(ee.code)?Me=String(ee.code):Me={value:String(ee.code.value),target:ee.code.target}),{...d.from(ee.range),message:ee.message,source:ee.source,code:Me,severity:U.from(ee.severity),relatedInformation:ee.relatedInformation&&ee.relatedInformation.map(N.from),tags:Array.isArray(ee.tags)?(0,l.$Hb)(ee.tags.map(y.from)):void 0}}Re.from=Te;function Ee(ee){const Me=new r.$jM(d.to(ee),ee.message,U.to(ee.severity));return Me.source=ee.source,Me.code=(0,S.$Sf)(ee.code)?ee.code:ee.code?.value,Me.relatedInformation=ee.relatedInformation&&ee.relatedInformation.map(N.to),Me.tags=ee.tags&&(0,l.$Hb)(ee.tags.map(y.to)),Me}Re.to=Ee})(P||(e.Diagnostic=P={}));var N;(function(Re){function Te(ee){return{...d.from(ee.location.range),message:ee.message,resource:ee.location.uri}}Re.from=Te;function Ee(ee){return new r.$iM(new r.$hM(ee.resource,d.to(ee)),ee.message)}Re.to=Ee})(N||(e.DiagnosticRelatedInformation=N={}));var U;(function(Re){function Te(ee){switch(ee){case r.DiagnosticSeverity.Error:return o.MarkerSeverity.Error;case r.DiagnosticSeverity.Warning:return o.MarkerSeverity.Warning;case r.DiagnosticSeverity.Information:return o.MarkerSeverity.Info;case r.DiagnosticSeverity.Hint:return o.MarkerSeverity.Hint}return o.MarkerSeverity.Error}Re.from=Te;function Ee(ee){switch(ee){case o.MarkerSeverity.Info:return r.DiagnosticSeverity.Information;case o.MarkerSeverity.Warning:return r.DiagnosticSeverity.Warning;case o.MarkerSeverity.Error:return r.DiagnosticSeverity.Error;case o.MarkerSeverity.Hint:return r.DiagnosticSeverity.Hint;default:return r.DiagnosticSeverity.Error}}Re.to=Ee})(U||(e.DiagnosticSeverity=U={}));var z;(function(Re){function Te(ee){return typeof ee=="number"&&ee>=r.ViewColumn.One?ee-1:ee===r.ViewColumn.Beside?f.$tD:f.$sD}Re.from=Te;function Ee(ee){if(typeof ee=="number"&&ee>=0)return ee+1;throw new Error("invalid 'EditorGroupColumn'")}Re.to=Ee})(z||(e.ViewColumn=z={}));function F(Re){return typeof Re.range<"u"}function I(Re){return Re.length===0?!0:!!F(Re[0])}e.$iO=I;var O;(function(Re){function Te(Je){return Je.map(Re.from)}Re.fromMany=Te;function Ee(Je){return Je&&typeof Je=="object"&&typeof Je.language=="string"&&typeof Je.value=="string"}function ee(Je){let ct;if(Ee(Je)){const{language:Mt,value:St}=Je;ct={value:"```"+Mt+`
`+St+"\n```\n"}}else r.$wM.isMarkdownString(Je)?ct={value:Je.value,isTrusted:Je.isTrusted,supportThemeIcons:Je.supportThemeIcons,supportHtml:Je.supportHtml,baseUri:Je.baseUri}:typeof Je=="string"?ct={value:Je}:ct={value:""};const vt=Object.create(null);ct.uris=vt;const Nt=Mt=>{try{let St=k.URI.parse(Mt,!0);St=St.with({query:Me(St.query,vt)}),vt[Mt]=St}catch{}return""},xt=new w.marked.Renderer;return xt.link=Nt,xt.image=Mt=>typeof Mt=="string"?Nt(R.$Ek(Mt).href):"",(0,w.marked)(ct.value,{renderer:xt}),ct}Re.from=ee;function Me(Je,ct){if(!Je)return Je;let vt;try{vt=(0,E.$Nh)(Je)}catch{}if(!vt)return Je;let Nt=!1;return vt=(0,C.$Mn)(vt,xt=>{if(k.URI.isUri(xt)){const Mt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ct[Mt]=xt,Nt=!0,Mt}else return}),Nt?JSON.stringify(vt):Je}function qe(Je){const ct=new r.$wM(Je.value,Je.supportThemeIcons);return ct.isTrusted=Je.isTrusted,ct.supportHtml=Je.supportHtml,ct.baseUri=Je.baseUri?k.URI.from(Je.baseUri):void 0,ct}Re.to=qe;function _e(Je){if(Je)return typeof Je=="string"?Je:Re.from(Je)}Re.fromStrict=_e})(O||(e.MarkdownString=O={}));function T(Re){return I(Re)?Re.map(Te=>({range:d.from(Te.range),hoverMessage:Array.isArray(Te.hoverMessage)?O.fromMany(Te.hoverMessage):Te.hoverMessage?O.from(Te.hoverMessage):void 0,renderOptions:Te.renderOptions})):Re.map(Te=>({range:d.from(Te)}))}e.$jO=T;function G(Re){return typeof Re>"u"?Re:typeof Re=="string"?k.URI.file(Re):Re}e.$kO=G;var te;(function(Re){function Te(Ee){return typeof Ee>"u"?Ee:{contentText:Ee.contentText,contentIconPath:Ee.contentIconPath?G(Ee.contentIconPath):void 0,border:Ee.border,borderColor:Ee.borderColor,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,color:Ee.color,backgroundColor:Ee.backgroundColor,margin:Ee.margin,width:Ee.width,height:Ee.height}}Re.from=Te})(te||(e.ThemableDecorationAttachmentRenderOptions=te={}));var x;(function(Re){function Te(Ee){return typeof Ee>"u"?Ee:{backgroundColor:Ee.backgroundColor,outline:Ee.outline,outlineColor:Ee.outlineColor,outlineStyle:Ee.outlineStyle,outlineWidth:Ee.outlineWidth,border:Ee.border,borderColor:Ee.borderColor,borderRadius:Ee.borderRadius,borderSpacing:Ee.borderSpacing,borderStyle:Ee.borderStyle,borderWidth:Ee.borderWidth,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,cursor:Ee.cursor,color:Ee.color,opacity:Ee.opacity,letterSpacing:Ee.letterSpacing,gutterIconPath:Ee.gutterIconPath?G(Ee.gutterIconPath):void 0,gutterIconSize:Ee.gutterIconSize,overviewRulerColor:Ee.overviewRulerColor,before:Ee.before?te.from(Ee.before):void 0,after:Ee.after?te.from(Ee.after):void 0}}Re.from=Te})(x||(e.ThemableDecorationRenderOptions=x={}));var X;(function(Re){function Te(Ee){if(typeof Ee>"u")return Ee;switch(Ee){case r.DecorationRangeBehavior.OpenOpen:return 0;case r.DecorationRangeBehavior.ClosedClosed:return 1;case r.DecorationRangeBehavior.OpenClosed:return 2;case r.DecorationRangeBehavior.ClosedOpen:return 3}}Re.from=Te})(X||(e.DecorationRangeBehavior=X={}));var Q;(function(Re){function Te(Ee){return{isWholeLine:Ee.isWholeLine,rangeBehavior:Ee.rangeBehavior?X.from(Ee.rangeBehavior):void 0,overviewRulerLane:Ee.overviewRulerLane,light:Ee.light?x.from(Ee.light):void 0,dark:Ee.dark?x.from(Ee.dark):void 0,backgroundColor:Ee.backgroundColor,outline:Ee.outline,outlineColor:Ee.outlineColor,outlineStyle:Ee.outlineStyle,outlineWidth:Ee.outlineWidth,border:Ee.border,borderColor:Ee.borderColor,borderRadius:Ee.borderRadius,borderSpacing:Ee.borderSpacing,borderStyle:Ee.borderStyle,borderWidth:Ee.borderWidth,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,cursor:Ee.cursor,color:Ee.color,opacity:Ee.opacity,letterSpacing:Ee.letterSpacing,gutterIconPath:Ee.gutterIconPath?G(Ee.gutterIconPath):void 0,gutterIconSize:Ee.gutterIconSize,overviewRulerColor:Ee.overviewRulerColor,before:Ee.before?te.from(Ee.before):void 0,after:Ee.after?te.from(Ee.after):void 0}}Re.from=Te})(Q||(e.DecorationRenderOptions=Q={}));var ae;(function(Re){function Te(ee){return{text:ee.newText,eol:ee.newEol&&Ie.from(ee.newEol),range:d.from(ee.range)}}Re.from=Te;function Ee(ee){const Me=new r.$cM(d.to(ee.range),ee.text);return Me.newEol=typeof ee.eol>"u"?void 0:Ie.to(ee.eol),Me}Re.to=Ee})(ae||(e.TextEdit=ae={}));var _;(function(Re){function Te(ee,Me){const qe={edits:[]};if(ee instanceof r.$fM){const _e=new p.$Bc;for(const Je of ee._allEntries())Je._type===1&&k.URI.isUri(Je.to)&&Je.from===void 0&&_e.add(Je.to);for(const Je of ee._allEntries())if(Je._type===1){let ct;Je.options?.contents&&(ArrayBuffer.isView(Je.options.contents)?ct={type:"base64",value:(0,j.$Me)(j.$se.wrap(Je.options.contents))}:ct={type:"dataTransferItem",id:Je.options.contents._itemId}),qe.edits.push({oldResource:Je.from,newResource:Je.to,options:{...Je.options,contents:ct},metadata:Je.metadata})}else Je._type===2?qe.edits.push({resource:Je.uri,textEdit:ae.from(Je.edit),versionId:_e.has(Je.uri)?void 0:Me?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===6?qe.edits.push({resource:Je.uri,textEdit:{range:d.from(Je.range),text:Je.edit.value,insertAsSnippet:!0},versionId:_e.has(Je.uri)?void 0:Me?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===3?qe.edits.push({metadata:Je.metadata,resource:Je.uri,cellEdit:Je.edit,notebookMetadata:Je.notebookMetadata,notebookVersionId:Me?.getNotebookDocumentVersion(Je.uri)}):Je._type===5&&qe.edits.push({metadata:Je.metadata,resource:Je.uri,notebookVersionId:Me?.getNotebookDocumentVersion(Je.uri),cellEdit:{editType:1,index:Je.index,count:Je.count,cells:Je.cells.map(Pt.from)}})}return qe}Re.from=Te;function Ee(ee){const Me=new r.$fM,qe=new p.$Ac;for(const _e of ee.edits)if(_e.textEdit){const Je=_e,ct=k.URI.revive(Je.resource),vt=d.to(Je.textEdit.range),Nt=Je.textEdit.text,xt=Je.textEdit.insertAsSnippet;let Mt;xt?Mt=r.$eM.replace(vt,new r.$gM(Nt)):Mt=r.$cM.replace(vt,Nt);const St=qe.get(ct);St?St.push(Mt):qe.set(ct,[Mt])}else Me.renameFile(k.URI.revive(_e.oldResource),k.URI.revive(_e.newResource),_e.options);for(const[_e,Je]of qe)Me.set(_e,Je);return Me}Re.to=Ee})(_||(e.WorkspaceEdit=_={}));var ge;(function(Re){const Te=Object.create(null);Te[r.SymbolKind.File]=0,Te[r.SymbolKind.Module]=1,Te[r.SymbolKind.Namespace]=2,Te[r.SymbolKind.Package]=3,Te[r.SymbolKind.Class]=4,Te[r.SymbolKind.Method]=5,Te[r.SymbolKind.Property]=6,Te[r.SymbolKind.Field]=7,Te[r.SymbolKind.Constructor]=8,Te[r.SymbolKind.Enum]=9,Te[r.SymbolKind.Interface]=10,Te[r.SymbolKind.Function]=11,Te[r.SymbolKind.Variable]=12,Te[r.SymbolKind.Constant]=13,Te[r.SymbolKind.String]=14,Te[r.SymbolKind.Number]=15,Te[r.SymbolKind.Boolean]=16,Te[r.SymbolKind.Array]=17,Te[r.SymbolKind.Object]=18,Te[r.SymbolKind.Key]=19,Te[r.SymbolKind.Null]=20,Te[r.SymbolKind.EnumMember]=21,Te[r.SymbolKind.Struct]=22,Te[r.SymbolKind.Event]=23,Te[r.SymbolKind.Operator]=24,Te[r.SymbolKind.TypeParameter]=25;function Ee(Me){return typeof Te[Me]=="number"?Te[Me]:6}Re.from=Ee;function ee(Me){for(const qe in Te)if(Te[qe]===Me)return Number(qe);return r.SymbolKind.Property}Re.to=ee})(ge||(e.SymbolKind=ge={}));var se;(function(Re){function Te(ee){switch(ee){case r.SymbolTag.Deprecated:return 1}}Re.from=Te;function Ee(ee){switch(ee){case 1:return r.SymbolTag.Deprecated}}Re.to=Ee})(se||(e.SymbolTag=se={}));var re;(function(Re){function Te(ee){return{name:ee.name,kind:ge.from(ee.kind),tags:ee.tags&&ee.tags.map(se.from),containerName:ee.containerName,location:ue.from(ee.location)}}Re.from=Te;function Ee(ee){const Me=new r.$nM(ee.name,ge.to(ee.kind),ee.containerName,ue.to(ee.location));return Me.tags=ee.tags&&ee.tags.map(se.to),Me}Re.to=Ee})(re||(e.WorkspaceSymbol=re={}));var B;(function(Re){function Te(ee){const Me={name:ee.name||"!!MISSING: name!!",detail:ee.detail,range:d.from(ee.range),selectionRange:d.from(ee.selectionRange),kind:ge.from(ee.kind),tags:ee.tags?.map(se.from)??[]};return ee.children&&(Me.children=ee.children.map(Te)),Me}Re.from=Te;function Ee(ee){const Me=new r.$oM(ee.name,ee.detail,ge.to(ee.kind),d.to(ee.range),d.to(ee.selectionRange));return(0,l.$Lb)(ee.tags)&&(Me.tags=ee.tags.map(se.to)),ee.children&&(Me.children=ee.children.map(Ee)),Me}Re.to=Ee})(B||(e.DocumentSymbol=B={}));var ie;(function(Re){function Te(ee){const Me=new r.$sM(ge.to(ee.kind),ee.name,ee.detail||"",k.URI.revive(ee.uri),d.to(ee.range),d.to(ee.selectionRange));return Me._sessionId=ee._sessionId,Me._itemId=ee._itemId,Me}Re.to=Te;function Ee(ee,Me,qe){if(Me=Me??ee._sessionId,qe=qe??ee._itemId,Me===void 0||qe===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:qe,name:ee.name,detail:ee.detail,kind:ge.from(ee.kind),uri:ee.uri,range:d.from(ee.range),selectionRange:d.from(ee.selectionRange),tags:ee.tags?.map(se.from)}}Re.from=Ee})(ie||(e.CallHierarchyItem=ie={}));var ye;(function(Re){function Te(Ee){return new r.$tM(ie.to(Ee.from),Ee.fromRanges.map(ee=>d.to(ee)))}Re.to=Te})(ye||(e.CallHierarchyIncomingCall=ye={}));var le;(function(Re){function Te(Ee){return new r.$uM(ie.to(Ee.to),Ee.fromRanges.map(ee=>d.to(ee)))}Re.to=Te})(le||(e.CallHierarchyOutgoingCall=le={}));var ue;(function(Re){function Te(ee){return{range:ee.range&&d.from(ee.range),uri:ee.uri}}Re.from=Te;function Ee(ee){return new r.$hM(k.URI.revive(ee.uri),d.to(ee.range))}Re.to=Ee})(ue||(e.location=ue={}));var ce;(function(Re){function Te(ee){const Me=ee,qe=ee;return{originSelectionRange:Me.originSelectionRange?d.from(Me.originSelectionRange):void 0,uri:Me.targetUri?Me.targetUri:qe.uri,range:d.from(Me.targetRange?Me.targetRange:qe.range),targetSelectionRange:Me.targetSelectionRange?d.from(Me.targetSelectionRange):void 0}}Re.from=Te;function Ee(ee){return{targetUri:k.URI.revive(ee.uri),targetRange:d.to(ee.range),targetSelectionRange:ee.targetSelectionRange?d.to(ee.targetSelectionRange):void 0,originSelectionRange:ee.originSelectionRange?d.to(ee.originSelectionRange):void 0}}Re.to=Ee})(ce||(e.DefinitionLink=ce={}));var de;(function(Re){function Te(ee){return{range:d.from(ee.range),contents:O.fromMany(ee.contents)}}Re.from=Te;function Ee(ee){return new r.$kM(ee.contents.map(O.to),d.to(ee.range))}Re.to=Ee})(de||(e.Hover=de={}));var H;(function(Re){function Te(ee){return{range:d.from(ee.range),expression:ee.expression}}Re.from=Te;function Ee(ee){return new r.$eN(d.to(ee.range),ee.expression)}Re.to=Ee})(H||(e.EvaluatableExpression=H={}));var Z;(function(Re){function Te(ee){if(ee instanceof r.$fN)return{type:"text",range:d.from(ee.range),text:ee.text};if(ee instanceof r.$gN)return{type:"variable",range:d.from(ee.range),variableName:ee.variableName,caseSensitiveLookup:ee.caseSensitiveLookup};if(ee instanceof r.$hN)return{type:"expression",range:d.from(ee.range),expression:ee.expression};throw new Error("Unknown 'InlineValue' type")}Re.from=Te;function Ee(ee){switch(ee.type){case"text":return{range:d.to(ee.range),text:ee.text};case"variable":return{range:d.to(ee.range),variableName:ee.variableName,caseSensitiveLookup:ee.caseSensitiveLookup};case"expression":return{range:d.to(ee.range),expression:ee.expression}}}Re.to=Ee})(Z||(e.InlineValue=Z={}));var he;(function(Re){function Te(ee){return{frameId:ee.frameId,stoppedLocation:d.from(ee.stoppedLocation)}}Re.from=Te;function Ee(ee){return new r.$iN(ee.frameId,d.to(ee.stoppedLocation))}Re.to=Ee})(he||(e.InlineValueContext=he={}));var be;(function(Re){function Te(ee){return{range:d.from(ee.range),kind:ee.kind}}Re.from=Te;function Ee(ee){return new r.$lM(d.to(ee.range),ee.kind)}Re.to=Ee})(be||(e.DocumentHighlight=be={}));var Pe;(function(Re){function Te(ee){return{uri:ee.uri,highlights:ee.highlights.map(be.from)}}Re.from=Te;function Ee(ee){return new r.$mM(k.URI.revive(ee.uri),ee.highlights.map(be.to))}Re.to=Ee})(Pe||(e.MultiDocumentHighlight=Pe={}));var pe;(function(Re){function Te(Ee){switch(Ee){case 1:return r.CompletionTriggerKind.TriggerCharacter;case 2:return r.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return r.CompletionTriggerKind.Invoke}}Re.to=Te})(pe||(e.CompletionTriggerKind=pe={}));var Ae;(function(Re){function Te(Ee){return{triggerKind:pe.to(Ee.triggerKind),triggerCharacter:Ee.triggerCharacter}}Re.to=Te})(Ae||(e.CompletionContext=Ae={}));var Oe;(function(Re){function Te(ee){switch(ee){case r.CompletionItemTag.Deprecated:return 1}}Re.from=Te;function Ee(ee){switch(ee){case 1:return r.CompletionItemTag.Deprecated}}Re.to=Ee})(Oe||(e.CompletionItemTag=Oe={}));var ze;(function(Re){const Te=new Map([[r.CompletionItemKind.Method,0],[r.CompletionItemKind.Function,1],[r.CompletionItemKind.Constructor,2],[r.CompletionItemKind.Field,3],[r.CompletionItemKind.Variable,4],[r.CompletionItemKind.Class,5],[r.CompletionItemKind.Interface,7],[r.CompletionItemKind.Struct,6],[r.CompletionItemKind.Module,8],[r.CompletionItemKind.Property,9],[r.CompletionItemKind.Unit,12],[r.CompletionItemKind.Value,13],[r.CompletionItemKind.Constant,14],[r.CompletionItemKind.Enum,15],[r.CompletionItemKind.EnumMember,16],[r.CompletionItemKind.Keyword,17],[r.CompletionItemKind.Snippet,27],[r.CompletionItemKind.Text,18],[r.CompletionItemKind.Color,19],[r.CompletionItemKind.File,20],[r.CompletionItemKind.Reference,21],[r.CompletionItemKind.Folder,23],[r.CompletionItemKind.Event,10],[r.CompletionItemKind.Operator,11],[r.CompletionItemKind.TypeParameter,24],[r.CompletionItemKind.Issue,26],[r.CompletionItemKind.User,25]]);function Ee(qe){return Te.get(qe)??9}Re.from=Ee;const ee=new Map([[0,r.CompletionItemKind.Method],[1,r.CompletionItemKind.Function],[2,r.CompletionItemKind.Constructor],[3,r.CompletionItemKind.Field],[4,r.CompletionItemKind.Variable],[5,r.CompletionItemKind.Class],[7,r.CompletionItemKind.Interface],[6,r.CompletionItemKind.Struct],[8,r.CompletionItemKind.Module],[9,r.CompletionItemKind.Property],[12,r.CompletionItemKind.Unit],[13,r.CompletionItemKind.Value],[14,r.CompletionItemKind.Constant],[15,r.CompletionItemKind.Enum],[16,r.CompletionItemKind.EnumMember],[17,r.CompletionItemKind.Keyword],[27,r.CompletionItemKind.Snippet],[18,r.CompletionItemKind.Text],[19,r.CompletionItemKind.Color],[20,r.CompletionItemKind.File],[21,r.CompletionItemKind.Reference],[23,r.CompletionItemKind.Folder],[10,r.CompletionItemKind.Event],[11,r.CompletionItemKind.Operator],[24,r.CompletionItemKind.TypeParameter],[25,r.CompletionItemKind.User],[26,r.CompletionItemKind.Issue]]);function Me(qe){return ee.get(qe)??r.CompletionItemKind.Property}Re.to=Me})(ze||(e.CompletionItemKind=ze={}));var q;(function(Re){function Te(Ee,ee){const Me=new r.$CM(Ee.label);return Me.insertText=Ee.insertText,Me.kind=ze.to(Ee.kind),Me.tags=Ee.tags?.map(Oe.to),Me.detail=Ee.detail,Me.documentation=R.$yk(Ee.documentation)?O.to(Ee.documentation):Ee.documentation,Me.sortText=Ee.sortText,Me.filterText=Ee.filterText,Me.preselect=Ee.preselect,Me.commitCharacters=Ee.commitCharacters,u.$9s.isIRange(Ee.range)?Me.range=d.to(Ee.range):typeof Ee.range=="object"&&(Me.range={inserting:d.to(Ee.range.insert),replacing:d.to(Ee.range.replace)}),Me.keepWhitespace=typeof Ee.insertTextRules>"u"?!1:!!(Ee.insertTextRules&1),typeof Ee.insertTextRules<"u"&&Ee.insertTextRules&4?Me.insertText=new r.$gM(Ee.insertText):(Me.insertText=Ee.insertText,Me.textEdit=Me.range instanceof r.$0L?new r.$cM(Me.range,Me.insertText):void 0),Ee.additionalTextEdits&&Ee.additionalTextEdits.length>0&&(Me.additionalTextEdits=Ee.additionalTextEdits.map(qe=>ae.to(qe))),Me.command=ee&&Ee.command?ee.fromInternal(Ee.command):void 0,Me}Re.to=Te})(q||(e.CompletionItem=q={}));var W;(function(Re){function Te(ee){if(typeof ee.label!="string"&&!Array.isArray(ee.label))throw new TypeError("Invalid label");return{label:ee.label,documentation:O.fromStrict(ee.documentation)}}Re.from=Te;function Ee(ee){return{label:ee.label,documentation:R.$yk(ee.documentation)?O.to(ee.documentation):ee.documentation}}Re.to=Ee})(W||(e.ParameterInformation=W={}));var Y;(function(Re){function Te(ee){return{label:ee.label,documentation:O.fromStrict(ee.documentation),parameters:Array.isArray(ee.parameters)?ee.parameters.map(W.from):[],activeParameter:ee.activeParameter}}Re.from=Te;function Ee(ee){return{label:ee.label,documentation:R.$yk(ee.documentation)?O.to(ee.documentation):ee.documentation,parameters:Array.isArray(ee.parameters)?ee.parameters.map(W.to):[],activeParameter:ee.activeParameter}}Re.to=Ee})(Y||(e.SignatureInformation=Y={}));var J;(function(Re){function Te(ee){return{activeSignature:ee.activeSignature,activeParameter:ee.activeParameter,signatures:Array.isArray(ee.signatures)?ee.signatures.map(Y.from):[]}}Re.from=Te;function Ee(ee){return{activeSignature:ee.activeSignature,activeParameter:ee.activeParameter,signatures:Array.isArray(ee.signatures)?ee.signatures.map(Y.to):[]}}Re.to=Ee})(J||(e.SignatureHelp=J={}));var $e;(function(Re){function Te(Ee,ee){const Me=new r.$BM(b.to(ee.position),typeof ee.label=="string"?ee.label:ee.label.map(ve.to.bind(void 0,Ee)),ee.kind&&Fe.to(ee.kind));return Me.textEdits=ee.textEdits&&ee.textEdits.map(ae.to),Me.tooltip=R.$yk(ee.tooltip)?O.to(ee.tooltip):ee.tooltip,Me.paddingLeft=ee.paddingLeft,Me.paddingRight=ee.paddingRight,Me}Re.to=Te})($e||(e.InlayHint=$e={}));var ve;(function(Re){function Te(Ee,ee){const Me=new r.$AM(ee.label);return Me.tooltip=R.$yk(ee.tooltip)?O.to(ee.tooltip):ee.tooltip,m.Command.is(ee.command)&&(Me.command=Ee.fromInternal(ee.command)),ee.location&&(Me.location=ue.to(ee.location)),Me}Re.to=Te})(ve||(e.InlayHintLabelPart=ve={}));var Fe;(function(Re){function Te(ee){return ee}Re.from=Te;function Ee(ee){return ee}Re.to=Ee})(Fe||(e.InlayHintKind=Fe={}));var He;(function(Re){function Te(ee){return{range:d.from(ee.range),url:ee.target,tooltip:ee.tooltip}}Re.from=Te;function Ee(ee){let Me;if(ee.url)try{Me=typeof ee.url=="string"?k.URI.parse(ee.url,!0):k.URI.revive(ee.url)}catch{}return new r.$HM(d.to(ee.range),Me)}Re.to=Ee})(He||(e.DocumentLink=He={}));var Qe;(function(Re){function Te(ee){const Me=new r.$KM(ee.label);return ee.textEdit&&(Me.textEdit=ae.to(ee.textEdit)),ee.additionalTextEdits&&(Me.additionalTextEdits=ee.additionalTextEdits.map(qe=>ae.to(qe))),Me}Re.to=Te;function Ee(ee){return{label:ee.label,textEdit:ee.textEdit?ae.from(ee.textEdit):void 0,additionalTextEdits:ee.additionalTextEdits?ee.additionalTextEdits.map(Me=>ae.from(Me)):void 0}}Re.from=Ee})(Qe||(e.ColorPresentation=Qe={}));var tt;(function(Re){function Te(ee){return new r.$IM(ee[0],ee[1],ee[2],ee[3])}Re.to=Te;function Ee(ee){return[ee.red,ee.green,ee.blue,ee.alpha]}Re.from=Ee})(tt||(e.Color=tt={}));var st;(function(Re){function Te(ee){return{range:d.from(ee.range)}}Re.from=Te;function Ee(ee){return new r.$rM(d.to(ee.range))}Re.to=Ee})(st||(e.SelectionRange=st={}));var ut;(function(Re){function Te(Ee){switch(Ee){case 2:return r.TextDocumentSaveReason.AfterDelay;case 1:return r.TextDocumentSaveReason.Manual;case 3:case 4:return r.TextDocumentSaveReason.FocusOut}}Re.to=Te})(ut||(e.TextDocumentSaveReason=ut={}));var rt;(function(Re){function Te(ee){switch(ee){case r.TextEditorLineNumbersStyle.Off:return 0;case r.TextEditorLineNumbersStyle.Relative:return 2;case r.TextEditorLineNumbersStyle.Interval:return 3;case r.TextEditorLineNumbersStyle.On:default:return 1}}Re.from=Te;function Ee(ee){switch(ee){case 0:return r.TextEditorLineNumbersStyle.Off;case 2:return r.TextEditorLineNumbersStyle.Relative;case 3:return r.TextEditorLineNumbersStyle.Interval;case 1:default:return r.TextEditorLineNumbersStyle.On}}Re.to=Ee})(rt||(e.TextEditorLineNumbersStyle=rt={}));var Ie;(function(Re){function Te(ee){if(ee===r.EndOfLine.CRLF)return 1;if(ee===r.EndOfLine.LF)return 0}Re.from=Te;function Ee(ee){if(ee===1)return r.EndOfLine.CRLF;if(ee===0)return r.EndOfLine.LF}Re.to=Ee})(Ie||(e.EndOfLine=Ie={}));var Be;(function(Re){function Te(Ee){if(typeof Ee=="object")return Ee.viewId;switch(Ee){case r.ProgressLocation.SourceControl:return 3;case r.ProgressLocation.Window:return 10;case r.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Re.from=Te})(Be||(e.ProgressLocation=Be={}));var Le;(function(Re){function Te(ee){const Me={start:ee.start+1,end:ee.end+1};return ee.kind&&(Me.kind=Ke.from(ee.kind)),Me}Re.from=Te;function Ee(ee){const Me={start:ee.start-1,end:ee.end-1};return ee.kind&&(Me.kind=Ke.to(ee.kind)),Me}Re.to=Ee})(Le||(e.FoldingRange=Le={}));var Ke;(function(Re){function Te(ee){if(ee)switch(ee){case r.FoldingRangeKind.Comment:return m.$Zt.Comment;case r.FoldingRangeKind.Imports:return m.$Zt.Imports;case r.FoldingRangeKind.Region:return m.$Zt.Region}}Re.from=Te;function Ee(ee){if(ee)switch(ee.value){case m.$Zt.Comment.value:return r.FoldingRangeKind.Comment;case m.$Zt.Imports.value:return r.FoldingRangeKind.Imports;case m.$Zt.Region.value:return r.FoldingRangeKind.Region}}Re.to=Ee})(Ke||(e.FoldingRangeKind=Ke={}));var ne;(function(Re){function Te(Ee){if(Ee)return{pinned:typeof Ee.preview=="boolean"?!Ee.preview:void 0,inactive:Ee.background,preserveFocus:Ee.preserveFocus,selection:typeof Ee.selection=="object"?d.from(Ee.selection):void 0,override:typeof Ee.override=="boolean"?n.$VE.id:void 0}}Re.from=Te})(ne||(e.TextEditorOpenOptions=ne={}));var oe;(function(Re){function Te(qe){return qe instanceof r.$5M?qe.toJSON():typeof qe=="string"?qe:Ee(qe)||ee(qe)?new r.$5M(qe.baseUri??qe.base,qe.pattern).toJSON():qe}Re.from=Te;function Ee(qe){const _e=qe;return _e?k.URI.isUri(_e.baseUri)&&typeof _e.pattern=="string":!1}function ee(qe){const _e=qe;return _e?typeof _e.base=="string"&&typeof _e.pattern=="string":!1}function Me(qe){return typeof qe=="string"?qe:new r.$5M(k.URI.revive(qe.baseUri),qe.pattern)}Re.to=Me})(oe||(e.GlobPattern=oe={}));var Ce;(function(Re){function Te(Ee){if(Ee){if(Array.isArray(Ee))return Ee.map(Te);if(typeof Ee=="string")return Ee;{const ee=Ee;return{language:ee.language,scheme:ee.scheme,pattern:oe.from(ee.pattern),exclusive:ee.exclusive,notebookType:ee.notebookType}}}else return}Re.from=Te})(Ce||(e.LanguageSelector=Ce={}));var Ge;(function(Re){function Te(ee){return!!ee&&typeof ee=="object"&&"documents"in ee&&Array.isArray(ee.documents)&&ee.documents.every(Me=>Array.isArray(Me)&&Me.every(qe=>qe&&typeof qe=="object"&&"uri"in qe&&k.URI.isUri(qe.uri)&&"version"in qe&&typeof qe.version=="number"&&"ranges"in qe&&Array.isArray(qe.ranges)&&qe.ranges.every(_e=>_e instanceof r.$0L)))}Re.is=Te;function Ee(ee){return{documents:ee.documents.map(Me=>Me.map(qe=>({uri:k.URI.from(qe.uri),version:qe.version,ranges:qe.ranges.map(_e=>d.from(_e))})))}}Re.from=Ee})(Ge||(e.MappedEditsContext=Ge={}));var xe;(function(Re){function Te(ee){return{start:ee.start,end:ee.end}}Re.from=Te;function Ee(ee){return new r.$vN(ee.start,ee.end)}Re.to=Ee})(xe||(e.NotebookRange=xe={}));var nt;(function(Re){function Te(ee){return{timing:typeof ee.runStartTime=="number"&&typeof ee.runEndTime=="number"?{startTime:ee.runStartTime,endTime:ee.runEndTime}:void 0,executionOrder:ee.executionOrder,success:ee.lastRunSuccess}}Re.to=Te;function Ee(ee){return{lastRunSuccess:ee.success,runStartTime:ee.timing?.startTime,runEndTime:ee.timing?.endTime,executionOrder:ee.executionOrder}}Re.from=Ee})(nt||(e.NotebookCellExecutionSummary=nt={}));var Ne;(function(Re){function Te(Ee){if(Ee===s.NotebookCellExecutionState.Unconfirmed)return r.NotebookCellExecutionState.Pending;if(Ee===s.NotebookCellExecutionState.Pending)return;if(Ee===s.NotebookCellExecutionState.Executing)return r.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Ee}`)}Re.to=Te})(Ne||(e.NotebookCellExecutionState=Ne={}));var $t;(function(Re){function Te(ee){switch(ee){case r.NotebookCellKind.Markup:return s.CellKind.Markup;case r.NotebookCellKind.Code:default:return s.CellKind.Code}}Re.from=Te;function Ee(ee){switch(ee){case s.CellKind.Markup:return r.NotebookCellKind.Markup;case s.CellKind.Code:default:return r.NotebookCellKind.Code}}Re.to=Ee})($t||(e.NotebookCellKind=$t={}));var Dt;(function(Re){function Te(ee){const Me={metadata:ee.metadata??Object.create(null),cells:[]};for(const qe of ee.cells)r.$wN.validate(qe),Me.cells.push(Pt.from(qe));return Me}Re.from=Te;function Ee(ee){const Me=new r.$xN(ee.cells.map(Pt.to));return(0,S.$6f)(ee.metadata)||(Me.metadata=ee.metadata),Me}Re.to=Ee})(Dt||(e.NotebookData=Dt={}));var Pt;(function(Re){function Te(ee){return{cellKind:$t.from(ee.kind),language:ee.languageId,mime:ee.mime,source:ee.value,metadata:ee.metadata,internalMetadata:nt.from(ee.executionSummary??{}),outputs:ee.outputs?ee.outputs.map(Xt.from):[]}}Re.from=Te;function Ee(ee){return new r.$wN($t.to(ee.cellKind),ee.source,ee.language,ee.mime,ee.outputs?ee.outputs.map(Xt.to):void 0,ee.metadata,ee.internalMetadata?nt.to(ee.internalMetadata):void 0)}Re.to=Ee})(Pt||(e.NotebookCellData=Pt={}));var Tt;(function(Re){function Te(ee){return{mime:ee.mime,valueBytes:j.$se.wrap(ee.data)}}Re.from=Te;function Ee(ee){return new r.$yN(ee.valueBytes.buffer,ee.mime)}Re.to=Ee})(Tt||(e.NotebookCellOutputItem=Tt={}));var Xt;(function(Re){function Te(ee){return{outputId:ee.id,items:ee.items.map(Tt.from),metadata:ee.metadata}}Re.from=Te;function Ee(ee){const Me=ee.items.map(Tt.to);return new r.$zN(Me,ee.outputId,ee.metadata)}Re.to=Ee})(Xt||(e.NotebookCellOutput=Xt={}));var Ct;(function(Re){function Te(Me){return ee(Me)?{include:oe.from(Me.include)??void 0,exclude:oe.from(Me.exclude)??void 0}:oe.from(Me)??void 0}Re.from=Te;function Ee(Me){return ee(Me)?{include:oe.to(Me.include),exclude:oe.to(Me.exclude)}:oe.to(Me)}Re.to=Ee;function ee(Me){const qe=Me;return qe?!(0,S.$2f)(qe.include)&&!(0,S.$2f)(qe.exclude):!1}})(Ct||(e.NotebookExclusiveDocumentPattern=Ct={}));var Jt;(function(Re){function Te(Ee,ee,Me){const qe=typeof Ee.command=="string"?{title:"",command:Ee.command}:Ee.command;return{alignment:Ee.alignment===r.NotebookCellStatusBarAlignment.Left?1:2,command:ee.toInternal(qe,Me),text:Ee.text,tooltip:Ee.tooltip,accessibilityInformation:Ee.accessibilityInformation,priority:Ee.priority}}Re.from=Te})(Jt||(e.NotebookStatusBarItem=Jt={}));var Yt;(function(Re){function Te(Ee,ee,Me){const qe=typeof Ee.command=="string"?{title:"",command:Ee.command}:Ee.command;return{command:ee.toInternal(qe,Me),label:Ee.label,description:Ee.description,detail:Ee.detail,documentation:Ee.documentation}}Re.from=Te})(Yt||(e.NotebookKernelSourceAction=Yt={}));var _t;(function(Re){function Te(Ee){return{transientOutputs:Ee?.transientOutputs??!1,transientCellMetadata:Ee?.transientCellMetadata??{},transientDocumentMetadata:Ee?.transientDocumentMetadata??{},cellContentMetadata:Ee?.cellContentMetadata??{}}}Re.from=Te})(_t||(e.NotebookDocumentContentOptions=_t={}));var ni;(function(Re){function Te(ee){return{uri:ee.uri,provides:ee.provides}}Re.from=Te;function Ee(ee){return new r.$BN(k.URI.revive(ee.uri),ee.provides)}Re.to=Ee})(ni||(e.NotebookRendererScript=ni={}));var et;(function(Re){function Te(ee){return{message:O.fromStrict(ee.message)||"",type:0,expected:ee.expectedOutput,actual:ee.actualOutput,contextValue:ee.contextValue,location:ee.location&&{range:d.from(ee.location.range),uri:ee.location.uri}}}Re.from=Te;function Ee(ee){const Me=new r.$HN(typeof ee.message=="string"?ee.message:O.to(ee.message));return Me.actualOutput=ee.actual,Me.expectedOutput=ee.expected,Me.contextValue=ee.contextValue,Me.location=ee.location?ue.to(ee.location):void 0,Me}Re.to=Ee})(et||(e.TestMessage=et={}));var Bt;(function(Re){Re.namespace=t.$1K,Re.denamespace=t.$2K})(Bt||(e.TestTag=Bt={}));var ei;(function(Re){function Te(ee){const Me=(0,i.$hO)(ee).controllerId;return{extId:c.$WK.fromExtHostTestItem(ee,Me).toString(),label:ee.label,uri:k.URI.revive(ee.uri),busy:ee.busy,tags:ee.tags.map(qe=>Bt.namespace(Me,qe.id)),range:u.$9s.lift(d.from(ee.range)),description:ee.description||null,sortText:ee.sortText||null,error:ee.error&&O.fromStrict(ee.error)||null}}Re.from=Te;function Ee(ee){return{parent:void 0,error:void 0,id:c.$WK.fromString(ee.extId).localId,label:ee.label,uri:k.URI.revive(ee.uri),tags:(ee.tags||[]).map(Me=>{const{tagId:qe}=Bt.denamespace(Me);return new r.$IN(qe)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:d.to(ee.range||void 0),canResolveChildren:!1,busy:ee.busy,description:ee.description||void 0,sortText:ee.sortText||void 0}}Re.toPlain=Ee})(ei||(e.TestItem=ei={})),function(Re){function Te(ee){return{id:ee.id}}Re.from=Te;function Ee(ee){return new r.$IN(ee.id)}Re.to=Ee}(Bt||(e.TestTag=Bt={}));var dt;(function(Re){const Te=(ee,Me)=>{const qe=[];for(const[Je,ct]of Me)c.$WK.compare(ct.item.extId,Je)===2&&(Me.delete(Je),qe.push(ct));const _e={...ei.toPlain(ee.item),parent:void 0,taskStates:ee.tasks.map(Je=>({state:Je.state,duration:Je.duration,messages:Je.messages.filter(ct=>ct.type===0).map(et.to)})),children:qe.map(Je=>Te(Je,Me))};for(const Je of _e.children)Je.parent=_e;return _e};function Ee(ee){const Me=[],qe=new Map;for(const _e of ee.items){qe.set(_e.item.extId,_e);const Je=c.$WK.root(_e.item.extId);ee.request.targets.some(ct=>ct.controllerId===Je&&ct.testIds.includes(_e.item.extId))&&Me.push(_e)}return{completedAt:ee.completedAt,results:Me.map(_e=>Te(_e,qe))}}Re.to=Ee})(dt||(e.TestResults=dt={}));var wt;(function(Re){function Te(qe){return{covered:qe.covered,total:qe.total}}function Ee(qe){return"line"in qe?b.from(qe):d.from(qe)}function ee(qe){return"branches"in qe?{count:qe.executed,location:Ee(qe.location),type:1,branches:qe.branches.length?qe.branches.map(_e=>({count:_e.executed,location:_e.location&&Ee(_e.location),label:_e.label})):void 0}:{type:0,name:qe.name,count:qe.executed,location:Ee(qe.location)}}Re.fromDetailed=ee;function Me(qe){return{uri:qe.uri,statement:Te(qe.statementCoverage),branch:qe.branchCoverage&&Te(qe.branchCoverage),declaration:qe.declarationCoverage&&Te(qe.declarationCoverage),details:qe.detailedCoverage?.map(ee)}}Re.fromFile=Me})(wt||(e.TestCoverage=wt={}));var ti;(function(Re){function Te(Ee){switch(Ee){case 1:return r.CodeActionTriggerKind.Invoke;case 2:return r.CodeActionTriggerKind.Automatic}}Re.to=Te})(ti||(e.CodeActionTriggerKind=ti={}));var Ht;(function(Re){function Te(ee){const Me=new r.$ON(ge.to(ee.kind),ee.name,ee.detail||"",k.URI.revive(ee.uri),d.to(ee.range),d.to(ee.selectionRange));return Me._sessionId=ee._sessionId,Me._itemId=ee._itemId,Me}Re.to=Te;function Ee(ee,Me,qe){if(Me=Me??ee._sessionId,qe=qe??ee._itemId,Me===void 0||qe===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:qe,kind:ge.from(ee.kind),name:ee.name,detail:ee.detail??"",uri:ee.uri,range:d.from(ee.range),selectionRange:d.from(ee.selectionRange),tags:ee.tags?.map(se.from)}}Re.from=Ee})(Ht||(e.TypeHierarchyItem=Ht={}));var Ut;(function(Re){function Te(Ee){if(Ee)return{value:Ee.value,tooltip:Ee.tooltip}}Re.from=Te})(Ut||(e.ViewBadge=Ut={}));var ft;(function(Re){function Te(qe,_e,Je){const ct=_e.fileData;return ct?new r.$XM(new r.$YM(ct.name,k.URI.revive(ct.uri),ct.id,(0,A.$db)(()=>Je(ct.id)))):qe===M.$ts.uriList&&_e.uriListData?new r.$WM(Me(_e.uriListData)):new r.$WM(_e.asString)}Re.to=Te;async function Ee(qe,_e){const Je=await _e.asString();if(qe===M.$ts.uriList)return{asString:Je,fileData:void 0,uriListData:ee(Je)};const ct=_e.asFile();return{asString:Je,fileData:ct?{name:ct.name,uri:ct.uri,id:ct._itemId??ct.id}:void 0}}Re.from=Ee;function ee(qe){return L.$Ft.split(qe).map(_e=>{if(_e.startsWith("#"))return _e;try{return k.URI.parse(_e)}catch{}return _e})}function Me(qe){return L.$Ft.create(qe.map(_e=>typeof _e=="string"?_e:k.URI.revive(_e)))}})(ft||(e.DataTransferItem=ft={}));var Rt;(function(Re){function Te(ee,Me){const qe=ee.items.map(([_e,Je])=>[_e,ft.to(_e,Je,Me)]);return new r.$ZM(qe)}Re.toDataTransfer=Te;async function Ee(ee){const Me={items:[]},qe=[];for(const[_e,Je]of ee)qe.push((async()=>{Me.items.push([_e,await ft.from(_e,Je)])})());return await Promise.all(qe),Me}Re.from=Ee})(Rt||(e.DataTransfer=Rt={}));var ii;(function(Re){function Te(ee,Me){return{kind:"reply",agentId:ee.participant??Me?.agentId??"",subCommand:ee.command??Me?.command,message:ee.prompt,title:ee.label}}Re.from=Te;function Ee(ee){return{prompt:ee.message,label:ee.title,participant:ee.agentId,command:ee.subCommand}}Re.to=Ee})(ii||(e.ChatFollowup=ii={}));var Zt;(function(Re){function Te(Ee){return"commandId"in Ee?{kind:"command",title:Ee.title??"",commandId:Ee.commandId??"",when:Ee.when??"",args:Ee.args}:{kind:"reply",message:Ee.message,title:Ee.title,tooltip:Ee.tooltip}}Re.from=Te})(Zt||(e.ChatInlineFollowup=Zt={}));var Xe;(function(Re){function Te(ee){switch(ee.role){case 0:return new r.$9N(ee.content);case 1:return new r.$0N(ee.content);case 2:return new r.$$N(ee.content)}}Re.to=Te;function Ee(ee){if(ee instanceof r.$9N)return{role:0,content:ee.content};if(ee instanceof r.$0N)return{role:1,content:ee.content};if(ee instanceof r.$$N)return{role:2,content:ee.content};throw new Error("Invalid LanguageModelMessage")}Re.from=Ee})(Xe||(e.LanguageModelMessage=Xe={}));var Lt;(function(Re){function Te(Me){const qe={};for(const _e of Object.keys(Me))qe[_e]=Me[_e].map(Re.to);return qe}Re.objectTo=Te;function Ee(Me){return{level:Wt.to(Me.level),kind:Me.kind,value:(0,k.$vc)(Me.value)?k.URI.revive(Me.value):Me.value,description:Me.description}}Re.to=Ee;function ee(Me){return{level:Wt.from(Me.level),kind:Me.kind,value:Me.value,description:Me.description}}Re.from=ee})(Lt||(e.ChatVariable=Lt={}));var Wt;(function(Re){function Te(ee){switch(ee){case"short":return r.ChatVariableLevel.Short;case"medium":return r.ChatVariableLevel.Medium;case"full":default:return r.ChatVariableLevel.Full}}Re.to=Te;function Ee(ee){switch(ee){case r.ChatVariableLevel.Short:return"short";case r.ChatVariableLevel.Medium:return"medium";case r.ChatVariableLevel.Full:default:return"full"}}Re.from=Ee})(Wt||(e.ChatVariableLevel=Wt={}));var ri;(function(Re){function Te(Ee){switch(Ee){case 1:return r.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return r.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return r.InteractiveEditorResponseFeedbackKind.Undone;case 3:return r.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return r.InteractiveEditorResponseFeedbackKind.Bug}}Re.to=Te})(ri||(e.InteractiveEditorResponseFeedbackKind=ri={}));var gt;(function(Re){function Te(ee){return{kind:"markdownContent",content:O.from(ee.value)}}Re.to=Te;function Ee(ee){return new r.$1N(O.to(ee.content))}Re.from=Ee})(gt||(e.ChatResponseMarkdownPart=gt={}));var Ot;(function(Re){function Te(ee){const{value:Me,baseUri:qe}=ee;function _e(Je,ct){return Je.map(vt=>{const Nt=k.URI.joinPath(ct,vt.name);return{label:vt.name,uri:Nt,children:vt.children&&_e(vt.children,Nt)}})}return{kind:"treeData",treeData:{label:(0,v.$Pg)(qe),uri:qe,children:_e(Me,qe)}}}Re.to=Te;function Ee(ee){const Me=(0,E.$Oh)(ee.treeData);function qe(ct){return ct.map(vt=>({name:vt.label,children:vt.children&&qe(vt.children)}))}const _e=Me.uri,Je=Me.children?qe(Me.children):[];return new r.$2N(Je,_e)}Re.from=Ee})(Ot||(e.ChatResponseFilesPart=Ot={}));var At;(function(Re){function Te(ee){return{kind:"inlineReference",name:ee.title,inlineReference:k.URI.isUri(ee.value)?ee.value:$.from(ee.value)}}Re.to=Te;function Ee(ee){const Me=(0,E.$Oh)(ee);return new r.$3N(k.URI.isUri(Me.inlineReference)?Me.inlineReference:$.to(Me.inlineReference),ee.name)}Re.from=Ee})(At||(e.ChatResponseAnchorPart=At={}));var qt;(function(Re){function Te(ee){return{kind:"progressMessage",content:O.from(ee.value)}}Re.to=Te;function Ee(ee){return new r.$4N(ee.content.value)}Re.from=Ee})(qt||(e.ChatResponseProgressPart=qt={}));var si;(function(Re){function Te(ee,Me,qe){return{kind:"command",command:Me.toInternal(ee.value,qe)??{command:ee.value.command,title:ee.value.title}}}Re.to=Te;function Ee(ee,Me){return new r.$5N(Me.fromInternal(ee.command)??{command:ee.command.id,title:ee.command.title})}Re.from=Ee})(si||(e.ChatResponseCommandButtonPart=si={}));var zt;(function(Re){function Te(ee){return{kind:"reference",reference:k.URI.isUri(ee.value)?ee.value:$.from(ee.value)}}Re.to=Te;function Ee(ee){const Me=(0,E.$Oh)(ee);return new r.$6N(k.URI.isUri(Me.reference)?Me.reference:$.to(Me.reference))}Re.from=Ee})(zt||(e.ChatResponseReferencePart=zt={}));var Kt;(function(Re){function Te(Me){return Me instanceof r.$1N?gt.to(Me):Me instanceof r.$3N?At.to(Me):Me instanceof r.$6N?zt.to(Me):Me instanceof r.$4N?qt.to(Me):Me instanceof r.$2N?Ot.to(Me):{kind:"content",content:""}}Re.to=Te;function Ee(Me,qe){switch(Me.kind){case"reference":return zt.from(Me);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return ee(Me,qe)}}Re.from=Ee;function ee(Me,qe){switch(Me.kind){case"markdownContent":return gt.from(Me);case"inlineReference":return At.from(Me);case"progressMessage":return;case"treeData":return Ot.from(Me);case"command":return si.from(Me,qe)}}Re.fromContent=ee})(Kt||(e.ChatResponsePart=Kt={}));var kt;(function(Re){function Te(Me,qe){return"markdownContent"in qe?((0,h.$YF)(Me,"chatParticipantAdditions"),{content:O.from(qe.markdownContent),kind:"markdownContent"}):"content"in qe?"vulnerabilities"in qe&&qe.vulnerabilities?((0,h.$YF)(Me,"chatParticipantAdditions"),{content:qe.content,vulnerabilities:qe.vulnerabilities,kind:"vulnerability"}):typeof qe.content=="string"?{content:qe.content,kind:"content"}:((0,h.$YF)(Me,"chatParticipantAdditions"),{content:O.from(qe.content),kind:"markdownContent"}):"documents"in qe?{documents:qe.documents.map(_e=>({uri:_e.uri,version:_e.version,ranges:_e.ranges.map(Je=>d.from(Je))})),kind:"usedContext"}:"reference"in qe?{reference:"uri"in qe.reference?{uri:qe.reference.uri,range:d.from(qe.reference.range)}:qe.reference,kind:"reference"}:"inlineReference"in qe?{inlineReference:"uri"in qe.inlineReference?{uri:qe.inlineReference.uri,range:d.from(qe.inlineReference.range)}:qe.inlineReference,name:qe.title,kind:"inlineReference"}:"participant"in qe?((0,h.$YF)(Me,"chatParticipantAdditions"),{agentName:qe.participant,command:qe.command,kind:"agentDetection"}):"message"in qe?{content:O.from(qe.message),kind:"progressMessage"}:void 0}Re.from=Te;function Ee(Me){switch(Me.kind){case"markdownContent":case"inlineReference":case"treeData":return Re.to(Me);case"content":return{content:Me.content};case"usedContext":return{documents:Me.documents.map(qe=>({uri:k.URI.revive(qe.uri),version:qe.version,ranges:qe.ranges.map(_e=>d.to(_e))}))};case"reference":return{reference:(0,k.$vc)(Me.reference)?k.URI.revive(Me.reference):$.to(Me.reference)};case"agentDetection":return;case"progressMessage":return{message:Me.content.value};case"vulnerability":return{content:Me.content,vulnerabilities:Me.vulnerabilities};default:return}}Re.to=Ee;function ee(Me,qe){switch(Me.kind){case"markdownContent":return{content:Me.content.value};case"inlineReference":return{inlineReference:(0,k.$vc)(Me.inlineReference)?k.URI.revive(Me.inlineReference):$.to(Me.inlineReference),title:Me.name};case"command":return{command:qe.fromInternal(Me.command)??{command:Me.command.id,title:Me.command.title}};default:return}}Re.toProgressContent=ee})(kt||(e.ChatResponseProgress=kt={}));var jt;(function(Re){function Te(Ee){return{prompt:Ee.message,command:Ee.command,variables:Ee.variables.variables.map(Qt.to)}}Re.to=Te})(jt||(e.ChatAgentRequest=jt={}));var Qt;(function(Re){function Te(Ee){return{name:Ee.name,range:[Ee.range.start,Ee.range.endExclusive],values:Ee.values.map(Lt.to)}}Re.to=Te})(Qt||(e.ChatAgentResolvedVariable=Qt={}));var Vt;(function(Re){function Te(Ee){return{label:Ee.label,values:Ee.values.map(Lt.from),insertText:Ee.insertText,detail:Ee.detail,documentation:Ee.documentation}}Re.from=Te})(Vt||(e.ChatAgentCompletionItem=Vt={}));var yt;(function(Re){function Te(Ee){return{errorDetails:Ee.errorDetails,metadata:Ee.metadata}}Re.to=Te})(yt||(e.ChatAgentResult=yt={}));var It;(function(Re){function Te(Ee,ee,Me){if(ee.action.kind==="vote")return;const qe=yt.to(Ee);return ee.action.kind==="command"?{action:{kind:"command",commandButton:kt.toProgressContent(ee.action.commandButton,Me)},result:qe}:ee.action.kind==="followUp"?{action:{kind:"followUp",followup:ii.to(ee.action.followup)},result:qe}:{action:ee.action,result:qe}}Re.to=Te})(It||(e.ChatAgentUserActionEvent=It={}));var Et;(function(Re){function Te(Ee,ee,Me){return"terminalCommand"in Ee?{terminalCommand:Ee.terminalCommand,shouldExecute:Ee.shouldExecute}:"uri"in Ee?{uri:Ee.uri}:ee.toInternal(Ee,Me)}Re.from=Te})(Et||(e.TerminalQuickFix=Et={}));var ci;(function(Re){function Te(Ee,ee){return{id:ee,label:Ee.label,description:Ee.description,canEdit:Ee.canEdit,collapsibleState:Ee.collapsibleState||0,contextValue:Ee.contextValue}}Re.from=Te})(ci||(e.DebugTreeItem=ci={}))}),define(Se[323],De([1,0,6,20,16]),function(fe,e,l,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2hc=void 0;let A=class{constructor(p,w){this.a=p.getProxy(l.$6L.MainThreadBulkEdits),this.b={getTextDocumentVersion:E=>w.getDocument(E)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(p,w,E){const M=L.WorkspaceEdit.from(p,this.b);return this.a.$tryApplyWorkspaceEdit(M,void 0,E?.isRefactoring??!1)}};e.$2hc=A,e.$2hc=A=Ye([Ve(0,j.$lO)],A)}),define(Se[324],De([1,0,19,8,44,4,48,3,38,18,2,215,25,6,16,7,285,26]),function(fe,e,l,j,L,A,R,p,w,E,M,C,v,S,k,u,m,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4hc=void 0;class i{constructor(t,f,h,r,a,d){this.j=t,this.k=f,this.l=h,this.m=r,this.n=a,this.o=d,this.b=w.$1d.create(!1),this.d=!1}close(){this.d=!0}get timings(){return{firstProgress:this.g,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.i){let f=function(r){if(t.d){const a=new Error("Response stream has been closed");throw Error.captureStackTrace(a,r),a}};const t=this;this.b.reset();const h=r=>{typeof this.g>"u"&&"content"in r&&(this.g=this.b.elapsed()),this.l.$handleProgressChunk(this.k.requestId,r)};this.i={markdown(r){f(this.markdown);const a=new u.$1N(r),d=k.ChatResponseMarkdownPart.to(a);return h(d),this},filetree(r,a){f(this.filetree);const d=new u.$2N(r,a),$=k.ChatResponseFilesPart.to(d);return h($),this},anchor(r,a){f(this.anchor);const d=new u.$3N(r,a),$=k.ChatResponseAnchorPart.to(d);return h($),this},button(r){f(this.anchor);const a=new u.$5N(r),d=k.ChatResponseCommandButtonPart.to(a,t.n,t.o);return h(d),this},progress(r){f(this.progress);const a=new u.$4N(r),d=k.ChatResponseProgressPart.to(a);return h(d),this},reference(r){f(this.reference);const a=new u.$6N(r),d=k.ChatResponseReferencePart.to(a);return h(d),this},push(r){f(this.push);const a=k.ChatResponsePart.to(r);return h(a),this},report(r){if(f(this.report),"placeholder"in r&&"resolvedContent"in r)return;const a=k.ChatResponseProgress.from(t.j,r);if(!a){t.m.error("Unknown progress type: "+JSON.stringify(r));return}return h(a),this}}}return this.i}}class n{static{this.b=0}constructor(t,f,h){this.j=f,this.k=h,this.d=new Map,this.i=new p.$3c,this.g=t.getProxy(S.$6L.MainThreadChatAgents2)}createChatAgent(t,f,h){const r=n.b++,a=new s(t,f,this.g,r,h);return this.d.set(r,a),this.g.$registerAgent(r,t.identifier,f,{}),a.apiAgent}async $invokeAgent(t,f,h,r){const a=this.d.get(t);if(!a)throw new Error(`[CHAT](${t}) CANNOT invoke agent because the agent is not registered`);let d=this.i.get(f.sessionId);d||(d=new p.$Sc,this.i.set(f.sessionId,d));const $=new i(a.extension,f,this.g,this.j,this.k.converter,d);try{const D=await this.l(f.agentId,h),b=a.invoke(k.ChatAgentRequest.to(f),{history:D},$.apiObject,r);return await(0,j.$6g)(Promise.resolve(b).then(g=>{if(g?.metadata)try{JSON.stringify(g.metadata)}catch(y){const P=`result.metadata MUST be JSON.stringify-able. Got error: ${y.message}`;return this.j.error(`[${a.extension.identifier.value}] [@${a.id}] ${P}`,a.extension),{errorDetails:{message:P},timings:$.timings}}return{errorDetails:g?.errorDetails,timings:$.timings,metadata:g?.metadata}}),r)}catch(D){return this.j.error(D,a.extension),{errorDetails:{message:(0,C.localize)(0,null,(0,L.$3i)(D)),responseIsIncomplete:!0}}}finally{$.close()}}async l(t,f){const h=[];for(const r of f.history){const a=k.ChatAgentResult.to(r.result),d=t===r.request.agentId?a:{...a,metadata:void 0};h.push(new u.$7N(r.request.message,r.request.command,r.request.variables.variables.map(k.ChatAgentResolvedVariable.to),{extensionId:"",name:r.request.agentId}));const $=(0,l.$Hb)(r.response.map(D=>k.ChatResponsePart.fromContent(D,this.k.converter)));h.push(new u.$8N($,d,{extensionId:"",name:r.request.agentId},r.request.command))}return h}$releaseSession(t){this.i.deleteAndDispose(t)}async $provideSlashCommands(t,f,h){const r=this.d.get(t);if(!r)return[];const a=await this.l(r.id,f);try{return await r.provideSlashCommands({history:a},h)}catch(d){const $=(0,L.$3i)(d);return this.j.error(`[${r.extension.identifier.value}] [@${r.id}] Error while providing slash commands: ${$}`),[]}}async $provideFollowups(t,f,h,r){const a=this.d.get(f);if(!a)return Promise.resolve([]);const d=k.ChatAgentResult.to(h);return(await a.provideFollowups(d,r)).filter($=>{const D=!$.participant||R.Iterable.some(this.d.values(),b=>b.id===$.participant&&v.$zm.equals(b.extension.identifier,a.extension.identifier));return D||this.j.warn(`[@${a.id}] ChatFollowup refers to an invalid participant: ${$.participant}`),D}).map($=>k.ChatFollowup.from($,t))}$acceptFeedback(t,f,h,r){const a=this.d.get(t);if(!a)return;const d=k.ChatAgentResult.to(f);let $;switch(h){case m.InteractiveSessionVoteDirection.Down:$=u.ChatResultFeedbackKind.Unhelpful;break;case m.InteractiveSessionVoteDirection.Up:$=u.ChatResultFeedbackKind.Helpful;break}a.acceptFeedback(Object.freeze(r?{result:d,kind:$,reportIssue:r}:{result:d,kind:$}))}$acceptAction(t,f,h){const r=this.d.get(t);if(!r||h.action.kind==="vote")return;const a=k.ChatAgentUserActionEvent.to(f,h,this.k.converter);a&&r.acceptAction(Object.freeze(a))}async $invokeCompletionProvider(t,f,h){const r=this.d.get(t);return r?(await r.invokeCompletionProvider(f,h)).map(k.ChatAgentCompletionItem.from):[]}async $provideWelcomeMessage(t,f){const h=this.d.get(t);if(h)return await h.provideWelcomeMessage(f)}async $provideSampleQuestions(t,f){const h=this.d.get(t);if(h)return(await h.provideSampleQuestions(f)).map(r=>k.ChatFollowup.from(r,void 0))}}e.$4hc=n;class s{constructor(t,f,h,r,a){this.extension=t,this.id=f,this.y=h,this.z=r,this.A=a,this.q=new A.$5d,this.s=new A.$5d}acceptFeedback(t){this.q.fire(t)}acceptAction(t){this.s.fire(t)}async invokeCompletionProvider(t,f){return this.u?await this.u.provider.provideCompletionItems(t,f)??[]:[]}async provideSlashCommands(t,f){if(!this.b)return[];const h=await this.b.provideCommands(t,f);return h?h.map(r=>("isSticky2"in r&&(0,o.$YF)(this.extension,"chatParticipantAdditions"),{name:r.name,description:r.description??"",followupPlaceholder:r.isSticky2?.placeholder,isSticky:r.isSticky2?.isSticky??r.isSticky,sampleRequest:r.sampleRequest})):[]}async provideFollowups(t,f){if(!this.d)return[];const h=await this.d.provideFollowups(t,f);return h?h.filter(r=>!(r&&"commandId"in r)).filter(r=>!(r&&"message"in r)):[]}async provideWelcomeMessage(t){if(!this.w)return[];const f=await this.w.provideWelcomeMessage(t);return f?f.map(h=>typeof h=="string"?h:k.MarkdownString.from(h)):[]}async provideSampleQuestions(t){if(!this.w||!this.w.provideSampleQuestions)return[];const f=await this.w.provideSampleQuestions(t);return f||[]}get apiAgent(){let t=!1,f=!1;const h=()=>{t||f||(f=!0,queueMicrotask(()=>{this.y.$updateAgent(this.z,{description:this.g??"",fullName:this.i,icon:this.j?this.j instanceof M.URI?this.j:"light"in this.j?this.j.light:void 0:void 0,iconDark:this.j&&"dark"in this.j?this.j.dark:void 0,themeIcon:this.j instanceof u.$3M?this.j:void 0,hasSlashCommands:this.b!==void 0,hasFollowups:this.d!==void 0,isDefault:this.k,isSecondary:this.p,helpTextPrefix:!this.l||typeof this.l=="string"?this.l:k.MarkdownString.from(this.l),helpTextVariablesPrefix:!this.m||typeof this.m=="string"?this.m:k.MarkdownString.from(this.m),helpTextPostfix:!this.n||typeof this.n=="string"?this.n:k.MarkdownString.from(this.n),sampleRequest:this.o,supportIssueReporting:this.t,isSticky:this.x}),f=!1}))},r=this;return{get name(){return r.id},get description(){return r.g??""},set description(a){r.g=a,h()},get fullName(){return(0,o.$YF)(r.extension,"defaultChatParticipant"),r.i??r.extension.displayName??r.extension.name},set fullName(a){(0,o.$YF)(r.extension,"defaultChatParticipant"),r.i=a,h()},get iconPath(){return r.j},set iconPath(a){r.j=a,h()},get requestHandler(){return r.A},set requestHandler(a){(0,E.$3f)(typeof a=="function","Invalid request handler"),r.A=a},get commandProvider(){return r.b},set commandProvider(a){r.b=a,h()},get followupProvider(){return r.d},set followupProvider(a){r.d=a,h()},get isDefault(){return(0,o.$YF)(r.extension,"defaultChatParticipant"),r.k},set isDefault(a){(0,o.$YF)(r.extension,"defaultChatParticipant"),r.k=a,h()},get helpTextPrefix(){return(0,o.$YF)(r.extension,"defaultChatParticipant"),r.l},set helpTextPrefix(a){if((0,o.$YF)(r.extension,"defaultChatParticipant"),!r.k)throw new Error("helpTextPrefix is only available on the default chat agent");r.l=a,h()},get helpTextVariablesPrefix(){return(0,o.$YF)(r.extension,"defaultChatParticipant"),r.m},set helpTextVariablesPrefix(a){if((0,o.$YF)(r.extension,"defaultChatParticipant"),!r.k)throw new Error("helpTextVariablesPrefix is only available on the default chat agent");r.m=a,h()},get helpTextPostfix(){return(0,o.$YF)(r.extension,"defaultChatParticipant"),r.n},set helpTextPostfix(a){if((0,o.$YF)(r.extension,"defaultChatParticipant"),!r.k)throw new Error("helpTextPostfix is only available on the default chat agent");r.n=a,h()},get isSecondary(){return(0,o.$YF)(r.extension,"defaultChatParticipant"),r.p},set isSecondary(a){(0,o.$YF)(r.extension,"defaultChatParticipant"),r.p=a,h()},get sampleRequest(){return r.o},set sampleRequest(a){r.o=a,h()},get supportIssueReporting(){return(0,o.$YF)(r.extension,"chatParticipantAdditions"),r.t},set supportIssueReporting(a){(0,o.$YF)(r.extension,"chatParticipantAdditions"),r.t=a,h()},get onDidReceiveFeedback(){return r.q.event},set participantVariableProvider(a){if((0,o.$YF)(r.extension,"chatParticipantAdditions"),r.u=a,a){if(!a.triggerCharacters.length)throw new Error("triggerCharacters are required");r.y.$registerAgentCompletionsProvider(r.z,a.triggerCharacters)}else r.y.$unregisterAgentCompletionsProvider(r.z)},get participantVariableProvider(){return(0,o.$YF)(r.extension,"chatParticipantAdditions"),r.u},set welcomeMessageProvider(a){(0,o.$YF)(r.extension,"defaultChatParticipant"),r.w=a,h()},get welcomeMessageProvider(){return(0,o.$YF)(r.extension,"defaultChatParticipant"),r.w},onDidPerformAction:(0,o.$XF)(this.extension,"chatParticipantAdditions")?this.s.event:void 0,get isSticky(){return r.x},set isSticky(a){r.x=a,h()},dispose(){t=!0,r.b=void 0,r.d=void 0,r.q.dispose(),r.y.$unregisterAgent(r.z)}}}invoke(t,f,h,r){return this.A(t,f,h,r)}}}),define(Se[325],De([1,0,13,3,6,16,7,26]),function(fe,e,l,j,L,A,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7hc=void 0;class w{static{this.a=0}constructor(C){this.b=new Map,this.c=C.getProxy(L.$6L.MainThreadChatVariables)}async $resolveVariable(C,v,S,k){const u=this.b.get(C);if(u)try{if(u.resolver.resolve2){(0,p.$YF)(u.extension,"chatParticipantAdditions");const m=new E(v,this.c),o=await u.resolver.resolve2(u.data.name,{prompt:S},m.apiObject,k);if(o)return o.map(A.ChatVariable.from)}else{const m=await u.resolver.resolve(u.data.name,{prompt:S},k);if(m)return m.map(A.ChatVariable.from)}}catch(m){(0,l.$2)(m)}}registerVariableResolver(C,v,S,k){const u=w.a++;return this.b.set(u,{extension:C,data:{name:v,description:S},resolver:k}),this.c.$registerVariable(u,{name:v,description:S}),(0,j.$Rc)(()=>{this.b.delete(u),this.c.$unregisterVariable(u)})}}e.$7hc=w;class E{constructor(C,v){this.c=C,this.d=v,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let v=function(k){if(C.a){const u=new Error("Response stream has been closed");throw Error.captureStackTrace(u,k),u}};const C=this,S=k=>{this.d.$handleProgressChunk(this.c,k)};this.b={progress(k){v(this.progress);const u=new R.$4N(k),m=A.ChatResponseProgressPart.to(u);return S(m),this},reference(k){v(this.reference);const u=new R.$6N(k),m=A.ChatResponseReferencePart.to(u);return S(m),this},push(k){v(this.push);const u=A.ChatResponsePart.to(k);return S(u),this}}}return this.b}}}),define(Se[326],De([1,0,8,53,4,3,2,82,25,16,7,6,26]),function(fe,e,l,j,L,A,R,p,w,E,M,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$hc=void 0;function S(k,u,m){const o=k.getProxy(C.$6L.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new w.$Bm,u.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===6){const $=this.b.get(d.handle);return $?$.value:d}else if(d&&d.$mid===7){const $=this.b.get(d.commentControlHandle);if(!$)return d;const D=$.getCommentThread(d.commentThreadHandle);return D?D.value:d}else if(d&&(d.$mid===9||d.$mid===8)){const $=this.b.get(d.thread.commentControlHandle);if(!$)return d;const D=$.getCommentThread(d.thread.commentThreadHandle);return D?d.$mid===8?D.value:{thread:D.value,text:d.text}:d}else if(d&&d.$mid===10){const $=this.b.get(d.thread.commentControlHandle);if(!$)return d;const D=$.getCommentThread(d.thread.commentThreadHandle);if(!D)return d;const b=d.commentUniqueId,g=D.getCommentByUniqueId(b);return g||d}else if(d&&d.$mid===11){const $=this.b.get(d.thread.commentControlHandle);if(!$)return d;const D=$.getCommentThread(d.thread.commentThreadHandle);if(!D)return d;const b=d.text,g=d.commentUniqueId,y=D.getCommentByUniqueId(g);return y?(typeof y.body=="string"?y.body=b:y.body=new M.$wM(b),y):d}return d}})}createCommentController(d,$,D){const b=i.a++,g=new s(d,b,$,D);this.b.set(g.handle,g);const y=this.c.get(d.identifier)||[];return y.push(g),this.c.set(d.identifier,y),g.value}async $createCommentThreadTemplate(d,$,D){const b=this.b.get(d);b&&b.$createCommentThreadTemplate($,D)}async $setActiveComment(d,$){const D=this.b.get(d);D&&D.$setActiveComment($??void 0)}async $updateCommentThreadTemplate(d,$,D){const b=this.b.get(d);b&&b.$updateCommentThreadTemplate($,D)}$deleteCommentThread(d,$){this.b.get(d)?.$deleteCommentThread($)}async $provideCommentingRanges(d,$,D){const b=this.b.get(d);if(!b||!b.commentingRangeProvider)return Promise.resolve(void 0);const g=await m.ensureDocumentData(R.URI.revive($));return(0,l.$0g)(async()=>{const y=await b.commentingRangeProvider.provideCommentingRanges(g.document,D);let P;return Array.isArray(y)?P={ranges:y,fileComments:!1}:y?P={ranges:y.ranges||[],fileComments:y.fileComments||!1}:P=y??void 0,P}).then(y=>{let P;return y&&(P={ranges:y.ranges.map(N=>E.Range.from(N)),fileComments:y.fileComments}),P})}$toggleReaction(d,$,D,b,g){const y=this.b.get(d);return!y||!y.reactionHandler?Promise.resolve(void 0):(0,l.$0g)(()=>{const P=y.getCommentThread($);if(P){const N=P.getCommentByUniqueId(b.uniqueIdInThread);if(y!==void 0&&N&&y.reactionHandler)return y.reactionHandler(N,f(g))}return Promise.resolve(void 0)})}}class n{static{this.a=0}set threadId(d){this.n=d}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(d){(d===void 0!=(this.p===void 0)||!d||!this.p||!d.isEqual(this.p))&&(this.p=d,this.b.range=d,this.c.fire())}get range(){return this.p}set canReply(d){this.d!==d&&(this.d=d,this.b.canReply=d,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(d){this.e=d,this.b.label=d,this.c.fire()}get contextValue(){return this.f}set contextValue(d){this.f=d,this.b.contextValue=d,this.c.fire()}get comments(){return this.q}set comments(d){this.q=d,this.b.comments=d,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(d){this.g=d,this.b.collapsibleState=d,this.c.fire()}get state(){return this.h}set state(d){this.h=d,this.b.state=d,this.c.fire()}get isDisposed(){return this.j}constructor(d,$,D,b,g,y,P,N){this.m=$,this.n=D,this.o=b,this.p=g,this.q=y,this.extensionDescription=P,this.r=N,this.handle=n.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new L.$5d,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new A.$Uc,this.l.value=new A.$Sc,this.n===void 0&&(this.n=`${d}.${this.handle}`),o.$createCommentThread($,this.handle,this.n,this.o,E.Range.from(this.p),P.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=y,this.i.push({dispose:()=>{o.$deleteCommentThread($,this.handle)}});const U=this;this.value={get uri(){return U.uri},get range(){return U.range},set range(z){U.range=z},get comments(){return U.comments},set comments(z){U.comments=z},get collapsibleState(){return U.collapsibleState},set collapsibleState(z){U.collapsibleState=z},get canReply(){return U.canReply},set canReply(z){U.canReply=z},get contextValue(){return U.contextValue},set contextValue(z){U.contextValue=z},get label(){return U.label},set label(z){U.label=z},get state(){return U.state},set state(z){U.state=z},dispose:()=>{U.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new A.$Sc);const d=D=>Object.prototype.hasOwnProperty.call(this.b,D),$={};d("range")&&($.range=E.Range.from(this.p)),d("label")&&($.label=this.label),d("contextValue")&&($.contextValue=this.contextValue??null),d("comments")&&($.comments=this.q.map(D=>c(this,D,this.k,this.extensionDescription))),d("collapsibleState")&&($.collapseState=h(this.g)),d("canReply")&&($.canReply=this.canReply),d("state")&&($.state=r(this.h)),d("isTemplate")&&($.isTemplate=this.r),this.b={},o.$updateCommentThread(this.m,this.handle,this.n,this.o,$)}getCommentByUniqueId(d){for(const $ of this.k){const D=$[0],b=$[1];if(d===b)return D}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(d=>d.dispose())}}Ye([(0,j.$Kh)(100)],n.prototype,"eventuallyUpdateCommentThread",null);class s{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(d){this.b=d,d?.resourceHints&&(0,v.$YF)(this.h,"commentingRangeHint"),o.$updateCommentingRanges(this.handle,d?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(d){this.c=d,o.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!d})}get options(){return this.d}set options(d){this.d=d,o.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,v.$YF)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,v.$YF)(this.h,"activeComment"),this.f}constructor(d,$,D,b){this.h=d,this.i=$,this.j=D,this.k=b,this.a=new Map,o.$registerCommentController(this.handle,D,b,this.h.identifier.value);const g=this;this.value=Object.freeze({id:g.id,label:g.label,get options(){return g.options},set options(y){g.options=y},get commentingRangeProvider(){return g.commentingRangeProvider},set commentingRangeProvider(y){g.commentingRangeProvider=y},get reactionHandler(){return g.reactionHandler},set reactionHandler(y){g.reactionHandler=y},get activeCommentThread(){return g.activeCommentThread},createCommentThread(y,P,N){return g.createCommentThread(y,P,N).value},dispose:()=>{g.dispose()}}),this.g=[],this.g.push({dispose:()=>{o.$unregisterCommentController(this.handle)}})}createCommentThread(d,$,D){$===void 0&&(0,v.$YF)(this.h,"fileComments");const b=new n(this.id,this.handle,void 0,d,$,D,this.h,!1);return this.a.set(b.handle,b),b}$setActiveComment(d){if(!d){this.e=void 0,this.f=void 0;return}const $=this.a.get(d.commentThreadHandle);$&&(this.e=d.uniqueIdInThread?$.getCommentByUniqueId(d.uniqueIdInThread):void 0,this.f=$)}$createCommentThreadTemplate(d,$){const D=new n(this.id,this.handle,void 0,R.URI.revive(d),E.Range.to($),[],this.h,!0);return D.collapsibleState=p.CommentThreadCollapsibleState.Expanded,this.a.set(D.handle,D),D}$updateCommentThreadTemplate(d,$){const D=this.a.get(d);D&&(D.range=E.Range.to($))}$deleteCommentThread(d){this.a.get(d)?.dispose(),this.a.delete(d)}getCommentThread(d){return this.a.get(d)}dispose(){this.a.forEach(d=>{d.dispose()}),this.g.forEach(d=>d.dispose())}}function c(a,d,$,D){let b=$.get(d);return b||(b=++a.commentHandle,$.set(d,b)),d.state!==void 0&&(0,v.$YF)(D,"commentsDraftState"),d.reactions?.some(g=>g.reactors!==void 0)&&(0,v.$YF)(D,"commentReactor"),{mode:d.mode,contextValue:d.contextValue,uniqueIdInThread:b,body:typeof d.body=="string"?d.body:E.MarkdownString.from(d.body),userName:d.author.name,userIconPath:d.author.iconPath,label:d.label,commentReactions:d.reactions?d.reactions.map(g=>t(g)):void 0,state:d.state,timestamp:d.timestamp?.toJSON()}}function t(a){return{label:a.label,iconPath:a.iconPath?E.$kO(a.iconPath):void 0,count:a.count,hasReacted:a.authorHasReacted,reactors:a.reactors&&a.reactors.length>0&&typeof a.reactors[0]!="string"?a.reactors.map(d=>d.name):a.reactors}}function f(a){return{label:a.label||"",count:a.count||0,iconPath:a.iconPath?R.URI.revive(a.iconPath):"",authorHasReacted:a.hasReacted||!1,reactors:a.reactors?.map(d=>({name:d}))}}function h(a){if(a!==void 0)switch(a){case M.CommentThreadCollapsibleState.Expanded:return p.CommentThreadCollapsibleState.Expanded;case M.CommentThreadCollapsibleState.Collapsed:return p.CommentThreadCollapsibleState.Collapsed}return p.CommentThreadCollapsibleState.Collapsed}function r(a){if(a!==void 0)switch(a){case M.CommentThreadState.Unresolved:return p.CommentThreadState.Unresolved;case M.CommentThreadState.Resolved:return p.CommentThreadState.Resolved}return p.CommentThreadState.Unresolved}return new i}e.$$hc=S}),define(Se[327],De([1,0,22,54,3,15,23,2,16,92,111,6,7]),function(fe,e,l,j,L,A,R,p,w,E,M,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qic=void 0;class S{constructor(f,h){this.document=f,this.b=h,this.a=1,this.c=new M.$Nhc("custom documents")}addEdit(f){return this.c.add([f])}async undo(f,h){await this.f(f).undo(),h||this.disposeBackup()}async redo(f,h){await this.f(f).redo(),h||this.disposeBackup()}disposeEdits(f){for(const h of f)this.c.delete(h)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const f=c(this.document.uri)+this.a++;return(0,R.$Sg)(this.b,f)}updateBackup(f){this.d?.delete(),this.d=f}disposeBackup(){this.d?.delete(),this.d=void 0}f(f){const h=this.c.get(f,0);if(!h)throw new Error("No edit found");return h}}class k{constructor(){this.a=new Map}get(f,h){return this.a.get(this.b(f,h))}add(f,h,r){const a=this.b(f,h.uri);if(this.a.has(a))throw new Error(`Document already exists for viewType:${f} resource:${h.uri}`);const d=new S(h,r);return this.a.set(a,d),d}delete(f,h){const r=this.b(f,h.uri);this.a.delete(r)}b(f,h){return`${f}@@@${h}`}}var u;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(u||(u={}));class m{constructor(){this.a=new Map}addTextProvider(f,h,r){return this.b(0,f,h,r)}addCustomProvider(f,h,r){return this.b(1,f,h,r)}get(f){return this.a.get(f)}b(f,h,r,a){if(this.a.has(h))throw new Error(`Provider for viewType:${h} already registered`);return this.a.set(h,{type:f,extension:r,provider:a}),new v.$8L(()=>this.a.delete(h))}}class o{constructor(f,h,r,a,d){this.d=h,this.f=r,this.g=a,this.h=d,this.b=new m,this.c=new k,this.a=f.getProxy(C.$6L.MainThreadCustomEditors)}registerCustomEditorProvider(f,h,r,a){const d=new L.$Sc;return n(r)?(d.add(this.b.addTextProvider(h,f,r)),this.a.$registerTextEditorProvider((0,E.$nic)(f),h,a.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,E.$lic)(f))):(d.add(this.b.addCustomProvider(h,f,r)),i(r)&&d.add(r.onDidChangeCustomDocument($=>{const D=this.i(h,$.document.uri);if(s($)){const b=D.addEdit($);this.a.$onDidEdit($.document.uri,h,b,$.label)}else this.a.$onContentChange($.document.uri,h)})),this.a.$registerCustomEditorProvider((0,E.$nic)(f),h,a.webviewOptions||{},!!a.supportsMultipleEditorsPerDocument,(0,E.$lic)(f))),v.$8L.from(d,new v.$8L(()=>{this.a.$unregisterEditorProvider(h)}))}async $createCustomDocument(f,h,r,a,d){const $=this.b.get(h);if(!$)throw new Error(`No provider found for '${h}'`);if($.type!==1)throw new Error(`Invalid provide type for '${h}'`);const D=p.URI.revive(f),b=await $.provider.openCustomDocument(D,{backupId:r,untitledDocumentData:a?.buffer},d);let g;return i($.provider)&&this.f&&(g=this.f.workspaceValue($.extension)??this.f.globalValue($.extension)),this.c.add(h,b,g),{editable:i($.provider)}}async $disposeCustomDocument(f,h){const r=this.b.get(h);if(!r)throw new Error(`No provider found for '${h}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${h}'`);const a=p.URI.revive(f),{document:d}=this.i(h,a);this.c.delete(h,d),d.dispose()}async $resolveCustomEditor(f,h,r,a,d,$){const D=this.b.get(r);if(!D)throw new Error(`No provider found for '${r}'`);const b=w.ViewColumn.to(d),g=this.g.createNewWebview(h,a.contentOptions,D.extension),y=this.h.createNewWebviewPanel(h,r,a.title,b,a.options,g,a.active),P=p.URI.revive(f);switch(D.type){case 1:{const{document:N}=this.i(r,P);return D.provider.resolveCustomEditor(N,y,$)}case 0:{const N=this.d.getDocument(P);return D.provider.resolveCustomTextEditor(N,y,$)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(f,h,r){this.i(h,f).disposeEdits(r)}async $onMoveCustomEditor(f,h,r){const a=this.b.get(r);if(!a)throw new Error(`No provider found for '${r}'`);if(!a.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const d=this.h.getWebviewPanel(f);if(!d)throw new Error("No webview found");const $=p.URI.revive(h),D=this.d.getDocument($);await a.provider.moveCustomTextEditor(D,d,l.CancellationToken.None)}async $undo(f,h,r,a){return this.i(h,f).undo(r,a)}async $redo(f,h,r,a){return this.i(h,f).redo(r,a)}async $revert(f,h,r){const a=this.i(h,f);await this.j(h).revertCustomDocument(a.document,r),a.disposeBackup()}async $onSave(f,h,r){const a=this.i(h,f);await this.j(h).saveCustomDocument(a.document,r),a.disposeBackup()}async $onSaveAs(f,h,r,a){const d=this.i(h,f);return this.j(h).saveCustomDocumentAs(d.document,p.URI.revive(r),a)}async $backup(f,h,r){const a=this.i(h,f),$=await this.j(h).backupCustomDocument(a.document,{destination:a.getNewBackupUri()},r);return a.updateBackup($),$.id}i(f,h){const r=this.c.get(f,p.URI.revive(h));if(!r)throw new Error("No custom document found");return r}j(f){const r=this.b.get(f)?.provider;if(!r||!i(r))throw new Error("Custom document is not editable");return r}}e.$qic=o;function i(t){return!!t.onDidChangeCustomDocument}function n(t){return typeof t.resolveCustomTextEditor=="function"}function s(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function c(t){const f=t.scheme===A.Schemas.file||t.scheme===A.Schemas.untitled?t.fsPath:t.toString();return(0,j.$6i)(f)+""}}),define(Se[328],De([1,0,216,138,2,6,7,16,4,12,28,59]),function(fe,e,l,j,L,A,R,p,w,E,M,C){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$Vhc=e.$Uhc=void 0;class S{#e;#t;#i;constructor(m,o,i,n,s,c,t,f){this.d=m,this.e=o,this.f=i,this.g=n,this.h=s,this.c=!1,this.f=Math.max(n,i),this.#i=new M.$Ac(h=>c.getComparisonKey(h)),this.#e=t,this.#t=f}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(m,o){if(!m){this.clear();return}this.j();let i=[];if(L.URI.isUri(m)){if(!o){this.delete(m);return}this.#i.set(m,o.slice()),i=[m]}else if(Array.isArray(m)){i=[];let c;m=[...m].sort(S.k);for(const t of m){const[f,h]=t;if((!c||f.toString()!==c.toString())&&(c&&this.#i.get(c).length===0&&this.#i.delete(c),c=f,i.push(f),this.#i.set(f,[])),h)this.#i.get(f)?.push(...h);else{const r=this.#i.get(f);r&&(r.length=0)}}}if(this.#t.fire(i),!this.#e)return;const n=[];let s=0;for(const c of i){let t=[];const f=this.#i.get(c);if(f)if(f.length>this.g){t=[];const h=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let r=0;r<4;r++)for(const a of f)if(a.severity===h[r]&&t.push({...p.Diagnostic.from(a),modelVersionId:this.h(c)})===this.g)break e;t.push({severity:j.MarkerSeverity.Info,message:(0,l.localize)(0,null,f.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=f.map(h=>({...p.Diagnostic.from(h),modelVersionId:this.h(c)}));if(n.push([c,t]),s+=t.length,s>this.f)break}this.#e.$changeMany(this.e,n)}delete(m){this.j(),this.#t.fire([m]),this.#i.delete(m),this.#e?.$changeMany(this.e,[[m,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(m,o){this.j();for(const[i,n]of this)m.call(o,i,n,this)}*[Symbol.iterator](){this.j();for(const m of this.#i.keys())yield[m,this.get(m)]}get(m){this.j();const o=this.#i.get(m);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(m){return this.j(),Array.isArray(this.#i.get(m))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(m,o){return m[0].toString()<o[0].toString()?-1:m[0].toString()>o[0].toString()?1:0}}e.$Uhc=S;let k=class{static{v=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*v.d}static _mapper(m){const o=new M.$Ac;for(const i of m)o.set(i,i);return{uris:Object.freeze(Array.from(o.values()))}}constructor(m,o,i,n){this.j=o,this.k=i,this.l=n,this.g=new Map,this.h=new w.$9d({merge:s=>s.flat(),delay:50}),this.onDidChangeDiagnostics=w.Event.map(this.h.event,v._mapper),this.f=m.getProxy(A.$6L.MainThreadDiagnostics)}createDiagnosticCollection(m,o){const{g:i,f:n,h:s,j:c,k:t,l:f}=this,h=new class{$changeMany(d,$){n.$changeMany(d,$),c.trace("[DiagnosticCollection] change many (extension, owner, uris)",m.value,d,$.length===0?"CLEARING":$)}$clear(d){n.$clear(d),c.trace("[DiagnosticCollection] remove all (extension, owner)",m.value,d)}dispose(){n.dispose()}};let r;if(!o)o="_generated_diagnostic_collection_name_#"+v.c++,r=o;else if(!i.has(o))r=o;else{this.j.warn(`DiagnosticCollection with name '${o}' does already exist.`);do r=o+v.c++;while(i.has(r))}return new class extends S{constructor(){super(o,r,v.e,v.d,d=>f.getDocument(d)?.version,t.extUri,h,s),i.set(r,this)}dispose(){super.dispose(),i.delete(r)}}}getDiagnostics(m){if(m)return this.m(m);{const o=new Map,i=[];for(const n of this.g.values())n.forEach((s,c)=>{let t=o.get(s.toString());typeof t>"u"&&(t=i.length,o.set(s.toString(),t),i.push([s,[]])),i[t][1]=i[t][1].concat(...c)});return i}}m(m){let o=[];for(const i of this.g.values())i.has(m)&&(o=o.concat(i.get(m)));return o}$acceptMarkersChange(m){if(!this.n){const o="_generated_mirror",i=new S(o,o,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,n=>{},this.k.extUri,void 0,this.h);this.g.set(o,i),this.n=i}for(const[o,i]of m)this.n.set(L.URI.revive(o),i.map(p.Diagnostic.to))}};e.$Vhc=k,e.$Vhc=k=v=Ye([Ve(1,E.$zj),Ve(2,C.$Thc)],k)}),define(Se[329],De([1,0,2,13,7,16,74]),function(fe,e,l,j,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ic=void 0;class p{constructor(E,M,C,v={timeout:1500,errors:3}){this.c=E,this.d=M,this.f=C,this.g=v,this.a=new R.$4c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(E){return(M,C,v)=>{const k={dispose:this.a.push([M,C,E])};return Array.isArray(v)&&v.push(k),k}}async $participateInSave(E,M){const C=l.URI.revive(E);let v=!1;const S=setTimeout(()=>v=!0,this.g.timeout),k=[];try{for(const u of[...this.a]){if(v)break;const m=this.d.getDocument(C),o=await this.h(u,{document:m,reason:A.TextDocumentSaveReason.to(M)});k.push(o)}}finally{clearTimeout(S)}return k}h([E,M,C],v){const S=this.b.get(E);return typeof S=="number"&&S>this.g.errors?Promise.resolve(!1):this.i(C,E,M,v).then(()=>!0,k=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' threw ERROR`),this.c.error(k),!(k instanceof Error)||k.message!=="concurrent_edits"){const u=this.b.get(E);this.b.set(E,u?u+1:1),typeof u=="number"&&u>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(E,M,C,v){const S=[],k=Date.now(),{document:u,reason:m}=v,{version:o}=u,i=Object.freeze({document:u,reason:m,waitUntil(n){if(Object.isFrozen(S))throw(0,j.$8)("waitUntil can not be called async");S.push(Promise.resolve(n))}});try{M.apply(C,[i])}catch(n){return Promise.reject(n)}return Object.freeze(S),new Promise((n,s)=>{const c=setTimeout(()=>s(new Error("timeout")),this.g.timeout);return Promise.all(S).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${E.identifier.value}' finished after ${Date.now()-k}ms`),clearTimeout(c),n(t)}).catch(t=>{clearTimeout(c),s(t)})}).then(n=>{const s={edits:[]};for(const c of n)if(Array.isArray(c)&&c.every(t=>t instanceof L.$cM))for(const{newText:t,newEol:f,range:h}of c)s.edits.push({resource:u.uri,versionId:void 0,textEdit:{range:h&&A.Range.from(h),text:t,eol:f&&A.EndOfLine.from(f)}});if(s.edits.length!==0)return o===u.version?this.f.$tryApplyWorkspaceEdit(s):Promise.reject(new Error("concurrent_edits"))})}}e.$5ic=p}),define(Se[330],De([1,0,4,3,2,6,152,16,18,24,7]),function(fe,e,l,j,L,A,R,p,w,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Whc=void 0;class C{constructor(S,k){this.a=new l.$5d,this.b=new l.$5d,this.c=new l.$5d,this.d=new l.$5d,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new j.$Sc,this.h=new Map,this.f=S.getProxy(A.$6L.MainThreadDocuments),this.g=k,this.g.onDidRemoveDocuments(u=>{for(const m of u)this.b.fire(m.document)},void 0,this.e),this.g.onDidAddDocuments(u=>{for(const m of u)this.a.fire(m.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(S){if(!S)return;const k=this.g.getDocument(S);if(k)return k}getDocument(S){const k=this.getDocumentData(S);if(!k?.document)throw new Error(`Unable to retrieve document from URI '${S}'`);return k.document}ensureDocumentData(S){const k=this.g.getDocument(S);if(k)return Promise.resolve(k);let u=this.h.get(S.toString());return u||(u=this.f.$tryOpenDocument(S).then(m=>{this.h.delete(S.toString());const o=L.URI.revive(m);return(0,w.$4f)(this.g.getDocument(o))},m=>(this.h.delete(S.toString()),Promise.reject(m))),this.h.set(S.toString(),u)),u}createDocumentData(S){return this.f.$tryCreateDocument(S).then(k=>L.URI.revive(k))}$acceptModelLanguageChanged(S,k){const u=L.URI.revive(S),m=this.g.getDocument(u);if(!m)throw new Error("unknown document");this.b.fire(m.document),m._acceptLanguageId(k),this.a.fire(m.document)}$acceptModelSaved(S){const k=L.URI.revive(S),u=this.g.getDocument(k);if(!u)throw new Error("unknown document");this.$acceptDirtyStateChanged(S,!1),this.d.fire(u.document)}$acceptDirtyStateChanged(S,k){const u=L.URI.revive(S),m=this.g.getDocument(u);if(!m)throw new Error("unknown document");m._acceptIsDirty(k),this.c.fire({document:m.document,contentChanges:[],reason:void 0})}$acceptModelChanged(S,k,u){const m=L.URI.revive(S),o=this.g.getDocument(m);if(!o)throw new Error("unknown document");o._acceptIsDirty(u),o.onEvents(k);let i;k.isUndoing?i=M.TextDocumentChangeReason.Undo:k.isRedoing&&(i=M.TextDocumentChangeReason.Redo),this.c.fire((0,E.$Ln)({document:o.document,contentChanges:k.changes.map(n=>({range:p.Range.to(n.range),rangeOffset:n.rangeOffset,rangeLength:n.rangeLength,text:n.text})),reason:i}))}setWordDefinitionFor(S,k){(0,R.$nO)(S,k)}}e.$Whc=C}),define(Se[70],De([1,0,72,4,18,2,5,6,20,16,7]),function(fe,e,l,j,L,A,R,p,w,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sic=e.$ric=void 0,e.$ric=(0,R.$fi)("IExtHostEditorTabs");class C{constructor(m,o,i){this.e=i,this.d=o,this.acceptDtoUpdate(m)}get apiObject(){if(!this.a){const m=this,o={get isActive(){return m.b.id===m.e()},get label(){return m.b.label},get input(){return m.c},get isDirty(){return m.b.isDirty},get isPinned(){return m.b.isPinned},get isPreview(){return m.b.isPreview},get group(){return m.d.apiObject}};this.a=Object.freeze(o)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(m){this.b=m,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new M.$PN(A.URI.revive(this.b.input.uri));case 2:return new M.$QN(A.URI.revive(this.b.input.original),A.URI.revive(this.b.input.modified));case 3:return new M.$RN(A.URI.revive(this.b.input.base),A.URI.revive(this.b.input.input1),A.URI.revive(this.b.input.input2),A.URI.revive(this.b.input.result));case 6:return new M.$SN(A.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new M.$TN(this.b.input.viewType);case 4:return new M.$UN(A.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new M.$VN(A.URI.revive(this.b.input.original),A.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new M.$WN;case 9:return new M.$XN(A.URI.revive(this.b.input.uri),A.URI.revive(this.b.input.inputBoxUri));case 10:return new M.$YN(this.b.input.providerId);default:return}}}class v{constructor(m,o){this.c=[],this.d="",this.b=m,this.e=o;for(const i of m.tabs)i.isActive&&(this.d=i.id),this.c.push(new C(i,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const m=this,o={get isActive(){return m.b.groupId===m.e()},get viewColumn(){return E.ViewColumn.to(m.b.viewColumn)},get activeTab(){return m.c.find(i=>i.tabId===m.d)?.apiObject},get tabs(){return Object.freeze(m.c.map(i=>i.apiObject))}};this.a=Object.freeze(o)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(m){this.b=m}acceptTabOperation(m){if(m.kind===0){const i=new C(m.tabDto,this,()=>this.activeTabId());return this.c.splice(m.index,0,i),m.tabDto.isActive&&(this.d=i.tabId),i}else if(m.kind===1){const i=this.c.splice(m.index,1)[0];if(!i)throw new Error(`Tab close updated received for index ${m.index} which does not exist`);return i.tabId===this.d&&(this.d=""),i}else if(m.kind===3){if(m.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const i=this.c.splice(m.oldIndex,1)[0];if(!i)throw new Error(`Tab move updated received for index ${m.oldIndex} which does not exist`);return this.c.splice(m.index,0,i),i}const o=this.c.find(i=>i.tabId===m.tabDto.id);if(!o)throw new Error("INVALID tab");return m.tabDto.isActive?this.d=m.tabDto.id:this.d===m.tabDto.id&&!m.tabDto.isActive&&(this.d=""),o.acceptDtoUpdate(m.tabDto),o}activeTabId(){return this.d}}let S=class{constructor(m){this.b=new j.$5d,this.c=new j.$5d,this.e=[],this.a=m.getProxy(p.$6L.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const m=this,o={onDidChangeTabGroups:m.c.event,onDidChangeTabs:m.b.event,get all(){return Object.freeze(m.e.map(i=>i.apiObject))},get activeTabGroup(){const i=m.d;return(0,L.$4f)(m.e.find(s=>s.groupId===i)?.apiObject)},close:async(i,n)=>{const s=Array.isArray(i)?i:[i];return s.length?k(s[0])?this.j(s,n):this.i(s,n):!0}};this.f=Object.freeze(o)}return this.f}$acceptEditorTabModel(m){const o=new Set(this.e.map(h=>h.groupId)),i=new Set(m.map(h=>h.groupId)),n=(0,l.$L)(o,i),s=this.e.filter(h=>n.removed.includes(h.groupId)).map(h=>h.apiObject),c=[],t=[];this.e=m.map(h=>{const r=new v(h,()=>this.d);return n.added.includes(r.groupId)?c.push(r.apiObject):t.push(r.apiObject),r});const f=(0,L.$4f)(m.find(h=>h.isActive===!0)?.groupId);f!==void 0&&this.d!==f&&(this.d=f),this.c.fire(Object.freeze({opened:c,closed:s,changed:t}))}$acceptTabGroupUpdate(m){const o=this.e.find(i=>i.groupId===m.groupId);if(!o)throw new Error("Update Group IPC call received before group creation.");o.acceptGroupDtoUpdate(m),m.isActive&&(this.d=m.groupId),this.c.fire(Object.freeze({changed:[o.apiObject],opened:[],closed:[]}))}$acceptTabOperation(m){const o=this.e.find(n=>n.groupId===m.groupId);if(!o)throw new Error("Update Tabs IPC call received before group creation.");const i=o.acceptTabOperation(m);switch(m.kind){case 0:this.b.fire(Object.freeze({opened:[i.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[i.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[i.apiObject]}));return}}g(m){for(const o of this.e)for(const i of o.tabs)if(i.apiObject===m)return i}h(m){return this.e.find(o=>o.apiObject===m)}async i(m,o){const i=[];for(const n of m){const s=this.g(n);if(!s)throw new Error("Tab close: Invalid tab not found!");i.push(s.tabId)}return this.a.$closeTab(i,o)}async j(m,o){const i=[];for(const n of m){const s=this.h(n);if(!s)throw new Error("Group close: Invalid group not found!");i.push(s.groupId)}return this.a.$closeGroup(i,o)}};e.$sic=S,e.$sic=S=Ye([Ve(0,w.$lO)],S);function k(u){return u.tabs!==void 0}}),define(Se[331],De([1,0,2,6,3,7,16,178,14,21,26,79]),function(fe,e,l,j,L,A,R,p,w,E,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ic=void 0;class v{constructor(){this.a=[]}add(u){this.b=void 0,this.a.push(u)}delete(u){const m=this.a.indexOf(u);m>=0&&(this.a.splice(m,1),this.b=void 0)}c(){if(!this.b){const u=this.a.sort(),m=[];let o,i,n=14,s=14;for(const c of u){let t=o?(0,w.$lf)(o,c):0;for(t===0?i=1:i=s;t<c.length;t++)t+1===c.length?(n=s,s=9):s+=1,m.push([i,c.toUpperCase().charCodeAt(t),s]),m.push([i,c.toLowerCase().charCodeAt(t),s]),i=s;o=c,s=n}m.push([9,58,10]),m.push([10,47,12]),this.b=new p.$_1(m)}}provideDocumentLinks(u){this.c();const m=[],o=p.$a2.computeLinks({getLineContent(i){return u.lineAt(i-1).text},getLineCount(){return u.lineCount}},this.b);for(const i of o){const n=R.DocumentLink.to(i);n.target&&m.push(n)}return m}}class S{constructor(u,m){this.i=m,this.b=new v,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=u.getProxy(j.$6L.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(u,m,o,i={}){if(S.j(o),this.d.has(m))throw new Error(`a provider for the scheme '${m}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(u,"*",this.b));const n=this.h++;this.b.add(m),this.d.add(m),this.c.set(n,o);let s=2;i.isCaseSensitive&&(s+=1024),i.isReadonly&&(s+=2048),typeof o.copy=="function"&&(s+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&((0,M.$YF)(u,"fsChunks"),s+=4);let c;i.isReadonly&&(0,C.$yk)(i.isReadonly)&&i.isReadonly.value!==""&&(c={value:i.isReadonly.value,isTrusted:i.isReadonly.isTrusted,supportThemeIcons:i.isReadonly.supportThemeIcons,supportHtml:i.isReadonly.supportHtml,baseUri:i.isReadonly.baseUri,uris:i.isReadonly.uris}),this.a.$registerFileSystemProvider(n,m,s,c).catch(f=>{console.error(`FAILED to register filesystem provider of ${u.identifier.value}-extension for the scheme ${m}`),console.error(f)});const t=o.onDidChangeFile(f=>{const h=[];for(const r of f){const{uri:a,type:d}=r;if(a.scheme!==m)continue;let $;switch(d){case A.FileChangeType.Changed:$=0;break;case A.FileChangeType.Created:$=1;break;case A.FileChangeType.Deleted:$=2;break;default:throw new Error("Unknown FileChangeType")}h.push({resource:a,type:$})}this.a.$onFileSystemChange(n,h)});return(0,L.$Rc)(()=>{t.dispose(),this.b.delete(m),this.d.delete(m),this.c.delete(n),this.a.$unregisterProvider(n)})}static j(u){if(!u)throw new Error("MISSING provider");if(typeof u.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof u.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof u.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof u.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof u.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof u.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof u.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof u.rename!="function")throw new Error("Provider does NOT implement rename")}static k(u){const{type:m,ctime:o,mtime:i,size:n,permissions:s}=u;return{type:m,ctime:o,mtime:i,size:n,permissions:s}}$stat(u,m){return Promise.resolve(this.l(u).stat(l.URI.revive(m))).then(o=>S.k(o))}$readdir(u,m){return Promise.resolve(this.l(u).readDirectory(l.URI.revive(m)))}$readFile(u,m){return Promise.resolve(this.l(u).readFile(l.URI.revive(m))).then(o=>E.$se.wrap(o))}$writeFile(u,m,o,i){return Promise.resolve(this.l(u).writeFile(l.URI.revive(m),o.buffer,i))}$delete(u,m,o){return Promise.resolve(this.l(u).delete(l.URI.revive(m),o))}$rename(u,m,o,i){return Promise.resolve(this.l(u).rename(l.URI.revive(m),l.URI.revive(o),i))}$copy(u,m,o,i){const n=this.l(u);if(!n.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(n.copy(l.URI.revive(m),l.URI.revive(o),i))}$mkdir(u,m){return Promise.resolve(this.l(u).createDirectory(l.URI.revive(m)))}$watch(u,m,o,i){const n=this.l(u).watch(l.URI.revive(o),i);this.f.set(m,n)}$unwatch(u,m){const o=this.f.get(m);o&&(o.dispose(),this.f.delete(m))}$open(u,m,o){const i=this.l(u);if(!i.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(i.open(l.URI.revive(m),o))}$close(u,m){const o=this.l(u);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(m))}$read(u,m,o,i){const n=this.l(u);if(!n.read)throw new Error('FileSystemProvider does not implement "read"');const s=E.$se.alloc(i);return Promise.resolve(n.read(m,o,s.buffer,0,i)).then(c=>s.slice(0,c))}$write(u,m,o,i){const n=this.l(u);if(!n.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(n.write(m,o,i.buffer,0,i.byteLength))}l(u){const m=this.c.get(u);if(!m){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return m}}e.$7ic=S}),define(Se[332],De([1,0,4,35,2,6,16,7,43]),function(fe,e,l,j,L,A,R,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8ic=void 0;class E{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(S,k,u,m,o,i){this.a=Math.random(),this.b=new l.$5d,this.c=new l.$5d,this.d=new l.$5d,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const n=(0,j.$Yj)(o),s=typeof o=="string",c=i?.correlate,t=m(f=>{if(!(typeof f.session=="number"&&f.session!==this.a)&&!(c&&typeof f.session>"u")){if(!i?.ignoreCreateEvents)for(const h of f.created){const r=L.URI.revive(h);n(r.fsPath)&&(!s||k.getWorkspaceFolder(r))&&this.b.fire(r)}if(!i?.ignoreChangeEvents)for(const h of f.changed){const r=L.URI.revive(h);n(r.fsPath)&&(!s||k.getWorkspaceFolder(r))&&this.c.fire(r)}if(!i?.ignoreDeleteEvents)for(const h of f.deleted){const r=L.URI.revive(h);n(r.fsPath)&&(!s||k.getWorkspaceFolder(r))&&this.d.fire(r)}}});this.g=p.$8L.from(this.i(S,u,o,i,i?.correlate),this.b,this.c,this.d,t)}i(S,k,u,m,o){const i=p.$8L.from();if(typeof u=="string")return i;const n=S.getProxy(A.$6L.MainThreadFileSystemEventService);let s=!1;return(u.pattern.includes(j.$Uj)||u.pattern.includes(j.$Vj))&&(s=!0),n.$watch(k.identifier.value,this.a,u.baseUri,{recursive:s,excludes:m?.excludes??[]},!!o),p.$8L.from({dispose:()=>n.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class M{constructor(S){this.a=S,this.session=this.a.session,this.b=new w.$V(()=>this.a.created.map(L.URI.revive)),this.c=new w.$V(()=>this.a.changed.map(L.URI.revive)),this.d=new w.$V(()=>this.a.deleted.map(L.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class C{constructor(S,k,u){this.j=S,this.k=k,this.l=u,this.a=new l.$5d,this.b=new l.$5d,this.c=new l.$5d,this.d=new l.$5d,this.g=new l.$7d,this.h=new l.$7d,this.i=new l.$7d,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(S,k,u,m){return new E(this.j,S,k,this.a.event,R.GlobPattern.from(u),m)}$onFileEvent(S){this.a.fire(new M(S))}$onDidRunFileOperation(S,k){switch(S){case 2:this.b.fire(Object.freeze({files:k.map(u=>({oldUri:L.URI.revive(u.source),newUri:L.URI.revive(u.target)}))}));break;case 1:this.d.fire(Object.freeze({files:k.map(u=>L.URI.revive(u.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:k.map(u=>L.URI.revive(u.target))}));break;default:}}getOnWillRenameFileEvent(S){return this.m(S,this.g)}getOnWillCreateFileEvent(S){return this.m(S,this.h)}getOnWillDeleteFileEvent(S){return this.m(S,this.i)}m(S,k){return(u,m,o)=>{const i=function(s){u.call(m,s)};return i.extension=S,k.event(i,void 0,o)}}async $onWillRunFileOperation(S,k,u,m){switch(S){case 2:return await this.n(this.g,{files:k.map(o=>({oldUri:L.URI.revive(o.source),newUri:L.URI.revive(o.target)}))},u,m);case 1:return await this.n(this.i,{files:k.map(o=>L.URI.revive(o.target))},u,m);case 0:case 3:return await this.n(this.h,{files:k.map(o=>L.URI.revive(o.target))},u,m)}}async n(S,k,u,m){const o=new Set,i=[];if(await S.fireAsync(k,m,async(s,c)=>{const t=Date.now(),f=await Promise.resolve(s);f instanceof p.$fM&&(i.push([c.extension,f]),o.add(c.extension.displayName??c.extension.identifier.value)),Date.now()-t>u&&this.k.warn("SLOW file-participant",c.extension.identifier)}),m.isCancellationRequested||i.length===0)return;const n={edits:[]};for(const[,s]of i){const{edits:c}=R.WorkspaceEdit.from(s,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});n.edits=n.edits.concat(c)}return{edit:n,extensionNames:Array.from(o)}}}e.$8ic=C}),define(Se[333],De([1,0,19,8,22,13,124,3,24,38,14,18,2,29,174,82,134,218,25,16,7,26,111,6]),function(fe,e,l,j,L,A,R,p,w,E,M,C,v,S,k,u,m,o,i,n,s,c,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xhc=void 0;class h{constructor(q,W){this.d=q,this.e=W}async provideDocumentSymbols(q,W){const Y=this.d.getDocument(q),J=await this.e.provideDocumentSymbols(Y,W);if(!(0,l.$Kb)(J))return J[0]instanceof s.$oM?J.map(n.DocumentSymbol.from):h.f(J)}static f(q){q=q.slice(0).sort((J,$e)=>{let ve=J.location.range.start.compareTo($e.location.range.start);return ve===0&&(ve=$e.location.range.end.compareTo(J.location.range.end)),ve});const W=[],Y=[];for(const J of q){const $e={name:J.name||"!!MISSING: name!!",kind:n.SymbolKind.from(J.kind),tags:J.tags?.map(n.SymbolTag.from)||[],detail:"",containerName:J.containerName,range:n.Range.from(J.location.range),selectionRange:n.Range.from(J.location.range),children:[]};for(;;){if(Y.length===0){Y.push($e),W.push($e);break}const ve=Y[Y.length-1];if(S.$9s.containsRange(ve.range,$e.range)&&!S.$9s.equalsRange(ve.range,$e.range)){ve.children?.push($e),Y.push($e);break}Y.pop()}}return W}}class r{constructor(q,W,Y,J,$e,ve){this.f=q,this.g=W,this.h=Y,this.j=J,this.k=$e,this.l=ve,this.d=new t.$Nhc("CodeLens"),this.e=new Map}async provideCodeLenses(q,W){const Y=this.f.getDocument(q),J=await this.h.provideCodeLenses(Y,W);if(!J||W.isCancellationRequested)return;const $e=this.d.add(J),ve=new p.$Sc;this.e.set($e,ve);const Fe={cacheId:$e,lenses:[]};for(let He=0;He<J.length;He++)Fe.lenses.push({cacheId:[$e,He],range:n.Range.from(J[He].range),command:this.g.toInternal(J[He].command,ve)});return Fe}async resolveCodeLens(q,W){const Y=q.cacheId&&this.d.get(...q.cacheId);if(!Y)return;let J;if(typeof this.h.resolveCodeLens!="function"||Y.isResolved?J=Y:J=await this.h.resolveCodeLens(Y,W),J||(J=Y),W.isCancellationRequested)return;const $e=q.cacheId&&this.e.get(q.cacheId[0]);if($e){if(!J.command){const ve=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,ve),this.l.error(ve);return}return q.command=this.g.toInternal(J.command,$e),q}}releaseCodeLenses(q){this.e.get(q)?.dispose(),this.e.delete(q),this.d.delete(q)}}function a(ze){return Array.isArray(ze)?ze.map(n.DefinitionLink.from):ze?[n.DefinitionLink.from(ze)]:[]}class d{constructor(q,W){this.d=q,this.e=W}async provideDefinition(q,W,Y){const J=this.d.getDocument(q),$e=n.Position.to(W),ve=await this.e.provideDefinition(J,$e,Y);return a(ve)}}class ${constructor(q,W){this.d=q,this.e=W}async provideDeclaration(q,W,Y){const J=this.d.getDocument(q),$e=n.Position.to(W),ve=await this.e.provideDeclaration(J,$e,Y);return a(ve)}}class D{constructor(q,W){this.d=q,this.e=W}async provideImplementation(q,W,Y){const J=this.d.getDocument(q),$e=n.Position.to(W),ve=await this.e.provideImplementation(J,$e,Y);return a(ve)}}class b{constructor(q,W){this.d=q,this.e=W}async provideTypeDefinition(q,W,Y){const J=this.d.getDocument(q),$e=n.Position.to(W),ve=await this.e.provideTypeDefinition(J,$e,Y);return a(ve)}}class g{constructor(q,W){this.d=q,this.e=W}async provideHover(q,W,Y){const J=this.d.getDocument(q),$e=n.Position.to(W),ve=await this.e.provideHover(J,$e,Y);if(!(!ve||(0,l.$Kb)(ve.contents)))return ve.range||(ve.range=J.getWordRangeAtPosition($e)),ve.range||(ve.range=new s.$0L($e,$e)),n.Hover.from(ve)}}class y{constructor(q,W){this.d=q,this.e=W}async provideEvaluatableExpression(q,W,Y){const J=this.d.getDocument(q),$e=n.Position.to(W),ve=await this.e.provideEvaluatableExpression(J,$e,Y);if(ve)return n.EvaluatableExpression.from(ve)}}class P{constructor(q,W){this.d=q,this.e=W}async provideInlineValues(q,W,Y,J){const $e=this.d.getDocument(q),ve=await this.e.provideInlineValues($e,n.Range.to(W),n.InlineValueContext.to(Y),J);if(Array.isArray(ve))return ve.map(Fe=>n.InlineValue.from(Fe))}}class N{constructor(q,W){this.d=q,this.e=W}async provideDocumentHighlights(q,W,Y){const J=this.d.getDocument(q),$e=n.Position.to(W),ve=await this.e.provideDocumentHighlights(J,$e,Y);if(Array.isArray(ve))return ve.map(n.DocumentHighlight.from)}}class U{constructor(q,W){this.d=q,this.e=W}async provideMultiDocumentHighlights(q,W,Y,J){const $e=this.d.getDocument(q),ve=Y.map(Qe=>this.d.getDocument(Qe)),Fe=n.Position.to(W),He=await this.e.provideMultiDocumentHighlights($e,Fe,ve,J);if(Array.isArray(He))return He.map(n.MultiDocumentHighlight.from)}}class z{constructor(q,W){this.d=q,this.e=W}async provideLinkedEditingRanges(q,W,Y){const J=this.d.getDocument(q),$e=n.Position.to(W),ve=await this.e.provideLinkedEditingRanges(J,$e,Y);if(ve&&Array.isArray(ve.ranges))return{ranges:(0,l.$Hb)(ve.ranges.map(n.Range.from)),wordPattern:ve.wordPattern}}}class F{constructor(q,W){this.d=q,this.e=W}async provideReferences(q,W,Y,J){const $e=this.d.getDocument(q),ve=n.Position.to(W),Fe=await this.e.provideReferences($e,ve,Y,J);if(Array.isArray(Fe))return Fe.map(n.location.from)}}class I{static{this.d=1e3}constructor(q,W,Y,J,$e,ve,Fe){this.g=q,this.h=W,this.j=Y,this.k=J,this.l=$e,this.m=ve,this.n=Fe,this.e=new t.$Nhc("CodeAction"),this.f=new Map}async provideCodeActions(q,W,Y,J){const $e=this.g.getDocument(q),ve=k.$$s.isISelection(W)?n.Selection.to(W):n.Range.to(W),Fe=[];for(const rt of this.j.getDiagnostics(q))if(ve.intersection(rt.range)&&Fe.push(rt)>I.d)break;const He={diagnostics:Fe,only:Y.only?new s.$qM(Y.only):void 0,triggerKind:n.CodeActionTriggerKind.to(Y.trigger)},Qe=await this.k.provideCodeActions($e,ve,He,J);if(!(0,l.$Lb)(Qe)||J.isCancellationRequested)return;const tt=this.e.add(Qe),st=new p.$Sc;this.f.set(tt,st);const ut=[];for(let rt=0;rt<Qe.length;rt++){const Ie=Qe[rt];if(Ie)if(I.o(Ie))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),ut.push({_isSynthetic:!0,title:Ie.title,command:this.h.toInternal(Ie,st)});else{He.only&&(Ie.kind?He.only.contains(Ie.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${He.only.value} 'requested but returned code action is of kind '${Ie.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${He.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const Be=Ie.ranges??[];ut.push({cacheId:[tt,rt],title:Ie.title,command:Ie.command&&this.h.toInternal(Ie.command,st),diagnostics:Ie.diagnostics&&Ie.diagnostics.map(n.Diagnostic.from),edit:Ie.edit&&n.WorkspaceEdit.from(Ie.edit,void 0),kind:Ie.kind&&Ie.kind.value,isPreferred:Ie.isPreferred,isAI:(0,c.$XF)(this.m,"codeActionAI")?Ie.isAI:!1,ranges:(0,c.$XF)(this.m,"codeActionRanges")?(0,l.$Hb)(Be.map(n.Range.from)):void 0,disabled:Ie.disabled?.reason})}}return{cacheId:tt,actions:ut}}async resolveCodeAction(q,W){const[Y,J]=q,$e=this.e.get(Y,J);if(!$e||I.o($e))return{};if(!this.k.resolveCodeAction)return{};const ve=await this.k.resolveCodeAction($e,W)??$e;let Fe;ve.edit&&(Fe=n.WorkspaceEdit.from(ve.edit,void 0));let He;if(ve.command){const Qe=this.f.get(Y);Qe&&(He=this.h.toInternal(ve.command,Qe))}return{edit:Fe,command:He}}releaseCodeActions(q){this.f.get(q)?.dispose(),this.f.delete(q),this.e.delete(q)}static o(q){return typeof q.command=="string"&&typeof q.title=="string"}}class O{static toInternalProviderId(q,W){return q+"."+W}constructor(q,W,Y,J,$e){this.d=q,this.e=W,this.f=Y,this.g=J,this.h=$e}async prepareDocumentPaste(q,W,Y,J){if(!this.f.prepareDocumentPaste)return;const $e=this.e.getDocument(q),ve=W.map(Qe=>n.Range.to(Qe)),Fe=n.DataTransfer.toDataTransfer(Y,()=>{throw new A.$$});if(await this.f.prepareDocumentPaste($e,ve,Fe,J),J.isCancellationRequested)return;const He=Array.from(Fe).filter(([,Qe])=>!(Qe instanceof s.$WM));return n.DataTransfer.from(He)}async providePasteEdits(q,W,Y,J,$e){if(!this.f.provideDocumentPasteEdits)return;const ve=this.e.getDocument(W),Fe=Y.map(tt=>n.Range.to(tt)),He=n.DataTransfer.toDataTransfer(J,async tt=>(await this.d.$resolvePasteFileData(this.g,q,tt)).buffer),Qe=await this.f.provideDocumentPasteEdits(ve,Fe,He,$e);if(Qe)return{label:Qe.label??(0,o.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:Qe.yieldTo?.map(tt=>"mimeType"in tt?tt:{providerId:O.toInternalProviderId(tt.extensionId,tt.providerId)}),insertText:typeof Qe.insertText=="string"?Qe.insertText:{snippet:Qe.insertText.value},additionalEdit:Qe.additionalEdit?n.WorkspaceEdit.from(Qe.additionalEdit,void 0):void 0}}}class T{constructor(q,W){this.d=q,this.e=W}async provideDocumentFormattingEdits(q,W,Y){const J=this.d.getDocument(q),$e=await this.e.provideDocumentFormattingEdits(J,W,Y);if(Array.isArray($e))return $e.map(n.TextEdit.from)}}class G{constructor(q,W){this.d=q,this.e=W}async provideDocumentRangeFormattingEdits(q,W,Y,J){const $e=this.d.getDocument(q),ve=n.Range.to(W),Fe=await this.e.provideDocumentRangeFormattingEdits($e,ve,Y,J);if(Array.isArray(Fe))return Fe.map(n.TextEdit.from)}async provideDocumentRangesFormattingEdits(q,W,Y,J){(0,C.$3f)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const $e=this.d.getDocument(q),ve=W.map(n.Range.to),Fe=await this.e.provideDocumentRangesFormattingEdits($e,ve,Y,J);if(Array.isArray(Fe))return Fe.map(n.TextEdit.from)}}class te{constructor(q,W){this.d=q,this.e=W,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(q,W,Y,J,$e){const ve=this.d.getDocument(q),Fe=n.Position.to(W),He=await this.e.provideOnTypeFormattingEdits(ve,Fe,Y,J,$e);if(Array.isArray(He))return He.map(n.TextEdit.from)}}class x{constructor(q,W){this.e=q,this.f=W,this.d=new t.$Nhc("WorkspaceSymbols")}async provideWorkspaceSymbols(q,W){const Y=await this.e.provideWorkspaceSymbols(q,W);if(!(0,l.$Lb)(Y))return{symbols:[]};const J=this.d.add(Y),$e={cacheId:J,symbols:[]};for(let ve=0;ve<Y.length;ve++){const Fe=Y[ve];if(!Fe||!Fe.name){this.f.warn("INVALID SymbolInformation",Fe);continue}$e.symbols.push({...n.WorkspaceSymbol.from(Fe),cacheId:[J,ve]})}return $e}async resolveWorkspaceSymbol(q,W){if(typeof this.e.resolveWorkspaceSymbol!="function"||!q.cacheId)return q;const Y=this.d.get(...q.cacheId);if(Y){const J=await this.e.resolveWorkspaceSymbol(Y,W);return J&&(0,w.$Nn)(q,n.WorkspaceSymbol.from(J),!0)}}releaseWorkspaceSymbols(q){this.d.delete(q)}}class X{static supportsResolving(q){return typeof q.prepareRename=="function"}constructor(q,W,Y){this.d=q,this.e=W,this.f=Y}async provideRenameEdits(q,W,Y,J){const $e=this.d.getDocument(q),ve=n.Position.to(W);try{const Fe=await this.e.provideRenameEdits($e,ve,Y,J);return Fe?n.WorkspaceEdit.from(Fe):void 0}catch(Fe){const He=X.g(Fe);return He?{rejectReason:He,edits:void 0}:Promise.reject(Fe)}}async resolveRenameLocation(q,W,Y){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const J=this.d.getDocument(q),$e=n.Position.to(W);try{const ve=await this.e.prepareRename(J,$e,Y);let Fe,He;if(s.$0L.isRange(ve)?(Fe=ve,He=J.getText(ve)):(0,C.$Uf)(ve)&&(Fe=ve.range,He=ve.placeholder),!Fe||!He)return;if(Fe.start.line>$e.line||Fe.end.line<$e.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:n.Range.from(Fe),text:He}}catch(ve){const Fe=X.g(ve);return Fe?{rejectReason:Fe,range:void 0,text:void 0}:Promise.reject(ve)}}static g(q){return typeof q=="string"?q:q instanceof Error&&typeof q.message=="string"?q.message:void 0}}class Q{constructor(q,W,Y){this.d=q,this.e=W,this.f=Y}async provideNewSymbolNames(q,W,Y){const J=this.d.getDocument(q),$e=n.Range.to(W);try{const ve=await this.e.provideNewSymbolNames(J,$e,Y);return ve?ve.map(Fe=>typeof Fe=="string"?{newSymbolName:Fe}:{newSymbolName:Fe.newSymbolName,tags:Fe.tags}):void 0}catch(ve){this.f.error(Q.g(ve)??JSON.stringify(ve,null,"	"));return}}static g(q){return typeof q=="string"?q:q instanceof Error&&typeof q.message=="string"?q.message:void 0}}class ae{constructor(q,W){this.resultId=q,this.tokens=W}}class _{constructor(q,W){this.f=q,this.g=W,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(q,W,Y){const J=this.f.getDocument(q),$e=W!==0?this.d.get(W):null;let ve=typeof $e?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(J,$e.resultId,Y):await this.g.provideDocumentSemanticTokens(J,Y);return $e&&this.d.delete(W),ve?(ve=_.h(ve),this.o(_.n($e,ve),ve)):null}async releaseDocumentSemanticColoring(q){this.d.delete(q)}static h(q){return _.j(q)?_.k(q)?q:new s.$oN(new Uint32Array(q.data),q.resultId):_.l(q)?_.m(q)?q:new s.$qN(q.edits.map(W=>new s.$pN(W.start,W.deleteCount,W.data?new Uint32Array(W.data):W.data)),q.resultId):q}static j(q){return q&&!!q.data}static k(q){return q.data instanceof Uint32Array}static l(q){return q&&Array.isArray(q.edits)}static m(q){for(const W of q.edits)if(!(W.data instanceof Uint32Array))return!1;return!0}static n(q,W){if(!_.j(W)||!q||!q.tokens)return W;const Y=q.tokens,J=Y.length,$e=W.data,ve=$e.length;let Fe=0;const He=Math.min(J,ve);for(;Fe<He&&Y[Fe]===$e[Fe];)Fe++;if(Fe===J&&Fe===ve)return new s.$qN([],W.resultId);let Qe=0;const tt=He-Fe;for(;Qe<tt&&Y[J-Qe-1]===$e[ve-Qe-1];)Qe++;return new s.$qN([{start:Fe,deleteCount:J-Fe-Qe,data:$e.subarray(Fe,ve-Qe)}],W.resultId)}o(q,W){if(_.j(q)){const Y=this.e++;return this.d.set(Y,new ae(q.resultId,q.data)),(0,m.$dab)({id:Y,type:"full",data:q.data})}if(_.l(q)){const Y=this.e++;return _.j(W)?this.d.set(Y,new ae(W.resultId,W.data)):this.d.set(Y,new ae(q.resultId)),(0,m.$dab)({id:Y,type:"delta",deltas:(q.edits||[]).map(J=>({start:J.start,deleteCount:J.deleteCount,data:J.data}))})}return null}}class ge{constructor(q,W){this.d=q,this.e=W}async provideDocumentRangeSemanticTokens(q,W,Y){const J=this.d.getDocument(q),$e=await this.e.provideDocumentRangeSemanticTokens(J,n.Range.to(W),Y);return $e?this.f($e):null}f(q){return(0,m.$dab)({id:0,type:"full",data:q.data})}}class se{static supportsResolving(q){return typeof q.resolveCompletionItem=="function"}constructor(q,W,Y,J,$e){this.f=q,this.g=W,this.h=Y,this.j=J,this.k=$e,this.d=new t.$Nhc("CompletionItem"),this.e=new Map}async provideCompletionItems(q,W,Y,J){const $e=this.f.getDocument(q),ve=n.Position.to(W),Fe=$e.getWordRangeAtPosition(ve)||new s.$0L(ve,ve),He=Fe.with({end:ve}),Qe=new E.$1d,tt=await this.h.provideCompletionItems($e,ve,J,n.CompletionContext.to(Y));if(!tt||J.isCancellationRequested)return;const st=Array.isArray(tt)?new s.$DM(tt):tt,ut=se.supportsResolving(this.h)?this.d.add(st.items):this.d.add([]),rt=new p.$Sc;this.e.set(ut,rt);const Ie=[],Be={x:ut,b:Ie,a:{replace:n.Range.from(Fe),insert:n.Range.from(He)},c:st.isIncomplete||void 0,d:Qe.elapsed()};for(let Le=0;Le<st.items.length;Le++){const Ke=st.items[Le],ne=this.l(Ke,[ut,Le],He,Fe);Ie.push(ne)}return Be}async resolveCompletionItem(q,W){if(typeof this.h.resolveCompletionItem!="function")return;const Y=this.d.get(...q);if(!Y)return;const J=this.l(Y,q),$e=await this.h.resolveCompletionItem(Y,W);if(!$e)return;const ve=this.l($e,q);return(J.h!==ve.h||J.i!==ve.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(J.n!==ve.n||J.o!==ve.o||!(0,w.$On)(J.p,ve.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...J,d:ve.d,c:ve.c,l:ve.l,h:ve.h,i:ve.i,n:ve.n,o:ve.o,p:ve.p}}releaseCompletionItems(q){this.e.get(q)?.dispose(),this.e.delete(q),this.d.delete(q)}l(q,W,Y,J){const $e=this.e.get(W[0]);if(!$e)throw Error("DisposableStore is missing...");const ve=this.g.toInternal(q.command,$e),Fe={x:W,a:q.label,b:q.kind!==void 0?n.CompletionItemKind.from(q.kind):void 0,m:q.tags&&q.tags.map(n.CompletionItemTag.from),c:q.detail,d:typeof q.documentation>"u"?void 0:n.MarkdownString.fromStrict(q.documentation),e:q.sortText!==q.label?q.sortText:void 0,f:q.filterText!==q.label?q.filterText:void 0,g:q.preselect||void 0,i:q.keepWhitespace?1:0,k:q.commitCharacters?.join(""),l:q.additionalTextEdits&&q.additionalTextEdits.map(n.TextEdit.from),n:ve?.$ident,o:ve?.id,p:ve?.$ident?void 0:ve?.arguments};q.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Fe.h=q.textEdit.newText):typeof q.insertText=="string"?Fe.h=q.insertText:q.insertText instanceof s.$gM&&(Fe.h=q.insertText.value,Fe.i|=4);let He;return q.textEdit?He=q.textEdit.range:q.range&&(He=q.range),s.$0L.isRange(He)?Fe.j=n.Range.from(He):He&&(!Y?.isEqual(He.inserting)||!J?.isEqual(He.replacing))&&(Fe.j={insert:n.Range.from(He.inserting),replace:n.Range.from(He.replacing)}),Fe}}class re{async provideInlineCompletions(q,W,Y,J){}disposeCompletions(q){}handleDidShowCompletionItem(q,W,Y){}handlePartialAccept(q,W,Y){}}class B extends re{constructor(q,W,Y,J){super(),this.f=q,this.g=W,this.h=Y,this.j=J,this.d=new ye,this.e=(0,c.$XF)(this.f,"inlineCompletionsAdditions"),this.k={[u.InlineCompletionTriggerKind.Automatic]:s.InlineCompletionTriggerKind.Automatic,[u.InlineCompletionTriggerKind.Explicit]:s.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,c.$XF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(q,W,Y,J){const $e=this.g.getDocument(q),ve=n.Position.to(W),Fe=await this.h.provideInlineCompletionItems($e,ve,{selectedCompletionInfo:Y.selectedSuggestionInfo?{range:n.Range.to(Y.selectedSuggestionInfo.range),text:Y.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[Y.triggerKind]},J);if(!Fe||J.isCancellationRequested)return;const He=Array.isArray(Fe)?Fe:Fe.items,Qe=this.e?Array.isArray(Fe)?[]:Fe.commands||[]:[],tt=this.e&&!Array.isArray(Fe)?Fe.enableForwardStability:void 0;let st;return{pid:this.d.createReferenceId({dispose(){st?.dispose()},items:He}),items:He.map((rt,Ie)=>{let Be;rt.command&&(st||(st=new p.$Sc),Be=this.j.toInternal(rt.command,st));const Le=rt.insertText;return{insertText:typeof Le=="string"?Le:{snippet:Le.value},filterText:rt.filterText,range:rt.range?n.Range.from(rt.range):void 0,command:Be,idx:Ie,completeBracketPairs:this.e?rt.completeBracketPairs:!1}}),commands:Qe.map(rt=>(st||(st=new p.$Sc),this.j.toInternal(rt,st))),suppressSuggestions:!1,enableForwardStability:tt}}disposeCompletions(q){this.d.disposeReferenceId(q)?.dispose()}handleDidShowCompletionItem(q,W,Y){const J=this.d.get(q)?.items[W];J&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(J,Y)}handlePartialAccept(q,W,Y){const J=this.d.get(q)?.items[W];J&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(J,Y)}}class ie{async provideInlineEdits(q,W,Y){const J=this.f.getDocument(q),$e=await this.g.provideInlineEdit(J,{triggerKind:this.e[W.triggerKind]},Y);if(!$e||Y.isCancellationRequested)return;let ve;const Fe=this.d.createReferenceId({dispose(){ve?.dispose()},item:$e});let He;$e.accepted&&(ve||(ve=new p.$Sc),He=this.h.toInternal($e.accepted,ve));let Qe;return $e.rejected&&(ve||(ve=new p.$Sc),Qe=this.h.toInternal($e.rejected,ve)),{pid:Fe,text:$e.text,range:n.Range.from($e.range),accepted:He,rejected:Qe}}disposeEdit(q){this.d.disposeReferenceId(q)?.dispose()}constructor(q,W,Y,J){this.f=W,this.g=Y,this.h=J,this.d=new ye,this.e={[u.InlineEditTriggerKind.Automatic]:s.InlineEditTriggerKind.Automatic,[u.InlineEditTriggerKind.Invoke]:s.InlineEditTriggerKind.Invoke}}}class ye{constructor(){this.d=new Map,this.e=1}createReferenceId(q){const W=this.e++;return this.d.set(W,q),W}disposeReferenceId(q){const W=this.d.get(q);return this.d.delete(q),W}get(q){return this.d.get(q)}}class le{constructor(q,W){this.e=q,this.f=W,this.d=new t.$Nhc("SignatureHelp")}async provideSignatureHelp(q,W,Y,J){const $e=this.e.getDocument(q),ve=n.Position.to(W),Fe=this.g(Y),He=await this.f.provideSignatureHelp($e,ve,J,Fe);if(He){const Qe=this.d.add([He]);return{...n.SignatureHelp.from(He),id:Qe}}}g(q){let W;if(q.activeSignatureHelp){const Y=n.SignatureHelp.to(q.activeSignatureHelp),J=this.d.get(q.activeSignatureHelp.id,0);J?(W=J,W.activeSignature=Y.activeSignature,W.activeParameter=Y.activeParameter):W=Y}return{...q,activeSignatureHelp:W}}releaseSignatureHelp(q){this.d.delete(q)}}class ue{constructor(q,W,Y,J,$e){this.f=q,this.g=W,this.h=Y,this.j=J,this.k=$e,this.d=new t.$Nhc("InlayHints"),this.e=new Map}async provideInlayHints(q,W,Y){const J=this.f.getDocument(q),$e=n.Range.to(W),ve=await this.h.provideInlayHints(J,$e,Y);if(!Array.isArray(ve)||ve.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(W)}`);return}if(Y.isCancellationRequested)return;const Fe=this.d.add(ve);this.e.set(Fe,new p.$Sc);const He={hints:[],cacheId:Fe};for(let Qe=0;Qe<ve.length;Qe++)this.l(ve[Qe],$e)&&He.hints.push(this.m(ve[Qe],[Fe,Qe]));return this.j.trace(`[InlayHints] ${He.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(W)}`),He}async resolveInlayHint(q,W){if(typeof this.h.resolveInlayHint!="function")return;const Y=this.d.get(...q);if(!Y)return;const J=await this.h.resolveInlayHint(Y,W);if(J&&this.l(J))return this.m(J,q)}releaseHints(q){this.e.get(q)?.dispose(),this.e.delete(q),this.d.delete(q)}l(q,W){return q.label.length===0||Array.isArray(q.label)&&q.label.every(Y=>Y.value.length===0)?(console.log("INVALID inlay hint, empty label",q),!1):!(W&&!W.contains(q.position))}m(q,W){const Y=this.e.get(W[0]);if(!Y)throw Error("DisposableStore is missing...");const J={label:"",cacheId:W,tooltip:n.MarkdownString.fromStrict(q.tooltip),position:n.Position.from(q.position),textEdits:q.textEdits&&q.textEdits.map(n.TextEdit.from),kind:q.kind&&n.InlayHintKind.from(q.kind),paddingLeft:q.paddingLeft,paddingRight:q.paddingRight};if(typeof q.label=="string")J.label=q.label;else{const $e=[];J.label=$e;for(const ve of q.label){if(!ve.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Fe={label:ve.value,tooltip:n.MarkdownString.fromStrict(ve.tooltip)};s.$hM.isLocation(ve.location)&&(Fe.location=n.location.from(ve.location)),ve.command&&(Fe.command=this.g.toInternal(ve.command,Y)),$e.push(Fe)}}return J}}class ce{constructor(q,W){this.e=q,this.f=W,this.d=new t.$Nhc("DocumentLink")}async provideLinks(q,W){const Y=this.e.getDocument(q),J=await this.f.provideDocumentLinks(Y,W);if(!(!Array.isArray(J)||J.length===0)&&!W.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:J.filter(ce.g).map(n.DocumentLink.from)};{const $e=this.d.add(J),ve={links:[],cacheId:$e};for(let Fe=0;Fe<J.length;Fe++){if(!ce.g(J[Fe]))continue;const He=n.DocumentLink.from(J[Fe]);He.cacheId=[$e,Fe],ve.links.push(He)}return ve}}}static g(q){return q.target&&q.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(q,W){if(typeof this.f.resolveDocumentLink!="function")return;const Y=this.d.get(...q);if(!Y)return;const J=await this.f.resolveDocumentLink(Y,W);if(!(!J||!ce.g(J)))return n.DocumentLink.from(J)}releaseLinks(q){this.d.delete(q)}}class de{constructor(q,W){this.d=q,this.e=W}async provideColors(q,W){const Y=this.d.getDocument(q),J=await this.e.provideDocumentColors(Y,W);return Array.isArray(J)?J.map(ve=>({color:n.Color.from(ve.color),range:n.Range.from(ve.range)})):[]}async provideColorPresentations(q,W,Y){const J=this.d.getDocument(q),$e=n.Range.to(W.range),ve=n.Color.to(W.color),Fe=await this.e.provideColorPresentations(ve,{document:J,range:$e},Y);if(Array.isArray(Fe))return Fe.map(n.ColorPresentation.from)}}class H{constructor(q,W){this.d=q,this.e=W}async provideFoldingRanges(q,W,Y){const J=this.d.getDocument(q),$e=await this.e.provideFoldingRanges(J,W,Y);if(Array.isArray($e))return $e.map(n.FoldingRange.from)}}class Z{constructor(q,W,Y){this.d=q,this.e=W,this.f=Y}async provideSelectionRanges(q,W,Y){const J=this.d.getDocument(q),$e=W.map(n.Position.to),ve=await this.e.provideSelectionRanges(J,$e,Y);if(!(0,l.$Lb)(ve))return[];if(ve.length!==$e.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Fe=[];for(let He=0;He<$e.length;He++){const Qe=[];Fe.push(Qe);let tt=$e[He],st=ve[He];for(;;){if(!st.range.contains(tt))throw new Error("INVALID selection range, must contain the previous range");if(Qe.push(n.SelectionRange.from(st)),!st.parent)break;tt=st.range,st=st.parent}}return Fe}}class he{constructor(q,W){this.f=q,this.g=W,this.d=new R.$qO(""),this.e=new Map}async prepareSession(q,W,Y){const J=this.f.getDocument(q),$e=n.Position.to(W),ve=await this.g.prepareCallHierarchy(J,$e,Y);if(!ve)return;const Fe=this.d.nextId();return this.e.set(Fe,new Map),Array.isArray(ve)?ve.map(He=>this.h(Fe,He)):[this.h(Fe,ve)]}async provideCallsTo(q,W,Y){const J=this.j(q,W);if(!J)throw new Error("missing call hierarchy item");const $e=await this.g.provideCallHierarchyIncomingCalls(J,Y);if($e)return $e.map(ve=>({from:this.h(q,ve.from),fromRanges:ve.fromRanges.map(Fe=>n.Range.from(Fe))}))}async provideCallsFrom(q,W,Y){const J=this.j(q,W);if(!J)throw new Error("missing call hierarchy item");const $e=await this.g.provideCallHierarchyOutgoingCalls(J,Y);if($e)return $e.map(ve=>({to:this.h(q,ve.to),fromRanges:ve.fromRanges.map(Fe=>n.Range.from(Fe))}))}releaseSession(q){this.e.delete(q)}h(q,W){const Y=this.e.get(q),J=n.CallHierarchyItem.from(W,q,Y.size.toString(36));return Y.set(J._itemId,W),J}j(q,W){return this.e.get(q)?.get(W)}}class be{constructor(q,W){this.f=q,this.g=W,this.d=new R.$qO(""),this.e=new Map}async prepareSession(q,W,Y){const J=this.f.getDocument(q),$e=n.Position.to(W),ve=await this.g.prepareTypeHierarchy(J,$e,Y);if(!ve)return;const Fe=this.d.nextId();return this.e.set(Fe,new Map),Array.isArray(ve)?ve.map(He=>this.h(Fe,He)):[this.h(Fe,ve)]}async provideSupertypes(q,W,Y){const J=this.j(q,W);if(!J)throw new Error("missing type hierarchy item");const $e=await this.g.provideTypeHierarchySupertypes(J,Y);if($e)return $e.map(ve=>this.h(q,ve))}async provideSubtypes(q,W,Y){const J=this.j(q,W);if(!J)throw new Error("missing type hierarchy item");const $e=await this.g.provideTypeHierarchySubtypes(J,Y);if($e)return $e.map(ve=>this.h(q,ve))}releaseSession(q){this.e.delete(q)}h(q,W){const Y=this.e.get(q),J=n.TypeHierarchyItem.from(W,q,Y.size.toString(36));return Y.set(J._itemId,W),J}j(q,W){return this.e.get(q)?.get(W)}}class Pe{static toInternalProviderId(q,W){return q+"."+W}constructor(q,W,Y,J,$e){this.d=q,this.e=W,this.f=Y,this.g=J,this.h=$e}async provideDocumentOnDropEdits(q,W,Y,J,$e){const ve=this.e.getDocument(W),Fe=n.Position.to(Y),He=n.DataTransfer.toDataTransfer(J,async tt=>(await this.d.$resolveDocumentOnDropFileData(this.g,q,tt)).buffer),Qe=await this.f.provideDocumentDropEdits(ve,Fe,He,$e);if(Qe)return{label:Qe.label??(0,o.localize)(1,null,this.h.displayName||this.h.name),yieldTo:Qe.yieldTo?.map(tt=>"mimeType"in tt?tt:{providerId:Pe.toInternalProviderId(tt.extensionId,tt.providerId)}),insertText:typeof Qe.insertText=="string"?Qe.insertText:{snippet:Qe.insertText.value},additionalEdit:Qe.additionalEdit?n.WorkspaceEdit.from(Qe.additionalEdit,void 0):void 0}}}class pe{constructor(q,W){this.d=q,this.e=W}async provideMappedEdits(q,W,Y,J){const $e=v.URI.revive(q),ve=this.d.getDocument($e),Fe=Y.documents.map(tt=>tt.map(st=>({uri:v.URI.revive(st.uri),version:st.version,ranges:st.ranges.map(ut=>n.Range.to(ut))}))),He={documents:Fe,selections:Fe[0]?.[0]?.ranges??[]},Qe=await this.e.provideMappedEdits(ve,W,He,J);return Qe?n.WorkspaceEdit.from(Qe):null}}class Ae{constructor(q,W){this.adapter=q,this.extension=W}}class Oe{static{this.d=0}constructor(q,W,Y,J,$e,ve,Fe,He){this.g=W,this.h=Y,this.j=J,this.k=$e,this.l=ve,this.m=Fe,this.n=He,this.f=new Map,this.e=q.getProxy(f.$6L.MainThreadLanguageFeatures)}o(q,W){return n.DocumentSelector.from(q,this.g,W)}p(q){return new s.$8L(()=>{this.f.delete(q),this.e.$unregister(q)})}q(){return Oe.d++}async s(q,W,Y,J,$e,ve=!1){const Fe=this.f.get(q);if(!Fe||!(Fe.adapter instanceof W))return J;const He=Date.now();ve||this.l.trace(`[${Fe.extension.identifier.value}] INVOKE provider '${Y.toString().replace(/[\r\n]/g,"")}'`);const Qe=Y(Fe.adapter,Fe.extension);return Promise.resolve(Qe).catch(tt=>{(0,A.$4)(tt)||(this.l.error(`[${Fe.extension.identifier.value}] provider FAILED`),this.l.error(tt),this.n.onExtensionError(Fe.extension.identifier,tt))}).finally(()=>{ve||this.l.trace(`[${Fe.extension.identifier.value}] provider DONE after ${Date.now()-He}ms`)}),L.CancellationToken.isCancellationToken($e)?(0,j.$7g)(Qe,$e):Qe}t(q,W){const Y=this.q();return this.f.set(Y,new Ae(q,W)),Y}static u(q){return q.displayName||q.name}registerDocumentSymbolProvider(q,W,Y,J){const $e=this.t(new h(this.h,Y),q),ve=J&&J.label||Oe.u(q);return this.e.$registerDocumentSymbolProvider($e,this.o(W,q),ve),this.p($e)}$provideDocumentSymbols(q,W,Y){return this.s(q,h,J=>J.provideDocumentSymbols(v.URI.revive(W),Y),void 0,Y)}registerCodeLensProvider(q,W,Y){const J=this.q(),$e=typeof Y.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(J,new Ae(new r(this.h,this.j.converter,Y,q,this.n,this.l),q)),this.e.$registerCodeLensSupport(J,this.o(W,q),$e);let ve=this.p(J);if($e!==void 0){const Fe=Y.onDidChangeCodeLenses(He=>this.e.$emitCodeLensEvent($e));ve=s.$8L.from(ve,Fe)}return ve}$provideCodeLenses(q,W,Y){return this.s(q,r,J=>J.provideCodeLenses(v.URI.revive(W),Y),void 0,Y)}$resolveCodeLens(q,W,Y){return this.s(q,r,J=>J.resolveCodeLens(W,Y),void 0,void 0)}$releaseCodeLenses(q,W){this.s(q,r,Y=>Promise.resolve(Y.releaseCodeLenses(W)),void 0,void 0)}registerDefinitionProvider(q,W,Y){const J=this.t(new d(this.h,Y),q);return this.e.$registerDefinitionSupport(J,this.o(W,q)),this.p(J)}$provideDefinition(q,W,Y,J){return this.s(q,d,$e=>$e.provideDefinition(v.URI.revive(W),Y,J),[],J)}registerDeclarationProvider(q,W,Y){const J=this.t(new $(this.h,Y),q);return this.e.$registerDeclarationSupport(J,this.o(W,q)),this.p(J)}$provideDeclaration(q,W,Y,J){return this.s(q,$,$e=>$e.provideDeclaration(v.URI.revive(W),Y,J),[],J)}registerImplementationProvider(q,W,Y){const J=this.t(new D(this.h,Y),q);return this.e.$registerImplementationSupport(J,this.o(W,q)),this.p(J)}$provideImplementation(q,W,Y,J){return this.s(q,D,$e=>$e.provideImplementation(v.URI.revive(W),Y,J),[],J)}registerTypeDefinitionProvider(q,W,Y){const J=this.t(new b(this.h,Y),q);return this.e.$registerTypeDefinitionSupport(J,this.o(W,q)),this.p(J)}$provideTypeDefinition(q,W,Y,J){return this.s(q,b,$e=>$e.provideTypeDefinition(v.URI.revive(W),Y,J),[],J)}registerHoverProvider(q,W,Y,J){const $e=this.t(new g(this.h,Y),q);return this.e.$registerHoverProvider($e,this.o(W,q)),this.p($e)}$provideHover(q,W,Y,J){return this.s(q,g,$e=>$e.provideHover(v.URI.revive(W),Y,J),void 0,J)}registerEvaluatableExpressionProvider(q,W,Y,J){const $e=this.t(new y(this.h,Y),q);return this.e.$registerEvaluatableExpressionProvider($e,this.o(W,q)),this.p($e)}$provideEvaluatableExpression(q,W,Y,J){return this.s(q,y,$e=>$e.provideEvaluatableExpression(v.URI.revive(W),Y,J),void 0,J)}registerInlineValuesProvider(q,W,Y,J){const $e=typeof Y.onDidChangeInlineValues=="function"?this.q():void 0,ve=this.t(new P(this.h,Y),q);this.e.$registerInlineValuesProvider(ve,this.o(W,q),$e);let Fe=this.p(ve);if($e!==void 0){const He=Y.onDidChangeInlineValues(Qe=>this.e.$emitInlineValuesEvent($e));Fe=s.$8L.from(Fe,He)}return Fe}$provideInlineValues(q,W,Y,J,$e){return this.s(q,P,ve=>ve.provideInlineValues(v.URI.revive(W),Y,J,$e),void 0,$e)}registerDocumentHighlightProvider(q,W,Y){const J=this.t(new N(this.h,Y),q);return this.e.$registerDocumentHighlightProvider(J,this.o(W,q)),this.p(J)}registerMultiDocumentHighlightProvider(q,W,Y){const J=this.t(new U(this.h,Y),q);return this.e.$registerMultiDocumentHighlightProvider(J,this.o(W,q)),this.p(J)}$provideDocumentHighlights(q,W,Y,J){return this.s(q,N,$e=>$e.provideDocumentHighlights(v.URI.revive(W),Y,J),void 0,J)}$provideMultiDocumentHighlights(q,W,Y,J,$e){return this.s(q,U,ve=>ve.provideMultiDocumentHighlights(v.URI.revive(W),Y,J.map(Fe=>v.URI.revive(Fe)),$e),void 0,$e)}registerLinkedEditingRangeProvider(q,W,Y){const J=this.t(new z(this.h,Y),q);return this.e.$registerLinkedEditingRangeProvider(J,this.o(W,q)),this.p(J)}$provideLinkedEditingRanges(q,W,Y,J){return this.s(q,z,async $e=>{const ve=await $e.provideLinkedEditingRanges(v.URI.revive(W),Y,J);if(ve)return{ranges:ve.ranges,wordPattern:ve.wordPattern?Oe.w(ve.wordPattern):void 0}},void 0,J)}registerReferenceProvider(q,W,Y){const J=this.t(new F(this.h,Y),q);return this.e.$registerReferenceSupport(J,this.o(W,q)),this.p(J)}$provideReferences(q,W,Y,J,$e){return this.s(q,F,ve=>ve.provideReferences(v.URI.revive(W),Y,J,$e),void 0,$e)}registerCodeActionProvider(q,W,Y,J){const $e=new p.$Sc,ve=this.t(new I(this.h,this.j.converter,this.k,Y,this.l,q,this.m),q);return this.e.$registerQuickFixSupport(ve,this.o(W,q),{providedKinds:J?.providedCodeActionKinds?.map(Fe=>Fe.value),documentation:J?.documentation?.map(Fe=>({kind:Fe.kind.value,command:this.j.converter.toInternal(Fe.command,$e)}))},Oe.u(q),!!Y.resolveCodeAction),$e.add(this.p(ve)),$e}$provideCodeActions(q,W,Y,J,$e){return this.s(q,I,ve=>ve.provideCodeActions(v.URI.revive(W),Y,J,$e),void 0,$e)}$resolveCodeAction(q,W,Y){return this.s(q,I,J=>J.resolveCodeAction(W,Y),{},void 0)}$releaseCodeActions(q,W){this.s(q,I,Y=>Promise.resolve(Y.releaseCodeActions(W)),void 0,void 0)}registerDocumentFormattingEditProvider(q,W,Y){const J=this.t(new T(this.h,Y),q);return this.e.$registerDocumentFormattingSupport(J,this.o(W,q),q.identifier,q.displayName||q.name),this.p(J)}$provideDocumentFormattingEdits(q,W,Y,J){return this.s(q,T,$e=>$e.provideDocumentFormattingEdits(v.URI.revive(W),Y,J),void 0,J)}registerDocumentRangeFormattingEditProvider(q,W,Y){const J=typeof Y.provideDocumentRangesFormattingEdits=="function",$e=this.t(new G(this.h,Y),q);return this.e.$registerRangeFormattingSupport($e,this.o(W,q),q.identifier,q.displayName||q.name,J),this.p($e)}$provideDocumentRangeFormattingEdits(q,W,Y,J,$e){return this.s(q,G,ve=>ve.provideDocumentRangeFormattingEdits(v.URI.revive(W),Y,J,$e),void 0,$e)}$provideDocumentRangesFormattingEdits(q,W,Y,J,$e){return this.s(q,G,ve=>ve.provideDocumentRangesFormattingEdits(v.URI.revive(W),Y,J,$e),void 0,$e)}registerOnTypeFormattingEditProvider(q,W,Y,J){const $e=this.t(new te(this.h,Y),q);return this.e.$registerOnTypeFormattingSupport($e,this.o(W,q),J,q.identifier),this.p($e)}$provideOnTypeFormattingEdits(q,W,Y,J,$e,ve){return this.s(q,te,Fe=>Fe.provideOnTypeFormattingEdits(v.URI.revive(W),Y,J,$e,ve),void 0,ve)}registerWorkspaceSymbolProvider(q,W){const Y=this.t(new x(W,this.l),q);return this.e.$registerNavigateTypeSupport(Y,typeof W.resolveWorkspaceSymbol=="function"),this.p(Y)}$provideWorkspaceSymbols(q,W,Y){return this.s(q,x,J=>J.provideWorkspaceSymbols(W,Y),{symbols:[]},Y)}$resolveWorkspaceSymbol(q,W,Y){return this.s(q,x,J=>J.resolveWorkspaceSymbol(W,Y),void 0,void 0)}$releaseWorkspaceSymbols(q,W){this.s(q,x,Y=>Y.releaseWorkspaceSymbols(W),void 0,void 0)}registerRenameProvider(q,W,Y){const J=this.t(new X(this.h,Y,this.l),q);return this.e.$registerRenameSupport(J,this.o(W,q),X.supportsResolving(Y)),this.p(J)}$provideRenameEdits(q,W,Y,J,$e){return this.s(q,X,ve=>ve.provideRenameEdits(v.URI.revive(W),Y,J,$e),void 0,$e)}$resolveRenameLocation(q,W,Y,J){return this.s(q,X,$e=>$e.resolveRenameLocation(v.URI.revive(W),Y,J),void 0,J)}registerNewSymbolNamesProvider(q,W,Y){const J=this.t(new Q(this.h,Y,this.l),q);return this.e.$registerNewSymbolNamesProvider(J,this.o(W,q)),this.p(J)}$provideNewSymbolNames(q,W,Y,J){return this.s(q,Q,$e=>$e.provideNewSymbolNames(v.URI.revive(W),Y,J),void 0,J)}registerDocumentSemanticTokensProvider(q,W,Y,J){const $e=this.t(new _(this.h,Y),q),ve=typeof Y.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider($e,this.o(W,q),J,ve);let Fe=this.p($e);if(ve){const He=Y.onDidChangeSemanticTokens(Qe=>this.e.$emitDocumentSemanticTokensEvent(ve));Fe=s.$8L.from(Fe,He)}return Fe}$provideDocumentSemanticTokens(q,W,Y,J){return this.s(q,_,$e=>$e.provideDocumentSemanticTokens(v.URI.revive(W),Y,J),null,J)}$releaseDocumentSemanticTokens(q,W){this.s(q,_,Y=>Y.releaseDocumentSemanticColoring(W),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(q,W,Y,J){const $e=this.t(new ge(this.h,Y),q);return this.e.$registerDocumentRangeSemanticTokensProvider($e,this.o(W,q),J),this.p($e)}$provideDocumentRangeSemanticTokens(q,W,Y,J){return this.s(q,ge,$e=>$e.provideDocumentRangeSemanticTokens(v.URI.revive(W),Y,J),null,J)}registerCompletionItemProvider(q,W,Y,J){const $e=this.t(new se(this.h,this.j.converter,Y,this.m,q),q);return this.e.$registerCompletionsProvider($e,this.o(W,q),J,se.supportsResolving(Y),q.identifier),this.p($e)}$provideCompletionItems(q,W,Y,J,$e){return this.s(q,se,ve=>ve.provideCompletionItems(v.URI.revive(W),Y,J,$e),void 0,$e)}$resolveCompletionItem(q,W,Y){return this.s(q,se,J=>J.resolveCompletionItem(W,Y),void 0,Y)}$releaseCompletionItems(q,W){this.s(q,se,Y=>Y.releaseCompletionItems(W),void 0,void 0)}registerInlineCompletionsProvider(q,W,Y,J){const $e=new B(q,this.h,Y,this.j.converter),ve=this.t($e,q);return this.e.$registerInlineCompletionsSupport(ve,this.o(W,q),$e.supportsHandleEvents,i.$zm.toKey(q.identifier.value),J?.yieldTo?.map(Fe=>i.$zm.toKey(Fe))||[]),this.p(ve)}$provideInlineCompletions(q,W,Y,J,$e){return this.s(q,re,ve=>ve.provideInlineCompletions(v.URI.revive(W),Y,J,$e),void 0,$e)}$handleInlineCompletionDidShow(q,W,Y,J){this.s(q,re,async $e=>{$e.handleDidShowCompletionItem(W,Y,J)},void 0,void 0)}$handleInlineCompletionPartialAccept(q,W,Y,J){this.s(q,re,async $e=>{$e.handlePartialAccept(W,Y,J)},void 0,void 0)}$freeInlineCompletionsList(q,W){this.s(q,re,async Y=>{Y.disposeCompletions(W)},void 0,void 0)}registerInlineEditProvider(q,W,Y){const J=new ie(q,this.h,Y,this.j.converter),$e=this.t(J,q);return this.e.$registerInlineEditProvider($e,this.o(W,q),q.identifier),this.p($e)}$provideInlineEdit(q,W,Y,J){return this.s(q,ie,$e=>$e.provideInlineEdits(v.URI.revive(W),Y,J),void 0,J)}$freeInlineEdit(q,W){this.s(q,ie,async Y=>{Y.disposeEdit(W)},void 0,void 0)}registerSignatureHelpProvider(q,W,Y,J){const $e=Array.isArray(J)?{triggerCharacters:J,retriggerCharacters:[]}:J,ve=this.t(new le(this.h,Y),q);return this.e.$registerSignatureHelpProvider(ve,this.o(W,q),$e),this.p(ve)}$provideSignatureHelp(q,W,Y,J,$e){return this.s(q,le,ve=>ve.provideSignatureHelp(v.URI.revive(W),Y,J,$e),void 0,$e)}$releaseSignatureHelp(q,W){this.s(q,le,Y=>Y.releaseSignatureHelp(W),void 0,void 0)}registerInlayHintsProvider(q,W,Y){const J=typeof Y.onDidChangeInlayHints=="function"?this.q():void 0,$e=this.t(new ue(this.h,this.j.converter,Y,this.l,q),q);this.e.$registerInlayHintsProvider($e,this.o(W,q),typeof Y.resolveInlayHint=="function",J,Oe.u(q));let ve=this.p($e);if(J!==void 0){const Fe=Y.onDidChangeInlayHints(He=>this.e.$emitInlayHintsEvent(J));ve=s.$8L.from(ve,Fe)}return ve}$provideInlayHints(q,W,Y,J){return this.s(q,ue,$e=>$e.provideInlayHints(v.URI.revive(W),Y,J),void 0,J)}$resolveInlayHint(q,W,Y){return this.s(q,ue,J=>J.resolveInlayHint(W,Y),void 0,Y)}$releaseInlayHints(q,W){this.s(q,ue,Y=>Y.releaseHints(W),void 0,void 0)}registerDocumentLinkProvider(q,W,Y){const J=this.t(new ce(this.h,Y),q);return this.e.$registerDocumentLinkProvider(J,this.o(W,q),typeof Y.resolveDocumentLink=="function"),this.p(J)}$provideDocumentLinks(q,W,Y){return this.s(q,ce,J=>J.provideLinks(v.URI.revive(W),Y),void 0,Y,W.scheme==="output")}$resolveDocumentLink(q,W,Y){return this.s(q,ce,J=>J.resolveLink(W,Y),void 0,void 0,!0)}$releaseDocumentLinks(q,W){this.s(q,ce,Y=>Y.releaseLinks(W),void 0,void 0,!0)}registerColorProvider(q,W,Y){const J=this.t(new de(this.h,Y),q);return this.e.$registerDocumentColorProvider(J,this.o(W,q)),this.p(J)}$provideDocumentColors(q,W,Y){return this.s(q,de,J=>J.provideColors(v.URI.revive(W),Y),[],Y)}$provideColorPresentations(q,W,Y,J){return this.s(q,de,$e=>$e.provideColorPresentations(v.URI.revive(W),Y,J),void 0,J)}registerFoldingRangeProvider(q,W,Y){const J=this.q(),$e=typeof Y.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(J,new Ae(new H(this.h,Y),q)),this.e.$registerFoldingRangeProvider(J,this.o(W,q),q.identifier,$e);let ve=this.p(J);if($e!==void 0){const Fe=Y.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent($e));ve=s.$8L.from(ve,Fe)}return ve}$provideFoldingRanges(q,W,Y,J){return this.s(q,H,$e=>$e.provideFoldingRanges(v.URI.revive(W),Y,J),void 0,J)}registerSelectionRangeProvider(q,W,Y){const J=this.t(new Z(this.h,Y,this.l),q);return this.e.$registerSelectionRangeProvider(J,this.o(W,q)),this.p(J)}$provideSelectionRanges(q,W,Y,J){return this.s(q,Z,$e=>$e.provideSelectionRanges(v.URI.revive(W),Y,J),[],J)}registerCallHierarchyProvider(q,W,Y){const J=this.t(new he(this.h,Y),q);return this.e.$registerCallHierarchyProvider(J,this.o(W,q)),this.p(J)}$prepareCallHierarchy(q,W,Y,J){return this.s(q,he,$e=>Promise.resolve($e.prepareSession(v.URI.revive(W),Y,J)),void 0,J)}$provideCallHierarchyIncomingCalls(q,W,Y,J){return this.s(q,he,$e=>$e.provideCallsTo(W,Y,J),void 0,J)}$provideCallHierarchyOutgoingCalls(q,W,Y,J){return this.s(q,he,$e=>$e.provideCallsFrom(W,Y,J),void 0,J)}$releaseCallHierarchy(q,W){this.s(q,he,Y=>Promise.resolve(Y.releaseSession(W)),void 0,void 0)}registerTypeHierarchyProvider(q,W,Y){const J=this.t(new be(this.h,Y),q);return this.e.$registerTypeHierarchyProvider(J,this.o(W,q)),this.p(J)}$prepareTypeHierarchy(q,W,Y,J){return this.s(q,be,$e=>Promise.resolve($e.prepareSession(v.URI.revive(W),Y,J)),void 0,J)}$provideTypeHierarchySupertypes(q,W,Y,J){return this.s(q,be,$e=>$e.provideSupertypes(W,Y,J),void 0,J)}$provideTypeHierarchySubtypes(q,W,Y,J){return this.s(q,be,$e=>$e.provideSubtypes(W,Y,J),void 0,J)}$releaseTypeHierarchy(q,W){this.s(q,be,Y=>Promise.resolve(Y.releaseSession(W)),void 0,void 0)}registerDocumentOnDropEditProvider(q,W,Y,J){const $e=this.q();this.f.set($e,new Ae(new Pe(this.e,this.h,Y,$e,q),q));const ve=(0,c.$XF)(q,"dropMetadata")&&J?Pe.toInternalProviderId(q.identifier.value,J.id):void 0;return this.e.$registerDocumentOnDropEditProvider($e,this.o(W,q),ve,(0,c.$XF)(q,"dropMetadata")?J:void 0),this.p($e)}$provideDocumentOnDropEdits(q,W,Y,J,$e,ve){return this.s(q,Pe,Fe=>Promise.resolve(Fe.provideDocumentOnDropEdits(W,v.URI.revive(Y),J,$e,ve)),void 0,void 0)}registerMappedEditsProvider(q,W,Y){const J=this.t(new pe(this.h,Y),q);return this.e.$registerMappedEditsProvider(J,this.o(W,q)),this.p(J)}$provideMappedEdits(q,W,Y,J,$e){return this.s(q,pe,ve=>Promise.resolve(ve.provideMappedEdits(W,Y,J,$e)),null,$e)}registerDocumentPasteEditProvider(q,W,Y,J){const $e=this.q();this.f.set($e,new Ae(new O(this.e,this.h,Y,$e,q),q));const ve=O.toInternalProviderId(q.identifier.value,J.id);return this.e.$registerPasteEditProvider($e,this.o(W,q),ve,{supportsCopy:!!Y.prepareDocumentPaste,supportsPaste:!!Y.provideDocumentPasteEdits,copyMimeTypes:J.copyMimeTypes,pasteMimeTypes:J.pasteMimeTypes}),this.p($e)}$prepareDocumentPaste(q,W,Y,J,$e){return this.s(q,O,ve=>ve.prepareDocumentPaste(v.URI.revive(W),Y,J,$e),void 0,$e)}$providePasteEdits(q,W,Y,J,$e,ve){return this.s(q,O,Fe=>Fe.providePasteEdits(W,v.URI.revive(Y),J,$e,ve),void 0,ve)}static w(q){return{pattern:q.source,flags:q.flags}}static y(q){return{decreaseIndentPattern:Oe.w(q.decreaseIndentPattern),increaseIndentPattern:Oe.w(q.increaseIndentPattern),indentNextLinePattern:q.indentNextLinePattern?Oe.w(q.indentNextLinePattern):void 0,unIndentedLinePattern:q.unIndentedLinePattern?Oe.w(q.unIndentedLinePattern):void 0}}static z(q){return{beforeText:Oe.w(q.beforeText),afterText:q.afterText?Oe.w(q.afterText):void 0,previousLineText:q.previousLineText?Oe.w(q.previousLineText):void 0,action:q.action}}static B(q){return q.map(Oe.z)}static C(q){return{open:q.open,close:q.close,notIn:q.notIn?q.notIn.map(W=>s.SyntaxTokenType.toString(W)):void 0}}static D(q){return q.map(Oe.C)}setLanguageConfiguration(q,W,Y){const{wordPattern:J}=Y;if(J&&(0,M.$8e)(J))throw new Error(`Invalid language configuration: wordPattern '${J}' is not allowed to match the empty string.`);J?this.h.setWordDefinitionFor(W,J):this.h.setWordDefinitionFor(W,void 0),Y.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",q,"Do not use."),Y.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",q,"Do not use.");const $e=this.q(),ve={comments:Y.comments,brackets:Y.brackets,wordPattern:Y.wordPattern?Oe.w(Y.wordPattern):void 0,indentationRules:Y.indentationRules?Oe.y(Y.indentationRules):void 0,onEnterRules:Y.onEnterRules?Oe.B(Y.onEnterRules):void 0,__electricCharacterSupport:Y.__electricCharacterSupport,__characterPairSupport:Y.__characterPairSupport,autoClosingPairs:Y.autoClosingPairs?Oe.D(Y.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration($e,W,ve),this.p($e)}$setWordDefinitions(q){for(const W of q)this.h.setWordDefinitionFor(W.languageId,new RegExp(W.regexSource,W.regexFlags))}}e.$Xhc=Oe}),define(Se[121],De([1,0,3,6,16,7,108,25,8,4,219,145,13,5,20,120,12]),function(fe,e,l,j,L,A,R,p,w,E,M,C,v,S,k,u,m){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$6hc=e.$5hc=void 0,e.$5hc=(0,S.$fi)("IExtHostLanguageModels");class i{constructor(t,f){this.option=t,this.stream=new w.$Ih,this.stream=f??new w.$Ih}}class n{constructor(){this.a=new Map,this.b=new w.$Ih,this.c=!1,this.d=!1;const t=this;this.apiObject={stream:t.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,t]of this.a)yield t.stream;else yield this.b}handleFragment(t){if(this.c)return;this.d=!0;let f=this.a.get(t.index);f||(this.a.size===0?f=new i(t.index,this.b):f=new i(t.index),this.a.set(t.index,f)),f.stream.emitOne(t.part)}get isStreaming(){return this.d}reject(t){this.c=!0;for(const f of this.f())f.reject(t)}resolve(){this.c=!0;for(const t of this.f())t.resolve()}}let s=class{static{o=this}static{this.a=1}constructor(t,f,h){this.j=f,this.k=h,this.c=new E.$5d,this.d=new E.$5d,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new p.$Bm,this.i=new Map,this.o=new Set,this.b=t.getProxy(j.$6L.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(t,f,h,r){const a=o.a++;this.f.set(a,{extension:t.identifier,provider:h,languageModelId:f});let d;return r.auth&&(d={providerLabel:t.displayName||t.name,accountLabel:typeof r.auth=="object"?r.auth.label:void 0}),this.b.$registerLanguageModelProvider(a,f,{extension:t.identifier,identifier:f,model:r.name??"",auth:d}),(0,l.$Rc)(()=>{this.f.delete(a),this.b.$unregisterProvider(a)})}async $provideLanguageModelResponse(t,f,h,r,a,d){const $=this.f.get(t);if(!$)return;const D=new R.$Kv(async b=>{if(d.isCancellationRequested){this.j.warn(`[CHAT](${$.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(f,{index:b.index,part:b.part})});return $.provider.provideLanguageModelResponse2(r.map(L.LanguageModelMessage.to),a,p.$zm.toKey(h),D,d)}$updateLanguageModels(t){const f=[],h=[];if(t.added)for(const r of t.added)this.g.set(r.identifier,r),f.push(r.model);if(t.removed)for(const r of t.removed){this.g.delete(r),h.push(r);for(const[a,d]of this.i)d.languageModelId===r&&(d.res.reject(new v.$5),this.i.delete(a))}this.d.fire(Object.freeze({added:Object.freeze(f),removed:Object.freeze(h)})),t.added?.forEach(this.n,this)}getLanguageModelIds(){return Array.from(this.g.keys())}$updateModelAccesslist(t){const f=new Array;for(const{from:h,to:r,enabled:a}of t){const d=this.h.get(h)??new p.$Am;if(d.has(r)!==a){a?d.add(r):d.delete(r),this.h.set(h,d);const D={from:h,to:r};f.push(D),this.c.fire(D)}}}async sendChatRequest(t,f,h,r,a){const d=t.identifier,$=await this.b.$prepareChatAccess(d,f,r.justification);if(!$||!this.g.has(f))throw A.$_N.NotFound(`Language model '${f}' is unknown.`);if(this.m(d,$)&&(!await this.l(t,{identifier:$.extension,displayName:$.auth.providerLabel},r.justification,r.silent)||!this.h.get(d)?.has($.extension)))throw A.$_N.NoPermissions(`Language model '${f}' cannot be used by '${d.value}'.`);const D=Math.random()*1e6|0,b=this.b.$fetchResponse(d,f,D,h.map(L.LanguageModelMessage.from),r.modelOptions??{},a),g=new w.$eh,y=new n;this.i.set(D,{languageModelId:f,res:y});let P;if(b.catch(N=>{g.isOpen()?y.reject(N):P=N}).finally(()=>{this.i.delete(D),y.resolve(),g.open()}),await g.wait(),P)throw new A.$_N(`Language model '${f}' errored, check cause for more details`,"Unknown",P);return y.apiObject}async $handleResponseFragment(t,f){const h=this.i.get(t);h&&h.res.handleFragment(f)}async l(t,f,h,r){const a=C.$_K+f.identifier.value;if(await this.k.getSession(t,a,[],{silent:!0}))return this.$updateModelAccesslist([{from:t.identifier,to:f.identifier,enabled:!0}]),!0;if(r)return!1;try{const $=h?(0,M.localize)(0,null,f.displayName,h):(0,M.localize)(1,null,f.displayName);return await this.k.getSession(t,a,[],{forceNewSession:{detail:$}}),this.$updateModelAccesslist([{from:t.identifier,to:f.identifier,enabled:!0}]),!0}catch{return!1}}m(t,f){return!!f.auth&&!p.$zm.equals(f.extension,t)}async n(t){for(const f of this.o)try{await this.l(f,{identifier:t.extension,displayName:""},void 0,!0)}catch(h){this.j.error("Fake Auth request failed"),this.j.error(h)}}createLanguageModelAccessInformation(t){this.o.add(t);const f=this,h=E.Event.signal(E.Event.filter(this.c.event,a=>p.$zm.equals(a.from,t.identifier))),r=E.Event.signal(this.d.event);return{get onDidChange(){return E.Event.any(h,r)},canSendRequest(a){const d=f.g.get(a);if(!d)return;if(!f.m(t.identifier,d))return!0;const $=f.h.get(t.identifier);if($)return $.has(d.extension)}}}};e.$6hc=s,e.$6hc=s=o=Ye([Ve(0,k.$lO),Ve(1,m.$zj),Ve(2,u.$Zhc)],s)}),define(Se[334],De([1,0,6,16,7,39,8,3,26]),function(fe,e,l,j,L,A,R,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mjc=void 0;class E{constructor(C,v,S,k){this.c=v,this.d=S,this.e=k,this.b=[],this.f=0,this.g=new Set,this.a=C.getProxy(l.$6L.MainThreadLanguages)}$acceptLanguageIds(C){this.b=C}async getLanguages(){return this.b.slice(0)}async changeLanguage(C,v){await this.a.$changeLanguage(C,v);const S=this.c.getDocumentData(C);if(!S)throw new Error(`document '${C.toString()}' NOT found`);return S.document}async tokenAtPosition(C,v){const S=C.version,k=j.Position.from(v),u=await this.a.$tokensAtPosition(C.uri,k),m={type:L.StandardTokenType.Other,range:C.getWordRangeAtPosition(v)??new L.$0L(v.line,v.character,v.line,v.character)};if(!u)return m;const o={range:j.Range.to(u.range),type:j.TokenType.to(u.type)};return!o.range.contains(v)||S!==C.version?m:o}createLanguageStatusItem(C,v,S){const k=this.f++,u=this.a,m=this.g,o=`${C.identifier.value}/${v}`;if(m.has(o))throw new Error(`LanguageStatusItem with id '${v}' ALREADY exists`);m.add(o);const i={selector:S,id:v,name:C.displayName??C.name,severity:L.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let n;const s=new p.$Sc,c=()=>{if(n?.dispose(),!m.has(o)){console.warn(`LanguageStatusItem (${v}) from ${C.identifier.value} has been disposed and CANNOT be updated anymore`);return}n=(0,R.$hh)(()=>{s.clear(),this.a.$setLanguageStatus(k,{id:o,name:i.name??C.displayName??C.name,source:C.displayName??C.name,selector:j.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===L.LanguageStatusSeverity.Error?A.default.Error:i.severity===L.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:i.command&&this.d.toInternal(i.command,s),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},t={dispose(){s.dispose(),n?.dispose(),u.$removeLanguageStatus(k),m.delete(o)},get id(){return i.id},get name(){return i.name},set name(f){i.name=f,c()},get selector(){return i.selector},set selector(f){i.selector=f,c()},get text(){return i.text},set text(f){i.text=f,c()},set text2(f){(0,w.$YF)(C,"languageStatusText"),i.text=f,c()},get text2(){return(0,w.$YF)(C,"languageStatusText"),i.text},get detail(){return i.detail},set detail(f){i.detail=f,c()},get severity(){return i.severity},set severity(f){i.severity=f,c()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(f){i.accessibilityInformation=f,c()},get command(){return i.command},set command(f){i.command=f,c()},get busy(){return i.busy},set busy(f){i.busy=f,c()}};return c(),t}}e.$mjc=E}),define(Se[335],De([1,0,15,2,16,7,119]),function(fe,e,l,j,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ic=e.$0ic=void 0;class p{constructor(C,v,S,k){this.start=C,this.deletedCount=v,this.deletedItems=S,this.items=k}asApiEvent(){return{range:new A.$vN(this.start,this.start+this.deletedCount),addedCells:this.items.map(C=>C.apiCell),removedCells:this.deletedItems}}}class w{static asModelAddData(C){return{EOL:C.eol,lines:C.source,languageId:C.language,uri:C.uri,isDirty:!1,versionId:1}}constructor(C,v,S){this.notebook=C,this.h=v,this.j=S,this.handle=S.handle,this.uri=j.URI.revive(S.uri),this.cellKind=S.cellKind,this.a=S.outputs.map(L.NotebookCellOutput.to),this.e=S.internalMetadata??{},this.b=Object.freeze(S.metadata??{}),this.d=Object.freeze(L.NotebookCellExecutionSummary.to(S.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const C=this,v=this.h.getDocument(this.uri);if(!v)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const S={get index(){return C.notebook.getCellIndex(C)},notebook:C.notebook.apiNotebook,kind:L.NotebookCellKind.to(this.j.cellKind),document:v.document,get mime(){return C.g},set mime(k){C.g=k},get outputs(){return C.a.slice(0)},get metadata(){return C.b},get executionSummary(){return C.d}};this.f=Object.freeze(S)}return this.f}setOutputs(C){this.a=C.map(L.NotebookCellOutput.to)}setOutputItems(C,v,S){const k=S.map(L.NotebookCellOutputItem.to),u=this.a.find(m=>m.id===C);if(u&&(v||(u.items.length=0),u.items.push(...k),u.items.length>1&&u.items.every(m=>R.$6J(m.mime)))){const m=new Map,o=[];u.items.forEach(i=>{let n;m.has(i.mime)?n=m.get(i.mime):(n=[],m.set(i.mime,n),o.push(i.mime)),n.push(i.data)}),u.items.length=0,o.forEach(i=>{const n=R.$7J(m.get(i));u.items.push({mime:i,data:n.data.buffer})})}}setMetadata(C){this.b=Object.freeze(C)}setInternalMetadata(C){this.e=C,this.d=Object.freeze(L.NotebookCellExecutionSummary.to(C))}setMime(C){}}e.$0ic=w;class E{static{this.a=0}constructor(C,v,S,k,u){this.k=C,this.l=v,this.m=S,this.uri=k,this.handle=E.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=u.viewType,this.f=Object.freeze(u.metadata??Object.create(null)),this.r([[0,0,u.cells]],!0,void 0),this.g=u.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const C=this,v={get uri(){return C.uri},get version(){return C.g},get notebookType(){return C.d},get isDirty(){return C.h},get isUntitled(){return C.uri.scheme===l.Schemas.untitled},get isClosed(){return C.j},get metadata(){return C.f},get cellCount(){return C.b.length},cellAt(S){return S=C.n(S),C.b[S].apiCell},getCells(S){return(S?C.p(S):C.b).map(u=>u.apiCell)},save(){return C.q()}};this.e=Object.freeze(v)}return this.e}acceptDocumentPropertiesChanged(C){C.metadata&&(this.f=Object.freeze({...this.f,...C.metadata}))}acceptDirty(C){this.h=C}acceptModelChanged(C,v,S){this.g=C.versionId,this.h=v,this.acceptDocumentPropertiesChanged({metadata:S});const k={notebook:this.apiNotebook,metadata:S,cellChanges:[],contentChanges:[]},u=[];for(const o of C.rawEvents)o.kind===R.NotebookCellsChangeType.ModelChange?this.r(o.changes,!1,k.contentChanges):o.kind===R.NotebookCellsChangeType.Move?this.s(o.index,o.length,o.newIdx,k.contentChanges):o.kind===R.NotebookCellsChangeType.Output?(this.t(o.index,o.outputs),u.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===R.NotebookCellsChangeType.OutputItem?(this.u(o.index,o.outputId,o.append,o.outputItems),u.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(o.index,o.language),u.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document})):o.kind===R.NotebookCellsChangeType.ChangeCellContent?u.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document}):o.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(o.index,o.mime):o.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(o.index,o.metadata),u.push({cell:this.b[o.index].apiCell,metadata:this.b[o.index].apiCell.metadata})):o.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(o.index,o.internalMetadata),u.push({cell:this.b[o.index].apiCell,executionSummary:this.b[o.index].apiCell.executionSummary}));const m=new Map;for(let o=0;o<u.length;o++){const i=u[o],n=m.get(i.cell);if(n===void 0){const s=k.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...i});m.set(i.cell,s-1)}else k.cellChanges[n]={...k.cellChanges[n],...i}}return Object.freeze(k),Object.freeze(k.cellChanges),Object.freeze(k.contentChanges),k}n(C){return C=C|0,C<0?0:C>=this.b.length?this.b.length-1:C}o(C){let v=C.start|0,S=C.end|0;return v<0&&(v=0),S>this.b.length&&(S=this.b.length),C.with({start:v,end:S})}p(C){C=this.o(C);const v=[];for(let S=C.start;S<C.end;S++)v.push(this.b[S]);return v}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(C,v,S){if(this.j)return;const k=[],u=[],m=[];if(C.reverse().forEach(o=>{const n=o[2].map(t=>{const f=new w(this,this.l,t);return v||u.push(w.asModelAddData(t)),f}),s=new p(o[0],o[1],[],n),c=this.b.splice(o[0],o[1],...n);for(const t of c)m.push(t.uri),s.deletedItems.push(t.apiCell);k.push(s)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:u,removedDocuments:m}),S)for(const o of k)S.push(o.asApiEvent())}s(C,v,S,k){const u=this.b.splice(C,v);this.b.splice(S,0,...u);const m=[new p(C,v,u.map(o=>o.apiCell),[]),new p(S,0,[],u)];for(const o of m)k.push(o.asApiEvent())}t(C,v){this.b[C].setOutputs(v)}u(C,v,S,k){this.b[C].setOutputItems(v,S,k)}v(C,v){const S=this.b[C];S.apiCell.document.languageId!==v&&this.m.$acceptModelLanguageChanged(S.uri,v)}w(C,v){const S=this.b[C];S.apiCell.mime=v}x(C,v){this.b[C].setMetadata(v)}y(C,v){this.b[C].setInternalMetadata(v)}getCellFromApiCell(C){return this.b.find(v=>v.apiCell===C)}getCellFromIndex(C){return this.b[C]}getCell(C){if(j.URI.isUri(C)){const v=R.CellUri.parse(C);if(!v||v.notebook.toString()!==this.uri.toString())return;C=v.handle}return this.b.find(v=>v.handle===C)}getCellIndex(C){return this.b.indexOf(C)}}e.$$ic=E}),define(Se[336],De([1,0,4,2,16,7]),function(fe,e,l,j,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ojc=void 0;class R{constructor(w,E,M,C={timeout:1500,errors:3}){this.b=w,this.c=E,this.d=M,this.f=C,this.a=new l.$7d}dispose(){}getOnWillSaveNotebookDocumentEvent(w){return(E,M,C)=>{const v=function(k){E.call(M,k)};return v.extension=w,this.a.event(v,void 0,C)}}async $participateInSave(w,E,M){const C=j.URI.revive(w),v=this.c.getNotebookDocument(C);if(!v)throw new Error("Unable to resolve notebook document");const S=[];if(await this.a.fireAsync({notebook:v.apiNotebook,reason:L.TextDocumentSaveReason.to(E)},M,async(u,m)=>{const o=Date.now(),i=await await Promise.resolve(u);Date.now()-o>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",m.extension.identifier),!M.isCancellationRequested&&i&&(i instanceof A.$fM?S.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",m.extension.identifier,"ignored due to invalid data"))}),M.isCancellationRequested)return!1;if(S.length===0)return!0;const k={edits:[]};for(const u of S){const{edits:m}=L.WorkspaceEdit.from(u);k.edits=k.edits.concat(m)}return this.d.$tryApplyWorkspaceEdit(k)}}e.$ojc=R}),define(Se[153],De([1,0,13,16,7]),function(fe,e,l,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_ic=void 0;class A{static{this.apiEditorsToExtHost=new WeakMap}constructor(p,w,E,M,C,v){this.id=p,this.f=w,this.notebookData=E,this.a=[],this.b=[],this.d=!1,this.a=C,this.b=M,this.c=v}get apiEditor(){if(!this.e){const p=this;this.e={get notebook(){return p.notebookData.apiNotebook},get selection(){return p.a[0]},set selection(w){this.selections=[w]},get selections(){return p.a},set selections(w){if(!Array.isArray(w)||!w.every(L.$vN.isNotebookRange))throw(0,l.$7)("selections");p.a=w,p.g(w)},get visibleRanges(){return p.b},revealRange(w,E){p.f.$tryRevealRange(p.id,j.NotebookRange.from(w),E??L.NotebookEditorRevealType.Default)},get viewColumn(){return p.c}},A.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(p){this.d=p}_acceptVisibleRanges(p){this.b=p}_acceptSelections(p){this.a=p}g(p){this.f.$trySetSelections(this.id,p.map(j.NotebookRange.from))}_acceptViewColumn(p){this.c=p}}e.$_ic=A}),define(Se[337],De([1,0,4,12,16]),function(fe,e,l,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qjc=void 0;let A=class{constructor(p,w){this.c=p,this.d=w,this.a=new l.$5d,this.b=new l.$5d,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(p,w){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",p,w);const E=this.d.getEditorById(p);w.visibleRanges&&E._acceptVisibleRanges(w.visibleRanges.ranges.map(L.NotebookRange.to)),w.selections&&E._acceptSelections(w.selections.selections.map(L.NotebookRange.to)),w.visibleRanges&&this.b.fire({notebookEditor:E.apiEditor,visibleRanges:E.apiEditor.visibleRanges}),w.selections&&this.a.fire(Object.freeze({notebookEditor:E.apiEditor,selections:E.apiEditor.selections}))}$acceptEditorViewColumns(p){for(const w in p)this.d.getEditorById(w)._acceptViewColumn(L.ViewColumn.to(p[w]))}};e.$qjc=A,e.$qjc=A=Ye([Ve(0,j.$zj)],A)}),define(Se[338],De([1,0,4,6,153]),function(fe,e,l,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tjc=void 0;class A{constructor(p,w){this.c=w,this.a=new Map,this.b=p.getProxy(j.$6L.MainThreadNotebookRenderers)}$postRendererMessage(p,w,E){const M=this.c.getEditorById(p);this.a.get(w)?.fire({editor:M.apiEditor,message:E})}createRendererMessaging(p,w){if(!p.contributes?.notebookRenderer?.some(M=>M.id===w))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${w})`);return{onDidReceiveMessage:(M,C,v)=>this.d(w).event(M,C,v),postMessage:(M,C)=>{L.$_ic.apiEditorsToExtHost.has(M)&&([M,C]=[C,M]);const v=C&&L.$_ic.apiEditorsToExtHost.get(C);return this.b.$postMessage(v?.id,w,M)}}}d(p){let w=this.a.get(p);return w||(w=new l.$5d({onDidRemoveLastListener:()=>{w?.dispose(),this.a.delete(p)}}),this.a.set(p,w),w)}}e.$tjc=A}),define(Se[339],De([1,0,16,108,22,53,13]),function(fe,e,l,j,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xjc=void 0;class p{constructor(C){this.b=0,this.c=new Map,this.a=C}async withProgress(C,v,S){const k=this.b++,{title:u,location:m,cancellable:o}=v,i={label:C.displayName||C.name,id:C.identifier.value};return this.a.$startProgress(k,{location:l.ProgressLocation.from(m),title:u,source:i,cancellable:o},C.isUnderDevelopment?void 0:C.identifier.value).catch(R.$2),this.d(k,S,!!o)}d(C,v,S){let k;S&&(k=new L.$ce,this.c.set(C,k));const u=o=>{this.a.$progressEnd(o),this.c.delete(o),k?.dispose()};let m;try{m=v(new E(this.a,C),S&&k?k.token:L.CancellationToken.None)}catch(o){throw u(C),o}return m.then(o=>u(C),o=>u(C)),m}$acceptProgressCanceled(C){const v=this.c.get(C);v&&(v.cancel(),this.c.delete(C))}}e.$xjc=p;function w(M,C){return M.message=C.message,typeof C.increment=="number"&&(typeof M.increment=="number"?M.increment+=C.increment:M.increment=C.increment),M}class E extends j.$Kv{constructor(C,v){super(S=>this.throttledReport(S)),this.c=C,this.d=v}throttledReport(C){this.c.$progressReport(this.d,C)}}Ye([(0,A.$Lh)(100,(M,C)=>w(M,C),()=>Object.create(null))],E.prototype,"throttledReport",null)}),define(Se[340],De([1,0,2,6,8,16]),function(fe,e,l,j,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yjc=void 0;class R{static{this.a=0}constructor(w,E){this.d=E,this.c=new Map,this.b=w.getProxy(j.$6L.MainThreadQuickDiff)}$provideOriginalResource(w,E,M){const C=l.URI.revive(E),v=this.c.get(w);return v?(0,L.$0g)(()=>v.provideOriginalResource(C,M)).then(S=>S||null):Promise.resolve(null)}registerQuickDiffProvider(w,E,M,C){const v=R.a++;return this.c.set(v,E),this.b.$registerQuickDiffProvider(v,A.DocumentSelector.from(w,this.d),M,C),{dispose:()=>{this.b.$unregisterQuickDiffProvider(v),this.c.delete(v)}}}}e.$yjc=R}),define(Se[341],De([1,0,22,4,3,6,2,7,13,19,39,55,26,16]),function(fe,e,l,j,L,A,R,p,w,E,M,C,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zjc=void 0;function k(u,m,o){const i=u.getProxy(A.$6L.MainThreadQuickOpen);class n{constructor($,D){this.e=new Map,this.f=0,this.a=$,this.b=D}showQuickPick($,D,b,g=l.CancellationToken.None){this.c=void 0;const y=Promise.resolve(D),P=++this.f,N=i.$show(P,{title:b?.title,placeHolder:b?.placeHolder,matchOnDescription:b?.matchOnDescription,matchOnDetail:b?.matchOnDetail,ignoreFocusLost:b?.ignoreFocusOut,canPickMany:b?.canPickMany},g),U={},z=N.then(()=>U);return Promise.race([z,y]).then(F=>{if(F===U)return;const I=(0,v.$XF)($,"quickPickItemTooltip");return y.then(O=>{const T=[];for(let G=0;G<O.length;G++){const te=O[G];if(typeof te=="string")T.push({label:te,handle:G});else if(te.kind===p.QuickPickItemKind.Separator)T.push({type:"separator",label:te.label});else{te.tooltip&&!I&&console.warn(`Extension '${$.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${$.identifier.value}`);const x=te.iconPath?h(te.iconPath):void 0;T.push({label:te.label,iconPath:x?.iconPath,iconClass:x?.iconClass,description:te.description,detail:te.detail,picked:te.picked,alwaysShow:te.alwaysShow,tooltip:I?S.MarkdownString.fromStrict(te.tooltip):void 0,handle:G})}}return b&&typeof b.onDidSelectItem=="function"&&(this.c=G=>{b.onDidSelectItem(O[G])}),i.$setItems(P,T),N.then(G=>{if(typeof G=="number")return O[G];if(Array.isArray(G))return G.map(te=>O[te])})})}).then(void 0,F=>{if(!(0,w.$4)(F))return i.$setError(P,F),Promise.reject(F)})}$onItemSelected($){this.c?.($)}showInput($,D=l.CancellationToken.None){return this.d=$?.validateInput,i.$input($,typeof this.d=="function",D).then(void 0,b=>{if(!(0,w.$4)(b))return Promise.reject(b)})}async $validateInput($){if(!this.d)return;const D=await this.d($);if(!D||typeof D=="string")return D;let b;switch(D.severity){case p.InputBoxValidationSeverity.Info:b=M.default.Info;break;case p.InputBoxValidationSeverity.Warning:b=M.default.Warning;break;case p.InputBoxValidationSeverity.Error:b=M.default.Error;break;default:b=D.message?M.default.Error:M.default.Ignore;break}return{content:D.message,severity:b}}async showWorkspaceFolderPick($,D=l.CancellationToken.None){const b=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[$]);if(!b)return;const g=await this.a.getWorkspaceFolders2();if(g)return g.find(y=>y.uri.toString()===b.uri.toString())}createQuickPick($){const D=new r($,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}createInputBox($){const D=new a($,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}$onDidChangeValue($,D){this.e.get($)?._fireDidChangeValue(D)}$onDidAccept($){this.e.get($)?._fireDidAccept()}$onDidChangeActive($,D){const b=this.e.get($);b instanceof r&&b._fireDidChangeActive(D)}$onDidChangeSelection($,D){const b=this.e.get($);b instanceof r&&b._fireDidChangeSelection(D)}$onDidTriggerButton($,D){this.e.get($)?._fireDidTriggerButton(D)}$onDidTriggerItemButton($,D,b){const g=this.e.get($);g instanceof r&&g._fireDidTriggerItemButton(D,b)}$onDidHide($){this.e.get($)?._fireDidHide()}}class s{static{this.a=1}constructor($,D){this.x=$,this.y=D,this._id=r.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new j.$5d,this.q=new j.$5d,this.r=new j.$5d,this.s=new j.$5d,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title($){this.b=$,this.z({title:$})}get step(){return this.c}set step($){this.c=$,this.z({step:$})}get totalSteps(){return this.d}set totalSteps($){this.d=$,this.z({totalSteps:$})}get enabled(){return this.g}set enabled($){this.g=$,this.z({enabled:$})}get busy(){return this.j}set busy($){this.j=$,this.z({busy:$})}get ignoreFocusOut(){return this.k}set ignoreFocusOut($){this.k=$,this.z({ignoreFocusOut:$})}get value(){return this.l}set value($){this.l=$,this.z({value:$})}get placeholder(){return this.m}set placeholder($){this.m=$,this.z({placeholder:$})}get buttons(){return this.n}set buttons($){this.n=$.slice(),this.o.clear(),$.forEach((D,b)=>{const g=D===p.$sN.Back?-1:b;this.o.set(g,D)}),this.z({buttons:$.map((D,b)=>({...h(D.iconPath),tooltip:D.tooltip,handle:D===p.$sN.Back?-1:b}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue($){this.l=$,this.q.fire($)}_fireDidTriggerButton($){const D=this.o.get($);D&&this.r.fire(D)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,L.$Oc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),i.$dispose(this._id))}z($){if(!this.v){for(const D of Object.keys($)){const b=$[D];this.u[D]=b===void 0?null:b}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){i.$createOrUpdate(this.u),this.u={id:this._id}}}function c(d){if(d instanceof p.$3M)return{id:d.id};const $=f(d),D=t(d);return{dark:typeof $=="string"?R.URI.file($):$,light:typeof D=="string"?R.URI.file(D):D}}function t(d){return typeof d=="object"&&"light"in d?d.light:d}function f(d){return typeof d=="object"&&"dark"in d?d.dark:d}function h(d){const $=c(d);let D,b;return"id"in $?b=C.ThemeIcon.asClassName($):D=$,{iconPath:D,iconClass:b}}class r extends s{constructor($,D){super($.identifier,D),this.O=$,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new j.$5d,this.L=[],this.M=new j.$5d,this.N=new j.$5d,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items($){this.B=$.slice(),this.C.clear(),this.D.clear(),$.forEach((g,y)=>{this.C.set(y,g),this.D.set(g,y)});const D=(0,v.$XF)(this.O,"quickPickItemTooltip"),b=[];for(let g=0;g<$.length;g++){const y=$[g];if(y.kind===p.QuickPickItemKind.Separator)b.push({type:"separator",label:y.label});else{y.tooltip&&!D&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const P=y.iconPath?h(y.iconPath):void 0;b.push({handle:g,label:y.label,iconPath:P?.iconPath,iconClass:P?.iconClass,description:y.description,detail:y.detail,picked:y.picked,alwaysShow:y.alwaysShow,tooltip:D?S.MarkdownString.fromStrict(y.tooltip):void 0,buttons:y.buttons?.map((N,U)=>({...h(N.iconPath),tooltip:N.tooltip,handle:U}))})}}this.z({items:b})}get canSelectMany(){return this.E}set canSelectMany($){this.E=$,this.z({canSelectMany:$})}get matchOnDescription(){return this.F}set matchOnDescription($){this.F=$,this.z({matchOnDescription:$})}get matchOnDetail(){return this.G}set matchOnDetail($){this.G=$,this.z({matchOnDetail:$})}get sortByLabel(){return this.H}set sortByLabel($){this.H=$,this.z({sortByLabel:$})}get keepScrollPosition(){return this.I}set keepScrollPosition($){this.I=$,this.z({keepScrollPosition:$})}get activeItems(){return this.J}set activeItems($){this.J=$.filter(D=>this.D.has(D)),this.z({activeItems:this.J.map(D=>this.D.get(D))})}get selectedItems(){return this.L}set selectedItems($){this.L=$.filter(D=>this.D.has(D)),this.z({selectedItems:this.L.map(D=>this.D.get(D))})}_fireDidChangeActive($){const D=(0,E.$Hb)($.map(b=>this.C.get(b)));this.J=D,this.K.fire(D)}_fireDidChangeSelection($){const D=(0,E.$Hb)($.map(b=>this.C.get(b)));this.L=D,this.M.fire(D)}_fireDidTriggerItemButton($,D){const b=this.C.get($);if(!b||!b.buttons||!b.buttons.length)return;const g=b.buttons[D];g&&this.N.fire({button:g,item:b})}}class a extends s{constructor($,D){super($.identifier,D),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password($){this.B=$,this.z({password:$})}get prompt(){return this.C}set prompt($){this.C=$,this.z({prompt:$})}get valueSelection(){return this.D}set valueSelection($){this.D=$,this.z({valueSelection:$})}get validationMessage(){return this.E}set validationMessage($){this.E=$,$?typeof $=="string"?this.z({validationMessage:$,severity:M.default.Error}):this.z({validationMessage:$.message,severity:$.severity??M.default.Error}):this.z({validationMessage:void 0,severity:M.default.Ignore})}}return new n(m,o)}e.$zjc=k}),define(Se[342],De([1,0,2,4,53,3,8,6,19,131,12,25,55,16,26,15,11]),function(fe,e,l,j,L,A,R,p,w,E,M,C,v,S,k,u,m){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$Bjc=e.$Ajc=void 0;function i(P){return P instanceof l.URI}function n(P,N){return P.scheme===u.Schemas.file&&N.scheme===u.Schemas.file&&m.$k?P.toString()===N.toString():P.toString().toLowerCase()===N.toString().toLowerCase()}function s(P){if(P)return typeof P.iconPath=="string"?l.URI.file(P.iconPath):l.URI.isUri(P.iconPath)||v.ThemeIcon.isThemeIcon(P.iconPath)?P.iconPath:void 0}function c(P){if(P.icon){if(l.URI.isUri(P.icon))return P.icon;if(v.ThemeIcon.isThemeIcon(P.icon))return P.icon;{const N=P.icon;return{light:N.light,dark:N.dark}}}else return}function t(P,N){if(!P.iconPath&&!N.iconPath)return 0;if(P.iconPath){if(!N.iconPath)return 1}else return-1;const U=typeof P.iconPath=="string"?P.iconPath:l.URI.isUri(P.iconPath)?P.iconPath.fsPath:P.iconPath.id,z=typeof N.iconPath=="string"?N.iconPath:l.URI.isUri(N.iconPath)?N.iconPath.fsPath:N.iconPath.id;return(0,E.$7q)(U,z)}function f(P,N){let U=0;if(P.strikeThrough!==N.strikeThrough)return P.strikeThrough?1:-1;if(P.faded!==N.faded)return P.faded?1:-1;if(P.tooltip!==N.tooltip)return(P.tooltip||"").localeCompare(N.tooltip||"");if(U=t(P,N),U!==0)return U;if(P.light&&N.light)U=t(P.light,N.light);else{if(P.light)return 1;if(N.light)return-1}if(U!==0)return U;if(P.dark&&N.dark)U=t(P.dark,N.dark);else{if(P.dark)return 1;if(N.dark)return-1}return U}function h(P,N){if(P.command!==N.command)return P.command<N.command?-1:1;if(P.title!==N.title)return P.title<N.title?-1:1;if(P.tooltip!==N.tooltip){if(P.tooltip!==void 0&&N.tooltip!==void 0)return P.tooltip<N.tooltip?-1:1;if(P.tooltip!==void 0)return 1;if(N.tooltip!==void 0)return-1}if(P.arguments===N.arguments)return 0;if(P.arguments)if(N.arguments){if(P.arguments.length!==N.arguments.length)return P.arguments.length-N.arguments.length}else return 1;else return-1;for(let U=0;U<P.arguments.length;U++){const z=P.arguments[U],F=N.arguments[U];if(z!==F&&!(i(z)&&i(F)&&n(z,F)))return z<F?-1:1}return 0}function r(P,N){let U=(0,E.$7q)(P.resourceUri.fsPath,N.resourceUri.fsPath,!0);if(U!==0)return U;if(P.command&&N.command)U=h(P.command,N.command);else{if(P.command)return 1;if(N.command)return-1}if(U!==0)return U;if(P.decorations&&N.decorations)U=f(P.decorations,N.decorations);else{if(P.decorations)return 1;if(N.decorations)return-1}if(P.multiFileDiffEditorModifiedUri&&N.multiFileDiffEditorModifiedUri)U=(0,E.$7q)(P.multiFileDiffEditorModifiedUri.fsPath,N.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(P.multiFileDiffEditorModifiedUri)return 1;if(N.multiFileDiffEditorModifiedUri)return-1}if(P.multiDiffEditorOriginalUri&&N.multiDiffEditorOriginalUri)U=(0,E.$7q)(P.multiDiffEditorOriginalUri.fsPath,N.multiDiffEditorOriginalUri.fsPath,!0);else{if(P.multiDiffEditorOriginalUri)return 1;if(N.multiDiffEditorOriginalUri)return-1}return U}function a(P,N){for(let U=0;U<P.length;U++)if(P[U]!==N[U])return!1;return!0}function d(P,N){return P.command===N.command&&P.title===N.title&&P.tooltip===N.tooltip&&(P.arguments&&N.arguments?a(P.arguments,N.arguments):P.arguments===N.arguments)}function $(P,N){return(0,w.$ub)(P,N,d)}class D{#e;#t;get value(){return this.d}set value(N){N=N??"",this.#e.$setInputBoxValue(this.l,N),this.n(N)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(N){this.#e.$setInputBoxPlaceholder(this.l,N),this.f=N}get validateInput(){return(0,k.$YF)(this.k,"scmValidation"),this.g}set validateInput(N){if((0,k.$YF)(this.k,"scmValidation"),N&&typeof N!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=N,this.#e.$setValidationProviderIsEnabled(this.l,!!N)}get enabled(){return this.h}set enabled(N){N=!!N,this.h!==N&&(this.h=N,this.#e.$setInputBoxEnablement(this.l,N))}get visible(){return this.j}set visible(N){N=!!N,this.j!==N&&(this.j=N,this.#e.$setInputBoxVisibility(this.l,N))}get document(){return(0,k.$YF)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(N,U,z,F,I){this.k=N,this.l=F,this.m=I,this.d="",this.e=new j.$5d,this.f="",this.h=!0,this.j=!0,this.#t=U,this.#e=z}showValidationMessage(N,U){(0,k.$YF)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,N,U)}$onInputBoxValueChange(N){this.n(N)}n(N){this.d=N,this.e.fire(N)}}e.$Ajc=D;class b{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(N){this.v=N,this.q.$updateGroupLabel(this.t,this.handle,N)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(N){this.p=N,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(N){this.f=[...N],this.k.fire()}constructor(N,U,z,F,I,O,T){this.q=N,this.s=U,this.t=z,this.u=F,this.v=I,this.multiDiffEditorEnableViewChanges=O,this.w=T,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new j.$5d,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new j.$5d,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=b.d++}getResourceState(N){return this.g.get(N)}$executeResourceCommand(N,U){const z=this.h.get(N);return z?(0,R.$0g)(()=>this.s.executeCommand(z.command,...z.arguments||[],U)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const N=[...this.f].sort(r),z=(0,w.$Db)(this.o,N,r).map(O=>{const T=O.toInsert.map(G=>{const te=this.e++;this.g.set(te,G);const x=G.resourceUri;let X;if(G.command)if(G.command.command==="vscode.open"||G.command.command==="vscode.diff"||G.command.command==="vscode.changes"){const de=new A.$Sc;X=this.s.converter.toInternal(G.command,de),this.j.set(te,de)}else this.h.set(te,G.command);const Q=(0,k.$XF)(this.w,"scmMultiDiffEditor"),ae=Q?G.multiDiffEditorOriginalUri:void 0,_=Q?G.multiFileDiffEditorModifiedUri:void 0,ge=s(G.decorations),se=G.decorations&&s(G.decorations.light)||ge,re=G.decorations&&s(G.decorations.dark)||ge,B=[se,re],ie=G.decorations&&G.decorations.tooltip||"",ye=G.decorations&&!!G.decorations.strikeThrough,le=G.decorations&&!!G.decorations.faded,ue=G.contextValue||"";return{rawResource:[te,x,B,ie,ye,le,ue,X,ae,_],handle:te}});return{start:O.start,deleteCount:O.deleteCount,toInsert:T}}),F=z.map(({start:O,deleteCount:T,toInsert:G})=>[O,T,G.map(te=>te.rawResource)]),I=z.reverse();for(const{start:O,deleteCount:T,toInsert:G}of I){const te=G.map(X=>X.handle),x=this.n.splice(O,T,...te);for(const X of x)this.g.delete(X),this.h.delete(X),this.j.get(X)?.dispose(),this.j.delete(X)}return this.o=N,F}dispose(){this.l=!0,this.m.fire()}}class g{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(N){this.g!==N&&(this.g=N,this.#e.$updateSourceControl(this.w,{count:N}))}get quickDiffProvider(){return this.h}set quickDiffProvider(N){this.h=N;let U;(0,k.$XF)(this.x,"quickDiffProvider")&&(U=N?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!N,quickDiffLabel:U})}get historyProvider(){return(0,k.$YF)(this.x,"scmHistoryProvider"),this.j}set historyProvider(N){(0,k.$YF)(this.x,"scmHistoryProvider"),this.j=N,this.k.value=new A.$Sc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!N}),N&&this.k.value.add(N.onDidChangeCurrentHistoryItemGroup(()=>{this.l=N?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(N){N!==this.m&&(this.m=N,this.#e.$updateSourceControl(this.w,{commitTemplate:N}))}get acceptInputCommand(){return this.o}set acceptInputCommand(N){this.n.value=new A.$Sc,this.o=N;const U=this.y.converter.toInternal(N,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:U})}get actionButton(){return(0,k.$YF)(this.x,"scmActionButton"),this.q}set actionButton(N){(0,k.$YF)(this.x,"scmActionButton"),this.p.value=new A.$Sc,this.q=N;const U=N!==void 0?{command:this.y.converter.toInternal(N.command,this.p.value),secondaryCommands:N.secondaryCommands?.map(z=>z.map(F=>this.y.converter.toInternal(F,this.p.value))),description:N.description,enabled:N.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:U??null})}get statusBarCommands(){return this.t}set statusBarCommands(N){if(this.t&&N&&$(this.t,N))return;this.s.value=new A.$Sc,this.t=N;const U=(N||[]).map(z=>this.y.converter.toInternal(z,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:U})}get selected(){return this.u}constructor(N,U,z,F,I,O,T){this.x=N,this.y=F,this.z=I,this.A=O,this.B=T,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new A.$Uc,this.m=void 0,this.n=new A.$Uc,this.o=void 0,this.p=new A.$Uc,this.s=new A.$Uc,this.t=void 0,this.u=!1,this.v=new j.$5d,this.onDidChangeSelection=this.v.event,this.w=g.d++,this.C=new Map,this.D=new Set,this.#e=z;const G=l.URI.from({scheme:u.Schemas.vscodeSourceControl,path:`${I}/scm${this.w}/input`,query:T?`rootUri=${encodeURIComponent(T.toString())}`:void 0});this.f=new D(N,U,this.#e,this.w,G),this.#e.$registerSourceControl(this.w,I,O,T,G)}createResourceGroup(N,U,z){const F=(0,k.$XF)(this.x,"scmMultiDiffEditor")&&z?.multiDiffEditorEnableViewChanges===!0,I=new b(this.#e,this.y,this.w,N,U,F,this.x),O=j.Event.once(I.onDidDispose)(()=>this.C.delete(I));return this.C.set(I,O),this.eventuallyAddResourceGroups(),I}eventuallyAddResourceGroups(){const N=[],U=[];for(const[z,F]of this.C){F.dispose();const I=z.onDidUpdateResourceStates(()=>{this.D.add(z),this.eventuallyUpdateResourceStates()});j.Event.once(z.onDidDispose)(()=>{this.D.delete(z),I.dispose(),this.e.delete(z.handle),this.#e.$unregisterGroup(this.w,z.handle)}),N.push([z.handle,z.id,z.label,z.features,z.multiDiffEditorEnableViewChanges]);const O=z._takeResourceStateSnapshot();O.length>0&&U.push([z.handle,O]),this.e.set(z.handle,z)}this.#e.$registerGroups(this.w,N,U),this.C.clear()}eventuallyUpdateResourceStates(){const N=[];this.D.forEach(U=>{const z=U._takeResourceStateSnapshot();z.length!==0&&N.push([U.handle,z])}),N.length>0&&this.#e.$spliceResourceStates(this.w,N),this.D.clear()}getResourceGroup(N){return this.e.get(N)}setSelectionState(N){this.u=N,this.v.fire(N)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(N=>N.dispose()),this.#e.$unregisterSourceControl(this.w)}}Ye([(0,L.$Kh)(100)],g.prototype,"eventuallyAddResourceGroups",null),Ye([(0,L.$Kh)(100)],g.prototype,"eventuallyUpdateResourceStates",null);let y=class{static{o=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(N,U,z,F){this.l=U,this.m=z,this.n=F,this.g=new Map,this.h=new C.$Bm,this.j=new j.$5d,this.e=N.getProxy(p.$6L.MainThreadSCM),this.f=N.getProxy(p.$6L.MainThreadTelemetry),U.registerArgumentProcessor({processArgument:I=>{if(I&&I.$mid===3){const O=this.g.get(I.sourceControlHandle);if(!O)return I;const T=O.getResourceGroup(I.groupHandle);return T?T.getResourceState(I.handle):I}else if(I&&I.$mid===4){const O=this.g.get(I.sourceControlHandle);return O?O.getResourceGroup(I.groupHandle):I}else if(I&&I.$mid===5){const O=this.g.get(I.handle);return O||I}return I}})}createSourceControl(N,U,z,F){this.n.trace("ExtHostSCM#createSourceControl",N.identifier.value,U,z,F),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:N.identifier.value});const I=o.d++,O=new g(N,this.m,this.e,this.l,U,z,F);this.g.set(I,O);const T=this.h.get(N.identifier)||[];return T.push(O),this.h.set(N.identifier,T),O}getLastInputBox(N){this.n.trace("ExtHostSCM#getLastInputBox",N.identifier.value);const U=this.h.get(N.identifier),z=U&&U[U.length-1];return z&&z.inputBox}$provideOriginalResource(N,U,z){const F=l.URI.revive(U);this.n.trace("ExtHostSCM#$provideOriginalResource",N,F.toString());const I=this.g.get(N);return!I||!I.quickDiffProvider||!I.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$0g)(()=>I.quickDiffProvider.provideOriginalResource(F,z)).then(O=>O||null)}$onInputBoxValueChange(N,U){this.n.trace("ExtHostSCM#$onInputBoxValueChange",N);const z=this.g.get(N);return z&&z.inputBox.$onInputBoxValueChange(U),Promise.resolve(void 0)}$executeResourceCommand(N,U,z,F){this.n.trace("ExtHostSCM#$executeResourceCommand",N,U,z);const I=this.g.get(N);if(!I)return Promise.resolve(void 0);const O=I.getResourceGroup(U);return O?O.$executeResourceCommand(z,F):Promise.resolve(void 0)}$validateInput(N,U,z){this.n.trace("ExtHostSCM#$validateInput",N);const F=this.g.get(N);return!F||!F.inputBox.validateInput?Promise.resolve(void 0):(0,R.$0g)(()=>F.inputBox.validateInput(U,z)).then(I=>{if(!I)return Promise.resolve(void 0);const O=S.MarkdownString.fromStrict(I.message);return O?Promise.resolve([O,I.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(N){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",N),N!==void 0&&this.g.get(N)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=N,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(N,U,z,F){return await this.g.get(N)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(U,z,F)??void 0}async $provideHistoryItems(N,U,z,F){return(await this.g.get(N)?.historyProvider?.provideHistoryItems(U,z,F))?.map(T=>({...T,icon:c(T)}))??void 0}async $provideHistoryItemSummary(N,U,z,F){const I=this.g.get(N)?.historyProvider;if(typeof I?.provideHistoryItemSummary!="function")return;const O=await I.provideHistoryItemSummary(U,z,F);return O?{...O,icon:c(O)}:void 0}async $provideHistoryItemChanges(N,U,z,F){return await this.g.get(N)?.historyProvider?.provideHistoryItemChanges(U,z,F)??void 0}};e.$Bjc=y,e.$Bjc=y=o=Ye([Ve(3,M.$zj)],y)}),define(Se[343],De([1,0,6,16,2]),function(fe,e,l,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cjc=void 0;class A{static{this.a=0}constructor(p,w){this.d=w,this.c=new Map,this.b=p.getProxy(l.$6L.MainThreadShare)}async $provideShare(p,w,E){return await this.c.get(p)?.provideShare({selection:j.Range.to(w.selection),resourceUri:L.URI.revive(w.resourceUri)},E)??void 0}registerShareProvider(p,w){const E=A.a++;return this.c.set(E,w),this.b.$registerShareProvider(E,j.DocumentSelector.from(p,this.d),w.id,w.label,w.priority),{dispose:()=>{this.b.$unregisterShareProvider(E),this.c.delete(E)}}}}e.$Cjc=A}),define(Se[344],De([1,0,7,6,222,3,16,18]),function(fe,e,l,j,L,A,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fjc=e.$Ejc=void 0;class w{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new l.$4M("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new l.$4M("statusBarItem.warningForeground")]])}#e;#t;constructor(v,S,k,u,m,o=l.StatusBarAlignment.Left,i){if(this.i=!1,this.k="",this.q=new A.$Sc,this.#e=v,this.#t=S,m&&u){this.c=(0,l.$GM)(u.identifier,m);const n=k.get(this.c);n&&(o=n.alignLeft?l.StatusBarAlignment.Left:l.StatusBarAlignment.Right,i=n.priority,this.j=!0,this.name=n.name,this.text=n.text,this.tooltip=n.tooltip,this.command=n.command,this.accessibilityInformation=n.accessibilityInformation)}else this.c=String(w.a++);this.e=u,this.f=m,this.g=o,this.h=this.u(i)}u(v){if((0,p.$Wf)(v))return v===Number.POSITIVE_INFINITY?Number.MAX_VALUE:v===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:v}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(v){this.k=v,this.v()}set name(v){this.m=v,this.v()}set tooltip(v){this.l=v,this.v()}set color(v){this.n=v,this.v()}set backgroundColor(v){v&&!w.b.has(v.id)&&(v=void 0),this.o=v,this.v()}set command(v){this.r?.fromApi!==v&&(this.p&&this.q.add(this.p),this.p=new A.$Sc,typeof v=="string"?this.r={fromApi:v,internal:this.#t.toInternal({title:"",command:v},this.p)}:v?this.r={fromApi:v,internal:this.#t.toInternal(v,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(v){this.t=v,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let v;this.e?this.f?v=`${this.e.identifier.value}.${this.f}`:v=this.e.identifier.value:v=this.f;let S;this.m?S=this.m:S=(0,L.localize)(0,null,this.e.displayName||this.e.name);let k=this.n;this.o&&(k=w.b.get(this.o.id));const u=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,v,this.e?.identifier.value,S,this.k,u,this.r?.internal,k,this.o,this.g===l.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Ejc=w;class E{constructor(v){this.b=[],this.a=v.createStatusBarEntry(void 0,"status.extensionMessage",l.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,L.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(v){const S={message:v};return this.b.unshift(S),this.c(),new l.$8L(()=>{const k=this.b.indexOf(S);k>=0&&(this.b.splice(k,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class M{constructor(v,S){this.e=new Map,this.a=v.getProxy(j.$6L.MainThreadStatusBar),this.b=S,this.c=new E(this)}$acceptStaticEntries(v){for(const S of v)this.e.set(S.entryId,S)}createStatusBarEntry(v,S,k,u){return new w(this.a,this.b,this.e,v,S,k,u)}setStatusBarMessage(v,S){const k=this.c.setMessage(v);let u;return typeof S=="number"?u=setTimeout(()=>k.dispose(),S):typeof S<"u"&&S.then(()=>k.dispose(),()=>k.dispose()),new l.$8L(()=>{k.dispose(),clearTimeout(u)})}}e.$Fjc=M}),define(Se[154],De([1,0,29,144,66,112,89,16,2]),function(fe,e,l,j,L,A,R,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AO=e.$zO=e.$yO=e.$xO=void 0;const E=(n,s,c,t)=>{let f=s;return{enumerable:!0,configurable:!1,get(){return f},set(h){if(!c(f,h)){const r=f;f=h,n.listener?.(t(h,r))}}}},M=(n,s)=>n===s,C={range:(n,s)=>n===s?!0:!n||!s?!1:n.isEqual(s),label:M,description:M,sortText:M,busy:M,error:M,canResolveChildren:M,tags:(n,s)=>!(n.length!==s.length||n.some(c=>!s.find(t=>c.id===t.id)))},v=n=>s=>({op:4,update:n(s)}),S=(n,s)=>({range:(()=>{let c;const t=v(f=>({range:l.$9s.lift(p.Range.from(f))}));return{enumerable:!0,configurable:!1,get(){return c},set(f){n.listener?.({op:6}),C.range(c,f)||(c=f,n.listener?.(t(f)))}}})(),label:E(n,s,C.label,v(c=>({label:c}))),description:E(n,void 0,C.description,v(c=>({description:c}))),sortText:E(n,void 0,C.sortText,v(c=>({sortText:c}))),canResolveChildren:E(n,!1,C.canResolveChildren,c=>({op:2,state:c})),busy:E(n,!1,C.busy,v(c=>({busy:c}))),error:E(n,void 0,C.error,v(c=>({error:p.MarkdownString.fromStrict(c)||null}))),tags:E(n,[],C.tags,(c,t)=>({op:1,new:c.map(p.TestTag.from),old:t.map(p.TestTag.from)}))}),k=n=>{const s=L.$WK.fromString(n.extId),c=new m(s.controllerId,s.localId,n.label,w.URI.revive(n.uri)||void 0);return c.range=p.Range.to(n.range||void 0),c.description=n.description||void 0,c.sortText=n.sortText||void 0,c.tags=n.tags.map(t=>p.TestTag.to({id:(0,R.$2K)(t).tagId})),c},u=n=>{let s;for(const c of n.tests){const t=k(c.item);(0,j.$hO)(t).parent=s,s=t}return s};e.$xO=u;class m{constructor(s,c,t,f){if(c.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(c)} symbol`);const h=(0,j.$gO)(this,s);Object.defineProperties(this,{id:{value:c,enumerable:!0,writable:!1},uri:{value:f,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return h.parent instanceof o?void 0:h.parent}},children:{value:(0,A.$fO)(h,j.$hO,m),enumerable:!0,writable:!1},...S(h,t)})}}e.$yO=m;class o extends m{constructor(s,c){super(s,s,c,void 0),this._isRoot=!0}}e.$zO=o;class i extends A.$bO{constructor(s,c,t){super({controllerId:s,getDocumentVersion:f=>f&&t.getDocument(f)?.version,getApiFor:j.$hO,getChildren:f=>f.children,root:new o(s,c),toITestItem:p.TestItem.from})}}e.$AO=i}),define(Se[33],De([1,0,18,7,16,24,6,19,12,56,29,49,2,3,5,20,154,21,67,44,38,87,90,30]),function(fe,e,l,j,L,A,R,p,w,E,M,C,v,S,k,u,m,o,i,n,s,c,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LO=e.$KO=e.$JO=e.$IO=e.$HO=e.$GO=void 0;let h=class{#e;#t;#i;constructor(b,g,y){this.b=new Map,this.c=new Map,this.#e=b.getProxy(R.$6L.MainThreadCommands),this.d=g,this.#i=y,this.#t=b.getProxy(R.$6L.MainThreadTelemetry),this.converter=new r(this,P=>{const N=this.c.get(P);return N?.result===d.Void?N:void 0},g),this.f=[{processArgument(P){return(0,E.$Oh)(P)}},{processArgument(P){return(0,A.$Mn)(P,function(N){if(M.$9s.isIRange(N))return L.Range.to(N);if(C.$8s.isIPosition(N))return L.Position.to(N);if(M.$9s.isIRange(N.range)&&v.URI.isUri(N.uri))return L.location.to(N);if(N instanceof o.$se)return N.buffer.buffer;if(!Array.isArray(N))return N})}}]}registerArgumentProcessor(b){this.f.push(b)}registerApiCommand(b){const g=this.registerCommand(!1,b.id,async(...y)=>{const P=b.args.map((U,z)=>{if(!U.validate(y[z]))throw new Error(`Invalid argument '${U.name}' when running '${b.id}', received: ${typeof y[z]=="object"?JSON.stringify(y[z],null,"	"):y[z]} `);return U.convert(y[z])}),N=await this.executeCommand(b.internalId,...P);return b.result.convert(N,y,this.converter)},void 0,{description:b.description,args:b.args,returns:b.result.description});return this.c.set(b.id,b),new j.$8L(()=>{g.dispose(),this.c.delete(b.id)})}registerCommand(b,g,y,P,N,U){if(this.d.trace("ExtHostCommands#registerCommand",g),!g.trim().length)throw new Error("invalid id");if(this.b.has(g))throw new Error(`command '${g}' already exists`);return this.b.set(g,{callback:y,thisArg:P,metadata:N,extension:U}),b&&this.#e.$registerCommand(g),new j.$8L(()=>{this.b.delete(g)&&b&&this.#e.$unregisterCommand(g)})}executeCommand(b,...g){return this.d.trace("ExtHostCommands#executeCommand",b),this.g(b,g,!0)}async g(b,g,y){if(this.b.has(b))return this.#e.$fireCommandActivationEvent(b),this.h(b,g,!1);{let P=!1;const N=(0,A.$Mn)(g,function(U){if(U instanceof j.$9L)return L.Position.from(U);if(U instanceof j.$0L)return L.Range.from(U);if(U instanceof j.$hM)return L.location.from(U);if(j.$vN.isNotebookRange(U))return L.NotebookRange.from(U);if(U instanceof ArrayBuffer)return P=!0,o.$se.wrap(new Uint8Array(U));if(U instanceof Uint8Array)return P=!0,o.$se.wrap(U);if(U instanceof o.$se)return P=!0,U;if(!Array.isArray(U))return U});try{const U=await this.#e.$executeCommand(b,P?new i.$9v(N):N,y);return(0,E.$Oh)(U)}catch(U){if(U instanceof Error&&U.message==="$executeCommand:retry")return this.g(b,g,!1);throw U}}}async h(b,g,y){const P=this.b.get(b);if(!P)throw new Error("Unknown command");const{callback:N,thisArg:U,metadata:z}=P;if(z?.args)for(let I=0;I<z.args.length;I++)try{(0,l.$0f)(g[I],z.args[I].constraint)}catch{throw new Error(`Running the contributed command: '${b}' failed. Illegal argument '${z.args[I].name}' - ${z.args[I].description}`)}const F=s.$1d.create();try{return await N.apply(U,g)}catch(I){if(b===this.converter.delegatingCommandId){const O=this.converter.getActualCommand(...g);O&&(b=O.command)}if(this.d.error(I,b,P.extension?.identifier),!y)throw I;if(P.extension?.identifier){const O=this.#i.onExtensionError(P.extension.identifier,I);this.d.trace("forwarded error to extension?",O,P.extension?.identifier)}throw new class extends Error{constructor(){super((0,n.$3i)(I)),this.id=b,this.source=P.extension?.displayName??P.extension?.name}}}finally{this.j(P,b,F.elapsed())}}j(b,g,y){b.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:b.extension.identifier.value,id:new c.$Zo(g),duration:y})}$executeContributedCommand(b,...g){this.d.trace("ExtHostCommands#$executeContributedCommand",b);const y=this.b.get(b);return y?(g=g.map(P=>this.f.reduce((N,U)=>U.processArgument(N,y.extension?.identifier),P)),this.h(b,g,!0)):Promise.reject(new Error(`Contributed command '${b}' does not exist.`))}getCommands(b=!1){return this.d.trace("ExtHostCommands#getCommands",b),this.#e.$getCommands().then(g=>(b&&(g=g.filter(y=>y[0]!=="_")),g))}$getContributedCommandMetadata(){const b=Object.create(null);for(const[g,y]of this.b){const{metadata:P}=y;P&&(b[g]=P)}return Promise.resolve(b)}};e.$GO=h,e.$GO=h=Ye([Ve(0,u.$lO),Ve(1,w.$zj),Ve(2,t.$FO)],h),e.$HO=(0,k.$fi)("IExtHostCommands");class r{constructor(b,g,y){this.d=b,this.f=g,this.g=y,this.delegatingCommandId=`__vsc${(0,f.$Bg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(b,g){if(!b)return;const y={$ident:void 0,id:b.command,title:b.title,tooltip:b.tooltip};if(!b.command)return y;const P=this.f(b.command);if(P)y.id=P.internalId,y.arguments=P.args.map((N,U)=>N.convert(b.arguments&&b.arguments[U]));else if((0,p.$Lb)(b.arguments)){const N=`${b.command} /${++this.c}`;this.b.set(N,b),g.add((0,S.$Rc)(()=>{this.b.delete(N),this.g.trace("CommandsConverter#DISPOSE",N)})),y.$ident=N,y.id=this.delegatingCommandId,y.arguments=[N],this.g.trace("CommandsConverter#CREATE",b.command,N)}return y}fromInternal(b){return typeof b.$ident=="string"?this.b.get(b.$ident):{command:b.id,title:b.title,arguments:b.arguments}}getActualCommand(...b){return this.b.get(b[0])}h(...b){const g=this.getActualCommand(...b);return this.g.trace("CommandsConverter#EXECUTE",b[0],g?g.command:"MISSING"),g?this.d.executeCommand(g.command,...g.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${b[0]}`)}}e.$IO=r;class a{static{this.Uri=new a("uri","Uri of a text document",b=>v.URI.isUri(b),b=>b)}static{this.Position=new a("position","A position in a text document",b=>j.$9L.isPosition(b),L.Position.from)}static{this.Range=new a("range","A range in a text document",b=>j.$0L.isRange(b),L.Range.from)}static{this.Selection=new a("selection","A selection in a text document",b=>j.$$L.isSelection(b),L.Selection.from)}static{this.Number=new a("number","",b=>typeof b=="number",b=>b)}static{this.String=new a("string","",b=>typeof b=="string",b=>b)}static{this.StringArray=a.Arr(a.String)}static Arr(b){return new a(`${b.name}_array`,`Array of ${b.name}, ${b.description}`,g=>Array.isArray(g)&&g.every(y=>b.validate(y)),g=>g.map(y=>b.convert(y)))}static{this.CallHierarchyItem=new a("item","A call hierarchy item",b=>b instanceof j.$sM,L.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new a("item","A type hierarchy item",b=>b instanceof j.$ON,L.TypeHierarchyItem.from)}static{this.TestItem=new a("testItem","A VS Code TestItem",b=>b instanceof m.$yO,L.TestItem.from)}constructor(b,g,y,P){this.name=b,this.description=g,this.validate=y,this.convert=P}optional(){return new a(this.name,`(optional) ${this.description}`,b=>b==null||this.validate(b),b=>b===void 0?void 0:b===null?null:this.convert(b))}with(b,g){return new a(b??this.name,g??this.description,this.validate,this.convert)}}e.$JO=a;class d{static{this.Void=new d("no result",b=>b)}constructor(b,g){this.description=b,this.convert=g}}e.$KO=d;class ${constructor(b,g,y,P,N){this.id=b,this.internalId=g,this.description=y,this.args=P,this.result=N}}e.$LO=$}),define(Se[345],De([1,0,19,15,2,82,134,45,33,16,7]),function(fe,e,l,j,L,A,R,p,w,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yhc=void 0;const C=[new w.$LO("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[w.$JO.Uri,w.$JO.Position],new w.$KO("A promise that resolves to an array of DocumentHighlight-instances.",S(E.DocumentHighlight.to))),new w.$LO("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[w.$JO.Uri],new w.$KO("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(u,m)=>{if((0,l.$Kb)(u))return;class o extends M.$nM{static to(n){const s=new o(n.name,E.SymbolKind.to(n.kind),n.containerName||"",new M.$hM(m[0],E.Range.to(n.range)));return s.detail=n.detail,s.range=s.location.range,s.selectionRange=E.Range.to(n.selectionRange),s.children=n.children?n.children.map(o.to):[],s}}return u.map(o.to)})),new w.$LO("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[w.$JO.Uri,new w.$JO("options","Formatting options",u=>!0,u=>u)],new w.$KO("A promise that resolves to an array of TextEdits.",S(E.TextEdit.to))),new w.$LO("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[w.$JO.Uri,w.$JO.Range,new w.$JO("options","Formatting options",u=>!0,u=>u)],new w.$KO("A promise that resolves to an array of TextEdits.",S(E.TextEdit.to))),new w.$LO("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[w.$JO.Uri,w.$JO.Position,new w.$JO("ch","Trigger character",u=>typeof u=="string",u=>u),new w.$JO("options","Formatting options",u=>!0,u=>u)],new w.$KO("A promise that resolves to an array of TextEdits.",S(E.TextEdit.to))),new w.$LO("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[w.$JO.Uri,w.$JO.Position],new w.$KO("A promise that resolves to an array of Location or LocationLink instances.",k)),new w.$LO("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[w.$JO.Uri,w.$JO.Position],new w.$KO("A promise that resolves to an array of Location or LocationLink instances.",k)),new w.$LO("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[w.$JO.Uri,w.$JO.Position],new w.$KO("A promise that resolves to an array of Location or LocationLink instances.",k)),new w.$LO("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[w.$JO.Uri,w.$JO.Position],new w.$KO("A promise that resolves to an array of Location or LocationLink instances.",k)),new w.$LO("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[w.$JO.Uri,w.$JO.Position],new w.$KO("A promise that resolves to an array of Location-instances.",S(E.location.to))),new w.$LO("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[w.$JO.Uri,w.$JO.Position],new w.$KO("A promise that resolves to an array of Hover-instances.",S(E.Hover.to))),new w.$LO("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[w.$JO.Uri,new w.$JO("position","A position in a text document",u=>Array.isArray(u)&&u.every(m=>M.$9L.isPosition(m)),u=>u.map(E.Position.from))],new w.$KO("A promise that resolves to an array of ranges.",u=>u.map(m=>{let o;for(const i of m.reverse())o=new M.$rM(E.Range.to(i),o);return o}))),new w.$LO("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[w.$JO.String.with("query","Search string")],new w.$KO("A promise that resolves to an array of SymbolInformation-instances.",u=>u.map(E.WorkspaceSymbol.to))),new w.$LO("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[w.$JO.Uri,w.$JO.Position],new w.$KO("A promise that resolves to an array of CallHierarchyItem-instances",u=>u.map(E.CallHierarchyItem.to))),new w.$LO("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[w.$JO.CallHierarchyItem],new w.$KO("A promise that resolves to an array of CallHierarchyIncomingCall-instances",u=>u.map(E.CallHierarchyIncomingCall.to))),new w.$LO("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[w.$JO.CallHierarchyItem],new w.$KO("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",u=>u.map(E.CallHierarchyOutgoingCall.to))),new w.$LO("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[w.$JO.Uri,w.$JO.Position],new w.$KO("A promise that resolves to a range and placeholder text.",u=>{if(u)return{range:E.Range.to(u.range),placeholder:u.text}})),new w.$LO("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[w.$JO.Uri,w.$JO.Position,w.$JO.String.with("newName","The new symbol name")],new w.$KO("A promise that resolves to a WorkspaceEdit.",u=>{if(u){if(u.rejectReason)throw new Error(u.rejectReason);return E.WorkspaceEdit.to(u)}})),new w.$LO("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[w.$JO.Uri,w.$JO.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new w.$KO("A promise that resolves to an array of DocumentLink-instances.",u=>u.map(E.DocumentLink.to))),new w.$LO("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[w.$JO.Uri],new w.$KO("A promise that resolves to SemanticTokensLegend.",u=>{if(u)return new M.$mN(u.tokenTypes,u.tokenModifiers)})),new w.$LO("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[w.$JO.Uri],new w.$KO("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const m=(0,R.$eab)(u);if(m.type==="full")return new M.$oN(m.data,void 0)})),new w.$LO("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[w.$JO.Uri,w.$JO.Range.optional()],new w.$KO("A promise that resolves to SemanticTokensLegend.",u=>{if(u)return new M.$mN(u.tokenTypes,u.tokenModifiers)})),new w.$LO("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[w.$JO.Uri,w.$JO.Range],new w.$KO("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const m=(0,R.$eab)(u);if(m.type==="full")return new M.$oN(m.data,void 0)})),new w.$LO("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[w.$JO.Uri,w.$JO.Position,w.$JO.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),w.$JO.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new w.$KO("A promise that resolves to a CompletionList-instance.",(u,m,o)=>{if(!u)return new M.$DM([]);const i=u.suggestions.map(n=>E.CompletionItem.to(n,o));return new M.$DM(i,u.incomplete)})),new w.$LO("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[w.$JO.Uri,w.$JO.Position,w.$JO.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new w.$KO("A promise that resolves to SignatureHelp.",u=>{if(u)return E.SignatureHelp.to(u)})),new w.$LO("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[w.$JO.Uri,w.$JO.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new w.$KO("A promise that resolves to an array of CodeLens-instances.",(u,m,o)=>S(i=>new M.$vM(E.Range.to(i.range),i.command&&o.fromInternal(i.command)))(u))),new w.$LO("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[w.$JO.Uri,new w.$JO("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",u=>M.$0L.isRange(u),u=>M.$$L.isSelection(u)?E.Selection.from(u):E.Range.from(u)),w.$JO.String.with("kind","Code action kind to return code actions for").optional(),w.$JO.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new w.$KO("A promise that resolves to an array of Command-instances.",(u,m,o)=>S(i=>{if(i._isSynthetic){if(!i.command)throw new Error("Synthetic code actions must have a command");return o.fromInternal(i.command)}else{const n=new M.$pM(i.title,i.kind?new M.$qM(i.kind):void 0);return i.edit&&(n.edit=E.WorkspaceEdit.to(i.edit)),i.command&&(n.command=o.fromInternal(i.command)),n.isPreferred=i.isPreferred,n}})(u))),new w.$LO("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[w.$JO.Uri],new w.$KO("A promise that resolves to an array of ColorInformation objects.",u=>u?u.map(m=>new M.$JM(E.Range.to(m.range),E.Color.to(m.color))):[])),new w.$LO("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new w.$JO("color","The color to show and insert",u=>u instanceof M.$IM,E.Color.from),new w.$JO("context","Context object with uri and range",u=>!0,u=>({uri:u.uri,range:E.Range.from(u.range)}))],new w.$KO("A promise that resolves to an array of ColorPresentation objects.",u=>u?u.map(E.ColorPresentation.to):[])),new w.$LO("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[w.$JO.Uri,w.$JO.Range],new w.$KO("A promise that resolves to an array of Inlay objects",(u,m,o)=>u.map(E.InlayHint.to.bind(void 0,o)))),new w.$LO("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[w.$JO.Uri],new w.$KO("A promise that resolves to an array of FoldingRange objects",(u,m)=>{if(u)return u.map(E.FoldingRange.to)})),new w.$LO("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new w.$KO("A promise that resolves to an array of NotebookContentProvider static info objects.",S(u=>({viewType:u.viewType,displayName:u.displayName,options:{transientOutputs:u.options.transientOutputs,transientCellMetadata:u.options.transientCellMetadata,transientDocumentMetadata:u.options.transientDocumentMetadata},filenamePattern:u.filenamePattern.map(m=>E.NotebookExclusiveDocumentPattern.to(m))})))),new w.$LO("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[w.$JO.Uri,w.$JO.Range,new w.$JO("context","An InlineValueContext",u=>u&&typeof u.frameId=="number"&&u.stoppedLocation instanceof M.$0L,u=>E.InlineValueContext.from(u))],new w.$KO("A promise that resolves to an array of InlineValue objects",u=>u.map(E.InlineValue.to))),new w.$LO("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new w.$JO("uriOrString","Uri-instance or string (only http/https)",u=>L.URI.isUri(u)||typeof u=="string"&&(0,j.$pg)(u,j.Schemas.http,j.Schemas.https),u=>u),new w.$JO("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[E.ViewColumn.from(u),void 0]:[E.ViewColumn.from(u.viewColumn),E.TextEditorOpenOptions.from(u)])).optional(),w.$JO.String.with("label","").optional()],w.$KO.Void),new w.$LO("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[w.$JO.Uri.with("resource","Resource to open"),w.$JO.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new w.$JO("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[E.ViewColumn.from(u),void 0]:[E.ViewColumn.from(u.viewColumn),E.TextEditorOpenOptions.from(u)])).optional()],w.$KO.Void),new w.$LO("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[w.$JO.Uri.with("left","Left-hand side resource of the diff editor"),w.$JO.Uri.with("right","Right-hand side resource of the diff editor"),w.$JO.String.with("title","Human readable title for the diff editor").optional(),new w.$JO("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="object",u=>u&&[E.ViewColumn.from(u.viewColumn),E.TextEditorOpenOptions.from(u)]).optional()],w.$KO.Void),new w.$LO("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[w.$JO.String.with("title","Human readable title for the changes editor"),new w.$JO("resourceList","List of resources to compare",u=>{for(const m of u){if(m.length!==3)return!1;const[o,i,n]=m;if(!L.URI.isUri(o)||!L.URI.isUri(i)&&i!==void 0&&i!==null||!L.URI.isUri(n)&&n!==void 0&&n!==null)return!1}return!0},u=>u)],w.$KO.Void),new w.$LO("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[w.$JO.Uri,w.$JO.Position],new w.$KO("A promise that resolves to an array of TypeHierarchyItem-instances",u=>u.map(E.TypeHierarchyItem.to))),new w.$LO("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[w.$JO.TypeHierarchyItem],new w.$KO("A promise that resolves to an array of TypeHierarchyItem-instances",u=>u.map(E.TypeHierarchyItem.to))),new w.$LO("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[w.$JO.TypeHierarchyItem],new w.$KO("A promise that resolves to an array of TypeHierarchyItem-instances",u=>u.map(E.TypeHierarchyItem.to))),new w.$LO("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[w.$JO.TestItem],w.$KO.Void),new w.$LO("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[w.$JO.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],w.$KO.Void),new w.$LO("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[w.$JO.String.with("name","The context key name"),new w.$JO("value","The context key value",()=>!0,u=>u)],w.$KO.Void),new w.$LO("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[w.$JO.Uri,w.$JO.StringArray,new w.$JO("MappedEditsContext","Mapped Edits Context",u=>E.MappedEditsContext.is(u),u=>E.MappedEditsContext.from(u))],new w.$KO("A promise that resolves to a workspace edit or null",u=>u?E.WorkspaceEdit.to(u):null))];class v{static register(m){C.forEach(m.registerApiCommand,m),this.a(m)}static a(m){m.registerCommand(!1,"_validateWhenClauses",p.$ej)}}e.$Yhc=v;function S(u){return m=>{if(Array.isArray(m))return m.map(u)}}function k(u){if(!Array.isArray(u))return;const m=[];for(const o of u)A.$Vt(o)?m.push(E.DefinitionLink.to(o)):m.push(E.location.to(o));return m}}),define(Se[346],De([1,0,8,3,2,6,33,16,7]),function(fe,e,l,j,L,A,R,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ic=void 0;class E{static{this.a=0}constructor(S,k){this.extension=S,this.provider=k,this.handle=E.a++}}class M{constructor(S){this.session=S,this.responses=[]}}class C{static{this.a=0}constructor(S,k,u,m){this.f=u,this.g=m,this.b=new Map,this.d=new Map,this.e=S.getProxy(A.$6L.MainThreadInlineChat),k.registerApiCommand(new R.$LO("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new R.$JO("Run arguments","",o=>!0,o=>{if(o)return{initialRange:o.initialRange?p.Range.from(o.initialRange):void 0,initialSelection:w.$$L.isSelection(o.initialSelection)?p.Selection.from(o.initialSelection):void 0,message:o.message,autoSend:o.autoSend,position:o.position?p.Position.from(o.position):void 0}})],R.$KO.Void))}registerProvider(S,k,u){const m=new E(S,k);return this.b.set(m.handle,m),this.e.$registerInteractiveEditorProvider(m.handle,u?.label??S.displayName??S.name,S.identifier.value,typeof k.handleInteractiveEditorResponseFeedback=="function",typeof k.provideFollowups=="function",u?.supportReportIssue??!1),(0,j.$Rc)(()=>{this.e.$unregisterInteractiveEditorProvider(m.handle),this.b.delete(m.handle)})}async $prepareSession(S,k,u,m){const o=this.b.get(S);if(!o){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this.f.getDocument(L.URI.revive(k)),n=p.Selection.to(u),s=await o.provider.prepareInteractiveEditorSession({document:i,selection:n},m);if(!s)return;if(s.wholeRange&&!s.wholeRange.contains(n))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const c=C.a++;return this.d.set(c,new M(s)),{id:c,placeholder:s.placeholder,input:s.input,slashCommands:s.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:p.Range.from(s.wholeRange),message:s.message}}async $provideResponse(S,k,u,m){const o=this.b.get(S);if(!o)return;const i=this.d.get(k.id);if(!i)return;const n={prompt:u.prompt,selection:p.Selection.to(u.selection),wholeRange:p.Range.to(u.wholeRange),attempt:u.attempt,live:u.live,previewDocument:this.f.getDocument(L.URI.revive(u.previewDocument)),withIntentDetection:u.withIntentDetection};let s=!1;const c={report:async D=>{if(!u.live&&D.edits?.length)throw new Error("Progress reporting is only supported for live sessions");s||m.isCancellationRequested||await this.e.$handleProgressChunk(u.requestId,{message:D.message,edits:D.edits?.map(p.TextEdit.from),editsShouldBeInstant:D.editsShouldBeInstant,slashCommand:D.slashCommand?.command,markdownFragment:w.$wM.isMarkdownString(D.content)?D.content.value:D.content})}},t=Promise.resolve(o.provider.provideInteractiveEditorResponse(i.session,n,c,m));let f;try{f=await(0,l.$6g)(t,m)}finally{s=!0}if(!f)return;const h=i.responses.push(f)-1,r={wholeRange:p.Range.from(f.wholeRange),placeholder:f.placeholder};if(!C.h(f))return{...r,id:h,type:"editorEdit",message:p.MarkdownString.from(f.contents),edits:[]};const{edits:a,contents:d}=f,$=d!==void 0?p.MarkdownString.from(d):void 0;return a instanceof w.$fM?{...r,id:h,type:"bulkEdit",edits:p.WorkspaceEdit.from(a),message:$}:{...r,id:h,type:"editorEdit",edits:a.map(p.TextEdit.from),message:$}}async $provideFollowups(S,k,u,m){const o=this.b.get(S),i=this.d.get(k),n=i?.responses[u];if(o&&n&&o.provider.provideFollowups){const s=Promise.resolve(o.provider.provideFollowups(i.session,n,m));return(await(0,l.$6g)(s,m))?.map(p.ChatInlineFollowup.from)}}$handleFeedback(S,k,u,m){const o=this.b.get(S),i=this.d.get(k),n=i?.responses[u];if(o&&n){const s=p.InteractiveEditorResponseFeedbackKind.to(m);o.provider.handleInteractiveEditorResponseFeedback?.(i.session,n,s)}}$releaseSession(S,k){}static h(S){return typeof S=="object"&&typeof S.edits=="object"}}e.$9ic=C}),define(Se[347],De([1,0,2,33]),function(fe,e,l,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jjc=void 0;class L{constructor(R,p,w,E,M){this.a=p,this.b=w,this.c=E;const C=new j.$LO("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new j.$JO("showOptions","Show Options",v=>!0,v=>v),new j.$JO("resource","Interactive resource Uri",v=>!0,v=>v),new j.$JO("controllerId","Notebook controller Id",v=>!0,v=>v),new j.$JO("title","Interactive editor title",v=>!0,v=>v)],new j.$KO("Notebook and input URI",v=>{if(M.debug("[ExtHostInteractive] open iw with notebook editor id",v.notebookEditorId),v.notebookEditorId!==void 0){const S=this.a.getEditorById(v.notebookEditorId);return M.debug("[ExtHostInteractive] notebook editor found",S.id),{notebookUri:l.URI.revive(v.notebookUri),inputUri:l.URI.revive(v.inputUri),notebookEditor:S.apiEditor}}return M.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",v.notebookUri,v.inputUri),{notebookUri:l.URI.revive(v.notebookUri),inputUri:l.URI.revive(v.inputUri)}}));this.c.registerApiCommand(C)}$willAddInteractiveDocument(R,p,w,E){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:p,lines:[""],languageId:w,uri:R,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(R,p){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$jjc=L}),define(Se[348],De([1,0,19,8,22,4,3,28,2,25,12,6,33,16,7,113,290,26,67,291]),function(fe,e,l,j,L,A,R,p,w,E,M,C,v,S,k,u,m,o,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sjc=e.$rjc=void 0;let s=class{constructor($,D,b,g,y){this.m=D,this.n=b,this.o=g,this.q=y,this.b=new p.$Ac,this.c=new p.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new A.$5d,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=$.getProxy(C.$6L.MainThreadNotebookKernels);const P=new v.$LO("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new v.$JO("options","Select kernel options",U=>!0,U=>{if(U&&"notebookEditor"in U&&"id"in U){const z=this.n.getIdByEditor(U.notebookEditor);return{id:U.id,extension:U.extension,notebookEditorId:z}}else if(U&&"notebookEditor"in U){const z=this.n.getIdByEditor(U.notebookEditor);if(z===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${U.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:z}}return U})],v.$KO.Void),N=new v.$LO("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[v.$JO.Uri],new v.$KO("A promise that resolves to an array of variables",(U,z)=>U.map(F=>({name:F.name,value:F.value,type:F.type,editable:!1}))));this.o.registerApiCommand(P),this.o.registerApiCommand(N)}createNotebookController($,D,b,g,y,P){for(const ge of this.j.values())if(ge.controller.id===D&&E.$zm.equals($.identifier,ge.extensionId))throw new Error(`notebook controller with id '${D}' ALREADY exist`);const N=this.k++,U=this;this.q.trace(`NotebookController[${N}], CREATED by ${$.identifier.value}, ${D}`);const z=()=>console.warn(`NO execute handler from notebook controller '${T.id}' of extension: '${$.identifier}'`);let F=!1;const I=new A.$5d,O=new A.$5d,T={id:a($.identifier,D),notebookType:b,extensionId:$.identifier,extensionLocation:$.extensionLocation,label:g||$.identifier.value,preloads:P?P.map(S.NotebookRendererScript.from):[]};let G=y??z,te,x;this.a.$addKernel(N,T).catch(ge=>{console.log(ge),F=!0});let X=0;const Q=()=>{if(F)return;const ge=++X;Promise.resolve().then(()=>{ge===X&&this.a.$updateKernel(N,T)})},ae=new p.$Ac,_={get id(){return D},get notebookType(){return T.notebookType},onDidChangeSelectedNotebooks:I.event,get label(){return T.label},set label(ge){T.label=ge??$.displayName??$.name,Q()},get detail(){return T.detail??""},set detail(ge){T.detail=ge,Q()},get description(){return T.description??""},set description(ge){T.description=ge,Q()},get supportedLanguages(){return T.supportedLanguages},set supportedLanguages(ge){T.supportedLanguages=ge,Q()},get supportsExecutionOrder(){return T.supportsExecutionOrder??!1},set supportsExecutionOrder(ge){T.supportsExecutionOrder=ge,Q()},get rendererScripts(){return T.preloads?T.preloads.map(S.NotebookRendererScript.to):[]},get executeHandler(){return G},set executeHandler(ge){G=ge??z},get interruptHandler(){return te},set interruptHandler(ge){te=ge,T.supportsInterrupt=!!ge,Q()},set variableProvider(ge){(0,o.$YF)($,"notebookVariableProvider"),x=ge,T.hasVariableProvider=!!ge,ge?.onDidChangeVariables(se=>U.a.$variablesUpdated(se.uri)),Q()},get variableProvider(){return x},createNotebookCellExecution(ge){if(F)throw new Error("notebook controller is DISPOSED");if(!ae.has(ge.notebook.uri))throw U.q.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ae.keys()).map(se=>se.toString())),new Error(`notebook controller is NOT associated to notebook: ${ge.notebook.uri.toString()}`);return U._createNotebookCellExecution(ge,a($.identifier,this.id))},createNotebookExecution(ge){if((0,o.$YF)($,"notebookExecution"),F)throw new Error("notebook controller is DISPOSED");if(!ae.has(ge.uri))throw U.q.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ae.keys()).map(se=>se.toString())),new Error(`notebook controller is NOT associated to notebook: ${ge.uri.toString()}`);return U._createNotebookExecution(ge,a($.identifier,this.id))},dispose:()=>{F||(this.q.trace(`NotebookController[${N}], DISPOSED`),F=!0,this.j.delete(N),I.dispose(),O.dispose(),this.a.$removeKernel(N))},updateNotebookAffinity(ge,se){se===k.NotebookControllerAffinity2.Hidden&&(0,o.$YF)($,"notebookControllerAffinityHidden"),U.a.$updateNotebookPriority(N,ge.uri,se)},onDidReceiveMessage:O.event,postMessage(ge,se){return(0,o.$YF)($,"notebookMessaging"),U.a.$postMessage(N,se&&U.n.getIdByEditor(se),ge)},asWebviewUri(ge){return(0,o.$YF)($,"notebookMessaging"),(0,u.$Jxb)(ge,U.m.remote)}};return this.j.set(N,{extensionId:$.identifier,controller:_,onDidReceiveMessage:O,onDidChangeSelection:I,associatedNotebooks:ae}),_}getIdByController($){for(const[D,b]of this.j)if(b.controller===$)return a(b.extensionId,$.id);return null}createNotebookControllerDetectionTask($,D){const b=this.g++,g=this;this.q.trace(`NotebookControllerDetectionTask[${b}], CREATED by ${$.identifier.value}`),this.a.$addKernelDetectionTask(b,D);const y={dispose:()=>{this.f.delete(b),g.a.$removeKernelDetectionTask(b)}};return this.f.set(b,y),y}registerKernelSourceActionProvider($,D,b){const g=this.i++,y=typeof b.onDidChangeNotebookKernelSourceActions=="function"?g:void 0,P=this;this.h.set(g,b),this.q.trace(`NotebookKernelSourceActionProvider[${g}], CREATED by ${$.identifier.value}`),this.a.$addKernelSourceActionProvider(g,g,D);let N;return y!==void 0&&(N=b.onDidChangeNotebookKernelSourceActions(U=>this.a.$emitNotebookKernelSourceActionsChangeEvent(y))),{dispose:()=>{this.h.delete(g),P.a.$removeKernelSourceActionProvider(g,g),N?.dispose()}}}async $provideKernelSourceActions($,D){const b=this.h.get($);if(b){const g=new R.$Sc;return(await b.provideNotebookKernelSourceActions(D)??[]).map(P=>S.NotebookKernelSourceAction.from(P,this.o.converter,g))}return[]}$acceptNotebookAssociation($,D,b){const g=this.j.get($);if(g){const y=this.n.getNotebookDocument(w.URI.revive(D));b?g.associatedNotebooks.set(y.uri,!0):g.associatedNotebooks.delete(y.uri),this.q.trace(`NotebookController[${$}] ASSOCIATE notebook`,y.uri.toString(),b),g.onDidChangeSelection.fire({selected:b,notebook:y.apiNotebook})}}async $executeCells($,D,b){const g=this.j.get($);if(!g)return;const y=this.n.getNotebookDocument(w.URI.revive(D)),P=[];for(const N of b){const U=y.getCell(N);U&&P.push(U.apiCell)}try{this.q.trace(`NotebookController[${$}] EXECUTE cells`,y.uri.toString(),P.length),await g.controller.executeHandler.call(g.controller,P,y.apiNotebook,g.controller)}catch(N){this.q.error(`NotebookController[${$}] execute cells FAILED`,N),console.error(N)}}async $cancelCells($,D,b){const g=this.j.get($);if(!g)return;const y=this.n.getNotebookDocument(w.URI.revive(D));if(g.controller.interruptHandler)await g.controller.interruptHandler.call(g.controller,y.apiNotebook);else for(const P of b){const N=y.getCell(P);N&&this.b.get(N.uri)?.cancel()}if(g.controller.interruptHandler){const P=this.c.get(y.uri);b.length&&Array.isArray(P)&&P.length&&P.forEach(N=>N.dispose())}}async $provideVariables($,D,b,g,y,P,N){const U=this.j.get($);if(!U)return;const z=this.n.getNotebookDocument(w.URI.revive(b)),F=U.controller.variableProvider;if(!F)return;let I;if(g!==void 0){if(I=this.s[g],!I)return}else this.s={};const O=y==="named"?k.NotebookVariablesRequestKind.Named:k.NotebookVariablesRequestKind.Indexed,T=F.provideVariables(z.apiNotebook,I,O,P,N);let G=0;for await(const te of T){if(N.isCancellationRequested)return;const x={id:this.r++,name:te.variable.name,value:te.variable.value,type:te.variable.type,hasNamedChildren:te.hasNamedChildren,indexedChildrenCount:te.indexedChildrenCount,extensionId:U.extensionId.value};if(this.s[x.id]=te.variable,this.a.$receiveVariable(D,x),G++>=n.$8gb)return}}$acceptKernelMessageFromRenderer($,D,b){const g=this.j.get($);if(!g)return;const y=this.n.getEditorById(D);g.onDidReceiveMessage.fire(Object.freeze({editor:y.apiEditor,message:b}))}$cellExecutionChanged($,D,b){const y=this.n.getNotebookDocument(w.URI.revive($)).getCell(D);if(y){const P=b?S.NotebookCellExecutionState.to(b):k.NotebookCellExecutionState.Idle;P!==void 0&&this.l.fire({cell:y.apiCell,state:P})}}_createNotebookCellExecution($,D){if($.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const g=this.n.getNotebookDocument($.notebook.uri).getCellFromApiCell($);if(!g)throw new Error("invalid cell");if(this.b.has(g.uri))throw new Error(`duplicate execution for ${g.uri}`);const y=new t(D,g,this.a);this.b.set(g.uri,y);const P=y.onDidChangeState(()=>{y.state===c.Resolved&&(y.dispose(),P.dispose(),this.b.delete(g.uri))});return y.asApiObject()}_createNotebookExecution($,D){const b=this.n.getNotebookDocument($.uri),g=$.getCells().find(N=>{const U=b.getCellFromApiCell(N);return U&&this.b.has(U.uri)});if(g)throw new Error(`duplicate cell execution for ${g.document.uri}`);if(this.c.has(b.uri))throw new Error(`duplicate notebook execution for ${b.uri}`);const y=new h(D,b,this.a),P=y.onDidChangeState(()=>{y.state===f.Resolved&&(y.dispose(),P.dispose(),this.c.delete(b.uri))});return this.c.set(b.uri,[y,P]),y.asApiObject()}};e.$rjc=s,e.$rjc=s=Ye([Ve(4,M.$zj)],s);var c;(function(d){d[d.Init=0]="Init",d[d.Started=1]="Started",d[d.Resolved=2]="Resolved"})(c||(c={}));class t extends R.$Tc{static{this.a=0}get state(){return this.f}constructor($,D,b){super(),this.m=D,this.n=b,this.b=t.a++,this.c=new A.$5d,this.onDidChangeState=this.c.event,this.f=c.Init,this.g=this.B(new L.$ce),this.h=new r(10,g=>this.s(g)),this.j=D.internalMetadata.executionOrder,this.n.$createExecution(this.b,$,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r($){await this.h.addItem($)}async s($){const D=Array.isArray($)?$:[$];return this.n.$updateExecution(this.b,new i.$9v(D))}t(){if(this.f===c.Init)throw new Error("Must call start before modifying cell output");if(this.f===c.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w($){let D=this.m;if($&&(D=this.m.notebook.getCellFromApiCell($)),!D)throw new Error("INVALID cell");return D.handle}y($){return $.map(D=>{const b=k.$zN.ensureUniqueMimeTypes(D.items,!0);return b===D.items?S.NotebookCellOutput.from(D):S.NotebookCellOutput.from({items:b,id:D.id,metadata:D.metadata})})}async z($,D,b){const g=this.w(D),y=this.y((0,l.$3b)($));return this.r({editType:m.CellExecutionUpdateType.Output,cellHandle:g,append:b,outputs:y})}async C($,D,b){return $=k.$zN.ensureUniqueMimeTypes((0,l.$3b)($),!0),this.r({editType:m.CellExecutionUpdateType.OutputItems,items:$.map(S.NotebookCellOutputItem.from),outputId:D.id,append:b})}asApiObject(){const $=this;return Object.freeze({get token(){return $.g.token},get cell(){return $.m.apiCell},get executionOrder(){return $.j},set executionOrder(b){$.j=b,$.s([{editType:m.CellExecutionUpdateType.ExecutionState,executionOrder:$.j}])},start(b){if($.f===c.Resolved||$.f===c.Started)throw new Error("Cannot call start again");$.f=c.Started,$.c.fire(),$.s({editType:m.CellExecutionUpdateType.ExecutionState,runStartTime:b})},end(b,g){if($.f===c.Resolved)throw new Error("Cannot call resolve twice");$.f=c.Resolved,$.c.fire(),$.h.flush(),$.n.$completeExecution($.b,new i.$9v({runEndTime:g,lastRunSuccess:b}))},clearOutput(b){return $.t(),$.z([],b,!1)},appendOutput(b,g){return $.t(),$.z(b,g,!0)},replaceOutput(b,g){return $.t(),$.z(b,g,!1)},appendOutputItems(b,g){return $.t(),$.C(b,g,!0)},replaceOutputItems(b,g){return $.t(),$.C(b,g,!1)}})}}var f;(function(d){d[d.Init=0]="Init",d[d.Started=1]="Started",d[d.Resolved=2]="Resolved"})(f||(f={}));class h extends R.$Tc{static{this.a=0}get state(){return this.f}constructor($,D,b){super(),this.h=D,this.j=b,this.b=h.a++,this.c=new A.$5d,this.onDidChangeState=this.c.event,this.f=f.Init,this.g=this.B(new L.$ce),this.j.$createNotebookExecution(this.b,$,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===f.Resolved||this.f===f.Started)throw new Error("Cannot call start again");this.f=f.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===f.Resolved)throw new Error("Cannot call resolve twice");this.f=f.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class r{constructor($,D){this.f=$,this.g=D,this.a=[],this.b=Date.now()}addItem($){return this.a.push($),this.c||(this.c=new j.$Ch,this.b=Date.now(),(0,j.$gh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const $=this.c;this.c=void 0;const D=this.a;return this.a=[],this.g(D).finally(()=>$.complete())}}function a(d,$){return`${d.value}/${$}`}e.$sjc=a}),define(Se[46],De([1,0,4,6,5,2,20,3,7,224,13,268,22,30,269,55,8,16,33]),function(fe,e,l,j,L,A,R,p,w,E,M,C,v,S,k,u,m,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gic=e.$Fic=e.$Eic=e.$Dic=void 0,e.$Dic=(0,L.$fi)("IExtHostTerminalService");class n{constructor(b,g,y,P){this.l=b,this._id=g,this.m=y,this.n=P,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(U=>this.f=U);const N=this;this.value={get name(){return N.n||""},get processId(){return N.b},get creationOptions(){return N.m},get exitStatus(){return N.h},get state(){return N.j},get selection(){return N.k},sendText(U,z=!0){N.q(),N.l.$sendText(N._id,U,z)},show(U){N.q(),N.l.$show(N._id,U)},hide(){N.q(),N.l.$hide(N._id)},dispose(){N.a||(N.a=!0,N.l.$dispose(N._id))},get dimensions(){if(!(N.d===void 0||N.g===void 0))return{columns:N.d,rows:N.g}}}}async create(b,g){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:b.name,shellPath:b.shellPath??void 0,shellArgs:b.shellArgs??void 0,cwd:b.cwd??g?.cwd??void 0,env:b.env??void 0,icon:a(b.iconPath)??void 0,color:u.ThemeColor.isThemeColor(b.color)?b.color.id:void 0,initialText:b.message??void 0,strictEnv:b.strictEnv??void 0,hideFromUser:b.hideFromUser??void 0,forceShellIntegration:g?.forceShellIntegration??void 0,isFeatureTerminal:g?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:g?.useShellEnvironment??void 0,location:g?.location||this.o(b.location,g?.resolvedExtHostIdentifier),isTransient:b.isTransient??void 0})}async createExtensionTerminal(b,g,y,P,N){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:P,color:u.ThemeColor.isThemeColor(N)?N.id:void 0,location:g?.location||this.o(b,y),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(b,g){return typeof b=="object"?"parentTerminal"in b&&b.parentTerminal&&g?{parentTerminal:g}:"viewColumn"in b?{viewColumn:o.ViewColumn.from(b.viewColumn),preserveFocus:b.preserveFocus}:void 0:b}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(b){this.n=b}setExitStatus(b,g){this.h=Object.freeze({code:b,reason:g})}setDimensions(b,g){return b===this.d&&g===this.g||b===0||g===0?!1:(this.d=b,this.g=g,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(b){this.k=b}_setProcessId(b){this.f?(this.f(b),this.f=void 0):this.b.then(g=>{g!==b&&(this.b=Promise.resolve(b))})}}e.$Eic=n;class s{get onProcessReady(){return this.b.event}constructor(b){this.g=b,this.id=0,this.shouldPersist=!1,this.a=new l.$5d,this.onProcessData=this.a.event,this.b=new l.$5d,this.d=new l.$5d,this.onDidChangeProperty=this.d.event,this.f=new l.$5d,this.onProcessExit=this.f.event}refreshProperty(b){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${b}`)}updateProperty(b,g){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${b}, value: ${g}`)}async start(){}shutdown(){this.g.close()}input(b){this.g.handleInput?.(b)}resize(b,g){this.g.setDimensions?.({columns:b,rows:g})}clearBuffer(){}async processBinary(b){}acknowledgeDataEvent(b){}async setUnicodeVersion(b){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(b){this.g.onDidWrite(g=>this.a.fire(g)),this.g.onDidClose?.((g=void 0)=>{this.f.fire(g===void 0?void 0:g)}),this.g.onDidOverrideDimensions?.(g=>{g&&this.d.fire({type:"overrideDimensions",value:{cols:g.columns,rows:g.rows}})}),this.g.onDidChangeName?.(g=>{this.d.fire({type:"title",value:g})}),this.g.open(b||void 0),b&&this.g.setDimensions?.(b),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let c=1,t=class extends p.$Tc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(b=>b.value)}constructor(b,g,y){super(),this.Q=g,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new p.$Uc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new l.$5d,this.onDidCloseTerminal=this.H.event,this.I=new l.$5d,this.onDidOpenTerminal=this.I.event,this.J=new l.$5d,this.onDidChangeActiveTerminal=this.J.event,this.L=new l.$5d,this.onDidChangeTerminalDimensions=this.L.event,this.M=new l.$5d,this.onDidChangeTerminalState=this.M.event,this.N=new l.$5d,this.onDidChangeShell=this.N.event,this.O=new l.$5d({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new l.$5d({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=y.getProxy(j.$6L.MainThreadTerminalService),this.y=new k.$Ptb(this.a.$sendProcessData),this.a.$registerProcessSupport(b),this.Q.registerArgumentProcessor({processArgument:P=>{const N=U=>{const z=U;return this.W(z.instanceId)?.value};switch(P?.$mid){case 15:return N(P);default:{if(Array.isArray(P))for(let U=0;U<P.length&&P[U].$mid===15;U++)P[U]=N(P[U]);return P}}}}),this.B({dispose:()=>{for(const[P,N]of this.g)N.shutdown(!0)}})}getDefaultShell(b){return(b?this.u:this.s)?.path||""}getDefaultShellArgs(b){return(b?this.u:this.s)?.args||[]}createExtensionTerminal(b,g){const y=new n(this.a,(0,S.$Bg)(),b,b.name),P=new s(b.pty);return y.createExtensionTerminal(b.location,g,this.R(b,g).resolvedExtHostIdentifier,a(b.iconPath),d(b.color)).then(N=>{const U=this.S(N,P);this.h[N]=U}),this.f.push(y),y.value}R(b,g){if(g=g||{},b.location&&typeof b.location=="object"&&"parentTerminal"in b.location){const y=b.location.parentTerminal;if(y){const P=this.f.find(N=>N.value===y);P&&(g.resolvedExtHostIdentifier=P._id)}}else b.location&&typeof b.location!="object"?g.location=b.location:g.location&&typeof g.location=="object"&&"splitActiveTerminal"in g.location&&(g.location={splitActiveTerminal:!0});return g}attachPtyToTerminal(b,g){if(!this.W(b))throw new Error(`Cannot resolve terminal with id ${b} for virtual process`);const P=new s(g),N=this.S(b,P);this.h[b]=N}async $acceptActiveTerminalChanged(b){const g=this.b;if(b===null){this.b=void 0,g!==this.b&&this.J.fire(this.b);return}const y=this.W(b);y&&(this.b=y,g!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(b,g){const y=this.W(b);y&&this.O.fire({terminal:y.value,data:g})}async $acceptTerminalDimensions(b,g,y){const P=this.W(b);P&&P.setDimensions(g,y)&&this.L.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptDidExecuteCommand(b,g){const y=this.W(b);y&&this.P.fire({terminal:y.value,...g})}async $acceptTerminalMaximumDimensions(b,g,y){this.g.get(b)?.resize(g,y)}async $acceptTerminalTitleChange(b,g){const y=this.W(b);y&&(y.name=g)}async $acceptTerminalClosed(b,g,y){const P=this.Y(this.f,b);if(P!==null){const N=this.f.splice(P,1)[0];N.setExitStatus(g,y),this.H.fire(N.value)}}$acceptTerminalOpened(b,g,y,P){if(g){const z=this.Y(this.f,g);if(z!==null){this.f[z]._id=b,this.I.fire(this.terminals[z]),this.f[z].isOpen=!0;return}}const N={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:A.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},U=new n(this.a,b,N,y);this.f.push(U),this.I.fire(U.value),U.isOpen=!0}async $acceptTerminalProcessId(b,g){this.W(b)?._setProcessId(g)}async $startExtensionTerminal(b,g){const y=this.W(b);if(!y)return{message:(0,E.localize)(0,null,b)};y.isOpen||await new Promise(N=>{const U=this.onDidOpenTerminal(async z=>{z===y.value&&(U.dispose(),N())})});const P=this.g.get(b);P?P.startSendingEvents(g):this.j[b]={initialDimensions:g}}S(b,g){const y=new p.$Sc;y.add(g.onProcessReady(N=>this.a.$sendProcessReady(b,N.pid,N.cwd,N.windowsPty))),y.add(g.onDidChangeProperty(N=>this.a.$sendProcessProperty(b,N))),this.y.startBuffering(b,g.onProcessData),y.add(g.onProcessExit(N=>this.U(b,N))),this.g.set(b,g);const P=this.j[b];return P&&g instanceof s&&(g.startSendingEvents(P.initialDimensions),delete this.j[b]),y}$acceptProcessAckDataEvent(b,g){this.g.get(b)?.acknowledgeDataEvent(g)}$acceptProcessInput(b,g){this.g.get(b)?.input(g)}$acceptTerminalInteraction(b){const g=this.W(b);g?.setInteractedWith()&&this.M.fire(g.value)}$acceptTerminalSelection(b,g){this.W(b)?.setSelection(g)}$acceptProcessResize(b,g,y){try{this.g.get(b)?.resize(g,y)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown(b,g){this.g.get(b)?.shutdown(g)}$acceptProcessRequestInitialCwd(b){this.g.get(b)?.getInitialCwd().then(g=>this.a.$sendProcessProperty(b,{type:"initialCwd",value:g}))}$acceptProcessRequestCwd(b){this.g.get(b)?.getCwd().then(g=>this.a.$sendProcessProperty(b,{type:"cwd",value:g}))}$acceptProcessRequestLatency(b){return Promise.resolve(b)}registerLinkProvider(b){return this.z.add(b),this.z.size===1&&this.a.$startLinkProvider(),new w.$8L(()=>{this.z.delete(b),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(b,g,y){if(this.C.has(g))throw new Error(`Terminal profile provider "${g}" already registered`);return this.C.set(g,y),this.a.$registerProfileProvider(g,b.identifier.value),new w.$8L(()=>{this.C.delete(g),this.a.$unregisterProfileProvider(g)})}registerTerminalQuickFixProvider(b,g,y){if(this.D.has(b))throw new Error(`Terminal quick fix provider "${b}" is already registered`);return this.D.set(b,y),this.a.$registerQuickFixProvider(b,g),new w.$8L(()=>{this.D.delete(b),this.a.$unregisterQuickFixProvider(b)})}async $provideTerminalQuickFixes(b,g){const y=new v.$ce().token;if(y.isCancellationRequested)return;const P=this.D.get(b);if(!P)return;const N=await P.provideTerminalQuickFixes(g,y);if(N===null||Array.isArray(N)&&N.length===0)return;const U=new p.$Sc;if(this.w.value=U,!Array.isArray(N))return N?o.TerminalQuickFix.from(N,this.Q.converter,U):void 0;const z=[];for(const F of N){const I=o.TerminalQuickFix.from(F,this.Q.converter,U);I&&z.push(I)}return z}async $createContributedProfileTerminal(b,g){const y=new v.$ce().token;let P=await this.C.get(b)?.provideTerminalProfile(y);if(!y.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${b}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,g);return}this.createTerminalFromOptions(P.options,g)}}async $provideLinks(b,g){const y=this.W(b);if(!y)return[];this.F.delete(b),this.G.get(b)?.dispose(!0);const N=new v.$ce;this.G.set(b,N);const U=[],z={terminal:y.value,line:g},F=[];for(const T of this.z)F.push(m.Promises.withAsyncBody(async G=>{N.token.onCancellationRequested(()=>G({provider:T,links:[]}));const te=await T.provideTerminalLinks(z,N.token)||[];N.token.isCancellationRequested||G({provider:T,links:te})}));const I=await Promise.all(F);if(N.token.isCancellationRequested)return[];const O=new Map;for(const T of I)T&&T.links.length>0&&U.push(...T.links.map(G=>{const te={id:c++,startIndex:G.startIndex,length:G.length,label:G.tooltip};return O.set(te.id,{provider:T.provider,link:G}),te}));return this.F.set(b,O),U}$activateLink(b,g){const y=this.F.get(b)?.get(g);y&&y.provider.handleTerminalLink(y.link)}U(b,g){this.y.stopBuffering(b),this.g.delete(b),delete this.j[b];const y=this.h[b];y&&(y.dispose(),delete this.h[b]),this.a.$sendProcessExit(b,g)}W(b){return this.X(this.f,b)}X(b,g){const y=this.Y(b,g);return y!==null?b[y]:null}Y(b,g){const y=b.findIndex(P=>P._id===g);return y===-1?null:y}getEnvironmentVariableCollection(b){let g=this.n.get(b.identifier.value);return g||(g=new f,this.$(b.identifier.value,g)),g.getScopedEnvironmentVariableCollection(void 0)}Z(b,g){const y=(0,C.$1r)(g.map),P=(0,C.$2r)(g.descriptionMap);this.a.$setEnvironmentVariableCollection(b,g.persistent,y.length===0?void 0:y,P)}$initEnvironmentVariableCollections(b){b.forEach(g=>{const y=g[0],P=new f(g[1]);this.$(y,P)})}$acceptDefaultProfile(b,g){const y=this.s;this.s=b,this.u=g,y?.path!==b.path&&this.N.fire(b.path)}$(b,g){this.n.set(b,g),g.onDidChangeCollection(()=>{this.Z(b,g)})}};e.$Fic=t,e.$Fic=t=Ye([Ve(1,i.$HO),Ve(2,R.$lO)],t);class f{get persistent(){return this.b}set persistent(b){this.b=b,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(b){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new l.$5d,this.map=new Map(b)}getScopedEnvironmentVariableCollection(b){const g=this.h(b);let y=this.a.get(g);return y||(y=new h(this,b),this.a.set(g,y),y.onDidChangeCollection(()=>this.d.fire())),y}replace(b,g,y,P){this.f(b,{value:g,type:w.EnvironmentVariableMutatorType.Replace,options:y??{applyAtProcessCreation:!0},scope:P})}append(b,g,y,P){this.f(b,{value:g,type:w.EnvironmentVariableMutatorType.Append,options:y??{applyAtProcessCreation:!0},scope:P})}prepend(b,g,y,P){this.f(b,{value:g,type:w.EnvironmentVariableMutatorType.Prepend,options:y??{applyAtProcessCreation:!0},scope:P})}f(b,g){if(g.options&&g.options.applyAtProcessCreation===!1&&!g.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const y=this.g(b,g.scope),P=this.map.get(y),N=g.options?{applyAtProcessCreation:g.options.applyAtProcessCreation??!1,applyAtShellIntegration:g.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!P||P.value!==g.value||P.type!==g.type||P.options?.applyAtProcessCreation!==N.applyAtProcessCreation||P.options?.applyAtShellIntegration!==N.applyAtShellIntegration||P.scope?.workspaceFolder?.index!==g.scope?.workspaceFolder?.index){const U=this.g(b,g.scope),z={variable:b,...g,options:N};this.map.set(U,z),this.d.fire()}}get(b,g){const y=this.g(b,g),P=this.map.get(y);return P?$(P):void 0}g(b,g){const y=this.h(g);return y.length?`${b}:::${y}`:b}h(b){return this.j(b?.workspaceFolder)??""}j(b){return b?b.uri.toString():void 0}getVariableMap(b){const g=new Map;for(const[y,P]of this.map)this.h(P.scope)===this.h(b)&&g.set(P.variable,$(P));return g}delete(b,g){const y=this.g(b,g);this.map.delete(y),this.d.fire()}clear(b){if(b?.workspaceFolder){for(const[g,y]of this.map)y.scope?.workspaceFolder?.index===b.workspaceFolder.index&&this.map.delete(g);this.k(b)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(b,g){const y=this.h(g),P=this.descriptionMap.get(y);if(!P||P.description!==b){let N;typeof b=="string"?N=b:N=b?.value.split(`

`)[0];const U={description:N,scope:g};this.descriptionMap.set(y,U),this.d.fire()}}getDescription(b){const g=this.h(b);return this.descriptionMap.get(g)?.description}k(b){const g=this.h(b);this.descriptionMap.delete(g)}}class h{get persistent(){return this.b.persistent}set persistent(b){this.b.persistent=b}get onDidChangeCollection(){return this.a&&this.a.event}constructor(b,g){this.b=b,this.d=g,this.a=new l.$5d}getScoped(b){return this.b.getScopedEnvironmentVariableCollection(b)}replace(b,g,y){this.b.replace(b,g,y,this.d)}append(b,g,y){this.b.append(b,g,y,this.d)}prepend(b,g,y){this.b.prepend(b,g,y,this.d)}get(b){return this.b.get(b,this.d)}forEach(b,g){this.b.getVariableMap(this.d).forEach((y,P)=>b.call(g,P,y,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(b){this.b.delete(b,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(b){this.b.setDescription(b,this.d)}get description(){return this.b.getDescription(this.d)}}let r=class extends t{constructor(b,g){super(!1,b,g)}createTerminal(b,g,y){throw new M.$_}createTerminalFromOptions(b,g){throw new M.$_}};e.$Gic=r,e.$Gic=r=Ye([Ve(0,i.$HO),Ve(1,R.$lO)],r);function a(D){if(!(!D||typeof D=="string"))return"id"in D?{id:D.id,color:D.color}:D}function d(D){return u.ThemeColor.isThemeColor(D)?D:void 0}function $(D){const b={...D};return delete b.scope,b.options=b.options??void 0,delete b.variable,b}}),define(Se[349],De([1,0,8,21,22,4,73,54,3,24,18,30,12,6,20,154,16,7,66,112,89,26]),function(fe,e,l,j,L,A,R,p,w,E,M,C,v,S,k,u,m,o,i,n,s,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mjc=e.$Ljc=e.$Kjc=e.$Jjc=void 0;let t=class extends w.$Tc{constructor(F,I,O,T){super(),this.w=T,this.f=this.B(new A.$5d),this.g=new Map,this.s=this.B(new A.$5d),this.onResultsChanged=this.f.event,this.results=[],this.h=F.getProxy(S.$6L.MainThreadTesting),this.m=new y(this.h),this.j=new a(this.h,I),O.registerArgumentProcessor({processArgument:G=>{switch(G?.$mid){case 16:{const te=G,x=te.tests[te.tests.length-1].item.extId;return this.g.get(i.$WK.root(x))?.collection.tree.get(x)?.actual??(0,u.$xO)(G)}case 18:{const{extId:te,message:x}=G;return{test:this.g.get(i.$WK.root(te))?.collection.tree.get(te)?.actual,message:m.TestMessage.to(x)}}default:return G}}}),O.registerCommand(!1,"testing.getExplorerSelection",async()=>{const G=await O.executeCommand("_testing.getExplorerSelection"),te=x=>{const X=this.g.get(i.$WK.root(x));if(X)return i.$WK.isRoot(x)?X.controller:X.collection.tree.get(x)?.actual};return{include:G?.include.map(te).filter(M.$1f)||[],exclude:G?.exclude.map(te).filter(M.$1f)||[]}})}createTestController(F,I,O,T){if(this.g.has(I))throw new Error(`Attempt to insert a duplicate controller with ID "${I}"`);const G=new w.$Sc,te=G.add(new u.$AO(I,O,this.w));te.root.label=O;const x=new Map,X=new Set,Q=this.h,ae={items:te.root.children,get label(){return O},set label(ge){O=ge,te.root.label=ge,Q.$updateController(I,{label:O})},get refreshHandler(){return T},set refreshHandler(ge){T=ge,Q.$updateController(I,{canRefresh:!!ge})},get id(){return I},createRunProfile:(ge,se,re,B,ie,ye)=>{let le=(0,p.$6i)(ge);for(;x.has(le);)le++;return new N(this.h,x,X,this.s.event,I,le,ge,se,re,B,ie,ye)},createTestItem(ge,se,re){return new u.$yO(I,ge,se,re)},createTestRun:(ge,se,re=!0)=>this.j.createTestRun(F,I,te,ge,se,re),invalidateTestResults:ge=>{if(ge===void 0)this.h.$markTestRetired(void 0);else{const se=ge instanceof Array?ge:[ge];this.h.$markTestRetired(se.map(re=>i.$WK.fromExtHostTestItem(re,I).toString()))}},set resolveHandler(ge){te.resolveHandler=ge},get resolveHandler(){return te.resolveHandler},dispose:()=>{G.dispose()}};Q.$registerTestController(I,O,!!T),G.add((0,w.$Rc)(()=>Q.$unregisterTestController(I)));const _={controller:ae,collection:te,profiles:x,extension:F,activeProfiles:X};return this.g.set(I,_),G.add((0,w.$Rc)(()=>this.g.delete(I))),G.add(te.onDidGenerateDiff(ge=>Q.$publishDiff(I,ge.map(s.TestsDiffOp.serialize)))),ae}createTestObserver(){return this.m.checkout()}async runTests(F,I=L.CancellationToken.None){const O=d(F);if(!O)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const T=this.g.get(O.controllerId);if(!T)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:F.include?.map(G=>i.$WK.fromExtHostTestItem(G,T.collection.root.id).toString())??[T.collection.root.id],profileGroup:U[O.kind],profileId:O.profileId,controllerId:O.controllerId}],exclude:F.exclude?.map(G=>G.id)},I)}$syncTests(){for(const{collection:F}of this.g.values())F.flushDiff();return Promise.resolve()}async $provideFileCoverage(F,I,O){return await this.j.getCoverageReport(F,I)?.provideFileCoverage(O)??[]}async $resolveFileCoverage(F,I,O,T){return await this.j.getCoverageReport(F,I)?.resolveFileCoverage(O,T)??[]}$configureRunProfile(F,I){this.g.get(F)?.profiles.get(I)?.configureHandler?.()}$setDefaultRunProfiles(F){const I=new Map;for(const[O,T]of Object.entries(F)){const G=this.g.get(O);if(!G)continue;const te=new Map,x=T.filter(Q=>!G.activeProfiles.has(Q)),X=[...G.activeProfiles].filter(Q=>!T.includes(Q));for(const Q of x)te.set(Q,!0),G.activeProfiles.add(Q);for(const Q of X)te.set(Q,!1),G.activeProfiles.delete(Q);te.size&&I.set(O,te)}this.s.fire(I)}async $refreshTests(F,I){await this.g.get(F)?.controller.refreshHandler?.(I)}$publishTestResults(F){this.results=Object.freeze(F.map(I=>(0,E.$Ln)(m.TestResults.to(I))).concat(this.results).sort((I,O)=>O.completedAt-I.completedAt).slice(0,32)),this.f.fire()}async $expandTest(F,I){const O=this.g.get(i.$WK.fromString(F).controllerId)?.collection;O&&(await O.expand(F,I<0?1/0:I),O.flushDiff())}$acceptDiff(F){this.m.applyDiff(F.map(I=>s.TestsDiffOp.deserialize({asCanonicalUri:O=>O},I)))}async $runControllerTests(F,I){return Promise.all(F.map(O=>this.y(O,!1,I)))}async $startContinuousRun(F,I){const O=new L.$ce(I),T=await Promise.all(F.map(G=>this.y(G,!0,O.token)));return!I.isCancellationRequested&&!T.some(G=>G.error)&&await new Promise(G=>I.onCancellationRequested(G)),O.dispose(!0),T}async y(F,I,O){const T=this.g.get(F.controllerId);if(!T)return{};const{collection:G,profiles:te,extension:x}=T,X=te.get(F.profileId);if(!X)return{};const Q=F.testIds.map(se=>G.tree.get(se)).filter(M.$1f),ae=F.excludeExtIds.map(se=>T.collection.tree.get(se)).filter(M.$1f).filter(se=>Q.some(re=>re.fullId.compare(se.fullId)===2));if(!Q.length)return{};const _=new o.$GN(Q.some(se=>se.actual instanceof u.$zO)?void 0:Q.map(se=>se.actual),ae.map(se=>se.actual),X,I),ge=(0,s.$YK)(F)&&this.j.prepareForMainThreadTestRun(_,$.fromInternal(F,T.collection),x,O);try{return await X.runHandler(_,O),{}}catch(se){return{error:String(se)}}finally{ge&&(ge.hasRunningTasks&&!O.isCancellationRequested&&await A.Event.toPromise(ge.onEnd),ge.dispose())}}$cancelExtensionTestRun(F){F===void 0?this.j.cancelAllRuns():this.j.cancelRunById(F)}};e.$Jjc=t,e.$Jjc=t=Ye([Ve(0,k.$lO),Ve(1,v.$zj)],t);const f=1e4;var h;(function(z){z[z.Running=0]="Running",z[z.Cancelling=1]="Cancelling",z[z.Ended=2]="Ended"})(h||(h={}));class r extends w.$Tc{get hasRunningTasks(){return this.f.size>0}get id(){return this.s.id}constructor(F,I,O,T,G){super(),this.s=F,this.w=I,this.y=O,this.z=T,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new A.$5d),this.m=this.B(new A.$5d),this.onDidCoverage=this.m.event,this.onEnd=this.j.event,this.h=this.B(new L.$ce(G));const te=this.B(new l.$rh(()=>this.C(),f));this.B(this.h.token.onCancellationRequested(()=>te.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.C()}createRun(F){const I=this.s.id,O=this.s.controllerId,T=(0,C.$Bg)(),G=this.y,te=this.m;let x;const X=ge=>(se,...re)=>{if(ae){this.z.warn(`Setting the state of test "${se.id}" is a no-op after the run ends.`);return}this.s.isIncluded(se)&&(this.F(se),ge(se,...re))},Q=(ge,se)=>{const re=se instanceof Array?se.map(m.TestMessage.from):[m.TestMessage.from(se)];if(ge.uri&&ge.range){const B={range:m.Range.from(ge.range),uri:ge.uri};for(const ie of re)ie.location=ie.location||B}this.w.$appendTestMessagesInRun(I,T,i.$WK.fromExtHostTestItem(ge,O).toString(),re)};let ae=!1;const _={isPersisted:this.s.isPersisted,token:this.h.token,name:F,get coverageProvider(){return x?.provider},set coverageProvider(ge){(0,c.$YF)(G,"testCoverage"),x=ge&&new D(ge),te.fire({taskId:T,runId:I,coverage:x})},enqueued:X(ge=>{this.w.$updateTestStateInRun(I,T,i.$WK.fromExtHostTestItem(ge,O).toString(),1)}),skipped:X(ge=>{this.w.$updateTestStateInRun(I,T,i.$WK.fromExtHostTestItem(ge,O).toString(),5)}),started:X(ge=>{this.w.$updateTestStateInRun(I,T,i.$WK.fromExtHostTestItem(ge,O).toString(),2)}),errored:X((ge,se,re)=>{Q(ge,se),this.w.$updateTestStateInRun(I,T,i.$WK.fromExtHostTestItem(ge,O).toString(),6,re)}),failed:X((ge,se,re)=>{Q(ge,se),this.w.$updateTestStateInRun(I,T,i.$WK.fromExtHostTestItem(ge,O).toString(),4,re)}),passed:X((ge,se)=>{this.w.$updateTestStateInRun(I,T,i.$WK.fromExtHostTestItem(ge,this.s.controllerId).toString(),3,se)}),appendOutput:(ge,se,re)=>{ae||(re&&(this.s.isIncluded(re)?this.F(re):re=void 0),this.w.$appendOutputToRun(I,T,j.$se.fromString(ge),se&&m.location.from(se),re&&i.$WK.fromExtHostTestItem(re,O).toString()))},end:()=>{ae||(ae=!0,this.w.$finishedTestRunTask(I,T),this.f.delete(T),this.f.size||this.D())}};return this.f.set(T,{run:_}),this.w.$startedTestRunTask(I,{id:T,name:F,running:!0}),_}C(){for(const{run:F}of this.f.values())F.end()}D(){this.c!==2&&(this.c=2,this.j.fire())}F(F){if(!(F instanceof u.$yO))throw new n.$dO(F.id);if(this.g.has(i.$WK.fromExtHostTestItem(F,this.s.controllerId).toString()))return;const I=[],O=this.s.colllection.root;for(;;){const T=m.TestItem.from(F);if(I.unshift(T),this.g.has(T.extId)||(this.g.add(T.extId),F===O))break;F=F.parent||O}this.w.$addTestsToRun(this.s.controllerId,this.s.id,I)}dispose(){this.D(),super.dispose()}}class a{get trackers(){return this.c.values()}constructor(F,I){this.g=F,this.h=I,this.c=new Map,this.f=[]}getCoverageReport(F,I){return this.f.find(O=>O.runId===F)?.coverage.get(I)}prepareForMainThreadTestRun(F,I,O,T){return this.j(F,I,O,T)}cancelRunById(F){for(const I of this.c.values())if(I.id===F){I.cancel();return}}cancelAllRuns(){for(const F of this.c.values())F.cancel()}createTestRun(F,I,O,T,G,te){const x=this.c.get(T);if(x)return x.createRun(G);const X=$.fromPublic(I,O,T,te),Q=d(T);this.g.$startedExtensionTestRun({controllerId:I,continuous:!!T.continuous,profile:Q&&{group:U[Q.kind],id:Q.profileId},exclude:T.exclude?.map(_=>i.$WK.fromExtHostTestItem(_,O.root.id).toString())??[],id:X.id,include:T.include?.map(_=>i.$WK.fromExtHostTestItem(_,O.root.id).toString())??[O.root.id],persist:te});const ae=this.j(T,X,F);return A.Event.once(ae.onEnd)(()=>{this.g.$finishedExtensionTestRun(X.id),ae.dispose()}),ae.createRun(G)}j(F,I,O,T){const G=new r(I,this.g,O,this.h,T);this.c.set(F,G);let te;const x=G.onDidCoverage(({runId:X,taskId:Q,coverage:ae})=>{te||(te={runId:X,coverage:new Map},this.f.unshift(te),this.f.length>s.$4K&&this.f.pop()),te.coverage.set(Q,ae),this.g.$signalCoverageAvailable(X,Q,!!ae)});return A.Event.once(G.onEnd)(()=>{this.c.delete(F),x.dispose()}),G}}e.$Kjc=a;const d=z=>{if(z.profile){if(!(z.profile instanceof N))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return z.profile}};class ${static fromPublic(F,I,O,T){return new $(F,(0,C.$Bg)(),O.include?.map(G=>i.$WK.fromExtHostTestItem(G,F).toString())??[F],O.exclude?.map(G=>i.$WK.fromExtHostTestItem(G,F).toString())??[],T,I)}static fromInternal(F,I){return new $(F.controllerId,F.runId,F.testIds,F.excludeExtIds,!0,I)}constructor(F,I,O,T,G,te){this.controllerId=F,this.id=I,this.isPersisted=G,this.colllection=te,this.c=O.map(x=>x+"\0"),this.f=T.map(x=>x+"\0")}isIncluded(F){const I=i.$WK.fromExtHostTestItem(F,this.controllerId).toString()+"\0";for(const O of this.f)if(I===O||I.startsWith(O))return!1;for(const O of this.c)if(I===O||I.startsWith(O))return!0;return!1}}e.$Ljc=$;class D{constructor(F){this.provider=F}async provideFileCoverage(F){this.c||(this.c=(async()=>this.provider.provideFileCoverage(F))());try{return(await this.c)?.map(m.TestCoverage.fromFile)??[]}catch(I){throw this.c=void 0,I}}async resolveFileCoverage(F,I){const O=await this.c;let T=O?.[F];return!this.provider||!O||!T?[]:(T.detailedCoverage||(T=O[F]=await this.provider.resolveFileCoverage?.(T,I)??T),T.detailedCoverage?.map(m.TestCoverage.fromDetailed)??[])}}class b{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(F){this.j=F,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(F){this.c.add(F)}update(F){Object.assign(F.revived,m.TestItem.toPlain(F.item)),this.c.has(F)||this.f.add(F)}remove(F){if(this.c.has(F)){this.c.delete(F);return}this.f.delete(F);const I=i.$WK.parentId(F.item.extId);if(I&&this.h.has(I.toString())){this.h.add(F.item.extId);return}this.g.add(F)}getChangeEvent(){const{c:F,f:I,g:O}=this;return{get added(){return[...F].map(T=>T.revived)},get updated(){return[...I].map(T=>T.revived)},get removed(){return[...O].map(T=>T.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class g extends s.$5K{constructor(){super(...arguments),this.s=new A.$5d,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(F){return this.f.get(F)}getMirroredTestDataByReference(F){return this.f.get(F.id)}w(F,I){return{...F,revived:m.TestItem.toPlain(F.item),depth:I?I.depth+1:0,children:new Set}}v(){return new b(this.s)}}class y{constructor(F){this.f=F}checkout(){this.c||(this.c=this.g());const F=this.c;return F.observers++,{onDidChangeTest:F.tests.onDidChangeTests,get tests(){return[...F.tests.rootTests].map(I=>I.revived)},dispose:(0,R.$db)(()=>{--F.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(F){return this.c?.tests.getMirroredTestDataByReference(F)}applyDiff(F){this.c?.tests.apply(F)}g(){const F=new g({asCanonicalUri:I=>I});return this.f.$subscribeToDiffs(),{observers:0,tests:F}}}const P=(z,F,I,O)=>{I?Object.assign(I,O):F.$updateTestRunConfig(z.controllerId,z.profileId,O)};class N{#e;#t;#i;#n;#s;get label(){return this.f}set label(F){F!==this.f&&(this.f=F,P(this,this.#e,this.#n,{label:F}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(F){F!==this.g&&(this.g=F,P(this,this.#e,this.#n,{supportsContinuousRun:F}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(F){F!==this.isDefault&&(F?this.#t.add(this.profileId):this.#t.delete(this.profileId),P(this,this.#e,this.#n,{isDefault:F}))}get tag(){return this._tag}set tag(F){F?.id!==this._tag?.id&&(this._tag=F,P(this,this.#e,this.#n,{tag:F?m.TestTag.namespace(this.controllerId,F.id):null}))}get configureHandler(){return this.c}set configureHandler(F){F!==this.c&&(this.c=F,P(this,this.#e,this.#n,{hasConfigurationHandler:!!F}))}get onDidChangeDefault(){return A.Event.chain(this.#i,F=>F.map(I=>I.get(this.controllerId)?.get(this.profileId)).filter(M.$1f))}constructor(F,I,O,T,G,te,x,X,Q,ae=!1,_=void 0,ge=!1){this.controllerId=G,this.profileId=te,this.f=x,this.kind=X,this.runHandler=Q,this._tag=_,this.g=ge,this.#e=F,this.#s=I,this.#t=O,this.#i=T,I.set(te,this);const se=U[X];if(typeof se!="number")throw new Error(`Unknown TestRunProfile.group ${X}`);ae&&O.add(te),this.#n={profileId:te,controllerId:G,tag:_?m.TestTag.namespace(this.controllerId,_.id):null,label:x,group:se,isDefault:ae,hasConfigurationHandler:!1,supportsContinuousRun:ge},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$Mjc=N;const U={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(Se[155],De([1,0,61,13,124,16,7]),function(fe,e,l,j,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uO=e.$tO=e.$sO=void 0;class p{static{this.c=new L.$qO("TextEditorDecorationType")}constructor(v,S,k){const u=p.c.nextId();v.$registerTextEditorDecorationType(S.identifier,u,A.DecorationRenderOptions.from(k)),this.value=Object.freeze({key:u,dispose(){v.$removeTextEditorDecorationType(u)}})}}e.$sO=p;class w{constructor(v,S){this.g=[],this.h=void 0,this.j=!1,this.c=v,this.d=v.version,this.e=S.undoStopBefore,this.f=S.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(v,S){this.k();let k=null;if(v instanceof R.$9L)k=new R.$0L(v,v);else if(v instanceof R.$0L)k=v;else throw new Error("Unrecognized location");this.l(k,S,!1)}insert(v,S){this.k(),this.l(new R.$0L(v,v),S,!0)}delete(v){this.k();let S=null;if(v instanceof R.$0L)S=v;else throw new Error("Unrecognized location");this.l(S,null,!0)}l(v,S,k){const u=this.c.validateRange(v);this.g.push({range:u,text:S,forceMoveMarkers:k})}setEndOfLine(v){if(this.k(),v!==R.EndOfLine.LF&&v!==R.EndOfLine.CRLF)throw(0,j.$7)("endOfLine");this.h=v}}class E{constructor(v,S,k,u){this.c=v,this.d=S,this._accept(k),this.e=u;const m=this;this.value={get tabSize(){return m.f},set tabSize(o){m.n(o)},get indentSize(){return m.g},set indentSize(o){m.p(o)},get insertSpaces(){return m.j},set insertSpaces(o){m.s(o)},get cursorStyle(){return m.k},set cursorStyle(o){m.t(o)},get lineNumbers(){return m.l},set lineNumbers(o){m.u(o)}}}_accept(v){this.f=v.tabSize,this.g=v.indentSize,this.h=v.originalIndentSize,this.j=v.insertSpaces,this.k=v.cursorStyle,this.l=A.TextEditorLineNumbersStyle.to(v.lineNumbers)}m(v){if(v==="auto")return"auto";if(typeof v=="number"){const S=Math.floor(v);return S>0?S:null}if(typeof v=="string"){const S=parseInt(v,10);return isNaN(S)?null:S>0?S:null}return null}n(v){const S=this.m(v);if(S!==null){if(typeof S=="number"){if(this.f===S)return;this.f=S}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:S}))}}o(v){if(v==="tabSize")return"tabSize";if(typeof v=="number"){const S=Math.floor(v);return S>0?S:null}if(typeof v=="string"){const S=parseInt(v,10);return isNaN(S)?null:S>0?S:null}return null}p(v){const S=this.o(v);if(S!==null){if(typeof S=="number"){if(this.h===S)return;this.g=S,this.h=S}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:S}))}}q(v){return v==="auto"?"auto":v==="false"?!1:!!v}s(v){const S=this.q(v);if(typeof S=="boolean"){if(this.j===S)return;this.j=S}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:S}))}t(v){this.k!==v&&(this.k=v,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:v})))}u(v){this.l!==v&&(this.l=v,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:A.TextEditorLineNumbersStyle.from(v)})))}assign(v){const S={};let k=!1;if(typeof v.tabSize<"u"){const u=this.m(v.tabSize);u==="auto"?(k=!0,S.tabSize=u):typeof u=="number"&&this.f!==u&&(this.f=u,k=!0,S.tabSize=u)}if(typeof v.indentSize<"u"){const u=this.o(v.indentSize);u==="tabSize"?(k=!0,S.indentSize=u):typeof u=="number"&&this.h!==u&&(this.g=u,this.h=u,k=!0,S.indentSize=u)}if(typeof v.insertSpaces<"u"){const u=this.q(v.insertSpaces);u==="auto"?(k=!0,S.insertSpaces=u):this.j!==u&&(this.j=u,k=!0,S.insertSpaces=u)}typeof v.cursorStyle<"u"&&this.k!==v.cursorStyle&&(this.k=v.cursorStyle,k=!0,S.cursorStyle=v.cursorStyle),typeof v.lineNumbers<"u"&&this.l!==v.lineNumbers&&(this.l=v.lineNumbers,k=!0,S.lineNumbers=A.TextEditorLineNumbersStyle.from(v.lineNumbers)),k&&this.v("setOptions",this.c.$trySetOptions(this.d,S))}v(v,S){S.catch(k=>{this.e.warn(`ExtHostTextEditorOptions '${v}' failed:'`),this.e.warn(k)})}}e.$tO=E;class M{constructor(v,S,k,u,m,o,i,n){this.id=v,this.j=S,this.k=k,this.g=!1,this.h=new Set,this.c=m,this.d=new E(this.j,this.id,o,k),this.e=i,this.f=n;const s=this;this.value=Object.freeze({get document(){return u.value},set document(c){throw new j.$9("document")},get selection(){return s.c&&s.c[0]},set selection(c){if(!(c instanceof R.$$L))throw(0,j.$7)("selection");s.c=[c],s.l()},get selections(){return s.c},set selections(c){if(!Array.isArray(c)||c.some(t=>!(t instanceof R.$$L)))throw(0,j.$7)("selections");s.c=c,s.l()},get visibleRanges(){return s.e},set visibleRanges(c){throw new j.$9("visibleRanges")},get options(){return s.d.value},set options(c){s.g||s.d.assign(c)},get viewColumn(){return s.f},set viewColumn(c){throw new j.$9("viewColumn")},edit(c,t={undoStopBefore:!0,undoStopAfter:!0}){if(s.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const f=new w(u.value,t);return c(f),s.m(f)},insertSnippet(c,t,f={undoStopBefore:!0,undoStopAfter:!0}){if(s.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let h;if(!t||Array.isArray(t)&&t.length===0)h=s.c.map(r=>A.Range.from(r));else if(t instanceof R.$9L){const{lineNumber:r,column:a}=A.Position.from(t);h=[{startLineNumber:r,startColumn:a,endLineNumber:r,endColumn:a}]}else if(t instanceof R.$0L)h=[A.Range.from(t)];else{h=[];for(const r of t)if(r instanceof R.$0L)h.push(A.Range.from(r));else{const{lineNumber:a,column:d}=A.Position.from(r);h.push({startLineNumber:a,startColumn:d,endLineNumber:a,endColumn:d})}}return S.$tryInsertSnippet(v,u.value.version,c.value,h,f)},setDecorations(c,t){const f=t.length===0;f&&!s.h.has(c.key)||(f?s.h.delete(c.key):s.h.add(c.key),s.n(()=>{if(A.$iO(t))return S.$trySetDecorations(v,c.key,A.$jO(t));{const h=new Array(4*t.length);for(let r=0,a=t.length;r<a;r++){const d=t[r];h[4*r]=d.start.line+1,h[4*r+1]=d.start.character+1,h[4*r+2]=d.end.line+1,h[4*r+3]=d.end.character+1}return S.$trySetDecorationsFast(v,c.key,h)}}))},revealRange(c,t){s.n(()=>S.$tryRevealRange(v,A.Range.from(c),t||R.TextEditorRevealType.Default))},show(c){S.$tryShowEditor(v,A.ViewColumn.from(c))},hide(){S.$tryHideEditor(v)}})}dispose(){(0,l.ok)(!this.g),this.g=!0}_acceptOptions(v){(0,l.ok)(!this.g),this.d._accept(v)}_acceptVisibleRanges(v){(0,l.ok)(!this.g),this.e=v}_acceptViewColumn(v){(0,l.ok)(!this.g),this.f=v}_acceptSelections(v){(0,l.ok)(!this.g),this.c=v}async l(){const v=this.c.map(A.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,v)),this.value}m(v){const S=v.finalize();if(S.edits.length===0&&!S.setEndOfLine)return Promise.resolve(!0);const k=S.edits.map(m=>m.range);k.sort((m,o)=>m.end.line===o.end.line?m.end.character===o.end.character?m.start.line===o.start.line?m.start.character-o.start.character:m.start.line-o.start.line:m.end.character-o.end.character:m.end.line-o.end.line);for(let m=0,o=k.length-1;m<o;m++){const i=k[m].end;if(k[m+1].start.isBefore(i))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const u=S.edits.map(m=>({range:A.Range.from(m.range),text:m.text,forceMoveMarkers:m.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,S.documentVersionId,u,{setEndOfLine:typeof S.setEndOfLine=="number"?A.EndOfLine.from(S.setEndOfLine):void 0,undoStopBefore:S.undoStopBefore,undoStopAfter:S.undoStopAfter})}n(v){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):v().then(()=>this,S=>(S instanceof Error&&S.name==="DISPOSED"||this.k.warn(S),null))}}e.$uO=M}),define(Se[71],De([1,0,61,4,3,2,5,6,152,20,155,16,12,28,15,48,43]),function(fe,e,l,j,L,A,R,p,w,E,M,C,v,S,k,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wO=e.$vO=void 0;class o{constructor(s){this.value=s,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let i=class{constructor(s,c){this.h=s,this.i=c,this.a=null,this.b=new Map,this.c=new S.$Ac,this.d=new j.$5d,this.e=new j.$5d,this.f=new j.$5d,this.g=new j.$5d,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(s){this.acceptDocumentsAndEditorsDelta(s)}acceptDocumentsAndEditorsDelta(s){const c=[],t=[],f=[];if(s.removedDocuments)for(const h of s.removedDocuments){const r=A.URI.revive(h),a=this.c.get(r);a?.unref()&&(this.c.delete(r),c.push(a.value))}if(s.addedDocuments)for(const h of s.addedDocuments){const r=A.URI.revive(h.uri);let a=this.c.get(r);if(a&&r.scheme!==k.Schemas.vscodeNotebookCell&&r.scheme!==k.Schemas.vscodeInteractiveInput)throw new Error(`document '${r} already exists!'`);a||(a=new o(new w.$oO(this.h.getProxy(p.$6L.MainThreadDocuments),r,h.lines,h.EOL,h.versionId,h.languageId,h.isDirty)),this.c.set(r,a),t.push(a.value)),a.ref()}if(s.removedEditors)for(const h of s.removedEditors){const r=this.b.get(h);this.b.delete(h),r&&f.push(r)}if(s.addedEditors)for(const h of s.addedEditors){const r=A.URI.revive(h.documentUri);l.ok(this.c.has(r),`document '${r}' does not exist`),l.ok(!this.b.has(h.id),`editor '${h.id}' already exists!`);const a=this.c.get(r).value,d=new M.$uO(h.id,this.h.getProxy(p.$6L.MainThreadTextEditors),this.i,new m.$V(()=>a.document),h.selections.map(C.Selection.to),h.options,h.visibleRanges.map($=>C.Range.to($)),typeof h.editorPosition=="number"?C.ViewColumn.to(h.editorPosition):void 0);this.b.set(h.id,d)}s.newActiveEditor!==void 0&&(l.ok(s.newActiveEditor===null||this.b.has(s.newActiveEditor),`active editor '${s.newActiveEditor}' does not exist`),this.a=s.newActiveEditor),(0,L.$Oc)(c),(0,L.$Oc)(f),s.removedDocuments&&this.e.fire(c),s.addedDocuments&&this.d.fire(t),(s.removedEditors||s.addedEditors)&&this.f.fire(this.allEditors().map(h=>h.value)),s.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(s){return this.c.get(s)?.value}allDocuments(){return u.Iterable.map(this.c.values(),s=>s.value)}getEditor(s){return this.b.get(s)}activeEditor(s){if(!this.a)return;const c=this.b.get(this.a);return s?c:c?.value}allEditors(){return[...this.b.values()]}};e.$vO=i,e.$vO=i=Ye([Ve(0,E.$lO),Ve(1,v.$zj)],i),e.$wO=(0,R.$fi)("IExtHostDocumentsAndEditors")}),define(Se[350],De([1,0,19,4,6,155,16,7]),function(fe,e,l,j,L,A,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9hc=void 0;class w{constructor(M,C){this.i=C,this.a=new j.$5d,this.b=new j.$5d,this.c=new j.$5d,this.d=new j.$5d,this.f=new j.$5d,this.g=new j.$5d,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=M.getProxy(L.$6L.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(v=>this.g.fire(v)),this.i.onDidChangeActiveTextEditor(v=>this.f.fire(v))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(M){const C=this.i.allEditors();return M?C:C.map(v=>v.value)}async showTextDocument(M,C,v){let S;typeof C=="number"?S={position:R.ViewColumn.from(C),preserveFocus:v}:typeof C=="object"?S={position:R.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selection:typeof C.selection=="object"?R.Range.from(C.selection):void 0,pinned:typeof C.preview=="boolean"?!C.preview:void 0}:S={preserveFocus:!1};const k=await this.h.$tryShowTextDocument(M.uri,S),u=k&&this.i.getEditor(k);if(u)return u.value;throw k?new Error(`Could NOT open editor for "${M.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${M.uri.toString()}".`)}createTextEditorDecorationType(M,C){return new A.$sO(this.h,M,C).value}$acceptEditorPropertiesChanged(M,C){const v=this.i.getEditor(M);if(!v)throw new Error("unknown text editor");if(C.options&&v._acceptOptions(C.options),C.selections){const S=C.selections.selections.map(R.Selection.to);v._acceptSelections(S)}if(C.visibleRanges){const S=l.$Hb(C.visibleRanges.map(R.Range.to));v._acceptVisibleRanges(S)}if(C.options&&this.b.fire({textEditor:v.value,options:{...C.options,lineNumbers:R.TextEditorLineNumbersStyle.to(C.options.lineNumbers)}}),C.selections){const S=p.TextEditorSelectionChangeKind.fromValue(C.selections.source),k=C.selections.selections.map(R.Selection.to);this.a.fire({textEditor:v.value,selections:k,kind:S})}if(C.visibleRanges){const S=l.$Hb(C.visibleRanges.map(R.Range.to));this.c.fire({textEditor:v.value,visibleRanges:S})}}$acceptEditorPositionData(M){for(const C in M){const v=this.i.getEditor(C);if(!v)throw new Error("Unknown text editor");const S=R.ViewColumn.to(M[C]);v.value.viewColumn!==S&&(v._acceptViewColumn(S),this.d.fire({textEditor:v.value,viewColumn:S}))}}getDiffInformation(M){return Promise.resolve(this.h.$getDiffInformation(M))}}e.$9hc=w}),define(Se[351],De([1,0,2,5,6,3,7,16,25,18]),function(fe,e,l,j,L,A,R,p,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pjc=e.$Ojc=void 0,e.$Ojc=(0,j.$fi)("IExtHostTimeline");class M{constructor(S,k){this.b=new Map,this.c=new Map,this.a=S.getProxy(L.$6L.MainThreadTimeline),k.registerArgumentProcessor({processArgument:(u,m)=>{if(u&&u.$mid===12)if(this.b.get(u.source)&&w.$zm.equals(m,this.b.get(u.source)?.extension)){const o=u.uri===void 0?void 0:l.URI.revive(u.uri);return this.c.get(u.source)?.get(C(o))?.get(u.handle)}else return;return u}})}async $getTimeline(S,k,u,m){return this.b.get(S)?.provider.provideTimeline(l.URI.revive(k),u,m)}registerTimelineProvider(S,k,u,m){const o=new A.$Sc,i=this.d(k.id,m,o).bind(this);let n;k.onDidChange&&(n=k.onDidChange(c=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...c,id:k.id}),this));const s=this.c;return this.f({...k,scheme:S,onDidChange:void 0,async provideTimeline(c,t,f){t?.resetCache&&(o.clear(),s.get(k.id)?.clear());const h=await k.provideTimeline(c,t,f);if(h==null)return;const r=i(c,t);return{...h,source:k.id,items:h.items.map(r)}},dispose(){for(const c of s.values())c.get(k.id)?.clear();n?.dispose(),o.dispose()}},u)}d(S,k,u){return(m,o)=>{let i;if(o?.cacheResults){let n=this.c.get(S);n===void 0&&(n=new Map,this.c.set(S,n));const s=C(m);i=n.get(s),i===void 0&&(i=new Map,n.set(s,i))}return n=>{const{iconPath:s,...c}=n,t=`${S}|${n.id??n.timestamp}`;i?.set(t,n);let f,h,r;n.iconPath&&(s instanceof R.$3M?r={id:s.id,color:s.color}:l.URI.isUri(s)?(f=s,h=s):{light:f,dark:h}=s);let a;return R.$wM.isMarkdownString(c.tooltip)?a=p.MarkdownString.from(c.tooltip):(0,E.$Sf)(c.tooltip)?a=c.tooltip:R.$wM.isMarkdownString(c.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),a=p.MarkdownString.from(c.detail)):(0,E.$Sf)(c.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),a=c.detail),{...c,id:c.id??void 0,handle:t,source:S,command:n.command?k.toInternal(n.command,u):void 0,icon:f,iconDark:h,themeIcon:r,tooltip:a,accessibilityInformation:n.accessibilityInformation}}}}f(S,k){if(this.b.get(S.id))throw new Error(`Timeline Provider ${S.id} already exists.`);return this.a.$registerTimelineProvider({id:S.id,label:S.label,scheme:S.scheme}),this.b.set(S.id,{provider:S,extension:k}),(0,A.$Rc)(()=>{for(const m of this.c.values())m.get(S.id)?.clear();this.b.delete(S.id),this.a.$unregisterTimelineProvider(S.id),S.dispose()})}}e.$Pjc=M;function C(v){return v?.toString()}}),define(Se[352],De([1,0,225,23,2,4,3,284,8,7,18,19,16,79,22,182,26]),function(fe,e,l,j,L,A,R,p,w,E,M,C,v,S,k,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qjc=void 0;function o(s,c){if((0,M.$Sf)(s))return{label:s};if(s&&typeof s=="object"&&typeof s.label=="string"){let t;return Array.isArray(s.highlights)&&(t=s.highlights.filter(f=>f.length===2&&typeof f[0]=="number"&&typeof f[1]=="number"),t=t.length?t:void 0),{label:s.label,highlights:t}}}class i extends R.$Tc{constructor(c,t,f){super(),this.f=c,this.g=t,this.h=f,this.a=new Map,this.b=new u.$J9;function h(r){return r&&r.$treeViewId&&(r.$treeItemHandle||r.$selectedTreeItems||r.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:r=>h(r)?this.r(r):Array.isArray(r)&&r.length>0?r.map(a=>h(a)?this.r(a):a):r})}registerTreeDataProvider(c,t,f){const h=this.createTreeView(c,{treeDataProvider:t},f);return{dispose:()=>h.dispose()}}createTreeView(c,t,f){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const h=t.dragAndDropController?.dropMimeTypes??[],r=t.dragAndDropController?.dragMimeTypes??[],a=!!t.dragAndDropController?.handleDrag,d=!!t.dragAndDropController?.handleDrop,$=this.m(c,t,f),D={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:h,dragMimeTypes:r,hasHandleDrag:a,hasHandleDrop:d,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},b=this.f.$registerTreeViewDataProvider(c,D),g={get onDidCollapseElement(){return $.onDidCollapseElement},get onDidExpandElement(){return $.onDidExpandElement},get selection(){return $.selectedElements},get onDidChangeSelection(){return $.onDidChangeSelection},get activeItem(){return(0,m.$YF)(f,"treeViewActiveItem"),$.focusedElement},get onDidChangeActiveItem(){return(0,m.$YF)(f,"treeViewActiveItem"),$.onDidChangeActiveItem},get visible(){return $.visible},get onDidChangeVisibility(){return $.onDidChangeVisibility},get onDidChangeCheckboxState(){return $.onDidChangeCheckboxState},get message(){return $.message},set message(y){(0,S.$yk)(y)&&(0,m.$YF)(f,"treeViewMarkdownMessage"),$.message=y},get title(){return $.title},set title(y){$.title=y},get description(){return $.description},set description(y){$.description=y},get badge(){return $.badge},set badge(y){y!==void 0&&E.ViewBadge.isViewBadge(y)?$.badge={value:Math.floor(Math.abs(y.value)),tooltip:y.tooltip}:y===void 0&&($.badge=void 0)},reveal:(y,P)=>$.reveal(y,P),dispose:async()=>{await b,this.a.delete(c),$.dispose()}};return this.B(g),g}$getChildren(c,t){const f=this.a.get(c);return f?f.getChildren(t):Promise.reject(new p.$rF(c))}async $handleDrop(c,t,f,h,r,a,d,$){const D=this.a.get(c);if(!D)return Promise.reject(new p.$rF(c));const b=v.DataTransfer.toDataTransfer(f,async g=>(await this.f.$resolveDropFileData(c,t,g)).buffer);return d===c&&$&&await this.j(b,D,$,r,a),D.onDrop(b,h,r)}async j(c,t,f,h,r){const a=this.b.removeDragOperationTransfer(r);if(a)(await a)?.forEach((d,$)=>{d&&c.set($,d)});else if(r&&t.handleDrag){const d=t.handleDrag(f,c,h);this.b.addDragOperationTransfer(r,d),await d}return c}async $handleDrag(c,t,f,h){const r=this.a.get(c);if(!r)return Promise.reject(new p.$rF(c));const a=await this.j(new E.$ZM,r,t,h,f);if(!(!a||h.isCancellationRequested))return v.DataTransfer.from(a)}async $hasResolve(c){const t=this.a.get(c);if(!t)throw new p.$rF(c);return t.hasResolve}$resolve(c,t,f){const h=this.a.get(c);if(!h)throw new p.$rF(c);return h.resolveTreeItem(t,f)}$setExpanded(c,t,f){const h=this.a.get(c);if(!h)throw new p.$rF(c);h.setExpanded(t,f)}$setSelectionAndFocus(c,t,f){const h=this.a.get(c);if(!h)throw new p.$rF(c);h.setSelectionAndFocus(t,f)}$setVisible(c,t){const f=this.a.get(c);if(!f){if(!t)return;throw new p.$rF(c)}f.setVisible(t)}$changeCheckboxState(c,t){const f=this.a.get(c);if(!f)throw new p.$rF(c);f.setCheckboxState(t)}m(c,t,f){const h=this.B(new n(c,t,this.f,this.g.converter,this.h,f));return this.a.set(c,h),h}r(c){const t=this.a.get(c.$treeViewId);return t&&"$treeItemHandle"in c?t.getExtensionElement(c.$treeItemHandle):t&&"$focusedTreeItem"in c&&c.$focusedTreeItem?t.focusedElement:null}}e.$Qjc=i;class n extends R.$Tc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(c=>this.getExtensionElement(c)).filter(c=>!(0,M.$2f)(c))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(c,t,f,h,r,a){if(super(),this.I=c,this.J=f,this.L=h,this.M=r,this.N=a,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new A.$5d),this.onDidExpandElement=this.u.event,this.w=this.B(new A.$5d),this.onDidCollapseElement=this.w.event,this.y=this.B(new A.$5d),this.onDidChangeSelection=this.y.event,this.z=this.B(new A.$5d),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new A.$5d),this.onDidChangeVisibility=this.C.event,this.D=this.B(new A.$5d),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new A.$5d),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new k.$ce,a.contributes&&a.contributes.views)for(const b in a.contributes.views)for(const g of a.contributes.views[b])g.id===c&&(this.P=g.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(b=>this.F.fire({message:!1,element:b})));let d,$;const D=A.Event.debounce(this.F.event,(b,g)=>(b||(b={message:!1,elements:[]}),g.element!==!1&&(d||(d=new Promise(y=>$=y),this.G=this.G.then(()=>d)),Array.isArray(g.element)?b.elements.push(...g.element):b.elements.push(g.element)),g.message&&(b.message=!0),b),200,!0);this.B(D(({message:b,elements:g})=>{g.length&&(this.H=this.H.then(()=>{const y=$;return d=null,this.$(g).then(()=>y())})),b&&this.J.$setMessage(this.I,v.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(c){const t=c?this.getExtensionElement(c):void 0;if(c&&!t)return this.M.error(`No tree item with id '${c}' found.`),Promise.resolve([]);let f=this.X(c);return f||(f=await this.Y(t)),f?f.map(h=>h.item):void 0}getExtensionElement(c){return this.j.get(c)}reveal(c,t){t=t||{select:!0,focus:!1};const f=(0,M.$2f)(t.select)?!0:t.select,h=(0,M.$2f)(t.focus)?!1:t.focus,r=(0,M.$2f)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):c?this.G.then(()=>this.S(c)).then(a=>this.W(c,a[a.length-1]).then(d=>this.J.$reveal(this.I,{item:d.item,parentChain:a.map($=>$.item)},{select:f,focus:h,expand:r})),a=>this.M.error(a)):this.J.$reveal(this.I,void 0,{select:f,focus:h,expand:r})}get message(){return this.O}set message(c){this.O=c,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(c){this.P=c,this.J.$setTitle(this.I,c,this.Q)}get description(){return this.Q}set description(c){this.Q=c,this.J.$setTitle(this.I,this.P,c)}get badge(){return this.R}set badge(c){this.R?.value===c?.value&&this.R?.tooltip===c?.tooltip||(this.R=v.ViewBadge.from(c),this.J.$setBadge(this.I,c))}setExpanded(c,t){const f=this.getExtensionElement(c);f&&(t?this.u.fire(Object.freeze({element:f})):this.w.fire(Object.freeze({element:f})))}setSelectionAndFocus(c,t){const f=!(0,C.$ub)(this.s,c);this.s=c;const h=this.t!==t;this.t=t,f&&this.y.fire(Object.freeze({selection:this.selectedElements})),h&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(c){c!==this.r&&(this.r=c,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(c){const t=(await Promise.all(c.map(async f=>{const h=this.getExtensionElement(f.treeItemHandle);return h?{extensionItem:h,treeItem:await this.f.getTreeItem(h),newState:f.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(f=>f!==void 0);t.forEach(f=>{f.treeItem.checkboxState=f.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(f=>[f.extensionItem,f.newState])})}async handleDrag(c,t,f){const h=[];for(const r of c){const a=this.getExtensionElement(r);a&&h.push(a)}if(!(!this.g?.handleDrag||h.length===0))return await this.g.handleDrag(h,t,f),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(c,t,f){const h=t?this.getExtensionElement(t):void 0;if(!(!h&&t||!this.g?.handleDrop))return(0,w.$0g)(()=>this.g?.handleDrop?this.g.handleDrop(h,c,f):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(c,t){if(!this.f.resolveTreeItem)return;const f=this.j.get(c);if(f){const h=this.m.get(f);if(h){const r=await this.f.resolveTreeItem(h.extensionItem,f,t)??h.extensionItem;return this.hb(r),h.item.tooltip=this.eb(r.tooltip),h.item.command=this.fb(h.disposableStore,r.command),h.item}}}S(c){return this.U(c).then(t=>t?this.S(t).then(f=>this.W(t,f[f.length-1]).then(h=>(f.push(h),f))):Promise.resolve([]))}U(c){const t=this.m.get(c);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,w.$0g)(()=>this.f.getParent(c))}W(c,t){const f=this.m.get(c);return f?Promise.resolve(f):(0,w.$0g)(()=>this.f.getTreeItem(c)).then(h=>this.kb(c,h,t,!0)).then(h=>this.getChildren(t?t.item.handle:void 0).then(()=>{const r=this.getExtensionElement(h);if(r){const a=this.m.get(r);if(a)return Promise.resolve(a)}throw new Error(`Cannot resolve tree item for element ${h} from extension ${this.N.identifier.value}`)}))}X(c){if(c){let t;if(typeof c=="string"){const f=this.getExtensionElement(c);t=f?this.m.get(f):void 0}else t=c;return t&&t.children||void 0}return this.h}async Y(c){this.rb(c);const t=new k.$ce(this.Z.token);try{const f=c?this.m.get(c):void 0,h=await this.f.getChildren(c);if(t.token.isCancellationRequested)return;const r=(0,C.$Hb)(h||[]),a=await Promise.all((0,C.$Hb)(r).map($=>this.f.getTreeItem($)));if(t.token.isCancellationRequested)return;const d=a.map(($,D)=>$?this.db(r[D],$,f):null);return(0,C.$Hb)(d)}finally{t.dispose()}}$(c){if(c.some(f=>!f))return this.Z.dispose(!0),this.Z=new k.$ce,this.tb(),this.J.$refresh(this.I);{const f=this.ab(c);if(f.length)return this.bb(f)}return Promise.resolve(void 0)}ab(c){const t=new Set,f=c.map(r=>this.m.get(r));for(const r of f)if(r&&!t.has(r.item.handle)){let a=r;for(;a&&a.parent&&f.findIndex(d=>a&&a.parent&&d&&d.item.handle===a.parent.item.handle)===-1;){const d=this.j.get(a.parent.item.handle);a=d?this.m.get(d):void 0}a&&!a.parent&&t.add(r.item.handle)}const h=[];return t.forEach(r=>{const a=this.j.get(r);if(a){const d=this.m.get(a);d&&(!d.parent||!t.has(d.parent.item.handle))&&h.push(r)}}),h}bb(c){const t={};return Promise.all(c.map(f=>this.cb(f).then(h=>{h&&(t[f]=h.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(c){const t=this.getExtensionElement(c);if(t){const f=this.m.get(t);if(f)return this.rb(t),(0,w.$0g)(()=>this.f.getTreeItem(t)).then(h=>{if(h){const r=this.ib(t,h,f.parent);return this.pb(t,r,f,f.parent),f.dispose(),r}return null})}return Promise.resolve(null)}db(c,t,f){const h=this.ib(c,t,f);if(t.id&&this.j.has(h.item.handle))throw new Error((0,l.localize)(0,null,t.id));return this.ob(c,h),this.qb(h,f),h}eb(c){return E.$wM.isMarkdownString(c)?v.MarkdownString.from(c):c}fb(c,t){return t?{...this.L.toInternal(t,c),originalId:t.command}:void 0}gb(c){if(c.checkboxState===void 0)return;let t,f,h;return typeof c.checkboxState=="number"?t=c.checkboxState:(t=c.checkboxState.state,f=c.checkboxState.tooltip,h=c.checkboxState.accessibilityInformation),{isChecked:t===E.TreeItemCheckboxState.Checked,tooltip:f,accessibilityInformation:h}}hb(c){if(!E.$UM.isTreeItem(c,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(c,t,f){this.hb(t);const h=this.B(new R.$Sc),r=this.kb(c,t,f),a=this.lb(t);return{item:{handle:r,parentHandle:f?f.item.handle:void 0,label:o(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(h,t.command),contextValue:t.contextValue,icon:a,iconDark:this.mb(t)||a,themeIcon:this.jb(t),collapsibleState:(0,M.$2f)(t.collapsibleState)?E.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:f,children:void 0,disposableStore:h,dispose(){h.dispose()}}}jb(c){return c.iconPath instanceof E.$3M?c.iconPath:void 0}kb(c,{id:t,label:f,resourceUri:h},r,a){if(t)return`${n.b}/${t}`;const d=o(f,this.N),$=r?r.item.handle:n.a;let D=d?d.label:h?(0,j.$Pg)(h):"";D=D.indexOf("/")!==-1?D.replace("/","//"):D;const b=this.m.has(c)?this.m.get(c).item.handle:void 0,g=this.X(r)||[];let y,P=0;do{if(y=`${$}/${P}:${D}`,a||!this.j.has(y)||b===y)break;P++}while(P<=g.length);return y}lb(c){if(c.iconPath&&!(c.iconPath instanceof E.$3M))return typeof c.iconPath=="string"||L.URI.isUri(c.iconPath)?this.nb(c.iconPath):this.nb(c.iconPath.light)}mb(c){if(c.iconPath&&!(c.iconPath instanceof E.$3M)&&c.iconPath.dark)return this.nb(c.iconPath.dark)}nb(c){return L.URI.isUri(c)?c:L.URI.file(c)}ob(c,t){this.j.set(t.item.handle,c),this.m.set(c,t)}pb(c,t,f,h){this.j.delete(t.item.handle),this.m.delete(c),t.item.handle!==f.item.handle&&this.j.delete(f.item.handle),this.ob(c,t);const r=this.X(h)||[],a=r.filter(d=>d.item.handle===f.item.handle)[0];a&&r.splice(r.indexOf(a),1,t)}qb(c,t){t?(t.children||(t.children=[]),t.children.push(c)):(this.h||(this.h=[]),this.h.push(c))}rb(c){if(c){const t=this.m.get(c);if(t){if(t.children)for(const f of t.children){const h=this.j.get(f.item.handle);h&&this.sb(h)}t.children=void 0}}else this.tb()}sb(c){const t=this.m.get(c);if(t){if(t.children)for(const f of t.children){const h=this.j.get(f.item.handle);h&&this.sb(h)}this.m.delete(c),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(c=>c.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Se[353],De([1,0,4,3,2,30,16,92,6,7]),function(fe,e,l,j,L,A,R,p,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pic=void 0;class M extends j.$Tc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(k,u,m,o){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new l.$5d),this.onDidDispose=this.#d.event,this.#h=this.B(new l.$5d),this.onDidChangeViewState=this.#h.event,this.#e=k,this.#t=u,this.#n=m,this.#i=o.viewType,this.#s=o.panelOptions,this.#o=o.viewColumn,this.#r=o.title,this.#u=o.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(k){this.c(),this.#r!==k&&(this.#r=k,this.#t.$setTitle(this.#e,k))}get iconPath(){return this.c(),this.#a}set iconPath(k){this.c(),this.#a!==k&&(this.#a=k,this.#t.$setIconPath(this.#e,L.URI.isUri(k)?{light:k,dark:k}:k))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(k){this.#l||(this.active!==k.active||this.visible!==k.visible||this.viewColumn!==k.viewColumn)&&(this.#u=k.active,this.#c=k.visible,this.#o=k.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(k,u){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof k>"u"?void 0:R.ViewColumn.from(k),preserveFocus:!!u})}c(){if(this.#l)throw new Error("Webview is disposed")}}class C extends j.$Tc{static c(){return(0,A.$Bg)()}constructor(k,u,m){super(),this.j=u,this.m=m,this.g=new Map,this.h=new Map,this.f=k.getProxy(w.$6L.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(k=>k.dispose()),this.g.clear()}createWebviewPanel(k,u,m,o,i={}){const n=typeof o=="object"?o.viewColumn:o,s={viewColumn:R.ViewColumn.from(n),preserveFocus:typeof o=="object"&&!!o.preserveFocus},c=(0,p.$lic)(k),t=C.c();this.f.$createWebviewPanel((0,p.$nic)(k),t,u,{title:m,panelOptions:v(i),webviewOptions:(0,p.$oic)(k,this.m,i),serializeBuffersForPostMessage:c},s);const f=this.j.createNewWebview(t,i,k);return this.createNewWebviewPanel(t,u,m,n,i,f,!0)}$onDidChangeWebviewPanelViewStates(k){const u=Object.keys(k);u.sort((m,o)=>{const i=k[m],n=k[o];return i.active?1:n.active?-1:+i.visible-+n.visible});for(const m of u){const o=this.getWebviewPanel(m);if(!o)continue;const i=k[m];o._updateViewState({active:i.active,visible:i.visible,viewColumn:R.ViewColumn.to(i.position)})}}async $onDidDisposeWebviewPanel(k){this.getWebviewPanel(k)?.dispose(),this.g.delete(k),this.j.deleteWebview(k)}registerWebviewPanelSerializer(k,u,m){if(this.h.has(u))throw new Error(`Serializer for '${u}' already registered`);return this.h.set(u,{serializer:m,extension:k}),this.f.$registerSerializer(u,{serializeBuffersForPostMessage:(0,p.$lic)(k)}),new E.$8L(()=>{this.h.delete(u),this.f.$unregisterSerializer(u)})}async $deserializeWebviewPanel(k,u,m,o){const i=this.h.get(u);if(!i)throw new Error(`No serializer found for '${u}'`);const{serializer:n,extension:s}=i,c=this.j.createNewWebview(k,m.webviewOptions,s),t=this.createNewWebviewPanel(k,u,m.title,o,m.panelOptions,c,m.active);await n.deserializeWebviewPanel(t,m.state)}createNewWebviewPanel(k,u,m,o,i,n,s){const c=new M(k,this.f,n,{viewType:u,title:m,viewColumn:o,panelOptions:i,active:s});return this.g.set(k,c),c}getWebviewPanel(k){return this.g.get(k)}}e.$pic=C;function v(S){return{enableFindWidget:S.enableFindWidget,retainContextWhenHidden:S.retainContextWhenHidden}}}),define(Se[354],De([1,0,4,3,92,16,6,7]),function(fe,e,l,j,L,A,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tjc=void 0;class w extends j.$Tc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(C,v,S,k,u,m){super(),this.#s=!1,this.#u=this.B(new l.$5d),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new l.$5d),this.onDidDispose=this.#l.event,this.#i=S,this.#a=k,this.#e=C,this.#t=v,this.#n=u,this.#r=m}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(C){this.a(),this.#a!==C&&(this.#a=C,this.#t.$setWebviewViewTitle(this.#e,C))}get description(){return this.a(),this.#o}set description(C){this.a(),this.#o!==C&&(this.#o=C,this.#t.$setWebviewViewDescription(this.#e,C))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(C){C===this.#r||this.#s||(this.#r=C,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(C){this.a(),!(C?.value===this.#c?.value&&C?.tooltip===this.#c?.tooltip)&&(this.#c=A.ViewBadge.from(C),this.#t.$setWebviewViewBadge(this.#e,C))}show(C){this.a(),this.#t.$show(this.#e,!!C)}a(){if(this.#s)throw new Error("Webview is disposed")}}class E{constructor(C,v){this.d=v,this.b=new Map,this.c=new Map,this.a=C.getProxy(R.$6L.MainThreadWebviewViews)}registerWebviewViewProvider(C,v,S,k){if(this.b.has(v))throw new Error(`View provider for '${v}' already registered`);return this.b.set(v,{provider:S,extension:C}),this.a.$registerWebviewViewProvider((0,L.$nic)(C),v,{retainContextWhenHidden:k?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,L.$lic)(C)}),new p.$8L(()=>{this.b.delete(v),this.a.$unregisterWebviewViewProvider(v)})}async $resolveWebviewView(C,v,S,k,u){const m=this.b.get(v);if(!m)throw new Error(`No view provider found for '${v}'`);const{provider:o,extension:i}=m,n=this.d.createNewWebview(C,{},i),s=new w(C,this.a,v,S,n,!0);this.c.set(C,s),await o.resolveWebviewView(s,{state:k},u)}async $onDidChangeWebviewViewVisibility(C,v){this.e(C)._setVisible(v)}async $disposeWebviewView(C){const v=this.e(C);this.c.delete(C),v.dispose(),this.d.deleteWebview(C)}e(C){const v=this.c.get(C);if(!v)throw new Error("No webview found");return v}}e.$Tjc=E}),define(Se[355],De([1,0,68,15,12,255,32,11]),function(fe,e,l,j,L,A,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ykc=void 0;let w=class{constructor(C,v){C.addFileSystemProvider(j.Schemas.file,new E(v),{isCaseSensitive:p.$k})}};e.$ykc=w,e.$ykc=w=Ye([Ve(0,l.$hic),Ve(1,L.$zj)],w);class E{constructor(C){this.b=C,this.a=new A.$Pq(this.b)}async stat(C){const v=await this.a.stat(C);return{type:v.type,ctime:v.ctime,mtime:v.mtime,size:v.size,permissions:v.permissions===R.FilePermission.Readonly?1:void 0}}readDirectory(C){return this.a.readdir(C)}createDirectory(C){return this.a.mkdir(C)}readFile(C){return this.a.readFile(C)}writeFile(C,v,S){return this.a.writeFile(C,v,{...S,unlock:!1,atomic:!1})}delete(C,v){return this.a.delete(C,{...v,useTrash:!1,atomic:!1})}rename(C,v,S){return this.a.rename(C,v,S)}copy(C,v,S){return this.a.copy(C,v,S)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(C,v){throw new Error("Method not implemented.")}}}),define(Se[356],De([1,0,17,63,30,33,3,6,2,20]),function(fe,e,l,j,L,A,R,p,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wkc=void 0;let M=class extends R.$Tc{constructor(v,S){super();const k=v.getProxy(p.$6L.MainThreadDownloadService);S.registerCommand(!1,"_workbench.downloadResource",async u=>{const m=w.URI.file((0,l.$jc)((0,j.tmpdir)(),(0,L.$Bg)()));return await k.$download(u,m),m})}};e.$wkc=M,e.$wkc=M=Ye([Ve(0,E.$lO),Ve(1,A.$HO)],M)}),define(Se[357],De([1,0,57,17,2,93,3,15,8,31]),function(fe,e,l,j,L,A,R,p,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ikc=void 0;class M extends A.$jic{constructor(){super(...arguments),this.i=null}async g(t){const f=await super.g(t);if(f.scheme!==p.Schemas.file)return f;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${f.fsPath}.`),f;const h=f.fsPath;let r=0;do{let a;r===0?a=h:a=/[/\\]$/.test(h)?`${h.substr(0,h.length-1)}-${r}`:`${h}-${r}`,await C(a);const d=j.$jc(a,"vscode.lock"),$=await u(this.d,d,!1);if($)return this.i=$,process.on("exit",()=>{$.dispose()}),L.URI.file(a);r++}while(r<10);return f}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$Ikc=M;async function C(c){try{await E.Promises.stat(c);return}catch{}try{await E.Promises.mkdir(c,{recursive:!0})}catch{}}const v=1e3,S=10*60*1e3;class k extends R.$Tc{constructor(t,f){super(),this.b=t,this.c=f,this.a=this.B(new w.$qh),this.a.cancelAndSet(async()=>{const h=await m(t,f);(!h||h.pid!==process.pid)&&(t.info(`Lock '${f}': The lock was lost unexpectedly.`),this.a.cancel());try{await E.Promises.utimes(f,new Date,new Date)}catch(r){t.error(r),t.info(`Lock '${f}': Could not update mtime.`)}},v)}dispose(){super.dispose();try{l.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const f={pid:process.pid,willReleaseAt:Date.now()+t};await E.Promises.writeFile(this.c,JSON.stringify(f),{flag:"w"})}catch(f){this.b.error(f)}}}async function u(c,t,f){try{const r={pid:process.pid,willReleaseAt:0};await E.Promises.writeFile(t,JSON.stringify(r),{flag:"wx"})}catch(r){c.error(r)}const h=await m(c,t);return!h||h.pid!==process.pid?f?(c.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(c.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),n(c,t)):(c.info(`Lock '${t}': Lock acquired.`),new k(c,t))}async function m(c,t){let f;try{f=await E.Promises.readFile(t)}catch(h){return c.error(h),null}try{return JSON.parse(String(f))}catch(h){return c.error(h),null}}async function o(c,t){let f;try{f=await E.Promises.stat(t)}catch(h){return c.error(h),0}return f.mtime.getTime()}function i(c){try{return process.kill(c,0),!0}catch{return!1}}async function n(c,t){const f=await m(c,t);if(!f)return c.info(`Lock '${t}': Could not read pid of lock holder.`),s(c,t);if(f.willReleaseAt){let $=f.willReleaseAt-Date.now();if($<5e3){for($>0?c.info(`Lock '${t}': The lockfile is scheduled to be released in ${$} ms.`):c.info(`Lock '${t}': The lockfile is scheduled to have been released.`);$>0;){if(await(0,w.$gh)(Math.min(100,$)),await o(c,t)===0)return s(c,t);$=f.willReleaseAt-Date.now()}return s(c,t)}}if(!i(f.pid))return c.info(`Lock '${t}': The pid ${f.pid} appears to be gone.`),s(c,t);const h=await o(c,t),r=Date.now()-h;if(r<=S)return c.info(`Lock '${t}': The lock does not look stale, elapsed: ${r} ms, giving up.`),null;c.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,w.$gh)(2e3);const a=await o(c,t),d=Date.now()-a;return d<=S?(c.info(`Lock '${t}': The lock does not look stale, elapsed: ${d} ms, giving up.`),null):(c.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),s(c,t))}async function s(c,t){c.info(`Lock '${t}': Deleting a stale lock.`);try{await E.Promises.unlink(t)}catch{}return u(c,t,!0)}}),define(Se[358],De([1,0,30,20,46,33]),function(fe,e,l,j,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4jc=void 0;let R=class extends L.$Fic{constructor(w,E){super(!0,w,E)}createTerminal(w,E,M){return this.createTerminalFromOptions({name:w,shellPath:E,shellArgs:M})}createTerminalFromOptions(w,E){const M=new L.$Eic(this.a,(0,l.$Bg)(),w,w.name);return this.f.push(M),M.create(w,this.R(w,E)),M.value}};e.$4jc=R,e.$4jc=R=Ye([Ve(0,A.$HO),Ve(1,j.$lO)],R)}),define(Se[359],De([1,0,4,37,45,5]),function(fe,e,l,j,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pL=e.$oL=e.OutputChannelUpdateMode=e.$nL=e.$mL=e.$lL=e.$kL=e.$jL=e.$iL=e.$hL=e.$gL=e.$fL=e.$eL=void 0,e.$eL="text/x-code-output",e.$fL="output",e.$gL="Log",e.$hL="text/x-code-log-output",e.$iL="log",e.$jL="workbench.panel.output",e.$kL=new L.$wj("inOutput",!1),e.$lL=new L.$wj("activeLogOutput",!1),e.$mL=new L.$wj("outputView.scrollLock",!1),e.$nL=(0,A.$fi)("outputService");var R;(function(w){w[w.Append=1]="Append",w[w.Replace=2]="Replace",w[w.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$oL={OutputChannels:"workbench.contributions.outputChannels"};class p{constructor(){this.a=new Map,this.b=new l.$5d,this.onDidRegisterChannel=this.b.event,this.c=new l.$5d,this.onDidRemoveChannel=this.c.event}registerChannel(E){this.a.has(E.id)||(this.a.set(E.id,E),this.b.fire(E.id))}getChannels(){const E=[];return this.a.forEach(M=>E.push(M)),E}getChannel(E){return this.a.get(E)}removeChannel(E){this.a.delete(E),this.c.fire(E)}}j.$Wn.add(e.$oL.OutputChannels,new p),e.$pL=new L.$wj("activeOutputChannel","")}),define(Se[156],De([1,0,6,5,20,25,12,359,68,27,59,187,21,18,32,4,3]),function(fe,e,l,j,L,A,R,p,w,E,M,C,v,S,k,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vjc=e.$ujc=void 0;class o extends R.$Fj{get disposed(){return this.n}constructor(c,t,f,h,r){super(),this.id=c,this.name=t,this.r=f,this.s=h,this.extension=r,this.m=0,this.n=!1,this.visible=!1,this.setLevel(f.getLevel()),this.B(f.onDidChangeLogLevel(a=>this.setLevel(a)))}get logLevel(){return this.getLevel()}appendLine(c){this.append(c+`
`)}append(c){this.info(c)}clear(){const c=this.m;this.r.flush(),this.s.$update(this.id,p.OutputChannelUpdateMode.Clear,c)}replace(c){const t=this.m;this.info(c),this.s.$update(this.id,p.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(c,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof c=="boolean"?c:t))}hide(){this.s.$close(this.id)}g(c,t){this.m+=v.$se.fromString(t).byteLength,(0,R.log)(this.r,c,t),this.visible&&(this.r.flush(),this.s.$update(this.id,p.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class i extends o{appendLine(c){this.append(c)}}let n=class{constructor(c,t,f,h,r,a){this.i=t,this.j=f,this.k=h,this.l=r,this.m=a,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=c.getProxy(l.$6L.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,C.$Lm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(c){this.h=c;for(const[t,f]of this.g)f.visible=t===this.h}createOutputChannel(c,t,f){if(c=c.trim(),!c)throw new Error("illegal argument `name`. must not be falsy");const h=typeof t=="object"&&t.log,r=(0,S.$Sf)(t)?t:void 0;if((0,S.$Sf)(r)&&!r.trim())throw new Error("illegal argument `languageId`. must not be empty");let a;const d=this.i.environment.extensionLogLevel?.find(([D])=>A.$zm.equals(f.identifier,D))?.[1];d&&(a=(0,R.$Pj)(d));const $=h?this.o(c,a,f):this.n(c,r,f);return $.then(D=>{this.g.set(D.id,D),D.visible=D.id===this.h}),h?this.r(c,a??this.m.getLevel(),$):this.q(c,$)}async n(c,t,f){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const h=await this.c,r=this.k.extUri.joinPath(h,`${this.f++}-${c.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),a=this.l.createLogger(r,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),d=await this.a.$register(c,r,t,f.identifier.value);return new o(d,c,a,this.a,f)}async o(c,t,f){const h=await this.p(f),r=c.replace(/[\\/:\*\?"<>\|]/g,""),a=this.k.extUri.joinPath(h,`${r}.log`),d=`${f.identifier.value}.${r}`,$=this.l.createLogger(a,{id:d,name:c,logLevel:t,extensionId:f.identifier.value});return new i(d,c,$,this.a,f)}p(c){let t=this.d.get(c.identifier.value);if(!t){const f=this.k.extUri.joinPath(this.i.logsLocation,c.identifier.value);this.d.set(c.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(f)}catch(h){if((0,k.$Vk)(h)!==k.FileSystemProviderErrorCode.FileExists)throw h}return f})())}return t}q(c,t){let f=!1;const h=()=>{if(f)throw new Error("Channel has been closed")};return{get name(){return c},append(r){h(),t.then(a=>a.append(r))},appendLine(r){h(),t.then(a=>a.appendLine(r))},clear(){h(),t.then(r=>r.clear())},replace(r){h(),t.then(a=>a.replace(r))},show(r,a){h(),t.then(d=>d.show(r,a))},hide(){h(),t.then(r=>r.hide())},dispose(){f=!0,t.then(r=>r.dispose())}}}r(c,t,f){const h=new m.$Sc,r=()=>{if(h.isDisposed)throw new Error("Channel has been closed")},a=h.add(new u.$5d);function d($){t=$,a.fire($)}return f.then($=>{h.add($),$.logLevel!==t&&d($.logLevel),h.add($.onDidChangeLogLevel(D=>d(D)))}),{...this.q(c,f),get logLevel(){return t},onDidChangeLogLevel:a.event,trace($,...D){r(),f.then(b=>b.trace($,...D))},debug($,...D){r(),f.then(b=>b.debug($,...D))},info($,...D){r(),f.then(b=>b.info($,...D))},warn($,...D){r(),f.then(b=>b.warn($,...D))},error($,...D){r(),f.then(b=>b.error($,...D))},dispose(){h.dispose()}}}};e.$ujc=n,e.$ujc=n=Ye([Ve(0,L.$lO),Ve(1,E.$BO),Ve(2,w.$hic),Ve(3,M.$Thc),Ve(4,R.$Aj),Ve(5,R.$zj)],n),e.$vjc=(0,j.$fi)("IExtHostOutputService")}),define(Se[157],De([1,0,5,8]),function(fe,e,l,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2m=e.$1m=void 0,e.$1m=(0,l.$fi)("remoteAgentService"),e.$2m=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(L){let A=1/0;for(let p=0;p<this.maxSampleCount;p++){const w=await L.getRoundTripTime();if(w===void 0)return;A=Math.min(A,w/2),await(0,j.$gh)(this.sampleDelay)}this.average.push(A),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(A):R=this.initial.reduce((p,w)=>p+w,0)/this.initial.length,this.lastMeasurement={initial:R,current:A,average:this.average.reduce((p,w)=>p+w,0)/this.average.length,high:typeof R>"u"?!1:A>this.highLatencyMaxThreshold||A>this.highLatencyMinThreshold&&A>R*this.highLatencyMultiple},this.lastMeasurement}}}),define(Se[360],De([1,0,229,85,37,40,52,3,4,157,11,24,8]),function(fe,e,l,j,L,A,R,p,w,E,M,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=void 0,e.$JI=Object.freeze({id:"application",order:100,title:(0,l.localize)(0,null),type:"object"}),e.$KI=Object.freeze({id:"workbench",order:7,title:(0,l.localize)(1,null),type:"object"}),e.$LI=Object.freeze({id:"security",scope:1,title:(0,l.localize)(2,null),type:"object",order:7}),e.$MI=Object.freeze({id:"problems",title:(0,l.localize)(3,null),type:"object",order:101}),e.$NI={ConfigurationMigration:"base.contributions.configuration.migration"};class S{constructor(){this.migrations=[],this.a=new w.$5d,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(i){this.migrations.push(...i)}}const k=new S;L.$Wn.add(e.$NI.ConfigurationMigration,k);let u=class extends p.$Tc{static{this.ID="workbench.contrib.configurationMigration"}constructor(i,n){super(),this.a=i,this.b=n,this.B(this.b.onDidChangeWorkspaceFolders(async s=>{for(const c of s.added)await this.f(c,k.migrations)})),this.c(k.migrations),this.B(k.onDidRegisterConfigurationMigration(s=>this.c(s)))}async c(i){await this.f(void 0,i);for(const n of this.b.getWorkspace().folders)await this.f(n,i)}async f(i,n){await Promise.all([n.map(s=>this.g(s,i?.uri))])}async g(i,n){const s=this.a.inspect(i.key,{resource:n}),c=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,f]of c){const h=s[t];if(!h)continue;const r=[];if(h.value!==void 0){const a=await this.h(i,t,h.value,n,void 0);for(const d of a??[])r.push([d,[]])}for(const{identifiers:a,value:d}of h.overrides??[])if(d!==void 0){const $=await this.h(i,t,d,n,a);for(const D of $??[])r.push([D,a])}r.length&&await Promise.allSettled(r.map(async([[a,d],$])=>this.a.updateValue(a,d.value,{resource:n,overrideIdentifiers:$},f)))}}async h(i,n,s,c,t){const f=r=>{const d=this.a.inspect(r,{resource:c})[n];if(d)return t?d.overrides?.find(({identifiers:$})=>(0,C.$On)($,t))?.value:d.value},h=await i.migrateFn(s,f);return Array.isArray(h)?h:[[i.key,h]]}};e.$OI=u,e.$OI=u=Ye([Ve(0,R.$Li),Ve(1,A.$oi)],u);let m=class extends p.$Tc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(i){super(),this.b=i,this.a=new v.$Ch,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!M.$i&&(await this.b.getEnvironment())?.os!==1)return;L.$Wn.as(j.$2n.Configuration).registerConfiguration({...e.$LI,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,l.localize)(4,null)},default:[],markdownDescription:(0,l.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,l.localize)(6,null),scope:2}}})}};e.$PI=m,e.$PI=m=Ye([Ve(0,E.$1m)],m)}),define(Se[361],De([1,0,35,15,17,23,238,360,85,5,37]),function(fe,e,l,j,L,A,R,p,w,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9eb=e.$8eb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$7eb=e.$6eb=void 0,e.$6eb=(0,E.$fi)("editorResolverService"),e.$7eb="workbench.editorAssociations";const C=M.$Wn.as(w.$2n.Configuration),v={...p.$KI,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(0,null),additionalProperties:{type:"string"}}}};C.registerConfiguration(v);var S;(function(o){o.builtin="builtin",o.option="option",o.exclusive="exclusive",o.default="default"})(S||(e.RegisteredEditorPriority=S={}));var k;(function(o){o[o.ABORT=1]="ABORT",o[o.NONE=2]="NONE"})(k||(e.ResolvedStatus=k={}));function u(o){switch(o){case S.exclusive:return 5;case S.default:return 4;case S.builtin:return 3;case S.option:default:return 1}}e.$8eb=u;function m(o,i){if(new Set([j.Schemas.extension,j.Schemas.webviewPanel,j.Schemas.vscodeWorkspaceTrust,j.Schemas.vscodeSettings]).has(i.scheme))return!1;const c=typeof o=="string"&&o.indexOf(L.$gc.sep)>=0?`${i.scheme}:${i.path}`:(0,A.$Pg)(i);return l.$Xj(typeof o=="string"?o.toLowerCase():o,c.toLowerCase())}e.$9eb=m}),define(Se[362],De([1,0,34,15,17,11,23,2,5,273,40,147,157]),function(fe,e,l,j,L,A,R,p,w,E,M,C,v){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$IL=e.$HL=void 0,e.$HL=(0,w.$fi)("pathService");let k=S=class{constructor(m,o,i,n){this.d=m,this.e=o,this.f=i,this.g=n,this.a=(async()=>(await this.e.getEnvironment())?.os||A.OS)(),this.b=(async()=>{const s=await this.e.getEnvironment();return this.c=s?.userHome??m})()}hasValidBasename(m,o,i){return typeof o=="string"||typeof o>"u"?this.a.then(n=>this.h(m,n,o)):this.h(m,o,i)}h(m,o,i){return m.scheme===j.Schemas.file||m.scheme===j.Schemas.vscodeRemote?(0,l.$dg)(i??(0,R.$Pg)(m),o===1):!0}get defaultUriScheme(){return S.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(m,o){if(m.remoteAuthority)return j.Schemas.vscodeRemote;const i=(0,E.$EL)(o.getWorkspace());if(i)return i;const n=o.getWorkspace().folders[0];if(n)return n.uri.scheme;const s=o.getWorkspace().configuration;return s?s.scheme:j.Schemas.file}userHome(m){return m?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(m=>m===1?L.$fc:L.$gc)}async fileURI(m){let o="";if(await this.a===1&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const n=m.indexOf("/",2);n===-1?(o=m.substring(2),m="/"):(o=m.substring(2,n),m=m.substring(n)||"/")}return p.URI.from({scheme:j.Schemas.file,authority:o,path:m,query:"",fragment:""})}};e.$IL=k,e.$IL=k=S=Ye([Ve(1,v.$1m),Ve(2,C.$qL),Ve(3,M.$oi)],k)}),define(Se[363],De([1,0,240,19,53,4,54,3,2,52,245,12,64,275,88,40,147,26,22,18,24,45]),function(fe,e,l,j,L,A,R,p,w,E,M,C,v,S,k,u,m,o,i,n,s,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BL=e.$AL=e.$zL=e.OnPortForward=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=e.TunnelSource=e.TunnelCloseReason=e.$tL=e.$sL=e.$rL=void 0;const t=10*1e3,f="remote.tunnels.toRestore",h="remote.tunnels.toRestoreExpiration",r=1e3*60*60*24*14;e.$rL="onTunnel",e.$sL=new c.$wj("forwardedPortsViewEnabled",!1,l.localize(0,null));function a(z){const F=z.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(F)return{host:F[1]?.substring(0,F[1].length-1)||"localhost",port:Number(F[2])}}e.$tL=a;var d;(function(z){z.Other="Other",z.User="User",z.AutoForwardEnd="AutoForwardEnd"})(d||(e.TunnelCloseReason=d={}));var $;(function(z){z[z.User=0]="User",z[z.Auto=1]="Auto",z[z.Extension=2]="Extension"})($||(e.TunnelSource=$={})),e.$uL={source:$.User,description:l.localize(1,null)},e.$vL={source:$.Auto,description:l.localize(2,null)};function D(z,F,I){const O=z.get(g(F,I));if(O)return O;if((0,k.$Uv)(F))for(const T of k.$Tv){const G=g(T,I);if(z.has(G))return z.get(G)}else if((0,k.$Wv)(F))for(const T of k.$Vv){const G=g(T,I);if(z.has(G))return z.get(G)}}e.$wL=D;function b(z,F,I){const O=D(z,F,I);if(O)return O;const T=(0,k.$Wv)(F)?"localhost":(0,k.$Uv)(F)?"0.0.0.0":void 0;if(T)return D(z,T,I)}e.$xL=b;function g(z,F){return z+":"+F}e.$yL=g;var y;(function(z){z.Notify="notify",z.OpenBrowser="openBrowser",z.OpenBrowserOnce="openBrowserOnce",z.OpenPreview="openPreview",z.Silent="silent",z.Ignore="ignore"})(y||(e.OnPortForward=y={}));function P(z){return z&&"host"in z&&typeof z.host=="string"&&"port"in z&&typeof z.port=="number"&&(!("detail"in z)||typeof z.detail=="string")&&(!("pid"in z)||typeof z.pid=="string")}e.$zL=P;class N extends p.$Tc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(F){super(),this.r=F,this.j=[],this.n=new A.$5d,this.onDidChangeAttributes=this.n.event,this.B(F.onDidChangeConfiguration(I=>{(I.affectsConfiguration(N.c)||I.affectsConfiguration(N.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(F,I,O){let T=this.w(F,I,O,this.j,0);const G={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;T>=0;){const te=this.j[T];te.key===F?(G.onAutoForward=te.onAutoForward??G.onAutoForward,G.elevateIfNeeded=te.elevateIfNeeded!==void 0?te.elevateIfNeeded:G.elevateIfNeeded,G.label=te.label??G.label,G.requireLocalPort=te.requireLocalPort,G.protocol=te.protocol):(G.onAutoForward=G.onAutoForward??te.onAutoForward,G.elevateIfNeeded=G.elevateIfNeeded!==void 0?G.elevateIfNeeded:te.elevateIfNeeded,G.label=G.label??te.label,G.requireLocalPort=G.requireLocalPort!==void 0?G.requireLocalPort:void 0,G.protocol=G.protocol??te.protocol),T=this.w(F,I,O,this.j,T+1)}return G.onAutoForward!==void 0||G.elevateIfNeeded!==void 0||G.label!==void 0||G.requireLocalPort!==void 0||G.protocol!==void 0?G:this.C()}t(F){return F.start!==void 0&&F.end!==void 0}u(F){return F.host!==void 0&&F.port!==void 0&&(0,n.$Sf)(F.host)&&(0,n.$Wf)(F.port)}w(F,I,O,T,G){if(G>=T.length)return-1;const te=!(0,k.$Uv)(I)&&!(0,k.$Wv)(I),X=T.slice(G).findIndex(Q=>(0,n.$Wf)(Q.key)?te?!1:Q.key===F:this.t(Q.key)?te?!1:F>=Q.key.start&&F<=Q.key.end:this.u(Q.key)?F===Q.key.port&&I===Q.key.host:O?Q.key.test(O):!1);return X>=0?X+G:-1}y(){const F=this.r.getValue(N.c);if(!F||!(0,n.$Uf)(F))return[];const I=[];for(const T in F){if(T===void 0)continue;const G=F[T];let te;if(Number(T))te=Number(T);else if((0,n.$Sf)(T))if(N.g.test(T)){const x=T.match(N.g);te={start:Number(x[1]),end:Number(x[2])}}else if(N.h.test(T)){const x=T.match(N.h);te={host:x[1],port:Number(x[2])}}else{let x;try{x=RegExp(T)}catch{}x&&(te=x)}te&&I.push({key:te,elevateIfNeeded:G.elevateIfNeeded,onAutoForward:G.onAutoForward,label:G.label,requireLocalPort:G.requireLocalPort,protocol:G.protocol})}const O=this.r.getValue(N.f);return O&&(this.m={elevateIfNeeded:O.elevateIfNeeded,label:O.label,onAutoForward:O.onAutoForward,requireLocalPort:O.requireLocalPort,protocol:O.protocol}),this.z(I)}z(F){function I(O,T){return(0,n.$Wf)(O.key)?O.key:T.t(O.key)?O.key.start:T.u(O.key)?O.key.port:Number.MAX_VALUE}return F.sort((O,T)=>I(O,this)-I(T,this))}C(){return this.m}static providedActionToAction(F){switch(F){case k.ProvidedOnAutoForward.Notify:return y.Notify;case k.ProvidedOnAutoForward.OpenBrowser:return y.OpenBrowser;case k.ProvidedOnAutoForward.OpenBrowserOnce:return y.OpenBrowserOnce;case k.ProvidedOnAutoForward.OpenPreview:return y.OpenPreview;case k.ProvidedOnAutoForward.Silent:return y.Silent;case k.ProvidedOnAutoForward.Ignore:return y.Ignore;default:return}}async addAttributes(F,I,O){const G=this.r.inspect(N.c).userRemoteValue;let te;!G||!(0,n.$Uf)(G)?te={}:te=(0,s.$Kn)(G),te[`${F}`]||(te[`${F}`]={});for(const x in I)te[`${F}`][x]=I[x];return this.r.updateValue(N.c,te,O)}}e.$AL=N;let U=class extends p.$Tc{constructor(F,I,O,T,G,te,x,X,Q,ae){super(),this.H=F,this.I=I,this.J=O,this.L=T,this.M=G,this.N=te,this.O=x,this.P=X,this.Q=Q,this.R=ae,this.c=new Map,this.g=new A.$5d,this.onForwardPort=this.g.event,this.h=new A.$5d,this.onClosePort=this.h.event,this.j=new A.$5d,this.onPortName=this.j.event,this.n=new A.$5d,this.onCandidatesChanged=this.n.event,this.t=new A.$5d,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new A.$5d,this.D=new Map,this.F=new Map,this.G=[],this.db=new Date,this.configPortsAttributes=new N(O),this.s=this.ab(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.jb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async _=>{const ge=await this.getAttributes(_.map(se=>({port:se.tunnelRemotePort,host:se.tunnelRemoteHost})));for(const se of _)if(se.localAddress){const re=g(se.tunnelRemoteHost,se.tunnelRemotePort),B=b(this.m??new Map,se.tunnelRemoteHost,se.tunnelRemotePort);this.forwarded.set(re,{remotePort:se.tunnelRemotePort,remoteHost:se.tunnelRemoteHost,localAddress:se.localAddress,protocol:ge?.get(se.tunnelRemotePort)?.protocol??k.TunnelProtocol.Http,localUri:await this.X(se.localAddress,ge?.get(se.tunnelRemotePort)),localPort:se.tunnelLocalPort,runningProcess:B?.detail,hasRunningProcess:!!B,pid:B?.pid,privacy:se.privacy,source:e.$uL}),this.f.set(re,se)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async _=>{const ge=g(_.tunnelRemoteHost,_.tunnelRemotePort);if(!b(this.forwarded,_.tunnelRemoteHost,_.tunnelRemotePort)&&!b(this.detected,_.tunnelRemoteHost,_.tunnelRemotePort)&&!b(this.c,_.tunnelRemoteHost,_.tunnelRemotePort)&&_.localAddress){const se=b(this.m??new Map,_.tunnelRemoteHost,_.tunnelRemotePort),re=(await this.getAttributes([{port:_.tunnelRemotePort,host:_.tunnelRemoteHost}]))?.get(_.tunnelRemotePort);this.forwarded.set(ge,{remoteHost:_.tunnelRemoteHost,remotePort:_.tunnelRemotePort,localAddress:_.localAddress,protocol:re?.protocol??k.TunnelProtocol.Http,localUri:await this.X(_.localAddress,re),localPort:_.tunnelLocalPort,closeable:!0,runningProcess:se?.detail,hasRunningProcess:!!se,pid:se?.pid,privacy:_.privacy,source:e.$uL})}await this.cb(),this.f.set(ge,_),this.g.fire(this.forwarded.get(ge))})),this.B(this.H.onTunnelClosed(_=>this.W(_,d.Other))),this.U()}S(){return this.Q.extensions.find(F=>F.activationEvents?.includes(e.$rL))?(this.R.createKey(e.$sL.key,!0),!0):!1}U(){if(this.S())return;const F=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&F.dispose()}))}async W(F,I){const O=g(F.host,F.port);this.forwarded.has(O)&&(this.forwarded.delete(O),await this.cb(),this.h.fire(F))}X(F,I){if(F.startsWith("http"))return w.URI.parse(F);const O=I?.protocol??"http";return w.URI.parse(`${O}://${F}`)}async Y(F){const I=this.N.getWorkspace(),O=I.configuration?(0,R.$6i)(I.configuration.path):I.folders.length>0?(0,R.$6i)(I.folders[0].uri.path):void 0;if(O===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${F}.${this.L.remoteAuthority}.${O}`}async Z(){return this.Y(f)}async $(){return this.Y(h)}async ab(){const F=this.I.get(f,1);if(F)return this.I.remove(f,1),await this.cb(),F;const I=await this.Z();if(I)return this.I.get(I,0)}async restoreForwarded(){if(this.bb(),this.J.getValue("remote.restoreForwardedPorts")){const F=await this.s;if(F&&F!==this.y){const I=JSON.parse(F)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${I.map(O=>O.remotePort).join(", ")}`);for(const O of I){const T=b(this.detected,O.remoteHost,O.remotePort);O.source.source!==$.Extension&&!T||O.source.source===$.Extension&&T?await this.fb({remote:{host:O.remoteHost,port:O.remotePort},local:O.localPort,name:O.name,elevateIfNeeded:!0,source:O.source}):O.source.source===$.Extension&&!T&&this.D.set(g(O.remoteHost,O.remotePort),O)}}}if(this.z=!0,this.C.fire(),!this.w){const F=await this.Z();this.w=this.B(new p.$Sc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async I=>{I.key===F&&(this.s=Promise.resolve(this.I.get(F,0)),await this.restoreForwarded())}))}}bb(){const F=this.I.keys(0,0).filter(I=>I.startsWith(h));for(const I of F){const O=this.I.getNumber(I,0);if(O&&O<Date.now()){this.s=Promise.resolve(void 0);const T=I.replace(h,f);this.I.remove(I,0),this.I.remove(T,0)}}}async cb(){if(this.J.getValue("remote.restoreForwardedPorts")){const F=Array.from(this.forwarded.values()),I=F.map(te=>({remoteHost:te.remoteHost,remotePort:te.remotePort,localPort:te.localPort,name:te.name,localAddress:te.localAddress,localUri:te.localUri,protocol:te.protocol,source:te.source}));let O;F.length>0&&(O=JSON.stringify(I));const T=await this.Z(),G=await this.$();!O&&T&&G?(this.I.remove(T,0),this.I.remove(G,0)):O!==this.y&&T&&G&&(this.I.store(T,O,0,0),this.I.store(G,Date.now()+r,0,0)),this.y=O}}async eb(F,I,O){if(!F.tunnelLocalPort||!O?.requireLocalPort||F.tunnelLocalPort===I)return;const T=new Date;if(this.db.getTime()+t>T.getTime())return;this.db=T;const G=l.localize(3,null,I,F.tunnelRemotePort,F.tunnelLocalPort);return this.P.info(G)}async forward(F,I){return!this.z&&this.L.remoteAuthority&&await A.Event.toPromise(this.C.event),this.fb(F,I)}async fb(F,I){await this.Q.activateByEvent(e.$rL);const O=b(this.forwarded,F.remote.host,F.remote.port);I=I??(I!==null?(await this.getAttributes([F.remote]))?.get(F.remote.port):void 0);const T=F.local!==void 0?F.local:F.remote.port;let G;if(O)return this.hb(O,F,I);{const te=this.L.remoteAuthority,x=te?{getAddress:async()=>(await this.M.resolveAuthority(te)).authority}:void 0,X=g(F.remote.host,F.remote.port);this.c.set(X,!0),F=this.gb(X,F);const Q=await this.H.openTunnel(x,F.remote.host,F.remote.port,void 0,T,F.elevateIfNeeded?F.elevateIfNeeded:I?.elevateIfNeeded,F.privacy,I?.protocol);if(typeof Q=="string")G=Q;else if(Q&&Q.localAddress){const ae=b(this.m??new Map,F.remote.host,F.remote.port),_=Q.protocol?Q.protocol===k.TunnelProtocol.Https?k.TunnelProtocol.Https:k.TunnelProtocol.Http:I?.protocol??k.TunnelProtocol.Http,ge={remoteHost:Q.tunnelRemoteHost,remotePort:Q.tunnelRemotePort,localPort:Q.tunnelLocalPort,name:I?.label??F.name,closeable:!0,localAddress:Q.localAddress,protocol:_,localUri:await this.X(Q.localAddress,I),runningProcess:ae?.detail,hasRunningProcess:!!ae,pid:ae?.pid,source:F.source??e.$uL,privacy:Q.privacy};return this.forwarded.set(X,ge),this.f.set(X,Q),this.c.delete(X),await this.cb(),await this.eb(Q,T,I),this.g.fire(ge),Q}this.c.delete(X)}return G}gb(F,I){const O=this.D.has(F)?this.D:this.F.has(F)?this.F:void 0;if(O){const T=O.get(F);O.delete(F),T&&(I.name=T.name??I.name,I.local=("local"in T?T.local:"localPort"in T?T.localPort:void 0)??I.local,I.privacy=I.privacy)}return I}async hb(F,I,O){const T=O?.label??I.name;let G;(function(x){x[x.None=0]="None",x[x.Fire=1]="Fire",x[x.Reopen=2]="Reopen"})(G||(G={}));let te=G.None;switch(T!==F.name&&(F.name=T,te=G.Fire),(O?.protocol||F.protocol!==k.TunnelProtocol.Http)&&O?.protocol!==F.protocol&&(I.source=F.source,te=G.Reopen),I.privacy&&F.privacy!==I.privacy&&(te=G.Reopen),te){case G.Fire:{this.g.fire();break}case G.Reopen:await this.close(F.remoteHost,F.remotePort,d.User),await this.fb(I,O)}return b(this.f,I.remote.host,I.remote.port)}async name(F,I,O){const T=b(this.forwarded,F,I),G=g(F,I);if(T){T.name=O,await this.cb(),this.j.fire({host:F,port:I});return}else this.detected.has(G)&&(this.detected.get(G).name=O,this.j.fire({host:F,port:I}))}async close(F,I,O){const T=g(F,I),G=this.forwarded.get(T);return O===d.AutoForwardEnd&&G&&G.source.source===$.Auto&&this.F.set(T,{local:G.localPort,name:G.name,privacy:G.privacy}),await this.H.closeTunnel(F,I),this.W({host:F,port:I},O)}address(F,I){const O=g(F,I);return(this.forwarded.get(O)||this.detected.get(O))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(F){if(F)for(const I of F){const O=b(this.m??new Map,I.remoteAddress.host,I.remoteAddress.port),T=typeof I.localAddress=="string"?I.localAddress:g(I.localAddress.host,I.localAddress.port);this.detected.set(g(I.remoteAddress.host,I.remoteAddress.port),{remoteHost:I.remoteAddress.host,remotePort:I.remoteAddress.port,localAddress:T,protocol:k.TunnelProtocol.Http,localUri:this.X(T),closeable:!1,runningProcess:O?.detail,hasRunningProcess:!!O,pid:O?.pid,privacy:k.TunnelPrivacyId.ConstantPrivate,source:{source:$.Extension,description:l.localize(4,null)}}),this.H.setEnvironmentTunnel(I.remoteAddress.host,I.remoteAddress.port,T,k.TunnelPrivacyId.ConstantPrivate,k.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(F){this.r=F}async setCandidates(F){let I=F;this.r&&(I=await this.r(F));const O=this.ib(I);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(O.values()).map(T=>T.port).join(", ")}`),this.n.fire(O)}ib(F){const I=this.m??new Map,O=new Map;return this.m=O,F.forEach(T=>{const G=g(T.host,T.port);O.set(G,{host:T.host,port:T.port,detail:T.detail,pid:T.pid}),I.has(G)&&I.delete(G);const te=b(this.forwarded,T.host,T.port);te&&(te.runningProcess=T.detail,te.hasRunningProcess=!0,te.pid=T.pid)}),I.forEach((T,G)=>{const te=a(G);if(!te)return;const x=b(this.forwarded,te.host,te.port);x&&(x.runningProcess=void 0,x.hasRunningProcess=!1,x.pid=void 0);const X=b(this.detected,te.host,te.port);X&&(X.runningProcess=void 0,X.hasRunningProcess=!1,X.pid=void 0)}),I}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async jb(){const F=Array.from(this.forwarded.values()),I=await this.getAttributes(F.map(O=>({port:O.remotePort,host:O.remoteHost})),!1);if(I)for(const O of F){const T=I.get(O.remotePort);(T?.protocol||O.protocol!==k.TunnelProtocol.Http)&&T?.protocol!==O.protocol&&await this.fb({remote:{host:O.remoteHost,port:O.remotePort},local:O.localPort,name:O.name,source:O.source},T),T&&T.label&&T.label!==O.name&&await this.name(O.remoteHost,O.remotePort,T.label)}}async getAttributes(F,I=!0){const O=new Map,T=new Map;F.forEach(Q=>{const ae=b(this.m??new Map,k.$Tv[0],Q.port)??Q;if(ae){O.set(Q.port,ae);const _=P(ae)?ae.pid:void 0;T.has(_)||T.set(_,[]),T.get(_)?.push(Q.port)}});const G=new Map;if(F.forEach(Q=>{const ae=this.configPortsAttributes.getAttributes(Q.port,Q.host,O.get(Q.port)?.detail);ae&&G.set(Q.port,ae)}),this.G.length===0||!I)return G.size>0?G:void 0;const te=await Promise.all((0,j.$Rb)(this.G.map(Q=>Array.from(T.entries()).map(ae=>{const _=ae[1],ge=O.get(_[0]);return Q.providePortAttributes(_,ge?.pid,ge?.detail,i.CancellationToken.None)})))),x=new Map;if(te.forEach(Q=>Q.forEach(ae=>{ae&&x.set(ae.port,ae)})),!G&&!x)return;const X=new Map;return F.forEach(Q=>{const ae=G.get(Q.port),_=x.get(Q.port);X.set(Q.port,{elevateIfNeeded:ae?.elevateIfNeeded,label:ae?.label,onAutoForward:ae?.onAutoForward??N.providedActionToAction(_?.autoForwardAction),requireLocalPort:ae?.requireLocalPort,protocol:ae?.protocol})}),X}addAttributesProvider(F){this.G.push(F)}};e.$BL=U,Ye([(0,L.$Kh)(1e3)],U.prototype,"cb",null),e.$BL=U=Ye([Ve(0,k.$Pv),Ve(1,S.$Ip),Ve(2,E.$Li),Ve(3,m.$qL),Ve(4,v.$kl),Ve(5,u.$oi),Ve(6,C.$zj),Ve(7,M.$iw),Ve(8,o.$UF),Ve(9,c.$xj)],U)}),define(Se[94],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$gK=e.$fK=void 0;class l{constructor(R,p){this.line=R,this.character=p}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,p){return new l(0,0)}with(R){return new l(0,0)}}e.$fK=l;class j{constructor(R,p,w,E){this.isEmpty=!1,this.isSingleLine=!1,this.start=new l(R,p),this.end=new l(w,E)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new j(0,0,0,0)}with(R){return new j(0,0,0,0)}}e.$gK=j;var L;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(L||(e.TextSearchCompleteMessageType=L={}))}),define(Se[36],De([1,0,19,35,24,34,14,5,17,13,94,8]),function(fe,e,l,j,L,A,R,p,w,E,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HK=e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.$AK=e.$zK=e.$yK=e.$xK=e.$wK=e.SearchErrorCode=e.$vK=e.$uK=e.SearchSortOrder=e.ViewMode=e.$tK=e.$sK=e.$rK=e.$qK=e.SearchCompletionExitCode=e.$pK=e.$oK=e.$nK=e.QueryType=e.SearchProviderType=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.$hK=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return M.TextSearchCompleteMessageType}}),e.$hK="workbench.view.search",e.$iK="workbench.panel.search",e.$jK="workbench.view.search",e.$kK="search-result",e.$lK="search.exclude";const v="\u27EA ",S=" characters skipped \u27EB",k=(v.length+S.length+5)*2;e.$mK=(0,p.$fi)("searchService");var u;(function(Q){Q[Q.file=0]="file",Q[Q.text=1]="text",Q[Q.aiText=2]="aiText"})(u||(e.SearchProviderType=u={}));var m;(function(Q){Q[Q.File=1]="File",Q[Q.Text=2]="Text",Q[Q.aiText=3]="aiText"})(m||(e.QueryType=m={}));function o(Q){return!!Q.preview}e.$nK=o;function i(Q){return!!Q.resource}e.$oK=i;function n(Q){return!!Q.message}e.$pK=n;var s;(function(Q){Q[Q.Normal=0]="Normal",Q[Q.NewSearchStarted=1]="NewSearchStarted"})(s||(e.SearchCompletionExitCode=s={}));class c{constructor(ae){this.resource=ae,this.results=[]}}e.$qK=c;class t{constructor(ae,_,ge,se){this.ranges=_,this.webviewIndex=se;const re=Array.isArray(_)?_:[_];if(ge&&ge.matchLines===1&&f(re)){ae=(0,R.$Lf)(ae,ge.matchLines);let B="",ie=0,ye=0;const le=Math.floor(ge.charsPerLine/5),ue=[];for(const ce of re){const de=Math.max(ce.startColumn-le,0),H=ce.startColumn+ge.charsPerLine;if(de>ye+le+k){const Z=v+(de-ye)+S;B+=Z+ae.slice(de,H),ie+=de-(ye+Z.length)}else B+=ae.slice(ye,H);ue.push(new r(0,ce.startColumn-ie,ce.endColumn-ie)),ye=H}this.preview={text:B,matches:Array.isArray(this.ranges)?ue:ue[0]}}else{const B=Array.isArray(_)?_[0].startLineNumber:_.startLineNumber;this.preview={text:ae,matches:(0,l.$2b)(_,ie=>new h(ie.startLineNumber-B,ie.startColumn,ie.endLineNumber-B,ie.endColumn))}}}}e.$rK=t;function f(Q){const ae=Q[0].startLineNumber;for(const _ of Q)if(_.startLineNumber!==ae||_.endLineNumber!==ae)return!1;return!0}class h{constructor(ae,_,ge,se){this.startLineNumber=ae,this.startColumn=_,this.endLineNumber=ge,this.endColumn=se}}e.$sK=h;class r extends h{constructor(ae,_,ge){super(ae,_,ae,ge)}}e.$tK=r;var a;(function(Q){Q.List="list",Q.Tree="tree"})(a||(e.ViewMode=a={}));var d;(function(Q){Q.Default="default",Q.FileNames="fileNames",Q.Type="type",Q.Modified="modified",Q.CountDescending="countDescending",Q.CountAscending="countAscending"})(d||(e.SearchSortOrder=d={}));function $(Q,ae=!0){const _=Q&&Q.files&&Q.files.exclude,ge=ae&&Q&&Q.search&&Q.search.exclude;if(!_&&!ge)return;if(!_||!ge)return _||ge;let se=Object.create(null);return se=L.$Nn(se,L.$Kn(_)),se=L.$Nn(se,L.$Kn(ge),!0),se}e.$uK=$;function D(Q,ae){return Q.excludePattern&&j.$Xj(Q.excludePattern,ae)?!1:Q.includePattern||Q.usingSearchPaths?Q.includePattern&&j.$Xj(Q.includePattern,ae)?!0:Q.usingSearchPaths?!!Q.folderQueries&&Q.folderQueries.some(_=>{const ge=_.folder.fsPath;if(A.$fg(ae,ge)){const se=w.$lc(ge,ae);return!_.includePattern||!!j.$Xj(_.includePattern,se)}else return!1}):!1:!0}e.$vK=D;var b;(function(Q){Q[Q.unknownEncoding=1]="unknownEncoding",Q[Q.regexParseError=2]="regexParseError",Q[Q.globParseError=3]="globParseError",Q[Q.invalidLiteral=4]="invalidLiteral",Q[Q.rgProcessError=5]="rgProcessError",Q[Q.other=6]="other",Q[Q.canceled=7]="canceled"})(b||(e.SearchErrorCode=b={}));class g extends Error{constructor(ae,_){super(ae),this.code=_}}e.$wK=g;function y(Q){const ae=Q.message;if((0,E.$4)(Q))return new g(ae,b.canceled);try{const _=JSON.parse(ae);return new g(_.message,_.code)}catch{return new g(ae,b.other)}}e.$xK=y;function P(Q){const ae={message:Q.message,code:Q.code};return new Error(JSON.stringify(ae))}e.$yK=P;function N(Q){return Q.type==="error"?!0:Q.type==="success"}e.$zK=N;function U(Q){return Q.type==="success"}e.$AK=U;function z(Q){return!!Q.path}e.$BK=z;function F(Q,ae,_=!0){const ge=Q.searchPath?Q.searchPath:Q.relativePath;return _?(0,R.$If)(ge,ae):j.$Xj(ae,ge)}e.$CK=F;class I{constructor(ae){this.path=ae,this.results=[]}addMatch(ae){this.results.push(ae)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$DK=I;function O(Q,ae){const _={...Q||{},...ae||{}};return Object.keys(_).filter(ge=>{const se=_[ge];return typeof se=="boolean"&&se})}e.$EK=O;class T{constructor(ae,_){this.c=null,this.a={...ae.excludePattern||{},..._.excludePattern||{}},this.b=j.$Yj(this.a);let ge=ae.includePattern;_.includePattern&&(ge?ge={...ge,..._.includePattern}:ge=_.includePattern),ge&&(this.c=j.$Yj(ge))}matchesExcludesSync(ae,_,ge){return!!(this.b&&this.b(ae,_,ge))}includedInQuerySync(ae,_,ge){return!(this.b&&this.b(ae,_,ge)||this.c&&!this.c(ae,_,ge))}includedInQuery(ae,_,ge){const se=this.b(ae,_,ge),re=()=>this.c?!!this.c(ae,_,ge):!0;return(0,C.$4g)(se)?se.then(B=>B?!1:re()):re()}hasSiblingExcludeClauses(){return G(this.a)}}e.$FK=T;function G(Q){for(const ae in Q)if(typeof Q[ae]!="boolean")return!0;return!1}function te(Q){if(!Q)return;let ae;return _=>(ae||(ae=(Q()||Promise.resolve([])).then(ge=>ge?X(ge):{})),ae.then(ge=>!!ge[_]))}e.$GK=te;function x(Q){if(!Q)return;let ae;return _=>{if(!ae){const ge=Q();ae=ge?X(ge):{}}return!!ae[_]}}e.$HK=x;function X(Q){const ae={};for(const _ of Q)ae[_]=!0;return ae}}),define(Se[41],De([1,0,19,8,22,4,3,76,15,125,23,14,2,227,5,12,258,40,59,27,20,16,7,65,36,6,56]),function(fe,e,l,j,L,A,R,p,w,E,M,C,v,S,k,u,m,o,i,n,s,c,t,f,h,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cic=e.$bic=void 0;function d(U,z,F){return new M.$Hg(I=>g(I,F)).isEqual(U,z)}function $(U,z,F){return d(U.uri,z.uri,F)?0:(0,C.$cf)(U.uri.toString(),z.uri.toString())}function D(U,z,F){return U.index!==z.index?U.index<z.index?-1:1:d(U.uri,z.uri,F)?(0,C.$cf)(U.name,z.name):(0,C.$cf)(U.uri.toString(),z.uri.toString())}function b(U,z,F,I){const O=U.slice(0).sort((G,te)=>F(G,te,I)),T=z.slice(0).sort((G,te)=>F(G,te,I));return(0,l.$Eb)(O,T,(G,te)=>F(G,te,I))}function g(U,z){const F=z.getCapabilities(U.scheme);return!(F&&F&1024)}class y extends o.$yi{static toExtHostWorkspace(z,F,I,O){if(!z)return{workspace:null,added:[],removed:[]};const{id:T,name:G,folders:te,configuration:x,transient:X,isUntitled:Q}=z,ae=[],_=F;F?te.forEach((B,ie)=>{const ye=v.URI.revive(B.uri),le=y.o(I||F,ye,O);le?(le.name=B.name,le.index=B.index,ae.push(le)):ae.push({uri:ye,name:B.name,index:ie})}):ae.push(...te.map(({uri:B,name:ie,index:ye})=>({uri:v.URI.revive(B),name:ie,index:ye}))),ae.sort((B,ie)=>B.index<ie.index?-1:1);const ge=new y(T,G,ae,!!X,x?v.URI.revive(x):null,!!Q,B=>g(B,O)),{added:se,removed:re}=b(_?_.workspaceFolders:[],ge.workspaceFolders,$,O);return{workspace:ge,added:se,removed:re}}static o(z,F,I){for(let O=0;O<z.folders.length;O++){const T=z.workspaceFolders[O];if(d(T.uri,F,I))return T}}constructor(z,F,I,O,T,G,te){super(z,I.map(x=>new o.$zi(x)),O,T,te),this.t=F,this.u=G,this.q=[],this.s=p.$li.forUris(te),I.forEach(x=>{this.q.push(x),this.s.set(x.uri,x)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(z,F){return F&&this.s.get(z)&&(z=(0,M.$Rg)(z)),this.s.findSubstr(z)}resolveWorkspaceFolder(z){return this.s.get(z)}}let P=class{constructor(z,F,I,O,T){this.c=new A.$5d,this.onDidChangeWorkspace=this.c.event,this.g=new A.$5d,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new A.$7d,this.C=new Map,this.h=O,this.s=I,this.t=T,this.j=new E.$gm,this.k=new j.$eh,this.o=z.getProxy(r.$6L.MainThreadWorkspace),this.q=z.getProxy(r.$6L.MainThreadMessageService);const G=F.workspace;this.l=G?new y(G.id,G.name,[],!!G.transient,G.configuration?v.URI.revive(G.configuration):null,!!G.isUntitled,te=>g(te,I)):void 0}$initializeWorkspace(z,F){this.v=F,this.$acceptWorkspaceData(z),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?v.URI.from({scheme:w.Schemas.untitled,path:(0,M.$Pg)((0,M.$Rg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(z,F,I,...O){const T=[];if(Array.isArray(O)&&O.forEach(Q=>{v.URI.isUri(Q.uri)&&!T.some(ae=>d(ae.uri,Q.uri,this.s))&&T.push({uri:Q.uri,name:Q.name||(0,M.$Og)(Q.uri)})}),this.n||[F,I].some(Q=>typeof Q!="number"||Q<0)||I===0&&T.length===0)return!1;const G=this.x?this.x.workspaceFolders:[];if(F+I>G.length)return!1;const te=G.slice(0);te.splice(F,I,...T.map(Q=>({uri:Q.uri,name:Q.name||(0,M.$Og)(Q.uri),index:void 0})));for(let Q=0;Q<te.length;Q++){const ae=te[Q];if(te.some((_,ge)=>ge!==Q&&d(ae.uri,_.uri,this.s)))return!1}te.forEach((Q,ae)=>Q.index=ae);const{added:x,removed:X}=b(G,te,D,this.s);if(x.length===0&&X.length===0)return!1;if(this.o){const Q=z.displayName||z.name;this.o.$updateWorkspaceFolders(Q,F,I,T).then(void 0,ae=>{this.n=void 0;const _={source:{identifier:z.identifier,label:z.displayName||z.name}};this.q.$showMessage(m.Severity.Error,(0,S.localize)(0,null,Q,ae.toString()),_,[])})}return this.y(te),!0}getWorkspaceFolder(z,F){if(this.x)return this.x.getWorkspaceFolder(z,F)}async getWorkspaceFolder2(z,F){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(z,F)}async resolveWorkspaceFolder(z){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(z)}getPath(){if(!this.x)return;const{folders:z}=this.x;if(z.length!==0)return z[0].uri.fsPath}getRelativePath(z,F){let I,O="";if(typeof z=="string"?(I=v.URI.file(z),O=z):typeof z<"u"&&(I=z,O=z.fsPath),!I)return O;const T=this.getWorkspaceFolder(I,!0);if(!T)return O;typeof F>"u"&&this.x&&(F=this.x.folders.length>1);let G=(0,M.$Ug)(T.uri,I);return F&&T.name&&(G=`${T.name}/${G}`),G}y(z){this.x&&(this.n=y.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:z,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(z){const{workspace:F,added:I,removed:O}=y.toExtHostWorkspace(z,this.l,this.n,this.s);this.l=F||void 0,this.n=void 0,this.c.fire(Object.freeze({added:I,removed:O}))}findFiles(z,F,I,O,T=L.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${O.value}, entryPoint: findFiles`);let G="",te=!0;return F===null?te=!1:F!==void 0&&(typeof F=="string"?G=F:G=F.pattern),this.z(z,void 0,{exclude:G,maxResults:I,useDefaultExcludes:te,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},T)}findFiles2(z,F={},I,O=L.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${I.value}, entryPoint: findFiles2`),this.z(void 0,z,F,O)}async z(z,F,I,O=L.CancellationToken.None){if(O&&O.isCancellationRequested)return Promise.resolve([]);const T=typeof I.exclude=="string"?I.exclude:I.exclude?I.exclude.pattern:void 0,G={ignoreSymlinks:typeof I.followSymlinks=="boolean"?!I.followSymlinks:void 0,disregardIgnoreFiles:typeof I.useIgnoreFiles=="boolean"?!I.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof I.useGlobalIgnoreFiles=="boolean"?!I.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof I.useParentIgnoreFiles=="boolean"?!I.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof I.useDefaultExcludes=="boolean"?!I.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof I.useDefaultSearchExcludes=="boolean"?!I.useDefaultSearchExcludes:!1,maxResults:I.maxResults,excludePattern:T,shouldGlobSearch:typeof I.fuzzy=="boolean"?!I.fuzzy:!0,_reason:"startFileSearch"};let te;if(z){const{includePattern:x,folder:X}=N(c.GlobPattern.from(z));te=X,G.includePattern=x}else{const{includePattern:x,folder:X}=N(c.GlobPattern.from(F));te=X,G.filePattern=x}return this.o.$startFileSearch(te??null,G,O).then(x=>Array.isArray(x)?x.map(X=>v.URI.revive(X)):[])}async findTextInFiles(z,F,I,O,T=L.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${O.value}, entryPoint: findTextInFiles`);const G=this.j.getNext(),te=typeof F.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:F.previewOptions,{includePattern:x,folder:X}=N(c.GlobPattern.from(F.include)),Q=typeof F.exclude=="string"?F.exclude:F.exclude?F.exclude.pattern:void 0,ae={ignoreSymlinks:typeof F.followSymlinks=="boolean"?!F.followSymlinks:void 0,disregardIgnoreFiles:typeof F.useIgnoreFiles=="boolean"?!F.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof F.useGlobalIgnoreFiles=="boolean"?!F.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof F.useParentIgnoreFiles=="boolean"?!F.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof F.useDefaultExcludes=="boolean"?!F.useDefaultExcludes:!0,fileEncoding:F.encoding,maxResults:F.maxResults,previewOptions:te,afterContext:F.afterContext,beforeContext:F.beforeContext,includePattern:x,excludePattern:Q},_=!1;if(this.u[G]=ge=>{if(_)return;const se=v.URI.revive(ge.resource);ge.results.forEach(re=>{const B=(0,a.$Oh)(re);(0,h.$nK)(B)?I({uri:se,preview:{text:B.preview.text,matches:(0,l.$2b)(B.preview.matches,ie=>new t.$0L(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))},ranges:(0,l.$2b)(B.ranges,ie=>new t.$0L(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))}):I({uri:se,text:B.text,lineNumber:B.lineNumber})})},T.isCancellationRequested)return{};try{const ge=await this.o.$startTextSearch(z,X??null,ae,G,T);return delete this.u[G],ge||{}}catch(ge){throw delete this.u[G],ge}}$handleTextSearchResult(z,F){this.u[F]?.(z)}async save(z){const F=await this.o.$save(z,{saveAs:!1});return v.URI.revive(F)}async saveAs(z){const F=await this.o.$save(z,{saveAs:!0});return v.URI.revive(F)}saveAll(z){return this.o.$saveAll(z)}resolveProxy(z){return this.o.$resolveProxy(z)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(z){return this.o.$requestWorkspaceTrust(z)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(z,F){if(this.w.has(z))throw new Error(`A provider has already been registered for scheme ${z}`);this.w.set(z,F);const I=this.t.transformOutgoingScheme(z),O=this.A++;return this.o.$registerEditSessionIdentityProvider(O,I),(0,R.$Rc)(()=>{this.w.delete(z),this.o.$unregisterEditSessionIdentityProvider(O)})}async $getEditSessionIdentifier(z,F){this.h.info("Getting edit session identifier for workspaceFolder",z);const I=await this.resolveWorkspaceFolder(v.URI.revive(z));if(!I){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",I);const O=this.w.get(I.uri.scheme);if(this.h.info(`Provider for scheme ${I.uri.scheme} is defined: `,!!O),!O)return;const T=await O.provideEditSessionIdentity(I,F);if(this.h.info("Provider returned edit session identifier: ",T),!!T)return T}async $provideEditSessionIdentityMatch(z,F,I,O){this.h.info("Getting edit session identifier for workspaceFolder",z);const T=await this.resolveWorkspaceFolder(v.URI.revive(z));if(!T){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",T);const G=this.w.get(T.uri.scheme);if(this.h.info(`Provider for scheme ${T.uri.scheme} is defined: `,!!G),!G)return;const te=await G.provideEditSessionIdentityMatch?.(F,I,O);if(this.h.info("Provider returned edit session identifier match result: ",te),!!te)return te}getOnWillCreateEditSessionIdentityEvent(z){return(F,I,O)=>{const T=function(te){F.call(I,te)};return T.extension=z,this.B.event(T,void 0,O)}}async $onWillCreateEditSessionIdentity(z,F,I){const O=await this.resolveWorkspaceFolder(v.URI.revive(z));if(O===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:O},F,async(T,G)=>{const te=Date.now();await Promise.resolve(T),Date.now()-te>I&&this.h.warn("SLOW edit session create-participant",G.extension.identifier)}),F.isCancellationRequested}registerCanonicalUriProvider(z,F){if(this.C.has(z))throw new Error(`A provider has already been registered for scheme ${z}`);this.C.set(z,F);const I=this.t.transformOutgoingScheme(z),O=this.A++;return this.o.$registerCanonicalUriProvider(O,I),(0,R.$Rc)(()=>{this.C.delete(z),this.o.$unregisterCanonicalUriProvider(O)})}async provideCanonicalUri(z,F,I){const O=this.C.get(z.scheme);if(!O)return;const T=await O.provideCanonicalUri?.(v.URI.revive(z),F,I);if(T)return T}async $provideCanonicalUri(z,F,I){return this.provideCanonicalUri(v.URI.revive(z),{targetScheme:F},I)}};e.$bic=P,e.$bic=P=Ye([Ve(0,s.$lO),Ve(1,n.$BO),Ve(2,i.$Thc),Ve(3,u.$zj),Ve(4,f.$_hc)],P),e.$cic=(0,k.$fi)("IExtHostWorkspace");function N(U){let z,F;return U&&(typeof U=="string"?z=U:(z=U.pattern,F=v.URI.revive(U.baseUri))),{includePattern:z,folder:F}}}),define(Se[42],De([1,0,24,4,41,6,7,260,85,18,8,5,20,12,2]),function(fe,e,l,j,L,A,R,p,w,E,M,C,v,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fic=e.$eic=e.$dic=void 0;function u(f,h){if(h){const r=h.split(".");let a=f;for(let d=0;a&&d<r.length;d++)a=a[r[d]];return a}}function m(f){return f instanceof k.URI}function o(f){return f&&f.uri instanceof k.URI&&f.languageId&&typeof f.languageId=="string"}function i(f){return f&&!f.uri&&f.languageId&&typeof f.languageId=="string"}function n(f){return f&&f.uri instanceof k.URI&&(!f.name||typeof f.name=="string")&&(!f.index||typeof f.index=="number")}function s(f){if(m(f))return{resource:f};if(o(f))return{resource:f.uri,overrideIdentifier:f.languageId};if(i(f))return{overrideIdentifier:f.languageId};if(n(f))return{resource:f.uri};if(f===null)return{resource:null}}let c=class{constructor(h,r,a){this.a=h.getProxy(A.$6L.MainThreadConfiguration),this.c=r,this.b=a,this.d=new M.$eh,this.e=null}getConfigProvider(){return this.d.wait().then(h=>this.e)}$initializeConfiguration(h){this.e=new t(this.a,this.c,h,this.b),this.d.open()}$acceptConfigurationChanged(h,r){this.getConfigProvider().then(a=>a.$acceptConfigurationChanged(h,r))}};e.$dic=c,e.$dic=c=Ye([Ve(0,v.$lO),Ve(1,L.$cic),Ve(2,S.$zj)],c);class t{constructor(h,r,a,d){this.a=new j.$5d,this.b=h,this.f=d,this.c=r,this.e=p.$io.parse(a),this.d=this.k(a.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(h,r){const a={data:this.e.toData(),workspace:this.c.workspace};this.e=p.$io.parse(h),this.d=this.k(h.configurationScopes),this.a.fire(this.j(r,a))}getConfiguration(h,r,a){const d=s(r)||{},$=this.g(h?u(this.e.getValue(void 0,d,this.c.workspace),h):this.e.getValue(void 0,d,this.c.workspace));h&&this.h(h,d,a?.identifier);function D(g){if(g==null)return null;if(typeof g=="boolean")return g?2:5;switch(g){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const b={has(g){return typeof u($,g)<"u"},get:(g,y)=>{this.h(h?`${h}.${g}`:g,d,a?.identifier);let P=u($,g);if(typeof P>"u")P=y;else{let N;const U=(z,F)=>{if((0,E.$Uf)(z)){let I;const O=()=>{N=N||(0,l.$Kn)($),I=I||u(N,F)};return new Proxy(z,{get:(T,G)=>{if(typeof G=="string"&&G.toLowerCase()==="tojson")return O(),()=>I;if(N)return I=I||u(N,F),I[G];const te=T[G];return typeof G=="string"?U(te,`${F}.${G}`):te},set:(T,G,te)=>(O(),I&&(I[G]=te),!0),deleteProperty:(T,G)=>(O(),I&&delete I[G],!0),defineProperty:(T,G,te)=>(O(),I&&Object.defineProperty(I,G,te),!0)})}return Array.isArray(z)?(0,l.$Kn)(z):z};P=U(P,g)}return P},update:(g,y,P,N)=>{g=h?`${h}.${g}`:g;const U=D(P);return y!==void 0?this.b.$updateConfigurationOption(U,g,y,d,N):this.b.$removeConfigurationOption(U,g,d,N)},inspect:g=>{g=h?`${h}.${g}`:g;const y=this.e.inspect(g,d,this.c.workspace);if(y)return{key:g,defaultValue:(0,l.$Kn)(y.policy?.value??y.default?.value),globalValue:(0,l.$Kn)(y.user?.value??y.application?.value),workspaceValue:(0,l.$Kn)(y.workspace?.value),workspaceFolderValue:(0,l.$Kn)(y.workspaceFolder?.value),defaultLanguageValue:(0,l.$Kn)(y.default?.override),globalLanguageValue:(0,l.$Kn)(y.user?.override??y.application?.override),workspaceLanguageValue:(0,l.$Kn)(y.workspace?.override),workspaceFolderLanguageValue:(0,l.$Kn)(y.workspaceFolder?.override),languageIds:(0,l.$Kn)(y.overrideIdentifiers)}}};return typeof $=="object"&&(0,l.$Nn)(b,$,!1),Object.freeze(b)}g(h){const r=a=>(0,E.$Uf)(a)?new Proxy(a,{get:(d,$)=>r(d[$]),set:(d,$,D)=>{throw new Error(`TypeError: Cannot assign to read only property '${String($)}' of object`)},deleteProperty:(d,$)=>{throw new Error(`TypeError: Cannot delete read only property '${String($)}' of object`)},defineProperty:(d,$)=>{throw new Error(`TypeError: Cannot define property '${String($)}' for a readonly object`)},setPrototypeOf:d=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):a;return r(h)}h(h,r,a){const d=w.$_n.test(h)?4:this.d.get(h),$=a?`[${a.value}] `:"";if(d===4){typeof r?.resource>"u"&&this.f.warn(`${$}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${h}', provide the URI of a resource or 'null' for any resource.`);return}if(d===3){r?.resource&&this.f.warn(`${$}Accessing a window scoped configuration for a resource is not expected. To associate '${h}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(h,r){const a=new p.$ko(h,r,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(d,$)=>a.affectsConfiguration(d,s($))})}k(h){return h.reduce((r,a)=>(r.set(a[0],a[1]),r),new Map)}}e.$eic=t,e.$fic=(0,C.$fi)("IExtHostConfiguration")}),define(Se[95],De([1,0,2,8,4,6,7,41,71,42,22,46,20,27,5,15,11,12,91,302,13]),function(fe,e,l,j,L,A,R,p,w,E,M,C,v,S,k,u,m,o,i,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ijc=e.$Hjc=e.$Gjc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var c;(function(U){function z(I){if(I!=null)return I}U.from=z;function F(I){if(I!=null)return I}U.to=F})(c||(c={}));var t;(function(U){function z(I){if(I!=null)return I}U.from=z;function F(I){if(I!=null)return I}U.to=F})(t||(t={}));var f;(function(U){function z(I){if(I!=null)return I}U.from=z;function F(I){if(I!=null)return I}U.to=F})(f||(f={}));var h;(function(U){function z(O){if(O){const T=O;return T&&!!T.process}else return!1}U.is=z;function F(O){if(O==null)return;const T={process:O.process,args:O.args};return O.options&&(T.options=f.from(O.options)),T}U.from=F;function I(O){if(O!=null)return new R.$QM(O.process,O.args,O.options)}U.to=I})(h||(h={}));var r;(function(U){function z(I){if(I!=null)return I}U.from=z;function F(I){if(I!=null)return I}U.to=F})(r||(r={}));var a;(function(U){function z(O){if(O){const T=O;return T&&(!!T.commandLine||!!T.command)}else return!1}U.is=z;function F(O){if(O==null)return;const T={};return O.commandLine!==void 0?T.commandLine=O.commandLine:(T.command=O.command,T.args=O.args),O.options&&(T.options=r.from(O.options)),T}U.from=F;function I(O){if(!(O==null||O.command===void 0&&O.commandLine===void 0))return O.commandLine?new R.$RM(O.commandLine,O.options):new R.$RM(O.command,O.args?O.args:[],O.options)}U.to=I})(a||(a={}));var d;(function(U){function z(O){if(O){const T=O;return T&&T.customExecution==="customExecution"}else return!1}U.is=z;function F(O){return{customExecution:"customExecution"}}U.from=F;function I(O,T){return T.get(O)}U.to=I})(d||(e.CustomExecutionDTO=d={}));var $;(function(U){function z(F,I){let O;return F.scope!==void 0&&typeof F.scope!="number"?O=F.scope.uri:F.scope!==void 0&&typeof F.scope=="number"&&(F.scope===R.TaskScope.Workspace&&I&&I.workspaceFile?O=I.workspaceFile:O=n.$gH),{id:F._id,workspaceFolder:O}}U.from=z})($||(e.TaskHandleDTO=$={}));var D;(function(U){function z(F){if(F!=null)return{_id:F.id,isDefault:F.isDefault}}U.from=z})(D||(D={}));var b;(function(U){function z(O,T){if(O==null)return[];const G=[];for(const te of O){const x=F(te,T);x&&G.push(x)}return G}U.fromMany=z;function F(O,T){if(O==null)return;let G;O.execution instanceof R.$QM?G=h.from(O.execution):O.execution instanceof R.$RM?G=a.from(O.execution):O.execution&&O.execution instanceof R.$SM&&(G=d.from(O.execution));const te=c.from(O.definition);let x;return O.scope?typeof O.scope=="number"?x=O.scope:x=O.scope.uri:x=R.TaskScope.Workspace,!te||!x?void 0:{_id:O._id,definition:te,name:O.name,source:{extensionId:T.identifier.value,label:O.source,scope:x},execution:G,isBackground:O.isBackground,group:D.from(O.group),presentationOptions:t.from(O.presentationOptions),problemMatchers:O.problemMatchers,hasDefinedMatchers:O.hasDefinedMatchers,runOptions:O.runOptions?O.runOptions:{reevaluateOnRerun:!0},detail:O.detail}}U.from=F;async function I(O,T,G){if(O==null)return;let te;h.is(O.execution)?te=h.to(O.execution):a.is(O.execution)?te=a.to(O.execution):d.is(O.execution)&&(te=d.to(O._id,G));const x=c.to(O.definition);let X;if(O.source&&(O.source.scope!==void 0?typeof O.source.scope=="number"?X=O.source.scope:X=await T.resolveWorkspaceFolder(l.URI.revive(O.source.scope)):X=R.TaskScope.Workspace),!x||!X)return;const Q=new R.$TM(x,X,O.name,O.source.label,te,O.problemMatchers);return O.isBackground!==void 0&&(Q.isBackground=O.isBackground),O.group!==void 0&&(Q.group=R.$PM.from(O.group._id),Q.group&&O.group.isDefault&&(Q.group=new R.$PM(Q.group.id,Q.group.label),O.group.isDefault===!0&&(Q.group.isDefault=O.group.isDefault))),O.presentationOptions&&(Q.presentationOptions=t.to(O.presentationOptions)),O._id&&(Q._id=O._id),O.detail&&(Q.detail=O.detail),Q}U.to=I})(b||(e.TaskDTO=b={}));var g;(function(U){function z(I){return I}U.from=z;function F(I){if(I)return Object.assign(Object.create(null),I)}U.to=F})(g||(g={}));class y{#e;constructor(z,F,I){this._id=F,this.a=I,this.#e=z}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(z){}fireDidEndProcess(z){}}let P=class{constructor(z,F,I,O,T,G,te,x){this.q=new L.$5d,this.r=new L.$5d,this.s=new L.$5d,this.u=new L.$5d,this.a=z.getProxy(A.$6L.MainThreadTask),this.b=I,this.c=O,this.d=T,this.e=G,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=te,this.g=x,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(z,F,I){if(!I)return new R.$8L(()=>{});const O=this.x();return this.j.set(O,{type:F,provider:I,extension:z}),this.a.$registerTaskProvider(O,F),new R.$8L(()=>{this.j.delete(O),this.a.$unregisterTaskProvider(O)})}registerTaskSystem(z,F){this.a.$registerTaskSystem(z,F)}fetchTasks(z){return this.a.$fetchTasks(g.from(z)).then(async F=>{const I=[];for(const O of F){const T=await b.to(O,this.b,this.m);T&&I.push(T)}return I})}get taskExecutions(){const z=[];return this.k.forEach(F=>z.push(F)),z}terminateTask(z){if(!(z instanceof y))throw new Error("No valid task execution provided");return this.a.$terminateTask(z._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(z,F,I){const O=this.m.get(z.id);O&&(this.o.set(z.id,O),this.e.attachPtyToTerminal(F,await O.callback(I))),this.p=z.id,this.q.fire({execution:await this.z(z)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(z){if(!this.l.has(z.id))return;const F=await this.z(z);this.l.delete(z.id),this.k.delete(z.id),this.B(z),this.r.fire({execution:F})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(z){const F=await this.z(z.id);this.s.fire({execution:F,processId:z.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(z){const F=await this.z(z.id);this.u.fire({execution:F,exitCode:z.exitCode})}$provideTasks(z,F){const I=this.j.get(z);if(!I)return Promise.reject(new Error("no handler found"));const O=[],T=(0,j.$0g)(()=>I.provider.provideTasks(M.CancellationToken.None)).then(G=>this.v(F,O,I,G));return new Promise(G=>{T.then(te=>{Promise.all(O).then(()=>{G(te)})})})}async $resolveTask(z,F){const I=this.j.get(z);if(!I)return Promise.reject(new Error("no handler found"));if(F.definition.type!==I.type)throw new Error(`Unexpected: Task of type [${F.definition.type}] cannot be resolved by provider of type [${I.type}].`);const O=await b.to(F,this.b,this.m);if(!O)throw new Error("Unexpected: Task cannot be resolved.");const T=await I.provider.resolveTask(O,M.CancellationToken.None);if(!T)return;this.A(T,I);const G=b.from(T,I.extension);if(!G)throw new Error("Unexpected: Task cannot be resolved.");if(T.definition!==O.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return d.is(G.execution)&&await this.y(G,T,!0),await this.w(G)}x(){return this.h++}async y(z,F,I){const O=await this.a.$createTaskId(z);!I&&!this.m.has(O)&&(this.n.add(O),this.o.set(O,F.execution)),this.m.set(O,F.execution)}async z(z,F){if(typeof z=="string"){const T=this.l.get(z);if(!T)throw new s.$bb("Unexpected: The specified task is missing an execution");return T}const I=this.l.get(z.id);if(I)return I;let O;return F?O=Promise.resolve(new y(this,z.id,F)):O=b.to(z.task,this.b,this.m).then(T=>{if(!T)throw new s.$bb("Unexpected: Task does not exist.");return new y(this,z.id,T)}),this.l.set(z.id,O),O.then(T=>(this.k.set(z.id,T),T))}A(z,F){z._deprecated&&this.g.report("Task.constructor",F.extension,"Use the Task constructor that takes a `scope` instead.")}B(z){this.o.get(z.id)&&this.o.delete(z.id),this.n.has(z.id)&&this.p!==z.id&&(this.m.delete(z.id),this.n.delete(z.id));const I=this.n.values();let O=I.next();for(;!O.done;)!this.o.has(O.value)&&this.p!==O.value&&(this.m.delete(O.value),this.n.delete(O.value)),O=I.next()}};e.$Gjc=P,e.$Gjc=P=Ye([Ve(0,v.$lO),Ve(1,S.$BO),Ve(2,p.$cic),Ve(3,w.$wO),Ve(4,E.$fic),Ve(5,C.$Dic),Ve(6,o.$zj),Ve(7,i.$Phc)],P);let N=class extends P{constructor(z,F,I,O,T,G,te,x){super(z,F,I,O,T,G,te,x),this.registerTaskSystem(u.Schemas.vscodeRemote,{scheme:u.Schemas.vscodeRemote,authority:"",platform:m.$h(0)})}async executeTask(z,F){if(!F.execution)throw new Error("Tasks to execute must include an execution");const I=b.from(F,z);if(I===void 0)throw new Error("Task is not valid");if(d.is(I.execution))await this.y(I,F,!1);else throw new s.$_;const O=await this.z(await this.a.$getTaskExecution(I),F);return this.a.$executeTask(I).catch(T=>{throw new Error(T)}),O}v(z,F,I,O){const T=[];if(O)for(const G of O){if(this.A(G,I),!G.definition||!z[G.definition.type]){const x=G.source?G.source:"No task source";this.f.warn(`The task [${x}, ${G.name}] uses an undefined task type. The task will be ignored in the future.`)}const te=b.from(G,I.extension);te&&d.is(te.execution)?(T.push(te),F.push(this.y(te,G,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:T,extension:I.extension}}async w(z){if(d.is(z.execution))return z;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(z,F){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(z,F,I){}};e.$Hjc=N,e.$Hjc=N=Ye([Ve(0,v.$lO),Ve(1,S.$BO),Ve(2,p.$cic),Ve(3,w.$wO),Ve(4,E.$fic),Ve(5,C.$Dic),Ve(6,o.$zj),Ve(7,i.$Phc)],N),e.$Ijc=(0,k.$fi)("IExtHostTask")}),define(Se[364],De([1,0,36,29]),function(fe,e,l,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PK=e.$OK=e.$NK=void 0;function L(R){return"cellResults"in R}e.$NK=L,e.$OK="rawCell#";function A(R,p){let w=-1;const E=[];let M=[];return R.forEach(v=>{v.range.startLineNumber!==w&&M.length>0&&(E.push([...M]),M=[]),M.push(v),w=v.range.endLineNumber}),M.length>0&&E.push([...M]),E.map(v=>{const S=[],k=v[0].range.startLineNumber,u=v[v.length-1].range.endLineNumber;for(let m=k;m<=u;m++)S.push(p.getLineContent(m));return new l.$rK(S.join(`
`)+`
`,v.map(m=>new j.$9s(m.range.startLineNumber-1,m.range.startColumn-1,m.range.endLineNumber-1,m.range.endColumn-1)))})}e.$PK=A}),define(Se[365],De([1,0,221,21,4,3,28,14,18,2,32,111,6,33,16,7,67,335,153,24,15,292,364,361]),function(fe,e,l,j,L,A,R,p,w,E,M,C,v,S,k,u,m,o,i,n,s,c,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ijc=void 0;class h{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(a=>a.apiEditor)}constructor(a,d,$,D,b,g){this.q=$,this.r=D,this.s=b,this.t=g,this.f=new Map,this.g=new R.$Ac,this.h=new Map,this.j=new L.$5d,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new L.$5d,this.onDidOpenNotebookDocument=this.m.event,this.n=new L.$5d,this.onDidCloseNotebookDocument=this.n.event,this.o=new L.$5d,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new C.$Nhc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=a.getProxy(v.$6L.MainThreadNotebook),this.c=a.getProxy(v.$6L.MainThreadNotebookDocuments),this.d=a.getProxy(v.$6L.MainThreadNotebookEditors),this.i=d.converter,d.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===13){const P=y.notebookEditor?.notebookUri,N=y.cell.handle,z=this.g.get(P)?.getCell(N);if(z)return z.apiCell}if(y&&y.$mid===14){const P=y.uri,N=this.g.get(P);if(N)return N.apiNotebook}return y}}),h.B(d)}getEditorById(a){const d=this.h.get(a);if(!d)throw new Error(`unknown text editor: ${a}. known editors: ${[...this.h.keys()]} `);return d}getIdByEditor(a){for(const[d,$]of this.h)if($.apiEditor===a)return d}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(a,d){const $=this.g.get(a);if(!$&&!d)throw new Error(`NO notebook document for '${a}'`);return $}static u(a,d){if(!d)return;const $=d.filenamePattern.map(D=>k.NotebookExclusiveDocumentPattern.from(D)).filter(D=>D!==void 0);if(d.filenamePattern&&!$){console.warn(`Notebook content provider view options file name pattern is invalid ${d.filenamePattern}`);return}return{extension:a.identifier,providerDisplayName:a.displayName||a.name,displayName:d.displayName,filenamePattern:$,exclusive:d.exclusive||!1}}registerNotebookCellStatusBarItemProvider(a,d,$){const D=h.a++,b=typeof $.onDidChangeCellStatusBarItems=="function"?h.a++:void 0;this.f.set(D,$),this.b.$registerNotebookCellStatusBarItemProvider(D,b,d);let g;return b!==void 0&&(g=$.onDidChangeCellStatusBarItems(y=>this.b.$emitCellStatusBarEvent(b))),new u.$8L(()=>{this.f.delete(D),this.b.$unregisterNotebookCellStatusBarItemProvider(D,b),g?.dispose()})}async createNotebookDocument(a){const d=await this.c.$tryCreateNotebook({viewType:a.viewType,content:a.content&&k.NotebookData.from(a.content)});return E.URI.revive(d)}async openNotebookDocument(a){const d=this.g.get(a);if(d)return d.apiNotebook;const $=await this.c.$tryOpenNotebook(a),D=this.g.get(E.URI.revive($));return(0,w.$4f)(D?.apiNotebook)}async showNotebookDocument(a,d){E.URI.isUri(a)&&(a=await this.openNotebookDocument(a));let $;typeof d=="object"?$={position:k.ViewColumn.from(d.viewColumn),preserveFocus:d.preserveFocus,selections:d.selections&&d.selections.map(k.NotebookRange.from),pinned:typeof d.preview=="boolean"?!d.preview:void 0}:$={preserveFocus:!1};const D=await this.d.$tryShowNotebookDocument(a.uri,a.notebookType,$),b=D&&this.h.get(D)?.apiEditor;if(b)return b;throw D?new Error(`Could NOT open editor for "${a.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${a.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(a,d,$,D){const b=this.f.get(a),g=E.URI.revive(d),y=this.g.get(g);if(!y||!b)return;const P=y.getCellFromIndex($);if(!P)return;const N=await b.provideCellStatusBarItems(P.apiCell,D);if(!N)return;const U=new A.$Sc,z=this.p.add([U]),I=(Array.isArray(N)?N:[N]).map(O=>k.NotebookStatusBarItem.from(O,this.i,U));return{cacheId:z,items:I}}$releaseNotebookCellStatusBarItems(a){this.p.delete(a)}registerNotebookSerializer(a,d,$,D,b){if((0,p.$Se)(d))throw new Error("viewType cannot be empty or just whitespace");const g=this.w++;return this.x.set(g,{viewType:d,serializer:$,options:D}),this.b.$registerNotebookSerializer(g,{id:a.identifier,location:a.extensionLocation},d,k.NotebookDocumentContentOptions.from(D),h.u(a,b)),(0,A.$Rc)(()=>{this.b.$unregisterNotebookSerializer(g)})}async $dataToNotebook(a,d,$){const D=this.x.get(a);if(!D)throw new Error("NO serializer found");const b=await D.serializer.deserializeNotebook(d.buffer,$);return new m.$9v(k.NotebookData.from(b))}async $notebookToData(a,d,$){const D=this.x.get(a);if(!D)throw new Error("NO serializer found");const b=await D.serializer.serializeNotebook(k.NotebookData.to(d.value),$);return j.$se.wrap(b)}async $saveNotebook(a,d,$,D,b){const g=E.URI.revive(d),y=this.x.get(a);if(!y)throw new Error("NO serializer found");const P=this.g.get(g);if(!P)throw new Error("Document NOT found");if(P.versionId!==$)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(g.scheme))throw new M.$1k((0,l.localize)(0,null,this.z(g)),6);await this.y(g,D);const N={metadata:(0,n.$Sn)(P.apiNotebook.metadata,O=>!(y.options?.transientDocumentMetadata??{})[O]),cells:[]};for(const O of P.apiNotebook.getCells()){const T=new u.$wN(O.kind,O.document.getText(),O.document.languageId,O.mime,y.options?.transientOutputs?[]:[...O.outputs],O.metadata,O.executionSummary);T.metadata=(0,n.$Sn)(O.metadata,G=>!(y.options?.transientCellMetadata??{})[G]),N.cells.push(T)}const U=await y.serializer.serializeNotebook(N,b);await this.s.value.writeFile(g,U);const z=this.s.getFileSystemProviderExtUri(g.scheme),F=await this.s.value.stat(g);return{name:z.basename(g),isFile:(F.type&M.FileType.File)!==0,isDirectory:(F.type&M.FileType.Directory)!==0,isSymbolicLink:(F.type&M.FileType.SymbolicLink)!==0,mtime:F.mtime,ctime:F.ctime,size:F.size,readonly:!!((F.permissions??0)&M.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(g.scheme),locked:!!((F.permissions??0)&M.FilePermission.Locked),etag:M.$_k({mtime:F.mtime,size:F.size}),children:void 0}}async $searchInNotebooks(a,d,$,D,b){const g=this.x.get(a)?.serializer;if(!g)return{limitHit:!1,results:[]};const y=new R.$Bc;await(async(F,I,O)=>{await Promise.all(F.map(async T=>await Promise.all(T.filenamePatterns.map(G=>{const te={_reason:O._reason,folderQueries:O.folderQueries,includePattern:O.includePattern,excludePattern:O.excludePattern,maxResults:O.maxResults,type:1,filePattern:G};return this.t.doInternalFileSearchWithCustomCallback(te,I,x=>{x.forEach(X=>{y.has(X)||D.some(ae=>T.isFromSettings&&!ae.isFromSettings?!1:ae.filenamePatterns.some(_=>(0,f.$9eb)(_,X)))||y.add(X)})}).catch(x=>{if(x.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw x})}))))})($,b,d);const N=new R.$Ac;let U=!1;const z=Array.from(y).map(async F=>{const I=[];try{if(b.isCancellationRequested)return;if(d.maxResults&&[...N.values()].reduce((te,x)=>te+x.cellResults.length,0)>d.maxResults){U=!0;return}const O=[],T=this.g.get(F);if(T)T.apiNotebook.getCells().forEach(x=>O.push({input:x.document.getText(),outputs:x.outputs.flatMap(X=>X.items.map(Q=>Q.data.toString()))}));else{const te=await this.s.value.readFile(F),x=j.$se.fromString(te.toString()),X=await g.deserializeNotebook(x.buffer,b);if(b.isCancellationRequested)return;k.NotebookData.from(X).cells.forEach(ae=>O.push({input:ae.source,outputs:ae.outputs.flatMap(_=>_.items.map(ge=>ge.valueBytes.toString()))}))}if(b.isCancellationRequested)return;O.forEach((te,x)=>{const X=d.contentPattern.pattern,Q=new c.$xTb(te.input,void 0,te.outputs),ae=Q.findInInputs(X),_=Q.findInOutputs(X),ge=_.flatMap(se=>(0,t.$PK)(se.matches,se.textBuffer)).map((se,re)=>(se.webviewIndex=re,se));if(ae.length>0||_.length>0){const se={index:x,contentResults:(0,t.$PK)(ae,Q.inputTextBuffer),webviewResults:ge};I.push(se)}});const G={resource:F,cellResults:I};N.set(F,G);return}catch{return}});return await Promise.all(z),{limitHit:U,results:[...N.values()]}}async y(a,d){const $=await this.s.value.stat(a);if(typeof d?.mtime=="number"&&typeof d.etag=="string"&&d.etag!==M.$$k&&typeof $.mtime=="number"&&typeof $.size=="number"&&d.mtime<$.mtime&&d.etag!==M.$_k({mtime:d.mtime,size:$.size}))throw new M.$1k((0,l.localize)(1,null),3,d)}z(a){return a.scheme===s.Schemas.file?a.fsPath:a.toString()}A(a,d,$){if(this.h.has(d))throw new Error(`editor with id ALREADY EXSIST: ${d}`);const D=new i.$_ic(d,this.d,a,$.visibleRanges.map(k.NotebookRange.to),$.selections.map(k.NotebookRange.to),typeof $.viewColumn=="number"?k.ViewColumn.to($.viewColumn):void 0);this.h.set(d,D)}$acceptDocumentAndEditorsDelta(a){if(a.value.removedDocuments)for(const $ of a.value.removedDocuments){const D=E.URI.revive($),b=this.g.get(D);b&&(b.dispose(),this.g.delete(D),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:b.apiNotebook.getCells().map(g=>g.document.uri)}),this.n.fire(b.apiNotebook));for(const g of this.h.values())g.notebookData.uri.toString()===D.toString()&&this.h.delete(g.id)}if(a.value.addedDocuments){const $=[];for(const D of a.value.addedDocuments){const b=E.URI.revive(D.uri);if(this.g.has(b))throw new Error(`adding EXISTING notebook ${b} `);const g=new o.$$ic(this.c,this.q,this.r,b,D);$.push(...D.cells.map(y=>o.$0ic.asModelAddData(y))),this.g.get(b)?.dispose(),this.g.set(b,g),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:$}),this.m.fire(g.apiNotebook)}}if(a.value.addedEditors)for(const $ of a.value.addedEditors){if(this.h.has($.id))return;const D=E.URI.revive($.documentUri),b=this.g.get(D);b&&this.A(b,$.id,$)}const d=[];if(a.value.removedEditors)for(const $ of a.value.removedEditors){const D=this.h.get($);D&&(this.h.delete($),this.k?.id===D.id&&(this.k=void 0),d.push(D))}if(a.value.visibleEditors){this.l=a.value.visibleEditors.map(D=>this.h.get(D)).filter(D=>!!D);const $=new Set;this.l.forEach(D=>$.add(D.id));for(const D of this.h.values()){const b=$.has(D.id);D._acceptVisibility(b)}this.l=[...this.h.values()].map(D=>D).filter(D=>D.visible),this.o.fire(this.visibleNotebookEditors)}a.value.newActiveEditor===null?this.k=void 0:a.value.newActiveEditor&&(this.h.get(a.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${a.value.newActiveEditor}`),this.k=this.h.get(a.value.newActiveEditor)),a.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(a){const d=S.$JO.String.with("notebookType","A notebook type"),$=new S.$LO("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[d,new S.$JO("data","Bytes to convert to data",b=>b instanceof Uint8Array,b=>j.$se.wrap(b))],new S.$KO("Notebook Data",b=>k.NotebookData.to(b.value))),D=new S.$LO("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[d,new S.$JO("NotebookData","Notebook data to convert to bytes",b=>!0,b=>new m.$9v(k.NotebookData.from(b)))],new S.$KO("Bytes",b=>b.buffer));a.registerApiCommand($),a.registerApiCommand(D)}}e.$ijc=h}),define(Se[366],De([1,0,17,22,44,35,23,38,36]),function(fe,e,l,j,L,A,R,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ajc=void 0;class E{constructor(v,S,k){this.k=v,this.l=S,this.o=k,this.e=!1,this.f=0,this.g=!1,this.a=v.filePattern,this.b=v.includePattern&&A.$Yj(v.includePattern),this.c=v.maxResults||void 0,this.d=v.exists,this.h=new Set,this.j=v.excludePattern&&A.$Yj(v.excludePattern)}cancel(){this.g=!0,this.h.forEach(v=>v.cancel()),this.h=new Set}search(v){const S=this.k.folderQueries||[];return new Promise((k,u)=>{const m=o=>{this.f++,v(o)};if(this.g)return k({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(o=>{const i=o.toString(),n=l.$nc(i);this.j&&this.j(i,n)||this.v(m,{base:o,basename:n})}),Promise.all(S.map(o=>this.p(o,m))).then(o=>{k({limitHit:this.e,stats:o[0]||void 0})},o=>{u(new Error((0,L.$3i)(o)))})})}async p(v,S){const k=new j.$ce,u=this.q(v),m=this.r(),o=new w.$FK(this.k,v),i=!o.hasSiblingExcludeClauses();let n;try{this.h.add(k),n=p.$1d.create();const s=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},u,k.token),c=n.elapsed(),t=p.$1d.create();return this.g&&!this.e||(s&&s.forEach(f=>{const h=l.$gc.relative(v.folder.path,f.path);if(i){const r=l.$nc(f.path);this.v(S,{base:v.folder,relativePath:h,basename:r});return}this.s(m,v.folder,h,S)}),this.g&&!this.e)?null:(this.u(m,o,S),{providerTime:c,postProcessTime:t.elapsed()})}finally{k.dispose(),this.h.delete(k)}}q(v){const S=(0,w.$EK)(this.k.includePattern,v.includePattern),k=(0,w.$EK)(this.k.excludePattern,v.excludePattern);return{folder:v.folder,excludes:k,includes:S,useIgnoreFiles:!v.disregardIgnoreFiles,useGlobalIgnoreFiles:!v.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!v.disregardParentIgnoreFiles,followSymlinks:!v.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const v={rootEntries:[],pathToEntries:Object.create(null)};return v.pathToEntries["."]=v.rootEntries,v}s({pathToEntries:v},S,k,u){if(k===this.a){const o=l.$nc(this.a);this.v(u,{base:S,relativePath:this.a,basename:o})}function m(o){const i=l.$nc(o),n=l.$mc(o);let s=v[n];s||(s=v[n]=[],m(n)),s.push({base:S,relativePath:o,basename:i})}m(k)}u({rootEntries:v,pathToEntries:S},k,u){const m=this,o=this.a;function i(n){const s=(0,w.$HK)(()=>n.map(c=>c.basename));for(let c=0,t=n.length;c<t;c++){const f=n[c],{relativePath:h,basename:r}=f;if(k.matchesExcludesSync(h,r,o!==r?s:void 0))continue;const a=S[h];if(a)i(a);else{if(h===o)continue;m.v(u,f)}if(m.e)break}}i(v)}v(v,S){(!this.b||S.relativePath&&this.b(S.relativePath,S.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||v(S))}}class M{constructor(){this.b=new Map}static{this.a=512}fileSearch(v,S,k,u){const m=this.c(v.cacheKey),o=new E(v,S,m&&m.token);let i=0;const n=s=>{i+=s.length,k(s.map(c=>this.d(c)))};return this.e(o,M.a,n,u).then(s=>({limitHit:s.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:i,detailStats:s.stats}}))}clearCache(v){this.c(v)?.cancel()}c(v){if(v)return this.b.has(v)||this.b.set(v,new j.$ce),this.b.get(v)}d(v){return v.relativePath?{resource:R.$Sg(v.base,v.relativePath)}:{resource:v.base}}e(v,S,k,u){const m=u.onCancellationRequested(()=>{v.cancel()}),o=n=>{n&&(i.push(n),S>0&&i.length>=S&&(k(i),i=[]))};let i=[];return v.search(o).then(n=>(i.length&&k(i),m.dispose(),n),n=>(i.length&&k(i),m.dispose(),Promise.reject(n)))}}e.$ajc=M}),define(Se[367],De([1,0,19,72,35,103,28,15,17,23,14,18,2,100,241,52,12,40,146,362,36]),function(fe,e,l,j,L,A,R,p,w,E,M,C,v,S,k,u,m,o,i,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KL=e.$JL=void 0;let c=class{constructor(g,y,P,N,U){this.a=g,this.b=y,this.c=P,this.d=N,this.e=U}text(g,y,P={}){g=this.f(g,P);const N=this.a.getValue(),U=y&&y.some(F=>!this.a.getValue({resource:F}).search.useRipgrep);return{...this.h(y?.map(o.$Ai),P),type:2,contentPattern:g,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:N.search.usePCRE2||U||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}f(g,y){const P=this.a.getValue();g.isRegExp&&(g.pattern=g.pattern.replace(/\r?\n/g,"\\n"));const N={...g,wordSeparators:P.editor.wordSeparators};return this.j(g,y)&&(N.isCaseSensitive=!0),this.k(g)&&(N.isMultiline=!0),y.notebookSearchConfig?.includeMarkupInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownInput=y.notebookSearchConfig.includeMarkupInput),y.notebookSearchConfig?.includeMarkupPreview&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownPreview=y.notebookSearchConfig.includeMarkupPreview),y.notebookSearchConfig?.includeCodeInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellInput=y.notebookSearchConfig.includeCodeInput),y.notebookSearchConfig?.includeOutput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellOutput=y.notebookSearchConfig.includeOutput),N}file(g,y={}){return{...this.h(g,y),type:1,filePattern:y.filePattern?y.filePattern.trim():y.filePattern,exists:y.exists,sortByScore:y.sortByScore,cacheKey:y.cacheKey,shouldGlobMatchFilePattern:y.shouldGlobSearch}}g(g,y){return g?(g=Array.isArray(g)?g.map(a):a(g),y?this.parseSearchPaths(g):{pattern:f(...Array.isArray(g)?g:[g])}):{}}h(g=[],y={}){const P=this.g(y.includePattern,y.expandPatterns),N=this.g(y.excludePattern,y.expandPatterns),U=g.length>1,z=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(O=>this.q(O,y,N)):g.map(O=>this.r(O,y,N,U))).filter(O=>!!O),F={_reason:y._reason,folderQueries:z,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:y.extraFileResources,excludePattern:N.pattern,includePattern:P.pattern,onlyOpenEditors:y.onlyOpenEditors,maxResults:y.maxResults};if(y.onlyOpenEditors){const O=l.$Hb(l.$Rb(this.c.groups.map(te=>te.editors.map(x=>x.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(O));const T=O.filter(te=>(0,s.$vK)(F,te.fsPath)),G=this.i(T);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(G)),{...F,...G}}const I=y.extraFileResources&&y.extraFileResources.filter(O=>(0,s.$vK)(F,O.fsPath));return F.extraFileResources=I&&I.length?I:void 0,F}i(g){const y=[],P=new R.$Ac,N={};let U=!1;return g.forEach(z=>{if(z.scheme===p.Schemas.walkThrough)return;if((0,E.$Wg)(z)){const I=this.b.getWorkspaceFolder(z)?.uri??z.with({path:w.$mc(z.fsPath)});let O=P.get(I);O||(U=!0,O={folder:I,includePattern:{}},y.push(O),P.set(I,O));const T=w.$lc(I.fsPath,z.fsPath);(0,C.$4f)(O.includePattern)[T.replace(/\\/g,"/")]=!0}else z.fsPath&&(U=!0,N[z.fsPath]=!0)}),{folderQueries:y,includePattern:N,usingSearchPaths:!0,excludePattern:U?void 0:{"**/*":!0}}}j(g,y){if(y.isSmartCase){if(g.isRegExp){if(M.$Jf(g.pattern,!0))return!0}else if(M.$Jf(g.pattern))return!0}return!!g.isCaseSensitive}k(g){return g.isMultiline||g.isRegExp&&(0,S.$gC)(g.pattern)||g.pattern.indexOf(`
`)>=0?!0:!!g.isMultiline}parseSearchPaths(g){const y=G=>w.$ic(G)||/^\.\.?([\/\\]|$)/.test(G),N=(Array.isArray(g)?g:h(g)).map(G=>{const te=this.e.resolvedUserHome;return te?(0,A.$bw)(G,te.scheme===p.Schemas.file?te.fsPath:te.path):G}),U=j.$K(N,G=>y(G)?"searchPaths":"exprSegments"),z=(U.exprSegments||[]).map(G=>M.$4e(G,"/")).map(G=>M.$4e(G,"\\")).map(G=>(G[0]==="."&&(G="*"+G),r(G))),F={},I=this.m(U.searchPaths||[]);I&&I.length&&(F.searchPaths=I);const O=l.$Rb(z),T=f(...O);return T&&(F.pattern=T),F}l(g,y){return y.disregardExcludeSettings?void 0:(0,s.$uK)(g,!y.disregardSearchExcludeSettings)}m(g){if(!g||!g.length)return[];const y=g.flatMap(N=>{let{pathPortion:U,globPortion:z}=t(N);return z&&(z=d(z)),this.n(U).flatMap(I=>this.o(I,z))}),P=new Map;return y.forEach(N=>{const U=N.searchPath.toString(),z=P.get(U);z?N.pattern&&(z.pattern=z.pattern||{},z.pattern[N.pattern]=!0):P.set(U,{searchPath:N.searchPath,pattern:N.pattern?f(N.pattern):void 0})}),Array.from(P.values())}n(g){if(w.$ic(g)){const y=this.b.getWorkspace().folders;return y[0]&&y[0].uri.scheme!==p.Schemas.file?[{searchPath:y[0].uri.with({path:g})}]:[{searchPath:v.URI.file(w.$hc(g))}]}if(this.b.getWorkbenchState()===2){const y=this.b.getWorkspace().folders[0].uri;if(g=a(g),g.startsWith("../")||g===".."){const N=w.$gc.resolve(y.path,g);return[{searchPath:y.with({path:N})}]}const P=d(g);return[{searchPath:y,pattern:P}]}else{if(g==="./"||g===".\\")return[];{const y=g.replace(/^\.[\/\\]/,""),N=this.b.getWorkspace().folders.map(U=>{const z=y.match(new RegExp(`^${M.$Xe(U.name)}(?:/(.*)|$)`));return z?{match:z,folder:U}:null}).filter(C.$1f);if(N.length)return N.map(U=>{const z=U.match[1];return{searchPath:U.folder.uri,pattern:z&&d(z)}});{const U=g.match(/\.[\/\\](.+)[\/\\]?/),z=U?U[1]:g,F=k.localize(0,null,z);throw new Error(F)}}}}o(g,y){const P=g.pattern&&y?`${g.pattern}/${y}`:g.pattern||y,N=[{searchPath:g.searchPath,pattern:P}];return P&&!P.endsWith("**")&&N.push({searchPath:g.searchPath,pattern:P+"/**"}),N}q(g,y,P){const N=this.r((0,o.$Ai)(g.searchPath),y,P,!1);return N?{...N,includePattern:g.pattern}:null}r(g,y,P,N){let U;const z=v.URI.isUri(g)?g:g.uri;if(P.searchPaths){const G=P.searchPaths.filter(te=>(0,E.$Lg)(te.searchPath,z))[0];if(G&&!G.pattern)return null;G&&(U=G.pattern)}const F=this.a.getValue({resource:z}),O={...this.l(F,y)||{},...U||{}},T=v.URI.isUri(g)?(0,E.$Pg)(g):g.name;return{folder:z,folderName:N?T:void 0,excludePattern:Object.keys(O).length>0?O:void 0,fileEncoding:F.files&&F.files.encoding,disregardIgnoreFiles:typeof y.disregardIgnoreFiles=="boolean"?y.disregardIgnoreFiles:!F.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof y.disregardGlobalIgnoreFiles=="boolean"?y.disregardGlobalIgnoreFiles:!F.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof y.disregardParentIgnoreFiles=="boolean"?y.disregardParentIgnoreFiles:!F.search.useParentIgnoreFiles,ignoreSymlinks:typeof y.ignoreSymlinks=="boolean"?y.ignoreSymlinks:!F.search.followSymlinks}}};e.$JL=c,e.$JL=c=Ye([Ve(0,u.$Li),Ve(1,o.$oi),Ve(2,i.$nD),Ve(3,m.$zj),Ve(4,n.$HL)],c);function t(b){const g=b.match(/[\*\{\}\(\)\[\]\?]/);if(g){const y=g.index,P=b.substr(0,y).match(/[/|\\][^/\\]*$/);if(P){let N=b.substr(0,P.index);return N.match(/[/\\]/)||(N+="/"),{pathPortion:N,globPortion:b.substr((P.index||0)+1)}}}return{pathPortion:b}}function f(...b){return b.length?b.reduce((g,y)=>(g[y]=!0,g),Object.create(null)):void 0}function h(b){return L.$Wj(b,",").map(g=>g.trim()).filter(g=>!!g.length)}function r(b){return[`**/${b}/**`,`**/${b}`].map(y=>y.replace(/\*\*\/\*\*/g,"**"))}function a(b){return b.replace(/\\/g,"/")}function d(b){return a(b).replace(/^\.\//,"").replace(/\/+$/g,"")}function $(b){return b.replace(/([?*[\]])/g,"[$1]")}function D(b,g){b=l.$Mb(b,N=>N.toString());const y=[],P=g.getWorkspace();return b&&b.forEach(N=>{let U;if(g.getWorkbenchState()===2)U=(0,E.$Ug)(P.folders[0].uri,N),U&&U!=="."&&(U="./"+U);else{const z=g.getWorkspaceFolder(N);if(z){const F=z.name;if(P.folders.filter(O=>O.name===F).length===1){const O=(0,E.$Ug)(z.uri,N);O===""?U=`./${z.name}`:U=`./${z.name}/${O}`}else U=N.fsPath}}U&&y.push($(U))}),y}e.$KL=D}),define(Se[368],De([1,0,23,2,22,13,5,367,36,40,8]),function(fe,e,l,j,L,A,R,p,w,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wub=e.$vub=void 0;const C=7e3;function v(m,o){const i=o.activationEvents;if(!i)return Promise.resolve(void 0);const n=[],s=[];for(const a of i)if(/^workspaceContains:/.test(a)){const d=a.substr(18);d.indexOf("*")>=0||d.indexOf("?")>=0||m.forceUsingSearch?s.push(d):n.push(d)}if(n.length===0&&s.length===0)return Promise.resolve(void 0);const{promise:c,resolve:t}=(0,M.$$g)(),f=a=>t({activationEvent:a}),h=Promise.all(n.map(a=>S(m,a,f))).then(()=>{}),r=k(m,o.identifier,s,f);return Promise.all([h,r]).then(()=>{t(void 0)}),c}e.$vub=v;async function S(m,o,i){for(const n of m.folders)if(await m.exists(l.$Sg(j.URI.revive(n),o))){i(`workspaceContains:${o}`);return}}async function k(m,o,i,n){if(i.length===0)return Promise.resolve(void 0);const s=new L.$ce,c=m.checkExists(m.folders,i,s.token),t=setTimeout(async()=>{s.cancel(),m.logService.info(`Not activating extension '${o.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},C);let f=!1;try{f=await c}catch(h){A.$4(h)||A.$1(h)}s.dispose(),clearTimeout(t),f&&n(`workspaceContains:${i.join(",")}`)}function u(m,o,i,n){const s=m.get(R.$ei),c=m.get(w.$mK),f=s.createInstance(p.$JL).file(o.map(h=>(0,E.$Ai)(j.URI.revive(h))),{_reason:"checkExists",includePattern:i,exists:!0});return c.fileSearch(f,n).then(h=>!!h.limitHit,h=>A.$4(h)?!1:Promise.reject(h))}e.$wub=u}),define(Se[47],De([1,0,217,17,58,23,8,3,76,2,12,6,42,298,118,41,26,148,13,25,21,277,7,64,5,27,93,20,107,69,46,121,4,368,117,279,15,115,38,11,116]),function(fe,e,l,j,L,A,R,p,w,E,M,C,v,S,k,u,m,o,i,n,s,c,t,f,h,r,a,d,$,D,b,g,y,P,N,U,z,F,I,O,T){"use strict";var G;Object.defineProperty(e,"__esModule",{value:!0}),e.$Sic=e.$Ric=e.$Qic=e.$Pic=e.$Oic=void 0,e.$Oic=(0,h.$fi)("IHostUtils");let te=G=class extends p.$Tc{constructor(B,ie,ye,le,ue,ce,de,H,Z,he,be,Pe,pe){super(),this.X=Pe,this.Y=pe,this.a=this.B(new y.$5d),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=ie,this.g=ye,this.f=de,this.j=le,this.m=ue,this.s=ce,this.t=Z,this.u=he,this.w=be,this.y=this.g.getProxy(C.$6L.MainThreadWorkspace),this.z=this.g.getProxy(C.$6L.MainThreadTelemetry),this.C=this.g.getProxy(C.$6L.MainThreadExtensionService),this.D=new R.$eh,this.F=new R.$eh,this.G=new R.$eh,this.H=new R.$eh,this.I=new se(this.f.extensions.activationEvents),this.L=new o.$O9b(this.I,this.f.extensions.allExtensions);const Ae=new n.$Am(this.f.extensions.myExtensions);this.J=new o.$O9b(this.I,_(this.L,Ae)),O.$t&&(this.s.info(`Creating extension host with the following global extensions: ${Q(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Q(this.J)}`)),this.M=new k.$zic(this.g,this.s),this.N=new N.$Hic(this.g),this.O=H,this.h=B.createChild(new $.$di([k.$Aic,this.M],[N.$Iic,this.N])),this.P=this.B(new S.$yic(this.J,this.L,{onExtensionActivationError:(Oe,ze,q)=>{this.C.$onExtensionActivationError(Oe,i.$3(ze),q)},actualActivateExtension:async(Oe,ze)=>{if(o.$O9b.isHostExtension(Oe,this.J,this.L))return await this.C.$activateExtension(Oe,ze),new S.$xic;const q=this.J.getExtensionDescription(Oe);return this.eb(q,ze)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.ub(),this.D.open(),await this.j.waitForInitializeCall(),L.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.sb()}catch(B){i.$1(B)}}async Z(){this.O.onWillDeactivateAll();let B=[];try{B=this.J.getAllExtensionDescriptions().map(ue=>ue.identifier).filter(ue=>this.isActivated(ue)).map(ue=>this.db(ue))}catch{}await Promise.all(B)}terminate(B,ie=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${B}`),this.s.flush(),this.u.dispose(),this.P.dispose(),i.setUnexpectedErrorHandler(le=>{this.s.error(le)}),this.g.dispose();const ye=this.Z();Promise.race([(0,R.$gh)(5e3),ye]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${ie}`):this.s.info(`Extension host exiting with code ${ie}`),this.s.flush(),this.s.dispose(),this.c.exit(ie)})}isActivated(B){return this.G.isOpen()?this.P.isActivated(B):!1}async getExtension(B){const ie=await this.C.$getExtension(B);return ie&&{...ie,identifier:new n.$zm(ie.identifier.value),extensionLocation:E.URI.revive(ie.extensionLocation)}}$(B,ie){return this.P.activateByEvent(B,ie)}ab(B,ie){return this.P.activateById(B,ie)}activateByIdWithErrors(B,ie){return this.ab(B,ie).then(()=>{const ye=this.P.getActivatedExtension(B);if(ye.activationFailed)return Promise.reject(ye.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(B=>this.J)}getExtensionExports(B){if(this.G.isOpen())return this.P.getActivatedExtension(B).exports;try{return this.P.getActivatedExtension(B).exports}catch{return null}}async bb(B){if(B.scheme===z.Schemas.file&&this.c.fsRealpath){const ie=await this.c.fsRealpath(B.fsPath);return E.URI.file(ie)}return B}async getExtensionPathIndex(){return this.Q||(this.Q=this.cb(this.J.getAllExtensionDescriptions()).then(B=>new ge(B))),this.Q}async cb(B){const ie=w.$li.forUris(ye=>A.$Jg.ignorePathCasing(ye));return await Promise.all(B.map(async ye=>{if(this.vb(ye)){const le=await this.bb(ye.extensionLocation);ie.set(le,ye)}})),ie}db(B){let ie=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(B))return ie;const ye=this.P.getActivatedExtension(B);if(!ye)return ie;try{typeof ye.module.deactivate=="function"&&(ie=Promise.resolve(ye.module.deactivate()).then(void 0,le=>(this.s.error(le),Promise.resolve(void 0))))}catch(le){this.s.error(`An error occurred when deactivating the extension '${B.value}':`),this.s.error(le)}try{(0,p.$Oc)(ye.subscriptions)}catch(le){this.s.error(`An error occurred when deactivating the subscriptions for extension '${B.value}':`),this.s.error(le)}return ie}async eb(B,ie){return this.f.remote.isRemote?this.C.$onWillActivateExtension(B.identifier):await this.C.$onWillActivateExtension(B.identifier),this.gb(B,ie).then(ye=>{const le=ye.activationTimes;return this.C.$onDidActivateExtension(B.identifier,le.codeLoadingTime,le.activateCallTime,le.activateResolvedTime,ie),this.fb(B,ie,"success",le),ye},ye=>{throw this.fb(B,ie,"failure"),ye})}fb(B,ie,ye,le){const ue=X(B,ie);this.z.$publicLog2("extensionActivationTimes",{...ue,...le||{},outcome:ye})}gb(B,ie){const ye=X(B,ie);this.z.$publicLog2("activatePlugin",ye);const le=this.vb(B);if(!le)return Promise.resolve(new S.$wic(S.$tic.NONE));this.s.info(`ExtensionService#_doActivateExtension ${B.identifier.value}, startup: ${ie.startup}, activationEvent: '${ie.activationEvent}'${B.identifier.value!==ie.extensionId.value?`, root cause: ${ie.extensionId.value}`:""}`),this.s.flush();const ue=new S.$uic(ie.startup);return Promise.all([this.wb(B,(0,A.$Sg)(B.extensionLocation,le),ue),this.hb(B)]).then(ce=>(L.mark(`code/extHost/willActivateExtension/${B.identifier.value}`),G.ib(this.s,B.identifier,ce[0],ce[1],ue))).then(ce=>(L.mark(`code/extHost/didActivateExtension/${B.identifier.value}`),ce))}hb(B){const ie=this.Y.createLanguageModelAccessInformation(B),ye=new c.$Cic(B,this.M),le=new c.$Bic(B.identifier.value,!1,this.M),ue=new U.$Jic(B,this.N),ce=B.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,de=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${B.identifier.value}`),Promise.all([ye.whenReady,le.whenReady,this.O.whenReady]).then(()=>{const H=this;let Z,he;const be=(0,m.$XF)(B,"ipc")?this.f.messagePorts?.get(n.$zm.toKey(B.identifier)):void 0;return Object.freeze({globalState:ye,workspaceState:le,secrets:ue,subscriptions:[],get languageModelAccessInformation(){return ie},get extensionUri(){return B.extensionLocation},get extensionPath(){return B.extensionLocation.fsPath},asAbsolutePath(Pe){return j.$jc(B.extensionLocation.fsPath,Pe)},get storagePath(){return H.O.workspaceValue(B)?.fsPath},get globalStoragePath(){return H.O.globalValue(B).fsPath},get logPath(){return j.$jc(H.f.logsLocation.fsPath,B.identifier.value)},get logUri(){return E.URI.joinPath(H.f.logsLocation,B.identifier.value)},get storageUri(){return H.O.workspaceValue(B)},get globalStorageUri(){return H.O.globalValue(B)},get extensionMode(){return ce},get extension(){return Z===void 0&&(Z=new ae(H,B.identifier,B,de,!1)),Z},get extensionRuntime(){return(0,m.$YF)(B,"extensionRuntime"),H.extensionRuntime},get environmentVariableCollection(){return H.u.getEnvironmentVariableCollection(B)},get messagePassingProtocol(){if(!he){if(!be)return;const Pe=y.Event.buffer(y.Event.fromDOMEventEmitter(be,"message",pe=>pe.data));be.start(),he={onDidReceiveMessage:Pe,postMessage:be.postMessage.bind(be)}}return he}})})}static ib(B,ie,ye,le,ue){return ye=ye||{activate:void 0,deactivate:void 0},this.jb(B,ie,ye,le,ue).then(ce=>new S.$vic(!1,null,ue.build(),ye,ce,le.subscriptions))}static jb(B,ie,ye,le,ue){if(typeof ye.activate=="function")try{ue.activateCallStart(),B.trace(`ExtensionService#_callActivateOptional ${ie.value}`);const ce=typeof global=="object"?global:self,de=ye.activate.apply(ce,[le]);return ue.activateCallStop(),ue.activateResolveStart(),Promise.resolve(de).then(H=>(ue.activateResolveStop(),H))}catch(ce){return Promise.reject(ce)}else return Promise.resolve(ye)}kb(B,ie){this.ab(B.identifier,{startup:!1,extensionId:B.identifier,activationEvent:ie}).then(void 0,ye=>{this.s.error(ye)})}lb(B,ie=0){const le=Date.now();(0,O.$B)(()=>{for(let ue=ie;ue<B.length;ue+=1){const ce=B[ue];for(const de of ce.activationEvents??[])if(de==="onStartupFinished")if(Date.now()-le>50){this.lb(B,ue);break}else this.kb(ce,de)}})}mb(){this.C.$setPerformanceMarks(L.getMarks()),this.m.getConfigProvider().then(B=>{const ie=B.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ye=this.J.getAllExtensionDescriptions();if(ie)this.lb(ye);else for(const le of ye)if(le.activationEvents)for(const ue of le.activationEvents)ue==="onStartupFinished"&&this.kb(le,ue)})}nb(){const B=this.$("*",!0).then(void 0,ce=>{this.s.error(ce)});this.B(this.j.onDidChangeWorkspace(ce=>this.ob(ce.added)));const ie=this.j.workspace?this.j.workspace.folders:[],ye=this.ob(ie),le=this.qb(),ue=Promise.all([le,B,ye]).then(()=>{});return Promise.race([ue,(0,R.$gh)(1e4)]).then(()=>{this.mb()}),ue}ob(B){return B.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(ie=>this.pb(B,ie))).then(()=>{})}async pb(B,ie){if(this.isActivated(ie.identifier))return;const ye=!this.f.remote.isRemote&&!!this.f.remote.authority,le={logService:this.s,folders:B.map(ce=>ce.uri),forceUsingSearch:ye||!this.c.fsExists,exists:ce=>this.c.fsExists(ce.fsPath),checkExists:(ce,de,H)=>this.y.$checkExists(ce,de,H)},ue=await(0,P.$vub)(le,ie);if(ue)return this.ab(ie.identifier,{startup:!0,extensionId:ie.identifier,activationEvent:ue.activationEvent}).then(void 0,ce=>this.s.error(ce))}async qb(){if(this.f.remote.authority)return this.$(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.rb()}catch(B){throw console.error(B),B}}async rb(){const{extensionDevelopmentLocationURI:B,extensionTestsLocationURI:ie}=this.f.environment;if(!B||!ie)throw new Error(l.localize(0,null));const ye=await this.wb(null,ie,new S.$uic(!1));if(!ye||typeof ye.run!="function")throw new Error(l.localize(1,null,ie.toString()));return new Promise((le,ue)=>{const ce=(Z,he)=>{Z?(O.$t&&this.s.error("Test runner called back with error",Z),ue(Z)):(O.$t&&(he?this.s.info(`Test runner called back with ${he} failures.`):this.s.info("Test runner called back with successful outcome.")),le(typeof he=="number"&&he>0?1:0))},de=(0,A.$Gg)(ie),H=ye.run(de,ce);H&&H.then&&H.then(()=>{O.$t&&this.s.info("Test runner finished successfully."),le(0)}).catch(Z=>{O.$t&&this.s.error("Test runner finished with error",Z),ue(Z instanceof Error&&Z.stack?Z.stack:String(Z))})})}sb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$gh)(1e3)])).then(()=>this.nb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(B,ie){return this.R[B]=ie,(0,p.$Rc)(()=>{delete this.R[B]})}async getRemoteExecServer(B){const{resolver:ie}=await this.tb(B);return ie?.resolveExecServer?.(B,{resolveAttempt:0})}async tb(B){const ie=B.indexOf("+");if(ie===-1)throw new t.$bM("Not an authority that can be resolved!",f.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ye=B.substr(0,ie);return await this.D.wait(),await this.$(`onResolveRemoteAuthority:${ye}`,!1),{authorityPrefix:ye,resolver:this.R[ye]}}async $resolveAuthority(B,ie){const ye=I.$1d.create(!1),le=()=>`[resolveAuthority(${(0,f.$ol)(B)},${ie})][${ye.elapsed()}ms] `,ue=W=>this.s.info(`${le()}${W}`),ce=W=>this.s.warn(`${le()}${W}`),de=(W,Y=void 0)=>this.s.error(`${le()}${W}`,Y),H=W=>{if(W instanceof t.$bM)return{type:"error",error:{code:W._code,message:W._message,detail:W._detail}};throw W},Z=async W=>{ue(`activating resolver for ${W}...`);const{resolver:Y,authorityPrefix:J}=await this.tb(W);if(!Y)throw de(`no resolver for ${J}`),new t.$bM(`No remote extension installed to resolve ${J}.`,f.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:Y,authorityPrefix:J,remoteAuthority:W}},he=B.split(/@|%40/g).reverse();ue(`activating remote resolvers ${he.join(" -> ")}`);let be;try{be=await Promise.all(he.map(Z)).catch(async W=>{if(!(W instanceof t.$bM)||W._code!==f.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw W;return ce(`resolving nested authorities failed: ${W.message}`),[await Z(B)]})}catch(W){return H(W)}const Pe=new R.$qh;Pe.cancelAndSet(()=>ue("waiting..."),1e3);let pe,Ae;for(const[W,{authorityPrefix:Y,resolver:J,remoteAuthority:$e}]of be.entries())try{if(W===be.length-1)ue("invoking final resolve()..."),L.mark(`code/extHost/willResolveAuthority/${Y}`),pe=await J.resolve($e,{resolveAttempt:ie,execServer:Ae}),L.mark(`code/extHost/didResolveAuthorityOK/${Y}`),ue("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(J,t.$aM.isManagedResolvedAuthority(pe)?pe:void 0));else{if(ue(`invoking resolveExecServer() for ${$e}`),L.mark(`code/extHost/willResolveExecServer/${Y}`),Ae=await J.resolveExecServer?.($e,{resolveAttempt:ie,execServer:Ae}),!Ae)throw new t.$bM(`Exec server was not available for ${$e}`,f.RemoteAuthorityResolverErrorCode.NoResolverFound);L.mark(`code/extHost/didResolveExecServerOK/${Y}`)}}catch(ve){return L.mark(`code/extHost/didResolveAuthorityError/${Y}`),de("returned an error",ve),Pe.dispose(),H(ve)}Pe.dispose();const Oe={environmentTunnels:pe.environmentTunnels,features:pe.tunnelFeatures?{elevation:pe.tunnelFeatures.elevation,privacyOptions:pe.tunnelFeatures.privacyOptions,protocol:pe.tunnelFeatures.protocol===void 0?!0:pe.tunnelFeatures.protocol}:void 0},ze={extensionHostEnv:pe.extensionHostEnv,isTrusted:pe.isTrusted,authenticationSession:pe.authenticationSessionForInitializingExtensions?{id:pe.authenticationSessionForInitializingExtensions.id,providerId:pe.authenticationSessionForInitializingExtensions.providerId}:void 0};ue(`returned ${t.$aM.isManagedResolvedAuthority(pe)?"managed authority":`${pe.host}:${pe.port}`}`);let q;if(t.$aM.isManagedResolvedAuthority(pe)){const W=ie;this.X.setFactory(W,pe.makeConnection),q={authority:B,connectTo:new f.$ll(W),connectionToken:pe.connectionToken}}else q={authority:B,connectTo:new f.$ml(pe.host,pe.port),connectionToken:pe.connectionToken};return{type:"ok",value:{authority:q,options:ze,tunnelInformation:Oe}}}async $getCanonicalURI(B,ie){this.s.info(`$getCanonicalURI invoked for authority (${(0,f.$ol)(B)})`);const{resolver:ye}=await this.tb(B);if(!ye)return null;const le=E.URI.revive(ie);if(typeof ye.getCanonicalURI>"u")return le;const ue=await(0,R.$0g)(()=>ye.getCanonicalURI(le));return ue||le}$startExtensionHost(B){B.toAdd.forEach(le=>le.extensionLocation=E.URI.revive(le.extensionLocation));const{globalRegistry:ie,myExtensions:ye}=x(this.I,this.L,this.J,B);return this.L.set(ie.getAllExtensionDescriptions()),this.J.set(ye),O.$t&&(this.s.info(`$startExtensionHost: global extensions: ${Q(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Q(this.J)}`)),this.sb()}$activateByEvent(B,ie){return ie===1?this.D.wait().then(ye=>this.$(B,!1)):this.G.wait().then(ye=>this.$(B,!1))}async $activate(B,ie){return await this.G.wait(),this.J.getExtensionDescription(B)?(await this.ab(B,ie),!0):!1}async $deltaExtensions(B){B.toAdd.forEach(ce=>ce.extensionLocation=E.URI.revive(ce.extensionLocation));const{globalRegistry:ie,myExtensions:ye}=x(this.I,this.L,this.J,B),le=await this.cb(ye);return(await this.getExtensionPathIndex()).setSearchTree(le),this.L.set(ie.getAllExtensionDescriptions()),this.J.set(ye),O.$t&&(this.s.info(`$deltaExtensions: global extensions: ${Q(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Q(this.J)}`)),Promise.resolve(void 0)}async $test_latency(B){return B}async $test_up(B){return B.byteLength}async $test_down(B){const ie=s.$se.alloc(B),ye=Math.random()%256;for(let le=0;le<B;le++)ie.writeUInt8(ye,le);return ie}async $updateRemoteConnectionData(B){this.W=B,this.a.fire()}};e.$Pic=te,e.$Pic=te=G=Ye([Ve(0,h.$ei),Ve(1,e.$Oic),Ve(2,d.$lO),Ve(3,u.$cic),Ve(4,v.$fic),Ve(5,M.$zj),Ve(6,r.$BO),Ve(7,a.$iic),Ve(8,D.$zAb),Ve(9,b.$Dic),Ve(10,F.$Lic),Ve(11,T.$Mic),Ve(12,g.$5hc)],te);function x(re,B,ie,ye){re.addActivationEvents(ye.addActivationEvents);const le=new o.$O9b(re,B.getAllExtensionDescriptions());le.deltaExtensions(ye.toAdd,ye.toRemove);const ue=new n.$Am(ie.getAllExtensionDescriptions().map(de=>de.identifier));for(const de of ye.myToRemove)ue.delete(de);for(const de of ye.myToAdd)ue.add(de);const ce=_(le,ue);return{globalRegistry:le,myExtensions:ce}}function X(re,B){return{id:re.identifier.value,name:re.name,extensionVersion:re.version,publisherDisplayName:re.publisher,activationEvents:re.activationEvents?re.activationEvents.join(","):null,isBuiltin:re.isBuiltin,reason:B.activationEvent,reasonId:B.extensionId.value}}function Q(re){return re.getAllExtensionDescriptions().map(B=>B.identifier.value).join(",")}e.$Qic=(0,h.$fi)("IExtHostExtensionService");class ae{#e;#t;#i;constructor(B,ie,ye,le,ue){this.#e=B,this.#t=ie,this.#i=ye.identifier,this.id=ye.identifier.value,this.extensionUri=ye.extensionLocation,this.extensionPath=j.$hc((0,A.$Gg)(ye.extensionLocation)),this.packageJSON=ye,this.extensionKind=le,this.isFromDifferentExtensionHost=ue}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Ric=ae;function _(re,B){return re.getAllExtensionDescriptions().filter(ie=>B.has(ie.identifier))}class ge{constructor(B){this.a=B}setSearchTree(B){this.a=B}findSubstr(B){return this.a.findSubstr(B)}forEach(B){return this.a.forEach(B)}}e.$Sic=ge;class se{constructor(B){this.a=new n.$Bm,this.addActivationEvents(B)}readActivationEvents(B){return this.a.get(B.identifier)??[]}addActivationEvents(B){for(const ie of Object.keys(B))this.a.set(ie,B[ie])}}}),define(Se[369],De([1,0,58,2,6,42,26,25,20,27,5,47,12,14]),function(fe,e,l,j,L,A,R,p,w,E,M,C,v,S){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$1jc=void 0;let u=class{constructor(s,c,t,f,h,r,a){this.c=s,this.d=c,this.e=t,this.f=f,this.g=h,this.h=r,this.i=a,this.a=new Map,this.b=[]}async install(){this.j(),l.mark("code/extHost/willWaitForConfig");const s=await this.f.getConfigProvider();l.mark("code/extHost/didWaitForConfig");const c=await this.g.getExtensionPathIndex();this.register(new o(this.c,c,this.d,s,this.i)),this.register(this.e.createInstance(m)),this.h.remote.isRemote&&this.register(this.e.createInstance(i,c,this.h.environment.appUriScheme))}register(s){if("nodeModuleName"in s)if(Array.isArray(s.nodeModuleName))for(const c of s.nodeModuleName)this.a.set(c,s);else this.a.set(s.nodeModuleName,s);typeof s.alternativeModuleName=="function"&&this.b.push(c=>s.alternativeModuleName(c))}};e.$1jc=u,e.$1jc=u=Ye([Ve(2,M.$ei),Ve(3,A.$fic),Ve(4,C.$Qic),Ve(5,E.$BO),Ve(6,v.$zj)],u);let m=class{static{k=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(s){if(s.environment.appRoot&&k.a.size){const c=(0,S.$Xe)(this.c(s.environment.appRoot.fsPath)),t="[a-z0-9_.-]",f=`@${t}+\\/${t}+|${t}+`,h="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${c}/${h}\\/)(${f})(.*)$`,"i")}}alternativeModuleName(s){if(!this.b)return;const c=this.b.exec(this.c(s));if(!c)return;const[,t,f,h]=c,r=k.a.get(f);if(r!==void 0)return console.warn(`${f} as been renamed to ${r}, please update your imports`),t+r+h}c(s){return s.replace(/\\/g,"/")}};m=k=Ye([Ve(0,E.$BO)],m);class o{constructor(s,c,t,f,h){this.c=s,this.d=c,this.e=t,this.f=f,this.g=h,this.nodeModuleName="vscode",this.a=new p.$Bm}load(s,c){const t=this.d.findSubstr(c);if(t){let f=this.a.get(t.identifier);return f||(f=this.c(t,this.e,this.f),this.a.set(t.identifier,f)),f}if(!this.b){let f="";this.d.forEach((h,r)=>f+=`	${r} -> ${h.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${c}. These are the extension path mappings: 
${f}`),this.b=this.c(R.$SF,this.e,this.f)}return this.b}}let i=class{constructor(s,c,t){this.e=s,this.f=c,this.nodeModuleName=["open","opn"],this.d=t.getProxy(L.$6L.MainThreadTelemetry);const f=t.getProxy(L.$6L.MainThreadWindow);this.c=(h,r)=>{const a=j.URI.parse(h);return r?this.g(h,r):a.scheme==="http"||a.scheme==="https"?f.$openUri(a,h,{allowTunneling:!0}):a.scheme==="mailto"||a.scheme===this.f?f.$openUri(a,h,{}):this.g(h,r)}}load(s,c,t){const f=this.e.findSubstr(c);return f&&(this.a=f.identifier.value,this.h()),this.b=t(s),this.c}g(s,c){return this.i(),this.b(s,c)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};i=Ye([Ve(2,w.$lO)],i)}),define(Se[60],De([1,0,43,3,17,50,5,71,70,47,7,41,295,42]),function(fe,e,l,j,L,A,R,p,w,E,M,C,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uic=e.$Tic=void 0,e.$Tic=(0,R.$fi)("IExtHostVariableResolverProvider");class k extends v.$mP{constructor(o,i,n,s,c,t,f){function h(){if(n){const r=n.activeEditor();if(r)return r.document.uri;const a=s.tabGroups.all.find(d=>d.isActive)?.activeTab;if(a!==void 0){if(a.input instanceof M.$QN||a.input instanceof M.$VN)return a.input.modified;if(a.input instanceof M.$PN||a.input instanceof M.$UN||a.input instanceof M.$SN)return a.input.uri}}}super({getFolderUri:r=>{const a=t.folders.filter(d=>d.name===r);if(a&&a.length>0)return a[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(r,a)=>c.getConfiguration(void 0,r).get(a),getAppRoot:()=>A.cwd(),getExecPath:()=>A.env.VSCODE_EXEC_PATH,getFilePath:()=>{const r=h();if(r)return L.$hc(r.fsPath)},getWorkspaceFolderPathForFile:()=>{if(i){const r=h();if(r){const a=i.getWorkspaceFolder(r);if(a)return L.$hc(a.uri.fsPath)}}},getSelectedText:()=>{if(n){const r=n.activeEditor();if(r&&!r.selection.isEmpty)return r.document.getText(r.selection)}},getLineNumber:()=>{if(n){const r=n.activeEditor();if(r)return String(r.selection.end.line+1)}},getExtension:r=>o.getExtension(r)},void 0,f?Promise.resolve(f):void 0,Promise.resolve(A.env))}}let u=class extends j.$Tc{constructor(o,i,n,s,c){super(),this.b=o,this.c=i,this.g=n,this.h=s,this.j=c,this.a=new l.$V(async()=>{const t=await this.h.getConfigProvider(),h={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async r=>{h.folders=await this.c.getWorkspaceFolders2()||[]})),new k(this.b,this.c,this.g,this.j,t,h,this.m())})}getResolver(){return this.a.value}m(){}};e.$Uic=u,e.$Uic=u=Ye([Ve(0,E.$Qic),Ve(1,C.$cic),Ve(2,p.$wO),Ve(3,S.$fic),Ve(4,w.$ric)],u)}),define(Se[96],De([1,0,8,4,2,25,5,6,70,47,20,7,41,143,287,42,60,3,55,33,16]),function(fe,e,l,j,L,A,R,p,w,E,M,C,v,S,k,u,m,o,i,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zic=e.$Yic=e.$Xic=e.$Wic=e.$Vic=void 0,e.$Vic=(0,R.$fi)("IExtHostDebugService");let c=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor($,D,b,g,y,P,N){this.N=D,this.O=b,this.P=g,this.Q=y,this.R=P,this.S=N,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new j.$5d,this.o=new j.$5d,this.q=new j.$5d,this.w=new j.$5d,this.l=$.getProxy(p.$6L.MainThreadDebugService),this.A=new j.$5d,this.C=new j.$5d,this.y=new f(this.l),this.z=new Map,this.O.getExtensionRegistry().then(U=>{U.onDidChange(z=>{this.V(U)}),this.V(U)})}async $getVisualizerTreeItem($,D){const b=this.W(D);if(!b)return;const g=await this.H.get($)?.getTreeItem?.(b);return g?this.U($,g):void 0}registerDebugVisualizationTree($,D,b){const g=A.$zm.toKey($.identifier),y=this.jb(g,D);if(this.G.has(y))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this.H.set(y,b),this.l.$registerDebugVisualizerTree(y,!!b.editItem),(0,o.$Rc)(()=>{this.l.$unregisterDebugVisualizerTree(y),this.H.delete(D)})}async $getVisualizerTreeItemChildren($,D){const b=this.J.get(D)?.item;return b?(await this.H.get($)?.getChildren?.(b))?.map(y=>this.U($,y))||[]:[]}async $editVisualizerTreeItem($,D){const b=this.J.get($);if(!b)return;const g=await this.H.get(b.provider)?.editItem?.(b.item,D);return this.U(b.provider,g||b.item)}$disposeVisualizedTree($){const D=this.J.get($);if(!D)return;const b=[D.children];for(const g of b)if(g)for(const y of g)b.push(this.J.get(y)?.children),this.J.delete(y)}U($,D){let b=this.I.get(D);return b||(b=this.F++,this.I.set(D,b),this.J.set(b,{provider:$,item:D})),s.DebugTreeItem.from(D,b)}asDebugSourceUri($,D){const b=$;if(typeof b.sourceReference=="number"&&b.sourceReference>0){let g=`debug:${encodeURIComponent(b.path||"")}`,y="?";return D&&(g+=`${y}session=${encodeURIComponent(D.id)}`,y="&"),g+=`${y}ref=${b.sourceReference}`,L.URI.parse(g)}else{if(b.path)return L.URI.file(b.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V($){const D=[];for(const b of $.getAllExtensionDescriptions())if(b.contributes){const g=b.contributes.debuggers;if(g&&g.length>0)for(const y of g)(0,k.$wG)(y)&&D.push(y.type)}this.l.$registerDebugTypes(D)}get stackFrameFocus(){return this.B}get onDidChangeStackFrameFocus(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const $=[];return this.z.forEach(D=>$.push(D)),$}async $resolveDebugVisualizer($,D){const b=this.L.get($);if(!b)throw new Error(`No debug visualizer found with id '${$}'`);let{v:g,provider:y,extensionId:P}=b;if(g.visualization||(g=await y.resolveDebugVisualization?.(g,D)||g,b.v=g),!g.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${y}'`);return this.kb(P,g.visualization)}async $executeDebugVisualizerCommand($){const D=this.L.get($);if(!D)throw new Error(`No debug visualizer found with id '${$}'`);const b=D.v.visualization;b&&"command"in b&&this.S.executeCommand(b.command,...b.arguments||[])}W($){const D=this.m.get($.sessionId);return D&&{session:D.api,variable:$.variable,containerId:$.containerId,frameId:$.frameId,threadId:$.threadId}}async $provideDebugVisualizers($,D,b,g){const y=this.W(b),P=this.jb($,D),N=this.G.get(P);if(!y||!N)return[];const U=await N.provideDebugVisualization(y,g);return U?U.map(z=>{const F=++this.M;this.L.set(F,{v:z,provider:N,extensionId:$});const I=z.iconPath?this.lb(z.iconPath):void 0;return{id:F,name:z.name,iconClass:I?.iconClass,iconPath:I?.iconPath,visualization:this.kb($,z.visualization)}}):[]}$disposeDebugVisualizers($){for(const D of $)this.L.delete(D)}registerDebugVisualizationProvider($,D,b){if(!$.contributes?.debugVisualizers?.some(P=>P.id===D))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${D})`);const g=A.$zm.toKey($.identifier),y=this.jb(g,D);if(this.G.has(y))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this.G.set(y,b),this.l.$registerDebugVisualizer(g,D),(0,o.$Rc)(()=>{this.l.$unregisterDebugVisualizer(g,D),this.G.delete(D)})}addBreakpoints($){const D=$.filter(y=>{const P=y.id;return this.z.has(P)?!1:(this.z.set(P,y),!0)});this.gb(D,[],[]);const b=[],g=new Map;for(const y of D)if(y instanceof C.$8M){let P=g.get(y.location.uri.toString());P||(P={type:"sourceMulti",uri:y.location.uri,lines:[]},g.set(y.location.uri.toString(),P),b.push(P)),P.lines.push({id:y.id,enabled:y.enabled,condition:y.condition,hitCondition:y.hitCondition,logMessage:y.logMessage,line:y.location.range.start.line,character:y.location.range.start.character,mode:y.mode})}else y instanceof C.$9M&&b.push({type:"function",id:y.id,enabled:y.enabled,hitCondition:y.hitCondition,logMessage:y.logMessage,condition:y.condition,functionName:y.functionName,mode:y.mode});return this.l.$registerBreakpoints(b)}removeBreakpoints($){const D=$.filter(P=>this.z.delete(P.id));this.gb([],D,[]);const b=D.filter(P=>P instanceof C.$8M).map(P=>P.id),g=D.filter(P=>P instanceof C.$9M).map(P=>P.id),y=D.filter(P=>P instanceof C.$0M).map(P=>P.id);return this.l.$unregisterBreakpoints(b,g,y)}startDebugging($,D,b){return this.l.$startDebugging($?$.uri:void 0,D,{parentSessionID:b.parentSession?b.parentSession.id:void 0,lifecycleManagedByParent:b.lifecycleManagedByParent,repl:b.consoleMode===C.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:b.noDebug,compact:b.compact,suppressSaveBeforeStart:b.suppressSaveBeforeStart,suppressDebugStatusbar:b.suppressDebugStatusbar??b.debugUI?.simple,suppressDebugToolbar:b.suppressDebugToolbar??b.debugUI?.simple,suppressDebugView:b.suppressDebugView??b.debugUI?.simple})}stopDebugging($){return this.l.$stopDebugging($?$.id:void 0)}registerDebugConfigurationProvider($,D,b){if(!D)return new C.$8L(()=>{});const g=this.d++;return this.f.push({type:$,handle:g,provider:D}),this.l.$registerDebugConfigurationProvider($,b,!!D.provideDebugConfigurations,!!D.resolveDebugConfiguration,!!D.resolveDebugConfigurationWithSubstitutedVariables,g),new C.$8L(()=>{this.f=this.f.filter(y=>y.provider!==D),this.l.$unregisterDebugConfigurationProvider(g)})}registerDebugAdapterDescriptorFactory($,D,b){if(!b)return new C.$8L(()=>{});if(!this.cb($,D))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${D}' debugger.`);if(this.$(D))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const g=this.g++;return this.h.push({type:D,handle:g,factory:b}),this.l.$registerDebugAdapterDescriptorFactory(D,g),new C.$8L(()=>{this.h=this.h.filter(y=>y.factory!==b),this.l.$unregisterDebugAdapterDescriptorFactory(g)})}registerDebugAdapterTrackerFactory($,D){if(!D)return new C.$8L(()=>{});const b=this.j++;return this.k.push({type:$,handle:b,factory:D}),new C.$8L(()=>{this.k=this.k.filter(g=>g.factory!==D)})}async $runInTerminal($,D){return Promise.resolve(void 0)}async $substituteVariables($,D){let b;const g=await this.ib($);return g&&(b={uri:g.uri,name:g.name,index:g.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(b,D)}X($,D){if($.type==="implementation")return new r($.implementation)}Y(){}async $startDASession($,D){const b=this,g=await this.hb(D);return this.eb(this.$(g.type),g).then(y=>{if(!y)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}' (extension might have failed to activate)`);const P=this.Z(y),N=this.X(P,g);if(!N)throw new Error(`Couldn't create a debug adapter for type '${g.type}'.`);const U=N;return this.D.set($,U),this.db(g).then(z=>(z&&this.E.set($,z),U.onMessage(async F=>{if(F.type==="request"&&F.command==="handshake"){const I=F,O={type:"response",seq:0,command:I.command,request_seq:I.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const T=await this.K.sign(I.arguments.value);O.body={signature:T},U.sendResponse(O)}else throw new Error("no signer")}catch(T){O.success=!1,O.message=T.message,U.sendResponse(O)}}else z&&z.onDidSendMessage&&z.onDidSendMessage(F),F=(0,k.$BG)(F,!0),b.l.$acceptDAMessage($,F)}),U.onError(F=>{z&&z.onError&&z.onError(F),this.l.$acceptDAError($,F.name,F.message,F.stack)}),U.onExit(F=>{z&&z.onExit&&z.onExit(F??void 0,void 0),this.l.$acceptDAExit($,F??void 0,void 0)}),z&&z.onWillStartSession&&z.onWillStartSession(),U.startSession()))})}$sendDAMessage($,D){D=(0,k.$AG)(D,!1);const b=this.E.get($);b&&b.onWillReceiveMessage&&b.onWillReceiveMessage(D),this.D.get($)?.sendMessage(D)}$stopDASession($){const D=this.E.get($);this.E.delete($),D&&D.onWillStopSession&&D.onWillStopSession();const b=this.D.get($);return this.D.delete($),b?b.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta($){const D=[],b=[],g=[];if($.added)for(const y of $.added){const P=y.id;if(P&&!this.z.has(P)){let N;if(y.type==="function")N=new C.$9M(y.functionName,y.enabled,y.condition,y.hitCondition,y.logMessage,y.mode);else if(y.type==="data")N=new C.$0M(y.label,y.dataId,y.canPersist,y.enabled,y.hitCondition,y.condition,y.logMessage,y.mode);else{const U=L.URI.revive(y.uri);N=new C.$8M(new C.$hM(U,new C.$9L(y.line,y.character)),y.enabled,y.condition,y.hitCondition,y.logMessage,y.mode)}(0,C.$6M)(N,P),this.z.set(P,N),D.push(N)}}if($.removed)for(const y of $.removed){const P=this.z.get(y);P&&(this.z.delete(y),b.push(P))}if($.changed){for(const y of $.changed)if(y.id){const P=this.z.get(y.id);if(P){if(P instanceof C.$9M&&y.type==="function"){const N=P;N.enabled=y.enabled,N.condition=y.condition,N.hitCondition=y.hitCondition,N.logMessage=y.logMessage,N.functionName=y.functionName}else if(P instanceof C.$8M&&y.type==="source"){const N=P;N.enabled=y.enabled,N.condition=y.condition,N.hitCondition=y.hitCondition,N.logMessage=y.logMessage,N.location=new C.$hM(L.URI.revive(y.uri),new C.$9L(y.line,y.character))}g.push(P)}}}this.gb(D,b,g)}async $acceptStackFrameFocus($){let D;const b=$.sessionId?await this.hb($.sessionId):void 0;if(!b)throw new Error("no DebugSession found for debug focus context");$.kind==="thread"?D=new C.$dN(b.api,$.threadId):D=new C.$cN(b.api,$.threadId,$.frameId),this.B=D,this.C.fire(this.B)}$provideDebugConfigurations($,D,b){return(0,l.$0g)(async()=>{const g=this.bb($);if(!g)throw new Error("no DebugConfigurationProvider found");if(!g.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const y=await this.ib(D);return g.provideDebugConfigurations(y,b)}).then(g=>{if(!g)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return g})}$resolveDebugConfiguration($,D,b,g){return(0,l.$0g)(async()=>{const y=this.bb($);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const P=await this.ib(D);return y.resolveDebugConfiguration(P,b,g)})}$resolveDebugConfigurationWithSubstitutedVariables($,D,b,g){return(0,l.$0g)(async()=>{const y=this.bb($);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const P=await this.ib(D);return y.resolveDebugConfigurationWithSubstitutedVariables(P,b,g)})}async $provideDebugAdapter($,D){const b=this.ab($);if(!b)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const g=await this.hb(D);return this.eb(b,g).then(y=>{if(!y)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}'`);return this.Z(y)})}async $acceptDebugSessionStarted($){const D=await this.hb($);this.n.fire(D.api)}async $acceptDebugSessionTerminated($){const D=await this.hb($);D&&(this.o.fire(D.api),this.m.delete(D.id))}async $acceptDebugSessionActiveChanged($){this.u=$?await this.hb($):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged($,D){(await this.hb($))?._acceptNameChanged(D)}async $acceptDebugSessionCustomEvent($,D){const g={session:(await this.hb($)).api,event:D.event,body:D.body};this.w.fire(g)}Z($){if($ instanceof C.$$M)return{type:"executable",command:$.command,args:$.args,options:$.options};if($ instanceof C.$_M)return{type:"server",port:$.port,host:$.host};if($ instanceof C.$aN)return{type:"pipeServer",path:$.path};if($ instanceof C.$bN)return{type:"implementation",implementation:$.implementation};throw new Error("convertToDto unexpected type")}$($){const D=this.h.filter(b=>b.type===$);if(D.length>0)return D[0].factory}ab($){const D=this.h.filter(b=>b.handle===$);if(D.length>0)return D[0].factory}bb($){const D=this.f.filter(b=>b.handle===$);if(D.length>0)return D[0].provider}cb($,D){if($.contributes){const b=$.contributes.debuggers;if(b&&b.length>0){for(const g of b)if(g.label&&g.type&&g.type===D)return!0}}return!1}db($){const b=$.configuration.type,g=this.k.filter(y=>y.type===b||y.type==="*").map(y=>(0,l.$0g)(()=>y.factory.createDebugAdapterTracker($.api)).then(P=>P,P=>null));return Promise.race([Promise.all(g).then(y=>{const P=y.filter(N=>!!N);if(P.length>0)return new h(P)}),new Promise(y=>setTimeout(()=>y(void 0),1e3))]).catch(y=>{})}async eb($,D){const b=D.configuration.debugServer;if(typeof b=="number")return Promise.resolve(new C.$_M(b));if($){const y=await this.O.getExtensionRegistry();return(0,l.$0g)(()=>$.createDebugAdapterDescriptor(D.api,this.fb(D,y))).then(P=>{if(P)return P})}const g=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(D,g))}fb($,D){}gb($,D,b){($.length>0||D.length>0||b.length>0)&&this.A.fire(Object.freeze({added:$,removed:D,changed:b}))}async hb($){if($)if(typeof $=="string"){const D=this.m.get($);if(D)return D}else{let D=this.m.get($.id);if(!D){const b=await this.ib($.folderUri),g=$.parent?this.m.get($.parent):void 0;D=new t(this.l,$.id,$.type,$.name,b,$.configuration,g?.api),this.m.set(D.id,D),this.l.$sessionCached(D.id)}return D}throw new Error("cannot find session")}ib($){if($){const D=L.URI.revive($);return this.N.resolveWorkspaceFolder(D)}return Promise.resolve(void 0)}jb($,D){return`${$}\0${D}`}kb($,D){if(D){if("title"in D&&"command"in D)return{type:0};if("treeId"in D)return{type:1,id:`${$}\0${D.treeId}`};throw new Error("Unsupported debug visualization type")}}lb($){const D=this.mb($);let b,g;return"id"in D?g=i.ThemeIcon.asClassName(D):b=D,{iconPath:b,iconClass:g}}mb($){if($ instanceof C.$3M)return{id:$.id};const D=typeof $=="object"&&"dark"in $?$.dark:$,b=typeof $=="object"&&"light"in $?$.light:$;return{dark:typeof D=="string"?L.URI.file(D):D,light:typeof b=="string"?L.URI.file(b):b}}};e.$Wic=c,e.$Wic=c=Ye([Ve(0,M.$lO),Ve(1,v.$cic),Ve(2,E.$Qic),Ve(3,u.$fic),Ve(4,w.$ric),Ve(5,m.$Tic),Ve(6,n.$HO)],c);class t{constructor($,D,b,g,y,P,N){this.f=$,this.g=D,this.h=b,this.j=g,this.k=y,this.l=P,this.m=N}get api(){const $=this;return this.d??=Object.freeze({id:$.g,type:$.h,get name(){return $.j},set name(D){$.j=D,$.f.$setDebugSessionName($.g,D)},parentSession:$.m,workspaceFolder:$.k,configuration:$.l,customRequest(D,b){return $.f.$customDebugAdapterRequest($.g,D,b)},getDebugProtocolBreakpoint(D){return $.f.$getDebugProtocolBreakpoint($.g,D.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged($){this.j=$}get configuration(){return this.l}}e.$Xic=t;class f{constructor($){this.value=Object.freeze({append(D){$.$appendDebugConsole(D)},appendLine(D){this.append(D+`
`)}})}}e.$Yic=f;class h{constructor($){this.d=$}onWillStartSession(){this.d.forEach($=>$.onWillStartSession?$.onWillStartSession():void 0)}onWillReceiveMessage($){this.d.forEach(D=>D.onWillReceiveMessage?D.onWillReceiveMessage($):void 0)}onDidSendMessage($){this.d.forEach(D=>D.onDidSendMessage?D.onDidSendMessage($):void 0)}onWillStopSession(){this.d.forEach($=>$.onWillStopSession?$.onWillStopSession():void 0)}onError($){this.d.forEach(D=>D.onError?D.onError($):void 0)}onExit($,D){this.d.forEach(b=>b.onExit?b.onExit($,D):void 0)}}class r extends S.$Onb{constructor($){super(),this.h=$,$.onDidSendMessage(D=>{this.acceptMessage(D)})}startSession(){return Promise.resolve(void 0)}sendMessage($){this.h.handleMessage($)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let a=class extends c{constructor($,D,b,g,y,P,N){super($,D,b,g,y,P,N)}};e.$Zic=a,e.$Zic=a=Ye([Ve(0,M.$lO),Ve(1,v.$cic),Ve(2,E.$Qic),Ve(3,u.$fic),Ve(4,w.$ric),Ve(5,m.$Tic),Ve(6,n.$HO)],a)}),define(Se[370],De([1,0,13,58,2,6,316,12,83,107,27,253,20,65,47,90]),function(fe,e,l,j,L,A,R,p,w,E,M,C,v,S,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3jc=e.$2jc=void 0;class m{static async installEarlyHandler(n){Error.stackTraceLimit=100;const s=n.get(p.$zj),t=n.get(v.$lO).getProxy(A.$6L.MainThreadErrors);l.setUnexpectedErrorHandler(f=>{s.error(f);const h=l.$3(f);t.$onUnexpectedError(h)})}static async installFullHandler(n){const s=n.get(p.$zj),c=n.get(v.$lO),t=n.get(k.$Qic),f=n.get(u.$FO),h=c.getProxy(A.$6L.MainThreadExtensionService),r=c.getProxy(A.$6L.MainThreadErrors),a=await t.getExtensionPathIndex(),d=new WeakMap;function $(g,y){if(d.has(g))return d.get(g).stack;let P="",N,U;for(const F of y)P+=`
	at ${F.toString()}`,U=F.getFileName(),!N&&U&&(N=a.findSubstr(L.URI.file(U)));const z=`${g.name||"Error"}: ${g.message||""}${P}`;return d.set(g,{extensionIdentifier:N?.identifier,stack:z}),z}const D=Symbol("prepareStackTrace wrapped");let b=$;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return b},set(g){if(g===$||!g||g[D]){b=g||$;return}b=function(y,P){return $(y,P),g.call(Error,y,P)},Object.assign(b,{[D]:!0})}}),l.setUnexpectedErrorHandler(g=>{s.error(g);const y=l.$3(g),P=d.get(g);if(!P?.extensionIdentifier){r.$onUnexpectedError(y);return}h.$onExtensionRuntimeError(P.extensionIdentifier,y);const N=f.onExtensionError(P.extensionIdentifier,g);s.trace("forwarded error to extension?",N,P)})}}e.$2jc=m;class o{constructor(n,s,c,t,f){this.a=c,this.b=new R.$W9b(n,null,t),s=o.e(s,this.b);const h=new E.$di(...(0,w.$bs)());h.set(M.$BO,{_serviceBrand:void 0,...s,messagePorts:f}),h.set(v.$lO,new v.$mO(this.b)),h.set(S.$_hc,new S.$aic(t)),h.set(k.$Oic,c);const r=new C.$Sq(h,!0);r.invokeFunction(m.installEarlyHandler),this.d=r.invokeFunction(a=>a.get(p.$zj)),j.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",s),this.c=r.invokeFunction(a=>a.get(k.$Qic)),this.c.initialize(),r.invokeFunction(m.installFullHandler)}async asBrowserUri(n){const s=this.b.getProxy(A.$6L.MainThreadExtensionService);return L.URI.revive(await s.$asBrowserUri(n))}terminate(n){this.c.terminate(n)}static e(n,s){n.extensions.allExtensions.forEach(t=>{t.extensionLocation=L.URI.revive(s.transformIncomingURIs(t.extensionLocation))}),n.environment.appRoot=L.URI.revive(s.transformIncomingURIs(n.environment.appRoot));const c=n.environment.extensionDevelopmentLocationURI;return c&&(n.environment.extensionDevelopmentLocationURI=c.map(t=>L.URI.revive(s.transformIncomingURIs(t)))),n.environment.extensionTestsLocationURI=L.URI.revive(s.transformIncomingURIs(n.environment.extensionTestsLocationURI)),n.environment.globalStorageHome=L.URI.revive(s.transformIncomingURIs(n.environment.globalStorageHome)),n.environment.workspaceStorageHome=L.URI.revive(s.transformIncomingURIs(n.environment.workspaceStorageHome)),n.environment.extensionTelemetryLogResource=L.URI.revive(s.transformIncomingURIs(n.environment.extensionTelemetryLogResource)),n.nlsBaseUrl=L.URI.revive(s.transformIncomingURIs(n.nlsBaseUrl)),n.logsLocation=L.URI.revive(s.transformIncomingURIs(n.logsLocation)),n.workspace=s.transformIncomingURIs(n.workspace),n}}e.$3jc=o}),define(Se[371],De([1,0,8,11,228,247,141,96,70,47,20,46,7,60,41,288,289,42,33,372]),function(fe,e,l,j,L,A,R,p,w,E,M,C,v,S,k,u,m,o,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$akc=void 0;let s=class extends p.$Wic{constructor(a,d,$,D,b,g,y,P){super(a,d,$,D,g,y,P),this.pb=b,this.nb=new h}X(a,d){switch(a.type){case"server":return new u.$8jc(a);case"pipeServer":return new u.$9jc(a);case"executable":return new u.$0jc(a,d.type)}return super.X(a,d)}fb(a,d){const $=u.$0jc.platformAdapterExecutable(d.getAllExtensionDescriptions(),a.type);if($)return new v.$$M($.command,$.args,$.options)}Y(){return new R.$Iac}async $runInTerminal(a,d){if(a.kind==="integrated"){this.ob||(this.ob=this.pb.onDidCloseTerminal(O=>{this.nb.onTerminalClosed(O)}));const $=await this.P.getConfigProvider(),D=this.pb.getDefaultShell(!0),b=this.pb.getDefaultShellArgs(!0),g=a.title||L.localize(0,null),y=c(D,b,a);let P=await this.nb.checkout(y,g),N,U=!1;if(P)N=a.cwd;else{const O={shellPath:D,shellArgs:b,cwd:a.cwd,name:g,iconPath:new v.$3M("debug"),env:a.env};U=!0,P=this.pb.createTerminalFromOptions(O,{isFeatureTerminal:!0,forceShellIntegration:!0,useShellEnvironment:!0}),this.nb.insert(P,y)}P.show(!0);const z=await P.processId;U?await new Promise(O=>setTimeout(O,1e3)):$.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(D.indexOf("powershell")>=0||D.indexOf("pwsh")>=0||D.indexOf("cmd.exe")>=0?P.sendText("cls"):D.indexOf("bash")>=0?P.sendText("clear"):j.$i?P.sendText("cls"):P.sendText("clear"));const F=(0,m.$_jc)(D,a.args,!!a.argsCanBeInterpretedByShell,N);P.sendText(F);const I=this.onDidTerminateDebugSession(O=>{O.id===d&&(this.nb.free(P),I.dispose())});return z}else if(a.kind==="external")return f(a,await this.P.getConfigProvider());return super.$runInTerminal(a,d)}};e.$akc=s,e.$akc=s=Ye([Ve(0,M.$lO),Ve(1,k.$cic),Ve(2,E.$Qic),Ve(3,o.$fic),Ve(4,C.$Dic),Ve(5,w.$ric),Ve(6,S.$Tic),Ve(7,i.$HO)],s);function c(r,a,d){const $=(0,n.createHash)("sha256");return $.update(JSON.stringify({shell:r,shellArgs:a})),$.update(JSON.stringify(Object.entries(d.env||{}).sort(([D],[b])=>D.localeCompare(b)))),$.digest("base64")}let t;function f(r,a){if(!t)if(j.$i)t=new A.$t_b;else if(j.$j)t=new A.$u_b;else if(j.$k)t=new A.$v_b;else throw new Error("external terminals not supported on this platform");const d=a.getConfiguration("terminal");return t.runInTerminal(r.title,r.cwd,r.args,r.env||{},d.external||{})}class h{constructor(){this.b=new Map}static{this.a=1e3}async checkout(a,d){const D=[...this.b.entries()].map(([b,g])=>(0,l.$5g)(async y=>{if(b.name!==d||g.lastUsedAt!==-1&&await(0,m.$$jc)(await b.processId))return null;const P=Date.now();return g.lastUsedAt+h.a>P||y.isCancellationRequested||g.config!==a?null:(g.lastUsedAt=P,b)}));return await(0,l.$kh)(D,b=>!!b)}insert(a,d){this.b.set(a,{lastUsedAt:Date.now(),config:d})}free(a){const d=this.b.get(a);d&&(d.lastUsedAt=-1)}onTerminalClosed(a){this.b.delete(a)}}}),define(Se[373],De([1,0,17,2,105,41,71,42,40,46,20,27,95,15,12,91,23,63,60]),function(fe,e,l,j,L,A,R,p,w,E,M,C,v,S,k,u,m,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5jc=void 0;let n=class extends v.$Gjc{constructor(c,t,f,h,r,a,d,$,D){super(c,t,f,h,r,a,d,$),this.C=f,this.D=D,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(S.Schemas.vscodeRemote,{scheme:S.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(S.Schemas.file,{scheme:S.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(c,t){const f=t;if(!t.execution&&f._id===void 0)throw new Error("Tasks to execute must include an execution");if(f._id!==void 0){const h=v.TaskHandleDTO.from(f,this.C),r=await this.a.$getTaskExecution(h);if(r.task===void 0)throw new Error("Task from execution DTO is undefined");const a=await this.z(r,t);return this.a.$executeTask(h).catch(()=>{}),a}else{const h=v.TaskDTO.from(t,c);if(h===void 0)return Promise.reject(new Error("Task is not valid"));v.CustomExecutionDTO.is(h.execution)&&await this.y(h,t,!1);const r=await this.z(await this.a.$getTaskExecution(h),t);return this.a.$executeTask(h).catch(()=>{}),r}}v(c,t,f,h){const r=[];if(h)for(const a of h){this.A(a,f),(!a.definition||!c[a.definition.type])&&this.f.warn(`The task [${a.source}, ${a.name}] uses an undefined task type. The task will be ignored in the future.`);const d=v.TaskDTO.from(a,f.extension);d&&(r.push(d),v.CustomExecutionDTO.is(d.execution)&&t.push(this.y(d,a,!0)))}return{tasks:r,extension:f.extension}}async w(c){return c}async G(c){let t=c&&c.length>0?c[0]:void 0;if(!t){const f=j.URI.file((0,o.homedir)());t=new w.$zi({uri:f,name:m.$Pg(f),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(c,t){const f=j.URI.revive(c),h={process:void 0,variables:Object.create(null)},r=await this.b.resolveWorkspaceFolder(f),a=await this.b.getWorkspaceFolders2()??[],d=await this.D.getResolver(),$=r?{uri:r.uri,name:r.name,index:r.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(a);for(const D of t.variables)h.variables[D]=await d.resolveAsync($,D);if(t.process!==void 0){let D;if(t.process.path!==void 0){D=t.process.path.split(l.$tc);for(let b=0;b<D.length;b++)D[b]=await d.resolveAsync($,D[b])}h.process=await L.win32.findExecutable(await d.resolveAsync($,t.process.name),t.process.cwd!==void 0?await d.resolveAsync($,t.process.cwd):void 0,D)}return h}async $jsonTasksSupported(){return!0}async $findExecutable(c,t,f){return L.win32.findExecutable(c,t,f)}};e.$5jc=n,e.$5jc=n=Ye([Ve(0,M.$lO),Ve(1,C.$BO),Ve(2,A.$cic),Ve(3,R.$wO),Ve(4,p.$fic),Ve(5,E.$Dic),Ve(6,k.$zj),Ve(7,u.$Phc),Ve(8,i.$Tic)],n)}),define(Se[374],De([1,0,63,60]),function(fe,e,l,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kkc=void 0;class L extends j.$Uic{m(){return(0,l.homedir)()}}e.$Kkc=L}),define(Se[158],De([1,0,19,8,22,44,15,17,23,2,36]),function(fe,e,l,j,L,A,R,p,w,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ejc=e.$djc=e.$cjc=e.$bjc=void 0;class C{constructor(i,n,s){this.d=i,this.e=n,this.f=s,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(i,n){const s=this.g.folderQueries||[],c=new L.$ce(n);return new Promise((t,f)=>{this.a=new S(i);let h=!1;const r=(a,d)=>{if(!h&&!this.b){const $=this.h(a);u(a)&&typeof this.g.maxResults=="number"&&this.c+$>this.g.maxResults&&(this.b=!0,h=!0,c.cancel(),a=this.j(a,this.g.maxResults-this.c));const D=this.h(a);this.c+=D,(D>0||!u(a))&&this.a.add(a,d)}};Promise.all(s.map((a,d)=>this.k(a,$=>r($,d),c.token))).then(a=>{c.dispose(),this.a.flush();const d=a.some($=>!!$&&!!$.limitHit);t({limitHit:this.b||d,messages:(0,l.$Rb)(a.map($=>$?.message?Array.isArray($.message)?$.message:[$.message]:[])),stats:{type:this.f}})},a=>{c.dispose();const d=(0,A.$3i)(a);f(new Error(d))})})}h(i){return u(i)?Array.isArray(i.ranges)?i.ranges.length:1:0}j(i,n){const s=Array.isArray(i.ranges)?i.ranges:[i.ranges],c=Array.isArray(i.preview.matches)?i.preview.matches:[i.preview.matches];return{ranges:s.slice(0,n),preview:{matches:c.slice(0,n),text:i.preview.text},uri:i.uri}}async k(i,n,s){const c=new M.$FK(this.g,i),t=[],f={report:a=>{if(!this.l(a))return;const d=i.folder.scheme===R.Schemas.file?(0,M.$GK)(()=>this.e.readdir(w.$Rg(a.uri))):void 0,$=w.$Ug(i.folder,a.uri);if($){const D=c.includedInQuery($,p.$nc($),d);(0,j.$4g)(D)?t.push(D.then(b=>{b&&n(a)})):D&&n(a)}}},h=this.n(i);let r;return this.d.query.type===3?r=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,h,f,s):r=await this.d.provider.provideTextSearchResults(v(this.d.query.contentPattern),h,f,s),t.length&&await Promise.all(t),r}l(i){if(u(i)){if(Array.isArray(i.ranges)){if(!Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(i.preview.matches.length!==i.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(i){const n=(0,M.$EK)(this.g.includePattern,i.includePattern),s=(0,M.$EK)(this.g.excludePattern,i.excludePattern),c={folder:E.URI.from(i.folder),excludes:s,includes:n,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,encoding:i.fileEncoding&&this.e.toCanonicalName(i.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(c.usePCRE2=this.g.usePCRE2),c}}e.$bjc=C;function v(o){return{isCaseSensitive:o.isCaseSensitive||!1,isRegExp:o.isRegExp||!1,isWordMatch:o.isWordMatch||!1,isMultiline:o.isMultiline||!1,pattern:o.pattern}}class S{constructor(i){this.e=i,this.b=-1,this.d=null,this.a=new m(512,n=>this.g(n))}add(i,n){this.d&&(this.b!==n||!w.$Lg(this.c,i.uri))&&(this.f(),this.d=null),this.d||(this.b=n,this.d={resource:i.uri,results:[]}),this.d.results.push(k(i))}f(){const i=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,i)}flush(){this.f(),this.a.flush()}g(i){this.e(i)}}e.$cjc=S;function k(o){return u(o)?{preview:{matches:(0,l.$2b)(o.preview.matches,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character})),text:o.preview.text},ranges:(0,l.$2b)(o.ranges,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character}))}:{text:o.text,lineNumber:o.lineNumber}}function u(o){return!!o.preview}e.$djc=u;class m{static{this.a=4e3}static{this.b=50}constructor(i,n){this.g=i,this.h=n,this.c=0,this.d=[],this.e=0}addItem(i,n){i&&this.j(i,n)}addItems(i,n){i&&this.k(i,n)}j(i,n){this.d.push(i),this.e+=n,this.l()}k(i,n){this.d=this.d.concat(i),this.e+=n,this.l()}l(){this.c<m.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},m.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$ejc=m}),define(Se[97],De([1,0,3,6,5,366,20,65,12,2,158]),function(fe,e,l,j,L,A,R,p,w,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hjc=e.$gjc=e.$fjc=void 0,e.$fjc=(0,L.$fi)("IExtHostSearch");let C=class{constructor(u,m,o){this.n=u,this.o=m,this.q=o,this.c=this.n.getProxy(j.$6L.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new A.$ajc}s(u){return this.o.transformOutgoingScheme(u)}registerTextSearchProvider(u,m){if(this.g.has(u))throw new Error(`a text search provider for the scheme '${u}' is already registered`);this.g.add(u);const o=this.d++;return this.e.set(o,m),this.c.$registerTextSearchProvider(o,this.s(u)),(0,l.$Rc)(()=>{this.g.delete(u),this.e.delete(o),this.c.$unregisterProvider(o)})}registerAITextSearchProvider(u,m){if(this.i.has(u))throw new Error(`an AI text search provider for the scheme '${u}'is already registered`);this.i.add(u);const o=this.d++;return this.h.set(o,m),this.c.$registerAITextSearchProvider(o,this.s(u)),(0,l.$Rc)(()=>{this.i.delete(u),this.h.delete(o),this.c.$unregisterProvider(o)})}registerFileSearchProvider(u,m){if(this.k.has(u))throw new Error(`a file search provider for the scheme '${u}' is already registered`);this.k.add(u);const o=this.d++;return this.j.set(o,m),this.c.$registerFileSearchProvider(o,this.s(u)),(0,l.$Rc)(()=>{this.k.delete(u),this.j.delete(o),this.c.$unregisterProvider(o)})}$provideFileSearchResults(u,m,o,i){const n=v(o),s=this.j.get(u);if(s)return this.l.fileSearch(n,s,c=>{this.c.$handleFileMatch(u,m,c.map(t=>t.resource))},i);throw new Error("3 unknown provider: "+u)}async doInternalFileSearchWithCustomCallback(u,m,o){return{messages:[]}}$clearCache(u){return this.l.clearCache(u),Promise.resolve(void 0)}$provideTextSearchResults(u,m,o,i){const n=this.e.get(u);if(!n||!n.provideTextSearchResults)throw new Error(`2 Unknown provider ${u}`);const s=v(o);return this.t(s,n).search(t=>this.c.$handleTextMatch(u,m,t),i)}$provideAITextSearchResults(u,m,o,i){const n=this.h.get(u);if(!n||!n.provideAITextSearchResults)throw new Error(`1 Unknown provider ${u}`);const s=v(o);return this.v(s,n).search(t=>this.c.$handleTextMatch(u,m,t),i)}$enableExtensionHostSearch(){}t(u,m){return new M.$bjc({query:u,provider:m},{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"textSearchProvider")}v(u,m){return new M.$bjc({query:u,provider:m},{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"aiTextSearchProvider")}};e.$gjc=C,e.$gjc=C=Ye([Ve(0,R.$lO),Ve(1,p.$_hc),Ve(2,w.$zj)],C);function v(k){return{...k,folderQueries:k.folderQueries&&k.folderQueries.map(S),extraFileResources:k.extraFileResources&&k.extraFileResources.map(u=>E.URI.revive(u))}}e.$hjc=v;function S(k){return{...k,folder:E.URI.revive(k.folder)}}}),define(Se[375],De([1,0,22,13,4,3,15,39,2,135,196,177,78,25,32,12,86,87,272,6,318,345,91,120,323,304,324,121,325,305,293,33,326,42,327,96,151,328,307,319,329,330,71,70,320,47,331,68,332,59,27,346,347,321,308,333,334,115,116,309,365,336,278,337,348,338,156,310,339,340,341,20,342,97,117,343,311,344,118,93,95,90,46,349,350,322,351,352,69,16,7,312,65,313,92,353,354,150,41,286,114,26,94]),function(fe,e,l,j,L,A,R,p,w,E,M,C,v,S,k,u,m,o,i,n,s,c,t,f,h,r,a,d,$,D,b,g,y,P,N,U,z,F,I,O,T,G,te,x,X,Q,ae,_,ge,se,re,B,ie,ye,le,ue,ce,de,H,Z,he,be,Pe,pe,Ae,Oe,ze,q,W,Y,J,$e,ve,Fe,He,Qe,tt,st,ut,rt,Ie,Be,Le,Ke,ne,oe,Ce,Ge,xe,nt,Ne,$t,Dt,Pt,Tt,Xt,Ct,Jt,Yt,_t,ni,et,Bt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wjc=void 0;function ei(dt){const wt=dt.get(re.$BO),ti=dt.get(se.$Thc),Ht=dt.get(_.$hic),Ut=dt.get(Q.$Qic),ft=dt.get(Yt.$cic),Rt=dt.get(Be.$FO),ii=dt.get(P.$fic),Zt=dt.get(Dt.$_hc),Xe=dt.get($e.$lO),Lt=dt.get(ut.$Aic),Wt=dt.get(rt.$iic),ri=dt.get(u.$Aj),gt=dt.get(u.$zj),Ot=dt.get(xe.$zAb),At=dt.get(t.$Phc),qt=dt.get(Jt.$Vjc),si=dt.get(He.$Iic),zt=dt.get(x.$ric),Kt=dt.get(H.$Mic),kt=dt.get(f.$Zhc),jt=dt.get(d.$5hc);Xe.set(n.$7L.ExtHostFileSystemInfo,ti),Xe.set(n.$7L.ExtHostLogLevelServiceShape,ri),Xe.set(n.$7L.ExtHostWorkspace,ft),Xe.set(n.$7L.ExtHostConfiguration,ii),Xe.set(n.$7L.ExtHostExtensionService,Ut),Xe.set(n.$7L.ExtHostStorage,Lt),Xe.set(n.$7L.ExtHostTunnelService,Ot),Xe.set(n.$7L.ExtHostWindow,qt),Xe.set(n.$7L.ExtHostSecretState,si),Xe.set(n.$7L.ExtHostTelemetry,Rt),Xe.set(n.$7L.ExtHostEditorTabs,zt),Xe.set(n.$7L.ExtHostManagedSockets,Kt),Xe.set(n.$7L.ExtHostAuthentication,kt),Xe.set(n.$7L.ExtHostChatProvider,jt);const Qt=Xe.set(n.$7L.ExtHostDecorations,dt.get(z.$2ic)),Vt=Xe.set(n.$7L.ExtHostDocumentsAndEditors,dt.get(te.$wO)),yt=Xe.set(n.$7L.ExtHostCommands,dt.get(g.$HO)),It=Xe.set(n.$7L.ExtHostTerminalService,dt.get(Le.$Dic)),Et=Xe.set(n.$7L.ExtHostDebugService,dt.get(U.$Vic)),ci=Xe.set(n.$7L.ExtHostSearch,dt.get(Fe.$fjc)),Re=Xe.set(n.$7L.ExtHostTask,dt.get(Ie.$Ijc)),Te=Xe.set(n.$7L.ExtHostOutputService,dt.get(ze.$vjc)),Ee=Xe.set(n.$7L.ExtHostLocalization,dt.get(de.$Lic)),ee=Xe.set(n.$7L.ExtHostUrls,new Pt.$Sjc(Xe)),Me=Xe.set(n.$7L.ExtHostDocuments,new G.$Whc(Xe,Vt)),qe=Xe.set(n.$7L.ExtHostDocumentContentProviders,new O.$4ic(Xe,Vt,gt)),_e=Xe.set(n.$7L.ExtHostDocumentSaveParticipant,new T.$5ic(gt,Me,Xe.getProxy(n.$6L.MainThreadBulkEdits))),Je=Xe.set(n.$7L.ExtHostNotebook,new he.$ijc(Xe,yt,Vt,Me,Ht,ci)),ct=Xe.set(n.$7L.ExtHostNotebookDocuments,new Pe.$pjc(Je)),vt=Xe.set(n.$7L.ExtHostNotebookEditors,new pe.$qjc(gt,Je)),Nt=Xe.set(n.$7L.ExtHostNotebookKernels,new Ae.$rjc(Xe,wt,Je,yt,gt)),xt=Xe.set(n.$7L.ExtHostNotebookRenderers,new Oe.$tjc(Xe,Je)),Mt=Xe.set(n.$7L.ExtHostNotebookDocumentSaveParticipant,new be.$ojc(gt,Je,Xe.getProxy(n.$6L.MainThreadBulkEdits))),St=Xe.set(n.$7L.ExtHostEditors,new ne.$9hc(Xe,Vt)),vi=Xe.set(n.$7L.ExtHostTreeViews,new Ge.$Qjc(Xe.getProxy(n.$6L.MainThreadTreeViews),yt,gt)),Pi=Xe.set(n.$7L.ExtHostEditorInsets,new b.$0hc(Xe.getProxy(n.$6L.MainThreadEditorInsets),St,wt.remote)),bi=Xe.set(n.$7L.ExtHostDiagnostics,new F.$Vhc(Xe,gt,ti,Vt)),wi=Xe.set(n.$7L.ExtHostLanguages,new ce.$mjc(Xe,Me,yt.converter,Zt)),ht=Xe.set(n.$7L.ExtHostLanguageFeatures,new ue.$Xhc(Xe,Zt,Me,yt,bi,gt,At,Rt)),Ai=Xe.set(n.$7L.ExtHostFileSystem,new ae.$7ic(Xe,ht)),ui=Xe.set(n.$7L.ExtHostFileSystemEventService,new ge.$8ic(Xe,gt,Vt)),gi=Xe.set(n.$7L.ExtHostQuickOpen,(0,J.$zjc)(Xe,ft,yt)),Ri=Xe.set(n.$7L.ExtHostSCM,new ve.$Bjc(Xe,yt,Me,gt)),ln=Xe.set(n.$7L.ExtHostQuickDiff,new Y.$yjc(Xe,Zt)),Xi=Xe.set(n.$7L.ExtHostShare,new Qe.$Cjc(Xe,Zt)),Li=Xe.set(n.$7L.ExtHostComments,(0,y.$$hc)(Xe,yt,Me)),yi=Xe.set(n.$7L.ExtHostProgress,new W.$xjc(Xe.getProxy(n.$6L.MainThreadProgress))),Zi=Xe.set(n.$7L.ExtHostLabelService,new le.$ljc(Xe)),Mi=Xe.set(n.$7L.ExtHostTheming,new oe.$Njc(Xe)),xi=Xe.set(n.$7L.ExtHostTimeline,new Ce.$Pjc(Xe,yt)),ki=Xe.set(n.$7L.ExtHostWebviews,new Tt.$mic(Xe,wt.remote,ft,gt,At)),Ei=Xe.set(n.$7L.ExtHostWebviewPanels,new Xt.$pic(Xe,ki,ft)),hn=Xe.set(n.$7L.ExtHostCustomEditors,new N.$qic(Xe,Me,Wt,ki,Ei)),dn=Xe.set(n.$7L.ExtHostWebviewViews,new Ct.$Tjc(Xe,ki)),mi=Xe.set(n.$7L.ExtHostTesting,new Ke.$Jjc(Xe,gt,yt,Vt)),Oi=Xe.set(n.$7L.ExtHostUriOpeners,new $t.$Rjc(Xe)),fn=Xe.set(n.$7L.ExtHostProfileContentHandlers,new q.$wjc(Xe));Xe.set(n.$7L.ExtHostInteractive,new ie.$jjc(Xe,Je,Vt,yt,gt));const gn=Xe.set(n.$7L.ExtHostInlineChat,new B.$9ic(Xe,yt,Me,gt)),_i=Xe.set(n.$7L.ExtHostChatAgents2,new a.$4hc(Xe,gt,yt)),mn=Xe.set(n.$7L.ExtHostChatVariables,new $.$7hc(Xe)),pi=Xe.set(n.$7L.ExtHostChat,new r.$3hc(Xe)),ji=Xe.set(n.$7L.ExtHostAiRelatedInformation,new s.$Ohc(Xe)),en=Xe.set(n.$7L.ExtHostAiEmbeddingVector,new X.$6ic(Xe)),Ni=Xe.set(n.$7L.ExtHostIssueReporter,new ye.$kjc(Xe)),tn=Xe.set(n.$7L.ExtHostStatusBar,new st.$Fjc(Xe,yt.converter)),Fi=Xe.set(n.$7L.ExtHostSpeech,new tt.$Djc(Xe)),nn=Object.values(n.$7L);Xe.assertRegistered(nn);const di=new h.$2hc(Xe,Vt),Si=new D.$8hc(Xe),Ti=new Z.$njc(Xe,gt),oi=new I.$3ic(Xe);return c.$Yhc.register(yt),function(Ue,li,zi){function ot(me){return(ke,We,at)=>{const pt=me(Ft=>{try{ke.call(We,Ft)}catch(Ji){j.$2(new Error(`[ExtensionListenerError] Extension '${Ue.identifier.value}' FAILED to handle event: ${Ji.toString()}`,{cause:Ji})),Rt.onExtensionError(Ue.identifier,Ji)}});return at?.push(pt),pt}}const bt=function(){let me=!Ue.isUnderDevelopment;function ke(){me||(gt.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),me=!0)}return function We(at){if(Array.isArray(at))at.forEach(We);else if(typeof at=="string")ke();else{const pt=at;typeof pt.scheme>"u"&&ke(),typeof pt.exclusive=="boolean"&&(0,et.$YF)(Ue,"documentFiltersExclusive")}return at}}(),$n={getSession(me,ke,We){return kt.getSession(Ue,me,ke,We)},getSessions(me,ke){return(0,et.$YF)(Ue,"authGetSessions"),kt.getSessions(Ue,me,ke)},async hasSession(me,ke){return(0,et.$YF)(Ue,"authSession"),!!await kt.getSession(Ue,me,ke,{silent:!0})},get onDidChangeSessions(){return ot(kt.onDidChangeSessions)},registerAuthenticationProvider(me,ke,We,at){return kt.registerAuthenticationProvider(me,ke,We,at)}},rn={registerCommand(me,ke,We){return yt.registerCommand(!0,me,ke,We,void 0,Ue)},registerTextEditorCommand(me,ke,We){return yt.registerCommand(!0,me,(...at)=>{const pt=St.getActiveTextEditor();if(!pt){gt.warn("Cannot execute "+me+" because there is no active text editor.");return}return pt.edit(Ft=>{ke.apply(We,[pt,Ft,...at])}).then(Ft=>{Ft||gt.warn("Edits from command "+me+" were not applied.")},Ft=>{gt.warn("An error occurred while running command "+me,Ft)})},void 0,void 0,Ue)},registerDiffInformationCommand:(me,ke,We)=>((0,et.$YF)(Ue,"diffCommand"),yt.registerCommand(!0,me,async(...at)=>{const pt=Vt.activeEditor(!0);if(!pt){gt.warn("Cannot execute "+me+" because there is no active text editor.");return}const Ft=await St.getDiffInformation(pt.id);ke.apply(We,[Ft,...at])},void 0,void 0,Ue)),executeCommand(me,...ke){return yt.executeCommand(me,...ke)},getCommands(me=!1){return yt.getCommands(me)}},Bi={get machineId(){return wt.telemetryInfo.machineId},get sessionId(){return wt.telemetryInfo.sessionId},get language(){return wt.environment.appLanguage},get appName(){return wt.environment.appName},get appRoot(){return wt.environment.appRoot?.fsPath??""},get appHost(){return wt.environment.appHost},get uriScheme(){return wt.environment.appUriScheme},get clipboard(){return Si.value},get shell(){return It.getDefaultShell(!1)},get onDidChangeShell(){return ot(It.onDidChangeShell)},get isTelemetryEnabled(){return Rt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return ot(Rt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,et.$YF)(Ue,"telemetry"),Rt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,et.$YF)(Ue,"telemetry"),ot(Rt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,Be.$EO)(wt.telemetryInfo.firstSessionDate)},createTelemetryLogger(me,ke){return Be.$DO.validateSender(me),Rt.instantiateLogger(Ue,me,ke)},openExternal(me,ke){return qt.openUri(me,{allowTunneling:!!wt.remote.authority,allowContributedOpeners:ke?.allowContributedOpeners})},async asExternalUri(me){if(me.scheme===wt.environment.appUriScheme)return ee.createAppUri(me);try{return await qt.asExternalUri(me,{allowTunneling:!!wt.remote.authority})}catch(ke){if((0,R.$og)(me,R.Schemas.http)||(0,R.$og)(me,R.Schemas.https))return me;throw ke}},get remoteName(){return(0,m.$qm)(wt.remote.authority)},get remoteAuthority(){return(0,et.$YF)(Ue,"resolvers"),wt.remote.authority},get uiKind(){return wt.uiKind},get logLevel(){return gt.getLevel()},get onDidChangeLogLevel(){return ot(gt.onDidChangeLogLevel)},registerIssueUriRequestHandler(me){return(0,et.$YF)(Ue,"handleIssueUri"),Ni.registerIssueUriRequestHandler(Ue,me)},registerIssueDataProvider(me){return(0,et.$YF)(Ue,"handleIssueUri"),Ni.registerIssueDataProvider(Ue,me)},get appQuality(){return(0,et.$YF)(Ue,"resolvers"),wt.quality},get appCommit(){return(0,et.$YF)(Ue,"resolvers"),wt.commit}};wt.environment.extensionTestsLocationURI||Object.freeze(Bi);const bn={createTestController(me,ke,We){return mi.createTestController(Ue,me,ke,We)},createTestObserver(){return(0,et.$YF)(Ue,"testObserver"),mi.createTestObserver()},runTests(me){return(0,et.$YF)(Ue,"testObserver"),mi.runTests(me)},get onDidChangeTestResults(){return(0,et.$YF)(Ue,"testObserver"),ot(mi.onResultsChanged)},get testResults(){return(0,et.$YF)(Ue,"testObserver"),mi.results}},Di=wt.remote.isRemote?Ne.ExtensionKind.Workspace:Ne.ExtensionKind.UI,sn={getExtension(me,ke){(0,et.$XF)(Ue,"extensionsAny")||(ke=!1);const We=li.mine.getExtensionDescription(me);if(We)return new Q.$Ric(Ut,Ue.identifier,We,Di,!1);if(ke){const at=li.all.getExtensionDescription(me);if(at)return new Q.$Ric(Ut,Ue.identifier,at,Di,!0)}},get all(){const me=[];for(const ke of li.mine.getAllExtensionDescriptions())me.push(new Q.$Ric(Ut,Ue.identifier,ke,Di,!1));return me},get allAcrossExtensionHosts(){(0,et.$YF)(Ue,"extensionsAny");const me=new S.$Am(li.mine.getAllExtensionDescriptions().map(We=>We.identifier)),ke=[];for(const We of li.all.getAllExtensionDescriptions()){const at=!me.has(We.identifier);ke.push(new Q.$Ric(Ut,Ue.identifier,We,Di,at))}return ke},get onDidChange(){return(0,et.$XF)(Ue,"extensionsAny")?ot(L.Event.any(li.mine.onDidChange,li.all.onDidChange)):ot(li.mine.onDidChange)}},Ui={createDiagnosticCollection(me){return bi.createDiagnosticCollection(Ue.identifier,me)},get onDidChangeDiagnostics(){return ot(bi.onDidChangeDiagnostics)},getDiagnostics:me=>bi.getDiagnostics(me),getLanguages(){return wi.getLanguages()},setTextDocumentLanguage(me,ke){return wi.changeLanguage(me.uri,ke)},match(me,ke){const We=nt.LanguageSelector.from(me);let at;return(0,M.$Qt)(We)&&(at=Je.notebookDocuments.find(pt=>!!pt.getCell(ke.uri))?.apiNotebook),(0,M.$Pt)(We,ke.uri,ke.languageId,!0,at?.uri,at?.notebookType)},registerCodeActionsProvider(me,ke,We){return ht.registerCodeActionProvider(Ue,bt(me),ke,We)},registerDocumentPasteEditProvider(me,ke,We){return(0,et.$YF)(Ue,"documentPaste"),ht.registerDocumentPasteEditProvider(Ue,bt(me),ke,We)},registerCodeLensProvider(me,ke){return ht.registerCodeLensProvider(Ue,bt(me),ke)},registerDefinitionProvider(me,ke){return ht.registerDefinitionProvider(Ue,bt(me),ke)},registerDeclarationProvider(me,ke){return ht.registerDeclarationProvider(Ue,bt(me),ke)},registerImplementationProvider(me,ke){return ht.registerImplementationProvider(Ue,bt(me),ke)},registerTypeDefinitionProvider(me,ke){return ht.registerTypeDefinitionProvider(Ue,bt(me),ke)},registerHoverProvider(me,ke){return ht.registerHoverProvider(Ue,bt(me),ke,Ue.identifier)},registerEvaluatableExpressionProvider(me,ke){return ht.registerEvaluatableExpressionProvider(Ue,bt(me),ke,Ue.identifier)},registerInlineValuesProvider(me,ke){return ht.registerInlineValuesProvider(Ue,bt(me),ke,Ue.identifier)},registerDocumentHighlightProvider(me,ke){return ht.registerDocumentHighlightProvider(Ue,bt(me),ke)},registerMultiDocumentHighlightProvider(me,ke){return ht.registerMultiDocumentHighlightProvider(Ue,bt(me),ke)},registerLinkedEditingRangeProvider(me,ke){return ht.registerLinkedEditingRangeProvider(Ue,bt(me),ke)},registerReferenceProvider(me,ke){return ht.registerReferenceProvider(Ue,bt(me),ke)},registerRenameProvider(me,ke){return ht.registerRenameProvider(Ue,bt(me),ke)},registerNewSymbolNamesProvider(me,ke){return(0,et.$YF)(Ue,"newSymbolNamesProvider"),ht.registerNewSymbolNamesProvider(Ue,bt(me),ke)},registerDocumentSymbolProvider(me,ke,We){return ht.registerDocumentSymbolProvider(Ue,bt(me),ke,We)},registerWorkspaceSymbolProvider(me){return ht.registerWorkspaceSymbolProvider(Ue,me)},registerDocumentFormattingEditProvider(me,ke){return ht.registerDocumentFormattingEditProvider(Ue,bt(me),ke)},registerDocumentRangeFormattingEditProvider(me,ke){return ht.registerDocumentRangeFormattingEditProvider(Ue,bt(me),ke)},registerOnTypeFormattingEditProvider(me,ke,We,...at){return ht.registerOnTypeFormattingEditProvider(Ue,bt(me),ke,[We].concat(at))},registerDocumentSemanticTokensProvider(me,ke,We){return ht.registerDocumentSemanticTokensProvider(Ue,bt(me),ke,We)},registerDocumentRangeSemanticTokensProvider(me,ke,We){return ht.registerDocumentRangeSemanticTokensProvider(Ue,bt(me),ke,We)},registerSignatureHelpProvider(me,ke,We,...at){return typeof We=="object"?ht.registerSignatureHelpProvider(Ue,bt(me),ke,We):ht.registerSignatureHelpProvider(Ue,bt(me),ke,typeof We>"u"?[]:[We,...at])},registerCompletionItemProvider(me,ke,...We){return ht.registerCompletionItemProvider(Ue,bt(me),ke,We)},registerInlineCompletionItemProvider(me,ke,We){return ke.handleDidShowCompletionItem&&(0,et.$YF)(Ue,"inlineCompletionsAdditions"),ke.handleDidPartiallyAcceptCompletionItem&&(0,et.$YF)(Ue,"inlineCompletionsAdditions"),We&&(0,et.$YF)(Ue,"inlineCompletionsAdditions"),ht.registerInlineCompletionsProvider(Ue,bt(me),ke,We)},registerInlineEditProvider(me,ke){return(0,et.$YF)(Ue,"inlineEdit"),ht.registerInlineEditProvider(Ue,bt(me),ke)},registerDocumentLinkProvider(me,ke){return ht.registerDocumentLinkProvider(Ue,bt(me),ke)},registerColorProvider(me,ke){return ht.registerColorProvider(Ue,bt(me),ke)},registerFoldingRangeProvider(me,ke){return ht.registerFoldingRangeProvider(Ue,bt(me),ke)},registerSelectionRangeProvider(me,ke){return ht.registerSelectionRangeProvider(Ue,me,ke)},registerCallHierarchyProvider(me,ke){return ht.registerCallHierarchyProvider(Ue,me,ke)},registerTypeHierarchyProvider(me,ke){return ht.registerTypeHierarchyProvider(Ue,me,ke)},setLanguageConfiguration:(me,ke)=>ht.setLanguageConfiguration(Ue,me,ke),getTokenInformationAtPosition(me,ke){return(0,et.$YF)(Ue,"tokenInformation"),wi.tokenAtPosition(me,ke)},registerInlayHintsProvider(me,ke){return ht.registerInlayHintsProvider(Ue,me,ke)},createLanguageStatusItem(me,ke){return wi.createLanguageStatusItem(Ue,me,ke)},registerDocumentDropEditProvider(me,ke,We){return ht.registerDocumentOnDropEditProvider(Ue,me,ke,(0,et.$XF)(Ue,"dropMetadata")?We:void 0)}},on={get activeTextEditor(){return St.getActiveTextEditor()},get visibleTextEditors(){return St.getVisibleTextEditors()},get activeTerminal(){return It.activeTerminal},get terminals(){return It.terminals},async showTextDocument(me,ke,We){w.URI.isUri(me)&&me.scheme===R.Schemas.vscodeRemote&&!me.authority&&At.report("workspace.showTextDocument",Ue,"A URI of 'vscode-remote' scheme requires an authority.");const at=await(w.URI.isUri(me)?Promise.resolve(Wi.openTextDocument(me)):Promise.resolve(me));return St.showTextDocument(at,ke,We)},createTextEditorDecorationType(me){return St.createTextEditorDecorationType(Ue,me)},onDidChangeActiveTextEditor(me,ke,We){return ot(St.onDidChangeActiveTextEditor)(me,ke,We)},onDidChangeVisibleTextEditors(me,ke,We){return ot(St.onDidChangeVisibleTextEditors)(me,ke,We)},onDidChangeTextEditorSelection(me,ke,We){return ot(St.onDidChangeTextEditorSelection)(me,ke,We)},onDidChangeTextEditorOptions(me,ke,We){return ot(St.onDidChangeTextEditorOptions)(me,ke,We)},onDidChangeTextEditorVisibleRanges(me,ke,We){return ot(St.onDidChangeTextEditorVisibleRanges)(me,ke,We)},onDidChangeTextEditorViewColumn(me,ke,We){return ot(St.onDidChangeTextEditorViewColumn)(me,ke,We)},onDidCloseTerminal(me,ke,We){return ot(It.onDidCloseTerminal)(me,ke,We)},onDidOpenTerminal(me,ke,We){return ot(It.onDidOpenTerminal)(me,ke,We)},onDidChangeActiveTerminal(me,ke,We){return ot(It.onDidChangeActiveTerminal)(me,ke,We)},onDidChangeTerminalDimensions(me,ke,We){return(0,et.$YF)(Ue,"terminalDimensions"),ot(It.onDidChangeTerminalDimensions)(me,ke,We)},onDidChangeTerminalState(me,ke,We){return ot(It.onDidChangeTerminalState)(me,ke,We)},onDidWriteTerminalData(me,ke,We){return(0,et.$YF)(Ue,"terminalDataWriteEvent"),ot(It.onDidWriteTerminalData)(me,ke,We)},onDidExecuteTerminalCommand(me,ke,We){return(0,et.$YF)(Ue,"terminalExecuteCommandEvent"),ot(It.onDidExecuteTerminalCommand)(me,ke,We)},get state(){return qt.getState(Ue)},onDidChangeWindowState(me,ke,We){return ot(qt.onDidChangeWindowState)(me,ke,We)},showInformationMessage(me,...ke){return Ti.showMessage(Ue,p.default.Info,me,ke[0],ke.slice(1))},showWarningMessage(me,...ke){return Ti.showMessage(Ue,p.default.Warning,me,ke[0],ke.slice(1))},showErrorMessage(me,...ke){return Ti.showMessage(Ue,p.default.Error,me,ke[0],ke.slice(1))},showQuickPick(me,ke,We){return gi.showQuickPick(Ue,me,ke,We)},showWorkspaceFolderPick(me){return gi.showWorkspaceFolderPick(me)},showInputBox(me,ke){return gi.showInput(me,ke)},showOpenDialog(me){return oi.showOpenDialog(Ue,me)},showSaveDialog(me){return oi.showSaveDialog(me)},createStatusBarItem(me,ke,We){let at,pt,Ft;return typeof me=="string"?(at=me,pt=ke,Ft=We):(pt=me,Ft=ke),tn.createStatusBarEntry(Ue,at,pt,Ft)},setStatusBarMessage(me,ke){return tn.setStatusBarMessage(me,ke)},withScmProgress(me){return At.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),yi.withProgress(Ue,{location:Ne.ProgressLocation.SourceControl},(ke,We)=>me({report(at){}}))},withProgress(me,ke){return yi.withProgress(Ue,me,ke)},createOutputChannel(me,ke){return Te.createOutputChannel(me,ke,Ue)},createWebviewPanel(me,ke,We,at){return Ei.createWebviewPanel(Ue,me,ke,We,at)},createWebviewTextEditorInset(me,ke,We,at){return(0,et.$YF)(Ue,"editorInsets"),Pi.createWebviewEditorInset(me,ke,We,at,Ue)},createTerminal(me,ke,We){return typeof me=="object"?"pty"in me?It.createExtensionTerminal(me):It.createTerminalFromOptions(me):It.createTerminal(me,ke,We)},registerTerminalLinkProvider(me){return It.registerLinkProvider(me)},registerTerminalProfileProvider(me,ke){return It.registerProfileProvider(Ue,me,ke)},registerTerminalQuickFixProvider(me,ke){return(0,et.$YF)(Ue,"terminalQuickFixProvider"),It.registerTerminalQuickFixProvider(me,Ue.identifier.value,ke)},registerTreeDataProvider(me,ke){return vi.registerTreeDataProvider(me,ke,Ue)},createTreeView(me,ke){return vi.createTreeView(me,ke,Ue)},registerWebviewPanelSerializer:(me,ke)=>Ei.registerWebviewPanelSerializer(Ue,me,ke),registerCustomEditorProvider:(me,ke,We={})=>hn.registerCustomEditorProvider(Ue,me,ke,We),registerFileDecorationProvider(me){return Qt.registerFileDecorationProvider(me,Ue)},registerUriHandler(me){return ee.registerUriHandler(Ue,me)},createQuickPick(){return gi.createQuickPick(Ue)},createInputBox(){return gi.createInputBox(Ue)},get activeColorTheme(){return Mi.activeColorTheme},onDidChangeActiveColorTheme(me,ke,We){return ot(Mi.onDidChangeActiveColorTheme)(me,ke,We)},registerWebviewViewProvider(me,ke,We){return dn.registerWebviewViewProvider(Ue,me,ke,We?.webviewOptions)},get activeNotebookEditor(){return Je.activeNotebookEditor},onDidChangeActiveNotebookEditor(me,ke,We){return ot(Je.onDidChangeActiveNotebookEditor)(me,ke,We)},get visibleNotebookEditors(){return Je.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ot(Je.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(me,ke,We){return ot(vt.onDidChangeNotebookEditorSelection)(me,ke,We)},onDidChangeNotebookEditorVisibleRanges(me,ke,We){return ot(vt.onDidChangeNotebookEditorVisibleRanges)(me,ke,We)},showNotebookDocument(me,ke){return Je.showNotebookDocument(me,ke)},registerExternalUriOpener(me,ke,We){return(0,et.$YF)(Ue,"externalUriOpener"),Oi.registerExternalUriOpener(Ue.identifier,me,ke,We)},registerProfileContentHandler(me,ke){return(0,et.$YF)(Ue,"profileContentHandlers"),fn.registerProfileContentHandler(Ue,me,ke)},registerQuickDiffProvider(me,ke,We,at){return(0,et.$YF)(Ue,"quickDiffProvider"),ln.registerQuickDiffProvider(bt(me),ke,We,at)},get tabGroups(){return zt.tabGroups},registerShareProvider(me,ke){return(0,et.$YF)(Ue,"shareProvider"),Xi.registerShareProvider(bt(me),ke)}},Wi={get rootPath(){return At.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(me){throw new j.$9("rootPath")},getWorkspaceFolder(me){return ft.getWorkspaceFolder(me)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(me){throw new j.$9("name")},get workspaceFile(){return ft.workspaceFile},set workspaceFile(me){throw new j.$9("workspaceFile")},updateWorkspaceFolders:(me,ke,...We)=>ft.updateWorkspaceFolders(Ue,me,ke||0,...We),onDidChangeWorkspaceFolders:function(me,ke,We){return ot(ft.onDidChangeWorkspace)(me,ke,We)},asRelativePath:(me,ke)=>ft.getRelativePath(me,ke),findFiles:(me,ke,We,at)=>ft.findFiles(me,ke,We,Ue.identifier,at),findFiles2:(me,ke,We)=>((0,et.$YF)(Ue,"findFiles2"),ft.findFiles2(me,ke,Ue.identifier,We)),findTextInFiles:(me,ke,We,at)=>{(0,et.$YF)(Ue,"findTextInFiles");let pt,Ft;return typeof ke=="object"?(pt=ke,Ft=We):(pt={},Ft=ke,at=We),ft.findTextInFiles(me,pt||{},Ft,Ue.identifier,at)},save:me=>ft.save(me),saveAs:me=>ft.saveAs(me),saveAll:me=>ft.saveAll(me),applyEdit(me,ke){return di.applyWorkspaceEdit(me,Ue,ke)},createFileSystemWatcher:(me,ke,We,at)=>{let pt;return typeof ke=="boolean"?pt={ignoreCreateEvents:!!ke,ignoreChangeEvents:!!We,ignoreDeleteEvents:!!at,correlate:!1}:ke&&((0,et.$YF)(Ue,"createFileSystemWatcher"),pt={...ke,correlate:!0}),ui.createFileSystemWatcher(ft,Ue,me,pt)},get textDocuments(){return Me.getAllDocumentData().map(me=>me.document)},set textDocuments(me){throw new j.$9("textDocuments")},openTextDocument(me){let ke;const We=me;if(typeof me=="string")ke=Promise.resolve(w.URI.file(me));else if(w.URI.isUri(me))ke=Promise.resolve(me);else if(!We||typeof We=="object")ke=Me.createDocumentData(We);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ke.then(at=>(at.scheme===R.Schemas.vscodeRemote&&!at.authority&&At.report("workspace.openTextDocument",Ue,"A URI of 'vscode-remote' scheme requires an authority."),Me.ensureDocumentData(at).then(pt=>pt.document)))},onDidOpenTextDocument:(me,ke,We)=>ot(Me.onDidAddDocument)(me,ke,We),onDidCloseTextDocument:(me,ke,We)=>ot(Me.onDidRemoveDocument)(me,ke,We),onDidChangeTextDocument:(me,ke,We)=>ot(Me.onDidChangeDocument)(me,ke,We),onDidSaveTextDocument:(me,ke,We)=>ot(Me.onDidSaveDocument)(me,ke,We),onWillSaveTextDocument:(me,ke,We)=>ot(_e.getOnWillSaveTextDocumentEvent(Ue))(me,ke,We),get notebookDocuments(){return Je.notebookDocuments.map(me=>me.apiNotebook)},async openNotebookDocument(me,ke){let We;if(w.URI.isUri(me))We=me,await Je.openNotebookDocument(me);else if(typeof me=="string")We=w.URI.revive(await Je.createNotebookDocument({viewType:me,content:ke}));else throw new Error("Invalid arguments");return Je.getNotebookDocument(We).apiNotebook},onDidSaveNotebookDocument(me,ke,We){return ot(ct.onDidSaveNotebookDocument)(me,ke,We)},onDidChangeNotebookDocument(me,ke,We){return ot(ct.onDidChangeNotebookDocument)(me,ke,We)},onWillSaveNotebookDocument(me,ke,We){return ot(Mt.getOnWillSaveNotebookDocumentEvent(Ue))(me,ke,We)},get onDidOpenNotebookDocument(){return ot(Je.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return ot(Je.onDidCloseNotebookDocument)},registerNotebookSerializer(me,ke,We,at){return Je.registerNotebookSerializer(Ue,me,ke,We,(0,et.$XF)(Ue,"notebookLiveShare")?at:void 0)},onDidChangeConfiguration:(me,ke,We)=>ot(zi.onDidChangeConfiguration)(me,ke,We),getConfiguration(me,ke){return ke=arguments.length===1?void 0:ke,zi.getConfiguration(me,ke,Ue)},registerTextDocumentContentProvider(me,ke){return qe.registerTextDocumentContentProvider(me,ke)},registerTaskProvider:(me,ke)=>(At.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),Re.registerTaskProvider(Ue,me,ke)),registerFileSystemProvider(me,ke,We){return(0,A.$Qc)(Ai.registerFileSystemProvider(Ue,me,ke,We),Ht.addFileSystemProvider(me,ke,We))},get fs(){return Ht.value},registerFileSearchProvider:(me,ke)=>((0,et.$YF)(Ue,"fileSearchProvider"),ci.registerFileSearchProvider(me,ke)),registerTextSearchProvider:(me,ke)=>((0,et.$YF)(Ue,"textSearchProvider"),ci.registerTextSearchProvider(me,ke)),registerAITextSearchProvider:(me,ke)=>((0,et.$YF)(Ue,"aiTextSearchProvider"),(0,et.$YF)(Ue,"textSearchProvider"),ci.registerAITextSearchProvider(me,ke)),registerRemoteAuthorityResolver:(me,ke)=>((0,et.$YF)(Ue,"resolvers"),Ut.registerRemoteAuthorityResolver(me,ke)),registerResourceLabelFormatter:me=>((0,et.$YF)(Ue,"resolvers"),Zi.$registerResourceLabelFormatter(me)),getRemoteExecServer:me=>((0,et.$YF)(Ue,"resolvers"),Ut.getRemoteExecServer(me)),onDidCreateFiles:(me,ke,We)=>ot(ui.onDidCreateFile)(me,ke,We),onDidDeleteFiles:(me,ke,We)=>ot(ui.onDidDeleteFile)(me,ke,We),onDidRenameFiles:(me,ke,We)=>ot(ui.onDidRenameFile)(me,ke,We),onWillCreateFiles:(me,ke,We)=>ot(ui.getOnWillCreateFileEvent(Ue))(me,ke,We),onWillDeleteFiles:(me,ke,We)=>ot(ui.getOnWillDeleteFileEvent(Ue))(me,ke,We),onWillRenameFiles:(me,ke,We)=>ot(ui.getOnWillRenameFileEvent(Ue))(me,ke,We),openTunnel:me=>((0,et.$YF)(Ue,"tunnels"),Ot.openTunnel(Ue,me).then(ke=>{if(!ke)throw new Error("cannot open tunnel");return ke})),get tunnels(){return(0,et.$YF)(Ue,"tunnels"),Ot.getTunnels()},onDidChangeTunnels:(me,ke,We)=>((0,et.$YF)(Ue,"tunnels"),ot(Ot.onDidChangeTunnels)(me,ke,We)),registerPortAttributesProvider:(me,ke)=>((0,et.$YF)(Ue,"portsAttributes"),Ot.registerPortsAttributesProvider(me,ke)),registerTunnelProvider:(me,ke)=>((0,et.$YF)(Ue,"tunnelFactory"),Ot.registerTunnelProvider(me,ke)),registerTimelineProvider:(me,ke)=>((0,et.$YF)(Ue,"timeline"),xi.registerTimelineProvider(me,ke,Ue.identifier,yt.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:me=>((0,et.$YF)(Ue,"workspaceTrust"),ft.requestWorkspaceTrust(me)),onDidGrantWorkspaceTrust:(me,ke,We)=>ot(ft.onDidGrantWorkspaceTrust)(me,ke,We),registerEditSessionIdentityProvider:(me,ke)=>((0,et.$YF)(Ue,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(me,ke)),onWillCreateEditSessionIdentity:(me,ke,We)=>((0,et.$YF)(Ue,"editSessionIdentityProvider"),ot(ft.getOnWillCreateEditSessionIdentityEvent(Ue))(me,ke,We)),registerCanonicalUriProvider:(me,ke)=>((0,et.$YF)(Ue,"canonicalUriProvider"),ft.registerCanonicalUriProvider(me,ke)),getCanonicalUri:(me,ke,We)=>((0,et.$YF)(Ue,"canonicalUriProvider"),ft.provideCanonicalUri(me,ke,We))},an={get inputBox(){return At.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),Ri.getLastInputBox(Ue)},createSourceControl(me,ke,We){return Ri.createSourceControl(Ue,me,ke,We)}},wn={createCommentController(me,ke){return Li.createCommentController(Ue,me,ke)}},pn={get activeDebugSession(){return Et.activeDebugSession},get activeDebugConsole(){return Et.activeDebugConsole},get breakpoints(){return Et.breakpoints},get stackFrameFocus(){return Et.stackFrameFocus},registerDebugVisualizationProvider(me,ke){return(0,et.$YF)(Ue,"debugVisualization"),Et.registerDebugVisualizationProvider(Ue,me,ke)},registerDebugVisualizationTreeProvider(me,ke){return(0,et.$YF)(Ue,"debugVisualization"),Et.registerDebugVisualizationTree(Ue,me,ke)},onDidStartDebugSession(me,ke,We){return ot(Et.onDidStartDebugSession)(me,ke,We)},onDidTerminateDebugSession(me,ke,We){return ot(Et.onDidTerminateDebugSession)(me,ke,We)},onDidChangeActiveDebugSession(me,ke,We){return ot(Et.onDidChangeActiveDebugSession)(me,ke,We)},onDidReceiveDebugSessionCustomEvent(me,ke,We){return ot(Et.onDidReceiveDebugSessionCustomEvent)(me,ke,We)},onDidChangeBreakpoints(me,ke,We){return ot(Et.onDidChangeBreakpoints)(me,ke,We)},onDidChangeStackFrameFocus(me,ke,We){return(0,et.$YF)(Ue,"debugFocus"),ot(Et.onDidChangeStackFrameFocus)(me,ke,We)},registerDebugConfigurationProvider(me,ke,We){return Et.registerDebugConfigurationProvider(me,ke,We||_t.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(me,ke){return Et.registerDebugAdapterDescriptorFactory(Ue,me,ke)},registerDebugAdapterTrackerFactory(me,ke){return Et.registerDebugAdapterTrackerFactory(me,ke)},startDebugging(me,ke,We){return!We||typeof We=="object"&&"configuration"in We?Et.startDebugging(me,ke,{parentSession:We}):Et.startDebugging(me,ke,We||{})},stopDebugging(me){return Et.stopDebugging(me)},addBreakpoints(me){return Et.addBreakpoints(me)},removeBreakpoints(me){return Et.removeBreakpoints(me)},asDebugSourceUri(me,ke){return Et.asDebugSourceUri(me,ke)}},cn={registerTaskProvider:(me,ke)=>Re.registerTaskProvider(Ue,me,ke),fetchTasks:me=>Re.fetchTasks(me),executeTask:me=>Re.executeTask(Ue,me),get taskExecutions(){return Re.taskExecutions},onDidStartTask:(me,ke,We)=>ot(Re.onDidStartTask)(me,ke,We),onDidEndTask:(me,ke,We)=>ot(Re.onDidEndTask)(me,ke,We),onDidStartTaskProcess:(me,ke,We)=>ot(Re.onDidStartTaskProcess)(me,ke,We),onDidEndTaskProcess:(me,ke,We)=>ot(Re.onDidEndTaskProcess)(me,ke,We)},un={createNotebookController(me,ke,We,at,pt){return Nt.createNotebookController(Ue,me,ke,We,at,(0,et.$XF)(Ue,"notebookMessaging")?pt:void 0)},registerNotebookCellStatusBarItemProvider:(me,ke)=>Je.registerNotebookCellStatusBarItemProvider(Ue,me,ke),createRendererMessaging(me){return xt.createRendererMessaging(Ue,me)},createNotebookControllerDetectionTask(me){return(0,et.$YF)(Ue,"notebookKernelSource"),Nt.createNotebookControllerDetectionTask(Ue,me)},registerKernelSourceActionProvider(me,ke){return(0,et.$YF)(Ue,"notebookKernelSource"),Nt.registerKernelSourceActionProvider(Ue,me,ke)},onDidChangeNotebookCellExecutionState(me,ke,We){return(0,et.$YF)(Ue,"notebookCellExecutionState"),ot(Nt.onDidChangeNotebookCellExecutionState)(me,ke,We)}},qi={t(...me){if(typeof me[0]=="string"){const ke=me.shift(),We=!me||typeof me[0]!="object"?me:me[0];return Ee.getMessage(Ue.identifier.value,{message:ke,args:We})}return Ee.getMessage(Ue.identifier.value,me[0])},get bundle(){return Ee.getBundle(Ue.identifier.value)},get uri(){return Ee.getBundleUri(Ue.identifier.value)}},Vi={_version:1,registerInteractiveEditorSessionProvider(me,ke){return(0,et.$YF)(Ue,"interactive"),gn.registerProvider(Ue,me,ke)},registerInteractiveSessionProvider(me,ke){return(0,et.$YF)(Ue,"interactive"),pi.registerChatProvider(Ue,me,ke)},sendInteractiveRequestToProvider(me,ke){return(0,et.$YF)(Ue,"interactive"),pi.sendInteractiveRequestToProvider(me,ke)},transferChatSession(me,ke){return(0,et.$YF)(Ue,"interactive"),pi.transferChatSession(me,ke)}},Hi={getRelatedInformation(me,ke){return(0,et.$YF)(Ue,"aiRelatedInformation"),ji.getRelatedInformation(Ue,me,ke)},registerRelatedInformationProvider(me,ke){return(0,et.$YF)(Ue,"aiRelatedInformation"),ji.registerRelatedInformationProvider(Ue,me,ke)},registerEmbeddingVectorProvider(me,ke){return(0,et.$YF)(Ue,"aiRelatedInformation"),en.registerEmbeddingVectorProvider(Ue,me,ke)}},Ci={registerChatResponseProvider(me,ke,We){return(0,et.$YF)(Ue,"chatProvider"),jt.registerLanguageModel(Ue,me,ke,We)},registerChatVariableResolver(me,ke,We){return(0,et.$YF)(Ue,"chatVariableResolver"),mn.registerVariableResolver(Ue,me,ke,We)},registerMappedEditsProvider(me,ke){return(0,et.$YF)(Ue,"mappedEditsProvider"),ht.registerMappedEditsProvider(Ue,me,ke)},createChatParticipant(me,ke){return(0,et.$YF)(Ue,"chatParticipant"),_i.createChatAgent(Ue,me,ke)}},Ki={get languageModels(){return(0,et.$YF)(Ue,"languageModels"),jt.getLanguageModelIds()},onDidChangeLanguageModels:(me,ke,We)=>((0,et.$YF)(Ue,"languageModels"),jt.onDidChangeProviders(me,ke,We)),sendChatRequest(me,ke,We,at){return(0,et.$YF)(Ue,"languageModels"),jt.sendChatRequest(Ue,me,ke,We,at)}},Gi={registerSpeechProvider(me,ke){return(0,et.$YF)(Ue,"speech"),Fi.registerProvider(Ue.identifier,me,ke)}};return{version:wt.version,ai:Hi,authentication:$n,commands:rn,comments:wn,chat:Ci,debug:pn,env:Bi,extensions:sn,interactive:Vi,l10n:qi,languages:Ui,lm:Ki,notebooks:un,scm:an,speech:Gi,tasks:cn,tests:bn,window:on,workspace:Wi,Breakpoint:Ne.$7M,TerminalOutputAnchor:Ne.TerminalOutputAnchor,ChatResultFeedbackKind:Ne.ChatResultFeedbackKind,ChatVariableLevel:Ne.ChatVariableLevel,ChatCompletionItem:Ne.$ZN,CallHierarchyIncomingCall:Ne.$tM,CallHierarchyItem:Ne.$sM,CallHierarchyOutgoingCall:Ne.$uM,CancellationError:j.$5,CancellationTokenSource:l.$ce,CandidatePortSource:n.CandidatePortSource,CodeAction:Ne.$pM,CodeActionKind:Ne.$qM,CodeActionTriggerKind:Ne.CodeActionTriggerKind,CodeLens:Ne.$vM,Color:Ne.$IM,ColorInformation:Ne.$JM,ColorPresentation:Ne.$KM,ColorThemeKind:Ne.ColorThemeKind,CommentMode:Ne.CommentMode,CommentState:Ne.CommentState,CommentThreadCollapsibleState:Ne.CommentThreadCollapsibleState,CommentThreadState:Ne.CommentThreadState,CompletionItem:Ne.$CM,CompletionItemKind:Ne.CompletionItemKind,CompletionItemTag:Ne.CompletionItemTag,CompletionList:Ne.$DM,CompletionTriggerKind:Ne.CompletionTriggerKind,ConfigurationTarget:Ne.ConfigurationTarget,CustomExecution:Ne.$SM,DebugAdapterExecutable:Ne.$$M,DebugAdapterInlineImplementation:Ne.$bN,DebugAdapterNamedPipeServer:Ne.$aN,DebugAdapterServer:Ne.$_M,DebugConfigurationProviderTriggerKind:_t.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Ne.DebugConsoleMode,DebugVisualization:Ne.$rN,DecorationRangeBehavior:Ne.DecorationRangeBehavior,Diagnostic:Ne.$jM,DiagnosticRelatedInformation:Ne.$iM,DiagnosticSeverity:Ne.DiagnosticSeverity,DiagnosticTag:Ne.DiagnosticTag,Disposable:Ne.$8L,DocumentHighlight:Ne.$lM,DocumentHighlightKind:Ne.DocumentHighlightKind,MultiDocumentHighlight:Ne.$mM,DocumentLink:Ne.$HM,DocumentSymbol:Ne.$oM,EndOfLine:Ne.EndOfLine,EnvironmentVariableMutatorType:Ne.EnvironmentVariableMutatorType,EvaluatableExpression:Ne.$eN,InlineValueText:Ne.$fN,InlineValueVariableLookup:Ne.$gN,InlineValueEvaluatableExpression:Ne.$hN,InlineCompletionTriggerKind:Ne.InlineCompletionTriggerKind,EventEmitter:L.$5d,ExtensionKind:Ne.ExtensionKind,ExtensionMode:Ne.ExtensionMode,ExternalUriOpenerPriority:Ne.ExternalUriOpenerPriority,FileChangeType:Ne.FileChangeType,FileDecoration:Ne.$tN,FileDecoration2:Ne.$tN,FileSystemError:Ne.$kN,FileType:k.FileType,FilePermission:k.FilePermission,FoldingRange:Ne.$lN,FoldingRangeKind:Ne.FoldingRangeKind,FunctionBreakpoint:Ne.$9M,InlineCompletionItem:Ne.$EM,InlineCompletionList:Ne.$FM,Hover:Ne.$kM,IndentAction:C.IndentAction,Location:Ne.$hM,MarkdownString:Ne.$wM,OverviewRulerLane:v.OverviewRulerLane,ParameterInformation:Ne.$xM,PortAutoForwardAction:Ne.PortAutoForwardAction,Position:Ne.$9L,ProcessExecution:Ne.$QM,ProgressLocation:Ne.ProgressLocation,QuickInputButtons:Ne.$sN,Range:Ne.$0L,RelativePattern:Ne.$5M,Selection:Ne.$$L,SelectionRange:Ne.$rM,SemanticTokens:Ne.$oN,SemanticTokensBuilder:Ne.$nN,SemanticTokensEdit:Ne.$pN,SemanticTokensEdits:Ne.$qN,SemanticTokensLegend:Ne.$mN,ShellExecution:Ne.$RM,ShellQuoting:Ne.ShellQuoting,SignatureHelp:Ne.$zM,SignatureHelpTriggerKind:Ne.SignatureHelpTriggerKind,SignatureInformation:Ne.$yM,SnippetString:Ne.$gM,SourceBreakpoint:Ne.$8M,StandardTokenType:Ne.StandardTokenType,StatusBarAlignment:Ne.StatusBarAlignment,SymbolInformation:Ne.$nM,SymbolKind:Ne.SymbolKind,SymbolTag:Ne.SymbolTag,Task:Ne.$TM,TaskGroup:Ne.$PM,TaskPanelKind:Ne.TaskPanelKind,TaskRevealKind:Ne.TaskRevealKind,TaskScope:Ne.TaskScope,TerminalLink:Ne.$LM,TerminalQuickFixTerminalCommand:Ne.$NM,TerminalQuickFixOpener:Ne.$MM,TerminalLocation:Ne.TerminalLocation,TerminalProfile:Ne.$OM,TerminalExitReason:Ne.TerminalExitReason,TextDocumentSaveReason:Ne.TextDocumentSaveReason,TextEdit:Ne.$cM,SnippetTextEdit:Ne.$eM,TextEditorCursorStyle:E.TextEditorCursorStyle,TextEditorLineNumbersStyle:Ne.TextEditorLineNumbersStyle,TextEditorRevealType:Ne.TextEditorRevealType,TextEditorSelectionChangeKind:Ne.TextEditorSelectionChangeKind,SyntaxTokenType:Ne.SyntaxTokenType,TextDocumentChangeReason:Ne.TextDocumentChangeReason,ThemeColor:Ne.$4M,ThemeIcon:Ne.$3M,TreeItem:Ne.$UM,TreeItemCheckboxState:Ne.TreeItemCheckboxState,TreeItemCollapsibleState:Ne.TreeItemCollapsibleState,TypeHierarchyItem:Ne.$ON,UIKind:ni.UIKind,Uri:w.URI,ViewColumn:Ne.ViewColumn,WorkspaceEdit:Ne.$fM,DocumentDropEdit:Ne.$1M,DocumentPasteEdit:Ne.$2M,InlayHint:Ne.$BM,InlayHintLabelPart:Ne.$AM,InlayHintKind:Ne.InlayHintKind,RemoteAuthorityResolverError:Ne.$bM,ResolvedAuthority:Ne.$_L,ManagedResolvedAuthority:Ne.$aM,SourceControlInputBoxValidationType:Ne.SourceControlInputBoxValidationType,ExtensionRuntime:Ne.ExtensionRuntime,TimelineItem:Ne.$DN,NotebookRange:Ne.$vN,NotebookCellKind:Ne.NotebookCellKind,NotebookCellExecutionState:Ne.NotebookCellExecutionState,NotebookCellData:Ne.$wN,NotebookData:Ne.$xN,NotebookRendererScript:Ne.$BN,NotebookCellStatusBarAlignment:Ne.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Ne.NotebookEditorRevealType,NotebookCellOutput:Ne.$zN,NotebookCellOutputItem:Ne.$yN,NotebookCellStatusBarItem:Ne.$AN,NotebookControllerAffinity:Ne.NotebookControllerAffinity,NotebookControllerAffinity2:Ne.NotebookControllerAffinity2,NotebookEdit:Ne.$dM,NotebookKernelSourceAction:Ne.$CN,NotebookVariablesRequestKind:Ne.NotebookVariablesRequestKind,PortAttributes:Ne.$FN,LinkedEditingRanges:Ne.$EN,TestResultState:Ne.TestResultState,TestRunRequest:Ne.$GN,TestMessage:Ne.$HN,TestTag:Ne.$IN,TestRunProfileKind:Ne.TestRunProfileKind,TextSearchCompleteMessageType:Bt.TextSearchCompleteMessageType,DataTransfer:Ne.$ZM,DataTransferItem:Ne.$VM,CoveredCount:Ne.$JN,FileCoverage:Ne.$KN,StatementCoverage:Ne.$LN,BranchCoverage:Ne.$MN,DeclarationCoverage:Ne.$NN,FunctionCoverage:Ne.$NN,WorkspaceTrustState:Ne.WorkspaceTrustState,LanguageStatusSeverity:Ne.LanguageStatusSeverity,QuickPickItemKind:Ne.QuickPickItemKind,InputBoxValidationSeverity:Ne.InputBoxValidationSeverity,TabInputText:Ne.$PN,TabInputTextDiff:Ne.$QN,TabInputTextMerge:Ne.$RN,TabInputCustom:Ne.$SN,TabInputNotebook:Ne.$UN,TabInputNotebookDiff:Ne.$VN,TabInputWebview:Ne.$TN,TabInputTerminal:Ne.$WN,TabInputInteractiveWindow:Ne.$XN,TabInputChat:Ne.$YN,TelemetryTrustedValue:o.$Zo,LogLevel:u.LogLevel,EditSessionIdentityMatch:i.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Ne.InteractiveSessionVoteDirection,ChatCopyKind:Ne.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Ne.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Ne.$cN,ThreadFocus:Ne.$dN,RelatedInformationType:Ne.RelatedInformationType,SpeechToTextStatus:Ne.SpeechToTextStatus,KeywordRecognitionStatus:Ne.KeywordRecognitionStatus,ChatResponseMarkdownPart:Ne.$1N,ChatResponseFileTreePart:Ne.$2N,ChatResponseAnchorPart:Ne.$3N,ChatResponseProgressPart:Ne.$4N,ChatResponseReferencePart:Ne.$6N,ChatResponseCommandButtonPart:Ne.$5N,ChatRequestTurn:Ne.$7N,ChatResponseTurn:Ne.$8N,LanguageModelChatSystemMessage:Ne.$9N,LanguageModelChatUserMessage:Ne.$0N,LanguageModelChatAssistantMessage:Ne.$$N,LanguageModelSystemMessage:Ne.$9N,LanguageModelUserMessage:Ne.$0N,LanguageModelAssistantMessage:Ne.$$N,LanguageModelError:Ne.$_N,NewSymbolName:Ne.$jN,NewSymbolNameTag:Ne.NewSymbolNameTag,InlineEdit:Ne.$aO,InlineEditTriggerKind:Ne.InlineEditTriggerKind}}}e.$Wjc=ei}),define(Se[376],De([1,0,83,156,41,151,42,33,71,46,95,96,97,118,69,91,150,68,59,117,90,70,149,12,60,115,116,120,121]),function(fe,e,l,j,L,A,R,p,w,E,M,C,v,S,k,u,m,o,i,n,s,c,t,f,h,r,a,d,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,l.$as)(r.$Lic,r.$Kic,1),(0,l.$as)(f.$Aj,t.$Xjc,1),(0,l.$as)(u.$Phc,u.$Qhc,1),(0,l.$as)(p.$HO,p.$GO,0),(0,l.$as)(d.$Zhc,d.$1hc,0),(0,l.$as)($.$5hc,$.$6hc,0),(0,l.$as)(R.$fic,R.$dic,0),(0,l.$as)(o.$hic,o.$gic,0),(0,l.$as)(C.$Vic,C.$Zic,0),(0,l.$as)(A.$2ic,A.$1ic,0),(0,l.$as)(w.$wO,w.$vO,0),(0,l.$as)(a.$Mic,a.$Nic,0),(0,l.$as)(i.$Thc,i.$Shc,0),(0,l.$as)(j.$vjc,j.$ujc,1),(0,l.$as)(v.$fjc,v.$gjc,0),(0,l.$as)(S.$Aic,S.$zic,0),(0,l.$as)(M.$Ijc,M.$Hjc,0),(0,l.$as)(E.$Dic,E.$Gic,0),(0,l.$as)(k.$zAb,k.$AAb,0),(0,l.$as)(m.$Vjc,m.$Ujc,0),(0,l.$as)(L.$cic,L.$bic,0),(0,l.$as)(n.$Iic,n.$Hic,0),(0,l.$as)(s.$FO,s.$CO,0),(0,l.$as)(c.$ric,c.$sic,0),(0,l.$as)(h.$Tic,h.$Uic,0)}),define(Se[122],De([1,0,19,12,36,94]),function(fe,e,l,j,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dkc=e.$ckc=e.$bkc=void 0;function R(C){return C.startsWith("**")||C.startsWith("/")?C:`/${C}`}e.$bkc=R;function p(C,v,S,k){const u=(0,l.$2b)(S,w),m=new L.$rK(v,u,k),o=m.preview.matches;return{ranges:(0,l.$2b)(u,E),uri:C,preview:{text:m.preview.text,matches:(0,l.$2b)(o,E)}}}e.$ckc=p;function w(C){return new L.$sK(C.start.line,C.start.character,C.end.line,C.end.character)}function E(C){return new A.$gK(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn)}let M=class{constructor(v,S){this.a=v,this.b=S}appendLine(v){this.b.debug(`${this.a}#search`,v)}};e.$dkc=M,e.$dkc=M=Ye([Ve(1,j.$zj)],M)}),define(Se[377],De([1,0,51,17,75,34,11,14,122,378]),function(fe,e,l,j,L,A,R,p,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gkc=e.$fkc=e.$ekc=void 0;const M=E.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function C(n,s,c,t){const f=v(n,s,c,t),h=s.folder.fsPath;return{cmd:l.spawn(M,f.args,{cwd:h}),rgDiskPath:M,siblingClauses:f.siblingClauses,rgArgs:f,cwd:h}}e.$ekc=C;function v(n,s,c,t){const f=["--files","--hidden","--case-sensitive","--no-require-git"];k([s],c,!1).forEach(r=>{const a=(0,w.$bkc)(r);if(f.push("-g",a),R.$j){const d=(0,L.$Rl)(a);d!==a&&f.push("-g",d)}});const h=S([s],t,void 0,!1);return h.globArgs.forEach(r=>{const a=`!${(0,w.$bkc)(r)}`;if(f.push("-g",a),R.$j){const d=(0,L.$Rl)(a);d!==a&&f.push("-g",d)}}),s.disregardIgnoreFiles!==!1?f.push("--no-ignore"):s.disregardParentIgnoreFiles!==!1&&f.push("--no-ignore-parent"),s.ignoreSymlinks||f.push("--follow"),n.exists&&f.push("--quiet"),f.push("--no-config"),s.disregardGlobalIgnoreFiles&&f.push("--no-ignore-global"),{args:f,siblingClauses:h.siblingClauses}}function S(n,s,c,t=!0){const f=[];let h={};return n.forEach(r=>{const a=Object.assign({},r.excludePattern||{},s||{}),d=u(a,t?r.folder.fsPath:void 0,c);f.push(...d.globArgs),d.siblingClauses&&(h=Object.assign(h,d.siblingClauses))}),{globArgs:f,siblingClauses:h}}function k(n,s,c=!0){const t=[];return n.forEach(f=>{const h=Object.assign({},s||{},f.includePattern||{}),r=u(h,c?f.folder.fsPath:void 0);t.push(...r.globArgs)}),t}function u(n,s,c){const t=[],f={};return Object.keys(n).forEach(h=>{if(c&&c.has(h)||!h)return;const r=n[h];h=o(s?m(s,h):h),h.startsWith("\\\\")?h="\\\\"+h.substr(2).replace(/\\/g,"/"):h=h.replace(/\\/g,"/"),typeof r=="boolean"&&r?(h.startsWith("\\\\")&&(h+="**"),t.push(i(h))):r&&r.when&&(f[h]=r)}),{globArgs:t,siblingClauses:f}}function m(n,s){return j.$ic(s)?s:j.$jc(n,s)}e.$fkc=m;function o(n){return n=p.$4e(n,"\\"),p.$4e(n,"/")}function i(n){return A.$bg(n).toLowerCase()==="c:/"?n.replace(/^c:[/\\]/i,"/"):n}e.$gkc=i}),define(Se[379],De([1,0,51,57,17,380,19,44,35,75,34,11,38,14,18,31,36,377,132]),function(fe,e,l,j,L,A,R,p,w,E,M,C,v,S,k,u,m,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ikc=e.$hkc=void 0;const n=new Set;process.on("exit",()=>{n.forEach(h=>h())});class s{constructor(r){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=r,this.b=r.filePattern||"",this.d=r.includePattern&&w.$Yj(r.includePattern),this.f=r.maxResults||null,this.g=!!r.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=r.shouldGlobMatchFilePattern?null:(0,i.$br)(this.b).normalizedLowercase),this.u=r.excludePattern&&w.$Yj(r.excludePattern),this.t=new Map,r.folderQueries.forEach(a=>{const d=Object.assign({},a.excludePattern||{},this.a.excludePattern||{}),$=a.folder.fsPath;r.folderQueries.map(D=>D.folder.fsPath).filter(D=>D!==$).forEach(D=>{(0,M.$fg)(D,$)&&(d[L.$lc($,D)]=!0)}),this.t.set($,new t(d,$))})}cancel(){this.l=!0,n.forEach(r=>r())}walk(r,a,d,$,D){if(this.m=v.$1d.create(!1),this.l)return D(null,this.j);a.forEach(b=>{const g=L.$nc(b.fsPath);this.u&&this.u(b.fsPath,g)||this.J(d,{relativePath:b.fsPath,searchPath:void 0})}),this.r=v.$1d.create(!1),this.w(r,(b,g)=>{this.x(this.y,this,b,d,$,y=>{if(y){const P=(0,p.$3i)(y);console.error(P),this.q.push(P),g(y,void 0)}else g(null,void 0)})},(b,g)=>{this.m.stop();const y=b?R.$Hb(b)[0]:null;D(y,this.j)})}w(r,a,d){const $=new Array(r.length),D=new Array(r.length);let b=!1,g=0;if(r.length===0)return d(null,[]);r.forEach((y,P)=>{a(y,(N,U)=>{if(N?(b=!0,$[P]=null,D[P]=N):($[P]=U,D[P]=null),++g===r.length)return d(b?D:null,$)})})}x(r,a,...d){try{r.apply(a,d)}catch($){d[d.length-1]($)}}y(r,a,d,$){const D=r.folder.fsPath,b=C.$j,g=()=>z&&z.kill();n.add(g);let y=T=>{n.delete(g),y=()=>{},$(T)},P="";const N=this.D(),U=(0,o.$ekc)(this.a,r,this.a.includePattern,this.t.get(r.folder.fsPath).expression),z=U.cmd,F=!Object.keys(U.siblingClauses).length,I=U.rgArgs.args.map(T=>T.match(/^-/)?T:`'${T}'`).join(" ");let O=`${U.rgDiskPath} ${I}
 - cwd: ${U.cwd}`;U.rgArgs.siblingClauses&&(O+=`
 - Sibling clauses: ${JSON.stringify(U.rgArgs.siblingClauses)}`),d({message:O}),this.s=0,this.z(z,"utf8",d,(T,G,te)=>{if(T){y(T);return}if(this.j){y();return}const X=(P+(b?E.$Ql(G||""):G)).split(`
`);if(te){const Q=X.length;X[Q-1]=X[Q-1].trim(),X[Q-1]||X.pop()}else P=X.pop()||"";if(X.length&&X[0].indexOf(`
`)!==-1){y(new Error("Splitting up files failed"));return}if(this.s+=X.length,F){for(const Q of X)if(this.J(a,{base:D,relativePath:Q,searchPath:this.N(r,Q)}),this.j){g();break}(te||this.j)&&y();return}this.G(r,N,D,X,a),te&&(this.H(N,D,a),y())})}spawnFindCmd(r){const a=this.t.get(r.folder.fsPath),d=a.getBasenameTerms(),$=a.getPathTerms(),D=["-L","."];if(d.length||$.length){D.push("-not","(","(");for(const b of d)D.push("-name",b),D.push("-o");for(const b of $)D.push("-path",b),D.push("-o");D.pop(),D.push(")","-prune",")")}return D.push("-type","f"),l.spawn("find",D,{cwd:r.folder.fsPath})}readStdout(r,a,d){let $="";this.z(r,a,()=>{},(D,b,g)=>{if(D){d(D);return}$+=b,g&&d(null,$)})}z(r,a,d,$){let D=(y,P,N)=>{(y||N)&&(D=()=>{},this.r?.stop()),$(y,P,N)},b=!1;r.stdout?(this.A(r.stdout,a,D),r.stdout.once("data",()=>b=!0)):d({message:"stdout is null"});let g;r.stderr?g=this.B(r.stderr):d({message:"stderr is null"}),r.on("error",y=>{D(y)}),r.on("close",y=>{let P;!b&&(P=this.C(g,a))&&f(P)?D(new Error(`command failed with error code ${y}: ${this.C(g,a)}`)):(this.g&&y===0&&(this.j=!0),D(null,"",!0))})}A(r,a,d){const $=new A.StringDecoder(a);return r.on("data",D=>{d(null,$.write(D))}),$}B(r){const a=[];return r.on("data",d=>{a.push(d)}),a}C(r,a){const d=new A.StringDecoder(a);return r.map($=>d.write($)).join("")}D(){const r={rootEntries:[],pathToEntries:Object.create(null)};return r.pathToEntries["."]=r.rootEntries,r}G(r,{pathToEntries:a},d,$,D){$.indexOf(this.b)!==-1&&this.J(D,{base:d,relativePath:this.b,searchPath:this.N(r,this.b)});const b=g=>{const y=L.$nc(g),P=L.$mc(g);let N=a[P];N||(N=a[P]=[],b(P)),N.push({base:d,relativePath:g,basename:y,searchPath:this.N(r,g)})};$.forEach(b)}H({rootEntries:r,pathToEntries:a},d,$){const D=this,b=this.t.get(d),g=this.b;function y(P){D.o++;const N=(0,m.$HK)(()=>P.map(U=>U.basename));for(let U=0,z=P.length;U<z;U++){const F=P[U],{relativePath:I,basename:O}=F;if(b.test(I,O,g!==O?N:void 0))continue;const T=a[I];if(T)y(T);else{if(D.p++,I===g)continue;D.J($,F)}if(D.j)break}}y(r)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(r,a,d,$,D){const b=r.folder,g=(0,m.$HK)(()=>d);this.w(d,(y,P)=>{if(this.l||this.j)return P(null);const N=a?[a,y].join(L.sep):y;if(this.t.get(r.folder.fsPath).test(N,y,this.a.filePattern!==y?g:void 0))return P(null);const U=[b.fsPath,N].join(L.sep);j.lstat(U,(z,F)=>{if(z||this.l||this.j)return P(null);this.L(U,F,(I,O)=>I||this.l||this.j?P(null):O.isDirectory()?(this.o++,this.M(U,F,(T,G)=>T||this.l||this.j||(G=G||"",this.v[G])?P(null):(this.v[G]=!0,u.Promises.readdir(U).then(te=>{if(this.l||this.j)return P(null);this.I(r,N,te,$,x=>P(x||null))},te=>{P(null)})))):(this.p++,N===this.b||this.h&&k.$Wf(O.size)&&O.size>this.h||this.J($,{base:b.fsPath,relativePath:N,searchPath:this.N(r,N)}),P(null,void 0)))})},y=>{const P=y&&R.$Hb(y);return D(P&&P.length>0?P[0]:void 0)})}J(r,a){this.K(a)&&(!this.d||this.d(a.relativePath,L.$nc(a.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||r(a))}K(r){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,m.$CK)(r,this.c);if(this.b)return(0,m.$CK)(r,this.b,!1)}return!0}L(r,a,d){return a.isSymbolicLink()?j.stat(r,d):d(null,a)}M(r,a,d){return a.isSymbolicLink()?j.realpath(r,($,D)=>$?d($):d(null,D)):d(null,r)}N(r,a){return r.folderName?L.$jc(r.folderName,a):a}}e.$hkc=s;class c{constructor(r){this.a=r.folderQueries,this.b=r.extraFileResources||[],this.c=new s(r)}search(r,a,d){this.c.walk(this.a,this.b,r,a,($,D)=>{d($,{limitHit:D,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$ikc=c;class t{constructor(r,a){this.expression=r,this.c=a,this.d(r)}d(r){let a,d;Object.keys(r).filter($=>r[$]).forEach($=>{L.$ic($)?(a=a||w.$Tj(),a[$]=r[$]):(d=d||w.$Tj(),d[$]=r[$])}),this.a=a&&w.$Yj(a,{trimForExclusions:!0}),this.b=d&&w.$Yj(d,{trimForExclusions:!0})}test(r,a,d){return this.b&&this.b(r,a,d)||this.a&&this.a(L.$jc(this.c,r),a,d)}getBasenameTerms(){const r=[];return this.a&&r.push(...w.$1j(this.a)),this.b&&r.push(...w.$1j(this.b)),r}getPathTerms(){const r=[];return this.a&&r.push(...w.$2j(this.a)),this.b&&r.push(...w.$2j(this.b)),r}}function f(h){const r=h.trim().split(`
`),a=r[0].trim();if(a.startsWith("Error parsing regex"))return a;if(a.startsWith("regex parse error"))return S.$Kf(r[r.length-1].trim());if(a.startsWith("error parsing glob")||a.startsWith("unsupported encoding"))return a.charAt(0).toUpperCase()+a.substr(1);if(a==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(a.startsWith("Literal "))return a}}),define(Se[381],De([1,0,98,21,191,22]),function(fe,e,l,j,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ND=e.$MD=e.$LD=e.$KD=e.$JD=e.$ID=e.$HD=e.$GD=e.$FD=e.DecodeStreamErrorKind=e.$ED=e.$DD=e.$CD=e.$BD=e.$AD=e.$zD=e.$yD=e.$xD=void 0,e.$xD="utf8",e.$yD="utf8bom",e.$zD="utf16be",e.$AD="utf16le";function R(a){return[e.$xD,e.$yD,e.$zD,e.$AD].some(d=>d===a)}e.$BD=R,e.$CD=[254,255],e.$DD=[255,254],e.$ED=[239,187,191];const p=512,w=512,E=512*8,M=512*128;var C;(function(a){a[a.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(C||(e.DecodeStreamErrorKind=C={}));class v extends Error{constructor(d,$){super(d),this.decodeStreamErrorKind=$}}e.$FD=v;class S{static async create(d){let $;if(d!==e.$xD)$=(await(0,L.$wD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(o(d));else{const D=new TextDecoder;$={write(b){return D.decode(b,{stream:!0})},end(){return D.decode()}}}return new S($)}constructor(d){this.a=d}write(d){return this.a.write(d)}end(){return this.a.end()}}function k(a,d){const $=d.minBytesRequiredForDetection??d.guessEncoding?E:w;return new Promise((D,b)=>{const g=(0,l.$ge)(F=>F.join("")),y=[];let P=0,N;const U=new A.$ce,z=async()=>{try{const F=await r({buffer:j.$se.concat(y),bytesRead:P},d.guessEncoding);if(F.seemsBinary&&d.acceptTextOnly)throw new v("Stream is binary but only text is accepted for decoding",1);F.encoding=await d.overwriteEncoding(F.encoding),N=await S.create(F.encoding);const I=N.write(j.$se.concat(y).buffer);g.write(I),y.length=0,P=0,D({stream:g,detected:F})}catch(F){U.cancel(),g.destroy(),b(F)}};(0,l.$ke)(a,{onData:async F=>{N?g.write(N.write(F.buffer)):(y.push(F),P+=F.byteLength,P>=$&&(a.pause(),await z(),setTimeout(()=>a.resume())))},onError:F=>g.error(F),onEnd:async()=>{N||await z(),g.end(N?.end())}},U.token)})}e.$GD=k;async function u(a,d,$){const b=(await(0,L.$wD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(o(d),$);let g=!1,y=!1;return{read(){if(y)return null;const P=a.read();if(typeof P!="string"){if(y=!0,!g&&$?.addBOM)switch(d){case e.$xD:case e.$yD:return j.$se.wrap(Uint8Array.from(e.$ED));case e.$zD:return j.$se.wrap(Uint8Array.from(e.$CD));case e.$AD:return j.$se.wrap(Uint8Array.from(e.$DD))}const N=b.end();return N&&N.length>0?(g=!0,j.$se.wrap(N)):null}return g=!0,j.$se.wrap(b.write(P))}}}e.$HD=u;async function m(a){return(await(0,L.$wD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(o(a))}e.$ID=m;function o(a){return a===e.$yD||a===null?e.$xD:a}e.$JD=o;function i(a,d){if(!a||d<e.$CD.length)return null;const $=a.readUInt8(0),D=a.readUInt8(1);if($===e.$CD[0]&&D===e.$CD[1])return e.$zD;if($===e.$DD[0]&&D===e.$DD[1])return e.$AD;if(d<e.$ED.length)return null;const b=a.readUInt8(2);return $===e.$ED[0]&&D===e.$ED[1]&&b===e.$ED[2]?e.$yD:null}e.$KD=i;const n=["ascii","utf-16","utf-32"];async function s(a){const d=await(0,L.$wD)("jschardet","dist/jschardet.min.js"),$=a.slice(0,M),D=f($.buffer),b=d.detect(D);if(!b||!b.encoding)return null;const g=b.encoding.toLowerCase();return 0<=n.indexOf(g)?null:t(b.encoding)}const c={ibm866:"cp866",big5:"cp950"};function t(a){const d=a.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return c[d]||d}function f(a){let d="";for(let $=0;$<a.length;$++)d+=String.fromCharCode(a[$]);return d}function h(a){switch(a){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const d=a.match(/windows(\d+)/);return d?"windows-"+d[1]:a}}}e.$LD=h;function r({buffer:a,bytesRead:d},$){let D=i(a,d),b=!1;if(D!==e.$zD&&D!==e.$AD&&a){let g=!0,y=!0,P=!1;for(let N=0;N<d&&N<p;N++){const U=N%2===1,z=a.readUInt8(N)===0;if(z&&(P=!0),g&&(U&&!z||!U&&z)&&(g=!1),y&&(U&&z||!U&&!z)&&(y=!1),z&&!g&&!y)break}P&&(g?D=e.$AD:y?D=e.$zD:b=!0)}return $&&!b&&!D&&a?s(a.slice(0,d)).then(g=>({seemsBinary:!1,encoding:g})):{seemsBinary:b,encoding:D}}e.$MD=r,e.$ND={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(Se[159],De([1,0,381,31,158]),function(fe,e,l,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qkc=void 0;class A extends L.$bjc{constructor(p,w,E=j,M="searchProcess"){super({query:p,provider:w},{readdir:C=>E.Promises.readdir(C.fsPath),toCanonicalName:C=>(0,l.$LD)(C)},M)}}e.$qkc=A}),define(Se[160],De([1,0,51,397,380,19,72,35,14,2,36,94,398,378,122]),function(fe,e,l,j,L,A,R,p,w,E,M,C,v,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pkc=e.$okc=e.$nkc=e.$mkc=e.$lkc=e.$kkc=e.$jkc=void 0;const u=S.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class m{constructor(g){this.a=g}provideTextSearchResults(g,y,P,N){return this.a.appendLine(`provideTextSearchResults ${g.pattern}, ${JSON.stringify({...y,folder:y.folder.toString()})}`),new Promise((U,z)=>{N.onCancellationRequested(()=>X());const F=t(g,y),I=y.folder.fsPath,O=F.map(se=>se.match(/^-/)?se:`'${se}'`).join(" ");this.a.appendLine(`${u} ${O}
 - cwd: ${I}`);let T=l.spawn(u,F,{cwd:I});T.on("error",se=>{console.error(se),this.a.appendLine("Error: "+(se&&se.message)),z((0,M.$yK)(new M.$wK(se&&se.message,M.SearchErrorCode.rgProcessError)))});let G=!1;const te=new n(y.maxResults,y.folder,y.previewOptions);te.on("result",se=>{G=!0,ae="",P.report(se)});let x=!1;const X=()=>{x=!0,T?.kill(),te?.cancel()};let Q=!1;te.on("hitLimit",()=>{Q=!0,X()});let ae="";T.stdout.on("data",se=>{te.handleData(se),G||(ae+=se)});let _=!1;T.stdout.once("data",()=>_=!0);let ge="";T.stderr.on("data",se=>{const re=se.toString();this.a.appendLine(re),ge.length+re.length<1e6&&(ge+=re)}),T.on("close",()=>{if(this.a.appendLine(_?"Got data from stdout":"No data from stdout"),this.a.appendLine(G?"Got result from parser":"No result from parser"),ae&&this.a.appendLine(`Got data without result: ${ae}`),this.a.appendLine(""),x)U({limitHit:Q});else{te.flush(),T=null;let se;ge&&!_&&(se=o(ge))?z((0,M.$yK)(new M.$wK(se.message,se.code))):U({limitHit:Q})}})})}}e.$jkc=m;function o(b){const g=b.split(`
`),y=g[0].trim();if(g.some(N=>N.startsWith("regex parse error")))return new M.$wK(i(g),M.SearchErrorCode.regexParseError);const P=y.match(/grep config error: unknown encoding: (.*)/);if(P)return new M.$wK(`Unknown encoding: ${P[1]}`,M.SearchErrorCode.unknownEncoding);if(y.startsWith("error parsing glob"))return new M.$wK(y.charAt(0).toUpperCase()+y.substr(1),M.SearchErrorCode.globParseError);if(y.startsWith("the literal"))return new M.$wK(y.charAt(0).toUpperCase()+y.substr(1),M.SearchErrorCode.invalidLiteral);if(y.startsWith("PCRE2: error compiling pattern"))return new M.$wK(y,M.SearchErrorCode.regexParseError)}function i(b){const g=["Regex parse error"],y=b.filter(P=>P.startsWith("PCRE2:"));if(y.length>=1){const P=y[0].replace("PCRE2:","");if(P.indexOf(":")!==-1&&P.split(":").length>=2){const N=P.split(":")[1];g.push(":"+N)}}return g.join("")}class n extends j.EventEmitter{constructor(g,y,P){super(),this.g=g,this.h=y,this.j=P,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new L.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(g,y){return super.on(g,y),this}handleData(g){if(this.b)return;const y=typeof g=="string"?g:this.d.write(g);this.k(y)}k(g){let y=g.indexOf(`
`);const P=this.a+g;if(y>=0)y+=this.a.length;else{this.a=P;return}let N=0;for(;y>=0;)this.m(P.substring(N,y).trim()),N=y+1,y=P.indexOf(`
`,N);this.a=P.substring(N)}m(g){if(this.b||!g)return;let y;try{y=JSON.parse(g)}catch{throw new Error(`malformed line from rg: ${g}`)}if(y.type==="match"){const P=s(y.data.path),N=E.URI.joinPath(this.h,P),U=this.n(y.data,N);this.p(U),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(y.type==="context"){const P=s(y.data.path),N=E.URI.joinPath(this.h,P);this.o(y.data,N).forEach(z=>this.p(z))}}n(g,y){const P=g.line_number-1,N=s(g.lines),U=Buffer.from(N);let z=0,F=0,I=P;g.submatches.length===0&&g.submatches.push(N.length?{start:0,end:1,match:{text:N[0]}}:{start:0,end:0,match:{text:""}});const O=(0,A.$Hb)(g.submatches.map((T,G)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const te=s(T.match),x=U.slice(z,T.start).toString(),X=c(x),Q=X.numLines>0?X.lastLineLength:X.lastLineLength+F,ae=c(te),_=X.numLines+I,ge=ae.numLines+_,se=ae.numLines>0?ae.lastLineLength:ae.lastLineLength+Q;return z=T.end,F=se,I=ge,new C.$gK(_,Q,ge,se)}));return(0,k.$ckc)(y,N,O,this.j)}o(g,y){const P=s(g.lines),N=g.line_number;return P.replace(/\r?\n$/,"").split(`
`).map((U,z)=>({text:U,uri:y,lineNumber:N+z}))}p(g){this.emit("result",g)}}e.$kkc=n;function s(b){return b.bytes?Buffer.from(b.bytes,"base64").toString():b.text}function c(b){const g=/\n/g;let y=0,P=-1,N;for(;N=g.exec(b);)y++,P=N.index;const U=P>=0?b.length-P-1:b.length;return{numLines:y,lastLineLength:U}}function t(b,g){const y=["--hidden","--no-require-git"];y.push(b.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:P,otherIncludes:N}=(0,R.$K)(g.includes,z=>z.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(N&&N.length){const z=new Set;N.forEach(F=>{z.add(F)}),y.push("-g","!*"),z.forEach(F=>{f(F).map(k.$bkc).forEach(I=>{y.push("-g",I)})})}P&&P.length&&P.forEach(z=>{y.push("-g",z)}),g.excludes.map(k.$bkc).forEach(z=>y.push("-g",`!${z}`)),g.maxFileSize&&y.push("--max-filesize",g.maxFileSize+""),g.useIgnoreFiles?g.useParentIgnoreFiles||y.push("--no-ignore-parent"):y.push("--no-ignore"),g.followSymlinks&&y.push("--follow"),g.encoding&&g.encoding!=="utf8"&&y.push("--encoding",g.encoding),b.pattern==="--"&&(b.isRegExp=!0,b.pattern="\\-\\-"),b.isMultiline&&!b.isRegExp&&(b.pattern=(0,w.$Xe)(b.pattern),b.isRegExp=!0),g.usePCRE2&&y.push("--pcre2"),y.push("--crlf"),b.isRegExp&&(b.pattern=h(b.pattern),y.push("--engine","auto"));let U;if(b.isWordMatch){const F=(0,w.$7e)(b.pattern,!!b.isRegExp,{wholeWord:b.isWordMatch}).source.replace(/\\\//g,"/");y.push("--regexp",F)}else if(b.isRegExp){let z=a(b.pattern);z=d(z),y.push("--regexp",z)}else U=b.pattern,y.push("--fixed-strings");return y.push("--no-config"),g.useGlobalIgnoreFiles||y.push("--no-ignore-global"),y.push("--json"),b.isMultiline&&y.push("--multiline"),g.beforeContext&&y.push("--before-context",g.beforeContext+""),g.afterContext&&y.push("--after-context",g.afterContext+""),y.push("--"),U&&y.push(U),y.push("."),y}e.$lkc=t;function f(b){return D(b).flatMap(y=>{const P=(0,p.$Wj)(y,"/");return P.map((N,U)=>P.slice(0,U+1).join("/"))})}function h(b){const g=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;b.match(g);)b=b.replace(g,"$1\\x{$2}");const y=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;b.match(y);)b=b.replace(y,"$1\\x{$2}");return b}e.$mkc=h;const r=b=>b.type==="Assertion"&&b.kind==="lookbehind";function a(b){let g;try{g=new v.RegExpParser().parsePattern(b)}catch{return b}let y="",P=0;const N=(F,I,O)=>{y+=b.slice(P,F)+O,P=I},U=[];return new v.RegExpVisitor({onCharacterEnter(F){if(F.raw!=="\\n")return;const I=U[0];if(!I)N(F.start,F.end,"\\r?\\n");else if(!U.some(r))if(I.type==="CharacterClass")if(I.negate){const O=b.slice(I.start+2,F.start)+b.slice(F.end,I.end-1);I.parent?.type==="Quantifier"?N(I.start,I.end,O?`[^${O}]`:"."):N(I.start,I.end,"(?!\\r?\\n"+(O?`|[${O}]`:"")+")")}else{const O=b.slice(I.start+1,F.start)+b.slice(F.end,I.end-1);N(I.start,I.end,O===""?"\\r?\\n":`(?:[${O}]|\\r?\\n)`)}else I.type==="Quantifier"&&N(F.start,F.end,"(?:\\r?\\n)")},onQuantifierEnter(F){U.unshift(F)},onQuantifierLeave(){U.shift()},onCharacterClassRangeEnter(F){U.unshift(F)},onCharacterClassRangeLeave(){U.shift()},onCharacterClassEnter(F){U.unshift(F)},onCharacterClassLeave(){U.shift()},onAssertionEnter(F){r(F)&&U.push(F)},onAssertionLeave(F){U[0]===F&&U.shift()}}).visit(g),y+=b.slice(P),y}e.$nkc=a;function d(b){return b.replace(/\n/g,"\\r?\\n")}e.$okc=d;function $(b){let g=!1,y=!1,P="",N="";for(let U=0;U<b.length;U++){const z=b[U];switch(z){case"\\":y?(g?N+="\\"+z:P+="\\"+z,y=!1):y=!0;break;case"{":if(y)g?N+=z:P+=z,y=!1;else{if(g)return{strInBraces:P+"{"+N+"{"+b.substring(U+1)};g=!0}break;case"}":if(y)g?N+=z:P+=z,y=!1;else{if(g)return{fixedStart:P,strInBraces:N,fixedEnd:b.substring(U+1)};P+=z}break;default:g?N+=(y?"\\":"")+z:P+=(y?"\\":"")+z,y=!1;break}}return{strInBraces:P+(g?"{"+N:"")}}function D(b){const{fixedStart:g,strInBraces:y,fixedEnd:P}=$(b);if(g===void 0||P===void 0)return[y];let N=(0,p.$Wj)(y,",");N.length||(N=[""]);const U=D(P);return N.flatMap(z=>{const F=g+z;return U.map(I=>F+I)})}e.$pkc=D}),define(Se[382],De([1,0,22,160,108,15]),function(fe,e,l,j,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tkc=void 0;class R{constructor(E){this.b=E,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(E,M,C,v){const S=new j.$jkc(this.b);if(M.folder.scheme===A.Schemas.vscodeUserData){const k={...M,folder:M.folder.with({scheme:A.Schemas.file})},u=new L.$Kv(m=>C.report({...m,uri:m.uri.with({scheme:M.folder.scheme})}));return this.c(v,m=>S.provideTextSearchResults(E,k,u,m))}else return this.c(v,k=>S.provideTextSearchResults(E,M,C,k))}async c(E,M){const C=p(E);this.a.add(C);const v=await M(C.token);return this.a.delete(C),v}d(){this.a.forEach(E=>E.cancel())}}e.$tkc=R;function p(w){const E=new l.$ce;return w.onCancellationRequested(()=>E.cancel()),E}}),define(Se[383],De([1,0,31,160,159]),function(fe,e,l,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rkc=void 0;class A{constructor(w){this.a=w}search(w,E,M){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const C={appendLine(S){M({message:S})}},v=new L.$qkc(this.a,new j.$jkc(C),l);return new Promise((S,k)=>v.search(u=>{E(u.map(R))},w).then(u=>S({limitHit:u.limitHit,type:"success",stats:u.stats}),k))}}e.$rkc=A;function R(p){return{path:p.resource&&p.resource.fsPath,results:p.results,numMatches:(p.results||[]).reduce((w,E)=>{if(E.ranges){const M=E;return w+(Array.isArray(M.ranges)?M.ranges.length:1)}else return w+1},0)}}}),define(Se[384],De([1,0,19,8,13,4,132,17,38,2,32,36,379,383]),function(fe,e,l,j,L,A,R,p,w,E,M,C,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$skc=void 0;class k{static{this.a=512}constructor(s="searchProcess"){this.d=s,this.b=Object.create(null)}fileSearch(s){let c;const t=o(s),f=new A.$5d({onDidAddFirstListener:()=>{c=(0,j.$5g)(h=>this.doFileSearchWithEngine(v.$ikc,t,r=>f.fire(r),h)),c.then(h=>f.fire(h),h=>f.fire({type:"error",error:{message:h.message,stack:h.stack}}))},onDidRemoveLastListener:()=>{c.cancel()}});return f.event}textSearch(s){let c;const t=o(s),f=new A.$5d({onDidAddFirstListener:()=>{c=(0,j.$5g)(h=>this.f(t,r=>f.fire(r),h)),c.then(h=>f.fire(h),h=>f.fire({type:"error",error:{message:h.message,stack:h.stack}}))},onDidRemoveLastListener:()=>{c.cancel()}});return f.event}f(s,c,t){return s.maxFileSize=this.g().maxFileSize,new S.$rkc(s).search(t,c,c)}g(){return{maxFileSize:16*M.$bl.GB}}doFileSearch(s,c,t){return this.doFileSearchWithEngine(v.$ikc,s,c,t)}doFileSearchWithEngine(s,c,t,f,h=k.a){let r=0;const a=$=>{Array.isArray($)?(r+=$.length,t($.map(D=>this.h(D)))):$.relativePath?(r++,t(this.h($))):t($)};if(c.sortByScore){let $=this.l(c,a,f);if(!$){const D=c.maxResults?Object.assign({},c,{maxResults:null}):c,b=new s(D);$=this.j(b,c,t,a,f)}return new Promise((D,b)=>{$.then(([g,y])=>{const P=y.map(N=>this.h(N));this.o(P,t,h),D(g)},b)})}const d=new s(c);return this.r(d,a,h,f).then($=>({limitHit:$.limitHit,type:"success",stats:{detailStats:$.stats,type:this.d,fromCache:!1,resultCount:r,sortingTime:void 0}}))}h(s){return{path:s.base?(0,p.$jc)(s.base,s.relativePath):s.relativePath}}j(s,c,t,f,h){const r=new A.$5d;let a=(0,j.$5g)($=>{let D=[];const b=g=>{Array.isArray(g)?D=g:(f(g),r.fire(g))};return this.r(s,b,-1,$).then(g=>[g,D])}),d;if(c.cacheKey){d=this.k(c.cacheKey);const $={promise:a,event:r.event,resolved:!1};d.resultsToSearchCache[c.filePattern||""]=$,a.then(()=>{$.resolved=!0},D=>{delete d.resultsToSearchCache[c.filePattern||""]}),a=this.s(a)}return a.then(([$,D])=>{const b=d?d.scorerCache:Object.create(null),g=(typeof c.maxResults!="number"||c.maxResults>0)&&w.$1d.create(!1);return this.n(c,D,b,h).then(y=>{const P=g?g.elapsed():-1;return[{type:"success",stats:{detailStats:$.stats,sortingTime:P,fromCache:!1,type:this.d,workspaceFolderCount:c.folderQueries.length,resultCount:y.length},messages:$.messages,limitHit:$.limitHit||typeof c.maxResults=="number"&&D.length>c.maxResults},y]})})}k(s){const c=this.b[s];return c||(this.b[s]=new u)}l(s,c,t){const f=s.cacheKey&&this.b[s.cacheKey];if(!f)return;const h=this.q(f,s.filePattern||"",c,t);if(h)return h.then(([r,a,d])=>{const $=w.$1d.create(!1);return this.n(s,a,f.scorerCache,t).then(D=>{const b=$.elapsed(),g={fromCache:!0,detailStats:d,type:this.d,resultCount:a.length,sortingTime:b};return[{type:"success",limitHit:r.limitHit||typeof s.maxResults=="number"&&a.length>s.maxResults,stats:g},D]})})}n(s,c,t,f){const h=(0,R.$br)(s.filePattern||""),r=(d,$)=>(0,R.$ar)(d,$,h,!0,m,t),a=typeof s.maxResults=="number"?s.maxResults:Number.MAX_VALUE;return l.$Gb(c,r,a,1e4,f)}o(s,c,t){if(t&&t>0)for(let f=0;f<s.length;f+=t)c(s.slice(f,f+t));else c(s)}q(s,c,t,f){const h=w.$1d.create(!1),r=c.indexOf(p.sep)>=0;let a;for(const b in s.resultsToSearchCache)if(c.startsWith(b)){if(r&&b.indexOf(p.sep)<0&&b!=="")continue;const g=s.resultsToSearchCache[b];a={promise:this.s(g.promise),event:g.event,resolved:g.resolved};break}if(!a)return null;const d=h.elapsed(),$=w.$1d.create(!1),D=a.event(t);return f&&f.onCancellationRequested(()=>{D.dispose()}),a.promise.then(([b,g])=>{if(f&&f.isCancellationRequested)throw(0,L.$6)();const y=[],P=(0,R.$br)(c).normalizedLowercase;for(const N of g)(0,C.$CK)(N,P)&&y.push(N);return[b,y,{cacheWasResolved:a.resolved,cacheLookupTime:d,cacheFilterTime:$.elapsed(),cacheEntryCount:g.length}]})}r(s,c,t,f){return new Promise((h,r)=>{let a=[];f?.onCancellationRequested(()=>s.cancel()),s.search(d=>{d&&(t?(a.push(d),t>0&&a.length>=t&&(c(a),a=[])):c(d))},d=>{c(d)},(d,$)=>{a.length&&c(a),d?(c({message:"Search finished. Error: "+d.message}),r(d)):(c({message:"Search finished. Stats: "+JSON.stringify($.stats)}),h($))})})}clearCache(s){return delete this.b[s],Promise.resolve(void 0)}s(s){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(c,t){return s.then(c,t)}catch(c){return this.then(void 0,c)}finally(c){return s.finally(c)}}}}e.$skc=k;class u{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const m=new class{getItemLabel(n){return(0,p.$nc)(n.relativePath)}getItemDescription(n){return(0,p.$mc)(n.relativePath)}getItemPath(n){return n.relativePath}};function o(n){return{...n,folderQueries:n.folderQueries&&n.folderQueries.map(i),extraFileResources:n.extraFileResources&&n.extraFileResources.map(s=>E.URI.revive(s))}}function i(n){return{...n,folder:E.URI.revive(n.folder)}}}),define(Se[385],De([1,0,3,15,2,31,12,27,20,97,65,36,384,382,122,159]),function(fe,e,l,j,L,A,R,p,w,E,M,C,v,S,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ukc=void 0;let m=class extends E.$gjc{constructor(i,n,s,c){super(i,s,c),this.w=A,this.x=-1,this.y=null,this.z=!1,this.A=new l.$Sc;const t=new k.$dkc("RipgrepSearchUD",this.q);this.A.add(this.registerTextSearchProvider(j.Schemas.vscodeUserData,new S.$tkc(t))),n.remote.isRemote&&n.remote.authority&&this.B()}dispose(){this.A.dispose()}$enableExtensionHostSearch(){this.B()}B(){if(this.z)return;this.z=!0;const i=new k.$dkc("RipgrepSearchEH",this.q);this.A.add(this.registerTextSearchProvider(j.Schemas.file,new S.$tkc(i))),this.A.add(this.C(j.Schemas.file,new v.$skc("fileSearchProvider")))}C(i,n){const s=this.d++;return this.y=n,this.x=s,this.c.$registerFileSearchProvider(s,this.s(i)),(0,l.$Rc)(()=>{this.y=null,this.c.$unregisterProvider(s)})}$provideFileSearchResults(i,n,s,c){const t=(0,E.$hjc)(s);if(i===this.x){const f=Date.now();return this.D(i,n,t,c).then(h=>{const r=Date.now()-f;return this.q.debug(`Ext host file search time: ${r}ms`),h})}return super.$provideFileSearchResults(i,n,s,c)}doInternalFileSearchWithCustomCallback(i,n,s){const c=t=>{if((0,C.$BK)(t)&&(t=[t]),Array.isArray(t)){s(t.map(f=>L.URI.file(f.path)));return}t.message&&this.q.debug("ExtHostSearch",t.message)};if(!this.y)throw new Error("No internal file search handler");return this.y.doFileSearch(i,c,n)}async D(i,n,s,c){return this.doInternalFileSearchWithCustomCallback(s,c,t=>{this.c.$handleFileMatch(i,n,t)})}$clearCache(i){return this.y?.clearCache(i),super.$clearCache(i)}t(i,n){return new u.$qkc(i,n,void 0,"textSearchProvider")}};e.$ukc=m,e.$ukc=m=Ye([Ve(0,w.$lO),Ve(1,p.$BO),Ve(2,M.$_hc),Ve(3,R.$zj)],m)}),define(Se[123],De([1,0,372,62,63,399,21,13,4,3,17,11,30,80,81]),function(fe,e,l,j,L,A,R,p,w,E,M,C,v,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=void 0;class u{traceSocketEvent(g,y){k.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,g,y)}constructor(g,y=""){this.f=!0,this.debugLabel=y,this.socket=g,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=P=>{if(this.traceSocketEvent("error",{code:P?.code,message:P?.message}),P){if(P.code==="EPIPE")return;(0,p.$1)(P)}},this.socket.on("error",this.a),this.b=P=>{this.traceSocketEvent("close",{hadError:P}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(g){const y=P=>{this.traceSocketEvent("read",P),g(R.$se.wrap(P))};return this.socket.on("data",y),{dispose:()=>this.socket.off("data",y)}}onClose(g){const y=P=>{g({type:0,hadError:P,error:void 0})};return this.socket.on("close",y),{dispose:()=>this.socket.off("close",y)}}onEnd(g){const y=()=>{g()};return this.socket.on("end",y),{dispose:()=>this.socket.off("end",y)}}write(g){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",g),this.socket.write(g.buffer,y=>{if(y){if(y.code==="EPIPE")return;(0,p.$1)(y)}})}catch(y){if(y.code==="EPIPE")return;(0,p.$1)(y)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((g,y)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),g();return}const P=()=>{this.socket.off("close",P),this.socket.off("end",P),this.socket.off("error",P),this.socket.off("timeout",P),this.socket.off("drain",P),this.traceSocketEvent("nodeDrainEnd"),g()};this.socket.on("close",P),this.socket.on("end",P),this.socket.on("error",P),this.socket.on("timeout",P),this.socket.on("drain",P)})}}e.$7h=u;var m;(function(b){b[b.MinHeaderByteSize=2]="MinHeaderByteSize",b[b.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(m||(m={}));var o;(function(b){b[b.PeekHeader=1]="PeekHeader",b[b.ReadHeader=2]="ReadHeader",b[b.ReadBody=3]="ReadBody",b[b.Fin=4]="Fin"})(o||(o={}));class i extends E.$Tc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(g,y){this.socket.traceSocketEvent(g,y)}constructor(g,y,P,N){super(),this.f=this.B(new w.$5d),this.g=this.B(new w.$5d),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=g,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:y,inflateBytesLength:P?.byteLength||0,recordInflateBytes:N}),this.a=this.B(new n(this,y,P,N,this.f,(U,z)=>this.m(U,z))),this.B(this.a.onError(U=>{console.error(U),(0,p.$1)(U),this.g.fire({type:0,hadError:!0,error:U})})),this.b=new k.$2h,this.B(this.socket.onData(U=>this.n(U))),this.B(this.socket.onClose(async U=>{this.a.isProcessingReadQueue()&&await w.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(U)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(g){return this.f.event(g)}onClose(g){return this.g.event(g)}onEnd(g){return this.socket.onEnd(g)}write(g){let y=0;for(;y<g.byteLength;)this.a.writeMessage(g.slice(y,Math.min(y+262144,g.byteLength)),{compressed:!0,opcode:2}),y+=262144}m(g,{compressed:y,opcode:P}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",g);let N=2;g.byteLength<126?N+=0:g.byteLength<2**16?N+=2:N+=8;const U=R.$se.alloc(N),z=y?64:0,F=P&15;if(U.writeUInt8(128|z|F,0),g.byteLength<126)U.writeUInt8(g.byteLength,1);else if(g.byteLength<2**16){U.writeUInt8(126,1);let I=1;U.writeUInt8(g.byteLength>>>8&255,++I),U.writeUInt8(g.byteLength>>>0&255,++I)}else{U.writeUInt8(127,1);let I=1;U.writeUInt8(0,++I),U.writeUInt8(0,++I),U.writeUInt8(0,++I),U.writeUInt8(0,++I),U.writeUInt8(g.byteLength>>>24&255,++I),U.writeUInt8(g.byteLength>>>16&255,++I),U.writeUInt8(g.byteLength>>>8&255,++I),U.writeUInt8(g.byteLength>>>0&255,++I)}this.socket.write(R.$se.concat([U,g]))}end(){this.h=!0,this.socket.end()}n(g){if(g.byteLength!==0){for(this.b.acceptChunk(g);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const y=this.b.peek(this.j.readLen),P=y.readUInt8(0),N=(P&128)>>>7,U=(P&64)>>>6,z=P&15,F=y.readUInt8(1),I=(F&128)>>>7,O=F&127;this.j.state=2,this.j.readLen=2+(I?4:0)+(O===126?2:0)+(O===127?8:0),this.j.fin=N,this.j.firstFrameOfMessage&&(this.j.compressed=!!U),this.j.firstFrameOfMessage=!!N,this.j.mask=0,this.j.opcode=z,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const y=this.b.read(this.j.readLen),P=y.readUInt8(1),N=(P&128)>>>7;let U=P&127,z=1;U===126?U=y.readUInt8(++z)*2**8+y.readUInt8(++z):U===127&&(U=y.readUInt8(++z)*0+y.readUInt8(++z)*0+y.readUInt8(++z)*0+y.readUInt8(++z)*0+y.readUInt8(++z)*2**24+y.readUInt8(++z)*2**16+y.readUInt8(++z)*2**8+y.readUInt8(++z));let F=0;N&&(F=y.readUInt8(++z)*2**24+y.readUInt8(++z)*2**16+y.readUInt8(++z)*2**8+y.readUInt8(++z)),this.j.state=3,this.j.readLen=U,this.j.mask=F,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const y=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",y),t(y,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",y),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(y,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(y,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await w.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$8h=i;class n extends E.$Tc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:R.$se.alloc(0)}constructor(g,y,P,N,U,z){super(),this.n=g,this.r=U,this.s=z,this.a=this.B(new w.$5d),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new w.$5d),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new w.$5d),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,y?(this.b=this.B(new s(this.n,N,P,{windowBits:15})),this.f=this.B(new c(this.n,{windowBits:15})),this.B(this.b.onError(F=>this.a.fire(F))),this.B(this.f.onError(F=>this.a.fire(F)))):(this.b=null,this.f=null)}writeMessage(g,y){this.g.push({data:g,options:y}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:g,options:y}=this.g.shift();if(this.f&&y.compressed){const P=await this.w(this.f,g);this.s(P,y)}else this.s(g,{...y,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(g,y){return new Promise((P,N)=>{g.write(y),g.flush(U=>P(U))})}acceptFrame(g,y,P){this.h.push({data:g,isCompressed:y,isLastFrameOfMessage:P}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const g=this.h.shift();if(this.b&&g.isCompressed){const y=await this.C(this.b,g.data,g.isLastFrameOfMessage);this.r.fire(y)}else this.r.fire(g.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(g,y,P){return new Promise((N,U)=>{g.write(y),P&&g.write(R.$se.fromByteArray([0,0,255,255])),g.flush(z=>N(z))})}}class s extends E.$Tc{get recordedInflateBytes(){return this.j?R.$se.concat(this.f):R.$se.alloc(0)}constructor(g,y,P,N){super(),this.h=g,this.j=y,this.a=this.B(new w.$5d),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,A.createInflateRaw)(N),this.b.on("error",U=>{this.h.traceSocketEvent("zlibInflateError",{message:U?.message,code:U?.code}),this.a.fire(U)}),this.b.on("data",U=>{this.h.traceSocketEvent("zlibInflateData",U),this.g.push(R.$se.wrap(U))}),P&&(this.h.traceSocketEvent("zlibInflateInitialWrite",P.buffer),this.b.write(P.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(g){this.j&&this.f.push(g.clone()),this.h.traceSocketEvent("zlibInflateWrite",g),this.b.write(g.buffer)}flush(g){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const y=R.$se.concat(this.g);this.g.length=0,g(y)})}}class c extends E.$Tc{constructor(g,y){super(),this.g=g,this.a=this.B(new w.$5d),this.onError=this.a.event,this.f=[],this.b=(0,A.createDeflateRaw)({windowBits:15}),this.b.on("error",P=>{this.g.traceSocketEvent("zlibDeflateError",{message:P?.message,code:P?.code}),this.a.fire(P)}),this.b.on("data",P=>{this.g.traceSocketEvent("zlibDeflateData",P),this.f.push(R.$se.wrap(P))})}write(g){this.g.traceSocketEvent("zlibDeflateWrite",g.buffer),this.b.write(g.buffer)}flush(g){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let y=R.$se.concat(this.f);this.f.length=0,y=y.slice(0,y.byteLength-4),g(y)})}}function t(b,g){if(g===0)return;const y=b.byteLength>>>2;for(let I=0;I<y;I++){const O=b.readUInt32BE(I*4);b.writeUInt32BE(O^g,I*4)}const P=y*4,N=b.byteLength-P,U=g>>>24&255,z=g>>>16&255,F=g>>>8&255;N>=1&&b.writeUInt8(b.readUInt8(P)^U,P),N>=2&&b.writeUInt8(b.readUInt8(P+1)^z,P+1),N>=3&&b.writeUInt8(b.readUInt8(P+2)^F,P+2)}e.$9h=process.env.XDG_RUNTIME_DIR;const f={2:107,1:103};function h(){const b=(0,v.$Bg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${b}-sock`;const g=process.platform!=="darwin"&&e.$9h?e.$9h:(0,L.tmpdir)(),y=(0,M.$jc)(g,`vscode-ipc-${b}.sock`);return a(y),y}e.$0h=h;function r(b,g,y){const N=(0,l.createHash)("sha256").update(b).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${N}-${y}-${g}-sock`;const U=y.substr(0,4),z=g.substr(0,6);let F;return process.platform!=="darwin"&&e.$9h&&!process.env.VSCODE_PORTABLE?F=(0,M.$jc)(e.$9h,`vscode-${N}-${U}-${z}.sock`):F=(0,M.$jc)(b,`${U}-${z}.sock`),a(F),F}e.$$h=r;function a(b){const g=f[C.$u];typeof g=="number"&&b.length>=g&&console.warn(`WARNING: IPC handle "${b}" is longer than ${g} chars, try a shorter --user-data-dir`)}class d extends S.$Vh{static b(g){const y=w.Event.fromNodeEventEmitter(g,"connection");return w.Event.map(y,P=>({protocol:new k.$3h(new u(P,"ipc-server-connection")),onDidClientDisconnect:w.Event.once(w.Event.fromNodeEventEmitter(P,"close"))}))}constructor(g){super(d.b(g)),this.d=g}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$_h=d;function $(b){return new Promise((g,y)=>{const P=(0,j.createServer)();P.on("error",y),P.listen(b,()=>{P.removeListener("error",y),g(new d(P))})})}e.$ai=$;function D(b,g){return new Promise((y,P)=>{const N=(0,j.createConnection)(b,()=>{N.removeListener("error",P),y(k.$4h.fromSocket(new u(N,`ipc-client${g}`),g))});N.once("error",P)})}e.$bi=D}),define(Se[386],De([1,0,62,63,171,123,8,3,11,52,12,139,262,263,110,88,21]),function(fe,e,l,j,L,A,R,p,w,E,M,C,v,S,k,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gac=e.$Fac=e.$Eac=e.$Dac=void 0;async function o(t,f,h,r,a){let d;for(let $=3;$&&(d?.dispose(),d=await new i(t,f,h,r,a).waitForReady(),!(a&&L.$Eg[a]||!L.$Eg[d.tunnelLocalPort]));$--);return d}class i extends p.$Tc{constructor(f,h,r,a,d){super(),this.m=h,this.n=d,this.privacy=u.TunnelPrivacyId.Private,this.j=new Map,this.a=f,this.b=l.createServer(),this.c=new R.$eh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=$=>this.r($),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=a,this.tunnelRemoteHost=r}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(h=>{h()})}async waitForReady(){const f=this.n??this.tunnelRemotePort,h=(0,u.$Wv)(this.m)?"0.0.0.0":"127.0.0.1";let r=await(0,L.$Fg)(f,2,1e3,h),a=null;return this.b.listen(r,this.m),await this.c.wait(),a=this.b.address(),a||(r=0,this.b.listen(r,this.m),await this.c.wait(),a=this.b.address()),this.tunnelLocalPort=a.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${a.port}`,this}async r(f){f.pause();const h=(0,u.$Uv)(this.tunnelRemoteHost)||(0,u.$Wv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,r=await(0,v.$vl)(this.a,h,this.tunnelRemotePort),a=r.getSocket(),d=r.readEntireBuffer();r.dispose(),d.byteLength>0&&f.write(d.buffer),f.on("end",()=>{f.localAddress&&this.j.delete(f.localAddress),a.end()}),f.on("close",()=>a.end()),f.on("error",()=>{f.localAddress&&this.j.delete(f.localAddress),a instanceof A.$7h?a.socket.destroy():a.end()}),a instanceof A.$7h?this.t(f,a):this.s(f,a),f.localAddress&&this.j.set(f.localAddress,()=>{f.end(),a.end()})}s(f,h){h.onClose(()=>f.destroy()),h.onEnd(()=>f.end()),h.onData(r=>f.write(r.buffer)),f.on("data",r=>h.write(m.$se.wrap(r))),f.resume()}t(f,h){const r=h.socket;r.on("end",()=>f.end()),r.on("close",()=>f.end()),r.on("error",()=>{f.destroy()}),r.pipe(f),f.pipe(r)}}e.$Dac=i;let n=class extends u.$Zv{constructor(f,h,r,a,d){super(h,d),this.v=f,this.w=r,this.y=a}isPortPrivileged(f){return(0,u.$Xv)(f,this.m,w.OS,j.release())}t(f,h,r,a,d,$,D,b){const g=this.s(h,r);if(g)return++g.refcount,g.value;if((0,u.$Rv)(f))return this.u(f,h,r,d,$,D,b);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${h}:${r} on local port ${d}.`);const y={commit:this.y.commit,quality:this.y.quality,addressProvider:f,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},P=o(y,a,h,r,d);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(h,r,P),P}}};e.$Eac=n,e.$Eac=n=Ye([Ve(0,S.$pl),Ve(1,M.$zj),Ve(2,k.$sl),Ve(3,C.$Rj),Ve(4,E.$Li)],n);let s=class extends n{constructor(f,h,r,a,d){super(f,h,r,a,d)}};e.$Fac=s,e.$Fac=s=Ye([Ve(0,S.$pl),Ve(1,M.$zj),Ve(2,k.$sl),Ve(3,C.$Rj),Ve(4,E.$Li)],s);let c=class extends p.$Tc{constructor(f,h,r,a,d){super(),this.b=f,this.c=h,this.f=r,this.g=a,this.h=d,this.a=new Map}async openTunnel(f,h,r,a,d,$,D,b,g){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${r}:${a} on local port ${$}.`),!this.a.has(f)){const y=new s(this.b,this.c,this.g,this.f,this.h);this.B(y),this.a.set(f,y),y.onTunnelClosed(async()=>{(await y.tunnels).length===0&&(y.dispose(),this.a.delete(f))})}return this.a.get(f).openTunnel(h,r,a,d,$,D,b,g)}};e.$Gac=c,e.$Gac=c=Ye([Ve(0,S.$pl),Ve(1,M.$zj),Ve(2,C.$Rj),Ve(3,k.$sl),Ve(4,E.$Li)],c)}),define(Se[387],De([1,0,123,282,57,33,2,12,40]),function(fe,e,l,j,L,A,R,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NO=e.$MO=void 0;class E{constructor(v,S,k){this.b=v,this.c=S,this.f=k,this.a=j.createServer((u,m)=>this.h(u,m)),this.g().catch(u=>(S.error(u),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",v=>this.c.error(v))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(v,S){const k=(m,o)=>{S.writeHead(m,{"content-type":"application/json"}),S.end(JSON.stringify(o||null),i=>i&&this.c.error(i))},u=[];v.setEncoding("utf8"),v.on("data",m=>u.push(m)),v.on("end",async()=>{try{const m=JSON.parse(u.join(""));let o;switch(m.type){case"open":o=await this.i(m);break;case"openExternal":o=await this.j(m);break;case"status":o=await this.l(m);break;case"extensionManagement":o=await this.k(m);break;default:k(404,`Unknown message type: ${m.type}`);break}k(200,o)}catch(m){const o=m instanceof Error?m.message:JSON.stringify(m);k(500,o),this.c.error("Error while processing pipe request",m)}})}async i(v){const{fileURIs:S,folderURIs:k,forceNewWindow:u,diffMode:m,mergeMode:o,addMode:i,forceReuseWindow:n,gotoLineMode:s,waitMarkerFilePath:c,remoteAuthority:t}=v,f=[];if(Array.isArray(k))for(const d of k)try{f.push({folderUri:R.URI.parse(d)})}catch{}if(Array.isArray(S))for(const d of S)try{(0,w.$Ki)(d)?f.push({workspaceUri:R.URI.parse(d)}):f.push({fileUri:R.URI.parse(d)})}catch{}const h=c?R.URI.file(c):void 0,a={forceNewWindow:u,diffMode:m,mergeMode:o,addMode:i,gotoLineMode:s,forceReuseWindow:n,preferNewWindow:!n&&!h&&!i,waitMarkerFileURI:h,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",f,a)}async j(v){for(const S of v.uris){const k=R.URI.parse(S),u=k.scheme==="file"?k:S;await this.b.executeCommand("_remoteCLI.openExternal",u)}}async k(v){const S=u=>u?.map(m=>/\.vsix$/i.test(m)?R.URI.parse(m):m),k={list:v.list,install:S(v.install),uninstall:S(v.uninstall),force:v.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",k)}async l(v){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&L.existsSync(this.f)&&L.unlinkSync(this.f)}}e.$MO=E;let M=class extends E{constructor(v,S){super(v,S,(0,l.$0h)())}};e.$NO=M,e.$NO=M=Ye([Ve(0,A.$HO),Ve(1,p.$zj)],M)}),define(Se[388],De([1,0,58,375,369,281,47,356,2,15,7,387,104,314,355]),function(fe,e,l,j,L,A,R,p,w,E,M,C,v,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zkc=void 0;class u extends L.$1jc{j(){const i=this,n=globalThis._VSCODE_NODE_MODULES.module,s=n._load;n._load=function(h,r,a){return h=t(h),i.a.has(h)?i.a.get(h).load(h,w.URI.file((0,v.$Kq)(r.filename)),d=>s.apply(this,[d,r,a])):s.apply(this,arguments)};const c=n._resolveLookupPaths;n._resolveLookupPaths=(f,h)=>c.call(this,t(f),h);const t=f=>{for(const h of i.b){const r=h(f);if(r){f=r;break}}return f}}}class m extends R.$Pic{constructor(){super(...arguments),this.extensionRuntime=M.ExtensionRuntime.Node}async ub(){this.h.createInstance(S.$xkc);const i=this.h.invokeFunction(j.$Wjc);if(this.h.createInstance(p.$wkc),this.f.remote.isRemote&&this.f.remote.authority){const c=this.h.createInstance(C.$NO);process.env.VSCODE_IPC_HOOK_CLI=c.ipcHandlePath}this.h.createInstance(k.$ykc),await this.h.createInstance(u,i,{mine:this.J,all:this.L}).install(),l.mark("code/extHost/didInitAPI");const s=await this.m.getConfigProvider();await(0,A.$vkc)(this.j,s,this,this.s,this.z,this.f),l.mark("code/extHost/didInitProxyResolver")}vb(i){return i.main}async wb(i,n,s){if(n.scheme!==E.Schemas.file)throw new Error(`Cannot load URI: '${n}', must be of file-scheme`);let c=null;s.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${n.toString(!0)}`),this.s.flush();const t=i?.identifier.value;i&&await this.w.initializeLocalizedMessages(i);try{t&&l.mark(`code/extHost/willLoadExtensionCode/${t}`),c=fe.__$__nodeRequire(n.fsPath)}finally{t&&l.mark(`code/extHost/didLoadExtensionCode/${t}`),s.codeLoadingStop()}return c}async $setRemoteEnvironment(i){if(this.f.remote.isRemote)for(const n in i){const s=i[n];s===null?delete process.env[n]:process.env[n]=s}}}e.$zkc=m}),define(Se[389],De([1,0,51,21,4,3,125,11,23,2,31,12,261,64,110,88,386,27,20,69,363]),function(fe,e,l,j,L,A,R,p,w,E,M,C,v,S,k,u,m,o,i,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hkc=e.$Gkc=e.$Fkc=e.$Ekc=e.$Dkc=e.$Ckc=e.$Bkc=e.$Akc=void 0;function c(g){const y=g.trim().split(`
`),P=[];return y.forEach(U=>{const z=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(U);z&&z.length>=3&&P.push({pid:parseInt(z[1],10),socket:parseInt(z[2],10)})}),P.reduce((U,z)=>(U[z.socket]=z,U),{})}e.$Akc=c;function t(...g){const y=[].concat(...g.map(h));return[...new Map(y.filter(P=>P.st==="0A").map(P=>{const N=P.local_address.split(":");return{socket:parseInt(P.inode,10),ip:f(N[0]),port:parseInt(N[1],16)}}).map(P=>[P.ip+":"+P.port,P])).values()]}e.$Bkc=t;function f(g){let y="";if(g.length===8)for(let P=g.length-2;P>=0;P-=2)y+=parseInt(g.substr(P,2),16),P!==0&&(y+=".");else for(let P=0;P<g.length;P+=8){const N=g.substring(P,P+8);let U="";for(let z=8;z>=2;z-=2)U+=N.substring(z-2,z),(z===6||z===2)&&(U=parseInt(U,16).toString(16),y+=`${U}`,U="",P+z!==g.length-6&&(y+=":"))}return y}e.$Ckc=f;function h(g){const y=g.trim().split(`
`),P=y.shift().trim().split(/\s+/).filter(U=>U!=="rx_queue"&&U!=="tm->when");return y.map(U=>U.trim().split(/\s+/).reduce((z,F,I)=>(z[P[I]||I]=F,z),{}))}e.$Dkc=h;function r(g){return!!g.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||g.indexOf("out/server-main.js")!==-1||g.indexOf("_productName=VSCode")!==-1}function a(g){const y=g.trim().split(`
`),P=[];return y.forEach(N=>{const U=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(N);U&&U.length>=4&&P.push({pid:parseInt(U[1],10),ppid:parseInt(U[2]),cmd:U[3]})}),P}e.$Ekc=a;async function d(g,y,P){const N=P.reduce((z,F)=>(z[F.pid]=F,z),{}),U=[];return g.forEach(({socket:z,ip:F,port:I})=>{const O=y[z]?y[z].pid:void 0,T=O?N[O]?.cmd:void 0;O&&T&&!r(T)&&U.push({host:F,port:I,detail:T,pid:O})}),U}e.$Fkc=d;function $(g,y,P){const N=new Map,U=a(y);for(const z of g){const F=P.get(z.port);if(F){N.set(z.port,F);continue}const I=U.find(O=>O.cmd.includes(`${z.port}`));if(I){let O=I,T;do T=U.find(G=>G.ppid===O.pid),T&&(O=T);while(T);N.set(z.port,{host:z.ip,port:z.port,pid:O.pid,detail:O.cmd,ppid:O.ppid})}else N.set(z.port,{host:z.ip,port:z.port,ppid:Number.MAX_VALUE})}return N}e.$Gkc=$;let D=class extends n.$AAb{constructor(y,P,N,U){super(y,P,N),this.D=P,this.F=U,this.y=void 0,this.z=new Map,this.C=!1,p.$k&&P.remote.isRemote&&P.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(y){if(y&&this.C)return;this.C=y;let P;this.y&&(P=this.y,await this.a.$onFoundNewCandidates(this.y));const N=new R.$hm;let U=0;for(;this.C;){const z=new Date().getTime(),F=(await this.I()).filter(T=>(0,u.$Uv)(T.host)||(0,u.$Wv)(T.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${F.map(T=>T.port).join(", ")}`);const I=new Date().getTime()-z;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${I} ms.`),U++>3&&N.update(I),(!P||JSON.stringify(P)!==JSON.stringify(F))&&(P=F,await this.a.$onFoundNewCandidates(P));const O=this.G(N.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${O} ms.`),await new Promise(T=>setTimeout(()=>T(),O))}}G(y){return Math.max(y*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(y=>y.port).join(", ")}`)}async I(){let y="",P="";try{y=await M.Promises.readFile("/proc/net/tcp","utf8"),P=await M.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const N=t(y,P),U=await new Promise(x=>{(0,l.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(X,Q,ae)=>{x(Q)})}),z=c(U),F=await M.Promises.readdir("/proc"),I=[];for(const x of F)try{const X=Number(x),Q=w.$Sg(E.URI.file("/proc"),x);if((await M.Promises.stat(Q.fsPath)).isDirectory()&&!isNaN(X)){const _=await M.Promises.readlink(w.$Sg(Q,"cwd").fsPath),ge=await M.Promises.readFile(w.$Sg(Q,"cmdline").fsPath,"utf8");I.push({pid:X,cwd:_,cmd:ge})}}catch{}const O=[],T=N.filter(x=>{const X=z[x.socket];return X||O.push(x),X}),G=d(T,z,I);let te;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${O.length}`),O.length>0){const x=await new Promise(X=>{(0,l.exec)("ps -F -A -l | grep root",(Q,ae,_)=>{X(ae)})});this.z=$(O,x,this.z),te=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${te.map(X=>X.port).join(", ")}`)}return G.then(x=>te?x.concat(te):x)}w(y){return async P=>{const N=new m.$Dac({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(z,F,I,O){const T=await y.makeConnection();return b.connect(T,F,I,O)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new S.$ll(0),connectionToken:y.connectionToken})}},signService:this.F},"localhost",P.remoteAddress.host||"localhost",P.remoteAddress.port,P.localAddressPort);await N.waitForReady();const U=new L.$5d;return{localAddress:(0,s.$tL)(N.localAddress)??N.localAddress,remoteAddress:{port:N.tunnelRemotePort,host:N.tunnelRemoteHost},onDidDispose:U.event,dispose:()=>{N.dispose(),U.fire(),U.dispose()}}}}};e.$Hkc=D,e.$Hkc=D=Ye([Ve(0,i.$lO),Ve(1,o.$BO),Ve(2,C.$zj),Ve(3,k.$sl)],D);class b extends v.$ytb{static connect(y,P,N,U){const z=new A.$Sc,F={onClose:z.add(new L.$5d),onData:z.add(new L.$5d),onEnd:z.add(new L.$5d)};z.add(y.onDidReceiveMessage(O=>F.onData.fire(j.$se.wrap(O)))),z.add(y.onDidEnd(()=>F.onEnd.fire())),z.add(y.onDidClose(O=>F.onClose.fire({type:0,error:O,hadError:!!O})));const I=new b(y,U,F);return I.B(z),(0,v.$xtb)(I,P,N,U,F)}constructor(y,P,N){super(P,N),this.n=y}write(y){this.n.send(y.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(Se[390],De([1,0,83,358,373,371,385,388,389,96,47,97,95,46,69,93,357,315,12,374,60,276,106,110,141]),function(fe,e,l,j,L,A,R,p,w,E,M,C,v,S,k,u,m,o,i,n,s,c,t,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,l.$as)(M.$Qic,p.$zkc,0),(0,l.$as)(i.$Aj,o.$Jkc,1),(0,l.$as)(i.$zj,new t.$ci(c.$Zjc,[!1],!0)),(0,l.$as)(f.$sl,h.$Iac,1),(0,l.$as)(u.$iic,m.$Ikc,0),(0,l.$as)(E.$Vic,A.$akc,0),(0,l.$as)(C.$fjc,R.$ukc,0),(0,l.$as)(v.$Ijc,L.$5jc,0),(0,l.$as)(S.$Dic,j.$4jc,0),(0,l.$as)(k.$zAb,w.$Hkc,0),(0,l.$as)(s.$Tic,n.$Kkc,0)}),define(Se[400],De([1,0,62,401,58,13,81,123,259,114,370,21,31,104,8,135,283,297,376,390]),function(fe,e,l,j,L,A,R,p,w,E,M,C,v,S,k,u,m,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let $=0;$<process.execArgv.length;$++)process.execArgv[$]==="--inspect-port=0"&&(process.execArgv.splice($,1),$--)}();const i=j(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const d=globalThis._VSCODE_NODE_MODULES.module,$=d._load;d._load=function(D){if(D==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return $.apply(this,arguments)}})();const n=process.exit.bind(process),s=process.on.bind(process);function c(d){process.exit=function($){if(d)n($);else{const D=new Error("An extension called process.exit() and this was prevented.");console.warn(D.stack)}},process.crash=function(){const $=new Error("An extension called process.crash() and this was prevented.");console.warn($.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function($,D){$==="uncaughtException"&&(D=function(){try{return D.call(void 0,arguments)}catch{}}),s($,D)}}let t=function(d){n()};function f(){const d=(0,o.$9m)(process.env);if(d.type===3)return new Promise(($,D)=>{const b=g=>{const y=g[0],P=new R.$5h;y.on("message",N=>P.fire(C.$se.wrap(N.data))),y.on("close",()=>{t("renderer closed the MessagePort")}),y.start(),$({onMessage:P.event,send:N=>y.postMessage(N.buffer)})};process.parentPort.on("message",g=>b(g.ports))});if(d.type===2)return new Promise(($,D)=>{let b=null;const g=setTimeout(()=>{t("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),y=108e5,P=3e5,N=new k.$sh(()=>t("renderer disconnected for too long (1)"),y),U=new k.$sh(()=>t("renderer disconnected for too long (2)"),P);process.on("message",(F,I)=>{if(F&&F.type==="VSCODE_EXTHOST_IPC_SOCKET"){I.setNoDelay(!0);const O=C.$se.wrap(Buffer.from(F.initialDataChunk,"base64"));let T;if(F.skipWebSocketFrames)T=new p.$7h(I,"extHost-socket");else{const G=C.$se.wrap(Buffer.from(F.inflateBytes,"base64"));T=new p.$8h(new p.$7h(I,"extHost-socket"),F.permessageDeflate,G,!1)}b?(N.cancel(),U.cancel(),b.beginAcceptReconnection(T,O),b.endAcceptReconnection(),b.sendResume()):(clearTimeout(g),b=new R.$6h({socket:T,initialChunk:O}),b.sendResume(),b.onDidDispose(()=>t("renderer disconnected")),$(b),b.onSocketClose(()=>{N.schedule()}))}if(F&&F.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(U.isScheduled())return;N.isScheduled()&&U.schedule()}});const z={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(z)});{const $=d.pipeName;return new Promise((D,b)=>{const g=l.createConnection($,()=>{g.removeListener("error",b);const y=new R.$6h({socket:new p.$7h(g,"extHost-renderer")});y.sendResume(),D(y)});g.once("error",b),g.on("close",()=>{t("renderer closed the socket")})})}}async function h(){const d=await f();return new class{constructor(){this.a=new R.$5h,this.onMessage=this.a.event,this.b=!1,d.onMessage($=>{(0,E.$Im)($,2)?(this.b=!0,t("received terminate message from renderer")):this.a.fire($)})}send($){this.b||d.send($)}async drain(){if(d.drain)return d.drain()}}}function r(d){return new Promise($=>{const D=d.onMessage(b=>{D.dispose();const g=JSON.parse(b.toString()),y=g.commit,P=w.default.commit;if(y&&P&&y!==P&&n(55),g.parentPid){let N=0;setInterval(function(){try{process.kill(g.parentPid,0),N=0}catch(z){z&&z.code==="EPERM"?(N++,N>=3&&t(`parent process ${g.parentPid} does not exist anymore (3 x EPERM): ${z.message} (code: ${z.code}) (errno: ${z.errno})`)):t(`parent process ${g.parentPid} does not exist anymore: ${z.message} (code: ${z.code}) (errno: ${z.errno})`)}},1e3);let U;try{U=globalThis._VSCODE_NODE_MODULES["native-watchdog"],U.start(g.parentPid)}catch(z){(0,A.$1)(z)}}d.send((0,E.$Hm)(0)),$({protocol:d,initData:g})});d.send((0,E.$Hm)(1))})}async function a(){const d=[];process.on("unhandledRejection",(N,U)=>{d.push(U),setTimeout(()=>{const z=d.indexOf(U);z>=0&&U.catch(F=>{d.splice(z,1),(0,A.$4)(F)||(console.warn(`rejected promise not handled within 1 second: ${F}`),F&&F.stack&&console.warn(`stack trace: ${F.stack}`),N&&(0,A.$1)(N))})},1e3)}),process.on("rejectionHandled",N=>{const U=d.indexOf(N);U>=0&&d.splice(U,1)}),process.on("uncaughtException",function(N){(0,A.$Z)(N)||(0,A.$1)(N)}),L.mark("code/extHost/willConnectToRenderer");const $=await h();L.mark("code/extHost/didConnectToRenderer");const D=await r($);L.mark("code/extHost/didWaitForInitData");const{initData:b}=D;c(!!b.environment.extensionTestsLocationURI),b.environment.useHostProxy=i.useHostProxy!==void 0?i.useHostProxy!=="false":void 0,b.environment.skipWorkspaceStorageLock=(0,u.boolean)(i.skipWorkspaceStorageLock,!1);const g=new class{constructor(){this.pid=process.pid}exit(U){n(U)}fsExists(U){return v.Promises.exists(U)}fsRealpath(U){return(0,S.$Jq)(U)}};let y=null;b.remote.authority&&i.transformURIs&&(y=(0,m.$es)(b.remote.authority));const P=new M.$3jc(D.protocol,b,g,y);t=N=>P.terminate(N)}a().catch(d=>console.log(d))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/8c2b09c0443b94d75a73819ed35610f7e09375ae/core/vs/workbench/api/node/extensionHostProcess.js.map
