/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Pe=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/base/common/network","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/strings","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/platform/extensions/common/extensions","vs/base/common/platform","vs/workbench/services/extensions/common/extensions","vs/base/common/buffer","vs/base/common/resources","vs/base/common/cancellation","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/base/common/severity","vs/base/common/uuid","vs/base/common/glob","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/themables","vs/base/common/errorMessage","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/ternarySearchTree","vs/base/common/iterator","vs/base/common/marshalling","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/base/common/codiconsUtil","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Re=function(me){for(var e=[],S=0,M=me.length;S<M;S++)e[S]=Pe[me[S]];return e};define(Pe[68],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=e.$Kh=e.$Jh=void 0;function S(R){return(m,f,k)=>{let O=null,D=null;if(typeof k.value=="function"?(O="value",D=k.value):typeof k.get=="function"&&(O="get",D=k.get),!D)throw new Error("not supported");k[O]=R(D,f)}}function M(R,m,f){let k=null,O=null;if(typeof f.value=="function"?(k="value",O=f.value,O.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(k="get",O=f.get),!O)throw new Error("not supported");const D=`$memoize$${m}`;f[k]=function(...l){return this.hasOwnProperty(D)||Object.defineProperty(this,D,{configurable:!1,enumerable:!1,writable:!1,value:O.apply(this,l)}),this[D]}}e.$Jh=M;function P(R,m,f){return S((k,O)=>{const D=`$debounce$${O}`,l=`$debounce$result$${O}`;return function(...E){this[l]||(this[l]=f?f():void 0),clearTimeout(this[D]),m&&(this[l]=m(this[l],...E),E=[this[l]]),this[D]=setTimeout(()=>{k.apply(this,E),this[l]=f?f():void 0},R)}})}e.$Kh=P;function F(R,m,f){return S((k,O)=>{const D=`$throttle$timer$${O}`,l=`$throttle$result$${O}`,E=`$throttle$lastRun$${O}`,g=`$throttle$pending$${O}`;return function(...s){if(this[l]||(this[l]=f?f():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),m&&(this[l]=m(this[l],...s)),this[g])return;const a=this[E]+R;a<=Date.now()?(this[E]=Date.now(),k.apply(this,[this[l]]),this[l]=f?f():void 0):(this[g]=!0,this[D]=setTimeout(()=>{this[g]=!1,this[E]=Date.now(),k.apply(this,[this[l]]),this[l]=f?f():void 0},a-Date.now()))}})}e.$Lh=F}),define(Pe[90],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rO=e.$qO=void 0;class S{constructor(P){this.a=P,this.b=0}nextId(){return this.a+ ++this.b}}e.$qO=S,e.$rO=new S("id#")}),define(Pe[122],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var S;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(S||(e.ScanError=S={}));var M;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(M||(e.SyntaxKind=M={}));var P;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(P||(e.ParseErrorCode=P={}));var F;(function(t){t.DEFAULT={allowTrailingComma:!0}})(F||(e.ParseOptions=F={}));function R(t,p=!1){let u=0;const o=t.length;let v="",b=0,$=16,I=0;function h(U){let C=0,L=0;for(;C<U;){const q=t.charCodeAt(u);if(q>=48&&q<=57)L=L*16+q-48;else if(q>=65&&q<=70)L=L*16+q-65+10;else if(q>=97&&q<=102)L=L*16+q-97+10;else break;u++,C++}return C<U&&(L=-1),L}function y(U){u=U,v="",b=0,$=16,I=0}function w(){const U=u;if(t.charCodeAt(u)===48)u++;else for(u++;u<t.length&&k(t.charCodeAt(u));)u++;if(u<t.length&&t.charCodeAt(u)===46)if(u++,u<t.length&&k(t.charCodeAt(u)))for(u++;u<t.length&&k(t.charCodeAt(u));)u++;else return I=3,t.substring(U,u);let C=u;if(u<t.length&&(t.charCodeAt(u)===69||t.charCodeAt(u)===101))if(u++,(u<t.length&&t.charCodeAt(u)===43||t.charCodeAt(u)===45)&&u++,u<t.length&&k(t.charCodeAt(u))){for(u++;u<t.length&&k(t.charCodeAt(u));)u++;C=u}else I=3;return t.substring(U,C)}function A(){let U="",C=u;for(;;){if(u>=o){U+=t.substring(C,u),I=2;break}const L=t.charCodeAt(u);if(L===34){U+=t.substring(C,u),u++;break}if(L===92){if(U+=t.substring(C,u),u++,u>=o){I=2;break}switch(t.charCodeAt(u++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const ne=h(4);ne>=0?U+=String.fromCharCode(ne):I=4;break}default:I=5}C=u;continue}if(L>=0&&L<=31)if(f(L)){U+=t.substring(C,u),I=2;break}else I=6;u++}return U}function N(){if(v="",I=0,b=u,u>=o)return b=o,$=17;let U=t.charCodeAt(u);if(m(U)){do u++,v+=String.fromCharCode(U),U=t.charCodeAt(u);while(m(U));return $=15}if(f(U))return u++,v+=String.fromCharCode(U),U===13&&t.charCodeAt(u)===10&&(u++,v+=`
`),$=14;switch(U){case 123:return u++,$=1;case 125:return u++,$=2;case 91:return u++,$=3;case 93:return u++,$=4;case 58:return u++,$=6;case 44:return u++,$=5;case 34:return u++,v=A(),$=10;case 47:{const C=u-1;if(t.charCodeAt(u+1)===47){for(u+=2;u<o&&!f(t.charCodeAt(u));)u++;return v=t.substring(C,u),$=12}if(t.charCodeAt(u+1)===42){u+=2;const L=o-1;let q=!1;for(;u<L;){if(t.charCodeAt(u)===42&&t.charCodeAt(u+1)===47){u+=2,q=!0;break}u++}return q||(u++,I=1),v=t.substring(C,u),$=13}return v+=String.fromCharCode(U),u++,$=16}case 45:if(v+=String.fromCharCode(U),u++,u===o||!k(t.charCodeAt(u)))return $=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return v+=w(),$=11;default:for(;u<o&&G(U);)u++,U=t.charCodeAt(u);if(b!==u){switch(v=t.substring(b,u),v){case"true":return $=8;case"false":return $=9;case"null":return $=7}return $=16}return v+=String.fromCharCode(U),u++,$=16}}function G(U){if(m(U)||f(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function V(){let U;do U=N();while(U>=12&&U<=15);return U}return{setPosition:y,getPosition:()=>u,scan:p?V:N,getToken:()=>$,getTokenValue:()=>v,getTokenOffset:()=>b,getTokenLength:()=>u-b,getTokenError:()=>I}}e.$pn=R;function m(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function f(t){return t===10||t===13||t===8232||t===8233}function k(t){return t>=48&&t<=57}var O;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(O||(O={}));function D(t,p){const u=[],o=new Object;let v;const b={value:{},offset:0,length:0,type:"object",parent:void 0};let $=!1;function I(h,y,w,A){b.value=h,b.offset=y,b.length=w,b.type=A,b.colonOffset=void 0,v=b}try{r(t,{onObjectBegin:(h,y)=>{if(p<=h)throw o;v=void 0,$=p>h,u.push("")},onObjectProperty:(h,y,w)=>{if(p<y||(I(h,y,w,"property"),u[u.length-1]=h,p<=y+w))throw o},onObjectEnd:(h,y)=>{if(p<=h)throw o;v=void 0,u.pop()},onArrayBegin:(h,y)=>{if(p<=h)throw o;v=void 0,u.push(0)},onArrayEnd:(h,y)=>{if(p<=h)throw o;v=void 0,u.pop()},onLiteralValue:(h,y,w)=>{if(p<y||(I(h,y,w,d(h)),p<=y+w))throw o},onSeparator:(h,y,w)=>{if(p<=y)throw o;if(h===":"&&v&&v.type==="property")v.colonOffset=y,$=!1,v=void 0;else if(h===","){const A=u[u.length-1];typeof A=="number"?u[u.length-1]=A+1:($=!0,u[u.length-1]=""),v=void 0}}})}catch(h){if(h!==o)throw h}return{path:u,previousNode:v,isAtPropertyKey:$,matches:h=>{let y=0;for(let w=0;y<h.length&&w<u.length;w++)if(h[y]===u[w]||h[y]==="*")y++;else if(h[y]!=="**")return!1;return y===h.length}}}e.$qn=D;function l(t,p=[],u=F.DEFAULT){let o=null,v=[];const b=[];function $(h){Array.isArray(v)?v.push(h):o!==null&&(v[o]=h)}return r(t,{onObjectBegin:()=>{const h={};$(h),b.push(v),v=h,o=null},onObjectProperty:h=>{o=h},onObjectEnd:()=>{v=b.pop()},onArrayBegin:()=>{const h=[];$(h),b.push(v),v=h,o=null},onArrayEnd:()=>{v=b.pop()},onLiteralValue:$,onError:(h,y,w)=>{p.push({error:h,offset:y,length:w})}},u),v[0]}e.$rn=l;function E(t,p=[],u=F.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function v(h){o.type==="property"&&(o.length=h-o.offset,o=o.parent)}function b(h){return o.children.push(h),h}r(t,{onObjectBegin:h=>{o=b({type:"object",offset:h,length:-1,parent:o,children:[]})},onObjectProperty:(h,y,w)=>{o=b({type:"property",offset:y,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:h,offset:y,length:w,parent:o})},onObjectEnd:(h,y)=>{o.length=h+y-o.offset,o=o.parent,v(h+y)},onArrayBegin:(h,y)=>{o=b({type:"array",offset:h,length:-1,parent:o,children:[]})},onArrayEnd:(h,y)=>{o.length=h+y-o.offset,o=o.parent,v(h+y)},onLiteralValue:(h,y,w)=>{b({type:d(h),offset:y,length:w,parent:o,value:h}),v(y+w)},onSeparator:(h,y,w)=>{o.type==="property"&&(h===":"?o.colonOffset=y:h===","&&v(y))},onError:(h,y,w)=>{p.push({error:h,offset:y,length:w})}},u);const I=o.children[0];return I&&delete I.parent,I}e.$sn=E;function g(t,p){if(!t)return;let u=t;for(const o of p)if(typeof o=="string"){if(u.type!=="object"||!Array.isArray(u.children))return;let v=!1;for(const b of u.children)if(Array.isArray(b.children)&&b.children[0].value===o){u=b.children[1],v=!0;break}if(!v)return}else{const v=o;if(u.type!=="array"||v<0||!Array.isArray(u.children)||v>=u.children.length)return;u=u.children[v]}return u}e.$tn=g;function s(t){if(!t.parent||!t.parent.children)return[];const p=s(t.parent);if(t.parent.type==="property"){const u=t.parent.children[0].value;p.push(u)}else if(t.parent.type==="array"){const u=t.parent.children.indexOf(t);u!==-1&&p.push(u)}return p}e.$un=s;function a(t){switch(t.type){case"array":return t.children.map(a);case"object":{const p=Object.create(null);for(const u of t.children){const o=u.children[1];o&&(p[u.children[0].value]=a(o))}return p}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$vn=a;function i(t,p,u=!1){return p>=t.offset&&p<t.offset+t.length||u&&p===t.offset+t.length}e.$wn=i;function n(t,p,u=!1){if(i(t,p,u)){const o=t.children;if(Array.isArray(o))for(let v=0;v<o.length&&o[v].offset<=p;v++){const b=n(o[v],p,u);if(b)return b}return t}}e.$xn=n;function r(t,p,u=F.DEFAULT){const o=R(t,!1);function v(re){return re?()=>re(o.getTokenOffset(),o.getTokenLength()):()=>!0}function b(re){return re?$e=>re($e,o.getTokenOffset(),o.getTokenLength()):()=>!0}const $=v(p.onObjectBegin),I=b(p.onObjectProperty),h=v(p.onObjectEnd),y=v(p.onArrayBegin),w=v(p.onArrayEnd),A=b(p.onLiteralValue),N=b(p.onSeparator),G=v(p.onComment),V=b(p.onError),U=u&&u.disallowComments,C=u&&u.allowTrailingComma;function L(){for(;;){const re=o.scan();switch(o.getTokenError()){case 4:q(14);break;case 5:q(15);break;case 3:q(13);break;case 1:U||q(11);break;case 2:q(12);break;case 6:q(16);break}switch(re){case 12:case 13:U?q(10):G();break;case 16:q(1);break;case 15:case 14:break;default:return re}}}function q(re,$e=[],ie=[]){if(V(re),$e.length+ie.length>0){let le=o.getToken();for(;le!==17;){if($e.indexOf(le)!==-1){L();break}else if(ie.indexOf(le)!==-1)break;le=L()}}}function ne(re){const $e=o.getTokenValue();return re?A($e):I($e),L(),!0}function ae(){switch(o.getToken()){case 11:{let re=0;try{re=JSON.parse(o.getTokenValue()),typeof re!="number"&&(q(2),re=0)}catch{q(2)}A(re);break}case 7:A(null);break;case 8:A(!0);break;case 9:A(!1);break;default:return!1}return L(),!0}function ye(){return o.getToken()!==10?(q(3,[],[2,5]),!1):(ne(!1),o.getToken()===6?(N(":"),L(),ve()||q(4,[],[2,5])):q(5,[],[2,5]),!0)}function Ie(){$(),L();let re=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(re||q(4,[],[]),N(","),L(),o.getToken()===2&&C)break}else re&&q(6,[],[]);ye()||q(4,[],[2,5]),re=!0}return h(),o.getToken()!==2?q(7,[2],[]):L(),!0}function ue(){y(),L();let re=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(re||q(4,[],[]),N(","),L(),o.getToken()===4&&C)break}else re&&q(6,[],[]);ve()||q(4,[],[4,5]),re=!0}return w(),o.getToken()!==4?q(8,[4],[]):L(),!0}function ve(){switch(o.getToken()){case 3:return ue();case 1:return Ie();case 10:return ne(!0);default:return ae()}}return L(),o.getToken()===17?u.allowEmptyContent?!0:(q(4,[],[]),!1):ve()?(o.getToken()!==17&&q(9,[],[]),!0):(q(4,[],[]),!1)}e.$yn=r;function c(t,p){const u=R(t),o=[];let v,b=0,$;do switch($=u.getPosition(),v=u.scan(),v){case 12:case 13:case 17:b!==$&&o.push(t.substring(b,$)),p!==void 0&&o.push(u.getTokenValue().replace(/[^\r\n]/g,p)),b=u.getPosition();break}while(v!==17);return o.join("")}e.$zn=c;function d(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$An=d}),function(me,e){typeof define=="function"&&define.amd?define(Pe[123],Re([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(me=typeof globalThis<"u"?globalThis:me||self,e(me.marked={}))}(this,function(me){"use strict";function e(De,be){for(var ge=0;ge<be.length;ge++){var J=be[ge];J.enumerable=J.enumerable||!1,J.configurable=!0,"value"in J&&(J.writable=!0),Object.defineProperty(De,J.key,J)}}function S(De,be,ge){return be&&e(De.prototype,be),ge&&e(De,ge),Object.defineProperty(De,"prototype",{writable:!1}),De}function M(De,be){if(De){if(typeof De=="string")return P(De,be);var ge=Object.prototype.toString.call(De).slice(8,-1);if(ge==="Object"&&De.constructor&&(ge=De.constructor.name),ge==="Map"||ge==="Set")return Array.from(De);if(ge==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ge))return P(De,be)}}function P(De,be){(be==null||be>De.length)&&(be=De.length);for(var ge=0,J=new Array(be);ge<be;ge++)J[ge]=De[ge];return J}function F(De,be){var ge=typeof Symbol<"u"&&De[Symbol.iterator]||De["@@iterator"];if(ge)return(ge=ge.call(De)).next.bind(ge);if(Array.isArray(De)||(ge=M(De))||be&&De&&typeof De.length=="number"){ge&&(De=ge);var J=0;return function(){return J>=De.length?{done:!0}:{done:!1,value:De[J++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}me.defaults=R();function m(De){me.defaults=De}var f=/[&<>"']/,k=/[&<>"']/g,O=/[<>"']|&(?!#?\w+;)/,D=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},E=function(be){return l[be]};function g(De,be){if(be){if(f.test(De))return De.replace(k,E)}else if(O.test(De))return De.replace(D,E);return De}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function a(De){return De.replace(s,function(be,ge){return ge=ge.toLowerCase(),ge==="colon"?":":ge.charAt(0)==="#"?ge.charAt(1)==="x"?String.fromCharCode(parseInt(ge.substring(2),16)):String.fromCharCode(+ge.substring(1)):""})}var i=/(^|[^\[])\^/g;function n(De,be){De=typeof De=="string"?De:De.source,be=be||"";var ge={replace:function(X,he){return he=he.source||he,he=he.replace(i,"$1"),De=De.replace(X,he),ge},getRegex:function(){return new RegExp(De,be)}};return ge}var r=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function d(De,be,ge){if(De){var J;try{J=decodeURIComponent(a(ge)).replace(r,"").toLowerCase()}catch{return null}if(J.indexOf("javascript:")===0||J.indexOf("vbscript:")===0||J.indexOf("data:")===0)return null}be&&!c.test(ge)&&(ge=v(be,ge));try{ge=encodeURI(ge).replace(/%25/g,"%")}catch{return null}return ge}var t={},p=/^[^:]+:\/*[^/]*$/,u=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function v(De,be){t[" "+De]||(p.test(De)?t[" "+De]=De+"/":t[" "+De]=h(De,"/",!0)),De=t[" "+De];var ge=De.indexOf(":")===-1;return be.substring(0,2)==="//"?ge?be:De.replace(u,"$1")+be:be.charAt(0)==="/"?ge?be:De.replace(o,"$1")+be:De+be}var b={exec:function(){}};function $(De){for(var be=1,ge,J;be<arguments.length;be++){ge=arguments[be];for(J in ge)Object.prototype.hasOwnProperty.call(ge,J)&&(De[J]=ge[J])}return De}function I(De,be){var ge=De.replace(/\|/g,function(he,fe,Fe){for(var de=!1,Ce=fe;--Ce>=0&&Fe[Ce]==="\\";)de=!de;return de?"|":" |"}),J=ge.split(/ \|/),X=0;if(J[0].trim()||J.shift(),J.length>0&&!J[J.length-1].trim()&&J.pop(),J.length>be)J.splice(be);else for(;J.length<be;)J.push("");for(;X<J.length;X++)J[X]=J[X].trim().replace(/\\\|/g,"|");return J}function h(De,be,ge){var J=De.length;if(J===0)return"";for(var X=0;X<J;){var he=De.charAt(J-X-1);if(he===be&&!ge)X++;else if(he!==be&&ge)X++;else break}return De.slice(0,J-X)}function y(De,be){if(De.indexOf(be[1])===-1)return-1;for(var ge=De.length,J=0,X=0;X<ge;X++)if(De[X]==="\\")X++;else if(De[X]===be[0])J++;else if(De[X]===be[1]&&(J--,J<0))return X;return-1}function w(De){De&&De.sanitize&&!De.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function A(De,be){if(be<1)return"";for(var ge="";be>1;)be&1&&(ge+=De),be>>=1,De+=De;return ge+De}function N(De,be,ge,J){var X=be.href,he=be.title?g(be.title):null,fe=De[1].replace(/\\([\[\]])/g,"$1");if(De[0].charAt(0)!=="!"){J.state.inLink=!0;var Fe={type:"link",raw:ge,href:X,title:he,text:fe,tokens:J.inlineTokens(fe)};return J.state.inLink=!1,Fe}return{type:"image",raw:ge,href:X,title:he,text:g(fe)}}function G(De,be){var ge=De.match(/^(\s+)(?:```)/);if(ge===null)return be;var J=ge[1];return be.split(`
`).map(function(X){var he=X.match(/^\s+/);if(he===null)return X;var fe=he[0];return fe.length>=J.length?X.slice(J.length):X}).join(`
`)}var V=function(){function De(ge){this.options=ge||me.defaults}var be=De.prototype;return be.space=function(J){var X=this.rules.block.newline.exec(J);if(X&&X[0].length>0)return{type:"space",raw:X[0]}},be.code=function(J){var X=this.rules.block.code.exec(J);if(X){var he=X[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:X[0],codeBlockStyle:"indented",text:this.options.pedantic?he:h(he,`
`)}}},be.fences=function(J){var X=this.rules.block.fences.exec(J);if(X){var he=X[0],fe=G(he,X[3]||"");return{type:"code",raw:he,lang:X[2]?X[2].trim():X[2],text:fe}}},be.heading=function(J){var X=this.rules.block.heading.exec(J);if(X){var he=X[2].trim();if(/#$/.test(he)){var fe=h(he,"#");(this.options.pedantic||!fe||/ $/.test(fe))&&(he=fe.trim())}return{type:"heading",raw:X[0],depth:X[1].length,text:he,tokens:this.lexer.inline(he)}}},be.hr=function(J){var X=this.rules.block.hr.exec(J);if(X)return{type:"hr",raw:X[0]}},be.blockquote=function(J){var X=this.rules.block.blockquote.exec(J);if(X){var he=X[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:X[0],tokens:this.lexer.blockTokens(he,[]),text:he}}},be.list=function(J){var X=this.rules.block.list.exec(J);if(X){var he,fe,Fe,de,Ce,Ae,je,z,j,K,H,ee,se=X[1].trim(),Oe=se.length>1,We={type:"list",raw:"",ordered:Oe,start:Oe?+se.slice(0,-1):"",loose:!1,items:[]};se=Oe?"\\d{1,9}\\"+se.slice(-1):"\\"+se,this.options.pedantic&&(se=Oe?se:"[*+-]");for(var Ke=new RegExp("^( {0,3}"+se+")((?:[	 ][^\\n]*)?(?:\\n|$))");J&&(ee=!1,!(!(X=Ke.exec(J))||this.rules.block.hr.test(J)));){if(he=X[0],J=J.substring(he.length),z=X[2].split(`
`,1)[0],j=J.split(`
`,1)[0],this.options.pedantic?(de=2,H=z.trimLeft()):(de=X[2].search(/[^ ]/),de=de>4?1:de,H=z.slice(de),de+=X[1].length),Ae=!1,!z&&/^ *$/.test(j)&&(he+=j+`
`,J=J.substring(j.length+1),ee=!0),!ee)for(var xe=new RegExp("^ {0,"+Math.min(3,de-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),tt=new RegExp("^ {0,"+Math.min(3,de-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),lt=new RegExp("^ {0,"+Math.min(3,de-1)+"}(?:```|~~~)"),rt=new RegExp("^ {0,"+Math.min(3,de-1)+"}#");J&&(K=J.split(`
`,1)[0],z=K,this.options.pedantic&&(z=z.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(lt.test(z)||rt.test(z)||xe.test(z)||tt.test(J)));){if(z.search(/[^ ]/)>=de||!z.trim())H+=`
`+z.slice(de);else if(!Ae)H+=`
`+z;else break;!Ae&&!z.trim()&&(Ae=!0),he+=K+`
`,J=J.substring(K.length+1)}We.loose||(je?We.loose=!0:/\n *\n *$/.test(he)&&(je=!0)),this.options.gfm&&(fe=/^\[[ xX]\] /.exec(H),fe&&(Fe=fe[0]!=="[ ] ",H=H.replace(/^\[[ xX]\] +/,""))),We.items.push({type:"list_item",raw:he,task:!!fe,checked:Fe,loose:!1,text:H}),We.raw+=he}We.items[We.items.length-1].raw=he.trimRight(),We.items[We.items.length-1].text=H.trimRight(),We.raw=We.raw.trimRight();var it=We.items.length;for(Ce=0;Ce<it;Ce++){this.lexer.state.top=!1,We.items[Ce].tokens=this.lexer.blockTokens(We.items[Ce].text,[]);var at=We.items[Ce].tokens.filter(function(et){return et.type==="space"}),Be=at.every(function(et){for(var Z=et.raw.split(""),Q=0,pe=F(Z),Ve;!(Ve=pe()).done;){var Ze=Ve.value;if(Ze===`
`&&(Q+=1),Q>1)return!0}return!1});!We.loose&&at.length&&Be&&(We.loose=!0,We.items[Ce].loose=!0)}return We}},be.html=function(J){var X=this.rules.block.html.exec(J);if(X){var he={type:"html",raw:X[0],pre:!this.options.sanitizer&&(X[1]==="pre"||X[1]==="script"||X[1]==="style"),text:X[0]};if(this.options.sanitize){var fe=this.options.sanitizer?this.options.sanitizer(X[0]):g(X[0]);he.type="paragraph",he.text=fe,he.tokens=this.lexer.inline(fe)}return he}},be.def=function(J){var X=this.rules.block.def.exec(J);if(X){X[3]&&(X[3]=X[3].substring(1,X[3].length-1));var he=X[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:he,raw:X[0],href:X[2],title:X[3]}}},be.table=function(J){var X=this.rules.block.table.exec(J);if(X){var he={type:"table",header:I(X[1]).map(function(je){return{text:je}}),align:X[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:X[3]&&X[3].trim()?X[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(he.header.length===he.align.length){he.raw=X[0];var fe=he.align.length,Fe,de,Ce,Ae;for(Fe=0;Fe<fe;Fe++)/^ *-+: *$/.test(he.align[Fe])?he.align[Fe]="right":/^ *:-+: *$/.test(he.align[Fe])?he.align[Fe]="center":/^ *:-+ *$/.test(he.align[Fe])?he.align[Fe]="left":he.align[Fe]=null;for(fe=he.rows.length,Fe=0;Fe<fe;Fe++)he.rows[Fe]=I(he.rows[Fe],he.header.length).map(function(je){return{text:je}});for(fe=he.header.length,de=0;de<fe;de++)he.header[de].tokens=this.lexer.inline(he.header[de].text);for(fe=he.rows.length,de=0;de<fe;de++)for(Ae=he.rows[de],Ce=0;Ce<Ae.length;Ce++)Ae[Ce].tokens=this.lexer.inline(Ae[Ce].text);return he}}},be.lheading=function(J){var X=this.rules.block.lheading.exec(J);if(X)return{type:"heading",raw:X[0],depth:X[2].charAt(0)==="="?1:2,text:X[1],tokens:this.lexer.inline(X[1])}},be.paragraph=function(J){var X=this.rules.block.paragraph.exec(J);if(X){var he=X[1].charAt(X[1].length-1)===`
`?X[1].slice(0,-1):X[1];return{type:"paragraph",raw:X[0],text:he,tokens:this.lexer.inline(he)}}},be.text=function(J){var X=this.rules.block.text.exec(J);if(X)return{type:"text",raw:X[0],text:X[0],tokens:this.lexer.inline(X[0])}},be.escape=function(J){var X=this.rules.inline.escape.exec(J);if(X)return{type:"escape",raw:X[0],text:g(X[1])}},be.tag=function(J){var X=this.rules.inline.tag.exec(J);if(X)return!this.lexer.state.inLink&&/^<a /i.test(X[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(X[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(X[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(X[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:X[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(X[0]):g(X[0]):X[0]}},be.link=function(J){var X=this.rules.inline.link.exec(J);if(X){var he=X[2].trim();if(!this.options.pedantic&&/^</.test(he)){if(!/>$/.test(he))return;var fe=h(he.slice(0,-1),"\\");if((he.length-fe.length)%2===0)return}else{var Fe=y(X[2],"()");if(Fe>-1){var de=X[0].indexOf("!")===0?5:4,Ce=de+X[1].length+Fe;X[2]=X[2].substring(0,Fe),X[0]=X[0].substring(0,Ce).trim(),X[3]=""}}var Ae=X[2],je="";if(this.options.pedantic){var z=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ae);z&&(Ae=z[1],je=z[3])}else je=X[3]?X[3].slice(1,-1):"";return Ae=Ae.trim(),/^</.test(Ae)&&(this.options.pedantic&&!/>$/.test(he)?Ae=Ae.slice(1):Ae=Ae.slice(1,-1)),N(X,{href:Ae&&Ae.replace(this.rules.inline._escapes,"$1"),title:je&&je.replace(this.rules.inline._escapes,"$1")},X[0],this.lexer)}},be.reflink=function(J,X){var he;if((he=this.rules.inline.reflink.exec(J))||(he=this.rules.inline.nolink.exec(J))){var fe=(he[2]||he[1]).replace(/\s+/g," ");if(fe=X[fe.toLowerCase()],!fe||!fe.href){var Fe=he[0].charAt(0);return{type:"text",raw:Fe,text:Fe}}return N(he,fe,he[0],this.lexer)}},be.emStrong=function(J,X,he){he===void 0&&(he="");var fe=this.rules.inline.emStrong.lDelim.exec(J);if(fe&&!(fe[3]&&he.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Fe=fe[1]||fe[2]||"";if(!Fe||Fe&&(he===""||this.rules.inline.punctuation.exec(he))){var de=fe[0].length-1,Ce,Ae,je=de,z=0,j=fe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(j.lastIndex=0,X=X.slice(-1*J.length+de);(fe=j.exec(X))!=null;)if(Ce=fe[1]||fe[2]||fe[3]||fe[4]||fe[5]||fe[6],!!Ce){if(Ae=Ce.length,fe[3]||fe[4]){je+=Ae;continue}else if((fe[5]||fe[6])&&de%3&&!((de+Ae)%3)){z+=Ae;continue}if(je-=Ae,!(je>0)){if(Ae=Math.min(Ae,Ae+je+z),Math.min(de,Ae)%2){var K=J.slice(1,de+fe.index+Ae);return{type:"em",raw:J.slice(0,de+fe.index+Ae+1),text:K,tokens:this.lexer.inlineTokens(K)}}var H=J.slice(2,de+fe.index+Ae-1);return{type:"strong",raw:J.slice(0,de+fe.index+Ae+1),text:H,tokens:this.lexer.inlineTokens(H)}}}}}},be.codespan=function(J){var X=this.rules.inline.code.exec(J);if(X){var he=X[2].replace(/\n/g," "),fe=/[^ ]/.test(he),Fe=/^ /.test(he)&&/ $/.test(he);return fe&&Fe&&(he=he.substring(1,he.length-1)),he=g(he,!0),{type:"codespan",raw:X[0],text:he}}},be.br=function(J){var X=this.rules.inline.br.exec(J);if(X)return{type:"br",raw:X[0]}},be.del=function(J){var X=this.rules.inline.del.exec(J);if(X)return{type:"del",raw:X[0],text:X[2],tokens:this.lexer.inlineTokens(X[2])}},be.autolink=function(J,X){var he=this.rules.inline.autolink.exec(J);if(he){var fe,Fe;return he[2]==="@"?(fe=g(this.options.mangle?X(he[1]):he[1]),Fe="mailto:"+fe):(fe=g(he[1]),Fe=fe),{type:"link",raw:he[0],text:fe,href:Fe,tokens:[{type:"text",raw:fe,text:fe}]}}},be.url=function(J,X){var he;if(he=this.rules.inline.url.exec(J)){var fe,Fe;if(he[2]==="@")fe=g(this.options.mangle?X(he[0]):he[0]),Fe="mailto:"+fe;else{var de;do de=he[0],he[0]=this.rules.inline._backpedal.exec(he[0])[0];while(de!==he[0]);fe=g(he[0]),he[1]==="www."?Fe="http://"+fe:Fe=fe}return{type:"link",raw:he[0],text:fe,href:Fe,tokens:[{type:"text",raw:fe,text:fe}]}}},be.inlineText=function(J,X){var he=this.rules.inline.text.exec(J);if(he){var fe;return this.lexer.state.inRawBlock?fe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):g(he[0]):he[0]:fe=g(this.options.smartypants?X(he[0]):he[0]),{type:"text",raw:he[0],text:fe}}},De}(),U={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:b,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};U._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,U._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,U.def=n(U.def).replace("label",U._label).replace("title",U._title).getRegex(),U.bullet=/(?:[*+-]|\d{1,9}[.)])/,U.listItemStart=n(/^( *)(bull) */).replace("bull",U.bullet).getRegex(),U.list=n(U.list).replace(/bull/g,U.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+U.def.source+")").getRegex(),U._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",U._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,U.html=n(U.html,"i").replace("comment",U._comment).replace("tag",U._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),U.paragraph=n(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.blockquote=n(U.blockquote).replace("paragraph",U.paragraph).getRegex(),U.normal=$({},U),U.gfm=$({},U.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),U.gfm.table=n(U.gfm.table).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.gfm.paragraph=n(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",U.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.pedantic=$({},U.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",U._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:b,paragraph:n(U.normal._paragraph).replace("hr",U.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",U.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var C={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:b,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:b,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};C._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",C.punctuation=n(C.punctuation).replace(/punctuation/g,C._punctuation).getRegex(),C.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,C.escapedEmSt=/\\\*|\\_/g,C._comment=n(U._comment).replace("(?:-->|$)","-->").getRegex(),C.emStrong.lDelim=n(C.emStrong.lDelim).replace(/punct/g,C._punctuation).getRegex(),C.emStrong.rDelimAst=n(C.emStrong.rDelimAst,"g").replace(/punct/g,C._punctuation).getRegex(),C.emStrong.rDelimUnd=n(C.emStrong.rDelimUnd,"g").replace(/punct/g,C._punctuation).getRegex(),C._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,C._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,C._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,C.autolink=n(C.autolink).replace("scheme",C._scheme).replace("email",C._email).getRegex(),C._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,C.tag=n(C.tag).replace("comment",C._comment).replace("attribute",C._attribute).getRegex(),C._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,C._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,C._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,C.link=n(C.link).replace("label",C._label).replace("href",C._href).replace("title",C._title).getRegex(),C.reflink=n(C.reflink).replace("label",C._label).replace("ref",U._label).getRegex(),C.nolink=n(C.nolink).replace("ref",U._label).getRegex(),C.reflinkSearch=n(C.reflinkSearch,"g").replace("reflink",C.reflink).replace("nolink",C.nolink).getRegex(),C.normal=$({},C),C.pedantic=$({},C.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",C._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",C._label).getRegex()}),C.gfm=$({},C.normal,{escape:n(C.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),C.gfm.url=n(C.gfm.url,"i").replace("email",C.gfm._extended_email).getRegex(),C.breaks=$({},C.gfm,{br:n(C.br).replace("{2,}","*").getRegex(),text:n(C.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function L(De){return De.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function q(De){var be="",ge,J,X=De.length;for(ge=0;ge<X;ge++)J=De.charCodeAt(ge),Math.random()>.5&&(J="x"+J.toString(16)),be+="&#"+J+";";return be}var ne=function(){function De(ge){this.tokens=[],this.tokens.links=Object.create(null),this.options=ge||me.defaults,this.options.tokenizer=this.options.tokenizer||new V,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var J={block:U.normal,inline:C.normal};this.options.pedantic?(J.block=U.pedantic,J.inline=C.pedantic):this.options.gfm&&(J.block=U.gfm,this.options.breaks?J.inline=C.breaks:J.inline=C.gfm),this.tokenizer.rules=J}De.lex=function(J,X){var he=new De(X);return he.lex(J)},De.lexInline=function(J,X){var he=new De(X);return he.inlineTokens(J)};var be=De.prototype;return be.lex=function(J){J=J.replace(/\r\n|\r/g,`
`),this.blockTokens(J,this.tokens);for(var X;X=this.inlineQueue.shift();)this.inlineTokens(X.src,X.tokens);return this.tokens},be.blockTokens=function(J,X){var he=this;X===void 0&&(X=[]),this.options.pedantic?J=J.replace(/\t/g,"    ").replace(/^ +$/gm,""):J=J.replace(/^( *)(\t+)/gm,function(je,z,j){return z+"    ".repeat(j.length)});for(var fe,Fe,de,Ce;J;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(je){return(fe=je.call({lexer:he},J,X))?(J=J.substring(fe.raw.length),X.push(fe),!0):!1}))){if(fe=this.tokenizer.space(J)){J=J.substring(fe.raw.length),fe.raw.length===1&&X.length>0?X[X.length-1].raw+=`
`:X.push(fe);continue}if(fe=this.tokenizer.code(J)){J=J.substring(fe.raw.length),Fe=X[X.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+fe.raw,Fe.text+=`
`+fe.text,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):X.push(fe);continue}if(fe=this.tokenizer.fences(J)){J=J.substring(fe.raw.length),X.push(fe);continue}if(fe=this.tokenizer.heading(J)){J=J.substring(fe.raw.length),X.push(fe);continue}if(fe=this.tokenizer.hr(J)){J=J.substring(fe.raw.length),X.push(fe);continue}if(fe=this.tokenizer.blockquote(J)){J=J.substring(fe.raw.length),X.push(fe);continue}if(fe=this.tokenizer.list(J)){J=J.substring(fe.raw.length),X.push(fe);continue}if(fe=this.tokenizer.html(J)){J=J.substring(fe.raw.length),X.push(fe);continue}if(fe=this.tokenizer.def(J)){J=J.substring(fe.raw.length),Fe=X[X.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+fe.raw,Fe.text+=`
`+fe.raw,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):this.tokens.links[fe.tag]||(this.tokens.links[fe.tag]={href:fe.href,title:fe.title});continue}if(fe=this.tokenizer.table(J)){J=J.substring(fe.raw.length),X.push(fe);continue}if(fe=this.tokenizer.lheading(J)){J=J.substring(fe.raw.length),X.push(fe);continue}if(de=J,this.options.extensions&&this.options.extensions.startBlock&&function(){var je=1/0,z=J.slice(1),j=void 0;he.options.extensions.startBlock.forEach(function(K){j=K.call({lexer:this},z),typeof j=="number"&&j>=0&&(je=Math.min(je,j))}),je<1/0&&je>=0&&(de=J.substring(0,je+1))}(),this.state.top&&(fe=this.tokenizer.paragraph(de))){Fe=X[X.length-1],Ce&&Fe.type==="paragraph"?(Fe.raw+=`
`+fe.raw,Fe.text+=`
`+fe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):X.push(fe),Ce=de.length!==J.length,J=J.substring(fe.raw.length);continue}if(fe=this.tokenizer.text(J)){J=J.substring(fe.raw.length),Fe=X[X.length-1],Fe&&Fe.type==="text"?(Fe.raw+=`
`+fe.raw,Fe.text+=`
`+fe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):X.push(fe);continue}if(J){var Ae="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return this.state.top=!0,X},be.inline=function(J,X){return X===void 0&&(X=[]),this.inlineQueue.push({src:J,tokens:X}),X},be.inlineTokens=function(J,X){var he=this;X===void 0&&(X=[]);var fe,Fe,de,Ce=J,Ae,je,z;if(this.tokens.links){var j=Object.keys(this.tokens.links);if(j.length>0)for(;(Ae=this.tokenizer.rules.inline.reflinkSearch.exec(Ce))!=null;)j.includes(Ae[0].slice(Ae[0].lastIndexOf("[")+1,-1))&&(Ce=Ce.slice(0,Ae.index)+"["+A("a",Ae[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ae=this.tokenizer.rules.inline.blockSkip.exec(Ce))!=null;)Ce=Ce.slice(0,Ae.index)+"["+A("a",Ae[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ae=this.tokenizer.rules.inline.escapedEmSt.exec(Ce))!=null;)Ce=Ce.slice(0,Ae.index)+"++"+Ce.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;J;)if(je||(z=""),je=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(H){return(fe=H.call({lexer:he},J,X))?(J=J.substring(fe.raw.length),X.push(fe),!0):!1}))){if(fe=this.tokenizer.escape(J)){J=J.substring(fe.raw.length),X.push(fe);continue}if(fe=this.tokenizer.tag(J)){J=J.substring(fe.raw.length),Fe=X[X.length-1],Fe&&fe.type==="text"&&Fe.type==="text"?(Fe.raw+=fe.raw,Fe.text+=fe.text):X.push(fe);continue}if(fe=this.tokenizer.link(J)){J=J.substring(fe.raw.length),X.push(fe);continue}if(fe=this.tokenizer.reflink(J,this.tokens.links)){J=J.substring(fe.raw.length),Fe=X[X.length-1],Fe&&fe.type==="text"&&Fe.type==="text"?(Fe.raw+=fe.raw,Fe.text+=fe.text):X.push(fe);continue}if(fe=this.tokenizer.emStrong(J,Ce,z)){J=J.substring(fe.raw.length),X.push(fe);continue}if(fe=this.tokenizer.codespan(J)){J=J.substring(fe.raw.length),X.push(fe);continue}if(fe=this.tokenizer.br(J)){J=J.substring(fe.raw.length),X.push(fe);continue}if(fe=this.tokenizer.del(J)){J=J.substring(fe.raw.length),X.push(fe);continue}if(fe=this.tokenizer.autolink(J,q)){J=J.substring(fe.raw.length),X.push(fe);continue}if(!this.state.inLink&&(fe=this.tokenizer.url(J,q))){J=J.substring(fe.raw.length),X.push(fe);continue}if(de=J,this.options.extensions&&this.options.extensions.startInline&&function(){var H=1/0,ee=J.slice(1),se=void 0;he.options.extensions.startInline.forEach(function(Oe){se=Oe.call({lexer:this},ee),typeof se=="number"&&se>=0&&(H=Math.min(H,se))}),H<1/0&&H>=0&&(de=J.substring(0,H+1))}(),fe=this.tokenizer.inlineText(de,L)){J=J.substring(fe.raw.length),fe.raw.slice(-1)!=="_"&&(z=fe.raw.slice(-1)),je=!0,Fe=X[X.length-1],Fe&&Fe.type==="text"?(Fe.raw+=fe.raw,Fe.text+=fe.text):X.push(fe);continue}if(J){var K="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(K);break}else throw new Error(K)}}return X},S(De,null,[{key:"rules",get:function(){return{block:U,inline:C}}}]),De}(),ae=function(){function De(ge){this.options=ge||me.defaults}var be=De.prototype;return be.code=function(J,X,he){var fe=(X||"").match(/\S*/)[0];if(this.options.highlight){var Fe=this.options.highlight(J,fe);Fe!=null&&Fe!==J&&(he=!0,J=Fe)}return J=J.replace(/\n$/,"")+`
`,fe?'<pre><code class="'+this.options.langPrefix+g(fe,!0)+'">'+(he?J:g(J,!0))+`</code></pre>
`:"<pre><code>"+(he?J:g(J,!0))+`</code></pre>
`},be.blockquote=function(J){return`<blockquote>
`+J+`</blockquote>
`},be.html=function(J){return J},be.heading=function(J,X,he,fe){if(this.options.headerIds){var Fe=this.options.headerPrefix+fe.slug(he);return"<h"+X+' id="'+Fe+'">'+J+"</h"+X+`>
`}return"<h"+X+">"+J+"</h"+X+`>
`},be.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},be.list=function(J,X,he){var fe=X?"ol":"ul",Fe=X&&he!==1?' start="'+he+'"':"";return"<"+fe+Fe+`>
`+J+"</"+fe+`>
`},be.listitem=function(J){return"<li>"+J+`</li>
`},be.checkbox=function(J){return"<input "+(J?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},be.paragraph=function(J){return"<p>"+J+`</p>
`},be.table=function(J,X){return X&&(X="<tbody>"+X+"</tbody>"),`<table>
<thead>
`+J+`</thead>
`+X+`</table>
`},be.tablerow=function(J){return`<tr>
`+J+`</tr>
`},be.tablecell=function(J,X){var he=X.header?"th":"td",fe=X.align?"<"+he+' align="'+X.align+'">':"<"+he+">";return fe+J+("</"+he+`>
`)},be.strong=function(J){return"<strong>"+J+"</strong>"},be.em=function(J){return"<em>"+J+"</em>"},be.codespan=function(J){return"<code>"+J+"</code>"},be.br=function(){return this.options.xhtml?"<br/>":"<br>"},be.del=function(J){return"<del>"+J+"</del>"},be.link=function(J,X,he){if(J=d(this.options.sanitize,this.options.baseUrl,J),J===null)return he;var fe='<a href="'+g(J)+'"';return X&&(fe+=' title="'+X+'"'),fe+=">"+he+"</a>",fe},be.image=function(J,X,he){if(J=d(this.options.sanitize,this.options.baseUrl,J),J===null)return he;var fe='<img src="'+J+'" alt="'+he+'"';return X&&(fe+=' title="'+X+'"'),fe+=this.options.xhtml?"/>":">",fe},be.text=function(J){return J},De}(),ye=function(){function De(){}var be=De.prototype;return be.strong=function(J){return J},be.em=function(J){return J},be.codespan=function(J){return J},be.del=function(J){return J},be.html=function(J){return J},be.text=function(J){return J},be.link=function(J,X,he){return""+he},be.image=function(J,X,he){return""+he},be.br=function(){return""},De}(),Ie=function(){function De(){this.seen={}}var be=De.prototype;return be.serialize=function(J){return J.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},be.getNextSafeSlug=function(J,X){var he=J,fe=0;if(this.seen.hasOwnProperty(he)){fe=this.seen[J];do fe++,he=J+"-"+fe;while(this.seen.hasOwnProperty(he))}return X||(this.seen[J]=fe,this.seen[he]=0),he},be.slug=function(J,X){X===void 0&&(X={});var he=this.serialize(J);return this.getNextSafeSlug(he,X.dryrun)},De}(),ue=function(){function De(ge){this.options=ge||me.defaults,this.options.renderer=this.options.renderer||new ae,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ye,this.slugger=new Ie}De.parse=function(J,X){var he=new De(X);return he.parse(J)},De.parseInline=function(J,X){var he=new De(X);return he.parseInline(J)};var be=De.prototype;return be.parse=function(J,X){X===void 0&&(X=!0);var he="",fe,Fe,de,Ce,Ae,je,z,j,K,H,ee,se,Oe,We,Ke,xe,tt,lt,rt,it=J.length;for(fe=0;fe<it;fe++){if(H=J[fe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[H.type]&&(rt=this.options.extensions.renderers[H.type].call({parser:this},H),rt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(H.type))){he+=rt||"";continue}switch(H.type){case"space":continue;case"hr":{he+=this.renderer.hr();continue}case"heading":{he+=this.renderer.heading(this.parseInline(H.tokens),H.depth,a(this.parseInline(H.tokens,this.textRenderer)),this.slugger);continue}case"code":{he+=this.renderer.code(H.text,H.lang,H.escaped);continue}case"table":{for(j="",z="",Ce=H.header.length,Fe=0;Fe<Ce;Fe++)z+=this.renderer.tablecell(this.parseInline(H.header[Fe].tokens),{header:!0,align:H.align[Fe]});for(j+=this.renderer.tablerow(z),K="",Ce=H.rows.length,Fe=0;Fe<Ce;Fe++){for(je=H.rows[Fe],z="",Ae=je.length,de=0;de<Ae;de++)z+=this.renderer.tablecell(this.parseInline(je[de].tokens),{header:!1,align:H.align[de]});K+=this.renderer.tablerow(z)}he+=this.renderer.table(j,K);continue}case"blockquote":{K=this.parse(H.tokens),he+=this.renderer.blockquote(K);continue}case"list":{for(ee=H.ordered,se=H.start,Oe=H.loose,Ce=H.items.length,K="",Fe=0;Fe<Ce;Fe++)Ke=H.items[Fe],xe=Ke.checked,tt=Ke.task,We="",Ke.task&&(lt=this.renderer.checkbox(xe),Oe?Ke.tokens.length>0&&Ke.tokens[0].type==="paragraph"?(Ke.tokens[0].text=lt+" "+Ke.tokens[0].text,Ke.tokens[0].tokens&&Ke.tokens[0].tokens.length>0&&Ke.tokens[0].tokens[0].type==="text"&&(Ke.tokens[0].tokens[0].text=lt+" "+Ke.tokens[0].tokens[0].text)):Ke.tokens.unshift({type:"text",text:lt}):We+=lt),We+=this.parse(Ke.tokens,Oe),K+=this.renderer.listitem(We,tt,xe);he+=this.renderer.list(K,ee,se);continue}case"html":{he+=this.renderer.html(H.text);continue}case"paragraph":{he+=this.renderer.paragraph(this.parseInline(H.tokens));continue}case"text":{for(K=H.tokens?this.parseInline(H.tokens):H.text;fe+1<it&&J[fe+1].type==="text";)H=J[++fe],K+=`
`+(H.tokens?this.parseInline(H.tokens):H.text);he+=X?this.renderer.paragraph(K):K;continue}default:{var at='Token with "'+H.type+'" type was not found.';if(this.options.silent){console.error(at);return}else throw new Error(at)}}}return he},be.parseInline=function(J,X){X=X||this.renderer;var he="",fe,Fe,de,Ce=J.length;for(fe=0;fe<Ce;fe++){if(Fe=J[fe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Fe.type]&&(de=this.options.extensions.renderers[Fe.type].call({parser:this},Fe),de!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Fe.type))){he+=de||"";continue}switch(Fe.type){case"escape":{he+=X.text(Fe.text);break}case"html":{he+=X.html(Fe.text);break}case"link":{he+=X.link(Fe.href,Fe.title,this.parseInline(Fe.tokens,X));break}case"image":{he+=X.image(Fe.href,Fe.title,Fe.text);break}case"strong":{he+=X.strong(this.parseInline(Fe.tokens,X));break}case"em":{he+=X.em(this.parseInline(Fe.tokens,X));break}case"codespan":{he+=X.codespan(Fe.text);break}case"br":{he+=X.br();break}case"del":{he+=X.del(this.parseInline(Fe.tokens,X));break}case"text":{he+=X.text(Fe.text);break}default:{var Ae='Token with "'+Fe.type+'" type was not found.';if(this.options.silent){console.error(Ae);return}else throw new Error(Ae)}}}return he},De}();function ve(De,be,ge){if(typeof De>"u"||De===null)throw new Error("marked(): input parameter is undefined or null");if(typeof De!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(De)+", string expected");if(typeof be=="function"&&(ge=be,be=null),be=$({},ve.defaults,be||{}),w(be),ge){var J=be.highlight,X;try{X=ne.lex(De,be)}catch(Ce){return ge(Ce)}var he=function(Ae){var je;if(!Ae)try{be.walkTokens&&ve.walkTokens(X,be.walkTokens),je=ue.parse(X,be)}catch(z){Ae=z}return be.highlight=J,Ae?ge(Ae):ge(null,je)};if(!J||J.length<3||(delete be.highlight,!X.length))return he();var fe=0;ve.walkTokens(X,function(Ce){Ce.type==="code"&&(fe++,setTimeout(function(){J(Ce.text,Ce.lang,function(Ae,je){if(Ae)return he(Ae);je!=null&&je!==Ce.text&&(Ce.text=je,Ce.escaped=!0),fe--,fe===0&&he()})},0))}),fe===0&&he();return}function Fe(Ce){if(Ce.message+=`
Please report this to https://github.com/markedjs/marked.`,be.silent)return"<p>An error occurred:</p><pre>"+g(Ce.message+"",!0)+"</pre>";throw Ce}try{var de=ne.lex(De,be);if(be.walkTokens){if(be.async)return Promise.all(ve.walkTokens(de,be.walkTokens)).then(function(){return ue.parse(de,be)}).catch(Fe);ve.walkTokens(de,be.walkTokens)}return ue.parse(de,be)}catch(Ce){Fe(Ce)}}ve.options=ve.setOptions=function(De){return $(ve.defaults,De),m(ve.defaults),ve},ve.getDefaults=R,ve.defaults=me.defaults,ve.use=function(){for(var De=arguments.length,be=new Array(De),ge=0;ge<De;ge++)be[ge]=arguments[ge];var J=$.apply(void 0,[{}].concat(be)),X=ve.defaults.extensions||{renderers:{},childTokens:{}},he;be.forEach(function(fe){if(fe.extensions&&(he=!0,fe.extensions.forEach(function(de){if(!de.name)throw new Error("extension name required");if(de.renderer){var Ce=X.renderers?X.renderers[de.name]:null;Ce?X.renderers[de.name]=function(){for(var Ae=arguments.length,je=new Array(Ae),z=0;z<Ae;z++)je[z]=arguments[z];var j=de.renderer.apply(this,je);return j===!1&&(j=Ce.apply(this,je)),j}:X.renderers[de.name]=de.renderer}if(de.tokenizer){if(!de.level||de.level!=="block"&&de.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");X[de.level]?X[de.level].unshift(de.tokenizer):X[de.level]=[de.tokenizer],de.start&&(de.level==="block"?X.startBlock?X.startBlock.push(de.start):X.startBlock=[de.start]:de.level==="inline"&&(X.startInline?X.startInline.push(de.start):X.startInline=[de.start]))}de.childTokens&&(X.childTokens[de.name]=de.childTokens)})),fe.renderer&&function(){var de=ve.defaults.renderer||new ae,Ce=function(z){var j=de[z];de[z]=function(){for(var K=arguments.length,H=new Array(K),ee=0;ee<K;ee++)H[ee]=arguments[ee];var se=fe.renderer[z].apply(de,H);return se===!1&&(se=j.apply(de,H)),se}};for(var Ae in fe.renderer)Ce(Ae);J.renderer=de}(),fe.tokenizer&&function(){var de=ve.defaults.tokenizer||new V,Ce=function(z){var j=de[z];de[z]=function(){for(var K=arguments.length,H=new Array(K),ee=0;ee<K;ee++)H[ee]=arguments[ee];var se=fe.tokenizer[z].apply(de,H);return se===!1&&(se=j.apply(de,H)),se}};for(var Ae in fe.tokenizer)Ce(Ae);J.tokenizer=de}(),fe.walkTokens){var Fe=ve.defaults.walkTokens;J.walkTokens=function(de){var Ce=[];return Ce.push(fe.walkTokens.call(this,de)),Fe&&(Ce=Ce.concat(Fe.call(this,de))),Ce}}he&&(J.extensions=X),ve.setOptions(J)})},ve.walkTokens=function(De,be){for(var ge=[],J=function(){var Fe=he.value;switch(ge=ge.concat(be.call(ve,Fe)),Fe.type){case"table":{for(var de=F(Fe.header),Ce;!(Ce=de()).done;){var Ae=Ce.value;ge=ge.concat(ve.walkTokens(Ae.tokens,be))}for(var je=F(Fe.rows),z;!(z=je()).done;)for(var j=z.value,K=F(j),H;!(H=K()).done;){var ee=H.value;ge=ge.concat(ve.walkTokens(ee.tokens,be))}break}case"list":{ge=ge.concat(ve.walkTokens(Fe.items,be));break}default:ve.defaults.extensions&&ve.defaults.extensions.childTokens&&ve.defaults.extensions.childTokens[Fe.type]?ve.defaults.extensions.childTokens[Fe.type].forEach(function(se){ge=ge.concat(ve.walkTokens(Fe[se],be))}):Fe.tokens&&(ge=ge.concat(ve.walkTokens(Fe.tokens,be)))}},X=F(De),he;!(he=X()).done;)J();return ge},ve.parseInline=function(De,be){if(typeof De>"u"||De===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof De!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(De)+", string expected");be=$({},ve.defaults,be||{}),w(be);try{var ge=ne.lexInline(De,be);return be.walkTokens&&ve.walkTokens(ge,be.walkTokens),ue.parseInline(ge,be)}catch(J){if(J.message+=`
Please report this to https://github.com/markedjs/marked.`,be.silent)return"<p>An error occurred:</p><pre>"+g(J.message+"",!0)+"</pre>";throw J}},ve.Parser=ue,ve.parser=ue.parse,ve.Renderer=ae,ve.TextRenderer=ye,ve.Lexer=ne,ve.lexer=ne.lex,ve.Tokenizer=V,ve.Slugger=Ie,ve.parse=ve;var re=ve.options,$e=ve.setOptions,ie=ve.use,le=ve.walkTokens,W=ve.parseInline,_=ve,ke=ue.parse,Ne=ne.lex;me.Lexer=ne,me.Parser=ue,me.Renderer=ae,me.Slugger=Ie,me.TextRenderer=ye,me.Tokenizer=V,me.getDefaults=R,me.lexer=Ne,me.marked=ve,me.options=re,me.parse=_,me.parseInline=W,me.parser=ke,me.setOptions=$e,me.use=ie,me.walkTokens=le,Object.defineProperty(me,"__esModule",{value:!0})}),define(Pe[124],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4j=void 0;function S(s){const a=F(s);if(a&&a.length>0)return new Uint32Array(a)}e.$4j=S;let M=0;const P=new Uint32Array(10);function F(s){if(M=0,R(s,D,4352),M>0||(R(s,l,4449),M>0)||(R(s,E,4520),M>0)||(R(s,g,12593),M))return P.subarray(0,M);if(s>=44032&&s<=55203){const a=s-44032,i=a%588,n=Math.floor(a/588),r=Math.floor(i/28),c=i%28-1;if(n<D.length?R(n,D,0):4352+n-12593<g.length&&R(4352+n,g,12593),r<l.length?R(r,l,0):4449+r-12593<g.length&&R(4449+r-12593,g,12593),c>=0&&(c<E.length?R(c,E,0):4520+c-12593<g.length&&R(4520+c-12593,g,12593)),M>0)return P.subarray(0,M)}}function R(s,a,i){s>=i&&s<i+a.length&&m(a[s-i])}function m(s){s!==0&&(P[M++]=s&255,s>>8&&(P[M++]=s>>8&255),s>>16&&(P[M++]=s>>16&255))}var f;(function(s){s[s.InitialConsonant=4352]="InitialConsonant",s[s.Vowel=4449]="Vowel",s[s.FinalConsonant=4520]="FinalConsonant",s[s.CompatibilityJamo=12593]="CompatibilityJamo"})(f||(f={}));var k;(function(s){s[s.NUL=0]="NUL",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z"})(k||(k={}));var O;(function(s){s[s.fa=24934]="fa",s[s.fg=26470]="fg",s[s.fq=29030]="fq",s[s.fr=29286]="fr",s[s.ft=29798]="ft",s[s.fv=30310]="fv",s[s.fx=30822]="fx",s[s.hk=27496]="hk",s[s.hl=27752]="hl",s[s.ho=28520]="ho",s[s.ml=27757]="ml",s[s.nj=27246]="nj",s[s.nl=27758]="nl",s[s.np=28782]="np",s[s.qt=29809]="qt",s[s.rt=29810]="rt",s[s.sg=26483]="sg",s[s.sw=30579]="sw"})(O||(O={}));const D=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),l=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),E=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),g=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Pe[125],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$im=e.$hm=e.$gm=e.rot=e.$em=void 0;function S(m,f,k){return Math.min(Math.max(m,f),k)}e.$em=S;function M(m,f){return(f+m%f)%f}e.rot=M;class P{constructor(){this.a=0}getNext(){return this.a++}}e.$gm=P;class F{constructor(){this.a=1,this.b=0}update(f){return this.b=this.b+(f-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$hm=F;class R{constructor(f){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(f),this.c.fill(0,0,f)}update(f){const k=this.c[this.d];return this.c[this.d]=f,this.d=(this.d+1)%this.c.length,this.e-=k,this.e+=f,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$im=R}),function(){function me(P){const F=[];typeof P=="number"&&F.push("code/timeOrigin",P);function R(f){F.push(f,Date.now())}function m(){const f=[];for(let k=0;k<F.length;k+=2)f.push({name:F[k],startTime:F[k+1]});return f}return{mark:R,getMarks:m}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?me():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const F=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const R of performance.getEntriesByType("mark"))F.push({name:R.name,startTime:Math.round(P+R.startTime)});return F}};if(typeof process=="object"){const P=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return me(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),me()}function S(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=S(M))}(),function(me,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var S=e();for(var M in S)(typeof exports=="object"?exports:me)[M]=S[M]}}(typeof self<"u"?self:this,function(){return function(me){var e={};function S(M){if(e[M])return e[M].exports;var P=e[M]={i:M,l:!1,exports:{}};return me[M].call(P.exports,P,P.exports,S),P.l=!0,P.exports}return S.m=me,S.c=e,S.d=function(M,P,F){S.o(M,P)||Object.defineProperty(M,P,{enumerable:!0,get:F})},S.r=function(M){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(M,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(M,"__esModule",{value:!0})},S.t=function(M,P){if(1&P&&(M=S(M)),8&P||4&P&&typeof M=="object"&&M&&M.__esModule)return M;var F=Object.create(null);if(S.r(F),Object.defineProperty(F,"default",{enumerable:!0,value:M}),2&P&&typeof M!="string")for(var R in M)S.d(F,R,function(m){return M[m]}.bind(null,R));return F},S.n=function(M){var P=M&&M.__esModule?function(){return M.default}:function(){return M};return S.d(P,"a",P),P},S.o=function(M,P){return Object.prototype.hasOwnProperty.call(M,P)},S.p="",S(S.s=0)}([function(me,e,S){(function(M){var P;e=me.exports=ie,P=typeof M=="object"&&M.env&&M.env.NODE_DEBUG&&/\bsemver\b/i.test(M.env.NODE_DEBUG)?function(){var j=Array.prototype.slice.call(arguments,0);j.unshift("SEMVER"),console.log.apply(console,j)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var F=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,m=e.re=[],f=e.src=[],k=0,O=k++;f[O]="0|[1-9]\\d*";var D=k++;f[D]="[0-9]+";var l=k++;f[l]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=k++;f[E]="("+f[O]+")\\.("+f[O]+")\\.("+f[O]+")";var g=k++;f[g]="("+f[D]+")\\.("+f[D]+")\\.("+f[D]+")";var s=k++;f[s]="(?:"+f[O]+"|"+f[l]+")";var a=k++;f[a]="(?:"+f[D]+"|"+f[l]+")";var i=k++;f[i]="(?:-("+f[s]+"(?:\\."+f[s]+")*))";var n=k++;f[n]="(?:-?("+f[a]+"(?:\\."+f[a]+")*))";var r=k++;f[r]="[0-9A-Za-z-]+";var c=k++;f[c]="(?:\\+("+f[r]+"(?:\\."+f[r]+")*))";var d=k++,t="v?"+f[E]+f[i]+"?"+f[c]+"?";f[d]="^"+t+"$";var p="[v=\\s]*"+f[g]+f[n]+"?"+f[c]+"?",u=k++;f[u]="^"+p+"$";var o=k++;f[o]="((?:<|>)?=?)";var v=k++;f[v]=f[D]+"|x|X|\\*";var b=k++;f[b]=f[O]+"|x|X|\\*";var $=k++;f[$]="[v=\\s]*("+f[b]+")(?:\\.("+f[b]+")(?:\\.("+f[b]+")(?:"+f[i]+")?"+f[c]+"?)?)?";var I=k++;f[I]="[v=\\s]*("+f[v]+")(?:\\.("+f[v]+")(?:\\.("+f[v]+")(?:"+f[n]+")?"+f[c]+"?)?)?";var h=k++;f[h]="^"+f[o]+"\\s*"+f[$]+"$";var y=k++;f[y]="^"+f[o]+"\\s*"+f[I]+"$";var w=k++;f[w]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var A=k++;f[A]="(?:~>?)";var N=k++;f[N]="(\\s*)"+f[A]+"\\s+",m[N]=new RegExp(f[N],"g");var G=k++;f[G]="^"+f[A]+f[$]+"$";var V=k++;f[V]="^"+f[A]+f[I]+"$";var U=k++;f[U]="(?:\\^)";var C=k++;f[C]="(\\s*)"+f[U]+"\\s+",m[C]=new RegExp(f[C],"g");var L=k++;f[L]="^"+f[U]+f[$]+"$";var q=k++;f[q]="^"+f[U]+f[I]+"$";var ne=k++;f[ne]="^"+f[o]+"\\s*("+p+")$|^$";var ae=k++;f[ae]="^"+f[o]+"\\s*("+t+")$|^$";var ye=k++;f[ye]="(\\s*)"+f[o]+"\\s*("+p+"|"+f[$]+")",m[ye]=new RegExp(f[ye],"g");var Ie=k++;f[Ie]="^\\s*("+f[$]+")\\s+-\\s+("+f[$]+")\\s*$";var ue=k++;f[ue]="^\\s*("+f[I]+")\\s+-\\s+("+f[I]+")\\s*$";var ve=k++;f[ve]="(<|>)?=?\\s*\\*";for(var re=0;re<35;re++)P(re,f[re]),m[re]||(m[re]=new RegExp(f[re]));function $e(j,K){if(j instanceof ie)return j;if(typeof j!="string"||j.length>F||!(K?m[u]:m[d]).test(j))return null;try{return new ie(j,K)}catch{return null}}function ie(j,K){if(j instanceof ie){if(j.loose===K)return j;j=j.version}else if(typeof j!="string")throw new TypeError("Invalid Version: "+j);if(j.length>F)throw new TypeError("version is longer than "+F+" characters");if(!(this instanceof ie))return new ie(j,K);P("SemVer",j,K),this.loose=K;var H=j.trim().match(K?m[u]:m[d]);if(!H)throw new TypeError("Invalid Version: "+j);if(this.raw=j,this.major=+H[1],this.minor=+H[2],this.patch=+H[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");H[4]?this.prerelease=H[4].split(".").map(function(ee){if(/^[0-9]+$/.test(ee)){var se=+ee;if(se>=0&&se<R)return se}return ee}):this.prerelease=[],this.build=H[5]?H[5].split("."):[],this.format()}e.parse=$e,e.valid=function(j,K){var H=$e(j,K);return H?H.version:null},e.clean=function(j,K){var H=$e(j.trim().replace(/^[=v]+/,""),K);return H?H.version:null},e.SemVer=ie,ie.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ie.prototype.toString=function(){return this.version},ie.prototype.compare=function(j){return P("SemVer.compare",this.version,this.loose,j),j instanceof ie||(j=new ie(j,this.loose)),this.compareMain(j)||this.comparePre(j)},ie.prototype.compareMain=function(j){return j instanceof ie||(j=new ie(j,this.loose)),W(this.major,j.major)||W(this.minor,j.minor)||W(this.patch,j.patch)},ie.prototype.comparePre=function(j){if(j instanceof ie||(j=new ie(j,this.loose)),this.prerelease.length&&!j.prerelease.length)return-1;if(!this.prerelease.length&&j.prerelease.length)return 1;if(!this.prerelease.length&&!j.prerelease.length)return 0;var K=0;do{var H=this.prerelease[K],ee=j.prerelease[K];if(P("prerelease compare",K,H,ee),H===void 0&&ee===void 0)return 0;if(ee===void 0)return 1;if(H===void 0)return-1;if(H!==ee)return W(H,ee)}while(++K)},ie.prototype.inc=function(j,K){switch(j){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",K);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",K);break;case"prepatch":this.prerelease.length=0,this.inc("patch",K),this.inc("pre",K);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",K),this.inc("pre",K);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var H=this.prerelease.length;--H>=0;)typeof this.prerelease[H]=="number"&&(this.prerelease[H]++,H=-2);H===-1&&this.prerelease.push(0)}K&&(this.prerelease[0]===K?isNaN(this.prerelease[1])&&(this.prerelease=[K,0]):this.prerelease=[K,0]);break;default:throw new Error("invalid increment argument: "+j)}return this.format(),this.raw=this.version,this},e.inc=function(j,K,H,ee){typeof H=="string"&&(ee=H,H=void 0);try{return new ie(j,H).inc(K,ee).version}catch{return null}},e.diff=function(j,K){if(De(j,K))return null;var H=$e(j),ee=$e(K);if(H.prerelease.length||ee.prerelease.length){for(var se in H)if((se==="major"||se==="minor"||se==="patch")&&H[se]!==ee[se])return"pre"+se;return"prerelease"}for(var se in H)if((se==="major"||se==="minor"||se==="patch")&&H[se]!==ee[se])return se},e.compareIdentifiers=W;var le=/^[0-9]+$/;function W(j,K){var H=le.test(j),ee=le.test(K);return H&&ee&&(j=+j,K=+K),H&&!ee?-1:ee&&!H?1:j<K?-1:j>K?1:0}function _(j,K,H){return new ie(j,H).compare(new ie(K,H))}function ke(j,K,H){return _(j,K,H)>0}function Ne(j,K,H){return _(j,K,H)<0}function De(j,K,H){return _(j,K,H)===0}function be(j,K,H){return _(j,K,H)!==0}function ge(j,K,H){return _(j,K,H)>=0}function J(j,K,H){return _(j,K,H)<=0}function X(j,K,H,ee){var se;switch(K){case"===":typeof j=="object"&&(j=j.version),typeof H=="object"&&(H=H.version),se=j===H;break;case"!==":typeof j=="object"&&(j=j.version),typeof H=="object"&&(H=H.version),se=j!==H;break;case"":case"=":case"==":se=De(j,H,ee);break;case"!=":se=be(j,H,ee);break;case">":se=ke(j,H,ee);break;case">=":se=ge(j,H,ee);break;case"<":se=Ne(j,H,ee);break;case"<=":se=J(j,H,ee);break;default:throw new TypeError("Invalid operator: "+K)}return se}function he(j,K){if(j instanceof he){if(j.loose===K)return j;j=j.value}if(!(this instanceof he))return new he(j,K);P("comparator",j,K),this.loose=K,this.parse(j),this.semver===fe?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(j,K){return W(K,j)},e.major=function(j,K){return new ie(j,K).major},e.minor=function(j,K){return new ie(j,K).minor},e.patch=function(j,K){return new ie(j,K).patch},e.compare=_,e.compareLoose=function(j,K){return _(j,K,!0)},e.rcompare=function(j,K,H){return _(K,j,H)},e.sort=function(j,K){return j.sort(function(H,ee){return e.compare(H,ee,K)})},e.rsort=function(j,K){return j.sort(function(H,ee){return e.rcompare(H,ee,K)})},e.gt=ke,e.lt=Ne,e.eq=De,e.neq=be,e.gte=ge,e.lte=J,e.cmp=X,e.Comparator=he;var fe={};function Fe(j,K){if(j instanceof Fe)return j.loose===K?j:new Fe(j.raw,K);if(j instanceof he)return new Fe(j.value,K);if(!(this instanceof Fe))return new Fe(j,K);if(this.loose=K,this.raw=j,this.set=j.split(/\s*\|\|\s*/).map(function(H){return this.parseRange(H.trim())},this).filter(function(H){return H.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+j);this.format()}function de(j){return!j||j.toLowerCase()==="x"||j==="*"}function Ce(j,K,H,ee,se,Oe,We,Ke,xe,tt,lt,rt,it){return((K=de(H)?"":de(ee)?">="+H+".0.0":de(se)?">="+H+"."+ee+".0":">="+K)+" "+(Ke=de(xe)?"":de(tt)?"<"+(+xe+1)+".0.0":de(lt)?"<"+xe+"."+(+tt+1)+".0":rt?"<="+xe+"."+tt+"."+lt+"-"+rt:"<="+Ke)).trim()}function Ae(j,K){for(var H=0;H<j.length;H++)if(!j[H].test(K))return!1;if(K.prerelease.length){for(H=0;H<j.length;H++)if(P(j[H].semver),j[H].semver!==fe&&j[H].semver.prerelease.length>0){var ee=j[H].semver;if(ee.major===K.major&&ee.minor===K.minor&&ee.patch===K.patch)return!0}return!1}return!0}function je(j,K,H){try{K=new Fe(K,H)}catch{return!1}return K.test(j)}function z(j,K,H,ee){var se,Oe,We,Ke,xe;switch(j=new ie(j,ee),K=new Fe(K,ee),H){case">":se=ke,Oe=J,We=Ne,Ke=">",xe=">=";break;case"<":se=Ne,Oe=ge,We=ke,Ke="<",xe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(je(j,K,ee))return!1;for(var tt=0;tt<K.set.length;++tt){var lt=K.set[tt],rt=null,it=null;if(lt.forEach(function(at){at.semver===fe&&(at=new he(">=0.0.0")),rt=rt||at,it=it||at,se(at.semver,rt.semver,ee)?rt=at:We(at.semver,it.semver,ee)&&(it=at)}),rt.operator===Ke||rt.operator===xe||(!it.operator||it.operator===Ke)&&Oe(j,it.semver)||it.operator===xe&&We(j,it.semver))return!1}return!0}he.prototype.parse=function(j){var K=this.loose?m[ne]:m[ae],H=j.match(K);if(!H)throw new TypeError("Invalid comparator: "+j);this.operator=H[1],this.operator==="="&&(this.operator=""),H[2]?this.semver=new ie(H[2],this.loose):this.semver=fe},he.prototype.toString=function(){return this.value},he.prototype.test=function(j){return P("Comparator.test",j,this.loose),this.semver===fe||(typeof j=="string"&&(j=new ie(j,this.loose)),X(j,this.operator,this.semver,this.loose))},he.prototype.intersects=function(j,K){if(!(j instanceof he))throw new TypeError("a Comparator is required");var H;if(this.operator==="")return H=new Fe(j.value,K),je(this.value,H,K);if(j.operator==="")return H=new Fe(this.value,K),je(j.semver,H,K);var ee=!(this.operator!==">="&&this.operator!==">"||j.operator!==">="&&j.operator!==">"),se=!(this.operator!=="<="&&this.operator!=="<"||j.operator!=="<="&&j.operator!=="<"),Oe=this.semver.version===j.semver.version,We=!(this.operator!==">="&&this.operator!=="<="||j.operator!==">="&&j.operator!=="<="),Ke=X(this.semver,"<",j.semver,K)&&(this.operator===">="||this.operator===">")&&(j.operator==="<="||j.operator==="<"),xe=X(this.semver,">",j.semver,K)&&(this.operator==="<="||this.operator==="<")&&(j.operator===">="||j.operator===">");return ee||se||Oe&&We||Ke||xe},e.Range=Fe,Fe.prototype.format=function(){return this.range=this.set.map(function(j){return j.join(" ").trim()}).join("||").trim(),this.range},Fe.prototype.toString=function(){return this.range},Fe.prototype.parseRange=function(j){var K=this.loose;j=j.trim(),P("range",j,K);var H=K?m[ue]:m[Ie];j=j.replace(H,Ce),P("hyphen replace",j),j=j.replace(m[ye],"$1$2$3"),P("comparator trim",j,m[ye]),j=(j=(j=j.replace(m[N],"$1~")).replace(m[C],"$1^")).split(/\s+/).join(" ");var ee=K?m[ne]:m[ae],se=j.split(" ").map(function(Oe){return function(We,Ke){return P("comp",We),We=function(xe,tt){return xe.trim().split(/\s+/).map(function(lt){return function(rt,it){P("caret",rt,it);var at=it?m[q]:m[L];return rt.replace(at,function(Be,et,Z,Q,pe){var Ve;return P("caret",rt,Be,et,Z,Q,pe),de(et)?Ve="":de(Z)?Ve=">="+et+".0.0 <"+(+et+1)+".0.0":de(Q)?Ve=et==="0"?">="+et+"."+Z+".0 <"+et+"."+(+Z+1)+".0":">="+et+"."+Z+".0 <"+(+et+1)+".0.0":pe?(P("replaceCaret pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),Ve=et==="0"?Z==="0"?">="+et+"."+Z+"."+Q+pe+" <"+et+"."+Z+"."+(+Q+1):">="+et+"."+Z+"."+Q+pe+" <"+et+"."+(+Z+1)+".0":">="+et+"."+Z+"."+Q+pe+" <"+(+et+1)+".0.0"):(P("no pr"),Ve=et==="0"?Z==="0"?">="+et+"."+Z+"."+Q+" <"+et+"."+Z+"."+(+Q+1):">="+et+"."+Z+"."+Q+" <"+et+"."+(+Z+1)+".0":">="+et+"."+Z+"."+Q+" <"+(+et+1)+".0.0"),P("caret return",Ve),Ve})}(lt,tt)}).join(" ")}(We,Ke),P("caret",We),We=function(xe,tt){return xe.trim().split(/\s+/).map(function(lt){return function(rt,it){var at=it?m[V]:m[G];return rt.replace(at,function(Be,et,Z,Q,pe){var Ve;return P("tilde",rt,Be,et,Z,Q,pe),de(et)?Ve="":de(Z)?Ve=">="+et+".0.0 <"+(+et+1)+".0.0":de(Q)?Ve=">="+et+"."+Z+".0 <"+et+"."+(+Z+1)+".0":pe?(P("replaceTilde pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),Ve=">="+et+"."+Z+"."+Q+pe+" <"+et+"."+(+Z+1)+".0"):Ve=">="+et+"."+Z+"."+Q+" <"+et+"."+(+Z+1)+".0",P("tilde return",Ve),Ve})}(lt,tt)}).join(" ")}(We,Ke),P("tildes",We),We=function(xe,tt){return P("replaceXRanges",xe,tt),xe.split(/\s+/).map(function(lt){return function(rt,it){rt=rt.trim();var at=it?m[y]:m[h];return rt.replace(at,function(Be,et,Z,Q,pe,Ve){P("xRange",rt,Be,et,Z,Q,pe,Ve);var Ze=de(Z),st=Ze||de(Q),Me=st||de(pe);return et==="="&&Me&&(et=""),Ze?Be=et===">"||et==="<"?"<0.0.0":"*":et&&Me?(st&&(Q=0),Me&&(pe=0),et===">"?(et=">=",st?(Z=+Z+1,Q=0,pe=0):Me&&(Q=+Q+1,pe=0)):et==="<="&&(et="<",st?Z=+Z+1:Q=+Q+1),Be=et+Z+"."+Q+"."+pe):st?Be=">="+Z+".0.0 <"+(+Z+1)+".0.0":Me&&(Be=">="+Z+"."+Q+".0 <"+Z+"."+(+Q+1)+".0"),P("xRange return",Be),Be})}(lt,tt)}).join(" ")}(We,Ke),P("xrange",We),We=function(xe,tt){return P("replaceStars",xe,tt),xe.trim().replace(m[ve],"")}(We,Ke),P("stars",We),We}(Oe,K)}).join(" ").split(/\s+/);return this.loose&&(se=se.filter(function(Oe){return!!Oe.match(ee)})),se=se.map(function(Oe){return new he(Oe,K)})},Fe.prototype.intersects=function(j,K){if(!(j instanceof Fe))throw new TypeError("a Range is required");return this.set.some(function(H){return H.every(function(ee){return j.set.some(function(se){return se.every(function(Oe){return ee.intersects(Oe,K)})})})})},e.toComparators=function(j,K){return new Fe(j,K).set.map(function(H){return H.map(function(ee){return ee.value}).join(" ").trim().split(" ")})},Fe.prototype.test=function(j){if(!j)return!1;typeof j=="string"&&(j=new ie(j,this.loose));for(var K=0;K<this.set.length;K++)if(Ae(this.set[K],j))return!0;return!1},e.satisfies=je,e.maxSatisfying=function(j,K,H){var ee=null,se=null;try{var Oe=new Fe(K,H)}catch{return null}return j.forEach(function(We){Oe.test(We)&&(ee&&se.compare(We)!==-1||(se=new ie(ee=We,H)))}),ee},e.minSatisfying=function(j,K,H){var ee=null,se=null;try{var Oe=new Fe(K,H)}catch{return null}return j.forEach(function(We){Oe.test(We)&&(ee&&se.compare(We)!==1||(se=new ie(ee=We,H)))}),ee},e.validRange=function(j,K){try{return new Fe(j,K).range||"*"}catch{return null}},e.ltr=function(j,K,H){return z(j,K,"<",H)},e.gtr=function(j,K,H){return z(j,K,">",H)},e.outside=z,e.prerelease=function(j,K){var H=$e(j,K);return H&&H.prerelease.length?H.prerelease:null},e.intersects=function(j,K,H){return j=new Fe(j,H),K=new Fe(K,H),j.intersects(K)},e.coerce=function(j){if(j instanceof ie)return j;if(typeof j!="string")return null;var K=j.match(m[w]);return K==null?null:$e((K[1]||"0")+"."+(K[2]||"0")+"."+(K[3]||"0"))}}).call(this,S(1))},function(me,e){var S,M,P=me.exports={};function F(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function m(a){if(S===setTimeout)return setTimeout(a,0);if((S===F||!S)&&setTimeout)return S=setTimeout,setTimeout(a,0);try{return S(a,0)}catch{try{return S.call(null,a,0)}catch{return S.call(this,a,0)}}}(function(){try{S=typeof setTimeout=="function"?setTimeout:F}catch{S=F}try{M=typeof clearTimeout=="function"?clearTimeout:R}catch{M=R}})();var f,k=[],O=!1,D=-1;function l(){O&&f&&(O=!1,f.length?k=f.concat(k):D=-1,k.length&&E())}function E(){if(!O){var a=m(l);O=!0;for(var i=k.length;i;){for(f=k,k=[];++D<i;)f&&f[D].run();D=-1,i=k.length}f=null,O=!1,function(n){if(M===clearTimeout)return clearTimeout(n);if((M===R||!M)&&clearTimeout)return M=clearTimeout,clearTimeout(n);try{M(n)}catch{try{return M.call(null,n)}catch{return M.call(this,n)}}}(a)}}function g(a,i){this.fun=a,this.array=i}function s(){}P.nextTick=function(a){var i=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)i[n-1]=arguments[n];k.push(new g(a,i)),k.length!==1||O||m(E)},g.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=s,P.addListener=s,P.once=s,P.off=s,P.removeListener=s,P.removeAllListeners=s,P.emit=s,P.prependListener=s,P.prependOnceListener=s,P.listeners=function(a){return[]},P.binding=function(a){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(a){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(Pe[126],Re([1,0,14,6]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=void 0;function P(c){const d=c;return d?typeof d.read=="function":!1}e.$de=P;function F(c){const d=c;return d?[d.on,d.pause,d.resume,d.destroy].every(t=>typeof t=="function"):!1}e.$ee=F;function R(c){const d=c;return d?F(d.stream)&&Array.isArray(d.buffer)&&typeof d.ended=="boolean":!1}e.$fe=R;function m(c,d){return new f(c,d)}e.$ge=m;class f{constructor(d,t){this.e=d,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(d){if(!this.a.destroyed){if(this.a.flowing)this.g(d);else if(this.b.data.push(d),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(d){this.a.destroyed||(this.a.flowing?this.h(d):this.b.error.push(d))}end(d){this.a.destroyed||(typeof d<"u"&&this.write(d),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(d){this.c.data.slice(0).forEach(t=>t(d))}h(d){this.c.error.length===0?(0,S.$1)(d):this.c.error.slice(0).forEach(t=>t(d))}i(){this.c.end.slice(0).forEach(d=>d())}on(d,t){if(!this.a.destroyed)switch(d){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(d,t){if(this.a.destroyed)return;let p;switch(d){case"data":p=this.c.data;break;case"end":p=this.c.end;break;case"error":p=this.c.error;break}if(p){const u=p.indexOf(t);u>=0&&p.splice(u,1)}}j(){if(this.b.data.length>0){const d=this.e(this.b.data);this.g(d),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(p=>p())}}k(){if(this.c.error.length>0){for(const d of this.b.error)this.h(d);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function k(c,d){const t=[];let p;for(;(p=c.read())!==null;)t.push(p);return d(t)}e.$he=k;function O(c,d,t){const p=[];let u;for(;(u=c.read())!==null&&p.length<t;)p.push(u);return u===null&&p.length>0?d(p):{read:()=>{if(p.length>0)return p.shift();if(typeof u<"u"){const o=u;return u=void 0,o}return c.read()}}}e.$ie=O;function D(c,d){return new Promise((t,p)=>{const u=[];l(c,{onData:o=>{d&&u.push(o)},onError:o=>{d?p(o):t(void 0)},onEnd:()=>{t(d?d(u):void 0)}})})}e.$je=D;function l(c,d,t){c.on("error",p=>{t?.isCancellationRequested||d.onError(p)}),c.on("end",()=>{t?.isCancellationRequested||d.onEnd()}),c.on("data",p=>{t?.isCancellationRequested||d.onData(p)})}e.$ke=l;function E(c,d){return new Promise((t,p)=>{const u=new M.$Sc,o=[],v=I=>{if(o.push(I),o.length>d)return u.dispose(),c.pause(),t({stream:c,buffer:o,ended:!1})},b=I=>(u.dispose(),p(I)),$=()=>(u.dispose(),t({stream:c,buffer:o,ended:!0}));u.add((0,M.$Rc)(()=>c.removeListener("error",b))),c.on("error",b),u.add((0,M.$Rc)(()=>c.removeListener("end",$))),c.on("end",$),u.add((0,M.$Rc)(()=>c.removeListener("data",v))),c.on("data",v)})}e.$le=E;function g(c,d){const t=m(d);return t.end(c),t}e.$me=g;function s(){const c=m(()=>{throw new Error("not supported")});return c.end(),c}e.$ne=s;function a(c){let d=!1;return{read:()=>d?null:(d=!0,c)}}e.$oe=a;function i(c,d,t){const p=m(t);return l(c,{onData:u=>p.write(d.data(u)),onError:u=>p.error(d.error?d.error(u):u),onEnd:()=>p.end()}),p}e.$pe=i;function n(c,d,t){let p=!1;return{read:()=>{const u=d.read();return p?u:(p=!0,u!==null?t([c,u]):c)}}}e.$qe=n;function r(c,d,t){let p=!1;const u=m(t);return l(d,{onData:o=>p?u.write(o):(p=!0,u.write(t([c,o]))),onError:o=>u.error(o),onEnd:()=>{p||(p=!0,u.write(c)),u.end()}}),u}e.$re=r}),define(Pe[23],Re([1,0,39,126]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=void 0;const P=typeof Buffer<"u",F=new S.$V(()=>new Uint8Array(256));let R,m;class f{static alloc(w){return P?new f(Buffer.allocUnsafe(w)):new f(new Uint8Array(w))}static wrap(w){return P&&!Buffer.isBuffer(w)&&(w=Buffer.from(w.buffer,w.byteOffset,w.byteLength)),new f(w)}static fromString(w,A){return!(A?.dontUseNodeBuffer||!1)&&P?new f(Buffer.from(w)):(R||(R=new TextEncoder),new f(R.encode(w)))}static fromByteArray(w){const A=f.alloc(w.length);for(let N=0,G=w.length;N<G;N++)A.buffer[N]=w[N];return A}static concat(w,A){if(typeof A>"u"){A=0;for(let V=0,U=w.length;V<U;V++)A+=w[V].byteLength}const N=f.alloc(A);let G=0;for(let V=0,U=w.length;V<U;V++){const C=w[V];N.set(C,G),G+=C.byteLength}return N}constructor(w){this.buffer=w,this.byteLength=this.buffer.byteLength}clone(){const w=f.alloc(this.byteLength);return w.set(this),w}toString(){return P?this.buffer.toString():(m||(m=new TextDecoder),m.decode(this.buffer))}slice(w,A){return new f(this.buffer.subarray(w,A))}set(w,A){if(w instanceof f)this.buffer.set(w.buffer,A);else if(w instanceof Uint8Array)this.buffer.set(w,A);else if(w instanceof ArrayBuffer)this.buffer.set(new Uint8Array(w),A);else if(ArrayBuffer.isView(w))this.buffer.set(new Uint8Array(w.buffer,w.byteOffset,w.byteLength),A);else throw new Error("Unknown argument 'array'")}readUInt32BE(w){return l(this.buffer,w)}writeUInt32BE(w,A){E(this.buffer,w,A)}readUInt32LE(w){return g(this.buffer,w)}writeUInt32LE(w,A){s(this.buffer,w,A)}readUInt8(w){return a(this.buffer,w)}writeUInt8(w,A){i(this.buffer,w,A)}indexOf(w,A=0){return k(this.buffer,w instanceof f?w.buffer:w,A)}}e.$se=f;function k(y,w,A=0){const N=w.byteLength,G=y.byteLength;if(N===0)return 0;if(N===1)return y.indexOf(w[0]);if(N>G-A)return-1;const V=F.value;V.fill(w.length);for(let q=0;q<w.length;q++)V[w[q]]=w.length-q-1;let U=A+w.length-1,C=U,L=-1;for(;U<G;)if(y[U]===w[C]){if(C===0){L=U;break}U--,C--}else U+=Math.max(w.length-C,V[y[U]]),C=w.length-1;return L}e.$te=k;function O(y,w){return y[w+0]<<0>>>0|y[w+1]<<8>>>0}e.$ue=O;function D(y,w,A){y[A+0]=w&255,w=w>>>8,y[A+1]=w&255}e.$ve=D;function l(y,w){return y[w]*2**24+y[w+1]*2**16+y[w+2]*2**8+y[w+3]}e.$we=l;function E(y,w,A){y[A+3]=w,w=w>>>8,y[A+2]=w,w=w>>>8,y[A+1]=w,w=w>>>8,y[A]=w}e.$xe=E;function g(y,w){return y[w+0]<<0>>>0|y[w+1]<<8>>>0|y[w+2]<<16>>>0|y[w+3]<<24>>>0}e.$ye=g;function s(y,w,A){y[A+0]=w&255,w=w>>>8,y[A+1]=w&255,w=w>>>8,y[A+2]=w&255,w=w>>>8,y[A+3]=w&255}e.$ze=s;function a(y,w){return y[w]}e.$Ae=a;function i(y,w,A){y[A]=w}e.$Be=i;function n(y){return M.$he(y,w=>f.concat(w))}e.$Ce=n;function r(y){return M.$oe(y)}e.$De=r;function c(y){return M.$je(y,w=>f.concat(w))}e.$Ee=c;async function d(y){return y.ended?f.concat(y.buffer):f.concat([...y.buffer,await c(y.stream)])}e.$Fe=d;function t(y){return M.$me(y,w=>f.concat(w))}e.$Ge=t;function p(y){return M.$pe(y,{data:w=>typeof w=="string"?f.fromString(w):f.wrap(w)},w=>f.concat(w))}e.$He=p;function u(y){return M.$ge(w=>f.concat(w),y)}e.$Ie=u;function o(y,w){return M.$qe(y,w,A=>f.concat(A))}e.$Je=o;function v(y,w){return M.$re(y,w,A=>f.concat(A))}e.$Ke=v;function b(y){let w=0,A=0,N=0;const G=new Uint8Array(Math.floor(y.length/4*3)),V=C=>{switch(A){case 3:G[N++]=w|C,A=0;break;case 2:G[N++]=w|C>>>2,w=C<<6,A=3;break;case 1:G[N++]=w|C>>>4,w=C<<4,A=2;break;default:w=C<<2,A=1}};for(let C=0;C<y.length;C++){const L=y.charCodeAt(C);if(L>=65&&L<=90)V(L-65);else if(L>=97&&L<=122)V(L-97+26);else if(L>=48&&L<=57)V(L-48+52);else if(L===43||L===45)V(62);else if(L===47||L===95)V(63);else{if(L===61)break;throw new SyntaxError(`Unexpected base64 character ${y[C]}`)}}const U=N;for(;A>0;)V(0);return f.wrap(G).slice(0,U)}e.$Le=b;const $="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function h({buffer:y},w=!0,A=!1){const N=A?I:$;let G="";const V=y.byteLength%3;let U=0;for(;U<y.byteLength-V;U+=3){const C=y[U+0],L=y[U+1],q=y[U+2];G+=N[C>>>2],G+=N[(C<<4|L>>>4)&63],G+=N[(L<<2|q>>>6)&63],G+=N[q&63]}if(V===1){const C=y[U+0];G+=N[C>>>2],G+=N[C<<4&63],w&&(G+="==")}else if(V===2){const C=y[U+0],L=y[U+1];G+=N[C>>>2],G+=N[(C<<4|L>>>4)&63],G+=N[L<<2&63],w&&(G+="=")}return G}e.$Me=h}),define(Pe[127],Re([1,0,28,124,15]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ik=e.$hk=e.$gk=e.$fk=e.FuzzyScore=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=e.$6j=e.or=void 0;function F(...de){return function(Ce,Ae){for(let je=0,z=de.length;je<z;je++){const j=de[je](Ce,Ae);if(j)return j}return null}}e.or=F,e.$6j=R.bind(void 0,!1),e.$7j=R.bind(void 0,!0);function R(de,Ce,Ae){if(!Ae||Ae.length<Ce.length)return null;let je;return de?je=P.$kf(Ae,Ce):je=Ae.indexOf(Ce)===0,je?Ce.length>0?[{start:0,end:Ce.length}]:[]:null}function m(de,Ce){const Ae=Ce.toLowerCase().indexOf(de.toLowerCase());return Ae===-1?null:[{start:Ae,end:Ae+de.length}]}e.$8j=m;function f(de,Ce){return k(de.toLowerCase(),Ce.toLowerCase(),0,0)}e.$9j=f;function k(de,Ce,Ae,je){if(Ae===de.length)return[];if(je===Ce.length)return null;if(de[Ae]===Ce[je]){let z=null;return(z=k(de,Ce,Ae+1,je+1))?c({start:je,end:je+1},z):null}return k(de,Ce,Ae,je+1)}function O(de){return 97<=de&&de<=122}function D(de){return 65<=de&&de<=90}e.$0j=D;function l(de){return 48<=de&&de<=57}function E(de){return de===32||de===9||de===10||de===13}const g=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(de=>g.add(de.charCodeAt(0)));function s(de){return E(de)||g.has(de)}function a(de,Ce){return de===Ce||s(de)&&s(Ce)}const i=new Map;function n(de){if(i.has(de))return i.get(de);let Ce;const Ae=(0,M.$4j)(de);return Ae&&(Ce=Ae),i.set(de,Ce),Ce}function r(de){return O(de)||D(de)||l(de)}function c(de,Ce){return Ce.length===0?Ce=[de]:de.end===Ce[0].start?Ce[0].start=de.start:Ce.unshift(de),Ce}function d(de,Ce){for(let Ae=Ce;Ae<de.length;Ae++){const je=de.charCodeAt(Ae);if(D(je)||l(je)||Ae>0&&!r(de.charCodeAt(Ae-1)))return Ae}return de.length}function t(de,Ce,Ae,je){if(Ae===de.length)return[];if(je===Ce.length)return null;if(de[Ae]!==Ce[je].toLowerCase())return null;{let z=null,j=je+1;for(z=t(de,Ce,Ae+1,je+1);!z&&(j=d(Ce,j))<Ce.length;)z=t(de,Ce,Ae+1,j),j++;return z===null?null:c({start:je,end:je+1},z)}}function p(de){let Ce=0,Ae=0,je=0,z=0,j=0;for(let Oe=0;Oe<de.length;Oe++)j=de.charCodeAt(Oe),D(j)&&Ce++,O(j)&&Ae++,r(j)&&je++,l(j)&&z++;const K=Ce/de.length,H=Ae/de.length,ee=je/de.length,se=z/de.length;return{upperPercent:K,lowerPercent:H,alphaPercent:ee,numericPercent:se}}function u(de){const{upperPercent:Ce,lowerPercent:Ae}=de;return Ae===0&&Ce>.6}function o(de){const{upperPercent:Ce,lowerPercent:Ae,alphaPercent:je,numericPercent:z}=de;return Ae>.2&&Ce<.8&&je>.6&&z<.2}function v(de){let Ce=0,Ae=0,je=0,z=0;for(let j=0;j<de.length;j++)je=de.charCodeAt(j),D(je)&&Ce++,O(je)&&Ae++,E(je)&&z++;return(Ce===0||Ae===0)&&z===0?de.length<=30:Ce<=5}function b(de,Ce){if(!Ce||(Ce=Ce.trim(),Ce.length===0)||!v(de))return null;Ce.length>60&&(Ce=Ce.substring(0,60));const Ae=p(Ce);if(!o(Ae)){if(!u(Ae))return null;Ce=Ce.toLowerCase()}let je=null,z=0;for(de=de.toLowerCase();z<Ce.length&&(je=t(de,Ce,0,z))===null;)z=d(Ce,z+1);return je}e.$$j=b;function $(de,Ce,Ae=!1){if(!Ce||Ce.length===0)return null;let je=null,z=0;for(de=de.toLowerCase(),Ce=Ce.toLowerCase();z<Ce.length&&(je=I(de,Ce,0,z,Ae),je===null);)z=h(Ce,z+1);return je}e.$_j=$;function I(de,Ce,Ae,je,z){let j=0;if(Ae===de.length)return[];if(je===Ce.length)return null;if(!a(de.charCodeAt(Ae),Ce.charCodeAt(je))){const ee=n(de.charCodeAt(Ae));if(!ee)return null;for(let se=0;se<ee.length;se++)if(!a(ee[se],Ce.charCodeAt(je+se)))return null;j+=ee.length-1}let K=null,H=je+j+1;if(K=I(de,Ce,Ae+1,H,z),!z)for(;!K&&(H=h(Ce,H))<Ce.length;)K=I(de,Ce,Ae+1,H,z),H++;if(!K)return null;if(de.charCodeAt(Ae)!==Ce.charCodeAt(je)){const ee=n(de.charCodeAt(Ae));if(!ee)return K;for(let se=0;se<ee.length;se++)if(ee[se]!==Ce.charCodeAt(je+se))return K}return c({start:je,end:je+j+1},K)}function h(de,Ce){for(let Ae=Ce;Ae<de.length;Ae++)if(s(de.charCodeAt(Ae))||Ae>0&&s(de.charCodeAt(Ae-1)))return Ae;return de.length}const y=F(e.$7j,b,m),w=F(e.$7j,b,f),A=new S.$Dc(1e4);function N(de,Ce,Ae=!1){if(typeof de!="string"||typeof Ce!="string")return null;let je=A.get(de);je||(je=new RegExp(P.$5e(de),"i"),A.set(de,je));const z=je.exec(Ce);return z?[{start:z.index,end:z.index+z[0].length}]:Ae?w(de,Ce):y(de,Ce)}e.$ak=N;function G(de,Ce){const Ae=be(de,de.toLowerCase(),0,Ce,Ce.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Ae?U(Ae):null}e.$bk=G;function V(de,Ce,Ae,je,z,j){const K=Math.min(13,de.length);for(;Ae<K;Ae++){const H=be(de,Ce,Ae,je,z,j,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(H)return H}return[0,j]}e.$ck=V;function U(de){if(typeof de>"u")return[];const Ce=[],Ae=de[1];for(let je=de.length-1;je>1;je--){const z=de[je]+Ae,j=Ce[Ce.length-1];j&&j.end===z?j.end=z+1:Ce.push({start:z,end:z+1})}return Ce}e.$dk=U;const C=128;function L(){const de=[],Ce=[];for(let Ae=0;Ae<=C;Ae++)Ce[Ae]=0;for(let Ae=0;Ae<=C;Ae++)de.push(Ce.slice(0));return de}function q(de){const Ce=[];for(let Ae=0;Ae<=de;Ae++)Ce[Ae]=0;return Ce}const ne=q(2*C),ae=q(2*C),ye=L(),Ie=L(),ue=L(),ve=!1;function re(de,Ce,Ae,je,z){function j(H,ee,se=" "){for(;H.length<ee;)H=se+H;return H}let K=` |   |${je.split("").map(H=>j(H,3)).join("|")}
`;for(let H=0;H<=Ae;H++)H===0?K+=" |":K+=`${Ce[H-1]}|`,K+=de[H].slice(0,z+1).map(ee=>j(ee.toString(),3)).join("|")+`
`;return K}function $e(de,Ce,Ae,je){de=de.substr(Ce),Ae=Ae.substr(je),console.log(re(Ie,de,de.length,Ae,Ae.length)),console.log(re(ue,de,de.length,Ae,Ae.length)),console.log(re(ye,de,de.length,Ae,Ae.length))}function ie(de,Ce){if(Ce<0||Ce>=de.length)return!1;const Ae=de.codePointAt(Ce);switch(Ae){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!P.$Cf(Ae)}}function le(de,Ce){if(Ce<0||Ce>=de.length)return!1;switch(de.charCodeAt(Ce)){case 32:case 9:return!0;default:return!1}}function W(de,Ce,Ae){return Ce[de]!==Ae[de]}function _(de,Ce,Ae,je,z,j,K=!1){for(;Ce<Ae&&z<j;)de[Ce]===je[z]&&(K&&(ne[Ce]=z),Ce+=1),z+=1;return Ce===Ae}e.$ek=_;var ke;(function(de){de[de.Diag=1]="Diag",de[de.Left=2]="Left",de[de.LeftLeft=3]="LeftLeft"})(ke||(ke={}));var Ne;(function(de){de.Default=[-100,0];function Ce(Ae){return!Ae||Ae.length===2&&Ae[0]===-100&&Ae[1]===0}de.isDefault=Ce})(Ne||(e.FuzzyScore=Ne={}));class De{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ce,Ae){this.firstMatchCanBeWeak=Ce,this.boostFullMatch=Ae}}e.$fk=De;function be(de,Ce,Ae,je,z,j,K=De.default){const H=de.length>C?C:de.length,ee=je.length>C?C:je.length;if(Ae>=H||j>=ee||H-Ae>ee-j||!_(Ce,Ae,H,z,j,ee,!0))return;ge(H,ee,Ae,j,Ce,z);let se=1,Oe=1,We=Ae,Ke=j;const xe=[!1];for(se=1,We=Ae;We<H;se++,We++){const at=ne[We],Be=ae[We],et=We+1<H?ae[We+1]:ee;for(Oe=at-j+1,Ke=at;Ke<et;Oe++,Ke++){let Z=Number.MIN_SAFE_INTEGER,Q=!1;Ke<=Be&&(Z=J(de,Ce,We,Ae,je,z,Ke,ee,j,ye[se-1][Oe-1]===0,xe));let pe=0;Z!==Number.MAX_SAFE_INTEGER&&(Q=!0,pe=Z+Ie[se-1][Oe-1]);const Ve=Ke>at,Ze=Ve?Ie[se][Oe-1]+(ye[se][Oe-1]>0?-5:0):0,st=Ke>at+1&&ye[se][Oe-1]>0,Me=st?Ie[se][Oe-2]+(ye[se][Oe-2]>0?-5:0):0;if(st&&(!Ve||Me>=Ze)&&(!Q||Me>=pe))Ie[se][Oe]=Me,ue[se][Oe]=3,ye[se][Oe]=0;else if(Ve&&(!Q||Ze>=pe))Ie[se][Oe]=Ze,ue[se][Oe]=2,ye[se][Oe]=0;else if(Q)Ie[se][Oe]=pe,ue[se][Oe]=1,ye[se][Oe]=ye[se-1][Oe-1]+1;else throw new Error("not possible")}}if(ve&&$e(de,Ae,je,j),!xe[0]&&!K.firstMatchCanBeWeak)return;se--,Oe--;const tt=[Ie[se][Oe],j];let lt=0,rt=0;for(;se>=1;){let at=Oe;do{const Be=ue[se][at];if(Be===3)at=at-2;else if(Be===2)at=at-1;else break}while(at>=1);lt>1&&Ce[Ae+se-1]===z[j+Oe-1]&&!W(at+j-1,je,z)&&lt+1>ye[se][at]&&(at=Oe),at===Oe?lt++:lt=1,rt||(rt=at),se--,Oe=at-1,tt.push(Oe)}ee===H&&K.boostFullMatch&&(tt[0]+=2);const it=rt-H;return tt[0]-=it,tt}e.$gk=be;function ge(de,Ce,Ae,je,z,j){let K=de-1,H=Ce-1;for(;K>=Ae&&H>=je;)z[K]===j[H]&&(ae[K]=H,K--),H--}function J(de,Ce,Ae,je,z,j,K,H,ee,se,Oe){if(Ce[Ae]!==j[K])return Number.MIN_SAFE_INTEGER;let We=1,Ke=!1;return K===Ae-je?We=de[Ae]===z[K]?7:5:W(K,z,j)&&(K===0||!W(K-1,z,j))?(We=de[Ae]===z[K]?7:5,Ke=!0):ie(j,K)&&(K===0||!ie(j,K-1))?We=5:(ie(j,K-1)||le(j,K-1))&&(We=5,Ke=!0),We>1&&Ae===je&&(Oe[0]=!0),Ke||(Ke=W(K,z,j)||ie(j,K-1)||le(j,K-1)),Ae===je?K>ee&&(We-=Ke?3:5):se?We+=Ke?2:0:We+=Ke?0:1,K+1===H&&(We-=Ke?3:5),We}function X(de,Ce,Ae,je,z,j,K){return fe(de,Ce,Ae,je,z,j,!0,K)}e.$hk=X;function he(de,Ce,Ae,je,z,j,K){return fe(de,Ce,Ae,je,z,j,!1,K)}e.$ik=he;function fe(de,Ce,Ae,je,z,j,K,H){let ee=be(de,Ce,Ae,je,z,j,H);if(ee&&!K)return ee;if(de.length>=3){const se=Math.min(7,de.length-1);for(let Oe=Ae+1;Oe<se;Oe++){const We=Fe(de,Oe);if(We){const Ke=be(We,We.toLowerCase(),Ae,je,z,j,H);Ke&&(Ke[0]-=3,(!ee||Ke[0]>ee[0])&&(ee=Ke))}}}return ee}function Fe(de,Ce){if(Ce+1>=de.length)return;const Ae=de[Ce],je=de[Ce+1];if(Ae!==je)return de.slice(0,Ce)+je+Ae+de.slice(Ce+2)}}),define(Pe[32],Re([1,0,15]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(M||(M={})),function(P){const F="error",R="warning",m="warn",f="info",k="ignore";function O(l){return l?S.$jf(F,l)?P.Error:S.$jf(R,l)||S.$jf(m,l)?P.Warning:S.$jf(f,l)?P.Info:P.Ignore:P.Ignore}P.fromValue=O;function D(l){switch(l){case P.Error:return F;case P.Warning:return R;case P.Info:return f;default:return k}}P.toString=D}(M||(M={})),e.default=M}),define(Pe[128],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2d=void 0,e.$2d=Symbol("MicrotaskDelay")}),define(Pe[50],Re([1,0,18,15]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$li=e.$ki=e.$ji=e.$ii=e.$hi=void 0;class P{constructor(){this.b="",this.c=0}reset(E){return this.b=E,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(E){const g=E.charCodeAt(0),s=this.b.charCodeAt(this.c);return g-s}value(){return this.b[this.c]}}e.$hi=P;class F{constructor(E=!0){this.e=E}reset(E){return this.b=E,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let E=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(E)this.c++;else break;else E=!1;return this}cmp(E){return this.e?(0,M.$df)(E,this.b,0,E.length,this.c,this.d):(0,M.$ff)(E,this.b,0,E.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$ii=F;class R{constructor(E=!0,g=!0){this.f=E,this.g=g}reset(E){this.d=0,this.e=0,this.b=E,this.c=E.length;for(let g=E.length-1;g>=0;g--,this.c--){const s=this.b.charCodeAt(g);if(!(s===47||this.f&&s===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let E=!0;for(;this.e<this.c;this.e++){const g=this.b.charCodeAt(this.e);if(g===47||this.f&&g===92)if(E)this.d++;else break;else E=!1}return this}cmp(E){return this.g?(0,M.$df)(E,this.b,0,E.length,this.d,this.e):(0,M.$ff)(E,this.b,0,E.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$ji=R;var m;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})(m||(m={}));class f{constructor(E,g){this.f=E,this.g=g,this.d=[],this.e=0}reset(E){return this.c=E,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(E)),this.b.reset(E.path),this.b.value()&&this.d.push(3)),this.g(E)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(E){if(this.d[this.e]===1)return(0,M.$ef)(E,this.c.scheme);if(this.d[this.e]===2)return(0,M.$ef)(E,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(E);if(this.d[this.e]===4)return(0,M.$cf)(E,this.c.query);if(this.d[this.e]===5)return(0,M.$cf)(E,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$ki=f;class k{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const E=this.right;return this.right=E.left,E.left=this,this.updateHeight(),E.updateHeight(),E}rotateRight(){const E=this.left;return this.left=E.right,E.right=this,this.updateHeight(),E.updateHeight(),E}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var O;(function(l){l[l.Left=-1]="Left",l[l.Mid=0]="Mid",l[l.Right=1]="Right"})(O||(O={}));class D{static forUris(E=()=>!1,g=()=>!1){return new D(new f(E,g))}static forPaths(E=!1){return new D(new R(void 0,!E))}static forStrings(){return new D(new P)}static forConfigKeys(){return new D(new F)}constructor(E){this.b=E}clear(){this.c=void 0}fill(E,g){if(g){const s=g.slice(0);(0,S.$Xb)(s);for(const a of s)this.set(a,E)}else{const s=E.slice(0);(0,S.$Xb)(s);for(const a of s)this.set(a[0],a[1])}}set(E,g){const s=this.b.reset(E);let a;this.c||(this.c=new k,this.c.segment=s.value());const i=[];for(a=this.c;;){const r=s.cmp(a.segment);if(r>0)a.left||(a.left=new k,a.left.segment=s.value()),i.push([-1,a]),a=a.left;else if(r<0)a.right||(a.right=new k,a.right.segment=s.value()),i.push([1,a]),a=a.right;else if(s.hasNext())s.next(),a.mid||(a.mid=new k,a.mid.segment=s.value()),i.push([0,a]),a=a.mid;else break}const n=a.value;a.value=g,a.key=E;for(let r=i.length-1;r>=0;r--){const c=i[r][1];c.updateHeight();const d=c.balanceFactor();if(d<-1||d>1){const t=i[r][0],p=i[r+1][0];if(t===1&&p===1)i[r][1]=c.rotateLeft();else if(t===-1&&p===-1)i[r][1]=c.rotateRight();else if(t===1&&p===-1)c.right=i[r+1][1]=i[r+1][1].rotateRight(),i[r][1]=c.rotateLeft();else if(t===-1&&p===1)c.left=i[r+1][1]=i[r+1][1].rotateLeft(),i[r][1]=c.rotateRight();else throw new Error;if(r>0)switch(i[r-1][0]){case-1:i[r-1][1].left=i[r][1];break;case 1:i[r-1][1].right=i[r][1];break;case 0:i[r-1][1].mid=i[r][1];break}else this.c=i[0][1]}}return n}get(E){return this.d(E)?.value}d(E){const g=this.b.reset(E);let s=this.c;for(;s;){const a=g.cmp(s.segment);if(a>0)s=s.left;else if(a<0)s=s.right;else if(g.hasNext())g.next(),s=s.mid;else break}return s}has(E){const g=this.d(E);return!(g?.value===void 0&&g?.mid===void 0)}delete(E){return this.e(E,!1)}deleteSuperstr(E){return this.e(E,!0)}e(E,g){const s=this.b.reset(E),a=[];let i=this.c;for(;i;){const n=s.cmp(i.segment);if(n>0)a.push([-1,i]),i=i.left;else if(n<0)a.push([1,i]),i=i.right;else if(s.hasNext())s.next(),a.push([0,i]),i=i.mid;else break}if(i){if(g?(i.left=void 0,i.mid=void 0,i.right=void 0,i.height=1):(i.key=void 0,i.value=void 0),!i.mid&&!i.value)if(i.left&&i.right){const n=this.f(i.right);if(n.key){const{key:r,value:c,segment:d}=n;this.e(n.key,!1),i.key=r,i.value=c,i.segment=d}}else{const n=i.left??i.right;if(a.length>0){const[r,c]=a[a.length-1];switch(r){case-1:c.left=n;break;case 0:c.mid=n;break;case 1:c.right=n;break}}else this.c=n}for(let n=a.length-1;n>=0;n--){const r=a[n][1];r.updateHeight();const c=r.balanceFactor();if(c>1?(r.right.balanceFactor()>=0||(r.right=r.right.rotateRight()),a[n][1]=r.rotateLeft()):c<-1&&(r.left.balanceFactor()<=0||(r.left=r.left.rotateLeft()),a[n][1]=r.rotateRight()),n>0)switch(a[n-1][0]){case-1:a[n-1][1].left=a[n][1];break;case 1:a[n-1][1].right=a[n][1];break;case 0:a[n-1][1].mid=a[n][1];break}else this.c=a[0][1]}}}f(E){for(;E.left;)E=E.left;return E}findSubstr(E){const g=this.b.reset(E);let s=this.c,a;for(;s;){const i=g.cmp(s.segment);if(i>0)s=s.left;else if(i<0)s=s.right;else if(g.hasNext())g.next(),a=s.value||a,s=s.mid;else break}return s&&s.value||a}findSuperstr(E){return this.g(E,!1)}g(E,g){const s=this.b.reset(E);let a=this.c;for(;a;){const i=s.cmp(a.segment);if(i>0)a=a.left;else if(i<0)a=a.right;else if(s.hasNext())s.next(),a=a.mid;else return a.mid?this.h(a.mid):g?a.value:void 0}}hasElementOrSubtree(E){return this.g(E,!0)!==void 0}forEach(E){for(const[g,s]of this)E(s,g)}*[Symbol.iterator](){yield*this.h(this.c)}h(E){const g=[];return this.j(E,g),g[Symbol.iterator]()}j(E,g){E&&(E.left&&this.j(E.left,g),E.value&&g.push([E.key,E.value]),E.mid&&this.j(E.mid,g),E.right&&this.j(E.right,g))}_isBalanced(){const E=g=>{if(!g)return!0;const s=g.balanceFactor();return s<-1||s>1?!1:E(g.left)&&E(g.right)};return E(this.c)}}e.$li=D}),define(Pe[40],Re([1,0,91]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$pk=e.ThemeColor=void 0;var M;(function(R){function m(f){return f&&typeof f=="object"&&typeof f.id=="string"}R.isThemeColor=m})(M||(e.ThemeColor=M={}));function P(R){return{id:R}}e.$pk=P;var F;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const m=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function f(n){const r=m.exec(n.id);if(!r)return f(S.$ok.error);const[,c,d]=r,t=["codicon","codicon-"+c];return d&&t.push("codicon-modifier-"+d.substring(1)),t}R.asClassNameArray=f;function k(n){return f(n).join(" ")}R.asClassName=k;function O(n){return"."+f(n).join(".")}R.asCSSSelector=O;function D(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||M.isThemeColor(n.color))}R.isThemeIcon=D;const l=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function E(n){const r=l.exec(n);if(!r)return;const[,c]=r;return{id:c}}R.fromString=E;function g(n){return{id:n}}R.fromId=g;function s(n,r){let c=n.id;const d=c.lastIndexOf("~");return d!==-1&&(c=c.substring(0,d)),r&&(c=`${c}~${r}`),{id:c}}R.modify=s;function a(n){const r=n.id.lastIndexOf("~");if(r!==-1)return n.id.substring(r+1)}R.getModifier=a;function i(n,r){return n.id===r.id&&n.color?.id===r.color?.id}R.isEqual=i})(F||(e.ThemeIcon=F={}))}),define(Pe[129],Re([1,0,127,15,40]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=void 0;const F="$(",R=new RegExp(`\\$\\(${P.ThemeIcon.iconNameExpression}(?:${P.ThemeIcon.iconModifierExpression})?\\)`,"g"),m=new RegExp(`(\\\\)?${R.source}`,"g");function f(i){return i.replace(m,(n,r)=>r?n:`\\${n}`)}e.$qk=f;const k=new RegExp(`\\\\${R.source}`,"g");function O(i){return i.replace(k,n=>`\\${n}`)}e.$rk=O;const D=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function l(i){return i.indexOf(F)===-1?i:i.replace(D,(n,r,c,d)=>c?n:r||d||"")}e.$sk=l;function E(i){return i?i.replace(/\$\((.*?)\)/g,(n,r)=>` ${r} `).trim():""}e.$tk=E;const g=new RegExp(`\\$\\(${P.ThemeIcon.iconNameCharacter}+\\)`,"g");function s(i){g.lastIndex=0;let n="";const r=[];let c=0;for(;;){const d=g.lastIndex,t=g.exec(i),p=i.substring(d,t?.index);if(p.length>0){n+=p;for(let u=0;u<p.length;u++)r.push(c)}if(!t)break;c+=t[0].length}return{text:n,iconOffsets:r}}e.$uk=s;function a(i,n,r=!1){const{text:c,iconOffsets:d}=n;if(!d||d.length===0)return(0,S.$ak)(i,c,r);const t=(0,M.$3e)(c," "),p=c.length-t.length,u=(0,S.$ak)(i,t,r);if(u)for(const o of u){const v=d[o.start+p]+p;o.start+=v,o.end+=v}return u}e.$vk=a}),define(Pe[33],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bg=e.$Ag=void 0;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(P){return S.test(P)}e.$Ag=M,e.$Bg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(m){for(let f=0;f<m.length;f++)m[f]=Math.floor(Math.random()*256);return m};const F=new Uint8Array(16),R=[];for(let m=0;m<256;m++)R.push(m.toString(16).padStart(2,"0"));return function(){P(F),F[6]=F[6]&15|64,F[8]=F[8]&63|128;let f=0,k="";return k+=R[F[f++]],k+=R[F[f++]],k+=R[F[f++]],k+=R[F[f++]],k+="-",k+=R[F[f++]],k+=R[F[f++]],k+="-",k+=R[F[f++]],k+=R[F[f++]],k+="-",k+=R[F[f++]],k+=R[F[f++]],k+="-",k+=R[F[f++]],k+=R[F[f++]],k+=R[F[f++]],k+=R[F[f++]],k+=R[F[f++]],k+=R[F[f++]],k}}()}),define(Pe[130],Re([1,0,18,51,33]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ft=e.$Et=e.$Dt=e.$Ct=e.$Bt=void 0;function F(D){return{asString:async()=>D,asFile:()=>{},value:typeof D=="string"?D:void 0}}e.$Bt=F;function R(D,l,E){const g={id:(0,P.$Bg)(),name:D,uri:l,data:E};return{asString:async()=>"",asFile:()=>g,value:void 0}}e.$Ct=R;class m{constructor(){this.a=new Map}get size(){let l=0;for(const E of this.a)l++;return l}has(l){return this.a.has(this.b(l))}matches(l){const E=[...this.a.keys()];return M.Iterable.some(this,([g,s])=>s.asFile())&&E.push("files"),O(f(l),E)}get(l){return this.a.get(this.b(l))?.[0]}append(l,E){const g=this.a.get(l);g?g.push(E):this.a.set(this.b(l),[E])}replace(l,E){this.a.set(this.b(l),[E])}delete(l){this.a.delete(this.b(l))}*[Symbol.iterator](){for(const[l,E]of this.a)for(const g of E)yield[l,g]}b(l){return f(l)}}e.$Dt=m;function f(D){return D.toLowerCase()}function k(D,l){return O(f(D),l.map(f))}e.$Et=k;function O(D,l){if(D==="*/*")return l.length>0;if(l.includes(D))return!0;const E=D.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!E)return!1;const[g,s,a]=E;return a==="*"?l.some(i=>i.startsWith(s+"/")):!1}e.$Ft=Object.freeze({create:D=>(0,S.$Mb)(D.map(l=>l.toString())).join(`\r
`),split:D=>D.split(`\r
`),parse:D=>e.$Ft.split(D).filter(l=>!l.startsWith("#"))})}),define(Pe[131],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$It=e.StringEOL=void 0;var S;(function(P){P[P.Unknown=0]="Unknown",P[P.Invalid=3]="Invalid",P[P.LF=1]="LF",P[P.CRLF=2]="CRLF"})(S||(e.StringEOL=S={}));function M(P){let F=0,R=0,m=0,f=0;for(let k=0,O=P.length;k<O;k++){const D=P.charCodeAt(k);D===13?(F===0&&(R=k),F++,k+1<O&&P.charCodeAt(k+1)===10?(f|=2,k++):f|=3,m=k+1):D===10&&(f|=1,F===0&&(R=k),F++,m=k+1)}return F===0&&(R=P.length),[F,R,P.length-m,f]}e.$It=M}),define(Pe[132],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gs=void 0,e.$Gs={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Pe[133],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8t=e.$7t=e.IndentAction=void 0;var S;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(S||(e.IndentAction=S={}));class M{constructor(m){if(this.e=null,this.f=!1,this.open=m.open,this.close=m.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(m.notIn))for(let f=0,k=m.notIn.length;f<k;f++)switch(m.notIn[f]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(m){switch(m){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(m,f){if(m.getTokenCount()===0)return!0;const k=m.findTokenIndexAtOffset(f-2),O=m.getStandardTokenType(k);return this.isOK(O)}g(m,f){for(let k=m;k<=f;k++){const O=String.fromCharCode(k);if(!this.open.includes(O)&&!this.close.includes(O))return O}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$7t=M;class P{constructor(m){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const f of m)F(this.autoClosingPairsOpenByStart,f.open.charAt(0),f),F(this.autoClosingPairsOpenByEnd,f.open.charAt(f.open.length-1),f),F(this.autoClosingPairsCloseByStart,f.close.charAt(0),f),F(this.autoClosingPairsCloseByEnd,f.close.charAt(f.close.length-1),f),f.close.length===1&&f.open.length===1&&F(this.autoClosingPairsCloseSingleChar,f.close,f)}}e.$8t=P;function F(R,m,f){R.has(m)?R.get(m).push(f):R.set(m,[f])}}),define(Pe[134],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eC=e.$dC=e.$cC=e.$bC=e.$aC=e.$_B=e.$$B=e.$0B=e.$9B=e.NodeColor=e.$8B=void 0;class S{constructor(a,i){this.piece=a,this.color=i,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$9B)return P(this.right);let a=this;for(;a.parent!==e.$9B&&a.parent.left!==a;)a=a.parent;return a.parent===e.$9B?e.$9B:a.parent}prev(){if(this.left!==e.$9B)return F(this.left);let a=this;for(;a.parent!==e.$9B&&a.parent.right!==a;)a=a.parent;return a.parent===e.$9B?e.$9B:a.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$8B=S;var M;(function(s){s[s.Black=0]="Black",s[s.Red=1]="Red"})(M||(e.NodeColor=M={})),e.$9B=new S(null,0),e.$9B.parent=e.$9B,e.$9B.left=e.$9B,e.$9B.right=e.$9B,e.$9B.color=0;function P(s){for(;s.left!==e.$9B;)s=s.left;return s}e.$0B=P;function F(s){for(;s.right!==e.$9B;)s=s.right;return s}e.$$B=F;function R(s){return s===e.$9B?0:s.size_left+s.piece.length+R(s.right)}function m(s){return s===e.$9B?0:s.lf_left+s.piece.lineFeedCnt+m(s.right)}function f(){e.$9B.parent=e.$9B}function k(s,a){const i=a.right;i.size_left+=a.size_left+(a.piece?a.piece.length:0),i.lf_left+=a.lf_left+(a.piece?a.piece.lineFeedCnt:0),a.right=i.left,i.left!==e.$9B&&(i.left.parent=a),i.parent=a.parent,a.parent===e.$9B?s.root=i:a.parent.left===a?a.parent.left=i:a.parent.right=i,i.left=a,a.parent=i}e.$_B=k;function O(s,a){const i=a.left;a.left=i.right,i.right!==e.$9B&&(i.right.parent=a),i.parent=a.parent,a.size_left-=i.size_left+(i.piece?i.piece.length:0),a.lf_left-=i.lf_left+(i.piece?i.piece.lineFeedCnt:0),a.parent===e.$9B?s.root=i:a===a.parent.right?a.parent.right=i:a.parent.left=i,i.right=a,a.parent=i}e.$aC=O;function D(s,a){let i,n;if(a.left===e.$9B?(n=a,i=n.right):a.right===e.$9B?(n=a,i=n.left):(n=P(a.right),i=n.right),n===s.root){s.root=i,i.color=0,a.detach(),f(),s.root.parent=e.$9B;return}const r=n.color===1;if(n===n.parent.left?n.parent.left=i:n.parent.right=i,n===a?(i.parent=n.parent,g(s,i)):(n.parent===a?i.parent=n:i.parent=n.parent,g(s,i),n.left=a.left,n.right=a.right,n.parent=a.parent,n.color=a.color,a===s.root?s.root=n:a===a.parent.left?a.parent.left=n:a.parent.right=n,n.left!==e.$9B&&(n.left.parent=n),n.right!==e.$9B&&(n.right.parent=n),n.size_left=a.size_left,n.lf_left=a.lf_left,g(s,n)),a.detach(),i.parent.left===i){const d=R(i),t=m(i);if(d!==i.parent.size_left||t!==i.parent.lf_left){const p=d-i.parent.size_left,u=t-i.parent.lf_left;i.parent.size_left=d,i.parent.lf_left=t,E(s,i.parent,p,u)}}if(g(s,i.parent),r){f();return}let c;for(;i!==s.root&&i.color===0;)i===i.parent.left?(c=i.parent.right,c.color===1&&(c.color=0,i.parent.color=1,k(s,i.parent),c=i.parent.right),c.left.color===0&&c.right.color===0?(c.color=1,i=i.parent):(c.right.color===0&&(c.left.color=0,c.color=1,O(s,c),c=i.parent.right),c.color=i.parent.color,i.parent.color=0,c.right.color=0,k(s,i.parent),i=s.root)):(c=i.parent.left,c.color===1&&(c.color=0,i.parent.color=1,O(s,i.parent),c=i.parent.left),c.left.color===0&&c.right.color===0?(c.color=1,i=i.parent):(c.left.color===0&&(c.right.color=0,c.color=1,k(s,c),c=i.parent.left),c.color=i.parent.color,i.parent.color=0,c.left.color=0,O(s,i.parent),i=s.root));i.color=0,f()}e.$bC=D;function l(s,a){for(g(s,a);a!==s.root&&a.parent.color===1;)if(a.parent===a.parent.parent.left){const i=a.parent.parent.right;i.color===1?(a.parent.color=0,i.color=0,a.parent.parent.color=1,a=a.parent.parent):(a===a.parent.right&&(a=a.parent,k(s,a)),a.parent.color=0,a.parent.parent.color=1,O(s,a.parent.parent))}else{const i=a.parent.parent.left;i.color===1?(a.parent.color=0,i.color=0,a.parent.parent.color=1,a=a.parent.parent):(a===a.parent.left&&(a=a.parent,O(s,a)),a.parent.color=0,a.parent.parent.color=1,k(s,a.parent.parent))}s.root.color=0}e.$cC=l;function E(s,a,i,n){for(;a!==s.root&&a!==e.$9B;)a.parent.left===a&&(a.parent.size_left+=i,a.parent.lf_left+=n),a=a.parent}e.$dC=E;function g(s,a){let i=0,n=0;if(a!==s.root){for(;a!==s.root&&a===a.parent.right;)a=a.parent;if(a!==s.root)for(a=a.parent,i=R(a.left)-a.size_left,n=m(a.left)-a.lf_left,a.size_left+=i,a.lf_left+=n;a!==s.root&&(i!==0||n!==0);)a.parent.left===a&&(a.parent.size_left+=i,a.parent.lf_left+=n),a=a.parent}}e.$eC=g}),define(Pe[92],Re([1,0,93,29,94,134,95]),function(me,e,S,M,P,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pC=e.$oC=e.$nC=e.$mC=e.$lC=void 0;const m=65535;function f(i){let n;return i[i.length-1]<65536?n=new Uint16Array(i.length):n=new Uint32Array(i.length),n.set(i,0),n}class k{constructor(n,r,c,d,t){this.lineStarts=n,this.cr=r,this.lf=c,this.crlf=d,this.isBasicASCII=t}}function O(i,n=!0){const r=[0];let c=1;for(let d=0,t=i.length;d<t;d++){const p=i.charCodeAt(d);p===13?d+1<t&&i.charCodeAt(d+1)===10?(r[c++]=d+2,d++):r[c++]=d+1:p===10&&(r[c++]=d+1)}return n?f(r):r}e.$lC=O;function D(i,n){i.length=0,i[0]=0;let r=1,c=0,d=0,t=0,p=!0;for(let o=0,v=n.length;o<v;o++){const b=n.charCodeAt(o);b===13?o+1<v&&n.charCodeAt(o+1)===10?(t++,i[r++]=o+2,o++):(c++,i[r++]=o+1):b===10?(d++,i[r++]=o+1):p&&b!==9&&(b<32||b>126)&&(p=!1)}const u=new k(f(i),c,d,t,p);return i.length=0,u}e.$mC=D;class l{constructor(n,r,c,d,t){this.bufferIndex=n,this.start=r,this.end=c,this.lineFeedCnt=d,this.length=t}}e.$nC=l;class E{constructor(n,r){this.buffer=n,this.lineStarts=r}}e.$oC=E;class g{constructor(n,r){this.a=[],this.c=n,this.d=r,this.b=0,n.root!==F.$9B&&n.iterate(n.root,c=>(c!==F.$9B&&this.a.push(c.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class s{constructor(n){this.a=n,this.b=[]}get(n){for(let r=this.b.length-1;r>=0;r--){const c=this.b[r];if(c.nodeStartOffset<=n&&c.nodeStartOffset+c.node.piece.length>=n)return c}return null}get2(n){for(let r=this.b.length-1;r>=0;r--){const c=this.b[r];if(c.nodeStartLineNumber&&c.nodeStartLineNumber<n&&c.nodeStartLineNumber+c.node.piece.lineFeedCnt>=n)return c}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let r=!1;const c=this.b;for(let d=0;d<c.length;d++){const t=c[d];if(t.node.parent===null||t.nodeStartOffset>=n){c[d]=null,r=!0;continue}}if(r){const d=[];for(const t of c)t!==null&&d.push(t);this.b=d}}}class a{constructor(n,r,c){this.create(n,r,c)}create(n,r,c){this.a=[new E("",[0])],this.g={line:0,column:0},this.root=F.$9B,this.b=1,this.c=0,this.d=r,this.e=r.length,this.f=c;let d=null;for(let t=0,p=n.length;t<p;t++)if(n[t].buffer.length>0){n[t].lineStarts||(n[t].lineStarts=O(n[t].buffer));const u=new l(t+1,{line:0,column:0},{line:n[t].lineStarts.length-1,column:n[t].buffer.length-n[t].lineStarts[n[t].lineStarts.length-1]},n[t].lineStarts.length-1,n[t].buffer.length);this.a.push(n[t]),d=this.S(d,u)}this.h=new s(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const r=m,c=r-Math.floor(r/3),d=c*2;let t="",p=0;const u=[];if(this.iterate(this.root,o=>{const v=this.R(o),b=v.length;if(p<=c||p+b<d)return t+=v,p+=b,!0;const $=t.replace(/\r\n|\r|\n/g,n);return u.push(new E($,O($))),t=v,p=b,!0}),p>0){const o=t.replace(/\r\n|\r|\n/g,n);u.push(new E(o,O(o)))}this.create(u,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new g(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let r=0;return this.iterate(this.root,d=>{if(d===F.$9B)return!0;const t=this.R(d),p=t.length,u=n.G(r),o=n.G(r+p),v=n.getValueInRange2(u,o);return r+=p,t===v})}getOffsetAt(n,r){let c=0,d=this.root;for(;d!==F.$9B;)if(d.left!==F.$9B&&d.lf_left+1>=n)d=d.left;else if(d.lf_left+d.piece.lineFeedCnt+1>=n){c+=d.size_left;const t=this.B(d,n-d.lf_left-2);return c+=t+r-1}else n-=d.lf_left+d.piece.lineFeedCnt,c+=d.size_left+d.piece.length,d=d.right;return c}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let r=this.root,c=0;const d=n;for(;r!==F.$9B;)if(r.size_left!==0&&r.size_left>=n)r=r.left;else if(r.size_left+r.piece.length>=n){const t=this.A(r,n-r.size_left);if(c+=r.lf_left+t.index,t.index===0){const p=this.getOffsetAt(c+1,1),u=d-p;return new S.$8s(c+1,u+1)}return new S.$8s(c+1,t.remainder+1)}else if(n-=r.size_left+r.piece.length,c+=r.lf_left+r.piece.lineFeedCnt,r.right===F.$9B){const t=this.getOffsetAt(c+1,1),p=d-n-t;return new S.$8s(c+1,p+1)}else r=r.right;return new S.$8s(1,1)}getValueInRange(n,r){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const c=this.H(n.startLineNumber,n.startColumn),d=this.H(n.endLineNumber,n.endColumn),t=this.getValueInRange2(c,d);return r?r!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,r):r===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,r):t}getValueInRange2(n,r){if(n.node===r.node){const u=n.node,o=this.a[u.piece.bufferIndex].buffer,v=this.u(u.piece.bufferIndex,u.piece.start);return o.substring(v+n.remainder,v+r.remainder)}let c=n.node;const d=this.a[c.piece.bufferIndex].buffer,t=this.u(c.piece.bufferIndex,c.piece.start);let p=d.substring(t+n.remainder,t+c.piece.length);for(c=c.next();c!==F.$9B;){const u=this.a[c.piece.bufferIndex].buffer,o=this.u(c.piece.bufferIndex,c.piece.start);if(c===r.node){p+=u.substring(o,o+r.remainder);break}else p+=u.substr(o,c.piece.length);c=c.next()}return p}getLinesContent(){const n=[];let r=0,c="",d=!1;return this.iterate(this.root,t=>{if(t===F.$9B)return!0;const p=t.piece;let u=p.length;if(u===0)return!0;const o=this.a[p.bufferIndex].buffer,v=this.a[p.bufferIndex].lineStarts,b=p.start.line,$=p.end.line;let I=v[b]+p.start.column;if(d&&(o.charCodeAt(I)===10&&(I++,u--),n[r++]=c,c="",d=!1,u===0))return!0;if(b===$)return!this.f&&o.charCodeAt(I+u-1)===13?(d=!0,c+=o.substr(I,u-1)):c+=o.substr(I,u),!0;c+=this.f?o.substring(I,Math.max(I,v[b+1]-this.e)):o.substring(I,v[b+1]).replace(/(\r\n|\r|\n)$/,""),n[r++]=c;for(let h=b+1;h<$;h++)c=this.f?o.substring(v[h],v[h+1]-this.e):o.substring(v[h],v[h+1]).replace(/(\r\n|\r|\n)$/,""),n[r++]=c;return!this.f&&o.charCodeAt(v[$]+p.end.column-1)===13?(d=!0,p.end.column===0?r--:c=o.substr(v[$],p.end.column-1)):c=o.substr(v[$],p.end.column),!0}),d&&(n[r++]=c,c=""),n[r++]=c,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const r=n.node.next();if(!r)return 0;const c=this.a[r.piece.bufferIndex],d=this.u(r.piece.bufferIndex,r.piece.start);return c.buffer.charCodeAt(d)}else{const r=this.a[n.node.piece.bufferIndex],d=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return r.buffer.charCodeAt(d)}}getLineCharCode(n,r){const c=this.H(n,r+1);return this.l(c)}getLineLength(n){if(n===this.getLineCount()){const r=this.getOffsetAt(n,1);return this.getLength()-r}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const r=this.G(n);return this.l(r)}findMatchesInNode(n,r,c,d,t,p,u,o,v,b,$){const I=this.a[n.piece.bufferIndex],h=this.u(n.piece.bufferIndex,n.piece.start),y=this.u(n.piece.bufferIndex,t),w=this.u(n.piece.bufferIndex,p);let A;const N={line:0,column:0};let G,V;r._wordSeparators?(G=I.buffer.substring(y,w),V=U=>U+y,r.reset(0)):(G=I.buffer,V=U=>U,r.reset(y));do if(A=r.next(G),A){if(V(A.index)>=w)return b;this.s(n,V(A.index)-h,N);const U=this.t(n.piece.bufferIndex,t,N),C=N.line===t.line?N.column-t.column+d:N.column+1,L=C+A[0].length;if($[b++]=(0,R.$hC)(new M.$9s(c+U,C,c+U,L),A,o),V(A.index)+A[0].length>=w||b>=v)return b}while(A);return b}findMatchesLineByLine(n,r,c,d){const t=[];let p=0;const u=new R.$kC(r.wordSeparators,r.regex);let o=this.H(n.startLineNumber,n.startColumn);if(o===null)return[];const v=this.H(n.endLineNumber,n.endColumn);if(v===null)return[];let b=this.s(o.node,o.remainder);const $=this.s(v.node,v.remainder);if(o.node===v.node)return this.findMatchesInNode(o.node,u,n.startLineNumber,n.startColumn,b,$,r,c,d,p,t),t;let I=n.startLineNumber,h=o.node;for(;h!==v.node;){const w=this.t(h.piece.bufferIndex,b,h.piece.end);if(w>=1){const N=this.a[h.piece.bufferIndex].lineStarts,G=this.u(h.piece.bufferIndex,h.piece.start),V=N[b.line+w],U=I===n.startLineNumber?n.startColumn:1;if(p=this.findMatchesInNode(h,u,I,U,b,this.s(h,V-G),r,c,d,p,t),p>=d)return t;I+=w}const A=I===n.startLineNumber?n.startColumn-1:0;if(I===n.endLineNumber){const N=this.getLineContent(I).substring(A,n.endColumn-1);return p=this.n(r,u,N,n.endLineNumber,A,p,t,c,d),t}if(p=this.n(r,u,this.getLineContent(I).substr(A),I,A,p,t,c,d),p>=d)return t;I++,o=this.H(I,1),h=o.node,b=this.s(o.node,o.remainder)}if(I===n.endLineNumber){const w=I===n.startLineNumber?n.startColumn-1:0,A=this.getLineContent(I).substring(w,n.endColumn-1);return p=this.n(r,u,A,n.endLineNumber,w,p,t,c,d),t}const y=I===n.startLineNumber?n.startColumn:1;return p=this.findMatchesInNode(v.node,u,I,y,b,$,r,c,d,p,t),t}n(n,r,c,d,t,p,u,o,v){const b=n.wordSeparators;if(!o&&n.simpleSearch){const I=n.simpleSearch,h=I.length,y=c.length;let w=-h;for(;(w=c.indexOf(I,w+h))!==-1;)if((!b||(0,R.$jC)(b,c,y,w,h))&&(u[p++]=new P.$pv(new M.$9s(d,w+1+t,d,w+1+h+t),null),p>=v))return p;return p}let $;r.reset(0);do if($=r.next(c),$&&(u[p++]=(0,R.$hC)(new M.$9s(d,$.index+1+t,d,$.index+1+$[0].length+t),$,o),p>=v))return p;while($);return p}insert(n,r,c=!1){if(this.f=this.f&&c,this.j.lineNumber=0,this.j.value="",this.root!==F.$9B){const{node:d,remainder:t,nodeStartOffset:p}=this.G(n),u=d.piece,o=u.bufferIndex,v=this.s(d,t);if(d.piece.bufferIndex===0&&u.end.line===this.g.line&&u.end.column===this.g.column&&p+u.length===n&&r.length<m){this.F(d,r),this.y();return}if(p===n)this.o(r,d),this.h.validate(n);else if(p+d.piece.length>n){const b=[];let $=new l(u.bufferIndex,v,u.end,this.t(u.bufferIndex,v,u.end),this.u(o,u.end)-this.u(o,v));if(this.K()&&this.M(r)&&this.I(d,t)===10){const w={line:$.start.line+1,column:0};$=new l($.bufferIndex,w,$.end,this.t($.bufferIndex,w,$.end),$.length-1),r+=`
`}if(this.K()&&this.L(r))if(this.I(d,t-1)===13){const w=this.s(d,t-1);this.C(d,w),r="\r"+r,d.piece.length===0&&b.push(d)}else this.C(d,v);else this.C(d,v);const I=this.w(r);$.length>0&&this.S(d,$);let h=d;for(let y=0;y<I.length;y++)h=this.S(h,I[y]);this.v(b)}else this.q(r,d)}else{const d=this.w(r);let t=this.T(null,d[0]);for(let p=1;p<d.length;p++)t=this.S(t,d[p])}this.y()}delete(n,r){if(this.j.lineNumber=0,this.j.value="",r<=0||this.root===F.$9B)return;const c=this.G(n),d=this.G(n+r),t=c.node,p=d.node;if(t===p){const I=this.s(t,c.remainder),h=this.s(t,d.remainder);if(c.nodeStartOffset===n){if(r===t.piece.length){const y=t.next();(0,F.$bC)(this,t),this.N(y),this.y();return}this.D(t,h),this.h.validate(n),this.N(t),this.y();return}if(c.nodeStartOffset+t.piece.length===n+r){this.C(t,I),this.O(t),this.y();return}this.E(t,I,h),this.y();return}const u=[],o=this.s(t,c.remainder);this.C(t,o),this.h.validate(n),t.piece.length===0&&u.push(t);const v=this.s(p,d.remainder);this.D(p,v),p.piece.length===0&&u.push(p);const b=t.next();for(let I=b;I!==F.$9B&&I!==p;I=I.next())u.push(I);const $=t.piece.length===0?t.prev():t;this.v(u),this.O($),this.y()}o(n,r){const c=[];if(this.K()&&this.M(n)&&this.L(r)){const p=r.piece,u={line:p.start.line+1,column:0},o=new l(p.bufferIndex,u,p.end,this.t(p.bufferIndex,u,p.end),p.length-1);r.piece=o,n+=`
`,(0,F.$dC)(this,r,-1,-1),r.piece.length===0&&c.push(r)}const d=this.w(n);let t=this.T(r,d[d.length-1]);for(let p=d.length-2;p>=0;p--)t=this.T(t,d[p]);this.N(t),this.v(c)}q(n,r){this.Q(n,r)&&(n+=`
`);const c=this.w(n),d=this.S(r,c[0]);let t=d;for(let p=1;p<c.length;p++)t=this.S(t,c[p]);this.N(d)}s(n,r,c){const d=n.piece,t=n.piece.bufferIndex,p=this.a[t].lineStarts,o=p[d.start.line]+d.start.column+r;let v=d.start.line,b=d.end.line,$=0,I=0,h=0;for(;v<=b&&($=v+(b-v)/2|0,h=p[$],$!==b);)if(I=p[$+1],o<h)b=$-1;else if(o>=I)v=$+1;else break;return c?(c.line=$,c.column=o-h,null):{line:$,column:o-h}}t(n,r,c){if(c.column===0)return c.line-r.line;const d=this.a[n].lineStarts;if(c.line===d.length-1)return c.line-r.line;const t=d[c.line+1],p=d[c.line]+c.column;if(t>p+1)return c.line-r.line;const u=p-1;return this.a[n].buffer.charCodeAt(u)===13?c.line-r.line+1:c.line-r.line}u(n,r){return this.a[n].lineStarts[r.line]+r.column}v(n){for(let r=0;r<n.length;r++)(0,F.$bC)(this,n[r])}w(n){if(n.length>m){const b=[];for(;n.length>m;){const I=n.charCodeAt(m-1);let h;I===13||I>=55296&&I<=56319?(h=n.substring(0,m-1),n=n.substring(m-1)):(h=n.substring(0,m),n=n.substring(m));const y=O(h);b.push(new l(this.a.length,{line:0,column:0},{line:y.length-1,column:h.length-y[y.length-1]},y.length-1,h.length)),this.a.push(new E(h,y))}const $=O(n);return b.push(new l(this.a.length,{line:0,column:0},{line:$.length-1,column:n.length-$[$.length-1]},$.length-1,n.length)),this.a.push(new E(n,$)),b}let r=this.a[0].buffer.length;const c=O(n,!1);let d=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===r&&r!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},d=this.g;for(let b=0;b<c.length;b++)c[b]+=r+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+="_"+n,r+=1}else{if(r!==0)for(let b=0;b<c.length;b++)c[b]+=r;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+=n}const t=this.a[0].buffer.length,p=this.a[0].lineStarts.length-1,u=t-this.a[0].lineStarts[p],o={line:p,column:u},v=new l(0,d,o,this.t(0,d,o),t-r);return this.g=o,[v]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,r=0){let c=this.root,d="";const t=this.h.get2(n);if(t){c=t.node;const p=this.B(c,n-t.nodeStartLineNumber-1),u=this.a[c.piece.bufferIndex].buffer,o=this.u(c.piece.bufferIndex,c.piece.start);if(t.nodeStartLineNumber+c.piece.lineFeedCnt===n)d=u.substring(o+p,o+c.piece.length);else{const v=this.B(c,n-t.nodeStartLineNumber);return u.substring(o+p,o+v-r)}}else{let p=0;const u=n;for(;c!==F.$9B;)if(c.left!==F.$9B&&c.lf_left>=n-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>n-1){const o=this.B(c,n-c.lf_left-2),v=this.B(c,n-c.lf_left-1),b=this.a[c.piece.bufferIndex].buffer,$=this.u(c.piece.bufferIndex,c.piece.start);return p+=c.size_left,this.h.set({node:c,nodeStartOffset:p,nodeStartLineNumber:u-(n-1-c.lf_left)}),b.substring($+o,$+v-r)}else if(c.lf_left+c.piece.lineFeedCnt===n-1){const o=this.B(c,n-c.lf_left-2),v=this.a[c.piece.bufferIndex].buffer,b=this.u(c.piece.bufferIndex,c.piece.start);d=v.substring(b+o,b+c.piece.length);break}else n-=c.lf_left+c.piece.lineFeedCnt,p+=c.size_left+c.piece.length,c=c.right}for(c=c.next();c!==F.$9B;){const p=this.a[c.piece.bufferIndex].buffer;if(c.piece.lineFeedCnt>0){const u=this.B(c,0),o=this.u(c.piece.bufferIndex,c.piece.start);return d+=p.substring(o,o+u-r),d}else{const u=this.u(c.piece.bufferIndex,c.piece.start);d+=p.substr(u,c.piece.length)}c=c.next()}return d}y(){let n=this.root,r=1,c=0;for(;n!==F.$9B;)r+=n.lf_left+n.piece.lineFeedCnt,c+=n.size_left+n.piece.length,n=n.right;this.b=r,this.c=c,this.h.validate(this.c)}A(n,r){const c=n.piece,d=this.s(n,r),t=d.line-c.start.line;if(this.u(c.bufferIndex,c.end)-this.u(c.bufferIndex,c.start)===r){const p=this.t(n.piece.bufferIndex,c.start,d);if(p!==t)return{index:p,remainder:0}}return{index:t,remainder:d.column}}B(n,r){if(r<0)return 0;const c=n.piece,d=this.a[c.bufferIndex].lineStarts,t=c.start.line+r+1;return t>c.end.line?d[c.end.line]+c.end.column-d[c.start.line]-c.start.column:d[t]-d[c.start.line]-c.start.column}C(n,r){const c=n.piece,d=c.lineFeedCnt,t=this.u(c.bufferIndex,c.end),p=r,u=this.u(c.bufferIndex,p),o=this.t(c.bufferIndex,c.start,p),v=o-d,b=u-t,$=c.length+b;n.piece=new l(c.bufferIndex,c.start,p,o,$),(0,F.$dC)(this,n,b,v)}D(n,r){const c=n.piece,d=c.lineFeedCnt,t=this.u(c.bufferIndex,c.start),p=r,u=this.t(c.bufferIndex,p,c.end),o=this.u(c.bufferIndex,p),v=u-d,b=t-o,$=c.length+b;n.piece=new l(c.bufferIndex,p,c.end,u,$),(0,F.$dC)(this,n,b,v)}E(n,r,c){const d=n.piece,t=d.start,p=d.end,u=d.length,o=d.lineFeedCnt,v=r,b=this.t(d.bufferIndex,d.start,v),$=this.u(d.bufferIndex,r)-this.u(d.bufferIndex,t);n.piece=new l(d.bufferIndex,d.start,v,b,$),(0,F.$dC)(this,n,$-u,b-o);const I=new l(d.bufferIndex,c,p,this.t(d.bufferIndex,c,p),this.u(d.bufferIndex,p)-this.u(d.bufferIndex,c)),h=this.S(n,I);this.N(h)}F(n,r){this.Q(r,n)&&(r+=`
`);const c=this.K()&&this.L(r)&&this.M(n),d=this.a[0].buffer.length;this.a[0].buffer+=r;const t=O(r,!1);for(let h=0;h<t.length;h++)t[h]+=d;if(c){const h=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:d-h}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const p=this.a[0].lineStarts.length-1,u=this.a[0].buffer.length-this.a[0].lineStarts[p],o={line:p,column:u},v=n.piece.length+r.length,b=n.piece.lineFeedCnt,$=this.t(0,n.piece.start,o),I=$-b;n.piece=new l(n.piece.bufferIndex,n.piece.start,o,$,v),this.g=o,(0,F.$dC)(this,n,r.length,I)}G(n){let r=this.root;const c=this.h.get(n);if(c)return{node:c.node,nodeStartOffset:c.nodeStartOffset,remainder:n-c.nodeStartOffset};let d=0;for(;r!==F.$9B;)if(r.size_left>n)r=r.left;else if(r.size_left+r.piece.length>=n){d+=r.size_left;const t={node:r,remainder:n-r.size_left,nodeStartOffset:d};return this.h.set(t),t}else n-=r.size_left+r.piece.length,d+=r.size_left+r.piece.length,r=r.right;return null}H(n,r){let c=this.root,d=0;for(;c!==F.$9B;)if(c.left!==F.$9B&&c.lf_left>=n-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>n-1){const t=this.B(c,n-c.lf_left-2),p=this.B(c,n-c.lf_left-1);return d+=c.size_left,{node:c,remainder:Math.min(t+r-1,p),nodeStartOffset:d}}else if(c.lf_left+c.piece.lineFeedCnt===n-1){const t=this.B(c,n-c.lf_left-2);if(t+r-1<=c.piece.length)return{node:c,remainder:t+r-1,nodeStartOffset:d};r-=c.piece.length-t;break}else n-=c.lf_left+c.piece.lineFeedCnt,d+=c.size_left+c.piece.length,c=c.right;for(c=c.next();c!==F.$9B;){if(c.piece.lineFeedCnt>0){const t=this.B(c,0),p=this.J(c);return{node:c,remainder:Math.min(r-1,t),nodeStartOffset:p}}else if(c.piece.length>=r-1){const t=this.J(c);return{node:c,remainder:r-1,nodeStartOffset:t}}else r-=c.piece.length;c=c.next()}return null}I(n,r){if(n.piece.lineFeedCnt<1)return-1;const c=this.a[n.piece.bufferIndex],d=this.u(n.piece.bufferIndex,n.piece.start)+r;return c.buffer.charCodeAt(d)}J(n){if(!n)return 0;let r=n.size_left;for(;n!==this.root;)n.parent.right===n&&(r+=n.parent.size_left+n.parent.piece.length),n=n.parent;return r}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===F.$9B||n.piece.lineFeedCnt===0)return!1;const r=n.piece,c=this.a[r.bufferIndex].lineStarts,d=r.start.line,t=c[d]+r.start.column;return d===c.length-1||c[d+1]>t+1?!1:this.a[r.bufferIndex].buffer.charCodeAt(t)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===F.$9B||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const r=n.prev();this.M(r)&&this.P(r,n)}}O(n){if(this.K()&&this.M(n)){const r=n.next();this.L(r)&&this.P(n,r)}}P(n,r){const c=[],d=this.a[n.piece.bufferIndex].lineStarts;let t;n.piece.end.column===0?t={line:n.piece.end.line-1,column:d[n.piece.end.line]-d[n.piece.end.line-1]-1}:t={line:n.piece.end.line,column:n.piece.end.column-1};const p=n.piece.length-1,u=n.piece.lineFeedCnt-1;n.piece=new l(n.piece.bufferIndex,n.piece.start,t,u,p),(0,F.$dC)(this,n,-1,-1),n.piece.length===0&&c.push(n);const o={line:r.piece.start.line+1,column:0},v=r.piece.length-1,b=this.t(r.piece.bufferIndex,o,r.piece.end);r.piece=new l(r.piece.bufferIndex,o,r.piece.end,b,v),(0,F.$dC)(this,r,-1,-1),r.piece.length===0&&c.push(r);const $=this.w(`\r
`);this.S(n,$[0]);for(let I=0;I<c.length;I++)(0,F.$bC)(this,c[I])}Q(n,r){if(this.K()&&this.M(n)){const c=r.next();if(this.L(c)){if(n+=`
`,c.piece.length===1)(0,F.$bC)(this,c);else{const d=c.piece,t={line:d.start.line+1,column:0},p=d.length-1,u=this.t(d.bufferIndex,t,d.end);c.piece=new l(d.bufferIndex,t,d.end,u,p),(0,F.$dC)(this,c,-1,-1)}return!0}}return!1}iterate(n,r){if(n===F.$9B)return r(F.$9B);const c=this.iterate(n.left,r);return c&&r(n)&&this.iterate(n.right,r)}R(n){if(n===F.$9B)return"";const r=this.a[n.piece.bufferIndex],c=n.piece,d=this.u(c.bufferIndex,c.start),t=this.u(c.bufferIndex,c.end);return r.buffer.substring(d,t)}getPieceContent(n){const r=this.a[n.bufferIndex],c=this.u(n.bufferIndex,n.start),d=this.u(n.bufferIndex,n.end);return r.buffer.substring(c,d)}S(n,r){const c=new F.$8B(r,1);if(c.left=F.$9B,c.right=F.$9B,c.parent=F.$9B,c.size_left=0,c.lf_left=0,this.root===F.$9B)this.root=c,c.color=0;else if(n.right===F.$9B)n.right=c,c.parent=n;else{const t=(0,F.$0B)(n.right);t.left=c,c.parent=t}return(0,F.$cC)(this,c),c}T(n,r){const c=new F.$8B(r,1);if(c.left=F.$9B,c.right=F.$9B,c.parent=F.$9B,c.size_left=0,c.lf_left=0,this.root===F.$9B)this.root=c,c.color=0;else if(n.left===F.$9B)n.left=c,c.parent=n;else{const d=(0,F.$$B)(n.left);d.right=c,c.parent=d}return(0,F.$cC)(this,c),c}U(n){let r="";return this.iterate(n,c=>(r+=this.R(c),!0)),r}}e.$pC=a}),define(Pe[135],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K9=e.$J9=void 0;class S{constructor(){this.a=new Map}removeDragOperationTransfer(F){if(F&&this.a.has(F)){const R=this.a.get(F);return this.a.delete(F),R}}addDragOperationTransfer(F,R){this.a.set(F,R)}}e.$J9=S;class M{constructor(F){this.identifier=F}}e.$K9=M}),define(Pe[136],Re([9,10]),function(me,e){return me.create("vs/base/common/actions",e)}),define(Pe[137],Re([1,0,5,6,136]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=void 0;class F extends M.$Tc{constructor(l,E="",g="",s=!0,a){super(),this.h=this.B(new S.$5d),this.onDidChange=this.h.event,this.w=!0,this.j=l,this.m=E,this.u=g,this.w=s,this.C=a}get id(){return this.j}get label(){return this.m}set label(l){this.D(l)}D(l){this.m!==l&&(this.m=l,this.h.fire({label:l}))}get tooltip(){return this.n||""}set tooltip(l){this.F(l)}F(l){this.n!==l&&(this.n=l,this.h.fire({tooltip:l}))}get class(){return this.u}set class(l){this.G(l)}G(l){this.u!==l&&(this.u=l,this.h.fire({class:l}))}get enabled(){return this.w}set enabled(l){this.H(l)}H(l){this.w!==l&&(this.w=l,this.h.fire({enabled:l}))}get checked(){return this.z}set checked(l){this.I(l)}I(l){this.z!==l&&(this.z=l,this.h.fire({checked:l}))}async run(l,E){this.C&&await this.C(l)}}e.$Wi=F;class R extends M.$Tc{constructor(){super(...arguments),this.f=this.B(new S.$5d),this.onWillRun=this.f.event,this.m=this.B(new S.$5d),this.onDidRun=this.m.event}async run(l,E){if(!l.enabled)return;this.f.fire({action:l});let g;try{await this.u(l,E)}catch(s){g=s}this.m.fire({action:l,error:g})}async u(l,E){await l.run(E)}}e.$Xi=R;class m{constructor(){this.id=m.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...l){let E=[];for(const g of l)g.length&&(E.length?E=[...E,new m,...g]:E=g);return E}static{this.ID="vs.actions.separator"}async run(){}}e.$Yi=m;class f{get actions(){return this.a}constructor(l,E,g,s){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=l,this.label=E,this.class=s,this.a=g}async run(){}}e.$Zi=f;class k extends F{static{this.ID="vs.actions.empty"}constructor(){super(k.ID,P.localize(0,null),void 0,!1)}}e.$1i=k;function O(D){return{id:D.id,label:D.label,class:D.class,enabled:D.enabled??!0,checked:D.checked,run:async(...l)=>D.run(...l),tooltip:D.label}}e.$2i=O}),define(Pe[138],Re([9,10]),function(me,e){return me.create("vs/base/common/date",e)}),define(Pe[139],Re([1,0,138]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lm=e.$Km=e.$Jm=void 0;const M=60,P=M*60,F=P*24,R=F*7,m=F*30,f=F*365;function k(l,E,g,s){typeof l!="number"&&(l=l.getTime());const a=Math.round((new Date().getTime()-l)/1e3);if(a<-30)return(0,S.localize)(0,null,k(new Date().getTime()+a*1e3,!1));if(!s&&a<30)return(0,S.localize)(1,null);let i;return a<M?(i=a,E?i===1?g?(0,S.localize)(2,null,i):(0,S.localize)(3,null,i):g?(0,S.localize)(4,null,i):(0,S.localize)(5,null,i):i===1?g?(0,S.localize)(6,null,i):(0,S.localize)(7,null,i):g?(0,S.localize)(8,null,i):(0,S.localize)(9,null,i)):a<P?(i=Math.floor(a/M),E?i===1?g?(0,S.localize)(10,null,i):(0,S.localize)(11,null,i):g?(0,S.localize)(12,null,i):(0,S.localize)(13,null,i):i===1?g?(0,S.localize)(14,null,i):(0,S.localize)(15,null,i):g?(0,S.localize)(16,null,i):(0,S.localize)(17,null,i)):a<F?(i=Math.floor(a/P),E?i===1?g?(0,S.localize)(18,null,i):(0,S.localize)(19,null,i):g?(0,S.localize)(20,null,i):(0,S.localize)(21,null,i):i===1?g?(0,S.localize)(22,null,i):(0,S.localize)(23,null,i):g?(0,S.localize)(24,null,i):(0,S.localize)(25,null,i)):a<R?(i=Math.floor(a/F),E?i===1?(0,S.localize)(26,null,i):(0,S.localize)(27,null,i):i===1?(0,S.localize)(28,null,i):(0,S.localize)(29,null,i)):a<m?(i=Math.floor(a/R),E?i===1?g?(0,S.localize)(30,null,i):(0,S.localize)(31,null,i):g?(0,S.localize)(32,null,i):(0,S.localize)(33,null,i):i===1?g?(0,S.localize)(34,null,i):(0,S.localize)(35,null,i):g?(0,S.localize)(36,null,i):(0,S.localize)(37,null,i)):a<f?(i=Math.floor(a/m),E?i===1?g?(0,S.localize)(38,null,i):(0,S.localize)(39,null,i):g?(0,S.localize)(40,null,i):(0,S.localize)(41,null,i):i===1?g?(0,S.localize)(42,null,i):(0,S.localize)(43,null,i):g?(0,S.localize)(44,null,i):(0,S.localize)(45,null,i)):(i=Math.floor(a/f),E?i===1?g?(0,S.localize)(46,null,i):(0,S.localize)(47,null,i):g?(0,S.localize)(48,null,i):(0,S.localize)(49,null,i):i===1?g?(0,S.localize)(50,null,i):(0,S.localize)(51,null,i):g?(0,S.localize)(52,null,i):(0,S.localize)(53,null,i))}e.$Jm=k;function O(l,E){const g=Math.abs(l/1e3);return g<1?E?(0,S.localize)(54,null,l):(0,S.localize)(55,null,l):g<M?E?(0,S.localize)(56,null,Math.round(l)/1e3):(0,S.localize)(57,null,Math.round(l)/1e3):g<P?E?(0,S.localize)(58,null,Math.round(l/(1e3*M))):(0,S.localize)(59,null,Math.round(l/(1e3*M))):g<F?E?(0,S.localize)(60,null,Math.round(l/(1e3*P))):(0,S.localize)(61,null,Math.round(l/(1e3*P))):(0,S.localize)(62,null,Math.round(l/(1e3*F)))}e.$Km=O;function D(l){return l.getFullYear()+"-"+String(l.getMonth()+1).padStart(2,"0")+"-"+String(l.getDate()).padStart(2,"0")+"T"+String(l.getHours()).padStart(2,"0")+":"+String(l.getMinutes()).padStart(2,"0")+":"+String(l.getSeconds()).padStart(2,"0")+"."+(l.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$Lm=D}),define(Pe[140],Re([9,10]),function(me,e){return me.create("vs/base/common/errorMessage",e)}),define(Pe[41],Re([1,0,18,16,140]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5i=e.$4i=e.$3i=void 0;function F(D,l){return l&&(D.stack||D.stacktrace)?P.localize(0,null,m(D),R(D.stack)||R(D.stacktrace)):m(D)}function R(D){return Array.isArray(D)?D.join(`
`):D}function m(D){return D.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${D.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof D.code=="string"&&typeof D.errno=="number"&&typeof D.syscall=="string"?P.localize(1,null,D.message):D.message||P.localize(2,null)}function f(D=null,l=!1){if(!D)return P.localize(3,null);if(Array.isArray(D)){const E=S.$Hb(D),g=f(E[0],l);return E.length>1?P.localize(4,null,g,E.length):g}if(M.$Sf(D))return D;if(D.detail){const E=D.detail;if(E.error)return F(E.error,l);if(E.exception)return F(E.exception,l)}return D.stack?F(D,l):D.message?D.message:P.localize(5,null)}e.$3i=f;function k(D){const l=D;return l instanceof Error&&Array.isArray(l.actions)}e.$4i=k;function O(D,l){let E;return typeof D=="string"?E=new Error(D):E=D,E.actions=l,E}e.$5i=O}),define(Pe[141],Re([1,0,39,19]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=e.$8q=e.$7q=e.$6q=e.$5q=e.$4q=e.$3q=e.$2q=e.$1q=e.$Zq=e.$Yq=e.$Xq=e.$Wq=void 0;const P=new S.$V(()=>{const I=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:I,collatorIsNumeric:I.resolvedOptions().numeric}}),F=new S.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new S.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function m(I,h,y=!1){const w=I||"",A=h||"",N=P.value.collator.compare(w,A);return P.value.collatorIsNumeric&&N===0&&w!==A?w<A?-1:1:N}e.$Wq=m;function f(I,h){const y=F.value.collator;return I=I||"",h=h||"",c(y,I,h)}e.$Xq=f;function k(I,h){const y=F.value.collator;return I=I||"",h=h||"",u(I,h)||c(y,I,h)}e.$Yq=k;function O(I,h){const y=F.value.collator;return I=I||"",h=h||"",p(I,h)||c(y,I,h)}e.$Zq=O;function D(I,h){return I=I||"",h=h||"",I===h?0:I<h?-1:1}e.$1q=D;function l(I,h){const[y,w]=n(I),[A,N]=n(h);let G=P.value.collator.compare(w,N);if(G===0){if(P.value.collatorIsNumeric&&w!==N)return w<N?-1:1;if(G=P.value.collator.compare(y,A),P.value.collatorIsNumeric&&G===0&&y!==A)return y<A?-1:1}return G}e.$2q=l;function E(I,h){I=I||"",h=h||"";const y=r(I),w=r(h),A=F.value.collator,N=R.value.collator;return c(N,y,w)||c(A,I,h)}e.$3q=E;function g(I,h){I=I||"",h=h||"";const y=r(I),w=r(h),A=F.value.collator,N=R.value.collator;return c(N,y,w)||u(I,h)||c(A,I,h)}e.$4q=g;function s(I,h){I=I||"",h=h||"";const y=r(I),w=r(h),A=F.value.collator,N=R.value.collator;return c(N,y,w)||p(I,h)||c(A,I,h)}e.$5q=s;function a(I,h){I=I||"",h=h||"";const y=r(I).toLowerCase(),w=r(h).toLowerCase();return y!==w?y<w?-1:1:I!==h?I<h?-1:1:0}e.$6q=a;const i=/^(.*?)(\.([^.]*))?$/;function n(I,h=!1){const y=I?i.exec(I):[];let w=[y&&y[1]||"",y&&y[3]||""];return h&&(!w[0]&&w[1]||w[0]&&w[0].charAt(0)===".")&&(w=[w[0]+"."+w[1],""]),w}function r(I){const h=I?i.exec(I):[];return h&&h[1]&&h[1].charAt(0)!=="."&&h[3]||""}function c(I,h,y){const w=I.compare(h,y);return w!==0?w:h.length!==y.length?h.length<y.length?-1:1:0}function d(I){const h=I.charAt(0);return h.toLocaleUpperCase()!==h}function t(I){const h=I.charAt(0);return h.toLocaleLowerCase()!==h}function p(I,h){return d(I)&&t(h)?-1:t(I)&&d(h)?1:0}function u(I,h){return t(I)&&d(h)?-1:d(I)&&t(h)?1:0}function o(I,h,y=!1){return y||(I=I&&I.toLowerCase(),h=h&&h.toLowerCase()),I===h?0:I<h?-1:1}function v(I,h,y=!1){const w=I.split(M.sep),A=h.split(M.sep),N=w.length-1,G=A.length-1;let V,U;for(let C=0;;C++){if(V=N===C,U=G===C,V&&U)return m(w[C],A[C],y);if(V)return-1;if(U)return 1;const L=o(w[C],A[C],y);if(L!==0)return L}}e.$7q=v;function b(I,h,y){const w=I.toLowerCase(),A=h.toLowerCase(),N=$(I,h,y);if(N)return N;const G=w.endsWith(y),V=A.endsWith(y);if(G!==V)return G?-1:1;const U=m(w,A);return U!==0?U:w.localeCompare(A)}e.$8q=b;function $(I,h,y){const w=I.toLowerCase(),A=h.toLowerCase(),N=w.startsWith(y),G=A.startsWith(y);if(N!==G)return N?-1:1;if(N&&G){if(w.length<A.length)return-1;if(w.length>A.length)return 1}return 0}e.$9q=$}),define(Pe[45],Re([1,0,19,21,15,16]),function(me,e,S,M,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=void 0;function R(b){return b===47||b===92}e.$$f=R;function m(b){return b.replace(/[\\/]/g,S.$gc.sep)}e.$_f=m;function f(b){return b.indexOf("/")===-1&&(b=m(b)),/^[a-zA-Z]:(\/|$)/.test(b)&&(b="/"+b),b}e.$ag=f;function k(b,$=S.$gc.sep){if(!b)return"";const I=b.length,h=b.charCodeAt(0);if(R(h)){if(R(b.charCodeAt(1))&&!R(b.charCodeAt(2))){let w=3;const A=w;for(;w<I&&!R(b.charCodeAt(w));w++);if(A!==w&&!R(b.charCodeAt(w+1))){for(w+=1;w<I;w++)if(R(b.charCodeAt(w)))return b.slice(0,w+1).replace(/[\\/]/g,$)}}return $}else if(i(h)&&b.charCodeAt(1)===58)return R(b.charCodeAt(2))?b.slice(0,2)+$:b.slice(0,2);let y=b.indexOf("://");if(y!==-1){for(y+=3;y<I;y++)if(R(b.charCodeAt(y)))return b.slice(0,y+1)}return""}e.$bg=k;function O(b){if(!M.$i||!b||b.length<5)return!1;let $=b.charCodeAt(0);if($!==92||($=b.charCodeAt(1),$!==92))return!1;let I=2;const h=I;for(;I<b.length&&($=b.charCodeAt(I),$!==92);I++);return!(h===I||($=b.charCodeAt(I+1),isNaN($)||$===92))}e.$cg=O;const D=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,E=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(b,$=M.$i){const I=$?D:l;return!(!b||b.length===0||/^\s+$/.test(b)||(I.lastIndex=0,I.test(b))||$&&E.test(b)||b==="."||b===".."||$&&b[b.length-1]==="."||$&&b.length!==b.trim().length||b.length>255)}e.$dg=g;function s(b,$,I){const h=b===$;return!I||h?h:!b||!$?!1:(0,P.$jf)(b,$)}e.$eg=s;function a(b,$,I,h=S.sep){if(b===$)return!0;if(!b||!$||$.length>b.length)return!1;if(I){if(!(0,P.$kf)(b,$))return!1;if($.length===b.length)return!0;let w=$.length;return $.charAt($.length-1)===h&&w--,b.charAt(w)===h}return $.charAt($.length-1)!==h&&($+=h),b.indexOf($)===0}e.$fg=a;function i(b){return b>=65&&b<=90||b>=97&&b<=122}e.$gg=i;function n(b,$){return M.$i&&b.endsWith(":")&&(b+=S.sep),(0,S.$ic)(b)||(b=(0,S.$jc)($,b)),b=(0,S.$hc)(b),M.$i?(b=(0,P.$4e)(b,S.sep),b.endsWith(":")&&(b+=S.sep)):(b=(0,P.$4e)(b,S.sep),b||(b=S.sep)),b}e.$hg=n;function r(b){const $=(0,S.$hc)(b);return M.$i?b.length>3?!1:c($)&&(b.length===2||$.charCodeAt(2)===92):$===S.$gc.sep}e.$ig=r;function c(b,$=M.$i){return $?i(b.charCodeAt(0))&&b.charCodeAt(1)===58:!1}e.$jg=c;function d(b,$=M.$i){return c(b,$)?b[0]:void 0}e.$kg=d;function t(b,$,I){return $.length>b.length?-1:b===$?0:(I&&(b=b.toLowerCase(),$=$.toLowerCase()),b.indexOf($))}e.$lg=t;function p(b){const $=b.split(":");let I,h,y;for(const w of $){const A=Number(w);(0,F.$Wf)(A)?h===void 0?h=A:y===void 0&&(y=A):I=I?[I,w].join(":"):w}if(!I)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:I,line:h!==void 0?h:void 0,column:y!==void 0?y:h!==void 0?1:void 0}}e.$mg=p;const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",o="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function v(b,$,I=8){let h="";for(let w=0;w<I;w++){let A;w===0&&M.$i&&!$&&(I===3||I===4)?A=o:A=u,h+=A.charAt(Math.floor(Math.random()*A.length))}let y;return $?y=`${$}-${h}`:y=h,b?(0,S.$jc)(b,y):y}e.$ng=v}),define(Pe[69],Re([1,0,19]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xs=e.$ws=e.$vs=e.$us=e.$ts=void 0,e.$ts=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const M={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function F(O){const D=(0,S.$oc)(O),l=M[D.toLowerCase()];return l!==void 0?l:R(O)}e.$us=F;function R(O){const D=(0,S.$oc)(O);return P[D.toLowerCase()]}e.$vs=R;function m(O){for(const D in P)if(P[D]===O)return D}e.$ws=m;const f=/^(.+)\/(.+?)(;.+)?$/;function k(O,D){const l=f.exec(O);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:D?void 0:O}e.$xs=k}),define(Pe[52],Re([1,0,23,2]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oh=e.$Nh=e.$Mh=void 0;function P(f){return JSON.stringify(f,R)}e.$Mh=P;function F(f){let k=JSON.parse(f);return k=m(k),k}e.$Nh=F;function R(f,k){return k instanceof RegExp?{$mid:2,source:k.source,flags:k.flags}:k}function m(f,k=0){if(!f||k>200)return f;if(typeof f=="object"){switch(f.$mid){case 1:return M.URI.revive(f);case 2:return new RegExp(f.source,f.flags);case 17:return new Date(f.source)}if(f instanceof S.$se||f instanceof Uint8Array)return f;if(Array.isArray(f))for(let O=0;O<f.length;++O)f[O]=m(f[O],k+1);else for(const O in f)Object.hasOwnProperty.call(f,O)&&(f[O]=m(f[O],k+1))}return f}e.$Oh=m}),define(Pe[12],Re([1,0,14,21,15,2,19]),function(me,e,S,M,P,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.Schemas=void 0;var m;(function(g){g.inMemory="inmemory",g.vscode="vscode",g.internal="private",g.walkThrough="walkThrough",g.walkThroughSnippet="walkThroughSnippet",g.http="http",g.https="https",g.file="file",g.mailto="mailto",g.untitled="untitled",g.data="data",g.command="command",g.vscodeRemote="vscode-remote",g.vscodeRemoteResource="vscode-remote-resource",g.vscodeManagedRemoteResource="vscode-managed-remote-resource",g.vscodeUserData="vscode-userdata",g.vscodeCustomEditor="vscode-custom-editor",g.vscodeNotebookCell="vscode-notebook-cell",g.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",g.vscodeNotebookCellOutput="vscode-notebook-cell-output",g.vscodeInteractiveInput="vscode-interactive-input",g.vscodeSettings="vscode-settings",g.vscodeWorkspaceTrust="vscode-workspace-trust",g.vscodeTerminal="vscode-terminal",g.vscodeChatCodeBlock="vscode-chat-code-block",g.vscodeChatSesssion="vscode-chat-editor",g.webviewPanel="webview-panel",g.vscodeWebview="vscode-webview",g.extension="extension",g.vscodeFileResource="vscode-file",g.tmp="tmp",g.vsls="vsls",g.vscodeSourceControl="vscode-scm",g.codeSetting="code-setting"})(m||(e.Schemas=m={}));function f(g,s){return F.URI.isUri(g)?(0,P.$jf)(g.scheme,s):(0,P.$kf)(g,s+":")}e.$og=f;function k(g,...s){return s.some(a=>f(g,a))}e.$pg=k,e.$qg="vscode-tkn",e.$rg="tkn";class O{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(s){this.d=s}setDelegate(s){this.e=s}setServerRootPath(s,a){this.f=D(s,a)}getServerRootPath(){return this.f}get g(){return R.$gc.join(this.f,m.vscodeRemoteResource)}set(s,a,i){this.a[s]=a,this.b[s]=i}setConnectionToken(s,a){this.c[s]=a}getPreferredWebSchema(){return this.d}rewrite(s){if(this.e)try{return this.e(s)}catch(d){return S.$1(d),s}const a=s.authority;let i=this.a[a];i&&i.indexOf(":")!==-1&&i.indexOf("[")===-1&&(i=`[${i}]`);const n=this.b[a],r=this.c[a];let c=`path=${encodeURIComponent(s.path)}`;return typeof r=="string"&&(c+=`&${e.$rg}=${encodeURIComponent(r)}`),F.URI.from({scheme:M.$o?this.d:m.vscodeRemoteResource,authority:`${i}:${n}`,path:this.g,query:c})}}e.$sg=new O;function D(g,s){return R.$gc.join(s??"/",`${g.quality??"oss"}-${g.commit??"dev"}`)}e.$tg=D,e.$ug="vs/../../extensions",e.$vg="vs/../../node_modules",e.$wg="vs/../../node_modules.asar",e.$xg="vs/../../node_modules.asar.unpacked",e.$yg="vscode-app";class l{static{this.a=e.$yg}asBrowserUri(s){const a=this.b(s,me);return this.uriToBrowserUri(a)}uriToBrowserUri(s){return s.scheme===m.vscodeRemote?e.$sg.rewrite(s):s.scheme===m.file&&(M.$m||M.$q===`${m.vscodeFileResource}://${l.a}`)?s.with({scheme:m.vscodeFileResource,authority:s.authority||l.a,query:null,fragment:null}):s}asFileUri(s){const a=this.b(s,me);return this.uriToFileUri(a)}uriToFileUri(s){return s.scheme===m.vscodeFileResource?s.with({scheme:m.file,authority:s.authority!==l.a?s.authority:null,query:null,fragment:null}):s}b(s,a){return F.URI.isUri(s)?s:F.URI.parse(a.toUrl(s))}}e.$zg=new l;var E;(function(g){const s=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);g.CoopAndCoep=Object.freeze(s.get("3"));const a="vscode-coi";function i(r){let c;typeof r=="string"?c=new URL(r).searchParams:r instanceof URL?c=r.searchParams:F.URI.isUri(r)&&(c=new URL(r.toString(!0)).searchParams);const d=c?.get(a);if(d)return s.get(d)}g.getHeadersFromQuery=i;function n(r,c,d){if(!globalThis.crossOriginIsolated)return;const t=c&&d?"3":d?"2":"1";r instanceof URLSearchParams?r.set(a,t):r[a]=t}g.addSearchParam=n})(E||(e.COI=E={}))}),define(Pe[24],Re([1,0,45,12,19,21,15,2]),function(me,e,S,M,P,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3g=e.DataUri=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=void 0;function f(E){return(0,m.$wc)(E,!0)}e.$Gg=f;class k{constructor(g){this.a=g}compare(g,s,a=!1){return g===s?0:(0,R.$cf)(this.getComparisonKey(g,a),this.getComparisonKey(s,a))}isEqual(g,s,a=!1){return g===s?!0:!g||!s?!1:this.getComparisonKey(g,a)===this.getComparisonKey(s,a)}getComparisonKey(g,s=!1){return g.with({path:this.a(g)?g.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(g){return this.a(g)}isEqualOrParent(g,s,a=!1){if(g.scheme===s.scheme){if(g.scheme===M.Schemas.file)return S.$fg(f(g),f(s),this.a(g))&&g.query===s.query&&(a||g.fragment===s.fragment);if((0,e.$Xg)(g.authority,s.authority))return S.$fg(g.path,s.path,this.a(g),"/")&&g.query===s.query&&(a||g.fragment===s.fragment)}return!1}joinPath(g,...s){return m.URI.joinPath(g,...s)}basenameOrAuthority(g){return(0,e.$Pg)(g)||g.authority}basename(g){return P.$gc.basename(g.path)}extname(g){return P.$gc.extname(g.path)}dirname(g){if(g.path.length===0)return g;let s;return g.scheme===M.Schemas.file?s=m.URI.file(P.$mc(f(g))).path:(s=P.$gc.dirname(g.path),g.authority&&s.length&&s.charCodeAt(0)!==47&&(console.error(`dirname("${g.toString})) resulted in a relative path`),s="/")),g.with({path:s})}normalizePath(g){if(!g.path.length)return g;let s;return g.scheme===M.Schemas.file?s=m.URI.file(P.$hc(f(g))).path:s=P.$gc.normalize(g.path),g.with({path:s})}relativePath(g,s){if(g.scheme!==s.scheme||!(0,e.$Xg)(g.authority,s.authority))return;if(g.scheme===M.Schemas.file){const n=P.$lc(f(g),f(s));return F.$i?S.$_f(n):n}let a=g.path||"/";const i=s.path||"/";if(this.a(g)){let n=0;for(const r=Math.min(a.length,i.length);n<r&&!(a.charCodeAt(n)!==i.charCodeAt(n)&&a.charAt(n).toLowerCase()!==i.charAt(n).toLowerCase());n++);a=i.substr(0,n)+a.substr(n)}return P.$gc.relative(a,i)}resolvePath(g,s){if(g.scheme===M.Schemas.file){const a=m.URI.file(P.$kc(f(g),s));return g.with({authority:a.authority,path:a.path})}return s=S.$ag(s),g.with({path:P.$gc.resolve(g.path,s)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,s){return g===s||g!==void 0&&s!==void 0&&(0,R.$jf)(g,s)}hasTrailingPathSeparator(g,s=P.sep){if(g.scheme===M.Schemas.file){const a=f(g);return a.length>S.$bg(a).length&&a[a.length-1]===s}else{const a=g.path;return a.length>1&&a.charCodeAt(a.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,s=P.sep){return(0,e.$Yg)(g,s)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,s=P.sep){let a=!1;if(g.scheme===M.Schemas.file){const i=f(g);a=i!==void 0&&i.length===S.$bg(i).length&&i[i.length-1]===s}else{s="/";const i=g.path;a=i.length===1&&i.charCodeAt(i.length-1)===47}return!a&&!(0,e.$Yg)(g,s)?g.with({path:g.path+"/"}):g}}e.$Hg=k,e.$Ig=new k(()=>!1),e.$Jg=new k(E=>E.scheme===M.Schemas.file?!F.$k:!0),e.$Kg=new k(E=>!0),e.$Lg=e.$Ig.isEqual.bind(e.$Ig),e.$Mg=e.$Ig.isEqualOrParent.bind(e.$Ig),e.$Ng=e.$Ig.getComparisonKey.bind(e.$Ig),e.$Og=e.$Ig.basenameOrAuthority.bind(e.$Ig),e.$Pg=e.$Ig.basename.bind(e.$Ig),e.$Qg=e.$Ig.extname.bind(e.$Ig),e.$Rg=e.$Ig.dirname.bind(e.$Ig),e.$Sg=e.$Ig.joinPath.bind(e.$Ig),e.$Tg=e.$Ig.normalizePath.bind(e.$Ig),e.$Ug=e.$Ig.relativePath.bind(e.$Ig),e.$Vg=e.$Ig.resolvePath.bind(e.$Ig),e.$Wg=e.$Ig.isAbsolutePath.bind(e.$Ig),e.$Xg=e.$Ig.isEqualAuthority.bind(e.$Ig),e.$Yg=e.$Ig.hasTrailingPathSeparator.bind(e.$Ig),e.$Zg=e.$Ig.removeTrailingPathSeparator.bind(e.$Ig),e.$1g=e.$Ig.addTrailingPathSeparator.bind(e.$Ig);function O(E,g){const s=[];for(let a=0;a<E.length;a++){const i=g(E[a]);E.some((n,r)=>r===a?!1:(0,e.$Mg)(i,g(n)))||s.push(E[a])}return s}e.$2g=O;var D;(function(E){E.META_DATA_LABEL="label",E.META_DATA_DESCRIPTION="description",E.META_DATA_SIZE="size",E.META_DATA_MIME="mime";function g(s){const a=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(r=>{const[c,d]=r.split(":");c&&d&&a.set(c,d)});const n=s.path.substring(0,s.path.indexOf(";"));return n&&a.set(E.META_DATA_MIME,n),a}E.parseMetaData=g})(D||(e.DataUri=D={}));function l(E,g,s){if(g){let a=E.path;return a&&a[0]!==P.$gc.sep&&(a=P.$gc.sep+a),E.with({scheme:s,authority:g,path:a})}return E.with({scheme:s})}e.$3g=l}),define(Pe[11],Re([1,0,25,14,5,6,24,21,128,39]),function(me,e,S,M,P,F,R,m,f,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.Promises=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=void 0;function O(ge){return!!ge&&typeof ge.then=="function"}e.$4g=O;function D(ge){const J=new S.$ce,X=ge(J.token),he=new Promise((fe,Fe)=>{const de=J.token.onCancellationRequested(()=>{de.dispose(),Fe(new M.$5)});Promise.resolve(X).then(Ce=>{de.dispose(),J.dispose(),fe(Ce)},Ce=>{de.dispose(),J.dispose(),Fe(Ce)})});return new class{cancel(){J.cancel(),J.dispose()}then(fe,Fe){return he.then(fe,Fe)}catch(fe){return this.then(void 0,fe)}finally(fe){return he.finally(fe)}}}e.$5g=D;function l(ge,J,X){return new Promise((he,fe)=>{const Fe=J.onCancellationRequested(()=>{Fe.dispose(),he(X)});ge.then(he,fe).finally(()=>Fe.dispose())})}e.$6g=l;function E(ge,J){return new Promise((X,he)=>{const fe=J.onCancellationRequested(()=>{fe.dispose(),he(new M.$5)});ge.then(X,he).finally(()=>fe.dispose())})}e.$7g=E;async function g(ge){let J=-1;const X=ge.map((he,fe)=>he.then(Fe=>(J=fe,Fe)));try{return await Promise.race(X)}finally{ge.forEach((he,fe)=>{fe!==J&&he.cancel()})}}e.$8g=g;function s(ge,J,X){let he;const fe=setTimeout(()=>{he?.(void 0),X?.()},J);return Promise.race([ge.finally(()=>clearTimeout(fe)),new Promise(Fe=>he=Fe)])}e.$9g=s;function a(ge){return new Promise((J,X)=>{const he=ge();O(he)?he.then(J,X):J(he)})}e.$0g=a;function i(){let ge,J;return{promise:new Promise((he,fe)=>{ge=he,J=fe}),resolve:ge,reject:J}}e.$$g=i;class n{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(J){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=J,!this.b){const X=()=>{if(this.b=null,this.f)return;const he=this.queue(this.d);return this.d=null,he};this.b=new Promise(he=>{this.a.then(X,X).then(he)})}return new Promise((X,he)=>{this.b.then(X,he)})}return this.a=J(),new Promise((X,he)=>{this.a.then(fe=>{this.a=null,X(fe)},fe=>{this.a=null,he(fe)})})}dispose(){this.f=!0}}e.$_g=n;class r{constructor(){this.a=Promise.resolve(null)}queue(J){return this.a=this.a.then(()=>J(),()=>J())}}e.$ah=r;class c{constructor(){this.a=new Map}queue(J,X){const fe=(this.a.get(J)??Promise.resolve()).catch(()=>{}).then(X).finally(()=>{this.a.get(J)===fe&&this.a.delete(J)});return this.a.set(J,fe),fe}}e.$bh=c;const d=(ge,J)=>{let X=!0;const he=setTimeout(()=>{X=!1,J()},ge);return{isTriggered:()=>X,dispose:()=>{clearTimeout(he),X=!1}}},t=ge=>{let J=!0;return queueMicrotask(()=>{J&&(J=!1,ge())}),{isTriggered:()=>J,dispose:()=>{J=!1}}};class p{constructor(J){this.defaultDelay=J,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(J,X=this.defaultDelay){this.g=J,this.h(),this.b||(this.b=new Promise((fe,Fe)=>{this.d=fe,this.f=Fe}).then(()=>{if(this.b=null,this.d=null,this.g){const fe=this.g;return this.g=null,fe()}}));const he=()=>{this.a=null,this.d?.(null)};return this.a=X===f.$2d?t(he):d(X,he),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new M.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$ch=p;class u{constructor(J){this.a=new p(J),this.b=new n}trigger(J,X){return this.a.trigger(()=>this.b.queue(J),X)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$dh=u;class o{constructor(){this.a=!1,this.b=new Promise((J,X)=>{this.d=J})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$eh=o;class v extends o{constructor(J){super(),this.f=setTimeout(()=>this.open(),J)}open(){clearTimeout(this.f),super.open()}}e.$fh=v;function b(ge,J){return J?new Promise((X,he)=>{const fe=setTimeout(()=>{Fe.dispose(),X()},ge),Fe=J.onCancellationRequested(()=>{clearTimeout(fe),Fe.dispose(),he(new M.$5)})}):D(X=>b(ge,X))}e.$gh=b;function $(ge,J=0,X){const he=setTimeout(()=>{ge(),X&&fe.dispose()},J),fe=(0,F.$Rc)(()=>{clearTimeout(he),X?.deleteAndLeak(fe)});return X?.add(fe),fe}e.$hh=$;function I(ge){const J=[];let X=0;const he=ge.length;function fe(){return X<he?ge[X++]():null}function Fe(de){de!=null&&J.push(de);const Ce=fe();return Ce?Ce.then(Fe):Promise.resolve(J)}return Promise.resolve(null).then(Fe)}e.$ih=I;function h(ge,J=he=>!!he,X=null){let he=0;const fe=ge.length,Fe=()=>{if(he>=fe)return Promise.resolve(X);const de=ge[he++];return Promise.resolve(de()).then(Ae=>J(Ae)?Promise.resolve(Ae):Fe())};return Fe()}e.$jh=h;function y(ge,J=he=>!!he,X=null){if(ge.length===0)return Promise.resolve(X);let he=ge.length;const fe=()=>{he=-1;for(const Fe of ge)Fe.cancel?.()};return new Promise((Fe,de)=>{for(const Ce of ge)Ce.then(Ae=>{--he>=0&&J(Ae)?(fe(),Fe(Ae)):he===0&&Fe(X)}).catch(Ae=>{--he>=0&&(fe(),de(Ae))})})}e.$kh=y;class w{constructor(J){this.a=0,this.b=!1,this.f=J,this.g=[],this.d=0,this.h=new P.$5d}whenIdle(){return this.size>0?P.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(J){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((X,he)=>{this.g.push({factory:J,c:X,e:he}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const J=this.g.shift();this.d++;const X=J.factory();X.then(J.c,J.e),X.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$lh=w;class A extends w{constructor(){super(1)}}e.$mh=A;class N{constructor(){this.a=new ue,this.b=0}queue(J){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,J())):this.a.run(this.b++,J())}}e.$nh=N;class G{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const J=new $e;return this.b.add(J),J.p}g(){for(const[,J]of this.a)if(J.size>0)return!1;return!0}queueSize(J,X=R.$Ig){const he=X.getComparisonKey(J);return this.a.get(he)?.size??0}queueFor(J,X,he=R.$Ig){const fe=he.getComparisonKey(J);let Fe=this.a.get(fe);if(!Fe){Fe=new A;const de=this.f++,Ce=P.Event.once(Fe.onDrained)(()=>{Fe?.dispose(),this.a.delete(fe),this.h(),this.d?.deleteAndDispose(de),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new F.$3c),this.d.set(de,Ce),this.a.set(fe,Fe)}return Fe.queue(X)}h(){this.g()&&this.j()}j(){for(const J of this.b)J.complete();this.b.clear()}dispose(){for(const[,J]of this.a)J.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$oh=G;class V{constructor(J,X){this.a=-1,typeof J=="function"&&typeof X=="number"&&this.setIfNotSet(J,X)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(J,X){this.cancel(),this.a=setTimeout(()=>{this.a=-1,J()},X)}setIfNotSet(J,X){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,J()},X))}}e.$ph=V;class U{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(J,X,he=globalThis){this.cancel();const fe=he.setInterval(()=>{J()},X);this.d=(0,F.$Rc)(()=>{he.clearInterval(fe),this.d=void 0})}dispose(){this.cancel()}}e.$qh=U;class C{constructor(J,X){this.b=-1,this.a=J,this.d=X,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(J=this.d){this.cancel(),this.b=setTimeout(this.f,J)}get delay(){return this.d}set delay(J){this.d=J}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$rh=C;class L{constructor(J,X){X%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${X}ms is not a multiple of 1000ms.`),this.a=J,this.b=X,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(J=this.b){J%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(J/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$sh=L;class q extends C{constructor(J,X){super(J,X),this.j=[]}work(J){this.j.push(J),this.isScheduled()||this.schedule()}h(){const J=this.j;this.j=[],this.a?.(J)}dispose(){this.j=[],super.dispose()}}e.$th=q;class ne extends F.$Tc{constructor(J,X){super(),this.g=J,this.h=X,this.a=[],this.b=this.B(new F.$Uc),this.f=!1}get pending(){return this.a.length}work(J){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+J.length>this.g.maxBufferedWork)return!1}else if(this.pending+J.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const X of J)this.a.push(X);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new C(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$uh=ne,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$wh=(ge,J)=>{(0,m.$B)(()=>{if(X)return;const he=Date.now()+15;J(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,he-Date.now())}}))});let X=!1;return{dispose(){X||(X=!0)}}}:e.$wh=(ge,J,X)=>{const he=ge.requestIdleCallback(J,typeof X=="number"?{timeout:X}:void 0);let fe=!1;return{dispose(){fe||(fe=!0,ge.cancelIdleCallback(he))}}},e.$vh=ge=>(0,e.$wh)(globalThis,ge)}();class ae{constructor(J,X){this.g=!1,this.d=()=>{try{this.j=X()}catch(he){this.l=he}finally{this.g=!0}},this.f=(0,e.$wh)(J,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$xh=ae;class ye extends ae{constructor(J){super(globalThis,J)}}e.$yh=ye;async function Ie(ge,J,X){let he;for(let fe=0;fe<X;fe++)try{return await ge()}catch(Fe){he=Fe,await b(J)}throw he}e.$zh=Ie;class ue{isRunning(J){return typeof J=="number"?this.a?.taskId===J:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(J,X,he){return this.a={taskId:J,cancel:()=>he?.(),promise:X},X.then(()=>this.d(J),()=>this.d(J)),X}d(J){this.a&&J===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const J=this.b;this.b=void 0,J.run().then(J.promiseResolve,J.promiseReject)}}queue(J){if(this.b)this.b.run=J;else{const{promise:X,resolve:he,reject:fe}=i();this.b={run:J,promise:X,promiseResolve:he,promiseReject:fe}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Ah=ue;class ve{constructor(J,X=()=>Date.now()){this.d=J,this.f=X,this.a=0,this.b=0}increment(){const J=this.f();return J-this.a>this.d&&(this.a=J,this.b=0),this.b++,this.b}}e.$Bh=ve;var re;(function(ge){ge[ge.Resolved=0]="Resolved",ge[ge.Rejected=1]="Rejected"})(re||(re={}));class $e{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((J,X)=>{this.a=J,this.b=X})}complete(J){return new Promise(X=>{this.a(J),this.d={outcome:0,value:J},X()})}error(J){return new Promise(X=>{this.b(J),this.d={outcome:1,value:J},X()})}cancel(){return this.error(new M.$5)}}e.$Ch=$e;var ie;(function(ge){async function J(he){let fe;const Fe=await Promise.all(he.map(de=>de.then(Ce=>Ce,Ce=>{fe||(fe=Ce)})));if(typeof fe<"u")throw fe;return Fe}ge.settled=J;function X(he){return new Promise(async(fe,Fe)=>{try{await he(fe,Fe)}catch(de){Fe(de)}})}ge.withAsyncBody=X})(ie||(e.Promises=ie={}));class le{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(J){this.a=void 0,this.b=void 0,this.d=!1,this.promise=J.then(X=>(this.a=X,this.d=!0,X),X=>{throw this.b=X,this.d=!0,X})}requireValue(){if(!this.d)throw new M.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Dh=le;class W{constructor(J){this.b=J,this.a=new k.$V(()=>new le(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Eh=W;var _;(function(ge){ge[ge.Initial=0]="Initial",ge[ge.DoneOK=1]="DoneOK",ge[ge.DoneError=2]="DoneError"})(_||(_={}));class ke{static fromArray(J){return new ke(X=>{X.emitMany(J)})}static fromPromise(J){return new ke(async X=>{X.emitMany(await J)})}static fromPromises(J){return new ke(async X=>{await Promise.all(J.map(async he=>X.emitOne(await he)))})}static merge(J){return new ke(async X=>{await Promise.all(J.map(async he=>{for await(const fe of he)X.emitOne(fe)}))})}static{this.EMPTY=ke.fromArray([])}constructor(J){this.a=0,this.b=[],this.d=null,this.f=new P.$5d,queueMicrotask(async()=>{const X={emitOne:he=>this.g(he),emitMany:he=>this.h(he),reject:he=>this.k(he)};try{await Promise.resolve(J(X)),this.j()}catch(he){this.k(he)}finally{X.emitOne=void 0,X.emitMany=void 0,X.reject=void 0}})}[Symbol.asyncIterator](){let J=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(J<this.b.length)return{done:!1,value:this.b[J++]};if(this.a===1)return{done:!0,value:void 0};await P.Event.toPromise(this.f.event)}while(!0)}}}static map(J,X){return new ke(async he=>{for await(const fe of J)he.emitOne(X(fe))})}map(J){return ke.map(this,J)}static filter(J,X){return new ke(async he=>{for await(const fe of J)X(fe)&&he.emitOne(fe)})}filter(J){return ke.filter(this,J)}static coalesce(J){return ke.filter(J,X=>!!X)}coalesce(){return ke.coalesce(this)}static async toPromise(J){const X=[];for await(const he of J)X.push(he);return X}toPromise(){return ke.toPromise(this)}g(J){this.a===0&&(this.b.push(J),this.f.fire())}h(J){this.a===0&&(this.b=this.b.concat(J),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(J){this.a===0&&(this.a=2,this.d=J,this.f.fire())}}e.$Fh=ke;class Ne extends ke{constructor(J,X){super(X),this.l=J}cancel(){this.l.cancel()}}e.$Gh=Ne;function De(ge){const J=new S.$ce,X=ge(J.token);return new Ne(J,async he=>{const fe=J.token.onCancellationRequested(()=>{fe.dispose(),J.dispose(),he.reject(new M.$5)});try{for await(const Fe of X){if(J.token.isCancellationRequested)return;he.emitOne(Fe)}fe.dispose(),J.dispose()}catch(Fe){fe.dispose(),J.dispose(),he.reject(Fe)}})}e.$Hh=De;class be{constructor(){this.a=new $e,this.b=new ke(he=>{if(J){he.reject(J);return}return X&&he.emitMany(X),this.d=fe=>he.reject(fe),this.f=fe=>he.emitOne(fe),this.a.p});let J,X;this.f=he=>{X||(X=[]),X.push(he)},this.d=he=>{J||(J=he)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(J){this.d(J),this.a.complete()}emitOne(J){this.f(J)}}e.$Ih=be}),define(Pe[34],Re([1,0,18,11,45,28,19,21,15]),function(me,e,S,M,P,F,R,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=void 0;function k(){return Object.create(null)}e.$Tj=k,e.$Uj="**",e.$Vj="/";const O="[/\\\\]",D="[^/\\\\]",l=/\//g;function E(ae,ye){switch(ae){case 0:return"";case 1:return`${D}*?`;default:return`(?:${O}|${D}+${O}${ye?`|${O}${D}+`:""})*?`}}function g(ae,ye){if(!ae)return[];const Ie=[];let ue=!1,ve=!1,re="";for(const $e of ae){switch($e){case ye:if(!ue&&!ve){Ie.push(re),re="";continue}break;case"{":ue=!0;break;case"}":ue=!1;break;case"[":ve=!0;break;case"]":ve=!1;break}re+=$e}return re&&Ie.push(re),Ie}e.$Wj=g;function s(ae){if(!ae)return"";let ye="";const Ie=g(ae,e.$Vj);if(Ie.every(ue=>ue===e.$Uj))ye=".*";else{let ue=!1;Ie.forEach((ve,re)=>{if(ve===e.$Uj){if(ue)return;ye+=E(2,re===Ie.length-1)}else{let $e=!1,ie="",le=!1,W="";for(const _ of ve){if(_!=="}"&&$e){ie+=_;continue}if(le&&(_!=="]"||!W)){let ke;_==="-"?ke=_:(_==="^"||_==="!")&&!W?ke="^":_===e.$Vj?ke="":ke=(0,f.$Xe)(_),W+=ke;continue}switch(_){case"{":$e=!0;continue;case"[":le=!0;continue;case"}":{const Ne=`(?:${g(ie,",").map(De=>s(De)).join("|")})`;ye+=Ne,$e=!1,ie="";break}case"]":{ye+="["+W+"]",le=!1,W="";break}case"?":ye+=D;continue;case"*":ye+=E(1);continue;default:ye+=(0,f.$Xe)(_)}}re<Ie.length-1&&(Ie[re+1]!==e.$Uj||re+2<Ie.length)&&(ye+=O)}ue=ve===e.$Uj})}return ye}const a=/^\*\*\/\*\.[\w\.-]+$/,i=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,r=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,d=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new F.$Dc(1e4),p=function(){return!1},u=function(){return null};function o(ae,ye){if(!ae)return u;let Ie;typeof ae!="string"?Ie=ae.pattern:Ie=ae,Ie=Ie.trim();const ue=`${Ie}_${!!ye.trimForExclusions}`;let ve=t.get(ue);if(ve)return v(ve,ae);let re;return a.test(Ie)?ve=$(Ie.substr(4),Ie):(re=i.exec(b(Ie,ye)))?ve=I(re[1],Ie):(ye.trimForExclusions?r:n).test(Ie)?ve=h(Ie,ye):(re=c.exec(b(Ie,ye)))?ve=y(re[1].substr(1),Ie,!0):(re=d.exec(b(Ie,ye)))?ve=y(re[1],Ie,!1):ve=w(Ie),t.set(ue,ve),v(ve,ae)}function v(ae,ye){if(typeof ye=="string")return ae;const Ie=function(ue,ve){return(0,P.$fg)(ue,ye.base,!m.$k)?ae((0,f.$3e)(ue.substr(ye.base.length),R.sep),ve):null};return Ie.allBasenames=ae.allBasenames,Ie.allPaths=ae.allPaths,Ie.basenames=ae.basenames,Ie.patterns=ae.patterns,Ie}function b(ae,ye){return ye.trimForExclusions&&ae.endsWith("/**")?ae.substr(0,ae.length-2):ae}function $(ae,ye){return function(Ie,ue){return typeof Ie=="string"&&Ie.endsWith(ae)?ye:null}}function I(ae,ye){const Ie=`/${ae}`,ue=`\\${ae}`,ve=function($e,ie){return typeof $e!="string"?null:ie?ie===ae?ye:null:$e===ae||$e.endsWith(Ie)||$e.endsWith(ue)?ye:null},re=[ae];return ve.basenames=re,ve.patterns=[ye],ve.allBasenames=re,ve}function h(ae,ye){const Ie=q(ae.slice(1,-1).split(",").map(ie=>o(ie,ye)).filter(ie=>ie!==u),ae),ue=Ie.length;if(!ue)return u;if(ue===1)return Ie[0];const ve=function(ie,le){for(let W=0,_=Ie.length;W<_;W++)if(Ie[W](ie,le))return ae;return null},re=Ie.find(ie=>!!ie.allBasenames);re&&(ve.allBasenames=re.allBasenames);const $e=Ie.reduce((ie,le)=>le.allPaths?ie.concat(le.allPaths):ie,[]);return $e.length&&(ve.allPaths=$e),ve}function y(ae,ye,Ie){const ue=R.sep===R.$gc.sep,ve=ue?ae:ae.replace(l,R.sep),re=R.sep+ve,$e=R.$gc.sep+ae;let ie;return Ie?ie=function(le,W){return typeof le=="string"&&(le===ve||le.endsWith(re)||!ue&&(le===ae||le.endsWith($e)))?ye:null}:ie=function(le,W){return typeof le=="string"&&(le===ve||!ue&&le===ae)?ye:null},ie.allPaths=[(Ie?"*/":"./")+ae],ie}function w(ae){try{const ye=new RegExp(`^${s(ae)}$`);return function(Ie){return ye.lastIndex=0,typeof Ie=="string"&&ye.test(Ie)?ae:null}}catch{return u}}function A(ae,ye,Ie){return!ae||typeof ye!="string"?!1:N(ae)(ye,void 0,Ie)}e.$Xj=A;function N(ae,ye={}){if(!ae)return p;if(typeof ae=="string"||G(ae)){const Ie=o(ae,ye);if(Ie===u)return p;const ue=function(ve,re){return!!Ie(ve,re)};return Ie.allBasenames&&(ue.allBasenames=Ie.allBasenames),Ie.allPaths&&(ue.allPaths=Ie.allPaths),ue}return C(ae,ye)}e.$Yj=N;function G(ae){const ye=ae;return ye?typeof ye.base=="string"&&typeof ye.pattern=="string":!1}e.$Zj=G;function V(ae){return ae.allBasenames||[]}e.$1j=V;function U(ae){return ae.allPaths||[]}e.$2j=U;function C(ae,ye){const Ie=q(Object.getOwnPropertyNames(ae).map(ie=>L(ie,ae[ie],ye)).filter(ie=>ie!==u)),ue=Ie.length;if(!ue)return u;if(!Ie.some(ie=>!!ie.requiresSiblings)){if(ue===1)return Ie[0];const ie=function(_,ke){let Ne;for(let De=0,be=Ie.length;De<be;De++){const ge=Ie[De](_,ke);if(typeof ge=="string")return ge;(0,M.$4g)(ge)&&(Ne||(Ne=[]),Ne.push(ge))}return Ne?(async()=>{for(const De of Ne){const be=await De;if(typeof be=="string")return be}return null})():null},le=Ie.find(_=>!!_.allBasenames);le&&(ie.allBasenames=le.allBasenames);const W=Ie.reduce((_,ke)=>ke.allPaths?_.concat(ke.allPaths):_,[]);return W.length&&(ie.allPaths=W),ie}const ve=function(ie,le,W){let _,ke;for(let Ne=0,De=Ie.length;Ne<De;Ne++){const be=Ie[Ne];be.requiresSiblings&&W&&(le||(le=(0,R.$nc)(ie)),_||(_=le.substr(0,le.length-(0,R.$oc)(ie).length)));const ge=be(ie,le,_,W);if(typeof ge=="string")return ge;(0,M.$4g)(ge)&&(ke||(ke=[]),ke.push(ge))}return ke?(async()=>{for(const Ne of ke){const De=await Ne;if(typeof De=="string")return De}return null})():null},re=Ie.find(ie=>!!ie.allBasenames);re&&(ve.allBasenames=re.allBasenames);const $e=Ie.reduce((ie,le)=>le.allPaths?ie.concat(le.allPaths):ie,[]);return $e.length&&(ve.allPaths=$e),ve}function L(ae,ye,Ie){if(ye===!1)return u;const ue=o(ae,Ie);if(ue===u)return u;if(typeof ye=="boolean")return ue;if(ye){const ve=ye.when;if(typeof ve=="string"){const re=($e,ie,le,W)=>{if(!W||!ue($e,ie))return null;const _=ve.replace("$(basename)",()=>le),ke=W(_);return(0,M.$4g)(ke)?ke.then(Ne=>Ne?ae:null):ke?ae:null};return re.requiresSiblings=!0,re}}return ue}function q(ae,ye){const Ie=ae.filter(ie=>!!ie.basenames);if(Ie.length<2)return ae;const ue=Ie.reduce((ie,le)=>{const W=le.basenames;return W?ie.concat(W):ie},[]);let ve;if(ye){ve=[];for(let ie=0,le=ue.length;ie<le;ie++)ve.push(ye)}else ve=Ie.reduce((ie,le)=>{const W=le.patterns;return W?ie.concat(W):ie},[]);const re=function(ie,le){if(typeof ie!="string")return null;if(!le){let _;for(_=ie.length;_>0;_--){const ke=ie.charCodeAt(_-1);if(ke===47||ke===92)break}le=ie.substr(_)}const W=ue.indexOf(le);return W!==-1?ve[W]:null};re.basenames=ue,re.patterns=ve,re.allBasenames=ue;const $e=ae.filter(ie=>!ie.basenames);return $e.push(re),$e}function ne(ae,ye){return(0,S.$ub)(ae,ye,(Ie,ue)=>typeof Ie=="string"&&typeof ue=="string"?Ie===ue:typeof Ie!="string"&&typeof ue!="string"?Ie.base===ue.base&&Ie.pattern===ue.pattern:!1)}e.$3j=ne}),define(Pe[53],Re([1,0,14,129,24,15,2]),function(me,e,S,M,P,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ek=e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.MarkdownStringTextNewlineStyle=void 0;var m;(function(i){i[i.Paragraph=0]="Paragraph",i[i.Break=1]="Break"})(m||(e.MarkdownStringTextNewlineStyle=m={}));class f{constructor(n="",r=!1){if(this.value=n,typeof this.value!="string")throw(0,S.$7)("value");typeof r=="boolean"?(this.isTrusted=r,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=r.isTrusted??void 0,this.supportThemeIcons=r.supportThemeIcons??!1,this.supportHtml=r.supportHtml??!1)}appendText(n,r=0){return this.value+=l(this.supportThemeIcons?(0,M.$qk)(n):n).replace(/([ \t]+)/g,(c,d)=>"&nbsp;".repeat(d.length)).replace(/\>/gm,"\\>").replace(/\n/g,r===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,r){return this.value+=`
${E(r,n)}
`,this}appendLink(n,r,c){return this.value+="[",this.value+=this.c(r,"]"),this.value+="](",this.value+=this.c(String(n),")"),c&&(this.value+=` "${this.c(this.c(c,'"'),")")}"`),this.value+=")",this}c(n,r){const c=new RegExp((0,F.$Xe)(r),"g");return n.replace(c,(d,t)=>n.charAt(t-1)!=="\\"?`\\${d}`:d)}}e.$wk=f;function k(i){return O(i)?!i.value:Array.isArray(i)?i.every(k):!0}e.$xk=k;function O(i){return i instanceof f?!0:i&&typeof i=="object"?typeof i.value=="string"&&(typeof i.isTrusted=="boolean"||typeof i.isTrusted=="object"||i.isTrusted===void 0)&&(typeof i.supportThemeIcons=="boolean"||i.supportThemeIcons===void 0):!1}e.$yk=O;function D(i,n){return i===n?!0:!i||!n?!1:i.value===n.value&&i.isTrusted===n.isTrusted&&i.supportThemeIcons===n.supportThemeIcons&&i.supportHtml===n.supportHtml&&(i.baseUri===n.baseUri||!!i.baseUri&&!!n.baseUri&&(0,P.$Lg)(R.URI.from(i.baseUri),R.URI.from(n.baseUri)))}e.$zk=D;function l(i){return i.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$Ak=l;function E(i,n){const r=i.match(/^`+/gm)?.reduce((d,t)=>d.length>t.length?d:t).length??0,c=r>=3?r+1:3;return[`${"`".repeat(c)}${n}`,i,`${"`".repeat(c)}`].join(`
`)}e.$Bk=E;function g(i){return i.replace(/"/g,"&quot;")}e.$Ck=g;function s(i){return i&&i.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$Dk=s;function a(i){const n=[],r=i.split("|").map(d=>d.trim());i=r[0];const c=r[1];if(c){const d=/height=(\d+)/.exec(c),t=/width=(\d+)/.exec(c),p=d?d[1]:"",u=t?t[1]:"",o=isFinite(parseInt(u)),v=isFinite(parseInt(p));o&&n.push(`width="${u}"`),v&&n.push(`height="${p}"`)}return{href:i,dimensions:n}}e.$Ek=a}),define(Pe[96],Re([1,0,18,45,19,21,24,15]),function(me,e,S,M,P,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hw=e.$gw=e.$fw=e.$ew=e.$dw=e.$cw=e.$bw=e.$aw=e.$_v=e.$$v=void 0;function f(o,v){const{os:b,tildify:$,relative:I}=v;if(I){const w=k(o,I,b);if(typeof w=="string")return w}let h=o.fsPath;if(b===1&&!F.$i?h=h.replace(/\//g,"\\"):b!==1&&F.$i&&(h=h.replace(/\\/g,"/")),b!==1&&$?.userHome){const w=$.userHome.fsPath;let A;o.scheme!==$.userHome.scheme&&o.path[0]===P.$gc.sep&&o.path[1]!==P.$gc.sep?A=$.userHome.with({path:o.path}).fsPath:A=h,h=l(A,w,b)}return(b===1?P.$fc:P.$gc).normalize(O(h,b===1))}e.$$v=f;function k(o,v,b){const $=b===1?P.$fc:P.$gc,I=b===3?R.$Ig:R.$Kg,h=v.getWorkspace(),y=(0,S.$Ob)(h.folders);if(!y)return;o.scheme!==y.uri.scheme&&o.path[0]===P.$gc.sep&&o.path[1]!==P.$gc.sep&&(o=y.uri.with({path:o.path}));const w=v.getWorkspaceFolder(o);if(!w)return;let A;if(I.isEqual(w.uri,o)?A="":A=I.relativePath(w.uri,o)??"",A&&(A=$.normalize(A)),h.folders.length>1&&!v.noPrefix){const N=w.name?w.name:I.basenameOrAuthority(w.uri);A=A?`${N} \u2022 ${A}`:N}return A}function O(o,v=F.$i){return(0,M.$jg)(o,v)?o.charAt(0).toUpperCase()+o.slice(1):o}e.$_v=O;let D=Object.create(null);function l(o,v,b=F.OS){if(b===1||!o||!v)return o;let $=D.original===v?D.normalized:void 0;$||($=v,F.$i&&($=(0,M.$_f)($)),$=`${(0,m.$4e)($,P.$gc.sep)}${P.$gc.sep}`,D={original:v,normalized:$});let I=o;return F.$i&&(I=(0,M.$_f)(I)),(b===3?I.startsWith($):(0,m.$kf)(I,$))?`~/${I.substr($.length)}`:o}e.$aw=l;function E(o,v){return o.replace(/^~($|\/|\\)/,`${v}$1`)}e.$bw=E;const g="\u2026",s="\\\\",a="~";function i(o,v=P.sep){const b=new Array(o.length);let $=!1;for(let I=0;I<o.length;I++){const h=o[I];if(h===""){b[I]=`.${v}`;continue}if(!h){b[I]=h;continue}$=!0;let y="",w=h;w.indexOf(s)===0?(y=w.substr(0,w.indexOf(s)+s.length),w=w.substr(w.indexOf(s)+s.length)):w.indexOf(v)===0?(y=w.substr(0,w.indexOf(v)+v.length),w=w.substr(w.indexOf(v)+v.length)):w.indexOf(a)===0&&(y=w.substr(0,w.indexOf(a)+a.length),w=w.substr(w.indexOf(a)+a.length));const A=w.split(v);for(let N=1;$&&N<=A.length;N++)for(let G=A.length-N;$&&G>=0;G--){$=!1;let V=A.slice(G,G+N).join(v);for(let U=0;!$&&U<o.length;U++)if(U!==I&&o[U]&&o[U].indexOf(V)>-1){const C=G+N===A.length,L=G>0&&o[U].indexOf(v)>-1?v+V:V,q=o[U].endsWith(L);$=!C||q}if(!$){let U="";(A[0].endsWith(":")||y!=="")&&(G===1&&(G=0,N++,V=A[0]+v+V),G>0&&(U=A[0]+v),U=y+U),G>0&&(U=U+g+v),U=U+V,G+N<A.length&&(U=U+v+g),b[I]=U}}$&&(b[I]=h)}return b}e.$cw=i;var n;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function r(o,v=Object.create(null)){const b=[];let $=!1,I="";for(const h of o)if(h==="$"||$&&h==="{")I&&b.push({value:I,type:n.TEXT}),I="",$=!0;else if(h==="}"&&$){const y=v[I];if(typeof y=="string")y.length&&b.push({value:y,type:n.VARIABLE});else if(y){const w=b[b.length-1];(!w||w.type!==n.SEPARATOR)&&b.push({value:y.label,type:n.SEPARATOR})}I="",$=!1}else I+=h;return I&&!$&&b.push({value:I,type:n.TEXT}),b.filter((h,y)=>{if(h.type===n.SEPARATOR){const w=b[y-1],A=b[y+1];return[w,A].every(N=>N&&(N.type===n.VARIABLE||N.type===n.TEXT)&&N.value.length>0)}return!0}).map(h=>h.value).join("")}e.$dw=r;function c(o,v){return F.$j||v?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,F.$j?"&":"&&"):o.replace(/&&|&/g,b=>b==="&"?"&&":"&")}e.$ew=c;function d(o,v){return F.$j||v?o.replace(/\(&&\w\)|&&/g,""):F.$i?o.replace(/&&|&/g,b=>b==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.$fw=d;function t(o){return o.replace(/&/g,"&&")}e.$gw=t;function p(o){if(o.endsWith("]")){const v=o.lastIndexOf(" [",o.length-2);if(v!==-1){const b=u(o.substring(0,v)),$=o.substring(v);return{name:b.name+$,parentPath:b.parentPath}}}return u(o)}e.$hw=p;function u(o){const v=o.indexOf("/")!==-1?P.$gc:P.$fc,b=v.basename(o),$=v.dirname(o);return b.length?{name:b,parentPath:$}:{name:$,parentPath:""}}}),define(Pe[142],Re([1,0,23,2]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kn=e.$jn=e.$in=e.$hn=e.$gn=void 0;function P(D){return D.toJSON()}class F{constructor(l){this.a=l}transformIncoming(l){const E=this.a.transformIncoming(l);return E===l?l:P(M.URI.from(E))}transformOutgoing(l){const E=this.a.transformOutgoing(l);return E===l?l:P(M.URI.from(E))}transformOutgoingURI(l){const E=this.a.transformOutgoing(l);return E===l?l:M.URI.from(E)}transformOutgoingScheme(l){return this.a.transformOutgoingScheme(l)}}e.$gn=F,e.$hn=new class{transformIncoming(D){return D}transformOutgoing(D){return D}transformOutgoingURI(D){return D}transformOutgoingScheme(D){return D}};function R(D,l,E){if(!D||E>200)return null;if(typeof D=="object"){if(D instanceof M.URI)return l.transformOutgoing(D);for(const g in D)if(Object.hasOwnProperty.call(D,g)){const s=R(D[g],l,E+1);s!==null&&(D[g]=s)}}return null}function m(D,l){const E=R(D,l,0);return E===null?D:E}e.$in=m;function f(D,l,E,g){if(!D||g>200)return null;if(typeof D=="object"){if(D.$mid===1)return E?M.URI.revive(l.transformIncoming(D)):l.transformIncoming(D);if(D instanceof S.$se)return null;for(const s in D)if(Object.hasOwnProperty.call(D,s)){const a=f(D[s],l,E,g+1);a!==null&&(D[s]=a)}}return null}function k(D,l){const E=f(D,l,!1,0);return E===null?D:E}e.$jn=k;function O(D,l){const E=f(D,l,!0,0);return E===null?D:E}e.$kn=O}),define(Pe[143],Re([1,0,15,21,23]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qt=e.$pt=e.$ot=void 0;let F;function R(){return F||(F=new TextDecoder("UTF-16LE")),F}let m;function f(){return m||(m=new TextDecoder("UTF-16BE")),m}let k;function O(){return k||(k=M.$D()?R():f()),k}e.$ot=O;function D(g,s,a){const i=new Uint16Array(g.buffer,s,a);return a>0&&(i[0]===65279||i[0]===65534)?l(g,s,a):R().decode(i)}e.$pt=D;function l(g,s,a){const i=[];let n=0;for(let r=0;r<a;r++){const c=P.$ue(g,s);s+=2,i[n++]=String.fromCharCode(c)}return i.join("")}class E{constructor(s){this.a=s|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const s=new Uint16Array(this.b.buffer,0,this.d);return O().decode(s)}f(){const s=this.e();this.d=0,this.c===null?this.c=[s]:this.c[this.c.length]=s}appendCharCode(s){const a=this.a-this.d;a<=1&&(a===0||S.$nf(s))&&this.f(),this.b[this.d++]=s}appendASCIICharCode(s){this.d===this.a&&this.f(),this.b[this.d++]=s}appendString(s){const a=s.length;if(this.d+a>=this.a){this.f(),this.c[this.c.length]=s;return}for(let i=0;i<a;i++)this.b[this.d++]=s.charCodeAt(i)}}e.$qt=E}),define(Pe[144],Re([1,0,23,143]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$st=e.$rt=void 0;function P(f){return f.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class F{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(k,O,D,l){this.oldPosition=k,this.oldText=O,this.newPosition=D,this.newText=l}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${P(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${P(this.oldText)}")`:`(replace@${this.oldPosition} "${P(this.oldText)}" with "${P(this.newText)}")`}static a(k){return 4+2*k.length}static c(k,O,D){const l=O.length;S.$xe(k,l,D),D+=4;for(let E=0;E<l;E++)S.$ve(k,O.charCodeAt(E),D),D+=2;return D}static d(k,O){const D=S.$we(k,O);return O+=4,(0,M.$pt)(k,O,D)}writeSize(){return 8+F.a(this.oldText)+F.a(this.newText)}write(k,O){return S.$xe(k,this.oldPosition,O),O+=4,S.$xe(k,this.newPosition,O),O+=4,O=F.c(k,this.oldText,O),O=F.c(k,this.newText,O),O}static read(k,O,D){const l=S.$we(k,O);O+=4;const E=S.$we(k,O);O+=4;const g=F.d(k,O);O+=F.a(g);const s=F.d(k,O);return O+=F.a(s),D.push(new F(l,g,E,s)),O}}e.$rt=F;function R(f,k){return f===null||f.length===0?k:new m(f,k).compress()}e.$st=R;class m{constructor(k,O){this.a=k,this.c=O,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let k=0,O=0,D=this.n(k),l=this.l(O);for(;k<this.f||O<this.h;){if(D===null){this.k(l),l=this.l(++O);continue}if(l===null){this.m(D),D=this.n(++k);continue}if(l.oldEnd<=D.newPosition){this.k(l),l=this.l(++O);continue}if(D.newEnd<=l.oldPosition){this.m(D),D=this.n(++k);continue}if(l.oldPosition<D.newPosition){const[i,n]=m.r(l,D.newPosition-l.oldPosition);this.k(i),l=n;continue}if(D.newPosition<l.oldPosition){const[i,n]=m.q(D,l.oldPosition-D.newPosition);this.m(i),D=n;continue}let s,a;if(l.oldEnd===D.newEnd)s=D,a=l,D=this.n(++k),l=this.l(++O);else if(l.oldEnd<D.newEnd){const[i,n]=m.q(D,l.oldLength);s=i,a=l,D=n,l=this.l(++O)}else{const[i,n]=m.r(l,D.newLength);s=D,a=i,D=this.n(++k),l=n}this.d[this.e++]=new F(s.oldPosition,s.oldText,a.newPosition,a.newText),this.g+=s.newLength-s.oldLength,this.j+=a.newLength-a.oldLength}const E=m.s(this.d);return m.t(E)}k(k){this.d[this.e++]=m.o(this.g,k),this.j+=k.newLength-k.oldLength}l(k){return k<this.h?this.c[k]:null}m(k){this.d[this.e++]=m.p(this.j,k),this.g+=k.newLength-k.oldLength}n(k){return k<this.f?this.a[k]:null}static o(k,O){return new F(O.oldPosition-k,O.oldText,O.newPosition,O.newText)}static p(k,O){return new F(O.oldPosition,O.oldText,O.newPosition+k,O.newText)}static q(k,O){const D=k.newText.substr(0,O),l=k.newText.substr(O);return[new F(k.oldPosition,k.oldText,k.newPosition,D),new F(k.oldEnd,"",k.newPosition+O,l)]}static r(k,O){const D=k.oldText.substr(0,O),l=k.oldText.substr(O);return[new F(k.oldPosition,D,k.newPosition,k.newText),new F(k.oldPosition+O,l,k.newEnd,"")]}static s(k){if(k.length===0)return k;const O=[];let D=0,l=k[0];for(let E=1;E<k.length;E++){const g=k[E];l.oldEnd===g.oldPosition?l=new F(l.oldPosition,l.oldText+g.oldText,l.newPosition,l.newText+g.newText):(O[D++]=l,l=g)}return O[D++]=l,O}static t(k){if(k.length===0)return k;const O=[];let D=0;for(let l=0;l<k.length;l++){const E=k[l];E.oldText!==E.newText&&(O[D++]=E)}return O}}}),define(Pe[145],Re([1,0,34,19]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qt=e.$Pt=void 0;function P(R,m,f,k,O,D){if(Array.isArray(R)){let l=0;for(const E of R){const g=P(E,m,f,k,O,D);if(g===10)return g;g>l&&(l=g)}return l}else{if(typeof R=="string")return k?R==="*"?5:R===f?10:0:0;if(R){const{language:l,pattern:E,scheme:g,hasAccessToAllModels:s,notebookType:a}=R;if(!k&&!s)return 0;a&&O&&(m=O);let i=0;if(g)if(g===m.scheme)i=10;else if(g==="*")i=5;else return 0;if(l)if(l===f)i=10;else if(l==="*")i=Math.max(i,5);else return 0;if(a)if(a===D)i=10;else if(a==="*"&&D!==void 0)i=Math.max(i,5);else return 0;if(E){let n;if(typeof E=="string"?n=E:n={...E,base:(0,M.$hc)(E.base)},n===m.fsPath||(0,S.$Xj)(n,m.fsPath))i=10;else return 0}return i}else return 0}}e.$Pt=P;function F(R){return typeof R=="string"?!1:Array.isArray(R)?R.some(F):!!R.notebookType}e.$Qt=F}),define(Pe[146],Re([1,0,5,15,29,94,92,131,144,6]),function(me,e,S,M,P,F,R,m,f,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qC=void 0;class O extends k.$Tc{constructor(l,E,g,s,a,i,n){super(),this.m=this.B(new S.$5d),this.onDidChangeContent=this.m.event,this.f=E,this.j=!i,this.g=s,this.h=a,this.c=new R.$pC(l,g,n)}equals(l){return!(l instanceof O)||this.f!==l.f||this.getEOL()!==l.getEOL()?!1:this.c.equal(l.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(l){return this.c.createSnapshot(l?this.f:"")}getOffsetAt(l,E){return this.c.getOffsetAt(l,E)}getPositionAt(l){return this.c.getPositionAt(l)}getRangeAt(l,E){const g=l+E,s=this.getPositionAt(l),a=this.getPositionAt(g);return new P.$9s(s.lineNumber,s.column,a.lineNumber,a.column)}getValueInRange(l,E=0){if(l.isEmpty())return"";const g=this.n(E);return this.c.getValueInRange(l,g)}getValueLengthInRange(l,E=0){if(l.isEmpty())return 0;if(l.startLineNumber===l.endLineNumber)return l.endColumn-l.startColumn;const g=this.getOffsetAt(l.startLineNumber,l.startColumn),s=this.getOffsetAt(l.endLineNumber,l.endColumn);let a=0;const i=this.n(E),n=this.getEOL();if(i.length!==n.length){const r=i.length-n.length,c=l.endLineNumber-l.startLineNumber;a=r*c}return s-g+a}getCharacterCountInRange(l,E=0){if(this.j){let g=0;const s=l.startLineNumber,a=l.endLineNumber;for(let i=s;i<=a;i++){const n=this.getLineContent(i),r=i===s?l.startColumn-1:0,c=i===a?l.endColumn-1:n.length;for(let d=r;d<c;d++)M.$nf(n.charCodeAt(d))?(g=g+1,d=d+1):g=g+1}return g+=this.n(E).length*(a-s),g}return this.getValueLengthInRange(l,E)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(l){return this.c.getLineContent(l)}getLineCharCode(l,E){return this.c.getLineCharCode(l,E)}getCharCode(l){return this.c.getCharCode(l)}getLineLength(l){return this.c.getLineLength(l)}getLineMinColumn(l){return 1}getLineMaxColumn(l){return this.getLineLength(l)+1}getLineFirstNonWhitespaceColumn(l){const E=M.$$e(this.getLineContent(l));return E===-1?0:E+1}getLineLastNonWhitespaceColumn(l){const E=M.$af(this.getLineContent(l));return E===-1?0:E+2}n(l){switch(l){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(l){this.c.setEOL(l)}applyEdits(l,E,g){let s=this.g,a=this.h,i=this.j,n=!0,r=[];for(let v=0;v<l.length;v++){const b=l[v];n&&b._isTracked&&(n=!1);const $=b.range;if(b.text){let A=!0;i||(A=!M.$yf(b.text),i=A),!s&&A&&(s=M.$xf(b.text)),!a&&A&&(a=M.$Af(b.text))}let I="",h=0,y=0,w=0;if(b.text){let A;[h,y,w,A]=(0,m.$It)(b.text);const N=this.getEOL();A===0||A===(N===`\r
`?2:1)?I=b.text:I=b.text.replace(/\r\n|\r|\n/g,N)}r[v]={sortIndex:v,identifier:b.identifier||null,range:$,rangeOffset:this.getOffsetAt($.startLineNumber,$.startColumn),rangeLength:this.getValueLengthInRange($),text:I,eolCount:h,firstLineLength:y,lastLineLength:w,forceMoveMarkers:!!b.forceMoveMarkers,isAutoWhitespaceEdit:b.isAutoWhitespaceEdit||!1}}r.sort(O.u);let c=!1;for(let v=0,b=r.length-1;v<b;v++){const $=r[v].range.getEndPosition(),I=r[v+1].range.getStartPosition();if(I.isBeforeOrEqual($)){if(I.isBefore($))throw new Error("Overlapping ranges are not allowed!");c=!0}}n&&(r=this.s(r));const d=g||E?O._getInverseEditRanges(r):[],t=[];if(E)for(let v=0;v<r.length;v++){const b=r[v],$=d[v];if(b.isAutoWhitespaceEdit&&b.range.isEmpty())for(let I=$.startLineNumber;I<=$.endLineNumber;I++){let h="";I===$.startLineNumber&&(h=this.getLineContent(b.range.startLineNumber),M.$$e(h)!==-1)||t.push({lineNumber:I,oldContent:h})}}let p=null;if(g){let v=0;p=[];for(let b=0;b<r.length;b++){const $=r[b],I=d[b],h=this.getValueInRange($.range),y=$.rangeOffset+v;v+=$.text.length-h.length,p[b]={sortIndex:$.sortIndex,identifier:$.identifier,range:I,text:h,textChange:new f.$rt($.rangeOffset,h,y,$.text)}}c||p.sort((b,$)=>b.sortIndex-$.sortIndex)}this.g=s,this.h=a,this.j=i;const u=this.t(r);let o=null;if(E&&t.length>0){t.sort((v,b)=>b.lineNumber-v.lineNumber),o=[];for(let v=0,b=t.length;v<b;v++){const $=t[v].lineNumber;if(v>0&&t[v-1].lineNumber===$)continue;const I=t[v].oldContent,h=this.getLineContent($);h.length===0||h===I||M.$$e(h)!==-1||o.push($)}}return this.m.fire(),new F.$tv(p,u,o)}s(l){return l.length<1e3?l:[this._toSingleEditOperation(l)]}_toSingleEditOperation(l){let E=!1;const g=l[0].range,s=l[l.length-1].range,a=new P.$9s(g.startLineNumber,g.startColumn,s.endLineNumber,s.endColumn);let i=g.startLineNumber,n=g.startColumn;const r=[];for(let u=0,o=l.length;u<o;u++){const v=l[u],b=v.range;E=E||v.forceMoveMarkers,r.push(this.getValueInRange(new P.$9s(i,n,b.startLineNumber,b.startColumn))),v.text.length>0&&r.push(v.text),i=b.endLineNumber,n=b.endColumn}const c=r.join(""),[d,t,p]=(0,m.$It)(c);return{sortIndex:0,identifier:l[0].identifier,range:a,rangeOffset:this.getOffsetAt(a.startLineNumber,a.startColumn),rangeLength:this.getValueLengthInRange(a,0),text:c,eolCount:d,firstLineLength:t,lastLineLength:p,forceMoveMarkers:E,isAutoWhitespaceEdit:!1}}t(l){l.sort(O.w);const E=[];for(let g=0;g<l.length;g++){const s=l[g],a=s.range.startLineNumber,i=s.range.startColumn,n=s.range.endLineNumber,r=s.range.endColumn;if(a===n&&i===r&&s.text.length===0)continue;s.text?(this.c.delete(s.rangeOffset,s.rangeLength),this.c.insert(s.rangeOffset,s.text,!0)):this.c.delete(s.rangeOffset,s.rangeLength);const c=new P.$9s(a,i,n,r);E.push({range:c,rangeLength:s.rangeLength,text:s.text,rangeOffset:s.rangeOffset,forceMoveMarkers:s.forceMoveMarkers})}return E}findMatchesLineByLine(l,E,g,s){return this.c.findMatchesLineByLine(l,E,g,s)}getPieceTree(){return this.c}static _getInverseEditRange(l,E){const g=l.startLineNumber,s=l.startColumn,[a,i,n]=(0,m.$It)(E);let r;if(E.length>0){const c=a+1;c===1?r=new P.$9s(g,s,g,s+i):r=new P.$9s(g,s,g+c-1,n+1)}else r=new P.$9s(g,s,g,s);return r}static _getInverseEditRanges(l){const E=[];let g=0,s=0,a=null;for(let i=0,n=l.length;i<n;i++){const r=l[i];let c,d;a?a.range.endLineNumber===r.range.startLineNumber?(c=g,d=s+(r.range.startColumn-a.range.endColumn)):(c=g+(r.range.startLineNumber-a.range.endLineNumber),d=r.range.startColumn):(c=r.range.startLineNumber,d=r.range.startColumn);let t;if(r.text.length>0){const p=r.eolCount+1;p===1?t=new P.$9s(c,d,c,d+r.firstLineLength):t=new P.$9s(c,d,c+p-1,r.lastLineLength+1)}else t=new P.$9s(c,d,c,d);g=t.endLineNumber,s=t.endColumn,E.push(t),a=r}return E}static u(l,E){const g=P.$9s.compareRangesUsingEnds(l.range,E.range);return g===0?l.sortIndex-E.sortIndex:g}static w(l,E){const g=P.$9s.compareRangesUsingEnds(l.range,E.range);return g===0?E.sortIndex-l.sortIndex:-g}}e.$qC=O}),define(Pe[147],Re([1,0,15,92,146]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rC=void 0;class F{constructor(f,k,O,D,l,E,g,s,a){this.a=f,this.b=k,this.c=O,this.d=D,this.e=l,this.f=E,this.g=g,this.h=s,this.j=a}k(f){const k=this.c+this.d+this.e,O=this.c+this.e;return k===0?f===1?`
`:`\r
`:O>k/2?`\r
`:`
`}create(f){const k=this.k(f),O=this.a;if(this.j&&(k===`\r
`&&(this.c>0||this.d>0)||k===`
`&&(this.c>0||this.e>0)))for(let l=0,E=O.length;l<E;l++){const g=O[l].buffer.replace(/\r\n|\r|\n/g,k),s=(0,M.$lC)(g);O[l]=new M.$oC(g,s)}const D=new P.$qC(O,this.b,k,this.f,this.g,this.h,this.j);return{textBuffer:D,disposable:D}}getFirstLineText(f){return this.a[0].buffer.substr(0,f).split(/\r\n|\r|\n/)[0]}}class R{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(f){if(f.length===0)return;this.a.length===0&&S.$Gf(f)&&(this.b=S.$Ff,f=f.substr(1));const k=f.charCodeAt(f.length-1);k===13||k>=55296&&k<=56319?(this.m(f.substr(0,f.length-1),!1),this.c=!0,this.d=k):(this.m(f,!1),this.c=!1,this.d=k)}m(f,k){!k&&f.length===0||(this.c?this.n(String.fromCharCode(this.d)+f):this.n(f))}n(f){const k=(0,M.$mC)(this.e,f);this.a.push(new M.$oC(f,k.lineStarts)),this.f+=k.cr,this.g+=k.lf,this.h+=k.crlf,k.isBasicASCII||(this.l=!1,this.j||(this.j=S.$xf(f)),this.k||(this.k=S.$Af(f)))}finish(f=!0){return this.o(),new F(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,f)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const f=this.a[this.a.length-1];f.buffer+=String.fromCharCode(this.d);const k=(0,M.$lC)(f.buffer);f.lineStarts=k,this.d===13&&this.f++}}}e.$rC=R}),define(Pe[97],Re([1,0,23,21]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eab=e.$dab=void 0;var P;(function(D){D[D.Full=1]="Full",D[D.Delta=2]="Delta"})(P||(P={}));function F(D){for(let l=0,E=D.length;l<E;l+=4){const g=D[l+0],s=D[l+1],a=D[l+2],i=D[l+3];D[l+0]=i,D[l+1]=a,D[l+2]=s,D[l+3]=g}}function R(D){const l=new Uint8Array(D.buffer,D.byteOffset,D.length*4);return M.$D()||F(l),S.$se.wrap(l)}function m(D){const l=D.buffer;if(M.$D()||F(l),l.byteOffset%4===0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const E=new Uint8Array(l.byteLength);return E.set(l),new Uint32Array(E.buffer,E.byteOffset,E.length/4)}}function f(D){const l=new Uint32Array(k(D));let E=0;if(l[E++]=D.id,D.type==="full")l[E++]=1,l[E++]=D.data.length,l.set(D.data,E),E+=D.data.length;else{l[E++]=2,l[E++]=D.deltas.length;for(const g of D.deltas)l[E++]=g.start,l[E++]=g.deleteCount,g.data?(l[E++]=g.data.length,l.set(g.data,E),E+=g.data.length):l[E++]=0}return R(l)}e.$dab=f;function k(D){let l=0;if(l+=2,D.type==="full")l+=1+D.data.length;else{l+=1,l+=3*D.deltas.length;for(const E of D.deltas)E.data&&(l+=E.data.length)}return l}function O(D){const l=m(D);let E=0;const g=l[E++];if(l[E++]===1){const n=l[E++],r=l.subarray(E,E+n);return E+=n,{id:g,type:"full",data:r}}const a=l[E++],i=[];for(let n=0;n<a;n++){const r=l[E++],c=l[E++],d=l[E++];let t;d>0&&(t=l.subarray(E,E+d),E+=d),i[n]={start:r,deleteCount:c,data:t}}return{id:g,type:"delta",deltas:i}}e.$eab=O}),define(Pe[148],Re([9,10]),function(me,e){return me.create("vs/editor/common/config/editorOptions",e)}),define(Pe[149],Re([1,0,18,26,21,132,150,148]),function(me,e,S,M,P,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var f;(function(Z){Z[Z.None=0]="None",Z[Z.Keep=1]="Keep",Z[Z.Brackets=2]="Brackets",Z[Z.Advanced=3]="Advanced",Z[Z.Full=4]="Full"})(f||(e.EditorAutoIndentStrategy=f={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(Q){this.c=Q}hasChanged(Q){return this.c[Q]}}e.ConfigurationChangedEvent=k;class O{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=O;class D{constructor(Q,pe,Ve,Ze){this.id=Q,this.name=pe,this.defaultValue=Ve,this.schema=Ze}applyUpdate(Q,pe){return E(Q,pe)}compute(Q,pe,Ve){return Ve}}class l{constructor(Q,pe){this.newValue=Q,this.didChange=pe}}e.ApplyUpdateResult=l;function E(Z,Q){if(typeof Z!="object"||typeof Q!="object"||!Z||!Q)return new l(Q,Z!==Q);if(Array.isArray(Z)||Array.isArray(Q)){const Ve=Array.isArray(Z)&&Array.isArray(Q)&&S.$ub(Z,Q);return new l(Q,!Ve)}let pe=!1;for(const Ve in Q)if(Q.hasOwnProperty(Ve)){const Ze=E(Z[Ve],Q[Ve]);Ze.didChange&&(Z[Ve]=Ze.newValue,pe=!0)}return new l(Z,pe)}class g{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,pe){return E(Q,pe)}validate(Q){return this.defaultValue}}class s{constructor(Q,pe,Ve,Ze){this.id=Q,this.name=pe,this.defaultValue=Ve,this.schema=Ze}applyUpdate(Q,pe){return E(Q,pe)}validate(Q){return typeof Q>"u"?this.defaultValue:Q}compute(Q,pe,Ve){return Ve}}function a(Z,Q){return typeof Z>"u"?Q:Z==="false"?!1:!!Z}e.boolean=a;class i extends s{constructor(Q,pe,Ve,Ze=void 0){typeof Ze<"u"&&(Ze.type="boolean",Ze.default=Ve),super(Q,pe,Ve,Ze)}validate(Q){return a(Q,this.defaultValue)}}function n(Z,Q,pe,Ve){if(typeof Z>"u")return Q;let Ze=parseInt(Z,10);return isNaN(Ze)?Q:(Ze=Math.max(pe,Ze),Ze=Math.min(Ve,Ze),Ze|0)}e.clampedInt=n;class r extends s{static clampedInt(Q,pe,Ve,Ze){return n(Q,pe,Ve,Ze)}constructor(Q,pe,Ve,Ze,st,Me=void 0){typeof Me<"u"&&(Me.type="integer",Me.default=Ve,Me.minimum=Ze,Me.maximum=st),super(Q,pe,Ve,Me),this.minimum=Ze,this.maximum=st}validate(Q){return r.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}function c(Z,Q,pe,Ve){if(typeof Z>"u")return Q;const Ze=d.float(Z,Q);return d.clamp(Ze,pe,Ve)}e.clampedFloat=c;class d extends s{static clamp(Q,pe,Ve){return Q<pe?pe:Q>Ve?Ve:Q}static float(Q,pe){if(typeof Q=="number")return Q;if(typeof Q>"u")return pe;const Ve=parseFloat(Q);return isNaN(Ve)?pe:Ve}constructor(Q,pe,Ve,Ze,st){typeof st<"u"&&(st.type="number",st.default=Ve),super(Q,pe,Ve,st),this.validationFn=Ze}validate(Q){return this.validationFn(d.float(Q,this.defaultValue))}}class t extends s{static string(Q,pe){return typeof Q!="string"?pe:Q}constructor(Q,pe,Ve,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.default=Ve),super(Q,pe,Ve,Ze)}validate(Q){return t.string(Q,this.defaultValue)}}function p(Z,Q,pe,Ve){return typeof Z!="string"?Q:Ve&&Z in Ve?Ve[Z]:pe.indexOf(Z)===-1?Q:Z}e.stringSet=p;class u extends s{constructor(Q,pe,Ve,Ze,st=void 0){typeof st<"u"&&(st.type="string",st.enum=Ze,st.default=Ve),super(Q,pe,Ve,st),this.c=Ze}validate(Q){return p(Q,this.defaultValue,this.c)}}class o extends D{constructor(Q,pe,Ve,Ze,st,Me,Dt=void 0){typeof Dt<"u"&&(Dt.type="string",Dt.enum=st,Dt.default=Ze),super(Q,pe,Ve,Dt),this.c=st,this.d=Me}validate(Q){return typeof Q!="string"?this.defaultValue:this.c.indexOf(Q)===-1?this.defaultValue:this.d(Q)}}function v(Z){switch(Z){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class b extends D{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[m.localize(0,null),m.localize(1,null),m.localize(2,null)],default:"auto",tags:["accessibility"],description:m.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,pe,Ve){return Ve===0?Q.accessibilitySupport:Ve}}class $ extends D{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:m.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:m.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{insertSpace:a(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:a(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var I;(function(Z){Z[Z.Hidden=0]="Hidden",Z[Z.Blink=1]="Blink",Z[Z.Smooth=2]="Smooth",Z[Z.Phase=3]="Phase",Z[Z.Expand=4]="Expand",Z[Z.Solid=5]="Solid"})(I||(e.TextEditorCursorBlinkingStyle=I={}));function h(Z){switch(Z){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var y;(function(Z){Z[Z.Line=1]="Line",Z[Z.Block=2]="Block",Z[Z.Underline=3]="Underline",Z[Z.LineThin=4]="LineThin",Z[Z.BlockOutline=5]="BlockOutline",Z[Z.UnderlineThin=6]="UnderlineThin"})(y||(e.TextEditorCursorStyle=y={}));function w(Z){switch(Z){case y.Line:return"line";case y.Block:return"block";case y.Underline:return"underline";case y.LineThin:return"line-thin";case y.BlockOutline:return"block-outline";case y.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=w;function A(Z){switch(Z){case"line":return y.Line;case"block":return y.Block;case"underline":return y.Underline;case"line-thin":return y.LineThin;case"block-outline":return y.BlockOutline;case"underline-thin":return y.UnderlineThin}}class N extends g{constructor(){super(141)}compute(Q,pe,Ve){const Ze=["monaco-editor"];return pe.get(39)&&Ze.push(pe.get(39)),Q.extraEditorClassName&&Ze.push(Q.extraEditorClassName),pe.get(74)==="default"?Ze.push("mouse-default"):pe.get(74)==="copy"&&Ze.push("mouse-copy"),pe.get(111)&&Ze.push("showUnused"),pe.get(139)&&Ze.push("showDeprecated"),Ze.join(" ")}}class G extends i{constructor(){super(37,"emptySelectionClipboard",!0,{description:m.localize(6,null)})}compute(Q,pe,Ve){return Ve&&Q.emptySelectionClipboard}}class V extends D{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:m.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[m.localize(8,null),m.localize(9,null),m.localize(10,null)],description:m.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[m.localize(12,null),m.localize(13,null),m.localize(14,null)],description:m.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:m.localize(16,null),included:P.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:m.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:m.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{cursorMoveOnType:a(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":p(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":p(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:a(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:a(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:a(pe.loop,this.defaultValue.loop)}}}class U extends D{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",U.OFF,{anyOf:[{type:"boolean",description:m.localize(19,null)},{type:"string",description:m.localize(20,null)}],description:m.localize(21,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"||Q.length===0?U.OFF:Q==="true"?U.ON:Q:Q?U.ON:U.OFF}}e.EditorFontLigatures=U;class C extends D{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",C.OFF,{anyOf:[{type:"boolean",description:m.localize(22,null)},{type:"string",description:m.localize(23,null)}],description:m.localize(24,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?C.OFF:Q==="true"?C.TRANSLATE:Q:Q?C.TRANSLATE:C.OFF}compute(Q,pe,Ve){return Q.fontInfo.fontVariationSettings}}e.EditorFontVariations=C;class L extends g{constructor(){super(50)}compute(Q,pe,Ve){return Q.fontInfo}}class q extends s{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:m.localize(25,null)})}validate(Q){const pe=d.float(Q,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:d.clamp(pe,6,100)}compute(Q,pe,Ve){return Q.fontInfo.fontSize}}class ne extends D{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:ne.d,maximum:ne.e,errorMessage:m.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:ne.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:m.localize(27,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(r.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,ne.d,ne.e))}}class ae extends D{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[m.localize(28,null),m.localize(29,null),m.localize(30,null)]},Ve=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:m.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:m.localize(32,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:m.localize(33,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:m.localize(34,null),...pe},"editor.gotoLocation.multipleImplementations":{description:m.localize(35,null),...pe},"editor.gotoLocation.multipleReferences":{description:m.localize(36,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Ve,description:m.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Ve,description:m.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Ve,description:m.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Ve,description:m.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Ve,description:m.localize(41,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{multiple:p(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??p(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??p(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??p(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??p(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??p(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ye extends D{constructor(){const Q={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:m.localize(42,null)},"editor.hover.delay":{type:"number",default:Q.delay,minimum:0,maximum:1e4,description:m.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:m.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Q.hidingDelay,description:m.localize(45,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:m.localize(46,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{enabled:a(pe.enabled,this.defaultValue.enabled),delay:r.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:a(pe.sticky,this.defaultValue.sticky),hidingDelay:r.clampedInt(pe.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:a(pe.above,this.defaultValue.above)}}}var Ie;(function(Z){Z[Z.None=0]="None",Z[Z.Text=1]="Text",Z[Z.Blocks=2]="Blocks"})(Ie||(e.RenderMinimap=Ie={}));class ue extends g{constructor(){super(144)}compute(Q,pe,Ve){return ue.computeLayout(pe,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio,glyphMarginDecorationLaneCount:Q.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Q){const pe=Q.height/Q.lineHeight,Ve=Math.floor(Q.paddingTop/Q.lineHeight);let Ze=Math.floor(Q.paddingBottom/Q.lineHeight);Q.scrollBeyondLastLine&&(Ze=Math.max(Ze,pe-1));const st=(Ve+Q.viewLineCount+Ze)/(Q.pixelRatio*Q.height),Me=Math.floor(Q.viewLineCount/st);return{typicalViewportLineCount:pe,extraLinesBeforeFirstLine:Ve,extraLinesBeyondLastLine:Ze,desiredRatio:st,minimapLineCount:Me}}static c(Q,pe){const Ve=Q.outerWidth,Ze=Q.outerHeight,st=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(st*Ze),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ze};const Me=pe.stableMinimapLayoutInput,Dt=Me&&Q.outerHeight===Me.outerHeight&&Q.lineHeight===Me.lineHeight&&Q.typicalHalfwidthCharacterWidth===Me.typicalHalfwidthCharacterWidth&&Q.pixelRatio===Me.pixelRatio&&Q.scrollBeyondLastLine===Me.scrollBeyondLastLine&&Q.paddingTop===Me.paddingTop&&Q.paddingBottom===Me.paddingBottom&&Q.minimap.enabled===Me.minimap.enabled&&Q.minimap.side===Me.minimap.side&&Q.minimap.size===Me.minimap.size&&Q.minimap.showSlider===Me.minimap.showSlider&&Q.minimap.renderCharacters===Me.minimap.renderCharacters&&Q.minimap.maxColumn===Me.minimap.maxColumn&&Q.minimap.scale===Me.minimap.scale&&Q.verticalScrollbarWidth===Me.verticalScrollbarWidth&&Q.isViewportWrapping===Me.isViewportWrapping,Kt=Q.lineHeight,Tt=Q.typicalHalfwidthCharacterWidth,Qt=Q.scrollBeyondLastLine,Zt=Q.minimap.renderCharacters;let St=st>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const Jt=Q.minimap.maxColumn,Gt=Q.minimap.size,_t=Q.minimap.side,ni=Q.verticalScrollbarWidth,Xe=Q.viewLineCount,jt=Q.remainingWidth,ei=Q.isViewportWrapping,dt=Zt?2:3;let pt=Math.floor(st*Ze);const ti=pt/st;let Vt=!1,zt=!1,ft=dt*St,Pt=St/st,ii=1;if(Gt==="fill"||Gt==="fit"){const{typicalViewportLineCount:Mt,extraLinesBeforeFirstLine:Ct,extraLinesBeyondLastLine:Bt,desiredRatio:si,minimapLineCount:Nt}=ue.computeContainedMinimapLineCount({viewLineCount:Xe,scrollBeyondLastLine:Qt,paddingTop:Q.paddingTop,paddingBottom:Q.paddingBottom,height:Ze,lineHeight:Kt,pixelRatio:st});if(Xe/Nt>1)Vt=!0,zt=!0,St=1,ft=1,Pt=St/st;else{let yt=!1,Ft=St+1;if(Gt==="fit"){const Yt=Math.ceil((Ct+Xe+Bt)*ft);ei&&Dt&&jt<=pe.stableFitRemainingWidth?(yt=!0,Ft=pe.stableFitMaxMinimapScale):yt=Yt>pt}if(Gt==="fill"||yt){Vt=!0;const Yt=St;ft=Math.min(Kt*st,Math.max(1,Math.floor(1/si))),ei&&Dt&&jt<=pe.stableFitRemainingWidth&&(Ft=pe.stableFitMaxMinimapScale),St=Math.min(Ft,Math.max(1,Math.floor(ft/dt))),St>Yt&&(ii=Math.min(2,St/Yt)),Pt=St/st/ii,pt=Math.ceil(Math.max(Mt,Ct+Xe+Bt)*ft),ei?(pe.stableMinimapLayoutInput=Q,pe.stableFitRemainingWidth=jt,pe.stableFitMaxMinimapScale=St):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const Xt=Math.floor(Jt*Pt),Je=Math.min(Xt,Math.max(0,Math.floor((jt-ni-2)*Pt/(Tt+Pt)))+e.MINIMAP_GUTTER_WIDTH);let Rt=Math.floor(st*Je);const Ut=Rt/st;Rt=Math.floor(Rt*ii);const ri=Zt?1:2,gt=_t==="left"?0:Ve-Je-ni;return{renderMinimap:ri,minimapLeft:gt,minimapWidth:Je,minimapHeightIsEditorHeight:Vt,minimapIsSampling:zt,minimapScale:St,minimapLineHeight:ft,minimapCanvasInnerWidth:Rt,minimapCanvasInnerHeight:pt,minimapCanvasOuterWidth:Ut,minimapCanvasOuterHeight:ti}}static computeLayout(Q,pe){const Ve=pe.outerWidth|0,Ze=pe.outerHeight|0,st=pe.lineHeight|0,Me=pe.lineNumbersDigitCount|0,Dt=pe.typicalHalfwidthCharacterWidth,Kt=pe.maxDigitWidth,Tt=pe.pixelRatio,Qt=pe.viewLineCount,Zt=Q.get(136),St=Zt==="inherit"?Q.get(135):Zt,Jt=St==="inherit"?Q.get(131):St,Gt=Q.get(134),_t=pe.isDominatedByLongLines,ni=Q.get(57),Xe=Q.get(68).renderType!==0,jt=Q.get(69),ei=Q.get(105),dt=Q.get(84),pt=Q.get(73),ti=Q.get(103),Vt=ti.verticalScrollbarSize,zt=ti.verticalHasArrows,ft=ti.arrowSize,Pt=ti.horizontalScrollbarSize,ii=Q.get(43),Xt=Q.get(110)!=="never";let Je=Q.get(66);ii&&Xt&&(Je+=16);let Rt=0;if(Xe){const wt=Math.max(Me,jt);Rt=Math.round(wt*Kt)}let Ut=0;ni&&(Ut=st*pe.glyphMarginDecorationLaneCount);let ri=0,gt=ri+Ut,Mt=gt+Rt,Ct=Mt+Je;const Bt=Ve-Ut-Rt-Je;let si=!1,Nt=!1,qt=-1;St==="inherit"&&_t?(si=!0,Nt=!0):Jt==="on"||Jt==="bounded"?Nt=!0:Jt==="wordWrapColumn"&&(qt=Gt);const yt=ue.c({outerWidth:Ve,outerHeight:Ze,lineHeight:st,typicalHalfwidthCharacterWidth:Dt,pixelRatio:Tt,scrollBeyondLastLine:ei,paddingTop:dt.top,paddingBottom:dt.bottom,minimap:pt,verticalScrollbarWidth:Vt,viewLineCount:Qt,remainingWidth:Bt,isViewportWrapping:Nt},pe.memory||new O);yt.renderMinimap!==0&&yt.minimapLeft===0&&(ri+=yt.minimapWidth,gt+=yt.minimapWidth,Mt+=yt.minimapWidth,Ct+=yt.minimapWidth);const Ft=Bt-yt.minimapWidth,Yt=Math.max(1,Math.floor((Ft-Vt-2)/Dt)),Wt=zt?ft:0;return Nt&&(qt=Math.max(1,Yt),Jt==="bounded"&&(qt=Math.min(qt,Gt))),{width:Ve,height:Ze,glyphMarginLeft:ri,glyphMarginWidth:Ut,glyphMarginDecorationLaneCount:pe.glyphMarginDecorationLaneCount,lineNumbersLeft:gt,lineNumbersWidth:Rt,decorationsLeft:Mt,decorationsWidth:Je,contentLeft:Ct,contentWidth:Ft,minimap:yt,viewportColumn:Yt,isWordWrapMinified:si,isViewportWrapping:Nt,wrappingColumn:qt,verticalScrollbarWidth:Vt,horizontalScrollbarHeight:Pt,overviewRuler:{top:Wt,width:Vt,height:Ze-2*Wt,right:0}}}}e.EditorLayoutInfoComputer=ue;class ve extends D{constructor(){super(138,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[m.localize(47,null),m.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:m.localize(49,null)}})}validate(Q){return p(Q,"simple",["simple","advanced"])}compute(Q,pe,Ve){return pe.get(2)===2?"advanced":Ve}}var re;(function(Z){Z.Off="off",Z.OnCode="onCode",Z.On="on"})(re||(e.ShowLightbulbIconMode=re={}));class $e extends D{constructor(){const Q={enabled:re.OnCode};super(65,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[re.Off,re.OnCode,re.On],default:Q.enabled,enumDescriptions:[m.localize(50,null),m.localize(51,null),m.localize(52,null)],description:m.localize(53,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:p(Q.enabled,this.defaultValue.enabled,[re.Off,re.OnCode,re.On])}}}class ie extends D{constructor(){const Q={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",Q,{"editor.stickyScroll.enabled":{type:"boolean",default:Q.enabled,description:m.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:Q.maxLineCount,minimum:1,maximum:20,description:m.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Q.defaultModel,description:m.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Q.scrollWithEditor,description:m.localize(57,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{enabled:a(pe.enabled,this.defaultValue.enabled),maxLineCount:r.clampedInt(pe.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:p(pe.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:a(pe.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class le extends D{constructor(){const Q={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(140,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"string",default:Q.enabled,description:m.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[m.localize(59,null),m.localize(60,null,P.$j?"Ctrl+Option":"Ctrl+Alt"),m.localize(61,null,P.$j?"Ctrl+Option":"Ctrl+Alt"),m.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:m.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:m.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Q.padding,description:m.localize(65,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return typeof pe.enabled=="boolean"&&(pe.enabled=pe.enabled?"on":"off"),{enabled:p(pe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:r.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(pe.fontFamily,this.defaultValue.fontFamily),padding:a(pe.padding,this.defaultValue.padding)}}}class W extends D{constructor(){super(66,"lineDecorationsWidth",10)}validate(Q){return typeof Q=="string"&&/^\d+(\.\d+)?ch$/.test(Q)?-parseFloat(Q.substring(0,Q.length-2)):r.clampedInt(Q,this.defaultValue,0,1e3)}compute(Q,pe,Ve){return Ve<0?r.clampedInt(-Ve*Q.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ve}}class _ extends d{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>d.clamp(Q,0,150),{markdownDescription:m.localize(66,null)})}compute(Q,pe,Ve){return Q.fontInfo.lineHeight}}class ke extends D{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(73,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:m.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:Q.autohide,description:m.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[m.localize(69,null),m.localize(70,null),m.localize(71,null)],default:Q.size,description:m.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:m.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:m.localize(74,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:m.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:m.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:m.localize(77,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{enabled:a(pe.enabled,this.defaultValue.enabled),autohide:a(pe.autohide,this.defaultValue.autohide),size:p(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:p(pe.side,this.defaultValue.side,["right","left"]),showSlider:p(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:a(pe.renderCharacters,this.defaultValue.renderCharacters),scale:r.clampedInt(pe.scale,1,1,3),maxColumn:r.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Ne(Z){return Z==="ctrlCmd"?P.$j?"metaKey":"ctrlKey":"altKey"}class De extends D{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(78,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(79,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{top:r.clampedInt(pe.top,0,0,1e3),bottom:r.clampedInt(pe.bottom,0,0,1e3)}}}class be extends D{constructor(){const Q={enabled:!0,cycle:!0};super(86,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:m.localize(80,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:m.localize(81,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{enabled:a(pe.enabled,this.defaultValue.enabled),cycle:a(pe.cycle,this.defaultValue.cycle)}}}class ge extends g{constructor(){super(142)}compute(Q,pe,Ve){return Q.pixelRatio}}class J extends D{constructor(){const Q={other:"on",comments:"off",strings:"off"},pe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[m.localize(82,null),m.localize(83,null),m.localize(84,null)]}];super(89,"quickSuggestions",Q,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:pe,default:Q.strings,description:m.localize(85,null)},comments:{anyOf:pe,default:Q.comments,description:m.localize(86,null)},other:{anyOf:pe,default:Q.other,description:m.localize(87,null)}},default:Q,markdownDescription:m.localize(88,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Q}validate(Q){if(typeof Q=="boolean"){const Tt=Q?"on":"off";return{comments:Tt,strings:Tt,other:Tt}}if(!Q||typeof Q!="object")return this.defaultValue;const{other:pe,comments:Ve,strings:Ze}=Q,st=["on","inline","off"];let Me,Dt,Kt;return typeof pe=="boolean"?Me=pe?"on":"off":Me=p(pe,this.defaultValue.other,st),typeof Ve=="boolean"?Dt=Ve?"on":"off":Dt=p(Ve,this.defaultValue.comments,st),typeof Ze=="boolean"?Kt=Ze?"on":"off":Kt=p(Ze,this.defaultValue.strings,st),{other:Me,comments:Dt,strings:Kt}}}var X;(function(Z){Z[Z.Off=0]="Off",Z[Z.On=1]="On",Z[Z.Relative=2]="Relative",Z[Z.Interval=3]="Interval",Z[Z.Custom=4]="Custom"})(X||(e.RenderLineNumbersType=X={}));class he extends D{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[m.localize(89,null),m.localize(90,null),m.localize(91,null),m.localize(92,null)],default:"on",description:m.localize(93,null)})}validate(Q){let pe=this.defaultValue.renderType,Ve=this.defaultValue.renderFn;return typeof Q<"u"&&(typeof Q=="function"?(pe=4,Ve=Q):Q==="interval"?pe=3:Q==="relative"?pe=2:Q==="on"?pe=1:pe=0),{renderType:pe,renderFn:Ve}}}function fe(Z){const Q=Z.get(98);return Q==="editable"?Z.get(91):Q!=="on"}e.filterValidationDecorations=fe;class Fe extends D{constructor(){const Q=[],pe={type:"number",description:m.localize(94,null)};super(102,"rulers",Q,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:m.localize(95,null),format:"color-hex"}}}]},default:Q,description:m.localize(96,null)})}validate(Q){if(Array.isArray(Q)){const pe=[];for(const Ve of Q)if(typeof Ve=="number")pe.push({column:r.clampedInt(Ve,0,0,1e4),color:null});else if(Ve&&typeof Ve=="object"){const Ze=Ve;pe.push({column:r.clampedInt(Ze.column,0,0,1e4),color:Ze.color})}return pe.sort((Ve,Ze)=>Ve.column-Ze.column),pe}return this.defaultValue}}class de extends D{constructor(){super(92,"readOnlyMessage",void 0)}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:Q}}function Ce(Z,Q){if(typeof Z!="string")return Q;switch(Z){case"hidden":return 2;case"visible":return 3;default:return 1}}class Ae extends D{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(97,null),m.localize(98,null),m.localize(99,null)],default:"auto",description:m.localize(100,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(101,null),m.localize(102,null),m.localize(103,null)],default:"auto",description:m.localize(104,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:m.localize(105,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:m.localize(106,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:m.localize(107,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:Q.ignoreHorizontalScrollbarInContentHeight,description:m.localize(108,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q,Ve=r.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ze=r.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:r.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ce(pe.vertical,this.defaultValue.vertical),horizontal:Ce(pe.horizontal,this.defaultValue.horizontal),useShadows:a(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:a(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:a(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:a(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:a(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ve,horizontalSliderSize:r.clampedInt(pe.horizontalSliderSize,Ve,0,1e3),verticalScrollbarSize:Ze,verticalSliderSize:r.clampedInt(pe.verticalSliderSize,Ze,0,1e3),scrollByPage:a(pe.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:a(pe.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class je extends D{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:m.localize(109,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:m.localize(110,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:m.localize(111,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:m.localize(112,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:m.localize(113,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:m.localize(114,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:m.localize(115,null)}})}applyUpdate(Q,pe){let Ve=!1;pe.allowedCharacters&&Q&&(M.$On(Q.allowedCharacters,pe.allowedCharacters)||(Q={...Q,allowedCharacters:pe.allowedCharacters},Ve=!0)),pe.allowedLocales&&Q&&(M.$On(Q.allowedLocales,pe.allowedLocales)||(Q={...Q,allowedLocales:pe.allowedLocales},Ve=!0));const Ze=super.applyUpdate(Q,pe);return Ve?new l(Ze.newValue,!0):Ze}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{nonBasicASCII:ee(pe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:a(pe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:a(pe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ee(pe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ee(pe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Q.allowedLocales,this.defaultValue.allowedLocales)}}c(Q,pe){if(typeof Q!="object"||!Q)return pe;const Ve={};for(const[Ze,st]of Object.entries(Q))st===!0&&(Ve[Ze]=!0);return Ve}}class z extends D{constructor(){const Q={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:m.localize(116,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Q.showToolbar,enum:["always","onHover","never"],enumDescriptions:[m.localize(117,null),m.localize(118,null),m.localize(119,null)],description:m.localize(120,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Q.suppressSuggestions,description:m.localize(121,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:Q.fontFamily,description:m.localize(122,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{enabled:a(pe.enabled,this.defaultValue.enabled),mode:p(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:p(pe.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:a(pe.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:a(pe.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(pe.fontFamily,this.defaultValue.fontFamily)}}}class j extends D{constructor(){const Q={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",Q,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:Q.enabled,description:m.localize(123,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:Q.showToolbar,enum:["always","onHover","never"],enumDescriptions:[m.localize(124,null),m.localize(125,null),m.localize(126,null)],description:m.localize(127,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:Q.fontFamily,description:m.localize(128,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:Q.backgroundColoring,description:m.localize(129,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{enabled:a(pe.enabled,this.defaultValue.enabled),showToolbar:p(pe.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:t.string(pe.fontFamily,this.defaultValue.fontFamily),keepOnBlur:a(pe.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:a(pe.backgroundColoring,this.defaultValue.backgroundColoring)}}}class K extends D{constructor(){const Q={enabled:F.$Gs.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:F.$Gs.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,markdownDescription:m.localize(130,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Q.independentColorPoolPerBracketType,description:m.localize(131,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{enabled:a(pe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:a(pe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class H extends D{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(132,null),m.localize(133,null),m.localize(134,null)],default:Q.bracketPairs,description:m.localize(135,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(136,null),m.localize(137,null),m.localize(138,null)],default:Q.bracketPairsHorizontal,description:m.localize(139,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:m.localize(140,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:m.localize(141,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[m.localize(142,null),m.localize(143,null),m.localize(144,null)],default:Q.highlightActiveIndentation,description:m.localize(145,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{bracketPairs:ee(pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ee(pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:a(pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:a(pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:ee(pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ee(Z,Q,pe){const Ve=pe.indexOf(Z);return Ve===-1?Q:pe[Ve]}class se extends D{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[m.localize(146,null),m.localize(147,null)],default:Q.insertMode,description:m.localize(148,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:m.localize(149,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:m.localize(150,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:m.localize(151,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[m.localize(152,null),m.localize(153,null),m.localize(154,null),m.localize(155,null)],default:Q.selectionMode,markdownDescription:m.localize(156,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:m.localize(157,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:m.localize(158,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:m.localize(159,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:m.localize(160,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:m.localize(161,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:m.localize(162,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:m.localize(163,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:m.localize(164,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:m.localize(165,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:m.localize(166,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:m.localize(167,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:m.localize(168,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:m.localize(169,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:m.localize(170,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:m.localize(171,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:m.localize(172,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:m.localize(173,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:m.localize(174,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:m.localize(175,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:m.localize(176,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:m.localize(177,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:m.localize(178,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:m.localize(179,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:m.localize(180,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:m.localize(181,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:m.localize(182,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:m.localize(183,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:m.localize(184,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:m.localize(185,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:m.localize(186,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:m.localize(187,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:m.localize(188,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:m.localize(189,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:m.localize(190,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:m.localize(191,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:m.localize(192,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:m.localize(193,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{insertMode:p(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:a(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:a(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:a(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:a(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:p(pe.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:a(pe.showIcons,this.defaultValue.showIcons),showStatusBar:a(pe.showStatusBar,this.defaultValue.showStatusBar),preview:a(pe.preview,this.defaultValue.preview),previewMode:p(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:a(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:a(pe.showMethods,this.defaultValue.showMethods),showFunctions:a(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:a(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:a(pe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:a(pe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:a(pe.showFields,this.defaultValue.showFields),showVariables:a(pe.showVariables,this.defaultValue.showVariables),showClasses:a(pe.showClasses,this.defaultValue.showClasses),showStructs:a(pe.showStructs,this.defaultValue.showStructs),showInterfaces:a(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:a(pe.showModules,this.defaultValue.showModules),showProperties:a(pe.showProperties,this.defaultValue.showProperties),showEvents:a(pe.showEvents,this.defaultValue.showEvents),showOperators:a(pe.showOperators,this.defaultValue.showOperators),showUnits:a(pe.showUnits,this.defaultValue.showUnits),showValues:a(pe.showValues,this.defaultValue.showValues),showConstants:a(pe.showConstants,this.defaultValue.showConstants),showEnums:a(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:a(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:a(pe.showKeywords,this.defaultValue.showKeywords),showWords:a(pe.showWords,this.defaultValue.showWords),showColors:a(pe.showColors,this.defaultValue.showColors),showFiles:a(pe.showFiles,this.defaultValue.showFiles),showReferences:a(pe.showReferences,this.defaultValue.showReferences),showFolders:a(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:a(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:a(pe.showSnippets,this.defaultValue.showSnippets),showUsers:a(pe.showUsers,this.defaultValue.showUsers),showIssues:a(pe.showIssues,this.defaultValue.showIssues)}}}class Oe extends D{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:m.localize(194,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:m.localize(195,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:a(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:a(Q.selectSubwords,this.defaultValue.selectSubwords)}}}var We;(function(Z){Z[Z.None=0]="None",Z[Z.Same=1]="Same",Z[Z.Indent=2]="Indent",Z[Z.DeepIndent=3]="DeepIndent"})(We||(e.WrappingIndent=We={}));class Ke extends D{constructor(){super(137,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[m.localize(196,null),m.localize(197,null),m.localize(198,null),m.localize(199,null)],description:m.localize(200,null),default:"same"}})}validate(Q){switch(Q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Q,pe,Ve){return pe.get(2)===2?0:Ve}}class xe extends g{constructor(){super(145)}compute(Q,pe,Ve){const Ze=pe.get(144);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:Ze.isWordWrapMinified,isViewportWrapping:Ze.isViewportWrapping,wrappingColumn:Ze.wrappingColumn}}}class tt extends D{constructor(){const Q={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",Q,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Q.enabled,markdownDescription:m.localize(201,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:m.localize(202,null),enum:["afterDrop","never"],enumDescriptions:[m.localize(203,null),m.localize(204,null)],default:"afterDrop"}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{enabled:a(pe.enabled,this.defaultValue.enabled),showDropSelector:p(pe.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class lt extends D{constructor(){const Q={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",Q,{"editor.pasteAs.enabled":{type:"boolean",default:Q.enabled,markdownDescription:m.localize(205,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:m.localize(206,null),enum:["afterPaste","never"],enumDescriptions:[m.localize(207,null),m.localize(208,null)],default:"afterPaste"}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{enabled:a(pe.enabled,this.defaultValue.enabled),showPasteSelector:p(pe.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const rt="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",at="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:P.$j?it:P.$k?at:rt,fontWeight:"normal",fontSize:P.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Be(Z){return e.editorOptionsRegistry[Z.id]=Z,Z}var et;(function(Z){Z[Z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Z[Z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Z[Z.accessibilitySupport=2]="accessibilitySupport",Z[Z.accessibilityPageSize=3]="accessibilityPageSize",Z[Z.ariaLabel=4]="ariaLabel",Z[Z.ariaRequired=5]="ariaRequired",Z[Z.autoClosingBrackets=6]="autoClosingBrackets",Z[Z.autoClosingComments=7]="autoClosingComments",Z[Z.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Z[Z.autoClosingDelete=9]="autoClosingDelete",Z[Z.autoClosingOvertype=10]="autoClosingOvertype",Z[Z.autoClosingQuotes=11]="autoClosingQuotes",Z[Z.autoIndent=12]="autoIndent",Z[Z.automaticLayout=13]="automaticLayout",Z[Z.autoSurround=14]="autoSurround",Z[Z.bracketPairColorization=15]="bracketPairColorization",Z[Z.guides=16]="guides",Z[Z.codeLens=17]="codeLens",Z[Z.codeLensFontFamily=18]="codeLensFontFamily",Z[Z.codeLensFontSize=19]="codeLensFontSize",Z[Z.colorDecorators=20]="colorDecorators",Z[Z.colorDecoratorsLimit=21]="colorDecoratorsLimit",Z[Z.columnSelection=22]="columnSelection",Z[Z.comments=23]="comments",Z[Z.contextmenu=24]="contextmenu",Z[Z.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Z[Z.cursorBlinking=26]="cursorBlinking",Z[Z.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Z[Z.cursorStyle=28]="cursorStyle",Z[Z.cursorSurroundingLines=29]="cursorSurroundingLines",Z[Z.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Z[Z.cursorWidth=31]="cursorWidth",Z[Z.disableLayerHinting=32]="disableLayerHinting",Z[Z.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Z[Z.domReadOnly=34]="domReadOnly",Z[Z.dragAndDrop=35]="dragAndDrop",Z[Z.dropIntoEditor=36]="dropIntoEditor",Z[Z.emptySelectionClipboard=37]="emptySelectionClipboard",Z[Z.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Z[Z.extraEditorClassName=39]="extraEditorClassName",Z[Z.fastScrollSensitivity=40]="fastScrollSensitivity",Z[Z.find=41]="find",Z[Z.fixedOverflowWidgets=42]="fixedOverflowWidgets",Z[Z.folding=43]="folding",Z[Z.foldingStrategy=44]="foldingStrategy",Z[Z.foldingHighlight=45]="foldingHighlight",Z[Z.foldingImportsByDefault=46]="foldingImportsByDefault",Z[Z.foldingMaximumRegions=47]="foldingMaximumRegions",Z[Z.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Z[Z.fontFamily=49]="fontFamily",Z[Z.fontInfo=50]="fontInfo",Z[Z.fontLigatures=51]="fontLigatures",Z[Z.fontSize=52]="fontSize",Z[Z.fontWeight=53]="fontWeight",Z[Z.fontVariations=54]="fontVariations",Z[Z.formatOnPaste=55]="formatOnPaste",Z[Z.formatOnType=56]="formatOnType",Z[Z.glyphMargin=57]="glyphMargin",Z[Z.gotoLocation=58]="gotoLocation",Z[Z.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Z[Z.hover=60]="hover",Z[Z.inDiffEditor=61]="inDiffEditor",Z[Z.inlineSuggest=62]="inlineSuggest",Z[Z.inlineEdit=63]="inlineEdit",Z[Z.letterSpacing=64]="letterSpacing",Z[Z.lightbulb=65]="lightbulb",Z[Z.lineDecorationsWidth=66]="lineDecorationsWidth",Z[Z.lineHeight=67]="lineHeight",Z[Z.lineNumbers=68]="lineNumbers",Z[Z.lineNumbersMinChars=69]="lineNumbersMinChars",Z[Z.linkedEditing=70]="linkedEditing",Z[Z.links=71]="links",Z[Z.matchBrackets=72]="matchBrackets",Z[Z.minimap=73]="minimap",Z[Z.mouseStyle=74]="mouseStyle",Z[Z.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",Z[Z.mouseWheelZoom=76]="mouseWheelZoom",Z[Z.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",Z[Z.multiCursorModifier=78]="multiCursorModifier",Z[Z.multiCursorPaste=79]="multiCursorPaste",Z[Z.multiCursorLimit=80]="multiCursorLimit",Z[Z.occurrencesHighlight=81]="occurrencesHighlight",Z[Z.overviewRulerBorder=82]="overviewRulerBorder",Z[Z.overviewRulerLanes=83]="overviewRulerLanes",Z[Z.padding=84]="padding",Z[Z.pasteAs=85]="pasteAs",Z[Z.parameterHints=86]="parameterHints",Z[Z.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",Z[Z.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",Z[Z.quickSuggestions=89]="quickSuggestions",Z[Z.quickSuggestionsDelay=90]="quickSuggestionsDelay",Z[Z.readOnly=91]="readOnly",Z[Z.readOnlyMessage=92]="readOnlyMessage",Z[Z.renameOnType=93]="renameOnType",Z[Z.renderControlCharacters=94]="renderControlCharacters",Z[Z.renderFinalNewline=95]="renderFinalNewline",Z[Z.renderLineHighlight=96]="renderLineHighlight",Z[Z.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",Z[Z.renderValidationDecorations=98]="renderValidationDecorations",Z[Z.renderWhitespace=99]="renderWhitespace",Z[Z.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",Z[Z.roundedSelection=101]="roundedSelection",Z[Z.rulers=102]="rulers",Z[Z.scrollbar=103]="scrollbar",Z[Z.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",Z[Z.scrollBeyondLastLine=105]="scrollBeyondLastLine",Z[Z.scrollPredominantAxis=106]="scrollPredominantAxis",Z[Z.selectionClipboard=107]="selectionClipboard",Z[Z.selectionHighlight=108]="selectionHighlight",Z[Z.selectOnLineNumbers=109]="selectOnLineNumbers",Z[Z.showFoldingControls=110]="showFoldingControls",Z[Z.showUnused=111]="showUnused",Z[Z.snippetSuggestions=112]="snippetSuggestions",Z[Z.smartSelect=113]="smartSelect",Z[Z.smoothScrolling=114]="smoothScrolling",Z[Z.stickyScroll=115]="stickyScroll",Z[Z.stickyTabStops=116]="stickyTabStops",Z[Z.stopRenderingLineAfter=117]="stopRenderingLineAfter",Z[Z.suggest=118]="suggest",Z[Z.suggestFontSize=119]="suggestFontSize",Z[Z.suggestLineHeight=120]="suggestLineHeight",Z[Z.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",Z[Z.suggestSelection=122]="suggestSelection",Z[Z.tabCompletion=123]="tabCompletion",Z[Z.tabIndex=124]="tabIndex",Z[Z.unicodeHighlighting=125]="unicodeHighlighting",Z[Z.unusualLineTerminators=126]="unusualLineTerminators",Z[Z.useShadowDOM=127]="useShadowDOM",Z[Z.useTabStops=128]="useTabStops",Z[Z.wordBreak=129]="wordBreak",Z[Z.wordSeparators=130]="wordSeparators",Z[Z.wordWrap=131]="wordWrap",Z[Z.wordWrapBreakAfterCharacters=132]="wordWrapBreakAfterCharacters",Z[Z.wordWrapBreakBeforeCharacters=133]="wordWrapBreakBeforeCharacters",Z[Z.wordWrapColumn=134]="wordWrapColumn",Z[Z.wordWrapOverride1=135]="wordWrapOverride1",Z[Z.wordWrapOverride2=136]="wordWrapOverride2",Z[Z.wrappingIndent=137]="wrappingIndent",Z[Z.wrappingStrategy=138]="wrappingStrategy",Z[Z.showDeprecated=139]="showDeprecated",Z[Z.inlayHints=140]="inlayHints",Z[Z.editorClassName=141]="editorClassName",Z[Z.pixelRatio=142]="pixelRatio",Z[Z.tabFocusMode=143]="tabFocusMode",Z[Z.layoutInfo=144]="layoutInfo",Z[Z.wrappingInfo=145]="wrappingInfo",Z[Z.defaultColorDecorators=146]="defaultColorDecorators",Z[Z.colorDecoratorsActivatedOn=147]="colorDecoratorsActivatedOn",Z[Z.inlineCompletionsAccessibilityVerbose=148]="inlineCompletionsAccessibilityVerbose"})(et||(e.EditorOption=et={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Be(new i(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:m.localize(209,null)})),acceptSuggestionOnEnter:Be(new u(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",m.localize(210,null),""],markdownDescription:m.localize(211,null)})),accessibilitySupport:Be(new b),accessibilityPageSize:Be(new r(3,"accessibilityPageSize",10,1,1073741824,{description:m.localize(212,null),tags:["accessibility"]})),ariaLabel:Be(new t(4,"ariaLabel",m.localize(213,null))),ariaRequired:Be(new i(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Be(new i(8,"screenReaderAnnounceInlineSuggestion",!0,{description:m.localize(214,null),tags:["accessibility"]})),autoClosingBrackets:Be(new u(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(215,null),m.localize(216,null),""],description:m.localize(217,null)})),autoClosingComments:Be(new u(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(218,null),m.localize(219,null),""],description:m.localize(220,null)})),autoClosingDelete:Be(new u(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",m.localize(221,null),""],description:m.localize(222,null)})),autoClosingOvertype:Be(new u(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",m.localize(223,null),""],description:m.localize(224,null)})),autoClosingQuotes:Be(new u(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(225,null),m.localize(226,null),""],description:m.localize(227,null)})),autoIndent:Be(new o(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],v,{enumDescriptions:[m.localize(228,null),m.localize(229,null),m.localize(230,null),m.localize(231,null),m.localize(232,null)],description:m.localize(233,null)})),automaticLayout:Be(new i(13,"automaticLayout",!1)),autoSurround:Be(new u(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[m.localize(234,null),m.localize(235,null),m.localize(236,null),""],description:m.localize(237,null)})),bracketPairColorization:Be(new K),bracketPairGuides:Be(new H),stickyTabStops:Be(new i(116,"stickyTabStops",!1,{description:m.localize(238,null)})),codeLens:Be(new i(17,"codeLens",!0,{description:m.localize(239,null)})),codeLensFontFamily:Be(new t(18,"codeLensFontFamily","",{description:m.localize(240,null)})),codeLensFontSize:Be(new r(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:m.localize(241,null)})),colorDecorators:Be(new i(20,"colorDecorators",!0,{description:m.localize(242,null)})),colorDecoratorActivatedOn:Be(new u(147,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[m.localize(243,null),m.localize(244,null),m.localize(245,null)],description:m.localize(246,null)})),colorDecoratorsLimit:Be(new r(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:m.localize(247,null)})),columnSelection:Be(new i(22,"columnSelection",!1,{description:m.localize(248,null)})),comments:Be(new $),contextmenu:Be(new i(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Be(new i(25,"copyWithSyntaxHighlighting",!0,{description:m.localize(249,null)})),cursorBlinking:Be(new o(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],h,{description:m.localize(250,null)})),cursorSmoothCaretAnimation:Be(new u(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[m.localize(251,null),m.localize(252,null),m.localize(253,null)],description:m.localize(254,null)})),cursorStyle:Be(new o(28,"cursorStyle",y.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],A,{description:m.localize(255,null)})),cursorSurroundingLines:Be(new r(29,"cursorSurroundingLines",0,0,1073741824,{description:m.localize(256,null)})),cursorSurroundingLinesStyle:Be(new u(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[m.localize(257,null),m.localize(258,null)],markdownDescription:m.localize(259,null)})),cursorWidth:Be(new r(31,"cursorWidth",0,0,1073741824,{markdownDescription:m.localize(260,null)})),disableLayerHinting:Be(new i(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Be(new i(33,"disableMonospaceOptimizations",!1)),domReadOnly:Be(new i(34,"domReadOnly",!1)),dragAndDrop:Be(new i(35,"dragAndDrop",!0,{description:m.localize(261,null)})),emptySelectionClipboard:Be(new G),dropIntoEditor:Be(new tt),stickyScroll:Be(new ie),experimentalWhitespaceRendering:Be(new u(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[m.localize(262,null),m.localize(263,null),m.localize(264,null)],description:m.localize(265,null)})),extraEditorClassName:Be(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Be(new d(40,"fastScrollSensitivity",5,Z=>Z<=0?5:Z,{markdownDescription:m.localize(266,null)})),find:Be(new V),fixedOverflowWidgets:Be(new i(42,"fixedOverflowWidgets",!1)),folding:Be(new i(43,"folding",!0,{description:m.localize(267,null)})),foldingStrategy:Be(new u(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[m.localize(268,null),m.localize(269,null)],description:m.localize(270,null)})),foldingHighlight:Be(new i(45,"foldingHighlight",!0,{description:m.localize(271,null)})),foldingImportsByDefault:Be(new i(46,"foldingImportsByDefault",!1,{description:m.localize(272,null)})),foldingMaximumRegions:Be(new r(47,"foldingMaximumRegions",5e3,10,65e3,{description:m.localize(273,null)})),unfoldOnClickAfterEndOfLine:Be(new i(48,"unfoldOnClickAfterEndOfLine",!1,{description:m.localize(274,null)})),fontFamily:Be(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:m.localize(275,null)})),fontInfo:Be(new L),fontLigatures2:Be(new U),fontSize:Be(new q),fontWeight:Be(new ne),fontVariations:Be(new C),formatOnPaste:Be(new i(55,"formatOnPaste",!1,{description:m.localize(276,null)})),formatOnType:Be(new i(56,"formatOnType",!1,{description:m.localize(277,null)})),glyphMargin:Be(new i(57,"glyphMargin",!0,{description:m.localize(278,null)})),gotoLocation:Be(new ae),hideCursorInOverviewRuler:Be(new i(59,"hideCursorInOverviewRuler",!1,{description:m.localize(279,null)})),hover:Be(new ye),inDiffEditor:Be(new i(61,"inDiffEditor",!1)),letterSpacing:Be(new d(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Z=>d.clamp(Z,-5,20),{description:m.localize(280,null)})),lightbulb:Be(new $e),lineDecorationsWidth:Be(new W),lineHeight:Be(new _),lineNumbers:Be(new he),lineNumbersMinChars:Be(new r(69,"lineNumbersMinChars",5,1,300)),linkedEditing:Be(new i(70,"linkedEditing",!1,{description:m.localize(281,null)})),links:Be(new i(71,"links",!0,{description:m.localize(282,null)})),matchBrackets:Be(new u(72,"matchBrackets","always",["always","near","never"],{description:m.localize(283,null)})),minimap:Be(new ke),mouseStyle:Be(new u(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Be(new d(75,"mouseWheelScrollSensitivity",1,Z=>Z===0?1:Z,{markdownDescription:m.localize(284,null)})),mouseWheelZoom:Be(new i(76,"mouseWheelZoom",!1,{markdownDescription:P.$j?m.localize(285,null):m.localize(286,null)})),multiCursorMergeOverlapping:Be(new i(77,"multiCursorMergeOverlapping",!0,{description:m.localize(287,null)})),multiCursorModifier:Be(new o(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Ne,{markdownEnumDescriptions:[m.localize(288,null),m.localize(289,null)],markdownDescription:m.localize(290,null)})),multiCursorPaste:Be(new u(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[m.localize(291,null),m.localize(292,null)],markdownDescription:m.localize(293,null)})),multiCursorLimit:Be(new r(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:m.localize(294,null)})),occurrencesHighlight:Be(new u(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[m.localize(295,null),m.localize(296,null),m.localize(297,null)],markdownDescription:m.localize(298,null)})),overviewRulerBorder:Be(new i(82,"overviewRulerBorder",!0,{description:m.localize(299,null)})),overviewRulerLanes:Be(new r(83,"overviewRulerLanes",3,0,3)),padding:Be(new De),pasteAs:Be(new lt),parameterHints:Be(new be),peekWidgetDefaultFocus:Be(new u(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[m.localize(300,null),m.localize(301,null)],description:m.localize(302,null)})),definitionLinkOpensInPeek:Be(new i(88,"definitionLinkOpensInPeek",!1,{description:m.localize(303,null)})),quickSuggestions:Be(new J),quickSuggestionsDelay:Be(new r(90,"quickSuggestionsDelay",10,0,1073741824,{description:m.localize(304,null)})),readOnly:Be(new i(91,"readOnly",!1)),readOnlyMessage:Be(new de),renameOnType:Be(new i(93,"renameOnType",!1,{description:m.localize(305,null),markdownDeprecationMessage:m.localize(306,null)})),renderControlCharacters:Be(new i(94,"renderControlCharacters",!0,{description:m.localize(307,null),restricted:!0})),renderFinalNewline:Be(new u(95,"renderFinalNewline",P.$k?"dimmed":"on",["off","on","dimmed"],{description:m.localize(308,null)})),renderLineHighlight:Be(new u(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",m.localize(309,null)],description:m.localize(310,null)})),renderLineHighlightOnlyWhenFocus:Be(new i(97,"renderLineHighlightOnlyWhenFocus",!1,{description:m.localize(311,null)})),renderValidationDecorations:Be(new u(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Be(new u(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",m.localize(312,null),m.localize(313,null),m.localize(314,null),""],description:m.localize(315,null)})),revealHorizontalRightPadding:Be(new r(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Be(new i(101,"roundedSelection",!0,{description:m.localize(316,null)})),rulers:Be(new Fe),scrollbar:Be(new Ae),scrollBeyondLastColumn:Be(new r(104,"scrollBeyondLastColumn",4,0,1073741824,{description:m.localize(317,null)})),scrollBeyondLastLine:Be(new i(105,"scrollBeyondLastLine",!0,{description:m.localize(318,null)})),scrollPredominantAxis:Be(new i(106,"scrollPredominantAxis",!0,{description:m.localize(319,null)})),selectionClipboard:Be(new i(107,"selectionClipboard",!0,{description:m.localize(320,null),included:P.$k})),selectionHighlight:Be(new i(108,"selectionHighlight",!0,{description:m.localize(321,null)})),selectOnLineNumbers:Be(new i(109,"selectOnLineNumbers",!0)),showFoldingControls:Be(new u(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[m.localize(322,null),m.localize(323,null),m.localize(324,null)],description:m.localize(325,null)})),showUnused:Be(new i(111,"showUnused",!0,{description:m.localize(326,null)})),showDeprecated:Be(new i(139,"showDeprecated",!0,{description:m.localize(327,null)})),inlayHints:Be(new le),snippetSuggestions:Be(new u(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[m.localize(328,null),m.localize(329,null),m.localize(330,null),m.localize(331,null)],description:m.localize(332,null)})),smartSelect:Be(new Oe),smoothScrolling:Be(new i(114,"smoothScrolling",!1,{description:m.localize(333,null)})),stopRenderingLineAfter:Be(new r(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Be(new se),inlineSuggest:Be(new z),inlineEdit:Be(new j),inlineCompletionsAccessibilityVerbose:Be(new i(148,"inlineCompletionsAccessibilityVerbose",!1,{description:m.localize(334,null)})),suggestFontSize:Be(new r(119,"suggestFontSize",0,0,1e3,{markdownDescription:m.localize(335,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Be(new r(120,"suggestLineHeight",0,0,1e3,{markdownDescription:m.localize(336,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Be(new i(121,"suggestOnTriggerCharacters",!0,{description:m.localize(337,null)})),suggestSelection:Be(new u(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[m.localize(338,null),m.localize(339,null),m.localize(340,null)],description:m.localize(341,null)})),tabCompletion:Be(new u(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[m.localize(342,null),m.localize(343,null),m.localize(344,null)],description:m.localize(345,null)})),tabIndex:Be(new r(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Be(new je),unusualLineTerminators:Be(new u(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[m.localize(346,null),m.localize(347,null),m.localize(348,null)],description:m.localize(349,null)})),useShadowDOM:Be(new i(127,"useShadowDOM",!0)),useTabStops:Be(new i(128,"useTabStops",!0,{description:m.localize(350,null)})),wordBreak:Be(new u(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[m.localize(351,null),m.localize(352,null)],description:m.localize(353,null)})),wordSeparators:Be(new t(130,"wordSeparators",R.$Hs,{description:m.localize(354,null)})),wordWrap:Be(new u(131,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[m.localize(355,null),m.localize(356,null),m.localize(357,null),m.localize(358,null)],description:m.localize(359,null)})),wordWrapBreakAfterCharacters:Be(new t(132,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Be(new t(133,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Be(new r(134,"wordWrapColumn",80,1,1073741824,{markdownDescription:m.localize(360,null)})),wordWrapOverride1:Be(new u(135,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Be(new u(136,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Be(new N),defaultColorDecorators:Be(new i(146,"defaultColorDecorators",!1,{markdownDescription:m.localize(361,null)})),pixelRatio:Be(new ge),tabFocusMode:Be(new i(143,"tabFocusMode",!1,{markdownDescription:m.localize(362,null)})),layoutInfo:Be(new ue),wrappingInfo:Be(new xe),wrappingIndent:Be(new Ke),wrappingStrategy:Be(new ve)}}),define(Pe[151],Re([9,10]),function(me,e){return me.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Pe[152],Re([9,10]),function(me,e){return me.create("vs/platform/contextkey/common/contextkey",e)}),define(Pe[153],Re([9,10]),function(me,e){return me.create("vs/platform/contextkey/common/scanner",e)}),define(Pe[154],Re([9,10]),function(me,e){return me.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Pe[155],Re([9,10]),function(me,e){return me.create("vs/platform/extensions/common/extensionValidator",e)}),define(Pe[156],Re([9,10]),function(me,e){return me.create("vs/platform/files/common/files",e)}),define(Pe[157],Re([9,10]),function(me,e){return me.create("vs/platform/markers/common/markers",e)}),define(Pe[158],Re([9,10]),function(me,e){return me.create("vs/platform/theme/common/iconRegistry",e)}),define(Pe[159],Re([9,10]),function(me,e){return me.create("vs/platform/workspace/common/workspace",e)}),define(Pe[160],Re([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Pe[161],Re([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Pe[162],Re([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Pe[163],Re([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Pe[164],Re([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(Pe[165],Re([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostLogService",e)}),define(Pe[166],Re([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostNotebook",e)}),define(Pe[167],Re([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Pe[168],Re([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Pe[169],Re([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Pe[170],Re([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Pe[171],Re([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Pe[172],Re([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Pe[173],Re([9,10]),function(me,e){return me.create("vs/workbench/common/configuration",e)}),define(Pe[174],Re([9,10]),function(me,e){return me.create("vs/workbench/common/editor",e)}),define(Pe[175],Re([9,10]),function(me,e){return me.create("vs/workbench/common/views",e)}),define(Pe[176],Re([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Pe[177],Re([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/common/debug",e)}),define(Pe[178],Re([9,10]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Pe[179],Re([9,10]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Pe[180],Re([9,10]),function(me,e){return me.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Pe[181],Re([9,10]),function(me,e){return me.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Pe[182],Re([9,10]),function(me,e){return me.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Pe[183],Re([9,10]),function(me,e){return me.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Pe[184],Re([1,0,14,153]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aj=e.TokenType=void 0;var P;(function(k){k[k.LParen=0]="LParen",k[k.RParen=1]="RParen",k[k.Neg=2]="Neg",k[k.Eq=3]="Eq",k[k.NotEq=4]="NotEq",k[k.Lt=5]="Lt",k[k.LtEq=6]="LtEq",k[k.Gt=7]="Gt",k[k.GtEq=8]="GtEq",k[k.RegexOp=9]="RegexOp",k[k.RegexStr=10]="RegexStr",k[k.True=11]="True",k[k.False=12]="False",k[k.In=13]="In",k[k.Not=14]="Not",k[k.And=15]="And",k[k.Or=16]="Or",k[k.Str=17]="Str",k[k.QuotedStr=18]="QuotedStr",k[k.Error=19]="Error",k[k.EOF=20]="EOF"})(P||(e.TokenType=P={}));function F(...k){switch(k.length){case 1:return(0,M.localize)(0,null,k[0]);case 2:return(0,M.localize)(1,null,k[0],k[1]);case 3:return(0,M.localize)(2,null,k[0],k[1],k[2]);default:return}}const R=(0,M.localize)(3,null),m=(0,M.localize)(4,null);class f{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(O){switch(O.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return O.isTripleEq?"===":"==";case 4:return O.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return O.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return O.lexeme;case 18:return O.lexeme;case 19:return O.lexeme;case 20:return"EOF";default:throw(0,S.$8)(`unhandled token type: ${JSON.stringify(O)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(O=>O.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(O){return this.c=O,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const D=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:D})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const D=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:D})}else this.h(126)?this.k(9):this.l(F("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(F("&&"));break;case 124:this.h(124)?this.k(16):this.l(F("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(O){return this.r()||this.c.charCodeAt(this.e)!==O?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(O){this.f.push({type:O,offset:this.d})}l(O){const D=this.d,l=this.c.substring(this.d,this.e),E={type:19,offset:this.d,lexeme:l};this.g.push({offset:D,lexeme:l,additionalInfo:O}),this.f.push(E)}n(){this.m.lastIndex=this.d;const O=this.m.exec(this.c);if(O){this.e=this.d+O[0].length;const D=this.c.substring(this.d,this.e),l=f.b.get(D);l?this.k(l):this.f.push({type:17,lexeme:D,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let O=this.e,D=!1,l=!1;for(;;){if(O>=this.c.length){this.e=O,this.l(m);return}const g=this.c.charCodeAt(O);if(D)D=!1;else if(g===47&&!l){O++;break}else g===91?l=!0:g===92?D=!0:g===93&&(l=!1);O++}for(;O<this.c.length&&f.a.has(this.c.charCodeAt(O));)O++;this.e=O;const E=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:E,offset:this.d})}r(){return this.e>=this.c.length}}e.$aj=f}),define(Pe[185],Re([1,0,24,32,155,297]),function(me,e,S,M,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$up=e.$tp=e.$sp=e.$rp=e.$qp=e.$pp=e.$op=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,m=/^-(\d{4})(\d{2})(\d{2})$/;function f(i){return i=i.trim(),i==="*"||R.test(i)}e.$op=f;function k(i){if(!f(i))return null;if(i=i.trim(),i==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=i.match(R);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}e.$pp=k;function O(i){if(!i)return null;const n=i.majorBase,r=i.majorMustEqual,c=i.minorBase;let d=i.minorMustEqual;const t=i.patchBase;let p=i.patchMustEqual;i.hasCaret&&(n===0||(d=!1),p=!1);let u=0;if(i.preRelease){const o=m.exec(i.preRelease);if(o){const[,v,b,$]=o;u=Date.UTC(Number(v),Number(b)-1,Number($))}}return{majorBase:n,majorMustEqual:r,minorBase:c,minorMustEqual:d,patchBase:t,patchMustEqual:p,isMinimum:i.hasGreaterEquals,notBefore:u}}e.$qp=O;function D(i,n,r){let c;typeof i=="string"?c=O(k(i)):c=i;let d;n instanceof Date?d=n.getTime():typeof n=="string"&&(d=new Date(n).getTime());let t;if(typeof r=="string"?t=O(k(r)):t=r,!c||!t)return!1;const p=c.majorBase,u=c.minorBase,o=c.patchBase;let v=t.majorBase,b=t.minorBase,$=t.patchBase;const I=t.notBefore;let h=t.majorMustEqual,y=t.minorMustEqual,w=t.patchMustEqual;return t.isMinimum?p>v?!0:p<v?!1:u>b?!0:u<b||d&&d<I?!1:o>=$:(p===1&&v===0&&(!h||!y||!w)&&(v=1,b=0,$=0,h=!0,y=!1,w=!1),p<v?!1:p>v?!h:u<b?!1:u>b?!y:o<$?!1:o>$?!w:!(d&&d<I))}e.$rp=D;function l(i,n,r,c,d){const t=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return t.push([M.default.Error,P.localize(0,null)]),t;if(typeof c.name!="string")return t.push([M.default.Error,P.localize(1,null,"name")]),t;if(typeof c.version!="string")return t.push([M.default.Error,P.localize(2,null,"version")]),t;if(!c.engines)return t.push([M.default.Error,P.localize(3,null,"engines")]),t;if(typeof c.engines.vscode!="string")return t.push([M.default.Error,P.localize(4,null,"engines.vscode")]),t;if(typeof c.extensionDependencies<"u"&&!a(c.extensionDependencies))return t.push([M.default.Error,P.localize(5,null,"extensionDependencies")]),t;if(typeof c.activationEvents<"u"){if(!a(c.activationEvents))return t.push([M.default.Error,P.localize(6,null,"activationEvents")]),t;if(typeof c.main>"u"&&typeof c.browser>"u")return t.push([M.default.Error,P.localize(7,null,"activationEvents","main","browser")]),t}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&t.push([M.default.Warning,P.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return t.push([M.default.Error,P.localize(9,null,"main")]),t;{const o=(0,S.$Sg)(r,c.main);(0,S.$Mg)(o,r)||t.push([M.default.Warning,P.localize(10,null,o.path,r.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return t.push([M.default.Error,P.localize(11,null,"browser")]),t;{const o=(0,S.$Sg)(r,c.browser);(0,S.$Mg)(o,r)||t.push([M.default.Warning,P.localize(12,null,o.path,r.path)])}}if(!F.valid(c.version))return t.push([M.default.Error,P.localize(13,null)]),t;const p=[];if(!E(i,n,c,d,p))for(const o of p)t.push([M.default.Error,o]);return t}e.$sp=l;function E(i,n,r,c,d){return c||typeof r.main>"u"&&typeof r.browser>"u"?!0:s(i,n,r.engines.vscode,d)}e.$tp=E;function g(i,n,r){return i==="*"||s(n,r,i)}e.$up=g;function s(i,n,r,c=[]){const d=O(k(r));if(!d)return c.push(P.localize(14,null,r)),!1;if(d.majorBase===0){if(!d.majorMustEqual||!d.minorMustEqual)return c.push(P.localize(15,null,r)),!1}else if(!d.majorMustEqual)return c.push(P.localize(16,null,r)),!1;return D(i,n,d)?!0:(c.push(P.localize(17,null,i,r)),!1)}function a(i){if(!Array.isArray(i))return!1;for(let n=0,r=i.length;n<r;n++)if(typeof i[n]!="string")return!1;return!0}}),define(Pe[70],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ci=void 0;class S{constructor(P,F=[],R=!1){this.ctor=P,this.staticArguments=F,this.supportsDelayedInstantiation=R}}e.$ci=S}),define(Pe[54],Re([1,0,70]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bs=e.$as=e.InstantiationType=void 0;const M=[];var P;(function(m){m[m.Eager=0]="Eager",m[m.Delayed=1]="Delayed"})(P||(e.InstantiationType=P={}));function F(m,f,k){f instanceof S.$ci||(f=new S.$ci(f,[],!!k)),M.push([m,f])}e.$as=F;function R(){return M}e.$bs=R}),define(Pe[186],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=e.$Qq=void 0;class S{constructor(F,R){this.key=F,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$Qq=S;class M{constructor(F){this.b=F,this.a=new Map}roots(){const F=[];for(const R of this.a.values())R.outgoing.size===0&&F.push(R);return F}insertEdge(F,R){const m=this.lookupOrInsertNode(F),f=this.lookupOrInsertNode(R);m.outgoing.set(f.key,f),f.incoming.set(m.key,m)}removeNode(F){const R=this.b(F);this.a.delete(R);for(const m of this.a.values())m.outgoing.delete(R),m.incoming.delete(R)}lookupOrInsertNode(F){const R=this.b(F);let m=this.a.get(R);return m||(m=new S(R,F),this.a.set(R,m)),m}lookup(F){return this.a.get(this.b(F))}isEmpty(){return this.a.size===0}toString(){const F=[];for(const[R,m]of this.a)F.push(`${R}
	(-> incoming)[${[...m.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...m.outgoing.keys()].join(",")}]
`);return F.join(`
`)}findCycleSlow(){for(const[F,R]of this.a){const m=new Set([F]),f=this.c(R,m);if(f)return f}}c(F,R){for(const[m,f]of F.outgoing){if(R.has(m))return[...R,m].join(" -> ");R.add(m);const k=this.c(f,R);if(k)return k;R.delete(m)}}}e.$Rq=M}),define(Pe[3],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gi=e.$fi=e.$ei=e._util=void 0;var S;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function m(f){return f[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=m})(S||(e._util=S={})),e.$ei=P("instantiationService");function M(R,m,f){m[S.DI_TARGET]===m?m[S.DI_DEPENDENCIES].push({id:R,index:f}):(m[S.DI_DEPENDENCIES]=[{id:R,index:f}],m[S.DI_TARGET]=m)}function P(R){if(S.serviceIds.has(R))return S.serviceIds.get(R);const m=function(f,k,O){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(m,f,O)};return m.toString=()=>R,S.serviceIds.set(R,m),m}e.$fi=P;function F(R){return R}e.$gi=F}),define(Pe[46],Re([1,0,16,2,3]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.ConfigurationTarget=e.$Ni=e.$Mi=e.$Li=void 0,e.$Li=(0,P.$fi)("configurationService");function F(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof M.URI)}e.$Mi=F;function R(i){return i&&typeof i=="object"&&(!i.overrideIdentifiers||Array.isArray(i.overrideIdentifiers))&&!i.overrideIdentifier&&(!i.resource||i.resource instanceof M.URI)}e.$Ni=R;var m;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.USER=2]="USER",i[i.USER_LOCAL=3]="USER_LOCAL",i[i.USER_REMOTE=4]="USER_REMOTE",i[i.WORKSPACE=5]="WORKSPACE",i[i.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",i[i.DEFAULT=7]="DEFAULT",i[i.MEMORY=8]="MEMORY"})(m||(e.ConfigurationTarget=m={}));function f(i){switch(i){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Oi=f;function k(i){return i.applicationValue!==void 0||i.userValue!==void 0||i.userLocalValue!==void 0||i.userRemoteValue!==void 0||i.workspaceValue!==void 0||i.workspaceFolderValue!==void 0}e.$Pi=k;function O(i,n){const r=Object.create(null);for(const c in i)D(r,c,i[c],n);return r}e.$Qi=O;function D(i,n,r,c){const d=n.split("."),t=d.pop();let p=i;for(let u=0;u<d.length;u++){const o=d[u];let v=p[o];switch(typeof v){case"undefined":v=p[o]=Object.create(null);break;case"object":break;default:c(`Ignoring ${n} as ${d.slice(0,u+1).join(".")} is ${JSON.stringify(v)}`);return}p=v}if(typeof p=="object"&&p!==null)try{p[t]=r}catch{c(`Ignoring ${n} as ${d.join(".")} is ${JSON.stringify(p)}`)}else c(`Ignoring ${n} as ${d.join(".")} is ${JSON.stringify(p)}`)}e.$Ri=D;function l(i,n){const r=n.split(".");E(i,r)}e.$Si=l;function E(i,n){const r=n.shift();if(n.length===0){delete i[r];return}if(Object.keys(i).indexOf(r)!==-1){const c=i[r];typeof c=="object"&&!Array.isArray(c)&&(E(c,n),Object.keys(c).length===0&&delete i[r])}}function g(i,n,r){function c(p,u){let o=p;for(const v of u){if(typeof o!="object"||o===null)return;o=o[v]}return o}const d=n.split("."),t=c(i,d);return typeof t>"u"?r:t}e.$Ti=g;function s(i,n,r){Object.keys(n).forEach(c=>{c!=="__proto__"&&(c in i?S.$Uf(i[c])&&S.$Uf(n[c])?s(i[c],n[c],r):r&&(i[c]=n[c]):i[c]=n[c])})}e.$Ui=s;function a(i){return i.replace(/[\[\]]/g,"")}e.$Vi=a}),define(Pe[35],Re([1,0,21,15,184,3,152,14]),function(me,e,S,M,P,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.ContextKeyExprType=e.$bj=void 0;const f=new Map;f.set("false",!1),f.set("true",!0),f.set("isMac",S.$j),f.set("isLinux",S.$k),f.set("isWindows",S.$i),f.set("isWeb",S.$o),f.set("isMacNative",S.$j&&!S.$o),f.set("isEdge",S.$H),f.set("isFirefox",S.$F),f.set("isChrome",S.$E),f.set("isSafari",S.$G);function k(le,W){if(f.get(le)!==void 0)throw(0,m.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");f.set(le,W)}e.$bj=k;const O=Object.prototype.hasOwnProperty;var D;(function(le){le[le.False=0]="False",le[le.True=1]="True",le[le.Defined=2]="Defined",le[le.Not=3]="Not",le[le.Equals=4]="Equals",le[le.NotEquals=5]="NotEquals",le[le.And=6]="And",le[le.Regex=7]="Regex",le[le.NotRegex=8]="NotRegex",le[le.Or=9]="Or",le[le.In=10]="In",le[le.NotIn=11]="NotIn",le[le.Greater=12]="Greater",le[le.GreaterEquals=13]="GreaterEquals",le[le.Smaller=14]="Smaller",le[le.SmallerEquals=15]="SmallerEquals"})(D||(e.ContextKeyExprType=D={}));const l={regexParsingWithErrorRecovery:!0},E=(0,R.localize)(0,null),g=(0,R.localize)(1,null),s=(0,R.localize)(2,null),a=(0,R.localize)(3,null),i=(0,R.localize)(4,null),n=(0,R.localize)(5,null),r=(0,R.localize)(6,null),c=(0,R.localize)(7,null);class d{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(W=l){this.k=W,this.d=new P.$aj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(W){if(W===""){this.h.push({message:E,offset:0,lexeme:"",additionalInfo:g});return}this.f=this.d.reset(W).scan(),this.g=0,this.h=[];try{const _=this.l();if(!this.E()){const ke=this.D(),Ne=ke.type===17?n:void 0;throw this.h.push({message:i,offset:ke.offset,lexeme:P.$aj.getLexeme(ke),additionalInfo:Ne}),d.c}return _}catch(_){if(_!==d.c)throw _;return}}l(){return this.m()}m(){const W=[this.o()];for(;this.y(16);){const _=this.o();W.push(_)}return W.length===1?W[0]:t.or(...W)}o(){const W=[this.s()];for(;this.y(15);){const _=this.s();W.push(_)}return W.length===1?W[0]:t.and(...W)}s(){if(this.y(2)){const W=this.D();switch(W.type){case 11:return this.z(),v.INSTANCE;case 12:return this.z(),b.INSTANCE;case 0:{this.z();const _=this.l();return this.A(1,a),_?.negate()}case 17:return this.z(),A.create(W.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",W)}}return this.t()}t(){const W=this.D();switch(W.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const _=this.l();return this.A(1,a),_}case 17:{const _=W.lexeme;if(this.z(),this.y(9)){const Ne=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Ne.type!==10)throw this.B("REGEX",Ne);const De=Ne.lexeme,be=De.lastIndexOf("/"),ge=be===De.length-1?void 0:this.w(De.substring(be+1));let J;try{J=new RegExp(De.substring(1,be),ge)}catch{throw this.B("REGEX",Ne)}return L.create(_,J)}switch(Ne.type){case 10:case 19:{const De=[Ne.lexeme];this.z();let be=this.D(),ge=0;for(let Fe=0;Fe<Ne.lexeme.length;Fe++)Ne.lexeme.charCodeAt(Fe)===40?ge++:Ne.lexeme.charCodeAt(Fe)===41&&ge--;for(;!this.E()&&be.type!==15&&be.type!==16;){switch(be.type){case 0:ge++;break;case 1:ge--;break;case 10:case 18:for(let Fe=0;Fe<be.lexeme.length;Fe++)be.lexeme.charCodeAt(Fe)===40?ge++:Ne.lexeme.charCodeAt(Fe)===41&&ge--}if(ge<0)break;De.push(P.$aj.getLexeme(be)),this.z(),be=this.D()}const J=De.join(""),X=J.lastIndexOf("/"),he=X===J.length-1?void 0:this.w(J.substring(X+1));let fe;try{fe=new RegExp(J.substring(1,X),he)}catch{throw this.B("REGEX",Ne)}return t.regex(_,fe)}case 18:{const De=Ne.lexeme;this.z();let be=null;if(!(0,M.$Se)(De)){const ge=De.indexOf("/"),J=De.lastIndexOf("/");if(ge!==J&&ge>=0){const X=De.slice(ge+1,J),he=De[J+1]==="i"?"i":"";try{be=new RegExp(X,he)}catch{throw this.B("REGEX",Ne)}}}if(be===null)throw this.B("REGEX",Ne);return L.create(_,be)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,s);const Ne=this.u();return t.notIn(_,Ne)}switch(this.D().type){case 3:{this.z();const Ne=this.u();if(this.x().type===18)return t.equals(_,Ne);switch(Ne){case"true":return t.has(_);case"false":return t.not(_);default:return t.equals(_,Ne)}}case 4:{this.z();const Ne=this.u();if(this.x().type===18)return t.notEquals(_,Ne);switch(Ne){case"true":return t.not(_);case"false":return t.has(_);default:return t.notEquals(_,Ne)}}case 5:return this.z(),U.create(_,this.u());case 6:return this.z(),C.create(_,this.u());case 7:return this.z(),G.create(_,this.u());case 8:return this.z(),V.create(_,this.u());case 13:return this.z(),t.in(_,this.u());default:return t.has(_)}}case 20:throw this.h.push({message:r,offset:W.offset,lexeme:"",additionalInfo:c}),d.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const W=this.D();switch(W.type){case 17:case 18:return this.z(),W.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(W){return W.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(W){return this.C(W)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(W,_){if(this.C(W))return this.z();throw this.B(_,this.D())}B(W,_,ke){const Ne=(0,R.localize)(8,null,W,P.$aj.getLexeme(_)),De=_.offset,be=P.$aj.getLexeme(_);return this.h.push({message:Ne,offset:De,lexeme:be,additionalInfo:ke}),d.c}C(W){return this.D().type===W}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$cj=d;class t{static false(){return v.INSTANCE}static true(){return b.INSTANCE}static has(W){return $.create(W)}static equals(W,_){return I.create(W,_)}static notEquals(W,_){return w.create(W,_)}static regex(W,_){return L.create(W,_)}static in(W,_){return h.create(W,_)}static notIn(W,_){return y.create(W,_)}static not(W){return A.create(W)}static and(...W){return ae.create(W,null,!0)}static or(...W){return ye.create(W,null,!0)}static greater(W,_){return G.create(W,_)}static greaterEquals(W,_){return V.create(W,_)}static smaller(W,_){return U.create(W,_)}static smallerEquals(W,_){return C.create(W,_)}static{this.c=new d({regexParsingWithErrorRecovery:!1})}static deserialize(W){return W==null?void 0:this.c.parse(W)}}e.$dj=t;function p(le){const W=new d({regexParsingWithErrorRecovery:!1});return le.map(_=>(W.parse(_),W.lexingErrors.length>0?W.lexingErrors.map(ke=>({errorMessage:ke.additionalInfo?(0,R.localize)(9,null,ke.additionalInfo):(0,R.localize)(10,null),offset:ke.offset,length:ke.lexeme.length})):W.parsingErrors.length>0?W.parsingErrors.map(ke=>({errorMessage:ke.additionalInfo?`${ke.message}. ${ke.additionalInfo}`:ke.message,offset:ke.offset,length:ke.lexeme.length})):[]))}e.$ej=p;function u(le,W){const _=le?le.substituteConstants():void 0,ke=W?W.substituteConstants():void 0;return!_&&!ke?!0:!_||!ke?!1:_.equals(ke)}e.$fj=u;function o(le,W){return le.cmp(W)}class v{static{this.INSTANCE=new v}constructor(){this.type=0}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!1}serialize(){return"false"}keys(){return[]}map(W){return this}negate(){return b.INSTANCE}}e.$gj=v;class b{static{this.INSTANCE=new b}constructor(){this.type=1}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!0}serialize(){return"true"}keys(){return[]}map(W){return this}negate(){return v.INSTANCE}}e.$hj=b;class ${static create(W,_=null){const ke=f.get(W);return typeof ke=="boolean"?ke?b.INSTANCE:v.INSTANCE:new $(W,_)}constructor(W,_){this.key=W,this.c=_,this.type=2}cmp(W){return W.type!==this.type?this.type-W.type:ue(this.key,W.key)}equals(W){return W.type===this.type?this.key===W.key:!1}substituteConstants(){const W=f.get(this.key);return typeof W=="boolean"?W?b.INSTANCE:v.INSTANCE:this}evaluate(W){return!!W.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(W){return W.mapDefined(this.key)}negate(){return this.c||(this.c=A.create(this.key,this)),this.c}}e.$ij=$;class I{static create(W,_,ke=null){if(typeof _=="boolean")return _?$.create(W,ke):A.create(W,ke);const Ne=f.get(W);return typeof Ne=="boolean"?_===(Ne?"true":"false")?b.INSTANCE:v.INSTANCE:new I(W,_,ke)}constructor(W,_,ke){this.c=W,this.d=_,this.f=ke,this.type=4}cmp(W){return W.type!==this.type?this.type-W.type:ve(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){const W=f.get(this.c);if(typeof W=="boolean"){const _=W?"true":"false";return this.d===_?b.INSTANCE:v.INSTANCE}return this}evaluate(W){return W.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(W){return W.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=w.create(this.c,this.d,this)),this.f}}e.$jj=I;class h{static create(W,_){return new h(W,_)}constructor(W,_){this.d=W,this.f=_,this.type=10,this.c=null}cmp(W){return W.type!==this.type?this.type-W.type:ve(this.d,this.f,W.d,W.f)}equals(W){return W.type===this.type?this.d===W.d&&this.f===W.f:!1}substituteConstants(){return this}evaluate(W){const _=W.getValue(this.f),ke=W.getValue(this.d);return Array.isArray(_)?_.includes(ke):typeof ke=="string"&&typeof _=="object"&&_!==null?O.call(_,ke):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(W){return W.mapIn(this.d,this.f)}negate(){return this.c||(this.c=y.create(this.d,this.f)),this.c}}e.$kj=h;class y{static create(W,_){return new y(W,_)}constructor(W,_){this.d=W,this.f=_,this.type=11,this.c=h.create(W,_)}cmp(W){return W.type!==this.type?this.type-W.type:this.c.cmp(W.c)}equals(W){return W.type===this.type?this.c.equals(W.c):!1}substituteConstants(){return this}evaluate(W){return!this.c.evaluate(W)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(W){return W.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$lj=y;class w{static create(W,_,ke=null){if(typeof _=="boolean")return _?A.create(W,ke):$.create(W,ke);const Ne=f.get(W);return typeof Ne=="boolean"?_===(Ne?"true":"false")?v.INSTANCE:b.INSTANCE:new w(W,_,ke)}constructor(W,_,ke){this.c=W,this.d=_,this.f=ke,this.type=5}cmp(W){return W.type!==this.type?this.type-W.type:ve(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){const W=f.get(this.c);if(typeof W=="boolean"){const _=W?"true":"false";return this.d===_?v.INSTANCE:b.INSTANCE}return this}evaluate(W){return W.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(W){return W.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$mj=w;class A{static create(W,_=null){const ke=f.get(W);return typeof ke=="boolean"?ke?v.INSTANCE:b.INSTANCE:new A(W,_)}constructor(W,_){this.c=W,this.d=_,this.type=3}cmp(W){return W.type!==this.type?this.type-W.type:ue(this.c,W.c)}equals(W){return W.type===this.type?this.c===W.c:!1}substituteConstants(){const W=f.get(this.c);return typeof W=="boolean"?W?v.INSTANCE:b.INSTANCE:this}evaluate(W){return!W.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(W){return W.mapNot(this.c)}negate(){return this.d||(this.d=$.create(this.c,this)),this.d}}e.$nj=A;function N(le,W){if(typeof le=="string"){const _=parseFloat(le);isNaN(_)||(le=_)}return typeof le=="string"||typeof le=="number"?W(le):v.INSTANCE}class G{static create(W,_,ke=null){return N(_,Ne=>new G(W,Ne,ke))}constructor(W,_,ke){this.c=W,this.d=_,this.f=ke,this.type=12}cmp(W){return W.type!==this.type?this.type-W.type:ve(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(W){return W.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$oj=G;class V{static create(W,_,ke=null){return N(_,Ne=>new V(W,Ne,ke))}constructor(W,_,ke){this.c=W,this.d=_,this.f=ke,this.type=13}cmp(W){return W.type!==this.type?this.type-W.type:ve(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(W){return W.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$pj=V;class U{static create(W,_,ke=null){return N(_,Ne=>new U(W,Ne,ke))}constructor(W,_,ke){this.c=W,this.d=_,this.f=ke,this.type=14}cmp(W){return W.type!==this.type?this.type-W.type:ve(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(W){return W.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$qj=U;class C{static create(W,_,ke=null){return N(_,Ne=>new C(W,Ne,ke))}constructor(W,_,ke){this.c=W,this.d=_,this.f=ke,this.type=15}cmp(W){return W.type!==this.type?this.type-W.type:ve(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(W){return W.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=G.create(this.c,this.d,this)),this.f}}e.$rj=C;class L{static create(W,_){return new L(W,_)}constructor(W,_){this.d=W,this.f=_,this.type=7,this.c=null}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.d<W.d)return-1;if(this.d>W.d)return 1;const _=this.f?this.f.source:"",ke=W.f?W.f.source:"";return _<ke?-1:_>ke?1:0}equals(W){if(W.type===this.type){const _=this.f?this.f.source:"",ke=W.f?W.f.source:"";return this.d===W.d&&_===ke}return!1}substituteConstants(){return this}evaluate(W){const _=W.getValue(this.d);return this.f?this.f.test(_):!1}serialize(){const W=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${W}`}keys(){return[this.d]}map(W){return W.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=q.create(this)),this.c}}e.$sj=L;class q{static create(W){return new q(W)}constructor(W){this.c=W,this.type=8}cmp(W){return W.type!==this.type?this.type-W.type:this.c.cmp(W.c)}equals(W){return W.type===this.type?this.c.equals(W.c):!1}substituteConstants(){return this}evaluate(W){return!this.c.evaluate(W)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(W){return new q(this.c.map(W))}negate(){return this.c}}e.$tj=q;function ne(le){let W=null;for(let _=0,ke=le.length;_<ke;_++){const Ne=le[_].substituteConstants();if(le[_]!==Ne&&W===null){W=[];for(let De=0;De<_;De++)W[De]=le[De]}W!==null&&(W[_]=Ne)}return W===null?le:W}class ae{static create(W,_,ke){return ae.d(W,_,ke)}constructor(W,_){this.expr=W,this.c=_,this.type=6}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let _=0,ke=this.expr.length;_<ke;_++){const Ne=o(this.expr[_],W.expr[_]);if(Ne!==0)return Ne}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let _=0,ke=this.expr.length;_<ke;_++)if(!this.expr[_].equals(W.expr[_]))return!1;return!0}return!1}substituteConstants(){const W=ne(this.expr);return W===this.expr?this:ae.create(W,this.c,!1)}evaluate(W){for(let _=0,ke=this.expr.length;_<ke;_++)if(!this.expr[_].evaluate(W))return!1;return!0}static d(W,_,ke){const Ne=[];let De=!1;for(const be of W)if(be){if(be.type===1){De=!0;continue}if(be.type===0)return v.INSTANCE;if(be.type===6){Ne.push(...be.expr);continue}Ne.push(be)}if(Ne.length===0&&De)return b.INSTANCE;if(Ne.length!==0){if(Ne.length===1)return Ne[0];Ne.sort(o);for(let be=1;be<Ne.length;be++)Ne[be-1].equals(Ne[be])&&(Ne.splice(be,1),be--);if(Ne.length===1)return Ne[0];for(;Ne.length>1;){const be=Ne[Ne.length-1];if(be.type!==9)break;Ne.pop();const ge=Ne.pop(),J=Ne.length===0,X=ye.create(be.expr.map(he=>ae.create([he,ge],null,ke)),null,J);X&&(Ne.push(X),Ne.sort(o))}if(Ne.length===1)return Ne[0];if(ke){for(let be=0;be<Ne.length;be++)for(let ge=be+1;ge<Ne.length;ge++)if(Ne[be].negate().equals(Ne[ge]))return v.INSTANCE;if(Ne.length===1)return Ne[0]}return new ae(Ne,_)}}serialize(){return this.expr.map(W=>W.serialize()).join(" && ")}keys(){const W=[];for(const _ of this.expr)W.push(..._.keys());return W}map(W){return new ae(this.expr.map(_=>_.map(W)),null)}negate(){if(!this.c){const W=[];for(const _ of this.expr)W.push(_.negate());this.c=ye.create(W,this,!0)}return this.c}}e.$uj=ae;class ye{static create(W,_,ke){return ye.d(W,_,ke)}constructor(W,_){this.expr=W,this.c=_,this.type=9}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let _=0,ke=this.expr.length;_<ke;_++){const Ne=o(this.expr[_],W.expr[_]);if(Ne!==0)return Ne}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let _=0,ke=this.expr.length;_<ke;_++)if(!this.expr[_].equals(W.expr[_]))return!1;return!0}return!1}substituteConstants(){const W=ne(this.expr);return W===this.expr?this:ye.create(W,this.c,!1)}evaluate(W){for(let _=0,ke=this.expr.length;_<ke;_++)if(this.expr[_].evaluate(W))return!0;return!1}static d(W,_,ke){let Ne=[],De=!1;if(W){for(let be=0,ge=W.length;be<ge;be++){const J=W[be];if(J){if(J.type===0){De=!0;continue}if(J.type===1)return b.INSTANCE;if(J.type===9){Ne=Ne.concat(J.expr);continue}Ne.push(J)}}if(Ne.length===0&&De)return v.INSTANCE;Ne.sort(o)}if(Ne.length!==0){if(Ne.length===1)return Ne[0];for(let be=1;be<Ne.length;be++)Ne[be-1].equals(Ne[be])&&(Ne.splice(be,1),be--);if(Ne.length===1)return Ne[0];if(ke){for(let be=0;be<Ne.length;be++)for(let ge=be+1;ge<Ne.length;ge++)if(Ne[be].negate().equals(Ne[ge]))return b.INSTANCE;if(Ne.length===1)return Ne[0]}return new ye(Ne,_)}}serialize(){return this.expr.map(W=>W.serialize()).join(" || ")}keys(){const W=[];for(const _ of this.expr)W.push(..._.keys());return W}map(W){return new ye(this.expr.map(_=>_.map(W)),null)}negate(){if(!this.c){const W=[];for(const _ of this.expr)W.push(_.negate());for(;W.length>1;){const _=W.shift(),ke=W.shift(),Ne=[];for(const De of ie(_))for(const be of ie(ke))Ne.push(ae.create([De,be],null,!1));W.unshift(ye.create(Ne,null,!1))}this.c=ye.create(W,this,!0)}return this.c}}e.$vj=ye;class Ie extends ${static{this.d=[]}static all(){return Ie.d.values()}constructor(W,_,ke){super(W,null),this.f=_,typeof ke=="object"?Ie.d.push({...ke,key:W}):ke!==!0&&Ie.d.push({key:W,description:ke,type:_!=null?typeof _:void 0})}bindTo(W){return W.createKey(this.key,this.f)}getValue(W){return W.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(W){return I.create(this.key,W)}notEqualsTo(W){return w.create(this.key,W)}}e.$wj=Ie,e.$xj=(0,F.$fi)("contextKeyService");function ue(le,W){return le<W?-1:le>W?1:0}function ve(le,W,_,ke){return le<_?-1:le>_?1:W<ke?-1:W>ke?1:0}function re(le,W){if(le.type===0||W.type===1)return!0;if(le.type===9)return W.type===9?$e(le.expr,W.expr):!1;if(W.type===9){for(const _ of W.expr)if(re(le,_))return!0;return!1}if(le.type===6){if(W.type===6)return $e(W.expr,le.expr);for(const _ of le.expr)if(re(_,W))return!0;return!1}return le.equals(W)}e.$yj=re;function $e(le,W){let _=0,ke=0;for(;_<le.length&&ke<W.length;){const Ne=le[_].cmp(W[ke]);if(Ne<0)return!1;Ne===0&&_++,ke++}return _===le.length}function ie(le){return le.type===9?le.expr:[le]}}),define(Pe[187],Re([1,0,3]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ni=e.$mi=void 0,e.$mi=(0,S.$fi)("environmentService"),e.$ni=(0,S.$gi)(e.$mi)}),define(Pe[98],Re([1,0,154,3]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.ExtensionGalleryErrorCode=e.$Oo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$No=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=void 0,e.$Bo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Co=new RegExp(e.$Bo),e.$Do="__web_extension",e.$Eo="skipWalkthrough",e.$Fo="extensionsSync",e.$Go="dependecyOrPackExtensionInstall";function P(r){switch(r){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Ho=P;function F(r){switch(r){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Io=F;function R(r,c){switch(r){case 3:return c==="x64"?"win32-x64":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Jo=R;function m(r,c){return c==="web"&&!r.includes("web")}e.$Ko=m;function f(r,c,d){return m(c,d)?!1:r==="undefined"||r==="universal"?!0:r==="unknown"?!1:r===d}e.$Lo=f;function k(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(!r.uuid||typeof r.uuid=="string")}e.$Mo=k;var O;(function(r){r[r.NoneOrRelevance=0]="NoneOrRelevance",r[r.LastUpdatedDate=1]="LastUpdatedDate",r[r.Title=2]="Title",r[r.PublisherName=3]="PublisherName",r[r.InstallCount=4]="InstallCount",r[r.PublishedDate=10]="PublishedDate",r[r.AverageRating=6]="AverageRating",r[r.WeightedRating=12]="WeightedRating"})(O||(e.SortBy=O={}));var D;(function(r){r[r.Default=0]="Default",r[r.Ascending=1]="Ascending",r[r.Descending=2]="Descending"})(D||(e.SortOrder=D={}));var l;(function(r){r.Install="install",r.Uninstall="uninstall"})(l||(e.StatisticType=l={}));var E;(function(r){r[r.None=1]="None",r[r.Install=2]="Install",r[r.Update=3]="Update",r[r.Migrate=4]="Migrate"})(E||(e.InstallOperation=E={})),e.$No=(0,M.$fi)("extensionGalleryService");var g;(function(r){r.Unsupported="Unsupported",r.Deprecated="Deprecated",r.Malicious="Malicious",r.Incompatible="Incompatible",r.IncompatibleTargetPlatform="IncompatibleTargetPlatform",r.ReleaseVersionNotFound="ReleaseVersionNotFound",r.Invalid="Invalid",r.Download="Download",r.DownloadSignature="DownloadSignature",r.UpdateMetadata="UpdateMetadata",r.Extract="Extract",r.Scanning="Scanning",r.Delete="Delete",r.Rename="Rename",r.CorruptZip="CorruptZip",r.IncompleteZip="IncompleteZip",r.Signature="Signature",r.NotAllowed="NotAllowed",r.Gallery="Gallery",r.Unknown="Unknown",r.Internal="Internal"})(g||(e.ExtensionManagementErrorCode=g={}));var s;(function(r){r.UnknownError="UnknownError",r.PackageIsInvalidZip="PackageIsInvalidZip",r.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(s||(e.ExtensionSignaturetErrorCode=s={}));class a extends Error{constructor(c,d){super(c),this.code=d,this.name=d}}e.$Oo=a;var i;(function(r){r.Timeout="Timeout",r.Cancelled="Cancelled",r.Failed="Failed"})(i||(e.ExtensionGalleryErrorCode=i={}));class n extends Error{constructor(c,d){super(c),this.code=d,this.name=d}}e.$Po=n,e.$Qo=(0,M.$fi)("extensionManagementService"),e.$Ro="extensionsIdentifiers/disabled",e.$So="extensionsIdentifiers/enabled",e.$To=(0,M.$fi)("IGlobalExtensionEnablementService"),e.$Uo=(0,M.$fi)("IExtensionTipsService"),e.$Vo=(0,S.localize2)(0,"Extensions"),e.$Wo=(0,S.localize2)(1,"Preferences")}),define(Pe[42],Re([1,0,50,19,15,16,2,156,3,21,12,39]),function(me,e,S,M,P,F,R,m,f,k,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cl=e.$bl=e.$al=e.$_k=e.$$k=e.FileKind=e.$0k=e.$9k=e.$8k=e.$7k=e.$6k=e.$5k=e.$4k=e.FileOperationResult=e.$3k=e.$2k=e.$1k=e.$Zk=e.$Yk=e.FileChangeType=e.$Xk=e.FileOperation=e.$Wk=e.$Vk=e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.FileSystemProviderErrorCode=e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.$Ik=e.FileSystemProviderCapabilities=e.$Hk=e.FilePermission=e.FileType=e.$Gk=e.$Fk=void 0,e.$Fk=(0,f.$fi)("fileService");function l(re){return re.create===!0}e.$Gk=l;var E;(function(re){re[re.Unknown=0]="Unknown",re[re.File=1]="File",re[re.Directory=2]="Directory",re[re.SymbolicLink=64]="SymbolicLink"})(E||(e.FileType=E={}));var g;(function(re){re[re.Readonly=1]="Readonly",re[re.Locked=2]="Locked"})(g||(e.FilePermission=g={}));function s(re){const $e=re;return!!$e&&typeof $e.onDidChange=="function"}e.$Hk=s;var a;(function(re){re[re.None=0]="None",re[re.FileReadWrite=2]="FileReadWrite",re[re.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",re[re.FileReadStream=16]="FileReadStream",re[re.FileFolderCopy=8]="FileFolderCopy",re[re.PathCaseSensitive=1024]="PathCaseSensitive",re[re.Readonly=2048]="Readonly",re[re.Trash=4096]="Trash",re[re.FileWriteUnlock=8192]="FileWriteUnlock",re[re.FileAtomicRead=16384]="FileAtomicRead",re[re.FileAtomicWrite=32768]="FileAtomicWrite",re[re.FileAtomicDelete=65536]="FileAtomicDelete",re[re.FileClone=131072]="FileClone"})(a||(e.FileSystemProviderCapabilities=a={}));function i(re){return!!(re.capabilities&2)}e.$Ik=i;function n(re){return!!(re.capabilities&8)}e.$Jk=n;function r(re){return!!(re.capabilities&131072)}e.$Kk=r;function c(re){return!!(re.capabilities&4)}e.$Lk=c;function d(re){return!!(re.capabilities&16)}e.$Mk=d;function t(re){return i(re)?!!(re.capabilities&16384):!1}e.$Nk=t;function p(re){return i(re)?!!(re.capabilities&32768):!1}e.$Ok=p;function u(re){return!!(re.capabilities&65536)}e.$Pk=u;function o(re){return!!(re.capabilities&2048)}e.$Qk=o;var v;(function(re){re.FileExists="EntryExists",re.FileNotFound="EntryNotFound",re.FileNotADirectory="EntryNotADirectory",re.FileIsADirectory="EntryIsADirectory",re.FileExceedsStorageQuota="EntryExceedsStorageQuota",re.FileTooLarge="EntryTooLarge",re.FileWriteLocked="EntryWriteLocked",re.NoPermissions="NoPermissions",re.Unavailable="Unavailable",re.Unknown="Unknown"})(v||(e.FileSystemProviderErrorCode=v={}));class b extends Error{static create($e,ie){const le=new b($e.toString(),ie);return h(le,ie),le}constructor($e,ie){super($e),this.code=ie}}e.$Rk=b;function $(re,$e){return b.create(re,$e)}e.$Sk=$;function I(re){return re||$((0,m.localize)(0,null),v.Unknown)}e.$Tk=I;function h(re,$e){return re.name=$e?`${$e} (FileSystemError)`:"FileSystemError",re}e.$Uk=h;function y(re){if(!re)return v.Unknown;if(re instanceof b)return re.code;const $e=/^(.+) \(FileSystemError\)$/.exec(re.name);if(!$e)return v.Unknown;switch($e[1]){case v.FileExists:return v.FileExists;case v.FileIsADirectory:return v.FileIsADirectory;case v.FileNotADirectory:return v.FileNotADirectory;case v.FileNotFound:return v.FileNotFound;case v.FileTooLarge:return v.FileTooLarge;case v.FileWriteLocked:return v.FileWriteLocked;case v.NoPermissions:return v.NoPermissions;case v.Unavailable:return v.Unavailable}return v.Unknown}e.$Vk=y;function w(re){if(re instanceof C)return re.fileOperationResult;switch(y(re)){case v.FileNotFound:return 1;case v.FileIsADirectory:return 0;case v.FileNotADirectory:return 9;case v.FileWriteLocked:return 5;case v.NoPermissions:return 6;case v.FileExists:return 4;case v.FileTooLarge:return 7;default:return 10}}e.$Wk=w;var A;(function(re){re[re.CREATE=0]="CREATE",re[re.DELETE=1]="DELETE",re[re.MOVE=2]="MOVE",re[re.COPY=3]="COPY",re[re.WRITE=4]="WRITE"})(A||(e.FileOperation=A={}));class N{constructor($e,ie,le){this.resource=$e,this.operation=ie,this.target=le}isOperation($e){return this.operation===$e}}e.$Xk=N;var G;(function(re){re[re.UPDATED=0]="UPDATED",re[re.ADDED=1]="ADDED",re[re.DELETED=2]="DELETED"})(G||(e.FileChangeType=G={}));class V{static{this.a=null}constructor($e,ie){this.c=ie,this.b=void 0,this.d=new D.$V(()=>{const le=S.$li.forUris(()=>this.c);return le.fill(this.rawAdded.map(W=>[W,!0])),le}),this.f=new D.$V(()=>{const le=S.$li.forUris(()=>this.c);return le.fill(this.rawUpdated.map(W=>[W,!0])),le}),this.g=new D.$V(()=>{const le=S.$li.forUris(()=>this.c);return le.fill(this.rawDeleted.map(W=>[W,!0])),le}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const le of $e){switch(le.type){case 1:this.rawAdded.push(le.resource);break;case 0:this.rawUpdated.push(le.resource);break;case 2:this.rawDeleted.push(le.resource);break}this.b!==V.a&&(typeof le.cId=="number"?this.b===void 0?this.b=le.cId:this.b!==le.cId&&(this.b=V.a):this.b!==void 0&&(this.b=V.a))}}contains($e,...ie){return this.h($e,{includeChildren:!1},...ie)}affects($e,...ie){return this.h($e,{includeChildren:!0},...ie)}h($e,ie,...le){if(!$e)return!1;const W=le.length>0;return!!((!W||le.includes(1))&&(this.d.value.get($e)||ie.includeChildren&&this.d.value.findSuperstr($e))||(!W||le.includes(0))&&(this.f.value.get($e)||ie.includeChildren&&this.f.value.findSuperstr($e))||(!W||le.includes(2))&&(this.g.value.findSubstr($e)||ie.includeChildren&&this.g.value.findSuperstr($e)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates($e){return this.b===$e}hasCorrelation(){return typeof this.b=="number"}}e.$Yk=V;function U(re,$e,ie){return!re||!$e||re===$e||$e.length>re.length?!1:($e.charAt($e.length-1)!==M.sep&&($e+=M.sep),ie?(0,P.$kf)(re,$e):re.indexOf($e)===0)}e.$Zk=U;class C extends Error{constructor($e,ie,le){super($e),this.fileOperationResult=ie,this.options=le}}e.$1k=C;class L extends C{constructor($e,ie,le,W){super($e,ie,W),this.fileOperationResult=ie,this.size=le}}e.$2k=L;class q extends C{constructor($e,ie,le){super($e,2,le),this.stat=ie}}e.$3k=q;var ne;(function(re){re[re.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",re[re.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",re[re.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",re[re.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",re[re.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",re[re.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",re[re.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",re[re.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",re[re.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",re[re.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",re[re.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ne||(e.FileOperationResult=ne={})),e.$4k={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$5k={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$6k="files.associations",e.$7k="files.exclude",e.$8k="files.readonlyInclude",e.$9k="files.readonlyExclude",e.$0k="files.readonlyFromPermissions";var ae;(function(re){re[re.FILE=0]="FILE",re[re.FOLDER=1]="FOLDER",re[re.ROOT_FOLDER=2]="ROOT_FOLDER"})(ae||(e.FileKind=ae={})),e.$$k="";function ye(re){if(!(typeof re.size!="number"||typeof re.mtime!="number"))return re.mtime.toString(29)+re.size.toString(31)}e.$_k=ye;async function Ie(re,$e){if(!$e.hasProvider(R.URI.from({scheme:re.scheme})))return new Promise(ie=>{const le=$e.onDidChangeFileSystemProviderRegistrations(W=>{W.scheme===re.scheme&&W.added&&(le.dispose(),ie())})})}e.$al=Ie;class ue{static{this.KB=1024}static{this.MB=ue.KB*ue.KB}static{this.GB=ue.MB*ue.KB}static{this.TB=ue.GB*ue.KB}static formatSize($e){return(0,F.$Wf)($e)||($e=0),$e<ue.KB?(0,m.localize)(1,null,$e.toFixed(0)):$e<ue.MB?(0,m.localize)(2,null,($e/ue.KB).toFixed(2)):$e<ue.GB?(0,m.localize)(3,null,($e/ue.MB).toFixed(2)):$e<ue.TB?(0,m.localize)(4,null,($e/ue.GB).toFixed(2)):(0,m.localize)(5,null,($e/ue.TB).toFixed(2))}}e.$bl=ue;function ve(re){const $e=typeof re=="string"||re?.scheme===O.Schemas.vscodeRemote;return typeof re!="string"&&re?.scheme===O.Schemas.file?1024*ue.MB:$e?10*ue.MB:k.$o?50*ue.MB:1024*ue.MB}e.$cl=ve}),define(Pe[71],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$di=void 0;class S{constructor(...P){this.a=new Map;for(const[F,R]of P)this.set(F,R)}set(P,F){const R=this.a.get(P);return this.a.set(P,F),R}has(P){return this.a.has(P)}get(P){return this.a.get(P)}}e.$di=S}),define(Pe[188],Re([1,0,11,14,6,70,186,3,71,189]),function(me,e,S,M,P,F,R,m,f,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=e.$Sq=void 0;const O=!1;class D extends Error{constructor(a){super("cyclic dependency between services"),this.message=a.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class l{constructor(a=new f.$di,i=!1,n,r=O){this.f=a,this.g=i,this.h=n,this.i=r,this.o=new Set,this.f.set(m.$ei,this),this._globalGraph=r?n?._globalGraph??new R.$Rq(c=>c):void 0}createChild(a){return new l(a,this.g,this,this.i)}invokeFunction(a,...i){const n=g.traceInvocation(this.i,a);let r=!1;try{return a({get:d=>{if(r)throw(0,M.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(d,n);if(!t)throw new Error(`[invokeFunction] unknown service '${d}'`);return t}},...i)}finally{r=!0,n.stop()}}createInstance(a,...i){let n,r;return a instanceof F.$ci?(n=g.traceCreation(this.i,a.ctor),r=this.j(a.ctor,a.staticArguments.concat(i),n)):(n=g.traceCreation(this.i,a),r=this.j(a,i,n)),n.stop(),r}j(a,i=[],n){const r=m._util.getServiceDependencies(a).sort((t,p)=>t.index-p.index),c=[];for(const t of r){const p=this.m(t.id,n);p||this.u(`[createInstance] ${a.name} depends on UNKNOWN service ${t.id}.`,!1),c.push(p)}const d=r.length>0?r[0].index:i.length;if(i.length!==d){console.trace(`[createInstance] First service dependency of ${a.name} at position ${d+1} conflicts with ${i.length} static arguments`);const t=d-i.length;t>0?i=i.concat(new Array(t)):i=i.slice(0,d)}return Reflect.construct(a,i.concat(c))}k(a,i){if(this.f.get(a)instanceof F.$ci)this.f.set(a,i);else if(this.h)this.h.k(a,i);else throw new Error("illegalState - setting UNKNOWN service instance")}l(a){const i=this.f.get(a);return!i&&this.h?this.h.l(a):i}m(a,i){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(a));const n=this.l(a);return n instanceof F.$ci?this.q(a,n,i.branch(a,!0)):(i.branch(a,!1),n)}q(a,i,n){if(this.o.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this.o.add(a);try{return this.r(a,i,n)}finally{this.o.delete(a)}}r(a,i,n){const r=new R.$Rq(t=>t.id.toString());let c=0;const d=[{id:a,desc:i,_trace:n}];for(;d.length;){const t=d.pop();if(r.lookupOrInsertNode(t),c++>1e3)throw new D(r);for(const p of m._util.getServiceDependencies(t.desc.ctor)){const u=this.l(p.id);if(u||this.u(`[createInstance] ${a} depends on ${p.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(p.id)),u instanceof F.$ci){const o={id:p.id,desc:u,_trace:t._trace.branch(p.id,!0)};r.insertEdge(t,o),d.push(o)}}}for(;;){const t=r.roots();if(t.length===0){if(!r.isEmpty())throw new D(r);break}for(const{data:p}of t){if(this.l(p.id)instanceof F.$ci){const o=this.s(p.id,p.desc.ctor,p.desc.staticArguments,p.desc.supportsDelayedInstantiation,p._trace);this.k(p.id,o)}r.removeNode(p)}}return this.l(a)}s(a,i,n=[],r,c){if(this.f.get(a)instanceof F.$ci)return this.t(a,i,n,r,c);if(this.h)return this.h.s(a,i,n,r,c);throw new Error(`illegalState - creating UNKNOWN service instance ${i.name}`)}t(a,i,n=[],r,c){if(r){const d=new l(void 0,this.g,this,this.i);d.c=String(a);const t=new Map,p=new S.$yh(()=>{const u=d.j(i,n,c);for(const[o,v]of t){const b=u[o];if(typeof b=="function")for(const $ of v)$.disposable=b.apply(u,$.listener)}return t.clear(),u});return new Proxy(Object.create(null),{get(u,o){if(!p.isInitialized&&typeof o=="string"&&(o.startsWith("onDid")||o.startsWith("onWill"))){let $=t.get(o);return $||($=new k.$4c,t.set(o,$)),(h,y,w)=>{if(p.isInitialized)return p.value[o](h,y,w);{const A={listener:[h,y,w],disposable:void 0},N=$.push(A);return(0,P.$Rc)(()=>{N(),A.disposable?.dispose()})}}}if(o in u)return u[o];const v=p.value;let b=v[o];return typeof b!="function"||(b=b.bind(v),u[o]=b),b},set(u,o,v){return p.value[o]=v,!0},getPrototypeOf(u){return i.prototype}})}else return this.j(i,n,c)}u(a,i){if(i&&console.warn(a),this.g)throw new Error(a)}}e.$Sq=l;var E;(function(s){s[s.None=0]="None",s[s.Creation=1]="Creation",s[s.Invocation=2]="Invocation",s[s.Branch=3]="Branch"})(E||(E={}));class g{static{this.all=new Set}static{this.c=new class extends g{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(a,i){return a?new g(2,i.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):g.c}static traceCreation(a,i){return a?new g(1,i.name):g.c}static{this.f=0}constructor(a,i){this.type=a,this.name=i,this.g=Date.now(),this.h=[]}branch(a,i){const n=new g(3,a.toString());return this.h.push([a,i,n]),n}stop(){const a=Date.now()-this.g;g.f+=a;let i=!1;function n(c,d){const t=[],p=new Array(c+1).join("	");for(const[u,o,v]of d.h)if(o&&v){i=!0,t.push(`${p}CREATES -> ${u}`);const b=n(c+1,v);b&&t.push(b)}else t.push(`${p}uses -> ${u}`);return t.join(`
`)}const r=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${g.f.toFixed(2)}ms)`];(a>2||i)&&g.all.add(r.join(`
`))}}e.$Tq=g}),define(Pe[13],Re([1,0,41,5,99,6,28,21,24,16,2,35,3]),function(me,e,S,M,P,F,R,m,f,k,O,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.log=e.$Cj=e.LogLevel=e.$Bj=e.$Aj=e.$zj=void 0,e.$zj=(0,l.$fi)("logService"),e.$Aj=(0,l.$fi)("loggerService");function E(){return new Date().toISOString()}function g(h){return(0,k.$Wf)(h)}e.$Bj=g;var s;(function(h){h[h.Off=0]="Off",h[h.Trace=1]="Trace",h[h.Debug=2]="Debug",h[h.Info=3]="Info",h[h.Warning=4]="Warning",h[h.Error=5]="Error"})(s||(e.LogLevel=s={})),e.$Cj=s.Info;function a(h,y,w){switch(y){case s.Trace:h.trace(w);break;case s.Debug:h.debug(w);break;case s.Info:h.info(w);break;case s.Warning:h.warn(w);break;case s.Error:h.error(w);break;case s.Off:break;default:throw new Error(`Invalid log level ${y}`)}}e.log=a;function i(h,y=!1){let w="";for(let A=0;A<h.length;A++){let N=h[A];if(N instanceof Error&&(N=(0,S.$3i)(N,y)),typeof N=="object")try{N=JSON.stringify(N)}catch{}w+=(A>0?" ":"")+N}return w}class n extends F.$Tc{constructor(){super(...arguments),this.b=e.$Cj,this.c=this.B(new M.$5d),this.onDidChangeLogLevel=this.c.event}setLevel(y){this.b!==y&&(this.b=y,this.c.fire(this.b))}getLevel(){return this.b}f(y){return this.b!==s.Off&&this.b<=y}}e.$Ej=n;class r extends n{constructor(y){super(),this.h=y}f(y){return this.h||super.f(y)}trace(y,...w){this.f(s.Trace)&&this.g(s.Trace,i([y,...w],!0))}debug(y,...w){this.f(s.Debug)&&this.g(s.Debug,i([y,...w]))}info(y,...w){this.f(s.Info)&&this.g(s.Info,i([y,...w]))}warn(y,...w){this.f(s.Warning)&&this.g(s.Warning,i([y,...w]))}error(y,...w){if(this.f(s.Error))if(y instanceof Error){const A=Array.prototype.slice.call(arguments);A[0]=y.stack,this.g(s.Error,i(A))}else this.g(s.Error,i([y,...w]))}flush(){}}e.$Fj=r;class c extends n{constructor(y=e.$Cj){super(),this.setLevel(y),this.g=!m.$i}trace(y,...w){this.f(s.Trace)&&(this.g?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,y,...w):console.log(`[main ${E()}]`,y,...w))}debug(y,...w){this.f(s.Debug)&&(this.g?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,y,...w):console.log(`[main ${E()}]`,y,...w))}info(y,...w){this.f(s.Info)&&(this.g?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,y,...w):console.log(`[main ${E()}]`,y,...w))}warn(y,...w){this.f(s.Warning)&&(this.g?console.warn(`\x1B[93m[main ${E()}]\x1B[0m`,y,...w):console.warn(`[main ${E()}]`,y,...w))}error(y,...w){this.f(s.Error)&&(this.g?console.error(`\x1B[91m[main ${E()}]\x1B[0m`,y,...w):console.error(`[main ${E()}]`,y,...w))}flush(){}}e.$Gj=c;class d extends n{constructor(y=e.$Cj,w=!0){super(),this.g=w,this.setLevel(y)}trace(y,...w){this.f(s.Trace)&&(this.g?console.log("%cTRACE","color: #888",y,...w):console.log(y,...w))}debug(y,...w){this.f(s.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",y,...w):console.log(y,...w))}info(y,...w){this.f(s.Info)&&(this.g?console.log("%c INFO","color: #33f",y,...w):console.log(y,...w))}warn(y,...w){this.f(s.Warning)&&(this.g?console.log("%c WARN","color: #993",y,...w):console.log(y,...w))}error(y,...w){this.f(s.Error)&&(this.g?console.log("%c  ERR","color: #f33",y,...w):console.error(y,...w))}flush(){}}e.$Hj=d;class t extends n{constructor(y,w=e.$Cj){super(),this.g=y,this.setLevel(w)}trace(y,...w){this.f(s.Trace)&&this.g.log(s.Trace,[this.h(y),...w])}debug(y,...w){this.f(s.Debug)&&this.g.log(s.Debug,[this.h(y),...w])}info(y,...w){this.f(s.Info)&&this.g.log(s.Info,[this.h(y),...w])}warn(y,...w){this.f(s.Warning)&&this.g.log(s.Warning,[this.h(y),...w])}error(y,...w){this.f(s.Error)&&this.g.log(s.Error,[this.h(y),...w])}h(y){return typeof y=="string"?y:(0,S.$3i)(y,this.f(s.Trace))}flush(){}}e.$Ij=t;class p extends n{constructor(y){super(),this.g=y,y.length&&this.setLevel(y[0].getLevel())}setLevel(y){for(const w of this.g)w.setLevel(y);super.setLevel(y)}trace(y,...w){for(const A of this.g)A.trace(y,...w)}debug(y,...w){for(const A of this.g)A.debug(y,...w)}info(y,...w){for(const A of this.g)A.info(y,...w)}warn(y,...w){for(const A of this.g)A.warn(y,...w)}error(y,...w){for(const A of this.g)A.error(y,...w)}flush(){for(const y of this.g)y.flush()}dispose(){for(const y of this.g)y.dispose();super.dispose()}}e.$Jj=p;class u extends F.$Tc{constructor(y,w,A){if(super(),this.h=y,this.j=w,this.b=new R.$Ac,this.c=this.B(new M.$5d),this.onDidChangeLoggers=this.c.event,this.f=this.B(new M.$5d),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new M.$5d),this.onDidChangeVisibility=this.g.event,A)for(const N of A)this.b.set(N.resource,{logger:void 0,info:N})}m(y){return(0,k.$Sf)(y)?[...this.b.values()].find(w=>w.info.id===y):this.b.get(y)}getLogger(y){return this.m(y)?.logger}createLogger(y,w){const A=this.n(y),N=(0,k.$Sf)(y)?y:w?.id??(0,P.$6i)(A.toString()).toString(16);let G=this.b.get(A)?.logger;const V=w?.logLevel==="always"?s.Trace:w?.logLevel;G||(G=this.s(A,V??this.getLogLevel(A)??this.h,{...w,id:N}));const U={logger:G,info:{resource:A,id:N,logLevel:V,name:w?.name,hidden:w?.hidden,extensionId:w?.extensionId,when:w?.when}};return this.registerLogger(U.info),this.b.set(A,U),G}n(y){return(0,k.$Sf)(y)?(0,f.$Sg)(this.j,`${y}.log`):y}setLogLevel(y,w){if(O.URI.isUri(y)){const A=y,N=w,G=this.b.get(A);G&&N!==G.info.logLevel&&(G.info.logLevel=N===this.h?void 0:N,G.logger?.setLevel(N),this.b.set(G.info.resource,G),this.f.fire([A,N]))}else{this.h=y;for(const[A,N]of this.b.entries())this.b.get(A)?.info.logLevel===void 0&&N.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(y,w){const A=this.m(y);A&&w!==!A.info.hidden&&(A.info.hidden=!w,this.b.set(A.info.resource,A),this.g.fire([A.info.resource,w]))}getLogLevel(y){let w;return y&&(w=this.b.get(y)?.info.logLevel),w??this.h}registerLogger(y){const w=this.b.get(y.resource);w?w.info.hidden!==y.hidden&&this.setVisibility(y.resource,!y.hidden):(this.b.set(y.resource,{info:y,logger:void 0}),this.c.fire({added:[y],removed:[]}))}deregisterLogger(y){const w=this.b.get(y);w&&(w.logger&&w.logger.dispose(),this.b.delete(y),this.c.fire({added:[],removed:[w.info]}))}*getRegisteredLoggers(){for(const y of this.b.values())yield y.info}getRegisteredLogger(y){return this.b.get(y)?.info}dispose(){this.b.forEach(y=>y.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Kj=u;class o{constructor(){this.onDidChangeLogLevel=new M.$5d().event}setLevel(y){}getLevel(){return s.Info}trace(y,...w){}debug(y,...w){}info(y,...w){}warn(y,...w){}error(y,...w){}critical(y,...w){}dispose(){}flush(){}}e.$Lj=o;class v extends o{}e.$Mj=v;function b(h){if(h.verbose)return s.Trace;if(typeof h.logLevel=="string"){const y=I(h.logLevel.toLowerCase());if(y!==void 0)return y}return e.$Cj}e.$Nj=b;function $(h){switch(h){case s.Trace:return"trace";case s.Debug:return"debug";case s.Info:return"info";case s.Warning:return"warn";case s.Error:return"error";case s.Off:return"off"}}e.$Oj=$;function I(h){switch(h){case"trace":return s.Trace;case"debug":return s.Debug;case"info":return s.Info;case"warn":return s.Warning;case"error":return s.Error;case"critical":return s.Error;case"off":return s.Off}}e.$Pj=I,e.$Qj=new D.$wj("logLevel",$(s.Info))}),define(Pe[190],Re([1,0,6,13]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IP=void 0;class P extends S.$Tc{constructor(R,m=[]){super(),this.a=new M.$Jj([R,...m]),this.B(R.onDidChangeLogLevel(f=>this.setLevel(f)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...m){this.a.trace(R,...m)}debug(R,...m){this.a.debug(R,...m)}info(R,...m){this.a.info(R,...m)}warn(R,...m){this.a.warn(R,...m)}error(R,...m){this.a.error(R,...m)}flush(){this.a.flush()}}e.$IP=P}),define(Pe[100],Re([1,0,32,157,3]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ot=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var F;(function(f){f[f.Unnecessary=1]="Unnecessary",f[f.Deprecated=2]="Deprecated"})(F||(e.MarkerTag=F={}));var R;(function(f){f[f.Hint=1]="Hint",f[f.Info=2]="Info",f[f.Warning=4]="Warning",f[f.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(f){function k(g,s){return s-g}f.compare=k;const O=Object.create(null);O[f.Error]=(0,M.localize)(0,null),O[f.Warning]=(0,M.localize)(1,null),O[f.Info]=(0,M.localize)(2,null);function D(g){return O[g]||""}f.toString=D;function l(g){switch(g){case S.default.Error:return f.Error;case S.default.Warning:return f.Warning;case S.default.Info:return f.Info;case S.default.Ignore:return f.Hint}}f.fromSeverity=l;function E(g){switch(g){case f.Error:return S.default.Error;case f.Warning:return S.default.Warning;case f.Info:return S.default.Info;case f.Hint:return S.default.Ignore}}f.toSeverity=E}(R||(e.MarkerSeverity=R={}));var m;(function(f){const k="";function O(l){return D(l,!0)}f.makeKey=O;function D(l,E){const g=[k];return l.source?g.push(l.source.replace("\xA6","\\\xA6")):g.push(k),l.code?typeof l.code=="string"?g.push(l.code.replace("\xA6","\\\xA6")):g.push(l.code.value.replace("\xA6","\\\xA6")):g.push(k),l.severity!==void 0&&l.severity!==null?g.push(R.toString(l.severity)):g.push(k),l.message&&E?g.push(l.message.replace("\xA6","\\\xA6")):g.push(k),l.startLineNumber!==void 0&&l.startLineNumber!==null?g.push(l.startLineNumber.toString()):g.push(k),l.startColumn!==void 0&&l.startColumn!==null?g.push(l.startColumn.toString()):g.push(k),l.endLineNumber!==void 0&&l.endLineNumber!==null?g.push(l.endLineNumber.toString()):g.push(k),l.endColumn!==void 0&&l.endColumn!==null?g.push(l.endColumn.toString()):g.push(k),g.push(k),g.join("\xA6")}f.makeKeyOptionalMessage=D})(m||(e.IMarkerData=m={})),e.$Ot=(0,P.$fi)("markerService")}),define(Pe[191],Re([1,0,5,32,3]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hv=e.$Gv=e.NotificationsFilter=e.$Fv=e.NeverShowAgainScope=e.NotificationPriority=e.$Ev=e.Severity=void 0,e.Severity=M.default,e.$Ev=(0,P.$fi)("notificationService");var F;(function(D){D[D.DEFAULT=0]="DEFAULT",D[D.SILENT=1]="SILENT",D[D.URGENT=2]="URGENT"})(F||(e.NotificationPriority=F={}));var R;(function(D){D[D.WORKSPACE=0]="WORKSPACE",D[D.PROFILE=1]="PROFILE",D[D.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));function m(D){if(D){const l=D;return typeof l.id=="string"&&typeof l.label=="string"}return!1}e.$Fv=m;var f;(function(D){D[D.OFF=0]="OFF",D[D.ERROR=1]="ERROR"})(f||(e.NotificationsFilter=f={}));class k{constructor(){this.progress=new O,this.onDidClose=S.Event.None,this.onDidChangeVisibility=S.Event.None}updateSeverity(l){}updateMessage(l){}updateActions(l){}close(){}}e.$Gv=k;class O{infinite(){}done(){}total(l){}worked(l){}}e.$Hv=O}),define(Pe[192],Re([1,0,3]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=e.$Rj=void 0,e.$Rj=(0,S.$fi)("productService"),e.$Sj="vscode://schemas/vscode-product"});var Ye=this&&this.__decorate||function(me,e,S,M){var P=arguments.length,F=P<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,S):M,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")F=Reflect.decorate(me,e,S,M);else for(var m=me.length-1;m>=0;m--)(R=me[m])&&(F=(P<3?R(F):P>3?R(e,S,F):R(e,S))||F);return P>3&&F&&Object.defineProperty(e,S,F),F},He=this&&this.__param||function(me,e){return function(S,M){e(S,M,me)}};define(Pe[101],Re([1,0,11,25,6,3]),function(me,e,S,M,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ov=e.$Nv=e.$Mv=e.$Lv=e.$Kv=e.$Jv=e.ProgressLocation=e.$Iv=void 0,e.$Iv=(0,F.$fi)("progressService");var R;(function(D){D[D.Explorer=1]="Explorer",D[D.Scm=3]="Scm",D[D.Extensions=5]="Extensions",D[D.Window=10]="Window",D[D.Notification=15]="Notification",D[D.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$Jv=Object.freeze({total(){},worked(){},done(){}});class m{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(l){this.b=l}report(l){this.a=l,this.b(this.a)}}e.$Kv=m;class f{get value(){return this.a}constructor(l){this.e=l}report(l){this.b?this.b.push(l):this.b=[l],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const l=this.b.shift();this.a=l,await this.e(this.a)}}finally{this.c=!1;const l=this.d;this.d=void 0,l?.()}}drain(){return this.c?new Promise(l=>{const E=this.d;this.d=()=>{E?.(),l()}}):Promise.resolve()}}e.$Lv=f;let k=class extends P.$Tc{constructor(l,E){super(),this.a=new S.$Ch,E.withProgress(l,g=>(this.b=g,this.c&&g.report(this.c),this.a.p)),this.B((0,P.$Rc)(()=>this.a.complete()))}report(l){this.b?this.b.report(l):this.c=l}};e.$Mv=k,e.$Mv=k=Ye([He(1,e.$Iv)],k);class O extends P.$Tc{constructor(l){super(),this.g=l,this.a=0,this.b=this.B(new P.$Sc)}start(l){this.stop();const E=++this.a,g=new M.$ce;return this.f=setTimeout(()=>{E===this.a&&(this.c=this.g.show(!0))},l),this.b.add((0,P.$Rc)(()=>clearTimeout(this.f))),this.b.add((0,P.$Rc)(()=>g.cancel())),this.b.add((0,P.$Rc)(()=>this.c?this.c.done():void 0)),{id:E,token:g.token,stop:()=>this.h(E),isCurrent:()=>this.a===E}}stop(){this.h(this.a)}h(l){this.a===l&&this.b.clear()}}e.$Nv=O,e.$Ov=(0,F.$fi)("editorProgressService")}),define(Pe[30],Re([1,0,55,16]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wn=void 0;class P{constructor(){this.a=new Map}add(R,m){S.ok(M.$Sf(R)),S.ok(M.$Uf(m)),S.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,m)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$Wn=new P}),define(Pe[72],Re([1,0,5,30]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xn=void 0,e.$Xn={JSONContribution:"base.contributions.json"};function P(m){return m.length>0&&m.charAt(m.length-1)==="#"?m.substring(0,m.length-1):m}class F{constructor(){this.b=new S.$5d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(f,k){this.a[P(f)]=k,this.b.fire(f)}notifySchemaChanged(f){this.b.fire(f)}getSchemaContributions(){return{schemas:this.a}}}const R=new F;M.$Wn.add(e.$Xn.JSONContribution,R)}),define(Pe[56],Re([1,0,18,5,16,151,46,72,30]),function(me,e,S,M,P,F,R,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.ConfigurationScope=e.$2n=e.EditPresentationTypes=void 0;var k;(function(d){d.Multiline="multilineText",d.Singleline="singlelineText"})(k||(e.EditPresentationTypes=k={})),e.$2n={Configuration:"base.contributions.configuration"};var O;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.MACHINE=2]="MACHINE",d[d.WINDOW=3]="WINDOW",d[d.RESOURCE=4]="RESOURCE",d[d.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",d[d.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(O||(e.ConfigurationScope=O={})),e.$3n={properties:{},patternProperties:{}},e.$4n={properties:{},patternProperties:{}},e.$5n={properties:{},patternProperties:{}},e.$6n={properties:{},patternProperties:{}},e.$7n={properties:{},patternProperties:{}},e.$8n={properties:{},patternProperties:{}},e.$9n="vscode://schemas/settings/resourceLanguage",e.$0n="vscode://schemas/settings/configurationDefaults";const D=f.$Wn.as(m.$Xn.JSONContribution);class l{constructor(){this.h=new Set,this.i=new M.$5d,this.onDidSchemaChange=this.i.event,this.j=new M.$5d,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:F.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},D.registerSchema(e.$9n,this.g),this.v()}registerConfiguration(t,p=!0){this.registerConfigurations([t],p)}registerConfigurations(t,p=!0){const u=new Set;this.n(t,p,u),D.registerSchema(e.$9n,this.g),this.i.fire(),this.j.fire({properties:u})}deregisterConfigurations(t){const p=new Set;this.o(t,p),D.registerSchema(e.$9n,this.g),this.i.fire(),this.j.fire({properties:p})}updateConfigurations({add:t,remove:p}){const u=new Set;this.o(p,u),this.n(t,!1,u),D.registerSchema(e.$9n,this.g),this.i.fire(),this.j.fire({properties:u})}registerDefaultConfigurations(t){const p=new Set;this.k(t,p),this.i.fire(),this.j.fire({properties:p,defaultsOverrides:!0})}k(t,p){const u=[];for(const{overrides:o,source:v}of t)for(const b in o)if(p.add(b),e.$_n.test(b)){const $=this.a.get(b),I=$?.valuesSources??new Map;if(v)for(const A of Object.keys(o[b]))I.set(A,v);const h={...$?.value||{},...o[b]};this.a.set(b,{source:v,value:h,valuesSources:I});const y=(0,R.$Vi)(b),w={type:"object",default:h,description:F.localize(1,null,y),$ref:e.$9n,defaultDefaultValue:h,source:P.$Sf(v)?void 0:v,defaultValueSource:v};u.push(...s(b)),this.d[b]=w,this.b.properties[b]=w}else{this.a.set(b,{value:o[b],source:v});const $=this.d[b];$&&(this.w(b,$),this.r(b,$))}this.m(u)}deregisterDefaultConfigurations(t){const p=new Set;this.l(t,p),this.i.fire(),this.j.fire({properties:p,defaultsOverrides:!0})}l(t,p){for(const{overrides:u,source:o}of t)for(const v in u){const b=this.a.get(v),$=P.$Sf(o)?o:o?.id,I=P.$Sf(b?.source)?b?.source:b?.source?.id;if($===I)if(p.add(v),this.a.delete(v),e.$_n.test(v))delete this.d[v],delete this.b.properties[v];else{const h=this.d[v];h&&(this.w(v,h),this.r(v,h))}}this.u()}deltaConfiguration(t){let p=!1;const u=new Set;t.removedDefaults&&(this.l(t.removedDefaults,u),p=!0),t.addedDefaults&&(this.k(t.addedDefaults,u),p=!0),t.removedConfigurations&&this.o(t.removedConfigurations,u),t.addedConfigurations&&this.n(t.addedConfigurations,!1,u),this.i.fire(),this.j.fire({properties:u,defaultsOverrides:p})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const p of t)this.h.add(p);this.u()}n(t,p,u){t.forEach(o=>{this.p(o,p,o.extensionInfo,o.restrictedProperties,void 0,u),this.c.push(o),this.q(o)})}o(t,p){const u=o=>{if(o.properties)for(const v in o.properties){p.add(v);const b=this.d[v];b?.policy?.name&&this.e.delete(b.policy.name),delete this.d[v],this.s(v,o.properties[v])}o.allOf?.forEach(v=>u(v))};for(const o of t){u(o);const v=this.c.indexOf(o);v!==-1&&this.c.splice(v,1)}}p(t,p=!0,u,o,v=3,b){v=P.$2f(t.scope)?v:t.scope;const $=t.properties;if($)for(const h in $){const y=$[h];if(p&&r(h,y)){delete $[h];continue}if(y.source=u,y.defaultDefaultValue=$[h].default,this.w(h,y),e.$_n.test(h)?y.scope=void 0:(y.scope=P.$2f(y.scope)?v:y.scope,y.restricted=P.$2f(y.restricted)?!!o?.includes(h):y.restricted),$[h].hasOwnProperty("included")&&!$[h].included){this.f[h]=$[h],delete $[h];continue}else this.d[h]=$[h],$[h].policy?.name&&this.e.set($[h].policy.name,h);!$[h].deprecationMessage&&$[h].markdownDeprecationMessage&&($[h].deprecationMessage=$[h].markdownDeprecationMessage),b.add(h)}const I=t.allOf;if(I)for(const h of I)this.p(h,p,u,o,v,b)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const p=u=>{const o=u.properties;if(o)for(const b in o)this.r(b,o[b]);u.allOf?.forEach(p)};p(t)}r(t,p){switch(e.$3n.properties[t]=p,p.scope){case 1:e.$4n.properties[t]=p;break;case 2:e.$5n.properties[t]=p;break;case 6:e.$6n.properties[t]=p;break;case 3:e.$7n.properties[t]=p;break;case 4:e.$8n.properties[t]=p;break;case 5:e.$8n.properties[t]=p,this.g.properties[t]=p;break}}s(t,p){switch(delete e.$3n.properties[t],p.scope){case 1:delete e.$4n.properties[t];break;case 2:delete e.$5n.properties[t];break;case 6:delete e.$6n.properties[t];break;case 3:delete e.$7n.properties[t];break;case 4:case 5:delete e.$8n.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const p=`[${t}]`,u={type:"object",description:F.localize(2,null),errorMessage:F.localize(3,null),$ref:e.$9n};this.w(p,u),e.$3n.properties[p]=u,e.$4n.properties[p]=u,e.$5n.properties[p]=u,e.$6n.properties[p]=u,e.$7n.properties[p]=u,e.$8n.properties[p]=u}}v(){const t={type:"object",description:F.localize(4,null),errorMessage:F.localize(5,null),$ref:e.$9n};e.$3n.patternProperties[e.$$n]=t,e.$4n.patternProperties[e.$$n]=t,e.$5n.patternProperties[e.$$n]=t,e.$6n.patternProperties[e.$$n]=t,e.$7n.patternProperties[e.$$n]=t,e.$8n.patternProperties[e.$$n]=t,this.i.fire()}w(t,p){const u=this.a.get(t);let o=u?.value,v=u?.source;P.$Zf(o)&&(o=p.defaultDefaultValue,v=void 0),P.$Zf(o)&&(o=i(p.type)),p.default=o,p.defaultValueSource=v}}const E="\\[([^\\]]+)\\]",g=new RegExp(E,"g");e.$$n=`^(${E})+$`,e.$_n=new RegExp(e.$$n);function s(d){const t=[];if(e.$_n.test(d)){let p=g.exec(d);for(;p?.length;){const u=p[1].trim();u&&t.push(u),p=g.exec(d)}}return(0,S.$Mb)(t)}e.$ao=s;function a(d){return d.reduce((t,p)=>`${t}[${p}]`,"")}e.$bo=a;function i(d){switch(Array.isArray(d)?d[0]:d){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$co=i;const n=new l;f.$Wn.add(e.$2n.Configuration,n);function r(d,t){return d.trim()?e.$_n.test(d)?F.localize(7,null,d):n.getConfigurationProperties()[d]!==void 0?F.localize(8,null,d):t.policy?.name&&n.getPolicyConfigurations().get(t.policy?.name)!==void 0?F.localize(9,null,d,t.policy?.name,n.getPolicyConfigurations().get(t.policy?.name)):null:F.localize(6,null)}e.$do=r;function c(){const d=[],t=n.getConfigurationProperties();for(const p of Object.keys(t))d.push([p,t[p].scope]);return d.push(["launch",4]),d.push(["task",4]),d}e.$eo=c}),define(Pe[193],Re([1,0,18,5,122,6,28,26,16,2,46,56,30]),function(me,e,S,M,P,F,R,m,f,k,O,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=void 0;function E(p){return Object.isFrozen(p)?p:m.$Ln(p)}class g{constructor(u={},o=[],v=[],b){this.b=u,this.c=o,this.d=v,this.raw=b,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const u=this.raw.map(o=>{if(o instanceof g)return o;const v=new s("");return v.parseRaw(o),v.configurationModel});this.f=u.reduce((o,v)=>v===o?v:o.merge(v),u[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(u){return u?(0,O.$Ti)(this.contents,u):this.contents}inspect(u,o){const v=this;return{get value(){return E(v.rawConfiguration.getValue(u))},get override(){return o?E(v.rawConfiguration.getOverrideValue(u,o)):void 0},get merged(){return E(o?v.rawConfiguration.override(o).getValue(u):v.rawConfiguration.getValue(u))},get overrides(){const b=[];for(const{contents:$,identifiers:I,keys:h}of v.rawConfiguration.overrides){const y=new g($,h).getValue(u);y!==void 0&&b.push({identifiers:I,value:y})}return b.length?E(b):void 0}}}getOverrideValue(u,o){const v=this.i(o);return v?u?(0,O.$Ti)(v,u):v:void 0}getKeysForOverrideIdentifier(u){const o=[];for(const v of this.overrides)v.identifiers.includes(u)&&o.push(...v.keys);return S.$Mb(o)}getAllOverrideIdentifiers(){const u=[];for(const o of this.overrides)u.push(...o.identifiers);return S.$Mb(u)}override(u){let o=this.a.get(u);return o||(o=this.g(u),this.a.set(u,o)),o}merge(...u){const o=m.$Kn(this.contents),v=m.$Kn(this.overrides),b=[...this.keys],$=this.raw?.length?[...this.raw]:[this];for(const I of u)if($.push(...I.raw?.length?I.raw:[I]),!I.isEmpty()){this.h(o,I.contents);for(const h of I.overrides){const[y]=v.filter(w=>S.$ub(w.identifiers,h.identifiers));y?(this.h(y.contents,h.contents),y.keys.push(...h.keys),y.keys=S.$Mb(y.keys)):v.push(m.$Kn(h))}for(const h of I.keys)b.indexOf(h)===-1&&b.push(h)}return new g(o,b,v,$.every(I=>I instanceof g)?void 0:$)}g(u){const o=this.i(u);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const v={};for(const b of S.$Mb([...Object.keys(this.contents),...Object.keys(o)])){let $=this.contents[b];const I=o[b];I&&(typeof $=="object"&&typeof I=="object"?($=m.$Kn($),this.h($,I)):$=I),v[b]=$}return new g(v,this.keys,this.overrides)}h(u,o){for(const v of Object.keys(o)){if(v in u&&f.$Uf(u[v])&&f.$Uf(o[v])){this.h(u[v],o[v]);continue}u[v]=m.$Kn(o[v])}}i(u){let o=null,v=null;const b=$=>{$&&(v?this.h(v,$):v=m.$Kn($))};for(const $ of this.overrides)$.identifiers.length===1&&$.identifiers[0]===u?o=$.contents:$.identifiers.includes(u)&&b($.contents);return b(o),v}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(u,o){this.j(u,o,!0)}setValue(u,o){this.j(u,o,!1)}removeValue(u){const o=this.keys.indexOf(u);o!==-1&&(this.keys.splice(o,1),(0,O.$Si)(this.contents,u),D.$_n.test(u)&&this.overrides.splice(this.overrides.findIndex(v=>S.$ub(v.identifiers,(0,D.$ao)(u))),1))}j(u,o,v){(0,O.$Ri)(this.contents,u,o,b=>console.error(b)),v=v||this.keys.indexOf(u)===-1,v&&this.keys.push(u),D.$_n.test(u)&&this.overrides.push({identifiers:(0,D.$ao)(u),keys:Object.keys(this.contents[u]),contents:(0,O.$Qi)(this.contents[u],b=>console.error(b))})}}e.$fo=g;class s{constructor(u){this.f=u,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new g}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(u,o){if(!f.$2f(u)){const v=this.g(u);this.parseRaw(v,o)}}reparse(u){this.a&&this.parseRaw(this.a,u)}parseRaw(u,o){this.a=u;const{contents:v,keys:b,overrides:$,restricted:I,hasExcludedProperties:h}=this.h(u,o);this.b=new g(v,b,$,h?[u]:void 0),this.c=I||[]}g(u){let o={},v=null,b=[];const $=[],I=[];function h(w){Array.isArray(b)?b.push(w):v!==null&&(b[v]=w)}const y={onObjectBegin:()=>{const w={};h(w),$.push(b),b=w,v=null},onObjectProperty:w=>{v=w},onObjectEnd:()=>{b=$.pop()},onArrayBegin:()=>{const w=[];h(w),$.push(b),b=w,v=null},onArrayEnd:()=>{b=$.pop()},onLiteralValue:h,onError:(w,A,N)=>{I.push({error:w,offset:A,length:N})}};if(u)try{P.$yn(u,y),o=b[0]||{}}catch(w){console.error(`Error while parsing settings file ${this.f}: ${w}`),this.d=[w]}return o}h(u,o){const v=l.$Wn.as(D.$2n.Configuration).getConfigurationProperties(),b=this.i(u,v,!0,o);u=b.raw;const $=(0,O.$Qi)(u,y=>console.error(`Conflict in settings file ${this.f}: ${y}`)),I=Object.keys(u),h=this.j(u,y=>console.error(`Conflict in settings file ${this.f}: ${y}`));return{contents:$,keys:I,overrides:h,restricted:b.restricted,hasExcludedProperties:b.hasExcludedProperties}}i(u,o,v,b){let $=!1;if(!b?.scopes&&!b?.skipRestricted&&!b?.exclude?.length)return{raw:u,restricted:[],hasExcludedProperties:$};const I={},h=[];for(const y in u)if(D.$_n.test(y)&&v){const w=this.i(u[y],o,!1,b);I[y]=w.raw,$=$||w.hasExcludedProperties,h.push(...w.restricted)}else{const w=o[y],A=w?typeof w.scope<"u"?w.scope:3:void 0;w?.restricted&&h.push(y),!b.exclude?.includes(y)&&(b.include?.includes(y)||(A===void 0||b.scopes===void 0||b.scopes.includes(A))&&!(b.skipRestricted&&w?.restricted))?I[y]=u[y]:$=!0}return{raw:I,restricted:h,hasExcludedProperties:$}}j(u,o){const v=[];for(const b of Object.keys(u))if(D.$_n.test(b)){const $={};for(const I in u[b])$[I]=u[b][I];v.push({identifiers:(0,D.$ao)(b),keys:Object.keys($),contents:(0,O.$Qi)($,o)})}return v}}e.$go=s;class a extends F.$Tc{constructor(u,o,v,b){super(),this.c=u,this.f=o,this.g=b,this.b=this.B(new M.$5d),this.onDidChange=this.b.event,this.a=new s(this.c.toString()),this.B(this.g.watch(v.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(M.Event.any(M.Event.filter(this.g.onDidFilesChange,$=>$.contains(this.c)),M.Event.filter(this.g.onDidRunOperation,$=>($.isOperation(0)||$.isOperation(3)||$.isOperation(1)||$.isOperation(4))&&v.isEqual($.resource,u)))(()=>this.b.fire()))}async loadConfiguration(){try{const u=await this.g.readFile(this.c);return this.a.parse(u.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new g}}reparse(u){return u&&(this.f=u),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$ho=a;class i{constructor(u,o,v,b,$,I,h,y,w,A,N,G,V){this.a=u,this.b=o,this.c=v,this.overrideIdentifiers=b,this.d=$,this.f=I,this.g=h,this.h=y,this.i=w,this.j=A,this.k=N,this.l=G,this.m=V}get value(){return E(this.c)}n(u){return u?.value!==void 0||u?.override!==void 0||u?.overrides!==void 0?u:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class n{constructor(u,o,v,b,$=new g,I=new g,h=new R.$Ac,y=new g,w=new R.$Ac){this.c=u,this.d=o,this.f=v,this.g=b,this.h=$,this.i=I,this.j=h,this.l=y,this.m=w,this.a=null,this.b=new R.$Ac,this.n=null}getValue(u,o,v){return this.p(u,o,v).getValue(u)}updateValue(u,o,v={}){let b;v.resource?(b=this.m.get(v.resource),b||(b=new g,this.m.set(v.resource,b))):b=this.l,o===void 0?b.removeValue(u):b.setValue(u,o),v.resource||(this.a=null)}inspect(u,o,v){const b=this.p(u,o,v),$=this.t(o.resource,v),I=o.resource?this.m.get(o.resource)||this.l:this.l,h=new Set;for(const y of b.overrides)for(const w of y.identifiers)b.getOverrideValue(u,w)!==void 0&&h.add(w);return new i(u,o,b.getValue(u),h.size?[...h]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,v?this.i:void 0,$||void 0,I)}keys(u){const o=this.t(void 0,u);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:o?o.keys.slice(0):[]}}updateDefaultConfiguration(u){this.c=u,this.a=null,this.b.clear()}updatePolicyConfiguration(u){this.d=u}updateApplicationConfiguration(u){this.f=u,this.a=null,this.b.clear()}updateLocalUserConfiguration(u){this.g=u,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(u){this.h=u,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(u){this.i=u,this.a=null,this.b.clear()}updateFolderConfiguration(u,o){this.j.set(u,o),this.b.delete(u)}deleteFolderConfiguration(u){this.folderConfigurations.delete(u),this.b.delete(u)}compareAndUpdateDefaultConfiguration(u,o){const v=[];if(!o){const{added:b,updated:$,removed:I}=d(this.c,u);o=[...b,...$,...I]}for(const b of o)for(const $ of(0,D.$ao)(b)){const I=this.c.getKeysForOverrideIdentifier($),h=u.getKeysForOverrideIdentifier($),y=[...h.filter(w=>I.indexOf(w)===-1),...I.filter(w=>h.indexOf(w)===-1),...I.filter(w=>!m.$On(this.c.override($).getValue(w),u.override($).getValue(w)))];v.push([$,y])}return this.updateDefaultConfiguration(u),{keys:o,overrides:v}}compareAndUpdatePolicyConfiguration(u){const{added:o,updated:v,removed:b}=d(this.d,u),$=[...o,...v,...b];return $.length&&this.updatePolicyConfiguration(u),{keys:$,overrides:[]}}compareAndUpdateApplicationConfiguration(u){const{added:o,updated:v,removed:b,overrides:$}=d(this.applicationConfiguration,u),I=[...o,...v,...b];return I.length&&this.updateApplicationConfiguration(u),{keys:I,overrides:$}}compareAndUpdateLocalUserConfiguration(u){const{added:o,updated:v,removed:b,overrides:$}=d(this.localUserConfiguration,u),I=[...o,...v,...b];return I.length&&this.updateLocalUserConfiguration(u),{keys:I,overrides:$}}compareAndUpdateRemoteUserConfiguration(u){const{added:o,updated:v,removed:b,overrides:$}=d(this.remoteUserConfiguration,u),I=[...o,...v,...b];return I.length&&this.updateRemoteUserConfiguration(u),{keys:I,overrides:$}}compareAndUpdateWorkspaceConfiguration(u){const{added:o,updated:v,removed:b,overrides:$}=d(this.workspaceConfiguration,u),I=[...o,...v,...b];return I.length&&this.updateWorkspaceConfiguration(u),{keys:I,overrides:$}}compareAndUpdateFolderConfiguration(u,o){const v=this.folderConfigurations.get(u),{added:b,updated:$,removed:I,overrides:h}=d(v,o),y=[...b,...$,...I];return(y.length||!v)&&this.updateFolderConfiguration(u,o),{keys:y,overrides:h}}compareAndDeleteFolderConfiguration(u){const o=this.folderConfigurations.get(u);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(u);const{added:v,updated:b,removed:$,overrides:I}=d(o,void 0);return{keys:[...v,...b,...$],overrides:I}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(u,o,v){let b=this.q(o,v);return o.overrideIdentifier&&(b=b.override(o.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(u)!==void 0&&(b=b.merge(this.d)),b}q({resource:u},o){let v=this.r();if(o&&u){const b=o.getFolder(u);b&&(v=this.s(b.uri)||v);const $=this.m.get(u);$&&(v=v.merge($))}return v}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(u){let o=this.b.get(u);if(!o){const v=this.r(),b=this.j.get(u);b?(o=v.merge(b),this.b.set(u,o)):o=v}return o}t(u,o){if(o&&u){const v=o.getFolder(u);if(v)return this.j.get(v.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((u,o)=>{const{contents:v,overrides:b,keys:$}=this.j.get(o);return u.push([o,{contents:v,overrides:b,keys:$}]),u},[])}}allKeys(){const u=new Set;return this.c.keys.forEach(o=>u.add(o)),this.userConfiguration.keys.forEach(o=>u.add(o)),this.i.keys.forEach(o=>u.add(o)),this.j.forEach(o=>o.keys.forEach(v=>u.add(v))),[...u.values()]}u(){const u=new Set;return this.c.getAllOverrideIdentifiers().forEach(o=>u.add(o)),this.userConfiguration.getAllOverrideIdentifiers().forEach(o=>u.add(o)),this.i.getAllOverrideIdentifiers().forEach(o=>u.add(o)),this.j.forEach(o=>o.getAllOverrideIdentifiers().forEach(v=>u.add(v))),[...u.values()]}v(u){const o=new Set;return this.c.getKeysForOverrideIdentifier(u).forEach(v=>o.add(v)),this.userConfiguration.getKeysForOverrideIdentifier(u).forEach(v=>o.add(v)),this.i.getKeysForOverrideIdentifier(u).forEach(v=>o.add(v)),this.j.forEach(v=>v.getKeysForOverrideIdentifier(u).forEach(b=>o.add(b))),[...o.values()]}static parse(u){const o=this.w(u.defaults),v=this.w(u.policy),b=this.w(u.application),$=this.w(u.user),I=this.w(u.workspace),h=u.folders.reduce((y,w)=>(y.set(k.URI.revive(w[0]),this.w(w[1])),y),new R.$Ac);return new n(o,v,b,$,new g,I,h,new g,new R.$Ac)}static w(u){return new g(u.contents,u.keys,u.overrides)}}e.$io=n;function r(...p){if(p.length===0)return{keys:[],overrides:[]};if(p.length===1)return p[0];const u=new Set,o=new Map;for(const b of p)b.keys.forEach($=>u.add($)),b.overrides.forEach(([$,I])=>{const h=(0,R.$xc)(o,$,new Set);I.forEach(y=>h.add(y))});const v=[];return o.forEach((b,$)=>v.push([$,[...b.values()]])),{keys:[...u.values()],overrides:v}}e.$jo=r;class c{constructor(u,o,v,b){this.change=u,this.f=o,this.g=v,this.h=b,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const $ of u.keys)this.affectedKeys.add($);for(const[,$]of u.overrides)for(const I of $)this.affectedKeys.add(I);this.d=this.a;for(const $ of this.affectedKeys)this.d+=$+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=n.parse(this.f.data)),this.i}affectsConfiguration(u,o){const v=this.a+u,b=this.d.indexOf(v);if(b<0)return!1;const $=b+v.length;if($>=this.d.length)return!1;const I=this.d.charCodeAt($);if(I!==this.b&&I!==this.c)return!1;if(o){const h=this.previousConfiguration?this.previousConfiguration.getValue(u,o,this.f?.workspace):void 0,y=this.g.getValue(u,o,this.h);return!m.$On(h,y)}return!0}}e.$ko=c;function d(p,u){const{added:o,removed:v,updated:b}=t(u?.rawConfiguration,p?.rawConfiguration),$=[],I=p?.getAllOverrideIdentifiers()||[],h=u?.getAllOverrideIdentifiers()||[];if(u){const y=h.filter(w=>!I.includes(w));for(const w of y)$.push([w,u.getKeysForOverrideIdentifier(w)])}if(p){const y=I.filter(w=>!h.includes(w));for(const w of y)$.push([w,p.getKeysForOverrideIdentifier(w)])}if(u&&p){for(const y of I)if(h.includes(y)){const w=t({contents:p.getOverrideValue(void 0,y)||{},keys:p.getKeysForOverrideIdentifier(y)},{contents:u.getOverrideValue(void 0,y)||{},keys:u.getKeysForOverrideIdentifier(y)});$.push([y,[...w.added,...w.removed,...w.updated]])}}return{added:o,removed:v,updated:b,overrides:$}}function t(p,u){const o=p?u?p.keys.filter($=>u.keys.indexOf($)===-1):[...p.keys]:[],v=u?p?u.keys.filter($=>p.keys.indexOf($)===-1):[...u.keys]:[],b=[];if(p&&u){for(const $ of u.keys)if(p.keys.indexOf($)!==-1){const I=(0,O.$Ti)(u.contents,$),h=(0,O.$Ti)(p.contents,$);m.$On(I,h)||b.push($)}}return{added:o,removed:v,updated:b}}}),define(Pe[102],Re([1,0,14,3]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ol=e.$nl=e.RemoteAuthorityResolverErrorCode=e.$ml=e.$ll=e.RemoteConnectionType=e.$kl=void 0,e.$kl=(0,M.$fi)("remoteAuthorityResolverService");var P;(function(O){O[O.WebSocket=0]="WebSocket",O[O.Managed=1]="Managed"})(P||(e.RemoteConnectionType=P={}));class F{constructor(D){this.id=D,this.type=1}toString(){return`Managed(${this.id})`}}e.$ll=F;class R{constructor(D,l){this.host=D,this.port=l,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$ml=R;var m;(function(O){O.Unknown="Unknown",O.NotAvailable="NotAvailable",O.TemporarilyNotAvailable="TemporarilyNotAvailable",O.NoResolverFound="NoResolverFound",O.InvalidAuthority="InvalidAuthority"})(m||(e.RemoteAuthorityResolverErrorCode=m={}));class f extends S.$bb{static isNotAvailable(D){return D instanceof f&&D._code===m.NotAvailable}static isTemporarilyNotAvailable(D){return D instanceof f&&D._code===m.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof f&&D._code===m.NoResolverFound}static isInvalidAuthority(D){return D instanceof f&&D._code===m.InvalidAuthority}static isHandled(D){return D instanceof f&&D.isHandled}constructor(D,l=m.Unknown,E){super(D),this._message=D,this._code=l,this._detail=E,this.isHandled=l===m.NotAvailable&&E===!0,Object.setPrototypeOf(this,f.prototype)}}e.$nl=f;function k(O){const D=O.indexOf("+");return D===-1?O:O.substring(0,D)}e.$ol=k}),define(Pe[57],Re([1,0,12]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=e.$rm=e.$qm=e.$pm=void 0;function M(f){return f.scheme===S.Schemas.vscodeRemote?f.authority:void 0}e.$pm=M;function P(f){if(!f)return;const k=f.indexOf("+");return k<0?f:f.substr(0,k)}e.$qm=P;function F(f){const{host:k,port:O}=m(f);if(typeof O>"u")throw new Error(`Invalid remote authority: ${f}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:k,port:O}}e.$rm=F;function R(f,k){let{host:O,port:D}=m(f);return typeof D>"u"&&(D=k),{host:O,port:D}}e.$sm=R;function m(f){const k=f.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(k)return{host:k[1],port:parseInt(k[2],10)};const O=f.match(/^(\[[0-9a-z:]+\])$/);if(O)return{host:O[1],port:void 0};const D=f.match(/(.*):(\d+)$/);return D?{host:D[1],port:parseInt(D[2],10)}:{host:f,port:void 0}}}),define(Pe[20],Re([1,0,15,3,57]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gm=e.$Fm=e.$Em=e.$Dm=e.$Cm=e.$Bm=e.$Am=e.$zm=e.TargetPlatform=e.ExtensionType=e.$ym=e.$xm=e.$wm=e.$vm=e.$um=e.$tm=void 0,e.$tm="extensions.user.cache",e.$um="extensions.builtin.cache",e.$vm="undefined_publisher",e.$wm=["ui","workspace","web"];function F(s){if(typeof s=="object"&&s!==null&&s.supported!==!0)return s.description}e.$xm=F,e.$ym=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var R;(function(s){s[s.System=0]="System",s[s.User=1]="User"})(R||(e.ExtensionType=R={}));var m;(function(s){s.WIN32_X64="win32-x64",s.WIN32_ARM64="win32-arm64",s.LINUX_X64="linux-x64",s.LINUX_ARM64="linux-arm64",s.LINUX_ARMHF="linux-armhf",s.ALPINE_X64="alpine-x64",s.ALPINE_ARM64="alpine-arm64",s.DARWIN_X64="darwin-x64",s.DARWIN_ARM64="darwin-arm64",s.WEB="web",s.UNIVERSAL="universal",s.UNKNOWN="unknown",s.UNDEFINED="undefined"})(m||(e.TargetPlatform=m={}));class f{constructor(a){this.value=a,this._lower=a.toLowerCase()}static equals(a,i){if(typeof a>"u"||a===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof a=="string"||typeof i=="string"){const n=typeof a=="string"?a:a.value,r=typeof i=="string"?i:i.value;return S.$jf(n,r)}return a._lower===i._lower}static toKey(a){return typeof a=="string"?a.toLowerCase():a._lower}}e.$zm=f;class k{get size(){return this.c.size}constructor(a){if(this.c=new Set,a)for(const i of a)this.add(i)}add(a){this.c.add(f.toKey(a))}delete(a){return this.c.delete(f.toKey(a))}has(a){return this.c.has(f.toKey(a))}}e.$Am=k;class O{constructor(){this.c=new Map}clear(){this.c.clear()}delete(a){this.c.delete(f.toKey(a))}get(a){return this.c.get(f.toKey(a))}has(a){return this.c.has(f.toKey(a))}set(a,i){this.c.set(f.toKey(a),i)}values(){return this.c.values()}forEach(a){this.c.forEach(a)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Bm=O;function D(s){return l(s)}e.$Cm=D;function l(s){return s.contributes&&s.contributes.localizations?s.contributes.localizations.length>0:!1}e.$Dm=l;function E(s){return s.contributes&&s.contributes.authentication?s.contributes.authentication.length>0:!1}e.$Em=E;function g(s,a){if(a){const i=`onResolveRemoteAuthority:${(0,P.$qm)(a)}`;return!!s.activationEvents?.includes(i)}return!1}e.$Fm=g,e.$Gm=(0,M.$fi)("IBuiltinExtensionsScannerService")}),define(Pe[103],Re([1,0,14,20]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DF=e.$CF=void 0;class P{constructor(){this.a=new Map,this.b=new WeakMap}register(R,m){this.a.set(R,m)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const m=Object.create(null);for(const f of R){const k=this.readActivationEvents(f);k.length>0&&(m[M.$zm.toKey(f.identifier)]=k)}return m}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const m=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let f=0;f<m.length;f++)m[f]==="onUri"&&(m[f]=`onUri:${M.$zm.toKey(R.identifier)}`);if(!R.contributes)return m;for(const f in R.contributes){const k=this.a.get(f);if(!k)continue;const O=R.contributes[f],D=Array.isArray(O)?O:[O];try{k(D,m)}catch(l){(0,S.$1)(l)}}return m}}e.$CF=P,e.$DF=new P}),define(Pe[194],Re([1,0,21,73,33]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yo=e.$Xo=void 0;function F(f){if(S.$u===2&&/^penguin(\.|$)/i.test(f))return"chromebook"}function R(f,k,O,D,l,E,g,s,a){const i=Object.create(null);i["common.machineId"]=E,i["common.sqmId"]=g,i.sessionID=(0,P.$Bg)()+Date.now(),i.commitHash=D,i.version=l,i["common.platformVersion"]=(f||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),i["common.platform"]=(0,S.$h)(S.$u),i["common.nodePlatform"]=M.$dc,i["common.nodeArch"]=O,i["common.product"]=a||"desktop",s&&(i["common.msftInternal"]=s);let n=0;const r=Date.now();Object.defineProperties(i,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-r,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),S.$l&&(i["common.snap"]="true");const c=F(k);return c&&(i["common.platformDetail"]=c),i}e.$Xo=R;function m(f){const k=M.env.USERDNSDOMAIN;if(!k)return!1;const O=k.toLowerCase();return f.some(D=>O===D)}e.$Yo=m}),define(Pe[195],Re([1,0,3]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Ol=e.$Nl=e.$Ml=e.$Ll=e.$Kl=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=e.$El=void 0,e.$El=(0,S.$fi)("telemetryService"),e.$Fl=(0,S.$fi)("customEndpointTelemetryService"),e.$Gl="telemetry.currentSessionDate",e.$Hl="telemetry.firstSessionDate",e.$Il="telemetry.lastSessionDate",e.$Jl="telemetry.machineId",e.$Kl="telemetry.sqmId",e.$Ll="telemetry",e.$Ml="telemetry.telemetryLevel",e.$Nl="telemetry.enableCrashReporter",e.$Ol="telemetry.enableTelemetry";var M;(function(F){F[F.NONE=0]="NONE",F[F.CRASH=1]="CRASH",F[F.ERROR=2]="ERROR",F[F.USAGE=3]="USAGE"})(M||(e.TelemetryLevel=M={}));var P;(function(F){F.OFF="off",F.CRASH="crash",F.ERROR="error",F.ON="all"})(P||(e.TelemetryConfiguration=P={}))}),define(Pe[58],Re([1,0,26,16,57,194,195]),function(me,e,S,M,P,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=void 0;class m{constructor(p){this.value=p,this.isTrustedTelemetryValue=!0}}e.$Zo=m;class f{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$1o=f,e.$2o=new f;class k{async publicLog(p,u,o){}async publicLogError(p,u,o){}}e.$3o=k,e.$4o="telemetry",e.$5o="extensionTelemetryLog",e.$6o={log:()=>null,flush:()=>Promise.resolve(null)};function O(t,p){return!p.isBuilt&&!p.disableTelemetry?!0:!(p.disableTelemetry||!t.enableTelemetry)}e.$7o=O;function D(t,p){return p.extensionTestsLocationURI?!0:!(p.isBuilt||p.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.$8o=D;function l(t){const p=t.getValue(R.$Ml),u=t.getValue(R.$Nl);if(t.getValue(R.$Ol)===!1||u===!1)return 0;switch(p??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$9o=l;function E(t){const p={},u={},o={};a(t,o);for(let v in o){v=v.length>150?v.substr(v.length-149):v;const b=o[v];typeof b=="number"?u[v]=b:typeof b=="boolean"?u[v]=b?1:0:typeof b=="string"?(b.length>8192&&console.warn(`Telemetry property: ${v} has been trimmed to 8192, the original length is ${b.length}`),p[v]=b.substring(0,8191)):typeof b<"u"&&b!==null&&(p[v]=b)}return{properties:p,measurements:u}}e.$0o=E;const g=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function s(t){if(!t)return"none";const p=(0,P.$qm)(t);return g.has(p)?p:"other"}e.$$o=s;function a(t,p,u=0,o){if(t)for(const v of Object.getOwnPropertyNames(t)){const b=t[v],$=o?o+v:v;Array.isArray(b)?p[$]=(0,S.$Pn)(b):b instanceof Date?p[$]=b.toISOString():(0,M.$Uf)(b)?u<2?a(b,p,u+1,$+"."):p[$]=(0,S.$Pn)(b):p[$]=b}}function i(t,p){const u=t.msftInternalDomains||[],o=p.getValue("telemetry.internalTesting");return(0,F.$Yo)(u)||o}e.$_o=i;function n(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.$ap=n;function r(t,p){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let u=t;const o=[];for(const I of p)for(;;){const h=I.exec(t);if(!h)break;o.push([h.index,I.lastIndex])}const v=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,b=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let $=0;for(u="";;){const I=b.exec(t);if(!I)break;const h=o.some(([y,w])=>I.index<w&&y<b.lastIndex);!v.test(I[0])&&!h&&(u+=t.substring($,I.index)+"<REDACTED: user-file-path>",$=b.lastIndex)}return $<t.length&&(u+=t.substr($)),u}function c(t){if(!t)return t;const p=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const u of p)if(u.regex.test(t))return`<REDACTED: ${u.label}>`;return t}function d(t,p){return(0,S.$Mn)(t,u=>{if(u instanceof m||Object.hasOwnProperty.call(u,"isTrustedTelemetryValue"))return u.value;if(typeof u=="string"){let o=u.replaceAll("%20"," ");o=r(o,p);for(const v of p)o=o.replace(v,"");return o=c(o),o}})}e.$bp=d}),define(Pe[196],Re([1,0,15,98,20,21,2,14,73,58]),function(me,e,S,M,P,F,R,m,f,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$np=e.$mp=e.$lp=e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=void 0;function O(u,o){return u.uuid&&o.uuid?u.uuid===o.uuid:u.id===o.id?!0:(0,S.$ef)(u.id,o.id)===0}e.$cp=O;const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class l{static create(o){const v=o.manifest?o.manifest.version:o.version,b=o.manifest?o.targetPlatform:o.properties.targetPlatform;return new l(o.identifier,v,b)}static parse(o){const v=D.exec(o);return v&&v[1]&&v[2]?new l({id:v[1]},v[2],v[4]||void 0):null}constructor(o,v,b="undefined"){this.version=v,this.targetPlatform=b,this.id=o.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(o){return o instanceof l?O(this,o)&&this.version===o.version&&this.targetPlatform===o.targetPlatform:!1}}e.$dp=l;const E=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function g(u){const o=E.exec(u);return o&&o[1]?[a(o[1]),o[2]]:[a(u),void 0]}e.$ep=g;function s(u,o){return`${u}.${o}`}e.$fp=s;function a(u){return u.toLowerCase()}e.$gp=a;function i(u,o){return a(s(u??P.$vm,o))}e.$hp=i;function n(u,o){const v=[],b=$=>{for(const I of v)if(I.some(h=>O(o(h),o($))))return I;return null};for(const $ of u){const I=b($);I?I.push($):v.push([$])}return v}e.$ip=n;function r(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}e.$jp=r;function c(u){return{id:new k.$Zo(u.identifier.id),name:new k.$Zo(u.name),galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,isPreReleaseVersion:u.properties.isPreReleaseVersion,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),isSigned:u.isSigned,...u.telemetryData}}e.$kp=c,e.$lp=new P.$zm("pprice.better-merge");function d(u,o){const v=[],b=o.manifest.extensionDependencies?.slice(0)??[];for(;b.length;){const $=b.shift();if($&&v.every(I=>!O(I.identifier,{id:$}))){const I=u.filter(h=>O(h.identifier,{id:$}));I.length===1&&(v.push(I[0]),b.push(...I[0].manifest.extensionDependencies?.slice(0)??[]))}}return v}e.$mp=d;async function t(u,o){if(!F.$k)return!1;let v;try{v=(await u.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{v=(await u.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch($){o.debug("Error while getting the os-release file.",(0,m.$0)($))}}return!!v&&(v.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function p(u,o){const v=await t(u,o),b=(0,M.$Jo)(v?"alpine":F.$u,f.$ec);return o.debug("ComputeTargetPlatform:",b),b}e.$np=p}),define(Pe[197],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6r=e.$5r=e.$4r=e.$3r=e.$2r=e.$1r=void 0;function S(f){return[...f.entries()]}e.$1r=S;function M(f){return f?[...f.entries()]:[]}e.$2r=M;function P(f){return new Map(f)}e.$3r=P;function F(f){return new Map(f??[])}e.$4r=F;function R(f){return Array.from(f.entries()).map(k=>[k[0],S(k[1].map),M(k[1].descriptionMap)])}e.$5r=R;function m(f){return new Map(f.map(k=>[k[0],{map:P(k[1]),descriptionMap:F(k[2])}]))}e.$6r=m}),define(Pe[198],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ptb=void 0;class S{constructor(P){this.b=P,this.a=new Map}dispose(){for(const P of this.a.values())P.dispose()}startBuffering(P,F,R=5){const m=F(f=>{const k=typeof f=="string"?f:f.data;let O=this.a.get(P);if(O){O.data.push(k);return}const D=setTimeout(()=>this.flushBuffer(P),R);O={data:[k],timeoutId:D,dispose:()=>{clearTimeout(D),this.flushBuffer(P),m.dispose()}},this.a.set(P,O)});return m}stopBuffering(P){this.a.get(P)?.dispose()}flushBuffer(P){const F=this.a.get(P);F&&(this.a.delete(P),this.b(P,F.data.join("")))}}e.$Ptb=S}),define(Pe[199],Re([1,0,11,91,298,40,5,16,2,158,72,30]),function(me,e,S,M,P,F,R,m,f,k,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tw=e.$Sw=e.$Rw=e.$Qw=e.$Pw=e.$Ow=e.$Nw=e.$Mw=e.IconFontDefinition=e.IconContribution=e.$Lw=void 0,e.$Lw={IconContribution:"base.contributions.icons"};var l;(function(d){function t(p,u){let o=p.defaults;for(;F.ThemeIcon.isThemeIcon(o);){const v=s.getIcon(o.id);if(!v)return;o=v.defaults}return o}d.getDefinition=t})(l||(e.IconContribution=l={}));var E;(function(d){function t(u){return{weight:u.weight,style:u.style,src:u.src.map(o=>({format:o.format,location:o.location.toString()}))}}d.toJSONObject=t;function p(u){const o=v=>(0,m.$Sf)(v)?v:void 0;if(u&&Array.isArray(u.src)&&u.src.every(v=>(0,m.$Sf)(v.format)&&(0,m.$Sf)(v.location)))return{weight:o(u.weight),style:o(u.style),src:u.src.map(v=>({format:v.format,location:f.URI.parse(v.location)}))}}d.fromJSONObject=p})(E||(e.IconFontDefinition=E={}));class g{constructor(){this.a=new R.$5d,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,k.localize)(0,null)},fontCharacter:{type:"string",description:(0,k.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${F.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,p,u,o){const v=this.b[t];if(v){if(u&&!v.description){v.description=u,this.d.properties[t].markdownDescription=`${u} $(${t})`;const I=this.e.enum.indexOf(t);I!==-1&&(this.e.enumDescriptions[I]=u),this.a.fire()}return v}const b={id:t,description:u,defaults:p,deprecationMessage:o};this.b[t]=b;const $={$ref:"#/definitions/icons"};return o&&($.deprecationMessage=o),u&&($.markdownDescription=`${u}: $(${t})`),this.d.properties[t]=$,this.e.enum.push(t),this.e.enumDescriptions.push(u||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const p=this.e.enum.indexOf(t);p!==-1&&(this.e.enum.splice(p,1),this.e.enumDescriptions.splice(p,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,p){const u=this.f[t];return u||(this.f[t]=p,this.a.fire(),p)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=(v,b)=>v.id.localeCompare(b.id),p=v=>{for(;F.ThemeIcon.isThemeIcon(v.defaults);)v=this.b[v.defaults.id];return`codicon codicon-${v?v.id:""}`},u=[];u.push("| preview     | identifier                        | default codicon ID                | description"),u.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const o=Object.keys(this.b).map(v=>this.b[v]);for(const v of o.filter(b=>!!b.description).sort(t))u.push(`|<i class="${p(v)}"></i>|${v.id}|${F.ThemeIcon.isThemeIcon(v.defaults)?v.defaults.id:v.id}|${v.description||""}|`);u.push("| preview     | identifier                        "),u.push("| ----------- | --------------------------------- |");for(const v of o.filter(b=>!F.ThemeIcon.isThemeIcon(b.defaults)).sort(t))u.push(`|<i class="${p(v)}"></i>|${v.id}|`);return u.join(`
`)}}const s=new g;D.$Wn.add(e.$Lw.IconContribution,s);function a(d,t,p,u){return s.registerIcon(d,t,p,u)}e.$Mw=a;function i(){return s}e.$Nw=i;function n(){const d=(0,P.$kk)();for(const t in d){const p="\\"+d[t].toString(16);s.registerIcon(t,{fontCharacter:p})}}n(),e.$Ow="vscode://schemas/icons";const r=D.$Wn.as(O.$Xn.JSONContribution);r.registerSchema(e.$Ow,s.getIconSchema());const c=new S.$rh(()=>r.notifySchemaChanged(e.$Ow),200);s.onDidChange(()=>{c.isScheduled()||c.schedule()}),e.$Pw=a("widget-close",M.$ok.close,(0,k.localize)(2,null)),e.$Qw=a("goto-previous-location",M.$ok.arrowUp,(0,k.localize)(3,null)),e.$Rw=a("goto-next-location",M.$ok.arrowDown,(0,k.localize)(4,null)),e.$Sw=F.ThemeIcon.modify(M.$ok.sync,"spin"),e.$Tw=F.ThemeIcon.modify(M.$ok.loading,"spin")}),define(Pe[200],Re([1,0,5,46,3,13]),function(me,e,S,M,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zv=e.$Yv=e.$Xv=e.$Wv=e.$Vv=e.$Uv=e.$Tv=e.$Sv=e.ProvidedOnAutoForward=e.$Rv=e.TunnelPrivacyId=e.TunnelProtocol=e.$Qv=e.$Pv=void 0,e.$Pv=(0,P.$fi)("tunnelService"),e.$Qv=(0,P.$fi)("sharedTunnelsService");var R;(function(a){a.Http="http",a.Https="https"})(R||(e.TunnelProtocol=R={}));var m;(function(a){a.ConstantPrivate="constantPrivate",a.Private="private",a.Public="public"})(m||(e.TunnelPrivacyId=m={}));function f(a){return!!a.forwardPort}e.$Rv=f;var k;(function(a){a[a.Notify=1]="Notify",a[a.OpenBrowser=2]="OpenBrowser",a[a.OpenPreview=3]="OpenPreview",a[a.Silent=4]="Silent",a[a.Ignore=5]="Ignore",a[a.OpenBrowserOnce=6]="OpenBrowserOnce"})(k||(e.ProvidedOnAutoForward=k={}));function O(a){if(a.scheme!=="http"&&a.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(a.authority);if(i)return{address:i[1],port:+i[2]}}e.$Sv=O,e.$Tv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function D(a){return e.$Tv.indexOf(a)>=0}e.$Uv=D,e.$Vv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function l(a){return e.$Vv.indexOf(a)>=0}e.$Wv=l;function E(a,i,n,r){if(n===1)return!1;if(n===2&&l(i)){const c=/(\d+)\.(\d+)\.(\d+)/g.exec(r);if(c?.length===4&&parseInt(c[1])>=18)return!1}return a<1024}e.$Xv=E;class g{constructor(i,n,r){this.remoteAddress=i,this.localAddress=n,this.b=r,this.a=new S.$5d,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Yv=g;let s=class{constructor(i,n){this.k=i,this.l=n,this.a=new S.$5d,this.onTunnelOpened=this.a.event,this.b=new S.$5d,this.onTunnelClosed=this.b.event,this.c=new S.$5d,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const i=this.l.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.i=i.privacyOptions,this.h=i.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const i=[],n=Array.from(this.e.values());for(const r of n){const c=Array.from(r.values());for(const d of c){const t=await d.value;t&&typeof t!="string"&&i.push(t)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:n}of i.values())await n.then(r=>typeof r!="string"?r?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,n,r,c,d){this.q(i,n,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:n,localAddress:r,privacy:c,protocol:d,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,n){(l(i)||D(i))&&(i=e.$Tv[0]);const r=this.s(i,n);if(r)return++r.refcount,r.value}openTunnel(i,n,r,c,d,t=!1,p,u){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${n}:${r} on local port ${d}.`);const o=this.f??i;if(!o)return;if(n||(n="localhost"),c||(c=this.m),this.f&&this.j.has(r)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const v=this.t(o,n,r,c,d,t,p,u);return v?v.then(b=>{if(b){if(typeof b=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(n,r),b}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(n,r);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const $=this.o(b);return(b.tunnelRemoteHost!==n||b.tunnelRemotePort!==r)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),p&&b.privacy!==p&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire($),$}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),v)}o(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const n=this.e.get(i.tunnelRemoteHost);if(n){const r=n.get(i.tunnelRemotePort);r&&(r.refcount--,await this.p(i.tunnelRemoteHost,i.tunnelRemotePort,r))}}}}async p(i,n,r){if(r.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${n}.`);const c=r.value.then(async d=>{d&&typeof d!="string"&&(await d.dispose(!0),this.b.fire({host:d.tunnelRemoteHost,port:d.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(n),c}}async closeTunnel(i,n){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${n} `);const r=this.e.get(i);if(r&&r.has(n)){const c=r.get(n);c.refcount=0,await this.p(i,n,c)}}q(i,n,r){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(n,{refcount:1,value:r})}async r(i,n){const r=this.e.get(i);if(r){const c=r.get(n),d=c?await c.value:void 0;(!d||typeof d=="string")&&r.delete(n),r.size===0&&this.e.delete(i)}}s(i,n){const r=[i];D(i)?(r.push(...e.$Tv),r.push(...e.$Vv)):l(i)&&r.push(...e.$Vv);const c=r.map(d=>this.e.get(d));for(const d of c){const t=d?.get(n);if(t)return t}}canTunnel(i){return!!O(i)}u(i,n,r,c,d,t,p){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${n}:${r} on local port ${c}.`);const u=r;this.j.add(u);const o=c===void 0?r:c,v={elevationRequired:d?this.isPortPrivileged(o):!1},b={remoteAddress:{host:n,port:r},localAddressPort:c,privacy:t,public:t?t!==m.Private:void 0,protocol:p},$=i.forwardPort(b,v);return $?(this.q(n,r,$),$.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(u)})):this.j.delete(u),$}};e.$Zv=s,e.$Zv=s=Ye([He(0,F.$zj),He(1,M.$Li)],s)}),define(Pe[201],Re([1,0,3]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$1v=void 0,e.$1v=(0,S.$fi)("editSessionIdentityService");var M;(function(P){P[P.Complete=100]="Complete",P[P.Partial=50]="Partial",P[P.None=0]="None"})(M||(e.EditSessionIdentityMatch=M={}))}),define(Pe[202],Re([1,0,12]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GL=e.$FL=e.$EL=e.$DL=e.$CL=void 0;function M(f){return f.scheme!==S.Schemas.file&&f.scheme!==S.Schemas.vscodeRemote}e.$CL=M;function P(f){if(f.folders.length)return f.folders.every(k=>M(k.uri))?f.folders[0].uri:void 0;if(f.configuration&&M(f.configuration))return f.configuration}e.$DL=P;function F(f){return P(f)?.scheme}e.$EL=F;function R(f){return P(f)?.authority}e.$FL=R;function m(f){return P(f)!==void 0}e.$GL=m}),define(Pe[47],Re([1,0,159,19,50,24,2,3,12]),function(me,e,S,M,P,F,R,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.WorkbenchState=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=void 0,e.$oi=(0,m.$fi)("contextService");function k(o){const v=o;return typeof v?.id=="string"&&R.URI.isUri(v.uri)}e.$pi=k;function O(o){return typeof o?.id=="string"&&!k(o)&&!l(o)}e.$qi=O,e.$ri={id:"ext-dev"},e.$si={id:"empty-window"};function D(o,v){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,M.$nc)(o)}:v?e.$ri:e.$si;const b=o;return b.configuration?{id:b.id,configPath:b.configuration}:b.folders.length===1?{id:b.id,uri:b.folders[0].uri}:{id:b.id}}e.$ti=D;function l(o){const v=o;return typeof v?.id=="string"&&R.URI.isUri(v.configPath)}e.$ui=l;function E(o){const v=o;if(v?.uri)return{id:v.id,uri:R.URI.revive(v.uri)};const b=o;if(b?.configPath)return{id:b.id,configPath:R.URI.revive(b.configPath)};if(o?.id)return{id:o.id}}e.$vi=E;var g;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})(g||(e.WorkbenchState=g={}));function s(o){const v=o;return!!(v&&typeof v=="object"&&typeof v.id=="string"&&Array.isArray(v.folders))}e.$wi=s;function a(o){const v=o;return!!(v&&typeof v=="object"&&R.URI.isUri(v.uri)&&typeof v.name=="string"&&typeof v.toResource=="function")}e.$xi=a;class i{constructor(v,b,$,I,h){this.h=v,this.j=$,this.k=I,this.l=h,this.c=P.$li.forUris(this.l,()=>!0),this.folders=b}update(v){this.h=v.id,this.k=v.configuration,this.j=v.transient,this.l=v.l,this.folders=v.folders}get folders(){return this.g}set folders(v){this.g=v,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(v){this.k=v}getFolder(v){return v&&this.c.findSubstr(v)||null}n(){this.c=P.$li.forUris(this.l,()=>!0);for(const v of this.folders)this.c.set(v.uri,v)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$yi=i;class n{constructor(v,b){this.raw=b,this.uri=v.uri,this.index=v.index,this.name=v.name}toResource(v){return(0,F.$Sg)(this.uri,v)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$zi=n;function r(o){return new n({uri:o,index:0,name:(0,F.$Og)(o)},{uri:o.toString()})}e.$Ai=r,e.$Bi="code-workspace",e.$Ci=`.${e.$Bi}`,e.$Di=[{name:(0,S.localize)(0,null),extensions:[e.$Bi]}],e.$Ei="workspace.json";function c(o,v){return F.$Jg.isEqualOrParent(o,v.untitledWorkspacesHome)}e.$Fi=c;function d(o){let v;return R.URI.isUri(o)?v=o:v=o.configuration,v?.scheme===f.Schemas.tmp}e.$Gi=d,e.$Hi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(o){return o.id===e.$Hi}e.$Ii=t;function p(o,v){return!c(o,v)&&!d(o)}e.$Ji=p;function u(o){return(typeof o=="string"?(0,M.$oc)(o):(0,F.$Qg)(o))===e.$Ci}e.$Ki=u}),define(Pe[74],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nhc=void 0;class S{static{this.a=!1}constructor(P){this.d=P,this.b=new Map,this.c=1}add(P){const F=this.c++;return this.b.set(F,P),this.e(),F}get(P,F){return this.b.has(P)?this.b.get(P)[F]:void 0}delete(P){this.b.delete(P),this.e()}e(){S.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Nhc=S}),define(Pe[43],Re([1,0,12,24,3]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Thc=e.$Shc=void 0;class F{constructor(){this.a=new Set(Object.keys(S.Schemas)),this.b=new Map,this.extUri=new M.$Hg(m=>{const f=this.b.get(m.scheme);return!(f===void 0||f&1024)})}$acceptProviderInfos(m,f){f===null?this.b.delete(m.scheme):this.b.set(m.scheme,f)}isFreeScheme(m){return!this.b.has(m)&&!this.a.has(m)}getCapabilities(m){return this.b.get(m)}}e.$Shc=F,e.$Thc=(0,P.$fi)("IExtHostFileSystemInfo")}),define(Pe[27],Re([1,0,3]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BO=void 0,e.$BO=(0,S.$fi)("IExtHostInitDataService")}),define(Pe[203],Re([1,0,165,13,190,27]),function(me,e,S,M,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zjc=void 0;let R=class extends P.$IP{constructor(f,k,O){const D=O.remote.isRemote?"remoteexthost":f?"workerexthost":"exthost",l=O.remote.isRemote?(0,S.localize)(0,null):f?(0,S.localize)(1,null):(0,S.localize)(2,null);super(k.createLogger(D,{name:l}))}};e.$Zjc=R,e.$Zjc=R=Ye([He(1,M.$Aj),He(2,F.$BO)],R)}),define(Pe[204],Re([1,0,11]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cic=e.$Bic=void 0;class M{constructor(R,m,f){this.h=new Map,this.a=R,this.b=m,this.c=f,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(k=>(this.f=k,this)),this.g=this.c.onDidChangeStorage(k=>{k.shared===this.b&&k.key===this.a&&(this.f=k.value)}),this.i=new S.$rh(()=>{const k=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const O of k.values())O.complete()}catch(O){for(const D of k.values())D.error(O)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,m){let f=this.f[R];return typeof f>"u"&&(f=m),f}update(R,m){this.f[R]=m;const f=this.h.get(R);if(f!==void 0)return f.p;const k=new S.$Ch;return this.h.set(R,k),this.i.isScheduled()||this.i.schedule(),k.p}dispose(){this.g.dispose()}}e.$Bic=M;class P extends M{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,m){super(R.identifier.value,!0,m),this.j=R}}e.$Cic=P}),define(Pe[205],Re([1,0,5,2]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pjc=void 0;class P{constructor(R){this.c=R,this.a=new S.$5d,this.onDidSaveNotebookDocument=this.a.event,this.b=new S.$5d,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,m,f,k){const D=this.c.getNotebookDocument(M.URI.revive(R)).acceptModelChanged(m.value,f,k);this.b.fire(D)}$acceptDirtyStateChanged(R,m){this.c.getNotebookDocument(M.URI.revive(R)).acceptDirty(m)}$acceptModelSaved(R){const m=this.c.getNotebookDocument(M.URI.revive(R));this.a.fire(m.apiNotebook)}}e.$pjc=P}),define(Pe[17],Re([1,0,3]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mO=e.$lO=void 0,e.$lO=(0,S.$fi)("IExtHostRpcService");class M{constructor(F){this.getProxy=F.getProxy.bind(F),this.set=F.set.bind(F),this.dispose=F.dispose.bind(F),this.assertRegistered=F.assertRegistered.bind(F),this.drain=F.drain.bind(F)}}e.$mO=M}),define(Pe[206],Re([1,0,20,5]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jic=void 0;class P{#e;constructor(R,m){this.b=new M.$5d,this.onDidChange=this.b.event,this.a=S.$zm.toKey(R.identifier),this.#e=m,this.#e.onDidChangePassword(f=>{f.extensionId===this.a&&this.b.fire({key:f.key})})}get(R){return this.#e.get(this.a,R)}store(R,m){return this.#e.store(this.a,R,m)}delete(R){return this.#e.delete(this.a,R)}}e.$Jic=P}),define(Pe[59],Re([1,0,3]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aic=e.$_hc=void 0,e.$_hc=(0,S.$fi)("IURITransformerService");class M{constructor(F){F?(this.transformIncoming=F.transformIncoming.bind(F),this.transformOutgoing=F.transformOutgoing.bind(F),this.transformOutgoingURI=F.transformOutgoingURI.bind(F),this.transformOutgoingScheme=F.transformOutgoingScheme.bind(F)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$aic=M}),define(Pe[207],Re([1,0,23]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jnb=e.$inb=void 0;class M{constructor(){this.buffers=[]}add(f){let k=this.buffers.indexOf(f);return k<0&&(k=this.buffers.length,this.buffers.push(f)),k}}function P(m,f){if(f.serializeBuffersForPostMessage){const k=new M,D=JSON.stringify(m,(E,g)=>{if(g instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:k.add(g)};if(ArrayBuffer.isView(g)){const s=F(g);if(s)return{$$vscode_array_buffer_reference$$:!0,index:k.add(g.buffer),view:{type:s,byteLength:g.byteLength,byteOffset:g.byteOffset}}}return g}),l=k.buffers.map(E=>{const g=new Uint8Array(E);return S.$se.wrap(g)});return{message:D,buffers:l}}else return{message:JSON.stringify(m),buffers:[]}}e.$inb=P;function F(m){switch(m.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(m,f){const k=f.map(l=>{const E=new ArrayBuffer(l.byteLength);return new Uint8Array(E).set(l.buffer),E}),O=f.length?(l,E)=>{if(E&&typeof E=="object"&&E.$$vscode_array_buffer_reference$$){const g=E,{index:s}=g,a=k[s];if(g.view)switch(g.view.type){case 1:return new Int8Array(a,g.view.byteOffset,g.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(a,g.view.byteOffset,g.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(a,g.view.byteOffset,g.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(a,g.view.byteOffset,g.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(a,g.view.byteOffset,g.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(a,g.view.byteOffset,g.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(a,g.view.byteOffset,g.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(a,g.view.byteOffset,g.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(a,g.view.byteOffset,g.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(a,g.view.byteOffset,g.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(a,g.view.byteOffset,g.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return a}return E}:void 0;return{message:JSON.parse(m,O),arrayBuffers:k}}e.$jnb=R}),define(Pe[104],Re([1,0,174,16,2,6,3,30,42,12,41,137,32]),function(me,e,S,M,P,F,R,m,f,k,O,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jF=e.$iF=e.$hF=e.EditorsOrder=e.$gF=e.CloseDirection=e.$fF=e.$eF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$dF=e.$cF=e.$bF=e.$aF=e.$_E=e.$$E=e.$0E=e.$9E=e.EditorInputCapabilities=e.$8E=e.SaveReason=e.Verbosity=e.$7E=e.$6E=e.$5E=e.$4E=e.$3E=e.$2E=e.$1E=e.$ZE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$YE=e.$XE=e.$WE=e.$VE=e.$UE=void 0,e.$UE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$VE={id:"default",displayName:(0,S.localize)(0,null),providerDisplayName:(0,S.localize)(1,null)},e.$WE="workbench.editor.sidebysideEditor",e.$XE="workbench.editors.textDiffEditor",e.$YE="workbench.editors.binaryResourceDiffEditor";var E;(function(ie){ie[ie.PROGRAMMATIC=1]="PROGRAMMATIC",ie[ie.USER=2]="USER",ie[ie.EDIT=3]="EDIT",ie[ie.NAVIGATION=4]="NAVIGATION",ie[ie.JUMP=5]="JUMP"})(E||(e.EditorPaneSelectionChangeReason=E={}));var g;(function(ie){ie[ie.IDENTICAL=1]="IDENTICAL",ie[ie.SIMILAR=2]="SIMILAR",ie[ie.DIFFERENT=3]="DIFFERENT"})(g||(e.EditorPaneSelectionCompareResult=g={}));function s(ie){const le=ie;return!!le&&typeof le.getSelection=="function"&&!!le.onDidChangeSelection}e.$ZE=s;function a(ie,le,W){for(const _ of W.visibleEditorPanes)if(_.group.id===le&&ie.matches(_.input))return _.getViewState()}e.$1E=a;function i(ie){if($(ie))return!1;const le=ie;return P.URI.isUri(le?.resource)}e.$2E=i;function n(ie){if($(ie))return!1;const le=ie;return le?.original!==void 0&&le.modified!==void 0}e.$3E=n;function r(ie){if($(ie))return!1;const le=ie;return!le||le.resources&&!Array.isArray(le.resources)?!1:!!le.resources||!!le.multiDiffSource}e.$4E=r;function c(ie){if($(ie)||n(ie))return!1;const le=ie;return le?.primary!==void 0&&le.secondary!==void 0}e.$5E=c;function d(ie){if($(ie))return!1;const le=ie;return le?le.resource===void 0||le.resource.scheme===k.Schemas.untitled||le.forceUntitled===!0:!1}e.$6E=d;function t(ie){if($(ie))return!1;const le=ie;return P.URI.isUri(le?.base?.resource)&&P.URI.isUri(le?.input1?.resource)&&P.URI.isUri(le?.input2?.resource)&&P.URI.isUri(le?.result?.resource)}e.$7E=t;var p;(function(ie){ie[ie.SHORT=0]="SHORT",ie[ie.MEDIUM=1]="MEDIUM",ie[ie.LONG=2]="LONG"})(p||(e.Verbosity=p={}));var u;(function(ie){ie[ie.EXPLICIT=1]="EXPLICIT",ie[ie.AUTO=2]="AUTO",ie[ie.FOCUS_CHANGE=3]="FOCUS_CHANGE",ie[ie.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(u||(e.SaveReason=u={}));class o{constructor(){this.a=new Map}registerSource(le,W){let _=this.a.get(le);return _||(_={source:le,label:W},this.a.set(le,_)),_.source}getSourceLabel(le){return this.a.get(le)?.label??le}}e.$8E=new o;var v;(function(ie){ie[ie.None=0]="None",ie[ie.Readonly=2]="Readonly",ie[ie.Untitled=4]="Untitled",ie[ie.Singleton=8]="Singleton",ie[ie.RequiresTrust=16]="RequiresTrust",ie[ie.CanSplitInGroup=32]="CanSplitInGroup",ie[ie.ForceDescription=64]="ForceDescription",ie[ie.CanDropIntoEditor=128]="CanDropIntoEditor",ie[ie.MultipleEditors=256]="MultipleEditors",ie[ie.Scratchpad=512]="Scratchpad",ie[ie.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(v||(e.EditorInputCapabilities=v={}));class b extends F.$Tc{}e.$9E=b;function $(ie){return ie instanceof b}e.$0E=$;function I(ie){const le=ie;return P.URI.isUri(le?.preferredResource)}function h(ie){const le=ie;return $(le?.primary)&&$(le?.secondary)}e.$$E=h;function y(ie){const le=ie;return $(le?.modified)&&$(le?.original)}e.$_E=y;function w(ie,le,W,_,ke){return $e(_,[(0,D.$2i)({id:"workbench.action.openLargeFile",label:(0,S.localize)(2,null),run:()=>{const Ne={...W,limits:{size:Number.MAX_VALUE}};ie.openEditor(le,Ne)}}),(0,D.$2i)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,S.localize)(3,null),run:()=>ke.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:l.default.Warning})}e.$aF=w;function A(ie){return $(ie?.editor)}e.$bF=A;function N(ie){const le=ie;return A(ie)&&le?.group!==void 0}e.$cF=N;function G(ie){const le=ie;return typeof le?.groupId=="number"&&$(le.editor)}e.$dF=G;var V;(function(ie){ie[ie.UNKNOWN=0]="UNKNOWN",ie[ie.REPLACE=1]="REPLACE",ie[ie.MOVE=2]="MOVE",ie[ie.UNPIN=3]="UNPIN"})(V||(e.EditorCloseContext=V={}));var U;(function(ie){ie[ie.GROUP_ACTIVE=0]="GROUP_ACTIVE",ie[ie.GROUP_INDEX=1]="GROUP_INDEX",ie[ie.GROUP_LABEL=2]="GROUP_LABEL",ie[ie.GROUP_LOCKED=3]="GROUP_LOCKED",ie[ie.EDITOR_OPEN=4]="EDITOR_OPEN",ie[ie.EDITOR_CLOSE=5]="EDITOR_CLOSE",ie[ie.EDITOR_MOVE=6]="EDITOR_MOVE",ie[ie.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ie[ie.EDITOR_LABEL=8]="EDITOR_LABEL",ie[ie.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ie[ie.EDITOR_PIN=10]="EDITOR_PIN",ie[ie.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",ie[ie.EDITOR_STICKY=12]="EDITOR_STICKY",ie[ie.EDITOR_DIRTY=13]="EDITOR_DIRTY",ie[ie.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(U||(e.GroupModelChangeKind=U={}));var C;(function(ie){ie[ie.PRIMARY=1]="PRIMARY",ie[ie.SECONDARY=2]="SECONDARY",ie[ie.BOTH=3]="BOTH",ie[ie.ANY=4]="ANY"})(C||(e.SideBySideEditor=C={}));class L{getOriginalUri(le,W){if(!le)return;if(t(le))return e.$fF.getOriginalUri(le.result,W);if(W?.supportSideBySide){const{primary:ke,secondary:Ne}=this.a(le);if(ke&&Ne){if(W?.supportSideBySide===C.BOTH)return{primary:this.getOriginalUri(ke,{filterByScheme:W.filterByScheme}),secondary:this.getOriginalUri(Ne,{filterByScheme:W.filterByScheme})};if(W?.supportSideBySide===C.ANY)return this.getOriginalUri(ke,{filterByScheme:W.filterByScheme})??this.getOriginalUri(Ne,{filterByScheme:W.filterByScheme});le=W.supportSideBySide===C.PRIMARY?ke:Ne}}if(n(le)||r(le)||c(le)||t(le))return;const _=I(le)?le.preferredResource:le.resource;return!_||!W||!W.filterByScheme?_:this.b(_,W.filterByScheme)}a(le){return h(le)||c(le)?{primary:le.primary,secondary:le.secondary}:y(le)||n(le)?{primary:le.modified,secondary:le.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(le,W){if(!le)return;if(t(le))return e.$fF.getCanonicalUri(le.result,W);if(W?.supportSideBySide){const{primary:ke,secondary:Ne}=this.a(le);if(ke&&Ne){if(W?.supportSideBySide===C.BOTH)return{primary:this.getCanonicalUri(ke,{filterByScheme:W.filterByScheme}),secondary:this.getCanonicalUri(Ne,{filterByScheme:W.filterByScheme})};if(W?.supportSideBySide===C.ANY)return this.getCanonicalUri(ke,{filterByScheme:W.filterByScheme})??this.getCanonicalUri(Ne,{filterByScheme:W.filterByScheme});le=W.supportSideBySide===C.PRIMARY?ke:Ne}}if(n(le)||r(le)||c(le)||t(le))return;const _=le.resource;return!_||!W||!W.filterByScheme?_:this.b(_,W.filterByScheme)}b(le,W){if(Array.isArray(W)){if(W.some(_=>le.scheme===_))return le}else if(W===le.scheme)return le}}var q;(function(ie){ie[ie.UNKNOWN=0]="UNKNOWN",ie[ie.KEYBOARD=1]="KEYBOARD",ie[ie.MOUSE=2]="MOUSE"})(q||(e.EditorCloseMethod=q={}));function ne(ie,le,W,_){if(!ie.isSticky(le))return!1;switch(_.preventPinnedEditorClose){case"keyboardAndMouse":return W===q.MOUSE||W===q.KEYBOARD;case"mouse":return W===q.MOUSE;case"keyboard":return W===q.KEYBOARD}return!1}e.$eF=ne,e.$fF=new L;var ae;(function(ie){ie[ie.LEFT=0]="LEFT",ie[ie.RIGHT=1]="RIGHT"})(ae||(e.CloseDirection=ae={}));class ye{constructor(){this.c=new Map,this.d=new Map}start(le){const W=this.a=le.get(R.$ei);for(const[_,ke]of this.c)this.e(_,ke,W);this.c.clear()}e(le,W,_){const ke=_.createInstance(W);this.d.set(le,ke)}registerFileEditorFactory(le){if(this.b)throw new Error("Can only register one file editor factory.");this.b=le}getFileEditorFactory(){return(0,M.$4f)(this.b)}registerEditorSerializer(le,W){if(this.c.has(le)||this.d.has(le))throw new Error(`A editor serializer with type ID '${le}' was already registered.`);return this.a?this.e(le,W,this.a):this.c.set(le,W),(0,F.$Rc)(()=>{this.c.delete(le),this.d.delete(le)})}getEditorSerializer(le){return this.d.get(typeof le=="string"?le:le.typeId)}}m.$Wn.add(e.$UE.EditorFactory,new ye);async function Ie(ie,le,W){return!ie||!ie.length?[]:await Promise.all(ie.map(async _=>{const ke=P.URI.revive(_.fileUri);if(!ke){W.info("Cannot resolve the path because it is not valid.",_);return}if(!await le.canHandleResource(ke)){W.info("Cannot resolve the path because it cannot be handled",_);return}let De=_.exists,be=_.type;if(typeof De!="boolean"||typeof be!="number")try{be=(await le.stat(ke)).isDirectory?f.FileType.Directory:f.FileType.Unknown,De=!0}catch(J){W.error(J),De=!1}if(!De&&_.openOnlyIfExists){W.info("Cannot resolve the path because it does not exist",_);return}if(be===f.FileType.Directory){W.info("Cannot resolve the path because it is a directory",_);return}const ge={..._.options,pinned:!0};return De?{resource:ke,options:ge}:{resource:ke,options:ge,forceUntitled:!0}}))}e.$gF=Ie;var ue;(function(ie){ie[ie.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ie[ie.SEQUENTIAL=1]="SEQUENTIAL"})(ue||(e.EditorsOrder=ue={}));function ve(ie){const le=ie;if(!le)return!1;const W=le;if(W.modified)return ve(W.modified);const _=le;return!!(_.contributionsState&&_.viewState&&Array.isArray(_.cursorState))}e.$hF=ve;function re(ie){return(0,O.$4i)(ie)}e.$iF=re;function $e(ie,le,W){const _=(0,O.$5i)(ie,le);return _.forceMessage=W?.forceMessage,_.forceSeverity=W?.forceSeverity,_.allowDialog=W?.allowDialog,_}e.$jF=$e}),define(Pe[208],Re([1,0,5,175,3,6,28,30,18,26,91,199]),function(me,e,S,M,P,F,R,m,f,k,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rF=e.$qF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$pF=e.ViewContentGroups=e.$oF=e.$nF=e.ViewContainerLocation=e.Extensions=e.$mF=e.$lF=e.$kF=void 0,e.$kF="views",e.$lF=(0,M.localize)(0,null),e.$mF=(0,D.$Mw)("default-view-icon",O.$ok.window,(0,M.localize)(1,null));var l;(function(p){p.ViewContainersRegistry="workbench.registry.view.containers",p.ViewsRegistry="workbench.registry.view"})(l||(e.Extensions=l={}));var E;(function(p){p[p.Sidebar=0]="Sidebar",p[p.Panel=1]="Panel",p[p.AuxiliaryBar=2]="AuxiliaryBar"})(E||(e.ViewContainerLocation=E={})),e.$nF=[0,1,2];function g(p){switch(p){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$oF=g;class s extends F.$Tc{constructor(){super(...arguments),this.c=this.B(new S.$5d),this.onDidRegister=this.c.event,this.f=this.B(new S.$5d),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,f.$Rb)([...this.g.values()])}registerViewContainer(u,o,v){const b=this.get(u.id);if(b)return b;const $=u;return $.openCommandActionDescriptor=v?.doNotRegisterOpenCommand?void 0:$.openCommandActionDescriptor??{id:$.id},(0,R.$xc)(this.g,o,[]).push($),v?.isDefault&&this.h.push($),this.c.fire({viewContainer:$,viewContainerLocation:o}),$}deregisterViewContainer(u){for(const o of this.g.keys()){const v=this.g.get(o),b=v?.indexOf(u);if(b!==-1){v?.splice(b,1),v.length===0&&this.g.delete(o),this.f.fire({viewContainer:u,viewContainerLocation:o});return}}}get(u){return this.all.filter(o=>o.id===u)[0]}getViewContainers(u){return[...this.g.get(u)||[]]}getViewContainerLocation(u){return[...this.g.keys()].filter(o=>this.getViewContainers(o).filter(v=>v?.id===u.id).length>0)[0]}getDefaultViewContainer(u){return this.h.find(o=>this.getViewContainerLocation(o)===u)}}m.$Wn.add(l.ViewContainersRegistry,new s);var a;(function(p){p.Open="2_open",p.Debug="4_debug",p.SCM="5_scm",p.More="9_more"})(a||(e.ViewContentGroups=a={}));function i(p,u){const o=p.group??a.More,v=u.group??a.More;return o!==v?o.localeCompare(v):(p.order??5)-(u.order??5)}class n extends F.$Tc{constructor(){super(...arguments),this.c=this.B(new S.$5d),this.onViewsRegistered=this.c.event,this.f=this.B(new S.$5d),this.onViewsDeregistered=this.f.event,this.g=this.B(new S.$5d),this.onDidChangeContainer=this.g.event,this.h=this.B(new S.$5d),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Gc}registerViews(u,o){this.registerViews2([{views:u,viewContainer:o}])}registerViews2(u){u.forEach(({views:o,viewContainer:v})=>this.r(o,v)),this.c.fire(u)}deregisterViews(u,o){const v=this.s(u,o);v.length&&this.f.fire({views:v,viewContainer:o})}moveViews(u,o){for(const v of this.m.keys())if(v!==o){const b=this.s(u,v);b.length&&(this.r(b,o),this.g.fire({views:b,from:v,to:o}))}}getViews(u){return this.m.get(u)||[]}getView(u){for(const o of this.j){const v=(this.m.get(o)||[]).filter(b=>b.id===u)[0];if(v)return v}return null}getViewContainer(u){for(const o of this.j)if((this.m.get(o)||[]).filter(b=>b.id===u)[0])return o;return null}registerViewWelcomeContent(u,o){return this.n.add(u,o),this.h.fire(u),(0,F.$Rc)(()=>{this.n.delete(u,o),this.h.fire(u)})}registerViewWelcomeContent2(u,o){const v=new Map;for(const[b,$]of o)this.n.add(u,$),v.set(b,(0,F.$Rc)(()=>{this.n.delete(u,$),this.h.fire(u)}));return this.h.fire(u),v}getViewWelcomeContent(u){const o=[];return this.n.forEach(u,v=>o.push(v)),o.sort(i)}r(u,o){let v=this.m.get(o);v||(v=[],this.m.set(o,v),this.j.push(o));for(const b of u){if(this.getView(b.id)!==null)throw new Error((0,M.localize)(2,null,b.id));v.push(b)}}s(u,o){const v=this.m.get(o);if(!v)return[];const b=[],$=[];for(const I of v)u.includes(I)?b.push(I):$.push(I);return b.length&&($.length?this.m.set(o,$):(this.m.delete(o),this.j.splice(this.j.indexOf(o),1))),b}}m.$Wn.add(l.ViewsRegistry,new n),e.$pF=(0,P.$fi)("viewDescriptorService");var r;(function(p){p[p.Default=0]="Default",p[p.Expand=1]="Expand"})(r||(e.ViewVisibilityState=r={}));var c;(function(p){p[p.None=0]="None",p[p.Collapsed=1]="Collapsed",p[p.Expanded=2]="Expanded"})(c||(e.TreeItemCollapsibleState=c={}));class d{constructor(u,o){this.c=!1,this.d=!1,(0,k.$Nn)(this,u),this.d=!!o,this.resolve=async v=>{if(o&&!this.c){const b=await o(v);b&&(this.tooltip=this.tooltip??b.tooltip,this.command=this.command??b.command)}v.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$qF=d;class t extends Error{constructor(u){super((0,M.localize)(3,null,u)),this.name="NoTreeViewError"}static is(u){return u.name==="NoTreeViewError"}}e.$rF=t}),define(Pe[209],Re([1,0,2,29,3]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BF=e.$AF=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$zF=e.$yF=void 0;function F(k){return!!k&&typeof k=="object"&&"uri"in k&&k.uri instanceof S.URI&&"version"in k&&typeof k.version=="number"&&"ranges"in k&&Array.isArray(k.ranges)&&k.ranges.every(M.$9s.isIRange)}e.$yF=F;function R(k){return!!k&&typeof k=="object"&&"documents"in k&&Array.isArray(k.documents)&&k.documents.every(F)}e.$zF=R;var m;(function(k){k[k.Down=0]="Down",k[k.Up=1]="Up"})(m||(e.InteractiveSessionVoteDirection=m={}));var f;(function(k){k[k.Action=1]="Action",k[k.Toolbar=2]="Toolbar"})(f||(e.ChatCopyKind=f={})),e.$AF=(0,P.$fi)("IChatService"),e.$BF="accessibility.voice.keywordActivation"}),define(Pe[210],Re([1,0,5,11,176]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Onb=void 0;class F{constructor(){this.f=new Map,this.m=[],this.n=new S.$5d,this.o=new S.$5d,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(m){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=m}onEvent(m){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=m}onRequest(m){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=m}sendResponse(m){m.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${m.command}`)):this.u("response",m)}sendRequest(m,f,k,O){const D={command:m};if(f&&Object.keys(f).length>0&&(D.arguments=f),this.u("request",D),typeof O=="number"){const l=setTimeout(()=>{clearTimeout(l);const E=this.f.get(D.seq);if(E){this.f.delete(D.seq);const g={type:"response",seq:0,request_seq:D.seq,success:!1,command:m,message:(0,P.localize)(0,null,O,m)};E(g)}},O)}return k&&this.f.set(D.seq,k),D.seq}acceptMessage(m){this.k?this.k(m):(this.m.push(m),this.m.length===1&&this.s())}q(m,f){return m.type!=="event"||f.type!=="event"}async s(){let m;for(;this.m.length;){if((!m||this.q(this.m[0],m))&&await(0,M.$gh)(0),m=this.m.shift(),!m)return;switch(m.type){case"event":this.j?.(m);break;case"request":this.g?.(m);break;case"response":{const f=m,k=this.f.get(f.request_seq);k&&(this.f.delete(f.request_seq),k(f));break}}}}u(m,f){f.type=m,f.seq=this.d++,this.sendMessage(f)}async w(){if(this.f.size===0)return Promise.resolve();const m=new Map;this.f.forEach((f,k)=>m.set(k,f)),await(0,M.$gh)(500),m.forEach((f,k)=>{f({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.f.delete(k)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$Onb=F}),define(Pe[211],Re([1,0,2,177,35,3]),function(me,e,S,M,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$BI=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$AI=e.MemoryRangeType=e.$zI=e.State=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.$oI=e.$nI=e.$mI=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.$gI=e.$fI=e.$eI=e.$dI=e.$cI=e.$bI=e.$aI=e.$_H=e.$$H=e.$0H=e.$9H=e.$8H=e.$7H=e.$6H=e.$5H=e.$4H=e.$3H=e.$2H=e.$1H=e.$ZH=e.$YH=e.$XH=e.$WH=e.$VH=e.$UH=e.$TH=e.$SH=e.$RH=e.$QH=e.$PH=e.$OH=e.$NH=e.$MH=e.$LH=e.$KH=e.$JH=e.$IH=e.$HH=e.$GH=e.$FH=e.$EH=e.$DH=e.$CH=e.$BH=e.$AH=e.$zH=e.$yH=e.$xH=e.$wH=e.$vH=e.$uH=e.$tH=e.$sH=e.$rH=e.$qH=void 0,e.$qH="workbench.view.debug",e.$rH="workbench.debug.variablesView",e.$sH="workbench.debug.watchExpressionsView",e.$tH="workbench.debug.callStackView",e.$uH="workbench.debug.loadedScriptsView",e.$vH="workbench.debug.breakPointsView",e.$wH="workbench.debug.disassemblyView",e.$xH="workbench.panel.repl",e.$yH="workbench.panel.repl.view",e.$zH=new P.$wj("debugType",void 0,{type:"string",description:M.localize(0,null)}),e.$AH=new P.$wj("debugConfigurationType",void 0,{type:"string",description:M.localize(1,null)}),e.$BH=new P.$wj("debugState","inactive",{type:"string",description:M.localize(2,null)}),e.$CH="debugUx",e.$DH=new P.$wj(e.$CH,"default",{type:"string",description:M.localize(3,null)}),e.$EH=new P.$wj("hasDebugged",!1,{type:"boolean",description:M.localize(4,null)}),e.$FH=new P.$wj("inDebugMode",!1,{type:"boolean",description:M.localize(5,null)}),e.$GH=new P.$wj("inDebugRepl",!1,{type:"boolean",description:M.localize(6,null)}),e.$HH=new P.$wj("breakpointWidgetVisible",!1,{type:"boolean",description:M.localize(7,null)}),e.$IH=new P.$wj("inBreakpointWidget",!1,{type:"boolean",description:M.localize(8,null)}),e.$JH=new P.$wj("breakpointsFocused",!0,{type:"boolean",description:M.localize(9,null)}),e.$KH=new P.$wj("watchExpressionsFocused",!0,{type:"boolean",description:M.localize(10,null)}),e.$LH=new P.$wj("watchExpressionsExist",!1,{type:"boolean",description:M.localize(11,null)}),e.$MH=new P.$wj("variablesFocused",!0,{type:"boolean",description:M.localize(12,null)}),e.$NH=new P.$wj("expressionSelected",!1,{type:"boolean",description:M.localize(13,null)}),e.$OH=new P.$wj("breakpointInputFocused",!1,{type:"boolean",description:M.localize(14,null)}),e.$PH=new P.$wj("callStackItemType",void 0,{type:"string",description:M.localize(15,null)}),e.$QH=new P.$wj("callStackSessionIsAttach",!1,{type:"boolean",description:M.localize(16,null)}),e.$RH=new P.$wj("callStackItemStopped",!1,{type:"boolean",description:M.localize(17,null)}),e.$SH=new P.$wj("callStackSessionHasOneThread",!1,{type:"boolean",description:M.localize(18,null)}),e.$TH=new P.$wj("watchItemType",void 0,{type:"string",description:M.localize(19,null)}),e.$UH=new P.$wj("canViewMemory",void 0,{type:"boolean",description:M.localize(20,null)}),e.$VH=new P.$wj("breakpointItemType",void 0,{type:"string",description:M.localize(21,null)}),e.$WH=new P.$wj("breakpointHasModes",!1,{type:"boolean",description:M.localize(22,null)}),e.$XH=new P.$wj("breakpointSupportsCondition",!1,{type:"boolean",description:M.localize(23,null)}),e.$YH=new P.$wj("loadedScriptsSupported",!1,{type:"boolean",description:M.localize(24,null)}),e.$ZH=new P.$wj("loadedScriptsItemType",void 0,{type:"string",description:M.localize(25,null)}),e.$1H=new P.$wj("focusedSessionIsAttach",!1,{type:"boolean",description:M.localize(26,null)}),e.$2H=new P.$wj("focusedSessionIsNoDebug",!1,{type:"boolean",description:M.localize(27,null)}),e.$3H=new P.$wj("stepBackSupported",!1,{type:"boolean",description:M.localize(28,null)}),e.$4H=new P.$wj("restartFrameSupported",!1,{type:"boolean",description:M.localize(29,null)}),e.$5H=new P.$wj("stackFrameSupportsRestart",!1,{type:"boolean",description:M.localize(30,null)}),e.$6H=new P.$wj("jumpToCursorSupported",!1,{type:"boolean",description:M.localize(31,null)}),e.$7H=new P.$wj("stepIntoTargetsSupported",!1,{type:"boolean",description:M.localize(32,null)}),e.$8H=new P.$wj("breakpointsExist",!1,{type:"boolean",description:M.localize(33,null)}),e.$9H=new P.$wj("debuggersAvailable",!1,{type:"boolean",description:M.localize(34,null)}),e.$0H=new P.$wj("debugExtensionAvailable",!0,{type:"boolean",description:M.localize(35,null)}),e.$$H=new P.$wj("debugProtocolVariableMenuContext",void 0,{type:"string",description:M.localize(36,null)}),e.$_H=new P.$wj("debugSetVariableSupported",!1,{type:"boolean",description:M.localize(37,null)}),e.$aI=new P.$wj("debugSetExpressionSupported",!1,{type:"boolean",description:M.localize(38,null)}),e.$bI=new P.$wj("breakWhenValueChangesSupported",!1,{type:"boolean",description:M.localize(39,null)}),e.$cI=new P.$wj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:M.localize(40,null)}),e.$dI=new P.$wj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:M.localize(41,null)}),e.$eI=new P.$wj("terminateDebuggeeSupported",!1,{type:"boolean",description:M.localize(42,null)}),e.$fI=new P.$wj("suspendDebuggeeSupported",!1,{type:"boolean",description:M.localize(43,null)}),e.$gI=new P.$wj("variableEvaluateNamePresent",!1,{type:"boolean",description:M.localize(44,null)}),e.$hI=new P.$wj("variableIsReadonly",!1,{type:"boolean",description:M.localize(45,null)}),e.$iI=new P.$wj("variableValue",!1,{type:"string",description:M.localize(46,null)}),e.$jI=new P.$wj("variableType",!1,{type:"string",description:M.localize(47,null)}),e.$kI=new P.$wj("variableName",!1,{type:"string",description:M.localize(48,null)}),e.$lI=new P.$wj("variableLanguage",!1,{type:"string",description:M.localize(49,null)}),e.$mI=new P.$wj("variableExtensionId",!1,{type:"string",description:M.localize(50,null)}),e.$nI=new P.$wj("exceptionWidgetVisible",!1,{type:"boolean",description:M.localize(51,null)}),e.$oI=new P.$wj("multiSessionRepl",!1,{type:"boolean",description:M.localize(52,null)}),e.$pI=new P.$wj("multiSessionDebug",!1,{type:"boolean",description:M.localize(53,null)}),e.$qI=new P.$wj("disassembleRequestSupported",!1,{type:"boolean",description:M.localize(54,null)}),e.$rI=new P.$wj("disassemblyViewFocus",!1,{type:"boolean",description:M.localize(55,null)}),e.$sI=new P.$wj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:M.localize(56,null)}),e.$tI=new P.$wj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:M.localize(57,null)});const R=i=>M.localize(58,null,i);e.$uI=R,e.$vI="editor.contrib.debug",e.$wI="editor.contrib.breakpoint",e.$xI="debug",e.$yI={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:M.localize(59,null)};var m;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(m||(e.State=m={}));function f(i){switch(i){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$zI=f;var k;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(k||(e.MemoryRangeType=k={})),e.$AI="vscode-debug-memory";var O;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(O||(e.DebugConfigurationProviderTriggerKind=O={}));var D;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(D||(e.DebuggerString=D={})),e.$BI=(0,F.$fi)("debugService");var l;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(l||(e.BreakpointWidgetContext=l={}));var E;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(E||(e.DebugVisualizationType=E={}));var g;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(g||(e.DebugTreeItemCollapsibleState=g={}));var s;(function(i){i.deserialize=n=>n,i.serialize=n=>n})(s||(e.IDebugVisualizationTreeItem=s={}));var a;(function(i){i.deserialize=n=>({id:n.id,name:n.name,iconPath:n.iconPath&&{light:S.URI.revive(n.iconPath.light),dark:S.URI.revive(n.iconPath.dark)},iconClass:n.iconClass,visualization:n.visualization}),i.serialize=n=>n})(a||(e.IDebugVisualization=a={}))}),define(Pe[212],Re([1,0,15,2,19,26,12,29,25,18]),function(me,e,S,M,P,F,R,m,f,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=void 0;const O=/{([^}]+)}/g;function D(I,h,y){return I.replace(O,function(w,A){return h&&A.length>0&&A[0]!=="_"?w:y&&y.hasOwnProperty(A)?y[A]:w})}e.$sG=D;function l(I){const h={};for(const y of Object.keys(I))y.startsWith("!")||(h[y]=I[y]);return h}e.$tG=l;function E(I){return I.configuration.request==="attach"&&!g(I)&&(!I.parentSession||E(I.parentSession))}e.$uG=E;function g(I){let h=I.configuration.type;if(h)return h==="vslsShare"&&(h=I.configuration.adapterProxy.configuration.type),(0,S.$jf)(h,"extensionhost")||(0,S.$jf)(h,"pwa-extensionhost")?I:I.parentSession?g(I.parentSession):void 0}e.$vG=g;function s(I){return I.type&&(I.label||I.program||I.runtime)}e.$wG=s;function a(I,h,y){let w,A=0;const N=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let G=null;for(;G=N.exec(I);){const V=G.index+1,U=V+G[0].length;if(V<=h&&U>=y){w=G[0],A=V;break}}if(w){const V=/\w+/g;let U=null;for(;(U=V.exec(w))&&!(U.index+1+A+U[0].length>=y););U&&(w=w.substring(0,V.lastIndex))}return w?{start:A,end:A+w.length-1}:{start:0,end:0}}e.$xG=a;async function i(I,h,y,w){if(I.evaluatableExpressionProvider.has(h)){const A=I.evaluatableExpressionProvider.ordered(h),N=(0,k.$Hb)(await Promise.all(A.map(async G=>{try{return await G.provideEvaluatableExpression(h,y,w??f.CancellationToken.None)}catch{return}})));if(N.length>0){let G=N[0].expression;const V=N[0].range;return G||(G=h.getLineContent(y.lineNumber).substring(V.startColumn-1,V.endColumn-1)),{range:V,matchingExpression:G}}}else{const A=h.getLineContent(y.lineNumber),{start:N,end:G}=a(A,y.column,y.column),V=A.substring(N-1,G);return{matchingExpression:V,range:new m.$9s(y.lineNumber,N,y.lineNumber,N+V.length)}}return null}e.$yG=i;const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function r(I){return!!(I&&I.match(n))}e.$zG=r;function c(I){if(typeof I.path=="string"&&!(typeof I.sourceReference=="number"&&I.sourceReference>0)){if(r(I.path))return M.URI.parse(I.path);if((0,P.$ic)(I.path))return M.URI.file(I.path)}return I.path}function d(I){if(typeof I.path=="object"){const h=M.URI.revive(I.path);if(h)return h.scheme===R.Schemas.file?h.fsPath:h.toString()}return I.path}function t(I,h){const y=h?c:d,w=(0,F.$Kn)(I);return u(w,(A,N)=>{A&&N&&(N.path=y(N))}),w}e.$AG=t;function p(I,h){const y=h?c:d,w=(0,F.$Kn)(I);return u(w,(A,N)=>{!A&&N&&(N.path=y(N))}),w}e.$BG=p;function u(I,h){switch(I.type){case"event":{const y=I;switch(y.event){case"output":h(!1,y.body.source);break;case"loadedSource":h(!1,y.body.source);break;case"breakpoint":h(!1,y.body.breakpoint.source);break;default:break}break}case"request":{const y=I;switch(y.command){case"setBreakpoints":h(!0,y.arguments.source);break;case"breakpointLocations":h(!0,y.arguments.source);break;case"source":h(!0,y.arguments.source);break;case"gotoTargets":h(!0,y.arguments.source);break;case"launchVSCode":y.arguments.args.forEach(w=>h(!1,w));break;default:break}break}case"response":{const y=I;if(y.success&&y.body)switch(y.command){case"stackTrace":y.body.stackFrames.forEach(w=>h(!1,w.source));break;case"loadedSources":y.body.sources.forEach(w=>h(!1,w));break;case"scopes":y.body.scopes.forEach(w=>h(!1,w.source));break;case"setFunctionBreakpoints":y.body.breakpoints.forEach(w=>h(!1,w.source));break;case"setBreakpoints":y.body.breakpoints.forEach(w=>h(!1,w.source));break;case"disassemble":y.body?.instructions.forEach(A=>h(!1,A.location));break;default:break}break}}}function o(I){return I.filter(h=>!h.presentation?.hidden).sort((h,y)=>h.presentation?y.presentation?h.presentation.group?y.presentation.group?h.presentation.group!==y.presentation.group?h.presentation.group.localeCompare(y.presentation.group):v(h.presentation.order,y.presentation.order):-1:y.presentation.group?1:v(h.presentation.order,y.presentation.order):-1:y.presentation?1:0)}e.$CG=o;function v(I,h){return typeof I!="number"?typeof h!="number"?0:1:typeof h!="number"?-1:I-h}async function b(I,h){const y=I.getValue("debug.saveBeforeStart",{overrideIdentifier:h.activeTextEditorLanguageId});if(y!=="none"&&(await h.saveAll(),y==="allEditorsInActiveGroup")){const w=h.activeEditorPane;w&&w.input.resource?.scheme===R.Schemas.untitled&&await h.save({editor:w.input,groupId:w.group.id})}await I.reloadConfiguration()}e.$DG=b;const $=(I,h)=>!I||!h?I===h:I.name===h.name&&I.path===h.path&&I.sourceReference===h.sourceReference;e.$EG=$}),define(Pe[213],Re([1,0,3]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0J=e.CellExecutionUpdateType=void 0;var M;(function(P){P[P.Output=1]="Output",P[P.OutputItems=2]="OutputItems",P[P.ExecutionState=3]="ExecutionState"})(M||(e.CellExecutionUpdateType=M={})),e.$0J=(0,S.$fi)("INotebookExecutionService")}),define(Pe[214],Re([1,0,3]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0gb=e.$9gb=e.ProxyKernelState=e.$8gb=void 0,e.$8gb=100;var M;(function(P){P[P.Disconnected=1]="Disconnected",P[P.Connected=2]="Connected",P[P.Initializing=3]="Initializing"})(M||(e.ProxyKernelState=M={})),e.$9gb=(0,S.$fi)("INotebookKernelService"),e.$0gb=(0,S.$fi)("INotebookKernelHistoryService")}),define(Pe[215],Re([1,0,6,29,147,95]),function(me,e,S,M,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xTb=void 0;class R extends S.$Tc{constructor(f,k,O){super(),this._source=f,this.b=k,this.c=O,this.a=void 0}f(f){const k=f.getLineCount();return new M.$9s(1,1,k,this.g(f,k))}g(f,k){if(k<1||k>f.getLineCount())throw new Error("Illegal value for lineNumber");return f.getLineLength(k)+1}get inputTextBuffer(){if(!this.b){const f=new P.$rC;f.acceptChunk(this._source);const k=f.finish(!0),{textBuffer:O,disposable:D}=k.create(1);this.b=O,this.B(D)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(f=>{const k=new P.$rC;k.acceptChunk(f);const O=k.finish(!0),{textBuffer:D,disposable:l}=O.create(1);return this.B(l),D})),this.a}findInInputs(f){const O=new F.$fC(f,!1,!1,null).parseSearchRequest();if(!O)return[];const D=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(D,O,!0,5e3)}findInOutputs(f){const O=new F.$fC(f,!1,!1,null).parseSearchRequest();return O?this.outputTextBuffers.map(D=>{const l=D.findMatchesLineByLine(this.f(D),O,!0,5e3);if(l.length!==0)return{textBuffer:D,matches:l}}).filter(D=>!!D):[]}}e.$xTb=R}),define(Pe[48],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WK=e.TestPosition=e.TestIdPathParts=void 0;var S;(function(F){F.Delimiter="\0"})(S||(e.TestIdPathParts=S={}));var M;(function(F){F[F.IsSame=0]="IsSame",F[F.Disconnected=1]="Disconnected",F[F.IsChild=2]="IsChild",F[F.IsParent=3]="IsParent"})(M||(e.TestPosition=M={}));class P{static fromExtHostTestItem(R,m,f=R.parent){if(R._isRoot)return new P([m]);const k=[R.id];for(let O=f;O&&O.id!==m;O=O.parent)k.push(O.id);return k.push(m),new P(k.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const m=R.indexOf("\0");return m===-1?R:R.slice(0,m)}static fromString(R){return new P(R.split("\0"))}static join(R,m){return new P([...R.path,m])}static joinToString(R,m){return R.toString()+"\0"+m}static parentId(R){const m=R.lastIndexOf("\0");return m===-1?void 0:R.slice(0,m)}static localId(R){const m=R.lastIndexOf("\0");return m===-1?R:R.slice(m+1)}static isChild(R,m){return m.startsWith(R)&&m[R.length]==="\0"}static compare(R,m){return R===m?0:P.isChild(R,m)?2:P.isChild(m,R)?3:1}constructor(R,m=R.length){if(this.path=R,this.d=m,R.length===0||m<1)throw new Error("cannot create test with empty path")}get rootId(){return new P(this.path,1)}get parentId(){return this.d>1?new P(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new P(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new P(this.path,R)}compare(R){if(typeof R=="string")return P.compare(this.toString(),R);for(let m=0;m<R.d&&m<this.d;m++)if(R.path[m]!==this.path[m])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.$WK=P}),define(Pe[60],Re([1,0,2,93,29,48]),function(me,e,S,M,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5K=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$4K=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$3K=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$2K=e.$1K=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$ZK=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$YK=e.$XK=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var R;(function(C){C[C.Unset=0]="Unset",C[C.Queued=1]="Queued",C[C.Running=2]="Running",C[C.Passed=3]="Passed",C[C.Failed=4]="Failed",C[C.Skipped=5]="Skipped",C[C.Errored=6]="Errored"})(R||(e.TestResultState=R={}));var m;(function(C){C[C.Run=1]="Run",C[C.Debug=2]="Debug",C[C.Coverage=3]="Coverage"})(m||(e.ExtTestRunProfileKind=m={}));var f;(function(C){C[C.Run=2]="Run",C[C.Debug=4]="Debug",C[C.Coverage=8]="Coverage",C[C.HasNonDefaultProfile=16]="HasNonDefaultProfile",C[C.HasConfigurable=32]="HasConfigurable",C[C.SupportsContinuousRun=64]="SupportsContinuousRun"})(f||(e.TestRunProfileBitset=f={})),e.$XK=[2,4,8,16,32,64];const k=C=>"runId"in C;e.$YK=k;var O;(function(C){C.serialize=L=>({range:L.range.toJSON(),uri:L.uri.toJSON()}),C.deserialize=(L,q)=>({range:P.$9s.lift(q.range),uri:L.asCanonicalUri(S.URI.revive(q.uri))})})(O||(e.IRichLocation=O={}));var D;(function(C){C[C.Error=0]="Error",C[C.Output=1]="Output"})(D||(e.TestMessageType=D={}));var l;(function(C){C.serialize=L=>({message:L.message,type:0,expected:L.expected,actual:L.actual,contextValue:L.contextValue,location:L.location&&O.serialize(L.location)}),C.deserialize=(L,q)=>({message:q.message,type:0,expected:q.expected,actual:q.actual,contextValue:q.contextValue,location:q.location&&O.deserialize(L,q.location)})})(l||(e.ITestErrorMessage=l={}));const E=(C,L)=>`${L?"s":"e"}${C}`;e.$ZK=E;var g;(function(C){C.serialize=L=>({message:L.message,type:1,offset:L.offset,length:L.length,location:L.location&&O.serialize(L.location)}),C.deserialize=(L,q)=>({message:q.message,type:1,offset:q.offset,length:q.length,location:q.location&&O.deserialize(L,q.location)})})(g||(e.ITestOutputMessage=g={}));var s;(function(C){C.serialize=L=>L.type===0?l.serialize(L):g.serialize(L),C.deserialize=(L,q)=>q.type===0?l.deserialize(L,q):g.deserialize(L,q)})(s||(e.ITestMessage=s={}));var a;(function(C){C.serializeWithoutMessages=L=>({state:L.state,duration:L.duration,messages:[]}),C.serialize=L=>({state:L.state,duration:L.duration,messages:L.messages.map(s.serialize)}),C.deserialize=(L,q)=>({state:q.state,duration:q.duration,messages:q.messages.map(ne=>s.deserialize(L,ne))})})(a||(e.ITestTaskState=a={}));const i="\0",n=(C,L)=>C+i+L;e.$1K=n;const r=C=>{const L=C.indexOf(i);return{ctrlId:C.slice(0,L),tagId:C.slice(L+1)}};e.$2K=r;var c;(function(C){C.serialize=L=>({extId:L.extId,label:L.label,tags:L.tags,busy:L.busy,children:void 0,uri:L.uri?.toJSON(),range:L.range?.toJSON()||null,description:L.description,error:L.error,sortText:L.sortText}),C.deserialize=(L,q)=>({extId:q.extId,label:q.label,tags:q.tags,busy:q.busy,children:void 0,uri:q.uri?L.asCanonicalUri(S.URI.revive(q.uri)):void 0,range:q.range?P.$9s.lift(q.range):null,description:q.description,error:q.error,sortText:q.sortText})})(c||(e.ITestItem=c={}));var d;(function(C){C[C.NotExpandable=0]="NotExpandable",C[C.Expandable=1]="Expandable",C[C.BusyExpanding=2]="BusyExpanding",C[C.Expanded=3]="Expanded"})(d||(e.TestItemExpandState=d={}));var t;(function(C){C.serialize=L=>({expand:L.expand,item:c.serialize(L.item)}),C.deserialize=(L,q)=>({controllerId:F.$WK.root(q.item.extId),expand:q.expand,item:c.deserialize(L,q.item)})})(t||(e.InternalTestItem=t={}));var p;(function(C){C.serialize=L=>{let q;return L.item&&(q={},L.item.label!==void 0&&(q.label=L.item.label),L.item.tags!==void 0&&(q.tags=L.item.tags),L.item.busy!==void 0&&(q.busy=L.item.busy),L.item.uri!==void 0&&(q.uri=L.item.uri?.toJSON()),L.item.range!==void 0&&(q.range=L.item.range?.toJSON()),L.item.description!==void 0&&(q.description=L.item.description),L.item.error!==void 0&&(q.error=L.item.error),L.item.sortText!==void 0&&(q.sortText=L.item.sortText)),{extId:L.extId,expand:L.expand,item:q}},C.deserialize=L=>{let q;return L.item&&(q={},L.item.label!==void 0&&(q.label=L.item.label),L.item.tags!==void 0&&(q.tags=L.item.tags),L.item.busy!==void 0&&(q.busy=L.item.busy),L.item.range!==void 0&&(q.range=L.item.range?P.$9s.lift(L.item.range):null),L.item.description!==void 0&&(q.description=L.item.description),L.item.error!==void 0&&(q.error=L.item.error),L.item.sortText!==void 0&&(q.sortText=L.item.sortText)),{extId:L.extId,expand:L.expand,item:q}}})(p||(e.ITestItemUpdate=p={}));const u=(C,L)=>{L.expand!==void 0&&(C.expand=L.expand),L.item!==void 0&&(C.item=C.item?Object.assign(C.item,L.item):L.item)};e.$3K=u;var o;(function(C){C.serializeWithoutMessages=L=>({...t.serialize(L),ownComputedState:L.ownComputedState,computedState:L.computedState,tasks:L.tasks.map(a.serializeWithoutMessages)}),C.serialize=L=>({...t.serialize(L),ownComputedState:L.ownComputedState,computedState:L.computedState,tasks:L.tasks.map(a.serialize)}),C.deserialize=(L,q)=>({...t.deserialize(L,q),ownComputedState:q.ownComputedState,computedState:q.computedState,tasks:q.tasks.map(ne=>a.deserialize(L,ne)),retired:!0})})(o||(e.TestResultItem=o={}));var v;(function(C){C.empty=()=>({covered:0,total:0}),C.sum=(L,q)=>{L.covered+=q.covered,L.total+=q.total}})(v||(e.ICoveredCount=v={}));var b;(function(C){C.serialize=L=>({statement:L.statement,branch:L.branch,declaration:L.declaration,details:L.details?.map(y.serialize),uri:L.uri.toJSON()}),C.deserialize=(L,q)=>({statement:q.statement,branch:q.branch,declaration:q.declaration,details:q.details?.map(y.deserialize),uri:L.asCanonicalUri(S.URI.revive(q.uri))})})(b||(e.IFileCoverage=b={}));function $(C){return{...C,location:C.location?.toJSON()}}function I(C){return C.location=C.location?M.$8s.isIPosition(C.location)?M.$8s.lift(C.location):P.$9s.lift(C.location):void 0,C}e.$4K=3;var h;(function(C){C[C.Declaration=0]="Declaration",C[C.Statement=1]="Statement",C[C.Branch=2]="Branch"})(h||(e.DetailType=h={}));var y;(function(C){C.serialize=L=>L.type===0?A.serialize(L):N.serialize(L),C.deserialize=L=>L.type===0?A.deserialize(L):N.deserialize(L)})(y||(e.CoverageDetails=y={}));var w;(function(C){C.serialize=$,C.deserialize=I})(w||(e.IBranchCoverage=w={}));var A;(function(C){C.serialize=$,C.deserialize=I})(A||(e.IDeclarationCoverage=A={}));var N;(function(C){C.serialize=L=>({...$(L),branches:L.branches?.map(w.serialize)}),C.deserialize=L=>({...I(L),branches:L.branches?.map(w.deserialize)})})(N||(e.IStatementCoverage=N={}));var G;(function(C){C[C.Add=0]="Add",C[C.Update=1]="Update",C[C.DocumentSynced=2]="DocumentSynced",C[C.Remove=3]="Remove",C[C.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",C[C.Retire=5]="Retire",C[C.AddTag=6]="AddTag",C[C.RemoveTag=7]="RemoveTag"})(G||(e.TestDiffOpType=G={}));var V;(function(C){C.deserialize=(L,q)=>q.op===0?{op:q.op,item:t.deserialize(L,q.item)}:q.op===1?{op:q.op,item:p.deserialize(q.item)}:q.op===2?{op:q.op,uri:L.asCanonicalUri(S.URI.revive(q.uri)),docv:q.docv}:q,C.serialize=L=>L.op===0?{op:L.op,item:t.serialize(L.item)}:L.op===1?{op:L.op,item:p.serialize(L.item)}:L})(V||(e.TestsDiffOp=V={}));class U{constructor(L){this.k=L,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(L){const q=this.v();for(const ne of L)switch(ne.op){case 0:this.l(t.deserialize(this.k,ne.item),q);break;case 1:this.o(p.deserialize(ne.item),q);break;case 3:this.p(ne.itemId,q);break;case 5:this.q(ne.itemId);break;case 4:this.updatePendingRoots(ne.amount);break;case 6:this.c.set(ne.tag.id,ne.tag);break;case 7:this.c.delete(ne.id);break}q.complete?.()}l(L,q){const ne=F.$WK.parentId(L.item.extId)?.toString();let ae;if(!ne)ae=this.w(L),this.g.add(ae),this.f.set(L.item.extId,ae);else if(this.f.has(ne)){const ye=this.f.get(ne);ye.children.add(L.item.extId),ae=this.w(L,ye),this.f.set(L.item.extId,ae)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(L)}`);return}return q.add?.(ae),L.expand===2&&this.h++,ae}o(L,q){const ne=this.f.get(L.extId);if(ne)return L.expand!==void 0&&(ne.expand===2&&this.h--,L.expand===2&&this.h++),(0,e.$3K)(ne,L),q.update?.(ne),ne}p(L,q){const ne=this.f.get(L);if(!ne)return;const ae=F.$WK.parentId(ne.item.extId)?.toString();ae?this.f.get(ae).children.delete(ne.item.extId):this.g.delete(ne);const ye=[[L]];for(;ye.length;)for(const Ie of ye.pop()){const ue=this.f.get(Ie);ue&&(ye.push(ue.children),this.f.delete(Ie),q.remove?.(ue,ue!==ne),ue.expand===2&&this.h--)}}q(L){}updatePendingRoots(L){this.j+=L}v(){return{}}}e.$5K=U}),define(Pe[75],Re([1,0,11,5,6,55,60,48]),function(me,e,S,M,P,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fO=e.$eO=e.$dO=e.$cO=e.$bO=e.TestItemEventOp=void 0;var f;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})(f||(e.TestItemEventOp=f={}));const k=(n,r)=>n===r,D=Object.entries({range:(n,r)=>n===r?!0:!n||!r?!1:n.equalsRange(r),busy:k,label:k,description:k,error:k,sortText:k,tags:(n,r)=>!(n.length!==r.length||n.some(c=>!r.includes(c)))}),l=(n,r)=>{let c;for(const[d,t]of D)t(n[d],r[d])||(c?c[d]=r[d]:c={[d]:r[d]});return c};class E extends P.$Tc{get root(){return this.s.root}constructor(r){super(),this.s=r,this.f=this.B(new S.$rh(()=>this.flushDiff(),200)),this.g=this.B(new M.$5d),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(r){this.h=r;for(const c of this.tree.values())this.J(c)}get resolveHandler(){return this.h}collectDiff(){const r=this.m;return this.m=[],r}pushDiff(r){switch(r.op){case 2:{for(const c of this.m)if(c.op===2&&c.uri===r.uri){c.docv=r.docv;return}break}case 1:{const c=this.m[this.m.length-1];if(c){if(c.op===1&&c.item.extId===r.item.extId){(0,R.$3K)(c.item,r.item);return}if(c.op===0&&c.item.item.extId===r.item.extId){(0,R.$3K)(c.item,r.item);return}}break}}this.m.push(r),this.f.isScheduled()||this.f.schedule()}expand(r,c){const d=this.tree.get(r);if(d){if((d.expandLevels===void 0||c>d.expandLevels)&&(d.expandLevels=c),d.expand===1){const t=this.M(d);return t.isOpen()?this.L(d,c-1):t.wait().then(()=>this.L(d,c-1))}else if(d.expand===3)return d.resolveBarrier?.isOpen()===!1?d.resolveBarrier.wait().then(()=>this.L(d,c-1)):this.L(d,c-1)}}dispose(){for(const r of this.tree.values())this.s.getApiFor(r.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(r,c){switch(c.op){case 3:this.O(m.$WK.joinToString(r.fullId,c.id));break;case 0:this.z(c.item,r);break;case 5:for(const d of c.ops)this.w(r,d);break;case 1:this.C(c.new,c.old,r.fullId.toString());break;case 2:this.J(r);break;case 4:this.pushDiff({op:1,item:{extId:r.fullId.toString(),item:c.update}});break;case 6:this.y(r.actual.uri);break;default:(0,F.$9c)(c)}}y(r){r&&this.pushDiff({op:2,uri:r,docv:this.s.getDocumentVersion(r)})}z(r,c){const d=m.$WK.fromExtHostTestItem(r,this.root.id,c?.actual),t=this.s.getApiFor(r);t.parent&&t.parent!==c?.actual&&this.s.getChildren(t.parent).delete(r.id);let p=this.tree.get(d.toString());if(!p){p={fullId:d,actual:r,expandLevels:c?.expandLevels?c.expandLevels-1:void 0,expand:0},r.tags.forEach(this.D,this),this.tree.set(p.fullId.toString(),p),this.G(r,c),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:p.expand,item:this.s.toITestItem(r)}}),this.I(r,p,c);return}if(p.actual===r){this.H(r,p,c);return}if(p.actual.uri?.toString()!==r.uri?.toString())return this.O(d.toString()),this.z(r,c);const u=this.s.getChildren(p.actual),o=p.actual,v=l(this.s.toITestItem(o),this.s.toITestItem(r));this.s.getApiFor(o).listener=void 0,p.actual=r,p.expand=0,v&&(v.hasOwnProperty("tags")&&(this.C(r.tags,o.tags,d.toString()),delete v.tags),this.w(p,{op:4,update:v})),this.I(r,p,c);for(const[b,$]of u)this.s.getChildren(r).get($.id)||this.O(m.$WK.joinToString(d,$.id));this.y(p.actual.uri)}C(r,c,d){const t=new Set(c.map(p=>p.id));for(const p of r)t.delete(p.id)||this.D(p);this.pushDiff({op:1,item:{extId:d,item:{tags:r.map(p=>(0,R.$1K)(this.s.controllerId,p.id))}}}),t.forEach(this.F,this)}D(r){const c=this.j.get(r.id);c?c.refCount++:(this.j.set(r.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.$1K)(this.s.controllerId,r.id)}}))}F(r){const c=this.j.get(r);c&&!--c.refCount&&(this.j.delete(r),this.pushDiff({op:7,id:(0,R.$1K)(this.s.controllerId,r)}))}G(r,c){this.s.getApiFor(r).parent=c&&c.actual!==this.root?c.actual:void 0}H(r,c,d){this.G(r,d);const t=this.s.getApiFor(r);t.parent=d?.actual,t.listener=p=>this.w(c,p),this.J(c)}I(r,c,d){this.H(r,c,d);for(const[t,p]of this.s.getChildren(r))this.z(p,c)}J(r){let c;this.h?r.resolveBarrier?c=r.resolveBarrier.isOpen()?3:2:c=r.actual.canResolveChildren?1:0:c=0,c!==r.expand&&(r.expand=c,this.pushDiff({op:1,item:{extId:r.fullId.toString(),expand:c}}),c===1&&r.expandLevels!==void 0&&this.M(r))}L(r,c){if(c<0)return;const d=[];for(const[t,p]of this.s.getChildren(r.actual)){const u=this.expand(m.$WK.joinToString(r.fullId,p.id),c);(0,S.$4g)(u)&&d.push(u)}if(d.length)return Promise.all(d).then(()=>{})}M(r){if(r.resolveBarrier)return r.resolveBarrier;if(!this.h){const p=new S.$eh;return p.open(),p}r.expand=2,this.N(r);const c=r.resolveBarrier=new S.$eh,d=p=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,p)};let t;try{t=this.h(r.actual===this.root?void 0:r.actual)}catch(p){d(p)}return(0,S.$4g)(t)?t.catch(d).then(()=>{c.open(),this.J(r)}):(c.open(),this.J(r)),r.resolveBarrier}N(r){this.pushDiff({op:1,item:{extId:r.fullId.toString(),expand:r.expand}})}O(r){const c=this.tree.get(r);if(!c)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:r});const d=[c];for(;d.length;){const t=d.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const p of t.actual.tags)this.F(p.id);this.tree.delete(t.fullId.toString());for(const[p,u]of this.s.getChildren(t.actual))d.push(this.tree.get(m.$WK.joinToString(t.fullId,u.id)))}}}flushDiff(){const r=this.collectDiff();r.length&&this.g.fire(r)}}e.$bO=E;class g extends Error{constructor(r){super(`Attempted to insert a duplicate test item ID ${r}`)}}e.$cO=g;class s extends Error{constructor(r){super(`TestItem with ID "${r}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$dO=s;class a extends Error{constructor(r,c,d){super(`TestItem with ID "${r}" is from controller "${c}" and cannot be added as a child of an item from controller "${d}".`)}}e.$eO=a;const i=(n,r,c)=>{let d=new Map;return{get size(){return d.size},forEach(t,p){for(const u of d.values())t.call(p,u,this)},[Symbol.iterator](){return d.entries()},replace(t){const p=new Map,u=new Set(d.keys()),o={op:5,ops:[]};for(const v of t){if(!(v instanceof c))throw new s(v.id);const b=r(v).controllerId;if(b!==n.controllerId)throw new a(v.id,b,n.controllerId);if(p.has(v.id))throw new g(v.id);p.set(v.id,v),u.delete(v.id),o.ops.push({op:0,item:v})}for(const v of u.keys())o.ops.push({op:3,id:v});n.listener?.(o),d=p},add(t){if(!(t instanceof c))throw new s(t.id);d.set(t.id,t),n.listener?.({op:0,item:t})},delete(t){d.delete(t)&&n.listener?.({op:3,id:t})},get(t){return d.get(t)},toJSON(){return Array.from(d.values())}}};e.$fO=i}),define(Pe[105],Re([1,0,75]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hO=e.$gO=void 0;const M=new WeakMap,P=(R,m)=>{const f={controllerId:m};return M.set(R,f),f};e.$gO=P;const F=R=>{const m=M.get(R);if(!m)throw new S.$dO(R?.id||"<unknown>");return m};e.$hO=F}),define(Pe[76],Re([1,0,12,2]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kxb=e.$Jxb=e.$Ixb=e.$Hxb=e.$Gxb=void 0,e.$Gxb="vscode-cdn.net",e.$Hxb=`vscode-resource.${e.$Gxb}`,e.$Ixb=`'self' https://*.${e.$Gxb}`;function P(m,f){return m.scheme===S.Schemas.http||m.scheme===S.Schemas.https?m:(f&&f.authority&&f.isRemote&&m.scheme===S.Schemas.file&&(m=M.URI.from({scheme:S.Schemas.vscodeRemote,authority:f.authority,path:m.path})),M.URI.from({scheme:S.Schemas.https,authority:`${m.scheme}+${F(m.authority)}.${e.$Hxb}`,path:m.path,fragment:m.fragment,query:m.query}))}e.$Jxb=P;function F(m){return m.replace(/./g,f=>{const k=f.charCodeAt(0);return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57?f:"-"+k.toString(16).padStart(4,"0")})}function R(m){return m.replace(/-([0-9a-f]{4})/g,(f,k)=>String.fromCharCode(parseInt(k,16)))}e.$Kxb=R}),define(Pe[216],Re([1,0,5,6,76]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0hc=void 0;class F{constructor(m,f,k){this.d=m,this.e=f,this.f=k,this.a=0,this.b=new M.$Sc,this.c=new Map,this.b.add(f.onDidChangeVisibleTextEditors(()=>{const O=f.getVisibleTextEditors();for(const D of this.c.values())O.indexOf(D.editor)<0&&D.inset.dispose()}))}dispose(){this.c.forEach(m=>m.inset.dispose()),this.b.dispose()}createWebviewEditorInset(m,f,k,O,D){let l;for(const r of this.e.getVisibleTextEditors(!0))if(r.value===m){l=r;break}if(!l)throw new Error("not a visible editor");const E=this,g=this.a++,s=new S.$5d,a=new S.$5d,i=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(r){return(0,P.$Jxb)(r,E.f)}get cspSource(){return P.$Ixb}set options(r){this.b=r,E.d.$setOptions(g,r)}get options(){return this.b}set html(r){this.a=r,E.d.$setHtml(g,r)}get html(){return this.a}get onDidReceiveMessage(){return s.event}postMessage(r){return E.d.$postMessage(g,r)}},n=new class{constructor(){this.editor=m,this.line=f,this.height=k,this.webview=i,this.onDidDispose=a.event}dispose(){E.c.has(g)&&(E.c.delete(g),E.d.$disposeEditorInset(g),a.fire(),a.dispose(),s.dispose())}};return this.d.$createEditorInset(g,l.id,l.value.document.uri,f+1,k,O||{},D.identifier,D.extensionLocation),this.c.set(g,{editor:m,inset:n,onDidReceiveMessage:s}),n}$onDidDispose(m){const f=this.c.get(m);f&&f.inset.dispose()}$onDidReceiveMessage(m,f){this.c.get(m)?.onDidReceiveMessage.fire(f)}}e.$0hc=F}),define(Pe[106],Re([1,0,3]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aL=e.$_K=void 0,e.$_K="__",e.$aL=(0,S.$fi)("IAuthenticationService")}),define(Pe[217],Re([1,0,3]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$O=e.VariableKind=e.$0O=void 0,e.$0O=(0,S.$fi)("configurationResolverService");var M;(function(F){F.Unknown="unknown",F.Env="env",F.Config="config",F.Command="command",F.Input="input",F.ExtensionInstallFolder="extensionInstallFolder",F.WorkspaceFolder="workspaceFolder",F.Cwd="cwd",F.WorkspaceFolderBasename="workspaceFolderBasename",F.UserHome="userHome",F.LineNumber="lineNumber",F.SelectedText="selectedText",F.File="file",F.FileWorkspaceFolder="fileWorkspaceFolder",F.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",F.RelativeFile="relativeFile",F.RelativeFileDirname="relativeFileDirname",F.FileDirname="fileDirname",F.FileExtname="fileExtname",F.FileBasename="fileBasename",F.FileBasenameNoExtension="fileBasenameNoExtension",F.FileDirnameBasename="fileDirnameBasename",F.ExecPath="execPath",F.ExecInstallFolder="execInstallFolder",F.PathSeparator="pathSeparator",F.PathSeparatorAlias="/"})(M||(e.VariableKind=M={}));class P extends Error{constructor(R,m){super(m),this.variable=R}}e.$$O=P}),define(Pe[218],Re([1,0,19,73,16,26,21,96,180,217,15]),function(me,e,S,M,P,F,R,m,f,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mP=void 0;class D{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(E,g,s,a){this.h=new Map,this.a=E,this.b=g,this.g=s,a&&(this.c=a.then(i=>this.i(i)))}i(E){if(R.$i){const g=Object.create(null);return Object.keys(E).forEach(s=>{g[s.toLowerCase()]=E[s]}),g}return E}resolveWithEnvironment(E,g,s){return this.l({env:this.i(E),userHome:void 0},g?g.uri:void 0,s)}async resolveAsync(E,g){const s={env:await this.c,userHome:await this.g};return this.l(s,E?E.uri:void 0,g)}async j(E,g,s,a){const i=F.$Kn(g);R.$i&&i.windows?Object.keys(i.windows).forEach(r=>i[r]=i.windows[r]):R.$j&&i.osx?Object.keys(i.osx).forEach(r=>i[r]=i.osx[r]):R.$k&&i.linux&&Object.keys(i.linux).forEach(r=>i[r]=i.linux[r]),delete i.windows,delete i.osx,delete i.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,E?E.uri:void 0,i,s,a)}async resolveAnyAsync(E,g,s){return this.j(E,g,s)}async resolveAnyMap(E,g,s){const a=new Map;return{newConfig:await this.j(E,g,s,a),resolvedVariables:a}}resolveWithInteractionReplace(E,g,s,a){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(E,g,s,a){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(E,g){if(this.h.has(E))throw new Error("Variable "+E+" is contributed twice.");this.h.set(E,g)}async l(E,g,s,a,i){if(P.$Sf(s))return this.m(E,g,s,a,i);if(Array.isArray(s))return Promise.all(s.map(n=>this.l(E,g,n,a,i)));if(P.$Uf(s)){const n=Object.create(null),r=await Promise.all(Object.keys(s).map(async c=>[await this.m(E,g,c,a,i),await this.l(E,g,s[c],a,i)]));for(const[c,d]of r)n[c]=d;return n}return s}m(E,g,s,a,i){return(0,O.$bf)(s,D.VARIABLE_REGEXP,async(n,r)=>{if(r.includes(D.VARIABLE_LHS))return n;let c=await this.o(E,n,r,g,a);return i?.set(r,c),c!==n&&P.$Sf(c)&&c.match(D.VARIABLE_REGEXP)&&(c=await this.m(E,g,c,a,i)),c})}n(E){return this.b?this.b.getUriLabel(E,{noPrefix:!0}):E.fsPath}async o(E,g,s,a,i){let n;const r=s.split(":");r.length>1&&(s=r[0],n=r[1]);const c=p=>{const u=this.a.getFilePath();if(u)return(0,m.$_v)(u);throw new k.$$O(p,(0,f.localize)(0,null,g))},d=p=>{const u=c(p);if(this.a.getWorkspaceFolderPathForFile){const o=this.a.getWorkspaceFolderPathForFile();if(o)return(0,m.$_v)(o)}throw new k.$$O(p,(0,f.localize)(1,null,g,S.$nc(u)))},t=p=>{if(n){const u=this.a.getFolderUri(n);if(u)return u;throw new k.$$O(p,(0,f.localize)(2,null,g,n))}if(a)return a;throw this.a.getWorkspaceFolderCount()>1?new k.$$O(p,(0,f.localize)(3,null,g)):new k.$$O(p,(0,f.localize)(4,null,g))};switch(s){case"env":if(n){if(E.env){const p=E.env[R.$i?n.toLowerCase():n];if(P.$Sf(p))return p}return""}throw new k.$$O(k.VariableKind.Env,(0,f.localize)(5,null,g));case"config":if(n){const p=this.a.getConfigurationValue(a,n);if(P.$2f(p))throw new k.$$O(k.VariableKind.Config,(0,f.localize)(6,null,g,n));if(P.$Uf(p))throw new k.$$O(k.VariableKind.Config,(0,f.localize)(7,null,g,n));return p}throw new k.$$O(k.VariableKind.Config,(0,f.localize)(8,null,g));case"command":return this.p(k.VariableKind.Command,g,n,i,"command");case"input":return this.p(k.VariableKind.Input,g,n,i,"input");case"extensionInstallFolder":if(n){const p=await this.a.getExtension(n);if(!p)throw new k.$$O(k.VariableKind.ExtensionInstallFolder,(0,f.localize)(9,null,g,n));return this.n(p.extensionLocation)}throw new k.$$O(k.VariableKind.ExtensionInstallFolder,(0,f.localize)(10,null,g));default:switch(s){case"workspaceRoot":case"workspaceFolder":return(0,m.$_v)(this.n(t(k.VariableKind.WorkspaceFolder)));case"cwd":return a||n?(0,m.$_v)(this.n(t(k.VariableKind.Cwd))):M.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,m.$_v)(S.$nc(this.n(t(k.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(E.userHome)return E.userHome;throw new k.$$O(k.VariableKind.UserHome,(0,f.localize)(11,null,g))}case"lineNumber":{const p=this.a.getLineNumber();if(p)return p;throw new k.$$O(k.VariableKind.LineNumber,(0,f.localize)(12,null,g))}case"selectedText":{const p=this.a.getSelectedText();if(p)return p;throw new k.$$O(k.VariableKind.SelectedText,(0,f.localize)(13,null,g))}case"file":return c(k.VariableKind.File);case"fileWorkspaceFolder":return d(k.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return S.$nc(d(k.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return a||n?S.$lc(this.n(t(k.VariableKind.RelativeFile)),c(k.VariableKind.RelativeFile)):c(k.VariableKind.RelativeFile);case"relativeFileDirname":{const p=S.$mc(c(k.VariableKind.RelativeFileDirname));if(a||n){const u=S.$lc(this.n(t(k.VariableKind.RelativeFileDirname)),p);return u.length===0?".":u}return p}case"fileDirname":return S.$mc(c(k.VariableKind.FileDirname));case"fileExtname":return S.$oc(c(k.VariableKind.FileExtname));case"fileBasename":return S.$nc(c(k.VariableKind.FileBasename));case"fileBasenameNoExtension":{const p=S.$nc(c(k.VariableKind.FileBasenameNoExtension));return p.slice(0,p.length-S.$oc(p).length)}case"fileDirnameBasename":return S.$nc(S.$mc(c(k.VariableKind.FileDirnameBasename)));case"execPath":{const p=this.a.getExecPath();return p||g}case"execInstallFolder":{const p=this.a.getAppRoot();return p||g}case"pathSeparator":case"/":return S.sep;default:try{const p=n?`${s}:${n}`:s;return this.p(k.VariableKind.Unknown,g,p,i,void 0)}catch{return g}}}}p(E,g,s,a,i){if(s&&a){const n=i===void 0?a[s]:a[i+":"+s];if(typeof n=="string")return n;throw new k.$$O(E,(0,f.localize)(14,null,g))}return g}}e.$mP=D}),define(Pe[107],Re([1,0,3,104]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qD=e.$pD=e.OpenEditorContext=e.GroupsOrder=e.$oD=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$nD=void 0,e.$nD=(0,S.$fi)("editorGroupsService");var P;(function(g){g[g.UP=0]="UP",g[g.DOWN=1]="DOWN",g[g.LEFT=2]="LEFT",g[g.RIGHT=3]="RIGHT"})(P||(e.GroupDirection=P={}));var F;(function(g){g[g.HORIZONTAL=0]="HORIZONTAL",g[g.VERTICAL=1]="VERTICAL"})(F||(e.GroupOrientation=F={}));var R;(function(g){g[g.FIRST=0]="FIRST",g[g.LAST=1]="LAST",g[g.NEXT=2]="NEXT",g[g.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var m;(function(g){g[g.MAXIMIZE=0]="MAXIMIZE",g[g.EXPAND=1]="EXPAND",g[g.EVEN=2]="EVEN"})(m||(e.GroupsArrangement=m={}));var f;(function(g){g[g.COPY_EDITORS=0]="COPY_EDITORS",g[g.MOVE_EDITORS=1]="MOVE_EDITORS"})(f||(e.MergeGroupMode=f={}));function k(g){const s=g;return(0,M.$0E)(s?.editor)&&(0,M.$0E)(s?.replacement)}e.$oD=k;var O;(function(g){g[g.CREATION_TIME=0]="CREATION_TIME",g[g.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",g[g.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(O||(e.GroupsOrder=O={}));var D;(function(g){g[g.NEW_EDITOR=1]="NEW_EDITOR",g[g.MOVE_EDITOR=2]="MOVE_EDITOR",g[g.COPY_EDITOR=3]="COPY_EDITOR"})(D||(e.OpenEditorContext=D={}));function l(g){const s=g;return!!s&&typeof s.id=="number"&&Array.isArray(s.editors)}e.$pD=l;function E(g){return g.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$qD=E}),define(Pe[219],Re([1,0,3,107]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vD=e.$uD=e.$tD=e.$sD=e.$rD=void 0,e.$rD=(0,S.$fi)("editorService"),e.$sD=-1,e.$tD=-2,e.$uD=-3;function P(F){const R=F;return typeof F=="number"||(0,M.$pD)(R)}e.$vD=P}),define(Pe[220],Re([1,0,3,187]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qL=void 0,e.$qL=(0,S.$gi)(M.$mi)}),define(Pe[108],Re([1,0,20,5,19,6,11]),function(me,e,S,M,P,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R9b=e.$Q9b=e.$P9b=e.$O9b=e.$N9b=void 0;class m{constructor(n,r){this.versionId=n,this.removedDueToLooping=r}}e.$N9b=m;class f{static isHostExtension(n,r,c){if(r.getExtensionDescription(n))return!1;const d=c.getExtensionDescription(n);return d?!!((d.main||d.browser)&&d.api==="none"):!1}constructor(n,r){this.j=n,this.c=new M.$5d,this.onDidChange=this.c.event,this.d=0,this.e=r,this.k()}k(){this.e.sort(s),this.f=new S.$Bm,this.g=[],this.h=new Map;for(const n of this.e){if(this.f.has(n.identifier)){console.error("Extension `"+n.identifier.value+"` is already registered");continue}this.f.set(n.identifier,n),this.g.push(n);const r=this.j.readActivationEvents(n);for(const c of r)this.h.has(c)||this.h.set(c,[]),this.h.get(c).push(n)}}set(n){return this.e=n,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(n,r){this.e=a(this.e,r),this.e=this.e.concat(n);const c=f.l(this.e);return this.e=a(this.e,c.map(d=>d.identifier)),this.k(),this.d++,this.c.fire(void 0),new m(this.d,c)}static l(n){const r=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(u){this.d.has(u)||(this.d.add(u),this.e.push(u))}addArc(u,o){this.addNode(u),this.addNode(o),this.c.has(u)?this.c.get(u).push(o):this.c.set(u,[o])}getArcs(u){return this.c.has(u)?this.c.get(u):[]}hasOnlyGoodArcs(u,o){const v=r.getArcs(u);for(let b=0;b<v.length;b++)if(!o.has(v[b]))return!1;return!0}getNodes(){return this.e}},c=new S.$Bm;for(const u of n)if(c.set(u.identifier,u),u.extensionDependencies)for(const o of u.extensionDependencies)r.addArc(S.$zm.toKey(u.identifier),S.$zm.toKey(o));const d=new Set;r.getNodes().filter(u=>r.getArcs(u).length===0).forEach(u=>d.add(u));const t=r.getNodes().filter(u=>!d.has(u));let p;do{p=!1;for(let u=0;u<t.length;u++){const o=t[u];r.hasOnlyGoodArcs(o,d)&&(t.splice(u,1),u--,d.add(o),p=!0)}}while(p);return t.map(u=>c.get(u))}containsActivationEvent(n){return this.h.has(n)}containsExtension(n){return this.f.has(n)}getExtensionDescriptionsForActivationEvent(n){const r=this.h.get(n);return r?r.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new k(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(n){const r=this.f.get(n);return r||void 0}getExtensionDescriptionByUUID(n){for(const r of this.g)if(r.uuid===n)return r}getExtensionDescriptionByIdOrUUID(n,r){return this.getExtensionDescription(n)??(r?this.getExtensionDescriptionByUUID(r):void 0)}}e.$O9b=f;class k{constructor(n,r){this.versionId=n,this.extensions=r}}e.$P9b=k;class O{constructor(n){this.d=new E,this.c=new f(n,[])}async acquireLock(n){const r=await this.d.acquire(n);return new D(this,r)}deltaExtensions(n,r,c){if(!n.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(r,c)}containsActivationEvent(n){return this.c.containsActivationEvent(n)}containsExtension(n){return this.c.containsExtension(n)}getExtensionDescriptionsForActivationEvent(n){return this.c.getExtensionDescriptionsForActivationEvent(n)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(n){return this.c.getExtensionDescription(n)}getExtensionDescriptionByUUID(n){return this.c.getExtensionDescriptionByUUID(n)}getExtensionDescriptionByIdOrUUID(n,r){return this.c.getExtensionDescriptionByIdOrUUID(n,r)}}e.$Q9b=O;class D extends F.$Tc{constructor(n,r){super(),this.f=n,this.c=!1,this.B(r)}isAcquiredFor(n){return!this.c&&this.f===n}}e.$R9b=D;class l{constructor(n){this.name=n;const r=(0,R.$$g)();this.promise=r.promise,this.c=r.resolve}resolve(n){this.c(n)}}class E{constructor(){this.c=[],this.d=!1}async acquire(n){const r=new l(n);return this.c.push(r),this.e(),r.promise}e(){if(this.d||this.c.length===0)return;const n=this.c.shift();this.d=!0;let r=!0;const c=setTimeout(()=>{r&&console.warn(`The customer named ${n.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),d=()=>{r&&(clearTimeout(c),r=!1,this.d=!1,this.e())};n.resolve((0,F.$Rc)(d))}}var g;(function(i){i[i.Builtin=0]="Builtin",i[i.User=1]="User",i[i.Dev=2]="Dev"})(g||(g={}));function s(i,n){const r=i.isBuiltin?0:i.isUnderDevelopment?2:1,c=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(r!==c)return r-c;const d=P.$gc.basename(i.extensionLocation.path),t=P.$gc.basename(n.extensionLocation.path);return d<t?-1:d>t?1:0}function a(i,n){const r=new S.$Am(n);return i.filter(c=>!r.has(c.identifier))}}),define(Pe[77],Re([1,0,23]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$Im=e.$Hm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var M;(function(k){k[k.Desktop=1]="Desktop",k[k.Web=2]="Web"})(M||(e.UIKind=M={}));var P;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(P||(e.ExtensionHostExitCode=P={}));var F;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(F||(e.MessageType=F={}));function R(k){const O=S.$se.alloc(1);switch(k){case 0:O.writeUInt8(1,0);break;case 1:O.writeUInt8(2,0);break;case 2:O.writeUInt8(3,0);break}return O}e.$Hm=R;function m(k,O){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return O===0;case 2:return O===1;case 3:return O===2;default:return!1}}e.$Im=m;var f;(function(k){k.Start="START_NATIVE_LOG",k.End="END_NATIVE_LOG"})(f||(e.NativeLogMarkers=f={}))}),define(Pe[61],Re([1,0,3,5,13,27,77,57,58,26,2,6,168]),function(me,e,S,M,P,F,R,m,f,k,O,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FO=e.$EO=e.$DO=e.$CO=void 0;let E=class extends D.$Tc{constructor(i,n){super(),this.s=i,this.t=n,this.a=this.B(new M.$5d),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new M.$5d),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=O.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:f.$5o,name:(0,l.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(r=>{(0,P.$Bj)(r)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===P.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(i,n,r){const c=this.getTelemetryDetails(),d=new g(n,r,i,this.n,this.j,this.getBuiltInCommonProperties(i),{isUsageEnabled:c.isUsageEnabled,isErrorsEnabled:c.isErrorsEnabled}),t=this.r.get(i.identifier.value)??[];return this.r.set(i.identifier.value,[...t,d]),d.apiTelemetryLogger}$initializeTelemetryLevel(i,n,r){this.f=i,this.g=n,this.c=r??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(i){const n=Object.create(null);switch(n["common.extname"]=`${i.publisher}.${i.name}`,n["common.extversion"]=i.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=s(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:n["common.uikind"]="web";break;case R.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,m.$qm)((0,f.$$o)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(i){this.h=this.getTelemetryConfiguration(),this.f=i;const n=this.getTelemetryDetails();this.r.forEach((r,c)=>{const d=r.filter(t=>!t.isDisposed);d.length===0?this.r.delete(c):this.r.set(c,d)}),this.r.forEach(r=>{for(const c of r)c.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(i,n){const c=this.r.get(i.value)?.filter(t=>!t.isDisposed);if(!c)return this.r.delete(i.value),!1;let d=!1;for(const t of c)t.ignoreUnhandledExtHostErrors||(t.logError(n),d=!0);return d}};e.$CO=E,e.$CO=E=Ye([He(0,F.$BO),He(1,P.$Aj)],E);class g{static validateSender(i){if(typeof i!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof i.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof i.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof i.flush<"u"&&typeof i.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(i,n,r,c,d,t,p){this.g=r,this.h=c,this.i=d,this.j=t,this.a=new M.$5d,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=i,this.d={isUsageEnabled:p.isUsageEnabled,isErrorsEnabled:p.isErrorsEnabled}}updateTelemetryEnablements(i,n){this.e&&(this.d={isUsageEnabled:i,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(i){let n="properties"in i?i.properties??{}:i;return n=(0,f.$bp)(n,[]),this.c&&(n=(0,k.$Nn)(n,this.c)),this.b||(n=(0,k.$Nn)(n,this.j)),"properties"in i?i.properties=n:i=n,i}k(i,n){this.f&&(this.g.publisher==="vscode"?i=this.g.name+"/"+i:i=this.g.identifier.value+"/"+i,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(i,n),this.h.trace(i,n))}logUsage(i,n){this.d.isUsageEnabled&&this.k(i,n)}logError(i,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof i=="string")this.k(i,n);else{const r={name:i.name,message:i.message,stack:i.stack,cause:i.cause},c=(0,f.$bp)(r,[]),d=new Error(c.message,{cause:c.cause});d.stack=c.stack,d.name=c.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(d,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const i=this,n={logUsage:i.logUsage.bind(i),get isUsageEnabled(){return i.d.isUsageEnabled},get isErrorsEnabled(){return i.d.isErrorsEnabled},logError:i.logError.bind(i),dispose:i.dispose.bind(i),onDidChangeEnableStates:i.a.event.bind(i)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let i=this.f;this.f=void 0,Promise.resolve(i.flush()).then(i=void 0),this.e=void 0}else this.f=void 0}}e.$DO=g;function s(a){const i=Date.now()-new Date(a).getTime();return isNaN(i)?!1:i<1e3*60*60*24}e.$EO=s,e.$FO=(0,S.$fi)("IExtHostTelemetry")}),define(Pe[22],Re([1,0,5,2,196,103,20,3]),function(me,e,S,M,P,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4F=e.$3F=e.$2F=e.ActivationKind=e.$1F=e.$ZF=e.$YF=e.$XF=e.$WF=e.ExtensionHostStartup=e.$VF=e.$UF=e.$TF=e.$SF=void 0,e.$SF=Object.freeze({identifier:new R.$zm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:M.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$TF="extensions.webWorker",e.$UF=(0,m.$fi)("extensionService");class f{constructor(d){this.dependency=d}}e.$VF=f;var k;(function(c){c[c.EagerAutoStart=1]="EagerAutoStart",c[c.EagerManualStart=2]="EagerManualStart",c[c.Lazy=3]="Lazy"})(k||(e.ExtensionHostStartup=k={}));class O{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(d,t,p){this.c=d,this.d=t.slice(0),this.e=p.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:F.$DF.createActivationEventsMap(this.d)}}set(d,t,p){if(this.c>d)throw new Error(`ExtensionHostExtensions: invalid versionId ${d} (current: ${this.c})`);const u=[],o=[],v=[],b=[],$=D(this.d),I=D(t),h=(G,V)=>G.extensionLocation.toString()===V.extensionLocation.toString()||G.isBuiltin===V.isBuiltin||G.isUserBuiltin===V.isUserBuiltin||G.isUnderDevelopment===V.isUnderDevelopment;for(const G of this.d){const V=I.get(G.identifier);if(!V){u.push(G.identifier),$.delete(G.identifier);continue}if(!h(G,V)){u.push(G.identifier),$.delete(G.identifier);continue}}for(const G of t){const V=$.get(G.identifier);if(!V){o.push(G);continue}if(!h(V,G)){u.push(V.identifier),$.delete(V.identifier);continue}}const y=new R.$Am(this.e),w=new R.$Am(p);for(const G of this.e)w.has(G)||v.push(G);for(const G of p)y.has(G)||b.push(G);const A=F.$DF.createActivationEventsMap(o),N={versionId:d,toRemove:u,toAdd:o,addActivationEvents:A,myToRemove:v,myToAdd:b};return this.delta(N),N}delta(d){if(this.c>=d.versionId)return null;const{toRemove:t,toAdd:p,myToRemove:u,myToAdd:o}=d,v=new R.$Am(t),b=new R.$Am(u);for(let $=0;$<this.d.length;$++)v.has(this.d[$].identifier)&&(this.d.splice($,1),$--);for(let $=0;$<this.e.length;$++)b.has(this.e[$])&&(this.e.splice($,1),$--);for(const $ of p)this.d.push($);for(const $ of o)this.e.push($);return this.f=null,d}containsExtension(d){for(const t of this.e)if(R.$zm.equals(t,d))return!0;return!1}containsActivationEvent(d){return this.f||(this.f=this.g()),this.f.has(d)}g(){const d=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const p=F.$DF.readActivationEvents(t);for(const u of p)d.add(u)}return d}}e.$WF=O;function D(c){const d=new R.$Bm;for(const t of c)d.set(t.identifier,t);return d}function l(c,d){return c.enabledApiProposals?c.enabledApiProposals.includes(d):!1}e.$XF=l;function E(c,d){if(!l(c,d))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${d}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${d}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}e.$YF=E;class g{constructor(d,t,p,u){this.codeLoadingTime=d,this.activateCallTime=t,this.activateResolvedTime=p,this.activationReason=u}}e.$ZF=g;class s{constructor(d,t){this.description=d,this.value=t}}e.$1F=s;var a;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(a||(e.ActivationKind=a={}));function i(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,P.$hp)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation,targetPlatform:c.targetPlatform,validations:[],isValid:!0}}e.$2F=i;function n(c,d){return{identifier:new R.$zm((0,P.$fp)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!d,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid,targetPlatform:c.targetPlatform}}e.$3F=n;class r{constructor(){this.onDidRegisterExtensions=S.Event.None,this.onDidChangeExtensionsStatus=S.Event.None,this.onDidChangeExtensions=S.Event.None,this.onWillActivateByEvent=S.Event.None,this.onDidChangeResponsiveChange=S.Event.None,this.onWillStop=S.Event.None,this.extensions=[]}activateByEvent(d){return Promise.resolve(void 0)}activateById(d,t){return Promise.resolve(void 0)}activationEventIsDone(d){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(d){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(d,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(d){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$4F=r}),define(Pe[221],Re([1,0,14,108,20,22,13,11]),function(me,e,S,M,P,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yic=e.$xic=e.$wic=e.$vic=e.$uic=e.$tic=void 0;class f{static{this.NONE=new f(!1,-1,-1,-1)}constructor(i,n,r,c){this.startup=i,this.codeLoadingTime=n,this.activateCallTime=r,this.activateResolvedTime=c}}e.$tic=f;class k{constructor(i){this.a=i,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(i,n){return i===-1||n===-1?-1:n-i}build(){return new f(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$uic=k;class O{constructor(i,n,r,c,d,t){this.activationFailed=i,this.activationFailedError=n,this.activationTimes=r,this.module=c,this.exports=d,this.subscriptions=t}}e.$vic=O;class D extends O{constructor(i){super(!1,null,i,{activate:void 0,deactivate:void 0},void 0,[])}}e.$wic=D;class l extends O{constructor(){super(!1,null,f.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$xic=l;class E extends O{constructor(i){super(!0,i,f.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let g=class{constructor(i,n,r,c){this.g=c,this.a=i,this.b=n,this.c=r,this.d=new P.$Bm,this.f=Object.create(null)}dispose(){for(const[i,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const i=[];for(const[n,r]of this.d)i.push(r.wait());await Promise.all(i)}isActivated(i){const n=this.d.get(i);return!!(n&&n.value)}getActivatedExtension(i){const n=this.d.get(i);if(!n||!n.value)throw new Error(`Extension '${i.value}' is not known or not activated`);return n.value}async activateByEvent(i,n){if(this.f[i])return;const r=this.a.getExtensionDescriptionsForActivationEvent(i);await this.h(r.map(c=>({id:c.identifier,reason:{startup:n,extensionId:c.identifier,activationEvent:i}}))),this.f[i]=!0}activateById(i,n){const r=this.a.getExtensionDescription(i);if(!r)throw new Error(`Extension '${i}' is not known`);return this.h([{id:r.identifier,reason:n}])}async h(i){const n=i.filter(r=>!this.isActivated(r.id)).map(r=>this.j(r));await Promise.all(n.map(r=>r.wait()))}j(i){if(this.d.has(i.id))return this.d.get(i.id);if(this.l(i.id))return this.k(i,null,[],null);const n=this.a.getExtensionDescription(i.id);if(!n){const d=new Error(`Cannot activate unknown extension '${i.id.value}'`),t=this.k(i,null,[],new E(d));return this.c.onExtensionActivationError(i.id,d,new F.$VF(i.id.value)),t}const r=[],c=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const d of c){if(this.m(d))continue;const t=this.d.get(d);if(t){r.push(t);continue}if(this.l(d)){r.push(this.j({id:this.b.getExtensionDescription(d).identifier,reason:i.reason}));continue}const p=this.a.getExtensionDescription(d);if(p){if(!p.main&&!p.browser)continue;r.push(this.j({id:p.identifier,reason:i.reason}));continue}const u=n.displayName||n.identifier.value,o=new Error(`Cannot activate the '${u}' extension because it depends on unknown extension '${d}'`),v=this.k(i,n.displayName,[],new E(o));return this.c.onExtensionActivationError(n.identifier,o,new F.$VF(d)),v}return this.k(i,n.displayName,r,null)}k(i,n,r,c){const d=new s(i.id,n,i.reason,r,c,this.c,this.g);return this.d.set(i.id,d),d}l(i){return M.$O9b.isHostExtension(i,this.a,this.b)}m(i){const n=this.b.getExtensionDescription(i);return n?!n.main&&!n.browser:!1}};e.$yic=g,e.$yic=g=Ye([He(3,R.$zj)],g);let s=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(i,n,r,c,d,t,p){this.c=i,this.d=n,this.f=r,this.g=c,this.h=d,this.j=t,this.k=p,this.a=new m.$eh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let i=0;i<this.g.length;i++){const n=this.g[i];if(n.value&&!n.value.activationFailed){this.g.splice(i,1),i--;continue}if(n.value&&n.value.activationFailed){const r=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);r.detail=n.value.activationFailedError,this.h=new E(r),this.j.onExtensionActivationError(this.c,r,null);return}}this.g.length>0&&await Promise.race(this.g.map(i=>i.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(i){const n=new Error;if(i&&i.name&&(n.name=i.name),i&&i.message?n.message=`Activating extension '${this.c.value}' failed: ${i.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${i}.`,i&&i.stack&&(n.stack=i.stack),this.h=new E(n),this.b&&S.$4(i))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(i)}}};s=Ye([He(6,R.$zj)],s)}),define(Pe[222],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Pe[223],Re([1,0,182,14,32,98,72,30,20,222,192,103]),function(me,e,S,M,P,F,R,m,f,k,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RF=e.$QF=e.$PF=e.$OF=e.$NF=e.$MF=void 0;const l=m.$Wn.as(R.$Xn.JSONContribution);class E{constructor(d,t,p){this.a=d,this.b=t,this.c=p}d(d,t){this.a({type:d,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(d){this.d(P.default.Error,d)}warn(d){this.d(P.default.Warning,d)}info(d){this.d(P.default.Info,d)}}e.$MF=E;class g{static a(d){const t=new f.$Am;for(let p=0,u=d.length;p<u;p++)t.add(d[p].description.identifier);return t}static compute(d,t){if(!d||!d.length)return new g(t,[]);if(!t||!t.length)return new g([],d);const p=this.a(d),u=this.a(t),o=t.filter(b=>!p.has(b.description.identifier)),v=d.filter(b=>!u.has(b.description.identifier));return new g(o,v)}constructor(d,t){this.added=d,this.removed=t}}e.$NF=g;class s{constructor(d,t){this.name=d,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(d){if(this.a!==null)throw new Error("Handler already set!");this.a=d,this.d()}acceptUsers(d){this.c=g.compute(this.b,d),this.b=d,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(d){(0,M.$1)(d)}}}e.$OF=s;const a={type:"string",enum:["ui","workspace"],enumDescriptions:[S.localize(0,null),S.localize(1,null)]},i="vscode://schemas/vscode-extensions";e.$PF={properties:{engines:{type:"object",description:S.localize(2,null),properties:{vscode:{type:"string",description:S.localize(3,null),default:"^1.22.0"}}},publisher:{description:S.localize(4,null),type:"string"},displayName:{description:S.localize(5,null),type:"string"},categories:{description:S.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:f.$ym},{type:"string",const:"Languages",deprecationMessage:S.localize(7,null)}]}},galleryBanner:{type:"object",description:S.localize(8,null),properties:{color:{description:S.localize(9,null),type:"string"},theme:{description:S.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:S.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:S.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:S.localize(13,null)},enabledApiProposals:{markdownDescription:S.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}},api:{markdownDescription:S.localize(15,null),type:"string",enum:["none"],enumDescriptions:[S.localize(16,null)]},activationEvents:{description:S.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:S.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:S.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:S.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:S.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:S.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:S.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:S.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:S.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:S.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:S.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:S.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:S.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:S.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:S.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:S.localize(32,null)},{label:"onUri",body:"onUri",description:S.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:S.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:S.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:S.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:S.localize(37,null)},{label:"onRenderer",description:S.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:S.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:S.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:S.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:S.localize(42,null)},{label:"*",description:S.localize(43,null),body:"*"}]}},badges:{type:"array",description:S.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:S.localize(45,null)},href:{type:"string",description:S.localize(46,null)},description:{type:"string",description:S.localize(47,null)}}}},markdown:{type:"string",description:S.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:S.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:S.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:F.$Bo}},extensionPack:{description:S.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:F.$Bo}},extensionKind:{description:S.localize(52,null),type:"array",items:a,default:["workspace"],defaultSnippets:[{body:["ui"],description:S.localize(53,null)},{body:["workspace"],description:S.localize(54,null)},{body:["ui","workspace"],description:S.localize(55,null)},{body:["workspace","ui"],description:S.localize(56,null)},{body:[],description:S.localize(57,null)}]},capabilities:{description:S.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:S.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:S.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[S.localize(61,null),S.localize(62,null),S.localize(63,null)]},description:{type:"string",markdownDescription:S.localize(64,null)}}},untrustedWorkspaces:{description:S.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:S.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[S.localize(67,null),S.localize(68,null),S.localize(69,null)]},restrictedConfigurations:{description:S.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:S.localize(71,null)}}}}},sponsor:{description:S.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:S.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:S.localize(74,null),type:"string"},"vscode:uninstall":{description:S.localize(75,null),type:"string"}}},icon:{type:"string",description:S.localize(76,null)},l10n:{type:"string",description:S.localize(77,null)},pricing:{type:"string",markdownDescription:S.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(d){if(this.a.has(d.extensionPoint))throw new Error("Duplicate extension point: "+d.extensionPoint);const t=new s(d.extensionPoint,d.defaultExtensionKind);return this.a.set(d.extensionPoint,t),d.activationEventsGenerator&&D.$DF.register(d.extensionPoint,d.activationEventsGenerator),e.$PF.properties.contributes.properties[d.extensionPoint]=d.jsonSchema,l.registerSchema(i,e.$PF),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$QF=n;const r={ExtensionsRegistry:"ExtensionsRegistry"};m.$Wn.add(r.ExtensionsRegistry,new n),e.$RF=m.$Wn.as(r.ExtensionsRegistry),l.registerSchema(i,e.$PF),l.registerSchema(O.$Sj,{properties:{extensionEnabledApiProposals:{description:S.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}}]}}}})}),define(Pe[224],Re([1,0,178,16,26,223,35,5]),function(me,e,S,M,P,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fH=void 0;const f={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:S.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:S.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:S.localize(2,null),default:""}}};var k;(function(l){function E(g,s,a){if(!g)return;const i=M.$Sf(g.type)?g.type:void 0;if(!i||i.length===0){a.error(S.localize(3,null));return}const n=[];if(Array.isArray(g.required))for(const r of g.required)M.$Sf(r)&&n.push(r);return{extensionId:s.value,taskType:i,required:n,properties:g.properties?P.$Kn(g.properties):{},when:g.when?R.$dj.deserialize(g.when):void 0}}l.from=E})(k||(k={}));const O=F.$RF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(l,E)=>{for(const g of l)g.type&&E.push(`onTaskType:${g.type}`)},jsonSchema:{description:S.localize(4,null),type:"array",items:f}});class D{constructor(){this.d=new m.$5d,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((E,g)=>{O.setHandler((s,a)=>{this.c=void 0;try{for(const i of a.removed){const n=i.value;for(const r of n)this.a&&r.type&&this.a[r.type]&&delete this.a[r.type]}for(const i of a.added){const n=i.value;for(const r of n){const c=k.from(r,i.description.identifier,i.collector);c&&(this.a[c.taskType]=c)}}(a.removed.length>0||a.added.length>0)&&this.d.fire()}catch{}E(void 0)})})}onReady(){return this.b}get(E){return this.a[E]}all(){return Object.keys(this.a).map(E=>this.a[E])}getJsonSchema(){if(this.c===void 0){const E=[];for(const g of this.all()){const s={type:"object",additionalProperties:!1};g.required.length>0&&(s.required=g.required.slice(0)),g.properties!==void 0?s.properties=P.$Kn(g.properties):s.properties=Object.create(null),s.properties.type={type:"string",enum:[g.taskType]},E.push(s)}this.c={oneOf:E}}return this.c}}e.$fH=new D}),define(Pe[225],Re([1,0,179,16,24,26,35,224]),function(me,e,S,M,P,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$pH=e.JsonSchemaVersion=e.ExecutionEngine=e.$oH=e.$nH=e.$mH=e.$lH=e.$kH=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$jH=e.ShellQuoting=e.$iH=e.$hH=e.$gH=void 0,e.$gH="settings",e.$hH=new R.$wj("taskRunning",!1,S.localize(0,null)),e.$iH=S.localize2(2,"Tasks");var f;(function(C){C[C.Escape=1]="Escape",C[C.Strong=2]="Strong",C[C.Weak=3]="Weak"})(f||(e.ShellQuoting=f={})),e.$jH="$customized",function(C){function L(q){if(!q)return C.Strong;switch(q.toLowerCase()){case"escape":return C.Escape;case"strong":return C.Strong;case"weak":return C.Weak;default:return C.Strong}}C.from=L}(f||(e.ShellQuoting=f={}));var k;(function(C){C.defaults={cwd:"${workspaceFolder}"}})(k||(e.CommandOptions=k={}));var O;(function(C){C[C.Always=1]="Always",C[C.Silent=2]="Silent",C[C.Never=3]="Never"})(O||(e.RevealKind=O={})),function(C){function L(q){switch(q.toLowerCase()){case"always":return C.Always;case"silent":return C.Silent;case"never":return C.Never;default:return C.Always}}C.fromString=L}(O||(e.RevealKind=O={}));var D;(function(C){C[C.Never=1]="Never",C[C.OnProblem=2]="OnProblem",C[C.Always=3]="Always"})(D||(e.RevealProblemKind=D={})),function(C){function L(q){switch(q.toLowerCase()){case"always":return C.Always;case"never":return C.Never;case"onproblem":return C.OnProblem;default:return C.OnProblem}}C.fromString=L}(D||(e.RevealProblemKind=D={}));var l;(function(C){C[C.Shared=1]="Shared",C[C.Dedicated=2]="Dedicated",C[C.New=3]="New"})(l||(e.PanelKind=l={})),function(C){function L(q){switch(q.toLowerCase()){case"shared":return C.Shared;case"dedicated":return C.Dedicated;case"new":return C.New;default:return C.Shared}}C.fromString=L}(l||(e.PanelKind=l={}));var E;(function(C){C.defaults={echo:!0,reveal:O.Always,revealProblems:D.Never,focus:!1,panel:l.Shared,showReuseMessage:!0,clear:!1}})(E||(e.PresentationOptions=E={}));var g;(function(C){C[C.Shell=1]="Shell",C[C.Process=2]="Process",C[C.CustomExecution=3]="CustomExecution"})(g||(e.RuntimeType=g={})),function(C){function L(ne){switch(ne.toLowerCase()){case"shell":return C.Shell;case"process":return C.Process;case"customExecution":return C.CustomExecution;default:return C.Process}}C.fromString=L;function q(ne){switch(ne){case C.Shell:return"shell";case C.Process:return"process";case C.CustomExecution:return"customExecution";default:return"process"}}C.toString=q}(g||(e.RuntimeType=g={}));var s;(function(C){function L(q){return M.$Sf(q)?q:q.value}C.value=L})(s||(e.CommandString=s={}));var a;(function(C){C.Clean={_id:"clean",isDefault:!1},C.Build={_id:"build",isDefault:!1},C.Rebuild={_id:"rebuild",isDefault:!1},C.Test={_id:"test",isDefault:!1};function L(ne){return ne===C.Clean._id||ne===C.Build._id||ne===C.Rebuild._id||ne===C.Test._id}C.is=L;function q(ne){if(ne!==void 0)return M.$Sf(ne)?L(ne)?{_id:ne,isDefault:!1}:void 0:ne}C.from=q})(a||(e.TaskGroup=a={}));var i;(function(C){C[C.Global=1]="Global",C[C.Workspace=2]="Workspace",C[C.Folder=3]="Folder"})(i||(e.TaskScope=i={}));var n;(function(C){C.Workspace="workspace",C.Extension="extension",C.InMemory="inMemory",C.WorkspaceFile="workspaceFile",C.User="user";function L(q){switch(q){case C.User:return 2;case C.WorkspaceFile:return 5;default:return 6}}C.toConfigurationTarget=L})(n||(e.TaskSourceKind=n={}));var r;(function(C){C.parallel="parallel",C.sequence="sequence"})(r||(e.DependsOrder=r={}));var c;(function(C){C[C.default=1]="default",C[C.folderOpen=2]="folderOpen"})(c||(e.RunOnOptions=c={}));var d;(function(C){C.defaults={reevaluateOnRerun:!0,runOn:c.default,instanceLimit:1}})(d||(e.RunOptions=d={}));class t{constructor(L,q,ne,ae,ye,Ie){this._label="",this._id=L,q&&(this._label=q),ne&&(this.type=ne),this.runOptions=ae,this.configurationProperties=ye,this._source=Ie}getDefinition(L){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const L={folder:this.d(),id:this._id};return JSON.stringify(L)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(L,q=!1){if(L===void 0)return!1;if(M.$Sf(L))return L===this._label||L===this.configurationProperties.identifier||q&&L===this._id;const ne=this.getDefinition(!0);return ne!==void 0&&ne._key===L._key}getQualifiedLabel(){const L=this.getWorkspaceFolder();return L?`${this._label} (${L.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(L){this.c===void 0&&(this.c=[]),L&&(this.c=this.c.concat(L))}get taskLoadMessages(){return this.c}}e.$kH=t;class p extends t{constructor(L,q,ne,ae,ye,Ie,ue,ve){super(L,ne,void 0,ue,ve,q),this.command={},this._source=q,this.hasDefinedMatchers=Ie,ye&&(this.command=ye)}clone(){return new p(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(L=!1){if(L&&this._source.customizes!==void 0)return this._source.customizes;{let q;switch(this.command?this.command.runtime:void 0){case g.Shell:q="shell";break;case g.Process:q="process";break;case g.CustomExecution:q="customExecution";break;case void 0:q="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:q,_key:this._id,id:this._id}}}static is(L){return L instanceof p}getMapKey(){const L=this._source.config.workspaceFolder;return L?`${L.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$gH:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const L=this.d();if(!L)return;let q=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(q+=this._source.kind);const ne={type:e.$jH,folder:L,id:q};return JSON.stringify(ne)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$Pg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(L){return new p(L._id,L._source,L._label,L.type,L.command,L.hasDefinedMatchers,L.runOptions,L.configurationProperties)}}e.$lH=p;class u extends t{constructor(L,q,ne,ae,ye,Ie,ue){super(L,ne,ae,Ie,ue,q),this._source=q,this.configures=ye}static is(L){return L instanceof u}f(L){return L}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$Pg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$gH:this._source.config.workspaceFolder?.uri.toString()}getKey(){const L=this.d();if(!L)return;let q=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(q+=this._source.kind);const ne={type:e.$jH,folder:L,id:q};return JSON.stringify(ne)}}e.$mH=u;class o extends t{constructor(L,q,ne,ae,ye,Ie,ue,ve,re){super(L,ne,ae,ve,re,q),this.defines=ye,this.hasDefinedMatchers=ue,this.command=Ie,this.icon=re.icon,this.hide=re.hide}clone(){return new o(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(L){return L instanceof o}getMapKey(){const L=this._source.workspaceFolder;return L?`${this._source.scope.toString()}|${L.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const L={type:"contributed",scope:this._source.scope,id:this._id};return L.folder=this.d(),JSON.stringify(L)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(L){return new o(L._id,L._source,L._label,L.type,L.defines,L.command,L.hasDefinedMatchers,L.runOptions,L.configurationProperties)}}e.$nH=o;class v extends t{constructor(L,q,ne,ae,ye,Ie){super(L,ne,ae,ye,Ie,q),this._source=q}clone(){return new v(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(L){return L instanceof v}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(L){return new v(L._id,L._source,L._label,L.type,L.runOptions,L.configurationProperties)}}e.$oH=v;var b;(function(C){C[C.Process=1]="Process",C[C.Terminal=2]="Terminal"})(b||(e.ExecutionEngine=b={})),function(C){C._default=C.Terminal}(b||(e.ExecutionEngine=b={}));var $;(function(C){C[C.V0_1_0=1]="V0_1_0",C[C.V2_0_0=2]="V2_0_0"})($||(e.JsonSchemaVersion=$={}));class I{constructor(L){this.c=new Map;for(let q=0;q<L.length;q++)this.c.set(L[q].uri.toString(),q)}compare(L,q){const ne=L.getWorkspaceFolder(),ae=q.getWorkspaceFolder();if(ne&&ae){let ye=this.c.get(ne.uri.toString());ye=ye===void 0?0:ye+1;let Ie=this.c.get(ae.uri.toString());return Ie=Ie===void 0?0:Ie+1,ye===Ie?L._label.localeCompare(q._label):ye-Ie}else return!ne&&ae?-1:ne&&!ae?1:0}}e.$pH=I;var h;(function(C){C.DependsOnStarted="dependsOnStarted",C.AcquiredInput="acquiredInput",C.Start="start",C.ProcessStarted="processStarted",C.Active="active",C.Inactive="inactive",C.Changed="changed",C.Terminated="terminated",C.ProcessEnded="processEnded",C.End="end"})(h||(e.TaskEventKind=h={}));var y;(function(C){C.SingleRun="singleRun",C.Background="background"})(y||(e.TaskRunType=y={}));var w;(function(C){C[C.System=0]="System",C[C.User=1]="User",C[C.FolderOpen=2]="FolderOpen",C[C.ConfigurationChange=3]="ConfigurationChange",C[C.Reconnect=4]="Reconnect"})(w||(e.TaskRunSource=w={}));var A;(function(C){function L(ve){return{taskId:ve._id,taskName:ve.configurationProperties.name,runType:ve.configurationProperties.isBackground?"background":"singleRun",group:ve.configurationProperties.group,__task:ve}}function q(ve,re,$e){return{...L(ve),kind:"start",terminalId:re,resolvedVariables:$e}}C.start=q;function ne(ve,re,$e){return{...L(ve),kind:"processStarted",terminalId:re,processId:$e}}C.processStarted=ne;function ae(ve,re,$e){return{...L(ve),kind:"processEnded",terminalId:re,exitCode:$e}}C.processEnded=ae;function ye(ve,re,$e){return{...L(ve),kind:"terminated",exitReason:$e,terminalId:re}}C.terminated=ye;function Ie(ve,re,$e){return{...L(re),kind:ve,terminalId:$e}}C.general=Ie;function ue(){return{kind:"changed"}}C.changed=ue})(A||(e.TaskEvent=A={}));var N;(function(C){function L(ne){const ae=Object.keys(ne).sort();let ye="";for(const Ie of ae){let ue=ne[Ie];ue instanceof Object?ue=L(ue):typeof ue=="string"&&(ue=ue.replace(/,/g,",,")),ye+=Ie+","+ue+","}return ye}function q(ne){const ye={_key:L(ne),type:ne.taskType};return Object.assign(ye,ne),ye}C.create=q})(N||(e.KeyedTaskIdentifier=N={}));var G;(function(C){C.AutoDetect="task.autoDetect",C.SaveBeforeRun="task.saveBeforeRun",C.ShowDecorations="task.showDecorations",C.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",C.SlowProviderWarning="task.slowProviderWarning",C.QuickOpenHistory="task.quickOpen.history",C.QuickOpenDetail="task.quickOpen.detail",C.QuickOpenSkip="task.quickOpen.skip",C.QuickOpenShowAll="task.quickOpen.showAll",C.AllowAutomaticTasks="task.allowAutomaticTasks",C.Reconnection="task.reconnection",C.VerboseLogging="task.verboseLogging"})(G||(e.TaskSettingId=G={}));var V;(function(C){C.Tasks="tasks",C.SuppressTaskName="tasks.suppressTaskName",C.Windows="tasks.windows",C.Osx="tasks.osx",C.Linux="tasks.linux",C.ShowOutput="tasks.showOutput",C.IsShellCommand="tasks.isShellCommand",C.ServiceTestSetting="tasks.service.testSetting"})(V||(e.TasksSchemaProperties=V={}));var U;(function(C){function L(q,ne){const ae=m.$fH.get(q.type);if(ae===void 0){const ve=F.$Kn(q);return delete ve._key,N.create(ve)}const ye=Object.create(null);ye.type=ae.taskType;const Ie=new Set;ae.required.forEach(ve=>Ie.add(ve));const ue=ae.properties;for(const ve of Object.keys(ue)){const re=q[ve];if(re!=null)ye[ve]=re;else if(Ie.has(ve)){const $e=ue[ve];if($e.default!==void 0)ye[ve]=F.$Kn($e.default);else switch($e.type){case"boolean":ye[ve]=!1;break;case"number":case"integer":ye[ve]=0;break;case"string":ye[ve]="";break;default:ne.error(S.localize(1,null,JSON.stringify(q,void 0,0),ve));return}}}return N.create(ye)}C.createTaskIdentifier=L})(U||(e.TaskDefinition=U={}))}),define(Pe[226],Re([1,0,14]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T9b=e.$S9b=void 0;class M{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,m)=>{this.b=R,this.d=m,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,S.$1)(R))}then(R,m){return this.j().then(R,m)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$S9b=M;class P extends M{constructor(){super(),this.h=!0,this.i=new S.$5}}e.$T9b=P}),define(Pe[49],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9v=e.$8v=e.$7v=e.$6v=void 0;class S{static{this.count=0}constructor(f){this._proxyIdentifierBrand=void 0,this.sid=f,this.nid=++S.count}}e.$6v=S;const M=[];function P(m){const f=new S(m);return M[f.nid]=f,f}e.$7v=P;function F(m){return M[m].sid}e.$8v=F;class R{constructor(f){this.value=f}}e.$9v=R}),define(Pe[4],Re([1,0,49]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7L=e.$6L=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$5L=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var M;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(M||(e.TextEditorRevealType=M={}));var P;(function(s){s[s.UnknownInput=0]="UnknownInput",s[s.TextInput=1]="TextInput",s[s.TextDiffInput=2]="TextDiffInput",s[s.TextMergeInput=3]="TextMergeInput",s[s.NotebookInput=4]="NotebookInput",s[s.NotebookDiffInput=5]="NotebookDiffInput",s[s.CustomEditorInput=6]="CustomEditorInput",s[s.WebviewEditorInput=7]="WebviewEditorInput",s[s.TerminalEditorInput=8]="TerminalEditorInput",s[s.InteractiveEditorInput=9]="InteractiveEditorInput",s[s.ChatEditorInput=10]="ChatEditorInput"})(P||(e.TabInputKind=P={}));var F;(function(s){s[s.TAB_OPEN=0]="TAB_OPEN",s[s.TAB_CLOSE=1]="TAB_CLOSE",s[s.TAB_UPDATE=2]="TAB_UPDATE",s[s.TAB_MOVE=3]="TAB_MOVE"})(F||(e.TabModelOperationKind=F={}));var R;(function(s){s[s.Editable=0]="Editable",s[s.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var m;(function(s){s[s.Int8Array=1]="Int8Array",s[s.Uint8Array=2]="Uint8Array",s[s.Uint8ClampedArray=3]="Uint8ClampedArray",s[s.Int16Array=4]="Int16Array",s[s.Uint16Array=5]="Uint16Array",s[s.Int32Array=6]="Int32Array",s[s.Uint32Array=7]="Uint32Array",s[s.Float32Array=8]="Float32Array",s[s.Float64Array=9]="Float64Array",s[s.BigInt64Array=10]="BigInt64Array",s[s.BigUint64Array=11]="BigUint64Array"})(m||(e.WebviewMessageArrayBufferViewType=m={}));var f;(function(s){s[s.Text=1]="Text",s[s.Error=2]="Error",s[s.Rich=3]="Rich"})(f||(e.CellOutputKind=f={}));var k;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(k||(e.NotebookEditorRevealType=k={}));var O;(function(s){s[s.None=0]="None",s[s.Process=1]="Process",s[s.Output=2]="Output"})(O||(e.CandidatePortSource=O={}));class D{static{this.a=0}static mixin(a){return a._id=D.a++,a}}e.$5L=D;var l;(function(s){s.label="a",s.kind="b",s.detail="c",s.documentation="d",s.sortText="e",s.filterText="f",s.preselect="g",s.insertText="h",s.insertTextRules="i",s.range="j",s.commitCharacters="k",s.additionalTextEdits="l",s.kindModifier="m",s.commandIdent="n",s.commandId="o",s.commandArguments="p"})(l||(e.ISuggestDataDtoField=l={}));var E;(function(s){s.defaultRanges="a",s.completions="b",s.isIncomplete="c",s.duration="d"})(E||(e.ISuggestResultDtoField=E={}));var g;(function(s){s[s.Workspace=0]="Workspace",s[s.TextDocument=1]="TextDocument"})(g||(e.ExtHostTestingResource=g={})),e.$6L={MainThreadAuthentication:(0,S.$7v)("MainThreadAuthentication"),MainThreadBulkEdits:(0,S.$7v)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,S.$7v)("MainThreadLanguageModels"),MainThreadChatAgents2:(0,S.$7v)("MainThreadChatAgents2"),MainThreadChatVariables:(0,S.$7v)("MainThreadChatVariables"),MainThreadClipboard:(0,S.$7v)("MainThreadClipboard"),MainThreadCommands:(0,S.$7v)("MainThreadCommands"),MainThreadComments:(0,S.$7v)("MainThreadComments"),MainThreadConfiguration:(0,S.$7v)("MainThreadConfiguration"),MainThreadConsole:(0,S.$7v)("MainThreadConsole"),MainThreadDebugService:(0,S.$7v)("MainThreadDebugService"),MainThreadDecorations:(0,S.$7v)("MainThreadDecorations"),MainThreadDiagnostics:(0,S.$7v)("MainThreadDiagnostics"),MainThreadDialogs:(0,S.$7v)("MainThreadDiaglogs"),MainThreadDocuments:(0,S.$7v)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,S.$7v)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,S.$7v)("MainThreadTextEditors"),MainThreadEditorInsets:(0,S.$7v)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,S.$7v)("MainThreadEditorTabs"),MainThreadErrors:(0,S.$7v)("MainThreadErrors"),MainThreadTreeViews:(0,S.$7v)("MainThreadTreeViews"),MainThreadDownloadService:(0,S.$7v)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,S.$7v)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,S.$7v)("MainThreadLanguages"),MainThreadLogger:(0,S.$7v)("MainThreadLogger"),MainThreadMessageService:(0,S.$7v)("MainThreadMessageService"),MainThreadOutputService:(0,S.$7v)("MainThreadOutputService"),MainThreadProgress:(0,S.$7v)("MainThreadProgress"),MainThreadQuickDiff:(0,S.$7v)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,S.$7v)("MainThreadQuickOpen"),MainThreadStatusBar:(0,S.$7v)("MainThreadStatusBar"),MainThreadSecretState:(0,S.$7v)("MainThreadSecretState"),MainThreadStorage:(0,S.$7v)("MainThreadStorage"),MainThreadSpeech:(0,S.$7v)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,S.$7v)("MainThreadTelemetry"),MainThreadTerminalService:(0,S.$7v)("MainThreadTerminalService"),MainThreadWebviews:(0,S.$7v)("MainThreadWebviews"),MainThreadWebviewPanels:(0,S.$7v)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,S.$7v)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,S.$7v)("MainThreadCustomEditors"),MainThreadUrls:(0,S.$7v)("MainThreadUrls"),MainThreadUriOpeners:(0,S.$7v)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,S.$7v)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,S.$7v)("MainThreadWorkspace"),MainThreadFileSystem:(0,S.$7v)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,S.$7v)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,S.$7v)("MainThreadExtensionService"),MainThreadSCM:(0,S.$7v)("MainThreadSCM"),MainThreadSearch:(0,S.$7v)("MainThreadSearch"),MainThreadShare:(0,S.$7v)("MainThreadShare"),MainThreadTask:(0,S.$7v)("MainThreadTask"),MainThreadWindow:(0,S.$7v)("MainThreadWindow"),MainThreadLabelService:(0,S.$7v)("MainThreadLabelService"),MainThreadNotebook:(0,S.$7v)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,S.$7v)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,S.$7v)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,S.$7v)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,S.$7v)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,S.$7v)("MainThreadInteractive"),MainThreadChat:(0,S.$7v)("MainThreadChat"),MainThreadInlineChat:(0,S.$7v)("MainThreadInlineChatShape"),MainThreadTheming:(0,S.$7v)("MainThreadTheming"),MainThreadTunnelService:(0,S.$7v)("MainThreadTunnelService"),MainThreadManagedSockets:(0,S.$7v)("MainThreadManagedSockets"),MainThreadTimeline:(0,S.$7v)("MainThreadTimeline"),MainThreadTesting:(0,S.$7v)("MainThreadTesting"),MainThreadLocalization:(0,S.$7v)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,S.$7v)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,S.$7v)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,S.$7v)("MainThreadIssueReporter")},e.$7L={ExtHostCommands:(0,S.$7v)("ExtHostCommands"),ExtHostConfiguration:(0,S.$7v)("ExtHostConfiguration"),ExtHostDiagnostics:(0,S.$7v)("ExtHostDiagnostics"),ExtHostDebugService:(0,S.$7v)("ExtHostDebugService"),ExtHostDecorations:(0,S.$7v)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,S.$7v)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,S.$7v)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,S.$7v)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,S.$7v)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,S.$7v)("ExtHostEditors"),ExtHostTreeViews:(0,S.$7v)("ExtHostTreeViews"),ExtHostFileSystem:(0,S.$7v)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,S.$7v)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,S.$7v)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,S.$7v)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,S.$7v)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,S.$7v)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,S.$7v)("ExtHostQuickDiff"),ExtHostStatusBar:(0,S.$7v)("ExtHostStatusBar"),ExtHostShare:(0,S.$7v)("ExtHostShare"),ExtHostExtensionService:(0,S.$7v)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,S.$7v)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,S.$7v)("ExtHostTerminalService"),ExtHostSCM:(0,S.$7v)("ExtHostSCM"),ExtHostSearch:(0,S.$7v)("ExtHostSearch"),ExtHostTask:(0,S.$7v)("ExtHostTask"),ExtHostWorkspace:(0,S.$7v)("ExtHostWorkspace"),ExtHostWindow:(0,S.$7v)("ExtHostWindow"),ExtHostWebviews:(0,S.$7v)("ExtHostWebviews"),ExtHostWebviewPanels:(0,S.$7v)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,S.$7v)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,S.$7v)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,S.$7v)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,S.$7v)("ExtHostEditorTabs"),ExtHostProgress:(0,S.$7v)("ExtHostProgress"),ExtHostComments:(0,S.$7v)("ExtHostComments"),ExtHostSecretState:(0,S.$7v)("ExtHostSecretState"),ExtHostStorage:(0,S.$7v)("ExtHostStorage"),ExtHostUrls:(0,S.$7v)("ExtHostUrls"),ExtHostUriOpeners:(0,S.$7v)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,S.$7v)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,S.$7v)("ExtHostOutputService"),ExtHostLabelService:(0,S.$7v)("ExtHostLabelService"),ExtHostNotebook:(0,S.$7v)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,S.$7v)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,S.$7v)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,S.$7v)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,S.$7v)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,S.$7v)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,S.$7v)("ExtHostInteractive"),ExtHostInlineChat:(0,S.$7v)("ExtHostInlineChatShape"),ExtHostChat:(0,S.$7v)("ExtHostChat"),ExtHostChatAgents2:(0,S.$7v)("ExtHostChatAgents"),ExtHostChatVariables:(0,S.$7v)("ExtHostChatVariables"),ExtHostChatProvider:(0,S.$7v)("ExtHostChatProvider"),ExtHostSpeech:(0,S.$7v)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,S.$7v)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,S.$7v)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,S.$7v)("ExtHostTheming"),ExtHostTunnelService:(0,S.$7v)("ExtHostTunnelService"),ExtHostManagedSockets:(0,S.$7v)("ExtHostManagedSockets"),ExtHostAuthentication:(0,S.$7v)("ExtHostAuthentication"),ExtHostTimeline:(0,S.$7v)("ExtHostTimeline"),ExtHostTesting:(0,S.$7v)("ExtHostTesting"),ExtHostTelemetry:(0,S.$7v)("ExtHostTelemetry"),ExtHostLocalization:(0,S.$7v)("ExtHostLocalization"),ExtHostIssueReporter:(0,S.$7v)("ExtHostIssueReporter")}}),define(Pe[78],Re([1,0,3,13,4,17]),function(me,e,S,M,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rhc=e.$Qhc=e.$Phc=void 0,e.$Phc=(0,S.$fi)("IExtHostApiDeprecationService");let R=class{constructor(f,k){this.c=k,this.a=new Set,this.b=f.getProxy(P.$6L.MainThreadTelemetry)}report(f,k,O){const D=this.d(f,k);this.a.has(D)||(this.a.add(D),k.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${f}' is deprecated. ${O}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:f}))}d(f,k){return`${f}-${k.identifier.value}`}};e.$Qhc=R,e.$Qhc=R=Ye([He(0,F.$lO),He(1,M.$zj)],R),e.$Rhc=Object.freeze(new class{report(m,f,k){}})}),define(Pe[227],Re([1,0,51,6,4]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3hc=void 0;class F{static{this.a=0}constructor(f,k){this.extension=f,this.provider=k,this.handle=F.a++}}class R{static{this.a=0}constructor(f){this.b=new Map,this.c=new Map,this.d=f.getProxy(P.$6L.MainThreadChat)}registerChatProvider(f,k,O){const D=new F(f,O);return this.b.set(D.handle,D),this.d.$registerChatProvider(D.handle,k),(0,M.$Rc)(()=>{this.d.$unregisterChatProvider(D.handle),this.b.delete(D.handle)})}transferChatSession(f,k){const O=S.Iterable.find(this.c.keys(),D=>this.c.get(D)===f)??0;typeof O=="number"&&this.d.$transferChatSession(O,k)}sendInteractiveRequestToProvider(f,k){this.d.$sendRequestToProvider(f,k)}async $prepareChat(f,k){const O=this.b.get(f);if(!O)return;const D=await O.provider.prepareSession(k);if(!D)return;const l=R.a++;return this.c.set(l,D),{id:l,requesterUsername:D.requester?.name,requesterAvatarIconUri:D.requester?.icon,responderUsername:D.responder?.name,responderAvatarIconUri:D.responder?.icon,inputPlaceholder:D.inputPlaceholder}}$releaseSession(f){this.c.delete(f)}}e.$3hc=R}),define(Pe[228],Re([1,0,4]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8hc=void 0;class M{constructor(F){const R=F.getProxy(S.$6L.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(m){return R.$writeText(m)}})}}e.$8hc=M}),define(Pe[229],Re([1,0,26,4,27,17]),function(me,e,S,M,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yjc=void 0;let R=class{constructor(O,D){this.a=O.getProxy(M.$6L.MainThreadConsole),this.b=D.consoleForward.includeStack,this.c=D.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(O,D){const l=this,E=console[O];Object.defineProperty(console,O,{set:()=>{},get:()=>function(){l.e(O,D,E,arguments)}})}e(O,D,l,E){this.a.$logExtensionHostMessage({type:"__$console",severity:D,arguments:f(E,this.b)}),this.c&&this.f(O,l,E)}};e.$Yjc=R,e.$Yjc=R=Ye([He(0,F.$lO),He(1,P.$BO)],R);const m=1e5;function f(k,O){const D=[];if(k.length)for(let l=0;l<k.length;l++){let E=k[l];if(typeof E>"u")E="undefined";else if(E instanceof Error){const g=E;g.stack?E=g.stack:E=g.toString()}D.push(E)}if(O){const l=new Error().stack;l&&D.push({__$stack:l.split(`
`).slice(3).join(`
`)})}try{const l=(0,S.$Pn)(D);return l.length>m?"Output omitted for a large object that exceeds the limits":l}catch(l){return`Output omitted for an object that cannot be inspected ('${l.toString()}')`}}}),define(Pe[230],Re([1,0,2,4,22]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ic=void 0;class F{constructor(m){this.a=m.getProxy(M.$6L.MainThreadDialogs)}showOpenDialog(m,f){return f?.allowUIResources&&(0,P.$YF)(m,"showLocal"),this.a.$showOpenDialog(f).then(k=>k?k.map(O=>S.URI.revive(O)):void 0)}showSaveDialog(m){return this.a.$showSaveDialog(m).then(f=>f?S.URI.revive(f):void 0)}}e.$3ic=F}),define(Pe[231],Re([1,0,6,4]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ljc=void 0;class P{constructor(R){this.b=0,this.a=R.getProxy(M.$6L.MainThreadLabelService)}$registerResourceLabelFormatter(R){const m=this.b++;return this.a.$registerResourceLabelFormatter(m,R),(0,S.$Rc)(()=>{this.a.$unregisterResourceLabelFormatter(m)})}}e.$ljc=P}),define(Pe[79],Re([1,0,21,15,2,3,13,4,27,17]),function(me,e,S,M,P,F,R,m,f,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lic=e.$Kic=void 0;let O=class{constructor(l,E,g){this.f=g,this.d=new Map,this.a=E.getProxy(m.$6L.MainThreadLocalization),this.b=l.environment.appLanguage,this.c=this.b===S.$g}getMessage(l,E){const{message:g,args:s,comment:a}=E;if(this.c)return(0,M.$Ue)(g,s??{});let i=g;a&&a.length>0&&(i+=`/${Array.isArray(a)?a.join(""):a}`);const n=this.d.get(l)?.contents[i];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${i}`),(0,M.$Ue)(n??g,s??{})}getBundle(l){return this.d.get(l)?.contents}getBundleUri(l){return this.d.get(l)?.uri}async initializeLocalizedMessages(l){if(this.c||!l.l10n&&!l.isBuiltin||this.d.has(l.identifier.value))return;let E;const g=await this.g(l);if(!g){this.f.error(`No bundle location found for extension ${l.identifier.value}`);return}try{const s=await this.a.$fetchBundleContents(g),a=JSON.parse(s);E=l.isBuiltin?a.contents?.bundle:a}catch(s){this.f.error(`Failed to load translations for ${l.identifier.value} from ${g}: ${s.message}`);return}E&&this.d.set(l.identifier.value,{contents:E,uri:g})}async g(l){if(l.isBuiltin){const E=await this.a.$fetchBuiltInBundleUri(l.identifier.value,this.b);return P.URI.revive(E)}return l.l10n?P.URI.joinPath(l.extensionLocation,l.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Kic=O,e.$Kic=O=Ye([He(0,f.$BO),He(1,k.$lO),He(2,R.$zj)],O),e.$Lic=(0,F.$fi)("IExtHostLocalizationService")}),define(Pe[232],Re([1,0,13,4,27,17,2,52]),function(me,e,S,M,P,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xjc=void 0;let f=class extends S.$Kj{constructor(D,l){super(l.logLevel,l.logsLocation,l.loggers.map(E=>(0,m.$Oh)(E))),this.r=D.getProxy(M.$6L.MainThreadLogger)}$setLogLevel(D,l){l?this.setLogLevel(R.URI.revive(l),D):this.setLogLevel(D)}setVisibility(D,l){super.setVisibility(D,l),this.r.$setVisibility(D,l)}s(D,l,E){return new k(this.r,D,l,E)}};e.$Xjc=f,e.$Xjc=f=Ye([He(0,F.$lO),He(1,P.$BO)],f);class k extends S.$Fj{constructor(D,l,E,g){super(g?.logLevel==="always"),this.r=D,this.s=l,this.m=!1,this.n=[],this.setLevel(E),this.r.$createLogger(l,g).then(()=>{this.u(this.n),this.m=!0})}g(D,l){const E=[[D,l]];this.m?this.u(E):this.n.push(...E)}u(D){this.r.$log(this.s,D)}flush(){this.r.$flush(this.s)}}}),define(Pe[80],Re([1,0,4,3,6,17,23]),function(me,e,S,M,P,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nic=e.$Mic=void 0,e.$Mic=(0,M.$fi)("IExtHostManagedSockets");let m=class{constructor(D){this.b=0,this.c=null,this.d=new Map,this.a=D.getProxy(S.$6L.MainThreadManagedSockets)}setFactory(D,l){for(const E of this.d.values())E.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new f(D,l),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(D){if(!this.c||this.c.socketFactoryId!==D)throw new Error(`No socket factory with id ${D}`);const l=++this.b,E=await this.c.makeConnection(),g=new P.$Sc;return this.d.set(l,new k(l,E,g)),g.add((0,P.$Rc)(()=>this.d.delete(l))),g.add(E.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(l),g.dispose()})),g.add(E.onDidClose(s=>{this.a.$onDidManagedSocketClose(l,s?.stack??s?.message),g.dispose()})),g.add(E.onDidReceiveMessage(s=>this.a.$onDidManagedSocketHaveData(l,R.$se.wrap(s)))),l}$remoteSocketWrite(D,l){this.d.get(D)?.actual.send(l.buffer)}$remoteSocketEnd(D){const l=this.d.get(D);l&&(l.actual.end(),l.dispose())}async $remoteSocketDrain(D){await this.d.get(D)?.actual.drain?.()}};e.$Nic=m,e.$Nic=m=Ye([He(0,F.$lO)],m);class f{constructor(D,l){this.socketFactoryId=D,this.makeConnection=l}}class k extends P.$Tc{constructor(D,l,E){super(),this.socketId=D,this.actual=l,this.B(E)}}}),define(Pe[233],Re([1,0,4,13,22]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$njc=void 0;function F(m){return m&&m.title}let R=class{constructor(f,k){this.b=k,this.a=f.getProxy(S.$6L.MainThreadMessageService)}showMessage(f,k,O,D,l){const E={source:{identifier:f.identifier,label:f.displayName||f.name}};let g;typeof D=="string"||F(D)?g=[D,...l]:(E.modal=D?.modal,E.useCustom=D?.useCustom,E.detail=D?.detail,g=l),E.useCustom&&(0,P.$YF)(f,"resolvers");const s=[];let a=!1;for(let i=0;i<g.length;i++){const n=g[i];if(typeof n=="string")s.push({title:n,handle:i,isCloseAffordance:!1});else if(typeof n=="object"){const{title:r,isCloseAffordance:c}=n;s.push({title:r,isCloseAffordance:!!c,handle:i}),c&&(a?this.b.warn(`[${f.identifier}] Only one message item can have 'isCloseAffordance':`,n):a=!0)}else this.b.warn(`[${f.identifier}] Invalid message item:`,n)}return this.a.$showMessage(k,O,E,s).then(i=>{if(typeof i=="number")return g[i]})}};e.$njc=R,e.$njc=R=Ye([He(1,M.$zj)],R)}),define(Pe[234],Re([1,0,6,16,2,22,4]),function(me,e,S,M,P,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wjc=void 0;class m{constructor(k){this.b=new Map,this.a=k.getProxy(R.$6L.MainThreadProfileContentHandlers)}registerProfileContentHandler(k,O,D){if((0,F.$YF)(k,"profileContentHandlers"),this.b.has(O))throw new Error(`Handler with id '${O}' already registered`);return this.b.set(O,D),this.a.$registerProfileContentHandler(O,D.name,D.description,k.identifier.value),(0,S.$Rc)(()=>{this.b.delete(O),this.a.$unregisterProfileContentHandler(O)})}async $saveProfile(k,O,D,l){const E=this.b.get(k);if(!E)throw new Error(`Unknown handler with id: ${k}`);return E.saveProfile(O,D,l)}async $readProfile(k,O,D){const l=this.b.get(k);if(!l)throw new Error(`Unknown handler with id: ${k}`);return l.readProfile((0,M.$Sf)(O)?O:P.URI.revive(O),D)}}e.$wjc=m}),define(Pe[81],Re([1,0,4,5,3]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iic=e.$Hic=void 0;class F{constructor(m){this.b=new M.$5d,this.onDidChangePassword=this.b.event,this.a=m.getProxy(S.$6L.MainThreadSecretState)}async $onDidChangePassword(m){this.b.fire(m)}get(m,f){return this.a.$getPassword(m,f)}store(m,f,k){return this.a.$setPassword(m,f,k)}delete(m,f){return this.a.$deletePassword(m,f)}}e.$Hic=F,e.$Iic=(0,P.$fi)("IExtHostSecretState")}),define(Pe[235],Re([1,0,25,6,4]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Djc=void 0;class F{static{this.a=1}constructor(m){this.c=new Map,this.d=new Map,this.b=m.getProxy(P.$6L.MainThreadSpeech)}async $createSpeechToTextSession(m,f,k){const O=this.c.get(m);if(!O)return;const D=new M.$Sc,l=new S.$ce;this.d.set(f,l);const E=D.add(O.provideSpeechToTextSession(l.token,k?{language:k}:void 0));D.add(E.onDidChange(g=>{l.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(f,g)})),D.add(l.token.onCancellationRequested(()=>D.dispose()))}async $cancelSpeechToTextSession(m){this.d.get(m)?.dispose(!0),this.d.delete(m)}async $createKeywordRecognitionSession(m,f){const k=this.c.get(m);if(!k)return;const O=new M.$Sc,D=new S.$ce;this.d.set(f,D);const l=O.add(k.provideKeywordRecognitionSession(D.token));O.add(l.onDidChange(E=>{D.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(f,E)})),O.add(D.token.onCancellationRequested(()=>O.dispose()))}async $cancelKeywordRecognitionSession(m){this.d.get(m)?.dispose(!0),this.d.delete(m)}registerProvider(m,f,k){const O=F.a++;return this.c.set(O,k),this.b.$registerProvider(O,f,{extension:m,displayName:m.value}),(0,M.$Rc)(()=>{this.b.$unregisterProvider(O),this.c.delete(O)})}}e.$Djc=F}),define(Pe[82],Re([1,0,4,5,3]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aic=e.$zic=void 0;class F{constructor(m,f){this.c=f,this.b=new M.$5d,this.onDidChangeStorage=this.b.event,this.a=m.getProxy(S.$6L.MainThreadStorage)}registerExtensionStorageKeysToSync(m,f){this.a.$registerExtensionStorageKeysToSync(m,f)}async initializeExtensionStorage(m,f,k){const O=await this.a.$initializeExtensionStorage(m,f);let D;return O&&(D=this.d(m,f,O)),D||k}setValue(m,f,k){return this.a.$setValue(m,f,k)}$acceptValue(m,f,k){const O=this.d(m,f,k);O&&this.b.fire({shared:m,key:f,value:O})}d(m,f,k){try{return JSON.parse(k)}catch(O){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${f}, global: ${m}): ${O}`)}}}e.$zic=F,e.$Aic=(0,P.$fi)("IExtHostStorage")}),define(Pe[236],Re([1,0,6,12,2,4]),function(me,e,S,M,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rjc=void 0;class R{static{this.a=new Set([M.Schemas.http,M.Schemas.https])}constructor(f){this.c=new Map,this.b=f.getProxy(F.$6L.MainThreadUriOpeners)}registerExternalUriOpener(f,k,O,D){if(this.c.has(k))throw new Error(`Opener with id '${k}' already registered`);const l=D.schemes.find(E=>!R.a.has(E));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this.c.set(k,O),this.b.$registerUriOpener(k,D.schemes,f,D.label),(0,S.$Rc)(()=>{this.c.delete(k),this.b.$unregisterUriOpener(k)})}async $canOpenUri(f,k,O){const D=this.c.get(f);if(!D)throw new Error(`Unknown opener with id: ${f}`);const l=P.URI.revive(k);return D.canOpenExternalUri(l,O)}async $openUri(f,k,O){const D=this.c.get(f);if(!D)throw new Error(`Unknown opener id: '${f}'`);return D.openExternalUri(P.URI.revive(k.resolvedUri),{sourceUri:P.URI.revive(k.sourceUri)},O)}}e.$Rjc=R}),define(Pe[237],Re([1,0,4,2,6,14,20]),function(me,e,S,M,P,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sjc=void 0;class m{static{this.a=0}constructor(k){this.c=new R.$Am,this.d=new Map,this.b=k.getProxy(S.$6L.MainThreadUrls)}registerUriHandler(k,O){const D=k.identifier;if(this.c.has(D))throw new Error(`Protocol handler already registered for extension ${D}`);const l=m.a++;return this.c.add(D),this.d.set(l,O),this.b.$registerUriHandler(l,D,k.displayName||k.name),(0,P.$Rc)(()=>{this.c.delete(D),this.d.delete(l),this.b.$unregisterUriHandler(l)})}$handleExternalUri(k,O){const D=this.d.get(k);if(!D)return Promise.resolve(void 0);try{D.handleUri(M.URI.revive(O))}catch(l){(0,F.$1)(l)}return Promise.resolve(void 0)}async createAppUri(k){return M.URI.revive(await this.b.$createAppUri(k))}}e.$Sjc=m}),define(Pe[62],Re([1,0,5,6,12,26,2,185,207,76,4]),function(me,e,S,M,P,F,R,m,f,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oic=e.$nic=e.$mic=e.$lic=e.$kic=void 0;class D{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(c,d,t,p,u,o,v){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new S.$5d,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new S.$5d,this._onDidDispose=this.#h.event,this.#e=c,this.#t=d,this.#o=t,this.#n=p,this.#s=u,this.#r=o,this.#l=l(o),this.#d=E(o),this.#i=v}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(c){return this.#u=!0,(0,k.$Jxb)(c,this.#n)}get cspSource(){const c=this.#r.extensionLocation;if(c.scheme===P.Schemas.https||c.scheme===P.Schemas.http){let d=c.toString();return d.endsWith("/")||(d+="/"),d+" "+k.$Ixb}return k.$Ixb}get html(){return this.a(),this.#a}set html(c){this.a(),this.#a!==c&&(this.#a=c,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(c)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(c)))}get options(){return this.a(),this.#o}set options(c){this.a(),F.$On(this.#o,c)||this.#t.$setOptions(this.#e,a(this.#r,this.#s,c)),this.#o=c}async postMessage(c){if(this.#c)return!1;const d=(0,f.$inb)(c,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,d.message,...d.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(c){if(!this.#d)return c;const d=this.#r.extensionLocation?.scheme===P.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===P.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return c.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(p,u,o,v,b,$)=>{const I=R.URI.from({scheme:v||"file",path:decodeURIComponent(b)}),h=(0,k.$Jxb)(I,{isRemote:d,authority:t}).toString();return`${u}${h}${$}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(p,u,o,v,b,$)=>{const I=R.URI.from({scheme:v||"file",path:decodeURIComponent(b)}),h=(0,k.$Jxb)(I,{isRemote:d,authority:t}).toString();return`${u}${h}${$}`})}}e.$kic=D;function l(r){try{const c=(0,m.$qp)((0,m.$pp)(r.engines.vscode));return!!c&&c.majorBase>=1&&c.minorBase>=57}catch{return!1}}e.$lic=l;function E(r){try{const c=(0,m.$qp)((0,m.$pp)(r.engines.vscode));return c?c.majorBase<1||c.majorBase===1&&c.minorBase<60:!1}catch{return!1}}class g extends M.$Tc{constructor(c,d,t,p,u){super(),this.c=d,this.f=t,this.g=p,this.h=u,this.b=new Map,this.a=c.getProxy(O.$6L.MainThreadWebviews)}dispose(){super.dispose();for(const c of this.b.values())c.dispose();this.b.clear()}$onMessage(c,d,t){const p=this.j(c);if(p){const{message:u}=(0,f.$jnb)(d,t.value);p._onMessageEmitter.fire(u)}}$onMissingCsp(c,d){this.g.warn(`${d} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(c,d,t){const p=new D(c,this.a,i(d),this.c,this.f,t,this.h);this.b.set(c,p);const u=p._onDidDispose(()=>{u.dispose(),this.deleteWebview(c)});return p}deleteWebview(c){this.b.delete(c)}j(c){return this.b.get(c)}}e.$mic=g;function s(r){return{id:r.identifier,location:r.extensionLocation}}e.$nic=s;function a(r,c,d){return{enableCommandUris:d.enableCommandUris,enableScripts:d.enableScripts,enableForms:d.enableForms,portMapping:d.portMapping,localResourceRoots:d.localResourceRoots||n(r,c)}}e.$oic=a;function i(r){return{enableCommandUris:r.enableCommandUris,enableScripts:r.enableScripts,enableForms:r.enableForms,portMapping:r.portMapping,localResourceRoots:r.localResourceRoots?.map(c=>R.URI.from(c))}}function n(r,c){return[...(c?.getWorkspaceFolders()||[]).map(d=>d.uri),r.extensionLocation]}}),define(Pe[109],Re([1,0,5,4,2,12,15,3,17,22]),function(me,e,S,M,P,F,R,m,f,k){"use strict";var O;Object.defineProperty(e,"__esModule",{value:!0}),e.$Vjc=e.$Ujc=void 0;let D=class{static{O=this}static{this.a={focused:!0,active:!0}}getState(E){const g=this.d;return{get focused(){return g.focused},get active(){return(0,k.$YF)(E,"windowActivity"),g.active}}}constructor(E){this.c=new S.$5d,this.onDidChangeWindowState=this.c.event,this.d=O.a,this.b=E.getProxy(M.$6L.MainThreadWindow),this.b.$getInitialState().then(({isFocused:g,isActive:s})=>{this.onDidChangeWindowProperty("focused",g),this.onDidChangeWindowProperty("active",s)})}$onDidChangeWindowFocus(E){this.onDidChangeWindowProperty("focused",E)}$onDidChangeWindowActive(E){this.onDidChangeWindowProperty("active",E)}onDidChangeWindowProperty(E,g){g!==this.d[E]&&(this.d={...this.d,[E]:g},this.c.fire(this.d))}openUri(E,g){let s;if(typeof E=="string"){s=E;try{E=P.URI.parse(E)}catch{return Promise.reject(`Invalid uri - '${E}'`)}}return(0,R.$Se)(E.scheme)?Promise.reject("Invalid scheme - cannot be empty"):E.scheme===F.Schemas.command?Promise.reject(`Invalid scheme '${E.scheme}'`):this.b.$openUri(E,s,g)}async asExternalUri(E,g){if((0,R.$Se)(E.scheme))return Promise.reject("Invalid scheme - cannot be empty");const s=await this.b.$asExternalUri(E,g);return P.URI.from(s)}};e.$Ujc=D,e.$Ujc=D=O=Ye([He(0,f.$lO)],D),e.$Vjc=(0,m.$fi)("IExtHostWindow")}),define(Pe[238],Re([1,0,229,27,17]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7lc=void 0;let F=class extends S.$Yjc{constructor(m,f){super(m,f)}f(m,f,k){f.apply(console,k)}};e.$7lc=F,e.$7lc=F=Ye([He(0,P.$lO),He(1,M.$BO)],F)}),define(Pe[239],Re([1,0,11,23,25,14,5,6,142,226,49]),function(me,e,S,M,P,F,R,m,f,k,O){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$W9b=e.ResponsiveState=e.RequestInitiator=e.$V9b=e.$U9b=void 0;function l(w,A){try{return JSON.stringify(w,A)}catch{return"null"}}const E="$$ref$$",g={[E]:-1};class s{constructor(A,N){this.jsonString=A,this.referencedBuffers=N}}function a(w,A=null,N=!1){const G=[];return{jsonString:(N?l:JSON.stringify)(w,(U,C)=>{if(typeof C>"u")return g;if(typeof C=="object"){if(C instanceof M.$se){const L=G.push(C)-1;return{[E]:L}}if(A)return A(U,C)}return C}),referencedBuffers:G}}e.$U9b=a;function i(w,A,N){return JSON.parse(w,(G,V)=>{if(V){const U=V[E];if(typeof U=="number")return A[U];if(N&&V.$mid===1)return N.transformIncoming(V)}return V})}e.$V9b=i;function n(w,A){return JSON.stringify(w,A)}function r(w){return w?(A,N)=>N&&N.$mid===1?w.transformOutgoing(N):N:null}var c;(function(w){w[w.LocalSide=0]="LocalSide",w[w.OtherSide=1]="OtherSide"})(c||(e.RequestInitiator=c={}));var d;(function(w){w[w.Responsive=0]="Responsive",w[w.Unresponsive=1]="Unresponsive"})(d||(e.ResponsiveState=d={}));const t=()=>{},p=Symbol.for("rpcProtocol"),u=Symbol.for("rpcProxy");class o extends m.$Tc{static{D=p}static{this.a=3*1e3}constructor(A,N=null,G=null){super(),this[D]=!0,this.b=this.B(new R.$5d),this.onDidChangeResponsiveState=this.b.event,this.c=A,this.f=N,this.g=G,this.h=r(this.g),this.j=!1,this.m=[],this.s=[];for(let V=0,U=O.$6v.count;V<U;V++)this.m[V]=null,this.s[V]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new S.$rh(()=>this.H(),1e3)),this.c.onMessage(V=>this.L(V))}dispose(){this.j=!0,Object.keys(this.w).forEach(A=>{const N=this.w[A];delete this.w[A],N.resolveErr(F.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(A){this.z===0&&(this.C=Date.now()+o.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(A){this.C=Date.now()+o.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(A){this.y!==A&&(this.y=A,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(A){return this.g?(0,f.$jn)(A,this.g):A}getProxy(A){const{nid:N,sid:G}=A;return this.s[N]||(this.s[N]=this.J(N,G)),this.s[N]}J(A,N){const G={get:(V,U)=>(typeof U=="string"&&!V[U]&&U.charCodeAt(0)===36&&(V[U]=(...C)=>this.U(A,U,C)),U===u?N:V[U])};return new Proxy(Object.create(null),G)}set(A,N){return this.m[A.nid]=N,N}assertRegistered(A){for(let N=0,G=A.length;N<G;N++){const V=A[N];if(!this.m[V.nid])throw new Error(`Missing proxy instance ${V.sid}`)}}L(A){if(this.j)return;const N=A.byteLength,G=b.read(A,0),V=G.readUInt8(),U=G.readUInt32();switch(V){case 1:case 2:{let{rpcId:C,method:L,args:q}=I.deserializeRequestJSONArgs(G);this.g&&(q=(0,f.$jn)(q,this.g)),this.M(N,U,C,L,q,V===2);break}case 3:case 4:{let{rpcId:C,method:L,args:q}=I.deserializeRequestMixedArgs(G);this.g&&(q=(0,f.$jn)(q,this.g)),this.M(N,U,C,L,q,V===4);break}case 5:{this.f?.logIncoming(N,U,0,"ack"),this.G(U);break}case 6:{this.N(N,U);break}case 7:{this.O(N,U,void 0);break}case 9:{let C=I.deserializeReplyOKJSON(G);this.g&&(C=(0,f.$jn)(C,this.g)),this.O(N,U,C);break}case 10:{const C=I.deserializeReplyOKJSONWithBuffers(G,this.g);this.O(N,U,C);break}case 8:{const C=I.deserializeReplyOKVSBuffer(G);this.O(N,U,C);break}case 11:{let C=I.deserializeReplyErrError(G);this.g&&(C=(0,f.$jn)(C,this.g)),this.P(N,U,C);break}case 12:{this.P(N,U,void 0);break}default:console.error("received unexpected message"),console.error(A)}}M(A,N,G,V,U,C){this.f?.logIncoming(A,N,1,`receiveRequest ${(0,O.$8v)(G)}.${V}(`,U);const L=String(N);let q,ne;if(C){const ye=new P.$ce;U.push(ye.token),q=this.Q(G,V,U),ne=()=>ye.cancel()}else q=this.Q(G,V,U),ne=t;this.u[L]=ne;const ae=I.serializeAcknowledged(N);this.f?.logOutgoing(ae.byteLength,N,1,"ack"),this.c.send(ae),q.then(ye=>{delete this.u[L];const Ie=I.serializeReplyOK(N,ye,this.h);this.f?.logOutgoing(Ie.byteLength,N,1,"reply:",ye),this.c.send(Ie)},ye=>{delete this.u[L];const Ie=I.serializeReplyErr(N,ye);this.f?.logOutgoing(Ie.byteLength,N,1,"replyErr:",ye),this.c.send(Ie)})}N(A,N){this.f?.logIncoming(A,N,1,"receiveCancel");const G=String(N);this.u[G]?.()}O(A,N,G){this.f?.logIncoming(A,N,0,"receiveReply:",G);const V=String(N);if(!this.w.hasOwnProperty(V))return;const U=this.w[V];delete this.w[V],U.resolveOk(G)}P(A,N,G){this.f?.logIncoming(A,N,0,"receiveReplyErr:",G);const V=String(N);if(!this.w.hasOwnProperty(V))return;const U=this.w[V];delete this.w[V];let C;G&&(G.$isError?(C=new Error,C.name=G.name,C.message=G.message,C.stack=G.stack):C=G),U.resolveErr(C)}Q(A,N,G){try{return Promise.resolve(this.S(A,N,G))}catch(V){return Promise.reject(V)}}S(A,N,G){const V=this.m[A];if(!V)throw new Error("Unknown actor "+(0,O.$8v)(A));const U=V[N];if(typeof U!="function")throw new Error("Unknown method "+N+" on actor "+(0,O.$8v)(A));return U.apply(V,G)}U(A,N,G){if(this.j)return new k.$T9b;let V=null;if(G.length>0&&P.CancellationToken.isCancellationToken(G[G.length-1])&&(V=G.pop()),V&&V.isCancellationRequested)return Promise.reject(F.$6());const U=I.serializeRequestArguments(G,this.h),C=++this.t,L=String(C),q=new k.$S9b,ne=new m.$Sc;V&&ne.add(V.onCancellationRequested(()=>{const ye=I.serializeCancel(C);this.f?.logOutgoing(ye.byteLength,C,0,"cancel"),this.c.send(I.serializeCancel(C))})),this.w[L]=new v(q,ne),this.F(C);const ae=I.serializeRequest(C,A,N,U,!!V);return this.f?.logOutgoing(ae.byteLength,C,0,`request: ${(0,O.$8v)(A)}.${N}(`,G),this.c.send(ae),q}}e.$W9b=o;class v{constructor(A,N){this.a=A,this.b=N}resolveOk(A){this.a.resolveOk(A),this.b.dispose()}resolveErr(A){this.a.resolveErr(A),this.b.dispose()}}class b{static alloc(A,N,G){const V=new b(M.$se.alloc(G+1+4),0);return V.writeUInt8(A),V.writeUInt32(N),V}static read(A,N){return new b(A,N)}get buffer(){return this.a}constructor(A,N){this.a=A,this.b=N}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(A){this.a.writeUInt8(A,this.b),this.b+=1}readUInt8(){const A=this.a.readUInt8(this.b);return this.b+=1,A}writeUInt32(A){this.a.writeUInt32BE(A,this.b),this.b+=4}readUInt32(){const A=this.a.readUInt32BE(this.b);return this.b+=4,A}static sizeShortString(A){return 1+A.byteLength}writeShortString(A){this.a.writeUInt8(A.byteLength,this.b),this.b+=1,this.a.set(A,this.b),this.b+=A.byteLength}readShortString(){const A=this.a.readUInt8(this.b);this.b+=1;const G=this.a.slice(this.b,this.b+A).toString();return this.b+=A,G}static sizeLongString(A){return 4+A.byteLength}writeLongString(A){this.a.writeUInt32BE(A.byteLength,this.b),this.b+=4,this.a.set(A,this.b),this.b+=A.byteLength}readLongString(){const A=this.a.readUInt32BE(this.b);this.b+=4;const G=this.a.slice(this.b,this.b+A).toString();return this.b+=A,G}writeBuffer(A){this.a.writeUInt32BE(A.byteLength,this.b),this.b+=4,this.a.set(A,this.b),this.b+=A.byteLength}static sizeVSBuffer(A){return 4+A.byteLength}writeVSBuffer(A){this.a.writeUInt32BE(A.byteLength,this.b),this.b+=4,this.a.set(A,this.b),this.b+=A.byteLength}readVSBuffer(){const A=this.a.readUInt32BE(this.b);this.b+=4;const N=this.a.slice(this.b,this.b+A);return this.b+=A,N}static sizeMixedArray(A){let N=0;N+=1;for(let G=0,V=A.length;G<V;G++){const U=A[G];switch(N+=1,U.type){case 1:N+=this.sizeLongString(U.value);break;case 2:N+=this.sizeVSBuffer(U.value);break;case 3:N+=this.sizeUInt32,N+=this.sizeLongString(U.value);for(let C=0;C<U.buffers.length;++C)N+=this.sizeVSBuffer(U.buffers[C]);break;case 4:break}}return N}writeMixedArray(A){this.a.writeUInt8(A.length,this.b),this.b+=1;for(let N=0,G=A.length;N<G;N++){const V=A[N];switch(V.type){case 1:this.writeUInt8(1),this.writeLongString(V.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(V.value);break;case 3:this.writeUInt8(3),this.writeUInt32(V.buffers.length),this.writeLongString(V.value);for(let U=0;U<V.buffers.length;++U)this.writeBuffer(V.buffers[U]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const A=this.a.readUInt8(this.b);this.b+=1;const N=new Array(A);for(let G=0;G<A;G++)switch(this.readUInt8()){case 1:N[G]=this.readLongString();break;case 2:N[G]=this.readVSBuffer();break;case 3:{const U=this.readUInt32(),C=this.readLongString(),L=[];for(let q=0;q<U;++q)L.push(this.readVSBuffer());N[G]=new O.$9v(i(C,L,null));break}case 4:N[G]=void 0;break}return N}}var $;(function(w){w[w.Simple=0]="Simple",w[w.Mixed=1]="Mixed"})($||($={}));class I{static a(A){for(let N=0,G=A.length;N<G;N++)if(A[N]instanceof M.$se||A[N]instanceof O.$9v||typeof A[N]>"u")return!0;return!1}static serializeRequestArguments(A,N){if(this.a(A)){const G=[];for(let V=0,U=A.length;V<U;V++){const C=A[V];if(C instanceof M.$se)G[V]={type:2,value:C};else if(typeof C>"u")G[V]={type:4};else if(C instanceof O.$9v){const{jsonString:L,referencedBuffers:q}=a(C.value,N);G[V]={type:3,value:M.$se.fromString(L),buffers:q}}else G[V]={type:1,value:M.$se.fromString(n(C,N))}}return{type:1,args:G}}return{type:0,args:n(A,N)}}static serializeRequest(A,N,G,V,U){switch(V.type){case 0:return this.b(A,N,G,V.args,U);case 1:return this.c(A,N,G,V.args,U)}}static b(A,N,G,V,U){const C=M.$se.fromString(G),L=M.$se.fromString(V);let q=0;q+=b.sizeUInt8(),q+=b.sizeShortString(C),q+=b.sizeLongString(L);const ne=b.alloc(U?2:1,A,q);return ne.writeUInt8(N),ne.writeShortString(C),ne.writeLongString(L),ne.buffer}static deserializeRequestJSONArgs(A){const N=A.readUInt8(),G=A.readShortString(),V=A.readLongString();return{rpcId:N,method:G,args:JSON.parse(V)}}static c(A,N,G,V,U){const C=M.$se.fromString(G);let L=0;L+=b.sizeUInt8(),L+=b.sizeShortString(C),L+=b.sizeMixedArray(V);const q=b.alloc(U?4:3,A,L);return q.writeUInt8(N),q.writeShortString(C),q.writeMixedArray(V),q.buffer}static deserializeRequestMixedArgs(A){const N=A.readUInt8(),G=A.readShortString(),V=A.readMixedArray(),U=new Array(V.length);for(let C=0,L=V.length;C<L;C++){const q=V[C];typeof q=="string"?U[C]=JSON.parse(q):U[C]=q}return{rpcId:N,method:G,args:U}}static serializeAcknowledged(A){return b.alloc(5,A,0).buffer}static serializeCancel(A){return b.alloc(6,A,0).buffer}static serializeReplyOK(A,N,G){if(typeof N>"u")return this.d(A);if(N instanceof M.$se)return this.e(A,N);if(N instanceof O.$9v){const{jsonString:V,referencedBuffers:U}=a(N.value,G,!0);return this.g(A,V,U)}else return this.f(A,l(N,G))}static d(A){return b.alloc(7,A,0).buffer}static e(A,N){let G=0;G+=b.sizeVSBuffer(N);const V=b.alloc(8,A,G);return V.writeVSBuffer(N),V.buffer}static deserializeReplyOKVSBuffer(A){return A.readVSBuffer()}static f(A,N){const G=M.$se.fromString(N);let V=0;V+=b.sizeLongString(G);const U=b.alloc(9,A,V);return U.writeLongString(G),U.buffer}static g(A,N,G){const V=M.$se.fromString(N);let U=0;U+=b.sizeUInt32,U+=b.sizeLongString(V);for(const L of G)U+=b.sizeVSBuffer(L);const C=b.alloc(10,A,U);C.writeUInt32(G.length),C.writeLongString(V);for(const L of G)C.writeBuffer(L);return C.buffer}static deserializeReplyOKJSON(A){const N=A.readLongString();return JSON.parse(N)}static deserializeReplyOKJSONWithBuffers(A,N){const G=A.readUInt32(),V=A.readLongString(),U=[];for(let C=0;C<G;++C)U.push(A.readVSBuffer());return new O.$9v(i(V,U,N))}static serializeReplyErr(A,N){const G=N?l(F.$3(N),null):void 0;if(typeof G!="string")return this.h(A);const V=M.$se.fromString(G);let U=0;U+=b.sizeLongString(V);const C=b.alloc(11,A,U);return C.writeLongString(V),C.buffer}static deserializeReplyErrError(A){const N=A.readLongString();return JSON.parse(N)}static h(A){return b.alloc(12,A,0).buffer}}var h;(function(w){w[w.RequestJSONArgs=1]="RequestJSONArgs",w[w.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",w[w.RequestMixedArgs=3]="RequestMixedArgs",w[w.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",w[w.Acknowledged=5]="Acknowledged",w[w.Cancel=6]="Cancel",w[w.ReplyOKEmpty=7]="ReplyOKEmpty",w[w.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",w[w.ReplyOKJSON=9]="ReplyOKJSON",w[w.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",w[w.ReplyErrError=11]="ReplyErrError",w[w.ReplyErrEmpty=12]="ReplyErrEmpty"})(h||(h={}));var y;(function(w){w[w.String=1]="String",w[w.VSBuffer=2]="VSBuffer",w[w.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",w[w.Undefined=4]="Undefined"})(y||(y={}))}),define(Pe[240],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9lc=void 0;const S=function(F){const R=m=>{globalThis.removeEventListener("message",R);const f=m.data;Object.defineProperties(globalThis,{postMessage:{value(k,O){f.postMessage(k,O)}},onmessage:{get(){return f.onmessage},set(k){f.onmessage=k}}}),f.addEventListener("message",k=>{globalThis.dispatchEvent(new MessageEvent("message",{data:k.data,ports:k.ports?[...k.ports]:void 0}))}),f.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(F)};globalThis.addEventListener("message",R)}.toString();class M extends EventTarget{constructor(F,R,m){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const f=`((${S})('${R}'))`,k=new Blob([f],{type:"application/javascript"}),O=URL.createObjectURL(k),D=new MessageChannel,l=O,E={type:"_newWorker",id:l,port:D.port2,url:O,options:m};F(E,[D.port2]),this.postMessage=D.port1.postMessage.bind(D.port1),this.terminate=()=>{F({type:"_terminateWorker",id:l}),URL.revokeObjectURL(O),D.port1.close(),D.port2.close()},Object.defineProperties(this,{onmessage:{get(){return D.port1.onmessage},set(g){D.port1.onmessage=g}},onmessageerror:{get(){return D.port1.onmessageerror},set(g){D.port1.onmessageerror=g}}}),D.port1.addEventListener("messageerror",g=>{const s=new MessageEvent("messageerror",{data:g.data});this.dispatchEvent(s)}),D.port1.addEventListener("message",g=>{const s=new MessageEvent("message",{data:g.data});this.dispatchEvent(s)}),D.port1.start()}}e.$9lc=M}),define(Pe[241],Re([1,0,23,28,12,54,3]),function(me,e,S,M,P,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PJ=e.$OJ=e.$NJ=e.$MJ=void 0,e.$MJ=(0,R.$fi)("notebookDocumentService");const m=["W","X","Y","Z","a","b","c","d","e","f"],f=new RegExp(`^[${m.join("")}]+`),k=7;function O(E){if(E.scheme!==P.Schemas.vscodeNotebookCell)return;const g=E.fragment.indexOf("s");if(g<0)return;const s=parseInt(E.fragment.substring(0,g).replace(f,""),k),a=(0,S.$Le)(E.fragment.substring(g+1)).toString();if(!isNaN(s))return{handle:s,notebook:E.with({scheme:a,fragment:null})}}e.$NJ=O;function D(E,g){const s=g.toString(k),i=`${s.length<m.length?m[s.length-1]:"z"}${s}s${(0,S.$Me)(S.$se.fromString(E.scheme),!0,!0)}`;return E.with({scheme:P.Schemas.vscodeNotebookCell,fragment:i})}e.$OJ=D;class l{constructor(){this.a=new M.$Ac}getNotebook(g){if(g.scheme===P.Schemas.vscodeNotebookCell){const s=O(g);if(s){const a=this.a.get(s.notebook);if(a)return a}}return this.a.get(g)}addNotebookDocument(g){this.a.set(g.uri,g)}removeNotebookDocument(g){this.a.delete(g.uri)}}e.$PJ=l,(0,F.$as)(e.$MJ,l,1)}),define(Pe[83],Re([1,0,23,34,51,69,12,19,21,35,241]),function(me,e,S,M,P,F,R,m,f,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8J=e.$7J=e.$6J=e.$5J=e.CellStatusbarAlignment=e.$4J=e.$3J=e.$2J=e.NotebookEditorPriority=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.CellKind=e.$SJ=e.$RJ=e.$QJ=void 0,e.$QJ="workbench.editor.notebook",e.$RJ="workbench.editor.notebookTextDiffEditor",e.$SJ="workbench.editor.interactive";var D;(function(q){q[q.Markup=1]="Markup",q[q.Code=2]="Code"})(D||(e.CellKind=D={})),e.$TJ=["application/json","application/javascript","text/html","image/svg+xml",F.$ts.latex,F.$ts.markdown,"image/png","image/jpeg",F.$ts.text],e.$UJ=[F.$ts.latex,F.$ts.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",F.$ts.text],e.$VJ=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$WJ="_notAvailable";var l;(function(q){q[q.Running=1]="Running",q[q.Idle=2]="Idle"})(l||(e.NotebookRunState=l={}));var E;(function(q){q[q.Unconfirmed=1]="Unconfirmed",q[q.Pending=2]="Pending",q[q.Executing=3]="Executing"})(E||(e.NotebookCellExecutionState=E={}));var g;(function(q){q[q.Unconfirmed=1]="Unconfirmed",q[q.Pending=2]="Pending",q[q.Executing=3]="Executing"})(g||(e.NotebookExecutionState=g={}));var s;(function(q){q[q.WithHardKernelDependency=0]="WithHardKernelDependency",q[q.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",q[q.Pure=2]="Pure",q[q.Never=3]="Never"})(s||(e.NotebookRendererMatch=s={}));var a;(function(q){q.Always="always",q.Never="never",q.Optional="optional"})(a||(e.RendererMessagingSpec=a={}));var i;(function(q){q[q.ModelChange=1]="ModelChange",q[q.Move=2]="Move",q[q.ChangeCellLanguage=5]="ChangeCellLanguage",q[q.Initialize=6]="Initialize",q[q.ChangeCellMetadata=7]="ChangeCellMetadata",q[q.Output=8]="Output",q[q.OutputItem=9]="OutputItem",q[q.ChangeCellContent=10]="ChangeCellContent",q[q.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",q[q.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",q[q.ChangeCellMime=13]="ChangeCellMime",q[q.Unknown=100]="Unknown"})(i||(e.NotebookCellsChangeType=i={}));var n;(function(q){q[q.Handle=0]="Handle",q[q.Index=1]="Index"})(n||(e.SelectionStateType=n={}));var r;(function(q){q[q.Replace=1]="Replace",q[q.Output=2]="Output",q[q.Metadata=3]="Metadata",q[q.CellLanguage=4]="CellLanguage",q[q.DocumentMetadata=5]="DocumentMetadata",q[q.Move=6]="Move",q[q.OutputItems=7]="OutputItems",q[q.PartialMetadata=8]="PartialMetadata",q[q.PartialInternalMetadata=9]="PartialInternalMetadata"})(r||(e.CellEditType=r={}));var c;(function(q){q.scheme=R.Schemas.vscodeNotebookCell;function ne(re,$e){return(0,O.$OJ)(re,$e)}q.generate=ne;function ae(re){return(0,O.$NJ)(re)}q.parse=ae;function ye(re,$e){return re.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${$e??""},${re.scheme!==R.Schemas.file?re.scheme:""}`})}q.generateCellOutputUri=ye;function Ie(re){if(re.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const $e=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(re.fragment);if(!$e)return;const ie=$e[1]&&$e[1]!==""?$e[1]:void 0,le=$e[2];return{outputId:ie,notebook:re.with({scheme:le||R.Schemas.file,fragment:null})}}q.parseCellOutputUri=Ie;function ue(re,$e,ie){return q.generate(re,$e).with({scheme:ie})}q.generateCellPropertyUri=ue;function ve(re,$e){if(re.scheme===$e)return q.parse(re.with({scheme:q.scheme}))}q.parseCellPropertyUri=ve})(c||(e.CellUri=c={}));const d=q=>f.$i?q.replace(/\//g,"\\"):q;class t{constructor(ne=[],ae=e.$TJ){this.e=ae,this.d=[...new Set(ne)].map(ye=>({pattern:ye,matches:M.$Yj(d(ye))}))}sort(ne){const ae=new Map(P.Iterable.map(ne,Ie=>[Ie,d(Ie)]));let ye=[];for(const{matches:Ie}of this.d)for(const[ue,ve]of ae)if(Ie(ve)){ye.push(ue),ae.delete(ue);break}return ae.size&&(ye=ye.concat([...ae.keys()].sort((Ie,ue)=>this.e.indexOf(Ie)-this.e.indexOf(ue)))),ye}prioritize(ne,ae){const ye=this.f(ne);if(ye===-1){this.d.unshift({pattern:ne,matches:M.$Yj(d(ne))});return}const Ie=new Set(ae.map(ve=>this.f(ve,ye)));Ie.delete(-1);const ue=Array.from(Ie).sort();this.d.splice(ye+1,0,...ue.map(ve=>this.d[ve]));for(let ve=ue.length-1;ve>=0;ve--)this.d.splice(ue[ve],1)}toArray(){return this.d.map(ne=>ne.pattern)}f(ne,ae=this.d.length){const ye=d(ne);for(let Ie=0;Ie<ae;Ie++)if(this.d[Ie].matches(ye))return Ie;return-1}}e.$XJ=t;function p(q,ne,ae,ye=(Ie,ue)=>Ie===ue){const Ie=[];function ue($e,ie,le){if(ie===0&&le.length===0)return;const W=Ie[Ie.length-1];W&&W.start+W.deleteCount===$e?(W.deleteCount+=ie,W.toInsert.push(...le)):Ie.push({start:$e,deleteCount:ie,toInsert:le})}let ve=0,re=0;for(;;){if(ve===q.length){ue(ve,0,ne.slice(re));break}if(re===ne.length){ue(ve,q.length-ve,[]);break}const $e=q[ve],ie=ne[re];if(ye($e,ie)){ve+=1,re+=1;continue}ae(ie)?(ue(ve,1,[]),ve+=1):(ue(ve,0,[ie]),re+=1)}return Ie}e.$YJ=p,e.$ZJ=new k.$wj("notebookEditorCursorAtBoundary","none"),e.$1J=new k.$wj("notebookEditorCursorAtLineBoundary","none");var u;(function(q){q.default="default",q.option="option"})(u||(e.NotebookEditorPriority=u={}));function o(q){const ne=q;return!!((typeof ne.include=="string"||M.$Zj(ne.include))&&(typeof ne.exclude=="string"||M.$Zj(ne.exclude)))}e.$2J=o;function v(q,ne,ae){if(Array.isArray(q.viewType)&&q.viewType.indexOf(ne)>=0||q.viewType===ne)return!0;if(q.filenamePattern){const ye=o(q.filenamePattern)?q.filenamePattern.include:q.filenamePattern,Ie=o(q.filenamePattern)?q.filenamePattern.exclude:void 0;if(M.$Xj(ye,(0,m.$nc)(ae.fsPath).toLowerCase()))return!(Ie&&M.$Xj(Ie,(0,m.$nc)(ae.fsPath).toLowerCase()))}return!1}e.$3J=v,e.$4J={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView"};var b;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(b||(e.CellStatusbarAlignment=b={}));class ${static{this.d="notebook/"}static create(ne){return`${$.d}${ne}`}static parse(ne){if(ne.startsWith($.d))return ne.substring($.d.length)}}e.$5J=$;function I(q){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(q)}e.$6J=I;const h=new TextDecoder;function y(q){const ne=[];let ae=!1;for(const ve of q)(ne.length===0||ae)&&(ne.push(ve),ae=!0);let ye=N(ne);const Ie=S.$se.concat(ne.map(ve=>S.$se.wrap(ve))),ue=L(Ie);return ye=ye||ue.byteLength!==Ie.byteLength,{data:ue,didCompression:ye}}e.$7J=y,e.$8J="\x1B[A";const w=e.$8J.split("").map(q=>q.charCodeAt(0)),A=10;function N(q){let ne=!1;return q.forEach((ae,ye)=>{if(ye===0||ae.length<e.$8J.length)return;const Ie=q[ye-1],ue=ae.subarray(0,e.$8J.length);if(ue[0]===w[0]&&ue[1]===w[1]&&ue[2]===w[2]){const ve=Ie.lastIndexOf(A);if(ve===-1)return;ne=!0,q[ye-1]=Ie.subarray(0,ve),q[ye]=ae.subarray(e.$8J.length)}}),ne}function G(q){let ne=q;do q=ne,ne=q.replace(/[^\n]\x08/gm,"");while(ne.length<q.length);return q}function V(q){for(q=q.replace(/\r+\n/gm,`
`);q.search(/\r[^$]/g)>-1;){const ne=q.match(/^(.*)\r+/m)[1];let ae=q.match(/\r+(.*)$/m)[1];ae=ae+ne.slice(ae.length,ne.length),q=q.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ae)}return q}const U=8,C=13;function L(q){return!q.buffer.includes(U)&&!q.buffer.includes(C)?q:S.$se.fromString(V(G(h.decode(q.buffer))))}}),define(Pe[7],Re([1,0,18,14,53,28,69,15,16,2,33,20,42,102,83]),function(me,e,S,M,P,F,R,m,f,k,O,D,l,E,g){"use strict";var s,a,i,n,r,c,d,t,p,u,o,v,b,$,I,h,y;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$aO=e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$_N=e.$$N=e.$0N=e.$9N=e.$8N=e.$7N=e.$6N=e.$5N=e.$4N=e.$3N=e.$2N=e.$1N=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$ZN=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$YN=e.$XN=e.$WN=e.$VN=e.$UN=e.$TN=e.$SN=e.$RN=e.$QN=e.$PN=e.$ON=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$NN=e.$MN=e.$LN=e.$KN=e.$JN=e.$IN=e.$HN=e.$GN=e.TestRunProfileKind=e.TestResultState=e.$FN=e.$EN=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$DN=e.NotebookVariablesRequestKind=e.$CN=e.$BN=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$AN=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$zN=e.$yN=e.$xN=e.$wN=e.$vN=e.ColorThemeKind=e.$uN=e.$tN=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$sN=e.$rN=e.DebugConsoleMode=e.$qN=e.$pN=e.$oN=e.$nN=e.$mN=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$lN=e.$kN=e.FileChangeType=e.$jN=e.NewSymbolNameTag=e.$iN=e.$hN=e.$gN=e.$fN=e.InlineCompletionTriggerKind=e.$eN=e.$dN=e.$cN=e.$bN=e.$aN=e.$_M=e.$$M=e.$0M=e.$9M=e.$8M=e.$7M=e.$6M=e.$5M=e.ConfigurationTarget=e.$4M=e.$3M=e.$2M=e.$1M=e.$ZM=e.$YM=e.$XM=e.$WM=e.$VM=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$UM=e.ViewBadge=e.ProgressLocation=e.$TM=e.$SM=e.TaskScope=e.ShellQuoting=e.$RM=e.$QM=e.$PM=e.TaskPanelKind=e.TaskRevealKind=e.$OM=e.TerminalLocation=e.$NM=e.$MM=e.$LM=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$KM=e.$JM=e.$IM=e.$HM=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$GM=e.StatusBarAlignment=e.ViewColumn=e.$FM=e.$EM=e.$DM=e.$CM=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$BM=e.$AM=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$zM=e.$yM=e.$xM=e.$wM=e.$vM=e.LanguageStatusSeverity=e.$uM=e.$tM=e.$sM=e.$rM=e.$qM=e.$pM=e.CodeActionTriggerKind=e.$oM=e.$nM=e.SymbolTag=e.SymbolKind=e.$mM=e.$lM=e.DocumentHighlightKind=e.$kM=e.$jM=e.$iM=e.$hM=e.DiagnosticSeverity=e.DiagnosticTag=e.$gM=e.$fM=e.FileEditType=e.$eM=e.$dM=e.$cM=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$bM=e.$aM=e.$_L=e.$$L=e.$0L=e.$9L=e.$8L=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function w(B){return Object.assign(B,{apply:function(...te){if(te.length===0)return Reflect.construct(B,[]);{const Se=te.length===1?[]:te[1];return Reflect.construct(B,Se,te[0].constructor)}},call:function(...te){if(te.length===0)return Reflect.construct(B,[]);{const[Se,...Ge]=te;return Reflect.construct(B,Ge,Se.constructor)}}})}var A;(function(B){B[B.Top=0]="Top",B[B.Bottom=1]="Bottom"})(A||(e.TerminalOutputAnchor=A={}));var N;(function(B){B[B.TerminalCommand=0]="TerminalCommand",B[B.Opener=1]="Opener",B[B.Command=3]="Command"})(N||(e.TerminalQuickFixType=N={}));let G=s=class{static from(...T){let te=T;return new s(function(){if(te){for(const Se of te)Se&&typeof Se.dispose=="function"&&Se.dispose();te=void 0}})}#e;constructor(T){this.#e=T}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$8L=G,e.$8L=G=s=Ye([w],G);let V=a=class{static Min(...T){if(T.length===0)throw new TypeError;let te=T[0];for(let Se=1;Se<T.length;Se++){const Ge=T[Se];Ge.isBefore(te)&&(te=Ge)}return te}static Max(...T){if(T.length===0)throw new TypeError;let te=T[0];for(let Se=1;Se<T.length;Se++){const Ge=T[Se];Ge.isAfter(te)&&(te=Ge)}return te}static isPosition(T){if(!T)return!1;if(T instanceof a)return!0;const{line:te,character:Se}=T;return typeof te=="number"&&typeof Se=="number"}static of(T){if(T instanceof a)return T;if(this.isPosition(T))return new a(T.line,T.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(T,te){if(T<0)throw(0,M.$7)("line must be non-negative");if(te<0)throw(0,M.$7)("character must be non-negative");this.c=T,this.e=te}isBefore(T){return this.c<T.c?!0:T.c<this.c?!1:this.e<T.e}isBeforeOrEqual(T){return this.c<T.c?!0:T.c<this.c?!1:this.e<=T.e}isAfter(T){return!this.isBeforeOrEqual(T)}isAfterOrEqual(T){return!this.isBefore(T)}isEqual(T){return this.c===T.c&&this.e===T.e}compareTo(T){return this.c<T.c?-1:this.c>T.line?1:this.e<T.e?-1:this.e>T.e?1:0}translate(T,te=0){if(T===null||te===null)throw(0,M.$7)();let Se;return typeof T>"u"?Se=0:typeof T=="number"?Se=T:(Se=typeof T.lineDelta=="number"?T.lineDelta:0,te=typeof T.characterDelta=="number"?T.characterDelta:0),Se===0&&te===0?this:new a(this.line+Se,this.character+te)}with(T,te=this.character){if(T===null||te===null)throw(0,M.$7)();let Se;return typeof T>"u"?Se=this.line:typeof T=="number"?Se=T:(Se=typeof T.line=="number"?T.line:this.line,te=typeof T.character=="number"?T.character:this.character),Se===this.line&&te===this.character?this:new a(Se,te)}toJSON(){return{line:this.line,character:this.character}}};e.$9L=V,e.$9L=V=a=Ye([w],V);let U=i=class{static isRange(T){return T instanceof i?!0:T?V.isPosition(T.start)&&V.isPosition(T.end):!1}static of(T){if(T instanceof i)return T;if(this.isRange(T))return new i(T.start,T.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(T,te,Se,Ge){let _e,ut;if(typeof T=="number"&&typeof te=="number"&&typeof Se=="number"&&typeof Ge=="number"?(_e=new V(T,te),ut=new V(Se,Ge)):V.isPosition(T)&&V.isPosition(te)&&(_e=V.of(T),ut=V.of(te)),!_e||!ut)throw new Error("Invalid arguments");_e.isBefore(ut)?(this.c=_e,this.e=ut):(this.c=ut,this.e=_e)}contains(T){return i.isRange(T)?this.contains(T.start)&&this.contains(T.end):V.isPosition(T)?!(V.of(T).isBefore(this.c)||this.e.isBefore(T)):!1}isEqual(T){return this.c.isEqual(T.c)&&this.e.isEqual(T.e)}intersection(T){const te=V.Max(T.start,this.c),Se=V.Min(T.end,this.e);if(!te.isAfter(Se))return new i(te,Se)}union(T){if(this.contains(T))return this;if(T.contains(this))return T;const te=V.Min(T.start,this.c),Se=V.Max(T.end,this.end);return new i(te,Se)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(T,te=this.end){if(T===null||te===null)throw(0,M.$7)();let Se;return T?V.isPosition(T)?Se=T:(Se=T.start||this.start,te=T.end||this.end):Se=this.start,Se.isEqual(this.c)&&te.isEqual(this.end)?this:new i(Se,te)}toJSON(){return[this.start,this.end]}};e.$0L=U,e.$0L=U=i=Ye([w],U);let C=n=class extends U{static isSelection(T){return T instanceof n?!0:T?U.isRange(T)&&V.isPosition(T.anchor)&&V.isPosition(T.active)&&typeof T.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(T,te,Se,Ge){let _e,ut;if(typeof T=="number"&&typeof te=="number"&&typeof Se=="number"&&typeof Ge=="number"?(_e=new V(T,te),ut=new V(Se,Ge)):V.isPosition(T)&&V.isPosition(te)&&(_e=V.of(T),ut=V.of(te)),!_e||!ut)throw new Error("Invalid arguments");super(_e,ut),this.f=_e,this.g=ut}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$$L=C,e.$$L=C=n=Ye([w],C);const L=B=>{if(typeof B!="string"||B.length===0||!/^[0-9A-Za-z_\-]+$/.test(B))throw(0,M.$7)("connectionToken")};class q{static isResolvedAuthority(T){return T&&typeof T=="object"&&typeof T.host=="string"&&typeof T.port=="number"&&(T.connectionToken===void 0||typeof T.connectionToken=="string")}constructor(T,te,Se){if(typeof T!="string"||T.length===0)throw(0,M.$7)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,M.$7)("port");typeof Se<"u"&&L(Se),this.host=T,this.port=Math.round(te),this.connectionToken=Se}}e.$_L=q;class ne{static isManagedResolvedAuthority(T){return T&&typeof T=="object"&&typeof T.makeConnection=="function"&&(T.connectionToken===void 0||typeof T.connectionToken=="string")}constructor(T,te){this.makeConnection=T,this.connectionToken=te,typeof te<"u"&&L(te)}}e.$aM=ne;class ae extends Error{static NotAvailable(T,te){return new ae(T,E.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(T){return new ae(T,E.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(T,te=E.RemoteAuthorityResolverErrorCode.Unknown,Se){super(T),this._message=T,this._code=te,this._detail=Se,Object.setPrototypeOf(this,ae.prototype)}}e.$bM=ae;var ye;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(ye||(e.EndOfLine=ye={}));var Ie;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(Ie||(e.EnvironmentVariableMutatorType=Ie={}));let ue=r=class{static isTextEdit(T){return T instanceof r?!0:T?U.isRange(T)&&typeof T.newText=="string":!1}static replace(T,te){return new r(T,te)}static insert(T,te){return r.replace(new U(T,T),te)}static delete(T){return r.replace(T,"")}static setEndOfLine(T){const te=new r(new U(new V(0,0),new V(0,0)),"");return te.newEol=T,te}get range(){return this.c}set range(T){if(T&&!U.isRange(T))throw(0,M.$7)("range");this.c=T}get newText(){return this.e||""}set newText(T){if(T&&typeof T!="string")throw(0,M.$7)("newText");this.e=T}get newEol(){return this.f}set newEol(T){if(T&&typeof T!="number")throw(0,M.$7)("newEol");this.f=T}constructor(T,te){this.c=T,this.e=te}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$cM=ue,e.$cM=ue=r=Ye([w],ue);let ve=c=class{static isNotebookCellEdit(T){return T instanceof c?!0:T?di.isNotebookRange(T)&&Array.isArray(T.newCells):!1}static replaceCells(T,te){return new c(T,te)}static insertCells(T,te){return new c(new di(T,T),te)}static deleteCells(T){return new c(T,[])}static updateCellMetadata(T,te){const Se=new c(new di(T,T),[]);return Se.newCellMetadata=te,Se}static updateNotebookMetadata(T){const te=new c(new di(0,0),[]);return te.newNotebookMetadata=T,te}constructor(T,te){this.range=T,this.newCells=te}};e.$dM=ve,e.$dM=ve=c=Ye([w],ve);class re{static isSnippetTextEdit(T){return T instanceof re?!0:T?U.isRange(T.range)&&le.isSnippetString(T.snippet):!1}static replace(T,te){return new re(T,te)}static insert(T,te){return re.replace(new U(T,T),te)}constructor(T,te){this.range=T,this.snippet=te}}e.$eM=re;var $e;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace",B[B.Snippet=6]="Snippet"})($e||(e.FileEditType=$e={}));let ie=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(T,te,Se,Ge){this.c.push({_type:1,from:T,to:te,options:Se,metadata:Ge})}createFile(T,te,Se){this.c.push({_type:1,from:void 0,to:T,options:te,metadata:Se})}deleteFile(T,te,Se){this.c.push({_type:1,from:T,to:void 0,options:te,metadata:Se})}e(T,te,Se){this.c.push({_type:3,metadata:Se,uri:T,edit:{editType:5,metadata:te},notebookMetadata:te})}f(T,te,Se,Ge){const _e=te.start,ut=te.end;(_e!==ut||Se.length>0)&&this.c.push({_type:5,uri:T,index:_e,count:ut-_e,cells:Se,metadata:Ge})}g(T,te,Se,Ge){this.c.push({_type:3,metadata:Ge,uri:T,edit:{editType:3,index:te,metadata:Se}})}replace(T,te,Se,Ge){this.c.push({_type:2,uri:T,edit:new ue(te,Se),metadata:Ge})}insert(T,te,Se,Ge){this.replace(T,new U(te,te),Se,Ge)}delete(T,te,Se){this.replace(T,te,"",Se)}has(T){return this.c.some(te=>te._type===2&&te.uri.toString()===T.toString())}set(T,te){if(te)for(const Se of te){if(!Se)continue;let Ge,_e;Array.isArray(Se)?(Ge=Se[0],_e=Se[1]):Ge=Se,ve.isNotebookCellEdit(Ge)?Ge.newCellMetadata?this.g(T,Ge.range.start,Ge.newCellMetadata,_e):Ge.newNotebookMetadata?this.e(T,Ge.newNotebookMetadata,_e):this.f(T,Ge.range,Ge.newCells,_e):re.isSnippetTextEdit(Ge)?this.c.push({_type:6,uri:T,range:Ge.range,edit:Ge.snippet,metadata:_e}):this.c.push({_type:2,uri:T,edit:Ge,metadata:_e})}else{for(let Se=0;Se<this.c.length;Se++){const Ge=this.c[Se];switch(Ge._type){case 2:case 6:case 3:case 5:Ge.uri.toString()===T.toString()&&(this.c[Se]=void 0);break}}(0,S.$Ib)(this.c)}}get(T){const te=[];for(const Se of this.c)Se._type===2&&Se.uri.toString()===T.toString()&&te.push(Se.edit);return te}entries(){const T=new F.$Ac;for(const te of this.c)if(te._type===2){let Se=T.get(te.uri);Se||(Se=[te.uri,[]],T.set(te.uri,Se)),Se[1].push(te.edit)}return[...T.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$fM=ie,e.$fM=ie=Ye([w],ie);let le=d=class{static isSnippetString(T){return T instanceof d?!0:T?typeof T.value=="string":!1}static c(T){return T.replace(/\$|}|\\/g,"\\$&")}constructor(T){this.e=1,this.value=T||""}appendText(T){return this.value+=d.c(T),this}appendTabstop(T=this.e++){return this.value+="$",this.value+=T,this}appendPlaceholder(T,te=this.e++){if(typeof T=="function"){const Se=new d;Se.e=this.e,T(Se),this.e=Se.e,T=Se.value}else T=d.c(T);return this.value+="${",this.value+=te,this.value+=":",this.value+=T,this.value+="}",this}appendChoice(T,te=this.e++){const Se=T.map(Ge=>Ge.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(T,te){if(typeof te=="function"){const Se=new d;Se.e=this.e,te(Se),this.e=Se.e,te=Se.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=T,te&&(this.value+=":",this.value+=te),this.value+="}",this}};e.$gM=le,e.$gM=le=d=Ye([w],le);var W;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(W||(e.DiagnosticTag=W={}));var _;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(_||(e.DiagnosticSeverity=_={}));let ke=t=class{static isLocation(T){return T instanceof t?!0:T?U.isRange(T.range)&&k.URI.isUri(T.uri):!1}constructor(T,te){if(this.uri=T,te)if(U.isRange(te))this.range=U.of(te);else if(V.isPosition(te))this.range=new U(te,te);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$hM=ke,e.$hM=ke=t=Ye([w],ke);let Ne=class{static is(T){return T?typeof T.message=="string"&&T.location&&U.isRange(T.location.range)&&k.URI.isUri(T.location.uri):!1}constructor(T,te){this.location=T,this.message=te}static isEqual(T,te){return T===te?!0:!T||!te?!1:T.message===te.message&&T.location.range.isEqual(te.location.range)&&T.location.uri.toString()===te.location.uri.toString()}};e.$iM=Ne,e.$iM=Ne=Ye([w],Ne);let De=class{constructor(T,te,Se=_.Error){if(!U.isRange(T))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=T,this.message=te,this.severity=Se}toJSON(){return{severity:_[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(T,te){return T===te?!0:!T||!te?!1:T.message===te.message&&T.severity===te.severity&&T.code===te.code&&T.severity===te.severity&&T.source===te.source&&T.range.isEqual(te.range)&&(0,S.$ub)(T.tags,te.tags)&&(0,S.$ub)(T.relatedInformation,te.relatedInformation,Ne.isEqual)}};e.$jM=De,e.$jM=De=Ye([w],De);let be=class{constructor(T,te){if(!T)throw new Error("Illegal argument, contents must be defined");Array.isArray(T)?this.contents=T:this.contents=[T],this.range=te}};e.$kM=be,e.$kM=be=Ye([w],be);var ge;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(ge||(e.DocumentHighlightKind=ge={}));let J=class{constructor(T,te=ge.Text){this.range=T,this.kind=te}toJSON(){return{range:this.range,kind:ge[this.kind]}}};e.$lM=J,e.$lM=J=Ye([w],J);let X=class{constructor(T,te){this.uri=T,this.highlights=te}toJSON(){return{uri:this.uri,highlights:this.highlights.map(T=>T.toJSON())}}};e.$mM=X,e.$mM=X=Ye([w],X);var he;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(he||(e.SymbolKind=he={}));var fe;(function(B){B[B.Deprecated=1]="Deprecated"})(fe||(e.SymbolTag=fe={}));let Fe=p=class{static validate(T){if(!T.name)throw new Error("name must not be falsy")}constructor(T,te,Se,Ge,_e){this.name=T,this.kind=te,this.containerName=_e,typeof Se=="string"&&(this.containerName=Se),Ge instanceof ke?this.location=Ge:Se instanceof U&&(this.location=new ke(Ge,Se)),p.validate(this)}toJSON(){return{name:this.name,kind:he[this.kind],location:this.location,containerName:this.containerName}}};e.$nM=Fe,e.$nM=Fe=p=Ye([w],Fe);let de=u=class{static validate(T){if(!T.name)throw new Error("name must not be falsy");if(!T.range.contains(T.selectionRange))throw new Error("selectionRange must be contained in fullRange");T.children?.forEach(u.validate)}constructor(T,te,Se,Ge,_e){this.name=T,this.detail=te,this.kind=Se,this.range=Ge,this.selectionRange=_e,this.children=[],u.validate(this)}};e.$oM=de,e.$oM=de=u=Ye([w],de);var Ce;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(Ce||(e.CodeActionTriggerKind=Ce={}));let Ae=class{constructor(T,te){this.title=T,this.kind=te}};e.$pM=Ae,e.$pM=Ae=Ye([w],Ae);let je=class{static{o=this}static{this.c="."}constructor(T){this.value=T}append(T){return new o(this.value?this.value+o.c+T:T)}intersects(T){return this.contains(T)||T.contains(this)}contains(T){return this.value===T.value||T.value.startsWith(this.value+o.c)}};e.$qM=je,e.$qM=je=o=Ye([w],je),je.Empty=new je(""),je.QuickFix=je.Empty.append("quickfix"),je.Refactor=je.Empty.append("refactor"),je.RefactorExtract=je.Refactor.append("extract"),je.RefactorInline=je.Refactor.append("inline"),je.RefactorMove=je.Refactor.append("move"),je.RefactorRewrite=je.Refactor.append("rewrite"),je.Source=je.Empty.append("source"),je.SourceOrganizeImports=je.Source.append("organizeImports"),je.SourceFixAll=je.Source.append("fixAll"),je.Notebook=je.Empty.append("notebook");let z=class{constructor(T,te){if(this.range=T,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$rM=z,e.$rM=z=Ye([w],z);class j{constructor(T,te,Se,Ge,_e,ut){this.kind=T,this.name=te,this.detail=Se,this.uri=Ge,this.range=_e,this.selectionRange=ut}}e.$sM=j;class K{constructor(T,te){this.fromRanges=te,this.from=T}}e.$tM=K;class H{constructor(T,te){this.fromRanges=te,this.to=T}}e.$uM=H;var ee;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(ee||(e.LanguageStatusSeverity=ee={}));let se=class{constructor(T,te){this.range=T,this.command=te}get isResolved(){return!!this.command}};e.$vM=se,e.$vM=se=Ye([w],se);let Oe=v=class{#e;static isMarkdownString(T){return T instanceof v?!0:T&&T.appendCodeblock&&T.appendMarkdown&&T.appendText&&T.value!==void 0}constructor(T,te=!1){this.#e=new P.$wk(T,{supportThemeIcons:te})}get value(){return this.#e.value}set value(T){this.#e.value=T}get isTrusted(){return this.#e.isTrusted}set isTrusted(T){this.#e.isTrusted=T}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(T){this.#e.supportThemeIcons=T}get supportHtml(){return this.#e.supportHtml}set supportHtml(T){this.#e.supportHtml=T}get baseUri(){return this.#e.baseUri}set baseUri(T){this.#e.baseUri=T}appendText(T){return this.#e.appendText(T),this}appendMarkdown(T){return this.#e.appendMarkdown(T),this}appendCodeblock(T,te){return this.#e.appendCodeblock(te??"",T),this}};e.$wM=Oe,e.$wM=Oe=v=Ye([w],Oe);let We=class{constructor(T,te){this.label=T,this.documentation=te}};e.$xM=We,e.$xM=We=Ye([w],We);let Ke=class{constructor(T,te){this.label=T,this.documentation=te,this.parameters=[]}};e.$yM=Ke,e.$yM=Ke=Ye([w],Ke);let xe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$zM=xe,e.$zM=xe=Ye([w],xe);var tt;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(tt||(e.SignatureHelpTriggerKind=tt={}));var lt;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(lt||(e.InlayHintKind=lt={}));let rt=class{constructor(T){this.value=T}};e.$AM=rt,e.$AM=rt=Ye([w],rt);let it=class{constructor(T,te,Se){this.position=T,this.label=te,this.kind=Se}};e.$BM=it,e.$BM=it=Ye([w],it);var at;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(at||(e.CompletionTriggerKind=at={}));var Be;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(Be||(e.CompletionItemKind=Be={}));var et;(function(B){B[B.Deprecated=1]="Deprecated"})(et||(e.CompletionItemTag=et={}));let Z=class{constructor(T,te){this.label=T,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&Be[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$CM=Z,e.$CM=Z=Ye([w],Z);let Q=class{constructor(T=[],te=!1){this.items=T,this.isIncomplete=te}};e.$DM=Q,e.$DM=Q=Ye([w],Q);let pe=class{constructor(T,te,Se){this.insertText=T,this.range=te,this.command=Se}};e.$EM=pe,e.$EM=pe=Ye([w],pe);let Ve=class{constructor(T){this.commands=void 0,this.suppressSuggestions=void 0,this.items=T}};e.$FM=Ve,e.$FM=Ve=Ye([w],Ve);var Ze;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(Ze||(e.ViewColumn=Ze={}));var st;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(st||(e.StatusBarAlignment=st={}));function Me(B,T){return`${D.$zm.toKey(B)}.${T}`}e.$GM=Me;var Dt;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative",B[B.Interval=3]="Interval"})(Dt||(e.TextEditorLineNumbersStyle=Dt={}));var Kt;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(Kt||(e.TextDocumentSaveReason=Kt={}));var Tt;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(Tt||(e.TextEditorRevealType=Tt={}));var Qt;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(Qt||(e.TextEditorSelectionChangeKind=Qt={}));var Zt;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(Zt||(e.TextDocumentChangeReason=Zt={}));var St;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(St||(e.DecorationRangeBehavior=St={})),function(B){function T(te){switch(te){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=T}(Qt||(e.TextEditorSelectionChangeKind=Qt={}));var Jt;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(Jt||(e.SyntaxTokenType=Jt={})),function(B){function T(te){switch(te){case B.Other:return"other";case B.Comment:return"comment";case B.String:return"string";case B.RegEx:return"regex"}return"other"}B.toString=T}(Jt||(e.SyntaxTokenType=Jt={}));let Gt=class{constructor(T,te){if(te&&!k.URI.isUri(te))throw(0,M.$7)("target");if(!U.isRange(T)||T.isEmpty)throw(0,M.$7)("range");this.range=T,this.target=te}};e.$HM=Gt,e.$HM=Gt=Ye([w],Gt);let _t=class{constructor(T,te,Se,Ge){this.red=T,this.green=te,this.blue=Se,this.alpha=Ge}};e.$IM=_t,e.$IM=_t=Ye([w],_t);let ni=class{constructor(T,te){if(te&&!(te instanceof _t))throw(0,M.$7)("color");if(!U.isRange(T)||T.isEmpty)throw(0,M.$7)("range");this.range=T,this.color=te}};e.$JM=ni,e.$JM=ni=Ye([w],ni);let Xe=class{constructor(T){if(!T||typeof T!="string")throw(0,M.$7)("label");this.label=T}};e.$KM=Xe,e.$KM=Xe=Ye([w],Xe);var jt;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(jt||(e.ColorFormat=jt={}));var ei;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(ei||(e.SourceControlInputBoxValidationType=ei={}));var dt;(function(B){B[B.Unknown=0]="Unknown",B[B.Shutdown=1]="Shutdown",B[B.Process=2]="Process",B[B.User=3]="User",B[B.Extension=4]="Extension"})(dt||(e.TerminalExitReason=dt={}));class pt{constructor(T,te,Se){if(this.startIndex=T,this.length=te,this.tooltip=Se,typeof T!="number"||T<0)throw(0,M.$7)("startIndex");if(typeof te!="number"||te<1)throw(0,M.$7)("length");if(Se!==void 0&&typeof Se!="string")throw(0,M.$7)("tooltip")}}e.$LM=pt;class ti{constructor(T){this.uri=T}}e.$MM=ti;class Vt{constructor(T){this.terminalCommand=T}}e.$NM=Vt;var zt;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(zt||(e.TerminalLocation=zt={}));class ft{constructor(T){if(this.options=T,typeof T!="object")throw(0,M.$7)("options")}}e.$OM=ft;var Pt;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(Pt||(e.TaskRevealKind=Pt={}));var ii;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(ii||(e.TaskPanelKind=ii={}));let Xt=class{static{b=this}static{this.Clean=new b("clean","Clean")}static{this.Build=new b("build","Build")}static{this.Rebuild=new b("rebuild","Rebuild")}static{this.Test=new b("test","Test")}static from(T){switch(T){case"clean":return b.Clean;case"build":return b.Build;case"rebuild":return b.Rebuild;case"test":return b.Test;default:return}}constructor(T,te){if(this.label=te,typeof T!="string"||typeof te!="string")throw(0,M.$7)("name");this.c=T}get id(){return this.c}};e.$PM=Xt,e.$PM=Xt=b=Ye([w],Xt);function Je(B){let T="";for(let te=0;te<B.length;te++)T+=B[te].replace(/,/g,",,")+",";return T}let Rt=class{constructor(T,te,Se){if(typeof T!="string")throw(0,M.$7)("process");this.e=[],this.c=T,te!==void 0&&(Array.isArray(te)?(this.e=te,this.f=Se):this.f=te)}get process(){return this.c}set process(T){if(typeof T!="string")throw(0,M.$7)("process");this.c=T}get args(){return this.e}set args(T){Array.isArray(T)||(T=[]),this.e=T}get options(){return this.f}set options(T){this.f=T}computeId(){const T=[];if(T.push("process"),this.c!==void 0&&T.push(this.c),this.e&&this.e.length>0)for(const te of this.e)T.push(te);return Je(T)}};e.$QM=Rt,e.$QM=Rt=Ye([w],Rt);let Ut=class{constructor(T,te,Se){if(this.f=[],Array.isArray(te)){if(!T)throw(0,M.$7)("command can't be undefined or null");if(typeof T!="string"&&typeof T.value!="string")throw(0,M.$7)("command");this.e=T,this.f=te,this.g=Se}else{if(typeof T!="string")throw(0,M.$7)("commandLine");this.c=T,this.g=te}}get commandLine(){return this.c}set commandLine(T){if(typeof T!="string")throw(0,M.$7)("commandLine");this.c=T}get command(){return this.e?this.e:""}set command(T){if(typeof T!="string"&&typeof T.value!="string")throw(0,M.$7)("command");this.e=T}get args(){return this.f}set args(T){this.f=T||[]}get options(){return this.g}set options(T){this.g=T}computeId(){const T=[];if(T.push("shell"),this.c!==void 0&&T.push(this.c),this.e!==void 0&&T.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const te of this.f)T.push(typeof te=="string"?te:te.value);return Je(T)}};e.$RM=Ut,e.$RM=Ut=Ye([w],Ut);var ri;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(ri||(e.ShellQuoting=ri={}));var gt;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(gt||(e.TaskScope=gt={}));class Mt{constructor(T){this.c=T}computeId(){return"customExecution"+(0,O.$Bg)()}set callback(T){this.c=T}get callback(){return this.c}}e.$SM=Mt;let Ct=class{static{$=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(T,te,Se,Ge,_e,ut){this.k=!1,this.l=this.definition=T;let mt;typeof te=="string"?(this.o=this.name=te,this.w=this.source=Se,this.execution=Ge,mt=_e,this.k=!0):te===gt.Global||te===gt.Workspace?(this.target=te,this.o=this.name=Se,this.w=this.source=Ge,this.execution=_e,mt=ut):(this.target=te,this.o=this.name=Se,this.w=this.source=Ge,this.execution=_e,mt=ut),typeof mt=="string"?(this.r=[mt],this.t=!0):Array.isArray(mt)?(this.r=mt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(T){this.j=T}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Rt?this.l={type:$.e,id:this.q.computeId()}:this.q instanceof Ut?this.l={type:$.f,id:this.q.computeId()}:this.q instanceof Mt?this.l={type:$.c,id:this.q.computeId()}:this.l={type:$.g,id:(0,O.$Bg)()}}get definition(){return this.l}set definition(T){if(T==null)throw(0,M.$7)("Kind can't be undefined or null");this.B(),this.l=T}get scope(){return this.m}set target(T){this.B(),this.m=T}get name(){return this.o}set name(T){if(typeof T!="string")throw(0,M.$7)("name");this.B(),this.o=T}get execution(){return this.q}set execution(T){T===null&&(T=void 0),this.B(),this.q=T;const te=this.l.type;($.g===te||$.e===te||$.f===te||$.c===te)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(T){if(Array.isArray(T))this.B(),this.r=T,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(T){T!==!0&&T!==!1&&(T=!1),this.B(),this.u=T}get source(){return this.w}set source(T){if(typeof T!="string"||T.length===0)throw(0,M.$7)("source must be a string of length > 0");this.B(),this.w=T}get group(){return this.x}set group(T){T===null&&(T=void 0),this.B(),this.x=T}get detail(){return this.A}set detail(T){T===null&&(T=void 0),this.A=T}get presentationOptions(){return this.y}set presentationOptions(T){T==null&&(T=Object.create(null)),this.B(),this.y=T}get runOptions(){return this.z}set runOptions(T){T==null&&(T=Object.create(null)),this.B(),this.z=T}};e.$TM=Ct,e.$TM=Ct=$=Ye([w],Ct);var Bt;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(Bt||(e.ProgressLocation=Bt={}));var si;(function(B){function T(te){const Se=te;return(0,f.$Wf)(Se.value)?Se.tooltip&&!(0,f.$Sf)(Se.tooltip)?(console.log("INVALID view badge, invalid tooltip",Se.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Se.value),!1)}B.isViewBadge=T})(si||(e.ViewBadge=si={}));let Nt=I=class{static isTreeItem(T,te){const Se=T;if(Se.checkboxState!==void 0){const Ge=(0,f.$Wf)(Se.checkboxState)?Se.checkboxState:(0,f.$Uf)(Se.checkboxState)&&(0,f.$Wf)(Se.checkboxState.state)?Se.checkboxState.state:void 0,_e=!(0,f.$Wf)(Se.checkboxState)&&(0,f.$Uf)(Se.checkboxState)?Se.checkboxState.tooltip:void 0;if(Ge===void 0||Ge!==yt.Checked&&Ge!==yt.Unchecked||_e!==void 0&&!(0,f.$Sf)(_e))return console.log("INVALID tree item, invalid checkboxState",Se.checkboxState),!1}if(T instanceof I)return!0;if(Se.label!==void 0&&!(0,f.$Sf)(Se.label)&&!Se.label?.label)return console.log("INVALID tree item, invalid label",Se.label),!1;if(Se.id!==void 0&&!(0,f.$Sf)(Se.id))return console.log("INVALID tree item, invalid id",Se.id),!1;if(Se.iconPath!==void 0&&!(0,f.$Sf)(Se.iconPath)&&!k.URI.isUri(Se.iconPath)&&(!Se.iconPath||!(0,f.$Sf)(Se.iconPath.id))){const Ge=Se.iconPath;if(!Ge||!(0,f.$Sf)(Ge.light)&&!k.URI.isUri(Ge.light)&&!(0,f.$Sf)(Ge.dark)&&!k.URI.isUri(Ge.dark))return console.log("INVALID tree item, invalid iconPath",Se.iconPath),!1}return Se.description!==void 0&&!(0,f.$Sf)(Se.description)&&typeof Se.description!="boolean"?(console.log("INVALID tree item, invalid description",Se.description),!1):Se.resourceUri!==void 0&&!k.URI.isUri(Se.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Se.resourceUri),!1):Se.tooltip!==void 0&&!(0,f.$Sf)(Se.tooltip)&&!(Se.tooltip instanceof Oe)?(console.log("INVALID tree item, invalid tooltip",Se.tooltip),!1):Se.command!==void 0&&!Se.command.command?(console.log("INVALID tree item, invalid command",Se.command),!1):Se.collapsibleState!==void 0&&Se.collapsibleState<qt.None&&Se.collapsibleState>qt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Se.collapsibleState),!1):Se.contextValue!==void 0&&!(0,f.$Sf)(Se.contextValue)?(console.log("INVALID tree item, invalid contextValue",Se.contextValue),!1):Se.accessibilityInformation!==void 0&&!Se.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Se.accessibilityInformation),!1):!0}constructor(T,te=qt.None){this.collapsibleState=te,k.URI.isUri(T)?this.resourceUri=T:this.label=T}};e.$UM=Nt,e.$UM=Nt=I=Ye([w],Nt);var qt;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(qt||(e.TreeItemCollapsibleState=qt={}));var yt;(function(B){B[B.Unchecked=0]="Unchecked",B[B.Checked=1]="Checked"})(yt||(e.TreeItemCheckboxState=yt={}));let Ft=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(T){this.value=T}};e.$VM=Ft,e.$VM=Ft=Ye([w],Ft);class Yt extends Ft{}e.$WM=Yt;class Wt extends Yt{#e;constructor(T){super(""),this.#e=T}asFile(){return this.#e}}e.$XM=Wt;class wt{constructor(T,te,Se,Ge){this.name=T,this.uri=te,this._itemId=Se,this.c=Ge}data(){return this.c()}}e.$YM=wt;let It=class{#e=new Map;constructor(T){for(const[te,Se]of T??[]){const Ge=this.#e.get(this.#t(te));Ge?Ge.push(Se):this.#e.set(this.#t(te),[Se])}}get(T){return this.#e.get(this.#t(T))?.[0]}set(T,te){this.#e.set(this.#t(T),[te])}forEach(T,te){for(const[Se,Ge]of this.#e)for(const _e of Ge)T.call(te,_e,Se,this)}*[Symbol.iterator](){for(const[T,te]of this.#e)for(const Se of te)yield[T,Se]}#t(T){return T.toLowerCase()}};e.$ZM=It,e.$ZM=It=Ye([w],It);let Et=class{constructor(T){this.insertText=T}};e.$1M=Et,e.$1M=Et=Ye([w],Et);let ci=class{constructor(T,te){this.label=te,this.insertText=T}};e.$2M=ci,e.$2M=ci=Ye([w],ci);let we=class{constructor(T,te){this.id=T,this.color=te}static isThemeIcon(T){return typeof T.id!="string"?(console.log("INVALID ThemeIcon, invalid id",T.id),!1):!0}};e.$3M=we,e.$3M=we=Ye([w],we),we.File=new we("file"),we.Folder=new we("folder");let Le=class{constructor(T){this.id=T}};e.$4M=Le,e.$4M=Le=Ye([w],Le);var ce;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(ce||(e.ConfigurationTarget=ce={}));let Y=class{get base(){return this.c}set base(T){this.c=T,this.e=k.URI.file(T)}get baseUri(){return this.e}set baseUri(T){this.e=T,this.c=T.fsPath}constructor(T,te){if(typeof T!="string"&&(!T||!k.URI.isUri(T)&&!k.URI.isUri(T.uri)))throw(0,M.$7)("base");if(typeof te!="string")throw(0,M.$7)("pattern");typeof T=="string"?this.baseUri=k.URI.file(T):k.URI.isUri(T)?this.baseUri=T:this.baseUri=T.uri,this.pattern=te}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$5M=Y,e.$5M=Y=Ye([w],Y);const Ee=new WeakMap;function Ue(B,T){Ee.set(B,T)}e.$6M=Ue;let Qe=class{constructor(T,te,Se,Ge,_e){this.enabled=typeof T=="boolean"?T:!0,typeof te=="string"&&(this.condition=te),typeof Se=="string"&&(this.hitCondition=Se),typeof Ge=="string"&&(this.logMessage=Ge),typeof _e=="string"&&(this.mode=_e)}get id(){return this.c||(this.c=Ee.get(this)??(0,O.$Bg)()),this.c}};e.$7M=Qe,e.$7M=Qe=Ye([w],Qe);let qe=class extends Qe{constructor(T,te,Se,Ge,_e,ut){if(super(te,Se,Ge,_e,ut),T===null)throw(0,M.$7)("location");this.location=T}};e.$8M=qe,e.$8M=qe=Ye([w],qe);let ct=class extends Qe{constructor(T,te,Se,Ge,_e,ut){super(te,Se,Ge,_e,ut),this.functionName=T}};e.$9M=ct,e.$9M=ct=Ye([w],ct);let bt=class extends Qe{constructor(T,te,Se,Ge,_e,ut,mt,Ht){if(super(Ge,_e,ut,mt,Ht),!te)throw(0,M.$7)("dataId");this.label=T,this.dataId=te,this.canPersist=Se}};e.$0M=bt,e.$0M=bt=Ye([w],bt);let Lt=class{constructor(T,te,Se){this.command=T,this.args=te||[],this.options=Se}};e.$$M=Lt,e.$$M=Lt=Ye([w],Lt);let xt=class{constructor(T,te){this.port=T,this.host=te}};e.$_M=xt,e.$_M=xt=Ye([w],xt);let At=class{constructor(T){this.path=T}};e.$aN=At,e.$aN=At=Ye([w],At);let kt=class{constructor(T){this.implementation=T}};e.$bN=kt,e.$bN=kt=Ye([w],kt);let wi=class{constructor(T,te,Se){this.session=T,this.threadId=te,this.frameId=Se}};e.$cN=wi,e.$cN=wi=Ye([w],wi);let Pi=class{constructor(T,te){this.session=T,this.threadId=te}};e.$dN=Pi,e.$dN=Pi=Ye([w],Pi);let pi=class{constructor(T,te){this.range=T,this.expression=te}};e.$eN=pi,e.$eN=pi=Ye([w],pi);var vi;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(vi||(e.InlineCompletionTriggerKind=vi={}));let ht=class{constructor(T,te){this.range=T,this.text=te}};e.$fN=ht,e.$fN=ht=Ye([w],ht);let Ri=class{constructor(T,te,Se=!0){this.range=T,this.variableName=te,this.caseSensitiveLookup=Se}};e.$gN=Ri,e.$gN=Ri=Ye([w],Ri);let ui=class{constructor(T,te){this.range=T,this.expression=te}};e.$hN=ui,e.$hN=ui=Ye([w],ui);let gi=class{constructor(T,te){this.frameId=T,this.stoppedLocation=te}};e.$iN=gi,e.$iN=gi=Ye([w],gi);var Ai;(function(B){B[B.AIGenerated=1]="AIGenerated"})(Ai||(e.NewSymbolNameTag=Ai={}));class ln{constructor(T,te){this.newSymbolName=T,this.tags=te}}e.$jN=ln;var Zi;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(Zi||(e.FileChangeType=Zi={}));let Mi=h=class extends Error{static FileExists(T){return new h(T,l.FileSystemProviderErrorCode.FileExists,h.FileExists)}static FileNotFound(T){return new h(T,l.FileSystemProviderErrorCode.FileNotFound,h.FileNotFound)}static FileNotADirectory(T){return new h(T,l.FileSystemProviderErrorCode.FileNotADirectory,h.FileNotADirectory)}static FileIsADirectory(T){return new h(T,l.FileSystemProviderErrorCode.FileIsADirectory,h.FileIsADirectory)}static NoPermissions(T){return new h(T,l.FileSystemProviderErrorCode.NoPermissions,h.NoPermissions)}static Unavailable(T){return new h(T,l.FileSystemProviderErrorCode.Unavailable,h.Unavailable)}constructor(T,te=l.FileSystemProviderErrorCode.Unknown,Se){super(k.URI.isUri(T)?T.toString(!0):T),this.code=Se?.name??"Unknown",(0,l.$Uk)(this,te),Object.setPrototypeOf(this,h.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}};e.$kN=Mi,e.$kN=Mi=h=Ye([w],Mi);let yi=class{constructor(T,te,Se){this.start=T,this.end=te,this.kind=Se}};e.$lN=yi,e.$lN=yi=Ye([w],yi);var Xi;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(Xi||(e.FoldingRangeKind=Xi={}));var Fi;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(Fi||(e.CommentThreadCollapsibleState=Fi={}));var xi;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(xi||(e.CommentMode=xi={}));var Ei;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(Ei||(e.CommentState=Ei={}));var ki;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(ki||(e.CommentThreadState=ki={}));class hn{constructor(T,te=[]){this.tokenTypes=T,this.tokenModifiers=te}}e.$mN=hn;function dn(B){return typeof B>"u"||(0,f.$Tf)(B)}class mi{constructor(T){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,T){this.m=!0;for(let te=0,Se=T.tokenTypes.length;te<Se;te++)this.k.set(T.tokenTypes[te],te);for(let te=0,Se=T.tokenModifiers.length;te<Se;te++)this.l.set(T.tokenModifiers[te],te)}}push(T,te,Se,Ge,_e){if(typeof T=="number"&&typeof te=="number"&&typeof Se=="number"&&typeof Ge=="number"&&(typeof _e=="number"||typeof _e>"u"))return typeof _e>"u"&&(_e=0),this.q(T,te,Se,Ge,_e);if(U.isRange(T)&&typeof te=="string"&&dn(Se))return this.o(T,te,Se);throw(0,M.$7)()}o(T,te,Se){if(!this.m)throw new Error("Legend must be provided in constructor");if(T.start.line!==T.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(te))throw new Error("`tokenType` is not in the provided legend");const Ge=T.start.line,_e=T.start.character,ut=T.end.character-T.start.character,mt=this.k.get(te);let Ht=0;if(Se)for(const ai of Se){if(!this.l.has(ai))throw new Error("`tokenModifier` is not in the provided legend");const hi=this.l.get(ai);Ht|=1<<hi>>>0}this.q(Ge,_e,ut,mt,Ht)}q(T,te,Se,Ge,_e){if(this.f&&(T<this.c||T===this.c&&te<this.e)){this.f=!1;const Ht=this.g.length/5|0;let ai=0,hi=0;for(let fi=0;fi<Ht;fi++){let $i=this.g[5*fi],Yi=this.g[5*fi+1];$i===0?($i=ai,Yi+=hi):$i+=ai,this.g[5*fi]=$i,this.g[5*fi+1]=Yi,ai=$i,hi=Yi}}let ut=T,mt=te;this.f&&this.j>0&&(ut-=this.c,ut===0&&(mt-=this.e)),this.g[this.j++]=ut,this.g[this.j++]=mt,this.g[this.j++]=Se,this.g[this.j++]=Ge,this.g[this.j++]=_e,this.c=T,this.e=te}static r(T){const te=[],Se=T.length/5|0;for(let mt=0;mt<Se;mt++)te[mt]=mt;te.sort((mt,Ht)=>{const ai=T[5*mt],hi=T[5*Ht];if(ai===hi){const fi=T[5*mt+1],$i=T[5*Ht+1];return fi-$i}return ai-hi});const Ge=new Uint32Array(T.length);let _e=0,ut=0;for(let mt=0;mt<Se;mt++){const Ht=5*te[mt],ai=T[Ht+0],hi=T[Ht+1],fi=T[Ht+2],$i=T[Ht+3],Yi=T[Ht+4],Rn=ai-_e,_n=Rn===0?hi-ut:hi,Qi=5*mt;Ge[Qi+0]=Rn,Ge[Qi+1]=_n,Ge[Qi+2]=fi,Ge[Qi+3]=$i,Ge[Qi+4]=Yi,_e=ai,ut=hi}return Ge}build(T){return this.f?new Li(new Uint32Array(this.g),T):new Li(mi.r(this.g),T)}}e.$nN=mi;class Li{constructor(T,te){this.resultId=te,this.data=T}}e.$oN=Li;class fn{constructor(T,te,Se){this.start=T,this.deleteCount=te,this.data=Se}}e.$pN=fn;class gn{constructor(T,te){this.resultId=te,this.edits=T}}e.$qN=gn;var _i;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(_i||(e.DebugConsoleMode=_i={}));class mn{constructor(T){this.name=T}}e.$rN=mn;let bi=class{static{this.Back={iconPath:new we("arrow-left")}}constructor(){}};e.$sN=bi,e.$sN=bi=Ye([w],bi);var Oi;(function(B){B[B.Separator=-1]="Separator",B[B.Default=0]="Default"})(Oi||(e.QuickPickItemKind=Oi={}));var en;(function(B){B[B.Info=1]="Info",B[B.Warning=2]="Warning",B[B.Error=3]="Error"})(en||(e.InputBoxValidationSeverity=en={}));var Ni;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(Ni||(e.ExtensionKind=Ni={}));class tn{static validate(T){if(typeof T.badge=="string"){let te=(0,m.$tf)(T.badge,0);if(te<T.badge.length&&(te+=(0,m.$tf)(T.badge,te)),T.badge.length>te)throw new Error("The 'badge'-property must be undefined or a short character")}else if(T.badge&&!we.isThemeIcon(T.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!T.color&&!T.badge&&!T.tooltip)throw new Error("The decoration is empty");return!0}constructor(T,te,Se){this.badge=T,this.tooltip=te,this.color=Se}}e.$tN=tn;let Ti=class{constructor(T){this.kind=T}};e.$uN=Ti,e.$uN=Ti=Ye([w],Ti);var nn;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast",B[B.HighContrastLight=4]="HighContrastLight"})(nn||(e.ColorThemeKind=nn={}));class di{static isNotebookRange(T){return T instanceof di?!0:T?typeof T.start=="number"&&typeof T.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(T,te){if(T<0)throw(0,M.$7)("start must be positive");if(te<0)throw(0,M.$7)("end must be positive");T<=te?(this.c=T,this.e=te):(this.c=te,this.e=T)}with(T){let te=this.c,Se=this.e;return T.start!==void 0&&(te=T.start),T.end!==void 0&&(Se=T.end),te===this.c&&Se===this.e?this:new di(te,Se)}}e.$vN=di;class Di{static validate(T){if(typeof T.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof T.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof T.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(T){return Array.isArray(T)&&T.every(te=>Di.isNotebookCellData(te))}static isNotebookCellData(T){return!0}constructor(T,te,Se,Ge,_e,ut,mt){this.kind=T,this.value=te,this.languageId=Se,this.mime=Ge,this.outputs=_e??[],this.metadata=ut,this.executionSummary=mt,Di.validate(this)}}e.$wN=Di;class ji{constructor(T){this.cells=T}}e.$xN=ji;class oi{static isNotebookCellOutputItem(T){return T instanceof oi?!0:T?typeof T.mime=="string"&&T.data instanceof Uint8Array:!1}static error(T){const te={name:T.name,message:T.message,stack:T.stack};return oi.json(te,"application/vnd.code.notebook.error")}static stdout(T){return oi.text(T,"application/vnd.code.notebook.stdout")}static stderr(T){return oi.text(T,"application/vnd.code.notebook.stderr")}static bytes(T,te="application/octet-stream"){return new oi(T,te)}static#e=new TextEncoder;static text(T,te=R.$ts.text){const Se=oi.#e.encode(String(T));return new oi(Se,te)}static json(T,te="text/x-json"){const Se=JSON.stringify(T,void 0,"	");return oi.text(Se,te)}constructor(T,te){this.data=T,this.mime=te;const Se=(0,R.$xs)(te,!0);if(!Se)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Se}}e.$yN=oi;class Te{static isNotebookCellOutput(T){return T instanceof Te?!0:!T||typeof T!="object"?!1:typeof T.id=="string"&&Array.isArray(T.items)}static ensureUniqueMimeTypes(T,te=!1){const Se=new Set,Ge=new Set;for(let _e=0;_e<T.length;_e++){const ut=T[_e],mt=(0,R.$xs)(ut.mime);if(!Se.has(mt)||(0,g.$6J)(mt)){Se.add(mt);continue}Ge.add(_e),te&&console.warn(`DUPLICATED mime type '${ut.mime}' will be dropped`)}return Ge.size===0?T:T.filter((_e,ut)=>!Ge.has(ut))}constructor(T,te,Se){this.items=Te.ensureUniqueMimeTypes(T,!0),typeof te=="string"?(this.id=te,this.metadata=Se):(this.id=(0,O.$Bg)(),this.metadata=te??Se)}}e.$zN=Te;var li;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(li||(e.NotebookCellKind=li={}));var zi;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(zi||(e.NotebookCellExecutionState=zi={}));var nt;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(nt||(e.NotebookCellStatusBarAlignment=nt={}));var $t;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})($t||(e.NotebookEditorRevealType=$t={}));class $n{constructor(T,te){this.text=T,this.alignment=te}}e.$AN=$n;var rn;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(rn||(e.NotebookControllerAffinity=rn={}));var Ui;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred",B[B.Hidden=-1]="Hidden"})(Ui||(e.NotebookControllerAffinity2=Ui={}));class pn{constructor(T,te=[]){this.uri=T,this.provides=(0,S.$3b)(te)}}e.$BN=pn;class Si{constructor(T){this.label=T}}e.$CN=Si;var sn;(function(B){B[B.Named=1]="Named",B[B.Indexed=2]="Indexed"})(sn||(e.NotebookVariablesRequestKind=sn={}));let Bi=class{constructor(T,te){this.label=T,this.timestamp=te}};e.$DN=Bi,e.$DN=Bi=Ye([w],Bi);var on;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(on||(e.ExtensionMode=on={}));var Wi;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(Wi||(e.ExtensionRuntime=Wi={}));var an;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(an||(e.StandardTokenType=an={}));class vn{constructor(T,te){this.ranges=T,this.wordPattern=te}}e.$EN=vn;class bn{constructor(T){this.c=T}get autoForwardAction(){return this.c}}e.$FN=bn;var cn;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(cn||(e.TestResultState=cn={}));var un;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(un||(e.TestRunProfileKind=un={}));let Vi=class{constructor(T=void 0,te=void 0,Se=void 0,Ge=!1){this.include=T,this.exclude=te,this.profile=Se,this.continuous=Ge}};e.$GN=Vi,e.$GN=Vi=Ye([w],Vi);let qi=y=class{static diff(T,te,Se){const Ge=new y(T);return Ge.expectedOutput=te,Ge.actualOutput=Se,Ge}constructor(T){this.message=T}};e.$HN=qi,e.$HN=qi=y=Ye([w],qi);let Hi=class{constructor(T){this.id=T}};e.$IN=Hi,e.$IN=Hi=Ye([w],Hi);class Ii{constructor(T,te){this.covered=T,this.total=te}}e.$JN=Ii;const Ki=B=>{if(B&&B.covered>B.total)throw new Error(`The total number of covered items (${B.covered}) cannot be greater than the total (${B.total})`)};class Ji{static fromDetails(T,te){const Se=new Ii(0,0),Ge=new Ii(0,0),_e=new Ii(0,0);for(const mt of te)if("branches"in mt){Se.total+=1,Se.covered+=mt.executed?1:0;for(const Ht of mt.branches)Ge.total+=1,Ge.covered+=Ht.executed?1:0}else _e.total+=1,_e.covered+=mt.executed?1:0;const ut=new Ji(T,Se,Ge.total>0?Ge:void 0,_e.total>0?_e:void 0);return ut.detailedCoverage=te,ut}constructor(T,te,Se,Ge){this.uri=T,this.statementCoverage=te,this.branchCoverage=Se,this.declarationCoverage=Ge,Ki(te),Ki(Se),Ki(Ge)}}e.$KN=Ji;class x{get executionCount(){return+this.executed}set executionCount(T){this.executed=T}constructor(T,te,Se=[]){this.executed=T,this.location=te,this.branches=Se}}e.$LN=x;class oe{get executionCount(){return+this.executed}set executionCount(T){this.executed=T}constructor(T,te,Se){this.executed=T,this.location=te,this.label=Se}}e.$MN=oe;class ze{get executionCount(){return+this.executed}set executionCount(T){this.executed=T}constructor(T,te,Se){this.name=T,this.executed=te,this.location=Se}}e.$NN=ze;var ot;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(ot||(e.ExternalUriOpenerPriority=ot={}));var vt;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(vt||(e.WorkspaceTrustState=vt={}));var Ot;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(Ot||(e.PortAutoForwardAction=Ot={}));class Gi{constructor(T,te,Se,Ge,_e,ut){this.kind=T,this.name=te,this.detail=Se,this.uri=Ge,this.range=_e,this.selectionRange=ut}}e.$ON=Gi;class An{constructor(T){this.uri=T}}e.$PN=An;class Mn{constructor(T,te){this.original=T,this.modified=te}}e.$QN=Mn;class Fn{constructor(T,te,Se,Ge){this.base=T,this.input1=te,this.input2=Se,this.result=Ge}}e.$RN=Fn;class Ln{constructor(T,te){this.uri=T,this.viewType=te}}e.$SN=Ln;class On{constructor(T){this.viewType=T}}e.$TN=On;class Nn{constructor(T,te){this.uri=T,this.notebookType=te}}e.$UN=Nn;class Tn{constructor(T,te,Se){this.original=T,this.modified=te,this.notebookType=Se}}e.$VN=Tn;class jn{constructor(){}}e.$WN=jn;class zn{constructor(T,te){this.uri=T,this.inputBoxUri=te}}e.$XN=zn;class Un{constructor(T){this.providerId=T}}e.$YN=Un;var wn;(function(B){B[B.Down=0]="Down",B[B.Up=1]="Up"})(wn||(e.InteractiveSessionVoteDirection=wn={}));var yn;(function(B){B[B.Action=1]="Action",B[B.Toolbar=2]="Toolbar"})(yn||(e.ChatCopyKind=yn={}));var En;(function(B){B[B.Short=1]="Short",B[B.Medium=2]="Medium",B[B.Full=3]="Full"})(En||(e.ChatVariableLevel=En={}));class Bn{constructor(T,te){this.label=T,this.values=te}}e.$ZN=Bn;var kn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful",B[B.Undone=2]="Undone",B[B.Accepted=3]="Accepted",B[B.Bug=4]="Bug"})(kn||(e.InteractiveEditorResponseFeedbackKind=kn={}));var Dn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful"})(Dn||(e.ChatResultFeedbackKind=Dn={}));class Wn{constructor(T){this.value=typeof T=="string"?new Oe(T):T}}e.$1N=Wn;class Vn{constructor(T,te){this.value=T,this.baseUri=te}}e.$2N=Vn;class qn{constructor(T,te){this.value=T,this.title=te}}e.$3N=qn;class Hn{constructor(T){this.value=T}}e.$4N=Hn;class Kn{constructor(T){this.value=T}}e.$5N=Kn;class Jn{constructor(T){this.value=T}}e.$6N=Jn;class Gn{constructor(T,te,Se,Ge){this.prompt=T,this.command=te,this.variables=Se,this.participant=Ge}}e.$7N=Gn;class Yn{constructor(T,te,Se,Ge){this.response=T,this.result=te,this.participant=Se,this.command=Ge}}e.$8N=Yn;class Qn{constructor(T){this.content=T}}e.$9N=Qn;class Zn{constructor(T,te){this.content=T,this.name=te}}e.$0N=Zn;class Xn{constructor(T){this.content=T}}e.$$N=Xn;class Ci extends Error{static NotFound(T){return new Ci(T,Ci.NotFound.name)}static NoPermissions(T){return new Ci(T,Ci.NoPermissions.name)}constructor(T,te,Se){super(T,{cause:Se}),this.name="LanguageModelError",this.code=te??""}}e.$_N=Ci;var Sn;(function(B){B[B.SymbolInformation=1]="SymbolInformation",B[B.CommandInformation=2]="CommandInformation",B[B.SearchInformation=3]="SearchInformation",B[B.SettingInformation=4]="SettingInformation"})(Sn||(e.RelatedInformationType=Sn={}));var In;(function(B){B[B.Started=1]="Started",B[B.Recognizing=2]="Recognizing",B[B.Recognized=3]="Recognized",B[B.Stopped=4]="Stopped"})(In||(e.SpeechToTextStatus=In={}));var Cn;(function(B){B[B.Recognized=1]="Recognized",B[B.Stopped=2]="Stopped"})(Cn||(e.KeywordRecognitionStatus=Cn={}));class xn{constructor(T,te){this.text=T,this.range=te}}e.$aO=xn;var Pn;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(Pn||(e.InlineEditTriggerKind=Pn={}))}),define(Pe[242],Re([1,0,4,7]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ohc=void 0;class P{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(S.$6L.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,m,f){if(this.a.size===0)throw new Error("No related information providers registered");const k=this.a.get(R);if(!k)throw new Error("related information provider not found");return await k.provideRelatedInformation(m,f)??[]}getRelatedInformation(R,m,f){return this.c.$getAiRelatedInformation(m,f)}registerRelatedInformationProvider(R,m,f){const k=this.b;return this.b++,this.a.set(k,f),this.c.$registerAiRelatedInformationProvider(k,m),new M.$8L(()=>{this.c.$unregisterAiRelatedInformationProvider(k),this.a.delete(k)})}}e.$Ohc=P}),define(Pe[84],Re([1,0,5,4,7,20,106,3,17]),function(me,e,S,M,P,F,R,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1hc=e.$Zhc=void 0,e.$Zhc=(0,m.$fi)("IExtHostAuthentication");let k=class{constructor(l){this.b=new Map,this.c=new S.$5d,this.onDidChangeSessions=this.c.event,this.d=new O,this.f=new O,this.a=l.getProxy(M.$6L.MainThreadAuthentication)}async getSession(l,E,g,s={}){const a=F.$zm.toKey(l.identifier),i=[...g].sort().join(" ");return await this.d.getOrCreate(`${a} ${E} ${i}`,async()=>{await this.a.$ensureProvider(E);const n=l.displayName||l.name;return this.a.$getSession(E,g,a,n,s)})}async getSessions(l,E,g){const s=F.$zm.toKey(l.identifier),a=[...g].sort().join(" ");return await this.f.getOrCreate(`${s} ${a}`,async()=>{await this.a.$ensureProvider(E);const i=l.displayName||l.name;return this.a.$getSessions(E,g,s,i)})}async removeSession(l,E){const g=this.b.get(l);return g?g.provider.removeSession(E):this.a.$removeSession(l,E)}registerAuthenticationProvider(l,E,g,s){if(this.b.get(l))throw new Error(`An authentication provider with id '${l}' is already registered.`);this.b.set(l,{label:E,provider:g,options:s??{supportsMultipleAccounts:!1}});const a=g.onDidChangeSessions(i=>this.a.$sendDidChangeSessions(l,i));return this.a.$registerAuthenticationProvider(l,E,s?.supportsMultipleAccounts??!1),new P.$8L(()=>{a.dispose(),this.b.delete(l),this.a.$unregisterAuthenticationProvider(l)})}$createSession(l,E,g){const s=this.b.get(l);if(s)return Promise.resolve(s.provider.createSession(E,g));throw new Error(`Unable to find authentication provider with handle: ${l}`)}$removeSession(l,E){const g=this.b.get(l);if(g)return Promise.resolve(g.provider.removeSession(E));throw new Error(`Unable to find authentication provider with handle: ${l}`)}$getSessions(l,E){const g=this.b.get(l);if(g)return Promise.resolve(g.provider.getSessions(E));throw new Error(`Unable to find authentication provider with handle: ${l}`)}$onDidChangeAuthenticationSessions(l,E){return l.startsWith(R.$_K)||this.c.fire({provider:{id:l,label:E}}),Promise.resolve()}};e.$1hc=k,e.$1hc=k=Ye([He(0,f.$lO)],k);class O{constructor(){this.a=new Map}getOrCreate(l,E){const g=this.a.get(l);if(g)return g;const s=E().finally(()=>this.a.delete(l));return this.a.set(l,s),s}}}),define(Pe[110],Re([1,0,2,4,7,3,17,13,18,15,19,22]),function(me,e,S,M,P,F,R,m,f,k,O,D){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$2ic=e.$1ic=void 0;let E=class{static{l=this}static{this.c=0}static{this.d=250}constructor(s,a){this.h=a,this.f=new Map,this.g=s.getProxy(M.$6L.MainThreadDecorations)}registerFileDecorationProvider(s,a){const i=l.c++;this.f.set(i,{provider:s,extensionDescription:a}),this.g.$registerDecorationProvider(i,a.identifier.value);const n=s.onDidChangeFileDecorations&&s.onDidChangeFileDecorations(r=>{if(!r){this.g.$onDidChange(i,null);return}const c=(0,f.$3b)(r);if(c.length<=l.d){this.g.$onDidChange(i,c);return}this.h.warn("[Decorations] CAPPING events from decorations provider",a.identifier.value,c.length);const d=c.map(u=>({uri:u,rank:(0,k.$Ye)(u.path,"/")})),t=(0,f.$zb)(d,(u,o)=>u.rank-o.rank||(0,k.$cf)(u.uri.path,o.uri.path)),p=[];e:for(const u of t){let o;for(const v of u){const b=(0,O.$mc)(v.uri.path);if(o!==b&&(o=b,p.push(v.uri)>=l.d))break e}}this.g.$onDidChange(i,p)});return new P.$8L(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(i),this.f.delete(i)})}async $provideDecorations(s,a,i){if(!this.f.has(s))return Object.create(null);const n=Object.create(null),{provider:r,extensionDescription:c}=this.f.get(s);return await Promise.all(a.map(async d=>{try{const{uri:t,id:p}=d,u=await Promise.resolve(r.provideFileDecoration(S.URI.revive(t),i));if(!u)return;try{P.$tN.validate(u),u.badge&&typeof u.badge!="string"&&(0,D.$YF)(c,"codiconDecoration"),n[p]=[u.propagate,u.tooltip,u.badge,u.color]}catch(o){this.h.warn(`INVALID decoration from extension '${c.identifier.value}': ${o}`)}}catch(t){this.h.error(t)}})),n}};e.$1ic=E,e.$1ic=E=l=Ye([He(0,R.$lO),He(1,m.$zj)],E),e.$2ic=(0,F.$fi)("IExtHostDecorations")}),define(Pe[243],Re([1,0,14,2,7,4,12,25,15]),function(me,e,S,M,P,F,R,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4ic=void 0;class k{static{this.a=0}constructor(D,l,E){this.d=l,this.e=E,this.b=new Map,this.c=D.getProxy(F.$6L.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(D,l){if(Object.keys(R.Schemas).indexOf(D)>=0)throw new Error(`scheme '${D}' already registered`);const E=k.a++;this.b.set(E,l),this.c.$registerTextContentProvider(E,D);let g;if(typeof l.onDidChange=="function"){let s;g=l.onDidChange(async a=>{if(a.scheme!==D){this.e.warn(`Provider for scheme '${D}' is firing event for schema '${a.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(a))return;s&&await s;const i=this.$provideTextDocumentContent(E,a).then(async n=>{if(!n&&typeof n!="string")return;const r=this.d.getDocument(a);if(!r)return;const c=(0,f.$9e)(n);if(!r.equalLines(c))return this.c.$onVirtualDocumentChange(a,n)}).catch(S.$1).finally(()=>{s===i&&(s=void 0)});s=i})}return new P.$8L(()=>{this.b.delete(E)&&this.c.$unregisterTextContentProvider(E),g&&(g.dispose(),g=void 0)})}$provideTextDocumentContent(D,l){const E=this.b.get(D);return E?Promise.resolve(E.provideTextDocumentContent(M.URI.revive(l),m.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.$4ic=k}),define(Pe[111],Re([1,0,55,12,15,299,150,7,18]),function(me,e,S,M,P,F,R,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pO=e.$oO=e.$nO=void 0;const k=new Map;function O(g,s){s?k.set(g,s):k.delete(g)}e.$nO=O;function D(g){return k.get(g)}class l extends F.$Av{constructor(s,a,i,n,r,c,d){super(a,i,n,r),this.c=s,this.m=c,this.q=d,this.b=!1}dispose(){(0,S.ok)(!this.b),this.b=!0,this.q=!1}equalLines(s){return(0,f.$ub)(this.f,s)}get document(){if(!this.a){const s=this;this.a={get uri(){return s.d},get fileName(){return s.d.fsPath},get isUntitled(){return s.d.scheme===M.Schemas.untitled},get languageId(){return s.m},get version(){return s.h},get isClosed(){return s.b},get isDirty(){return s.q},save(){return s.r()},getText(a){return a?s.s(a):s.getText()},get eol(){return s.g===`
`?m.EndOfLine.LF:m.EndOfLine.CRLF},get lineCount(){return s.f.length},lineAt(a){return s.t(a)},offsetAt(a){return s.u(a)},positionAt(a){return s.v(a)},validateRange(a){return s.w(a)},validatePosition(a){return s.x(a)},getWordRangeAtPosition(a,i){return s.y(a,i)}}}return Object.freeze(this.a)}_acceptLanguageId(s){(0,S.ok)(!this.b),this.m=s}_acceptIsDirty(s){(0,S.ok)(!this.b),this.q=s}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(s){const a=this.w(s);if(a.isEmpty)return"";if(a.isSingleLine)return this.f[a.start.line].substring(a.start.character,a.end.character);const i=this.g,n=a.start.line,r=a.end.line,c=[];c.push(this.f[n].substring(a.start.character));for(let d=n+1;d<r;d++)c.push(this.f[d]);return c.push(this.f[r].substring(0,a.end.character)),c.join(i)}t(s){let a;if(s instanceof m.$9L?a=s.line:typeof s=="number"&&(a=s),typeof a!="number"||a<0||a>=this.f.length||Math.floor(a)!==a)throw new Error("Illegal value for `line`");return new E(a,this.f[a],a===this.f.length-1)}u(s){return s=this.x(s),this.l(),this.j.getPrefixSum(s.line-1)+s.character}v(s){s=Math.floor(s),s=Math.max(0,s),this.l();const a=this.j.getIndexOf(s),i=this.f[a.index].length;return new m.$9L(a.index,Math.min(a.remainder,i))}w(s){if(!(s instanceof m.$0L))throw new Error("Invalid argument");const a=this.x(s.start),i=this.x(s.end);return a===s.start&&i===s.end?s:new m.$0L(a.line,a.character,i.line,i.character)}x(s){if(!(s instanceof m.$9L))throw new Error("Invalid argument");if(this.f.length===0)return s.with(0,0);let{line:a,character:i}=s,n=!1;if(a<0)a=0,i=0,n=!0;else if(a>=this.f.length)a=this.f.length-1,i=this.f[a].length,n=!0;else{const r=this.f[a].length;i<0?(i=0,n=!0):i>r&&(i=r,n=!0)}return n?new m.$9L(a,i):s}y(s,a){const i=this.x(s);if(!a)a=D(this.m);else if((0,P.$8e)(a))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${a.source}' because it matches the empty string.`);const n=(0,R.$Ls)(i.character+1,(0,R.$Js)(a),this.f[i.line],0);if(n)return new m.$0L(i.line,n.startColumn-1,i.line,n.endColumn-1)}}e.$oO=l;class E{constructor(s,a,i){this.a=s,this.b=a,this.c=i}get lineNumber(){return this.a}get text(){return this.b}get range(){return new m.$0L(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new m.$0L(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$pO=E}),define(Pe[244],Re([1,0,4,7]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6ic=void 0;class P{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(S.$6L.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,m,f){if(this.a.size===0)throw new Error("No embedding vector providers registered");const k=this.a.get(R);if(!k)throw new Error("Embedding vector provider not found");const O=await k.provideEmbeddingVector(m,f);if(!O)throw new Error("Embedding vector provider returned undefined");return O}registerEmbeddingVectorProvider(R,m,f){const k=this.b;return this.b++,this.a.set(k,f),this.c.$registerAiEmbeddingVectorProvider(m,k),new M.$8L(()=>{this.c.$unregisterAiEmbeddingVectorProvider(k),this.a.delete(k)})}}e.$6ic=P}),define(Pe[63],Re([1,0,4,42,7,23,3,17,43,6,11,24,12]),function(me,e,S,M,P,F,R,m,f,k,O,D,l){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$hic=e.$gic=void 0;let g=E=class{constructor(a,i){this.b=new Map,this.c=new O.$oh,this.a=a.getProxy(S.$6L.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(r){try{let c;const d=n.b.get(r.scheme);return d?(await n.a.$ensureActivation(r.scheme),c=await d.impl.stat(r)):c=await n.a.$stat(r),{type:c.type,ctime:c.ctime,mtime:c.mtime,size:c.size,permissions:c.permissions===M.FilePermission.Readonly?1:void 0}}catch(c){E.e(c)}},async readDirectory(r){try{const c=n.b.get(r.scheme);return c?(await n.a.$ensureActivation(r.scheme),(await c.impl.readDirectory(r)).slice()):await n.a.$readdir(r)}catch(c){return E.e(c)}},async createDirectory(r){try{const c=n.b.get(r.scheme);return c&&!c.isReadonly?(await n.a.$ensureActivation(r.scheme),await n.d(c.impl,c.extUri,r)):await n.a.$mkdir(r)}catch(c){return E.e(c)}},async readFile(r){try{const c=n.b.get(r.scheme);return c?(await n.a.$ensureActivation(r.scheme),(await c.impl.readFile(r)).slice()):(await n.a.$readFile(r)).buffer}catch(c){return E.e(c)}},async writeFile(r,c){try{const d=n.b.get(r.scheme);return d&&!d.isReadonly?(await n.a.$ensureActivation(r.scheme),await n.d(d.impl,d.extUri,d.extUri.dirname(r)),await n.c.queueFor(r,()=>Promise.resolve(d.impl.writeFile(r,c,{create:!0,overwrite:!0})))):await n.a.$writeFile(r,F.$se.wrap(c))}catch(d){return E.e(d)}},async delete(r,c){try{const d=n.b.get(r.scheme);return d&&!d.isReadonly&&!c?.useTrash?(await n.a.$ensureActivation(r.scheme),await d.impl.delete(r,{recursive:!1,...c})):await n.a.$delete(r,{recursive:!1,useTrash:!1,atomic:!1,...c})}catch(d){return E.e(d)}},async rename(r,c,d){try{return await n.a.$rename(r,c,{overwrite:!1,...d})}catch(t){return E.e(t)}},async copy(r,c,d){try{return await n.a.$copy(r,c,{overwrite:!1,...d})}catch(t){return E.e(t)}},isWritableFileSystem(r){const c=i.getCapabilities(r);if(typeof c=="number")return!(c&2048)}})}async d(a,i,n){const r=[];for(;!i.isEqual(n,i.dirname(n));)try{if(!((await a.stat(n)).type&M.FileType.Directory))throw P.$kN.FileExists(`Unable to create folder '${n.scheme===l.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(c){if(M.$Vk(c)!==M.FileSystemProviderErrorCode.FileNotFound)throw c;r.push(i.basename(n)),n=i.dirname(n)}for(let c=r.length-1;c>=0;c--){n=i.joinPath(n,r[c]);try{await a.createDirectory(n)}catch(d){if(M.$Vk(d)!==M.FileSystemProviderErrorCode.FileExists)throw d}}}static e(a){if(a instanceof P.$kN)throw a;if(a instanceof M.$Rk)switch(a.code){case M.FileSystemProviderErrorCode.FileExists:throw P.$kN.FileExists(a.message);case M.FileSystemProviderErrorCode.FileNotFound:throw P.$kN.FileNotFound(a.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw P.$kN.FileNotADirectory(a.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw P.$kN.FileIsADirectory(a.message);case M.FileSystemProviderErrorCode.NoPermissions:throw P.$kN.NoPermissions(a.message);case M.FileSystemProviderErrorCode.Unavailable:throw P.$kN.Unavailable(a.message);default:throw new P.$kN(a.message,a.name)}if(!(a instanceof Error))throw new P.$kN(String(a));if(a.name==="ENOPRO"||a.message.includes("ENOPRO"))throw P.$kN.Unavailable(a.message);switch(a.name){case M.FileSystemProviderErrorCode.FileExists:throw P.$kN.FileExists(a.message);case M.FileSystemProviderErrorCode.FileNotFound:throw P.$kN.FileNotFound(a.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw P.$kN.FileNotADirectory(a.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw P.$kN.FileIsADirectory(a.message);case M.FileSystemProviderErrorCode.NoPermissions:throw P.$kN.NoPermissions(a.message);case M.FileSystemProviderErrorCode.Unavailable:throw P.$kN.Unavailable(a.message);default:throw new P.$kN(a.message,a.name)}}addFileSystemProvider(a,i,n){return this.b.set(a,{impl:i,extUri:n?.isCaseSensitive?D.$Ig:D.$Kg,isReadonly:!!n?.isReadonly}),(0,k.$Rc)(()=>this.b.delete(a))}getFileSystemProviderExtUri(a){return this.b.get(a)?.extUri??D.$Ig}};e.$gic=g,e.$gic=g=E=Ye([He(0,m.$lO),He(1,f.$Thc)],g),e.$hic=(0,R.$fi)("IExtHostConsumerFileSystem")}),define(Pe[245],Re([1,0,4,7]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kjc=void 0;class P{constructor(R){this.a=new Map,this.b=new Map,this.c=R.getProxy(S.$6L.MainThreadIssueReporter)}async $getIssueReporterUri(R,m){if(this.a.size===0)throw new Error("No issue request handlers registered");const f=this.a.get(R);if(!f)throw new Error("Issue request handler not found");const k=await f.handleIssueUrlRequest();if(!k)throw new Error("Issue request handler returned no result");return k}async $getIssueReporterData(R,m){if(this.b.size===0)throw new Error("No issue request handlers registered");const f=this.b.get(R);if(!f)throw new Error("Issue data provider not found");const k=await f.provideIssueData(m);if(!k)throw new Error("Issue data provider returned no result");return k}async $getIssueReporterTemplate(R,m){if(this.b.size===0)throw new Error("No issue request handlers registered");const f=this.b.get(R);if(!f)throw new Error("Issue data provider not found");const k=await f.provideIssueTemplate(m);if(!k)throw new Error("Issue template provider returned no result");return k}registerIssueUriRequestHandler(R,m){const f=R.identifier.value;return this.a.set(f,m),this.c.$registerIssueUriRequestHandler(f),new M.$8L(()=>{this.c.$unregisterIssueUriRequestHandler(f),this.a.delete(f)})}registerIssueDataProvider(R,m){const f=R.identifier.value;return this.b.set(f,m),this.c.$registerIssueDataProvider(f),new M.$8L(()=>{this.c.$unregisterIssueDataProvider(f),this.b.delete(f)})}}e.$kjc=P}),define(Pe[85],Re([1,0,3,27,13,63,2]),function(me,e,S,M,P,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jic=e.$iic=void 0,e.$iic=(0,S.$fi)("IExtensionStoragePaths");let m=class{constructor(k,O,D){this.d=O,this.f=D,this.a=k.workspace??void 0,this.b=k.environment,this.whenReady=this.h().then(l=>this.c=l)}async g(k){return R.URI.joinPath(this.b.workspaceStorageHome,k)}async h(){if(!this.a)return Promise.resolve(void 0);const k=this.a.id,O=await this.g(k);try{return await this.f.value.stat(O),this.d.trace("[ExtHostStorage] storage dir already exists",O),O}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",O),await this.f.value.createDirectory(O),await this.f.value.writeFile(R.URI.joinPath(O,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),O}catch(D){this.d.error("[ExtHostStorage]",D);return}}workspaceValue(k){if(this.c)return R.URI.joinPath(this.c,k.identifier.value)}globalValue(k){return R.URI.joinPath(this.b.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$jic=m,e.$jic=m=Ye([He(0,M.$BO),He(1,P.$zj),He(2,F.$hic)],m)}),define(Pe[246],Re([1,0,7,17,5]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Njc=void 0;let F=class{constructor(m){this.a=new S.$uN(S.ColorThemeKind.Dark),this.b=new P.$5d}get activeColorTheme(){return this.a}$onColorThemeChange(m){let f;switch(m){case"light":f=S.ColorThemeKind.Light;break;case"hcDark":f=S.ColorThemeKind.HighContrast;break;case"hcLight":f=S.ColorThemeKind.HighContrastLight;break;default:f=S.ColorThemeKind.Dark}this.a=new S.$uN(f),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Njc=F,e.$Njc=F=Ye([He(0,M.$lO)],F)}),define(Pe[86],Re([1,0,25,5,6,171,3,13,200,4,27,17,7]),function(me,e,S,M,P,F,R,m,f,k,O,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AAb=e.$zAb=e.TunnelDtoConverter=void 0;class E extends f.$Yv{}var g;(function(a){function i(r){return{remoteAddress:r.remoteAddress,localAddress:r.localAddress,public:!!r.public,privacy:r.privacy??(r.public?f.TunnelPrivacyId.Public:f.TunnelPrivacyId.Private),protocol:r.protocol}}a.fromApiTunnel=i;function n(r){return{remoteAddress:{host:r.tunnelRemoteHost,port:r.tunnelRemotePort},localAddress:r.localAddress,public:r.privacy!==f.TunnelPrivacyId.ConstantPrivate&&r.privacy!==f.TunnelPrivacyId.ConstantPrivate,privacy:r.privacy,protocol:r.protocol}}a.fromServiceTunnel=n})(g||(e.TunnelDtoConverter=g={})),e.$zAb=(0,R.$fi)("IExtHostTunnelService");let s=class extends P.$Tc{constructor(i,n,r){super(),this.s=r,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new M.$5d,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=i.getProxy(k.$6L.MainThreadTunnelService)}async openTunnel(i,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${i.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const r=await this.a.$openTunnel(n,i.displayName);if(r){const c=new E(r.remoteAddress,r.localAddress,()=>this.a.$closeTunnel(r.remoteAddress));return this.B(c),c}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(i,n){i.portRange===void 0&&i.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const r=this.u();return this.r.set(r,{selector:i,provider:n}),this.a.$registerPortsAttributesProvider(i,r),new l.$8L(()=>{this.r.delete(r),this.a.$unregisterPortsAttributesProvider(r)})}async $providePortAttributes(i,n,r,c,d){const t=[];for(const u of i){const o=this.r.get(u);if(!o)return[];t.push(...await Promise.all(n.map(async v=>{let b;try{b=await o.provider.providePortAttributes({port:v,pid:r,commandLine:c},d)}catch{b=await o.provider.providePortAttributes(v,r,c,d)}return{providedAttributes:b,port:v}})))}const p=t.filter(u=>!!u.providedAttributes);return p.length>0?p.map(u=>({autoForwardAction:u.providedAttributes.autoForwardAction,port:u.port})):[]}async $registerCandidateFinder(i){}registerTunnelProvider(i,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(c,d)=>await i.provideTunnel(c,d,S.CancellationToken.None)??void 0;const r=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions,protocol:n.tunnelFeatures.protocol===void 0?!0:n.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(r),Promise.resolve((0,P.$Rc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(i,n){if(i){i.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(i.candidatePortSource),i.showCandidatePort&&(this.f=i.showCandidatePort,this.a.$setCandidateFilter());const r=i.tunnelFactory??(n?this.w(n):void 0);if(r){this.b=r;let c=i.tunnelFeatures?.privacyOptions??[];i.tunnelFeatures?.public&&c.length===0&&(c=[{id:"private",label:F.localize(0,null),themeIcon:"lock"},{id:"public",label:F.localize(1,null),themeIcon:"eye"}]);const d=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,public:!!i.tunnelFeatures?.public,privacyOptions:c,protocol:!0}:void 0;this.a.$setTunnelProvider(d)}}else this.b=void 0;return(0,P.$Rc)(()=>{this.b=void 0})}w(i){}async $closeTunnel(i,n){if(this.g.has(i.host)){const r=this.g.get(i.host);r.has(i.port)&&(n&&r.get(i.port).disposeListener.dispose(),await r.get(i.port).tunnel.dispose(),r.delete(i.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(i,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const r=this.b(i,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),r!==void 0){const c=await r;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),c===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(i.remoteAddress.host)||this.g.set(i.remoteAddress.host,new Map);const d=this.B(c.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(c.remoteAddress))));return this.g.get(i.remoteAddress.host).set(i.remoteAddress.port,{tunnel:c,disposeListener:d}),g.fromApiTunnel(c)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(r){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),r instanceof Error)return r.message}}async $applyCandidateFilter(i){const n=await Promise.all(i.map(c=>this.f(c.host,c.port,c.detail??""))),r=i.filter((c,d)=>n[d]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${i.map(c=>c.port).join(", ")} to ${r.map(c=>c.port).join(", ")}`),r}};e.$AAb=s,e.$AAb=s=Ye([He(0,D.$lO),He(1,O.$BO),He(2,m.$zj)],s)}),define(Pe[8],Re([1,0,18,23,130,247,53,28,123,52,69,26,24,16,2,29,87,100,105,104,83,48,60,219,22,7]),function(me,e,S,M,P,F,R,m,f,k,O,D,l,E,g,s,a,i,n,r,c,d,t,p,u,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatAgentRequest=e.ChatResponseProgress=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$kO=e.$jO=e.MarkdownString=e.$iO=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0;var v;(function(we){function Le(Y){const{selectionStartLineNumber:Ee,selectionStartColumn:Ue,positionLineNumber:Qe,positionColumn:qe}=Y,ct=new o.$9L(Ee-1,Ue-1),bt=new o.$9L(Qe-1,qe-1);return new o.$$L(ct,bt)}we.to=Le;function ce(Y){const{anchor:Ee,active:Ue}=Y;return{selectionStartLineNumber:Ee.line+1,selectionStartColumn:Ee.character+1,positionLineNumber:Ue.line+1,positionColumn:Ue.character+1}}we.from=ce})(v||(e.Selection=v={}));var b;(function(we){function Le(Y){if(!Y)return;const{start:Ee,end:Ue}=Y;return{startLineNumber:Ee.line+1,startColumn:Ee.character+1,endLineNumber:Ue.line+1,endColumn:Ue.character+1}}we.from=Le;function ce(Y){if(!Y)return;const{startLineNumber:Ee,startColumn:Ue,endLineNumber:Qe,endColumn:qe}=Y;return new o.$0L(Ee-1,Ue-1,Qe-1,qe-1)}we.to=ce})(b||(e.Range=b={}));var $;(function(we){function Le(Y){return{uri:Y.uri,range:b.from(Y.range)}}we.from=Le;function ce(Y){return new o.$hM(g.URI.revive(Y.uri),b.to(Y.range))}we.to=ce})($||(e.Location=$={}));var I;(function(we){function Le(ce){switch(ce){case 1:return o.StandardTokenType.Comment;case 0:return o.StandardTokenType.Other;case 3:return o.StandardTokenType.RegEx;case 2:return o.StandardTokenType.String}}we.to=Le})(I||(e.TokenType=I={}));var h;(function(we){function Le(Y){return new o.$9L(Y.lineNumber-1,Y.column-1)}we.to=Le;function ce(Y){return{lineNumber:Y.line+1,column:Y.character+1}}we.from=ce})(h||(e.Position=h={}));var y;(function(we){function Le(Ee,Ue,Qe){return(0,S.$Hb)((0,S.$3b)(Ee).map(qe=>ce(qe,Ue,Qe)))}we.from=Le;function ce(Ee,Ue,Qe){if(typeof Ee=="string")return{$serialized:!0,language:Ee,isBuiltin:Qe?.isBuiltin};if(Ee)return{$serialized:!0,language:Ee.language,scheme:Y(Ee.scheme,Ue),pattern:Q.from(Ee.pattern)??void 0,exclusive:Ee.exclusive,notebookType:Ee.notebookType,isBuiltin:Qe?.isBuiltin}}function Y(Ee,Ue){return Ue&&typeof Ee=="string"?Ue.transformOutgoingScheme(Ee):Ee}})(y||(e.DocumentSelector=y={}));var w;(function(we){function Le(Y){switch(Y){case o.DiagnosticTag.Unnecessary:return 1;case o.DiagnosticTag.Deprecated:return 2}}we.from=Le;function ce(Y){switch(Y){case 1:return o.DiagnosticTag.Unnecessary;case 2:return o.DiagnosticTag.Deprecated;default:return}}we.to=ce})(w||(e.DiagnosticTag=w={}));var A;(function(we){function Le(Y){let Ee;return Y.code&&((0,E.$Sf)(Y.code)||(0,E.$Wf)(Y.code)?Ee=String(Y.code):Ee={value:String(Y.code.value),target:Y.code.target}),{...b.from(Y.range),message:Y.message,source:Y.source,code:Ee,severity:G.from(Y.severity),relatedInformation:Y.relatedInformation&&Y.relatedInformation.map(N.from),tags:Array.isArray(Y.tags)?(0,S.$Hb)(Y.tags.map(w.from)):void 0}}we.from=Le;function ce(Y){const Ee=new o.$jM(b.to(Y),Y.message,G.to(Y.severity));return Ee.source=Y.source,Ee.code=(0,E.$Sf)(Y.code)?Y.code:Y.code?.value,Ee.relatedInformation=Y.relatedInformation&&Y.relatedInformation.map(N.to),Ee.tags=Y.tags&&(0,S.$Hb)(Y.tags.map(w.to)),Ee}we.to=ce})(A||(e.Diagnostic=A={}));var N;(function(we){function Le(Y){return{...b.from(Y.location.range),message:Y.message,resource:Y.location.uri}}we.from=Le;function ce(Y){return new o.$iM(new o.$hM(Y.resource,b.to(Y)),Y.message)}we.to=ce})(N||(e.DiagnosticRelatedInformation=N={}));var G;(function(we){function Le(Y){switch(Y){case o.DiagnosticSeverity.Error:return i.MarkerSeverity.Error;case o.DiagnosticSeverity.Warning:return i.MarkerSeverity.Warning;case o.DiagnosticSeverity.Information:return i.MarkerSeverity.Info;case o.DiagnosticSeverity.Hint:return i.MarkerSeverity.Hint}return i.MarkerSeverity.Error}we.from=Le;function ce(Y){switch(Y){case i.MarkerSeverity.Info:return o.DiagnosticSeverity.Information;case i.MarkerSeverity.Warning:return o.DiagnosticSeverity.Warning;case i.MarkerSeverity.Error:return o.DiagnosticSeverity.Error;case i.MarkerSeverity.Hint:return o.DiagnosticSeverity.Hint;default:return o.DiagnosticSeverity.Error}}we.to=ce})(G||(e.DiagnosticSeverity=G={}));var V;(function(we){function Le(Y){return typeof Y=="number"&&Y>=o.ViewColumn.One?Y-1:Y===o.ViewColumn.Beside?p.$tD:p.$sD}we.from=Le;function ce(Y){if(typeof Y=="number"&&Y>=0)return Y+1;throw new Error("invalid 'EditorGroupColumn'")}we.to=ce})(V||(e.ViewColumn=V={}));function U(we){return typeof we.range<"u"}function C(we){return we.length===0?!0:!!U(we[0])}e.$iO=C;var L;(function(we){function Le(qe){return qe.map(we.from)}we.fromMany=Le;function ce(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function Y(qe){let ct;if(ce(qe)){const{language:At,value:kt}=qe;ct={value:"```"+At+`
`+kt+"\n```\n"}}else o.$wM.isMarkdownString(qe)?ct={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml,baseUri:qe.baseUri}:typeof qe=="string"?ct={value:qe}:ct={value:""};const bt=Object.create(null);ct.uris=bt;const Lt=At=>{try{let kt=g.URI.parse(At,!0);kt=kt.with({query:Ee(kt.query,bt)}),bt[At]=kt}catch{}return""},xt=new f.marked.Renderer;return xt.link=Lt,xt.image=At=>typeof At=="string"?Lt(R.$Ek(At).href):"",(0,f.marked)(ct.value,{renderer:xt}),ct}we.from=Y;function Ee(qe,ct){if(!qe)return qe;let bt;try{bt=(0,k.$Nh)(qe)}catch{}if(!bt)return qe;let Lt=!1;return bt=(0,D.$Mn)(bt,xt=>{if(g.URI.isUri(xt)){const At=`__uri_${Math.random().toString(16).slice(2,8)}`;return ct[At]=xt,Lt=!0,At}else return}),Lt?JSON.stringify(bt):qe}function Ue(qe){const ct=new o.$wM(qe.value,qe.supportThemeIcons);return ct.isTrusted=qe.isTrusted,ct.supportHtml=qe.supportHtml,ct.baseUri=qe.baseUri?g.URI.from(qe.baseUri):void 0,ct}we.to=Ue;function Qe(qe){if(qe)return typeof qe=="string"?qe:we.from(qe)}we.fromStrict=Qe})(L||(e.MarkdownString=L={}));function q(we){return C(we)?we.map(Le=>({range:b.from(Le.range),hoverMessage:Array.isArray(Le.hoverMessage)?L.fromMany(Le.hoverMessage):Le.hoverMessage?L.from(Le.hoverMessage):void 0,renderOptions:Le.renderOptions})):we.map(Le=>({range:b.from(Le)}))}e.$jO=q;function ne(we){return typeof we>"u"?we:typeof we=="string"?g.URI.file(we):we}e.$kO=ne;var ae;(function(we){function Le(ce){return typeof ce>"u"?ce:{contentText:ce.contentText,contentIconPath:ce.contentIconPath?ne(ce.contentIconPath):void 0,border:ce.border,borderColor:ce.borderColor,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,color:ce.color,backgroundColor:ce.backgroundColor,margin:ce.margin,width:ce.width,height:ce.height}}we.from=Le})(ae||(e.ThemableDecorationAttachmentRenderOptions=ae={}));var ye;(function(we){function Le(ce){return typeof ce>"u"?ce:{backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?ne(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?ae.from(ce.before):void 0,after:ce.after?ae.from(ce.after):void 0}}we.from=Le})(ye||(e.ThemableDecorationRenderOptions=ye={}));var Ie;(function(we){function Le(ce){if(typeof ce>"u")return ce;switch(ce){case o.DecorationRangeBehavior.OpenOpen:return 0;case o.DecorationRangeBehavior.ClosedClosed:return 1;case o.DecorationRangeBehavior.OpenClosed:return 2;case o.DecorationRangeBehavior.ClosedOpen:return 3}}we.from=Le})(Ie||(e.DecorationRangeBehavior=Ie={}));var ue;(function(we){function Le(ce){return{isWholeLine:ce.isWholeLine,rangeBehavior:ce.rangeBehavior?Ie.from(ce.rangeBehavior):void 0,overviewRulerLane:ce.overviewRulerLane,light:ce.light?ye.from(ce.light):void 0,dark:ce.dark?ye.from(ce.dark):void 0,backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?ne(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?ae.from(ce.before):void 0,after:ce.after?ae.from(ce.after):void 0}}we.from=Le})(ue||(e.DecorationRenderOptions=ue={}));var ve;(function(we){function Le(Y){return{text:Y.newText,eol:Y.newEol&&it.from(Y.newEol),range:b.from(Y.range)}}we.from=Le;function ce(Y){const Ee=new o.$cM(b.to(Y.range),Y.text);return Ee.newEol=typeof Y.eol>"u"?void 0:it.to(Y.eol),Ee}we.to=ce})(ve||(e.TextEdit=ve={}));var re;(function(we){function Le(Y,Ee){const Ue={edits:[]};if(Y instanceof o.$fM){const Qe=new m.$Bc;for(const qe of Y._allEntries())qe._type===1&&g.URI.isUri(qe.to)&&qe.from===void 0&&Qe.add(qe.to);for(const qe of Y._allEntries())if(qe._type===1){let ct;qe.options?.contents&&(ArrayBuffer.isView(qe.options.contents)?ct={type:"base64",value:(0,M.$Me)(M.$se.wrap(qe.options.contents))}:ct={type:"dataTransferItem",id:qe.options.contents._itemId}),Ue.edits.push({oldResource:qe.from,newResource:qe.to,options:{...qe.options,contents:ct},metadata:qe.metadata})}else qe._type===2?Ue.edits.push({resource:qe.uri,textEdit:ve.from(qe.edit),versionId:Qe.has(qe.uri)?void 0:Ee?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===6?Ue.edits.push({resource:qe.uri,textEdit:{range:b.from(qe.range),text:qe.edit.value,insertAsSnippet:!0},versionId:Qe.has(qe.uri)?void 0:Ee?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===3?Ue.edits.push({metadata:qe.metadata,resource:qe.uri,cellEdit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:Ee?.getNotebookDocumentVersion(qe.uri)}):qe._type===5&&Ue.edits.push({metadata:qe.metadata,resource:qe.uri,notebookVersionId:Ee?.getNotebookDocumentVersion(qe.uri),cellEdit:{editType:1,index:qe.index,count:qe.count,cells:qe.cells.map(Tt.from)}})}return Ue}we.from=Le;function ce(Y){const Ee=new o.$fM,Ue=new m.$Ac;for(const Qe of Y.edits)if(Qe.textEdit){const qe=Qe,ct=g.URI.revive(qe.resource),bt=b.to(qe.textEdit.range),Lt=qe.textEdit.text,xt=qe.textEdit.insertAsSnippet;let At;xt?At=o.$eM.replace(bt,new o.$gM(Lt)):At=o.$cM.replace(bt,Lt);const kt=Ue.get(ct);kt?kt.push(At):Ue.set(ct,[At])}else Ee.renameFile(g.URI.revive(Qe.oldResource),g.URI.revive(Qe.newResource),Qe.options);for(const[Qe,qe]of Ue)Ee.set(Qe,qe);return Ee}we.to=ce})(re||(e.WorkspaceEdit=re={}));var $e;(function(we){const Le=Object.create(null);Le[o.SymbolKind.File]=0,Le[o.SymbolKind.Module]=1,Le[o.SymbolKind.Namespace]=2,Le[o.SymbolKind.Package]=3,Le[o.SymbolKind.Class]=4,Le[o.SymbolKind.Method]=5,Le[o.SymbolKind.Property]=6,Le[o.SymbolKind.Field]=7,Le[o.SymbolKind.Constructor]=8,Le[o.SymbolKind.Enum]=9,Le[o.SymbolKind.Interface]=10,Le[o.SymbolKind.Function]=11,Le[o.SymbolKind.Variable]=12,Le[o.SymbolKind.Constant]=13,Le[o.SymbolKind.String]=14,Le[o.SymbolKind.Number]=15,Le[o.SymbolKind.Boolean]=16,Le[o.SymbolKind.Array]=17,Le[o.SymbolKind.Object]=18,Le[o.SymbolKind.Key]=19,Le[o.SymbolKind.Null]=20,Le[o.SymbolKind.EnumMember]=21,Le[o.SymbolKind.Struct]=22,Le[o.SymbolKind.Event]=23,Le[o.SymbolKind.Operator]=24,Le[o.SymbolKind.TypeParameter]=25;function ce(Ee){return typeof Le[Ee]=="number"?Le[Ee]:6}we.from=ce;function Y(Ee){for(const Ue in Le)if(Le[Ue]===Ee)return Number(Ue);return o.SymbolKind.Property}we.to=Y})($e||(e.SymbolKind=$e={}));var ie;(function(we){function Le(Y){switch(Y){case o.SymbolTag.Deprecated:return 1}}we.from=Le;function ce(Y){switch(Y){case 1:return o.SymbolTag.Deprecated}}we.to=ce})(ie||(e.SymbolTag=ie={}));var le;(function(we){function Le(Y){return{name:Y.name,kind:$e.from(Y.kind),tags:Y.tags&&Y.tags.map(ie.from),containerName:Y.containerName,location:De.from(Y.location)}}we.from=Le;function ce(Y){const Ee=new o.$nM(Y.name,$e.to(Y.kind),Y.containerName,De.to(Y.location));return Ee.tags=Y.tags&&Y.tags.map(ie.to),Ee}we.to=ce})(le||(e.WorkspaceSymbol=le={}));var W;(function(we){function Le(Y){const Ee={name:Y.name||"!!MISSING: name!!",detail:Y.detail,range:b.from(Y.range),selectionRange:b.from(Y.selectionRange),kind:$e.from(Y.kind),tags:Y.tags?.map(ie.from)??[]};return Y.children&&(Ee.children=Y.children.map(Le)),Ee}we.from=Le;function ce(Y){const Ee=new o.$oM(Y.name,Y.detail,$e.to(Y.kind),b.to(Y.range),b.to(Y.selectionRange));return(0,S.$Lb)(Y.tags)&&(Ee.tags=Y.tags.map(ie.to)),Y.children&&(Ee.children=Y.children.map(ce)),Ee}we.to=ce})(W||(e.DocumentSymbol=W={}));var _;(function(we){function Le(Y){const Ee=new o.$sM($e.to(Y.kind),Y.name,Y.detail||"",g.URI.revive(Y.uri),b.to(Y.range),b.to(Y.selectionRange));return Ee._sessionId=Y._sessionId,Ee._itemId=Y._itemId,Ee}we.to=Le;function ce(Y,Ee,Ue){if(Ee=Ee??Y._sessionId,Ue=Ue??Y._itemId,Ee===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Ee,_itemId:Ue,name:Y.name,detail:Y.detail,kind:$e.from(Y.kind),uri:Y.uri,range:b.from(Y.range),selectionRange:b.from(Y.selectionRange),tags:Y.tags?.map(ie.from)}}we.from=ce})(_||(e.CallHierarchyItem=_={}));var ke;(function(we){function Le(ce){return new o.$tM(_.to(ce.from),ce.fromRanges.map(Y=>b.to(Y)))}we.to=Le})(ke||(e.CallHierarchyIncomingCall=ke={}));var Ne;(function(we){function Le(ce){return new o.$uM(_.to(ce.to),ce.fromRanges.map(Y=>b.to(Y)))}we.to=Le})(Ne||(e.CallHierarchyOutgoingCall=Ne={}));var De;(function(we){function Le(Y){return{range:Y.range&&b.from(Y.range),uri:Y.uri}}we.from=Le;function ce(Y){return new o.$hM(g.URI.revive(Y.uri),b.to(Y.range))}we.to=ce})(De||(e.location=De={}));var be;(function(we){function Le(Y){const Ee=Y,Ue=Y;return{originSelectionRange:Ee.originSelectionRange?b.from(Ee.originSelectionRange):void 0,uri:Ee.targetUri?Ee.targetUri:Ue.uri,range:b.from(Ee.targetRange?Ee.targetRange:Ue.range),targetSelectionRange:Ee.targetSelectionRange?b.from(Ee.targetSelectionRange):void 0}}we.from=Le;function ce(Y){return{targetUri:g.URI.revive(Y.uri),targetRange:b.to(Y.range),targetSelectionRange:Y.targetSelectionRange?b.to(Y.targetSelectionRange):void 0,originSelectionRange:Y.originSelectionRange?b.to(Y.originSelectionRange):void 0}}we.to=ce})(be||(e.DefinitionLink=be={}));var ge;(function(we){function Le(Y){return{range:b.from(Y.range),contents:L.fromMany(Y.contents)}}we.from=Le;function ce(Y){return new o.$kM(Y.contents.map(L.to),b.to(Y.range))}we.to=ce})(ge||(e.Hover=ge={}));var J;(function(we){function Le(Y){return{range:b.from(Y.range),expression:Y.expression}}we.from=Le;function ce(Y){return new o.$eN(b.to(Y.range),Y.expression)}we.to=ce})(J||(e.EvaluatableExpression=J={}));var X;(function(we){function Le(Y){if(Y instanceof o.$fN)return{type:"text",range:b.from(Y.range),text:Y.text};if(Y instanceof o.$gN)return{type:"variable",range:b.from(Y.range),variableName:Y.variableName,caseSensitiveLookup:Y.caseSensitiveLookup};if(Y instanceof o.$hN)return{type:"expression",range:b.from(Y.range),expression:Y.expression};throw new Error("Unknown 'InlineValue' type")}we.from=Le;function ce(Y){switch(Y.type){case"text":return{range:b.to(Y.range),text:Y.text};case"variable":return{range:b.to(Y.range),variableName:Y.variableName,caseSensitiveLookup:Y.caseSensitiveLookup};case"expression":return{range:b.to(Y.range),expression:Y.expression}}}we.to=ce})(X||(e.InlineValue=X={}));var he;(function(we){function Le(Y){return{frameId:Y.frameId,stoppedLocation:b.from(Y.stoppedLocation)}}we.from=Le;function ce(Y){return new o.$iN(Y.frameId,b.to(Y.stoppedLocation))}we.to=ce})(he||(e.InlineValueContext=he={}));var fe;(function(we){function Le(Y){return{range:b.from(Y.range),kind:Y.kind}}we.from=Le;function ce(Y){return new o.$lM(b.to(Y.range),Y.kind)}we.to=ce})(fe||(e.DocumentHighlight=fe={}));var Fe;(function(we){function Le(Y){return{uri:Y.uri,highlights:Y.highlights.map(fe.from)}}we.from=Le;function ce(Y){return new o.$mM(g.URI.revive(Y.uri),Y.highlights.map(fe.to))}we.to=ce})(Fe||(e.MultiDocumentHighlight=Fe={}));var de;(function(we){function Le(ce){switch(ce){case 1:return o.CompletionTriggerKind.TriggerCharacter;case 2:return o.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return o.CompletionTriggerKind.Invoke}}we.to=Le})(de||(e.CompletionTriggerKind=de={}));var Ce;(function(we){function Le(ce){return{triggerKind:de.to(ce.triggerKind),triggerCharacter:ce.triggerCharacter}}we.to=Le})(Ce||(e.CompletionContext=Ce={}));var Ae;(function(we){function Le(Y){switch(Y){case o.CompletionItemTag.Deprecated:return 1}}we.from=Le;function ce(Y){switch(Y){case 1:return o.CompletionItemTag.Deprecated}}we.to=ce})(Ae||(e.CompletionItemTag=Ae={}));var je;(function(we){const Le=new Map([[o.CompletionItemKind.Method,0],[o.CompletionItemKind.Function,1],[o.CompletionItemKind.Constructor,2],[o.CompletionItemKind.Field,3],[o.CompletionItemKind.Variable,4],[o.CompletionItemKind.Class,5],[o.CompletionItemKind.Interface,7],[o.CompletionItemKind.Struct,6],[o.CompletionItemKind.Module,8],[o.CompletionItemKind.Property,9],[o.CompletionItemKind.Unit,12],[o.CompletionItemKind.Value,13],[o.CompletionItemKind.Constant,14],[o.CompletionItemKind.Enum,15],[o.CompletionItemKind.EnumMember,16],[o.CompletionItemKind.Keyword,17],[o.CompletionItemKind.Snippet,27],[o.CompletionItemKind.Text,18],[o.CompletionItemKind.Color,19],[o.CompletionItemKind.File,20],[o.CompletionItemKind.Reference,21],[o.CompletionItemKind.Folder,23],[o.CompletionItemKind.Event,10],[o.CompletionItemKind.Operator,11],[o.CompletionItemKind.TypeParameter,24],[o.CompletionItemKind.Issue,26],[o.CompletionItemKind.User,25]]);function ce(Ue){return Le.get(Ue)??9}we.from=ce;const Y=new Map([[0,o.CompletionItemKind.Method],[1,o.CompletionItemKind.Function],[2,o.CompletionItemKind.Constructor],[3,o.CompletionItemKind.Field],[4,o.CompletionItemKind.Variable],[5,o.CompletionItemKind.Class],[7,o.CompletionItemKind.Interface],[6,o.CompletionItemKind.Struct],[8,o.CompletionItemKind.Module],[9,o.CompletionItemKind.Property],[12,o.CompletionItemKind.Unit],[13,o.CompletionItemKind.Value],[14,o.CompletionItemKind.Constant],[15,o.CompletionItemKind.Enum],[16,o.CompletionItemKind.EnumMember],[17,o.CompletionItemKind.Keyword],[27,o.CompletionItemKind.Snippet],[18,o.CompletionItemKind.Text],[19,o.CompletionItemKind.Color],[20,o.CompletionItemKind.File],[21,o.CompletionItemKind.Reference],[23,o.CompletionItemKind.Folder],[10,o.CompletionItemKind.Event],[11,o.CompletionItemKind.Operator],[24,o.CompletionItemKind.TypeParameter],[25,o.CompletionItemKind.User],[26,o.CompletionItemKind.Issue]]);function Ee(Ue){return Y.get(Ue)??o.CompletionItemKind.Property}we.to=Ee})(je||(e.CompletionItemKind=je={}));var z;(function(we){function Le(ce,Y){const Ee=new o.$CM(ce.label);return Ee.insertText=ce.insertText,Ee.kind=je.to(ce.kind),Ee.tags=ce.tags?.map(Ae.to),Ee.detail=ce.detail,Ee.documentation=R.$yk(ce.documentation)?L.to(ce.documentation):ce.documentation,Ee.sortText=ce.sortText,Ee.filterText=ce.filterText,Ee.preselect=ce.preselect,Ee.commitCharacters=ce.commitCharacters,s.$9s.isIRange(ce.range)?Ee.range=b.to(ce.range):typeof ce.range=="object"&&(Ee.range={inserting:b.to(ce.range.insert),replacing:b.to(ce.range.replace)}),Ee.keepWhitespace=typeof ce.insertTextRules>"u"?!1:!!(ce.insertTextRules&1),typeof ce.insertTextRules<"u"&&ce.insertTextRules&4?Ee.insertText=new o.$gM(ce.insertText):(Ee.insertText=ce.insertText,Ee.textEdit=Ee.range instanceof o.$0L?new o.$cM(Ee.range,Ee.insertText):void 0),ce.additionalTextEdits&&ce.additionalTextEdits.length>0&&(Ee.additionalTextEdits=ce.additionalTextEdits.map(Ue=>ve.to(Ue))),Ee.command=Y&&ce.command?Y.fromInternal(ce.command):void 0,Ee}we.to=Le})(z||(e.CompletionItem=z={}));var j;(function(we){function Le(Y){if(typeof Y.label!="string"&&!Array.isArray(Y.label))throw new TypeError("Invalid label");return{label:Y.label,documentation:L.fromStrict(Y.documentation)}}we.from=Le;function ce(Y){return{label:Y.label,documentation:R.$yk(Y.documentation)?L.to(Y.documentation):Y.documentation}}we.to=ce})(j||(e.ParameterInformation=j={}));var K;(function(we){function Le(Y){return{label:Y.label,documentation:L.fromStrict(Y.documentation),parameters:Array.isArray(Y.parameters)?Y.parameters.map(j.from):[],activeParameter:Y.activeParameter}}we.from=Le;function ce(Y){return{label:Y.label,documentation:R.$yk(Y.documentation)?L.to(Y.documentation):Y.documentation,parameters:Array.isArray(Y.parameters)?Y.parameters.map(j.to):[],activeParameter:Y.activeParameter}}we.to=ce})(K||(e.SignatureInformation=K={}));var H;(function(we){function Le(Y){return{activeSignature:Y.activeSignature,activeParameter:Y.activeParameter,signatures:Array.isArray(Y.signatures)?Y.signatures.map(K.from):[]}}we.from=Le;function ce(Y){return{activeSignature:Y.activeSignature,activeParameter:Y.activeParameter,signatures:Array.isArray(Y.signatures)?Y.signatures.map(K.to):[]}}we.to=ce})(H||(e.SignatureHelp=H={}));var ee;(function(we){function Le(ce,Y){const Ee=new o.$BM(h.to(Y.position),typeof Y.label=="string"?Y.label:Y.label.map(se.to.bind(void 0,ce)),Y.kind&&Oe.to(Y.kind));return Ee.textEdits=Y.textEdits&&Y.textEdits.map(ve.to),Ee.tooltip=R.$yk(Y.tooltip)?L.to(Y.tooltip):Y.tooltip,Ee.paddingLeft=Y.paddingLeft,Ee.paddingRight=Y.paddingRight,Ee}we.to=Le})(ee||(e.InlayHint=ee={}));var se;(function(we){function Le(ce,Y){const Ee=new o.$AM(Y.label);return Ee.tooltip=R.$yk(Y.tooltip)?L.to(Y.tooltip):Y.tooltip,a.Command.is(Y.command)&&(Ee.command=ce.fromInternal(Y.command)),Y.location&&(Ee.location=De.to(Y.location)),Ee}we.to=Le})(se||(e.InlayHintLabelPart=se={}));var Oe;(function(we){function Le(Y){return Y}we.from=Le;function ce(Y){return Y}we.to=ce})(Oe||(e.InlayHintKind=Oe={}));var We;(function(we){function Le(Y){return{range:b.from(Y.range),url:Y.target,tooltip:Y.tooltip}}we.from=Le;function ce(Y){let Ee;if(Y.url)try{Ee=typeof Y.url=="string"?g.URI.parse(Y.url,!0):g.URI.revive(Y.url)}catch{}return new o.$HM(b.to(Y.range),Ee)}we.to=ce})(We||(e.DocumentLink=We={}));var Ke;(function(we){function Le(Y){const Ee=new o.$KM(Y.label);return Y.textEdit&&(Ee.textEdit=ve.to(Y.textEdit)),Y.additionalTextEdits&&(Ee.additionalTextEdits=Y.additionalTextEdits.map(Ue=>ve.to(Ue))),Ee}we.to=Le;function ce(Y){return{label:Y.label,textEdit:Y.textEdit?ve.from(Y.textEdit):void 0,additionalTextEdits:Y.additionalTextEdits?Y.additionalTextEdits.map(Ee=>ve.from(Ee)):void 0}}we.from=ce})(Ke||(e.ColorPresentation=Ke={}));var xe;(function(we){function Le(Y){return new o.$IM(Y[0],Y[1],Y[2],Y[3])}we.to=Le;function ce(Y){return[Y.red,Y.green,Y.blue,Y.alpha]}we.from=ce})(xe||(e.Color=xe={}));var tt;(function(we){function Le(Y){return{range:b.from(Y.range)}}we.from=Le;function ce(Y){return new o.$rM(b.to(Y.range))}we.to=ce})(tt||(e.SelectionRange=tt={}));var lt;(function(we){function Le(ce){switch(ce){case 2:return o.TextDocumentSaveReason.AfterDelay;case 1:return o.TextDocumentSaveReason.Manual;case 3:case 4:return o.TextDocumentSaveReason.FocusOut}}we.to=Le})(lt||(e.TextDocumentSaveReason=lt={}));var rt;(function(we){function Le(Y){switch(Y){case o.TextEditorLineNumbersStyle.Off:return 0;case o.TextEditorLineNumbersStyle.Relative:return 2;case o.TextEditorLineNumbersStyle.Interval:return 3;case o.TextEditorLineNumbersStyle.On:default:return 1}}we.from=Le;function ce(Y){switch(Y){case 0:return o.TextEditorLineNumbersStyle.Off;case 2:return o.TextEditorLineNumbersStyle.Relative;case 3:return o.TextEditorLineNumbersStyle.Interval;case 1:default:return o.TextEditorLineNumbersStyle.On}}we.to=ce})(rt||(e.TextEditorLineNumbersStyle=rt={}));var it;(function(we){function Le(Y){if(Y===o.EndOfLine.CRLF)return 1;if(Y===o.EndOfLine.LF)return 0}we.from=Le;function ce(Y){if(Y===1)return o.EndOfLine.CRLF;if(Y===0)return o.EndOfLine.LF}we.to=ce})(it||(e.EndOfLine=it={}));var at;(function(we){function Le(ce){if(typeof ce=="object")return ce.viewId;switch(ce){case o.ProgressLocation.SourceControl:return 3;case o.ProgressLocation.Window:return 10;case o.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}we.from=Le})(at||(e.ProgressLocation=at={}));var Be;(function(we){function Le(Y){const Ee={start:Y.start+1,end:Y.end+1};return Y.kind&&(Ee.kind=et.from(Y.kind)),Ee}we.from=Le;function ce(Y){const Ee={start:Y.start-1,end:Y.end-1};return Y.kind&&(Ee.kind=et.to(Y.kind)),Ee}we.to=ce})(Be||(e.FoldingRange=Be={}));var et;(function(we){function Le(Y){if(Y)switch(Y){case o.FoldingRangeKind.Comment:return a.$Zt.Comment;case o.FoldingRangeKind.Imports:return a.$Zt.Imports;case o.FoldingRangeKind.Region:return a.$Zt.Region}}we.from=Le;function ce(Y){if(Y)switch(Y.value){case a.$Zt.Comment.value:return o.FoldingRangeKind.Comment;case a.$Zt.Imports.value:return o.FoldingRangeKind.Imports;case a.$Zt.Region.value:return o.FoldingRangeKind.Region}}we.to=ce})(et||(e.FoldingRangeKind=et={}));var Z;(function(we){function Le(ce){if(ce)return{pinned:typeof ce.preview=="boolean"?!ce.preview:void 0,inactive:ce.background,preserveFocus:ce.preserveFocus,selection:typeof ce.selection=="object"?b.from(ce.selection):void 0,override:typeof ce.override=="boolean"?r.$VE.id:void 0}}we.from=Le})(Z||(e.TextEditorOpenOptions=Z={}));var Q;(function(we){function Le(Ue){return Ue instanceof o.$5M?Ue.toJSON():typeof Ue=="string"?Ue:ce(Ue)||Y(Ue)?new o.$5M(Ue.baseUri??Ue.base,Ue.pattern).toJSON():Ue}we.from=Le;function ce(Ue){const Qe=Ue;return Qe?g.URI.isUri(Qe.baseUri)&&typeof Qe.pattern=="string":!1}function Y(Ue){const Qe=Ue;return Qe?typeof Qe.base=="string"&&typeof Qe.pattern=="string":!1}function Ee(Ue){return typeof Ue=="string"?Ue:new o.$5M(g.URI.revive(Ue.baseUri),Ue.pattern)}we.to=Ee})(Q||(e.GlobPattern=Q={}));var pe;(function(we){function Le(ce){if(ce){if(Array.isArray(ce))return ce.map(Le);if(typeof ce=="string")return ce;{const Y=ce;return{language:Y.language,scheme:Y.scheme,pattern:Q.from(Y.pattern),exclusive:Y.exclusive,notebookType:Y.notebookType}}}else return}we.from=Le})(pe||(e.LanguageSelector=pe={}));var Ve;(function(we){function Le(Y){return!!Y&&typeof Y=="object"&&"documents"in Y&&Array.isArray(Y.documents)&&Y.documents.every(Ee=>Array.isArray(Ee)&&Ee.every(Ue=>Ue&&typeof Ue=="object"&&"uri"in Ue&&g.URI.isUri(Ue.uri)&&"version"in Ue&&typeof Ue.version=="number"&&"ranges"in Ue&&Array.isArray(Ue.ranges)&&Ue.ranges.every(Qe=>Qe instanceof o.$0L)))}we.is=Le;function ce(Y){return{documents:Y.documents.map(Ee=>Ee.map(Ue=>({uri:g.URI.from(Ue.uri),version:Ue.version,ranges:Ue.ranges.map(Qe=>b.from(Qe))})))}}we.from=ce})(Ve||(e.MappedEditsContext=Ve={}));var Ze;(function(we){function Le(Y){return{start:Y.start,end:Y.end}}we.from=Le;function ce(Y){return new o.$vN(Y.start,Y.end)}we.to=ce})(Ze||(e.NotebookRange=Ze={}));var st;(function(we){function Le(Y){return{timing:typeof Y.runStartTime=="number"&&typeof Y.runEndTime=="number"?{startTime:Y.runStartTime,endTime:Y.runEndTime}:void 0,executionOrder:Y.executionOrder,success:Y.lastRunSuccess}}we.to=Le;function ce(Y){return{lastRunSuccess:Y.success,runStartTime:Y.timing?.startTime,runEndTime:Y.timing?.endTime,executionOrder:Y.executionOrder}}we.from=ce})(st||(e.NotebookCellExecutionSummary=st={}));var Me;(function(we){function Le(ce){if(ce===c.NotebookCellExecutionState.Unconfirmed)return o.NotebookCellExecutionState.Pending;if(ce===c.NotebookCellExecutionState.Pending)return;if(ce===c.NotebookCellExecutionState.Executing)return o.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ce}`)}we.to=Le})(Me||(e.NotebookCellExecutionState=Me={}));var Dt;(function(we){function Le(Y){switch(Y){case o.NotebookCellKind.Markup:return c.CellKind.Markup;case o.NotebookCellKind.Code:default:return c.CellKind.Code}}we.from=Le;function ce(Y){switch(Y){case c.CellKind.Markup:return o.NotebookCellKind.Markup;case c.CellKind.Code:default:return o.NotebookCellKind.Code}}we.to=ce})(Dt||(e.NotebookCellKind=Dt={}));var Kt;(function(we){function Le(Y){const Ee={metadata:Y.metadata??Object.create(null),cells:[]};for(const Ue of Y.cells)o.$wN.validate(Ue),Ee.cells.push(Tt.from(Ue));return Ee}we.from=Le;function ce(Y){const Ee=new o.$xN(Y.cells.map(Tt.to));return(0,E.$6f)(Y.metadata)||(Ee.metadata=Y.metadata),Ee}we.to=ce})(Kt||(e.NotebookData=Kt={}));var Tt;(function(we){function Le(Y){return{cellKind:Dt.from(Y.kind),language:Y.languageId,mime:Y.mime,source:Y.value,metadata:Y.metadata,internalMetadata:st.from(Y.executionSummary??{}),outputs:Y.outputs?Y.outputs.map(Zt.from):[]}}we.from=Le;function ce(Y){return new o.$wN(Dt.to(Y.cellKind),Y.source,Y.language,Y.mime,Y.outputs?Y.outputs.map(Zt.to):void 0,Y.metadata,Y.internalMetadata?st.to(Y.internalMetadata):void 0)}we.to=ce})(Tt||(e.NotebookCellData=Tt={}));var Qt;(function(we){function Le(Y){return{mime:Y.mime,valueBytes:M.$se.wrap(Y.data)}}we.from=Le;function ce(Y){return new o.$yN(Y.valueBytes.buffer,Y.mime)}we.to=ce})(Qt||(e.NotebookCellOutputItem=Qt={}));var Zt;(function(we){function Le(Y){return{outputId:Y.id,items:Y.items.map(Qt.from),metadata:Y.metadata}}we.from=Le;function ce(Y){const Ee=Y.items.map(Qt.to);return new o.$zN(Ee,Y.outputId,Y.metadata)}we.to=ce})(Zt||(e.NotebookCellOutput=Zt={}));var St;(function(we){function Le(Ee){return Y(Ee)?{include:Q.from(Ee.include)??void 0,exclude:Q.from(Ee.exclude)??void 0}:Q.from(Ee)??void 0}we.from=Le;function ce(Ee){return Y(Ee)?{include:Q.to(Ee.include),exclude:Q.to(Ee.exclude)}:Q.to(Ee)}we.to=ce;function Y(Ee){const Ue=Ee;return Ue?!(0,E.$2f)(Ue.include)&&!(0,E.$2f)(Ue.exclude):!1}})(St||(e.NotebookExclusiveDocumentPattern=St={}));var Jt;(function(we){function Le(ce,Y,Ee){const Ue=typeof ce.command=="string"?{title:"",command:ce.command}:ce.command;return{alignment:ce.alignment===o.NotebookCellStatusBarAlignment.Left?1:2,command:Y.toInternal(Ue,Ee),text:ce.text,tooltip:ce.tooltip,accessibilityInformation:ce.accessibilityInformation,priority:ce.priority}}we.from=Le})(Jt||(e.NotebookStatusBarItem=Jt={}));var Gt;(function(we){function Le(ce,Y,Ee){const Ue=typeof ce.command=="string"?{title:"",command:ce.command}:ce.command;return{command:Y.toInternal(Ue,Ee),label:ce.label,description:ce.description,detail:ce.detail,documentation:ce.documentation}}we.from=Le})(Gt||(e.NotebookKernelSourceAction=Gt={}));var _t;(function(we){function Le(ce){return{transientOutputs:ce?.transientOutputs??!1,transientCellMetadata:ce?.transientCellMetadata??{},transientDocumentMetadata:ce?.transientDocumentMetadata??{},cellContentMetadata:ce?.cellContentMetadata??{}}}we.from=Le})(_t||(e.NotebookDocumentContentOptions=_t={}));var ni;(function(we){function Le(Y){return{uri:Y.uri,provides:Y.provides}}we.from=Le;function ce(Y){return new o.$BN(g.URI.revive(Y.uri),Y.provides)}we.to=ce})(ni||(e.NotebookRendererScript=ni={}));var Xe;(function(we){function Le(Y){return{message:L.fromStrict(Y.message)||"",type:0,expected:Y.expectedOutput,actual:Y.actualOutput,contextValue:Y.contextValue,location:Y.location&&{range:b.from(Y.location.range),uri:Y.location.uri}}}we.from=Le;function ce(Y){const Ee=new o.$HN(typeof Y.message=="string"?Y.message:L.to(Y.message));return Ee.actualOutput=Y.actual,Ee.expectedOutput=Y.expected,Ee.contextValue=Y.contextValue,Ee.location=Y.location?De.to(Y.location):void 0,Ee}we.to=ce})(Xe||(e.TestMessage=Xe={}));var jt;(function(we){we.namespace=t.$1K,we.denamespace=t.$2K})(jt||(e.TestTag=jt={}));var ei;(function(we){function Le(Y){const Ee=(0,n.$hO)(Y).controllerId;return{extId:d.$WK.fromExtHostTestItem(Y,Ee).toString(),label:Y.label,uri:g.URI.revive(Y.uri),busy:Y.busy,tags:Y.tags.map(Ue=>jt.namespace(Ee,Ue.id)),range:s.$9s.lift(b.from(Y.range)),description:Y.description||null,sortText:Y.sortText||null,error:Y.error&&L.fromStrict(Y.error)||null}}we.from=Le;function ce(Y){return{parent:void 0,error:void 0,id:d.$WK.fromString(Y.extId).localId,label:Y.label,uri:g.URI.revive(Y.uri),tags:(Y.tags||[]).map(Ee=>{const{tagId:Ue}=jt.denamespace(Ee);return new o.$IN(Ue)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:b.to(Y.range||void 0),canResolveChildren:!1,busy:Y.busy,description:Y.description||void 0,sortText:Y.sortText||void 0}}we.toPlain=ce})(ei||(e.TestItem=ei={})),function(we){function Le(Y){return{id:Y.id}}we.from=Le;function ce(Y){return new o.$IN(Y.id)}we.to=ce}(jt||(e.TestTag=jt={}));var dt;(function(we){const Le=(Y,Ee)=>{const Ue=[];for(const[qe,ct]of Ee)d.$WK.compare(ct.item.extId,qe)===2&&(Ee.delete(qe),Ue.push(ct));const Qe={...ei.toPlain(Y.item),parent:void 0,taskStates:Y.tasks.map(qe=>({state:qe.state,duration:qe.duration,messages:qe.messages.filter(ct=>ct.type===0).map(Xe.to)})),children:Ue.map(qe=>Le(qe,Ee))};for(const qe of Qe.children)qe.parent=Qe;return Qe};function ce(Y){const Ee=[],Ue=new Map;for(const Qe of Y.items){Ue.set(Qe.item.extId,Qe);const qe=d.$WK.root(Qe.item.extId);Y.request.targets.some(ct=>ct.controllerId===qe&&ct.testIds.includes(Qe.item.extId))&&Ee.push(Qe)}return{completedAt:Y.completedAt,results:Ee.map(Qe=>Le(Qe,Ue))}}we.to=ce})(dt||(e.TestResults=dt={}));var pt;(function(we){function Le(Ue){return{covered:Ue.covered,total:Ue.total}}function ce(Ue){return"line"in Ue?h.from(Ue):b.from(Ue)}function Y(Ue){return"branches"in Ue?{count:Ue.executed,location:ce(Ue.location),type:1,branches:Ue.branches.length?Ue.branches.map(Qe=>({count:Qe.executed,location:Qe.location&&ce(Qe.location),label:Qe.label})):void 0}:{type:0,name:Ue.name,count:Ue.executed,location:ce(Ue.location)}}we.fromDetailed=Y;function Ee(Ue){return{uri:Ue.uri,statement:Le(Ue.statementCoverage),branch:Ue.branchCoverage&&Le(Ue.branchCoverage),declaration:Ue.declarationCoverage&&Le(Ue.declarationCoverage),details:Ue.detailedCoverage?.map(Y)}}we.fromFile=Ee})(pt||(e.TestCoverage=pt={}));var ti;(function(we){function Le(ce){switch(ce){case 1:return o.CodeActionTriggerKind.Invoke;case 2:return o.CodeActionTriggerKind.Automatic}}we.to=Le})(ti||(e.CodeActionTriggerKind=ti={}));var Vt;(function(we){function Le(Y){const Ee=new o.$ON($e.to(Y.kind),Y.name,Y.detail||"",g.URI.revive(Y.uri),b.to(Y.range),b.to(Y.selectionRange));return Ee._sessionId=Y._sessionId,Ee._itemId=Y._itemId,Ee}we.to=Le;function ce(Y,Ee,Ue){if(Ee=Ee??Y._sessionId,Ue=Ue??Y._itemId,Ee===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Ee,_itemId:Ue,kind:$e.from(Y.kind),name:Y.name,detail:Y.detail??"",uri:Y.uri,range:b.from(Y.range),selectionRange:b.from(Y.selectionRange),tags:Y.tags?.map(ie.from)}}we.from=ce})(Vt||(e.TypeHierarchyItem=Vt={}));var zt;(function(we){function Le(ce){if(ce)return{value:ce.value,tooltip:ce.tooltip}}we.from=Le})(zt||(e.ViewBadge=zt={}));var ft;(function(we){function Le(Ue,Qe,qe){const ct=Qe.fileData;return ct?new o.$XM(new o.$YM(ct.name,g.URI.revive(ct.uri),ct.id,(0,F.$db)(()=>qe(ct.id)))):Ue===O.$ts.uriList&&Qe.uriListData?new o.$WM(Ee(Qe.uriListData)):new o.$WM(Qe.asString)}we.to=Le;async function ce(Ue,Qe){const qe=await Qe.asString();if(Ue===O.$ts.uriList)return{asString:qe,fileData:void 0,uriListData:Y(qe)};const ct=Qe.asFile();return{asString:qe,fileData:ct?{name:ct.name,uri:ct.uri,id:ct._itemId??ct.id}:void 0}}we.from=ce;function Y(Ue){return P.$Ft.split(Ue).map(Qe=>{if(Qe.startsWith("#"))return Qe;try{return g.URI.parse(Qe)}catch{}return Qe})}function Ee(Ue){return P.$Ft.create(Ue.map(Qe=>typeof Qe=="string"?Qe:g.URI.revive(Qe)))}})(ft||(e.DataTransferItem=ft={}));var Pt;(function(we){function Le(Y,Ee){const Ue=Y.items.map(([Qe,qe])=>[Qe,ft.to(Qe,qe,Ee)]);return new o.$ZM(Ue)}we.toDataTransfer=Le;async function ce(Y){const Ee={items:[]},Ue=[];for(const[Qe,qe]of Y)Ue.push((async()=>{Ee.items.push([Qe,await ft.from(Qe,qe)])})());return await Promise.all(Ue),Ee}we.from=ce})(Pt||(e.DataTransfer=Pt={}));var ii;(function(we){function Le(Y,Ee){return{kind:"reply",agentId:Y.participant??Ee?.agentId??"",subCommand:Y.command??Ee?.command,message:Y.prompt,title:Y.label}}we.from=Le;function ce(Y){return{prompt:Y.message,label:Y.title,participant:Y.agentId,command:Y.subCommand}}we.to=ce})(ii||(e.ChatFollowup=ii={}));var Xt;(function(we){function Le(ce){return"commandId"in ce?{kind:"command",title:ce.title??"",commandId:ce.commandId??"",when:ce.when??"",args:ce.args}:{kind:"reply",message:ce.message,title:ce.title,tooltip:ce.tooltip}}we.from=Le})(Xt||(e.ChatInlineFollowup=Xt={}));var Je;(function(we){function Le(Y){switch(Y.role){case 0:return new o.$9N(Y.content);case 1:return new o.$0N(Y.content);case 2:return new o.$$N(Y.content)}}we.to=Le;function ce(Y){if(Y instanceof o.$9N)return{role:0,content:Y.content};if(Y instanceof o.$0N)return{role:1,content:Y.content};if(Y instanceof o.$$N)return{role:2,content:Y.content};throw new Error("Invalid LanguageModelMessage")}we.from=ce})(Je||(e.LanguageModelMessage=Je={}));var Rt;(function(we){function Le(Ee){const Ue={};for(const Qe of Object.keys(Ee))Ue[Qe]=Ee[Qe].map(we.to);return Ue}we.objectTo=Le;function ce(Ee){return{level:Ut.to(Ee.level),kind:Ee.kind,value:(0,g.$vc)(Ee.value)?g.URI.revive(Ee.value):Ee.value,description:Ee.description}}we.to=ce;function Y(Ee){return{level:Ut.from(Ee.level),kind:Ee.kind,value:Ee.value,description:Ee.description}}we.from=Y})(Rt||(e.ChatVariable=Rt={}));var Ut;(function(we){function Le(Y){switch(Y){case"short":return o.ChatVariableLevel.Short;case"medium":return o.ChatVariableLevel.Medium;case"full":default:return o.ChatVariableLevel.Full}}we.to=Le;function ce(Y){switch(Y){case o.ChatVariableLevel.Short:return"short";case o.ChatVariableLevel.Medium:return"medium";case o.ChatVariableLevel.Full:default:return"full"}}we.from=ce})(Ut||(e.ChatVariableLevel=Ut={}));var ri;(function(we){function Le(ce){switch(ce){case 1:return o.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return o.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return o.InteractiveEditorResponseFeedbackKind.Undone;case 3:return o.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return o.InteractiveEditorResponseFeedbackKind.Bug}}we.to=Le})(ri||(e.InteractiveEditorResponseFeedbackKind=ri={}));var gt;(function(we){function Le(Y){return{kind:"markdownContent",content:L.from(Y.value)}}we.to=Le;function ce(Y){return new o.$1N(L.to(Y.content))}we.from=ce})(gt||(e.ChatResponseMarkdownPart=gt={}));var Mt;(function(we){function Le(Y){const{value:Ee,baseUri:Ue}=Y;function Qe(qe,ct){return qe.map(bt=>{const Lt=g.URI.joinPath(ct,bt.name);return{label:bt.name,uri:Lt,children:bt.children&&Qe(bt.children,Lt)}})}return{kind:"treeData",treeData:{label:(0,l.$Pg)(Ue),uri:Ue,children:Qe(Ee,Ue)}}}we.to=Le;function ce(Y){const Ee=(0,k.$Oh)(Y.treeData);function Ue(ct){return ct.map(bt=>({name:bt.label,children:bt.children&&Ue(bt.children)}))}const Qe=Ee.uri,qe=Ee.children?Ue(Ee.children):[];return new o.$2N(qe,Qe)}we.from=ce})(Mt||(e.ChatResponseFilesPart=Mt={}));var Ct;(function(we){function Le(Y){return{kind:"inlineReference",name:Y.title,inlineReference:g.URI.isUri(Y.value)?Y.value:$.from(Y.value)}}we.to=Le;function ce(Y){const Ee=(0,k.$Oh)(Y);return new o.$3N(g.URI.isUri(Ee.inlineReference)?Ee.inlineReference:$.to(Ee.inlineReference),Y.name)}we.from=ce})(Ct||(e.ChatResponseAnchorPart=Ct={}));var Bt;(function(we){function Le(Y){return{kind:"progressMessage",content:L.from(Y.value)}}we.to=Le;function ce(Y){return new o.$4N(Y.content.value)}we.from=ce})(Bt||(e.ChatResponseProgressPart=Bt={}));var si;(function(we){function Le(Y,Ee,Ue){return{kind:"command",command:Ee.toInternal(Y.value,Ue)??{command:Y.value.command,title:Y.value.title}}}we.to=Le;function ce(Y,Ee){return new o.$5N(Ee.fromInternal(Y.command)??{command:Y.command.id,title:Y.command.title})}we.from=ce})(si||(e.ChatResponseCommandButtonPart=si={}));var Nt;(function(we){function Le(Y){return{kind:"reference",reference:g.URI.isUri(Y.value)?Y.value:$.from(Y.value)}}we.to=Le;function ce(Y){const Ee=(0,k.$Oh)(Y);return new o.$6N(g.URI.isUri(Ee.reference)?Ee.reference:$.to(Ee.reference))}we.from=ce})(Nt||(e.ChatResponseReferencePart=Nt={}));var qt;(function(we){function Le(Ee){return Ee instanceof o.$1N?gt.to(Ee):Ee instanceof o.$3N?Ct.to(Ee):Ee instanceof o.$6N?Nt.to(Ee):Ee instanceof o.$4N?Bt.to(Ee):Ee instanceof o.$2N?Mt.to(Ee):{kind:"content",content:""}}we.to=Le;function ce(Ee,Ue){switch(Ee.kind){case"reference":return Nt.from(Ee);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return Y(Ee,Ue)}}we.from=ce;function Y(Ee,Ue){switch(Ee.kind){case"markdownContent":return gt.from(Ee);case"inlineReference":return Ct.from(Ee);case"progressMessage":return;case"treeData":return Mt.from(Ee);case"command":return si.from(Ee,Ue)}}we.fromContent=Y})(qt||(e.ChatResponsePart=qt={}));var yt;(function(we){function Le(Ee,Ue){return"markdownContent"in Ue?((0,u.$YF)(Ee,"chatParticipantAdditions"),{content:L.from(Ue.markdownContent),kind:"markdownContent"}):"content"in Ue?"vulnerabilities"in Ue&&Ue.vulnerabilities?((0,u.$YF)(Ee,"chatParticipantAdditions"),{content:Ue.content,vulnerabilities:Ue.vulnerabilities,kind:"vulnerability"}):typeof Ue.content=="string"?{content:Ue.content,kind:"content"}:((0,u.$YF)(Ee,"chatParticipantAdditions"),{content:L.from(Ue.content),kind:"markdownContent"}):"documents"in Ue?{documents:Ue.documents.map(Qe=>({uri:Qe.uri,version:Qe.version,ranges:Qe.ranges.map(qe=>b.from(qe))})),kind:"usedContext"}:"reference"in Ue?{reference:"uri"in Ue.reference?{uri:Ue.reference.uri,range:b.from(Ue.reference.range)}:Ue.reference,kind:"reference"}:"inlineReference"in Ue?{inlineReference:"uri"in Ue.inlineReference?{uri:Ue.inlineReference.uri,range:b.from(Ue.inlineReference.range)}:Ue.inlineReference,name:Ue.title,kind:"inlineReference"}:"participant"in Ue?((0,u.$YF)(Ee,"chatParticipantAdditions"),{agentName:Ue.participant,command:Ue.command,kind:"agentDetection"}):"message"in Ue?{content:L.from(Ue.message),kind:"progressMessage"}:void 0}we.from=Le;function ce(Ee){switch(Ee.kind){case"markdownContent":case"inlineReference":case"treeData":return we.to(Ee);case"content":return{content:Ee.content};case"usedContext":return{documents:Ee.documents.map(Ue=>({uri:g.URI.revive(Ue.uri),version:Ue.version,ranges:Ue.ranges.map(Qe=>b.to(Qe))}))};case"reference":return{reference:(0,g.$vc)(Ee.reference)?g.URI.revive(Ee.reference):$.to(Ee.reference)};case"agentDetection":return;case"progressMessage":return{message:Ee.content.value};case"vulnerability":return{content:Ee.content,vulnerabilities:Ee.vulnerabilities};default:return}}we.to=ce;function Y(Ee,Ue){switch(Ee.kind){case"markdownContent":return{content:Ee.content.value};case"inlineReference":return{inlineReference:(0,g.$vc)(Ee.inlineReference)?g.URI.revive(Ee.inlineReference):$.to(Ee.inlineReference),title:Ee.name};case"command":return{command:Ue.fromInternal(Ee.command)??{command:Ee.command.id,title:Ee.command.title}};default:return}}we.toProgressContent=Y})(yt||(e.ChatResponseProgress=yt={}));var Ft;(function(we){function Le(ce){return{prompt:ce.message,command:ce.command,variables:ce.variables.variables.map(Yt.to)}}we.to=Le})(Ft||(e.ChatAgentRequest=Ft={}));var Yt;(function(we){function Le(ce){return{name:ce.name,range:[ce.range.start,ce.range.endExclusive],values:ce.values.map(Rt.to)}}we.to=Le})(Yt||(e.ChatAgentResolvedVariable=Yt={}));var Wt;(function(we){function Le(ce){return{label:ce.label,values:ce.values.map(Rt.from),insertText:ce.insertText,detail:ce.detail,documentation:ce.documentation}}we.from=Le})(Wt||(e.ChatAgentCompletionItem=Wt={}));var wt;(function(we){function Le(ce){return{errorDetails:ce.errorDetails,metadata:ce.metadata}}we.to=Le})(wt||(e.ChatAgentResult=wt={}));var It;(function(we){function Le(ce,Y,Ee){if(Y.action.kind==="vote")return;const Ue=wt.to(ce);return Y.action.kind==="command"?{action:{kind:"command",commandButton:yt.toProgressContent(Y.action.commandButton,Ee)},result:Ue}:Y.action.kind==="followUp"?{action:{kind:"followUp",followup:ii.to(Y.action.followup)},result:Ue}:{action:Y.action,result:Ue}}we.to=Le})(It||(e.ChatAgentUserActionEvent=It={}));var Et;(function(we){function Le(ce,Y,Ee){return"terminalCommand"in ce?{terminalCommand:ce.terminalCommand,shouldExecute:ce.shouldExecute}:"uri"in ce?{uri:ce.uri}:Y.toInternal(ce,Ee)}we.from=Le})(Et||(e.TerminalQuickFix=Et={}));var ci;(function(we){function Le(ce,Y){return{id:Y,label:ce.label,description:ce.description,canEdit:ce.canEdit,collapsibleState:ce.collapsibleState||0,contextValue:ce.contextValue}}we.from=Le})(ci||(e.DebugTreeItem=ci={}))}),define(Pe[248],Re([1,0,4,17,8]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2hc=void 0;let F=class{constructor(m,f){this.a=m.getProxy(S.$6L.MainThreadBulkEdits),this.b={getTextDocumentVersion:k=>f.getDocument(k)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(m,f,k){const O=P.WorkspaceEdit.from(m,this.b);return this.a.$tryApplyWorkspaceEdit(O,void 0,k?.isRefactoring??!1)}};e.$2hc=F,e.$2hc=F=Ye([He(0,M.$lO)],F)}),define(Pe[249],Re([1,0,18,11,41,5,51,6,64,16,2,160,20,4,8,7,209,22]),function(me,e,S,M,P,F,R,m,f,k,O,D,l,E,g,s,a,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4hc=void 0;class n{constructor(t,p,u,o,v,b){this.j=t,this.k=p,this.l=u,this.m=o,this.n=v,this.o=b,this.b=f.$1d.create(!1),this.d=!1}close(){this.d=!0}get timings(){return{firstProgress:this.g,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.i){let p=function(o){if(t.d){const v=new Error("Response stream has been closed");throw Error.captureStackTrace(v,o),v}};const t=this;this.b.reset();const u=o=>{typeof this.g>"u"&&"content"in o&&(this.g=this.b.elapsed()),this.l.$handleProgressChunk(this.k.requestId,o)};this.i={markdown(o){p(this.markdown);const v=new s.$1N(o),b=g.ChatResponseMarkdownPart.to(v);return u(b),this},filetree(o,v){p(this.filetree);const b=new s.$2N(o,v),$=g.ChatResponseFilesPart.to(b);return u($),this},anchor(o,v){p(this.anchor);const b=new s.$3N(o,v),$=g.ChatResponseAnchorPart.to(b);return u($),this},button(o){p(this.anchor);const v=new s.$5N(o),b=g.ChatResponseCommandButtonPart.to(v,t.n,t.o);return u(b),this},progress(o){p(this.progress);const v=new s.$4N(o),b=g.ChatResponseProgressPart.to(v);return u(b),this},reference(o){p(this.reference);const v=new s.$6N(o),b=g.ChatResponseReferencePart.to(v);return u(b),this},push(o){p(this.push);const v=g.ChatResponsePart.to(o);return u(v),this},report(o){if(p(this.report),"placeholder"in o&&"resolvedContent"in o)return;const v=g.ChatResponseProgress.from(t.j,o);if(!v){t.m.error("Unknown progress type: "+JSON.stringify(o));return}return u(v),this}}}return this.i}}class r{static{this.b=0}constructor(t,p,u){this.j=p,this.k=u,this.d=new Map,this.i=new m.$3c,this.g=t.getProxy(E.$6L.MainThreadChatAgents2)}createChatAgent(t,p,u){const o=r.b++,v=new c(t,p,this.g,o,u);return this.d.set(o,v),this.g.$registerAgent(o,t.identifier,p,{}),v.apiAgent}async $invokeAgent(t,p,u,o){const v=this.d.get(t);if(!v)throw new Error(`[CHAT](${t}) CANNOT invoke agent because the agent is not registered`);let b=this.i.get(p.sessionId);b||(b=new m.$Sc,this.i.set(p.sessionId,b));const $=new n(v.extension,p,this.g,this.j,this.k.converter,b);try{const I=await this.l(p.agentId,u),h=v.invoke(g.ChatAgentRequest.to(p),{history:I},$.apiObject,o);return await(0,M.$6g)(Promise.resolve(h).then(y=>{if(y?.metadata)try{JSON.stringify(y.metadata)}catch(w){const A=`result.metadata MUST be JSON.stringify-able. Got error: ${w.message}`;return this.j.error(`[${v.extension.identifier.value}] [@${v.id}] ${A}`,v.extension),{errorDetails:{message:A},timings:$.timings}}return{errorDetails:y?.errorDetails,timings:$.timings,metadata:y?.metadata}}),o)}catch(I){return this.j.error(I,v.extension),{errorDetails:{message:(0,D.localize)(0,null,(0,P.$3i)(I)),responseIsIncomplete:!0}}}finally{$.close()}}async l(t,p){const u=[];for(const o of p.history){const v=g.ChatAgentResult.to(o.result),b=t===o.request.agentId?v:{...v,metadata:void 0};u.push(new s.$7N(o.request.message,o.request.command,o.request.variables.variables.map(g.ChatAgentResolvedVariable.to),{extensionId:"",name:o.request.agentId}));const $=(0,S.$Hb)(o.response.map(I=>g.ChatResponsePart.fromContent(I,this.k.converter)));u.push(new s.$8N($,b,{extensionId:"",name:o.request.agentId},o.request.command))}return u}$releaseSession(t){this.i.deleteAndDispose(t)}async $provideSlashCommands(t,p,u){const o=this.d.get(t);if(!o)return[];const v=await this.l(o.id,p);try{return await o.provideSlashCommands({history:v},u)}catch(b){const $=(0,P.$3i)(b);return this.j.error(`[${o.extension.identifier.value}] [@${o.id}] Error while providing slash commands: ${$}`),[]}}async $provideFollowups(t,p,u,o){const v=this.d.get(p);if(!v)return Promise.resolve([]);const b=g.ChatAgentResult.to(u);return(await v.provideFollowups(b,o)).filter($=>{const I=!$.participant||R.Iterable.some(this.d.values(),h=>h.id===$.participant&&l.$zm.equals(h.extension.identifier,v.extension.identifier));return I||this.j.warn(`[@${v.id}] ChatFollowup refers to an invalid participant: ${$.participant}`),I}).map($=>g.ChatFollowup.from($,t))}$acceptFeedback(t,p,u,o){const v=this.d.get(t);if(!v)return;const b=g.ChatAgentResult.to(p);let $;switch(u){case a.InteractiveSessionVoteDirection.Down:$=s.ChatResultFeedbackKind.Unhelpful;break;case a.InteractiveSessionVoteDirection.Up:$=s.ChatResultFeedbackKind.Helpful;break}v.acceptFeedback(Object.freeze(o?{result:b,kind:$,reportIssue:o}:{result:b,kind:$}))}$acceptAction(t,p,u){const o=this.d.get(t);if(!o||u.action.kind==="vote")return;const v=g.ChatAgentUserActionEvent.to(p,u,this.k.converter);v&&o.acceptAction(Object.freeze(v))}async $invokeCompletionProvider(t,p,u){const o=this.d.get(t);return o?(await o.invokeCompletionProvider(p,u)).map(g.ChatAgentCompletionItem.from):[]}async $provideWelcomeMessage(t,p){const u=this.d.get(t);if(u)return await u.provideWelcomeMessage(p)}async $provideSampleQuestions(t,p){const u=this.d.get(t);if(u)return(await u.provideSampleQuestions(p)).map(o=>g.ChatFollowup.from(o,void 0))}}e.$4hc=r;class c{constructor(t,p,u,o,v){this.extension=t,this.id=p,this.y=u,this.z=o,this.A=v,this.q=new F.$5d,this.s=new F.$5d}acceptFeedback(t){this.q.fire(t)}acceptAction(t){this.s.fire(t)}async invokeCompletionProvider(t,p){return this.u?await this.u.provider.provideCompletionItems(t,p)??[]:[]}async provideSlashCommands(t,p){if(!this.b)return[];const u=await this.b.provideCommands(t,p);return u?u.map(o=>("isSticky2"in o&&(0,i.$YF)(this.extension,"chatParticipantAdditions"),{name:o.name,description:o.description??"",followupPlaceholder:o.isSticky2?.placeholder,isSticky:o.isSticky2?.isSticky??o.isSticky,sampleRequest:o.sampleRequest})):[]}async provideFollowups(t,p){if(!this.d)return[];const u=await this.d.provideFollowups(t,p);return u?u.filter(o=>!(o&&"commandId"in o)).filter(o=>!(o&&"message"in o)):[]}async provideWelcomeMessage(t){if(!this.w)return[];const p=await this.w.provideWelcomeMessage(t);return p?p.map(u=>typeof u=="string"?u:g.MarkdownString.from(u)):[]}async provideSampleQuestions(t){if(!this.w||!this.w.provideSampleQuestions)return[];const p=await this.w.provideSampleQuestions(t);return p||[]}get apiAgent(){let t=!1,p=!1;const u=()=>{t||p||(p=!0,queueMicrotask(()=>{this.y.$updateAgent(this.z,{description:this.g??"",fullName:this.i,icon:this.j?this.j instanceof O.URI?this.j:"light"in this.j?this.j.light:void 0:void 0,iconDark:this.j&&"dark"in this.j?this.j.dark:void 0,themeIcon:this.j instanceof s.$3M?this.j:void 0,hasSlashCommands:this.b!==void 0,hasFollowups:this.d!==void 0,isDefault:this.k,isSecondary:this.p,helpTextPrefix:!this.l||typeof this.l=="string"?this.l:g.MarkdownString.from(this.l),helpTextVariablesPrefix:!this.m||typeof this.m=="string"?this.m:g.MarkdownString.from(this.m),helpTextPostfix:!this.n||typeof this.n=="string"?this.n:g.MarkdownString.from(this.n),sampleRequest:this.o,supportIssueReporting:this.t,isSticky:this.x}),p=!1}))},o=this;return{get name(){return o.id},get description(){return o.g??""},set description(v){o.g=v,u()},get fullName(){return(0,i.$YF)(o.extension,"defaultChatParticipant"),o.i??o.extension.displayName??o.extension.name},set fullName(v){(0,i.$YF)(o.extension,"defaultChatParticipant"),o.i=v,u()},get iconPath(){return o.j},set iconPath(v){o.j=v,u()},get requestHandler(){return o.A},set requestHandler(v){(0,k.$3f)(typeof v=="function","Invalid request handler"),o.A=v},get commandProvider(){return o.b},set commandProvider(v){o.b=v,u()},get followupProvider(){return o.d},set followupProvider(v){o.d=v,u()},get isDefault(){return(0,i.$YF)(o.extension,"defaultChatParticipant"),o.k},set isDefault(v){(0,i.$YF)(o.extension,"defaultChatParticipant"),o.k=v,u()},get helpTextPrefix(){return(0,i.$YF)(o.extension,"defaultChatParticipant"),o.l},set helpTextPrefix(v){if((0,i.$YF)(o.extension,"defaultChatParticipant"),!o.k)throw new Error("helpTextPrefix is only available on the default chat agent");o.l=v,u()},get helpTextVariablesPrefix(){return(0,i.$YF)(o.extension,"defaultChatParticipant"),o.m},set helpTextVariablesPrefix(v){if((0,i.$YF)(o.extension,"defaultChatParticipant"),!o.k)throw new Error("helpTextVariablesPrefix is only available on the default chat agent");o.m=v,u()},get helpTextPostfix(){return(0,i.$YF)(o.extension,"defaultChatParticipant"),o.n},set helpTextPostfix(v){if((0,i.$YF)(o.extension,"defaultChatParticipant"),!o.k)throw new Error("helpTextPostfix is only available on the default chat agent");o.n=v,u()},get isSecondary(){return(0,i.$YF)(o.extension,"defaultChatParticipant"),o.p},set isSecondary(v){(0,i.$YF)(o.extension,"defaultChatParticipant"),o.p=v,u()},get sampleRequest(){return o.o},set sampleRequest(v){o.o=v,u()},get supportIssueReporting(){return(0,i.$YF)(o.extension,"chatParticipantAdditions"),o.t},set supportIssueReporting(v){(0,i.$YF)(o.extension,"chatParticipantAdditions"),o.t=v,u()},get onDidReceiveFeedback(){return o.q.event},set participantVariableProvider(v){if((0,i.$YF)(o.extension,"chatParticipantAdditions"),o.u=v,v){if(!v.triggerCharacters.length)throw new Error("triggerCharacters are required");o.y.$registerAgentCompletionsProvider(o.z,v.triggerCharacters)}else o.y.$unregisterAgentCompletionsProvider(o.z)},get participantVariableProvider(){return(0,i.$YF)(o.extension,"chatParticipantAdditions"),o.u},set welcomeMessageProvider(v){(0,i.$YF)(o.extension,"defaultChatParticipant"),o.w=v,u()},get welcomeMessageProvider(){return(0,i.$YF)(o.extension,"defaultChatParticipant"),o.w},onDidPerformAction:(0,i.$XF)(this.extension,"chatParticipantAdditions")?this.s.event:void 0,get isSticky(){return o.x},set isSticky(v){o.x=v,u()},dispose(){t=!0,o.b=void 0,o.d=void 0,o.q.dispose(),o.y.$unregisterAgent(o.z)}}}invoke(t,p,u,o){return this.A(t,p,u,o)}}}),define(Pe[250],Re([1,0,14,6,4,8,7,22]),function(me,e,S,M,P,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7hc=void 0;class f{static{this.a=0}constructor(D){this.b=new Map,this.c=D.getProxy(P.$6L.MainThreadChatVariables)}async $resolveVariable(D,l,E,g){const s=this.b.get(D);if(s)try{if(s.resolver.resolve2){(0,m.$YF)(s.extension,"chatParticipantAdditions");const a=new k(l,this.c),i=await s.resolver.resolve2(s.data.name,{prompt:E},a.apiObject,g);if(i)return i.map(F.ChatVariable.from)}else{const a=await s.resolver.resolve(s.data.name,{prompt:E},g);if(a)return a.map(F.ChatVariable.from)}}catch(a){(0,S.$2)(a)}}registerVariableResolver(D,l,E,g){const s=f.a++;return this.b.set(s,{extension:D,data:{name:l,description:E},resolver:g}),this.c.$registerVariable(s,{name:l,description:E}),(0,M.$Rc)(()=>{this.b.delete(s),this.c.$unregisterVariable(s)})}}e.$7hc=f;class k{constructor(D,l){this.c=D,this.d=l,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let l=function(g){if(D.a){const s=new Error("Response stream has been closed");throw Error.captureStackTrace(s,g),s}};const D=this,E=g=>{this.d.$handleProgressChunk(this.c,g)};this.b={progress(g){l(this.progress);const s=new R.$4N(g),a=F.ChatResponseProgressPart.to(s);return E(a),this},reference(g){l(this.reference);const s=new R.$6N(g),a=F.ChatResponseReferencePart.to(s);return E(a),this},push(g){l(this.push);const s=F.ChatResponsePart.to(g);return E(s),this}}}return this.b}}}),define(Pe[251],Re([1,0,11,68,5,6,2,87,20,8,7,4,22]),function(me,e,S,M,P,F,R,m,f,k,O,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$hc=void 0;function E(g,s,a){const i=g.getProxy(D.$6L.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new f.$Bm,s.registerArgumentProcessor({processArgument:b=>{if(b&&b.$mid===6){const $=this.b.get(b.handle);return $?$.value:b}else if(b&&b.$mid===7){const $=this.b.get(b.commentControlHandle);if(!$)return b;const I=$.getCommentThread(b.commentThreadHandle);return I?I.value:b}else if(b&&(b.$mid===9||b.$mid===8)){const $=this.b.get(b.thread.commentControlHandle);if(!$)return b;const I=$.getCommentThread(b.thread.commentThreadHandle);return I?b.$mid===8?I.value:{thread:I.value,text:b.text}:b}else if(b&&b.$mid===10){const $=this.b.get(b.thread.commentControlHandle);if(!$)return b;const I=$.getCommentThread(b.thread.commentThreadHandle);if(!I)return b;const h=b.commentUniqueId,y=I.getCommentByUniqueId(h);return y||b}else if(b&&b.$mid===11){const $=this.b.get(b.thread.commentControlHandle);if(!$)return b;const I=$.getCommentThread(b.thread.commentThreadHandle);if(!I)return b;const h=b.text,y=b.commentUniqueId,w=I.getCommentByUniqueId(y);return w?(typeof w.body=="string"?w.body=h:w.body=new O.$wM(h),w):b}return b}})}createCommentController(b,$,I){const h=n.a++,y=new c(b,h,$,I);this.b.set(y.handle,y);const w=this.c.get(b.identifier)||[];return w.push(y),this.c.set(b.identifier,w),y.value}async $createCommentThreadTemplate(b,$,I){const h=this.b.get(b);h&&h.$createCommentThreadTemplate($,I)}async $setActiveComment(b,$){const I=this.b.get(b);I&&I.$setActiveComment($??void 0)}async $updateCommentThreadTemplate(b,$,I){const h=this.b.get(b);h&&h.$updateCommentThreadTemplate($,I)}$deleteCommentThread(b,$){this.b.get(b)?.$deleteCommentThread($)}async $provideCommentingRanges(b,$,I){const h=this.b.get(b);if(!h||!h.commentingRangeProvider)return Promise.resolve(void 0);const y=await a.ensureDocumentData(R.URI.revive($));return(0,S.$0g)(async()=>{const w=await h.commentingRangeProvider.provideCommentingRanges(y.document,I);let A;return Array.isArray(w)?A={ranges:w,fileComments:!1}:w?A={ranges:w.ranges||[],fileComments:w.fileComments||!1}:A=w??void 0,A}).then(w=>{let A;return w&&(A={ranges:w.ranges.map(N=>k.Range.from(N)),fileComments:w.fileComments}),A})}$toggleReaction(b,$,I,h,y){const w=this.b.get(b);return!w||!w.reactionHandler?Promise.resolve(void 0):(0,S.$0g)(()=>{const A=w.getCommentThread($);if(A){const N=A.getCommentByUniqueId(h.uniqueIdInThread);if(w!==void 0&&N&&w.reactionHandler)return w.reactionHandler(N,p(y))}return Promise.resolve(void 0)})}}class r{static{this.a=0}set threadId(b){this.n=b}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(b){(b===void 0!=(this.p===void 0)||!b||!this.p||!b.isEqual(this.p))&&(this.p=b,this.b.range=b,this.c.fire())}get range(){return this.p}set canReply(b){this.d!==b&&(this.d=b,this.b.canReply=b,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(b){this.e=b,this.b.label=b,this.c.fire()}get contextValue(){return this.f}set contextValue(b){this.f=b,this.b.contextValue=b,this.c.fire()}get comments(){return this.q}set comments(b){this.q=b,this.b.comments=b,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(b){this.g=b,this.b.collapsibleState=b,this.c.fire()}get state(){return this.h}set state(b){this.h=b,this.b.state=b,this.c.fire()}get isDisposed(){return this.j}constructor(b,$,I,h,y,w,A,N){this.m=$,this.n=I,this.o=h,this.p=y,this.q=w,this.extensionDescription=A,this.r=N,this.handle=r.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new P.$5d,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new F.$Uc,this.l.value=new F.$Sc,this.n===void 0&&(this.n=`${b}.${this.handle}`),i.$createCommentThread($,this.handle,this.n,this.o,k.Range.from(this.p),A.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=w,this.i.push({dispose:()=>{i.$deleteCommentThread($,this.handle)}});const G=this;this.value={get uri(){return G.uri},get range(){return G.range},set range(V){G.range=V},get comments(){return G.comments},set comments(V){G.comments=V},get collapsibleState(){return G.collapsibleState},set collapsibleState(V){G.collapsibleState=V},get canReply(){return G.canReply},set canReply(V){G.canReply=V},get contextValue(){return G.contextValue},set contextValue(V){G.contextValue=V},get label(){return G.label},set label(V){G.label=V},get state(){return G.state},set state(V){G.state=V},dispose:()=>{G.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new F.$Sc);const b=I=>Object.prototype.hasOwnProperty.call(this.b,I),$={};b("range")&&($.range=k.Range.from(this.p)),b("label")&&($.label=this.label),b("contextValue")&&($.contextValue=this.contextValue??null),b("comments")&&($.comments=this.q.map(I=>d(this,I,this.k,this.extensionDescription))),b("collapsibleState")&&($.collapseState=u(this.g)),b("canReply")&&($.canReply=this.canReply),b("state")&&($.state=o(this.h)),b("isTemplate")&&($.isTemplate=this.r),this.b={},i.$updateCommentThread(this.m,this.handle,this.n,this.o,$)}getCommentByUniqueId(b){for(const $ of this.k){const I=$[0],h=$[1];if(b===h)return I}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(b=>b.dispose())}}Ye([(0,M.$Kh)(100)],r.prototype,"eventuallyUpdateCommentThread",null);class c{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(b){this.b=b,b?.resourceHints&&(0,l.$YF)(this.h,"commentingRangeHint"),i.$updateCommentingRanges(this.handle,b?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(b){this.c=b,i.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!b})}get options(){return this.d}set options(b){this.d=b,i.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,l.$YF)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,l.$YF)(this.h,"activeComment"),this.f}constructor(b,$,I,h){this.h=b,this.i=$,this.j=I,this.k=h,this.a=new Map,i.$registerCommentController(this.handle,I,h,this.h.identifier.value);const y=this;this.value=Object.freeze({id:y.id,label:y.label,get options(){return y.options},set options(w){y.options=w},get commentingRangeProvider(){return y.commentingRangeProvider},set commentingRangeProvider(w){y.commentingRangeProvider=w},get reactionHandler(){return y.reactionHandler},set reactionHandler(w){y.reactionHandler=w},get activeCommentThread(){return y.activeCommentThread},createCommentThread(w,A,N){return y.createCommentThread(w,A,N).value},dispose:()=>{y.dispose()}}),this.g=[],this.g.push({dispose:()=>{i.$unregisterCommentController(this.handle)}})}createCommentThread(b,$,I){$===void 0&&(0,l.$YF)(this.h,"fileComments");const h=new r(this.id,this.handle,void 0,b,$,I,this.h,!1);return this.a.set(h.handle,h),h}$setActiveComment(b){if(!b){this.e=void 0,this.f=void 0;return}const $=this.a.get(b.commentThreadHandle);$&&(this.e=b.uniqueIdInThread?$.getCommentByUniqueId(b.uniqueIdInThread):void 0,this.f=$)}$createCommentThreadTemplate(b,$){const I=new r(this.id,this.handle,void 0,R.URI.revive(b),k.Range.to($),[],this.h,!0);return I.collapsibleState=m.CommentThreadCollapsibleState.Expanded,this.a.set(I.handle,I),I}$updateCommentThreadTemplate(b,$){const I=this.a.get(b);I&&(I.range=k.Range.to($))}$deleteCommentThread(b){this.a.get(b)?.dispose(),this.a.delete(b)}getCommentThread(b){return this.a.get(b)}dispose(){this.a.forEach(b=>{b.dispose()}),this.g.forEach(b=>b.dispose())}}function d(v,b,$,I){let h=$.get(b);return h||(h=++v.commentHandle,$.set(b,h)),b.state!==void 0&&(0,l.$YF)(I,"commentsDraftState"),b.reactions?.some(y=>y.reactors!==void 0)&&(0,l.$YF)(I,"commentReactor"),{mode:b.mode,contextValue:b.contextValue,uniqueIdInThread:h,body:typeof b.body=="string"?b.body:k.MarkdownString.from(b.body),userName:b.author.name,userIconPath:b.author.iconPath,label:b.label,commentReactions:b.reactions?b.reactions.map(y=>t(y)):void 0,state:b.state,timestamp:b.timestamp?.toJSON()}}function t(v){return{label:v.label,iconPath:v.iconPath?k.$kO(v.iconPath):void 0,count:v.count,hasReacted:v.authorHasReacted,reactors:v.reactors&&v.reactors.length>0&&typeof v.reactors[0]!="string"?v.reactors.map(b=>b.name):v.reactors}}function p(v){return{label:v.label||"",count:v.count||0,iconPath:v.iconPath?R.URI.revive(v.iconPath):"",authorHasReacted:v.hasReacted||!1,reactors:v.reactors?.map(b=>({name:b}))}}function u(v){if(v!==void 0)switch(v){case O.CommentThreadCollapsibleState.Expanded:return m.CommentThreadCollapsibleState.Expanded;case O.CommentThreadCollapsibleState.Collapsed:return m.CommentThreadCollapsibleState.Collapsed}return m.CommentThreadCollapsibleState.Collapsed}function o(v){if(v!==void 0)switch(v){case O.CommentThreadState.Unresolved:return m.CommentThreadState.Unresolved;case O.CommentThreadState.Resolved:return m.CommentThreadState.Resolved}return m.CommentThreadState.Unresolved}return new n}e.$$hc=E}),define(Pe[252],Re([1,0,25,99,6,12,24,2,8,62,74,4,7]),function(me,e,S,M,P,F,R,m,f,k,O,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qic=void 0;class E{constructor(p,u){this.document=p,this.b=u,this.a=1,this.c=new O.$Nhc("custom documents")}addEdit(p){return this.c.add([p])}async undo(p,u){await this.f(p).undo(),u||this.disposeBackup()}async redo(p,u){await this.f(p).redo(),u||this.disposeBackup()}disposeEdits(p){for(const u of p)this.c.delete(u)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const p=d(this.document.uri)+this.a++;return(0,R.$Sg)(this.b,p)}updateBackup(p){this.d?.delete(),this.d=p}disposeBackup(){this.d?.delete(),this.d=void 0}f(p){const u=this.c.get(p,0);if(!u)throw new Error("No edit found");return u}}class g{constructor(){this.a=new Map}get(p,u){return this.a.get(this.b(p,u))}add(p,u,o){const v=this.b(p,u.uri);if(this.a.has(v))throw new Error(`Document already exists for viewType:${p} resource:${u.uri}`);const b=new E(u,o);return this.a.set(v,b),b}delete(p,u){const o=this.b(p,u.uri);this.a.delete(o)}b(p,u){return`${p}@@@${u}`}}var s;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(s||(s={}));class a{constructor(){this.a=new Map}addTextProvider(p,u,o){return this.b(0,p,u,o)}addCustomProvider(p,u,o){return this.b(1,p,u,o)}get(p){return this.a.get(p)}b(p,u,o,v){if(this.a.has(u))throw new Error(`Provider for viewType:${u} already registered`);return this.a.set(u,{type:p,extension:o,provider:v}),new l.$8L(()=>this.a.delete(u))}}class i{constructor(p,u,o,v,b){this.d=u,this.f=o,this.g=v,this.h=b,this.b=new a,this.c=new g,this.a=p.getProxy(D.$6L.MainThreadCustomEditors)}registerCustomEditorProvider(p,u,o,v){const b=new P.$Sc;return r(o)?(b.add(this.b.addTextProvider(u,p,o)),this.a.$registerTextEditorProvider((0,k.$nic)(p),u,v.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,k.$lic)(p))):(b.add(this.b.addCustomProvider(u,p,o)),n(o)&&b.add(o.onDidChangeCustomDocument($=>{const I=this.i(u,$.document.uri);if(c($)){const h=I.addEdit($);this.a.$onDidEdit($.document.uri,u,h,$.label)}else this.a.$onContentChange($.document.uri,u)})),this.a.$registerCustomEditorProvider((0,k.$nic)(p),u,v.webviewOptions||{},!!v.supportsMultipleEditorsPerDocument,(0,k.$lic)(p))),l.$8L.from(b,new l.$8L(()=>{this.a.$unregisterEditorProvider(u)}))}async $createCustomDocument(p,u,o,v,b){const $=this.b.get(u);if(!$)throw new Error(`No provider found for '${u}'`);if($.type!==1)throw new Error(`Invalid provide type for '${u}'`);const I=m.URI.revive(p),h=await $.provider.openCustomDocument(I,{backupId:o,untitledDocumentData:v?.buffer},b);let y;return n($.provider)&&this.f&&(y=this.f.workspaceValue($.extension)??this.f.globalValue($.extension)),this.c.add(u,h,y),{editable:n($.provider)}}async $disposeCustomDocument(p,u){const o=this.b.get(u);if(!o)throw new Error(`No provider found for '${u}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${u}'`);const v=m.URI.revive(p),{document:b}=this.i(u,v);this.c.delete(u,b),b.dispose()}async $resolveCustomEditor(p,u,o,v,b,$){const I=this.b.get(o);if(!I)throw new Error(`No provider found for '${o}'`);const h=f.ViewColumn.to(b),y=this.g.createNewWebview(u,v.contentOptions,I.extension),w=this.h.createNewWebviewPanel(u,o,v.title,h,v.options,y,v.active),A=m.URI.revive(p);switch(I.type){case 1:{const{document:N}=this.i(o,A);return I.provider.resolveCustomEditor(N,w,$)}case 0:{const N=this.d.getDocument(A);return I.provider.resolveCustomTextEditor(N,w,$)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(p,u,o){this.i(u,p).disposeEdits(o)}async $onMoveCustomEditor(p,u,o){const v=this.b.get(o);if(!v)throw new Error(`No provider found for '${o}'`);if(!v.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const b=this.h.getWebviewPanel(p);if(!b)throw new Error("No webview found");const $=m.URI.revive(u),I=this.d.getDocument($);await v.provider.moveCustomTextEditor(I,b,S.CancellationToken.None)}async $undo(p,u,o,v){return this.i(u,p).undo(o,v)}async $redo(p,u,o,v){return this.i(u,p).redo(o,v)}async $revert(p,u,o){const v=this.i(u,p);await this.j(u).revertCustomDocument(v.document,o),v.disposeBackup()}async $onSave(p,u,o){const v=this.i(u,p);await this.j(u).saveCustomDocument(v.document,o),v.disposeBackup()}async $onSaveAs(p,u,o,v){const b=this.i(u,p);return this.j(u).saveCustomDocumentAs(b.document,m.URI.revive(o),v)}async $backup(p,u,o){const v=this.i(u,p),$=await this.j(u).backupCustomDocument(v.document,{destination:v.getNewBackupUri()},o);return v.updateBackup($),$.id}i(p,u){const o=this.c.get(p,m.URI.revive(u));if(!o)throw new Error("No custom document found");return o}j(p){const o=this.b.get(p)?.provider;if(!o||!n(o))throw new Error("Custom document is not editable");return o}}e.$qic=i;function n(t){return!!t.onDidChangeCustomDocument}function r(t){return typeof t.resolveCustomTextEditor=="function"}function c(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function d(t){const p=t.scheme===F.Schemas.file||t.scheme===F.Schemas.untitled?t.fsPath:t.toString();return(0,M.$6i)(p)+""}}),define(Pe[253],Re([1,0,161,100,2,4,7,8,5,13,28,43]),function(me,e,S,M,P,F,R,m,f,k,O,D){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$Vhc=e.$Uhc=void 0;class E{#e;#t;#i;constructor(a,i,n,r,c,d,t,p){this.d=a,this.e=i,this.f=n,this.g=r,this.h=c,this.c=!1,this.f=Math.max(r,n),this.#i=new O.$Ac(u=>d.getComparisonKey(u)),this.#e=t,this.#t=p}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(a,i){if(!a){this.clear();return}this.j();let n=[];if(P.URI.isUri(a)){if(!i){this.delete(a);return}this.#i.set(a,i.slice()),n=[a]}else if(Array.isArray(a)){n=[];let d;a=[...a].sort(E.k);for(const t of a){const[p,u]=t;if((!d||p.toString()!==d.toString())&&(d&&this.#i.get(d).length===0&&this.#i.delete(d),d=p,n.push(p),this.#i.set(p,[])),u)this.#i.get(p)?.push(...u);else{const o=this.#i.get(p);o&&(o.length=0)}}}if(this.#t.fire(n),!this.#e)return;const r=[];let c=0;for(const d of n){let t=[];const p=this.#i.get(d);if(p)if(p.length>this.g){t=[];const u=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let o=0;o<4;o++)for(const v of p)if(v.severity===u[o]&&t.push({...m.Diagnostic.from(v),modelVersionId:this.h(d)})===this.g)break e;t.push({severity:M.MarkerSeverity.Info,message:(0,S.localize)(0,null,p.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=p.map(u=>({...m.Diagnostic.from(u),modelVersionId:this.h(d)}));if(r.push([d,t]),c+=t.length,c>this.f)break}this.#e.$changeMany(this.e,r)}delete(a){this.j(),this.#t.fire([a]),this.#i.delete(a),this.#e?.$changeMany(this.e,[[a,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(a,i){this.j();for(const[n,r]of this)a.call(i,n,r,this)}*[Symbol.iterator](){this.j();for(const a of this.#i.keys())yield[a,this.get(a)]}get(a){this.j();const i=this.#i.get(a);return Array.isArray(i)?Object.freeze(i.slice(0)):[]}has(a){return this.j(),Array.isArray(this.#i.get(a))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(a,i){return a[0].toString()<i[0].toString()?-1:a[0].toString()>i[0].toString()?1:0}}e.$Uhc=E;let g=class{static{l=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*l.d}static _mapper(a){const i=new O.$Ac;for(const n of a)i.set(n,n);return{uris:Object.freeze(Array.from(i.values()))}}constructor(a,i,n,r){this.j=i,this.k=n,this.l=r,this.g=new Map,this.h=new f.$9d({merge:c=>c.flat(),delay:50}),this.onDidChangeDiagnostics=f.Event.map(this.h.event,l._mapper),this.f=a.getProxy(F.$6L.MainThreadDiagnostics)}createDiagnosticCollection(a,i){const{g:n,f:r,h:c,j:d,k:t,l:p}=this,u=new class{$changeMany(b,$){r.$changeMany(b,$),d.trace("[DiagnosticCollection] change many (extension, owner, uris)",a.value,b,$.length===0?"CLEARING":$)}$clear(b){r.$clear(b),d.trace("[DiagnosticCollection] remove all (extension, owner)",a.value,b)}dispose(){r.dispose()}};let o;if(!i)i="_generated_diagnostic_collection_name_#"+l.c++,o=i;else if(!n.has(i))o=i;else{this.j.warn(`DiagnosticCollection with name '${i}' does already exist.`);do o=i+l.c++;while(n.has(o))}return new class extends E{constructor(){super(i,o,l.e,l.d,b=>p.getDocument(b)?.version,t.extUri,u,c),n.set(o,this)}dispose(){super.dispose(),n.delete(o)}}}getDiagnostics(a){if(a)return this.m(a);{const i=new Map,n=[];for(const r of this.g.values())r.forEach((c,d)=>{let t=i.get(c.toString());typeof t>"u"&&(t=n.length,i.set(c.toString(),t),n.push([c,[]])),n[t][1]=n[t][1].concat(...d)});return n}}m(a){let i=[];for(const n of this.g.values())n.has(a)&&(i=i.concat(n.get(a)));return i}$acceptMarkersChange(a){if(!this.n){const i="_generated_mirror",n=new E(i,i,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,r=>{},this.k.extUri,void 0,this.h);this.g.set(i,n),this.n=n}for(const[i,n]of a)this.n.set(P.URI.revive(i),n.map(m.Diagnostic.to))}};e.$Vhc=g,e.$Vhc=g=l=Ye([He(1,k.$zj),He(2,D.$Thc)],g)}),define(Pe[254],Re([1,0,2,14,7,8,189]),function(me,e,S,M,P,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ic=void 0;class m{constructor(k,O,D,l={timeout:1500,errors:3}){this.c=k,this.d=O,this.f=D,this.g=l,this.a=new R.$4c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(k){return(O,D,l)=>{const g={dispose:this.a.push([O,D,k])};return Array.isArray(l)&&l.push(g),g}}async $participateInSave(k,O){const D=S.URI.revive(k);let l=!1;const E=setTimeout(()=>l=!0,this.g.timeout),g=[];try{for(const s of[...this.a]){if(l)break;const a=this.d.getDocument(D),i=await this.h(s,{document:a,reason:F.TextDocumentSaveReason.to(O)});g.push(i)}}finally{clearTimeout(E)}return g}h([k,O,D],l){const E=this.b.get(k);return typeof E=="number"&&E>this.g.errors?Promise.resolve(!1):this.i(D,k,O,l).then(()=>!0,g=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' threw ERROR`),this.c.error(g),!(g instanceof Error)||g.message!=="concurrent_edits"){const s=this.b.get(k);this.b.set(k,s?s+1:1),typeof s=="number"&&s>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(k,O,D,l){const E=[],g=Date.now(),{document:s,reason:a}=l,{version:i}=s,n=Object.freeze({document:s,reason:a,waitUntil(r){if(Object.isFrozen(E))throw(0,M.$8)("waitUntil can not be called async");E.push(Promise.resolve(r))}});try{O.apply(D,[n])}catch(r){return Promise.reject(r)}return Object.freeze(E),new Promise((r,c)=>{const d=setTimeout(()=>c(new Error("timeout")),this.g.timeout);return Promise.all(E).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-g}ms`),clearTimeout(d),r(t)}).catch(t=>{clearTimeout(d),c(t)})}).then(r=>{const c={edits:[]};for(const d of r)if(Array.isArray(d)&&d.every(t=>t instanceof P.$cM))for(const{newText:t,newEol:p,range:u}of d)c.edits.push({resource:s.uri,versionId:void 0,textEdit:{range:u&&F.Range.from(u),text:t,eol:p&&F.EndOfLine.from(p)}});if(c.edits.length!==0)return i===s.version?this.f.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.$5ic=m}),define(Pe[255],Re([1,0,5,6,2,4,111,8,16,26,7]),function(me,e,S,M,P,F,R,m,f,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Whc=void 0;class D{constructor(E,g){this.a=new S.$5d,this.b=new S.$5d,this.c=new S.$5d,this.d=new S.$5d,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new M.$Sc,this.h=new Map,this.f=E.getProxy(F.$6L.MainThreadDocuments),this.g=g,this.g.onDidRemoveDocuments(s=>{for(const a of s)this.b.fire(a.document)},void 0,this.e),this.g.onDidAddDocuments(s=>{for(const a of s)this.a.fire(a.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(E){if(!E)return;const g=this.g.getDocument(E);if(g)return g}getDocument(E){const g=this.getDocumentData(E);if(!g?.document)throw new Error(`Unable to retrieve document from URI '${E}'`);return g.document}ensureDocumentData(E){const g=this.g.getDocument(E);if(g)return Promise.resolve(g);let s=this.h.get(E.toString());return s||(s=this.f.$tryOpenDocument(E).then(a=>{this.h.delete(E.toString());const i=P.URI.revive(a);return(0,f.$4f)(this.g.getDocument(i))},a=>(this.h.delete(E.toString()),Promise.reject(a))),this.h.set(E.toString(),s)),s}createDocumentData(E){return this.f.$tryCreateDocument(E).then(g=>P.URI.revive(g))}$acceptModelLanguageChanged(E,g){const s=P.URI.revive(E),a=this.g.getDocument(s);if(!a)throw new Error("unknown document");this.b.fire(a.document),a._acceptLanguageId(g),this.a.fire(a.document)}$acceptModelSaved(E){const g=P.URI.revive(E),s=this.g.getDocument(g);if(!s)throw new Error("unknown document");this.$acceptDirtyStateChanged(E,!1),this.d.fire(s.document)}$acceptDirtyStateChanged(E,g){const s=P.URI.revive(E),a=this.g.getDocument(s);if(!a)throw new Error("unknown document");a._acceptIsDirty(g),this.c.fire({document:a.document,contentChanges:[],reason:void 0})}$acceptModelChanged(E,g,s){const a=P.URI.revive(E),i=this.g.getDocument(a);if(!i)throw new Error("unknown document");i._acceptIsDirty(s),i.onEvents(g);let n;g.isUndoing?n=O.TextDocumentChangeReason.Undo:g.isRedoing&&(n=O.TextDocumentChangeReason.Redo),this.c.fire((0,k.$Ln)({document:i.document,contentChanges:g.changes.map(r=>({range:m.Range.to(r.range),rangeOffset:r.rangeOffset,rangeLength:r.rangeLength,text:r.text})),reason:n}))}setWordDefinitionFor(E,g){(0,R.$nO)(E,g)}}e.$Whc=D}),define(Pe[65],Re([1,0,256,5,16,2,3,4,17,8,7]),function(me,e,S,M,P,F,R,m,f,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sic=e.$ric=void 0,e.$ric=(0,R.$fi)("IExtHostEditorTabs");class D{constructor(a,i,n){this.e=n,this.d=i,this.acceptDtoUpdate(a)}get apiObject(){if(!this.a){const a=this,i={get isActive(){return a.b.id===a.e()},get label(){return a.b.label},get input(){return a.c},get isDirty(){return a.b.isDirty},get isPinned(){return a.b.isPinned},get isPreview(){return a.b.isPreview},get group(){return a.d.apiObject}};this.a=Object.freeze(i)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(a){this.b=a,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new O.$PN(F.URI.revive(this.b.input.uri));case 2:return new O.$QN(F.URI.revive(this.b.input.original),F.URI.revive(this.b.input.modified));case 3:return new O.$RN(F.URI.revive(this.b.input.base),F.URI.revive(this.b.input.input1),F.URI.revive(this.b.input.input2),F.URI.revive(this.b.input.result));case 6:return new O.$SN(F.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new O.$TN(this.b.input.viewType);case 4:return new O.$UN(F.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new O.$VN(F.URI.revive(this.b.input.original),F.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new O.$WN;case 9:return new O.$XN(F.URI.revive(this.b.input.uri),F.URI.revive(this.b.input.inputBoxUri));case 10:return new O.$YN(this.b.input.providerId);default:return}}}class l{constructor(a,i){this.c=[],this.d="",this.b=a,this.e=i;for(const n of a.tabs)n.isActive&&(this.d=n.id),this.c.push(new D(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const a=this,i={get isActive(){return a.b.groupId===a.e()},get viewColumn(){return k.ViewColumn.to(a.b.viewColumn)},get activeTab(){return a.c.find(n=>n.tabId===a.d)?.apiObject},get tabs(){return Object.freeze(a.c.map(n=>n.apiObject))}};this.a=Object.freeze(i)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(a){this.b=a}acceptTabOperation(a){if(a.kind===0){const n=new D(a.tabDto,this,()=>this.activeTabId());return this.c.splice(a.index,0,n),a.tabDto.isActive&&(this.d=n.tabId),n}else if(a.kind===1){const n=this.c.splice(a.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${a.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(a.kind===3){if(a.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(a.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${a.oldIndex} which does not exist`);return this.c.splice(a.index,0,n),n}const i=this.c.find(n=>n.tabId===a.tabDto.id);if(!i)throw new Error("INVALID tab");return a.tabDto.isActive?this.d=a.tabDto.id:this.d===a.tabDto.id&&!a.tabDto.isActive&&(this.d=""),i.acceptDtoUpdate(a.tabDto),i}activeTabId(){return this.d}}let E=class{constructor(a){this.b=new M.$5d,this.c=new M.$5d,this.e=[],this.a=a.getProxy(m.$6L.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const a=this,i={onDidChangeTabGroups:a.c.event,onDidChangeTabs:a.b.event,get all(){return Object.freeze(a.e.map(n=>n.apiObject))},get activeTabGroup(){const n=a.d;return(0,P.$4f)(a.e.find(c=>c.groupId===n)?.apiObject)},close:async(n,r)=>{const c=Array.isArray(n)?n:[n];return c.length?g(c[0])?this.j(c,r):this.i(c,r):!0}};this.f=Object.freeze(i)}return this.f}$acceptEditorTabModel(a){const i=new Set(this.e.map(u=>u.groupId)),n=new Set(a.map(u=>u.groupId)),r=(0,S.$L)(i,n),c=this.e.filter(u=>r.removed.includes(u.groupId)).map(u=>u.apiObject),d=[],t=[];this.e=a.map(u=>{const o=new l(u,()=>this.d);return r.added.includes(o.groupId)?d.push(o.apiObject):t.push(o.apiObject),o});const p=(0,P.$4f)(a.find(u=>u.isActive===!0)?.groupId);p!==void 0&&this.d!==p&&(this.d=p),this.c.fire(Object.freeze({opened:d,closed:c,changed:t}))}$acceptTabGroupUpdate(a){const i=this.e.find(n=>n.groupId===a.groupId);if(!i)throw new Error("Update Group IPC call received before group creation.");i.acceptGroupDtoUpdate(a),a.isActive&&(this.d=a.groupId),this.c.fire(Object.freeze({changed:[i.apiObject],opened:[],closed:[]}))}$acceptTabOperation(a){const i=this.e.find(r=>r.groupId===a.groupId);if(!i)throw new Error("Update Tabs IPC call received before group creation.");const n=i.acceptTabOperation(a);switch(a.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(a){for(const i of this.e)for(const n of i.tabs)if(n.apiObject===a)return n}h(a){return this.e.find(i=>i.apiObject===a)}async i(a,i){const n=[];for(const r of a){const c=this.g(r);if(!c)throw new Error("Tab close: Invalid tab not found!");n.push(c.tabId)}return this.a.$closeTab(n,i)}async j(a,i){const n=[];for(const r of a){const c=this.h(r);if(!c)throw new Error("Group close: Invalid group not found!");n.push(c.groupId)}return this.a.$closeGroup(n,i)}};e.$sic=E,e.$sic=E=Ye([He(0,f.$lO)],E);function g(s){return s.tabs!==void 0}}),define(Pe[257],Re([1,0,2,4,6,7,8,300,15,23,22,53]),function(me,e,S,M,P,F,R,m,f,k,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ic=void 0;class l{constructor(){this.a=[]}add(s){this.b=void 0,this.a.push(s)}delete(s){const a=this.a.indexOf(s);a>=0&&(this.a.splice(a,1),this.b=void 0)}c(){if(!this.b){const s=this.a.sort(),a=[];let i,n,r=14,c=14;for(const d of s){let t=i?(0,f.$lf)(i,d):0;for(t===0?n=1:n=c;t<d.length;t++)t+1===d.length?(r=c,c=9):c+=1,a.push([n,d.toUpperCase().charCodeAt(t),c]),a.push([n,d.toLowerCase().charCodeAt(t),c]),n=c;i=d,c=r}a.push([9,58,10]),a.push([10,47,12]),this.b=new m.$_1(a)}}provideDocumentLinks(s){this.c();const a=[],i=m.$a2.computeLinks({getLineContent(n){return s.lineAt(n-1).text},getLineCount(){return s.lineCount}},this.b);for(const n of i){const r=R.DocumentLink.to(n);r.target&&a.push(r)}return a}}class E{constructor(s,a){this.i=a,this.b=new l,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=s.getProxy(M.$6L.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(s,a,i,n={}){if(E.j(i),this.d.has(a))throw new Error(`a provider for the scheme '${a}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(s,"*",this.b));const r=this.h++;this.b.add(a),this.d.add(a),this.c.set(r,i);let c=2;n.isCaseSensitive&&(c+=1024),n.isReadonly&&(c+=2048),typeof i.copy=="function"&&(c+=8),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,O.$YF)(s,"fsChunks"),c+=4);let d;n.isReadonly&&(0,D.$yk)(n.isReadonly)&&n.isReadonly.value!==""&&(d={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(r,a,c,d).catch(p=>{console.error(`FAILED to register filesystem provider of ${s.identifier.value}-extension for the scheme ${a}`),console.error(p)});const t=i.onDidChangeFile(p=>{const u=[];for(const o of p){const{uri:v,type:b}=o;if(v.scheme!==a)continue;let $;switch(b){case F.FileChangeType.Changed:$=0;break;case F.FileChangeType.Created:$=1;break;case F.FileChangeType.Deleted:$=2;break;default:throw new Error("Unknown FileChangeType")}u.push({resource:v,type:$})}this.a.$onFileSystemChange(r,u)});return(0,P.$Rc)(()=>{t.dispose(),this.b.delete(a),this.d.delete(a),this.c.delete(r),this.a.$unregisterProvider(r)})}static j(s){if(!s)throw new Error("MISSING provider");if(typeof s.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof s.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof s.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof s.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof s.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof s.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof s.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof s.rename!="function")throw new Error("Provider does NOT implement rename")}static k(s){const{type:a,ctime:i,mtime:n,size:r,permissions:c}=s;return{type:a,ctime:i,mtime:n,size:r,permissions:c}}$stat(s,a){return Promise.resolve(this.l(s).stat(S.URI.revive(a))).then(i=>E.k(i))}$readdir(s,a){return Promise.resolve(this.l(s).readDirectory(S.URI.revive(a)))}$readFile(s,a){return Promise.resolve(this.l(s).readFile(S.URI.revive(a))).then(i=>k.$se.wrap(i))}$writeFile(s,a,i,n){return Promise.resolve(this.l(s).writeFile(S.URI.revive(a),i.buffer,n))}$delete(s,a,i){return Promise.resolve(this.l(s).delete(S.URI.revive(a),i))}$rename(s,a,i,n){return Promise.resolve(this.l(s).rename(S.URI.revive(a),S.URI.revive(i),n))}$copy(s,a,i,n){const r=this.l(s);if(!r.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(r.copy(S.URI.revive(a),S.URI.revive(i),n))}$mkdir(s,a){return Promise.resolve(this.l(s).createDirectory(S.URI.revive(a)))}$watch(s,a,i,n){const r=this.l(s).watch(S.URI.revive(i),n);this.f.set(a,r)}$unwatch(s,a){const i=this.f.get(a);i&&(i.dispose(),this.f.delete(a))}$open(s,a,i){const n=this.l(s);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(S.URI.revive(a),i))}$close(s,a){const i=this.l(s);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(a))}$read(s,a,i,n){const r=this.l(s);if(!r.read)throw new Error('FileSystemProvider does not implement "read"');const c=k.$se.alloc(n);return Promise.resolve(r.read(a,i,c.buffer,0,n)).then(d=>c.slice(0,d))}$write(s,a,i,n){const r=this.l(s);if(!r.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(r.write(a,i,n.buffer,0,n.byteLength))}l(s){const a=this.c.get(s);if(!a){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return a}}e.$7ic=E}),define(Pe[258],Re([1,0,5,34,2,4,8,7,39]),function(me,e,S,M,P,F,R,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8ic=void 0;class k{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(E,g,s,a,i,n){this.a=Math.random(),this.b=new S.$5d,this.c=new S.$5d,this.d=new S.$5d,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const r=(0,M.$Yj)(i),c=typeof i=="string",d=n?.correlate,t=a(p=>{if(!(typeof p.session=="number"&&p.session!==this.a)&&!(d&&typeof p.session>"u")){if(!n?.ignoreCreateEvents)for(const u of p.created){const o=P.URI.revive(u);r(o.fsPath)&&(!c||g.getWorkspaceFolder(o))&&this.b.fire(o)}if(!n?.ignoreChangeEvents)for(const u of p.changed){const o=P.URI.revive(u);r(o.fsPath)&&(!c||g.getWorkspaceFolder(o))&&this.c.fire(o)}if(!n?.ignoreDeleteEvents)for(const u of p.deleted){const o=P.URI.revive(u);r(o.fsPath)&&(!c||g.getWorkspaceFolder(o))&&this.d.fire(o)}}});this.g=m.$8L.from(this.i(E,s,i,n,n?.correlate),this.b,this.c,this.d,t)}i(E,g,s,a,i){const n=m.$8L.from();if(typeof s=="string")return n;const r=E.getProxy(F.$6L.MainThreadFileSystemEventService);let c=!1;return(s.pattern.includes(M.$Uj)||s.pattern.includes(M.$Vj))&&(c=!0),r.$watch(g.identifier.value,this.a,s.baseUri,{recursive:c,excludes:a?.excludes??[]},!!i),m.$8L.from({dispose:()=>r.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class O{constructor(E){this.a=E,this.session=this.a.session,this.b=new f.$V(()=>this.a.created.map(P.URI.revive)),this.c=new f.$V(()=>this.a.changed.map(P.URI.revive)),this.d=new f.$V(()=>this.a.deleted.map(P.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class D{constructor(E,g,s){this.j=E,this.k=g,this.l=s,this.a=new S.$5d,this.b=new S.$5d,this.c=new S.$5d,this.d=new S.$5d,this.g=new S.$7d,this.h=new S.$7d,this.i=new S.$7d,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(E,g,s,a){return new k(this.j,E,g,this.a.event,R.GlobPattern.from(s),a)}$onFileEvent(E){this.a.fire(new O(E))}$onDidRunFileOperation(E,g){switch(E){case 2:this.b.fire(Object.freeze({files:g.map(s=>({oldUri:P.URI.revive(s.source),newUri:P.URI.revive(s.target)}))}));break;case 1:this.d.fire(Object.freeze({files:g.map(s=>P.URI.revive(s.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:g.map(s=>P.URI.revive(s.target))}));break;default:}}getOnWillRenameFileEvent(E){return this.m(E,this.g)}getOnWillCreateFileEvent(E){return this.m(E,this.h)}getOnWillDeleteFileEvent(E){return this.m(E,this.i)}m(E,g){return(s,a,i)=>{const n=function(c){s.call(a,c)};return n.extension=E,g.event(n,void 0,i)}}async $onWillRunFileOperation(E,g,s,a){switch(E){case 2:return await this.n(this.g,{files:g.map(i=>({oldUri:P.URI.revive(i.source),newUri:P.URI.revive(i.target)}))},s,a);case 1:return await this.n(this.i,{files:g.map(i=>P.URI.revive(i.target))},s,a);case 0:case 3:return await this.n(this.h,{files:g.map(i=>P.URI.revive(i.target))},s,a)}}async n(E,g,s,a){const i=new Set,n=[];if(await E.fireAsync(g,a,async(c,d)=>{const t=Date.now(),p=await Promise.resolve(c);p instanceof m.$fM&&(n.push([d.extension,p]),i.add(d.extension.displayName??d.extension.identifier.value)),Date.now()-t>s&&this.k.warn("SLOW file-participant",d.extension.identifier)}),a.isCancellationRequested||n.length===0)return;const r={edits:[]};for(const[,c]of n){const{edits:d}=R.WorkspaceEdit.from(c,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});r.edits=r.edits.concat(d)}return{edit:r,extensionNames:Array.from(i)}}}e.$8ic=D}),define(Pe[259],Re([1,0,18,11,25,14,90,6,26,64,15,16,2,29,301,87,97,163,20,8,7,22,74,4]),function(me,e,S,M,P,F,R,m,f,k,O,D,l,E,g,s,a,i,n,r,c,d,t,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xhc=void 0;class u{constructor(z,j){this.d=z,this.e=j}async provideDocumentSymbols(z,j){const K=this.d.getDocument(z),H=await this.e.provideDocumentSymbols(K,j);if(!(0,S.$Kb)(H))return H[0]instanceof c.$oM?H.map(r.DocumentSymbol.from):u.f(H)}static f(z){z=z.slice(0).sort((H,ee)=>{let se=H.location.range.start.compareTo(ee.location.range.start);return se===0&&(se=ee.location.range.end.compareTo(H.location.range.end)),se});const j=[],K=[];for(const H of z){const ee={name:H.name||"!!MISSING: name!!",kind:r.SymbolKind.from(H.kind),tags:H.tags?.map(r.SymbolTag.from)||[],detail:"",containerName:H.containerName,range:r.Range.from(H.location.range),selectionRange:r.Range.from(H.location.range),children:[]};for(;;){if(K.length===0){K.push(ee),j.push(ee);break}const se=K[K.length-1];if(E.$9s.containsRange(se.range,ee.range)&&!E.$9s.equalsRange(se.range,ee.range)){se.children?.push(ee),K.push(ee);break}K.pop()}}return j}}class o{constructor(z,j,K,H,ee,se){this.f=z,this.g=j,this.h=K,this.j=H,this.k=ee,this.l=se,this.d=new t.$Nhc("CodeLens"),this.e=new Map}async provideCodeLenses(z,j){const K=this.f.getDocument(z),H=await this.h.provideCodeLenses(K,j);if(!H||j.isCancellationRequested)return;const ee=this.d.add(H),se=new m.$Sc;this.e.set(ee,se);const Oe={cacheId:ee,lenses:[]};for(let We=0;We<H.length;We++)Oe.lenses.push({cacheId:[ee,We],range:r.Range.from(H[We].range),command:this.g.toInternal(H[We].command,se)});return Oe}async resolveCodeLens(z,j){const K=z.cacheId&&this.d.get(...z.cacheId);if(!K)return;let H;if(typeof this.h.resolveCodeLens!="function"||K.isResolved?H=K:H=await this.h.resolveCodeLens(K,j),H||(H=K),j.isCancellationRequested)return;const ee=z.cacheId&&this.e.get(z.cacheId[0]);if(ee){if(!H.command){const se=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,se),this.l.error(se);return}return z.command=this.g.toInternal(H.command,ee),z}}releaseCodeLenses(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}}function v(je){return Array.isArray(je)?je.map(r.DefinitionLink.from):je?[r.DefinitionLink.from(je)]:[]}class b{constructor(z,j){this.d=z,this.e=j}async provideDefinition(z,j,K){const H=this.d.getDocument(z),ee=r.Position.to(j),se=await this.e.provideDefinition(H,ee,K);return v(se)}}class ${constructor(z,j){this.d=z,this.e=j}async provideDeclaration(z,j,K){const H=this.d.getDocument(z),ee=r.Position.to(j),se=await this.e.provideDeclaration(H,ee,K);return v(se)}}class I{constructor(z,j){this.d=z,this.e=j}async provideImplementation(z,j,K){const H=this.d.getDocument(z),ee=r.Position.to(j),se=await this.e.provideImplementation(H,ee,K);return v(se)}}class h{constructor(z,j){this.d=z,this.e=j}async provideTypeDefinition(z,j,K){const H=this.d.getDocument(z),ee=r.Position.to(j),se=await this.e.provideTypeDefinition(H,ee,K);return v(se)}}class y{constructor(z,j){this.d=z,this.e=j}async provideHover(z,j,K){const H=this.d.getDocument(z),ee=r.Position.to(j),se=await this.e.provideHover(H,ee,K);if(!(!se||(0,S.$Kb)(se.contents)))return se.range||(se.range=H.getWordRangeAtPosition(ee)),se.range||(se.range=new c.$0L(ee,ee)),r.Hover.from(se)}}class w{constructor(z,j){this.d=z,this.e=j}async provideEvaluatableExpression(z,j,K){const H=this.d.getDocument(z),ee=r.Position.to(j),se=await this.e.provideEvaluatableExpression(H,ee,K);if(se)return r.EvaluatableExpression.from(se)}}class A{constructor(z,j){this.d=z,this.e=j}async provideInlineValues(z,j,K,H){const ee=this.d.getDocument(z),se=await this.e.provideInlineValues(ee,r.Range.to(j),r.InlineValueContext.to(K),H);if(Array.isArray(se))return se.map(Oe=>r.InlineValue.from(Oe))}}class N{constructor(z,j){this.d=z,this.e=j}async provideDocumentHighlights(z,j,K){const H=this.d.getDocument(z),ee=r.Position.to(j),se=await this.e.provideDocumentHighlights(H,ee,K);if(Array.isArray(se))return se.map(r.DocumentHighlight.from)}}class G{constructor(z,j){this.d=z,this.e=j}async provideMultiDocumentHighlights(z,j,K,H){const ee=this.d.getDocument(z),se=K.map(Ke=>this.d.getDocument(Ke)),Oe=r.Position.to(j),We=await this.e.provideMultiDocumentHighlights(ee,Oe,se,H);if(Array.isArray(We))return We.map(r.MultiDocumentHighlight.from)}}class V{constructor(z,j){this.d=z,this.e=j}async provideLinkedEditingRanges(z,j,K){const H=this.d.getDocument(z),ee=r.Position.to(j),se=await this.e.provideLinkedEditingRanges(H,ee,K);if(se&&Array.isArray(se.ranges))return{ranges:(0,S.$Hb)(se.ranges.map(r.Range.from)),wordPattern:se.wordPattern}}}class U{constructor(z,j){this.d=z,this.e=j}async provideReferences(z,j,K,H){const ee=this.d.getDocument(z),se=r.Position.to(j),Oe=await this.e.provideReferences(ee,se,K,H);if(Array.isArray(Oe))return Oe.map(r.location.from)}}class C{static{this.d=1e3}constructor(z,j,K,H,ee,se,Oe){this.g=z,this.h=j,this.j=K,this.k=H,this.l=ee,this.m=se,this.n=Oe,this.e=new t.$Nhc("CodeAction"),this.f=new Map}async provideCodeActions(z,j,K,H){const ee=this.g.getDocument(z),se=g.$$s.isISelection(j)?r.Selection.to(j):r.Range.to(j),Oe=[];for(const rt of this.j.getDiagnostics(z))if(se.intersection(rt.range)&&Oe.push(rt)>C.d)break;const We={diagnostics:Oe,only:K.only?new c.$qM(K.only):void 0,triggerKind:r.CodeActionTriggerKind.to(K.trigger)},Ke=await this.k.provideCodeActions(ee,se,We,H);if(!(0,S.$Lb)(Ke)||H.isCancellationRequested)return;const xe=this.e.add(Ke),tt=new m.$Sc;this.f.set(xe,tt);const lt=[];for(let rt=0;rt<Ke.length;rt++){const it=Ke[rt];if(it)if(C.o(it))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),lt.push({_isSynthetic:!0,title:it.title,command:this.h.toInternal(it,tt)});else{We.only&&(it.kind?We.only.contains(it.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${We.only.value} 'requested but returned code action is of kind '${it.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${We.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const at=it.ranges??[];lt.push({cacheId:[xe,rt],title:it.title,command:it.command&&this.h.toInternal(it.command,tt),diagnostics:it.diagnostics&&it.diagnostics.map(r.Diagnostic.from),edit:it.edit&&r.WorkspaceEdit.from(it.edit,void 0),kind:it.kind&&it.kind.value,isPreferred:it.isPreferred,isAI:(0,d.$XF)(this.m,"codeActionAI")?it.isAI:!1,ranges:(0,d.$XF)(this.m,"codeActionRanges")?(0,S.$Hb)(at.map(r.Range.from)):void 0,disabled:it.disabled?.reason})}}return{cacheId:xe,actions:lt}}async resolveCodeAction(z,j){const[K,H]=z,ee=this.e.get(K,H);if(!ee||C.o(ee))return{};if(!this.k.resolveCodeAction)return{};const se=await this.k.resolveCodeAction(ee,j)??ee;let Oe;se.edit&&(Oe=r.WorkspaceEdit.from(se.edit,void 0));let We;if(se.command){const Ke=this.f.get(K);Ke&&(We=this.h.toInternal(se.command,Ke))}return{edit:Oe,command:We}}releaseCodeActions(z){this.f.get(z)?.dispose(),this.f.delete(z),this.e.delete(z)}static o(z){return typeof z.command=="string"&&typeof z.title=="string"}}class L{static toInternalProviderId(z,j){return z+"."+j}constructor(z,j,K,H,ee){this.d=z,this.e=j,this.f=K,this.g=H,this.h=ee}async prepareDocumentPaste(z,j,K,H){if(!this.f.prepareDocumentPaste)return;const ee=this.e.getDocument(z),se=j.map(Ke=>r.Range.to(Ke)),Oe=r.DataTransfer.toDataTransfer(K,()=>{throw new F.$$});if(await this.f.prepareDocumentPaste(ee,se,Oe,H),H.isCancellationRequested)return;const We=Array.from(Oe).filter(([,Ke])=>!(Ke instanceof c.$WM));return r.DataTransfer.from(We)}async providePasteEdits(z,j,K,H,ee){if(!this.f.provideDocumentPasteEdits)return;const se=this.e.getDocument(j),Oe=K.map(xe=>r.Range.to(xe)),We=r.DataTransfer.toDataTransfer(H,async xe=>(await this.d.$resolvePasteFileData(this.g,z,xe)).buffer),Ke=await this.f.provideDocumentPasteEdits(se,Oe,We,ee);if(Ke)return{label:Ke.label??(0,i.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:Ke.yieldTo?.map(xe=>"mimeType"in xe?xe:{providerId:L.toInternalProviderId(xe.extensionId,xe.providerId)}),insertText:typeof Ke.insertText=="string"?Ke.insertText:{snippet:Ke.insertText.value},additionalEdit:Ke.additionalEdit?r.WorkspaceEdit.from(Ke.additionalEdit,void 0):void 0}}}class q{constructor(z,j){this.d=z,this.e=j}async provideDocumentFormattingEdits(z,j,K){const H=this.d.getDocument(z),ee=await this.e.provideDocumentFormattingEdits(H,j,K);if(Array.isArray(ee))return ee.map(r.TextEdit.from)}}class ne{constructor(z,j){this.d=z,this.e=j}async provideDocumentRangeFormattingEdits(z,j,K,H){const ee=this.d.getDocument(z),se=r.Range.to(j),Oe=await this.e.provideDocumentRangeFormattingEdits(ee,se,K,H);if(Array.isArray(Oe))return Oe.map(r.TextEdit.from)}async provideDocumentRangesFormattingEdits(z,j,K,H){(0,D.$3f)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ee=this.d.getDocument(z),se=j.map(r.Range.to),Oe=await this.e.provideDocumentRangesFormattingEdits(ee,se,K,H);if(Array.isArray(Oe))return Oe.map(r.TextEdit.from)}}class ae{constructor(z,j){this.d=z,this.e=j,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(z,j,K,H,ee){const se=this.d.getDocument(z),Oe=r.Position.to(j),We=await this.e.provideOnTypeFormattingEdits(se,Oe,K,H,ee);if(Array.isArray(We))return We.map(r.TextEdit.from)}}class ye{constructor(z,j){this.e=z,this.f=j,this.d=new t.$Nhc("WorkspaceSymbols")}async provideWorkspaceSymbols(z,j){const K=await this.e.provideWorkspaceSymbols(z,j);if(!(0,S.$Lb)(K))return{symbols:[]};const H=this.d.add(K),ee={cacheId:H,symbols:[]};for(let se=0;se<K.length;se++){const Oe=K[se];if(!Oe||!Oe.name){this.f.warn("INVALID SymbolInformation",Oe);continue}ee.symbols.push({...r.WorkspaceSymbol.from(Oe),cacheId:[H,se]})}return ee}async resolveWorkspaceSymbol(z,j){if(typeof this.e.resolveWorkspaceSymbol!="function"||!z.cacheId)return z;const K=this.d.get(...z.cacheId);if(K){const H=await this.e.resolveWorkspaceSymbol(K,j);return H&&(0,f.$Nn)(z,r.WorkspaceSymbol.from(H),!0)}}releaseWorkspaceSymbols(z){this.d.delete(z)}}class Ie{static supportsResolving(z){return typeof z.prepareRename=="function"}constructor(z,j,K){this.d=z,this.e=j,this.f=K}async provideRenameEdits(z,j,K,H){const ee=this.d.getDocument(z),se=r.Position.to(j);try{const Oe=await this.e.provideRenameEdits(ee,se,K,H);return Oe?r.WorkspaceEdit.from(Oe):void 0}catch(Oe){const We=Ie.g(Oe);return We?{rejectReason:We,edits:void 0}:Promise.reject(Oe)}}async resolveRenameLocation(z,j,K){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const H=this.d.getDocument(z),ee=r.Position.to(j);try{const se=await this.e.prepareRename(H,ee,K);let Oe,We;if(c.$0L.isRange(se)?(Oe=se,We=H.getText(se)):(0,D.$Uf)(se)&&(Oe=se.range,We=se.placeholder),!Oe||!We)return;if(Oe.start.line>ee.line||Oe.end.line<ee.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:r.Range.from(Oe),text:We}}catch(se){const Oe=Ie.g(se);return Oe?{rejectReason:Oe,range:void 0,text:void 0}:Promise.reject(se)}}static g(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class ue{constructor(z,j,K){this.d=z,this.e=j,this.f=K}async provideNewSymbolNames(z,j,K){const H=this.d.getDocument(z),ee=r.Range.to(j);try{const se=await this.e.provideNewSymbolNames(H,ee,K);return se?se.map(Oe=>typeof Oe=="string"?{newSymbolName:Oe}:{newSymbolName:Oe.newSymbolName,tags:Oe.tags}):void 0}catch(se){this.f.error(ue.g(se)??JSON.stringify(se,null,"	"));return}}static g(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class ve{constructor(z,j){this.resultId=z,this.tokens=j}}class re{constructor(z,j){this.f=z,this.g=j,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(z,j,K){const H=this.f.getDocument(z),ee=j!==0?this.d.get(j):null;let se=typeof ee?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(H,ee.resultId,K):await this.g.provideDocumentSemanticTokens(H,K);return ee&&this.d.delete(j),se?(se=re.h(se),this.o(re.n(ee,se),se)):null}async releaseDocumentSemanticColoring(z){this.d.delete(z)}static h(z){return re.j(z)?re.k(z)?z:new c.$oN(new Uint32Array(z.data),z.resultId):re.l(z)?re.m(z)?z:new c.$qN(z.edits.map(j=>new c.$pN(j.start,j.deleteCount,j.data?new Uint32Array(j.data):j.data)),z.resultId):z}static j(z){return z&&!!z.data}static k(z){return z.data instanceof Uint32Array}static l(z){return z&&Array.isArray(z.edits)}static m(z){for(const j of z.edits)if(!(j.data instanceof Uint32Array))return!1;return!0}static n(z,j){if(!re.j(j)||!z||!z.tokens)return j;const K=z.tokens,H=K.length,ee=j.data,se=ee.length;let Oe=0;const We=Math.min(H,se);for(;Oe<We&&K[Oe]===ee[Oe];)Oe++;if(Oe===H&&Oe===se)return new c.$qN([],j.resultId);let Ke=0;const xe=We-Oe;for(;Ke<xe&&K[H-Ke-1]===ee[se-Ke-1];)Ke++;return new c.$qN([{start:Oe,deleteCount:H-Oe-Ke,data:ee.subarray(Oe,se-Ke)}],j.resultId)}o(z,j){if(re.j(z)){const K=this.e++;return this.d.set(K,new ve(z.resultId,z.data)),(0,a.$dab)({id:K,type:"full",data:z.data})}if(re.l(z)){const K=this.e++;return re.j(j)?this.d.set(K,new ve(j.resultId,j.data)):this.d.set(K,new ve(z.resultId)),(0,a.$dab)({id:K,type:"delta",deltas:(z.edits||[]).map(H=>({start:H.start,deleteCount:H.deleteCount,data:H.data}))})}return null}}class $e{constructor(z,j){this.d=z,this.e=j}async provideDocumentRangeSemanticTokens(z,j,K){const H=this.d.getDocument(z),ee=await this.e.provideDocumentRangeSemanticTokens(H,r.Range.to(j),K);return ee?this.f(ee):null}f(z){return(0,a.$dab)({id:0,type:"full",data:z.data})}}class ie{static supportsResolving(z){return typeof z.resolveCompletionItem=="function"}constructor(z,j,K,H,ee){this.f=z,this.g=j,this.h=K,this.j=H,this.k=ee,this.d=new t.$Nhc("CompletionItem"),this.e=new Map}async provideCompletionItems(z,j,K,H){const ee=this.f.getDocument(z),se=r.Position.to(j),Oe=ee.getWordRangeAtPosition(se)||new c.$0L(se,se),We=Oe.with({end:se}),Ke=new k.$1d,xe=await this.h.provideCompletionItems(ee,se,H,r.CompletionContext.to(K));if(!xe||H.isCancellationRequested)return;const tt=Array.isArray(xe)?new c.$DM(xe):xe,lt=ie.supportsResolving(this.h)?this.d.add(tt.items):this.d.add([]),rt=new m.$Sc;this.e.set(lt,rt);const it=[],at={x:lt,b:it,a:{replace:r.Range.from(Oe),insert:r.Range.from(We)},c:tt.isIncomplete||void 0,d:Ke.elapsed()};for(let Be=0;Be<tt.items.length;Be++){const et=tt.items[Be],Z=this.l(et,[lt,Be],We,Oe);it.push(Z)}return at}async resolveCompletionItem(z,j){if(typeof this.h.resolveCompletionItem!="function")return;const K=this.d.get(...z);if(!K)return;const H=this.l(K,z),ee=await this.h.resolveCompletionItem(K,j);if(!ee)return;const se=this.l(ee,z);return(H.h!==se.h||H.i!==se.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(H.n!==se.n||H.o!==se.o||!(0,f.$On)(H.p,se.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...H,d:se.d,c:se.c,l:se.l,h:se.h,i:se.i,n:se.n,o:se.o,p:se.p}}releaseCompletionItems(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}l(z,j,K,H){const ee=this.e.get(j[0]);if(!ee)throw Error("DisposableStore is missing...");const se=this.g.toInternal(z.command,ee),Oe={x:j,a:z.label,b:z.kind!==void 0?r.CompletionItemKind.from(z.kind):void 0,m:z.tags&&z.tags.map(r.CompletionItemTag.from),c:z.detail,d:typeof z.documentation>"u"?void 0:r.MarkdownString.fromStrict(z.documentation),e:z.sortText!==z.label?z.sortText:void 0,f:z.filterText!==z.label?z.filterText:void 0,g:z.preselect||void 0,i:z.keepWhitespace?1:0,k:z.commitCharacters?.join(""),l:z.additionalTextEdits&&z.additionalTextEdits.map(r.TextEdit.from),n:se?.$ident,o:se?.id,p:se?.$ident?void 0:se?.arguments};z.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Oe.h=z.textEdit.newText):typeof z.insertText=="string"?Oe.h=z.insertText:z.insertText instanceof c.$gM&&(Oe.h=z.insertText.value,Oe.i|=4);let We;return z.textEdit?We=z.textEdit.range:z.range&&(We=z.range),c.$0L.isRange(We)?Oe.j=r.Range.from(We):We&&(!K?.isEqual(We.inserting)||!H?.isEqual(We.replacing))&&(Oe.j={insert:r.Range.from(We.inserting),replace:r.Range.from(We.replacing)}),Oe}}class le{async provideInlineCompletions(z,j,K,H){}disposeCompletions(z){}handleDidShowCompletionItem(z,j,K){}handlePartialAccept(z,j,K){}}class W extends le{constructor(z,j,K,H){super(),this.f=z,this.g=j,this.h=K,this.j=H,this.d=new ke,this.e=(0,d.$XF)(this.f,"inlineCompletionsAdditions"),this.k={[s.InlineCompletionTriggerKind.Automatic]:c.InlineCompletionTriggerKind.Automatic,[s.InlineCompletionTriggerKind.Explicit]:c.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,d.$XF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(z,j,K,H){const ee=this.g.getDocument(z),se=r.Position.to(j),Oe=await this.h.provideInlineCompletionItems(ee,se,{selectedCompletionInfo:K.selectedSuggestionInfo?{range:r.Range.to(K.selectedSuggestionInfo.range),text:K.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[K.triggerKind]},H);if(!Oe||H.isCancellationRequested)return;const We=Array.isArray(Oe)?Oe:Oe.items,Ke=this.e?Array.isArray(Oe)?[]:Oe.commands||[]:[],xe=this.e&&!Array.isArray(Oe)?Oe.enableForwardStability:void 0;let tt;return{pid:this.d.createReferenceId({dispose(){tt?.dispose()},items:We}),items:We.map((rt,it)=>{let at;rt.command&&(tt||(tt=new m.$Sc),at=this.j.toInternal(rt.command,tt));const Be=rt.insertText;return{insertText:typeof Be=="string"?Be:{snippet:Be.value},filterText:rt.filterText,range:rt.range?r.Range.from(rt.range):void 0,command:at,idx:it,completeBracketPairs:this.e?rt.completeBracketPairs:!1}}),commands:Ke.map(rt=>(tt||(tt=new m.$Sc),this.j.toInternal(rt,tt))),suppressSuggestions:!1,enableForwardStability:xe}}disposeCompletions(z){this.d.disposeReferenceId(z)?.dispose()}handleDidShowCompletionItem(z,j,K){const H=this.d.get(z)?.items[j];H&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(H,K)}handlePartialAccept(z,j,K){const H=this.d.get(z)?.items[j];H&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(H,K)}}class _{async provideInlineEdits(z,j,K){const H=this.f.getDocument(z),ee=await this.g.provideInlineEdit(H,{triggerKind:this.e[j.triggerKind]},K);if(!ee||K.isCancellationRequested)return;let se;const Oe=this.d.createReferenceId({dispose(){se?.dispose()},item:ee});let We;ee.accepted&&(se||(se=new m.$Sc),We=this.h.toInternal(ee.accepted,se));let Ke;return ee.rejected&&(se||(se=new m.$Sc),Ke=this.h.toInternal(ee.rejected,se)),{pid:Oe,text:ee.text,range:r.Range.from(ee.range),accepted:We,rejected:Ke}}disposeEdit(z){this.d.disposeReferenceId(z)?.dispose()}constructor(z,j,K,H){this.f=j,this.g=K,this.h=H,this.d=new ke,this.e={[s.InlineEditTriggerKind.Automatic]:c.InlineEditTriggerKind.Automatic,[s.InlineEditTriggerKind.Invoke]:c.InlineEditTriggerKind.Invoke}}}class ke{constructor(){this.d=new Map,this.e=1}createReferenceId(z){const j=this.e++;return this.d.set(j,z),j}disposeReferenceId(z){const j=this.d.get(z);return this.d.delete(z),j}get(z){return this.d.get(z)}}class Ne{constructor(z,j){this.e=z,this.f=j,this.d=new t.$Nhc("SignatureHelp")}async provideSignatureHelp(z,j,K,H){const ee=this.e.getDocument(z),se=r.Position.to(j),Oe=this.g(K),We=await this.f.provideSignatureHelp(ee,se,H,Oe);if(We){const Ke=this.d.add([We]);return{...r.SignatureHelp.from(We),id:Ke}}}g(z){let j;if(z.activeSignatureHelp){const K=r.SignatureHelp.to(z.activeSignatureHelp),H=this.d.get(z.activeSignatureHelp.id,0);H?(j=H,j.activeSignature=K.activeSignature,j.activeParameter=K.activeParameter):j=K}return{...z,activeSignatureHelp:j}}releaseSignatureHelp(z){this.d.delete(z)}}class De{constructor(z,j,K,H,ee){this.f=z,this.g=j,this.h=K,this.j=H,this.k=ee,this.d=new t.$Nhc("InlayHints"),this.e=new Map}async provideInlayHints(z,j,K){const H=this.f.getDocument(z),ee=r.Range.to(j),se=await this.h.provideInlayHints(H,ee,K);if(!Array.isArray(se)||se.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(j)}`);return}if(K.isCancellationRequested)return;const Oe=this.d.add(se);this.e.set(Oe,new m.$Sc);const We={hints:[],cacheId:Oe};for(let Ke=0;Ke<se.length;Ke++)this.l(se[Ke],ee)&&We.hints.push(this.m(se[Ke],[Oe,Ke]));return this.j.trace(`[InlayHints] ${We.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(j)}`),We}async resolveInlayHint(z,j){if(typeof this.h.resolveInlayHint!="function")return;const K=this.d.get(...z);if(!K)return;const H=await this.h.resolveInlayHint(K,j);if(H&&this.l(H))return this.m(H,z)}releaseHints(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}l(z,j){return z.label.length===0||Array.isArray(z.label)&&z.label.every(K=>K.value.length===0)?(console.log("INVALID inlay hint, empty label",z),!1):!(j&&!j.contains(z.position))}m(z,j){const K=this.e.get(j[0]);if(!K)throw Error("DisposableStore is missing...");const H={label:"",cacheId:j,tooltip:r.MarkdownString.fromStrict(z.tooltip),position:r.Position.from(z.position),textEdits:z.textEdits&&z.textEdits.map(r.TextEdit.from),kind:z.kind&&r.InlayHintKind.from(z.kind),paddingLeft:z.paddingLeft,paddingRight:z.paddingRight};if(typeof z.label=="string")H.label=z.label;else{const ee=[];H.label=ee;for(const se of z.label){if(!se.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Oe={label:se.value,tooltip:r.MarkdownString.fromStrict(se.tooltip)};c.$hM.isLocation(se.location)&&(Oe.location=r.location.from(se.location)),se.command&&(Oe.command=this.g.toInternal(se.command,K)),ee.push(Oe)}}return H}}class be{constructor(z,j){this.e=z,this.f=j,this.d=new t.$Nhc("DocumentLink")}async provideLinks(z,j){const K=this.e.getDocument(z),H=await this.f.provideDocumentLinks(K,j);if(!(!Array.isArray(H)||H.length===0)&&!j.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:H.filter(be.g).map(r.DocumentLink.from)};{const ee=this.d.add(H),se={links:[],cacheId:ee};for(let Oe=0;Oe<H.length;Oe++){if(!be.g(H[Oe]))continue;const We=r.DocumentLink.from(H[Oe]);We.cacheId=[ee,Oe],se.links.push(We)}return se}}}static g(z){return z.target&&z.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(z,j){if(typeof this.f.resolveDocumentLink!="function")return;const K=this.d.get(...z);if(!K)return;const H=await this.f.resolveDocumentLink(K,j);if(!(!H||!be.g(H)))return r.DocumentLink.from(H)}releaseLinks(z){this.d.delete(z)}}class ge{constructor(z,j){this.d=z,this.e=j}async provideColors(z,j){const K=this.d.getDocument(z),H=await this.e.provideDocumentColors(K,j);return Array.isArray(H)?H.map(se=>({color:r.Color.from(se.color),range:r.Range.from(se.range)})):[]}async provideColorPresentations(z,j,K){const H=this.d.getDocument(z),ee=r.Range.to(j.range),se=r.Color.to(j.color),Oe=await this.e.provideColorPresentations(se,{document:H,range:ee},K);if(Array.isArray(Oe))return Oe.map(r.ColorPresentation.from)}}class J{constructor(z,j){this.d=z,this.e=j}async provideFoldingRanges(z,j,K){const H=this.d.getDocument(z),ee=await this.e.provideFoldingRanges(H,j,K);if(Array.isArray(ee))return ee.map(r.FoldingRange.from)}}class X{constructor(z,j,K){this.d=z,this.e=j,this.f=K}async provideSelectionRanges(z,j,K){const H=this.d.getDocument(z),ee=j.map(r.Position.to),se=await this.e.provideSelectionRanges(H,ee,K);if(!(0,S.$Lb)(se))return[];if(se.length!==ee.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Oe=[];for(let We=0;We<ee.length;We++){const Ke=[];Oe.push(Ke);let xe=ee[We],tt=se[We];for(;;){if(!tt.range.contains(xe))throw new Error("INVALID selection range, must contain the previous range");if(Ke.push(r.SelectionRange.from(tt)),!tt.parent)break;xe=tt.range,tt=tt.parent}}return Oe}}class he{constructor(z,j){this.f=z,this.g=j,this.d=new R.$qO(""),this.e=new Map}async prepareSession(z,j,K){const H=this.f.getDocument(z),ee=r.Position.to(j),se=await this.g.prepareCallHierarchy(H,ee,K);if(!se)return;const Oe=this.d.nextId();return this.e.set(Oe,new Map),Array.isArray(se)?se.map(We=>this.h(Oe,We)):[this.h(Oe,se)]}async provideCallsTo(z,j,K){const H=this.j(z,j);if(!H)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyIncomingCalls(H,K);if(ee)return ee.map(se=>({from:this.h(z,se.from),fromRanges:se.fromRanges.map(Oe=>r.Range.from(Oe))}))}async provideCallsFrom(z,j,K){const H=this.j(z,j);if(!H)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyOutgoingCalls(H,K);if(ee)return ee.map(se=>({to:this.h(z,se.to),fromRanges:se.fromRanges.map(Oe=>r.Range.from(Oe))}))}releaseSession(z){this.e.delete(z)}h(z,j){const K=this.e.get(z),H=r.CallHierarchyItem.from(j,z,K.size.toString(36));return K.set(H._itemId,j),H}j(z,j){return this.e.get(z)?.get(j)}}class fe{constructor(z,j){this.f=z,this.g=j,this.d=new R.$qO(""),this.e=new Map}async prepareSession(z,j,K){const H=this.f.getDocument(z),ee=r.Position.to(j),se=await this.g.prepareTypeHierarchy(H,ee,K);if(!se)return;const Oe=this.d.nextId();return this.e.set(Oe,new Map),Array.isArray(se)?se.map(We=>this.h(Oe,We)):[this.h(Oe,se)]}async provideSupertypes(z,j,K){const H=this.j(z,j);if(!H)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySupertypes(H,K);if(ee)return ee.map(se=>this.h(z,se))}async provideSubtypes(z,j,K){const H=this.j(z,j);if(!H)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySubtypes(H,K);if(ee)return ee.map(se=>this.h(z,se))}releaseSession(z){this.e.delete(z)}h(z,j){const K=this.e.get(z),H=r.TypeHierarchyItem.from(j,z,K.size.toString(36));return K.set(H._itemId,j),H}j(z,j){return this.e.get(z)?.get(j)}}class Fe{static toInternalProviderId(z,j){return z+"."+j}constructor(z,j,K,H,ee){this.d=z,this.e=j,this.f=K,this.g=H,this.h=ee}async provideDocumentOnDropEdits(z,j,K,H,ee){const se=this.e.getDocument(j),Oe=r.Position.to(K),We=r.DataTransfer.toDataTransfer(H,async xe=>(await this.d.$resolveDocumentOnDropFileData(this.g,z,xe)).buffer),Ke=await this.f.provideDocumentDropEdits(se,Oe,We,ee);if(Ke)return{label:Ke.label??(0,i.localize)(1,null,this.h.displayName||this.h.name),yieldTo:Ke.yieldTo?.map(xe=>"mimeType"in xe?xe:{providerId:Fe.toInternalProviderId(xe.extensionId,xe.providerId)}),insertText:typeof Ke.insertText=="string"?Ke.insertText:{snippet:Ke.insertText.value},additionalEdit:Ke.additionalEdit?r.WorkspaceEdit.from(Ke.additionalEdit,void 0):void 0}}}class de{constructor(z,j){this.d=z,this.e=j}async provideMappedEdits(z,j,K,H){const ee=l.URI.revive(z),se=this.d.getDocument(ee),Oe=K.documents.map(xe=>xe.map(tt=>({uri:l.URI.revive(tt.uri),version:tt.version,ranges:tt.ranges.map(lt=>r.Range.to(lt))}))),We={documents:Oe,selections:Oe[0]?.[0]?.ranges??[]},Ke=await this.e.provideMappedEdits(se,j,We,H);return Ke?r.WorkspaceEdit.from(Ke):null}}class Ce{constructor(z,j){this.adapter=z,this.extension=j}}class Ae{static{this.d=0}constructor(z,j,K,H,ee,se,Oe,We){this.g=j,this.h=K,this.j=H,this.k=ee,this.l=se,this.m=Oe,this.n=We,this.f=new Map,this.e=z.getProxy(p.$6L.MainThreadLanguageFeatures)}o(z,j){return r.DocumentSelector.from(z,this.g,j)}p(z){return new c.$8L(()=>{this.f.delete(z),this.e.$unregister(z)})}q(){return Ae.d++}async s(z,j,K,H,ee,se=!1){const Oe=this.f.get(z);if(!Oe||!(Oe.adapter instanceof j))return H;const We=Date.now();se||this.l.trace(`[${Oe.extension.identifier.value}] INVOKE provider '${K.toString().replace(/[\r\n]/g,"")}'`);const Ke=K(Oe.adapter,Oe.extension);return Promise.resolve(Ke).catch(xe=>{(0,F.$4)(xe)||(this.l.error(`[${Oe.extension.identifier.value}] provider FAILED`),this.l.error(xe),this.n.onExtensionError(Oe.extension.identifier,xe))}).finally(()=>{se||this.l.trace(`[${Oe.extension.identifier.value}] provider DONE after ${Date.now()-We}ms`)}),P.CancellationToken.isCancellationToken(ee)?(0,M.$7g)(Ke,ee):Ke}t(z,j){const K=this.q();return this.f.set(K,new Ce(z,j)),K}static u(z){return z.displayName||z.name}registerDocumentSymbolProvider(z,j,K,H){const ee=this.t(new u(this.h,K),z),se=H&&H.label||Ae.u(z);return this.e.$registerDocumentSymbolProvider(ee,this.o(j,z),se),this.p(ee)}$provideDocumentSymbols(z,j,K){return this.s(z,u,H=>H.provideDocumentSymbols(l.URI.revive(j),K),void 0,K)}registerCodeLensProvider(z,j,K){const H=this.q(),ee=typeof K.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(H,new Ce(new o(this.h,this.j.converter,K,z,this.n,this.l),z)),this.e.$registerCodeLensSupport(H,this.o(j,z),ee);let se=this.p(H);if(ee!==void 0){const Oe=K.onDidChangeCodeLenses(We=>this.e.$emitCodeLensEvent(ee));se=c.$8L.from(se,Oe)}return se}$provideCodeLenses(z,j,K){return this.s(z,o,H=>H.provideCodeLenses(l.URI.revive(j),K),void 0,K)}$resolveCodeLens(z,j,K){return this.s(z,o,H=>H.resolveCodeLens(j,K),void 0,void 0)}$releaseCodeLenses(z,j){this.s(z,o,K=>Promise.resolve(K.releaseCodeLenses(j)),void 0,void 0)}registerDefinitionProvider(z,j,K){const H=this.t(new b(this.h,K),z);return this.e.$registerDefinitionSupport(H,this.o(j,z)),this.p(H)}$provideDefinition(z,j,K,H){return this.s(z,b,ee=>ee.provideDefinition(l.URI.revive(j),K,H),[],H)}registerDeclarationProvider(z,j,K){const H=this.t(new $(this.h,K),z);return this.e.$registerDeclarationSupport(H,this.o(j,z)),this.p(H)}$provideDeclaration(z,j,K,H){return this.s(z,$,ee=>ee.provideDeclaration(l.URI.revive(j),K,H),[],H)}registerImplementationProvider(z,j,K){const H=this.t(new I(this.h,K),z);return this.e.$registerImplementationSupport(H,this.o(j,z)),this.p(H)}$provideImplementation(z,j,K,H){return this.s(z,I,ee=>ee.provideImplementation(l.URI.revive(j),K,H),[],H)}registerTypeDefinitionProvider(z,j,K){const H=this.t(new h(this.h,K),z);return this.e.$registerTypeDefinitionSupport(H,this.o(j,z)),this.p(H)}$provideTypeDefinition(z,j,K,H){return this.s(z,h,ee=>ee.provideTypeDefinition(l.URI.revive(j),K,H),[],H)}registerHoverProvider(z,j,K,H){const ee=this.t(new y(this.h,K),z);return this.e.$registerHoverProvider(ee,this.o(j,z)),this.p(ee)}$provideHover(z,j,K,H){return this.s(z,y,ee=>ee.provideHover(l.URI.revive(j),K,H),void 0,H)}registerEvaluatableExpressionProvider(z,j,K,H){const ee=this.t(new w(this.h,K),z);return this.e.$registerEvaluatableExpressionProvider(ee,this.o(j,z)),this.p(ee)}$provideEvaluatableExpression(z,j,K,H){return this.s(z,w,ee=>ee.provideEvaluatableExpression(l.URI.revive(j),K,H),void 0,H)}registerInlineValuesProvider(z,j,K,H){const ee=typeof K.onDidChangeInlineValues=="function"?this.q():void 0,se=this.t(new A(this.h,K),z);this.e.$registerInlineValuesProvider(se,this.o(j,z),ee);let Oe=this.p(se);if(ee!==void 0){const We=K.onDidChangeInlineValues(Ke=>this.e.$emitInlineValuesEvent(ee));Oe=c.$8L.from(Oe,We)}return Oe}$provideInlineValues(z,j,K,H,ee){return this.s(z,A,se=>se.provideInlineValues(l.URI.revive(j),K,H,ee),void 0,ee)}registerDocumentHighlightProvider(z,j,K){const H=this.t(new N(this.h,K),z);return this.e.$registerDocumentHighlightProvider(H,this.o(j,z)),this.p(H)}registerMultiDocumentHighlightProvider(z,j,K){const H=this.t(new G(this.h,K),z);return this.e.$registerMultiDocumentHighlightProvider(H,this.o(j,z)),this.p(H)}$provideDocumentHighlights(z,j,K,H){return this.s(z,N,ee=>ee.provideDocumentHighlights(l.URI.revive(j),K,H),void 0,H)}$provideMultiDocumentHighlights(z,j,K,H,ee){return this.s(z,G,se=>se.provideMultiDocumentHighlights(l.URI.revive(j),K,H.map(Oe=>l.URI.revive(Oe)),ee),void 0,ee)}registerLinkedEditingRangeProvider(z,j,K){const H=this.t(new V(this.h,K),z);return this.e.$registerLinkedEditingRangeProvider(H,this.o(j,z)),this.p(H)}$provideLinkedEditingRanges(z,j,K,H){return this.s(z,V,async ee=>{const se=await ee.provideLinkedEditingRanges(l.URI.revive(j),K,H);if(se)return{ranges:se.ranges,wordPattern:se.wordPattern?Ae.w(se.wordPattern):void 0}},void 0,H)}registerReferenceProvider(z,j,K){const H=this.t(new U(this.h,K),z);return this.e.$registerReferenceSupport(H,this.o(j,z)),this.p(H)}$provideReferences(z,j,K,H,ee){return this.s(z,U,se=>se.provideReferences(l.URI.revive(j),K,H,ee),void 0,ee)}registerCodeActionProvider(z,j,K,H){const ee=new m.$Sc,se=this.t(new C(this.h,this.j.converter,this.k,K,this.l,z,this.m),z);return this.e.$registerQuickFixSupport(se,this.o(j,z),{providedKinds:H?.providedCodeActionKinds?.map(Oe=>Oe.value),documentation:H?.documentation?.map(Oe=>({kind:Oe.kind.value,command:this.j.converter.toInternal(Oe.command,ee)}))},Ae.u(z),!!K.resolveCodeAction),ee.add(this.p(se)),ee}$provideCodeActions(z,j,K,H,ee){return this.s(z,C,se=>se.provideCodeActions(l.URI.revive(j),K,H,ee),void 0,ee)}$resolveCodeAction(z,j,K){return this.s(z,C,H=>H.resolveCodeAction(j,K),{},void 0)}$releaseCodeActions(z,j){this.s(z,C,K=>Promise.resolve(K.releaseCodeActions(j)),void 0,void 0)}registerDocumentFormattingEditProvider(z,j,K){const H=this.t(new q(this.h,K),z);return this.e.$registerDocumentFormattingSupport(H,this.o(j,z),z.identifier,z.displayName||z.name),this.p(H)}$provideDocumentFormattingEdits(z,j,K,H){return this.s(z,q,ee=>ee.provideDocumentFormattingEdits(l.URI.revive(j),K,H),void 0,H)}registerDocumentRangeFormattingEditProvider(z,j,K){const H=typeof K.provideDocumentRangesFormattingEdits=="function",ee=this.t(new ne(this.h,K),z);return this.e.$registerRangeFormattingSupport(ee,this.o(j,z),z.identifier,z.displayName||z.name,H),this.p(ee)}$provideDocumentRangeFormattingEdits(z,j,K,H,ee){return this.s(z,ne,se=>se.provideDocumentRangeFormattingEdits(l.URI.revive(j),K,H,ee),void 0,ee)}$provideDocumentRangesFormattingEdits(z,j,K,H,ee){return this.s(z,ne,se=>se.provideDocumentRangesFormattingEdits(l.URI.revive(j),K,H,ee),void 0,ee)}registerOnTypeFormattingEditProvider(z,j,K,H){const ee=this.t(new ae(this.h,K),z);return this.e.$registerOnTypeFormattingSupport(ee,this.o(j,z),H,z.identifier),this.p(ee)}$provideOnTypeFormattingEdits(z,j,K,H,ee,se){return this.s(z,ae,Oe=>Oe.provideOnTypeFormattingEdits(l.URI.revive(j),K,H,ee,se),void 0,se)}registerWorkspaceSymbolProvider(z,j){const K=this.t(new ye(j,this.l),z);return this.e.$registerNavigateTypeSupport(K,typeof j.resolveWorkspaceSymbol=="function"),this.p(K)}$provideWorkspaceSymbols(z,j,K){return this.s(z,ye,H=>H.provideWorkspaceSymbols(j,K),{symbols:[]},K)}$resolveWorkspaceSymbol(z,j,K){return this.s(z,ye,H=>H.resolveWorkspaceSymbol(j,K),void 0,void 0)}$releaseWorkspaceSymbols(z,j){this.s(z,ye,K=>K.releaseWorkspaceSymbols(j),void 0,void 0)}registerRenameProvider(z,j,K){const H=this.t(new Ie(this.h,K,this.l),z);return this.e.$registerRenameSupport(H,this.o(j,z),Ie.supportsResolving(K)),this.p(H)}$provideRenameEdits(z,j,K,H,ee){return this.s(z,Ie,se=>se.provideRenameEdits(l.URI.revive(j),K,H,ee),void 0,ee)}$resolveRenameLocation(z,j,K,H){return this.s(z,Ie,ee=>ee.resolveRenameLocation(l.URI.revive(j),K,H),void 0,H)}registerNewSymbolNamesProvider(z,j,K){const H=this.t(new ue(this.h,K,this.l),z);return this.e.$registerNewSymbolNamesProvider(H,this.o(j,z)),this.p(H)}$provideNewSymbolNames(z,j,K,H){return this.s(z,ue,ee=>ee.provideNewSymbolNames(l.URI.revive(j),K,H),void 0,H)}registerDocumentSemanticTokensProvider(z,j,K,H){const ee=this.t(new re(this.h,K),z),se=typeof K.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ee,this.o(j,z),H,se);let Oe=this.p(ee);if(se){const We=K.onDidChangeSemanticTokens(Ke=>this.e.$emitDocumentSemanticTokensEvent(se));Oe=c.$8L.from(Oe,We)}return Oe}$provideDocumentSemanticTokens(z,j,K,H){return this.s(z,re,ee=>ee.provideDocumentSemanticTokens(l.URI.revive(j),K,H),null,H)}$releaseDocumentSemanticTokens(z,j){this.s(z,re,K=>K.releaseDocumentSemanticColoring(j),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(z,j,K,H){const ee=this.t(new $e(this.h,K),z);return this.e.$registerDocumentRangeSemanticTokensProvider(ee,this.o(j,z),H),this.p(ee)}$provideDocumentRangeSemanticTokens(z,j,K,H){return this.s(z,$e,ee=>ee.provideDocumentRangeSemanticTokens(l.URI.revive(j),K,H),null,H)}registerCompletionItemProvider(z,j,K,H){const ee=this.t(new ie(this.h,this.j.converter,K,this.m,z),z);return this.e.$registerCompletionsProvider(ee,this.o(j,z),H,ie.supportsResolving(K),z.identifier),this.p(ee)}$provideCompletionItems(z,j,K,H,ee){return this.s(z,ie,se=>se.provideCompletionItems(l.URI.revive(j),K,H,ee),void 0,ee)}$resolveCompletionItem(z,j,K){return this.s(z,ie,H=>H.resolveCompletionItem(j,K),void 0,K)}$releaseCompletionItems(z,j){this.s(z,ie,K=>K.releaseCompletionItems(j),void 0,void 0)}registerInlineCompletionsProvider(z,j,K,H){const ee=new W(z,this.h,K,this.j.converter),se=this.t(ee,z);return this.e.$registerInlineCompletionsSupport(se,this.o(j,z),ee.supportsHandleEvents,n.$zm.toKey(z.identifier.value),H?.yieldTo?.map(Oe=>n.$zm.toKey(Oe))||[]),this.p(se)}$provideInlineCompletions(z,j,K,H,ee){return this.s(z,le,se=>se.provideInlineCompletions(l.URI.revive(j),K,H,ee),void 0,ee)}$handleInlineCompletionDidShow(z,j,K,H){this.s(z,le,async ee=>{ee.handleDidShowCompletionItem(j,K,H)},void 0,void 0)}$handleInlineCompletionPartialAccept(z,j,K,H){this.s(z,le,async ee=>{ee.handlePartialAccept(j,K,H)},void 0,void 0)}$freeInlineCompletionsList(z,j){this.s(z,le,async K=>{K.disposeCompletions(j)},void 0,void 0)}registerInlineEditProvider(z,j,K){const H=new _(z,this.h,K,this.j.converter),ee=this.t(H,z);return this.e.$registerInlineEditProvider(ee,this.o(j,z),z.identifier),this.p(ee)}$provideInlineEdit(z,j,K,H){return this.s(z,_,ee=>ee.provideInlineEdits(l.URI.revive(j),K,H),void 0,H)}$freeInlineEdit(z,j){this.s(z,_,async K=>{K.disposeEdit(j)},void 0,void 0)}registerSignatureHelpProvider(z,j,K,H){const ee=Array.isArray(H)?{triggerCharacters:H,retriggerCharacters:[]}:H,se=this.t(new Ne(this.h,K),z);return this.e.$registerSignatureHelpProvider(se,this.o(j,z),ee),this.p(se)}$provideSignatureHelp(z,j,K,H,ee){return this.s(z,Ne,se=>se.provideSignatureHelp(l.URI.revive(j),K,H,ee),void 0,ee)}$releaseSignatureHelp(z,j){this.s(z,Ne,K=>K.releaseSignatureHelp(j),void 0,void 0)}registerInlayHintsProvider(z,j,K){const H=typeof K.onDidChangeInlayHints=="function"?this.q():void 0,ee=this.t(new De(this.h,this.j.converter,K,this.l,z),z);this.e.$registerInlayHintsProvider(ee,this.o(j,z),typeof K.resolveInlayHint=="function",H,Ae.u(z));let se=this.p(ee);if(H!==void 0){const Oe=K.onDidChangeInlayHints(We=>this.e.$emitInlayHintsEvent(H));se=c.$8L.from(se,Oe)}return se}$provideInlayHints(z,j,K,H){return this.s(z,De,ee=>ee.provideInlayHints(l.URI.revive(j),K,H),void 0,H)}$resolveInlayHint(z,j,K){return this.s(z,De,H=>H.resolveInlayHint(j,K),void 0,K)}$releaseInlayHints(z,j){this.s(z,De,K=>K.releaseHints(j),void 0,void 0)}registerDocumentLinkProvider(z,j,K){const H=this.t(new be(this.h,K),z);return this.e.$registerDocumentLinkProvider(H,this.o(j,z),typeof K.resolveDocumentLink=="function"),this.p(H)}$provideDocumentLinks(z,j,K){return this.s(z,be,H=>H.provideLinks(l.URI.revive(j),K),void 0,K,j.scheme==="output")}$resolveDocumentLink(z,j,K){return this.s(z,be,H=>H.resolveLink(j,K),void 0,void 0,!0)}$releaseDocumentLinks(z,j){this.s(z,be,K=>K.releaseLinks(j),void 0,void 0,!0)}registerColorProvider(z,j,K){const H=this.t(new ge(this.h,K),z);return this.e.$registerDocumentColorProvider(H,this.o(j,z)),this.p(H)}$provideDocumentColors(z,j,K){return this.s(z,ge,H=>H.provideColors(l.URI.revive(j),K),[],K)}$provideColorPresentations(z,j,K,H){return this.s(z,ge,ee=>ee.provideColorPresentations(l.URI.revive(j),K,H),void 0,H)}registerFoldingRangeProvider(z,j,K){const H=this.q(),ee=typeof K.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(H,new Ce(new J(this.h,K),z)),this.e.$registerFoldingRangeProvider(H,this.o(j,z),z.identifier,ee);let se=this.p(H);if(ee!==void 0){const Oe=K.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ee));se=c.$8L.from(se,Oe)}return se}$provideFoldingRanges(z,j,K,H){return this.s(z,J,ee=>ee.provideFoldingRanges(l.URI.revive(j),K,H),void 0,H)}registerSelectionRangeProvider(z,j,K){const H=this.t(new X(this.h,K,this.l),z);return this.e.$registerSelectionRangeProvider(H,this.o(j,z)),this.p(H)}$provideSelectionRanges(z,j,K,H){return this.s(z,X,ee=>ee.provideSelectionRanges(l.URI.revive(j),K,H),[],H)}registerCallHierarchyProvider(z,j,K){const H=this.t(new he(this.h,K),z);return this.e.$registerCallHierarchyProvider(H,this.o(j,z)),this.p(H)}$prepareCallHierarchy(z,j,K,H){return this.s(z,he,ee=>Promise.resolve(ee.prepareSession(l.URI.revive(j),K,H)),void 0,H)}$provideCallHierarchyIncomingCalls(z,j,K,H){return this.s(z,he,ee=>ee.provideCallsTo(j,K,H),void 0,H)}$provideCallHierarchyOutgoingCalls(z,j,K,H){return this.s(z,he,ee=>ee.provideCallsFrom(j,K,H),void 0,H)}$releaseCallHierarchy(z,j){this.s(z,he,K=>Promise.resolve(K.releaseSession(j)),void 0,void 0)}registerTypeHierarchyProvider(z,j,K){const H=this.t(new fe(this.h,K),z);return this.e.$registerTypeHierarchyProvider(H,this.o(j,z)),this.p(H)}$prepareTypeHierarchy(z,j,K,H){return this.s(z,fe,ee=>Promise.resolve(ee.prepareSession(l.URI.revive(j),K,H)),void 0,H)}$provideTypeHierarchySupertypes(z,j,K,H){return this.s(z,fe,ee=>ee.provideSupertypes(j,K,H),void 0,H)}$provideTypeHierarchySubtypes(z,j,K,H){return this.s(z,fe,ee=>ee.provideSubtypes(j,K,H),void 0,H)}$releaseTypeHierarchy(z,j){this.s(z,fe,K=>Promise.resolve(K.releaseSession(j)),void 0,void 0)}registerDocumentOnDropEditProvider(z,j,K,H){const ee=this.q();this.f.set(ee,new Ce(new Fe(this.e,this.h,K,ee,z),z));const se=(0,d.$XF)(z,"dropMetadata")&&H?Fe.toInternalProviderId(z.identifier.value,H.id):void 0;return this.e.$registerDocumentOnDropEditProvider(ee,this.o(j,z),se,(0,d.$XF)(z,"dropMetadata")?H:void 0),this.p(ee)}$provideDocumentOnDropEdits(z,j,K,H,ee,se){return this.s(z,Fe,Oe=>Promise.resolve(Oe.provideDocumentOnDropEdits(j,l.URI.revive(K),H,ee,se)),void 0,void 0)}registerMappedEditsProvider(z,j,K){const H=this.t(new de(this.h,K),z);return this.e.$registerMappedEditsProvider(H,this.o(j,z)),this.p(H)}$provideMappedEdits(z,j,K,H,ee){return this.s(z,de,se=>Promise.resolve(se.provideMappedEdits(j,K,H,ee)),null,ee)}registerDocumentPasteEditProvider(z,j,K,H){const ee=this.q();this.f.set(ee,new Ce(new L(this.e,this.h,K,ee,z),z));const se=L.toInternalProviderId(z.identifier.value,H.id);return this.e.$registerPasteEditProvider(ee,this.o(j,z),se,{supportsCopy:!!K.prepareDocumentPaste,supportsPaste:!!K.provideDocumentPasteEdits,copyMimeTypes:H.copyMimeTypes,pasteMimeTypes:H.pasteMimeTypes}),this.p(ee)}$prepareDocumentPaste(z,j,K,H,ee){return this.s(z,L,se=>se.prepareDocumentPaste(l.URI.revive(j),K,H,ee),void 0,ee)}$providePasteEdits(z,j,K,H,ee,se){return this.s(z,L,Oe=>Oe.providePasteEdits(j,l.URI.revive(K),H,ee,se),void 0,se)}static w(z){return{pattern:z.source,flags:z.flags}}static y(z){return{decreaseIndentPattern:Ae.w(z.decreaseIndentPattern),increaseIndentPattern:Ae.w(z.increaseIndentPattern),indentNextLinePattern:z.indentNextLinePattern?Ae.w(z.indentNextLinePattern):void 0,unIndentedLinePattern:z.unIndentedLinePattern?Ae.w(z.unIndentedLinePattern):void 0}}static z(z){return{beforeText:Ae.w(z.beforeText),afterText:z.afterText?Ae.w(z.afterText):void 0,previousLineText:z.previousLineText?Ae.w(z.previousLineText):void 0,action:z.action}}static B(z){return z.map(Ae.z)}static C(z){return{open:z.open,close:z.close,notIn:z.notIn?z.notIn.map(j=>c.SyntaxTokenType.toString(j)):void 0}}static D(z){return z.map(Ae.C)}setLanguageConfiguration(z,j,K){const{wordPattern:H}=K;if(H&&(0,O.$8e)(H))throw new Error(`Invalid language configuration: wordPattern '${H}' is not allowed to match the empty string.`);H?this.h.setWordDefinitionFor(j,H):this.h.setWordDefinitionFor(j,void 0),K.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",z,"Do not use."),K.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",z,"Do not use.");const ee=this.q(),se={comments:K.comments,brackets:K.brackets,wordPattern:K.wordPattern?Ae.w(K.wordPattern):void 0,indentationRules:K.indentationRules?Ae.y(K.indentationRules):void 0,onEnterRules:K.onEnterRules?Ae.B(K.onEnterRules):void 0,__electricCharacterSupport:K.__electricCharacterSupport,__characterPairSupport:K.__characterPairSupport,autoClosingPairs:K.autoClosingPairs?Ae.D(K.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(ee,j,se),this.p(ee)}$setWordDefinitions(z){for(const j of z)this.h.setWordDefinitionFor(j.languageId,new RegExp(j.regexSource,j.regexFlags))}}e.$Xhc=Ae}),define(Pe[88],Re([1,0,6,4,8,7,101,20,11,5,164,106,14,3,17,84,13]),function(me,e,S,M,P,F,R,m,f,k,O,D,l,E,g,s,a){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$6hc=e.$5hc=void 0,e.$5hc=(0,E.$fi)("IExtHostLanguageModels");class n{constructor(t,p){this.option=t,this.stream=new f.$Ih,this.stream=p??new f.$Ih}}class r{constructor(){this.a=new Map,this.b=new f.$Ih,this.c=!1,this.d=!1;const t=this;this.apiObject={stream:t.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,t]of this.a)yield t.stream;else yield this.b}handleFragment(t){if(this.c)return;this.d=!0;let p=this.a.get(t.index);p||(this.a.size===0?p=new n(t.index,this.b):p=new n(t.index),this.a.set(t.index,p)),p.stream.emitOne(t.part)}get isStreaming(){return this.d}reject(t){this.c=!0;for(const p of this.f())p.reject(t)}resolve(){this.c=!0;for(const t of this.f())t.resolve()}}let c=class{static{i=this}static{this.a=1}constructor(t,p,u){this.j=p,this.k=u,this.c=new k.$5d,this.d=new k.$5d,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new m.$Bm,this.i=new Map,this.o=new Set,this.b=t.getProxy(M.$6L.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(t,p,u,o){const v=i.a++;this.f.set(v,{extension:t.identifier,provider:u,languageModelId:p});let b;return o.auth&&(b={providerLabel:t.displayName||t.name,accountLabel:typeof o.auth=="object"?o.auth.label:void 0}),this.b.$registerLanguageModelProvider(v,p,{extension:t.identifier,identifier:p,model:o.name??"",auth:b}),(0,S.$Rc)(()=>{this.f.delete(v),this.b.$unregisterProvider(v)})}async $provideLanguageModelResponse(t,p,u,o,v,b){const $=this.f.get(t);if(!$)return;const I=new R.$Kv(async h=>{if(b.isCancellationRequested){this.j.warn(`[CHAT](${$.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(p,{index:h.index,part:h.part})});return $.provider.provideLanguageModelResponse2(o.map(P.LanguageModelMessage.to),v,m.$zm.toKey(u),I,b)}$updateLanguageModels(t){const p=[],u=[];if(t.added)for(const o of t.added)this.g.set(o.identifier,o),p.push(o.model);if(t.removed)for(const o of t.removed){this.g.delete(o),u.push(o);for(const[v,b]of this.i)b.languageModelId===o&&(b.res.reject(new l.$5),this.i.delete(v))}this.d.fire(Object.freeze({added:Object.freeze(p),removed:Object.freeze(u)})),t.added?.forEach(this.n,this)}getLanguageModelIds(){return Array.from(this.g.keys())}$updateModelAccesslist(t){const p=new Array;for(const{from:u,to:o,enabled:v}of t){const b=this.h.get(u)??new m.$Am;if(b.has(o)!==v){v?b.add(o):b.delete(o),this.h.set(u,b);const I={from:u,to:o};p.push(I),this.c.fire(I)}}}async sendChatRequest(t,p,u,o,v){const b=t.identifier,$=await this.b.$prepareChatAccess(b,p,o.justification);if(!$||!this.g.has(p))throw F.$_N.NotFound(`Language model '${p}' is unknown.`);if(this.m(b,$)&&(!await this.l(t,{identifier:$.extension,displayName:$.auth.providerLabel},o.justification,o.silent)||!this.h.get(b)?.has($.extension)))throw F.$_N.NoPermissions(`Language model '${p}' cannot be used by '${b.value}'.`);const I=Math.random()*1e6|0,h=this.b.$fetchResponse(b,p,I,u.map(P.LanguageModelMessage.from),o.modelOptions??{},v),y=new f.$eh,w=new r;this.i.set(I,{languageModelId:p,res:w});let A;if(h.catch(N=>{y.isOpen()?w.reject(N):A=N}).finally(()=>{this.i.delete(I),w.resolve(),y.open()}),await y.wait(),A)throw new F.$_N(`Language model '${p}' errored, check cause for more details`,"Unknown",A);return w.apiObject}async $handleResponseFragment(t,p){const u=this.i.get(t);u&&u.res.handleFragment(p)}async l(t,p,u,o){const v=D.$_K+p.identifier.value;if(await this.k.getSession(t,v,[],{silent:!0}))return this.$updateModelAccesslist([{from:t.identifier,to:p.identifier,enabled:!0}]),!0;if(o)return!1;try{const $=u?(0,O.localize)(0,null,p.displayName,u):(0,O.localize)(1,null,p.displayName);return await this.k.getSession(t,v,[],{forceNewSession:{detail:$}}),this.$updateModelAccesslist([{from:t.identifier,to:p.identifier,enabled:!0}]),!0}catch{return!1}}m(t,p){return!!p.auth&&!m.$zm.equals(p.extension,t)}async n(t){for(const p of this.o)try{await this.l(p,{identifier:t.extension,displayName:""},void 0,!0)}catch(u){this.j.error("Fake Auth request failed"),this.j.error(u)}}createLanguageModelAccessInformation(t){this.o.add(t);const p=this,u=k.Event.signal(k.Event.filter(this.c.event,v=>m.$zm.equals(v.from,t.identifier))),o=k.Event.signal(this.d.event);return{get onDidChange(){return k.Event.any(u,o)},canSendRequest(v){const b=p.g.get(v);if(!b)return;if(!p.m(t.identifier,b))return!0;const $=p.h.get(t.identifier);if($)return $.has(b.extension)}}}};e.$6hc=c,e.$6hc=c=i=Ye([He(0,g.$lO),He(1,a.$zj),He(2,s.$Zhc)],c)}),define(Pe[260],Re([1,0,4,8,7,32,11,6,22]),function(me,e,S,M,P,F,R,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mjc=void 0;class k{constructor(D,l,E,g){this.c=l,this.d=E,this.e=g,this.b=[],this.f=0,this.g=new Set,this.a=D.getProxy(S.$6L.MainThreadLanguages)}$acceptLanguageIds(D){this.b=D}async getLanguages(){return this.b.slice(0)}async changeLanguage(D,l){await this.a.$changeLanguage(D,l);const E=this.c.getDocumentData(D);if(!E)throw new Error(`document '${D.toString()}' NOT found`);return E.document}async tokenAtPosition(D,l){const E=D.version,g=M.Position.from(l),s=await this.a.$tokensAtPosition(D.uri,g),a={type:P.StandardTokenType.Other,range:D.getWordRangeAtPosition(l)??new P.$0L(l.line,l.character,l.line,l.character)};if(!s)return a;const i={range:M.Range.to(s.range),type:M.TokenType.to(s.type)};return!i.range.contains(l)||E!==D.version?a:i}createLanguageStatusItem(D,l,E){const g=this.f++,s=this.a,a=this.g,i=`${D.identifier.value}/${l}`;if(a.has(i))throw new Error(`LanguageStatusItem with id '${l}' ALREADY exists`);a.add(i);const n={selector:E,id:l,name:D.displayName??D.name,severity:P.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let r;const c=new m.$Sc,d=()=>{if(r?.dispose(),!a.has(i)){console.warn(`LanguageStatusItem (${l}) from ${D.identifier.value} has been disposed and CANNOT be updated anymore`);return}r=(0,R.$hh)(()=>{c.clear(),this.a.$setLanguageStatus(g,{id:i,name:n.name??D.displayName??D.name,source:D.displayName??D.name,selector:M.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===P.LanguageStatusSeverity.Error?F.default.Error:n.severity===P.LanguageStatusSeverity.Warning?F.default.Warning:F.default.Info,command:n.command&&this.d.toInternal(n.command,c),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},t={dispose(){c.dispose(),r?.dispose(),s.$removeLanguageStatus(g),a.delete(i)},get id(){return n.id},get name(){return n.name},set name(p){n.name=p,d()},get selector(){return n.selector},set selector(p){n.selector=p,d()},get text(){return n.text},set text(p){n.text=p,d()},set text2(p){(0,f.$YF)(D,"languageStatusText"),n.text=p,d()},get text2(){return(0,f.$YF)(D,"languageStatusText"),n.text},get detail(){return n.detail},set detail(p){n.detail=p,d()},get severity(){return n.severity},set severity(p){n.severity=p,d()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(p){n.accessibilityInformation=p,d()},get command(){return n.command},set command(p){n.command=p,d()},get busy(){return n.busy},set busy(p){n.busy=p,d()}};return d(),t}}e.$mjc=k}),define(Pe[261],Re([1,0,12,2,8,7,83]),function(me,e,S,M,P,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ic=e.$0ic=void 0;class m{constructor(D,l,E,g){this.start=D,this.deletedCount=l,this.deletedItems=E,this.items=g}asApiEvent(){return{range:new F.$vN(this.start,this.start+this.deletedCount),addedCells:this.items.map(D=>D.apiCell),removedCells:this.deletedItems}}}class f{static asModelAddData(D){return{EOL:D.eol,lines:D.source,languageId:D.language,uri:D.uri,isDirty:!1,versionId:1}}constructor(D,l,E){this.notebook=D,this.h=l,this.j=E,this.handle=E.handle,this.uri=M.URI.revive(E.uri),this.cellKind=E.cellKind,this.a=E.outputs.map(P.NotebookCellOutput.to),this.e=E.internalMetadata??{},this.b=Object.freeze(E.metadata??{}),this.d=Object.freeze(P.NotebookCellExecutionSummary.to(E.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const D=this,l=this.h.getDocument(this.uri);if(!l)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const E={get index(){return D.notebook.getCellIndex(D)},notebook:D.notebook.apiNotebook,kind:P.NotebookCellKind.to(this.j.cellKind),document:l.document,get mime(){return D.g},set mime(g){D.g=g},get outputs(){return D.a.slice(0)},get metadata(){return D.b},get executionSummary(){return D.d}};this.f=Object.freeze(E)}return this.f}setOutputs(D){this.a=D.map(P.NotebookCellOutput.to)}setOutputItems(D,l,E){const g=E.map(P.NotebookCellOutputItem.to),s=this.a.find(a=>a.id===D);if(s&&(l||(s.items.length=0),s.items.push(...g),s.items.length>1&&s.items.every(a=>R.$6J(a.mime)))){const a=new Map,i=[];s.items.forEach(n=>{let r;a.has(n.mime)?r=a.get(n.mime):(r=[],a.set(n.mime,r),i.push(n.mime)),r.push(n.data)}),s.items.length=0,i.forEach(n=>{const r=R.$7J(a.get(n));s.items.push({mime:n,data:r.data.buffer})})}}setMetadata(D){this.b=Object.freeze(D)}setInternalMetadata(D){this.e=D,this.d=Object.freeze(P.NotebookCellExecutionSummary.to(D))}setMime(D){}}e.$0ic=f;class k{static{this.a=0}constructor(D,l,E,g,s){this.k=D,this.l=l,this.m=E,this.uri=g,this.handle=k.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=s.viewType,this.f=Object.freeze(s.metadata??Object.create(null)),this.r([[0,0,s.cells]],!0,void 0),this.g=s.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const D=this,l={get uri(){return D.uri},get version(){return D.g},get notebookType(){return D.d},get isDirty(){return D.h},get isUntitled(){return D.uri.scheme===S.Schemas.untitled},get isClosed(){return D.j},get metadata(){return D.f},get cellCount(){return D.b.length},cellAt(E){return E=D.n(E),D.b[E].apiCell},getCells(E){return(E?D.p(E):D.b).map(s=>s.apiCell)},save(){return D.q()}};this.e=Object.freeze(l)}return this.e}acceptDocumentPropertiesChanged(D){D.metadata&&(this.f=Object.freeze({...this.f,...D.metadata}))}acceptDirty(D){this.h=D}acceptModelChanged(D,l,E){this.g=D.versionId,this.h=l,this.acceptDocumentPropertiesChanged({metadata:E});const g={notebook:this.apiNotebook,metadata:E,cellChanges:[],contentChanges:[]},s=[];for(const i of D.rawEvents)i.kind===R.NotebookCellsChangeType.ModelChange?this.r(i.changes,!1,g.contentChanges):i.kind===R.NotebookCellsChangeType.Move?this.s(i.index,i.length,i.newIdx,g.contentChanges):i.kind===R.NotebookCellsChangeType.Output?(this.t(i.index,i.outputs),s.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===R.NotebookCellsChangeType.OutputItem?(this.u(i.index,i.outputId,i.append,i.outputItems),s.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(i.index,i.language),s.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document})):i.kind===R.NotebookCellsChangeType.ChangeCellContent?s.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document}):i.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(i.index,i.mime):i.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(i.index,i.metadata),s.push({cell:this.b[i.index].apiCell,metadata:this.b[i.index].apiCell.metadata})):i.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(i.index,i.internalMetadata),s.push({cell:this.b[i.index].apiCell,executionSummary:this.b[i.index].apiCell.executionSummary}));const a=new Map;for(let i=0;i<s.length;i++){const n=s[i],r=a.get(n.cell);if(r===void 0){const c=g.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});a.set(n.cell,c-1)}else g.cellChanges[r]={...g.cellChanges[r],...n}}return Object.freeze(g),Object.freeze(g.cellChanges),Object.freeze(g.contentChanges),g}n(D){return D=D|0,D<0?0:D>=this.b.length?this.b.length-1:D}o(D){let l=D.start|0,E=D.end|0;return l<0&&(l=0),E>this.b.length&&(E=this.b.length),D.with({start:l,end:E})}p(D){D=this.o(D);const l=[];for(let E=D.start;E<D.end;E++)l.push(this.b[E]);return l}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(D,l,E){if(this.j)return;const g=[],s=[],a=[];if(D.reverse().forEach(i=>{const r=i[2].map(t=>{const p=new f(this,this.l,t);return l||s.push(f.asModelAddData(t)),p}),c=new m(i[0],i[1],[],r),d=this.b.splice(i[0],i[1],...r);for(const t of d)a.push(t.uri),c.deletedItems.push(t.apiCell);g.push(c)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:s,removedDocuments:a}),E)for(const i of g)E.push(i.asApiEvent())}s(D,l,E,g){const s=this.b.splice(D,l);this.b.splice(E,0,...s);const a=[new m(D,l,s.map(i=>i.apiCell),[]),new m(E,0,[],s)];for(const i of a)g.push(i.asApiEvent())}t(D,l){this.b[D].setOutputs(l)}u(D,l,E,g){this.b[D].setOutputItems(l,E,g)}v(D,l){const E=this.b[D];E.apiCell.document.languageId!==l&&this.m.$acceptModelLanguageChanged(E.uri,l)}w(D,l){const E=this.b[D];E.apiCell.mime=l}x(D,l){this.b[D].setMetadata(l)}y(D,l){this.b[D].setInternalMetadata(l)}getCellFromApiCell(D){return this.b.find(l=>l.apiCell===D)}getCellFromIndex(D){return this.b[D]}getCell(D){if(M.URI.isUri(D)){const l=R.CellUri.parse(D);if(!l||l.notebook.toString()!==this.uri.toString())return;D=l.handle}return this.b.find(l=>l.handle===D)}getCellIndex(D){return this.b.indexOf(D)}}e.$$ic=k}),define(Pe[262],Re([1,0,5,2,8,7]),function(me,e,S,M,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ojc=void 0;class R{constructor(f,k,O,D={timeout:1500,errors:3}){this.b=f,this.c=k,this.d=O,this.f=D,this.a=new S.$7d}dispose(){}getOnWillSaveNotebookDocumentEvent(f){return(k,O,D)=>{const l=function(g){k.call(O,g)};return l.extension=f,this.a.event(l,void 0,D)}}async $participateInSave(f,k,O){const D=M.URI.revive(f),l=this.c.getNotebookDocument(D);if(!l)throw new Error("Unable to resolve notebook document");const E=[];if(await this.a.fireAsync({notebook:l.apiNotebook,reason:P.TextDocumentSaveReason.to(k)},O,async(s,a)=>{const i=Date.now(),n=await await Promise.resolve(s);Date.now()-i>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",a.extension.identifier),!O.isCancellationRequested&&n&&(n instanceof F.$fM?E.push(n):this.b.warn("onWillSaveNotebookDocument-listener from extension",a.extension.identifier,"ignored due to invalid data"))}),O.isCancellationRequested)return!1;if(E.length===0)return!0;const g={edits:[]};for(const s of E){const{edits:a}=P.WorkspaceEdit.from(s);g.edits=g.edits.concat(a)}return this.d.$tryApplyWorkspaceEdit(g)}}e.$ojc=R}),define(Pe[112],Re([1,0,14,8,7]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_ic=void 0;class F{static{this.apiEditorsToExtHost=new WeakMap}constructor(m,f,k,O,D,l){this.id=m,this.f=f,this.notebookData=k,this.a=[],this.b=[],this.d=!1,this.a=D,this.b=O,this.c=l}get apiEditor(){if(!this.e){const m=this;this.e={get notebook(){return m.notebookData.apiNotebook},get selection(){return m.a[0]},set selection(f){this.selections=[f]},get selections(){return m.a},set selections(f){if(!Array.isArray(f)||!f.every(P.$vN.isNotebookRange))throw(0,S.$7)("selections");m.a=f,m.g(f)},get visibleRanges(){return m.b},revealRange(f,k){m.f.$tryRevealRange(m.id,M.NotebookRange.from(f),k??P.NotebookEditorRevealType.Default)},get viewColumn(){return m.c}},F.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(m){this.d=m}_acceptVisibleRanges(m){this.b=m}_acceptSelections(m){this.a=m}g(m){this.f.$trySetSelections(this.id,m.map(M.NotebookRange.from))}_acceptViewColumn(m){this.c=m}}e.$_ic=F}),define(Pe[263],Re([1,0,5,13,8]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qjc=void 0;let F=class{constructor(m,f){this.c=m,this.d=f,this.a=new S.$5d,this.b=new S.$5d,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(m,f){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",m,f);const k=this.d.getEditorById(m);f.visibleRanges&&k._acceptVisibleRanges(f.visibleRanges.ranges.map(P.NotebookRange.to)),f.selections&&k._acceptSelections(f.selections.selections.map(P.NotebookRange.to)),f.visibleRanges&&this.b.fire({notebookEditor:k.apiEditor,visibleRanges:k.apiEditor.visibleRanges}),f.selections&&this.a.fire(Object.freeze({notebookEditor:k.apiEditor,selections:k.apiEditor.selections}))}$acceptEditorViewColumns(m){for(const f in m)this.d.getEditorById(f)._acceptViewColumn(P.ViewColumn.to(m[f]))}};e.$qjc=F,e.$qjc=F=Ye([He(0,M.$zj)],F)}),define(Pe[264],Re([1,0,5,4,112]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tjc=void 0;class F{constructor(m,f){this.c=f,this.a=new Map,this.b=m.getProxy(M.$6L.MainThreadNotebookRenderers)}$postRendererMessage(m,f,k){const O=this.c.getEditorById(m);this.a.get(f)?.fire({editor:O.apiEditor,message:k})}createRendererMessaging(m,f){if(!m.contributes?.notebookRenderer?.some(O=>O.id===f))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${f})`);return{onDidReceiveMessage:(O,D,l)=>this.d(f).event(O,D,l),postMessage:(O,D)=>{P.$_ic.apiEditorsToExtHost.has(O)&&([O,D]=[D,O]);const l=D&&P.$_ic.apiEditorsToExtHost.get(D);return this.b.$postMessage(l?.id,f,O)}}}d(m){let f=this.a.get(m);return f||(f=new S.$5d({onDidRemoveLastListener:()=>{f?.dispose(),this.a.delete(m)}}),this.a.set(m,f),f)}}e.$tjc=F}),define(Pe[265],Re([1,0,8,101,25,68,14]),function(me,e,S,M,P,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xjc=void 0;class m{constructor(D){this.b=0,this.c=new Map,this.a=D}async withProgress(D,l,E){const g=this.b++,{title:s,location:a,cancellable:i}=l,n={label:D.displayName||D.name,id:D.identifier.value};return this.a.$startProgress(g,{location:S.ProgressLocation.from(a),title:s,source:n,cancellable:i},D.isUnderDevelopment?void 0:D.identifier.value).catch(R.$2),this.d(g,E,!!i)}d(D,l,E){let g;E&&(g=new P.$ce,this.c.set(D,g));const s=i=>{this.a.$progressEnd(i),this.c.delete(i),g?.dispose()};let a;try{a=l(new k(this.a,D),E&&g?g.token:P.CancellationToken.None)}catch(i){throw s(D),i}return a.then(i=>s(D),i=>s(D)),a}$acceptProgressCanceled(D){const l=this.c.get(D);l&&(l.cancel(),this.c.delete(D))}}e.$xjc=m;function f(O,D){return O.message=D.message,typeof D.increment=="number"&&(typeof O.increment=="number"?O.increment+=D.increment:O.increment=D.increment),O}class k extends M.$Kv{constructor(D,l){super(E=>this.throttledReport(E)),this.c=D,this.d=l}throttledReport(D){this.c.$progressReport(this.d,D)}}Ye([(0,F.$Lh)(100,(O,D)=>f(O,D),()=>Object.create(null))],k.prototype,"throttledReport",null)}),define(Pe[266],Re([1,0,2,4,11,8]),function(me,e,S,M,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yjc=void 0;class R{static{this.a=0}constructor(f,k){this.d=k,this.c=new Map,this.b=f.getProxy(M.$6L.MainThreadQuickDiff)}$provideOriginalResource(f,k,O){const D=S.URI.revive(k),l=this.c.get(f);return l?(0,P.$0g)(()=>l.provideOriginalResource(D,O)).then(E=>E||null):Promise.resolve(null)}registerQuickDiffProvider(f,k,O,D){const l=R.a++;return this.c.set(l,k),this.b.$registerQuickDiffProvider(l,F.DocumentSelector.from(f,this.d),O,D),{dispose:()=>{this.b.$unregisterQuickDiffProvider(l),this.c.delete(l)}}}}e.$yjc=R}),define(Pe[267],Re([1,0,25,5,6,4,2,7,14,18,32,40,22,8]),function(me,e,S,M,P,F,R,m,f,k,O,D,l,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zjc=void 0;function g(s,a,i){const n=s.getProxy(F.$6L.MainThreadQuickOpen);class r{constructor($,I){this.e=new Map,this.f=0,this.a=$,this.b=I}showQuickPick($,I,h,y=S.CancellationToken.None){this.c=void 0;const w=Promise.resolve(I),A=++this.f,N=n.$show(A,{title:h?.title,placeHolder:h?.placeHolder,matchOnDescription:h?.matchOnDescription,matchOnDetail:h?.matchOnDetail,ignoreFocusLost:h?.ignoreFocusOut,canPickMany:h?.canPickMany},y),G={},V=N.then(()=>G);return Promise.race([V,w]).then(U=>{if(U===G)return;const C=(0,l.$XF)($,"quickPickItemTooltip");return w.then(L=>{const q=[];for(let ne=0;ne<L.length;ne++){const ae=L[ne];if(typeof ae=="string")q.push({label:ae,handle:ne});else if(ae.kind===m.QuickPickItemKind.Separator)q.push({type:"separator",label:ae.label});else{ae.tooltip&&!C&&console.warn(`Extension '${$.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${$.identifier.value}`);const ye=ae.iconPath?u(ae.iconPath):void 0;q.push({label:ae.label,iconPath:ye?.iconPath,iconClass:ye?.iconClass,description:ae.description,detail:ae.detail,picked:ae.picked,alwaysShow:ae.alwaysShow,tooltip:C?E.MarkdownString.fromStrict(ae.tooltip):void 0,handle:ne})}}return h&&typeof h.onDidSelectItem=="function"&&(this.c=ne=>{h.onDidSelectItem(L[ne])}),n.$setItems(A,q),N.then(ne=>{if(typeof ne=="number")return L[ne];if(Array.isArray(ne))return ne.map(ae=>L[ae])})})}).then(void 0,U=>{if(!(0,f.$4)(U))return n.$setError(A,U),Promise.reject(U)})}$onItemSelected($){this.c?.($)}showInput($,I=S.CancellationToken.None){return this.d=$?.validateInput,n.$input($,typeof this.d=="function",I).then(void 0,h=>{if(!(0,f.$4)(h))return Promise.reject(h)})}async $validateInput($){if(!this.d)return;const I=await this.d($);if(!I||typeof I=="string")return I;let h;switch(I.severity){case m.InputBoxValidationSeverity.Info:h=O.default.Info;break;case m.InputBoxValidationSeverity.Warning:h=O.default.Warning;break;case m.InputBoxValidationSeverity.Error:h=O.default.Error;break;default:h=I.message?O.default.Error:O.default.Ignore;break}return{content:I.message,severity:h}}async showWorkspaceFolderPick($,I=S.CancellationToken.None){const h=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[$]);if(!h)return;const y=await this.a.getWorkspaceFolders2();if(y)return y.find(w=>w.uri.toString()===h.uri.toString())}createQuickPick($){const I=new o($,()=>this.e.delete(I._id));return this.e.set(I._id,I),I}createInputBox($){const I=new v($,()=>this.e.delete(I._id));return this.e.set(I._id,I),I}$onDidChangeValue($,I){this.e.get($)?._fireDidChangeValue(I)}$onDidAccept($){this.e.get($)?._fireDidAccept()}$onDidChangeActive($,I){const h=this.e.get($);h instanceof o&&h._fireDidChangeActive(I)}$onDidChangeSelection($,I){const h=this.e.get($);h instanceof o&&h._fireDidChangeSelection(I)}$onDidTriggerButton($,I){this.e.get($)?._fireDidTriggerButton(I)}$onDidTriggerItemButton($,I,h){const y=this.e.get($);y instanceof o&&y._fireDidTriggerItemButton(I,h)}$onDidHide($){this.e.get($)?._fireDidHide()}}class c{static{this.a=1}constructor($,I){this.x=$,this.y=I,this._id=o.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new M.$5d,this.q=new M.$5d,this.r=new M.$5d,this.s=new M.$5d,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title($){this.b=$,this.z({title:$})}get step(){return this.c}set step($){this.c=$,this.z({step:$})}get totalSteps(){return this.d}set totalSteps($){this.d=$,this.z({totalSteps:$})}get enabled(){return this.g}set enabled($){this.g=$,this.z({enabled:$})}get busy(){return this.j}set busy($){this.j=$,this.z({busy:$})}get ignoreFocusOut(){return this.k}set ignoreFocusOut($){this.k=$,this.z({ignoreFocusOut:$})}get value(){return this.l}set value($){this.l=$,this.z({value:$})}get placeholder(){return this.m}set placeholder($){this.m=$,this.z({placeholder:$})}get buttons(){return this.n}set buttons($){this.n=$.slice(),this.o.clear(),$.forEach((I,h)=>{const y=I===m.$sN.Back?-1:h;this.o.set(y,I)}),this.z({buttons:$.map((I,h)=>({...u(I.iconPath),tooltip:I.tooltip,handle:I===m.$sN.Back?-1:h}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue($){this.l=$,this.q.fire($)}_fireDidTriggerButton($){const I=this.o.get($);I&&this.r.fire(I)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,P.$Oc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z($){if(!this.v){for(const I of Object.keys($)){const h=$[I];this.u[I]=h===void 0?null:h}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}function d(b){if(b instanceof m.$3M)return{id:b.id};const $=p(b),I=t(b);return{dark:typeof $=="string"?R.URI.file($):$,light:typeof I=="string"?R.URI.file(I):I}}function t(b){return typeof b=="object"&&"light"in b?b.light:b}function p(b){return typeof b=="object"&&"dark"in b?b.dark:b}function u(b){const $=d(b);let I,h;return"id"in $?h=D.ThemeIcon.asClassName($):I=$,{iconPath:I,iconClass:h}}class o extends c{constructor($,I){super($.identifier,I),this.O=$,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new M.$5d,this.L=[],this.M=new M.$5d,this.N=new M.$5d,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items($){this.B=$.slice(),this.C.clear(),this.D.clear(),$.forEach((y,w)=>{this.C.set(w,y),this.D.set(y,w)});const I=(0,l.$XF)(this.O,"quickPickItemTooltip"),h=[];for(let y=0;y<$.length;y++){const w=$[y];if(w.kind===m.QuickPickItemKind.Separator)h.push({type:"separator",label:w.label});else{w.tooltip&&!I&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const A=w.iconPath?u(w.iconPath):void 0;h.push({handle:y,label:w.label,iconPath:A?.iconPath,iconClass:A?.iconClass,description:w.description,detail:w.detail,picked:w.picked,alwaysShow:w.alwaysShow,tooltip:I?E.MarkdownString.fromStrict(w.tooltip):void 0,buttons:w.buttons?.map((N,G)=>({...u(N.iconPath),tooltip:N.tooltip,handle:G}))})}}this.z({items:h})}get canSelectMany(){return this.E}set canSelectMany($){this.E=$,this.z({canSelectMany:$})}get matchOnDescription(){return this.F}set matchOnDescription($){this.F=$,this.z({matchOnDescription:$})}get matchOnDetail(){return this.G}set matchOnDetail($){this.G=$,this.z({matchOnDetail:$})}get sortByLabel(){return this.H}set sortByLabel($){this.H=$,this.z({sortByLabel:$})}get keepScrollPosition(){return this.I}set keepScrollPosition($){this.I=$,this.z({keepScrollPosition:$})}get activeItems(){return this.J}set activeItems($){this.J=$.filter(I=>this.D.has(I)),this.z({activeItems:this.J.map(I=>this.D.get(I))})}get selectedItems(){return this.L}set selectedItems($){this.L=$.filter(I=>this.D.has(I)),this.z({selectedItems:this.L.map(I=>this.D.get(I))})}_fireDidChangeActive($){const I=(0,k.$Hb)($.map(h=>this.C.get(h)));this.J=I,this.K.fire(I)}_fireDidChangeSelection($){const I=(0,k.$Hb)($.map(h=>this.C.get(h)));this.L=I,this.M.fire(I)}_fireDidTriggerItemButton($,I){const h=this.C.get($);if(!h||!h.buttons||!h.buttons.length)return;const y=h.buttons[I];y&&this.N.fire({button:y,item:h})}}class v extends c{constructor($,I){super($.identifier,I),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password($){this.B=$,this.z({password:$})}get prompt(){return this.C}set prompt($){this.C=$,this.z({prompt:$})}get valueSelection(){return this.D}set valueSelection($){this.D=$,this.z({valueSelection:$})}get validationMessage(){return this.E}set validationMessage($){this.E=$,$?typeof $=="string"?this.z({validationMessage:$,severity:O.default.Error}):this.z({validationMessage:$.message,severity:$.severity??O.default.Error}):this.z({validationMessage:void 0,severity:O.default.Ignore})}}return new r(a,i)}e.$zjc=g}),define(Pe[268],Re([1,0,2,5,68,6,11,4,18,141,13,20,40,8,22,12,21]),function(me,e,S,M,P,F,R,m,f,k,O,D,l,E,g,s,a){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$Bjc=e.$Ajc=void 0;function n(A){return A instanceof S.URI}function r(A,N){return A.scheme===s.Schemas.file&&N.scheme===s.Schemas.file&&a.$k?A.toString()===N.toString():A.toString().toLowerCase()===N.toString().toLowerCase()}function c(A){if(A)return typeof A.iconPath=="string"?S.URI.file(A.iconPath):S.URI.isUri(A.iconPath)||l.ThemeIcon.isThemeIcon(A.iconPath)?A.iconPath:void 0}function d(A){if(A.icon){if(S.URI.isUri(A.icon))return A.icon;if(l.ThemeIcon.isThemeIcon(A.icon))return A.icon;{const N=A.icon;return{light:N.light,dark:N.dark}}}else return}function t(A,N){if(!A.iconPath&&!N.iconPath)return 0;if(A.iconPath){if(!N.iconPath)return 1}else return-1;const G=typeof A.iconPath=="string"?A.iconPath:S.URI.isUri(A.iconPath)?A.iconPath.fsPath:A.iconPath.id,V=typeof N.iconPath=="string"?N.iconPath:S.URI.isUri(N.iconPath)?N.iconPath.fsPath:N.iconPath.id;return(0,k.$7q)(G,V)}function p(A,N){let G=0;if(A.strikeThrough!==N.strikeThrough)return A.strikeThrough?1:-1;if(A.faded!==N.faded)return A.faded?1:-1;if(A.tooltip!==N.tooltip)return(A.tooltip||"").localeCompare(N.tooltip||"");if(G=t(A,N),G!==0)return G;if(A.light&&N.light)G=t(A.light,N.light);else{if(A.light)return 1;if(N.light)return-1}if(G!==0)return G;if(A.dark&&N.dark)G=t(A.dark,N.dark);else{if(A.dark)return 1;if(N.dark)return-1}return G}function u(A,N){if(A.command!==N.command)return A.command<N.command?-1:1;if(A.title!==N.title)return A.title<N.title?-1:1;if(A.tooltip!==N.tooltip){if(A.tooltip!==void 0&&N.tooltip!==void 0)return A.tooltip<N.tooltip?-1:1;if(A.tooltip!==void 0)return 1;if(N.tooltip!==void 0)return-1}if(A.arguments===N.arguments)return 0;if(A.arguments)if(N.arguments){if(A.arguments.length!==N.arguments.length)return A.arguments.length-N.arguments.length}else return 1;else return-1;for(let G=0;G<A.arguments.length;G++){const V=A.arguments[G],U=N.arguments[G];if(V!==U&&!(n(V)&&n(U)&&r(V,U)))return V<U?-1:1}return 0}function o(A,N){let G=(0,k.$7q)(A.resourceUri.fsPath,N.resourceUri.fsPath,!0);if(G!==0)return G;if(A.command&&N.command)G=u(A.command,N.command);else{if(A.command)return 1;if(N.command)return-1}if(G!==0)return G;if(A.decorations&&N.decorations)G=p(A.decorations,N.decorations);else{if(A.decorations)return 1;if(N.decorations)return-1}if(A.multiFileDiffEditorModifiedUri&&N.multiFileDiffEditorModifiedUri)G=(0,k.$7q)(A.multiFileDiffEditorModifiedUri.fsPath,N.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(A.multiFileDiffEditorModifiedUri)return 1;if(N.multiFileDiffEditorModifiedUri)return-1}if(A.multiDiffEditorOriginalUri&&N.multiDiffEditorOriginalUri)G=(0,k.$7q)(A.multiDiffEditorOriginalUri.fsPath,N.multiDiffEditorOriginalUri.fsPath,!0);else{if(A.multiDiffEditorOriginalUri)return 1;if(N.multiDiffEditorOriginalUri)return-1}return G}function v(A,N){for(let G=0;G<A.length;G++)if(A[G]!==N[G])return!1;return!0}function b(A,N){return A.command===N.command&&A.title===N.title&&A.tooltip===N.tooltip&&(A.arguments&&N.arguments?v(A.arguments,N.arguments):A.arguments===N.arguments)}function $(A,N){return(0,f.$ub)(A,N,b)}class I{#e;#t;get value(){return this.d}set value(N){N=N??"",this.#e.$setInputBoxValue(this.l,N),this.n(N)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(N){this.#e.$setInputBoxPlaceholder(this.l,N),this.f=N}get validateInput(){return(0,g.$YF)(this.k,"scmValidation"),this.g}set validateInput(N){if((0,g.$YF)(this.k,"scmValidation"),N&&typeof N!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=N,this.#e.$setValidationProviderIsEnabled(this.l,!!N)}get enabled(){return this.h}set enabled(N){N=!!N,this.h!==N&&(this.h=N,this.#e.$setInputBoxEnablement(this.l,N))}get visible(){return this.j}set visible(N){N=!!N,this.j!==N&&(this.j=N,this.#e.$setInputBoxVisibility(this.l,N))}get document(){return(0,g.$YF)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(N,G,V,U,C){this.k=N,this.l=U,this.m=C,this.d="",this.e=new M.$5d,this.f="",this.h=!0,this.j=!0,this.#t=G,this.#e=V}showValidationMessage(N,G){(0,g.$YF)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,N,G)}$onInputBoxValueChange(N){this.n(N)}n(N){this.d=N,this.e.fire(N)}}e.$Ajc=I;class h{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(N){this.v=N,this.q.$updateGroupLabel(this.t,this.handle,N)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(N){this.p=N,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(N){this.f=[...N],this.k.fire()}constructor(N,G,V,U,C,L,q){this.q=N,this.s=G,this.t=V,this.u=U,this.v=C,this.multiDiffEditorEnableViewChanges=L,this.w=q,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new M.$5d,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new M.$5d,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=h.d++}getResourceState(N){return this.g.get(N)}$executeResourceCommand(N,G){const V=this.h.get(N);return V?(0,R.$0g)(()=>this.s.executeCommand(V.command,...V.arguments||[],G)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const N=[...this.f].sort(o),V=(0,f.$Db)(this.o,N,o).map(L=>{const q=L.toInsert.map(ne=>{const ae=this.e++;this.g.set(ae,ne);const ye=ne.resourceUri;let Ie;if(ne.command)if(ne.command.command==="vscode.open"||ne.command.command==="vscode.diff"||ne.command.command==="vscode.changes"){const ge=new F.$Sc;Ie=this.s.converter.toInternal(ne.command,ge),this.j.set(ae,ge)}else this.h.set(ae,ne.command);const ue=(0,g.$XF)(this.w,"scmMultiDiffEditor"),ve=ue?ne.multiDiffEditorOriginalUri:void 0,re=ue?ne.multiFileDiffEditorModifiedUri:void 0,$e=c(ne.decorations),ie=ne.decorations&&c(ne.decorations.light)||$e,le=ne.decorations&&c(ne.decorations.dark)||$e,W=[ie,le],_=ne.decorations&&ne.decorations.tooltip||"",ke=ne.decorations&&!!ne.decorations.strikeThrough,Ne=ne.decorations&&!!ne.decorations.faded,De=ne.contextValue||"";return{rawResource:[ae,ye,W,_,ke,Ne,De,Ie,ve,re],handle:ae}});return{start:L.start,deleteCount:L.deleteCount,toInsert:q}}),U=V.map(({start:L,deleteCount:q,toInsert:ne})=>[L,q,ne.map(ae=>ae.rawResource)]),C=V.reverse();for(const{start:L,deleteCount:q,toInsert:ne}of C){const ae=ne.map(Ie=>Ie.handle),ye=this.n.splice(L,q,...ae);for(const Ie of ye)this.g.delete(Ie),this.h.delete(Ie),this.j.get(Ie)?.dispose(),this.j.delete(Ie)}return this.o=N,U}dispose(){this.l=!0,this.m.fire()}}class y{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(N){this.g!==N&&(this.g=N,this.#e.$updateSourceControl(this.w,{count:N}))}get quickDiffProvider(){return this.h}set quickDiffProvider(N){this.h=N;let G;(0,g.$XF)(this.x,"quickDiffProvider")&&(G=N?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!N,quickDiffLabel:G})}get historyProvider(){return(0,g.$YF)(this.x,"scmHistoryProvider"),this.j}set historyProvider(N){(0,g.$YF)(this.x,"scmHistoryProvider"),this.j=N,this.k.value=new F.$Sc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!N}),N&&this.k.value.add(N.onDidChangeCurrentHistoryItemGroup(()=>{this.l=N?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(N){N!==this.m&&(this.m=N,this.#e.$updateSourceControl(this.w,{commitTemplate:N}))}get acceptInputCommand(){return this.o}set acceptInputCommand(N){this.n.value=new F.$Sc,this.o=N;const G=this.y.converter.toInternal(N,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:G})}get actionButton(){return(0,g.$YF)(this.x,"scmActionButton"),this.q}set actionButton(N){(0,g.$YF)(this.x,"scmActionButton"),this.p.value=new F.$Sc,this.q=N;const G=N!==void 0?{command:this.y.converter.toInternal(N.command,this.p.value),secondaryCommands:N.secondaryCommands?.map(V=>V.map(U=>this.y.converter.toInternal(U,this.p.value))),description:N.description,enabled:N.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:G??null})}get statusBarCommands(){return this.t}set statusBarCommands(N){if(this.t&&N&&$(this.t,N))return;this.s.value=new F.$Sc,this.t=N;const G=(N||[]).map(V=>this.y.converter.toInternal(V,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:G})}get selected(){return this.u}constructor(N,G,V,U,C,L,q){this.x=N,this.y=U,this.z=C,this.A=L,this.B=q,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new F.$Uc,this.m=void 0,this.n=new F.$Uc,this.o=void 0,this.p=new F.$Uc,this.s=new F.$Uc,this.t=void 0,this.u=!1,this.v=new M.$5d,this.onDidChangeSelection=this.v.event,this.w=y.d++,this.C=new Map,this.D=new Set,this.#e=V;const ne=S.URI.from({scheme:s.Schemas.vscodeSourceControl,path:`${C}/scm${this.w}/input`,query:q?`rootUri=${encodeURIComponent(q.toString())}`:void 0});this.f=new I(N,G,this.#e,this.w,ne),this.#e.$registerSourceControl(this.w,C,L,q,ne)}createResourceGroup(N,G,V){const U=(0,g.$XF)(this.x,"scmMultiDiffEditor")&&V?.multiDiffEditorEnableViewChanges===!0,C=new h(this.#e,this.y,this.w,N,G,U,this.x),L=M.Event.once(C.onDidDispose)(()=>this.C.delete(C));return this.C.set(C,L),this.eventuallyAddResourceGroups(),C}eventuallyAddResourceGroups(){const N=[],G=[];for(const[V,U]of this.C){U.dispose();const C=V.onDidUpdateResourceStates(()=>{this.D.add(V),this.eventuallyUpdateResourceStates()});M.Event.once(V.onDidDispose)(()=>{this.D.delete(V),C.dispose(),this.e.delete(V.handle),this.#e.$unregisterGroup(this.w,V.handle)}),N.push([V.handle,V.id,V.label,V.features,V.multiDiffEditorEnableViewChanges]);const L=V._takeResourceStateSnapshot();L.length>0&&G.push([V.handle,L]),this.e.set(V.handle,V)}this.#e.$registerGroups(this.w,N,G),this.C.clear()}eventuallyUpdateResourceStates(){const N=[];this.D.forEach(G=>{const V=G._takeResourceStateSnapshot();V.length!==0&&N.push([G.handle,V])}),N.length>0&&this.#e.$spliceResourceStates(this.w,N),this.D.clear()}getResourceGroup(N){return this.e.get(N)}setSelectionState(N){this.u=N,this.v.fire(N)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(N=>N.dispose()),this.#e.$unregisterSourceControl(this.w)}}Ye([(0,P.$Kh)(100)],y.prototype,"eventuallyAddResourceGroups",null),Ye([(0,P.$Kh)(100)],y.prototype,"eventuallyUpdateResourceStates",null);let w=class{static{i=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(N,G,V,U){this.l=G,this.m=V,this.n=U,this.g=new Map,this.h=new D.$Bm,this.j=new M.$5d,this.e=N.getProxy(m.$6L.MainThreadSCM),this.f=N.getProxy(m.$6L.MainThreadTelemetry),G.registerArgumentProcessor({processArgument:C=>{if(C&&C.$mid===3){const L=this.g.get(C.sourceControlHandle);if(!L)return C;const q=L.getResourceGroup(C.groupHandle);return q?q.getResourceState(C.handle):C}else if(C&&C.$mid===4){const L=this.g.get(C.sourceControlHandle);return L?L.getResourceGroup(C.groupHandle):C}else if(C&&C.$mid===5){const L=this.g.get(C.handle);return L||C}return C}})}createSourceControl(N,G,V,U){this.n.trace("ExtHostSCM#createSourceControl",N.identifier.value,G,V,U),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:N.identifier.value});const C=i.d++,L=new y(N,this.m,this.e,this.l,G,V,U);this.g.set(C,L);const q=this.h.get(N.identifier)||[];return q.push(L),this.h.set(N.identifier,q),L}getLastInputBox(N){this.n.trace("ExtHostSCM#getLastInputBox",N.identifier.value);const G=this.h.get(N.identifier),V=G&&G[G.length-1];return V&&V.inputBox}$provideOriginalResource(N,G,V){const U=S.URI.revive(G);this.n.trace("ExtHostSCM#$provideOriginalResource",N,U.toString());const C=this.g.get(N);return!C||!C.quickDiffProvider||!C.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$0g)(()=>C.quickDiffProvider.provideOriginalResource(U,V)).then(L=>L||null)}$onInputBoxValueChange(N,G){this.n.trace("ExtHostSCM#$onInputBoxValueChange",N);const V=this.g.get(N);return V&&V.inputBox.$onInputBoxValueChange(G),Promise.resolve(void 0)}$executeResourceCommand(N,G,V,U){this.n.trace("ExtHostSCM#$executeResourceCommand",N,G,V);const C=this.g.get(N);if(!C)return Promise.resolve(void 0);const L=C.getResourceGroup(G);return L?L.$executeResourceCommand(V,U):Promise.resolve(void 0)}$validateInput(N,G,V){this.n.trace("ExtHostSCM#$validateInput",N);const U=this.g.get(N);return!U||!U.inputBox.validateInput?Promise.resolve(void 0):(0,R.$0g)(()=>U.inputBox.validateInput(G,V)).then(C=>{if(!C)return Promise.resolve(void 0);const L=E.MarkdownString.fromStrict(C.message);return L?Promise.resolve([L,C.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(N){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",N),N!==void 0&&this.g.get(N)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=N,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(N,G,V,U){return await this.g.get(N)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(G,V,U)??void 0}async $provideHistoryItems(N,G,V,U){return(await this.g.get(N)?.historyProvider?.provideHistoryItems(G,V,U))?.map(q=>({...q,icon:d(q)}))??void 0}async $provideHistoryItemSummary(N,G,V,U){const C=this.g.get(N)?.historyProvider;if(typeof C?.provideHistoryItemSummary!="function")return;const L=await C.provideHistoryItemSummary(G,V,U);return L?{...L,icon:d(L)}:void 0}async $provideHistoryItemChanges(N,G,V,U){return await this.g.get(N)?.historyProvider?.provideHistoryItemChanges(G,V,U)??void 0}};e.$Bjc=w,e.$Bjc=w=i=Ye([He(3,O.$zj)],w)}),define(Pe[269],Re([1,0,4,8,2]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cjc=void 0;class F{static{this.a=0}constructor(m,f){this.d=f,this.c=new Map,this.b=m.getProxy(S.$6L.MainThreadShare)}async $provideShare(m,f,k){return await this.c.get(m)?.provideShare({selection:M.Range.to(f.selection),resourceUri:P.URI.revive(f.resourceUri)},k)??void 0}registerShareProvider(m,f){const k=F.a++;return this.c.set(k,f),this.b.$registerShareProvider(k,M.DocumentSelector.from(m,this.d),f.id,f.label,f.priority),{dispose:()=>{this.b.$unregisterShareProvider(k),this.c.delete(k)}}}}e.$Cjc=F}),define(Pe[270],Re([1,0,7,4,167,6,8,16]),function(me,e,S,M,P,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fjc=e.$Ejc=void 0;class f{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new S.$4M("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new S.$4M("statusBarItem.warningForeground")]])}#e;#t;constructor(l,E,g,s,a,i=S.StatusBarAlignment.Left,n){if(this.i=!1,this.k="",this.q=new F.$Sc,this.#e=l,this.#t=E,a&&s){this.c=(0,S.$GM)(s.identifier,a);const r=g.get(this.c);r&&(i=r.alignLeft?S.StatusBarAlignment.Left:S.StatusBarAlignment.Right,n=r.priority,this.j=!0,this.name=r.name,this.text=r.text,this.tooltip=r.tooltip,this.command=r.command,this.accessibilityInformation=r.accessibilityInformation)}else this.c=String(f.a++);this.e=s,this.f=a,this.g=i,this.h=this.u(n)}u(l){if((0,m.$Wf)(l))return l===Number.POSITIVE_INFINITY?Number.MAX_VALUE:l===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:l}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(l){this.k=l,this.v()}set name(l){this.m=l,this.v()}set tooltip(l){this.l=l,this.v()}set color(l){this.n=l,this.v()}set backgroundColor(l){l&&!f.b.has(l.id)&&(l=void 0),this.o=l,this.v()}set command(l){this.r?.fromApi!==l&&(this.p&&this.q.add(this.p),this.p=new F.$Sc,typeof l=="string"?this.r={fromApi:l,internal:this.#t.toInternal({title:"",command:l},this.p)}:l?this.r={fromApi:l,internal:this.#t.toInternal(l,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(l){this.t=l,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let l;this.e?this.f?l=`${this.e.identifier.value}.${this.f}`:l=this.e.identifier.value:l=this.f;let E;this.m?E=this.m:E=(0,P.localize)(0,null,this.e.displayName||this.e.name);let g=this.n;this.o&&(g=f.b.get(this.o.id));const s=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,l,this.e?.identifier.value,E,this.k,s,this.r?.internal,g,this.o,this.g===S.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Ejc=f;class k{constructor(l){this.b=[],this.a=l.createStatusBarEntry(void 0,"status.extensionMessage",S.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,P.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(l){const E={message:l};return this.b.unshift(E),this.c(),new S.$8L(()=>{const g=this.b.indexOf(E);g>=0&&(this.b.splice(g,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class O{constructor(l,E){this.e=new Map,this.a=l.getProxy(M.$6L.MainThreadStatusBar),this.b=E,this.c=new k(this)}$acceptStaticEntries(l){for(const E of l)this.e.set(E.entryId,E)}createStatusBarEntry(l,E,g,s){return new f(this.a,this.b,this.e,l,E,g,s)}setStatusBarMessage(l,E){const g=this.c.setMessage(l);let s;return typeof E=="number"?s=setTimeout(()=>g.dispose(),E):typeof E<"u"&&E.then(()=>g.dispose(),()=>g.dispose()),new S.$8L(()=>{g.dispose(),clearTimeout(s)})}}e.$Fjc=O}),define(Pe[113],Re([1,0,29,105,48,75,60,8,2]),function(me,e,S,M,P,F,R,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AO=e.$zO=e.$yO=e.$xO=void 0;const k=(r,c,d,t)=>{let p=c;return{enumerable:!0,configurable:!1,get(){return p},set(u){if(!d(p,u)){const o=p;p=u,r.listener?.(t(u,o))}}}},O=(r,c)=>r===c,D={range:(r,c)=>r===c?!0:!r||!c?!1:r.isEqual(c),label:O,description:O,sortText:O,busy:O,error:O,canResolveChildren:O,tags:(r,c)=>!(r.length!==c.length||r.some(d=>!c.find(t=>d.id===t.id)))},l=r=>c=>({op:4,update:r(c)}),E=(r,c)=>({range:(()=>{let d;const t=l(p=>({range:S.$9s.lift(m.Range.from(p))}));return{enumerable:!0,configurable:!1,get(){return d},set(p){r.listener?.({op:6}),D.range(d,p)||(d=p,r.listener?.(t(p)))}}})(),label:k(r,c,D.label,l(d=>({label:d}))),description:k(r,void 0,D.description,l(d=>({description:d}))),sortText:k(r,void 0,D.sortText,l(d=>({sortText:d}))),canResolveChildren:k(r,!1,D.canResolveChildren,d=>({op:2,state:d})),busy:k(r,!1,D.busy,l(d=>({busy:d}))),error:k(r,void 0,D.error,l(d=>({error:m.MarkdownString.fromStrict(d)||null}))),tags:k(r,[],D.tags,(d,t)=>({op:1,new:d.map(m.TestTag.from),old:t.map(m.TestTag.from)}))}),g=r=>{const c=P.$WK.fromString(r.extId),d=new a(c.controllerId,c.localId,r.label,f.URI.revive(r.uri)||void 0);return d.range=m.Range.to(r.range||void 0),d.description=r.description||void 0,d.sortText=r.sortText||void 0,d.tags=r.tags.map(t=>m.TestTag.to({id:(0,R.$2K)(t).tagId})),d},s=r=>{let c;for(const d of r.tests){const t=g(d.item);(0,M.$hO)(t).parent=c,c=t}return c};e.$xO=s;class a{constructor(c,d,t,p){if(d.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(d)} symbol`);const u=(0,M.$gO)(this,c);Object.defineProperties(this,{id:{value:d,enumerable:!0,writable:!1},uri:{value:p,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return u.parent instanceof i?void 0:u.parent}},children:{value:(0,F.$fO)(u,M.$hO,a),enumerable:!0,writable:!1},...E(u,t)})}}e.$yO=a;class i extends a{constructor(c,d){super(c,c,d,void 0),this._isRoot=!0}}e.$zO=i;class n extends F.$bO{constructor(c,d,t){super({controllerId:c,getDocumentVersion:p=>p&&t.getDocument(p)?.version,getApiFor:M.$hO,getChildren:p=>p.children,root:new i(c,d),toITestItem:m.TestItem.from})}}e.$AO=n}),define(Pe[31],Re([1,0,16,7,8,26,4,18,13,52,29,93,2,6,3,17,113,23,49,41,64,58,61,33]),function(me,e,S,M,P,F,R,m,f,k,O,D,l,E,g,s,a,i,n,r,c,d,t,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LO=e.$KO=e.$JO=e.$IO=e.$HO=e.$GO=void 0;let u=class{#e;#t;#i;constructor(h,y,w){this.b=new Map,this.c=new Map,this.#e=h.getProxy(R.$6L.MainThreadCommands),this.d=y,this.#i=w,this.#t=h.getProxy(R.$6L.MainThreadTelemetry),this.converter=new o(this,A=>{const N=this.c.get(A);return N?.result===b.Void?N:void 0},y),this.f=[{processArgument(A){return(0,k.$Oh)(A)}},{processArgument(A){return(0,F.$Mn)(A,function(N){if(O.$9s.isIRange(N))return P.Range.to(N);if(D.$8s.isIPosition(N))return P.Position.to(N);if(O.$9s.isIRange(N.range)&&l.URI.isUri(N.uri))return P.location.to(N);if(N instanceof i.$se)return N.buffer.buffer;if(!Array.isArray(N))return N})}}]}registerArgumentProcessor(h){this.f.push(h)}registerApiCommand(h){const y=this.registerCommand(!1,h.id,async(...w)=>{const A=h.args.map((G,V)=>{if(!G.validate(w[V]))throw new Error(`Invalid argument '${G.name}' when running '${h.id}', received: ${typeof w[V]=="object"?JSON.stringify(w[V],null,"	"):w[V]} `);return G.convert(w[V])}),N=await this.executeCommand(h.internalId,...A);return h.result.convert(N,w,this.converter)},void 0,{description:h.description,args:h.args,returns:h.result.description});return this.c.set(h.id,h),new M.$8L(()=>{y.dispose(),this.c.delete(h.id)})}registerCommand(h,y,w,A,N,G){if(this.d.trace("ExtHostCommands#registerCommand",y),!y.trim().length)throw new Error("invalid id");if(this.b.has(y))throw new Error(`command '${y}' already exists`);return this.b.set(y,{callback:w,thisArg:A,metadata:N,extension:G}),h&&this.#e.$registerCommand(y),new M.$8L(()=>{this.b.delete(y)&&h&&this.#e.$unregisterCommand(y)})}executeCommand(h,...y){return this.d.trace("ExtHostCommands#executeCommand",h),this.g(h,y,!0)}async g(h,y,w){if(this.b.has(h))return this.#e.$fireCommandActivationEvent(h),this.h(h,y,!1);{let A=!1;const N=(0,F.$Mn)(y,function(G){if(G instanceof M.$9L)return P.Position.from(G);if(G instanceof M.$0L)return P.Range.from(G);if(G instanceof M.$hM)return P.location.from(G);if(M.$vN.isNotebookRange(G))return P.NotebookRange.from(G);if(G instanceof ArrayBuffer)return A=!0,i.$se.wrap(new Uint8Array(G));if(G instanceof Uint8Array)return A=!0,i.$se.wrap(G);if(G instanceof i.$se)return A=!0,G;if(!Array.isArray(G))return G});try{const G=await this.#e.$executeCommand(h,A?new n.$9v(N):N,w);return(0,k.$Oh)(G)}catch(G){if(G instanceof Error&&G.message==="$executeCommand:retry")return this.g(h,y,!1);throw G}}}async h(h,y,w){const A=this.b.get(h);if(!A)throw new Error("Unknown command");const{callback:N,thisArg:G,metadata:V}=A;if(V?.args)for(let C=0;C<V.args.length;C++)try{(0,S.$0f)(y[C],V.args[C].constraint)}catch{throw new Error(`Running the contributed command: '${h}' failed. Illegal argument '${V.args[C].name}' - ${V.args[C].description}`)}const U=c.$1d.create();try{return await N.apply(G,y)}catch(C){if(h===this.converter.delegatingCommandId){const L=this.converter.getActualCommand(...y);L&&(h=L.command)}if(this.d.error(C,h,A.extension?.identifier),!w)throw C;if(A.extension?.identifier){const L=this.#i.onExtensionError(A.extension.identifier,C);this.d.trace("forwarded error to extension?",L,A.extension?.identifier)}throw new class extends Error{constructor(){super((0,r.$3i)(C)),this.id=h,this.source=A.extension?.displayName??A.extension?.name}}}finally{this.j(A,h,U.elapsed())}}j(h,y,w){h.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:h.extension.identifier.value,id:new d.$Zo(y),duration:w})}$executeContributedCommand(h,...y){this.d.trace("ExtHostCommands#$executeContributedCommand",h);const w=this.b.get(h);return w?(y=y.map(A=>this.f.reduce((N,G)=>G.processArgument(N,w.extension?.identifier),A)),this.h(h,y,!0)):Promise.reject(new Error(`Contributed command '${h}' does not exist.`))}getCommands(h=!1){return this.d.trace("ExtHostCommands#getCommands",h),this.#e.$getCommands().then(y=>(h&&(y=y.filter(w=>w[0]!=="_")),y))}$getContributedCommandMetadata(){const h=Object.create(null);for(const[y,w]of this.b){const{metadata:A}=w;A&&(h[y]=A)}return Promise.resolve(h)}};e.$GO=u,e.$GO=u=Ye([He(0,s.$lO),He(1,f.$zj),He(2,t.$FO)],u),e.$HO=(0,g.$fi)("IExtHostCommands");class o{constructor(h,y,w){this.d=h,this.f=y,this.g=w,this.delegatingCommandId=`__vsc${(0,p.$Bg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(h,y){if(!h)return;const w={$ident:void 0,id:h.command,title:h.title,tooltip:h.tooltip};if(!h.command)return w;const A=this.f(h.command);if(A)w.id=A.internalId,w.arguments=A.args.map((N,G)=>N.convert(h.arguments&&h.arguments[G]));else if((0,m.$Lb)(h.arguments)){const N=`${h.command} /${++this.c}`;this.b.set(N,h),y.add((0,E.$Rc)(()=>{this.b.delete(N),this.g.trace("CommandsConverter#DISPOSE",N)})),w.$ident=N,w.id=this.delegatingCommandId,w.arguments=[N],this.g.trace("CommandsConverter#CREATE",h.command,N)}return w}fromInternal(h){return typeof h.$ident=="string"?this.b.get(h.$ident):{command:h.id,title:h.title,arguments:h.arguments}}getActualCommand(...h){return this.b.get(h[0])}h(...h){const y=this.getActualCommand(...h);return this.g.trace("CommandsConverter#EXECUTE",h[0],y?y.command:"MISSING"),y?this.d.executeCommand(y.command,...y.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${h[0]}`)}}e.$IO=o;class v{static{this.Uri=new v("uri","Uri of a text document",h=>l.URI.isUri(h),h=>h)}static{this.Position=new v("position","A position in a text document",h=>M.$9L.isPosition(h),P.Position.from)}static{this.Range=new v("range","A range in a text document",h=>M.$0L.isRange(h),P.Range.from)}static{this.Selection=new v("selection","A selection in a text document",h=>M.$$L.isSelection(h),P.Selection.from)}static{this.Number=new v("number","",h=>typeof h=="number",h=>h)}static{this.String=new v("string","",h=>typeof h=="string",h=>h)}static{this.StringArray=v.Arr(v.String)}static Arr(h){return new v(`${h.name}_array`,`Array of ${h.name}, ${h.description}`,y=>Array.isArray(y)&&y.every(w=>h.validate(w)),y=>y.map(w=>h.convert(w)))}static{this.CallHierarchyItem=new v("item","A call hierarchy item",h=>h instanceof M.$sM,P.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new v("item","A type hierarchy item",h=>h instanceof M.$ON,P.TypeHierarchyItem.from)}static{this.TestItem=new v("testItem","A VS Code TestItem",h=>h instanceof a.$yO,P.TestItem.from)}constructor(h,y,w,A){this.name=h,this.description=y,this.validate=w,this.convert=A}optional(){return new v(this.name,`(optional) ${this.description}`,h=>h==null||this.validate(h),h=>h===void 0?void 0:h===null?null:this.convert(h))}with(h,y){return new v(h??this.name,y??this.description,this.validate,this.convert)}}e.$JO=v;class b{static{this.Void=new b("no result",h=>h)}constructor(h,y){this.description=h,this.convert=y}}e.$KO=b;class ${constructor(h,y,w,A,N){this.id=h,this.internalId=y,this.description=w,this.args=A,this.result=N}}e.$LO=$}),define(Pe[271],Re([1,0,18,12,2,87,97,35,31,8,7]),function(me,e,S,M,P,F,R,m,f,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yhc=void 0;const D=[new f.$LO("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[f.$JO.Uri,f.$JO.Position],new f.$KO("A promise that resolves to an array of DocumentHighlight-instances.",E(k.DocumentHighlight.to))),new f.$LO("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[f.$JO.Uri],new f.$KO("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(s,a)=>{if((0,S.$Kb)(s))return;class i extends O.$nM{static to(r){const c=new i(r.name,k.SymbolKind.to(r.kind),r.containerName||"",new O.$hM(a[0],k.Range.to(r.range)));return c.detail=r.detail,c.range=c.location.range,c.selectionRange=k.Range.to(r.selectionRange),c.children=r.children?r.children.map(i.to):[],c}}return s.map(i.to)})),new f.$LO("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[f.$JO.Uri,new f.$JO("options","Formatting options",s=>!0,s=>s)],new f.$KO("A promise that resolves to an array of TextEdits.",E(k.TextEdit.to))),new f.$LO("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[f.$JO.Uri,f.$JO.Range,new f.$JO("options","Formatting options",s=>!0,s=>s)],new f.$KO("A promise that resolves to an array of TextEdits.",E(k.TextEdit.to))),new f.$LO("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[f.$JO.Uri,f.$JO.Position,new f.$JO("ch","Trigger character",s=>typeof s=="string",s=>s),new f.$JO("options","Formatting options",s=>!0,s=>s)],new f.$KO("A promise that resolves to an array of TextEdits.",E(k.TextEdit.to))),new f.$LO("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[f.$JO.Uri,f.$JO.Position],new f.$KO("A promise that resolves to an array of Location or LocationLink instances.",g)),new f.$LO("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[f.$JO.Uri,f.$JO.Position],new f.$KO("A promise that resolves to an array of Location or LocationLink instances.",g)),new f.$LO("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[f.$JO.Uri,f.$JO.Position],new f.$KO("A promise that resolves to an array of Location or LocationLink instances.",g)),new f.$LO("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[f.$JO.Uri,f.$JO.Position],new f.$KO("A promise that resolves to an array of Location or LocationLink instances.",g)),new f.$LO("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[f.$JO.Uri,f.$JO.Position],new f.$KO("A promise that resolves to an array of Location-instances.",E(k.location.to))),new f.$LO("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[f.$JO.Uri,f.$JO.Position],new f.$KO("A promise that resolves to an array of Hover-instances.",E(k.Hover.to))),new f.$LO("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[f.$JO.Uri,new f.$JO("position","A position in a text document",s=>Array.isArray(s)&&s.every(a=>O.$9L.isPosition(a)),s=>s.map(k.Position.from))],new f.$KO("A promise that resolves to an array of ranges.",s=>s.map(a=>{let i;for(const n of a.reverse())i=new O.$rM(k.Range.to(n),i);return i}))),new f.$LO("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[f.$JO.String.with("query","Search string")],new f.$KO("A promise that resolves to an array of SymbolInformation-instances.",s=>s.map(k.WorkspaceSymbol.to))),new f.$LO("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[f.$JO.Uri,f.$JO.Position],new f.$KO("A promise that resolves to an array of CallHierarchyItem-instances",s=>s.map(k.CallHierarchyItem.to))),new f.$LO("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[f.$JO.CallHierarchyItem],new f.$KO("A promise that resolves to an array of CallHierarchyIncomingCall-instances",s=>s.map(k.CallHierarchyIncomingCall.to))),new f.$LO("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[f.$JO.CallHierarchyItem],new f.$KO("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",s=>s.map(k.CallHierarchyOutgoingCall.to))),new f.$LO("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[f.$JO.Uri,f.$JO.Position],new f.$KO("A promise that resolves to a range and placeholder text.",s=>{if(s)return{range:k.Range.to(s.range),placeholder:s.text}})),new f.$LO("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[f.$JO.Uri,f.$JO.Position,f.$JO.String.with("newName","The new symbol name")],new f.$KO("A promise that resolves to a WorkspaceEdit.",s=>{if(s){if(s.rejectReason)throw new Error(s.rejectReason);return k.WorkspaceEdit.to(s)}})),new f.$LO("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[f.$JO.Uri,f.$JO.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new f.$KO("A promise that resolves to an array of DocumentLink-instances.",s=>s.map(k.DocumentLink.to))),new f.$LO("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[f.$JO.Uri],new f.$KO("A promise that resolves to SemanticTokensLegend.",s=>{if(s)return new O.$mN(s.tokenTypes,s.tokenModifiers)})),new f.$LO("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[f.$JO.Uri],new f.$KO("A promise that resolves to SemanticTokens.",s=>{if(!s)return;const a=(0,R.$eab)(s);if(a.type==="full")return new O.$oN(a.data,void 0)})),new f.$LO("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[f.$JO.Uri,f.$JO.Range.optional()],new f.$KO("A promise that resolves to SemanticTokensLegend.",s=>{if(s)return new O.$mN(s.tokenTypes,s.tokenModifiers)})),new f.$LO("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[f.$JO.Uri,f.$JO.Range],new f.$KO("A promise that resolves to SemanticTokens.",s=>{if(!s)return;const a=(0,R.$eab)(s);if(a.type==="full")return new O.$oN(a.data,void 0)})),new f.$LO("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[f.$JO.Uri,f.$JO.Position,f.$JO.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),f.$JO.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new f.$KO("A promise that resolves to a CompletionList-instance.",(s,a,i)=>{if(!s)return new O.$DM([]);const n=s.suggestions.map(r=>k.CompletionItem.to(r,i));return new O.$DM(n,s.incomplete)})),new f.$LO("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[f.$JO.Uri,f.$JO.Position,f.$JO.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new f.$KO("A promise that resolves to SignatureHelp.",s=>{if(s)return k.SignatureHelp.to(s)})),new f.$LO("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[f.$JO.Uri,f.$JO.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new f.$KO("A promise that resolves to an array of CodeLens-instances.",(s,a,i)=>E(n=>new O.$vM(k.Range.to(n.range),n.command&&i.fromInternal(n.command)))(s))),new f.$LO("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[f.$JO.Uri,new f.$JO("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",s=>O.$0L.isRange(s),s=>O.$$L.isSelection(s)?k.Selection.from(s):k.Range.from(s)),f.$JO.String.with("kind","Code action kind to return code actions for").optional(),f.$JO.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new f.$KO("A promise that resolves to an array of Command-instances.",(s,a,i)=>E(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return i.fromInternal(n.command)}else{const r=new O.$pM(n.title,n.kind?new O.$qM(n.kind):void 0);return n.edit&&(r.edit=k.WorkspaceEdit.to(n.edit)),n.command&&(r.command=i.fromInternal(n.command)),r.isPreferred=n.isPreferred,r}})(s))),new f.$LO("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[f.$JO.Uri],new f.$KO("A promise that resolves to an array of ColorInformation objects.",s=>s?s.map(a=>new O.$JM(k.Range.to(a.range),k.Color.to(a.color))):[])),new f.$LO("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new f.$JO("color","The color to show and insert",s=>s instanceof O.$IM,k.Color.from),new f.$JO("context","Context object with uri and range",s=>!0,s=>({uri:s.uri,range:k.Range.from(s.range)}))],new f.$KO("A promise that resolves to an array of ColorPresentation objects.",s=>s?s.map(k.ColorPresentation.to):[])),new f.$LO("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[f.$JO.Uri,f.$JO.Range],new f.$KO("A promise that resolves to an array of Inlay objects",(s,a,i)=>s.map(k.InlayHint.to.bind(void 0,i)))),new f.$LO("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[f.$JO.Uri],new f.$KO("A promise that resolves to an array of FoldingRange objects",(s,a)=>{if(s)return s.map(k.FoldingRange.to)})),new f.$LO("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new f.$KO("A promise that resolves to an array of NotebookContentProvider static info objects.",E(s=>({viewType:s.viewType,displayName:s.displayName,options:{transientOutputs:s.options.transientOutputs,transientCellMetadata:s.options.transientCellMetadata,transientDocumentMetadata:s.options.transientDocumentMetadata},filenamePattern:s.filenamePattern.map(a=>k.NotebookExclusiveDocumentPattern.to(a))})))),new f.$LO("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[f.$JO.Uri,f.$JO.Range,new f.$JO("context","An InlineValueContext",s=>s&&typeof s.frameId=="number"&&s.stoppedLocation instanceof O.$0L,s=>k.InlineValueContext.from(s))],new f.$KO("A promise that resolves to an array of InlineValue objects",s=>s.map(k.InlineValue.to))),new f.$LO("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new f.$JO("uriOrString","Uri-instance or string (only http/https)",s=>P.URI.isUri(s)||typeof s=="string"&&(0,M.$pg)(s,M.Schemas.http,M.Schemas.https),s=>s),new f.$JO("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[k.ViewColumn.from(s),void 0]:[k.ViewColumn.from(s.viewColumn),k.TextEditorOpenOptions.from(s)])).optional(),f.$JO.String.with("label","").optional()],f.$KO.Void),new f.$LO("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[f.$JO.Uri.with("resource","Resource to open"),f.$JO.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new f.$JO("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[k.ViewColumn.from(s),void 0]:[k.ViewColumn.from(s.viewColumn),k.TextEditorOpenOptions.from(s)])).optional()],f.$KO.Void),new f.$LO("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[f.$JO.Uri.with("left","Left-hand side resource of the diff editor"),f.$JO.Uri.with("right","Right-hand side resource of the diff editor"),f.$JO.String.with("title","Human readable title for the diff editor").optional(),new f.$JO("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="object",s=>s&&[k.ViewColumn.from(s.viewColumn),k.TextEditorOpenOptions.from(s)]).optional()],f.$KO.Void),new f.$LO("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[f.$JO.String.with("title","Human readable title for the changes editor"),new f.$JO("resourceList","List of resources to compare",s=>{for(const a of s){if(a.length!==3)return!1;const[i,n,r]=a;if(!P.URI.isUri(i)||!P.URI.isUri(n)&&n!==void 0&&n!==null||!P.URI.isUri(r)&&r!==void 0&&r!==null)return!1}return!0},s=>s)],f.$KO.Void),new f.$LO("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[f.$JO.Uri,f.$JO.Position],new f.$KO("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(k.TypeHierarchyItem.to))),new f.$LO("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[f.$JO.TypeHierarchyItem],new f.$KO("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(k.TypeHierarchyItem.to))),new f.$LO("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[f.$JO.TypeHierarchyItem],new f.$KO("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(k.TypeHierarchyItem.to))),new f.$LO("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[f.$JO.TestItem],f.$KO.Void),new f.$LO("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[f.$JO.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],f.$KO.Void),new f.$LO("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[f.$JO.String.with("name","The context key name"),new f.$JO("value","The context key value",()=>!0,s=>s)],f.$KO.Void),new f.$LO("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[f.$JO.Uri,f.$JO.StringArray,new f.$JO("MappedEditsContext","Mapped Edits Context",s=>k.MappedEditsContext.is(s),s=>k.MappedEditsContext.from(s))],new f.$KO("A promise that resolves to a workspace edit or null",s=>s?k.WorkspaceEdit.to(s):null))];class l{static register(a){D.forEach(a.registerApiCommand,a),this.a(a)}static a(a){a.registerCommand(!1,"_validateWhenClauses",m.$ej)}}e.$Yhc=l;function E(s){return a=>{if(Array.isArray(a))return a.map(s)}}function g(s){if(!Array.isArray(s))return;const a=[];for(const i of s)F.$Vt(i)?a.push(k.DefinitionLink.to(i)):a.push(k.location.to(i));return a}}),define(Pe[272],Re([1,0,11,6,2,4,31,8,7]),function(me,e,S,M,P,F,R,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ic=void 0;class k{static{this.a=0}constructor(E,g){this.extension=E,this.provider=g,this.handle=k.a++}}class O{constructor(E){this.session=E,this.responses=[]}}class D{static{this.a=0}constructor(E,g,s,a){this.f=s,this.g=a,this.b=new Map,this.d=new Map,this.e=E.getProxy(F.$6L.MainThreadInlineChat),g.registerApiCommand(new R.$LO("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new R.$JO("Run arguments","",i=>!0,i=>{if(i)return{initialRange:i.initialRange?m.Range.from(i.initialRange):void 0,initialSelection:f.$$L.isSelection(i.initialSelection)?m.Selection.from(i.initialSelection):void 0,message:i.message,autoSend:i.autoSend,position:i.position?m.Position.from(i.position):void 0}})],R.$KO.Void))}registerProvider(E,g,s){const a=new k(E,g);return this.b.set(a.handle,a),this.e.$registerInteractiveEditorProvider(a.handle,s?.label??E.displayName??E.name,E.identifier.value,typeof g.handleInteractiveEditorResponseFeedback=="function",typeof g.provideFollowups=="function",s?.supportReportIssue??!1),(0,M.$Rc)(()=>{this.e.$unregisterInteractiveEditorProvider(a.handle),this.b.delete(a.handle)})}async $prepareSession(E,g,s,a){const i=this.b.get(E);if(!i){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this.f.getDocument(P.URI.revive(g)),r=m.Selection.to(s),c=await i.provider.prepareInteractiveEditorSession({document:n,selection:r},a);if(!c)return;if(c.wholeRange&&!c.wholeRange.contains(r))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const d=D.a++;return this.d.set(d,new O(c)),{id:d,placeholder:c.placeholder,input:c.input,slashCommands:c.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:m.Range.from(c.wholeRange),message:c.message}}async $provideResponse(E,g,s,a){const i=this.b.get(E);if(!i)return;const n=this.d.get(g.id);if(!n)return;const r={prompt:s.prompt,selection:m.Selection.to(s.selection),wholeRange:m.Range.to(s.wholeRange),attempt:s.attempt,live:s.live,previewDocument:this.f.getDocument(P.URI.revive(s.previewDocument)),withIntentDetection:s.withIntentDetection};let c=!1;const d={report:async I=>{if(!s.live&&I.edits?.length)throw new Error("Progress reporting is only supported for live sessions");c||a.isCancellationRequested||await this.e.$handleProgressChunk(s.requestId,{message:I.message,edits:I.edits?.map(m.TextEdit.from),editsShouldBeInstant:I.editsShouldBeInstant,slashCommand:I.slashCommand?.command,markdownFragment:f.$wM.isMarkdownString(I.content)?I.content.value:I.content})}},t=Promise.resolve(i.provider.provideInteractiveEditorResponse(n.session,r,d,a));let p;try{p=await(0,S.$6g)(t,a)}finally{c=!0}if(!p)return;const u=n.responses.push(p)-1,o={wholeRange:m.Range.from(p.wholeRange),placeholder:p.placeholder};if(!D.h(p))return{...o,id:u,type:"editorEdit",message:m.MarkdownString.from(p.contents),edits:[]};const{edits:v,contents:b}=p,$=b!==void 0?m.MarkdownString.from(b):void 0;return v instanceof f.$fM?{...o,id:u,type:"bulkEdit",edits:m.WorkspaceEdit.from(v),message:$}:{...o,id:u,type:"editorEdit",edits:v.map(m.TextEdit.from),message:$}}async $provideFollowups(E,g,s,a){const i=this.b.get(E),n=this.d.get(g),r=n?.responses[s];if(i&&r&&i.provider.provideFollowups){const c=Promise.resolve(i.provider.provideFollowups(n.session,r,a));return(await(0,S.$6g)(c,a))?.map(m.ChatInlineFollowup.from)}}$handleFeedback(E,g,s,a){const i=this.b.get(E),n=this.d.get(g),r=n?.responses[s];if(i&&r){const c=m.InteractiveEditorResponseFeedbackKind.to(a);i.provider.handleInteractiveEditorResponseFeedback?.(n.session,r,c)}}$releaseSession(E,g){}static h(E){return typeof E=="object"&&typeof E.edits=="object"}}e.$9ic=D}),define(Pe[273],Re([1,0,2,31]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jjc=void 0;class P{constructor(R,m,f,k,O){this.a=m,this.b=f,this.c=k;const D=new M.$LO("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new M.$JO("showOptions","Show Options",l=>!0,l=>l),new M.$JO("resource","Interactive resource Uri",l=>!0,l=>l),new M.$JO("controllerId","Notebook controller Id",l=>!0,l=>l),new M.$JO("title","Interactive editor title",l=>!0,l=>l)],new M.$KO("Notebook and input URI",l=>{if(O.debug("[ExtHostInteractive] open iw with notebook editor id",l.notebookEditorId),l.notebookEditorId!==void 0){const E=this.a.getEditorById(l.notebookEditorId);return O.debug("[ExtHostInteractive] notebook editor found",E.id),{notebookUri:S.URI.revive(l.notebookUri),inputUri:S.URI.revive(l.inputUri),notebookEditor:E.apiEditor}}return O.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",l.notebookUri,l.inputUri),{notebookUri:S.URI.revive(l.notebookUri),inputUri:S.URI.revive(l.inputUri)}}));this.c.registerApiCommand(D)}$willAddInteractiveDocument(R,m,f,k){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:m,lines:[""],languageId:f,uri:R,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(R,m){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$jjc=P}),define(Pe[274],Re([1,0,18,11,25,5,6,28,2,20,13,4,31,8,7,76,213,22,49,214]),function(me,e,S,M,P,F,R,m,f,k,O,D,l,E,g,s,a,i,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sjc=e.$rjc=void 0;let c=class{constructor($,I,h,y,w){this.m=I,this.n=h,this.o=y,this.q=w,this.b=new m.$Ac,this.c=new m.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new F.$5d,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=$.getProxy(D.$6L.MainThreadNotebookKernels);const A=new l.$LO("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new l.$JO("options","Select kernel options",G=>!0,G=>{if(G&&"notebookEditor"in G&&"id"in G){const V=this.n.getIdByEditor(G.notebookEditor);return{id:G.id,extension:G.extension,notebookEditorId:V}}else if(G&&"notebookEditor"in G){const V=this.n.getIdByEditor(G.notebookEditor);if(V===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${G.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:V}}return G})],l.$KO.Void),N=new l.$LO("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[l.$JO.Uri],new l.$KO("A promise that resolves to an array of variables",(G,V)=>G.map(U=>({name:U.name,value:U.value,type:U.type,editable:!1}))));this.o.registerApiCommand(A),this.o.registerApiCommand(N)}createNotebookController($,I,h,y,w,A){for(const $e of this.j.values())if($e.controller.id===I&&k.$zm.equals($.identifier,$e.extensionId))throw new Error(`notebook controller with id '${I}' ALREADY exist`);const N=this.k++,G=this;this.q.trace(`NotebookController[${N}], CREATED by ${$.identifier.value}, ${I}`);const V=()=>console.warn(`NO execute handler from notebook controller '${q.id}' of extension: '${$.identifier}'`);let U=!1;const C=new F.$5d,L=new F.$5d,q={id:v($.identifier,I),notebookType:h,extensionId:$.identifier,extensionLocation:$.extensionLocation,label:y||$.identifier.value,preloads:A?A.map(E.NotebookRendererScript.from):[]};let ne=w??V,ae,ye;this.a.$addKernel(N,q).catch($e=>{console.log($e),U=!0});let Ie=0;const ue=()=>{if(U)return;const $e=++Ie;Promise.resolve().then(()=>{$e===Ie&&this.a.$updateKernel(N,q)})},ve=new m.$Ac,re={get id(){return I},get notebookType(){return q.notebookType},onDidChangeSelectedNotebooks:C.event,get label(){return q.label},set label($e){q.label=$e??$.displayName??$.name,ue()},get detail(){return q.detail??""},set detail($e){q.detail=$e,ue()},get description(){return q.description??""},set description($e){q.description=$e,ue()},get supportedLanguages(){return q.supportedLanguages},set supportedLanguages($e){q.supportedLanguages=$e,ue()},get supportsExecutionOrder(){return q.supportsExecutionOrder??!1},set supportsExecutionOrder($e){q.supportsExecutionOrder=$e,ue()},get rendererScripts(){return q.preloads?q.preloads.map(E.NotebookRendererScript.to):[]},get executeHandler(){return ne},set executeHandler($e){ne=$e??V},get interruptHandler(){return ae},set interruptHandler($e){ae=$e,q.supportsInterrupt=!!$e,ue()},set variableProvider($e){(0,i.$YF)($,"notebookVariableProvider"),ye=$e,q.hasVariableProvider=!!$e,$e?.onDidChangeVariables(ie=>G.a.$variablesUpdated(ie.uri)),ue()},get variableProvider(){return ye},createNotebookCellExecution($e){if(U)throw new Error("notebook controller is DISPOSED");if(!ve.has($e.notebook.uri))throw G.q.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ve.keys()).map(ie=>ie.toString())),new Error(`notebook controller is NOT associated to notebook: ${$e.notebook.uri.toString()}`);return G._createNotebookCellExecution($e,v($.identifier,this.id))},createNotebookExecution($e){if((0,i.$YF)($,"notebookExecution"),U)throw new Error("notebook controller is DISPOSED");if(!ve.has($e.uri))throw G.q.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ve.keys()).map(ie=>ie.toString())),new Error(`notebook controller is NOT associated to notebook: ${$e.uri.toString()}`);return G._createNotebookExecution($e,v($.identifier,this.id))},dispose:()=>{U||(this.q.trace(`NotebookController[${N}], DISPOSED`),U=!0,this.j.delete(N),C.dispose(),L.dispose(),this.a.$removeKernel(N))},updateNotebookAffinity($e,ie){ie===g.NotebookControllerAffinity2.Hidden&&(0,i.$YF)($,"notebookControllerAffinityHidden"),G.a.$updateNotebookPriority(N,$e.uri,ie)},onDidReceiveMessage:L.event,postMessage($e,ie){return(0,i.$YF)($,"notebookMessaging"),G.a.$postMessage(N,ie&&G.n.getIdByEditor(ie),$e)},asWebviewUri($e){return(0,i.$YF)($,"notebookMessaging"),(0,s.$Jxb)($e,G.m.remote)}};return this.j.set(N,{extensionId:$.identifier,controller:re,onDidReceiveMessage:L,onDidChangeSelection:C,associatedNotebooks:ve}),re}getIdByController($){for(const[I,h]of this.j)if(h.controller===$)return v(h.extensionId,$.id);return null}createNotebookControllerDetectionTask($,I){const h=this.g++,y=this;this.q.trace(`NotebookControllerDetectionTask[${h}], CREATED by ${$.identifier.value}`),this.a.$addKernelDetectionTask(h,I);const w={dispose:()=>{this.f.delete(h),y.a.$removeKernelDetectionTask(h)}};return this.f.set(h,w),w}registerKernelSourceActionProvider($,I,h){const y=this.i++,w=typeof h.onDidChangeNotebookKernelSourceActions=="function"?y:void 0,A=this;this.h.set(y,h),this.q.trace(`NotebookKernelSourceActionProvider[${y}], CREATED by ${$.identifier.value}`),this.a.$addKernelSourceActionProvider(y,y,I);let N;return w!==void 0&&(N=h.onDidChangeNotebookKernelSourceActions(G=>this.a.$emitNotebookKernelSourceActionsChangeEvent(w))),{dispose:()=>{this.h.delete(y),A.a.$removeKernelSourceActionProvider(y,y),N?.dispose()}}}async $provideKernelSourceActions($,I){const h=this.h.get($);if(h){const y=new R.$Sc;return(await h.provideNotebookKernelSourceActions(I)??[]).map(A=>E.NotebookKernelSourceAction.from(A,this.o.converter,y))}return[]}$acceptNotebookAssociation($,I,h){const y=this.j.get($);if(y){const w=this.n.getNotebookDocument(f.URI.revive(I));h?y.associatedNotebooks.set(w.uri,!0):y.associatedNotebooks.delete(w.uri),this.q.trace(`NotebookController[${$}] ASSOCIATE notebook`,w.uri.toString(),h),y.onDidChangeSelection.fire({selected:h,notebook:w.apiNotebook})}}async $executeCells($,I,h){const y=this.j.get($);if(!y)return;const w=this.n.getNotebookDocument(f.URI.revive(I)),A=[];for(const N of h){const G=w.getCell(N);G&&A.push(G.apiCell)}try{this.q.trace(`NotebookController[${$}] EXECUTE cells`,w.uri.toString(),A.length),await y.controller.executeHandler.call(y.controller,A,w.apiNotebook,y.controller)}catch(N){this.q.error(`NotebookController[${$}] execute cells FAILED`,N),console.error(N)}}async $cancelCells($,I,h){const y=this.j.get($);if(!y)return;const w=this.n.getNotebookDocument(f.URI.revive(I));if(y.controller.interruptHandler)await y.controller.interruptHandler.call(y.controller,w.apiNotebook);else for(const A of h){const N=w.getCell(A);N&&this.b.get(N.uri)?.cancel()}if(y.controller.interruptHandler){const A=this.c.get(w.uri);h.length&&Array.isArray(A)&&A.length&&A.forEach(N=>N.dispose())}}async $provideVariables($,I,h,y,w,A,N){const G=this.j.get($);if(!G)return;const V=this.n.getNotebookDocument(f.URI.revive(h)),U=G.controller.variableProvider;if(!U)return;let C;if(y!==void 0){if(C=this.s[y],!C)return}else this.s={};const L=w==="named"?g.NotebookVariablesRequestKind.Named:g.NotebookVariablesRequestKind.Indexed,q=U.provideVariables(V.apiNotebook,C,L,A,N);let ne=0;for await(const ae of q){if(N.isCancellationRequested)return;const ye={id:this.r++,name:ae.variable.name,value:ae.variable.value,type:ae.variable.type,hasNamedChildren:ae.hasNamedChildren,indexedChildrenCount:ae.indexedChildrenCount,extensionId:G.extensionId.value};if(this.s[ye.id]=ae.variable,this.a.$receiveVariable(I,ye),ne++>=r.$8gb)return}}$acceptKernelMessageFromRenderer($,I,h){const y=this.j.get($);if(!y)return;const w=this.n.getEditorById(I);y.onDidReceiveMessage.fire(Object.freeze({editor:w.apiEditor,message:h}))}$cellExecutionChanged($,I,h){const w=this.n.getNotebookDocument(f.URI.revive($)).getCell(I);if(w){const A=h?E.NotebookCellExecutionState.to(h):g.NotebookCellExecutionState.Idle;A!==void 0&&this.l.fire({cell:w.apiCell,state:A})}}_createNotebookCellExecution($,I){if($.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const y=this.n.getNotebookDocument($.notebook.uri).getCellFromApiCell($);if(!y)throw new Error("invalid cell");if(this.b.has(y.uri))throw new Error(`duplicate execution for ${y.uri}`);const w=new t(I,y,this.a);this.b.set(y.uri,w);const A=w.onDidChangeState(()=>{w.state===d.Resolved&&(w.dispose(),A.dispose(),this.b.delete(y.uri))});return w.asApiObject()}_createNotebookExecution($,I){const h=this.n.getNotebookDocument($.uri),y=$.getCells().find(N=>{const G=h.getCellFromApiCell(N);return G&&this.b.has(G.uri)});if(y)throw new Error(`duplicate cell execution for ${y.document.uri}`);if(this.c.has(h.uri))throw new Error(`duplicate notebook execution for ${h.uri}`);const w=new u(I,h,this.a),A=w.onDidChangeState(()=>{w.state===p.Resolved&&(w.dispose(),A.dispose(),this.c.delete(h.uri))});return this.c.set(h.uri,[w,A]),w.asApiObject()}};e.$rjc=c,e.$rjc=c=Ye([He(4,O.$zj)],c);var d;(function(b){b[b.Init=0]="Init",b[b.Started=1]="Started",b[b.Resolved=2]="Resolved"})(d||(d={}));class t extends R.$Tc{static{this.a=0}get state(){return this.f}constructor($,I,h){super(),this.m=I,this.n=h,this.b=t.a++,this.c=new F.$5d,this.onDidChangeState=this.c.event,this.f=d.Init,this.g=this.B(new P.$ce),this.h=new o(10,y=>this.s(y)),this.j=I.internalMetadata.executionOrder,this.n.$createExecution(this.b,$,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r($){await this.h.addItem($)}async s($){const I=Array.isArray($)?$:[$];return this.n.$updateExecution(this.b,new n.$9v(I))}t(){if(this.f===d.Init)throw new Error("Must call start before modifying cell output");if(this.f===d.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w($){let I=this.m;if($&&(I=this.m.notebook.getCellFromApiCell($)),!I)throw new Error("INVALID cell");return I.handle}y($){return $.map(I=>{const h=g.$zN.ensureUniqueMimeTypes(I.items,!0);return h===I.items?E.NotebookCellOutput.from(I):E.NotebookCellOutput.from({items:h,id:I.id,metadata:I.metadata})})}async z($,I,h){const y=this.w(I),w=this.y((0,S.$3b)($));return this.r({editType:a.CellExecutionUpdateType.Output,cellHandle:y,append:h,outputs:w})}async C($,I,h){return $=g.$zN.ensureUniqueMimeTypes((0,S.$3b)($),!0),this.r({editType:a.CellExecutionUpdateType.OutputItems,items:$.map(E.NotebookCellOutputItem.from),outputId:I.id,append:h})}asApiObject(){const $=this;return Object.freeze({get token(){return $.g.token},get cell(){return $.m.apiCell},get executionOrder(){return $.j},set executionOrder(h){$.j=h,$.s([{editType:a.CellExecutionUpdateType.ExecutionState,executionOrder:$.j}])},start(h){if($.f===d.Resolved||$.f===d.Started)throw new Error("Cannot call start again");$.f=d.Started,$.c.fire(),$.s({editType:a.CellExecutionUpdateType.ExecutionState,runStartTime:h})},end(h,y){if($.f===d.Resolved)throw new Error("Cannot call resolve twice");$.f=d.Resolved,$.c.fire(),$.h.flush(),$.n.$completeExecution($.b,new n.$9v({runEndTime:y,lastRunSuccess:h}))},clearOutput(h){return $.t(),$.z([],h,!1)},appendOutput(h,y){return $.t(),$.z(h,y,!0)},replaceOutput(h,y){return $.t(),$.z(h,y,!1)},appendOutputItems(h,y){return $.t(),$.C(h,y,!0)},replaceOutputItems(h,y){return $.t(),$.C(h,y,!1)}})}}var p;(function(b){b[b.Init=0]="Init",b[b.Started=1]="Started",b[b.Resolved=2]="Resolved"})(p||(p={}));class u extends R.$Tc{static{this.a=0}get state(){return this.f}constructor($,I,h){super(),this.h=I,this.j=h,this.b=u.a++,this.c=new F.$5d,this.onDidChangeState=this.c.event,this.f=p.Init,this.g=this.B(new P.$ce),this.j.$createNotebookExecution(this.b,$,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===p.Resolved||this.f===p.Started)throw new Error("Cannot call start again");this.f=p.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===p.Resolved)throw new Error("Cannot call resolve twice");this.f=p.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class o{constructor($,I){this.f=$,this.g=I,this.a=[],this.b=Date.now()}addItem($){return this.a.push($),this.c||(this.c=new M.$Ch,this.b=Date.now(),(0,M.$gh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const $=this.c;this.c=void 0;const I=this.a;return this.a=[],this.g(I).finally(()=>$.complete())}}function v(b,$){return`${b.value}/${$}`}e.$sjc=v}),define(Pe[66],Re([1,0,5,4,3,2,17,6,7,169,14,197,25,33,198,40,11,8,31]),function(me,e,S,M,P,F,R,m,f,k,O,D,l,E,g,s,a,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gic=e.$Fic=e.$Eic=e.$Dic=void 0,e.$Dic=(0,P.$fi)("IExtHostTerminalService");class r{constructor(h,y,w,A){this.l=h,this._id=y,this.m=w,this.n=A,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(G=>this.f=G);const N=this;this.value={get name(){return N.n||""},get processId(){return N.b},get creationOptions(){return N.m},get exitStatus(){return N.h},get state(){return N.j},get selection(){return N.k},sendText(G,V=!0){N.q(),N.l.$sendText(N._id,G,V)},show(G){N.q(),N.l.$show(N._id,G)},hide(){N.q(),N.l.$hide(N._id)},dispose(){N.a||(N.a=!0,N.l.$dispose(N._id))},get dimensions(){if(!(N.d===void 0||N.g===void 0))return{columns:N.d,rows:N.g}}}}async create(h,y){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:h.name,shellPath:h.shellPath??void 0,shellArgs:h.shellArgs??void 0,cwd:h.cwd??y?.cwd??void 0,env:h.env??void 0,icon:v(h.iconPath)??void 0,color:s.ThemeColor.isThemeColor(h.color)?h.color.id:void 0,initialText:h.message??void 0,strictEnv:h.strictEnv??void 0,hideFromUser:h.hideFromUser??void 0,forceShellIntegration:y?.forceShellIntegration??void 0,isFeatureTerminal:y?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:y?.useShellEnvironment??void 0,location:y?.location||this.o(h.location,y?.resolvedExtHostIdentifier),isTransient:h.isTransient??void 0})}async createExtensionTerminal(h,y,w,A,N){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:A,color:s.ThemeColor.isThemeColor(N)?N.id:void 0,location:y?.location||this.o(h,w),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(h,y){return typeof h=="object"?"parentTerminal"in h&&h.parentTerminal&&y?{parentTerminal:y}:"viewColumn"in h?{viewColumn:i.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus}:void 0:h}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(h){this.n=h}setExitStatus(h,y){this.h=Object.freeze({code:h,reason:y})}setDimensions(h,y){return h===this.d&&y===this.g||h===0||y===0?!1:(this.d=h,this.g=y,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(h){this.k=h}_setProcessId(h){this.f?(this.f(h),this.f=void 0):this.b.then(y=>{y!==h&&(this.b=Promise.resolve(h))})}}e.$Eic=r;class c{get onProcessReady(){return this.b.event}constructor(h){this.g=h,this.id=0,this.shouldPersist=!1,this.a=new S.$5d,this.onProcessData=this.a.event,this.b=new S.$5d,this.d=new S.$5d,this.onDidChangeProperty=this.d.event,this.f=new S.$5d,this.onProcessExit=this.f.event}refreshProperty(h){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${h}`)}updateProperty(h,y){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${h}, value: ${y}`)}async start(){}shutdown(){this.g.close()}input(h){this.g.handleInput?.(h)}resize(h,y){this.g.setDimensions?.({columns:h,rows:y})}clearBuffer(){}async processBinary(h){}acknowledgeDataEvent(h){}async setUnicodeVersion(h){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(h){this.g.onDidWrite(y=>this.a.fire(y)),this.g.onDidClose?.((y=void 0)=>{this.f.fire(y===void 0?void 0:y)}),this.g.onDidOverrideDimensions?.(y=>{y&&this.d.fire({type:"overrideDimensions",value:{cols:y.columns,rows:y.rows}})}),this.g.onDidChangeName?.(y=>{this.d.fire({type:"title",value:y})}),this.g.open(h||void 0),h&&this.g.setDimensions?.(h),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let d=1,t=class extends m.$Tc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(h=>h.value)}constructor(h,y,w){super(),this.Q=y,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new m.$Uc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new S.$5d,this.onDidCloseTerminal=this.H.event,this.I=new S.$5d,this.onDidOpenTerminal=this.I.event,this.J=new S.$5d,this.onDidChangeActiveTerminal=this.J.event,this.L=new S.$5d,this.onDidChangeTerminalDimensions=this.L.event,this.M=new S.$5d,this.onDidChangeTerminalState=this.M.event,this.N=new S.$5d,this.onDidChangeShell=this.N.event,this.O=new S.$5d({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new S.$5d({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=w.getProxy(M.$6L.MainThreadTerminalService),this.y=new g.$Ptb(this.a.$sendProcessData),this.a.$registerProcessSupport(h),this.Q.registerArgumentProcessor({processArgument:A=>{const N=G=>{const V=G;return this.W(V.instanceId)?.value};switch(A?.$mid){case 15:return N(A);default:{if(Array.isArray(A))for(let G=0;G<A.length&&A[G].$mid===15;G++)A[G]=N(A[G]);return A}}}}),this.B({dispose:()=>{for(const[A,N]of this.g)N.shutdown(!0)}})}getDefaultShell(h){return(h?this.u:this.s)?.path||""}getDefaultShellArgs(h){return(h?this.u:this.s)?.args||[]}createExtensionTerminal(h,y){const w=new r(this.a,(0,E.$Bg)(),h,h.name),A=new c(h.pty);return w.createExtensionTerminal(h.location,y,this.R(h,y).resolvedExtHostIdentifier,v(h.iconPath),b(h.color)).then(N=>{const G=this.S(N,A);this.h[N]=G}),this.f.push(w),w.value}R(h,y){if(y=y||{},h.location&&typeof h.location=="object"&&"parentTerminal"in h.location){const w=h.location.parentTerminal;if(w){const A=this.f.find(N=>N.value===w);A&&(y.resolvedExtHostIdentifier=A._id)}}else h.location&&typeof h.location!="object"?y.location=h.location:y.location&&typeof y.location=="object"&&"splitActiveTerminal"in y.location&&(y.location={splitActiveTerminal:!0});return y}attachPtyToTerminal(h,y){if(!this.W(h))throw new Error(`Cannot resolve terminal with id ${h} for virtual process`);const A=new c(y),N=this.S(h,A);this.h[h]=N}async $acceptActiveTerminalChanged(h){const y=this.b;if(h===null){this.b=void 0,y!==this.b&&this.J.fire(this.b);return}const w=this.W(h);w&&(this.b=w,y!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(h,y){const w=this.W(h);w&&this.O.fire({terminal:w.value,data:y})}async $acceptTerminalDimensions(h,y,w){const A=this.W(h);A&&A.setDimensions(y,w)&&this.L.fire({terminal:A.value,dimensions:A.value.dimensions})}async $acceptDidExecuteCommand(h,y){const w=this.W(h);w&&this.P.fire({terminal:w.value,...y})}async $acceptTerminalMaximumDimensions(h,y,w){this.g.get(h)?.resize(y,w)}async $acceptTerminalTitleChange(h,y){const w=this.W(h);w&&(w.name=y)}async $acceptTerminalClosed(h,y,w){const A=this.Y(this.f,h);if(A!==null){const N=this.f.splice(A,1)[0];N.setExitStatus(y,w),this.H.fire(N.value)}}$acceptTerminalOpened(h,y,w,A){if(y){const V=this.Y(this.f,y);if(V!==null){this.f[V]._id=h,this.I.fire(this.terminals[V]),this.f[V].isOpen=!0;return}}const N={name:A.name,shellPath:A.executable,shellArgs:A.args,cwd:typeof A.cwd=="string"?A.cwd:F.URI.revive(A.cwd),env:A.env,hideFromUser:A.hideFromUser},G=new r(this.a,h,N,w);this.f.push(G),this.I.fire(G.value),G.isOpen=!0}async $acceptTerminalProcessId(h,y){this.W(h)?._setProcessId(y)}async $startExtensionTerminal(h,y){const w=this.W(h);if(!w)return{message:(0,k.localize)(0,null,h)};w.isOpen||await new Promise(N=>{const G=this.onDidOpenTerminal(async V=>{V===w.value&&(G.dispose(),N())})});const A=this.g.get(h);A?A.startSendingEvents(y):this.j[h]={initialDimensions:y}}S(h,y){const w=new m.$Sc;w.add(y.onProcessReady(N=>this.a.$sendProcessReady(h,N.pid,N.cwd,N.windowsPty))),w.add(y.onDidChangeProperty(N=>this.a.$sendProcessProperty(h,N))),this.y.startBuffering(h,y.onProcessData),w.add(y.onProcessExit(N=>this.U(h,N))),this.g.set(h,y);const A=this.j[h];return A&&y instanceof c&&(y.startSendingEvents(A.initialDimensions),delete this.j[h]),w}$acceptProcessAckDataEvent(h,y){this.g.get(h)?.acknowledgeDataEvent(y)}$acceptProcessInput(h,y){this.g.get(h)?.input(y)}$acceptTerminalInteraction(h){const y=this.W(h);y?.setInteractedWith()&&this.M.fire(y.value)}$acceptTerminalSelection(h,y){this.W(h)?.setSelection(y)}$acceptProcessResize(h,y,w){try{this.g.get(h)?.resize(y,w)}catch(A){if(A.code!=="EPIPE"&&A.code!=="ERR_IPC_CHANNEL_CLOSED")throw A}}$acceptProcessShutdown(h,y){this.g.get(h)?.shutdown(y)}$acceptProcessRequestInitialCwd(h){this.g.get(h)?.getInitialCwd().then(y=>this.a.$sendProcessProperty(h,{type:"initialCwd",value:y}))}$acceptProcessRequestCwd(h){this.g.get(h)?.getCwd().then(y=>this.a.$sendProcessProperty(h,{type:"cwd",value:y}))}$acceptProcessRequestLatency(h){return Promise.resolve(h)}registerLinkProvider(h){return this.z.add(h),this.z.size===1&&this.a.$startLinkProvider(),new f.$8L(()=>{this.z.delete(h),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(h,y,w){if(this.C.has(y))throw new Error(`Terminal profile provider "${y}" already registered`);return this.C.set(y,w),this.a.$registerProfileProvider(y,h.identifier.value),new f.$8L(()=>{this.C.delete(y),this.a.$unregisterProfileProvider(y)})}registerTerminalQuickFixProvider(h,y,w){if(this.D.has(h))throw new Error(`Terminal quick fix provider "${h}" is already registered`);return this.D.set(h,w),this.a.$registerQuickFixProvider(h,y),new f.$8L(()=>{this.D.delete(h),this.a.$unregisterQuickFixProvider(h)})}async $provideTerminalQuickFixes(h,y){const w=new l.$ce().token;if(w.isCancellationRequested)return;const A=this.D.get(h);if(!A)return;const N=await A.provideTerminalQuickFixes(y,w);if(N===null||Array.isArray(N)&&N.length===0)return;const G=new m.$Sc;if(this.w.value=G,!Array.isArray(N))return N?i.TerminalQuickFix.from(N,this.Q.converter,G):void 0;const V=[];for(const U of N){const C=i.TerminalQuickFix.from(U,this.Q.converter,G);C&&V.push(C)}return V}async $createContributedProfileTerminal(h,y){const w=new l.$ce().token;let A=await this.C.get(h)?.provideTerminalProfile(w);if(!w.isCancellationRequested){if(A&&!("options"in A)&&(A={options:A}),!A||!("options"in A))throw new Error(`No terminal profile options provided for id "${h}"`);if("pty"in A.options){this.createExtensionTerminal(A.options,y);return}this.createTerminalFromOptions(A.options,y)}}async $provideLinks(h,y){const w=this.W(h);if(!w)return[];this.F.delete(h),this.G.get(h)?.dispose(!0);const N=new l.$ce;this.G.set(h,N);const G=[],V={terminal:w.value,line:y},U=[];for(const q of this.z)U.push(a.Promises.withAsyncBody(async ne=>{N.token.onCancellationRequested(()=>ne({provider:q,links:[]}));const ae=await q.provideTerminalLinks(V,N.token)||[];N.token.isCancellationRequested||ne({provider:q,links:ae})}));const C=await Promise.all(U);if(N.token.isCancellationRequested)return[];const L=new Map;for(const q of C)q&&q.links.length>0&&G.push(...q.links.map(ne=>{const ae={id:d++,startIndex:ne.startIndex,length:ne.length,label:ne.tooltip};return L.set(ae.id,{provider:q.provider,link:ne}),ae}));return this.F.set(h,L),G}$activateLink(h,y){const w=this.F.get(h)?.get(y);w&&w.provider.handleTerminalLink(w.link)}U(h,y){this.y.stopBuffering(h),this.g.delete(h),delete this.j[h];const w=this.h[h];w&&(w.dispose(),delete this.h[h]),this.a.$sendProcessExit(h,y)}W(h){return this.X(this.f,h)}X(h,y){const w=this.Y(h,y);return w!==null?h[w]:null}Y(h,y){const w=h.findIndex(A=>A._id===y);return w===-1?null:w}getEnvironmentVariableCollection(h){let y=this.n.get(h.identifier.value);return y||(y=new p,this.$(h.identifier.value,y)),y.getScopedEnvironmentVariableCollection(void 0)}Z(h,y){const w=(0,D.$1r)(y.map),A=(0,D.$2r)(y.descriptionMap);this.a.$setEnvironmentVariableCollection(h,y.persistent,w.length===0?void 0:w,A)}$initEnvironmentVariableCollections(h){h.forEach(y=>{const w=y[0],A=new p(y[1]);this.$(w,A)})}$acceptDefaultProfile(h,y){const w=this.s;this.s=h,this.u=y,w?.path!==h.path&&this.N.fire(h.path)}$(h,y){this.n.set(h,y),y.onDidChangeCollection(()=>{this.Z(h,y)})}};e.$Fic=t,e.$Fic=t=Ye([He(1,n.$HO),He(2,R.$lO)],t);class p{get persistent(){return this.b}set persistent(h){this.b=h,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(h){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new S.$5d,this.map=new Map(h)}getScopedEnvironmentVariableCollection(h){const y=this.h(h);let w=this.a.get(y);return w||(w=new u(this,h),this.a.set(y,w),w.onDidChangeCollection(()=>this.d.fire())),w}replace(h,y,w,A){this.f(h,{value:y,type:f.EnvironmentVariableMutatorType.Replace,options:w??{applyAtProcessCreation:!0},scope:A})}append(h,y,w,A){this.f(h,{value:y,type:f.EnvironmentVariableMutatorType.Append,options:w??{applyAtProcessCreation:!0},scope:A})}prepend(h,y,w,A){this.f(h,{value:y,type:f.EnvironmentVariableMutatorType.Prepend,options:w??{applyAtProcessCreation:!0},scope:A})}f(h,y){if(y.options&&y.options.applyAtProcessCreation===!1&&!y.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const w=this.g(h,y.scope),A=this.map.get(w),N=y.options?{applyAtProcessCreation:y.options.applyAtProcessCreation??!1,applyAtShellIntegration:y.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!A||A.value!==y.value||A.type!==y.type||A.options?.applyAtProcessCreation!==N.applyAtProcessCreation||A.options?.applyAtShellIntegration!==N.applyAtShellIntegration||A.scope?.workspaceFolder?.index!==y.scope?.workspaceFolder?.index){const G=this.g(h,y.scope),V={variable:h,...y,options:N};this.map.set(G,V),this.d.fire()}}get(h,y){const w=this.g(h,y),A=this.map.get(w);return A?$(A):void 0}g(h,y){const w=this.h(y);return w.length?`${h}:::${w}`:h}h(h){return this.j(h?.workspaceFolder)??""}j(h){return h?h.uri.toString():void 0}getVariableMap(h){const y=new Map;for(const[w,A]of this.map)this.h(A.scope)===this.h(h)&&y.set(A.variable,$(A));return y}delete(h,y){const w=this.g(h,y);this.map.delete(w),this.d.fire()}clear(h){if(h?.workspaceFolder){for(const[y,w]of this.map)w.scope?.workspaceFolder?.index===h.workspaceFolder.index&&this.map.delete(y);this.k(h)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(h,y){const w=this.h(y),A=this.descriptionMap.get(w);if(!A||A.description!==h){let N;typeof h=="string"?N=h:N=h?.value.split(`

`)[0];const G={description:N,scope:y};this.descriptionMap.set(w,G),this.d.fire()}}getDescription(h){const y=this.h(h);return this.descriptionMap.get(y)?.description}k(h){const y=this.h(h);this.descriptionMap.delete(y)}}class u{get persistent(){return this.b.persistent}set persistent(h){this.b.persistent=h}get onDidChangeCollection(){return this.a&&this.a.event}constructor(h,y){this.b=h,this.d=y,this.a=new S.$5d}getScoped(h){return this.b.getScopedEnvironmentVariableCollection(h)}replace(h,y,w){this.b.replace(h,y,w,this.d)}append(h,y,w){this.b.append(h,y,w,this.d)}prepend(h,y,w){this.b.prepend(h,y,w,this.d)}get(h){return this.b.get(h,this.d)}forEach(h,y){this.b.getVariableMap(this.d).forEach((w,A)=>h.call(y,A,w,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(h){this.b.delete(h,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(h){this.b.setDescription(h,this.d)}get description(){return this.b.getDescription(this.d)}}let o=class extends t{constructor(h,y){super(!1,h,y)}createTerminal(h,y,w){throw new O.$_}createTerminalFromOptions(h,y){throw new O.$_}};e.$Gic=o,e.$Gic=o=Ye([He(0,n.$HO),He(1,R.$lO)],o);function v(I){if(!(!I||typeof I=="string"))return"id"in I?{id:I.id,color:I.color}:I}function b(I){return s.ThemeColor.isThemeColor(I)?I:void 0}function $(I){const h={...I};return delete h.scope,h.options=h.options??void 0,delete h.variable,h}}),define(Pe[275],Re([1,0,11,23,25,5,247,99,6,26,16,33,13,4,17,113,8,7,48,75,60,22]),function(me,e,S,M,P,F,R,m,f,k,O,D,l,E,g,s,a,i,n,r,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mjc=e.$Ljc=e.$Kjc=e.$Jjc=void 0;let t=class extends f.$Tc{constructor(U,C,L,q){super(),this.w=q,this.f=this.B(new F.$5d),this.g=new Map,this.s=this.B(new F.$5d),this.onResultsChanged=this.f.event,this.results=[],this.h=U.getProxy(E.$6L.MainThreadTesting),this.m=new w(this.h),this.j=new v(this.h,C),L.registerArgumentProcessor({processArgument:ne=>{switch(ne?.$mid){case 16:{const ae=ne,ye=ae.tests[ae.tests.length-1].item.extId;return this.g.get(n.$WK.root(ye))?.collection.tree.get(ye)?.actual??(0,s.$xO)(ne)}case 18:{const{extId:ae,message:ye}=ne;return{test:this.g.get(n.$WK.root(ae))?.collection.tree.get(ae)?.actual,message:a.TestMessage.to(ye)}}default:return ne}}}),L.registerCommand(!1,"testing.getExplorerSelection",async()=>{const ne=await L.executeCommand("_testing.getExplorerSelection"),ae=ye=>{const Ie=this.g.get(n.$WK.root(ye));if(Ie)return n.$WK.isRoot(ye)?Ie.controller:Ie.collection.tree.get(ye)?.actual};return{include:ne?.include.map(ae).filter(O.$1f)||[],exclude:ne?.exclude.map(ae).filter(O.$1f)||[]}})}createTestController(U,C,L,q){if(this.g.has(C))throw new Error(`Attempt to insert a duplicate controller with ID "${C}"`);const ne=new f.$Sc,ae=ne.add(new s.$AO(C,L,this.w));ae.root.label=L;const ye=new Map,Ie=new Set,ue=this.h,ve={items:ae.root.children,get label(){return L},set label($e){L=$e,ae.root.label=$e,ue.$updateController(C,{label:L})},get refreshHandler(){return q},set refreshHandler($e){q=$e,ue.$updateController(C,{canRefresh:!!$e})},get id(){return C},createRunProfile:($e,ie,le,W,_,ke)=>{let Ne=(0,m.$6i)($e);for(;ye.has(Ne);)Ne++;return new N(this.h,ye,Ie,this.s.event,C,Ne,$e,ie,le,W,_,ke)},createTestItem($e,ie,le){return new s.$yO(C,$e,ie,le)},createTestRun:($e,ie,le=!0)=>this.j.createTestRun(U,C,ae,$e,ie,le),invalidateTestResults:$e=>{if($e===void 0)this.h.$markTestRetired(void 0);else{const ie=$e instanceof Array?$e:[$e];this.h.$markTestRetired(ie.map(le=>n.$WK.fromExtHostTestItem(le,C).toString()))}},set resolveHandler($e){ae.resolveHandler=$e},get resolveHandler(){return ae.resolveHandler},dispose:()=>{ne.dispose()}};ue.$registerTestController(C,L,!!q),ne.add((0,f.$Rc)(()=>ue.$unregisterTestController(C)));const re={controller:ve,collection:ae,profiles:ye,extension:U,activeProfiles:Ie};return this.g.set(C,re),ne.add((0,f.$Rc)(()=>this.g.delete(C))),ne.add(ae.onDidGenerateDiff($e=>ue.$publishDiff(C,$e.map(c.TestsDiffOp.serialize)))),ve}createTestObserver(){return this.m.checkout()}async runTests(U,C=P.CancellationToken.None){const L=b(U);if(!L)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const q=this.g.get(L.controllerId);if(!q)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:U.include?.map(ne=>n.$WK.fromExtHostTestItem(ne,q.collection.root.id).toString())??[q.collection.root.id],profileGroup:G[L.kind],profileId:L.profileId,controllerId:L.controllerId}],exclude:U.exclude?.map(ne=>ne.id)},C)}$syncTests(){for(const{collection:U}of this.g.values())U.flushDiff();return Promise.resolve()}async $provideFileCoverage(U,C,L){return await this.j.getCoverageReport(U,C)?.provideFileCoverage(L)??[]}async $resolveFileCoverage(U,C,L,q){return await this.j.getCoverageReport(U,C)?.resolveFileCoverage(L,q)??[]}$configureRunProfile(U,C){this.g.get(U)?.profiles.get(C)?.configureHandler?.()}$setDefaultRunProfiles(U){const C=new Map;for(const[L,q]of Object.entries(U)){const ne=this.g.get(L);if(!ne)continue;const ae=new Map,ye=q.filter(ue=>!ne.activeProfiles.has(ue)),Ie=[...ne.activeProfiles].filter(ue=>!q.includes(ue));for(const ue of ye)ae.set(ue,!0),ne.activeProfiles.add(ue);for(const ue of Ie)ae.set(ue,!1),ne.activeProfiles.delete(ue);ae.size&&C.set(L,ae)}this.s.fire(C)}async $refreshTests(U,C){await this.g.get(U)?.controller.refreshHandler?.(C)}$publishTestResults(U){this.results=Object.freeze(U.map(C=>(0,k.$Ln)(a.TestResults.to(C))).concat(this.results).sort((C,L)=>L.completedAt-C.completedAt).slice(0,32)),this.f.fire()}async $expandTest(U,C){const L=this.g.get(n.$WK.fromString(U).controllerId)?.collection;L&&(await L.expand(U,C<0?1/0:C),L.flushDiff())}$acceptDiff(U){this.m.applyDiff(U.map(C=>c.TestsDiffOp.deserialize({asCanonicalUri:L=>L},C)))}async $runControllerTests(U,C){return Promise.all(U.map(L=>this.y(L,!1,C)))}async $startContinuousRun(U,C){const L=new P.$ce(C),q=await Promise.all(U.map(ne=>this.y(ne,!0,L.token)));return!C.isCancellationRequested&&!q.some(ne=>ne.error)&&await new Promise(ne=>C.onCancellationRequested(ne)),L.dispose(!0),q}async y(U,C,L){const q=this.g.get(U.controllerId);if(!q)return{};const{collection:ne,profiles:ae,extension:ye}=q,Ie=ae.get(U.profileId);if(!Ie)return{};const ue=U.testIds.map(ie=>ne.tree.get(ie)).filter(O.$1f),ve=U.excludeExtIds.map(ie=>q.collection.tree.get(ie)).filter(O.$1f).filter(ie=>ue.some(le=>le.fullId.compare(ie.fullId)===2));if(!ue.length)return{};const re=new i.$GN(ue.some(ie=>ie.actual instanceof s.$zO)?void 0:ue.map(ie=>ie.actual),ve.map(ie=>ie.actual),Ie,C),$e=(0,c.$YK)(U)&&this.j.prepareForMainThreadTestRun(re,$.fromInternal(U,q.collection),ye,L);try{return await Ie.runHandler(re,L),{}}catch(ie){return{error:String(ie)}}finally{$e&&($e.hasRunningTasks&&!L.isCancellationRequested&&await F.Event.toPromise($e.onEnd),$e.dispose())}}$cancelExtensionTestRun(U){U===void 0?this.j.cancelAllRuns():this.j.cancelRunById(U)}};e.$Jjc=t,e.$Jjc=t=Ye([He(0,g.$lO),He(1,l.$zj)],t);const p=1e4;var u;(function(V){V[V.Running=0]="Running",V[V.Cancelling=1]="Cancelling",V[V.Ended=2]="Ended"})(u||(u={}));class o extends f.$Tc{get hasRunningTasks(){return this.f.size>0}get id(){return this.s.id}constructor(U,C,L,q,ne){super(),this.s=U,this.w=C,this.y=L,this.z=q,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new F.$5d),this.m=this.B(new F.$5d),this.onDidCoverage=this.m.event,this.onEnd=this.j.event,this.h=this.B(new P.$ce(ne));const ae=this.B(new S.$rh(()=>this.C(),p));this.B(this.h.token.onCancellationRequested(()=>ae.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.C()}createRun(U){const C=this.s.id,L=this.s.controllerId,q=(0,D.$Bg)(),ne=this.y,ae=this.m;let ye;const Ie=$e=>(ie,...le)=>{if(ve){this.z.warn(`Setting the state of test "${ie.id}" is a no-op after the run ends.`);return}this.s.isIncluded(ie)&&(this.F(ie),$e(ie,...le))},ue=($e,ie)=>{const le=ie instanceof Array?ie.map(a.TestMessage.from):[a.TestMessage.from(ie)];if($e.uri&&$e.range){const W={range:a.Range.from($e.range),uri:$e.uri};for(const _ of le)_.location=_.location||W}this.w.$appendTestMessagesInRun(C,q,n.$WK.fromExtHostTestItem($e,L).toString(),le)};let ve=!1;const re={isPersisted:this.s.isPersisted,token:this.h.token,name:U,get coverageProvider(){return ye?.provider},set coverageProvider($e){(0,d.$YF)(ne,"testCoverage"),ye=$e&&new I($e),ae.fire({taskId:q,runId:C,coverage:ye})},enqueued:Ie($e=>{this.w.$updateTestStateInRun(C,q,n.$WK.fromExtHostTestItem($e,L).toString(),1)}),skipped:Ie($e=>{this.w.$updateTestStateInRun(C,q,n.$WK.fromExtHostTestItem($e,L).toString(),5)}),started:Ie($e=>{this.w.$updateTestStateInRun(C,q,n.$WK.fromExtHostTestItem($e,L).toString(),2)}),errored:Ie(($e,ie,le)=>{ue($e,ie),this.w.$updateTestStateInRun(C,q,n.$WK.fromExtHostTestItem($e,L).toString(),6,le)}),failed:Ie(($e,ie,le)=>{ue($e,ie),this.w.$updateTestStateInRun(C,q,n.$WK.fromExtHostTestItem($e,L).toString(),4,le)}),passed:Ie(($e,ie)=>{this.w.$updateTestStateInRun(C,q,n.$WK.fromExtHostTestItem($e,this.s.controllerId).toString(),3,ie)}),appendOutput:($e,ie,le)=>{ve||(le&&(this.s.isIncluded(le)?this.F(le):le=void 0),this.w.$appendOutputToRun(C,q,M.$se.fromString($e),ie&&a.location.from(ie),le&&n.$WK.fromExtHostTestItem(le,L).toString()))},end:()=>{ve||(ve=!0,this.w.$finishedTestRunTask(C,q),this.f.delete(q),this.f.size||this.D())}};return this.f.set(q,{run:re}),this.w.$startedTestRunTask(C,{id:q,name:U,running:!0}),re}C(){for(const{run:U}of this.f.values())U.end()}D(){this.c!==2&&(this.c=2,this.j.fire())}F(U){if(!(U instanceof s.$yO))throw new r.$dO(U.id);if(this.g.has(n.$WK.fromExtHostTestItem(U,this.s.controllerId).toString()))return;const C=[],L=this.s.colllection.root;for(;;){const q=a.TestItem.from(U);if(C.unshift(q),this.g.has(q.extId)||(this.g.add(q.extId),U===L))break;U=U.parent||L}this.w.$addTestsToRun(this.s.controllerId,this.s.id,C)}dispose(){this.D(),super.dispose()}}class v{get trackers(){return this.c.values()}constructor(U,C){this.g=U,this.h=C,this.c=new Map,this.f=[]}getCoverageReport(U,C){return this.f.find(L=>L.runId===U)?.coverage.get(C)}prepareForMainThreadTestRun(U,C,L,q){return this.j(U,C,L,q)}cancelRunById(U){for(const C of this.c.values())if(C.id===U){C.cancel();return}}cancelAllRuns(){for(const U of this.c.values())U.cancel()}createTestRun(U,C,L,q,ne,ae){const ye=this.c.get(q);if(ye)return ye.createRun(ne);const Ie=$.fromPublic(C,L,q,ae),ue=b(q);this.g.$startedExtensionTestRun({controllerId:C,continuous:!!q.continuous,profile:ue&&{group:G[ue.kind],id:ue.profileId},exclude:q.exclude?.map(re=>n.$WK.fromExtHostTestItem(re,L.root.id).toString())??[],id:Ie.id,include:q.include?.map(re=>n.$WK.fromExtHostTestItem(re,L.root.id).toString())??[L.root.id],persist:ae});const ve=this.j(q,Ie,U);return F.Event.once(ve.onEnd)(()=>{this.g.$finishedExtensionTestRun(Ie.id),ve.dispose()}),ve.createRun(ne)}j(U,C,L,q){const ne=new o(C,this.g,L,this.h,q);this.c.set(U,ne);let ae;const ye=ne.onDidCoverage(({runId:Ie,taskId:ue,coverage:ve})=>{ae||(ae={runId:Ie,coverage:new Map},this.f.unshift(ae),this.f.length>c.$4K&&this.f.pop()),ae.coverage.set(ue,ve),this.g.$signalCoverageAvailable(Ie,ue,!!ve)});return F.Event.once(ne.onEnd)(()=>{this.c.delete(U),ye.dispose()}),ne}}e.$Kjc=v;const b=V=>{if(V.profile){if(!(V.profile instanceof N))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return V.profile}};class ${static fromPublic(U,C,L,q){return new $(U,(0,D.$Bg)(),L.include?.map(ne=>n.$WK.fromExtHostTestItem(ne,U).toString())??[U],L.exclude?.map(ne=>n.$WK.fromExtHostTestItem(ne,U).toString())??[],q,C)}static fromInternal(U,C){return new $(U.controllerId,U.runId,U.testIds,U.excludeExtIds,!0,C)}constructor(U,C,L,q,ne,ae){this.controllerId=U,this.id=C,this.isPersisted=ne,this.colllection=ae,this.c=L.map(ye=>ye+"\0"),this.f=q.map(ye=>ye+"\0")}isIncluded(U){const C=n.$WK.fromExtHostTestItem(U,this.controllerId).toString()+"\0";for(const L of this.f)if(C===L||C.startsWith(L))return!1;for(const L of this.c)if(C===L||C.startsWith(L))return!0;return!1}}e.$Ljc=$;class I{constructor(U){this.provider=U}async provideFileCoverage(U){this.c||(this.c=(async()=>this.provider.provideFileCoverage(U))());try{return(await this.c)?.map(a.TestCoverage.fromFile)??[]}catch(C){throw this.c=void 0,C}}async resolveFileCoverage(U,C){const L=await this.c;let q=L?.[U];return!this.provider||!L||!q?[]:(q.detailedCoverage||(q=L[U]=await this.provider.resolveFileCoverage?.(q,C)??q),q.detailedCoverage?.map(a.TestCoverage.fromDetailed)??[])}}class h{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(U){this.j=U,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(U){this.c.add(U)}update(U){Object.assign(U.revived,a.TestItem.toPlain(U.item)),this.c.has(U)||this.f.add(U)}remove(U){if(this.c.has(U)){this.c.delete(U);return}this.f.delete(U);const C=n.$WK.parentId(U.item.extId);if(C&&this.h.has(C.toString())){this.h.add(U.item.extId);return}this.g.add(U)}getChangeEvent(){const{c:U,f:C,g:L}=this;return{get added(){return[...U].map(q=>q.revived)},get updated(){return[...C].map(q=>q.revived)},get removed(){return[...L].map(q=>q.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class y extends c.$5K{constructor(){super(...arguments),this.s=new F.$5d,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(U){return this.f.get(U)}getMirroredTestDataByReference(U){return this.f.get(U.id)}w(U,C){return{...U,revived:a.TestItem.toPlain(U.item),depth:C?C.depth+1:0,children:new Set}}v(){return new h(this.s)}}class w{constructor(U){this.f=U}checkout(){this.c||(this.c=this.g());const U=this.c;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map(C=>C.revived)},dispose:(0,R.$db)(()=>{--U.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(U){return this.c?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.c?.tests.apply(U)}g(){const U=new y({asCanonicalUri:C=>C});return this.f.$subscribeToDiffs(),{observers:0,tests:U}}}const A=(V,U,C,L)=>{C?Object.assign(C,L):U.$updateTestRunConfig(V.controllerId,V.profileId,L)};class N{#e;#t;#i;#n;#s;get label(){return this.f}set label(U){U!==this.f&&(this.f=U,A(this,this.#e,this.#n,{label:U}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(U){U!==this.g&&(this.g=U,A(this,this.#e,this.#n,{supportsContinuousRun:U}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(U){U!==this.isDefault&&(U?this.#t.add(this.profileId):this.#t.delete(this.profileId),A(this,this.#e,this.#n,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,A(this,this.#e,this.#n,{tag:U?a.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this.c}set configureHandler(U){U!==this.c&&(this.c=U,A(this,this.#e,this.#n,{hasConfigurationHandler:!!U}))}get onDidChangeDefault(){return F.Event.chain(this.#i,U=>U.map(C=>C.get(this.controllerId)?.get(this.profileId)).filter(O.$1f))}constructor(U,C,L,q,ne,ae,ye,Ie,ue,ve=!1,re=void 0,$e=!1){this.controllerId=ne,this.profileId=ae,this.f=ye,this.kind=Ie,this.runHandler=ue,this._tag=re,this.g=$e,this.#e=U,this.#s=C,this.#t=L,this.#i=q,C.set(ae,this);const ie=G[Ie];if(typeof ie!="number")throw new Error(`Unknown TestRunProfile.group ${Ie}`);ve&&L.add(ae),this.#n={profileId:ae,controllerId:ne,tag:re?a.TestTag.namespace(this.controllerId,re.id):null,label:ye,group:ie,isDefault:ve,hasConfigurationHandler:!1,supportsContinuousRun:$e},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$Mjc=N;const G={[i.TestRunProfileKind.Coverage]:8,[i.TestRunProfileKind.Debug]:4,[i.TestRunProfileKind.Run]:2}}),define(Pe[114],Re([1,0,55,14,90,8,7]),function(me,e,S,M,P,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uO=e.$tO=e.$sO=void 0;class m{static{this.c=new P.$qO("TextEditorDecorationType")}constructor(l,E,g){const s=m.c.nextId();l.$registerTextEditorDecorationType(E.identifier,s,F.DecorationRenderOptions.from(g)),this.value=Object.freeze({key:s,dispose(){l.$removeTextEditorDecorationType(s)}})}}e.$sO=m;class f{constructor(l,E){this.g=[],this.h=void 0,this.j=!1,this.c=l,this.d=l.version,this.e=E.undoStopBefore,this.f=E.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(l,E){this.k();let g=null;if(l instanceof R.$9L)g=new R.$0L(l,l);else if(l instanceof R.$0L)g=l;else throw new Error("Unrecognized location");this.l(g,E,!1)}insert(l,E){this.k(),this.l(new R.$0L(l,l),E,!0)}delete(l){this.k();let E=null;if(l instanceof R.$0L)E=l;else throw new Error("Unrecognized location");this.l(E,null,!0)}l(l,E,g){const s=this.c.validateRange(l);this.g.push({range:s,text:E,forceMoveMarkers:g})}setEndOfLine(l){if(this.k(),l!==R.EndOfLine.LF&&l!==R.EndOfLine.CRLF)throw(0,M.$7)("endOfLine");this.h=l}}class k{constructor(l,E,g,s){this.c=l,this.d=E,this._accept(g),this.e=s;const a=this;this.value={get tabSize(){return a.f},set tabSize(i){a.n(i)},get indentSize(){return a.g},set indentSize(i){a.p(i)},get insertSpaces(){return a.j},set insertSpaces(i){a.s(i)},get cursorStyle(){return a.k},set cursorStyle(i){a.t(i)},get lineNumbers(){return a.l},set lineNumbers(i){a.u(i)}}}_accept(l){this.f=l.tabSize,this.g=l.indentSize,this.h=l.originalIndentSize,this.j=l.insertSpaces,this.k=l.cursorStyle,this.l=F.TextEditorLineNumbersStyle.to(l.lineNumbers)}m(l){if(l==="auto")return"auto";if(typeof l=="number"){const E=Math.floor(l);return E>0?E:null}if(typeof l=="string"){const E=parseInt(l,10);return isNaN(E)?null:E>0?E:null}return null}n(l){const E=this.m(l);if(E!==null){if(typeof E=="number"){if(this.f===E)return;this.f=E}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:E}))}}o(l){if(l==="tabSize")return"tabSize";if(typeof l=="number"){const E=Math.floor(l);return E>0?E:null}if(typeof l=="string"){const E=parseInt(l,10);return isNaN(E)?null:E>0?E:null}return null}p(l){const E=this.o(l);if(E!==null){if(typeof E=="number"){if(this.h===E)return;this.g=E,this.h=E}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:E}))}}q(l){return l==="auto"?"auto":l==="false"?!1:!!l}s(l){const E=this.q(l);if(typeof E=="boolean"){if(this.j===E)return;this.j=E}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:E}))}t(l){this.k!==l&&(this.k=l,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:l})))}u(l){this.l!==l&&(this.l=l,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:F.TextEditorLineNumbersStyle.from(l)})))}assign(l){const E={};let g=!1;if(typeof l.tabSize<"u"){const s=this.m(l.tabSize);s==="auto"?(g=!0,E.tabSize=s):typeof s=="number"&&this.f!==s&&(this.f=s,g=!0,E.tabSize=s)}if(typeof l.indentSize<"u"){const s=this.o(l.indentSize);s==="tabSize"?(g=!0,E.indentSize=s):typeof s=="number"&&this.h!==s&&(this.g=s,this.h=s,g=!0,E.indentSize=s)}if(typeof l.insertSpaces<"u"){const s=this.q(l.insertSpaces);s==="auto"?(g=!0,E.insertSpaces=s):this.j!==s&&(this.j=s,g=!0,E.insertSpaces=s)}typeof l.cursorStyle<"u"&&this.k!==l.cursorStyle&&(this.k=l.cursorStyle,g=!0,E.cursorStyle=l.cursorStyle),typeof l.lineNumbers<"u"&&this.l!==l.lineNumbers&&(this.l=l.lineNumbers,g=!0,E.lineNumbers=F.TextEditorLineNumbersStyle.from(l.lineNumbers)),g&&this.v("setOptions",this.c.$trySetOptions(this.d,E))}v(l,E){E.catch(g=>{this.e.warn(`ExtHostTextEditorOptions '${l}' failed:'`),this.e.warn(g)})}}e.$tO=k;class O{constructor(l,E,g,s,a,i,n,r){this.id=l,this.j=E,this.k=g,this.g=!1,this.h=new Set,this.c=a,this.d=new k(this.j,this.id,i,g),this.e=n,this.f=r;const c=this;this.value=Object.freeze({get document(){return s.value},set document(d){throw new M.$9("document")},get selection(){return c.c&&c.c[0]},set selection(d){if(!(d instanceof R.$$L))throw(0,M.$7)("selection");c.c=[d],c.l()},get selections(){return c.c},set selections(d){if(!Array.isArray(d)||d.some(t=>!(t instanceof R.$$L)))throw(0,M.$7)("selections");c.c=d,c.l()},get visibleRanges(){return c.e},set visibleRanges(d){throw new M.$9("visibleRanges")},get options(){return c.d.value},set options(d){c.g||c.d.assign(d)},get viewColumn(){return c.f},set viewColumn(d){throw new M.$9("viewColumn")},edit(d,t={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const p=new f(s.value,t);return d(p),c.m(p)},insertSnippet(d,t,p={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let u;if(!t||Array.isArray(t)&&t.length===0)u=c.c.map(o=>F.Range.from(o));else if(t instanceof R.$9L){const{lineNumber:o,column:v}=F.Position.from(t);u=[{startLineNumber:o,startColumn:v,endLineNumber:o,endColumn:v}]}else if(t instanceof R.$0L)u=[F.Range.from(t)];else{u=[];for(const o of t)if(o instanceof R.$0L)u.push(F.Range.from(o));else{const{lineNumber:v,column:b}=F.Position.from(o);u.push({startLineNumber:v,startColumn:b,endLineNumber:v,endColumn:b})}}return E.$tryInsertSnippet(l,s.value.version,d.value,u,p)},setDecorations(d,t){const p=t.length===0;p&&!c.h.has(d.key)||(p?c.h.delete(d.key):c.h.add(d.key),c.n(()=>{if(F.$iO(t))return E.$trySetDecorations(l,d.key,F.$jO(t));{const u=new Array(4*t.length);for(let o=0,v=t.length;o<v;o++){const b=t[o];u[4*o]=b.start.line+1,u[4*o+1]=b.start.character+1,u[4*o+2]=b.end.line+1,u[4*o+3]=b.end.character+1}return E.$trySetDecorationsFast(l,d.key,u)}}))},revealRange(d,t){c.n(()=>E.$tryRevealRange(l,F.Range.from(d),t||R.TextEditorRevealType.Default))},show(d){E.$tryShowEditor(l,F.ViewColumn.from(d))},hide(){E.$tryHideEditor(l)}})}dispose(){(0,S.ok)(!this.g),this.g=!0}_acceptOptions(l){(0,S.ok)(!this.g),this.d._accept(l)}_acceptVisibleRanges(l){(0,S.ok)(!this.g),this.e=l}_acceptViewColumn(l){(0,S.ok)(!this.g),this.f=l}_acceptSelections(l){(0,S.ok)(!this.g),this.c=l}async l(){const l=this.c.map(F.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,l)),this.value}m(l){const E=l.finalize();if(E.edits.length===0&&!E.setEndOfLine)return Promise.resolve(!0);const g=E.edits.map(a=>a.range);g.sort((a,i)=>a.end.line===i.end.line?a.end.character===i.end.character?a.start.line===i.start.line?a.start.character-i.start.character:a.start.line-i.start.line:a.end.character-i.end.character:a.end.line-i.end.line);for(let a=0,i=g.length-1;a<i;a++){const n=g[a].end;if(g[a+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const s=E.edits.map(a=>({range:F.Range.from(a.range),text:a.text,forceMoveMarkers:a.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,E.documentVersionId,s,{setEndOfLine:typeof E.setEndOfLine=="number"?F.EndOfLine.from(E.setEndOfLine):void 0,undoStopBefore:E.undoStopBefore,undoStopAfter:E.undoStopAfter})}n(l){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,E=>(E instanceof Error&&E.name==="DISPOSED"||this.k.warn(E),null))}}e.$uO=O}),define(Pe[67],Re([1,0,55,5,6,2,3,4,111,17,114,8,13,28,12,51,39]),function(me,e,S,M,P,F,R,m,f,k,O,D,l,E,g,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wO=e.$vO=void 0;class i{constructor(c){this.value=c,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor(c,d){this.h=c,this.i=d,this.a=null,this.b=new Map,this.c=new E.$Ac,this.d=new M.$5d,this.e=new M.$5d,this.f=new M.$5d,this.g=new M.$5d,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const d=[],t=[],p=[];if(c.removedDocuments)for(const u of c.removedDocuments){const o=F.URI.revive(u),v=this.c.get(o);v?.unref()&&(this.c.delete(o),d.push(v.value))}if(c.addedDocuments)for(const u of c.addedDocuments){const o=F.URI.revive(u.uri);let v=this.c.get(o);if(v&&o.scheme!==g.Schemas.vscodeNotebookCell&&o.scheme!==g.Schemas.vscodeInteractiveInput)throw new Error(`document '${o} already exists!'`);v||(v=new i(new f.$oO(this.h.getProxy(m.$6L.MainThreadDocuments),o,u.lines,u.EOL,u.versionId,u.languageId,u.isDirty)),this.c.set(o,v),t.push(v.value)),v.ref()}if(c.removedEditors)for(const u of c.removedEditors){const o=this.b.get(u);this.b.delete(u),o&&p.push(o)}if(c.addedEditors)for(const u of c.addedEditors){const o=F.URI.revive(u.documentUri);S.ok(this.c.has(o),`document '${o}' does not exist`),S.ok(!this.b.has(u.id),`editor '${u.id}' already exists!`);const v=this.c.get(o).value,b=new O.$uO(u.id,this.h.getProxy(m.$6L.MainThreadTextEditors),this.i,new a.$V(()=>v.document),u.selections.map(D.Selection.to),u.options,u.visibleRanges.map($=>D.Range.to($)),typeof u.editorPosition=="number"?D.ViewColumn.to(u.editorPosition):void 0);this.b.set(u.id,b)}c.newActiveEditor!==void 0&&(S.ok(c.newActiveEditor===null||this.b.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this.a=c.newActiveEditor),(0,P.$Oc)(d),(0,P.$Oc)(p),c.removedDocuments&&this.e.fire(d),c.addedDocuments&&this.d.fire(t),(c.removedEditors||c.addedEditors)&&this.f.fire(this.allEditors().map(u=>u.value)),c.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(c){return this.c.get(c)?.value}allDocuments(){return s.Iterable.map(this.c.values(),c=>c.value)}getEditor(c){return this.b.get(c)}activeEditor(c){if(!this.a)return;const d=this.b.get(this.a);return c?d:d?.value}allEditors(){return[...this.b.values()]}};e.$vO=n,e.$vO=n=Ye([He(0,k.$lO),He(1,l.$zj)],n),e.$wO=(0,R.$fi)("IExtHostDocumentsAndEditors")}),define(Pe[276],Re([1,0,18,5,4,114,8,7]),function(me,e,S,M,P,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9hc=void 0;class f{constructor(O,D){this.i=D,this.a=new M.$5d,this.b=new M.$5d,this.c=new M.$5d,this.d=new M.$5d,this.f=new M.$5d,this.g=new M.$5d,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=O.getProxy(P.$6L.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(l=>this.g.fire(l)),this.i.onDidChangeActiveTextEditor(l=>this.f.fire(l))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(O){const D=this.i.allEditors();return O?D:D.map(l=>l.value)}async showTextDocument(O,D,l){let E;typeof D=="number"?E={position:R.ViewColumn.from(D),preserveFocus:l}:typeof D=="object"?E={position:R.ViewColumn.from(D.viewColumn),preserveFocus:D.preserveFocus,selection:typeof D.selection=="object"?R.Range.from(D.selection):void 0,pinned:typeof D.preview=="boolean"?!D.preview:void 0}:E={preserveFocus:!1};const g=await this.h.$tryShowTextDocument(O.uri,E),s=g&&this.i.getEditor(g);if(s)return s.value;throw g?new Error(`Could NOT open editor for "${O.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${O.uri.toString()}".`)}createTextEditorDecorationType(O,D){return new F.$sO(this.h,O,D).value}$acceptEditorPropertiesChanged(O,D){const l=this.i.getEditor(O);if(!l)throw new Error("unknown text editor");if(D.options&&l._acceptOptions(D.options),D.selections){const E=D.selections.selections.map(R.Selection.to);l._acceptSelections(E)}if(D.visibleRanges){const E=S.$Hb(D.visibleRanges.map(R.Range.to));l._acceptVisibleRanges(E)}if(D.options&&this.b.fire({textEditor:l.value,options:{...D.options,lineNumbers:R.TextEditorLineNumbersStyle.to(D.options.lineNumbers)}}),D.selections){const E=m.TextEditorSelectionChangeKind.fromValue(D.selections.source),g=D.selections.selections.map(R.Selection.to);this.a.fire({textEditor:l.value,selections:g,kind:E})}if(D.visibleRanges){const E=S.$Hb(D.visibleRanges.map(R.Range.to));this.c.fire({textEditor:l.value,visibleRanges:E})}}$acceptEditorPositionData(O){for(const D in O){const l=this.i.getEditor(D);if(!l)throw new Error("Unknown text editor");const E=R.ViewColumn.to(O[D]);l.value.viewColumn!==E&&(l._acceptViewColumn(E),this.d.fire({textEditor:l.value,viewColumn:E}))}}getDiffInformation(O){return Promise.resolve(this.h.$getDiffInformation(O))}}e.$9hc=f}),define(Pe[277],Re([1,0,2,3,4,6,7,8,20,16]),function(me,e,S,M,P,F,R,m,f,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pjc=e.$Ojc=void 0,e.$Ojc=(0,M.$fi)("IExtHostTimeline");class O{constructor(E,g){this.b=new Map,this.c=new Map,this.a=E.getProxy(P.$6L.MainThreadTimeline),g.registerArgumentProcessor({processArgument:(s,a)=>{if(s&&s.$mid===12)if(this.b.get(s.source)&&f.$zm.equals(a,this.b.get(s.source)?.extension)){const i=s.uri===void 0?void 0:S.URI.revive(s.uri);return this.c.get(s.source)?.get(D(i))?.get(s.handle)}else return;return s}})}async $getTimeline(E,g,s,a){return this.b.get(E)?.provider.provideTimeline(S.URI.revive(g),s,a)}registerTimelineProvider(E,g,s,a){const i=new F.$Sc,n=this.d(g.id,a,i).bind(this);let r;g.onDidChange&&(r=g.onDidChange(d=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...d,id:g.id}),this));const c=this.c;return this.f({...g,scheme:E,onDidChange:void 0,async provideTimeline(d,t,p){t?.resetCache&&(i.clear(),c.get(g.id)?.clear());const u=await g.provideTimeline(d,t,p);if(u==null)return;const o=n(d,t);return{...u,source:g.id,items:u.items.map(o)}},dispose(){for(const d of c.values())d.get(g.id)?.clear();r?.dispose(),i.dispose()}},s)}d(E,g,s){return(a,i)=>{let n;if(i?.cacheResults){let r=this.c.get(E);r===void 0&&(r=new Map,this.c.set(E,r));const c=D(a);n=r.get(c),n===void 0&&(n=new Map,r.set(c,n))}return r=>{const{iconPath:c,...d}=r,t=`${E}|${r.id??r.timestamp}`;n?.set(t,r);let p,u,o;r.iconPath&&(c instanceof R.$3M?o={id:c.id,color:c.color}:S.URI.isUri(c)?(p=c,u=c):{light:p,dark:u}=c);let v;return R.$wM.isMarkdownString(d.tooltip)?v=m.MarkdownString.from(d.tooltip):(0,k.$Sf)(d.tooltip)?v=d.tooltip:R.$wM.isMarkdownString(d.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),v=m.MarkdownString.from(d.detail)):(0,k.$Sf)(d.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),v=d.detail),{...d,id:d.id??void 0,handle:t,source:E,command:r.command?g.toInternal(r.command,s):void 0,icon:p,iconDark:u,themeIcon:o,tooltip:v,accessibilityInformation:r.accessibilityInformation}}}}f(E,g){if(this.b.get(E.id))throw new Error(`Timeline Provider ${E.id} already exists.`);return this.a.$registerTimelineProvider({id:E.id,label:E.label,scheme:E.scheme}),this.b.set(E.id,{provider:E,extension:g}),(0,F.$Rc)(()=>{for(const a of this.c.values())a.get(E.id)?.clear();this.b.delete(E.id),this.a.$unregisterTimelineProvider(E.id),E.dispose()})}}e.$Pjc=O;function D(l){return l?.toString()}}),define(Pe[278],Re([1,0,170,24,2,5,6,208,11,7,16,18,8,53,25,135,22]),function(me,e,S,M,P,F,R,m,f,k,O,D,l,E,g,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qjc=void 0;function i(c,d){if((0,O.$Sf)(c))return{label:c};if(c&&typeof c=="object"&&typeof c.label=="string"){let t;return Array.isArray(c.highlights)&&(t=c.highlights.filter(p=>p.length===2&&typeof p[0]=="number"&&typeof p[1]=="number"),t=t.length?t:void 0),{label:c.label,highlights:t}}}class n extends R.$Tc{constructor(d,t,p){super(),this.f=d,this.g=t,this.h=p,this.a=new Map,this.b=new s.$J9;function u(o){return o&&o.$treeViewId&&(o.$treeItemHandle||o.$selectedTreeItems||o.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:o=>u(o)?this.r(o):Array.isArray(o)&&o.length>0?o.map(v=>u(v)?this.r(v):v):o})}registerTreeDataProvider(d,t,p){const u=this.createTreeView(d,{treeDataProvider:t},p);return{dispose:()=>u.dispose()}}createTreeView(d,t,p){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const u=t.dragAndDropController?.dropMimeTypes??[],o=t.dragAndDropController?.dragMimeTypes??[],v=!!t.dragAndDropController?.handleDrag,b=!!t.dragAndDropController?.handleDrop,$=this.m(d,t,p),I={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:u,dragMimeTypes:o,hasHandleDrag:v,hasHandleDrop:b,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},h=this.f.$registerTreeViewDataProvider(d,I),y={get onDidCollapseElement(){return $.onDidCollapseElement},get onDidExpandElement(){return $.onDidExpandElement},get selection(){return $.selectedElements},get onDidChangeSelection(){return $.onDidChangeSelection},get activeItem(){return(0,a.$YF)(p,"treeViewActiveItem"),$.focusedElement},get onDidChangeActiveItem(){return(0,a.$YF)(p,"treeViewActiveItem"),$.onDidChangeActiveItem},get visible(){return $.visible},get onDidChangeVisibility(){return $.onDidChangeVisibility},get onDidChangeCheckboxState(){return $.onDidChangeCheckboxState},get message(){return $.message},set message(w){(0,E.$yk)(w)&&(0,a.$YF)(p,"treeViewMarkdownMessage"),$.message=w},get title(){return $.title},set title(w){$.title=w},get description(){return $.description},set description(w){$.description=w},get badge(){return $.badge},set badge(w){w!==void 0&&k.ViewBadge.isViewBadge(w)?$.badge={value:Math.floor(Math.abs(w.value)),tooltip:w.tooltip}:w===void 0&&($.badge=void 0)},reveal:(w,A)=>$.reveal(w,A),dispose:async()=>{await h,this.a.delete(d),$.dispose()}};return this.B(y),y}$getChildren(d,t){const p=this.a.get(d);return p?p.getChildren(t):Promise.reject(new m.$rF(d))}async $handleDrop(d,t,p,u,o,v,b,$){const I=this.a.get(d);if(!I)return Promise.reject(new m.$rF(d));const h=l.DataTransfer.toDataTransfer(p,async y=>(await this.f.$resolveDropFileData(d,t,y)).buffer);return b===d&&$&&await this.j(h,I,$,o,v),I.onDrop(h,u,o)}async j(d,t,p,u,o){const v=this.b.removeDragOperationTransfer(o);if(v)(await v)?.forEach((b,$)=>{b&&d.set($,b)});else if(o&&t.handleDrag){const b=t.handleDrag(p,d,u);this.b.addDragOperationTransfer(o,b),await b}return d}async $handleDrag(d,t,p,u){const o=this.a.get(d);if(!o)return Promise.reject(new m.$rF(d));const v=await this.j(new k.$ZM,o,t,u,p);if(!(!v||u.isCancellationRequested))return l.DataTransfer.from(v)}async $hasResolve(d){const t=this.a.get(d);if(!t)throw new m.$rF(d);return t.hasResolve}$resolve(d,t,p){const u=this.a.get(d);if(!u)throw new m.$rF(d);return u.resolveTreeItem(t,p)}$setExpanded(d,t,p){const u=this.a.get(d);if(!u)throw new m.$rF(d);u.setExpanded(t,p)}$setSelectionAndFocus(d,t,p){const u=this.a.get(d);if(!u)throw new m.$rF(d);u.setSelectionAndFocus(t,p)}$setVisible(d,t){const p=this.a.get(d);if(!p){if(!t)return;throw new m.$rF(d)}p.setVisible(t)}$changeCheckboxState(d,t){const p=this.a.get(d);if(!p)throw new m.$rF(d);p.setCheckboxState(t)}m(d,t,p){const u=this.B(new r(d,t,this.f,this.g.converter,this.h,p));return this.a.set(d,u),u}r(d){const t=this.a.get(d.$treeViewId);return t&&"$treeItemHandle"in d?t.getExtensionElement(d.$treeItemHandle):t&&"$focusedTreeItem"in d&&d.$focusedTreeItem?t.focusedElement:null}}e.$Qjc=n;class r extends R.$Tc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(d=>this.getExtensionElement(d)).filter(d=>!(0,O.$2f)(d))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(d,t,p,u,o,v){if(super(),this.I=d,this.J=p,this.L=u,this.M=o,this.N=v,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new F.$5d),this.onDidExpandElement=this.u.event,this.w=this.B(new F.$5d),this.onDidCollapseElement=this.w.event,this.y=this.B(new F.$5d),this.onDidChangeSelection=this.y.event,this.z=this.B(new F.$5d),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new F.$5d),this.onDidChangeVisibility=this.C.event,this.D=this.B(new F.$5d),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new F.$5d),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new g.$ce,v.contributes&&v.contributes.views)for(const h in v.contributes.views)for(const y of v.contributes.views[h])y.id===d&&(this.P=y.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(h=>this.F.fire({message:!1,element:h})));let b,$;const I=F.Event.debounce(this.F.event,(h,y)=>(h||(h={message:!1,elements:[]}),y.element!==!1&&(b||(b=new Promise(w=>$=w),this.G=this.G.then(()=>b)),Array.isArray(y.element)?h.elements.push(...y.element):h.elements.push(y.element)),y.message&&(h.message=!0),h),200,!0);this.B(I(({message:h,elements:y})=>{y.length&&(this.H=this.H.then(()=>{const w=$;return b=null,this.$(y).then(()=>w())})),h&&this.J.$setMessage(this.I,l.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(d){const t=d?this.getExtensionElement(d):void 0;if(d&&!t)return this.M.error(`No tree item with id '${d}' found.`),Promise.resolve([]);let p=this.X(d);return p||(p=await this.Y(t)),p?p.map(u=>u.item):void 0}getExtensionElement(d){return this.j.get(d)}reveal(d,t){t=t||{select:!0,focus:!1};const p=(0,O.$2f)(t.select)?!0:t.select,u=(0,O.$2f)(t.focus)?!1:t.focus,o=(0,O.$2f)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):d?this.G.then(()=>this.S(d)).then(v=>this.W(d,v[v.length-1]).then(b=>this.J.$reveal(this.I,{item:b.item,parentChain:v.map($=>$.item)},{select:p,focus:u,expand:o})),v=>this.M.error(v)):this.J.$reveal(this.I,void 0,{select:p,focus:u,expand:o})}get message(){return this.O}set message(d){this.O=d,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(d){this.P=d,this.J.$setTitle(this.I,d,this.Q)}get description(){return this.Q}set description(d){this.Q=d,this.J.$setTitle(this.I,this.P,d)}get badge(){return this.R}set badge(d){this.R?.value===d?.value&&this.R?.tooltip===d?.tooltip||(this.R=l.ViewBadge.from(d),this.J.$setBadge(this.I,d))}setExpanded(d,t){const p=this.getExtensionElement(d);p&&(t?this.u.fire(Object.freeze({element:p})):this.w.fire(Object.freeze({element:p})))}setSelectionAndFocus(d,t){const p=!(0,D.$ub)(this.s,d);this.s=d;const u=this.t!==t;this.t=t,p&&this.y.fire(Object.freeze({selection:this.selectedElements})),u&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(d){d!==this.r&&(this.r=d,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(d){const t=(await Promise.all(d.map(async p=>{const u=this.getExtensionElement(p.treeItemHandle);return u?{extensionItem:u,treeItem:await this.f.getTreeItem(u),newState:p.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(p=>p!==void 0);t.forEach(p=>{p.treeItem.checkboxState=p.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(p=>[p.extensionItem,p.newState])})}async handleDrag(d,t,p){const u=[];for(const o of d){const v=this.getExtensionElement(o);v&&u.push(v)}if(!(!this.g?.handleDrag||u.length===0))return await this.g.handleDrag(u,t,p),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(d,t,p){const u=t?this.getExtensionElement(t):void 0;if(!(!u&&t||!this.g?.handleDrop))return(0,f.$0g)(()=>this.g?.handleDrop?this.g.handleDrop(u,d,p):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(d,t){if(!this.f.resolveTreeItem)return;const p=this.j.get(d);if(p){const u=this.m.get(p);if(u){const o=await this.f.resolveTreeItem(u.extensionItem,p,t)??u.extensionItem;return this.hb(o),u.item.tooltip=this.eb(o.tooltip),u.item.command=this.fb(u.disposableStore,o.command),u.item}}}S(d){return this.U(d).then(t=>t?this.S(t).then(p=>this.W(t,p[p.length-1]).then(u=>(p.push(u),p))):Promise.resolve([]))}U(d){const t=this.m.get(d);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,f.$0g)(()=>this.f.getParent(d))}W(d,t){const p=this.m.get(d);return p?Promise.resolve(p):(0,f.$0g)(()=>this.f.getTreeItem(d)).then(u=>this.kb(d,u,t,!0)).then(u=>this.getChildren(t?t.item.handle:void 0).then(()=>{const o=this.getExtensionElement(u);if(o){const v=this.m.get(o);if(v)return Promise.resolve(v)}throw new Error(`Cannot resolve tree item for element ${u} from extension ${this.N.identifier.value}`)}))}X(d){if(d){let t;if(typeof d=="string"){const p=this.getExtensionElement(d);t=p?this.m.get(p):void 0}else t=d;return t&&t.children||void 0}return this.h}async Y(d){this.rb(d);const t=new g.$ce(this.Z.token);try{const p=d?this.m.get(d):void 0,u=await this.f.getChildren(d);if(t.token.isCancellationRequested)return;const o=(0,D.$Hb)(u||[]),v=await Promise.all((0,D.$Hb)(o).map($=>this.f.getTreeItem($)));if(t.token.isCancellationRequested)return;const b=v.map(($,I)=>$?this.db(o[I],$,p):null);return(0,D.$Hb)(b)}finally{t.dispose()}}$(d){if(d.some(p=>!p))return this.Z.dispose(!0),this.Z=new g.$ce,this.tb(),this.J.$refresh(this.I);{const p=this.ab(d);if(p.length)return this.bb(p)}return Promise.resolve(void 0)}ab(d){const t=new Set,p=d.map(o=>this.m.get(o));for(const o of p)if(o&&!t.has(o.item.handle)){let v=o;for(;v&&v.parent&&p.findIndex(b=>v&&v.parent&&b&&b.item.handle===v.parent.item.handle)===-1;){const b=this.j.get(v.parent.item.handle);v=b?this.m.get(b):void 0}v&&!v.parent&&t.add(o.item.handle)}const u=[];return t.forEach(o=>{const v=this.j.get(o);if(v){const b=this.m.get(v);b&&(!b.parent||!t.has(b.parent.item.handle))&&u.push(o)}}),u}bb(d){const t={};return Promise.all(d.map(p=>this.cb(p).then(u=>{u&&(t[p]=u.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(d){const t=this.getExtensionElement(d);if(t){const p=this.m.get(t);if(p)return this.rb(t),(0,f.$0g)(()=>this.f.getTreeItem(t)).then(u=>{if(u){const o=this.ib(t,u,p.parent);return this.pb(t,o,p,p.parent),p.dispose(),o}return null})}return Promise.resolve(null)}db(d,t,p){const u=this.ib(d,t,p);if(t.id&&this.j.has(u.item.handle))throw new Error((0,S.localize)(0,null,t.id));return this.ob(d,u),this.qb(u,p),u}eb(d){return k.$wM.isMarkdownString(d)?l.MarkdownString.from(d):d}fb(d,t){return t?{...this.L.toInternal(t,d),originalId:t.command}:void 0}gb(d){if(d.checkboxState===void 0)return;let t,p,u;return typeof d.checkboxState=="number"?t=d.checkboxState:(t=d.checkboxState.state,p=d.checkboxState.tooltip,u=d.checkboxState.accessibilityInformation),{isChecked:t===k.TreeItemCheckboxState.Checked,tooltip:p,accessibilityInformation:u}}hb(d){if(!k.$UM.isTreeItem(d,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(d,t,p){this.hb(t);const u=this.B(new R.$Sc),o=this.kb(d,t,p),v=this.lb(t);return{item:{handle:o,parentHandle:p?p.item.handle:void 0,label:i(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(u,t.command),contextValue:t.contextValue,icon:v,iconDark:this.mb(t)||v,themeIcon:this.jb(t),collapsibleState:(0,O.$2f)(t.collapsibleState)?k.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:p,children:void 0,disposableStore:u,dispose(){u.dispose()}}}jb(d){return d.iconPath instanceof k.$3M?d.iconPath:void 0}kb(d,{id:t,label:p,resourceUri:u},o,v){if(t)return`${r.b}/${t}`;const b=i(p,this.N),$=o?o.item.handle:r.a;let I=b?b.label:u?(0,M.$Pg)(u):"";I=I.indexOf("/")!==-1?I.replace("/","//"):I;const h=this.m.has(d)?this.m.get(d).item.handle:void 0,y=this.X(o)||[];let w,A=0;do{if(w=`${$}/${A}:${I}`,v||!this.j.has(w)||h===w)break;A++}while(A<=y.length);return w}lb(d){if(d.iconPath&&!(d.iconPath instanceof k.$3M))return typeof d.iconPath=="string"||P.URI.isUri(d.iconPath)?this.nb(d.iconPath):this.nb(d.iconPath.light)}mb(d){if(d.iconPath&&!(d.iconPath instanceof k.$3M)&&d.iconPath.dark)return this.nb(d.iconPath.dark)}nb(d){return P.URI.isUri(d)?d:P.URI.file(d)}ob(d,t){this.j.set(t.item.handle,d),this.m.set(d,t)}pb(d,t,p,u){this.j.delete(t.item.handle),this.m.delete(d),t.item.handle!==p.item.handle&&this.j.delete(p.item.handle),this.ob(d,t);const o=this.X(u)||[],v=o.filter(b=>b.item.handle===p.item.handle)[0];v&&o.splice(o.indexOf(v),1,t)}qb(d,t){t?(t.children||(t.children=[]),t.children.push(d)):(this.h||(this.h=[]),this.h.push(d))}rb(d){if(d){const t=this.m.get(d);if(t){if(t.children)for(const p of t.children){const u=this.j.get(p.item.handle);u&&this.sb(u)}t.children=void 0}}else this.tb()}sb(d){const t=this.m.get(d);if(t){if(t.children)for(const p of t.children){const u=this.j.get(p.item.handle);u&&this.sb(u)}this.m.delete(d),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(d=>d.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Pe[279],Re([1,0,5,6,2,33,8,62,4,7]),function(me,e,S,M,P,F,R,m,f,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pic=void 0;class O extends M.$Tc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(g,s,a,i){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new S.$5d),this.onDidDispose=this.#d.event,this.#h=this.B(new S.$5d),this.onDidChangeViewState=this.#h.event,this.#e=g,this.#t=s,this.#n=a,this.#i=i.viewType,this.#s=i.panelOptions,this.#o=i.viewColumn,this.#r=i.title,this.#u=i.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(g){this.c(),this.#r!==g&&(this.#r=g,this.#t.$setTitle(this.#e,g))}get iconPath(){return this.c(),this.#a}set iconPath(g){this.c(),this.#a!==g&&(this.#a=g,this.#t.$setIconPath(this.#e,P.URI.isUri(g)?{light:g,dark:g}:g))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(g){this.#l||(this.active!==g.active||this.visible!==g.visible||this.viewColumn!==g.viewColumn)&&(this.#u=g.active,this.#c=g.visible,this.#o=g.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(g,s){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof g>"u"?void 0:R.ViewColumn.from(g),preserveFocus:!!s})}c(){if(this.#l)throw new Error("Webview is disposed")}}class D extends M.$Tc{static c(){return(0,F.$Bg)()}constructor(g,s,a){super(),this.j=s,this.m=a,this.g=new Map,this.h=new Map,this.f=g.getProxy(f.$6L.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(g=>g.dispose()),this.g.clear()}createWebviewPanel(g,s,a,i,n={}){const r=typeof i=="object"?i.viewColumn:i,c={viewColumn:R.ViewColumn.from(r),preserveFocus:typeof i=="object"&&!!i.preserveFocus},d=(0,m.$lic)(g),t=D.c();this.f.$createWebviewPanel((0,m.$nic)(g),t,s,{title:a,panelOptions:l(n),webviewOptions:(0,m.$oic)(g,this.m,n),serializeBuffersForPostMessage:d},c);const p=this.j.createNewWebview(t,n,g);return this.createNewWebviewPanel(t,s,a,r,n,p,!0)}$onDidChangeWebviewPanelViewStates(g){const s=Object.keys(g);s.sort((a,i)=>{const n=g[a],r=g[i];return n.active?1:r.active?-1:+n.visible-+r.visible});for(const a of s){const i=this.getWebviewPanel(a);if(!i)continue;const n=g[a];i._updateViewState({active:n.active,visible:n.visible,viewColumn:R.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(g){this.getWebviewPanel(g)?.dispose(),this.g.delete(g),this.j.deleteWebview(g)}registerWebviewPanelSerializer(g,s,a){if(this.h.has(s))throw new Error(`Serializer for '${s}' already registered`);return this.h.set(s,{serializer:a,extension:g}),this.f.$registerSerializer(s,{serializeBuffersForPostMessage:(0,m.$lic)(g)}),new k.$8L(()=>{this.h.delete(s),this.f.$unregisterSerializer(s)})}async $deserializeWebviewPanel(g,s,a,i){const n=this.h.get(s);if(!n)throw new Error(`No serializer found for '${s}'`);const{serializer:r,extension:c}=n,d=this.j.createNewWebview(g,a.webviewOptions,c),t=this.createNewWebviewPanel(g,s,a.title,i,a.panelOptions,d,a.active);await r.deserializeWebviewPanel(t,a.state)}createNewWebviewPanel(g,s,a,i,n,r,c){const d=new O(g,this.f,r,{viewType:s,title:a,viewColumn:i,panelOptions:n,active:c});return this.g.set(g,d),d}getWebviewPanel(g){return this.g.get(g)}}e.$pic=D;function l(E){return{enableFindWidget:E.enableFindWidget,retainContextWhenHidden:E.retainContextWhenHidden}}}),define(Pe[280],Re([1,0,5,6,62,8,4,7]),function(me,e,S,M,P,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tjc=void 0;class f extends M.$Tc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(D,l,E,g,s,a){super(),this.#s=!1,this.#u=this.B(new S.$5d),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new S.$5d),this.onDidDispose=this.#l.event,this.#i=E,this.#a=g,this.#e=D,this.#t=l,this.#n=s,this.#r=a}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(D){this.a(),this.#a!==D&&(this.#a=D,this.#t.$setWebviewViewTitle(this.#e,D))}get description(){return this.a(),this.#o}set description(D){this.a(),this.#o!==D&&(this.#o=D,this.#t.$setWebviewViewDescription(this.#e,D))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(D){D===this.#r||this.#s||(this.#r=D,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(D){this.a(),!(D?.value===this.#c?.value&&D?.tooltip===this.#c?.tooltip)&&(this.#c=F.ViewBadge.from(D),this.#t.$setWebviewViewBadge(this.#e,D))}show(D){this.a(),this.#t.$show(this.#e,!!D)}a(){if(this.#s)throw new Error("Webview is disposed")}}class k{constructor(D,l){this.d=l,this.b=new Map,this.c=new Map,this.a=D.getProxy(R.$6L.MainThreadWebviewViews)}registerWebviewViewProvider(D,l,E,g){if(this.b.has(l))throw new Error(`View provider for '${l}' already registered`);return this.b.set(l,{provider:E,extension:D}),this.a.$registerWebviewViewProvider((0,P.$nic)(D),l,{retainContextWhenHidden:g?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,P.$lic)(D)}),new m.$8L(()=>{this.b.delete(l),this.a.$unregisterWebviewViewProvider(l)})}async $resolveWebviewView(D,l,E,g,s){const a=this.b.get(l);if(!a)throw new Error(`No view provider found for '${l}'`);const{provider:i,extension:n}=a,r=this.d.createNewWebview(D,{},n),c=new f(D,this.a,l,E,r,!0);this.c.set(D,c),await i.resolveWebviewView(c,{state:g},s)}async $onDidChangeWebviewViewVisibility(D,l){this.e(D)._setVisible(l)}async $disposeWebviewView(D){const l=this.e(D);this.c.delete(D),l.dispose(),this.d.deleteWebview(D)}e(D){const l=this.c.get(D);if(!l)throw new Error("No webview found");return l}}e.$Tjc=k}),define(Pe[281],Re([1,0,5,30,35,3]),function(me,e,S,M,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pL=e.$oL=e.OutputChannelUpdateMode=e.$nL=e.$mL=e.$lL=e.$kL=e.$jL=e.$iL=e.$hL=e.$gL=e.$fL=e.$eL=void 0,e.$eL="text/x-code-output",e.$fL="output",e.$gL="Log",e.$hL="text/x-code-log-output",e.$iL="log",e.$jL="workbench.panel.output",e.$kL=new P.$wj("inOutput",!1),e.$lL=new P.$wj("activeLogOutput",!1),e.$mL=new P.$wj("outputView.scrollLock",!1),e.$nL=(0,F.$fi)("outputService");var R;(function(f){f[f.Append=1]="Append",f[f.Replace=2]="Replace",f[f.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$oL={OutputChannels:"workbench.contributions.outputChannels"};class m{constructor(){this.a=new Map,this.b=new S.$5d,this.onDidRegisterChannel=this.b.event,this.c=new S.$5d,this.onDidRemoveChannel=this.c.event}registerChannel(k){this.a.has(k.id)||(this.a.set(k.id,k),this.b.fire(k.id))}getChannels(){const k=[];return this.a.forEach(O=>k.push(O)),k}getChannel(k){return this.a.get(k)}removeChannel(k){this.a.delete(k),this.c.fire(k)}}M.$Wn.add(e.$oL.OutputChannels,new m),e.$pL=new P.$wj("activeOutputChannel","")}),define(Pe[115],Re([1,0,4,3,17,20,13,281,63,27,43,139,23,16,42,5,6]),function(me,e,S,M,P,F,R,m,f,k,O,D,l,E,g,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vjc=e.$ujc=void 0;class i extends R.$Fj{get disposed(){return this.n}constructor(d,t,p,u,o){super(),this.id=d,this.name=t,this.r=p,this.s=u,this.extension=o,this.m=0,this.n=!1,this.visible=!1,this.setLevel(p.getLevel()),this.B(p.onDidChangeLogLevel(v=>this.setLevel(v)))}get logLevel(){return this.getLevel()}appendLine(d){this.append(d+`
`)}append(d){this.info(d)}clear(){const d=this.m;this.r.flush(),this.s.$update(this.id,m.OutputChannelUpdateMode.Clear,d)}replace(d){const t=this.m;this.info(d),this.s.$update(this.id,m.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(d,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof d=="boolean"?d:t))}hide(){this.s.$close(this.id)}g(d,t){this.m+=l.$se.fromString(t).byteLength,(0,R.log)(this.r,d,t),this.visible&&(this.r.flush(),this.s.$update(this.id,m.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends i{appendLine(d){this.append(d)}}let r=class{constructor(d,t,p,u,o,v){this.i=t,this.j=p,this.k=u,this.l=o,this.m=v,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=d.getProxy(S.$6L.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,D.$Lm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(d){this.h=d;for(const[t,p]of this.g)p.visible=t===this.h}createOutputChannel(d,t,p){if(d=d.trim(),!d)throw new Error("illegal argument `name`. must not be falsy");const u=typeof t=="object"&&t.log,o=(0,E.$Sf)(t)?t:void 0;if((0,E.$Sf)(o)&&!o.trim())throw new Error("illegal argument `languageId`. must not be empty");let v;const b=this.i.environment.extensionLogLevel?.find(([I])=>F.$zm.equals(p.identifier,I))?.[1];b&&(v=(0,R.$Pj)(b));const $=u?this.o(d,v,p):this.n(d,o,p);return $.then(I=>{this.g.set(I.id,I),I.visible=I.id===this.h}),u?this.r(d,v??this.m.getLevel(),$):this.q(d,$)}async n(d,t,p){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const u=await this.c,o=this.k.extUri.joinPath(u,`${this.f++}-${d.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),v=this.l.createLogger(o,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),b=await this.a.$register(d,o,t,p.identifier.value);return new i(b,d,v,this.a,p)}async o(d,t,p){const u=await this.p(p),o=d.replace(/[\\/:\*\?"<>\|]/g,""),v=this.k.extUri.joinPath(u,`${o}.log`),b=`${p.identifier.value}.${o}`,$=this.l.createLogger(v,{id:b,name:d,logLevel:t,extensionId:p.identifier.value});return new n(b,d,$,this.a,p)}p(d){let t=this.d.get(d.identifier.value);if(!t){const p=this.k.extUri.joinPath(this.i.logsLocation,d.identifier.value);this.d.set(d.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(p)}catch(u){if((0,g.$Vk)(u)!==g.FileSystemProviderErrorCode.FileExists)throw u}return p})())}return t}q(d,t){let p=!1;const u=()=>{if(p)throw new Error("Channel has been closed")};return{get name(){return d},append(o){u(),t.then(v=>v.append(o))},appendLine(o){u(),t.then(v=>v.appendLine(o))},clear(){u(),t.then(o=>o.clear())},replace(o){u(),t.then(v=>v.replace(o))},show(o,v){u(),t.then(b=>b.show(o,v))},hide(){u(),t.then(o=>o.hide())},dispose(){p=!0,t.then(o=>o.dispose())}}}r(d,t,p){const u=new a.$Sc,o=()=>{if(u.isDisposed)throw new Error("Channel has been closed")},v=u.add(new s.$5d);function b($){t=$,v.fire($)}return p.then($=>{u.add($),$.logLevel!==t&&b($.logLevel),u.add($.onDidChangeLogLevel(I=>b(I)))}),{...this.q(d,p),get logLevel(){return t},onDidChangeLogLevel:v.event,trace($,...I){o(),p.then(h=>h.trace($,...I))},debug($,...I){o(),p.then(h=>h.debug($,...I))},info($,...I){o(),p.then(h=>h.info($,...I))},warn($,...I){o(),p.then(h=>h.warn($,...I))},error($,...I){o(),p.then(h=>h.error($,...I))},dispose(){u.dispose()}}}};e.$ujc=r,e.$ujc=r=Ye([He(0,P.$lO),He(1,k.$BO),He(2,f.$hic),He(3,O.$Thc),He(4,R.$Aj),He(5,R.$zj)],r),e.$vjc=(0,M.$fi)("IExtHostOutputService")}),define(Pe[116],Re([1,0,3,11]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2m=e.$1m=void 0,e.$1m=(0,S.$fi)("remoteAgentService"),e.$2m=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(P){let F=1/0;for(let m=0;m<this.maxSampleCount;m++){const f=await P.getRoundTripTime();if(f===void 0)return;F=Math.min(F,f/2),await(0,M.$gh)(this.sampleDelay)}this.average.push(F),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(F):R=this.initial.reduce((m,f)=>m+f,0)/this.initial.length,this.lastMeasurement={initial:R,current:F,average:this.average.reduce((m,f)=>m+f,0)/this.average.length,high:typeof R>"u"?!1:F>this.highLatencyMaxThreshold||F>this.highLatencyMinThreshold&&F>R*this.highLatencyMultiple},this.lastMeasurement}}}),define(Pe[282],Re([1,0,173,56,30,47,46,6,5,116,21,26,11]),function(me,e,S,M,P,F,R,m,f,k,O,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=void 0,e.$JI=Object.freeze({id:"application",order:100,title:(0,S.localize)(0,null),type:"object"}),e.$KI=Object.freeze({id:"workbench",order:7,title:(0,S.localize)(1,null),type:"object"}),e.$LI=Object.freeze({id:"security",scope:1,title:(0,S.localize)(2,null),type:"object",order:7}),e.$MI=Object.freeze({id:"problems",title:(0,S.localize)(3,null),type:"object",order:101}),e.$NI={ConfigurationMigration:"base.contributions.configuration.migration"};class E{constructor(){this.migrations=[],this.a=new f.$5d,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(n){this.migrations.push(...n)}}const g=new E;P.$Wn.add(e.$NI.ConfigurationMigration,g);let s=class extends m.$Tc{static{this.ID="workbench.contrib.configurationMigration"}constructor(n,r){super(),this.a=n,this.b=r,this.B(this.b.onDidChangeWorkspaceFolders(async c=>{for(const d of c.added)await this.f(d,g.migrations)})),this.c(g.migrations),this.B(g.onDidRegisterConfigurationMigration(c=>this.c(c)))}async c(n){await this.f(void 0,n);for(const r of this.b.getWorkspace().folders)await this.f(r,n)}async f(n,r){await Promise.all([r.map(c=>this.g(c,n?.uri))])}async g(n,r){const c=this.a.inspect(n.key,{resource:r}),d=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,p]of d){const u=c[t];if(!u)continue;const o=[];if(u.value!==void 0){const v=await this.h(n,t,u.value,r,void 0);for(const b of v??[])o.push([b,[]])}for(const{identifiers:v,value:b}of u.overrides??[])if(b!==void 0){const $=await this.h(n,t,b,r,v);for(const I of $??[])o.push([I,v])}o.length&&await Promise.allSettled(o.map(async([[v,b],$])=>this.a.updateValue(v,b.value,{resource:r,overrideIdentifiers:$},p)))}}async h(n,r,c,d,t){const p=o=>{const b=this.a.inspect(o,{resource:d})[r];if(b)return t?b.overrides?.find(({identifiers:$})=>(0,D.$On)($,t))?.value:b.value},u=await n.migrateFn(c,p);return Array.isArray(u)?u:[[n.key,u]]}};e.$OI=s,e.$OI=s=Ye([He(0,R.$Li),He(1,F.$oi)],s);let a=class extends m.$Tc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(n){super(),this.b=n,this.a=new l.$Ch,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!O.$i&&(await this.b.getEnvironment())?.os!==1)return;P.$Wn.as(M.$2n.Configuration).registerConfiguration({...e.$LI,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,S.localize)(4,null)},default:[],markdownDescription:(0,S.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,S.localize)(6,null),scope:2}}})}};e.$PI=a,e.$PI=a=Ye([He(0,k.$1m)],a)}),define(Pe[283],Re([1,0,34,12,19,24,181,282,56,3,30]),function(me,e,S,M,P,F,R,m,f,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9eb=e.$8eb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$7eb=e.$6eb=void 0,e.$6eb=(0,k.$fi)("editorResolverService"),e.$7eb="workbench.editorAssociations";const D=O.$Wn.as(f.$2n.Configuration),l={...m.$KI,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(0,null),additionalProperties:{type:"string"}}}};D.registerConfiguration(l);var E;(function(i){i.builtin="builtin",i.option="option",i.exclusive="exclusive",i.default="default"})(E||(e.RegisteredEditorPriority=E={}));var g;(function(i){i[i.ABORT=1]="ABORT",i[i.NONE=2]="NONE"})(g||(e.ResolvedStatus=g={}));function s(i){switch(i){case E.exclusive:return 5;case E.default:return 4;case E.builtin:return 3;case E.option:default:return 1}}e.$8eb=s;function a(i,n){if(new Set([M.Schemas.extension,M.Schemas.webviewPanel,M.Schemas.vscodeWorkspaceTrust,M.Schemas.vscodeSettings]).has(n.scheme))return!1;const d=typeof i=="string"&&i.indexOf(P.$gc.sep)>=0?`${n.scheme}:${n.path}`:(0,F.$Pg)(n);return S.$Xj(typeof i=="string"?i.toLowerCase():i,d.toLowerCase())}e.$9eb=a}),define(Pe[284],Re([1,0,45,12,19,21,24,2,3,202,47,220,116]),function(me,e,S,M,P,F,R,m,f,k,O,D,l){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$IL=e.$HL=void 0,e.$HL=(0,f.$fi)("pathService");let g=E=class{constructor(a,i,n,r){this.d=a,this.e=i,this.f=n,this.g=r,this.a=(async()=>(await this.e.getEnvironment())?.os||F.OS)(),this.b=(async()=>{const c=await this.e.getEnvironment();return this.c=c?.userHome??a})()}hasValidBasename(a,i,n){return typeof i=="string"||typeof i>"u"?this.a.then(r=>this.h(a,r,i)):this.h(a,i,n)}h(a,i,n){return a.scheme===M.Schemas.file||a.scheme===M.Schemas.vscodeRemote?(0,S.$dg)(n??(0,R.$Pg)(a),i===1):!0}get defaultUriScheme(){return E.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(a,i){if(a.remoteAuthority)return M.Schemas.vscodeRemote;const n=(0,k.$EL)(i.getWorkspace());if(n)return n;const r=i.getWorkspace().folders[0];if(r)return r.uri.scheme;const c=i.getWorkspace().configuration;return c?c.scheme:M.Schemas.file}userHome(a){return a?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(a=>a===1?P.$fc:P.$gc)}async fileURI(a){let i="";if(await this.a===1&&(a=a.replace(/\\/g,"/")),a[0]==="/"&&a[1]==="/"){const r=a.indexOf("/",2);r===-1?(i=a.substring(2),a="/"):(i=a.substring(2,r),a=a.substring(r)||"/")}return m.URI.from({scheme:M.Schemas.file,authority:i,path:a,query:"",fragment:""})}};e.$IL=g,e.$IL=g=E=Ye([He(1,l.$1m),He(2,D.$qL),He(3,O.$oi)],g)}),define(Pe[117],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$gK=e.$fK=void 0;class S{constructor(R,m){this.line=R,this.character=m}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,m){return new S(0,0)}with(R){return new S(0,0)}}e.$fK=S;class M{constructor(R,m,f,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new S(R,m),this.end=new S(f,k)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new M(0,0,0,0)}with(R){return new M(0,0,0,0)}}e.$gK=M;var P;(function(F){F[F.Information=1]="Information",F[F.Warning=2]="Warning"})(P||(e.TextSearchCompleteMessageType=P={}))}),define(Pe[44],Re([1,0,18,34,26,45,15,3,19,14,117,11]),function(me,e,S,M,P,F,R,m,f,k,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HK=e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.$AK=e.$zK=e.$yK=e.$xK=e.$wK=e.SearchErrorCode=e.$vK=e.$uK=e.SearchSortOrder=e.ViewMode=e.$tK=e.$sK=e.$rK=e.$qK=e.SearchCompletionExitCode=e.$pK=e.$oK=e.$nK=e.QueryType=e.SearchProviderType=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.$hK=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return O.TextSearchCompleteMessageType}}),e.$hK="workbench.view.search",e.$iK="workbench.panel.search",e.$jK="workbench.view.search",e.$kK="search-result",e.$lK="search.exclude";const l="\u27EA ",E=" characters skipped \u27EB",g=(l.length+E.length+5)*2;e.$mK=(0,m.$fi)("searchService");var s;(function(ue){ue[ue.file=0]="file",ue[ue.text=1]="text",ue[ue.aiText=2]="aiText"})(s||(e.SearchProviderType=s={}));var a;(function(ue){ue[ue.File=1]="File",ue[ue.Text=2]="Text",ue[ue.aiText=3]="aiText"})(a||(e.QueryType=a={}));function i(ue){return!!ue.preview}e.$nK=i;function n(ue){return!!ue.resource}e.$oK=n;function r(ue){return!!ue.message}e.$pK=r;var c;(function(ue){ue[ue.Normal=0]="Normal",ue[ue.NewSearchStarted=1]="NewSearchStarted"})(c||(e.SearchCompletionExitCode=c={}));class d{constructor(ve){this.resource=ve,this.results=[]}}e.$qK=d;class t{constructor(ve,re,$e,ie){this.ranges=re,this.webviewIndex=ie;const le=Array.isArray(re)?re:[re];if($e&&$e.matchLines===1&&p(le)){ve=(0,R.$Lf)(ve,$e.matchLines);let W="",_=0,ke=0;const Ne=Math.floor($e.charsPerLine/5),De=[];for(const be of le){const ge=Math.max(be.startColumn-Ne,0),J=be.startColumn+$e.charsPerLine;if(ge>ke+Ne+g){const X=l+(ge-ke)+E;W+=X+ve.slice(ge,J),_+=ge-(ke+X.length)}else W+=ve.slice(ke,J);De.push(new o(0,be.startColumn-_,be.endColumn-_)),ke=J}this.preview={text:W,matches:Array.isArray(this.ranges)?De:De[0]}}else{const W=Array.isArray(re)?re[0].startLineNumber:re.startLineNumber;this.preview={text:ve,matches:(0,S.$2b)(re,_=>new u(_.startLineNumber-W,_.startColumn,_.endLineNumber-W,_.endColumn))}}}}e.$rK=t;function p(ue){const ve=ue[0].startLineNumber;for(const re of ue)if(re.startLineNumber!==ve||re.endLineNumber!==ve)return!1;return!0}class u{constructor(ve,re,$e,ie){this.startLineNumber=ve,this.startColumn=re,this.endLineNumber=$e,this.endColumn=ie}}e.$sK=u;class o extends u{constructor(ve,re,$e){super(ve,re,ve,$e)}}e.$tK=o;var v;(function(ue){ue.List="list",ue.Tree="tree"})(v||(e.ViewMode=v={}));var b;(function(ue){ue.Default="default",ue.FileNames="fileNames",ue.Type="type",ue.Modified="modified",ue.CountDescending="countDescending",ue.CountAscending="countAscending"})(b||(e.SearchSortOrder=b={}));function $(ue,ve=!0){const re=ue&&ue.files&&ue.files.exclude,$e=ve&&ue&&ue.search&&ue.search.exclude;if(!re&&!$e)return;if(!re||!$e)return re||$e;let ie=Object.create(null);return ie=P.$Nn(ie,P.$Kn(re)),ie=P.$Nn(ie,P.$Kn($e),!0),ie}e.$uK=$;function I(ue,ve){return ue.excludePattern&&M.$Xj(ue.excludePattern,ve)?!1:ue.includePattern||ue.usingSearchPaths?ue.includePattern&&M.$Xj(ue.includePattern,ve)?!0:ue.usingSearchPaths?!!ue.folderQueries&&ue.folderQueries.some(re=>{const $e=re.folder.fsPath;if(F.$fg(ve,$e)){const ie=f.$lc($e,ve);return!re.includePattern||!!M.$Xj(re.includePattern,ie)}else return!1}):!1:!0}e.$vK=I;var h;(function(ue){ue[ue.unknownEncoding=1]="unknownEncoding",ue[ue.regexParseError=2]="regexParseError",ue[ue.globParseError=3]="globParseError",ue[ue.invalidLiteral=4]="invalidLiteral",ue[ue.rgProcessError=5]="rgProcessError",ue[ue.other=6]="other",ue[ue.canceled=7]="canceled"})(h||(e.SearchErrorCode=h={}));class y extends Error{constructor(ve,re){super(ve),this.code=re}}e.$wK=y;function w(ue){const ve=ue.message;if((0,k.$4)(ue))return new y(ve,h.canceled);try{const re=JSON.parse(ve);return new y(re.message,re.code)}catch{return new y(ve,h.other)}}e.$xK=w;function A(ue){const ve={message:ue.message,code:ue.code};return new Error(JSON.stringify(ve))}e.$yK=A;function N(ue){return ue.type==="error"?!0:ue.type==="success"}e.$zK=N;function G(ue){return ue.type==="success"}e.$AK=G;function V(ue){return!!ue.path}e.$BK=V;function U(ue,ve,re=!0){const $e=ue.searchPath?ue.searchPath:ue.relativePath;return re?(0,R.$If)($e,ve):M.$Xj(ve,$e)}e.$CK=U;class C{constructor(ve){this.path=ve,this.results=[]}addMatch(ve){this.results.push(ve)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$DK=C;function L(ue,ve){const re={...ue||{},...ve||{}};return Object.keys(re).filter($e=>{const ie=re[$e];return typeof ie=="boolean"&&ie})}e.$EK=L;class q{constructor(ve,re){this.c=null,this.a={...ve.excludePattern||{},...re.excludePattern||{}},this.b=M.$Yj(this.a);let $e=ve.includePattern;re.includePattern&&($e?$e={...$e,...re.includePattern}:$e=re.includePattern),$e&&(this.c=M.$Yj($e))}matchesExcludesSync(ve,re,$e){return!!(this.b&&this.b(ve,re,$e))}includedInQuerySync(ve,re,$e){return!(this.b&&this.b(ve,re,$e)||this.c&&!this.c(ve,re,$e))}includedInQuery(ve,re,$e){const ie=this.b(ve,re,$e),le=()=>this.c?!!this.c(ve,re,$e):!0;return(0,D.$4g)(ie)?ie.then(W=>W?!1:le()):le()}hasSiblingExcludeClauses(){return ne(this.a)}}e.$FK=q;function ne(ue){for(const ve in ue)if(typeof ue[ve]!="boolean")return!0;return!1}function ae(ue){if(!ue)return;let ve;return re=>(ve||(ve=(ue()||Promise.resolve([])).then($e=>$e?Ie($e):{})),ve.then($e=>!!$e[re]))}e.$GK=ae;function ye(ue){if(!ue)return;let ve;return re=>{if(!ve){const $e=ue();ve=$e?Ie($e):{}}return!!ve[re]}}e.$HK=ye;function Ie(ue){const ve={};for(const re of ue)ve[re]=!0;return ve}}),define(Pe[36],Re([1,0,18,11,25,5,6,50,12,125,24,15,2,172,3,13,191,47,43,27,17,8,7,59,44,4,52]),function(me,e,S,M,P,F,R,m,f,k,O,D,l,E,g,s,a,i,n,r,c,d,t,p,u,o,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cic=e.$bic=void 0;function b(G,V,U){return new O.$Hg(C=>y(C,U)).isEqual(G,V)}function $(G,V,U){return b(G.uri,V.uri,U)?0:(0,D.$cf)(G.uri.toString(),V.uri.toString())}function I(G,V,U){return G.index!==V.index?G.index<V.index?-1:1:b(G.uri,V.uri,U)?(0,D.$cf)(G.name,V.name):(0,D.$cf)(G.uri.toString(),V.uri.toString())}function h(G,V,U,C){const L=G.slice(0).sort((ne,ae)=>U(ne,ae,C)),q=V.slice(0).sort((ne,ae)=>U(ne,ae,C));return(0,S.$Eb)(L,q,(ne,ae)=>U(ne,ae,C))}function y(G,V){const U=V.getCapabilities(G.scheme);return!(U&&U&1024)}class w extends i.$yi{static toExtHostWorkspace(V,U,C,L){if(!V)return{workspace:null,added:[],removed:[]};const{id:q,name:ne,folders:ae,configuration:ye,transient:Ie,isUntitled:ue}=V,ve=[],re=U;U?ae.forEach((W,_)=>{const ke=l.URI.revive(W.uri),Ne=w.o(C||U,ke,L);Ne?(Ne.name=W.name,Ne.index=W.index,ve.push(Ne)):ve.push({uri:ke,name:W.name,index:_})}):ve.push(...ae.map(({uri:W,name:_,index:ke})=>({uri:l.URI.revive(W),name:_,index:ke}))),ve.sort((W,_)=>W.index<_.index?-1:1);const $e=new w(q,ne,ve,!!Ie,ye?l.URI.revive(ye):null,!!ue,W=>y(W,L)),{added:ie,removed:le}=h(re?re.workspaceFolders:[],$e.workspaceFolders,$,L);return{workspace:$e,added:ie,removed:le}}static o(V,U,C){for(let L=0;L<V.folders.length;L++){const q=V.workspaceFolders[L];if(b(q.uri,U,C))return q}}constructor(V,U,C,L,q,ne,ae){super(V,C.map(ye=>new i.$zi(ye)),L,q,ae),this.t=U,this.u=ne,this.q=[],this.s=m.$li.forUris(ae),C.forEach(ye=>{this.q.push(ye),this.s.set(ye.uri,ye)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(V,U){return U&&this.s.get(V)&&(V=(0,O.$Rg)(V)),this.s.findSubstr(V)}resolveWorkspaceFolder(V){return this.s.get(V)}}let A=class{constructor(V,U,C,L,q){this.c=new F.$5d,this.onDidChangeWorkspace=this.c.event,this.g=new F.$5d,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new F.$7d,this.C=new Map,this.h=L,this.s=C,this.t=q,this.j=new k.$gm,this.k=new M.$eh,this.o=V.getProxy(o.$6L.MainThreadWorkspace),this.q=V.getProxy(o.$6L.MainThreadMessageService);const ne=U.workspace;this.l=ne?new w(ne.id,ne.name,[],!!ne.transient,ne.configuration?l.URI.revive(ne.configuration):null,!!ne.isUntitled,ae=>y(ae,C)):void 0}$initializeWorkspace(V,U){this.v=U,this.$acceptWorkspaceData(V),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?l.URI.from({scheme:f.Schemas.untitled,path:(0,O.$Pg)((0,O.$Rg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(V,U,C,...L){const q=[];if(Array.isArray(L)&&L.forEach(ue=>{l.URI.isUri(ue.uri)&&!q.some(ve=>b(ve.uri,ue.uri,this.s))&&q.push({uri:ue.uri,name:ue.name||(0,O.$Og)(ue.uri)})}),this.n||[U,C].some(ue=>typeof ue!="number"||ue<0)||C===0&&q.length===0)return!1;const ne=this.x?this.x.workspaceFolders:[];if(U+C>ne.length)return!1;const ae=ne.slice(0);ae.splice(U,C,...q.map(ue=>({uri:ue.uri,name:ue.name||(0,O.$Og)(ue.uri),index:void 0})));for(let ue=0;ue<ae.length;ue++){const ve=ae[ue];if(ae.some((re,$e)=>$e!==ue&&b(ve.uri,re.uri,this.s)))return!1}ae.forEach((ue,ve)=>ue.index=ve);const{added:ye,removed:Ie}=h(ne,ae,I,this.s);if(ye.length===0&&Ie.length===0)return!1;if(this.o){const ue=V.displayName||V.name;this.o.$updateWorkspaceFolders(ue,U,C,q).then(void 0,ve=>{this.n=void 0;const re={source:{identifier:V.identifier,label:V.displayName||V.name}};this.q.$showMessage(a.Severity.Error,(0,E.localize)(0,null,ue,ve.toString()),re,[])})}return this.y(ae),!0}getWorkspaceFolder(V,U){if(this.x)return this.x.getWorkspaceFolder(V,U)}async getWorkspaceFolder2(V,U){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(V,U)}async resolveWorkspaceFolder(V){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(V)}getPath(){if(!this.x)return;const{folders:V}=this.x;if(V.length!==0)return V[0].uri.fsPath}getRelativePath(V,U){let C,L="";if(typeof V=="string"?(C=l.URI.file(V),L=V):typeof V<"u"&&(C=V,L=V.fsPath),!C)return L;const q=this.getWorkspaceFolder(C,!0);if(!q)return L;typeof U>"u"&&this.x&&(U=this.x.folders.length>1);let ne=(0,O.$Ug)(q.uri,C);return U&&q.name&&(ne=`${q.name}/${ne}`),ne}y(V){this.x&&(this.n=w.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:V,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(V){const{workspace:U,added:C,removed:L}=w.toExtHostWorkspace(V,this.l,this.n,this.s);this.l=U||void 0,this.n=void 0,this.c.fire(Object.freeze({added:C,removed:L}))}findFiles(V,U,C,L,q=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${L.value}, entryPoint: findFiles`);let ne="",ae=!0;return U===null?ae=!1:U!==void 0&&(typeof U=="string"?ne=U:ne=U.pattern),this.z(V,void 0,{exclude:ne,maxResults:C,useDefaultExcludes:ae,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},q)}findFiles2(V,U={},C,L=P.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${C.value}, entryPoint: findFiles2`),this.z(void 0,V,U,L)}async z(V,U,C,L=P.CancellationToken.None){if(L&&L.isCancellationRequested)return Promise.resolve([]);const q=typeof C.exclude=="string"?C.exclude:C.exclude?C.exclude.pattern:void 0,ne={ignoreSymlinks:typeof C.followSymlinks=="boolean"?!C.followSymlinks:void 0,disregardIgnoreFiles:typeof C.useIgnoreFiles=="boolean"?!C.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof C.useGlobalIgnoreFiles=="boolean"?!C.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof C.useParentIgnoreFiles=="boolean"?!C.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof C.useDefaultExcludes=="boolean"?!C.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof C.useDefaultSearchExcludes=="boolean"?!C.useDefaultSearchExcludes:!1,maxResults:C.maxResults,excludePattern:q,shouldGlobSearch:typeof C.fuzzy=="boolean"?!C.fuzzy:!0,_reason:"startFileSearch"};let ae;if(V){const{includePattern:ye,folder:Ie}=N(d.GlobPattern.from(V));ae=Ie,ne.includePattern=ye}else{const{includePattern:ye,folder:Ie}=N(d.GlobPattern.from(U));ae=Ie,ne.filePattern=ye}return this.o.$startFileSearch(ae??null,ne,L).then(ye=>Array.isArray(ye)?ye.map(Ie=>l.URI.revive(Ie)):[])}async findTextInFiles(V,U,C,L,q=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${L.value}, entryPoint: findTextInFiles`);const ne=this.j.getNext(),ae=typeof U.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:ye,folder:Ie}=N(d.GlobPattern.from(U.include)),ue=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,ve={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof U.useParentIgnoreFiles=="boolean"?!U.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:ae,afterContext:U.afterContext,beforeContext:U.beforeContext,includePattern:ye,excludePattern:ue},re=!1;if(this.u[ne]=$e=>{if(re)return;const ie=l.URI.revive($e.resource);$e.results.forEach(le=>{const W=(0,v.$Oh)(le);(0,u.$nK)(W)?C({uri:ie,preview:{text:W.preview.text,matches:(0,S.$2b)(W.preview.matches,_=>new t.$0L(_.startLineNumber,_.startColumn,_.endLineNumber,_.endColumn))},ranges:(0,S.$2b)(W.ranges,_=>new t.$0L(_.startLineNumber,_.startColumn,_.endLineNumber,_.endColumn))}):C({uri:ie,text:W.text,lineNumber:W.lineNumber})})},q.isCancellationRequested)return{};try{const $e=await this.o.$startTextSearch(V,Ie??null,ve,ne,q);return delete this.u[ne],$e||{}}catch($e){throw delete this.u[ne],$e}}$handleTextSearchResult(V,U){this.u[U]?.(V)}async save(V){const U=await this.o.$save(V,{saveAs:!1});return l.URI.revive(U)}async saveAs(V){const U=await this.o.$save(V,{saveAs:!0});return l.URI.revive(U)}saveAll(V){return this.o.$saveAll(V)}resolveProxy(V){return this.o.$resolveProxy(V)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(V){return this.o.$requestWorkspaceTrust(V)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(V,U){if(this.w.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.w.set(V,U);const C=this.t.transformOutgoingScheme(V),L=this.A++;return this.o.$registerEditSessionIdentityProvider(L,C),(0,R.$Rc)(()=>{this.w.delete(V),this.o.$unregisterEditSessionIdentityProvider(L)})}async $getEditSessionIdentifier(V,U){this.h.info("Getting edit session identifier for workspaceFolder",V);const C=await this.resolveWorkspaceFolder(l.URI.revive(V));if(!C){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",C);const L=this.w.get(C.uri.scheme);if(this.h.info(`Provider for scheme ${C.uri.scheme} is defined: `,!!L),!L)return;const q=await L.provideEditSessionIdentity(C,U);if(this.h.info("Provider returned edit session identifier: ",q),!!q)return q}async $provideEditSessionIdentityMatch(V,U,C,L){this.h.info("Getting edit session identifier for workspaceFolder",V);const q=await this.resolveWorkspaceFolder(l.URI.revive(V));if(!q){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",q);const ne=this.w.get(q.uri.scheme);if(this.h.info(`Provider for scheme ${q.uri.scheme} is defined: `,!!ne),!ne)return;const ae=await ne.provideEditSessionIdentityMatch?.(U,C,L);if(this.h.info("Provider returned edit session identifier match result: ",ae),!!ae)return ae}getOnWillCreateEditSessionIdentityEvent(V){return(U,C,L)=>{const q=function(ae){U.call(C,ae)};return q.extension=V,this.B.event(q,void 0,L)}}async $onWillCreateEditSessionIdentity(V,U,C){const L=await this.resolveWorkspaceFolder(l.URI.revive(V));if(L===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:L},U,async(q,ne)=>{const ae=Date.now();await Promise.resolve(q),Date.now()-ae>C&&this.h.warn("SLOW edit session create-participant",ne.extension.identifier)}),U.isCancellationRequested}registerCanonicalUriProvider(V,U){if(this.C.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.C.set(V,U);const C=this.t.transformOutgoingScheme(V),L=this.A++;return this.o.$registerCanonicalUriProvider(L,C),(0,R.$Rc)(()=>{this.C.delete(V),this.o.$unregisterCanonicalUriProvider(L)})}async provideCanonicalUri(V,U,C){const L=this.C.get(V.scheme);if(!L)return;const q=await L.provideCanonicalUri?.(l.URI.revive(V),U,C);if(q)return q}async $provideCanonicalUri(V,U,C){return this.provideCanonicalUri(l.URI.revive(V),{targetScheme:U},C)}};e.$bic=A,e.$bic=A=Ye([He(0,c.$lO),He(1,r.$BO),He(2,n.$Thc),He(3,s.$zj),He(4,p.$_hc)],A),e.$cic=(0,g.$fi)("IExtHostWorkspace");function N(G){let V,U;return G&&(typeof G=="string"?V=G:(V=G.pattern,U=l.URI.revive(G.baseUri))),{includePattern:V,folder:U}}}),define(Pe[37],Re([1,0,26,5,36,4,7,193,56,16,11,3,17,13,2]),function(me,e,S,M,P,F,R,m,f,k,O,D,l,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fic=e.$eic=e.$dic=void 0;function s(p,u){if(u){const o=u.split(".");let v=p;for(let b=0;v&&b<o.length;b++)v=v[o[b]];return v}}function a(p){return p instanceof g.URI}function i(p){return p&&p.uri instanceof g.URI&&p.languageId&&typeof p.languageId=="string"}function n(p){return p&&!p.uri&&p.languageId&&typeof p.languageId=="string"}function r(p){return p&&p.uri instanceof g.URI&&(!p.name||typeof p.name=="string")&&(!p.index||typeof p.index=="number")}function c(p){if(a(p))return{resource:p};if(i(p))return{resource:p.uri,overrideIdentifier:p.languageId};if(n(p))return{overrideIdentifier:p.languageId};if(r(p))return{resource:p.uri};if(p===null)return{resource:null}}let d=class{constructor(u,o,v){this.a=u.getProxy(F.$6L.MainThreadConfiguration),this.c=o,this.b=v,this.d=new O.$eh,this.e=null}getConfigProvider(){return this.d.wait().then(u=>this.e)}$initializeConfiguration(u){this.e=new t(this.a,this.c,u,this.b),this.d.open()}$acceptConfigurationChanged(u,o){this.getConfigProvider().then(v=>v.$acceptConfigurationChanged(u,o))}};e.$dic=d,e.$dic=d=Ye([He(0,l.$lO),He(1,P.$cic),He(2,E.$zj)],d);class t{constructor(u,o,v,b){this.a=new M.$5d,this.b=u,this.f=b,this.c=o,this.e=m.$io.parse(v),this.d=this.k(v.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(u,o){const v={data:this.e.toData(),workspace:this.c.workspace};this.e=m.$io.parse(u),this.d=this.k(u.configurationScopes),this.a.fire(this.j(o,v))}getConfiguration(u,o,v){const b=c(o)||{},$=this.g(u?s(this.e.getValue(void 0,b,this.c.workspace),u):this.e.getValue(void 0,b,this.c.workspace));u&&this.h(u,b,v?.identifier);function I(y){if(y==null)return null;if(typeof y=="boolean")return y?2:5;switch(y){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const h={has(y){return typeof s($,y)<"u"},get:(y,w)=>{this.h(u?`${u}.${y}`:y,b,v?.identifier);let A=s($,y);if(typeof A>"u")A=w;else{let N;const G=(V,U)=>{if((0,k.$Uf)(V)){let C;const L=()=>{N=N||(0,S.$Kn)($),C=C||s(N,U)};return new Proxy(V,{get:(q,ne)=>{if(typeof ne=="string"&&ne.toLowerCase()==="tojson")return L(),()=>C;if(N)return C=C||s(N,U),C[ne];const ae=q[ne];return typeof ne=="string"?G(ae,`${U}.${ne}`):ae},set:(q,ne,ae)=>(L(),C&&(C[ne]=ae),!0),deleteProperty:(q,ne)=>(L(),C&&delete C[ne],!0),defineProperty:(q,ne,ae)=>(L(),C&&Object.defineProperty(C,ne,ae),!0)})}return Array.isArray(V)?(0,S.$Kn)(V):V};A=G(A,y)}return A},update:(y,w,A,N)=>{y=u?`${u}.${y}`:y;const G=I(A);return w!==void 0?this.b.$updateConfigurationOption(G,y,w,b,N):this.b.$removeConfigurationOption(G,y,b,N)},inspect:y=>{y=u?`${u}.${y}`:y;const w=this.e.inspect(y,b,this.c.workspace);if(w)return{key:y,defaultValue:(0,S.$Kn)(w.policy?.value??w.default?.value),globalValue:(0,S.$Kn)(w.user?.value??w.application?.value),workspaceValue:(0,S.$Kn)(w.workspace?.value),workspaceFolderValue:(0,S.$Kn)(w.workspaceFolder?.value),defaultLanguageValue:(0,S.$Kn)(w.default?.override),globalLanguageValue:(0,S.$Kn)(w.user?.override??w.application?.override),workspaceLanguageValue:(0,S.$Kn)(w.workspace?.override),workspaceFolderLanguageValue:(0,S.$Kn)(w.workspaceFolder?.override),languageIds:(0,S.$Kn)(w.overrideIdentifiers)}}};return typeof $=="object"&&(0,S.$Nn)(h,$,!1),Object.freeze(h)}g(u){const o=v=>(0,k.$Uf)(v)?new Proxy(v,{get:(b,$)=>o(b[$]),set:(b,$,I)=>{throw new Error(`TypeError: Cannot assign to read only property '${String($)}' of object`)},deleteProperty:(b,$)=>{throw new Error(`TypeError: Cannot delete read only property '${String($)}' of object`)},defineProperty:(b,$)=>{throw new Error(`TypeError: Cannot define property '${String($)}' for a readonly object`)},setPrototypeOf:b=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):v;return o(u)}h(u,o,v){const b=f.$_n.test(u)?4:this.d.get(u),$=v?`[${v.value}] `:"";if(b===4){typeof o?.resource>"u"&&this.f.warn(`${$}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${u}', provide the URI of a resource or 'null' for any resource.`);return}if(b===3){o?.resource&&this.f.warn(`${$}Accessing a window scoped configuration for a resource is not expected. To associate '${u}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(u,o){const v=new m.$ko(u,o,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(b,$)=>v.affectsConfiguration(b,c($))})}k(u){return u.reduce((o,v)=>(o.set(v[0],v[1]),o),new Map)}}e.$eic=t,e.$fic=(0,D.$fi)("IExtHostConfiguration")}),define(Pe[118],Re([1,0,2,11,5,4,7,36,67,37,25,66,17,27,3,12,21,13,78,225,14]),function(me,e,S,M,P,F,R,m,f,k,O,D,l,E,g,s,a,i,n,r,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ijc=e.$Hjc=e.$Gjc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var d;(function(G){function V(C){if(C!=null)return C}G.from=V;function U(C){if(C!=null)return C}G.to=U})(d||(d={}));var t;(function(G){function V(C){if(C!=null)return C}G.from=V;function U(C){if(C!=null)return C}G.to=U})(t||(t={}));var p;(function(G){function V(C){if(C!=null)return C}G.from=V;function U(C){if(C!=null)return C}G.to=U})(p||(p={}));var u;(function(G){function V(L){if(L){const q=L;return q&&!!q.process}else return!1}G.is=V;function U(L){if(L==null)return;const q={process:L.process,args:L.args};return L.options&&(q.options=p.from(L.options)),q}G.from=U;function C(L){if(L!=null)return new R.$QM(L.process,L.args,L.options)}G.to=C})(u||(u={}));var o;(function(G){function V(C){if(C!=null)return C}G.from=V;function U(C){if(C!=null)return C}G.to=U})(o||(o={}));var v;(function(G){function V(L){if(L){const q=L;return q&&(!!q.commandLine||!!q.command)}else return!1}G.is=V;function U(L){if(L==null)return;const q={};return L.commandLine!==void 0?q.commandLine=L.commandLine:(q.command=L.command,q.args=L.args),L.options&&(q.options=o.from(L.options)),q}G.from=U;function C(L){if(!(L==null||L.command===void 0&&L.commandLine===void 0))return L.commandLine?new R.$RM(L.commandLine,L.options):new R.$RM(L.command,L.args?L.args:[],L.options)}G.to=C})(v||(v={}));var b;(function(G){function V(L){if(L){const q=L;return q&&q.customExecution==="customExecution"}else return!1}G.is=V;function U(L){return{customExecution:"customExecution"}}G.from=U;function C(L,q){return q.get(L)}G.to=C})(b||(e.CustomExecutionDTO=b={}));var $;(function(G){function V(U,C){let L;return U.scope!==void 0&&typeof U.scope!="number"?L=U.scope.uri:U.scope!==void 0&&typeof U.scope=="number"&&(U.scope===R.TaskScope.Workspace&&C&&C.workspaceFile?L=C.workspaceFile:L=r.$gH),{id:U._id,workspaceFolder:L}}G.from=V})($||(e.TaskHandleDTO=$={}));var I;(function(G){function V(U){if(U!=null)return{_id:U.id,isDefault:U.isDefault}}G.from=V})(I||(I={}));var h;(function(G){function V(L,q){if(L==null)return[];const ne=[];for(const ae of L){const ye=U(ae,q);ye&&ne.push(ye)}return ne}G.fromMany=V;function U(L,q){if(L==null)return;let ne;L.execution instanceof R.$QM?ne=u.from(L.execution):L.execution instanceof R.$RM?ne=v.from(L.execution):L.execution&&L.execution instanceof R.$SM&&(ne=b.from(L.execution));const ae=d.from(L.definition);let ye;return L.scope?typeof L.scope=="number"?ye=L.scope:ye=L.scope.uri:ye=R.TaskScope.Workspace,!ae||!ye?void 0:{_id:L._id,definition:ae,name:L.name,source:{extensionId:q.identifier.value,label:L.source,scope:ye},execution:ne,isBackground:L.isBackground,group:I.from(L.group),presentationOptions:t.from(L.presentationOptions),problemMatchers:L.problemMatchers,hasDefinedMatchers:L.hasDefinedMatchers,runOptions:L.runOptions?L.runOptions:{reevaluateOnRerun:!0},detail:L.detail}}G.from=U;async function C(L,q,ne){if(L==null)return;let ae;u.is(L.execution)?ae=u.to(L.execution):v.is(L.execution)?ae=v.to(L.execution):b.is(L.execution)&&(ae=b.to(L._id,ne));const ye=d.to(L.definition);let Ie;if(L.source&&(L.source.scope!==void 0?typeof L.source.scope=="number"?Ie=L.source.scope:Ie=await q.resolveWorkspaceFolder(S.URI.revive(L.source.scope)):Ie=R.TaskScope.Workspace),!ye||!Ie)return;const ue=new R.$TM(ye,Ie,L.name,L.source.label,ae,L.problemMatchers);return L.isBackground!==void 0&&(ue.isBackground=L.isBackground),L.group!==void 0&&(ue.group=R.$PM.from(L.group._id),ue.group&&L.group.isDefault&&(ue.group=new R.$PM(ue.group.id,ue.group.label),L.group.isDefault===!0&&(ue.group.isDefault=L.group.isDefault))),L.presentationOptions&&(ue.presentationOptions=t.to(L.presentationOptions)),L._id&&(ue._id=L._id),L.detail&&(ue.detail=L.detail),ue}G.to=C})(h||(e.TaskDTO=h={}));var y;(function(G){function V(C){return C}G.from=V;function U(C){if(C)return Object.assign(Object.create(null),C)}G.to=U})(y||(y={}));class w{#e;constructor(V,U,C){this._id=U,this.a=C,this.#e=V}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(V){}fireDidEndProcess(V){}}let A=class{constructor(V,U,C,L,q,ne,ae,ye){this.q=new P.$5d,this.r=new P.$5d,this.s=new P.$5d,this.u=new P.$5d,this.a=V.getProxy(F.$6L.MainThreadTask),this.b=C,this.c=L,this.d=q,this.e=ne,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ae,this.g=ye,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(V,U,C){if(!C)return new R.$8L(()=>{});const L=this.x();return this.j.set(L,{type:U,provider:C,extension:V}),this.a.$registerTaskProvider(L,U),new R.$8L(()=>{this.j.delete(L),this.a.$unregisterTaskProvider(L)})}registerTaskSystem(V,U){this.a.$registerTaskSystem(V,U)}fetchTasks(V){return this.a.$fetchTasks(y.from(V)).then(async U=>{const C=[];for(const L of U){const q=await h.to(L,this.b,this.m);q&&C.push(q)}return C})}get taskExecutions(){const V=[];return this.k.forEach(U=>V.push(U)),V}terminateTask(V){if(!(V instanceof w))throw new Error("No valid task execution provided");return this.a.$terminateTask(V._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(V,U,C){const L=this.m.get(V.id);L&&(this.o.set(V.id,L),this.e.attachPtyToTerminal(U,await L.callback(C))),this.p=V.id,this.q.fire({execution:await this.z(V)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(V){if(!this.l.has(V.id))return;const U=await this.z(V);this.l.delete(V.id),this.k.delete(V.id),this.B(V),this.r.fire({execution:U})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(V){const U=await this.z(V.id);this.s.fire({execution:U,processId:V.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(V){const U=await this.z(V.id);this.u.fire({execution:U,exitCode:V.exitCode})}$provideTasks(V,U){const C=this.j.get(V);if(!C)return Promise.reject(new Error("no handler found"));const L=[],q=(0,M.$0g)(()=>C.provider.provideTasks(O.CancellationToken.None)).then(ne=>this.v(U,L,C,ne));return new Promise(ne=>{q.then(ae=>{Promise.all(L).then(()=>{ne(ae)})})})}async $resolveTask(V,U){const C=this.j.get(V);if(!C)return Promise.reject(new Error("no handler found"));if(U.definition.type!==C.type)throw new Error(`Unexpected: Task of type [${U.definition.type}] cannot be resolved by provider of type [${C.type}].`);const L=await h.to(U,this.b,this.m);if(!L)throw new Error("Unexpected: Task cannot be resolved.");const q=await C.provider.resolveTask(L,O.CancellationToken.None);if(!q)return;this.A(q,C);const ne=h.from(q,C.extension);if(!ne)throw new Error("Unexpected: Task cannot be resolved.");if(q.definition!==L.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return b.is(ne.execution)&&await this.y(ne,q,!0),await this.w(ne)}x(){return this.h++}async y(V,U,C){const L=await this.a.$createTaskId(V);!C&&!this.m.has(L)&&(this.n.add(L),this.o.set(L,U.execution)),this.m.set(L,U.execution)}async z(V,U){if(typeof V=="string"){const q=this.l.get(V);if(!q)throw new c.$bb("Unexpected: The specified task is missing an execution");return q}const C=this.l.get(V.id);if(C)return C;let L;return U?L=Promise.resolve(new w(this,V.id,U)):L=h.to(V.task,this.b,this.m).then(q=>{if(!q)throw new c.$bb("Unexpected: Task does not exist.");return new w(this,V.id,q)}),this.l.set(V.id,L),L.then(q=>(this.k.set(V.id,q),q))}A(V,U){V._deprecated&&this.g.report("Task.constructor",U.extension,"Use the Task constructor that takes a `scope` instead.")}B(V){this.o.get(V.id)&&this.o.delete(V.id),this.n.has(V.id)&&this.p!==V.id&&(this.m.delete(V.id),this.n.delete(V.id));const C=this.n.values();let L=C.next();for(;!L.done;)!this.o.has(L.value)&&this.p!==L.value&&(this.m.delete(L.value),this.n.delete(L.value)),L=C.next()}};e.$Gjc=A,e.$Gjc=A=Ye([He(0,l.$lO),He(1,E.$BO),He(2,m.$cic),He(3,f.$wO),He(4,k.$fic),He(5,D.$Dic),He(6,i.$zj),He(7,n.$Phc)],A);let N=class extends A{constructor(V,U,C,L,q,ne,ae,ye){super(V,U,C,L,q,ne,ae,ye),this.registerTaskSystem(s.Schemas.vscodeRemote,{scheme:s.Schemas.vscodeRemote,authority:"",platform:a.$h(0)})}async executeTask(V,U){if(!U.execution)throw new Error("Tasks to execute must include an execution");const C=h.from(U,V);if(C===void 0)throw new Error("Task is not valid");if(b.is(C.execution))await this.y(C,U,!1);else throw new c.$_;const L=await this.z(await this.a.$getTaskExecution(C),U);return this.a.$executeTask(C).catch(q=>{throw new Error(q)}),L}v(V,U,C,L){const q=[];if(L)for(const ne of L){if(this.A(ne,C),!ne.definition||!V[ne.definition.type]){const ye=ne.source?ne.source:"No task source";this.f.warn(`The task [${ye}, ${ne.name}] uses an undefined task type. The task will be ignored in the future.`)}const ae=h.from(ne,C.extension);ae&&b.is(ae.execution)?(q.push(ae),U.push(this.y(ae,ne,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:q,extension:C.extension}}async w(V){if(b.is(V.execution))return V;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(V,U){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(V,U,C){}};e.$Hjc=N,e.$Hjc=N=Ye([He(0,l.$lO),He(1,E.$BO),He(2,m.$cic),He(3,f.$wO),He(4,k.$fic),He(5,D.$Dic),He(6,i.$zj),He(7,n.$Phc)],N),e.$Ijc=(0,g.$fi)("IExtHostTask")}),define(Pe[285],Re([1,0,44,29]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PK=e.$OK=e.$NK=void 0;function P(R){return"cellResults"in R}e.$NK=P,e.$OK="rawCell#";function F(R,m){let f=-1;const k=[];let O=[];return R.forEach(l=>{l.range.startLineNumber!==f&&O.length>0&&(k.push([...O]),O=[]),O.push(l),f=l.range.endLineNumber}),O.length>0&&k.push([...O]),k.map(l=>{const E=[],g=l[0].range.startLineNumber,s=l[l.length-1].range.endLineNumber;for(let a=g;a<=s;a++)E.push(m.getLineContent(a));return new S.$rK(E.join(`
`)+`
`,l.map(a=>new M.$9s(a.range.startLineNumber-1,a.range.startColumn-1,a.range.endLineNumber-1,a.range.endColumn-1)))})}e.$PK=F}),define(Pe[286],Re([1,0,166,23,5,6,28,15,16,2,42,74,4,31,8,7,49,261,112,26,12,215,285,283]),function(me,e,S,M,P,F,R,m,f,k,O,D,l,E,g,s,a,i,n,r,c,d,t,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ijc=void 0;class u{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(v=>v.apiEditor)}constructor(v,b,$,I,h,y){this.q=$,this.r=I,this.s=h,this.t=y,this.f=new Map,this.g=new R.$Ac,this.h=new Map,this.j=new P.$5d,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new P.$5d,this.onDidOpenNotebookDocument=this.m.event,this.n=new P.$5d,this.onDidCloseNotebookDocument=this.n.event,this.o=new P.$5d,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new D.$Nhc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=v.getProxy(l.$6L.MainThreadNotebook),this.c=v.getProxy(l.$6L.MainThreadNotebookDocuments),this.d=v.getProxy(l.$6L.MainThreadNotebookEditors),this.i=b.converter,b.registerArgumentProcessor({processArgument:w=>{if(w&&w.$mid===13){const A=w.notebookEditor?.notebookUri,N=w.cell.handle,V=this.g.get(A)?.getCell(N);if(V)return V.apiCell}if(w&&w.$mid===14){const A=w.uri,N=this.g.get(A);if(N)return N.apiNotebook}return w}}),u.B(b)}getEditorById(v){const b=this.h.get(v);if(!b)throw new Error(`unknown text editor: ${v}. known editors: ${[...this.h.keys()]} `);return b}getIdByEditor(v){for(const[b,$]of this.h)if($.apiEditor===v)return b}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(v,b){const $=this.g.get(v);if(!$&&!b)throw new Error(`NO notebook document for '${v}'`);return $}static u(v,b){if(!b)return;const $=b.filenamePattern.map(I=>g.NotebookExclusiveDocumentPattern.from(I)).filter(I=>I!==void 0);if(b.filenamePattern&&!$){console.warn(`Notebook content provider view options file name pattern is invalid ${b.filenamePattern}`);return}return{extension:v.identifier,providerDisplayName:v.displayName||v.name,displayName:b.displayName,filenamePattern:$,exclusive:b.exclusive||!1}}registerNotebookCellStatusBarItemProvider(v,b,$){const I=u.a++,h=typeof $.onDidChangeCellStatusBarItems=="function"?u.a++:void 0;this.f.set(I,$),this.b.$registerNotebookCellStatusBarItemProvider(I,h,b);let y;return h!==void 0&&(y=$.onDidChangeCellStatusBarItems(w=>this.b.$emitCellStatusBarEvent(h))),new s.$8L(()=>{this.f.delete(I),this.b.$unregisterNotebookCellStatusBarItemProvider(I,h),y?.dispose()})}async createNotebookDocument(v){const b=await this.c.$tryCreateNotebook({viewType:v.viewType,content:v.content&&g.NotebookData.from(v.content)});return k.URI.revive(b)}async openNotebookDocument(v){const b=this.g.get(v);if(b)return b.apiNotebook;const $=await this.c.$tryOpenNotebook(v),I=this.g.get(k.URI.revive($));return(0,f.$4f)(I?.apiNotebook)}async showNotebookDocument(v,b){k.URI.isUri(v)&&(v=await this.openNotebookDocument(v));let $;typeof b=="object"?$={position:g.ViewColumn.from(b.viewColumn),preserveFocus:b.preserveFocus,selections:b.selections&&b.selections.map(g.NotebookRange.from),pinned:typeof b.preview=="boolean"?!b.preview:void 0}:$={preserveFocus:!1};const I=await this.d.$tryShowNotebookDocument(v.uri,v.notebookType,$),h=I&&this.h.get(I)?.apiEditor;if(h)return h;throw I?new Error(`Could NOT open editor for "${v.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${v.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(v,b,$,I){const h=this.f.get(v),y=k.URI.revive(b),w=this.g.get(y);if(!w||!h)return;const A=w.getCellFromIndex($);if(!A)return;const N=await h.provideCellStatusBarItems(A.apiCell,I);if(!N)return;const G=new F.$Sc,V=this.p.add([G]),C=(Array.isArray(N)?N:[N]).map(L=>g.NotebookStatusBarItem.from(L,this.i,G));return{cacheId:V,items:C}}$releaseNotebookCellStatusBarItems(v){this.p.delete(v)}registerNotebookSerializer(v,b,$,I,h){if((0,m.$Se)(b))throw new Error("viewType cannot be empty or just whitespace");const y=this.w++;return this.x.set(y,{viewType:b,serializer:$,options:I}),this.b.$registerNotebookSerializer(y,{id:v.identifier,location:v.extensionLocation},b,g.NotebookDocumentContentOptions.from(I),u.u(v,h)),(0,F.$Rc)(()=>{this.b.$unregisterNotebookSerializer(y)})}async $dataToNotebook(v,b,$){const I=this.x.get(v);if(!I)throw new Error("NO serializer found");const h=await I.serializer.deserializeNotebook(b.buffer,$);return new a.$9v(g.NotebookData.from(h))}async $notebookToData(v,b,$){const I=this.x.get(v);if(!I)throw new Error("NO serializer found");const h=await I.serializer.serializeNotebook(g.NotebookData.to(b.value),$);return M.$se.wrap(h)}async $saveNotebook(v,b,$,I,h){const y=k.URI.revive(b),w=this.x.get(v);if(!w)throw new Error("NO serializer found");const A=this.g.get(y);if(!A)throw new Error("Document NOT found");if(A.versionId!==$)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(y.scheme))throw new O.$1k((0,S.localize)(0,null,this.z(y)),6);await this.y(y,I);const N={metadata:(0,r.$Sn)(A.apiNotebook.metadata,L=>!(w.options?.transientDocumentMetadata??{})[L]),cells:[]};for(const L of A.apiNotebook.getCells()){const q=new s.$wN(L.kind,L.document.getText(),L.document.languageId,L.mime,w.options?.transientOutputs?[]:[...L.outputs],L.metadata,L.executionSummary);q.metadata=(0,r.$Sn)(L.metadata,ne=>!(w.options?.transientCellMetadata??{})[ne]),N.cells.push(q)}const G=await w.serializer.serializeNotebook(N,h);await this.s.value.writeFile(y,G);const V=this.s.getFileSystemProviderExtUri(y.scheme),U=await this.s.value.stat(y);return{name:V.basename(y),isFile:(U.type&O.FileType.File)!==0,isDirectory:(U.type&O.FileType.Directory)!==0,isSymbolicLink:(U.type&O.FileType.SymbolicLink)!==0,mtime:U.mtime,ctime:U.ctime,size:U.size,readonly:!!((U.permissions??0)&O.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(y.scheme),locked:!!((U.permissions??0)&O.FilePermission.Locked),etag:O.$_k({mtime:U.mtime,size:U.size}),children:void 0}}async $searchInNotebooks(v,b,$,I,h){const y=this.x.get(v)?.serializer;if(!y)return{limitHit:!1,results:[]};const w=new R.$Bc;await(async(U,C,L)=>{await Promise.all(U.map(async q=>await Promise.all(q.filenamePatterns.map(ne=>{const ae={_reason:L._reason,folderQueries:L.folderQueries,includePattern:L.includePattern,excludePattern:L.excludePattern,maxResults:L.maxResults,type:1,filePattern:ne};return this.t.doInternalFileSearchWithCustomCallback(ae,C,ye=>{ye.forEach(Ie=>{w.has(Ie)||I.some(ve=>q.isFromSettings&&!ve.isFromSettings?!1:ve.filenamePatterns.some(re=>(0,p.$9eb)(re,Ie)))||w.add(Ie)})}).catch(ye=>{if(ye.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw ye})}))))})($,h,b);const N=new R.$Ac;let G=!1;const V=Array.from(w).map(async U=>{const C=[];try{if(h.isCancellationRequested)return;if(b.maxResults&&[...N.values()].reduce((ae,ye)=>ae+ye.cellResults.length,0)>b.maxResults){G=!0;return}const L=[],q=this.g.get(U);if(q)q.apiNotebook.getCells().forEach(ye=>L.push({input:ye.document.getText(),outputs:ye.outputs.flatMap(Ie=>Ie.items.map(ue=>ue.data.toString()))}));else{const ae=await this.s.value.readFile(U),ye=M.$se.fromString(ae.toString()),Ie=await y.deserializeNotebook(ye.buffer,h);if(h.isCancellationRequested)return;g.NotebookData.from(Ie).cells.forEach(ve=>L.push({input:ve.source,outputs:ve.outputs.flatMap(re=>re.items.map($e=>$e.valueBytes.toString()))}))}if(h.isCancellationRequested)return;L.forEach((ae,ye)=>{const Ie=b.contentPattern.pattern,ue=new d.$xTb(ae.input,void 0,ae.outputs),ve=ue.findInInputs(Ie),re=ue.findInOutputs(Ie),$e=re.flatMap(ie=>(0,t.$PK)(ie.matches,ie.textBuffer)).map((ie,le)=>(ie.webviewIndex=le,ie));if(ve.length>0||re.length>0){const ie={index:ye,contentResults:(0,t.$PK)(ve,ue.inputTextBuffer),webviewResults:$e};C.push(ie)}});const ne={resource:U,cellResults:C};N.set(U,ne);return}catch{return}});return await Promise.all(V),{limitHit:G,results:[...N.values()]}}async y(v,b){const $=await this.s.value.stat(v);if(typeof b?.mtime=="number"&&typeof b.etag=="string"&&b.etag!==O.$$k&&typeof $.mtime=="number"&&typeof $.size=="number"&&b.mtime<$.mtime&&b.etag!==O.$_k({mtime:b.mtime,size:$.size}))throw new O.$1k((0,S.localize)(1,null),3,b)}z(v){return v.scheme===c.Schemas.file?v.fsPath:v.toString()}A(v,b,$){if(this.h.has(b))throw new Error(`editor with id ALREADY EXSIST: ${b}`);const I=new n.$_ic(b,this.d,v,$.visibleRanges.map(g.NotebookRange.to),$.selections.map(g.NotebookRange.to),typeof $.viewColumn=="number"?g.ViewColumn.to($.viewColumn):void 0);this.h.set(b,I)}$acceptDocumentAndEditorsDelta(v){if(v.value.removedDocuments)for(const $ of v.value.removedDocuments){const I=k.URI.revive($),h=this.g.get(I);h&&(h.dispose(),this.g.delete(I),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:h.apiNotebook.getCells().map(y=>y.document.uri)}),this.n.fire(h.apiNotebook));for(const y of this.h.values())y.notebookData.uri.toString()===I.toString()&&this.h.delete(y.id)}if(v.value.addedDocuments){const $=[];for(const I of v.value.addedDocuments){const h=k.URI.revive(I.uri);if(this.g.has(h))throw new Error(`adding EXISTING notebook ${h} `);const y=new i.$$ic(this.c,this.q,this.r,h,I);$.push(...I.cells.map(w=>i.$0ic.asModelAddData(w))),this.g.get(h)?.dispose(),this.g.set(h,y),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:$}),this.m.fire(y.apiNotebook)}}if(v.value.addedEditors)for(const $ of v.value.addedEditors){if(this.h.has($.id))return;const I=k.URI.revive($.documentUri),h=this.g.get(I);h&&this.A(h,$.id,$)}const b=[];if(v.value.removedEditors)for(const $ of v.value.removedEditors){const I=this.h.get($);I&&(this.h.delete($),this.k?.id===I.id&&(this.k=void 0),b.push(I))}if(v.value.visibleEditors){this.l=v.value.visibleEditors.map(I=>this.h.get(I)).filter(I=>!!I);const $=new Set;this.l.forEach(I=>$.add(I.id));for(const I of this.h.values()){const h=$.has(I.id);I._acceptVisibility(h)}this.l=[...this.h.values()].map(I=>I).filter(I=>I.visible),this.o.fire(this.visibleNotebookEditors)}v.value.newActiveEditor===null?this.k=void 0:v.value.newActiveEditor&&(this.h.get(v.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${v.value.newActiveEditor}`),this.k=this.h.get(v.value.newActiveEditor)),v.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(v){const b=E.$JO.String.with("notebookType","A notebook type"),$=new E.$LO("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[b,new E.$JO("data","Bytes to convert to data",h=>h instanceof Uint8Array,h=>M.$se.wrap(h))],new E.$KO("Notebook Data",h=>g.NotebookData.to(h.value))),I=new E.$LO("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[b,new E.$JO("NotebookData","Notebook data to convert to bytes",h=>!0,h=>new a.$9v(g.NotebookData.from(h)))],new E.$KO("Bytes",h=>h.buffer));v.registerApiCommand($),v.registerApiCommand(I)}}e.$ijc=u}),define(Pe[287],Re([1,0,19,25,41,34,24,64,44]),function(me,e,S,M,P,F,R,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ajc=void 0;class k{constructor(l,E,g){this.k=l,this.l=E,this.o=g,this.e=!1,this.f=0,this.g=!1,this.a=l.filePattern,this.b=l.includePattern&&F.$Yj(l.includePattern),this.c=l.maxResults||void 0,this.d=l.exists,this.h=new Set,this.j=l.excludePattern&&F.$Yj(l.excludePattern)}cancel(){this.g=!0,this.h.forEach(l=>l.cancel()),this.h=new Set}search(l){const E=this.k.folderQueries||[];return new Promise((g,s)=>{const a=i=>{this.f++,l(i)};if(this.g)return g({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(i=>{const n=i.toString(),r=S.$nc(n);this.j&&this.j(n,r)||this.v(a,{base:i,basename:r})}),Promise.all(E.map(i=>this.p(i,a))).then(i=>{g({limitHit:this.e,stats:i[0]||void 0})},i=>{s(new Error((0,P.$3i)(i)))})})}async p(l,E){const g=new M.$ce,s=this.q(l),a=this.r(),i=new f.$FK(this.k,l),n=!i.hasSiblingExcludeClauses();let r;try{this.h.add(g),r=m.$1d.create();const c=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},s,g.token),d=r.elapsed(),t=m.$1d.create();return this.g&&!this.e||(c&&c.forEach(p=>{const u=S.$gc.relative(l.folder.path,p.path);if(n){const o=S.$nc(p.path);this.v(E,{base:l.folder,relativePath:u,basename:o});return}this.s(a,l.folder,u,E)}),this.g&&!this.e)?null:(this.u(a,i,E),{providerTime:d,postProcessTime:t.elapsed()})}finally{g.dispose(),this.h.delete(g)}}q(l){const E=(0,f.$EK)(this.k.includePattern,l.includePattern),g=(0,f.$EK)(this.k.excludePattern,l.excludePattern);return{folder:l.folder,excludes:g,includes:E,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}s({pathToEntries:l},E,g,s){if(g===this.a){const i=S.$nc(this.a);this.v(s,{base:E,relativePath:this.a,basename:i})}function a(i){const n=S.$nc(i),r=S.$mc(i);let c=l[r];c||(c=l[r]=[],a(r)),c.push({base:E,relativePath:i,basename:n})}a(g)}u({rootEntries:l,pathToEntries:E},g,s){const a=this,i=this.a;function n(r){const c=(0,f.$HK)(()=>r.map(d=>d.basename));for(let d=0,t=r.length;d<t;d++){const p=r[d],{relativePath:u,basename:o}=p;if(g.matchesExcludesSync(u,o,i!==o?c:void 0))continue;const v=E[u];if(v)n(v);else{if(u===i)continue;a.v(s,p)}if(a.e)break}}n(l)}v(l,E){(!this.b||E.relativePath&&this.b(E.relativePath,E.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||l(E))}}class O{constructor(){this.b=new Map}static{this.a=512}fileSearch(l,E,g,s){const a=this.c(l.cacheKey),i=new k(l,E,a&&a.token);let n=0;const r=c=>{n+=c.length,g(c.map(d=>this.d(d)))};return this.e(i,O.a,r,s).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:c.stats}}))}clearCache(l){this.c(l)?.cancel()}c(l){if(l)return this.b.has(l)||this.b.set(l,new M.$ce),this.b.get(l)}d(l){return l.relativePath?{resource:R.$Sg(l.base,l.relativePath)}:{resource:l.base}}e(l,E,g,s){const a=s.onCancellationRequested(()=>{l.cancel()}),i=r=>{r&&(n.push(r),E>0&&n.length>=E&&(g(n),n=[]))};let n=[];return l.search(i).then(r=>(n.length&&g(n),a.dispose(),r),r=>(n.length&&g(n),a.dispose(),Promise.reject(r)))}}e.$ajc=O}),define(Pe[288],Re([1,0,18,256,34,96,28,12,19,24,15,16,2,95,183,46,13,47,107,284,44]),function(me,e,S,M,P,F,R,m,f,k,O,D,l,E,g,s,a,i,n,r,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KL=e.$JL=void 0;let d=class{constructor(y,w,A,N,G){this.a=y,this.b=w,this.c=A,this.d=N,this.e=G}text(y,w,A={}){y=this.f(y,A);const N=this.a.getValue(),G=w&&w.some(U=>!this.a.getValue({resource:U}).search.useRipgrep);return{...this.h(w?.map(i.$Ai),A),type:2,contentPattern:y,previewOptions:A.previewOptions,maxFileSize:A.maxFileSize,usePCRE2:N.search.usePCRE2||G||!1,beforeContext:A.beforeContext,afterContext:A.afterContext,userDisabledExcludesAndIgnoreFiles:A.disregardExcludeSettings&&A.disregardIgnoreFiles}}f(y,w){const A=this.a.getValue();y.isRegExp&&(y.pattern=y.pattern.replace(/\r?\n/g,"\\n"));const N={...y,wordSeparators:A.editor.wordSeparators};return this.j(y,w)&&(N.isCaseSensitive=!0),this.k(y)&&(N.isMultiline=!0),w.notebookSearchConfig?.includeMarkupInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownInput=w.notebookSearchConfig.includeMarkupInput),w.notebookSearchConfig?.includeMarkupPreview&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownPreview=w.notebookSearchConfig.includeMarkupPreview),w.notebookSearchConfig?.includeCodeInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellInput=w.notebookSearchConfig.includeCodeInput),w.notebookSearchConfig?.includeOutput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellOutput=w.notebookSearchConfig.includeOutput),N}file(y,w={}){return{...this.h(y,w),type:1,filePattern:w.filePattern?w.filePattern.trim():w.filePattern,exists:w.exists,sortByScore:w.sortByScore,cacheKey:w.cacheKey,shouldGlobMatchFilePattern:w.shouldGlobSearch}}g(y,w){return y?(y=Array.isArray(y)?y.map(v):v(y),w?this.parseSearchPaths(y):{pattern:p(...Array.isArray(y)?y:[y])}):{}}h(y=[],w={}){const A=this.g(w.includePattern,w.expandPatterns),N=this.g(w.excludePattern,w.expandPatterns),G=y.length>1,V=(A.searchPaths&&A.searchPaths.length?A.searchPaths.map(L=>this.q(L,w,N)):y.map(L=>this.r(L,w,N,G))).filter(L=>!!L),U={_reason:w._reason,folderQueries:V,usingSearchPaths:!!(A.searchPaths&&A.searchPaths.length),extraFileResources:w.extraFileResources,excludePattern:N.pattern,includePattern:A.pattern,onlyOpenEditors:w.onlyOpenEditors,maxResults:w.maxResults};if(w.onlyOpenEditors){const L=S.$Hb(S.$Rb(this.c.groups.map(ae=>ae.editors.map(ye=>ye.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(L));const q=L.filter(ae=>(0,c.$vK)(U,ae.fsPath)),ne=this.i(q);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(ne)),{...U,...ne}}const C=w.extraFileResources&&w.extraFileResources.filter(L=>(0,c.$vK)(U,L.fsPath));return U.extraFileResources=C&&C.length?C:void 0,U}i(y){const w=[],A=new R.$Ac,N={};let G=!1;return y.forEach(V=>{if(V.scheme===m.Schemas.walkThrough)return;if((0,k.$Wg)(V)){const C=this.b.getWorkspaceFolder(V)?.uri??V.with({path:f.$mc(V.fsPath)});let L=A.get(C);L||(G=!0,L={folder:C,includePattern:{}},w.push(L),A.set(C,L));const q=f.$lc(C.fsPath,V.fsPath);(0,D.$4f)(L.includePattern)[q.replace(/\\/g,"/")]=!0}else V.fsPath&&(G=!0,N[V.fsPath]=!0)}),{folderQueries:w,includePattern:N,usingSearchPaths:!0,excludePattern:G?void 0:{"**/*":!0}}}j(y,w){if(w.isSmartCase){if(y.isRegExp){if(O.$Jf(y.pattern,!0))return!0}else if(O.$Jf(y.pattern))return!0}return!!y.isCaseSensitive}k(y){return y.isMultiline||y.isRegExp&&(0,E.$gC)(y.pattern)||y.pattern.indexOf(`
`)>=0?!0:!!y.isMultiline}parseSearchPaths(y){const w=ne=>f.$ic(ne)||/^\.\.?([\/\\]|$)/.test(ne),N=(Array.isArray(y)?y:u(y)).map(ne=>{const ae=this.e.resolvedUserHome;return ae?(0,F.$bw)(ne,ae.scheme===m.Schemas.file?ae.fsPath:ae.path):ne}),G=M.$K(N,ne=>w(ne)?"searchPaths":"exprSegments"),V=(G.exprSegments||[]).map(ne=>O.$4e(ne,"/")).map(ne=>O.$4e(ne,"\\")).map(ne=>(ne[0]==="."&&(ne="*"+ne),o(ne))),U={},C=this.m(G.searchPaths||[]);C&&C.length&&(U.searchPaths=C);const L=S.$Rb(V),q=p(...L);return q&&(U.pattern=q),U}l(y,w){return w.disregardExcludeSettings?void 0:(0,c.$uK)(y,!w.disregardSearchExcludeSettings)}m(y){if(!y||!y.length)return[];const w=y.flatMap(N=>{let{pathPortion:G,globPortion:V}=t(N);return V&&(V=b(V)),this.n(G).flatMap(C=>this.o(C,V))}),A=new Map;return w.forEach(N=>{const G=N.searchPath.toString(),V=A.get(G);V?N.pattern&&(V.pattern=V.pattern||{},V.pattern[N.pattern]=!0):A.set(G,{searchPath:N.searchPath,pattern:N.pattern?p(N.pattern):void 0})}),Array.from(A.values())}n(y){if(f.$ic(y)){const w=this.b.getWorkspace().folders;return w[0]&&w[0].uri.scheme!==m.Schemas.file?[{searchPath:w[0].uri.with({path:y})}]:[{searchPath:l.URI.file(f.$hc(y))}]}if(this.b.getWorkbenchState()===2){const w=this.b.getWorkspace().folders[0].uri;if(y=v(y),y.startsWith("../")||y===".."){const N=f.$gc.resolve(w.path,y);return[{searchPath:w.with({path:N})}]}const A=b(y);return[{searchPath:w,pattern:A}]}else{if(y==="./"||y===".\\")return[];{const w=y.replace(/^\.[\/\\]/,""),N=this.b.getWorkspace().folders.map(G=>{const V=w.match(new RegExp(`^${O.$Xe(G.name)}(?:/(.*)|$)`));return V?{match:V,folder:G}:null}).filter(D.$1f);if(N.length)return N.map(G=>{const V=G.match[1];return{searchPath:G.folder.uri,pattern:V&&b(V)}});{const G=y.match(/\.[\/\\](.+)[\/\\]?/),V=G?G[1]:y,U=g.localize(0,null,V);throw new Error(U)}}}}o(y,w){const A=y.pattern&&w?`${y.pattern}/${w}`:y.pattern||w,N=[{searchPath:y.searchPath,pattern:A}];return A&&!A.endsWith("**")&&N.push({searchPath:y.searchPath,pattern:A+"/**"}),N}q(y,w,A){const N=this.r((0,i.$Ai)(y.searchPath),w,A,!1);return N?{...N,includePattern:y.pattern}:null}r(y,w,A,N){let G;const V=l.URI.isUri(y)?y:y.uri;if(A.searchPaths){const ne=A.searchPaths.filter(ae=>(0,k.$Lg)(ae.searchPath,V))[0];if(ne&&!ne.pattern)return null;ne&&(G=ne.pattern)}const U=this.a.getValue({resource:V}),L={...this.l(U,w)||{},...G||{}},q=l.URI.isUri(y)?(0,k.$Pg)(y):y.name;return{folder:V,folderName:N?q:void 0,excludePattern:Object.keys(L).length>0?L:void 0,fileEncoding:U.files&&U.files.encoding,disregardIgnoreFiles:typeof w.disregardIgnoreFiles=="boolean"?w.disregardIgnoreFiles:!U.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof w.disregardGlobalIgnoreFiles=="boolean"?w.disregardGlobalIgnoreFiles:!U.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof w.disregardParentIgnoreFiles=="boolean"?w.disregardParentIgnoreFiles:!U.search.useParentIgnoreFiles,ignoreSymlinks:typeof w.ignoreSymlinks=="boolean"?w.ignoreSymlinks:!U.search.followSymlinks}}};e.$JL=d,e.$JL=d=Ye([He(0,s.$Li),He(1,i.$oi),He(2,n.$nD),He(3,a.$zj),He(4,r.$HL)],d);function t(h){const y=h.match(/[\*\{\}\(\)\[\]\?]/);if(y){const w=y.index,A=h.substr(0,w).match(/[/|\\][^/\\]*$/);if(A){let N=h.substr(0,A.index);return N.match(/[/\\]/)||(N+="/"),{pathPortion:N,globPortion:h.substr((A.index||0)+1)}}}return{pathPortion:h}}function p(...h){return h.length?h.reduce((y,w)=>(y[w]=!0,y),Object.create(null)):void 0}function u(h){return P.$Wj(h,",").map(y=>y.trim()).filter(y=>!!y.length)}function o(h){return[`**/${h}/**`,`**/${h}`].map(w=>w.replace(/\*\*\/\*\*/g,"**"))}function v(h){return h.replace(/\\/g,"/")}function b(h){return v(h).replace(/^\.\//,"").replace(/\/+$/g,"")}function $(h){return h.replace(/([?*[\]])/g,"[$1]")}function I(h,y){h=S.$Mb(h,N=>N.toString());const w=[],A=y.getWorkspace();return h&&h.forEach(N=>{let G;if(y.getWorkbenchState()===2)G=(0,k.$Ug)(A.folders[0].uri,N),G&&G!=="."&&(G="./"+G);else{const V=y.getWorkspaceFolder(N);if(V){const U=V.name;if(A.folders.filter(L=>L.name===U).length===1){const L=(0,k.$Ug)(V.uri,N);L===""?G=`./${V.name}`:G=`./${V.name}/${L}`}else G=N.fsPath}}G&&w.push($(G))}),w}e.$KL=I}),define(Pe[289],Re([1,0,24,2,25,14,3,288,44,47,11]),function(me,e,S,M,P,F,R,m,f,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wub=e.$vub=void 0;const D=7e3;function l(a,i){const n=i.activationEvents;if(!n)return Promise.resolve(void 0);const r=[],c=[];for(const v of n)if(/^workspaceContains:/.test(v)){const b=v.substr(18);b.indexOf("*")>=0||b.indexOf("?")>=0||a.forceUsingSearch?c.push(b):r.push(b)}if(r.length===0&&c.length===0)return Promise.resolve(void 0);const{promise:d,resolve:t}=(0,O.$$g)(),p=v=>t({activationEvent:v}),u=Promise.all(r.map(v=>E(a,v,p))).then(()=>{}),o=g(a,i.identifier,c,p);return Promise.all([u,o]).then(()=>{t(void 0)}),d}e.$vub=l;async function E(a,i,n){for(const r of a.folders)if(await a.exists(S.$Sg(M.URI.revive(r),i))){n(`workspaceContains:${i}`);return}}async function g(a,i,n,r){if(n.length===0)return Promise.resolve(void 0);const c=new P.$ce,d=a.checkExists(a.folders,n,c.token),t=setTimeout(async()=>{c.cancel(),a.logService.info(`Not activating extension '${i.value}': Timed out while searching for 'workspaceContains' pattern ${n.join(",")}`)},D);let p=!1;try{p=await d}catch(u){F.$4(u)||F.$1(u)}c.dispose(),clearTimeout(t),p&&r(`workspaceContains:${n.join(",")}`)}function s(a,i,n,r){const c=a.get(R.$ei),d=a.get(f.$mK),p=c.createInstance(m.$JL).file(i.map(u=>(0,k.$Ai)(M.URI.revive(u))),{_reason:"checkExists",includePattern:n,exists:!0});return d.fileSearch(p,r).then(u=>!!u.limitHit,u=>F.$4(u)?!1:Promise.reject(u))}e.$wub=s}),define(Pe[38],Re([1,0,162,19,89,24,11,6,50,2,13,4,37,221,82,36,22,108,14,20,23,204,7,102,3,27,85,17,71,86,66,88,5,289,81,206,12,79,64,21,80]),function(me,e,S,M,P,F,R,m,f,k,O,D,l,E,g,s,a,i,n,r,c,d,t,p,u,o,v,b,$,I,h,y,w,A,N,G,V,U,C,L,q){"use strict";var ne;Object.defineProperty(e,"__esModule",{value:!0}),e.$Sic=e.$Ric=e.$Qic=e.$Pic=e.$Oic=void 0,e.$Oic=(0,u.$fi)("IHostUtils");let ae=ne=class extends m.$Tc{constructor(W,_,ke,Ne,De,be,ge,J,X,he,fe,Fe,de){super(),this.X=Fe,this.Y=de,this.a=this.B(new w.$5d),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=_,this.g=ke,this.f=ge,this.j=Ne,this.m=De,this.s=be,this.t=X,this.u=he,this.w=fe,this.y=this.g.getProxy(D.$6L.MainThreadWorkspace),this.z=this.g.getProxy(D.$6L.MainThreadTelemetry),this.C=this.g.getProxy(D.$6L.MainThreadExtensionService),this.D=new R.$eh,this.F=new R.$eh,this.G=new R.$eh,this.H=new R.$eh,this.I=new ie(this.f.extensions.activationEvents),this.L=new i.$O9b(this.I,this.f.extensions.allExtensions);const Ce=new r.$Am(this.f.extensions.myExtensions);this.J=new i.$O9b(this.I,re(this.L,Ce)),L.$t&&(this.s.info(`Creating extension host with the following global extensions: ${ue(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${ue(this.J)}`)),this.M=new g.$zic(this.g,this.s),this.N=new N.$Hic(this.g),this.O=J,this.h=W.createChild(new $.$di([g.$Aic,this.M],[N.$Iic,this.N])),this.P=this.B(new E.$yic(this.J,this.L,{onExtensionActivationError:(Ae,je,z)=>{this.C.$onExtensionActivationError(Ae,n.$3(je),z)},actualActivateExtension:async(Ae,je)=>{if(i.$O9b.isHostExtension(Ae,this.J,this.L))return await this.C.$activateExtension(Ae,je),new E.$xic;const z=this.J.getExtensionDescription(Ae);return this.eb(z,je)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.ub(),this.D.open(),await this.j.waitForInitializeCall(),P.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.sb()}catch(W){n.$1(W)}}async Z(){this.O.onWillDeactivateAll();let W=[];try{W=this.J.getAllExtensionDescriptions().map(De=>De.identifier).filter(De=>this.isActivated(De)).map(De=>this.db(De))}catch{}await Promise.all(W)}terminate(W,_=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${W}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(Ne=>{this.s.error(Ne)}),this.g.dispose();const ke=this.Z();Promise.race([(0,R.$gh)(5e3),ke]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${_}`):this.s.info(`Extension host exiting with code ${_}`),this.s.flush(),this.s.dispose(),this.c.exit(_)})}isActivated(W){return this.G.isOpen()?this.P.isActivated(W):!1}async getExtension(W){const _=await this.C.$getExtension(W);return _&&{..._,identifier:new r.$zm(_.identifier.value),extensionLocation:k.URI.revive(_.extensionLocation)}}$(W,_){return this.P.activateByEvent(W,_)}ab(W,_){return this.P.activateById(W,_)}activateByIdWithErrors(W,_){return this.ab(W,_).then(()=>{const ke=this.P.getActivatedExtension(W);if(ke.activationFailed)return Promise.reject(ke.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(W=>this.J)}getExtensionExports(W){if(this.G.isOpen())return this.P.getActivatedExtension(W).exports;try{return this.P.getActivatedExtension(W).exports}catch{return null}}async bb(W){if(W.scheme===V.Schemas.file&&this.c.fsRealpath){const _=await this.c.fsRealpath(W.fsPath);return k.URI.file(_)}return W}async getExtensionPathIndex(){return this.Q||(this.Q=this.cb(this.J.getAllExtensionDescriptions()).then(W=>new $e(W))),this.Q}async cb(W){const _=f.$li.forUris(ke=>F.$Jg.ignorePathCasing(ke));return await Promise.all(W.map(async ke=>{if(this.vb(ke)){const Ne=await this.bb(ke.extensionLocation);_.set(Ne,ke)}})),_}db(W){let _=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(W))return _;const ke=this.P.getActivatedExtension(W);if(!ke)return _;try{typeof ke.module.deactivate=="function"&&(_=Promise.resolve(ke.module.deactivate()).then(void 0,Ne=>(this.s.error(Ne),Promise.resolve(void 0))))}catch(Ne){this.s.error(`An error occurred when deactivating the extension '${W.value}':`),this.s.error(Ne)}try{(0,m.$Oc)(ke.subscriptions)}catch(Ne){this.s.error(`An error occurred when deactivating the subscriptions for extension '${W.value}':`),this.s.error(Ne)}return _}async eb(W,_){return this.f.remote.isRemote?this.C.$onWillActivateExtension(W.identifier):await this.C.$onWillActivateExtension(W.identifier),this.gb(W,_).then(ke=>{const Ne=ke.activationTimes;return this.C.$onDidActivateExtension(W.identifier,Ne.codeLoadingTime,Ne.activateCallTime,Ne.activateResolvedTime,_),this.fb(W,_,"success",Ne),ke},ke=>{throw this.fb(W,_,"failure"),ke})}fb(W,_,ke,Ne){const De=Ie(W,_);this.z.$publicLog2("extensionActivationTimes",{...De,...Ne||{},outcome:ke})}gb(W,_){const ke=Ie(W,_);this.z.$publicLog2("activatePlugin",ke);const Ne=this.vb(W);if(!Ne)return Promise.resolve(new E.$wic(E.$tic.NONE));this.s.info(`ExtensionService#_doActivateExtension ${W.identifier.value}, startup: ${_.startup}, activationEvent: '${_.activationEvent}'${W.identifier.value!==_.extensionId.value?`, root cause: ${_.extensionId.value}`:""}`),this.s.flush();const De=new E.$uic(_.startup);return Promise.all([this.wb(W,(0,F.$Sg)(W.extensionLocation,Ne),De),this.hb(W)]).then(be=>(P.mark(`code/extHost/willActivateExtension/${W.identifier.value}`),ne.ib(this.s,W.identifier,be[0],be[1],De))).then(be=>(P.mark(`code/extHost/didActivateExtension/${W.identifier.value}`),be))}hb(W){const _=this.Y.createLanguageModelAccessInformation(W),ke=new d.$Cic(W,this.M),Ne=new d.$Bic(W.identifier.value,!1,this.M),De=new G.$Jic(W,this.N),be=W.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ge=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${W.identifier.value}`),Promise.all([ke.whenReady,Ne.whenReady,this.O.whenReady]).then(()=>{const J=this;let X,he;const fe=(0,a.$XF)(W,"ipc")?this.f.messagePorts?.get(r.$zm.toKey(W.identifier)):void 0;return Object.freeze({globalState:ke,workspaceState:Ne,secrets:De,subscriptions:[],get languageModelAccessInformation(){return _},get extensionUri(){return W.extensionLocation},get extensionPath(){return W.extensionLocation.fsPath},asAbsolutePath(Fe){return M.$jc(W.extensionLocation.fsPath,Fe)},get storagePath(){return J.O.workspaceValue(W)?.fsPath},get globalStoragePath(){return J.O.globalValue(W).fsPath},get logPath(){return M.$jc(J.f.logsLocation.fsPath,W.identifier.value)},get logUri(){return k.URI.joinPath(J.f.logsLocation,W.identifier.value)},get storageUri(){return J.O.workspaceValue(W)},get globalStorageUri(){return J.O.globalValue(W)},get extensionMode(){return be},get extension(){return X===void 0&&(X=new ve(J,W.identifier,W,ge,!1)),X},get extensionRuntime(){return(0,a.$YF)(W,"extensionRuntime"),J.extensionRuntime},get environmentVariableCollection(){return J.u.getEnvironmentVariableCollection(W)},get messagePassingProtocol(){if(!he){if(!fe)return;const Fe=w.Event.buffer(w.Event.fromDOMEventEmitter(fe,"message",de=>de.data));fe.start(),he={onDidReceiveMessage:Fe,postMessage:fe.postMessage.bind(fe)}}return he}})})}static ib(W,_,ke,Ne,De){return ke=ke||{activate:void 0,deactivate:void 0},this.jb(W,_,ke,Ne,De).then(be=>new E.$vic(!1,null,De.build(),ke,be,Ne.subscriptions))}static jb(W,_,ke,Ne,De){if(typeof ke.activate=="function")try{De.activateCallStart(),W.trace(`ExtensionService#_callActivateOptional ${_.value}`);const be=typeof global=="object"?global:self,ge=ke.activate.apply(be,[Ne]);return De.activateCallStop(),De.activateResolveStart(),Promise.resolve(ge).then(J=>(De.activateResolveStop(),J))}catch(be){return Promise.reject(be)}else return Promise.resolve(ke)}kb(W,_){this.ab(W.identifier,{startup:!1,extensionId:W.identifier,activationEvent:_}).then(void 0,ke=>{this.s.error(ke)})}lb(W,_=0){const Ne=Date.now();(0,L.$B)(()=>{for(let De=_;De<W.length;De+=1){const be=W[De];for(const ge of be.activationEvents??[])if(ge==="onStartupFinished")if(Date.now()-Ne>50){this.lb(W,De);break}else this.kb(be,ge)}})}mb(){this.C.$setPerformanceMarks(P.getMarks()),this.m.getConfigProvider().then(W=>{const _=W.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ke=this.J.getAllExtensionDescriptions();if(_)this.lb(ke);else for(const Ne of ke)if(Ne.activationEvents)for(const De of Ne.activationEvents)De==="onStartupFinished"&&this.kb(Ne,De)})}nb(){const W=this.$("*",!0).then(void 0,be=>{this.s.error(be)});this.B(this.j.onDidChangeWorkspace(be=>this.ob(be.added)));const _=this.j.workspace?this.j.workspace.folders:[],ke=this.ob(_),Ne=this.qb(),De=Promise.all([Ne,W,ke]).then(()=>{});return Promise.race([De,(0,R.$gh)(1e4)]).then(()=>{this.mb()}),De}ob(W){return W.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(_=>this.pb(W,_))).then(()=>{})}async pb(W,_){if(this.isActivated(_.identifier))return;const ke=!this.f.remote.isRemote&&!!this.f.remote.authority,Ne={logService:this.s,folders:W.map(be=>be.uri),forceUsingSearch:ke||!this.c.fsExists,exists:be=>this.c.fsExists(be.fsPath),checkExists:(be,ge,J)=>this.y.$checkExists(be,ge,J)},De=await(0,A.$vub)(Ne,_);if(De)return this.ab(_.identifier,{startup:!0,extensionId:_.identifier,activationEvent:De.activationEvent}).then(void 0,be=>this.s.error(be))}async qb(){if(this.f.remote.authority)return this.$(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.rb()}catch(W){throw console.error(W),W}}async rb(){const{extensionDevelopmentLocationURI:W,extensionTestsLocationURI:_}=this.f.environment;if(!W||!_)throw new Error(S.localize(0,null));const ke=await this.wb(null,_,new E.$uic(!1));if(!ke||typeof ke.run!="function")throw new Error(S.localize(1,null,_.toString()));return new Promise((Ne,De)=>{const be=(X,he)=>{X?(L.$t&&this.s.error("Test runner called back with error",X),De(X)):(L.$t&&(he?this.s.info(`Test runner called back with ${he} failures.`):this.s.info("Test runner called back with successful outcome.")),Ne(typeof he=="number"&&he>0?1:0))},ge=(0,F.$Gg)(_),J=ke.run(ge,be);J&&J.then&&J.then(()=>{L.$t&&this.s.info("Test runner finished successfully."),Ne(0)}).catch(X=>{L.$t&&this.s.error("Test runner finished with error",X),De(X instanceof Error&&X.stack?X.stack:String(X))})})}sb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$gh)(1e3)])).then(()=>this.nb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(W,_){return this.R[W]=_,(0,m.$Rc)(()=>{delete this.R[W]})}async getRemoteExecServer(W){const{resolver:_}=await this.tb(W);return _?.resolveExecServer?.(W,{resolveAttempt:0})}async tb(W){const _=W.indexOf("+");if(_===-1)throw new t.$bM("Not an authority that can be resolved!",p.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ke=W.substr(0,_);return await this.D.wait(),await this.$(`onResolveRemoteAuthority:${ke}`,!1),{authorityPrefix:ke,resolver:this.R[ke]}}async $resolveAuthority(W,_){const ke=C.$1d.create(!1),Ne=()=>`[resolveAuthority(${(0,p.$ol)(W)},${_})][${ke.elapsed()}ms] `,De=j=>this.s.info(`${Ne()}${j}`),be=j=>this.s.warn(`${Ne()}${j}`),ge=(j,K=void 0)=>this.s.error(`${Ne()}${j}`,K),J=j=>{if(j instanceof t.$bM)return{type:"error",error:{code:j._code,message:j._message,detail:j._detail}};throw j},X=async j=>{De(`activating resolver for ${j}...`);const{resolver:K,authorityPrefix:H}=await this.tb(j);if(!K)throw ge(`no resolver for ${H}`),new t.$bM(`No remote extension installed to resolve ${H}.`,p.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:K,authorityPrefix:H,remoteAuthority:j}},he=W.split(/@|%40/g).reverse();De(`activating remote resolvers ${he.join(" -> ")}`);let fe;try{fe=await Promise.all(he.map(X)).catch(async j=>{if(!(j instanceof t.$bM)||j._code!==p.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw j;return be(`resolving nested authorities failed: ${j.message}`),[await X(W)]})}catch(j){return J(j)}const Fe=new R.$qh;Fe.cancelAndSet(()=>De("waiting..."),1e3);let de,Ce;for(const[j,{authorityPrefix:K,resolver:H,remoteAuthority:ee}]of fe.entries())try{if(j===fe.length-1)De("invoking final resolve()..."),P.mark(`code/extHost/willResolveAuthority/${K}`),de=await H.resolve(ee,{resolveAttempt:_,execServer:Ce}),P.mark(`code/extHost/didResolveAuthorityOK/${K}`),De("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(H,t.$aM.isManagedResolvedAuthority(de)?de:void 0));else{if(De(`invoking resolveExecServer() for ${ee}`),P.mark(`code/extHost/willResolveExecServer/${K}`),Ce=await H.resolveExecServer?.(ee,{resolveAttempt:_,execServer:Ce}),!Ce)throw new t.$bM(`Exec server was not available for ${ee}`,p.RemoteAuthorityResolverErrorCode.NoResolverFound);P.mark(`code/extHost/didResolveExecServerOK/${K}`)}}catch(se){return P.mark(`code/extHost/didResolveAuthorityError/${K}`),ge("returned an error",se),Fe.dispose(),J(se)}Fe.dispose();const Ae={environmentTunnels:de.environmentTunnels,features:de.tunnelFeatures?{elevation:de.tunnelFeatures.elevation,privacyOptions:de.tunnelFeatures.privacyOptions,protocol:de.tunnelFeatures.protocol===void 0?!0:de.tunnelFeatures.protocol}:void 0},je={extensionHostEnv:de.extensionHostEnv,isTrusted:de.isTrusted,authenticationSession:de.authenticationSessionForInitializingExtensions?{id:de.authenticationSessionForInitializingExtensions.id,providerId:de.authenticationSessionForInitializingExtensions.providerId}:void 0};De(`returned ${t.$aM.isManagedResolvedAuthority(de)?"managed authority":`${de.host}:${de.port}`}`);let z;if(t.$aM.isManagedResolvedAuthority(de)){const j=_;this.X.setFactory(j,de.makeConnection),z={authority:W,connectTo:new p.$ll(j),connectionToken:de.connectionToken}}else z={authority:W,connectTo:new p.$ml(de.host,de.port),connectionToken:de.connectionToken};return{type:"ok",value:{authority:z,options:je,tunnelInformation:Ae}}}async $getCanonicalURI(W,_){this.s.info(`$getCanonicalURI invoked for authority (${(0,p.$ol)(W)})`);const{resolver:ke}=await this.tb(W);if(!ke)return null;const Ne=k.URI.revive(_);if(typeof ke.getCanonicalURI>"u")return Ne;const De=await(0,R.$0g)(()=>ke.getCanonicalURI(Ne));return De||Ne}$startExtensionHost(W){W.toAdd.forEach(Ne=>Ne.extensionLocation=k.URI.revive(Ne.extensionLocation));const{globalRegistry:_,myExtensions:ke}=ye(this.I,this.L,this.J,W);return this.L.set(_.getAllExtensionDescriptions()),this.J.set(ke),L.$t&&(this.s.info(`$startExtensionHost: global extensions: ${ue(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${ue(this.J)}`)),this.sb()}$activateByEvent(W,_){return _===1?this.D.wait().then(ke=>this.$(W,!1)):this.G.wait().then(ke=>this.$(W,!1))}async $activate(W,_){return await this.G.wait(),this.J.getExtensionDescription(W)?(await this.ab(W,_),!0):!1}async $deltaExtensions(W){W.toAdd.forEach(be=>be.extensionLocation=k.URI.revive(be.extensionLocation));const{globalRegistry:_,myExtensions:ke}=ye(this.I,this.L,this.J,W),Ne=await this.cb(ke);return(await this.getExtensionPathIndex()).setSearchTree(Ne),this.L.set(_.getAllExtensionDescriptions()),this.J.set(ke),L.$t&&(this.s.info(`$deltaExtensions: global extensions: ${ue(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${ue(this.J)}`)),Promise.resolve(void 0)}async $test_latency(W){return W}async $test_up(W){return W.byteLength}async $test_down(W){const _=c.$se.alloc(W),ke=Math.random()%256;for(let Ne=0;Ne<W;Ne++)_.writeUInt8(ke,Ne);return _}async $updateRemoteConnectionData(W){this.W=W,this.a.fire()}};e.$Pic=ae,e.$Pic=ae=ne=Ye([He(0,u.$ei),He(1,e.$Oic),He(2,b.$lO),He(3,s.$cic),He(4,l.$fic),He(5,O.$zj),He(6,o.$BO),He(7,v.$iic),He(8,I.$zAb),He(9,h.$Dic),He(10,U.$Lic),He(11,q.$Mic),He(12,y.$5hc)],ae);function ye(le,W,_,ke){le.addActivationEvents(ke.addActivationEvents);const Ne=new i.$O9b(le,W.getAllExtensionDescriptions());Ne.deltaExtensions(ke.toAdd,ke.toRemove);const De=new r.$Am(_.getAllExtensionDescriptions().map(ge=>ge.identifier));for(const ge of ke.myToRemove)De.delete(ge);for(const ge of ke.myToAdd)De.add(ge);const be=re(Ne,De);return{globalRegistry:Ne,myExtensions:be}}function Ie(le,W){return{id:le.identifier.value,name:le.name,extensionVersion:le.version,publisherDisplayName:le.publisher,activationEvents:le.activationEvents?le.activationEvents.join(","):null,isBuiltin:le.isBuiltin,reason:W.activationEvent,reasonId:W.extensionId.value}}function ue(le){return le.getAllExtensionDescriptions().map(W=>W.identifier.value).join(",")}e.$Qic=(0,u.$fi)("IExtHostExtensionService");class ve{#e;#t;#i;constructor(W,_,ke,Ne,De){this.#e=W,this.#t=_,this.#i=ke.identifier,this.id=ke.identifier.value,this.extensionUri=ke.extensionLocation,this.extensionPath=M.$hc((0,F.$Gg)(ke.extensionLocation)),this.packageJSON=ke,this.extensionKind=Ne,this.isFromDifferentExtensionHost=De}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Ric=ve;function re(le,W){return le.getAllExtensionDescriptions().filter(_=>W.has(_.identifier))}class $e{constructor(W){this.a=W}setSearchTree(W){this.a=W}findSubstr(W){return this.a.findSubstr(W)}forEach(W){return this.a.forEach(W)}}e.$Sic=$e;class ie{constructor(W){this.a=new r.$Bm,this.addActivationEvents(W)}readActivationEvents(W){return this.a.get(W.identifier)??[]}addActivationEvents(W){for(const _ of Object.keys(W))this.a.set(_,W[_])}}}),define(Pe[290],Re([1,0,89,2,4,37,22,20,17,27,3,38,13,15]),function(me,e,S,M,P,F,R,m,f,k,O,D,l,E){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$1jc=void 0;let s=class{constructor(c,d,t,p,u,o,v){this.c=c,this.d=d,this.e=t,this.f=p,this.g=u,this.h=o,this.i=v,this.a=new Map,this.b=[]}async install(){this.j(),S.mark("code/extHost/willWaitForConfig");const c=await this.f.getConfigProvider();S.mark("code/extHost/didWaitForConfig");const d=await this.g.getExtensionPathIndex();this.register(new i(this.c,d,this.d,c,this.i)),this.register(this.e.createInstance(a)),this.h.remote.isRemote&&this.register(this.e.createInstance(n,d,this.h.environment.appUriScheme))}register(c){if("nodeModuleName"in c)if(Array.isArray(c.nodeModuleName))for(const d of c.nodeModuleName)this.a.set(d,c);else this.a.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this.b.push(d=>c.alternativeModuleName(d))}};e.$1jc=s,e.$1jc=s=Ye([He(2,O.$ei),He(3,F.$fic),He(4,D.$Qic),He(5,k.$BO),He(6,l.$zj)],s);let a=class{static{g=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(c){if(c.environment.appRoot&&g.a.size){const d=(0,E.$Xe)(this.c(c.environment.appRoot.fsPath)),t="[a-z0-9_.-]",p=`@${t}+\\/${t}+|${t}+`,u="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${d}/${u}\\/)(${p})(.*)$`,"i")}}alternativeModuleName(c){if(!this.b)return;const d=this.b.exec(this.c(c));if(!d)return;const[,t,p,u]=d,o=g.a.get(p);if(o!==void 0)return console.warn(`${p} as been renamed to ${o}, please update your imports`),t+o+u}c(c){return c.replace(/\\/g,"/")}};a=g=Ye([He(0,k.$BO)],a);class i{constructor(c,d,t,p,u){this.c=c,this.d=d,this.e=t,this.f=p,this.g=u,this.nodeModuleName="vscode",this.a=new m.$Bm}load(c,d){const t=this.d.findSubstr(d);if(t){let p=this.a.get(t.identifier);return p||(p=this.c(t,this.e,this.f),this.a.set(t.identifier,p)),p}if(!this.b){let p="";this.d.forEach((u,o)=>p+=`	${o} -> ${u.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${d}. These are the extension path mappings: 
${p}`),this.b=this.c(R.$SF,this.e,this.f)}return this.b}}let n=class{constructor(c,d,t){this.e=c,this.f=d,this.nodeModuleName=["open","opn"],this.d=t.getProxy(P.$6L.MainThreadTelemetry);const p=t.getProxy(P.$6L.MainThreadWindow);this.c=(u,o)=>{const v=M.URI.parse(u);return o?this.g(u,o):v.scheme==="http"||v.scheme==="https"?p.$openUri(v,u,{allowTunneling:!0}):v.scheme==="mailto"||v.scheme===this.f?p.$openUri(v,u,{}):this.g(u,o)}}load(c,d,t){const p=this.e.findSubstr(d);return p&&(this.a=p.identifier.value,this.h()),this.b=t(c),this.c}g(c,d){return this.i(),this.b(c,d)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=Ye([He(2,f.$lO)],n)}),define(Pe[119],Re([1,0,39,6,19,73,3,67,65,38,7,36,218,37]),function(me,e,S,M,P,F,R,m,f,k,O,D,l,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uic=e.$Tic=void 0,e.$Tic=(0,R.$fi)("IExtHostVariableResolverProvider");class g extends l.$mP{constructor(i,n,r,c,d,t,p){function u(){if(r){const o=r.activeEditor();if(o)return o.document.uri;const v=c.tabGroups.all.find(b=>b.isActive)?.activeTab;if(v!==void 0){if(v.input instanceof O.$QN||v.input instanceof O.$VN)return v.input.modified;if(v.input instanceof O.$PN||v.input instanceof O.$UN||v.input instanceof O.$SN)return v.input.uri}}}super({getFolderUri:o=>{const v=t.folders.filter(b=>b.name===o);if(v&&v.length>0)return v[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(o,v)=>d.getConfiguration(void 0,o).get(v),getAppRoot:()=>F.cwd(),getExecPath:()=>F.env.VSCODE_EXEC_PATH,getFilePath:()=>{const o=u();if(o)return P.$hc(o.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const o=u();if(o){const v=n.getWorkspaceFolder(o);if(v)return P.$hc(v.uri.fsPath)}}},getSelectedText:()=>{if(r){const o=r.activeEditor();if(o&&!o.selection.isEmpty)return o.document.getText(o.selection)}},getLineNumber:()=>{if(r){const o=r.activeEditor();if(o)return String(o.selection.end.line+1)}},getExtension:o=>i.getExtension(o)},void 0,p?Promise.resolve(p):void 0,Promise.resolve(F.env))}}let s=class extends M.$Tc{constructor(i,n,r,c,d){super(),this.b=i,this.c=n,this.g=r,this.h=c,this.j=d,this.a=new S.$V(async()=>{const t=await this.h.getConfigProvider(),u={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async o=>{u.folders=await this.c.getWorkspaceFolders2()||[]})),new g(this.b,this.c,this.g,this.j,t,u,this.m())})}getResolver(){return this.a.value}m(){}};e.$Uic=s,e.$Uic=s=Ye([He(0,k.$Qic),He(1,D.$cic),He(2,m.$wO),He(3,E.$fic),He(4,f.$ric)],s)}),define(Pe[120],Re([1,0,11,5,2,20,3,4,65,38,17,7,36,210,212,37,119,6,40,31,8]),function(me,e,S,M,P,F,R,m,f,k,O,D,l,E,g,s,a,i,n,r,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zic=e.$Yic=e.$Xic=e.$Wic=e.$Vic=void 0,e.$Vic=(0,R.$fi)("IExtHostDebugService");let d=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor($,I,h,y,w,A,N){this.N=I,this.O=h,this.P=y,this.Q=w,this.R=A,this.S=N,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new M.$5d,this.o=new M.$5d,this.q=new M.$5d,this.w=new M.$5d,this.l=$.getProxy(m.$6L.MainThreadDebugService),this.A=new M.$5d,this.C=new M.$5d,this.y=new p(this.l),this.z=new Map,this.O.getExtensionRegistry().then(G=>{G.onDidChange(V=>{this.V(G)}),this.V(G)})}async $getVisualizerTreeItem($,I){const h=this.W(I);if(!h)return;const y=await this.H.get($)?.getTreeItem?.(h);return y?this.U($,y):void 0}registerDebugVisualizationTree($,I,h){const y=F.$zm.toKey($.identifier),w=this.jb(y,I);if(this.G.has(w))throw new Error(`A debug visualization provider with id '${I}' is already registered`);return this.H.set(w,h),this.l.$registerDebugVisualizerTree(w,!!h.editItem),(0,i.$Rc)(()=>{this.l.$unregisterDebugVisualizerTree(w),this.H.delete(I)})}async $getVisualizerTreeItemChildren($,I){const h=this.J.get(I)?.item;return h?(await this.H.get($)?.getChildren?.(h))?.map(w=>this.U($,w))||[]:[]}async $editVisualizerTreeItem($,I){const h=this.J.get($);if(!h)return;const y=await this.H.get(h.provider)?.editItem?.(h.item,I);return this.U(h.provider,y||h.item)}$disposeVisualizedTree($){const I=this.J.get($);if(!I)return;const h=[I.children];for(const y of h)if(y)for(const w of y)h.push(this.J.get(w)?.children),this.J.delete(w)}U($,I){let h=this.I.get(I);return h||(h=this.F++,this.I.set(I,h),this.J.set(h,{provider:$,item:I})),c.DebugTreeItem.from(I,h)}asDebugSourceUri($,I){const h=$;if(typeof h.sourceReference=="number"&&h.sourceReference>0){let y=`debug:${encodeURIComponent(h.path||"")}`,w="?";return I&&(y+=`${w}session=${encodeURIComponent(I.id)}`,w="&"),y+=`${w}ref=${h.sourceReference}`,P.URI.parse(y)}else{if(h.path)return P.URI.file(h.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V($){const I=[];for(const h of $.getAllExtensionDescriptions())if(h.contributes){const y=h.contributes.debuggers;if(y&&y.length>0)for(const w of y)(0,g.$wG)(w)&&I.push(w.type)}this.l.$registerDebugTypes(I)}get stackFrameFocus(){return this.B}get onDidChangeStackFrameFocus(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const $=[];return this.z.forEach(I=>$.push(I)),$}async $resolveDebugVisualizer($,I){const h=this.L.get($);if(!h)throw new Error(`No debug visualizer found with id '${$}'`);let{v:y,provider:w,extensionId:A}=h;if(y.visualization||(y=await w.resolveDebugVisualization?.(y,I)||y,h.v=y),!y.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${w}'`);return this.kb(A,y.visualization)}async $executeDebugVisualizerCommand($){const I=this.L.get($);if(!I)throw new Error(`No debug visualizer found with id '${$}'`);const h=I.v.visualization;h&&"command"in h&&this.S.executeCommand(h.command,...h.arguments||[])}W($){const I=this.m.get($.sessionId);return I&&{session:I.api,variable:$.variable,containerId:$.containerId,frameId:$.frameId,threadId:$.threadId}}async $provideDebugVisualizers($,I,h,y){const w=this.W(h),A=this.jb($,I),N=this.G.get(A);if(!w||!N)return[];const G=await N.provideDebugVisualization(w,y);return G?G.map(V=>{const U=++this.M;this.L.set(U,{v:V,provider:N,extensionId:$});const C=V.iconPath?this.lb(V.iconPath):void 0;return{id:U,name:V.name,iconClass:C?.iconClass,iconPath:C?.iconPath,visualization:this.kb($,V.visualization)}}):[]}$disposeDebugVisualizers($){for(const I of $)this.L.delete(I)}registerDebugVisualizationProvider($,I,h){if(!$.contributes?.debugVisualizers?.some(A=>A.id===I))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${I})`);const y=F.$zm.toKey($.identifier),w=this.jb(y,I);if(this.G.has(w))throw new Error(`A debug visualization provider with id '${I}' is already registered`);return this.G.set(w,h),this.l.$registerDebugVisualizer(y,I),(0,i.$Rc)(()=>{this.l.$unregisterDebugVisualizer(y,I),this.G.delete(I)})}addBreakpoints($){const I=$.filter(w=>{const A=w.id;return this.z.has(A)?!1:(this.z.set(A,w),!0)});this.gb(I,[],[]);const h=[],y=new Map;for(const w of I)if(w instanceof D.$8M){let A=y.get(w.location.uri.toString());A||(A={type:"sourceMulti",uri:w.location.uri,lines:[]},y.set(w.location.uri.toString(),A),h.push(A)),A.lines.push({id:w.id,enabled:w.enabled,condition:w.condition,hitCondition:w.hitCondition,logMessage:w.logMessage,line:w.location.range.start.line,character:w.location.range.start.character,mode:w.mode})}else w instanceof D.$9M&&h.push({type:"function",id:w.id,enabled:w.enabled,hitCondition:w.hitCondition,logMessage:w.logMessage,condition:w.condition,functionName:w.functionName,mode:w.mode});return this.l.$registerBreakpoints(h)}removeBreakpoints($){const I=$.filter(A=>this.z.delete(A.id));this.gb([],I,[]);const h=I.filter(A=>A instanceof D.$8M).map(A=>A.id),y=I.filter(A=>A instanceof D.$9M).map(A=>A.id),w=I.filter(A=>A instanceof D.$0M).map(A=>A.id);return this.l.$unregisterBreakpoints(h,y,w)}startDebugging($,I,h){return this.l.$startDebugging($?$.uri:void 0,I,{parentSessionID:h.parentSession?h.parentSession.id:void 0,lifecycleManagedByParent:h.lifecycleManagedByParent,repl:h.consoleMode===D.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:h.noDebug,compact:h.compact,suppressSaveBeforeStart:h.suppressSaveBeforeStart,suppressDebugStatusbar:h.suppressDebugStatusbar??h.debugUI?.simple,suppressDebugToolbar:h.suppressDebugToolbar??h.debugUI?.simple,suppressDebugView:h.suppressDebugView??h.debugUI?.simple})}stopDebugging($){return this.l.$stopDebugging($?$.id:void 0)}registerDebugConfigurationProvider($,I,h){if(!I)return new D.$8L(()=>{});const y=this.d++;return this.f.push({type:$,handle:y,provider:I}),this.l.$registerDebugConfigurationProvider($,h,!!I.provideDebugConfigurations,!!I.resolveDebugConfiguration,!!I.resolveDebugConfigurationWithSubstitutedVariables,y),new D.$8L(()=>{this.f=this.f.filter(w=>w.provider!==I),this.l.$unregisterDebugConfigurationProvider(y)})}registerDebugAdapterDescriptorFactory($,I,h){if(!h)return new D.$8L(()=>{});if(!this.cb($,I))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${I}' debugger.`);if(this.$(I))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const y=this.g++;return this.h.push({type:I,handle:y,factory:h}),this.l.$registerDebugAdapterDescriptorFactory(I,y),new D.$8L(()=>{this.h=this.h.filter(w=>w.factory!==h),this.l.$unregisterDebugAdapterDescriptorFactory(y)})}registerDebugAdapterTrackerFactory($,I){if(!I)return new D.$8L(()=>{});const h=this.j++;return this.k.push({type:$,handle:h,factory:I}),new D.$8L(()=>{this.k=this.k.filter(y=>y.factory!==I)})}async $runInTerminal($,I){return Promise.resolve(void 0)}async $substituteVariables($,I){let h;const y=await this.ib($);return y&&(h={uri:y.uri,name:y.name,index:y.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(h,I)}X($,I){if($.type==="implementation")return new o($.implementation)}Y(){}async $startDASession($,I){const h=this,y=await this.hb(I);return this.eb(this.$(y.type),y).then(w=>{if(!w)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${y.type}' (extension might have failed to activate)`);const A=this.Z(w),N=this.X(A,y);if(!N)throw new Error(`Couldn't create a debug adapter for type '${y.type}'.`);const G=N;return this.D.set($,G),this.db(y).then(V=>(V&&this.E.set($,V),G.onMessage(async U=>{if(U.type==="request"&&U.command==="handshake"){const C=U,L={type:"response",seq:0,command:C.command,request_seq:C.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const q=await this.K.sign(C.arguments.value);L.body={signature:q},G.sendResponse(L)}else throw new Error("no signer")}catch(q){L.success=!1,L.message=q.message,G.sendResponse(L)}}else V&&V.onDidSendMessage&&V.onDidSendMessage(U),U=(0,g.$BG)(U,!0),h.l.$acceptDAMessage($,U)}),G.onError(U=>{V&&V.onError&&V.onError(U),this.l.$acceptDAError($,U.name,U.message,U.stack)}),G.onExit(U=>{V&&V.onExit&&V.onExit(U??void 0,void 0),this.l.$acceptDAExit($,U??void 0,void 0)}),V&&V.onWillStartSession&&V.onWillStartSession(),G.startSession()))})}$sendDAMessage($,I){I=(0,g.$AG)(I,!1);const h=this.E.get($);h&&h.onWillReceiveMessage&&h.onWillReceiveMessage(I),this.D.get($)?.sendMessage(I)}$stopDASession($){const I=this.E.get($);this.E.delete($),I&&I.onWillStopSession&&I.onWillStopSession();const h=this.D.get($);return this.D.delete($),h?h.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta($){const I=[],h=[],y=[];if($.added)for(const w of $.added){const A=w.id;if(A&&!this.z.has(A)){let N;if(w.type==="function")N=new D.$9M(w.functionName,w.enabled,w.condition,w.hitCondition,w.logMessage,w.mode);else if(w.type==="data")N=new D.$0M(w.label,w.dataId,w.canPersist,w.enabled,w.hitCondition,w.condition,w.logMessage,w.mode);else{const G=P.URI.revive(w.uri);N=new D.$8M(new D.$hM(G,new D.$9L(w.line,w.character)),w.enabled,w.condition,w.hitCondition,w.logMessage,w.mode)}(0,D.$6M)(N,A),this.z.set(A,N),I.push(N)}}if($.removed)for(const w of $.removed){const A=this.z.get(w);A&&(this.z.delete(w),h.push(A))}if($.changed){for(const w of $.changed)if(w.id){const A=this.z.get(w.id);if(A){if(A instanceof D.$9M&&w.type==="function"){const N=A;N.enabled=w.enabled,N.condition=w.condition,N.hitCondition=w.hitCondition,N.logMessage=w.logMessage,N.functionName=w.functionName}else if(A instanceof D.$8M&&w.type==="source"){const N=A;N.enabled=w.enabled,N.condition=w.condition,N.hitCondition=w.hitCondition,N.logMessage=w.logMessage,N.location=new D.$hM(P.URI.revive(w.uri),new D.$9L(w.line,w.character))}y.push(A)}}}this.gb(I,h,y)}async $acceptStackFrameFocus($){let I;const h=$.sessionId?await this.hb($.sessionId):void 0;if(!h)throw new Error("no DebugSession found for debug focus context");$.kind==="thread"?I=new D.$dN(h.api,$.threadId):I=new D.$cN(h.api,$.threadId,$.frameId),this.B=I,this.C.fire(this.B)}$provideDebugConfigurations($,I,h){return(0,S.$0g)(async()=>{const y=this.bb($);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const w=await this.ib(I);return y.provideDebugConfigurations(w,h)}).then(y=>{if(!y)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return y})}$resolveDebugConfiguration($,I,h,y){return(0,S.$0g)(async()=>{const w=this.bb($);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const A=await this.ib(I);return w.resolveDebugConfiguration(A,h,y)})}$resolveDebugConfigurationWithSubstitutedVariables($,I,h,y){return(0,S.$0g)(async()=>{const w=this.bb($);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const A=await this.ib(I);return w.resolveDebugConfigurationWithSubstitutedVariables(A,h,y)})}async $provideDebugAdapter($,I){const h=this.ab($);if(!h)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const y=await this.hb(I);return this.eb(h,y).then(w=>{if(!w)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${y.type}'`);return this.Z(w)})}async $acceptDebugSessionStarted($){const I=await this.hb($);this.n.fire(I.api)}async $acceptDebugSessionTerminated($){const I=await this.hb($);I&&(this.o.fire(I.api),this.m.delete(I.id))}async $acceptDebugSessionActiveChanged($){this.u=$?await this.hb($):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged($,I){(await this.hb($))?._acceptNameChanged(I)}async $acceptDebugSessionCustomEvent($,I){const y={session:(await this.hb($)).api,event:I.event,body:I.body};this.w.fire(y)}Z($){if($ instanceof D.$$M)return{type:"executable",command:$.command,args:$.args,options:$.options};if($ instanceof D.$_M)return{type:"server",port:$.port,host:$.host};if($ instanceof D.$aN)return{type:"pipeServer",path:$.path};if($ instanceof D.$bN)return{type:"implementation",implementation:$.implementation};throw new Error("convertToDto unexpected type")}$($){const I=this.h.filter(h=>h.type===$);if(I.length>0)return I[0].factory}ab($){const I=this.h.filter(h=>h.handle===$);if(I.length>0)return I[0].factory}bb($){const I=this.f.filter(h=>h.handle===$);if(I.length>0)return I[0].provider}cb($,I){if($.contributes){const h=$.contributes.debuggers;if(h&&h.length>0){for(const y of h)if(y.label&&y.type&&y.type===I)return!0}}return!1}db($){const h=$.configuration.type,y=this.k.filter(w=>w.type===h||w.type==="*").map(w=>(0,S.$0g)(()=>w.factory.createDebugAdapterTracker($.api)).then(A=>A,A=>null));return Promise.race([Promise.all(y).then(w=>{const A=w.filter(N=>!!N);if(A.length>0)return new u(A)}),new Promise(w=>setTimeout(()=>w(void 0),1e3))]).catch(w=>{})}async eb($,I){const h=I.configuration.debugServer;if(typeof h=="number")return Promise.resolve(new D.$_M(h));if($){const w=await this.O.getExtensionRegistry();return(0,S.$0g)(()=>$.createDebugAdapterDescriptor(I.api,this.fb(I,w))).then(A=>{if(A)return A})}const y=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(I,y))}fb($,I){}gb($,I,h){($.length>0||I.length>0||h.length>0)&&this.A.fire(Object.freeze({added:$,removed:I,changed:h}))}async hb($){if($)if(typeof $=="string"){const I=this.m.get($);if(I)return I}else{let I=this.m.get($.id);if(!I){const h=await this.ib($.folderUri),y=$.parent?this.m.get($.parent):void 0;I=new t(this.l,$.id,$.type,$.name,h,$.configuration,y?.api),this.m.set(I.id,I),this.l.$sessionCached(I.id)}return I}throw new Error("cannot find session")}ib($){if($){const I=P.URI.revive($);return this.N.resolveWorkspaceFolder(I)}return Promise.resolve(void 0)}jb($,I){return`${$}\0${I}`}kb($,I){if(I){if("title"in I&&"command"in I)return{type:0};if("treeId"in I)return{type:1,id:`${$}\0${I.treeId}`};throw new Error("Unsupported debug visualization type")}}lb($){const I=this.mb($);let h,y;return"id"in I?y=n.ThemeIcon.asClassName(I):h=I,{iconPath:h,iconClass:y}}mb($){if($ instanceof D.$3M)return{id:$.id};const I=typeof $=="object"&&"dark"in $?$.dark:$,h=typeof $=="object"&&"light"in $?$.light:$;return{dark:typeof I=="string"?P.URI.file(I):I,light:typeof h=="string"?P.URI.file(h):h}}};e.$Wic=d,e.$Wic=d=Ye([He(0,O.$lO),He(1,l.$cic),He(2,k.$Qic),He(3,s.$fic),He(4,f.$ric),He(5,a.$Tic),He(6,r.$HO)],d);class t{constructor($,I,h,y,w,A,N){this.f=$,this.g=I,this.h=h,this.j=y,this.k=w,this.l=A,this.m=N}get api(){const $=this;return this.d??=Object.freeze({id:$.g,type:$.h,get name(){return $.j},set name(I){$.j=I,$.f.$setDebugSessionName($.g,I)},parentSession:$.m,workspaceFolder:$.k,configuration:$.l,customRequest(I,h){return $.f.$customDebugAdapterRequest($.g,I,h)},getDebugProtocolBreakpoint(I){return $.f.$getDebugProtocolBreakpoint($.g,I.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged($){this.j=$}get configuration(){return this.l}}e.$Xic=t;class p{constructor($){this.value=Object.freeze({append(I){$.$appendDebugConsole(I)},appendLine(I){this.append(I+`
`)}})}}e.$Yic=p;class u{constructor($){this.d=$}onWillStartSession(){this.d.forEach($=>$.onWillStartSession?$.onWillStartSession():void 0)}onWillReceiveMessage($){this.d.forEach(I=>I.onWillReceiveMessage?I.onWillReceiveMessage($):void 0)}onDidSendMessage($){this.d.forEach(I=>I.onDidSendMessage?I.onDidSendMessage($):void 0)}onWillStopSession(){this.d.forEach($=>$.onWillStopSession?$.onWillStopSession():void 0)}onError($){this.d.forEach(I=>I.onError?I.onError($):void 0)}onExit($,I){this.d.forEach(h=>h.onExit?h.onExit($,I):void 0)}}class o extends E.$Onb{constructor($){super(),this.h=$,$.onDidSendMessage(I=>{this.acceptMessage(I)})}startSession(){return Promise.resolve(void 0)}sendMessage($){this.h.handleMessage($)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let v=class extends d{constructor($,I,h,y,w,A,N){super($,I,h,y,w,A,N)}};e.$Zic=v,e.$Zic=v=Ye([He(0,O.$lO),He(1,l.$cic),He(2,k.$Qic),He(3,s.$fic),He(4,f.$ric),He(5,a.$Tic),He(6,r.$HO)],v)}),define(Pe[291],Re([1,0,14,89,2,4,239,13,54,71,27,188,17,59,38,61]),function(me,e,S,M,P,F,R,m,f,k,O,D,l,E,g,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3jc=e.$2jc=void 0;class a{static async installEarlyHandler(r){Error.stackTraceLimit=100;const c=r.get(m.$zj),t=r.get(l.$lO).getProxy(F.$6L.MainThreadErrors);S.setUnexpectedErrorHandler(p=>{c.error(p);const u=S.$3(p);t.$onUnexpectedError(u)})}static async installFullHandler(r){const c=r.get(m.$zj),d=r.get(l.$lO),t=r.get(g.$Qic),p=r.get(s.$FO),u=d.getProxy(F.$6L.MainThreadExtensionService),o=d.getProxy(F.$6L.MainThreadErrors),v=await t.getExtensionPathIndex(),b=new WeakMap;function $(y,w){if(b.has(y))return b.get(y).stack;let A="",N,G;for(const U of w)A+=`
	at ${U.toString()}`,G=U.getFileName(),!N&&G&&(N=v.findSubstr(P.URI.file(G)));const V=`${y.name||"Error"}: ${y.message||""}${A}`;return b.set(y,{extensionIdentifier:N?.identifier,stack:V}),V}const I=Symbol("prepareStackTrace wrapped");let h=$;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return h},set(y){if(y===$||!y||y[I]){h=y||$;return}h=function(w,A){return $(w,A),y.call(Error,w,A)},Object.assign(h,{[I]:!0})}}),S.setUnexpectedErrorHandler(y=>{c.error(y);const w=S.$3(y),A=b.get(y);if(!A?.extensionIdentifier){o.$onUnexpectedError(w);return}u.$onExtensionRuntimeError(A.extensionIdentifier,w);const N=p.onExtensionError(A.extensionIdentifier,y);c.trace("forwarded error to extension?",N,A)})}}e.$2jc=a;class i{constructor(r,c,d,t,p){this.a=d,this.b=new R.$W9b(r,null,t),c=i.e(c,this.b);const u=new k.$di(...(0,f.$bs)());u.set(O.$BO,{_serviceBrand:void 0,...c,messagePorts:p}),u.set(l.$lO,new l.$mO(this.b)),u.set(E.$_hc,new E.$aic(t)),u.set(g.$Oic,d);const o=new D.$Sq(u,!0);o.invokeFunction(a.installEarlyHandler),this.d=o.invokeFunction(v=>v.get(m.$zj)),M.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",c),this.c=o.invokeFunction(v=>v.get(g.$Qic)),this.c.initialize(),o.invokeFunction(a.installFullHandler)}async asBrowserUri(r){const c=this.b.getProxy(F.$6L.MainThreadExtensionService);return P.URI.revive(await c.$asBrowserUri(r))}terminate(r){this.c.terminate(r)}static e(r,c){r.extensions.allExtensions.forEach(t=>{t.extensionLocation=P.URI.revive(c.transformIncomingURIs(t.extensionLocation))}),r.environment.appRoot=P.URI.revive(c.transformIncomingURIs(r.environment.appRoot));const d=r.environment.extensionDevelopmentLocationURI;return d&&(r.environment.extensionDevelopmentLocationURI=d.map(t=>P.URI.revive(c.transformIncomingURIs(t)))),r.environment.extensionTestsLocationURI=P.URI.revive(c.transformIncomingURIs(r.environment.extensionTestsLocationURI)),r.environment.globalStorageHome=P.URI.revive(c.transformIncomingURIs(r.environment.globalStorageHome)),r.environment.workspaceStorageHome=P.URI.revive(c.transformIncomingURIs(r.environment.workspaceStorageHome)),r.environment.extensionTelemetryLogResource=P.URI.revive(c.transformIncomingURIs(r.environment.extensionTelemetryLogResource)),r.nlsBaseUrl=P.URI.revive(c.transformIncomingURIs(r.nlsBaseUrl)),r.logsLocation=P.URI.revive(c.transformIncomingURIs(r.logsLocation)),r.workspace=c.transformIncomingURIs(r.workspace),r}}e.$3jc=i}),define(Pe[292],Re([1,0,18,11,25,41,12,19,24,2,44]),function(me,e,S,M,P,F,R,m,f,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ejc=e.$djc=e.$cjc=e.$bjc=void 0;class D{constructor(n,r,c){this.d=n,this.e=r,this.f=c,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(n,r){const c=this.g.folderQueries||[],d=new P.$ce(r);return new Promise((t,p)=>{this.a=new E(n);let u=!1;const o=(v,b)=>{if(!u&&!this.b){const $=this.h(v);s(v)&&typeof this.g.maxResults=="number"&&this.c+$>this.g.maxResults&&(this.b=!0,u=!0,d.cancel(),v=this.j(v,this.g.maxResults-this.c));const I=this.h(v);this.c+=I,(I>0||!s(v))&&this.a.add(v,b)}};Promise.all(c.map((v,b)=>this.k(v,$=>o($,b),d.token))).then(v=>{d.dispose(),this.a.flush();const b=v.some($=>!!$&&!!$.limitHit);t({limitHit:this.b||b,messages:(0,S.$Rb)(v.map($=>$?.message?Array.isArray($.message)?$.message:[$.message]:[])),stats:{type:this.f}})},v=>{d.dispose();const b=(0,F.$3i)(v);p(new Error(b))})})}h(n){return s(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,r){const c=Array.isArray(n.ranges)?n.ranges:[n.ranges],d=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:c.slice(0,r),preview:{matches:d.slice(0,r),text:n.preview.text},uri:n.uri}}async k(n,r,c){const d=new O.$FK(this.g,n),t=[],p={report:v=>{if(!this.l(v))return;const b=n.folder.scheme===R.Schemas.file?(0,O.$GK)(()=>this.e.readdir(f.$Rg(v.uri))):void 0,$=f.$Ug(n.folder,v.uri);if($){const I=d.includedInQuery($,m.$nc($),b);(0,M.$4g)(I)?t.push(I.then(h=>{h&&r(v)})):I&&r(v)}}},u=this.n(n);let o;return this.d.query.type===3?o=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,u,p,c):o=await this.d.provider.provideTextSearchResults(l(this.d.query.contentPattern),u,p,c),t.length&&await Promise.all(t),o}l(n){if(s(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const r=(0,O.$EK)(this.g.includePattern,n.includePattern),c=(0,O.$EK)(this.g.excludePattern,n.excludePattern),d={folder:k.URI.from(n.folder),excludes:c,includes:r,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.e.toCanonicalName(n.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(d.usePCRE2=this.g.usePCRE2),d}}e.$bjc=D;function l(i){return{isCaseSensitive:i.isCaseSensitive||!1,isRegExp:i.isRegExp||!1,isWordMatch:i.isWordMatch||!1,isMultiline:i.isMultiline||!1,pattern:i.pattern}}class E{constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new a(512,r=>this.g(r))}add(n,r){this.d&&(this.b!==r||!f.$Lg(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=r,this.d={resource:n.uri,results:[]}),this.d.results.push(g(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$cjc=E;function g(i){return s(i)?{preview:{matches:(0,S.$2b)(i.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:i.preview.text},ranges:(0,S.$2b)(i.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:i.text,lineNumber:i.lineNumber}}function s(i){return!!i.preview}e.$djc=s;class a{static{this.a=4e3}static{this.b=50}constructor(n,r){this.g=n,this.h=r,this.c=0,this.d=[],this.e=0}addItem(n,r){n&&this.j(n,r)}addItems(n,r){n&&this.k(n,r)}j(n,r){this.d.push(n),this.e+=r,this.l()}k(n,r){this.d=this.d.concat(n),this.e+=r,this.l()}l(){this.c<a.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},a.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$ejc=a}),define(Pe[121],Re([1,0,6,4,3,287,17,59,13,2,292]),function(me,e,S,M,P,F,R,m,f,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hjc=e.$gjc=e.$fjc=void 0,e.$fjc=(0,P.$fi)("IExtHostSearch");let D=class{constructor(s,a,i){this.n=s,this.o=a,this.q=i,this.c=this.n.getProxy(M.$6L.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new F.$ajc}s(s){return this.o.transformOutgoingScheme(s)}registerTextSearchProvider(s,a){if(this.g.has(s))throw new Error(`a text search provider for the scheme '${s}' is already registered`);this.g.add(s);const i=this.d++;return this.e.set(i,a),this.c.$registerTextSearchProvider(i,this.s(s)),(0,S.$Rc)(()=>{this.g.delete(s),this.e.delete(i),this.c.$unregisterProvider(i)})}registerAITextSearchProvider(s,a){if(this.i.has(s))throw new Error(`an AI text search provider for the scheme '${s}'is already registered`);this.i.add(s);const i=this.d++;return this.h.set(i,a),this.c.$registerAITextSearchProvider(i,this.s(s)),(0,S.$Rc)(()=>{this.i.delete(s),this.h.delete(i),this.c.$unregisterProvider(i)})}registerFileSearchProvider(s,a){if(this.k.has(s))throw new Error(`a file search provider for the scheme '${s}' is already registered`);this.k.add(s);const i=this.d++;return this.j.set(i,a),this.c.$registerFileSearchProvider(i,this.s(s)),(0,S.$Rc)(()=>{this.k.delete(s),this.j.delete(i),this.c.$unregisterProvider(i)})}$provideFileSearchResults(s,a,i,n){const r=l(i),c=this.j.get(s);if(c)return this.l.fileSearch(r,c,d=>{this.c.$handleFileMatch(s,a,d.map(t=>t.resource))},n);throw new Error("3 unknown provider: "+s)}async doInternalFileSearchWithCustomCallback(s,a,i){return{messages:[]}}$clearCache(s){return this.l.clearCache(s),Promise.resolve(void 0)}$provideTextSearchResults(s,a,i,n){const r=this.e.get(s);if(!r||!r.provideTextSearchResults)throw new Error(`2 Unknown provider ${s}`);const c=l(i);return this.t(c,r).search(t=>this.c.$handleTextMatch(s,a,t),n)}$provideAITextSearchResults(s,a,i,n){const r=this.h.get(s);if(!r||!r.provideAITextSearchResults)throw new Error(`1 Unknown provider ${s}`);const c=l(i);return this.v(c,r).search(t=>this.c.$handleTextMatch(s,a,t),n)}$enableExtensionHostSearch(){}t(s,a){return new O.$bjc({query:s,provider:a},{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"textSearchProvider")}v(s,a){return new O.$bjc({query:s,provider:a},{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"aiTextSearchProvider")}};e.$gjc=D,e.$gjc=D=Ye([He(0,R.$lO),He(1,m.$_hc),He(2,f.$zj)],D);function l(g){return{...g,folderQueries:g.folderQueries&&g.folderQueries.map(E),extraFileResources:g.extraFileResources&&g.extraFileResources.map(s=>k.URI.revive(s))}}e.$hjc=l;function E(g){return{...g,folder:k.URI.revive(g.folder)}}}),define(Pe[293],Re([1,0,25,14,5,6,12,32,2,149,145,133,94,20,42,13,57,58,201,4,242,271,78,84,248,227,249,88,250,228,216,31,251,37,252,120,110,253,230,243,254,255,67,65,244,38,257,63,258,43,27,272,273,245,231,259,260,79,80,233,286,262,205,263,274,264,115,234,265,266,267,17,268,121,81,269,235,270,82,85,118,61,66,275,276,246,277,278,86,8,7,236,59,237,62,279,280,109,36,211,77,22,117]),function(me,e,S,M,P,F,R,m,f,k,O,D,l,E,g,s,a,i,n,r,c,d,t,p,u,o,v,b,$,I,h,y,w,A,N,G,V,U,C,L,q,ne,ae,ye,Ie,ue,ve,re,$e,ie,le,W,_,ke,Ne,De,be,ge,J,X,he,fe,Fe,de,Ce,Ae,je,z,j,K,H,ee,se,Oe,We,Ke,xe,tt,lt,rt,it,at,Be,et,Z,Q,pe,Ve,Ze,st,Me,Dt,Kt,Tt,Qt,Zt,St,Jt,Gt,_t,ni,Xe,jt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wjc=void 0;function ei(dt){const pt=dt.get(le.$BO),ti=dt.get(ie.$Thc),Vt=dt.get(re.$hic),zt=dt.get(ue.$Qic),ft=dt.get(Gt.$cic),Pt=dt.get(at.$FO),ii=dt.get(A.$fic),Xt=dt.get(Kt.$_hc),Je=dt.get(ee.$lO),Rt=dt.get(lt.$Aic),Ut=dt.get(rt.$iic),ri=dt.get(s.$Aj),gt=dt.get(s.$zj),Mt=dt.get(Ze.$zAb),Ct=dt.get(t.$Phc),Bt=dt.get(Jt.$Vjc),si=dt.get(We.$Iic),Nt=dt.get(ye.$ric),qt=dt.get(J.$Mic),yt=dt.get(p.$Zhc),Ft=dt.get(b.$5hc);Je.set(r.$7L.ExtHostFileSystemInfo,ti),Je.set(r.$7L.ExtHostLogLevelServiceShape,ri),Je.set(r.$7L.ExtHostWorkspace,ft),Je.set(r.$7L.ExtHostConfiguration,ii),Je.set(r.$7L.ExtHostExtensionService,zt),Je.set(r.$7L.ExtHostStorage,Rt),Je.set(r.$7L.ExtHostTunnelService,Mt),Je.set(r.$7L.ExtHostWindow,Bt),Je.set(r.$7L.ExtHostSecretState,si),Je.set(r.$7L.ExtHostTelemetry,Pt),Je.set(r.$7L.ExtHostEditorTabs,Nt),Je.set(r.$7L.ExtHostManagedSockets,qt),Je.set(r.$7L.ExtHostAuthentication,yt),Je.set(r.$7L.ExtHostChatProvider,Ft);const Yt=Je.set(r.$7L.ExtHostDecorations,dt.get(V.$2ic)),Wt=Je.set(r.$7L.ExtHostDocumentsAndEditors,dt.get(ae.$wO)),wt=Je.set(r.$7L.ExtHostCommands,dt.get(y.$HO)),It=Je.set(r.$7L.ExtHostTerminalService,dt.get(Be.$Dic)),Et=Je.set(r.$7L.ExtHostDebugService,dt.get(G.$Vic)),ci=Je.set(r.$7L.ExtHostSearch,dt.get(Oe.$fjc)),we=Je.set(r.$7L.ExtHostTask,dt.get(it.$Ijc)),Le=Je.set(r.$7L.ExtHostOutputService,dt.get(je.$vjc)),ce=Je.set(r.$7L.ExtHostLocalization,dt.get(ge.$Lic)),Y=Je.set(r.$7L.ExtHostUrls,new Tt.$Sjc(Je)),Ee=Je.set(r.$7L.ExtHostDocuments,new ne.$Whc(Je,Wt)),Ue=Je.set(r.$7L.ExtHostDocumentContentProviders,new L.$4ic(Je,Wt,gt)),Qe=Je.set(r.$7L.ExtHostDocumentSaveParticipant,new q.$5ic(gt,Ee,Je.getProxy(r.$6L.MainThreadBulkEdits))),qe=Je.set(r.$7L.ExtHostNotebook,new he.$ijc(Je,wt,Wt,Ee,Vt,ci)),ct=Je.set(r.$7L.ExtHostNotebookDocuments,new Fe.$pjc(qe)),bt=Je.set(r.$7L.ExtHostNotebookEditors,new de.$qjc(gt,qe)),Lt=Je.set(r.$7L.ExtHostNotebookKernels,new Ce.$rjc(Je,pt,qe,wt,gt)),xt=Je.set(r.$7L.ExtHostNotebookRenderers,new Ae.$tjc(Je,qe)),At=Je.set(r.$7L.ExtHostNotebookDocumentSaveParticipant,new fe.$ojc(gt,qe,Je.getProxy(r.$6L.MainThreadBulkEdits))),kt=Je.set(r.$7L.ExtHostEditors,new Z.$9hc(Je,Wt)),wi=Je.set(r.$7L.ExtHostTreeViews,new Ve.$Qjc(Je.getProxy(r.$6L.MainThreadTreeViews),wt,gt)),Pi=Je.set(r.$7L.ExtHostEditorInsets,new h.$0hc(Je.getProxy(r.$6L.MainThreadEditorInsets),kt,pt.remote)),pi=Je.set(r.$7L.ExtHostDiagnostics,new U.$Vhc(Je,gt,ti,Wt)),vi=Je.set(r.$7L.ExtHostLanguages,new be.$mjc(Je,Ee,wt.converter,Xt)),ht=Je.set(r.$7L.ExtHostLanguageFeatures,new De.$Xhc(Je,Xt,Ee,wt,pi,gt,Ct,Pt)),Ri=Je.set(r.$7L.ExtHostFileSystem,new ve.$7ic(Je,ht)),ui=Je.set(r.$7L.ExtHostFileSystemEventService,new $e.$8ic(Je,gt,Wt)),gi=Je.set(r.$7L.ExtHostQuickOpen,(0,H.$zjc)(Je,ft,wt)),Ai=Je.set(r.$7L.ExtHostSCM,new se.$Bjc(Je,wt,Ee,gt)),ln=Je.set(r.$7L.ExtHostQuickDiff,new K.$yjc(Je,Xt)),Zi=Je.set(r.$7L.ExtHostShare,new Ke.$Cjc(Je,Xt)),Mi=Je.set(r.$7L.ExtHostComments,(0,w.$$hc)(Je,wt,Ee)),yi=Je.set(r.$7L.ExtHostProgress,new j.$xjc(Je.getProxy(r.$6L.MainThreadProgress))),Xi=Je.set(r.$7L.ExtHostLabelService,new Ne.$ljc(Je)),Fi=Je.set(r.$7L.ExtHostTheming,new Q.$Njc(Je)),xi=Je.set(r.$7L.ExtHostTimeline,new pe.$Pjc(Je,wt)),Ei=Je.set(r.$7L.ExtHostWebviews,new Qt.$mic(Je,pt.remote,ft,gt,Ct)),ki=Je.set(r.$7L.ExtHostWebviewPanels,new Zt.$pic(Je,Ei,ft)),hn=Je.set(r.$7L.ExtHostCustomEditors,new N.$qic(Je,Ee,Ut,Ei,ki)),dn=Je.set(r.$7L.ExtHostWebviewViews,new St.$Tjc(Je,Ei)),mi=Je.set(r.$7L.ExtHostTesting,new et.$Jjc(Je,gt,wt,Wt)),Li=Je.set(r.$7L.ExtHostUriOpeners,new Dt.$Rjc(Je)),fn=Je.set(r.$7L.ExtHostProfileContentHandlers,new z.$wjc(Je));Je.set(r.$7L.ExtHostInteractive,new _.$jjc(Je,qe,Wt,wt,gt));const gn=Je.set(r.$7L.ExtHostInlineChat,new W.$9ic(Je,wt,Ee,gt)),_i=Je.set(r.$7L.ExtHostChatAgents2,new v.$4hc(Je,gt,wt)),mn=Je.set(r.$7L.ExtHostChatVariables,new $.$7hc(Je)),bi=Je.set(r.$7L.ExtHostChat,new o.$3hc(Je)),Oi=Je.set(r.$7L.ExtHostAiRelatedInformation,new c.$Ohc(Je)),en=Je.set(r.$7L.ExtHostAiEmbeddingVector,new Ie.$6ic(Je)),Ni=Je.set(r.$7L.ExtHostIssueReporter,new ke.$kjc(Je)),tn=Je.set(r.$7L.ExtHostStatusBar,new tt.$Fjc(Je,wt.converter)),Ti=Je.set(r.$7L.ExtHostSpeech,new xe.$Djc(Je)),nn=Object.values(r.$7L);Je.assertRegistered(nn);const di=new u.$2hc(Je,Wt),Di=new I.$8hc(Je),ji=new X.$njc(Je,gt),oi=new C.$3ic(Je);return d.$Yhc.register(wt),function(Te,li,zi){function nt(x){return(oe,ze,ot)=>{const vt=x(Ot=>{try{oe.call(ze,Ot)}catch(Gi){M.$2(new Error(`[ExtensionListenerError] Extension '${Te.identifier.value}' FAILED to handle event: ${Gi.toString()}`,{cause:Gi})),Pt.onExtensionError(Te.identifier,Gi)}});return ot?.push(vt),vt}}const $t=function(){let x=!Te.isUnderDevelopment;function oe(){x||(gt.info(`Extension '${Te.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),x=!0)}return function ze(ot){if(Array.isArray(ot))ot.forEach(ze);else if(typeof ot=="string")oe();else{const vt=ot;typeof vt.scheme>"u"&&oe(),typeof vt.exclusive=="boolean"&&(0,Xe.$YF)(Te,"documentFiltersExclusive")}return ot}}(),$n={getSession(x,oe,ze){return yt.getSession(Te,x,oe,ze)},getSessions(x,oe){return(0,Xe.$YF)(Te,"authGetSessions"),yt.getSessions(Te,x,oe)},async hasSession(x,oe){return(0,Xe.$YF)(Te,"authSession"),!!await yt.getSession(Te,x,oe,{silent:!0})},get onDidChangeSessions(){return nt(yt.onDidChangeSessions)},registerAuthenticationProvider(x,oe,ze,ot){return yt.registerAuthenticationProvider(x,oe,ze,ot)}},rn={registerCommand(x,oe,ze){return wt.registerCommand(!0,x,oe,ze,void 0,Te)},registerTextEditorCommand(x,oe,ze){return wt.registerCommand(!0,x,(...ot)=>{const vt=kt.getActiveTextEditor();if(!vt){gt.warn("Cannot execute "+x+" because there is no active text editor.");return}return vt.edit(Ot=>{oe.apply(ze,[vt,Ot,...ot])}).then(Ot=>{Ot||gt.warn("Edits from command "+x+" were not applied.")},Ot=>{gt.warn("An error occurred while running command "+x,Ot)})},void 0,void 0,Te)},registerDiffInformationCommand:(x,oe,ze)=>((0,Xe.$YF)(Te,"diffCommand"),wt.registerCommand(!0,x,async(...ot)=>{const vt=Wt.activeEditor(!0);if(!vt){gt.warn("Cannot execute "+x+" because there is no active text editor.");return}const Ot=await kt.getDiffInformation(vt.id);oe.apply(ze,[Ot,...ot])},void 0,void 0,Te)),executeCommand(x,...oe){return wt.executeCommand(x,...oe)},getCommands(x=!1){return wt.getCommands(x)}},Ui={get machineId(){return pt.telemetryInfo.machineId},get sessionId(){return pt.telemetryInfo.sessionId},get language(){return pt.environment.appLanguage},get appName(){return pt.environment.appName},get appRoot(){return pt.environment.appRoot?.fsPath??""},get appHost(){return pt.environment.appHost},get uriScheme(){return pt.environment.appUriScheme},get clipboard(){return Di.value},get shell(){return It.getDefaultShell(!1)},get onDidChangeShell(){return nt(It.onDidChangeShell)},get isTelemetryEnabled(){return Pt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return nt(Pt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Xe.$YF)(Te,"telemetry"),Pt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Xe.$YF)(Te,"telemetry"),nt(Pt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,at.$EO)(pt.telemetryInfo.firstSessionDate)},createTelemetryLogger(x,oe){return at.$DO.validateSender(x),Pt.instantiateLogger(Te,x,oe)},openExternal(x,oe){return Bt.openUri(x,{allowTunneling:!!pt.remote.authority,allowContributedOpeners:oe?.allowContributedOpeners})},async asExternalUri(x){if(x.scheme===pt.environment.appUriScheme)return Y.createAppUri(x);try{return await Bt.asExternalUri(x,{allowTunneling:!!pt.remote.authority})}catch(oe){if((0,R.$og)(x,R.Schemas.http)||(0,R.$og)(x,R.Schemas.https))return x;throw oe}},get remoteName(){return(0,a.$qm)(pt.remote.authority)},get remoteAuthority(){return(0,Xe.$YF)(Te,"resolvers"),pt.remote.authority},get uiKind(){return pt.uiKind},get logLevel(){return gt.getLevel()},get onDidChangeLogLevel(){return nt(gt.onDidChangeLogLevel)},registerIssueUriRequestHandler(x){return(0,Xe.$YF)(Te,"handleIssueUri"),Ni.registerIssueUriRequestHandler(Te,x)},registerIssueDataProvider(x){return(0,Xe.$YF)(Te,"handleIssueUri"),Ni.registerIssueDataProvider(Te,x)},get appQuality(){return(0,Xe.$YF)(Te,"resolvers"),pt.quality},get appCommit(){return(0,Xe.$YF)(Te,"resolvers"),pt.commit}};pt.environment.extensionTestsLocationURI||Object.freeze(Ui);const pn={createTestController(x,oe,ze){return mi.createTestController(Te,x,oe,ze)},createTestObserver(){return(0,Xe.$YF)(Te,"testObserver"),mi.createTestObserver()},runTests(x){return(0,Xe.$YF)(Te,"testObserver"),mi.runTests(x)},get onDidChangeTestResults(){return(0,Xe.$YF)(Te,"testObserver"),nt(mi.onResultsChanged)},get testResults(){return(0,Xe.$YF)(Te,"testObserver"),mi.results}},Si=pt.remote.isRemote?Me.ExtensionKind.Workspace:Me.ExtensionKind.UI,sn={getExtension(x,oe){(0,Xe.$XF)(Te,"extensionsAny")||(oe=!1);const ze=li.mine.getExtensionDescription(x);if(ze)return new ue.$Ric(zt,Te.identifier,ze,Si,!1);if(oe){const ot=li.all.getExtensionDescription(x);if(ot)return new ue.$Ric(zt,Te.identifier,ot,Si,!0)}},get all(){const x=[];for(const oe of li.mine.getAllExtensionDescriptions())x.push(new ue.$Ric(zt,Te.identifier,oe,Si,!1));return x},get allAcrossExtensionHosts(){(0,Xe.$YF)(Te,"extensionsAny");const x=new E.$Am(li.mine.getAllExtensionDescriptions().map(ze=>ze.identifier)),oe=[];for(const ze of li.all.getAllExtensionDescriptions()){const ot=!x.has(ze.identifier);oe.push(new ue.$Ric(zt,Te.identifier,ze,Si,ot))}return oe},get onDidChange(){return(0,Xe.$XF)(Te,"extensionsAny")?nt(P.Event.any(li.mine.onDidChange,li.all.onDidChange)):nt(li.mine.onDidChange)}},Bi={createDiagnosticCollection(x){return pi.createDiagnosticCollection(Te.identifier,x)},get onDidChangeDiagnostics(){return nt(pi.onDidChangeDiagnostics)},getDiagnostics:x=>pi.getDiagnostics(x),getLanguages(){return vi.getLanguages()},setTextDocumentLanguage(x,oe){return vi.changeLanguage(x.uri,oe)},match(x,oe){const ze=st.LanguageSelector.from(x);let ot;return(0,O.$Qt)(ze)&&(ot=qe.notebookDocuments.find(vt=>!!vt.getCell(oe.uri))?.apiNotebook),(0,O.$Pt)(ze,oe.uri,oe.languageId,!0,ot?.uri,ot?.notebookType)},registerCodeActionsProvider(x,oe,ze){return ht.registerCodeActionProvider(Te,$t(x),oe,ze)},registerDocumentPasteEditProvider(x,oe,ze){return(0,Xe.$YF)(Te,"documentPaste"),ht.registerDocumentPasteEditProvider(Te,$t(x),oe,ze)},registerCodeLensProvider(x,oe){return ht.registerCodeLensProvider(Te,$t(x),oe)},registerDefinitionProvider(x,oe){return ht.registerDefinitionProvider(Te,$t(x),oe)},registerDeclarationProvider(x,oe){return ht.registerDeclarationProvider(Te,$t(x),oe)},registerImplementationProvider(x,oe){return ht.registerImplementationProvider(Te,$t(x),oe)},registerTypeDefinitionProvider(x,oe){return ht.registerTypeDefinitionProvider(Te,$t(x),oe)},registerHoverProvider(x,oe){return ht.registerHoverProvider(Te,$t(x),oe,Te.identifier)},registerEvaluatableExpressionProvider(x,oe){return ht.registerEvaluatableExpressionProvider(Te,$t(x),oe,Te.identifier)},registerInlineValuesProvider(x,oe){return ht.registerInlineValuesProvider(Te,$t(x),oe,Te.identifier)},registerDocumentHighlightProvider(x,oe){return ht.registerDocumentHighlightProvider(Te,$t(x),oe)},registerMultiDocumentHighlightProvider(x,oe){return ht.registerMultiDocumentHighlightProvider(Te,$t(x),oe)},registerLinkedEditingRangeProvider(x,oe){return ht.registerLinkedEditingRangeProvider(Te,$t(x),oe)},registerReferenceProvider(x,oe){return ht.registerReferenceProvider(Te,$t(x),oe)},registerRenameProvider(x,oe){return ht.registerRenameProvider(Te,$t(x),oe)},registerNewSymbolNamesProvider(x,oe){return(0,Xe.$YF)(Te,"newSymbolNamesProvider"),ht.registerNewSymbolNamesProvider(Te,$t(x),oe)},registerDocumentSymbolProvider(x,oe,ze){return ht.registerDocumentSymbolProvider(Te,$t(x),oe,ze)},registerWorkspaceSymbolProvider(x){return ht.registerWorkspaceSymbolProvider(Te,x)},registerDocumentFormattingEditProvider(x,oe){return ht.registerDocumentFormattingEditProvider(Te,$t(x),oe)},registerDocumentRangeFormattingEditProvider(x,oe){return ht.registerDocumentRangeFormattingEditProvider(Te,$t(x),oe)},registerOnTypeFormattingEditProvider(x,oe,ze,...ot){return ht.registerOnTypeFormattingEditProvider(Te,$t(x),oe,[ze].concat(ot))},registerDocumentSemanticTokensProvider(x,oe,ze){return ht.registerDocumentSemanticTokensProvider(Te,$t(x),oe,ze)},registerDocumentRangeSemanticTokensProvider(x,oe,ze){return ht.registerDocumentRangeSemanticTokensProvider(Te,$t(x),oe,ze)},registerSignatureHelpProvider(x,oe,ze,...ot){return typeof ze=="object"?ht.registerSignatureHelpProvider(Te,$t(x),oe,ze):ht.registerSignatureHelpProvider(Te,$t(x),oe,typeof ze>"u"?[]:[ze,...ot])},registerCompletionItemProvider(x,oe,...ze){return ht.registerCompletionItemProvider(Te,$t(x),oe,ze)},registerInlineCompletionItemProvider(x,oe,ze){return oe.handleDidShowCompletionItem&&(0,Xe.$YF)(Te,"inlineCompletionsAdditions"),oe.handleDidPartiallyAcceptCompletionItem&&(0,Xe.$YF)(Te,"inlineCompletionsAdditions"),ze&&(0,Xe.$YF)(Te,"inlineCompletionsAdditions"),ht.registerInlineCompletionsProvider(Te,$t(x),oe,ze)},registerInlineEditProvider(x,oe){return(0,Xe.$YF)(Te,"inlineEdit"),ht.registerInlineEditProvider(Te,$t(x),oe)},registerDocumentLinkProvider(x,oe){return ht.registerDocumentLinkProvider(Te,$t(x),oe)},registerColorProvider(x,oe){return ht.registerColorProvider(Te,$t(x),oe)},registerFoldingRangeProvider(x,oe){return ht.registerFoldingRangeProvider(Te,$t(x),oe)},registerSelectionRangeProvider(x,oe){return ht.registerSelectionRangeProvider(Te,x,oe)},registerCallHierarchyProvider(x,oe){return ht.registerCallHierarchyProvider(Te,x,oe)},registerTypeHierarchyProvider(x,oe){return ht.registerTypeHierarchyProvider(Te,x,oe)},setLanguageConfiguration:(x,oe)=>ht.setLanguageConfiguration(Te,x,oe),getTokenInformationAtPosition(x,oe){return(0,Xe.$YF)(Te,"tokenInformation"),vi.tokenAtPosition(x,oe)},registerInlayHintsProvider(x,oe){return ht.registerInlayHintsProvider(Te,x,oe)},createLanguageStatusItem(x,oe){return vi.createLanguageStatusItem(Te,x,oe)},registerDocumentDropEditProvider(x,oe,ze){return ht.registerDocumentOnDropEditProvider(Te,x,oe,(0,Xe.$XF)(Te,"dropMetadata")?ze:void 0)}},on={get activeTextEditor(){return kt.getActiveTextEditor()},get visibleTextEditors(){return kt.getVisibleTextEditors()},get activeTerminal(){return It.activeTerminal},get terminals(){return It.terminals},async showTextDocument(x,oe,ze){f.URI.isUri(x)&&x.scheme===R.Schemas.vscodeRemote&&!x.authority&&Ct.report("workspace.showTextDocument",Te,"A URI of 'vscode-remote' scheme requires an authority.");const ot=await(f.URI.isUri(x)?Promise.resolve(Wi.openTextDocument(x)):Promise.resolve(x));return kt.showTextDocument(ot,oe,ze)},createTextEditorDecorationType(x){return kt.createTextEditorDecorationType(Te,x)},onDidChangeActiveTextEditor(x,oe,ze){return nt(kt.onDidChangeActiveTextEditor)(x,oe,ze)},onDidChangeVisibleTextEditors(x,oe,ze){return nt(kt.onDidChangeVisibleTextEditors)(x,oe,ze)},onDidChangeTextEditorSelection(x,oe,ze){return nt(kt.onDidChangeTextEditorSelection)(x,oe,ze)},onDidChangeTextEditorOptions(x,oe,ze){return nt(kt.onDidChangeTextEditorOptions)(x,oe,ze)},onDidChangeTextEditorVisibleRanges(x,oe,ze){return nt(kt.onDidChangeTextEditorVisibleRanges)(x,oe,ze)},onDidChangeTextEditorViewColumn(x,oe,ze){return nt(kt.onDidChangeTextEditorViewColumn)(x,oe,ze)},onDidCloseTerminal(x,oe,ze){return nt(It.onDidCloseTerminal)(x,oe,ze)},onDidOpenTerminal(x,oe,ze){return nt(It.onDidOpenTerminal)(x,oe,ze)},onDidChangeActiveTerminal(x,oe,ze){return nt(It.onDidChangeActiveTerminal)(x,oe,ze)},onDidChangeTerminalDimensions(x,oe,ze){return(0,Xe.$YF)(Te,"terminalDimensions"),nt(It.onDidChangeTerminalDimensions)(x,oe,ze)},onDidChangeTerminalState(x,oe,ze){return nt(It.onDidChangeTerminalState)(x,oe,ze)},onDidWriteTerminalData(x,oe,ze){return(0,Xe.$YF)(Te,"terminalDataWriteEvent"),nt(It.onDidWriteTerminalData)(x,oe,ze)},onDidExecuteTerminalCommand(x,oe,ze){return(0,Xe.$YF)(Te,"terminalExecuteCommandEvent"),nt(It.onDidExecuteTerminalCommand)(x,oe,ze)},get state(){return Bt.getState(Te)},onDidChangeWindowState(x,oe,ze){return nt(Bt.onDidChangeWindowState)(x,oe,ze)},showInformationMessage(x,...oe){return ji.showMessage(Te,m.default.Info,x,oe[0],oe.slice(1))},showWarningMessage(x,...oe){return ji.showMessage(Te,m.default.Warning,x,oe[0],oe.slice(1))},showErrorMessage(x,...oe){return ji.showMessage(Te,m.default.Error,x,oe[0],oe.slice(1))},showQuickPick(x,oe,ze){return gi.showQuickPick(Te,x,oe,ze)},showWorkspaceFolderPick(x){return gi.showWorkspaceFolderPick(x)},showInputBox(x,oe){return gi.showInput(x,oe)},showOpenDialog(x){return oi.showOpenDialog(Te,x)},showSaveDialog(x){return oi.showSaveDialog(x)},createStatusBarItem(x,oe,ze){let ot,vt,Ot;return typeof x=="string"?(ot=x,vt=oe,Ot=ze):(vt=x,Ot=oe),tn.createStatusBarEntry(Te,ot,vt,Ot)},setStatusBarMessage(x,oe){return tn.setStatusBarMessage(x,oe)},withScmProgress(x){return Ct.report("window.withScmProgress",Te,"Use 'withProgress' instead."),yi.withProgress(Te,{location:Me.ProgressLocation.SourceControl},(oe,ze)=>x({report(ot){}}))},withProgress(x,oe){return yi.withProgress(Te,x,oe)},createOutputChannel(x,oe){return Le.createOutputChannel(x,oe,Te)},createWebviewPanel(x,oe,ze,ot){return ki.createWebviewPanel(Te,x,oe,ze,ot)},createWebviewTextEditorInset(x,oe,ze,ot){return(0,Xe.$YF)(Te,"editorInsets"),Pi.createWebviewEditorInset(x,oe,ze,ot,Te)},createTerminal(x,oe,ze){return typeof x=="object"?"pty"in x?It.createExtensionTerminal(x):It.createTerminalFromOptions(x):It.createTerminal(x,oe,ze)},registerTerminalLinkProvider(x){return It.registerLinkProvider(x)},registerTerminalProfileProvider(x,oe){return It.registerProfileProvider(Te,x,oe)},registerTerminalQuickFixProvider(x,oe){return(0,Xe.$YF)(Te,"terminalQuickFixProvider"),It.registerTerminalQuickFixProvider(x,Te.identifier.value,oe)},registerTreeDataProvider(x,oe){return wi.registerTreeDataProvider(x,oe,Te)},createTreeView(x,oe){return wi.createTreeView(x,oe,Te)},registerWebviewPanelSerializer:(x,oe)=>ki.registerWebviewPanelSerializer(Te,x,oe),registerCustomEditorProvider:(x,oe,ze={})=>hn.registerCustomEditorProvider(Te,x,oe,ze),registerFileDecorationProvider(x){return Yt.registerFileDecorationProvider(x,Te)},registerUriHandler(x){return Y.registerUriHandler(Te,x)},createQuickPick(){return gi.createQuickPick(Te)},createInputBox(){return gi.createInputBox(Te)},get activeColorTheme(){return Fi.activeColorTheme},onDidChangeActiveColorTheme(x,oe,ze){return nt(Fi.onDidChangeActiveColorTheme)(x,oe,ze)},registerWebviewViewProvider(x,oe,ze){return dn.registerWebviewViewProvider(Te,x,oe,ze?.webviewOptions)},get activeNotebookEditor(){return qe.activeNotebookEditor},onDidChangeActiveNotebookEditor(x,oe,ze){return nt(qe.onDidChangeActiveNotebookEditor)(x,oe,ze)},get visibleNotebookEditors(){return qe.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return nt(qe.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(x,oe,ze){return nt(bt.onDidChangeNotebookEditorSelection)(x,oe,ze)},onDidChangeNotebookEditorVisibleRanges(x,oe,ze){return nt(bt.onDidChangeNotebookEditorVisibleRanges)(x,oe,ze)},showNotebookDocument(x,oe){return qe.showNotebookDocument(x,oe)},registerExternalUriOpener(x,oe,ze){return(0,Xe.$YF)(Te,"externalUriOpener"),Li.registerExternalUriOpener(Te.identifier,x,oe,ze)},registerProfileContentHandler(x,oe){return(0,Xe.$YF)(Te,"profileContentHandlers"),fn.registerProfileContentHandler(Te,x,oe)},registerQuickDiffProvider(x,oe,ze,ot){return(0,Xe.$YF)(Te,"quickDiffProvider"),ln.registerQuickDiffProvider($t(x),oe,ze,ot)},get tabGroups(){return Nt.tabGroups},registerShareProvider(x,oe){return(0,Xe.$YF)(Te,"shareProvider"),Zi.registerShareProvider($t(x),oe)}},Wi={get rootPath(){return Ct.report("workspace.rootPath",Te,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(x){throw new M.$9("rootPath")},getWorkspaceFolder(x){return ft.getWorkspaceFolder(x)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(x){throw new M.$9("name")},get workspaceFile(){return ft.workspaceFile},set workspaceFile(x){throw new M.$9("workspaceFile")},updateWorkspaceFolders:(x,oe,...ze)=>ft.updateWorkspaceFolders(Te,x,oe||0,...ze),onDidChangeWorkspaceFolders:function(x,oe,ze){return nt(ft.onDidChangeWorkspace)(x,oe,ze)},asRelativePath:(x,oe)=>ft.getRelativePath(x,oe),findFiles:(x,oe,ze,ot)=>ft.findFiles(x,oe,ze,Te.identifier,ot),findFiles2:(x,oe,ze)=>((0,Xe.$YF)(Te,"findFiles2"),ft.findFiles2(x,oe,Te.identifier,ze)),findTextInFiles:(x,oe,ze,ot)=>{(0,Xe.$YF)(Te,"findTextInFiles");let vt,Ot;return typeof oe=="object"?(vt=oe,Ot=ze):(vt={},Ot=oe,ot=ze),ft.findTextInFiles(x,vt||{},Ot,Te.identifier,ot)},save:x=>ft.save(x),saveAs:x=>ft.saveAs(x),saveAll:x=>ft.saveAll(x),applyEdit(x,oe){return di.applyWorkspaceEdit(x,Te,oe)},createFileSystemWatcher:(x,oe,ze,ot)=>{let vt;return typeof oe=="boolean"?vt={ignoreCreateEvents:!!oe,ignoreChangeEvents:!!ze,ignoreDeleteEvents:!!ot,correlate:!1}:oe&&((0,Xe.$YF)(Te,"createFileSystemWatcher"),vt={...oe,correlate:!0}),ui.createFileSystemWatcher(ft,Te,x,vt)},get textDocuments(){return Ee.getAllDocumentData().map(x=>x.document)},set textDocuments(x){throw new M.$9("textDocuments")},openTextDocument(x){let oe;const ze=x;if(typeof x=="string")oe=Promise.resolve(f.URI.file(x));else if(f.URI.isUri(x))oe=Promise.resolve(x);else if(!ze||typeof ze=="object")oe=Ee.createDocumentData(ze);else throw new Error("illegal argument - uriOrFileNameOrOptions");return oe.then(ot=>(ot.scheme===R.Schemas.vscodeRemote&&!ot.authority&&Ct.report("workspace.openTextDocument",Te,"A URI of 'vscode-remote' scheme requires an authority."),Ee.ensureDocumentData(ot).then(vt=>vt.document)))},onDidOpenTextDocument:(x,oe,ze)=>nt(Ee.onDidAddDocument)(x,oe,ze),onDidCloseTextDocument:(x,oe,ze)=>nt(Ee.onDidRemoveDocument)(x,oe,ze),onDidChangeTextDocument:(x,oe,ze)=>nt(Ee.onDidChangeDocument)(x,oe,ze),onDidSaveTextDocument:(x,oe,ze)=>nt(Ee.onDidSaveDocument)(x,oe,ze),onWillSaveTextDocument:(x,oe,ze)=>nt(Qe.getOnWillSaveTextDocumentEvent(Te))(x,oe,ze),get notebookDocuments(){return qe.notebookDocuments.map(x=>x.apiNotebook)},async openNotebookDocument(x,oe){let ze;if(f.URI.isUri(x))ze=x,await qe.openNotebookDocument(x);else if(typeof x=="string")ze=f.URI.revive(await qe.createNotebookDocument({viewType:x,content:oe}));else throw new Error("Invalid arguments");return qe.getNotebookDocument(ze).apiNotebook},onDidSaveNotebookDocument(x,oe,ze){return nt(ct.onDidSaveNotebookDocument)(x,oe,ze)},onDidChangeNotebookDocument(x,oe,ze){return nt(ct.onDidChangeNotebookDocument)(x,oe,ze)},onWillSaveNotebookDocument(x,oe,ze){return nt(At.getOnWillSaveNotebookDocumentEvent(Te))(x,oe,ze)},get onDidOpenNotebookDocument(){return nt(qe.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return nt(qe.onDidCloseNotebookDocument)},registerNotebookSerializer(x,oe,ze,ot){return qe.registerNotebookSerializer(Te,x,oe,ze,(0,Xe.$XF)(Te,"notebookLiveShare")?ot:void 0)},onDidChangeConfiguration:(x,oe,ze)=>nt(zi.onDidChangeConfiguration)(x,oe,ze),getConfiguration(x,oe){return oe=arguments.length===1?void 0:oe,zi.getConfiguration(x,oe,Te)},registerTextDocumentContentProvider(x,oe){return Ue.registerTextDocumentContentProvider(x,oe)},registerTaskProvider:(x,oe)=>(Ct.report("window.registerTaskProvider",Te,"Use the corresponding function on the 'tasks' namespace instead"),we.registerTaskProvider(Te,x,oe)),registerFileSystemProvider(x,oe,ze){return(0,F.$Qc)(Ri.registerFileSystemProvider(Te,x,oe,ze),Vt.addFileSystemProvider(x,oe,ze))},get fs(){return Vt.value},registerFileSearchProvider:(x,oe)=>((0,Xe.$YF)(Te,"fileSearchProvider"),ci.registerFileSearchProvider(x,oe)),registerTextSearchProvider:(x,oe)=>((0,Xe.$YF)(Te,"textSearchProvider"),ci.registerTextSearchProvider(x,oe)),registerAITextSearchProvider:(x,oe)=>((0,Xe.$YF)(Te,"aiTextSearchProvider"),(0,Xe.$YF)(Te,"textSearchProvider"),ci.registerAITextSearchProvider(x,oe)),registerRemoteAuthorityResolver:(x,oe)=>((0,Xe.$YF)(Te,"resolvers"),zt.registerRemoteAuthorityResolver(x,oe)),registerResourceLabelFormatter:x=>((0,Xe.$YF)(Te,"resolvers"),Xi.$registerResourceLabelFormatter(x)),getRemoteExecServer:x=>((0,Xe.$YF)(Te,"resolvers"),zt.getRemoteExecServer(x)),onDidCreateFiles:(x,oe,ze)=>nt(ui.onDidCreateFile)(x,oe,ze),onDidDeleteFiles:(x,oe,ze)=>nt(ui.onDidDeleteFile)(x,oe,ze),onDidRenameFiles:(x,oe,ze)=>nt(ui.onDidRenameFile)(x,oe,ze),onWillCreateFiles:(x,oe,ze)=>nt(ui.getOnWillCreateFileEvent(Te))(x,oe,ze),onWillDeleteFiles:(x,oe,ze)=>nt(ui.getOnWillDeleteFileEvent(Te))(x,oe,ze),onWillRenameFiles:(x,oe,ze)=>nt(ui.getOnWillRenameFileEvent(Te))(x,oe,ze),openTunnel:x=>((0,Xe.$YF)(Te,"tunnels"),Mt.openTunnel(Te,x).then(oe=>{if(!oe)throw new Error("cannot open tunnel");return oe})),get tunnels(){return(0,Xe.$YF)(Te,"tunnels"),Mt.getTunnels()},onDidChangeTunnels:(x,oe,ze)=>((0,Xe.$YF)(Te,"tunnels"),nt(Mt.onDidChangeTunnels)(x,oe,ze)),registerPortAttributesProvider:(x,oe)=>((0,Xe.$YF)(Te,"portsAttributes"),Mt.registerPortsAttributesProvider(x,oe)),registerTunnelProvider:(x,oe)=>((0,Xe.$YF)(Te,"tunnelFactory"),Mt.registerTunnelProvider(x,oe)),registerTimelineProvider:(x,oe)=>((0,Xe.$YF)(Te,"timeline"),xi.registerTimelineProvider(x,oe,Te.identifier,wt.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:x=>((0,Xe.$YF)(Te,"workspaceTrust"),ft.requestWorkspaceTrust(x)),onDidGrantWorkspaceTrust:(x,oe,ze)=>nt(ft.onDidGrantWorkspaceTrust)(x,oe,ze),registerEditSessionIdentityProvider:(x,oe)=>((0,Xe.$YF)(Te,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(x,oe)),onWillCreateEditSessionIdentity:(x,oe,ze)=>((0,Xe.$YF)(Te,"editSessionIdentityProvider"),nt(ft.getOnWillCreateEditSessionIdentityEvent(Te))(x,oe,ze)),registerCanonicalUriProvider:(x,oe)=>((0,Xe.$YF)(Te,"canonicalUriProvider"),ft.registerCanonicalUriProvider(x,oe)),getCanonicalUri:(x,oe,ze)=>((0,Xe.$YF)(Te,"canonicalUriProvider"),ft.provideCanonicalUri(x,oe,ze))},an={get inputBox(){return Ct.report("scm.inputBox",Te,"Use 'SourceControl.inputBox' instead"),Ai.getLastInputBox(Te)},createSourceControl(x,oe,ze){return Ai.createSourceControl(Te,x,oe,ze)}},vn={createCommentController(x,oe){return Mi.createCommentController(Te,x,oe)}},bn={get activeDebugSession(){return Et.activeDebugSession},get activeDebugConsole(){return Et.activeDebugConsole},get breakpoints(){return Et.breakpoints},get stackFrameFocus(){return Et.stackFrameFocus},registerDebugVisualizationProvider(x,oe){return(0,Xe.$YF)(Te,"debugVisualization"),Et.registerDebugVisualizationProvider(Te,x,oe)},registerDebugVisualizationTreeProvider(x,oe){return(0,Xe.$YF)(Te,"debugVisualization"),Et.registerDebugVisualizationTree(Te,x,oe)},onDidStartDebugSession(x,oe,ze){return nt(Et.onDidStartDebugSession)(x,oe,ze)},onDidTerminateDebugSession(x,oe,ze){return nt(Et.onDidTerminateDebugSession)(x,oe,ze)},onDidChangeActiveDebugSession(x,oe,ze){return nt(Et.onDidChangeActiveDebugSession)(x,oe,ze)},onDidReceiveDebugSessionCustomEvent(x,oe,ze){return nt(Et.onDidReceiveDebugSessionCustomEvent)(x,oe,ze)},onDidChangeBreakpoints(x,oe,ze){return nt(Et.onDidChangeBreakpoints)(x,oe,ze)},onDidChangeStackFrameFocus(x,oe,ze){return(0,Xe.$YF)(Te,"debugFocus"),nt(Et.onDidChangeStackFrameFocus)(x,oe,ze)},registerDebugConfigurationProvider(x,oe,ze){return Et.registerDebugConfigurationProvider(x,oe,ze||_t.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(x,oe){return Et.registerDebugAdapterDescriptorFactory(Te,x,oe)},registerDebugAdapterTrackerFactory(x,oe){return Et.registerDebugAdapterTrackerFactory(x,oe)},startDebugging(x,oe,ze){return!ze||typeof ze=="object"&&"configuration"in ze?Et.startDebugging(x,oe,{parentSession:ze}):Et.startDebugging(x,oe,ze||{})},stopDebugging(x){return Et.stopDebugging(x)},addBreakpoints(x){return Et.addBreakpoints(x)},removeBreakpoints(x){return Et.removeBreakpoints(x)},asDebugSourceUri(x,oe){return Et.asDebugSourceUri(x,oe)}},cn={registerTaskProvider:(x,oe)=>we.registerTaskProvider(Te,x,oe),fetchTasks:x=>we.fetchTasks(x),executeTask:x=>we.executeTask(Te,x),get taskExecutions(){return we.taskExecutions},onDidStartTask:(x,oe,ze)=>nt(we.onDidStartTask)(x,oe,ze),onDidEndTask:(x,oe,ze)=>nt(we.onDidEndTask)(x,oe,ze),onDidStartTaskProcess:(x,oe,ze)=>nt(we.onDidStartTaskProcess)(x,oe,ze),onDidEndTaskProcess:(x,oe,ze)=>nt(we.onDidEndTaskProcess)(x,oe,ze)},un={createNotebookController(x,oe,ze,ot,vt){return Lt.createNotebookController(Te,x,oe,ze,ot,(0,Xe.$XF)(Te,"notebookMessaging")?vt:void 0)},registerNotebookCellStatusBarItemProvider:(x,oe)=>qe.registerNotebookCellStatusBarItemProvider(Te,x,oe),createRendererMessaging(x){return xt.createRendererMessaging(Te,x)},createNotebookControllerDetectionTask(x){return(0,Xe.$YF)(Te,"notebookKernelSource"),Lt.createNotebookControllerDetectionTask(Te,x)},registerKernelSourceActionProvider(x,oe){return(0,Xe.$YF)(Te,"notebookKernelSource"),Lt.registerKernelSourceActionProvider(Te,x,oe)},onDidChangeNotebookCellExecutionState(x,oe,ze){return(0,Xe.$YF)(Te,"notebookCellExecutionState"),nt(Lt.onDidChangeNotebookCellExecutionState)(x,oe,ze)}},Vi={t(...x){if(typeof x[0]=="string"){const oe=x.shift(),ze=!x||typeof x[0]!="object"?x:x[0];return ce.getMessage(Te.identifier.value,{message:oe,args:ze})}return ce.getMessage(Te.identifier.value,x[0])},get bundle(){return ce.getBundle(Te.identifier.value)},get uri(){return ce.getBundleUri(Te.identifier.value)}},qi={_version:1,registerInteractiveEditorSessionProvider(x,oe){return(0,Xe.$YF)(Te,"interactive"),gn.registerProvider(Te,x,oe)},registerInteractiveSessionProvider(x,oe){return(0,Xe.$YF)(Te,"interactive"),bi.registerChatProvider(Te,x,oe)},sendInteractiveRequestToProvider(x,oe){return(0,Xe.$YF)(Te,"interactive"),bi.sendInteractiveRequestToProvider(x,oe)},transferChatSession(x,oe){return(0,Xe.$YF)(Te,"interactive"),bi.transferChatSession(x,oe)}},Hi={getRelatedInformation(x,oe){return(0,Xe.$YF)(Te,"aiRelatedInformation"),Oi.getRelatedInformation(Te,x,oe)},registerRelatedInformationProvider(x,oe){return(0,Xe.$YF)(Te,"aiRelatedInformation"),Oi.registerRelatedInformationProvider(Te,x,oe)},registerEmbeddingVectorProvider(x,oe){return(0,Xe.$YF)(Te,"aiRelatedInformation"),en.registerEmbeddingVectorProvider(Te,x,oe)}},Ii={registerChatResponseProvider(x,oe,ze){return(0,Xe.$YF)(Te,"chatProvider"),Ft.registerLanguageModel(Te,x,oe,ze)},registerChatVariableResolver(x,oe,ze){return(0,Xe.$YF)(Te,"chatVariableResolver"),mn.registerVariableResolver(Te,x,oe,ze)},registerMappedEditsProvider(x,oe){return(0,Xe.$YF)(Te,"mappedEditsProvider"),ht.registerMappedEditsProvider(Te,x,oe)},createChatParticipant(x,oe){return(0,Xe.$YF)(Te,"chatParticipant"),_i.createChatAgent(Te,x,oe)}},Ki={get languageModels(){return(0,Xe.$YF)(Te,"languageModels"),Ft.getLanguageModelIds()},onDidChangeLanguageModels:(x,oe,ze)=>((0,Xe.$YF)(Te,"languageModels"),Ft.onDidChangeProviders(x,oe,ze)),sendChatRequest(x,oe,ze,ot){return(0,Xe.$YF)(Te,"languageModels"),Ft.sendChatRequest(Te,x,oe,ze,ot)}},Ji={registerSpeechProvider(x,oe){return(0,Xe.$YF)(Te,"speech"),Ti.registerProvider(Te.identifier,x,oe)}};return{version:pt.version,ai:Hi,authentication:$n,commands:rn,comments:vn,chat:Ii,debug:bn,env:Ui,extensions:sn,interactive:qi,l10n:Vi,languages:Bi,lm:Ki,notebooks:un,scm:an,speech:Ji,tasks:cn,tests:pn,window:on,workspace:Wi,Breakpoint:Me.$7M,TerminalOutputAnchor:Me.TerminalOutputAnchor,ChatResultFeedbackKind:Me.ChatResultFeedbackKind,ChatVariableLevel:Me.ChatVariableLevel,ChatCompletionItem:Me.$ZN,CallHierarchyIncomingCall:Me.$tM,CallHierarchyItem:Me.$sM,CallHierarchyOutgoingCall:Me.$uM,CancellationError:M.$5,CancellationTokenSource:S.$ce,CandidatePortSource:r.CandidatePortSource,CodeAction:Me.$pM,CodeActionKind:Me.$qM,CodeActionTriggerKind:Me.CodeActionTriggerKind,CodeLens:Me.$vM,Color:Me.$IM,ColorInformation:Me.$JM,ColorPresentation:Me.$KM,ColorThemeKind:Me.ColorThemeKind,CommentMode:Me.CommentMode,CommentState:Me.CommentState,CommentThreadCollapsibleState:Me.CommentThreadCollapsibleState,CommentThreadState:Me.CommentThreadState,CompletionItem:Me.$CM,CompletionItemKind:Me.CompletionItemKind,CompletionItemTag:Me.CompletionItemTag,CompletionList:Me.$DM,CompletionTriggerKind:Me.CompletionTriggerKind,ConfigurationTarget:Me.ConfigurationTarget,CustomExecution:Me.$SM,DebugAdapterExecutable:Me.$$M,DebugAdapterInlineImplementation:Me.$bN,DebugAdapterNamedPipeServer:Me.$aN,DebugAdapterServer:Me.$_M,DebugConfigurationProviderTriggerKind:_t.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Me.DebugConsoleMode,DebugVisualization:Me.$rN,DecorationRangeBehavior:Me.DecorationRangeBehavior,Diagnostic:Me.$jM,DiagnosticRelatedInformation:Me.$iM,DiagnosticSeverity:Me.DiagnosticSeverity,DiagnosticTag:Me.DiagnosticTag,Disposable:Me.$8L,DocumentHighlight:Me.$lM,DocumentHighlightKind:Me.DocumentHighlightKind,MultiDocumentHighlight:Me.$mM,DocumentLink:Me.$HM,DocumentSymbol:Me.$oM,EndOfLine:Me.EndOfLine,EnvironmentVariableMutatorType:Me.EnvironmentVariableMutatorType,EvaluatableExpression:Me.$eN,InlineValueText:Me.$fN,InlineValueVariableLookup:Me.$gN,InlineValueEvaluatableExpression:Me.$hN,InlineCompletionTriggerKind:Me.InlineCompletionTriggerKind,EventEmitter:P.$5d,ExtensionKind:Me.ExtensionKind,ExtensionMode:Me.ExtensionMode,ExternalUriOpenerPriority:Me.ExternalUriOpenerPriority,FileChangeType:Me.FileChangeType,FileDecoration:Me.$tN,FileDecoration2:Me.$tN,FileSystemError:Me.$kN,FileType:g.FileType,FilePermission:g.FilePermission,FoldingRange:Me.$lN,FoldingRangeKind:Me.FoldingRangeKind,FunctionBreakpoint:Me.$9M,InlineCompletionItem:Me.$EM,InlineCompletionList:Me.$FM,Hover:Me.$kM,IndentAction:D.IndentAction,Location:Me.$hM,MarkdownString:Me.$wM,OverviewRulerLane:l.OverviewRulerLane,ParameterInformation:Me.$xM,PortAutoForwardAction:Me.PortAutoForwardAction,Position:Me.$9L,ProcessExecution:Me.$QM,ProgressLocation:Me.ProgressLocation,QuickInputButtons:Me.$sN,Range:Me.$0L,RelativePattern:Me.$5M,Selection:Me.$$L,SelectionRange:Me.$rM,SemanticTokens:Me.$oN,SemanticTokensBuilder:Me.$nN,SemanticTokensEdit:Me.$pN,SemanticTokensEdits:Me.$qN,SemanticTokensLegend:Me.$mN,ShellExecution:Me.$RM,ShellQuoting:Me.ShellQuoting,SignatureHelp:Me.$zM,SignatureHelpTriggerKind:Me.SignatureHelpTriggerKind,SignatureInformation:Me.$yM,SnippetString:Me.$gM,SourceBreakpoint:Me.$8M,StandardTokenType:Me.StandardTokenType,StatusBarAlignment:Me.StatusBarAlignment,SymbolInformation:Me.$nM,SymbolKind:Me.SymbolKind,SymbolTag:Me.SymbolTag,Task:Me.$TM,TaskGroup:Me.$PM,TaskPanelKind:Me.TaskPanelKind,TaskRevealKind:Me.TaskRevealKind,TaskScope:Me.TaskScope,TerminalLink:Me.$LM,TerminalQuickFixTerminalCommand:Me.$NM,TerminalQuickFixOpener:Me.$MM,TerminalLocation:Me.TerminalLocation,TerminalProfile:Me.$OM,TerminalExitReason:Me.TerminalExitReason,TextDocumentSaveReason:Me.TextDocumentSaveReason,TextEdit:Me.$cM,SnippetTextEdit:Me.$eM,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:Me.TextEditorLineNumbersStyle,TextEditorRevealType:Me.TextEditorRevealType,TextEditorSelectionChangeKind:Me.TextEditorSelectionChangeKind,SyntaxTokenType:Me.SyntaxTokenType,TextDocumentChangeReason:Me.TextDocumentChangeReason,ThemeColor:Me.$4M,ThemeIcon:Me.$3M,TreeItem:Me.$UM,TreeItemCheckboxState:Me.TreeItemCheckboxState,TreeItemCollapsibleState:Me.TreeItemCollapsibleState,TypeHierarchyItem:Me.$ON,UIKind:ni.UIKind,Uri:f.URI,ViewColumn:Me.ViewColumn,WorkspaceEdit:Me.$fM,DocumentDropEdit:Me.$1M,DocumentPasteEdit:Me.$2M,InlayHint:Me.$BM,InlayHintLabelPart:Me.$AM,InlayHintKind:Me.InlayHintKind,RemoteAuthorityResolverError:Me.$bM,ResolvedAuthority:Me.$_L,ManagedResolvedAuthority:Me.$aM,SourceControlInputBoxValidationType:Me.SourceControlInputBoxValidationType,ExtensionRuntime:Me.ExtensionRuntime,TimelineItem:Me.$DN,NotebookRange:Me.$vN,NotebookCellKind:Me.NotebookCellKind,NotebookCellExecutionState:Me.NotebookCellExecutionState,NotebookCellData:Me.$wN,NotebookData:Me.$xN,NotebookRendererScript:Me.$BN,NotebookCellStatusBarAlignment:Me.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Me.NotebookEditorRevealType,NotebookCellOutput:Me.$zN,NotebookCellOutputItem:Me.$yN,NotebookCellStatusBarItem:Me.$AN,NotebookControllerAffinity:Me.NotebookControllerAffinity,NotebookControllerAffinity2:Me.NotebookControllerAffinity2,NotebookEdit:Me.$dM,NotebookKernelSourceAction:Me.$CN,NotebookVariablesRequestKind:Me.NotebookVariablesRequestKind,PortAttributes:Me.$FN,LinkedEditingRanges:Me.$EN,TestResultState:Me.TestResultState,TestRunRequest:Me.$GN,TestMessage:Me.$HN,TestTag:Me.$IN,TestRunProfileKind:Me.TestRunProfileKind,TextSearchCompleteMessageType:jt.TextSearchCompleteMessageType,DataTransfer:Me.$ZM,DataTransferItem:Me.$VM,CoveredCount:Me.$JN,FileCoverage:Me.$KN,StatementCoverage:Me.$LN,BranchCoverage:Me.$MN,DeclarationCoverage:Me.$NN,FunctionCoverage:Me.$NN,WorkspaceTrustState:Me.WorkspaceTrustState,LanguageStatusSeverity:Me.LanguageStatusSeverity,QuickPickItemKind:Me.QuickPickItemKind,InputBoxValidationSeverity:Me.InputBoxValidationSeverity,TabInputText:Me.$PN,TabInputTextDiff:Me.$QN,TabInputTextMerge:Me.$RN,TabInputCustom:Me.$SN,TabInputNotebook:Me.$UN,TabInputNotebookDiff:Me.$VN,TabInputWebview:Me.$TN,TabInputTerminal:Me.$WN,TabInputInteractiveWindow:Me.$XN,TabInputChat:Me.$YN,TelemetryTrustedValue:i.$Zo,LogLevel:s.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Me.InteractiveSessionVoteDirection,ChatCopyKind:Me.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Me.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Me.$cN,ThreadFocus:Me.$dN,RelatedInformationType:Me.RelatedInformationType,SpeechToTextStatus:Me.SpeechToTextStatus,KeywordRecognitionStatus:Me.KeywordRecognitionStatus,ChatResponseMarkdownPart:Me.$1N,ChatResponseFileTreePart:Me.$2N,ChatResponseAnchorPart:Me.$3N,ChatResponseProgressPart:Me.$4N,ChatResponseReferencePart:Me.$6N,ChatResponseCommandButtonPart:Me.$5N,ChatRequestTurn:Me.$7N,ChatResponseTurn:Me.$8N,LanguageModelChatSystemMessage:Me.$9N,LanguageModelChatUserMessage:Me.$0N,LanguageModelChatAssistantMessage:Me.$$N,LanguageModelSystemMessage:Me.$9N,LanguageModelUserMessage:Me.$0N,LanguageModelAssistantMessage:Me.$$N,LanguageModelError:Me.$_N,NewSymbolName:Me.$jN,NewSymbolNameTag:Me.NewSymbolNameTag,InlineEdit:Me.$aO,InlineEditTriggerKind:Me.InlineEditTriggerKind}}}e.$Wjc=ei}),define(Pe[294],Re([1,0,54,115,36,110,37,31,67,66,118,120,121,82,86,78,109,63,43,81,61,65,232,13,119,79,80,84,88]),function(me,e,S,M,P,F,R,m,f,k,O,D,l,E,g,s,a,i,n,r,c,d,t,p,u,o,v,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,S.$as)(o.$Lic,o.$Kic,1),(0,S.$as)(p.$Aj,t.$Xjc,1),(0,S.$as)(s.$Phc,s.$Qhc,1),(0,S.$as)(m.$HO,m.$GO,0),(0,S.$as)(b.$Zhc,b.$1hc,0),(0,S.$as)($.$5hc,$.$6hc,0),(0,S.$as)(R.$fic,R.$dic,0),(0,S.$as)(i.$hic,i.$gic,0),(0,S.$as)(D.$Vic,D.$Zic,0),(0,S.$as)(F.$2ic,F.$1ic,0),(0,S.$as)(f.$wO,f.$vO,0),(0,S.$as)(v.$Mic,v.$Nic,0),(0,S.$as)(n.$Thc,n.$Shc,0),(0,S.$as)(M.$vjc,M.$ujc,1),(0,S.$as)(l.$fjc,l.$gjc,0),(0,S.$as)(E.$Aic,E.$zic,0),(0,S.$as)(O.$Ijc,O.$Hjc,0),(0,S.$as)(k.$Dic,k.$Gic,0),(0,S.$as)(g.$zAb,g.$AAb,0),(0,S.$as)(a.$Vjc,a.$Ujc,0),(0,S.$as)(P.$cic,P.$bic,0),(0,S.$as)(r.$Iic,r.$Hic,0),(0,S.$as)(c.$FO,c.$CO,0),(0,S.$as)(d.$ric,d.$sic,0),(0,S.$as)(u.$Tic,u.$Uic,0)}),define(Pe[295],Re([1,0,293,38,2,290,7,11,238]),function(me,e,S,M,P,F,R,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8lc=void 0;class k extends F.$1jc{j(){}getModule(E,g){for(const s of this.b){const a=s(E);if(a){E=a;break}}if(this.a.has(E))return this.a.get(E).load(E,g,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class O extends M.$Pic{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Webworker}async ub(){this.h.createInstance(f.$7lc);const E=this.h.invokeFunction(S.$Wjc);this.r=this.h.createInstance(k,E,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.Ab()}vb(E){return E.browser}async wb(E,g,s){g=g.with({path:D(g.path,".js")});const a=E?.identifier.value;a&&performance.mark(`code/extHost/willFetchExtensionCode/${a}`);const i=P.URI.revive(await this.C.$asBrowserUri(g)),n=await fetch(i.toString(!0));if(a&&performance.mark(`code/extHost/didFetchExtensionCode/${a}`),n.status!==200)throw new Error(n.statusText);const r=await n.text(),c=`${g.toString(!0)}#vscode-extension`,d=`${r}
//# sourceURL=${c}`;let t;try{t=new Function("module","exports","require",d)}catch(v){throw console.error(a?`Loading code for extension ${a} failed: ${v.message}`:`Loading code failed: ${v.message}`),console.error(`${g.toString(!0)}${typeof v.line=="number"?` line ${v.line}`:""}${typeof v.column=="number"?` column ${v.column}`:""}`),console.error(v),v}E&&await this.w.initializeLocalizedMessages(E);const p={},u={exports:p},o=v=>{const b=this.r.getModule(v,g);if(b===void 0)throw new Error(`Cannot load module '${v}'`);return b};try{return s.codeLoadingStart(),a&&performance.mark(`code/extHost/willLoadExtensionCode/${a}`),t(u,p,o),u.exports!==p?u.exports:p}finally{a&&performance.mark(`code/extHost/didLoadExtensionCode/${a}`),s.codeLoadingStop()}}async $setRemoteEnvironment(E){}async Ab(E=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const g=Date.now()+E;for(;Date.now()<g&&!("__jsDebugIsReady"in globalThis);)await(0,m.$gh)(10)}}e.$8lc=O;function D(l,E){return l.endsWith(E)?l:l+E}}),define(Pe[296],Re([1,0,70,54,13,38,203,85,295]),function(me,e,S,M,P,F,R,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,M.$as)(P.$zj,new S.$ci(R.$Zjc,[!0],!0)),(0,M.$as)(F.$Qic,f.$8lc,0),(0,M.$as)(m.$iic,m.$jic,0)}),define(Pe[302],Re([1,0,23,5,77,291,240,19,89,12,2,294,296]),function(me,e,S,M,P,F,R,m,f,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const D=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const l=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function E(t){return/^(file|vscode-remote):/i.test(t)}const g=fetch.bind(self);function s(t){self.fetch=async function(p,u){return p instanceof Request||E(String(p))&&(p=(await t(O.URI.parse(String(p)))).toString(!0)),g(p,u)},self.XMLHttpRequest=class extends XMLHttpRequest{open(p,u,o,v,b){(async()=>(E(u.toString())&&(u=(await t(O.URI.parse(u.toString()))).toString(!0)),super.open(p,u,o??!0,v,b)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const t=self.Worker;Worker=function(p,u){if(/^file:/i.test(p.toString()))p=k.$zg.uriToBrowserUri(O.URI.parse(p.toString())).toString(!0);else if(/^vscode-remote:/i.test(p.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const v=`(${function(h){function y(N){return typeof N=="string"||N instanceof URL?String(N).replace(/^file:\/\//i,"vscode-file://vscode-app"):N}const w=fetch.bind(self);self.fetch=function(N,G){return N instanceof Request?w(N,G):w(y(N),G)},self.XMLHttpRequest=class extends XMLHttpRequest{open(N,G,V,U,C){return super.open(N,y(G),V??!0,U,C)}};const A=importScripts.bind(self);self.importScripts=(...N)=>{A(...N.map(y))},A(h)}.toString()}('${p}'))`;u=u||{},u.name=`${name} -> ${u.name||m.$nc(p.toString())}`;const b=new Blob([v],{type:"application/javascript"}),$=URL.createObjectURL(b);return new t($,u)}}else self.Worker=class extends R.$9lc{constructor(t,p){super(l,t,{name:m.$nc(t.toString()),...p})}};const a=new class{constructor(){this.pid=void 0}exit(t){D()}};class i{constructor(){const p=new MessageChannel,u=new M.$5d;let o=!1;l(p.port2,[p.port2]),p.port1.onmessage=v=>{const{data:b}=v;if(!(b instanceof ArrayBuffer)){console.warn("UNKNOWN data received",b);return}const $=S.$se.wrap(new Uint8Array(b,0,b.byteLength));if((0,P.$Im)($,2)){o=!0,r("received terminate message from renderer");return}u.fire($)},this.protocol={onMessage:u.event,send:v=>{if(!o){const b=v.buffer.buffer.slice(v.buffer.byteOffset,v.buffer.byteOffset+v.buffer.byteLength);p.port1.postMessage(b,[b])}}}}}function n(t){return new Promise(p=>{const u=t.onMessage(o=>{u.dispose();const v=JSON.parse(o.toString());t.send((0,P.$Hm)(0)),p({protocol:t,initData:v})});t.send((0,P.$Hm)(1))})}let r=t=>D();function c(t){return!!t&&typeof t=="object"&&t.type==="vscode.init"&&t.data instanceof Map}function d(){f.mark("code/extHost/willConnectToRenderer");const t=new i;return{onmessage(p){c(p)&&n(t.protocol).then(u=>{f.mark("code/extHost/didWaitForInitData");const o=new F.$3jc(u.protocol,u.initData,a,null,p.data);s(v=>o.asBrowserUri(v)),r=v=>o.terminate(v)})}}}e.create=d})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/8c2b09c0443b94d75a73819ed35610f7e09375ae/core/vs/workbench/api/worker/extensionHostWorker.js.map
